# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class PCAP_CommonDataTypes:

    _name_  = 'PCAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 20, 3, 4, 1, 3]
    
    _obj_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TransactionID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolIE-ID',
        'TransactionID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TransactionID >-----#
    TransactionID = CHOICE(name='TransactionID', mode=MODE_TYPE)
    _TransactionID_shortTID = INT(name='shortTID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransactionID_shortTID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _TransactionID_longTID = INT(name='longTID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TransactionID_longTID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    TransactionID._cont = ASN1Dict([
        ('shortTID', _TransactionID_shortTID),
        ('longTID', _TransactionID_longTID),
        ])
    TransactionID._ext = None
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessful-outcome', 2), ('outcome', 3)])
    TriggeringMessage._ext = None
    
    _all_ = [
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolIE_ID,
        _TransactionID_shortTID,
        _TransactionID_longTID,
        TransactionID,
        TriggeringMessage,
    ]

class PCAP_Constants:

    _name_  = 'PCAP-Constants'
    _oid_   = [0, 4, 0, 0, 20, 3, 4, 1, 4]
    
    _obj_ = [
        'id-PositionCalculation',
        'id-InformationExchangeInitiation',
        'id-InformationReporting',
        'id-InformationExchangeTermination',
        'id-InformationExchangeFailure',
        'id-ErrorIndication',
        'id-privateMessage',
        'id-PositionParameterModification',
        'id-PositionInitiation',
        'id-PositionActivation',
        'id-Abort',
        'id-PositionPeriodicReport',
        'id-PositionPeriodicResult',
        'id-PositionPeriodicTermination',
        'maxNrOfErrors',
        'maxSat',
        'maxSatAlmanac',
        'maxNrOfLevels',
        'maxNrOfPoints',
        'maxNrOfExpInfo',
        'maxNrOfMeasNCell',
        'maxNrOfMeasurements',
        'maxNrOfSets',
        'maxRateMatching',
        'maxNrOfTFs',
        'maxTTI-count',
        'maxTS-1',
        'maxCCTrCH',
        'maxTF',
        'maxTFC',
        'maxPRACH',
        'maxTrCH',
        'maxTGPS',
        'maxNoOfMeasurements',
        'maxCellMeas',
        'maxNrOfEDPCCH-PO-QUANTSTEPs',
        'maxNrOfRefETFCI-PO-QUANTSTEPs',
        'maxNrOfRefETFCIs',
        'maxSet',
        'maxGANSSSat',
        'maxSgnType',
        'maxGANSS',
        'maxGANSSSet',
        'maxGANSSSatAlmanac',
        'maxGANSSClockMod',
        'maxGANSS-1',
        'maxNrOfIRATMeasurements',
        'maxReportedGERANCells',
        'maxIonGridInfo',
        'maxAddPos',
        'maxBeacons',
        'maxBTs',
        'maxWLANs',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-GPS-UTRAN-TRU',
        'id-InformationExchangeID',
        'id-InformationExchangeObjectType-InfEx-Rprt',
        'id-InformationExchangeObjectType-InfEx-Rqst',
        'id-InformationExchangeObjectType-InfEx-Rsp',
        'id-InformationReportCharacteristics',
        'id-InformationType',
        'id-GPS-MeasuredResultsList',
        'id-MethodType',
        'id-RefPosition-InfEx-Rqst',
        'id-RefPosition-InfEx-Rsp',
        'id-RefPosition-Inf-Rprt',
        'id-RequestedDataValue',
        'id-RequestedDataValueInformation',
        'id-TransactionID',
        'id-UE-PositionEstimate',
        'id-CellId-MeasuredResultsSets',
        'id-OTDOA-MeasurementGroup',
        'id-AccuracyFulfilmentIndicator',
        'id-HorizontalAccuracyCode',
        'id-VerticalAccuracyCode',
        'id-UTDOA-Group',
        'id-RequestType',
        'id-UE-PositioningCapability',
        'id-UC-id',
        'id-ResponseTime',
        'id-PositioningPriority',
        'id-ClientType',
        'id-PositioningMethod',
        'id-UTDOAPositioning',
        'id-GPSPositioning',
        'id-OTDOAAssistanceData',
        'id-Positioning-ResponseTime',
        'id-EnvironmentCharacterisation',
        'id-PositionData',
        'id-IncludeVelocity',
        'id-VelocityEstimate',
        'id-rxTimingDeviation768Info',
        'id-UC-ID-InfEx-Rqst',
        'id-UE-PositionEstimateInfo',
        'id-UTRAN-GPSReferenceTime',
        'id-UTRAN-GPSReferenceTimeResult',
        'id-UTRAN-GPS-DriftRate',
        'id-OTDOA-AddMeasuredResultsInfo',
        'id-GPS-ReferenceLocation',
        'id-OTDOA-MeasuredResultsSets',
        'id-rxTimingDeviation384extInfo',
        'id-ExtendedRoundTripTime',
        'id-PeriodicPosCalcInfo',
        'id-PeriodicLocationInfo',
        'id-AmountOfReporting',
        'id-MeasInstructionsUsed',
        'id-RRCstateChange',
        'id-PeriodicTerminationCause',
        'id-MeasurementValidity',
        'id-roundTripTimeInfoWithType1',
        'id-CellIDPositioning',
        'id-AddMeasurementInfo',
        'id-Extended-RNC-ID',
        'id-GANSS-CommonAssistanceData',
        'id-GANSS-GenericAssistanceDataList',
        'id-GANSS-MeasuredResultsList',
        'id-GANSS-UTRAN-TRU',
        'id-GANSSPositioning',
        'id-GANSS-PositioningDataSet',
        'id-GNSS-PositioningMethod',
        'id-NetworkAssistedGANSSSuport',
        'id-TUTRANGANSSMeasurementValueInfo',
        'id-AdditionalGPSAssistDataRequired',
        'id-AdditionalGanssAssistDataRequired',
        'id-angleOfArrivalLCR',
        'id-extendedTimingAdvanceLCR',
        'id-additionalMeasurementInforLCR',
        'id-timingAdvanceLCR-R7',
        'id-rxTimingDeviationLCR',
        'id-GPSReferenceTimeUncertainty',
        'id-GANSS-AddIonoModelReq',
        'id-GANSS-EarthOrientParaReq',
        'id-GANSS-Additional-Ionospheric-Model',
        'id-GANSS-Earth-Orientation-Parameters',
        'id-GANSS-Additional-Time-Models',
        'id-GANSS-Additional-Navigation-Models',
        'id-GANSS-Additional-UTC-Models',
        'id-GANSS-Auxiliary-Information',
        'id-GANSS-SBAS-ID',
        'id-GANSS-SBAS-IDs',
        'id-GANSS-Signal-IDs',
        'id-supportGANSSNonNativeADchoices',
        'id-PositionDataUEbased',
        'id-ganssCodePhaseAmbiguityExt',
        'id-ganssIntegerCodePhaseExt',
        'id-GANSScarrierPhaseRequested',
        'id-GANSSMultiFreqMeasRequested',
        'id-ganssReq-AddIonosphericModel',
        'id-ganssReq-EarthOrientPara',
        'id-ganssAddNavigationModel-req',
        'id-ganssAddUTCModel-req',
        'id-ganssAuxInfo-req',
        'id-GANSS-AlmanacModelChoice',
        'id-GANSS-alm-keplerianNAVAlmanac',
        'id-GANSS-alm-keplerianReducedAlmanac',
        'id-GANSS-alm-keplerianMidiAlmanac',
        'id-GANSS-alm-keplerianGLONASS',
        'id-GANSS-alm-ecefSBASAlmanac',
        'id-UTRAN-GANSSReferenceTimeResult',
        'id-GANSS-Reference-Time-Only',
        'id-GANSS-AddADchoices',
        'id-OTDOA-ReferenceCellInfo',
        'id-DGNSS-ValidityPeriod',
        'id-AzimuthAndElevationLSB',
        'id-completeAlmanacProvided',
        'id-GPS-Week-Cycle',
        'id-GANSS-Day-Cycle',
        'id-ganss-Delta-T',
        'id-requestedCellIDGERANMeasurements',
        'id-CellId-IRATMeasuredResultsSets',
        'id-IMSI',
        'id-IMEI',
        'id-GANSS-alm-keplerianBDSAlmanac',
        'id-BDS-Ionospheric-Grid-Model',
        'id-DBDS-Correction-Information',
        'id-BDSIonosphericGridModel',
        'id-DBDSCorrection',
        'id-Confidence',
        'id-ExtraDopplerInfoExtension',
        'id-GANSS-Confidence',
        'id-GANSS-ExtraDopplerExtension',
        'id-Additional-PositioningDataSet',
        'id-Additional-PositioningMethod',
        'id-AddPos-MeasuredResults',
        'id-AddPosSupport',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-PositionCalculation',
        'id-InformationExchangeInitiation',
        'id-InformationReporting',
        'id-InformationExchangeTermination',
        'id-InformationExchangeFailure',
        'id-ErrorIndication',
        'id-privateMessage',
        'id-PositionParameterModification',
        'id-PositionInitiation',
        'id-PositionActivation',
        'id-Abort',
        'id-PositionPeriodicReport',
        'id-PositionPeriodicResult',
        'id-PositionPeriodicTermination',
        'maxNrOfErrors',
        'maxSat',
        'maxSatAlmanac',
        'maxNrOfLevels',
        'maxNrOfPoints',
        'maxNrOfExpInfo',
        'maxNrOfMeasNCell',
        'maxNrOfMeasurements',
        'maxNrOfSets',
        'maxRateMatching',
        'maxNrOfTFs',
        'maxTTI-count',
        'maxTS-1',
        'maxCCTrCH',
        'maxTF',
        'maxTFC',
        'maxPRACH',
        'maxTrCH',
        'maxTGPS',
        'maxNoOfMeasurements',
        'maxCellMeas',
        'maxNrOfEDPCCH-PO-QUANTSTEPs',
        'maxNrOfRefETFCI-PO-QUANTSTEPs',
        'maxNrOfRefETFCIs',
        'maxSet',
        'maxGANSSSat',
        'maxSgnType',
        'maxGANSS',
        'maxGANSSSet',
        'maxGANSSSatAlmanac',
        'maxGANSSClockMod',
        'maxGANSS-1',
        'maxNrOfIRATMeasurements',
        'maxReportedGERANCells',
        'maxIonGridInfo',
        'maxAddPos',
        'maxBeacons',
        'maxBTs',
        'maxWLANs',
        'id-Cause',
        'id-CriticalityDiagnostics',
        'id-GPS-UTRAN-TRU',
        'id-InformationExchangeID',
        'id-InformationExchangeObjectType-InfEx-Rprt',
        'id-InformationExchangeObjectType-InfEx-Rqst',
        'id-InformationExchangeObjectType-InfEx-Rsp',
        'id-InformationReportCharacteristics',
        'id-InformationType',
        'id-GPS-MeasuredResultsList',
        'id-MethodType',
        'id-RefPosition-InfEx-Rqst',
        'id-RefPosition-InfEx-Rsp',
        'id-RefPosition-Inf-Rprt',
        'id-RequestedDataValue',
        'id-RequestedDataValueInformation',
        'id-TransactionID',
        'id-UE-PositionEstimate',
        'id-CellId-MeasuredResultsSets',
        'id-OTDOA-MeasurementGroup',
        'id-AccuracyFulfilmentIndicator',
        'id-HorizontalAccuracyCode',
        'id-VerticalAccuracyCode',
        'id-UTDOA-Group',
        'id-RequestType',
        'id-UE-PositioningCapability',
        'id-UC-id',
        'id-ResponseTime',
        'id-PositioningPriority',
        'id-ClientType',
        'id-PositioningMethod',
        'id-UTDOAPositioning',
        'id-GPSPositioning',
        'id-OTDOAAssistanceData',
        'id-Positioning-ResponseTime',
        'id-EnvironmentCharacterisation',
        'id-PositionData',
        'id-IncludeVelocity',
        'id-VelocityEstimate',
        'id-rxTimingDeviation768Info',
        'id-UC-ID-InfEx-Rqst',
        'id-UE-PositionEstimateInfo',
        'id-UTRAN-GPSReferenceTime',
        'id-UTRAN-GPSReferenceTimeResult',
        'id-UTRAN-GPS-DriftRate',
        'id-OTDOA-AddMeasuredResultsInfo',
        'id-GPS-ReferenceLocation',
        'id-OTDOA-MeasuredResultsSets',
        'id-rxTimingDeviation384extInfo',
        'id-ExtendedRoundTripTime',
        'id-PeriodicPosCalcInfo',
        'id-PeriodicLocationInfo',
        'id-AmountOfReporting',
        'id-MeasInstructionsUsed',
        'id-RRCstateChange',
        'id-PeriodicTerminationCause',
        'id-MeasurementValidity',
        'id-roundTripTimeInfoWithType1',
        'id-CellIDPositioning',
        'id-AddMeasurementInfo',
        'id-Extended-RNC-ID',
        'id-GANSS-CommonAssistanceData',
        'id-GANSS-GenericAssistanceDataList',
        'id-GANSS-MeasuredResultsList',
        'id-GANSS-UTRAN-TRU',
        'id-GANSSPositioning',
        'id-GANSS-PositioningDataSet',
        'id-GNSS-PositioningMethod',
        'id-NetworkAssistedGANSSSuport',
        'id-TUTRANGANSSMeasurementValueInfo',
        'id-AdditionalGPSAssistDataRequired',
        'id-AdditionalGanssAssistDataRequired',
        'id-angleOfArrivalLCR',
        'id-extendedTimingAdvanceLCR',
        'id-additionalMeasurementInforLCR',
        'id-timingAdvanceLCR-R7',
        'id-rxTimingDeviationLCR',
        'id-GPSReferenceTimeUncertainty',
        'id-GANSS-AddIonoModelReq',
        'id-GANSS-EarthOrientParaReq',
        'id-GANSS-Additional-Ionospheric-Model',
        'id-GANSS-Earth-Orientation-Parameters',
        'id-GANSS-Additional-Time-Models',
        'id-GANSS-Additional-Navigation-Models',
        'id-GANSS-Additional-UTC-Models',
        'id-GANSS-Auxiliary-Information',
        'id-GANSS-SBAS-ID',
        'id-GANSS-SBAS-IDs',
        'id-GANSS-Signal-IDs',
        'id-supportGANSSNonNativeADchoices',
        'id-PositionDataUEbased',
        'id-ganssCodePhaseAmbiguityExt',
        'id-ganssIntegerCodePhaseExt',
        'id-GANSScarrierPhaseRequested',
        'id-GANSSMultiFreqMeasRequested',
        'id-ganssReq-AddIonosphericModel',
        'id-ganssReq-EarthOrientPara',
        'id-ganssAddNavigationModel-req',
        'id-ganssAddUTCModel-req',
        'id-ganssAuxInfo-req',
        'id-GANSS-AlmanacModelChoice',
        'id-GANSS-alm-keplerianNAVAlmanac',
        'id-GANSS-alm-keplerianReducedAlmanac',
        'id-GANSS-alm-keplerianMidiAlmanac',
        'id-GANSS-alm-keplerianGLONASS',
        'id-GANSS-alm-ecefSBASAlmanac',
        'id-UTRAN-GANSSReferenceTimeResult',
        'id-GANSS-Reference-Time-Only',
        'id-GANSS-AddADchoices',
        'id-OTDOA-ReferenceCellInfo',
        'id-DGNSS-ValidityPeriod',
        'id-AzimuthAndElevationLSB',
        'id-completeAlmanacProvided',
        'id-GPS-Week-Cycle',
        'id-GANSS-Day-Cycle',
        'id-ganss-Delta-T',
        'id-requestedCellIDGERANMeasurements',
        'id-CellId-IRATMeasuredResultsSets',
        'id-IMSI',
        'id-IMEI',
        'id-GANSS-alm-keplerianBDSAlmanac',
        'id-BDS-Ionospheric-Grid-Model',
        'id-DBDS-Correction-Information',
        'id-BDSIonosphericGridModel',
        'id-DBDSCorrection',
        'id-Confidence',
        'id-ExtraDopplerInfoExtension',
        'id-GANSS-Confidence',
        'id-GANSS-ExtraDopplerExtension',
        'id-Additional-PositioningDataSet',
        'id-Additional-PositioningMethod',
        'id-AddPos-MeasuredResults',
        'id-AddPosSupport',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-PositionCalculation >-----#
    id_PositionCalculation = INT(name='id-PositionCalculation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_PositionCalculation._val = 1
    
    #-----< id-InformationExchangeInitiation >-----#
    id_InformationExchangeInitiation = INT(name='id-InformationExchangeInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_InformationExchangeInitiation._val = 2
    
    #-----< id-InformationReporting >-----#
    id_InformationReporting = INT(name='id-InformationReporting', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_InformationReporting._val = 3
    
    #-----< id-InformationExchangeTermination >-----#
    id_InformationExchangeTermination = INT(name='id-InformationExchangeTermination', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_InformationExchangeTermination._val = 4
    
    #-----< id-InformationExchangeFailure >-----#
    id_InformationExchangeFailure = INT(name='id-InformationExchangeFailure', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_InformationExchangeFailure._val = 5
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name='id-ErrorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_ErrorIndication._val = 6
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name='id-privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_privateMessage._val = 7
    
    #-----< id-PositionParameterModification >-----#
    id_PositionParameterModification = INT(name='id-PositionParameterModification', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_PositionParameterModification._val = 8
    
    #-----< id-PositionInitiation >-----#
    id_PositionInitiation = INT(name='id-PositionInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_PositionInitiation._val = 9
    
    #-----< id-PositionActivation >-----#
    id_PositionActivation = INT(name='id-PositionActivation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_PositionActivation._val = 10
    
    #-----< id-Abort >-----#
    id_Abort = INT(name='id-Abort', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_Abort._val = 11
    
    #-----< id-PositionPeriodicReport >-----#
    id_PositionPeriodicReport = INT(name='id-PositionPeriodicReport', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_PositionPeriodicReport._val = 12
    
    #-----< id-PositionPeriodicResult >-----#
    id_PositionPeriodicResult = INT(name='id-PositionPeriodicResult', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_PositionPeriodicResult._val = 13
    
    #-----< id-PositionPeriodicTermination >-----#
    id_PositionPeriodicTermination = INT(name='id-PositionPeriodicTermination', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')))
    id_PositionPeriodicTermination._val = 14
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name='maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< maxSat >-----#
    maxSat = INT(name='maxSat', mode=MODE_VALUE)
    maxSat._val = 16
    
    #-----< maxSatAlmanac >-----#
    maxSatAlmanac = INT(name='maxSatAlmanac', mode=MODE_VALUE)
    maxSatAlmanac._val = 32
    
    #-----< maxNrOfLevels >-----#
    maxNrOfLevels = INT(name='maxNrOfLevels', mode=MODE_VALUE)
    maxNrOfLevels._val = 256
    
    #-----< maxNrOfPoints >-----#
    maxNrOfPoints = INT(name='maxNrOfPoints', mode=MODE_VALUE)
    maxNrOfPoints._val = 15
    
    #-----< maxNrOfExpInfo >-----#
    maxNrOfExpInfo = INT(name='maxNrOfExpInfo', mode=MODE_VALUE)
    maxNrOfExpInfo._val = 32
    
    #-----< maxNrOfMeasNCell >-----#
    maxNrOfMeasNCell = INT(name='maxNrOfMeasNCell', mode=MODE_VALUE)
    maxNrOfMeasNCell._val = 32
    
    #-----< maxNrOfMeasurements >-----#
    maxNrOfMeasurements = INT(name='maxNrOfMeasurements', mode=MODE_VALUE)
    maxNrOfMeasurements._val = 16
    
    #-----< maxNrOfSets >-----#
    maxNrOfSets = INT(name='maxNrOfSets', mode=MODE_VALUE)
    maxNrOfSets._val = 3
    
    #-----< maxRateMatching >-----#
    maxRateMatching = INT(name='maxRateMatching', mode=MODE_VALUE)
    maxRateMatching._val = 256
    
    #-----< maxNrOfTFs >-----#
    maxNrOfTFs = INT(name='maxNrOfTFs', mode=MODE_VALUE)
    maxNrOfTFs._val = 32
    
    #-----< maxTTI-count >-----#
    maxTTI_count = INT(name='maxTTI-count', mode=MODE_VALUE)
    maxTTI_count._val = 4
    
    #-----< maxTS-1 >-----#
    maxTS_1 = INT(name='maxTS-1', mode=MODE_VALUE)
    maxTS_1._val = 13
    
    #-----< maxCCTrCH >-----#
    maxCCTrCH = INT(name='maxCCTrCH', mode=MODE_VALUE)
    maxCCTrCH._val = 8
    
    #-----< maxTF >-----#
    maxTF = INT(name='maxTF', mode=MODE_VALUE)
    maxTF._val = 32
    
    #-----< maxTFC >-----#
    maxTFC = INT(name='maxTFC', mode=MODE_VALUE)
    maxTFC._val = 1024
    
    #-----< maxPRACH >-----#
    maxPRACH = INT(name='maxPRACH', mode=MODE_VALUE)
    maxPRACH._val = 16
    
    #-----< maxTrCH >-----#
    maxTrCH = INT(name='maxTrCH', mode=MODE_VALUE)
    maxTrCH._val = 32
    
    #-----< maxTGPS >-----#
    maxTGPS = INT(name='maxTGPS', mode=MODE_VALUE)
    maxTGPS._val = 6
    
    #-----< maxNoOfMeasurements >-----#
    maxNoOfMeasurements = INT(name='maxNoOfMeasurements', mode=MODE_VALUE)
    maxNoOfMeasurements._val = 16
    
    #-----< maxCellMeas >-----#
    maxCellMeas = INT(name='maxCellMeas', mode=MODE_VALUE)
    maxCellMeas._val = 32
    
    #-----< maxNrOfEDPCCH-PO-QUANTSTEPs >-----#
    maxNrOfEDPCCH_PO_QUANTSTEPs = INT(name='maxNrOfEDPCCH-PO-QUANTSTEPs', mode=MODE_VALUE)
    maxNrOfEDPCCH_PO_QUANTSTEPs._val = 8
    
    #-----< maxNrOfRefETFCI-PO-QUANTSTEPs >-----#
    maxNrOfRefETFCI_PO_QUANTSTEPs = INT(name='maxNrOfRefETFCI-PO-QUANTSTEPs', mode=MODE_VALUE)
    maxNrOfRefETFCI_PO_QUANTSTEPs._val = 8
    
    #-----< maxNrOfRefETFCIs >-----#
    maxNrOfRefETFCIs = INT(name='maxNrOfRefETFCIs', mode=MODE_VALUE)
    maxNrOfRefETFCIs._val = 8
    
    #-----< maxSet >-----#
    maxSet = INT(name='maxSet', mode=MODE_VALUE)
    maxSet._val = 9
    
    #-----< maxGANSSSat >-----#
    maxGANSSSat = INT(name='maxGANSSSat', mode=MODE_VALUE)
    maxGANSSSat._val = 64
    
    #-----< maxSgnType >-----#
    maxSgnType = INT(name='maxSgnType', mode=MODE_VALUE)
    maxSgnType._val = 8
    
    #-----< maxGANSS >-----#
    maxGANSS = INT(name='maxGANSS', mode=MODE_VALUE)
    maxGANSS._val = 8
    
    #-----< maxGANSSSet >-----#
    maxGANSSSet = INT(name='maxGANSSSet', mode=MODE_VALUE)
    maxGANSSSet._val = 9
    
    #-----< maxGANSSSatAlmanac >-----#
    maxGANSSSatAlmanac = INT(name='maxGANSSSatAlmanac', mode=MODE_VALUE)
    maxGANSSSatAlmanac._val = 36
    
    #-----< maxGANSSClockMod >-----#
    maxGANSSClockMod = INT(name='maxGANSSClockMod', mode=MODE_VALUE)
    maxGANSSClockMod._val = 4
    
    #-----< maxGANSS-1 >-----#
    maxGANSS_1 = INT(name='maxGANSS-1', mode=MODE_VALUE)
    maxGANSS_1._val = 7
    
    #-----< maxNrOfIRATMeasurements >-----#
    maxNrOfIRATMeasurements = INT(name='maxNrOfIRATMeasurements', mode=MODE_VALUE)
    maxNrOfIRATMeasurements._val = 16
    
    #-----< maxReportedGERANCells >-----#
    maxReportedGERANCells = INT(name='maxReportedGERANCells', mode=MODE_VALUE)
    maxReportedGERANCells._val = 6
    
    #-----< maxIonGridInfo >-----#
    maxIonGridInfo = INT(name='maxIonGridInfo', mode=MODE_VALUE)
    maxIonGridInfo._val = 320
    
    #-----< maxAddPos >-----#
    maxAddPos = INT(name='maxAddPos', mode=MODE_VALUE)
    maxAddPos._val = 8
    
    #-----< maxBeacons >-----#
    maxBeacons = INT(name='maxBeacons', mode=MODE_VALUE)
    maxBeacons._val = 64
    
    #-----< maxBTs >-----#
    maxBTs = INT(name='maxBTs', mode=MODE_VALUE)
    maxBTs._val = 32
    
    #-----< maxWLANs >-----#
    maxWLANs = INT(name='maxWLANs', mode=MODE_VALUE)
    maxWLANs._val = 64
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Cause._val = 1
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CriticalityDiagnostics._val = 2
    
    #-----< id-GPS-UTRAN-TRU >-----#
    id_GPS_UTRAN_TRU = INT(name='id-GPS-UTRAN-TRU', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GPS_UTRAN_TRU._val = 3
    
    #-----< id-InformationExchangeID >-----#
    id_InformationExchangeID = INT(name='id-InformationExchangeID', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeID._val = 4
    
    #-----< id-InformationExchangeObjectType-InfEx-Rprt >-----#
    id_InformationExchangeObjectType_InfEx_Rprt = INT(name='id-InformationExchangeObjectType-InfEx-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeObjectType_InfEx_Rprt._val = 5
    
    #-----< id-InformationExchangeObjectType-InfEx-Rqst >-----#
    id_InformationExchangeObjectType_InfEx_Rqst = INT(name='id-InformationExchangeObjectType-InfEx-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeObjectType_InfEx_Rqst._val = 6
    
    #-----< id-InformationExchangeObjectType-InfEx-Rsp >-----#
    id_InformationExchangeObjectType_InfEx_Rsp = INT(name='id-InformationExchangeObjectType-InfEx-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationExchangeObjectType_InfEx_Rsp._val = 7
    
    #-----< id-InformationReportCharacteristics >-----#
    id_InformationReportCharacteristics = INT(name='id-InformationReportCharacteristics', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationReportCharacteristics._val = 8
    
    #-----< id-InformationType >-----#
    id_InformationType = INT(name='id-InformationType', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_InformationType._val = 9
    
    #-----< id-GPS-MeasuredResultsList >-----#
    id_GPS_MeasuredResultsList = INT(name='id-GPS-MeasuredResultsList', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GPS_MeasuredResultsList._val = 10
    
    #-----< id-MethodType >-----#
    id_MethodType = INT(name='id-MethodType', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MethodType._val = 11
    
    #-----< id-RefPosition-InfEx-Rqst >-----#
    id_RefPosition_InfEx_Rqst = INT(name='id-RefPosition-InfEx-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RefPosition_InfEx_Rqst._val = 12
    
    #-----< id-RefPosition-InfEx-Rsp >-----#
    id_RefPosition_InfEx_Rsp = INT(name='id-RefPosition-InfEx-Rsp', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RefPosition_InfEx_Rsp._val = 13
    
    #-----< id-RefPosition-Inf-Rprt >-----#
    id_RefPosition_Inf_Rprt = INT(name='id-RefPosition-Inf-Rprt', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RefPosition_Inf_Rprt._val = 14
    
    #-----< id-RequestedDataValue >-----#
    id_RequestedDataValue = INT(name='id-RequestedDataValue', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedDataValue._val = 15
    
    #-----< id-RequestedDataValueInformation >-----#
    id_RequestedDataValueInformation = INT(name='id-RequestedDataValueInformation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestedDataValueInformation._val = 16
    
    #-----< id-TransactionID >-----#
    id_TransactionID = INT(name='id-TransactionID', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TransactionID._val = 17
    
    #-----< id-UE-PositionEstimate >-----#
    id_UE_PositionEstimate = INT(name='id-UE-PositionEstimate', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_PositionEstimate._val = 18
    
    #-----< id-CellId-MeasuredResultsSets >-----#
    id_CellId_MeasuredResultsSets = INT(name='id-CellId-MeasuredResultsSets', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellId_MeasuredResultsSets._val = 20
    
    #-----< id-OTDOA-MeasurementGroup >-----#
    id_OTDOA_MeasurementGroup = INT(name='id-OTDOA-MeasurementGroup', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOA_MeasurementGroup._val = 22
    
    #-----< id-AccuracyFulfilmentIndicator >-----#
    id_AccuracyFulfilmentIndicator = INT(name='id-AccuracyFulfilmentIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AccuracyFulfilmentIndicator._val = 23
    
    #-----< id-HorizontalAccuracyCode >-----#
    id_HorizontalAccuracyCode = INT(name='id-HorizontalAccuracyCode', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_HorizontalAccuracyCode._val = 24
    
    #-----< id-VerticalAccuracyCode >-----#
    id_VerticalAccuracyCode = INT(name='id-VerticalAccuracyCode', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_VerticalAccuracyCode._val = 25
    
    #-----< id-UTDOA-Group >-----#
    id_UTDOA_Group = INT(name='id-UTDOA-Group', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UTDOA_Group._val = 26
    
    #-----< id-RequestType >-----#
    id_RequestType = INT(name='id-RequestType', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RequestType._val = 28
    
    #-----< id-UE-PositioningCapability >-----#
    id_UE_PositioningCapability = INT(name='id-UE-PositioningCapability', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_PositioningCapability._val = 29
    
    #-----< id-UC-id >-----#
    id_UC_id = INT(name='id-UC-id', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UC_id._val = 30
    
    #-----< id-ResponseTime >-----#
    id_ResponseTime = INT(name='id-ResponseTime', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ResponseTime._val = 31
    
    #-----< id-PositioningPriority >-----#
    id_PositioningPriority = INT(name='id-PositioningPriority', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PositioningPriority._val = 32
    
    #-----< id-ClientType >-----#
    id_ClientType = INT(name='id-ClientType', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ClientType._val = 33
    
    #-----< id-PositioningMethod >-----#
    id_PositioningMethod = INT(name='id-PositioningMethod', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PositioningMethod._val = 34
    
    #-----< id-UTDOAPositioning >-----#
    id_UTDOAPositioning = INT(name='id-UTDOAPositioning', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UTDOAPositioning._val = 35
    
    #-----< id-GPSPositioning >-----#
    id_GPSPositioning = INT(name='id-GPSPositioning', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GPSPositioning._val = 36
    
    #-----< id-OTDOAAssistanceData >-----#
    id_OTDOAAssistanceData = INT(name='id-OTDOAAssistanceData', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOAAssistanceData._val = 37
    
    #-----< id-Positioning-ResponseTime >-----#
    id_Positioning_ResponseTime = INT(name='id-Positioning-ResponseTime', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Positioning_ResponseTime._val = 38
    
    #-----< id-EnvironmentCharacterisation >-----#
    id_EnvironmentCharacterisation = INT(name='id-EnvironmentCharacterisation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_EnvironmentCharacterisation._val = 39
    
    #-----< id-PositionData >-----#
    id_PositionData = INT(name='id-PositionData', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PositionData._val = 40
    
    #-----< id-IncludeVelocity >-----#
    id_IncludeVelocity = INT(name='id-IncludeVelocity', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IncludeVelocity._val = 41
    
    #-----< id-VelocityEstimate >-----#
    id_VelocityEstimate = INT(name='id-VelocityEstimate', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_VelocityEstimate._val = 42
    
    #-----< id-rxTimingDeviation768Info >-----#
    id_rxTimingDeviation768Info = INT(name='id-rxTimingDeviation768Info', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_rxTimingDeviation768Info._val = 43
    
    #-----< id-UC-ID-InfEx-Rqst >-----#
    id_UC_ID_InfEx_Rqst = INT(name='id-UC-ID-InfEx-Rqst', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UC_ID_InfEx_Rqst._val = 44
    
    #-----< id-UE-PositionEstimateInfo >-----#
    id_UE_PositionEstimateInfo = INT(name='id-UE-PositionEstimateInfo', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UE_PositionEstimateInfo._val = 45
    
    #-----< id-UTRAN-GPSReferenceTime >-----#
    id_UTRAN_GPSReferenceTime = INT(name='id-UTRAN-GPSReferenceTime', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UTRAN_GPSReferenceTime._val = 46
    
    #-----< id-UTRAN-GPSReferenceTimeResult >-----#
    id_UTRAN_GPSReferenceTimeResult = INT(name='id-UTRAN-GPSReferenceTimeResult', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UTRAN_GPSReferenceTimeResult._val = 47
    
    #-----< id-UTRAN-GPS-DriftRate >-----#
    id_UTRAN_GPS_DriftRate = INT(name='id-UTRAN-GPS-DriftRate', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UTRAN_GPS_DriftRate._val = 48
    
    #-----< id-OTDOA-AddMeasuredResultsInfo >-----#
    id_OTDOA_AddMeasuredResultsInfo = INT(name='id-OTDOA-AddMeasuredResultsInfo', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOA_AddMeasuredResultsInfo._val = 49
    
    #-----< id-GPS-ReferenceLocation >-----#
    id_GPS_ReferenceLocation = INT(name='id-GPS-ReferenceLocation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GPS_ReferenceLocation._val = 50
    
    #-----< id-OTDOA-MeasuredResultsSets >-----#
    id_OTDOA_MeasuredResultsSets = INT(name='id-OTDOA-MeasuredResultsSets', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOA_MeasuredResultsSets._val = 51
    
    #-----< id-rxTimingDeviation384extInfo >-----#
    id_rxTimingDeviation384extInfo = INT(name='id-rxTimingDeviation384extInfo', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_rxTimingDeviation384extInfo._val = 55
    
    #-----< id-ExtendedRoundTripTime >-----#
    id_ExtendedRoundTripTime = INT(name='id-ExtendedRoundTripTime', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtendedRoundTripTime._val = 56
    
    #-----< id-PeriodicPosCalcInfo >-----#
    id_PeriodicPosCalcInfo = INT(name='id-PeriodicPosCalcInfo', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PeriodicPosCalcInfo._val = 57
    
    #-----< id-PeriodicLocationInfo >-----#
    id_PeriodicLocationInfo = INT(name='id-PeriodicLocationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PeriodicLocationInfo._val = 58
    
    #-----< id-AmountOfReporting >-----#
    id_AmountOfReporting = INT(name='id-AmountOfReporting', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AmountOfReporting._val = 59
    
    #-----< id-MeasInstructionsUsed >-----#
    id_MeasInstructionsUsed = INT(name='id-MeasInstructionsUsed', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasInstructionsUsed._val = 60
    
    #-----< id-RRCstateChange >-----#
    id_RRCstateChange = INT(name='id-RRCstateChange', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_RRCstateChange._val = 61
    
    #-----< id-PeriodicTerminationCause >-----#
    id_PeriodicTerminationCause = INT(name='id-PeriodicTerminationCause', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PeriodicTerminationCause._val = 62
    
    #-----< id-MeasurementValidity >-----#
    id_MeasurementValidity = INT(name='id-MeasurementValidity', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_MeasurementValidity._val = 63
    
    #-----< id-roundTripTimeInfoWithType1 >-----#
    id_roundTripTimeInfoWithType1 = INT(name='id-roundTripTimeInfoWithType1', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_roundTripTimeInfoWithType1._val = 64
    
    #-----< id-CellIDPositioning >-----#
    id_CellIDPositioning = INT(name='id-CellIDPositioning', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellIDPositioning._val = 66
    
    #-----< id-AddMeasurementInfo >-----#
    id_AddMeasurementInfo = INT(name='id-AddMeasurementInfo', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AddMeasurementInfo._val = 67
    
    #-----< id-Extended-RNC-ID >-----#
    id_Extended_RNC_ID = INT(name='id-Extended-RNC-ID', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Extended_RNC_ID._val = 68
    
    #-----< id-GANSS-CommonAssistanceData >-----#
    id_GANSS_CommonAssistanceData = INT(name='id-GANSS-CommonAssistanceData', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_CommonAssistanceData._val = 69
    
    #-----< id-GANSS-GenericAssistanceDataList >-----#
    id_GANSS_GenericAssistanceDataList = INT(name='id-GANSS-GenericAssistanceDataList', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_GenericAssistanceDataList._val = 70
    
    #-----< id-GANSS-MeasuredResultsList >-----#
    id_GANSS_MeasuredResultsList = INT(name='id-GANSS-MeasuredResultsList', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_MeasuredResultsList._val = 71
    
    #-----< id-GANSS-UTRAN-TRU >-----#
    id_GANSS_UTRAN_TRU = INT(name='id-GANSS-UTRAN-TRU', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_UTRAN_TRU._val = 72
    
    #-----< id-GANSSPositioning >-----#
    id_GANSSPositioning = INT(name='id-GANSSPositioning', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSSPositioning._val = 73
    
    #-----< id-GANSS-PositioningDataSet >-----#
    id_GANSS_PositioningDataSet = INT(name='id-GANSS-PositioningDataSet', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_PositioningDataSet._val = 74
    
    #-----< id-GNSS-PositioningMethod >-----#
    id_GNSS_PositioningMethod = INT(name='id-GNSS-PositioningMethod', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GNSS_PositioningMethod._val = 75
    
    #-----< id-NetworkAssistedGANSSSuport >-----#
    id_NetworkAssistedGANSSSuport = INT(name='id-NetworkAssistedGANSSSuport', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_NetworkAssistedGANSSSuport._val = 76
    
    #-----< id-TUTRANGANSSMeasurementValueInfo >-----#
    id_TUTRANGANSSMeasurementValueInfo = INT(name='id-TUTRANGANSSMeasurementValueInfo', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_TUTRANGANSSMeasurementValueInfo._val = 77
    
    #-----< id-AdditionalGPSAssistDataRequired >-----#
    id_AdditionalGPSAssistDataRequired = INT(name='id-AdditionalGPSAssistDataRequired', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalGPSAssistDataRequired._val = 78
    
    #-----< id-AdditionalGanssAssistDataRequired >-----#
    id_AdditionalGanssAssistDataRequired = INT(name='id-AdditionalGanssAssistDataRequired', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AdditionalGanssAssistDataRequired._val = 79
    
    #-----< id-angleOfArrivalLCR >-----#
    id_angleOfArrivalLCR = INT(name='id-angleOfArrivalLCR', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_angleOfArrivalLCR._val = 80
    
    #-----< id-extendedTimingAdvanceLCR >-----#
    id_extendedTimingAdvanceLCR = INT(name='id-extendedTimingAdvanceLCR', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_extendedTimingAdvanceLCR._val = 81
    
    #-----< id-additionalMeasurementInforLCR >-----#
    id_additionalMeasurementInforLCR = INT(name='id-additionalMeasurementInforLCR', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_additionalMeasurementInforLCR._val = 82
    
    #-----< id-timingAdvanceLCR-R7 >-----#
    id_timingAdvanceLCR_R7 = INT(name='id-timingAdvanceLCR-R7', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_timingAdvanceLCR_R7._val = 83
    
    #-----< id-rxTimingDeviationLCR >-----#
    id_rxTimingDeviationLCR = INT(name='id-rxTimingDeviationLCR', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_rxTimingDeviationLCR._val = 84
    
    #-----< id-GPSReferenceTimeUncertainty >-----#
    id_GPSReferenceTimeUncertainty = INT(name='id-GPSReferenceTimeUncertainty', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GPSReferenceTimeUncertainty._val = 85
    
    #-----< id-GANSS-AddIonoModelReq >-----#
    id_GANSS_AddIonoModelReq = INT(name='id-GANSS-AddIonoModelReq', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AddIonoModelReq._val = 86
    
    #-----< id-GANSS-EarthOrientParaReq >-----#
    id_GANSS_EarthOrientParaReq = INT(name='id-GANSS-EarthOrientParaReq', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_EarthOrientParaReq._val = 87
    
    #-----< id-GANSS-Additional-Ionospheric-Model >-----#
    id_GANSS_Additional_Ionospheric_Model = INT(name='id-GANSS-Additional-Ionospheric-Model', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_Ionospheric_Model._val = 88
    
    #-----< id-GANSS-Earth-Orientation-Parameters >-----#
    id_GANSS_Earth_Orientation_Parameters = INT(name='id-GANSS-Earth-Orientation-Parameters', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Earth_Orientation_Parameters._val = 89
    
    #-----< id-GANSS-Additional-Time-Models >-----#
    id_GANSS_Additional_Time_Models = INT(name='id-GANSS-Additional-Time-Models', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_Time_Models._val = 90
    
    #-----< id-GANSS-Additional-Navigation-Models >-----#
    id_GANSS_Additional_Navigation_Models = INT(name='id-GANSS-Additional-Navigation-Models', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_Navigation_Models._val = 91
    
    #-----< id-GANSS-Additional-UTC-Models >-----#
    id_GANSS_Additional_UTC_Models = INT(name='id-GANSS-Additional-UTC-Models', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Additional_UTC_Models._val = 92
    
    #-----< id-GANSS-Auxiliary-Information >-----#
    id_GANSS_Auxiliary_Information = INT(name='id-GANSS-Auxiliary-Information', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Auxiliary_Information._val = 93
    
    #-----< id-GANSS-SBAS-ID >-----#
    id_GANSS_SBAS_ID = INT(name='id-GANSS-SBAS-ID', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_SBAS_ID._val = 94
    
    #-----< id-GANSS-SBAS-IDs >-----#
    id_GANSS_SBAS_IDs = INT(name='id-GANSS-SBAS-IDs', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_SBAS_IDs._val = 95
    
    #-----< id-GANSS-Signal-IDs >-----#
    id_GANSS_Signal_IDs = INT(name='id-GANSS-Signal-IDs', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Signal_IDs._val = 96
    
    #-----< id-supportGANSSNonNativeADchoices >-----#
    id_supportGANSSNonNativeADchoices = INT(name='id-supportGANSSNonNativeADchoices', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_supportGANSSNonNativeADchoices._val = 97
    
    #-----< id-PositionDataUEbased >-----#
    id_PositionDataUEbased = INT(name='id-PositionDataUEbased', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_PositionDataUEbased._val = 98
    
    #-----< id-ganssCodePhaseAmbiguityExt >-----#
    id_ganssCodePhaseAmbiguityExt = INT(name='id-ganssCodePhaseAmbiguityExt', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ganssCodePhaseAmbiguityExt._val = 99
    
    #-----< id-ganssIntegerCodePhaseExt >-----#
    id_ganssIntegerCodePhaseExt = INT(name='id-ganssIntegerCodePhaseExt', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ganssIntegerCodePhaseExt._val = 100
    
    #-----< id-GANSScarrierPhaseRequested >-----#
    id_GANSScarrierPhaseRequested = INT(name='id-GANSScarrierPhaseRequested', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSScarrierPhaseRequested._val = 101
    
    #-----< id-GANSSMultiFreqMeasRequested >-----#
    id_GANSSMultiFreqMeasRequested = INT(name='id-GANSSMultiFreqMeasRequested', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSSMultiFreqMeasRequested._val = 102
    
    #-----< id-ganssReq-AddIonosphericModel >-----#
    id_ganssReq_AddIonosphericModel = INT(name='id-ganssReq-AddIonosphericModel', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ganssReq_AddIonosphericModel._val = 103
    
    #-----< id-ganssReq-EarthOrientPara >-----#
    id_ganssReq_EarthOrientPara = INT(name='id-ganssReq-EarthOrientPara', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ganssReq_EarthOrientPara._val = 104
    
    #-----< id-ganssAddNavigationModel-req >-----#
    id_ganssAddNavigationModel_req = INT(name='id-ganssAddNavigationModel-req', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ganssAddNavigationModel_req._val = 105
    
    #-----< id-ganssAddUTCModel-req >-----#
    id_ganssAddUTCModel_req = INT(name='id-ganssAddUTCModel-req', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ganssAddUTCModel_req._val = 106
    
    #-----< id-ganssAuxInfo-req >-----#
    id_ganssAuxInfo_req = INT(name='id-ganssAuxInfo-req', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ganssAuxInfo_req._val = 107
    
    #-----< id-GANSS-AlmanacModelChoice >-----#
    id_GANSS_AlmanacModelChoice = INT(name='id-GANSS-AlmanacModelChoice', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AlmanacModelChoice._val = 108
    
    #-----< id-GANSS-alm-keplerianNAVAlmanac >-----#
    id_GANSS_alm_keplerianNAVAlmanac = INT(name='id-GANSS-alm-keplerianNAVAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianNAVAlmanac._val = 109
    
    #-----< id-GANSS-alm-keplerianReducedAlmanac >-----#
    id_GANSS_alm_keplerianReducedAlmanac = INT(name='id-GANSS-alm-keplerianReducedAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianReducedAlmanac._val = 110
    
    #-----< id-GANSS-alm-keplerianMidiAlmanac >-----#
    id_GANSS_alm_keplerianMidiAlmanac = INT(name='id-GANSS-alm-keplerianMidiAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianMidiAlmanac._val = 111
    
    #-----< id-GANSS-alm-keplerianGLONASS >-----#
    id_GANSS_alm_keplerianGLONASS = INT(name='id-GANSS-alm-keplerianGLONASS', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianGLONASS._val = 112
    
    #-----< id-GANSS-alm-ecefSBASAlmanac >-----#
    id_GANSS_alm_ecefSBASAlmanac = INT(name='id-GANSS-alm-ecefSBASAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_ecefSBASAlmanac._val = 113
    
    #-----< id-UTRAN-GANSSReferenceTimeResult >-----#
    id_UTRAN_GANSSReferenceTimeResult = INT(name='id-UTRAN-GANSSReferenceTimeResult', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_UTRAN_GANSSReferenceTimeResult._val = 114
    
    #-----< id-GANSS-Reference-Time-Only >-----#
    id_GANSS_Reference_Time_Only = INT(name='id-GANSS-Reference-Time-Only', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Reference_Time_Only._val = 115
    
    #-----< id-GANSS-AddADchoices >-----#
    id_GANSS_AddADchoices = INT(name='id-GANSS-AddADchoices', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_AddADchoices._val = 116
    
    #-----< id-OTDOA-ReferenceCellInfo >-----#
    id_OTDOA_ReferenceCellInfo = INT(name='id-OTDOA-ReferenceCellInfo', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_OTDOA_ReferenceCellInfo._val = 117
    
    #-----< id-DGNSS-ValidityPeriod >-----#
    id_DGNSS_ValidityPeriod = INT(name='id-DGNSS-ValidityPeriod', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DGNSS_ValidityPeriod._val = 118
    
    #-----< id-AzimuthAndElevationLSB >-----#
    id_AzimuthAndElevationLSB = INT(name='id-AzimuthAndElevationLSB', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AzimuthAndElevationLSB._val = 119
    
    #-----< id-completeAlmanacProvided >-----#
    id_completeAlmanacProvided = INT(name='id-completeAlmanacProvided', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_completeAlmanacProvided._val = 120
    
    #-----< id-GPS-Week-Cycle >-----#
    id_GPS_Week_Cycle = INT(name='id-GPS-Week-Cycle', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GPS_Week_Cycle._val = 121
    
    #-----< id-GANSS-Day-Cycle >-----#
    id_GANSS_Day_Cycle = INT(name='id-GANSS-Day-Cycle', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Day_Cycle._val = 122
    
    #-----< id-ganss-Delta-T >-----#
    id_ganss_Delta_T = INT(name='id-ganss-Delta-T', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ganss_Delta_T._val = 123
    
    #-----< id-requestedCellIDGERANMeasurements >-----#
    id_requestedCellIDGERANMeasurements = INT(name='id-requestedCellIDGERANMeasurements', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_requestedCellIDGERANMeasurements._val = 124
    
    #-----< id-CellId-IRATMeasuredResultsSets >-----#
    id_CellId_IRATMeasuredResultsSets = INT(name='id-CellId-IRATMeasuredResultsSets', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_CellId_IRATMeasuredResultsSets._val = 125
    
    #-----< id-IMSI >-----#
    id_IMSI = INT(name='id-IMSI', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IMSI._val = 128
    
    #-----< id-IMEI >-----#
    id_IMEI = INT(name='id-IMEI', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_IMEI._val = 129
    
    #-----< id-GANSS-alm-keplerianBDSAlmanac >-----#
    id_GANSS_alm_keplerianBDSAlmanac = INT(name='id-GANSS-alm-keplerianBDSAlmanac', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_alm_keplerianBDSAlmanac._val = 130
    
    #-----< id-BDS-Ionospheric-Grid-Model >-----#
    id_BDS_Ionospheric_Grid_Model = INT(name='id-BDS-Ionospheric-Grid-Model', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BDS_Ionospheric_Grid_Model._val = 131
    
    #-----< id-DBDS-Correction-Information >-----#
    id_DBDS_Correction_Information = INT(name='id-DBDS-Correction-Information', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DBDS_Correction_Information._val = 132
    
    #-----< id-BDSIonosphericGridModel >-----#
    id_BDSIonosphericGridModel = INT(name='id-BDSIonosphericGridModel', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_BDSIonosphericGridModel._val = 133
    
    #-----< id-DBDSCorrection >-----#
    id_DBDSCorrection = INT(name='id-DBDSCorrection', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_DBDSCorrection._val = 134
    
    #-----< id-Confidence >-----#
    id_Confidence = INT(name='id-Confidence', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Confidence._val = 135
    
    #-----< id-ExtraDopplerInfoExtension >-----#
    id_ExtraDopplerInfoExtension = INT(name='id-ExtraDopplerInfoExtension', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_ExtraDopplerInfoExtension._val = 136
    
    #-----< id-GANSS-Confidence >-----#
    id_GANSS_Confidence = INT(name='id-GANSS-Confidence', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_Confidence._val = 137
    
    #-----< id-GANSS-ExtraDopplerExtension >-----#
    id_GANSS_ExtraDopplerExtension = INT(name='id-GANSS-ExtraDopplerExtension', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_GANSS_ExtraDopplerExtension._val = 138
    
    #-----< id-Additional-PositioningDataSet >-----#
    id_Additional_PositioningDataSet = INT(name='id-Additional-PositioningDataSet', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_PositioningDataSet._val = 139
    
    #-----< id-Additional-PositioningMethod >-----#
    id_Additional_PositioningMethod = INT(name='id-Additional-PositioningMethod', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_Additional_PositioningMethod._val = 140
    
    #-----< id-AddPos-MeasuredResults >-----#
    id_AddPos_MeasuredResults = INT(name='id-AddPos-MeasuredResults', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AddPos_MeasuredResults._val = 141
    
    #-----< id-AddPosSupport >-----#
    id_AddPosSupport = INT(name='id-AddPosSupport', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    id_AddPosSupport._val = 142
    
    _all_ = [
        id_PositionCalculation,
        id_InformationExchangeInitiation,
        id_InformationReporting,
        id_InformationExchangeTermination,
        id_InformationExchangeFailure,
        id_ErrorIndication,
        id_privateMessage,
        id_PositionParameterModification,
        id_PositionInitiation,
        id_PositionActivation,
        id_Abort,
        id_PositionPeriodicReport,
        id_PositionPeriodicResult,
        id_PositionPeriodicTermination,
        maxNrOfErrors,
        maxSat,
        maxSatAlmanac,
        maxNrOfLevels,
        maxNrOfPoints,
        maxNrOfExpInfo,
        maxNrOfMeasNCell,
        maxNrOfMeasurements,
        maxNrOfSets,
        maxRateMatching,
        maxNrOfTFs,
        maxTTI_count,
        maxTS_1,
        maxCCTrCH,
        maxTF,
        maxTFC,
        maxPRACH,
        maxTrCH,
        maxTGPS,
        maxNoOfMeasurements,
        maxCellMeas,
        maxNrOfEDPCCH_PO_QUANTSTEPs,
        maxNrOfRefETFCI_PO_QUANTSTEPs,
        maxNrOfRefETFCIs,
        maxSet,
        maxGANSSSat,
        maxSgnType,
        maxGANSS,
        maxGANSSSet,
        maxGANSSSatAlmanac,
        maxGANSSClockMod,
        maxGANSS_1,
        maxNrOfIRATMeasurements,
        maxReportedGERANCells,
        maxIonGridInfo,
        maxAddPos,
        maxBeacons,
        maxBTs,
        maxWLANs,
        id_Cause,
        id_CriticalityDiagnostics,
        id_GPS_UTRAN_TRU,
        id_InformationExchangeID,
        id_InformationExchangeObjectType_InfEx_Rprt,
        id_InformationExchangeObjectType_InfEx_Rqst,
        id_InformationExchangeObjectType_InfEx_Rsp,
        id_InformationReportCharacteristics,
        id_InformationType,
        id_GPS_MeasuredResultsList,
        id_MethodType,
        id_RefPosition_InfEx_Rqst,
        id_RefPosition_InfEx_Rsp,
        id_RefPosition_Inf_Rprt,
        id_RequestedDataValue,
        id_RequestedDataValueInformation,
        id_TransactionID,
        id_UE_PositionEstimate,
        id_CellId_MeasuredResultsSets,
        id_OTDOA_MeasurementGroup,
        id_AccuracyFulfilmentIndicator,
        id_HorizontalAccuracyCode,
        id_VerticalAccuracyCode,
        id_UTDOA_Group,
        id_RequestType,
        id_UE_PositioningCapability,
        id_UC_id,
        id_ResponseTime,
        id_PositioningPriority,
        id_ClientType,
        id_PositioningMethod,
        id_UTDOAPositioning,
        id_GPSPositioning,
        id_OTDOAAssistanceData,
        id_Positioning_ResponseTime,
        id_EnvironmentCharacterisation,
        id_PositionData,
        id_IncludeVelocity,
        id_VelocityEstimate,
        id_rxTimingDeviation768Info,
        id_UC_ID_InfEx_Rqst,
        id_UE_PositionEstimateInfo,
        id_UTRAN_GPSReferenceTime,
        id_UTRAN_GPSReferenceTimeResult,
        id_UTRAN_GPS_DriftRate,
        id_OTDOA_AddMeasuredResultsInfo,
        id_GPS_ReferenceLocation,
        id_OTDOA_MeasuredResultsSets,
        id_rxTimingDeviation384extInfo,
        id_ExtendedRoundTripTime,
        id_PeriodicPosCalcInfo,
        id_PeriodicLocationInfo,
        id_AmountOfReporting,
        id_MeasInstructionsUsed,
        id_RRCstateChange,
        id_PeriodicTerminationCause,
        id_MeasurementValidity,
        id_roundTripTimeInfoWithType1,
        id_CellIDPositioning,
        id_AddMeasurementInfo,
        id_Extended_RNC_ID,
        id_GANSS_CommonAssistanceData,
        id_GANSS_GenericAssistanceDataList,
        id_GANSS_MeasuredResultsList,
        id_GANSS_UTRAN_TRU,
        id_GANSSPositioning,
        id_GANSS_PositioningDataSet,
        id_GNSS_PositioningMethod,
        id_NetworkAssistedGANSSSuport,
        id_TUTRANGANSSMeasurementValueInfo,
        id_AdditionalGPSAssistDataRequired,
        id_AdditionalGanssAssistDataRequired,
        id_angleOfArrivalLCR,
        id_extendedTimingAdvanceLCR,
        id_additionalMeasurementInforLCR,
        id_timingAdvanceLCR_R7,
        id_rxTimingDeviationLCR,
        id_GPSReferenceTimeUncertainty,
        id_GANSS_AddIonoModelReq,
        id_GANSS_EarthOrientParaReq,
        id_GANSS_Additional_Ionospheric_Model,
        id_GANSS_Earth_Orientation_Parameters,
        id_GANSS_Additional_Time_Models,
        id_GANSS_Additional_Navigation_Models,
        id_GANSS_Additional_UTC_Models,
        id_GANSS_Auxiliary_Information,
        id_GANSS_SBAS_ID,
        id_GANSS_SBAS_IDs,
        id_GANSS_Signal_IDs,
        id_supportGANSSNonNativeADchoices,
        id_PositionDataUEbased,
        id_ganssCodePhaseAmbiguityExt,
        id_ganssIntegerCodePhaseExt,
        id_GANSScarrierPhaseRequested,
        id_GANSSMultiFreqMeasRequested,
        id_ganssReq_AddIonosphericModel,
        id_ganssReq_EarthOrientPara,
        id_ganssAddNavigationModel_req,
        id_ganssAddUTCModel_req,
        id_ganssAuxInfo_req,
        id_GANSS_AlmanacModelChoice,
        id_GANSS_alm_keplerianNAVAlmanac,
        id_GANSS_alm_keplerianReducedAlmanac,
        id_GANSS_alm_keplerianMidiAlmanac,
        id_GANSS_alm_keplerianGLONASS,
        id_GANSS_alm_ecefSBASAlmanac,
        id_UTRAN_GANSSReferenceTimeResult,
        id_GANSS_Reference_Time_Only,
        id_GANSS_AddADchoices,
        id_OTDOA_ReferenceCellInfo,
        id_DGNSS_ValidityPeriod,
        id_AzimuthAndElevationLSB,
        id_completeAlmanacProvided,
        id_GPS_Week_Cycle,
        id_GANSS_Day_Cycle,
        id_ganss_Delta_T,
        id_requestedCellIDGERANMeasurements,
        id_CellId_IRATMeasuredResultsSets,
        id_IMSI,
        id_IMEI,
        id_GANSS_alm_keplerianBDSAlmanac,
        id_BDS_Ionospheric_Grid_Model,
        id_DBDS_Correction_Information,
        id_BDSIonosphericGridModel,
        id_DBDSCorrection,
        id_Confidence,
        id_ExtraDopplerInfoExtension,
        id_GANSS_Confidence,
        id_GANSS_ExtraDopplerExtension,
        id_Additional_PositioningDataSet,
        id_Additional_PositioningMethod,
        id_AddPos_MeasuredResults,
        id_AddPosSupport,
    ]

class PCAP_Containers:

    _name_  = 'PCAP-Containers'
    _oid_   = [0, 4, 0, 0, 20, 3, 4, 1, 5]
    
    _obj_ = [
        'PCAP-PROTOCOL-IES',
        'PCAP-PROTOCOL-EXTENSION',
        'PCAP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'PCAP-PROTOCOL-IES',
        'PCAP-PROTOCOL-EXTENSION',
        'PCAP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'PCAP-PROTOCOL-IES',
        'PCAP-PROTOCOL-EXTENSION',
        'PCAP-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-Single-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< PCAP-PROTOCOL-IES >-----#
    PCAP_PROTOCOL_IES = CLASS(name='PCAP-PROTOCOL-IES', mode=MODE_TYPE)
    _PCAP_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _PCAP_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'Criticality')))
    _PCAP_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _PCAP_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'Presence')))
    PCAP_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _PCAP_PROTOCOL_IES_id),
        ('criticality', _PCAP_PROTOCOL_IES_criticality),
        ('Value', _PCAP_PROTOCOL_IES_Value),
        ('presence', _PCAP_PROTOCOL_IES_presence),
        ])
    
    #-----< PCAP-PROTOCOL-EXTENSION >-----#
    PCAP_PROTOCOL_EXTENSION = CLASS(name='PCAP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _PCAP_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _PCAP_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'Criticality')))
    _PCAP_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _PCAP_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'Presence')))
    PCAP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _PCAP_PROTOCOL_EXTENSION_id),
        ('criticality', _PCAP_PROTOCOL_EXTENSION_criticality),
        ('Extension', _PCAP_PROTOCOL_EXTENSION_Extension),
        ('presence', _PCAP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< PCAP-PRIVATE-IES >-----#
    PCAP_PRIVATE_IES = CLASS(name='PCAP-PRIVATE-IES', mode=MODE_TYPE)
    _PCAP_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'PrivateIE-ID')))
    _PCAP_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'Criticality')))
    _PCAP_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _PCAP_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'Presence')))
    PCAP_PRIVATE_IES._cont = ASN1Dict([
        ('id', _PCAP_PRIVATE_IES_id),
        ('criticality', _PCAP_PRIVATE_IES_criticality),
        ('Value', _PCAP_PRIVATE_IES_Value),
        ('presence', _PCAP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Single-Container >-----#
    ProtocolIE_Single_Container = SEQ(name='ProtocolIE-Single-Container', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')), param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _PCAP_PROTOCOL_IES_id,
        _PCAP_PROTOCOL_IES_criticality,
        _PCAP_PROTOCOL_IES_Value,
        _PCAP_PROTOCOL_IES_presence,
        PCAP_PROTOCOL_IES,
        _PCAP_PROTOCOL_EXTENSION_id,
        _PCAP_PROTOCOL_EXTENSION_criticality,
        _PCAP_PROTOCOL_EXTENSION_Extension,
        _PCAP_PROTOCOL_EXTENSION_presence,
        PCAP_PROTOCOL_EXTENSION,
        _PCAP_PRIVATE_IES_id,
        _PCAP_PRIVATE_IES_criticality,
        _PCAP_PRIVATE_IES_Value,
        _PCAP_PRIVATE_IES_presence,
        PCAP_PRIVATE_IES,
    ]

class PCAP_IEs:

    _name_  = 'PCAP-IEs'
    _oid_   = [0, 4, 0, 0, 20, 3, 4, 1, 2]
    
    _obj_ = [
        'AccuracyFulfilmentIndicator',
        'AdditionalMethodType',
        'AddPos-MeasuredResults',
        'AddPos-MeasuredResults-Element',
        'BarometricPressure-ExtIEs',
        'WLANMeasurementList-ExtIEs',
        'BTMeasurementList-ExtIEs',
        'MBSMeasurementList-ExtIEs',
        'WLANMeasurementList',
        'WLANMeasurementList-Element',
        'WLANMeasurementList-Element-ExtIEs',
        'BTMeasurementList',
        'BTMeasurementList-Element',
        'BTMeasurementList-Element-ExtIEs',
        'MBSMeasurementList',
        'MBSMeasurementList-Element',
        'MBSMeasurementList-Element-ExtIEs',
        'BaroMeasurement',
        'AlmanacAndSatelliteHealthSIB',
        'AlmanacAndSatelliteHealthSIB-ExtIEs',
        'Cause',
        'CauseRadioNetwork',
        'CauseTransport',
        'CauseProtocol',
        'CauseMisc',
        'CellId-MeasuredResultsSets',
        'CellId-MeasuredResultsInfoList',
        'CellId-MeasuredResultsInfo',
        'CellId-MeasuredResultsInfo-ExtIEs',
        'RoundTripTimeInfo',
        'RoundTripTimeInfo-ExtIEs',
        'RoundTripTimeInfoWithType1',
        'RoundTripTimeInfoWithType1-ExtIEs',
        'UE-RxTxTimeDifferenceType2',
        'UE-RxTxTimeDifferenceType1',
        'UE-PositioningMeasQuality',
        'UE-PositioningMeasQuality-ExtIEs',
        'RoundTripTime',
        'ExtendedRoundTripTime',
        'UTRANAccessPointPositionAltitude',
        'UTRANAccessPointPositionAltitude-ExtIEs',
        'RxTimingDeviationInfo',
        'RxTimingDeviationInfo-ExtIEs',
        'RxTimingDeviationLCRInfo',
        'RxTimingDeviationLCRInfo-ExtIEs',
        'ExtendedTimingAdvanceLCR',
        'RxTimingDeviation768Info',
        'RxTimingDeviation768Info-ExtIEs',
        'RxTimingDeviation384extInfo',
        'RxTimingDeviation384extInfo-ExtIEs',
        'AddMeasurementInfo',
        'AddMeasurementInfo-ExtIEs',
        'AngleOfArrivalLCR',
        'AngleOfArrivalLCR-ExtIEs',
        'RxTimingDeviation',
        'RxTimingDeviationLCR',
        'RxTimingDeviation768',
        'RxTimingDeviation384ext',
        'TimingAdvance',
        'TimingAdvanceLCR',
        'TimingAdvance768',
        'TimingAdvance384ext',
        'Pathloss',
        'CPICH-EcNo',
        'CPICH-RSCP',
        'AOA-LCR',
        'AOA-LCR-Accuracy-Class',
        'CellId-IRATMeasuredResultsSets',
        'CellId-IRATMeasuredResultsInfoList',
        'CellId-IRATMeasuredResultsInfoListExtIEs',
        'GERAN-MeasuredResultsInfoList',
        'GERAN-MeasuredResultsInfo',
        'GERAN-MeasuredResultsInfo-ExtIEs',
        'GERANCellGlobalID',
        'GERANCellGlobalID-ExtIEs',
        'PLMN-Identity',
        'GSM-RSSI',
        'GERANPhysicalCellID',
        'GSM-BSIC',
        'GSM-BCCH-ARFCN',
        'CellIDPositioning',
        'CellIDPositioning-ExtIEs',
        'RequestedCellIDMeasurements',
        'RequestedCellIDMeasurementsFDD-ExtIEs',
        'RequestedCellIDMeasurementsTDD-ExtIEs',
        'RequestedCellIDGERANMeasurements',
        'RequestedCellIDGERANMeasurements-ExtIEs',
        'ClientType',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnosticsRepetition',
        'TypeOfError',
        'DGPSCorrections',
        'DGPSCorrections-ExtIEs',
        'DiffCorrectionStatus',
        'DGPS-CorrectionSatInfoList',
        'DGPS-CorrectionSatInfo',
        'DGPS-CorrectionSatInfo-ExtIEs',
        'DGNSS-ValidityPeriod',
        'DGNSS-ValidityPeriod-ExtIEs',
        'UDRE',
        'UDREGrowthRate',
        'UDREValidityTime',
        'PRC',
        'RRC',
        'IMEI',
        'IMSI',
        'UE-PositionEstimate',
        'GeographicalCoordinates',
        'GeographicalCoordinates-ExtIEs',
        'GA-AltitudeAndDirection',
        'GA-EllipsoidArc',
        'GA-EllipsoidArc-ExtIEs',
        'GA-Point',
        'GA-Point-ExtIEs',
        'GA-PointWithAltitude',
        'GA-PointWithAltitude-ExtIEs',
        'GA-PointWithAltitudeAndUncertaintyEllipsoid',
        'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        'GA-PointWithUnCertainty',
        'GA-PointWithUnCertainty-ExtIEs',
        'GA-PointWithUnCertaintyEllipse',
        'GA-PointWithUnCertaintyEllipse-ExtIEs',
        'GA-Polygon',
        'GA-Polygon-ExtIEs',
        'GA-UncertaintyEllipse',
        'UE-PositionEstimateInfo',
        'UE-PositionEstimateInfo-ExtIEs',
        'ReferenceTimeChoice',
        'Extension-ReferenceTimeChoice',
        'Extension-ReferenceTimeChoice-IE',
        'Cell-Timing',
        'Cell-Timing-ExtIEs',
        'GANSS-Reference-Time-Only',
        'GANSS-Reference-Time-Only-ExtIEs',
        'PositionDataUEbased',
        'PositionDataUEbased-ExtIEs',
        'PositionData',
        'PositionData-ExtIEs',
        'GANSS-PositioningDataSet',
        'GANSS-PositioningMethodAndUsage',
        'PositioningDataDiscriminator',
        'PositioningDataSet',
        'PositioningMethodAndUsage',
        'Additional-PositioningDataSet',
        'Additional-PositioningMethodAndUsage',
        'GPS-AcquisitionAssistance',
        'GPS-AcquisitionAssistance-ExtIEs',
        'AcquisitionSatInfoList',
        'AcquisitionSatInfo',
        'AcquisitionSatInfo-ExtIEs',
        'ExtraDopplerInfo',
        'ExtraDopplerInfo-ExtIEs',
        'ExtraDopplerInfoExtension',
        'ExtraDopplerInfoExtension-ExtIEs',
        'DopplerUncertainty',
        'DopplerUncertaintyExtension',
        'CodePhaseSearchWindow',
        'AzimuthAndElevation',
        'AzimuthAndElevation-ExtIEs',
        'AzimuthAndElevationLSB',
        'AzimuthAndElevationLSB-ExtIEs',
        'Confidence',
        'AuxInfoGANSS-ID1',
        'AuxInfoGANSS-ID1-element',
        'AuxInfoGANSS-ID1-element-ExtIEs',
        'AuxInfoGANSS-ID3',
        'AuxInfoGANSS-ID3-element',
        'AuxInfoGANSS-ID3-element-ExtIEs',
        'CNAVclockModel',
        'CNAVclockModel-ExtIEs',
        'DeltaUT1',
        'DeltaUT1-ExtIEs',
        'DGANSS-Corrections',
        'DGANSS-Corrections-ExtIEs',
        'DGANSS-Information',
        'DGANSS-InformationItem',
        'DGANSS-InformationItem-ExtIEs',
        'DGANSS-SignalInformation',
        'DGANSS-SignalInformationItem',
        'DGANSS-SignalInformationItem-ExtIEs',
        'GANSS-AddClockModels',
        'GANSS-AddOrbitModels',
        'GANSS-Additional-Ionospheric-Model',
        'GANSS-Additional-Ionospheric-Model-ExtIEs',
        'GANSS-Additional-Navigation-Models',
        'GANSS-Additional-Navigation-Models-ExtIEs',
        'GANSS-Additional-Time-Models',
        'GANSS-Additional-UTC-Models',
        'GANSS-ALM-BDSKeplericanset',
        'GANSS-ALM-BDSKeplericanset-ExtIEs',
        'Satellite-Information-BDS-KP-List',
        'Satellite-Information-BDS-KP-Item',
        'Satellite-Information-BDS-KP-Item-ExtIEs',
        'GANSS-ALM-ECEFsbasAlmanacSet',
        'GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs',
        'GANSS-ALM-GlonassAlmanacSet',
        'GANSS-ALM-GlonassAlmanacSet-ExtIEs',
        'GANSS-ALM-MidiAlmanacSet',
        'GANSS-ALM-MidiAlmanacSet-ExtIEs',
        'GANSS-ALM-NAVKeplerianSet',
        'GANSS-ALM-NAVKeplerianSet-ExtIEs',
        'GANSS-ALM-ReducedKeplerianSet',
        'GANSS-ALM-ReducedKeplerianSet-ExtIEs',
        'GANSS-AlmanacAndSatelliteHealth',
        'GANSS-AlmanacAndSatelliteHealth-ExtIEs',
        'GANSS-AlmanacModel',
        'Extension-GANSS-AlmanacModel',
        'Extension-GANSS-AlmanacModel-IE',
        'GANSS-Auxiliary-Information',
        'GANSS-AzimuthAndElevation',
        'GANSS-AzimuthAndElevation-ExtIEs',
        'GANSS-Clock-Model',
        'GANSS-CommonAssistanceData',
        'GANSS-CommonAssistanceData-ExtIEs',
        'GANSS-Data-Bit-Assistance',
        'GANSS-Data-Bit-Assistance-ExtIEs',
        'GANSS-DataBitAssistanceList',
        'GANSS-DataBitAssistanceItem',
        'GANSS-DataBitAssistanceItem-ExtIEs',
        'GANSS-DataBitAssistanceSgnList',
        'GANSS-DataBitAssistanceSgnItem',
        'GANSS-DataBitAssistanceSgnItem-ExtIEs',
        'GANSS-Earth-Orientation-Parameters',
        'GANSS-Earth-Orientation-Parameters-ExtIEs',
        'GANSS-ExtraDoppler',
        'GANSS-ExtraDoppler-ExtIEs',
        'GANSS-ExtraDopplerExtension',
        'GANSS-ExtraDopplerExtension-ExtIEs',
        'GANSS-GenericAssistanceDataList',
        'GANSSGenericAssistanceData',
        'GANSSGenericAssistance-ExtIEs',
        'BDS-Ionospheric-Grid-Model',
        'BDS-Ionospheric-Grid-Model-ExtIEs',
        'BDS-Reference-Time',
        'BDS-Ionospheric-Grid-Information',
        'BDS-Ionospheric-Grid-Information-ExtIEs',
        'DBDS-Correction-Information',
        'DBDS-Correction-Information-ExtIEs',
        'DBDS-Information',
        'DBDS-Information-ExtIEs',
        'DGANSS-Signal-Information',
        'DGANSS-Signal-Information-ExtIEs',
        'GANSS-GenericMeasurementInfo',
        'GANSS-GenericMeasurementInfo-ExtIEs',
        'GANSSID',
        'GANSSID-ExtIEs',
        'GANSSMeasurementSignalList',
        'GANSSMeasurementSignalList-ExtIEs',
        'GanssCodePhaseAmbiguityExt',
        'GanssCodePhaseAmbiguityExt-ExtIEs',
        'GANSS-Ionospheric-Model',
        'GANSS-Ionospheric-Model-ExtIEs',
        'GANSS-IonosphereRegionalStormFlags',
        'GANSS-IonosphereRegionalStormFlags-ExtIEs',
        'GANSS-KeplerianParametersAlm',
        'GANSS-KeplerianParametersAlm-ExtIEs',
        'GANSS-KeplerianParametersOrb',
        'GANSS-KeplerianParametersOrb-ExtIEs',
        'GANSS-MeasurementParameters',
        'GANSS-MeasurementParametersItem',
        'GANSS-MeasurementParametersItem-ExtIEs',
        'GanssIntegerCodePhaseExt',
        'GanssIntegerCodePhaseExt-ExtIEs',
        'GANSS-MeasuredResultsList',
        'GANSS-MeasuredResults',
        'GANSS-MeasuredResults-ExtIEs',
        'GANSS-Navigation-Model',
        'GANSS-Navigation-Model-ExtIEs',
        'GANSS-Orbit-Model',
        'GANSS-Real-Time-Integrity',
        'GANSS-RealTimeInformationItem',
        'GANSS-RealTimeInformationItem-ExtIEs',
        'GANSS-Reference-Location',
        'GANSS-Reference-Location-ExtIEs',
        'GANSS-ReferenceMeasurementInfo',
        'GANSS-ReferenceMeasurementInfo-ExtIEs',
        'GANSS-Reference-Time',
        'GANSS-Reference-Time-ExtIEs',
        'GANSS-Day-Cycle',
        'GANSS-ReferenceTimeOnly',
        'GANSS-ReferenceTimeOnly-ExtIEs',
        'GANSS-SatelliteClockModelItem',
        'GANSS-SatelliteClockModelItem-ExtIEs',
        'GANSS-SatelliteInformation',
        'GANSS-SatelliteInformationItem',
        'GANSS-SatelliteInformationItem-ExtIEs',
        'GANSS-SatelliteInformationKP',
        'GANSS-SatelliteInformationKPItem',
        'GANSS-SatelliteInformationKPItem-ExtIEs',
        'GANSS-SAT-Info-Almanac-GLOkpList',
        'GANSS-SAT-Info-Almanac-GLOkp',
        'GANSS-SAT-Info-Almanac-GLOkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-MIDIkpList',
        'GANSS-SAT-Info-Almanac-MIDIkp',
        'GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-NAVkpList',
        'GANSS-SAT-Info-Almanac-NAVkp',
        'GANSS-SAT-Info-Almanac-NAVkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-REDkpList',
        'GANSS-SAT-Info-Almanac-REDkp',
        'GANSS-SAT-Info-Almanac-REDkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-SBASecefList',
        'GANSS-SAT-Info-Almanac-SBASecef',
        'GANSS-SAT-Info-Almanac-SBASecef-ExtIEs',
        'Ganss-Sat-Info-AddNavList',
        'Ganss-Sat-Info-AddNavList-ExtIEs',
        'GANSS-Sat-Info-Nav',
        'GANSS-Sat-Info-Nav-ExtIEs',
        'GANSS-SignalID',
        'GANSS-SignalID-ExtIEs',
        'GANSS-StatusHealth',
        'GANSS-Time-Model',
        'GANSS-Time-Model-ExtIEs',
        'GANSS-Delta-T',
        'GANSS-UTRAN-TimeRelationshipUncertainty',
        'GANSS-UTRAN-TRU',
        'GANSS-UTRAN-TRU-ExtIEs',
        'GANSS-UTC-Model',
        'GANSS-UTC-Model-ExtIEs',
        'TUTRAN-GANSS-DriftRate',
        'GLONASSclockModel',
        'GLONASSclockModel-ExtIEs',
        'NAVclockModel',
        'NAVclockModel-ExtIEs',
        'NavModel-CNAVKeplerianSet',
        'NavModel-CNAVKeplerianSet-ExtIEs',
        'NavModel-GLONASSecef',
        'NavModel-GLONASSecef-ExtIEs',
        'NavModel-NAVKeplerianSet',
        'NavModel-NAVKeplerianSet-ExtIEs',
        'NavModel-SBASecef',
        'NavModel-SBASecef-ExtIEs',
        'NavModel-BDSKeplerianSet',
        'NavModel-BDSKeplerianSet-ExtIEs',
        'SBASclockModel',
        'SBASclockModel-ExtIEs',
        'BDSClockModel',
        'BDSClockModel-ExtIEs',
        'UTCmodelSet1',
        'UTCmodelSet1-ExtIEs',
        'UTCmodelSet2',
        'UTCmodelSet2-ExtIEs',
        'UTCmodelSet3',
        'UTCmodelSet3-ExtIEs',
        'UTCmodelSet4',
        'UTCmodelSet4-ExtIEs',
        'UTRAN-GANSSReferenceTimeDL',
        'UTRAN-GANSSReferenceTimeDL-ExtIEs',
        'UTRAN-GANSSReferenceTimeUL',
        'UTRAN-GANSSReferenceTimeUL-ExtIEs',
        'GPS-AlmanacAndSatelliteHealth',
        'GPS-AlmanacAndSatelliteHealth-ExtIEs',
        'CompleteAlmanacProvided',
        'AlmanacSatInfoList',
        'AlmanacSatInfo',
        'AlmanacSatInfo-ExtIEs',
        'GPS-ClockAndEphemerisParameters',
        'GPS-ClockAndEphemerisParameters-ExtIEs',
        'SubFrame1Reserved',
        'GPS-Ionospheric-Model',
        'GPS-Ionospheric-Model-ExtIEs',
        'MeasuredResultsList',
        'GPS-MeasuredResults',
        'GPS-MeasuredResults-ExtIEs',
        'GPS-MeasurementParamList',
        'GPS-MeasurementParam',
        'MultipathIndicator',
        'GPS-MeasurementParam-ExtIEs',
        'GPS-NavigationModel',
        'NavigationModelSatInfo',
        'NavigationModelSatInfo-ExtIEs',
        'SatelliteStatus',
        'GPS-RealTimeIntegrity',
        'BadSatList',
        'NoBadSatellites',
        'GPS-ReferenceLocation',
        'GPS-ReferenceLocation-ExtIEs',
        'GPS-ReferenceTime',
        'GPS-ReferenceTime-ExtIEs',
        'GPS-Week-Cycle',
        'GPS-TOW-AssistList',
        'GPS-TOW-Assist',
        'GPS-TOW-Assist-ExtIEs',
        'UTRAN-GPS-DriftRate',
        'GPSReferenceTimeUncertainty',
        'GPSReferenceTimeUncertainty-ExtIEs',
        'GPS-Transmission-TOW',
        'GPS-UTC-Model',
        'GPS-UTCmodel-ExtIEs',
        'GPS-UTRAN-TRU',
        'AdditionalGPSAssistDataRequired',
        'AdditionalGPSAssistDataRequired-ExtIEs',
        'AdditionalGanssAssistDataRequired',
        'AdditionalGanssAssistDataRequired-ExtIEs',
        'GANSSReq-AddIonosphericModel',
        'GANSSReq-AddIonosphericModel-ExtIEs',
        'GANSSReq-EarthOrientPara',
        'GanssRequestedGenericAssistanceDataList',
        'GanssReqGenericData',
        'GanssReqGenericData-ExtIEs',
        'BDSIonosphericGridModel',
        'DBDSCorrection',
        'DBDSCorrection-ExtIEs',
        'GANSS-AddNavigationModel-Req',
        'GANSS-AddUTCModel-Req',
        'GANSS-AuxInfo-req',
        'GANSS-AddADchoices',
        'GANSS-AddADchoices-ExtIEs',
        'DGANSS-Sig-Id-Req',
        'GanssDataBits',
        'GanssDataBits-ExtIEs',
        'ReqDataBitAssistanceList',
        'ReqDataBitAssistanceList-ExtIEs',
        'InformationExchangeID',
        'InformationReportCharacteristics',
        'InformationReportCharacteristicsType',
        'InformationReportPeriodicity',
        'InformationType',
        'ExplicitInformationList',
        'ExplicitInformation',
        'DganssCorrectionsReq',
        'DganssCorrectionsReq-ExtIEs',
        'Ganss-almanacAndSatelliteHealthReq',
        'Ganss-almanacAndSatelliteHealthReq-ExtIEs',
        'GANSSCommonDataReq',
        'GANSSCommonDataReq-ExtIEs',
        'GANSS-AddIonoModelReq',
        'GANSS-AddIonoModelReq-ExtIEs',
        'GANSS-EarthOrientParaReq',
        'GANSS-EarthOrientParaReq-ExtIEs',
        'GANSSGenericDataList',
        'GANSSGenericDataReq',
        'AddNavigationModelsGANSS',
        'AddNavigationModelsGANSS-ExtIEs',
        'AddSatelliteRelatedDataListGANSS',
        'AddSatelliteRelatedDataGANSS',
        'AddSatelliteRelatedDataGANSS-ExtIEs',
        'BDS-Ionospheric-Grid-Model-Request',
        'DBDS-Corrections',
        'DBDS-Corrections-ExtIEs',
        'GANSS-AddUtcModelsReq',
        'GANSS-AddUtcModelsReq-ExtIEs',
        'GANSS-AuxInfoReq',
        'GANSS-AuxInfoReq-ExtIEs',
        'GANSS-SBAS-ID',
        'Ganss-utcModelReq',
        'Ganss-utcModelReq-ExtIEs',
        'Ganss-realTimeIntegrityReq',
        'Ganss-realTimeIntegrityReq-ExtIEs',
        'Ganss-referenceMeasurementInfoReq',
        'Ganss-referenceMeasurementInfoReq-ExtIEs',
        'Ganss-TimeModel-Gnss-Gnss',
        'Ganss-TimeModel-Gnss-Gnss-ExtIEs',
        'TransmissionGanssTimeIndicator',
        'AlmanacAndSatelliteHealth',
        'UtcModel',
        'UtcModel-ExtIEs',
        'IonosphericModel',
        'IonosphericModel-ExtIEs',
        'NavigationModel',
        'NavigationModel-ExtIEs',
        'NavModelAdditionalData',
        'NavModelAdditionalData-ExtIEs',
        'SatelliteRelatedDataList',
        'SatelliteRelatedData',
        'SatelliteRelatedData-ExtIEs',
        'NavigationModelGANSS',
        'NavigationModelGANSS-ExtIEs',
        'SatelliteRelatedDataListGANSS',
        'SatelliteRelatedDataGANSS',
        'SatelliteRelatedDataGANSS-ExtIEs',
        'DgpsCorrections',
        'ReferenceTime',
        'AcquisitionAssistance',
        'RealTimeIntegrity',
        'AlmanacAndSatelliteHealthSIB-InfoType',
        'AlmanacAndSatelliteHealthSIB-InfoType-ExtIEs',
        'ReferenceLocation',
        'TransmissionTOWIndicator',
        'MessageStructure',
        'MessageStructureRepetition',
        'MessageStructure-ExtIEs',
        'MeasInstructionsUsed',
        'MeasInstructionsUsed-ExtIEs',
        'MeasurementValidity',
        'MeasurementValidity-ExtIEs',
        'MethodType',
        'OTDOA-MeasurementGroup',
        'OTDOA-MeasurementGroup-ExtIEs',
        'OTDOA-ReferenceCellInfo',
        'OTDOA-ReferenceCellInfo-ExtIEs',
        'OTDOA-ReferenceCellInfoSAS-centric',
        'OTDOA-ReferenceCellInfoSAS-centric-ExtIEs',
        'OTDOA-NeighbourCellInfoList',
        'OTDOA-NeighbourCellInfo',
        'OTDOA-NeighbourCellInfo-ExtIEs',
        'OTDOA-MeasuredResultsSets',
        'OTDOA-MeasuredResultsInfoList',
        'OTDOA-MeasuredResultsInfo',
        'OTDOA-MeasuredResultsInfo-ExtIEs',
        'OTDOA-AddMeasuredResultsInfo',
        'OTDOA-AddMeasuredResultsInfo-ExtIEs',
        'UE-SFNSFNTimeDifferenceType2Info',
        'UE-SFNSFNTimeDifferenceInfo-ExtIEs',
        'UC-ID',
        'UC-ID-ExtIEs',
        'Extended-RNC-ID',
        'RelativeTimingDifferenceInfo',
        'SFNSFNMeasurementValueInfo',
        'SFNSFNMeasurementValueInfo-ExtIEs',
        'SFNSFNValue',
        'SFNSFNQuality',
        'SFNSFNDriftRate',
        'SFNSFNDriftRateQuality',
        'TUTRANGPSMeasurementValueInfo',
        'TUTRANGPSMeasurementValueInfo-ExtIEs',
        'SFN',
        'TUTRANGPS',
        'TUTRANGPSQuality',
        'TUTRANGPSDriftRate',
        'TUTRANGPSDriftRateQuality',
        'TUTRANGANSSMeasurementValueInfo',
        'TUTRANGANSSMeasurementValueInfo-ExtIEs',
        'TUTRANGANSS',
        'AdditionalMeasurementInforLCR',
        'AdditionalMeasurementInforLCR-ExtIEs',
        'TimingAdvanceLCR-R7',
        'PeriodicPosCalcInfo',
        'PeriodicPosCalcInfo-ExtIEs',
        'PeriodicLocationInfo',
        'PeriodicLocationInfo-ExtIEs',
        'PeriodicTerminationCause',
        'PositioningMethod',
        'PositioningMethod-ExtIEs',
        'GNSS-PositioningMethod',
        'Additional-PositioningMethod',
        'SelectedPositionMethod',
        'PositioningPriority',
        'RRCstateChange',
        'RRCstateChange-ExtIEs',
        'RequestedDataValue',
        'RequestedDataValue-ExtIEs',
        'RequestedDataValueInformation',
        'InformationAvailable',
        'InformationAvailable-ExtIEs',
        'InformationNotAvailable',
        'RequestType',
        'RequestType-ExtIEs',
        'RequestTypeEvent',
        'RequestTypeReportArea',
        'RequestTypeAccuracyCode',
        'ResponseTime',
        'HorizontalAccuracyCode',
        'UE-PositioningCapability',
        'UE-PositioningCapability-ExtIEs',
        'NetworkAssistedGANSSSupport',
        'AddPosSupport',
        'AddPosSupport-Element',
        'NetworkAssistedGANSSSuport-ExtIEs',
        'NetworkAssistedGPSSuport',
        'GANSS-SBAS-IDs',
        'GANSS-SBAS-IDs-ExtIEs',
        'GANSS-Signal-IDs',
        'GANSS-Signal-IDs-ExtIEs',
        'SupportGANSSNonNativeADchoices',
        'UTDOAPositioning',
        'UTDOAPositioning-ExtIEs',
        'UTDOA-BitCount',
        'UTDOA-TimeInterval',
        'EnvironmentCharacterisation',
        'GPSPositioning',
        'GPSPositioning-ExtIEs',
        'GPSPositioningInstructions',
        'GPSPositioningInstructions-ExtIEs',
        'GANSSPositioning',
        'GANSSPositioning-ExtIEs',
        'GANSS-PositioningInstructions',
        'GANSS-PositioningInstructions-ExtIEs',
        'GANSScarrierPhaseRequested',
        'GANSSMultiFreqMeasRequested',
        'OTDOAAssistanceData',
        'OTDOAAssistanceData-ExtIEs',
        'UE-Positioning-OTDOA-AssistanceData',
        'UE-Positioning-OTDOAAssistanceData-ExtIEs',
        'UE-Positioning-OTDOA-ReferenceCellInfo',
        'UE-Positioning-OTDOAReferenceCellInfo-ExtIEs',
        'ReferenceCellPosition',
        'UE-Positioning-IPDL-Parameters',
        'UE-Positioning-IPDL-Parameters-ExtIEs',
        'IP-Spacing',
        'IP-Length',
        'BurstModeParameters',
        'BurstModeParameters-ExtIEs',
        'UE-Positioning-OTDOA-NeighbourCellList',
        'UE-Positioning-OTDOA-NeighbourCellInfo',
        'UE-Positioning-OTDOANeighbourCellInfo-ExtIEs',
        'SFN-SFN-RelTimeDifference1',
        'SFN-SFN-RelTimeDifference1-ExtIEs',
        'SFN-Offset-Validity',
        'OTDOA-SearchWindowSize',
        'SFN-SFN-Drift',
        'FineSFNSFN',
        'VerticalAccuracyCode',
        'UTDOA-Group',
        'UTDOA-Group-ExtIEs',
        'FrequencyInfo',
        'FrequencyInfo-ExtIEs',
        'FrequencyInfoFDD',
        'FrequencyInfoFDD-ExtIEs',
        'FrequencyInfoTDD',
        'FrequencyInfoTDD-ExtIEs',
        'UTDOA-RRCState',
        'UTDOA-CELLDCH',
        'UTDOA-CELLDCH-ExtIEs',
        'UL-DPCHInfo',
        'UL-DPCHInfoFDD-ExtIEs',
        'UL-DPCHInfoTDD-ExtIEs',
        'Compressed-Mode-Assistance-Data',
        'Compressed-Mode-Assistance-DataFDD-ExtIEs',
        'DL-InformationFDD',
        'DL-InformationFDD-ExtIEs',
        'UL-InformationFDD',
        'UL-InformationFDD-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Information',
        'Transmission-Gap-Pattern-Sequence-Information-ExtIEs',
        'TGD',
        'TGPRC',
        'TGPSID',
        'TGSN',
        'Uplink-Compressed-Mode-Method',
        'GapDuration',
        'GapLength',
        'Active-Pattern-Sequence-Information',
        'Active-Pattern-Sequence-Information-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Status-List',
        'Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs',
        'DCH-Information',
        'DCH-Information-ExtIEs',
        'TrChInfoList',
        'UL-TrCHInfo',
        'UL-TrCHInfo-ExtIEs',
        'UL-TrCHType',
        'E-DPCH-Information',
        'E-DPCH-Information-ExtIEs',
        'Max-Set-E-DPDCHs',
        'E-TFCS-Information',
        'E-TFCS-Information-ExtIEs',
        'E-DCH-TFCS-Index',
        'Reference-E-TFCI-Information',
        'Reference-E-TFCI-Information-Item',
        'Reference-E-TFCI-Information-Item-ExtIEs',
        'Reference-E-TFCI-PO',
        'E-TFCI',
        'E-TTI',
        'E-DPCCH-PO',
        'CellParameterID',
        'TFCI-Coding',
        'RepetitionLength',
        'RepetitionPeriod',
        'TDD-DPCHOffset',
        'UL-Timeslot-Information',
        'maxNrOfULTSs',
        'UL-Timeslot-InformationItem',
        'UL-Timeslot-InformationItem-ExtIEs',
        'TimeSlot',
        'MidambleShiftAndBurstType',
        'MidambleShiftLong',
        'MidambleShiftShort',
        'MidambleConfigurationBurstType1And3',
        'MidambleConfigurationBurstType2',
        'TDD-UL-Code-Information',
        'maxNrOfDPCHs',
        'TDD-UL-Code-InformationItem',
        'TDD-UL-Code-InformationItem-ExtIEs',
        'TDD-ChannelisationCode',
        'SpecialBurstScheduling',
        'UTDOA-CELLFACH',
        'UTDOA-CELLFACH-ExtIEs',
        'PRACHparameters',
        'PRACH-ChannelInfo',
        'PRACH-ChannelInfo-ExtIEs',
        'PRACH-Info',
        'PRACH-Info-FDD-ExtIEs',
        'PRACH-Info-TDD-ExtIEs',
        'SF-PRACH',
        'AvailableSignatures',
        'PreambleScramblingCodeWordNumber',
        'PuncturingLimit',
        'AvailableSubChannelNumbers',
        'ScramblingCodeType',
        'UL-ScramblingCode',
        'NumberOfFBI-Bits',
        'TransportFormatSet',
        'TransportFormatSet-ExtIEs',
        'TransportFormatSet-DynamicPartList',
        'TransportFormatSet-DynamicPartList-ExtIEs',
        'TbsTTIInfo',
        'TbsTTIInfo-ExtIEs',
        'RLC-Size',
        'TransportFormatSet-NrOfTransportBlocks',
        'TransportFormatSet-Semi-staticPart',
        'TransportFormatSet-Semi-staticPart-ExtIEs',
        'TransportFormatSet-TransmissionTimeIntervalSemiStatic',
        'TransportFormatSet-ChannelCodingType',
        'TransportFormatSet-CodingRate',
        'TransportFormatSet-RateMatchingAttribute',
        'TransportFormatSet-CRC-Size',
        'TransportFormatSet-TransmissionTimeIntervalDynamic',
        'TFCS',
        'CTFC',
        'C-RNTI',
        'UARFCN',
        'CFN',
        'ChipOffset',
        'FrameOffset',
        'PrimaryScramblingCode',
        'UschParameters',
        'UschParameters-ExtIEs',
        'USCH-SchedulingOffset',
        'MaxPRACH-MidambleShifts',
        'PRACH-Midamble',
        'Positioning-ResponseTime',
        'AmountOfReporting',
        'IncludeVelocity',
        'VelocityEstimate',
        'HorizontalVelocity',
        'HorizontalVelocity-ExtIEs',
        'HorizontalWithVerticalVelocity',
        'HorizontalWithVerticalVelocity-ExtIEs',
        'HorizontalVelocityWithUncertainty',
        'HorizontalVelocityWithUncertainty-ExtIEs',
        'HorizontalWithVerticalVelocityAndUncertainty',
        'HorizontalWithVerticalVelocityAndUncertainty-ExtIEs',
        'HorizontalSpeedAndBearing',
        'VerticalVelocity',
        'VerticalSpeedDirection',
        'UTRAN-GPSReferenceTime',
        'UTRAN-GPSReferenceTime-ExtIEs',
        'UTRAN-GPSReferenceTimeResult',
        'UTRAN-GPSReferenceTimeResult-ExtIEs',
        'UTRAN-GANSSReferenceTimeResult',
        'UTRAN-GANSSReferenceTimeResult-ExtIEs',
        ]
    _type_ = [
        'AccuracyFulfilmentIndicator',
        'AdditionalMethodType',
        'AddPos-MeasuredResults',
        'AddPos-MeasuredResults-Element',
        'WLANMeasurementList',
        'WLANMeasurementList-Element',
        'BTMeasurementList',
        'BTMeasurementList-Element',
        'MBSMeasurementList',
        'MBSMeasurementList-Element',
        'BaroMeasurement',
        'AlmanacAndSatelliteHealthSIB',
        'Cause',
        'CauseRadioNetwork',
        'CauseTransport',
        'CauseProtocol',
        'CauseMisc',
        'CellId-MeasuredResultsSets',
        'CellId-MeasuredResultsInfoList',
        'CellId-MeasuredResultsInfo',
        'RoundTripTimeInfo',
        'RoundTripTimeInfoWithType1',
        'UE-RxTxTimeDifferenceType2',
        'UE-RxTxTimeDifferenceType1',
        'UE-PositioningMeasQuality',
        'RoundTripTime',
        'ExtendedRoundTripTime',
        'UTRANAccessPointPositionAltitude',
        'RxTimingDeviationInfo',
        'RxTimingDeviationLCRInfo',
        'ExtendedTimingAdvanceLCR',
        'RxTimingDeviation768Info',
        'RxTimingDeviation384extInfo',
        'AddMeasurementInfo',
        'AngleOfArrivalLCR',
        'RxTimingDeviation',
        'RxTimingDeviationLCR',
        'RxTimingDeviation768',
        'RxTimingDeviation384ext',
        'TimingAdvance',
        'TimingAdvanceLCR',
        'TimingAdvance768',
        'TimingAdvance384ext',
        'Pathloss',
        'CPICH-EcNo',
        'CPICH-RSCP',
        'AOA-LCR',
        'AOA-LCR-Accuracy-Class',
        'CellId-IRATMeasuredResultsSets',
        'CellId-IRATMeasuredResultsInfoList',
        'GERAN-MeasuredResultsInfoList',
        'GERAN-MeasuredResultsInfo',
        'GERANCellGlobalID',
        'PLMN-Identity',
        'GSM-RSSI',
        'GERANPhysicalCellID',
        'GSM-BSIC',
        'GSM-BCCH-ARFCN',
        'CellIDPositioning',
        'RequestedCellIDMeasurements',
        'RequestedCellIDGERANMeasurements',
        'ClientType',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnosticsRepetition',
        'TypeOfError',
        'DGPSCorrections',
        'DiffCorrectionStatus',
        'DGPS-CorrectionSatInfoList',
        'DGPS-CorrectionSatInfo',
        'DGNSS-ValidityPeriod',
        'UDRE',
        'UDREGrowthRate',
        'UDREValidityTime',
        'PRC',
        'RRC',
        'IMEI',
        'IMSI',
        'UE-PositionEstimate',
        'GeographicalCoordinates',
        'GA-AltitudeAndDirection',
        'GA-EllipsoidArc',
        'GA-Point',
        'GA-PointWithAltitude',
        'GA-PointWithAltitudeAndUncertaintyEllipsoid',
        'GA-PointWithUnCertainty',
        'GA-PointWithUnCertaintyEllipse',
        'GA-Polygon',
        'GA-UncertaintyEllipse',
        'UE-PositionEstimateInfo',
        'ReferenceTimeChoice',
        'Extension-ReferenceTimeChoice',
        'Cell-Timing',
        'GANSS-Reference-Time-Only',
        'PositionDataUEbased',
        'PositionData',
        'GANSS-PositioningDataSet',
        'GANSS-PositioningMethodAndUsage',
        'PositioningDataDiscriminator',
        'PositioningDataSet',
        'PositioningMethodAndUsage',
        'Additional-PositioningDataSet',
        'Additional-PositioningMethodAndUsage',
        'GPS-AcquisitionAssistance',
        'AcquisitionSatInfoList',
        'AcquisitionSatInfo',
        'ExtraDopplerInfo',
        'ExtraDopplerInfoExtension',
        'DopplerUncertainty',
        'DopplerUncertaintyExtension',
        'CodePhaseSearchWindow',
        'AzimuthAndElevation',
        'AzimuthAndElevationLSB',
        'Confidence',
        'AuxInfoGANSS-ID1',
        'AuxInfoGANSS-ID1-element',
        'AuxInfoGANSS-ID3',
        'AuxInfoGANSS-ID3-element',
        'CNAVclockModel',
        'DeltaUT1',
        'DGANSS-Corrections',
        'DGANSS-Information',
        'DGANSS-InformationItem',
        'DGANSS-SignalInformation',
        'DGANSS-SignalInformationItem',
        'GANSS-AddClockModels',
        'GANSS-AddOrbitModels',
        'GANSS-Additional-Ionospheric-Model',
        'GANSS-Additional-Navigation-Models',
        'GANSS-Additional-Time-Models',
        'GANSS-Additional-UTC-Models',
        'GANSS-ALM-BDSKeplericanset',
        'Satellite-Information-BDS-KP-List',
        'Satellite-Information-BDS-KP-Item',
        'GANSS-ALM-ECEFsbasAlmanacSet',
        'GANSS-ALM-GlonassAlmanacSet',
        'GANSS-ALM-MidiAlmanacSet',
        'GANSS-ALM-NAVKeplerianSet',
        'GANSS-ALM-ReducedKeplerianSet',
        'GANSS-AlmanacAndSatelliteHealth',
        'GANSS-AlmanacModel',
        'Extension-GANSS-AlmanacModel',
        'GANSS-Auxiliary-Information',
        'GANSS-AzimuthAndElevation',
        'GANSS-Clock-Model',
        'GANSS-CommonAssistanceData',
        'GANSS-Data-Bit-Assistance',
        'GANSS-DataBitAssistanceList',
        'GANSS-DataBitAssistanceItem',
        'GANSS-DataBitAssistanceSgnList',
        'GANSS-DataBitAssistanceSgnItem',
        'GANSS-Earth-Orientation-Parameters',
        'GANSS-ExtraDoppler',
        'GANSS-ExtraDopplerExtension',
        'GANSS-GenericAssistanceDataList',
        'GANSSGenericAssistanceData',
        'BDS-Ionospheric-Grid-Model',
        'BDS-Reference-Time',
        'BDS-Ionospheric-Grid-Information',
        'DBDS-Correction-Information',
        'DBDS-Information',
        'DGANSS-Signal-Information',
        'GANSS-GenericMeasurementInfo',
        'GANSSID',
        'GANSSMeasurementSignalList',
        'GanssCodePhaseAmbiguityExt',
        'GANSS-Ionospheric-Model',
        'GANSS-IonosphereRegionalStormFlags',
        'GANSS-KeplerianParametersAlm',
        'GANSS-KeplerianParametersOrb',
        'GANSS-MeasurementParameters',
        'GANSS-MeasurementParametersItem',
        'GanssIntegerCodePhaseExt',
        'GANSS-MeasuredResultsList',
        'GANSS-MeasuredResults',
        'GANSS-Navigation-Model',
        'GANSS-Orbit-Model',
        'GANSS-Real-Time-Integrity',
        'GANSS-RealTimeInformationItem',
        'GANSS-Reference-Location',
        'GANSS-ReferenceMeasurementInfo',
        'GANSS-Reference-Time',
        'GANSS-Day-Cycle',
        'GANSS-ReferenceTimeOnly',
        'GANSS-SatelliteClockModelItem',
        'GANSS-SatelliteInformation',
        'GANSS-SatelliteInformationItem',
        'GANSS-SatelliteInformationKP',
        'GANSS-SatelliteInformationKPItem',
        'GANSS-SAT-Info-Almanac-GLOkpList',
        'GANSS-SAT-Info-Almanac-GLOkp',
        'GANSS-SAT-Info-Almanac-MIDIkpList',
        'GANSS-SAT-Info-Almanac-MIDIkp',
        'GANSS-SAT-Info-Almanac-NAVkpList',
        'GANSS-SAT-Info-Almanac-NAVkp',
        'GANSS-SAT-Info-Almanac-REDkpList',
        'GANSS-SAT-Info-Almanac-REDkp',
        'GANSS-SAT-Info-Almanac-SBASecefList',
        'GANSS-SAT-Info-Almanac-SBASecef',
        'Ganss-Sat-Info-AddNavList',
        'GANSS-Sat-Info-Nav',
        'GANSS-SignalID',
        'GANSS-StatusHealth',
        'GANSS-Time-Model',
        'GANSS-Delta-T',
        'GANSS-UTRAN-TimeRelationshipUncertainty',
        'GANSS-UTRAN-TRU',
        'GANSS-UTC-Model',
        'TUTRAN-GANSS-DriftRate',
        'GLONASSclockModel',
        'NAVclockModel',
        'NavModel-CNAVKeplerianSet',
        'NavModel-GLONASSecef',
        'NavModel-NAVKeplerianSet',
        'NavModel-SBASecef',
        'NavModel-BDSKeplerianSet',
        'SBASclockModel',
        'BDSClockModel',
        'UTCmodelSet1',
        'UTCmodelSet2',
        'UTCmodelSet3',
        'UTCmodelSet4',
        'UTRAN-GANSSReferenceTimeDL',
        'UTRAN-GANSSReferenceTimeUL',
        'GPS-AlmanacAndSatelliteHealth',
        'CompleteAlmanacProvided',
        'AlmanacSatInfoList',
        'AlmanacSatInfo',
        'GPS-ClockAndEphemerisParameters',
        'SubFrame1Reserved',
        'GPS-Ionospheric-Model',
        'MeasuredResultsList',
        'GPS-MeasuredResults',
        'GPS-MeasurementParamList',
        'GPS-MeasurementParam',
        'MultipathIndicator',
        'GPS-NavigationModel',
        'NavigationModelSatInfo',
        'SatelliteStatus',
        'GPS-RealTimeIntegrity',
        'BadSatList',
        'NoBadSatellites',
        'GPS-ReferenceLocation',
        'GPS-ReferenceTime',
        'GPS-Week-Cycle',
        'GPS-TOW-AssistList',
        'GPS-TOW-Assist',
        'UTRAN-GPS-DriftRate',
        'GPSReferenceTimeUncertainty',
        'GPS-Transmission-TOW',
        'GPS-UTC-Model',
        'GPS-UTRAN-TRU',
        'AdditionalGPSAssistDataRequired',
        'AdditionalGanssAssistDataRequired',
        'GANSSReq-AddIonosphericModel',
        'GANSSReq-EarthOrientPara',
        'GanssRequestedGenericAssistanceDataList',
        'GanssReqGenericData',
        'BDSIonosphericGridModel',
        'DBDSCorrection',
        'GANSS-AddNavigationModel-Req',
        'GANSS-AddUTCModel-Req',
        'GANSS-AuxInfo-req',
        'GANSS-AddADchoices',
        'DGANSS-Sig-Id-Req',
        'GanssDataBits',
        'ReqDataBitAssistanceList',
        'InformationExchangeID',
        'InformationReportCharacteristics',
        'InformationReportCharacteristicsType',
        'InformationReportPeriodicity',
        'InformationType',
        'ExplicitInformationList',
        'ExplicitInformation',
        'DganssCorrectionsReq',
        'Ganss-almanacAndSatelliteHealthReq',
        'GANSSCommonDataReq',
        'GANSS-AddIonoModelReq',
        'GANSS-EarthOrientParaReq',
        'GANSSGenericDataList',
        'GANSSGenericDataReq',
        'AddNavigationModelsGANSS',
        'AddSatelliteRelatedDataListGANSS',
        'AddSatelliteRelatedDataGANSS',
        'BDS-Ionospheric-Grid-Model-Request',
        'DBDS-Corrections',
        'GANSS-AddUtcModelsReq',
        'GANSS-AuxInfoReq',
        'GANSS-SBAS-ID',
        'Ganss-utcModelReq',
        'Ganss-realTimeIntegrityReq',
        'Ganss-referenceMeasurementInfoReq',
        'Ganss-TimeModel-Gnss-Gnss',
        'TransmissionGanssTimeIndicator',
        'AlmanacAndSatelliteHealth',
        'UtcModel',
        'IonosphericModel',
        'NavigationModel',
        'NavModelAdditionalData',
        'SatelliteRelatedDataList',
        'SatelliteRelatedData',
        'NavigationModelGANSS',
        'SatelliteRelatedDataListGANSS',
        'SatelliteRelatedDataGANSS',
        'DgpsCorrections',
        'ReferenceTime',
        'AcquisitionAssistance',
        'RealTimeIntegrity',
        'AlmanacAndSatelliteHealthSIB-InfoType',
        'ReferenceLocation',
        'TransmissionTOWIndicator',
        'MessageStructure',
        'MessageStructureRepetition',
        'MeasInstructionsUsed',
        'MeasurementValidity',
        'MethodType',
        'OTDOA-MeasurementGroup',
        'OTDOA-ReferenceCellInfo',
        'OTDOA-ReferenceCellInfoSAS-centric',
        'OTDOA-NeighbourCellInfoList',
        'OTDOA-NeighbourCellInfo',
        'OTDOA-MeasuredResultsSets',
        'OTDOA-MeasuredResultsInfoList',
        'OTDOA-MeasuredResultsInfo',
        'OTDOA-AddMeasuredResultsInfo',
        'UE-SFNSFNTimeDifferenceType2Info',
        'UC-ID',
        'Extended-RNC-ID',
        'RelativeTimingDifferenceInfo',
        'SFNSFNMeasurementValueInfo',
        'SFNSFNValue',
        'SFNSFNQuality',
        'SFNSFNDriftRate',
        'SFNSFNDriftRateQuality',
        'TUTRANGPSMeasurementValueInfo',
        'SFN',
        'TUTRANGPS',
        'TUTRANGPSQuality',
        'TUTRANGPSDriftRate',
        'TUTRANGPSDriftRateQuality',
        'TUTRANGANSSMeasurementValueInfo',
        'TUTRANGANSS',
        'AdditionalMeasurementInforLCR',
        'TimingAdvanceLCR-R7',
        'PeriodicPosCalcInfo',
        'PeriodicLocationInfo',
        'PeriodicTerminationCause',
        'PositioningMethod',
        'GNSS-PositioningMethod',
        'Additional-PositioningMethod',
        'SelectedPositionMethod',
        'PositioningPriority',
        'RRCstateChange',
        'RequestedDataValue',
        'RequestedDataValueInformation',
        'InformationAvailable',
        'InformationNotAvailable',
        'RequestType',
        'RequestTypeEvent',
        'RequestTypeReportArea',
        'RequestTypeAccuracyCode',
        'ResponseTime',
        'HorizontalAccuracyCode',
        'UE-PositioningCapability',
        'NetworkAssistedGANSSSupport',
        'AddPosSupport',
        'AddPosSupport-Element',
        'NetworkAssistedGPSSuport',
        'GANSS-SBAS-IDs',
        'GANSS-Signal-IDs',
        'SupportGANSSNonNativeADchoices',
        'UTDOAPositioning',
        'UTDOA-BitCount',
        'UTDOA-TimeInterval',
        'EnvironmentCharacterisation',
        'GPSPositioning',
        'GPSPositioningInstructions',
        'GANSSPositioning',
        'GANSS-PositioningInstructions',
        'GANSScarrierPhaseRequested',
        'GANSSMultiFreqMeasRequested',
        'OTDOAAssistanceData',
        'UE-Positioning-OTDOA-AssistanceData',
        'UE-Positioning-OTDOA-ReferenceCellInfo',
        'ReferenceCellPosition',
        'UE-Positioning-IPDL-Parameters',
        'IP-Spacing',
        'IP-Length',
        'BurstModeParameters',
        'UE-Positioning-OTDOA-NeighbourCellList',
        'UE-Positioning-OTDOA-NeighbourCellInfo',
        'SFN-SFN-RelTimeDifference1',
        'SFN-Offset-Validity',
        'OTDOA-SearchWindowSize',
        'SFN-SFN-Drift',
        'FineSFNSFN',
        'VerticalAccuracyCode',
        'UTDOA-Group',
        'FrequencyInfo',
        'FrequencyInfoFDD',
        'FrequencyInfoTDD',
        'UTDOA-RRCState',
        'UTDOA-CELLDCH',
        'UL-DPCHInfo',
        'Compressed-Mode-Assistance-Data',
        'DL-InformationFDD',
        'UL-InformationFDD',
        'Transmission-Gap-Pattern-Sequence-Information',
        'TGD',
        'TGPRC',
        'TGPSID',
        'TGSN',
        'Uplink-Compressed-Mode-Method',
        'GapDuration',
        'GapLength',
        'Active-Pattern-Sequence-Information',
        'Transmission-Gap-Pattern-Sequence-Status-List',
        'DCH-Information',
        'TrChInfoList',
        'UL-TrCHInfo',
        'UL-TrCHType',
        'E-DPCH-Information',
        'Max-Set-E-DPDCHs',
        'E-TFCS-Information',
        'E-DCH-TFCS-Index',
        'Reference-E-TFCI-Information',
        'Reference-E-TFCI-Information-Item',
        'Reference-E-TFCI-PO',
        'E-TFCI',
        'E-TTI',
        'E-DPCCH-PO',
        'CellParameterID',
        'TFCI-Coding',
        'RepetitionLength',
        'RepetitionPeriod',
        'TDD-DPCHOffset',
        'UL-Timeslot-Information',
        'UL-Timeslot-InformationItem',
        'TimeSlot',
        'MidambleShiftAndBurstType',
        'MidambleShiftLong',
        'MidambleShiftShort',
        'MidambleConfigurationBurstType1And3',
        'MidambleConfigurationBurstType2',
        'TDD-UL-Code-Information',
        'TDD-UL-Code-InformationItem',
        'TDD-ChannelisationCode',
        'SpecialBurstScheduling',
        'UTDOA-CELLFACH',
        'PRACHparameters',
        'PRACH-ChannelInfo',
        'PRACH-Info',
        'SF-PRACH',
        'AvailableSignatures',
        'PreambleScramblingCodeWordNumber',
        'PuncturingLimit',
        'AvailableSubChannelNumbers',
        'ScramblingCodeType',
        'UL-ScramblingCode',
        'NumberOfFBI-Bits',
        'TransportFormatSet',
        'TransportFormatSet-DynamicPartList',
        'TbsTTIInfo',
        'RLC-Size',
        'TransportFormatSet-NrOfTransportBlocks',
        'TransportFormatSet-Semi-staticPart',
        'TransportFormatSet-TransmissionTimeIntervalSemiStatic',
        'TransportFormatSet-ChannelCodingType',
        'TransportFormatSet-CodingRate',
        'TransportFormatSet-RateMatchingAttribute',
        'TransportFormatSet-CRC-Size',
        'TransportFormatSet-TransmissionTimeIntervalDynamic',
        'TFCS',
        'CTFC',
        'C-RNTI',
        'UARFCN',
        'CFN',
        'ChipOffset',
        'FrameOffset',
        'PrimaryScramblingCode',
        'UschParameters',
        'USCH-SchedulingOffset',
        'MaxPRACH-MidambleShifts',
        'PRACH-Midamble',
        'Positioning-ResponseTime',
        'AmountOfReporting',
        'IncludeVelocity',
        'VelocityEstimate',
        'HorizontalVelocity',
        'HorizontalWithVerticalVelocity',
        'HorizontalVelocityWithUncertainty',
        'HorizontalWithVerticalVelocityAndUncertainty',
        'HorizontalSpeedAndBearing',
        'VerticalVelocity',
        'VerticalSpeedDirection',
        'UTRAN-GPSReferenceTime',
        'UTRAN-GPSReferenceTimeResult',
        'UTRAN-GANSSReferenceTimeResult',
        ]
    _set_ = [
        'BarometricPressure-ExtIEs',
        'WLANMeasurementList-ExtIEs',
        'BTMeasurementList-ExtIEs',
        'MBSMeasurementList-ExtIEs',
        'WLANMeasurementList-Element-ExtIEs',
        'BTMeasurementList-Element-ExtIEs',
        'MBSMeasurementList-Element-ExtIEs',
        'AlmanacAndSatelliteHealthSIB-ExtIEs',
        'CellId-MeasuredResultsInfo-ExtIEs',
        'RoundTripTimeInfo-ExtIEs',
        'RoundTripTimeInfoWithType1-ExtIEs',
        'UE-PositioningMeasQuality-ExtIEs',
        'UTRANAccessPointPositionAltitude-ExtIEs',
        'RxTimingDeviationInfo-ExtIEs',
        'RxTimingDeviationLCRInfo-ExtIEs',
        'RxTimingDeviation768Info-ExtIEs',
        'RxTimingDeviation384extInfo-ExtIEs',
        'AddMeasurementInfo-ExtIEs',
        'AngleOfArrivalLCR-ExtIEs',
        'CellId-IRATMeasuredResultsInfoListExtIEs',
        'GERAN-MeasuredResultsInfo-ExtIEs',
        'GERANCellGlobalID-ExtIEs',
        'CellIDPositioning-ExtIEs',
        'RequestedCellIDMeasurementsFDD-ExtIEs',
        'RequestedCellIDMeasurementsTDD-ExtIEs',
        'RequestedCellIDGERANMeasurements-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'DGPSCorrections-ExtIEs',
        'DGPS-CorrectionSatInfo-ExtIEs',
        'DGNSS-ValidityPeriod-ExtIEs',
        'GeographicalCoordinates-ExtIEs',
        'GA-EllipsoidArc-ExtIEs',
        'GA-Point-ExtIEs',
        'GA-PointWithAltitude-ExtIEs',
        'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        'GA-PointWithUnCertainty-ExtIEs',
        'GA-PointWithUnCertaintyEllipse-ExtIEs',
        'GA-Polygon-ExtIEs',
        'UE-PositionEstimateInfo-ExtIEs',
        'Extension-ReferenceTimeChoice-IE',
        'Cell-Timing-ExtIEs',
        'GANSS-Reference-Time-Only-ExtIEs',
        'PositionDataUEbased-ExtIEs',
        'PositionData-ExtIEs',
        'GPS-AcquisitionAssistance-ExtIEs',
        'AcquisitionSatInfo-ExtIEs',
        'ExtraDopplerInfo-ExtIEs',
        'ExtraDopplerInfoExtension-ExtIEs',
        'AzimuthAndElevation-ExtIEs',
        'AzimuthAndElevationLSB-ExtIEs',
        'AuxInfoGANSS-ID1-element-ExtIEs',
        'AuxInfoGANSS-ID3-element-ExtIEs',
        'CNAVclockModel-ExtIEs',
        'DeltaUT1-ExtIEs',
        'DGANSS-Corrections-ExtIEs',
        'DGANSS-InformationItem-ExtIEs',
        'DGANSS-SignalInformationItem-ExtIEs',
        'GANSS-Additional-Ionospheric-Model-ExtIEs',
        'GANSS-Additional-Navigation-Models-ExtIEs',
        'GANSS-ALM-BDSKeplericanset-ExtIEs',
        'Satellite-Information-BDS-KP-Item-ExtIEs',
        'GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs',
        'GANSS-ALM-GlonassAlmanacSet-ExtIEs',
        'GANSS-ALM-MidiAlmanacSet-ExtIEs',
        'GANSS-ALM-NAVKeplerianSet-ExtIEs',
        'GANSS-ALM-ReducedKeplerianSet-ExtIEs',
        'GANSS-AlmanacAndSatelliteHealth-ExtIEs',
        'Extension-GANSS-AlmanacModel-IE',
        'GANSS-AzimuthAndElevation-ExtIEs',
        'GANSS-CommonAssistanceData-ExtIEs',
        'GANSS-Data-Bit-Assistance-ExtIEs',
        'GANSS-DataBitAssistanceItem-ExtIEs',
        'GANSS-DataBitAssistanceSgnItem-ExtIEs',
        'GANSS-Earth-Orientation-Parameters-ExtIEs',
        'GANSS-ExtraDoppler-ExtIEs',
        'GANSS-ExtraDopplerExtension-ExtIEs',
        'GANSSGenericAssistance-ExtIEs',
        'BDS-Ionospheric-Grid-Model-ExtIEs',
        'BDS-Ionospheric-Grid-Information-ExtIEs',
        'DBDS-Correction-Information-ExtIEs',
        'DBDS-Information-ExtIEs',
        'DGANSS-Signal-Information-ExtIEs',
        'GANSS-GenericMeasurementInfo-ExtIEs',
        'GANSSID-ExtIEs',
        'GANSSMeasurementSignalList-ExtIEs',
        'GanssCodePhaseAmbiguityExt-ExtIEs',
        'GANSS-Ionospheric-Model-ExtIEs',
        'GANSS-IonosphereRegionalStormFlags-ExtIEs',
        'GANSS-KeplerianParametersAlm-ExtIEs',
        'GANSS-KeplerianParametersOrb-ExtIEs',
        'GANSS-MeasurementParametersItem-ExtIEs',
        'GanssIntegerCodePhaseExt-ExtIEs',
        'GANSS-MeasuredResults-ExtIEs',
        'GANSS-Navigation-Model-ExtIEs',
        'GANSS-RealTimeInformationItem-ExtIEs',
        'GANSS-Reference-Location-ExtIEs',
        'GANSS-ReferenceMeasurementInfo-ExtIEs',
        'GANSS-Reference-Time-ExtIEs',
        'GANSS-ReferenceTimeOnly-ExtIEs',
        'GANSS-SatelliteClockModelItem-ExtIEs',
        'GANSS-SatelliteInformationItem-ExtIEs',
        'GANSS-SatelliteInformationKPItem-ExtIEs',
        'GANSS-SAT-Info-Almanac-GLOkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-NAVkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-REDkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-SBASecef-ExtIEs',
        'Ganss-Sat-Info-AddNavList-ExtIEs',
        'GANSS-Sat-Info-Nav-ExtIEs',
        'GANSS-SignalID-ExtIEs',
        'GANSS-Time-Model-ExtIEs',
        'GANSS-UTRAN-TRU-ExtIEs',
        'GANSS-UTC-Model-ExtIEs',
        'GLONASSclockModel-ExtIEs',
        'NAVclockModel-ExtIEs',
        'NavModel-CNAVKeplerianSet-ExtIEs',
        'NavModel-GLONASSecef-ExtIEs',
        'NavModel-NAVKeplerianSet-ExtIEs',
        'NavModel-SBASecef-ExtIEs',
        'NavModel-BDSKeplerianSet-ExtIEs',
        'SBASclockModel-ExtIEs',
        'BDSClockModel-ExtIEs',
        'UTCmodelSet1-ExtIEs',
        'UTCmodelSet2-ExtIEs',
        'UTCmodelSet3-ExtIEs',
        'UTCmodelSet4-ExtIEs',
        'UTRAN-GANSSReferenceTimeDL-ExtIEs',
        'UTRAN-GANSSReferenceTimeUL-ExtIEs',
        'GPS-AlmanacAndSatelliteHealth-ExtIEs',
        'AlmanacSatInfo-ExtIEs',
        'GPS-ClockAndEphemerisParameters-ExtIEs',
        'GPS-Ionospheric-Model-ExtIEs',
        'GPS-MeasuredResults-ExtIEs',
        'GPS-MeasurementParam-ExtIEs',
        'NavigationModelSatInfo-ExtIEs',
        'GPS-ReferenceLocation-ExtIEs',
        'GPS-ReferenceTime-ExtIEs',
        'GPS-TOW-Assist-ExtIEs',
        'GPSReferenceTimeUncertainty-ExtIEs',
        'GPS-UTCmodel-ExtIEs',
        'AdditionalGPSAssistDataRequired-ExtIEs',
        'AdditionalGanssAssistDataRequired-ExtIEs',
        'GANSSReq-AddIonosphericModel-ExtIEs',
        'GanssReqGenericData-ExtIEs',
        'DBDSCorrection-ExtIEs',
        'GANSS-AddADchoices-ExtIEs',
        'GanssDataBits-ExtIEs',
        'ReqDataBitAssistanceList-ExtIEs',
        'DganssCorrectionsReq-ExtIEs',
        'Ganss-almanacAndSatelliteHealthReq-ExtIEs',
        'GANSSCommonDataReq-ExtIEs',
        'GANSS-AddIonoModelReq-ExtIEs',
        'GANSS-EarthOrientParaReq-ExtIEs',
        'AddNavigationModelsGANSS-ExtIEs',
        'AddSatelliteRelatedDataGANSS-ExtIEs',
        'DBDS-Corrections-ExtIEs',
        'GANSS-AddUtcModelsReq-ExtIEs',
        'GANSS-AuxInfoReq-ExtIEs',
        'Ganss-utcModelReq-ExtIEs',
        'Ganss-realTimeIntegrityReq-ExtIEs',
        'Ganss-referenceMeasurementInfoReq-ExtIEs',
        'Ganss-TimeModel-Gnss-Gnss-ExtIEs',
        'UtcModel-ExtIEs',
        'IonosphericModel-ExtIEs',
        'NavigationModel-ExtIEs',
        'NavModelAdditionalData-ExtIEs',
        'SatelliteRelatedData-ExtIEs',
        'NavigationModelGANSS-ExtIEs',
        'SatelliteRelatedDataGANSS-ExtIEs',
        'AlmanacAndSatelliteHealthSIB-InfoType-ExtIEs',
        'MessageStructure-ExtIEs',
        'MeasInstructionsUsed-ExtIEs',
        'MeasurementValidity-ExtIEs',
        'OTDOA-MeasurementGroup-ExtIEs',
        'OTDOA-ReferenceCellInfo-ExtIEs',
        'OTDOA-ReferenceCellInfoSAS-centric-ExtIEs',
        'OTDOA-NeighbourCellInfo-ExtIEs',
        'OTDOA-MeasuredResultsInfo-ExtIEs',
        'OTDOA-AddMeasuredResultsInfo-ExtIEs',
        'UE-SFNSFNTimeDifferenceInfo-ExtIEs',
        'UC-ID-ExtIEs',
        'SFNSFNMeasurementValueInfo-ExtIEs',
        'TUTRANGPSMeasurementValueInfo-ExtIEs',
        'TUTRANGANSSMeasurementValueInfo-ExtIEs',
        'AdditionalMeasurementInforLCR-ExtIEs',
        'PeriodicPosCalcInfo-ExtIEs',
        'PeriodicLocationInfo-ExtIEs',
        'PositioningMethod-ExtIEs',
        'RRCstateChange-ExtIEs',
        'RequestedDataValue-ExtIEs',
        'InformationAvailable-ExtIEs',
        'RequestType-ExtIEs',
        'UE-PositioningCapability-ExtIEs',
        'NetworkAssistedGANSSSuport-ExtIEs',
        'GANSS-SBAS-IDs-ExtIEs',
        'GANSS-Signal-IDs-ExtIEs',
        'UTDOAPositioning-ExtIEs',
        'GPSPositioning-ExtIEs',
        'GPSPositioningInstructions-ExtIEs',
        'GANSSPositioning-ExtIEs',
        'GANSS-PositioningInstructions-ExtIEs',
        'OTDOAAssistanceData-ExtIEs',
        'UE-Positioning-OTDOAAssistanceData-ExtIEs',
        'UE-Positioning-OTDOAReferenceCellInfo-ExtIEs',
        'UE-Positioning-IPDL-Parameters-ExtIEs',
        'BurstModeParameters-ExtIEs',
        'UE-Positioning-OTDOANeighbourCellInfo-ExtIEs',
        'SFN-SFN-RelTimeDifference1-ExtIEs',
        'UTDOA-Group-ExtIEs',
        'FrequencyInfo-ExtIEs',
        'FrequencyInfoFDD-ExtIEs',
        'FrequencyInfoTDD-ExtIEs',
        'UTDOA-CELLDCH-ExtIEs',
        'UL-DPCHInfoFDD-ExtIEs',
        'UL-DPCHInfoTDD-ExtIEs',
        'Compressed-Mode-Assistance-DataFDD-ExtIEs',
        'DL-InformationFDD-ExtIEs',
        'UL-InformationFDD-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Information-ExtIEs',
        'Active-Pattern-Sequence-Information-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs',
        'DCH-Information-ExtIEs',
        'UL-TrCHInfo-ExtIEs',
        'E-DPCH-Information-ExtIEs',
        'E-TFCS-Information-ExtIEs',
        'Reference-E-TFCI-Information-Item-ExtIEs',
        'UL-Timeslot-InformationItem-ExtIEs',
        'TDD-UL-Code-InformationItem-ExtIEs',
        'UTDOA-CELLFACH-ExtIEs',
        'PRACH-ChannelInfo-ExtIEs',
        'PRACH-Info-FDD-ExtIEs',
        'PRACH-Info-TDD-ExtIEs',
        'TransportFormatSet-ExtIEs',
        'TransportFormatSet-DynamicPartList-ExtIEs',
        'TbsTTIInfo-ExtIEs',
        'TransportFormatSet-Semi-staticPart-ExtIEs',
        'UschParameters-ExtIEs',
        'HorizontalVelocity-ExtIEs',
        'HorizontalWithVerticalVelocity-ExtIEs',
        'HorizontalVelocityWithUncertainty-ExtIEs',
        'HorizontalWithVerticalVelocityAndUncertainty-ExtIEs',
        'UTRAN-GPSReferenceTime-ExtIEs',
        'UTRAN-GPSReferenceTimeResult-ExtIEs',
        'UTRAN-GANSSReferenceTimeResult-ExtIEs',
        ]
    _val_ = [
        'maxNrOfULTSs',
        'maxNrOfDPCHs',
        ]
    _class_ = [
        'BarometricPressure-ExtIEs',
        'WLANMeasurementList-ExtIEs',
        'BTMeasurementList-ExtIEs',
        'MBSMeasurementList-ExtIEs',
        'WLANMeasurementList-Element-ExtIEs',
        'BTMeasurementList-Element-ExtIEs',
        'MBSMeasurementList-Element-ExtIEs',
        'AlmanacAndSatelliteHealthSIB-ExtIEs',
        'CellId-MeasuredResultsInfo-ExtIEs',
        'RoundTripTimeInfo-ExtIEs',
        'RoundTripTimeInfoWithType1-ExtIEs',
        'UE-PositioningMeasQuality-ExtIEs',
        'UTRANAccessPointPositionAltitude-ExtIEs',
        'RxTimingDeviationInfo-ExtIEs',
        'RxTimingDeviationLCRInfo-ExtIEs',
        'RxTimingDeviation768Info-ExtIEs',
        'RxTimingDeviation384extInfo-ExtIEs',
        'AddMeasurementInfo-ExtIEs',
        'AngleOfArrivalLCR-ExtIEs',
        'CellId-IRATMeasuredResultsInfoListExtIEs',
        'GERAN-MeasuredResultsInfo-ExtIEs',
        'GERANCellGlobalID-ExtIEs',
        'CellIDPositioning-ExtIEs',
        'RequestedCellIDMeasurementsFDD-ExtIEs',
        'RequestedCellIDMeasurementsTDD-ExtIEs',
        'RequestedCellIDGERANMeasurements-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'DGPSCorrections-ExtIEs',
        'DGPS-CorrectionSatInfo-ExtIEs',
        'DGNSS-ValidityPeriod-ExtIEs',
        'GeographicalCoordinates-ExtIEs',
        'GA-EllipsoidArc-ExtIEs',
        'GA-Point-ExtIEs',
        'GA-PointWithAltitude-ExtIEs',
        'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        'GA-PointWithUnCertainty-ExtIEs',
        'GA-PointWithUnCertaintyEllipse-ExtIEs',
        'GA-Polygon-ExtIEs',
        'UE-PositionEstimateInfo-ExtIEs',
        'Extension-ReferenceTimeChoice-IE',
        'Cell-Timing-ExtIEs',
        'GANSS-Reference-Time-Only-ExtIEs',
        'PositionDataUEbased-ExtIEs',
        'PositionData-ExtIEs',
        'GPS-AcquisitionAssistance-ExtIEs',
        'AcquisitionSatInfo-ExtIEs',
        'ExtraDopplerInfo-ExtIEs',
        'ExtraDopplerInfoExtension-ExtIEs',
        'AzimuthAndElevation-ExtIEs',
        'AzimuthAndElevationLSB-ExtIEs',
        'AuxInfoGANSS-ID1-element-ExtIEs',
        'AuxInfoGANSS-ID3-element-ExtIEs',
        'CNAVclockModel-ExtIEs',
        'DeltaUT1-ExtIEs',
        'DGANSS-Corrections-ExtIEs',
        'DGANSS-InformationItem-ExtIEs',
        'DGANSS-SignalInformationItem-ExtIEs',
        'GANSS-Additional-Ionospheric-Model-ExtIEs',
        'GANSS-Additional-Navigation-Models-ExtIEs',
        'GANSS-ALM-BDSKeplericanset-ExtIEs',
        'Satellite-Information-BDS-KP-Item-ExtIEs',
        'GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs',
        'GANSS-ALM-GlonassAlmanacSet-ExtIEs',
        'GANSS-ALM-MidiAlmanacSet-ExtIEs',
        'GANSS-ALM-NAVKeplerianSet-ExtIEs',
        'GANSS-ALM-ReducedKeplerianSet-ExtIEs',
        'GANSS-AlmanacAndSatelliteHealth-ExtIEs',
        'Extension-GANSS-AlmanacModel-IE',
        'GANSS-AzimuthAndElevation-ExtIEs',
        'GANSS-CommonAssistanceData-ExtIEs',
        'GANSS-Data-Bit-Assistance-ExtIEs',
        'GANSS-DataBitAssistanceItem-ExtIEs',
        'GANSS-DataBitAssistanceSgnItem-ExtIEs',
        'GANSS-Earth-Orientation-Parameters-ExtIEs',
        'GANSS-ExtraDoppler-ExtIEs',
        'GANSS-ExtraDopplerExtension-ExtIEs',
        'GANSSGenericAssistance-ExtIEs',
        'BDS-Ionospheric-Grid-Model-ExtIEs',
        'BDS-Ionospheric-Grid-Information-ExtIEs',
        'DBDS-Correction-Information-ExtIEs',
        'DBDS-Information-ExtIEs',
        'DGANSS-Signal-Information-ExtIEs',
        'GANSS-GenericMeasurementInfo-ExtIEs',
        'GANSSID-ExtIEs',
        'GANSSMeasurementSignalList-ExtIEs',
        'GanssCodePhaseAmbiguityExt-ExtIEs',
        'GANSS-Ionospheric-Model-ExtIEs',
        'GANSS-IonosphereRegionalStormFlags-ExtIEs',
        'GANSS-KeplerianParametersAlm-ExtIEs',
        'GANSS-KeplerianParametersOrb-ExtIEs',
        'GANSS-MeasurementParametersItem-ExtIEs',
        'GanssIntegerCodePhaseExt-ExtIEs',
        'GANSS-MeasuredResults-ExtIEs',
        'GANSS-Navigation-Model-ExtIEs',
        'GANSS-RealTimeInformationItem-ExtIEs',
        'GANSS-Reference-Location-ExtIEs',
        'GANSS-ReferenceMeasurementInfo-ExtIEs',
        'GANSS-Reference-Time-ExtIEs',
        'GANSS-ReferenceTimeOnly-ExtIEs',
        'GANSS-SatelliteClockModelItem-ExtIEs',
        'GANSS-SatelliteInformationItem-ExtIEs',
        'GANSS-SatelliteInformationKPItem-ExtIEs',
        'GANSS-SAT-Info-Almanac-GLOkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-NAVkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-REDkp-ExtIEs',
        'GANSS-SAT-Info-Almanac-SBASecef-ExtIEs',
        'Ganss-Sat-Info-AddNavList-ExtIEs',
        'GANSS-Sat-Info-Nav-ExtIEs',
        'GANSS-SignalID-ExtIEs',
        'GANSS-Time-Model-ExtIEs',
        'GANSS-UTRAN-TRU-ExtIEs',
        'GANSS-UTC-Model-ExtIEs',
        'GLONASSclockModel-ExtIEs',
        'NAVclockModel-ExtIEs',
        'NavModel-CNAVKeplerianSet-ExtIEs',
        'NavModel-GLONASSecef-ExtIEs',
        'NavModel-NAVKeplerianSet-ExtIEs',
        'NavModel-SBASecef-ExtIEs',
        'NavModel-BDSKeplerianSet-ExtIEs',
        'SBASclockModel-ExtIEs',
        'BDSClockModel-ExtIEs',
        'UTCmodelSet1-ExtIEs',
        'UTCmodelSet2-ExtIEs',
        'UTCmodelSet3-ExtIEs',
        'UTCmodelSet4-ExtIEs',
        'UTRAN-GANSSReferenceTimeDL-ExtIEs',
        'UTRAN-GANSSReferenceTimeUL-ExtIEs',
        'GPS-AlmanacAndSatelliteHealth-ExtIEs',
        'AlmanacSatInfo-ExtIEs',
        'GPS-ClockAndEphemerisParameters-ExtIEs',
        'GPS-Ionospheric-Model-ExtIEs',
        'GPS-MeasuredResults-ExtIEs',
        'GPS-MeasurementParam-ExtIEs',
        'NavigationModelSatInfo-ExtIEs',
        'GPS-ReferenceLocation-ExtIEs',
        'GPS-ReferenceTime-ExtIEs',
        'GPS-TOW-Assist-ExtIEs',
        'GPSReferenceTimeUncertainty-ExtIEs',
        'GPS-UTCmodel-ExtIEs',
        'AdditionalGPSAssistDataRequired-ExtIEs',
        'AdditionalGanssAssistDataRequired-ExtIEs',
        'GANSSReq-AddIonosphericModel-ExtIEs',
        'GanssReqGenericData-ExtIEs',
        'DBDSCorrection-ExtIEs',
        'GANSS-AddADchoices-ExtIEs',
        'GanssDataBits-ExtIEs',
        'ReqDataBitAssistanceList-ExtIEs',
        'DganssCorrectionsReq-ExtIEs',
        'Ganss-almanacAndSatelliteHealthReq-ExtIEs',
        'GANSSCommonDataReq-ExtIEs',
        'GANSS-AddIonoModelReq-ExtIEs',
        'GANSS-EarthOrientParaReq-ExtIEs',
        'AddNavigationModelsGANSS-ExtIEs',
        'AddSatelliteRelatedDataGANSS-ExtIEs',
        'DBDS-Corrections-ExtIEs',
        'GANSS-AddUtcModelsReq-ExtIEs',
        'GANSS-AuxInfoReq-ExtIEs',
        'Ganss-utcModelReq-ExtIEs',
        'Ganss-realTimeIntegrityReq-ExtIEs',
        'Ganss-referenceMeasurementInfoReq-ExtIEs',
        'Ganss-TimeModel-Gnss-Gnss-ExtIEs',
        'UtcModel-ExtIEs',
        'IonosphericModel-ExtIEs',
        'NavigationModel-ExtIEs',
        'NavModelAdditionalData-ExtIEs',
        'SatelliteRelatedData-ExtIEs',
        'NavigationModelGANSS-ExtIEs',
        'SatelliteRelatedDataGANSS-ExtIEs',
        'AlmanacAndSatelliteHealthSIB-InfoType-ExtIEs',
        'MessageStructure-ExtIEs',
        'MeasInstructionsUsed-ExtIEs',
        'MeasurementValidity-ExtIEs',
        'OTDOA-MeasurementGroup-ExtIEs',
        'OTDOA-ReferenceCellInfo-ExtIEs',
        'OTDOA-ReferenceCellInfoSAS-centric-ExtIEs',
        'OTDOA-NeighbourCellInfo-ExtIEs',
        'OTDOA-MeasuredResultsInfo-ExtIEs',
        'OTDOA-AddMeasuredResultsInfo-ExtIEs',
        'UE-SFNSFNTimeDifferenceInfo-ExtIEs',
        'UC-ID-ExtIEs',
        'SFNSFNMeasurementValueInfo-ExtIEs',
        'TUTRANGPSMeasurementValueInfo-ExtIEs',
        'TUTRANGANSSMeasurementValueInfo-ExtIEs',
        'AdditionalMeasurementInforLCR-ExtIEs',
        'PeriodicPosCalcInfo-ExtIEs',
        'PeriodicLocationInfo-ExtIEs',
        'PositioningMethod-ExtIEs',
        'RRCstateChange-ExtIEs',
        'RequestedDataValue-ExtIEs',
        'InformationAvailable-ExtIEs',
        'RequestType-ExtIEs',
        'UE-PositioningCapability-ExtIEs',
        'NetworkAssistedGANSSSuport-ExtIEs',
        'GANSS-SBAS-IDs-ExtIEs',
        'GANSS-Signal-IDs-ExtIEs',
        'UTDOAPositioning-ExtIEs',
        'GPSPositioning-ExtIEs',
        'GPSPositioningInstructions-ExtIEs',
        'GANSSPositioning-ExtIEs',
        'GANSS-PositioningInstructions-ExtIEs',
        'OTDOAAssistanceData-ExtIEs',
        'UE-Positioning-OTDOAAssistanceData-ExtIEs',
        'UE-Positioning-OTDOAReferenceCellInfo-ExtIEs',
        'UE-Positioning-IPDL-Parameters-ExtIEs',
        'BurstModeParameters-ExtIEs',
        'UE-Positioning-OTDOANeighbourCellInfo-ExtIEs',
        'SFN-SFN-RelTimeDifference1-ExtIEs',
        'UTDOA-Group-ExtIEs',
        'FrequencyInfo-ExtIEs',
        'FrequencyInfoFDD-ExtIEs',
        'FrequencyInfoTDD-ExtIEs',
        'UTDOA-CELLDCH-ExtIEs',
        'UL-DPCHInfoFDD-ExtIEs',
        'UL-DPCHInfoTDD-ExtIEs',
        'Compressed-Mode-Assistance-DataFDD-ExtIEs',
        'DL-InformationFDD-ExtIEs',
        'UL-InformationFDD-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Information-ExtIEs',
        'Active-Pattern-Sequence-Information-ExtIEs',
        'Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs',
        'DCH-Information-ExtIEs',
        'UL-TrCHInfo-ExtIEs',
        'E-DPCH-Information-ExtIEs',
        'E-TFCS-Information-ExtIEs',
        'Reference-E-TFCI-Information-Item-ExtIEs',
        'UL-Timeslot-InformationItem-ExtIEs',
        'TDD-UL-Code-InformationItem-ExtIEs',
        'UTDOA-CELLFACH-ExtIEs',
        'PRACH-ChannelInfo-ExtIEs',
        'PRACH-Info-FDD-ExtIEs',
        'PRACH-Info-TDD-ExtIEs',
        'TransportFormatSet-ExtIEs',
        'TransportFormatSet-DynamicPartList-ExtIEs',
        'TbsTTIInfo-ExtIEs',
        'TransportFormatSet-Semi-staticPart-ExtIEs',
        'UschParameters-ExtIEs',
        'HorizontalVelocity-ExtIEs',
        'HorizontalWithVerticalVelocity-ExtIEs',
        'HorizontalVelocityWithUncertainty-ExtIEs',
        'HorizontalWithVerticalVelocityAndUncertainty-ExtIEs',
        'UTRAN-GPSReferenceTime-ExtIEs',
        'UTRAN-GPSReferenceTimeResult-ExtIEs',
        'UTRAN-GANSSReferenceTimeResult-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AccuracyFulfilmentIndicator >-----#
    AccuracyFulfilmentIndicator = ENUM(name='AccuracyFulfilmentIndicator', mode=MODE_TYPE)
    AccuracyFulfilmentIndicator._cont = ASN1Dict([('requested-Accuracy-Fulfilled', 0), ('requested-Accuracy-Not-Fulfilled', 1)])
    AccuracyFulfilmentIndicator._ext = []
    
    #-----< AdditionalMethodType >-----#
    AdditionalMethodType = ENUM(name='AdditionalMethodType', mode=MODE_TYPE)
    AdditionalMethodType._cont = ASN1Dict([('ue-assisted', 0), ('ue-based', 1), ('ue-based-preferred-but-ue-assisted-allowed', 2), ('ue-assisted-preferred-but-ue-based-allowed', 3)])
    AdditionalMethodType._ext = []
    
    #-----< AddPos-MeasuredResults >-----#
    AddPos_MeasuredResults = SEQ_OF(name='AddPos-MeasuredResults', mode=MODE_TYPE)
    _AddPos_MeasuredResults__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddPos-MeasuredResults-Element')))
    AddPos_MeasuredResults._cont = _AddPos_MeasuredResults__item_
    AddPos_MeasuredResults._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AddPos-MeasuredResults-Element >-----#
    AddPos_MeasuredResults_Element = SEQ(name='AddPos-MeasuredResults-Element', mode=MODE_TYPE)
    _AddPos_MeasuredResults_Element_timestamp = TIME_UTC(name='timestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AddPos_MeasuredResults_Element_type = CHOICE(name='type', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __AddPos_MeasuredResults_Element_type_barometricPressure = SEQ(name='barometricPressure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AddPos_MeasuredResults_Element_type_barometricPressure_uncompensatedBarometricPressure = INT(name='uncompensatedBarometricPressure', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'BaroMeasurement')))
    ___AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__id._const_tab = ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__id_tab
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__id._const_tab_at = None
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__id._const_tab_id = 'id'
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__criticality._const_tab = ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__criticality_tab
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__extensionValue._const_tab = ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__extensionValue_tab
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item_._cont = ASN1Dict([
        ('id', _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__id),
        ('criticality', _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__criticality),
        ('extensionValue', _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__extensionValue),
        ])
    ____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item_._ext = None
    ___AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions._cont = ____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item_
    ___AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __AddPos_MeasuredResults_Element_type_barometricPressure._cont = ASN1Dict([
        ('uncompensatedBarometricPressure', ___AddPos_MeasuredResults_Element_type_barometricPressure_uncompensatedBarometricPressure),
        ('iE-Extensions', ___AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions),
        ])
    __AddPos_MeasuredResults_Element_type_barometricPressure._ext = []
    __AddPos_MeasuredResults_Element_type_wlan = SEQ(name='wlan', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AddPos_MeasuredResults_Element_type_wlan_wlanMeasurementList = SEQ_OF(name='wlanMeasurementList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'WLANMeasurementList')))
    ___AddPos_MeasuredResults_Element_type_wlan_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__id._const_tab = ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__id_tab
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__id._const_tab_at = None
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__id._const_tab_id = 'id'
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__criticality._const_tab = ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__criticality_tab
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__extensionValue._const_tab = ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__extensionValue_tab
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item_._cont = ASN1Dict([
        ('id', _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__id),
        ('criticality', _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__criticality),
        ('extensionValue', _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__extensionValue),
        ])
    ____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item_._ext = None
    ___AddPos_MeasuredResults_Element_type_wlan_iE_Extensions._cont = ____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item_
    ___AddPos_MeasuredResults_Element_type_wlan_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __AddPos_MeasuredResults_Element_type_wlan._cont = ASN1Dict([
        ('wlanMeasurementList', ___AddPos_MeasuredResults_Element_type_wlan_wlanMeasurementList),
        ('iE-Extensions', ___AddPos_MeasuredResults_Element_type_wlan_iE_Extensions),
        ])
    __AddPos_MeasuredResults_Element_type_wlan._ext = []
    __AddPos_MeasuredResults_Element_type_bt = SEQ(name='bt', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AddPos_MeasuredResults_Element_type_bt_btMeasurementList = SEQ_OF(name='btMeasurementList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'BTMeasurementList')))
    ___AddPos_MeasuredResults_Element_type_bt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__id._const_tab = ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__id_tab
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__id._const_tab_at = None
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__id._const_tab_id = 'id'
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__criticality._const_tab = ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__criticality_tab
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__extensionValue._const_tab = ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__extensionValue_tab
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__id),
        ('criticality', _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__criticality),
        ('extensionValue', _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__extensionValue),
        ])
    ____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item_._ext = None
    ___AddPos_MeasuredResults_Element_type_bt_iE_Extensions._cont = ____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item_
    ___AddPos_MeasuredResults_Element_type_bt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __AddPos_MeasuredResults_Element_type_bt._cont = ASN1Dict([
        ('btMeasurementList', ___AddPos_MeasuredResults_Element_type_bt_btMeasurementList),
        ('iE-Extensions', ___AddPos_MeasuredResults_Element_type_bt_iE_Extensions),
        ])
    __AddPos_MeasuredResults_Element_type_bt._ext = []
    __AddPos_MeasuredResults_Element_type_mbs = SEQ(name='mbs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___AddPos_MeasuredResults_Element_type_mbs_mbsMeasurementList = SEQ_OF(name='mbsMeasurementList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MBSMeasurementList')))
    ___AddPos_MeasuredResults_Element_type_mbs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__id._const_tab = ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__id_tab
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__id._const_tab_at = None
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__id._const_tab_id = 'id'
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__criticality._const_tab = ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__criticality_tab
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__extensionValue._const_tab = ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__extensionValue_tab
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__id),
        ('criticality', _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__criticality),
        ('extensionValue', _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__extensionValue),
        ])
    ____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item_._ext = None
    ___AddPos_MeasuredResults_Element_type_mbs_iE_Extensions._cont = ____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item_
    ___AddPos_MeasuredResults_Element_type_mbs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    __AddPos_MeasuredResults_Element_type_mbs._cont = ASN1Dict([
        ('mbsMeasurementList', ___AddPos_MeasuredResults_Element_type_mbs_mbsMeasurementList),
        ('iE-Extensions', ___AddPos_MeasuredResults_Element_type_mbs_iE_Extensions),
        ])
    __AddPos_MeasuredResults_Element_type_mbs._ext = []
    _AddPos_MeasuredResults_Element_type._cont = ASN1Dict([
        ('barometricPressure', __AddPos_MeasuredResults_Element_type_barometricPressure),
        ('wlan', __AddPos_MeasuredResults_Element_type_wlan),
        ('bt', __AddPos_MeasuredResults_Element_type_bt),
        ('mbs', __AddPos_MeasuredResults_Element_type_mbs),
        ])
    _AddPos_MeasuredResults_Element_type._ext = []
    AddPos_MeasuredResults_Element._cont = ASN1Dict([
        ('timestamp', _AddPos_MeasuredResults_Element_timestamp),
        ('type', _AddPos_MeasuredResults_Element_type),
        ])
    AddPos_MeasuredResults_Element._ext = []
    
    #-----< BarometricPressure-ExtIEs >-----#
    BarometricPressure_ExtIEs = CLASS(name='BarometricPressure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    BarometricPressure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasurementList-ExtIEs >-----#
    WLANMeasurementList_ExtIEs = CLASS(name='WLANMeasurementList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    WLANMeasurementList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BTMeasurementList-ExtIEs >-----#
    BTMeasurementList_ExtIEs = CLASS(name='BTMeasurementList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    BTMeasurementList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSMeasurementList-ExtIEs >-----#
    MBSMeasurementList_ExtIEs = CLASS(name='MBSMeasurementList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    MBSMeasurementList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< WLANMeasurementList >-----#
    WLANMeasurementList = SEQ_OF(name='WLANMeasurementList', mode=MODE_TYPE)
    _WLANMeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'WLANMeasurementList-Element')))
    WLANMeasurementList._cont = _WLANMeasurementList__item_
    WLANMeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< WLANMeasurementList-Element >-----#
    WLANMeasurementList_Element = SEQ(name='WLANMeasurementList-Element', mode=MODE_TYPE)
    _WLANMeasurementList_Element_wlanBSSID = OCT_STR(name='wlanBSSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLANMeasurementList_Element_wlanBSSID._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _WLANMeasurementList_Element_wlanSSID = OCT_STR(name='wlanSSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementList_Element_wlanSSID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _WLANMeasurementList_Element_wlanRSSI = INT(name='wlanRSSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementList_Element_wlanRSSI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _WLANMeasurementList_Element_wlanRTTvalue = INT(name='wlanRTTvalue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementList_Element_wlanRTTvalue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    _WLANMeasurementList_Element_wlanRTTunits = ENUM(name='wlanRTTunits', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementList_Element_wlanRTTunits._cont = ASN1Dict([('microseconds', 0), ('hundredsofnanoseconds', 1), ('tensofnanoseconds', 2), ('nanoseconds', 3), ('tenthsofnanosecond', 4)])
    _WLANMeasurementList_Element_wlanRTTunits._ext = []
    _WLANMeasurementList_Element_wlanRTTaccuracy = INT(name='wlanRTTaccuracy', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementList_Element_wlanRTTaccuracy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _WLANMeasurementList_Element_wlanAPChannelFrequency = INT(name='wlanAPChannelFrequency', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementList_Element_wlanAPChannelFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    _WLANMeasurementList_Element_wlanServingFlag = BOOL(name='wlanServingFlag', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WLANMeasurementList_Element_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __WLANMeasurementList_Element_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___WLANMeasurementList_Element_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____WLANMeasurementList_Element_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementList_Element_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementList_Element_iE_Extensions__item__id._const_tab = ____WLANMeasurementList_Element_iE_Extensions__item__id_tab
    ___WLANMeasurementList_Element_iE_Extensions__item__id._const_tab_at = None
    ___WLANMeasurementList_Element_iE_Extensions__item__id._const_tab_id = 'id'
    ___WLANMeasurementList_Element_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____WLANMeasurementList_Element_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementList_Element_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementList_Element_iE_Extensions__item__criticality._const_tab = ____WLANMeasurementList_Element_iE_Extensions__item__criticality_tab
    ___WLANMeasurementList_Element_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___WLANMeasurementList_Element_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___WLANMeasurementList_Element_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____WLANMeasurementList_Element_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____WLANMeasurementList_Element_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___WLANMeasurementList_Element_iE_Extensions__item__extensionValue._const_tab = ____WLANMeasurementList_Element_iE_Extensions__item__extensionValue_tab
    ___WLANMeasurementList_Element_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___WLANMeasurementList_Element_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __WLANMeasurementList_Element_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___WLANMeasurementList_Element_iE_Extensions__item__id),
        ('criticality', ___WLANMeasurementList_Element_iE_Extensions__item__criticality),
        ('extensionValue', ___WLANMeasurementList_Element_iE_Extensions__item__extensionValue),
        ])
    __WLANMeasurementList_Element_iE_Extensions__item_._ext = None
    _WLANMeasurementList_Element_iE_Extensions._cont = __WLANMeasurementList_Element_iE_Extensions__item_
    _WLANMeasurementList_Element_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    WLANMeasurementList_Element._cont = ASN1Dict([
        ('wlanBSSID', _WLANMeasurementList_Element_wlanBSSID),
        ('wlanSSID', _WLANMeasurementList_Element_wlanSSID),
        ('wlanRSSI', _WLANMeasurementList_Element_wlanRSSI),
        ('wlanRTTvalue', _WLANMeasurementList_Element_wlanRTTvalue),
        ('wlanRTTunits', _WLANMeasurementList_Element_wlanRTTunits),
        ('wlanRTTaccuracy', _WLANMeasurementList_Element_wlanRTTaccuracy),
        ('wlanAPChannelFrequency', _WLANMeasurementList_Element_wlanAPChannelFrequency),
        ('wlanServingFlag', _WLANMeasurementList_Element_wlanServingFlag),
        ('iE-Extensions', _WLANMeasurementList_Element_iE_Extensions),
        ])
    WLANMeasurementList_Element._ext = []
    
    #-----< WLANMeasurementList-Element-ExtIEs >-----#
    WLANMeasurementList_Element_ExtIEs = CLASS(name='WLANMeasurementList-Element-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    WLANMeasurementList_Element_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BTMeasurementList >-----#
    BTMeasurementList = SEQ_OF(name='BTMeasurementList', mode=MODE_TYPE)
    _BTMeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'BTMeasurementList-Element')))
    BTMeasurementList._cont = _BTMeasurementList__item_
    BTMeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BTMeasurementList-Element >-----#
    BTMeasurementList_Element = SEQ(name='BTMeasurementList-Element', mode=MODE_TYPE)
    _BTMeasurementList_Element_btADDR = OCT_STR(name='btADDR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BTMeasurementList_Element_btADDR._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _BTMeasurementList_Element_btRSSI = INT(name='btRSSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BTMeasurementList_Element_btRSSI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _BTMeasurementList_Element_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BTMeasurementList_Element_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___BTMeasurementList_Element_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____BTMeasurementList_Element_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BTMeasurementList_Element_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BTMeasurementList_Element_iE_Extensions__item__id._const_tab = ____BTMeasurementList_Element_iE_Extensions__item__id_tab
    ___BTMeasurementList_Element_iE_Extensions__item__id._const_tab_at = None
    ___BTMeasurementList_Element_iE_Extensions__item__id._const_tab_id = 'id'
    ___BTMeasurementList_Element_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BTMeasurementList_Element_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BTMeasurementList_Element_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BTMeasurementList_Element_iE_Extensions__item__criticality._const_tab = ____BTMeasurementList_Element_iE_Extensions__item__criticality_tab
    ___BTMeasurementList_Element_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BTMeasurementList_Element_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BTMeasurementList_Element_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BTMeasurementList_Element_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BTMeasurementList_Element_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BTMeasurementList_Element_iE_Extensions__item__extensionValue._const_tab = ____BTMeasurementList_Element_iE_Extensions__item__extensionValue_tab
    ___BTMeasurementList_Element_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BTMeasurementList_Element_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BTMeasurementList_Element_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BTMeasurementList_Element_iE_Extensions__item__id),
        ('criticality', ___BTMeasurementList_Element_iE_Extensions__item__criticality),
        ('extensionValue', ___BTMeasurementList_Element_iE_Extensions__item__extensionValue),
        ])
    __BTMeasurementList_Element_iE_Extensions__item_._ext = None
    _BTMeasurementList_Element_iE_Extensions._cont = __BTMeasurementList_Element_iE_Extensions__item_
    _BTMeasurementList_Element_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BTMeasurementList_Element._cont = ASN1Dict([
        ('btADDR', _BTMeasurementList_Element_btADDR),
        ('btRSSI', _BTMeasurementList_Element_btRSSI),
        ('iE-Extensions', _BTMeasurementList_Element_iE_Extensions),
        ])
    BTMeasurementList_Element._ext = []
    
    #-----< BTMeasurementList-Element-ExtIEs >-----#
    BTMeasurementList_Element_ExtIEs = CLASS(name='BTMeasurementList-Element-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    BTMeasurementList_Element_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBSMeasurementList >-----#
    MBSMeasurementList = SEQ_OF(name='MBSMeasurementList', mode=MODE_TYPE)
    _MBSMeasurementList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MBSMeasurementList-Element')))
    MBSMeasurementList._cont = _MBSMeasurementList__item_
    MBSMeasurementList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< MBSMeasurementList-Element >-----#
    MBSMeasurementList_Element = SEQ(name='MBSMeasurementList-Element', mode=MODE_TYPE)
    _MBSMeasurementList_Element_transmitterID = INT(name='transmitterID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBSMeasurementList_Element_transmitterID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _MBSMeasurementList_Element_codephase = INT(name='codephase', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBSMeasurementList_Element_codephase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2097151)], ev=None, er=[])
    _MBSMeasurementList_Element_codephaseRMS = INT(name='codephaseRMS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MBSMeasurementList_Element_codephaseRMS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _MBSMeasurementList_Element_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBSMeasurementList_Element_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___MBSMeasurementList_Element_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBSMeasurementList_Element_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____MBSMeasurementList_Element_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSMeasurementList_Element_iE_Extensions__item__id._const_tab = ____MBSMeasurementList_Element_iE_Extensions__item__id_tab
    ___MBSMeasurementList_Element_iE_Extensions__item__id._const_tab_at = None
    ___MBSMeasurementList_Element_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBSMeasurementList_Element_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBSMeasurementList_Element_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____MBSMeasurementList_Element_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSMeasurementList_Element_iE_Extensions__item__criticality._const_tab = ____MBSMeasurementList_Element_iE_Extensions__item__criticality_tab
    ___MBSMeasurementList_Element_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBSMeasurementList_Element_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBSMeasurementList_Element_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBSMeasurementList_Element_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____MBSMeasurementList_Element_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBSMeasurementList_Element_iE_Extensions__item__extensionValue._const_tab = ____MBSMeasurementList_Element_iE_Extensions__item__extensionValue_tab
    ___MBSMeasurementList_Element_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBSMeasurementList_Element_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBSMeasurementList_Element_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBSMeasurementList_Element_iE_Extensions__item__id),
        ('criticality', ___MBSMeasurementList_Element_iE_Extensions__item__criticality),
        ('extensionValue', ___MBSMeasurementList_Element_iE_Extensions__item__extensionValue),
        ])
    __MBSMeasurementList_Element_iE_Extensions__item_._ext = None
    _MBSMeasurementList_Element_iE_Extensions._cont = __MBSMeasurementList_Element_iE_Extensions__item_
    _MBSMeasurementList_Element_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBSMeasurementList_Element._cont = ASN1Dict([
        ('transmitterID', _MBSMeasurementList_Element_transmitterID),
        ('codephase', _MBSMeasurementList_Element_codephase),
        ('codephaseRMS', _MBSMeasurementList_Element_codephaseRMS),
        ('iE-Extensions', _MBSMeasurementList_Element_iE_Extensions),
        ])
    MBSMeasurementList_Element._ext = []
    
    #-----< MBSMeasurementList-Element-ExtIEs >-----#
    MBSMeasurementList_Element_ExtIEs = CLASS(name='MBSMeasurementList-Element-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    MBSMeasurementList_Element_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BaroMeasurement >-----#
    BaroMeasurement = INT(name='BaroMeasurement', mode=MODE_TYPE)
    BaroMeasurement._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=30000, ub=115000)], ev=None, er=[])
    
    #-----< AlmanacAndSatelliteHealthSIB >-----#
    AlmanacAndSatelliteHealthSIB = SEQ(name='AlmanacAndSatelliteHealthSIB', mode=MODE_TYPE)
    _AlmanacAndSatelliteHealthSIB_gpsAlmanacAndSatelliteHealth = SEQ(name='gpsAlmanacAndSatelliteHealth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-AlmanacAndSatelliteHealth')))
    _AlmanacAndSatelliteHealthSIB_satMask = BIT_STR(name='satMask', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacAndSatelliteHealthSIB_satMask._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _AlmanacAndSatelliteHealthSIB_lsbTOW = BIT_STR(name='lsbTOW', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacAndSatelliteHealthSIB_lsbTOW._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _AlmanacAndSatelliteHealthSIB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AlmanacAndSatelliteHealthSIB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__id._const_tab = ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__id_tab
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__id._const_tab_at = None
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__id._const_tab_id = 'id'
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__criticality._const_tab = ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__criticality_tab
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__extensionValue._const_tab = ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__extensionValue_tab
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AlmanacAndSatelliteHealthSIB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__id),
        ('criticality', ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__criticality),
        ('extensionValue', ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__extensionValue),
        ])
    __AlmanacAndSatelliteHealthSIB_iE_Extensions__item_._ext = None
    _AlmanacAndSatelliteHealthSIB_iE_Extensions._cont = __AlmanacAndSatelliteHealthSIB_iE_Extensions__item_
    _AlmanacAndSatelliteHealthSIB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AlmanacAndSatelliteHealthSIB._cont = ASN1Dict([
        ('gpsAlmanacAndSatelliteHealth', _AlmanacAndSatelliteHealthSIB_gpsAlmanacAndSatelliteHealth),
        ('satMask', _AlmanacAndSatelliteHealthSIB_satMask),
        ('lsbTOW', _AlmanacAndSatelliteHealthSIB_lsbTOW),
        ('iE-Extensions', _AlmanacAndSatelliteHealthSIB_iE_Extensions),
        ])
    AlmanacAndSatelliteHealthSIB._ext = []
    
    #-----< AlmanacAndSatelliteHealthSIB-ExtIEs >-----#
    AlmanacAndSatelliteHealthSIB_ExtIEs = CLASS(name='AlmanacAndSatelliteHealthSIB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AlmanacAndSatelliteHealthSIB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = ENUM(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CauseRadioNetwork')))
    _Cause_transport = ENUM(name='transport', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CauseTransport')))
    _Cause_protocol = ENUM(name='protocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CauseProtocol')))
    _Cause_misc = ENUM(name='misc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CauseMisc')))
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transport', _Cause_transport),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ])
    Cause._ext = []
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = ENUM(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('invalid-reference-information', 0), ('information-temporarily-not-available', 1), ('information-provision-not-supported-for-the-object', 2), ('position-calculation-error-invalid-GPS-measured-results', 3), ('position-calculation-error-invalid-CellID-measured-results', 4), ('position-calculation-error-invalid-OTDOA-measured-results', 5), ('position-calculation-error-AGPS-positioning-method-not-supported', 6), ('position-calculation-error-CellID-positioning-method-not-supported', 7), ('position-calculation-error-OTDOA-positioning-method-not-supported', 8), ('initial-UE-position-estimate-missing', 9), ('position-caclulation-error-invalid-UTDOA-measured-results', 10), ('position-calculation-error-UTDOA-positioning-method-not-supported', 11), ('position-calculation-error-UTDOA-not-supported-UTRAN-cell', 12), ('positioning-method-not-supported', 13), ('loss-of-contact-with-UE', 14), ('sAS-unable-to-perform-UTDOA-positioning-within-response-time', 15), ('location-measurement-failure', 16), ('ue-positioning-error-Not-enough-OTDOA-cells', 17), ('ue-positioning-error-Not-enough-GPS-Satellites', 18), ('ue-positioning-error-Reference-Cell-not-serving-cell', 19), ('ue-positioning-error-Not-Accomplished-GPS-Timing-of-Cell-Frames', 20), ('ue-positioning-error-Undefined-Error', 21), ('position-calculation-error-invalid-Galileo-measured-results', 22), ('position-calculation-error-AGalileo-positioning-method-not-supported', 23), ('ue-positioning-error-Not-enough-Galileo-Satellites', 24), ('ue-positioning-error-Not-Accomplished-Galileo-Timing-of-Cell-Frames', 25), ('ue-positioning-error-Assistance-Data-missing', 26), ('position-calculation-error-invalid-GLONASS-measured-results', 27), ('position-calculation-error-invalid-GANSS-measured-results', 28), ('position-calculation-error-AGANSS-positioning-method-not-supported', 29), ('ue-positioning-error-Not-enough-GANSS-Satellites', 30), ('ue-positioning-error-Not-Accomplished-GANSS-Timing-of-Cell-Frames', 31), ('position-calculation-error-invalid-BDS-measured-results', 32), ('ue-Positioning-Error-Not-enough-BDS-Satellites', 33), ('position-calculation-error-A-BDS-positioning-method-not-supported', 34)])
    CauseRadioNetwork._ext = ['position-calculation-error-invalid-CellID-measured-results', 'position-calculation-error-invalid-OTDOA-measured-results', 'position-calculation-error-AGPS-positioning-method-not-supported', 'position-calculation-error-CellID-positioning-method-not-supported', 'position-calculation-error-OTDOA-positioning-method-not-supported', 'initial-UE-position-estimate-missing', 'position-caclulation-error-invalid-UTDOA-measured-results', 'position-calculation-error-UTDOA-positioning-method-not-supported', 'position-calculation-error-UTDOA-not-supported-UTRAN-cell', 'positioning-method-not-supported', 'loss-of-contact-with-UE', 'sAS-unable-to-perform-UTDOA-positioning-within-response-time', 'location-measurement-failure', 'ue-positioning-error-Not-enough-OTDOA-cells', 'ue-positioning-error-Not-enough-GPS-Satellites', 'ue-positioning-error-Reference-Cell-not-serving-cell', 'ue-positioning-error-Not-Accomplished-GPS-Timing-of-Cell-Frames', 'ue-positioning-error-Undefined-Error', 'position-calculation-error-invalid-Galileo-measured-results', 'position-calculation-error-AGalileo-positioning-method-not-supported', 'ue-positioning-error-Not-enough-Galileo-Satellites', 'ue-positioning-error-Not-Accomplished-Galileo-Timing-of-Cell-Frames', 'ue-positioning-error-Assistance-Data-missing', 'position-calculation-error-invalid-GLONASS-measured-results', 'position-calculation-error-invalid-GANSS-measured-results', 'position-calculation-error-AGANSS-positioning-method-not-supported', 'ue-positioning-error-Not-enough-GANSS-Satellites', 'ue-positioning-error-Not-Accomplished-GANSS-Timing-of-Cell-Frames', 'position-calculation-error-invalid-BDS-measured-results', 'ue-Positioning-Error-Not-enough-BDS-Satellites', 'position-calculation-error-A-BDS-positioning-method-not-supported']
    
    #-----< CauseTransport >-----#
    CauseTransport = ENUM(name='CauseTransport', mode=MODE_TYPE)
    CauseTransport._cont = ASN1Dict([('transport-resource-unavailable', 0), ('unspecified', 1)])
    CauseTransport._ext = []
    
    #-----< CauseProtocol >-----#
    CauseProtocol = ENUM(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 0), ('abstract-syntax-error-reject', 1), ('abstract-syntax-error-ignore-and-notify', 2), ('message-not-compatible-with-receiver-state', 3), ('semantic-error', 4), ('unspecified', 5), ('abstract-syntax-error-falsely-constructed-message', 6)])
    CauseProtocol._ext = []
    
    #-----< CauseMisc >-----#
    CauseMisc = ENUM(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('processing-overload', 0), ('hardware-failure', 1), ('o-and-m-intervention', 2), ('unspecified', 3)])
    CauseMisc._ext = []
    
    #-----< CellId-MeasuredResultsSets >-----#
    CellId_MeasuredResultsSets = SEQ_OF(name='CellId-MeasuredResultsSets', mode=MODE_TYPE)
    _CellId_MeasuredResultsSets__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-MeasuredResultsInfoList')))
    CellId_MeasuredResultsSets._cont = _CellId_MeasuredResultsSets__item_
    CellId_MeasuredResultsSets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CellId-MeasuredResultsInfoList >-----#
    CellId_MeasuredResultsInfoList = SEQ_OF(name='CellId-MeasuredResultsInfoList', mode=MODE_TYPE)
    _CellId_MeasuredResultsInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-MeasuredResultsInfo')))
    CellId_MeasuredResultsInfoList._cont = _CellId_MeasuredResultsInfoList__item_
    CellId_MeasuredResultsInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< CellId-MeasuredResultsInfo >-----#
    CellId_MeasuredResultsInfo = SEQ(name='CellId-MeasuredResultsInfo', mode=MODE_TYPE)
    _CellId_MeasuredResultsInfo_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _CellId_MeasuredResultsInfo_uTRANAccessPointPositionAltitude = SEQ(name='uTRANAccessPointPositionAltitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTRANAccessPointPositionAltitude')))
    _CellId_MeasuredResultsInfo_ue_PositionEstimate = CHOICE(name='ue-PositionEstimate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')), opt=True)
    _CellId_MeasuredResultsInfo_roundTripTimeInfo = SEQ(name='roundTripTimeInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RoundTripTimeInfo')), opt=True)
    _CellId_MeasuredResultsInfo_rxTimingDeviationInfo = SEQ(name='rxTimingDeviationInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviationInfo')), opt=True)
    _CellId_MeasuredResultsInfo_rxTimingDeviationLCRInfo = SEQ(name='rxTimingDeviationLCRInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviationLCRInfo')), opt=True)
    _CellId_MeasuredResultsInfo_pathloss = INT(name='pathloss', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Pathloss')), opt=True)
    _CellId_MeasuredResultsInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellId_MeasuredResultsInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviation768Info')))
    _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviation384extInfo')))
    _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RoundTripTimeInfoWithType1')))
    _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddMeasurementInfo')))
    _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AngleOfArrivalLCR')))
    ____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'reject'), ('Extension', _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'reject'), ('Extension', _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'ignore'), ('Extension', _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 67), ('criticality', 'ignore'), ('Extension', _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 80), ('criticality', 'ignore'), ('Extension', _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__id._const_tab = ____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__id._const_tab_at = None
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__criticality._const_tab = ____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__extensionValue._const_tab = ____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellId_MeasuredResultsInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellId_MeasuredResultsInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellId_MeasuredResultsInfo_iE_Extensions__item__id),
        ('criticality', ___CellId_MeasuredResultsInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___CellId_MeasuredResultsInfo_iE_Extensions__item__extensionValue),
        ])
    __CellId_MeasuredResultsInfo_iE_Extensions__item_._ext = None
    _CellId_MeasuredResultsInfo_iE_Extensions._cont = __CellId_MeasuredResultsInfo_iE_Extensions__item_
    _CellId_MeasuredResultsInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellId_MeasuredResultsInfo._cont = ASN1Dict([
        ('uC-ID', _CellId_MeasuredResultsInfo_uC_ID),
        ('uTRANAccessPointPositionAltitude', _CellId_MeasuredResultsInfo_uTRANAccessPointPositionAltitude),
        ('ue-PositionEstimate', _CellId_MeasuredResultsInfo_ue_PositionEstimate),
        ('roundTripTimeInfo', _CellId_MeasuredResultsInfo_roundTripTimeInfo),
        ('rxTimingDeviationInfo', _CellId_MeasuredResultsInfo_rxTimingDeviationInfo),
        ('rxTimingDeviationLCRInfo', _CellId_MeasuredResultsInfo_rxTimingDeviationLCRInfo),
        ('pathloss', _CellId_MeasuredResultsInfo_pathloss),
        ('iE-Extensions', _CellId_MeasuredResultsInfo_iE_Extensions),
        ])
    CellId_MeasuredResultsInfo._ext = []
    
    #-----< CellId-MeasuredResultsInfo-ExtIEs >-----#
    CellId_MeasuredResultsInfo_ExtIEs = CLASS(name='CellId-MeasuredResultsInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviation768Info')))
    _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviation384extInfo')))
    _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RoundTripTimeInfoWithType1')))
    _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddMeasurementInfo')))
    _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AngleOfArrivalLCR')))
    CellId_MeasuredResultsInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 43), ('criticality', 'reject'), ('Extension', _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'reject'), ('Extension', _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 64), ('criticality', 'ignore'), ('Extension', _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 67), ('criticality', 'ignore'), ('Extension', _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 80), ('criticality', 'ignore'), ('Extension', _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RoundTripTimeInfo >-----#
    RoundTripTimeInfo = SEQ(name='RoundTripTimeInfo', mode=MODE_TYPE)
    _RoundTripTimeInfo_ue_RxTxTimeDifferenceType2 = INT(name='ue-RxTxTimeDifferenceType2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-RxTxTimeDifferenceType2')))
    _RoundTripTimeInfo_ue_PositioningMeasQuality = SEQ(name='ue-PositioningMeasQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-PositioningMeasQuality')))
    _RoundTripTimeInfo_roundTripTime = INT(name='roundTripTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RoundTripTime')))
    _RoundTripTimeInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RoundTripTimeInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RoundTripTimeInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RoundTripTimeInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____RoundTripTimeInfo_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExtendedRoundTripTime')))
    ____RoundTripTimeInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 56), ('criticality', 'ignore'), ('Extension', _____RoundTripTimeInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RoundTripTimeInfo_iE_Extensions__item__id._const_tab = ____RoundTripTimeInfo_iE_Extensions__item__id_tab
    ___RoundTripTimeInfo_iE_Extensions__item__id._const_tab_at = None
    ___RoundTripTimeInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___RoundTripTimeInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RoundTripTimeInfo_iE_Extensions__item__criticality._const_tab = ____RoundTripTimeInfo_iE_Extensions__item__id_tab
    ___RoundTripTimeInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RoundTripTimeInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RoundTripTimeInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RoundTripTimeInfo_iE_Extensions__item__extensionValue._const_tab = ____RoundTripTimeInfo_iE_Extensions__item__id_tab
    ___RoundTripTimeInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RoundTripTimeInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RoundTripTimeInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RoundTripTimeInfo_iE_Extensions__item__id),
        ('criticality', ___RoundTripTimeInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___RoundTripTimeInfo_iE_Extensions__item__extensionValue),
        ])
    __RoundTripTimeInfo_iE_Extensions__item_._ext = None
    _RoundTripTimeInfo_iE_Extensions._cont = __RoundTripTimeInfo_iE_Extensions__item_
    _RoundTripTimeInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RoundTripTimeInfo._cont = ASN1Dict([
        ('ue-RxTxTimeDifferenceType2', _RoundTripTimeInfo_ue_RxTxTimeDifferenceType2),
        ('ue-PositioningMeasQuality', _RoundTripTimeInfo_ue_PositioningMeasQuality),
        ('roundTripTime', _RoundTripTimeInfo_roundTripTime),
        ('iE-Extensions', _RoundTripTimeInfo_iE_Extensions),
        ])
    RoundTripTimeInfo._ext = []
    
    #-----< RoundTripTimeInfo-ExtIEs >-----#
    RoundTripTimeInfo_ExtIEs = CLASS(name='RoundTripTimeInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _RoundTripTimeInfo_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExtendedRoundTripTime')))
    RoundTripTimeInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 56), ('criticality', 'ignore'), ('Extension', _RoundTripTimeInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RoundTripTimeInfoWithType1 >-----#
    RoundTripTimeInfoWithType1 = SEQ(name='RoundTripTimeInfoWithType1', mode=MODE_TYPE)
    _RoundTripTimeInfoWithType1_ue_RxTxTimeDifferenceType1 = INT(name='ue-RxTxTimeDifferenceType1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-RxTxTimeDifferenceType1')))
    _RoundTripTimeInfoWithType1_roundTripTime = INT(name='roundTripTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RoundTripTime')))
    _RoundTripTimeInfoWithType1_extendedRoundTripTime = INT(name='extendedRoundTripTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'ExtendedRoundTripTime')), opt=True)
    _RoundTripTimeInfoWithType1_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RoundTripTimeInfoWithType1_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RoundTripTimeInfoWithType1_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RoundTripTimeInfoWithType1_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__id._const_tab = ____RoundTripTimeInfoWithType1_iE_Extensions__item__id_tab
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__id._const_tab_at = None
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__id._const_tab_id = 'id'
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RoundTripTimeInfoWithType1_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RoundTripTimeInfoWithType1_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__criticality._const_tab = ____RoundTripTimeInfoWithType1_iE_Extensions__item__criticality_tab
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RoundTripTimeInfoWithType1_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RoundTripTimeInfoWithType1_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__extensionValue._const_tab = ____RoundTripTimeInfoWithType1_iE_Extensions__item__extensionValue_tab
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RoundTripTimeInfoWithType1_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RoundTripTimeInfoWithType1_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RoundTripTimeInfoWithType1_iE_Extensions__item__id),
        ('criticality', ___RoundTripTimeInfoWithType1_iE_Extensions__item__criticality),
        ('extensionValue', ___RoundTripTimeInfoWithType1_iE_Extensions__item__extensionValue),
        ])
    __RoundTripTimeInfoWithType1_iE_Extensions__item_._ext = None
    _RoundTripTimeInfoWithType1_iE_Extensions._cont = __RoundTripTimeInfoWithType1_iE_Extensions__item_
    _RoundTripTimeInfoWithType1_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RoundTripTimeInfoWithType1._cont = ASN1Dict([
        ('ue-RxTxTimeDifferenceType1', _RoundTripTimeInfoWithType1_ue_RxTxTimeDifferenceType1),
        ('roundTripTime', _RoundTripTimeInfoWithType1_roundTripTime),
        ('extendedRoundTripTime', _RoundTripTimeInfoWithType1_extendedRoundTripTime),
        ('iE-Extensions', _RoundTripTimeInfoWithType1_iE_Extensions),
        ])
    RoundTripTimeInfoWithType1._ext = []
    
    #-----< RoundTripTimeInfoWithType1-ExtIEs >-----#
    RoundTripTimeInfoWithType1_ExtIEs = CLASS(name='RoundTripTimeInfoWithType1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RoundTripTimeInfoWithType1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-RxTxTimeDifferenceType2 >-----#
    UE_RxTxTimeDifferenceType2 = INT(name='UE-RxTxTimeDifferenceType2', mode=MODE_TYPE)
    UE_RxTxTimeDifferenceType2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< UE-RxTxTimeDifferenceType1 >-----#
    UE_RxTxTimeDifferenceType1 = INT(name='UE-RxTxTimeDifferenceType1', mode=MODE_TYPE)
    UE_RxTxTimeDifferenceType1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=768, ub=1280)], ev=None, er=[])
    
    #-----< UE-PositioningMeasQuality >-----#
    UE_PositioningMeasQuality = SEQ(name='UE-PositioningMeasQuality', mode=MODE_TYPE)
    _UE_PositioningMeasQuality_stdResolution = BIT_STR(name='stdResolution', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_PositioningMeasQuality_stdResolution._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _UE_PositioningMeasQuality_numberOfMeasurements = BIT_STR(name='numberOfMeasurements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_PositioningMeasQuality_numberOfMeasurements._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _UE_PositioningMeasQuality_stdOfMeasurements = BIT_STR(name='stdOfMeasurements', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_PositioningMeasQuality_stdOfMeasurements._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _UE_PositioningMeasQuality_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_PositioningMeasQuality_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UE_PositioningMeasQuality_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_PositioningMeasQuality_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_PositioningMeasQuality_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_PositioningMeasQuality_iE_Extensions__item__id._const_tab = ____UE_PositioningMeasQuality_iE_Extensions__item__id_tab
    ___UE_PositioningMeasQuality_iE_Extensions__item__id._const_tab_at = None
    ___UE_PositioningMeasQuality_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_PositioningMeasQuality_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_PositioningMeasQuality_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_PositioningMeasQuality_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_PositioningMeasQuality_iE_Extensions__item__criticality._const_tab = ____UE_PositioningMeasQuality_iE_Extensions__item__criticality_tab
    ___UE_PositioningMeasQuality_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_PositioningMeasQuality_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_PositioningMeasQuality_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_PositioningMeasQuality_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_PositioningMeasQuality_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_PositioningMeasQuality_iE_Extensions__item__extensionValue._const_tab = ____UE_PositioningMeasQuality_iE_Extensions__item__extensionValue_tab
    ___UE_PositioningMeasQuality_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_PositioningMeasQuality_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_PositioningMeasQuality_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_PositioningMeasQuality_iE_Extensions__item__id),
        ('criticality', ___UE_PositioningMeasQuality_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_PositioningMeasQuality_iE_Extensions__item__extensionValue),
        ])
    __UE_PositioningMeasQuality_iE_Extensions__item_._ext = None
    _UE_PositioningMeasQuality_iE_Extensions._cont = __UE_PositioningMeasQuality_iE_Extensions__item_
    _UE_PositioningMeasQuality_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_PositioningMeasQuality._cont = ASN1Dict([
        ('stdResolution', _UE_PositioningMeasQuality_stdResolution),
        ('numberOfMeasurements', _UE_PositioningMeasQuality_numberOfMeasurements),
        ('stdOfMeasurements', _UE_PositioningMeasQuality_stdOfMeasurements),
        ('iE-Extensions', _UE_PositioningMeasQuality_iE_Extensions),
        ])
    UE_PositioningMeasQuality._ext = []
    
    #-----< UE-PositioningMeasQuality-ExtIEs >-----#
    UE_PositioningMeasQuality_ExtIEs = CLASS(name='UE-PositioningMeasQuality-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UE_PositioningMeasQuality_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RoundTripTime >-----#
    RoundTripTime = INT(name='RoundTripTime', mode=MODE_TYPE)
    RoundTripTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32766)], ev=None, er=[])
    
    #-----< ExtendedRoundTripTime >-----#
    ExtendedRoundTripTime = INT(name='ExtendedRoundTripTime', mode=MODE_TYPE)
    ExtendedRoundTripTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32767, ub=103041)], ev=None, er=[])
    
    #-----< UTRANAccessPointPositionAltitude >-----#
    UTRANAccessPointPositionAltitude = SEQ(name='UTRANAccessPointPositionAltitude', mode=MODE_TYPE)
    _UTRANAccessPointPositionAltitude_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GeographicalCoordinates')))
    _UTRANAccessPointPositionAltitude_ga_AltitudeAndDirection = SEQ(name='ga-AltitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-AltitudeAndDirection')), opt=True)
    _UTRANAccessPointPositionAltitude_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTRANAccessPointPositionAltitude_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTRANAccessPointPositionAltitude_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRANAccessPointPositionAltitude_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__id._const_tab = ____UTRANAccessPointPositionAltitude_iE_Extensions__item__id_tab
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__id._const_tab_at = None
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__id._const_tab_id = 'id'
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTRANAccessPointPositionAltitude_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRANAccessPointPositionAltitude_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__criticality._const_tab = ____UTRANAccessPointPositionAltitude_iE_Extensions__item__criticality_tab
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTRANAccessPointPositionAltitude_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRANAccessPointPositionAltitude_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__extensionValue._const_tab = ____UTRANAccessPointPositionAltitude_iE_Extensions__item__extensionValue_tab
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTRANAccessPointPositionAltitude_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTRANAccessPointPositionAltitude_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTRANAccessPointPositionAltitude_iE_Extensions__item__id),
        ('criticality', ___UTRANAccessPointPositionAltitude_iE_Extensions__item__criticality),
        ('extensionValue', ___UTRANAccessPointPositionAltitude_iE_Extensions__item__extensionValue),
        ])
    __UTRANAccessPointPositionAltitude_iE_Extensions__item_._ext = None
    _UTRANAccessPointPositionAltitude_iE_Extensions._cont = __UTRANAccessPointPositionAltitude_iE_Extensions__item_
    _UTRANAccessPointPositionAltitude_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTRANAccessPointPositionAltitude._cont = ASN1Dict([
        ('geographicalCoordinates', _UTRANAccessPointPositionAltitude_geographicalCoordinates),
        ('ga-AltitudeAndDirection', _UTRANAccessPointPositionAltitude_ga_AltitudeAndDirection),
        ('iE-Extensions', _UTRANAccessPointPositionAltitude_iE_Extensions),
        ])
    UTRANAccessPointPositionAltitude._ext = []
    
    #-----< UTRANAccessPointPositionAltitude-ExtIEs >-----#
    UTRANAccessPointPositionAltitude_ExtIEs = CLASS(name='UTRANAccessPointPositionAltitude-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTRANAccessPointPositionAltitude_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RxTimingDeviationInfo >-----#
    RxTimingDeviationInfo = SEQ(name='RxTimingDeviationInfo', mode=MODE_TYPE)
    _RxTimingDeviationInfo_rxTimingDeviation = INT(name='rxTimingDeviation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviation')))
    _RxTimingDeviationInfo_timingAdvance = INT(name='timingAdvance', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TimingAdvance')))
    _RxTimingDeviationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RxTimingDeviationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RxTimingDeviationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RxTimingDeviationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RxTimingDeviationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTimingDeviationInfo_iE_Extensions__item__id._const_tab = ____RxTimingDeviationInfo_iE_Extensions__item__id_tab
    ___RxTimingDeviationInfo_iE_Extensions__item__id._const_tab_at = None
    ___RxTimingDeviationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___RxTimingDeviationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RxTimingDeviationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RxTimingDeviationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTimingDeviationInfo_iE_Extensions__item__criticality._const_tab = ____RxTimingDeviationInfo_iE_Extensions__item__criticality_tab
    ___RxTimingDeviationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RxTimingDeviationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RxTimingDeviationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RxTimingDeviationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RxTimingDeviationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTimingDeviationInfo_iE_Extensions__item__extensionValue._const_tab = ____RxTimingDeviationInfo_iE_Extensions__item__extensionValue_tab
    ___RxTimingDeviationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RxTimingDeviationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RxTimingDeviationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RxTimingDeviationInfo_iE_Extensions__item__id),
        ('criticality', ___RxTimingDeviationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___RxTimingDeviationInfo_iE_Extensions__item__extensionValue),
        ])
    __RxTimingDeviationInfo_iE_Extensions__item_._ext = None
    _RxTimingDeviationInfo_iE_Extensions._cont = __RxTimingDeviationInfo_iE_Extensions__item_
    _RxTimingDeviationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RxTimingDeviationInfo._cont = ASN1Dict([
        ('rxTimingDeviation', _RxTimingDeviationInfo_rxTimingDeviation),
        ('timingAdvance', _RxTimingDeviationInfo_timingAdvance),
        ('iE-Extensions', _RxTimingDeviationInfo_iE_Extensions),
        ])
    RxTimingDeviationInfo._ext = []
    
    #-----< RxTimingDeviationInfo-ExtIEs >-----#
    RxTimingDeviationInfo_ExtIEs = CLASS(name='RxTimingDeviationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RxTimingDeviationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RxTimingDeviationLCRInfo >-----#
    RxTimingDeviationLCRInfo = SEQ(name='RxTimingDeviationLCRInfo', mode=MODE_TYPE)
    _RxTimingDeviationLCRInfo_rxTimingDeviationLCR = INT(name='rxTimingDeviationLCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviationLCR')))
    _RxTimingDeviationLCRInfo_timingAdvanceLCR = INT(name='timingAdvanceLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TimingAdvanceLCR')))
    _RxTimingDeviationLCRInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RxTimingDeviationLCRInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RxTimingDeviationLCRInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____RxTimingDeviationLCRInfo_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExtendedTimingAdvanceLCR')))
    ____RxTimingDeviationLCRInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 81), ('criticality', 'ignore'), ('Extension', _____RxTimingDeviationLCRInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__id._const_tab = ____RxTimingDeviationLCRInfo_iE_Extensions__item__id_tab
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__id._const_tab_at = None
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__criticality._const_tab = ____RxTimingDeviationLCRInfo_iE_Extensions__item__id_tab
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__extensionValue._const_tab = ____RxTimingDeviationLCRInfo_iE_Extensions__item__id_tab
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RxTimingDeviationLCRInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RxTimingDeviationLCRInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RxTimingDeviationLCRInfo_iE_Extensions__item__id),
        ('criticality', ___RxTimingDeviationLCRInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___RxTimingDeviationLCRInfo_iE_Extensions__item__extensionValue),
        ])
    __RxTimingDeviationLCRInfo_iE_Extensions__item_._ext = None
    _RxTimingDeviationLCRInfo_iE_Extensions._cont = __RxTimingDeviationLCRInfo_iE_Extensions__item_
    _RxTimingDeviationLCRInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RxTimingDeviationLCRInfo._cont = ASN1Dict([
        ('rxTimingDeviationLCR', _RxTimingDeviationLCRInfo_rxTimingDeviationLCR),
        ('timingAdvanceLCR', _RxTimingDeviationLCRInfo_timingAdvanceLCR),
        ('iE-Extensions', _RxTimingDeviationLCRInfo_iE_Extensions),
        ])
    RxTimingDeviationLCRInfo._ext = []
    
    #-----< RxTimingDeviationLCRInfo-ExtIEs >-----#
    RxTimingDeviationLCRInfo_ExtIEs = CLASS(name='RxTimingDeviationLCRInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _RxTimingDeviationLCRInfo_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExtendedTimingAdvanceLCR')))
    RxTimingDeviationLCRInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 81), ('criticality', 'ignore'), ('Extension', _RxTimingDeviationLCRInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ExtendedTimingAdvanceLCR >-----#
    ExtendedTimingAdvanceLCR = INT(name='ExtendedTimingAdvanceLCR', mode=MODE_TYPE)
    ExtendedTimingAdvanceLCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2048, ub=8191)], ev=None, er=[])
    
    #-----< RxTimingDeviation768Info >-----#
    RxTimingDeviation768Info = SEQ(name='RxTimingDeviation768Info', mode=MODE_TYPE)
    _RxTimingDeviation768Info_rxTimingDeviation768 = INT(name='rxTimingDeviation768', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviation768')))
    _RxTimingDeviation768Info_timingAdvance768 = INT(name='timingAdvance768', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TimingAdvance768')))
    _RxTimingDeviation768Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RxTimingDeviation768Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RxTimingDeviation768Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RxTimingDeviation768Info_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RxTimingDeviation768Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTimingDeviation768Info_iE_Extensions__item__id._const_tab = ____RxTimingDeviation768Info_iE_Extensions__item__id_tab
    ___RxTimingDeviation768Info_iE_Extensions__item__id._const_tab_at = None
    ___RxTimingDeviation768Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___RxTimingDeviation768Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RxTimingDeviation768Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RxTimingDeviation768Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTimingDeviation768Info_iE_Extensions__item__criticality._const_tab = ____RxTimingDeviation768Info_iE_Extensions__item__criticality_tab
    ___RxTimingDeviation768Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RxTimingDeviation768Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RxTimingDeviation768Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RxTimingDeviation768Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RxTimingDeviation768Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTimingDeviation768Info_iE_Extensions__item__extensionValue._const_tab = ____RxTimingDeviation768Info_iE_Extensions__item__extensionValue_tab
    ___RxTimingDeviation768Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RxTimingDeviation768Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RxTimingDeviation768Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RxTimingDeviation768Info_iE_Extensions__item__id),
        ('criticality', ___RxTimingDeviation768Info_iE_Extensions__item__criticality),
        ('extensionValue', ___RxTimingDeviation768Info_iE_Extensions__item__extensionValue),
        ])
    __RxTimingDeviation768Info_iE_Extensions__item_._ext = None
    _RxTimingDeviation768Info_iE_Extensions._cont = __RxTimingDeviation768Info_iE_Extensions__item_
    _RxTimingDeviation768Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RxTimingDeviation768Info._cont = ASN1Dict([
        ('rxTimingDeviation768', _RxTimingDeviation768Info_rxTimingDeviation768),
        ('timingAdvance768', _RxTimingDeviation768Info_timingAdvance768),
        ('iE-Extensions', _RxTimingDeviation768Info_iE_Extensions),
        ])
    RxTimingDeviation768Info._ext = []
    
    #-----< RxTimingDeviation768Info-ExtIEs >-----#
    RxTimingDeviation768Info_ExtIEs = CLASS(name='RxTimingDeviation768Info-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RxTimingDeviation768Info_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RxTimingDeviation384extInfo >-----#
    RxTimingDeviation384extInfo = SEQ(name='RxTimingDeviation384extInfo', mode=MODE_TYPE)
    _RxTimingDeviation384extInfo_rxTimingDeviation384ext = INT(name='rxTimingDeviation384ext', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviation384ext')))
    _RxTimingDeviation384extInfo_timingAdvance384ext = INT(name='timingAdvance384ext', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TimingAdvance384ext')))
    _RxTimingDeviation384extInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RxTimingDeviation384extInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RxTimingDeviation384extInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RxTimingDeviation384extInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RxTimingDeviation384extInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTimingDeviation384extInfo_iE_Extensions__item__id._const_tab = ____RxTimingDeviation384extInfo_iE_Extensions__item__id_tab
    ___RxTimingDeviation384extInfo_iE_Extensions__item__id._const_tab_at = None
    ___RxTimingDeviation384extInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___RxTimingDeviation384extInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RxTimingDeviation384extInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RxTimingDeviation384extInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTimingDeviation384extInfo_iE_Extensions__item__criticality._const_tab = ____RxTimingDeviation384extInfo_iE_Extensions__item__criticality_tab
    ___RxTimingDeviation384extInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RxTimingDeviation384extInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RxTimingDeviation384extInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RxTimingDeviation384extInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RxTimingDeviation384extInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RxTimingDeviation384extInfo_iE_Extensions__item__extensionValue._const_tab = ____RxTimingDeviation384extInfo_iE_Extensions__item__extensionValue_tab
    ___RxTimingDeviation384extInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RxTimingDeviation384extInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RxTimingDeviation384extInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RxTimingDeviation384extInfo_iE_Extensions__item__id),
        ('criticality', ___RxTimingDeviation384extInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___RxTimingDeviation384extInfo_iE_Extensions__item__extensionValue),
        ])
    __RxTimingDeviation384extInfo_iE_Extensions__item_._ext = None
    _RxTimingDeviation384extInfo_iE_Extensions._cont = __RxTimingDeviation384extInfo_iE_Extensions__item_
    _RxTimingDeviation384extInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RxTimingDeviation384extInfo._cont = ASN1Dict([
        ('rxTimingDeviation384ext', _RxTimingDeviation384extInfo_rxTimingDeviation384ext),
        ('timingAdvance384ext', _RxTimingDeviation384extInfo_timingAdvance384ext),
        ('iE-Extensions', _RxTimingDeviation384extInfo_iE_Extensions),
        ])
    RxTimingDeviation384extInfo._ext = []
    
    #-----< RxTimingDeviation384extInfo-ExtIEs >-----#
    RxTimingDeviation384extInfo_ExtIEs = CLASS(name='RxTimingDeviation384extInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RxTimingDeviation384extInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AddMeasurementInfo >-----#
    AddMeasurementInfo = SEQ(name='AddMeasurementInfo', mode=MODE_TYPE)
    _AddMeasurementInfo_cpich_RSCP = INT(name='cpich-RSCP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CPICH-RSCP')), opt=True)
    _AddMeasurementInfo_cpich_EcNo = INT(name='cpich-EcNo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CPICH-EcNo')), opt=True)
    _AddMeasurementInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AddMeasurementInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AddMeasurementInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AddMeasurementInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AddMeasurementInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddMeasurementInfo_iE_Extensions__item__id._const_tab = ____AddMeasurementInfo_iE_Extensions__item__id_tab
    ___AddMeasurementInfo_iE_Extensions__item__id._const_tab_at = None
    ___AddMeasurementInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___AddMeasurementInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AddMeasurementInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AddMeasurementInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddMeasurementInfo_iE_Extensions__item__criticality._const_tab = ____AddMeasurementInfo_iE_Extensions__item__criticality_tab
    ___AddMeasurementInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AddMeasurementInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AddMeasurementInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AddMeasurementInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AddMeasurementInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddMeasurementInfo_iE_Extensions__item__extensionValue._const_tab = ____AddMeasurementInfo_iE_Extensions__item__extensionValue_tab
    ___AddMeasurementInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AddMeasurementInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AddMeasurementInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AddMeasurementInfo_iE_Extensions__item__id),
        ('criticality', ___AddMeasurementInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___AddMeasurementInfo_iE_Extensions__item__extensionValue),
        ])
    __AddMeasurementInfo_iE_Extensions__item_._ext = None
    _AddMeasurementInfo_iE_Extensions._cont = __AddMeasurementInfo_iE_Extensions__item_
    _AddMeasurementInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AddMeasurementInfo._cont = ASN1Dict([
        ('cpich-RSCP', _AddMeasurementInfo_cpich_RSCP),
        ('cpich-EcNo', _AddMeasurementInfo_cpich_EcNo),
        ('iE-Extensions', _AddMeasurementInfo_iE_Extensions),
        ])
    AddMeasurementInfo._ext = []
    
    #-----< AddMeasurementInfo-ExtIEs >-----#
    AddMeasurementInfo_ExtIEs = CLASS(name='AddMeasurementInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AddMeasurementInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AngleOfArrivalLCR >-----#
    AngleOfArrivalLCR = SEQ(name='AngleOfArrivalLCR', mode=MODE_TYPE)
    _AngleOfArrivalLCR_aOA_LCR = INT(name='aOA-LCR', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AOA-LCR')))
    _AngleOfArrivalLCR_aOA_LCR_Accuracy_Class = ENUM(name='aOA-LCR-Accuracy-Class', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AOA-LCR-Accuracy-Class')))
    _AngleOfArrivalLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AngleOfArrivalLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AngleOfArrivalLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AngleOfArrivalLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AngleOfArrivalLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AngleOfArrivalLCR_iE_Extensions__item__id._const_tab = ____AngleOfArrivalLCR_iE_Extensions__item__id_tab
    ___AngleOfArrivalLCR_iE_Extensions__item__id._const_tab_at = None
    ___AngleOfArrivalLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___AngleOfArrivalLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AngleOfArrivalLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AngleOfArrivalLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AngleOfArrivalLCR_iE_Extensions__item__criticality._const_tab = ____AngleOfArrivalLCR_iE_Extensions__item__criticality_tab
    ___AngleOfArrivalLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AngleOfArrivalLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AngleOfArrivalLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AngleOfArrivalLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AngleOfArrivalLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AngleOfArrivalLCR_iE_Extensions__item__extensionValue._const_tab = ____AngleOfArrivalLCR_iE_Extensions__item__extensionValue_tab
    ___AngleOfArrivalLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AngleOfArrivalLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AngleOfArrivalLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AngleOfArrivalLCR_iE_Extensions__item__id),
        ('criticality', ___AngleOfArrivalLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___AngleOfArrivalLCR_iE_Extensions__item__extensionValue),
        ])
    __AngleOfArrivalLCR_iE_Extensions__item_._ext = None
    _AngleOfArrivalLCR_iE_Extensions._cont = __AngleOfArrivalLCR_iE_Extensions__item_
    _AngleOfArrivalLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AngleOfArrivalLCR._cont = ASN1Dict([
        ('aOA-LCR', _AngleOfArrivalLCR_aOA_LCR),
        ('aOA-LCR-Accuracy-Class', _AngleOfArrivalLCR_aOA_LCR_Accuracy_Class),
        ('iE-Extensions', _AngleOfArrivalLCR_iE_Extensions),
        ])
    AngleOfArrivalLCR._ext = []
    
    #-----< AngleOfArrivalLCR-ExtIEs >-----#
    AngleOfArrivalLCR_ExtIEs = CLASS(name='AngleOfArrivalLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AngleOfArrivalLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RxTimingDeviation >-----#
    RxTimingDeviation = INT(name='RxTimingDeviation', mode=MODE_TYPE)
    RxTimingDeviation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< RxTimingDeviationLCR >-----#
    RxTimingDeviationLCR = INT(name='RxTimingDeviationLCR', mode=MODE_TYPE)
    RxTimingDeviationLCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< RxTimingDeviation768 >-----#
    RxTimingDeviation768 = INT(name='RxTimingDeviation768', mode=MODE_TYPE)
    RxTimingDeviation768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< RxTimingDeviation384ext >-----#
    RxTimingDeviation384ext = INT(name='RxTimingDeviation384ext', mode=MODE_TYPE)
    RxTimingDeviation384ext._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    
    #-----< TimingAdvance >-----#
    TimingAdvance = INT(name='TimingAdvance', mode=MODE_TYPE)
    TimingAdvance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< TimingAdvanceLCR >-----#
    TimingAdvanceLCR = INT(name='TimingAdvanceLCR', mode=MODE_TYPE)
    TimingAdvanceLCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    
    #-----< TimingAdvance768 >-----#
    TimingAdvance768 = INT(name='TimingAdvance768', mode=MODE_TYPE)
    TimingAdvance768._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< TimingAdvance384ext >-----#
    TimingAdvance384ext = INT(name='TimingAdvance384ext', mode=MODE_TYPE)
    TimingAdvance384ext._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< Pathloss >-----#
    Pathloss = INT(name='Pathloss', mode=MODE_TYPE)
    Pathloss._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=46, ub=158)], ev=None, er=[])
    
    #-----< CPICH-EcNo >-----#
    CPICH_EcNo = INT(name='CPICH-EcNo', mode=MODE_TYPE)
    CPICH_EcNo._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=49)], ev=None, er=[])
    
    #-----< CPICH-RSCP >-----#
    CPICH_RSCP = INT(name='CPICH-RSCP', mode=MODE_TYPE)
    CPICH_RSCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-5, ub=91)], ev=None, er=[])
    
    #-----< AOA-LCR >-----#
    AOA_LCR = INT(name='AOA-LCR', mode=MODE_TYPE)
    AOA_LCR._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=719)], ev=None, er=[])
    
    #-----< AOA-LCR-Accuracy-Class >-----#
    AOA_LCR_Accuracy_Class = ENUM(name='AOA-LCR-Accuracy-Class', mode=MODE_TYPE)
    AOA_LCR_Accuracy_Class._cont = ASN1Dict([('a', 0), ('b', 1), ('c', 2), ('d', 3), ('e', 4), ('f', 5), ('g', 6), ('h', 7)])
    AOA_LCR_Accuracy_Class._ext = []
    
    #-----< CellId-IRATMeasuredResultsSets >-----#
    CellId_IRATMeasuredResultsSets = SEQ_OF(name='CellId-IRATMeasuredResultsSets', mode=MODE_TYPE)
    _CellId_IRATMeasuredResultsSets__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-IRATMeasuredResultsInfoList')))
    CellId_IRATMeasuredResultsSets._cont = _CellId_IRATMeasuredResultsSets__item_
    CellId_IRATMeasuredResultsSets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< CellId-IRATMeasuredResultsInfoList >-----#
    CellId_IRATMeasuredResultsInfoList = SEQ(name='CellId-IRATMeasuredResultsInfoList', mode=MODE_TYPE)
    _CellId_IRATMeasuredResultsInfoList_gERAN_MeasuredResultsInfoList = SEQ_OF(name='gERAN-MeasuredResultsInfoList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GERAN-MeasuredResultsInfoList')), opt=True)
    _CellId_IRATMeasuredResultsInfoList_iE_Extenstions = SEQ_OF(name='iE-Extenstions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__id._const_tab = ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__id_tab
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__id._const_tab_at = None
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__id._const_tab_id = 'id'
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__criticality._const_tab = ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__criticality_tab
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__criticality._const_tab_at = ('..', 'id')
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__criticality._const_tab_id = 'criticality'
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__extensionValue._const_tab = ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__extensionValue_tab
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__extensionValue._const_tab_id = 'Extension'
    __CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item_._cont = ASN1Dict([
        ('id', ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__id),
        ('criticality', ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__criticality),
        ('extensionValue', ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__extensionValue),
        ])
    __CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item_._ext = None
    _CellId_IRATMeasuredResultsInfoList_iE_Extenstions._cont = __CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item_
    _CellId_IRATMeasuredResultsInfoList_iE_Extenstions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellId_IRATMeasuredResultsInfoList._cont = ASN1Dict([
        ('gERAN-MeasuredResultsInfoList', _CellId_IRATMeasuredResultsInfoList_gERAN_MeasuredResultsInfoList),
        ('iE-Extenstions', _CellId_IRATMeasuredResultsInfoList_iE_Extenstions),
        ])
    CellId_IRATMeasuredResultsInfoList._ext = []
    
    #-----< CellId-IRATMeasuredResultsInfoListExtIEs >-----#
    CellId_IRATMeasuredResultsInfoListExtIEs = CLASS(name='CellId-IRATMeasuredResultsInfoListExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    CellId_IRATMeasuredResultsInfoListExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GERAN-MeasuredResultsInfoList >-----#
    GERAN_MeasuredResultsInfoList = SEQ_OF(name='GERAN-MeasuredResultsInfoList', mode=MODE_TYPE)
    _GERAN_MeasuredResultsInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GERAN-MeasuredResultsInfo')))
    GERAN_MeasuredResultsInfoList._cont = _GERAN_MeasuredResultsInfoList__item_
    GERAN_MeasuredResultsInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< GERAN-MeasuredResultsInfo >-----#
    GERAN_MeasuredResultsInfo = SEQ(name='GERAN-MeasuredResultsInfo', mode=MODE_TYPE)
    _GERAN_MeasuredResultsInfo_gERANCellID = SEQ(name='gERANCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GERANCellGlobalID')), opt=True)
    _GERAN_MeasuredResultsInfo_gERANPhysicalCellID = SEQ(name='gERANPhysicalCellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GERANPhysicalCellID')))
    _GERAN_MeasuredResultsInfo_gSM_RSSI = INT(name='gSM-RSSI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GSM-RSSI')))
    _GERAN_MeasuredResultsInfo_iE_Extenstions = SEQ_OF(name='iE-Extenstions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GERAN_MeasuredResultsInfo_iE_Extenstions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__id._const_tab = ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__id_tab
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__id._const_tab_at = None
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__id._const_tab_id = 'id'
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__criticality._const_tab = ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__criticality_tab
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__criticality._const_tab_at = ('..', 'id')
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__criticality._const_tab_id = 'criticality'
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__extensionValue._const_tab = ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__extensionValue_tab
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__extensionValue._const_tab_id = 'Extension'
    __GERAN_MeasuredResultsInfo_iE_Extenstions__item_._cont = ASN1Dict([
        ('id', ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__id),
        ('criticality', ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__criticality),
        ('extensionValue', ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__extensionValue),
        ])
    __GERAN_MeasuredResultsInfo_iE_Extenstions__item_._ext = None
    _GERAN_MeasuredResultsInfo_iE_Extenstions._cont = __GERAN_MeasuredResultsInfo_iE_Extenstions__item_
    _GERAN_MeasuredResultsInfo_iE_Extenstions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GERAN_MeasuredResultsInfo._cont = ASN1Dict([
        ('gERANCellID', _GERAN_MeasuredResultsInfo_gERANCellID),
        ('gERANPhysicalCellID', _GERAN_MeasuredResultsInfo_gERANPhysicalCellID),
        ('gSM-RSSI', _GERAN_MeasuredResultsInfo_gSM_RSSI),
        ('iE-Extenstions', _GERAN_MeasuredResultsInfo_iE_Extenstions),
        ])
    GERAN_MeasuredResultsInfo._ext = []
    
    #-----< GERAN-MeasuredResultsInfo-ExtIEs >-----#
    GERAN_MeasuredResultsInfo_ExtIEs = CLASS(name='GERAN-MeasuredResultsInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GERAN_MeasuredResultsInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GERANCellGlobalID >-----#
    GERANCellGlobalID = SEQ(name='GERANCellGlobalID', mode=MODE_TYPE)
    _GERANCellGlobalID_plmn_Identity = OCT_STR(name='plmn-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PLMN-Identity')))
    _GERANCellGlobalID_locationAreaCode = BIT_STR(name='locationAreaCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GERANCellGlobalID_locationAreaCode._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GERANCellGlobalID_cellIdentity = BIT_STR(name='cellIdentity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GERANCellGlobalID_cellIdentity._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GERANCellGlobalID_iE_Extenstions = SEQ_OF(name='iE-Extenstions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GERANCellGlobalID_iE_Extenstions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GERANCellGlobalID_iE_Extenstions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GERANCellGlobalID_iE_Extenstions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GERANCellGlobalID_iE_Extenstions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERANCellGlobalID_iE_Extenstions__item__id._const_tab = ____GERANCellGlobalID_iE_Extenstions__item__id_tab
    ___GERANCellGlobalID_iE_Extenstions__item__id._const_tab_at = None
    ___GERANCellGlobalID_iE_Extenstions__item__id._const_tab_id = 'id'
    ___GERANCellGlobalID_iE_Extenstions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GERANCellGlobalID_iE_Extenstions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GERANCellGlobalID_iE_Extenstions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERANCellGlobalID_iE_Extenstions__item__criticality._const_tab = ____GERANCellGlobalID_iE_Extenstions__item__criticality_tab
    ___GERANCellGlobalID_iE_Extenstions__item__criticality._const_tab_at = ('..', 'id')
    ___GERANCellGlobalID_iE_Extenstions__item__criticality._const_tab_id = 'criticality'
    ___GERANCellGlobalID_iE_Extenstions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GERANCellGlobalID_iE_Extenstions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GERANCellGlobalID_iE_Extenstions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERANCellGlobalID_iE_Extenstions__item__extensionValue._const_tab = ____GERANCellGlobalID_iE_Extenstions__item__extensionValue_tab
    ___GERANCellGlobalID_iE_Extenstions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GERANCellGlobalID_iE_Extenstions__item__extensionValue._const_tab_id = 'Extension'
    __GERANCellGlobalID_iE_Extenstions__item_._cont = ASN1Dict([
        ('id', ___GERANCellGlobalID_iE_Extenstions__item__id),
        ('criticality', ___GERANCellGlobalID_iE_Extenstions__item__criticality),
        ('extensionValue', ___GERANCellGlobalID_iE_Extenstions__item__extensionValue),
        ])
    __GERANCellGlobalID_iE_Extenstions__item_._ext = None
    _GERANCellGlobalID_iE_Extenstions._cont = __GERANCellGlobalID_iE_Extenstions__item_
    _GERANCellGlobalID_iE_Extenstions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GERANCellGlobalID._cont = ASN1Dict([
        ('plmn-Identity', _GERANCellGlobalID_plmn_Identity),
        ('locationAreaCode', _GERANCellGlobalID_locationAreaCode),
        ('cellIdentity', _GERANCellGlobalID_cellIdentity),
        ('iE-Extenstions', _GERANCellGlobalID_iE_Extenstions),
        ])
    GERANCellGlobalID._ext = []
    
    #-----< GERANCellGlobalID-ExtIEs >-----#
    GERANCellGlobalID_ExtIEs = CLASS(name='GERANCellGlobalID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GERANCellGlobalID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = OCT_STR(name='PLMN-Identity', mode=MODE_TYPE)
    PLMN_Identity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< GSM-RSSI >-----#
    GSM_RSSI = INT(name='GSM-RSSI', mode=MODE_TYPE)
    GSM_RSSI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< GERANPhysicalCellID >-----#
    GERANPhysicalCellID = SEQ(name='GERANPhysicalCellID', mode=MODE_TYPE)
    _GERANPhysicalCellID_bsic = SEQ(name='bsic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GSM-BSIC')))
    _GERANPhysicalCellID_arfcn = INT(name='arfcn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GSM-BCCH-ARFCN')))
    GERANPhysicalCellID._cont = ASN1Dict([
        ('bsic', _GERANPhysicalCellID_bsic),
        ('arfcn', _GERANPhysicalCellID_arfcn),
        ])
    GERANPhysicalCellID._ext = None
    
    #-----< GSM-BSIC >-----#
    GSM_BSIC = SEQ(name='GSM-BSIC', mode=MODE_TYPE)
    _GSM_BSIC_networkColourCode = BIT_STR(name='networkColourCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GSM_BSIC_networkColourCode._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GSM_BSIC_baseStationColourCode = BIT_STR(name='baseStationColourCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GSM_BSIC_baseStationColourCode._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    GSM_BSIC._cont = ASN1Dict([
        ('networkColourCode', _GSM_BSIC_networkColourCode),
        ('baseStationColourCode', _GSM_BSIC_baseStationColourCode),
        ])
    GSM_BSIC._ext = None
    
    #-----< GSM-BCCH-ARFCN >-----#
    GSM_BCCH_ARFCN = INT(name='GSM-BCCH-ARFCN', mode=MODE_TYPE)
    GSM_BCCH_ARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    
    #-----< CellIDPositioning >-----#
    CellIDPositioning = SEQ(name='CellIDPositioning', mode=MODE_TYPE)
    _CellIDPositioning_requestedCellIDMeasurements = CHOICE(name='requestedCellIDMeasurements', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RequestedCellIDMeasurements')))
    _CellIDPositioning_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellIDPositioning_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___CellIDPositioning_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellIDPositioning_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____CellIDPositioning_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RequestedCellIDGERANMeasurements')))
    ____CellIDPositioning_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 124), ('criticality', 'reject'), ('Extension', _____CellIDPositioning_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CellIDPositioning_iE_Extensions__item__id._const_tab = ____CellIDPositioning_iE_Extensions__item__id_tab
    ___CellIDPositioning_iE_Extensions__item__id._const_tab_at = None
    ___CellIDPositioning_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellIDPositioning_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CellIDPositioning_iE_Extensions__item__criticality._const_tab = ____CellIDPositioning_iE_Extensions__item__id_tab
    ___CellIDPositioning_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellIDPositioning_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellIDPositioning_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CellIDPositioning_iE_Extensions__item__extensionValue._const_tab = ____CellIDPositioning_iE_Extensions__item__id_tab
    ___CellIDPositioning_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellIDPositioning_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellIDPositioning_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellIDPositioning_iE_Extensions__item__id),
        ('criticality', ___CellIDPositioning_iE_Extensions__item__criticality),
        ('extensionValue', ___CellIDPositioning_iE_Extensions__item__extensionValue),
        ])
    __CellIDPositioning_iE_Extensions__item_._ext = None
    _CellIDPositioning_iE_Extensions._cont = __CellIDPositioning_iE_Extensions__item_
    _CellIDPositioning_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellIDPositioning._cont = ASN1Dict([
        ('requestedCellIDMeasurements', _CellIDPositioning_requestedCellIDMeasurements),
        ('iE-Extensions', _CellIDPositioning_iE_Extensions),
        ])
    CellIDPositioning._ext = []
    
    #-----< CellIDPositioning-ExtIEs >-----#
    CellIDPositioning_ExtIEs = CLASS(name='CellIDPositioning-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _CellIDPositioning_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RequestedCellIDGERANMeasurements')))
    CellIDPositioning_ExtIEs._val = ASN1Set(rv=[dict([('id', 124), ('criticality', 'reject'), ('Extension', _CellIDPositioning_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RequestedCellIDMeasurements >-----#
    RequestedCellIDMeasurements = CHOICE(name='RequestedCellIDMeasurements', mode=MODE_TYPE)
    _RequestedCellIDMeasurements_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_fdd_roundTripTimeInfoWanted = BOOL(name='roundTripTimeInfoWanted', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_fdd_pathlossWanted = BOOL(name='pathlossWanted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_fdd_roundTripTimeInfoWithType1Wanted = BOOL(name='roundTripTimeInfoWithType1Wanted', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_fdd_cpichRSCPWanted = BOOL(name='cpichRSCPWanted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_fdd_cpicEcNoWanted = BOOL(name='cpicEcNoWanted', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_fdd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___RequestedCellIDMeasurements_fdd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__id._const_tab = _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__id_tab
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__id._const_tab_at = None
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__id._const_tab_id = 'id'
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__criticality._const_tab = _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__criticality_tab
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__extensionValue._const_tab = _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__extensionValue_tab
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___RequestedCellIDMeasurements_fdd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__id),
        ('criticality', ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__criticality),
        ('extensionValue', ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__extensionValue),
        ])
    ___RequestedCellIDMeasurements_fdd_iE_Extensions__item_._ext = None
    __RequestedCellIDMeasurements_fdd_iE_Extensions._cont = ___RequestedCellIDMeasurements_fdd_iE_Extensions__item_
    __RequestedCellIDMeasurements_fdd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _RequestedCellIDMeasurements_fdd._cont = ASN1Dict([
        ('roundTripTimeInfoWanted', __RequestedCellIDMeasurements_fdd_roundTripTimeInfoWanted),
        ('pathlossWanted', __RequestedCellIDMeasurements_fdd_pathlossWanted),
        ('roundTripTimeInfoWithType1Wanted', __RequestedCellIDMeasurements_fdd_roundTripTimeInfoWithType1Wanted),
        ('cpichRSCPWanted', __RequestedCellIDMeasurements_fdd_cpichRSCPWanted),
        ('cpicEcNoWanted', __RequestedCellIDMeasurements_fdd_cpicEcNoWanted),
        ('iE-Extensions', __RequestedCellIDMeasurements_fdd_iE_Extensions),
        ])
    _RequestedCellIDMeasurements_fdd._ext = []
    _RequestedCellIDMeasurements_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_tdd_rxTimingDeviationInfoWanted = BOOL(name='rxTimingDeviationInfoWanted', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_tdd_pathlossWanted = BOOL(name='pathlossWanted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_tdd_rxTimingDeviationLCRInfoWanted = BOOL(name='rxTimingDeviationLCRInfoWanted', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_tdd_rxTimingDeviation768InfoWanted = BOOL(name='rxTimingDeviation768InfoWanted', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_tdd_rxTimingDeviation384extInfoWanted = BOOL(name='rxTimingDeviation384extInfoWanted', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_tdd_angleOfArrivalLCRWanted = BOOL(name='angleOfArrivalLCRWanted', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_tdd_timingAdvanceLCRWanted = BOOL(name='timingAdvanceLCRWanted', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __RequestedCellIDMeasurements_tdd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___RequestedCellIDMeasurements_tdd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__id._const_tab = _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__id_tab
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__id._const_tab_at = None
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__id._const_tab_id = 'id'
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__criticality._const_tab = _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__criticality_tab
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__extensionValue._const_tab = _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__extensionValue_tab
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___RequestedCellIDMeasurements_tdd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__id),
        ('criticality', ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__criticality),
        ('extensionValue', ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__extensionValue),
        ])
    ___RequestedCellIDMeasurements_tdd_iE_Extensions__item_._ext = None
    __RequestedCellIDMeasurements_tdd_iE_Extensions._cont = ___RequestedCellIDMeasurements_tdd_iE_Extensions__item_
    __RequestedCellIDMeasurements_tdd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _RequestedCellIDMeasurements_tdd._cont = ASN1Dict([
        ('rxTimingDeviationInfoWanted', __RequestedCellIDMeasurements_tdd_rxTimingDeviationInfoWanted),
        ('pathlossWanted', __RequestedCellIDMeasurements_tdd_pathlossWanted),
        ('rxTimingDeviationLCRInfoWanted', __RequestedCellIDMeasurements_tdd_rxTimingDeviationLCRInfoWanted),
        ('rxTimingDeviation768InfoWanted', __RequestedCellIDMeasurements_tdd_rxTimingDeviation768InfoWanted),
        ('rxTimingDeviation384extInfoWanted', __RequestedCellIDMeasurements_tdd_rxTimingDeviation384extInfoWanted),
        ('angleOfArrivalLCRWanted', __RequestedCellIDMeasurements_tdd_angleOfArrivalLCRWanted),
        ('timingAdvanceLCRWanted', __RequestedCellIDMeasurements_tdd_timingAdvanceLCRWanted),
        ('iE-Extensions', __RequestedCellIDMeasurements_tdd_iE_Extensions),
        ])
    _RequestedCellIDMeasurements_tdd._ext = []
    RequestedCellIDMeasurements._cont = ASN1Dict([
        ('fdd', _RequestedCellIDMeasurements_fdd),
        ('tdd', _RequestedCellIDMeasurements_tdd),
        ])
    RequestedCellIDMeasurements._ext = []
    
    #-----< RequestedCellIDMeasurementsFDD-ExtIEs >-----#
    RequestedCellIDMeasurementsFDD_ExtIEs = CLASS(name='RequestedCellIDMeasurementsFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RequestedCellIDMeasurementsFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedCellIDMeasurementsTDD-ExtIEs >-----#
    RequestedCellIDMeasurementsTDD_ExtIEs = CLASS(name='RequestedCellIDMeasurementsTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RequestedCellIDMeasurementsTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedCellIDGERANMeasurements >-----#
    RequestedCellIDGERANMeasurements = SEQ(name='RequestedCellIDGERANMeasurements', mode=MODE_TYPE)
    _RequestedCellIDGERANMeasurements_rSSIMeasurementsWanted = BOOL(name='rSSIMeasurementsWanted', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedCellIDGERANMeasurements_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedCellIDGERANMeasurements_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedCellIDGERANMeasurements_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RequestedCellIDGERANMeasurements_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__id._const_tab = ____RequestedCellIDGERANMeasurements_iE_Extensions__item__id_tab
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__id._const_tab_at = None
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RequestedCellIDGERANMeasurements_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RequestedCellIDGERANMeasurements_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__criticality._const_tab = ____RequestedCellIDGERANMeasurements_iE_Extensions__item__criticality_tab
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RequestedCellIDGERANMeasurements_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RequestedCellIDGERANMeasurements_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__extensionValue._const_tab = ____RequestedCellIDGERANMeasurements_iE_Extensions__item__extensionValue_tab
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedCellIDGERANMeasurements_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedCellIDGERANMeasurements_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedCellIDGERANMeasurements_iE_Extensions__item__id),
        ('criticality', ___RequestedCellIDGERANMeasurements_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedCellIDGERANMeasurements_iE_Extensions__item__extensionValue),
        ])
    __RequestedCellIDGERANMeasurements_iE_Extensions__item_._ext = None
    _RequestedCellIDGERANMeasurements_iE_Extensions._cont = __RequestedCellIDGERANMeasurements_iE_Extensions__item_
    _RequestedCellIDGERANMeasurements_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedCellIDGERANMeasurements._cont = ASN1Dict([
        ('rSSIMeasurementsWanted', _RequestedCellIDGERANMeasurements_rSSIMeasurementsWanted),
        ('iE-Extensions', _RequestedCellIDGERANMeasurements_iE_Extensions),
        ])
    RequestedCellIDGERANMeasurements._ext = []
    
    #-----< RequestedCellIDGERANMeasurements-ExtIEs >-----#
    RequestedCellIDGERANMeasurements_ExtIEs = CLASS(name='RequestedCellIDGERANMeasurements-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RequestedCellIDGERANMeasurements_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ClientType >-----#
    ClientType = ENUM(name='ClientType', mode=MODE_TYPE)
    ClientType._cont = ASN1Dict([('emergency-services', 0), ('value-added-services', 1), ('plmn-operator-services', 2), ('lawful-intercept-services', 3), ('plmn-operator-broadcast-services', 4), ('plmn-operator-oam', 5), ('plmn-operator-anonymous-statistics', 6), ('plmn-operator-target-ms-service-support', 7)])
    ClientType._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_transactionID = CHOICE(name='transactionID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'TransactionID')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('transactionID', _CriticalityDiagnostics_transactionID),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__repetitionNumber = INT(name='repetitionNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnosticsRepetition')), opt=True)
    __CriticalityDiagnostics_IE_List__item__messageStructure = SEQ_OF(name='messageStructure', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MessageStructure')), opt=True)
    __CriticalityDiagnostics_IE_List__item__typeOfError = ENUM(name='typeOfError', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TypeOfError')))
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        ('criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        ('iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        ('iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        ('repetitionNumber', __CriticalityDiagnostics_IE_List__item__repetitionNumber),
        ('messageStructure', __CriticalityDiagnostics_IE_List__item__messageStructure),
        ('typeOfError', __CriticalityDiagnostics_IE_List__item__typeOfError),
        ('iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnosticsRepetition >-----#
    CriticalityDiagnosticsRepetition = INT(name='CriticalityDiagnosticsRepetition', mode=MODE_TYPE)
    CriticalityDiagnosticsRepetition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    #-----< DGPSCorrections >-----#
    DGPSCorrections = SEQ(name='DGPSCorrections', mode=MODE_TYPE)
    _DGPSCorrections_gps_TOW_sec = INT(name='gps-TOW-sec', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGPSCorrections_gps_TOW_sec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=604799)], ev=None, er=[])
    _DGPSCorrections_statusHealth = ENUM(name='statusHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DiffCorrectionStatus')))
    _DGPSCorrections_dgps_CorrectionSatInfoList = SEQ_OF(name='dgps-CorrectionSatInfoList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DGPS-CorrectionSatInfoList')), opt=True)
    _DGPSCorrections_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGPSCorrections_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DGPSCorrections_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGPSCorrections_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGPSCorrections_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSCorrections_iE_Extensions__item__id._const_tab = ____DGPSCorrections_iE_Extensions__item__id_tab
    ___DGPSCorrections_iE_Extensions__item__id._const_tab_at = None
    ___DGPSCorrections_iE_Extensions__item__id._const_tab_id = 'id'
    ___DGPSCorrections_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DGPSCorrections_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGPSCorrections_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSCorrections_iE_Extensions__item__criticality._const_tab = ____DGPSCorrections_iE_Extensions__item__criticality_tab
    ___DGPSCorrections_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGPSCorrections_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGPSCorrections_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DGPSCorrections_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGPSCorrections_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGPSCorrections_iE_Extensions__item__extensionValue._const_tab = ____DGPSCorrections_iE_Extensions__item__extensionValue_tab
    ___DGPSCorrections_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGPSCorrections_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGPSCorrections_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGPSCorrections_iE_Extensions__item__id),
        ('criticality', ___DGPSCorrections_iE_Extensions__item__criticality),
        ('extensionValue', ___DGPSCorrections_iE_Extensions__item__extensionValue),
        ])
    __DGPSCorrections_iE_Extensions__item_._ext = None
    _DGPSCorrections_iE_Extensions._cont = __DGPSCorrections_iE_Extensions__item_
    _DGPSCorrections_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGPSCorrections._cont = ASN1Dict([
        ('gps-TOW-sec', _DGPSCorrections_gps_TOW_sec),
        ('statusHealth', _DGPSCorrections_statusHealth),
        ('dgps-CorrectionSatInfoList', _DGPSCorrections_dgps_CorrectionSatInfoList),
        ('iE-Extensions', _DGPSCorrections_iE_Extensions),
        ])
    DGPSCorrections._ext = []
    
    #-----< DGPSCorrections-ExtIEs >-----#
    DGPSCorrections_ExtIEs = CLASS(name='DGPSCorrections-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DGPSCorrections_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DiffCorrectionStatus >-----#
    DiffCorrectionStatus = ENUM(name='DiffCorrectionStatus', mode=MODE_TYPE)
    DiffCorrectionStatus._cont = ASN1Dict([('udre-1-0', 0), ('udre-0-75', 1), ('udre-0-5', 2), ('udre-0-3', 3), ('udre-0-2', 4), ('udre-0-1', 5), ('noData', 6), ('invalidData', 7)])
    DiffCorrectionStatus._ext = None
    
    #-----< DGPS-CorrectionSatInfoList >-----#
    DGPS_CorrectionSatInfoList = SEQ_OF(name='DGPS-CorrectionSatInfoList', mode=MODE_TYPE)
    _DGPS_CorrectionSatInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DGPS-CorrectionSatInfo')))
    DGPS_CorrectionSatInfoList._cont = _DGPS_CorrectionSatInfoList__item_
    DGPS_CorrectionSatInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< DGPS-CorrectionSatInfo >-----#
    DGPS_CorrectionSatInfo = SEQ(name='DGPS-CorrectionSatInfo', mode=MODE_TYPE)
    _DGPS_CorrectionSatInfo_satID = INT(name='satID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGPS_CorrectionSatInfo_satID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _DGPS_CorrectionSatInfo_iode = INT(name='iode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGPS_CorrectionSatInfo_iode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _DGPS_CorrectionSatInfo_udre = ENUM(name='udre', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UDRE')))
    _DGPS_CorrectionSatInfo_prc = INT(name='prc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PRC')))
    _DGPS_CorrectionSatInfo_rrc = INT(name='rrc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RRC')))
    _DGPS_CorrectionSatInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGPS_CorrectionSatInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGPS_CorrectionSatInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____DGPS_CorrectionSatInfo_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DGNSS-ValidityPeriod')))
    ____DGPS_CorrectionSatInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 118), ('criticality', 'ignore'), ('Extension', _____DGPS_CorrectionSatInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__id._const_tab = ____DGPS_CorrectionSatInfo_iE_Extensions__item__id_tab
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__id._const_tab_at = None
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__criticality._const_tab = ____DGPS_CorrectionSatInfo_iE_Extensions__item__id_tab
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__extensionValue._const_tab = ____DGPS_CorrectionSatInfo_iE_Extensions__item__id_tab
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGPS_CorrectionSatInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGPS_CorrectionSatInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGPS_CorrectionSatInfo_iE_Extensions__item__id),
        ('criticality', ___DGPS_CorrectionSatInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___DGPS_CorrectionSatInfo_iE_Extensions__item__extensionValue),
        ])
    __DGPS_CorrectionSatInfo_iE_Extensions__item_._ext = None
    _DGPS_CorrectionSatInfo_iE_Extensions._cont = __DGPS_CorrectionSatInfo_iE_Extensions__item_
    _DGPS_CorrectionSatInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGPS_CorrectionSatInfo._cont = ASN1Dict([
        ('satID', _DGPS_CorrectionSatInfo_satID),
        ('iode', _DGPS_CorrectionSatInfo_iode),
        ('udre', _DGPS_CorrectionSatInfo_udre),
        ('prc', _DGPS_CorrectionSatInfo_prc),
        ('rrc', _DGPS_CorrectionSatInfo_rrc),
        ('iE-Extensions', _DGPS_CorrectionSatInfo_iE_Extensions),
        ])
    DGPS_CorrectionSatInfo._ext = []
    
    #-----< DGPS-CorrectionSatInfo-ExtIEs >-----#
    DGPS_CorrectionSatInfo_ExtIEs = CLASS(name='DGPS-CorrectionSatInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _DGPS_CorrectionSatInfo_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DGNSS-ValidityPeriod')))
    DGPS_CorrectionSatInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 118), ('criticality', 'ignore'), ('Extension', _DGPS_CorrectionSatInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DGNSS-ValidityPeriod >-----#
    DGNSS_ValidityPeriod = SEQ(name='DGNSS-ValidityPeriod', mode=MODE_TYPE)
    _DGNSS_ValidityPeriod_udreGrowthRate = ENUM(name='udreGrowthRate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UDREGrowthRate')))
    _DGNSS_ValidityPeriod_udreValidityTime = ENUM(name='udreValidityTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UDREValidityTime')))
    _DGNSS_ValidityPeriod_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGNSS_ValidityPeriod_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id._const_tab = ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id._const_tab_at = None
    ___DGNSS_ValidityPeriod_iE_Extensions__item__id._const_tab_id = 'id'
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality._const_tab = ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue._const_tab = ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGNSS_ValidityPeriod_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGNSS_ValidityPeriod_iE_Extensions__item__id),
        ('criticality', ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality),
        ('extensionValue', ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue),
        ])
    __DGNSS_ValidityPeriod_iE_Extensions__item_._ext = None
    _DGNSS_ValidityPeriod_iE_Extensions._cont = __DGNSS_ValidityPeriod_iE_Extensions__item_
    _DGNSS_ValidityPeriod_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGNSS_ValidityPeriod._cont = ASN1Dict([
        ('udreGrowthRate', _DGNSS_ValidityPeriod_udreGrowthRate),
        ('udreValidityTime', _DGNSS_ValidityPeriod_udreValidityTime),
        ('iE-Extensions', _DGNSS_ValidityPeriod_iE_Extensions),
        ])
    DGNSS_ValidityPeriod._ext = []
    
    #-----< DGNSS-ValidityPeriod-ExtIEs >-----#
    DGNSS_ValidityPeriod_ExtIEs = CLASS(name='DGNSS-ValidityPeriod-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DGNSS_ValidityPeriod_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UDRE >-----#
    UDRE = ENUM(name='UDRE', mode=MODE_TYPE)
    UDRE._cont = ASN1Dict([('lessThan1', 0), ('between1-and-4', 1), ('between4-and-8', 2), ('over8', 3)])
    UDRE._ext = None
    
    #-----< UDREGrowthRate >-----#
    UDREGrowthRate = ENUM(name='UDREGrowthRate', mode=MODE_TYPE)
    UDREGrowthRate._cont = ASN1Dict([('growth-1-point-5', 0), ('growth-2', 1), ('growth-4', 2), ('growth-6', 3), ('growth-8', 4), ('growth-10', 5), ('growth-12', 6), ('growth-16', 7)])
    UDREGrowthRate._ext = None
    
    #-----< UDREValidityTime >-----#
    UDREValidityTime = ENUM(name='UDREValidityTime', mode=MODE_TYPE)
    UDREValidityTime._cont = ASN1Dict([('val-20sec', 0), ('val-40sec', 1), ('val-80sec', 2), ('val-160sec', 3), ('val-320sec', 4), ('val-640sec', 5), ('val-1280sec', 6), ('val-2560sec', 7)])
    UDREValidityTime._ext = None
    
    #-----< PRC >-----#
    PRC = INT(name='PRC', mode=MODE_TYPE)
    PRC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2047, ub=2047)], ev=None, er=[])
    
    #-----< RRC >-----#
    RRC = INT(name='RRC', mode=MODE_TYPE)
    RRC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=127)], ev=None, er=[])
    
    #-----< IMEI >-----#
    IMEI = OCT_STR(name='IMEI', mode=MODE_TYPE)
    IMEI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name='IMSI', mode=MODE_TYPE)
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< UE-PositionEstimate >-----#
    UE_PositionEstimate = CHOICE(name='UE-PositionEstimate', mode=MODE_TYPE)
    _UE_PositionEstimate_point = SEQ(name='point', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-Point')))
    _UE_PositionEstimate_pointWithUnCertainty = SEQ(name='pointWithUnCertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-PointWithUnCertainty')))
    _UE_PositionEstimate_polygon = SEQ_OF(name='polygon', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-Polygon')))
    _UE_PositionEstimate_pointWithUncertaintyEllipse = SEQ(name='pointWithUncertaintyEllipse', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-PointWithUnCertaintyEllipse')))
    _UE_PositionEstimate_pointWithAltitude = SEQ(name='pointWithAltitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-PointWithAltitude')))
    _UE_PositionEstimate_pointWithAltitudeAndUncertaintyEllipsoid = SEQ(name='pointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-PointWithAltitudeAndUncertaintyEllipsoid')))
    _UE_PositionEstimate_ellipsoidArc = SEQ(name='ellipsoidArc', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-EllipsoidArc')))
    UE_PositionEstimate._cont = ASN1Dict([
        ('point', _UE_PositionEstimate_point),
        ('pointWithUnCertainty', _UE_PositionEstimate_pointWithUnCertainty),
        ('polygon', _UE_PositionEstimate_polygon),
        ('pointWithUncertaintyEllipse', _UE_PositionEstimate_pointWithUncertaintyEllipse),
        ('pointWithAltitude', _UE_PositionEstimate_pointWithAltitude),
        ('pointWithAltitudeAndUncertaintyEllipsoid', _UE_PositionEstimate_pointWithAltitudeAndUncertaintyEllipsoid),
        ('ellipsoidArc', _UE_PositionEstimate_ellipsoidArc),
        ])
    UE_PositionEstimate._ext = []
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name='GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _GeographicalCoordinates_latitudeSign._ext = None
    _GeographicalCoordinates_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeographicalCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GeographicalCoordinates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeographicalCoordinates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab = ____GeographicalCoordinates_iE_Extensions__item__criticality_tab
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab = ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeographicalCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeographicalCoordinates_iE_Extensions__item__id),
        ('criticality', ___GeographicalCoordinates_iE_Extensions__item__criticality),
        ('extensionValue', ___GeographicalCoordinates_iE_Extensions__item__extensionValue),
        ])
    __GeographicalCoordinates_iE_Extensions__item_._ext = None
    _GeographicalCoordinates_iE_Extensions._cont = __GeographicalCoordinates_iE_Extensions__item_
    _GeographicalCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        ('latitudeSign', _GeographicalCoordinates_latitudeSign),
        ('latitude', _GeographicalCoordinates_latitude),
        ('longitude', _GeographicalCoordinates_longitude),
        ('iE-Extensions', _GeographicalCoordinates_iE_Extensions),
        ])
    GeographicalCoordinates._ext = []
    
    #-----< GeographicalCoordinates-ExtIEs >-----#
    GeographicalCoordinates_ExtIEs = CLASS(name='GeographicalCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GeographicalCoordinates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-AltitudeAndDirection >-----#
    GA_AltitudeAndDirection = SEQ(name='GA-AltitudeAndDirection', mode=MODE_TYPE)
    _GA_AltitudeAndDirection_directionOfAltitude = ENUM(name='directionOfAltitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_AltitudeAndDirection_directionOfAltitude._cont = ASN1Dict([('height', 0), ('depth', 1)])
    _GA_AltitudeAndDirection_directionOfAltitude._ext = None
    _GA_AltitudeAndDirection_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_AltitudeAndDirection_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    GA_AltitudeAndDirection._cont = ASN1Dict([
        ('directionOfAltitude', _GA_AltitudeAndDirection_directionOfAltitude),
        ('altitude', _GA_AltitudeAndDirection_altitude),
        ])
    GA_AltitudeAndDirection._ext = []
    
    #-----< GA-EllipsoidArc >-----#
    GA_EllipsoidArc = SEQ(name='GA-EllipsoidArc', mode=MODE_TYPE)
    _GA_EllipsoidArc_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GeographicalCoordinates')))
    _GA_EllipsoidArc_innerRadius = INT(name='innerRadius', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_innerRadius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GA_EllipsoidArc_uncertaintyRadius = INT(name='uncertaintyRadius', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_uncertaintyRadius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_EllipsoidArc_offsetAngle = INT(name='offsetAngle', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_offsetAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _GA_EllipsoidArc_includedAngle = INT(name='includedAngle', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_includedAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _GA_EllipsoidArc_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _GA_EllipsoidArc_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_EllipsoidArc_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GA_EllipsoidArc_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_EllipsoidArc_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__id_tab
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab_at = None
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_EllipsoidArc_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_EllipsoidArc_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_EllipsoidArc_iE_Extensions__item__id),
        ('criticality', ___GA_EllipsoidArc_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_EllipsoidArc_iE_Extensions__item__extensionValue),
        ])
    __GA_EllipsoidArc_iE_Extensions__item_._ext = None
    _GA_EllipsoidArc_iE_Extensions._cont = __GA_EllipsoidArc_iE_Extensions__item_
    _GA_EllipsoidArc_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_EllipsoidArc._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_EllipsoidArc_geographicalCoordinates),
        ('innerRadius', _GA_EllipsoidArc_innerRadius),
        ('uncertaintyRadius', _GA_EllipsoidArc_uncertaintyRadius),
        ('offsetAngle', _GA_EllipsoidArc_offsetAngle),
        ('includedAngle', _GA_EllipsoidArc_includedAngle),
        ('confidence', _GA_EllipsoidArc_confidence),
        ('iE-Extensions', _GA_EllipsoidArc_iE_Extensions),
        ])
    GA_EllipsoidArc._ext = []
    
    #-----< GA-EllipsoidArc-ExtIEs >-----#
    GA_EllipsoidArc_ExtIEs = CLASS(name='GA-EllipsoidArc-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GA_EllipsoidArc_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-Point >-----#
    GA_Point = SEQ(name='GA-Point', mode=MODE_TYPE)
    _GA_Point_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GeographicalCoordinates')))
    _GA_Point_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_Point_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GA_Point_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_Point_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_Point_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_Point_iE_Extensions__item__id._const_tab = ____GA_Point_iE_Extensions__item__id_tab
    ___GA_Point_iE_Extensions__item__id._const_tab_at = None
    ___GA_Point_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_Point_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_Point_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_Point_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_Point_iE_Extensions__item__criticality._const_tab = ____GA_Point_iE_Extensions__item__criticality_tab
    ___GA_Point_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_Point_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_Point_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_Point_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_Point_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_Point_iE_Extensions__item__extensionValue._const_tab = ____GA_Point_iE_Extensions__item__extensionValue_tab
    ___GA_Point_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_Point_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_Point_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_Point_iE_Extensions__item__id),
        ('criticality', ___GA_Point_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_Point_iE_Extensions__item__extensionValue),
        ])
    __GA_Point_iE_Extensions__item_._ext = None
    _GA_Point_iE_Extensions._cont = __GA_Point_iE_Extensions__item_
    _GA_Point_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_Point._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_Point_geographicalCoordinates),
        ('iE-Extensions', _GA_Point_iE_Extensions),
        ])
    GA_Point._ext = []
    
    #-----< GA-Point-ExtIEs >-----#
    GA_Point_ExtIEs = CLASS(name='GA-Point-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GA_Point_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithAltitude >-----#
    GA_PointWithAltitude = SEQ(name='GA-PointWithAltitude', mode=MODE_TYPE)
    _GA_PointWithAltitude_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithAltitude_altitudeAndDirection = SEQ(name='altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-AltitudeAndDirection')))
    _GA_PointWithAltitude_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithAltitude_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithAltitude_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_PointWithAltitude_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__id_tab
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_PointWithAltitude_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_PointWithAltitude_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_PointWithAltitude_iE_Extensions__item__id),
        ('criticality', ___GA_PointWithAltitude_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_PointWithAltitude_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithAltitude_iE_Extensions__item_._ext = None
    _GA_PointWithAltitude_iE_Extensions._cont = __GA_PointWithAltitude_iE_Extensions__item_
    _GA_PointWithAltitude_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithAltitude._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_PointWithAltitude_geographicalCoordinates),
        ('altitudeAndDirection', _GA_PointWithAltitude_altitudeAndDirection),
        ('iE-Extensions', _GA_PointWithAltitude_iE_Extensions),
        ])
    GA_PointWithAltitude._ext = []
    
    #-----< GA-PointWithAltitude-ExtIEs >-----#
    GA_PointWithAltitude_ExtIEs = CLASS(name='GA-PointWithAltitude-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GA_PointWithAltitude_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithAltitudeAndUncertaintyEllipsoid >-----#
    GA_PointWithAltitudeAndUncertaintyEllipsoid = SEQ(name='GA-PointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE)
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection = SEQ(name='altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-AltitudeAndDirection')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse = SEQ(name='uncertaintyEllipse', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-UncertaintyEllipse')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude = INT(name='uncertaintyAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id),
        ('criticality', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_._ext = None
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions._cont = __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithAltitudeAndUncertaintyEllipsoid._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates),
        ('altitudeAndDirection', _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection),
        ('uncertaintyEllipse', _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse),
        ('uncertaintyAltitude', _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude),
        ('confidence', _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence),
        ('iE-Extensions', _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions),
        ])
    GA_PointWithAltitudeAndUncertaintyEllipsoid._ext = []
    
    #-----< GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs >-----#
    GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs = CLASS(name='GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithUnCertainty >-----#
    GA_PointWithUnCertainty = SEQ(name='GA-PointWithUnCertainty', mode=MODE_TYPE)
    _GA_PointWithUnCertainty_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithUnCertainty_uncertaintyCode = INT(name='uncertaintyCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithUnCertainty_uncertaintyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithUnCertainty_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithUnCertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithUnCertainty_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_PointWithUnCertainty_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_PointWithUnCertainty_iE_Extensions__item__id),
        ('criticality', ___GA_PointWithUnCertainty_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithUnCertainty_iE_Extensions__item_._ext = None
    _GA_PointWithUnCertainty_iE_Extensions._cont = __GA_PointWithUnCertainty_iE_Extensions__item_
    _GA_PointWithUnCertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithUnCertainty._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_PointWithUnCertainty_geographicalCoordinates),
        ('uncertaintyCode', _GA_PointWithUnCertainty_uncertaintyCode),
        ('iE-Extensions', _GA_PointWithUnCertainty_iE_Extensions),
        ])
    GA_PointWithUnCertainty._ext = []
    
    #-----< GA-PointWithUnCertainty-ExtIEs >-----#
    GA_PointWithUnCertainty_ExtIEs = CLASS(name='GA-PointWithUnCertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GA_PointWithUnCertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithUnCertaintyEllipse >-----#
    GA_PointWithUnCertaintyEllipse = SEQ(name='GA-PointWithUnCertaintyEllipse', mode=MODE_TYPE)
    _GA_PointWithUnCertaintyEllipse_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse = SEQ(name='uncertaintyEllipse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-UncertaintyEllipse')))
    _GA_PointWithUnCertaintyEllipse_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithUnCertaintyEllipse_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _GA_PointWithUnCertaintyEllipse_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id),
        ('criticality', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_._ext = None
    _GA_PointWithUnCertaintyEllipse_iE_Extensions._cont = __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_
    _GA_PointWithUnCertaintyEllipse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithUnCertaintyEllipse._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_PointWithUnCertaintyEllipse_geographicalCoordinates),
        ('uncertaintyEllipse', _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse),
        ('confidence', _GA_PointWithUnCertaintyEllipse_confidence),
        ('iE-Extensions', _GA_PointWithUnCertaintyEllipse_iE_Extensions),
        ])
    GA_PointWithUnCertaintyEllipse._ext = []
    
    #-----< GA-PointWithUnCertaintyEllipse-ExtIEs >-----#
    GA_PointWithUnCertaintyEllipse_ExtIEs = CLASS(name='GA-PointWithUnCertaintyEllipse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GA_PointWithUnCertaintyEllipse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-Polygon >-----#
    GA_Polygon = SEQ_OF(name='GA-Polygon', mode=MODE_TYPE)
    _GA_Polygon__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GA_Polygon__item__geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GeographicalCoordinates')))
    __GA_Polygon__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GA_Polygon__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____GA_Polygon__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____GA_Polygon__item__iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GA_Polygon__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Polygon__item__iE_Extensions__item__id._const_tab = _____GA_Polygon__item__iE_Extensions__item__id_tab
    ____GA_Polygon__item__iE_Extensions__item__id._const_tab_at = None
    ____GA_Polygon__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____GA_Polygon__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____GA_Polygon__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GA_Polygon__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Polygon__item__iE_Extensions__item__criticality._const_tab = _____GA_Polygon__item__iE_Extensions__item__criticality_tab
    ____GA_Polygon__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____GA_Polygon__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____GA_Polygon__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Polygon__item__iE_Extensions__item__extensionValue._const_tab = _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab
    ____GA_Polygon__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____GA_Polygon__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___GA_Polygon__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____GA_Polygon__item__iE_Extensions__item__id),
        ('criticality', ____GA_Polygon__item__iE_Extensions__item__criticality),
        ('extensionValue', ____GA_Polygon__item__iE_Extensions__item__extensionValue),
        ])
    ___GA_Polygon__item__iE_Extensions__item_._ext = None
    __GA_Polygon__item__iE_Extensions._cont = ___GA_Polygon__item__iE_Extensions__item_
    __GA_Polygon__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GA_Polygon__item_._cont = ASN1Dict([
        ('geographicalCoordinates', __GA_Polygon__item__geographicalCoordinates),
        ('iE-Extensions', __GA_Polygon__item__iE_Extensions),
        ])
    _GA_Polygon__item_._ext = []
    GA_Polygon._cont = _GA_Polygon__item_
    GA_Polygon._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< GA-Polygon-ExtIEs >-----#
    GA_Polygon_ExtIEs = CLASS(name='GA-Polygon-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GA_Polygon_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-UncertaintyEllipse >-----#
    GA_UncertaintyEllipse = SEQ(name='GA-UncertaintyEllipse', mode=MODE_TYPE)
    _GA_UncertaintyEllipse_uncertaintySemi_major = INT(name='uncertaintySemi-major', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_UncertaintyEllipse_uncertaintySemi_minor = INT(name='uncertaintySemi-minor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_UncertaintyEllipse_orientationOfMajorAxis = INT(name='orientationOfMajorAxis', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=89)], ev=None, er=[])
    GA_UncertaintyEllipse._cont = ASN1Dict([
        ('uncertaintySemi-major', _GA_UncertaintyEllipse_uncertaintySemi_major),
        ('uncertaintySemi-minor', _GA_UncertaintyEllipse_uncertaintySemi_minor),
        ('orientationOfMajorAxis', _GA_UncertaintyEllipse_orientationOfMajorAxis),
        ])
    GA_UncertaintyEllipse._ext = []
    
    #-----< UE-PositionEstimateInfo >-----#
    UE_PositionEstimateInfo = SEQ(name='UE-PositionEstimateInfo', mode=MODE_TYPE)
    _UE_PositionEstimateInfo_referenceTimeChoice = CHOICE(name='referenceTimeChoice', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'ReferenceTimeChoice')))
    _UE_PositionEstimateInfo_ue_positionEstimate = CHOICE(name='ue-positionEstimate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _UE_PositionEstimateInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_PositionEstimateInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UE_PositionEstimateInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_PositionEstimateInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UE_PositionEstimateInfo_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPSReferenceTimeUncertainty')))
    _____UE_PositionEstimateInfo_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositionDataUEbased')))
    ____UE_PositionEstimateInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'ignore'), ('Extension', _____UE_PositionEstimateInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'ignore'), ('Extension', _____UE_PositionEstimateInfo_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UE_PositionEstimateInfo_iE_Extensions__item__id._const_tab = ____UE_PositionEstimateInfo_iE_Extensions__item__id_tab
    ___UE_PositionEstimateInfo_iE_Extensions__item__id._const_tab_at = None
    ___UE_PositionEstimateInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_PositionEstimateInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UE_PositionEstimateInfo_iE_Extensions__item__criticality._const_tab = ____UE_PositionEstimateInfo_iE_Extensions__item__id_tab
    ___UE_PositionEstimateInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_PositionEstimateInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_PositionEstimateInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UE_PositionEstimateInfo_iE_Extensions__item__extensionValue._const_tab = ____UE_PositionEstimateInfo_iE_Extensions__item__id_tab
    ___UE_PositionEstimateInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_PositionEstimateInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_PositionEstimateInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_PositionEstimateInfo_iE_Extensions__item__id),
        ('criticality', ___UE_PositionEstimateInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_PositionEstimateInfo_iE_Extensions__item__extensionValue),
        ])
    __UE_PositionEstimateInfo_iE_Extensions__item_._ext = None
    _UE_PositionEstimateInfo_iE_Extensions._cont = __UE_PositionEstimateInfo_iE_Extensions__item_
    _UE_PositionEstimateInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_PositionEstimateInfo._cont = ASN1Dict([
        ('referenceTimeChoice', _UE_PositionEstimateInfo_referenceTimeChoice),
        ('ue-positionEstimate', _UE_PositionEstimateInfo_ue_positionEstimate),
        ('iE-Extensions', _UE_PositionEstimateInfo_iE_Extensions),
        ])
    UE_PositionEstimateInfo._ext = []
    
    #-----< UE-PositionEstimateInfo-ExtIEs >-----#
    UE_PositionEstimateInfo_ExtIEs = CLASS(name='UE-PositionEstimateInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _UE_PositionEstimateInfo_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPSReferenceTimeUncertainty')))
    _UE_PositionEstimateInfo_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositionDataUEbased')))
    UE_PositionEstimateInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 85), ('criticality', 'ignore'), ('Extension', _UE_PositionEstimateInfo_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 98), ('criticality', 'ignore'), ('Extension', _UE_PositionEstimateInfo_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ReferenceTimeChoice >-----#
    ReferenceTimeChoice = CHOICE(name='ReferenceTimeChoice', mode=MODE_TYPE)
    _ReferenceTimeChoice_utran_GPSReferenceTimeResult = SEQ(name='utran-GPSReferenceTimeResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GPSReferenceTimeResult')))
    _ReferenceTimeChoice_gps_ReferenceTimeOnly = INT(name='gps-ReferenceTimeOnly', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReferenceTimeChoice_gps_ReferenceTimeOnly._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=604799999)], ev=[], er=[])
    _ReferenceTimeChoice_cell_Timing = SEQ(name='cell-Timing', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Cell-Timing')))
    _ReferenceTimeChoice_extension_ReferenceTimeChoice = SEQ(name='extension-ReferenceTimeChoice', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Extension-ReferenceTimeChoice')))
    ReferenceTimeChoice._cont = ASN1Dict([
        ('utran-GPSReferenceTimeResult', _ReferenceTimeChoice_utran_GPSReferenceTimeResult),
        ('gps-ReferenceTimeOnly', _ReferenceTimeChoice_gps_ReferenceTimeOnly),
        ('cell-Timing', _ReferenceTimeChoice_cell_Timing),
        ('extension-ReferenceTimeChoice', _ReferenceTimeChoice_extension_ReferenceTimeChoice),
        ])
    ReferenceTimeChoice._ext = ['extension-ReferenceTimeChoice']
    
    #-----< Extension-ReferenceTimeChoice >-----#
    Extension_ReferenceTimeChoice = SEQ(name='Extension-ReferenceTimeChoice', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_ReferenceTimeChoice_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    __Extension_ReferenceTimeChoice_id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    ___Extension_ReferenceTimeChoice_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GANSSReferenceTimeResult')))
    ___Extension_ReferenceTimeChoice_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Reference-Time-Only')))
    __Extension_ReferenceTimeChoice_id_tab._val = ASN1Set(rv=[dict([('id', 114), ('criticality', 'ignore'), ('Value', ___Extension_ReferenceTimeChoice_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 115), ('criticality', 'ignore'), ('Value', ___Extension_ReferenceTimeChoice_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_ReferenceTimeChoice_id._const_tab = __Extension_ReferenceTimeChoice_id_tab
    _Extension_ReferenceTimeChoice_id._const_tab_at = None
    _Extension_ReferenceTimeChoice_id._const_tab_id = 'id'
    _Extension_ReferenceTimeChoice_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    _Extension_ReferenceTimeChoice_criticality._const_tab = __Extension_ReferenceTimeChoice_id_tab
    _Extension_ReferenceTimeChoice_criticality._const_tab_at = ('..', 'id')
    _Extension_ReferenceTimeChoice_criticality._const_tab_id = 'criticality'
    _Extension_ReferenceTimeChoice_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    _Extension_ReferenceTimeChoice_value._const_tab = __Extension_ReferenceTimeChoice_id_tab
    _Extension_ReferenceTimeChoice_value._const_tab_at = ('..', 'id')
    _Extension_ReferenceTimeChoice_value._const_tab_id = 'Value'
    Extension_ReferenceTimeChoice._cont = ASN1Dict([
        ('id', _Extension_ReferenceTimeChoice_id),
        ('criticality', _Extension_ReferenceTimeChoice_criticality),
        ('value', _Extension_ReferenceTimeChoice_value),
        ])
    Extension_ReferenceTimeChoice._ext = None
    
    #-----< Extension-ReferenceTimeChoice-IE >-----#
    Extension_ReferenceTimeChoice_IE = CLASS(name='Extension-ReferenceTimeChoice-IE', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _Extension_ReferenceTimeChoice_IE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GANSSReferenceTimeResult')))
    _Extension_ReferenceTimeChoice_IE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Reference-Time-Only')))
    Extension_ReferenceTimeChoice_IE._val = ASN1Set(rv=[dict([('id', 114), ('criticality', 'ignore'), ('Value', _Extension_ReferenceTimeChoice_IE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 115), ('criticality', 'ignore'), ('Value', _Extension_ReferenceTimeChoice_IE_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< Cell-Timing >-----#
    Cell_Timing = SEQ(name='Cell-Timing', mode=MODE_TYPE)
    _Cell_Timing_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Cell_Timing_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _Cell_Timing_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _Cell_Timing_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Cell_Timing_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Cell_Timing_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Cell_Timing_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Cell_Timing_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Timing_iE_Extensions__item__id._const_tab = ____Cell_Timing_iE_Extensions__item__id_tab
    ___Cell_Timing_iE_Extensions__item__id._const_tab_at = None
    ___Cell_Timing_iE_Extensions__item__id._const_tab_id = 'id'
    ___Cell_Timing_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Cell_Timing_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Cell_Timing_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Timing_iE_Extensions__item__criticality._const_tab = ____Cell_Timing_iE_Extensions__item__criticality_tab
    ___Cell_Timing_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Cell_Timing_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Cell_Timing_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Cell_Timing_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Cell_Timing_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Cell_Timing_iE_Extensions__item__extensionValue._const_tab = ____Cell_Timing_iE_Extensions__item__extensionValue_tab
    ___Cell_Timing_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Cell_Timing_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Cell_Timing_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Cell_Timing_iE_Extensions__item__id),
        ('criticality', ___Cell_Timing_iE_Extensions__item__criticality),
        ('extensionValue', ___Cell_Timing_iE_Extensions__item__extensionValue),
        ])
    __Cell_Timing_iE_Extensions__item_._ext = None
    _Cell_Timing_iE_Extensions._cont = __Cell_Timing_iE_Extensions__item_
    _Cell_Timing_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Cell_Timing._cont = ASN1Dict([
        ('sfn', _Cell_Timing_sfn),
        ('uC-ID', _Cell_Timing_uC_ID),
        ('iE-Extensions', _Cell_Timing_iE_Extensions),
        ])
    Cell_Timing._ext = []
    
    #-----< Cell-Timing-ExtIEs >-----#
    Cell_Timing_ExtIEs = CLASS(name='Cell-Timing-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Cell_Timing_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Reference-Time-Only >-----#
    GANSS_Reference_Time_Only = SEQ(name='GANSS-Reference-Time-Only', mode=MODE_TYPE)
    _GANSS_Reference_Time_Only_ganssTODmsec = INT(name='ganssTODmsec', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Reference_Time_Only_ganssTODmsec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599999)], ev=None, er=[])
    _GANSS_Reference_Time_Only_ganssTimeID = SEQ(name='ganssTimeID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    _GANSS_Reference_Time_Only_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Reference_Time_Only_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Reference_Time_Only_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Reference_Time_Only_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Reference_Time_Only_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Reference_Time_Only_iE_Extensions__item__id._const_tab = ____GANSS_Reference_Time_Only_iE_Extensions__item__id_tab
    ___GANSS_Reference_Time_Only_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_Reference_Time_Only_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Reference_Time_Only_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Reference_Time_Only_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Reference_Time_Only_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Reference_Time_Only_iE_Extensions__item__criticality._const_tab = ____GANSS_Reference_Time_Only_iE_Extensions__item__criticality_tab
    ___GANSS_Reference_Time_Only_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Reference_Time_Only_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Reference_Time_Only_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Reference_Time_Only_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Reference_Time_Only_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Reference_Time_Only_iE_Extensions__item__extensionValue._const_tab = ____GANSS_Reference_Time_Only_iE_Extensions__item__extensionValue_tab
    ___GANSS_Reference_Time_Only_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Reference_Time_Only_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Reference_Time_Only_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Reference_Time_Only_iE_Extensions__item__id),
        ('criticality', ___GANSS_Reference_Time_Only_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Reference_Time_Only_iE_Extensions__item__extensionValue),
        ])
    __GANSS_Reference_Time_Only_iE_Extensions__item_._ext = None
    _GANSS_Reference_Time_Only_iE_Extensions._cont = __GANSS_Reference_Time_Only_iE_Extensions__item_
    _GANSS_Reference_Time_Only_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Reference_Time_Only._cont = ASN1Dict([
        ('ganssTODmsec', _GANSS_Reference_Time_Only_ganssTODmsec),
        ('ganssTimeID', _GANSS_Reference_Time_Only_ganssTimeID),
        ('iE-Extensions', _GANSS_Reference_Time_Only_iE_Extensions),
        ])
    GANSS_Reference_Time_Only._ext = []
    
    #-----< GANSS-Reference-Time-Only-ExtIEs >-----#
    GANSS_Reference_Time_Only_ExtIEs = CLASS(name='GANSS-Reference-Time-Only-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_Reference_Time_Only_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositionDataUEbased >-----#
    PositionDataUEbased = SEQ(name='PositionDataUEbased', mode=MODE_TYPE)
    _PositionDataUEbased_positionData = BIT_STR(name='positionData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PositionDataUEbased_positionData._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _PositionDataUEbased_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionDataUEbased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionDataUEbased_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionDataUEbased_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionDataUEbased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionDataUEbased_iE_Extensions__item__id._const_tab = ____PositionDataUEbased_iE_Extensions__item__id_tab
    ___PositionDataUEbased_iE_Extensions__item__id._const_tab_at = None
    ___PositionDataUEbased_iE_Extensions__item__id._const_tab_id = 'id'
    ___PositionDataUEbased_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PositionDataUEbased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionDataUEbased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionDataUEbased_iE_Extensions__item__criticality._const_tab = ____PositionDataUEbased_iE_Extensions__item__criticality_tab
    ___PositionDataUEbased_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionDataUEbased_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PositionDataUEbased_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PositionDataUEbased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionDataUEbased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionDataUEbased_iE_Extensions__item__extensionValue._const_tab = ____PositionDataUEbased_iE_Extensions__item__extensionValue_tab
    ___PositionDataUEbased_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionDataUEbased_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionDataUEbased_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PositionDataUEbased_iE_Extensions__item__id),
        ('criticality', ___PositionDataUEbased_iE_Extensions__item__criticality),
        ('extensionValue', ___PositionDataUEbased_iE_Extensions__item__extensionValue),
        ])
    __PositionDataUEbased_iE_Extensions__item_._ext = None
    _PositionDataUEbased_iE_Extensions._cont = __PositionDataUEbased_iE_Extensions__item_
    _PositionDataUEbased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionDataUEbased._cont = ASN1Dict([
        ('positionData', _PositionDataUEbased_positionData),
        ('iE-Extensions', _PositionDataUEbased_iE_Extensions),
        ])
    PositionDataUEbased._ext = []
    
    #-----< PositionDataUEbased-ExtIEs >-----#
    PositionDataUEbased_ExtIEs = CLASS(name='PositionDataUEbased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PositionDataUEbased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositionData >-----#
    PositionData = SEQ(name='PositionData', mode=MODE_TYPE)
    _PositionData_positioningDataDiscriminator = BIT_STR(name='positioningDataDiscriminator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PositioningDataDiscriminator')))
    _PositionData_positioningDataSet = SEQ_OF(name='positioningDataSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PositioningDataSet')), opt=True)
    _PositionData_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionData_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionData_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionData_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PositionData_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-PositioningDataSet')))
    _____PositionData_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Additional-PositioningDataSet')))
    ____PositionData_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'ignore'), ('Extension', _____PositionData_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 139), ('criticality', 'ignore'), ('Extension', _____PositionData_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionData_iE_Extensions__item__id._const_tab = ____PositionData_iE_Extensions__item__id_tab
    ___PositionData_iE_Extensions__item__id._const_tab_at = None
    ___PositionData_iE_Extensions__item__id._const_tab_id = 'id'
    ___PositionData_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositionData_iE_Extensions__item__criticality._const_tab = ____PositionData_iE_Extensions__item__id_tab
    ___PositionData_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionData_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PositionData_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositionData_iE_Extensions__item__extensionValue._const_tab = ____PositionData_iE_Extensions__item__id_tab
    ___PositionData_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionData_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionData_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PositionData_iE_Extensions__item__id),
        ('criticality', ___PositionData_iE_Extensions__item__criticality),
        ('extensionValue', ___PositionData_iE_Extensions__item__extensionValue),
        ])
    __PositionData_iE_Extensions__item_._ext = None
    _PositionData_iE_Extensions._cont = __PositionData_iE_Extensions__item_
    _PositionData_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionData._cont = ASN1Dict([
        ('positioningDataDiscriminator', _PositionData_positioningDataDiscriminator),
        ('positioningDataSet', _PositionData_positioningDataSet),
        ('iE-Extensions', _PositionData_iE_Extensions),
        ])
    PositionData._ext = []
    
    #-----< PositionData-ExtIEs >-----#
    PositionData_ExtIEs = CLASS(name='PositionData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _PositionData_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-PositioningDataSet')))
    _PositionData_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Additional-PositioningDataSet')))
    PositionData_ExtIEs._val = ASN1Set(rv=[dict([('id', 74), ('criticality', 'ignore'), ('Extension', _PositionData_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 139), ('criticality', 'ignore'), ('Extension', _PositionData_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-PositioningDataSet >-----#
    GANSS_PositioningDataSet = SEQ_OF(name='GANSS-PositioningDataSet', mode=MODE_TYPE)
    _GANSS_PositioningDataSet__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-PositioningMethodAndUsage')))
    GANSS_PositioningDataSet._cont = _GANSS_PositioningDataSet__item_
    GANSS_PositioningDataSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< GANSS-PositioningMethodAndUsage >-----#
    GANSS_PositioningMethodAndUsage = OCT_STR(name='GANSS-PositioningMethodAndUsage', mode=MODE_TYPE)
    GANSS_PositioningMethodAndUsage._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PositioningDataDiscriminator >-----#
    PositioningDataDiscriminator = BIT_STR(name='PositioningDataDiscriminator', mode=MODE_TYPE)
    PositioningDataDiscriminator._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< PositioningDataSet >-----#
    PositioningDataSet = SEQ_OF(name='PositioningDataSet', mode=MODE_TYPE)
    _PositioningDataSet__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositioningMethodAndUsage')))
    PositioningDataSet._cont = _PositioningDataSet__item_
    PositioningDataSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< PositioningMethodAndUsage >-----#
    PositioningMethodAndUsage = OCT_STR(name='PositioningMethodAndUsage', mode=MODE_TYPE)
    PositioningMethodAndUsage._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< Additional-PositioningDataSet >-----#
    Additional_PositioningDataSet = SEQ_OF(name='Additional-PositioningDataSet', mode=MODE_TYPE)
    _Additional_PositioningDataSet__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Additional-PositioningMethodAndUsage')))
    Additional_PositioningDataSet._cont = _Additional_PositioningDataSet__item_
    Additional_PositioningDataSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Additional-PositioningMethodAndUsage >-----#
    Additional_PositioningMethodAndUsage = OCT_STR(name='Additional-PositioningMethodAndUsage', mode=MODE_TYPE)
    Additional_PositioningMethodAndUsage._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< GPS-AcquisitionAssistance >-----#
    GPS_AcquisitionAssistance = SEQ(name='GPS-AcquisitionAssistance', mode=MODE_TYPE)
    _GPS_AcquisitionAssistance_gps_TOW_1msec = INT(name='gps-TOW-1msec', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_AcquisitionAssistance_gps_TOW_1msec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=604799999)], ev=None, er=[])
    _GPS_AcquisitionAssistance_satelliteInformationList = SEQ_OF(name='satelliteInformationList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AcquisitionSatInfoList')))
    _GPS_AcquisitionAssistance_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_AcquisitionAssistance_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPS_AcquisitionAssistance_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GPSReferenceTime')))
    _____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPSReferenceTimeUncertainty')))
    _____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Confidence')))
    ____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 46), ('criticality', 'ignore'), ('Extension', _____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Extension', _____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 135), ('criticality', 'ignore'), ('Extension', _____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GPS_AcquisitionAssistance_iE_Extensions__item__id._const_tab = ____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab
    ___GPS_AcquisitionAssistance_iE_Extensions__item__id._const_tab_at = None
    ___GPS_AcquisitionAssistance_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_AcquisitionAssistance_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GPS_AcquisitionAssistance_iE_Extensions__item__criticality._const_tab = ____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab
    ___GPS_AcquisitionAssistance_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_AcquisitionAssistance_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_AcquisitionAssistance_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GPS_AcquisitionAssistance_iE_Extensions__item__extensionValue._const_tab = ____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab
    ___GPS_AcquisitionAssistance_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_AcquisitionAssistance_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_AcquisitionAssistance_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_AcquisitionAssistance_iE_Extensions__item__id),
        ('criticality', ___GPS_AcquisitionAssistance_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_AcquisitionAssistance_iE_Extensions__item__extensionValue),
        ])
    __GPS_AcquisitionAssistance_iE_Extensions__item_._ext = None
    _GPS_AcquisitionAssistance_iE_Extensions._cont = __GPS_AcquisitionAssistance_iE_Extensions__item_
    _GPS_AcquisitionAssistance_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_AcquisitionAssistance._cont = ASN1Dict([
        ('gps-TOW-1msec', _GPS_AcquisitionAssistance_gps_TOW_1msec),
        ('satelliteInformationList', _GPS_AcquisitionAssistance_satelliteInformationList),
        ('iE-Extensions', _GPS_AcquisitionAssistance_iE_Extensions),
        ])
    GPS_AcquisitionAssistance._ext = []
    
    #-----< GPS-AcquisitionAssistance-ExtIEs >-----#
    GPS_AcquisitionAssistance_ExtIEs = CLASS(name='GPS-AcquisitionAssistance-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GPS_AcquisitionAssistance_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GPSReferenceTime')))
    _GPS_AcquisitionAssistance_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPSReferenceTimeUncertainty')))
    _GPS_AcquisitionAssistance_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Confidence')))
    GPS_AcquisitionAssistance_ExtIEs._val = ASN1Set(rv=[dict([('id', 46), ('criticality', 'ignore'), ('Extension', _GPS_AcquisitionAssistance_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Extension', _GPS_AcquisitionAssistance_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 135), ('criticality', 'ignore'), ('Extension', _GPS_AcquisitionAssistance_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AcquisitionSatInfoList >-----#
    AcquisitionSatInfoList = SEQ_OF(name='AcquisitionSatInfoList', mode=MODE_TYPE)
    _AcquisitionSatInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AcquisitionSatInfo')))
    AcquisitionSatInfoList._cont = _AcquisitionSatInfoList__item_
    AcquisitionSatInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< AcquisitionSatInfo >-----#
    AcquisitionSatInfo = SEQ(name='AcquisitionSatInfo', mode=MODE_TYPE)
    _AcquisitionSatInfo_satID = INT(name='satID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AcquisitionSatInfo_satID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _AcquisitionSatInfo_doppler0thOrder = INT(name='doppler0thOrder', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AcquisitionSatInfo_doppler0thOrder._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2048, ub=2047)], ev=None, er=[])
    _AcquisitionSatInfo_extraDopplerInfo = SEQ(name='extraDopplerInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'ExtraDopplerInfo')), opt=True)
    _AcquisitionSatInfo_codePhase = INT(name='codePhase', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AcquisitionSatInfo_codePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1022)], ev=None, er=[])
    _AcquisitionSatInfo_integerCodePhase = INT(name='integerCodePhase', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AcquisitionSatInfo_integerCodePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=19)], ev=None, er=[])
    _AcquisitionSatInfo_gps_BitNumber = INT(name='gps-BitNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AcquisitionSatInfo_gps_BitNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _AcquisitionSatInfo_codePhaseSearchWindow = ENUM(name='codePhaseSearchWindow', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CodePhaseSearchWindow')))
    _AcquisitionSatInfo_azimuthAndElevation = SEQ(name='azimuthAndElevation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AzimuthAndElevation')), opt=True)
    _AcquisitionSatInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AcquisitionSatInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AcquisitionSatInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AcquisitionSatInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____AcquisitionSatInfo_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExtraDopplerInfoExtension')))
    ____AcquisitionSatInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'ignore'), ('Extension', _____AcquisitionSatInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AcquisitionSatInfo_iE_Extensions__item__id._const_tab = ____AcquisitionSatInfo_iE_Extensions__item__id_tab
    ___AcquisitionSatInfo_iE_Extensions__item__id._const_tab_at = None
    ___AcquisitionSatInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___AcquisitionSatInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___AcquisitionSatInfo_iE_Extensions__item__criticality._const_tab = ____AcquisitionSatInfo_iE_Extensions__item__id_tab
    ___AcquisitionSatInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AcquisitionSatInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AcquisitionSatInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___AcquisitionSatInfo_iE_Extensions__item__extensionValue._const_tab = ____AcquisitionSatInfo_iE_Extensions__item__id_tab
    ___AcquisitionSatInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AcquisitionSatInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AcquisitionSatInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AcquisitionSatInfo_iE_Extensions__item__id),
        ('criticality', ___AcquisitionSatInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___AcquisitionSatInfo_iE_Extensions__item__extensionValue),
        ])
    __AcquisitionSatInfo_iE_Extensions__item_._ext = None
    _AcquisitionSatInfo_iE_Extensions._cont = __AcquisitionSatInfo_iE_Extensions__item_
    _AcquisitionSatInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AcquisitionSatInfo._cont = ASN1Dict([
        ('satID', _AcquisitionSatInfo_satID),
        ('doppler0thOrder', _AcquisitionSatInfo_doppler0thOrder),
        ('extraDopplerInfo', _AcquisitionSatInfo_extraDopplerInfo),
        ('codePhase', _AcquisitionSatInfo_codePhase),
        ('integerCodePhase', _AcquisitionSatInfo_integerCodePhase),
        ('gps-BitNumber', _AcquisitionSatInfo_gps_BitNumber),
        ('codePhaseSearchWindow', _AcquisitionSatInfo_codePhaseSearchWindow),
        ('azimuthAndElevation', _AcquisitionSatInfo_azimuthAndElevation),
        ('iE-Extensions', _AcquisitionSatInfo_iE_Extensions),
        ])
    AcquisitionSatInfo._ext = []
    
    #-----< AcquisitionSatInfo-ExtIEs >-----#
    AcquisitionSatInfo_ExtIEs = CLASS(name='AcquisitionSatInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _AcquisitionSatInfo_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExtraDopplerInfoExtension')))
    AcquisitionSatInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'ignore'), ('Extension', _AcquisitionSatInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ExtraDopplerInfo >-----#
    ExtraDopplerInfo = SEQ(name='ExtraDopplerInfo', mode=MODE_TYPE)
    _ExtraDopplerInfo_doppler1stOrder = INT(name='doppler1stOrder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtraDopplerInfo_doppler1stOrder._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-42, ub=21)], ev=None, er=[])
    _ExtraDopplerInfo_dopplerUncertainty = ENUM(name='dopplerUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DopplerUncertainty')))
    _ExtraDopplerInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtraDopplerInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___ExtraDopplerInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____ExtraDopplerInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ExtraDopplerInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtraDopplerInfo_iE_Extensions__item__id._const_tab = ____ExtraDopplerInfo_iE_Extensions__item__id_tab
    ___ExtraDopplerInfo_iE_Extensions__item__id._const_tab_at = None
    ___ExtraDopplerInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExtraDopplerInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExtraDopplerInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ExtraDopplerInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtraDopplerInfo_iE_Extensions__item__criticality._const_tab = ____ExtraDopplerInfo_iE_Extensions__item__criticality_tab
    ___ExtraDopplerInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExtraDopplerInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExtraDopplerInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExtraDopplerInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ExtraDopplerInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtraDopplerInfo_iE_Extensions__item__extensionValue._const_tab = ____ExtraDopplerInfo_iE_Extensions__item__extensionValue_tab
    ___ExtraDopplerInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExtraDopplerInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExtraDopplerInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExtraDopplerInfo_iE_Extensions__item__id),
        ('criticality', ___ExtraDopplerInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___ExtraDopplerInfo_iE_Extensions__item__extensionValue),
        ])
    __ExtraDopplerInfo_iE_Extensions__item_._ext = None
    _ExtraDopplerInfo_iE_Extensions._cont = __ExtraDopplerInfo_iE_Extensions__item_
    _ExtraDopplerInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtraDopplerInfo._cont = ASN1Dict([
        ('doppler1stOrder', _ExtraDopplerInfo_doppler1stOrder),
        ('dopplerUncertainty', _ExtraDopplerInfo_dopplerUncertainty),
        ('iE-Extensions', _ExtraDopplerInfo_iE_Extensions),
        ])
    ExtraDopplerInfo._ext = []
    
    #-----< ExtraDopplerInfo-ExtIEs >-----#
    ExtraDopplerInfo_ExtIEs = CLASS(name='ExtraDopplerInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ExtraDopplerInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ExtraDopplerInfoExtension >-----#
    ExtraDopplerInfoExtension = SEQ(name='ExtraDopplerInfoExtension', mode=MODE_TYPE)
    _ExtraDopplerInfoExtension_doppler1stOrder = INT(name='doppler1stOrder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtraDopplerInfoExtension_doppler1stOrder._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-42, ub=21)], ev=None, er=[])
    _ExtraDopplerInfoExtension_dopplerUncertaintyExtension = ENUM(name='dopplerUncertaintyExtension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DopplerUncertaintyExtension')))
    _ExtraDopplerInfoExtension_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ExtraDopplerInfoExtension_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___ExtraDopplerInfoExtension_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____ExtraDopplerInfoExtension_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ExtraDopplerInfoExtension_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtraDopplerInfoExtension_iE_Extensions__item__id._const_tab = ____ExtraDopplerInfoExtension_iE_Extensions__item__id_tab
    ___ExtraDopplerInfoExtension_iE_Extensions__item__id._const_tab_at = None
    ___ExtraDopplerInfoExtension_iE_Extensions__item__id._const_tab_id = 'id'
    ___ExtraDopplerInfoExtension_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ExtraDopplerInfoExtension_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ExtraDopplerInfoExtension_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtraDopplerInfoExtension_iE_Extensions__item__criticality._const_tab = ____ExtraDopplerInfoExtension_iE_Extensions__item__criticality_tab
    ___ExtraDopplerInfoExtension_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ExtraDopplerInfoExtension_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ExtraDopplerInfoExtension_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ExtraDopplerInfoExtension_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ExtraDopplerInfoExtension_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ExtraDopplerInfoExtension_iE_Extensions__item__extensionValue._const_tab = ____ExtraDopplerInfoExtension_iE_Extensions__item__extensionValue_tab
    ___ExtraDopplerInfoExtension_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ExtraDopplerInfoExtension_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ExtraDopplerInfoExtension_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ExtraDopplerInfoExtension_iE_Extensions__item__id),
        ('criticality', ___ExtraDopplerInfoExtension_iE_Extensions__item__criticality),
        ('extensionValue', ___ExtraDopplerInfoExtension_iE_Extensions__item__extensionValue),
        ])
    __ExtraDopplerInfoExtension_iE_Extensions__item_._ext = None
    _ExtraDopplerInfoExtension_iE_Extensions._cont = __ExtraDopplerInfoExtension_iE_Extensions__item_
    _ExtraDopplerInfoExtension_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ExtraDopplerInfoExtension._cont = ASN1Dict([
        ('doppler1stOrder', _ExtraDopplerInfoExtension_doppler1stOrder),
        ('dopplerUncertaintyExtension', _ExtraDopplerInfoExtension_dopplerUncertaintyExtension),
        ('iE-Extensions', _ExtraDopplerInfoExtension_iE_Extensions),
        ])
    ExtraDopplerInfoExtension._ext = []
    
    #-----< ExtraDopplerInfoExtension-ExtIEs >-----#
    ExtraDopplerInfoExtension_ExtIEs = CLASS(name='ExtraDopplerInfoExtension-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ExtraDopplerInfoExtension_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DopplerUncertainty >-----#
    DopplerUncertainty = ENUM(name='DopplerUncertainty', mode=MODE_TYPE)
    DopplerUncertainty._cont = ASN1Dict([('hz12-5', 0), ('hz25', 1), ('hz50', 2), ('hz100', 3), ('hz200', 4)])
    DopplerUncertainty._ext = []
    
    #-----< DopplerUncertaintyExtension >-----#
    DopplerUncertaintyExtension = ENUM(name='DopplerUncertaintyExtension', mode=MODE_TYPE)
    DopplerUncertaintyExtension._cont = ASN1Dict([('hz300', 0), ('hz400', 1), ('hz500', 2), ('hz600', 3), ('noInformation', 4)])
    DopplerUncertaintyExtension._ext = []
    
    #-----< CodePhaseSearchWindow >-----#
    CodePhaseSearchWindow = ENUM(name='CodePhaseSearchWindow', mode=MODE_TYPE)
    CodePhaseSearchWindow._cont = ASN1Dict([('w1023', 0), ('w1', 1), ('w2', 2), ('w3', 3), ('w4', 4), ('w6', 5), ('w8', 6), ('w12', 7), ('w16', 8), ('w24', 9), ('w32', 10), ('w48', 11), ('w64', 12), ('w96', 13), ('w128', 14), ('w192', 15)])
    CodePhaseSearchWindow._ext = None
    
    #-----< AzimuthAndElevation >-----#
    AzimuthAndElevation = SEQ(name='AzimuthAndElevation', mode=MODE_TYPE)
    _AzimuthAndElevation_azimuth = INT(name='azimuth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AzimuthAndElevation_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _AzimuthAndElevation_elevation = INT(name='elevation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AzimuthAndElevation_elevation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _AzimuthAndElevation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AzimuthAndElevation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AzimuthAndElevation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AzimuthAndElevation_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____AzimuthAndElevation_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AzimuthAndElevationLSB')))
    ____AzimuthAndElevation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 119), ('criticality', 'ignore'), ('Extension', _____AzimuthAndElevation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AzimuthAndElevation_iE_Extensions__item__id._const_tab = ____AzimuthAndElevation_iE_Extensions__item__id_tab
    ___AzimuthAndElevation_iE_Extensions__item__id._const_tab_at = None
    ___AzimuthAndElevation_iE_Extensions__item__id._const_tab_id = 'id'
    ___AzimuthAndElevation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___AzimuthAndElevation_iE_Extensions__item__criticality._const_tab = ____AzimuthAndElevation_iE_Extensions__item__id_tab
    ___AzimuthAndElevation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AzimuthAndElevation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AzimuthAndElevation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___AzimuthAndElevation_iE_Extensions__item__extensionValue._const_tab = ____AzimuthAndElevation_iE_Extensions__item__id_tab
    ___AzimuthAndElevation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AzimuthAndElevation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AzimuthAndElevation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AzimuthAndElevation_iE_Extensions__item__id),
        ('criticality', ___AzimuthAndElevation_iE_Extensions__item__criticality),
        ('extensionValue', ___AzimuthAndElevation_iE_Extensions__item__extensionValue),
        ])
    __AzimuthAndElevation_iE_Extensions__item_._ext = None
    _AzimuthAndElevation_iE_Extensions._cont = __AzimuthAndElevation_iE_Extensions__item_
    _AzimuthAndElevation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AzimuthAndElevation._cont = ASN1Dict([
        ('azimuth', _AzimuthAndElevation_azimuth),
        ('elevation', _AzimuthAndElevation_elevation),
        ('iE-Extensions', _AzimuthAndElevation_iE_Extensions),
        ])
    AzimuthAndElevation._ext = []
    
    #-----< AzimuthAndElevation-ExtIEs >-----#
    AzimuthAndElevation_ExtIEs = CLASS(name='AzimuthAndElevation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _AzimuthAndElevation_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AzimuthAndElevationLSB')))
    AzimuthAndElevation_ExtIEs._val = ASN1Set(rv=[dict([('id', 119), ('criticality', 'ignore'), ('Extension', _AzimuthAndElevation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< AzimuthAndElevationLSB >-----#
    AzimuthAndElevationLSB = SEQ(name='AzimuthAndElevationLSB', mode=MODE_TYPE)
    _AzimuthAndElevationLSB_azimuthLSB = INT(name='azimuthLSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AzimuthAndElevationLSB_azimuthLSB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _AzimuthAndElevationLSB_elevationLSB = INT(name='elevationLSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AzimuthAndElevationLSB_elevationLSB._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _AzimuthAndElevationLSB_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AzimuthAndElevationLSB_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AzimuthAndElevationLSB_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AzimuthAndElevationLSB_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AzimuthAndElevationLSB_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AzimuthAndElevationLSB_iE_Extensions__item__id._const_tab = ____AzimuthAndElevationLSB_iE_Extensions__item__id_tab
    ___AzimuthAndElevationLSB_iE_Extensions__item__id._const_tab_at = None
    ___AzimuthAndElevationLSB_iE_Extensions__item__id._const_tab_id = 'id'
    ___AzimuthAndElevationLSB_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AzimuthAndElevationLSB_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AzimuthAndElevationLSB_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AzimuthAndElevationLSB_iE_Extensions__item__criticality._const_tab = ____AzimuthAndElevationLSB_iE_Extensions__item__criticality_tab
    ___AzimuthAndElevationLSB_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AzimuthAndElevationLSB_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AzimuthAndElevationLSB_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AzimuthAndElevationLSB_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AzimuthAndElevationLSB_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AzimuthAndElevationLSB_iE_Extensions__item__extensionValue._const_tab = ____AzimuthAndElevationLSB_iE_Extensions__item__extensionValue_tab
    ___AzimuthAndElevationLSB_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AzimuthAndElevationLSB_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AzimuthAndElevationLSB_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AzimuthAndElevationLSB_iE_Extensions__item__id),
        ('criticality', ___AzimuthAndElevationLSB_iE_Extensions__item__criticality),
        ('extensionValue', ___AzimuthAndElevationLSB_iE_Extensions__item__extensionValue),
        ])
    __AzimuthAndElevationLSB_iE_Extensions__item_._ext = None
    _AzimuthAndElevationLSB_iE_Extensions._cont = __AzimuthAndElevationLSB_iE_Extensions__item_
    _AzimuthAndElevationLSB_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AzimuthAndElevationLSB._cont = ASN1Dict([
        ('azimuthLSB', _AzimuthAndElevationLSB_azimuthLSB),
        ('elevationLSB', _AzimuthAndElevationLSB_elevationLSB),
        ('iE-Extensions', _AzimuthAndElevationLSB_iE_Extensions),
        ])
    AzimuthAndElevationLSB._ext = []
    
    #-----< AzimuthAndElevationLSB-ExtIEs >-----#
    AzimuthAndElevationLSB_ExtIEs = CLASS(name='AzimuthAndElevationLSB-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AzimuthAndElevationLSB_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Confidence >-----#
    Confidence = INT(name='Confidence', mode=MODE_TYPE)
    Confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< AuxInfoGANSS-ID1 >-----#
    AuxInfoGANSS_ID1 = SEQ_OF(name='AuxInfoGANSS-ID1', mode=MODE_TYPE)
    _AuxInfoGANSS_ID1__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AuxInfoGANSS-ID1-element')))
    AuxInfoGANSS_ID1._cont = _AuxInfoGANSS_ID1__item_
    AuxInfoGANSS_ID1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AuxInfoGANSS-ID1-element >-----#
    AuxInfoGANSS_ID1_element = SEQ(name='AuxInfoGANSS-ID1-element', mode=MODE_TYPE)
    _AuxInfoGANSS_ID1_element_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuxInfoGANSS_ID1_element_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _AuxInfoGANSS_ID1_element_signalsAvailable = BIT_STR(name='signalsAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuxInfoGANSS_ID1_element_signalsAvailable._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _AuxInfoGANSS_ID1_element_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AuxInfoGANSS_ID1_element_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AuxInfoGANSS_ID1_element_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AuxInfoGANSS_ID1_element_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__id._const_tab = ____AuxInfoGANSS_ID1_element_ie_Extensions__item__id_tab
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__id._const_tab_at = None
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__id._const_tab_id = 'id'
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality._const_tab = ____AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality_tab
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue._const_tab = ____AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue_tab
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AuxInfoGANSS_ID1_element_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___AuxInfoGANSS_ID1_element_ie_Extensions__item__id),
        ('criticality', ___AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality),
        ('extensionValue', ___AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue),
        ])
    __AuxInfoGANSS_ID1_element_ie_Extensions__item_._ext = None
    _AuxInfoGANSS_ID1_element_ie_Extensions._cont = __AuxInfoGANSS_ID1_element_ie_Extensions__item_
    _AuxInfoGANSS_ID1_element_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AuxInfoGANSS_ID1_element._cont = ASN1Dict([
        ('svID', _AuxInfoGANSS_ID1_element_svID),
        ('signalsAvailable', _AuxInfoGANSS_ID1_element_signalsAvailable),
        ('ie-Extensions', _AuxInfoGANSS_ID1_element_ie_Extensions),
        ])
    AuxInfoGANSS_ID1_element._ext = []
    
    #-----< AuxInfoGANSS-ID1-element-ExtIEs >-----#
    AuxInfoGANSS_ID1_element_ExtIEs = CLASS(name='AuxInfoGANSS-ID1-element-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AuxInfoGANSS_ID1_element_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AuxInfoGANSS-ID3 >-----#
    AuxInfoGANSS_ID3 = SEQ_OF(name='AuxInfoGANSS-ID3', mode=MODE_TYPE)
    _AuxInfoGANSS_ID3__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AuxInfoGANSS-ID3-element')))
    AuxInfoGANSS_ID3._cont = _AuxInfoGANSS_ID3__item_
    AuxInfoGANSS_ID3._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< AuxInfoGANSS-ID3-element >-----#
    AuxInfoGANSS_ID3_element = SEQ(name='AuxInfoGANSS-ID3-element', mode=MODE_TYPE)
    _AuxInfoGANSS_ID3_element_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuxInfoGANSS_ID3_element_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _AuxInfoGANSS_ID3_element_signalsAvailable = BIT_STR(name='signalsAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuxInfoGANSS_ID3_element_signalsAvailable._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _AuxInfoGANSS_ID3_element_channelNumber = INT(name='channelNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AuxInfoGANSS_ID3_element_channelNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-7, ub=13)], ev=None, er=[])
    _AuxInfoGANSS_ID3_element_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AuxInfoGANSS_ID3_element_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AuxInfoGANSS_ID3_element_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AuxInfoGANSS_ID3_element_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__id._const_tab = ____AuxInfoGANSS_ID3_element_ie_Extensions__item__id_tab
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__id._const_tab_at = None
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__id._const_tab_id = 'id'
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality._const_tab = ____AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality_tab
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue._const_tab = ____AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue_tab
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AuxInfoGANSS_ID3_element_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___AuxInfoGANSS_ID3_element_ie_Extensions__item__id),
        ('criticality', ___AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality),
        ('extensionValue', ___AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue),
        ])
    __AuxInfoGANSS_ID3_element_ie_Extensions__item_._ext = None
    _AuxInfoGANSS_ID3_element_ie_Extensions._cont = __AuxInfoGANSS_ID3_element_ie_Extensions__item_
    _AuxInfoGANSS_ID3_element_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AuxInfoGANSS_ID3_element._cont = ASN1Dict([
        ('svID', _AuxInfoGANSS_ID3_element_svID),
        ('signalsAvailable', _AuxInfoGANSS_ID3_element_signalsAvailable),
        ('channelNumber', _AuxInfoGANSS_ID3_element_channelNumber),
        ('ie-Extensions', _AuxInfoGANSS_ID3_element_ie_Extensions),
        ])
    AuxInfoGANSS_ID3_element._ext = []
    
    #-----< AuxInfoGANSS-ID3-element-ExtIEs >-----#
    AuxInfoGANSS_ID3_element_ExtIEs = CLASS(name='AuxInfoGANSS-ID3-element-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AuxInfoGANSS_ID3_element_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CNAVclockModel >-----#
    CNAVclockModel = SEQ(name='CNAVclockModel', mode=MODE_TYPE)
    _CNAVclockModel_cnavToc = BIT_STR(name='cnavToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAVclockModel_cnavToc._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavTop = BIT_STR(name='cnavTop', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAVclockModel_cnavTop._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavURA0 = BIT_STR(name='cnavURA0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAVclockModel_cnavURA0._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavURA1 = BIT_STR(name='cnavURA1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAVclockModel_cnavURA1._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavURA2 = BIT_STR(name='cnavURA2', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAVclockModel_cnavURA2._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavAf2 = BIT_STR(name='cnavAf2', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAVclockModel_cnavAf2._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavAf1 = BIT_STR(name='cnavAf1', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAVclockModel_cnavAf1._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavAf0 = BIT_STR(name='cnavAf0', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAVclockModel_cnavAf0._const_sz = ASN1Set(rv=[26], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavTgd = BIT_STR(name='cnavTgd', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CNAVclockModel_cnavTgd._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavISCl1cp = BIT_STR(name='cnavISCl1cp', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAVclockModel_cnavISCl1cp._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavISCl1cd = BIT_STR(name='cnavISCl1cd', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAVclockModel_cnavISCl1cd._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavISCl1ca = BIT_STR(name='cnavISCl1ca', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAVclockModel_cnavISCl1ca._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavISCl2c = BIT_STR(name='cnavISCl2c', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAVclockModel_cnavISCl2c._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavISCl5i5 = BIT_STR(name='cnavISCl5i5', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAVclockModel_cnavISCl5i5._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _CNAVclockModel_cnavISCl5q5 = BIT_STR(name='cnavISCl5q5', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CNAVclockModel_cnavISCl5q5._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _CNAVclockModel_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNAVclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___CNAVclockModel_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____CNAVclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____CNAVclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNAVclockModel_ie_Extensions__item__id._const_tab = ____CNAVclockModel_ie_Extensions__item__id_tab
    ___CNAVclockModel_ie_Extensions__item__id._const_tab_at = None
    ___CNAVclockModel_ie_Extensions__item__id._const_tab_id = 'id'
    ___CNAVclockModel_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CNAVclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____CNAVclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNAVclockModel_ie_Extensions__item__criticality._const_tab = ____CNAVclockModel_ie_Extensions__item__criticality_tab
    ___CNAVclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CNAVclockModel_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CNAVclockModel_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CNAVclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____CNAVclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNAVclockModel_ie_Extensions__item__extensionValue._const_tab = ____CNAVclockModel_ie_Extensions__item__extensionValue_tab
    ___CNAVclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CNAVclockModel_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CNAVclockModel_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___CNAVclockModel_ie_Extensions__item__id),
        ('criticality', ___CNAVclockModel_ie_Extensions__item__criticality),
        ('extensionValue', ___CNAVclockModel_ie_Extensions__item__extensionValue),
        ])
    __CNAVclockModel_ie_Extensions__item_._ext = None
    _CNAVclockModel_ie_Extensions._cont = __CNAVclockModel_ie_Extensions__item_
    _CNAVclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNAVclockModel._cont = ASN1Dict([
        ('cnavToc', _CNAVclockModel_cnavToc),
        ('cnavTop', _CNAVclockModel_cnavTop),
        ('cnavURA0', _CNAVclockModel_cnavURA0),
        ('cnavURA1', _CNAVclockModel_cnavURA1),
        ('cnavURA2', _CNAVclockModel_cnavURA2),
        ('cnavAf2', _CNAVclockModel_cnavAf2),
        ('cnavAf1', _CNAVclockModel_cnavAf1),
        ('cnavAf0', _CNAVclockModel_cnavAf0),
        ('cnavTgd', _CNAVclockModel_cnavTgd),
        ('cnavISCl1cp', _CNAVclockModel_cnavISCl1cp),
        ('cnavISCl1cd', _CNAVclockModel_cnavISCl1cd),
        ('cnavISCl1ca', _CNAVclockModel_cnavISCl1ca),
        ('cnavISCl2c', _CNAVclockModel_cnavISCl2c),
        ('cnavISCl5i5', _CNAVclockModel_cnavISCl5i5),
        ('cnavISCl5q5', _CNAVclockModel_cnavISCl5q5),
        ('ie-Extensions', _CNAVclockModel_ie_Extensions),
        ])
    CNAVclockModel._ext = []
    
    #-----< CNAVclockModel-ExtIEs >-----#
    CNAVclockModel_ExtIEs = CLASS(name='CNAVclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    CNAVclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DeltaUT1 >-----#
    DeltaUT1 = SEQ(name='DeltaUT1', mode=MODE_TYPE)
    _DeltaUT1_b1 = BIT_STR(name='b1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DeltaUT1_b1._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _DeltaUT1_b2 = BIT_STR(name='b2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DeltaUT1_b2._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _DeltaUT1_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DeltaUT1_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DeltaUT1_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DeltaUT1_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DeltaUT1_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DeltaUT1_ie_Extensions__item__id._const_tab = ____DeltaUT1_ie_Extensions__item__id_tab
    ___DeltaUT1_ie_Extensions__item__id._const_tab_at = None
    ___DeltaUT1_ie_Extensions__item__id._const_tab_id = 'id'
    ___DeltaUT1_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DeltaUT1_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DeltaUT1_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DeltaUT1_ie_Extensions__item__criticality._const_tab = ____DeltaUT1_ie_Extensions__item__criticality_tab
    ___DeltaUT1_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DeltaUT1_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DeltaUT1_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DeltaUT1_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DeltaUT1_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DeltaUT1_ie_Extensions__item__extensionValue._const_tab = ____DeltaUT1_ie_Extensions__item__extensionValue_tab
    ___DeltaUT1_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DeltaUT1_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DeltaUT1_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DeltaUT1_ie_Extensions__item__id),
        ('criticality', ___DeltaUT1_ie_Extensions__item__criticality),
        ('extensionValue', ___DeltaUT1_ie_Extensions__item__extensionValue),
        ])
    __DeltaUT1_ie_Extensions__item_._ext = None
    _DeltaUT1_ie_Extensions._cont = __DeltaUT1_ie_Extensions__item_
    _DeltaUT1_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DeltaUT1._cont = ASN1Dict([
        ('b1', _DeltaUT1_b1),
        ('b2', _DeltaUT1_b2),
        ('ie-Extensions', _DeltaUT1_ie_Extensions),
        ])
    DeltaUT1._ext = []
    
    #-----< DeltaUT1-ExtIEs >-----#
    DeltaUT1_ExtIEs = CLASS(name='DeltaUT1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DeltaUT1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGANSS-Corrections >-----#
    DGANSS_Corrections = SEQ(name='DGANSS-Corrections', mode=MODE_TYPE)
    _DGANSS_Corrections_dGANSS_ReferenceTime = INT(name='dGANSS-ReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_Corrections_dGANSS_ReferenceTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=119)], ev=None, er=[])
    _DGANSS_Corrections_dGANSS_Information = SEQ_OF(name='dGANSS-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DGANSS-Information')))
    _DGANSS_Corrections_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGANSS_Corrections_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DGANSS_Corrections_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGANSS_Corrections_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGANSS_Corrections_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSS_Corrections_ie_Extensions__item__id._const_tab = ____DGANSS_Corrections_ie_Extensions__item__id_tab
    ___DGANSS_Corrections_ie_Extensions__item__id._const_tab_at = None
    ___DGANSS_Corrections_ie_Extensions__item__id._const_tab_id = 'id'
    ___DGANSS_Corrections_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DGANSS_Corrections_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGANSS_Corrections_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSS_Corrections_ie_Extensions__item__criticality._const_tab = ____DGANSS_Corrections_ie_Extensions__item__criticality_tab
    ___DGANSS_Corrections_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGANSS_Corrections_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGANSS_Corrections_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DGANSS_Corrections_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGANSS_Corrections_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSS_Corrections_ie_Extensions__item__extensionValue._const_tab = ____DGANSS_Corrections_ie_Extensions__item__extensionValue_tab
    ___DGANSS_Corrections_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGANSS_Corrections_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGANSS_Corrections_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGANSS_Corrections_ie_Extensions__item__id),
        ('criticality', ___DGANSS_Corrections_ie_Extensions__item__criticality),
        ('extensionValue', ___DGANSS_Corrections_ie_Extensions__item__extensionValue),
        ])
    __DGANSS_Corrections_ie_Extensions__item_._ext = None
    _DGANSS_Corrections_ie_Extensions._cont = __DGANSS_Corrections_ie_Extensions__item_
    _DGANSS_Corrections_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGANSS_Corrections._cont = ASN1Dict([
        ('dGANSS-ReferenceTime', _DGANSS_Corrections_dGANSS_ReferenceTime),
        ('dGANSS-Information', _DGANSS_Corrections_dGANSS_Information),
        ('ie-Extensions', _DGANSS_Corrections_ie_Extensions),
        ])
    DGANSS_Corrections._ext = []
    
    #-----< DGANSS-Corrections-ExtIEs >-----#
    DGANSS_Corrections_ExtIEs = CLASS(name='DGANSS-Corrections-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DGANSS_Corrections_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGANSS-Information >-----#
    DGANSS_Information = SEQ_OF(name='DGANSS-Information', mode=MODE_TYPE)
    _DGANSS_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DGANSS-InformationItem')))
    DGANSS_Information._cont = _DGANSS_Information__item_
    DGANSS_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DGANSS-InformationItem >-----#
    DGANSS_InformationItem = SEQ(name='DGANSS-InformationItem', mode=MODE_TYPE)
    _DGANSS_InformationItem_gANSS_SignalId = SEQ(name='gANSS-SignalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SignalID')), opt=True)
    _DGANSS_InformationItem_gANSS_StatusHealth = ENUM(name='gANSS-StatusHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-StatusHealth')))
    _DGANSS_InformationItem_dGANSS_SignalInformation = SEQ_OF(name='dGANSS-SignalInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DGANSS-SignalInformation')), opt=True)
    _DGANSS_InformationItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGANSS_InformationItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DGANSS_InformationItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGANSS_InformationItem_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGANSS_InformationItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSS_InformationItem_ie_Extensions__item__id._const_tab = ____DGANSS_InformationItem_ie_Extensions__item__id_tab
    ___DGANSS_InformationItem_ie_Extensions__item__id._const_tab_at = None
    ___DGANSS_InformationItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___DGANSS_InformationItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DGANSS_InformationItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGANSS_InformationItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSS_InformationItem_ie_Extensions__item__criticality._const_tab = ____DGANSS_InformationItem_ie_Extensions__item__criticality_tab
    ___DGANSS_InformationItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGANSS_InformationItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGANSS_InformationItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DGANSS_InformationItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DGANSS_InformationItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DGANSS_InformationItem_ie_Extensions__item__extensionValue._const_tab = ____DGANSS_InformationItem_ie_Extensions__item__extensionValue_tab
    ___DGANSS_InformationItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGANSS_InformationItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGANSS_InformationItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGANSS_InformationItem_ie_Extensions__item__id),
        ('criticality', ___DGANSS_InformationItem_ie_Extensions__item__criticality),
        ('extensionValue', ___DGANSS_InformationItem_ie_Extensions__item__extensionValue),
        ])
    __DGANSS_InformationItem_ie_Extensions__item_._ext = None
    _DGANSS_InformationItem_ie_Extensions._cont = __DGANSS_InformationItem_ie_Extensions__item_
    _DGANSS_InformationItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGANSS_InformationItem._cont = ASN1Dict([
        ('gANSS-SignalId', _DGANSS_InformationItem_gANSS_SignalId),
        ('gANSS-StatusHealth', _DGANSS_InformationItem_gANSS_StatusHealth),
        ('dGANSS-SignalInformation', _DGANSS_InformationItem_dGANSS_SignalInformation),
        ('ie-Extensions', _DGANSS_InformationItem_ie_Extensions),
        ])
    DGANSS_InformationItem._ext = []
    
    #-----< DGANSS-InformationItem-ExtIEs >-----#
    DGANSS_InformationItem_ExtIEs = CLASS(name='DGANSS-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DGANSS_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGANSS-SignalInformation >-----#
    DGANSS_SignalInformation = SEQ_OF(name='DGANSS-SignalInformation', mode=MODE_TYPE)
    _DGANSS_SignalInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DGANSS-SignalInformationItem')))
    DGANSS_SignalInformation._cont = _DGANSS_SignalInformation__item_
    DGANSS_SignalInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DGANSS-SignalInformationItem >-----#
    DGANSS_SignalInformationItem = SEQ(name='DGANSS-SignalInformationItem', mode=MODE_TYPE)
    _DGANSS_SignalInformationItem_satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_SignalInformationItem_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _DGANSS_SignalInformationItem_gANSS_iod = BIT_STR(name='gANSS-iod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_SignalInformationItem_gANSS_iod._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _DGANSS_SignalInformationItem_udre = ENUM(name='udre', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UDRE')))
    _DGANSS_SignalInformationItem_ganss_prc = INT(name='ganss-prc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_SignalInformationItem_ganss_prc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2047, ub=2047)], ev=None, er=[])
    _DGANSS_SignalInformationItem_ganss_rrc = INT(name='ganss-rrc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DGANSS_SignalInformationItem_ganss_rrc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=127)], ev=None, er=[])
    _DGANSS_SignalInformationItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DGANSS_SignalInformationItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DGANSS_SignalInformationItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DGNSS-ValidityPeriod')))
    ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 118), ('criticality', 'ignore'), ('Extension', _____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DGANSS_SignalInformationItem_ie_Extensions__item__id._const_tab = ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab
    ___DGANSS_SignalInformationItem_ie_Extensions__item__id._const_tab_at = None
    ___DGANSS_SignalInformationItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality._const_tab = ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab
    ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue._const_tab = ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab
    ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DGANSS_SignalInformationItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DGANSS_SignalInformationItem_ie_Extensions__item__id),
        ('criticality', ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality),
        ('extensionValue', ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue),
        ])
    __DGANSS_SignalInformationItem_ie_Extensions__item_._ext = None
    _DGANSS_SignalInformationItem_ie_Extensions._cont = __DGANSS_SignalInformationItem_ie_Extensions__item_
    _DGANSS_SignalInformationItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DGANSS_SignalInformationItem._cont = ASN1Dict([
        ('satId', _DGANSS_SignalInformationItem_satId),
        ('gANSS-iod', _DGANSS_SignalInformationItem_gANSS_iod),
        ('udre', _DGANSS_SignalInformationItem_udre),
        ('ganss-prc', _DGANSS_SignalInformationItem_ganss_prc),
        ('ganss-rrc', _DGANSS_SignalInformationItem_ganss_rrc),
        ('ie-Extensions', _DGANSS_SignalInformationItem_ie_Extensions),
        ])
    DGANSS_SignalInformationItem._ext = []
    
    #-----< DGANSS-SignalInformationItem-ExtIEs >-----#
    DGANSS_SignalInformationItem_ExtIEs = CLASS(name='DGANSS-SignalInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _DGANSS_SignalInformationItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DGNSS-ValidityPeriod')))
    DGANSS_SignalInformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 118), ('criticality', 'ignore'), ('Extension', _DGANSS_SignalInformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-AddClockModels >-----#
    GANSS_AddClockModels = CHOICE(name='GANSS-AddClockModels', mode=MODE_TYPE)
    _GANSS_AddClockModels_navClockModel = SEQ(name='navClockModel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NAVclockModel')))
    _GANSS_AddClockModels_cnavClockModel = SEQ(name='cnavClockModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CNAVclockModel')))
    _GANSS_AddClockModels_glonassClockModel = SEQ(name='glonassClockModel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GLONASSclockModel')))
    _GANSS_AddClockModels_sbasClockModel = SEQ(name='sbasClockModel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SBASclockModel')))
    _GANSS_AddClockModels_bDSClockModel = SEQ(name='bDSClockModel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'BDSClockModel')))
    GANSS_AddClockModels._cont = ASN1Dict([
        ('navClockModel', _GANSS_AddClockModels_navClockModel),
        ('cnavClockModel', _GANSS_AddClockModels_cnavClockModel),
        ('glonassClockModel', _GANSS_AddClockModels_glonassClockModel),
        ('sbasClockModel', _GANSS_AddClockModels_sbasClockModel),
        ('bDSClockModel', _GANSS_AddClockModels_bDSClockModel),
        ])
    GANSS_AddClockModels._ext = ['bDSClockModel']
    
    #-----< GANSS-AddOrbitModels >-----#
    GANSS_AddOrbitModels = CHOICE(name='GANSS-AddOrbitModels', mode=MODE_TYPE)
    _GANSS_AddOrbitModels_navKeplerianSet = SEQ(name='navKeplerianSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NavModel-NAVKeplerianSet')))
    _GANSS_AddOrbitModels_cnavKeplerianSet = SEQ(name='cnavKeplerianSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NavModel-CNAVKeplerianSet')))
    _GANSS_AddOrbitModels_glonassECEF = SEQ(name='glonassECEF', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NavModel-GLONASSecef')))
    _GANSS_AddOrbitModels_sbasECEF = SEQ(name='sbasECEF', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NavModel-SBASecef')))
    _GANSS_AddOrbitModels_bDSKeplerianSet = SEQ(name='bDSKeplerianSet', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NavModel-BDSKeplerianSet')))
    GANSS_AddOrbitModels._cont = ASN1Dict([
        ('navKeplerianSet', _GANSS_AddOrbitModels_navKeplerianSet),
        ('cnavKeplerianSet', _GANSS_AddOrbitModels_cnavKeplerianSet),
        ('glonassECEF', _GANSS_AddOrbitModels_glonassECEF),
        ('sbasECEF', _GANSS_AddOrbitModels_sbasECEF),
        ('bDSKeplerianSet', _GANSS_AddOrbitModels_bDSKeplerianSet),
        ])
    GANSS_AddOrbitModels._ext = ['bDSKeplerianSet']
    
    #-----< GANSS-Additional-Ionospheric-Model >-----#
    GANSS_Additional_Ionospheric_Model = SEQ(name='GANSS-Additional-Ionospheric-Model', mode=MODE_TYPE)
    _GANSS_Additional_Ionospheric_Model_dataID = BIT_STR(name='dataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Additional_Ionospheric_Model_dataID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_Additional_Ionospheric_Model_alpha_beta_parameters = SEQ(name='alpha-beta-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-Ionospheric-Model')))
    _GANSS_Additional_Ionospheric_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id._const_tab = ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id),
        ('criticality', ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_._ext = None
    _GANSS_Additional_Ionospheric_Model_ie_Extensions._cont = __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_
    _GANSS_Additional_Ionospheric_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Additional_Ionospheric_Model._cont = ASN1Dict([
        ('dataID', _GANSS_Additional_Ionospheric_Model_dataID),
        ('alpha-beta-parameters', _GANSS_Additional_Ionospheric_Model_alpha_beta_parameters),
        ('ie-Extensions', _GANSS_Additional_Ionospheric_Model_ie_Extensions),
        ])
    GANSS_Additional_Ionospheric_Model._ext = []
    
    #-----< GANSS-Additional-Ionospheric-Model-ExtIEs >-----#
    GANSS_Additional_Ionospheric_Model_ExtIEs = CLASS(name='GANSS-Additional-Ionospheric-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_Additional_Ionospheric_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Additional-Navigation-Models >-----#
    GANSS_Additional_Navigation_Models = SEQ(name='GANSS-Additional-Navigation-Models', mode=MODE_TYPE)
    _GANSS_Additional_Navigation_Models_non_broadcastIndication = ENUM(name='non-broadcastIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Additional_Navigation_Models_non_broadcastIndication._cont = ASN1Dict([('true', 0)])
    _GANSS_Additional_Navigation_Models_non_broadcastIndication._ext = None
    _GANSS_Additional_Navigation_Models_ganssSatInfoNavList = SEQ_OF(name='ganssSatInfoNavList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Ganss-Sat-Info-AddNavList')))
    _GANSS_Additional_Navigation_Models_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Additional_Navigation_Models_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id._const_tab = ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality._const_tab = ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Additional_Navigation_Models_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id),
        ('criticality', ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Additional_Navigation_Models_ie_Extensions__item_._ext = None
    _GANSS_Additional_Navigation_Models_ie_Extensions._cont = __GANSS_Additional_Navigation_Models_ie_Extensions__item_
    _GANSS_Additional_Navigation_Models_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Additional_Navigation_Models._cont = ASN1Dict([
        ('non-broadcastIndication', _GANSS_Additional_Navigation_Models_non_broadcastIndication),
        ('ganssSatInfoNavList', _GANSS_Additional_Navigation_Models_ganssSatInfoNavList),
        ('ie-Extensions', _GANSS_Additional_Navigation_Models_ie_Extensions),
        ])
    GANSS_Additional_Navigation_Models._ext = []
    
    #-----< GANSS-Additional-Navigation-Models-ExtIEs >-----#
    GANSS_Additional_Navigation_Models_ExtIEs = CLASS(name='GANSS-Additional-Navigation-Models-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_Additional_Navigation_Models_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Additional-Time-Models >-----#
    GANSS_Additional_Time_Models = SEQ_OF(name='GANSS-Additional-Time-Models', mode=MODE_TYPE)
    _GANSS_Additional_Time_Models__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Time-Model')))
    GANSS_Additional_Time_Models._cont = _GANSS_Additional_Time_Models__item_
    GANSS_Additional_Time_Models._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< GANSS-Additional-UTC-Models >-----#
    GANSS_Additional_UTC_Models = CHOICE(name='GANSS-Additional-UTC-Models', mode=MODE_TYPE)
    _GANSS_Additional_UTC_Models_utcModel1 = SEQ(name='utcModel1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTCmodelSet1')))
    _GANSS_Additional_UTC_Models_utcModel2 = SEQ(name='utcModel2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTCmodelSet2')))
    _GANSS_Additional_UTC_Models_utcModel3 = SEQ(name='utcModel3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTCmodelSet3')))
    _GANSS_Additional_UTC_Models_utcModel4 = SEQ(name='utcModel4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTCmodelSet4')))
    GANSS_Additional_UTC_Models._cont = ASN1Dict([
        ('utcModel1', _GANSS_Additional_UTC_Models_utcModel1),
        ('utcModel2', _GANSS_Additional_UTC_Models_utcModel2),
        ('utcModel3', _GANSS_Additional_UTC_Models_utcModel3),
        ('utcModel4', _GANSS_Additional_UTC_Models_utcModel4),
        ])
    GANSS_Additional_UTC_Models._ext = ['utcModel4']
    
    #-----< GANSS-ALM-BDSKeplericanset >-----#
    GANSS_ALM_BDSKeplericanset = SEQ(name='GANSS-ALM-BDSKeplericanset', mode=MODE_TYPE)
    _GANSS_ALM_BDSKeplericanset_satellite_Information_BDS_KP_List = SEQ_OF(name='satellite-Information-BDS-KP-List', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Satellite-Information-BDS-KP-List')))
    _GANSS_ALM_BDSKeplericanset_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_BDSKeplericanset_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__id._const_tab = ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__id_tab
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_BDSKeplericanset_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_BDSKeplericanset_ie_Extensions__item_._ext = None
    _GANSS_ALM_BDSKeplericanset_ie_Extensions._cont = __GANSS_ALM_BDSKeplericanset_ie_Extensions__item_
    _GANSS_ALM_BDSKeplericanset_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_BDSKeplericanset._cont = ASN1Dict([
        ('satellite-Information-BDS-KP-List', _GANSS_ALM_BDSKeplericanset_satellite_Information_BDS_KP_List),
        ('ie-Extensions', _GANSS_ALM_BDSKeplericanset_ie_Extensions),
        ])
    GANSS_ALM_BDSKeplericanset._ext = []
    
    #-----< GANSS-ALM-BDSKeplericanset-ExtIEs >-----#
    GANSS_ALM_BDSKeplericanset_ExtIEs = CLASS(name='GANSS-ALM-BDSKeplericanset-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_BDSKeplericanset_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Satellite-Information-BDS-KP-List >-----#
    Satellite_Information_BDS_KP_List = SEQ_OF(name='Satellite-Information-BDS-KP-List', mode=MODE_TYPE)
    _Satellite_Information_BDS_KP_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Satellite-Information-BDS-KP-Item')))
    Satellite_Information_BDS_KP_List._cont = _Satellite_Information_BDS_KP_List__item_
    Satellite_Information_BDS_KP_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< Satellite-Information-BDS-KP-Item >-----#
    Satellite_Information_BDS_KP_Item = SEQ(name='Satellite-Information-BDS-KP-Item', mode=MODE_TYPE)
    _Satellite_Information_BDS_KP_Item_sVID_BDS = INT(name='sVID-BDS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_sVID_BDS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_tOA_BDS = BIT_STR(name='tOA-BDS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_tOA_BDS._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_a21_BDS = BIT_STR(name='a21-BDS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_a21_BDS._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_e_BDS = BIT_STR(name='e-BDS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_e_BDS._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_omg_lower_BDS = BIT_STR(name='omg-lower-BDS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_omg_lower_BDS._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_m0_BDS = BIT_STR(name='m0-BDS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_m0_BDS._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_omg_0_BDS = BIT_STR(name='omg-0-BDS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_omg_0_BDS._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_omg_upper_BDS = BIT_STR(name='omg-upper-BDS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_omg_upper_BDS._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_delta_i_BDS = BIT_STR(name='delta-i-BDS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_delta_i_BDS._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_a0_BDS = BIT_STR(name='a0-BDS', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_a0_BDS._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_a1_BDS = BIT_STR(name='a1-BDS', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Satellite_Information_BDS_KP_Item_a1_BDS._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_hea_BDS = BIT_STR(name='hea-BDS', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Satellite_Information_BDS_KP_Item_hea_BDS._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _Satellite_Information_BDS_KP_Item_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Satellite_Information_BDS_KP_Item_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__id._const_tab = ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__id_tab
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__id._const_tab_at = None
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__id._const_tab_id = 'id'
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__criticality._const_tab = ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__criticality_tab
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__extensionValue._const_tab = ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__extensionValue_tab
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Satellite_Information_BDS_KP_Item_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__id),
        ('criticality', ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__criticality),
        ('extensionValue', ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__extensionValue),
        ])
    __Satellite_Information_BDS_KP_Item_ie_Extensions__item_._ext = None
    _Satellite_Information_BDS_KP_Item_ie_Extensions._cont = __Satellite_Information_BDS_KP_Item_ie_Extensions__item_
    _Satellite_Information_BDS_KP_Item_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Satellite_Information_BDS_KP_Item._cont = ASN1Dict([
        ('sVID-BDS', _Satellite_Information_BDS_KP_Item_sVID_BDS),
        ('tOA-BDS', _Satellite_Information_BDS_KP_Item_tOA_BDS),
        ('a21-BDS', _Satellite_Information_BDS_KP_Item_a21_BDS),
        ('e-BDS', _Satellite_Information_BDS_KP_Item_e_BDS),
        ('omg-lower-BDS', _Satellite_Information_BDS_KP_Item_omg_lower_BDS),
        ('m0-BDS', _Satellite_Information_BDS_KP_Item_m0_BDS),
        ('omg-0-BDS', _Satellite_Information_BDS_KP_Item_omg_0_BDS),
        ('omg-upper-BDS', _Satellite_Information_BDS_KP_Item_omg_upper_BDS),
        ('delta-i-BDS', _Satellite_Information_BDS_KP_Item_delta_i_BDS),
        ('a0-BDS', _Satellite_Information_BDS_KP_Item_a0_BDS),
        ('a1-BDS', _Satellite_Information_BDS_KP_Item_a1_BDS),
        ('hea-BDS', _Satellite_Information_BDS_KP_Item_hea_BDS),
        ('ie-Extensions', _Satellite_Information_BDS_KP_Item_ie_Extensions),
        ])
    Satellite_Information_BDS_KP_Item._ext = []
    
    #-----< Satellite-Information-BDS-KP-Item-ExtIEs >-----#
    Satellite_Information_BDS_KP_Item_ExtIEs = CLASS(name='Satellite-Information-BDS-KP-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Satellite_Information_BDS_KP_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ALM-ECEFsbasAlmanacSet >-----#
    GANSS_ALM_ECEFsbasAlmanacSet = SEQ(name='GANSS-ALM-ECEFsbasAlmanacSet', mode=MODE_TYPE)
    _GANSS_ALM_ECEFsbasAlmanacSet_sat_info_SBASecefList = SEQ_OF(name='sat-info-SBASecefList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SAT-Info-Almanac-SBASecefList')))
    _GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id._const_tab = ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id_tab
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item_._ext = None
    _GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions._cont = __GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item_
    _GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_ECEFsbasAlmanacSet._cont = ASN1Dict([
        ('sat-info-SBASecefList', _GANSS_ALM_ECEFsbasAlmanacSet_sat_info_SBASecefList),
        ('ie-Extensions', _GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions),
        ])
    GANSS_ALM_ECEFsbasAlmanacSet._ext = []
    
    #-----< GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs >-----#
    GANSS_ALM_ECEFsbasAlmanacSet_ExtIEs = CLASS(name='GANSS-ALM-ECEFsbasAlmanacSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_ECEFsbasAlmanacSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ALM-GlonassAlmanacSet >-----#
    GANSS_ALM_GlonassAlmanacSet = SEQ(name='GANSS-ALM-GlonassAlmanacSet', mode=MODE_TYPE)
    _GANSS_ALM_GlonassAlmanacSet_sat_info_GLOkpList = SEQ_OF(name='sat-info-GLOkpList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SAT-Info-Almanac-GLOkpList')))
    _GANSS_ALM_GlonassAlmanacSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id._const_tab = ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id_tab
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item_._ext = None
    _GANSS_ALM_GlonassAlmanacSet_ie_Extensions._cont = __GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item_
    _GANSS_ALM_GlonassAlmanacSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_GlonassAlmanacSet._cont = ASN1Dict([
        ('sat-info-GLOkpList', _GANSS_ALM_GlonassAlmanacSet_sat_info_GLOkpList),
        ('ie-Extensions', _GANSS_ALM_GlonassAlmanacSet_ie_Extensions),
        ])
    GANSS_ALM_GlonassAlmanacSet._ext = []
    
    #-----< GANSS-ALM-GlonassAlmanacSet-ExtIEs >-----#
    GANSS_ALM_GlonassAlmanacSet_ExtIEs = CLASS(name='GANSS-ALM-GlonassAlmanacSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_GlonassAlmanacSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ALM-MidiAlmanacSet >-----#
    GANSS_ALM_MidiAlmanacSet = SEQ(name='GANSS-ALM-MidiAlmanacSet', mode=MODE_TYPE)
    _GANSS_ALM_MidiAlmanacSet_t_oa = INT(name='t-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ALM_MidiAlmanacSet_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_ALM_MidiAlmanacSet_sat_info_MIDIkpList = SEQ_OF(name='sat-info-MIDIkpList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SAT-Info-Almanac-MIDIkpList')))
    _GANSS_ALM_MidiAlmanacSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_MidiAlmanacSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id._const_tab = ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id_tab
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_MidiAlmanacSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_MidiAlmanacSet_ie_Extensions__item_._ext = None
    _GANSS_ALM_MidiAlmanacSet_ie_Extensions._cont = __GANSS_ALM_MidiAlmanacSet_ie_Extensions__item_
    _GANSS_ALM_MidiAlmanacSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_MidiAlmanacSet._cont = ASN1Dict([
        ('t-oa', _GANSS_ALM_MidiAlmanacSet_t_oa),
        ('sat-info-MIDIkpList', _GANSS_ALM_MidiAlmanacSet_sat_info_MIDIkpList),
        ('ie-Extensions', _GANSS_ALM_MidiAlmanacSet_ie_Extensions),
        ])
    GANSS_ALM_MidiAlmanacSet._ext = []
    
    #-----< GANSS-ALM-MidiAlmanacSet-ExtIEs >-----#
    GANSS_ALM_MidiAlmanacSet_ExtIEs = CLASS(name='GANSS-ALM-MidiAlmanacSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_MidiAlmanacSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ALM-NAVKeplerianSet >-----#
    GANSS_ALM_NAVKeplerianSet = SEQ(name='GANSS-ALM-NAVKeplerianSet', mode=MODE_TYPE)
    _GANSS_ALM_NAVKeplerianSet_t_oa = INT(name='t-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ALM_NAVKeplerianSet_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_ALM_NAVKeplerianSet_sat_info_NAVkpList = SEQ_OF(name='sat-info-NAVkpList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SAT-Info-Almanac-NAVkpList')))
    _GANSS_ALM_NAVKeplerianSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_NAVKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id._const_tab = ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id_tab
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_NAVKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_NAVKeplerianSet_ie_Extensions__item_._ext = None
    _GANSS_ALM_NAVKeplerianSet_ie_Extensions._cont = __GANSS_ALM_NAVKeplerianSet_ie_Extensions__item_
    _GANSS_ALM_NAVKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_NAVKeplerianSet._cont = ASN1Dict([
        ('t-oa', _GANSS_ALM_NAVKeplerianSet_t_oa),
        ('sat-info-NAVkpList', _GANSS_ALM_NAVKeplerianSet_sat_info_NAVkpList),
        ('ie-Extensions', _GANSS_ALM_NAVKeplerianSet_ie_Extensions),
        ])
    GANSS_ALM_NAVKeplerianSet._ext = []
    
    #-----< GANSS-ALM-NAVKeplerianSet-ExtIEs >-----#
    GANSS_ALM_NAVKeplerianSet_ExtIEs = CLASS(name='GANSS-ALM-NAVKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_NAVKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ALM-ReducedKeplerianSet >-----#
    GANSS_ALM_ReducedKeplerianSet = SEQ(name='GANSS-ALM-ReducedKeplerianSet', mode=MODE_TYPE)
    _GANSS_ALM_ReducedKeplerianSet_t_oa = INT(name='t-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ALM_ReducedKeplerianSet_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_ALM_ReducedKeplerianSet_sat_info_REDkpList = SEQ_OF(name='sat-info-REDkpList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SAT-Info-Almanac-REDkpList')))
    _GANSS_ALM_ReducedKeplerianSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id._const_tab = ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id_tab
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality._const_tab = ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality_tab
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id),
        ('criticality', ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item_._ext = None
    _GANSS_ALM_ReducedKeplerianSet_ie_Extensions._cont = __GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item_
    _GANSS_ALM_ReducedKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ALM_ReducedKeplerianSet._cont = ASN1Dict([
        ('t-oa', _GANSS_ALM_ReducedKeplerianSet_t_oa),
        ('sat-info-REDkpList', _GANSS_ALM_ReducedKeplerianSet_sat_info_REDkpList),
        ('ie-Extensions', _GANSS_ALM_ReducedKeplerianSet_ie_Extensions),
        ])
    GANSS_ALM_ReducedKeplerianSet._ext = []
    
    #-----< GANSS-ALM-ReducedKeplerianSet-ExtIEs >-----#
    GANSS_ALM_ReducedKeplerianSet_ExtIEs = CLASS(name='GANSS-ALM-ReducedKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_ALM_ReducedKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-AlmanacAndSatelliteHealth >-----#
    GANSS_AlmanacAndSatelliteHealth = SEQ(name='GANSS-AlmanacAndSatelliteHealth', mode=MODE_TYPE)
    _GANSS_AlmanacAndSatelliteHealth_weekNumber = INT(name='weekNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_AlmanacAndSatelliteHealth_weekNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _GANSS_AlmanacAndSatelliteHealth_gANSS_AlmanacModel = CHOICE(name='gANSS-AlmanacModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AlmanacModel')))
    _GANSS_AlmanacAndSatelliteHealth_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id_tab_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CompleteAlmanacProvided')))
    ____GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 120), ('criticality', 'ignore'), ('Extension', _____GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id._const_tab = ____GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id_tab
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__criticality._const_tab = ____GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id_tab
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__extensionValue._const_tab = ____GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id_tab
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id),
        ('criticality', ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__extensionValue),
        ])
    __GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item_._ext = None
    _GANSS_AlmanacAndSatelliteHealth_ie_Extensions._cont = __GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item_
    _GANSS_AlmanacAndSatelliteHealth_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_AlmanacAndSatelliteHealth._cont = ASN1Dict([
        ('weekNumber', _GANSS_AlmanacAndSatelliteHealth_weekNumber),
        ('gANSS-AlmanacModel', _GANSS_AlmanacAndSatelliteHealth_gANSS_AlmanacModel),
        ('ie-Extensions', _GANSS_AlmanacAndSatelliteHealth_ie_Extensions),
        ])
    GANSS_AlmanacAndSatelliteHealth._ext = []
    
    #-----< GANSS-AlmanacAndSatelliteHealth-ExtIEs >-----#
    GANSS_AlmanacAndSatelliteHealth_ExtIEs = CLASS(name='GANSS-AlmanacAndSatelliteHealth-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSS_AlmanacAndSatelliteHealth_ExtIEs_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CompleteAlmanacProvided')))
    GANSS_AlmanacAndSatelliteHealth_ExtIEs._val = ASN1Set(rv=[dict([('id', 120), ('criticality', 'ignore'), ('Extension', _GANSS_AlmanacAndSatelliteHealth_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-AlmanacModel >-----#
    GANSS_AlmanacModel = CHOICE(name='GANSS-AlmanacModel', mode=MODE_TYPE)
    _GANSS_AlmanacModel_gANSS_keplerianParameters = SEQ(name='gANSS-keplerianParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-KeplerianParametersAlm')))
    _GANSS_AlmanacModel_extension_GANSS_AlmanacModel = SEQ(name='extension-GANSS-AlmanacModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Extension-GANSS-AlmanacModel')))
    GANSS_AlmanacModel._cont = ASN1Dict([
        ('gANSS-keplerianParameters', _GANSS_AlmanacModel_gANSS_keplerianParameters),
        ('extension-GANSS-AlmanacModel', _GANSS_AlmanacModel_extension_GANSS_AlmanacModel),
        ])
    GANSS_AlmanacModel._ext = ['extension-GANSS-AlmanacModel']
    
    #-----< Extension-GANSS-AlmanacModel >-----#
    Extension_GANSS_AlmanacModel = SEQ(name='Extension-GANSS-AlmanacModel', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_GANSS_AlmanacModel_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    __Extension_GANSS_AlmanacModel_id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-NAVKeplerianSet')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-ReducedKeplerianSet')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-MidiAlmanacSet')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-GlonassAlmanacSet')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-ECEFsbasAlmanacSet')))
    ___Extension_GANSS_AlmanacModel_id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-BDSKeplericanset')))
    __Extension_GANSS_AlmanacModel_id_tab._val = ASN1Set(rv=[dict([('id', 109), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 110), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 111), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 113), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', ___Extension_GANSS_AlmanacModel_id_tab_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_GANSS_AlmanacModel_id._const_tab = __Extension_GANSS_AlmanacModel_id_tab
    _Extension_GANSS_AlmanacModel_id._const_tab_at = None
    _Extension_GANSS_AlmanacModel_id._const_tab_id = 'id'
    _Extension_GANSS_AlmanacModel_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    _Extension_GANSS_AlmanacModel_criticality._const_tab = __Extension_GANSS_AlmanacModel_id_tab
    _Extension_GANSS_AlmanacModel_criticality._const_tab_at = ('..', 'id')
    _Extension_GANSS_AlmanacModel_criticality._const_tab_id = 'criticality'
    _Extension_GANSS_AlmanacModel_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    _Extension_GANSS_AlmanacModel_value._const_tab = __Extension_GANSS_AlmanacModel_id_tab
    _Extension_GANSS_AlmanacModel_value._const_tab_at = ('..', 'id')
    _Extension_GANSS_AlmanacModel_value._const_tab_id = 'Value'
    Extension_GANSS_AlmanacModel._cont = ASN1Dict([
        ('id', _Extension_GANSS_AlmanacModel_id),
        ('criticality', _Extension_GANSS_AlmanacModel_criticality),
        ('value', _Extension_GANSS_AlmanacModel_value),
        ])
    Extension_GANSS_AlmanacModel._ext = None
    
    #-----< Extension-GANSS-AlmanacModel-IE >-----#
    Extension_GANSS_AlmanacModel_IE = CLASS(name='Extension-GANSS-AlmanacModel-IE', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-NAVKeplerianSet')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-ReducedKeplerianSet')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-MidiAlmanacSet')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-GlonassAlmanacSet')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-ECEFsbasAlmanacSet')))
    _Extension_GANSS_AlmanacModel_IE_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ALM-BDSKeplericanset')))
    Extension_GANSS_AlmanacModel_IE._val = ASN1Set(rv=[dict([('id', 109), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 110), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_1), ('presence', 'mandatory')]), dict([('id', 111), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_2), ('presence', 'mandatory')]), dict([('id', 112), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_3), ('presence', 'mandatory')]), dict([('id', 113), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_4), ('presence', 'mandatory')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _Extension_GANSS_AlmanacModel_IE_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< GANSS-Auxiliary-Information >-----#
    GANSS_Auxiliary_Information = CHOICE(name='GANSS-Auxiliary-Information', mode=MODE_TYPE)
    _GANSS_Auxiliary_Information_ganssID1 = SEQ_OF(name='ganssID1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AuxInfoGANSS-ID1')))
    _GANSS_Auxiliary_Information_ganssID3 = SEQ_OF(name='ganssID3', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AuxInfoGANSS-ID3')))
    GANSS_Auxiliary_Information._cont = ASN1Dict([
        ('ganssID1', _GANSS_Auxiliary_Information_ganssID1),
        ('ganssID3', _GANSS_Auxiliary_Information_ganssID3),
        ])
    GANSS_Auxiliary_Information._ext = []
    
    #-----< GANSS-AzimuthAndElevation >-----#
    GANSS_AzimuthAndElevation = SEQ(name='GANSS-AzimuthAndElevation', mode=MODE_TYPE)
    _GANSS_AzimuthAndElevation_azimuth = INT(name='azimuth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_AzimuthAndElevation_azimuth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _GANSS_AzimuthAndElevation_elevation = INT(name='elevation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_AzimuthAndElevation_elevation._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=75)], ev=None, er=[])
    _GANSS_AzimuthAndElevation_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_AzimuthAndElevation_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_AzimuthAndElevation_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_AzimuthAndElevation_ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AzimuthAndElevationLSB')))
    ____GANSS_AzimuthAndElevation_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 119), ('criticality', 'ignore'), ('Extension', _____GANSS_AzimuthAndElevation_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__id._const_tab = ____GANSS_AzimuthAndElevation_ie_Extensions__item__id_tab
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__criticality._const_tab = ____GANSS_AzimuthAndElevation_ie_Extensions__item__id_tab
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__extensionValue._const_tab = ____GANSS_AzimuthAndElevation_ie_Extensions__item__id_tab
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_AzimuthAndElevation_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_AzimuthAndElevation_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_AzimuthAndElevation_ie_Extensions__item__id),
        ('criticality', ___GANSS_AzimuthAndElevation_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_AzimuthAndElevation_ie_Extensions__item__extensionValue),
        ])
    __GANSS_AzimuthAndElevation_ie_Extensions__item_._ext = None
    _GANSS_AzimuthAndElevation_ie_Extensions._cont = __GANSS_AzimuthAndElevation_ie_Extensions__item_
    _GANSS_AzimuthAndElevation_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_AzimuthAndElevation._cont = ASN1Dict([
        ('azimuth', _GANSS_AzimuthAndElevation_azimuth),
        ('elevation', _GANSS_AzimuthAndElevation_elevation),
        ('ie-Extensions', _GANSS_AzimuthAndElevation_ie_Extensions),
        ])
    GANSS_AzimuthAndElevation._ext = []
    
    #-----< GANSS-AzimuthAndElevation-ExtIEs >-----#
    GANSS_AzimuthAndElevation_ExtIEs = CLASS(name='GANSS-AzimuthAndElevation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSS_AzimuthAndElevation_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AzimuthAndElevationLSB')))
    GANSS_AzimuthAndElevation_ExtIEs._val = ASN1Set(rv=[dict([('id', 119), ('criticality', 'ignore'), ('Extension', _GANSS_AzimuthAndElevation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Clock-Model >-----#
    GANSS_Clock_Model = SEQ_OF(name='GANSS-Clock-Model', mode=MODE_TYPE)
    _GANSS_Clock_Model__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SatelliteClockModelItem')))
    GANSS_Clock_Model._cont = _GANSS_Clock_Model__item_
    GANSS_Clock_Model._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< GANSS-CommonAssistanceData >-----#
    GANSS_CommonAssistanceData = SEQ(name='GANSS-CommonAssistanceData', mode=MODE_TYPE)
    _GANSS_CommonAssistanceData_ganss_Reference_Time = SEQ(name='ganss-Reference-Time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Reference-Time')), opt=True)
    _GANSS_CommonAssistanceData_ganss_Ionospheric_Model = SEQ(name='ganss-Ionospheric-Model', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Ionospheric-Model')), opt=True)
    _GANSS_CommonAssistanceData_ganss_Reference_Location = SEQ(name='ganss-Reference-Location', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Reference-Location')), opt=True)
    _GANSS_CommonAssistanceData_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_CommonAssistanceData_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_CommonAssistanceData_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Additional-Ionospheric-Model')))
    _____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Earth-Orientation-Parameters')))
    ____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 88), ('criticality', 'ignore'), ('Extension', _____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 89), ('criticality', 'ignore'), ('Extension', _____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_CommonAssistanceData_ie_Extensions__item__id._const_tab = ____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab
    ___GANSS_CommonAssistanceData_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_CommonAssistanceData_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_CommonAssistanceData_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_CommonAssistanceData_ie_Extensions__item__criticality._const_tab = ____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab
    ___GANSS_CommonAssistanceData_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_CommonAssistanceData_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_CommonAssistanceData_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_CommonAssistanceData_ie_Extensions__item__extensionValue._const_tab = ____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab
    ___GANSS_CommonAssistanceData_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_CommonAssistanceData_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_CommonAssistanceData_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_CommonAssistanceData_ie_Extensions__item__id),
        ('criticality', ___GANSS_CommonAssistanceData_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_CommonAssistanceData_ie_Extensions__item__extensionValue),
        ])
    __GANSS_CommonAssistanceData_ie_Extensions__item_._ext = None
    _GANSS_CommonAssistanceData_ie_Extensions._cont = __GANSS_CommonAssistanceData_ie_Extensions__item_
    _GANSS_CommonAssistanceData_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_CommonAssistanceData._cont = ASN1Dict([
        ('ganss-Reference-Time', _GANSS_CommonAssistanceData_ganss_Reference_Time),
        ('ganss-Ionospheric-Model', _GANSS_CommonAssistanceData_ganss_Ionospheric_Model),
        ('ganss-Reference-Location', _GANSS_CommonAssistanceData_ganss_Reference_Location),
        ('ie-Extensions', _GANSS_CommonAssistanceData_ie_Extensions),
        ])
    GANSS_CommonAssistanceData._ext = []
    
    #-----< GANSS-CommonAssistanceData-ExtIEs >-----#
    GANSS_CommonAssistanceData_ExtIEs = CLASS(name='GANSS-CommonAssistanceData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSS_CommonAssistanceData_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Additional-Ionospheric-Model')))
    _GANSS_CommonAssistanceData_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Earth-Orientation-Parameters')))
    GANSS_CommonAssistanceData_ExtIEs._val = ASN1Set(rv=[dict([('id', 88), ('criticality', 'ignore'), ('Extension', _GANSS_CommonAssistanceData_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 89), ('criticality', 'ignore'), ('Extension', _GANSS_CommonAssistanceData_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Data-Bit-Assistance >-----#
    GANSS_Data_Bit_Assistance = SEQ(name='GANSS-Data-Bit-Assistance', mode=MODE_TYPE)
    _GANSS_Data_Bit_Assistance_ganssTod = INT(name='ganssTod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Data_Bit_Assistance_ganssTod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=[], er=[])
    _GANSS_Data_Bit_Assistance_dataBitAssistancelist = SEQ_OF(name='dataBitAssistancelist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-DataBitAssistanceList')))
    _GANSS_Data_Bit_Assistance_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Data_Bit_Assistance_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id._const_tab = ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality._const_tab = ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Data_Bit_Assistance_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id),
        ('criticality', ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Data_Bit_Assistance_ie_Extensions__item_._ext = None
    _GANSS_Data_Bit_Assistance_ie_Extensions._cont = __GANSS_Data_Bit_Assistance_ie_Extensions__item_
    _GANSS_Data_Bit_Assistance_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Data_Bit_Assistance._cont = ASN1Dict([
        ('ganssTod', _GANSS_Data_Bit_Assistance_ganssTod),
        ('dataBitAssistancelist', _GANSS_Data_Bit_Assistance_dataBitAssistancelist),
        ('ie-Extensions', _GANSS_Data_Bit_Assistance_ie_Extensions),
        ])
    GANSS_Data_Bit_Assistance._ext = []
    
    #-----< GANSS-Data-Bit-Assistance-ExtIEs >-----#
    GANSS_Data_Bit_Assistance_ExtIEs = CLASS(name='GANSS-Data-Bit-Assistance-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_Data_Bit_Assistance_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-DataBitAssistanceList >-----#
    GANSS_DataBitAssistanceList = SEQ_OF(name='GANSS-DataBitAssistanceList', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-DataBitAssistanceItem')))
    GANSS_DataBitAssistanceList._cont = _GANSS_DataBitAssistanceList__item_
    GANSS_DataBitAssistanceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-DataBitAssistanceItem >-----#
    GANSS_DataBitAssistanceItem = SEQ(name='GANSS-DataBitAssistanceItem', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceItem_satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_DataBitAssistanceItem_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_DataBitAssistanceItem_dataBitAssistanceSgnList = SEQ_OF(name='dataBitAssistanceSgnList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-DataBitAssistanceSgnList')))
    _GANSS_DataBitAssistanceItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_DataBitAssistanceItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id._const_tab = ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality._const_tab = ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_DataBitAssistanceItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_DataBitAssistanceItem_ie_Extensions__item_._ext = None
    _GANSS_DataBitAssistanceItem_ie_Extensions._cont = __GANSS_DataBitAssistanceItem_ie_Extensions__item_
    _GANSS_DataBitAssistanceItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_DataBitAssistanceItem._cont = ASN1Dict([
        ('satId', _GANSS_DataBitAssistanceItem_satId),
        ('dataBitAssistanceSgnList', _GANSS_DataBitAssistanceItem_dataBitAssistanceSgnList),
        ('ie-Extensions', _GANSS_DataBitAssistanceItem_ie_Extensions),
        ])
    GANSS_DataBitAssistanceItem._ext = []
    
    #-----< GANSS-DataBitAssistanceItem-ExtIEs >-----#
    GANSS_DataBitAssistanceItem_ExtIEs = CLASS(name='GANSS-DataBitAssistanceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_DataBitAssistanceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-DataBitAssistanceSgnList >-----#
    GANSS_DataBitAssistanceSgnList = SEQ_OF(name='GANSS-DataBitAssistanceSgnList', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceSgnList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-DataBitAssistanceSgnItem')))
    GANSS_DataBitAssistanceSgnList._cont = _GANSS_DataBitAssistanceSgnList__item_
    GANSS_DataBitAssistanceSgnList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSS-DataBitAssistanceSgnItem >-----#
    GANSS_DataBitAssistanceSgnItem = SEQ(name='GANSS-DataBitAssistanceSgnItem', mode=MODE_TYPE)
    _GANSS_DataBitAssistanceSgnItem_ganss_SignalId = SEQ(name='ganss-SignalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SignalID')))
    _GANSS_DataBitAssistanceSgnItem_ganssDataBits = BIT_STR(name='ganssDataBits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_DataBitAssistanceSgnItem_ganssDataBits._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _GANSS_DataBitAssistanceSgnItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id._const_tab = ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality._const_tab = ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_._ext = None
    _GANSS_DataBitAssistanceSgnItem_ie_Extensions._cont = __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_
    _GANSS_DataBitAssistanceSgnItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_DataBitAssistanceSgnItem._cont = ASN1Dict([
        ('ganss-SignalId', _GANSS_DataBitAssistanceSgnItem_ganss_SignalId),
        ('ganssDataBits', _GANSS_DataBitAssistanceSgnItem_ganssDataBits),
        ('ie-Extensions', _GANSS_DataBitAssistanceSgnItem_ie_Extensions),
        ])
    GANSS_DataBitAssistanceSgnItem._ext = []
    
    #-----< GANSS-DataBitAssistanceSgnItem-ExtIEs >-----#
    GANSS_DataBitAssistanceSgnItem_ExtIEs = CLASS(name='GANSS-DataBitAssistanceSgnItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_DataBitAssistanceSgnItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Earth-Orientation-Parameters >-----#
    GANSS_Earth_Orientation_Parameters = SEQ(name='GANSS-Earth-Orientation-Parameters', mode=MODE_TYPE)
    _GANSS_Earth_Orientation_Parameters_teop = BIT_STR(name='teop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_teop._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmX = BIT_STR(name='pmX', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmX._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmXdot = BIT_STR(name='pmXdot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmXdot._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmY = BIT_STR(name='pmY', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmY._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_pmYdot = BIT_STR(name='pmYdot', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_pmYdot._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_deltaUT1 = BIT_STR(name='deltaUT1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_deltaUT1._const_sz = ASN1Set(rv=[31], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_deltaUT1dot = BIT_STR(name='deltaUT1dot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Earth_Orientation_Parameters_deltaUT1dot._const_sz = ASN1Set(rv=[19], rr=[], ev=None, er=[])
    _GANSS_Earth_Orientation_Parameters_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id._const_tab = ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality._const_tab = ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id),
        ('criticality', ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_._ext = None
    _GANSS_Earth_Orientation_Parameters_ie_Extensions._cont = __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_
    _GANSS_Earth_Orientation_Parameters_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Earth_Orientation_Parameters._cont = ASN1Dict([
        ('teop', _GANSS_Earth_Orientation_Parameters_teop),
        ('pmX', _GANSS_Earth_Orientation_Parameters_pmX),
        ('pmXdot', _GANSS_Earth_Orientation_Parameters_pmXdot),
        ('pmY', _GANSS_Earth_Orientation_Parameters_pmY),
        ('pmYdot', _GANSS_Earth_Orientation_Parameters_pmYdot),
        ('deltaUT1', _GANSS_Earth_Orientation_Parameters_deltaUT1),
        ('deltaUT1dot', _GANSS_Earth_Orientation_Parameters_deltaUT1dot),
        ('ie-Extensions', _GANSS_Earth_Orientation_Parameters_ie_Extensions),
        ])
    GANSS_Earth_Orientation_Parameters._ext = []
    
    #-----< GANSS-Earth-Orientation-Parameters-ExtIEs >-----#
    GANSS_Earth_Orientation_Parameters_ExtIEs = CLASS(name='GANSS-Earth-Orientation-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_Earth_Orientation_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ExtraDoppler >-----#
    GANSS_ExtraDoppler = SEQ(name='GANSS-ExtraDoppler', mode=MODE_TYPE)
    _GANSS_ExtraDoppler_dopplerFirstOrder = INT(name='dopplerFirstOrder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ExtraDoppler_dopplerFirstOrder._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-42, ub=21)], ev=None, er=[])
    _GANSS_ExtraDoppler_dopplerUncertainty = ENUM(name='dopplerUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ExtraDoppler_dopplerUncertainty._cont = ASN1Dict([('dH40', 0), ('dH20', 1), ('dH10', 2), ('dH5', 3), ('dH2-5', 4)])
    _GANSS_ExtraDoppler_dopplerUncertainty._ext = None
    _GANSS_ExtraDoppler_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ExtraDoppler_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ExtraDoppler_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ExtraDoppler_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ExtraDoppler_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ExtraDoppler_ie_Extensions__item__id._const_tab = ____GANSS_ExtraDoppler_ie_Extensions__item__id_tab
    ___GANSS_ExtraDoppler_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ExtraDoppler_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ExtraDoppler_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ExtraDoppler_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ExtraDoppler_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ExtraDoppler_ie_Extensions__item__criticality._const_tab = ____GANSS_ExtraDoppler_ie_Extensions__item__criticality_tab
    ___GANSS_ExtraDoppler_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ExtraDoppler_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ExtraDoppler_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ExtraDoppler_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ExtraDoppler_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ExtraDoppler_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ExtraDoppler_ie_Extensions__item__extensionValue_tab
    ___GANSS_ExtraDoppler_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ExtraDoppler_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ExtraDoppler_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ExtraDoppler_ie_Extensions__item__id),
        ('criticality', ___GANSS_ExtraDoppler_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ExtraDoppler_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ExtraDoppler_ie_Extensions__item_._ext = None
    _GANSS_ExtraDoppler_ie_Extensions._cont = __GANSS_ExtraDoppler_ie_Extensions__item_
    _GANSS_ExtraDoppler_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ExtraDoppler._cont = ASN1Dict([
        ('dopplerFirstOrder', _GANSS_ExtraDoppler_dopplerFirstOrder),
        ('dopplerUncertainty', _GANSS_ExtraDoppler_dopplerUncertainty),
        ('ie-Extensions', _GANSS_ExtraDoppler_ie_Extensions),
        ])
    GANSS_ExtraDoppler._ext = []
    
    #-----< GANSS-ExtraDoppler-ExtIEs >-----#
    GANSS_ExtraDoppler_ExtIEs = CLASS(name='GANSS-ExtraDoppler-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_ExtraDoppler_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ExtraDopplerExtension >-----#
    GANSS_ExtraDopplerExtension = SEQ(name='GANSS-ExtraDopplerExtension', mode=MODE_TYPE)
    _GANSS_ExtraDopplerExtension_dopplerFirstOrder = INT(name='dopplerFirstOrder', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ExtraDopplerExtension_dopplerFirstOrder._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-42, ub=21)], ev=None, er=[])
    _GANSS_ExtraDopplerExtension_dopplerUncertaintyExtension = ENUM(name='dopplerUncertaintyExtension', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ExtraDopplerExtension_dopplerUncertaintyExtension._cont = ASN1Dict([('dH60', 0), ('dH80', 1), ('dH100', 2), ('dH120', 3), ('noInformation', 4)])
    _GANSS_ExtraDopplerExtension_dopplerUncertaintyExtension._ext = None
    _GANSS_ExtraDopplerExtension_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ExtraDopplerExtension_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ExtraDopplerExtension_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ExtraDopplerExtension_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__id._const_tab = ____GANSS_ExtraDopplerExtension_ie_Extensions__item__id_tab
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ExtraDopplerExtension_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ExtraDopplerExtension_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__criticality._const_tab = ____GANSS_ExtraDopplerExtension_ie_Extensions__item__criticality_tab
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ExtraDopplerExtension_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ExtraDopplerExtension_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ExtraDopplerExtension_ie_Extensions__item__extensionValue_tab
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ExtraDopplerExtension_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ExtraDopplerExtension_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ExtraDopplerExtension_ie_Extensions__item__id),
        ('criticality', ___GANSS_ExtraDopplerExtension_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ExtraDopplerExtension_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ExtraDopplerExtension_ie_Extensions__item_._ext = None
    _GANSS_ExtraDopplerExtension_ie_Extensions._cont = __GANSS_ExtraDopplerExtension_ie_Extensions__item_
    _GANSS_ExtraDopplerExtension_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ExtraDopplerExtension._cont = ASN1Dict([
        ('dopplerFirstOrder', _GANSS_ExtraDopplerExtension_dopplerFirstOrder),
        ('dopplerUncertaintyExtension', _GANSS_ExtraDopplerExtension_dopplerUncertaintyExtension),
        ('ie-Extensions', _GANSS_ExtraDopplerExtension_ie_Extensions),
        ])
    GANSS_ExtraDopplerExtension._ext = []
    
    #-----< GANSS-ExtraDopplerExtension-ExtIEs >-----#
    GANSS_ExtraDopplerExtension_ExtIEs = CLASS(name='GANSS-ExtraDopplerExtension-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_ExtraDopplerExtension_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-GenericAssistanceDataList >-----#
    GANSS_GenericAssistanceDataList = SEQ_OF(name='GANSS-GenericAssistanceDataList', mode=MODE_TYPE)
    _GANSS_GenericAssistanceDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSSGenericAssistanceData')))
    GANSS_GenericAssistanceDataList._cont = _GANSS_GenericAssistanceDataList__item_
    GANSS_GenericAssistanceDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSSGenericAssistanceData >-----#
    GANSSGenericAssistanceData = SEQ(name='GANSSGenericAssistanceData', mode=MODE_TYPE)
    _GANSSGenericAssistanceData_ganssId = SEQ(name='ganssId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    _GANSSGenericAssistanceData_ganss_Real_Time_Integrity = SEQ_OF(name='ganss-Real-Time-Integrity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Real-Time-Integrity')), opt=True)
    _GANSSGenericAssistanceData_ganss_DataBitAssistance = SEQ(name='ganss-DataBitAssistance', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Data-Bit-Assistance')), opt=True)
    _GANSSGenericAssistanceData_dganss_Corrections = SEQ(name='dganss-Corrections', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DGANSS-Corrections')), opt=True)
    _GANSSGenericAssistanceData_ganss_AlmanacAndSatelliteHealth = SEQ(name='ganss-AlmanacAndSatelliteHealth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AlmanacAndSatelliteHealth')), opt=True)
    _GANSSGenericAssistanceData_ganss_ReferenceMeasurementInfo = SEQ(name='ganss-ReferenceMeasurementInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ReferenceMeasurementInfo')), opt=True)
    _GANSSGenericAssistanceData_ganss_UTC_Model = SEQ(name='ganss-UTC-Model', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-UTC-Model')), opt=True)
    _GANSSGenericAssistanceData_ganss_Time_Model = SEQ(name='ganss-Time-Model', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Time-Model')), opt=True)
    _GANSSGenericAssistanceData_ganss_Navigation_Model = SEQ(name='ganss-Navigation-Model', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Navigation-Model')), opt=True)
    _GANSSGenericAssistanceData_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSSGenericAssistanceData_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSSGenericAssistanceData_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSSGenericAssistanceData_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Additional-Time-Models')))
    _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Additional-Navigation-Models')))
    _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Additional-UTC-Models')))
    _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Auxiliary-Information')))
    _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SBAS-ID')))
    _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'BDS-Ionospheric-Grid-Model')))
    _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DBDS-Correction-Information')))
    ____GANSSGenericAssistanceData_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 90), ('criticality', 'ignore'), ('Extension', _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Extension', _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 92), ('criticality', 'ignore'), ('Extension', _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'ignore'), ('Extension', _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'ignore'), ('Extension', _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 131), ('criticality', 'ignore'), ('Extension', _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 132), ('criticality', 'ignore'), ('Extension', _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSSGenericAssistanceData_ie_Extensions__item__id._const_tab = ____GANSSGenericAssistanceData_ie_Extensions__item__id_tab
    ___GANSSGenericAssistanceData_ie_Extensions__item__id._const_tab_at = None
    ___GANSSGenericAssistanceData_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSSGenericAssistanceData_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSSGenericAssistanceData_ie_Extensions__item__criticality._const_tab = ____GANSSGenericAssistanceData_ie_Extensions__item__id_tab
    ___GANSSGenericAssistanceData_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSSGenericAssistanceData_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSSGenericAssistanceData_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSSGenericAssistanceData_ie_Extensions__item__extensionValue._const_tab = ____GANSSGenericAssistanceData_ie_Extensions__item__id_tab
    ___GANSSGenericAssistanceData_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSSGenericAssistanceData_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSSGenericAssistanceData_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSSGenericAssistanceData_ie_Extensions__item__id),
        ('criticality', ___GANSSGenericAssistanceData_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSSGenericAssistanceData_ie_Extensions__item__extensionValue),
        ])
    __GANSSGenericAssistanceData_ie_Extensions__item_._ext = None
    _GANSSGenericAssistanceData_ie_Extensions._cont = __GANSSGenericAssistanceData_ie_Extensions__item_
    _GANSSGenericAssistanceData_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSSGenericAssistanceData._cont = ASN1Dict([
        ('ganssId', _GANSSGenericAssistanceData_ganssId),
        ('ganss-Real-Time-Integrity', _GANSSGenericAssistanceData_ganss_Real_Time_Integrity),
        ('ganss-DataBitAssistance', _GANSSGenericAssistanceData_ganss_DataBitAssistance),
        ('dganss-Corrections', _GANSSGenericAssistanceData_dganss_Corrections),
        ('ganss-AlmanacAndSatelliteHealth', _GANSSGenericAssistanceData_ganss_AlmanacAndSatelliteHealth),
        ('ganss-ReferenceMeasurementInfo', _GANSSGenericAssistanceData_ganss_ReferenceMeasurementInfo),
        ('ganss-UTC-Model', _GANSSGenericAssistanceData_ganss_UTC_Model),
        ('ganss-Time-Model', _GANSSGenericAssistanceData_ganss_Time_Model),
        ('ganss-Navigation-Model', _GANSSGenericAssistanceData_ganss_Navigation_Model),
        ('ie-Extensions', _GANSSGenericAssistanceData_ie_Extensions),
        ])
    GANSSGenericAssistanceData._ext = []
    
    #-----< GANSSGenericAssistance-ExtIEs >-----#
    GANSSGenericAssistance_ExtIEs = CLASS(name='GANSSGenericAssistance-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSSGenericAssistance_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Additional-Time-Models')))
    _GANSSGenericAssistance_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Additional-Navigation-Models')))
    _GANSSGenericAssistance_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Additional-UTC-Models')))
    _GANSSGenericAssistance_ExtIEs_val_Extension_3 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Auxiliary-Information')))
    _GANSSGenericAssistance_ExtIEs_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SBAS-ID')))
    _GANSSGenericAssistance_ExtIEs_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'BDS-Ionospheric-Grid-Model')))
    _GANSSGenericAssistance_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DBDS-Correction-Information')))
    GANSSGenericAssistance_ExtIEs._val = ASN1Set(rv=[dict([('id', 90), ('criticality', 'ignore'), ('Extension', _GANSSGenericAssistance_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 91), ('criticality', 'ignore'), ('Extension', _GANSSGenericAssistance_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 92), ('criticality', 'ignore'), ('Extension', _GANSSGenericAssistance_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'ignore'), ('Extension', _GANSSGenericAssistance_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'ignore'), ('Extension', _GANSSGenericAssistance_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 131), ('criticality', 'ignore'), ('Extension', _GANSSGenericAssistance_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 132), ('criticality', 'ignore'), ('Extension', _GANSSGenericAssistance_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BDS-Ionospheric-Grid-Model >-----#
    BDS_Ionospheric_Grid_Model = SEQ(name='BDS-Ionospheric-Grid-Model', mode=MODE_TYPE)
    _BDS_Ionospheric_Grid_Model_bDS_Reference_Time = INT(name='bDS-Reference-Time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'BDS-Reference-Time')))
    _BDS_Ionospheric_Grid_Model_bDS_Ionospheric_Grid_Information = SEQ_OF(name='bDS-Ionospheric-Grid-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'BDS-Ionospheric-Grid-Information')))
    _BDS_Ionospheric_Grid_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BDS_Ionospheric_Grid_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id._const_tab = ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__id_tab
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id._const_tab_at = None
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality._const_tab = ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality_tab
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue._const_tab = ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue_tab
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BDS_Ionospheric_Grid_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id),
        ('criticality', ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue),
        ])
    __BDS_Ionospheric_Grid_Model_ie_Extensions__item_._ext = None
    _BDS_Ionospheric_Grid_Model_ie_Extensions._cont = __BDS_Ionospheric_Grid_Model_ie_Extensions__item_
    _BDS_Ionospheric_Grid_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BDS_Ionospheric_Grid_Model._cont = ASN1Dict([
        ('bDS-Reference-Time', _BDS_Ionospheric_Grid_Model_bDS_Reference_Time),
        ('bDS-Ionospheric-Grid-Information', _BDS_Ionospheric_Grid_Model_bDS_Ionospheric_Grid_Information),
        ('ie-Extensions', _BDS_Ionospheric_Grid_Model_ie_Extensions),
        ])
    BDS_Ionospheric_Grid_Model._ext = []
    
    #-----< BDS-Ionospheric-Grid-Model-ExtIEs >-----#
    BDS_Ionospheric_Grid_Model_ExtIEs = CLASS(name='BDS-Ionospheric-Grid-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    BDS_Ionospheric_Grid_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BDS-Reference-Time >-----#
    BDS_Reference_Time = INT(name='BDS-Reference-Time', mode=MODE_TYPE)
    BDS_Reference_Time._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3570)], ev=None, er=[])
    
    #-----< BDS-Ionospheric-Grid-Information >-----#
    BDS_Ionospheric_Grid_Information = SEQ_OF(name='BDS-Ionospheric-Grid-Information', mode=MODE_TYPE)
    _BDS_Ionospheric_Grid_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __BDS_Ionospheric_Grid_Information__item__iGP_number_BDS = INT(name='iGP-number-BDS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __BDS_Ionospheric_Grid_Information__item__iGP_number_BDS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=None, er=[])
    __BDS_Ionospheric_Grid_Information__item__vertical_Delay_BDS = BIT_STR(name='vertical-Delay-BDS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __BDS_Ionospheric_Grid_Information__item__vertical_Delay_BDS._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    __BDS_Ionospheric_Grid_Information__item__gIVEI_BDS = BIT_STR(name='gIVEI-BDS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __BDS_Ionospheric_Grid_Information__item__gIVEI_BDS._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    __BDS_Ionospheric_Grid_Information__item__ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___BDS_Ionospheric_Grid_Information__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__id._const_tab = _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__id_tab
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__id._const_tab_at = None
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__id._const_tab_id = 'id'
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__criticality._const_tab = _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__criticality_tab
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__extensionValue._const_tab = _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__extensionValue_tab
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___BDS_Ionospheric_Grid_Information__item__ie_Extensions__item_._cont = ASN1Dict([
        ('id', ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__id),
        ('criticality', ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__criticality),
        ('extensionValue', ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__extensionValue),
        ])
    ___BDS_Ionospheric_Grid_Information__item__ie_Extensions__item_._ext = None
    __BDS_Ionospheric_Grid_Information__item__ie_Extensions._cont = ___BDS_Ionospheric_Grid_Information__item__ie_Extensions__item_
    __BDS_Ionospheric_Grid_Information__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _BDS_Ionospheric_Grid_Information__item_._cont = ASN1Dict([
        ('iGP-number-BDS', __BDS_Ionospheric_Grid_Information__item__iGP_number_BDS),
        ('vertical-Delay-BDS', __BDS_Ionospheric_Grid_Information__item__vertical_Delay_BDS),
        ('gIVEI-BDS', __BDS_Ionospheric_Grid_Information__item__gIVEI_BDS),
        ('ie-Extensions', __BDS_Ionospheric_Grid_Information__item__ie_Extensions),
        ])
    _BDS_Ionospheric_Grid_Information__item_._ext = []
    BDS_Ionospheric_Grid_Information._cont = _BDS_Ionospheric_Grid_Information__item_
    BDS_Ionospheric_Grid_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=320)], ev=None, er=[])
    
    #-----< BDS-Ionospheric-Grid-Information-ExtIEs >-----#
    BDS_Ionospheric_Grid_Information_ExtIEs = CLASS(name='BDS-Ionospheric-Grid-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    BDS_Ionospheric_Grid_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DBDS-Correction-Information >-----#
    DBDS_Correction_Information = SEQ(name='DBDS-Correction-Information', mode=MODE_TYPE)
    _DBDS_Correction_Information_bDS_Reference_Time = INT(name='bDS-Reference-Time', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'BDS-Reference-Time')))
    _DBDS_Correction_Information_dBDS_Information = SEQ_OF(name='dBDS-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DBDS-Information')))
    _DBDS_Correction_Information_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDS_Correction_Information_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DBDS_Correction_Information_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DBDS_Correction_Information_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DBDS_Correction_Information_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Correction_Information_ie_Extensions__item__id._const_tab = ____DBDS_Correction_Information_ie_Extensions__item__id_tab
    ___DBDS_Correction_Information_ie_Extensions__item__id._const_tab_at = None
    ___DBDS_Correction_Information_ie_Extensions__item__id._const_tab_id = 'id'
    ___DBDS_Correction_Information_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DBDS_Correction_Information_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DBDS_Correction_Information_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Correction_Information_ie_Extensions__item__criticality._const_tab = ____DBDS_Correction_Information_ie_Extensions__item__criticality_tab
    ___DBDS_Correction_Information_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DBDS_Correction_Information_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DBDS_Correction_Information_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DBDS_Correction_Information_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DBDS_Correction_Information_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Correction_Information_ie_Extensions__item__extensionValue._const_tab = ____DBDS_Correction_Information_ie_Extensions__item__extensionValue_tab
    ___DBDS_Correction_Information_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DBDS_Correction_Information_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DBDS_Correction_Information_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___DBDS_Correction_Information_ie_Extensions__item__id),
        ('criticality', ___DBDS_Correction_Information_ie_Extensions__item__criticality),
        ('extensionValue', ___DBDS_Correction_Information_ie_Extensions__item__extensionValue),
        ])
    __DBDS_Correction_Information_ie_Extensions__item_._ext = None
    _DBDS_Correction_Information_ie_Extensions._cont = __DBDS_Correction_Information_ie_Extensions__item_
    _DBDS_Correction_Information_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDS_Correction_Information._cont = ASN1Dict([
        ('bDS-Reference-Time', _DBDS_Correction_Information_bDS_Reference_Time),
        ('dBDS-Information', _DBDS_Correction_Information_dBDS_Information),
        ('ie-Extensions', _DBDS_Correction_Information_ie_Extensions),
        ])
    DBDS_Correction_Information._ext = []
    
    #-----< DBDS-Correction-Information-ExtIEs >-----#
    DBDS_Correction_Information_ExtIEs = CLASS(name='DBDS-Correction-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DBDS_Correction_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DBDS-Information >-----#
    DBDS_Information = SEQ_OF(name='DBDS-Information', mode=MODE_TYPE)
    _DBDS_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __DBDS_Information__item__dBDS_Signal_ID = SEQ(name='dBDS-Signal-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    __DBDS_Information__item__dGANSS_Signal_Information = SEQ_OF(name='dGANSS-Signal-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DGANSS-Signal-Information')))
    __DBDS_Information__item__ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___DBDS_Information__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____DBDS_Information__item__ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____DBDS_Information__item__ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____DBDS_Information__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DBDS_Information__item__ie_Extensions__item__id._const_tab = _____DBDS_Information__item__ie_Extensions__item__id_tab
    ____DBDS_Information__item__ie_Extensions__item__id._const_tab_at = None
    ____DBDS_Information__item__ie_Extensions__item__id._const_tab_id = 'id'
    ____DBDS_Information__item__ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____DBDS_Information__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____DBDS_Information__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DBDS_Information__item__ie_Extensions__item__criticality._const_tab = _____DBDS_Information__item__ie_Extensions__item__criticality_tab
    ____DBDS_Information__item__ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____DBDS_Information__item__ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ____DBDS_Information__item__ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____DBDS_Information__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____DBDS_Information__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DBDS_Information__item__ie_Extensions__item__extensionValue._const_tab = _____DBDS_Information__item__ie_Extensions__item__extensionValue_tab
    ____DBDS_Information__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____DBDS_Information__item__ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___DBDS_Information__item__ie_Extensions__item_._cont = ASN1Dict([
        ('id', ____DBDS_Information__item__ie_Extensions__item__id),
        ('criticality', ____DBDS_Information__item__ie_Extensions__item__criticality),
        ('extensionValue', ____DBDS_Information__item__ie_Extensions__item__extensionValue),
        ])
    ___DBDS_Information__item__ie_Extensions__item_._ext = None
    __DBDS_Information__item__ie_Extensions._cont = ___DBDS_Information__item__ie_Extensions__item_
    __DBDS_Information__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _DBDS_Information__item_._cont = ASN1Dict([
        ('dBDS-Signal-ID', __DBDS_Information__item__dBDS_Signal_ID),
        ('dGANSS-Signal-Information', __DBDS_Information__item__dGANSS_Signal_Information),
        ('ie-Extensions', __DBDS_Information__item__ie_Extensions),
        ])
    _DBDS_Information__item_._ext = []
    DBDS_Information._cont = _DBDS_Information__item_
    DBDS_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< DBDS-Information-ExtIEs >-----#
    DBDS_Information_ExtIEs = CLASS(name='DBDS-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DBDS_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGANSS-Signal-Information >-----#
    DGANSS_Signal_Information = SEQ_OF(name='DGANSS-Signal-Information', mode=MODE_TYPE)
    _DGANSS_Signal_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __DGANSS_Signal_Information__item__sat_ID_BDS = INT(name='sat-ID-BDS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DGANSS_Signal_Information__item__sat_ID_BDS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __DGANSS_Signal_Information__item__uDREI_BDS = INT(name='uDREI-BDS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DGANSS_Signal_Information__item__uDREI_BDS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    __DGANSS_Signal_Information__item__rURAI_BDS = INT(name='rURAI-BDS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DGANSS_Signal_Information__item__rURAI_BDS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    __DGANSS_Signal_Information__item__delta_t_BDS = BIT_STR(name='delta-t-BDS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __DGANSS_Signal_Information__item__delta_t_BDS._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    __DGANSS_Signal_Information__item__ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___DGANSS_Signal_Information__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____DGANSS_Signal_Information__item__ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____DGANSS_Signal_Information__item__ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____DGANSS_Signal_Information__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DGANSS_Signal_Information__item__ie_Extensions__item__id._const_tab = _____DGANSS_Signal_Information__item__ie_Extensions__item__id_tab
    ____DGANSS_Signal_Information__item__ie_Extensions__item__id._const_tab_at = None
    ____DGANSS_Signal_Information__item__ie_Extensions__item__id._const_tab_id = 'id'
    ____DGANSS_Signal_Information__item__ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____DGANSS_Signal_Information__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____DGANSS_Signal_Information__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DGANSS_Signal_Information__item__ie_Extensions__item__criticality._const_tab = _____DGANSS_Signal_Information__item__ie_Extensions__item__criticality_tab
    ____DGANSS_Signal_Information__item__ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____DGANSS_Signal_Information__item__ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ____DGANSS_Signal_Information__item__ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____DGANSS_Signal_Information__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____DGANSS_Signal_Information__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DGANSS_Signal_Information__item__ie_Extensions__item__extensionValue._const_tab = _____DGANSS_Signal_Information__item__ie_Extensions__item__extensionValue_tab
    ____DGANSS_Signal_Information__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____DGANSS_Signal_Information__item__ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___DGANSS_Signal_Information__item__ie_Extensions__item_._cont = ASN1Dict([
        ('id', ____DGANSS_Signal_Information__item__ie_Extensions__item__id),
        ('criticality', ____DGANSS_Signal_Information__item__ie_Extensions__item__criticality),
        ('extensionValue', ____DGANSS_Signal_Information__item__ie_Extensions__item__extensionValue),
        ])
    ___DGANSS_Signal_Information__item__ie_Extensions__item_._ext = None
    __DGANSS_Signal_Information__item__ie_Extensions._cont = ___DGANSS_Signal_Information__item__ie_Extensions__item_
    __DGANSS_Signal_Information__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _DGANSS_Signal_Information__item_._cont = ASN1Dict([
        ('sat-ID-BDS', __DGANSS_Signal_Information__item__sat_ID_BDS),
        ('uDREI-BDS', __DGANSS_Signal_Information__item__uDREI_BDS),
        ('rURAI-BDS', __DGANSS_Signal_Information__item__rURAI_BDS),
        ('delta-t-BDS', __DGANSS_Signal_Information__item__delta_t_BDS),
        ('ie-Extensions', __DGANSS_Signal_Information__item__ie_Extensions),
        ])
    _DGANSS_Signal_Information__item_._ext = []
    DGANSS_Signal_Information._cont = _DGANSS_Signal_Information__item_
    DGANSS_Signal_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< DGANSS-Signal-Information-ExtIEs >-----#
    DGANSS_Signal_Information_ExtIEs = CLASS(name='DGANSS-Signal-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DGANSS_Signal_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-GenericMeasurementInfo >-----#
    GANSS_GenericMeasurementInfo = SEQ_OF(name='GANSS-GenericMeasurementInfo', mode=MODE_TYPE)
    _GANSS_GenericMeasurementInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_GenericMeasurementInfo__item__ganssId = SEQ(name='ganssId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    __GANSS_GenericMeasurementInfo__item__ganssMeasurementSignalList = SEQ_OF(name='ganssMeasurementSignalList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSMeasurementSignalList')))
    __GANSS_GenericMeasurementInfo__item__ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_GenericMeasurementInfo__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__id._const_tab = _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__id_tab
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__id._const_tab_id = 'id'
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__criticality._const_tab = _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__criticality_tab
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___GANSS_GenericMeasurementInfo__item__ie_Extensions__item_._cont = ASN1Dict([
        ('id', ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__id),
        ('criticality', ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__criticality),
        ('extensionValue', ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_GenericMeasurementInfo__item__ie_Extensions__item_._ext = None
    __GANSS_GenericMeasurementInfo__item__ie_Extensions._cont = ___GANSS_GenericMeasurementInfo__item__ie_Extensions__item_
    __GANSS_GenericMeasurementInfo__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_GenericMeasurementInfo__item_._cont = ASN1Dict([
        ('ganssId', __GANSS_GenericMeasurementInfo__item__ganssId),
        ('ganssMeasurementSignalList', __GANSS_GenericMeasurementInfo__item__ganssMeasurementSignalList),
        ('ie-Extensions', __GANSS_GenericMeasurementInfo__item__ie_Extensions),
        ])
    _GANSS_GenericMeasurementInfo__item_._ext = []
    GANSS_GenericMeasurementInfo._cont = _GANSS_GenericMeasurementInfo__item_
    GANSS_GenericMeasurementInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSS-GenericMeasurementInfo-ExtIEs >-----#
    GANSS_GenericMeasurementInfo_ExtIEs = CLASS(name='GANSS-GenericMeasurementInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_GenericMeasurementInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSSID >-----#
    GANSSID = SEQ(name='GANSSID', mode=MODE_TYPE)
    _GANSSID_ganss_ID = INT(name='ganss-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSSID_ganss_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _GANSSID_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSSID_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSSID_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSSID_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSSID_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSSID_ie_Extensions__item__id._const_tab = ____GANSSID_ie_Extensions__item__id_tab
    ___GANSSID_ie_Extensions__item__id._const_tab_at = None
    ___GANSSID_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSSID_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSSID_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSSID_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSSID_ie_Extensions__item__criticality._const_tab = ____GANSSID_ie_Extensions__item__criticality_tab
    ___GANSSID_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSSID_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSSID_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSSID_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSSID_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSSID_ie_Extensions__item__extensionValue._const_tab = ____GANSSID_ie_Extensions__item__extensionValue_tab
    ___GANSSID_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSSID_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSSID_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSSID_ie_Extensions__item__id),
        ('criticality', ___GANSSID_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSSID_ie_Extensions__item__extensionValue),
        ])
    __GANSSID_ie_Extensions__item_._ext = None
    _GANSSID_ie_Extensions._cont = __GANSSID_ie_Extensions__item_
    _GANSSID_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSSID._cont = ASN1Dict([
        ('ganss-ID', _GANSSID_ganss_ID),
        ('ie-Extensions', _GANSSID_ie_Extensions),
        ])
    GANSSID._ext = []
    
    #-----< GANSSID-ExtIEs >-----#
    GANSSID_ExtIEs = CLASS(name='GANSSID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSSID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSSMeasurementSignalList >-----#
    GANSSMeasurementSignalList = SEQ_OF(name='GANSSMeasurementSignalList', mode=MODE_TYPE)
    _GANSSMeasurementSignalList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSSMeasurementSignalList__item__ganssSignalId = SEQ(name='ganssSignalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SignalID')), opt=True)
    __GANSSMeasurementSignalList__item__ganssCodePhaseAmbiguity = INT(name='ganssCodePhaseAmbiguity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __GANSSMeasurementSignalList__item__ganssCodePhaseAmbiguity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    __GANSSMeasurementSignalList__item__ganssMeasurementParameters = SEQ_OF(name='ganssMeasurementParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-MeasurementParameters')))
    __GANSSMeasurementSignalList__item__ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSSMeasurementSignalList__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____GANSSMeasurementSignalList__item__ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______GANSSMeasurementSignalList__item__ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GanssCodePhaseAmbiguityExt')))
    _____GANSSMeasurementSignalList__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'ignore'), ('Extension', ______GANSSMeasurementSignalList__item__ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__id._const_tab = _____GANSSMeasurementSignalList__item__ie_Extensions__item__id_tab
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__id._const_tab_id = 'id'
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__criticality._const_tab = _____GANSSMeasurementSignalList__item__ie_Extensions__item__id_tab
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__extensionValue._const_tab = _____GANSSMeasurementSignalList__item__ie_Extensions__item__id_tab
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____GANSSMeasurementSignalList__item__ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___GANSSMeasurementSignalList__item__ie_Extensions__item_._cont = ASN1Dict([
        ('id', ____GANSSMeasurementSignalList__item__ie_Extensions__item__id),
        ('criticality', ____GANSSMeasurementSignalList__item__ie_Extensions__item__criticality),
        ('extensionValue', ____GANSSMeasurementSignalList__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSSMeasurementSignalList__item__ie_Extensions__item_._ext = None
    __GANSSMeasurementSignalList__item__ie_Extensions._cont = ___GANSSMeasurementSignalList__item__ie_Extensions__item_
    __GANSSMeasurementSignalList__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSSMeasurementSignalList__item_._cont = ASN1Dict([
        ('ganssSignalId', __GANSSMeasurementSignalList__item__ganssSignalId),
        ('ganssCodePhaseAmbiguity', __GANSSMeasurementSignalList__item__ganssCodePhaseAmbiguity),
        ('ganssMeasurementParameters', __GANSSMeasurementSignalList__item__ganssMeasurementParameters),
        ('ie-Extensions', __GANSSMeasurementSignalList__item__ie_Extensions),
        ])
    _GANSSMeasurementSignalList__item_._ext = []
    GANSSMeasurementSignalList._cont = _GANSSMeasurementSignalList__item_
    GANSSMeasurementSignalList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSSMeasurementSignalList-ExtIEs >-----#
    GANSSMeasurementSignalList_ExtIEs = CLASS(name='GANSSMeasurementSignalList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSSMeasurementSignalList_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GanssCodePhaseAmbiguityExt')))
    GANSSMeasurementSignalList_ExtIEs._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'ignore'), ('Extension', _GANSSMeasurementSignalList_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GanssCodePhaseAmbiguityExt >-----#
    GanssCodePhaseAmbiguityExt = SEQ(name='GanssCodePhaseAmbiguityExt', mode=MODE_TYPE)
    _GanssCodePhaseAmbiguityExt_ganssCodePhaseAmbiguity_ext = INT(name='ganssCodePhaseAmbiguity-ext', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssCodePhaseAmbiguityExt_ganssCodePhaseAmbiguity_ext._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=127)], ev=None, er=[])
    _GanssCodePhaseAmbiguityExt_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GanssCodePhaseAmbiguityExt_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__id._const_tab = ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__id_tab
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__id._const_tab_at = None
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__id._const_tab_id = 'id'
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__criticality._const_tab = ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__criticality_tab
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__extensionValue._const_tab = ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__extensionValue_tab
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GanssCodePhaseAmbiguityExt_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__id),
        ('criticality', ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__criticality),
        ('extensionValue', ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__extensionValue),
        ])
    __GanssCodePhaseAmbiguityExt_ie_Extensions__item_._ext = None
    _GanssCodePhaseAmbiguityExt_ie_Extensions._cont = __GanssCodePhaseAmbiguityExt_ie_Extensions__item_
    _GanssCodePhaseAmbiguityExt_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GanssCodePhaseAmbiguityExt._cont = ASN1Dict([
        ('ganssCodePhaseAmbiguity-ext', _GanssCodePhaseAmbiguityExt_ganssCodePhaseAmbiguity_ext),
        ('ie-Extensions', _GanssCodePhaseAmbiguityExt_ie_Extensions),
        ])
    GanssCodePhaseAmbiguityExt._ext = []
    
    #-----< GanssCodePhaseAmbiguityExt-ExtIEs >-----#
    GanssCodePhaseAmbiguityExt_ExtIEs = CLASS(name='GanssCodePhaseAmbiguityExt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GanssCodePhaseAmbiguityExt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Ionospheric-Model >-----#
    GANSS_Ionospheric_Model = SEQ(name='GANSS-Ionospheric-Model', mode=MODE_TYPE)
    _GANSS_Ionospheric_Model_alpha_zero_ionos = BIT_STR(name='alpha-zero-ionos', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Ionospheric_Model_alpha_zero_ionos._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_Ionospheric_Model_alpha_one_ionos = BIT_STR(name='alpha-one-ionos', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Ionospheric_Model_alpha_one_ionos._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_Ionospheric_Model_alpha_two_ionos = BIT_STR(name='alpha-two-ionos', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Ionospheric_Model_alpha_two_ionos._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_Ionospheric_Model_gANSS_IonosphereRegionalStormFlags = SEQ(name='gANSS-IonosphereRegionalStormFlags', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-IonosphereRegionalStormFlags')), opt=True)
    _GANSS_Ionospheric_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Ionospheric_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id._const_tab = ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Ionospheric_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Ionospheric_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Ionospheric_Model_ie_Extensions__item__id),
        ('criticality', ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Ionospheric_Model_ie_Extensions__item_._ext = None
    _GANSS_Ionospheric_Model_ie_Extensions._cont = __GANSS_Ionospheric_Model_ie_Extensions__item_
    _GANSS_Ionospheric_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Ionospheric_Model._cont = ASN1Dict([
        ('alpha-zero-ionos', _GANSS_Ionospheric_Model_alpha_zero_ionos),
        ('alpha-one-ionos', _GANSS_Ionospheric_Model_alpha_one_ionos),
        ('alpha-two-ionos', _GANSS_Ionospheric_Model_alpha_two_ionos),
        ('gANSS-IonosphereRegionalStormFlags', _GANSS_Ionospheric_Model_gANSS_IonosphereRegionalStormFlags),
        ('ie-Extensions', _GANSS_Ionospheric_Model_ie_Extensions),
        ])
    GANSS_Ionospheric_Model._ext = []
    
    #-----< GANSS-Ionospheric-Model-ExtIEs >-----#
    GANSS_Ionospheric_Model_ExtIEs = CLASS(name='GANSS-Ionospheric-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_Ionospheric_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-IonosphereRegionalStormFlags >-----#
    GANSS_IonosphereRegionalStormFlags = SEQ(name='GANSS-IonosphereRegionalStormFlags', mode=MODE_TYPE)
    _GANSS_IonosphereRegionalStormFlags_storm_flag_one = BOOL(name='storm-flag-one', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_two = BOOL(name='storm-flag-two', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_three = BOOL(name='storm-flag-three', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_four = BOOL(name='storm-flag-four', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_storm_flag_five = BOOL(name='storm-flag-five', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_IonosphereRegionalStormFlags_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id._const_tab = ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality._const_tab = ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue._const_tab = ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id),
        ('criticality', ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue),
        ])
    __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_._ext = None
    _GANSS_IonosphereRegionalStormFlags_ie_Extensions._cont = __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_
    _GANSS_IonosphereRegionalStormFlags_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_IonosphereRegionalStormFlags._cont = ASN1Dict([
        ('storm-flag-one', _GANSS_IonosphereRegionalStormFlags_storm_flag_one),
        ('storm-flag-two', _GANSS_IonosphereRegionalStormFlags_storm_flag_two),
        ('storm-flag-three', _GANSS_IonosphereRegionalStormFlags_storm_flag_three),
        ('storm-flag-four', _GANSS_IonosphereRegionalStormFlags_storm_flag_four),
        ('storm-flag-five', _GANSS_IonosphereRegionalStormFlags_storm_flag_five),
        ('ie-Extensions', _GANSS_IonosphereRegionalStormFlags_ie_Extensions),
        ])
    GANSS_IonosphereRegionalStormFlags._ext = []
    
    #-----< GANSS-IonosphereRegionalStormFlags-ExtIEs >-----#
    GANSS_IonosphereRegionalStormFlags_ExtIEs = CLASS(name='GANSS-IonosphereRegionalStormFlags-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_IonosphereRegionalStormFlags_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-KeplerianParametersAlm >-----#
    GANSS_KeplerianParametersAlm = SEQ(name='GANSS-KeplerianParametersAlm', mode=MODE_TYPE)
    _GANSS_KeplerianParametersAlm_t_oa = INT(name='t-oa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersAlm_t_oa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _GANSS_KeplerianParametersAlm_iod_a = INT(name='iod-a', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersAlm_iod_a._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _GANSS_KeplerianParametersAlm_gANSS_SatelliteInformationKP = SEQ_OF(name='gANSS-SatelliteInformationKP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SatelliteInformationKP')))
    _GANSS_KeplerianParametersAlm_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_KeplerianParametersAlm_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id._const_tab = ____GANSS_KeplerianParametersAlm_ie_Extensions__item__id_tab
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality._const_tab = ____GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality_tab
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue._const_tab = ____GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue_tab
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_KeplerianParametersAlm_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id),
        ('criticality', ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue),
        ])
    __GANSS_KeplerianParametersAlm_ie_Extensions__item_._ext = None
    _GANSS_KeplerianParametersAlm_ie_Extensions._cont = __GANSS_KeplerianParametersAlm_ie_Extensions__item_
    _GANSS_KeplerianParametersAlm_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_KeplerianParametersAlm._cont = ASN1Dict([
        ('t-oa', _GANSS_KeplerianParametersAlm_t_oa),
        ('iod-a', _GANSS_KeplerianParametersAlm_iod_a),
        ('gANSS-SatelliteInformationKP', _GANSS_KeplerianParametersAlm_gANSS_SatelliteInformationKP),
        ('ie-Extensions', _GANSS_KeplerianParametersAlm_ie_Extensions),
        ])
    GANSS_KeplerianParametersAlm._ext = []
    
    #-----< GANSS-KeplerianParametersAlm-ExtIEs >-----#
    GANSS_KeplerianParametersAlm_ExtIEs = CLASS(name='GANSS-KeplerianParametersAlm-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_KeplerianParametersAlm_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-KeplerianParametersOrb >-----#
    GANSS_KeplerianParametersOrb = SEQ(name='GANSS-KeplerianParametersOrb', mode=MODE_TYPE)
    _GANSS_KeplerianParametersOrb_toe_nav = BIT_STR(name='toe-nav', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_toe_nav._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_ganss_omega_nav = BIT_STR(name='ganss-omega-nav', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_ganss_omega_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_delta_n_nav = BIT_STR(name='delta-n-nav', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_delta_n_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_m_zero_nav = BIT_STR(name='m-zero-nav', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_m_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_omegadot_nav = BIT_STR(name='omegadot-nav', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_omegadot_nav._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_ganss_e_nav = BIT_STR(name='ganss-e-nav', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_ganss_e_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_idot_nav = BIT_STR(name='idot-nav', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_idot_nav._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_a_sqrt_nav = BIT_STR(name='a-sqrt-nav', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_a_sqrt_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_i_zero_nav = BIT_STR(name='i-zero-nav', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_i_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_omega_zero_nav = BIT_STR(name='omega-zero-nav', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_omega_zero_nav._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_rs_nav = BIT_STR(name='c-rs-nav', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_rs_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_is_nav = BIT_STR(name='c-is-nav', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_is_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_us_nav = BIT_STR(name='c-us-nav', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_us_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_rc_nav = BIT_STR(name='c-rc-nav', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_rc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_ic_nav = BIT_STR(name='c-ic-nav', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_ic_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_c_uc_nav = BIT_STR(name='c-uc-nav', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_KeplerianParametersOrb_c_uc_nav._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_KeplerianParametersOrb_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_KeplerianParametersOrb_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id._const_tab = ____GANSS_KeplerianParametersOrb_ie_Extensions__item__id_tab
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality._const_tab = ____GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality_tab
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue._const_tab = ____GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue_tab
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_KeplerianParametersOrb_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id),
        ('criticality', ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue),
        ])
    __GANSS_KeplerianParametersOrb_ie_Extensions__item_._ext = None
    _GANSS_KeplerianParametersOrb_ie_Extensions._cont = __GANSS_KeplerianParametersOrb_ie_Extensions__item_
    _GANSS_KeplerianParametersOrb_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_KeplerianParametersOrb._cont = ASN1Dict([
        ('toe-nav', _GANSS_KeplerianParametersOrb_toe_nav),
        ('ganss-omega-nav', _GANSS_KeplerianParametersOrb_ganss_omega_nav),
        ('delta-n-nav', _GANSS_KeplerianParametersOrb_delta_n_nav),
        ('m-zero-nav', _GANSS_KeplerianParametersOrb_m_zero_nav),
        ('omegadot-nav', _GANSS_KeplerianParametersOrb_omegadot_nav),
        ('ganss-e-nav', _GANSS_KeplerianParametersOrb_ganss_e_nav),
        ('idot-nav', _GANSS_KeplerianParametersOrb_idot_nav),
        ('a-sqrt-nav', _GANSS_KeplerianParametersOrb_a_sqrt_nav),
        ('i-zero-nav', _GANSS_KeplerianParametersOrb_i_zero_nav),
        ('omega-zero-nav', _GANSS_KeplerianParametersOrb_omega_zero_nav),
        ('c-rs-nav', _GANSS_KeplerianParametersOrb_c_rs_nav),
        ('c-is-nav', _GANSS_KeplerianParametersOrb_c_is_nav),
        ('c-us-nav', _GANSS_KeplerianParametersOrb_c_us_nav),
        ('c-rc-nav', _GANSS_KeplerianParametersOrb_c_rc_nav),
        ('c-ic-nav', _GANSS_KeplerianParametersOrb_c_ic_nav),
        ('c-uc-nav', _GANSS_KeplerianParametersOrb_c_uc_nav),
        ('ie-Extensions', _GANSS_KeplerianParametersOrb_ie_Extensions),
        ])
    GANSS_KeplerianParametersOrb._ext = []
    
    #-----< GANSS-KeplerianParametersOrb-ExtIEs >-----#
    GANSS_KeplerianParametersOrb_ExtIEs = CLASS(name='GANSS-KeplerianParametersOrb-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_KeplerianParametersOrb_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-MeasurementParameters >-----#
    GANSS_MeasurementParameters = SEQ_OF(name='GANSS-MeasurementParameters', mode=MODE_TYPE)
    _GANSS_MeasurementParameters__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-MeasurementParametersItem')))
    GANSS_MeasurementParameters._cont = _GANSS_MeasurementParameters__item_
    GANSS_MeasurementParameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-MeasurementParametersItem >-----#
    GANSS_MeasurementParametersItem = SEQ(name='GANSS-MeasurementParametersItem', mode=MODE_TYPE)
    _GANSS_MeasurementParametersItem_satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_MeasurementParametersItem_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_MeasurementParametersItem_cToNzero = INT(name='cToNzero', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_MeasurementParametersItem_cToNzero._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_MeasurementParametersItem_multipathIndicator = ENUM(name='multipathIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_MeasurementParametersItem_multipathIndicator._cont = ASN1Dict([('nM', 0), ('low', 1), ('medium', 2), ('high', 3)])
    _GANSS_MeasurementParametersItem_multipathIndicator._ext = None
    _GANSS_MeasurementParametersItem_carrierQualityIndication = BIT_STR(name='carrierQualityIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_MeasurementParametersItem_carrierQualityIndication._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_MeasurementParametersItem_ganssCodePhase = INT(name='ganssCodePhase', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_MeasurementParametersItem_ganssCodePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2097151)], ev=None, er=[])
    _GANSS_MeasurementParametersItem_ganssIntegerCodePhase = INT(name='ganssIntegerCodePhase', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_MeasurementParametersItem_ganssIntegerCodePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_MeasurementParametersItem_codePhaseRmsError = INT(name='codePhaseRmsError', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_MeasurementParametersItem_codePhaseRmsError._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_MeasurementParametersItem_doppler = INT(name='doppler', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_MeasurementParametersItem_doppler._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _GANSS_MeasurementParametersItem_adr = INT(name='adr', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_MeasurementParametersItem_adr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=33554431)], ev=None, er=[])
    _GANSS_MeasurementParametersItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_MeasurementParametersItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_MeasurementParametersItem_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_MeasurementParametersItem_ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GanssIntegerCodePhaseExt')))
    ____GANSS_MeasurementParametersItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 100), ('criticality', 'ignore'), ('Extension', _____GANSS_MeasurementParametersItem_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__id._const_tab = ____GANSS_MeasurementParametersItem_ie_Extensions__item__id_tab
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__criticality._const_tab = ____GANSS_MeasurementParametersItem_ie_Extensions__item__id_tab
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_MeasurementParametersItem_ie_Extensions__item__id_tab
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_MeasurementParametersItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_MeasurementParametersItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_MeasurementParametersItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_MeasurementParametersItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_MeasurementParametersItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_MeasurementParametersItem_ie_Extensions__item_._ext = None
    _GANSS_MeasurementParametersItem_ie_Extensions._cont = __GANSS_MeasurementParametersItem_ie_Extensions__item_
    _GANSS_MeasurementParametersItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_MeasurementParametersItem._cont = ASN1Dict([
        ('satId', _GANSS_MeasurementParametersItem_satId),
        ('cToNzero', _GANSS_MeasurementParametersItem_cToNzero),
        ('multipathIndicator', _GANSS_MeasurementParametersItem_multipathIndicator),
        ('carrierQualityIndication', _GANSS_MeasurementParametersItem_carrierQualityIndication),
        ('ganssCodePhase', _GANSS_MeasurementParametersItem_ganssCodePhase),
        ('ganssIntegerCodePhase', _GANSS_MeasurementParametersItem_ganssIntegerCodePhase),
        ('codePhaseRmsError', _GANSS_MeasurementParametersItem_codePhaseRmsError),
        ('doppler', _GANSS_MeasurementParametersItem_doppler),
        ('adr', _GANSS_MeasurementParametersItem_adr),
        ('ie-Extensions', _GANSS_MeasurementParametersItem_ie_Extensions),
        ])
    GANSS_MeasurementParametersItem._ext = []
    
    #-----< GANSS-MeasurementParametersItem-ExtIEs >-----#
    GANSS_MeasurementParametersItem_ExtIEs = CLASS(name='GANSS-MeasurementParametersItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSS_MeasurementParametersItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GanssIntegerCodePhaseExt')))
    GANSS_MeasurementParametersItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 100), ('criticality', 'ignore'), ('Extension', _GANSS_MeasurementParametersItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GanssIntegerCodePhaseExt >-----#
    GanssIntegerCodePhaseExt = SEQ(name='GanssIntegerCodePhaseExt', mode=MODE_TYPE)
    _GanssIntegerCodePhaseExt_ganssIntegerCodePhase_ext = INT(name='ganssIntegerCodePhase-ext', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssIntegerCodePhaseExt_ganssIntegerCodePhase_ext._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=64, ub=127)], ev=None, er=[])
    _GanssIntegerCodePhaseExt_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GanssIntegerCodePhaseExt_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GanssIntegerCodePhaseExt_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GanssIntegerCodePhaseExt_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__id._const_tab = ____GanssIntegerCodePhaseExt_ie_Extensions__item__id_tab
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__id._const_tab_at = None
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__id._const_tab_id = 'id'
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GanssIntegerCodePhaseExt_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GanssIntegerCodePhaseExt_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__criticality._const_tab = ____GanssIntegerCodePhaseExt_ie_Extensions__item__criticality_tab
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GanssIntegerCodePhaseExt_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GanssIntegerCodePhaseExt_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__extensionValue._const_tab = ____GanssIntegerCodePhaseExt_ie_Extensions__item__extensionValue_tab
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GanssIntegerCodePhaseExt_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GanssIntegerCodePhaseExt_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GanssIntegerCodePhaseExt_ie_Extensions__item__id),
        ('criticality', ___GanssIntegerCodePhaseExt_ie_Extensions__item__criticality),
        ('extensionValue', ___GanssIntegerCodePhaseExt_ie_Extensions__item__extensionValue),
        ])
    __GanssIntegerCodePhaseExt_ie_Extensions__item_._ext = None
    _GanssIntegerCodePhaseExt_ie_Extensions._cont = __GanssIntegerCodePhaseExt_ie_Extensions__item_
    _GanssIntegerCodePhaseExt_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GanssIntegerCodePhaseExt._cont = ASN1Dict([
        ('ganssIntegerCodePhase-ext', _GanssIntegerCodePhaseExt_ganssIntegerCodePhase_ext),
        ('ie-Extensions', _GanssIntegerCodePhaseExt_ie_Extensions),
        ])
    GanssIntegerCodePhaseExt._ext = []
    
    #-----< GanssIntegerCodePhaseExt-ExtIEs >-----#
    GanssIntegerCodePhaseExt_ExtIEs = CLASS(name='GanssIntegerCodePhaseExt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GanssIntegerCodePhaseExt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-MeasuredResultsList >-----#
    GANSS_MeasuredResultsList = SEQ_OF(name='GANSS-MeasuredResultsList', mode=MODE_TYPE)
    _GANSS_MeasuredResultsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-MeasuredResults')))
    GANSS_MeasuredResultsList._cont = _GANSS_MeasuredResultsList__item_
    GANSS_MeasuredResultsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< GANSS-MeasuredResults >-----#
    GANSS_MeasuredResults = SEQ(name='GANSS-MeasuredResults', mode=MODE_TYPE)
    _GANSS_MeasuredResults_referenceTime = CHOICE(name='referenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __GANSS_MeasuredResults_referenceTime_utranReferenceTime = SEQ(name='utranReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GANSSReferenceTimeUL')))
    __GANSS_MeasuredResults_referenceTime_ganssReferenceTimeOnly = SEQ(name='ganssReferenceTimeOnly', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ReferenceTimeOnly')))
    _GANSS_MeasuredResults_referenceTime._cont = ASN1Dict([
        ('utranReferenceTime', __GANSS_MeasuredResults_referenceTime_utranReferenceTime),
        ('ganssReferenceTimeOnly', __GANSS_MeasuredResults_referenceTime_ganssReferenceTimeOnly),
        ])
    _GANSS_MeasuredResults_referenceTime._ext = []
    _GANSS_MeasuredResults_ganssGenericMeasurementInfo = SEQ_OF(name='ganssGenericMeasurementInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-GenericMeasurementInfo')))
    _GANSS_MeasuredResults_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_MeasuredResults_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_MeasuredResults_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_MeasuredResults_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_MeasuredResults_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_MeasuredResults_ie_Extensions__item__id._const_tab = ____GANSS_MeasuredResults_ie_Extensions__item__id_tab
    ___GANSS_MeasuredResults_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_MeasuredResults_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_MeasuredResults_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_MeasuredResults_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_MeasuredResults_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_MeasuredResults_ie_Extensions__item__criticality._const_tab = ____GANSS_MeasuredResults_ie_Extensions__item__criticality_tab
    ___GANSS_MeasuredResults_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_MeasuredResults_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_MeasuredResults_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_MeasuredResults_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_MeasuredResults_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_MeasuredResults_ie_Extensions__item__extensionValue._const_tab = ____GANSS_MeasuredResults_ie_Extensions__item__extensionValue_tab
    ___GANSS_MeasuredResults_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_MeasuredResults_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_MeasuredResults_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_MeasuredResults_ie_Extensions__item__id),
        ('criticality', ___GANSS_MeasuredResults_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_MeasuredResults_ie_Extensions__item__extensionValue),
        ])
    __GANSS_MeasuredResults_ie_Extensions__item_._ext = None
    _GANSS_MeasuredResults_ie_Extensions._cont = __GANSS_MeasuredResults_ie_Extensions__item_
    _GANSS_MeasuredResults_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_MeasuredResults._cont = ASN1Dict([
        ('referenceTime', _GANSS_MeasuredResults_referenceTime),
        ('ganssGenericMeasurementInfo', _GANSS_MeasuredResults_ganssGenericMeasurementInfo),
        ('ie-Extensions', _GANSS_MeasuredResults_ie_Extensions),
        ])
    GANSS_MeasuredResults._ext = []
    
    #-----< GANSS-MeasuredResults-ExtIEs >-----#
    GANSS_MeasuredResults_ExtIEs = CLASS(name='GANSS-MeasuredResults-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_MeasuredResults_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Navigation-Model >-----#
    GANSS_Navigation_Model = SEQ(name='GANSS-Navigation-Model', mode=MODE_TYPE)
    _GANSS_Navigation_Model_non_broadcastIndication = ENUM(name='non-broadcastIndication', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Navigation_Model_non_broadcastIndication._cont = ASN1Dict([('true', 0)])
    _GANSS_Navigation_Model_non_broadcastIndication._ext = None
    _GANSS_Navigation_Model_ganssSatInfoNav = SEQ_OF(name='ganssSatInfoNav', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Sat-Info-Nav')))
    _GANSS_Navigation_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Navigation_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Navigation_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Navigation_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Navigation_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Navigation_Model_ie_Extensions__item__id._const_tab = ____GANSS_Navigation_Model_ie_Extensions__item__id_tab
    ___GANSS_Navigation_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Navigation_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Navigation_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Navigation_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Navigation_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Navigation_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_Navigation_Model_ie_Extensions__item__criticality_tab
    ___GANSS_Navigation_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Navigation_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Navigation_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Navigation_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Navigation_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Navigation_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Navigation_Model_ie_Extensions__item__extensionValue_tab
    ___GANSS_Navigation_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Navigation_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Navigation_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Navigation_Model_ie_Extensions__item__id),
        ('criticality', ___GANSS_Navigation_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Navigation_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Navigation_Model_ie_Extensions__item_._ext = None
    _GANSS_Navigation_Model_ie_Extensions._cont = __GANSS_Navigation_Model_ie_Extensions__item_
    _GANSS_Navigation_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Navigation_Model._cont = ASN1Dict([
        ('non-broadcastIndication', _GANSS_Navigation_Model_non_broadcastIndication),
        ('ganssSatInfoNav', _GANSS_Navigation_Model_ganssSatInfoNav),
        ('ie-Extensions', _GANSS_Navigation_Model_ie_Extensions),
        ])
    GANSS_Navigation_Model._ext = []
    
    #-----< GANSS-Navigation-Model-ExtIEs >-----#
    GANSS_Navigation_Model_ExtIEs = CLASS(name='GANSS-Navigation-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_Navigation_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Orbit-Model >-----#
    GANSS_Orbit_Model = CHOICE(name='GANSS-Orbit-Model', mode=MODE_TYPE)
    _GANSS_Orbit_Model_gANSS_keplerianParameters = SEQ(name='gANSS-keplerianParameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-KeplerianParametersOrb')))
    GANSS_Orbit_Model._cont = ASN1Dict([
        ('gANSS-keplerianParameters', _GANSS_Orbit_Model_gANSS_keplerianParameters),
        ])
    GANSS_Orbit_Model._ext = []
    
    #-----< GANSS-Real-Time-Integrity >-----#
    GANSS_Real_Time_Integrity = SEQ_OF(name='GANSS-Real-Time-Integrity', mode=MODE_TYPE)
    _GANSS_Real_Time_Integrity__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-RealTimeInformationItem')))
    GANSS_Real_Time_Integrity._cont = _GANSS_Real_Time_Integrity__item_
    GANSS_Real_Time_Integrity._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-RealTimeInformationItem >-----#
    GANSS_RealTimeInformationItem = SEQ(name='GANSS-RealTimeInformationItem', mode=MODE_TYPE)
    _GANSS_RealTimeInformationItem_bad_ganss_satId = INT(name='bad-ganss-satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_RealTimeInformationItem_bad_ganss_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_RealTimeInformationItem_bad_ganss_signalId = BIT_STR(name='bad-ganss-signalId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_RealTimeInformationItem_bad_ganss_signalId._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_RealTimeInformationItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_RealTimeInformationItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__id._const_tab = ____GANSS_RealTimeInformationItem_ie_Extensions__item__id_tab
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality._const_tab = ____GANSS_RealTimeInformationItem_ie_Extensions__item__criticality_tab
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_RealTimeInformationItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_RealTimeInformationItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_RealTimeInformationItem_ie_Extensions__item_._ext = None
    _GANSS_RealTimeInformationItem_ie_Extensions._cont = __GANSS_RealTimeInformationItem_ie_Extensions__item_
    _GANSS_RealTimeInformationItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_RealTimeInformationItem._cont = ASN1Dict([
        ('bad-ganss-satId', _GANSS_RealTimeInformationItem_bad_ganss_satId),
        ('bad-ganss-signalId', _GANSS_RealTimeInformationItem_bad_ganss_signalId),
        ('ie-Extensions', _GANSS_RealTimeInformationItem_ie_Extensions),
        ])
    GANSS_RealTimeInformationItem._ext = []
    
    #-----< GANSS-RealTimeInformationItem-ExtIEs >-----#
    GANSS_RealTimeInformationItem_ExtIEs = CLASS(name='GANSS-RealTimeInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_RealTimeInformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Reference-Location >-----#
    GANSS_Reference_Location = SEQ(name='GANSS-Reference-Location', mode=MODE_TYPE)
    _GANSS_Reference_Location_ue_PositionEstimate = CHOICE(name='ue-PositionEstimate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _GANSS_Reference_Location_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Reference_Location_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Reference_Location_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Reference_Location_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Reference_Location_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Reference_Location_iE_Extensions__item__id._const_tab = ____GANSS_Reference_Location_iE_Extensions__item__id_tab
    ___GANSS_Reference_Location_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_Reference_Location_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Reference_Location_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Reference_Location_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Reference_Location_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Reference_Location_iE_Extensions__item__criticality._const_tab = ____GANSS_Reference_Location_iE_Extensions__item__criticality_tab
    ___GANSS_Reference_Location_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Reference_Location_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Reference_Location_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Reference_Location_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Reference_Location_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Reference_Location_iE_Extensions__item__extensionValue._const_tab = ____GANSS_Reference_Location_iE_Extensions__item__extensionValue_tab
    ___GANSS_Reference_Location_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Reference_Location_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Reference_Location_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Reference_Location_iE_Extensions__item__id),
        ('criticality', ___GANSS_Reference_Location_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Reference_Location_iE_Extensions__item__extensionValue),
        ])
    __GANSS_Reference_Location_iE_Extensions__item_._ext = None
    _GANSS_Reference_Location_iE_Extensions._cont = __GANSS_Reference_Location_iE_Extensions__item_
    _GANSS_Reference_Location_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Reference_Location._cont = ASN1Dict([
        ('ue-PositionEstimate', _GANSS_Reference_Location_ue_PositionEstimate),
        ('iE-Extensions', _GANSS_Reference_Location_iE_Extensions),
        ])
    GANSS_Reference_Location._ext = []
    
    #-----< GANSS-Reference-Location-ExtIEs >-----#
    GANSS_Reference_Location_ExtIEs = CLASS(name='GANSS-Reference-Location-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_Reference_Location_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-ReferenceMeasurementInfo >-----#
    GANSS_ReferenceMeasurementInfo = SEQ(name='GANSS-ReferenceMeasurementInfo', mode=MODE_TYPE)
    _GANSS_ReferenceMeasurementInfo_ganssSignalId = SEQ(name='ganssSignalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SignalID')), opt=True)
    _GANSS_ReferenceMeasurementInfo_satelliteInformation = SEQ_OF(name='satelliteInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SatelliteInformation')))
    _GANSS_ReferenceMeasurementInfo_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ReferenceMeasurementInfo_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Confidence')))
    ____GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 137), ('criticality', 'ignore'), ('Extension', _____GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id._const_tab = ____GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id_tab
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__criticality._const_tab = ____GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id_tab
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id_tab
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ReferenceMeasurementInfo_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id),
        ('criticality', ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ReferenceMeasurementInfo_ie_Extensions__item_._ext = None
    _GANSS_ReferenceMeasurementInfo_ie_Extensions._cont = __GANSS_ReferenceMeasurementInfo_ie_Extensions__item_
    _GANSS_ReferenceMeasurementInfo_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ReferenceMeasurementInfo._cont = ASN1Dict([
        ('ganssSignalId', _GANSS_ReferenceMeasurementInfo_ganssSignalId),
        ('satelliteInformation', _GANSS_ReferenceMeasurementInfo_satelliteInformation),
        ('ie-Extensions', _GANSS_ReferenceMeasurementInfo_ie_Extensions),
        ])
    GANSS_ReferenceMeasurementInfo._ext = []
    
    #-----< GANSS-ReferenceMeasurementInfo-ExtIEs >-----#
    GANSS_ReferenceMeasurementInfo_ExtIEs = CLASS(name='GANSS-ReferenceMeasurementInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSS_ReferenceMeasurementInfo_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Confidence')))
    GANSS_ReferenceMeasurementInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 137), ('criticality', 'ignore'), ('Extension', _GANSS_ReferenceMeasurementInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Reference-Time >-----#
    GANSS_Reference_Time = SEQ(name='GANSS-Reference-Time', mode=MODE_TYPE)
    _GANSS_Reference_Time_ganssDay = INT(name='ganssDay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Reference_Time_ganssDay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _GANSS_Reference_Time_ganssTod = INT(name='ganssTod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Reference_Time_ganssTod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=None, er=[])
    _GANSS_Reference_Time_ganssTodUncertainty = INT(name='ganssTodUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Reference_Time_ganssTodUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GANSS_Reference_Time_ganssTimeId = SEQ(name='ganssTimeId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    _GANSS_Reference_Time_utran_ganssreferenceTime = SEQ(name='utran-ganssreferenceTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GANSSReferenceTimeDL')), opt=True)
    _GANSS_Reference_Time_tutran_ganss_driftRate = ENUM(name='tutran-ganss-driftRate', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TUTRAN-GANSS-DriftRate')), opt=True)
    _GANSS_Reference_Time_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Reference_Time_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Reference_Time_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Reference_Time_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_Reference_Time_ie_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Day-Cycle')))
    ____GANSS_Reference_Time_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 122), ('criticality', 'ignore'), ('Extension', _____GANSS_Reference_Time_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_Reference_Time_ie_Extensions__item__id._const_tab = ____GANSS_Reference_Time_ie_Extensions__item__id_tab
    ___GANSS_Reference_Time_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Reference_Time_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Reference_Time_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_Reference_Time_ie_Extensions__item__criticality._const_tab = ____GANSS_Reference_Time_ie_Extensions__item__id_tab
    ___GANSS_Reference_Time_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Reference_Time_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Reference_Time_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_Reference_Time_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Reference_Time_ie_Extensions__item__id_tab
    ___GANSS_Reference_Time_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Reference_Time_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Reference_Time_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Reference_Time_ie_Extensions__item__id),
        ('criticality', ___GANSS_Reference_Time_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Reference_Time_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Reference_Time_ie_Extensions__item_._ext = None
    _GANSS_Reference_Time_ie_Extensions._cont = __GANSS_Reference_Time_ie_Extensions__item_
    _GANSS_Reference_Time_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Reference_Time._cont = ASN1Dict([
        ('ganssDay', _GANSS_Reference_Time_ganssDay),
        ('ganssTod', _GANSS_Reference_Time_ganssTod),
        ('ganssTodUncertainty', _GANSS_Reference_Time_ganssTodUncertainty),
        ('ganssTimeId', _GANSS_Reference_Time_ganssTimeId),
        ('utran-ganssreferenceTime', _GANSS_Reference_Time_utran_ganssreferenceTime),
        ('tutran-ganss-driftRate', _GANSS_Reference_Time_tutran_ganss_driftRate),
        ('ie-Extensions', _GANSS_Reference_Time_ie_Extensions),
        ])
    GANSS_Reference_Time._ext = []
    
    #-----< GANSS-Reference-Time-ExtIEs >-----#
    GANSS_Reference_Time_ExtIEs = CLASS(name='GANSS-Reference-Time-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSS_Reference_Time_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Day-Cycle')))
    GANSS_Reference_Time_ExtIEs._val = ASN1Set(rv=[dict([('id', 122), ('criticality', 'ignore'), ('Extension', _GANSS_Reference_Time_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Day-Cycle >-----#
    GANSS_Day_Cycle = INT(name='GANSS-Day-Cycle', mode=MODE_TYPE)
    GANSS_Day_Cycle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< GANSS-ReferenceTimeOnly >-----#
    GANSS_ReferenceTimeOnly = SEQ(name='GANSS-ReferenceTimeOnly', mode=MODE_TYPE)
    _GANSS_ReferenceTimeOnly_gANSS_tod = INT(name='gANSS-tod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_ReferenceTimeOnly_gANSS_tod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3599999)], ev=None, er=[])
    _GANSS_ReferenceTimeOnly_gANSS_timeId = SEQ(name='gANSS-timeId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    _GANSS_ReferenceTimeOnly_gANSS_TimeUncertainty = INT(name='gANSS-TimeUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_ReferenceTimeOnly_gANSS_TimeUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GANSS_ReferenceTimeOnly_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_ReferenceTimeOnly_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_ReferenceTimeOnly_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ReferenceTimeOnly_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__id._const_tab = ____GANSS_ReferenceTimeOnly_ie_Extensions__item__id_tab
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_ReferenceTimeOnly_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ReferenceTimeOnly_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__criticality._const_tab = ____GANSS_ReferenceTimeOnly_ie_Extensions__item__criticality_tab
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_ReferenceTimeOnly_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_ReferenceTimeOnly_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__extensionValue._const_tab = ____GANSS_ReferenceTimeOnly_ie_Extensions__item__extensionValue_tab
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_ReferenceTimeOnly_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_ReferenceTimeOnly_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_ReferenceTimeOnly_ie_Extensions__item__id),
        ('criticality', ___GANSS_ReferenceTimeOnly_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_ReferenceTimeOnly_ie_Extensions__item__extensionValue),
        ])
    __GANSS_ReferenceTimeOnly_ie_Extensions__item_._ext = None
    _GANSS_ReferenceTimeOnly_ie_Extensions._cont = __GANSS_ReferenceTimeOnly_ie_Extensions__item_
    _GANSS_ReferenceTimeOnly_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_ReferenceTimeOnly._cont = ASN1Dict([
        ('gANSS-tod', _GANSS_ReferenceTimeOnly_gANSS_tod),
        ('gANSS-timeId', _GANSS_ReferenceTimeOnly_gANSS_timeId),
        ('gANSS-TimeUncertainty', _GANSS_ReferenceTimeOnly_gANSS_TimeUncertainty),
        ('ie-Extensions', _GANSS_ReferenceTimeOnly_ie_Extensions),
        ])
    GANSS_ReferenceTimeOnly._ext = []
    
    #-----< GANSS-ReferenceTimeOnly-ExtIEs >-----#
    GANSS_ReferenceTimeOnly_ExtIEs = CLASS(name='GANSS-ReferenceTimeOnly-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_ReferenceTimeOnly_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SatelliteClockModelItem >-----#
    GANSS_SatelliteClockModelItem = SEQ(name='GANSS-SatelliteClockModelItem', mode=MODE_TYPE)
    _GANSS_SatelliteClockModelItem_t_oc = BIT_STR(name='t-oc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteClockModelItem_t_oc._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_a_i2 = BIT_STR(name='a-i2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteClockModelItem_a_i2._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_a_i1 = BIT_STR(name='a-i1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteClockModelItem_a_i1._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_a_i0 = BIT_STR(name='a-i0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteClockModelItem_a_i0._const_sz = ASN1Set(rv=[31], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_t_gd = BIT_STR(name='t-gd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_SatelliteClockModelItem_t_gd._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_sisa = BIT_STR(name='sisa', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteClockModelItem_sisa._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_model_id = INT(name='model-id', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_SatelliteClockModelItem_model_id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _GANSS_SatelliteClockModelItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SatelliteClockModelItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id._const_tab = ____GANSS_SatelliteClockModelItem_ie_Extensions__item__id_tab
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality._const_tab = ____GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality_tab
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SatelliteClockModelItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SatelliteClockModelItem_ie_Extensions__item_._ext = None
    _GANSS_SatelliteClockModelItem_ie_Extensions._cont = __GANSS_SatelliteClockModelItem_ie_Extensions__item_
    _GANSS_SatelliteClockModelItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SatelliteClockModelItem._cont = ASN1Dict([
        ('t-oc', _GANSS_SatelliteClockModelItem_t_oc),
        ('a-i2', _GANSS_SatelliteClockModelItem_a_i2),
        ('a-i1', _GANSS_SatelliteClockModelItem_a_i1),
        ('a-i0', _GANSS_SatelliteClockModelItem_a_i0),
        ('t-gd', _GANSS_SatelliteClockModelItem_t_gd),
        ('sisa', _GANSS_SatelliteClockModelItem_sisa),
        ('model-id', _GANSS_SatelliteClockModelItem_model_id),
        ('ie-Extensions', _GANSS_SatelliteClockModelItem_ie_Extensions),
        ])
    GANSS_SatelliteClockModelItem._ext = []
    
    #-----< GANSS-SatelliteClockModelItem-ExtIEs >-----#
    GANSS_SatelliteClockModelItem_ExtIEs = CLASS(name='GANSS-SatelliteClockModelItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_SatelliteClockModelItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SatelliteInformation >-----#
    GANSS_SatelliteInformation = SEQ_OF(name='GANSS-SatelliteInformation', mode=MODE_TYPE)
    _GANSS_SatelliteInformation__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SatelliteInformationItem')))
    GANSS_SatelliteInformation._cont = _GANSS_SatelliteInformation__item_
    GANSS_SatelliteInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-SatelliteInformationItem >-----#
    GANSS_SatelliteInformationItem = SEQ(name='GANSS-SatelliteInformationItem', mode=MODE_TYPE)
    _GANSS_SatelliteInformationItem_ganssSatId = INT(name='ganssSatId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationItem_ganssSatId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SatelliteInformationItem_dopplerZeroOrder = INT(name='dopplerZeroOrder', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationItem_dopplerZeroOrder._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2048, ub=2047)], ev=None, er=[])
    _GANSS_SatelliteInformationItem_extraDoppler = SEQ(name='extraDoppler', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ExtraDoppler')), opt=True)
    _GANSS_SatelliteInformationItem_codePhase = INT(name='codePhase', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationItem_codePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _GANSS_SatelliteInformationItem_integerCodePhase = INT(name='integerCodePhase', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationItem_integerCodePhase._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GANSS_SatelliteInformationItem_codePhaseSearchWindow = INT(name='codePhaseSearchWindow', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationItem_codePhaseSearchWindow._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _GANSS_SatelliteInformationItem_azimuthAndElevation = SEQ(name='azimuthAndElevation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AzimuthAndElevation')), opt=True)
    _GANSS_SatelliteInformationItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SatelliteInformationItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SatelliteInformationItem_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_SatelliteInformationItem_ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ExtraDopplerExtension')))
    ____GANSS_SatelliteInformationItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'ignore'), ('Extension', _____GANSS_SatelliteInformationItem_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__id._const_tab = ____GANSS_SatelliteInformationItem_ie_Extensions__item__id_tab
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__criticality._const_tab = ____GANSS_SatelliteInformationItem_ie_Extensions__item__id_tab
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SatelliteInformationItem_ie_Extensions__item__id_tab
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SatelliteInformationItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SatelliteInformationItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SatelliteInformationItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_SatelliteInformationItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SatelliteInformationItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SatelliteInformationItem_ie_Extensions__item_._ext = None
    _GANSS_SatelliteInformationItem_ie_Extensions._cont = __GANSS_SatelliteInformationItem_ie_Extensions__item_
    _GANSS_SatelliteInformationItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SatelliteInformationItem._cont = ASN1Dict([
        ('ganssSatId', _GANSS_SatelliteInformationItem_ganssSatId),
        ('dopplerZeroOrder', _GANSS_SatelliteInformationItem_dopplerZeroOrder),
        ('extraDoppler', _GANSS_SatelliteInformationItem_extraDoppler),
        ('codePhase', _GANSS_SatelliteInformationItem_codePhase),
        ('integerCodePhase', _GANSS_SatelliteInformationItem_integerCodePhase),
        ('codePhaseSearchWindow', _GANSS_SatelliteInformationItem_codePhaseSearchWindow),
        ('azimuthAndElevation', _GANSS_SatelliteInformationItem_azimuthAndElevation),
        ('ie-Extensions', _GANSS_SatelliteInformationItem_ie_Extensions),
        ])
    GANSS_SatelliteInformationItem._ext = []
    
    #-----< GANSS-SatelliteInformationItem-ExtIEs >-----#
    GANSS_SatelliteInformationItem_ExtIEs = CLASS(name='GANSS-SatelliteInformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSS_SatelliteInformationItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-ExtraDopplerExtension')))
    GANSS_SatelliteInformationItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 138), ('criticality', 'ignore'), ('Extension', _GANSS_SatelliteInformationItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-SatelliteInformationKP >-----#
    GANSS_SatelliteInformationKP = SEQ_OF(name='GANSS-SatelliteInformationKP', mode=MODE_TYPE)
    _GANSS_SatelliteInformationKP__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SatelliteInformationKPItem')))
    GANSS_SatelliteInformationKP._cont = _GANSS_SatelliteInformationKP__item_
    GANSS_SatelliteInformationKP._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SatelliteInformationKPItem >-----#
    GANSS_SatelliteInformationKPItem = SEQ(name='GANSS-SatelliteInformationKPItem', mode=MODE_TYPE)
    _GANSS_SatelliteInformationKPItem_satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_e_alm = BIT_STR(name='ganss-e-alm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_e_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_delta_I_alm = BIT_STR(name='ganss-delta-I-alm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_delta_I_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_omegadot_alm = BIT_STR(name='ganss-omegadot-alm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_omegadot_alm._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_svStatusINAV_alm = BIT_STR(name='ganss-svStatusINAV-alm', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_svStatusINAV_alm._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_svStatusFNAV_alm = BIT_STR(name='ganss-svStatusFNAV-alm', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_SatelliteInformationKPItem_ganss_svStatusFNAV_alm._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_delta_a_sqrt_alm = BIT_STR(name='ganss-delta-a-sqrt-alm', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_delta_a_sqrt_alm._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_omegazero_alm = BIT_STR(name='ganss-omegazero-alm', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_omegazero_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_m_zero_alm = BIT_STR(name='ganss-m-zero-alm', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_m_zero_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_omega_alm = BIT_STR(name='ganss-omega-alm', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_omega_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_af_zero_alm = BIT_STR(name='ganss-af-zero-alm', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_af_zero_alm._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ganss_af_one_alm = BIT_STR(name='ganss-af-one-alm', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SatelliteInformationKPItem_ganss_af_one_alm._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _GANSS_SatelliteInformationKPItem_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SatelliteInformationKPItem_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id._const_tab = ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__id_tab
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality._const_tab = ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality_tab
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue_tab
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SatelliteInformationKPItem_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id),
        ('criticality', ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SatelliteInformationKPItem_ie_Extensions__item_._ext = None
    _GANSS_SatelliteInformationKPItem_ie_Extensions._cont = __GANSS_SatelliteInformationKPItem_ie_Extensions__item_
    _GANSS_SatelliteInformationKPItem_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SatelliteInformationKPItem._cont = ASN1Dict([
        ('satId', _GANSS_SatelliteInformationKPItem_satId),
        ('ganss-e-alm', _GANSS_SatelliteInformationKPItem_ganss_e_alm),
        ('ganss-delta-I-alm', _GANSS_SatelliteInformationKPItem_ganss_delta_I_alm),
        ('ganss-omegadot-alm', _GANSS_SatelliteInformationKPItem_ganss_omegadot_alm),
        ('ganss-svStatusINAV-alm', _GANSS_SatelliteInformationKPItem_ganss_svStatusINAV_alm),
        ('ganss-svStatusFNAV-alm', _GANSS_SatelliteInformationKPItem_ganss_svStatusFNAV_alm),
        ('ganss-delta-a-sqrt-alm', _GANSS_SatelliteInformationKPItem_ganss_delta_a_sqrt_alm),
        ('ganss-omegazero-alm', _GANSS_SatelliteInformationKPItem_ganss_omegazero_alm),
        ('ganss-m-zero-alm', _GANSS_SatelliteInformationKPItem_ganss_m_zero_alm),
        ('ganss-omega-alm', _GANSS_SatelliteInformationKPItem_ganss_omega_alm),
        ('ganss-af-zero-alm', _GANSS_SatelliteInformationKPItem_ganss_af_zero_alm),
        ('ganss-af-one-alm', _GANSS_SatelliteInformationKPItem_ganss_af_one_alm),
        ('ie-Extensions', _GANSS_SatelliteInformationKPItem_ie_Extensions),
        ])
    GANSS_SatelliteInformationKPItem._ext = []
    
    #-----< GANSS-SatelliteInformationKPItem-ExtIEs >-----#
    GANSS_SatelliteInformationKPItem_ExtIEs = CLASS(name='GANSS-SatelliteInformationKPItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_SatelliteInformationKPItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-GLOkpList >-----#
    GANSS_SAT_Info_Almanac_GLOkpList = SEQ_OF(name='GANSS-SAT-Info-Almanac-GLOkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_GLOkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SAT-Info-Almanac-GLOkp')))
    GANSS_SAT_Info_Almanac_GLOkpList._cont = _GANSS_SAT_Info_Almanac_GLOkpList__item_
    GANSS_SAT_Info_Almanac_GLOkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-GLOkp >-----#
    GANSS_SAT_Info_Almanac_GLOkp = SEQ(name='GANSS-SAT-Info-Almanac-GLOkp', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmNA = BIT_STR(name='gloAlmNA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmNA._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmnA = BIT_STR(name='gloAlmnA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmnA._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmHA = BIT_STR(name='gloAlmHA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmHA._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmLambdaA = BIT_STR(name='gloAlmLambdaA', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmLambdaA._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTlambdaA = BIT_STR(name='gloAlmTlambdaA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTlambdaA._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaIA = BIT_STR(name='gloAlmDeltaIA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaIA._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAkmDeltaTA = BIT_STR(name='gloAkmDeltaTA', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAkmDeltaTA._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaTdotA = BIT_STR(name='gloAlmDeltaTdotA', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaTdotA._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmEpsilonA = BIT_STR(name='gloAlmEpsilonA', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmEpsilonA._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmOmegaA = BIT_STR(name='gloAlmOmegaA', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmOmegaA._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTauA = BIT_STR(name='gloAlmTauA', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTauA._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmCA = BIT_STR(name='gloAlmCA', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmCA._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmMA = BIT_STR(name='gloAlmMA', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_SAT_Info_Almanac_GLOkp_gloAlmMA._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_GLOkp._cont = ASN1Dict([
        ('gloAlmNA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmNA),
        ('gloAlmnA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmnA),
        ('gloAlmHA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmHA),
        ('gloAlmLambdaA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmLambdaA),
        ('gloAlmTlambdaA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTlambdaA),
        ('gloAlmDeltaIA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaIA),
        ('gloAkmDeltaTA', _GANSS_SAT_Info_Almanac_GLOkp_gloAkmDeltaTA),
        ('gloAlmDeltaTdotA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaTdotA),
        ('gloAlmEpsilonA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmEpsilonA),
        ('gloAlmOmegaA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmOmegaA),
        ('gloAlmTauA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTauA),
        ('gloAlmCA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmCA),
        ('gloAlmMA', _GANSS_SAT_Info_Almanac_GLOkp_gloAlmMA),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_GLOkp._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-GLOkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_GLOkp_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-GLOkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_GLOkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-MIDIkpList >-----#
    GANSS_SAT_Info_Almanac_MIDIkpList = SEQ_OF(name='GANSS-SAT-Info-Almanac-MIDIkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_MIDIkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SAT-Info-Almanac-MIDIkp')))
    GANSS_SAT_Info_Almanac_MIDIkpList._cont = _GANSS_SAT_Info_Almanac_MIDIkpList__item_
    GANSS_SAT_Info_Almanac_MIDIkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-MIDIkp >-----#
    GANSS_SAT_Info_Almanac_MIDIkp = SEQ(name='GANSS-SAT-Info-Almanac-MIDIkp', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_MIDIkp_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmE = BIT_STR(name='midiAlmE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmE._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmDeltaI = BIT_STR(name='midiAlmDeltaI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmDeltaI._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmegaDot = BIT_STR(name='midiAlmOmegaDot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmegaDot._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmSqrtA = BIT_STR(name='midiAlmSqrtA', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmSqrtA._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega0 = BIT_STR(name='midiAlmOmega0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega0._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega = BIT_STR(name='midiAlmOmega', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmMo = BIT_STR(name='midiAlmMo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmMo._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf0 = BIT_STR(name='midiAlmaf0', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf0._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf1 = BIT_STR(name='midiAlmaf1', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf1._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL1Health = BIT_STR(name='midiAlmL1Health', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL1Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL2Health = BIT_STR(name='midiAlmL2Health', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL2Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL5Health = BIT_STR(name='midiAlmL5Health', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL5Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_MIDIkp._cont = ASN1Dict([
        ('svID', _GANSS_SAT_Info_Almanac_MIDIkp_svID),
        ('midiAlmE', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmE),
        ('midiAlmDeltaI', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmDeltaI),
        ('midiAlmOmegaDot', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmegaDot),
        ('midiAlmSqrtA', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmSqrtA),
        ('midiAlmOmega0', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega0),
        ('midiAlmOmega', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega),
        ('midiAlmMo', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmMo),
        ('midiAlmaf0', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf0),
        ('midiAlmaf1', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf1),
        ('midiAlmL1Health', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL1Health),
        ('midiAlmL2Health', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL2Health),
        ('midiAlmL5Health', _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL5Health),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_MIDIkp._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_MIDIkp_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-MIDIkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_MIDIkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-NAVkpList >-----#
    GANSS_SAT_Info_Almanac_NAVkpList = SEQ_OF(name='GANSS-SAT-Info-Almanac-NAVkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_NAVkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SAT-Info-Almanac-NAVkp')))
    GANSS_SAT_Info_Almanac_NAVkpList._cont = _GANSS_SAT_Info_Almanac_NAVkpList__item_
    GANSS_SAT_Info_Almanac_NAVkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-NAVkp >-----#
    GANSS_SAT_Info_Almanac_NAVkp = SEQ(name='GANSS-SAT-Info-Almanac-NAVkp', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_NAVkp_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmE = BIT_STR(name='navAlmE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmE._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmDeltaI = BIT_STR(name='navAlmDeltaI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmDeltaI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGADOT = BIT_STR(name='navAlmOMEGADOT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGADOT._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmSVHealth = BIT_STR(name='navAlmSVHealth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmSVHealth._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmSqrtA = BIT_STR(name='navAlmSqrtA', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmSqrtA._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGAo = BIT_STR(name='navAlmOMEGAo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGAo._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOmega = BIT_STR(name='navAlmOmega', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmOmega._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmMo = BIT_STR(name='navAlmMo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmMo._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf0 = BIT_STR(name='navAlmaf0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf0._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf1 = BIT_STR(name='navAlmaf1', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf1._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_NAVkp._cont = ASN1Dict([
        ('svID', _GANSS_SAT_Info_Almanac_NAVkp_svID),
        ('navAlmE', _GANSS_SAT_Info_Almanac_NAVkp_navAlmE),
        ('navAlmDeltaI', _GANSS_SAT_Info_Almanac_NAVkp_navAlmDeltaI),
        ('navAlmOMEGADOT', _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGADOT),
        ('navAlmSVHealth', _GANSS_SAT_Info_Almanac_NAVkp_navAlmSVHealth),
        ('navAlmSqrtA', _GANSS_SAT_Info_Almanac_NAVkp_navAlmSqrtA),
        ('navAlmOMEGAo', _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGAo),
        ('navAlmOmega', _GANSS_SAT_Info_Almanac_NAVkp_navAlmOmega),
        ('navAlmMo', _GANSS_SAT_Info_Almanac_NAVkp_navAlmMo),
        ('navAlmaf0', _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf0),
        ('navAlmaf1', _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf1),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_NAVkp._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-NAVkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_NAVkp_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-NAVkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_NAVkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-REDkpList >-----#
    GANSS_SAT_Info_Almanac_REDkpList = SEQ_OF(name='GANSS-SAT-Info-Almanac-REDkpList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_REDkpList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SAT-Info-Almanac-REDkp')))
    GANSS_SAT_Info_Almanac_REDkpList._cont = _GANSS_SAT_Info_Almanac_REDkpList__item_
    GANSS_SAT_Info_Almanac_REDkpList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-REDkp >-----#
    GANSS_SAT_Info_Almanac_REDkp = SEQ(name='GANSS-SAT-Info-Almanac-REDkp', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_REDkp_svID = INT(name='svID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmDeltaA = BIT_STR(name='redAlmDeltaA', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmDeltaA._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmOmega0 = BIT_STR(name='redAlmOmega0', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmOmega0._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmPhi0 = BIT_STR(name='redAlmPhi0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmPhi0._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL1Health = BIT_STR(name='redAlmL1Health', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL1Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL2Health = BIT_STR(name='redAlmL2Health', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL2Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL5Health = BIT_STR(name='redAlmL5Health', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_REDkp_redAlmL5Health._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_REDkp_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_REDkp_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_REDkp_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_REDkp._cont = ASN1Dict([
        ('svID', _GANSS_SAT_Info_Almanac_REDkp_svID),
        ('redAlmDeltaA', _GANSS_SAT_Info_Almanac_REDkp_redAlmDeltaA),
        ('redAlmOmega0', _GANSS_SAT_Info_Almanac_REDkp_redAlmOmega0),
        ('redAlmPhi0', _GANSS_SAT_Info_Almanac_REDkp_redAlmPhi0),
        ('redAlmL1Health', _GANSS_SAT_Info_Almanac_REDkp_redAlmL1Health),
        ('redAlmL2Health', _GANSS_SAT_Info_Almanac_REDkp_redAlmL2Health),
        ('redAlmL5Health', _GANSS_SAT_Info_Almanac_REDkp_redAlmL5Health),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_REDkp_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_REDkp._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-REDkp-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_REDkp_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-REDkp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_REDkp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SAT-Info-Almanac-SBASecefList >-----#
    GANSS_SAT_Info_Almanac_SBASecefList = SEQ_OF(name='GANSS-SAT-Info-Almanac-SBASecefList', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_SBASecefList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SAT-Info-Almanac-SBASecef')))
    GANSS_SAT_Info_Almanac_SBASecefList._cont = _GANSS_SAT_Info_Almanac_SBASecefList__item_
    GANSS_SAT_Info_Almanac_SBASecefList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=36)], ev=None, er=[])
    
    #-----< GANSS-SAT-Info-Almanac-SBASecef >-----#
    GANSS_SAT_Info_Almanac_SBASecef = SEQ(name='GANSS-SAT-Info-Almanac-SBASecef', mode=MODE_TYPE)
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmDataID = BIT_STR(name='sbasAlmDataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmDataID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_svID = INT(name='svID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_svID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmHealth = BIT_STR(name='sbasAlmHealth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmHealth._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXg = BIT_STR(name='sbasAlmXg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXg._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYg = BIT_STR(name='sbasAlmYg', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYg._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZg = BIT_STR(name='sbasAlmZg', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZg._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXgdot = BIT_STR(name='sbasAlmXgdot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXgdot._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYgDot = BIT_STR(name='sbasAlmYgDot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYgDot._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZgDot = BIT_STR(name='sbasAlmZgDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZgDot._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmTo = BIT_STR(name='sbasAlmTo', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmTo._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id._const_tab = ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id_tab
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality._const_tab = ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality_tab
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue_tab
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id),
        ('criticality', ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item_._ext = None
    _GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions._cont = __GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item_
    _GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SAT_Info_Almanac_SBASecef._cont = ASN1Dict([
        ('sbasAlmDataID', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmDataID),
        ('svID', _GANSS_SAT_Info_Almanac_SBASecef_svID),
        ('sbasAlmHealth', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmHealth),
        ('sbasAlmXg', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXg),
        ('sbasAlmYg', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYg),
        ('sbasAlmZg', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZg),
        ('sbasAlmXgdot', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXgdot),
        ('sbasAlmYgDot', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYgDot),
        ('sbasAlmZgDot', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZgDot),
        ('sbasAlmTo', _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmTo),
        ('ie-Extensions', _GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions),
        ])
    GANSS_SAT_Info_Almanac_SBASecef._ext = []
    
    #-----< GANSS-SAT-Info-Almanac-SBASecef-ExtIEs >-----#
    GANSS_SAT_Info_Almanac_SBASecef_ExtIEs = CLASS(name='GANSS-SAT-Info-Almanac-SBASecef-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_SAT_Info_Almanac_SBASecef_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ganss-Sat-Info-AddNavList >-----#
    Ganss_Sat_Info_AddNavList = SEQ_OF(name='Ganss-Sat-Info-AddNavList', mode=MODE_TYPE)
    _Ganss_Sat_Info_AddNavList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Ganss_Sat_Info_AddNavList__item__satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Ganss_Sat_Info_AddNavList__item__satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __Ganss_Sat_Info_AddNavList__item__svHealth = BIT_STR(name='svHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Ganss_Sat_Info_AddNavList__item__svHealth._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    __Ganss_Sat_Info_AddNavList__item__iod = BIT_STR(name='iod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __Ganss_Sat_Info_AddNavList__item__iod._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    __Ganss_Sat_Info_AddNavList__item__ganssAddClockModels = CHOICE(name='ganssAddClockModels', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddClockModels')))
    __Ganss_Sat_Info_AddNavList__item__ganssAddOrbitModels = CHOICE(name='ganssAddOrbitModels', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddOrbitModels')))
    __Ganss_Sat_Info_AddNavList__item__ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id._const_tab = _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id._const_tab_at = None
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id._const_tab_id = 'id'
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality._const_tab = _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue._const_tab = _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_._cont = ASN1Dict([
        ('id', ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id),
        ('criticality', ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality),
        ('extensionValue', ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue),
        ])
    ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_._ext = None
    __Ganss_Sat_Info_AddNavList__item__ie_Extensions._cont = ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_
    __Ganss_Sat_Info_AddNavList__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Ganss_Sat_Info_AddNavList__item_._cont = ASN1Dict([
        ('satId', __Ganss_Sat_Info_AddNavList__item__satId),
        ('svHealth', __Ganss_Sat_Info_AddNavList__item__svHealth),
        ('iod', __Ganss_Sat_Info_AddNavList__item__iod),
        ('ganssAddClockModels', __Ganss_Sat_Info_AddNavList__item__ganssAddClockModels),
        ('ganssAddOrbitModels', __Ganss_Sat_Info_AddNavList__item__ganssAddOrbitModels),
        ('ie-Extensions', __Ganss_Sat_Info_AddNavList__item__ie_Extensions),
        ])
    _Ganss_Sat_Info_AddNavList__item_._ext = []
    Ganss_Sat_Info_AddNavList._cont = _Ganss_Sat_Info_AddNavList__item_
    Ganss_Sat_Info_AddNavList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< Ganss-Sat-Info-AddNavList-ExtIEs >-----#
    Ganss_Sat_Info_AddNavList_ExtIEs = CLASS(name='Ganss-Sat-Info-AddNavList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Ganss_Sat_Info_AddNavList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Sat-Info-Nav >-----#
    GANSS_Sat_Info_Nav = SEQ_OF(name='GANSS-Sat-Info-Nav', mode=MODE_TYPE)
    _GANSS_Sat_Info_Nav__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GANSS_Sat_Info_Nav__item__satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Sat_Info_Nav__item__satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __GANSS_Sat_Info_Nav__item__svHealth = BIT_STR(name='svHealth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Sat_Info_Nav__item__svHealth._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    __GANSS_Sat_Info_Nav__item__iod = BIT_STR(name='iod', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __GANSS_Sat_Info_Nav__item__iod._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    __GANSS_Sat_Info_Nav__item__ganssClockModel = SEQ_OF(name='ganssClockModel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Clock-Model')))
    __GANSS_Sat_Info_Nav__item__ganssOrbitModel = CHOICE(name='ganssOrbitModel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Orbit-Model')))
    __GANSS_Sat_Info_Nav__item__ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id._const_tab = _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id._const_tab_at = None
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id._const_tab_id = 'id'
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality._const_tab = _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue._const_tab = _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_._cont = ASN1Dict([
        ('id', ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id),
        ('criticality', ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality),
        ('extensionValue', ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue),
        ])
    ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_._ext = None
    __GANSS_Sat_Info_Nav__item__ie_Extensions._cont = ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_
    __GANSS_Sat_Info_Nav__item__ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GANSS_Sat_Info_Nav__item_._cont = ASN1Dict([
        ('satId', __GANSS_Sat_Info_Nav__item__satId),
        ('svHealth', __GANSS_Sat_Info_Nav__item__svHealth),
        ('iod', __GANSS_Sat_Info_Nav__item__iod),
        ('ganssClockModel', __GANSS_Sat_Info_Nav__item__ganssClockModel),
        ('ganssOrbitModel', __GANSS_Sat_Info_Nav__item__ganssOrbitModel),
        ('ie-Extensions', __GANSS_Sat_Info_Nav__item__ie_Extensions),
        ])
    _GANSS_Sat_Info_Nav__item_._ext = []
    GANSS_Sat_Info_Nav._cont = _GANSS_Sat_Info_Nav__item_
    GANSS_Sat_Info_Nav._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< GANSS-Sat-Info-Nav-ExtIEs >-----#
    GANSS_Sat_Info_Nav_ExtIEs = CLASS(name='GANSS-Sat-Info-Nav-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_Sat_Info_Nav_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SignalID >-----#
    GANSS_SignalID = SEQ(name='GANSS-SignalID', mode=MODE_TYPE)
    _GANSS_SignalID_ganssSignalID = INT(name='ganssSignalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SignalID_ganssSignalID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=[], er=[ASN1RangeInt(lb=4, ub=7)])
    _GANSS_SignalID_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SignalID_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SignalID_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SignalID_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SignalID_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SignalID_ie_Extensions__item__id._const_tab = ____GANSS_SignalID_ie_Extensions__item__id_tab
    ___GANSS_SignalID_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_SignalID_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SignalID_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SignalID_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SignalID_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SignalID_ie_Extensions__item__criticality._const_tab = ____GANSS_SignalID_ie_Extensions__item__criticality_tab
    ___GANSS_SignalID_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SignalID_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SignalID_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SignalID_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SignalID_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SignalID_ie_Extensions__item__extensionValue._const_tab = ____GANSS_SignalID_ie_Extensions__item__extensionValue_tab
    ___GANSS_SignalID_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SignalID_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SignalID_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SignalID_ie_Extensions__item__id),
        ('criticality', ___GANSS_SignalID_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SignalID_ie_Extensions__item__extensionValue),
        ])
    __GANSS_SignalID_ie_Extensions__item_._ext = None
    _GANSS_SignalID_ie_Extensions._cont = __GANSS_SignalID_ie_Extensions__item_
    _GANSS_SignalID_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SignalID._cont = ASN1Dict([
        ('ganssSignalID', _GANSS_SignalID_ganssSignalID),
        ('ie-Extensions', _GANSS_SignalID_ie_Extensions),
        ])
    GANSS_SignalID._ext = []
    
    #-----< GANSS-SignalID-ExtIEs >-----#
    GANSS_SignalID_ExtIEs = CLASS(name='GANSS-SignalID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_SignalID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-StatusHealth >-----#
    GANSS_StatusHealth = ENUM(name='GANSS-StatusHealth', mode=MODE_TYPE)
    GANSS_StatusHealth._cont = ASN1Dict([('udre-scale-1dot0', 0), ('udre-scale-0dot75', 1), ('udre-scale-0dot5', 2), ('udre-scale-0dot3', 3), ('udre-scale-Odot2', 4), ('udre-scale-0dot1', 5), ('no-data', 6), ('invalid-data', 7)])
    GANSS_StatusHealth._ext = None
    
    #-----< GANSS-Time-Model >-----#
    GANSS_Time_Model = SEQ(name='GANSS-Time-Model', mode=MODE_TYPE)
    _GANSS_Time_Model_ganss_time_model_refTime = INT(name='ganss-time-model-refTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Time_Model_ganss_time_model_refTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37799)], ev=None, er=[])
    _GANSS_Time_Model_ganss_t_a0 = INT(name='ganss-t-a0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Time_Model_ganss_t_a0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-2147483648, ub=2147483647)], ev=None, er=[])
    _GANSS_Time_Model_ganss_t_a1 = INT(name='ganss-t-a1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Time_Model_ganss_t_a1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _GANSS_Time_Model_ganss_t_a2 = INT(name='ganss-t-a2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Time_Model_ganss_t_a2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-64, ub=63)], ev=None, er=[])
    _GANSS_Time_Model_gnss_to_id = ENUM(name='gnss-to-id', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Time_Model_gnss_to_id._cont = ASN1Dict([('gps', 0), ('galileo', 1), ('qzss', 2), ('glonass', 3), ('bds', 4)])
    _GANSS_Time_Model_gnss_to_id._ext = ['galileo', 'qzss', 'glonass', 'bds']
    _GANSS_Time_Model_ganss_wk_number = INT(name='ganss-wk-number', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_Time_Model_ganss_wk_number._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _GANSS_Time_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Time_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Time_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Time_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_Time_Model_ie_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Delta-T')))
    ____GANSS_Time_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 123), ('criticality', 'ignore'), ('Extension', _____GANSS_Time_Model_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_Time_Model_ie_Extensions__item__id._const_tab = ____GANSS_Time_Model_ie_Extensions__item__id_tab
    ___GANSS_Time_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_Time_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Time_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_Time_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_Time_Model_ie_Extensions__item__id_tab
    ___GANSS_Time_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Time_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_Time_Model_ie_Extensions__item__id_tab
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Time_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Time_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Time_Model_ie_Extensions__item__id),
        ('criticality', ___GANSS_Time_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Time_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_Time_Model_ie_Extensions__item_._ext = None
    _GANSS_Time_Model_ie_Extensions._cont = __GANSS_Time_Model_ie_Extensions__item_
    _GANSS_Time_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Time_Model._cont = ASN1Dict([
        ('ganss-time-model-refTime', _GANSS_Time_Model_ganss_time_model_refTime),
        ('ganss-t-a0', _GANSS_Time_Model_ganss_t_a0),
        ('ganss-t-a1', _GANSS_Time_Model_ganss_t_a1),
        ('ganss-t-a2', _GANSS_Time_Model_ganss_t_a2),
        ('gnss-to-id', _GANSS_Time_Model_gnss_to_id),
        ('ganss-wk-number', _GANSS_Time_Model_ganss_wk_number),
        ('ie-Extensions', _GANSS_Time_Model_ie_Extensions),
        ])
    GANSS_Time_Model._ext = []
    
    #-----< GANSS-Time-Model-ExtIEs >-----#
    GANSS_Time_Model_ExtIEs = CLASS(name='GANSS-Time-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSS_Time_Model_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Delta-T')))
    GANSS_Time_Model_ExtIEs._val = ASN1Set(rv=[dict([('id', 123), ('criticality', 'ignore'), ('Extension', _GANSS_Time_Model_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-Delta-T >-----#
    GANSS_Delta_T = INT(name='GANSS-Delta-T', mode=MODE_TYPE)
    GANSS_Delta_T._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-128, ub=127)], ev=None, er=[])
    
    #-----< GANSS-UTRAN-TimeRelationshipUncertainty >-----#
    GANSS_UTRAN_TimeRelationshipUncertainty = ENUM(name='GANSS-UTRAN-TimeRelationshipUncertainty', mode=MODE_TYPE)
    GANSS_UTRAN_TimeRelationshipUncertainty._cont = ASN1Dict([('gANSS-UTRAN-TRU-50nano', 0), ('gANSS-UTRAN-TRU-500nano', 1), ('gANSS-UTRAN-TRU-1micro', 2), ('gANSS-UTRAN-TRU-10micro', 3), ('gANSS-UTRAN-TRU-1milli', 4), ('gANSS-UTRAN-TRU-10milli', 5), ('gANSS-UTRAN-TRU-100milli', 6), ('gANSS-UTRAN-TRU-unreliable', 7)])
    GANSS_UTRAN_TimeRelationshipUncertainty._ext = []
    
    #-----< GANSS-UTRAN-TRU >-----#
    GANSS_UTRAN_TRU = SEQ(name='GANSS-UTRAN-TRU', mode=MODE_TYPE)
    _GANSS_UTRAN_TRU_gANSS_UTRAN_TimeRelationshipUncertainty = ENUM(name='gANSS-UTRAN-TimeRelationshipUncertainty', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-UTRAN-TimeRelationshipUncertainty')))
    _GANSS_UTRAN_TRU_ganssId = SEQ(name='ganssId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    _GANSS_UTRAN_TRU_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTRAN_TRU_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTRAN_TRU_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_UTRAN_TRU_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTRAN_TRU_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTRAN_TRU_ie_Extensions__item__id._const_tab = ____GANSS_UTRAN_TRU_ie_Extensions__item__id_tab
    ___GANSS_UTRAN_TRU_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTRAN_TRU_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_UTRAN_TRU_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_UTRAN_TRU_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTRAN_TRU_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTRAN_TRU_ie_Extensions__item__criticality._const_tab = ____GANSS_UTRAN_TRU_ie_Extensions__item__criticality_tab
    ___GANSS_UTRAN_TRU_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_UTRAN_TRU_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_UTRAN_TRU_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_UTRAN_TRU_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTRAN_TRU_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTRAN_TRU_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTRAN_TRU_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTRAN_TRU_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_UTRAN_TRU_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_UTRAN_TRU_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_UTRAN_TRU_ie_Extensions__item__id),
        ('criticality', ___GANSS_UTRAN_TRU_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_UTRAN_TRU_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTRAN_TRU_ie_Extensions__item_._ext = None
    _GANSS_UTRAN_TRU_ie_Extensions._cont = __GANSS_UTRAN_TRU_ie_Extensions__item_
    _GANSS_UTRAN_TRU_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTRAN_TRU._cont = ASN1Dict([
        ('gANSS-UTRAN-TimeRelationshipUncertainty', _GANSS_UTRAN_TRU_gANSS_UTRAN_TimeRelationshipUncertainty),
        ('ganssId', _GANSS_UTRAN_TRU_ganssId),
        ('ie-Extensions', _GANSS_UTRAN_TRU_ie_Extensions),
        ])
    GANSS_UTRAN_TRU._ext = []
    
    #-----< GANSS-UTRAN-TRU-ExtIEs >-----#
    GANSS_UTRAN_TRU_ExtIEs = CLASS(name='GANSS-UTRAN-TRU-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_UTRAN_TRU_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-UTC-Model >-----#
    GANSS_UTC_Model = SEQ(name='GANSS-UTC-Model', mode=MODE_TYPE)
    _GANSS_UTC_Model_a_one_utc = BIT_STR(name='a-one-utc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_a_one_utc._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_a_zero_utc = BIT_STR(name='a-zero-utc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_a_zero_utc._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_t_ot_utc = BIT_STR(name='t-ot-utc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_t_ot_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_w_n_t_utc = BIT_STR(name='w-n-t-utc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_w_n_t_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_delta_t_ls_utc = BIT_STR(name='delta-t-ls-utc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_delta_t_ls_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_w_n_lsf_utc = BIT_STR(name='w-n-lsf-utc', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_w_n_lsf_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_dn_utc = BIT_STR(name='dn-utc', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_dn_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_delta_t_lsf_utc = BIT_STR(name='delta-t-lsf-utc', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_UTC_Model_delta_t_lsf_utc._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_UTC_Model_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_UTC_Model_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_UTC_Model_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_UTC_Model_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTC_Model_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTC_Model_ie_Extensions__item__id._const_tab = ____GANSS_UTC_Model_ie_Extensions__item__id_tab
    ___GANSS_UTC_Model_ie_Extensions__item__id._const_tab_at = None
    ___GANSS_UTC_Model_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_UTC_Model_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTC_Model_ie_Extensions__item__criticality._const_tab = ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab
    ___GANSS_UTC_Model_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_UTC_Model_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue._const_tab = ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_UTC_Model_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_UTC_Model_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_UTC_Model_ie_Extensions__item__id),
        ('criticality', ___GANSS_UTC_Model_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSS_UTC_Model_ie_Extensions__item__extensionValue),
        ])
    __GANSS_UTC_Model_ie_Extensions__item_._ext = None
    _GANSS_UTC_Model_ie_Extensions._cont = __GANSS_UTC_Model_ie_Extensions__item_
    _GANSS_UTC_Model_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_UTC_Model._cont = ASN1Dict([
        ('a-one-utc', _GANSS_UTC_Model_a_one_utc),
        ('a-zero-utc', _GANSS_UTC_Model_a_zero_utc),
        ('t-ot-utc', _GANSS_UTC_Model_t_ot_utc),
        ('w-n-t-utc', _GANSS_UTC_Model_w_n_t_utc),
        ('delta-t-ls-utc', _GANSS_UTC_Model_delta_t_ls_utc),
        ('w-n-lsf-utc', _GANSS_UTC_Model_w_n_lsf_utc),
        ('dn-utc', _GANSS_UTC_Model_dn_utc),
        ('delta-t-lsf-utc', _GANSS_UTC_Model_delta_t_lsf_utc),
        ('ie-Extensions', _GANSS_UTC_Model_ie_Extensions),
        ])
    GANSS_UTC_Model._ext = []
    
    #-----< GANSS-UTC-Model-ExtIEs >-----#
    GANSS_UTC_Model_ExtIEs = CLASS(name='GANSS-UTC-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_UTC_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TUTRAN-GANSS-DriftRate >-----#
    TUTRAN_GANSS_DriftRate = ENUM(name='TUTRAN-GANSS-DriftRate', mode=MODE_TYPE)
    TUTRAN_GANSS_DriftRate._cont = ASN1Dict([('uTRAN-GANSSDrift0', 0), ('uTRAN-GANSSDrift1', 1), ('uTRAN-GANSSDrift2', 2), ('uTRAN-GANSSDrift5', 3), ('uTRAN-GANSSDrift10', 4), ('uTRAN-GANSSDrift15', 5), ('uTRAN-GANSSDrift25', 6), ('uTRAN-GANSSDrift50', 7), ('uTRAN-GANSSDrift-1', 8), ('uTRAN-GANSSDrift-2', 9), ('uTRAN-GANSSDrift-5', 10), ('uTRAN-GANSSDrift-10', 11), ('uTRAN-GANSSDrift-15', 12), ('uTRAN-GANSSDrift-25', 13), ('uTRAN-GANSSDrift-50', 14)])
    TUTRAN_GANSS_DriftRate._ext = []
    
    #-----< GLONASSclockModel >-----#
    GLONASSclockModel = SEQ(name='GLONASSclockModel', mode=MODE_TYPE)
    _GLONASSclockModel_gloTau = BIT_STR(name='gloTau', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GLONASSclockModel_gloTau._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GLONASSclockModel_gloGamma = BIT_STR(name='gloGamma', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GLONASSclockModel_gloGamma._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _GLONASSclockModel_gloDeltaTau = BIT_STR(name='gloDeltaTau', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GLONASSclockModel_gloDeltaTau._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GLONASSclockModel_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GLONASSclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GLONASSclockModel_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GLONASSclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GLONASSclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GLONASSclockModel_ie_Extensions__item__id._const_tab = ____GLONASSclockModel_ie_Extensions__item__id_tab
    ___GLONASSclockModel_ie_Extensions__item__id._const_tab_at = None
    ___GLONASSclockModel_ie_Extensions__item__id._const_tab_id = 'id'
    ___GLONASSclockModel_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GLONASSclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GLONASSclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GLONASSclockModel_ie_Extensions__item__criticality._const_tab = ____GLONASSclockModel_ie_Extensions__item__criticality_tab
    ___GLONASSclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GLONASSclockModel_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GLONASSclockModel_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GLONASSclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GLONASSclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GLONASSclockModel_ie_Extensions__item__extensionValue._const_tab = ____GLONASSclockModel_ie_Extensions__item__extensionValue_tab
    ___GLONASSclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GLONASSclockModel_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GLONASSclockModel_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GLONASSclockModel_ie_Extensions__item__id),
        ('criticality', ___GLONASSclockModel_ie_Extensions__item__criticality),
        ('extensionValue', ___GLONASSclockModel_ie_Extensions__item__extensionValue),
        ])
    __GLONASSclockModel_ie_Extensions__item_._ext = None
    _GLONASSclockModel_ie_Extensions._cont = __GLONASSclockModel_ie_Extensions__item_
    _GLONASSclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GLONASSclockModel._cont = ASN1Dict([
        ('gloTau', _GLONASSclockModel_gloTau),
        ('gloGamma', _GLONASSclockModel_gloGamma),
        ('gloDeltaTau', _GLONASSclockModel_gloDeltaTau),
        ('ie-Extensions', _GLONASSclockModel_ie_Extensions),
        ])
    GLONASSclockModel._ext = []
    
    #-----< GLONASSclockModel-ExtIEs >-----#
    GLONASSclockModel_ExtIEs = CLASS(name='GLONASSclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GLONASSclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NAVclockModel >-----#
    NAVclockModel = SEQ(name='NAVclockModel', mode=MODE_TYPE)
    _NAVclockModel_navToc = BIT_STR(name='navToc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NAVclockModel_navToc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NAVclockModel_navaf2 = BIT_STR(name='navaf2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NAVclockModel_navaf2._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _NAVclockModel_navaf1 = BIT_STR(name='navaf1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NAVclockModel_navaf1._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NAVclockModel_navaf0 = BIT_STR(name='navaf0', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NAVclockModel_navaf0._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _NAVclockModel_navTgd = BIT_STR(name='navTgd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NAVclockModel_navTgd._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _NAVclockModel_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NAVclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___NAVclockModel_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____NAVclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NAVclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NAVclockModel_ie_Extensions__item__id._const_tab = ____NAVclockModel_ie_Extensions__item__id_tab
    ___NAVclockModel_ie_Extensions__item__id._const_tab_at = None
    ___NAVclockModel_ie_Extensions__item__id._const_tab_id = 'id'
    ___NAVclockModel_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NAVclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NAVclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NAVclockModel_ie_Extensions__item__criticality._const_tab = ____NAVclockModel_ie_Extensions__item__criticality_tab
    ___NAVclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NAVclockModel_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NAVclockModel_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NAVclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NAVclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NAVclockModel_ie_Extensions__item__extensionValue._const_tab = ____NAVclockModel_ie_Extensions__item__extensionValue_tab
    ___NAVclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NAVclockModel_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NAVclockModel_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___NAVclockModel_ie_Extensions__item__id),
        ('criticality', ___NAVclockModel_ie_Extensions__item__criticality),
        ('extensionValue', ___NAVclockModel_ie_Extensions__item__extensionValue),
        ])
    __NAVclockModel_ie_Extensions__item_._ext = None
    _NAVclockModel_ie_Extensions._cont = __NAVclockModel_ie_Extensions__item_
    _NAVclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NAVclockModel._cont = ASN1Dict([
        ('navToc', _NAVclockModel_navToc),
        ('navaf2', _NAVclockModel_navaf2),
        ('navaf1', _NAVclockModel_navaf1),
        ('navaf0', _NAVclockModel_navaf0),
        ('navTgd', _NAVclockModel_navTgd),
        ('ie-Extensions', _NAVclockModel_ie_Extensions),
        ])
    NAVclockModel._ext = []
    
    #-----< NAVclockModel-ExtIEs >-----#
    NAVclockModel_ExtIEs = CLASS(name='NAVclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    NAVclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NavModel-CNAVKeplerianSet >-----#
    NavModel_CNAVKeplerianSet = SEQ(name='NavModel-CNAVKeplerianSet', mode=MODE_TYPE)
    _NavModel_CNAVKeplerianSet_cnavTop = BIT_STR(name='cnavTop', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavTop._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavURAindex = BIT_STR(name='cnavURAindex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavURAindex._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavDeltaA = BIT_STR(name='cnavDeltaA', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavDeltaA._const_sz = ASN1Set(rv=[26], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavAdot = BIT_STR(name='cnavAdot', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavAdot._const_sz = ASN1Set(rv=[25], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavDeltaNo = BIT_STR(name='cnavDeltaNo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavDeltaNo._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavDeltaNoDot = BIT_STR(name='cnavDeltaNoDot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavDeltaNoDot._const_sz = ASN1Set(rv=[23], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavMo = BIT_STR(name='cnavMo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavMo._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavE = BIT_STR(name='cnavE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavE._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavOmega = BIT_STR(name='cnavOmega', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavOmega._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavOMEGA0 = BIT_STR(name='cnavOMEGA0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavOMEGA0._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot = BIT_STR(name='cnavDeltaOmegaDot', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavIo = BIT_STR(name='cnavIo', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavIo._const_sz = ASN1Set(rv=[33], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavIoDot = BIT_STR(name='cnavIoDot', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavIoDot._const_sz = ASN1Set(rv=[15], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavCis = BIT_STR(name='cnavCis', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavCis._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavCic = BIT_STR(name='cnavCic', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavCic._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavCrs = BIT_STR(name='cnavCrs', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavCrs._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavCrc = BIT_STR(name='cnavCrc', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavCrc._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavCus = BIT_STR(name='cnavCus', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavCus._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_cnavCuc = BIT_STR(name='cnavCuc', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_CNAVKeplerianSet_cnavCuc._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    _NavModel_CNAVKeplerianSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NavModel_CNAVKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__id._const_tab = ____NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality._const_tab = ____NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NavModel_CNAVKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___NavModel_CNAVKeplerianSet_ie_Extensions__item__id),
        ('criticality', ___NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality),
        ('extensionValue', ___NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __NavModel_CNAVKeplerianSet_ie_Extensions__item_._ext = None
    _NavModel_CNAVKeplerianSet_ie_Extensions._cont = __NavModel_CNAVKeplerianSet_ie_Extensions__item_
    _NavModel_CNAVKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NavModel_CNAVKeplerianSet._cont = ASN1Dict([
        ('cnavTop', _NavModel_CNAVKeplerianSet_cnavTop),
        ('cnavURAindex', _NavModel_CNAVKeplerianSet_cnavURAindex),
        ('cnavDeltaA', _NavModel_CNAVKeplerianSet_cnavDeltaA),
        ('cnavAdot', _NavModel_CNAVKeplerianSet_cnavAdot),
        ('cnavDeltaNo', _NavModel_CNAVKeplerianSet_cnavDeltaNo),
        ('cnavDeltaNoDot', _NavModel_CNAVKeplerianSet_cnavDeltaNoDot),
        ('cnavMo', _NavModel_CNAVKeplerianSet_cnavMo),
        ('cnavE', _NavModel_CNAVKeplerianSet_cnavE),
        ('cnavOmega', _NavModel_CNAVKeplerianSet_cnavOmega),
        ('cnavOMEGA0', _NavModel_CNAVKeplerianSet_cnavOMEGA0),
        ('cnavDeltaOmegaDot', _NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot),
        ('cnavIo', _NavModel_CNAVKeplerianSet_cnavIo),
        ('cnavIoDot', _NavModel_CNAVKeplerianSet_cnavIoDot),
        ('cnavCis', _NavModel_CNAVKeplerianSet_cnavCis),
        ('cnavCic', _NavModel_CNAVKeplerianSet_cnavCic),
        ('cnavCrs', _NavModel_CNAVKeplerianSet_cnavCrs),
        ('cnavCrc', _NavModel_CNAVKeplerianSet_cnavCrc),
        ('cnavCus', _NavModel_CNAVKeplerianSet_cnavCus),
        ('cnavCuc', _NavModel_CNAVKeplerianSet_cnavCuc),
        ('ie-Extensions', _NavModel_CNAVKeplerianSet_ie_Extensions),
        ])
    NavModel_CNAVKeplerianSet._ext = []
    
    #-----< NavModel-CNAVKeplerianSet-ExtIEs >-----#
    NavModel_CNAVKeplerianSet_ExtIEs = CLASS(name='NavModel-CNAVKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    NavModel_CNAVKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NavModel-GLONASSecef >-----#
    NavModel_GLONASSecef = SEQ(name='NavModel-GLONASSecef', mode=MODE_TYPE)
    _NavModel_GLONASSecef_gloEn = BIT_STR(name='gloEn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloEn._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloP1 = BIT_STR(name='gloP1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloP1._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloP2 = BIT_STR(name='gloP2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloP2._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloM = BIT_STR(name='gloM', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NavModel_GLONASSecef_gloM._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloX = BIT_STR(name='gloX', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloX._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloXdot = BIT_STR(name='gloXdot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloXdot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloXdotdot = BIT_STR(name='gloXdotdot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloXdotdot._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloY = BIT_STR(name='gloY', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloY._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloYdot = BIT_STR(name='gloYdot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloYdot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloYdotdot = BIT_STR(name='gloYdotdot', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloYdotdot._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloZ = BIT_STR(name='gloZ', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloZ._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloZdot = BIT_STR(name='gloZdot', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloZdot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_gloZdotdot = BIT_STR(name='gloZdotdot', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_GLONASSecef_gloZdotdot._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _NavModel_GLONASSecef_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NavModel_GLONASSecef_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___NavModel_GLONASSecef_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____NavModel_GLONASSecef_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_GLONASSecef_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_GLONASSecef_ie_Extensions__item__id._const_tab = ____NavModel_GLONASSecef_ie_Extensions__item__id_tab
    ___NavModel_GLONASSecef_ie_Extensions__item__id._const_tab_at = None
    ___NavModel_GLONASSecef_ie_Extensions__item__id._const_tab_id = 'id'
    ___NavModel_GLONASSecef_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NavModel_GLONASSecef_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_GLONASSecef_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_GLONASSecef_ie_Extensions__item__criticality._const_tab = ____NavModel_GLONASSecef_ie_Extensions__item__criticality_tab
    ___NavModel_GLONASSecef_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NavModel_GLONASSecef_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NavModel_GLONASSecef_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_GLONASSecef_ie_Extensions__item__extensionValue._const_tab = ____NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab
    ___NavModel_GLONASSecef_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NavModel_GLONASSecef_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NavModel_GLONASSecef_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___NavModel_GLONASSecef_ie_Extensions__item__id),
        ('criticality', ___NavModel_GLONASSecef_ie_Extensions__item__criticality),
        ('extensionValue', ___NavModel_GLONASSecef_ie_Extensions__item__extensionValue),
        ])
    __NavModel_GLONASSecef_ie_Extensions__item_._ext = None
    _NavModel_GLONASSecef_ie_Extensions._cont = __NavModel_GLONASSecef_ie_Extensions__item_
    _NavModel_GLONASSecef_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NavModel_GLONASSecef._cont = ASN1Dict([
        ('gloEn', _NavModel_GLONASSecef_gloEn),
        ('gloP1', _NavModel_GLONASSecef_gloP1),
        ('gloP2', _NavModel_GLONASSecef_gloP2),
        ('gloM', _NavModel_GLONASSecef_gloM),
        ('gloX', _NavModel_GLONASSecef_gloX),
        ('gloXdot', _NavModel_GLONASSecef_gloXdot),
        ('gloXdotdot', _NavModel_GLONASSecef_gloXdotdot),
        ('gloY', _NavModel_GLONASSecef_gloY),
        ('gloYdot', _NavModel_GLONASSecef_gloYdot),
        ('gloYdotdot', _NavModel_GLONASSecef_gloYdotdot),
        ('gloZ', _NavModel_GLONASSecef_gloZ),
        ('gloZdot', _NavModel_GLONASSecef_gloZdot),
        ('gloZdotdot', _NavModel_GLONASSecef_gloZdotdot),
        ('ie-Extensions', _NavModel_GLONASSecef_ie_Extensions),
        ])
    NavModel_GLONASSecef._ext = []
    
    #-----< NavModel-GLONASSecef-ExtIEs >-----#
    NavModel_GLONASSecef_ExtIEs = CLASS(name='NavModel-GLONASSecef-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    NavModel_GLONASSecef_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NavModel-NAVKeplerianSet >-----#
    NavModel_NAVKeplerianSet = SEQ(name='NavModel-NAVKeplerianSet', mode=MODE_TYPE)
    _NavModel_NAVKeplerianSet_navURA = BIT_STR(name='navURA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navURA._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navFitFlag = BIT_STR(name='navFitFlag', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navFitFlag._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navToe = BIT_STR(name='navToe', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navToe._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navOmega = BIT_STR(name='navOmega', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navOmega._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navDeltaN = BIT_STR(name='navDeltaN', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navDeltaN._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navM0 = BIT_STR(name='navM0', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navM0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navOmegaADot = BIT_STR(name='navOmegaADot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navOmegaADot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navE = BIT_STR(name='navE', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navE._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navIDot = BIT_STR(name='navIDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navIDot._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navAPowerHalf = BIT_STR(name='navAPowerHalf', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navAPowerHalf._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navI0 = BIT_STR(name='navI0', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navI0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navOmegaA0 = BIT_STR(name='navOmegaA0', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navOmegaA0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navCrs = BIT_STR(name='navCrs', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navCrs._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navCis = BIT_STR(name='navCis', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navCis._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navCus = BIT_STR(name='navCus', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navCus._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navCrc = BIT_STR(name='navCrc', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navCrc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navCic = BIT_STR(name='navCic', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navCic._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_navCuc = BIT_STR(name='navCuc', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_NAVKeplerianSet_navCuc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_NAVKeplerianSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NavModel_NAVKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__id._const_tab = ____NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab = ____NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NavModel_NAVKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___NavModel_NAVKeplerianSet_ie_Extensions__item__id),
        ('criticality', ___NavModel_NAVKeplerianSet_ie_Extensions__item__criticality),
        ('extensionValue', ___NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __NavModel_NAVKeplerianSet_ie_Extensions__item_._ext = None
    _NavModel_NAVKeplerianSet_ie_Extensions._cont = __NavModel_NAVKeplerianSet_ie_Extensions__item_
    _NavModel_NAVKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NavModel_NAVKeplerianSet._cont = ASN1Dict([
        ('navURA', _NavModel_NAVKeplerianSet_navURA),
        ('navFitFlag', _NavModel_NAVKeplerianSet_navFitFlag),
        ('navToe', _NavModel_NAVKeplerianSet_navToe),
        ('navOmega', _NavModel_NAVKeplerianSet_navOmega),
        ('navDeltaN', _NavModel_NAVKeplerianSet_navDeltaN),
        ('navM0', _NavModel_NAVKeplerianSet_navM0),
        ('navOmegaADot', _NavModel_NAVKeplerianSet_navOmegaADot),
        ('navE', _NavModel_NAVKeplerianSet_navE),
        ('navIDot', _NavModel_NAVKeplerianSet_navIDot),
        ('navAPowerHalf', _NavModel_NAVKeplerianSet_navAPowerHalf),
        ('navI0', _NavModel_NAVKeplerianSet_navI0),
        ('navOmegaA0', _NavModel_NAVKeplerianSet_navOmegaA0),
        ('navCrs', _NavModel_NAVKeplerianSet_navCrs),
        ('navCis', _NavModel_NAVKeplerianSet_navCis),
        ('navCus', _NavModel_NAVKeplerianSet_navCus),
        ('navCrc', _NavModel_NAVKeplerianSet_navCrc),
        ('navCic', _NavModel_NAVKeplerianSet_navCic),
        ('navCuc', _NavModel_NAVKeplerianSet_navCuc),
        ('ie-Extensions', _NavModel_NAVKeplerianSet_ie_Extensions),
        ])
    NavModel_NAVKeplerianSet._ext = []
    
    #-----< NavModel-NAVKeplerianSet-ExtIEs >-----#
    NavModel_NAVKeplerianSet_ExtIEs = CLASS(name='NavModel-NAVKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    NavModel_NAVKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NavModel-SBASecef >-----#
    NavModel_SBASecef = SEQ(name='NavModel-SBASecef', mode=MODE_TYPE)
    _NavModel_SBASecef_sbasTo = BIT_STR(name='sbasTo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _NavModel_SBASecef_sbasTo._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _NavModel_SBASecef_sbasAccuracy = BIT_STR(name='sbasAccuracy', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBASecef_sbasAccuracy._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _NavModel_SBASecef_sbasXg = BIT_STR(name='sbasXg', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBASecef_sbasXg._const_sz = ASN1Set(rv=[30], rr=[], ev=None, er=[])
    _NavModel_SBASecef_sbasYg = BIT_STR(name='sbasYg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBASecef_sbasYg._const_sz = ASN1Set(rv=[30], rr=[], ev=None, er=[])
    _NavModel_SBASecef_sbasZg = BIT_STR(name='sbasZg', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBASecef_sbasZg._const_sz = ASN1Set(rv=[25], rr=[], ev=None, er=[])
    _NavModel_SBASecef_sbasXgDot = BIT_STR(name='sbasXgDot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBASecef_sbasXgDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _NavModel_SBASecef_sbasYgDot = BIT_STR(name='sbasYgDot', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBASecef_sbasYgDot._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _NavModel_SBASecef_sbasZgDot = BIT_STR(name='sbasZgDot', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBASecef_sbasZgDot._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _NavModel_SBASecef_sbasXgDotDot = BIT_STR(name='sbasXgDotDot', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBASecef_sbasXgDotDot._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _NavModel_SBASecef_sbagYgDotDot = BIT_STR(name='sbagYgDotDot', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBASecef_sbagYgDotDot._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _NavModel_SBASecef_sbasZgDotDot = BIT_STR(name='sbasZgDotDot', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_SBASecef_sbasZgDotDot._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _NavModel_SBASecef_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NavModel_SBASecef_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___NavModel_SBASecef_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____NavModel_SBASecef_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_SBASecef_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_SBASecef_ie_Extensions__item__id._const_tab = ____NavModel_SBASecef_ie_Extensions__item__id_tab
    ___NavModel_SBASecef_ie_Extensions__item__id._const_tab_at = None
    ___NavModel_SBASecef_ie_Extensions__item__id._const_tab_id = 'id'
    ___NavModel_SBASecef_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NavModel_SBASecef_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_SBASecef_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_SBASecef_ie_Extensions__item__criticality._const_tab = ____NavModel_SBASecef_ie_Extensions__item__criticality_tab
    ___NavModel_SBASecef_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NavModel_SBASecef_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NavModel_SBASecef_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NavModel_SBASecef_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_SBASecef_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_SBASecef_ie_Extensions__item__extensionValue._const_tab = ____NavModel_SBASecef_ie_Extensions__item__extensionValue_tab
    ___NavModel_SBASecef_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NavModel_SBASecef_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NavModel_SBASecef_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___NavModel_SBASecef_ie_Extensions__item__id),
        ('criticality', ___NavModel_SBASecef_ie_Extensions__item__criticality),
        ('extensionValue', ___NavModel_SBASecef_ie_Extensions__item__extensionValue),
        ])
    __NavModel_SBASecef_ie_Extensions__item_._ext = None
    _NavModel_SBASecef_ie_Extensions._cont = __NavModel_SBASecef_ie_Extensions__item_
    _NavModel_SBASecef_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NavModel_SBASecef._cont = ASN1Dict([
        ('sbasTo', _NavModel_SBASecef_sbasTo),
        ('sbasAccuracy', _NavModel_SBASecef_sbasAccuracy),
        ('sbasXg', _NavModel_SBASecef_sbasXg),
        ('sbasYg', _NavModel_SBASecef_sbasYg),
        ('sbasZg', _NavModel_SBASecef_sbasZg),
        ('sbasXgDot', _NavModel_SBASecef_sbasXgDot),
        ('sbasYgDot', _NavModel_SBASecef_sbasYgDot),
        ('sbasZgDot', _NavModel_SBASecef_sbasZgDot),
        ('sbasXgDotDot', _NavModel_SBASecef_sbasXgDotDot),
        ('sbagYgDotDot', _NavModel_SBASecef_sbagYgDotDot),
        ('sbasZgDotDot', _NavModel_SBASecef_sbasZgDotDot),
        ('ie-Extensions', _NavModel_SBASecef_ie_Extensions),
        ])
    NavModel_SBASecef._ext = []
    
    #-----< NavModel-SBASecef-ExtIEs >-----#
    NavModel_SBASecef_ExtIEs = CLASS(name='NavModel-SBASecef-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    NavModel_SBASecef_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NavModel-BDSKeplerianSet >-----#
    NavModel_BDSKeplerianSet = SEQ(name='NavModel-BDSKeplerianSet', mode=MODE_TYPE)
    _NavModel_BDSKeplerianSet_uRAIndex_BDS = BIT_STR(name='uRAIndex-BDS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_uRAIndex_BDS._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_tOA_BDS = BIT_STR(name='tOA-BDS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_tOA_BDS._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_a1_2_BDS = BIT_STR(name='a1-2-BDS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_a1_2_BDS._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_e_BDS = BIT_STR(name='e-BDS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_e_BDS._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_oMG_BDS = BIT_STR(name='oMG-BDS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_oMG_BDS._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_dLTn_BDS = BIT_STR(name='dLTn-BDS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_dLTn_BDS._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_m0_BDS = BIT_STR(name='m0-BDS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_m0_BDS._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_oMG0_BDS = BIT_STR(name='oMG0-BDS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_oMG0_BDS._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_oMGdot_BDS = BIT_STR(name='oMGdot-BDS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_oMGdot_BDS._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_i0_BDS = BIT_STR(name='i0-BDS', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_i0_BDS._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_iDOT_BDS = BIT_STR(name='iDOT-BDS', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_iDOT_BDS._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_cuc_BDS = BIT_STR(name='cuc-BDS', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_cuc_BDS._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_cus_BDS = BIT_STR(name='cus-BDS', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_cus_BDS._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_crc_BDS = BIT_STR(name='crc-BDS', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_crc_BDS._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_crs_BDS = BIT_STR(name='crs-BDS', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_crs_BDS._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_cic_BDS = BIT_STR(name='cic-BDS', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_cic_BDS._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_cis_BDS = BIT_STR(name='cis-BDS', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_cis_BDS._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_aODE_BDS = BIT_STR(name='aODE-BDS', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModel_BDSKeplerianSet_aODE_BDS._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _NavModel_BDSKeplerianSet_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NavModel_BDSKeplerianSet_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____NavModel_BDSKeplerianSet_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_BDSKeplerianSet_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__id._const_tab = ____NavModel_BDSKeplerianSet_ie_Extensions__item__id_tab
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__id._const_tab_at = None
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__id._const_tab_id = 'id'
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NavModel_BDSKeplerianSet_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_BDSKeplerianSet_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__criticality._const_tab = ____NavModel_BDSKeplerianSet_ie_Extensions__item__criticality_tab
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue._const_tab = ____NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue_tab
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NavModel_BDSKeplerianSet_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___NavModel_BDSKeplerianSet_ie_Extensions__item__id),
        ('criticality', ___NavModel_BDSKeplerianSet_ie_Extensions__item__criticality),
        ('extensionValue', ___NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue),
        ])
    __NavModel_BDSKeplerianSet_ie_Extensions__item_._ext = None
    _NavModel_BDSKeplerianSet_ie_Extensions._cont = __NavModel_BDSKeplerianSet_ie_Extensions__item_
    _NavModel_BDSKeplerianSet_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NavModel_BDSKeplerianSet._cont = ASN1Dict([
        ('uRAIndex-BDS', _NavModel_BDSKeplerianSet_uRAIndex_BDS),
        ('tOA-BDS', _NavModel_BDSKeplerianSet_tOA_BDS),
        ('a1-2-BDS', _NavModel_BDSKeplerianSet_a1_2_BDS),
        ('e-BDS', _NavModel_BDSKeplerianSet_e_BDS),
        ('oMG-BDS', _NavModel_BDSKeplerianSet_oMG_BDS),
        ('dLTn-BDS', _NavModel_BDSKeplerianSet_dLTn_BDS),
        ('m0-BDS', _NavModel_BDSKeplerianSet_m0_BDS),
        ('oMG0-BDS', _NavModel_BDSKeplerianSet_oMG0_BDS),
        ('oMGdot-BDS', _NavModel_BDSKeplerianSet_oMGdot_BDS),
        ('i0-BDS', _NavModel_BDSKeplerianSet_i0_BDS),
        ('iDOT-BDS', _NavModel_BDSKeplerianSet_iDOT_BDS),
        ('cuc-BDS', _NavModel_BDSKeplerianSet_cuc_BDS),
        ('cus-BDS', _NavModel_BDSKeplerianSet_cus_BDS),
        ('crc-BDS', _NavModel_BDSKeplerianSet_crc_BDS),
        ('crs-BDS', _NavModel_BDSKeplerianSet_crs_BDS),
        ('cic-BDS', _NavModel_BDSKeplerianSet_cic_BDS),
        ('cis-BDS', _NavModel_BDSKeplerianSet_cis_BDS),
        ('aODE-BDS', _NavModel_BDSKeplerianSet_aODE_BDS),
        ('ie-Extensions', _NavModel_BDSKeplerianSet_ie_Extensions),
        ])
    NavModel_BDSKeplerianSet._ext = []
    
    #-----< NavModel-BDSKeplerianSet-ExtIEs >-----#
    NavModel_BDSKeplerianSet_ExtIEs = CLASS(name='NavModel-BDSKeplerianSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    NavModel_BDSKeplerianSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SBASclockModel >-----#
    SBASclockModel = SEQ(name='SBASclockModel', mode=MODE_TYPE)
    _SBASclockModel_sbasTo = BIT_STR(name='sbasTo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SBASclockModel_sbasTo._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _SBASclockModel_sbasAgfo = BIT_STR(name='sbasAgfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SBASclockModel_sbasAgfo._const_sz = ASN1Set(rv=[12], rr=[], ev=None, er=[])
    _SBASclockModel_sbasAgf1 = BIT_STR(name='sbasAgf1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SBASclockModel_sbasAgf1._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SBASclockModel_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SBASclockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___SBASclockModel_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____SBASclockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SBASclockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SBASclockModel_ie_Extensions__item__id._const_tab = ____SBASclockModel_ie_Extensions__item__id_tab
    ___SBASclockModel_ie_Extensions__item__id._const_tab_at = None
    ___SBASclockModel_ie_Extensions__item__id._const_tab_id = 'id'
    ___SBASclockModel_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SBASclockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SBASclockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SBASclockModel_ie_Extensions__item__criticality._const_tab = ____SBASclockModel_ie_Extensions__item__criticality_tab
    ___SBASclockModel_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SBASclockModel_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SBASclockModel_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SBASclockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SBASclockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SBASclockModel_ie_Extensions__item__extensionValue._const_tab = ____SBASclockModel_ie_Extensions__item__extensionValue_tab
    ___SBASclockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SBASclockModel_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SBASclockModel_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___SBASclockModel_ie_Extensions__item__id),
        ('criticality', ___SBASclockModel_ie_Extensions__item__criticality),
        ('extensionValue', ___SBASclockModel_ie_Extensions__item__extensionValue),
        ])
    __SBASclockModel_ie_Extensions__item_._ext = None
    _SBASclockModel_ie_Extensions._cont = __SBASclockModel_ie_Extensions__item_
    _SBASclockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SBASclockModel._cont = ASN1Dict([
        ('sbasTo', _SBASclockModel_sbasTo),
        ('sbasAgfo', _SBASclockModel_sbasAgfo),
        ('sbasAgf1', _SBASclockModel_sbasAgf1),
        ('ie-Extensions', _SBASclockModel_ie_Extensions),
        ])
    SBASclockModel._ext = []
    
    #-----< SBASclockModel-ExtIEs >-----#
    SBASclockModel_ExtIEs = CLASS(name='SBASclockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    SBASclockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BDSClockModel >-----#
    BDSClockModel = SEQ(name='BDSClockModel', mode=MODE_TYPE)
    _BDSClockModel_toc_BDS = BIT_STR(name='toc-BDS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDSClockModel_toc_BDS._const_sz = ASN1Set(rv=[17], rr=[], ev=None, er=[])
    _BDSClockModel_a0_BDS = BIT_STR(name='a0-BDS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDSClockModel_a0_BDS._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _BDSClockModel_a1_BDS = BIT_STR(name='a1-BDS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDSClockModel_a1_BDS._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _BDSClockModel_a2_BDS = BIT_STR(name='a2-BDS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDSClockModel_a2_BDS._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _BDSClockModel_tGD1_BDS = BIT_STR(name='tGD1-BDS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDSClockModel_tGD1_BDS._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _BDSClockModel_aODC_BDS = BIT_STR(name='aODC-BDS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BDSClockModel_aODC_BDS._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _BDSClockModel_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BDSClockModel_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___BDSClockModel_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____BDSClockModel_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BDSClockModel_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDSClockModel_ie_Extensions__item__id._const_tab = ____BDSClockModel_ie_Extensions__item__id_tab
    ___BDSClockModel_ie_Extensions__item__id._const_tab_at = None
    ___BDSClockModel_ie_Extensions__item__id._const_tab_id = 'id'
    ___BDSClockModel_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BDSClockModel_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BDSClockModel_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDSClockModel_ie_Extensions__item__criticality._const_tab = ____BDSClockModel_ie_Extensions__item__criticality_tab
    ___BDSClockModel_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BDSClockModel_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BDSClockModel_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BDSClockModel_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BDSClockModel_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BDSClockModel_ie_Extensions__item__extensionValue._const_tab = ____BDSClockModel_ie_Extensions__item__extensionValue_tab
    ___BDSClockModel_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BDSClockModel_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BDSClockModel_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___BDSClockModel_ie_Extensions__item__id),
        ('criticality', ___BDSClockModel_ie_Extensions__item__criticality),
        ('extensionValue', ___BDSClockModel_ie_Extensions__item__extensionValue),
        ])
    __BDSClockModel_ie_Extensions__item_._ext = None
    _BDSClockModel_ie_Extensions._cont = __BDSClockModel_ie_Extensions__item_
    _BDSClockModel_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BDSClockModel._cont = ASN1Dict([
        ('toc-BDS', _BDSClockModel_toc_BDS),
        ('a0-BDS', _BDSClockModel_a0_BDS),
        ('a1-BDS', _BDSClockModel_a1_BDS),
        ('a2-BDS', _BDSClockModel_a2_BDS),
        ('tGD1-BDS', _BDSClockModel_tGD1_BDS),
        ('aODC-BDS', _BDSClockModel_aODC_BDS),
        ('ie-Extensions', _BDSClockModel_ie_Extensions),
        ])
    BDSClockModel._ext = []
    
    #-----< BDSClockModel-ExtIEs >-----#
    BDSClockModel_ExtIEs = CLASS(name='BDSClockModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    BDSClockModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTCmodelSet1 >-----#
    UTCmodelSet1 = SEQ(name='UTCmodelSet1', mode=MODE_TYPE)
    _UTCmodelSet1_utcA0 = BIT_STR(name='utcA0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet1_utcA0._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _UTCmodelSet1_utcA1 = BIT_STR(name='utcA1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet1_utcA1._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _UTCmodelSet1_utcA2 = BIT_STR(name='utcA2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet1_utcA2._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _UTCmodelSet1_utcDeltaTls = BIT_STR(name='utcDeltaTls', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet1_utcDeltaTls._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet1_utcTot = BIT_STR(name='utcTot', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet1_utcTot._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _UTCmodelSet1_utcWNot = BIT_STR(name='utcWNot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet1_utcWNot._const_sz = ASN1Set(rv=[13], rr=[], ev=None, er=[])
    _UTCmodelSet1_utcWNlsf = BIT_STR(name='utcWNlsf', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet1_utcWNlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet1_utcDN = BIT_STR(name='utcDN', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet1_utcDN._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _UTCmodelSet1_utcDeltaTlsf = BIT_STR(name='utcDeltaTlsf', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet1_utcDeltaTlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet1_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTCmodelSet1_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTCmodelSet1_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTCmodelSet1_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet1_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet1_ie_Extensions__item__id._const_tab = ____UTCmodelSet1_ie_Extensions__item__id_tab
    ___UTCmodelSet1_ie_Extensions__item__id._const_tab_at = None
    ___UTCmodelSet1_ie_Extensions__item__id._const_tab_id = 'id'
    ___UTCmodelSet1_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTCmodelSet1_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet1_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet1_ie_Extensions__item__criticality._const_tab = ____UTCmodelSet1_ie_Extensions__item__criticality_tab
    ___UTCmodelSet1_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTCmodelSet1_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTCmodelSet1_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTCmodelSet1_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet1_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet1_ie_Extensions__item__extensionValue._const_tab = ____UTCmodelSet1_ie_Extensions__item__extensionValue_tab
    ___UTCmodelSet1_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTCmodelSet1_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTCmodelSet1_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTCmodelSet1_ie_Extensions__item__id),
        ('criticality', ___UTCmodelSet1_ie_Extensions__item__criticality),
        ('extensionValue', ___UTCmodelSet1_ie_Extensions__item__extensionValue),
        ])
    __UTCmodelSet1_ie_Extensions__item_._ext = None
    _UTCmodelSet1_ie_Extensions._cont = __UTCmodelSet1_ie_Extensions__item_
    _UTCmodelSet1_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTCmodelSet1._cont = ASN1Dict([
        ('utcA0', _UTCmodelSet1_utcA0),
        ('utcA1', _UTCmodelSet1_utcA1),
        ('utcA2', _UTCmodelSet1_utcA2),
        ('utcDeltaTls', _UTCmodelSet1_utcDeltaTls),
        ('utcTot', _UTCmodelSet1_utcTot),
        ('utcWNot', _UTCmodelSet1_utcWNot),
        ('utcWNlsf', _UTCmodelSet1_utcWNlsf),
        ('utcDN', _UTCmodelSet1_utcDN),
        ('utcDeltaTlsf', _UTCmodelSet1_utcDeltaTlsf),
        ('ie-Extensions', _UTCmodelSet1_ie_Extensions),
        ])
    UTCmodelSet1._ext = []
    
    #-----< UTCmodelSet1-ExtIEs >-----#
    UTCmodelSet1_ExtIEs = CLASS(name='UTCmodelSet1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTCmodelSet1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTCmodelSet2 >-----#
    UTCmodelSet2 = SEQ(name='UTCmodelSet2', mode=MODE_TYPE)
    _UTCmodelSet2_nA = BIT_STR(name='nA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet2_nA._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _UTCmodelSet2_tauC = BIT_STR(name='tauC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet2_tauC._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _UTCmodelSet2_deltaUT1 = SEQ(name='deltaUT1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DeltaUT1')), opt=True)
    _UTCmodelSet2_kp = BIT_STR(name='kp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTCmodelSet2_kp._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _UTCmodelSet2_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTCmodelSet2_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTCmodelSet2_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTCmodelSet2_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet2_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet2_ie_Extensions__item__id._const_tab = ____UTCmodelSet2_ie_Extensions__item__id_tab
    ___UTCmodelSet2_ie_Extensions__item__id._const_tab_at = None
    ___UTCmodelSet2_ie_Extensions__item__id._const_tab_id = 'id'
    ___UTCmodelSet2_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTCmodelSet2_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet2_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet2_ie_Extensions__item__criticality._const_tab = ____UTCmodelSet2_ie_Extensions__item__criticality_tab
    ___UTCmodelSet2_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTCmodelSet2_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTCmodelSet2_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTCmodelSet2_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet2_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet2_ie_Extensions__item__extensionValue._const_tab = ____UTCmodelSet2_ie_Extensions__item__extensionValue_tab
    ___UTCmodelSet2_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTCmodelSet2_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTCmodelSet2_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTCmodelSet2_ie_Extensions__item__id),
        ('criticality', ___UTCmodelSet2_ie_Extensions__item__criticality),
        ('extensionValue', ___UTCmodelSet2_ie_Extensions__item__extensionValue),
        ])
    __UTCmodelSet2_ie_Extensions__item_._ext = None
    _UTCmodelSet2_ie_Extensions._cont = __UTCmodelSet2_ie_Extensions__item_
    _UTCmodelSet2_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTCmodelSet2._cont = ASN1Dict([
        ('nA', _UTCmodelSet2_nA),
        ('tauC', _UTCmodelSet2_tauC),
        ('deltaUT1', _UTCmodelSet2_deltaUT1),
        ('kp', _UTCmodelSet2_kp),
        ('ie-Extensions', _UTCmodelSet2_ie_Extensions),
        ])
    UTCmodelSet2._ext = []
    
    #-----< UTCmodelSet2-ExtIEs >-----#
    UTCmodelSet2_ExtIEs = CLASS(name='UTCmodelSet2-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTCmodelSet2_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTCmodelSet3 >-----#
    UTCmodelSet3 = SEQ(name='UTCmodelSet3', mode=MODE_TYPE)
    _UTCmodelSet3_utcA1wnt = BIT_STR(name='utcA1wnt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet3_utcA1wnt._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _UTCmodelSet3_utcA0wnt = BIT_STR(name='utcA0wnt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet3_utcA0wnt._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _UTCmodelSet3_utcTot = BIT_STR(name='utcTot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet3_utcTot._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet3_utcWNt = BIT_STR(name='utcWNt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet3_utcWNt._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet3_utcDeltaTls = BIT_STR(name='utcDeltaTls', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet3_utcDeltaTls._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet3_utcWNlsf = BIT_STR(name='utcWNlsf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet3_utcWNlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet3_utcDN = BIT_STR(name='utcDN', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet3_utcDN._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet3_utcDeltaTlsf = BIT_STR(name='utcDeltaTlsf', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet3_utcDeltaTlsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet3_utcStandardID = BIT_STR(name='utcStandardID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet3_utcStandardID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _UTCmodelSet3_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTCmodelSet3_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTCmodelSet3_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTCmodelSet3_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet3_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet3_ie_Extensions__item__id._const_tab = ____UTCmodelSet3_ie_Extensions__item__id_tab
    ___UTCmodelSet3_ie_Extensions__item__id._const_tab_at = None
    ___UTCmodelSet3_ie_Extensions__item__id._const_tab_id = 'id'
    ___UTCmodelSet3_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTCmodelSet3_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet3_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet3_ie_Extensions__item__criticality._const_tab = ____UTCmodelSet3_ie_Extensions__item__criticality_tab
    ___UTCmodelSet3_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTCmodelSet3_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTCmodelSet3_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTCmodelSet3_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet3_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet3_ie_Extensions__item__extensionValue._const_tab = ____UTCmodelSet3_ie_Extensions__item__extensionValue_tab
    ___UTCmodelSet3_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTCmodelSet3_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTCmodelSet3_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTCmodelSet3_ie_Extensions__item__id),
        ('criticality', ___UTCmodelSet3_ie_Extensions__item__criticality),
        ('extensionValue', ___UTCmodelSet3_ie_Extensions__item__extensionValue),
        ])
    __UTCmodelSet3_ie_Extensions__item_._ext = None
    _UTCmodelSet3_ie_Extensions._cont = __UTCmodelSet3_ie_Extensions__item_
    _UTCmodelSet3_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTCmodelSet3._cont = ASN1Dict([
        ('utcA1wnt', _UTCmodelSet3_utcA1wnt),
        ('utcA0wnt', _UTCmodelSet3_utcA0wnt),
        ('utcTot', _UTCmodelSet3_utcTot),
        ('utcWNt', _UTCmodelSet3_utcWNt),
        ('utcDeltaTls', _UTCmodelSet3_utcDeltaTls),
        ('utcWNlsf', _UTCmodelSet3_utcWNlsf),
        ('utcDN', _UTCmodelSet3_utcDN),
        ('utcDeltaTlsf', _UTCmodelSet3_utcDeltaTlsf),
        ('utcStandardID', _UTCmodelSet3_utcStandardID),
        ('ie-Extensions', _UTCmodelSet3_ie_Extensions),
        ])
    UTCmodelSet3._ext = []
    
    #-----< UTCmodelSet3-ExtIEs >-----#
    UTCmodelSet3_ExtIEs = CLASS(name='UTCmodelSet3-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTCmodelSet3_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTCmodelSet4 >-----#
    UTCmodelSet4 = SEQ(name='UTCmodelSet4', mode=MODE_TYPE)
    _UTCmodelSet4_utca0_BDS = BIT_STR(name='utca0-BDS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet4_utca0_BDS._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _UTCmodelSet4_utca1_BDS = BIT_STR(name='utca1-BDS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet4_utca1_BDS._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _UTCmodelSet4_utcDeltatLS_BDS = BIT_STR(name='utcDeltatLS-BDS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet4_utcDeltatLS_BDS._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet4_utcWNt = BIT_STR(name='utcWNt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet4_utcWNt._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet4_utcDeltaTls = BIT_STR(name='utcDeltaTls', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet4_utcDeltaTls._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet4_utcWNlsf_BDS = BIT_STR(name='utcWNlsf-BDS', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet4_utcWNlsf_BDS._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet4_utcDN_BDS = BIT_STR(name='utcDN-BDS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet4_utcDN_BDS._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet4_utcDeltaTlsf_BDS = BIT_STR(name='utcDeltaTlsf-BDS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTCmodelSet4_utcDeltaTlsf_BDS._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _UTCmodelSet4_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTCmodelSet4_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTCmodelSet4_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTCmodelSet4_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet4_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet4_ie_Extensions__item__id._const_tab = ____UTCmodelSet4_ie_Extensions__item__id_tab
    ___UTCmodelSet4_ie_Extensions__item__id._const_tab_at = None
    ___UTCmodelSet4_ie_Extensions__item__id._const_tab_id = 'id'
    ___UTCmodelSet4_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTCmodelSet4_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet4_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet4_ie_Extensions__item__criticality._const_tab = ____UTCmodelSet4_ie_Extensions__item__criticality_tab
    ___UTCmodelSet4_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTCmodelSet4_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTCmodelSet4_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTCmodelSet4_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTCmodelSet4_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTCmodelSet4_ie_Extensions__item__extensionValue._const_tab = ____UTCmodelSet4_ie_Extensions__item__extensionValue_tab
    ___UTCmodelSet4_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTCmodelSet4_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTCmodelSet4_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTCmodelSet4_ie_Extensions__item__id),
        ('criticality', ___UTCmodelSet4_ie_Extensions__item__criticality),
        ('extensionValue', ___UTCmodelSet4_ie_Extensions__item__extensionValue),
        ])
    __UTCmodelSet4_ie_Extensions__item_._ext = None
    _UTCmodelSet4_ie_Extensions._cont = __UTCmodelSet4_ie_Extensions__item_
    _UTCmodelSet4_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTCmodelSet4._cont = ASN1Dict([
        ('utca0-BDS', _UTCmodelSet4_utca0_BDS),
        ('utca1-BDS', _UTCmodelSet4_utca1_BDS),
        ('utcDeltatLS-BDS', _UTCmodelSet4_utcDeltatLS_BDS),
        ('utcWNt', _UTCmodelSet4_utcWNt),
        ('utcDeltaTls', _UTCmodelSet4_utcDeltaTls),
        ('utcWNlsf-BDS', _UTCmodelSet4_utcWNlsf_BDS),
        ('utcDN-BDS', _UTCmodelSet4_utcDN_BDS),
        ('utcDeltaTlsf-BDS', _UTCmodelSet4_utcDeltaTlsf_BDS),
        ('ie-Extensions', _UTCmodelSet4_ie_Extensions),
        ])
    UTCmodelSet4._ext = []
    
    #-----< UTCmodelSet4-ExtIEs >-----#
    UTCmodelSet4_ExtIEs = CLASS(name='UTCmodelSet4-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTCmodelSet4_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTRAN-GANSSReferenceTimeDL >-----#
    UTRAN_GANSSReferenceTimeDL = SEQ(name='UTRAN-GANSSReferenceTimeDL', mode=MODE_TYPE)
    _UTRAN_GANSSReferenceTimeDL_utran_GANSSTimingOfCellFrames = INT(name='utran-GANSSTimingOfCellFrames', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GANSSReferenceTimeDL_utran_GANSSTimingOfCellFrames._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3999999)], ev=None, er=[])
    _UTRAN_GANSSReferenceTimeDL_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')), opt=True)
    _UTRAN_GANSSReferenceTimeDL_referenceSfn = INT(name='referenceSfn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GANSSReferenceTimeDL_referenceSfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _UTRAN_GANSSReferenceTimeDL_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTRAN_GANSSReferenceTimeDL_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__id._const_tab = ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__id_tab
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__id._const_tab_at = None
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__id._const_tab_id = 'id'
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__criticality._const_tab = ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__criticality_tab
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__extensionValue._const_tab = ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__extensionValue_tab
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTRAN_GANSSReferenceTimeDL_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__id),
        ('criticality', ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__criticality),
        ('extensionValue', ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__extensionValue),
        ])
    __UTRAN_GANSSReferenceTimeDL_ie_Extensions__item_._ext = None
    _UTRAN_GANSSReferenceTimeDL_ie_Extensions._cont = __UTRAN_GANSSReferenceTimeDL_ie_Extensions__item_
    _UTRAN_GANSSReferenceTimeDL_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTRAN_GANSSReferenceTimeDL._cont = ASN1Dict([
        ('utran-GANSSTimingOfCellFrames', _UTRAN_GANSSReferenceTimeDL_utran_GANSSTimingOfCellFrames),
        ('uC-ID', _UTRAN_GANSSReferenceTimeDL_uC_ID),
        ('referenceSfn', _UTRAN_GANSSReferenceTimeDL_referenceSfn),
        ('ie-Extensions', _UTRAN_GANSSReferenceTimeDL_ie_Extensions),
        ])
    UTRAN_GANSSReferenceTimeDL._ext = []
    
    #-----< UTRAN-GANSSReferenceTimeDL-ExtIEs >-----#
    UTRAN_GANSSReferenceTimeDL_ExtIEs = CLASS(name='UTRAN-GANSSReferenceTimeDL-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTRAN_GANSSReferenceTimeDL_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTRAN-GANSSReferenceTimeUL >-----#
    UTRAN_GANSSReferenceTimeUL = SEQ(name='UTRAN-GANSSReferenceTimeUL', mode=MODE_TYPE)
    _UTRAN_GANSSReferenceTimeUL_ue_GANSSTimingOfCellFrames = INT(name='ue-GANSSTimingOfCellFrames', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GANSSReferenceTimeUL_ue_GANSSTimingOfCellFrames._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=345599999999)], ev=None, er=[])
    _UTRAN_GANSSReferenceTimeUL_gANSS_TimeId = SEQ(name='gANSS-TimeId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    _UTRAN_GANSSReferenceTimeUL_gANSS_TimeUncertainty = INT(name='gANSS-TimeUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTRAN_GANSSReferenceTimeUL_gANSS_TimeUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _UTRAN_GANSSReferenceTimeUL_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _UTRAN_GANSSReferenceTimeUL_referenceSfn = INT(name='referenceSfn', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GANSSReferenceTimeUL_referenceSfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _UTRAN_GANSSReferenceTimeUL_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTRAN_GANSSReferenceTimeUL_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__id._const_tab = ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__id_tab
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__id._const_tab_at = None
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__id._const_tab_id = 'id'
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__criticality._const_tab = ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__criticality_tab
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__extensionValue._const_tab = ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__extensionValue_tab
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTRAN_GANSSReferenceTimeUL_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__id),
        ('criticality', ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__criticality),
        ('extensionValue', ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__extensionValue),
        ])
    __UTRAN_GANSSReferenceTimeUL_ie_Extensions__item_._ext = None
    _UTRAN_GANSSReferenceTimeUL_ie_Extensions._cont = __UTRAN_GANSSReferenceTimeUL_ie_Extensions__item_
    _UTRAN_GANSSReferenceTimeUL_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTRAN_GANSSReferenceTimeUL._cont = ASN1Dict([
        ('ue-GANSSTimingOfCellFrames', _UTRAN_GANSSReferenceTimeUL_ue_GANSSTimingOfCellFrames),
        ('gANSS-TimeId', _UTRAN_GANSSReferenceTimeUL_gANSS_TimeId),
        ('gANSS-TimeUncertainty', _UTRAN_GANSSReferenceTimeUL_gANSS_TimeUncertainty),
        ('uC-ID', _UTRAN_GANSSReferenceTimeUL_uC_ID),
        ('referenceSfn', _UTRAN_GANSSReferenceTimeUL_referenceSfn),
        ('ie-Extensions', _UTRAN_GANSSReferenceTimeUL_ie_Extensions),
        ])
    UTRAN_GANSSReferenceTimeUL._ext = []
    
    #-----< UTRAN-GANSSReferenceTimeUL-ExtIEs >-----#
    UTRAN_GANSSReferenceTimeUL_ExtIEs = CLASS(name='UTRAN-GANSSReferenceTimeUL-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTRAN_GANSSReferenceTimeUL_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-AlmanacAndSatelliteHealth >-----#
    GPS_AlmanacAndSatelliteHealth = SEQ(name='GPS-AlmanacAndSatelliteHealth', mode=MODE_TYPE)
    _GPS_AlmanacAndSatelliteHealth_wn_a = BIT_STR(name='wn-a', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_AlmanacAndSatelliteHealth_wn_a._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_AlmanacAndSatelliteHealth_almanacSatInfoList = SEQ_OF(name='almanacSatInfoList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AlmanacSatInfoList')))
    _GPS_AlmanacAndSatelliteHealth_svGlobalHealth = BIT_STR(name='svGlobalHealth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GPS_AlmanacAndSatelliteHealth_svGlobalHealth._const_sz = ASN1Set(rv=[364], rr=[], ev=None, er=[])
    _GPS_AlmanacAndSatelliteHealth_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_AlmanacAndSatelliteHealth_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id_tab_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CompleteAlmanacProvided')))
    ____GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 120), ('criticality', 'ignore'), ('Extension', _____GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id._const_tab = ____GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id_tab
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id._const_tab_at = None
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__criticality._const_tab = ____GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id_tab
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__extensionValue._const_tab = ____GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id_tab
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_AlmanacAndSatelliteHealth_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id),
        ('criticality', ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__extensionValue),
        ])
    __GPS_AlmanacAndSatelliteHealth_iE_Extensions__item_._ext = None
    _GPS_AlmanacAndSatelliteHealth_iE_Extensions._cont = __GPS_AlmanacAndSatelliteHealth_iE_Extensions__item_
    _GPS_AlmanacAndSatelliteHealth_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_AlmanacAndSatelliteHealth._cont = ASN1Dict([
        ('wn-a', _GPS_AlmanacAndSatelliteHealth_wn_a),
        ('almanacSatInfoList', _GPS_AlmanacAndSatelliteHealth_almanacSatInfoList),
        ('svGlobalHealth', _GPS_AlmanacAndSatelliteHealth_svGlobalHealth),
        ('iE-Extensions', _GPS_AlmanacAndSatelliteHealth_iE_Extensions),
        ])
    GPS_AlmanacAndSatelliteHealth._ext = []
    
    #-----< GPS-AlmanacAndSatelliteHealth-ExtIEs >-----#
    GPS_AlmanacAndSatelliteHealth_ExtIEs = CLASS(name='GPS-AlmanacAndSatelliteHealth-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GPS_AlmanacAndSatelliteHealth_ExtIEs_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CompleteAlmanacProvided')))
    GPS_AlmanacAndSatelliteHealth_ExtIEs._val = ASN1Set(rv=[dict([('id', 120), ('criticality', 'ignore'), ('Extension', _GPS_AlmanacAndSatelliteHealth_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CompleteAlmanacProvided >-----#
    CompleteAlmanacProvided = BOOL(name='CompleteAlmanacProvided', mode=MODE_TYPE)
    
    #-----< AlmanacSatInfoList >-----#
    AlmanacSatInfoList = SEQ_OF(name='AlmanacSatInfoList', mode=MODE_TYPE)
    _AlmanacSatInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AlmanacSatInfo')))
    AlmanacSatInfoList._cont = _AlmanacSatInfoList__item_
    AlmanacSatInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AlmanacSatInfo >-----#
    AlmanacSatInfo = SEQ(name='AlmanacSatInfo', mode=MODE_TYPE)
    _AlmanacSatInfo_dataID = BIT_STR(name='dataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_dataID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _AlmanacSatInfo_satID = INT(name='satID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_satID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _AlmanacSatInfo_e = BIT_STR(name='e', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_e._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _AlmanacSatInfo_t_oa = BIT_STR(name='t-oa', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_t_oa._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _AlmanacSatInfo_deltaI = BIT_STR(name='deltaI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_deltaI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _AlmanacSatInfo_omegaDot = BIT_STR(name='omegaDot', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_omegaDot._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _AlmanacSatInfo_satHealth = BIT_STR(name='satHealth', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_satHealth._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _AlmanacSatInfo_a_Sqrt = BIT_STR(name='a-Sqrt', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_a_Sqrt._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _AlmanacSatInfo_omega0 = BIT_STR(name='omega0', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_omega0._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _AlmanacSatInfo_m0 = BIT_STR(name='m0', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_m0._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _AlmanacSatInfo_omega = BIT_STR(name='omega', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_omega._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _AlmanacSatInfo_af0 = BIT_STR(name='af0', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_af0._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _AlmanacSatInfo_af1 = BIT_STR(name='af1', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AlmanacSatInfo_af1._const_sz = ASN1Set(rv=[11], rr=[], ev=None, er=[])
    _AlmanacSatInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AlmanacSatInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AlmanacSatInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AlmanacSatInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AlmanacSatInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlmanacSatInfo_iE_Extensions__item__id._const_tab = ____AlmanacSatInfo_iE_Extensions__item__id_tab
    ___AlmanacSatInfo_iE_Extensions__item__id._const_tab_at = None
    ___AlmanacSatInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___AlmanacSatInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AlmanacSatInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AlmanacSatInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlmanacSatInfo_iE_Extensions__item__criticality._const_tab = ____AlmanacSatInfo_iE_Extensions__item__criticality_tab
    ___AlmanacSatInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AlmanacSatInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AlmanacSatInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AlmanacSatInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AlmanacSatInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlmanacSatInfo_iE_Extensions__item__extensionValue._const_tab = ____AlmanacSatInfo_iE_Extensions__item__extensionValue_tab
    ___AlmanacSatInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AlmanacSatInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AlmanacSatInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AlmanacSatInfo_iE_Extensions__item__id),
        ('criticality', ___AlmanacSatInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___AlmanacSatInfo_iE_Extensions__item__extensionValue),
        ])
    __AlmanacSatInfo_iE_Extensions__item_._ext = None
    _AlmanacSatInfo_iE_Extensions._cont = __AlmanacSatInfo_iE_Extensions__item_
    _AlmanacSatInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AlmanacSatInfo._cont = ASN1Dict([
        ('dataID', _AlmanacSatInfo_dataID),
        ('satID', _AlmanacSatInfo_satID),
        ('e', _AlmanacSatInfo_e),
        ('t-oa', _AlmanacSatInfo_t_oa),
        ('deltaI', _AlmanacSatInfo_deltaI),
        ('omegaDot', _AlmanacSatInfo_omegaDot),
        ('satHealth', _AlmanacSatInfo_satHealth),
        ('a-Sqrt', _AlmanacSatInfo_a_Sqrt),
        ('omega0', _AlmanacSatInfo_omega0),
        ('m0', _AlmanacSatInfo_m0),
        ('omega', _AlmanacSatInfo_omega),
        ('af0', _AlmanacSatInfo_af0),
        ('af1', _AlmanacSatInfo_af1),
        ('iE-Extensions', _AlmanacSatInfo_iE_Extensions),
        ])
    AlmanacSatInfo._ext = []
    
    #-----< AlmanacSatInfo-ExtIEs >-----#
    AlmanacSatInfo_ExtIEs = CLASS(name='AlmanacSatInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AlmanacSatInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-ClockAndEphemerisParameters >-----#
    GPS_ClockAndEphemerisParameters = SEQ(name='GPS-ClockAndEphemerisParameters', mode=MODE_TYPE)
    _GPS_ClockAndEphemerisParameters_codeOnL2 = BIT_STR(name='codeOnL2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_codeOnL2._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_uraIndex = BIT_STR(name='uraIndex', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_uraIndex._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_satHealth = BIT_STR(name='satHealth', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_satHealth._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_iodc = BIT_STR(name='iodc', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_iodc._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_l2Pflag = BIT_STR(name='l2Pflag', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_l2Pflag._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_sf1Revd = SEQ(name='sf1Revd', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SubFrame1Reserved')))
    _GPS_ClockAndEphemerisParameters_t_GD = BIT_STR(name='t-GD', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_t_GD._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_t_oc = BIT_STR(name='t-oc', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_t_oc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_af2 = BIT_STR(name='af2', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_af2._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_af1 = BIT_STR(name='af1', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_af1._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_af0 = BIT_STR(name='af0', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_af0._const_sz = ASN1Set(rv=[22], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_c_rs = BIT_STR(name='c-rs', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_c_rs._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_delta_n = BIT_STR(name='delta-n', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_delta_n._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_m0 = BIT_STR(name='m0', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_m0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_c_uc = BIT_STR(name='c-uc', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_c_uc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_e = BIT_STR(name='e', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_e._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_c_us = BIT_STR(name='c-us', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_c_us._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_a_Sqrt = BIT_STR(name='a-Sqrt', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_a_Sqrt._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_t_oe = BIT_STR(name='t-oe', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_t_oe._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_fitInterval = BIT_STR(name='fitInterval', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_fitInterval._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_aodo = BIT_STR(name='aodo', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_aodo._const_sz = ASN1Set(rv=[5], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_c_ic = BIT_STR(name='c-ic', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_c_ic._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_omega0 = BIT_STR(name='omega0', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_omega0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_c_is = BIT_STR(name='c-is', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_c_is._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_i0 = BIT_STR(name='i0', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_i0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_c_rc = BIT_STR(name='c-rc', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_c_rc._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_omega = BIT_STR(name='omega', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_omega._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_omegaDot = BIT_STR(name='omegaDot', mode=MODE_TYPE, tag=(27, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_omegaDot._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_iDot = BIT_STR(name='iDot', mode=MODE_TYPE, tag=(28, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ClockAndEphemerisParameters_iDot._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GPS_ClockAndEphemerisParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(29, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_ClockAndEphemerisParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__id._const_tab = ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__id_tab
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__id._const_tab_at = None
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__criticality._const_tab = ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__criticality_tab
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__extensionValue._const_tab = ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__extensionValue_tab
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_ClockAndEphemerisParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__id),
        ('criticality', ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__extensionValue),
        ])
    __GPS_ClockAndEphemerisParameters_iE_Extensions__item_._ext = None
    _GPS_ClockAndEphemerisParameters_iE_Extensions._cont = __GPS_ClockAndEphemerisParameters_iE_Extensions__item_
    _GPS_ClockAndEphemerisParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_ClockAndEphemerisParameters._cont = ASN1Dict([
        ('codeOnL2', _GPS_ClockAndEphemerisParameters_codeOnL2),
        ('uraIndex', _GPS_ClockAndEphemerisParameters_uraIndex),
        ('satHealth', _GPS_ClockAndEphemerisParameters_satHealth),
        ('iodc', _GPS_ClockAndEphemerisParameters_iodc),
        ('l2Pflag', _GPS_ClockAndEphemerisParameters_l2Pflag),
        ('sf1Revd', _GPS_ClockAndEphemerisParameters_sf1Revd),
        ('t-GD', _GPS_ClockAndEphemerisParameters_t_GD),
        ('t-oc', _GPS_ClockAndEphemerisParameters_t_oc),
        ('af2', _GPS_ClockAndEphemerisParameters_af2),
        ('af1', _GPS_ClockAndEphemerisParameters_af1),
        ('af0', _GPS_ClockAndEphemerisParameters_af0),
        ('c-rs', _GPS_ClockAndEphemerisParameters_c_rs),
        ('delta-n', _GPS_ClockAndEphemerisParameters_delta_n),
        ('m0', _GPS_ClockAndEphemerisParameters_m0),
        ('c-uc', _GPS_ClockAndEphemerisParameters_c_uc),
        ('e', _GPS_ClockAndEphemerisParameters_e),
        ('c-us', _GPS_ClockAndEphemerisParameters_c_us),
        ('a-Sqrt', _GPS_ClockAndEphemerisParameters_a_Sqrt),
        ('t-oe', _GPS_ClockAndEphemerisParameters_t_oe),
        ('fitInterval', _GPS_ClockAndEphemerisParameters_fitInterval),
        ('aodo', _GPS_ClockAndEphemerisParameters_aodo),
        ('c-ic', _GPS_ClockAndEphemerisParameters_c_ic),
        ('omega0', _GPS_ClockAndEphemerisParameters_omega0),
        ('c-is', _GPS_ClockAndEphemerisParameters_c_is),
        ('i0', _GPS_ClockAndEphemerisParameters_i0),
        ('c-rc', _GPS_ClockAndEphemerisParameters_c_rc),
        ('omega', _GPS_ClockAndEphemerisParameters_omega),
        ('omegaDot', _GPS_ClockAndEphemerisParameters_omegaDot),
        ('iDot', _GPS_ClockAndEphemerisParameters_iDot),
        ('iE-Extensions', _GPS_ClockAndEphemerisParameters_iE_Extensions),
        ])
    GPS_ClockAndEphemerisParameters._ext = []
    
    #-----< GPS-ClockAndEphemerisParameters-ExtIEs >-----#
    GPS_ClockAndEphemerisParameters_ExtIEs = CLASS(name='GPS-ClockAndEphemerisParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GPS_ClockAndEphemerisParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SubFrame1Reserved >-----#
    SubFrame1Reserved = SEQ(name='SubFrame1Reserved', mode=MODE_TYPE)
    _SubFrame1Reserved_reserved1 = BIT_STR(name='reserved1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubFrame1Reserved_reserved1._const_sz = ASN1Set(rv=[23], rr=[], ev=None, er=[])
    _SubFrame1Reserved_reserved2 = BIT_STR(name='reserved2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubFrame1Reserved_reserved2._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SubFrame1Reserved_reserved3 = BIT_STR(name='reserved3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubFrame1Reserved_reserved3._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _SubFrame1Reserved_reserved4 = BIT_STR(name='reserved4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SubFrame1Reserved_reserved4._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    SubFrame1Reserved._cont = ASN1Dict([
        ('reserved1', _SubFrame1Reserved_reserved1),
        ('reserved2', _SubFrame1Reserved_reserved2),
        ('reserved3', _SubFrame1Reserved_reserved3),
        ('reserved4', _SubFrame1Reserved_reserved4),
        ])
    SubFrame1Reserved._ext = None
    
    #-----< GPS-Ionospheric-Model >-----#
    GPS_Ionospheric_Model = SEQ(name='GPS-Ionospheric-Model', mode=MODE_TYPE)
    _GPS_Ionospheric_Model_alfa0 = BIT_STR(name='alfa0', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alfa0._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_alfa1 = BIT_STR(name='alfa1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alfa1._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_alfa2 = BIT_STR(name='alfa2', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alfa2._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_alfa3 = BIT_STR(name='alfa3', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_alfa3._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta0 = BIT_STR(name='beta0', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta0._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta1 = BIT_STR(name='beta1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta1._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta2 = BIT_STR(name='beta2', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta2._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_beta3 = BIT_STR(name='beta3', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_Ionospheric_Model_beta3._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_Ionospheric_Model_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_Ionospheric_Model_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPS_Ionospheric_Model_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_Ionospheric_Model_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_Ionospheric_Model_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_Ionospheric_Model_iE_Extensions__item__id._const_tab = ____GPS_Ionospheric_Model_iE_Extensions__item__id_tab
    ___GPS_Ionospheric_Model_iE_Extensions__item__id._const_tab_at = None
    ___GPS_Ionospheric_Model_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_Ionospheric_Model_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPS_Ionospheric_Model_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_Ionospheric_Model_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_Ionospheric_Model_iE_Extensions__item__criticality._const_tab = ____GPS_Ionospheric_Model_iE_Extensions__item__criticality_tab
    ___GPS_Ionospheric_Model_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_Ionospheric_Model_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPS_Ionospheric_Model_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_Ionospheric_Model_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue._const_tab = ____GPS_Ionospheric_Model_iE_Extensions__item__extensionValue_tab
    ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_Ionospheric_Model_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_Ionospheric_Model_iE_Extensions__item__id),
        ('criticality', ___GPS_Ionospheric_Model_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue),
        ])
    __GPS_Ionospheric_Model_iE_Extensions__item_._ext = None
    _GPS_Ionospheric_Model_iE_Extensions._cont = __GPS_Ionospheric_Model_iE_Extensions__item_
    _GPS_Ionospheric_Model_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_Ionospheric_Model._cont = ASN1Dict([
        ('alfa0', _GPS_Ionospheric_Model_alfa0),
        ('alfa1', _GPS_Ionospheric_Model_alfa1),
        ('alfa2', _GPS_Ionospheric_Model_alfa2),
        ('alfa3', _GPS_Ionospheric_Model_alfa3),
        ('beta0', _GPS_Ionospheric_Model_beta0),
        ('beta1', _GPS_Ionospheric_Model_beta1),
        ('beta2', _GPS_Ionospheric_Model_beta2),
        ('beta3', _GPS_Ionospheric_Model_beta3),
        ('iE-Extensions', _GPS_Ionospheric_Model_iE_Extensions),
        ])
    GPS_Ionospheric_Model._ext = []
    
    #-----< GPS-Ionospheric-Model-ExtIEs >-----#
    GPS_Ionospheric_Model_ExtIEs = CLASS(name='GPS-Ionospheric-Model-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GPS_Ionospheric_Model_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasuredResultsList >-----#
    MeasuredResultsList = SEQ_OF(name='MeasuredResultsList', mode=MODE_TYPE)
    _MeasuredResultsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-MeasuredResults')))
    MeasuredResultsList._cont = _MeasuredResultsList__item_
    MeasuredResultsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    
    #-----< GPS-MeasuredResults >-----#
    GPS_MeasuredResults = SEQ(name='GPS-MeasuredResults', mode=MODE_TYPE)
    _GPS_MeasuredResults_gps_TOW_1msec = INT(name='gps-TOW-1msec', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_MeasuredResults_gps_TOW_1msec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=604799999)], ev=None, er=[])
    _GPS_MeasuredResults_gps_MeasurementParamList = SEQ_OF(name='gps-MeasurementParamList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-MeasurementParamList')))
    _GPS_MeasuredResults_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_MeasuredResults_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPS_MeasuredResults_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_MeasuredResults_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GPS_MeasuredResults_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GPSReferenceTimeResult')))
    _____GPS_MeasuredResults_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPSReferenceTimeUncertainty')))
    ____GPS_MeasuredResults_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'ignore'), ('Extension', _____GPS_MeasuredResults_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Extension', _____GPS_MeasuredResults_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GPS_MeasuredResults_iE_Extensions__item__id._const_tab = ____GPS_MeasuredResults_iE_Extensions__item__id_tab
    ___GPS_MeasuredResults_iE_Extensions__item__id._const_tab_at = None
    ___GPS_MeasuredResults_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_MeasuredResults_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GPS_MeasuredResults_iE_Extensions__item__criticality._const_tab = ____GPS_MeasuredResults_iE_Extensions__item__id_tab
    ___GPS_MeasuredResults_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_MeasuredResults_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_MeasuredResults_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GPS_MeasuredResults_iE_Extensions__item__extensionValue._const_tab = ____GPS_MeasuredResults_iE_Extensions__item__id_tab
    ___GPS_MeasuredResults_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_MeasuredResults_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_MeasuredResults_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_MeasuredResults_iE_Extensions__item__id),
        ('criticality', ___GPS_MeasuredResults_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_MeasuredResults_iE_Extensions__item__extensionValue),
        ])
    __GPS_MeasuredResults_iE_Extensions__item_._ext = None
    _GPS_MeasuredResults_iE_Extensions._cont = __GPS_MeasuredResults_iE_Extensions__item_
    _GPS_MeasuredResults_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_MeasuredResults._cont = ASN1Dict([
        ('gps-TOW-1msec', _GPS_MeasuredResults_gps_TOW_1msec),
        ('gps-MeasurementParamList', _GPS_MeasuredResults_gps_MeasurementParamList),
        ('iE-Extensions', _GPS_MeasuredResults_iE_Extensions),
        ])
    GPS_MeasuredResults._ext = []
    
    #-----< GPS-MeasuredResults-ExtIEs >-----#
    GPS_MeasuredResults_ExtIEs = CLASS(name='GPS-MeasuredResults-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GPS_MeasuredResults_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GPSReferenceTimeResult')))
    _GPS_MeasuredResults_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPSReferenceTimeUncertainty')))
    GPS_MeasuredResults_ExtIEs._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'ignore'), ('Extension', _GPS_MeasuredResults_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Extension', _GPS_MeasuredResults_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GPS-MeasurementParamList >-----#
    GPS_MeasurementParamList = SEQ_OF(name='GPS-MeasurementParamList', mode=MODE_TYPE)
    _GPS_MeasurementParamList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-MeasurementParam')))
    GPS_MeasurementParamList._cont = _GPS_MeasurementParamList__item_
    GPS_MeasurementParamList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GPS-MeasurementParam >-----#
    GPS_MeasurementParam = SEQ(name='GPS-MeasurementParam', mode=MODE_TYPE)
    _GPS_MeasurementParam_satelliteID = INT(name='satelliteID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_MeasurementParam_satelliteID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GPS_MeasurementParam_c_N0 = INT(name='c-N0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_MeasurementParam_c_N0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GPS_MeasurementParam_doppler = INT(name='doppler', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_MeasurementParam_doppler._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32768)], ev=None, er=[])
    _GPS_MeasurementParam_wholeGPS_Chips = INT(name='wholeGPS-Chips', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_MeasurementParam_wholeGPS_Chips._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1022)], ev=None, er=[])
    _GPS_MeasurementParam_fractionalGPS_Chips = INT(name='fractionalGPS-Chips', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_MeasurementParam_fractionalGPS_Chips._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _GPS_MeasurementParam_multipathIndicator = ENUM(name='multipathIndicator', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MultipathIndicator')))
    _GPS_MeasurementParam_pseudorangeRMS_Error = INT(name='pseudorangeRMS-Error', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_MeasurementParam_pseudorangeRMS_Error._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GPS_MeasurementParam_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_MeasurementParam_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPS_MeasurementParam_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_MeasurementParam_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_MeasurementParam_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_MeasurementParam_iE_Extensions__item__id._const_tab = ____GPS_MeasurementParam_iE_Extensions__item__id_tab
    ___GPS_MeasurementParam_iE_Extensions__item__id._const_tab_at = None
    ___GPS_MeasurementParam_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_MeasurementParam_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPS_MeasurementParam_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_MeasurementParam_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_MeasurementParam_iE_Extensions__item__criticality._const_tab = ____GPS_MeasurementParam_iE_Extensions__item__criticality_tab
    ___GPS_MeasurementParam_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_MeasurementParam_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_MeasurementParam_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPS_MeasurementParam_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_MeasurementParam_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_MeasurementParam_iE_Extensions__item__extensionValue._const_tab = ____GPS_MeasurementParam_iE_Extensions__item__extensionValue_tab
    ___GPS_MeasurementParam_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_MeasurementParam_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_MeasurementParam_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_MeasurementParam_iE_Extensions__item__id),
        ('criticality', ___GPS_MeasurementParam_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_MeasurementParam_iE_Extensions__item__extensionValue),
        ])
    __GPS_MeasurementParam_iE_Extensions__item_._ext = None
    _GPS_MeasurementParam_iE_Extensions._cont = __GPS_MeasurementParam_iE_Extensions__item_
    _GPS_MeasurementParam_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_MeasurementParam._cont = ASN1Dict([
        ('satelliteID', _GPS_MeasurementParam_satelliteID),
        ('c-N0', _GPS_MeasurementParam_c_N0),
        ('doppler', _GPS_MeasurementParam_doppler),
        ('wholeGPS-Chips', _GPS_MeasurementParam_wholeGPS_Chips),
        ('fractionalGPS-Chips', _GPS_MeasurementParam_fractionalGPS_Chips),
        ('multipathIndicator', _GPS_MeasurementParam_multipathIndicator),
        ('pseudorangeRMS-Error', _GPS_MeasurementParam_pseudorangeRMS_Error),
        ('iE-Extensions', _GPS_MeasurementParam_iE_Extensions),
        ])
    GPS_MeasurementParam._ext = []
    
    #-----< MultipathIndicator >-----#
    MultipathIndicator = ENUM(name='MultipathIndicator', mode=MODE_TYPE)
    MultipathIndicator._cont = ASN1Dict([('nm', 0), ('low', 1), ('medium', 2), ('high', 3)])
    MultipathIndicator._ext = None
    
    #-----< GPS-MeasurementParam-ExtIEs >-----#
    GPS_MeasurementParam_ExtIEs = CLASS(name='GPS-MeasurementParam-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GPS_MeasurementParam_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-NavigationModel >-----#
    GPS_NavigationModel = SEQ_OF(name='GPS-NavigationModel', mode=MODE_TYPE)
    _GPS_NavigationModel__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'NavigationModelSatInfo')))
    GPS_NavigationModel._cont = _GPS_NavigationModel__item_
    GPS_NavigationModel._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< NavigationModelSatInfo >-----#
    NavigationModelSatInfo = SEQ(name='NavigationModelSatInfo', mode=MODE_TYPE)
    _NavigationModelSatInfo_satID = INT(name='satID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavigationModelSatInfo_satID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _NavigationModelSatInfo_satelliteStatus = ENUM(name='satelliteStatus', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SatelliteStatus')))
    _NavigationModelSatInfo_gps_clockAndEphemerisParms = SEQ(name='gps-clockAndEphemerisParms', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-ClockAndEphemerisParameters')), opt=True)
    _NavigationModelSatInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NavigationModelSatInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___NavigationModelSatInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____NavigationModelSatInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavigationModelSatInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavigationModelSatInfo_iE_Extensions__item__id._const_tab = ____NavigationModelSatInfo_iE_Extensions__item__id_tab
    ___NavigationModelSatInfo_iE_Extensions__item__id._const_tab_at = None
    ___NavigationModelSatInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___NavigationModelSatInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NavigationModelSatInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavigationModelSatInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavigationModelSatInfo_iE_Extensions__item__criticality._const_tab = ____NavigationModelSatInfo_iE_Extensions__item__criticality_tab
    ___NavigationModelSatInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NavigationModelSatInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NavigationModelSatInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NavigationModelSatInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavigationModelSatInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavigationModelSatInfo_iE_Extensions__item__extensionValue._const_tab = ____NavigationModelSatInfo_iE_Extensions__item__extensionValue_tab
    ___NavigationModelSatInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NavigationModelSatInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NavigationModelSatInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NavigationModelSatInfo_iE_Extensions__item__id),
        ('criticality', ___NavigationModelSatInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___NavigationModelSatInfo_iE_Extensions__item__extensionValue),
        ])
    __NavigationModelSatInfo_iE_Extensions__item_._ext = None
    _NavigationModelSatInfo_iE_Extensions._cont = __NavigationModelSatInfo_iE_Extensions__item_
    _NavigationModelSatInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NavigationModelSatInfo._cont = ASN1Dict([
        ('satID', _NavigationModelSatInfo_satID),
        ('satelliteStatus', _NavigationModelSatInfo_satelliteStatus),
        ('gps-clockAndEphemerisParms', _NavigationModelSatInfo_gps_clockAndEphemerisParms),
        ('iE-Extensions', _NavigationModelSatInfo_iE_Extensions),
        ])
    NavigationModelSatInfo._ext = []
    
    #-----< NavigationModelSatInfo-ExtIEs >-----#
    NavigationModelSatInfo_ExtIEs = CLASS(name='NavigationModelSatInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    NavigationModelSatInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SatelliteStatus >-----#
    SatelliteStatus = ENUM(name='SatelliteStatus', mode=MODE_TYPE)
    SatelliteStatus._cont = ASN1Dict([('ns-NN', 0), ('es-SN', 1), ('es-NN', 2), ('rev2', 3), ('rev', 4)])
    SatelliteStatus._ext = None
    
    #-----< GPS-RealTimeIntegrity >-----#
    GPS_RealTimeIntegrity = CHOICE(name='GPS-RealTimeIntegrity', mode=MODE_TYPE)
    _GPS_RealTimeIntegrity_badSatellites = SEQ_OF(name='badSatellites', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'BadSatList')))
    _GPS_RealTimeIntegrity_noBadSatellites = NULL(name='noBadSatellites', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NoBadSatellites')))
    GPS_RealTimeIntegrity._cont = ASN1Dict([
        ('badSatellites', _GPS_RealTimeIntegrity_badSatellites),
        ('noBadSatellites', _GPS_RealTimeIntegrity_noBadSatellites),
        ])
    GPS_RealTimeIntegrity._ext = []
    
    #-----< BadSatList >-----#
    BadSatList = SEQ_OF(name='BadSatList', mode=MODE_TYPE)
    _BadSatList__item_ = INT(name='_item_', mode=MODE_TYPE)
    _BadSatList__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    BadSatList._cont = _BadSatList__item_
    BadSatList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< NoBadSatellites >-----#
    NoBadSatellites = NULL(name='NoBadSatellites', mode=MODE_TYPE)
    
    #-----< GPS-ReferenceLocation >-----#
    GPS_ReferenceLocation = SEQ(name='GPS-ReferenceLocation', mode=MODE_TYPE)
    _GPS_ReferenceLocation_ue_PositionEstimate = CHOICE(name='ue-PositionEstimate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _GPS_ReferenceLocation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_ReferenceLocation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPS_ReferenceLocation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_ReferenceLocation_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_ReferenceLocation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_ReferenceLocation_iE_Extensions__item__id._const_tab = ____GPS_ReferenceLocation_iE_Extensions__item__id_tab
    ___GPS_ReferenceLocation_iE_Extensions__item__id._const_tab_at = None
    ___GPS_ReferenceLocation_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_ReferenceLocation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPS_ReferenceLocation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_ReferenceLocation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_ReferenceLocation_iE_Extensions__item__criticality._const_tab = ____GPS_ReferenceLocation_iE_Extensions__item__criticality_tab
    ___GPS_ReferenceLocation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_ReferenceLocation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_ReferenceLocation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPS_ReferenceLocation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_ReferenceLocation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_ReferenceLocation_iE_Extensions__item__extensionValue._const_tab = ____GPS_ReferenceLocation_iE_Extensions__item__extensionValue_tab
    ___GPS_ReferenceLocation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_ReferenceLocation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_ReferenceLocation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_ReferenceLocation_iE_Extensions__item__id),
        ('criticality', ___GPS_ReferenceLocation_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_ReferenceLocation_iE_Extensions__item__extensionValue),
        ])
    __GPS_ReferenceLocation_iE_Extensions__item_._ext = None
    _GPS_ReferenceLocation_iE_Extensions._cont = __GPS_ReferenceLocation_iE_Extensions__item_
    _GPS_ReferenceLocation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_ReferenceLocation._cont = ASN1Dict([
        ('ue-PositionEstimate', _GPS_ReferenceLocation_ue_PositionEstimate),
        ('iE-Extensions', _GPS_ReferenceLocation_iE_Extensions),
        ])
    GPS_ReferenceLocation._ext = []
    
    #-----< GPS-ReferenceLocation-ExtIEs >-----#
    GPS_ReferenceLocation_ExtIEs = CLASS(name='GPS-ReferenceLocation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GPS_ReferenceLocation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-ReferenceTime >-----#
    GPS_ReferenceTime = SEQ(name='GPS-ReferenceTime', mode=MODE_TYPE)
    _GPS_ReferenceTime_gps_Week = INT(name='gps-Week', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ReferenceTime_gps_Week._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _GPS_ReferenceTime_gps_TOW_1msec = INT(name='gps-TOW-1msec', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_ReferenceTime_gps_TOW_1msec._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=604799999)], ev=None, er=[])
    _GPS_ReferenceTime_gps_TOW_AssistList = SEQ_OF(name='gps-TOW-AssistList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-TOW-AssistList')), opt=True)
    _GPS_ReferenceTime_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_ReferenceTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPS_ReferenceTime_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_ReferenceTime_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GPSReferenceTime')))
    _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-UTRAN-TRU')))
    _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GPS-DriftRate')))
    _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPSReferenceTimeUncertainty')))
    _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-Week-Cycle')))
    ____GPS_ReferenceTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 46), ('criticality', 'ignore'), ('Extension', _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Extension', _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'ignore'), ('Extension', _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Extension', _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Extension', _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GPS_ReferenceTime_iE_Extensions__item__id._const_tab = ____GPS_ReferenceTime_iE_Extensions__item__id_tab
    ___GPS_ReferenceTime_iE_Extensions__item__id._const_tab_at = None
    ___GPS_ReferenceTime_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_ReferenceTime_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GPS_ReferenceTime_iE_Extensions__item__criticality._const_tab = ____GPS_ReferenceTime_iE_Extensions__item__id_tab
    ___GPS_ReferenceTime_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_ReferenceTime_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_ReferenceTime_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GPS_ReferenceTime_iE_Extensions__item__extensionValue._const_tab = ____GPS_ReferenceTime_iE_Extensions__item__id_tab
    ___GPS_ReferenceTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_ReferenceTime_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_ReferenceTime_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_ReferenceTime_iE_Extensions__item__id),
        ('criticality', ___GPS_ReferenceTime_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_ReferenceTime_iE_Extensions__item__extensionValue),
        ])
    __GPS_ReferenceTime_iE_Extensions__item_._ext = None
    _GPS_ReferenceTime_iE_Extensions._cont = __GPS_ReferenceTime_iE_Extensions__item_
    _GPS_ReferenceTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_ReferenceTime._cont = ASN1Dict([
        ('gps-Week', _GPS_ReferenceTime_gps_Week),
        ('gps-TOW-1msec', _GPS_ReferenceTime_gps_TOW_1msec),
        ('gps-TOW-AssistList', _GPS_ReferenceTime_gps_TOW_AssistList),
        ('iE-Extensions', _GPS_ReferenceTime_iE_Extensions),
        ])
    GPS_ReferenceTime._ext = []
    
    #-----< GPS-ReferenceTime-ExtIEs >-----#
    GPS_ReferenceTime_ExtIEs = CLASS(name='GPS-ReferenceTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GPS_ReferenceTime_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GPSReferenceTime')))
    _GPS_ReferenceTime_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-UTRAN-TRU')))
    _GPS_ReferenceTime_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTRAN-GPS-DriftRate')))
    _GPS_ReferenceTime_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPSReferenceTimeUncertainty')))
    _GPS_ReferenceTime_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-Week-Cycle')))
    GPS_ReferenceTime_ExtIEs._val = ASN1Set(rv=[dict([('id', 46), ('criticality', 'ignore'), ('Extension', _GPS_ReferenceTime_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Extension', _GPS_ReferenceTime_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 48), ('criticality', 'ignore'), ('Extension', _GPS_ReferenceTime_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Extension', _GPS_ReferenceTime_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Extension', _GPS_ReferenceTime_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GPS-Week-Cycle >-----#
    GPS_Week_Cycle = INT(name='GPS-Week-Cycle', mode=MODE_TYPE)
    GPS_Week_Cycle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< GPS-TOW-AssistList >-----#
    GPS_TOW_AssistList = SEQ_OF(name='GPS-TOW-AssistList', mode=MODE_TYPE)
    _GPS_TOW_AssistList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-TOW-Assist')))
    GPS_TOW_AssistList._cont = _GPS_TOW_AssistList__item_
    GPS_TOW_AssistList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GPS-TOW-Assist >-----#
    GPS_TOW_Assist = SEQ(name='GPS-TOW-Assist', mode=MODE_TYPE)
    _GPS_TOW_Assist_satID = INT(name='satID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_TOW_Assist_satID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _GPS_TOW_Assist_tlm_Message = BIT_STR(name='tlm-Message', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_TOW_Assist_tlm_Message._const_sz = ASN1Set(rv=[14], rr=[], ev=None, er=[])
    _GPS_TOW_Assist_antiSpoof = BOOL(name='antiSpoof', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_TOW_Assist_alert = BOOL(name='alert', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_TOW_Assist_tlm_Reserved = BIT_STR(name='tlm-Reserved', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_TOW_Assist_tlm_Reserved._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GPS_TOW_Assist_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_TOW_Assist_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPS_TOW_Assist_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_TOW_Assist_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_TOW_Assist_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_TOW_Assist_iE_Extensions__item__id._const_tab = ____GPS_TOW_Assist_iE_Extensions__item__id_tab
    ___GPS_TOW_Assist_iE_Extensions__item__id._const_tab_at = None
    ___GPS_TOW_Assist_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_TOW_Assist_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPS_TOW_Assist_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_TOW_Assist_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_TOW_Assist_iE_Extensions__item__criticality._const_tab = ____GPS_TOW_Assist_iE_Extensions__item__criticality_tab
    ___GPS_TOW_Assist_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_TOW_Assist_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_TOW_Assist_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPS_TOW_Assist_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_TOW_Assist_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_TOW_Assist_iE_Extensions__item__extensionValue._const_tab = ____GPS_TOW_Assist_iE_Extensions__item__extensionValue_tab
    ___GPS_TOW_Assist_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_TOW_Assist_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_TOW_Assist_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_TOW_Assist_iE_Extensions__item__id),
        ('criticality', ___GPS_TOW_Assist_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_TOW_Assist_iE_Extensions__item__extensionValue),
        ])
    __GPS_TOW_Assist_iE_Extensions__item_._ext = None
    _GPS_TOW_Assist_iE_Extensions._cont = __GPS_TOW_Assist_iE_Extensions__item_
    _GPS_TOW_Assist_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_TOW_Assist._cont = ASN1Dict([
        ('satID', _GPS_TOW_Assist_satID),
        ('tlm-Message', _GPS_TOW_Assist_tlm_Message),
        ('antiSpoof', _GPS_TOW_Assist_antiSpoof),
        ('alert', _GPS_TOW_Assist_alert),
        ('tlm-Reserved', _GPS_TOW_Assist_tlm_Reserved),
        ('iE-Extensions', _GPS_TOW_Assist_iE_Extensions),
        ])
    GPS_TOW_Assist._ext = []
    
    #-----< GPS-TOW-Assist-ExtIEs >-----#
    GPS_TOW_Assist_ExtIEs = CLASS(name='GPS-TOW-Assist-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GPS_TOW_Assist_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTRAN-GPS-DriftRate >-----#
    UTRAN_GPS_DriftRate = ENUM(name='UTRAN-GPS-DriftRate', mode=MODE_TYPE)
    UTRAN_GPS_DriftRate._cont = ASN1Dict([('utran-GPSDrift0', 0), ('utran-GPSDrift1', 1), ('utran-GPSDrift2', 2), ('utran-GPSDrift5', 3), ('utran-GPSDrift10', 4), ('utran-GPSDrift15', 5), ('utran-GPSDrift25', 6), ('utran-GPSDrift50', 7), ('utran-GPSDrift-1', 8), ('utran-GPSDrift-2', 9), ('utran-GPSDrift-5', 10), ('utran-GPSDrift-10', 11), ('utran-GPSDrift-15', 12), ('utran-GPSDrift-25', 13), ('utran-GPSDrift-50', 14)])
    UTRAN_GPS_DriftRate._ext = []
    
    #-----< GPSReferenceTimeUncertainty >-----#
    GPSReferenceTimeUncertainty = SEQ(name='GPSReferenceTimeUncertainty', mode=MODE_TYPE)
    _GPSReferenceTimeUncertainty_gps_RefTimeUNC = INT(name='gps-RefTimeUNC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPSReferenceTimeUncertainty_gps_RefTimeUNC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GPSReferenceTimeUncertainty_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPSReferenceTimeUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPSReferenceTimeUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPSReferenceTimeUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__id._const_tab = ____GPSReferenceTimeUncertainty_iE_Extensions__item__id_tab
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPSReferenceTimeUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPSReferenceTimeUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__criticality._const_tab = ____GPSReferenceTimeUncertainty_iE_Extensions__item__criticality_tab
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPSReferenceTimeUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPSReferenceTimeUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__extensionValue._const_tab = ____GPSReferenceTimeUncertainty_iE_Extensions__item__extensionValue_tab
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPSReferenceTimeUncertainty_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPSReferenceTimeUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPSReferenceTimeUncertainty_iE_Extensions__item__id),
        ('criticality', ___GPSReferenceTimeUncertainty_iE_Extensions__item__criticality),
        ('extensionValue', ___GPSReferenceTimeUncertainty_iE_Extensions__item__extensionValue),
        ])
    __GPSReferenceTimeUncertainty_iE_Extensions__item_._ext = None
    _GPSReferenceTimeUncertainty_iE_Extensions._cont = __GPSReferenceTimeUncertainty_iE_Extensions__item_
    _GPSReferenceTimeUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPSReferenceTimeUncertainty._cont = ASN1Dict([
        ('gps-RefTimeUNC', _GPSReferenceTimeUncertainty_gps_RefTimeUNC),
        ('iE-Extensions', _GPSReferenceTimeUncertainty_iE_Extensions),
        ])
    GPSReferenceTimeUncertainty._ext = []
    
    #-----< GPSReferenceTimeUncertainty-ExtIEs >-----#
    GPSReferenceTimeUncertainty_ExtIEs = CLASS(name='GPSReferenceTimeUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GPSReferenceTimeUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-Transmission-TOW >-----#
    GPS_Transmission_TOW = INT(name='GPS-Transmission-TOW', mode=MODE_TYPE)
    GPS_Transmission_TOW._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=604799)], ev=None, er=[])
    
    #-----< GPS-UTC-Model >-----#
    GPS_UTC_Model = SEQ(name='GPS-UTC-Model', mode=MODE_TYPE)
    _GPS_UTC_Model_a1 = BIT_STR(name='a1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_a1._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _GPS_UTC_Model_a0 = BIT_STR(name='a0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_a0._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    _GPS_UTC_Model_t_ot = BIT_STR(name='t-ot', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_t_ot._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_delta_t_LS = BIT_STR(name='delta-t-LS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_delta_t_LS._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_wn_t = BIT_STR(name='wn-t', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_wn_t._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_wn_lsf = BIT_STR(name='wn-lsf', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_wn_lsf._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_dn = BIT_STR(name='dn', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_dn._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_delta_t_LSF = BIT_STR(name='delta-t-LSF', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPS_UTC_Model_delta_t_LSF._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GPS_UTC_Model_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPS_UTC_Model_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPS_UTC_Model_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPS_UTC_Model_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_UTC_Model_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_UTC_Model_iE_Extensions__item__id._const_tab = ____GPS_UTC_Model_iE_Extensions__item__id_tab
    ___GPS_UTC_Model_iE_Extensions__item__id._const_tab_at = None
    ___GPS_UTC_Model_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPS_UTC_Model_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPS_UTC_Model_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_UTC_Model_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_UTC_Model_iE_Extensions__item__criticality._const_tab = ____GPS_UTC_Model_iE_Extensions__item__criticality_tab
    ___GPS_UTC_Model_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPS_UTC_Model_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPS_UTC_Model_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPS_UTC_Model_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPS_UTC_Model_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPS_UTC_Model_iE_Extensions__item__extensionValue._const_tab = ____GPS_UTC_Model_iE_Extensions__item__extensionValue_tab
    ___GPS_UTC_Model_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPS_UTC_Model_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPS_UTC_Model_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPS_UTC_Model_iE_Extensions__item__id),
        ('criticality', ___GPS_UTC_Model_iE_Extensions__item__criticality),
        ('extensionValue', ___GPS_UTC_Model_iE_Extensions__item__extensionValue),
        ])
    __GPS_UTC_Model_iE_Extensions__item_._ext = None
    _GPS_UTC_Model_iE_Extensions._cont = __GPS_UTC_Model_iE_Extensions__item_
    _GPS_UTC_Model_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPS_UTC_Model._cont = ASN1Dict([
        ('a1', _GPS_UTC_Model_a1),
        ('a0', _GPS_UTC_Model_a0),
        ('t-ot', _GPS_UTC_Model_t_ot),
        ('delta-t-LS', _GPS_UTC_Model_delta_t_LS),
        ('wn-t', _GPS_UTC_Model_wn_t),
        ('wn-lsf', _GPS_UTC_Model_wn_lsf),
        ('dn', _GPS_UTC_Model_dn),
        ('delta-t-LSF', _GPS_UTC_Model_delta_t_LSF),
        ('iE-Extensions', _GPS_UTC_Model_iE_Extensions),
        ])
    GPS_UTC_Model._ext = []
    
    #-----< GPS-UTCmodel-ExtIEs >-----#
    GPS_UTCmodel_ExtIEs = CLASS(name='GPS-UTCmodel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GPS_UTCmodel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPS-UTRAN-TRU >-----#
    GPS_UTRAN_TRU = ENUM(name='GPS-UTRAN-TRU', mode=MODE_TYPE)
    GPS_UTRAN_TRU._cont = ASN1Dict([('nsec-50', 0), ('nsec-500', 1), ('usec-1', 2), ('usec-10', 3), ('msec-1', 4), ('msec-10', 5), ('msec-100', 6), ('unreliable', 7)])
    GPS_UTRAN_TRU._ext = []
    
    #-----< AdditionalGPSAssistDataRequired >-----#
    AdditionalGPSAssistDataRequired = SEQ(name='AdditionalGPSAssistDataRequired', mode=MODE_TYPE)
    _AdditionalGPSAssistDataRequired_almanacRequest = BOOL(name='almanacRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGPSAssistDataRequired_utcModelRequest = BOOL(name='utcModelRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGPSAssistDataRequired_ionosphericModelRequest = BOOL(name='ionosphericModelRequest', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGPSAssistDataRequired_navigationModelRequest = BOOL(name='navigationModelRequest', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGPSAssistDataRequired_dgpsCorrectionsRequest = BOOL(name='dgpsCorrectionsRequest', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGPSAssistDataRequired_referenceLocationRequest = BOOL(name='referenceLocationRequest', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGPSAssistDataRequired_referenceTimeRequest = BOOL(name='referenceTimeRequest', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGPSAssistDataRequired_aquisitionAssistanceRequest = BOOL(name='aquisitionAssistanceRequest', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGPSAssistDataRequired_realTimeIntegrityRequest = BOOL(name='realTimeIntegrityRequest', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGPSAssistDataRequired_navModelAddDataRequest = SEQ(name='navModelAddDataRequest', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NavModelAdditionalData')), opt=True)
    _AdditionalGPSAssistDataRequired_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalGPSAssistDataRequired_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalGPSAssistDataRequired_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AdditionalGPSAssistDataRequired_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__id._const_tab = ____AdditionalGPSAssistDataRequired_iE_Extensions__item__id_tab
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AdditionalGPSAssistDataRequired_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AdditionalGPSAssistDataRequired_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__criticality._const_tab = ____AdditionalGPSAssistDataRequired_iE_Extensions__item__criticality_tab
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AdditionalGPSAssistDataRequired_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AdditionalGPSAssistDataRequired_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__extensionValue._const_tab = ____AdditionalGPSAssistDataRequired_iE_Extensions__item__extensionValue_tab
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalGPSAssistDataRequired_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalGPSAssistDataRequired_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalGPSAssistDataRequired_iE_Extensions__item__id),
        ('criticality', ___AdditionalGPSAssistDataRequired_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalGPSAssistDataRequired_iE_Extensions__item__extensionValue),
        ])
    __AdditionalGPSAssistDataRequired_iE_Extensions__item_._ext = None
    _AdditionalGPSAssistDataRequired_iE_Extensions._cont = __AdditionalGPSAssistDataRequired_iE_Extensions__item_
    _AdditionalGPSAssistDataRequired_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalGPSAssistDataRequired._cont = ASN1Dict([
        ('almanacRequest', _AdditionalGPSAssistDataRequired_almanacRequest),
        ('utcModelRequest', _AdditionalGPSAssistDataRequired_utcModelRequest),
        ('ionosphericModelRequest', _AdditionalGPSAssistDataRequired_ionosphericModelRequest),
        ('navigationModelRequest', _AdditionalGPSAssistDataRequired_navigationModelRequest),
        ('dgpsCorrectionsRequest', _AdditionalGPSAssistDataRequired_dgpsCorrectionsRequest),
        ('referenceLocationRequest', _AdditionalGPSAssistDataRequired_referenceLocationRequest),
        ('referenceTimeRequest', _AdditionalGPSAssistDataRequired_referenceTimeRequest),
        ('aquisitionAssistanceRequest', _AdditionalGPSAssistDataRequired_aquisitionAssistanceRequest),
        ('realTimeIntegrityRequest', _AdditionalGPSAssistDataRequired_realTimeIntegrityRequest),
        ('navModelAddDataRequest', _AdditionalGPSAssistDataRequired_navModelAddDataRequest),
        ('iE-Extensions', _AdditionalGPSAssistDataRequired_iE_Extensions),
        ])
    AdditionalGPSAssistDataRequired._ext = []
    
    #-----< AdditionalGPSAssistDataRequired-ExtIEs >-----#
    AdditionalGPSAssistDataRequired_ExtIEs = CLASS(name='AdditionalGPSAssistDataRequired-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AdditionalGPSAssistDataRequired_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AdditionalGanssAssistDataRequired >-----#
    AdditionalGanssAssistDataRequired = SEQ(name='AdditionalGanssAssistDataRequired', mode=MODE_TYPE)
    _AdditionalGanssAssistDataRequired_ganssReferenceTime = BOOL(name='ganssReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGanssAssistDataRequired_ganssreferenceLocation = BOOL(name='ganssreferenceLocation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGanssAssistDataRequired_ganssIonosphericModel = BOOL(name='ganssIonosphericModel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AdditionalGanssAssistDataRequired_ganssRequestedGenericAssistanceDataList = SEQ_OF(name='ganssRequestedGenericAssistanceDataList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GanssRequestedGenericAssistanceDataList')))
    _AdditionalGanssAssistDataRequired_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalGanssAssistDataRequired_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSSReq-AddIonosphericModel')))
    _____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSSReq-EarthOrientPara')))
    ____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__id._const_tab = ____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__criticality._const_tab = ____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__extensionValue._const_tab = ____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalGanssAssistDataRequired_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalGanssAssistDataRequired_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalGanssAssistDataRequired_iE_Extensions__item__id),
        ('criticality', ___AdditionalGanssAssistDataRequired_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalGanssAssistDataRequired_iE_Extensions__item__extensionValue),
        ])
    __AdditionalGanssAssistDataRequired_iE_Extensions__item_._ext = None
    _AdditionalGanssAssistDataRequired_iE_Extensions._cont = __AdditionalGanssAssistDataRequired_iE_Extensions__item_
    _AdditionalGanssAssistDataRequired_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalGanssAssistDataRequired._cont = ASN1Dict([
        ('ganssReferenceTime', _AdditionalGanssAssistDataRequired_ganssReferenceTime),
        ('ganssreferenceLocation', _AdditionalGanssAssistDataRequired_ganssreferenceLocation),
        ('ganssIonosphericModel', _AdditionalGanssAssistDataRequired_ganssIonosphericModel),
        ('ganssRequestedGenericAssistanceDataList', _AdditionalGanssAssistDataRequired_ganssRequestedGenericAssistanceDataList),
        ('iE-Extensions', _AdditionalGanssAssistDataRequired_iE_Extensions),
        ])
    AdditionalGanssAssistDataRequired._ext = []
    
    #-----< AdditionalGanssAssistDataRequired-ExtIEs >-----#
    AdditionalGanssAssistDataRequired_ExtIEs = CLASS(name='AdditionalGanssAssistDataRequired-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _AdditionalGanssAssistDataRequired_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSSReq-AddIonosphericModel')))
    _AdditionalGanssAssistDataRequired_ExtIEs_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSSReq-EarthOrientPara')))
    AdditionalGanssAssistDataRequired_ExtIEs._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _AdditionalGanssAssistDataRequired_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 104), ('criticality', 'ignore'), ('Extension', _AdditionalGanssAssistDataRequired_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSSReq-AddIonosphericModel >-----#
    GANSSReq_AddIonosphericModel = SEQ(name='GANSSReq-AddIonosphericModel', mode=MODE_TYPE)
    _GANSSReq_AddIonosphericModel_ganss_add_iono_mode_req = BIT_STR(name='ganss-add-iono-mode-req', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSSReq_AddIonosphericModel_ganss_add_iono_mode_req._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSSReq_AddIonosphericModel_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSSReq_AddIonosphericModel_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSSReq_AddIonosphericModel_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSSReq_AddIonosphericModel_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__id._const_tab = ____GANSSReq_AddIonosphericModel_iE_Extensions__item__id_tab
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__id._const_tab_at = None
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSSReq_AddIonosphericModel_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSSReq_AddIonosphericModel_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__criticality._const_tab = ____GANSSReq_AddIonosphericModel_iE_Extensions__item__criticality_tab
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSSReq_AddIonosphericModel_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSSReq_AddIonosphericModel_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__extensionValue._const_tab = ____GANSSReq_AddIonosphericModel_iE_Extensions__item__extensionValue_tab
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSSReq_AddIonosphericModel_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSSReq_AddIonosphericModel_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSSReq_AddIonosphericModel_iE_Extensions__item__id),
        ('criticality', ___GANSSReq_AddIonosphericModel_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSSReq_AddIonosphericModel_iE_Extensions__item__extensionValue),
        ])
    __GANSSReq_AddIonosphericModel_iE_Extensions__item_._ext = None
    _GANSSReq_AddIonosphericModel_iE_Extensions._cont = __GANSSReq_AddIonosphericModel_iE_Extensions__item_
    _GANSSReq_AddIonosphericModel_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSSReq_AddIonosphericModel._cont = ASN1Dict([
        ('ganss-add-iono-mode-req', _GANSSReq_AddIonosphericModel_ganss_add_iono_mode_req),
        ('iE-Extensions', _GANSSReq_AddIonosphericModel_iE_Extensions),
        ])
    GANSSReq_AddIonosphericModel._ext = []
    
    #-----< GANSSReq-AddIonosphericModel-ExtIEs >-----#
    GANSSReq_AddIonosphericModel_ExtIEs = CLASS(name='GANSSReq-AddIonosphericModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSSReq_AddIonosphericModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSSReq-EarthOrientPara >-----#
    GANSSReq_EarthOrientPara = BOOL(name='GANSSReq-EarthOrientPara', mode=MODE_TYPE)
    
    #-----< GanssRequestedGenericAssistanceDataList >-----#
    GanssRequestedGenericAssistanceDataList = SEQ_OF(name='GanssRequestedGenericAssistanceDataList', mode=MODE_TYPE)
    _GanssRequestedGenericAssistanceDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GanssReqGenericData')))
    GanssRequestedGenericAssistanceDataList._cont = _GanssRequestedGenericAssistanceDataList__item_
    GanssRequestedGenericAssistanceDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GanssReqGenericData >-----#
    GanssReqGenericData = SEQ(name='GanssReqGenericData', mode=MODE_TYPE)
    _GanssReqGenericData_ganssId = SEQ(name='ganssId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    _GanssReqGenericData_ganssRealTimeIntegrity = BOOL(name='ganssRealTimeIntegrity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssReqGenericData_ganssDifferentialCorrection = BIT_STR(name='ganssDifferentialCorrection', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DGANSS-Sig-Id-Req')), opt=True)
    _GanssReqGenericData_ganssAlmanac = BOOL(name='ganssAlmanac', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssReqGenericData_ganssNavigationModel = BOOL(name='ganssNavigationModel', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssReqGenericData_ganssTimeModelGnssGnss = BIT_STR(name='ganssTimeModelGnssGnss', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssReqGenericData_ganssTimeModelGnssGnss._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _GanssReqGenericData_ganssReferenceMeasurementInfo = BOOL(name='ganssReferenceMeasurementInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssReqGenericData_ganssDataBits = SEQ(name='ganssDataBits', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GanssDataBits')), opt=True)
    _GanssReqGenericData_ganssUTCModel = BOOL(name='ganssUTCModel', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssReqGenericData_ganssNavigationModelAdditionalData = SEQ(name='ganssNavigationModelAdditionalData', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NavigationModelGANSS')), opt=True)
    _GanssReqGenericData_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GanssReqGenericData_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GanssReqGenericData_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GanssReqGenericData_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddNavigationModel-Req')))
    _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddUTCModel-Req')))
    _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_2 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AuxInfo-req')))
    _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SBAS-ID')))
    _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddADchoices')))
    _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_5 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'BDSIonosphericGridModel')))
    _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DBDSCorrection')))
    ____GanssReqGenericData_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 105), ('criticality', 'ignore'), ('Extension', _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Extension', _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Extension', _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'ignore'), ('Extension', _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 116), ('criticality', 'ignore'), ('Extension', _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 133), ('criticality', 'ignore'), ('Extension', _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'ignore'), ('Extension', _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GanssReqGenericData_iE_Extensions__item__id._const_tab = ____GanssReqGenericData_iE_Extensions__item__id_tab
    ___GanssReqGenericData_iE_Extensions__item__id._const_tab_at = None
    ___GanssReqGenericData_iE_Extensions__item__id._const_tab_id = 'id'
    ___GanssReqGenericData_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GanssReqGenericData_iE_Extensions__item__criticality._const_tab = ____GanssReqGenericData_iE_Extensions__item__id_tab
    ___GanssReqGenericData_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GanssReqGenericData_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GanssReqGenericData_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GanssReqGenericData_iE_Extensions__item__extensionValue._const_tab = ____GanssReqGenericData_iE_Extensions__item__id_tab
    ___GanssReqGenericData_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GanssReqGenericData_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GanssReqGenericData_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GanssReqGenericData_iE_Extensions__item__id),
        ('criticality', ___GanssReqGenericData_iE_Extensions__item__criticality),
        ('extensionValue', ___GanssReqGenericData_iE_Extensions__item__extensionValue),
        ])
    __GanssReqGenericData_iE_Extensions__item_._ext = None
    _GanssReqGenericData_iE_Extensions._cont = __GanssReqGenericData_iE_Extensions__item_
    _GanssReqGenericData_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GanssReqGenericData._cont = ASN1Dict([
        ('ganssId', _GanssReqGenericData_ganssId),
        ('ganssRealTimeIntegrity', _GanssReqGenericData_ganssRealTimeIntegrity),
        ('ganssDifferentialCorrection', _GanssReqGenericData_ganssDifferentialCorrection),
        ('ganssAlmanac', _GanssReqGenericData_ganssAlmanac),
        ('ganssNavigationModel', _GanssReqGenericData_ganssNavigationModel),
        ('ganssTimeModelGnssGnss', _GanssReqGenericData_ganssTimeModelGnssGnss),
        ('ganssReferenceMeasurementInfo', _GanssReqGenericData_ganssReferenceMeasurementInfo),
        ('ganssDataBits', _GanssReqGenericData_ganssDataBits),
        ('ganssUTCModel', _GanssReqGenericData_ganssUTCModel),
        ('ganssNavigationModelAdditionalData', _GanssReqGenericData_ganssNavigationModelAdditionalData),
        ('iE-Extensions', _GanssReqGenericData_iE_Extensions),
        ])
    GanssReqGenericData._ext = []
    
    #-----< GanssReqGenericData-ExtIEs >-----#
    GanssReqGenericData_ExtIEs = CLASS(name='GanssReqGenericData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GanssReqGenericData_ExtIEs_val_Extension_0 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddNavigationModel-Req')))
    _GanssReqGenericData_ExtIEs_val_Extension_1 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddUTCModel-Req')))
    _GanssReqGenericData_ExtIEs_val_Extension_2 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AuxInfo-req')))
    _GanssReqGenericData_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SBAS-ID')))
    _GanssReqGenericData_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddADchoices')))
    _GanssReqGenericData_ExtIEs_val_Extension_5 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'BDSIonosphericGridModel')))
    _GanssReqGenericData_ExtIEs_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'DBDSCorrection')))
    GanssReqGenericData_ExtIEs._val = ASN1Set(rv=[dict([('id', 105), ('criticality', 'ignore'), ('Extension', _GanssReqGenericData_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 106), ('criticality', 'ignore'), ('Extension', _GanssReqGenericData_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Extension', _GanssReqGenericData_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 94), ('criticality', 'ignore'), ('Extension', _GanssReqGenericData_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 116), ('criticality', 'ignore'), ('Extension', _GanssReqGenericData_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 133), ('criticality', 'ignore'), ('Extension', _GanssReqGenericData_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 134), ('criticality', 'ignore'), ('Extension', _GanssReqGenericData_ExtIEs_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< BDSIonosphericGridModel >-----#
    BDSIonosphericGridModel = BOOL(name='BDSIonosphericGridModel', mode=MODE_TYPE)
    
    #-----< DBDSCorrection >-----#
    DBDSCorrection = SEQ(name='DBDSCorrection', mode=MODE_TYPE)
    _DBDSCorrection_dGANSSSignalBDS = BIT_STR(name='dGANSSSignalBDS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDSCorrection_dGANSSSignalBDS._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DBDSCorrection_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDSCorrection_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DBDSCorrection_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DBDSCorrection_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DBDSCorrection_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDSCorrection_iE_Extensions__item__id._const_tab = ____DBDSCorrection_iE_Extensions__item__id_tab
    ___DBDSCorrection_iE_Extensions__item__id._const_tab_at = None
    ___DBDSCorrection_iE_Extensions__item__id._const_tab_id = 'id'
    ___DBDSCorrection_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DBDSCorrection_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DBDSCorrection_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDSCorrection_iE_Extensions__item__criticality._const_tab = ____DBDSCorrection_iE_Extensions__item__criticality_tab
    ___DBDSCorrection_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DBDSCorrection_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DBDSCorrection_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DBDSCorrection_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DBDSCorrection_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDSCorrection_iE_Extensions__item__extensionValue._const_tab = ____DBDSCorrection_iE_Extensions__item__extensionValue_tab
    ___DBDSCorrection_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DBDSCorrection_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DBDSCorrection_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DBDSCorrection_iE_Extensions__item__id),
        ('criticality', ___DBDSCorrection_iE_Extensions__item__criticality),
        ('extensionValue', ___DBDSCorrection_iE_Extensions__item__extensionValue),
        ])
    __DBDSCorrection_iE_Extensions__item_._ext = None
    _DBDSCorrection_iE_Extensions._cont = __DBDSCorrection_iE_Extensions__item_
    _DBDSCorrection_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDSCorrection._cont = ASN1Dict([
        ('dGANSSSignalBDS', _DBDSCorrection_dGANSSSignalBDS),
        ('iE-Extensions', _DBDSCorrection_iE_Extensions),
        ])
    DBDSCorrection._ext = []
    
    #-----< DBDSCorrection-ExtIEs >-----#
    DBDSCorrection_ExtIEs = CLASS(name='DBDSCorrection-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DBDSCorrection_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-AddNavigationModel-Req >-----#
    GANSS_AddNavigationModel_Req = BOOL(name='GANSS-AddNavigationModel-Req', mode=MODE_TYPE)
    
    #-----< GANSS-AddUTCModel-Req >-----#
    GANSS_AddUTCModel_Req = BOOL(name='GANSS-AddUTCModel-Req', mode=MODE_TYPE)
    
    #-----< GANSS-AuxInfo-req >-----#
    GANSS_AuxInfo_req = BOOL(name='GANSS-AuxInfo-req', mode=MODE_TYPE)
    
    #-----< GANSS-AddADchoices >-----#
    GANSS_AddADchoices = SEQ(name='GANSS-AddADchoices', mode=MODE_TYPE)
    _GANSS_AddADchoices_orbitModelID = INT(name='orbitModelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_AddADchoices_orbitModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _GANSS_AddADchoices_clockModelID = INT(name='clockModelID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_AddADchoices_clockModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _GANSS_AddADchoices_utcModelID = INT(name='utcModelID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_AddADchoices_utcModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _GANSS_AddADchoices_almanacModelID = INT(name='almanacModelID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSS_AddADchoices_almanacModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _GANSS_AddADchoices_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_AddADchoices_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_AddADchoices_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_AddADchoices_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AddADchoices_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AddADchoices_iE_Extensions__item__id._const_tab = ____GANSS_AddADchoices_iE_Extensions__item__id_tab
    ___GANSS_AddADchoices_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_AddADchoices_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_AddADchoices_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_AddADchoices_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AddADchoices_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AddADchoices_iE_Extensions__item__criticality._const_tab = ____GANSS_AddADchoices_iE_Extensions__item__criticality_tab
    ___GANSS_AddADchoices_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_AddADchoices_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_AddADchoices_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_AddADchoices_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AddADchoices_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AddADchoices_iE_Extensions__item__extensionValue._const_tab = ____GANSS_AddADchoices_iE_Extensions__item__extensionValue_tab
    ___GANSS_AddADchoices_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_AddADchoices_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_AddADchoices_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_AddADchoices_iE_Extensions__item__id),
        ('criticality', ___GANSS_AddADchoices_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_AddADchoices_iE_Extensions__item__extensionValue),
        ])
    __GANSS_AddADchoices_iE_Extensions__item_._ext = None
    _GANSS_AddADchoices_iE_Extensions._cont = __GANSS_AddADchoices_iE_Extensions__item_
    _GANSS_AddADchoices_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_AddADchoices._cont = ASN1Dict([
        ('orbitModelID', _GANSS_AddADchoices_orbitModelID),
        ('clockModelID', _GANSS_AddADchoices_clockModelID),
        ('utcModelID', _GANSS_AddADchoices_utcModelID),
        ('almanacModelID', _GANSS_AddADchoices_almanacModelID),
        ('iE-Extensions', _GANSS_AddADchoices_iE_Extensions),
        ])
    GANSS_AddADchoices._ext = []
    
    #-----< GANSS-AddADchoices-ExtIEs >-----#
    GANSS_AddADchoices_ExtIEs = CLASS(name='GANSS-AddADchoices-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_AddADchoices_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DGANSS-Sig-Id-Req >-----#
    DGANSS_Sig_Id_Req = BIT_STR(name='DGANSS-Sig-Id-Req', mode=MODE_TYPE)
    DGANSS_Sig_Id_Req._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< GanssDataBits >-----#
    GanssDataBits = SEQ(name='GanssDataBits', mode=MODE_TYPE)
    _GanssDataBits_ganssTod = INT(name='ganssTod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssDataBits_ganssTod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=None, er=[])
    _GanssDataBits_dataBitAssistancelist = SEQ(name='dataBitAssistancelist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'ReqDataBitAssistanceList')))
    _GanssDataBits_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GanssDataBits_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GanssDataBits_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GanssDataBits_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GanssDataBits_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GanssDataBits_iE_Extensions__item__id._const_tab = ____GanssDataBits_iE_Extensions__item__id_tab
    ___GanssDataBits_iE_Extensions__item__id._const_tab_at = None
    ___GanssDataBits_iE_Extensions__item__id._const_tab_id = 'id'
    ___GanssDataBits_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GanssDataBits_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GanssDataBits_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GanssDataBits_iE_Extensions__item__criticality._const_tab = ____GanssDataBits_iE_Extensions__item__criticality_tab
    ___GanssDataBits_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GanssDataBits_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GanssDataBits_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GanssDataBits_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GanssDataBits_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GanssDataBits_iE_Extensions__item__extensionValue._const_tab = ____GanssDataBits_iE_Extensions__item__extensionValue_tab
    ___GanssDataBits_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GanssDataBits_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GanssDataBits_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GanssDataBits_iE_Extensions__item__id),
        ('criticality', ___GanssDataBits_iE_Extensions__item__criticality),
        ('extensionValue', ___GanssDataBits_iE_Extensions__item__extensionValue),
        ])
    __GanssDataBits_iE_Extensions__item_._ext = None
    _GanssDataBits_iE_Extensions._cont = __GanssDataBits_iE_Extensions__item_
    _GanssDataBits_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GanssDataBits._cont = ASN1Dict([
        ('ganssTod', _GanssDataBits_ganssTod),
        ('dataBitAssistancelist', _GanssDataBits_dataBitAssistancelist),
        ('iE-Extensions', _GanssDataBits_iE_Extensions),
        ])
    GanssDataBits._ext = []
    
    #-----< GanssDataBits-ExtIEs >-----#
    GanssDataBits_ExtIEs = CLASS(name='GanssDataBits-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GanssDataBits_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReqDataBitAssistanceList >-----#
    ReqDataBitAssistanceList = SEQ(name='ReqDataBitAssistanceList', mode=MODE_TYPE)
    _ReqDataBitAssistanceList_ganssSignalID = BIT_STR(name='ganssSignalID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReqDataBitAssistanceList_ganssSignalID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _ReqDataBitAssistanceList_ganssDataBitInterval = INT(name='ganssDataBitInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReqDataBitAssistanceList_ganssDataBitInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _ReqDataBitAssistanceList_ganssSatelliteInfo = SEQ_OF(name='ganssSatelliteInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ReqDataBitAssistanceList_ganssSatelliteInfo__item_ = INT(name='_item_', mode=MODE_TYPE)
    __ReqDataBitAssistanceList_ganssSatelliteInfo__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _ReqDataBitAssistanceList_ganssSatelliteInfo._cont = __ReqDataBitAssistanceList_ganssSatelliteInfo__item_
    _ReqDataBitAssistanceList_ganssSatelliteInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _ReqDataBitAssistanceList_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ReqDataBitAssistanceList_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___ReqDataBitAssistanceList_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____ReqDataBitAssistanceList_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ReqDataBitAssistanceList_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReqDataBitAssistanceList_iE_Extensions__item__id._const_tab = ____ReqDataBitAssistanceList_iE_Extensions__item__id_tab
    ___ReqDataBitAssistanceList_iE_Extensions__item__id._const_tab_at = None
    ___ReqDataBitAssistanceList_iE_Extensions__item__id._const_tab_id = 'id'
    ___ReqDataBitAssistanceList_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ReqDataBitAssistanceList_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ReqDataBitAssistanceList_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReqDataBitAssistanceList_iE_Extensions__item__criticality._const_tab = ____ReqDataBitAssistanceList_iE_Extensions__item__criticality_tab
    ___ReqDataBitAssistanceList_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ReqDataBitAssistanceList_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ReqDataBitAssistanceList_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ReqDataBitAssistanceList_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ReqDataBitAssistanceList_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ReqDataBitAssistanceList_iE_Extensions__item__extensionValue._const_tab = ____ReqDataBitAssistanceList_iE_Extensions__item__extensionValue_tab
    ___ReqDataBitAssistanceList_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ReqDataBitAssistanceList_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ReqDataBitAssistanceList_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ReqDataBitAssistanceList_iE_Extensions__item__id),
        ('criticality', ___ReqDataBitAssistanceList_iE_Extensions__item__criticality),
        ('extensionValue', ___ReqDataBitAssistanceList_iE_Extensions__item__extensionValue),
        ])
    __ReqDataBitAssistanceList_iE_Extensions__item_._ext = None
    _ReqDataBitAssistanceList_iE_Extensions._cont = __ReqDataBitAssistanceList_iE_Extensions__item_
    _ReqDataBitAssistanceList_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ReqDataBitAssistanceList._cont = ASN1Dict([
        ('ganssSignalID', _ReqDataBitAssistanceList_ganssSignalID),
        ('ganssDataBitInterval', _ReqDataBitAssistanceList_ganssDataBitInterval),
        ('ganssSatelliteInfo', _ReqDataBitAssistanceList_ganssSatelliteInfo),
        ('iE-Extensions', _ReqDataBitAssistanceList_iE_Extensions),
        ])
    ReqDataBitAssistanceList._ext = []
    
    #-----< ReqDataBitAssistanceList-ExtIEs >-----#
    ReqDataBitAssistanceList_ExtIEs = CLASS(name='ReqDataBitAssistanceList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ReqDataBitAssistanceList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeID >-----#
    InformationExchangeID = INT(name='InformationExchangeID', mode=MODE_TYPE)
    InformationExchangeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< InformationReportCharacteristics >-----#
    InformationReportCharacteristics = SEQ(name='InformationReportCharacteristics', mode=MODE_TYPE)
    _InformationReportCharacteristics_type = ENUM(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'InformationReportCharacteristicsType')))
    _InformationReportCharacteristics_periodicity = CHOICE(name='periodicity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'InformationReportPeriodicity')), opt=True)
    InformationReportCharacteristics._cont = ASN1Dict([
        ('type', _InformationReportCharacteristics_type),
        ('periodicity', _InformationReportCharacteristics_periodicity),
        ])
    InformationReportCharacteristics._ext = []
    
    #-----< InformationReportCharacteristicsType >-----#
    InformationReportCharacteristicsType = ENUM(name='InformationReportCharacteristicsType', mode=MODE_TYPE)
    InformationReportCharacteristicsType._cont = ASN1Dict([('onDemand', 0), ('periodic', 1), ('onModification', 2)])
    InformationReportCharacteristicsType._ext = []
    
    #-----< InformationReportPeriodicity >-----#
    InformationReportPeriodicity = CHOICE(name='InformationReportPeriodicity', mode=MODE_TYPE)
    _InformationReportPeriodicity_min = INT(name='min', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InformationReportPeriodicity_min._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60)], ev=[], er=[])
    _InformationReportPeriodicity_hour = INT(name='hour', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InformationReportPeriodicity_hour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=[], er=[])
    InformationReportPeriodicity._cont = ASN1Dict([
        ('min', _InformationReportPeriodicity_min),
        ('hour', _InformationReportPeriodicity_hour),
        ])
    InformationReportPeriodicity._ext = []
    
    #-----< InformationType >-----#
    InformationType = CHOICE(name='InformationType', mode=MODE_TYPE)
    _InformationType_implicitInformation = ENUM(name='implicitInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MethodType')))
    _InformationType_explicitInformation = SEQ_OF(name='explicitInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'ExplicitInformationList')))
    InformationType._cont = ASN1Dict([
        ('implicitInformation', _InformationType_implicitInformation),
        ('explicitInformation', _InformationType_explicitInformation),
        ])
    InformationType._ext = []
    
    #-----< ExplicitInformationList >-----#
    ExplicitInformationList = SEQ_OF(name='ExplicitInformationList', mode=MODE_TYPE)
    _ExplicitInformationList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExplicitInformation')))
    ExplicitInformationList._cont = _ExplicitInformationList__item_
    ExplicitInformationList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< ExplicitInformation >-----#
    ExplicitInformation = CHOICE(name='ExplicitInformation', mode=MODE_TYPE)
    _ExplicitInformation_almanacAndSatelliteHealth = NULL(name='almanacAndSatelliteHealth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AlmanacAndSatelliteHealth')))
    _ExplicitInformation_utcModel = SEQ(name='utcModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UtcModel')))
    _ExplicitInformation_ionosphericModel = SEQ(name='ionosphericModel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'IonosphericModel')))
    _ExplicitInformation_navigationModel = SEQ(name='navigationModel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NavigationModel')))
    _ExplicitInformation_dgpsCorrections = NULL(name='dgpsCorrections', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DgpsCorrections')))
    _ExplicitInformation_referenceTime = NULL(name='referenceTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'ReferenceTime')))
    _ExplicitInformation_acquisitionAssistance = NULL(name='acquisitionAssistance', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AcquisitionAssistance')))
    _ExplicitInformation_realTimeIntegrity = NULL(name='realTimeIntegrity', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RealTimeIntegrity')))
    _ExplicitInformation_almanacAndSatelliteHealthSIB = SEQ(name='almanacAndSatelliteHealthSIB', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AlmanacAndSatelliteHealthSIB-InfoType')))
    _ExplicitInformation_referenceLocation = NULL(name='referenceLocation', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'ReferenceLocation')))
    _ExplicitInformation_ganss_Common_DataReq = SEQ(name='ganss-Common-DataReq', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSCommonDataReq')))
    _ExplicitInformation_ganss_Generic_DataList = SEQ_OF(name='ganss-Generic-DataList', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSGenericDataList')))
    ExplicitInformation._cont = ASN1Dict([
        ('almanacAndSatelliteHealth', _ExplicitInformation_almanacAndSatelliteHealth),
        ('utcModel', _ExplicitInformation_utcModel),
        ('ionosphericModel', _ExplicitInformation_ionosphericModel),
        ('navigationModel', _ExplicitInformation_navigationModel),
        ('dgpsCorrections', _ExplicitInformation_dgpsCorrections),
        ('referenceTime', _ExplicitInformation_referenceTime),
        ('acquisitionAssistance', _ExplicitInformation_acquisitionAssistance),
        ('realTimeIntegrity', _ExplicitInformation_realTimeIntegrity),
        ('almanacAndSatelliteHealthSIB', _ExplicitInformation_almanacAndSatelliteHealthSIB),
        ('referenceLocation', _ExplicitInformation_referenceLocation),
        ('ganss-Common-DataReq', _ExplicitInformation_ganss_Common_DataReq),
        ('ganss-Generic-DataList', _ExplicitInformation_ganss_Generic_DataList),
        ])
    ExplicitInformation._ext = ['referenceLocation', 'ganss-Common-DataReq', 'ganss-Generic-DataList']
    
    #-----< DganssCorrectionsReq >-----#
    DganssCorrectionsReq = SEQ(name='DganssCorrectionsReq', mode=MODE_TYPE)
    _DganssCorrectionsReq_transmissionGanssTimeIndicator = ENUM(name='transmissionGanssTimeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionGanssTimeIndicator')), opt=True)
    _DganssCorrectionsReq_dganss_sig_id_req = BIT_STR(name='dganss-sig-id-req', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DGANSS-Sig-Id-Req')))
    _DganssCorrectionsReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DganssCorrectionsReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DganssCorrectionsReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DganssCorrectionsReq_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DganssCorrectionsReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DganssCorrectionsReq_iE_Extensions__item__id._const_tab = ____DganssCorrectionsReq_iE_Extensions__item__id_tab
    ___DganssCorrectionsReq_iE_Extensions__item__id._const_tab_at = None
    ___DganssCorrectionsReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___DganssCorrectionsReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DganssCorrectionsReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DganssCorrectionsReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DganssCorrectionsReq_iE_Extensions__item__criticality._const_tab = ____DganssCorrectionsReq_iE_Extensions__item__criticality_tab
    ___DganssCorrectionsReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DganssCorrectionsReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DganssCorrectionsReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DganssCorrectionsReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DganssCorrectionsReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DganssCorrectionsReq_iE_Extensions__item__extensionValue._const_tab = ____DganssCorrectionsReq_iE_Extensions__item__extensionValue_tab
    ___DganssCorrectionsReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DganssCorrectionsReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DganssCorrectionsReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DganssCorrectionsReq_iE_Extensions__item__id),
        ('criticality', ___DganssCorrectionsReq_iE_Extensions__item__criticality),
        ('extensionValue', ___DganssCorrectionsReq_iE_Extensions__item__extensionValue),
        ])
    __DganssCorrectionsReq_iE_Extensions__item_._ext = None
    _DganssCorrectionsReq_iE_Extensions._cont = __DganssCorrectionsReq_iE_Extensions__item_
    _DganssCorrectionsReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DganssCorrectionsReq._cont = ASN1Dict([
        ('transmissionGanssTimeIndicator', _DganssCorrectionsReq_transmissionGanssTimeIndicator),
        ('dganss-sig-id-req', _DganssCorrectionsReq_dganss_sig_id_req),
        ('iE-Extensions', _DganssCorrectionsReq_iE_Extensions),
        ])
    DganssCorrectionsReq._ext = []
    
    #-----< DganssCorrectionsReq-ExtIEs >-----#
    DganssCorrectionsReq_ExtIEs = CLASS(name='DganssCorrectionsReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DganssCorrectionsReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ganss-almanacAndSatelliteHealthReq >-----#
    Ganss_almanacAndSatelliteHealthReq = SEQ(name='Ganss-almanacAndSatelliteHealthReq', mode=MODE_TYPE)
    _Ganss_almanacAndSatelliteHealthReq_transmissionGanssTimeIndicator = ENUM(name='transmissionGanssTimeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionGanssTimeIndicator')), opt=True)
    _Ganss_almanacAndSatelliteHealthReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__id._const_tab = ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__id_tab
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__id._const_tab_at = None
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__criticality._const_tab = ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__criticality_tab
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__extensionValue._const_tab = ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__extensionValue_tab
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__id),
        ('criticality', ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__criticality),
        ('extensionValue', ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__extensionValue),
        ])
    __Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item_._ext = None
    _Ganss_almanacAndSatelliteHealthReq_iE_Extensions._cont = __Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item_
    _Ganss_almanacAndSatelliteHealthReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ganss_almanacAndSatelliteHealthReq._cont = ASN1Dict([
        ('transmissionGanssTimeIndicator', _Ganss_almanacAndSatelliteHealthReq_transmissionGanssTimeIndicator),
        ('iE-Extensions', _Ganss_almanacAndSatelliteHealthReq_iE_Extensions),
        ])
    Ganss_almanacAndSatelliteHealthReq._ext = []
    
    #-----< Ganss-almanacAndSatelliteHealthReq-ExtIEs >-----#
    Ganss_almanacAndSatelliteHealthReq_ExtIEs = CLASS(name='Ganss-almanacAndSatelliteHealthReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Ganss_almanacAndSatelliteHealthReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSSCommonDataReq >-----#
    GANSSCommonDataReq = SEQ(name='GANSSCommonDataReq', mode=MODE_TYPE)
    _GANSSCommonDataReq_ganss_ReferenceTime = ENUM(name='ganss-ReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSSCommonDataReq_ganss_ReferenceTime._cont = ASN1Dict([('requested', 0), ('not-requested', 1)])
    _GANSSCommonDataReq_ganss_ReferenceTime._ext = None
    _GANSSCommonDataReq_ganss_IonosphericModel = ENUM(name='ganss-IonosphericModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSSCommonDataReq_ganss_IonosphericModel._cont = ASN1Dict([('requested', 0), ('not-requested', 1)])
    _GANSSCommonDataReq_ganss_IonosphericModel._ext = None
    _GANSSCommonDataReq_ganss_ReferenceLocation = ENUM(name='ganss-ReferenceLocation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSSCommonDataReq_ganss_ReferenceLocation._cont = ASN1Dict([('requested', 0), ('not-requested', 1)])
    _GANSSCommonDataReq_ganss_ReferenceLocation._ext = None
    _GANSSCommonDataReq_ie_Extensions = SEQ_OF(name='ie-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSSCommonDataReq_ie_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSSCommonDataReq_ie_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSSCommonDataReq_ie_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSSCommonDataReq_ie_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddIonoModelReq')))
    _____GANSSCommonDataReq_ie_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-EarthOrientParaReq')))
    ____GANSSCommonDataReq_ie_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 86), ('criticality', 'ignore'), ('Extension', _____GANSSCommonDataReq_ie_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 87), ('criticality', 'ignore'), ('Extension', _____GANSSCommonDataReq_ie_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSSCommonDataReq_ie_Extensions__item__id._const_tab = ____GANSSCommonDataReq_ie_Extensions__item__id_tab
    ___GANSSCommonDataReq_ie_Extensions__item__id._const_tab_at = None
    ___GANSSCommonDataReq_ie_Extensions__item__id._const_tab_id = 'id'
    ___GANSSCommonDataReq_ie_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSSCommonDataReq_ie_Extensions__item__criticality._const_tab = ____GANSSCommonDataReq_ie_Extensions__item__id_tab
    ___GANSSCommonDataReq_ie_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSSCommonDataReq_ie_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSSCommonDataReq_ie_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSSCommonDataReq_ie_Extensions__item__extensionValue._const_tab = ____GANSSCommonDataReq_ie_Extensions__item__id_tab
    ___GANSSCommonDataReq_ie_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSSCommonDataReq_ie_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSSCommonDataReq_ie_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSSCommonDataReq_ie_Extensions__item__id),
        ('criticality', ___GANSSCommonDataReq_ie_Extensions__item__criticality),
        ('extensionValue', ___GANSSCommonDataReq_ie_Extensions__item__extensionValue),
        ])
    __GANSSCommonDataReq_ie_Extensions__item_._ext = None
    _GANSSCommonDataReq_ie_Extensions._cont = __GANSSCommonDataReq_ie_Extensions__item_
    _GANSSCommonDataReq_ie_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSSCommonDataReq._cont = ASN1Dict([
        ('ganss-ReferenceTime', _GANSSCommonDataReq_ganss_ReferenceTime),
        ('ganss-IonosphericModel', _GANSSCommonDataReq_ganss_IonosphericModel),
        ('ganss-ReferenceLocation', _GANSSCommonDataReq_ganss_ReferenceLocation),
        ('ie-Extensions', _GANSSCommonDataReq_ie_Extensions),
        ])
    GANSSCommonDataReq._ext = []
    
    #-----< GANSSCommonDataReq-ExtIEs >-----#
    GANSSCommonDataReq_ExtIEs = CLASS(name='GANSSCommonDataReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSSCommonDataReq_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddIonoModelReq')))
    _GANSSCommonDataReq_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-EarthOrientParaReq')))
    GANSSCommonDataReq_ExtIEs._val = ASN1Set(rv=[dict([('id', 86), ('criticality', 'ignore'), ('Extension', _GANSSCommonDataReq_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 87), ('criticality', 'ignore'), ('Extension', _GANSSCommonDataReq_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSS-AddIonoModelReq >-----#
    GANSS_AddIonoModelReq = SEQ(name='GANSS-AddIonoModelReq', mode=MODE_TYPE)
    _GANSS_AddIonoModelReq_dataID = BIT_STR(name='dataID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_AddIonoModelReq_dataID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _GANSS_AddIonoModelReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_AddIonoModelReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_AddIonoModelReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_AddIonoModelReq_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AddIonoModelReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AddIonoModelReq_iE_Extensions__item__id._const_tab = ____GANSS_AddIonoModelReq_iE_Extensions__item__id_tab
    ___GANSS_AddIonoModelReq_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_AddIonoModelReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_AddIonoModelReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_AddIonoModelReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AddIonoModelReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AddIonoModelReq_iE_Extensions__item__criticality._const_tab = ____GANSS_AddIonoModelReq_iE_Extensions__item__criticality_tab
    ___GANSS_AddIonoModelReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_AddIonoModelReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_AddIonoModelReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_AddIonoModelReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AddIonoModelReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AddIonoModelReq_iE_Extensions__item__extensionValue._const_tab = ____GANSS_AddIonoModelReq_iE_Extensions__item__extensionValue_tab
    ___GANSS_AddIonoModelReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_AddIonoModelReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_AddIonoModelReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_AddIonoModelReq_iE_Extensions__item__id),
        ('criticality', ___GANSS_AddIonoModelReq_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_AddIonoModelReq_iE_Extensions__item__extensionValue),
        ])
    __GANSS_AddIonoModelReq_iE_Extensions__item_._ext = None
    _GANSS_AddIonoModelReq_iE_Extensions._cont = __GANSS_AddIonoModelReq_iE_Extensions__item_
    _GANSS_AddIonoModelReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_AddIonoModelReq._cont = ASN1Dict([
        ('dataID', _GANSS_AddIonoModelReq_dataID),
        ('iE-Extensions', _GANSS_AddIonoModelReq_iE_Extensions),
        ])
    GANSS_AddIonoModelReq._ext = []
    
    #-----< GANSS-AddIonoModelReq-ExtIEs >-----#
    GANSS_AddIonoModelReq_ExtIEs = CLASS(name='GANSS-AddIonoModelReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_AddIonoModelReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-EarthOrientParaReq >-----#
    GANSS_EarthOrientParaReq = SEQ(name='GANSS-EarthOrientParaReq', mode=MODE_TYPE)
    _GANSS_EarthOrientParaReq_eopReq = ENUM(name='eopReq', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_EarthOrientParaReq_eopReq._cont = ASN1Dict([('requested', 0), ('not-requested', 1)])
    _GANSS_EarthOrientParaReq_eopReq._ext = None
    _GANSS_EarthOrientParaReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_EarthOrientParaReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_EarthOrientParaReq_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_EarthOrientParaReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__id._const_tab = ____GANSS_EarthOrientParaReq_iE_Extensions__item__id_tab
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_EarthOrientParaReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_EarthOrientParaReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__criticality._const_tab = ____GANSS_EarthOrientParaReq_iE_Extensions__item__criticality_tab
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_EarthOrientParaReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_EarthOrientParaReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__extensionValue._const_tab = ____GANSS_EarthOrientParaReq_iE_Extensions__item__extensionValue_tab
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_EarthOrientParaReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_EarthOrientParaReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_EarthOrientParaReq_iE_Extensions__item__id),
        ('criticality', ___GANSS_EarthOrientParaReq_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_EarthOrientParaReq_iE_Extensions__item__extensionValue),
        ])
    __GANSS_EarthOrientParaReq_iE_Extensions__item_._ext = None
    _GANSS_EarthOrientParaReq_iE_Extensions._cont = __GANSS_EarthOrientParaReq_iE_Extensions__item_
    _GANSS_EarthOrientParaReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_EarthOrientParaReq._cont = ASN1Dict([
        ('eopReq', _GANSS_EarthOrientParaReq_eopReq),
        ('iE-Extensions', _GANSS_EarthOrientParaReq_iE_Extensions),
        ])
    GANSS_EarthOrientParaReq._ext = []
    
    #-----< GANSS-EarthOrientParaReq-ExtIEs >-----#
    GANSS_EarthOrientParaReq_ExtIEs = CLASS(name='GANSS-EarthOrientParaReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_EarthOrientParaReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSSGenericDataList >-----#
    GANSSGenericDataList = SEQ_OF(name='GANSSGenericDataList', mode=MODE_TYPE)
    _GANSSGenericDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSSGenericDataReq')))
    GANSSGenericDataList._cont = _GANSSGenericDataList__item_
    GANSSGenericDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< GANSSGenericDataReq >-----#
    GANSSGenericDataReq = SEQ(name='GANSSGenericDataReq', mode=MODE_TYPE)
    _GANSSGenericDataReq_ganssID = SEQ(name='ganssID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    _GANSSGenericDataReq_ganss_realTimeIntegrity = SEQ(name='ganss-realTimeIntegrity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Ganss-realTimeIntegrityReq')), opt=True)
    _GANSSGenericDataReq_ganss_dataBitAssistance = SEQ(name='ganss-dataBitAssistance', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GanssDataBits')), opt=True)
    _GANSSGenericDataReq_dganssCorrections = SEQ(name='dganssCorrections', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DganssCorrectionsReq')), opt=True)
    _GANSSGenericDataReq_ganss_almanacAndSatelliteHealth = SEQ(name='ganss-almanacAndSatelliteHealth', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Ganss-almanacAndSatelliteHealthReq')), opt=True)
    _GANSSGenericDataReq_ganss_referenceMeasurementInfo = SEQ(name='ganss-referenceMeasurementInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Ganss-referenceMeasurementInfoReq')), opt=True)
    _GANSSGenericDataReq_ganss_utcModel = SEQ(name='ganss-utcModel', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Ganss-utcModelReq')), opt=True)
    _GANSSGenericDataReq_ganss_TimeModel_Gnss_Gnss = SEQ(name='ganss-TimeModel-Gnss-Gnss', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Ganss-TimeModel-Gnss-Gnss')), opt=True)
    _GANSSGenericDataReq_navigationModel = SEQ(name='navigationModel', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NavigationModelGANSS')), opt=True)
    _GANSSGenericDataReq_ganss_AddNavModelsReq = SEQ(name='ganss-AddNavModelsReq', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AddNavigationModelsGANSS')), opt=True)
    _GANSSGenericDataReq_ganss_AddUtcModelsReq = SEQ(name='ganss-AddUtcModelsReq', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AddUtcModelsReq')), opt=True)
    _GANSSGenericDataReq_ganss_AuxInfoReq = SEQ(name='ganss-AuxInfoReq', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-AuxInfoReq')), opt=True)
    _GANSSGenericDataReq_ganss_SBAS_ID = ENUM(name='ganss-SBAS-ID', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SBAS-ID')), opt=True)
    _GANSSGenericDataReq_dBDS_Corrections = SEQ(name='dBDS-Corrections', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DBDS-Corrections')), opt=True)
    _GANSSGenericDataReq_bDS_Ionospheric_Grid_Model_Request = ENUM(name='bDS-Ionospheric-Grid-Model-Request', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'BDS-Ionospheric-Grid-Model-Request')), opt=True)
    GANSSGenericDataReq._cont = ASN1Dict([
        ('ganssID', _GANSSGenericDataReq_ganssID),
        ('ganss-realTimeIntegrity', _GANSSGenericDataReq_ganss_realTimeIntegrity),
        ('ganss-dataBitAssistance', _GANSSGenericDataReq_ganss_dataBitAssistance),
        ('dganssCorrections', _GANSSGenericDataReq_dganssCorrections),
        ('ganss-almanacAndSatelliteHealth', _GANSSGenericDataReq_ganss_almanacAndSatelliteHealth),
        ('ganss-referenceMeasurementInfo', _GANSSGenericDataReq_ganss_referenceMeasurementInfo),
        ('ganss-utcModel', _GANSSGenericDataReq_ganss_utcModel),
        ('ganss-TimeModel-Gnss-Gnss', _GANSSGenericDataReq_ganss_TimeModel_Gnss_Gnss),
        ('navigationModel', _GANSSGenericDataReq_navigationModel),
        ('ganss-AddNavModelsReq', _GANSSGenericDataReq_ganss_AddNavModelsReq),
        ('ganss-AddUtcModelsReq', _GANSSGenericDataReq_ganss_AddUtcModelsReq),
        ('ganss-AuxInfoReq', _GANSSGenericDataReq_ganss_AuxInfoReq),
        ('ganss-SBAS-ID', _GANSSGenericDataReq_ganss_SBAS_ID),
        ('dBDS-Corrections', _GANSSGenericDataReq_dBDS_Corrections),
        ('bDS-Ionospheric-Grid-Model-Request', _GANSSGenericDataReq_bDS_Ionospheric_Grid_Model_Request),
        ])
    GANSSGenericDataReq._ext = ['ganss-AddNavModelsReq', 'ganss-AddUtcModelsReq', 'ganss-AuxInfoReq', 'ganss-SBAS-ID', 'dBDS-Corrections', 'bDS-Ionospheric-Grid-Model-Request']
    
    #-----< AddNavigationModelsGANSS >-----#
    AddNavigationModelsGANSS = SEQ(name='AddNavigationModelsGANSS', mode=MODE_TYPE)
    _AddNavigationModelsGANSS_ganssWeek = INT(name='ganssWeek', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AddNavigationModelsGANSS_ganssWeek._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _AddNavigationModelsGANSS_ganssTOE = INT(name='ganssTOE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AddNavigationModelsGANSS_ganssTOE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=167)], ev=None, er=[])
    _AddNavigationModelsGANSS_t_toe_limit = INT(name='t-toe-limit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AddNavigationModelsGANSS_t_toe_limit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    _AddNavigationModelsGANSS_addSatRelatedDataListGANSS = SEQ_OF(name='addSatRelatedDataListGANSS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AddSatelliteRelatedDataListGANSS')))
    _AddNavigationModelsGANSS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AddNavigationModelsGANSS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AddNavigationModelsGANSS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AddNavigationModelsGANSS_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AddNavigationModelsGANSS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddNavigationModelsGANSS_iE_Extensions__item__id._const_tab = ____AddNavigationModelsGANSS_iE_Extensions__item__id_tab
    ___AddNavigationModelsGANSS_iE_Extensions__item__id._const_tab_at = None
    ___AddNavigationModelsGANSS_iE_Extensions__item__id._const_tab_id = 'id'
    ___AddNavigationModelsGANSS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AddNavigationModelsGANSS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AddNavigationModelsGANSS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddNavigationModelsGANSS_iE_Extensions__item__criticality._const_tab = ____AddNavigationModelsGANSS_iE_Extensions__item__criticality_tab
    ___AddNavigationModelsGANSS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AddNavigationModelsGANSS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AddNavigationModelsGANSS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AddNavigationModelsGANSS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AddNavigationModelsGANSS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddNavigationModelsGANSS_iE_Extensions__item__extensionValue._const_tab = ____AddNavigationModelsGANSS_iE_Extensions__item__extensionValue_tab
    ___AddNavigationModelsGANSS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AddNavigationModelsGANSS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AddNavigationModelsGANSS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AddNavigationModelsGANSS_iE_Extensions__item__id),
        ('criticality', ___AddNavigationModelsGANSS_iE_Extensions__item__criticality),
        ('extensionValue', ___AddNavigationModelsGANSS_iE_Extensions__item__extensionValue),
        ])
    __AddNavigationModelsGANSS_iE_Extensions__item_._ext = None
    _AddNavigationModelsGANSS_iE_Extensions._cont = __AddNavigationModelsGANSS_iE_Extensions__item_
    _AddNavigationModelsGANSS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AddNavigationModelsGANSS._cont = ASN1Dict([
        ('ganssWeek', _AddNavigationModelsGANSS_ganssWeek),
        ('ganssTOE', _AddNavigationModelsGANSS_ganssTOE),
        ('t-toe-limit', _AddNavigationModelsGANSS_t_toe_limit),
        ('addSatRelatedDataListGANSS', _AddNavigationModelsGANSS_addSatRelatedDataListGANSS),
        ('iE-Extensions', _AddNavigationModelsGANSS_iE_Extensions),
        ])
    AddNavigationModelsGANSS._ext = []
    
    #-----< AddNavigationModelsGANSS-ExtIEs >-----#
    AddNavigationModelsGANSS_ExtIEs = CLASS(name='AddNavigationModelsGANSS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AddNavigationModelsGANSS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AddSatelliteRelatedDataListGANSS >-----#
    AddSatelliteRelatedDataListGANSS = SEQ_OF(name='AddSatelliteRelatedDataListGANSS', mode=MODE_TYPE)
    _AddSatelliteRelatedDataListGANSS__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddSatelliteRelatedDataGANSS')))
    AddSatelliteRelatedDataListGANSS._cont = _AddSatelliteRelatedDataListGANSS__item_
    AddSatelliteRelatedDataListGANSS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< AddSatelliteRelatedDataGANSS >-----#
    AddSatelliteRelatedDataGANSS = SEQ(name='AddSatelliteRelatedDataGANSS', mode=MODE_TYPE)
    _AddSatelliteRelatedDataGANSS_satID = INT(name='satID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AddSatelliteRelatedDataGANSS_satID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _AddSatelliteRelatedDataGANSS_iod = BIT_STR(name='iod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AddSatelliteRelatedDataGANSS_iod._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _AddSatelliteRelatedDataGANSS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AddSatelliteRelatedDataGANSS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__id._const_tab = ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__id_tab
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__id._const_tab_at = None
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__id._const_tab_id = 'id'
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__criticality._const_tab = ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__criticality_tab
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue._const_tab = ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue_tab
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AddSatelliteRelatedDataGANSS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__id),
        ('criticality', ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__criticality),
        ('extensionValue', ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue),
        ])
    __AddSatelliteRelatedDataGANSS_iE_Extensions__item_._ext = None
    _AddSatelliteRelatedDataGANSS_iE_Extensions._cont = __AddSatelliteRelatedDataGANSS_iE_Extensions__item_
    _AddSatelliteRelatedDataGANSS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AddSatelliteRelatedDataGANSS._cont = ASN1Dict([
        ('satID', _AddSatelliteRelatedDataGANSS_satID),
        ('iod', _AddSatelliteRelatedDataGANSS_iod),
        ('iE-Extensions', _AddSatelliteRelatedDataGANSS_iE_Extensions),
        ])
    AddSatelliteRelatedDataGANSS._ext = []
    
    #-----< AddSatelliteRelatedDataGANSS-ExtIEs >-----#
    AddSatelliteRelatedDataGANSS_ExtIEs = CLASS(name='AddSatelliteRelatedDataGANSS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AddSatelliteRelatedDataGANSS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< BDS-Ionospheric-Grid-Model-Request >-----#
    BDS_Ionospheric_Grid_Model_Request = ENUM(name='BDS-Ionospheric-Grid-Model-Request', mode=MODE_TYPE)
    BDS_Ionospheric_Grid_Model_Request._cont = ASN1Dict([('requested', 0)])
    BDS_Ionospheric_Grid_Model_Request._ext = []
    
    #-----< DBDS-Corrections >-----#
    DBDS_Corrections = SEQ(name='DBDS-Corrections', mode=MODE_TYPE)
    _DBDS_Corrections_transmissionGanssTimeIndicator = ENUM(name='transmissionGanssTimeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionGanssTimeIndicator')), opt=True)
    _DBDS_Corrections_dGANSS_Signal = BIT_STR(name='dGANSS-Signal', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _DBDS_Corrections_dGANSS_Signal._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _DBDS_Corrections_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DBDS_Corrections_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DBDS_Corrections_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DBDS_Corrections_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DBDS_Corrections_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Corrections_iE_Extensions__item__id._const_tab = ____DBDS_Corrections_iE_Extensions__item__id_tab
    ___DBDS_Corrections_iE_Extensions__item__id._const_tab_at = None
    ___DBDS_Corrections_iE_Extensions__item__id._const_tab_id = 'id'
    ___DBDS_Corrections_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DBDS_Corrections_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DBDS_Corrections_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Corrections_iE_Extensions__item__criticality._const_tab = ____DBDS_Corrections_iE_Extensions__item__criticality_tab
    ___DBDS_Corrections_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DBDS_Corrections_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DBDS_Corrections_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DBDS_Corrections_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DBDS_Corrections_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DBDS_Corrections_iE_Extensions__item__extensionValue._const_tab = ____DBDS_Corrections_iE_Extensions__item__extensionValue_tab
    ___DBDS_Corrections_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DBDS_Corrections_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DBDS_Corrections_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DBDS_Corrections_iE_Extensions__item__id),
        ('criticality', ___DBDS_Corrections_iE_Extensions__item__criticality),
        ('extensionValue', ___DBDS_Corrections_iE_Extensions__item__extensionValue),
        ])
    __DBDS_Corrections_iE_Extensions__item_._ext = None
    _DBDS_Corrections_iE_Extensions._cont = __DBDS_Corrections_iE_Extensions__item_
    _DBDS_Corrections_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DBDS_Corrections._cont = ASN1Dict([
        ('transmissionGanssTimeIndicator', _DBDS_Corrections_transmissionGanssTimeIndicator),
        ('dGANSS-Signal', _DBDS_Corrections_dGANSS_Signal),
        ('iE-Extensions', _DBDS_Corrections_iE_Extensions),
        ])
    DBDS_Corrections._ext = []
    
    #-----< DBDS-Corrections-ExtIEs >-----#
    DBDS_Corrections_ExtIEs = CLASS(name='DBDS-Corrections-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DBDS_Corrections_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-AddUtcModelsReq >-----#
    GANSS_AddUtcModelsReq = SEQ(name='GANSS-AddUtcModelsReq', mode=MODE_TYPE)
    _GANSS_AddUtcModelsReq_transmissionGanssTimeIndicator = ENUM(name='transmissionGanssTimeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionGanssTimeIndicator')), opt=True)
    _GANSS_AddUtcModelsReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_AddUtcModelsReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_AddUtcModelsReq_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AddUtcModelsReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__id._const_tab = ____GANSS_AddUtcModelsReq_iE_Extensions__item__id_tab
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_AddUtcModelsReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AddUtcModelsReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__criticality._const_tab = ____GANSS_AddUtcModelsReq_iE_Extensions__item__criticality_tab
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_AddUtcModelsReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AddUtcModelsReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__extensionValue._const_tab = ____GANSS_AddUtcModelsReq_iE_Extensions__item__extensionValue_tab
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_AddUtcModelsReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_AddUtcModelsReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_AddUtcModelsReq_iE_Extensions__item__id),
        ('criticality', ___GANSS_AddUtcModelsReq_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_AddUtcModelsReq_iE_Extensions__item__extensionValue),
        ])
    __GANSS_AddUtcModelsReq_iE_Extensions__item_._ext = None
    _GANSS_AddUtcModelsReq_iE_Extensions._cont = __GANSS_AddUtcModelsReq_iE_Extensions__item_
    _GANSS_AddUtcModelsReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_AddUtcModelsReq._cont = ASN1Dict([
        ('transmissionGanssTimeIndicator', _GANSS_AddUtcModelsReq_transmissionGanssTimeIndicator),
        ('iE-Extensions', _GANSS_AddUtcModelsReq_iE_Extensions),
        ])
    GANSS_AddUtcModelsReq._ext = []
    
    #-----< GANSS-AddUtcModelsReq-ExtIEs >-----#
    GANSS_AddUtcModelsReq_ExtIEs = CLASS(name='GANSS-AddUtcModelsReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_AddUtcModelsReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-AuxInfoReq >-----#
    GANSS_AuxInfoReq = SEQ(name='GANSS-AuxInfoReq', mode=MODE_TYPE)
    _GANSS_AuxInfoReq_transmissionGanssTimeIndicator = ENUM(name='transmissionGanssTimeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionGanssTimeIndicator')), opt=True)
    _GANSS_AuxInfoReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_AuxInfoReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_AuxInfoReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_AuxInfoReq_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AuxInfoReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AuxInfoReq_iE_Extensions__item__id._const_tab = ____GANSS_AuxInfoReq_iE_Extensions__item__id_tab
    ___GANSS_AuxInfoReq_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_AuxInfoReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_AuxInfoReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_AuxInfoReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AuxInfoReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AuxInfoReq_iE_Extensions__item__criticality._const_tab = ____GANSS_AuxInfoReq_iE_Extensions__item__criticality_tab
    ___GANSS_AuxInfoReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_AuxInfoReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_AuxInfoReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_AuxInfoReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_AuxInfoReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_AuxInfoReq_iE_Extensions__item__extensionValue._const_tab = ____GANSS_AuxInfoReq_iE_Extensions__item__extensionValue_tab
    ___GANSS_AuxInfoReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_AuxInfoReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_AuxInfoReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_AuxInfoReq_iE_Extensions__item__id),
        ('criticality', ___GANSS_AuxInfoReq_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_AuxInfoReq_iE_Extensions__item__extensionValue),
        ])
    __GANSS_AuxInfoReq_iE_Extensions__item_._ext = None
    _GANSS_AuxInfoReq_iE_Extensions._cont = __GANSS_AuxInfoReq_iE_Extensions__item_
    _GANSS_AuxInfoReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_AuxInfoReq._cont = ASN1Dict([
        ('transmissionGanssTimeIndicator', _GANSS_AuxInfoReq_transmissionGanssTimeIndicator),
        ('iE-Extensions', _GANSS_AuxInfoReq_iE_Extensions),
        ])
    GANSS_AuxInfoReq._ext = []
    
    #-----< GANSS-AuxInfoReq-ExtIEs >-----#
    GANSS_AuxInfoReq_ExtIEs = CLASS(name='GANSS-AuxInfoReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_AuxInfoReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-SBAS-ID >-----#
    GANSS_SBAS_ID = ENUM(name='GANSS-SBAS-ID', mode=MODE_TYPE)
    GANSS_SBAS_ID._cont = ASN1Dict([('waas', 0), ('egnos', 1), ('msas', 2), ('gagan', 3)])
    GANSS_SBAS_ID._ext = []
    
    #-----< Ganss-utcModelReq >-----#
    Ganss_utcModelReq = SEQ(name='Ganss-utcModelReq', mode=MODE_TYPE)
    _Ganss_utcModelReq_transmissionGanssTimeIndicator = ENUM(name='transmissionGanssTimeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionGanssTimeIndicator')), opt=True)
    _Ganss_utcModelReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ganss_utcModelReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Ganss_utcModelReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Ganss_utcModelReq_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_utcModelReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_utcModelReq_iE_Extensions__item__id._const_tab = ____Ganss_utcModelReq_iE_Extensions__item__id_tab
    ___Ganss_utcModelReq_iE_Extensions__item__id._const_tab_at = None
    ___Ganss_utcModelReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___Ganss_utcModelReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Ganss_utcModelReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_utcModelReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_utcModelReq_iE_Extensions__item__criticality._const_tab = ____Ganss_utcModelReq_iE_Extensions__item__criticality_tab
    ___Ganss_utcModelReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Ganss_utcModelReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Ganss_utcModelReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Ganss_utcModelReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_utcModelReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_utcModelReq_iE_Extensions__item__extensionValue._const_tab = ____Ganss_utcModelReq_iE_Extensions__item__extensionValue_tab
    ___Ganss_utcModelReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Ganss_utcModelReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Ganss_utcModelReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Ganss_utcModelReq_iE_Extensions__item__id),
        ('criticality', ___Ganss_utcModelReq_iE_Extensions__item__criticality),
        ('extensionValue', ___Ganss_utcModelReq_iE_Extensions__item__extensionValue),
        ])
    __Ganss_utcModelReq_iE_Extensions__item_._ext = None
    _Ganss_utcModelReq_iE_Extensions._cont = __Ganss_utcModelReq_iE_Extensions__item_
    _Ganss_utcModelReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ganss_utcModelReq._cont = ASN1Dict([
        ('transmissionGanssTimeIndicator', _Ganss_utcModelReq_transmissionGanssTimeIndicator),
        ('iE-Extensions', _Ganss_utcModelReq_iE_Extensions),
        ])
    Ganss_utcModelReq._ext = []
    
    #-----< Ganss-utcModelReq-ExtIEs >-----#
    Ganss_utcModelReq_ExtIEs = CLASS(name='Ganss-utcModelReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Ganss_utcModelReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ganss-realTimeIntegrityReq >-----#
    Ganss_realTimeIntegrityReq = SEQ(name='Ganss-realTimeIntegrityReq', mode=MODE_TYPE)
    _Ganss_realTimeIntegrityReq_transmissionGanssTimeIndicator = ENUM(name='transmissionGanssTimeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionGanssTimeIndicator')), opt=True)
    _Ganss_realTimeIntegrityReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ganss_realTimeIntegrityReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Ganss_realTimeIntegrityReq_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_realTimeIntegrityReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__id._const_tab = ____Ganss_realTimeIntegrityReq_iE_Extensions__item__id_tab
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__id._const_tab_at = None
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Ganss_realTimeIntegrityReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_realTimeIntegrityReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__criticality._const_tab = ____Ganss_realTimeIntegrityReq_iE_Extensions__item__criticality_tab
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Ganss_realTimeIntegrityReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_realTimeIntegrityReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__extensionValue._const_tab = ____Ganss_realTimeIntegrityReq_iE_Extensions__item__extensionValue_tab
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Ganss_realTimeIntegrityReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Ganss_realTimeIntegrityReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Ganss_realTimeIntegrityReq_iE_Extensions__item__id),
        ('criticality', ___Ganss_realTimeIntegrityReq_iE_Extensions__item__criticality),
        ('extensionValue', ___Ganss_realTimeIntegrityReq_iE_Extensions__item__extensionValue),
        ])
    __Ganss_realTimeIntegrityReq_iE_Extensions__item_._ext = None
    _Ganss_realTimeIntegrityReq_iE_Extensions._cont = __Ganss_realTimeIntegrityReq_iE_Extensions__item_
    _Ganss_realTimeIntegrityReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ganss_realTimeIntegrityReq._cont = ASN1Dict([
        ('transmissionGanssTimeIndicator', _Ganss_realTimeIntegrityReq_transmissionGanssTimeIndicator),
        ('iE-Extensions', _Ganss_realTimeIntegrityReq_iE_Extensions),
        ])
    Ganss_realTimeIntegrityReq._ext = []
    
    #-----< Ganss-realTimeIntegrityReq-ExtIEs >-----#
    Ganss_realTimeIntegrityReq_ExtIEs = CLASS(name='Ganss-realTimeIntegrityReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Ganss_realTimeIntegrityReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ganss-referenceMeasurementInfoReq >-----#
    Ganss_referenceMeasurementInfoReq = SEQ(name='Ganss-referenceMeasurementInfoReq', mode=MODE_TYPE)
    _Ganss_referenceMeasurementInfoReq_transmissionGanssTimeIndicator = ENUM(name='transmissionGanssTimeIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionGanssTimeIndicator')), opt=True)
    _Ganss_referenceMeasurementInfoReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ganss_referenceMeasurementInfoReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__id._const_tab = ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__id_tab
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__id._const_tab_at = None
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__criticality._const_tab = ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__criticality_tab
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__extensionValue._const_tab = ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__extensionValue_tab
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Ganss_referenceMeasurementInfoReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__id),
        ('criticality', ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__criticality),
        ('extensionValue', ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__extensionValue),
        ])
    __Ganss_referenceMeasurementInfoReq_iE_Extensions__item_._ext = None
    _Ganss_referenceMeasurementInfoReq_iE_Extensions._cont = __Ganss_referenceMeasurementInfoReq_iE_Extensions__item_
    _Ganss_referenceMeasurementInfoReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ganss_referenceMeasurementInfoReq._cont = ASN1Dict([
        ('transmissionGanssTimeIndicator', _Ganss_referenceMeasurementInfoReq_transmissionGanssTimeIndicator),
        ('iE-Extensions', _Ganss_referenceMeasurementInfoReq_iE_Extensions),
        ])
    Ganss_referenceMeasurementInfoReq._ext = []
    
    #-----< Ganss-referenceMeasurementInfoReq-ExtIEs >-----#
    Ganss_referenceMeasurementInfoReq_ExtIEs = CLASS(name='Ganss-referenceMeasurementInfoReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Ganss_referenceMeasurementInfoReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Ganss-TimeModel-Gnss-Gnss >-----#
    Ganss_TimeModel_Gnss_Gnss = SEQ(name='Ganss-TimeModel-Gnss-Gnss', mode=MODE_TYPE)
    _Ganss_TimeModel_Gnss_Gnss_ganssTimeModelGnssGnssExt = BIT_STR(name='ganssTimeModelGnssGnssExt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Ganss_TimeModel_Gnss_Gnss_ganssTimeModelGnssGnssExt._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _Ganss_TimeModel_Gnss_Gnss_transmissionGanssTimeIndicator = ENUM(name='transmissionGanssTimeIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionGanssTimeIndicator')), opt=True)
    _Ganss_TimeModel_Gnss_Gnss_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__id._const_tab = ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__id_tab
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__id._const_tab_at = None
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__id._const_tab_id = 'id'
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__criticality._const_tab = ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__criticality_tab
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__extensionValue._const_tab = ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__extensionValue_tab
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__id),
        ('criticality', ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__criticality),
        ('extensionValue', ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__extensionValue),
        ])
    __Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item_._ext = None
    _Ganss_TimeModel_Gnss_Gnss_iE_Extensions._cont = __Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item_
    _Ganss_TimeModel_Gnss_Gnss_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ganss_TimeModel_Gnss_Gnss._cont = ASN1Dict([
        ('ganssTimeModelGnssGnssExt', _Ganss_TimeModel_Gnss_Gnss_ganssTimeModelGnssGnssExt),
        ('transmissionGanssTimeIndicator', _Ganss_TimeModel_Gnss_Gnss_transmissionGanssTimeIndicator),
        ('iE-Extensions', _Ganss_TimeModel_Gnss_Gnss_iE_Extensions),
        ])
    Ganss_TimeModel_Gnss_Gnss._ext = []
    
    #-----< Ganss-TimeModel-Gnss-Gnss-ExtIEs >-----#
    Ganss_TimeModel_Gnss_Gnss_ExtIEs = CLASS(name='Ganss-TimeModel-Gnss-Gnss-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Ganss_TimeModel_Gnss_Gnss_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransmissionGanssTimeIndicator >-----#
    TransmissionGanssTimeIndicator = ENUM(name='TransmissionGanssTimeIndicator', mode=MODE_TYPE)
    TransmissionGanssTimeIndicator._cont = ASN1Dict([('requested', 0), ('not-Requested', 1)])
    TransmissionGanssTimeIndicator._ext = None
    
    #-----< AlmanacAndSatelliteHealth >-----#
    AlmanacAndSatelliteHealth = NULL(name='AlmanacAndSatelliteHealth', mode=MODE_TYPE)
    
    #-----< UtcModel >-----#
    UtcModel = SEQ(name='UtcModel', mode=MODE_TYPE)
    _UtcModel_transmissionTOWIndicator = ENUM(name='transmissionTOWIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionTOWIndicator')))
    _UtcModel_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UtcModel_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UtcModel_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UtcModel_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UtcModel_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UtcModel_iE_Extensions__item__id._const_tab = ____UtcModel_iE_Extensions__item__id_tab
    ___UtcModel_iE_Extensions__item__id._const_tab_at = None
    ___UtcModel_iE_Extensions__item__id._const_tab_id = 'id'
    ___UtcModel_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UtcModel_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UtcModel_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UtcModel_iE_Extensions__item__criticality._const_tab = ____UtcModel_iE_Extensions__item__criticality_tab
    ___UtcModel_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UtcModel_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UtcModel_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UtcModel_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UtcModel_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UtcModel_iE_Extensions__item__extensionValue._const_tab = ____UtcModel_iE_Extensions__item__extensionValue_tab
    ___UtcModel_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UtcModel_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UtcModel_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UtcModel_iE_Extensions__item__id),
        ('criticality', ___UtcModel_iE_Extensions__item__criticality),
        ('extensionValue', ___UtcModel_iE_Extensions__item__extensionValue),
        ])
    __UtcModel_iE_Extensions__item_._ext = None
    _UtcModel_iE_Extensions._cont = __UtcModel_iE_Extensions__item_
    _UtcModel_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UtcModel._cont = ASN1Dict([
        ('transmissionTOWIndicator', _UtcModel_transmissionTOWIndicator),
        ('iE-Extensions', _UtcModel_iE_Extensions),
        ])
    UtcModel._ext = []
    
    #-----< UtcModel-ExtIEs >-----#
    UtcModel_ExtIEs = CLASS(name='UtcModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UtcModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IonosphericModel >-----#
    IonosphericModel = SEQ(name='IonosphericModel', mode=MODE_TYPE)
    _IonosphericModel_transmissionTOWIndicator = ENUM(name='transmissionTOWIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionTOWIndicator')))
    _IonosphericModel_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IonosphericModel_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___IonosphericModel_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____IonosphericModel_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____IonosphericModel_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IonosphericModel_iE_Extensions__item__id._const_tab = ____IonosphericModel_iE_Extensions__item__id_tab
    ___IonosphericModel_iE_Extensions__item__id._const_tab_at = None
    ___IonosphericModel_iE_Extensions__item__id._const_tab_id = 'id'
    ___IonosphericModel_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IonosphericModel_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____IonosphericModel_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IonosphericModel_iE_Extensions__item__criticality._const_tab = ____IonosphericModel_iE_Extensions__item__criticality_tab
    ___IonosphericModel_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IonosphericModel_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IonosphericModel_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IonosphericModel_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____IonosphericModel_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IonosphericModel_iE_Extensions__item__extensionValue._const_tab = ____IonosphericModel_iE_Extensions__item__extensionValue_tab
    ___IonosphericModel_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IonosphericModel_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IonosphericModel_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IonosphericModel_iE_Extensions__item__id),
        ('criticality', ___IonosphericModel_iE_Extensions__item__criticality),
        ('extensionValue', ___IonosphericModel_iE_Extensions__item__extensionValue),
        ])
    __IonosphericModel_iE_Extensions__item_._ext = None
    _IonosphericModel_iE_Extensions._cont = __IonosphericModel_iE_Extensions__item_
    _IonosphericModel_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IonosphericModel._cont = ASN1Dict([
        ('transmissionTOWIndicator', _IonosphericModel_transmissionTOWIndicator),
        ('iE-Extensions', _IonosphericModel_iE_Extensions),
        ])
    IonosphericModel._ext = []
    
    #-----< IonosphericModel-ExtIEs >-----#
    IonosphericModel_ExtIEs = CLASS(name='IonosphericModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    IonosphericModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NavigationModel >-----#
    NavigationModel = SEQ(name='NavigationModel', mode=MODE_TYPE)
    _NavigationModel_transmissionTOWIndicator = ENUM(name='transmissionTOWIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionTOWIndicator')))
    _NavigationModel_navModelAdditionalData = SEQ(name='navModelAdditionalData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NavModelAdditionalData')), opt=True)
    _NavigationModel_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NavigationModel_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___NavigationModel_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____NavigationModel_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavigationModel_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavigationModel_iE_Extensions__item__id._const_tab = ____NavigationModel_iE_Extensions__item__id_tab
    ___NavigationModel_iE_Extensions__item__id._const_tab_at = None
    ___NavigationModel_iE_Extensions__item__id._const_tab_id = 'id'
    ___NavigationModel_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NavigationModel_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavigationModel_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavigationModel_iE_Extensions__item__criticality._const_tab = ____NavigationModel_iE_Extensions__item__criticality_tab
    ___NavigationModel_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NavigationModel_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NavigationModel_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NavigationModel_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavigationModel_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavigationModel_iE_Extensions__item__extensionValue._const_tab = ____NavigationModel_iE_Extensions__item__extensionValue_tab
    ___NavigationModel_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NavigationModel_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NavigationModel_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NavigationModel_iE_Extensions__item__id),
        ('criticality', ___NavigationModel_iE_Extensions__item__criticality),
        ('extensionValue', ___NavigationModel_iE_Extensions__item__extensionValue),
        ])
    __NavigationModel_iE_Extensions__item_._ext = None
    _NavigationModel_iE_Extensions._cont = __NavigationModel_iE_Extensions__item_
    _NavigationModel_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NavigationModel._cont = ASN1Dict([
        ('transmissionTOWIndicator', _NavigationModel_transmissionTOWIndicator),
        ('navModelAdditionalData', _NavigationModel_navModelAdditionalData),
        ('iE-Extensions', _NavigationModel_iE_Extensions),
        ])
    NavigationModel._ext = []
    
    #-----< NavigationModel-ExtIEs >-----#
    NavigationModel_ExtIEs = CLASS(name='NavigationModel-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    NavigationModel_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NavModelAdditionalData >-----#
    NavModelAdditionalData = SEQ(name='NavModelAdditionalData', mode=MODE_TYPE)
    _NavModelAdditionalData_gps_Week = INT(name='gps-Week', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelAdditionalData_gps_Week._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _NavModelAdditionalData_gps_TOE = INT(name='gps-TOE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelAdditionalData_gps_TOE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=167)], ev=None, er=[])
    _NavModelAdditionalData_t_TOE_limit = INT(name='t-TOE-limit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavModelAdditionalData_t_TOE_limit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    _NavModelAdditionalData_satRelatedDataList = SEQ_OF(name='satRelatedDataList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SatelliteRelatedDataList')))
    _NavModelAdditionalData_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NavModelAdditionalData_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___NavModelAdditionalData_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____NavModelAdditionalData_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModelAdditionalData_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModelAdditionalData_iE_Extensions__item__id._const_tab = ____NavModelAdditionalData_iE_Extensions__item__id_tab
    ___NavModelAdditionalData_iE_Extensions__item__id._const_tab_at = None
    ___NavModelAdditionalData_iE_Extensions__item__id._const_tab_id = 'id'
    ___NavModelAdditionalData_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NavModelAdditionalData_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModelAdditionalData_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModelAdditionalData_iE_Extensions__item__criticality._const_tab = ____NavModelAdditionalData_iE_Extensions__item__criticality_tab
    ___NavModelAdditionalData_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NavModelAdditionalData_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NavModelAdditionalData_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NavModelAdditionalData_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavModelAdditionalData_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavModelAdditionalData_iE_Extensions__item__extensionValue._const_tab = ____NavModelAdditionalData_iE_Extensions__item__extensionValue_tab
    ___NavModelAdditionalData_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NavModelAdditionalData_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NavModelAdditionalData_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NavModelAdditionalData_iE_Extensions__item__id),
        ('criticality', ___NavModelAdditionalData_iE_Extensions__item__criticality),
        ('extensionValue', ___NavModelAdditionalData_iE_Extensions__item__extensionValue),
        ])
    __NavModelAdditionalData_iE_Extensions__item_._ext = None
    _NavModelAdditionalData_iE_Extensions._cont = __NavModelAdditionalData_iE_Extensions__item_
    _NavModelAdditionalData_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NavModelAdditionalData._cont = ASN1Dict([
        ('gps-Week', _NavModelAdditionalData_gps_Week),
        ('gps-TOE', _NavModelAdditionalData_gps_TOE),
        ('t-TOE-limit', _NavModelAdditionalData_t_TOE_limit),
        ('satRelatedDataList', _NavModelAdditionalData_satRelatedDataList),
        ('iE-Extensions', _NavModelAdditionalData_iE_Extensions),
        ])
    NavModelAdditionalData._ext = []
    
    #-----< NavModelAdditionalData-ExtIEs >-----#
    NavModelAdditionalData_ExtIEs = CLASS(name='NavModelAdditionalData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    NavModelAdditionalData_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SatelliteRelatedDataList >-----#
    SatelliteRelatedDataList = SEQ_OF(name='SatelliteRelatedDataList', mode=MODE_TYPE)
    _SatelliteRelatedDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'SatelliteRelatedData')))
    SatelliteRelatedDataList._cont = _SatelliteRelatedDataList__item_
    SatelliteRelatedDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    
    #-----< SatelliteRelatedData >-----#
    SatelliteRelatedData = SEQ(name='SatelliteRelatedData', mode=MODE_TYPE)
    _SatelliteRelatedData_satID = INT(name='satID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SatelliteRelatedData_satID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SatelliteRelatedData_iode = INT(name='iode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SatelliteRelatedData_iode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _SatelliteRelatedData_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SatelliteRelatedData_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___SatelliteRelatedData_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____SatelliteRelatedData_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SatelliteRelatedData_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SatelliteRelatedData_iE_Extensions__item__id._const_tab = ____SatelliteRelatedData_iE_Extensions__item__id_tab
    ___SatelliteRelatedData_iE_Extensions__item__id._const_tab_at = None
    ___SatelliteRelatedData_iE_Extensions__item__id._const_tab_id = 'id'
    ___SatelliteRelatedData_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SatelliteRelatedData_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SatelliteRelatedData_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SatelliteRelatedData_iE_Extensions__item__criticality._const_tab = ____SatelliteRelatedData_iE_Extensions__item__criticality_tab
    ___SatelliteRelatedData_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SatelliteRelatedData_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SatelliteRelatedData_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SatelliteRelatedData_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SatelliteRelatedData_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SatelliteRelatedData_iE_Extensions__item__extensionValue._const_tab = ____SatelliteRelatedData_iE_Extensions__item__extensionValue_tab
    ___SatelliteRelatedData_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SatelliteRelatedData_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SatelliteRelatedData_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SatelliteRelatedData_iE_Extensions__item__id),
        ('criticality', ___SatelliteRelatedData_iE_Extensions__item__criticality),
        ('extensionValue', ___SatelliteRelatedData_iE_Extensions__item__extensionValue),
        ])
    __SatelliteRelatedData_iE_Extensions__item_._ext = None
    _SatelliteRelatedData_iE_Extensions._cont = __SatelliteRelatedData_iE_Extensions__item_
    _SatelliteRelatedData_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SatelliteRelatedData._cont = ASN1Dict([
        ('satID', _SatelliteRelatedData_satID),
        ('iode', _SatelliteRelatedData_iode),
        ('iE-Extensions', _SatelliteRelatedData_iE_Extensions),
        ])
    SatelliteRelatedData._ext = []
    
    #-----< SatelliteRelatedData-ExtIEs >-----#
    SatelliteRelatedData_ExtIEs = CLASS(name='SatelliteRelatedData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    SatelliteRelatedData_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< NavigationModelGANSS >-----#
    NavigationModelGANSS = SEQ(name='NavigationModelGANSS', mode=MODE_TYPE)
    _NavigationModelGANSS_ganssWeek = INT(name='ganssWeek', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavigationModelGANSS_ganssWeek._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _NavigationModelGANSS_ganssTOE = INT(name='ganssTOE', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavigationModelGANSS_ganssTOE._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=167)], ev=None, er=[])
    _NavigationModelGANSS_t_toe_limit = INT(name='t-toe-limit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavigationModelGANSS_t_toe_limit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    _NavigationModelGANSS_satRelatedDataListGANSS = SEQ_OF(name='satRelatedDataListGANSS', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SatelliteRelatedDataListGANSS')))
    _NavigationModelGANSS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NavigationModelGANSS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___NavigationModelGANSS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____NavigationModelGANSS_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavigationModelGANSS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavigationModelGANSS_iE_Extensions__item__id._const_tab = ____NavigationModelGANSS_iE_Extensions__item__id_tab
    ___NavigationModelGANSS_iE_Extensions__item__id._const_tab_at = None
    ___NavigationModelGANSS_iE_Extensions__item__id._const_tab_id = 'id'
    ___NavigationModelGANSS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NavigationModelGANSS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavigationModelGANSS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavigationModelGANSS_iE_Extensions__item__criticality._const_tab = ____NavigationModelGANSS_iE_Extensions__item__criticality_tab
    ___NavigationModelGANSS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NavigationModelGANSS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NavigationModelGANSS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NavigationModelGANSS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____NavigationModelGANSS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___NavigationModelGANSS_iE_Extensions__item__extensionValue._const_tab = ____NavigationModelGANSS_iE_Extensions__item__extensionValue_tab
    ___NavigationModelGANSS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NavigationModelGANSS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NavigationModelGANSS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NavigationModelGANSS_iE_Extensions__item__id),
        ('criticality', ___NavigationModelGANSS_iE_Extensions__item__criticality),
        ('extensionValue', ___NavigationModelGANSS_iE_Extensions__item__extensionValue),
        ])
    __NavigationModelGANSS_iE_Extensions__item_._ext = None
    _NavigationModelGANSS_iE_Extensions._cont = __NavigationModelGANSS_iE_Extensions__item_
    _NavigationModelGANSS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NavigationModelGANSS._cont = ASN1Dict([
        ('ganssWeek', _NavigationModelGANSS_ganssWeek),
        ('ganssTOE', _NavigationModelGANSS_ganssTOE),
        ('t-toe-limit', _NavigationModelGANSS_t_toe_limit),
        ('satRelatedDataListGANSS', _NavigationModelGANSS_satRelatedDataListGANSS),
        ('iE-Extensions', _NavigationModelGANSS_iE_Extensions),
        ])
    NavigationModelGANSS._ext = []
    
    #-----< NavigationModelGANSS-ExtIEs >-----#
    NavigationModelGANSS_ExtIEs = CLASS(name='NavigationModelGANSS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    NavigationModelGANSS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SatelliteRelatedDataListGANSS >-----#
    SatelliteRelatedDataListGANSS = SEQ_OF(name='SatelliteRelatedDataListGANSS', mode=MODE_TYPE)
    _SatelliteRelatedDataListGANSS__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'SatelliteRelatedDataGANSS')))
    SatelliteRelatedDataListGANSS._cont = _SatelliteRelatedDataListGANSS__item_
    SatelliteRelatedDataListGANSS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=64)], ev=None, er=[])
    
    #-----< SatelliteRelatedDataGANSS >-----#
    SatelliteRelatedDataGANSS = SEQ(name='SatelliteRelatedDataGANSS', mode=MODE_TYPE)
    _SatelliteRelatedDataGANSS_satID = INT(name='satID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SatelliteRelatedDataGANSS_satID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SatelliteRelatedDataGANSS_iod = BIT_STR(name='iod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SatelliteRelatedDataGANSS_iod._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _SatelliteRelatedDataGANSS_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SatelliteRelatedDataGANSS_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____SatelliteRelatedDataGANSS_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SatelliteRelatedDataGANSS_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__id._const_tab = ____SatelliteRelatedDataGANSS_iE_Extensions__item__id_tab
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__id._const_tab_at = None
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__id._const_tab_id = 'id'
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SatelliteRelatedDataGANSS_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SatelliteRelatedDataGANSS_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__criticality._const_tab = ____SatelliteRelatedDataGANSS_iE_Extensions__item__criticality_tab
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue._const_tab = ____SatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue_tab
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SatelliteRelatedDataGANSS_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SatelliteRelatedDataGANSS_iE_Extensions__item__id),
        ('criticality', ___SatelliteRelatedDataGANSS_iE_Extensions__item__criticality),
        ('extensionValue', ___SatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue),
        ])
    __SatelliteRelatedDataGANSS_iE_Extensions__item_._ext = None
    _SatelliteRelatedDataGANSS_iE_Extensions._cont = __SatelliteRelatedDataGANSS_iE_Extensions__item_
    _SatelliteRelatedDataGANSS_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SatelliteRelatedDataGANSS._cont = ASN1Dict([
        ('satID', _SatelliteRelatedDataGANSS_satID),
        ('iod', _SatelliteRelatedDataGANSS_iod),
        ('iE-Extensions', _SatelliteRelatedDataGANSS_iE_Extensions),
        ])
    SatelliteRelatedDataGANSS._ext = []
    
    #-----< SatelliteRelatedDataGANSS-ExtIEs >-----#
    SatelliteRelatedDataGANSS_ExtIEs = CLASS(name='SatelliteRelatedDataGANSS-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    SatelliteRelatedDataGANSS_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DgpsCorrections >-----#
    DgpsCorrections = NULL(name='DgpsCorrections', mode=MODE_TYPE)
    
    #-----< ReferenceTime >-----#
    ReferenceTime = NULL(name='ReferenceTime', mode=MODE_TYPE)
    
    #-----< AcquisitionAssistance >-----#
    AcquisitionAssistance = NULL(name='AcquisitionAssistance', mode=MODE_TYPE)
    
    #-----< RealTimeIntegrity >-----#
    RealTimeIntegrity = NULL(name='RealTimeIntegrity', mode=MODE_TYPE)
    
    #-----< AlmanacAndSatelliteHealthSIB-InfoType >-----#
    AlmanacAndSatelliteHealthSIB_InfoType = SEQ(name='AlmanacAndSatelliteHealthSIB-InfoType', mode=MODE_TYPE)
    _AlmanacAndSatelliteHealthSIB_InfoType_transmissionTOWIndicator = ENUM(name='transmissionTOWIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransmissionTOWIndicator')))
    _AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__id._const_tab = ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__id_tab
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__id._const_tab_at = None
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__id._const_tab_id = 'id'
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__criticality._const_tab = ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__criticality_tab
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__extensionValue._const_tab = ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__extensionValue_tab
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__id),
        ('criticality', ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__criticality),
        ('extensionValue', ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__extensionValue),
        ])
    __AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item_._ext = None
    _AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions._cont = __AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item_
    _AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AlmanacAndSatelliteHealthSIB_InfoType._cont = ASN1Dict([
        ('transmissionTOWIndicator', _AlmanacAndSatelliteHealthSIB_InfoType_transmissionTOWIndicator),
        ('iE-Extensions', _AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions),
        ])
    AlmanacAndSatelliteHealthSIB_InfoType._ext = []
    
    #-----< AlmanacAndSatelliteHealthSIB-InfoType-ExtIEs >-----#
    AlmanacAndSatelliteHealthSIB_InfoType_ExtIEs = CLASS(name='AlmanacAndSatelliteHealthSIB-InfoType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AlmanacAndSatelliteHealthSIB_InfoType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReferenceLocation >-----#
    ReferenceLocation = NULL(name='ReferenceLocation', mode=MODE_TYPE)
    
    #-----< TransmissionTOWIndicator >-----#
    TransmissionTOWIndicator = ENUM(name='TransmissionTOWIndicator', mode=MODE_TYPE)
    TransmissionTOWIndicator._cont = ASN1Dict([('requested', 0), ('not-Requested', 1)])
    TransmissionTOWIndicator._ext = None
    
    #-----< MessageStructure >-----#
    MessageStructure = SEQ_OF(name='MessageStructure', mode=MODE_TYPE)
    _MessageStructure__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __MessageStructure__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProtocolIE-ID')))
    __MessageStructure__item__repetitionNumber = INT(name='repetitionNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MessageStructureRepetition')), opt=True)
    __MessageStructure__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___MessageStructure__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____MessageStructure__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____MessageStructure__item__iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__id._const_tab = _____MessageStructure__item__iE_Extensions__item__id_tab
    ____MessageStructure__item__iE_Extensions__item__id._const_tab_at = None
    ____MessageStructure__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____MessageStructure__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____MessageStructure__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab = _____MessageStructure__item__iE_Extensions__item__criticality_tab
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____MessageStructure__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____MessageStructure__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab = _____MessageStructure__item__iE_Extensions__item__extensionValue_tab
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___MessageStructure__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____MessageStructure__item__iE_Extensions__item__id),
        ('criticality', ____MessageStructure__item__iE_Extensions__item__criticality),
        ('extensionValue', ____MessageStructure__item__iE_Extensions__item__extensionValue),
        ])
    ___MessageStructure__item__iE_Extensions__item_._ext = None
    __MessageStructure__item__iE_Extensions._cont = ___MessageStructure__item__iE_Extensions__item_
    __MessageStructure__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _MessageStructure__item_._cont = ASN1Dict([
        ('iE-ID', __MessageStructure__item__iE_ID),
        ('repetitionNumber', __MessageStructure__item__repetitionNumber),
        ('iE-Extensions', __MessageStructure__item__iE_Extensions),
        ])
    _MessageStructure__item_._ext = []
    MessageStructure._cont = _MessageStructure__item_
    MessageStructure._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MessageStructureRepetition >-----#
    MessageStructureRepetition = INT(name='MessageStructureRepetition', mode=MODE_TYPE)
    MessageStructureRepetition._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MessageStructure-ExtIEs >-----#
    MessageStructure_ExtIEs = CLASS(name='MessageStructure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    MessageStructure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasInstructionsUsed >-----#
    MeasInstructionsUsed = SEQ(name='MeasInstructionsUsed', mode=MODE_TYPE)
    _MeasInstructionsUsed_measurementValidity = SEQ(name='measurementValidity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MeasurementValidity')))
    _MeasInstructionsUsed_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasInstructionsUsed_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___MeasInstructionsUsed_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____MeasInstructionsUsed_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____MeasInstructionsUsed_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasInstructionsUsed_iE_Extensions__item__id._const_tab = ____MeasInstructionsUsed_iE_Extensions__item__id_tab
    ___MeasInstructionsUsed_iE_Extensions__item__id._const_tab_at = None
    ___MeasInstructionsUsed_iE_Extensions__item__id._const_tab_id = 'id'
    ___MeasInstructionsUsed_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MeasInstructionsUsed_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____MeasInstructionsUsed_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasInstructionsUsed_iE_Extensions__item__criticality._const_tab = ____MeasInstructionsUsed_iE_Extensions__item__criticality_tab
    ___MeasInstructionsUsed_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MeasInstructionsUsed_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MeasInstructionsUsed_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MeasInstructionsUsed_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____MeasInstructionsUsed_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasInstructionsUsed_iE_Extensions__item__extensionValue._const_tab = ____MeasInstructionsUsed_iE_Extensions__item__extensionValue_tab
    ___MeasInstructionsUsed_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MeasInstructionsUsed_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MeasInstructionsUsed_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MeasInstructionsUsed_iE_Extensions__item__id),
        ('criticality', ___MeasInstructionsUsed_iE_Extensions__item__criticality),
        ('extensionValue', ___MeasInstructionsUsed_iE_Extensions__item__extensionValue),
        ])
    __MeasInstructionsUsed_iE_Extensions__item_._ext = None
    _MeasInstructionsUsed_iE_Extensions._cont = __MeasInstructionsUsed_iE_Extensions__item_
    _MeasInstructionsUsed_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasInstructionsUsed._cont = ASN1Dict([
        ('measurementValidity', _MeasInstructionsUsed_measurementValidity),
        ('iE-Extensions', _MeasInstructionsUsed_iE_Extensions),
        ])
    MeasInstructionsUsed._ext = []
    
    #-----< MeasInstructionsUsed-ExtIEs >-----#
    MeasInstructionsUsed_ExtIEs = CLASS(name='MeasInstructionsUsed-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    MeasInstructionsUsed_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MeasurementValidity >-----#
    MeasurementValidity = SEQ(name='MeasurementValidity', mode=MODE_TYPE)
    _MeasurementValidity_ue_State = ENUM(name='ue-State', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _MeasurementValidity_ue_State._cont = ASN1Dict([('cell-DCH', 0), ('all-States-Except-Cell-DCH', 1), ('all-States', 2)])
    _MeasurementValidity_ue_State._ext = []
    _MeasurementValidity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MeasurementValidity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___MeasurementValidity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____MeasurementValidity_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____MeasurementValidity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementValidity_iE_Extensions__item__id._const_tab = ____MeasurementValidity_iE_Extensions__item__id_tab
    ___MeasurementValidity_iE_Extensions__item__id._const_tab_at = None
    ___MeasurementValidity_iE_Extensions__item__id._const_tab_id = 'id'
    ___MeasurementValidity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MeasurementValidity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____MeasurementValidity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementValidity_iE_Extensions__item__criticality._const_tab = ____MeasurementValidity_iE_Extensions__item__criticality_tab
    ___MeasurementValidity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MeasurementValidity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MeasurementValidity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MeasurementValidity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____MeasurementValidity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MeasurementValidity_iE_Extensions__item__extensionValue._const_tab = ____MeasurementValidity_iE_Extensions__item__extensionValue_tab
    ___MeasurementValidity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MeasurementValidity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MeasurementValidity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MeasurementValidity_iE_Extensions__item__id),
        ('criticality', ___MeasurementValidity_iE_Extensions__item__criticality),
        ('extensionValue', ___MeasurementValidity_iE_Extensions__item__extensionValue),
        ])
    __MeasurementValidity_iE_Extensions__item_._ext = None
    _MeasurementValidity_iE_Extensions._cont = __MeasurementValidity_iE_Extensions__item_
    _MeasurementValidity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MeasurementValidity._cont = ASN1Dict([
        ('ue-State', _MeasurementValidity_ue_State),
        ('iE-Extensions', _MeasurementValidity_iE_Extensions),
        ])
    MeasurementValidity._ext = []
    
    #-----< MeasurementValidity-ExtIEs >-----#
    MeasurementValidity_ExtIEs = CLASS(name='MeasurementValidity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    MeasurementValidity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MethodType >-----#
    MethodType = ENUM(name='MethodType', mode=MODE_TYPE)
    MethodType._cont = ASN1Dict([('ue-assisted', 0), ('ue-based', 1)])
    MethodType._ext = None
    
    #-----< OTDOA-MeasurementGroup >-----#
    OTDOA_MeasurementGroup = SEQ(name='OTDOA-MeasurementGroup', mode=MODE_TYPE)
    _OTDOA_MeasurementGroup_otdoa_ReferenceCellInfo = SEQ(name='otdoa-ReferenceCellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-ReferenceCellInfo')))
    _OTDOA_MeasurementGroup_otdoa_NeighbourCellInfoList = SEQ_OF(name='otdoa-NeighbourCellInfoList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-NeighbourCellInfoList')))
    _OTDOA_MeasurementGroup_otdoa_MeasuredResultsSets = SEQ_OF(name='otdoa-MeasuredResultsSets', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-MeasuredResultsSets')))
    _OTDOA_MeasurementGroup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OTDOA_MeasurementGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___OTDOA_MeasurementGroup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____OTDOA_MeasurementGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_MeasurementGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_MeasurementGroup_iE_Extensions__item__id._const_tab = ____OTDOA_MeasurementGroup_iE_Extensions__item__id_tab
    ___OTDOA_MeasurementGroup_iE_Extensions__item__id._const_tab_at = None
    ___OTDOA_MeasurementGroup_iE_Extensions__item__id._const_tab_id = 'id'
    ___OTDOA_MeasurementGroup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____OTDOA_MeasurementGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_MeasurementGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_MeasurementGroup_iE_Extensions__item__criticality._const_tab = ____OTDOA_MeasurementGroup_iE_Extensions__item__criticality_tab
    ___OTDOA_MeasurementGroup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOA_MeasurementGroup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OTDOA_MeasurementGroup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____OTDOA_MeasurementGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_MeasurementGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_MeasurementGroup_iE_Extensions__item__extensionValue._const_tab = ____OTDOA_MeasurementGroup_iE_Extensions__item__extensionValue_tab
    ___OTDOA_MeasurementGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OTDOA_MeasurementGroup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OTDOA_MeasurementGroup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OTDOA_MeasurementGroup_iE_Extensions__item__id),
        ('criticality', ___OTDOA_MeasurementGroup_iE_Extensions__item__criticality),
        ('extensionValue', ___OTDOA_MeasurementGroup_iE_Extensions__item__extensionValue),
        ])
    __OTDOA_MeasurementGroup_iE_Extensions__item_._ext = None
    _OTDOA_MeasurementGroup_iE_Extensions._cont = __OTDOA_MeasurementGroup_iE_Extensions__item_
    _OTDOA_MeasurementGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OTDOA_MeasurementGroup._cont = ASN1Dict([
        ('otdoa-ReferenceCellInfo', _OTDOA_MeasurementGroup_otdoa_ReferenceCellInfo),
        ('otdoa-NeighbourCellInfoList', _OTDOA_MeasurementGroup_otdoa_NeighbourCellInfoList),
        ('otdoa-MeasuredResultsSets', _OTDOA_MeasurementGroup_otdoa_MeasuredResultsSets),
        ('iE-Extensions', _OTDOA_MeasurementGroup_iE_Extensions),
        ])
    OTDOA_MeasurementGroup._ext = []
    
    #-----< OTDOA-MeasurementGroup-ExtIEs >-----#
    OTDOA_MeasurementGroup_ExtIEs = CLASS(name='OTDOA-MeasurementGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    OTDOA_MeasurementGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OTDOA-ReferenceCellInfo >-----#
    OTDOA_ReferenceCellInfo = SEQ(name='OTDOA-ReferenceCellInfo', mode=MODE_TYPE)
    _OTDOA_ReferenceCellInfo_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _OTDOA_ReferenceCellInfo_uTRANAccessPointPositionAltitude = SEQ(name='uTRANAccessPointPositionAltitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTRANAccessPointPositionAltitude')))
    _OTDOA_ReferenceCellInfo_tUTRANGPSMeasurementValueInfo = SEQ(name='tUTRANGPSMeasurementValueInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TUTRANGPSMeasurementValueInfo')), opt=True)
    _OTDOA_ReferenceCellInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OTDOA_ReferenceCellInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'TUTRANGANSSMeasurementValueInfo')))
    _____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AdditionalMeasurementInforLCR')))
    ____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 77), ('criticality', 'ignore'), ('Extension', _____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'ignore'), ('Extension', _____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__id._const_tab = ____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__id._const_tab_at = None
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality._const_tab = ____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue._const_tab = ____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OTDOA_ReferenceCellInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OTDOA_ReferenceCellInfo_iE_Extensions__item__id),
        ('criticality', ___OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue),
        ])
    __OTDOA_ReferenceCellInfo_iE_Extensions__item_._ext = None
    _OTDOA_ReferenceCellInfo_iE_Extensions._cont = __OTDOA_ReferenceCellInfo_iE_Extensions__item_
    _OTDOA_ReferenceCellInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OTDOA_ReferenceCellInfo._cont = ASN1Dict([
        ('uC-ID', _OTDOA_ReferenceCellInfo_uC_ID),
        ('uTRANAccessPointPositionAltitude', _OTDOA_ReferenceCellInfo_uTRANAccessPointPositionAltitude),
        ('tUTRANGPSMeasurementValueInfo', _OTDOA_ReferenceCellInfo_tUTRANGPSMeasurementValueInfo),
        ('iE-Extensions', _OTDOA_ReferenceCellInfo_iE_Extensions),
        ])
    OTDOA_ReferenceCellInfo._ext = []
    
    #-----< OTDOA-ReferenceCellInfo-ExtIEs >-----#
    OTDOA_ReferenceCellInfo_ExtIEs = CLASS(name='OTDOA-ReferenceCellInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _OTDOA_ReferenceCellInfo_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'TUTRANGANSSMeasurementValueInfo')))
    _OTDOA_ReferenceCellInfo_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AdditionalMeasurementInforLCR')))
    OTDOA_ReferenceCellInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 77), ('criticality', 'ignore'), ('Extension', _OTDOA_ReferenceCellInfo_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 82), ('criticality', 'ignore'), ('Extension', _OTDOA_ReferenceCellInfo_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< OTDOA-ReferenceCellInfoSAS-centric >-----#
    OTDOA_ReferenceCellInfoSAS_centric = SEQ(name='OTDOA-ReferenceCellInfoSAS-centric', mode=MODE_TYPE)
    _OTDOA_ReferenceCellInfoSAS_centric_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__id._const_tab = ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__id_tab
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__id._const_tab_at = None
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__id._const_tab_id = 'id'
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__criticality._const_tab = ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__criticality_tab
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__extensionValue._const_tab = ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__extensionValue_tab
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__id),
        ('criticality', ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__criticality),
        ('extensionValue', ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__extensionValue),
        ])
    __OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item_._ext = None
    _OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions._cont = __OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item_
    _OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OTDOA_ReferenceCellInfoSAS_centric._cont = ASN1Dict([
        ('uC-ID', _OTDOA_ReferenceCellInfoSAS_centric_uC_ID),
        ('iE-Extensions', _OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions),
        ])
    OTDOA_ReferenceCellInfoSAS_centric._ext = []
    
    #-----< OTDOA-ReferenceCellInfoSAS-centric-ExtIEs >-----#
    OTDOA_ReferenceCellInfoSAS_centric_ExtIEs = CLASS(name='OTDOA-ReferenceCellInfoSAS-centric-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    OTDOA_ReferenceCellInfoSAS_centric_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OTDOA-NeighbourCellInfoList >-----#
    OTDOA_NeighbourCellInfoList = SEQ_OF(name='OTDOA-NeighbourCellInfoList', mode=MODE_TYPE)
    _OTDOA_NeighbourCellInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-NeighbourCellInfo')))
    OTDOA_NeighbourCellInfoList._cont = _OTDOA_NeighbourCellInfoList__item_
    OTDOA_NeighbourCellInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< OTDOA-NeighbourCellInfo >-----#
    OTDOA_NeighbourCellInfo = SEQ(name='OTDOA-NeighbourCellInfo', mode=MODE_TYPE)
    _OTDOA_NeighbourCellInfo_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _OTDOA_NeighbourCellInfo_uTRANAccessPointPositionAltitude = SEQ(name='uTRANAccessPointPositionAltitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTRANAccessPointPositionAltitude')))
    _OTDOA_NeighbourCellInfo_relativeTimingDifferenceInfo = CHOICE(name='relativeTimingDifferenceInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RelativeTimingDifferenceInfo')))
    _OTDOA_NeighbourCellInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OTDOA_NeighbourCellInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__id._const_tab = ____OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__id._const_tab_at = None
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality._const_tab = ____OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality_tab
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue._const_tab = ____OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue_tab
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OTDOA_NeighbourCellInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OTDOA_NeighbourCellInfo_iE_Extensions__item__id),
        ('criticality', ___OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue),
        ])
    __OTDOA_NeighbourCellInfo_iE_Extensions__item_._ext = None
    _OTDOA_NeighbourCellInfo_iE_Extensions._cont = __OTDOA_NeighbourCellInfo_iE_Extensions__item_
    _OTDOA_NeighbourCellInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OTDOA_NeighbourCellInfo._cont = ASN1Dict([
        ('uC-ID', _OTDOA_NeighbourCellInfo_uC_ID),
        ('uTRANAccessPointPositionAltitude', _OTDOA_NeighbourCellInfo_uTRANAccessPointPositionAltitude),
        ('relativeTimingDifferenceInfo', _OTDOA_NeighbourCellInfo_relativeTimingDifferenceInfo),
        ('iE-Extensions', _OTDOA_NeighbourCellInfo_iE_Extensions),
        ])
    OTDOA_NeighbourCellInfo._ext = []
    
    #-----< OTDOA-NeighbourCellInfo-ExtIEs >-----#
    OTDOA_NeighbourCellInfo_ExtIEs = CLASS(name='OTDOA-NeighbourCellInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    OTDOA_NeighbourCellInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OTDOA-MeasuredResultsSets >-----#
    OTDOA_MeasuredResultsSets = SEQ_OF(name='OTDOA-MeasuredResultsSets', mode=MODE_TYPE)
    _OTDOA_MeasuredResultsSets__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-MeasuredResultsInfoList')))
    OTDOA_MeasuredResultsSets._cont = _OTDOA_MeasuredResultsSets__item_
    OTDOA_MeasuredResultsSets._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< OTDOA-MeasuredResultsInfoList >-----#
    OTDOA_MeasuredResultsInfoList = SEQ_OF(name='OTDOA-MeasuredResultsInfoList', mode=MODE_TYPE)
    _OTDOA_MeasuredResultsInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-MeasuredResultsInfo')))
    OTDOA_MeasuredResultsInfoList._cont = _OTDOA_MeasuredResultsInfoList__item_
    OTDOA_MeasuredResultsInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< OTDOA-MeasuredResultsInfo >-----#
    OTDOA_MeasuredResultsInfo = SEQ(name='OTDOA-MeasuredResultsInfo', mode=MODE_TYPE)
    _OTDOA_MeasuredResultsInfo_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _OTDOA_MeasuredResultsInfo_ue_SFNSFNTimeDifferenceType2Info = SEQ(name='ue-SFNSFNTimeDifferenceType2Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-SFNSFNTimeDifferenceType2Info')))
    _OTDOA_MeasuredResultsInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OTDOA_MeasuredResultsInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____OTDOA_MeasuredResultsInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____OTDOA_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-AddMeasuredResultsInfo')))
    ____OTDOA_MeasuredResultsInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'ignore'), ('Extension', _____OTDOA_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__id._const_tab = ____OTDOA_MeasuredResultsInfo_iE_Extensions__item__id_tab
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__id._const_tab_at = None
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__criticality._const_tab = ____OTDOA_MeasuredResultsInfo_iE_Extensions__item__id_tab
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__extensionValue._const_tab = ____OTDOA_MeasuredResultsInfo_iE_Extensions__item__id_tab
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OTDOA_MeasuredResultsInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__id),
        ('criticality', ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__extensionValue),
        ])
    __OTDOA_MeasuredResultsInfo_iE_Extensions__item_._ext = None
    _OTDOA_MeasuredResultsInfo_iE_Extensions._cont = __OTDOA_MeasuredResultsInfo_iE_Extensions__item_
    _OTDOA_MeasuredResultsInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OTDOA_MeasuredResultsInfo._cont = ASN1Dict([
        ('uC-ID', _OTDOA_MeasuredResultsInfo_uC_ID),
        ('ue-SFNSFNTimeDifferenceType2Info', _OTDOA_MeasuredResultsInfo_ue_SFNSFNTimeDifferenceType2Info),
        ('iE-Extensions', _OTDOA_MeasuredResultsInfo_iE_Extensions),
        ])
    OTDOA_MeasuredResultsInfo._ext = []
    
    #-----< OTDOA-MeasuredResultsInfo-ExtIEs >-----#
    OTDOA_MeasuredResultsInfo_ExtIEs = CLASS(name='OTDOA-MeasuredResultsInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _OTDOA_MeasuredResultsInfo_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-AddMeasuredResultsInfo')))
    OTDOA_MeasuredResultsInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 49), ('criticality', 'ignore'), ('Extension', _OTDOA_MeasuredResultsInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< OTDOA-AddMeasuredResultsInfo >-----#
    OTDOA_AddMeasuredResultsInfo = SEQ(name='OTDOA-AddMeasuredResultsInfo', mode=MODE_TYPE)
    _OTDOA_AddMeasuredResultsInfo_primaryCPICH_Info = INT(name='primaryCPICH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PrimaryScramblingCode')))
    _OTDOA_AddMeasuredResultsInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OTDOA_AddMeasuredResultsInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__id._const_tab = ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__id_tab
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__id._const_tab_at = None
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__criticality._const_tab = ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__criticality_tab
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__extensionValue._const_tab = ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__extensionValue_tab
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OTDOA_AddMeasuredResultsInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__id),
        ('criticality', ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__extensionValue),
        ])
    __OTDOA_AddMeasuredResultsInfo_iE_Extensions__item_._ext = None
    _OTDOA_AddMeasuredResultsInfo_iE_Extensions._cont = __OTDOA_AddMeasuredResultsInfo_iE_Extensions__item_
    _OTDOA_AddMeasuredResultsInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OTDOA_AddMeasuredResultsInfo._cont = ASN1Dict([
        ('primaryCPICH-Info', _OTDOA_AddMeasuredResultsInfo_primaryCPICH_Info),
        ('iE-Extensions', _OTDOA_AddMeasuredResultsInfo_iE_Extensions),
        ])
    OTDOA_AddMeasuredResultsInfo._ext = []
    
    #-----< OTDOA-AddMeasuredResultsInfo-ExtIEs >-----#
    OTDOA_AddMeasuredResultsInfo_ExtIEs = CLASS(name='OTDOA-AddMeasuredResultsInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    OTDOA_AddMeasuredResultsInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-SFNSFNTimeDifferenceType2Info >-----#
    UE_SFNSFNTimeDifferenceType2Info = SEQ(name='UE-SFNSFNTimeDifferenceType2Info', mode=MODE_TYPE)
    _UE_SFNSFNTimeDifferenceType2Info_ue_SFNSFNTimeDifferenceType2 = INT(name='ue-SFNSFNTimeDifferenceType2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_SFNSFNTimeDifferenceType2Info_ue_SFNSFNTimeDifferenceType2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40961)], ev=None, er=[])
    _UE_SFNSFNTimeDifferenceType2Info_ue_PositioningMeasQuality = SEQ(name='ue-PositioningMeasQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-PositioningMeasQuality')))
    _UE_SFNSFNTimeDifferenceType2Info_measurementDelay = INT(name='measurementDelay', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_SFNSFNTimeDifferenceType2Info_measurementDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UE_SFNSFNTimeDifferenceType2Info_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__id._const_tab = ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__id_tab
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__id._const_tab_at = None
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__criticality._const_tab = ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__criticality_tab
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__extensionValue._const_tab = ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__extensionValue_tab
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__id),
        ('criticality', ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__extensionValue),
        ])
    __UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item_._ext = None
    _UE_SFNSFNTimeDifferenceType2Info_iE_Extensions._cont = __UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item_
    _UE_SFNSFNTimeDifferenceType2Info_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_SFNSFNTimeDifferenceType2Info._cont = ASN1Dict([
        ('ue-SFNSFNTimeDifferenceType2', _UE_SFNSFNTimeDifferenceType2Info_ue_SFNSFNTimeDifferenceType2),
        ('ue-PositioningMeasQuality', _UE_SFNSFNTimeDifferenceType2Info_ue_PositioningMeasQuality),
        ('measurementDelay', _UE_SFNSFNTimeDifferenceType2Info_measurementDelay),
        ('iE-Extensions', _UE_SFNSFNTimeDifferenceType2Info_iE_Extensions),
        ])
    UE_SFNSFNTimeDifferenceType2Info._ext = []
    
    #-----< UE-SFNSFNTimeDifferenceInfo-ExtIEs >-----#
    UE_SFNSFNTimeDifferenceInfo_ExtIEs = CLASS(name='UE-SFNSFNTimeDifferenceInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UE_SFNSFNTimeDifferenceInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UC-ID >-----#
    UC_ID = SEQ(name='UC-ID', mode=MODE_TYPE)
    _UC_ID_rNC_ID = INT(name='rNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UC_ID_rNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _UC_ID_c_ID = INT(name='c-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UC_ID_c_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UC_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UC_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UC_ID_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Extended-RNC-ID')))
    ____UC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 68), ('criticality', 'reject'), ('Extension', _____UC_ID_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UC_ID_iE_Extensions__item__id._const_tab = ____UC_ID_iE_Extensions__item__id_tab
    ___UC_ID_iE_Extensions__item__id._const_tab_at = None
    ___UC_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___UC_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UC_ID_iE_Extensions__item__criticality._const_tab = ____UC_ID_iE_Extensions__item__id_tab
    ___UC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UC_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UC_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UC_ID_iE_Extensions__item__extensionValue._const_tab = ____UC_ID_iE_Extensions__item__id_tab
    ___UC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UC_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UC_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UC_ID_iE_Extensions__item__id),
        ('criticality', ___UC_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___UC_ID_iE_Extensions__item__extensionValue),
        ])
    __UC_ID_iE_Extensions__item_._ext = None
    _UC_ID_iE_Extensions._cont = __UC_ID_iE_Extensions__item_
    _UC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UC_ID._cont = ASN1Dict([
        ('rNC-ID', _UC_ID_rNC_ID),
        ('c-ID', _UC_ID_c_ID),
        ('iE-Extensions', _UC_ID_iE_Extensions),
        ])
    UC_ID._ext = []
    
    #-----< UC-ID-ExtIEs >-----#
    UC_ID_ExtIEs = CLASS(name='UC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _UC_ID_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Extended-RNC-ID')))
    UC_ID_ExtIEs._val = ASN1Set(rv=[dict([('id', 68), ('criticality', 'reject'), ('Extension', _UC_ID_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Extended-RNC-ID >-----#
    Extended_RNC_ID = INT(name='Extended-RNC-ID', mode=MODE_TYPE)
    Extended_RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=65535)], ev=None, er=[])
    
    #-----< RelativeTimingDifferenceInfo >-----#
    RelativeTimingDifferenceInfo = CHOICE(name='RelativeTimingDifferenceInfo', mode=MODE_TYPE)
    _RelativeTimingDifferenceInfo_sFNSFNMeasurementValueInfo = SEQ(name='sFNSFNMeasurementValueInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFNSFNMeasurementValueInfo')))
    _RelativeTimingDifferenceInfo_tUTRANGPSMeasurementValueInfo = SEQ(name='tUTRANGPSMeasurementValueInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TUTRANGPSMeasurementValueInfo')))
    _RelativeTimingDifferenceInfo_tUTRANGANSSMeasurementValueInfo = SEQ(name='tUTRANGANSSMeasurementValueInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TUTRANGANSSMeasurementValueInfo')))
    RelativeTimingDifferenceInfo._cont = ASN1Dict([
        ('sFNSFNMeasurementValueInfo', _RelativeTimingDifferenceInfo_sFNSFNMeasurementValueInfo),
        ('tUTRANGPSMeasurementValueInfo', _RelativeTimingDifferenceInfo_tUTRANGPSMeasurementValueInfo),
        ('tUTRANGANSSMeasurementValueInfo', _RelativeTimingDifferenceInfo_tUTRANGANSSMeasurementValueInfo),
        ])
    RelativeTimingDifferenceInfo._ext = ['tUTRANGANSSMeasurementValueInfo']
    
    #-----< SFNSFNMeasurementValueInfo >-----#
    SFNSFNMeasurementValueInfo = SEQ(name='SFNSFNMeasurementValueInfo', mode=MODE_TYPE)
    _SFNSFNMeasurementValueInfo_sFNSFNValue = INT(name='sFNSFNValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFNSFNValue')))
    _SFNSFNMeasurementValueInfo_sFNSFNQuality = INT(name='sFNSFNQuality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFNSFNQuality')), opt=True)
    _SFNSFNMeasurementValueInfo_sFNSFNDriftRate = INT(name='sFNSFNDriftRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFNSFNDriftRate')))
    _SFNSFNMeasurementValueInfo_sFNSFNDriftRateQuality = INT(name='sFNSFNDriftRateQuality', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFNSFNDriftRateQuality')), opt=True)
    _SFNSFNMeasurementValueInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFNSFNMeasurementValueInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____SFNSFNMeasurementValueInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementValueInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__id._const_tab = ____SFNSFNMeasurementValueInfo_iE_Extensions__item__id_tab
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__id._const_tab_at = None
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SFNSFNMeasurementValueInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementValueInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__criticality._const_tab = ____SFNSFNMeasurementValueInfo_iE_Extensions__item__criticality_tab
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SFNSFNMeasurementValueInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SFNSFNMeasurementValueInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__extensionValue._const_tab = ____SFNSFNMeasurementValueInfo_iE_Extensions__item__extensionValue_tab
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SFNSFNMeasurementValueInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SFNSFNMeasurementValueInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SFNSFNMeasurementValueInfo_iE_Extensions__item__id),
        ('criticality', ___SFNSFNMeasurementValueInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___SFNSFNMeasurementValueInfo_iE_Extensions__item__extensionValue),
        ])
    __SFNSFNMeasurementValueInfo_iE_Extensions__item_._ext = None
    _SFNSFNMeasurementValueInfo_iE_Extensions._cont = __SFNSFNMeasurementValueInfo_iE_Extensions__item_
    _SFNSFNMeasurementValueInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFNSFNMeasurementValueInfo._cont = ASN1Dict([
        ('sFNSFNValue', _SFNSFNMeasurementValueInfo_sFNSFNValue),
        ('sFNSFNQuality', _SFNSFNMeasurementValueInfo_sFNSFNQuality),
        ('sFNSFNDriftRate', _SFNSFNMeasurementValueInfo_sFNSFNDriftRate),
        ('sFNSFNDriftRateQuality', _SFNSFNMeasurementValueInfo_sFNSFNDriftRateQuality),
        ('iE-Extensions', _SFNSFNMeasurementValueInfo_iE_Extensions),
        ])
    SFNSFNMeasurementValueInfo._ext = []
    
    #-----< SFNSFNMeasurementValueInfo-ExtIEs >-----#
    SFNSFNMeasurementValueInfo_ExtIEs = CLASS(name='SFNSFNMeasurementValueInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    SFNSFNMeasurementValueInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SFNSFNValue >-----#
    SFNSFNValue = INT(name='SFNSFNValue', mode=MODE_TYPE)
    SFNSFNValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=614399)], ev=None, er=[])
    
    #-----< SFNSFNQuality >-----#
    SFNSFNQuality = INT(name='SFNSFNQuality', mode=MODE_TYPE)
    SFNSFNQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< SFNSFNDriftRate >-----#
    SFNSFNDriftRate = INT(name='SFNSFNDriftRate', mode=MODE_TYPE)
    SFNSFNDriftRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-100, ub=100)], ev=None, er=[])
    
    #-----< SFNSFNDriftRateQuality >-----#
    SFNSFNDriftRateQuality = INT(name='SFNSFNDriftRateQuality', mode=MODE_TYPE)
    SFNSFNDriftRateQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< TUTRANGPSMeasurementValueInfo >-----#
    TUTRANGPSMeasurementValueInfo = SEQ(name='TUTRANGPSMeasurementValueInfo', mode=MODE_TYPE)
    _TUTRANGPSMeasurementValueInfo_sFN = INT(name='sFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFN')))
    _TUTRANGPSMeasurementValueInfo_tUTRANGPS = SEQ(name='tUTRANGPS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TUTRANGPS')))
    _TUTRANGPSMeasurementValueInfo_tUTRANGPSQuality = INT(name='tUTRANGPSQuality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TUTRANGPSQuality')), opt=True)
    _TUTRANGPSMeasurementValueInfo_tUTRANGPSDriftRate = INT(name='tUTRANGPSDriftRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TUTRANGPSDriftRate')))
    _TUTRANGPSMeasurementValueInfo_tUTRANGPSDriftRateQuality = INT(name='tUTRANGPSDriftRateQuality', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TUTRANGPSDriftRateQuality')), opt=True)
    _TUTRANGPSMeasurementValueInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TUTRANGPSMeasurementValueInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__id._const_tab = ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__id_tab
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__id._const_tab_at = None
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__criticality._const_tab = ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__criticality_tab
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__extensionValue._const_tab = ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__extensionValue_tab
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TUTRANGPSMeasurementValueInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__id),
        ('criticality', ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__extensionValue),
        ])
    __TUTRANGPSMeasurementValueInfo_iE_Extensions__item_._ext = None
    _TUTRANGPSMeasurementValueInfo_iE_Extensions._cont = __TUTRANGPSMeasurementValueInfo_iE_Extensions__item_
    _TUTRANGPSMeasurementValueInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TUTRANGPSMeasurementValueInfo._cont = ASN1Dict([
        ('sFN', _TUTRANGPSMeasurementValueInfo_sFN),
        ('tUTRANGPS', _TUTRANGPSMeasurementValueInfo_tUTRANGPS),
        ('tUTRANGPSQuality', _TUTRANGPSMeasurementValueInfo_tUTRANGPSQuality),
        ('tUTRANGPSDriftRate', _TUTRANGPSMeasurementValueInfo_tUTRANGPSDriftRate),
        ('tUTRANGPSDriftRateQuality', _TUTRANGPSMeasurementValueInfo_tUTRANGPSDriftRateQuality),
        ('iE-Extensions', _TUTRANGPSMeasurementValueInfo_iE_Extensions),
        ])
    TUTRANGPSMeasurementValueInfo._ext = []
    
    #-----< TUTRANGPSMeasurementValueInfo-ExtIEs >-----#
    TUTRANGPSMeasurementValueInfo_ExtIEs = CLASS(name='TUTRANGPSMeasurementValueInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    TUTRANGPSMeasurementValueInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SFN >-----#
    SFN = INT(name='SFN', mode=MODE_TYPE)
    SFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< TUTRANGPS >-----#
    TUTRANGPS = SEQ(name='TUTRANGPS', mode=MODE_TYPE)
    _TUTRANGPS_ms_part = INT(name='ms-part', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGPS_ms_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _TUTRANGPS_ls_part = INT(name='ls-part', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGPS_ls_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    TUTRANGPS._cont = ASN1Dict([
        ('ms-part', _TUTRANGPS_ms_part),
        ('ls-part', _TUTRANGPS_ls_part),
        ])
    TUTRANGPS._ext = None
    
    #-----< TUTRANGPSQuality >-----#
    TUTRANGPSQuality = INT(name='TUTRANGPSQuality', mode=MODE_TYPE)
    TUTRANGPSQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< TUTRANGPSDriftRate >-----#
    TUTRANGPSDriftRate = INT(name='TUTRANGPSDriftRate', mode=MODE_TYPE)
    TUTRANGPSDriftRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-50, ub=50)], ev=None, er=[])
    
    #-----< TUTRANGPSDriftRateQuality >-----#
    TUTRANGPSDriftRateQuality = INT(name='TUTRANGPSDriftRateQuality', mode=MODE_TYPE)
    TUTRANGPSDriftRateQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=50)], ev=None, er=[])
    
    #-----< TUTRANGANSSMeasurementValueInfo >-----#
    TUTRANGANSSMeasurementValueInfo = SEQ(name='TUTRANGANSSMeasurementValueInfo', mode=MODE_TYPE)
    _TUTRANGANSSMeasurementValueInfo_ganssID = SEQ(name='ganssID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    _TUTRANGANSSMeasurementValueInfo_sFN = INT(name='sFN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFN')))
    _TUTRANGANSSMeasurementValueInfo_tUTRANGANSS = SEQ(name='tUTRANGANSS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TUTRANGANSS')))
    _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSQuality = INT(name='tUTRANGANSSQuality', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSDriftRate = INT(name='tUTRANGANSSDriftRate', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSDriftRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-50, ub=50)], ev=None, er=[])
    _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSDriftRateQuality = INT(name='tUTRANGANSSDriftRateQuality', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSDriftRateQuality._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=50)], ev=None, er=[])
    _TUTRANGANSSMeasurementValueInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TUTRANGANSSMeasurementValueInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__id._const_tab = ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__id_tab
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__id._const_tab_at = None
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__criticality._const_tab = ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__criticality_tab
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__extensionValue._const_tab = ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__extensionValue_tab
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TUTRANGANSSMeasurementValueInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__id),
        ('criticality', ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__extensionValue),
        ])
    __TUTRANGANSSMeasurementValueInfo_iE_Extensions__item_._ext = None
    _TUTRANGANSSMeasurementValueInfo_iE_Extensions._cont = __TUTRANGANSSMeasurementValueInfo_iE_Extensions__item_
    _TUTRANGANSSMeasurementValueInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TUTRANGANSSMeasurementValueInfo._cont = ASN1Dict([
        ('ganssID', _TUTRANGANSSMeasurementValueInfo_ganssID),
        ('sFN', _TUTRANGANSSMeasurementValueInfo_sFN),
        ('tUTRANGANSS', _TUTRANGANSSMeasurementValueInfo_tUTRANGANSS),
        ('tUTRANGANSSQuality', _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSQuality),
        ('tUTRANGANSSDriftRate', _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSDriftRate),
        ('tUTRANGANSSDriftRateQuality', _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSDriftRateQuality),
        ('iE-Extensions', _TUTRANGANSSMeasurementValueInfo_iE_Extensions),
        ])
    TUTRANGANSSMeasurementValueInfo._ext = []
    
    #-----< TUTRANGANSSMeasurementValueInfo-ExtIEs >-----#
    TUTRANGANSSMeasurementValueInfo_ExtIEs = CLASS(name='TUTRANGANSSMeasurementValueInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    TUTRANGANSSMeasurementValueInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TUTRANGANSS >-----#
    TUTRANGANSS = SEQ(name='TUTRANGANSS', mode=MODE_TYPE)
    _TUTRANGANSS_ms_part = INT(name='ms-part', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGANSS_ms_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    _TUTRANGANSS_ls_part = INT(name='ls-part', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TUTRANGANSS_ls_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    TUTRANGANSS._cont = ASN1Dict([
        ('ms-part', _TUTRANGANSS_ms_part),
        ('ls-part', _TUTRANGANSS_ls_part),
        ])
    TUTRANGANSS._ext = None
    
    #-----< AdditionalMeasurementInforLCR >-----#
    AdditionalMeasurementInforLCR = SEQ(name='AdditionalMeasurementInforLCR', mode=MODE_TYPE)
    _AdditionalMeasurementInforLCR_timingAdvanceLCR_R7 = INT(name='timingAdvanceLCR-R7', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TimingAdvanceLCR-R7')))
    _AdditionalMeasurementInforLCR_rxTimingDeviationLCR = INT(name='rxTimingDeviationLCR', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviationLCR')))
    _AdditionalMeasurementInforLCR_angleOfArrivalLCR = SEQ(name='angleOfArrivalLCR', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AngleOfArrivalLCR')), opt=True)
    _AdditionalMeasurementInforLCR_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AdditionalMeasurementInforLCR_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____AdditionalMeasurementInforLCR_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AdditionalMeasurementInforLCR_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__id._const_tab = ____AdditionalMeasurementInforLCR_iE_Extensions__item__id_tab
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__id._const_tab_at = None
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__id._const_tab_id = 'id'
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AdditionalMeasurementInforLCR_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AdditionalMeasurementInforLCR_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__criticality._const_tab = ____AdditionalMeasurementInforLCR_iE_Extensions__item__criticality_tab
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AdditionalMeasurementInforLCR_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____AdditionalMeasurementInforLCR_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__extensionValue._const_tab = ____AdditionalMeasurementInforLCR_iE_Extensions__item__extensionValue_tab
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AdditionalMeasurementInforLCR_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AdditionalMeasurementInforLCR_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AdditionalMeasurementInforLCR_iE_Extensions__item__id),
        ('criticality', ___AdditionalMeasurementInforLCR_iE_Extensions__item__criticality),
        ('extensionValue', ___AdditionalMeasurementInforLCR_iE_Extensions__item__extensionValue),
        ])
    __AdditionalMeasurementInforLCR_iE_Extensions__item_._ext = None
    _AdditionalMeasurementInforLCR_iE_Extensions._cont = __AdditionalMeasurementInforLCR_iE_Extensions__item_
    _AdditionalMeasurementInforLCR_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AdditionalMeasurementInforLCR._cont = ASN1Dict([
        ('timingAdvanceLCR-R7', _AdditionalMeasurementInforLCR_timingAdvanceLCR_R7),
        ('rxTimingDeviationLCR', _AdditionalMeasurementInforLCR_rxTimingDeviationLCR),
        ('angleOfArrivalLCR', _AdditionalMeasurementInforLCR_angleOfArrivalLCR),
        ('iE-Extensions', _AdditionalMeasurementInforLCR_iE_Extensions),
        ])
    AdditionalMeasurementInforLCR._ext = []
    
    #-----< AdditionalMeasurementInforLCR-ExtIEs >-----#
    AdditionalMeasurementInforLCR_ExtIEs = CLASS(name='AdditionalMeasurementInforLCR-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AdditionalMeasurementInforLCR_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimingAdvanceLCR-R7 >-----#
    TimingAdvanceLCR_R7 = INT(name='TimingAdvanceLCR-R7', mode=MODE_TYPE)
    TimingAdvanceLCR_R7._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    
    #-----< PeriodicPosCalcInfo >-----#
    PeriodicPosCalcInfo = SEQ(name='PeriodicPosCalcInfo', mode=MODE_TYPE)
    _PeriodicPosCalcInfo_referenceNumber = INT(name='referenceNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicPosCalcInfo_referenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=[], er=[])
    _PeriodicPosCalcInfo_amountOutstandingRequests = INT(name='amountOutstandingRequests', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicPosCalcInfo_amountOutstandingRequests._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=[], er=[])
    _PeriodicPosCalcInfo_reportingInterval = INT(name='reportingInterval', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicPosCalcInfo_reportingInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=[], er=[])
    _PeriodicPosCalcInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PeriodicPosCalcInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PeriodicPosCalcInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PeriodicPosCalcInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PeriodicPosCalcInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicPosCalcInfo_iE_Extensions__item__id._const_tab = ____PeriodicPosCalcInfo_iE_Extensions__item__id_tab
    ___PeriodicPosCalcInfo_iE_Extensions__item__id._const_tab_at = None
    ___PeriodicPosCalcInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___PeriodicPosCalcInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PeriodicPosCalcInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PeriodicPosCalcInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicPosCalcInfo_iE_Extensions__item__criticality._const_tab = ____PeriodicPosCalcInfo_iE_Extensions__item__criticality_tab
    ___PeriodicPosCalcInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PeriodicPosCalcInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PeriodicPosCalcInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PeriodicPosCalcInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PeriodicPosCalcInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicPosCalcInfo_iE_Extensions__item__extensionValue._const_tab = ____PeriodicPosCalcInfo_iE_Extensions__item__extensionValue_tab
    ___PeriodicPosCalcInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PeriodicPosCalcInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PeriodicPosCalcInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PeriodicPosCalcInfo_iE_Extensions__item__id),
        ('criticality', ___PeriodicPosCalcInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___PeriodicPosCalcInfo_iE_Extensions__item__extensionValue),
        ])
    __PeriodicPosCalcInfo_iE_Extensions__item_._ext = None
    _PeriodicPosCalcInfo_iE_Extensions._cont = __PeriodicPosCalcInfo_iE_Extensions__item_
    _PeriodicPosCalcInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PeriodicPosCalcInfo._cont = ASN1Dict([
        ('referenceNumber', _PeriodicPosCalcInfo_referenceNumber),
        ('amountOutstandingRequests', _PeriodicPosCalcInfo_amountOutstandingRequests),
        ('reportingInterval', _PeriodicPosCalcInfo_reportingInterval),
        ('iE-Extensions', _PeriodicPosCalcInfo_iE_Extensions),
        ])
    PeriodicPosCalcInfo._ext = []
    
    #-----< PeriodicPosCalcInfo-ExtIEs >-----#
    PeriodicPosCalcInfo_ExtIEs = CLASS(name='PeriodicPosCalcInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PeriodicPosCalcInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PeriodicLocationInfo >-----#
    PeriodicLocationInfo = SEQ(name='PeriodicLocationInfo', mode=MODE_TYPE)
    _PeriodicLocationInfo_reportingAmount = INT(name='reportingAmount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicLocationInfo_reportingAmount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=[], er=[])
    _PeriodicLocationInfo_reportingInterval = INT(name='reportingInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicLocationInfo_reportingInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=[], er=[])
    _PeriodicLocationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PeriodicLocationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PeriodicLocationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PeriodicLocationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PeriodicLocationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicLocationInfo_iE_Extensions__item__id._const_tab = ____PeriodicLocationInfo_iE_Extensions__item__id_tab
    ___PeriodicLocationInfo_iE_Extensions__item__id._const_tab_at = None
    ___PeriodicLocationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___PeriodicLocationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicLocationInfo_iE_Extensions__item__criticality._const_tab = ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab
    ___PeriodicLocationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PeriodicLocationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue._const_tab = ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PeriodicLocationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PeriodicLocationInfo_iE_Extensions__item__id),
        ('criticality', ___PeriodicLocationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___PeriodicLocationInfo_iE_Extensions__item__extensionValue),
        ])
    __PeriodicLocationInfo_iE_Extensions__item_._ext = None
    _PeriodicLocationInfo_iE_Extensions._cont = __PeriodicLocationInfo_iE_Extensions__item_
    _PeriodicLocationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PeriodicLocationInfo._cont = ASN1Dict([
        ('reportingAmount', _PeriodicLocationInfo_reportingAmount),
        ('reportingInterval', _PeriodicLocationInfo_reportingInterval),
        ('iE-Extensions', _PeriodicLocationInfo_iE_Extensions),
        ])
    PeriodicLocationInfo._ext = []
    
    #-----< PeriodicLocationInfo-ExtIEs >-----#
    PeriodicLocationInfo_ExtIEs = CLASS(name='PeriodicLocationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PeriodicLocationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PeriodicTerminationCause >-----#
    PeriodicTerminationCause = ENUM(name='PeriodicTerminationCause', mode=MODE_TYPE)
    PeriodicTerminationCause._cont = ASN1Dict([('rrc-state-transition', 0), ('cancelled-by-srnc', 1), ('cancelled-by-sas', 2), ('undefined', 3)])
    PeriodicTerminationCause._ext = []
    
    #-----< PositioningMethod >-----#
    PositioningMethod = SEQ(name='PositioningMethod', mode=MODE_TYPE)
    _PositioningMethod_additionalMethodType = ENUM(name='additionalMethodType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AdditionalMethodType')))
    _PositioningMethod_selectedPositionMethod = ENUM(name='selectedPositionMethod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SelectedPositionMethod')))
    _PositioningMethod_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositioningMethod_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositioningMethod_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositioningMethod_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PositioningMethod_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GNSS-PositioningMethod')))
    _____PositioningMethod_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Additional-PositioningMethod')))
    ____PositioningMethod_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 75), ('criticality', 'ignore'), ('Extension', _____PositioningMethod_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'conditional')]), dict([('id', 140), ('criticality', 'ignore'), ('Extension', _____PositioningMethod_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___PositioningMethod_iE_Extensions__item__id._const_tab = ____PositioningMethod_iE_Extensions__item__id_tab
    ___PositioningMethod_iE_Extensions__item__id._const_tab_at = None
    ___PositioningMethod_iE_Extensions__item__id._const_tab_id = 'id'
    ___PositioningMethod_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositioningMethod_iE_Extensions__item__criticality._const_tab = ____PositioningMethod_iE_Extensions__item__id_tab
    ___PositioningMethod_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositioningMethod_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PositioningMethod_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositioningMethod_iE_Extensions__item__extensionValue._const_tab = ____PositioningMethod_iE_Extensions__item__id_tab
    ___PositioningMethod_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositioningMethod_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PositioningMethod_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PositioningMethod_iE_Extensions__item__id),
        ('criticality', ___PositioningMethod_iE_Extensions__item__criticality),
        ('extensionValue', ___PositioningMethod_iE_Extensions__item__extensionValue),
        ])
    __PositioningMethod_iE_Extensions__item_._ext = None
    _PositioningMethod_iE_Extensions._cont = __PositioningMethod_iE_Extensions__item_
    _PositioningMethod_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositioningMethod._cont = ASN1Dict([
        ('additionalMethodType', _PositioningMethod_additionalMethodType),
        ('selectedPositionMethod', _PositioningMethod_selectedPositionMethod),
        ('iE-Extensions', _PositioningMethod_iE_Extensions),
        ])
    PositioningMethod._ext = []
    
    #-----< PositioningMethod-ExtIEs >-----#
    PositioningMethod_ExtIEs = CLASS(name='PositioningMethod-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _PositioningMethod_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GNSS-PositioningMethod')))
    _PositioningMethod_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Additional-PositioningMethod')))
    PositioningMethod_ExtIEs._val = ASN1Set(rv=[dict([('id', 75), ('criticality', 'ignore'), ('Extension', _PositioningMethod_ExtIEs_val_Extension_0), ('presence', 'conditional')]), dict([('id', 140), ('criticality', 'ignore'), ('Extension', _PositioningMethod_ExtIEs_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< GNSS-PositioningMethod >-----#
    GNSS_PositioningMethod = BIT_STR(name='GNSS-PositioningMethod', mode=MODE_TYPE)
    GNSS_PositioningMethod._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    
    #-----< Additional-PositioningMethod >-----#
    Additional_PositioningMethod = BIT_STR(name='Additional-PositioningMethod', mode=MODE_TYPE)
    Additional_PositioningMethod._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< SelectedPositionMethod >-----#
    SelectedPositionMethod = ENUM(name='SelectedPositionMethod', mode=MODE_TYPE)
    SelectedPositionMethod._cont = ASN1Dict([('oTDOA', 0), ('gPS', 1), ('oTDOA-or-GPS', 2), ('cell-id', 3), ('uTDOA', 4), ('gNSS', 5), ('oTDOA-or-GNSS', 6), ('gPS-and-AddPos', 7), ('oTDOA-or-GPS-and-AddPos', 8)])
    SelectedPositionMethod._ext = ['gNSS', 'oTDOA-or-GNSS', 'gPS-and-AddPos', 'oTDOA-or-GPS-and-AddPos']
    
    #-----< PositioningPriority >-----#
    PositioningPriority = ENUM(name='PositioningPriority', mode=MODE_TYPE)
    PositioningPriority._cont = ASN1Dict([('high-priority', 0), ('normal-priority', 1)])
    PositioningPriority._ext = []
    
    #-----< RRCstateChange >-----#
    RRCstateChange = SEQ(name='RRCstateChange', mode=MODE_TYPE)
    _RRCstateChange_new_ue_State = ENUM(name='new-ue-State', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RRCstateChange_new_ue_State._cont = ASN1Dict([('cell-DCH', 0), ('cell-FACH', 1), ('cell-PCH', 2), ('ura-PCH', 3)])
    _RRCstateChange_new_ue_State._ext = []
    _RRCstateChange_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RRCstateChange_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RRCstateChange_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RRCstateChange_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RRCstateChange_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RRCstateChange_iE_Extensions__item__id._const_tab = ____RRCstateChange_iE_Extensions__item__id_tab
    ___RRCstateChange_iE_Extensions__item__id._const_tab_at = None
    ___RRCstateChange_iE_Extensions__item__id._const_tab_id = 'id'
    ___RRCstateChange_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RRCstateChange_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RRCstateChange_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RRCstateChange_iE_Extensions__item__criticality._const_tab = ____RRCstateChange_iE_Extensions__item__criticality_tab
    ___RRCstateChange_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RRCstateChange_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RRCstateChange_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RRCstateChange_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RRCstateChange_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RRCstateChange_iE_Extensions__item__extensionValue._const_tab = ____RRCstateChange_iE_Extensions__item__extensionValue_tab
    ___RRCstateChange_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RRCstateChange_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RRCstateChange_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RRCstateChange_iE_Extensions__item__id),
        ('criticality', ___RRCstateChange_iE_Extensions__item__criticality),
        ('extensionValue', ___RRCstateChange_iE_Extensions__item__extensionValue),
        ])
    __RRCstateChange_iE_Extensions__item_._ext = None
    _RRCstateChange_iE_Extensions._cont = __RRCstateChange_iE_Extensions__item_
    _RRCstateChange_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RRCstateChange._cont = ASN1Dict([
        ('new-ue-State', _RRCstateChange_new_ue_State),
        ('iE-Extensions', _RRCstateChange_iE_Extensions),
        ])
    RRCstateChange._ext = []
    
    #-----< RRCstateChange-ExtIEs >-----#
    RRCstateChange_ExtIEs = CLASS(name='RRCstateChange-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RRCstateChange_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedDataValue >-----#
    RequestedDataValue = SEQ(name='RequestedDataValue', mode=MODE_TYPE)
    _RequestedDataValue_gpsAlmanacAndSatelliteHealth = SEQ(name='gpsAlmanacAndSatelliteHealth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-AlmanacAndSatelliteHealth')), opt=True)
    _RequestedDataValue_gps_UTC_Model = SEQ(name='gps-UTC-Model', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-UTC-Model')), opt=True)
    _RequestedDataValue_gps_Ionospheric_Model = SEQ(name='gps-Ionospheric-Model', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-Ionospheric-Model')), opt=True)
    _RequestedDataValue_gps_NavigationModel = SEQ_OF(name='gps-NavigationModel', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-NavigationModel')), opt=True)
    _RequestedDataValue_dgpsCorrections = SEQ(name='dgpsCorrections', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DGPSCorrections')), opt=True)
    _RequestedDataValue_referenceTime = SEQ(name='referenceTime', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-ReferenceTime')), opt=True)
    _RequestedDataValue_gps_AcquisitionAssistance = SEQ(name='gps-AcquisitionAssistance', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-AcquisitionAssistance')), opt=True)
    _RequestedDataValue_gps_RealTime_Integrity = CHOICE(name='gps-RealTime-Integrity', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-RealTimeIntegrity')), opt=True)
    _RequestedDataValue_almanacAndSatelliteHealthSIB = SEQ(name='almanacAndSatelliteHealthSIB', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AlmanacAndSatelliteHealthSIB')), opt=True)
    _RequestedDataValue_gps_Transmission_TOW = INT(name='gps-Transmission-TOW', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPS-Transmission-TOW')), opt=True)
    _RequestedDataValue_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestedDataValue_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RequestedDataValue_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RequestedDataValue_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-ReferenceLocation')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-CommonAssistanceData')))
    _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-GenericAssistanceDataList')))
    ____RequestedDataValue_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 50), ('criticality', 'ignore'), ('Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 69), ('criticality', 'ignore'), ('Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'ignore'), ('Extension', _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RequestedDataValue_iE_Extensions__item__id._const_tab = ____RequestedDataValue_iE_Extensions__item__id_tab
    ___RequestedDataValue_iE_Extensions__item__id._const_tab_at = None
    ___RequestedDataValue_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestedDataValue_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RequestedDataValue_iE_Extensions__item__criticality._const_tab = ____RequestedDataValue_iE_Extensions__item__id_tab
    ___RequestedDataValue_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestedDataValue_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestedDataValue_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RequestedDataValue_iE_Extensions__item__extensionValue._const_tab = ____RequestedDataValue_iE_Extensions__item__id_tab
    ___RequestedDataValue_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestedDataValue_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestedDataValue_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestedDataValue_iE_Extensions__item__id),
        ('criticality', ___RequestedDataValue_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestedDataValue_iE_Extensions__item__extensionValue),
        ])
    __RequestedDataValue_iE_Extensions__item_._ext = None
    _RequestedDataValue_iE_Extensions._cont = __RequestedDataValue_iE_Extensions__item_
    _RequestedDataValue_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestedDataValue._cont = ASN1Dict([
        ('gpsAlmanacAndSatelliteHealth', _RequestedDataValue_gpsAlmanacAndSatelliteHealth),
        ('gps-UTC-Model', _RequestedDataValue_gps_UTC_Model),
        ('gps-Ionospheric-Model', _RequestedDataValue_gps_Ionospheric_Model),
        ('gps-NavigationModel', _RequestedDataValue_gps_NavigationModel),
        ('dgpsCorrections', _RequestedDataValue_dgpsCorrections),
        ('referenceTime', _RequestedDataValue_referenceTime),
        ('gps-AcquisitionAssistance', _RequestedDataValue_gps_AcquisitionAssistance),
        ('gps-RealTime-Integrity', _RequestedDataValue_gps_RealTime_Integrity),
        ('almanacAndSatelliteHealthSIB', _RequestedDataValue_almanacAndSatelliteHealthSIB),
        ('gps-Transmission-TOW', _RequestedDataValue_gps_Transmission_TOW),
        ('iE-Extensions', _RequestedDataValue_iE_Extensions),
        ])
    RequestedDataValue._ext = []
    
    #-----< RequestedDataValue-ExtIEs >-----#
    RequestedDataValue_ExtIEs = CLASS(name='RequestedDataValue-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _RequestedDataValue_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-ReferenceLocation')))
    _RequestedDataValue_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-CommonAssistanceData')))
    _RequestedDataValue_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-GenericAssistanceDataList')))
    RequestedDataValue_ExtIEs._val = ASN1Set(rv=[dict([('id', 50), ('criticality', 'ignore'), ('Extension', _RequestedDataValue_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 69), ('criticality', 'ignore'), ('Extension', _RequestedDataValue_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 70), ('criticality', 'ignore'), ('Extension', _RequestedDataValue_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RequestedDataValueInformation >-----#
    RequestedDataValueInformation = CHOICE(name='RequestedDataValueInformation', mode=MODE_TYPE)
    _RequestedDataValueInformation_informationAvailable = SEQ(name='informationAvailable', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'InformationAvailable')))
    _RequestedDataValueInformation_informationNotAvailable = NULL(name='informationNotAvailable', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'InformationNotAvailable')))
    RequestedDataValueInformation._cont = ASN1Dict([
        ('informationAvailable', _RequestedDataValueInformation_informationAvailable),
        ('informationNotAvailable', _RequestedDataValueInformation_informationNotAvailable),
        ])
    RequestedDataValueInformation._ext = None
    
    #-----< InformationAvailable >-----#
    InformationAvailable = SEQ(name='InformationAvailable', mode=MODE_TYPE)
    _InformationAvailable_requestedDataValue = SEQ(name='requestedDataValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RequestedDataValue')))
    _InformationAvailable_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationAvailable_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___InformationAvailable_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationAvailable_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationAvailable_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationAvailable_iE_Extensions__item__id._const_tab = ____InformationAvailable_iE_Extensions__item__id_tab
    ___InformationAvailable_iE_Extensions__item__id._const_tab_at = None
    ___InformationAvailable_iE_Extensions__item__id._const_tab_id = 'id'
    ___InformationAvailable_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationAvailable_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationAvailable_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationAvailable_iE_Extensions__item__criticality._const_tab = ____InformationAvailable_iE_Extensions__item__criticality_tab
    ___InformationAvailable_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationAvailable_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InformationAvailable_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationAvailable_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationAvailable_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationAvailable_iE_Extensions__item__extensionValue._const_tab = ____InformationAvailable_iE_Extensions__item__extensionValue_tab
    ___InformationAvailable_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationAvailable_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationAvailable_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___InformationAvailable_iE_Extensions__item__id),
        ('criticality', ___InformationAvailable_iE_Extensions__item__criticality),
        ('extensionValue', ___InformationAvailable_iE_Extensions__item__extensionValue),
        ])
    __InformationAvailable_iE_Extensions__item_._ext = None
    _InformationAvailable_iE_Extensions._cont = __InformationAvailable_iE_Extensions__item_
    _InformationAvailable_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationAvailable._cont = ASN1Dict([
        ('requestedDataValue', _InformationAvailable_requestedDataValue),
        ('iE-Extensions', _InformationAvailable_iE_Extensions),
        ])
    InformationAvailable._ext = []
    
    #-----< InformationAvailable-ExtIEs >-----#
    InformationAvailable_ExtIEs = CLASS(name='InformationAvailable-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    InformationAvailable_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationNotAvailable >-----#
    InformationNotAvailable = NULL(name='InformationNotAvailable', mode=MODE_TYPE)
    
    #-----< RequestType >-----#
    RequestType = SEQ(name='RequestType', mode=MODE_TYPE)
    _RequestType_event = ENUM(name='event', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RequestTypeEvent')))
    _RequestType_reportArea = ENUM(name='reportArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RequestTypeReportArea')))
    _RequestType_horizontalaccuracyCode = INT(name='horizontalaccuracyCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RequestTypeAccuracyCode')), opt=True)
    _RequestType_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RequestType_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RequestType_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RequestType_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RequestType_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestType_iE_Extensions__item__id._const_tab = ____RequestType_iE_Extensions__item__id_tab
    ___RequestType_iE_Extensions__item__id._const_tab_at = None
    ___RequestType_iE_Extensions__item__id._const_tab_id = 'id'
    ___RequestType_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RequestType_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RequestType_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestType_iE_Extensions__item__criticality._const_tab = ____RequestType_iE_Extensions__item__criticality_tab
    ___RequestType_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RequestType_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RequestType_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RequestType_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RequestType_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RequestType_iE_Extensions__item__extensionValue._const_tab = ____RequestType_iE_Extensions__item__extensionValue_tab
    ___RequestType_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RequestType_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RequestType_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RequestType_iE_Extensions__item__id),
        ('criticality', ___RequestType_iE_Extensions__item__criticality),
        ('extensionValue', ___RequestType_iE_Extensions__item__extensionValue),
        ])
    __RequestType_iE_Extensions__item_._ext = None
    _RequestType_iE_Extensions._cont = __RequestType_iE_Extensions__item_
    _RequestType_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RequestType._cont = ASN1Dict([
        ('event', _RequestType_event),
        ('reportArea', _RequestType_reportArea),
        ('horizontalaccuracyCode', _RequestType_horizontalaccuracyCode),
        ('iE-Extensions', _RequestType_iE_Extensions),
        ])
    RequestType._ext = []
    
    #-----< RequestType-ExtIEs >-----#
    RequestType_ExtIEs = CLASS(name='RequestType-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RequestType_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestTypeEvent >-----#
    RequestTypeEvent = ENUM(name='RequestTypeEvent', mode=MODE_TYPE)
    RequestTypeEvent._cont = ASN1Dict([('stop-change-of-service-area', 0), ('direct', 1), ('change-of-service-area', 2), ('stop-direct', 3), ('periodic', 4), ('stop-periodic', 5)])
    RequestTypeEvent._ext = ['periodic', 'stop-periodic']
    
    #-----< RequestTypeReportArea >-----#
    RequestTypeReportArea = ENUM(name='RequestTypeReportArea', mode=MODE_TYPE)
    RequestTypeReportArea._cont = ASN1Dict([('service-area', 0), ('geographical-area', 1)])
    RequestTypeReportArea._ext = []
    
    #-----< RequestTypeAccuracyCode >-----#
    RequestTypeAccuracyCode = INT(name='RequestTypeAccuracyCode', mode=MODE_TYPE)
    RequestTypeAccuracyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< ResponseTime >-----#
    ResponseTime = ENUM(name='ResponseTime', mode=MODE_TYPE)
    ResponseTime._cont = ASN1Dict([('low-delay', 0), ('delay-tolerant', 1)])
    ResponseTime._ext = []
    
    #-----< HorizontalAccuracyCode >-----#
    HorizontalAccuracyCode = INT(name='HorizontalAccuracyCode', mode=MODE_TYPE)
    HorizontalAccuracyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< UE-PositioningCapability >-----#
    UE_PositioningCapability = SEQ(name='UE-PositioningCapability', mode=MODE_TYPE)
    _UE_PositioningCapability_standAloneLocationMethodsSupported = BOOL(name='standAloneLocationMethodsSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_PositioningCapability_ueBasedOTDOASupported = BOOL(name='ueBasedOTDOASupported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_PositioningCapability_networkAssistedGPSSupport = ENUM(name='networkAssistedGPSSupport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NetworkAssistedGPSSuport')))
    _UE_PositioningCapability_supportGPSTimingOfCellFrame = BOOL(name='supportGPSTimingOfCellFrame', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_PositioningCapability_supportForIPDL = BOOL(name='supportForIPDL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_PositioningCapability_supportForRxTxTimeDiff = BOOL(name='supportForRxTxTimeDiff', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_PositioningCapability_supportForUEAGPSinCellPCH = BOOL(name='supportForUEAGPSinCellPCH', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_PositioningCapability_supportForSFNSFNTimeDiff = BOOL(name='supportForSFNSFNTimeDiff', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_PositioningCapability_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_PositioningCapability_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UE_PositioningCapability_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_PositioningCapability_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UE_PositioningCapability_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'NetworkAssistedGANSSSupport')))
    _____UE_PositioningCapability_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddPosSupport')))
    ____UE_PositioningCapability_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 76), ('criticality', 'ignore'), ('Extension', _____UE_PositioningCapability_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'ignore'), ('Extension', _____UE_PositioningCapability_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UE_PositioningCapability_iE_Extensions__item__id._const_tab = ____UE_PositioningCapability_iE_Extensions__item__id_tab
    ___UE_PositioningCapability_iE_Extensions__item__id._const_tab_at = None
    ___UE_PositioningCapability_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_PositioningCapability_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UE_PositioningCapability_iE_Extensions__item__criticality._const_tab = ____UE_PositioningCapability_iE_Extensions__item__id_tab
    ___UE_PositioningCapability_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_PositioningCapability_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_PositioningCapability_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UE_PositioningCapability_iE_Extensions__item__extensionValue._const_tab = ____UE_PositioningCapability_iE_Extensions__item__id_tab
    ___UE_PositioningCapability_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_PositioningCapability_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_PositioningCapability_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_PositioningCapability_iE_Extensions__item__id),
        ('criticality', ___UE_PositioningCapability_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_PositioningCapability_iE_Extensions__item__extensionValue),
        ])
    __UE_PositioningCapability_iE_Extensions__item_._ext = None
    _UE_PositioningCapability_iE_Extensions._cont = __UE_PositioningCapability_iE_Extensions__item_
    _UE_PositioningCapability_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_PositioningCapability._cont = ASN1Dict([
        ('standAloneLocationMethodsSupported', _UE_PositioningCapability_standAloneLocationMethodsSupported),
        ('ueBasedOTDOASupported', _UE_PositioningCapability_ueBasedOTDOASupported),
        ('networkAssistedGPSSupport', _UE_PositioningCapability_networkAssistedGPSSupport),
        ('supportGPSTimingOfCellFrame', _UE_PositioningCapability_supportGPSTimingOfCellFrame),
        ('supportForIPDL', _UE_PositioningCapability_supportForIPDL),
        ('supportForRxTxTimeDiff', _UE_PositioningCapability_supportForRxTxTimeDiff),
        ('supportForUEAGPSinCellPCH', _UE_PositioningCapability_supportForUEAGPSinCellPCH),
        ('supportForSFNSFNTimeDiff', _UE_PositioningCapability_supportForSFNSFNTimeDiff),
        ('iE-Extensions', _UE_PositioningCapability_iE_Extensions),
        ])
    UE_PositioningCapability._ext = []
    
    #-----< UE-PositioningCapability-ExtIEs >-----#
    UE_PositioningCapability_ExtIEs = CLASS(name='UE-PositioningCapability-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _UE_PositioningCapability_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'NetworkAssistedGANSSSupport')))
    _UE_PositioningCapability_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddPosSupport')))
    UE_PositioningCapability_ExtIEs._val = ASN1Set(rv=[dict([('id', 76), ('criticality', 'ignore'), ('Extension', _UE_PositioningCapability_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'ignore'), ('Extension', _UE_PositioningCapability_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NetworkAssistedGANSSSupport >-----#
    NetworkAssistedGANSSSupport = SEQ_OF(name='NetworkAssistedGANSSSupport', mode=MODE_TYPE)
    _NetworkAssistedGANSSSupport__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __NetworkAssistedGANSSSupport__item__ganssID = SEQ(name='ganssID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    __NetworkAssistedGANSSSupport__item__ganssMode = ENUM(name='ganssMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NetworkAssistedGANSSSupport__item__ganssMode._cont = ASN1Dict([('networkBased', 0), ('ue-Based', 1), ('both', 2), ('none', 3)])
    __NetworkAssistedGANSSSupport__item__ganssMode._ext = None
    __NetworkAssistedGANSSSupport__item__ganssSignalID = SEQ(name='ganssSignalID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SignalID')), opt=True)
    __NetworkAssistedGANSSSupport__item__supportGANSSTimingOfCellFrame = BOOL(name='supportGANSSTimingOfCellFrame', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NetworkAssistedGANSSSupport__item__supportGANSSCarrierPhaseMeasurement = BOOL(name='supportGANSSCarrierPhaseMeasurement', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __NetworkAssistedGANSSSupport__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___NetworkAssistedGANSSSupport__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ______NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SBAS-IDs')))
    ______NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Signal-IDs')))
    ______NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab_val_Extension_2 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'SupportGANSSNonNativeADchoices')))
    _____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 95), ('criticality', 'ignore'), ('Extension', ______NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', ______NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'ignore'), ('Extension', ______NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id._const_tab = _____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id._const_tab_at = None
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__criticality._const_tab = _____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__extensionValue._const_tab = _____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___NetworkAssistedGANSSSupport__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id),
        ('criticality', ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__criticality),
        ('extensionValue', ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__extensionValue),
        ])
    ___NetworkAssistedGANSSSupport__item__iE_Extensions__item_._ext = None
    __NetworkAssistedGANSSSupport__item__iE_Extensions._cont = ___NetworkAssistedGANSSSupport__item__iE_Extensions__item_
    __NetworkAssistedGANSSSupport__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _NetworkAssistedGANSSSupport__item_._cont = ASN1Dict([
        ('ganssID', __NetworkAssistedGANSSSupport__item__ganssID),
        ('ganssMode', __NetworkAssistedGANSSSupport__item__ganssMode),
        ('ganssSignalID', __NetworkAssistedGANSSSupport__item__ganssSignalID),
        ('supportGANSSTimingOfCellFrame', __NetworkAssistedGANSSSupport__item__supportGANSSTimingOfCellFrame),
        ('supportGANSSCarrierPhaseMeasurement', __NetworkAssistedGANSSSupport__item__supportGANSSCarrierPhaseMeasurement),
        ('iE-Extensions', __NetworkAssistedGANSSSupport__item__iE_Extensions),
        ])
    _NetworkAssistedGANSSSupport__item_._ext = []
    NetworkAssistedGANSSSupport._cont = _NetworkAssistedGANSSSupport__item_
    NetworkAssistedGANSSSupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AddPosSupport >-----#
    AddPosSupport = SEQ_OF(name='AddPosSupport', mode=MODE_TYPE)
    _AddPosSupport__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddPosSupport-Element')))
    AddPosSupport._cont = _AddPosSupport__item_
    AddPosSupport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< AddPosSupport-Element >-----#
    AddPosSupport_Element = SEQ(name='AddPosSupport-Element', mode=MODE_TYPE)
    _AddPosSupport_Element_addPosID = ENUM(name='addPosID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AddPosSupport_Element_addPosID._cont = ASN1Dict([('barometricPressure', 0), ('wLAN', 1), ('bluetooth', 2), ('mBS', 3)])
    _AddPosSupport_Element_addPosID._ext = []
    _AddPosSupport_Element_addPosMode = ENUM(name='addPosMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AddPosSupport_Element_addPosMode._cont = ASN1Dict([('standalone', 0), ('ue-assisted', 1), ('both', 2)])
    _AddPosSupport_Element_addPosMode._ext = []
    AddPosSupport_Element._cont = ASN1Dict([
        ('addPosID', _AddPosSupport_Element_addPosID),
        ('addPosMode', _AddPosSupport_Element_addPosMode),
        ])
    AddPosSupport_Element._ext = []
    
    #-----< NetworkAssistedGANSSSuport-ExtIEs >-----#
    NetworkAssistedGANSSSuport_ExtIEs = CLASS(name='NetworkAssistedGANSSSuport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _NetworkAssistedGANSSSuport_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-SBAS-IDs')))
    _NetworkAssistedGANSSSuport_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-Signal-IDs')))
    _NetworkAssistedGANSSSuport_ExtIEs_val_Extension_2 = BOOL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'SupportGANSSNonNativeADchoices')))
    NetworkAssistedGANSSSuport_ExtIEs._val = ASN1Set(rv=[dict([('id', 95), ('criticality', 'ignore'), ('Extension', _NetworkAssistedGANSSSuport_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _NetworkAssistedGANSSSuport_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 97), ('criticality', 'ignore'), ('Extension', _NetworkAssistedGANSSSuport_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< NetworkAssistedGPSSuport >-----#
    NetworkAssistedGPSSuport = ENUM(name='NetworkAssistedGPSSuport', mode=MODE_TYPE)
    NetworkAssistedGPSSuport._cont = ASN1Dict([('network-based', 0), ('ue-based', 1), ('both', 2), ('none', 3)])
    NetworkAssistedGPSSuport._ext = []
    
    #-----< GANSS-SBAS-IDs >-----#
    GANSS_SBAS_IDs = SEQ(name='GANSS-SBAS-IDs', mode=MODE_TYPE)
    _GANSS_SBAS_IDs_ganss_sbas_ids = BIT_STR(name='ganss-sbas-ids', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_SBAS_IDs_ganss_sbas_ids._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_SBAS_IDs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_SBAS_IDs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_SBAS_IDs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_SBAS_IDs_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SBAS_IDs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SBAS_IDs_iE_Extensions__item__id._const_tab = ____GANSS_SBAS_IDs_iE_Extensions__item__id_tab
    ___GANSS_SBAS_IDs_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_SBAS_IDs_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_SBAS_IDs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_SBAS_IDs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SBAS_IDs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SBAS_IDs_iE_Extensions__item__criticality._const_tab = ____GANSS_SBAS_IDs_iE_Extensions__item__criticality_tab
    ___GANSS_SBAS_IDs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_SBAS_IDs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_SBAS_IDs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_SBAS_IDs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_SBAS_IDs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_SBAS_IDs_iE_Extensions__item__extensionValue._const_tab = ____GANSS_SBAS_IDs_iE_Extensions__item__extensionValue_tab
    ___GANSS_SBAS_IDs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_SBAS_IDs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_SBAS_IDs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_SBAS_IDs_iE_Extensions__item__id),
        ('criticality', ___GANSS_SBAS_IDs_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_SBAS_IDs_iE_Extensions__item__extensionValue),
        ])
    __GANSS_SBAS_IDs_iE_Extensions__item_._ext = None
    _GANSS_SBAS_IDs_iE_Extensions._cont = __GANSS_SBAS_IDs_iE_Extensions__item_
    _GANSS_SBAS_IDs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_SBAS_IDs._cont = ASN1Dict([
        ('ganss-sbas-ids', _GANSS_SBAS_IDs_ganss_sbas_ids),
        ('iE-Extensions', _GANSS_SBAS_IDs_iE_Extensions),
        ])
    GANSS_SBAS_IDs._ext = []
    
    #-----< GANSS-SBAS-IDs-ExtIEs >-----#
    GANSS_SBAS_IDs_ExtIEs = CLASS(name='GANSS-SBAS-IDs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_SBAS_IDs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-Signal-IDs >-----#
    GANSS_Signal_IDs = SEQ(name='GANSS-Signal-IDs', mode=MODE_TYPE)
    _GANSS_Signal_IDs_ganss_signal_ids = BIT_STR(name='ganss-signal-ids', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_Signal_IDs_ganss_signal_ids._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_Signal_IDs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_Signal_IDs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_Signal_IDs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_Signal_IDs_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Signal_IDs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Signal_IDs_iE_Extensions__item__id._const_tab = ____GANSS_Signal_IDs_iE_Extensions__item__id_tab
    ___GANSS_Signal_IDs_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_Signal_IDs_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_Signal_IDs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSS_Signal_IDs_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Signal_IDs_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Signal_IDs_iE_Extensions__item__criticality._const_tab = ____GANSS_Signal_IDs_iE_Extensions__item__criticality_tab
    ___GANSS_Signal_IDs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_Signal_IDs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_Signal_IDs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSS_Signal_IDs_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSS_Signal_IDs_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSS_Signal_IDs_iE_Extensions__item__extensionValue._const_tab = ____GANSS_Signal_IDs_iE_Extensions__item__extensionValue_tab
    ___GANSS_Signal_IDs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_Signal_IDs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_Signal_IDs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_Signal_IDs_iE_Extensions__item__id),
        ('criticality', ___GANSS_Signal_IDs_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_Signal_IDs_iE_Extensions__item__extensionValue),
        ])
    __GANSS_Signal_IDs_iE_Extensions__item_._ext = None
    _GANSS_Signal_IDs_iE_Extensions._cont = __GANSS_Signal_IDs_iE_Extensions__item_
    _GANSS_Signal_IDs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_Signal_IDs._cont = ASN1Dict([
        ('ganss-signal-ids', _GANSS_Signal_IDs_ganss_signal_ids),
        ('iE-Extensions', _GANSS_Signal_IDs_iE_Extensions),
        ])
    GANSS_Signal_IDs._ext = []
    
    #-----< GANSS-Signal-IDs-ExtIEs >-----#
    GANSS_Signal_IDs_ExtIEs = CLASS(name='GANSS-Signal-IDs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSS_Signal_IDs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SupportGANSSNonNativeADchoices >-----#
    SupportGANSSNonNativeADchoices = BOOL(name='SupportGANSSNonNativeADchoices', mode=MODE_TYPE)
    
    #-----< UTDOAPositioning >-----#
    UTDOAPositioning = SEQ(name='UTDOAPositioning', mode=MODE_TYPE)
    _UTDOAPositioning_utdoa_BitCount = INT(name='utdoa-BitCount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-BitCount')))
    _UTDOAPositioning_utdoa_timeInterval = INT(name='utdoa-timeInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-TimeInterval')))
    _UTDOAPositioning_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTDOAPositioning_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTDOAPositioning_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTDOAPositioning_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOAPositioning_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOAPositioning_iE_Extensions__item__id._const_tab = ____UTDOAPositioning_iE_Extensions__item__id_tab
    ___UTDOAPositioning_iE_Extensions__item__id._const_tab_at = None
    ___UTDOAPositioning_iE_Extensions__item__id._const_tab_id = 'id'
    ___UTDOAPositioning_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTDOAPositioning_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOAPositioning_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOAPositioning_iE_Extensions__item__criticality._const_tab = ____UTDOAPositioning_iE_Extensions__item__criticality_tab
    ___UTDOAPositioning_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTDOAPositioning_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTDOAPositioning_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTDOAPositioning_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOAPositioning_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOAPositioning_iE_Extensions__item__extensionValue._const_tab = ____UTDOAPositioning_iE_Extensions__item__extensionValue_tab
    ___UTDOAPositioning_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTDOAPositioning_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTDOAPositioning_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTDOAPositioning_iE_Extensions__item__id),
        ('criticality', ___UTDOAPositioning_iE_Extensions__item__criticality),
        ('extensionValue', ___UTDOAPositioning_iE_Extensions__item__extensionValue),
        ])
    __UTDOAPositioning_iE_Extensions__item_._ext = None
    _UTDOAPositioning_iE_Extensions._cont = __UTDOAPositioning_iE_Extensions__item_
    _UTDOAPositioning_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTDOAPositioning._cont = ASN1Dict([
        ('utdoa-BitCount', _UTDOAPositioning_utdoa_BitCount),
        ('utdoa-timeInterval', _UTDOAPositioning_utdoa_timeInterval),
        ('iE-Extensions', _UTDOAPositioning_iE_Extensions),
        ])
    UTDOAPositioning._ext = []
    
    #-----< UTDOAPositioning-ExtIEs >-----#
    UTDOAPositioning_ExtIEs = CLASS(name='UTDOAPositioning-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTDOAPositioning_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTDOA-BitCount >-----#
    UTDOA_BitCount = INT(name='UTDOA-BitCount', mode=MODE_TYPE)
    UTDOA_BitCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5000)], ev=None, er=[])
    
    #-----< UTDOA-TimeInterval >-----#
    UTDOA_TimeInterval = INT(name='UTDOA-TimeInterval', mode=MODE_TYPE)
    UTDOA_TimeInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3000)], ev=None, er=[])
    
    #-----< EnvironmentCharacterisation >-----#
    EnvironmentCharacterisation = ENUM(name='EnvironmentCharacterisation', mode=MODE_TYPE)
    EnvironmentCharacterisation._cont = ASN1Dict([('heavyMultipathandNLOSconditions', 0), ('noOrLightMultipathAndUsuallyLOSconditions', 1), ('notDefinedOrMixedEnvironment', 2)])
    EnvironmentCharacterisation._ext = []
    
    #-----< GPSPositioning >-----#
    GPSPositioning = SEQ(name='GPSPositioning', mode=MODE_TYPE)
    _GPSPositioning_gpsPositioningInstructions = SEQ(name='gpsPositioningInstructions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GPSPositioningInstructions')))
    _GPSPositioning_requestedDataValue = SEQ(name='requestedDataValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RequestedDataValue')), opt=True)
    _GPSPositioning_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPSPositioning_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPSPositioning_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPSPositioning_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPSPositioning_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPSPositioning_iE_Extensions__item__id._const_tab = ____GPSPositioning_iE_Extensions__item__id_tab
    ___GPSPositioning_iE_Extensions__item__id._const_tab_at = None
    ___GPSPositioning_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPSPositioning_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GPSPositioning_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPSPositioning_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPSPositioning_iE_Extensions__item__criticality._const_tab = ____GPSPositioning_iE_Extensions__item__criticality_tab
    ___GPSPositioning_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPSPositioning_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPSPositioning_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GPSPositioning_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GPSPositioning_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GPSPositioning_iE_Extensions__item__extensionValue._const_tab = ____GPSPositioning_iE_Extensions__item__extensionValue_tab
    ___GPSPositioning_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPSPositioning_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPSPositioning_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPSPositioning_iE_Extensions__item__id),
        ('criticality', ___GPSPositioning_iE_Extensions__item__criticality),
        ('extensionValue', ___GPSPositioning_iE_Extensions__item__extensionValue),
        ])
    __GPSPositioning_iE_Extensions__item_._ext = None
    _GPSPositioning_iE_Extensions._cont = __GPSPositioning_iE_Extensions__item_
    _GPSPositioning_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPSPositioning._cont = ASN1Dict([
        ('gpsPositioningInstructions', _GPSPositioning_gpsPositioningInstructions),
        ('requestedDataValue', _GPSPositioning_requestedDataValue),
        ('iE-Extensions', _GPSPositioning_iE_Extensions),
        ])
    GPSPositioning._ext = []
    
    #-----< GPSPositioning-ExtIEs >-----#
    GPSPositioning_ExtIEs = CLASS(name='GPSPositioning-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GPSPositioning_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GPSPositioningInstructions >-----#
    GPSPositioningInstructions = SEQ(name='GPSPositioningInstructions', mode=MODE_TYPE)
    _GPSPositioningInstructions_horizontalAccuracyCode = INT(name='horizontalAccuracyCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'HorizontalAccuracyCode')), opt=True)
    _GPSPositioningInstructions_verticalAccuracyCode = INT(name='verticalAccuracyCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'VerticalAccuracyCode')), opt=True)
    _GPSPositioningInstructions_gpsTimingOfCellWanted = BOOL(name='gpsTimingOfCellWanted', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPSPositioningInstructions_additionalAssistanceDataRequest = BOOL(name='additionalAssistanceDataRequest', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPSPositioningInstructions_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GPSPositioningInstructions_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GPSPositioningInstructions_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GPSPositioningInstructions_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GPSPositioningInstructions_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MeasurementValidity')))
    ____GPSPositioningInstructions_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 63), ('criticality', 'ignore'), ('Extension', _____GPSPositioningInstructions_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GPSPositioningInstructions_iE_Extensions__item__id._const_tab = ____GPSPositioningInstructions_iE_Extensions__item__id_tab
    ___GPSPositioningInstructions_iE_Extensions__item__id._const_tab_at = None
    ___GPSPositioningInstructions_iE_Extensions__item__id._const_tab_id = 'id'
    ___GPSPositioningInstructions_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GPSPositioningInstructions_iE_Extensions__item__criticality._const_tab = ____GPSPositioningInstructions_iE_Extensions__item__id_tab
    ___GPSPositioningInstructions_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GPSPositioningInstructions_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GPSPositioningInstructions_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GPSPositioningInstructions_iE_Extensions__item__extensionValue._const_tab = ____GPSPositioningInstructions_iE_Extensions__item__id_tab
    ___GPSPositioningInstructions_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GPSPositioningInstructions_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GPSPositioningInstructions_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GPSPositioningInstructions_iE_Extensions__item__id),
        ('criticality', ___GPSPositioningInstructions_iE_Extensions__item__criticality),
        ('extensionValue', ___GPSPositioningInstructions_iE_Extensions__item__extensionValue),
        ])
    __GPSPositioningInstructions_iE_Extensions__item_._ext = None
    _GPSPositioningInstructions_iE_Extensions._cont = __GPSPositioningInstructions_iE_Extensions__item_
    _GPSPositioningInstructions_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GPSPositioningInstructions._cont = ASN1Dict([
        ('horizontalAccuracyCode', _GPSPositioningInstructions_horizontalAccuracyCode),
        ('verticalAccuracyCode', _GPSPositioningInstructions_verticalAccuracyCode),
        ('gpsTimingOfCellWanted', _GPSPositioningInstructions_gpsTimingOfCellWanted),
        ('additionalAssistanceDataRequest', _GPSPositioningInstructions_additionalAssistanceDataRequest),
        ('iE-Extensions', _GPSPositioningInstructions_iE_Extensions),
        ])
    GPSPositioningInstructions._ext = []
    
    #-----< GPSPositioningInstructions-ExtIEs >-----#
    GPSPositioningInstructions_ExtIEs = CLASS(name='GPSPositioningInstructions-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GPSPositioningInstructions_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MeasurementValidity')))
    GPSPositioningInstructions_ExtIEs._val = ASN1Set(rv=[dict([('id', 63), ('criticality', 'ignore'), ('Extension', _GPSPositioningInstructions_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSSPositioning >-----#
    GANSSPositioning = SEQ(name='GANSSPositioning', mode=MODE_TYPE)
    _GANSSPositioning_ganssPositioningInstructions = SEQ(name='ganssPositioningInstructions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSS-PositioningInstructions')))
    _GANSSPositioning_requestedDataValue = SEQ(name='requestedDataValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RequestedDataValue')), opt=True)
    _GANSSPositioning_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSSPositioning_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSSPositioning_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSSPositioning_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSSPositioning_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSSPositioning_iE_Extensions__item__id._const_tab = ____GANSSPositioning_iE_Extensions__item__id_tab
    ___GANSSPositioning_iE_Extensions__item__id._const_tab_at = None
    ___GANSSPositioning_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSSPositioning_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GANSSPositioning_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSSPositioning_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSSPositioning_iE_Extensions__item__criticality._const_tab = ____GANSSPositioning_iE_Extensions__item__criticality_tab
    ___GANSSPositioning_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSSPositioning_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSSPositioning_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GANSSPositioning_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____GANSSPositioning_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GANSSPositioning_iE_Extensions__item__extensionValue._const_tab = ____GANSSPositioning_iE_Extensions__item__extensionValue_tab
    ___GANSSPositioning_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSSPositioning_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSSPositioning_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSSPositioning_iE_Extensions__item__id),
        ('criticality', ___GANSSPositioning_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSSPositioning_iE_Extensions__item__extensionValue),
        ])
    __GANSSPositioning_iE_Extensions__item_._ext = None
    _GANSSPositioning_iE_Extensions._cont = __GANSSPositioning_iE_Extensions__item_
    _GANSSPositioning_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSSPositioning._cont = ASN1Dict([
        ('ganssPositioningInstructions', _GANSSPositioning_ganssPositioningInstructions),
        ('requestedDataValue', _GANSSPositioning_requestedDataValue),
        ('iE-Extensions', _GANSSPositioning_iE_Extensions),
        ])
    GANSSPositioning._ext = []
    
    #-----< GANSSPositioning-ExtIEs >-----#
    GANSSPositioning_ExtIEs = CLASS(name='GANSSPositioning-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    GANSSPositioning_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GANSS-PositioningInstructions >-----#
    GANSS_PositioningInstructions = SEQ(name='GANSS-PositioningInstructions', mode=MODE_TYPE)
    _GANSS_PositioningInstructions_horizontalAccuracyCode = INT(name='horizontalAccuracyCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'HorizontalAccuracyCode')), opt=True)
    _GANSS_PositioningInstructions_verticalAccuracyCode = INT(name='verticalAccuracyCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'VerticalAccuracyCode')), opt=True)
    _GANSS_PositioningInstructions_ganssTimingOfCellWanted = BIT_STR(name='ganssTimingOfCellWanted', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_PositioningInstructions_ganssTimingOfCellWanted._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_PositioningInstructions_additionalAssistanceDataRequest = BIT_STR(name='additionalAssistanceDataRequest', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSS_PositioningInstructions_additionalAssistanceDataRequest._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _GANSS_PositioningInstructions_measurementValidity = SEQ(name='measurementValidity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MeasurementValidity')), opt=True)
    _GANSS_PositioningInstructions_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GANSS_PositioningInstructions_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___GANSS_PositioningInstructions_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____GANSS_PositioningInstructions_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____GANSS_PositioningInstructions_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSScarrierPhaseRequested')))
    _____GANSS_PositioningInstructions_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSSMultiFreqMeasRequested')))
    ____GANSS_PositioningInstructions_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 101), ('criticality', 'ignore'), ('Extension', _____GANSS_PositioningInstructions_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'ignore'), ('Extension', _____GANSS_PositioningInstructions_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___GANSS_PositioningInstructions_iE_Extensions__item__id._const_tab = ____GANSS_PositioningInstructions_iE_Extensions__item__id_tab
    ___GANSS_PositioningInstructions_iE_Extensions__item__id._const_tab_at = None
    ___GANSS_PositioningInstructions_iE_Extensions__item__id._const_tab_id = 'id'
    ___GANSS_PositioningInstructions_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___GANSS_PositioningInstructions_iE_Extensions__item__criticality._const_tab = ____GANSS_PositioningInstructions_iE_Extensions__item__id_tab
    ___GANSS_PositioningInstructions_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GANSS_PositioningInstructions_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GANSS_PositioningInstructions_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___GANSS_PositioningInstructions_iE_Extensions__item__extensionValue._const_tab = ____GANSS_PositioningInstructions_iE_Extensions__item__id_tab
    ___GANSS_PositioningInstructions_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GANSS_PositioningInstructions_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GANSS_PositioningInstructions_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GANSS_PositioningInstructions_iE_Extensions__item__id),
        ('criticality', ___GANSS_PositioningInstructions_iE_Extensions__item__criticality),
        ('extensionValue', ___GANSS_PositioningInstructions_iE_Extensions__item__extensionValue),
        ])
    __GANSS_PositioningInstructions_iE_Extensions__item_._ext = None
    _GANSS_PositioningInstructions_iE_Extensions._cont = __GANSS_PositioningInstructions_iE_Extensions__item_
    _GANSS_PositioningInstructions_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GANSS_PositioningInstructions._cont = ASN1Dict([
        ('horizontalAccuracyCode', _GANSS_PositioningInstructions_horizontalAccuracyCode),
        ('verticalAccuracyCode', _GANSS_PositioningInstructions_verticalAccuracyCode),
        ('ganssTimingOfCellWanted', _GANSS_PositioningInstructions_ganssTimingOfCellWanted),
        ('additionalAssistanceDataRequest', _GANSS_PositioningInstructions_additionalAssistanceDataRequest),
        ('measurementValidity', _GANSS_PositioningInstructions_measurementValidity),
        ('iE-Extensions', _GANSS_PositioningInstructions_iE_Extensions),
        ])
    GANSS_PositioningInstructions._ext = []
    
    #-----< GANSS-PositioningInstructions-ExtIEs >-----#
    GANSS_PositioningInstructions_ExtIEs = CLASS(name='GANSS-PositioningInstructions-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _GANSS_PositioningInstructions_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSScarrierPhaseRequested')))
    _GANSS_PositioningInstructions_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSSMultiFreqMeasRequested')))
    GANSS_PositioningInstructions_ExtIEs._val = ASN1Set(rv=[dict([('id', 101), ('criticality', 'ignore'), ('Extension', _GANSS_PositioningInstructions_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 102), ('criticality', 'ignore'), ('Extension', _GANSS_PositioningInstructions_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GANSScarrierPhaseRequested >-----#
    GANSScarrierPhaseRequested = BIT_STR(name='GANSScarrierPhaseRequested', mode=MODE_TYPE)
    GANSScarrierPhaseRequested._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< GANSSMultiFreqMeasRequested >-----#
    GANSSMultiFreqMeasRequested = BIT_STR(name='GANSSMultiFreqMeasRequested', mode=MODE_TYPE)
    GANSSMultiFreqMeasRequested._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< OTDOAAssistanceData >-----#
    OTDOAAssistanceData = SEQ(name='OTDOAAssistanceData', mode=MODE_TYPE)
    _OTDOAAssistanceData_uE_Positioning_OTDOA_AssistanceData = SEQ(name='uE-Positioning-OTDOA-AssistanceData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-Positioning-OTDOA-AssistanceData')))
    _OTDOAAssistanceData_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __OTDOAAssistanceData_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___OTDOAAssistanceData_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____OTDOAAssistanceData_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOAAssistanceData_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOAAssistanceData_iE_Extensions__item__id._const_tab = ____OTDOAAssistanceData_iE_Extensions__item__id_tab
    ___OTDOAAssistanceData_iE_Extensions__item__id._const_tab_at = None
    ___OTDOAAssistanceData_iE_Extensions__item__id._const_tab_id = 'id'
    ___OTDOAAssistanceData_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____OTDOAAssistanceData_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOAAssistanceData_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOAAssistanceData_iE_Extensions__item__criticality._const_tab = ____OTDOAAssistanceData_iE_Extensions__item__criticality_tab
    ___OTDOAAssistanceData_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___OTDOAAssistanceData_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___OTDOAAssistanceData_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____OTDOAAssistanceData_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____OTDOAAssistanceData_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___OTDOAAssistanceData_iE_Extensions__item__extensionValue._const_tab = ____OTDOAAssistanceData_iE_Extensions__item__extensionValue_tab
    ___OTDOAAssistanceData_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___OTDOAAssistanceData_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __OTDOAAssistanceData_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___OTDOAAssistanceData_iE_Extensions__item__id),
        ('criticality', ___OTDOAAssistanceData_iE_Extensions__item__criticality),
        ('extensionValue', ___OTDOAAssistanceData_iE_Extensions__item__extensionValue),
        ])
    __OTDOAAssistanceData_iE_Extensions__item_._ext = None
    _OTDOAAssistanceData_iE_Extensions._cont = __OTDOAAssistanceData_iE_Extensions__item_
    _OTDOAAssistanceData_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    OTDOAAssistanceData._cont = ASN1Dict([
        ('uE-Positioning-OTDOA-AssistanceData', _OTDOAAssistanceData_uE_Positioning_OTDOA_AssistanceData),
        ('iE-Extensions', _OTDOAAssistanceData_iE_Extensions),
        ])
    OTDOAAssistanceData._ext = []
    
    #-----< OTDOAAssistanceData-ExtIEs >-----#
    OTDOAAssistanceData_ExtIEs = CLASS(name='OTDOAAssistanceData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    OTDOAAssistanceData_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Positioning-OTDOA-AssistanceData >-----#
    UE_Positioning_OTDOA_AssistanceData = SEQ(name='UE-Positioning-OTDOA-AssistanceData', mode=MODE_TYPE)
    _UE_Positioning_OTDOA_AssistanceData_ue_positioning_OTDOA_ReferenceCellInfo = SEQ(name='ue-positioning-OTDOA-ReferenceCellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-Positioning-OTDOA-ReferenceCellInfo')), opt=True)
    _UE_Positioning_OTDOA_AssistanceData_ue_positioning_OTDOA_NeighbourCellList = SEQ_OF(name='ue-positioning-OTDOA-NeighbourCellList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-Positioning-OTDOA-NeighbourCellList')), opt=True)
    _UE_Positioning_OTDOA_AssistanceData_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__id._const_tab = ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__id_tab
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__id._const_tab_at = None
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__criticality._const_tab = ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__criticality_tab
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__extensionValue._const_tab = ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__extensionValue_tab
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__id),
        ('criticality', ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__extensionValue),
        ])
    __UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item_._ext = None
    _UE_Positioning_OTDOA_AssistanceData_iE_Extensions._cont = __UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item_
    _UE_Positioning_OTDOA_AssistanceData_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_Positioning_OTDOA_AssistanceData._cont = ASN1Dict([
        ('ue-positioning-OTDOA-ReferenceCellInfo', _UE_Positioning_OTDOA_AssistanceData_ue_positioning_OTDOA_ReferenceCellInfo),
        ('ue-positioning-OTDOA-NeighbourCellList', _UE_Positioning_OTDOA_AssistanceData_ue_positioning_OTDOA_NeighbourCellList),
        ('iE-Extensions', _UE_Positioning_OTDOA_AssistanceData_iE_Extensions),
        ])
    UE_Positioning_OTDOA_AssistanceData._ext = []
    
    #-----< UE-Positioning-OTDOAAssistanceData-ExtIEs >-----#
    UE_Positioning_OTDOAAssistanceData_ExtIEs = CLASS(name='UE-Positioning-OTDOAAssistanceData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UE_Positioning_OTDOAAssistanceData_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Positioning-OTDOA-ReferenceCellInfo >-----#
    UE_Positioning_OTDOA_ReferenceCellInfo = SEQ(name='UE-Positioning-OTDOA-ReferenceCellInfo', mode=MODE_TYPE)
    _UE_Positioning_OTDOA_ReferenceCellInfo_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFN')), opt=True)
    _UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_fdd_primaryCPICH_Info = INT(name='primaryCPICH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PrimaryScramblingCode')))
    __UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('primaryCPICH-Info', ___UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_fdd_primaryCPICH_Info),
        ])
    __UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_fdd._ext = []
    __UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_tdd_cellParameterID = INT(name='cellParameterID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CellParameterID')))
    __UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('cellParameterID', ___UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_tdd_cellParameterID),
        ])
    __UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_tdd._ext = []
    _UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_fdd),
        ('tdd', __UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_tdd),
        ])
    _UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo._ext = []
    _UE_Positioning_OTDOA_ReferenceCellInfo_frequencyInfo = SEQ(name='frequencyInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'FrequencyInfo')), opt=True)
    _UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode = CHOICE(name='positioningMode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased = SEQ(name='ueBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased_cellPosition = CHOICE(name='cellPosition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'ReferenceCellPosition')), opt=True)
    ___UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased_roundTripTime = INT(name='roundTripTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased_roundTripTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32766)], ev=None, er=[])
    __UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased._cont = ASN1Dict([
        ('cellPosition', ___UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased_cellPosition),
        ('roundTripTime', ___UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased_roundTripTime),
        ])
    __UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased._ext = []
    __UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueAssisted = SEQ(name='ueAssisted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueAssisted._cont = ASN1Dict([
        ])
    __UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueAssisted._ext = []
    _UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode._cont = ASN1Dict([
        ('ueBased', __UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased),
        ('ueAssisted', __UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueAssisted),
        ])
    _UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode._ext = []
    _UE_Positioning_OTDOA_ReferenceCellInfo_ue_positioning_IPDL_Paremeters = SEQ(name='ue-positioning-IPDL-Paremeters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-Positioning-IPDL-Parameters')), opt=True)
    _UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExtendedRoundTripTime')))
    _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'TimingAdvanceLCR-R7')))
    _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviationLCR')))
    _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AngleOfArrivalLCR')))
    ____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 56), ('criticality', 'ignore'), ('Extension', _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Extension', _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 84), ('criticality', 'ignore'), ('Extension', _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 80), ('criticality', 'ignore'), ('Extension', _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id._const_tab = ____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id._const_tab_at = None
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality._const_tab = ____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue._const_tab = ____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id),
        ('criticality', ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue),
        ])
    __UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item_._ext = None
    _UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions._cont = __UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item_
    _UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_Positioning_OTDOA_ReferenceCellInfo._cont = ASN1Dict([
        ('sfn', _UE_Positioning_OTDOA_ReferenceCellInfo_sfn),
        ('modeSpecificInfo', _UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo),
        ('frequencyInfo', _UE_Positioning_OTDOA_ReferenceCellInfo_frequencyInfo),
        ('positioningMode', _UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode),
        ('ue-positioning-IPDL-Paremeters', _UE_Positioning_OTDOA_ReferenceCellInfo_ue_positioning_IPDL_Paremeters),
        ('iE-Extensions', _UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions),
        ])
    UE_Positioning_OTDOA_ReferenceCellInfo._ext = []
    
    #-----< UE-Positioning-OTDOAReferenceCellInfo-ExtIEs >-----#
    UE_Positioning_OTDOAReferenceCellInfo_ExtIEs = CLASS(name='UE-Positioning-OTDOAReferenceCellInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExtendedRoundTripTime')))
    _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'TimingAdvanceLCR-R7')))
    _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RxTimingDeviationLCR')))
    _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AngleOfArrivalLCR')))
    UE_Positioning_OTDOAReferenceCellInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 56), ('criticality', 'ignore'), ('Extension', _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Extension', _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 84), ('criticality', 'ignore'), ('Extension', _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 80), ('criticality', 'ignore'), ('Extension', _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ReferenceCellPosition >-----#
    ReferenceCellPosition = CHOICE(name='ReferenceCellPosition', mode=MODE_TYPE)
    _ReferenceCellPosition_ellipsoidPoint = SEQ(name='ellipsoidPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GeographicalCoordinates')))
    _ReferenceCellPosition_ellipsoidPointWithAltitude = SEQ(name='ellipsoidPointWithAltitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GA-PointWithAltitude')))
    ReferenceCellPosition._cont = ASN1Dict([
        ('ellipsoidPoint', _ReferenceCellPosition_ellipsoidPoint),
        ('ellipsoidPointWithAltitude', _ReferenceCellPosition_ellipsoidPointWithAltitude),
        ])
    ReferenceCellPosition._ext = []
    
    #-----< UE-Positioning-IPDL-Parameters >-----#
    UE_Positioning_IPDL_Parameters = SEQ(name='UE-Positioning-IPDL-Parameters', mode=MODE_TYPE)
    _UE_Positioning_IPDL_Parameters_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_ip_Spacing = ENUM(name='ip-Spacing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'IP-Spacing')))
    ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_ip_Length = ENUM(name='ip-Length', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'IP-Length')))
    ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_ip_Offset = INT(name='ip-Offset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_ip_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_seed = INT(name='seed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_seed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    __UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('ip-Spacing', ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_ip_Spacing),
        ('ip-Length', ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_ip_Length),
        ('ip-Offset', ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_ip_Offset),
        ('seed', ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_seed),
        ])
    __UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd._ext = []
    __UE_Positioning_IPDL_Parameters_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UE_Positioning_IPDL_Parameters_modeSpecificInfo_tdd._cont = ASN1Dict([
        ])
    __UE_Positioning_IPDL_Parameters_modeSpecificInfo_tdd._ext = []
    _UE_Positioning_IPDL_Parameters_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd),
        ('tdd', __UE_Positioning_IPDL_Parameters_modeSpecificInfo_tdd),
        ])
    _UE_Positioning_IPDL_Parameters_modeSpecificInfo._ext = []
    _UE_Positioning_IPDL_Parameters_burstModeParameters = SEQ(name='burstModeParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'BurstModeParameters')), opt=True)
    _UE_Positioning_IPDL_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_Positioning_IPDL_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__id._const_tab = ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__id_tab
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__criticality._const_tab = ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__criticality_tab
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__extensionValue._const_tab = ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__extensionValue_tab
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_Positioning_IPDL_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__id),
        ('criticality', ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__extensionValue),
        ])
    __UE_Positioning_IPDL_Parameters_iE_Extensions__item_._ext = None
    _UE_Positioning_IPDL_Parameters_iE_Extensions._cont = __UE_Positioning_IPDL_Parameters_iE_Extensions__item_
    _UE_Positioning_IPDL_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_Positioning_IPDL_Parameters._cont = ASN1Dict([
        ('modeSpecificInfo', _UE_Positioning_IPDL_Parameters_modeSpecificInfo),
        ('burstModeParameters', _UE_Positioning_IPDL_Parameters_burstModeParameters),
        ('iE-Extensions', _UE_Positioning_IPDL_Parameters_iE_Extensions),
        ])
    UE_Positioning_IPDL_Parameters._ext = []
    
    #-----< UE-Positioning-IPDL-Parameters-ExtIEs >-----#
    UE_Positioning_IPDL_Parameters_ExtIEs = CLASS(name='UE-Positioning-IPDL-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UE_Positioning_IPDL_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IP-Spacing >-----#
    IP_Spacing = ENUM(name='IP-Spacing', mode=MODE_TYPE)
    IP_Spacing._cont = ASN1Dict([('e5', 0), ('e7', 1), ('e10', 2), ('e15', 3), ('e20', 4), ('e30', 5), ('e40', 6), ('e50', 7)])
    IP_Spacing._ext = []
    
    #-----< IP-Length >-----#
    IP_Length = ENUM(name='IP-Length', mode=MODE_TYPE)
    IP_Length._cont = ASN1Dict([('ipl5', 0), ('ipl10', 1)])
    IP_Length._ext = []
    
    #-----< BurstModeParameters >-----#
    BurstModeParameters = SEQ(name='BurstModeParameters', mode=MODE_TYPE)
    _BurstModeParameters_burstStart = INT(name='burstStart', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BurstModeParameters_burstStart._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _BurstModeParameters_burstLength = INT(name='burstLength', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BurstModeParameters_burstLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=10, ub=25)], ev=None, er=[])
    _BurstModeParameters_burstFreq = INT(name='burstFreq', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BurstModeParameters_burstFreq._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _BurstModeParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __BurstModeParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___BurstModeParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____BurstModeParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BurstModeParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BurstModeParameters_iE_Extensions__item__id._const_tab = ____BurstModeParameters_iE_Extensions__item__id_tab
    ___BurstModeParameters_iE_Extensions__item__id._const_tab_at = None
    ___BurstModeParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___BurstModeParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____BurstModeParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BurstModeParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BurstModeParameters_iE_Extensions__item__criticality._const_tab = ____BurstModeParameters_iE_Extensions__item__criticality_tab
    ___BurstModeParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___BurstModeParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___BurstModeParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____BurstModeParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____BurstModeParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___BurstModeParameters_iE_Extensions__item__extensionValue._const_tab = ____BurstModeParameters_iE_Extensions__item__extensionValue_tab
    ___BurstModeParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___BurstModeParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __BurstModeParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___BurstModeParameters_iE_Extensions__item__id),
        ('criticality', ___BurstModeParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___BurstModeParameters_iE_Extensions__item__extensionValue),
        ])
    __BurstModeParameters_iE_Extensions__item_._ext = None
    _BurstModeParameters_iE_Extensions._cont = __BurstModeParameters_iE_Extensions__item_
    _BurstModeParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    BurstModeParameters._cont = ASN1Dict([
        ('burstStart', _BurstModeParameters_burstStart),
        ('burstLength', _BurstModeParameters_burstLength),
        ('burstFreq', _BurstModeParameters_burstFreq),
        ('iE-Extensions', _BurstModeParameters_iE_Extensions),
        ])
    BurstModeParameters._ext = []
    
    #-----< BurstModeParameters-ExtIEs >-----#
    BurstModeParameters_ExtIEs = CLASS(name='BurstModeParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    BurstModeParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Positioning-OTDOA-NeighbourCellList >-----#
    UE_Positioning_OTDOA_NeighbourCellList = SEQ_OF(name='UE-Positioning-OTDOA-NeighbourCellList', mode=MODE_TYPE)
    _UE_Positioning_OTDOA_NeighbourCellList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-Positioning-OTDOA-NeighbourCellInfo')))
    UE_Positioning_OTDOA_NeighbourCellList._cont = _UE_Positioning_OTDOA_NeighbourCellList__item_
    UE_Positioning_OTDOA_NeighbourCellList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UE-Positioning-OTDOA-NeighbourCellInfo >-----#
    UE_Positioning_OTDOA_NeighbourCellInfo = SEQ(name='UE-Positioning-OTDOA-NeighbourCellInfo', mode=MODE_TYPE)
    _UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_fdd_primaryCPICH_Info = INT(name='primaryCPICH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PrimaryScramblingCode')))
    __UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('primaryCPICH-Info', ___UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_fdd_primaryCPICH_Info),
        ])
    __UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_fdd._ext = []
    __UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_tdd_cellParameterID = INT(name='cellParameterID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CellParameterID')))
    __UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('cellParameterID', ___UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_tdd_cellParameterID),
        ])
    __UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_tdd._ext = []
    _UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_fdd),
        ('tdd', __UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_tdd),
        ])
    _UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo._ext = []
    _UE_Positioning_OTDOA_NeighbourCellInfo_frequencyInfo = SEQ(name='frequencyInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'FrequencyInfo')), opt=True)
    _UE_Positioning_OTDOA_NeighbourCellInfo_ue_positioning_IPDL_Paremeters = SEQ(name='ue-positioning-IPDL-Paremeters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-Positioning-IPDL-Parameters')), opt=True)
    _UE_Positioning_OTDOA_NeighbourCellInfo_sfn_SFN_RelTimeDifference = SEQ(name='sfn-SFN-RelTimeDifference', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFN-SFN-RelTimeDifference1')))
    _UE_Positioning_OTDOA_NeighbourCellInfo_sfn_Offset_Validity = ENUM(name='sfn-Offset-Validity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFN-Offset-Validity')), opt=True)
    _UE_Positioning_OTDOA_NeighbourCellInfo_sfn_SFN_Drift = ENUM(name='sfn-SFN-Drift', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SFN-SFN-Drift')), opt=True)
    _UE_Positioning_OTDOA_NeighbourCellInfo_searchWindowSize = ENUM(name='searchWindowSize', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-SearchWindowSize')))
    _UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode = CHOICE(name='positioningMode', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased = SEQ(name='ueBased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeNorth = INT(name='relativeNorth', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeNorth._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20000, ub=20000)], ev=None, er=[])
    ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeEast = INT(name='relativeEast', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeEast._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-20000, ub=20000)], ev=None, er=[])
    ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeAltitude = INT(name='relativeAltitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-4000, ub=4000)], ev=None, er=[])
    ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_fineSFN_SFN = INT(name='fineSFN-SFN', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'FineSFNSFN')), opt=True)
    ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_roundTripTime = INT(name='roundTripTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_roundTripTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32766)], ev=None, er=[])
    __UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased._cont = ASN1Dict([
        ('relativeNorth', ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeNorth),
        ('relativeEast', ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeEast),
        ('relativeAltitude', ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeAltitude),
        ('fineSFN-SFN', ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_fineSFN_SFN),
        ('roundTripTime', ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_roundTripTime),
        ])
    __UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased._ext = []
    __UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueAssisted = SEQ(name='ueAssisted', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueAssisted._cont = ASN1Dict([
        ])
    __UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueAssisted._ext = []
    _UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode._cont = ASN1Dict([
        ('ueBased', __UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased),
        ('ueAssisted', __UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueAssisted),
        ])
    _UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode._ext = []
    _UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExtendedRoundTripTime')))
    ____UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 56), ('criticality', 'ignore'), ('Extension', _____UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id._const_tab = ____UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id._const_tab_at = None
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality._const_tab = ____UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue._const_tab = ____UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id),
        ('criticality', ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue),
        ])
    __UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item_._ext = None
    _UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions._cont = __UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item_
    _UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_Positioning_OTDOA_NeighbourCellInfo._cont = ASN1Dict([
        ('modeSpecificInfo', _UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo),
        ('frequencyInfo', _UE_Positioning_OTDOA_NeighbourCellInfo_frequencyInfo),
        ('ue-positioning-IPDL-Paremeters', _UE_Positioning_OTDOA_NeighbourCellInfo_ue_positioning_IPDL_Paremeters),
        ('sfn-SFN-RelTimeDifference', _UE_Positioning_OTDOA_NeighbourCellInfo_sfn_SFN_RelTimeDifference),
        ('sfn-Offset-Validity', _UE_Positioning_OTDOA_NeighbourCellInfo_sfn_Offset_Validity),
        ('sfn-SFN-Drift', _UE_Positioning_OTDOA_NeighbourCellInfo_sfn_SFN_Drift),
        ('searchWindowSize', _UE_Positioning_OTDOA_NeighbourCellInfo_searchWindowSize),
        ('positioningMode', _UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode),
        ('iE-Extensions', _UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions),
        ])
    UE_Positioning_OTDOA_NeighbourCellInfo._ext = []
    
    #-----< UE-Positioning-OTDOANeighbourCellInfo-ExtIEs >-----#
    UE_Positioning_OTDOANeighbourCellInfo_ExtIEs = CLASS(name='UE-Positioning-OTDOANeighbourCellInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _UE_Positioning_OTDOANeighbourCellInfo_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ExtendedRoundTripTime')))
    UE_Positioning_OTDOANeighbourCellInfo_ExtIEs._val = ASN1Set(rv=[dict([('id', 56), ('criticality', 'ignore'), ('Extension', _UE_Positioning_OTDOANeighbourCellInfo_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SFN-SFN-RelTimeDifference1 >-----#
    SFN_SFN_RelTimeDifference1 = SEQ(name='SFN-SFN-RelTimeDifference1', mode=MODE_TYPE)
    _SFN_SFN_RelTimeDifference1_sfn_Offset = INT(name='sfn-Offset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SFN_SFN_RelTimeDifference1_sfn_Offset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _SFN_SFN_RelTimeDifference1_sfn_sfn_Reltimedifference = INT(name='sfn-sfn-Reltimedifference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SFN_SFN_RelTimeDifference1_sfn_sfn_Reltimedifference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=38399)], ev=None, er=[])
    _SFN_SFN_RelTimeDifference1_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SFN_SFN_RelTimeDifference1_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__id._const_tab = ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__id_tab
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__id._const_tab_at = None
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__id._const_tab_id = 'id'
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__criticality._const_tab = ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__criticality_tab
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__extensionValue._const_tab = ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__extensionValue_tab
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SFN_SFN_RelTimeDifference1_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__id),
        ('criticality', ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__criticality),
        ('extensionValue', ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__extensionValue),
        ])
    __SFN_SFN_RelTimeDifference1_iE_Extensions__item_._ext = None
    _SFN_SFN_RelTimeDifference1_iE_Extensions._cont = __SFN_SFN_RelTimeDifference1_iE_Extensions__item_
    _SFN_SFN_RelTimeDifference1_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SFN_SFN_RelTimeDifference1._cont = ASN1Dict([
        ('sfn-Offset', _SFN_SFN_RelTimeDifference1_sfn_Offset),
        ('sfn-sfn-Reltimedifference', _SFN_SFN_RelTimeDifference1_sfn_sfn_Reltimedifference),
        ('iE-Extensions', _SFN_SFN_RelTimeDifference1_iE_Extensions),
        ])
    SFN_SFN_RelTimeDifference1._ext = []
    
    #-----< SFN-SFN-RelTimeDifference1-ExtIEs >-----#
    SFN_SFN_RelTimeDifference1_ExtIEs = CLASS(name='SFN-SFN-RelTimeDifference1-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    SFN_SFN_RelTimeDifference1_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SFN-Offset-Validity >-----#
    SFN_Offset_Validity = ENUM(name='SFN-Offset-Validity', mode=MODE_TYPE)
    SFN_Offset_Validity._cont = ASN1Dict([('false', 0)])
    SFN_Offset_Validity._ext = None
    
    #-----< OTDOA-SearchWindowSize >-----#
    OTDOA_SearchWindowSize = ENUM(name='OTDOA-SearchWindowSize', mode=MODE_TYPE)
    OTDOA_SearchWindowSize._cont = ASN1Dict([('c20', 0), ('c40', 1), ('c80', 2), ('c160', 3), ('c320', 4), ('c640', 5), ('c1280', 6), ('moreThan1280', 7)])
    OTDOA_SearchWindowSize._ext = []
    
    #-----< SFN-SFN-Drift >-----#
    SFN_SFN_Drift = ENUM(name='SFN-SFN-Drift', mode=MODE_TYPE)
    SFN_SFN_Drift._cont = ASN1Dict([('sfnsfndrift0', 0), ('sfnsfndrift1', 1), ('sfnsfndrift2', 2), ('sfnsfndrift3', 3), ('sfnsfndrift4', 4), ('sfnsfndrift5', 5), ('sfnsfndrift8', 6), ('sfnsfndrift10', 7), ('sfnsfndrift15', 8), ('sfnsfndrift25', 9), ('sfnsfndrift35', 10), ('sfnsfndrift50', 11), ('sfnsfndrift65', 12), ('sfnsfndrift80', 13), ('sfnsfndrift100', 14), ('sfnsfndrift-1', 15), ('sfnsfndrift-2', 16), ('sfnsfndrift-3', 17), ('sfnsfndrift-4', 18), ('sfnsfndrift-5', 19), ('sfnsfndrift-8', 20), ('sfnsfndrift-10', 21), ('sfnsfndrift-15', 22), ('sfnsfndrift-25', 23), ('sfnsfndrift-35', 24), ('sfnsfndrift-50', 25), ('sfnsfndrift-65', 26), ('sfnsfndrift-80', 27), ('sfnsfndrift-100', 28)])
    SFN_SFN_Drift._ext = []
    
    #-----< FineSFNSFN >-----#
    FineSFNSFN = INT(name='FineSFNSFN', mode=MODE_TYPE)
    FineSFNSFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< VerticalAccuracyCode >-----#
    VerticalAccuracyCode = INT(name='VerticalAccuracyCode', mode=MODE_TYPE)
    VerticalAccuracyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< UTDOA-Group >-----#
    UTDOA_Group = SEQ(name='UTDOA-Group', mode=MODE_TYPE)
    _UTDOA_Group_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _UTDOA_Group_frequencyInfo = SEQ(name='frequencyInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'FrequencyInfo')))
    _UTDOA_Group_uTDOA_ChannelSettings = CHOICE(name='uTDOA-ChannelSettings', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-RRCState')))
    _UTDOA_Group_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTDOA_Group_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTDOA_Group_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTDOA_Group_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOA_Group_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOA_Group_iE_Extensions__item__id._const_tab = ____UTDOA_Group_iE_Extensions__item__id_tab
    ___UTDOA_Group_iE_Extensions__item__id._const_tab_at = None
    ___UTDOA_Group_iE_Extensions__item__id._const_tab_id = 'id'
    ___UTDOA_Group_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTDOA_Group_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOA_Group_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOA_Group_iE_Extensions__item__criticality._const_tab = ____UTDOA_Group_iE_Extensions__item__criticality_tab
    ___UTDOA_Group_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTDOA_Group_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTDOA_Group_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTDOA_Group_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOA_Group_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOA_Group_iE_Extensions__item__extensionValue._const_tab = ____UTDOA_Group_iE_Extensions__item__extensionValue_tab
    ___UTDOA_Group_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTDOA_Group_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTDOA_Group_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTDOA_Group_iE_Extensions__item__id),
        ('criticality', ___UTDOA_Group_iE_Extensions__item__criticality),
        ('extensionValue', ___UTDOA_Group_iE_Extensions__item__extensionValue),
        ])
    __UTDOA_Group_iE_Extensions__item_._ext = None
    _UTDOA_Group_iE_Extensions._cont = __UTDOA_Group_iE_Extensions__item_
    _UTDOA_Group_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTDOA_Group._cont = ASN1Dict([
        ('uC-ID', _UTDOA_Group_uC_ID),
        ('frequencyInfo', _UTDOA_Group_frequencyInfo),
        ('uTDOA-ChannelSettings', _UTDOA_Group_uTDOA_ChannelSettings),
        ('iE-Extensions', _UTDOA_Group_iE_Extensions),
        ])
    UTDOA_Group._ext = []
    
    #-----< UTDOA-Group-ExtIEs >-----#
    UTDOA_Group_ExtIEs = CLASS(name='UTDOA-Group-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTDOA_Group_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FrequencyInfo >-----#
    FrequencyInfo = SEQ(name='FrequencyInfo', mode=MODE_TYPE)
    _FrequencyInfo_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FrequencyInfo_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'FrequencyInfoFDD')))
    __FrequencyInfo_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'FrequencyInfoTDD')))
    _FrequencyInfo_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __FrequencyInfo_modeSpecificInfo_fdd),
        ('tdd', __FrequencyInfo_modeSpecificInfo_tdd),
        ])
    _FrequencyInfo_modeSpecificInfo._ext = []
    _FrequencyInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FrequencyInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___FrequencyInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____FrequencyInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____FrequencyInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FrequencyInfo_iE_Extensions__item__id._const_tab = ____FrequencyInfo_iE_Extensions__item__id_tab
    ___FrequencyInfo_iE_Extensions__item__id._const_tab_at = None
    ___FrequencyInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___FrequencyInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FrequencyInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____FrequencyInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FrequencyInfo_iE_Extensions__item__criticality._const_tab = ____FrequencyInfo_iE_Extensions__item__criticality_tab
    ___FrequencyInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FrequencyInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FrequencyInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FrequencyInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____FrequencyInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FrequencyInfo_iE_Extensions__item__extensionValue._const_tab = ____FrequencyInfo_iE_Extensions__item__extensionValue_tab
    ___FrequencyInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FrequencyInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FrequencyInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FrequencyInfo_iE_Extensions__item__id),
        ('criticality', ___FrequencyInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___FrequencyInfo_iE_Extensions__item__extensionValue),
        ])
    __FrequencyInfo_iE_Extensions__item_._ext = None
    _FrequencyInfo_iE_Extensions._cont = __FrequencyInfo_iE_Extensions__item_
    _FrequencyInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FrequencyInfo._cont = ASN1Dict([
        ('modeSpecificInfo', _FrequencyInfo_modeSpecificInfo),
        ('iE-Extensions', _FrequencyInfo_iE_Extensions),
        ])
    FrequencyInfo._ext = []
    
    #-----< FrequencyInfo-ExtIEs >-----#
    FrequencyInfo_ExtIEs = CLASS(name='FrequencyInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    FrequencyInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FrequencyInfoFDD >-----#
    FrequencyInfoFDD = SEQ(name='FrequencyInfoFDD', mode=MODE_TYPE)
    _FrequencyInfoFDD_uarfcn_UL = INT(name='uarfcn-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UARFCN')), opt=True)
    _FrequencyInfoFDD_uarfcn_DL = INT(name='uarfcn-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UARFCN')))
    _FrequencyInfoFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FrequencyInfoFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___FrequencyInfoFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____FrequencyInfoFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____FrequencyInfoFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FrequencyInfoFDD_iE_Extensions__item__id._const_tab = ____FrequencyInfoFDD_iE_Extensions__item__id_tab
    ___FrequencyInfoFDD_iE_Extensions__item__id._const_tab_at = None
    ___FrequencyInfoFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___FrequencyInfoFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FrequencyInfoFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____FrequencyInfoFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FrequencyInfoFDD_iE_Extensions__item__criticality._const_tab = ____FrequencyInfoFDD_iE_Extensions__item__criticality_tab
    ___FrequencyInfoFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FrequencyInfoFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FrequencyInfoFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FrequencyInfoFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____FrequencyInfoFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FrequencyInfoFDD_iE_Extensions__item__extensionValue._const_tab = ____FrequencyInfoFDD_iE_Extensions__item__extensionValue_tab
    ___FrequencyInfoFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FrequencyInfoFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FrequencyInfoFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FrequencyInfoFDD_iE_Extensions__item__id),
        ('criticality', ___FrequencyInfoFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___FrequencyInfoFDD_iE_Extensions__item__extensionValue),
        ])
    __FrequencyInfoFDD_iE_Extensions__item_._ext = None
    _FrequencyInfoFDD_iE_Extensions._cont = __FrequencyInfoFDD_iE_Extensions__item_
    _FrequencyInfoFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FrequencyInfoFDD._cont = ASN1Dict([
        ('uarfcn-UL', _FrequencyInfoFDD_uarfcn_UL),
        ('uarfcn-DL', _FrequencyInfoFDD_uarfcn_DL),
        ('iE-Extensions', _FrequencyInfoFDD_iE_Extensions),
        ])
    FrequencyInfoFDD._ext = []
    
    #-----< FrequencyInfoFDD-ExtIEs >-----#
    FrequencyInfoFDD_ExtIEs = CLASS(name='FrequencyInfoFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    FrequencyInfoFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< FrequencyInfoTDD >-----#
    FrequencyInfoTDD = SEQ(name='FrequencyInfoTDD', mode=MODE_TYPE)
    _FrequencyInfoTDD_uarfcn = INT(name='uarfcn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UARFCN')))
    _FrequencyInfoTDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __FrequencyInfoTDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___FrequencyInfoTDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____FrequencyInfoTDD_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____FrequencyInfoTDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FrequencyInfoTDD_iE_Extensions__item__id._const_tab = ____FrequencyInfoTDD_iE_Extensions__item__id_tab
    ___FrequencyInfoTDD_iE_Extensions__item__id._const_tab_at = None
    ___FrequencyInfoTDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___FrequencyInfoTDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____FrequencyInfoTDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____FrequencyInfoTDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FrequencyInfoTDD_iE_Extensions__item__criticality._const_tab = ____FrequencyInfoTDD_iE_Extensions__item__criticality_tab
    ___FrequencyInfoTDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___FrequencyInfoTDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___FrequencyInfoTDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____FrequencyInfoTDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____FrequencyInfoTDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___FrequencyInfoTDD_iE_Extensions__item__extensionValue._const_tab = ____FrequencyInfoTDD_iE_Extensions__item__extensionValue_tab
    ___FrequencyInfoTDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___FrequencyInfoTDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __FrequencyInfoTDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___FrequencyInfoTDD_iE_Extensions__item__id),
        ('criticality', ___FrequencyInfoTDD_iE_Extensions__item__criticality),
        ('extensionValue', ___FrequencyInfoTDD_iE_Extensions__item__extensionValue),
        ])
    __FrequencyInfoTDD_iE_Extensions__item_._ext = None
    _FrequencyInfoTDD_iE_Extensions._cont = __FrequencyInfoTDD_iE_Extensions__item_
    _FrequencyInfoTDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    FrequencyInfoTDD._cont = ASN1Dict([
        ('uarfcn', _FrequencyInfoTDD_uarfcn),
        ('iE-Extensions', _FrequencyInfoTDD_iE_Extensions),
        ])
    FrequencyInfoTDD._ext = []
    
    #-----< FrequencyInfoTDD-ExtIEs >-----#
    FrequencyInfoTDD_ExtIEs = CLASS(name='FrequencyInfoTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    FrequencyInfoTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTDOA-RRCState >-----#
    UTDOA_RRCState = CHOICE(name='UTDOA-RRCState', mode=MODE_TYPE)
    _UTDOA_RRCState_uTDOA_CELLDCH = SEQ(name='uTDOA-CELLDCH', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-CELLDCH')))
    _UTDOA_RRCState_uTDOA_CELLFACH = SEQ(name='uTDOA-CELLFACH', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-CELLFACH')))
    UTDOA_RRCState._cont = ASN1Dict([
        ('uTDOA-CELLDCH', _UTDOA_RRCState_uTDOA_CELLDCH),
        ('uTDOA-CELLFACH', _UTDOA_RRCState_uTDOA_CELLFACH),
        ])
    UTDOA_RRCState._ext = []
    
    #-----< UTDOA-CELLDCH >-----#
    UTDOA_CELLDCH = SEQ(name='UTDOA-CELLDCH', mode=MODE_TYPE)
    _UTDOA_CELLDCH_uL_DPCHInfo = CHOICE(name='uL-DPCHInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UL-DPCHInfo')))
    _UTDOA_CELLDCH_compressedModeAssistanceData = SEQ(name='compressedModeAssistanceData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Compressed-Mode-Assistance-Data')), opt=True)
    _UTDOA_CELLDCH_dCH_Information = SEQ(name='dCH-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DCH-Information')), opt=True)
    _UTDOA_CELLDCH_e_DPCH_Information = SEQ(name='e-DPCH-Information', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'E-DPCH-Information')), opt=True)
    _UTDOA_CELLDCH_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTDOA_CELLDCH_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTDOA_CELLDCH_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTDOA_CELLDCH_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOA_CELLDCH_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOA_CELLDCH_iE_Extensions__item__id._const_tab = ____UTDOA_CELLDCH_iE_Extensions__item__id_tab
    ___UTDOA_CELLDCH_iE_Extensions__item__id._const_tab_at = None
    ___UTDOA_CELLDCH_iE_Extensions__item__id._const_tab_id = 'id'
    ___UTDOA_CELLDCH_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTDOA_CELLDCH_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOA_CELLDCH_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOA_CELLDCH_iE_Extensions__item__criticality._const_tab = ____UTDOA_CELLDCH_iE_Extensions__item__criticality_tab
    ___UTDOA_CELLDCH_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTDOA_CELLDCH_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTDOA_CELLDCH_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTDOA_CELLDCH_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOA_CELLDCH_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOA_CELLDCH_iE_Extensions__item__extensionValue._const_tab = ____UTDOA_CELLDCH_iE_Extensions__item__extensionValue_tab
    ___UTDOA_CELLDCH_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTDOA_CELLDCH_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTDOA_CELLDCH_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTDOA_CELLDCH_iE_Extensions__item__id),
        ('criticality', ___UTDOA_CELLDCH_iE_Extensions__item__criticality),
        ('extensionValue', ___UTDOA_CELLDCH_iE_Extensions__item__extensionValue),
        ])
    __UTDOA_CELLDCH_iE_Extensions__item_._ext = None
    _UTDOA_CELLDCH_iE_Extensions._cont = __UTDOA_CELLDCH_iE_Extensions__item_
    _UTDOA_CELLDCH_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTDOA_CELLDCH._cont = ASN1Dict([
        ('uL-DPCHInfo', _UTDOA_CELLDCH_uL_DPCHInfo),
        ('compressedModeAssistanceData', _UTDOA_CELLDCH_compressedModeAssistanceData),
        ('dCH-Information', _UTDOA_CELLDCH_dCH_Information),
        ('e-DPCH-Information', _UTDOA_CELLDCH_e_DPCH_Information),
        ('iE-Extensions', _UTDOA_CELLDCH_iE_Extensions),
        ])
    UTDOA_CELLDCH._ext = []
    
    #-----< UTDOA-CELLDCH-ExtIEs >-----#
    UTDOA_CELLDCH_ExtIEs = CLASS(name='UTDOA-CELLDCH-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTDOA_CELLDCH_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCHInfo >-----#
    UL_DPCHInfo = CHOICE(name='UL-DPCHInfo', mode=MODE_TYPE)
    _UL_DPCHInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UL_DPCHInfo_fdd_scramblingCodeType = ENUM(name='scramblingCodeType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'ScramblingCodeType')))
    __UL_DPCHInfo_fdd_scramblingCode = INT(name='scramblingCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UL-ScramblingCode')))
    __UL_DPCHInfo_fdd_tfci_Existence = BOOL(name='tfci-Existence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UL_DPCHInfo_fdd_numberOfFBI_Bits = INT(name='numberOfFBI-Bits', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'NumberOfFBI-Bits')))
    __UL_DPCHInfo_fdd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___UL_DPCHInfo_fdd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____UL_DPCHInfo_fdd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____UL_DPCHInfo_fdd_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UL_DPCHInfo_fdd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UL_DPCHInfo_fdd_iE_Extensions__item__id._const_tab = _____UL_DPCHInfo_fdd_iE_Extensions__item__id_tab
    ____UL_DPCHInfo_fdd_iE_Extensions__item__id._const_tab_at = None
    ____UL_DPCHInfo_fdd_iE_Extensions__item__id._const_tab_id = 'id'
    ____UL_DPCHInfo_fdd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____UL_DPCHInfo_fdd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UL_DPCHInfo_fdd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UL_DPCHInfo_fdd_iE_Extensions__item__criticality._const_tab = _____UL_DPCHInfo_fdd_iE_Extensions__item__criticality_tab
    ____UL_DPCHInfo_fdd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____UL_DPCHInfo_fdd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____UL_DPCHInfo_fdd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____UL_DPCHInfo_fdd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UL_DPCHInfo_fdd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UL_DPCHInfo_fdd_iE_Extensions__item__extensionValue._const_tab = _____UL_DPCHInfo_fdd_iE_Extensions__item__extensionValue_tab
    ____UL_DPCHInfo_fdd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____UL_DPCHInfo_fdd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___UL_DPCHInfo_fdd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____UL_DPCHInfo_fdd_iE_Extensions__item__id),
        ('criticality', ____UL_DPCHInfo_fdd_iE_Extensions__item__criticality),
        ('extensionValue', ____UL_DPCHInfo_fdd_iE_Extensions__item__extensionValue),
        ])
    ___UL_DPCHInfo_fdd_iE_Extensions__item_._ext = None
    __UL_DPCHInfo_fdd_iE_Extensions._cont = ___UL_DPCHInfo_fdd_iE_Extensions__item_
    __UL_DPCHInfo_fdd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _UL_DPCHInfo_fdd._cont = ASN1Dict([
        ('scramblingCodeType', __UL_DPCHInfo_fdd_scramblingCodeType),
        ('scramblingCode', __UL_DPCHInfo_fdd_scramblingCode),
        ('tfci-Existence', __UL_DPCHInfo_fdd_tfci_Existence),
        ('numberOfFBI-Bits', __UL_DPCHInfo_fdd_numberOfFBI_Bits),
        ('iE-Extensions', __UL_DPCHInfo_fdd_iE_Extensions),
        ])
    _UL_DPCHInfo_fdd._ext = []
    _UL_DPCHInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UL_DPCHInfo_tdd_cellParameterID = INT(name='cellParameterID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CellParameterID')))
    __UL_DPCHInfo_tdd_tFCI_Coding = ENUM(name='tFCI-Coding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TFCI-Coding')))
    __UL_DPCHInfo_tdd_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PuncturingLimit')))
    __UL_DPCHInfo_tdd_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RepetitionPeriod')))
    __UL_DPCHInfo_tdd_repetitionLength = INT(name='repetitionLength', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RepetitionLength')))
    __UL_DPCHInfo_tdd_tdd_DPCHOffset = CHOICE(name='tdd-DPCHOffset', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TDD-DPCHOffset')))
    __UL_DPCHInfo_tdd_uL_Timeslot_Information = SEQ_OF(name='uL-Timeslot-Information', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UL-Timeslot-Information')))
    __UL_DPCHInfo_tdd_frameOffset = INT(name='frameOffset', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'FrameOffset')))
    __UL_DPCHInfo_tdd_specialBurstScheduling = INT(name='specialBurstScheduling', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SpecialBurstScheduling')))
    __UL_DPCHInfo_tdd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___UL_DPCHInfo_tdd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____UL_DPCHInfo_tdd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____UL_DPCHInfo_tdd_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UL_DPCHInfo_tdd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UL_DPCHInfo_tdd_iE_Extensions__item__id._const_tab = _____UL_DPCHInfo_tdd_iE_Extensions__item__id_tab
    ____UL_DPCHInfo_tdd_iE_Extensions__item__id._const_tab_at = None
    ____UL_DPCHInfo_tdd_iE_Extensions__item__id._const_tab_id = 'id'
    ____UL_DPCHInfo_tdd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____UL_DPCHInfo_tdd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UL_DPCHInfo_tdd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UL_DPCHInfo_tdd_iE_Extensions__item__criticality._const_tab = _____UL_DPCHInfo_tdd_iE_Extensions__item__criticality_tab
    ____UL_DPCHInfo_tdd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____UL_DPCHInfo_tdd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____UL_DPCHInfo_tdd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____UL_DPCHInfo_tdd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____UL_DPCHInfo_tdd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UL_DPCHInfo_tdd_iE_Extensions__item__extensionValue._const_tab = _____UL_DPCHInfo_tdd_iE_Extensions__item__extensionValue_tab
    ____UL_DPCHInfo_tdd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____UL_DPCHInfo_tdd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___UL_DPCHInfo_tdd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____UL_DPCHInfo_tdd_iE_Extensions__item__id),
        ('criticality', ____UL_DPCHInfo_tdd_iE_Extensions__item__criticality),
        ('extensionValue', ____UL_DPCHInfo_tdd_iE_Extensions__item__extensionValue),
        ])
    ___UL_DPCHInfo_tdd_iE_Extensions__item_._ext = None
    __UL_DPCHInfo_tdd_iE_Extensions._cont = ___UL_DPCHInfo_tdd_iE_Extensions__item_
    __UL_DPCHInfo_tdd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _UL_DPCHInfo_tdd._cont = ASN1Dict([
        ('cellParameterID', __UL_DPCHInfo_tdd_cellParameterID),
        ('tFCI-Coding', __UL_DPCHInfo_tdd_tFCI_Coding),
        ('punctureLimit', __UL_DPCHInfo_tdd_punctureLimit),
        ('repetitionPeriod', __UL_DPCHInfo_tdd_repetitionPeriod),
        ('repetitionLength', __UL_DPCHInfo_tdd_repetitionLength),
        ('tdd-DPCHOffset', __UL_DPCHInfo_tdd_tdd_DPCHOffset),
        ('uL-Timeslot-Information', __UL_DPCHInfo_tdd_uL_Timeslot_Information),
        ('frameOffset', __UL_DPCHInfo_tdd_frameOffset),
        ('specialBurstScheduling', __UL_DPCHInfo_tdd_specialBurstScheduling),
        ('iE-Extensions', __UL_DPCHInfo_tdd_iE_Extensions),
        ])
    _UL_DPCHInfo_tdd._ext = []
    UL_DPCHInfo._cont = ASN1Dict([
        ('fdd', _UL_DPCHInfo_fdd),
        ('tdd', _UL_DPCHInfo_tdd),
        ])
    UL_DPCHInfo._ext = []
    
    #-----< UL-DPCHInfoFDD-ExtIEs >-----#
    UL_DPCHInfoFDD_ExtIEs = CLASS(name='UL-DPCHInfoFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UL_DPCHInfoFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-DPCHInfoTDD-ExtIEs >-----#
    UL_DPCHInfoTDD_ExtIEs = CLASS(name='UL-DPCHInfoTDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UL_DPCHInfoTDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Compressed-Mode-Assistance-Data >-----#
    Compressed_Mode_Assistance_Data = SEQ(name='Compressed-Mode-Assistance-Data', mode=MODE_TYPE)
    _Compressed_Mode_Assistance_Data_dl_information = SEQ(name='dl-information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'DL-InformationFDD')))
    _Compressed_Mode_Assistance_Data_ul_information = SEQ(name='ul-information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UL-InformationFDD')))
    _Compressed_Mode_Assistance_Data_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Compressed_Mode_Assistance_Data_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Compressed_Mode_Assistance_Data_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Compressed_Mode_Assistance_Data_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__id._const_tab = ____Compressed_Mode_Assistance_Data_iE_Extensions__item__id_tab
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__id._const_tab_at = None
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__id._const_tab_id = 'id'
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Compressed_Mode_Assistance_Data_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Compressed_Mode_Assistance_Data_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__criticality._const_tab = ____Compressed_Mode_Assistance_Data_iE_Extensions__item__criticality_tab
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Compressed_Mode_Assistance_Data_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Compressed_Mode_Assistance_Data_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__extensionValue._const_tab = ____Compressed_Mode_Assistance_Data_iE_Extensions__item__extensionValue_tab
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Compressed_Mode_Assistance_Data_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Compressed_Mode_Assistance_Data_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Compressed_Mode_Assistance_Data_iE_Extensions__item__id),
        ('criticality', ___Compressed_Mode_Assistance_Data_iE_Extensions__item__criticality),
        ('extensionValue', ___Compressed_Mode_Assistance_Data_iE_Extensions__item__extensionValue),
        ])
    __Compressed_Mode_Assistance_Data_iE_Extensions__item_._ext = None
    _Compressed_Mode_Assistance_Data_iE_Extensions._cont = __Compressed_Mode_Assistance_Data_iE_Extensions__item_
    _Compressed_Mode_Assistance_Data_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Compressed_Mode_Assistance_Data._cont = ASN1Dict([
        ('dl-information', _Compressed_Mode_Assistance_Data_dl_information),
        ('ul-information', _Compressed_Mode_Assistance_Data_ul_information),
        ('iE-Extensions', _Compressed_Mode_Assistance_Data_iE_Extensions),
        ])
    Compressed_Mode_Assistance_Data._ext = []
    
    #-----< Compressed-Mode-Assistance-DataFDD-ExtIEs >-----#
    Compressed_Mode_Assistance_DataFDD_ExtIEs = CLASS(name='Compressed-Mode-Assistance-DataFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Compressed_Mode_Assistance_DataFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DL-InformationFDD >-----#
    DL_InformationFDD = SEQ(name='DL-InformationFDD', mode=MODE_TYPE)
    _DL_InformationFDD_primaryScramblingCode = INT(name='primaryScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PrimaryScramblingCode')))
    _DL_InformationFDD_chipOffset = INT(name='chipOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'ChipOffset')))
    _DL_InformationFDD_frameOffset = INT(name='frameOffset', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'FrameOffset')))
    _DL_InformationFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DL_InformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DL_InformationFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DL_InformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DL_InformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_InformationFDD_iE_Extensions__item__id._const_tab = ____DL_InformationFDD_iE_Extensions__item__id_tab
    ___DL_InformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___DL_InformationFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___DL_InformationFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DL_InformationFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DL_InformationFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_InformationFDD_iE_Extensions__item__criticality._const_tab = ____DL_InformationFDD_iE_Extensions__item__criticality_tab
    ___DL_InformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DL_InformationFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DL_InformationFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DL_InformationFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DL_InformationFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DL_InformationFDD_iE_Extensions__item__extensionValue._const_tab = ____DL_InformationFDD_iE_Extensions__item__extensionValue_tab
    ___DL_InformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DL_InformationFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DL_InformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DL_InformationFDD_iE_Extensions__item__id),
        ('criticality', ___DL_InformationFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___DL_InformationFDD_iE_Extensions__item__extensionValue),
        ])
    __DL_InformationFDD_iE_Extensions__item_._ext = None
    _DL_InformationFDD_iE_Extensions._cont = __DL_InformationFDD_iE_Extensions__item_
    _DL_InformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DL_InformationFDD._cont = ASN1Dict([
        ('primaryScramblingCode', _DL_InformationFDD_primaryScramblingCode),
        ('chipOffset', _DL_InformationFDD_chipOffset),
        ('frameOffset', _DL_InformationFDD_frameOffset),
        ('iE-Extensions', _DL_InformationFDD_iE_Extensions),
        ])
    DL_InformationFDD._ext = []
    
    #-----< DL-InformationFDD-ExtIEs >-----#
    DL_InformationFDD_ExtIEs = CLASS(name='DL-InformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DL_InformationFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-InformationFDD >-----#
    UL_InformationFDD = SEQ(name='UL-InformationFDD', mode=MODE_TYPE)
    _UL_InformationFDD_transmissionGapPatternSequenceInfo = SEQ_OF(name='transmissionGapPatternSequenceInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Transmission-Gap-Pattern-Sequence-Information')))
    _UL_InformationFDD_activePatternSequenceInfo = SEQ(name='activePatternSequenceInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Active-Pattern-Sequence-Information')))
    _UL_InformationFDD_cFN = INT(name='cFN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CFN')))
    _UL_InformationFDD_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_InformationFDD_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UL_InformationFDD_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_InformationFDD_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UL_InformationFDD_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_InformationFDD_iE_Extensions__item__id._const_tab = ____UL_InformationFDD_iE_Extensions__item__id_tab
    ___UL_InformationFDD_iE_Extensions__item__id._const_tab_at = None
    ___UL_InformationFDD_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_InformationFDD_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_InformationFDD_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UL_InformationFDD_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_InformationFDD_iE_Extensions__item__criticality._const_tab = ____UL_InformationFDD_iE_Extensions__item__criticality_tab
    ___UL_InformationFDD_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_InformationFDD_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_InformationFDD_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_InformationFDD_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UL_InformationFDD_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_InformationFDD_iE_Extensions__item__extensionValue._const_tab = ____UL_InformationFDD_iE_Extensions__item__extensionValue_tab
    ___UL_InformationFDD_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_InformationFDD_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_InformationFDD_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_InformationFDD_iE_Extensions__item__id),
        ('criticality', ___UL_InformationFDD_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_InformationFDD_iE_Extensions__item__extensionValue),
        ])
    __UL_InformationFDD_iE_Extensions__item_._ext = None
    _UL_InformationFDD_iE_Extensions._cont = __UL_InformationFDD_iE_Extensions__item_
    _UL_InformationFDD_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_InformationFDD._cont = ASN1Dict([
        ('transmissionGapPatternSequenceInfo', _UL_InformationFDD_transmissionGapPatternSequenceInfo),
        ('activePatternSequenceInfo', _UL_InformationFDD_activePatternSequenceInfo),
        ('cFN', _UL_InformationFDD_cFN),
        ('iE-Extensions', _UL_InformationFDD_iE_Extensions),
        ])
    UL_InformationFDD._ext = []
    
    #-----< UL-InformationFDD-ExtIEs >-----#
    UL_InformationFDD_ExtIEs = CLASS(name='UL-InformationFDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UL_InformationFDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-Information >-----#
    Transmission_Gap_Pattern_Sequence_Information = SEQ_OF(name='Transmission-Gap-Pattern-Sequence-Information', mode=MODE_TYPE)
    _Transmission_Gap_Pattern_Sequence_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Transmission_Gap_Pattern_Sequence_Information__item__tGPSID = INT(name='tGPSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TGPSID')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGSN = INT(name='tGSN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TGSN')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGL1 = INT(name='tGL1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GapLength')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGL2 = INT(name='tGL2', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GapLength')), opt=True)
    __Transmission_Gap_Pattern_Sequence_Information__item__tGD = INT(name='tGD', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TGD')))
    __Transmission_Gap_Pattern_Sequence_Information__item__tGPL1 = INT(name='tGPL1', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GapDuration')))
    __Transmission_Gap_Pattern_Sequence_Information__item__uplink_Compressed_Mode_Method = ENUM(name='uplink-Compressed-Mode-Method', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Uplink-Compressed-Mode-Method')))
    __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id._const_tab = _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id._const_tab_at = None
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality._const_tab = _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue._const_tab = _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id),
        ('criticality', ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality),
        ('extensionValue', ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue),
        ])
    ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_._ext = None
    __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions._cont = ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_
    __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Transmission_Gap_Pattern_Sequence_Information__item_._cont = ASN1Dict([
        ('tGPSID', __Transmission_Gap_Pattern_Sequence_Information__item__tGPSID),
        ('tGSN', __Transmission_Gap_Pattern_Sequence_Information__item__tGSN),
        ('tGL1', __Transmission_Gap_Pattern_Sequence_Information__item__tGL1),
        ('tGL2', __Transmission_Gap_Pattern_Sequence_Information__item__tGL2),
        ('tGD', __Transmission_Gap_Pattern_Sequence_Information__item__tGD),
        ('tGPL1', __Transmission_Gap_Pattern_Sequence_Information__item__tGPL1),
        ('uplink-Compressed-Mode-Method', __Transmission_Gap_Pattern_Sequence_Information__item__uplink_Compressed_Mode_Method),
        ('iE-Extensions', __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions),
        ])
    _Transmission_Gap_Pattern_Sequence_Information__item_._ext = []
    Transmission_Gap_Pattern_Sequence_Information._cont = _Transmission_Gap_Pattern_Sequence_Information__item_
    Transmission_Gap_Pattern_Sequence_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-Information-ExtIEs >-----#
    Transmission_Gap_Pattern_Sequence_Information_ExtIEs = CLASS(name='Transmission-Gap-Pattern-Sequence-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Transmission_Gap_Pattern_Sequence_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TGD >-----#
    TGD = INT(name='TGD', mode=MODE_TYPE)
    TGD._const_val = ASN1Set(rv=[0], rr=[ASN1RangeInt(lb=15, ub=269)], ev=None, er=[])
    
    #-----< TGPRC >-----#
    TGPRC = INT(name='TGPRC', mode=MODE_TYPE)
    TGPRC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< TGPSID >-----#
    TGPSID = INT(name='TGPSID', mode=MODE_TYPE)
    TGPSID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< TGSN >-----#
    TGSN = INT(name='TGSN', mode=MODE_TYPE)
    TGSN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< Uplink-Compressed-Mode-Method >-----#
    Uplink_Compressed_Mode_Method = ENUM(name='Uplink-Compressed-Mode-Method', mode=MODE_TYPE)
    Uplink_Compressed_Mode_Method._cont = ASN1Dict([('sFdiv2', 0), ('higher-layer-scheduling', 1)])
    Uplink_Compressed_Mode_Method._ext = []
    
    #-----< GapDuration >-----#
    GapDuration = INT(name='GapDuration', mode=MODE_TYPE)
    GapDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=144)], ev=[], er=[])
    
    #-----< GapLength >-----#
    GapLength = INT(name='GapLength', mode=MODE_TYPE)
    GapLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    
    #-----< Active-Pattern-Sequence-Information >-----#
    Active_Pattern_Sequence_Information = SEQ(name='Active-Pattern-Sequence-Information', mode=MODE_TYPE)
    _Active_Pattern_Sequence_Information_cMConfigurationChangeCFN = INT(name='cMConfigurationChangeCFN', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CFN')))
    _Active_Pattern_Sequence_Information_transmission_Gap_Pattern_Sequence_Status = SEQ_OF(name='transmission-Gap-Pattern-Sequence-Status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Transmission-Gap-Pattern-Sequence-Status-List')), opt=True)
    _Active_Pattern_Sequence_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Active_Pattern_Sequence_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id._const_tab = ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id._const_tab_at = None
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality._const_tab = ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue._const_tab = ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Active_Pattern_Sequence_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Active_Pattern_Sequence_Information_iE_Extensions__item__id),
        ('criticality', ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue),
        ])
    __Active_Pattern_Sequence_Information_iE_Extensions__item_._ext = None
    _Active_Pattern_Sequence_Information_iE_Extensions._cont = __Active_Pattern_Sequence_Information_iE_Extensions__item_
    _Active_Pattern_Sequence_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Active_Pattern_Sequence_Information._cont = ASN1Dict([
        ('cMConfigurationChangeCFN', _Active_Pattern_Sequence_Information_cMConfigurationChangeCFN),
        ('transmission-Gap-Pattern-Sequence-Status', _Active_Pattern_Sequence_Information_transmission_Gap_Pattern_Sequence_Status),
        ('iE-Extensions', _Active_Pattern_Sequence_Information_iE_Extensions),
        ])
    Active_Pattern_Sequence_Information._ext = []
    
    #-----< Active-Pattern-Sequence-Information-ExtIEs >-----#
    Active_Pattern_Sequence_Information_ExtIEs = CLASS(name='Active-Pattern-Sequence-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Active_Pattern_Sequence_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-Status-List >-----#
    Transmission_Gap_Pattern_Sequence_Status_List = SEQ_OF(name='Transmission-Gap-Pattern-Sequence-Status-List', mode=MODE_TYPE)
    _Transmission_Gap_Pattern_Sequence_Status_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPSID = INT(name='tGPSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TGPSID')))
    __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPRC = INT(name='tGPRC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TGPRC')))
    __Transmission_Gap_Pattern_Sequence_Status_List__item__tGCFN = INT(name='tGCFN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CFN')))
    __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id._const_tab = _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id._const_tab_at = None
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality._const_tab = _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality_tab
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue._const_tab = _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue_tab
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id),
        ('criticality', ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue),
        ])
    ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_._ext = None
    __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions._cont = ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_
    __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _Transmission_Gap_Pattern_Sequence_Status_List__item_._cont = ASN1Dict([
        ('tGPSID', __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPSID),
        ('tGPRC', __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPRC),
        ('tGCFN', __Transmission_Gap_Pattern_Sequence_Status_List__item__tGCFN),
        ('iE-Extensions', __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions),
        ])
    _Transmission_Gap_Pattern_Sequence_Status_List__item_._ext = []
    Transmission_Gap_Pattern_Sequence_Status_List._cont = _Transmission_Gap_Pattern_Sequence_Status_List__item_
    Transmission_Gap_Pattern_Sequence_Status_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    
    #-----< Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs >-----#
    Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs = CLASS(name='Transmission-Gap-Pattern-Sequence-Status-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DCH-Information >-----#
    DCH_Information = SEQ(name='DCH-Information', mode=MODE_TYPE)
    _DCH_Information_tFCS = SEQ_OF(name='tFCS', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TFCS')))
    _DCH_Information_trChInfo = SEQ_OF(name='trChInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TrChInfoList')))
    _DCH_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___DCH_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____DCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Information_iE_Extensions__item__id._const_tab = ____DCH_Information_iE_Extensions__item__id_tab
    ___DCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___DCH_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___DCH_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Information_iE_Extensions__item__criticality._const_tab = ____DCH_Information_iE_Extensions__item__criticality_tab
    ___DCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DCH_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DCH_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____DCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DCH_Information_iE_Extensions__item__extensionValue._const_tab = ____DCH_Information_iE_Extensions__item__extensionValue_tab
    ___DCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DCH_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DCH_Information_iE_Extensions__item__id),
        ('criticality', ___DCH_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___DCH_Information_iE_Extensions__item__extensionValue),
        ])
    __DCH_Information_iE_Extensions__item_._ext = None
    _DCH_Information_iE_Extensions._cont = __DCH_Information_iE_Extensions__item_
    _DCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DCH_Information._cont = ASN1Dict([
        ('tFCS', _DCH_Information_tFCS),
        ('trChInfo', _DCH_Information_trChInfo),
        ('iE-Extensions', _DCH_Information_iE_Extensions),
        ])
    DCH_Information._ext = []
    
    #-----< DCH-Information-ExtIEs >-----#
    DCH_Information_ExtIEs = CLASS(name='DCH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    DCH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TrChInfoList >-----#
    TrChInfoList = SEQ_OF(name='TrChInfoList', mode=MODE_TYPE)
    _TrChInfoList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UL-TrCHInfo')))
    TrChInfoList._cont = _TrChInfoList__item_
    TrChInfoList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UL-TrCHInfo >-----#
    UL_TrCHInfo = SEQ(name='UL-TrCHInfo', mode=MODE_TYPE)
    _UL_TrCHInfo_uL_TrCHtype = ENUM(name='uL-TrCHtype', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UL-TrCHType')))
    _UL_TrCHInfo_tfs = SEQ(name='tfs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet')))
    _UL_TrCHInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_TrCHInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UL_TrCHInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_TrCHInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UL_TrCHInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TrCHInfo_iE_Extensions__item__id._const_tab = ____UL_TrCHInfo_iE_Extensions__item__id_tab
    ___UL_TrCHInfo_iE_Extensions__item__id._const_tab_at = None
    ___UL_TrCHInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_TrCHInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_TrCHInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UL_TrCHInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TrCHInfo_iE_Extensions__item__criticality._const_tab = ____UL_TrCHInfo_iE_Extensions__item__criticality_tab
    ___UL_TrCHInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_TrCHInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_TrCHInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_TrCHInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UL_TrCHInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_TrCHInfo_iE_Extensions__item__extensionValue._const_tab = ____UL_TrCHInfo_iE_Extensions__item__extensionValue_tab
    ___UL_TrCHInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_TrCHInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_TrCHInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_TrCHInfo_iE_Extensions__item__id),
        ('criticality', ___UL_TrCHInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_TrCHInfo_iE_Extensions__item__extensionValue),
        ])
    __UL_TrCHInfo_iE_Extensions__item_._ext = None
    _UL_TrCHInfo_iE_Extensions._cont = __UL_TrCHInfo_iE_Extensions__item_
    _UL_TrCHInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_TrCHInfo._cont = ASN1Dict([
        ('uL-TrCHtype', _UL_TrCHInfo_uL_TrCHtype),
        ('tfs', _UL_TrCHInfo_tfs),
        ('iE-Extensions', _UL_TrCHInfo_iE_Extensions),
        ])
    UL_TrCHInfo._ext = []
    
    #-----< UL-TrCHInfo-ExtIEs >-----#
    UL_TrCHInfo_ExtIEs = CLASS(name='UL-TrCHInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UL_TrCHInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UL-TrCHType >-----#
    UL_TrCHType = ENUM(name='UL-TrCHType', mode=MODE_TYPE)
    UL_TrCHType._cont = ASN1Dict([('dch', 0), ('usch', 1)])
    UL_TrCHType._ext = []
    
    #-----< E-DPCH-Information >-----#
    E_DPCH_Information = SEQ(name='E-DPCH-Information', mode=MODE_TYPE)
    _E_DPCH_Information_maxSet_E_DPDCHs = ENUM(name='maxSet-E-DPDCHs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Max-Set-E-DPDCHs')))
    _E_DPCH_Information_ul_PunctureLimit = INT(name='ul-PunctureLimit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PuncturingLimit')))
    _E_DPCH_Information_e_TFCS_Information = SEQ(name='e-TFCS-Information', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'E-TFCS-Information')))
    _E_DPCH_Information_e_TTI = ENUM(name='e-TTI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'E-TTI')))
    _E_DPCH_Information_e_DPCCH_PO = INT(name='e-DPCCH-PO', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'E-DPCCH-PO')), opt=True)
    _E_DPCH_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_DPCH_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___E_DPCH_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_DPCH_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____E_DPCH_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DPCH_Information_iE_Extensions__item__id._const_tab = ____E_DPCH_Information_iE_Extensions__item__id_tab
    ___E_DPCH_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_DPCH_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_DPCH_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_DPCH_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____E_DPCH_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DPCH_Information_iE_Extensions__item__criticality._const_tab = ____E_DPCH_Information_iE_Extensions__item__criticality_tab
    ___E_DPCH_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_DPCH_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_DPCH_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_DPCH_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____E_DPCH_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_DPCH_Information_iE_Extensions__item__extensionValue._const_tab = ____E_DPCH_Information_iE_Extensions__item__extensionValue_tab
    ___E_DPCH_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_DPCH_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_DPCH_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_DPCH_Information_iE_Extensions__item__id),
        ('criticality', ___E_DPCH_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_DPCH_Information_iE_Extensions__item__extensionValue),
        ])
    __E_DPCH_Information_iE_Extensions__item_._ext = None
    _E_DPCH_Information_iE_Extensions._cont = __E_DPCH_Information_iE_Extensions__item_
    _E_DPCH_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_DPCH_Information._cont = ASN1Dict([
        ('maxSet-E-DPDCHs', _E_DPCH_Information_maxSet_E_DPDCHs),
        ('ul-PunctureLimit', _E_DPCH_Information_ul_PunctureLimit),
        ('e-TFCS-Information', _E_DPCH_Information_e_TFCS_Information),
        ('e-TTI', _E_DPCH_Information_e_TTI),
        ('e-DPCCH-PO', _E_DPCH_Information_e_DPCCH_PO),
        ('iE-Extensions', _E_DPCH_Information_iE_Extensions),
        ])
    E_DPCH_Information._ext = []
    
    #-----< E-DPCH-Information-ExtIEs >-----#
    E_DPCH_Information_ExtIEs = CLASS(name='E-DPCH-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    E_DPCH_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Max-Set-E-DPDCHs >-----#
    Max_Set_E_DPDCHs = ENUM(name='Max-Set-E-DPDCHs', mode=MODE_TYPE)
    Max_Set_E_DPDCHs._cont = ASN1Dict([('vN64', 0), ('vN32', 1), ('vN16', 2), ('vN8', 3), ('v2xN4', 4), ('v2xN2', 5), ('v2xN2plus2xN4', 6)])
    Max_Set_E_DPDCHs._ext = []
    
    #-----< E-TFCS-Information >-----#
    E_TFCS_Information = SEQ(name='E-TFCS-Information', mode=MODE_TYPE)
    _E_TFCS_Information_e_DCH_TFCS_Index = INT(name='e-DCH-TFCS-Index', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'E-DCH-TFCS-Index')))
    _E_TFCS_Information_reference_E_TFCI_Information = SEQ_OF(name='reference-E-TFCI-Information', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Reference-E-TFCI-Information')), opt=True)
    _E_TFCS_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __E_TFCS_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___E_TFCS_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____E_TFCS_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____E_TFCS_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCS_Information_iE_Extensions__item__id._const_tab = ____E_TFCS_Information_iE_Extensions__item__id_tab
    ___E_TFCS_Information_iE_Extensions__item__id._const_tab_at = None
    ___E_TFCS_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___E_TFCS_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____E_TFCS_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____E_TFCS_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCS_Information_iE_Extensions__item__criticality._const_tab = ____E_TFCS_Information_iE_Extensions__item__criticality_tab
    ___E_TFCS_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___E_TFCS_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___E_TFCS_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____E_TFCS_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____E_TFCS_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___E_TFCS_Information_iE_Extensions__item__extensionValue._const_tab = ____E_TFCS_Information_iE_Extensions__item__extensionValue_tab
    ___E_TFCS_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___E_TFCS_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __E_TFCS_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___E_TFCS_Information_iE_Extensions__item__id),
        ('criticality', ___E_TFCS_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___E_TFCS_Information_iE_Extensions__item__extensionValue),
        ])
    __E_TFCS_Information_iE_Extensions__item_._ext = None
    _E_TFCS_Information_iE_Extensions._cont = __E_TFCS_Information_iE_Extensions__item_
    _E_TFCS_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    E_TFCS_Information._cont = ASN1Dict([
        ('e-DCH-TFCS-Index', _E_TFCS_Information_e_DCH_TFCS_Index),
        ('reference-E-TFCI-Information', _E_TFCS_Information_reference_E_TFCI_Information),
        ('iE-Extensions', _E_TFCS_Information_iE_Extensions),
        ])
    E_TFCS_Information._ext = []
    
    #-----< E-TFCS-Information-ExtIEs >-----#
    E_TFCS_Information_ExtIEs = CLASS(name='E-TFCS-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    E_TFCS_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< E-DCH-TFCS-Index >-----#
    E_DCH_TFCS_Index = INT(name='E-DCH-TFCS-Index', mode=MODE_TYPE)
    E_DCH_TFCS_Index._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=[], er=[])
    
    #-----< Reference-E-TFCI-Information >-----#
    Reference_E_TFCI_Information = SEQ_OF(name='Reference-E-TFCI-Information', mode=MODE_TYPE)
    _Reference_E_TFCI_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Reference-E-TFCI-Information-Item')))
    Reference_E_TFCI_Information._cont = _Reference_E_TFCI_Information__item_
    Reference_E_TFCI_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Reference-E-TFCI-Information-Item >-----#
    Reference_E_TFCI_Information_Item = SEQ(name='Reference-E-TFCI-Information-Item', mode=MODE_TYPE)
    _Reference_E_TFCI_Information_Item_reference_E_TFCI = INT(name='reference-E-TFCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'E-TFCI')))
    _Reference_E_TFCI_Information_Item_reference_E_TFCI_PO = INT(name='reference-E-TFCI-PO', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'Reference-E-TFCI-PO')))
    _Reference_E_TFCI_Information_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Reference_E_TFCI_Information_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab = ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab_at = None
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab = ____Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab = ____Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Reference_E_TFCI_Information_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id),
        ('criticality', ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue),
        ])
    __Reference_E_TFCI_Information_Item_iE_Extensions__item_._ext = None
    _Reference_E_TFCI_Information_Item_iE_Extensions._cont = __Reference_E_TFCI_Information_Item_iE_Extensions__item_
    _Reference_E_TFCI_Information_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Reference_E_TFCI_Information_Item._cont = ASN1Dict([
        ('reference-E-TFCI', _Reference_E_TFCI_Information_Item_reference_E_TFCI),
        ('reference-E-TFCI-PO', _Reference_E_TFCI_Information_Item_reference_E_TFCI_PO),
        ('iE-Extensions', _Reference_E_TFCI_Information_Item_iE_Extensions),
        ])
    Reference_E_TFCI_Information_Item._ext = []
    
    #-----< Reference-E-TFCI-Information-Item-ExtIEs >-----#
    Reference_E_TFCI_Information_Item_ExtIEs = CLASS(name='Reference-E-TFCI-Information-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    Reference_E_TFCI_Information_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Reference-E-TFCI-PO >-----#
    Reference_E_TFCI_PO = INT(name='Reference-E-TFCI-PO', mode=MODE_TYPE)
    Reference_E_TFCI_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< E-TFCI >-----#
    E_TFCI = INT(name='E-TFCI', mode=MODE_TYPE)
    E_TFCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< E-TTI >-----#
    E_TTI = ENUM(name='E-TTI', mode=MODE_TYPE)
    E_TTI._cont = ASN1Dict([('e-TTI-2ms', 0), ('e-TTI-10ms', 1)])
    E_TTI._ext = []
    
    #-----< E-DPCCH-PO >-----#
    E_DPCCH_PO = INT(name='E-DPCCH-PO', mode=MODE_TYPE)
    E_DPCCH_PO._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8)], ev=None, er=[])
    
    #-----< CellParameterID >-----#
    CellParameterID = INT(name='CellParameterID', mode=MODE_TYPE)
    CellParameterID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=[], er=[])
    
    #-----< TFCI-Coding >-----#
    TFCI_Coding = ENUM(name='TFCI-Coding', mode=MODE_TYPE)
    TFCI_Coding._cont = ASN1Dict([('v4', 0), ('v8', 1), ('v16', 2), ('v32', 3)])
    TFCI_Coding._ext = []
    
    #-----< RepetitionLength >-----#
    RepetitionLength = INT(name='RepetitionLength', mode=MODE_TYPE)
    RepetitionLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=63)], ev=None, er=[])
    
    #-----< RepetitionPeriod >-----#
    RepetitionPeriod = ENUM(name='RepetitionPeriod', mode=MODE_TYPE)
    RepetitionPeriod._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v4', 2), ('v8', 3), ('v16', 4), ('v32', 5), ('v64', 6)])
    RepetitionPeriod._ext = []
    
    #-----< TDD-DPCHOffset >-----#
    TDD_DPCHOffset = CHOICE(name='TDD-DPCHOffset', mode=MODE_TYPE)
    _TDD_DPCHOffset_initialOffset = INT(name='initialOffset', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TDD_DPCHOffset_initialOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _TDD_DPCHOffset_noinitialOffset = INT(name='noinitialOffset', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TDD_DPCHOffset_noinitialOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    TDD_DPCHOffset._cont = ASN1Dict([
        ('initialOffset', _TDD_DPCHOffset_initialOffset),
        ('noinitialOffset', _TDD_DPCHOffset_noinitialOffset),
        ])
    TDD_DPCHOffset._ext = None
    
    #-----< UL-Timeslot-Information >-----#
    UL_Timeslot_Information = SEQ_OF(name='UL-Timeslot-Information', mode=MODE_TYPE)
    _UL_Timeslot_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UL-Timeslot-InformationItem')))
    UL_Timeslot_Information._cont = _UL_Timeslot_Information__item_
    UL_Timeslot_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< maxNrOfULTSs >-----#
    maxNrOfULTSs = INT(name='maxNrOfULTSs', mode=MODE_VALUE)
    maxNrOfULTSs._val = 15
    
    #-----< UL-Timeslot-InformationItem >-----#
    UL_Timeslot_InformationItem = SEQ(name='UL-Timeslot-InformationItem', mode=MODE_TYPE)
    _UL_Timeslot_InformationItem_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TimeSlot')))
    _UL_Timeslot_InformationItem_midambleShiftAndBurstType = CHOICE(name='midambleShiftAndBurstType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MidambleShiftAndBurstType')))
    _UL_Timeslot_InformationItem_tFCI_Presence = BOOL(name='tFCI-Presence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UL_Timeslot_InformationItem_uL_Code_InformationList = SEQ_OF(name='uL-Code-InformationList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TDD-UL-Code-Information')))
    _UL_Timeslot_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UL_Timeslot_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab = ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___UL_Timeslot_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab = ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UL_Timeslot_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UL_Timeslot_InformationItem_iE_Extensions__item__id),
        ('criticality', ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __UL_Timeslot_InformationItem_iE_Extensions__item_._ext = None
    _UL_Timeslot_InformationItem_iE_Extensions._cont = __UL_Timeslot_InformationItem_iE_Extensions__item_
    _UL_Timeslot_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UL_Timeslot_InformationItem._cont = ASN1Dict([
        ('timeSlot', _UL_Timeslot_InformationItem_timeSlot),
        ('midambleShiftAndBurstType', _UL_Timeslot_InformationItem_midambleShiftAndBurstType),
        ('tFCI-Presence', _UL_Timeslot_InformationItem_tFCI_Presence),
        ('uL-Code-InformationList', _UL_Timeslot_InformationItem_uL_Code_InformationList),
        ('iE-Extensions', _UL_Timeslot_InformationItem_iE_Extensions),
        ])
    UL_Timeslot_InformationItem._ext = []
    
    #-----< UL-Timeslot-InformationItem-ExtIEs >-----#
    UL_Timeslot_InformationItem_ExtIEs = CLASS(name='UL-Timeslot-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UL_Timeslot_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TimeSlot >-----#
    TimeSlot = INT(name='TimeSlot', mode=MODE_TYPE)
    TimeSlot._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< MidambleShiftAndBurstType >-----#
    MidambleShiftAndBurstType = CHOICE(name='MidambleShiftAndBurstType', mode=MODE_TYPE)
    _MidambleShiftAndBurstType_type1 = SEQ(name='type1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType_type1_midambleConfigurationBurstType1And3 = ENUM(name='midambleConfigurationBurstType1And3', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MidambleConfigurationBurstType1And3')))
    __MidambleShiftAndBurstType_type1_midambleAllocationMode = CHOICE(name='midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType_type1_midambleAllocationMode_defaultMidamble = NULL(name='defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type1_midambleAllocationMode_commonMidamble = NULL(name='commonMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type1_midambleAllocationMode_ueSpecificMidamble = INT(name='ueSpecificMidamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MidambleShiftLong')))
    __MidambleShiftAndBurstType_type1_midambleAllocationMode._cont = ASN1Dict([
        ('defaultMidamble', ___MidambleShiftAndBurstType_type1_midambleAllocationMode_defaultMidamble),
        ('commonMidamble', ___MidambleShiftAndBurstType_type1_midambleAllocationMode_commonMidamble),
        ('ueSpecificMidamble', ___MidambleShiftAndBurstType_type1_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType_type1_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType_type1._cont = ASN1Dict([
        ('midambleConfigurationBurstType1And3', __MidambleShiftAndBurstType_type1_midambleConfigurationBurstType1And3),
        ('midambleAllocationMode', __MidambleShiftAndBurstType_type1_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType_type1._ext = []
    _MidambleShiftAndBurstType_type2 = SEQ(name='type2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType_type2_midambleConfigurationBurstType2 = ENUM(name='midambleConfigurationBurstType2', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MidambleConfigurationBurstType2')))
    __MidambleShiftAndBurstType_type2_midambleAllocationMode = CHOICE(name='midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType_type2_midambleAllocationMode_defaultMidamble = NULL(name='defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type2_midambleAllocationMode_commonMidamble = NULL(name='commonMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type2_midambleAllocationMode_ueSpecificMidamble = INT(name='ueSpecificMidamble', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MidambleShiftShort')))
    __MidambleShiftAndBurstType_type2_midambleAllocationMode._cont = ASN1Dict([
        ('defaultMidamble', ___MidambleShiftAndBurstType_type2_midambleAllocationMode_defaultMidamble),
        ('commonMidamble', ___MidambleShiftAndBurstType_type2_midambleAllocationMode_commonMidamble),
        ('ueSpecificMidamble', ___MidambleShiftAndBurstType_type2_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType_type2_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType_type2._cont = ASN1Dict([
        ('midambleConfigurationBurstType2', __MidambleShiftAndBurstType_type2_midambleConfigurationBurstType2),
        ('midambleAllocationMode', __MidambleShiftAndBurstType_type2_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType_type2._ext = []
    _MidambleShiftAndBurstType_type3 = SEQ(name='type3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MidambleShiftAndBurstType_type3_midambleConfigurationBurstType1And3 = ENUM(name='midambleConfigurationBurstType1And3', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MidambleConfigurationBurstType1And3')))
    __MidambleShiftAndBurstType_type3_midambleAllocationMode = CHOICE(name='midambleAllocationMode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___MidambleShiftAndBurstType_type3_midambleAllocationMode_defaultMidamble = NULL(name='defaultMidamble', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___MidambleShiftAndBurstType_type3_midambleAllocationMode_ueSpecificMidamble = INT(name='ueSpecificMidamble', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MidambleShiftLong')))
    __MidambleShiftAndBurstType_type3_midambleAllocationMode._cont = ASN1Dict([
        ('defaultMidamble', ___MidambleShiftAndBurstType_type3_midambleAllocationMode_defaultMidamble),
        ('ueSpecificMidamble', ___MidambleShiftAndBurstType_type3_midambleAllocationMode_ueSpecificMidamble),
        ])
    __MidambleShiftAndBurstType_type3_midambleAllocationMode._ext = []
    _MidambleShiftAndBurstType_type3._cont = ASN1Dict([
        ('midambleConfigurationBurstType1And3', __MidambleShiftAndBurstType_type3_midambleConfigurationBurstType1And3),
        ('midambleAllocationMode', __MidambleShiftAndBurstType_type3_midambleAllocationMode),
        ])
    _MidambleShiftAndBurstType_type3._ext = []
    MidambleShiftAndBurstType._cont = ASN1Dict([
        ('type1', _MidambleShiftAndBurstType_type1),
        ('type2', _MidambleShiftAndBurstType_type2),
        ('type3', _MidambleShiftAndBurstType_type3),
        ])
    MidambleShiftAndBurstType._ext = []
    
    #-----< MidambleShiftLong >-----#
    MidambleShiftLong = INT(name='MidambleShiftLong', mode=MODE_TYPE)
    MidambleShiftLong._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< MidambleShiftShort >-----#
    MidambleShiftShort = INT(name='MidambleShiftShort', mode=MODE_TYPE)
    MidambleShiftShort._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=5)], ev=None, er=[])
    
    #-----< MidambleConfigurationBurstType1And3 >-----#
    MidambleConfigurationBurstType1And3 = ENUM(name='MidambleConfigurationBurstType1And3', mode=MODE_TYPE)
    MidambleConfigurationBurstType1And3._cont = ASN1Dict([('v4', 0), ('v8', 1), ('v16', 2)])
    MidambleConfigurationBurstType1And3._ext = None
    
    #-----< MidambleConfigurationBurstType2 >-----#
    MidambleConfigurationBurstType2 = ENUM(name='MidambleConfigurationBurstType2', mode=MODE_TYPE)
    MidambleConfigurationBurstType2._cont = ASN1Dict([('v3', 0), ('v6', 1)])
    MidambleConfigurationBurstType2._ext = None
    
    #-----< TDD-UL-Code-Information >-----#
    TDD_UL_Code_Information = SEQ_OF(name='TDD-UL-Code-Information', mode=MODE_TYPE)
    _TDD_UL_Code_Information__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'TDD-UL-Code-InformationItem')))
    TDD_UL_Code_Information._cont = _TDD_UL_Code_Information__item_
    TDD_UL_Code_Information._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=240)], ev=None, er=[])
    
    #-----< maxNrOfDPCHs >-----#
    maxNrOfDPCHs = INT(name='maxNrOfDPCHs', mode=MODE_VALUE)
    maxNrOfDPCHs._val = 240
    
    #-----< TDD-UL-Code-InformationItem >-----#
    TDD_UL_Code_InformationItem = SEQ(name='TDD-UL-Code-InformationItem', mode=MODE_TYPE)
    _TDD_UL_Code_InformationItem_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TDD-ChannelisationCode')))
    _TDD_UL_Code_InformationItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TDD_UL_Code_InformationItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id._const_tab = ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id._const_tab_at = None
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality._const_tab = ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab = ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TDD_UL_Code_InformationItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TDD_UL_Code_InformationItem_iE_Extensions__item__id),
        ('criticality', ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality),
        ('extensionValue', ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue),
        ])
    __TDD_UL_Code_InformationItem_iE_Extensions__item_._ext = None
    _TDD_UL_Code_InformationItem_iE_Extensions._cont = __TDD_UL_Code_InformationItem_iE_Extensions__item_
    _TDD_UL_Code_InformationItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TDD_UL_Code_InformationItem._cont = ASN1Dict([
        ('tdd-ChannelisationCode', _TDD_UL_Code_InformationItem_tdd_ChannelisationCode),
        ('iE-Extensions', _TDD_UL_Code_InformationItem_iE_Extensions),
        ])
    TDD_UL_Code_InformationItem._ext = []
    
    #-----< TDD-UL-Code-InformationItem-ExtIEs >-----#
    TDD_UL_Code_InformationItem_ExtIEs = CLASS(name='TDD-UL-Code-InformationItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    TDD_UL_Code_InformationItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TDD-ChannelisationCode >-----#
    TDD_ChannelisationCode = ENUM(name='TDD-ChannelisationCode', mode=MODE_TYPE)
    TDD_ChannelisationCode._cont = ASN1Dict([('chCode1div1', 0), ('chCode2div1', 1), ('chCode2div2', 2), ('chCode4div1', 3), ('chCode4div2', 4), ('chCode4div3', 5), ('chCode4div4', 6), ('chCode8div1', 7), ('chCode8div2', 8), ('chCode8div3', 9), ('chCode8div4', 10), ('chCode8div5', 11), ('chCode8div6', 12), ('chCode8div7', 13), ('chCode8div8', 14), ('chCode16div1', 15), ('chCode16div2', 16), ('chCode16div3', 17), ('chCode16div4', 18), ('chCode16div5', 19), ('chCode16div6', 20), ('chCode16div7', 21), ('chCode16div8', 22), ('chCode16div9', 23), ('chCode16div10', 24), ('chCode16div11', 25), ('chCode16div12', 26), ('chCode16div13', 27), ('chCode16div14', 28), ('chCode16div15', 29), ('chCode16div16', 30)])
    TDD_ChannelisationCode._ext = []
    
    #-----< SpecialBurstScheduling >-----#
    SpecialBurstScheduling = INT(name='SpecialBurstScheduling', mode=MODE_TYPE)
    SpecialBurstScheduling._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< UTDOA-CELLFACH >-----#
    UTDOA_CELLFACH = SEQ(name='UTDOA-CELLFACH', mode=MODE_TYPE)
    _UTDOA_CELLFACH_pRACHparameters = SEQ_OF(name='pRACHparameters', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PRACHparameters')))
    _UTDOA_CELLFACH_cRNTI = BIT_STR(name='cRNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'C-RNTI')))
    _UTDOA_CELLFACH_uschParameters = SEQ(name='uschParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UschParameters')), opt=True)
    _UTDOA_CELLFACH_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTDOA_CELLFACH_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTDOA_CELLFACH_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTDOA_CELLFACH_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOA_CELLFACH_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOA_CELLFACH_iE_Extensions__item__id._const_tab = ____UTDOA_CELLFACH_iE_Extensions__item__id_tab
    ___UTDOA_CELLFACH_iE_Extensions__item__id._const_tab_at = None
    ___UTDOA_CELLFACH_iE_Extensions__item__id._const_tab_id = 'id'
    ___UTDOA_CELLFACH_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTDOA_CELLFACH_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOA_CELLFACH_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOA_CELLFACH_iE_Extensions__item__criticality._const_tab = ____UTDOA_CELLFACH_iE_Extensions__item__criticality_tab
    ___UTDOA_CELLFACH_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTDOA_CELLFACH_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTDOA_CELLFACH_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTDOA_CELLFACH_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTDOA_CELLFACH_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTDOA_CELLFACH_iE_Extensions__item__extensionValue._const_tab = ____UTDOA_CELLFACH_iE_Extensions__item__extensionValue_tab
    ___UTDOA_CELLFACH_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTDOA_CELLFACH_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTDOA_CELLFACH_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTDOA_CELLFACH_iE_Extensions__item__id),
        ('criticality', ___UTDOA_CELLFACH_iE_Extensions__item__criticality),
        ('extensionValue', ___UTDOA_CELLFACH_iE_Extensions__item__extensionValue),
        ])
    __UTDOA_CELLFACH_iE_Extensions__item_._ext = None
    _UTDOA_CELLFACH_iE_Extensions._cont = __UTDOA_CELLFACH_iE_Extensions__item_
    _UTDOA_CELLFACH_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTDOA_CELLFACH._cont = ASN1Dict([
        ('pRACHparameters', _UTDOA_CELLFACH_pRACHparameters),
        ('cRNTI', _UTDOA_CELLFACH_cRNTI),
        ('uschParameters', _UTDOA_CELLFACH_uschParameters),
        ('iE-Extensions', _UTDOA_CELLFACH_iE_Extensions),
        ])
    UTDOA_CELLFACH._ext = []
    
    #-----< UTDOA-CELLFACH-ExtIEs >-----#
    UTDOA_CELLFACH_ExtIEs = CLASS(name='UTDOA-CELLFACH-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTDOA_CELLFACH_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRACHparameters >-----#
    PRACHparameters = SEQ_OF(name='PRACHparameters', mode=MODE_TYPE)
    _PRACHparameters__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PRACH-ChannelInfo')))
    PRACHparameters._cont = _PRACHparameters__item_
    PRACHparameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PRACH-ChannelInfo >-----#
    PRACH_ChannelInfo = SEQ(name='PRACH-ChannelInfo', mode=MODE_TYPE)
    _PRACH_ChannelInfo_pRACH_Info = CHOICE(name='pRACH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PRACH-Info')))
    _PRACH_ChannelInfo_tFS = SEQ(name='tFS', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet')))
    _PRACH_ChannelInfo_tFCS = SEQ_OF(name='tFCS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TFCS')))
    _PRACH_ChannelInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PRACH_ChannelInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PRACH_ChannelInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PRACH_ChannelInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PRACH_ChannelInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_ChannelInfo_iE_Extensions__item__id._const_tab = ____PRACH_ChannelInfo_iE_Extensions__item__id_tab
    ___PRACH_ChannelInfo_iE_Extensions__item__id._const_tab_at = None
    ___PRACH_ChannelInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___PRACH_ChannelInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PRACH_ChannelInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PRACH_ChannelInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_ChannelInfo_iE_Extensions__item__criticality._const_tab = ____PRACH_ChannelInfo_iE_Extensions__item__criticality_tab
    ___PRACH_ChannelInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PRACH_ChannelInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PRACH_ChannelInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PRACH_ChannelInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PRACH_ChannelInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PRACH_ChannelInfo_iE_Extensions__item__extensionValue._const_tab = ____PRACH_ChannelInfo_iE_Extensions__item__extensionValue_tab
    ___PRACH_ChannelInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PRACH_ChannelInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PRACH_ChannelInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PRACH_ChannelInfo_iE_Extensions__item__id),
        ('criticality', ___PRACH_ChannelInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___PRACH_ChannelInfo_iE_Extensions__item__extensionValue),
        ])
    __PRACH_ChannelInfo_iE_Extensions__item_._ext = None
    _PRACH_ChannelInfo_iE_Extensions._cont = __PRACH_ChannelInfo_iE_Extensions__item_
    _PRACH_ChannelInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PRACH_ChannelInfo._cont = ASN1Dict([
        ('pRACH-Info', _PRACH_ChannelInfo_pRACH_Info),
        ('tFS', _PRACH_ChannelInfo_tFS),
        ('tFCS', _PRACH_ChannelInfo_tFCS),
        ('iE-Extensions', _PRACH_ChannelInfo_iE_Extensions),
        ])
    PRACH_ChannelInfo._ext = []
    
    #-----< PRACH-ChannelInfo-ExtIEs >-----#
    PRACH_ChannelInfo_ExtIEs = CLASS(name='PRACH-ChannelInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PRACH_ChannelInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRACH-Info >-----#
    PRACH_Info = CHOICE(name='PRACH-Info', mode=MODE_TYPE)
    _PRACH_Info_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PRACH_Info_fdd_availableSignatures = BIT_STR(name='availableSignatures', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AvailableSignatures')))
    __PRACH_Info_fdd_availableSF = ENUM(name='availableSF', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'SF-PRACH')))
    __PRACH_Info_fdd_preambleScramblingCodeWordNumber = INT(name='preambleScramblingCodeWordNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PreambleScramblingCodeWordNumber')))
    __PRACH_Info_fdd_puncturingLimit = INT(name='puncturingLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PuncturingLimit')))
    __PRACH_Info_fdd_availableSubChannelNumbers = BIT_STR(name='availableSubChannelNumbers', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'AvailableSubChannelNumbers')))
    __PRACH_Info_fdd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___PRACH_Info_fdd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____PRACH_Info_fdd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____PRACH_Info_fdd_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PRACH_Info_fdd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PRACH_Info_fdd_iE_Extensions__item__id._const_tab = _____PRACH_Info_fdd_iE_Extensions__item__id_tab
    ____PRACH_Info_fdd_iE_Extensions__item__id._const_tab_at = None
    ____PRACH_Info_fdd_iE_Extensions__item__id._const_tab_id = 'id'
    ____PRACH_Info_fdd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____PRACH_Info_fdd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PRACH_Info_fdd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PRACH_Info_fdd_iE_Extensions__item__criticality._const_tab = _____PRACH_Info_fdd_iE_Extensions__item__criticality_tab
    ____PRACH_Info_fdd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____PRACH_Info_fdd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____PRACH_Info_fdd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____PRACH_Info_fdd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PRACH_Info_fdd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PRACH_Info_fdd_iE_Extensions__item__extensionValue._const_tab = _____PRACH_Info_fdd_iE_Extensions__item__extensionValue_tab
    ____PRACH_Info_fdd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____PRACH_Info_fdd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___PRACH_Info_fdd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____PRACH_Info_fdd_iE_Extensions__item__id),
        ('criticality', ____PRACH_Info_fdd_iE_Extensions__item__criticality),
        ('extensionValue', ____PRACH_Info_fdd_iE_Extensions__item__extensionValue),
        ])
    ___PRACH_Info_fdd_iE_Extensions__item_._ext = None
    __PRACH_Info_fdd_iE_Extensions._cont = ___PRACH_Info_fdd_iE_Extensions__item_
    __PRACH_Info_fdd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _PRACH_Info_fdd._cont = ASN1Dict([
        ('availableSignatures', __PRACH_Info_fdd_availableSignatures),
        ('availableSF', __PRACH_Info_fdd_availableSF),
        ('preambleScramblingCodeWordNumber', __PRACH_Info_fdd_preambleScramblingCodeWordNumber),
        ('puncturingLimit', __PRACH_Info_fdd_puncturingLimit),
        ('availableSubChannelNumbers', __PRACH_Info_fdd_availableSubChannelNumbers),
        ('iE-Extensions', __PRACH_Info_fdd_iE_Extensions),
        ])
    _PRACH_Info_fdd._ext = []
    _PRACH_Info_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PRACH_Info_tdd_timeSlot = INT(name='timeSlot', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TimeSlot')))
    __PRACH_Info_tdd_tdd_ChannelisationCode = ENUM(name='tdd-ChannelisationCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TDD-ChannelisationCode')))
    __PRACH_Info_tdd_maxPRACH_MidambleShifts = ENUM(name='maxPRACH-MidambleShifts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'MaxPRACH-MidambleShifts')))
    __PRACH_Info_tdd_pRACH_Midamble = ENUM(name='pRACH-Midamble', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PRACH-Midamble')))
    __PRACH_Info_tdd_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___PRACH_Info_tdd_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____PRACH_Info_tdd_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____PRACH_Info_tdd_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PRACH_Info_tdd_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PRACH_Info_tdd_iE_Extensions__item__id._const_tab = _____PRACH_Info_tdd_iE_Extensions__item__id_tab
    ____PRACH_Info_tdd_iE_Extensions__item__id._const_tab_at = None
    ____PRACH_Info_tdd_iE_Extensions__item__id._const_tab_id = 'id'
    ____PRACH_Info_tdd_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____PRACH_Info_tdd_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PRACH_Info_tdd_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PRACH_Info_tdd_iE_Extensions__item__criticality._const_tab = _____PRACH_Info_tdd_iE_Extensions__item__criticality_tab
    ____PRACH_Info_tdd_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____PRACH_Info_tdd_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____PRACH_Info_tdd_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____PRACH_Info_tdd_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PRACH_Info_tdd_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PRACH_Info_tdd_iE_Extensions__item__extensionValue._const_tab = _____PRACH_Info_tdd_iE_Extensions__item__extensionValue_tab
    ____PRACH_Info_tdd_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____PRACH_Info_tdd_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___PRACH_Info_tdd_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____PRACH_Info_tdd_iE_Extensions__item__id),
        ('criticality', ____PRACH_Info_tdd_iE_Extensions__item__criticality),
        ('extensionValue', ____PRACH_Info_tdd_iE_Extensions__item__extensionValue),
        ])
    ___PRACH_Info_tdd_iE_Extensions__item_._ext = None
    __PRACH_Info_tdd_iE_Extensions._cont = ___PRACH_Info_tdd_iE_Extensions__item_
    __PRACH_Info_tdd_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _PRACH_Info_tdd._cont = ASN1Dict([
        ('timeSlot', __PRACH_Info_tdd_timeSlot),
        ('tdd-ChannelisationCode', __PRACH_Info_tdd_tdd_ChannelisationCode),
        ('maxPRACH-MidambleShifts', __PRACH_Info_tdd_maxPRACH_MidambleShifts),
        ('pRACH-Midamble', __PRACH_Info_tdd_pRACH_Midamble),
        ('iE-Extensions', __PRACH_Info_tdd_iE_Extensions),
        ])
    _PRACH_Info_tdd._ext = []
    PRACH_Info._cont = ASN1Dict([
        ('fdd', _PRACH_Info_fdd),
        ('tdd', _PRACH_Info_tdd),
        ])
    PRACH_Info._ext = []
    
    #-----< PRACH-Info-FDD-ExtIEs >-----#
    PRACH_Info_FDD_ExtIEs = CLASS(name='PRACH-Info-FDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PRACH_Info_FDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PRACH-Info-TDD-ExtIEs >-----#
    PRACH_Info_TDD_ExtIEs = CLASS(name='PRACH-Info-TDD-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PRACH_Info_TDD_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SF-PRACH >-----#
    SF_PRACH = ENUM(name='SF-PRACH', mode=MODE_TYPE)
    SF_PRACH._cont = ASN1Dict([('sfpr32', 0), ('sfpr64', 1), ('sfpr128', 2), ('sfpr256', 3)])
    SF_PRACH._ext = []
    
    #-----< AvailableSignatures >-----#
    AvailableSignatures = BIT_STR(name='AvailableSignatures', mode=MODE_TYPE)
    AvailableSignatures._cont = ASN1Dict([('signature15', 0), ('signature14', 1), ('signature13', 2), ('signature12', 3), ('signature11', 4), ('signature10', 5), ('signature9', 6), ('signature8', 7), ('signature7', 8), ('signature6', 9), ('signature5', 10), ('signature4', 11), ('signature3', 12), ('signature2', 13), ('signature1', 14), ('signature0', 15)])
    AvailableSignatures._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< PreambleScramblingCodeWordNumber >-----#
    PreambleScramblingCodeWordNumber = INT(name='PreambleScramblingCodeWordNumber', mode=MODE_TYPE)
    PreambleScramblingCodeWordNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< PuncturingLimit >-----#
    PuncturingLimit = INT(name='PuncturingLimit', mode=MODE_TYPE)
    PuncturingLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< AvailableSubChannelNumbers >-----#
    AvailableSubChannelNumbers = BIT_STR(name='AvailableSubChannelNumbers', mode=MODE_TYPE)
    AvailableSubChannelNumbers._cont = ASN1Dict([('subCh11', 0), ('subCh10', 1), ('subCh9', 2), ('subCh8', 3), ('subCh7', 4), ('subCh6', 5), ('subCh5', 6), ('subCh4', 7), ('subCh3', 8), ('subCh2', 9), ('subCh1', 10), ('subCh0', 11)])
    AvailableSubChannelNumbers._const_sz = ASN1Set(rv=[12], rr=[], ev=None, er=[])
    
    #-----< ScramblingCodeType >-----#
    ScramblingCodeType = ENUM(name='ScramblingCodeType', mode=MODE_TYPE)
    ScramblingCodeType._cont = ASN1Dict([('shortSC', 0), ('longSC', 1)])
    ScramblingCodeType._ext = None
    
    #-----< UL-ScramblingCode >-----#
    UL_ScramblingCode = INT(name='UL-ScramblingCode', mode=MODE_TYPE)
    UL_ScramblingCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    
    #-----< NumberOfFBI-Bits >-----#
    NumberOfFBI_Bits = INT(name='NumberOfFBI-Bits', mode=MODE_TYPE)
    NumberOfFBI_Bits._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2)], ev=None, er=[])
    
    #-----< TransportFormatSet >-----#
    TransportFormatSet = SEQ(name='TransportFormatSet', mode=MODE_TYPE)
    _TransportFormatSet_dynamicPart = SEQ_OF(name='dynamicPart', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet-DynamicPartList')))
    _TransportFormatSet_semi_staticPart = SEQ(name='semi-staticPart', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet-Semi-staticPart')))
    _TransportFormatSet_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransportFormatSet_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___TransportFormatSet_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____TransportFormatSet_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_iE_Extensions__item__id._const_tab = ____TransportFormatSet_iE_Extensions__item__id_tab
    ___TransportFormatSet_iE_Extensions__item__id._const_tab_at = None
    ___TransportFormatSet_iE_Extensions__item__id._const_tab_id = 'id'
    ___TransportFormatSet_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TransportFormatSet_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_iE_Extensions__item__criticality._const_tab = ____TransportFormatSet_iE_Extensions__item__criticality_tab
    ___TransportFormatSet_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TransportFormatSet_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TransportFormatSet_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TransportFormatSet_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_iE_Extensions__item__extensionValue._const_tab = ____TransportFormatSet_iE_Extensions__item__extensionValue_tab
    ___TransportFormatSet_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TransportFormatSet_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TransportFormatSet_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TransportFormatSet_iE_Extensions__item__id),
        ('criticality', ___TransportFormatSet_iE_Extensions__item__criticality),
        ('extensionValue', ___TransportFormatSet_iE_Extensions__item__extensionValue),
        ])
    __TransportFormatSet_iE_Extensions__item_._ext = None
    _TransportFormatSet_iE_Extensions._cont = __TransportFormatSet_iE_Extensions__item_
    _TransportFormatSet_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransportFormatSet._cont = ASN1Dict([
        ('dynamicPart', _TransportFormatSet_dynamicPart),
        ('semi-staticPart', _TransportFormatSet_semi_staticPart),
        ('iE-Extensions', _TransportFormatSet_iE_Extensions),
        ])
    TransportFormatSet._ext = []
    
    #-----< TransportFormatSet-ExtIEs >-----#
    TransportFormatSet_ExtIEs = CLASS(name='TransportFormatSet-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    TransportFormatSet_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportFormatSet-DynamicPartList >-----#
    TransportFormatSet_DynamicPartList = SEQ_OF(name='TransportFormatSet-DynamicPartList', mode=MODE_TYPE)
    _TransportFormatSet_DynamicPartList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __TransportFormatSet_DynamicPartList__item__rlc_Size = INT(name='rlc-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RLC-Size')))
    __TransportFormatSet_DynamicPartList__item__numberOfTbsTTIList = SEQ_OF(name='numberOfTbsTTIList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___TransportFormatSet_DynamicPartList__item__numberOfTbsTTIList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'TbsTTIInfo')))
    __TransportFormatSet_DynamicPartList__item__numberOfTbsTTIList._cont = ___TransportFormatSet_DynamicPartList__item__numberOfTbsTTIList__item_
    __TransportFormatSet_DynamicPartList__item__numberOfTbsTTIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    __TransportFormatSet_DynamicPartList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id._const_tab = _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id._const_tab_at = None
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality._const_tab = _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue._const_tab = _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id),
        ('criticality', ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue),
        ])
    ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_._ext = None
    __TransportFormatSet_DynamicPartList__item__iE_Extensions._cont = ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_
    __TransportFormatSet_DynamicPartList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TransportFormatSet_DynamicPartList__item_._cont = ASN1Dict([
        ('rlc-Size', __TransportFormatSet_DynamicPartList__item__rlc_Size),
        ('numberOfTbsTTIList', __TransportFormatSet_DynamicPartList__item__numberOfTbsTTIList),
        ('iE-Extensions', __TransportFormatSet_DynamicPartList__item__iE_Extensions),
        ])
    _TransportFormatSet_DynamicPartList__item_._ext = []
    TransportFormatSet_DynamicPartList._cont = _TransportFormatSet_DynamicPartList__item_
    TransportFormatSet_DynamicPartList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< TransportFormatSet-DynamicPartList-ExtIEs >-----#
    TransportFormatSet_DynamicPartList_ExtIEs = CLASS(name='TransportFormatSet-DynamicPartList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    TransportFormatSet_DynamicPartList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TbsTTIInfo >-----#
    TbsTTIInfo = SEQ(name='TbsTTIInfo', mode=MODE_TYPE)
    _TbsTTIInfo_tTIInfo = ENUM(name='tTIInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet-TransmissionTimeIntervalDynamic')), opt=True)
    _TbsTTIInfo_numberOfTbs = INT(name='numberOfTbs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet-NrOfTransportBlocks')))
    _TbsTTIInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TbsTTIInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___TbsTTIInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____TbsTTIInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TbsTTIInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TbsTTIInfo_iE_Extensions__item__id._const_tab = ____TbsTTIInfo_iE_Extensions__item__id_tab
    ___TbsTTIInfo_iE_Extensions__item__id._const_tab_at = None
    ___TbsTTIInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___TbsTTIInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TbsTTIInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TbsTTIInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TbsTTIInfo_iE_Extensions__item__criticality._const_tab = ____TbsTTIInfo_iE_Extensions__item__criticality_tab
    ___TbsTTIInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TbsTTIInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TbsTTIInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TbsTTIInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TbsTTIInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TbsTTIInfo_iE_Extensions__item__extensionValue._const_tab = ____TbsTTIInfo_iE_Extensions__item__extensionValue_tab
    ___TbsTTIInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TbsTTIInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TbsTTIInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TbsTTIInfo_iE_Extensions__item__id),
        ('criticality', ___TbsTTIInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___TbsTTIInfo_iE_Extensions__item__extensionValue),
        ])
    __TbsTTIInfo_iE_Extensions__item_._ext = None
    _TbsTTIInfo_iE_Extensions._cont = __TbsTTIInfo_iE_Extensions__item_
    _TbsTTIInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TbsTTIInfo._cont = ASN1Dict([
        ('tTIInfo', _TbsTTIInfo_tTIInfo),
        ('numberOfTbs', _TbsTTIInfo_numberOfTbs),
        ('iE-Extensions', _TbsTTIInfo_iE_Extensions),
        ])
    TbsTTIInfo._ext = []
    
    #-----< TbsTTIInfo-ExtIEs >-----#
    TbsTTIInfo_ExtIEs = CLASS(name='TbsTTIInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    TbsTTIInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RLC-Size >-----#
    RLC_Size = INT(name='RLC-Size', mode=MODE_TYPE)
    RLC_Size._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=129, ub=5055)], ev=None, er=[])
    
    #-----< TransportFormatSet-NrOfTransportBlocks >-----#
    TransportFormatSet_NrOfTransportBlocks = INT(name='TransportFormatSet-NrOfTransportBlocks', mode=MODE_TYPE)
    TransportFormatSet_NrOfTransportBlocks._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=512)], ev=None, er=[])
    
    #-----< TransportFormatSet-Semi-staticPart >-----#
    TransportFormatSet_Semi_staticPart = SEQ(name='TransportFormatSet-Semi-staticPart', mode=MODE_TYPE)
    _TransportFormatSet_Semi_staticPart_transmissionTimeInterval = ENUM(name='transmissionTimeInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet-TransmissionTimeIntervalSemiStatic')))
    _TransportFormatSet_Semi_staticPart_channelCoding = ENUM(name='channelCoding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet-ChannelCodingType')))
    _TransportFormatSet_Semi_staticPart_codingRate = ENUM(name='codingRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet-CodingRate')), opt=True)
    _TransportFormatSet_Semi_staticPart_rateMatchingAttribute = INT(name='rateMatchingAttribute', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet-RateMatchingAttribute')))
    _TransportFormatSet_Semi_staticPart_cRC_Size = ENUM(name='cRC-Size', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TransportFormatSet-CRC-Size')))
    _TransportFormatSet_Semi_staticPart_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransportFormatSet_Semi_staticPart_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id._const_tab = ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id._const_tab_at = None
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id._const_tab_id = 'id'
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality._const_tab = ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue._const_tab = ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TransportFormatSet_Semi_staticPart_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id),
        ('criticality', ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality),
        ('extensionValue', ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue),
        ])
    __TransportFormatSet_Semi_staticPart_iE_Extensions__item_._ext = None
    _TransportFormatSet_Semi_staticPart_iE_Extensions._cont = __TransportFormatSet_Semi_staticPart_iE_Extensions__item_
    _TransportFormatSet_Semi_staticPart_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransportFormatSet_Semi_staticPart._cont = ASN1Dict([
        ('transmissionTimeInterval', _TransportFormatSet_Semi_staticPart_transmissionTimeInterval),
        ('channelCoding', _TransportFormatSet_Semi_staticPart_channelCoding),
        ('codingRate', _TransportFormatSet_Semi_staticPart_codingRate),
        ('rateMatchingAttribute', _TransportFormatSet_Semi_staticPart_rateMatchingAttribute),
        ('cRC-Size', _TransportFormatSet_Semi_staticPart_cRC_Size),
        ('iE-Extensions', _TransportFormatSet_Semi_staticPart_iE_Extensions),
        ])
    TransportFormatSet_Semi_staticPart._ext = []
    
    #-----< TransportFormatSet-Semi-staticPart-ExtIEs >-----#
    TransportFormatSet_Semi_staticPart_ExtIEs = CLASS(name='TransportFormatSet-Semi-staticPart-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    TransportFormatSet_Semi_staticPart_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TransportFormatSet-TransmissionTimeIntervalSemiStatic >-----#
    TransportFormatSet_TransmissionTimeIntervalSemiStatic = ENUM(name='TransportFormatSet-TransmissionTimeIntervalSemiStatic', mode=MODE_TYPE)
    TransportFormatSet_TransmissionTimeIntervalSemiStatic._cont = ASN1Dict([('msec-5', 0), ('msec-10', 1), ('msec-20', 2), ('msec-40', 3), ('msec-80', 4), ('dynamic', 5)])
    TransportFormatSet_TransmissionTimeIntervalSemiStatic._ext = []
    
    #-----< TransportFormatSet-ChannelCodingType >-----#
    TransportFormatSet_ChannelCodingType = ENUM(name='TransportFormatSet-ChannelCodingType', mode=MODE_TYPE)
    TransportFormatSet_ChannelCodingType._cont = ASN1Dict([('no-codingTDD', 0), ('convolutional-coding', 1), ('turbo-coding', 2)])
    TransportFormatSet_ChannelCodingType._ext = []
    
    #-----< TransportFormatSet-CodingRate >-----#
    TransportFormatSet_CodingRate = ENUM(name='TransportFormatSet-CodingRate', mode=MODE_TYPE)
    TransportFormatSet_CodingRate._cont = ASN1Dict([('half', 0), ('third', 1)])
    TransportFormatSet_CodingRate._ext = []
    
    #-----< TransportFormatSet-RateMatchingAttribute >-----#
    TransportFormatSet_RateMatchingAttribute = INT(name='TransportFormatSet-RateMatchingAttribute', mode=MODE_TYPE)
    TransportFormatSet_RateMatchingAttribute._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< TransportFormatSet-CRC-Size >-----#
    TransportFormatSet_CRC_Size = ENUM(name='TransportFormatSet-CRC-Size', mode=MODE_TYPE)
    TransportFormatSet_CRC_Size._cont = ASN1Dict([('v0', 0), ('v8', 1), ('v12', 2), ('v16', 3), ('v24', 4)])
    TransportFormatSet_CRC_Size._ext = []
    
    #-----< TransportFormatSet-TransmissionTimeIntervalDynamic >-----#
    TransportFormatSet_TransmissionTimeIntervalDynamic = ENUM(name='TransportFormatSet-TransmissionTimeIntervalDynamic', mode=MODE_TYPE)
    TransportFormatSet_TransmissionTimeIntervalDynamic._cont = ASN1Dict([('msec-10', 0), ('msec-20', 1), ('msec-40', 2), ('msec-80', 3), ('dynamic', 4)])
    TransportFormatSet_TransmissionTimeIntervalDynamic._ext = []
    
    #-----< TFCS >-----#
    TFCS = SEQ_OF(name='TFCS', mode=MODE_TYPE)
    _TFCS__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CTFC')))
    TFCS._cont = _TFCS__item_
    TFCS._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< CTFC >-----#
    CTFC = CHOICE(name='CTFC', mode=MODE_TYPE)
    _CTFC_ctfc2Bit = SEQ_OF(name='ctfc2Bit', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CTFC_ctfc2Bit__item_ = INT(name='_item_', mode=MODE_TYPE)
    __CTFC_ctfc2Bit__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    _CTFC_ctfc2Bit._cont = __CTFC_ctfc2Bit__item_
    _CTFC_ctfc2Bit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _CTFC_ctfc4Bit = SEQ_OF(name='ctfc4Bit', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CTFC_ctfc4Bit__item_ = INT(name='_item_', mode=MODE_TYPE)
    __CTFC_ctfc4Bit__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _CTFC_ctfc4Bit._cont = __CTFC_ctfc4Bit__item_
    _CTFC_ctfc4Bit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _CTFC_ctfc6Bit = SEQ_OF(name='ctfc6Bit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CTFC_ctfc6Bit__item_ = INT(name='_item_', mode=MODE_TYPE)
    __CTFC_ctfc6Bit__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _CTFC_ctfc6Bit._cont = __CTFC_ctfc6Bit__item_
    _CTFC_ctfc6Bit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _CTFC_ctfc8Bit = SEQ_OF(name='ctfc8Bit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CTFC_ctfc8Bit__item_ = INT(name='_item_', mode=MODE_TYPE)
    __CTFC_ctfc8Bit__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _CTFC_ctfc8Bit._cont = __CTFC_ctfc8Bit__item_
    _CTFC_ctfc8Bit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _CTFC_ctfc12Bit = SEQ_OF(name='ctfc12Bit', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CTFC_ctfc12Bit__item_ = INT(name='_item_', mode=MODE_TYPE)
    __CTFC_ctfc12Bit__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _CTFC_ctfc12Bit._cont = __CTFC_ctfc12Bit__item_
    _CTFC_ctfc12Bit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _CTFC_ctfc16Bit = SEQ_OF(name='ctfc16Bit', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CTFC_ctfc16Bit__item_ = INT(name='_item_', mode=MODE_TYPE)
    __CTFC_ctfc16Bit__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CTFC_ctfc16Bit._cont = __CTFC_ctfc16Bit__item_
    _CTFC_ctfc16Bit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _CTFC_ctfc24Bit = SEQ_OF(name='ctfc24Bit', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CTFC_ctfc24Bit__item_ = INT(name='_item_', mode=MODE_TYPE)
    __CTFC_ctfc24Bit__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777215)], ev=None, er=[])
    _CTFC_ctfc24Bit._cont = __CTFC_ctfc24Bit__item_
    _CTFC_ctfc24Bit._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    CTFC._cont = ASN1Dict([
        ('ctfc2Bit', _CTFC_ctfc2Bit),
        ('ctfc4Bit', _CTFC_ctfc4Bit),
        ('ctfc6Bit', _CTFC_ctfc6Bit),
        ('ctfc8Bit', _CTFC_ctfc8Bit),
        ('ctfc12Bit', _CTFC_ctfc12Bit),
        ('ctfc16Bit', _CTFC_ctfc16Bit),
        ('ctfc24Bit', _CTFC_ctfc24Bit),
        ])
    CTFC._ext = []
    
    #-----< C-RNTI >-----#
    C_RNTI = BIT_STR(name='C-RNTI', mode=MODE_TYPE)
    C_RNTI._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< UARFCN >-----#
    UARFCN = INT(name='UARFCN', mode=MODE_TYPE)
    UARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    
    #-----< CFN >-----#
    CFN = INT(name='CFN', mode=MODE_TYPE)
    CFN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ChipOffset >-----#
    ChipOffset = INT(name='ChipOffset', mode=MODE_TYPE)
    ChipOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=38399)], ev=None, er=[])
    
    #-----< FrameOffset >-----#
    FrameOffset = INT(name='FrameOffset', mode=MODE_TYPE)
    FrameOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< PrimaryScramblingCode >-----#
    PrimaryScramblingCode = INT(name='PrimaryScramblingCode', mode=MODE_TYPE)
    PrimaryScramblingCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    
    #-----< UschParameters >-----#
    UschParameters = SEQ(name='UschParameters', mode=MODE_TYPE)
    _UschParameters_cellParameterID = INT(name='cellParameterID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'CellParameterID')))
    _UschParameters_tFCI_Coding = ENUM(name='tFCI-Coding', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TFCI-Coding')))
    _UschParameters_punctureLimit = INT(name='punctureLimit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'PuncturingLimit')))
    _UschParameters_repetitionPeriod = ENUM(name='repetitionPeriod', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RepetitionPeriod')))
    _UschParameters_uSCH_SchedulingOffset = INT(name='uSCH-SchedulingOffset', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'USCH-SchedulingOffset')))
    _UschParameters_uL_Timeslot_Information = SEQ_OF(name='uL-Timeslot-Information', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UL-Timeslot-Information')))
    _UschParameters_tFCS = SEQ_OF(name='tFCS', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TFCS')))
    _UschParameters_trChInfo = SEQ_OF(name='trChInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'TrChInfoList')))
    _UschParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UschParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UschParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UschParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UschParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UschParameters_iE_Extensions__item__id._const_tab = ____UschParameters_iE_Extensions__item__id_tab
    ___UschParameters_iE_Extensions__item__id._const_tab_at = None
    ___UschParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___UschParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UschParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UschParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UschParameters_iE_Extensions__item__criticality._const_tab = ____UschParameters_iE_Extensions__item__criticality_tab
    ___UschParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UschParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UschParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UschParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UschParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UschParameters_iE_Extensions__item__extensionValue._const_tab = ____UschParameters_iE_Extensions__item__extensionValue_tab
    ___UschParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UschParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UschParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UschParameters_iE_Extensions__item__id),
        ('criticality', ___UschParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___UschParameters_iE_Extensions__item__extensionValue),
        ])
    __UschParameters_iE_Extensions__item_._ext = None
    _UschParameters_iE_Extensions._cont = __UschParameters_iE_Extensions__item_
    _UschParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UschParameters._cont = ASN1Dict([
        ('cellParameterID', _UschParameters_cellParameterID),
        ('tFCI-Coding', _UschParameters_tFCI_Coding),
        ('punctureLimit', _UschParameters_punctureLimit),
        ('repetitionPeriod', _UschParameters_repetitionPeriod),
        ('uSCH-SchedulingOffset', _UschParameters_uSCH_SchedulingOffset),
        ('uL-Timeslot-Information', _UschParameters_uL_Timeslot_Information),
        ('tFCS', _UschParameters_tFCS),
        ('trChInfo', _UschParameters_trChInfo),
        ('iE-Extensions', _UschParameters_iE_Extensions),
        ])
    UschParameters._ext = []
    
    #-----< UschParameters-ExtIEs >-----#
    UschParameters_ExtIEs = CLASS(name='UschParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UschParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< USCH-SchedulingOffset >-----#
    USCH_SchedulingOffset = INT(name='USCH-SchedulingOffset', mode=MODE_TYPE)
    USCH_SchedulingOffset._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< MaxPRACH-MidambleShifts >-----#
    MaxPRACH_MidambleShifts = ENUM(name='MaxPRACH-MidambleShifts', mode=MODE_TYPE)
    MaxPRACH_MidambleShifts._cont = ASN1Dict([('shift4', 0), ('shift8', 1)])
    MaxPRACH_MidambleShifts._ext = []
    
    #-----< PRACH-Midamble >-----#
    PRACH_Midamble = ENUM(name='PRACH-Midamble', mode=MODE_TYPE)
    PRACH_Midamble._cont = ASN1Dict([('inverted', 0), ('direct', 1)])
    PRACH_Midamble._ext = []
    
    #-----< Positioning-ResponseTime >-----#
    Positioning_ResponseTime = ENUM(name='Positioning-ResponseTime', mode=MODE_TYPE)
    Positioning_ResponseTime._cont = ASN1Dict([('ms250', 0), ('ms500', 1), ('s1', 2), ('s2', 3), ('s3', 4), ('s4', 5), ('s6', 6), ('s8', 7), ('s12', 8), ('s16', 9), ('s20', 10), ('s24', 11), ('s28', 12), ('s32', 13), ('s64', 14)])
    Positioning_ResponseTime._ext = []
    
    #-----< AmountOfReporting >-----#
    AmountOfReporting = ENUM(name='AmountOfReporting', mode=MODE_TYPE)
    AmountOfReporting._cont = ASN1Dict([('ra2', 0), ('ra4', 1), ('ra8', 2), ('ra16', 3), ('ra32', 4), ('ra64', 5), ('ra-Infinity', 6)])
    AmountOfReporting._ext = []
    
    #-----< IncludeVelocity >-----#
    IncludeVelocity = ENUM(name='IncludeVelocity', mode=MODE_TYPE)
    IncludeVelocity._cont = ASN1Dict([('requested', 0)])
    IncludeVelocity._ext = None
    
    #-----< VelocityEstimate >-----#
    VelocityEstimate = CHOICE(name='VelocityEstimate', mode=MODE_TYPE)
    _VelocityEstimate_horizontalVelocity = SEQ(name='horizontalVelocity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'HorizontalVelocity')))
    _VelocityEstimate_horizontalWithVerticalVelocity = SEQ(name='horizontalWithVerticalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'HorizontalWithVerticalVelocity')))
    _VelocityEstimate_horizontalVelocityWithUncertainty = SEQ(name='horizontalVelocityWithUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'HorizontalVelocityWithUncertainty')))
    _VelocityEstimate_horizontalWithVerticalVelocityAndUncertainty = SEQ(name='horizontalWithVerticalVelocityAndUncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'HorizontalWithVerticalVelocityAndUncertainty')))
    VelocityEstimate._cont = ASN1Dict([
        ('horizontalVelocity', _VelocityEstimate_horizontalVelocity),
        ('horizontalWithVerticalVelocity', _VelocityEstimate_horizontalWithVerticalVelocity),
        ('horizontalVelocityWithUncertainty', _VelocityEstimate_horizontalVelocityWithUncertainty),
        ('horizontalWithVerticalVelocityAndUncertainty', _VelocityEstimate_horizontalWithVerticalVelocityAndUncertainty),
        ])
    VelocityEstimate._ext = []
    
    #-----< HorizontalVelocity >-----#
    HorizontalVelocity = SEQ(name='HorizontalVelocity', mode=MODE_TYPE)
    _HorizontalVelocity_horizontalSpeedAndBearing = SEQ(name='horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalVelocity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalVelocity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalVelocity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____HorizontalVelocity_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocity_iE_Extensions__item__id._const_tab = ____HorizontalVelocity_iE_Extensions__item__id_tab
    ___HorizontalVelocity_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalVelocity_iE_Extensions__item__id._const_tab_id = 'id'
    ___HorizontalVelocity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HorizontalVelocity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocity_iE_Extensions__item__criticality._const_tab = ____HorizontalVelocity_iE_Extensions__item__criticality_tab
    ___HorizontalVelocity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HorizontalVelocity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HorizontalVelocity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocity_iE_Extensions__item__extensionValue._const_tab = ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab
    ___HorizontalVelocity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HorizontalVelocity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HorizontalVelocity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HorizontalVelocity_iE_Extensions__item__id),
        ('criticality', ___HorizontalVelocity_iE_Extensions__item__criticality),
        ('extensionValue', ___HorizontalVelocity_iE_Extensions__item__extensionValue),
        ])
    __HorizontalVelocity_iE_Extensions__item_._ext = None
    _HorizontalVelocity_iE_Extensions._cont = __HorizontalVelocity_iE_Extensions__item_
    _HorizontalVelocity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalVelocity._cont = ASN1Dict([
        ('horizontalSpeedAndBearing', _HorizontalVelocity_horizontalSpeedAndBearing),
        ('iE-Extensions', _HorizontalVelocity_iE_Extensions),
        ])
    HorizontalVelocity._ext = []
    
    #-----< HorizontalVelocity-ExtIEs >-----#
    HorizontalVelocity_ExtIEs = CLASS(name='HorizontalVelocity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    HorizontalVelocity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalWithVerticalVelocity >-----#
    HorizontalWithVerticalVelocity = SEQ(name='HorizontalWithVerticalVelocity', mode=MODE_TYPE)
    _HorizontalWithVerticalVelocity_horizontalSpeedAndBearing = SEQ(name='horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalWithVerticalVelocity_verticalVelocity = SEQ(name='verticalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'VerticalVelocity')))
    _HorizontalWithVerticalVelocity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalWithVerticalVelocity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id._const_tab = ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id._const_tab_id = 'id'
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality._const_tab = ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue._const_tab = ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HorizontalWithVerticalVelocity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HorizontalWithVerticalVelocity_iE_Extensions__item__id),
        ('criticality', ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality),
        ('extensionValue', ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue),
        ])
    __HorizontalWithVerticalVelocity_iE_Extensions__item_._ext = None
    _HorizontalWithVerticalVelocity_iE_Extensions._cont = __HorizontalWithVerticalVelocity_iE_Extensions__item_
    _HorizontalWithVerticalVelocity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalWithVerticalVelocity._cont = ASN1Dict([
        ('horizontalSpeedAndBearing', _HorizontalWithVerticalVelocity_horizontalSpeedAndBearing),
        ('verticalVelocity', _HorizontalWithVerticalVelocity_verticalVelocity),
        ('iE-Extensions', _HorizontalWithVerticalVelocity_iE_Extensions),
        ])
    HorizontalWithVerticalVelocity._ext = []
    
    #-----< HorizontalWithVerticalVelocity-ExtIEs >-----#
    HorizontalWithVerticalVelocity_ExtIEs = CLASS(name='HorizontalWithVerticalVelocity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    HorizontalWithVerticalVelocity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalVelocityWithUncertainty >-----#
    HorizontalVelocityWithUncertainty = SEQ(name='HorizontalVelocityWithUncertainty', mode=MODE_TYPE)
    _HorizontalVelocityWithUncertainty_horizontalSpeedAndBearing = SEQ(name='horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalVelocityWithUncertainty_uncertaintySpeed = INT(name='uncertaintySpeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalVelocityWithUncertainty_uncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalVelocityWithUncertainty_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalVelocityWithUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id._const_tab = ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id._const_tab_id = 'id'
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality._const_tab = ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue._const_tab = ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HorizontalVelocityWithUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id),
        ('criticality', ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality),
        ('extensionValue', ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue),
        ])
    __HorizontalVelocityWithUncertainty_iE_Extensions__item_._ext = None
    _HorizontalVelocityWithUncertainty_iE_Extensions._cont = __HorizontalVelocityWithUncertainty_iE_Extensions__item_
    _HorizontalVelocityWithUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalVelocityWithUncertainty._cont = ASN1Dict([
        ('horizontalSpeedAndBearing', _HorizontalVelocityWithUncertainty_horizontalSpeedAndBearing),
        ('uncertaintySpeed', _HorizontalVelocityWithUncertainty_uncertaintySpeed),
        ('iE-Extensions', _HorizontalVelocityWithUncertainty_iE_Extensions),
        ])
    HorizontalVelocityWithUncertainty._ext = []
    
    #-----< HorizontalVelocityWithUncertainty-ExtIEs >-----#
    HorizontalVelocityWithUncertainty_ExtIEs = CLASS(name='HorizontalVelocityWithUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    HorizontalVelocityWithUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalWithVerticalVelocityAndUncertainty >-----#
    HorizontalWithVerticalVelocityAndUncertainty = SEQ(name='HorizontalWithVerticalVelocityAndUncertainty', mode=MODE_TYPE)
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeedAndBearing = SEQ(name='horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalWithVerticalVelocityAndUncertainty_verticalVelocity = SEQ(name='verticalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'VerticalVelocity')))
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed = INT(name='horizontalUncertaintySpeed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed = INT(name='verticalUncertaintySpeed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id._const_tab = ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id._const_tab_id = 'id'
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality._const_tab = ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue._const_tab = ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id),
        ('criticality', ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality),
        ('extensionValue', ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue),
        ])
    __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_._ext = None
    _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions._cont = __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_
    _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalWithVerticalVelocityAndUncertainty._cont = ASN1Dict([
        ('horizontalSpeedAndBearing', _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeedAndBearing),
        ('verticalVelocity', _HorizontalWithVerticalVelocityAndUncertainty_verticalVelocity),
        ('horizontalUncertaintySpeed', _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed),
        ('verticalUncertaintySpeed', _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed),
        ('iE-Extensions', _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions),
        ])
    HorizontalWithVerticalVelocityAndUncertainty._ext = []
    
    #-----< HorizontalWithVerticalVelocityAndUncertainty-ExtIEs >-----#
    HorizontalWithVerticalVelocityAndUncertainty_ExtIEs = CLASS(name='HorizontalWithVerticalVelocityAndUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    HorizontalWithVerticalVelocityAndUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalSpeedAndBearing >-----#
    HorizontalSpeedAndBearing = SEQ(name='HorizontalSpeedAndBearing', mode=MODE_TYPE)
    _HorizontalSpeedAndBearing_bearing = INT(name='bearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalSpeedAndBearing_bearing._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _HorizontalSpeedAndBearing_horizontalSpeed = INT(name='horizontalSpeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalSpeedAndBearing_horizontalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    HorizontalSpeedAndBearing._cont = ASN1Dict([
        ('bearing', _HorizontalSpeedAndBearing_bearing),
        ('horizontalSpeed', _HorizontalSpeedAndBearing_horizontalSpeed),
        ])
    HorizontalSpeedAndBearing._ext = None
    
    #-----< VerticalVelocity >-----#
    VerticalVelocity = SEQ(name='VerticalVelocity', mode=MODE_TYPE)
    _VerticalVelocity_verticalSpeed = INT(name='verticalSpeed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VerticalVelocity_verticalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _VerticalVelocity_verticalSpeedDirection = ENUM(name='verticalSpeedDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'VerticalSpeedDirection')))
    VerticalVelocity._cont = ASN1Dict([
        ('verticalSpeed', _VerticalVelocity_verticalSpeed),
        ('verticalSpeedDirection', _VerticalVelocity_verticalSpeedDirection),
        ])
    VerticalVelocity._ext = None
    
    #-----< VerticalSpeedDirection >-----#
    VerticalSpeedDirection = ENUM(name='VerticalSpeedDirection', mode=MODE_TYPE)
    VerticalSpeedDirection._cont = ASN1Dict([('upward', 0), ('downward', 1)])
    VerticalSpeedDirection._ext = None
    
    #-----< UTRAN-GPSReferenceTime >-----#
    UTRAN_GPSReferenceTime = SEQ(name='UTRAN-GPSReferenceTime', mode=MODE_TYPE)
    _UTRAN_GPSReferenceTime_utran_GPSTimingOfCell = INT(name='utran-GPSTimingOfCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GPSReferenceTime_utran_GPSTimingOfCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2322431999999)], ev=[], er=[])
    _UTRAN_GPSReferenceTime_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')), opt=True)
    _UTRAN_GPSReferenceTime_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GPSReferenceTime_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _UTRAN_GPSReferenceTime_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTRAN_GPSReferenceTime_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTRAN_GPSReferenceTime_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GPSReferenceTime_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__id._const_tab = ____UTRAN_GPSReferenceTime_iE_Extensions__item__id_tab
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__id._const_tab_at = None
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__id._const_tab_id = 'id'
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTRAN_GPSReferenceTime_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GPSReferenceTime_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__criticality._const_tab = ____UTRAN_GPSReferenceTime_iE_Extensions__item__criticality_tab
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTRAN_GPSReferenceTime_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GPSReferenceTime_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__extensionValue._const_tab = ____UTRAN_GPSReferenceTime_iE_Extensions__item__extensionValue_tab
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTRAN_GPSReferenceTime_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTRAN_GPSReferenceTime_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTRAN_GPSReferenceTime_iE_Extensions__item__id),
        ('criticality', ___UTRAN_GPSReferenceTime_iE_Extensions__item__criticality),
        ('extensionValue', ___UTRAN_GPSReferenceTime_iE_Extensions__item__extensionValue),
        ])
    __UTRAN_GPSReferenceTime_iE_Extensions__item_._ext = None
    _UTRAN_GPSReferenceTime_iE_Extensions._cont = __UTRAN_GPSReferenceTime_iE_Extensions__item_
    _UTRAN_GPSReferenceTime_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTRAN_GPSReferenceTime._cont = ASN1Dict([
        ('utran-GPSTimingOfCell', _UTRAN_GPSReferenceTime_utran_GPSTimingOfCell),
        ('uC-ID', _UTRAN_GPSReferenceTime_uC_ID),
        ('sfn', _UTRAN_GPSReferenceTime_sfn),
        ('iE-Extensions', _UTRAN_GPSReferenceTime_iE_Extensions),
        ])
    UTRAN_GPSReferenceTime._ext = []
    
    #-----< UTRAN-GPSReferenceTime-ExtIEs >-----#
    UTRAN_GPSReferenceTime_ExtIEs = CLASS(name='UTRAN-GPSReferenceTime-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTRAN_GPSReferenceTime_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTRAN-GPSReferenceTimeResult >-----#
    UTRAN_GPSReferenceTimeResult = SEQ(name='UTRAN-GPSReferenceTimeResult', mode=MODE_TYPE)
    _UTRAN_GPSReferenceTimeResult_ue_GPSTimingOfCell = INT(name='ue-GPSTimingOfCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GPSReferenceTimeResult_ue_GPSTimingOfCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=37158911999999)], ev=[], er=[])
    _UTRAN_GPSReferenceTimeResult_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _UTRAN_GPSReferenceTimeResult_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GPSReferenceTimeResult_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _UTRAN_GPSReferenceTimeResult_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTRAN_GPSReferenceTimeResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__id._const_tab = ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__id_tab
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__id._const_tab_at = None
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__id._const_tab_id = 'id'
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__criticality._const_tab = ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__criticality_tab
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__extensionValue._const_tab = ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__extensionValue_tab
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTRAN_GPSReferenceTimeResult_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__id),
        ('criticality', ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__criticality),
        ('extensionValue', ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__extensionValue),
        ])
    __UTRAN_GPSReferenceTimeResult_iE_Extensions__item_._ext = None
    _UTRAN_GPSReferenceTimeResult_iE_Extensions._cont = __UTRAN_GPSReferenceTimeResult_iE_Extensions__item_
    _UTRAN_GPSReferenceTimeResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTRAN_GPSReferenceTimeResult._cont = ASN1Dict([
        ('ue-GPSTimingOfCell', _UTRAN_GPSReferenceTimeResult_ue_GPSTimingOfCell),
        ('uC-ID', _UTRAN_GPSReferenceTimeResult_uC_ID),
        ('sfn', _UTRAN_GPSReferenceTimeResult_sfn),
        ('iE-Extensions', _UTRAN_GPSReferenceTimeResult_iE_Extensions),
        ])
    UTRAN_GPSReferenceTimeResult._ext = []
    
    #-----< UTRAN-GPSReferenceTimeResult-ExtIEs >-----#
    UTRAN_GPSReferenceTimeResult_ExtIEs = CLASS(name='UTRAN-GPSReferenceTimeResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTRAN_GPSReferenceTimeResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UTRAN-GANSSReferenceTimeResult >-----#
    UTRAN_GANSSReferenceTimeResult = SEQ(name='UTRAN-GANSSReferenceTimeResult', mode=MODE_TYPE)
    _UTRAN_GANSSReferenceTimeResult_ue_GANSSTimingOfCell = INT(name='ue-GANSSTimingOfCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GANSSReferenceTimeResult_ue_GANSSTimingOfCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=345599999999)], ev=[], er=[])
    _UTRAN_GANSSReferenceTimeResult_ganss_Time_ID = SEQ(name='ganss-Time-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'GANSSID')), opt=True)
    _UTRAN_GANSSReferenceTimeResult_ganssTodUncertainty = INT(name='ganssTodUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTRAN_GANSSReferenceTimeResult_ganssTodUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _UTRAN_GANSSReferenceTimeResult_uC_ID = SEQ(name='uC-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _UTRAN_GANSSReferenceTimeResult_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GANSSReferenceTimeResult_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _UTRAN_GANSSReferenceTimeResult_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTRAN_GANSSReferenceTimeResult_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__id._const_tab = ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__id_tab
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__id._const_tab_at = None
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__id._const_tab_id = 'id'
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__criticality._const_tab = ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__criticality_tab
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__extensionValue._const_tab = ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__extensionValue_tab
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTRAN_GANSSReferenceTimeResult_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__id),
        ('criticality', ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__criticality),
        ('extensionValue', ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__extensionValue),
        ])
    __UTRAN_GANSSReferenceTimeResult_iE_Extensions__item_._ext = None
    _UTRAN_GANSSReferenceTimeResult_iE_Extensions._cont = __UTRAN_GANSSReferenceTimeResult_iE_Extensions__item_
    _UTRAN_GANSSReferenceTimeResult_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTRAN_GANSSReferenceTimeResult._cont = ASN1Dict([
        ('ue-GANSSTimingOfCell', _UTRAN_GANSSReferenceTimeResult_ue_GANSSTimingOfCell),
        ('ganss-Time-ID', _UTRAN_GANSSReferenceTimeResult_ganss_Time_ID),
        ('ganssTodUncertainty', _UTRAN_GANSSReferenceTimeResult_ganssTodUncertainty),
        ('uC-ID', _UTRAN_GANSSReferenceTimeResult_uC_ID),
        ('sfn', _UTRAN_GANSSReferenceTimeResult_sfn),
        ('iE-Extensions', _UTRAN_GANSSReferenceTimeResult_iE_Extensions),
        ])
    UTRAN_GANSSReferenceTimeResult._ext = []
    
    #-----< UTRAN-GANSSReferenceTimeResult-ExtIEs >-----#
    UTRAN_GANSSReferenceTimeResult_ExtIEs = CLASS(name='UTRAN-GANSSReferenceTimeResult-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UTRAN_GANSSReferenceTimeResult_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        AccuracyFulfilmentIndicator,
        AdditionalMethodType,
        _AddPos_MeasuredResults__item_,
        AddPos_MeasuredResults,
        _AddPos_MeasuredResults_Element_timestamp,
        ___AddPos_MeasuredResults_Element_type_barometricPressure_uncompensatedBarometricPressure,
        ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__id_tab,
        _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__id,
        ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__criticality_tab,
        _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__criticality,
        ______AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__extensionValue_tab,
        _____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item__extensionValue,
        ____AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions__item_,
        ___AddPos_MeasuredResults_Element_type_barometricPressure_iE_Extensions,
        __AddPos_MeasuredResults_Element_type_barometricPressure,
        ___AddPos_MeasuredResults_Element_type_wlan_wlanMeasurementList,
        ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__id_tab,
        _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__id,
        ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__criticality_tab,
        _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__criticality,
        ______AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__extensionValue_tab,
        _____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item__extensionValue,
        ____AddPos_MeasuredResults_Element_type_wlan_iE_Extensions__item_,
        ___AddPos_MeasuredResults_Element_type_wlan_iE_Extensions,
        __AddPos_MeasuredResults_Element_type_wlan,
        ___AddPos_MeasuredResults_Element_type_bt_btMeasurementList,
        ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__id_tab,
        _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__id,
        ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__criticality_tab,
        _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__criticality,
        ______AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__extensionValue_tab,
        _____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item__extensionValue,
        ____AddPos_MeasuredResults_Element_type_bt_iE_Extensions__item_,
        ___AddPos_MeasuredResults_Element_type_bt_iE_Extensions,
        __AddPos_MeasuredResults_Element_type_bt,
        ___AddPos_MeasuredResults_Element_type_mbs_mbsMeasurementList,
        ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__id_tab,
        _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__id,
        ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__criticality_tab,
        _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__criticality,
        ______AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__extensionValue_tab,
        _____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item__extensionValue,
        ____AddPos_MeasuredResults_Element_type_mbs_iE_Extensions__item_,
        ___AddPos_MeasuredResults_Element_type_mbs_iE_Extensions,
        __AddPos_MeasuredResults_Element_type_mbs,
        _AddPos_MeasuredResults_Element_type,
        AddPos_MeasuredResults_Element,
        BarometricPressure_ExtIEs,
        WLANMeasurementList_ExtIEs,
        BTMeasurementList_ExtIEs,
        MBSMeasurementList_ExtIEs,
        _WLANMeasurementList__item_,
        WLANMeasurementList,
        _WLANMeasurementList_Element_wlanBSSID,
        _WLANMeasurementList_Element_wlanSSID,
        _WLANMeasurementList_Element_wlanRSSI,
        _WLANMeasurementList_Element_wlanRTTvalue,
        _WLANMeasurementList_Element_wlanRTTunits,
        _WLANMeasurementList_Element_wlanRTTaccuracy,
        _WLANMeasurementList_Element_wlanAPChannelFrequency,
        _WLANMeasurementList_Element_wlanServingFlag,
        ____WLANMeasurementList_Element_iE_Extensions__item__id_tab,
        ___WLANMeasurementList_Element_iE_Extensions__item__id,
        ____WLANMeasurementList_Element_iE_Extensions__item__criticality_tab,
        ___WLANMeasurementList_Element_iE_Extensions__item__criticality,
        ____WLANMeasurementList_Element_iE_Extensions__item__extensionValue_tab,
        ___WLANMeasurementList_Element_iE_Extensions__item__extensionValue,
        __WLANMeasurementList_Element_iE_Extensions__item_,
        _WLANMeasurementList_Element_iE_Extensions,
        WLANMeasurementList_Element,
        WLANMeasurementList_Element_ExtIEs,
        _BTMeasurementList__item_,
        BTMeasurementList,
        _BTMeasurementList_Element_btADDR,
        _BTMeasurementList_Element_btRSSI,
        ____BTMeasurementList_Element_iE_Extensions__item__id_tab,
        ___BTMeasurementList_Element_iE_Extensions__item__id,
        ____BTMeasurementList_Element_iE_Extensions__item__criticality_tab,
        ___BTMeasurementList_Element_iE_Extensions__item__criticality,
        ____BTMeasurementList_Element_iE_Extensions__item__extensionValue_tab,
        ___BTMeasurementList_Element_iE_Extensions__item__extensionValue,
        __BTMeasurementList_Element_iE_Extensions__item_,
        _BTMeasurementList_Element_iE_Extensions,
        BTMeasurementList_Element,
        BTMeasurementList_Element_ExtIEs,
        _MBSMeasurementList__item_,
        MBSMeasurementList,
        _MBSMeasurementList_Element_transmitterID,
        _MBSMeasurementList_Element_codephase,
        _MBSMeasurementList_Element_codephaseRMS,
        ____MBSMeasurementList_Element_iE_Extensions__item__id_tab,
        ___MBSMeasurementList_Element_iE_Extensions__item__id,
        ____MBSMeasurementList_Element_iE_Extensions__item__criticality_tab,
        ___MBSMeasurementList_Element_iE_Extensions__item__criticality,
        ____MBSMeasurementList_Element_iE_Extensions__item__extensionValue_tab,
        ___MBSMeasurementList_Element_iE_Extensions__item__extensionValue,
        __MBSMeasurementList_Element_iE_Extensions__item_,
        _MBSMeasurementList_Element_iE_Extensions,
        MBSMeasurementList_Element,
        MBSMeasurementList_Element_ExtIEs,
        BaroMeasurement,
        _AlmanacAndSatelliteHealthSIB_gpsAlmanacAndSatelliteHealth,
        _AlmanacAndSatelliteHealthSIB_satMask,
        _AlmanacAndSatelliteHealthSIB_lsbTOW,
        ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__id_tab,
        ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__id,
        ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__criticality_tab,
        ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__criticality,
        ____AlmanacAndSatelliteHealthSIB_iE_Extensions__item__extensionValue_tab,
        ___AlmanacAndSatelliteHealthSIB_iE_Extensions__item__extensionValue,
        __AlmanacAndSatelliteHealthSIB_iE_Extensions__item_,
        _AlmanacAndSatelliteHealthSIB_iE_Extensions,
        AlmanacAndSatelliteHealthSIB,
        AlmanacAndSatelliteHealthSIB_ExtIEs,
        _Cause_radioNetwork,
        _Cause_transport,
        _Cause_protocol,
        _Cause_misc,
        Cause,
        CauseRadioNetwork,
        CauseTransport,
        CauseProtocol,
        CauseMisc,
        _CellId_MeasuredResultsSets__item_,
        CellId_MeasuredResultsSets,
        _CellId_MeasuredResultsInfoList__item_,
        CellId_MeasuredResultsInfoList,
        _CellId_MeasuredResultsInfo_uC_ID,
        _CellId_MeasuredResultsInfo_uTRANAccessPointPositionAltitude,
        _CellId_MeasuredResultsInfo_ue_PositionEstimate,
        _CellId_MeasuredResultsInfo_roundTripTimeInfo,
        _CellId_MeasuredResultsInfo_rxTimingDeviationInfo,
        _CellId_MeasuredResultsInfo_rxTimingDeviationLCRInfo,
        _CellId_MeasuredResultsInfo_pathloss,
        ____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab,
        _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_0,
        _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_1,
        _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_2,
        _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_3,
        _____CellId_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_4,
        ___CellId_MeasuredResultsInfo_iE_Extensions__item__id,
        ___CellId_MeasuredResultsInfo_iE_Extensions__item__criticality,
        ___CellId_MeasuredResultsInfo_iE_Extensions__item__extensionValue,
        __CellId_MeasuredResultsInfo_iE_Extensions__item_,
        _CellId_MeasuredResultsInfo_iE_Extensions,
        CellId_MeasuredResultsInfo,
        CellId_MeasuredResultsInfo_ExtIEs,
        _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_0,
        _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_1,
        _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_2,
        _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_3,
        _CellId_MeasuredResultsInfo_ExtIEs_val_Extension_4,
        _RoundTripTimeInfo_ue_RxTxTimeDifferenceType2,
        _RoundTripTimeInfo_ue_PositioningMeasQuality,
        _RoundTripTimeInfo_roundTripTime,
        ____RoundTripTimeInfo_iE_Extensions__item__id_tab,
        _____RoundTripTimeInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___RoundTripTimeInfo_iE_Extensions__item__id,
        ___RoundTripTimeInfo_iE_Extensions__item__criticality,
        ___RoundTripTimeInfo_iE_Extensions__item__extensionValue,
        __RoundTripTimeInfo_iE_Extensions__item_,
        _RoundTripTimeInfo_iE_Extensions,
        RoundTripTimeInfo,
        RoundTripTimeInfo_ExtIEs,
        _RoundTripTimeInfo_ExtIEs_val_Extension_0,
        _RoundTripTimeInfoWithType1_ue_RxTxTimeDifferenceType1,
        _RoundTripTimeInfoWithType1_roundTripTime,
        _RoundTripTimeInfoWithType1_extendedRoundTripTime,
        ____RoundTripTimeInfoWithType1_iE_Extensions__item__id_tab,
        ___RoundTripTimeInfoWithType1_iE_Extensions__item__id,
        ____RoundTripTimeInfoWithType1_iE_Extensions__item__criticality_tab,
        ___RoundTripTimeInfoWithType1_iE_Extensions__item__criticality,
        ____RoundTripTimeInfoWithType1_iE_Extensions__item__extensionValue_tab,
        ___RoundTripTimeInfoWithType1_iE_Extensions__item__extensionValue,
        __RoundTripTimeInfoWithType1_iE_Extensions__item_,
        _RoundTripTimeInfoWithType1_iE_Extensions,
        RoundTripTimeInfoWithType1,
        RoundTripTimeInfoWithType1_ExtIEs,
        UE_RxTxTimeDifferenceType2,
        UE_RxTxTimeDifferenceType1,
        _UE_PositioningMeasQuality_stdResolution,
        _UE_PositioningMeasQuality_numberOfMeasurements,
        _UE_PositioningMeasQuality_stdOfMeasurements,
        ____UE_PositioningMeasQuality_iE_Extensions__item__id_tab,
        ___UE_PositioningMeasQuality_iE_Extensions__item__id,
        ____UE_PositioningMeasQuality_iE_Extensions__item__criticality_tab,
        ___UE_PositioningMeasQuality_iE_Extensions__item__criticality,
        ____UE_PositioningMeasQuality_iE_Extensions__item__extensionValue_tab,
        ___UE_PositioningMeasQuality_iE_Extensions__item__extensionValue,
        __UE_PositioningMeasQuality_iE_Extensions__item_,
        _UE_PositioningMeasQuality_iE_Extensions,
        UE_PositioningMeasQuality,
        UE_PositioningMeasQuality_ExtIEs,
        RoundTripTime,
        ExtendedRoundTripTime,
        _UTRANAccessPointPositionAltitude_geographicalCoordinates,
        _UTRANAccessPointPositionAltitude_ga_AltitudeAndDirection,
        ____UTRANAccessPointPositionAltitude_iE_Extensions__item__id_tab,
        ___UTRANAccessPointPositionAltitude_iE_Extensions__item__id,
        ____UTRANAccessPointPositionAltitude_iE_Extensions__item__criticality_tab,
        ___UTRANAccessPointPositionAltitude_iE_Extensions__item__criticality,
        ____UTRANAccessPointPositionAltitude_iE_Extensions__item__extensionValue_tab,
        ___UTRANAccessPointPositionAltitude_iE_Extensions__item__extensionValue,
        __UTRANAccessPointPositionAltitude_iE_Extensions__item_,
        _UTRANAccessPointPositionAltitude_iE_Extensions,
        UTRANAccessPointPositionAltitude,
        UTRANAccessPointPositionAltitude_ExtIEs,
        _RxTimingDeviationInfo_rxTimingDeviation,
        _RxTimingDeviationInfo_timingAdvance,
        ____RxTimingDeviationInfo_iE_Extensions__item__id_tab,
        ___RxTimingDeviationInfo_iE_Extensions__item__id,
        ____RxTimingDeviationInfo_iE_Extensions__item__criticality_tab,
        ___RxTimingDeviationInfo_iE_Extensions__item__criticality,
        ____RxTimingDeviationInfo_iE_Extensions__item__extensionValue_tab,
        ___RxTimingDeviationInfo_iE_Extensions__item__extensionValue,
        __RxTimingDeviationInfo_iE_Extensions__item_,
        _RxTimingDeviationInfo_iE_Extensions,
        RxTimingDeviationInfo,
        RxTimingDeviationInfo_ExtIEs,
        _RxTimingDeviationLCRInfo_rxTimingDeviationLCR,
        _RxTimingDeviationLCRInfo_timingAdvanceLCR,
        ____RxTimingDeviationLCRInfo_iE_Extensions__item__id_tab,
        _____RxTimingDeviationLCRInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___RxTimingDeviationLCRInfo_iE_Extensions__item__id,
        ___RxTimingDeviationLCRInfo_iE_Extensions__item__criticality,
        ___RxTimingDeviationLCRInfo_iE_Extensions__item__extensionValue,
        __RxTimingDeviationLCRInfo_iE_Extensions__item_,
        _RxTimingDeviationLCRInfo_iE_Extensions,
        RxTimingDeviationLCRInfo,
        RxTimingDeviationLCRInfo_ExtIEs,
        _RxTimingDeviationLCRInfo_ExtIEs_val_Extension_0,
        ExtendedTimingAdvanceLCR,
        _RxTimingDeviation768Info_rxTimingDeviation768,
        _RxTimingDeviation768Info_timingAdvance768,
        ____RxTimingDeviation768Info_iE_Extensions__item__id_tab,
        ___RxTimingDeviation768Info_iE_Extensions__item__id,
        ____RxTimingDeviation768Info_iE_Extensions__item__criticality_tab,
        ___RxTimingDeviation768Info_iE_Extensions__item__criticality,
        ____RxTimingDeviation768Info_iE_Extensions__item__extensionValue_tab,
        ___RxTimingDeviation768Info_iE_Extensions__item__extensionValue,
        __RxTimingDeviation768Info_iE_Extensions__item_,
        _RxTimingDeviation768Info_iE_Extensions,
        RxTimingDeviation768Info,
        RxTimingDeviation768Info_ExtIEs,
        _RxTimingDeviation384extInfo_rxTimingDeviation384ext,
        _RxTimingDeviation384extInfo_timingAdvance384ext,
        ____RxTimingDeviation384extInfo_iE_Extensions__item__id_tab,
        ___RxTimingDeviation384extInfo_iE_Extensions__item__id,
        ____RxTimingDeviation384extInfo_iE_Extensions__item__criticality_tab,
        ___RxTimingDeviation384extInfo_iE_Extensions__item__criticality,
        ____RxTimingDeviation384extInfo_iE_Extensions__item__extensionValue_tab,
        ___RxTimingDeviation384extInfo_iE_Extensions__item__extensionValue,
        __RxTimingDeviation384extInfo_iE_Extensions__item_,
        _RxTimingDeviation384extInfo_iE_Extensions,
        RxTimingDeviation384extInfo,
        RxTimingDeviation384extInfo_ExtIEs,
        _AddMeasurementInfo_cpich_RSCP,
        _AddMeasurementInfo_cpich_EcNo,
        ____AddMeasurementInfo_iE_Extensions__item__id_tab,
        ___AddMeasurementInfo_iE_Extensions__item__id,
        ____AddMeasurementInfo_iE_Extensions__item__criticality_tab,
        ___AddMeasurementInfo_iE_Extensions__item__criticality,
        ____AddMeasurementInfo_iE_Extensions__item__extensionValue_tab,
        ___AddMeasurementInfo_iE_Extensions__item__extensionValue,
        __AddMeasurementInfo_iE_Extensions__item_,
        _AddMeasurementInfo_iE_Extensions,
        AddMeasurementInfo,
        AddMeasurementInfo_ExtIEs,
        _AngleOfArrivalLCR_aOA_LCR,
        _AngleOfArrivalLCR_aOA_LCR_Accuracy_Class,
        ____AngleOfArrivalLCR_iE_Extensions__item__id_tab,
        ___AngleOfArrivalLCR_iE_Extensions__item__id,
        ____AngleOfArrivalLCR_iE_Extensions__item__criticality_tab,
        ___AngleOfArrivalLCR_iE_Extensions__item__criticality,
        ____AngleOfArrivalLCR_iE_Extensions__item__extensionValue_tab,
        ___AngleOfArrivalLCR_iE_Extensions__item__extensionValue,
        __AngleOfArrivalLCR_iE_Extensions__item_,
        _AngleOfArrivalLCR_iE_Extensions,
        AngleOfArrivalLCR,
        AngleOfArrivalLCR_ExtIEs,
        RxTimingDeviation,
        RxTimingDeviationLCR,
        RxTimingDeviation768,
        RxTimingDeviation384ext,
        TimingAdvance,
        TimingAdvanceLCR,
        TimingAdvance768,
        TimingAdvance384ext,
        Pathloss,
        CPICH_EcNo,
        CPICH_RSCP,
        AOA_LCR,
        AOA_LCR_Accuracy_Class,
        _CellId_IRATMeasuredResultsSets__item_,
        CellId_IRATMeasuredResultsSets,
        _CellId_IRATMeasuredResultsInfoList_gERAN_MeasuredResultsInfoList,
        ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__id_tab,
        ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__id,
        ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__criticality_tab,
        ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__criticality,
        ____CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__extensionValue_tab,
        ___CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item__extensionValue,
        __CellId_IRATMeasuredResultsInfoList_iE_Extenstions__item_,
        _CellId_IRATMeasuredResultsInfoList_iE_Extenstions,
        CellId_IRATMeasuredResultsInfoList,
        CellId_IRATMeasuredResultsInfoListExtIEs,
        _GERAN_MeasuredResultsInfoList__item_,
        GERAN_MeasuredResultsInfoList,
        _GERAN_MeasuredResultsInfo_gERANCellID,
        _GERAN_MeasuredResultsInfo_gERANPhysicalCellID,
        _GERAN_MeasuredResultsInfo_gSM_RSSI,
        ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__id_tab,
        ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__id,
        ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__criticality_tab,
        ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__criticality,
        ____GERAN_MeasuredResultsInfo_iE_Extenstions__item__extensionValue_tab,
        ___GERAN_MeasuredResultsInfo_iE_Extenstions__item__extensionValue,
        __GERAN_MeasuredResultsInfo_iE_Extenstions__item_,
        _GERAN_MeasuredResultsInfo_iE_Extenstions,
        GERAN_MeasuredResultsInfo,
        GERAN_MeasuredResultsInfo_ExtIEs,
        _GERANCellGlobalID_plmn_Identity,
        _GERANCellGlobalID_locationAreaCode,
        _GERANCellGlobalID_cellIdentity,
        ____GERANCellGlobalID_iE_Extenstions__item__id_tab,
        ___GERANCellGlobalID_iE_Extenstions__item__id,
        ____GERANCellGlobalID_iE_Extenstions__item__criticality_tab,
        ___GERANCellGlobalID_iE_Extenstions__item__criticality,
        ____GERANCellGlobalID_iE_Extenstions__item__extensionValue_tab,
        ___GERANCellGlobalID_iE_Extenstions__item__extensionValue,
        __GERANCellGlobalID_iE_Extenstions__item_,
        _GERANCellGlobalID_iE_Extenstions,
        GERANCellGlobalID,
        GERANCellGlobalID_ExtIEs,
        PLMN_Identity,
        GSM_RSSI,
        _GERANPhysicalCellID_bsic,
        _GERANPhysicalCellID_arfcn,
        GERANPhysicalCellID,
        _GSM_BSIC_networkColourCode,
        _GSM_BSIC_baseStationColourCode,
        GSM_BSIC,
        GSM_BCCH_ARFCN,
        _CellIDPositioning_requestedCellIDMeasurements,
        ____CellIDPositioning_iE_Extensions__item__id_tab,
        _____CellIDPositioning_iE_Extensions__item__id_tab_val_Extension_0,
        ___CellIDPositioning_iE_Extensions__item__id,
        ___CellIDPositioning_iE_Extensions__item__criticality,
        ___CellIDPositioning_iE_Extensions__item__extensionValue,
        __CellIDPositioning_iE_Extensions__item_,
        _CellIDPositioning_iE_Extensions,
        CellIDPositioning,
        CellIDPositioning_ExtIEs,
        _CellIDPositioning_ExtIEs_val_Extension_0,
        __RequestedCellIDMeasurements_fdd_roundTripTimeInfoWanted,
        __RequestedCellIDMeasurements_fdd_pathlossWanted,
        __RequestedCellIDMeasurements_fdd_roundTripTimeInfoWithType1Wanted,
        __RequestedCellIDMeasurements_fdd_cpichRSCPWanted,
        __RequestedCellIDMeasurements_fdd_cpicEcNoWanted,
        _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__id_tab,
        ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__id,
        _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__criticality_tab,
        ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__criticality,
        _____RequestedCellIDMeasurements_fdd_iE_Extensions__item__extensionValue_tab,
        ____RequestedCellIDMeasurements_fdd_iE_Extensions__item__extensionValue,
        ___RequestedCellIDMeasurements_fdd_iE_Extensions__item_,
        __RequestedCellIDMeasurements_fdd_iE_Extensions,
        _RequestedCellIDMeasurements_fdd,
        __RequestedCellIDMeasurements_tdd_rxTimingDeviationInfoWanted,
        __RequestedCellIDMeasurements_tdd_pathlossWanted,
        __RequestedCellIDMeasurements_tdd_rxTimingDeviationLCRInfoWanted,
        __RequestedCellIDMeasurements_tdd_rxTimingDeviation768InfoWanted,
        __RequestedCellIDMeasurements_tdd_rxTimingDeviation384extInfoWanted,
        __RequestedCellIDMeasurements_tdd_angleOfArrivalLCRWanted,
        __RequestedCellIDMeasurements_tdd_timingAdvanceLCRWanted,
        _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__id_tab,
        ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__id,
        _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__criticality_tab,
        ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__criticality,
        _____RequestedCellIDMeasurements_tdd_iE_Extensions__item__extensionValue_tab,
        ____RequestedCellIDMeasurements_tdd_iE_Extensions__item__extensionValue,
        ___RequestedCellIDMeasurements_tdd_iE_Extensions__item_,
        __RequestedCellIDMeasurements_tdd_iE_Extensions,
        _RequestedCellIDMeasurements_tdd,
        RequestedCellIDMeasurements,
        RequestedCellIDMeasurementsFDD_ExtIEs,
        RequestedCellIDMeasurementsTDD_ExtIEs,
        _RequestedCellIDGERANMeasurements_rSSIMeasurementsWanted,
        ____RequestedCellIDGERANMeasurements_iE_Extensions__item__id_tab,
        ___RequestedCellIDGERANMeasurements_iE_Extensions__item__id,
        ____RequestedCellIDGERANMeasurements_iE_Extensions__item__criticality_tab,
        ___RequestedCellIDGERANMeasurements_iE_Extensions__item__criticality,
        ____RequestedCellIDGERANMeasurements_iE_Extensions__item__extensionValue_tab,
        ___RequestedCellIDGERANMeasurements_iE_Extensions__item__extensionValue,
        __RequestedCellIDGERANMeasurements_iE_Extensions__item_,
        _RequestedCellIDGERANMeasurements_iE_Extensions,
        RequestedCellIDGERANMeasurements,
        RequestedCellIDGERANMeasurements_ExtIEs,
        ClientType,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_transactionID,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__repetitionNumber,
        __CriticalityDiagnostics_IE_List__item__messageStructure,
        __CriticalityDiagnostics_IE_List__item__typeOfError,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue_tab,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        CriticalityDiagnostics_ExtIEs,
        CriticalityDiagnosticsRepetition,
        TypeOfError,
        _DGPSCorrections_gps_TOW_sec,
        _DGPSCorrections_statusHealth,
        _DGPSCorrections_dgps_CorrectionSatInfoList,
        ____DGPSCorrections_iE_Extensions__item__id_tab,
        ___DGPSCorrections_iE_Extensions__item__id,
        ____DGPSCorrections_iE_Extensions__item__criticality_tab,
        ___DGPSCorrections_iE_Extensions__item__criticality,
        ____DGPSCorrections_iE_Extensions__item__extensionValue_tab,
        ___DGPSCorrections_iE_Extensions__item__extensionValue,
        __DGPSCorrections_iE_Extensions__item_,
        _DGPSCorrections_iE_Extensions,
        DGPSCorrections,
        DGPSCorrections_ExtIEs,
        DiffCorrectionStatus,
        _DGPS_CorrectionSatInfoList__item_,
        DGPS_CorrectionSatInfoList,
        _DGPS_CorrectionSatInfo_satID,
        _DGPS_CorrectionSatInfo_iode,
        _DGPS_CorrectionSatInfo_udre,
        _DGPS_CorrectionSatInfo_prc,
        _DGPS_CorrectionSatInfo_rrc,
        ____DGPS_CorrectionSatInfo_iE_Extensions__item__id_tab,
        _____DGPS_CorrectionSatInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___DGPS_CorrectionSatInfo_iE_Extensions__item__id,
        ___DGPS_CorrectionSatInfo_iE_Extensions__item__criticality,
        ___DGPS_CorrectionSatInfo_iE_Extensions__item__extensionValue,
        __DGPS_CorrectionSatInfo_iE_Extensions__item_,
        _DGPS_CorrectionSatInfo_iE_Extensions,
        DGPS_CorrectionSatInfo,
        DGPS_CorrectionSatInfo_ExtIEs,
        _DGPS_CorrectionSatInfo_ExtIEs_val_Extension_0,
        _DGNSS_ValidityPeriod_udreGrowthRate,
        _DGNSS_ValidityPeriod_udreValidityTime,
        ____DGNSS_ValidityPeriod_iE_Extensions__item__id_tab,
        ___DGNSS_ValidityPeriod_iE_Extensions__item__id,
        ____DGNSS_ValidityPeriod_iE_Extensions__item__criticality_tab,
        ___DGNSS_ValidityPeriod_iE_Extensions__item__criticality,
        ____DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue_tab,
        ___DGNSS_ValidityPeriod_iE_Extensions__item__extensionValue,
        __DGNSS_ValidityPeriod_iE_Extensions__item_,
        _DGNSS_ValidityPeriod_iE_Extensions,
        DGNSS_ValidityPeriod,
        DGNSS_ValidityPeriod_ExtIEs,
        UDRE,
        UDREGrowthRate,
        UDREValidityTime,
        PRC,
        RRC,
        IMEI,
        IMSI,
        _UE_PositionEstimate_point,
        _UE_PositionEstimate_pointWithUnCertainty,
        _UE_PositionEstimate_polygon,
        _UE_PositionEstimate_pointWithUncertaintyEllipse,
        _UE_PositionEstimate_pointWithAltitude,
        _UE_PositionEstimate_pointWithAltitudeAndUncertaintyEllipsoid,
        _UE_PositionEstimate_ellipsoidArc,
        UE_PositionEstimate,
        _GeographicalCoordinates_latitudeSign,
        _GeographicalCoordinates_latitude,
        _GeographicalCoordinates_longitude,
        ____GeographicalCoordinates_iE_Extensions__item__id_tab,
        ___GeographicalCoordinates_iE_Extensions__item__id,
        ____GeographicalCoordinates_iE_Extensions__item__criticality_tab,
        ___GeographicalCoordinates_iE_Extensions__item__criticality,
        ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab,
        ___GeographicalCoordinates_iE_Extensions__item__extensionValue,
        __GeographicalCoordinates_iE_Extensions__item_,
        _GeographicalCoordinates_iE_Extensions,
        GeographicalCoordinates,
        GeographicalCoordinates_ExtIEs,
        _GA_AltitudeAndDirection_directionOfAltitude,
        _GA_AltitudeAndDirection_altitude,
        GA_AltitudeAndDirection,
        _GA_EllipsoidArc_geographicalCoordinates,
        _GA_EllipsoidArc_innerRadius,
        _GA_EllipsoidArc_uncertaintyRadius,
        _GA_EllipsoidArc_offsetAngle,
        _GA_EllipsoidArc_includedAngle,
        _GA_EllipsoidArc_confidence,
        ____GA_EllipsoidArc_iE_Extensions__item__id_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__id,
        ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__criticality,
        ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__extensionValue,
        __GA_EllipsoidArc_iE_Extensions__item_,
        _GA_EllipsoidArc_iE_Extensions,
        GA_EllipsoidArc,
        GA_EllipsoidArc_ExtIEs,
        _GA_Point_geographicalCoordinates,
        ____GA_Point_iE_Extensions__item__id_tab,
        ___GA_Point_iE_Extensions__item__id,
        ____GA_Point_iE_Extensions__item__criticality_tab,
        ___GA_Point_iE_Extensions__item__criticality,
        ____GA_Point_iE_Extensions__item__extensionValue_tab,
        ___GA_Point_iE_Extensions__item__extensionValue,
        __GA_Point_iE_Extensions__item_,
        _GA_Point_iE_Extensions,
        GA_Point,
        GA_Point_ExtIEs,
        _GA_PointWithAltitude_geographicalCoordinates,
        _GA_PointWithAltitude_altitudeAndDirection,
        ____GA_PointWithAltitude_iE_Extensions__item__id_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__id,
        ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__criticality,
        ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__extensionValue,
        __GA_PointWithAltitude_iE_Extensions__item_,
        _GA_PointWithAltitude_iE_Extensions,
        GA_PointWithAltitude,
        GA_PointWithAltitude_ExtIEs,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue,
        __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions,
        GA_PointWithAltitudeAndUncertaintyEllipsoid,
        GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs,
        _GA_PointWithUnCertainty_geographicalCoordinates,
        _GA_PointWithUnCertainty_uncertaintyCode,
        ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__id,
        ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__criticality,
        ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue,
        __GA_PointWithUnCertainty_iE_Extensions__item_,
        _GA_PointWithUnCertainty_iE_Extensions,
        GA_PointWithUnCertainty,
        GA_PointWithUnCertainty_ExtIEs,
        _GA_PointWithUnCertaintyEllipse_geographicalCoordinates,
        _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse,
        _GA_PointWithUnCertaintyEllipse_confidence,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue,
        __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_,
        _GA_PointWithUnCertaintyEllipse_iE_Extensions,
        GA_PointWithUnCertaintyEllipse,
        GA_PointWithUnCertaintyEllipse_ExtIEs,
        __GA_Polygon__item__geographicalCoordinates,
        _____GA_Polygon__item__iE_Extensions__item__id_tab,
        ____GA_Polygon__item__iE_Extensions__item__id,
        _____GA_Polygon__item__iE_Extensions__item__criticality_tab,
        ____GA_Polygon__item__iE_Extensions__item__criticality,
        _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab,
        ____GA_Polygon__item__iE_Extensions__item__extensionValue,
        ___GA_Polygon__item__iE_Extensions__item_,
        __GA_Polygon__item__iE_Extensions,
        _GA_Polygon__item_,
        GA_Polygon,
        GA_Polygon_ExtIEs,
        _GA_UncertaintyEllipse_uncertaintySemi_major,
        _GA_UncertaintyEllipse_uncertaintySemi_minor,
        _GA_UncertaintyEllipse_orientationOfMajorAxis,
        GA_UncertaintyEllipse,
        _UE_PositionEstimateInfo_referenceTimeChoice,
        _UE_PositionEstimateInfo_ue_positionEstimate,
        ____UE_PositionEstimateInfo_iE_Extensions__item__id_tab,
        _____UE_PositionEstimateInfo_iE_Extensions__item__id_tab_val_Extension_0,
        _____UE_PositionEstimateInfo_iE_Extensions__item__id_tab_val_Extension_1,
        ___UE_PositionEstimateInfo_iE_Extensions__item__id,
        ___UE_PositionEstimateInfo_iE_Extensions__item__criticality,
        ___UE_PositionEstimateInfo_iE_Extensions__item__extensionValue,
        __UE_PositionEstimateInfo_iE_Extensions__item_,
        _UE_PositionEstimateInfo_iE_Extensions,
        UE_PositionEstimateInfo,
        UE_PositionEstimateInfo_ExtIEs,
        _UE_PositionEstimateInfo_ExtIEs_val_Extension_0,
        _UE_PositionEstimateInfo_ExtIEs_val_Extension_1,
        _ReferenceTimeChoice_utran_GPSReferenceTimeResult,
        _ReferenceTimeChoice_gps_ReferenceTimeOnly,
        _ReferenceTimeChoice_cell_Timing,
        _ReferenceTimeChoice_extension_ReferenceTimeChoice,
        ReferenceTimeChoice,
        __Extension_ReferenceTimeChoice_id_tab,
        ___Extension_ReferenceTimeChoice_id_tab_val_Value_0,
        ___Extension_ReferenceTimeChoice_id_tab_val_Value_1,
        _Extension_ReferenceTimeChoice_id,
        _Extension_ReferenceTimeChoice_criticality,
        _Extension_ReferenceTimeChoice_value,
        Extension_ReferenceTimeChoice,
        Extension_ReferenceTimeChoice_IE,
        _Extension_ReferenceTimeChoice_IE_val_Value_0,
        _Extension_ReferenceTimeChoice_IE_val_Value_1,
        _Cell_Timing_sfn,
        _Cell_Timing_uC_ID,
        ____Cell_Timing_iE_Extensions__item__id_tab,
        ___Cell_Timing_iE_Extensions__item__id,
        ____Cell_Timing_iE_Extensions__item__criticality_tab,
        ___Cell_Timing_iE_Extensions__item__criticality,
        ____Cell_Timing_iE_Extensions__item__extensionValue_tab,
        ___Cell_Timing_iE_Extensions__item__extensionValue,
        __Cell_Timing_iE_Extensions__item_,
        _Cell_Timing_iE_Extensions,
        Cell_Timing,
        Cell_Timing_ExtIEs,
        _GANSS_Reference_Time_Only_ganssTODmsec,
        _GANSS_Reference_Time_Only_ganssTimeID,
        ____GANSS_Reference_Time_Only_iE_Extensions__item__id_tab,
        ___GANSS_Reference_Time_Only_iE_Extensions__item__id,
        ____GANSS_Reference_Time_Only_iE_Extensions__item__criticality_tab,
        ___GANSS_Reference_Time_Only_iE_Extensions__item__criticality,
        ____GANSS_Reference_Time_Only_iE_Extensions__item__extensionValue_tab,
        ___GANSS_Reference_Time_Only_iE_Extensions__item__extensionValue,
        __GANSS_Reference_Time_Only_iE_Extensions__item_,
        _GANSS_Reference_Time_Only_iE_Extensions,
        GANSS_Reference_Time_Only,
        GANSS_Reference_Time_Only_ExtIEs,
        _PositionDataUEbased_positionData,
        ____PositionDataUEbased_iE_Extensions__item__id_tab,
        ___PositionDataUEbased_iE_Extensions__item__id,
        ____PositionDataUEbased_iE_Extensions__item__criticality_tab,
        ___PositionDataUEbased_iE_Extensions__item__criticality,
        ____PositionDataUEbased_iE_Extensions__item__extensionValue_tab,
        ___PositionDataUEbased_iE_Extensions__item__extensionValue,
        __PositionDataUEbased_iE_Extensions__item_,
        _PositionDataUEbased_iE_Extensions,
        PositionDataUEbased,
        PositionDataUEbased_ExtIEs,
        _PositionData_positioningDataDiscriminator,
        _PositionData_positioningDataSet,
        ____PositionData_iE_Extensions__item__id_tab,
        _____PositionData_iE_Extensions__item__id_tab_val_Extension_0,
        _____PositionData_iE_Extensions__item__id_tab_val_Extension_1,
        ___PositionData_iE_Extensions__item__id,
        ___PositionData_iE_Extensions__item__criticality,
        ___PositionData_iE_Extensions__item__extensionValue,
        __PositionData_iE_Extensions__item_,
        _PositionData_iE_Extensions,
        PositionData,
        PositionData_ExtIEs,
        _PositionData_ExtIEs_val_Extension_0,
        _PositionData_ExtIEs_val_Extension_1,
        _GANSS_PositioningDataSet__item_,
        GANSS_PositioningDataSet,
        GANSS_PositioningMethodAndUsage,
        PositioningDataDiscriminator,
        _PositioningDataSet__item_,
        PositioningDataSet,
        PositioningMethodAndUsage,
        _Additional_PositioningDataSet__item_,
        Additional_PositioningDataSet,
        Additional_PositioningMethodAndUsage,
        _GPS_AcquisitionAssistance_gps_TOW_1msec,
        _GPS_AcquisitionAssistance_satelliteInformationList,
        ____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab,
        _____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab_val_Extension_0,
        _____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab_val_Extension_1,
        _____GPS_AcquisitionAssistance_iE_Extensions__item__id_tab_val_Extension_2,
        ___GPS_AcquisitionAssistance_iE_Extensions__item__id,
        ___GPS_AcquisitionAssistance_iE_Extensions__item__criticality,
        ___GPS_AcquisitionAssistance_iE_Extensions__item__extensionValue,
        __GPS_AcquisitionAssistance_iE_Extensions__item_,
        _GPS_AcquisitionAssistance_iE_Extensions,
        GPS_AcquisitionAssistance,
        GPS_AcquisitionAssistance_ExtIEs,
        _GPS_AcquisitionAssistance_ExtIEs_val_Extension_0,
        _GPS_AcquisitionAssistance_ExtIEs_val_Extension_1,
        _GPS_AcquisitionAssistance_ExtIEs_val_Extension_2,
        _AcquisitionSatInfoList__item_,
        AcquisitionSatInfoList,
        _AcquisitionSatInfo_satID,
        _AcquisitionSatInfo_doppler0thOrder,
        _AcquisitionSatInfo_extraDopplerInfo,
        _AcquisitionSatInfo_codePhase,
        _AcquisitionSatInfo_integerCodePhase,
        _AcquisitionSatInfo_gps_BitNumber,
        _AcquisitionSatInfo_codePhaseSearchWindow,
        _AcquisitionSatInfo_azimuthAndElevation,
        ____AcquisitionSatInfo_iE_Extensions__item__id_tab,
        _____AcquisitionSatInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___AcquisitionSatInfo_iE_Extensions__item__id,
        ___AcquisitionSatInfo_iE_Extensions__item__criticality,
        ___AcquisitionSatInfo_iE_Extensions__item__extensionValue,
        __AcquisitionSatInfo_iE_Extensions__item_,
        _AcquisitionSatInfo_iE_Extensions,
        AcquisitionSatInfo,
        AcquisitionSatInfo_ExtIEs,
        _AcquisitionSatInfo_ExtIEs_val_Extension_0,
        _ExtraDopplerInfo_doppler1stOrder,
        _ExtraDopplerInfo_dopplerUncertainty,
        ____ExtraDopplerInfo_iE_Extensions__item__id_tab,
        ___ExtraDopplerInfo_iE_Extensions__item__id,
        ____ExtraDopplerInfo_iE_Extensions__item__criticality_tab,
        ___ExtraDopplerInfo_iE_Extensions__item__criticality,
        ____ExtraDopplerInfo_iE_Extensions__item__extensionValue_tab,
        ___ExtraDopplerInfo_iE_Extensions__item__extensionValue,
        __ExtraDopplerInfo_iE_Extensions__item_,
        _ExtraDopplerInfo_iE_Extensions,
        ExtraDopplerInfo,
        ExtraDopplerInfo_ExtIEs,
        _ExtraDopplerInfoExtension_doppler1stOrder,
        _ExtraDopplerInfoExtension_dopplerUncertaintyExtension,
        ____ExtraDopplerInfoExtension_iE_Extensions__item__id_tab,
        ___ExtraDopplerInfoExtension_iE_Extensions__item__id,
        ____ExtraDopplerInfoExtension_iE_Extensions__item__criticality_tab,
        ___ExtraDopplerInfoExtension_iE_Extensions__item__criticality,
        ____ExtraDopplerInfoExtension_iE_Extensions__item__extensionValue_tab,
        ___ExtraDopplerInfoExtension_iE_Extensions__item__extensionValue,
        __ExtraDopplerInfoExtension_iE_Extensions__item_,
        _ExtraDopplerInfoExtension_iE_Extensions,
        ExtraDopplerInfoExtension,
        ExtraDopplerInfoExtension_ExtIEs,
        DopplerUncertainty,
        DopplerUncertaintyExtension,
        CodePhaseSearchWindow,
        _AzimuthAndElevation_azimuth,
        _AzimuthAndElevation_elevation,
        ____AzimuthAndElevation_iE_Extensions__item__id_tab,
        _____AzimuthAndElevation_iE_Extensions__item__id_tab_val_Extension_0,
        ___AzimuthAndElevation_iE_Extensions__item__id,
        ___AzimuthAndElevation_iE_Extensions__item__criticality,
        ___AzimuthAndElevation_iE_Extensions__item__extensionValue,
        __AzimuthAndElevation_iE_Extensions__item_,
        _AzimuthAndElevation_iE_Extensions,
        AzimuthAndElevation,
        AzimuthAndElevation_ExtIEs,
        _AzimuthAndElevation_ExtIEs_val_Extension_0,
        _AzimuthAndElevationLSB_azimuthLSB,
        _AzimuthAndElevationLSB_elevationLSB,
        ____AzimuthAndElevationLSB_iE_Extensions__item__id_tab,
        ___AzimuthAndElevationLSB_iE_Extensions__item__id,
        ____AzimuthAndElevationLSB_iE_Extensions__item__criticality_tab,
        ___AzimuthAndElevationLSB_iE_Extensions__item__criticality,
        ____AzimuthAndElevationLSB_iE_Extensions__item__extensionValue_tab,
        ___AzimuthAndElevationLSB_iE_Extensions__item__extensionValue,
        __AzimuthAndElevationLSB_iE_Extensions__item_,
        _AzimuthAndElevationLSB_iE_Extensions,
        AzimuthAndElevationLSB,
        AzimuthAndElevationLSB_ExtIEs,
        Confidence,
        _AuxInfoGANSS_ID1__item_,
        AuxInfoGANSS_ID1,
        _AuxInfoGANSS_ID1_element_svID,
        _AuxInfoGANSS_ID1_element_signalsAvailable,
        ____AuxInfoGANSS_ID1_element_ie_Extensions__item__id_tab,
        ___AuxInfoGANSS_ID1_element_ie_Extensions__item__id,
        ____AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality_tab,
        ___AuxInfoGANSS_ID1_element_ie_Extensions__item__criticality,
        ____AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue_tab,
        ___AuxInfoGANSS_ID1_element_ie_Extensions__item__extensionValue,
        __AuxInfoGANSS_ID1_element_ie_Extensions__item_,
        _AuxInfoGANSS_ID1_element_ie_Extensions,
        AuxInfoGANSS_ID1_element,
        AuxInfoGANSS_ID1_element_ExtIEs,
        _AuxInfoGANSS_ID3__item_,
        AuxInfoGANSS_ID3,
        _AuxInfoGANSS_ID3_element_svID,
        _AuxInfoGANSS_ID3_element_signalsAvailable,
        _AuxInfoGANSS_ID3_element_channelNumber,
        ____AuxInfoGANSS_ID3_element_ie_Extensions__item__id_tab,
        ___AuxInfoGANSS_ID3_element_ie_Extensions__item__id,
        ____AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality_tab,
        ___AuxInfoGANSS_ID3_element_ie_Extensions__item__criticality,
        ____AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue_tab,
        ___AuxInfoGANSS_ID3_element_ie_Extensions__item__extensionValue,
        __AuxInfoGANSS_ID3_element_ie_Extensions__item_,
        _AuxInfoGANSS_ID3_element_ie_Extensions,
        AuxInfoGANSS_ID3_element,
        AuxInfoGANSS_ID3_element_ExtIEs,
        _CNAVclockModel_cnavToc,
        _CNAVclockModel_cnavTop,
        _CNAVclockModel_cnavURA0,
        _CNAVclockModel_cnavURA1,
        _CNAVclockModel_cnavURA2,
        _CNAVclockModel_cnavAf2,
        _CNAVclockModel_cnavAf1,
        _CNAVclockModel_cnavAf0,
        _CNAVclockModel_cnavTgd,
        _CNAVclockModel_cnavISCl1cp,
        _CNAVclockModel_cnavISCl1cd,
        _CNAVclockModel_cnavISCl1ca,
        _CNAVclockModel_cnavISCl2c,
        _CNAVclockModel_cnavISCl5i5,
        _CNAVclockModel_cnavISCl5q5,
        ____CNAVclockModel_ie_Extensions__item__id_tab,
        ___CNAVclockModel_ie_Extensions__item__id,
        ____CNAVclockModel_ie_Extensions__item__criticality_tab,
        ___CNAVclockModel_ie_Extensions__item__criticality,
        ____CNAVclockModel_ie_Extensions__item__extensionValue_tab,
        ___CNAVclockModel_ie_Extensions__item__extensionValue,
        __CNAVclockModel_ie_Extensions__item_,
        _CNAVclockModel_ie_Extensions,
        CNAVclockModel,
        CNAVclockModel_ExtIEs,
        _DeltaUT1_b1,
        _DeltaUT1_b2,
        ____DeltaUT1_ie_Extensions__item__id_tab,
        ___DeltaUT1_ie_Extensions__item__id,
        ____DeltaUT1_ie_Extensions__item__criticality_tab,
        ___DeltaUT1_ie_Extensions__item__criticality,
        ____DeltaUT1_ie_Extensions__item__extensionValue_tab,
        ___DeltaUT1_ie_Extensions__item__extensionValue,
        __DeltaUT1_ie_Extensions__item_,
        _DeltaUT1_ie_Extensions,
        DeltaUT1,
        DeltaUT1_ExtIEs,
        _DGANSS_Corrections_dGANSS_ReferenceTime,
        _DGANSS_Corrections_dGANSS_Information,
        ____DGANSS_Corrections_ie_Extensions__item__id_tab,
        ___DGANSS_Corrections_ie_Extensions__item__id,
        ____DGANSS_Corrections_ie_Extensions__item__criticality_tab,
        ___DGANSS_Corrections_ie_Extensions__item__criticality,
        ____DGANSS_Corrections_ie_Extensions__item__extensionValue_tab,
        ___DGANSS_Corrections_ie_Extensions__item__extensionValue,
        __DGANSS_Corrections_ie_Extensions__item_,
        _DGANSS_Corrections_ie_Extensions,
        DGANSS_Corrections,
        DGANSS_Corrections_ExtIEs,
        _DGANSS_Information__item_,
        DGANSS_Information,
        _DGANSS_InformationItem_gANSS_SignalId,
        _DGANSS_InformationItem_gANSS_StatusHealth,
        _DGANSS_InformationItem_dGANSS_SignalInformation,
        ____DGANSS_InformationItem_ie_Extensions__item__id_tab,
        ___DGANSS_InformationItem_ie_Extensions__item__id,
        ____DGANSS_InformationItem_ie_Extensions__item__criticality_tab,
        ___DGANSS_InformationItem_ie_Extensions__item__criticality,
        ____DGANSS_InformationItem_ie_Extensions__item__extensionValue_tab,
        ___DGANSS_InformationItem_ie_Extensions__item__extensionValue,
        __DGANSS_InformationItem_ie_Extensions__item_,
        _DGANSS_InformationItem_ie_Extensions,
        DGANSS_InformationItem,
        DGANSS_InformationItem_ExtIEs,
        _DGANSS_SignalInformation__item_,
        DGANSS_SignalInformation,
        _DGANSS_SignalInformationItem_satId,
        _DGANSS_SignalInformationItem_gANSS_iod,
        _DGANSS_SignalInformationItem_udre,
        _DGANSS_SignalInformationItem_ganss_prc,
        _DGANSS_SignalInformationItem_ganss_rrc,
        ____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab,
        _____DGANSS_SignalInformationItem_ie_Extensions__item__id_tab_val_Extension_0,
        ___DGANSS_SignalInformationItem_ie_Extensions__item__id,
        ___DGANSS_SignalInformationItem_ie_Extensions__item__criticality,
        ___DGANSS_SignalInformationItem_ie_Extensions__item__extensionValue,
        __DGANSS_SignalInformationItem_ie_Extensions__item_,
        _DGANSS_SignalInformationItem_ie_Extensions,
        DGANSS_SignalInformationItem,
        DGANSS_SignalInformationItem_ExtIEs,
        _DGANSS_SignalInformationItem_ExtIEs_val_Extension_0,
        _GANSS_AddClockModels_navClockModel,
        _GANSS_AddClockModels_cnavClockModel,
        _GANSS_AddClockModels_glonassClockModel,
        _GANSS_AddClockModels_sbasClockModel,
        _GANSS_AddClockModels_bDSClockModel,
        GANSS_AddClockModels,
        _GANSS_AddOrbitModels_navKeplerianSet,
        _GANSS_AddOrbitModels_cnavKeplerianSet,
        _GANSS_AddOrbitModels_glonassECEF,
        _GANSS_AddOrbitModels_sbasECEF,
        _GANSS_AddOrbitModels_bDSKeplerianSet,
        GANSS_AddOrbitModels,
        _GANSS_Additional_Ionospheric_Model_dataID,
        _GANSS_Additional_Ionospheric_Model_alpha_beta_parameters,
        ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id_tab,
        ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__id,
        ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality_tab,
        ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__criticality,
        ____GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Additional_Ionospheric_Model_ie_Extensions__item__extensionValue,
        __GANSS_Additional_Ionospheric_Model_ie_Extensions__item_,
        _GANSS_Additional_Ionospheric_Model_ie_Extensions,
        GANSS_Additional_Ionospheric_Model,
        GANSS_Additional_Ionospheric_Model_ExtIEs,
        _GANSS_Additional_Navigation_Models_non_broadcastIndication,
        _GANSS_Additional_Navigation_Models_ganssSatInfoNavList,
        ____GANSS_Additional_Navigation_Models_ie_Extensions__item__id_tab,
        ___GANSS_Additional_Navigation_Models_ie_Extensions__item__id,
        ____GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality_tab,
        ___GANSS_Additional_Navigation_Models_ie_Extensions__item__criticality,
        ____GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Additional_Navigation_Models_ie_Extensions__item__extensionValue,
        __GANSS_Additional_Navigation_Models_ie_Extensions__item_,
        _GANSS_Additional_Navigation_Models_ie_Extensions,
        GANSS_Additional_Navigation_Models,
        GANSS_Additional_Navigation_Models_ExtIEs,
        _GANSS_Additional_Time_Models__item_,
        GANSS_Additional_Time_Models,
        _GANSS_Additional_UTC_Models_utcModel1,
        _GANSS_Additional_UTC_Models_utcModel2,
        _GANSS_Additional_UTC_Models_utcModel3,
        _GANSS_Additional_UTC_Models_utcModel4,
        GANSS_Additional_UTC_Models,
        _GANSS_ALM_BDSKeplericanset_satellite_Information_BDS_KP_List,
        ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__id_tab,
        ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__id,
        ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__criticality,
        ____GANSS_ALM_BDSKeplericanset_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_BDSKeplericanset_ie_Extensions__item__extensionValue,
        __GANSS_ALM_BDSKeplericanset_ie_Extensions__item_,
        _GANSS_ALM_BDSKeplericanset_ie_Extensions,
        GANSS_ALM_BDSKeplericanset,
        GANSS_ALM_BDSKeplericanset_ExtIEs,
        _Satellite_Information_BDS_KP_List__item_,
        Satellite_Information_BDS_KP_List,
        _Satellite_Information_BDS_KP_Item_sVID_BDS,
        _Satellite_Information_BDS_KP_Item_tOA_BDS,
        _Satellite_Information_BDS_KP_Item_a21_BDS,
        _Satellite_Information_BDS_KP_Item_e_BDS,
        _Satellite_Information_BDS_KP_Item_omg_lower_BDS,
        _Satellite_Information_BDS_KP_Item_m0_BDS,
        _Satellite_Information_BDS_KP_Item_omg_0_BDS,
        _Satellite_Information_BDS_KP_Item_omg_upper_BDS,
        _Satellite_Information_BDS_KP_Item_delta_i_BDS,
        _Satellite_Information_BDS_KP_Item_a0_BDS,
        _Satellite_Information_BDS_KP_Item_a1_BDS,
        _Satellite_Information_BDS_KP_Item_hea_BDS,
        ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__id_tab,
        ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__id,
        ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__criticality_tab,
        ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__criticality,
        ____Satellite_Information_BDS_KP_Item_ie_Extensions__item__extensionValue_tab,
        ___Satellite_Information_BDS_KP_Item_ie_Extensions__item__extensionValue,
        __Satellite_Information_BDS_KP_Item_ie_Extensions__item_,
        _Satellite_Information_BDS_KP_Item_ie_Extensions,
        Satellite_Information_BDS_KP_Item,
        Satellite_Information_BDS_KP_Item_ExtIEs,
        _GANSS_ALM_ECEFsbasAlmanacSet_sat_info_SBASecefList,
        ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id_tab,
        ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__id,
        ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__criticality,
        ____GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item__extensionValue,
        __GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions__item_,
        _GANSS_ALM_ECEFsbasAlmanacSet_ie_Extensions,
        GANSS_ALM_ECEFsbasAlmanacSet,
        GANSS_ALM_ECEFsbasAlmanacSet_ExtIEs,
        _GANSS_ALM_GlonassAlmanacSet_sat_info_GLOkpList,
        ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id_tab,
        ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__id,
        ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__criticality,
        ____GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item__extensionValue,
        __GANSS_ALM_GlonassAlmanacSet_ie_Extensions__item_,
        _GANSS_ALM_GlonassAlmanacSet_ie_Extensions,
        GANSS_ALM_GlonassAlmanacSet,
        GANSS_ALM_GlonassAlmanacSet_ExtIEs,
        _GANSS_ALM_MidiAlmanacSet_t_oa,
        _GANSS_ALM_MidiAlmanacSet_sat_info_MIDIkpList,
        ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id_tab,
        ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__id,
        ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__criticality,
        ____GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_MidiAlmanacSet_ie_Extensions__item__extensionValue,
        __GANSS_ALM_MidiAlmanacSet_ie_Extensions__item_,
        _GANSS_ALM_MidiAlmanacSet_ie_Extensions,
        GANSS_ALM_MidiAlmanacSet,
        GANSS_ALM_MidiAlmanacSet_ExtIEs,
        _GANSS_ALM_NAVKeplerianSet_t_oa,
        _GANSS_ALM_NAVKeplerianSet_sat_info_NAVkpList,
        ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id_tab,
        ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__id,
        ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__criticality,
        ____GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_NAVKeplerianSet_ie_Extensions__item__extensionValue,
        __GANSS_ALM_NAVKeplerianSet_ie_Extensions__item_,
        _GANSS_ALM_NAVKeplerianSet_ie_Extensions,
        GANSS_ALM_NAVKeplerianSet,
        GANSS_ALM_NAVKeplerianSet_ExtIEs,
        _GANSS_ALM_ReducedKeplerianSet_t_oa,
        _GANSS_ALM_ReducedKeplerianSet_sat_info_REDkpList,
        ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id_tab,
        ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__id,
        ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality_tab,
        ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__criticality,
        ____GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item__extensionValue,
        __GANSS_ALM_ReducedKeplerianSet_ie_Extensions__item_,
        _GANSS_ALM_ReducedKeplerianSet_ie_Extensions,
        GANSS_ALM_ReducedKeplerianSet,
        GANSS_ALM_ReducedKeplerianSet_ExtIEs,
        _GANSS_AlmanacAndSatelliteHealth_weekNumber,
        _GANSS_AlmanacAndSatelliteHealth_gANSS_AlmanacModel,
        ____GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id_tab,
        _____GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__id,
        ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__criticality,
        ___GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item__extensionValue,
        __GANSS_AlmanacAndSatelliteHealth_ie_Extensions__item_,
        _GANSS_AlmanacAndSatelliteHealth_ie_Extensions,
        GANSS_AlmanacAndSatelliteHealth,
        GANSS_AlmanacAndSatelliteHealth_ExtIEs,
        _GANSS_AlmanacAndSatelliteHealth_ExtIEs_val_Extension_0,
        _GANSS_AlmanacModel_gANSS_keplerianParameters,
        _GANSS_AlmanacModel_extension_GANSS_AlmanacModel,
        GANSS_AlmanacModel,
        __Extension_GANSS_AlmanacModel_id_tab,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_0,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_1,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_2,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_3,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_4,
        ___Extension_GANSS_AlmanacModel_id_tab_val_Value_5,
        _Extension_GANSS_AlmanacModel_id,
        _Extension_GANSS_AlmanacModel_criticality,
        _Extension_GANSS_AlmanacModel_value,
        Extension_GANSS_AlmanacModel,
        Extension_GANSS_AlmanacModel_IE,
        _Extension_GANSS_AlmanacModel_IE_val_Value_0,
        _Extension_GANSS_AlmanacModel_IE_val_Value_1,
        _Extension_GANSS_AlmanacModel_IE_val_Value_2,
        _Extension_GANSS_AlmanacModel_IE_val_Value_3,
        _Extension_GANSS_AlmanacModel_IE_val_Value_4,
        _Extension_GANSS_AlmanacModel_IE_val_Value_5,
        _GANSS_Auxiliary_Information_ganssID1,
        _GANSS_Auxiliary_Information_ganssID3,
        GANSS_Auxiliary_Information,
        _GANSS_AzimuthAndElevation_azimuth,
        _GANSS_AzimuthAndElevation_elevation,
        ____GANSS_AzimuthAndElevation_ie_Extensions__item__id_tab,
        _____GANSS_AzimuthAndElevation_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_AzimuthAndElevation_ie_Extensions__item__id,
        ___GANSS_AzimuthAndElevation_ie_Extensions__item__criticality,
        ___GANSS_AzimuthAndElevation_ie_Extensions__item__extensionValue,
        __GANSS_AzimuthAndElevation_ie_Extensions__item_,
        _GANSS_AzimuthAndElevation_ie_Extensions,
        GANSS_AzimuthAndElevation,
        GANSS_AzimuthAndElevation_ExtIEs,
        _GANSS_AzimuthAndElevation_ExtIEs_val_Extension_0,
        _GANSS_Clock_Model__item_,
        GANSS_Clock_Model,
        _GANSS_CommonAssistanceData_ganss_Reference_Time,
        _GANSS_CommonAssistanceData_ganss_Ionospheric_Model,
        _GANSS_CommonAssistanceData_ganss_Reference_Location,
        ____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab,
        _____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSS_CommonAssistanceData_ie_Extensions__item__id_tab_val_Extension_1,
        ___GANSS_CommonAssistanceData_ie_Extensions__item__id,
        ___GANSS_CommonAssistanceData_ie_Extensions__item__criticality,
        ___GANSS_CommonAssistanceData_ie_Extensions__item__extensionValue,
        __GANSS_CommonAssistanceData_ie_Extensions__item_,
        _GANSS_CommonAssistanceData_ie_Extensions,
        GANSS_CommonAssistanceData,
        GANSS_CommonAssistanceData_ExtIEs,
        _GANSS_CommonAssistanceData_ExtIEs_val_Extension_0,
        _GANSS_CommonAssistanceData_ExtIEs_val_Extension_1,
        _GANSS_Data_Bit_Assistance_ganssTod,
        _GANSS_Data_Bit_Assistance_dataBitAssistancelist,
        ____GANSS_Data_Bit_Assistance_ie_Extensions__item__id_tab,
        ___GANSS_Data_Bit_Assistance_ie_Extensions__item__id,
        ____GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality_tab,
        ___GANSS_Data_Bit_Assistance_ie_Extensions__item__criticality,
        ____GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Data_Bit_Assistance_ie_Extensions__item__extensionValue,
        __GANSS_Data_Bit_Assistance_ie_Extensions__item_,
        _GANSS_Data_Bit_Assistance_ie_Extensions,
        GANSS_Data_Bit_Assistance,
        GANSS_Data_Bit_Assistance_ExtIEs,
        _GANSS_DataBitAssistanceList__item_,
        GANSS_DataBitAssistanceList,
        _GANSS_DataBitAssistanceItem_satId,
        _GANSS_DataBitAssistanceItem_dataBitAssistanceSgnList,
        ____GANSS_DataBitAssistanceItem_ie_Extensions__item__id_tab,
        ___GANSS_DataBitAssistanceItem_ie_Extensions__item__id,
        ____GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality_tab,
        ___GANSS_DataBitAssistanceItem_ie_Extensions__item__criticality,
        ____GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_DataBitAssistanceItem_ie_Extensions__item__extensionValue,
        __GANSS_DataBitAssistanceItem_ie_Extensions__item_,
        _GANSS_DataBitAssistanceItem_ie_Extensions,
        GANSS_DataBitAssistanceItem,
        GANSS_DataBitAssistanceItem_ExtIEs,
        _GANSS_DataBitAssistanceSgnList__item_,
        GANSS_DataBitAssistanceSgnList,
        _GANSS_DataBitAssistanceSgnItem_ganss_SignalId,
        _GANSS_DataBitAssistanceSgnItem_ganssDataBits,
        ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id_tab,
        ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__id,
        ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality_tab,
        ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__criticality,
        ____GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_DataBitAssistanceSgnItem_ie_Extensions__item__extensionValue,
        __GANSS_DataBitAssistanceSgnItem_ie_Extensions__item_,
        _GANSS_DataBitAssistanceSgnItem_ie_Extensions,
        GANSS_DataBitAssistanceSgnItem,
        GANSS_DataBitAssistanceSgnItem_ExtIEs,
        _GANSS_Earth_Orientation_Parameters_teop,
        _GANSS_Earth_Orientation_Parameters_pmX,
        _GANSS_Earth_Orientation_Parameters_pmXdot,
        _GANSS_Earth_Orientation_Parameters_pmY,
        _GANSS_Earth_Orientation_Parameters_pmYdot,
        _GANSS_Earth_Orientation_Parameters_deltaUT1,
        _GANSS_Earth_Orientation_Parameters_deltaUT1dot,
        ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id_tab,
        ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__id,
        ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality_tab,
        ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__criticality,
        ____GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Earth_Orientation_Parameters_ie_Extensions__item__extensionValue,
        __GANSS_Earth_Orientation_Parameters_ie_Extensions__item_,
        _GANSS_Earth_Orientation_Parameters_ie_Extensions,
        GANSS_Earth_Orientation_Parameters,
        GANSS_Earth_Orientation_Parameters_ExtIEs,
        _GANSS_ExtraDoppler_dopplerFirstOrder,
        _GANSS_ExtraDoppler_dopplerUncertainty,
        ____GANSS_ExtraDoppler_ie_Extensions__item__id_tab,
        ___GANSS_ExtraDoppler_ie_Extensions__item__id,
        ____GANSS_ExtraDoppler_ie_Extensions__item__criticality_tab,
        ___GANSS_ExtraDoppler_ie_Extensions__item__criticality,
        ____GANSS_ExtraDoppler_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ExtraDoppler_ie_Extensions__item__extensionValue,
        __GANSS_ExtraDoppler_ie_Extensions__item_,
        _GANSS_ExtraDoppler_ie_Extensions,
        GANSS_ExtraDoppler,
        GANSS_ExtraDoppler_ExtIEs,
        _GANSS_ExtraDopplerExtension_dopplerFirstOrder,
        _GANSS_ExtraDopplerExtension_dopplerUncertaintyExtension,
        ____GANSS_ExtraDopplerExtension_ie_Extensions__item__id_tab,
        ___GANSS_ExtraDopplerExtension_ie_Extensions__item__id,
        ____GANSS_ExtraDopplerExtension_ie_Extensions__item__criticality_tab,
        ___GANSS_ExtraDopplerExtension_ie_Extensions__item__criticality,
        ____GANSS_ExtraDopplerExtension_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ExtraDopplerExtension_ie_Extensions__item__extensionValue,
        __GANSS_ExtraDopplerExtension_ie_Extensions__item_,
        _GANSS_ExtraDopplerExtension_ie_Extensions,
        GANSS_ExtraDopplerExtension,
        GANSS_ExtraDopplerExtension_ExtIEs,
        _GANSS_GenericAssistanceDataList__item_,
        GANSS_GenericAssistanceDataList,
        _GANSSGenericAssistanceData_ganssId,
        _GANSSGenericAssistanceData_ganss_Real_Time_Integrity,
        _GANSSGenericAssistanceData_ganss_DataBitAssistance,
        _GANSSGenericAssistanceData_dganss_Corrections,
        _GANSSGenericAssistanceData_ganss_AlmanacAndSatelliteHealth,
        _GANSSGenericAssistanceData_ganss_ReferenceMeasurementInfo,
        _GANSSGenericAssistanceData_ganss_UTC_Model,
        _GANSSGenericAssistanceData_ganss_Time_Model,
        _GANSSGenericAssistanceData_ganss_Navigation_Model,
        ____GANSSGenericAssistanceData_ie_Extensions__item__id_tab,
        _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_1,
        _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_2,
        _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_3,
        _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_4,
        _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_5,
        _____GANSSGenericAssistanceData_ie_Extensions__item__id_tab_val_Extension_6,
        ___GANSSGenericAssistanceData_ie_Extensions__item__id,
        ___GANSSGenericAssistanceData_ie_Extensions__item__criticality,
        ___GANSSGenericAssistanceData_ie_Extensions__item__extensionValue,
        __GANSSGenericAssistanceData_ie_Extensions__item_,
        _GANSSGenericAssistanceData_ie_Extensions,
        GANSSGenericAssistanceData,
        GANSSGenericAssistance_ExtIEs,
        _GANSSGenericAssistance_ExtIEs_val_Extension_0,
        _GANSSGenericAssistance_ExtIEs_val_Extension_1,
        _GANSSGenericAssistance_ExtIEs_val_Extension_2,
        _GANSSGenericAssistance_ExtIEs_val_Extension_3,
        _GANSSGenericAssistance_ExtIEs_val_Extension_4,
        _GANSSGenericAssistance_ExtIEs_val_Extension_5,
        _GANSSGenericAssistance_ExtIEs_val_Extension_6,
        _BDS_Ionospheric_Grid_Model_bDS_Reference_Time,
        _BDS_Ionospheric_Grid_Model_bDS_Ionospheric_Grid_Information,
        ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__id_tab,
        ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__id,
        ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality_tab,
        ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__criticality,
        ____BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue_tab,
        ___BDS_Ionospheric_Grid_Model_ie_Extensions__item__extensionValue,
        __BDS_Ionospheric_Grid_Model_ie_Extensions__item_,
        _BDS_Ionospheric_Grid_Model_ie_Extensions,
        BDS_Ionospheric_Grid_Model,
        BDS_Ionospheric_Grid_Model_ExtIEs,
        BDS_Reference_Time,
        __BDS_Ionospheric_Grid_Information__item__iGP_number_BDS,
        __BDS_Ionospheric_Grid_Information__item__vertical_Delay_BDS,
        __BDS_Ionospheric_Grid_Information__item__gIVEI_BDS,
        _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__id_tab,
        ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__id,
        _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__criticality_tab,
        ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__criticality,
        _____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__extensionValue_tab,
        ____BDS_Ionospheric_Grid_Information__item__ie_Extensions__item__extensionValue,
        ___BDS_Ionospheric_Grid_Information__item__ie_Extensions__item_,
        __BDS_Ionospheric_Grid_Information__item__ie_Extensions,
        _BDS_Ionospheric_Grid_Information__item_,
        BDS_Ionospheric_Grid_Information,
        BDS_Ionospheric_Grid_Information_ExtIEs,
        _DBDS_Correction_Information_bDS_Reference_Time,
        _DBDS_Correction_Information_dBDS_Information,
        ____DBDS_Correction_Information_ie_Extensions__item__id_tab,
        ___DBDS_Correction_Information_ie_Extensions__item__id,
        ____DBDS_Correction_Information_ie_Extensions__item__criticality_tab,
        ___DBDS_Correction_Information_ie_Extensions__item__criticality,
        ____DBDS_Correction_Information_ie_Extensions__item__extensionValue_tab,
        ___DBDS_Correction_Information_ie_Extensions__item__extensionValue,
        __DBDS_Correction_Information_ie_Extensions__item_,
        _DBDS_Correction_Information_ie_Extensions,
        DBDS_Correction_Information,
        DBDS_Correction_Information_ExtIEs,
        __DBDS_Information__item__dBDS_Signal_ID,
        __DBDS_Information__item__dGANSS_Signal_Information,
        _____DBDS_Information__item__ie_Extensions__item__id_tab,
        ____DBDS_Information__item__ie_Extensions__item__id,
        _____DBDS_Information__item__ie_Extensions__item__criticality_tab,
        ____DBDS_Information__item__ie_Extensions__item__criticality,
        _____DBDS_Information__item__ie_Extensions__item__extensionValue_tab,
        ____DBDS_Information__item__ie_Extensions__item__extensionValue,
        ___DBDS_Information__item__ie_Extensions__item_,
        __DBDS_Information__item__ie_Extensions,
        _DBDS_Information__item_,
        DBDS_Information,
        DBDS_Information_ExtIEs,
        __DGANSS_Signal_Information__item__sat_ID_BDS,
        __DGANSS_Signal_Information__item__uDREI_BDS,
        __DGANSS_Signal_Information__item__rURAI_BDS,
        __DGANSS_Signal_Information__item__delta_t_BDS,
        _____DGANSS_Signal_Information__item__ie_Extensions__item__id_tab,
        ____DGANSS_Signal_Information__item__ie_Extensions__item__id,
        _____DGANSS_Signal_Information__item__ie_Extensions__item__criticality_tab,
        ____DGANSS_Signal_Information__item__ie_Extensions__item__criticality,
        _____DGANSS_Signal_Information__item__ie_Extensions__item__extensionValue_tab,
        ____DGANSS_Signal_Information__item__ie_Extensions__item__extensionValue,
        ___DGANSS_Signal_Information__item__ie_Extensions__item_,
        __DGANSS_Signal_Information__item__ie_Extensions,
        _DGANSS_Signal_Information__item_,
        DGANSS_Signal_Information,
        DGANSS_Signal_Information_ExtIEs,
        __GANSS_GenericMeasurementInfo__item__ganssId,
        __GANSS_GenericMeasurementInfo__item__ganssMeasurementSignalList,
        _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__id_tab,
        ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__id,
        _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__criticality_tab,
        ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__criticality,
        _____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_GenericMeasurementInfo__item__ie_Extensions__item__extensionValue,
        ___GANSS_GenericMeasurementInfo__item__ie_Extensions__item_,
        __GANSS_GenericMeasurementInfo__item__ie_Extensions,
        _GANSS_GenericMeasurementInfo__item_,
        GANSS_GenericMeasurementInfo,
        GANSS_GenericMeasurementInfo_ExtIEs,
        _GANSSID_ganss_ID,
        ____GANSSID_ie_Extensions__item__id_tab,
        ___GANSSID_ie_Extensions__item__id,
        ____GANSSID_ie_Extensions__item__criticality_tab,
        ___GANSSID_ie_Extensions__item__criticality,
        ____GANSSID_ie_Extensions__item__extensionValue_tab,
        ___GANSSID_ie_Extensions__item__extensionValue,
        __GANSSID_ie_Extensions__item_,
        _GANSSID_ie_Extensions,
        GANSSID,
        GANSSID_ExtIEs,
        __GANSSMeasurementSignalList__item__ganssSignalId,
        __GANSSMeasurementSignalList__item__ganssCodePhaseAmbiguity,
        __GANSSMeasurementSignalList__item__ganssMeasurementParameters,
        _____GANSSMeasurementSignalList__item__ie_Extensions__item__id_tab,
        ______GANSSMeasurementSignalList__item__ie_Extensions__item__id_tab_val_Extension_0,
        ____GANSSMeasurementSignalList__item__ie_Extensions__item__id,
        ____GANSSMeasurementSignalList__item__ie_Extensions__item__criticality,
        ____GANSSMeasurementSignalList__item__ie_Extensions__item__extensionValue,
        ___GANSSMeasurementSignalList__item__ie_Extensions__item_,
        __GANSSMeasurementSignalList__item__ie_Extensions,
        _GANSSMeasurementSignalList__item_,
        GANSSMeasurementSignalList,
        GANSSMeasurementSignalList_ExtIEs,
        _GANSSMeasurementSignalList_ExtIEs_val_Extension_0,
        _GanssCodePhaseAmbiguityExt_ganssCodePhaseAmbiguity_ext,
        ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__id_tab,
        ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__id,
        ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__criticality_tab,
        ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__criticality,
        ____GanssCodePhaseAmbiguityExt_ie_Extensions__item__extensionValue_tab,
        ___GanssCodePhaseAmbiguityExt_ie_Extensions__item__extensionValue,
        __GanssCodePhaseAmbiguityExt_ie_Extensions__item_,
        _GanssCodePhaseAmbiguityExt_ie_Extensions,
        GanssCodePhaseAmbiguityExt,
        GanssCodePhaseAmbiguityExt_ExtIEs,
        _GANSS_Ionospheric_Model_alpha_zero_ionos,
        _GANSS_Ionospheric_Model_alpha_one_ionos,
        _GANSS_Ionospheric_Model_alpha_two_ionos,
        _GANSS_Ionospheric_Model_gANSS_IonosphereRegionalStormFlags,
        ____GANSS_Ionospheric_Model_ie_Extensions__item__id_tab,
        ___GANSS_Ionospheric_Model_ie_Extensions__item__id,
        ____GANSS_Ionospheric_Model_ie_Extensions__item__criticality_tab,
        ___GANSS_Ionospheric_Model_ie_Extensions__item__criticality,
        ____GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Ionospheric_Model_ie_Extensions__item__extensionValue,
        __GANSS_Ionospheric_Model_ie_Extensions__item_,
        _GANSS_Ionospheric_Model_ie_Extensions,
        GANSS_Ionospheric_Model,
        GANSS_Ionospheric_Model_ExtIEs,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_one,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_two,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_three,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_four,
        _GANSS_IonosphereRegionalStormFlags_storm_flag_five,
        ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id_tab,
        ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__id,
        ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality_tab,
        ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__criticality,
        ____GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue_tab,
        ___GANSS_IonosphereRegionalStormFlags_ie_Extensions__item__extensionValue,
        __GANSS_IonosphereRegionalStormFlags_ie_Extensions__item_,
        _GANSS_IonosphereRegionalStormFlags_ie_Extensions,
        GANSS_IonosphereRegionalStormFlags,
        GANSS_IonosphereRegionalStormFlags_ExtIEs,
        _GANSS_KeplerianParametersAlm_t_oa,
        _GANSS_KeplerianParametersAlm_iod_a,
        _GANSS_KeplerianParametersAlm_gANSS_SatelliteInformationKP,
        ____GANSS_KeplerianParametersAlm_ie_Extensions__item__id_tab,
        ___GANSS_KeplerianParametersAlm_ie_Extensions__item__id,
        ____GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality_tab,
        ___GANSS_KeplerianParametersAlm_ie_Extensions__item__criticality,
        ____GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue_tab,
        ___GANSS_KeplerianParametersAlm_ie_Extensions__item__extensionValue,
        __GANSS_KeplerianParametersAlm_ie_Extensions__item_,
        _GANSS_KeplerianParametersAlm_ie_Extensions,
        GANSS_KeplerianParametersAlm,
        GANSS_KeplerianParametersAlm_ExtIEs,
        _GANSS_KeplerianParametersOrb_toe_nav,
        _GANSS_KeplerianParametersOrb_ganss_omega_nav,
        _GANSS_KeplerianParametersOrb_delta_n_nav,
        _GANSS_KeplerianParametersOrb_m_zero_nav,
        _GANSS_KeplerianParametersOrb_omegadot_nav,
        _GANSS_KeplerianParametersOrb_ganss_e_nav,
        _GANSS_KeplerianParametersOrb_idot_nav,
        _GANSS_KeplerianParametersOrb_a_sqrt_nav,
        _GANSS_KeplerianParametersOrb_i_zero_nav,
        _GANSS_KeplerianParametersOrb_omega_zero_nav,
        _GANSS_KeplerianParametersOrb_c_rs_nav,
        _GANSS_KeplerianParametersOrb_c_is_nav,
        _GANSS_KeplerianParametersOrb_c_us_nav,
        _GANSS_KeplerianParametersOrb_c_rc_nav,
        _GANSS_KeplerianParametersOrb_c_ic_nav,
        _GANSS_KeplerianParametersOrb_c_uc_nav,
        ____GANSS_KeplerianParametersOrb_ie_Extensions__item__id_tab,
        ___GANSS_KeplerianParametersOrb_ie_Extensions__item__id,
        ____GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality_tab,
        ___GANSS_KeplerianParametersOrb_ie_Extensions__item__criticality,
        ____GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue_tab,
        ___GANSS_KeplerianParametersOrb_ie_Extensions__item__extensionValue,
        __GANSS_KeplerianParametersOrb_ie_Extensions__item_,
        _GANSS_KeplerianParametersOrb_ie_Extensions,
        GANSS_KeplerianParametersOrb,
        GANSS_KeplerianParametersOrb_ExtIEs,
        _GANSS_MeasurementParameters__item_,
        GANSS_MeasurementParameters,
        _GANSS_MeasurementParametersItem_satId,
        _GANSS_MeasurementParametersItem_cToNzero,
        _GANSS_MeasurementParametersItem_multipathIndicator,
        _GANSS_MeasurementParametersItem_carrierQualityIndication,
        _GANSS_MeasurementParametersItem_ganssCodePhase,
        _GANSS_MeasurementParametersItem_ganssIntegerCodePhase,
        _GANSS_MeasurementParametersItem_codePhaseRmsError,
        _GANSS_MeasurementParametersItem_doppler,
        _GANSS_MeasurementParametersItem_adr,
        ____GANSS_MeasurementParametersItem_ie_Extensions__item__id_tab,
        _____GANSS_MeasurementParametersItem_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_MeasurementParametersItem_ie_Extensions__item__id,
        ___GANSS_MeasurementParametersItem_ie_Extensions__item__criticality,
        ___GANSS_MeasurementParametersItem_ie_Extensions__item__extensionValue,
        __GANSS_MeasurementParametersItem_ie_Extensions__item_,
        _GANSS_MeasurementParametersItem_ie_Extensions,
        GANSS_MeasurementParametersItem,
        GANSS_MeasurementParametersItem_ExtIEs,
        _GANSS_MeasurementParametersItem_ExtIEs_val_Extension_0,
        _GanssIntegerCodePhaseExt_ganssIntegerCodePhase_ext,
        ____GanssIntegerCodePhaseExt_ie_Extensions__item__id_tab,
        ___GanssIntegerCodePhaseExt_ie_Extensions__item__id,
        ____GanssIntegerCodePhaseExt_ie_Extensions__item__criticality_tab,
        ___GanssIntegerCodePhaseExt_ie_Extensions__item__criticality,
        ____GanssIntegerCodePhaseExt_ie_Extensions__item__extensionValue_tab,
        ___GanssIntegerCodePhaseExt_ie_Extensions__item__extensionValue,
        __GanssIntegerCodePhaseExt_ie_Extensions__item_,
        _GanssIntegerCodePhaseExt_ie_Extensions,
        GanssIntegerCodePhaseExt,
        GanssIntegerCodePhaseExt_ExtIEs,
        _GANSS_MeasuredResultsList__item_,
        GANSS_MeasuredResultsList,
        __GANSS_MeasuredResults_referenceTime_utranReferenceTime,
        __GANSS_MeasuredResults_referenceTime_ganssReferenceTimeOnly,
        _GANSS_MeasuredResults_referenceTime,
        _GANSS_MeasuredResults_ganssGenericMeasurementInfo,
        ____GANSS_MeasuredResults_ie_Extensions__item__id_tab,
        ___GANSS_MeasuredResults_ie_Extensions__item__id,
        ____GANSS_MeasuredResults_ie_Extensions__item__criticality_tab,
        ___GANSS_MeasuredResults_ie_Extensions__item__criticality,
        ____GANSS_MeasuredResults_ie_Extensions__item__extensionValue_tab,
        ___GANSS_MeasuredResults_ie_Extensions__item__extensionValue,
        __GANSS_MeasuredResults_ie_Extensions__item_,
        _GANSS_MeasuredResults_ie_Extensions,
        GANSS_MeasuredResults,
        GANSS_MeasuredResults_ExtIEs,
        _GANSS_Navigation_Model_non_broadcastIndication,
        _GANSS_Navigation_Model_ganssSatInfoNav,
        ____GANSS_Navigation_Model_ie_Extensions__item__id_tab,
        ___GANSS_Navigation_Model_ie_Extensions__item__id,
        ____GANSS_Navigation_Model_ie_Extensions__item__criticality_tab,
        ___GANSS_Navigation_Model_ie_Extensions__item__criticality,
        ____GANSS_Navigation_Model_ie_Extensions__item__extensionValue_tab,
        ___GANSS_Navigation_Model_ie_Extensions__item__extensionValue,
        __GANSS_Navigation_Model_ie_Extensions__item_,
        _GANSS_Navigation_Model_ie_Extensions,
        GANSS_Navigation_Model,
        GANSS_Navigation_Model_ExtIEs,
        _GANSS_Orbit_Model_gANSS_keplerianParameters,
        GANSS_Orbit_Model,
        _GANSS_Real_Time_Integrity__item_,
        GANSS_Real_Time_Integrity,
        _GANSS_RealTimeInformationItem_bad_ganss_satId,
        _GANSS_RealTimeInformationItem_bad_ganss_signalId,
        ____GANSS_RealTimeInformationItem_ie_Extensions__item__id_tab,
        ___GANSS_RealTimeInformationItem_ie_Extensions__item__id,
        ____GANSS_RealTimeInformationItem_ie_Extensions__item__criticality_tab,
        ___GANSS_RealTimeInformationItem_ie_Extensions__item__criticality,
        ____GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_RealTimeInformationItem_ie_Extensions__item__extensionValue,
        __GANSS_RealTimeInformationItem_ie_Extensions__item_,
        _GANSS_RealTimeInformationItem_ie_Extensions,
        GANSS_RealTimeInformationItem,
        GANSS_RealTimeInformationItem_ExtIEs,
        _GANSS_Reference_Location_ue_PositionEstimate,
        ____GANSS_Reference_Location_iE_Extensions__item__id_tab,
        ___GANSS_Reference_Location_iE_Extensions__item__id,
        ____GANSS_Reference_Location_iE_Extensions__item__criticality_tab,
        ___GANSS_Reference_Location_iE_Extensions__item__criticality,
        ____GANSS_Reference_Location_iE_Extensions__item__extensionValue_tab,
        ___GANSS_Reference_Location_iE_Extensions__item__extensionValue,
        __GANSS_Reference_Location_iE_Extensions__item_,
        _GANSS_Reference_Location_iE_Extensions,
        GANSS_Reference_Location,
        GANSS_Reference_Location_ExtIEs,
        _GANSS_ReferenceMeasurementInfo_ganssSignalId,
        _GANSS_ReferenceMeasurementInfo_satelliteInformation,
        ____GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id_tab,
        _____GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__id,
        ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__criticality,
        ___GANSS_ReferenceMeasurementInfo_ie_Extensions__item__extensionValue,
        __GANSS_ReferenceMeasurementInfo_ie_Extensions__item_,
        _GANSS_ReferenceMeasurementInfo_ie_Extensions,
        GANSS_ReferenceMeasurementInfo,
        GANSS_ReferenceMeasurementInfo_ExtIEs,
        _GANSS_ReferenceMeasurementInfo_ExtIEs_val_Extension_0,
        _GANSS_Reference_Time_ganssDay,
        _GANSS_Reference_Time_ganssTod,
        _GANSS_Reference_Time_ganssTodUncertainty,
        _GANSS_Reference_Time_ganssTimeId,
        _GANSS_Reference_Time_utran_ganssreferenceTime,
        _GANSS_Reference_Time_tutran_ganss_driftRate,
        ____GANSS_Reference_Time_ie_Extensions__item__id_tab,
        _____GANSS_Reference_Time_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_Reference_Time_ie_Extensions__item__id,
        ___GANSS_Reference_Time_ie_Extensions__item__criticality,
        ___GANSS_Reference_Time_ie_Extensions__item__extensionValue,
        __GANSS_Reference_Time_ie_Extensions__item_,
        _GANSS_Reference_Time_ie_Extensions,
        GANSS_Reference_Time,
        GANSS_Reference_Time_ExtIEs,
        _GANSS_Reference_Time_ExtIEs_val_Extension_0,
        GANSS_Day_Cycle,
        _GANSS_ReferenceTimeOnly_gANSS_tod,
        _GANSS_ReferenceTimeOnly_gANSS_timeId,
        _GANSS_ReferenceTimeOnly_gANSS_TimeUncertainty,
        ____GANSS_ReferenceTimeOnly_ie_Extensions__item__id_tab,
        ___GANSS_ReferenceTimeOnly_ie_Extensions__item__id,
        ____GANSS_ReferenceTimeOnly_ie_Extensions__item__criticality_tab,
        ___GANSS_ReferenceTimeOnly_ie_Extensions__item__criticality,
        ____GANSS_ReferenceTimeOnly_ie_Extensions__item__extensionValue_tab,
        ___GANSS_ReferenceTimeOnly_ie_Extensions__item__extensionValue,
        __GANSS_ReferenceTimeOnly_ie_Extensions__item_,
        _GANSS_ReferenceTimeOnly_ie_Extensions,
        GANSS_ReferenceTimeOnly,
        GANSS_ReferenceTimeOnly_ExtIEs,
        _GANSS_SatelliteClockModelItem_t_oc,
        _GANSS_SatelliteClockModelItem_a_i2,
        _GANSS_SatelliteClockModelItem_a_i1,
        _GANSS_SatelliteClockModelItem_a_i0,
        _GANSS_SatelliteClockModelItem_t_gd,
        _GANSS_SatelliteClockModelItem_sisa,
        _GANSS_SatelliteClockModelItem_model_id,
        ____GANSS_SatelliteClockModelItem_ie_Extensions__item__id_tab,
        ___GANSS_SatelliteClockModelItem_ie_Extensions__item__id,
        ____GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality_tab,
        ___GANSS_SatelliteClockModelItem_ie_Extensions__item__criticality,
        ____GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SatelliteClockModelItem_ie_Extensions__item__extensionValue,
        __GANSS_SatelliteClockModelItem_ie_Extensions__item_,
        _GANSS_SatelliteClockModelItem_ie_Extensions,
        GANSS_SatelliteClockModelItem,
        GANSS_SatelliteClockModelItem_ExtIEs,
        _GANSS_SatelliteInformation__item_,
        GANSS_SatelliteInformation,
        _GANSS_SatelliteInformationItem_ganssSatId,
        _GANSS_SatelliteInformationItem_dopplerZeroOrder,
        _GANSS_SatelliteInformationItem_extraDoppler,
        _GANSS_SatelliteInformationItem_codePhase,
        _GANSS_SatelliteInformationItem_integerCodePhase,
        _GANSS_SatelliteInformationItem_codePhaseSearchWindow,
        _GANSS_SatelliteInformationItem_azimuthAndElevation,
        ____GANSS_SatelliteInformationItem_ie_Extensions__item__id_tab,
        _____GANSS_SatelliteInformationItem_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_SatelliteInformationItem_ie_Extensions__item__id,
        ___GANSS_SatelliteInformationItem_ie_Extensions__item__criticality,
        ___GANSS_SatelliteInformationItem_ie_Extensions__item__extensionValue,
        __GANSS_SatelliteInformationItem_ie_Extensions__item_,
        _GANSS_SatelliteInformationItem_ie_Extensions,
        GANSS_SatelliteInformationItem,
        GANSS_SatelliteInformationItem_ExtIEs,
        _GANSS_SatelliteInformationItem_ExtIEs_val_Extension_0,
        _GANSS_SatelliteInformationKP__item_,
        GANSS_SatelliteInformationKP,
        _GANSS_SatelliteInformationKPItem_satId,
        _GANSS_SatelliteInformationKPItem_ganss_e_alm,
        _GANSS_SatelliteInformationKPItem_ganss_delta_I_alm,
        _GANSS_SatelliteInformationKPItem_ganss_omegadot_alm,
        _GANSS_SatelliteInformationKPItem_ganss_svStatusINAV_alm,
        _GANSS_SatelliteInformationKPItem_ganss_svStatusFNAV_alm,
        _GANSS_SatelliteInformationKPItem_ganss_delta_a_sqrt_alm,
        _GANSS_SatelliteInformationKPItem_ganss_omegazero_alm,
        _GANSS_SatelliteInformationKPItem_ganss_m_zero_alm,
        _GANSS_SatelliteInformationKPItem_ganss_omega_alm,
        _GANSS_SatelliteInformationKPItem_ganss_af_zero_alm,
        _GANSS_SatelliteInformationKPItem_ganss_af_one_alm,
        ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__id_tab,
        ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__id,
        ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality_tab,
        ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__criticality,
        ____GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SatelliteInformationKPItem_ie_Extensions__item__extensionValue,
        __GANSS_SatelliteInformationKPItem_ie_Extensions__item_,
        _GANSS_SatelliteInformationKPItem_ie_Extensions,
        GANSS_SatelliteInformationKPItem,
        GANSS_SatelliteInformationKPItem_ExtIEs,
        _GANSS_SAT_Info_Almanac_GLOkpList__item_,
        GANSS_SAT_Info_Almanac_GLOkpList,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmNA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmnA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmHA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmLambdaA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTlambdaA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaIA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAkmDeltaTA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmDeltaTdotA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmEpsilonA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmOmegaA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmTauA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmCA,
        _GANSS_SAT_Info_Almanac_GLOkp_gloAlmMA,
        ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_GLOkp_ie_Extensions,
        GANSS_SAT_Info_Almanac_GLOkp,
        GANSS_SAT_Info_Almanac_GLOkp_ExtIEs,
        _GANSS_SAT_Info_Almanac_MIDIkpList__item_,
        GANSS_SAT_Info_Almanac_MIDIkpList,
        _GANSS_SAT_Info_Almanac_MIDIkp_svID,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmE,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmDeltaI,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmegaDot,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmSqrtA,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega0,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmOmega,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmMo,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf0,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmaf1,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL1Health,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL2Health,
        _GANSS_SAT_Info_Almanac_MIDIkp_midiAlmL5Health,
        ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_MIDIkp_ie_Extensions,
        GANSS_SAT_Info_Almanac_MIDIkp,
        GANSS_SAT_Info_Almanac_MIDIkp_ExtIEs,
        _GANSS_SAT_Info_Almanac_NAVkpList__item_,
        GANSS_SAT_Info_Almanac_NAVkpList,
        _GANSS_SAT_Info_Almanac_NAVkp_svID,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmE,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmDeltaI,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGADOT,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmSVHealth,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmSqrtA,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmOMEGAo,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmOmega,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmMo,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf0,
        _GANSS_SAT_Info_Almanac_NAVkp_navAlmaf1,
        ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_NAVkp_ie_Extensions,
        GANSS_SAT_Info_Almanac_NAVkp,
        GANSS_SAT_Info_Almanac_NAVkp_ExtIEs,
        _GANSS_SAT_Info_Almanac_REDkpList__item_,
        GANSS_SAT_Info_Almanac_REDkpList,
        _GANSS_SAT_Info_Almanac_REDkp_svID,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmDeltaA,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmOmega0,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmPhi0,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmL1Health,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmL2Health,
        _GANSS_SAT_Info_Almanac_REDkp_redAlmL5Health,
        ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_REDkp_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_REDkp_ie_Extensions,
        GANSS_SAT_Info_Almanac_REDkp,
        GANSS_SAT_Info_Almanac_REDkp_ExtIEs,
        _GANSS_SAT_Info_Almanac_SBASecefList__item_,
        GANSS_SAT_Info_Almanac_SBASecefList,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmDataID,
        _GANSS_SAT_Info_Almanac_SBASecef_svID,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmHealth,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXg,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYg,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZg,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmXgdot,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmYgDot,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmZgDot,
        _GANSS_SAT_Info_Almanac_SBASecef_sbasAlmTo,
        ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id_tab,
        ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__id,
        ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality_tab,
        ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__criticality,
        ____GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item__extensionValue,
        __GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions__item_,
        _GANSS_SAT_Info_Almanac_SBASecef_ie_Extensions,
        GANSS_SAT_Info_Almanac_SBASecef,
        GANSS_SAT_Info_Almanac_SBASecef_ExtIEs,
        __Ganss_Sat_Info_AddNavList__item__satId,
        __Ganss_Sat_Info_AddNavList__item__svHealth,
        __Ganss_Sat_Info_AddNavList__item__iod,
        __Ganss_Sat_Info_AddNavList__item__ganssAddClockModels,
        __Ganss_Sat_Info_AddNavList__item__ganssAddOrbitModels,
        _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id_tab,
        ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__id,
        _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality_tab,
        ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__criticality,
        _____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue_tab,
        ____Ganss_Sat_Info_AddNavList__item__ie_Extensions__item__extensionValue,
        ___Ganss_Sat_Info_AddNavList__item__ie_Extensions__item_,
        __Ganss_Sat_Info_AddNavList__item__ie_Extensions,
        _Ganss_Sat_Info_AddNavList__item_,
        Ganss_Sat_Info_AddNavList,
        Ganss_Sat_Info_AddNavList_ExtIEs,
        __GANSS_Sat_Info_Nav__item__satId,
        __GANSS_Sat_Info_Nav__item__svHealth,
        __GANSS_Sat_Info_Nav__item__iod,
        __GANSS_Sat_Info_Nav__item__ganssClockModel,
        __GANSS_Sat_Info_Nav__item__ganssOrbitModel,
        _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id_tab,
        ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__id,
        _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality_tab,
        ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__criticality,
        _____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue_tab,
        ____GANSS_Sat_Info_Nav__item__ie_Extensions__item__extensionValue,
        ___GANSS_Sat_Info_Nav__item__ie_Extensions__item_,
        __GANSS_Sat_Info_Nav__item__ie_Extensions,
        _GANSS_Sat_Info_Nav__item_,
        GANSS_Sat_Info_Nav,
        GANSS_Sat_Info_Nav_ExtIEs,
        _GANSS_SignalID_ganssSignalID,
        ____GANSS_SignalID_ie_Extensions__item__id_tab,
        ___GANSS_SignalID_ie_Extensions__item__id,
        ____GANSS_SignalID_ie_Extensions__item__criticality_tab,
        ___GANSS_SignalID_ie_Extensions__item__criticality,
        ____GANSS_SignalID_ie_Extensions__item__extensionValue_tab,
        ___GANSS_SignalID_ie_Extensions__item__extensionValue,
        __GANSS_SignalID_ie_Extensions__item_,
        _GANSS_SignalID_ie_Extensions,
        GANSS_SignalID,
        GANSS_SignalID_ExtIEs,
        GANSS_StatusHealth,
        _GANSS_Time_Model_ganss_time_model_refTime,
        _GANSS_Time_Model_ganss_t_a0,
        _GANSS_Time_Model_ganss_t_a1,
        _GANSS_Time_Model_ganss_t_a2,
        _GANSS_Time_Model_gnss_to_id,
        _GANSS_Time_Model_ganss_wk_number,
        ____GANSS_Time_Model_ie_Extensions__item__id_tab,
        _____GANSS_Time_Model_ie_Extensions__item__id_tab_val_Extension_0,
        ___GANSS_Time_Model_ie_Extensions__item__id,
        ___GANSS_Time_Model_ie_Extensions__item__criticality,
        ___GANSS_Time_Model_ie_Extensions__item__extensionValue,
        __GANSS_Time_Model_ie_Extensions__item_,
        _GANSS_Time_Model_ie_Extensions,
        GANSS_Time_Model,
        GANSS_Time_Model_ExtIEs,
        _GANSS_Time_Model_ExtIEs_val_Extension_0,
        GANSS_Delta_T,
        GANSS_UTRAN_TimeRelationshipUncertainty,
        _GANSS_UTRAN_TRU_gANSS_UTRAN_TimeRelationshipUncertainty,
        _GANSS_UTRAN_TRU_ganssId,
        ____GANSS_UTRAN_TRU_ie_Extensions__item__id_tab,
        ___GANSS_UTRAN_TRU_ie_Extensions__item__id,
        ____GANSS_UTRAN_TRU_ie_Extensions__item__criticality_tab,
        ___GANSS_UTRAN_TRU_ie_Extensions__item__criticality,
        ____GANSS_UTRAN_TRU_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTRAN_TRU_ie_Extensions__item__extensionValue,
        __GANSS_UTRAN_TRU_ie_Extensions__item_,
        _GANSS_UTRAN_TRU_ie_Extensions,
        GANSS_UTRAN_TRU,
        GANSS_UTRAN_TRU_ExtIEs,
        _GANSS_UTC_Model_a_one_utc,
        _GANSS_UTC_Model_a_zero_utc,
        _GANSS_UTC_Model_t_ot_utc,
        _GANSS_UTC_Model_w_n_t_utc,
        _GANSS_UTC_Model_delta_t_ls_utc,
        _GANSS_UTC_Model_w_n_lsf_utc,
        _GANSS_UTC_Model_dn_utc,
        _GANSS_UTC_Model_delta_t_lsf_utc,
        ____GANSS_UTC_Model_ie_Extensions__item__id_tab,
        ___GANSS_UTC_Model_ie_Extensions__item__id,
        ____GANSS_UTC_Model_ie_Extensions__item__criticality_tab,
        ___GANSS_UTC_Model_ie_Extensions__item__criticality,
        ____GANSS_UTC_Model_ie_Extensions__item__extensionValue_tab,
        ___GANSS_UTC_Model_ie_Extensions__item__extensionValue,
        __GANSS_UTC_Model_ie_Extensions__item_,
        _GANSS_UTC_Model_ie_Extensions,
        GANSS_UTC_Model,
        GANSS_UTC_Model_ExtIEs,
        TUTRAN_GANSS_DriftRate,
        _GLONASSclockModel_gloTau,
        _GLONASSclockModel_gloGamma,
        _GLONASSclockModel_gloDeltaTau,
        ____GLONASSclockModel_ie_Extensions__item__id_tab,
        ___GLONASSclockModel_ie_Extensions__item__id,
        ____GLONASSclockModel_ie_Extensions__item__criticality_tab,
        ___GLONASSclockModel_ie_Extensions__item__criticality,
        ____GLONASSclockModel_ie_Extensions__item__extensionValue_tab,
        ___GLONASSclockModel_ie_Extensions__item__extensionValue,
        __GLONASSclockModel_ie_Extensions__item_,
        _GLONASSclockModel_ie_Extensions,
        GLONASSclockModel,
        GLONASSclockModel_ExtIEs,
        _NAVclockModel_navToc,
        _NAVclockModel_navaf2,
        _NAVclockModel_navaf1,
        _NAVclockModel_navaf0,
        _NAVclockModel_navTgd,
        ____NAVclockModel_ie_Extensions__item__id_tab,
        ___NAVclockModel_ie_Extensions__item__id,
        ____NAVclockModel_ie_Extensions__item__criticality_tab,
        ___NAVclockModel_ie_Extensions__item__criticality,
        ____NAVclockModel_ie_Extensions__item__extensionValue_tab,
        ___NAVclockModel_ie_Extensions__item__extensionValue,
        __NAVclockModel_ie_Extensions__item_,
        _NAVclockModel_ie_Extensions,
        NAVclockModel,
        NAVclockModel_ExtIEs,
        _NavModel_CNAVKeplerianSet_cnavTop,
        _NavModel_CNAVKeplerianSet_cnavURAindex,
        _NavModel_CNAVKeplerianSet_cnavDeltaA,
        _NavModel_CNAVKeplerianSet_cnavAdot,
        _NavModel_CNAVKeplerianSet_cnavDeltaNo,
        _NavModel_CNAVKeplerianSet_cnavDeltaNoDot,
        _NavModel_CNAVKeplerianSet_cnavMo,
        _NavModel_CNAVKeplerianSet_cnavE,
        _NavModel_CNAVKeplerianSet_cnavOmega,
        _NavModel_CNAVKeplerianSet_cnavOMEGA0,
        _NavModel_CNAVKeplerianSet_cnavDeltaOmegaDot,
        _NavModel_CNAVKeplerianSet_cnavIo,
        _NavModel_CNAVKeplerianSet_cnavIoDot,
        _NavModel_CNAVKeplerianSet_cnavCis,
        _NavModel_CNAVKeplerianSet_cnavCic,
        _NavModel_CNAVKeplerianSet_cnavCrs,
        _NavModel_CNAVKeplerianSet_cnavCrc,
        _NavModel_CNAVKeplerianSet_cnavCus,
        _NavModel_CNAVKeplerianSet_cnavCuc,
        ____NavModel_CNAVKeplerianSet_ie_Extensions__item__id_tab,
        ___NavModel_CNAVKeplerianSet_ie_Extensions__item__id,
        ____NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality_tab,
        ___NavModel_CNAVKeplerianSet_ie_Extensions__item__criticality,
        ____NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___NavModel_CNAVKeplerianSet_ie_Extensions__item__extensionValue,
        __NavModel_CNAVKeplerianSet_ie_Extensions__item_,
        _NavModel_CNAVKeplerianSet_ie_Extensions,
        NavModel_CNAVKeplerianSet,
        NavModel_CNAVKeplerianSet_ExtIEs,
        _NavModel_GLONASSecef_gloEn,
        _NavModel_GLONASSecef_gloP1,
        _NavModel_GLONASSecef_gloP2,
        _NavModel_GLONASSecef_gloM,
        _NavModel_GLONASSecef_gloX,
        _NavModel_GLONASSecef_gloXdot,
        _NavModel_GLONASSecef_gloXdotdot,
        _NavModel_GLONASSecef_gloY,
        _NavModel_GLONASSecef_gloYdot,
        _NavModel_GLONASSecef_gloYdotdot,
        _NavModel_GLONASSecef_gloZ,
        _NavModel_GLONASSecef_gloZdot,
        _NavModel_GLONASSecef_gloZdotdot,
        ____NavModel_GLONASSecef_ie_Extensions__item__id_tab,
        ___NavModel_GLONASSecef_ie_Extensions__item__id,
        ____NavModel_GLONASSecef_ie_Extensions__item__criticality_tab,
        ___NavModel_GLONASSecef_ie_Extensions__item__criticality,
        ____NavModel_GLONASSecef_ie_Extensions__item__extensionValue_tab,
        ___NavModel_GLONASSecef_ie_Extensions__item__extensionValue,
        __NavModel_GLONASSecef_ie_Extensions__item_,
        _NavModel_GLONASSecef_ie_Extensions,
        NavModel_GLONASSecef,
        NavModel_GLONASSecef_ExtIEs,
        _NavModel_NAVKeplerianSet_navURA,
        _NavModel_NAVKeplerianSet_navFitFlag,
        _NavModel_NAVKeplerianSet_navToe,
        _NavModel_NAVKeplerianSet_navOmega,
        _NavModel_NAVKeplerianSet_navDeltaN,
        _NavModel_NAVKeplerianSet_navM0,
        _NavModel_NAVKeplerianSet_navOmegaADot,
        _NavModel_NAVKeplerianSet_navE,
        _NavModel_NAVKeplerianSet_navIDot,
        _NavModel_NAVKeplerianSet_navAPowerHalf,
        _NavModel_NAVKeplerianSet_navI0,
        _NavModel_NAVKeplerianSet_navOmegaA0,
        _NavModel_NAVKeplerianSet_navCrs,
        _NavModel_NAVKeplerianSet_navCis,
        _NavModel_NAVKeplerianSet_navCus,
        _NavModel_NAVKeplerianSet_navCrc,
        _NavModel_NAVKeplerianSet_navCic,
        _NavModel_NAVKeplerianSet_navCuc,
        ____NavModel_NAVKeplerianSet_ie_Extensions__item__id_tab,
        ___NavModel_NAVKeplerianSet_ie_Extensions__item__id,
        ____NavModel_NAVKeplerianSet_ie_Extensions__item__criticality_tab,
        ___NavModel_NAVKeplerianSet_ie_Extensions__item__criticality,
        ____NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___NavModel_NAVKeplerianSet_ie_Extensions__item__extensionValue,
        __NavModel_NAVKeplerianSet_ie_Extensions__item_,
        _NavModel_NAVKeplerianSet_ie_Extensions,
        NavModel_NAVKeplerianSet,
        NavModel_NAVKeplerianSet_ExtIEs,
        _NavModel_SBASecef_sbasTo,
        _NavModel_SBASecef_sbasAccuracy,
        _NavModel_SBASecef_sbasXg,
        _NavModel_SBASecef_sbasYg,
        _NavModel_SBASecef_sbasZg,
        _NavModel_SBASecef_sbasXgDot,
        _NavModel_SBASecef_sbasYgDot,
        _NavModel_SBASecef_sbasZgDot,
        _NavModel_SBASecef_sbasXgDotDot,
        _NavModel_SBASecef_sbagYgDotDot,
        _NavModel_SBASecef_sbasZgDotDot,
        ____NavModel_SBASecef_ie_Extensions__item__id_tab,
        ___NavModel_SBASecef_ie_Extensions__item__id,
        ____NavModel_SBASecef_ie_Extensions__item__criticality_tab,
        ___NavModel_SBASecef_ie_Extensions__item__criticality,
        ____NavModel_SBASecef_ie_Extensions__item__extensionValue_tab,
        ___NavModel_SBASecef_ie_Extensions__item__extensionValue,
        __NavModel_SBASecef_ie_Extensions__item_,
        _NavModel_SBASecef_ie_Extensions,
        NavModel_SBASecef,
        NavModel_SBASecef_ExtIEs,
        _NavModel_BDSKeplerianSet_uRAIndex_BDS,
        _NavModel_BDSKeplerianSet_tOA_BDS,
        _NavModel_BDSKeplerianSet_a1_2_BDS,
        _NavModel_BDSKeplerianSet_e_BDS,
        _NavModel_BDSKeplerianSet_oMG_BDS,
        _NavModel_BDSKeplerianSet_dLTn_BDS,
        _NavModel_BDSKeplerianSet_m0_BDS,
        _NavModel_BDSKeplerianSet_oMG0_BDS,
        _NavModel_BDSKeplerianSet_oMGdot_BDS,
        _NavModel_BDSKeplerianSet_i0_BDS,
        _NavModel_BDSKeplerianSet_iDOT_BDS,
        _NavModel_BDSKeplerianSet_cuc_BDS,
        _NavModel_BDSKeplerianSet_cus_BDS,
        _NavModel_BDSKeplerianSet_crc_BDS,
        _NavModel_BDSKeplerianSet_crs_BDS,
        _NavModel_BDSKeplerianSet_cic_BDS,
        _NavModel_BDSKeplerianSet_cis_BDS,
        _NavModel_BDSKeplerianSet_aODE_BDS,
        ____NavModel_BDSKeplerianSet_ie_Extensions__item__id_tab,
        ___NavModel_BDSKeplerianSet_ie_Extensions__item__id,
        ____NavModel_BDSKeplerianSet_ie_Extensions__item__criticality_tab,
        ___NavModel_BDSKeplerianSet_ie_Extensions__item__criticality,
        ____NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue_tab,
        ___NavModel_BDSKeplerianSet_ie_Extensions__item__extensionValue,
        __NavModel_BDSKeplerianSet_ie_Extensions__item_,
        _NavModel_BDSKeplerianSet_ie_Extensions,
        NavModel_BDSKeplerianSet,
        NavModel_BDSKeplerianSet_ExtIEs,
        _SBASclockModel_sbasTo,
        _SBASclockModel_sbasAgfo,
        _SBASclockModel_sbasAgf1,
        ____SBASclockModel_ie_Extensions__item__id_tab,
        ___SBASclockModel_ie_Extensions__item__id,
        ____SBASclockModel_ie_Extensions__item__criticality_tab,
        ___SBASclockModel_ie_Extensions__item__criticality,
        ____SBASclockModel_ie_Extensions__item__extensionValue_tab,
        ___SBASclockModel_ie_Extensions__item__extensionValue,
        __SBASclockModel_ie_Extensions__item_,
        _SBASclockModel_ie_Extensions,
        SBASclockModel,
        SBASclockModel_ExtIEs,
        _BDSClockModel_toc_BDS,
        _BDSClockModel_a0_BDS,
        _BDSClockModel_a1_BDS,
        _BDSClockModel_a2_BDS,
        _BDSClockModel_tGD1_BDS,
        _BDSClockModel_aODC_BDS,
        ____BDSClockModel_ie_Extensions__item__id_tab,
        ___BDSClockModel_ie_Extensions__item__id,
        ____BDSClockModel_ie_Extensions__item__criticality_tab,
        ___BDSClockModel_ie_Extensions__item__criticality,
        ____BDSClockModel_ie_Extensions__item__extensionValue_tab,
        ___BDSClockModel_ie_Extensions__item__extensionValue,
        __BDSClockModel_ie_Extensions__item_,
        _BDSClockModel_ie_Extensions,
        BDSClockModel,
        BDSClockModel_ExtIEs,
        _UTCmodelSet1_utcA0,
        _UTCmodelSet1_utcA1,
        _UTCmodelSet1_utcA2,
        _UTCmodelSet1_utcDeltaTls,
        _UTCmodelSet1_utcTot,
        _UTCmodelSet1_utcWNot,
        _UTCmodelSet1_utcWNlsf,
        _UTCmodelSet1_utcDN,
        _UTCmodelSet1_utcDeltaTlsf,
        ____UTCmodelSet1_ie_Extensions__item__id_tab,
        ___UTCmodelSet1_ie_Extensions__item__id,
        ____UTCmodelSet1_ie_Extensions__item__criticality_tab,
        ___UTCmodelSet1_ie_Extensions__item__criticality,
        ____UTCmodelSet1_ie_Extensions__item__extensionValue_tab,
        ___UTCmodelSet1_ie_Extensions__item__extensionValue,
        __UTCmodelSet1_ie_Extensions__item_,
        _UTCmodelSet1_ie_Extensions,
        UTCmodelSet1,
        UTCmodelSet1_ExtIEs,
        _UTCmodelSet2_nA,
        _UTCmodelSet2_tauC,
        _UTCmodelSet2_deltaUT1,
        _UTCmodelSet2_kp,
        ____UTCmodelSet2_ie_Extensions__item__id_tab,
        ___UTCmodelSet2_ie_Extensions__item__id,
        ____UTCmodelSet2_ie_Extensions__item__criticality_tab,
        ___UTCmodelSet2_ie_Extensions__item__criticality,
        ____UTCmodelSet2_ie_Extensions__item__extensionValue_tab,
        ___UTCmodelSet2_ie_Extensions__item__extensionValue,
        __UTCmodelSet2_ie_Extensions__item_,
        _UTCmodelSet2_ie_Extensions,
        UTCmodelSet2,
        UTCmodelSet2_ExtIEs,
        _UTCmodelSet3_utcA1wnt,
        _UTCmodelSet3_utcA0wnt,
        _UTCmodelSet3_utcTot,
        _UTCmodelSet3_utcWNt,
        _UTCmodelSet3_utcDeltaTls,
        _UTCmodelSet3_utcWNlsf,
        _UTCmodelSet3_utcDN,
        _UTCmodelSet3_utcDeltaTlsf,
        _UTCmodelSet3_utcStandardID,
        ____UTCmodelSet3_ie_Extensions__item__id_tab,
        ___UTCmodelSet3_ie_Extensions__item__id,
        ____UTCmodelSet3_ie_Extensions__item__criticality_tab,
        ___UTCmodelSet3_ie_Extensions__item__criticality,
        ____UTCmodelSet3_ie_Extensions__item__extensionValue_tab,
        ___UTCmodelSet3_ie_Extensions__item__extensionValue,
        __UTCmodelSet3_ie_Extensions__item_,
        _UTCmodelSet3_ie_Extensions,
        UTCmodelSet3,
        UTCmodelSet3_ExtIEs,
        _UTCmodelSet4_utca0_BDS,
        _UTCmodelSet4_utca1_BDS,
        _UTCmodelSet4_utcDeltatLS_BDS,
        _UTCmodelSet4_utcWNt,
        _UTCmodelSet4_utcDeltaTls,
        _UTCmodelSet4_utcWNlsf_BDS,
        _UTCmodelSet4_utcDN_BDS,
        _UTCmodelSet4_utcDeltaTlsf_BDS,
        ____UTCmodelSet4_ie_Extensions__item__id_tab,
        ___UTCmodelSet4_ie_Extensions__item__id,
        ____UTCmodelSet4_ie_Extensions__item__criticality_tab,
        ___UTCmodelSet4_ie_Extensions__item__criticality,
        ____UTCmodelSet4_ie_Extensions__item__extensionValue_tab,
        ___UTCmodelSet4_ie_Extensions__item__extensionValue,
        __UTCmodelSet4_ie_Extensions__item_,
        _UTCmodelSet4_ie_Extensions,
        UTCmodelSet4,
        UTCmodelSet4_ExtIEs,
        _UTRAN_GANSSReferenceTimeDL_utran_GANSSTimingOfCellFrames,
        _UTRAN_GANSSReferenceTimeDL_uC_ID,
        _UTRAN_GANSSReferenceTimeDL_referenceSfn,
        ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__id_tab,
        ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__id,
        ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__criticality_tab,
        ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__criticality,
        ____UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__extensionValue_tab,
        ___UTRAN_GANSSReferenceTimeDL_ie_Extensions__item__extensionValue,
        __UTRAN_GANSSReferenceTimeDL_ie_Extensions__item_,
        _UTRAN_GANSSReferenceTimeDL_ie_Extensions,
        UTRAN_GANSSReferenceTimeDL,
        UTRAN_GANSSReferenceTimeDL_ExtIEs,
        _UTRAN_GANSSReferenceTimeUL_ue_GANSSTimingOfCellFrames,
        _UTRAN_GANSSReferenceTimeUL_gANSS_TimeId,
        _UTRAN_GANSSReferenceTimeUL_gANSS_TimeUncertainty,
        _UTRAN_GANSSReferenceTimeUL_uC_ID,
        _UTRAN_GANSSReferenceTimeUL_referenceSfn,
        ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__id_tab,
        ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__id,
        ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__criticality_tab,
        ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__criticality,
        ____UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__extensionValue_tab,
        ___UTRAN_GANSSReferenceTimeUL_ie_Extensions__item__extensionValue,
        __UTRAN_GANSSReferenceTimeUL_ie_Extensions__item_,
        _UTRAN_GANSSReferenceTimeUL_ie_Extensions,
        UTRAN_GANSSReferenceTimeUL,
        UTRAN_GANSSReferenceTimeUL_ExtIEs,
        _GPS_AlmanacAndSatelliteHealth_wn_a,
        _GPS_AlmanacAndSatelliteHealth_almanacSatInfoList,
        _GPS_AlmanacAndSatelliteHealth_svGlobalHealth,
        ____GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id_tab,
        _____GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id_tab_val_Extension_0,
        ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__id,
        ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__criticality,
        ___GPS_AlmanacAndSatelliteHealth_iE_Extensions__item__extensionValue,
        __GPS_AlmanacAndSatelliteHealth_iE_Extensions__item_,
        _GPS_AlmanacAndSatelliteHealth_iE_Extensions,
        GPS_AlmanacAndSatelliteHealth,
        GPS_AlmanacAndSatelliteHealth_ExtIEs,
        _GPS_AlmanacAndSatelliteHealth_ExtIEs_val_Extension_0,
        CompleteAlmanacProvided,
        _AlmanacSatInfoList__item_,
        AlmanacSatInfoList,
        _AlmanacSatInfo_dataID,
        _AlmanacSatInfo_satID,
        _AlmanacSatInfo_e,
        _AlmanacSatInfo_t_oa,
        _AlmanacSatInfo_deltaI,
        _AlmanacSatInfo_omegaDot,
        _AlmanacSatInfo_satHealth,
        _AlmanacSatInfo_a_Sqrt,
        _AlmanacSatInfo_omega0,
        _AlmanacSatInfo_m0,
        _AlmanacSatInfo_omega,
        _AlmanacSatInfo_af0,
        _AlmanacSatInfo_af1,
        ____AlmanacSatInfo_iE_Extensions__item__id_tab,
        ___AlmanacSatInfo_iE_Extensions__item__id,
        ____AlmanacSatInfo_iE_Extensions__item__criticality_tab,
        ___AlmanacSatInfo_iE_Extensions__item__criticality,
        ____AlmanacSatInfo_iE_Extensions__item__extensionValue_tab,
        ___AlmanacSatInfo_iE_Extensions__item__extensionValue,
        __AlmanacSatInfo_iE_Extensions__item_,
        _AlmanacSatInfo_iE_Extensions,
        AlmanacSatInfo,
        AlmanacSatInfo_ExtIEs,
        _GPS_ClockAndEphemerisParameters_codeOnL2,
        _GPS_ClockAndEphemerisParameters_uraIndex,
        _GPS_ClockAndEphemerisParameters_satHealth,
        _GPS_ClockAndEphemerisParameters_iodc,
        _GPS_ClockAndEphemerisParameters_l2Pflag,
        _GPS_ClockAndEphemerisParameters_sf1Revd,
        _GPS_ClockAndEphemerisParameters_t_GD,
        _GPS_ClockAndEphemerisParameters_t_oc,
        _GPS_ClockAndEphemerisParameters_af2,
        _GPS_ClockAndEphemerisParameters_af1,
        _GPS_ClockAndEphemerisParameters_af0,
        _GPS_ClockAndEphemerisParameters_c_rs,
        _GPS_ClockAndEphemerisParameters_delta_n,
        _GPS_ClockAndEphemerisParameters_m0,
        _GPS_ClockAndEphemerisParameters_c_uc,
        _GPS_ClockAndEphemerisParameters_e,
        _GPS_ClockAndEphemerisParameters_c_us,
        _GPS_ClockAndEphemerisParameters_a_Sqrt,
        _GPS_ClockAndEphemerisParameters_t_oe,
        _GPS_ClockAndEphemerisParameters_fitInterval,
        _GPS_ClockAndEphemerisParameters_aodo,
        _GPS_ClockAndEphemerisParameters_c_ic,
        _GPS_ClockAndEphemerisParameters_omega0,
        _GPS_ClockAndEphemerisParameters_c_is,
        _GPS_ClockAndEphemerisParameters_i0,
        _GPS_ClockAndEphemerisParameters_c_rc,
        _GPS_ClockAndEphemerisParameters_omega,
        _GPS_ClockAndEphemerisParameters_omegaDot,
        _GPS_ClockAndEphemerisParameters_iDot,
        ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__id_tab,
        ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__id,
        ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__criticality_tab,
        ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__criticality,
        ____GPS_ClockAndEphemerisParameters_iE_Extensions__item__extensionValue_tab,
        ___GPS_ClockAndEphemerisParameters_iE_Extensions__item__extensionValue,
        __GPS_ClockAndEphemerisParameters_iE_Extensions__item_,
        _GPS_ClockAndEphemerisParameters_iE_Extensions,
        GPS_ClockAndEphemerisParameters,
        GPS_ClockAndEphemerisParameters_ExtIEs,
        _SubFrame1Reserved_reserved1,
        _SubFrame1Reserved_reserved2,
        _SubFrame1Reserved_reserved3,
        _SubFrame1Reserved_reserved4,
        SubFrame1Reserved,
        _GPS_Ionospheric_Model_alfa0,
        _GPS_Ionospheric_Model_alfa1,
        _GPS_Ionospheric_Model_alfa2,
        _GPS_Ionospheric_Model_alfa3,
        _GPS_Ionospheric_Model_beta0,
        _GPS_Ionospheric_Model_beta1,
        _GPS_Ionospheric_Model_beta2,
        _GPS_Ionospheric_Model_beta3,
        ____GPS_Ionospheric_Model_iE_Extensions__item__id_tab,
        ___GPS_Ionospheric_Model_iE_Extensions__item__id,
        ____GPS_Ionospheric_Model_iE_Extensions__item__criticality_tab,
        ___GPS_Ionospheric_Model_iE_Extensions__item__criticality,
        ____GPS_Ionospheric_Model_iE_Extensions__item__extensionValue_tab,
        ___GPS_Ionospheric_Model_iE_Extensions__item__extensionValue,
        __GPS_Ionospheric_Model_iE_Extensions__item_,
        _GPS_Ionospheric_Model_iE_Extensions,
        GPS_Ionospheric_Model,
        GPS_Ionospheric_Model_ExtIEs,
        _MeasuredResultsList__item_,
        MeasuredResultsList,
        _GPS_MeasuredResults_gps_TOW_1msec,
        _GPS_MeasuredResults_gps_MeasurementParamList,
        ____GPS_MeasuredResults_iE_Extensions__item__id_tab,
        _____GPS_MeasuredResults_iE_Extensions__item__id_tab_val_Extension_0,
        _____GPS_MeasuredResults_iE_Extensions__item__id_tab_val_Extension_1,
        ___GPS_MeasuredResults_iE_Extensions__item__id,
        ___GPS_MeasuredResults_iE_Extensions__item__criticality,
        ___GPS_MeasuredResults_iE_Extensions__item__extensionValue,
        __GPS_MeasuredResults_iE_Extensions__item_,
        _GPS_MeasuredResults_iE_Extensions,
        GPS_MeasuredResults,
        GPS_MeasuredResults_ExtIEs,
        _GPS_MeasuredResults_ExtIEs_val_Extension_0,
        _GPS_MeasuredResults_ExtIEs_val_Extension_1,
        _GPS_MeasurementParamList__item_,
        GPS_MeasurementParamList,
        _GPS_MeasurementParam_satelliteID,
        _GPS_MeasurementParam_c_N0,
        _GPS_MeasurementParam_doppler,
        _GPS_MeasurementParam_wholeGPS_Chips,
        _GPS_MeasurementParam_fractionalGPS_Chips,
        _GPS_MeasurementParam_multipathIndicator,
        _GPS_MeasurementParam_pseudorangeRMS_Error,
        ____GPS_MeasurementParam_iE_Extensions__item__id_tab,
        ___GPS_MeasurementParam_iE_Extensions__item__id,
        ____GPS_MeasurementParam_iE_Extensions__item__criticality_tab,
        ___GPS_MeasurementParam_iE_Extensions__item__criticality,
        ____GPS_MeasurementParam_iE_Extensions__item__extensionValue_tab,
        ___GPS_MeasurementParam_iE_Extensions__item__extensionValue,
        __GPS_MeasurementParam_iE_Extensions__item_,
        _GPS_MeasurementParam_iE_Extensions,
        GPS_MeasurementParam,
        MultipathIndicator,
        GPS_MeasurementParam_ExtIEs,
        _GPS_NavigationModel__item_,
        GPS_NavigationModel,
        _NavigationModelSatInfo_satID,
        _NavigationModelSatInfo_satelliteStatus,
        _NavigationModelSatInfo_gps_clockAndEphemerisParms,
        ____NavigationModelSatInfo_iE_Extensions__item__id_tab,
        ___NavigationModelSatInfo_iE_Extensions__item__id,
        ____NavigationModelSatInfo_iE_Extensions__item__criticality_tab,
        ___NavigationModelSatInfo_iE_Extensions__item__criticality,
        ____NavigationModelSatInfo_iE_Extensions__item__extensionValue_tab,
        ___NavigationModelSatInfo_iE_Extensions__item__extensionValue,
        __NavigationModelSatInfo_iE_Extensions__item_,
        _NavigationModelSatInfo_iE_Extensions,
        NavigationModelSatInfo,
        NavigationModelSatInfo_ExtIEs,
        SatelliteStatus,
        _GPS_RealTimeIntegrity_badSatellites,
        _GPS_RealTimeIntegrity_noBadSatellites,
        GPS_RealTimeIntegrity,
        _BadSatList__item_,
        BadSatList,
        NoBadSatellites,
        _GPS_ReferenceLocation_ue_PositionEstimate,
        ____GPS_ReferenceLocation_iE_Extensions__item__id_tab,
        ___GPS_ReferenceLocation_iE_Extensions__item__id,
        ____GPS_ReferenceLocation_iE_Extensions__item__criticality_tab,
        ___GPS_ReferenceLocation_iE_Extensions__item__criticality,
        ____GPS_ReferenceLocation_iE_Extensions__item__extensionValue_tab,
        ___GPS_ReferenceLocation_iE_Extensions__item__extensionValue,
        __GPS_ReferenceLocation_iE_Extensions__item_,
        _GPS_ReferenceLocation_iE_Extensions,
        GPS_ReferenceLocation,
        GPS_ReferenceLocation_ExtIEs,
        _GPS_ReferenceTime_gps_Week,
        _GPS_ReferenceTime_gps_TOW_1msec,
        _GPS_ReferenceTime_gps_TOW_AssistList,
        ____GPS_ReferenceTime_iE_Extensions__item__id_tab,
        _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_0,
        _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_1,
        _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_2,
        _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_3,
        _____GPS_ReferenceTime_iE_Extensions__item__id_tab_val_Extension_4,
        ___GPS_ReferenceTime_iE_Extensions__item__id,
        ___GPS_ReferenceTime_iE_Extensions__item__criticality,
        ___GPS_ReferenceTime_iE_Extensions__item__extensionValue,
        __GPS_ReferenceTime_iE_Extensions__item_,
        _GPS_ReferenceTime_iE_Extensions,
        GPS_ReferenceTime,
        GPS_ReferenceTime_ExtIEs,
        _GPS_ReferenceTime_ExtIEs_val_Extension_0,
        _GPS_ReferenceTime_ExtIEs_val_Extension_1,
        _GPS_ReferenceTime_ExtIEs_val_Extension_2,
        _GPS_ReferenceTime_ExtIEs_val_Extension_3,
        _GPS_ReferenceTime_ExtIEs_val_Extension_4,
        GPS_Week_Cycle,
        _GPS_TOW_AssistList__item_,
        GPS_TOW_AssistList,
        _GPS_TOW_Assist_satID,
        _GPS_TOW_Assist_tlm_Message,
        _GPS_TOW_Assist_antiSpoof,
        _GPS_TOW_Assist_alert,
        _GPS_TOW_Assist_tlm_Reserved,
        ____GPS_TOW_Assist_iE_Extensions__item__id_tab,
        ___GPS_TOW_Assist_iE_Extensions__item__id,
        ____GPS_TOW_Assist_iE_Extensions__item__criticality_tab,
        ___GPS_TOW_Assist_iE_Extensions__item__criticality,
        ____GPS_TOW_Assist_iE_Extensions__item__extensionValue_tab,
        ___GPS_TOW_Assist_iE_Extensions__item__extensionValue,
        __GPS_TOW_Assist_iE_Extensions__item_,
        _GPS_TOW_Assist_iE_Extensions,
        GPS_TOW_Assist,
        GPS_TOW_Assist_ExtIEs,
        UTRAN_GPS_DriftRate,
        _GPSReferenceTimeUncertainty_gps_RefTimeUNC,
        ____GPSReferenceTimeUncertainty_iE_Extensions__item__id_tab,
        ___GPSReferenceTimeUncertainty_iE_Extensions__item__id,
        ____GPSReferenceTimeUncertainty_iE_Extensions__item__criticality_tab,
        ___GPSReferenceTimeUncertainty_iE_Extensions__item__criticality,
        ____GPSReferenceTimeUncertainty_iE_Extensions__item__extensionValue_tab,
        ___GPSReferenceTimeUncertainty_iE_Extensions__item__extensionValue,
        __GPSReferenceTimeUncertainty_iE_Extensions__item_,
        _GPSReferenceTimeUncertainty_iE_Extensions,
        GPSReferenceTimeUncertainty,
        GPSReferenceTimeUncertainty_ExtIEs,
        GPS_Transmission_TOW,
        _GPS_UTC_Model_a1,
        _GPS_UTC_Model_a0,
        _GPS_UTC_Model_t_ot,
        _GPS_UTC_Model_delta_t_LS,
        _GPS_UTC_Model_wn_t,
        _GPS_UTC_Model_wn_lsf,
        _GPS_UTC_Model_dn,
        _GPS_UTC_Model_delta_t_LSF,
        ____GPS_UTC_Model_iE_Extensions__item__id_tab,
        ___GPS_UTC_Model_iE_Extensions__item__id,
        ____GPS_UTC_Model_iE_Extensions__item__criticality_tab,
        ___GPS_UTC_Model_iE_Extensions__item__criticality,
        ____GPS_UTC_Model_iE_Extensions__item__extensionValue_tab,
        ___GPS_UTC_Model_iE_Extensions__item__extensionValue,
        __GPS_UTC_Model_iE_Extensions__item_,
        _GPS_UTC_Model_iE_Extensions,
        GPS_UTC_Model,
        GPS_UTCmodel_ExtIEs,
        GPS_UTRAN_TRU,
        _AdditionalGPSAssistDataRequired_almanacRequest,
        _AdditionalGPSAssistDataRequired_utcModelRequest,
        _AdditionalGPSAssistDataRequired_ionosphericModelRequest,
        _AdditionalGPSAssistDataRequired_navigationModelRequest,
        _AdditionalGPSAssistDataRequired_dgpsCorrectionsRequest,
        _AdditionalGPSAssistDataRequired_referenceLocationRequest,
        _AdditionalGPSAssistDataRequired_referenceTimeRequest,
        _AdditionalGPSAssistDataRequired_aquisitionAssistanceRequest,
        _AdditionalGPSAssistDataRequired_realTimeIntegrityRequest,
        _AdditionalGPSAssistDataRequired_navModelAddDataRequest,
        ____AdditionalGPSAssistDataRequired_iE_Extensions__item__id_tab,
        ___AdditionalGPSAssistDataRequired_iE_Extensions__item__id,
        ____AdditionalGPSAssistDataRequired_iE_Extensions__item__criticality_tab,
        ___AdditionalGPSAssistDataRequired_iE_Extensions__item__criticality,
        ____AdditionalGPSAssistDataRequired_iE_Extensions__item__extensionValue_tab,
        ___AdditionalGPSAssistDataRequired_iE_Extensions__item__extensionValue,
        __AdditionalGPSAssistDataRequired_iE_Extensions__item_,
        _AdditionalGPSAssistDataRequired_iE_Extensions,
        AdditionalGPSAssistDataRequired,
        AdditionalGPSAssistDataRequired_ExtIEs,
        _AdditionalGanssAssistDataRequired_ganssReferenceTime,
        _AdditionalGanssAssistDataRequired_ganssreferenceLocation,
        _AdditionalGanssAssistDataRequired_ganssIonosphericModel,
        _AdditionalGanssAssistDataRequired_ganssRequestedGenericAssistanceDataList,
        ____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab,
        _____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab_val_Extension_0,
        _____AdditionalGanssAssistDataRequired_iE_Extensions__item__id_tab_val_Extension_1,
        ___AdditionalGanssAssistDataRequired_iE_Extensions__item__id,
        ___AdditionalGanssAssistDataRequired_iE_Extensions__item__criticality,
        ___AdditionalGanssAssistDataRequired_iE_Extensions__item__extensionValue,
        __AdditionalGanssAssistDataRequired_iE_Extensions__item_,
        _AdditionalGanssAssistDataRequired_iE_Extensions,
        AdditionalGanssAssistDataRequired,
        AdditionalGanssAssistDataRequired_ExtIEs,
        _AdditionalGanssAssistDataRequired_ExtIEs_val_Extension_0,
        _AdditionalGanssAssistDataRequired_ExtIEs_val_Extension_1,
        _GANSSReq_AddIonosphericModel_ganss_add_iono_mode_req,
        ____GANSSReq_AddIonosphericModel_iE_Extensions__item__id_tab,
        ___GANSSReq_AddIonosphericModel_iE_Extensions__item__id,
        ____GANSSReq_AddIonosphericModel_iE_Extensions__item__criticality_tab,
        ___GANSSReq_AddIonosphericModel_iE_Extensions__item__criticality,
        ____GANSSReq_AddIonosphericModel_iE_Extensions__item__extensionValue_tab,
        ___GANSSReq_AddIonosphericModel_iE_Extensions__item__extensionValue,
        __GANSSReq_AddIonosphericModel_iE_Extensions__item_,
        _GANSSReq_AddIonosphericModel_iE_Extensions,
        GANSSReq_AddIonosphericModel,
        GANSSReq_AddIonosphericModel_ExtIEs,
        GANSSReq_EarthOrientPara,
        _GanssRequestedGenericAssistanceDataList__item_,
        GanssRequestedGenericAssistanceDataList,
        _GanssReqGenericData_ganssId,
        _GanssReqGenericData_ganssRealTimeIntegrity,
        _GanssReqGenericData_ganssDifferentialCorrection,
        _GanssReqGenericData_ganssAlmanac,
        _GanssReqGenericData_ganssNavigationModel,
        _GanssReqGenericData_ganssTimeModelGnssGnss,
        _GanssReqGenericData_ganssReferenceMeasurementInfo,
        _GanssReqGenericData_ganssDataBits,
        _GanssReqGenericData_ganssUTCModel,
        _GanssReqGenericData_ganssNavigationModelAdditionalData,
        ____GanssReqGenericData_iE_Extensions__item__id_tab,
        _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_0,
        _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_1,
        _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_2,
        _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_3,
        _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_4,
        _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_5,
        _____GanssReqGenericData_iE_Extensions__item__id_tab_val_Extension_6,
        ___GanssReqGenericData_iE_Extensions__item__id,
        ___GanssReqGenericData_iE_Extensions__item__criticality,
        ___GanssReqGenericData_iE_Extensions__item__extensionValue,
        __GanssReqGenericData_iE_Extensions__item_,
        _GanssReqGenericData_iE_Extensions,
        GanssReqGenericData,
        GanssReqGenericData_ExtIEs,
        _GanssReqGenericData_ExtIEs_val_Extension_0,
        _GanssReqGenericData_ExtIEs_val_Extension_1,
        _GanssReqGenericData_ExtIEs_val_Extension_2,
        _GanssReqGenericData_ExtIEs_val_Extension_3,
        _GanssReqGenericData_ExtIEs_val_Extension_4,
        _GanssReqGenericData_ExtIEs_val_Extension_5,
        _GanssReqGenericData_ExtIEs_val_Extension_6,
        BDSIonosphericGridModel,
        _DBDSCorrection_dGANSSSignalBDS,
        ____DBDSCorrection_iE_Extensions__item__id_tab,
        ___DBDSCorrection_iE_Extensions__item__id,
        ____DBDSCorrection_iE_Extensions__item__criticality_tab,
        ___DBDSCorrection_iE_Extensions__item__criticality,
        ____DBDSCorrection_iE_Extensions__item__extensionValue_tab,
        ___DBDSCorrection_iE_Extensions__item__extensionValue,
        __DBDSCorrection_iE_Extensions__item_,
        _DBDSCorrection_iE_Extensions,
        DBDSCorrection,
        DBDSCorrection_ExtIEs,
        GANSS_AddNavigationModel_Req,
        GANSS_AddUTCModel_Req,
        GANSS_AuxInfo_req,
        _GANSS_AddADchoices_orbitModelID,
        _GANSS_AddADchoices_clockModelID,
        _GANSS_AddADchoices_utcModelID,
        _GANSS_AddADchoices_almanacModelID,
        ____GANSS_AddADchoices_iE_Extensions__item__id_tab,
        ___GANSS_AddADchoices_iE_Extensions__item__id,
        ____GANSS_AddADchoices_iE_Extensions__item__criticality_tab,
        ___GANSS_AddADchoices_iE_Extensions__item__criticality,
        ____GANSS_AddADchoices_iE_Extensions__item__extensionValue_tab,
        ___GANSS_AddADchoices_iE_Extensions__item__extensionValue,
        __GANSS_AddADchoices_iE_Extensions__item_,
        _GANSS_AddADchoices_iE_Extensions,
        GANSS_AddADchoices,
        GANSS_AddADchoices_ExtIEs,
        DGANSS_Sig_Id_Req,
        _GanssDataBits_ganssTod,
        _GanssDataBits_dataBitAssistancelist,
        ____GanssDataBits_iE_Extensions__item__id_tab,
        ___GanssDataBits_iE_Extensions__item__id,
        ____GanssDataBits_iE_Extensions__item__criticality_tab,
        ___GanssDataBits_iE_Extensions__item__criticality,
        ____GanssDataBits_iE_Extensions__item__extensionValue_tab,
        ___GanssDataBits_iE_Extensions__item__extensionValue,
        __GanssDataBits_iE_Extensions__item_,
        _GanssDataBits_iE_Extensions,
        GanssDataBits,
        GanssDataBits_ExtIEs,
        _ReqDataBitAssistanceList_ganssSignalID,
        _ReqDataBitAssistanceList_ganssDataBitInterval,
        __ReqDataBitAssistanceList_ganssSatelliteInfo__item_,
        _ReqDataBitAssistanceList_ganssSatelliteInfo,
        ____ReqDataBitAssistanceList_iE_Extensions__item__id_tab,
        ___ReqDataBitAssistanceList_iE_Extensions__item__id,
        ____ReqDataBitAssistanceList_iE_Extensions__item__criticality_tab,
        ___ReqDataBitAssistanceList_iE_Extensions__item__criticality,
        ____ReqDataBitAssistanceList_iE_Extensions__item__extensionValue_tab,
        ___ReqDataBitAssistanceList_iE_Extensions__item__extensionValue,
        __ReqDataBitAssistanceList_iE_Extensions__item_,
        _ReqDataBitAssistanceList_iE_Extensions,
        ReqDataBitAssistanceList,
        ReqDataBitAssistanceList_ExtIEs,
        InformationExchangeID,
        _InformationReportCharacteristics_type,
        _InformationReportCharacteristics_periodicity,
        InformationReportCharacteristics,
        InformationReportCharacteristicsType,
        _InformationReportPeriodicity_min,
        _InformationReportPeriodicity_hour,
        InformationReportPeriodicity,
        _InformationType_implicitInformation,
        _InformationType_explicitInformation,
        InformationType,
        _ExplicitInformationList__item_,
        ExplicitInformationList,
        _ExplicitInformation_almanacAndSatelliteHealth,
        _ExplicitInformation_utcModel,
        _ExplicitInformation_ionosphericModel,
        _ExplicitInformation_navigationModel,
        _ExplicitInformation_dgpsCorrections,
        _ExplicitInformation_referenceTime,
        _ExplicitInformation_acquisitionAssistance,
        _ExplicitInformation_realTimeIntegrity,
        _ExplicitInformation_almanacAndSatelliteHealthSIB,
        _ExplicitInformation_referenceLocation,
        _ExplicitInformation_ganss_Common_DataReq,
        _ExplicitInformation_ganss_Generic_DataList,
        ExplicitInformation,
        _DganssCorrectionsReq_transmissionGanssTimeIndicator,
        _DganssCorrectionsReq_dganss_sig_id_req,
        ____DganssCorrectionsReq_iE_Extensions__item__id_tab,
        ___DganssCorrectionsReq_iE_Extensions__item__id,
        ____DganssCorrectionsReq_iE_Extensions__item__criticality_tab,
        ___DganssCorrectionsReq_iE_Extensions__item__criticality,
        ____DganssCorrectionsReq_iE_Extensions__item__extensionValue_tab,
        ___DganssCorrectionsReq_iE_Extensions__item__extensionValue,
        __DganssCorrectionsReq_iE_Extensions__item_,
        _DganssCorrectionsReq_iE_Extensions,
        DganssCorrectionsReq,
        DganssCorrectionsReq_ExtIEs,
        _Ganss_almanacAndSatelliteHealthReq_transmissionGanssTimeIndicator,
        ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__id_tab,
        ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__id,
        ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__criticality_tab,
        ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__criticality,
        ____Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__extensionValue_tab,
        ___Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item__extensionValue,
        __Ganss_almanacAndSatelliteHealthReq_iE_Extensions__item_,
        _Ganss_almanacAndSatelliteHealthReq_iE_Extensions,
        Ganss_almanacAndSatelliteHealthReq,
        Ganss_almanacAndSatelliteHealthReq_ExtIEs,
        _GANSSCommonDataReq_ganss_ReferenceTime,
        _GANSSCommonDataReq_ganss_IonosphericModel,
        _GANSSCommonDataReq_ganss_ReferenceLocation,
        ____GANSSCommonDataReq_ie_Extensions__item__id_tab,
        _____GANSSCommonDataReq_ie_Extensions__item__id_tab_val_Extension_0,
        _____GANSSCommonDataReq_ie_Extensions__item__id_tab_val_Extension_1,
        ___GANSSCommonDataReq_ie_Extensions__item__id,
        ___GANSSCommonDataReq_ie_Extensions__item__criticality,
        ___GANSSCommonDataReq_ie_Extensions__item__extensionValue,
        __GANSSCommonDataReq_ie_Extensions__item_,
        _GANSSCommonDataReq_ie_Extensions,
        GANSSCommonDataReq,
        GANSSCommonDataReq_ExtIEs,
        _GANSSCommonDataReq_ExtIEs_val_Extension_0,
        _GANSSCommonDataReq_ExtIEs_val_Extension_1,
        _GANSS_AddIonoModelReq_dataID,
        ____GANSS_AddIonoModelReq_iE_Extensions__item__id_tab,
        ___GANSS_AddIonoModelReq_iE_Extensions__item__id,
        ____GANSS_AddIonoModelReq_iE_Extensions__item__criticality_tab,
        ___GANSS_AddIonoModelReq_iE_Extensions__item__criticality,
        ____GANSS_AddIonoModelReq_iE_Extensions__item__extensionValue_tab,
        ___GANSS_AddIonoModelReq_iE_Extensions__item__extensionValue,
        __GANSS_AddIonoModelReq_iE_Extensions__item_,
        _GANSS_AddIonoModelReq_iE_Extensions,
        GANSS_AddIonoModelReq,
        GANSS_AddIonoModelReq_ExtIEs,
        _GANSS_EarthOrientParaReq_eopReq,
        ____GANSS_EarthOrientParaReq_iE_Extensions__item__id_tab,
        ___GANSS_EarthOrientParaReq_iE_Extensions__item__id,
        ____GANSS_EarthOrientParaReq_iE_Extensions__item__criticality_tab,
        ___GANSS_EarthOrientParaReq_iE_Extensions__item__criticality,
        ____GANSS_EarthOrientParaReq_iE_Extensions__item__extensionValue_tab,
        ___GANSS_EarthOrientParaReq_iE_Extensions__item__extensionValue,
        __GANSS_EarthOrientParaReq_iE_Extensions__item_,
        _GANSS_EarthOrientParaReq_iE_Extensions,
        GANSS_EarthOrientParaReq,
        GANSS_EarthOrientParaReq_ExtIEs,
        _GANSSGenericDataList__item_,
        GANSSGenericDataList,
        _GANSSGenericDataReq_ganssID,
        _GANSSGenericDataReq_ganss_realTimeIntegrity,
        _GANSSGenericDataReq_ganss_dataBitAssistance,
        _GANSSGenericDataReq_dganssCorrections,
        _GANSSGenericDataReq_ganss_almanacAndSatelliteHealth,
        _GANSSGenericDataReq_ganss_referenceMeasurementInfo,
        _GANSSGenericDataReq_ganss_utcModel,
        _GANSSGenericDataReq_ganss_TimeModel_Gnss_Gnss,
        _GANSSGenericDataReq_navigationModel,
        _GANSSGenericDataReq_ganss_AddNavModelsReq,
        _GANSSGenericDataReq_ganss_AddUtcModelsReq,
        _GANSSGenericDataReq_ganss_AuxInfoReq,
        _GANSSGenericDataReq_ganss_SBAS_ID,
        _GANSSGenericDataReq_dBDS_Corrections,
        _GANSSGenericDataReq_bDS_Ionospheric_Grid_Model_Request,
        GANSSGenericDataReq,
        _AddNavigationModelsGANSS_ganssWeek,
        _AddNavigationModelsGANSS_ganssTOE,
        _AddNavigationModelsGANSS_t_toe_limit,
        _AddNavigationModelsGANSS_addSatRelatedDataListGANSS,
        ____AddNavigationModelsGANSS_iE_Extensions__item__id_tab,
        ___AddNavigationModelsGANSS_iE_Extensions__item__id,
        ____AddNavigationModelsGANSS_iE_Extensions__item__criticality_tab,
        ___AddNavigationModelsGANSS_iE_Extensions__item__criticality,
        ____AddNavigationModelsGANSS_iE_Extensions__item__extensionValue_tab,
        ___AddNavigationModelsGANSS_iE_Extensions__item__extensionValue,
        __AddNavigationModelsGANSS_iE_Extensions__item_,
        _AddNavigationModelsGANSS_iE_Extensions,
        AddNavigationModelsGANSS,
        AddNavigationModelsGANSS_ExtIEs,
        _AddSatelliteRelatedDataListGANSS__item_,
        AddSatelliteRelatedDataListGANSS,
        _AddSatelliteRelatedDataGANSS_satID,
        _AddSatelliteRelatedDataGANSS_iod,
        ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__id_tab,
        ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__id,
        ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__criticality_tab,
        ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__criticality,
        ____AddSatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue_tab,
        ___AddSatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue,
        __AddSatelliteRelatedDataGANSS_iE_Extensions__item_,
        _AddSatelliteRelatedDataGANSS_iE_Extensions,
        AddSatelliteRelatedDataGANSS,
        AddSatelliteRelatedDataGANSS_ExtIEs,
        BDS_Ionospheric_Grid_Model_Request,
        _DBDS_Corrections_transmissionGanssTimeIndicator,
        _DBDS_Corrections_dGANSS_Signal,
        ____DBDS_Corrections_iE_Extensions__item__id_tab,
        ___DBDS_Corrections_iE_Extensions__item__id,
        ____DBDS_Corrections_iE_Extensions__item__criticality_tab,
        ___DBDS_Corrections_iE_Extensions__item__criticality,
        ____DBDS_Corrections_iE_Extensions__item__extensionValue_tab,
        ___DBDS_Corrections_iE_Extensions__item__extensionValue,
        __DBDS_Corrections_iE_Extensions__item_,
        _DBDS_Corrections_iE_Extensions,
        DBDS_Corrections,
        DBDS_Corrections_ExtIEs,
        _GANSS_AddUtcModelsReq_transmissionGanssTimeIndicator,
        ____GANSS_AddUtcModelsReq_iE_Extensions__item__id_tab,
        ___GANSS_AddUtcModelsReq_iE_Extensions__item__id,
        ____GANSS_AddUtcModelsReq_iE_Extensions__item__criticality_tab,
        ___GANSS_AddUtcModelsReq_iE_Extensions__item__criticality,
        ____GANSS_AddUtcModelsReq_iE_Extensions__item__extensionValue_tab,
        ___GANSS_AddUtcModelsReq_iE_Extensions__item__extensionValue,
        __GANSS_AddUtcModelsReq_iE_Extensions__item_,
        _GANSS_AddUtcModelsReq_iE_Extensions,
        GANSS_AddUtcModelsReq,
        GANSS_AddUtcModelsReq_ExtIEs,
        _GANSS_AuxInfoReq_transmissionGanssTimeIndicator,
        ____GANSS_AuxInfoReq_iE_Extensions__item__id_tab,
        ___GANSS_AuxInfoReq_iE_Extensions__item__id,
        ____GANSS_AuxInfoReq_iE_Extensions__item__criticality_tab,
        ___GANSS_AuxInfoReq_iE_Extensions__item__criticality,
        ____GANSS_AuxInfoReq_iE_Extensions__item__extensionValue_tab,
        ___GANSS_AuxInfoReq_iE_Extensions__item__extensionValue,
        __GANSS_AuxInfoReq_iE_Extensions__item_,
        _GANSS_AuxInfoReq_iE_Extensions,
        GANSS_AuxInfoReq,
        GANSS_AuxInfoReq_ExtIEs,
        GANSS_SBAS_ID,
        _Ganss_utcModelReq_transmissionGanssTimeIndicator,
        ____Ganss_utcModelReq_iE_Extensions__item__id_tab,
        ___Ganss_utcModelReq_iE_Extensions__item__id,
        ____Ganss_utcModelReq_iE_Extensions__item__criticality_tab,
        ___Ganss_utcModelReq_iE_Extensions__item__criticality,
        ____Ganss_utcModelReq_iE_Extensions__item__extensionValue_tab,
        ___Ganss_utcModelReq_iE_Extensions__item__extensionValue,
        __Ganss_utcModelReq_iE_Extensions__item_,
        _Ganss_utcModelReq_iE_Extensions,
        Ganss_utcModelReq,
        Ganss_utcModelReq_ExtIEs,
        _Ganss_realTimeIntegrityReq_transmissionGanssTimeIndicator,
        ____Ganss_realTimeIntegrityReq_iE_Extensions__item__id_tab,
        ___Ganss_realTimeIntegrityReq_iE_Extensions__item__id,
        ____Ganss_realTimeIntegrityReq_iE_Extensions__item__criticality_tab,
        ___Ganss_realTimeIntegrityReq_iE_Extensions__item__criticality,
        ____Ganss_realTimeIntegrityReq_iE_Extensions__item__extensionValue_tab,
        ___Ganss_realTimeIntegrityReq_iE_Extensions__item__extensionValue,
        __Ganss_realTimeIntegrityReq_iE_Extensions__item_,
        _Ganss_realTimeIntegrityReq_iE_Extensions,
        Ganss_realTimeIntegrityReq,
        Ganss_realTimeIntegrityReq_ExtIEs,
        _Ganss_referenceMeasurementInfoReq_transmissionGanssTimeIndicator,
        ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__id_tab,
        ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__id,
        ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__criticality_tab,
        ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__criticality,
        ____Ganss_referenceMeasurementInfoReq_iE_Extensions__item__extensionValue_tab,
        ___Ganss_referenceMeasurementInfoReq_iE_Extensions__item__extensionValue,
        __Ganss_referenceMeasurementInfoReq_iE_Extensions__item_,
        _Ganss_referenceMeasurementInfoReq_iE_Extensions,
        Ganss_referenceMeasurementInfoReq,
        Ganss_referenceMeasurementInfoReq_ExtIEs,
        _Ganss_TimeModel_Gnss_Gnss_ganssTimeModelGnssGnssExt,
        _Ganss_TimeModel_Gnss_Gnss_transmissionGanssTimeIndicator,
        ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__id_tab,
        ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__id,
        ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__criticality_tab,
        ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__criticality,
        ____Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__extensionValue_tab,
        ___Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item__extensionValue,
        __Ganss_TimeModel_Gnss_Gnss_iE_Extensions__item_,
        _Ganss_TimeModel_Gnss_Gnss_iE_Extensions,
        Ganss_TimeModel_Gnss_Gnss,
        Ganss_TimeModel_Gnss_Gnss_ExtIEs,
        TransmissionGanssTimeIndicator,
        AlmanacAndSatelliteHealth,
        _UtcModel_transmissionTOWIndicator,
        ____UtcModel_iE_Extensions__item__id_tab,
        ___UtcModel_iE_Extensions__item__id,
        ____UtcModel_iE_Extensions__item__criticality_tab,
        ___UtcModel_iE_Extensions__item__criticality,
        ____UtcModel_iE_Extensions__item__extensionValue_tab,
        ___UtcModel_iE_Extensions__item__extensionValue,
        __UtcModel_iE_Extensions__item_,
        _UtcModel_iE_Extensions,
        UtcModel,
        UtcModel_ExtIEs,
        _IonosphericModel_transmissionTOWIndicator,
        ____IonosphericModel_iE_Extensions__item__id_tab,
        ___IonosphericModel_iE_Extensions__item__id,
        ____IonosphericModel_iE_Extensions__item__criticality_tab,
        ___IonosphericModel_iE_Extensions__item__criticality,
        ____IonosphericModel_iE_Extensions__item__extensionValue_tab,
        ___IonosphericModel_iE_Extensions__item__extensionValue,
        __IonosphericModel_iE_Extensions__item_,
        _IonosphericModel_iE_Extensions,
        IonosphericModel,
        IonosphericModel_ExtIEs,
        _NavigationModel_transmissionTOWIndicator,
        _NavigationModel_navModelAdditionalData,
        ____NavigationModel_iE_Extensions__item__id_tab,
        ___NavigationModel_iE_Extensions__item__id,
        ____NavigationModel_iE_Extensions__item__criticality_tab,
        ___NavigationModel_iE_Extensions__item__criticality,
        ____NavigationModel_iE_Extensions__item__extensionValue_tab,
        ___NavigationModel_iE_Extensions__item__extensionValue,
        __NavigationModel_iE_Extensions__item_,
        _NavigationModel_iE_Extensions,
        NavigationModel,
        NavigationModel_ExtIEs,
        _NavModelAdditionalData_gps_Week,
        _NavModelAdditionalData_gps_TOE,
        _NavModelAdditionalData_t_TOE_limit,
        _NavModelAdditionalData_satRelatedDataList,
        ____NavModelAdditionalData_iE_Extensions__item__id_tab,
        ___NavModelAdditionalData_iE_Extensions__item__id,
        ____NavModelAdditionalData_iE_Extensions__item__criticality_tab,
        ___NavModelAdditionalData_iE_Extensions__item__criticality,
        ____NavModelAdditionalData_iE_Extensions__item__extensionValue_tab,
        ___NavModelAdditionalData_iE_Extensions__item__extensionValue,
        __NavModelAdditionalData_iE_Extensions__item_,
        _NavModelAdditionalData_iE_Extensions,
        NavModelAdditionalData,
        NavModelAdditionalData_ExtIEs,
        _SatelliteRelatedDataList__item_,
        SatelliteRelatedDataList,
        _SatelliteRelatedData_satID,
        _SatelliteRelatedData_iode,
        ____SatelliteRelatedData_iE_Extensions__item__id_tab,
        ___SatelliteRelatedData_iE_Extensions__item__id,
        ____SatelliteRelatedData_iE_Extensions__item__criticality_tab,
        ___SatelliteRelatedData_iE_Extensions__item__criticality,
        ____SatelliteRelatedData_iE_Extensions__item__extensionValue_tab,
        ___SatelliteRelatedData_iE_Extensions__item__extensionValue,
        __SatelliteRelatedData_iE_Extensions__item_,
        _SatelliteRelatedData_iE_Extensions,
        SatelliteRelatedData,
        SatelliteRelatedData_ExtIEs,
        _NavigationModelGANSS_ganssWeek,
        _NavigationModelGANSS_ganssTOE,
        _NavigationModelGANSS_t_toe_limit,
        _NavigationModelGANSS_satRelatedDataListGANSS,
        ____NavigationModelGANSS_iE_Extensions__item__id_tab,
        ___NavigationModelGANSS_iE_Extensions__item__id,
        ____NavigationModelGANSS_iE_Extensions__item__criticality_tab,
        ___NavigationModelGANSS_iE_Extensions__item__criticality,
        ____NavigationModelGANSS_iE_Extensions__item__extensionValue_tab,
        ___NavigationModelGANSS_iE_Extensions__item__extensionValue,
        __NavigationModelGANSS_iE_Extensions__item_,
        _NavigationModelGANSS_iE_Extensions,
        NavigationModelGANSS,
        NavigationModelGANSS_ExtIEs,
        _SatelliteRelatedDataListGANSS__item_,
        SatelliteRelatedDataListGANSS,
        _SatelliteRelatedDataGANSS_satID,
        _SatelliteRelatedDataGANSS_iod,
        ____SatelliteRelatedDataGANSS_iE_Extensions__item__id_tab,
        ___SatelliteRelatedDataGANSS_iE_Extensions__item__id,
        ____SatelliteRelatedDataGANSS_iE_Extensions__item__criticality_tab,
        ___SatelliteRelatedDataGANSS_iE_Extensions__item__criticality,
        ____SatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue_tab,
        ___SatelliteRelatedDataGANSS_iE_Extensions__item__extensionValue,
        __SatelliteRelatedDataGANSS_iE_Extensions__item_,
        _SatelliteRelatedDataGANSS_iE_Extensions,
        SatelliteRelatedDataGANSS,
        SatelliteRelatedDataGANSS_ExtIEs,
        DgpsCorrections,
        ReferenceTime,
        AcquisitionAssistance,
        RealTimeIntegrity,
        _AlmanacAndSatelliteHealthSIB_InfoType_transmissionTOWIndicator,
        ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__id_tab,
        ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__id,
        ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__criticality_tab,
        ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__criticality,
        ____AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__extensionValue_tab,
        ___AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item__extensionValue,
        __AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions__item_,
        _AlmanacAndSatelliteHealthSIB_InfoType_iE_Extensions,
        AlmanacAndSatelliteHealthSIB_InfoType,
        AlmanacAndSatelliteHealthSIB_InfoType_ExtIEs,
        ReferenceLocation,
        TransmissionTOWIndicator,
        __MessageStructure__item__iE_ID,
        __MessageStructure__item__repetitionNumber,
        _____MessageStructure__item__iE_Extensions__item__id_tab,
        ____MessageStructure__item__iE_Extensions__item__id,
        _____MessageStructure__item__iE_Extensions__item__criticality_tab,
        ____MessageStructure__item__iE_Extensions__item__criticality,
        _____MessageStructure__item__iE_Extensions__item__extensionValue_tab,
        ____MessageStructure__item__iE_Extensions__item__extensionValue,
        ___MessageStructure__item__iE_Extensions__item_,
        __MessageStructure__item__iE_Extensions,
        _MessageStructure__item_,
        MessageStructure,
        MessageStructureRepetition,
        MessageStructure_ExtIEs,
        _MeasInstructionsUsed_measurementValidity,
        ____MeasInstructionsUsed_iE_Extensions__item__id_tab,
        ___MeasInstructionsUsed_iE_Extensions__item__id,
        ____MeasInstructionsUsed_iE_Extensions__item__criticality_tab,
        ___MeasInstructionsUsed_iE_Extensions__item__criticality,
        ____MeasInstructionsUsed_iE_Extensions__item__extensionValue_tab,
        ___MeasInstructionsUsed_iE_Extensions__item__extensionValue,
        __MeasInstructionsUsed_iE_Extensions__item_,
        _MeasInstructionsUsed_iE_Extensions,
        MeasInstructionsUsed,
        MeasInstructionsUsed_ExtIEs,
        _MeasurementValidity_ue_State,
        ____MeasurementValidity_iE_Extensions__item__id_tab,
        ___MeasurementValidity_iE_Extensions__item__id,
        ____MeasurementValidity_iE_Extensions__item__criticality_tab,
        ___MeasurementValidity_iE_Extensions__item__criticality,
        ____MeasurementValidity_iE_Extensions__item__extensionValue_tab,
        ___MeasurementValidity_iE_Extensions__item__extensionValue,
        __MeasurementValidity_iE_Extensions__item_,
        _MeasurementValidity_iE_Extensions,
        MeasurementValidity,
        MeasurementValidity_ExtIEs,
        MethodType,
        _OTDOA_MeasurementGroup_otdoa_ReferenceCellInfo,
        _OTDOA_MeasurementGroup_otdoa_NeighbourCellInfoList,
        _OTDOA_MeasurementGroup_otdoa_MeasuredResultsSets,
        ____OTDOA_MeasurementGroup_iE_Extensions__item__id_tab,
        ___OTDOA_MeasurementGroup_iE_Extensions__item__id,
        ____OTDOA_MeasurementGroup_iE_Extensions__item__criticality_tab,
        ___OTDOA_MeasurementGroup_iE_Extensions__item__criticality,
        ____OTDOA_MeasurementGroup_iE_Extensions__item__extensionValue_tab,
        ___OTDOA_MeasurementGroup_iE_Extensions__item__extensionValue,
        __OTDOA_MeasurementGroup_iE_Extensions__item_,
        _OTDOA_MeasurementGroup_iE_Extensions,
        OTDOA_MeasurementGroup,
        OTDOA_MeasurementGroup_ExtIEs,
        _OTDOA_ReferenceCellInfo_uC_ID,
        _OTDOA_ReferenceCellInfo_uTRANAccessPointPositionAltitude,
        _OTDOA_ReferenceCellInfo_tUTRANGPSMeasurementValueInfo,
        ____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab,
        _____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_0,
        _____OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_1,
        ___OTDOA_ReferenceCellInfo_iE_Extensions__item__id,
        ___OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality,
        ___OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue,
        __OTDOA_ReferenceCellInfo_iE_Extensions__item_,
        _OTDOA_ReferenceCellInfo_iE_Extensions,
        OTDOA_ReferenceCellInfo,
        OTDOA_ReferenceCellInfo_ExtIEs,
        _OTDOA_ReferenceCellInfo_ExtIEs_val_Extension_0,
        _OTDOA_ReferenceCellInfo_ExtIEs_val_Extension_1,
        _OTDOA_ReferenceCellInfoSAS_centric_uC_ID,
        ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__id_tab,
        ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__id,
        ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__criticality_tab,
        ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__criticality,
        ____OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__extensionValue_tab,
        ___OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item__extensionValue,
        __OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions__item_,
        _OTDOA_ReferenceCellInfoSAS_centric_iE_Extensions,
        OTDOA_ReferenceCellInfoSAS_centric,
        OTDOA_ReferenceCellInfoSAS_centric_ExtIEs,
        _OTDOA_NeighbourCellInfoList__item_,
        OTDOA_NeighbourCellInfoList,
        _OTDOA_NeighbourCellInfo_uC_ID,
        _OTDOA_NeighbourCellInfo_uTRANAccessPointPositionAltitude,
        _OTDOA_NeighbourCellInfo_relativeTimingDifferenceInfo,
        ____OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab,
        ___OTDOA_NeighbourCellInfo_iE_Extensions__item__id,
        ____OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality_tab,
        ___OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality,
        ____OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue_tab,
        ___OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue,
        __OTDOA_NeighbourCellInfo_iE_Extensions__item_,
        _OTDOA_NeighbourCellInfo_iE_Extensions,
        OTDOA_NeighbourCellInfo,
        OTDOA_NeighbourCellInfo_ExtIEs,
        _OTDOA_MeasuredResultsSets__item_,
        OTDOA_MeasuredResultsSets,
        _OTDOA_MeasuredResultsInfoList__item_,
        OTDOA_MeasuredResultsInfoList,
        _OTDOA_MeasuredResultsInfo_uC_ID,
        _OTDOA_MeasuredResultsInfo_ue_SFNSFNTimeDifferenceType2Info,
        ____OTDOA_MeasuredResultsInfo_iE_Extensions__item__id_tab,
        _____OTDOA_MeasuredResultsInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__id,
        ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__criticality,
        ___OTDOA_MeasuredResultsInfo_iE_Extensions__item__extensionValue,
        __OTDOA_MeasuredResultsInfo_iE_Extensions__item_,
        _OTDOA_MeasuredResultsInfo_iE_Extensions,
        OTDOA_MeasuredResultsInfo,
        OTDOA_MeasuredResultsInfo_ExtIEs,
        _OTDOA_MeasuredResultsInfo_ExtIEs_val_Extension_0,
        _OTDOA_AddMeasuredResultsInfo_primaryCPICH_Info,
        ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__id_tab,
        ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__id,
        ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__criticality_tab,
        ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__criticality,
        ____OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__extensionValue_tab,
        ___OTDOA_AddMeasuredResultsInfo_iE_Extensions__item__extensionValue,
        __OTDOA_AddMeasuredResultsInfo_iE_Extensions__item_,
        _OTDOA_AddMeasuredResultsInfo_iE_Extensions,
        OTDOA_AddMeasuredResultsInfo,
        OTDOA_AddMeasuredResultsInfo_ExtIEs,
        _UE_SFNSFNTimeDifferenceType2Info_ue_SFNSFNTimeDifferenceType2,
        _UE_SFNSFNTimeDifferenceType2Info_ue_PositioningMeasQuality,
        _UE_SFNSFNTimeDifferenceType2Info_measurementDelay,
        ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__id_tab,
        ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__id,
        ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__criticality_tab,
        ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__criticality,
        ____UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__extensionValue_tab,
        ___UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item__extensionValue,
        __UE_SFNSFNTimeDifferenceType2Info_iE_Extensions__item_,
        _UE_SFNSFNTimeDifferenceType2Info_iE_Extensions,
        UE_SFNSFNTimeDifferenceType2Info,
        UE_SFNSFNTimeDifferenceInfo_ExtIEs,
        _UC_ID_rNC_ID,
        _UC_ID_c_ID,
        ____UC_ID_iE_Extensions__item__id_tab,
        _____UC_ID_iE_Extensions__item__id_tab_val_Extension_0,
        ___UC_ID_iE_Extensions__item__id,
        ___UC_ID_iE_Extensions__item__criticality,
        ___UC_ID_iE_Extensions__item__extensionValue,
        __UC_ID_iE_Extensions__item_,
        _UC_ID_iE_Extensions,
        UC_ID,
        UC_ID_ExtIEs,
        _UC_ID_ExtIEs_val_Extension_0,
        Extended_RNC_ID,
        _RelativeTimingDifferenceInfo_sFNSFNMeasurementValueInfo,
        _RelativeTimingDifferenceInfo_tUTRANGPSMeasurementValueInfo,
        _RelativeTimingDifferenceInfo_tUTRANGANSSMeasurementValueInfo,
        RelativeTimingDifferenceInfo,
        _SFNSFNMeasurementValueInfo_sFNSFNValue,
        _SFNSFNMeasurementValueInfo_sFNSFNQuality,
        _SFNSFNMeasurementValueInfo_sFNSFNDriftRate,
        _SFNSFNMeasurementValueInfo_sFNSFNDriftRateQuality,
        ____SFNSFNMeasurementValueInfo_iE_Extensions__item__id_tab,
        ___SFNSFNMeasurementValueInfo_iE_Extensions__item__id,
        ____SFNSFNMeasurementValueInfo_iE_Extensions__item__criticality_tab,
        ___SFNSFNMeasurementValueInfo_iE_Extensions__item__criticality,
        ____SFNSFNMeasurementValueInfo_iE_Extensions__item__extensionValue_tab,
        ___SFNSFNMeasurementValueInfo_iE_Extensions__item__extensionValue,
        __SFNSFNMeasurementValueInfo_iE_Extensions__item_,
        _SFNSFNMeasurementValueInfo_iE_Extensions,
        SFNSFNMeasurementValueInfo,
        SFNSFNMeasurementValueInfo_ExtIEs,
        SFNSFNValue,
        SFNSFNQuality,
        SFNSFNDriftRate,
        SFNSFNDriftRateQuality,
        _TUTRANGPSMeasurementValueInfo_sFN,
        _TUTRANGPSMeasurementValueInfo_tUTRANGPS,
        _TUTRANGPSMeasurementValueInfo_tUTRANGPSQuality,
        _TUTRANGPSMeasurementValueInfo_tUTRANGPSDriftRate,
        _TUTRANGPSMeasurementValueInfo_tUTRANGPSDriftRateQuality,
        ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__id_tab,
        ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__id,
        ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__criticality_tab,
        ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__criticality,
        ____TUTRANGPSMeasurementValueInfo_iE_Extensions__item__extensionValue_tab,
        ___TUTRANGPSMeasurementValueInfo_iE_Extensions__item__extensionValue,
        __TUTRANGPSMeasurementValueInfo_iE_Extensions__item_,
        _TUTRANGPSMeasurementValueInfo_iE_Extensions,
        TUTRANGPSMeasurementValueInfo,
        TUTRANGPSMeasurementValueInfo_ExtIEs,
        SFN,
        _TUTRANGPS_ms_part,
        _TUTRANGPS_ls_part,
        TUTRANGPS,
        TUTRANGPSQuality,
        TUTRANGPSDriftRate,
        TUTRANGPSDriftRateQuality,
        _TUTRANGANSSMeasurementValueInfo_ganssID,
        _TUTRANGANSSMeasurementValueInfo_sFN,
        _TUTRANGANSSMeasurementValueInfo_tUTRANGANSS,
        _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSQuality,
        _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSDriftRate,
        _TUTRANGANSSMeasurementValueInfo_tUTRANGANSSDriftRateQuality,
        ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__id_tab,
        ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__id,
        ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__criticality_tab,
        ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__criticality,
        ____TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__extensionValue_tab,
        ___TUTRANGANSSMeasurementValueInfo_iE_Extensions__item__extensionValue,
        __TUTRANGANSSMeasurementValueInfo_iE_Extensions__item_,
        _TUTRANGANSSMeasurementValueInfo_iE_Extensions,
        TUTRANGANSSMeasurementValueInfo,
        TUTRANGANSSMeasurementValueInfo_ExtIEs,
        _TUTRANGANSS_ms_part,
        _TUTRANGANSS_ls_part,
        TUTRANGANSS,
        _AdditionalMeasurementInforLCR_timingAdvanceLCR_R7,
        _AdditionalMeasurementInforLCR_rxTimingDeviationLCR,
        _AdditionalMeasurementInforLCR_angleOfArrivalLCR,
        ____AdditionalMeasurementInforLCR_iE_Extensions__item__id_tab,
        ___AdditionalMeasurementInforLCR_iE_Extensions__item__id,
        ____AdditionalMeasurementInforLCR_iE_Extensions__item__criticality_tab,
        ___AdditionalMeasurementInforLCR_iE_Extensions__item__criticality,
        ____AdditionalMeasurementInforLCR_iE_Extensions__item__extensionValue_tab,
        ___AdditionalMeasurementInforLCR_iE_Extensions__item__extensionValue,
        __AdditionalMeasurementInforLCR_iE_Extensions__item_,
        _AdditionalMeasurementInforLCR_iE_Extensions,
        AdditionalMeasurementInforLCR,
        AdditionalMeasurementInforLCR_ExtIEs,
        TimingAdvanceLCR_R7,
        _PeriodicPosCalcInfo_referenceNumber,
        _PeriodicPosCalcInfo_amountOutstandingRequests,
        _PeriodicPosCalcInfo_reportingInterval,
        ____PeriodicPosCalcInfo_iE_Extensions__item__id_tab,
        ___PeriodicPosCalcInfo_iE_Extensions__item__id,
        ____PeriodicPosCalcInfo_iE_Extensions__item__criticality_tab,
        ___PeriodicPosCalcInfo_iE_Extensions__item__criticality,
        ____PeriodicPosCalcInfo_iE_Extensions__item__extensionValue_tab,
        ___PeriodicPosCalcInfo_iE_Extensions__item__extensionValue,
        __PeriodicPosCalcInfo_iE_Extensions__item_,
        _PeriodicPosCalcInfo_iE_Extensions,
        PeriodicPosCalcInfo,
        PeriodicPosCalcInfo_ExtIEs,
        _PeriodicLocationInfo_reportingAmount,
        _PeriodicLocationInfo_reportingInterval,
        ____PeriodicLocationInfo_iE_Extensions__item__id_tab,
        ___PeriodicLocationInfo_iE_Extensions__item__id,
        ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab,
        ___PeriodicLocationInfo_iE_Extensions__item__criticality,
        ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab,
        ___PeriodicLocationInfo_iE_Extensions__item__extensionValue,
        __PeriodicLocationInfo_iE_Extensions__item_,
        _PeriodicLocationInfo_iE_Extensions,
        PeriodicLocationInfo,
        PeriodicLocationInfo_ExtIEs,
        PeriodicTerminationCause,
        _PositioningMethod_additionalMethodType,
        _PositioningMethod_selectedPositionMethod,
        ____PositioningMethod_iE_Extensions__item__id_tab,
        _____PositioningMethod_iE_Extensions__item__id_tab_val_Extension_0,
        _____PositioningMethod_iE_Extensions__item__id_tab_val_Extension_1,
        ___PositioningMethod_iE_Extensions__item__id,
        ___PositioningMethod_iE_Extensions__item__criticality,
        ___PositioningMethod_iE_Extensions__item__extensionValue,
        __PositioningMethod_iE_Extensions__item_,
        _PositioningMethod_iE_Extensions,
        PositioningMethod,
        PositioningMethod_ExtIEs,
        _PositioningMethod_ExtIEs_val_Extension_0,
        _PositioningMethod_ExtIEs_val_Extension_1,
        GNSS_PositioningMethod,
        Additional_PositioningMethod,
        SelectedPositionMethod,
        PositioningPriority,
        _RRCstateChange_new_ue_State,
        ____RRCstateChange_iE_Extensions__item__id_tab,
        ___RRCstateChange_iE_Extensions__item__id,
        ____RRCstateChange_iE_Extensions__item__criticality_tab,
        ___RRCstateChange_iE_Extensions__item__criticality,
        ____RRCstateChange_iE_Extensions__item__extensionValue_tab,
        ___RRCstateChange_iE_Extensions__item__extensionValue,
        __RRCstateChange_iE_Extensions__item_,
        _RRCstateChange_iE_Extensions,
        RRCstateChange,
        RRCstateChange_ExtIEs,
        _RequestedDataValue_gpsAlmanacAndSatelliteHealth,
        _RequestedDataValue_gps_UTC_Model,
        _RequestedDataValue_gps_Ionospheric_Model,
        _RequestedDataValue_gps_NavigationModel,
        _RequestedDataValue_dgpsCorrections,
        _RequestedDataValue_referenceTime,
        _RequestedDataValue_gps_AcquisitionAssistance,
        _RequestedDataValue_gps_RealTime_Integrity,
        _RequestedDataValue_almanacAndSatelliteHealthSIB,
        _RequestedDataValue_gps_Transmission_TOW,
        ____RequestedDataValue_iE_Extensions__item__id_tab,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_0,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_1,
        _____RequestedDataValue_iE_Extensions__item__id_tab_val_Extension_2,
        ___RequestedDataValue_iE_Extensions__item__id,
        ___RequestedDataValue_iE_Extensions__item__criticality,
        ___RequestedDataValue_iE_Extensions__item__extensionValue,
        __RequestedDataValue_iE_Extensions__item_,
        _RequestedDataValue_iE_Extensions,
        RequestedDataValue,
        RequestedDataValue_ExtIEs,
        _RequestedDataValue_ExtIEs_val_Extension_0,
        _RequestedDataValue_ExtIEs_val_Extension_1,
        _RequestedDataValue_ExtIEs_val_Extension_2,
        _RequestedDataValueInformation_informationAvailable,
        _RequestedDataValueInformation_informationNotAvailable,
        RequestedDataValueInformation,
        _InformationAvailable_requestedDataValue,
        ____InformationAvailable_iE_Extensions__item__id_tab,
        ___InformationAvailable_iE_Extensions__item__id,
        ____InformationAvailable_iE_Extensions__item__criticality_tab,
        ___InformationAvailable_iE_Extensions__item__criticality,
        ____InformationAvailable_iE_Extensions__item__extensionValue_tab,
        ___InformationAvailable_iE_Extensions__item__extensionValue,
        __InformationAvailable_iE_Extensions__item_,
        _InformationAvailable_iE_Extensions,
        InformationAvailable,
        InformationAvailable_ExtIEs,
        InformationNotAvailable,
        _RequestType_event,
        _RequestType_reportArea,
        _RequestType_horizontalaccuracyCode,
        ____RequestType_iE_Extensions__item__id_tab,
        ___RequestType_iE_Extensions__item__id,
        ____RequestType_iE_Extensions__item__criticality_tab,
        ___RequestType_iE_Extensions__item__criticality,
        ____RequestType_iE_Extensions__item__extensionValue_tab,
        ___RequestType_iE_Extensions__item__extensionValue,
        __RequestType_iE_Extensions__item_,
        _RequestType_iE_Extensions,
        RequestType,
        RequestType_ExtIEs,
        RequestTypeEvent,
        RequestTypeReportArea,
        RequestTypeAccuracyCode,
        ResponseTime,
        HorizontalAccuracyCode,
        _UE_PositioningCapability_standAloneLocationMethodsSupported,
        _UE_PositioningCapability_ueBasedOTDOASupported,
        _UE_PositioningCapability_networkAssistedGPSSupport,
        _UE_PositioningCapability_supportGPSTimingOfCellFrame,
        _UE_PositioningCapability_supportForIPDL,
        _UE_PositioningCapability_supportForRxTxTimeDiff,
        _UE_PositioningCapability_supportForUEAGPSinCellPCH,
        _UE_PositioningCapability_supportForSFNSFNTimeDiff,
        ____UE_PositioningCapability_iE_Extensions__item__id_tab,
        _____UE_PositioningCapability_iE_Extensions__item__id_tab_val_Extension_0,
        _____UE_PositioningCapability_iE_Extensions__item__id_tab_val_Extension_1,
        ___UE_PositioningCapability_iE_Extensions__item__id,
        ___UE_PositioningCapability_iE_Extensions__item__criticality,
        ___UE_PositioningCapability_iE_Extensions__item__extensionValue,
        __UE_PositioningCapability_iE_Extensions__item_,
        _UE_PositioningCapability_iE_Extensions,
        UE_PositioningCapability,
        UE_PositioningCapability_ExtIEs,
        _UE_PositioningCapability_ExtIEs_val_Extension_0,
        _UE_PositioningCapability_ExtIEs_val_Extension_1,
        __NetworkAssistedGANSSSupport__item__ganssID,
        __NetworkAssistedGANSSSupport__item__ganssMode,
        __NetworkAssistedGANSSSupport__item__ganssSignalID,
        __NetworkAssistedGANSSSupport__item__supportGANSSTimingOfCellFrame,
        __NetworkAssistedGANSSSupport__item__supportGANSSCarrierPhaseMeasurement,
        _____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab,
        ______NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab_val_Extension_0,
        ______NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab_val_Extension_1,
        ______NetworkAssistedGANSSSupport__item__iE_Extensions__item__id_tab_val_Extension_2,
        ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__id,
        ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__criticality,
        ____NetworkAssistedGANSSSupport__item__iE_Extensions__item__extensionValue,
        ___NetworkAssistedGANSSSupport__item__iE_Extensions__item_,
        __NetworkAssistedGANSSSupport__item__iE_Extensions,
        _NetworkAssistedGANSSSupport__item_,
        NetworkAssistedGANSSSupport,
        _AddPosSupport__item_,
        AddPosSupport,
        _AddPosSupport_Element_addPosID,
        _AddPosSupport_Element_addPosMode,
        AddPosSupport_Element,
        NetworkAssistedGANSSSuport_ExtIEs,
        _NetworkAssistedGANSSSuport_ExtIEs_val_Extension_0,
        _NetworkAssistedGANSSSuport_ExtIEs_val_Extension_1,
        _NetworkAssistedGANSSSuport_ExtIEs_val_Extension_2,
        NetworkAssistedGPSSuport,
        _GANSS_SBAS_IDs_ganss_sbas_ids,
        ____GANSS_SBAS_IDs_iE_Extensions__item__id_tab,
        ___GANSS_SBAS_IDs_iE_Extensions__item__id,
        ____GANSS_SBAS_IDs_iE_Extensions__item__criticality_tab,
        ___GANSS_SBAS_IDs_iE_Extensions__item__criticality,
        ____GANSS_SBAS_IDs_iE_Extensions__item__extensionValue_tab,
        ___GANSS_SBAS_IDs_iE_Extensions__item__extensionValue,
        __GANSS_SBAS_IDs_iE_Extensions__item_,
        _GANSS_SBAS_IDs_iE_Extensions,
        GANSS_SBAS_IDs,
        GANSS_SBAS_IDs_ExtIEs,
        _GANSS_Signal_IDs_ganss_signal_ids,
        ____GANSS_Signal_IDs_iE_Extensions__item__id_tab,
        ___GANSS_Signal_IDs_iE_Extensions__item__id,
        ____GANSS_Signal_IDs_iE_Extensions__item__criticality_tab,
        ___GANSS_Signal_IDs_iE_Extensions__item__criticality,
        ____GANSS_Signal_IDs_iE_Extensions__item__extensionValue_tab,
        ___GANSS_Signal_IDs_iE_Extensions__item__extensionValue,
        __GANSS_Signal_IDs_iE_Extensions__item_,
        _GANSS_Signal_IDs_iE_Extensions,
        GANSS_Signal_IDs,
        GANSS_Signal_IDs_ExtIEs,
        SupportGANSSNonNativeADchoices,
        _UTDOAPositioning_utdoa_BitCount,
        _UTDOAPositioning_utdoa_timeInterval,
        ____UTDOAPositioning_iE_Extensions__item__id_tab,
        ___UTDOAPositioning_iE_Extensions__item__id,
        ____UTDOAPositioning_iE_Extensions__item__criticality_tab,
        ___UTDOAPositioning_iE_Extensions__item__criticality,
        ____UTDOAPositioning_iE_Extensions__item__extensionValue_tab,
        ___UTDOAPositioning_iE_Extensions__item__extensionValue,
        __UTDOAPositioning_iE_Extensions__item_,
        _UTDOAPositioning_iE_Extensions,
        UTDOAPositioning,
        UTDOAPositioning_ExtIEs,
        UTDOA_BitCount,
        UTDOA_TimeInterval,
        EnvironmentCharacterisation,
        _GPSPositioning_gpsPositioningInstructions,
        _GPSPositioning_requestedDataValue,
        ____GPSPositioning_iE_Extensions__item__id_tab,
        ___GPSPositioning_iE_Extensions__item__id,
        ____GPSPositioning_iE_Extensions__item__criticality_tab,
        ___GPSPositioning_iE_Extensions__item__criticality,
        ____GPSPositioning_iE_Extensions__item__extensionValue_tab,
        ___GPSPositioning_iE_Extensions__item__extensionValue,
        __GPSPositioning_iE_Extensions__item_,
        _GPSPositioning_iE_Extensions,
        GPSPositioning,
        GPSPositioning_ExtIEs,
        _GPSPositioningInstructions_horizontalAccuracyCode,
        _GPSPositioningInstructions_verticalAccuracyCode,
        _GPSPositioningInstructions_gpsTimingOfCellWanted,
        _GPSPositioningInstructions_additionalAssistanceDataRequest,
        ____GPSPositioningInstructions_iE_Extensions__item__id_tab,
        _____GPSPositioningInstructions_iE_Extensions__item__id_tab_val_Extension_0,
        ___GPSPositioningInstructions_iE_Extensions__item__id,
        ___GPSPositioningInstructions_iE_Extensions__item__criticality,
        ___GPSPositioningInstructions_iE_Extensions__item__extensionValue,
        __GPSPositioningInstructions_iE_Extensions__item_,
        _GPSPositioningInstructions_iE_Extensions,
        GPSPositioningInstructions,
        GPSPositioningInstructions_ExtIEs,
        _GPSPositioningInstructions_ExtIEs_val_Extension_0,
        _GANSSPositioning_ganssPositioningInstructions,
        _GANSSPositioning_requestedDataValue,
        ____GANSSPositioning_iE_Extensions__item__id_tab,
        ___GANSSPositioning_iE_Extensions__item__id,
        ____GANSSPositioning_iE_Extensions__item__criticality_tab,
        ___GANSSPositioning_iE_Extensions__item__criticality,
        ____GANSSPositioning_iE_Extensions__item__extensionValue_tab,
        ___GANSSPositioning_iE_Extensions__item__extensionValue,
        __GANSSPositioning_iE_Extensions__item_,
        _GANSSPositioning_iE_Extensions,
        GANSSPositioning,
        GANSSPositioning_ExtIEs,
        _GANSS_PositioningInstructions_horizontalAccuracyCode,
        _GANSS_PositioningInstructions_verticalAccuracyCode,
        _GANSS_PositioningInstructions_ganssTimingOfCellWanted,
        _GANSS_PositioningInstructions_additionalAssistanceDataRequest,
        _GANSS_PositioningInstructions_measurementValidity,
        ____GANSS_PositioningInstructions_iE_Extensions__item__id_tab,
        _____GANSS_PositioningInstructions_iE_Extensions__item__id_tab_val_Extension_0,
        _____GANSS_PositioningInstructions_iE_Extensions__item__id_tab_val_Extension_1,
        ___GANSS_PositioningInstructions_iE_Extensions__item__id,
        ___GANSS_PositioningInstructions_iE_Extensions__item__criticality,
        ___GANSS_PositioningInstructions_iE_Extensions__item__extensionValue,
        __GANSS_PositioningInstructions_iE_Extensions__item_,
        _GANSS_PositioningInstructions_iE_Extensions,
        GANSS_PositioningInstructions,
        GANSS_PositioningInstructions_ExtIEs,
        _GANSS_PositioningInstructions_ExtIEs_val_Extension_0,
        _GANSS_PositioningInstructions_ExtIEs_val_Extension_1,
        GANSScarrierPhaseRequested,
        GANSSMultiFreqMeasRequested,
        _OTDOAAssistanceData_uE_Positioning_OTDOA_AssistanceData,
        ____OTDOAAssistanceData_iE_Extensions__item__id_tab,
        ___OTDOAAssistanceData_iE_Extensions__item__id,
        ____OTDOAAssistanceData_iE_Extensions__item__criticality_tab,
        ___OTDOAAssistanceData_iE_Extensions__item__criticality,
        ____OTDOAAssistanceData_iE_Extensions__item__extensionValue_tab,
        ___OTDOAAssistanceData_iE_Extensions__item__extensionValue,
        __OTDOAAssistanceData_iE_Extensions__item_,
        _OTDOAAssistanceData_iE_Extensions,
        OTDOAAssistanceData,
        OTDOAAssistanceData_ExtIEs,
        _UE_Positioning_OTDOA_AssistanceData_ue_positioning_OTDOA_ReferenceCellInfo,
        _UE_Positioning_OTDOA_AssistanceData_ue_positioning_OTDOA_NeighbourCellList,
        ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__id_tab,
        ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__id,
        ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__criticality_tab,
        ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__criticality,
        ____UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__extensionValue_tab,
        ___UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item__extensionValue,
        __UE_Positioning_OTDOA_AssistanceData_iE_Extensions__item_,
        _UE_Positioning_OTDOA_AssistanceData_iE_Extensions,
        UE_Positioning_OTDOA_AssistanceData,
        UE_Positioning_OTDOAAssistanceData_ExtIEs,
        _UE_Positioning_OTDOA_ReferenceCellInfo_sfn,
        ___UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_fdd_primaryCPICH_Info,
        __UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_fdd,
        ___UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_tdd_cellParameterID,
        __UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo_tdd,
        _UE_Positioning_OTDOA_ReferenceCellInfo_modeSpecificInfo,
        _UE_Positioning_OTDOA_ReferenceCellInfo_frequencyInfo,
        ___UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased_cellPosition,
        ___UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased_roundTripTime,
        __UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueBased,
        __UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode_ueAssisted,
        _UE_Positioning_OTDOA_ReferenceCellInfo_positioningMode,
        _UE_Positioning_OTDOA_ReferenceCellInfo_ue_positioning_IPDL_Paremeters,
        ____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab,
        _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_0,
        _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_1,
        _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_2,
        _____UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id_tab_val_Extension_3,
        ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__id,
        ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__criticality,
        ___UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item__extensionValue,
        __UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions__item_,
        _UE_Positioning_OTDOA_ReferenceCellInfo_iE_Extensions,
        UE_Positioning_OTDOA_ReferenceCellInfo,
        UE_Positioning_OTDOAReferenceCellInfo_ExtIEs,
        _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_0,
        _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_1,
        _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_2,
        _UE_Positioning_OTDOAReferenceCellInfo_ExtIEs_val_Extension_3,
        _ReferenceCellPosition_ellipsoidPoint,
        _ReferenceCellPosition_ellipsoidPointWithAltitude,
        ReferenceCellPosition,
        ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_ip_Spacing,
        ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_ip_Length,
        ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_ip_Offset,
        ___UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd_seed,
        __UE_Positioning_IPDL_Parameters_modeSpecificInfo_fdd,
        __UE_Positioning_IPDL_Parameters_modeSpecificInfo_tdd,
        _UE_Positioning_IPDL_Parameters_modeSpecificInfo,
        _UE_Positioning_IPDL_Parameters_burstModeParameters,
        ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__id_tab,
        ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__id,
        ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__criticality_tab,
        ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__criticality,
        ____UE_Positioning_IPDL_Parameters_iE_Extensions__item__extensionValue_tab,
        ___UE_Positioning_IPDL_Parameters_iE_Extensions__item__extensionValue,
        __UE_Positioning_IPDL_Parameters_iE_Extensions__item_,
        _UE_Positioning_IPDL_Parameters_iE_Extensions,
        UE_Positioning_IPDL_Parameters,
        UE_Positioning_IPDL_Parameters_ExtIEs,
        IP_Spacing,
        IP_Length,
        _BurstModeParameters_burstStart,
        _BurstModeParameters_burstLength,
        _BurstModeParameters_burstFreq,
        ____BurstModeParameters_iE_Extensions__item__id_tab,
        ___BurstModeParameters_iE_Extensions__item__id,
        ____BurstModeParameters_iE_Extensions__item__criticality_tab,
        ___BurstModeParameters_iE_Extensions__item__criticality,
        ____BurstModeParameters_iE_Extensions__item__extensionValue_tab,
        ___BurstModeParameters_iE_Extensions__item__extensionValue,
        __BurstModeParameters_iE_Extensions__item_,
        _BurstModeParameters_iE_Extensions,
        BurstModeParameters,
        BurstModeParameters_ExtIEs,
        _UE_Positioning_OTDOA_NeighbourCellList__item_,
        UE_Positioning_OTDOA_NeighbourCellList,
        ___UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_fdd_primaryCPICH_Info,
        __UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_fdd,
        ___UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_tdd_cellParameterID,
        __UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo_tdd,
        _UE_Positioning_OTDOA_NeighbourCellInfo_modeSpecificInfo,
        _UE_Positioning_OTDOA_NeighbourCellInfo_frequencyInfo,
        _UE_Positioning_OTDOA_NeighbourCellInfo_ue_positioning_IPDL_Paremeters,
        _UE_Positioning_OTDOA_NeighbourCellInfo_sfn_SFN_RelTimeDifference,
        _UE_Positioning_OTDOA_NeighbourCellInfo_sfn_Offset_Validity,
        _UE_Positioning_OTDOA_NeighbourCellInfo_sfn_SFN_Drift,
        _UE_Positioning_OTDOA_NeighbourCellInfo_searchWindowSize,
        ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeNorth,
        ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeEast,
        ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_relativeAltitude,
        ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_fineSFN_SFN,
        ___UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased_roundTripTime,
        __UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueBased,
        __UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode_ueAssisted,
        _UE_Positioning_OTDOA_NeighbourCellInfo_positioningMode,
        ____UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab,
        _____UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id_tab_val_Extension_0,
        ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__id,
        ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__criticality,
        ___UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item__extensionValue,
        __UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions__item_,
        _UE_Positioning_OTDOA_NeighbourCellInfo_iE_Extensions,
        UE_Positioning_OTDOA_NeighbourCellInfo,
        UE_Positioning_OTDOANeighbourCellInfo_ExtIEs,
        _UE_Positioning_OTDOANeighbourCellInfo_ExtIEs_val_Extension_0,
        _SFN_SFN_RelTimeDifference1_sfn_Offset,
        _SFN_SFN_RelTimeDifference1_sfn_sfn_Reltimedifference,
        ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__id_tab,
        ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__id,
        ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__criticality_tab,
        ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__criticality,
        ____SFN_SFN_RelTimeDifference1_iE_Extensions__item__extensionValue_tab,
        ___SFN_SFN_RelTimeDifference1_iE_Extensions__item__extensionValue,
        __SFN_SFN_RelTimeDifference1_iE_Extensions__item_,
        _SFN_SFN_RelTimeDifference1_iE_Extensions,
        SFN_SFN_RelTimeDifference1,
        SFN_SFN_RelTimeDifference1_ExtIEs,
        SFN_Offset_Validity,
        OTDOA_SearchWindowSize,
        SFN_SFN_Drift,
        FineSFNSFN,
        VerticalAccuracyCode,
        _UTDOA_Group_uC_ID,
        _UTDOA_Group_frequencyInfo,
        _UTDOA_Group_uTDOA_ChannelSettings,
        ____UTDOA_Group_iE_Extensions__item__id_tab,
        ___UTDOA_Group_iE_Extensions__item__id,
        ____UTDOA_Group_iE_Extensions__item__criticality_tab,
        ___UTDOA_Group_iE_Extensions__item__criticality,
        ____UTDOA_Group_iE_Extensions__item__extensionValue_tab,
        ___UTDOA_Group_iE_Extensions__item__extensionValue,
        __UTDOA_Group_iE_Extensions__item_,
        _UTDOA_Group_iE_Extensions,
        UTDOA_Group,
        UTDOA_Group_ExtIEs,
        __FrequencyInfo_modeSpecificInfo_fdd,
        __FrequencyInfo_modeSpecificInfo_tdd,
        _FrequencyInfo_modeSpecificInfo,
        ____FrequencyInfo_iE_Extensions__item__id_tab,
        ___FrequencyInfo_iE_Extensions__item__id,
        ____FrequencyInfo_iE_Extensions__item__criticality_tab,
        ___FrequencyInfo_iE_Extensions__item__criticality,
        ____FrequencyInfo_iE_Extensions__item__extensionValue_tab,
        ___FrequencyInfo_iE_Extensions__item__extensionValue,
        __FrequencyInfo_iE_Extensions__item_,
        _FrequencyInfo_iE_Extensions,
        FrequencyInfo,
        FrequencyInfo_ExtIEs,
        _FrequencyInfoFDD_uarfcn_UL,
        _FrequencyInfoFDD_uarfcn_DL,
        ____FrequencyInfoFDD_iE_Extensions__item__id_tab,
        ___FrequencyInfoFDD_iE_Extensions__item__id,
        ____FrequencyInfoFDD_iE_Extensions__item__criticality_tab,
        ___FrequencyInfoFDD_iE_Extensions__item__criticality,
        ____FrequencyInfoFDD_iE_Extensions__item__extensionValue_tab,
        ___FrequencyInfoFDD_iE_Extensions__item__extensionValue,
        __FrequencyInfoFDD_iE_Extensions__item_,
        _FrequencyInfoFDD_iE_Extensions,
        FrequencyInfoFDD,
        FrequencyInfoFDD_ExtIEs,
        _FrequencyInfoTDD_uarfcn,
        ____FrequencyInfoTDD_iE_Extensions__item__id_tab,
        ___FrequencyInfoTDD_iE_Extensions__item__id,
        ____FrequencyInfoTDD_iE_Extensions__item__criticality_tab,
        ___FrequencyInfoTDD_iE_Extensions__item__criticality,
        ____FrequencyInfoTDD_iE_Extensions__item__extensionValue_tab,
        ___FrequencyInfoTDD_iE_Extensions__item__extensionValue,
        __FrequencyInfoTDD_iE_Extensions__item_,
        _FrequencyInfoTDD_iE_Extensions,
        FrequencyInfoTDD,
        FrequencyInfoTDD_ExtIEs,
        _UTDOA_RRCState_uTDOA_CELLDCH,
        _UTDOA_RRCState_uTDOA_CELLFACH,
        UTDOA_RRCState,
        _UTDOA_CELLDCH_uL_DPCHInfo,
        _UTDOA_CELLDCH_compressedModeAssistanceData,
        _UTDOA_CELLDCH_dCH_Information,
        _UTDOA_CELLDCH_e_DPCH_Information,
        ____UTDOA_CELLDCH_iE_Extensions__item__id_tab,
        ___UTDOA_CELLDCH_iE_Extensions__item__id,
        ____UTDOA_CELLDCH_iE_Extensions__item__criticality_tab,
        ___UTDOA_CELLDCH_iE_Extensions__item__criticality,
        ____UTDOA_CELLDCH_iE_Extensions__item__extensionValue_tab,
        ___UTDOA_CELLDCH_iE_Extensions__item__extensionValue,
        __UTDOA_CELLDCH_iE_Extensions__item_,
        _UTDOA_CELLDCH_iE_Extensions,
        UTDOA_CELLDCH,
        UTDOA_CELLDCH_ExtIEs,
        __UL_DPCHInfo_fdd_scramblingCodeType,
        __UL_DPCHInfo_fdd_scramblingCode,
        __UL_DPCHInfo_fdd_tfci_Existence,
        __UL_DPCHInfo_fdd_numberOfFBI_Bits,
        _____UL_DPCHInfo_fdd_iE_Extensions__item__id_tab,
        ____UL_DPCHInfo_fdd_iE_Extensions__item__id,
        _____UL_DPCHInfo_fdd_iE_Extensions__item__criticality_tab,
        ____UL_DPCHInfo_fdd_iE_Extensions__item__criticality,
        _____UL_DPCHInfo_fdd_iE_Extensions__item__extensionValue_tab,
        ____UL_DPCHInfo_fdd_iE_Extensions__item__extensionValue,
        ___UL_DPCHInfo_fdd_iE_Extensions__item_,
        __UL_DPCHInfo_fdd_iE_Extensions,
        _UL_DPCHInfo_fdd,
        __UL_DPCHInfo_tdd_cellParameterID,
        __UL_DPCHInfo_tdd_tFCI_Coding,
        __UL_DPCHInfo_tdd_punctureLimit,
        __UL_DPCHInfo_tdd_repetitionPeriod,
        __UL_DPCHInfo_tdd_repetitionLength,
        __UL_DPCHInfo_tdd_tdd_DPCHOffset,
        __UL_DPCHInfo_tdd_uL_Timeslot_Information,
        __UL_DPCHInfo_tdd_frameOffset,
        __UL_DPCHInfo_tdd_specialBurstScheduling,
        _____UL_DPCHInfo_tdd_iE_Extensions__item__id_tab,
        ____UL_DPCHInfo_tdd_iE_Extensions__item__id,
        _____UL_DPCHInfo_tdd_iE_Extensions__item__criticality_tab,
        ____UL_DPCHInfo_tdd_iE_Extensions__item__criticality,
        _____UL_DPCHInfo_tdd_iE_Extensions__item__extensionValue_tab,
        ____UL_DPCHInfo_tdd_iE_Extensions__item__extensionValue,
        ___UL_DPCHInfo_tdd_iE_Extensions__item_,
        __UL_DPCHInfo_tdd_iE_Extensions,
        _UL_DPCHInfo_tdd,
        UL_DPCHInfo,
        UL_DPCHInfoFDD_ExtIEs,
        UL_DPCHInfoTDD_ExtIEs,
        _Compressed_Mode_Assistance_Data_dl_information,
        _Compressed_Mode_Assistance_Data_ul_information,
        ____Compressed_Mode_Assistance_Data_iE_Extensions__item__id_tab,
        ___Compressed_Mode_Assistance_Data_iE_Extensions__item__id,
        ____Compressed_Mode_Assistance_Data_iE_Extensions__item__criticality_tab,
        ___Compressed_Mode_Assistance_Data_iE_Extensions__item__criticality,
        ____Compressed_Mode_Assistance_Data_iE_Extensions__item__extensionValue_tab,
        ___Compressed_Mode_Assistance_Data_iE_Extensions__item__extensionValue,
        __Compressed_Mode_Assistance_Data_iE_Extensions__item_,
        _Compressed_Mode_Assistance_Data_iE_Extensions,
        Compressed_Mode_Assistance_Data,
        Compressed_Mode_Assistance_DataFDD_ExtIEs,
        _DL_InformationFDD_primaryScramblingCode,
        _DL_InformationFDD_chipOffset,
        _DL_InformationFDD_frameOffset,
        ____DL_InformationFDD_iE_Extensions__item__id_tab,
        ___DL_InformationFDD_iE_Extensions__item__id,
        ____DL_InformationFDD_iE_Extensions__item__criticality_tab,
        ___DL_InformationFDD_iE_Extensions__item__criticality,
        ____DL_InformationFDD_iE_Extensions__item__extensionValue_tab,
        ___DL_InformationFDD_iE_Extensions__item__extensionValue,
        __DL_InformationFDD_iE_Extensions__item_,
        _DL_InformationFDD_iE_Extensions,
        DL_InformationFDD,
        DL_InformationFDD_ExtIEs,
        _UL_InformationFDD_transmissionGapPatternSequenceInfo,
        _UL_InformationFDD_activePatternSequenceInfo,
        _UL_InformationFDD_cFN,
        ____UL_InformationFDD_iE_Extensions__item__id_tab,
        ___UL_InformationFDD_iE_Extensions__item__id,
        ____UL_InformationFDD_iE_Extensions__item__criticality_tab,
        ___UL_InformationFDD_iE_Extensions__item__criticality,
        ____UL_InformationFDD_iE_Extensions__item__extensionValue_tab,
        ___UL_InformationFDD_iE_Extensions__item__extensionValue,
        __UL_InformationFDD_iE_Extensions__item_,
        _UL_InformationFDD_iE_Extensions,
        UL_InformationFDD,
        UL_InformationFDD_ExtIEs,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGPSID,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGSN,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGL1,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGL2,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGD,
        __Transmission_Gap_Pattern_Sequence_Information__item__tGPL1,
        __Transmission_Gap_Pattern_Sequence_Information__item__uplink_Compressed_Mode_Method,
        _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id_tab,
        ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__id,
        _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality_tab,
        ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__criticality,
        _____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue_tab,
        ____Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item__extensionValue,
        ___Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions__item_,
        __Transmission_Gap_Pattern_Sequence_Information__item__iE_Extensions,
        _Transmission_Gap_Pattern_Sequence_Information__item_,
        Transmission_Gap_Pattern_Sequence_Information,
        Transmission_Gap_Pattern_Sequence_Information_ExtIEs,
        TGD,
        TGPRC,
        TGPSID,
        TGSN,
        Uplink_Compressed_Mode_Method,
        GapDuration,
        GapLength,
        _Active_Pattern_Sequence_Information_cMConfigurationChangeCFN,
        _Active_Pattern_Sequence_Information_transmission_Gap_Pattern_Sequence_Status,
        ____Active_Pattern_Sequence_Information_iE_Extensions__item__id_tab,
        ___Active_Pattern_Sequence_Information_iE_Extensions__item__id,
        ____Active_Pattern_Sequence_Information_iE_Extensions__item__criticality_tab,
        ___Active_Pattern_Sequence_Information_iE_Extensions__item__criticality,
        ____Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue_tab,
        ___Active_Pattern_Sequence_Information_iE_Extensions__item__extensionValue,
        __Active_Pattern_Sequence_Information_iE_Extensions__item_,
        _Active_Pattern_Sequence_Information_iE_Extensions,
        Active_Pattern_Sequence_Information,
        Active_Pattern_Sequence_Information_ExtIEs,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPSID,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__tGPRC,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__tGCFN,
        _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id_tab,
        ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__id,
        _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality_tab,
        ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__criticality,
        _____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue_tab,
        ____Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item__extensionValue,
        ___Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions__item_,
        __Transmission_Gap_Pattern_Sequence_Status_List__item__iE_Extensions,
        _Transmission_Gap_Pattern_Sequence_Status_List__item_,
        Transmission_Gap_Pattern_Sequence_Status_List,
        Transmission_Gap_Pattern_Sequence_Status_List_ExtIEs,
        _DCH_Information_tFCS,
        _DCH_Information_trChInfo,
        ____DCH_Information_iE_Extensions__item__id_tab,
        ___DCH_Information_iE_Extensions__item__id,
        ____DCH_Information_iE_Extensions__item__criticality_tab,
        ___DCH_Information_iE_Extensions__item__criticality,
        ____DCH_Information_iE_Extensions__item__extensionValue_tab,
        ___DCH_Information_iE_Extensions__item__extensionValue,
        __DCH_Information_iE_Extensions__item_,
        _DCH_Information_iE_Extensions,
        DCH_Information,
        DCH_Information_ExtIEs,
        _TrChInfoList__item_,
        TrChInfoList,
        _UL_TrCHInfo_uL_TrCHtype,
        _UL_TrCHInfo_tfs,
        ____UL_TrCHInfo_iE_Extensions__item__id_tab,
        ___UL_TrCHInfo_iE_Extensions__item__id,
        ____UL_TrCHInfo_iE_Extensions__item__criticality_tab,
        ___UL_TrCHInfo_iE_Extensions__item__criticality,
        ____UL_TrCHInfo_iE_Extensions__item__extensionValue_tab,
        ___UL_TrCHInfo_iE_Extensions__item__extensionValue,
        __UL_TrCHInfo_iE_Extensions__item_,
        _UL_TrCHInfo_iE_Extensions,
        UL_TrCHInfo,
        UL_TrCHInfo_ExtIEs,
        UL_TrCHType,
        _E_DPCH_Information_maxSet_E_DPDCHs,
        _E_DPCH_Information_ul_PunctureLimit,
        _E_DPCH_Information_e_TFCS_Information,
        _E_DPCH_Information_e_TTI,
        _E_DPCH_Information_e_DPCCH_PO,
        ____E_DPCH_Information_iE_Extensions__item__id_tab,
        ___E_DPCH_Information_iE_Extensions__item__id,
        ____E_DPCH_Information_iE_Extensions__item__criticality_tab,
        ___E_DPCH_Information_iE_Extensions__item__criticality,
        ____E_DPCH_Information_iE_Extensions__item__extensionValue_tab,
        ___E_DPCH_Information_iE_Extensions__item__extensionValue,
        __E_DPCH_Information_iE_Extensions__item_,
        _E_DPCH_Information_iE_Extensions,
        E_DPCH_Information,
        E_DPCH_Information_ExtIEs,
        Max_Set_E_DPDCHs,
        _E_TFCS_Information_e_DCH_TFCS_Index,
        _E_TFCS_Information_reference_E_TFCI_Information,
        ____E_TFCS_Information_iE_Extensions__item__id_tab,
        ___E_TFCS_Information_iE_Extensions__item__id,
        ____E_TFCS_Information_iE_Extensions__item__criticality_tab,
        ___E_TFCS_Information_iE_Extensions__item__criticality,
        ____E_TFCS_Information_iE_Extensions__item__extensionValue_tab,
        ___E_TFCS_Information_iE_Extensions__item__extensionValue,
        __E_TFCS_Information_iE_Extensions__item_,
        _E_TFCS_Information_iE_Extensions,
        E_TFCS_Information,
        E_TFCS_Information_ExtIEs,
        E_DCH_TFCS_Index,
        _Reference_E_TFCI_Information__item_,
        Reference_E_TFCI_Information,
        _Reference_E_TFCI_Information_Item_reference_E_TFCI,
        _Reference_E_TFCI_Information_Item_reference_E_TFCI_PO,
        ____Reference_E_TFCI_Information_Item_iE_Extensions__item__id_tab,
        ___Reference_E_TFCI_Information_Item_iE_Extensions__item__id,
        ____Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality_tab,
        ___Reference_E_TFCI_Information_Item_iE_Extensions__item__criticality,
        ____Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue_tab,
        ___Reference_E_TFCI_Information_Item_iE_Extensions__item__extensionValue,
        __Reference_E_TFCI_Information_Item_iE_Extensions__item_,
        _Reference_E_TFCI_Information_Item_iE_Extensions,
        Reference_E_TFCI_Information_Item,
        Reference_E_TFCI_Information_Item_ExtIEs,
        Reference_E_TFCI_PO,
        E_TFCI,
        E_TTI,
        E_DPCCH_PO,
        CellParameterID,
        TFCI_Coding,
        RepetitionLength,
        RepetitionPeriod,
        _TDD_DPCHOffset_initialOffset,
        _TDD_DPCHOffset_noinitialOffset,
        TDD_DPCHOffset,
        _UL_Timeslot_Information__item_,
        UL_Timeslot_Information,
        maxNrOfULTSs,
        _UL_Timeslot_InformationItem_timeSlot,
        _UL_Timeslot_InformationItem_midambleShiftAndBurstType,
        _UL_Timeslot_InformationItem_tFCI_Presence,
        _UL_Timeslot_InformationItem_uL_Code_InformationList,
        ____UL_Timeslot_InformationItem_iE_Extensions__item__id_tab,
        ___UL_Timeslot_InformationItem_iE_Extensions__item__id,
        ____UL_Timeslot_InformationItem_iE_Extensions__item__criticality_tab,
        ___UL_Timeslot_InformationItem_iE_Extensions__item__criticality,
        ____UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___UL_Timeslot_InformationItem_iE_Extensions__item__extensionValue,
        __UL_Timeslot_InformationItem_iE_Extensions__item_,
        _UL_Timeslot_InformationItem_iE_Extensions,
        UL_Timeslot_InformationItem,
        UL_Timeslot_InformationItem_ExtIEs,
        TimeSlot,
        __MidambleShiftAndBurstType_type1_midambleConfigurationBurstType1And3,
        ___MidambleShiftAndBurstType_type1_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType_type1_midambleAllocationMode_commonMidamble,
        ___MidambleShiftAndBurstType_type1_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType_type1_midambleAllocationMode,
        _MidambleShiftAndBurstType_type1,
        __MidambleShiftAndBurstType_type2_midambleConfigurationBurstType2,
        ___MidambleShiftAndBurstType_type2_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType_type2_midambleAllocationMode_commonMidamble,
        ___MidambleShiftAndBurstType_type2_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType_type2_midambleAllocationMode,
        _MidambleShiftAndBurstType_type2,
        __MidambleShiftAndBurstType_type3_midambleConfigurationBurstType1And3,
        ___MidambleShiftAndBurstType_type3_midambleAllocationMode_defaultMidamble,
        ___MidambleShiftAndBurstType_type3_midambleAllocationMode_ueSpecificMidamble,
        __MidambleShiftAndBurstType_type3_midambleAllocationMode,
        _MidambleShiftAndBurstType_type3,
        MidambleShiftAndBurstType,
        MidambleShiftLong,
        MidambleShiftShort,
        MidambleConfigurationBurstType1And3,
        MidambleConfigurationBurstType2,
        _TDD_UL_Code_Information__item_,
        TDD_UL_Code_Information,
        maxNrOfDPCHs,
        _TDD_UL_Code_InformationItem_tdd_ChannelisationCode,
        ____TDD_UL_Code_InformationItem_iE_Extensions__item__id_tab,
        ___TDD_UL_Code_InformationItem_iE_Extensions__item__id,
        ____TDD_UL_Code_InformationItem_iE_Extensions__item__criticality_tab,
        ___TDD_UL_Code_InformationItem_iE_Extensions__item__criticality,
        ____TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue_tab,
        ___TDD_UL_Code_InformationItem_iE_Extensions__item__extensionValue,
        __TDD_UL_Code_InformationItem_iE_Extensions__item_,
        _TDD_UL_Code_InformationItem_iE_Extensions,
        TDD_UL_Code_InformationItem,
        TDD_UL_Code_InformationItem_ExtIEs,
        TDD_ChannelisationCode,
        SpecialBurstScheduling,
        _UTDOA_CELLFACH_pRACHparameters,
        _UTDOA_CELLFACH_cRNTI,
        _UTDOA_CELLFACH_uschParameters,
        ____UTDOA_CELLFACH_iE_Extensions__item__id_tab,
        ___UTDOA_CELLFACH_iE_Extensions__item__id,
        ____UTDOA_CELLFACH_iE_Extensions__item__criticality_tab,
        ___UTDOA_CELLFACH_iE_Extensions__item__criticality,
        ____UTDOA_CELLFACH_iE_Extensions__item__extensionValue_tab,
        ___UTDOA_CELLFACH_iE_Extensions__item__extensionValue,
        __UTDOA_CELLFACH_iE_Extensions__item_,
        _UTDOA_CELLFACH_iE_Extensions,
        UTDOA_CELLFACH,
        UTDOA_CELLFACH_ExtIEs,
        _PRACHparameters__item_,
        PRACHparameters,
        _PRACH_ChannelInfo_pRACH_Info,
        _PRACH_ChannelInfo_tFS,
        _PRACH_ChannelInfo_tFCS,
        ____PRACH_ChannelInfo_iE_Extensions__item__id_tab,
        ___PRACH_ChannelInfo_iE_Extensions__item__id,
        ____PRACH_ChannelInfo_iE_Extensions__item__criticality_tab,
        ___PRACH_ChannelInfo_iE_Extensions__item__criticality,
        ____PRACH_ChannelInfo_iE_Extensions__item__extensionValue_tab,
        ___PRACH_ChannelInfo_iE_Extensions__item__extensionValue,
        __PRACH_ChannelInfo_iE_Extensions__item_,
        _PRACH_ChannelInfo_iE_Extensions,
        PRACH_ChannelInfo,
        PRACH_ChannelInfo_ExtIEs,
        __PRACH_Info_fdd_availableSignatures,
        __PRACH_Info_fdd_availableSF,
        __PRACH_Info_fdd_preambleScramblingCodeWordNumber,
        __PRACH_Info_fdd_puncturingLimit,
        __PRACH_Info_fdd_availableSubChannelNumbers,
        _____PRACH_Info_fdd_iE_Extensions__item__id_tab,
        ____PRACH_Info_fdd_iE_Extensions__item__id,
        _____PRACH_Info_fdd_iE_Extensions__item__criticality_tab,
        ____PRACH_Info_fdd_iE_Extensions__item__criticality,
        _____PRACH_Info_fdd_iE_Extensions__item__extensionValue_tab,
        ____PRACH_Info_fdd_iE_Extensions__item__extensionValue,
        ___PRACH_Info_fdd_iE_Extensions__item_,
        __PRACH_Info_fdd_iE_Extensions,
        _PRACH_Info_fdd,
        __PRACH_Info_tdd_timeSlot,
        __PRACH_Info_tdd_tdd_ChannelisationCode,
        __PRACH_Info_tdd_maxPRACH_MidambleShifts,
        __PRACH_Info_tdd_pRACH_Midamble,
        _____PRACH_Info_tdd_iE_Extensions__item__id_tab,
        ____PRACH_Info_tdd_iE_Extensions__item__id,
        _____PRACH_Info_tdd_iE_Extensions__item__criticality_tab,
        ____PRACH_Info_tdd_iE_Extensions__item__criticality,
        _____PRACH_Info_tdd_iE_Extensions__item__extensionValue_tab,
        ____PRACH_Info_tdd_iE_Extensions__item__extensionValue,
        ___PRACH_Info_tdd_iE_Extensions__item_,
        __PRACH_Info_tdd_iE_Extensions,
        _PRACH_Info_tdd,
        PRACH_Info,
        PRACH_Info_FDD_ExtIEs,
        PRACH_Info_TDD_ExtIEs,
        SF_PRACH,
        AvailableSignatures,
        PreambleScramblingCodeWordNumber,
        PuncturingLimit,
        AvailableSubChannelNumbers,
        ScramblingCodeType,
        UL_ScramblingCode,
        NumberOfFBI_Bits,
        _TransportFormatSet_dynamicPart,
        _TransportFormatSet_semi_staticPart,
        ____TransportFormatSet_iE_Extensions__item__id_tab,
        ___TransportFormatSet_iE_Extensions__item__id,
        ____TransportFormatSet_iE_Extensions__item__criticality_tab,
        ___TransportFormatSet_iE_Extensions__item__criticality,
        ____TransportFormatSet_iE_Extensions__item__extensionValue_tab,
        ___TransportFormatSet_iE_Extensions__item__extensionValue,
        __TransportFormatSet_iE_Extensions__item_,
        _TransportFormatSet_iE_Extensions,
        TransportFormatSet,
        TransportFormatSet_ExtIEs,
        __TransportFormatSet_DynamicPartList__item__rlc_Size,
        ___TransportFormatSet_DynamicPartList__item__numberOfTbsTTIList__item_,
        __TransportFormatSet_DynamicPartList__item__numberOfTbsTTIList,
        _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id_tab,
        ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__id,
        _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality_tab,
        ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__criticality,
        _____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue_tab,
        ____TransportFormatSet_DynamicPartList__item__iE_Extensions__item__extensionValue,
        ___TransportFormatSet_DynamicPartList__item__iE_Extensions__item_,
        __TransportFormatSet_DynamicPartList__item__iE_Extensions,
        _TransportFormatSet_DynamicPartList__item_,
        TransportFormatSet_DynamicPartList,
        TransportFormatSet_DynamicPartList_ExtIEs,
        _TbsTTIInfo_tTIInfo,
        _TbsTTIInfo_numberOfTbs,
        ____TbsTTIInfo_iE_Extensions__item__id_tab,
        ___TbsTTIInfo_iE_Extensions__item__id,
        ____TbsTTIInfo_iE_Extensions__item__criticality_tab,
        ___TbsTTIInfo_iE_Extensions__item__criticality,
        ____TbsTTIInfo_iE_Extensions__item__extensionValue_tab,
        ___TbsTTIInfo_iE_Extensions__item__extensionValue,
        __TbsTTIInfo_iE_Extensions__item_,
        _TbsTTIInfo_iE_Extensions,
        TbsTTIInfo,
        TbsTTIInfo_ExtIEs,
        RLC_Size,
        TransportFormatSet_NrOfTransportBlocks,
        _TransportFormatSet_Semi_staticPart_transmissionTimeInterval,
        _TransportFormatSet_Semi_staticPart_channelCoding,
        _TransportFormatSet_Semi_staticPart_codingRate,
        _TransportFormatSet_Semi_staticPart_rateMatchingAttribute,
        _TransportFormatSet_Semi_staticPart_cRC_Size,
        ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__id_tab,
        ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__id,
        ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality_tab,
        ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__criticality,
        ____TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue_tab,
        ___TransportFormatSet_Semi_staticPart_iE_Extensions__item__extensionValue,
        __TransportFormatSet_Semi_staticPart_iE_Extensions__item_,
        _TransportFormatSet_Semi_staticPart_iE_Extensions,
        TransportFormatSet_Semi_staticPart,
        TransportFormatSet_Semi_staticPart_ExtIEs,
        TransportFormatSet_TransmissionTimeIntervalSemiStatic,
        TransportFormatSet_ChannelCodingType,
        TransportFormatSet_CodingRate,
        TransportFormatSet_RateMatchingAttribute,
        TransportFormatSet_CRC_Size,
        TransportFormatSet_TransmissionTimeIntervalDynamic,
        _TFCS__item_,
        TFCS,
        __CTFC_ctfc2Bit__item_,
        _CTFC_ctfc2Bit,
        __CTFC_ctfc4Bit__item_,
        _CTFC_ctfc4Bit,
        __CTFC_ctfc6Bit__item_,
        _CTFC_ctfc6Bit,
        __CTFC_ctfc8Bit__item_,
        _CTFC_ctfc8Bit,
        __CTFC_ctfc12Bit__item_,
        _CTFC_ctfc12Bit,
        __CTFC_ctfc16Bit__item_,
        _CTFC_ctfc16Bit,
        __CTFC_ctfc24Bit__item_,
        _CTFC_ctfc24Bit,
        CTFC,
        C_RNTI,
        UARFCN,
        CFN,
        ChipOffset,
        FrameOffset,
        PrimaryScramblingCode,
        _UschParameters_cellParameterID,
        _UschParameters_tFCI_Coding,
        _UschParameters_punctureLimit,
        _UschParameters_repetitionPeriod,
        _UschParameters_uSCH_SchedulingOffset,
        _UschParameters_uL_Timeslot_Information,
        _UschParameters_tFCS,
        _UschParameters_trChInfo,
        ____UschParameters_iE_Extensions__item__id_tab,
        ___UschParameters_iE_Extensions__item__id,
        ____UschParameters_iE_Extensions__item__criticality_tab,
        ___UschParameters_iE_Extensions__item__criticality,
        ____UschParameters_iE_Extensions__item__extensionValue_tab,
        ___UschParameters_iE_Extensions__item__extensionValue,
        __UschParameters_iE_Extensions__item_,
        _UschParameters_iE_Extensions,
        UschParameters,
        UschParameters_ExtIEs,
        USCH_SchedulingOffset,
        MaxPRACH_MidambleShifts,
        PRACH_Midamble,
        Positioning_ResponseTime,
        AmountOfReporting,
        IncludeVelocity,
        _VelocityEstimate_horizontalVelocity,
        _VelocityEstimate_horizontalWithVerticalVelocity,
        _VelocityEstimate_horizontalVelocityWithUncertainty,
        _VelocityEstimate_horizontalWithVerticalVelocityAndUncertainty,
        VelocityEstimate,
        _HorizontalVelocity_horizontalSpeedAndBearing,
        ____HorizontalVelocity_iE_Extensions__item__id_tab,
        ___HorizontalVelocity_iE_Extensions__item__id,
        ____HorizontalVelocity_iE_Extensions__item__criticality_tab,
        ___HorizontalVelocity_iE_Extensions__item__criticality,
        ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab,
        ___HorizontalVelocity_iE_Extensions__item__extensionValue,
        __HorizontalVelocity_iE_Extensions__item_,
        _HorizontalVelocity_iE_Extensions,
        HorizontalVelocity,
        HorizontalVelocity_ExtIEs,
        _HorizontalWithVerticalVelocity_horizontalSpeedAndBearing,
        _HorizontalWithVerticalVelocity_verticalVelocity,
        ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab,
        ___HorizontalWithVerticalVelocity_iE_Extensions__item__id,
        ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab,
        ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality,
        ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab,
        ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue,
        __HorizontalWithVerticalVelocity_iE_Extensions__item_,
        _HorizontalWithVerticalVelocity_iE_Extensions,
        HorizontalWithVerticalVelocity,
        HorizontalWithVerticalVelocity_ExtIEs,
        _HorizontalVelocityWithUncertainty_horizontalSpeedAndBearing,
        _HorizontalVelocityWithUncertainty_uncertaintySpeed,
        ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab,
        ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id,
        ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab,
        ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality,
        ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab,
        ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue,
        __HorizontalVelocityWithUncertainty_iE_Extensions__item_,
        _HorizontalVelocityWithUncertainty_iE_Extensions,
        HorizontalVelocityWithUncertainty,
        HorizontalVelocityWithUncertainty_ExtIEs,
        _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeedAndBearing,
        _HorizontalWithVerticalVelocityAndUncertainty_verticalVelocity,
        _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed,
        _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed,
        ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab,
        ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id,
        ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab,
        ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality,
        ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab,
        ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue,
        __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_,
        _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions,
        HorizontalWithVerticalVelocityAndUncertainty,
        HorizontalWithVerticalVelocityAndUncertainty_ExtIEs,
        _HorizontalSpeedAndBearing_bearing,
        _HorizontalSpeedAndBearing_horizontalSpeed,
        HorizontalSpeedAndBearing,
        _VerticalVelocity_verticalSpeed,
        _VerticalVelocity_verticalSpeedDirection,
        VerticalVelocity,
        VerticalSpeedDirection,
        _UTRAN_GPSReferenceTime_utran_GPSTimingOfCell,
        _UTRAN_GPSReferenceTime_uC_ID,
        _UTRAN_GPSReferenceTime_sfn,
        ____UTRAN_GPSReferenceTime_iE_Extensions__item__id_tab,
        ___UTRAN_GPSReferenceTime_iE_Extensions__item__id,
        ____UTRAN_GPSReferenceTime_iE_Extensions__item__criticality_tab,
        ___UTRAN_GPSReferenceTime_iE_Extensions__item__criticality,
        ____UTRAN_GPSReferenceTime_iE_Extensions__item__extensionValue_tab,
        ___UTRAN_GPSReferenceTime_iE_Extensions__item__extensionValue,
        __UTRAN_GPSReferenceTime_iE_Extensions__item_,
        _UTRAN_GPSReferenceTime_iE_Extensions,
        UTRAN_GPSReferenceTime,
        UTRAN_GPSReferenceTime_ExtIEs,
        _UTRAN_GPSReferenceTimeResult_ue_GPSTimingOfCell,
        _UTRAN_GPSReferenceTimeResult_uC_ID,
        _UTRAN_GPSReferenceTimeResult_sfn,
        ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__id_tab,
        ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__id,
        ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__criticality_tab,
        ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__criticality,
        ____UTRAN_GPSReferenceTimeResult_iE_Extensions__item__extensionValue_tab,
        ___UTRAN_GPSReferenceTimeResult_iE_Extensions__item__extensionValue,
        __UTRAN_GPSReferenceTimeResult_iE_Extensions__item_,
        _UTRAN_GPSReferenceTimeResult_iE_Extensions,
        UTRAN_GPSReferenceTimeResult,
        UTRAN_GPSReferenceTimeResult_ExtIEs,
        _UTRAN_GANSSReferenceTimeResult_ue_GANSSTimingOfCell,
        _UTRAN_GANSSReferenceTimeResult_ganss_Time_ID,
        _UTRAN_GANSSReferenceTimeResult_ganssTodUncertainty,
        _UTRAN_GANSSReferenceTimeResult_uC_ID,
        _UTRAN_GANSSReferenceTimeResult_sfn,
        ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__id_tab,
        ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__id,
        ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__criticality_tab,
        ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__criticality,
        ____UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__extensionValue_tab,
        ___UTRAN_GANSSReferenceTimeResult_iE_Extensions__item__extensionValue,
        __UTRAN_GANSSReferenceTimeResult_iE_Extensions__item_,
        _UTRAN_GANSSReferenceTimeResult_iE_Extensions,
        UTRAN_GANSSReferenceTimeResult,
        UTRAN_GANSSReferenceTimeResult_ExtIEs,
    ]

class PCAP_PDU_Contents:

    _name_  = 'PCAP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 20, 3, 4, 1, 1]
    
    _obj_ = [
        'PositionCalculationRequest',
        'PositionCalculationRequestIEs',
        'PositionCalculationRequestExtensions',
        'PositionCalculationResponse',
        'PositionCalculationResponseIEs',
        'PositionCalculationResponseExtensions',
        'PositionCalculationFailure',
        'PositionCalculationFailureIEs',
        'PositionCalculationFailureExtensions',
        'InformationExchangeInitiationRequest',
        'InformationExchangeInitiationRequest-IEs',
        'InformationExchangeInitiationRequest-Extensions',
        'InformationExchangeObjectType-InfEx-Rqst',
        'RefPosition-InfEx-Rqst',
        'RefPositionItem-InfEx-Rqst-ExtIEs',
        'Extension-InformationExchangeObjectType-InfEx-Rqst',
        'Extension-InformationExchangeObjectType-InfEx-RqstIE',
        'UC-ID-InfEx-Rqst',
        'UCIDItem-InfEx-Rqst-ExtIEs',
        'InformationExchangeInitiationResponse',
        'InformationExchangeInitiationResponse-IEs',
        'InformationExchangeInitiationResponse-Extensions',
        'InformationExchangeObjectType-InfEx-Rsp',
        'RefPosition-InfEx-Rsp',
        'RefPositionItem-InfEx-Rsp-ExtIEs',
        'InformationExchangeInitiationFailure',
        'InformationExchangeInitiationFailure-IEs',
        'InformationExchangeInitiationFailure-Extensions',
        'PositionInitiationRequest',
        'PositionInitiationRequestIEs',
        'PositionInitiationRequestExtensions',
        'PositionInitiationResponse',
        'PositionInitiationResponseIEs',
        'PositionInitiationResponseExtensions',
        'PositionInitiationFailure',
        'PositionInitiationFailureIEs',
        'PositionInitiationFailureExtensions',
        'PositionActivationRequest',
        'PositionActivationRequestIEs',
        'PositionActivationRequestExtensions',
        'PositionActivationResponse',
        'PositionActivationResponseIEs',
        'PositionActivationResponseExtensions',
        'PositionActivationFailure',
        'PositionActivationFailureIEs',
        'PositionActivationFailureExtensions',
        'InformationReport',
        'InformationReport-IEs',
        'InformationReport-Extensions',
        'InformationExchangeObjectType-InfEx-Rprt',
        'RefPosition-InfEx-Rprt',
        'RefPositionItem-InfEx-Rprt-ExtIEs',
        'InformationExchangeTerminationRequest',
        'InformationExchangeTerminationRequest-IEs',
        'InformationExchangeTerminationRequest-Extensions',
        'InformationExchangeFailureIndication',
        'InformationExchangeFailureIndication-IEs',
        'InformationExchangeFailureIndication-Extensions',
        'ErrorIndication',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PositionParameterModification',
        'PositionParameterModificationIEs',
        'PositionParameterModificationExtensions',
        'PrivateMessage',
        'PrivateMessage-IEs',
        'Abort',
        'AbortIEs',
        'AbortExtensions',
        'PositionPeriodicReport',
        'PositionPeriodicReport-IEs',
        'PositionPeriodicReport-Extensions',
        'PositionPeriodicResult',
        'PositionPeriodicResult-IEs',
        'PositionPeriodicResult-Extensions',
        'PositionPeriodicTermination',
        'PositionPeriodicTermination-IEs',
        'PositionPeriodicTermination-Extensions',
        ]
    _type_ = [
        'PositionCalculationRequest',
        'PositionCalculationResponse',
        'PositionCalculationFailure',
        'InformationExchangeInitiationRequest',
        'InformationExchangeObjectType-InfEx-Rqst',
        'RefPosition-InfEx-Rqst',
        'Extension-InformationExchangeObjectType-InfEx-Rqst',
        'UC-ID-InfEx-Rqst',
        'InformationExchangeInitiationResponse',
        'InformationExchangeObjectType-InfEx-Rsp',
        'RefPosition-InfEx-Rsp',
        'InformationExchangeInitiationFailure',
        'PositionInitiationRequest',
        'PositionInitiationResponse',
        'PositionInitiationFailure',
        'PositionActivationRequest',
        'PositionActivationResponse',
        'PositionActivationFailure',
        'InformationReport',
        'InformationExchangeObjectType-InfEx-Rprt',
        'RefPosition-InfEx-Rprt',
        'InformationExchangeTerminationRequest',
        'InformationExchangeFailureIndication',
        'ErrorIndication',
        'PositionParameterModification',
        'PrivateMessage',
        'Abort',
        'PositionPeriodicReport',
        'PositionPeriodicResult',
        'PositionPeriodicTermination',
        ]
    _set_ = [
        'PositionCalculationRequestIEs',
        'PositionCalculationRequestExtensions',
        'PositionCalculationResponseIEs',
        'PositionCalculationResponseExtensions',
        'PositionCalculationFailureIEs',
        'PositionCalculationFailureExtensions',
        'InformationExchangeInitiationRequest-IEs',
        'InformationExchangeInitiationRequest-Extensions',
        'RefPositionItem-InfEx-Rqst-ExtIEs',
        'Extension-InformationExchangeObjectType-InfEx-RqstIE',
        'UCIDItem-InfEx-Rqst-ExtIEs',
        'InformationExchangeInitiationResponse-IEs',
        'InformationExchangeInitiationResponse-Extensions',
        'RefPositionItem-InfEx-Rsp-ExtIEs',
        'InformationExchangeInitiationFailure-IEs',
        'InformationExchangeInitiationFailure-Extensions',
        'PositionInitiationRequestIEs',
        'PositionInitiationRequestExtensions',
        'PositionInitiationResponseIEs',
        'PositionInitiationResponseExtensions',
        'PositionInitiationFailureIEs',
        'PositionInitiationFailureExtensions',
        'PositionActivationRequestIEs',
        'PositionActivationRequestExtensions',
        'PositionActivationResponseIEs',
        'PositionActivationResponseExtensions',
        'PositionActivationFailureIEs',
        'PositionActivationFailureExtensions',
        'InformationReport-IEs',
        'InformationReport-Extensions',
        'RefPositionItem-InfEx-Rprt-ExtIEs',
        'InformationExchangeTerminationRequest-IEs',
        'InformationExchangeTerminationRequest-Extensions',
        'InformationExchangeFailureIndication-IEs',
        'InformationExchangeFailureIndication-Extensions',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PositionParameterModificationIEs',
        'PositionParameterModificationExtensions',
        'PrivateMessage-IEs',
        'AbortIEs',
        'AbortExtensions',
        'PositionPeriodicReport-IEs',
        'PositionPeriodicReport-Extensions',
        'PositionPeriodicResult-IEs',
        'PositionPeriodicResult-Extensions',
        'PositionPeriodicTermination-IEs',
        'PositionPeriodicTermination-Extensions',
        ]
    _val_ = [
        ]
    _class_ = [
        'PositionCalculationRequestIEs',
        'PositionCalculationRequestExtensions',
        'PositionCalculationResponseIEs',
        'PositionCalculationResponseExtensions',
        'PositionCalculationFailureIEs',
        'PositionCalculationFailureExtensions',
        'InformationExchangeInitiationRequest-IEs',
        'InformationExchangeInitiationRequest-Extensions',
        'RefPositionItem-InfEx-Rqst-ExtIEs',
        'Extension-InformationExchangeObjectType-InfEx-RqstIE',
        'UCIDItem-InfEx-Rqst-ExtIEs',
        'InformationExchangeInitiationResponse-IEs',
        'InformationExchangeInitiationResponse-Extensions',
        'RefPositionItem-InfEx-Rsp-ExtIEs',
        'InformationExchangeInitiationFailure-IEs',
        'InformationExchangeInitiationFailure-Extensions',
        'PositionInitiationRequestIEs',
        'PositionInitiationRequestExtensions',
        'PositionInitiationResponseIEs',
        'PositionInitiationResponseExtensions',
        'PositionInitiationFailureIEs',
        'PositionInitiationFailureExtensions',
        'PositionActivationRequestIEs',
        'PositionActivationRequestExtensions',
        'PositionActivationResponseIEs',
        'PositionActivationResponseExtensions',
        'PositionActivationFailureIEs',
        'PositionActivationFailureExtensions',
        'InformationReport-IEs',
        'InformationReport-Extensions',
        'RefPositionItem-InfEx-Rprt-ExtIEs',
        'InformationExchangeTerminationRequest-IEs',
        'InformationExchangeTerminationRequest-Extensions',
        'InformationExchangeFailureIndication-IEs',
        'InformationExchangeFailureIndication-Extensions',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'PositionParameterModificationIEs',
        'PositionParameterModificationExtensions',
        'PrivateMessage-IEs',
        'AbortIEs',
        'AbortExtensions',
        'PositionPeriodicReport-IEs',
        'PositionPeriodicReport-Extensions',
        'PositionPeriodicResult-IEs',
        'PositionPeriodicResult-Extensions',
        'PositionPeriodicTermination-IEs',
        'PositionPeriodicTermination-Extensions',
        ]
    _param_ = [
        ]
    
    #-----< PositionCalculationRequest >-----#
    PositionCalculationRequest = SEQ(name='PositionCalculationRequest', mode=MODE_TYPE)
    _PositionCalculationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionCalculationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionCalculationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionCalculationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionCalculationRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _____PositionCalculationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MeasuredResultsList')))
    ____PositionCalculationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'reject'), ('Value', _____PositionCalculationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _____PositionCalculationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionCalculationRequest_protocolIEs__item__id._const_tab = ____PositionCalculationRequest_protocolIEs__item__id_tab
    ___PositionCalculationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositionCalculationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionCalculationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionCalculationRequest_protocolIEs__item__criticality._const_tab = ____PositionCalculationRequest_protocolIEs__item__id_tab
    ___PositionCalculationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionCalculationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionCalculationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionCalculationRequest_protocolIEs__item__value._const_tab = ____PositionCalculationRequest_protocolIEs__item__id_tab
    ___PositionCalculationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionCalculationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionCalculationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionCalculationRequest_protocolIEs__item__id),
        ('criticality', ___PositionCalculationRequest_protocolIEs__item__criticality),
        ('value', ___PositionCalculationRequest_protocolIEs__item__value),
        ])
    __PositionCalculationRequest_protocolIEs__item_._ext = None
    _PositionCalculationRequest_protocolIEs._cont = __PositionCalculationRequest_protocolIEs__item_
    _PositionCalculationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionCalculationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionCalculationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionCalculationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionCalculationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-MeasuredResultsSets')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-MeasurementGroup')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'HorizontalAccuracyCode')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VerticalAccuracyCode')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-Group')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Positioning-ResponseTime')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IncludeVelocity')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PeriodicPosCalcInfo')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-MeasuredResultsList')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_9 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-IRATMeasuredResultsSets')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_10 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMSI')))
    _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_11 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMEI')))
    ____PositionCalculationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'reject'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'reject'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 24), ('criticality', 'ignore'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 25), ('criticality', 'ignore'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'reject'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 57), ('criticality', 'ignore'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'reject'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'ignore'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 128), ('criticality', 'ignore'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Extension', _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionCalculationRequest_protocolExtensions__item__id._const_tab = ____PositionCalculationRequest_protocolExtensions__item__id_tab
    ___PositionCalculationRequest_protocolExtensions__item__id._const_tab_at = None
    ___PositionCalculationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionCalculationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositionCalculationRequest_protocolExtensions__item__criticality._const_tab = ____PositionCalculationRequest_protocolExtensions__item__id_tab
    ___PositionCalculationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionCalculationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionCalculationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositionCalculationRequest_protocolExtensions__item__extensionValue._const_tab = ____PositionCalculationRequest_protocolExtensions__item__id_tab
    ___PositionCalculationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionCalculationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionCalculationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionCalculationRequest_protocolExtensions__item__id),
        ('criticality', ___PositionCalculationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionCalculationRequest_protocolExtensions__item__extensionValue),
        ])
    __PositionCalculationRequest_protocolExtensions__item_._ext = None
    _PositionCalculationRequest_protocolExtensions._cont = __PositionCalculationRequest_protocolExtensions__item_
    _PositionCalculationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionCalculationRequest._cont = ASN1Dict([
        ('protocolIEs', _PositionCalculationRequest_protocolIEs),
        ('protocolExtensions', _PositionCalculationRequest_protocolExtensions),
        ])
    PositionCalculationRequest._ext = []
    
    #-----< PositionCalculationRequestIEs >-----#
    PositionCalculationRequestIEs = CLASS(name='PositionCalculationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionCalculationRequestIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _PositionCalculationRequestIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MeasuredResultsList')))
    PositionCalculationRequestIEs._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'reject'), ('Value', _PositionCalculationRequestIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _PositionCalculationRequestIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionCalculationRequestExtensions >-----#
    PositionCalculationRequestExtensions = CLASS(name='PositionCalculationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _PositionCalculationRequestExtensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-MeasuredResultsSets')))
    _PositionCalculationRequestExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-MeasurementGroup')))
    _PositionCalculationRequestExtensions_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'HorizontalAccuracyCode')))
    _PositionCalculationRequestExtensions_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VerticalAccuracyCode')))
    _PositionCalculationRequestExtensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-Group')))
    _PositionCalculationRequestExtensions_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Positioning-ResponseTime')))
    _PositionCalculationRequestExtensions_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IncludeVelocity')))
    _PositionCalculationRequestExtensions_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PeriodicPosCalcInfo')))
    _PositionCalculationRequestExtensions_val_Extension_8 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-MeasuredResultsList')))
    _PositionCalculationRequestExtensions_val_Extension_9 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-IRATMeasuredResultsSets')))
    _PositionCalculationRequestExtensions_val_Extension_10 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMSI')))
    _PositionCalculationRequestExtensions_val_Extension_11 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMEI')))
    PositionCalculationRequestExtensions._val = ASN1Set(rv=[dict([('id', 20), ('criticality', 'reject'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'reject'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 24), ('criticality', 'ignore'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 25), ('criticality', 'ignore'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'reject'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 57), ('criticality', 'ignore'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'reject'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'ignore'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 128), ('criticality', 'ignore'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Extension', _PositionCalculationRequestExtensions_val_Extension_11), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionCalculationResponse >-----#
    PositionCalculationResponse = SEQ(name='PositionCalculationResponse', mode=MODE_TYPE)
    _PositionCalculationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionCalculationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionCalculationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionCalculationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionCalculationResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _____PositionCalculationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    ____PositionCalculationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'ignore'), ('Value', _____PositionCalculationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____PositionCalculationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionCalculationResponse_protocolIEs__item__id._const_tab = ____PositionCalculationResponse_protocolIEs__item__id_tab
    ___PositionCalculationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositionCalculationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionCalculationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionCalculationResponse_protocolIEs__item__criticality._const_tab = ____PositionCalculationResponse_protocolIEs__item__id_tab
    ___PositionCalculationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionCalculationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionCalculationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionCalculationResponse_protocolIEs__item__value._const_tab = ____PositionCalculationResponse_protocolIEs__item__id_tab
    ___PositionCalculationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionCalculationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionCalculationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionCalculationResponse_protocolIEs__item__id),
        ('criticality', ___PositionCalculationResponse_protocolIEs__item__criticality),
        ('value', ___PositionCalculationResponse_protocolIEs__item__value),
        ])
    __PositionCalculationResponse_protocolIEs__item_._ext = None
    _PositionCalculationResponse_protocolIEs._cont = __PositionCalculationResponse_protocolIEs__item_
    _PositionCalculationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionCalculationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionCalculationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionCalculationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionCalculationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PositionCalculationResponse_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AccuracyFulfilmentIndicator')))
    _____PositionCalculationResponse_protocolExtensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VelocityEstimate')))
    ____PositionCalculationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 23), ('criticality', 'ignore'), ('Extension', _____PositionCalculationResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'ignore'), ('Extension', _____PositionCalculationResponse_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionCalculationResponse_protocolExtensions__item__id._const_tab = ____PositionCalculationResponse_protocolExtensions__item__id_tab
    ___PositionCalculationResponse_protocolExtensions__item__id._const_tab_at = None
    ___PositionCalculationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionCalculationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositionCalculationResponse_protocolExtensions__item__criticality._const_tab = ____PositionCalculationResponse_protocolExtensions__item__id_tab
    ___PositionCalculationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionCalculationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionCalculationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositionCalculationResponse_protocolExtensions__item__extensionValue._const_tab = ____PositionCalculationResponse_protocolExtensions__item__id_tab
    ___PositionCalculationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionCalculationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionCalculationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionCalculationResponse_protocolExtensions__item__id),
        ('criticality', ___PositionCalculationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionCalculationResponse_protocolExtensions__item__extensionValue),
        ])
    __PositionCalculationResponse_protocolExtensions__item_._ext = None
    _PositionCalculationResponse_protocolExtensions._cont = __PositionCalculationResponse_protocolExtensions__item_
    _PositionCalculationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionCalculationResponse._cont = ASN1Dict([
        ('protocolIEs', _PositionCalculationResponse_protocolIEs),
        ('protocolExtensions', _PositionCalculationResponse_protocolExtensions),
        ])
    PositionCalculationResponse._ext = []
    
    #-----< PositionCalculationResponseIEs >-----#
    PositionCalculationResponseIEs = CLASS(name='PositionCalculationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionCalculationResponseIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _PositionCalculationResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    PositionCalculationResponseIEs._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'ignore'), ('Value', _PositionCalculationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _PositionCalculationResponseIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionCalculationResponseExtensions >-----#
    PositionCalculationResponseExtensions = CLASS(name='PositionCalculationResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _PositionCalculationResponseExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AccuracyFulfilmentIndicator')))
    _PositionCalculationResponseExtensions_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VelocityEstimate')))
    PositionCalculationResponseExtensions._val = ASN1Set(rv=[dict([('id', 23), ('criticality', 'ignore'), ('Extension', _PositionCalculationResponseExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'ignore'), ('Extension', _PositionCalculationResponseExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionCalculationFailure >-----#
    PositionCalculationFailure = SEQ(name='PositionCalculationFailure', mode=MODE_TYPE)
    _PositionCalculationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionCalculationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionCalculationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionCalculationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionCalculationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    _____PositionCalculationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    ____PositionCalculationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PositionCalculationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____PositionCalculationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionCalculationFailure_protocolIEs__item__id._const_tab = ____PositionCalculationFailure_protocolIEs__item__id_tab
    ___PositionCalculationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositionCalculationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionCalculationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionCalculationFailure_protocolIEs__item__criticality._const_tab = ____PositionCalculationFailure_protocolIEs__item__id_tab
    ___PositionCalculationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionCalculationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionCalculationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionCalculationFailure_protocolIEs__item__value._const_tab = ____PositionCalculationFailure_protocolIEs__item__id_tab
    ___PositionCalculationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionCalculationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionCalculationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionCalculationFailure_protocolIEs__item__id),
        ('criticality', ___PositionCalculationFailure_protocolIEs__item__criticality),
        ('value', ___PositionCalculationFailure_protocolIEs__item__value),
        ])
    __PositionCalculationFailure_protocolIEs__item_._ext = None
    _PositionCalculationFailure_protocolIEs._cont = __PositionCalculationFailure_protocolIEs__item_
    _PositionCalculationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionCalculationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionCalculationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionCalculationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionCalculationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionCalculationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionCalculationFailure_protocolExtensions__item__id._const_tab = ____PositionCalculationFailure_protocolExtensions__item__id_tab
    ___PositionCalculationFailure_protocolExtensions__item__id._const_tab_at = None
    ___PositionCalculationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionCalculationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PositionCalculationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionCalculationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionCalculationFailure_protocolExtensions__item__criticality._const_tab = ____PositionCalculationFailure_protocolExtensions__item__criticality_tab
    ___PositionCalculationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionCalculationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionCalculationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PositionCalculationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionCalculationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionCalculationFailure_protocolExtensions__item__extensionValue._const_tab = ____PositionCalculationFailure_protocolExtensions__item__extensionValue_tab
    ___PositionCalculationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionCalculationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionCalculationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionCalculationFailure_protocolExtensions__item__id),
        ('criticality', ___PositionCalculationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionCalculationFailure_protocolExtensions__item__extensionValue),
        ])
    __PositionCalculationFailure_protocolExtensions__item_._ext = None
    _PositionCalculationFailure_protocolExtensions._cont = __PositionCalculationFailure_protocolExtensions__item_
    _PositionCalculationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionCalculationFailure._cont = ASN1Dict([
        ('protocolIEs', _PositionCalculationFailure_protocolIEs),
        ('protocolExtensions', _PositionCalculationFailure_protocolExtensions),
        ])
    PositionCalculationFailure._ext = []
    
    #-----< PositionCalculationFailureIEs >-----#
    PositionCalculationFailureIEs = CLASS(name='PositionCalculationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionCalculationFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    _PositionCalculationFailureIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    PositionCalculationFailureIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _PositionCalculationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _PositionCalculationFailureIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionCalculationFailureExtensions >-----#
    PositionCalculationFailureExtensions = CLASS(name='PositionCalculationFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PositionCalculationFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationRequest >-----#
    InformationExchangeInitiationRequest = SEQ(name='InformationExchangeInitiationRequest', mode=MODE_TYPE)
    _InformationExchangeInitiationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeInitiationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rqst')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationType')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationReportCharacteristics')))
    _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-UTRAN-TRU')))
    ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationRequest_protocolIEs__item__id._const_tab = ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab
    ___InformationExchangeInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeInitiationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality._const_tab = ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___InformationExchangeInitiationRequest_protocolIEs__item__value._const_tab = ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab
    ___InformationExchangeInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationExchangeInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationRequest_protocolIEs__item__id),
        ('criticality', ___InformationExchangeInitiationRequest_protocolIEs__item__criticality),
        ('value', ___InformationExchangeInitiationRequest_protocolIEs__item__value),
        ])
    __InformationExchangeInitiationRequest_protocolIEs__item_._ext = None
    _InformationExchangeInitiationRequest_protocolIEs._cont = __InformationExchangeInitiationRequest_protocolIEs__item_
    _InformationExchangeInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeInitiationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeInitiationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-UTRAN-TRU')))
    _____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMSI')))
    _____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMEI')))
    ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'reject'), ('Extension', _____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'conditional')]), dict([('id', 128), ('criticality', 'ignore'), ('Extension', _____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Extension', _____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id._const_tab = ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeInitiationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality._const_tab = ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationExchangeInitiationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationRequest_protocolExtensions__item__id),
        ('criticality', ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeInitiationRequest_protocolExtensions__item_._ext = None
    _InformationExchangeInitiationRequest_protocolExtensions._cont = __InformationExchangeInitiationRequest_protocolExtensions__item_
    _InformationExchangeInitiationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeInitiationRequest._cont = ASN1Dict([
        ('protocolIEs', _InformationExchangeInitiationRequest_protocolIEs),
        ('protocolExtensions', _InformationExchangeInitiationRequest_protocolExtensions),
        ])
    InformationExchangeInitiationRequest._ext = []
    
    #-----< InformationExchangeInitiationRequest-IEs >-----#
    InformationExchangeInitiationRequest_IEs = CLASS(name='InformationExchangeInitiationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _InformationExchangeInitiationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    _InformationExchangeInitiationRequest_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rqst')))
    _InformationExchangeInitiationRequest_IEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationType')))
    _InformationExchangeInitiationRequest_IEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationReportCharacteristics')))
    _InformationExchangeInitiationRequest_IEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPS-UTRAN-TRU')))
    InformationExchangeInitiationRequest_IEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'reject'), ('Value', _InformationExchangeInitiationRequest_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 6), ('criticality', 'reject'), ('Value', _InformationExchangeInitiationRequest_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'reject'), ('Value', _InformationExchangeInitiationRequest_IEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 8), ('criticality', 'reject'), ('Value', _InformationExchangeInitiationRequest_IEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _InformationExchangeInitiationRequest_IEs_val_Value_4), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationRequest-Extensions >-----#
    InformationExchangeInitiationRequest_Extensions = CLASS(name='InformationExchangeInitiationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _InformationExchangeInitiationRequest_Extensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-UTRAN-TRU')))
    _InformationExchangeInitiationRequest_Extensions_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMSI')))
    _InformationExchangeInitiationRequest_Extensions_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMEI')))
    InformationExchangeInitiationRequest_Extensions._val = ASN1Set(rv=[dict([('id', 72), ('criticality', 'reject'), ('Extension', _InformationExchangeInitiationRequest_Extensions_val_Extension_0), ('presence', 'conditional')]), dict([('id', 128), ('criticality', 'ignore'), ('Extension', _InformationExchangeInitiationRequest_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Extension', _InformationExchangeInitiationRequest_Extensions_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeObjectType-InfEx-Rqst >-----#
    InformationExchangeObjectType_InfEx_Rqst = CHOICE(name='InformationExchangeObjectType-InfEx-Rqst', mode=MODE_TYPE)
    _InformationExchangeObjectType_InfEx_Rqst_referencePosition = SEQ(name='referencePosition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-PDU-Contents', 'RefPosition-InfEx-Rqst')))
    _InformationExchangeObjectType_InfEx_Rqst_extension_InformationExchangeObjectType_InfEx_Rqst = SEQ(name='extension-InformationExchangeObjectType-InfEx-Rqst', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-PDU-Contents', 'Extension-InformationExchangeObjectType-InfEx-Rqst')))
    InformationExchangeObjectType_InfEx_Rqst._cont = ASN1Dict([
        ('referencePosition', _InformationExchangeObjectType_InfEx_Rqst_referencePosition),
        ('extension-InformationExchangeObjectType-InfEx-Rqst', _InformationExchangeObjectType_InfEx_Rqst_extension_InformationExchangeObjectType_InfEx_Rqst),
        ])
    InformationExchangeObjectType_InfEx_Rqst._ext = ['extension-InformationExchangeObjectType-InfEx-Rqst']
    
    #-----< RefPosition-InfEx-Rqst >-----#
    RefPosition_InfEx_Rqst = SEQ(name='RefPosition-InfEx-Rqst', mode=MODE_TYPE)
    _RefPosition_InfEx_Rqst_referencePositionEstimate = CHOICE(name='referencePositionEstimate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _RefPosition_InfEx_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RefPosition_InfEx_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RefPosition_InfEx_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RefPosition_InfEx_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__id._const_tab = ____RefPosition_InfEx_Rqst_iE_Extensions__item__id_tab
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RefPosition_InfEx_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RefPosition_InfEx_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__criticality._const_tab = ____RefPosition_InfEx_Rqst_iE_Extensions__item__criticality_tab
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RefPosition_InfEx_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RefPosition_InfEx_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab = ____RefPosition_InfEx_Rqst_iE_Extensions__item__extensionValue_tab
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RefPosition_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RefPosition_InfEx_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RefPosition_InfEx_Rqst_iE_Extensions__item__id),
        ('criticality', ___RefPosition_InfEx_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___RefPosition_InfEx_Rqst_iE_Extensions__item__extensionValue),
        ])
    __RefPosition_InfEx_Rqst_iE_Extensions__item_._ext = None
    _RefPosition_InfEx_Rqst_iE_Extensions._cont = __RefPosition_InfEx_Rqst_iE_Extensions__item_
    _RefPosition_InfEx_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RefPosition_InfEx_Rqst._cont = ASN1Dict([
        ('referencePositionEstimate', _RefPosition_InfEx_Rqst_referencePositionEstimate),
        ('iE-Extensions', _RefPosition_InfEx_Rqst_iE_Extensions),
        ])
    RefPosition_InfEx_Rqst._ext = []
    
    #-----< RefPositionItem-InfEx-Rqst-ExtIEs >-----#
    RefPositionItem_InfEx_Rqst_ExtIEs = CLASS(name='RefPositionItem-InfEx-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RefPositionItem_InfEx_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Extension-InformationExchangeObjectType-InfEx-Rqst >-----#
    Extension_InformationExchangeObjectType_InfEx_Rqst = SEQ(name='Extension-InformationExchangeObjectType-InfEx-Rqst', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Single-Container')))
    _Extension_InformationExchangeObjectType_InfEx_Rqst_id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'UC-ID-InfEx-Rqst')))
    ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-MeasuredResultsSets')))
    __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'reject'), ('Value', ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'ignore'), ('Value', ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    _Extension_InformationExchangeObjectType_InfEx_Rqst_id._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rqst_id._const_tab_at = None
    _Extension_InformationExchangeObjectType_InfEx_Rqst_id._const_tab_id = 'id'
    _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality._const_tab_at = ('..', 'id')
    _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality._const_tab_id = 'criticality'
    _Extension_InformationExchangeObjectType_InfEx_Rqst_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    _Extension_InformationExchangeObjectType_InfEx_Rqst_value._const_tab = __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab
    _Extension_InformationExchangeObjectType_InfEx_Rqst_value._const_tab_at = ('..', 'id')
    _Extension_InformationExchangeObjectType_InfEx_Rqst_value._const_tab_id = 'Value'
    Extension_InformationExchangeObjectType_InfEx_Rqst._cont = ASN1Dict([
        ('id', _Extension_InformationExchangeObjectType_InfEx_Rqst_id),
        ('criticality', _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality),
        ('value', _Extension_InformationExchangeObjectType_InfEx_Rqst_value),
        ])
    Extension_InformationExchangeObjectType_InfEx_Rqst._ext = None
    
    #-----< Extension-InformationExchangeObjectType-InfEx-RqstIE >-----#
    Extension_InformationExchangeObjectType_InfEx_RqstIE = CLASS(name='Extension-InformationExchangeObjectType-InfEx-RqstIE', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'UC-ID-InfEx-Rqst')))
    _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-MeasuredResultsSets')))
    Extension_InformationExchangeObjectType_InfEx_RqstIE._val = ASN1Set(rv=[dict([('id', 44), ('criticality', 'reject'), ('Value', _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_0), ('presence', 'mandatory')]), dict([('id', 20), ('criticality', 'ignore'), ('Value', _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    
    #-----< UC-ID-InfEx-Rqst >-----#
    UC_ID_InfEx_Rqst = SEQ(name='UC-ID-InfEx-Rqst', mode=MODE_TYPE)
    _UC_ID_InfEx_Rqst_referenceUC_ID = SEQ(name='referenceUC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _UC_ID_InfEx_Rqst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UC_ID_InfEx_Rqst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____UC_ID_InfEx_Rqst_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UC_ID_InfEx_Rqst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__id._const_tab = ____UC_ID_InfEx_Rqst_iE_Extensions__item__id_tab
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__id._const_tab_at = None
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__id._const_tab_id = 'id'
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UC_ID_InfEx_Rqst_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UC_ID_InfEx_Rqst_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__criticality._const_tab = ____UC_ID_InfEx_Rqst_iE_Extensions__item__criticality_tab
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UC_ID_InfEx_Rqst_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____UC_ID_InfEx_Rqst_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab = ____UC_ID_InfEx_Rqst_iE_Extensions__item__extensionValue_tab
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UC_ID_InfEx_Rqst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UC_ID_InfEx_Rqst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UC_ID_InfEx_Rqst_iE_Extensions__item__id),
        ('criticality', ___UC_ID_InfEx_Rqst_iE_Extensions__item__criticality),
        ('extensionValue', ___UC_ID_InfEx_Rqst_iE_Extensions__item__extensionValue),
        ])
    __UC_ID_InfEx_Rqst_iE_Extensions__item_._ext = None
    _UC_ID_InfEx_Rqst_iE_Extensions._cont = __UC_ID_InfEx_Rqst_iE_Extensions__item_
    _UC_ID_InfEx_Rqst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UC_ID_InfEx_Rqst._cont = ASN1Dict([
        ('referenceUC-ID', _UC_ID_InfEx_Rqst_referenceUC_ID),
        ('iE-Extensions', _UC_ID_InfEx_Rqst_iE_Extensions),
        ])
    UC_ID_InfEx_Rqst._ext = []
    
    #-----< UCIDItem-InfEx-Rqst-ExtIEs >-----#
    UCIDItem_InfEx_Rqst_ExtIEs = CLASS(name='UCIDItem-InfEx-Rqst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    UCIDItem_InfEx_Rqst_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationResponse >-----#
    InformationExchangeInitiationResponse = SEQ(name='InformationExchangeInitiationResponse', mode=MODE_TYPE)
    _InformationExchangeInitiationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeInitiationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rsp')))
    _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolIEs__item__id._const_tab = ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab
    ___InformationExchangeInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeInitiationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality._const_tab = ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___InformationExchangeInitiationResponse_protocolIEs__item__value._const_tab = ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab
    ___InformationExchangeInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationExchangeInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationResponse_protocolIEs__item__id),
        ('criticality', ___InformationExchangeInitiationResponse_protocolIEs__item__criticality),
        ('value', ___InformationExchangeInitiationResponse_protocolIEs__item__value),
        ])
    __InformationExchangeInitiationResponse_protocolIEs__item_._ext = None
    _InformationExchangeInitiationResponse_protocolIEs._cont = __InformationExchangeInitiationResponse_protocolIEs__item_
    _InformationExchangeInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeInitiationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeInitiationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id._const_tab = ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeInitiationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality._const_tab = ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationExchangeInitiationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationResponse_protocolExtensions__item__id),
        ('criticality', ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeInitiationResponse_protocolExtensions__item_._ext = None
    _InformationExchangeInitiationResponse_protocolExtensions._cont = __InformationExchangeInitiationResponse_protocolExtensions__item_
    _InformationExchangeInitiationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeInitiationResponse._cont = ASN1Dict([
        ('protocolIEs', _InformationExchangeInitiationResponse_protocolIEs),
        ('protocolExtensions', _InformationExchangeInitiationResponse_protocolExtensions),
        ])
    InformationExchangeInitiationResponse._ext = []
    
    #-----< InformationExchangeInitiationResponse-IEs >-----#
    InformationExchangeInitiationResponse_IEs = CLASS(name='InformationExchangeInitiationResponse-IEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _InformationExchangeInitiationResponse_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    _InformationExchangeInitiationResponse_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rsp')))
    _InformationExchangeInitiationResponse_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    InformationExchangeInitiationResponse_IEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationResponse_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationResponse_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationResponse_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationResponse-Extensions >-----#
    InformationExchangeInitiationResponse_Extensions = CLASS(name='InformationExchangeInitiationResponse-Extensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    InformationExchangeInitiationResponse_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeObjectType-InfEx-Rsp >-----#
    InformationExchangeObjectType_InfEx_Rsp = CHOICE(name='InformationExchangeObjectType-InfEx-Rsp', mode=MODE_TYPE)
    _InformationExchangeObjectType_InfEx_Rsp_referencePosition = SEQ(name='referencePosition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-PDU-Contents', 'RefPosition-InfEx-Rsp')))
    InformationExchangeObjectType_InfEx_Rsp._cont = ASN1Dict([
        ('referencePosition', _InformationExchangeObjectType_InfEx_Rsp_referencePosition),
        ])
    InformationExchangeObjectType_InfEx_Rsp._ext = []
    
    #-----< RefPosition-InfEx-Rsp >-----#
    RefPosition_InfEx_Rsp = SEQ(name='RefPosition-InfEx-Rsp', mode=MODE_TYPE)
    _RefPosition_InfEx_Rsp_requestedDataValue = SEQ(name='requestedDataValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RequestedDataValue')))
    _RefPosition_InfEx_Rsp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RefPosition_InfEx_Rsp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RefPosition_InfEx_Rsp_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RefPosition_InfEx_Rsp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__id._const_tab = ____RefPosition_InfEx_Rsp_iE_Extensions__item__id_tab
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__id._const_tab_at = None
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__id._const_tab_id = 'id'
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RefPosition_InfEx_Rsp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RefPosition_InfEx_Rsp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__criticality._const_tab = ____RefPosition_InfEx_Rsp_iE_Extensions__item__criticality_tab
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RefPosition_InfEx_Rsp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RefPosition_InfEx_Rsp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab = ____RefPosition_InfEx_Rsp_iE_Extensions__item__extensionValue_tab
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RefPosition_InfEx_Rsp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RefPosition_InfEx_Rsp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RefPosition_InfEx_Rsp_iE_Extensions__item__id),
        ('criticality', ___RefPosition_InfEx_Rsp_iE_Extensions__item__criticality),
        ('extensionValue', ___RefPosition_InfEx_Rsp_iE_Extensions__item__extensionValue),
        ])
    __RefPosition_InfEx_Rsp_iE_Extensions__item_._ext = None
    _RefPosition_InfEx_Rsp_iE_Extensions._cont = __RefPosition_InfEx_Rsp_iE_Extensions__item_
    _RefPosition_InfEx_Rsp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RefPosition_InfEx_Rsp._cont = ASN1Dict([
        ('requestedDataValue', _RefPosition_InfEx_Rsp_requestedDataValue),
        ('iE-Extensions', _RefPosition_InfEx_Rsp_iE_Extensions),
        ])
    RefPosition_InfEx_Rsp._ext = []
    
    #-----< RefPositionItem-InfEx-Rsp-ExtIEs >-----#
    RefPositionItem_InfEx_Rsp_ExtIEs = CLASS(name='RefPositionItem-InfEx-Rsp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RefPositionItem_InfEx_Rsp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationFailure >-----#
    InformationExchangeInitiationFailure = SEQ(name='InformationExchangeInitiationFailure', mode=MODE_TYPE)
    _InformationExchangeInitiationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeInitiationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolIEs__item__id._const_tab = ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab
    ___InformationExchangeInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeInitiationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality._const_tab = ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___InformationExchangeInitiationFailure_protocolIEs__item__value._const_tab = ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab
    ___InformationExchangeInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationExchangeInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationFailure_protocolIEs__item__id),
        ('criticality', ___InformationExchangeInitiationFailure_protocolIEs__item__criticality),
        ('value', ___InformationExchangeInitiationFailure_protocolIEs__item__value),
        ])
    __InformationExchangeInitiationFailure_protocolIEs__item_._ext = None
    _InformationExchangeInitiationFailure_protocolIEs._cont = __InformationExchangeInitiationFailure_protocolIEs__item_
    _InformationExchangeInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeInitiationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeInitiationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id._const_tab = ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeInitiationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality._const_tab = ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationExchangeInitiationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeInitiationFailure_protocolExtensions__item__id),
        ('criticality', ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeInitiationFailure_protocolExtensions__item_._ext = None
    _InformationExchangeInitiationFailure_protocolExtensions._cont = __InformationExchangeInitiationFailure_protocolExtensions__item_
    _InformationExchangeInitiationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeInitiationFailure._cont = ASN1Dict([
        ('protocolIEs', _InformationExchangeInitiationFailure_protocolIEs),
        ('protocolExtensions', _InformationExchangeInitiationFailure_protocolExtensions),
        ])
    InformationExchangeInitiationFailure._ext = []
    
    #-----< InformationExchangeInitiationFailure-IEs >-----#
    InformationExchangeInitiationFailure_IEs = CLASS(name='InformationExchangeInitiationFailure-IEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _InformationExchangeInitiationFailure_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    _InformationExchangeInitiationFailure_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    _InformationExchangeInitiationFailure_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    InformationExchangeInitiationFailure_IEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationFailure_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationFailure_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _InformationExchangeInitiationFailure_IEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeInitiationFailure-Extensions >-----#
    InformationExchangeInitiationFailure_Extensions = CLASS(name='InformationExchangeInitiationFailure-Extensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    InformationExchangeInitiationFailure_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositionInitiationRequest >-----#
    PositionInitiationRequest = SEQ(name='PositionInitiationRequest', mode=MODE_TYPE)
    _PositionInitiationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionInitiationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionInitiationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionInitiationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RequestType')))
    _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositioningCapability')))
    _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VerticalAccuracyCode')))
    _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ResponseTime')))
    _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositioningPriority')))
    _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ClientType')))
    ____PositionInitiationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 28), ('criticality', 'reject'), ('Value', _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 30), ('criticality', 'reject'), ('Value', _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionInitiationRequest_protocolIEs__item__id._const_tab = ____PositionInitiationRequest_protocolIEs__item__id_tab
    ___PositionInitiationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositionInitiationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionInitiationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionInitiationRequest_protocolIEs__item__criticality._const_tab = ____PositionInitiationRequest_protocolIEs__item__id_tab
    ___PositionInitiationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionInitiationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionInitiationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionInitiationRequest_protocolIEs__item__value._const_tab = ____PositionInitiationRequest_protocolIEs__item__id_tab
    ___PositionInitiationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionInitiationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionInitiationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionInitiationRequest_protocolIEs__item__id),
        ('criticality', ___PositionInitiationRequest_protocolIEs__item__criticality),
        ('value', ___PositionInitiationRequest_protocolIEs__item__value),
        ])
    __PositionInitiationRequest_protocolIEs__item_._ext = None
    _PositionInitiationRequest_protocolIEs._cont = __PositionInitiationRequest_protocolIEs__item_
    _PositionInitiationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionInitiationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionInitiationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionInitiationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionInitiationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IncludeVelocity')))
    _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PeriodicLocationInfo')))
    _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMSI')))
    _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMEI')))
    ____PositionInitiationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Extension', _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Extension', _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 128), ('criticality', 'ignore'), ('Extension', _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Extension', _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionInitiationRequest_protocolExtensions__item__id._const_tab = ____PositionInitiationRequest_protocolExtensions__item__id_tab
    ___PositionInitiationRequest_protocolExtensions__item__id._const_tab_at = None
    ___PositionInitiationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionInitiationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositionInitiationRequest_protocolExtensions__item__criticality._const_tab = ____PositionInitiationRequest_protocolExtensions__item__id_tab
    ___PositionInitiationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionInitiationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionInitiationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositionInitiationRequest_protocolExtensions__item__extensionValue._const_tab = ____PositionInitiationRequest_protocolExtensions__item__id_tab
    ___PositionInitiationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionInitiationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionInitiationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionInitiationRequest_protocolExtensions__item__id),
        ('criticality', ___PositionInitiationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionInitiationRequest_protocolExtensions__item__extensionValue),
        ])
    __PositionInitiationRequest_protocolExtensions__item_._ext = None
    _PositionInitiationRequest_protocolExtensions._cont = __PositionInitiationRequest_protocolExtensions__item_
    _PositionInitiationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionInitiationRequest._cont = ASN1Dict([
        ('protocolIEs', _PositionInitiationRequest_protocolIEs),
        ('protocolExtensions', _PositionInitiationRequest_protocolExtensions),
        ])
    PositionInitiationRequest._ext = []
    
    #-----< PositionInitiationRequestIEs >-----#
    PositionInitiationRequestIEs = CLASS(name='PositionInitiationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionInitiationRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RequestType')))
    _PositionInitiationRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositioningCapability')))
    _PositionInitiationRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _PositionInitiationRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VerticalAccuracyCode')))
    _PositionInitiationRequestIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ResponseTime')))
    _PositionInitiationRequestIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositioningPriority')))
    _PositionInitiationRequestIEs_val_Value_6 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'ClientType')))
    PositionInitiationRequestIEs._val = ASN1Set(rv=[dict([('id', 28), ('criticality', 'reject'), ('Value', _PositionInitiationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 29), ('criticality', 'reject'), ('Value', _PositionInitiationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 30), ('criticality', 'reject'), ('Value', _PositionInitiationRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 25), ('criticality', 'ignore'), ('Value', _PositionInitiationRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 31), ('criticality', 'ignore'), ('Value', _PositionInitiationRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _PositionInitiationRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 33), ('criticality', 'ignore'), ('Value', _PositionInitiationRequestIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionInitiationRequestExtensions >-----#
    PositionInitiationRequestExtensions = CLASS(name='PositionInitiationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _PositionInitiationRequestExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IncludeVelocity')))
    _PositionInitiationRequestExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PeriodicLocationInfo')))
    _PositionInitiationRequestExtensions_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMSI')))
    _PositionInitiationRequestExtensions_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IMEI')))
    PositionInitiationRequestExtensions._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Extension', _PositionInitiationRequestExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Extension', _PositionInitiationRequestExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 128), ('criticality', 'ignore'), ('Extension', _PositionInitiationRequestExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 129), ('criticality', 'ignore'), ('Extension', _PositionInitiationRequestExtensions_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionInitiationResponse >-----#
    PositionInitiationResponse = SEQ(name='PositionInitiationResponse', mode=MODE_TYPE)
    _PositionInitiationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionInitiationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionInitiationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionInitiationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionInitiationResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _____PositionInitiationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositionData')))
    _____PositionInitiationResponse_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AccuracyFulfilmentIndicator')))
    ____PositionInitiationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'reject'), ('Value', _____PositionInitiationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _____PositionInitiationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _____PositionInitiationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionInitiationResponse_protocolIEs__item__id._const_tab = ____PositionInitiationResponse_protocolIEs__item__id_tab
    ___PositionInitiationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositionInitiationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionInitiationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionInitiationResponse_protocolIEs__item__criticality._const_tab = ____PositionInitiationResponse_protocolIEs__item__id_tab
    ___PositionInitiationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionInitiationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionInitiationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionInitiationResponse_protocolIEs__item__value._const_tab = ____PositionInitiationResponse_protocolIEs__item__id_tab
    ___PositionInitiationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionInitiationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionInitiationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionInitiationResponse_protocolIEs__item__id),
        ('criticality', ___PositionInitiationResponse_protocolIEs__item__criticality),
        ('value', ___PositionInitiationResponse_protocolIEs__item__value),
        ])
    __PositionInitiationResponse_protocolIEs__item_._ext = None
    _PositionInitiationResponse_protocolIEs._cont = __PositionInitiationResponse_protocolIEs__item_
    _PositionInitiationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionInitiationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionInitiationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionInitiationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionInitiationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PositionInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VelocityEstimate')))
    ____PositionInitiationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 42), ('criticality', 'ignore'), ('Extension', _____PositionInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionInitiationResponse_protocolExtensions__item__id._const_tab = ____PositionInitiationResponse_protocolExtensions__item__id_tab
    ___PositionInitiationResponse_protocolExtensions__item__id._const_tab_at = None
    ___PositionInitiationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionInitiationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositionInitiationResponse_protocolExtensions__item__criticality._const_tab = ____PositionInitiationResponse_protocolExtensions__item__id_tab
    ___PositionInitiationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionInitiationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionInitiationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositionInitiationResponse_protocolExtensions__item__extensionValue._const_tab = ____PositionInitiationResponse_protocolExtensions__item__id_tab
    ___PositionInitiationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionInitiationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionInitiationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionInitiationResponse_protocolExtensions__item__id),
        ('criticality', ___PositionInitiationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionInitiationResponse_protocolExtensions__item__extensionValue),
        ])
    __PositionInitiationResponse_protocolExtensions__item_._ext = None
    _PositionInitiationResponse_protocolExtensions._cont = __PositionInitiationResponse_protocolExtensions__item_
    _PositionInitiationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionInitiationResponse._cont = ASN1Dict([
        ('protocolIEs', _PositionInitiationResponse_protocolIEs),
        ('protocolExtensions', _PositionInitiationResponse_protocolExtensions),
        ])
    PositionInitiationResponse._ext = []
    
    #-----< PositionInitiationResponseIEs >-----#
    PositionInitiationResponseIEs = CLASS(name='PositionInitiationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionInitiationResponseIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _PositionInitiationResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositionData')))
    _PositionInitiationResponseIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AccuracyFulfilmentIndicator')))
    PositionInitiationResponseIEs._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'reject'), ('Value', _PositionInitiationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _PositionInitiationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _PositionInitiationResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionInitiationResponseExtensions >-----#
    PositionInitiationResponseExtensions = CLASS(name='PositionInitiationResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _PositionInitiationResponseExtensions_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VelocityEstimate')))
    PositionInitiationResponseExtensions._val = ASN1Set(rv=[dict([('id', 42), ('criticality', 'ignore'), ('Extension', _PositionInitiationResponseExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionInitiationFailure >-----#
    PositionInitiationFailure = SEQ(name='PositionInitiationFailure', mode=MODE_TYPE)
    _PositionInitiationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionInitiationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionInitiationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionInitiationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionInitiationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    _____PositionInitiationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    ____PositionInitiationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PositionInitiationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____PositionInitiationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionInitiationFailure_protocolIEs__item__id._const_tab = ____PositionInitiationFailure_protocolIEs__item__id_tab
    ___PositionInitiationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositionInitiationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionInitiationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionInitiationFailure_protocolIEs__item__criticality._const_tab = ____PositionInitiationFailure_protocolIEs__item__id_tab
    ___PositionInitiationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionInitiationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionInitiationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionInitiationFailure_protocolIEs__item__value._const_tab = ____PositionInitiationFailure_protocolIEs__item__id_tab
    ___PositionInitiationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionInitiationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionInitiationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionInitiationFailure_protocolIEs__item__id),
        ('criticality', ___PositionInitiationFailure_protocolIEs__item__criticality),
        ('value', ___PositionInitiationFailure_protocolIEs__item__value),
        ])
    __PositionInitiationFailure_protocolIEs__item_._ext = None
    _PositionInitiationFailure_protocolIEs._cont = __PositionInitiationFailure_protocolIEs__item_
    _PositionInitiationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionInitiationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionInitiationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionInitiationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionInitiationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionInitiationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionInitiationFailure_protocolExtensions__item__id._const_tab = ____PositionInitiationFailure_protocolExtensions__item__id_tab
    ___PositionInitiationFailure_protocolExtensions__item__id._const_tab_at = None
    ___PositionInitiationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionInitiationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PositionInitiationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionInitiationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionInitiationFailure_protocolExtensions__item__criticality._const_tab = ____PositionInitiationFailure_protocolExtensions__item__criticality_tab
    ___PositionInitiationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionInitiationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionInitiationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PositionInitiationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionInitiationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionInitiationFailure_protocolExtensions__item__extensionValue._const_tab = ____PositionInitiationFailure_protocolExtensions__item__extensionValue_tab
    ___PositionInitiationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionInitiationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionInitiationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionInitiationFailure_protocolExtensions__item__id),
        ('criticality', ___PositionInitiationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionInitiationFailure_protocolExtensions__item__extensionValue),
        ])
    __PositionInitiationFailure_protocolExtensions__item_._ext = None
    _PositionInitiationFailure_protocolExtensions._cont = __PositionInitiationFailure_protocolExtensions__item_
    _PositionInitiationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionInitiationFailure._cont = ASN1Dict([
        ('protocolIEs', _PositionInitiationFailure_protocolIEs),
        ('protocolExtensions', _PositionInitiationFailure_protocolExtensions),
        ])
    PositionInitiationFailure._ext = []
    
    #-----< PositionInitiationFailureIEs >-----#
    PositionInitiationFailureIEs = CLASS(name='PositionInitiationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionInitiationFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    _PositionInitiationFailureIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    PositionInitiationFailureIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _PositionInitiationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _PositionInitiationFailureIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionInitiationFailureExtensions >-----#
    PositionInitiationFailureExtensions = CLASS(name='PositionInitiationFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PositionInitiationFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositionActivationRequest >-----#
    PositionActivationRequest = SEQ(name='PositionActivationRequest', mode=MODE_TYPE)
    _PositionActivationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionActivationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionActivationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionActivationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositioningMethod')))
    _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Positioning-ResponseTime')))
    _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositioningPriority')))
    _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'EnvironmentCharacterisation')))
    _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTDOAPositioning')))
    _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPSPositioning')))
    _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOAAssistanceData')))
    ____PositionActivationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 34), ('criticality', 'reject'), ('Value', _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 39), ('criticality', 'ignore'), ('Value', _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'reject'), ('Value', _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 36), ('criticality', 'reject'), ('Value', _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 37), ('criticality', 'reject'), ('Value', _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionActivationRequest_protocolIEs__item__id._const_tab = ____PositionActivationRequest_protocolIEs__item__id_tab
    ___PositionActivationRequest_protocolIEs__item__id._const_tab_at = None
    ___PositionActivationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionActivationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionActivationRequest_protocolIEs__item__criticality._const_tab = ____PositionActivationRequest_protocolIEs__item__id_tab
    ___PositionActivationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionActivationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionActivationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionActivationRequest_protocolIEs__item__value._const_tab = ____PositionActivationRequest_protocolIEs__item__id_tab
    ___PositionActivationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionActivationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionActivationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionActivationRequest_protocolIEs__item__id),
        ('criticality', ___PositionActivationRequest_protocolIEs__item__criticality),
        ('value', ___PositionActivationRequest_protocolIEs__item__value),
        ])
    __PositionActivationRequest_protocolIEs__item_._ext = None
    _PositionActivationRequest_protocolIEs._cont = __PositionActivationRequest_protocolIEs__item_
    _PositionActivationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionActivationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionActivationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionActivationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionActivationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IncludeVelocity')))
    _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AmountOfReporting')))
    _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellIDPositioning')))
    _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSSPositioning')))
    ____PositionActivationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Extension', _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 59), ('criticality', 'ignore'), ('Extension', _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 66), ('criticality', 'ignore'), ('Extension', _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'reject'), ('Extension', _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionActivationRequest_protocolExtensions__item__id._const_tab = ____PositionActivationRequest_protocolExtensions__item__id_tab
    ___PositionActivationRequest_protocolExtensions__item__id._const_tab_at = None
    ___PositionActivationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionActivationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositionActivationRequest_protocolExtensions__item__criticality._const_tab = ____PositionActivationRequest_protocolExtensions__item__id_tab
    ___PositionActivationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionActivationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionActivationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositionActivationRequest_protocolExtensions__item__extensionValue._const_tab = ____PositionActivationRequest_protocolExtensions__item__id_tab
    ___PositionActivationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionActivationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionActivationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionActivationRequest_protocolExtensions__item__id),
        ('criticality', ___PositionActivationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionActivationRequest_protocolExtensions__item__extensionValue),
        ])
    __PositionActivationRequest_protocolExtensions__item_._ext = None
    _PositionActivationRequest_protocolExtensions._cont = __PositionActivationRequest_protocolExtensions__item_
    _PositionActivationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionActivationRequest._cont = ASN1Dict([
        ('protocolIEs', _PositionActivationRequest_protocolIEs),
        ('protocolExtensions', _PositionActivationRequest_protocolExtensions),
        ])
    PositionActivationRequest._ext = []
    
    #-----< PositionActivationRequestIEs >-----#
    PositionActivationRequestIEs = CLASS(name='PositionActivationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionActivationRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositioningMethod')))
    _PositionActivationRequestIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Positioning-ResponseTime')))
    _PositionActivationRequestIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositioningPriority')))
    _PositionActivationRequestIEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'EnvironmentCharacterisation')))
    _PositionActivationRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTDOAPositioning')))
    _PositionActivationRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GPSPositioning')))
    _PositionActivationRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOAAssistanceData')))
    PositionActivationRequestIEs._val = ASN1Set(rv=[dict([('id', 34), ('criticality', 'reject'), ('Value', _PositionActivationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _PositionActivationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 32), ('criticality', 'ignore'), ('Value', _PositionActivationRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 39), ('criticality', 'ignore'), ('Value', _PositionActivationRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'reject'), ('Value', _PositionActivationRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 36), ('criticality', 'reject'), ('Value', _PositionActivationRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 37), ('criticality', 'reject'), ('Value', _PositionActivationRequestIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionActivationRequestExtensions >-----#
    PositionActivationRequestExtensions = CLASS(name='PositionActivationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _PositionActivationRequestExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'IncludeVelocity')))
    _PositionActivationRequestExtensions_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AmountOfReporting')))
    _PositionActivationRequestExtensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellIDPositioning')))
    _PositionActivationRequestExtensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSSPositioning')))
    PositionActivationRequestExtensions._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Extension', _PositionActivationRequestExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 59), ('criticality', 'ignore'), ('Extension', _PositionActivationRequestExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 66), ('criticality', 'ignore'), ('Extension', _PositionActivationRequestExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 73), ('criticality', 'reject'), ('Extension', _PositionActivationRequestExtensions_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionActivationResponse >-----#
    PositionActivationResponse = SEQ(name='PositionActivationResponse', mode=MODE_TYPE)
    _PositionActivationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionActivationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionActivationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionActivationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimateInfo')))
    _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MeasuredResultsList')))
    _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-MeasuredResultsSets')))
    _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-MeasuredResultsSets')))
    _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-Group')))
    ____PositionActivationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 51), ('criticality', 'reject'), ('Value', _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionActivationResponse_protocolIEs__item__id._const_tab = ____PositionActivationResponse_protocolIEs__item__id_tab
    ___PositionActivationResponse_protocolIEs__item__id._const_tab_at = None
    ___PositionActivationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionActivationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionActivationResponse_protocolIEs__item__criticality._const_tab = ____PositionActivationResponse_protocolIEs__item__id_tab
    ___PositionActivationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionActivationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionActivationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionActivationResponse_protocolIEs__item__value._const_tab = ____PositionActivationResponse_protocolIEs__item__id_tab
    ___PositionActivationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionActivationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionActivationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionActivationResponse_protocolIEs__item__id),
        ('criticality', ___PositionActivationResponse_protocolIEs__item__criticality),
        ('value', ___PositionActivationResponse_protocolIEs__item__value),
        ])
    __PositionActivationResponse_protocolIEs__item_._ext = None
    _PositionActivationResponse_protocolIEs._cont = __PositionActivationResponse_protocolIEs__item_
    _PositionActivationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionActivationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionActivationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionActivationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionActivationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VelocityEstimate')))
    _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MeasInstructionsUsed')))
    _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-MeasuredResultsList')))
    _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AdditionalGPSAssistDataRequired')))
    _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AdditionalGanssAssistDataRequired')))
    _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-ReferenceCellInfoSAS-centric')))
    _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-IRATMeasuredResultsSets')))
    _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddPos-MeasuredResults')))
    ____PositionActivationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 42), ('criticality', 'ignore'), ('Extension', _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 60), ('criticality', 'ignore'), ('Extension', _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'reject'), ('Extension', _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Extension', _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'reject'), ('Extension', _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'ignore'), ('Extension', _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 141), ('criticality', 'reject'), ('Extension', _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionActivationResponse_protocolExtensions__item__id._const_tab = ____PositionActivationResponse_protocolExtensions__item__id_tab
    ___PositionActivationResponse_protocolExtensions__item__id._const_tab_at = None
    ___PositionActivationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionActivationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositionActivationResponse_protocolExtensions__item__criticality._const_tab = ____PositionActivationResponse_protocolExtensions__item__id_tab
    ___PositionActivationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionActivationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionActivationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositionActivationResponse_protocolExtensions__item__extensionValue._const_tab = ____PositionActivationResponse_protocolExtensions__item__id_tab
    ___PositionActivationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionActivationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionActivationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionActivationResponse_protocolExtensions__item__id),
        ('criticality', ___PositionActivationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionActivationResponse_protocolExtensions__item__extensionValue),
        ])
    __PositionActivationResponse_protocolExtensions__item_._ext = None
    _PositionActivationResponse_protocolExtensions._cont = __PositionActivationResponse_protocolExtensions__item_
    _PositionActivationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionActivationResponse._cont = ASN1Dict([
        ('protocolIEs', _PositionActivationResponse_protocolIEs),
        ('protocolExtensions', _PositionActivationResponse_protocolExtensions),
        ])
    PositionActivationResponse._ext = []
    
    #-----< PositionActivationResponseIEs >-----#
    PositionActivationResponseIEs = CLASS(name='PositionActivationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionActivationResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimateInfo')))
    _PositionActivationResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MeasuredResultsList')))
    _PositionActivationResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-MeasuredResultsSets')))
    _PositionActivationResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-MeasuredResultsSets')))
    _PositionActivationResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-Group')))
    PositionActivationResponseIEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _PositionActivationResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'reject'), ('Value', _PositionActivationResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 20), ('criticality', 'reject'), ('Value', _PositionActivationResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 51), ('criticality', 'reject'), ('Value', _PositionActivationResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _PositionActivationResponseIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionActivationResponseExtensions >-----#
    PositionActivationResponseExtensions = CLASS(name='PositionActivationResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _PositionActivationResponseExtensions_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VelocityEstimate')))
    _PositionActivationResponseExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MeasInstructionsUsed')))
    _PositionActivationResponseExtensions_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-MeasuredResultsList')))
    _PositionActivationResponseExtensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AdditionalGPSAssistDataRequired')))
    _PositionActivationResponseExtensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AdditionalGanssAssistDataRequired')))
    _PositionActivationResponseExtensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-ReferenceCellInfoSAS-centric')))
    _PositionActivationResponseExtensions_val_Extension_6 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-IRATMeasuredResultsSets')))
    _PositionActivationResponseExtensions_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddPos-MeasuredResults')))
    PositionActivationResponseExtensions._val = ASN1Set(rv=[dict([('id', 42), ('criticality', 'ignore'), ('Extension', _PositionActivationResponseExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 60), ('criticality', 'ignore'), ('Extension', _PositionActivationResponseExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 71), ('criticality', 'reject'), ('Extension', _PositionActivationResponseExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Extension', _PositionActivationResponseExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _PositionActivationResponseExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'reject'), ('Extension', _PositionActivationResponseExtensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'ignore'), ('Extension', _PositionActivationResponseExtensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 141), ('criticality', 'reject'), ('Extension', _PositionActivationResponseExtensions_val_Extension_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionActivationFailure >-----#
    PositionActivationFailure = SEQ(name='PositionActivationFailure', mode=MODE_TYPE)
    _PositionActivationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionActivationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionActivationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionActivationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionActivationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    _____PositionActivationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    ____PositionActivationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PositionActivationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____PositionActivationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionActivationFailure_protocolIEs__item__id._const_tab = ____PositionActivationFailure_protocolIEs__item__id_tab
    ___PositionActivationFailure_protocolIEs__item__id._const_tab_at = None
    ___PositionActivationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionActivationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionActivationFailure_protocolIEs__item__criticality._const_tab = ____PositionActivationFailure_protocolIEs__item__id_tab
    ___PositionActivationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionActivationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionActivationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionActivationFailure_protocolIEs__item__value._const_tab = ____PositionActivationFailure_protocolIEs__item__id_tab
    ___PositionActivationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionActivationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionActivationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionActivationFailure_protocolIEs__item__id),
        ('criticality', ___PositionActivationFailure_protocolIEs__item__criticality),
        ('value', ___PositionActivationFailure_protocolIEs__item__value),
        ])
    __PositionActivationFailure_protocolIEs__item_._ext = None
    _PositionActivationFailure_protocolIEs._cont = __PositionActivationFailure_protocolIEs__item_
    _PositionActivationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionActivationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionActivationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionActivationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionActivationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionActivationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionActivationFailure_protocolExtensions__item__id._const_tab = ____PositionActivationFailure_protocolExtensions__item__id_tab
    ___PositionActivationFailure_protocolExtensions__item__id._const_tab_at = None
    ___PositionActivationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionActivationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PositionActivationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionActivationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionActivationFailure_protocolExtensions__item__criticality._const_tab = ____PositionActivationFailure_protocolExtensions__item__criticality_tab
    ___PositionActivationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionActivationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionActivationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PositionActivationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionActivationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionActivationFailure_protocolExtensions__item__extensionValue._const_tab = ____PositionActivationFailure_protocolExtensions__item__extensionValue_tab
    ___PositionActivationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionActivationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionActivationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionActivationFailure_protocolExtensions__item__id),
        ('criticality', ___PositionActivationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionActivationFailure_protocolExtensions__item__extensionValue),
        ])
    __PositionActivationFailure_protocolExtensions__item_._ext = None
    _PositionActivationFailure_protocolExtensions._cont = __PositionActivationFailure_protocolExtensions__item_
    _PositionActivationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionActivationFailure._cont = ASN1Dict([
        ('protocolIEs', _PositionActivationFailure_protocolIEs),
        ('protocolExtensions', _PositionActivationFailure_protocolExtensions),
        ])
    PositionActivationFailure._ext = []
    
    #-----< PositionActivationFailureIEs >-----#
    PositionActivationFailureIEs = CLASS(name='PositionActivationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionActivationFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    _PositionActivationFailureIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    PositionActivationFailureIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _PositionActivationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _PositionActivationFailureIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionActivationFailureExtensions >-----#
    PositionActivationFailureExtensions = CLASS(name='PositionActivationFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PositionActivationFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationReport >-----#
    InformationReport = SEQ(name='InformationReport', mode=MODE_TYPE)
    _InformationReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __InformationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___InformationReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____InformationReport_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____InformationReport_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    _____InformationReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rprt')))
    ____InformationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____InformationReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____InformationReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InformationReport_protocolIEs__item__id._const_tab = ____InformationReport_protocolIEs__item__id_tab
    ___InformationReport_protocolIEs__item__id._const_tab_at = None
    ___InformationReport_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___InformationReport_protocolIEs__item__criticality._const_tab = ____InformationReport_protocolIEs__item__id_tab
    ___InformationReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___InformationReport_protocolIEs__item__value._const_tab = ____InformationReport_protocolIEs__item__id_tab
    ___InformationReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationReport_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationReport_protocolIEs__item__id),
        ('criticality', ___InformationReport_protocolIEs__item__criticality),
        ('value', ___InformationReport_protocolIEs__item__value),
        ])
    __InformationReport_protocolIEs__item_._ext = None
    _InformationReport_protocolIEs._cont = __InformationReport_protocolIEs__item_
    _InformationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationReport_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___InformationReport_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationReport_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReport_protocolExtensions__item__id._const_tab = ____InformationReport_protocolExtensions__item__id_tab
    ___InformationReport_protocolExtensions__item__id._const_tab_at = None
    ___InformationReport_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationReport_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationReport_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationReport_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReport_protocolExtensions__item__criticality._const_tab = ____InformationReport_protocolExtensions__item__criticality_tab
    ___InformationReport_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationReport_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationReport_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationReport_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationReport_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationReport_protocolExtensions__item__extensionValue._const_tab = ____InformationReport_protocolExtensions__item__extensionValue_tab
    ___InformationReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationReport_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationReport_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationReport_protocolExtensions__item__id),
        ('criticality', ___InformationReport_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationReport_protocolExtensions__item__extensionValue),
        ])
    __InformationReport_protocolExtensions__item_._ext = None
    _InformationReport_protocolExtensions._cont = __InformationReport_protocolExtensions__item_
    _InformationReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationReport._cont = ASN1Dict([
        ('protocolIEs', _InformationReport_protocolIEs),
        ('protocolExtensions', _InformationReport_protocolExtensions),
        ])
    InformationReport._ext = []
    
    #-----< InformationReport-IEs >-----#
    InformationReport_IEs = CLASS(name='InformationReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _InformationReport_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    _InformationReport_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeObjectType-InfEx-Rprt')))
    InformationReport_IEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _InformationReport_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _InformationReport_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationReport-Extensions >-----#
    InformationReport_Extensions = CLASS(name='InformationReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    InformationReport_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeObjectType-InfEx-Rprt >-----#
    InformationExchangeObjectType_InfEx_Rprt = CHOICE(name='InformationExchangeObjectType-InfEx-Rprt', mode=MODE_TYPE)
    _InformationExchangeObjectType_InfEx_Rprt_referencePosition = SEQ(name='referencePosition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-PDU-Contents', 'RefPosition-InfEx-Rprt')))
    InformationExchangeObjectType_InfEx_Rprt._cont = ASN1Dict([
        ('referencePosition', _InformationExchangeObjectType_InfEx_Rprt_referencePosition),
        ])
    InformationExchangeObjectType_InfEx_Rprt._ext = []
    
    #-----< RefPosition-InfEx-Rprt >-----#
    RefPosition_InfEx_Rprt = SEQ(name='RefPosition-InfEx-Rprt', mode=MODE_TYPE)
    _RefPosition_InfEx_Rprt_requestedDataValueInformation = CHOICE(name='requestedDataValueInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-IEs', 'RequestedDataValueInformation')))
    _RefPosition_InfEx_Rprt_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RefPosition_InfEx_Rprt_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____RefPosition_InfEx_Rprt_iE_Extensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RefPosition_InfEx_Rprt_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__id._const_tab = ____RefPosition_InfEx_Rprt_iE_Extensions__item__id_tab
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__id._const_tab_at = None
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__id._const_tab_id = 'id'
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RefPosition_InfEx_Rprt_iE_Extensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RefPosition_InfEx_Rprt_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__criticality._const_tab = ____RefPosition_InfEx_Rprt_iE_Extensions__item__criticality_tab
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RefPosition_InfEx_Rprt_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____RefPosition_InfEx_Rprt_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab = ____RefPosition_InfEx_Rprt_iE_Extensions__item__extensionValue_tab
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RefPosition_InfEx_Rprt_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RefPosition_InfEx_Rprt_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RefPosition_InfEx_Rprt_iE_Extensions__item__id),
        ('criticality', ___RefPosition_InfEx_Rprt_iE_Extensions__item__criticality),
        ('extensionValue', ___RefPosition_InfEx_Rprt_iE_Extensions__item__extensionValue),
        ])
    __RefPosition_InfEx_Rprt_iE_Extensions__item_._ext = None
    _RefPosition_InfEx_Rprt_iE_Extensions._cont = __RefPosition_InfEx_Rprt_iE_Extensions__item_
    _RefPosition_InfEx_Rprt_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RefPosition_InfEx_Rprt._cont = ASN1Dict([
        ('requestedDataValueInformation', _RefPosition_InfEx_Rprt_requestedDataValueInformation),
        ('iE-Extensions', _RefPosition_InfEx_Rprt_iE_Extensions),
        ])
    RefPosition_InfEx_Rprt._ext = []
    
    #-----< RefPositionItem-InfEx-Rprt-ExtIEs >-----#
    RefPositionItem_InfEx_Rprt_ExtIEs = CLASS(name='RefPositionItem-InfEx-Rprt-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    RefPositionItem_InfEx_Rprt_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeTerminationRequest >-----#
    InformationExchangeTerminationRequest = SEQ(name='InformationExchangeTerminationRequest', mode=MODE_TYPE)
    _InformationExchangeTerminationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeTerminationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeTerminationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____InformationExchangeTerminationRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____InformationExchangeTerminationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolIEs__item__id._const_tab = ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab
    ___InformationExchangeTerminationRequest_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeTerminationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality._const_tab = ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeTerminationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeTerminationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___InformationExchangeTerminationRequest_protocolIEs__item__value._const_tab = ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab
    ___InformationExchangeTerminationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationExchangeTerminationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationExchangeTerminationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeTerminationRequest_protocolIEs__item__id),
        ('criticality', ___InformationExchangeTerminationRequest_protocolIEs__item__criticality),
        ('value', ___InformationExchangeTerminationRequest_protocolIEs__item__value),
        ])
    __InformationExchangeTerminationRequest_protocolIEs__item_._ext = None
    _InformationExchangeTerminationRequest_protocolIEs._cont = __InformationExchangeTerminationRequest_protocolIEs__item_
    _InformationExchangeTerminationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeTerminationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeTerminationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id._const_tab = ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeTerminationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality._const_tab = ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationExchangeTerminationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeTerminationRequest_protocolExtensions__item__id),
        ('criticality', ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeTerminationRequest_protocolExtensions__item_._ext = None
    _InformationExchangeTerminationRequest_protocolExtensions._cont = __InformationExchangeTerminationRequest_protocolExtensions__item_
    _InformationExchangeTerminationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeTerminationRequest._cont = ASN1Dict([
        ('protocolIEs', _InformationExchangeTerminationRequest_protocolIEs),
        ('protocolExtensions', _InformationExchangeTerminationRequest_protocolExtensions),
        ])
    InformationExchangeTerminationRequest._ext = []
    
    #-----< InformationExchangeTerminationRequest-IEs >-----#
    InformationExchangeTerminationRequest_IEs = CLASS(name='InformationExchangeTerminationRequest-IEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _InformationExchangeTerminationRequest_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    InformationExchangeTerminationRequest_IEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _InformationExchangeTerminationRequest_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeTerminationRequest-Extensions >-----#
    InformationExchangeTerminationRequest_Extensions = CLASS(name='InformationExchangeTerminationRequest-Extensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    InformationExchangeTerminationRequest_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeFailureIndication >-----#
    InformationExchangeFailureIndication = SEQ(name='InformationExchangeFailureIndication', mode=MODE_TYPE)
    _InformationExchangeFailureIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __InformationExchangeFailureIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___InformationExchangeFailureIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____InformationExchangeFailureIndication_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    ____InformationExchangeFailureIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolIEs__item__id._const_tab = ____InformationExchangeFailureIndication_protocolIEs__item__id_tab
    ___InformationExchangeFailureIndication_protocolIEs__item__id._const_tab_at = None
    ___InformationExchangeFailureIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality._const_tab = ____InformationExchangeFailureIndication_protocolIEs__item__id_tab
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeFailureIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeFailureIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___InformationExchangeFailureIndication_protocolIEs__item__value._const_tab = ____InformationExchangeFailureIndication_protocolIEs__item__id_tab
    ___InformationExchangeFailureIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationExchangeFailureIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationExchangeFailureIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeFailureIndication_protocolIEs__item__id),
        ('criticality', ___InformationExchangeFailureIndication_protocolIEs__item__criticality),
        ('value', ___InformationExchangeFailureIndication_protocolIEs__item__value),
        ])
    __InformationExchangeFailureIndication_protocolIEs__item_._ext = None
    _InformationExchangeFailureIndication_protocolIEs._cont = __InformationExchangeFailureIndication_protocolIEs__item_
    _InformationExchangeFailureIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationExchangeFailureIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationExchangeFailureIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___InformationExchangeFailureIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolExtensions__item__id._const_tab = ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab
    ___InformationExchangeFailureIndication_protocolExtensions__item__id._const_tab_at = None
    ___InformationExchangeFailureIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality._const_tab = ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationExchangeFailureIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue._const_tab = ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationExchangeFailureIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationExchangeFailureIndication_protocolExtensions__item__id),
        ('criticality', ___InformationExchangeFailureIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue),
        ])
    __InformationExchangeFailureIndication_protocolExtensions__item_._ext = None
    _InformationExchangeFailureIndication_protocolExtensions._cont = __InformationExchangeFailureIndication_protocolExtensions__item_
    _InformationExchangeFailureIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationExchangeFailureIndication._cont = ASN1Dict([
        ('protocolIEs', _InformationExchangeFailureIndication_protocolIEs),
        ('protocolExtensions', _InformationExchangeFailureIndication_protocolExtensions),
        ])
    InformationExchangeFailureIndication._ext = []
    
    #-----< InformationExchangeFailureIndication-IEs >-----#
    InformationExchangeFailureIndication_IEs = CLASS(name='InformationExchangeFailureIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _InformationExchangeFailureIndication_IEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'InformationExchangeID')))
    _InformationExchangeFailureIndication_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    InformationExchangeFailureIndication_IEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _InformationExchangeFailureIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _InformationExchangeFailureIndication_IEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationExchangeFailureIndication-Extensions >-----#
    InformationExchangeFailureIndication_Extensions = CLASS(name='InformationExchangeFailureIndication-Extensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    InformationExchangeFailureIndication_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ErrorIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ErrorIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___ErrorIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____ErrorIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__id._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__id._const_tab_at = None
    ___ErrorIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ErrorIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab = ____ErrorIndication_protocolExtensions__item__criticality_tab
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ErrorIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____ErrorIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab = ____ErrorIndication_protocolExtensions__item__extensionValue_tab
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ErrorIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolExtensions__item__id),
        ('criticality', ___ErrorIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___ErrorIndication_protocolExtensions__item__extensionValue),
        ])
    __ErrorIndication_protocolExtensions__item_._ext = None
    _ErrorIndication_protocolExtensions._cont = __ErrorIndication_protocolExtensions__item_
    _ErrorIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ('protocolExtensions', _ErrorIndication_protocolExtensions),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name='ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CriticalityDiagnostics')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 2), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndicationExtensions >-----#
    ErrorIndicationExtensions = CLASS(name='ErrorIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ErrorIndicationExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositionParameterModification >-----#
    PositionParameterModification = SEQ(name='PositionParameterModification', mode=MODE_TYPE)
    _PositionParameterModification_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionParameterModification_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionParameterModification_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionParameterModification_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionParameterModification_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _____PositionParameterModification_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-Group')))
    ____PositionParameterModification_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'reject'), ('Value', _____PositionParameterModification_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _____PositionParameterModification_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionParameterModification_protocolIEs__item__id._const_tab = ____PositionParameterModification_protocolIEs__item__id_tab
    ___PositionParameterModification_protocolIEs__item__id._const_tab_at = None
    ___PositionParameterModification_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionParameterModification_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionParameterModification_protocolIEs__item__criticality._const_tab = ____PositionParameterModification_protocolIEs__item__id_tab
    ___PositionParameterModification_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionParameterModification_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionParameterModification_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionParameterModification_protocolIEs__item__value._const_tab = ____PositionParameterModification_protocolIEs__item__id_tab
    ___PositionParameterModification_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionParameterModification_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionParameterModification_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionParameterModification_protocolIEs__item__id),
        ('criticality', ___PositionParameterModification_protocolIEs__item__criticality),
        ('value', ___PositionParameterModification_protocolIEs__item__value),
        ])
    __PositionParameterModification_protocolIEs__item_._ext = None
    _PositionParameterModification_protocolIEs._cont = __PositionParameterModification_protocolIEs__item_
    _PositionParameterModification_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionParameterModification_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionParameterModification_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionParameterModification_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionParameterModification_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PositionParameterModification_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RRCstateChange')))
    ____PositionParameterModification_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Extension', _____PositionParameterModification_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionParameterModification_protocolExtensions__item__id._const_tab = ____PositionParameterModification_protocolExtensions__item__id_tab
    ___PositionParameterModification_protocolExtensions__item__id._const_tab_at = None
    ___PositionParameterModification_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionParameterModification_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositionParameterModification_protocolExtensions__item__criticality._const_tab = ____PositionParameterModification_protocolExtensions__item__id_tab
    ___PositionParameterModification_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionParameterModification_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionParameterModification_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositionParameterModification_protocolExtensions__item__extensionValue._const_tab = ____PositionParameterModification_protocolExtensions__item__id_tab
    ___PositionParameterModification_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionParameterModification_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionParameterModification_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionParameterModification_protocolExtensions__item__id),
        ('criticality', ___PositionParameterModification_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionParameterModification_protocolExtensions__item__extensionValue),
        ])
    __PositionParameterModification_protocolExtensions__item_._ext = None
    _PositionParameterModification_protocolExtensions._cont = __PositionParameterModification_protocolExtensions__item_
    _PositionParameterModification_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionParameterModification._cont = ASN1Dict([
        ('protocolIEs', _PositionParameterModification_protocolIEs),
        ('protocolExtensions', _PositionParameterModification_protocolExtensions),
        ])
    PositionParameterModification._ext = []
    
    #-----< PositionParameterModificationIEs >-----#
    PositionParameterModificationIEs = CLASS(name='PositionParameterModificationIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionParameterModificationIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UC-ID')))
    _PositionParameterModificationIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UTDOA-Group')))
    PositionParameterModificationIEs._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'reject'), ('Value', _PositionParameterModificationIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 26), ('criticality', 'reject'), ('Value', _PositionParameterModificationIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionParameterModificationExtensions >-----#
    PositionParameterModificationExtensions = CLASS(name='PositionParameterModificationExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _PositionParameterModificationExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'RRCstateChange')))
    PositionParameterModificationExtensions._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'ignore'), ('Extension', _PositionParameterModificationExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_PCAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_PCAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_PCAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name='PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Abort >-----#
    Abort = SEQ(name='Abort', mode=MODE_TYPE)
    _Abort_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __Abort_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___Abort_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____Abort_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____Abort_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    ____Abort_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _____Abort_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Abort_protocolIEs__item__id._const_tab = ____Abort_protocolIEs__item__id_tab
    ___Abort_protocolIEs__item__id._const_tab_at = None
    ___Abort_protocolIEs__item__id._const_tab_id = 'id'
    ___Abort_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___Abort_protocolIEs__item__criticality._const_tab = ____Abort_protocolIEs__item__id_tab
    ___Abort_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Abort_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Abort_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___Abort_protocolIEs__item__value._const_tab = ____Abort_protocolIEs__item__id_tab
    ___Abort_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Abort_protocolIEs__item__value._const_tab_id = 'Value'
    __Abort_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Abort_protocolIEs__item__id),
        ('criticality', ___Abort_protocolIEs__item__criticality),
        ('value', ___Abort_protocolIEs__item__value),
        ])
    __Abort_protocolIEs__item_._ext = None
    _Abort_protocolIEs._cont = __Abort_protocolIEs__item_
    _Abort_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Abort_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Abort_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___Abort_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____Abort_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Abort_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Abort_protocolExtensions__item__id._const_tab = ____Abort_protocolExtensions__item__id_tab
    ___Abort_protocolExtensions__item__id._const_tab_at = None
    ___Abort_protocolExtensions__item__id._const_tab_id = 'id'
    ___Abort_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Abort_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Abort_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Abort_protocolExtensions__item__criticality._const_tab = ____Abort_protocolExtensions__item__criticality_tab
    ___Abort_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Abort_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Abort_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Abort_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____Abort_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Abort_protocolExtensions__item__extensionValue._const_tab = ____Abort_protocolExtensions__item__extensionValue_tab
    ___Abort_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Abort_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Abort_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Abort_protocolExtensions__item__id),
        ('criticality', ___Abort_protocolExtensions__item__criticality),
        ('extensionValue', ___Abort_protocolExtensions__item__extensionValue),
        ])
    __Abort_protocolExtensions__item_._ext = None
    _Abort_protocolExtensions._cont = __Abort_protocolExtensions__item_
    _Abort_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Abort._cont = ASN1Dict([
        ('protocolIEs', _Abort_protocolIEs),
        ('protocolExtensions', _Abort_protocolExtensions),
        ])
    Abort._ext = []
    
    #-----< AbortIEs >-----#
    AbortIEs = CLASS(name='AbortIEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _AbortIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    AbortIEs._val = ASN1Set(rv=[dict([('id', 1), ('criticality', 'ignore'), ('Value', _AbortIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< AbortExtensions >-----#
    AbortExtensions = CLASS(name='AbortExtensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    AbortExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositionPeriodicReport >-----#
    PositionPeriodicReport = SEQ(name='PositionPeriodicReport', mode=MODE_TYPE)
    _PositionPeriodicReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionPeriodicReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionPeriodicReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionPeriodicReport_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimateInfo')))
    _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VelocityEstimate')))
    _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MeasuredResultsList')))
    _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-MeasuredResultsSets')))
    _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-MeasuredResultsSets')))
    _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_5 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    ____PositionPeriodicReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'ignore'), ('Value', _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'ignore'), ('Value', _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 20), ('criticality', 'ignore'), ('Value', _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 51), ('criticality', 'ignore'), ('Value', _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionPeriodicReport_protocolIEs__item__id._const_tab = ____PositionPeriodicReport_protocolIEs__item__id_tab
    ___PositionPeriodicReport_protocolIEs__item__id._const_tab_at = None
    ___PositionPeriodicReport_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionPeriodicReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionPeriodicReport_protocolIEs__item__criticality._const_tab = ____PositionPeriodicReport_protocolIEs__item__id_tab
    ___PositionPeriodicReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionPeriodicReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionPeriodicReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionPeriodicReport_protocolIEs__item__value._const_tab = ____PositionPeriodicReport_protocolIEs__item__id_tab
    ___PositionPeriodicReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionPeriodicReport_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionPeriodicReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionPeriodicReport_protocolIEs__item__id),
        ('criticality', ___PositionPeriodicReport_protocolIEs__item__criticality),
        ('value', ___PositionPeriodicReport_protocolIEs__item__value),
        ])
    __PositionPeriodicReport_protocolIEs__item_._ext = None
    _PositionPeriodicReport_protocolIEs._cont = __PositionPeriodicReport_protocolIEs__item_
    _PositionPeriodicReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionPeriodicReport_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionPeriodicReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionPeriodicReport_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionPeriodicReport_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-MeasuredResultsList')))
    _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AdditionalGPSAssistDataRequired')))
    _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AdditionalGanssAssistDataRequired')))
    _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-ReferenceCellInfoSAS-centric')))
    _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-IRATMeasuredResultsSets')))
    _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddPos-MeasuredResults')))
    ____PositionPeriodicReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 71), ('criticality', 'ignore'), ('Extension', _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Extension', _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'reject'), ('Extension', _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'ignore'), ('Extension', _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 141), ('criticality', 'ignore'), ('Extension', _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionPeriodicReport_protocolExtensions__item__id._const_tab = ____PositionPeriodicReport_protocolExtensions__item__id_tab
    ___PositionPeriodicReport_protocolExtensions__item__id._const_tab_at = None
    ___PositionPeriodicReport_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionPeriodicReport_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositionPeriodicReport_protocolExtensions__item__criticality._const_tab = ____PositionPeriodicReport_protocolExtensions__item__id_tab
    ___PositionPeriodicReport_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionPeriodicReport_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionPeriodicReport_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositionPeriodicReport_protocolExtensions__item__extensionValue._const_tab = ____PositionPeriodicReport_protocolExtensions__item__id_tab
    ___PositionPeriodicReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionPeriodicReport_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionPeriodicReport_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionPeriodicReport_protocolExtensions__item__id),
        ('criticality', ___PositionPeriodicReport_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionPeriodicReport_protocolExtensions__item__extensionValue),
        ])
    __PositionPeriodicReport_protocolExtensions__item_._ext = None
    _PositionPeriodicReport_protocolExtensions._cont = __PositionPeriodicReport_protocolExtensions__item_
    _PositionPeriodicReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionPeriodicReport._cont = ASN1Dict([
        ('protocolIEs', _PositionPeriodicReport_protocolIEs),
        ('protocolExtensions', _PositionPeriodicReport_protocolExtensions),
        ])
    PositionPeriodicReport._ext = []
    
    #-----< PositionPeriodicReport-IEs >-----#
    PositionPeriodicReport_IEs = CLASS(name='PositionPeriodicReport-IEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionPeriodicReport_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimateInfo')))
    _PositionPeriodicReport_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VelocityEstimate')))
    _PositionPeriodicReport_IEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'MeasuredResultsList')))
    _PositionPeriodicReport_IEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-MeasuredResultsSets')))
    _PositionPeriodicReport_IEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-MeasuredResultsSets')))
    _PositionPeriodicReport_IEs_val_Value_5 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    PositionPeriodicReport_IEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _PositionPeriodicReport_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'ignore'), ('Value', _PositionPeriodicReport_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 10), ('criticality', 'ignore'), ('Value', _PositionPeriodicReport_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 20), ('criticality', 'ignore'), ('Value', _PositionPeriodicReport_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 51), ('criticality', 'ignore'), ('Value', _PositionPeriodicReport_IEs_val_Value_4), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _PositionPeriodicReport_IEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionPeriodicReport-Extensions >-----#
    PositionPeriodicReport_Extensions = CLASS(name='PositionPeriodicReport-Extensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    _PositionPeriodicReport_Extensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'GANSS-MeasuredResultsList')))
    _PositionPeriodicReport_Extensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AdditionalGPSAssistDataRequired')))
    _PositionPeriodicReport_Extensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AdditionalGanssAssistDataRequired')))
    _PositionPeriodicReport_Extensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'OTDOA-ReferenceCellInfoSAS-centric')))
    _PositionPeriodicReport_Extensions_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'CellId-IRATMeasuredResultsSets')))
    _PositionPeriodicReport_Extensions_val_Extension_5 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AddPos-MeasuredResults')))
    PositionPeriodicReport_Extensions._val = ASN1Set(rv=[dict([('id', 71), ('criticality', 'ignore'), ('Extension', _PositionPeriodicReport_Extensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 78), ('criticality', 'ignore'), ('Extension', _PositionPeriodicReport_Extensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Extension', _PositionPeriodicReport_Extensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 117), ('criticality', 'reject'), ('Extension', _PositionPeriodicReport_Extensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 125), ('criticality', 'ignore'), ('Extension', _PositionPeriodicReport_Extensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 141), ('criticality', 'ignore'), ('Extension', _PositionPeriodicReport_Extensions_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionPeriodicResult >-----#
    PositionPeriodicResult = SEQ(name='PositionPeriodicResult', mode=MODE_TYPE)
    _PositionPeriodicResult_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionPeriodicResult_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionPeriodicResult_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionPeriodicResult_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VelocityEstimate')))
    _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositionData')))
    _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AccuracyFulfilmentIndicator')))
    _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    ____PositionPeriodicResult_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'ignore'), ('Value', _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'ignore'), ('Value', _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionPeriodicResult_protocolIEs__item__id._const_tab = ____PositionPeriodicResult_protocolIEs__item__id_tab
    ___PositionPeriodicResult_protocolIEs__item__id._const_tab_at = None
    ___PositionPeriodicResult_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionPeriodicResult_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionPeriodicResult_protocolIEs__item__criticality._const_tab = ____PositionPeriodicResult_protocolIEs__item__id_tab
    ___PositionPeriodicResult_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionPeriodicResult_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionPeriodicResult_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionPeriodicResult_protocolIEs__item__value._const_tab = ____PositionPeriodicResult_protocolIEs__item__id_tab
    ___PositionPeriodicResult_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionPeriodicResult_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionPeriodicResult_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionPeriodicResult_protocolIEs__item__id),
        ('criticality', ___PositionPeriodicResult_protocolIEs__item__criticality),
        ('value', ___PositionPeriodicResult_protocolIEs__item__value),
        ])
    __PositionPeriodicResult_protocolIEs__item_._ext = None
    _PositionPeriodicResult_protocolIEs._cont = __PositionPeriodicResult_protocolIEs__item_
    _PositionPeriodicResult_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionPeriodicResult_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionPeriodicResult_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionPeriodicResult_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionPeriodicResult_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionPeriodicResult_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionPeriodicResult_protocolExtensions__item__id._const_tab = ____PositionPeriodicResult_protocolExtensions__item__id_tab
    ___PositionPeriodicResult_protocolExtensions__item__id._const_tab_at = None
    ___PositionPeriodicResult_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionPeriodicResult_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PositionPeriodicResult_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionPeriodicResult_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionPeriodicResult_protocolExtensions__item__criticality._const_tab = ____PositionPeriodicResult_protocolExtensions__item__criticality_tab
    ___PositionPeriodicResult_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionPeriodicResult_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionPeriodicResult_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PositionPeriodicResult_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionPeriodicResult_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionPeriodicResult_protocolExtensions__item__extensionValue._const_tab = ____PositionPeriodicResult_protocolExtensions__item__extensionValue_tab
    ___PositionPeriodicResult_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionPeriodicResult_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionPeriodicResult_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionPeriodicResult_protocolExtensions__item__id),
        ('criticality', ___PositionPeriodicResult_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionPeriodicResult_protocolExtensions__item__extensionValue),
        ])
    __PositionPeriodicResult_protocolExtensions__item_._ext = None
    _PositionPeriodicResult_protocolExtensions._cont = __PositionPeriodicResult_protocolExtensions__item_
    _PositionPeriodicResult_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionPeriodicResult._cont = ASN1Dict([
        ('protocolIEs', _PositionPeriodicResult_protocolIEs),
        ('protocolExtensions', _PositionPeriodicResult_protocolExtensions),
        ])
    PositionPeriodicResult._ext = []
    
    #-----< PositionPeriodicResult-IEs >-----#
    PositionPeriodicResult_IEs = CLASS(name='PositionPeriodicResult-IEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionPeriodicResult_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'UE-PositionEstimate')))
    _PositionPeriodicResult_IEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'VelocityEstimate')))
    _PositionPeriodicResult_IEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PositionData')))
    _PositionPeriodicResult_IEs_val_Value_3 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'AccuracyFulfilmentIndicator')))
    _PositionPeriodicResult_IEs_val_Value_4 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'Cause')))
    PositionPeriodicResult_IEs._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'ignore'), ('Value', _PositionPeriodicResult_IEs_val_Value_0), ('presence', 'optional')]), dict([('id', 42), ('criticality', 'ignore'), ('Value', _PositionPeriodicResult_IEs_val_Value_1), ('presence', 'optional')]), dict([('id', 40), ('criticality', 'ignore'), ('Value', _PositionPeriodicResult_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _PositionPeriodicResult_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 1), ('criticality', 'ignore'), ('Value', _PositionPeriodicResult_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionPeriodicResult-Extensions >-----#
    PositionPeriodicResult_Extensions = CLASS(name='PositionPeriodicResult-Extensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PositionPeriodicResult_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PositionPeriodicTermination >-----#
    PositionPeriodicTermination = SEQ(name='PositionPeriodicTermination', mode=MODE_TYPE)
    _PositionPeriodicTermination_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Container')))
    __PositionPeriodicTermination_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolIE-Field')))
    ___PositionPeriodicTermination_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['id']))
    ____PositionPeriodicTermination_protocolIEs__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _____PositionPeriodicTermination_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PeriodicTerminationCause')))
    ____PositionPeriodicTermination_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 62), ('criticality', 'ignore'), ('Value', _____PositionPeriodicTermination_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionPeriodicTermination_protocolIEs__item__id._const_tab = ____PositionPeriodicTermination_protocolIEs__item__id_tab
    ___PositionPeriodicTermination_protocolIEs__item__id._const_tab_at = None
    ___PositionPeriodicTermination_protocolIEs__item__id._const_tab_id = 'id'
    ___PositionPeriodicTermination_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['criticality']))
    ___PositionPeriodicTermination_protocolIEs__item__criticality._const_tab = ____PositionPeriodicTermination_protocolIEs__item__id_tab
    ___PositionPeriodicTermination_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PositionPeriodicTermination_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___PositionPeriodicTermination_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-IES'), ['Value']))
    ___PositionPeriodicTermination_protocolIEs__item__value._const_tab = ____PositionPeriodicTermination_protocolIEs__item__id_tab
    ___PositionPeriodicTermination_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___PositionPeriodicTermination_protocolIEs__item__value._const_tab_id = 'Value'
    __PositionPeriodicTermination_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___PositionPeriodicTermination_protocolIEs__item__id),
        ('criticality', ___PositionPeriodicTermination_protocolIEs__item__criticality),
        ('value', ___PositionPeriodicTermination_protocolIEs__item__value),
        ])
    __PositionPeriodicTermination_protocolIEs__item_._ext = None
    _PositionPeriodicTermination_protocolIEs._cont = __PositionPeriodicTermination_protocolIEs__item_
    _PositionPeriodicTermination_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PositionPeriodicTermination_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionPeriodicTermination_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-Containers', 'ProtocolExtensionField')))
    ___PositionPeriodicTermination_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionPeriodicTermination_protocolExtensions__item__id_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionPeriodicTermination_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionPeriodicTermination_protocolExtensions__item__id._const_tab = ____PositionPeriodicTermination_protocolExtensions__item__id_tab
    ___PositionPeriodicTermination_protocolExtensions__item__id._const_tab_at = None
    ___PositionPeriodicTermination_protocolExtensions__item__id._const_tab_id = 'id'
    ___PositionPeriodicTermination_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PositionPeriodicTermination_protocolExtensions__item__criticality_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionPeriodicTermination_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionPeriodicTermination_protocolExtensions__item__criticality._const_tab = ____PositionPeriodicTermination_protocolExtensions__item__criticality_tab
    ___PositionPeriodicTermination_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionPeriodicTermination_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___PositionPeriodicTermination_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PositionPeriodicTermination_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_PCAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    ____PositionPeriodicTermination_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PositionPeriodicTermination_protocolExtensions__item__extensionValue._const_tab = ____PositionPeriodicTermination_protocolExtensions__item__extensionValue_tab
    ___PositionPeriodicTermination_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionPeriodicTermination_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionPeriodicTermination_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___PositionPeriodicTermination_protocolExtensions__item__id),
        ('criticality', ___PositionPeriodicTermination_protocolExtensions__item__criticality),
        ('extensionValue', ___PositionPeriodicTermination_protocolExtensions__item__extensionValue),
        ])
    __PositionPeriodicTermination_protocolExtensions__item_._ext = None
    _PositionPeriodicTermination_protocolExtensions._cont = __PositionPeriodicTermination_protocolExtensions__item_
    _PositionPeriodicTermination_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionPeriodicTermination._cont = ASN1Dict([
        ('protocolIEs', _PositionPeriodicTermination_protocolIEs),
        ('protocolExtensions', _PositionPeriodicTermination_protocolExtensions),
        ])
    PositionPeriodicTermination._ext = []
    
    #-----< PositionPeriodicTermination-IEs >-----#
    PositionPeriodicTermination_IEs = CLASS(name='PositionPeriodicTermination-IEs', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-IES')))
    _PositionPeriodicTermination_IEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-IEs', 'PeriodicTerminationCause')))
    PositionPeriodicTermination_IEs._val = ASN1Set(rv=[dict([('id', 62), ('criticality', 'ignore'), ('Value', _PositionPeriodicTermination_IEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionPeriodicTermination-Extensions >-----#
    PositionPeriodicTermination_Extensions = CLASS(name='PositionPeriodicTermination-Extensions', mode=MODE_SET, typeref=ASN1RefType(('PCAP-Containers', 'PCAP-PROTOCOL-EXTENSION')))
    PositionPeriodicTermination_Extensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        ____PositionCalculationRequest_protocolIEs__item__id_tab,
        _____PositionCalculationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositionCalculationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___PositionCalculationRequest_protocolIEs__item__id,
        ___PositionCalculationRequest_protocolIEs__item__criticality,
        ___PositionCalculationRequest_protocolIEs__item__value,
        __PositionCalculationRequest_protocolIEs__item_,
        _PositionCalculationRequest_protocolIEs,
        ____PositionCalculationRequest_protocolExtensions__item__id_tab,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_5,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_6,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_7,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_8,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_9,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_10,
        _____PositionCalculationRequest_protocolExtensions__item__id_tab_val_Extension_11,
        ___PositionCalculationRequest_protocolExtensions__item__id,
        ___PositionCalculationRequest_protocolExtensions__item__criticality,
        ___PositionCalculationRequest_protocolExtensions__item__extensionValue,
        __PositionCalculationRequest_protocolExtensions__item_,
        _PositionCalculationRequest_protocolExtensions,
        PositionCalculationRequest,
        PositionCalculationRequestIEs,
        _PositionCalculationRequestIEs_val_Value_0,
        _PositionCalculationRequestIEs_val_Value_1,
        PositionCalculationRequestExtensions,
        _PositionCalculationRequestExtensions_val_Extension_0,
        _PositionCalculationRequestExtensions_val_Extension_1,
        _PositionCalculationRequestExtensions_val_Extension_2,
        _PositionCalculationRequestExtensions_val_Extension_3,
        _PositionCalculationRequestExtensions_val_Extension_4,
        _PositionCalculationRequestExtensions_val_Extension_5,
        _PositionCalculationRequestExtensions_val_Extension_6,
        _PositionCalculationRequestExtensions_val_Extension_7,
        _PositionCalculationRequestExtensions_val_Extension_8,
        _PositionCalculationRequestExtensions_val_Extension_9,
        _PositionCalculationRequestExtensions_val_Extension_10,
        _PositionCalculationRequestExtensions_val_Extension_11,
        ____PositionCalculationResponse_protocolIEs__item__id_tab,
        _____PositionCalculationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositionCalculationResponse_protocolIEs__item__id_tab_val_Value_1,
        ___PositionCalculationResponse_protocolIEs__item__id,
        ___PositionCalculationResponse_protocolIEs__item__criticality,
        ___PositionCalculationResponse_protocolIEs__item__value,
        __PositionCalculationResponse_protocolIEs__item_,
        _PositionCalculationResponse_protocolIEs,
        ____PositionCalculationResponse_protocolExtensions__item__id_tab,
        _____PositionCalculationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        _____PositionCalculationResponse_protocolExtensions__item__id_tab_val_Extension_1,
        ___PositionCalculationResponse_protocolExtensions__item__id,
        ___PositionCalculationResponse_protocolExtensions__item__criticality,
        ___PositionCalculationResponse_protocolExtensions__item__extensionValue,
        __PositionCalculationResponse_protocolExtensions__item_,
        _PositionCalculationResponse_protocolExtensions,
        PositionCalculationResponse,
        PositionCalculationResponseIEs,
        _PositionCalculationResponseIEs_val_Value_0,
        _PositionCalculationResponseIEs_val_Value_1,
        PositionCalculationResponseExtensions,
        _PositionCalculationResponseExtensions_val_Extension_0,
        _PositionCalculationResponseExtensions_val_Extension_1,
        ____PositionCalculationFailure_protocolIEs__item__id_tab,
        _____PositionCalculationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositionCalculationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___PositionCalculationFailure_protocolIEs__item__id,
        ___PositionCalculationFailure_protocolIEs__item__criticality,
        ___PositionCalculationFailure_protocolIEs__item__value,
        __PositionCalculationFailure_protocolIEs__item_,
        _PositionCalculationFailure_protocolIEs,
        ____PositionCalculationFailure_protocolExtensions__item__id_tab,
        ___PositionCalculationFailure_protocolExtensions__item__id,
        ____PositionCalculationFailure_protocolExtensions__item__criticality_tab,
        ___PositionCalculationFailure_protocolExtensions__item__criticality,
        ____PositionCalculationFailure_protocolExtensions__item__extensionValue_tab,
        ___PositionCalculationFailure_protocolExtensions__item__extensionValue,
        __PositionCalculationFailure_protocolExtensions__item_,
        _PositionCalculationFailure_protocolExtensions,
        PositionCalculationFailure,
        PositionCalculationFailureIEs,
        _PositionCalculationFailureIEs_val_Value_0,
        _PositionCalculationFailureIEs_val_Value_1,
        PositionCalculationFailureExtensions,
        ____InformationExchangeInitiationRequest_protocolIEs__item__id_tab,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____InformationExchangeInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        ___InformationExchangeInitiationRequest_protocolIEs__item__id,
        ___InformationExchangeInitiationRequest_protocolIEs__item__criticality,
        ___InformationExchangeInitiationRequest_protocolIEs__item__value,
        __InformationExchangeInitiationRequest_protocolIEs__item_,
        _InformationExchangeInitiationRequest_protocolIEs,
        ____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab,
        _____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____InformationExchangeInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        ___InformationExchangeInitiationRequest_protocolExtensions__item__id,
        ___InformationExchangeInitiationRequest_protocolExtensions__item__criticality,
        ___InformationExchangeInitiationRequest_protocolExtensions__item__extensionValue,
        __InformationExchangeInitiationRequest_protocolExtensions__item_,
        _InformationExchangeInitiationRequest_protocolExtensions,
        InformationExchangeInitiationRequest,
        InformationExchangeInitiationRequest_IEs,
        _InformationExchangeInitiationRequest_IEs_val_Value_0,
        _InformationExchangeInitiationRequest_IEs_val_Value_1,
        _InformationExchangeInitiationRequest_IEs_val_Value_2,
        _InformationExchangeInitiationRequest_IEs_val_Value_3,
        _InformationExchangeInitiationRequest_IEs_val_Value_4,
        InformationExchangeInitiationRequest_Extensions,
        _InformationExchangeInitiationRequest_Extensions_val_Extension_0,
        _InformationExchangeInitiationRequest_Extensions_val_Extension_1,
        _InformationExchangeInitiationRequest_Extensions_val_Extension_2,
        _InformationExchangeObjectType_InfEx_Rqst_referencePosition,
        _InformationExchangeObjectType_InfEx_Rqst_extension_InformationExchangeObjectType_InfEx_Rqst,
        InformationExchangeObjectType_InfEx_Rqst,
        _RefPosition_InfEx_Rqst_referencePositionEstimate,
        ____RefPosition_InfEx_Rqst_iE_Extensions__item__id_tab,
        ___RefPosition_InfEx_Rqst_iE_Extensions__item__id,
        ____RefPosition_InfEx_Rqst_iE_Extensions__item__criticality_tab,
        ___RefPosition_InfEx_Rqst_iE_Extensions__item__criticality,
        ____RefPosition_InfEx_Rqst_iE_Extensions__item__extensionValue_tab,
        ___RefPosition_InfEx_Rqst_iE_Extensions__item__extensionValue,
        __RefPosition_InfEx_Rqst_iE_Extensions__item_,
        _RefPosition_InfEx_Rqst_iE_Extensions,
        RefPosition_InfEx_Rqst,
        RefPositionItem_InfEx_Rqst_ExtIEs,
        __Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab,
        ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_0,
        ___Extension_InformationExchangeObjectType_InfEx_Rqst_id_tab_val_Value_1,
        _Extension_InformationExchangeObjectType_InfEx_Rqst_id,
        _Extension_InformationExchangeObjectType_InfEx_Rqst_criticality,
        _Extension_InformationExchangeObjectType_InfEx_Rqst_value,
        Extension_InformationExchangeObjectType_InfEx_Rqst,
        Extension_InformationExchangeObjectType_InfEx_RqstIE,
        _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_0,
        _Extension_InformationExchangeObjectType_InfEx_RqstIE_val_Value_1,
        _UC_ID_InfEx_Rqst_referenceUC_ID,
        ____UC_ID_InfEx_Rqst_iE_Extensions__item__id_tab,
        ___UC_ID_InfEx_Rqst_iE_Extensions__item__id,
        ____UC_ID_InfEx_Rqst_iE_Extensions__item__criticality_tab,
        ___UC_ID_InfEx_Rqst_iE_Extensions__item__criticality,
        ____UC_ID_InfEx_Rqst_iE_Extensions__item__extensionValue_tab,
        ___UC_ID_InfEx_Rqst_iE_Extensions__item__extensionValue,
        __UC_ID_InfEx_Rqst_iE_Extensions__item_,
        _UC_ID_InfEx_Rqst_iE_Extensions,
        UC_ID_InfEx_Rqst,
        UCIDItem_InfEx_Rqst_ExtIEs,
        ____InformationExchangeInitiationResponse_protocolIEs__item__id_tab,
        _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____InformationExchangeInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___InformationExchangeInitiationResponse_protocolIEs__item__id,
        ___InformationExchangeInitiationResponse_protocolIEs__item__criticality,
        ___InformationExchangeInitiationResponse_protocolIEs__item__value,
        __InformationExchangeInitiationResponse_protocolIEs__item_,
        _InformationExchangeInitiationResponse_protocolIEs,
        ____InformationExchangeInitiationResponse_protocolExtensions__item__id_tab,
        ___InformationExchangeInitiationResponse_protocolExtensions__item__id,
        ____InformationExchangeInitiationResponse_protocolExtensions__item__criticality_tab,
        ___InformationExchangeInitiationResponse_protocolExtensions__item__criticality,
        ____InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeInitiationResponse_protocolExtensions__item__extensionValue,
        __InformationExchangeInitiationResponse_protocolExtensions__item_,
        _InformationExchangeInitiationResponse_protocolExtensions,
        InformationExchangeInitiationResponse,
        InformationExchangeInitiationResponse_IEs,
        _InformationExchangeInitiationResponse_IEs_val_Value_0,
        _InformationExchangeInitiationResponse_IEs_val_Value_1,
        _InformationExchangeInitiationResponse_IEs_val_Value_2,
        InformationExchangeInitiationResponse_Extensions,
        _InformationExchangeObjectType_InfEx_Rsp_referencePosition,
        InformationExchangeObjectType_InfEx_Rsp,
        _RefPosition_InfEx_Rsp_requestedDataValue,
        ____RefPosition_InfEx_Rsp_iE_Extensions__item__id_tab,
        ___RefPosition_InfEx_Rsp_iE_Extensions__item__id,
        ____RefPosition_InfEx_Rsp_iE_Extensions__item__criticality_tab,
        ___RefPosition_InfEx_Rsp_iE_Extensions__item__criticality,
        ____RefPosition_InfEx_Rsp_iE_Extensions__item__extensionValue_tab,
        ___RefPosition_InfEx_Rsp_iE_Extensions__item__extensionValue,
        __RefPosition_InfEx_Rsp_iE_Extensions__item_,
        _RefPosition_InfEx_Rsp_iE_Extensions,
        RefPosition_InfEx_Rsp,
        RefPositionItem_InfEx_Rsp_ExtIEs,
        ____InformationExchangeInitiationFailure_protocolIEs__item__id_tab,
        _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____InformationExchangeInitiationFailure_protocolIEs__item__id_tab_val_Value_2,
        ___InformationExchangeInitiationFailure_protocolIEs__item__id,
        ___InformationExchangeInitiationFailure_protocolIEs__item__criticality,
        ___InformationExchangeInitiationFailure_protocolIEs__item__value,
        __InformationExchangeInitiationFailure_protocolIEs__item_,
        _InformationExchangeInitiationFailure_protocolIEs,
        ____InformationExchangeInitiationFailure_protocolExtensions__item__id_tab,
        ___InformationExchangeInitiationFailure_protocolExtensions__item__id,
        ____InformationExchangeInitiationFailure_protocolExtensions__item__criticality_tab,
        ___InformationExchangeInitiationFailure_protocolExtensions__item__criticality,
        ____InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeInitiationFailure_protocolExtensions__item__extensionValue,
        __InformationExchangeInitiationFailure_protocolExtensions__item_,
        _InformationExchangeInitiationFailure_protocolExtensions,
        InformationExchangeInitiationFailure,
        InformationExchangeInitiationFailure_IEs,
        _InformationExchangeInitiationFailure_IEs_val_Value_0,
        _InformationExchangeInitiationFailure_IEs_val_Value_1,
        _InformationExchangeInitiationFailure_IEs_val_Value_2,
        InformationExchangeInitiationFailure_Extensions,
        ____PositionInitiationRequest_protocolIEs__item__id_tab,
        _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____PositionInitiationRequest_protocolIEs__item__id_tab_val_Value_6,
        ___PositionInitiationRequest_protocolIEs__item__id,
        ___PositionInitiationRequest_protocolIEs__item__criticality,
        ___PositionInitiationRequest_protocolIEs__item__value,
        __PositionInitiationRequest_protocolIEs__item_,
        _PositionInitiationRequest_protocolIEs,
        ____PositionInitiationRequest_protocolExtensions__item__id_tab,
        _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____PositionInitiationRequest_protocolExtensions__item__id_tab_val_Extension_3,
        ___PositionInitiationRequest_protocolExtensions__item__id,
        ___PositionInitiationRequest_protocolExtensions__item__criticality,
        ___PositionInitiationRequest_protocolExtensions__item__extensionValue,
        __PositionInitiationRequest_protocolExtensions__item_,
        _PositionInitiationRequest_protocolExtensions,
        PositionInitiationRequest,
        PositionInitiationRequestIEs,
        _PositionInitiationRequestIEs_val_Value_0,
        _PositionInitiationRequestIEs_val_Value_1,
        _PositionInitiationRequestIEs_val_Value_2,
        _PositionInitiationRequestIEs_val_Value_3,
        _PositionInitiationRequestIEs_val_Value_4,
        _PositionInitiationRequestIEs_val_Value_5,
        _PositionInitiationRequestIEs_val_Value_6,
        PositionInitiationRequestExtensions,
        _PositionInitiationRequestExtensions_val_Extension_0,
        _PositionInitiationRequestExtensions_val_Extension_1,
        _PositionInitiationRequestExtensions_val_Extension_2,
        _PositionInitiationRequestExtensions_val_Extension_3,
        ____PositionInitiationResponse_protocolIEs__item__id_tab,
        _____PositionInitiationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositionInitiationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositionInitiationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___PositionInitiationResponse_protocolIEs__item__id,
        ___PositionInitiationResponse_protocolIEs__item__criticality,
        ___PositionInitiationResponse_protocolIEs__item__value,
        __PositionInitiationResponse_protocolIEs__item_,
        _PositionInitiationResponse_protocolIEs,
        ____PositionInitiationResponse_protocolExtensions__item__id_tab,
        _____PositionInitiationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        ___PositionInitiationResponse_protocolExtensions__item__id,
        ___PositionInitiationResponse_protocolExtensions__item__criticality,
        ___PositionInitiationResponse_protocolExtensions__item__extensionValue,
        __PositionInitiationResponse_protocolExtensions__item_,
        _PositionInitiationResponse_protocolExtensions,
        PositionInitiationResponse,
        PositionInitiationResponseIEs,
        _PositionInitiationResponseIEs_val_Value_0,
        _PositionInitiationResponseIEs_val_Value_1,
        _PositionInitiationResponseIEs_val_Value_2,
        PositionInitiationResponseExtensions,
        _PositionInitiationResponseExtensions_val_Extension_0,
        ____PositionInitiationFailure_protocolIEs__item__id_tab,
        _____PositionInitiationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositionInitiationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___PositionInitiationFailure_protocolIEs__item__id,
        ___PositionInitiationFailure_protocolIEs__item__criticality,
        ___PositionInitiationFailure_protocolIEs__item__value,
        __PositionInitiationFailure_protocolIEs__item_,
        _PositionInitiationFailure_protocolIEs,
        ____PositionInitiationFailure_protocolExtensions__item__id_tab,
        ___PositionInitiationFailure_protocolExtensions__item__id,
        ____PositionInitiationFailure_protocolExtensions__item__criticality_tab,
        ___PositionInitiationFailure_protocolExtensions__item__criticality,
        ____PositionInitiationFailure_protocolExtensions__item__extensionValue_tab,
        ___PositionInitiationFailure_protocolExtensions__item__extensionValue,
        __PositionInitiationFailure_protocolExtensions__item_,
        _PositionInitiationFailure_protocolExtensions,
        PositionInitiationFailure,
        PositionInitiationFailureIEs,
        _PositionInitiationFailureIEs_val_Value_0,
        _PositionInitiationFailureIEs_val_Value_1,
        PositionInitiationFailureExtensions,
        ____PositionActivationRequest_protocolIEs__item__id_tab,
        _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____PositionActivationRequest_protocolIEs__item__id_tab_val_Value_6,
        ___PositionActivationRequest_protocolIEs__item__id,
        ___PositionActivationRequest_protocolIEs__item__criticality,
        ___PositionActivationRequest_protocolIEs__item__value,
        __PositionActivationRequest_protocolIEs__item_,
        _PositionActivationRequest_protocolIEs,
        ____PositionActivationRequest_protocolExtensions__item__id_tab,
        _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____PositionActivationRequest_protocolExtensions__item__id_tab_val_Extension_3,
        ___PositionActivationRequest_protocolExtensions__item__id,
        ___PositionActivationRequest_protocolExtensions__item__criticality,
        ___PositionActivationRequest_protocolExtensions__item__extensionValue,
        __PositionActivationRequest_protocolExtensions__item_,
        _PositionActivationRequest_protocolExtensions,
        PositionActivationRequest,
        PositionActivationRequestIEs,
        _PositionActivationRequestIEs_val_Value_0,
        _PositionActivationRequestIEs_val_Value_1,
        _PositionActivationRequestIEs_val_Value_2,
        _PositionActivationRequestIEs_val_Value_3,
        _PositionActivationRequestIEs_val_Value_4,
        _PositionActivationRequestIEs_val_Value_5,
        _PositionActivationRequestIEs_val_Value_6,
        PositionActivationRequestExtensions,
        _PositionActivationRequestExtensions_val_Extension_0,
        _PositionActivationRequestExtensions_val_Extension_1,
        _PositionActivationRequestExtensions_val_Extension_2,
        _PositionActivationRequestExtensions_val_Extension_3,
        ____PositionActivationResponse_protocolIEs__item__id_tab,
        _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_3,
        _____PositionActivationResponse_protocolIEs__item__id_tab_val_Value_4,
        ___PositionActivationResponse_protocolIEs__item__id,
        ___PositionActivationResponse_protocolIEs__item__criticality,
        ___PositionActivationResponse_protocolIEs__item__value,
        __PositionActivationResponse_protocolIEs__item_,
        _PositionActivationResponse_protocolIEs,
        ____PositionActivationResponse_protocolExtensions__item__id_tab,
        _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_1,
        _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_2,
        _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_3,
        _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_4,
        _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_5,
        _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_6,
        _____PositionActivationResponse_protocolExtensions__item__id_tab_val_Extension_7,
        ___PositionActivationResponse_protocolExtensions__item__id,
        ___PositionActivationResponse_protocolExtensions__item__criticality,
        ___PositionActivationResponse_protocolExtensions__item__extensionValue,
        __PositionActivationResponse_protocolExtensions__item_,
        _PositionActivationResponse_protocolExtensions,
        PositionActivationResponse,
        PositionActivationResponseIEs,
        _PositionActivationResponseIEs_val_Value_0,
        _PositionActivationResponseIEs_val_Value_1,
        _PositionActivationResponseIEs_val_Value_2,
        _PositionActivationResponseIEs_val_Value_3,
        _PositionActivationResponseIEs_val_Value_4,
        PositionActivationResponseExtensions,
        _PositionActivationResponseExtensions_val_Extension_0,
        _PositionActivationResponseExtensions_val_Extension_1,
        _PositionActivationResponseExtensions_val_Extension_2,
        _PositionActivationResponseExtensions_val_Extension_3,
        _PositionActivationResponseExtensions_val_Extension_4,
        _PositionActivationResponseExtensions_val_Extension_5,
        _PositionActivationResponseExtensions_val_Extension_6,
        _PositionActivationResponseExtensions_val_Extension_7,
        ____PositionActivationFailure_protocolIEs__item__id_tab,
        _____PositionActivationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____PositionActivationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___PositionActivationFailure_protocolIEs__item__id,
        ___PositionActivationFailure_protocolIEs__item__criticality,
        ___PositionActivationFailure_protocolIEs__item__value,
        __PositionActivationFailure_protocolIEs__item_,
        _PositionActivationFailure_protocolIEs,
        ____PositionActivationFailure_protocolExtensions__item__id_tab,
        ___PositionActivationFailure_protocolExtensions__item__id,
        ____PositionActivationFailure_protocolExtensions__item__criticality_tab,
        ___PositionActivationFailure_protocolExtensions__item__criticality,
        ____PositionActivationFailure_protocolExtensions__item__extensionValue_tab,
        ___PositionActivationFailure_protocolExtensions__item__extensionValue,
        __PositionActivationFailure_protocolExtensions__item_,
        _PositionActivationFailure_protocolExtensions,
        PositionActivationFailure,
        PositionActivationFailureIEs,
        _PositionActivationFailureIEs_val_Value_0,
        _PositionActivationFailureIEs_val_Value_1,
        PositionActivationFailureExtensions,
        ____InformationReport_protocolIEs__item__id_tab,
        _____InformationReport_protocolIEs__item__id_tab_val_Value_0,
        _____InformationReport_protocolIEs__item__id_tab_val_Value_1,
        ___InformationReport_protocolIEs__item__id,
        ___InformationReport_protocolIEs__item__criticality,
        ___InformationReport_protocolIEs__item__value,
        __InformationReport_protocolIEs__item_,
        _InformationReport_protocolIEs,
        ____InformationReport_protocolExtensions__item__id_tab,
        ___InformationReport_protocolExtensions__item__id,
        ____InformationReport_protocolExtensions__item__criticality_tab,
        ___InformationReport_protocolExtensions__item__criticality,
        ____InformationReport_protocolExtensions__item__extensionValue_tab,
        ___InformationReport_protocolExtensions__item__extensionValue,
        __InformationReport_protocolExtensions__item_,
        _InformationReport_protocolExtensions,
        InformationReport,
        InformationReport_IEs,
        _InformationReport_IEs_val_Value_0,
        _InformationReport_IEs_val_Value_1,
        InformationReport_Extensions,
        _InformationExchangeObjectType_InfEx_Rprt_referencePosition,
        InformationExchangeObjectType_InfEx_Rprt,
        _RefPosition_InfEx_Rprt_requestedDataValueInformation,
        ____RefPosition_InfEx_Rprt_iE_Extensions__item__id_tab,
        ___RefPosition_InfEx_Rprt_iE_Extensions__item__id,
        ____RefPosition_InfEx_Rprt_iE_Extensions__item__criticality_tab,
        ___RefPosition_InfEx_Rprt_iE_Extensions__item__criticality,
        ____RefPosition_InfEx_Rprt_iE_Extensions__item__extensionValue_tab,
        ___RefPosition_InfEx_Rprt_iE_Extensions__item__extensionValue,
        __RefPosition_InfEx_Rprt_iE_Extensions__item_,
        _RefPosition_InfEx_Rprt_iE_Extensions,
        RefPosition_InfEx_Rprt,
        RefPositionItem_InfEx_Rprt_ExtIEs,
        ____InformationExchangeTerminationRequest_protocolIEs__item__id_tab,
        _____InformationExchangeTerminationRequest_protocolIEs__item__id_tab_val_Value_0,
        ___InformationExchangeTerminationRequest_protocolIEs__item__id,
        ___InformationExchangeTerminationRequest_protocolIEs__item__criticality,
        ___InformationExchangeTerminationRequest_protocolIEs__item__value,
        __InformationExchangeTerminationRequest_protocolIEs__item_,
        _InformationExchangeTerminationRequest_protocolIEs,
        ____InformationExchangeTerminationRequest_protocolExtensions__item__id_tab,
        ___InformationExchangeTerminationRequest_protocolExtensions__item__id,
        ____InformationExchangeTerminationRequest_protocolExtensions__item__criticality_tab,
        ___InformationExchangeTerminationRequest_protocolExtensions__item__criticality,
        ____InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeTerminationRequest_protocolExtensions__item__extensionValue,
        __InformationExchangeTerminationRequest_protocolExtensions__item_,
        _InformationExchangeTerminationRequest_protocolExtensions,
        InformationExchangeTerminationRequest,
        InformationExchangeTerminationRequest_IEs,
        _InformationExchangeTerminationRequest_IEs_val_Value_0,
        InformationExchangeTerminationRequest_Extensions,
        ____InformationExchangeFailureIndication_protocolIEs__item__id_tab,
        _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_0,
        _____InformationExchangeFailureIndication_protocolIEs__item__id_tab_val_Value_1,
        ___InformationExchangeFailureIndication_protocolIEs__item__id,
        ___InformationExchangeFailureIndication_protocolIEs__item__criticality,
        ___InformationExchangeFailureIndication_protocolIEs__item__value,
        __InformationExchangeFailureIndication_protocolIEs__item_,
        _InformationExchangeFailureIndication_protocolIEs,
        ____InformationExchangeFailureIndication_protocolExtensions__item__id_tab,
        ___InformationExchangeFailureIndication_protocolExtensions__item__id,
        ____InformationExchangeFailureIndication_protocolExtensions__item__criticality_tab,
        ___InformationExchangeFailureIndication_protocolExtensions__item__criticality,
        ____InformationExchangeFailureIndication_protocolExtensions__item__extensionValue_tab,
        ___InformationExchangeFailureIndication_protocolExtensions__item__extensionValue,
        __InformationExchangeFailureIndication_protocolExtensions__item_,
        _InformationExchangeFailureIndication_protocolExtensions,
        InformationExchangeFailureIndication,
        InformationExchangeFailureIndication_IEs,
        _InformationExchangeFailureIndication_IEs_val_Value_0,
        _InformationExchangeFailureIndication_IEs_val_Value_1,
        InformationExchangeFailureIndication_Extensions,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ____ErrorIndication_protocolExtensions__item__id_tab,
        ___ErrorIndication_protocolExtensions__item__id,
        ____ErrorIndication_protocolExtensions__item__criticality_tab,
        ___ErrorIndication_protocolExtensions__item__criticality,
        ____ErrorIndication_protocolExtensions__item__extensionValue_tab,
        ___ErrorIndication_protocolExtensions__item__extensionValue,
        __ErrorIndication_protocolExtensions__item_,
        _ErrorIndication_protocolExtensions,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        ErrorIndicationExtensions,
        ____PositionParameterModification_protocolIEs__item__id_tab,
        _____PositionParameterModification_protocolIEs__item__id_tab_val_Value_0,
        _____PositionParameterModification_protocolIEs__item__id_tab_val_Value_1,
        ___PositionParameterModification_protocolIEs__item__id,
        ___PositionParameterModification_protocolIEs__item__criticality,
        ___PositionParameterModification_protocolIEs__item__value,
        __PositionParameterModification_protocolIEs__item_,
        _PositionParameterModification_protocolIEs,
        ____PositionParameterModification_protocolExtensions__item__id_tab,
        _____PositionParameterModification_protocolExtensions__item__id_tab_val_Extension_0,
        ___PositionParameterModification_protocolExtensions__item__id,
        ___PositionParameterModification_protocolExtensions__item__criticality,
        ___PositionParameterModification_protocolExtensions__item__extensionValue,
        __PositionParameterModification_protocolExtensions__item_,
        _PositionParameterModification_protocolExtensions,
        PositionParameterModification,
        PositionParameterModificationIEs,
        _PositionParameterModificationIEs_val_Value_0,
        _PositionParameterModificationIEs_val_Value_1,
        PositionParameterModificationExtensions,
        _PositionParameterModificationExtensions_val_Extension_0,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____Abort_protocolIEs__item__id_tab,
        _____Abort_protocolIEs__item__id_tab_val_Value_0,
        ___Abort_protocolIEs__item__id,
        ___Abort_protocolIEs__item__criticality,
        ___Abort_protocolIEs__item__value,
        __Abort_protocolIEs__item_,
        _Abort_protocolIEs,
        ____Abort_protocolExtensions__item__id_tab,
        ___Abort_protocolExtensions__item__id,
        ____Abort_protocolExtensions__item__criticality_tab,
        ___Abort_protocolExtensions__item__criticality,
        ____Abort_protocolExtensions__item__extensionValue_tab,
        ___Abort_protocolExtensions__item__extensionValue,
        __Abort_protocolExtensions__item_,
        _Abort_protocolExtensions,
        Abort,
        AbortIEs,
        _AbortIEs_val_Value_0,
        AbortExtensions,
        ____PositionPeriodicReport_protocolIEs__item__id_tab,
        _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_0,
        _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_1,
        _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_2,
        _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_3,
        _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_4,
        _____PositionPeriodicReport_protocolIEs__item__id_tab_val_Value_5,
        ___PositionPeriodicReport_protocolIEs__item__id,
        ___PositionPeriodicReport_protocolIEs__item__criticality,
        ___PositionPeriodicReport_protocolIEs__item__value,
        __PositionPeriodicReport_protocolIEs__item_,
        _PositionPeriodicReport_protocolIEs,
        ____PositionPeriodicReport_protocolExtensions__item__id_tab,
        _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_0,
        _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_1,
        _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_2,
        _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_3,
        _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_4,
        _____PositionPeriodicReport_protocolExtensions__item__id_tab_val_Extension_5,
        ___PositionPeriodicReport_protocolExtensions__item__id,
        ___PositionPeriodicReport_protocolExtensions__item__criticality,
        ___PositionPeriodicReport_protocolExtensions__item__extensionValue,
        __PositionPeriodicReport_protocolExtensions__item_,
        _PositionPeriodicReport_protocolExtensions,
        PositionPeriodicReport,
        PositionPeriodicReport_IEs,
        _PositionPeriodicReport_IEs_val_Value_0,
        _PositionPeriodicReport_IEs_val_Value_1,
        _PositionPeriodicReport_IEs_val_Value_2,
        _PositionPeriodicReport_IEs_val_Value_3,
        _PositionPeriodicReport_IEs_val_Value_4,
        _PositionPeriodicReport_IEs_val_Value_5,
        PositionPeriodicReport_Extensions,
        _PositionPeriodicReport_Extensions_val_Extension_0,
        _PositionPeriodicReport_Extensions_val_Extension_1,
        _PositionPeriodicReport_Extensions_val_Extension_2,
        _PositionPeriodicReport_Extensions_val_Extension_3,
        _PositionPeriodicReport_Extensions_val_Extension_4,
        _PositionPeriodicReport_Extensions_val_Extension_5,
        ____PositionPeriodicResult_protocolIEs__item__id_tab,
        _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_0,
        _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_1,
        _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_2,
        _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_3,
        _____PositionPeriodicResult_protocolIEs__item__id_tab_val_Value_4,
        ___PositionPeriodicResult_protocolIEs__item__id,
        ___PositionPeriodicResult_protocolIEs__item__criticality,
        ___PositionPeriodicResult_protocolIEs__item__value,
        __PositionPeriodicResult_protocolIEs__item_,
        _PositionPeriodicResult_protocolIEs,
        ____PositionPeriodicResult_protocolExtensions__item__id_tab,
        ___PositionPeriodicResult_protocolExtensions__item__id,
        ____PositionPeriodicResult_protocolExtensions__item__criticality_tab,
        ___PositionPeriodicResult_protocolExtensions__item__criticality,
        ____PositionPeriodicResult_protocolExtensions__item__extensionValue_tab,
        ___PositionPeriodicResult_protocolExtensions__item__extensionValue,
        __PositionPeriodicResult_protocolExtensions__item_,
        _PositionPeriodicResult_protocolExtensions,
        PositionPeriodicResult,
        PositionPeriodicResult_IEs,
        _PositionPeriodicResult_IEs_val_Value_0,
        _PositionPeriodicResult_IEs_val_Value_1,
        _PositionPeriodicResult_IEs_val_Value_2,
        _PositionPeriodicResult_IEs_val_Value_3,
        _PositionPeriodicResult_IEs_val_Value_4,
        PositionPeriodicResult_Extensions,
        ____PositionPeriodicTermination_protocolIEs__item__id_tab,
        _____PositionPeriodicTermination_protocolIEs__item__id_tab_val_Value_0,
        ___PositionPeriodicTermination_protocolIEs__item__id,
        ___PositionPeriodicTermination_protocolIEs__item__criticality,
        ___PositionPeriodicTermination_protocolIEs__item__value,
        __PositionPeriodicTermination_protocolIEs__item_,
        _PositionPeriodicTermination_protocolIEs,
        ____PositionPeriodicTermination_protocolExtensions__item__id_tab,
        ___PositionPeriodicTermination_protocolExtensions__item__id,
        ____PositionPeriodicTermination_protocolExtensions__item__criticality_tab,
        ___PositionPeriodicTermination_protocolExtensions__item__criticality,
        ____PositionPeriodicTermination_protocolExtensions__item__extensionValue_tab,
        ___PositionPeriodicTermination_protocolExtensions__item__extensionValue,
        __PositionPeriodicTermination_protocolExtensions__item_,
        _PositionPeriodicTermination_protocolExtensions,
        PositionPeriodicTermination,
        PositionPeriodicTermination_IEs,
        _PositionPeriodicTermination_IEs_val_Value_0,
        PositionPeriodicTermination_Extensions,
    ]

class PCAP_PDU_Descriptions:

    _name_  = 'PCAP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 20, 3, 4, 1, 0]
    
    _obj_ = [
        'PCAP-ELEMENTARY-PROCEDURE',
        'PCAP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'Outcome',
        'PCAP-ELEMENTARY-PROCEDURES',
        'PCAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'PCAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'positionCalculation',
        'informationExchangeInitiation',
        'positionInitiation',
        'positionActivation',
        'informationReporting',
        'informationExchangeTermination',
        'informationExchangeFailure',
        'errorIndication',
        'privateMessage',
        'positionParameterModification',
        'abort',
        'positionPeriodicReport',
        'positionPeriodicResult',
        'positionPeriodicTermination',
        ]
    _type_ = [
        'PCAP-ELEMENTARY-PROCEDURE',
        'PCAP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'Outcome',
        ]
    _set_ = [
        'PCAP-ELEMENTARY-PROCEDURES',
        'PCAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'PCAP-ELEMENTARY-PROCEDURES-CLASS-2',
        ]
    _val_ = [
        'positionCalculation',
        'informationExchangeInitiation',
        'positionInitiation',
        'positionActivation',
        'informationReporting',
        'informationExchangeTermination',
        'informationExchangeFailure',
        'errorIndication',
        'privateMessage',
        'positionParameterModification',
        'abort',
        'positionPeriodicReport',
        'positionPeriodicResult',
        'positionPeriodicTermination',
        ]
    _class_ = [
        'PCAP-ELEMENTARY-PROCEDURE',
        'PCAP-ELEMENTARY-PROCEDURES',
        'PCAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'PCAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'positionCalculation',
        'informationExchangeInitiation',
        'positionInitiation',
        'positionActivation',
        'informationReporting',
        'informationExchangeTermination',
        'informationExchangeFailure',
        'errorIndication',
        'privateMessage',
        'positionParameterModification',
        'abort',
        'positionPeriodicReport',
        'positionPeriodicResult',
        'positionPeriodicTermination',
        ]
    _param_ = [
        ]
    
    #-----< PCAP-ELEMENTARY-PROCEDURE >-----#
    PCAP_ELEMENTARY_PROCEDURE = CLASS(name='PCAP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _PCAP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _PCAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _PCAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _PCAP_ELEMENTARY_PROCEDURE_Outcome = OPEN(name='Outcome', mode=MODE_TYPE, opt=True)
    _PCAP_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _PCAP_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-CommonDataTypes', 'Criticality')), default='ignore')
    PCAP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('Outcome', _PCAP_ELEMENTARY_PROCEDURE_Outcome),
        ('procedureCode', _PCAP_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _PCAP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< PCAP-PDU >-----#
    PCAP_PDU = CHOICE(name='PCAP-PDU', mode=MODE_TYPE)
    _PCAP_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'InitiatingMessage')))
    _PCAP_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'SuccessfulOutcome')))
    _PCAP_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    _PCAP_PDU_outcome = SEQ(name='outcome', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'Outcome')))
    PCAP_PDU._cont = ASN1Dict([
        ('initiatingMessage', _PCAP_PDU_initiatingMessage),
        ('successfulOutcome', _PCAP_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _PCAP_PDU_unsuccessfulOutcome),
        ('outcome', _PCAP_PDU_outcome),
        ])
    PCAP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_PCAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionParameterModification')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'Abort')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicResult')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicTermination')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 14), ('criticality', 'ignore')])], er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_transactionID = CHOICE(name='transactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'TransactionID')))
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('transactionID', _InitiatingMessage_transactionID),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_PCAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionParameterModification')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'Abort')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicResult')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicTermination')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 14), ('criticality', 'ignore')])], er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_transactionID = CHOICE(name='transactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'TransactionID')))
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('transactionID', _SuccessfulOutcome_transactionID),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_PCAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionParameterModification')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'Abort')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicResult')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicTermination')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 14), ('criticality', 'ignore')])], er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_transactionID = CHOICE(name='transactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'TransactionID')))
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('transactionID', _UnsuccessfulOutcome_transactionID),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< Outcome >-----#
    Outcome = SEQ(name='Outcome', mode=MODE_TYPE)
    _Outcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __Outcome_procedureCode_tab = CLASS(name='_tab_PCAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationReport')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'ErrorIndication')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PrivateMessage')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionParameterModification')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'Abort')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicReport')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicResult')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicTermination')))
    __Outcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_6), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_8), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 14), ('criticality', 'ignore')])], er=[])
    _Outcome_procedureCode._const_tab = __Outcome_procedureCode_tab
    _Outcome_procedureCode._const_tab_at = None
    _Outcome_procedureCode._const_tab_id = 'procedureCode'
    _Outcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _Outcome_criticality._const_tab = __Outcome_procedureCode_tab
    _Outcome_criticality._const_tab_at = ('..', 'procedureCode')
    _Outcome_criticality._const_tab_id = 'criticality'
    _Outcome_transactionID = CHOICE(name='transactionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PCAP-CommonDataTypes', 'TransactionID')))
    _Outcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE'), ['Outcome']))
    _Outcome_value._const_tab = __Outcome_procedureCode_tab
    _Outcome_value._const_tab_at = ('..', 'procedureCode')
    _Outcome_value._const_tab_id = 'Outcome'
    Outcome._cont = ASN1Dict([
        ('procedureCode', _Outcome_procedureCode),
        ('criticality', _Outcome_criticality),
        ('transactionID', _Outcome_transactionID),
        ('value', _Outcome_value),
        ])
    Outcome._ext = None
    
    #-----< PCAP-ELEMENTARY-PROCEDURES >-----#
    PCAP_ELEMENTARY_PROCEDURES = CLASS(name='PCAP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationRequest')))
    _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationResponse')))
    _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationFailure')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationReport')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'ErrorIndication')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PrivateMessage')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationRequest')))
    _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationResponse')))
    _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationFailure')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationRequest')))
    _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationResponse')))
    _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationFailure')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionParameterModification')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'Abort')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicReport')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicResult')))
    _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicTermination')))
    PCAP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('UnsuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('SuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), ('UnsuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8), ('procedureCode', 10), ('criticality', 'reject')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), ('procedureCode', 14), ('criticality', 'ignore')])], er=[])
    
    #-----< PCAP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    PCAP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='PCAP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationRequest')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationResponse')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationFailure')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationRequest')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationResponse')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationFailure')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationRequest')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationResponse')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationFailure')))
    PCAP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('UnsuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')])], rr=[], ev=[dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('UnsuccessfulOutcome', _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3), ('procedureCode', 10), ('criticality', 'reject')])], er=[])
    
    #-----< PCAP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    PCAP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='PCAP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationReport')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'ErrorIndication')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PrivateMessage')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionParameterModification')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'Abort')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicReport')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicResult')))
    _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicTermination')))
    PCAP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 3), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 4), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 5), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 6), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 7), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 8), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), ('procedureCode', 14), ('criticality', 'ignore')])], er=[])
    
    #-----< positionCalculation >-----#
    positionCalculation = CLASS(name='positionCalculation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _positionCalculation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationRequest')))
    _positionCalculation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationResponse')))
    _positionCalculation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionCalculationFailure')))
    positionCalculation._val = dict([('InitiatingMessage', _positionCalculation_val_InitiatingMessage), ('SuccessfulOutcome', _positionCalculation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _positionCalculation_val_UnsuccessfulOutcome), ('procedureCode', 1), ('criticality', 'reject')])
    
    #-----< informationExchangeInitiation >-----#
    informationExchangeInitiation = CLASS(name='informationExchangeInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _informationExchangeInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationRequest')))
    _informationExchangeInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationResponse')))
    _informationExchangeInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeInitiationFailure')))
    informationExchangeInitiation._val = dict([('InitiatingMessage', _informationExchangeInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _informationExchangeInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _informationExchangeInitiation_val_UnsuccessfulOutcome), ('procedureCode', 2), ('criticality', 'reject')])
    
    #-----< positionInitiation >-----#
    positionInitiation = CLASS(name='positionInitiation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _positionInitiation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationRequest')))
    _positionInitiation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationResponse')))
    _positionInitiation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionInitiationFailure')))
    positionInitiation._val = dict([('InitiatingMessage', _positionInitiation_val_InitiatingMessage), ('SuccessfulOutcome', _positionInitiation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _positionInitiation_val_UnsuccessfulOutcome), ('procedureCode', 9), ('criticality', 'reject')])
    
    #-----< positionActivation >-----#
    positionActivation = CLASS(name='positionActivation', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _positionActivation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationRequest')))
    _positionActivation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationResponse')))
    _positionActivation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionActivationFailure')))
    positionActivation._val = dict([('InitiatingMessage', _positionActivation_val_InitiatingMessage), ('SuccessfulOutcome', _positionActivation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _positionActivation_val_UnsuccessfulOutcome), ('procedureCode', 10), ('criticality', 'reject')])
    
    #-----< informationReporting >-----#
    informationReporting = CLASS(name='informationReporting', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _informationReporting_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationReport')))
    informationReporting._val = dict([('InitiatingMessage', _informationReporting_val_InitiatingMessage), ('procedureCode', 3), ('criticality', 'ignore')])
    
    #-----< informationExchangeTermination >-----#
    informationExchangeTermination = CLASS(name='informationExchangeTermination', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _informationExchangeTermination_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeTerminationRequest')))
    informationExchangeTermination._val = dict([('InitiatingMessage', _informationExchangeTermination_val_InitiatingMessage), ('procedureCode', 4), ('criticality', 'ignore')])
    
    #-----< informationExchangeFailure >-----#
    informationExchangeFailure = CLASS(name='informationExchangeFailure', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _informationExchangeFailure_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'InformationExchangeFailureIndication')))
    informationExchangeFailure._val = dict([('InitiatingMessage', _informationExchangeFailure_val_InitiatingMessage), ('procedureCode', 5), ('criticality', 'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 6), ('criticality', 'ignore')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 7), ('criticality', 'ignore')])
    
    #-----< positionParameterModification >-----#
    positionParameterModification = CLASS(name='positionParameterModification', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _positionParameterModification_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionParameterModification')))
    positionParameterModification._val = dict([('InitiatingMessage', _positionParameterModification_val_InitiatingMessage), ('procedureCode', 8), ('criticality', 'ignore')])
    
    #-----< abort >-----#
    abort = CLASS(name='abort', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _abort_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'Abort')))
    abort._val = dict([('InitiatingMessage', _abort_val_InitiatingMessage), ('procedureCode', 11), ('criticality', 'ignore')])
    
    #-----< positionPeriodicReport >-----#
    positionPeriodicReport = CLASS(name='positionPeriodicReport', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _positionPeriodicReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicReport')))
    positionPeriodicReport._val = dict([('InitiatingMessage', _positionPeriodicReport_val_InitiatingMessage), ('procedureCode', 12), ('criticality', 'ignore')])
    
    #-----< positionPeriodicResult >-----#
    positionPeriodicResult = CLASS(name='positionPeriodicResult', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _positionPeriodicResult_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicResult')))
    positionPeriodicResult._val = dict([('InitiatingMessage', _positionPeriodicResult_val_InitiatingMessage), ('procedureCode', 13), ('criticality', 'ignore')])
    
    #-----< positionPeriodicTermination >-----#
    positionPeriodicTermination = CLASS(name='positionPeriodicTermination', mode=MODE_VALUE, typeref=ASN1RefType(('PCAP-PDU-Descriptions', 'PCAP-ELEMENTARY-PROCEDURE')))
    _positionPeriodicTermination_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('PCAP-PDU-Contents', 'PositionPeriodicTermination')))
    positionPeriodicTermination._val = dict([('InitiatingMessage', _positionPeriodicTermination_val_InitiatingMessage), ('procedureCode', 14), ('criticality', 'ignore')])
    
    _all_ = [
        _PCAP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _PCAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _PCAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _PCAP_ELEMENTARY_PROCEDURE_Outcome,
        _PCAP_ELEMENTARY_PROCEDURE_procedureCode,
        _PCAP_ELEMENTARY_PROCEDURE_criticality,
        PCAP_ELEMENTARY_PROCEDURE,
        _PCAP_PDU_initiatingMessage,
        _PCAP_PDU_successfulOutcome,
        _PCAP_PDU_unsuccessfulOutcome,
        _PCAP_PDU_outcome,
        PCAP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_transactionID,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_transactionID,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_transactionID,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        __Outcome_procedureCode_tab,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_0,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_0,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_1,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_2,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_3,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_4,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_5,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_6,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_7,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_7,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_8,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_8,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_9,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_10,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_11,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_12,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_13,
        _Outcome_procedureCode,
        _Outcome_criticality,
        _Outcome_transactionID,
        _Outcome_value,
        Outcome,
        PCAP_ELEMENTARY_PROCEDURES,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_0,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_7,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _PCAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _PCAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_8,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _PCAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        PCAP_ELEMENTARY_PROCEDURES_CLASS_1,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_0,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_3,
        PCAP_ELEMENTARY_PROCEDURES_CLASS_2,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _PCAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        positionCalculation,
        _positionCalculation_val_InitiatingMessage,
        _positionCalculation_val_SuccessfulOutcome,
        _positionCalculation_val_UnsuccessfulOutcome,
        informationExchangeInitiation,
        _informationExchangeInitiation_val_InitiatingMessage,
        _informationExchangeInitiation_val_SuccessfulOutcome,
        _informationExchangeInitiation_val_UnsuccessfulOutcome,
        positionInitiation,
        _positionInitiation_val_InitiatingMessage,
        _positionInitiation_val_SuccessfulOutcome,
        _positionInitiation_val_UnsuccessfulOutcome,
        positionActivation,
        _positionActivation_val_InitiatingMessage,
        _positionActivation_val_SuccessfulOutcome,
        _positionActivation_val_UnsuccessfulOutcome,
        informationReporting,
        _informationReporting_val_InitiatingMessage,
        informationExchangeTermination,
        _informationExchangeTermination_val_InitiatingMessage,
        informationExchangeFailure,
        _informationExchangeFailure_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        positionParameterModification,
        _positionParameterModification_val_InitiatingMessage,
        abort,
        _abort_val_InitiatingMessage,
        positionPeriodicReport,
        _positionPeriodicReport_val_InitiatingMessage,
        positionPeriodicResult,
        _positionPeriodicResult_val_InitiatingMessage,
        positionPeriodicTermination,
        _positionPeriodicTermination_val_InitiatingMessage,
    ]

init_modules(PCAP_CommonDataTypes, PCAP_Constants, PCAP_Containers, PCAP_IEs, PCAP_PDU_Contents, PCAP_PDU_Descriptions)
