# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class RANAP_CommonDataTypes:

    _name_  = 'RANAP-CommonDataTypes'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 3]
    
    _obj_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolExtensionID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _type_ = [
        'Criticality',
        'Presence',
        'PrivateIE-ID',
        'ProcedureCode',
        'ProtocolExtensionID',
        'ProtocolIE-ID',
        'TriggeringMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Criticality >-----#
    Criticality = ENUM(name='Criticality', mode=MODE_TYPE)
    Criticality._cont = ASN1Dict([('reject', 0), ('ignore', 1), ('notify', 2)])
    Criticality._ext = None
    
    #-----< Presence >-----#
    Presence = ENUM(name='Presence', mode=MODE_TYPE)
    Presence._cont = ASN1Dict([('optional', 0), ('conditional', 1), ('mandatory', 2)])
    Presence._ext = None
    
    #-----< PrivateIE-ID >-----#
    PrivateIE_ID = CHOICE(name='PrivateIE-ID', mode=MODE_TYPE)
    _PrivateIE_ID_local = INT(name='local', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrivateIE_ID_local._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _PrivateIE_ID_global_ = OID(name='global', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PrivateIE_ID._cont = ASN1Dict([
        ('local', _PrivateIE_ID_local),
        ('global', _PrivateIE_ID_global_),
        ])
    PrivateIE_ID._ext = None
    
    #-----< ProcedureCode >-----#
    ProcedureCode = INT(name='ProcedureCode', mode=MODE_TYPE)
    ProcedureCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< ProtocolExtensionID >-----#
    ProtocolExtensionID = INT(name='ProtocolExtensionID', mode=MODE_TYPE)
    ProtocolExtensionID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< ProtocolIE-ID >-----#
    ProtocolIE_ID = INT(name='ProtocolIE-ID', mode=MODE_TYPE)
    ProtocolIE_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TriggeringMessage >-----#
    TriggeringMessage = ENUM(name='TriggeringMessage', mode=MODE_TYPE)
    TriggeringMessage._cont = ASN1Dict([('initiating-message', 0), ('successful-outcome', 1), ('unsuccessfull-outcome', 2), ('outcome', 3)])
    TriggeringMessage._ext = None
    
    _all_ = [
        Criticality,
        Presence,
        _PrivateIE_ID_local,
        _PrivateIE_ID_global_,
        PrivateIE_ID,
        ProcedureCode,
        ProtocolExtensionID,
        ProtocolIE_ID,
        TriggeringMessage,
    ]

class RANAP_Constants:

    _name_  = 'RANAP-Constants'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 4]
    
    _obj_ = [
        'id-RAB-Assignment',
        'id-Iu-Release',
        'id-RelocationPreparation',
        'id-RelocationResourceAllocation',
        'id-RelocationCancel',
        'id-SRNS-ContextTransfer',
        'id-SecurityModeControl',
        'id-DataVolumeReport',
        'id-Reset',
        'id-RAB-ReleaseRequest',
        'id-Iu-ReleaseRequest',
        'id-RelocationDetect',
        'id-RelocationComplete',
        'id-Paging',
        'id-CommonID',
        'id-CN-InvokeTrace',
        'id-LocationReportingControl',
        'id-LocationReport',
        'id-InitialUE-Message',
        'id-DirectTransfer',
        'id-OverloadControl',
        'id-ErrorIndication',
        'id-SRNS-DataForward',
        'id-ForwardSRNS-Context',
        'id-privateMessage',
        'id-CN-DeactivateTrace',
        'id-ResetResource',
        'id-RANAP-Relocation',
        'id-RAB-ModifyRequest',
        'id-LocationRelatedData',
        'id-InformationTransfer',
        'id-UESpecificInformation',
        'id-UplinkInformationExchange',
        'id-DirectInformationTransfer',
        'id-MBMSSessionStart',
        'id-MBMSSessionUpdate',
        'id-MBMSSessionStop',
        'id-MBMSUELinking',
        'id-MBMSRegistration',
        'id-MBMSCNDe-Registration-Procedure',
        'id-MBMSRABEstablishmentIndication',
        'id-MBMSRABRelease',
        'id-enhancedRelocationComplete',
        'id-enhancedRelocationCompleteConfirm',
        'id-RANAPenhancedRelocation',
        'id-SRVCCPreparation',
        'id-UeRadioCapabilityMatch',
        'id-UeRegistrationQuery',
        'id-RerouteNASRequest',
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'maxNrOfDTs',
        'maxNrOfErrors',
        'maxNrOfIuSigConIds',
        'maxNrOfPDPDirections',
        'maxNrOfPoints',
        'maxNrOfRABs',
        'maxNrOfSeparateTrafficDirections',
        'maxNrOfSRBs',
        'maxNrOfVol',
        'maxNrOfLevels',
        'maxNrOfAltValues',
        'maxNrOfPLMNsSN',
        'maxNrOfLAs',
        'maxNrOfSNAs',
        'maxNrOfUEsToBeTraced',
        'maxNrOfInterfaces',
        'maxRAB-Subflows',
        'maxRAB-SubflowCombination',
        'maxSet',
        'maxNrOfHSDSCHMACdFlows-1',
        'maxnoofMulticastServicesPerUE',
        'maxnoofMulticastServicesPerRNC',
        'maxMBMSSA',
        'maxMBMSRA',
        'maxNrOfEDCHMACdFlows-1',
        'maxGANSSSet',
        'maxNrOfCSGs',
        'maxNrOfEUTRAFreqs',
        'maxNrOfCellIds',
        'maxNrOfRAIs',
        'maxNrOfLAIs',
        'maxSizeOfIMSInfo',
        'maxnoofMDTPLMNs',
        'maxAddPosSet',
        'maxnoofPLMNs',
        'id-AreaIdentity',
        'id-CN-DomainIndicator',
        'id-Cause',
        'id-ChosenEncryptionAlgorithm',
        'id-ChosenIntegrityProtectionAlgorithm',
        'id-ClassmarkInformation2',
        'id-ClassmarkInformation3',
        'id-CriticalityDiagnostics',
        'id-DL-GTP-PDU-SequenceNumber',
        'id-EncryptionInformation',
        'id-IntegrityProtectionInformation',
        'id-IuTransportAssociation',
        'id-L3-Information',
        'id-LAI',
        'id-NAS-PDU',
        'id-NonSearchingIndication',
        'id-NumberOfSteps',
        'id-OMC-ID',
        'id-OldBSS-ToNewBSS-Information',
        'id-PagingAreaID',
        'id-PagingCause',
        'id-PermanentNAS-UE-ID',
        'id-RAB-ContextItem',
        'id-RAB-ContextList',
        'id-RAB-DataForwardingItem',
        'id-RAB-DataForwardingItem-SRNS-CtxReq',
        'id-RAB-DataForwardingList',
        'id-RAB-DataForwardingList-SRNS-CtxReq',
        'id-RAB-DataVolumeReportItem',
        'id-RAB-DataVolumeReportList',
        'id-RAB-DataVolumeReportRequestItem',
        'id-RAB-DataVolumeReportRequestList',
        'id-RAB-FailedItem',
        'id-RAB-FailedList',
        'id-RAB-ID',
        'id-RAB-QueuedItem',
        'id-RAB-QueuedList',
        'id-RAB-ReleaseFailedList',
        'id-RAB-ReleaseItem',
        'id-RAB-ReleaseList',
        'id-RAB-ReleasedItem',
        'id-RAB-ReleasedList',
        'id-RAB-ReleasedList-IuRelComp',
        'id-RAB-RelocationReleaseItem',
        'id-RAB-RelocationReleaseList',
        'id-RAB-SetupItem-RelocReq',
        'id-RAB-SetupItem-RelocReqAck',
        'id-RAB-SetupList-RelocReq',
        'id-RAB-SetupList-RelocReqAck',
        'id-RAB-SetupOrModifiedItem',
        'id-RAB-SetupOrModifiedList',
        'id-RAB-SetupOrModifyItem',
        'id-RAB-SetupOrModifyList',
        'id-RAC',
        'id-RelocationType',
        'id-RequestType',
        'id-SAI',
        'id-SAPI',
        'id-SourceID',
        'id-Source-ToTarget-TransparentContainer',
        'id-TargetID',
        'id-Target-ToSource-TransparentContainer',
        'id-TemporaryUE-ID',
        'id-TraceReference',
        'id-TraceType',
        'id-TransportLayerAddress',
        'id-TriggerID',
        'id-UE-ID',
        'id-UL-GTP-PDU-SequenceNumber',
        'id-RAB-FailedtoReportItem',
        'id-RAB-FailedtoReportList',
        'id-KeyStatus',
        'id-DRX-CycleLengthCoefficient',
        'id-IuSigConIdList',
        'id-IuSigConIdItem',
        'id-IuSigConId',
        'id-DirectTransferInformationItem-RANAP-RelocInf',
        'id-DirectTransferInformationList-RANAP-RelocInf',
        'id-RAB-ContextItem-RANAP-RelocInf',
        'id-RAB-ContextList-RANAP-RelocInf',
        'id-RAB-ContextFailedtoTransferItem',
        'id-RAB-ContextFailedtoTransferList',
        'id-GlobalRNC-ID',
        'id-RAB-ReleasedItem-IuRelComp',
        'id-MessageStructure',
        'id-Alt-RAB-Parameters',
        'id-Ass-RAB-Parameters',
        'id-RAB-ModifyList',
        'id-RAB-ModifyItem',
        'id-TypeOfError',
        'id-BroadcastAssistanceDataDecipheringKeys',
        'id-LocationRelatedDataRequestType',
        'id-GlobalCN-ID',
        'id-LastKnownServiceArea',
        'id-SRB-TrCH-Mapping',
        'id-InterSystemInformation-TransparentContainer',
        'id-NewBSS-To-OldBSS-Information',
        'id-SourceRNC-PDCP-context-info',
        'id-InformationTransferID',
        'id-SNA-Access-Information',
        'id-ProvidedData',
        'id-GERAN-BSC-Container',
        'id-GERAN-Classmark',
        'id-GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item',
        'id-GERAN-Iumode-RAB-FailedList-RABAssgntResponse',
        'id-VerticalAccuracyCode',
        'id-ResponseTime',
        'id-PositioningPriority',
        'id-ClientType',
        'id-LocationRelatedDataRequestTypeSpecificToGERANIuMode',
        'id-SignallingIndication',
        'id-hS-DSCH-MAC-d-Flow-ID',
        'id-UESBI-Iu',
        'id-PositionData',
        'id-PositionDataSpecificToGERANIuMode',
        'id-CellLoadInformationGroup',
        'id-AccuracyFulfilmentIndicator',
        'id-InformationTransferType',
        'id-TraceRecordingSessionInformation',
        'id-TracePropagationParameters',
        'id-InterSystemInformationTransferType',
        'id-SelectedPLMN-ID',
        'id-RedirectionCompleted',
        'id-RedirectionIndication',
        'id-NAS-SequenceNumber',
        'id-RejectCauseValue',
        'id-APN',
        'id-CNMBMSLinkingInformation',
        'id-DeltaRAListofIdleModeUEs',
        'id-FrequenceLayerConvergenceFlag',
        'id-InformationExchangeID',
        'id-InformationExchangeType',
        'id-InformationRequested',
        'id-InformationRequestType',
        'id-IPMulticastAddress',
        'id-JoinedMBMSBearerServicesList',
        'id-LeftMBMSBearerServicesList',
        'id-MBMSBearerServiceType',
        'id-MBMSCNDe-Registration',
        'id-MBMSServiceArea',
        'id-MBMSSessionDuration',
        'id-MBMSSessionIdentity',
        'id-PDP-TypeInformation',
        'id-RAB-Parameters',
        'id-RAListofIdleModeUEs',
        'id-MBMSRegistrationRequestType',
        'id-SessionUpdateID',
        'id-TMGI',
        'id-TransportLayerInformation',
        'id-UnsuccessfulLinkingList',
        'id-MBMSLinkingInformation',
        'id-MBMSSessionRepetitionNumber',
        'id-AlternativeRABConfiguration',
        'id-AlternativeRABConfigurationRequest',
        'id-E-DCH-MAC-d-Flow-ID',
        'id-SourceBSS-ToTargetBSS-TransparentContainer',
        'id-TargetBSS-ToSourceBSS-TransparentContainer',
        'id-TimeToMBMSDataTransfer',
        'id-IncludeVelocity',
        'id-VelocityEstimate',
        'id-RedirectAttemptFlag',
        'id-RAT-Type',
        'id-PeriodicLocationInfo',
        'id-MBMSCountingInformation',
        'id-170-not-to-be-used-for-IE-ids',
        'id-ExtendedRNC-ID',
        'id-Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf',
        'id-Alt-RAB-Parameter-ExtendedMaxBitrateInf',
        'id-Ass-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'id-Ass-RAB-Parameter-ExtendedMaxBitrateList',
        'id-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'id-RAB-Parameter-ExtendedMaxBitrateList',
        'id-Requested-RAB-Parameter-ExtendedMaxBitrateList',
        'id-Requested-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'id-LAofIdleModeUEs',
        'id-newLAListofIdleModeUEs',
        'id-LAListwithNoIdleModeUEsAnyMore',
        'id-183-not-to-be-used-for-IE-ids',
        'id-GANSS-PositioningDataSet',
        'id-RequestedGANSSAssistanceData',
        'id-BroadcastGANSSAssistanceDataDecipheringKeys',
        'id-d-RNTI-for-NoIuCSUP',
        'id-RAB-SetupList-EnhancedRelocCompleteReq',
        'id-RAB-SetupItem-EnhancedRelocCompleteReq',
        'id-RAB-SetupList-EnhancedRelocCompleteRes',
        'id-RAB-SetupItem-EnhancedRelocCompleteRes',
        'id-RAB-SetupList-EnhRelocInfoReq',
        'id-RAB-SetupItem-EnhRelocInfoReq',
        'id-RAB-SetupList-EnhRelocInfoRes',
        'id-RAB-SetupItem-EnhRelocInfoRes',
        'id-OldIuSigConId',
        'id-RAB-FailedList-EnhRelocInfoRes',
        'id-RAB-FailedItem-EnhRelocInfoRes',
        'id-Global-ENB-ID',
        'id-UE-History-Information',
        'id-MBMSSynchronisationInformation',
        'id-SubscriberProfileIDforRFP',
        'id-CSG-Id',
        'id-OldIuSigConIdCS',
        'id-OldIuSigConIdPS',
        'id-GlobalCN-IDCS',
        'id-GlobalCN-IDPS',
        'id-SourceExtendedRNC-ID',
        'id-RAB-ToBeReleasedItem-EnhancedRelocCompleteRes',
        'id-RAB-ToBeReleasedList-EnhancedRelocCompleteRes',
        'id-SourceRNC-ID',
        'id-Relocation-TargetRNC-ID',
        'id-Relocation-TargetExtendedRNC-ID',
        'id-Alt-RAB-Parameter-SupportedGuaranteedBitrateInf',
        'id-Alt-RAB-Parameter-SupportedMaxBitrateInf',
        'id-Ass-RAB-Parameter-SupportedGuaranteedBitrateList',
        'id-Ass-RAB-Parameter-SupportedMaxBitrateList',
        'id-RAB-Parameter-SupportedGuaranteedBitrateList',
        'id-RAB-Parameter-SupportedMaxBitrateList',
        'id-Requested-RAB-Parameter-SupportedMaxBitrateList',
        'id-Requested-RAB-Parameter-SupportedGuaranteedBitrateList',
        'id-Relocation-SourceRNC-ID',
        'id-Relocation-SourceExtendedRNC-ID',
        'id-EncryptionKey',
        'id-IntegrityProtectionKey',
        'id-SRVCC-HO-Indication',
        'id-SRVCC-Information',
        'id-SRVCC-Operation-Possible',
        'id-CSG-Id-List',
        'id-PSRABtobeReplaced',
        'id-E-UTRAN-Service-Handover',
        'id-UE-AggregateMaximumBitRate',
        'id-CSG-Membership-Status',
        'id-Cell-Access-Mode',
        'id-IP-Source-Address',
        'id-CSFB-Information',
        'id-PDP-TypeInformation-extension',
        'id-MSISDN',
        'id-Offload-RAB-Parameters',
        'id-LGW-TransportLayerAddress',
        'id-Correlation-ID',
        'id-IRAT-Measurement-Configuration',
        'id-MDT-Configuration',
        'id-Priority-Class-Indicator',
        'id-RNSAPRelocationParameters',
        'id-RABParametersList',
        'id-Management-Based-MDT-Allowed',
        'id-HigherBitratesThan16MbpsFlag',
        'id-Trace-Collection-Entity-IP-Addess',
        'id-End-Of-CSFB',
        'id-Time-UE-StayedInCell-EnhancedGranularity',
        'id-Out-Of-UTRAN',
        'id-TraceRecordingSessionReference',
        'id-IMSI',
        'id-HO-Cause',
        'id-VoiceSupportMatchIndicator',
        'id-RSRVCC-HO-Indication',
        'id-RSRVCC-Information',
        'id-AnchorPLMN-ID',
        'id-Tunnel-Information-for-BBF',
        'id-Management-Based-MDT-PLMN-List',
        'id-SignallingBasedMDTPLMNList',
        'id-M4Report',
        'id-M5Report',
        'id-M6Report',
        'id-M7Report',
        'id-TimingDifferenceULDL',
        'id-Serving-Cell-Identifier',
        'id-EARFCN-Extended',
        'id-RSRVCC-Operation-Possible',
        'id-SIPTO-LGW-TransportLayerAddress',
        'id-SIPTO-Correlation-ID',
        'id-LHN-ID',
        'id-Session-Re-establishment-Indicator',
        'id-LastE-UTRANPLMNIdentity',
        'id-RSRQ-Type',
        'id-RSRQ-Extension',
        'id-Additional-CSPS-coordination-information',
        'id-UERegistrationQueryResult',
        'id-IuSigConIdRangeEnd',
        'id-BarometricPressure',
        'id-Additional-PositioningDataSet',
        'id-CivicAddress',
        'id-SGSN-Group-Identity',
        'id-P-TMSI',
        'id-RANAP-Message',
        'id-PowerSavingIndicator',
        'id-UE-Usage-Type',
        'id-DCN-ID',
        'id-UE-Application-Layer-Measurement-Configuration',
        'id-UE-Application-Layer-Measurement-Configuration-For-Relocation',
        'id-UE-Application-Layer-Measurement-Capability',
        'id-UeApplicationLayerMeasurementSupportIndication',
        'id-SRVCCSource',
        ]
    _type_ = [
        ]
    _set_ = [
        ]
    _val_ = [
        'id-RAB-Assignment',
        'id-Iu-Release',
        'id-RelocationPreparation',
        'id-RelocationResourceAllocation',
        'id-RelocationCancel',
        'id-SRNS-ContextTransfer',
        'id-SecurityModeControl',
        'id-DataVolumeReport',
        'id-Reset',
        'id-RAB-ReleaseRequest',
        'id-Iu-ReleaseRequest',
        'id-RelocationDetect',
        'id-RelocationComplete',
        'id-Paging',
        'id-CommonID',
        'id-CN-InvokeTrace',
        'id-LocationReportingControl',
        'id-LocationReport',
        'id-InitialUE-Message',
        'id-DirectTransfer',
        'id-OverloadControl',
        'id-ErrorIndication',
        'id-SRNS-DataForward',
        'id-ForwardSRNS-Context',
        'id-privateMessage',
        'id-CN-DeactivateTrace',
        'id-ResetResource',
        'id-RANAP-Relocation',
        'id-RAB-ModifyRequest',
        'id-LocationRelatedData',
        'id-InformationTransfer',
        'id-UESpecificInformation',
        'id-UplinkInformationExchange',
        'id-DirectInformationTransfer',
        'id-MBMSSessionStart',
        'id-MBMSSessionUpdate',
        'id-MBMSSessionStop',
        'id-MBMSUELinking',
        'id-MBMSRegistration',
        'id-MBMSCNDe-Registration-Procedure',
        'id-MBMSRABEstablishmentIndication',
        'id-MBMSRABRelease',
        'id-enhancedRelocationComplete',
        'id-enhancedRelocationCompleteConfirm',
        'id-RANAPenhancedRelocation',
        'id-SRVCCPreparation',
        'id-UeRadioCapabilityMatch',
        'id-UeRegistrationQuery',
        'id-RerouteNASRequest',
        'maxPrivateIEs',
        'maxProtocolExtensions',
        'maxProtocolIEs',
        'maxNrOfDTs',
        'maxNrOfErrors',
        'maxNrOfIuSigConIds',
        'maxNrOfPDPDirections',
        'maxNrOfPoints',
        'maxNrOfRABs',
        'maxNrOfSeparateTrafficDirections',
        'maxNrOfSRBs',
        'maxNrOfVol',
        'maxNrOfLevels',
        'maxNrOfAltValues',
        'maxNrOfPLMNsSN',
        'maxNrOfLAs',
        'maxNrOfSNAs',
        'maxNrOfUEsToBeTraced',
        'maxNrOfInterfaces',
        'maxRAB-Subflows',
        'maxRAB-SubflowCombination',
        'maxSet',
        'maxNrOfHSDSCHMACdFlows-1',
        'maxnoofMulticastServicesPerUE',
        'maxnoofMulticastServicesPerRNC',
        'maxMBMSSA',
        'maxMBMSRA',
        'maxNrOfEDCHMACdFlows-1',
        'maxGANSSSet',
        'maxNrOfCSGs',
        'maxNrOfEUTRAFreqs',
        'maxNrOfCellIds',
        'maxNrOfRAIs',
        'maxNrOfLAIs',
        'maxSizeOfIMSInfo',
        'maxnoofMDTPLMNs',
        'maxAddPosSet',
        'maxnoofPLMNs',
        'id-AreaIdentity',
        'id-CN-DomainIndicator',
        'id-Cause',
        'id-ChosenEncryptionAlgorithm',
        'id-ChosenIntegrityProtectionAlgorithm',
        'id-ClassmarkInformation2',
        'id-ClassmarkInformation3',
        'id-CriticalityDiagnostics',
        'id-DL-GTP-PDU-SequenceNumber',
        'id-EncryptionInformation',
        'id-IntegrityProtectionInformation',
        'id-IuTransportAssociation',
        'id-L3-Information',
        'id-LAI',
        'id-NAS-PDU',
        'id-NonSearchingIndication',
        'id-NumberOfSteps',
        'id-OMC-ID',
        'id-OldBSS-ToNewBSS-Information',
        'id-PagingAreaID',
        'id-PagingCause',
        'id-PermanentNAS-UE-ID',
        'id-RAB-ContextItem',
        'id-RAB-ContextList',
        'id-RAB-DataForwardingItem',
        'id-RAB-DataForwardingItem-SRNS-CtxReq',
        'id-RAB-DataForwardingList',
        'id-RAB-DataForwardingList-SRNS-CtxReq',
        'id-RAB-DataVolumeReportItem',
        'id-RAB-DataVolumeReportList',
        'id-RAB-DataVolumeReportRequestItem',
        'id-RAB-DataVolumeReportRequestList',
        'id-RAB-FailedItem',
        'id-RAB-FailedList',
        'id-RAB-ID',
        'id-RAB-QueuedItem',
        'id-RAB-QueuedList',
        'id-RAB-ReleaseFailedList',
        'id-RAB-ReleaseItem',
        'id-RAB-ReleaseList',
        'id-RAB-ReleasedItem',
        'id-RAB-ReleasedList',
        'id-RAB-ReleasedList-IuRelComp',
        'id-RAB-RelocationReleaseItem',
        'id-RAB-RelocationReleaseList',
        'id-RAB-SetupItem-RelocReq',
        'id-RAB-SetupItem-RelocReqAck',
        'id-RAB-SetupList-RelocReq',
        'id-RAB-SetupList-RelocReqAck',
        'id-RAB-SetupOrModifiedItem',
        'id-RAB-SetupOrModifiedList',
        'id-RAB-SetupOrModifyItem',
        'id-RAB-SetupOrModifyList',
        'id-RAC',
        'id-RelocationType',
        'id-RequestType',
        'id-SAI',
        'id-SAPI',
        'id-SourceID',
        'id-Source-ToTarget-TransparentContainer',
        'id-TargetID',
        'id-Target-ToSource-TransparentContainer',
        'id-TemporaryUE-ID',
        'id-TraceReference',
        'id-TraceType',
        'id-TransportLayerAddress',
        'id-TriggerID',
        'id-UE-ID',
        'id-UL-GTP-PDU-SequenceNumber',
        'id-RAB-FailedtoReportItem',
        'id-RAB-FailedtoReportList',
        'id-KeyStatus',
        'id-DRX-CycleLengthCoefficient',
        'id-IuSigConIdList',
        'id-IuSigConIdItem',
        'id-IuSigConId',
        'id-DirectTransferInformationItem-RANAP-RelocInf',
        'id-DirectTransferInformationList-RANAP-RelocInf',
        'id-RAB-ContextItem-RANAP-RelocInf',
        'id-RAB-ContextList-RANAP-RelocInf',
        'id-RAB-ContextFailedtoTransferItem',
        'id-RAB-ContextFailedtoTransferList',
        'id-GlobalRNC-ID',
        'id-RAB-ReleasedItem-IuRelComp',
        'id-MessageStructure',
        'id-Alt-RAB-Parameters',
        'id-Ass-RAB-Parameters',
        'id-RAB-ModifyList',
        'id-RAB-ModifyItem',
        'id-TypeOfError',
        'id-BroadcastAssistanceDataDecipheringKeys',
        'id-LocationRelatedDataRequestType',
        'id-GlobalCN-ID',
        'id-LastKnownServiceArea',
        'id-SRB-TrCH-Mapping',
        'id-InterSystemInformation-TransparentContainer',
        'id-NewBSS-To-OldBSS-Information',
        'id-SourceRNC-PDCP-context-info',
        'id-InformationTransferID',
        'id-SNA-Access-Information',
        'id-ProvidedData',
        'id-GERAN-BSC-Container',
        'id-GERAN-Classmark',
        'id-GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item',
        'id-GERAN-Iumode-RAB-FailedList-RABAssgntResponse',
        'id-VerticalAccuracyCode',
        'id-ResponseTime',
        'id-PositioningPriority',
        'id-ClientType',
        'id-LocationRelatedDataRequestTypeSpecificToGERANIuMode',
        'id-SignallingIndication',
        'id-hS-DSCH-MAC-d-Flow-ID',
        'id-UESBI-Iu',
        'id-PositionData',
        'id-PositionDataSpecificToGERANIuMode',
        'id-CellLoadInformationGroup',
        'id-AccuracyFulfilmentIndicator',
        'id-InformationTransferType',
        'id-TraceRecordingSessionInformation',
        'id-TracePropagationParameters',
        'id-InterSystemInformationTransferType',
        'id-SelectedPLMN-ID',
        'id-RedirectionCompleted',
        'id-RedirectionIndication',
        'id-NAS-SequenceNumber',
        'id-RejectCauseValue',
        'id-APN',
        'id-CNMBMSLinkingInformation',
        'id-DeltaRAListofIdleModeUEs',
        'id-FrequenceLayerConvergenceFlag',
        'id-InformationExchangeID',
        'id-InformationExchangeType',
        'id-InformationRequested',
        'id-InformationRequestType',
        'id-IPMulticastAddress',
        'id-JoinedMBMSBearerServicesList',
        'id-LeftMBMSBearerServicesList',
        'id-MBMSBearerServiceType',
        'id-MBMSCNDe-Registration',
        'id-MBMSServiceArea',
        'id-MBMSSessionDuration',
        'id-MBMSSessionIdentity',
        'id-PDP-TypeInformation',
        'id-RAB-Parameters',
        'id-RAListofIdleModeUEs',
        'id-MBMSRegistrationRequestType',
        'id-SessionUpdateID',
        'id-TMGI',
        'id-TransportLayerInformation',
        'id-UnsuccessfulLinkingList',
        'id-MBMSLinkingInformation',
        'id-MBMSSessionRepetitionNumber',
        'id-AlternativeRABConfiguration',
        'id-AlternativeRABConfigurationRequest',
        'id-E-DCH-MAC-d-Flow-ID',
        'id-SourceBSS-ToTargetBSS-TransparentContainer',
        'id-TargetBSS-ToSourceBSS-TransparentContainer',
        'id-TimeToMBMSDataTransfer',
        'id-IncludeVelocity',
        'id-VelocityEstimate',
        'id-RedirectAttemptFlag',
        'id-RAT-Type',
        'id-PeriodicLocationInfo',
        'id-MBMSCountingInformation',
        'id-170-not-to-be-used-for-IE-ids',
        'id-ExtendedRNC-ID',
        'id-Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf',
        'id-Alt-RAB-Parameter-ExtendedMaxBitrateInf',
        'id-Ass-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'id-Ass-RAB-Parameter-ExtendedMaxBitrateList',
        'id-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'id-RAB-Parameter-ExtendedMaxBitrateList',
        'id-Requested-RAB-Parameter-ExtendedMaxBitrateList',
        'id-Requested-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'id-LAofIdleModeUEs',
        'id-newLAListofIdleModeUEs',
        'id-LAListwithNoIdleModeUEsAnyMore',
        'id-183-not-to-be-used-for-IE-ids',
        'id-GANSS-PositioningDataSet',
        'id-RequestedGANSSAssistanceData',
        'id-BroadcastGANSSAssistanceDataDecipheringKeys',
        'id-d-RNTI-for-NoIuCSUP',
        'id-RAB-SetupList-EnhancedRelocCompleteReq',
        'id-RAB-SetupItem-EnhancedRelocCompleteReq',
        'id-RAB-SetupList-EnhancedRelocCompleteRes',
        'id-RAB-SetupItem-EnhancedRelocCompleteRes',
        'id-RAB-SetupList-EnhRelocInfoReq',
        'id-RAB-SetupItem-EnhRelocInfoReq',
        'id-RAB-SetupList-EnhRelocInfoRes',
        'id-RAB-SetupItem-EnhRelocInfoRes',
        'id-OldIuSigConId',
        'id-RAB-FailedList-EnhRelocInfoRes',
        'id-RAB-FailedItem-EnhRelocInfoRes',
        'id-Global-ENB-ID',
        'id-UE-History-Information',
        'id-MBMSSynchronisationInformation',
        'id-SubscriberProfileIDforRFP',
        'id-CSG-Id',
        'id-OldIuSigConIdCS',
        'id-OldIuSigConIdPS',
        'id-GlobalCN-IDCS',
        'id-GlobalCN-IDPS',
        'id-SourceExtendedRNC-ID',
        'id-RAB-ToBeReleasedItem-EnhancedRelocCompleteRes',
        'id-RAB-ToBeReleasedList-EnhancedRelocCompleteRes',
        'id-SourceRNC-ID',
        'id-Relocation-TargetRNC-ID',
        'id-Relocation-TargetExtendedRNC-ID',
        'id-Alt-RAB-Parameter-SupportedGuaranteedBitrateInf',
        'id-Alt-RAB-Parameter-SupportedMaxBitrateInf',
        'id-Ass-RAB-Parameter-SupportedGuaranteedBitrateList',
        'id-Ass-RAB-Parameter-SupportedMaxBitrateList',
        'id-RAB-Parameter-SupportedGuaranteedBitrateList',
        'id-RAB-Parameter-SupportedMaxBitrateList',
        'id-Requested-RAB-Parameter-SupportedMaxBitrateList',
        'id-Requested-RAB-Parameter-SupportedGuaranteedBitrateList',
        'id-Relocation-SourceRNC-ID',
        'id-Relocation-SourceExtendedRNC-ID',
        'id-EncryptionKey',
        'id-IntegrityProtectionKey',
        'id-SRVCC-HO-Indication',
        'id-SRVCC-Information',
        'id-SRVCC-Operation-Possible',
        'id-CSG-Id-List',
        'id-PSRABtobeReplaced',
        'id-E-UTRAN-Service-Handover',
        'id-UE-AggregateMaximumBitRate',
        'id-CSG-Membership-Status',
        'id-Cell-Access-Mode',
        'id-IP-Source-Address',
        'id-CSFB-Information',
        'id-PDP-TypeInformation-extension',
        'id-MSISDN',
        'id-Offload-RAB-Parameters',
        'id-LGW-TransportLayerAddress',
        'id-Correlation-ID',
        'id-IRAT-Measurement-Configuration',
        'id-MDT-Configuration',
        'id-Priority-Class-Indicator',
        'id-RNSAPRelocationParameters',
        'id-RABParametersList',
        'id-Management-Based-MDT-Allowed',
        'id-HigherBitratesThan16MbpsFlag',
        'id-Trace-Collection-Entity-IP-Addess',
        'id-End-Of-CSFB',
        'id-Time-UE-StayedInCell-EnhancedGranularity',
        'id-Out-Of-UTRAN',
        'id-TraceRecordingSessionReference',
        'id-IMSI',
        'id-HO-Cause',
        'id-VoiceSupportMatchIndicator',
        'id-RSRVCC-HO-Indication',
        'id-RSRVCC-Information',
        'id-AnchorPLMN-ID',
        'id-Tunnel-Information-for-BBF',
        'id-Management-Based-MDT-PLMN-List',
        'id-SignallingBasedMDTPLMNList',
        'id-M4Report',
        'id-M5Report',
        'id-M6Report',
        'id-M7Report',
        'id-TimingDifferenceULDL',
        'id-Serving-Cell-Identifier',
        'id-EARFCN-Extended',
        'id-RSRVCC-Operation-Possible',
        'id-SIPTO-LGW-TransportLayerAddress',
        'id-SIPTO-Correlation-ID',
        'id-LHN-ID',
        'id-Session-Re-establishment-Indicator',
        'id-LastE-UTRANPLMNIdentity',
        'id-RSRQ-Type',
        'id-RSRQ-Extension',
        'id-Additional-CSPS-coordination-information',
        'id-UERegistrationQueryResult',
        'id-IuSigConIdRangeEnd',
        'id-BarometricPressure',
        'id-Additional-PositioningDataSet',
        'id-CivicAddress',
        'id-SGSN-Group-Identity',
        'id-P-TMSI',
        'id-RANAP-Message',
        'id-PowerSavingIndicator',
        'id-UE-Usage-Type',
        'id-DCN-ID',
        'id-UE-Application-Layer-Measurement-Configuration',
        'id-UE-Application-Layer-Measurement-Configuration-For-Relocation',
        'id-UE-Application-Layer-Measurement-Capability',
        'id-UeApplicationLayerMeasurementSupportIndication',
        'id-SRVCCSource',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< id-RAB-Assignment >-----#
    id_RAB_Assignment = INT(name='id-RAB-Assignment', mode=MODE_VALUE)
    id_RAB_Assignment._val = 0
    
    #-----< id-Iu-Release >-----#
    id_Iu_Release = INT(name='id-Iu-Release', mode=MODE_VALUE)
    id_Iu_Release._val = 1
    
    #-----< id-RelocationPreparation >-----#
    id_RelocationPreparation = INT(name='id-RelocationPreparation', mode=MODE_VALUE)
    id_RelocationPreparation._val = 2
    
    #-----< id-RelocationResourceAllocation >-----#
    id_RelocationResourceAllocation = INT(name='id-RelocationResourceAllocation', mode=MODE_VALUE)
    id_RelocationResourceAllocation._val = 3
    
    #-----< id-RelocationCancel >-----#
    id_RelocationCancel = INT(name='id-RelocationCancel', mode=MODE_VALUE)
    id_RelocationCancel._val = 4
    
    #-----< id-SRNS-ContextTransfer >-----#
    id_SRNS_ContextTransfer = INT(name='id-SRNS-ContextTransfer', mode=MODE_VALUE)
    id_SRNS_ContextTransfer._val = 5
    
    #-----< id-SecurityModeControl >-----#
    id_SecurityModeControl = INT(name='id-SecurityModeControl', mode=MODE_VALUE)
    id_SecurityModeControl._val = 6
    
    #-----< id-DataVolumeReport >-----#
    id_DataVolumeReport = INT(name='id-DataVolumeReport', mode=MODE_VALUE)
    id_DataVolumeReport._val = 7
    
    #-----< id-Reset >-----#
    id_Reset = INT(name='id-Reset', mode=MODE_VALUE)
    id_Reset._val = 9
    
    #-----< id-RAB-ReleaseRequest >-----#
    id_RAB_ReleaseRequest = INT(name='id-RAB-ReleaseRequest', mode=MODE_VALUE)
    id_RAB_ReleaseRequest._val = 10
    
    #-----< id-Iu-ReleaseRequest >-----#
    id_Iu_ReleaseRequest = INT(name='id-Iu-ReleaseRequest', mode=MODE_VALUE)
    id_Iu_ReleaseRequest._val = 11
    
    #-----< id-RelocationDetect >-----#
    id_RelocationDetect = INT(name='id-RelocationDetect', mode=MODE_VALUE)
    id_RelocationDetect._val = 12
    
    #-----< id-RelocationComplete >-----#
    id_RelocationComplete = INT(name='id-RelocationComplete', mode=MODE_VALUE)
    id_RelocationComplete._val = 13
    
    #-----< id-Paging >-----#
    id_Paging = INT(name='id-Paging', mode=MODE_VALUE)
    id_Paging._val = 14
    
    #-----< id-CommonID >-----#
    id_CommonID = INT(name='id-CommonID', mode=MODE_VALUE)
    id_CommonID._val = 15
    
    #-----< id-CN-InvokeTrace >-----#
    id_CN_InvokeTrace = INT(name='id-CN-InvokeTrace', mode=MODE_VALUE)
    id_CN_InvokeTrace._val = 16
    
    #-----< id-LocationReportingControl >-----#
    id_LocationReportingControl = INT(name='id-LocationReportingControl', mode=MODE_VALUE)
    id_LocationReportingControl._val = 17
    
    #-----< id-LocationReport >-----#
    id_LocationReport = INT(name='id-LocationReport', mode=MODE_VALUE)
    id_LocationReport._val = 18
    
    #-----< id-InitialUE-Message >-----#
    id_InitialUE_Message = INT(name='id-InitialUE-Message', mode=MODE_VALUE)
    id_InitialUE_Message._val = 19
    
    #-----< id-DirectTransfer >-----#
    id_DirectTransfer = INT(name='id-DirectTransfer', mode=MODE_VALUE)
    id_DirectTransfer._val = 20
    
    #-----< id-OverloadControl >-----#
    id_OverloadControl = INT(name='id-OverloadControl', mode=MODE_VALUE)
    id_OverloadControl._val = 21
    
    #-----< id-ErrorIndication >-----#
    id_ErrorIndication = INT(name='id-ErrorIndication', mode=MODE_VALUE)
    id_ErrorIndication._val = 22
    
    #-----< id-SRNS-DataForward >-----#
    id_SRNS_DataForward = INT(name='id-SRNS-DataForward', mode=MODE_VALUE)
    id_SRNS_DataForward._val = 23
    
    #-----< id-ForwardSRNS-Context >-----#
    id_ForwardSRNS_Context = INT(name='id-ForwardSRNS-Context', mode=MODE_VALUE)
    id_ForwardSRNS_Context._val = 24
    
    #-----< id-privateMessage >-----#
    id_privateMessage = INT(name='id-privateMessage', mode=MODE_VALUE)
    id_privateMessage._val = 25
    
    #-----< id-CN-DeactivateTrace >-----#
    id_CN_DeactivateTrace = INT(name='id-CN-DeactivateTrace', mode=MODE_VALUE)
    id_CN_DeactivateTrace._val = 26
    
    #-----< id-ResetResource >-----#
    id_ResetResource = INT(name='id-ResetResource', mode=MODE_VALUE)
    id_ResetResource._val = 27
    
    #-----< id-RANAP-Relocation >-----#
    id_RANAP_Relocation = INT(name='id-RANAP-Relocation', mode=MODE_VALUE)
    id_RANAP_Relocation._val = 28
    
    #-----< id-RAB-ModifyRequest >-----#
    id_RAB_ModifyRequest = INT(name='id-RAB-ModifyRequest', mode=MODE_VALUE)
    id_RAB_ModifyRequest._val = 29
    
    #-----< id-LocationRelatedData >-----#
    id_LocationRelatedData = INT(name='id-LocationRelatedData', mode=MODE_VALUE)
    id_LocationRelatedData._val = 30
    
    #-----< id-InformationTransfer >-----#
    id_InformationTransfer = INT(name='id-InformationTransfer', mode=MODE_VALUE)
    id_InformationTransfer._val = 31
    
    #-----< id-UESpecificInformation >-----#
    id_UESpecificInformation = INT(name='id-UESpecificInformation', mode=MODE_VALUE)
    id_UESpecificInformation._val = 32
    
    #-----< id-UplinkInformationExchange >-----#
    id_UplinkInformationExchange = INT(name='id-UplinkInformationExchange', mode=MODE_VALUE)
    id_UplinkInformationExchange._val = 33
    
    #-----< id-DirectInformationTransfer >-----#
    id_DirectInformationTransfer = INT(name='id-DirectInformationTransfer', mode=MODE_VALUE)
    id_DirectInformationTransfer._val = 34
    
    #-----< id-MBMSSessionStart >-----#
    id_MBMSSessionStart = INT(name='id-MBMSSessionStart', mode=MODE_VALUE)
    id_MBMSSessionStart._val = 35
    
    #-----< id-MBMSSessionUpdate >-----#
    id_MBMSSessionUpdate = INT(name='id-MBMSSessionUpdate', mode=MODE_VALUE)
    id_MBMSSessionUpdate._val = 36
    
    #-----< id-MBMSSessionStop >-----#
    id_MBMSSessionStop = INT(name='id-MBMSSessionStop', mode=MODE_VALUE)
    id_MBMSSessionStop._val = 37
    
    #-----< id-MBMSUELinking >-----#
    id_MBMSUELinking = INT(name='id-MBMSUELinking', mode=MODE_VALUE)
    id_MBMSUELinking._val = 38
    
    #-----< id-MBMSRegistration >-----#
    id_MBMSRegistration = INT(name='id-MBMSRegistration', mode=MODE_VALUE)
    id_MBMSRegistration._val = 39
    
    #-----< id-MBMSCNDe-Registration-Procedure >-----#
    id_MBMSCNDe_Registration_Procedure = INT(name='id-MBMSCNDe-Registration-Procedure', mode=MODE_VALUE)
    id_MBMSCNDe_Registration_Procedure._val = 40
    
    #-----< id-MBMSRABEstablishmentIndication >-----#
    id_MBMSRABEstablishmentIndication = INT(name='id-MBMSRABEstablishmentIndication', mode=MODE_VALUE)
    id_MBMSRABEstablishmentIndication._val = 41
    
    #-----< id-MBMSRABRelease >-----#
    id_MBMSRABRelease = INT(name='id-MBMSRABRelease', mode=MODE_VALUE)
    id_MBMSRABRelease._val = 42
    
    #-----< id-enhancedRelocationComplete >-----#
    id_enhancedRelocationComplete = INT(name='id-enhancedRelocationComplete', mode=MODE_VALUE)
    id_enhancedRelocationComplete._val = 43
    
    #-----< id-enhancedRelocationCompleteConfirm >-----#
    id_enhancedRelocationCompleteConfirm = INT(name='id-enhancedRelocationCompleteConfirm', mode=MODE_VALUE)
    id_enhancedRelocationCompleteConfirm._val = 44
    
    #-----< id-RANAPenhancedRelocation >-----#
    id_RANAPenhancedRelocation = INT(name='id-RANAPenhancedRelocation', mode=MODE_VALUE)
    id_RANAPenhancedRelocation._val = 45
    
    #-----< id-SRVCCPreparation >-----#
    id_SRVCCPreparation = INT(name='id-SRVCCPreparation', mode=MODE_VALUE)
    id_SRVCCPreparation._val = 46
    
    #-----< id-UeRadioCapabilityMatch >-----#
    id_UeRadioCapabilityMatch = INT(name='id-UeRadioCapabilityMatch', mode=MODE_VALUE)
    id_UeRadioCapabilityMatch._val = 47
    
    #-----< id-UeRegistrationQuery >-----#
    id_UeRegistrationQuery = INT(name='id-UeRegistrationQuery', mode=MODE_VALUE)
    id_UeRegistrationQuery._val = 48
    
    #-----< id-RerouteNASRequest >-----#
    id_RerouteNASRequest = INT(name='id-RerouteNASRequest', mode=MODE_VALUE)
    id_RerouteNASRequest._val = 49
    
    #-----< maxPrivateIEs >-----#
    maxPrivateIEs = INT(name='maxPrivateIEs', mode=MODE_VALUE)
    maxPrivateIEs._val = 65535
    
    #-----< maxProtocolExtensions >-----#
    maxProtocolExtensions = INT(name='maxProtocolExtensions', mode=MODE_VALUE)
    maxProtocolExtensions._val = 65535
    
    #-----< maxProtocolIEs >-----#
    maxProtocolIEs = INT(name='maxProtocolIEs', mode=MODE_VALUE)
    maxProtocolIEs._val = 65535
    
    #-----< maxNrOfDTs >-----#
    maxNrOfDTs = INT(name='maxNrOfDTs', mode=MODE_VALUE)
    maxNrOfDTs._val = 15
    
    #-----< maxNrOfErrors >-----#
    maxNrOfErrors = INT(name='maxNrOfErrors', mode=MODE_VALUE)
    maxNrOfErrors._val = 256
    
    #-----< maxNrOfIuSigConIds >-----#
    maxNrOfIuSigConIds = INT(name='maxNrOfIuSigConIds', mode=MODE_VALUE)
    maxNrOfIuSigConIds._val = 250
    
    #-----< maxNrOfPDPDirections >-----#
    maxNrOfPDPDirections = INT(name='maxNrOfPDPDirections', mode=MODE_VALUE)
    maxNrOfPDPDirections._val = 2
    
    #-----< maxNrOfPoints >-----#
    maxNrOfPoints = INT(name='maxNrOfPoints', mode=MODE_VALUE)
    maxNrOfPoints._val = 15
    
    #-----< maxNrOfRABs >-----#
    maxNrOfRABs = INT(name='maxNrOfRABs', mode=MODE_VALUE)
    maxNrOfRABs._val = 256
    
    #-----< maxNrOfSeparateTrafficDirections >-----#
    maxNrOfSeparateTrafficDirections = INT(name='maxNrOfSeparateTrafficDirections', mode=MODE_VALUE)
    maxNrOfSeparateTrafficDirections._val = 2
    
    #-----< maxNrOfSRBs >-----#
    maxNrOfSRBs = INT(name='maxNrOfSRBs', mode=MODE_VALUE)
    maxNrOfSRBs._val = 8
    
    #-----< maxNrOfVol >-----#
    maxNrOfVol = INT(name='maxNrOfVol', mode=MODE_VALUE)
    maxNrOfVol._val = 2
    
    #-----< maxNrOfLevels >-----#
    maxNrOfLevels = INT(name='maxNrOfLevels', mode=MODE_VALUE)
    maxNrOfLevels._val = 256
    
    #-----< maxNrOfAltValues >-----#
    maxNrOfAltValues = INT(name='maxNrOfAltValues', mode=MODE_VALUE)
    maxNrOfAltValues._val = 16
    
    #-----< maxNrOfPLMNsSN >-----#
    maxNrOfPLMNsSN = INT(name='maxNrOfPLMNsSN', mode=MODE_VALUE)
    maxNrOfPLMNsSN._val = 32
    
    #-----< maxNrOfLAs >-----#
    maxNrOfLAs = INT(name='maxNrOfLAs', mode=MODE_VALUE)
    maxNrOfLAs._val = 65536
    
    #-----< maxNrOfSNAs >-----#
    maxNrOfSNAs = INT(name='maxNrOfSNAs', mode=MODE_VALUE)
    maxNrOfSNAs._val = 65536
    
    #-----< maxNrOfUEsToBeTraced >-----#
    maxNrOfUEsToBeTraced = INT(name='maxNrOfUEsToBeTraced', mode=MODE_VALUE)
    maxNrOfUEsToBeTraced._val = 64
    
    #-----< maxNrOfInterfaces >-----#
    maxNrOfInterfaces = INT(name='maxNrOfInterfaces', mode=MODE_VALUE)
    maxNrOfInterfaces._val = 16
    
    #-----< maxRAB-Subflows >-----#
    maxRAB_Subflows = INT(name='maxRAB-Subflows', mode=MODE_VALUE)
    maxRAB_Subflows._val = 7
    
    #-----< maxRAB-SubflowCombination >-----#
    maxRAB_SubflowCombination = INT(name='maxRAB-SubflowCombination', mode=MODE_VALUE)
    maxRAB_SubflowCombination._val = 64
    
    #-----< maxSet >-----#
    maxSet = INT(name='maxSet', mode=MODE_VALUE)
    maxSet._val = 9
    
    #-----< maxNrOfHSDSCHMACdFlows-1 >-----#
    maxNrOfHSDSCHMACdFlows_1 = INT(name='maxNrOfHSDSCHMACdFlows-1', mode=MODE_VALUE)
    maxNrOfHSDSCHMACdFlows_1._val = 7
    
    #-----< maxnoofMulticastServicesPerUE >-----#
    maxnoofMulticastServicesPerUE = INT(name='maxnoofMulticastServicesPerUE', mode=MODE_VALUE)
    maxnoofMulticastServicesPerUE._val = 128
    
    #-----< maxnoofMulticastServicesPerRNC >-----#
    maxnoofMulticastServicesPerRNC = INT(name='maxnoofMulticastServicesPerRNC', mode=MODE_VALUE)
    maxnoofMulticastServicesPerRNC._val = 512
    
    #-----< maxMBMSSA >-----#
    maxMBMSSA = INT(name='maxMBMSSA', mode=MODE_VALUE)
    maxMBMSSA._val = 256
    
    #-----< maxMBMSRA >-----#
    maxMBMSRA = INT(name='maxMBMSRA', mode=MODE_VALUE)
    maxMBMSRA._val = 65536
    
    #-----< maxNrOfEDCHMACdFlows-1 >-----#
    maxNrOfEDCHMACdFlows_1 = INT(name='maxNrOfEDCHMACdFlows-1', mode=MODE_VALUE)
    maxNrOfEDCHMACdFlows_1._val = 7
    
    #-----< maxGANSSSet >-----#
    maxGANSSSet = INT(name='maxGANSSSet', mode=MODE_VALUE)
    maxGANSSSet._val = 9
    
    #-----< maxNrOfCSGs >-----#
    maxNrOfCSGs = INT(name='maxNrOfCSGs', mode=MODE_VALUE)
    maxNrOfCSGs._val = 256
    
    #-----< maxNrOfEUTRAFreqs >-----#
    maxNrOfEUTRAFreqs = INT(name='maxNrOfEUTRAFreqs', mode=MODE_VALUE)
    maxNrOfEUTRAFreqs._val = 8
    
    #-----< maxNrOfCellIds >-----#
    maxNrOfCellIds = INT(name='maxNrOfCellIds', mode=MODE_VALUE)
    maxNrOfCellIds._val = 32
    
    #-----< maxNrOfRAIs >-----#
    maxNrOfRAIs = INT(name='maxNrOfRAIs', mode=MODE_VALUE)
    maxNrOfRAIs._val = 8
    
    #-----< maxNrOfLAIs >-----#
    maxNrOfLAIs = INT(name='maxNrOfLAIs', mode=MODE_VALUE)
    maxNrOfLAIs._val = 8
    
    #-----< maxSizeOfIMSInfo >-----#
    maxSizeOfIMSInfo = INT(name='maxSizeOfIMSInfo', mode=MODE_VALUE)
    maxSizeOfIMSInfo._val = 32
    
    #-----< maxnoofMDTPLMNs >-----#
    maxnoofMDTPLMNs = INT(name='maxnoofMDTPLMNs', mode=MODE_VALUE)
    maxnoofMDTPLMNs._val = 16
    
    #-----< maxAddPosSet >-----#
    maxAddPosSet = INT(name='maxAddPosSet', mode=MODE_VALUE)
    maxAddPosSet._val = 8
    
    #-----< maxnoofPLMNs >-----#
    maxnoofPLMNs = INT(name='maxnoofPLMNs', mode=MODE_VALUE)
    maxnoofPLMNs._val = 16
    
    #-----< id-AreaIdentity >-----#
    id_AreaIdentity = INT(name='id-AreaIdentity', mode=MODE_VALUE)
    id_AreaIdentity._val = 0
    
    #-----< id-CN-DomainIndicator >-----#
    id_CN_DomainIndicator = INT(name='id-CN-DomainIndicator', mode=MODE_VALUE)
    id_CN_DomainIndicator._val = 3
    
    #-----< id-Cause >-----#
    id_Cause = INT(name='id-Cause', mode=MODE_VALUE)
    id_Cause._val = 4
    
    #-----< id-ChosenEncryptionAlgorithm >-----#
    id_ChosenEncryptionAlgorithm = INT(name='id-ChosenEncryptionAlgorithm', mode=MODE_VALUE)
    id_ChosenEncryptionAlgorithm._val = 5
    
    #-----< id-ChosenIntegrityProtectionAlgorithm >-----#
    id_ChosenIntegrityProtectionAlgorithm = INT(name='id-ChosenIntegrityProtectionAlgorithm', mode=MODE_VALUE)
    id_ChosenIntegrityProtectionAlgorithm._val = 6
    
    #-----< id-ClassmarkInformation2 >-----#
    id_ClassmarkInformation2 = INT(name='id-ClassmarkInformation2', mode=MODE_VALUE)
    id_ClassmarkInformation2._val = 7
    
    #-----< id-ClassmarkInformation3 >-----#
    id_ClassmarkInformation3 = INT(name='id-ClassmarkInformation3', mode=MODE_VALUE)
    id_ClassmarkInformation3._val = 8
    
    #-----< id-CriticalityDiagnostics >-----#
    id_CriticalityDiagnostics = INT(name='id-CriticalityDiagnostics', mode=MODE_VALUE)
    id_CriticalityDiagnostics._val = 9
    
    #-----< id-DL-GTP-PDU-SequenceNumber >-----#
    id_DL_GTP_PDU_SequenceNumber = INT(name='id-DL-GTP-PDU-SequenceNumber', mode=MODE_VALUE)
    id_DL_GTP_PDU_SequenceNumber._val = 10
    
    #-----< id-EncryptionInformation >-----#
    id_EncryptionInformation = INT(name='id-EncryptionInformation', mode=MODE_VALUE)
    id_EncryptionInformation._val = 11
    
    #-----< id-IntegrityProtectionInformation >-----#
    id_IntegrityProtectionInformation = INT(name='id-IntegrityProtectionInformation', mode=MODE_VALUE)
    id_IntegrityProtectionInformation._val = 12
    
    #-----< id-IuTransportAssociation >-----#
    id_IuTransportAssociation = INT(name='id-IuTransportAssociation', mode=MODE_VALUE)
    id_IuTransportAssociation._val = 13
    
    #-----< id-L3-Information >-----#
    id_L3_Information = INT(name='id-L3-Information', mode=MODE_VALUE)
    id_L3_Information._val = 14
    
    #-----< id-LAI >-----#
    id_LAI = INT(name='id-LAI', mode=MODE_VALUE)
    id_LAI._val = 15
    
    #-----< id-NAS-PDU >-----#
    id_NAS_PDU = INT(name='id-NAS-PDU', mode=MODE_VALUE)
    id_NAS_PDU._val = 16
    
    #-----< id-NonSearchingIndication >-----#
    id_NonSearchingIndication = INT(name='id-NonSearchingIndication', mode=MODE_VALUE)
    id_NonSearchingIndication._val = 17
    
    #-----< id-NumberOfSteps >-----#
    id_NumberOfSteps = INT(name='id-NumberOfSteps', mode=MODE_VALUE)
    id_NumberOfSteps._val = 18
    
    #-----< id-OMC-ID >-----#
    id_OMC_ID = INT(name='id-OMC-ID', mode=MODE_VALUE)
    id_OMC_ID._val = 19
    
    #-----< id-OldBSS-ToNewBSS-Information >-----#
    id_OldBSS_ToNewBSS_Information = INT(name='id-OldBSS-ToNewBSS-Information', mode=MODE_VALUE)
    id_OldBSS_ToNewBSS_Information._val = 20
    
    #-----< id-PagingAreaID >-----#
    id_PagingAreaID = INT(name='id-PagingAreaID', mode=MODE_VALUE)
    id_PagingAreaID._val = 21
    
    #-----< id-PagingCause >-----#
    id_PagingCause = INT(name='id-PagingCause', mode=MODE_VALUE)
    id_PagingCause._val = 22
    
    #-----< id-PermanentNAS-UE-ID >-----#
    id_PermanentNAS_UE_ID = INT(name='id-PermanentNAS-UE-ID', mode=MODE_VALUE)
    id_PermanentNAS_UE_ID._val = 23
    
    #-----< id-RAB-ContextItem >-----#
    id_RAB_ContextItem = INT(name='id-RAB-ContextItem', mode=MODE_VALUE)
    id_RAB_ContextItem._val = 24
    
    #-----< id-RAB-ContextList >-----#
    id_RAB_ContextList = INT(name='id-RAB-ContextList', mode=MODE_VALUE)
    id_RAB_ContextList._val = 25
    
    #-----< id-RAB-DataForwardingItem >-----#
    id_RAB_DataForwardingItem = INT(name='id-RAB-DataForwardingItem', mode=MODE_VALUE)
    id_RAB_DataForwardingItem._val = 26
    
    #-----< id-RAB-DataForwardingItem-SRNS-CtxReq >-----#
    id_RAB_DataForwardingItem_SRNS_CtxReq = INT(name='id-RAB-DataForwardingItem-SRNS-CtxReq', mode=MODE_VALUE)
    id_RAB_DataForwardingItem_SRNS_CtxReq._val = 27
    
    #-----< id-RAB-DataForwardingList >-----#
    id_RAB_DataForwardingList = INT(name='id-RAB-DataForwardingList', mode=MODE_VALUE)
    id_RAB_DataForwardingList._val = 28
    
    #-----< id-RAB-DataForwardingList-SRNS-CtxReq >-----#
    id_RAB_DataForwardingList_SRNS_CtxReq = INT(name='id-RAB-DataForwardingList-SRNS-CtxReq', mode=MODE_VALUE)
    id_RAB_DataForwardingList_SRNS_CtxReq._val = 29
    
    #-----< id-RAB-DataVolumeReportItem >-----#
    id_RAB_DataVolumeReportItem = INT(name='id-RAB-DataVolumeReportItem', mode=MODE_VALUE)
    id_RAB_DataVolumeReportItem._val = 30
    
    #-----< id-RAB-DataVolumeReportList >-----#
    id_RAB_DataVolumeReportList = INT(name='id-RAB-DataVolumeReportList', mode=MODE_VALUE)
    id_RAB_DataVolumeReportList._val = 31
    
    #-----< id-RAB-DataVolumeReportRequestItem >-----#
    id_RAB_DataVolumeReportRequestItem = INT(name='id-RAB-DataVolumeReportRequestItem', mode=MODE_VALUE)
    id_RAB_DataVolumeReportRequestItem._val = 32
    
    #-----< id-RAB-DataVolumeReportRequestList >-----#
    id_RAB_DataVolumeReportRequestList = INT(name='id-RAB-DataVolumeReportRequestList', mode=MODE_VALUE)
    id_RAB_DataVolumeReportRequestList._val = 33
    
    #-----< id-RAB-FailedItem >-----#
    id_RAB_FailedItem = INT(name='id-RAB-FailedItem', mode=MODE_VALUE)
    id_RAB_FailedItem._val = 34
    
    #-----< id-RAB-FailedList >-----#
    id_RAB_FailedList = INT(name='id-RAB-FailedList', mode=MODE_VALUE)
    id_RAB_FailedList._val = 35
    
    #-----< id-RAB-ID >-----#
    id_RAB_ID = INT(name='id-RAB-ID', mode=MODE_VALUE)
    id_RAB_ID._val = 36
    
    #-----< id-RAB-QueuedItem >-----#
    id_RAB_QueuedItem = INT(name='id-RAB-QueuedItem', mode=MODE_VALUE)
    id_RAB_QueuedItem._val = 37
    
    #-----< id-RAB-QueuedList >-----#
    id_RAB_QueuedList = INT(name='id-RAB-QueuedList', mode=MODE_VALUE)
    id_RAB_QueuedList._val = 38
    
    #-----< id-RAB-ReleaseFailedList >-----#
    id_RAB_ReleaseFailedList = INT(name='id-RAB-ReleaseFailedList', mode=MODE_VALUE)
    id_RAB_ReleaseFailedList._val = 39
    
    #-----< id-RAB-ReleaseItem >-----#
    id_RAB_ReleaseItem = INT(name='id-RAB-ReleaseItem', mode=MODE_VALUE)
    id_RAB_ReleaseItem._val = 40
    
    #-----< id-RAB-ReleaseList >-----#
    id_RAB_ReleaseList = INT(name='id-RAB-ReleaseList', mode=MODE_VALUE)
    id_RAB_ReleaseList._val = 41
    
    #-----< id-RAB-ReleasedItem >-----#
    id_RAB_ReleasedItem = INT(name='id-RAB-ReleasedItem', mode=MODE_VALUE)
    id_RAB_ReleasedItem._val = 42
    
    #-----< id-RAB-ReleasedList >-----#
    id_RAB_ReleasedList = INT(name='id-RAB-ReleasedList', mode=MODE_VALUE)
    id_RAB_ReleasedList._val = 43
    
    #-----< id-RAB-ReleasedList-IuRelComp >-----#
    id_RAB_ReleasedList_IuRelComp = INT(name='id-RAB-ReleasedList-IuRelComp', mode=MODE_VALUE)
    id_RAB_ReleasedList_IuRelComp._val = 44
    
    #-----< id-RAB-RelocationReleaseItem >-----#
    id_RAB_RelocationReleaseItem = INT(name='id-RAB-RelocationReleaseItem', mode=MODE_VALUE)
    id_RAB_RelocationReleaseItem._val = 45
    
    #-----< id-RAB-RelocationReleaseList >-----#
    id_RAB_RelocationReleaseList = INT(name='id-RAB-RelocationReleaseList', mode=MODE_VALUE)
    id_RAB_RelocationReleaseList._val = 46
    
    #-----< id-RAB-SetupItem-RelocReq >-----#
    id_RAB_SetupItem_RelocReq = INT(name='id-RAB-SetupItem-RelocReq', mode=MODE_VALUE)
    id_RAB_SetupItem_RelocReq._val = 47
    
    #-----< id-RAB-SetupItem-RelocReqAck >-----#
    id_RAB_SetupItem_RelocReqAck = INT(name='id-RAB-SetupItem-RelocReqAck', mode=MODE_VALUE)
    id_RAB_SetupItem_RelocReqAck._val = 48
    
    #-----< id-RAB-SetupList-RelocReq >-----#
    id_RAB_SetupList_RelocReq = INT(name='id-RAB-SetupList-RelocReq', mode=MODE_VALUE)
    id_RAB_SetupList_RelocReq._val = 49
    
    #-----< id-RAB-SetupList-RelocReqAck >-----#
    id_RAB_SetupList_RelocReqAck = INT(name='id-RAB-SetupList-RelocReqAck', mode=MODE_VALUE)
    id_RAB_SetupList_RelocReqAck._val = 50
    
    #-----< id-RAB-SetupOrModifiedItem >-----#
    id_RAB_SetupOrModifiedItem = INT(name='id-RAB-SetupOrModifiedItem', mode=MODE_VALUE)
    id_RAB_SetupOrModifiedItem._val = 51
    
    #-----< id-RAB-SetupOrModifiedList >-----#
    id_RAB_SetupOrModifiedList = INT(name='id-RAB-SetupOrModifiedList', mode=MODE_VALUE)
    id_RAB_SetupOrModifiedList._val = 52
    
    #-----< id-RAB-SetupOrModifyItem >-----#
    id_RAB_SetupOrModifyItem = INT(name='id-RAB-SetupOrModifyItem', mode=MODE_VALUE)
    id_RAB_SetupOrModifyItem._val = 53
    
    #-----< id-RAB-SetupOrModifyList >-----#
    id_RAB_SetupOrModifyList = INT(name='id-RAB-SetupOrModifyList', mode=MODE_VALUE)
    id_RAB_SetupOrModifyList._val = 54
    
    #-----< id-RAC >-----#
    id_RAC = INT(name='id-RAC', mode=MODE_VALUE)
    id_RAC._val = 55
    
    #-----< id-RelocationType >-----#
    id_RelocationType = INT(name='id-RelocationType', mode=MODE_VALUE)
    id_RelocationType._val = 56
    
    #-----< id-RequestType >-----#
    id_RequestType = INT(name='id-RequestType', mode=MODE_VALUE)
    id_RequestType._val = 57
    
    #-----< id-SAI >-----#
    id_SAI = INT(name='id-SAI', mode=MODE_VALUE)
    id_SAI._val = 58
    
    #-----< id-SAPI >-----#
    id_SAPI = INT(name='id-SAPI', mode=MODE_VALUE)
    id_SAPI._val = 59
    
    #-----< id-SourceID >-----#
    id_SourceID = INT(name='id-SourceID', mode=MODE_VALUE)
    id_SourceID._val = 60
    
    #-----< id-Source-ToTarget-TransparentContainer >-----#
    id_Source_ToTarget_TransparentContainer = INT(name='id-Source-ToTarget-TransparentContainer', mode=MODE_VALUE)
    id_Source_ToTarget_TransparentContainer._val = 61
    
    #-----< id-TargetID >-----#
    id_TargetID = INT(name='id-TargetID', mode=MODE_VALUE)
    id_TargetID._val = 62
    
    #-----< id-Target-ToSource-TransparentContainer >-----#
    id_Target_ToSource_TransparentContainer = INT(name='id-Target-ToSource-TransparentContainer', mode=MODE_VALUE)
    id_Target_ToSource_TransparentContainer._val = 63
    
    #-----< id-TemporaryUE-ID >-----#
    id_TemporaryUE_ID = INT(name='id-TemporaryUE-ID', mode=MODE_VALUE)
    id_TemporaryUE_ID._val = 64
    
    #-----< id-TraceReference >-----#
    id_TraceReference = INT(name='id-TraceReference', mode=MODE_VALUE)
    id_TraceReference._val = 65
    
    #-----< id-TraceType >-----#
    id_TraceType = INT(name='id-TraceType', mode=MODE_VALUE)
    id_TraceType._val = 66
    
    #-----< id-TransportLayerAddress >-----#
    id_TransportLayerAddress = INT(name='id-TransportLayerAddress', mode=MODE_VALUE)
    id_TransportLayerAddress._val = 67
    
    #-----< id-TriggerID >-----#
    id_TriggerID = INT(name='id-TriggerID', mode=MODE_VALUE)
    id_TriggerID._val = 68
    
    #-----< id-UE-ID >-----#
    id_UE_ID = INT(name='id-UE-ID', mode=MODE_VALUE)
    id_UE_ID._val = 69
    
    #-----< id-UL-GTP-PDU-SequenceNumber >-----#
    id_UL_GTP_PDU_SequenceNumber = INT(name='id-UL-GTP-PDU-SequenceNumber', mode=MODE_VALUE)
    id_UL_GTP_PDU_SequenceNumber._val = 70
    
    #-----< id-RAB-FailedtoReportItem >-----#
    id_RAB_FailedtoReportItem = INT(name='id-RAB-FailedtoReportItem', mode=MODE_VALUE)
    id_RAB_FailedtoReportItem._val = 71
    
    #-----< id-RAB-FailedtoReportList >-----#
    id_RAB_FailedtoReportList = INT(name='id-RAB-FailedtoReportList', mode=MODE_VALUE)
    id_RAB_FailedtoReportList._val = 72
    
    #-----< id-KeyStatus >-----#
    id_KeyStatus = INT(name='id-KeyStatus', mode=MODE_VALUE)
    id_KeyStatus._val = 75
    
    #-----< id-DRX-CycleLengthCoefficient >-----#
    id_DRX_CycleLengthCoefficient = INT(name='id-DRX-CycleLengthCoefficient', mode=MODE_VALUE)
    id_DRX_CycleLengthCoefficient._val = 76
    
    #-----< id-IuSigConIdList >-----#
    id_IuSigConIdList = INT(name='id-IuSigConIdList', mode=MODE_VALUE)
    id_IuSigConIdList._val = 77
    
    #-----< id-IuSigConIdItem >-----#
    id_IuSigConIdItem = INT(name='id-IuSigConIdItem', mode=MODE_VALUE)
    id_IuSigConIdItem._val = 78
    
    #-----< id-IuSigConId >-----#
    id_IuSigConId = INT(name='id-IuSigConId', mode=MODE_VALUE)
    id_IuSigConId._val = 79
    
    #-----< id-DirectTransferInformationItem-RANAP-RelocInf >-----#
    id_DirectTransferInformationItem_RANAP_RelocInf = INT(name='id-DirectTransferInformationItem-RANAP-RelocInf', mode=MODE_VALUE)
    id_DirectTransferInformationItem_RANAP_RelocInf._val = 80
    
    #-----< id-DirectTransferInformationList-RANAP-RelocInf >-----#
    id_DirectTransferInformationList_RANAP_RelocInf = INT(name='id-DirectTransferInformationList-RANAP-RelocInf', mode=MODE_VALUE)
    id_DirectTransferInformationList_RANAP_RelocInf._val = 81
    
    #-----< id-RAB-ContextItem-RANAP-RelocInf >-----#
    id_RAB_ContextItem_RANAP_RelocInf = INT(name='id-RAB-ContextItem-RANAP-RelocInf', mode=MODE_VALUE)
    id_RAB_ContextItem_RANAP_RelocInf._val = 82
    
    #-----< id-RAB-ContextList-RANAP-RelocInf >-----#
    id_RAB_ContextList_RANAP_RelocInf = INT(name='id-RAB-ContextList-RANAP-RelocInf', mode=MODE_VALUE)
    id_RAB_ContextList_RANAP_RelocInf._val = 83
    
    #-----< id-RAB-ContextFailedtoTransferItem >-----#
    id_RAB_ContextFailedtoTransferItem = INT(name='id-RAB-ContextFailedtoTransferItem', mode=MODE_VALUE)
    id_RAB_ContextFailedtoTransferItem._val = 84
    
    #-----< id-RAB-ContextFailedtoTransferList >-----#
    id_RAB_ContextFailedtoTransferList = INT(name='id-RAB-ContextFailedtoTransferList', mode=MODE_VALUE)
    id_RAB_ContextFailedtoTransferList._val = 85
    
    #-----< id-GlobalRNC-ID >-----#
    id_GlobalRNC_ID = INT(name='id-GlobalRNC-ID', mode=MODE_VALUE)
    id_GlobalRNC_ID._val = 86
    
    #-----< id-RAB-ReleasedItem-IuRelComp >-----#
    id_RAB_ReleasedItem_IuRelComp = INT(name='id-RAB-ReleasedItem-IuRelComp', mode=MODE_VALUE)
    id_RAB_ReleasedItem_IuRelComp._val = 87
    
    #-----< id-MessageStructure >-----#
    id_MessageStructure = INT(name='id-MessageStructure', mode=MODE_VALUE)
    id_MessageStructure._val = 88
    
    #-----< id-Alt-RAB-Parameters >-----#
    id_Alt_RAB_Parameters = INT(name='id-Alt-RAB-Parameters', mode=MODE_VALUE)
    id_Alt_RAB_Parameters._val = 89
    
    #-----< id-Ass-RAB-Parameters >-----#
    id_Ass_RAB_Parameters = INT(name='id-Ass-RAB-Parameters', mode=MODE_VALUE)
    id_Ass_RAB_Parameters._val = 90
    
    #-----< id-RAB-ModifyList >-----#
    id_RAB_ModifyList = INT(name='id-RAB-ModifyList', mode=MODE_VALUE)
    id_RAB_ModifyList._val = 91
    
    #-----< id-RAB-ModifyItem >-----#
    id_RAB_ModifyItem = INT(name='id-RAB-ModifyItem', mode=MODE_VALUE)
    id_RAB_ModifyItem._val = 92
    
    #-----< id-TypeOfError >-----#
    id_TypeOfError = INT(name='id-TypeOfError', mode=MODE_VALUE)
    id_TypeOfError._val = 93
    
    #-----< id-BroadcastAssistanceDataDecipheringKeys >-----#
    id_BroadcastAssistanceDataDecipheringKeys = INT(name='id-BroadcastAssistanceDataDecipheringKeys', mode=MODE_VALUE)
    id_BroadcastAssistanceDataDecipheringKeys._val = 94
    
    #-----< id-LocationRelatedDataRequestType >-----#
    id_LocationRelatedDataRequestType = INT(name='id-LocationRelatedDataRequestType', mode=MODE_VALUE)
    id_LocationRelatedDataRequestType._val = 95
    
    #-----< id-GlobalCN-ID >-----#
    id_GlobalCN_ID = INT(name='id-GlobalCN-ID', mode=MODE_VALUE)
    id_GlobalCN_ID._val = 96
    
    #-----< id-LastKnownServiceArea >-----#
    id_LastKnownServiceArea = INT(name='id-LastKnownServiceArea', mode=MODE_VALUE)
    id_LastKnownServiceArea._val = 97
    
    #-----< id-SRB-TrCH-Mapping >-----#
    id_SRB_TrCH_Mapping = INT(name='id-SRB-TrCH-Mapping', mode=MODE_VALUE)
    id_SRB_TrCH_Mapping._val = 98
    
    #-----< id-InterSystemInformation-TransparentContainer >-----#
    id_InterSystemInformation_TransparentContainer = INT(name='id-InterSystemInformation-TransparentContainer', mode=MODE_VALUE)
    id_InterSystemInformation_TransparentContainer._val = 99
    
    #-----< id-NewBSS-To-OldBSS-Information >-----#
    id_NewBSS_To_OldBSS_Information = INT(name='id-NewBSS-To-OldBSS-Information', mode=MODE_VALUE)
    id_NewBSS_To_OldBSS_Information._val = 100
    
    #-----< id-SourceRNC-PDCP-context-info >-----#
    id_SourceRNC_PDCP_context_info = INT(name='id-SourceRNC-PDCP-context-info', mode=MODE_VALUE)
    id_SourceRNC_PDCP_context_info._val = 103
    
    #-----< id-InformationTransferID >-----#
    id_InformationTransferID = INT(name='id-InformationTransferID', mode=MODE_VALUE)
    id_InformationTransferID._val = 104
    
    #-----< id-SNA-Access-Information >-----#
    id_SNA_Access_Information = INT(name='id-SNA-Access-Information', mode=MODE_VALUE)
    id_SNA_Access_Information._val = 105
    
    #-----< id-ProvidedData >-----#
    id_ProvidedData = INT(name='id-ProvidedData', mode=MODE_VALUE)
    id_ProvidedData._val = 106
    
    #-----< id-GERAN-BSC-Container >-----#
    id_GERAN_BSC_Container = INT(name='id-GERAN-BSC-Container', mode=MODE_VALUE)
    id_GERAN_BSC_Container._val = 107
    
    #-----< id-GERAN-Classmark >-----#
    id_GERAN_Classmark = INT(name='id-GERAN-Classmark', mode=MODE_VALUE)
    id_GERAN_Classmark._val = 108
    
    #-----< id-GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item >-----#
    id_GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item = INT(name='id-GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item', mode=MODE_VALUE)
    id_GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item._val = 109
    
    #-----< id-GERAN-Iumode-RAB-FailedList-RABAssgntResponse >-----#
    id_GERAN_Iumode_RAB_FailedList_RABAssgntResponse = INT(name='id-GERAN-Iumode-RAB-FailedList-RABAssgntResponse', mode=MODE_VALUE)
    id_GERAN_Iumode_RAB_FailedList_RABAssgntResponse._val = 110
    
    #-----< id-VerticalAccuracyCode >-----#
    id_VerticalAccuracyCode = INT(name='id-VerticalAccuracyCode', mode=MODE_VALUE)
    id_VerticalAccuracyCode._val = 111
    
    #-----< id-ResponseTime >-----#
    id_ResponseTime = INT(name='id-ResponseTime', mode=MODE_VALUE)
    id_ResponseTime._val = 112
    
    #-----< id-PositioningPriority >-----#
    id_PositioningPriority = INT(name='id-PositioningPriority', mode=MODE_VALUE)
    id_PositioningPriority._val = 113
    
    #-----< id-ClientType >-----#
    id_ClientType = INT(name='id-ClientType', mode=MODE_VALUE)
    id_ClientType._val = 114
    
    #-----< id-LocationRelatedDataRequestTypeSpecificToGERANIuMode >-----#
    id_LocationRelatedDataRequestTypeSpecificToGERANIuMode = INT(name='id-LocationRelatedDataRequestTypeSpecificToGERANIuMode', mode=MODE_VALUE)
    id_LocationRelatedDataRequestTypeSpecificToGERANIuMode._val = 115
    
    #-----< id-SignallingIndication >-----#
    id_SignallingIndication = INT(name='id-SignallingIndication', mode=MODE_VALUE)
    id_SignallingIndication._val = 116
    
    #-----< id-hS-DSCH-MAC-d-Flow-ID >-----#
    id_hS_DSCH_MAC_d_Flow_ID = INT(name='id-hS-DSCH-MAC-d-Flow-ID', mode=MODE_VALUE)
    id_hS_DSCH_MAC_d_Flow_ID._val = 117
    
    #-----< id-UESBI-Iu >-----#
    id_UESBI_Iu = INT(name='id-UESBI-Iu', mode=MODE_VALUE)
    id_UESBI_Iu._val = 118
    
    #-----< id-PositionData >-----#
    id_PositionData = INT(name='id-PositionData', mode=MODE_VALUE)
    id_PositionData._val = 119
    
    #-----< id-PositionDataSpecificToGERANIuMode >-----#
    id_PositionDataSpecificToGERANIuMode = INT(name='id-PositionDataSpecificToGERANIuMode', mode=MODE_VALUE)
    id_PositionDataSpecificToGERANIuMode._val = 120
    
    #-----< id-CellLoadInformationGroup >-----#
    id_CellLoadInformationGroup = INT(name='id-CellLoadInformationGroup', mode=MODE_VALUE)
    id_CellLoadInformationGroup._val = 121
    
    #-----< id-AccuracyFulfilmentIndicator >-----#
    id_AccuracyFulfilmentIndicator = INT(name='id-AccuracyFulfilmentIndicator', mode=MODE_VALUE)
    id_AccuracyFulfilmentIndicator._val = 122
    
    #-----< id-InformationTransferType >-----#
    id_InformationTransferType = INT(name='id-InformationTransferType', mode=MODE_VALUE)
    id_InformationTransferType._val = 123
    
    #-----< id-TraceRecordingSessionInformation >-----#
    id_TraceRecordingSessionInformation = INT(name='id-TraceRecordingSessionInformation', mode=MODE_VALUE)
    id_TraceRecordingSessionInformation._val = 124
    
    #-----< id-TracePropagationParameters >-----#
    id_TracePropagationParameters = INT(name='id-TracePropagationParameters', mode=MODE_VALUE)
    id_TracePropagationParameters._val = 125
    
    #-----< id-InterSystemInformationTransferType >-----#
    id_InterSystemInformationTransferType = INT(name='id-InterSystemInformationTransferType', mode=MODE_VALUE)
    id_InterSystemInformationTransferType._val = 126
    
    #-----< id-SelectedPLMN-ID >-----#
    id_SelectedPLMN_ID = INT(name='id-SelectedPLMN-ID', mode=MODE_VALUE)
    id_SelectedPLMN_ID._val = 127
    
    #-----< id-RedirectionCompleted >-----#
    id_RedirectionCompleted = INT(name='id-RedirectionCompleted', mode=MODE_VALUE)
    id_RedirectionCompleted._val = 128
    
    #-----< id-RedirectionIndication >-----#
    id_RedirectionIndication = INT(name='id-RedirectionIndication', mode=MODE_VALUE)
    id_RedirectionIndication._val = 129
    
    #-----< id-NAS-SequenceNumber >-----#
    id_NAS_SequenceNumber = INT(name='id-NAS-SequenceNumber', mode=MODE_VALUE)
    id_NAS_SequenceNumber._val = 130
    
    #-----< id-RejectCauseValue >-----#
    id_RejectCauseValue = INT(name='id-RejectCauseValue', mode=MODE_VALUE)
    id_RejectCauseValue._val = 131
    
    #-----< id-APN >-----#
    id_APN = INT(name='id-APN', mode=MODE_VALUE)
    id_APN._val = 132
    
    #-----< id-CNMBMSLinkingInformation >-----#
    id_CNMBMSLinkingInformation = INT(name='id-CNMBMSLinkingInformation', mode=MODE_VALUE)
    id_CNMBMSLinkingInformation._val = 133
    
    #-----< id-DeltaRAListofIdleModeUEs >-----#
    id_DeltaRAListofIdleModeUEs = INT(name='id-DeltaRAListofIdleModeUEs', mode=MODE_VALUE)
    id_DeltaRAListofIdleModeUEs._val = 134
    
    #-----< id-FrequenceLayerConvergenceFlag >-----#
    id_FrequenceLayerConvergenceFlag = INT(name='id-FrequenceLayerConvergenceFlag', mode=MODE_VALUE)
    id_FrequenceLayerConvergenceFlag._val = 135
    
    #-----< id-InformationExchangeID >-----#
    id_InformationExchangeID = INT(name='id-InformationExchangeID', mode=MODE_VALUE)
    id_InformationExchangeID._val = 136
    
    #-----< id-InformationExchangeType >-----#
    id_InformationExchangeType = INT(name='id-InformationExchangeType', mode=MODE_VALUE)
    id_InformationExchangeType._val = 137
    
    #-----< id-InformationRequested >-----#
    id_InformationRequested = INT(name='id-InformationRequested', mode=MODE_VALUE)
    id_InformationRequested._val = 138
    
    #-----< id-InformationRequestType >-----#
    id_InformationRequestType = INT(name='id-InformationRequestType', mode=MODE_VALUE)
    id_InformationRequestType._val = 139
    
    #-----< id-IPMulticastAddress >-----#
    id_IPMulticastAddress = INT(name='id-IPMulticastAddress', mode=MODE_VALUE)
    id_IPMulticastAddress._val = 140
    
    #-----< id-JoinedMBMSBearerServicesList >-----#
    id_JoinedMBMSBearerServicesList = INT(name='id-JoinedMBMSBearerServicesList', mode=MODE_VALUE)
    id_JoinedMBMSBearerServicesList._val = 141
    
    #-----< id-LeftMBMSBearerServicesList >-----#
    id_LeftMBMSBearerServicesList = INT(name='id-LeftMBMSBearerServicesList', mode=MODE_VALUE)
    id_LeftMBMSBearerServicesList._val = 142
    
    #-----< id-MBMSBearerServiceType >-----#
    id_MBMSBearerServiceType = INT(name='id-MBMSBearerServiceType', mode=MODE_VALUE)
    id_MBMSBearerServiceType._val = 143
    
    #-----< id-MBMSCNDe-Registration >-----#
    id_MBMSCNDe_Registration = INT(name='id-MBMSCNDe-Registration', mode=MODE_VALUE)
    id_MBMSCNDe_Registration._val = 144
    
    #-----< id-MBMSServiceArea >-----#
    id_MBMSServiceArea = INT(name='id-MBMSServiceArea', mode=MODE_VALUE)
    id_MBMSServiceArea._val = 145
    
    #-----< id-MBMSSessionDuration >-----#
    id_MBMSSessionDuration = INT(name='id-MBMSSessionDuration', mode=MODE_VALUE)
    id_MBMSSessionDuration._val = 146
    
    #-----< id-MBMSSessionIdentity >-----#
    id_MBMSSessionIdentity = INT(name='id-MBMSSessionIdentity', mode=MODE_VALUE)
    id_MBMSSessionIdentity._val = 147
    
    #-----< id-PDP-TypeInformation >-----#
    id_PDP_TypeInformation = INT(name='id-PDP-TypeInformation', mode=MODE_VALUE)
    id_PDP_TypeInformation._val = 148
    
    #-----< id-RAB-Parameters >-----#
    id_RAB_Parameters = INT(name='id-RAB-Parameters', mode=MODE_VALUE)
    id_RAB_Parameters._val = 149
    
    #-----< id-RAListofIdleModeUEs >-----#
    id_RAListofIdleModeUEs = INT(name='id-RAListofIdleModeUEs', mode=MODE_VALUE)
    id_RAListofIdleModeUEs._val = 150
    
    #-----< id-MBMSRegistrationRequestType >-----#
    id_MBMSRegistrationRequestType = INT(name='id-MBMSRegistrationRequestType', mode=MODE_VALUE)
    id_MBMSRegistrationRequestType._val = 151
    
    #-----< id-SessionUpdateID >-----#
    id_SessionUpdateID = INT(name='id-SessionUpdateID', mode=MODE_VALUE)
    id_SessionUpdateID._val = 152
    
    #-----< id-TMGI >-----#
    id_TMGI = INT(name='id-TMGI', mode=MODE_VALUE)
    id_TMGI._val = 153
    
    #-----< id-TransportLayerInformation >-----#
    id_TransportLayerInformation = INT(name='id-TransportLayerInformation', mode=MODE_VALUE)
    id_TransportLayerInformation._val = 154
    
    #-----< id-UnsuccessfulLinkingList >-----#
    id_UnsuccessfulLinkingList = INT(name='id-UnsuccessfulLinkingList', mode=MODE_VALUE)
    id_UnsuccessfulLinkingList._val = 155
    
    #-----< id-MBMSLinkingInformation >-----#
    id_MBMSLinkingInformation = INT(name='id-MBMSLinkingInformation', mode=MODE_VALUE)
    id_MBMSLinkingInformation._val = 156
    
    #-----< id-MBMSSessionRepetitionNumber >-----#
    id_MBMSSessionRepetitionNumber = INT(name='id-MBMSSessionRepetitionNumber', mode=MODE_VALUE)
    id_MBMSSessionRepetitionNumber._val = 157
    
    #-----< id-AlternativeRABConfiguration >-----#
    id_AlternativeRABConfiguration = INT(name='id-AlternativeRABConfiguration', mode=MODE_VALUE)
    id_AlternativeRABConfiguration._val = 158
    
    #-----< id-AlternativeRABConfigurationRequest >-----#
    id_AlternativeRABConfigurationRequest = INT(name='id-AlternativeRABConfigurationRequest', mode=MODE_VALUE)
    id_AlternativeRABConfigurationRequest._val = 159
    
    #-----< id-E-DCH-MAC-d-Flow-ID >-----#
    id_E_DCH_MAC_d_Flow_ID = INT(name='id-E-DCH-MAC-d-Flow-ID', mode=MODE_VALUE)
    id_E_DCH_MAC_d_Flow_ID._val = 160
    
    #-----< id-SourceBSS-ToTargetBSS-TransparentContainer >-----#
    id_SourceBSS_ToTargetBSS_TransparentContainer = INT(name='id-SourceBSS-ToTargetBSS-TransparentContainer', mode=MODE_VALUE)
    id_SourceBSS_ToTargetBSS_TransparentContainer._val = 161
    
    #-----< id-TargetBSS-ToSourceBSS-TransparentContainer >-----#
    id_TargetBSS_ToSourceBSS_TransparentContainer = INT(name='id-TargetBSS-ToSourceBSS-TransparentContainer', mode=MODE_VALUE)
    id_TargetBSS_ToSourceBSS_TransparentContainer._val = 162
    
    #-----< id-TimeToMBMSDataTransfer >-----#
    id_TimeToMBMSDataTransfer = INT(name='id-TimeToMBMSDataTransfer', mode=MODE_VALUE)
    id_TimeToMBMSDataTransfer._val = 163
    
    #-----< id-IncludeVelocity >-----#
    id_IncludeVelocity = INT(name='id-IncludeVelocity', mode=MODE_VALUE)
    id_IncludeVelocity._val = 164
    
    #-----< id-VelocityEstimate >-----#
    id_VelocityEstimate = INT(name='id-VelocityEstimate', mode=MODE_VALUE)
    id_VelocityEstimate._val = 165
    
    #-----< id-RedirectAttemptFlag >-----#
    id_RedirectAttemptFlag = INT(name='id-RedirectAttemptFlag', mode=MODE_VALUE)
    id_RedirectAttemptFlag._val = 166
    
    #-----< id-RAT-Type >-----#
    id_RAT_Type = INT(name='id-RAT-Type', mode=MODE_VALUE)
    id_RAT_Type._val = 167
    
    #-----< id-PeriodicLocationInfo >-----#
    id_PeriodicLocationInfo = INT(name='id-PeriodicLocationInfo', mode=MODE_VALUE)
    id_PeriodicLocationInfo._val = 168
    
    #-----< id-MBMSCountingInformation >-----#
    id_MBMSCountingInformation = INT(name='id-MBMSCountingInformation', mode=MODE_VALUE)
    id_MBMSCountingInformation._val = 169
    
    #-----< id-170-not-to-be-used-for-IE-ids >-----#
    id_170_not_to_be_used_for_IE_ids = INT(name='id-170-not-to-be-used-for-IE-ids', mode=MODE_VALUE)
    id_170_not_to_be_used_for_IE_ids._val = 170
    
    #-----< id-ExtendedRNC-ID >-----#
    id_ExtendedRNC_ID = INT(name='id-ExtendedRNC-ID', mode=MODE_VALUE)
    id_ExtendedRNC_ID._val = 171
    
    #-----< id-Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf >-----#
    id_Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf = INT(name='id-Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf', mode=MODE_VALUE)
    id_Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf._val = 172
    
    #-----< id-Alt-RAB-Parameter-ExtendedMaxBitrateInf >-----#
    id_Alt_RAB_Parameter_ExtendedMaxBitrateInf = INT(name='id-Alt-RAB-Parameter-ExtendedMaxBitrateInf', mode=MODE_VALUE)
    id_Alt_RAB_Parameter_ExtendedMaxBitrateInf._val = 173
    
    #-----< id-Ass-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    id_Ass_RAB_Parameter_ExtendedGuaranteedBitrateList = INT(name='id-Ass-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_VALUE)
    id_Ass_RAB_Parameter_ExtendedGuaranteedBitrateList._val = 174
    
    #-----< id-Ass-RAB-Parameter-ExtendedMaxBitrateList >-----#
    id_Ass_RAB_Parameter_ExtendedMaxBitrateList = INT(name='id-Ass-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_VALUE)
    id_Ass_RAB_Parameter_ExtendedMaxBitrateList._val = 175
    
    #-----< id-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    id_RAB_Parameter_ExtendedGuaranteedBitrateList = INT(name='id-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_VALUE)
    id_RAB_Parameter_ExtendedGuaranteedBitrateList._val = 176
    
    #-----< id-RAB-Parameter-ExtendedMaxBitrateList >-----#
    id_RAB_Parameter_ExtendedMaxBitrateList = INT(name='id-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_VALUE)
    id_RAB_Parameter_ExtendedMaxBitrateList._val = 177
    
    #-----< id-Requested-RAB-Parameter-ExtendedMaxBitrateList >-----#
    id_Requested_RAB_Parameter_ExtendedMaxBitrateList = INT(name='id-Requested-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_VALUE)
    id_Requested_RAB_Parameter_ExtendedMaxBitrateList._val = 178
    
    #-----< id-Requested-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    id_Requested_RAB_Parameter_ExtendedGuaranteedBitrateList = INT(name='id-Requested-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_VALUE)
    id_Requested_RAB_Parameter_ExtendedGuaranteedBitrateList._val = 179
    
    #-----< id-LAofIdleModeUEs >-----#
    id_LAofIdleModeUEs = INT(name='id-LAofIdleModeUEs', mode=MODE_VALUE)
    id_LAofIdleModeUEs._val = 180
    
    #-----< id-newLAListofIdleModeUEs >-----#
    id_newLAListofIdleModeUEs = INT(name='id-newLAListofIdleModeUEs', mode=MODE_VALUE)
    id_newLAListofIdleModeUEs._val = 181
    
    #-----< id-LAListwithNoIdleModeUEsAnyMore >-----#
    id_LAListwithNoIdleModeUEsAnyMore = INT(name='id-LAListwithNoIdleModeUEsAnyMore', mode=MODE_VALUE)
    id_LAListwithNoIdleModeUEsAnyMore._val = 182
    
    #-----< id-183-not-to-be-used-for-IE-ids >-----#
    id_183_not_to_be_used_for_IE_ids = INT(name='id-183-not-to-be-used-for-IE-ids', mode=MODE_VALUE)
    id_183_not_to_be_used_for_IE_ids._val = 183
    
    #-----< id-GANSS-PositioningDataSet >-----#
    id_GANSS_PositioningDataSet = INT(name='id-GANSS-PositioningDataSet', mode=MODE_VALUE)
    id_GANSS_PositioningDataSet._val = 184
    
    #-----< id-RequestedGANSSAssistanceData >-----#
    id_RequestedGANSSAssistanceData = INT(name='id-RequestedGANSSAssistanceData', mode=MODE_VALUE)
    id_RequestedGANSSAssistanceData._val = 185
    
    #-----< id-BroadcastGANSSAssistanceDataDecipheringKeys >-----#
    id_BroadcastGANSSAssistanceDataDecipheringKeys = INT(name='id-BroadcastGANSSAssistanceDataDecipheringKeys', mode=MODE_VALUE)
    id_BroadcastGANSSAssistanceDataDecipheringKeys._val = 186
    
    #-----< id-d-RNTI-for-NoIuCSUP >-----#
    id_d_RNTI_for_NoIuCSUP = INT(name='id-d-RNTI-for-NoIuCSUP', mode=MODE_VALUE)
    id_d_RNTI_for_NoIuCSUP._val = 187
    
    #-----< id-RAB-SetupList-EnhancedRelocCompleteReq >-----#
    id_RAB_SetupList_EnhancedRelocCompleteReq = INT(name='id-RAB-SetupList-EnhancedRelocCompleteReq', mode=MODE_VALUE)
    id_RAB_SetupList_EnhancedRelocCompleteReq._val = 188
    
    #-----< id-RAB-SetupItem-EnhancedRelocCompleteReq >-----#
    id_RAB_SetupItem_EnhancedRelocCompleteReq = INT(name='id-RAB-SetupItem-EnhancedRelocCompleteReq', mode=MODE_VALUE)
    id_RAB_SetupItem_EnhancedRelocCompleteReq._val = 189
    
    #-----< id-RAB-SetupList-EnhancedRelocCompleteRes >-----#
    id_RAB_SetupList_EnhancedRelocCompleteRes = INT(name='id-RAB-SetupList-EnhancedRelocCompleteRes', mode=MODE_VALUE)
    id_RAB_SetupList_EnhancedRelocCompleteRes._val = 190
    
    #-----< id-RAB-SetupItem-EnhancedRelocCompleteRes >-----#
    id_RAB_SetupItem_EnhancedRelocCompleteRes = INT(name='id-RAB-SetupItem-EnhancedRelocCompleteRes', mode=MODE_VALUE)
    id_RAB_SetupItem_EnhancedRelocCompleteRes._val = 191
    
    #-----< id-RAB-SetupList-EnhRelocInfoReq >-----#
    id_RAB_SetupList_EnhRelocInfoReq = INT(name='id-RAB-SetupList-EnhRelocInfoReq', mode=MODE_VALUE)
    id_RAB_SetupList_EnhRelocInfoReq._val = 192
    
    #-----< id-RAB-SetupItem-EnhRelocInfoReq >-----#
    id_RAB_SetupItem_EnhRelocInfoReq = INT(name='id-RAB-SetupItem-EnhRelocInfoReq', mode=MODE_VALUE)
    id_RAB_SetupItem_EnhRelocInfoReq._val = 193
    
    #-----< id-RAB-SetupList-EnhRelocInfoRes >-----#
    id_RAB_SetupList_EnhRelocInfoRes = INT(name='id-RAB-SetupList-EnhRelocInfoRes', mode=MODE_VALUE)
    id_RAB_SetupList_EnhRelocInfoRes._val = 194
    
    #-----< id-RAB-SetupItem-EnhRelocInfoRes >-----#
    id_RAB_SetupItem_EnhRelocInfoRes = INT(name='id-RAB-SetupItem-EnhRelocInfoRes', mode=MODE_VALUE)
    id_RAB_SetupItem_EnhRelocInfoRes._val = 195
    
    #-----< id-OldIuSigConId >-----#
    id_OldIuSigConId = INT(name='id-OldIuSigConId', mode=MODE_VALUE)
    id_OldIuSigConId._val = 196
    
    #-----< id-RAB-FailedList-EnhRelocInfoRes >-----#
    id_RAB_FailedList_EnhRelocInfoRes = INT(name='id-RAB-FailedList-EnhRelocInfoRes', mode=MODE_VALUE)
    id_RAB_FailedList_EnhRelocInfoRes._val = 197
    
    #-----< id-RAB-FailedItem-EnhRelocInfoRes >-----#
    id_RAB_FailedItem_EnhRelocInfoRes = INT(name='id-RAB-FailedItem-EnhRelocInfoRes', mode=MODE_VALUE)
    id_RAB_FailedItem_EnhRelocInfoRes._val = 198
    
    #-----< id-Global-ENB-ID >-----#
    id_Global_ENB_ID = INT(name='id-Global-ENB-ID', mode=MODE_VALUE)
    id_Global_ENB_ID._val = 199
    
    #-----< id-UE-History-Information >-----#
    id_UE_History_Information = INT(name='id-UE-History-Information', mode=MODE_VALUE)
    id_UE_History_Information._val = 200
    
    #-----< id-MBMSSynchronisationInformation >-----#
    id_MBMSSynchronisationInformation = INT(name='id-MBMSSynchronisationInformation', mode=MODE_VALUE)
    id_MBMSSynchronisationInformation._val = 201
    
    #-----< id-SubscriberProfileIDforRFP >-----#
    id_SubscriberProfileIDforRFP = INT(name='id-SubscriberProfileIDforRFP', mode=MODE_VALUE)
    id_SubscriberProfileIDforRFP._val = 202
    
    #-----< id-CSG-Id >-----#
    id_CSG_Id = INT(name='id-CSG-Id', mode=MODE_VALUE)
    id_CSG_Id._val = 203
    
    #-----< id-OldIuSigConIdCS >-----#
    id_OldIuSigConIdCS = INT(name='id-OldIuSigConIdCS', mode=MODE_VALUE)
    id_OldIuSigConIdCS._val = 204
    
    #-----< id-OldIuSigConIdPS >-----#
    id_OldIuSigConIdPS = INT(name='id-OldIuSigConIdPS', mode=MODE_VALUE)
    id_OldIuSigConIdPS._val = 205
    
    #-----< id-GlobalCN-IDCS >-----#
    id_GlobalCN_IDCS = INT(name='id-GlobalCN-IDCS', mode=MODE_VALUE)
    id_GlobalCN_IDCS._val = 206
    
    #-----< id-GlobalCN-IDPS >-----#
    id_GlobalCN_IDPS = INT(name='id-GlobalCN-IDPS', mode=MODE_VALUE)
    id_GlobalCN_IDPS._val = 207
    
    #-----< id-SourceExtendedRNC-ID >-----#
    id_SourceExtendedRNC_ID = INT(name='id-SourceExtendedRNC-ID', mode=MODE_VALUE)
    id_SourceExtendedRNC_ID._val = 208
    
    #-----< id-RAB-ToBeReleasedItem-EnhancedRelocCompleteRes >-----#
    id_RAB_ToBeReleasedItem_EnhancedRelocCompleteRes = INT(name='id-RAB-ToBeReleasedItem-EnhancedRelocCompleteRes', mode=MODE_VALUE)
    id_RAB_ToBeReleasedItem_EnhancedRelocCompleteRes._val = 209
    
    #-----< id-RAB-ToBeReleasedList-EnhancedRelocCompleteRes >-----#
    id_RAB_ToBeReleasedList_EnhancedRelocCompleteRes = INT(name='id-RAB-ToBeReleasedList-EnhancedRelocCompleteRes', mode=MODE_VALUE)
    id_RAB_ToBeReleasedList_EnhancedRelocCompleteRes._val = 210
    
    #-----< id-SourceRNC-ID >-----#
    id_SourceRNC_ID = INT(name='id-SourceRNC-ID', mode=MODE_VALUE)
    id_SourceRNC_ID._val = 211
    
    #-----< id-Relocation-TargetRNC-ID >-----#
    id_Relocation_TargetRNC_ID = INT(name='id-Relocation-TargetRNC-ID', mode=MODE_VALUE)
    id_Relocation_TargetRNC_ID._val = 212
    
    #-----< id-Relocation-TargetExtendedRNC-ID >-----#
    id_Relocation_TargetExtendedRNC_ID = INT(name='id-Relocation-TargetExtendedRNC-ID', mode=MODE_VALUE)
    id_Relocation_TargetExtendedRNC_ID._val = 213
    
    #-----< id-Alt-RAB-Parameter-SupportedGuaranteedBitrateInf >-----#
    id_Alt_RAB_Parameter_SupportedGuaranteedBitrateInf = INT(name='id-Alt-RAB-Parameter-SupportedGuaranteedBitrateInf', mode=MODE_VALUE)
    id_Alt_RAB_Parameter_SupportedGuaranteedBitrateInf._val = 214
    
    #-----< id-Alt-RAB-Parameter-SupportedMaxBitrateInf >-----#
    id_Alt_RAB_Parameter_SupportedMaxBitrateInf = INT(name='id-Alt-RAB-Parameter-SupportedMaxBitrateInf', mode=MODE_VALUE)
    id_Alt_RAB_Parameter_SupportedMaxBitrateInf._val = 215
    
    #-----< id-Ass-RAB-Parameter-SupportedGuaranteedBitrateList >-----#
    id_Ass_RAB_Parameter_SupportedGuaranteedBitrateList = INT(name='id-Ass-RAB-Parameter-SupportedGuaranteedBitrateList', mode=MODE_VALUE)
    id_Ass_RAB_Parameter_SupportedGuaranteedBitrateList._val = 216
    
    #-----< id-Ass-RAB-Parameter-SupportedMaxBitrateList >-----#
    id_Ass_RAB_Parameter_SupportedMaxBitrateList = INT(name='id-Ass-RAB-Parameter-SupportedMaxBitrateList', mode=MODE_VALUE)
    id_Ass_RAB_Parameter_SupportedMaxBitrateList._val = 217
    
    #-----< id-RAB-Parameter-SupportedGuaranteedBitrateList >-----#
    id_RAB_Parameter_SupportedGuaranteedBitrateList = INT(name='id-RAB-Parameter-SupportedGuaranteedBitrateList', mode=MODE_VALUE)
    id_RAB_Parameter_SupportedGuaranteedBitrateList._val = 218
    
    #-----< id-RAB-Parameter-SupportedMaxBitrateList >-----#
    id_RAB_Parameter_SupportedMaxBitrateList = INT(name='id-RAB-Parameter-SupportedMaxBitrateList', mode=MODE_VALUE)
    id_RAB_Parameter_SupportedMaxBitrateList._val = 219
    
    #-----< id-Requested-RAB-Parameter-SupportedMaxBitrateList >-----#
    id_Requested_RAB_Parameter_SupportedMaxBitrateList = INT(name='id-Requested-RAB-Parameter-SupportedMaxBitrateList', mode=MODE_VALUE)
    id_Requested_RAB_Parameter_SupportedMaxBitrateList._val = 220
    
    #-----< id-Requested-RAB-Parameter-SupportedGuaranteedBitrateList >-----#
    id_Requested_RAB_Parameter_SupportedGuaranteedBitrateList = INT(name='id-Requested-RAB-Parameter-SupportedGuaranteedBitrateList', mode=MODE_VALUE)
    id_Requested_RAB_Parameter_SupportedGuaranteedBitrateList._val = 221
    
    #-----< id-Relocation-SourceRNC-ID >-----#
    id_Relocation_SourceRNC_ID = INT(name='id-Relocation-SourceRNC-ID', mode=MODE_VALUE)
    id_Relocation_SourceRNC_ID._val = 222
    
    #-----< id-Relocation-SourceExtendedRNC-ID >-----#
    id_Relocation_SourceExtendedRNC_ID = INT(name='id-Relocation-SourceExtendedRNC-ID', mode=MODE_VALUE)
    id_Relocation_SourceExtendedRNC_ID._val = 223
    
    #-----< id-EncryptionKey >-----#
    id_EncryptionKey = INT(name='id-EncryptionKey', mode=MODE_VALUE)
    id_EncryptionKey._val = 224
    
    #-----< id-IntegrityProtectionKey >-----#
    id_IntegrityProtectionKey = INT(name='id-IntegrityProtectionKey', mode=MODE_VALUE)
    id_IntegrityProtectionKey._val = 225
    
    #-----< id-SRVCC-HO-Indication >-----#
    id_SRVCC_HO_Indication = INT(name='id-SRVCC-HO-Indication', mode=MODE_VALUE)
    id_SRVCC_HO_Indication._val = 226
    
    #-----< id-SRVCC-Information >-----#
    id_SRVCC_Information = INT(name='id-SRVCC-Information', mode=MODE_VALUE)
    id_SRVCC_Information._val = 227
    
    #-----< id-SRVCC-Operation-Possible >-----#
    id_SRVCC_Operation_Possible = INT(name='id-SRVCC-Operation-Possible', mode=MODE_VALUE)
    id_SRVCC_Operation_Possible._val = 228
    
    #-----< id-CSG-Id-List >-----#
    id_CSG_Id_List = INT(name='id-CSG-Id-List', mode=MODE_VALUE)
    id_CSG_Id_List._val = 229
    
    #-----< id-PSRABtobeReplaced >-----#
    id_PSRABtobeReplaced = INT(name='id-PSRABtobeReplaced', mode=MODE_VALUE)
    id_PSRABtobeReplaced._val = 230
    
    #-----< id-E-UTRAN-Service-Handover >-----#
    id_E_UTRAN_Service_Handover = INT(name='id-E-UTRAN-Service-Handover', mode=MODE_VALUE)
    id_E_UTRAN_Service_Handover._val = 231
    
    #-----< id-UE-AggregateMaximumBitRate >-----#
    id_UE_AggregateMaximumBitRate = INT(name='id-UE-AggregateMaximumBitRate', mode=MODE_VALUE)
    id_UE_AggregateMaximumBitRate._val = 233
    
    #-----< id-CSG-Membership-Status >-----#
    id_CSG_Membership_Status = INT(name='id-CSG-Membership-Status', mode=MODE_VALUE)
    id_CSG_Membership_Status._val = 234
    
    #-----< id-Cell-Access-Mode >-----#
    id_Cell_Access_Mode = INT(name='id-Cell-Access-Mode', mode=MODE_VALUE)
    id_Cell_Access_Mode._val = 235
    
    #-----< id-IP-Source-Address >-----#
    id_IP_Source_Address = INT(name='id-IP-Source-Address', mode=MODE_VALUE)
    id_IP_Source_Address._val = 236
    
    #-----< id-CSFB-Information >-----#
    id_CSFB_Information = INT(name='id-CSFB-Information', mode=MODE_VALUE)
    id_CSFB_Information._val = 237
    
    #-----< id-PDP-TypeInformation-extension >-----#
    id_PDP_TypeInformation_extension = INT(name='id-PDP-TypeInformation-extension', mode=MODE_VALUE)
    id_PDP_TypeInformation_extension._val = 238
    
    #-----< id-MSISDN >-----#
    id_MSISDN = INT(name='id-MSISDN', mode=MODE_VALUE)
    id_MSISDN._val = 239
    
    #-----< id-Offload-RAB-Parameters >-----#
    id_Offload_RAB_Parameters = INT(name='id-Offload-RAB-Parameters', mode=MODE_VALUE)
    id_Offload_RAB_Parameters._val = 240
    
    #-----< id-LGW-TransportLayerAddress >-----#
    id_LGW_TransportLayerAddress = INT(name='id-LGW-TransportLayerAddress', mode=MODE_VALUE)
    id_LGW_TransportLayerAddress._val = 241
    
    #-----< id-Correlation-ID >-----#
    id_Correlation_ID = INT(name='id-Correlation-ID', mode=MODE_VALUE)
    id_Correlation_ID._val = 242
    
    #-----< id-IRAT-Measurement-Configuration >-----#
    id_IRAT_Measurement_Configuration = INT(name='id-IRAT-Measurement-Configuration', mode=MODE_VALUE)
    id_IRAT_Measurement_Configuration._val = 243
    
    #-----< id-MDT-Configuration >-----#
    id_MDT_Configuration = INT(name='id-MDT-Configuration', mode=MODE_VALUE)
    id_MDT_Configuration._val = 244
    
    #-----< id-Priority-Class-Indicator >-----#
    id_Priority_Class_Indicator = INT(name='id-Priority-Class-Indicator', mode=MODE_VALUE)
    id_Priority_Class_Indicator._val = 245
    
    #-----< id-RNSAPRelocationParameters >-----#
    id_RNSAPRelocationParameters = INT(name='id-RNSAPRelocationParameters', mode=MODE_VALUE)
    id_RNSAPRelocationParameters._val = 247
    
    #-----< id-RABParametersList >-----#
    id_RABParametersList = INT(name='id-RABParametersList', mode=MODE_VALUE)
    id_RABParametersList._val = 248
    
    #-----< id-Management-Based-MDT-Allowed >-----#
    id_Management_Based_MDT_Allowed = INT(name='id-Management-Based-MDT-Allowed', mode=MODE_VALUE)
    id_Management_Based_MDT_Allowed._val = 249
    
    #-----< id-HigherBitratesThan16MbpsFlag >-----#
    id_HigherBitratesThan16MbpsFlag = INT(name='id-HigherBitratesThan16MbpsFlag', mode=MODE_VALUE)
    id_HigherBitratesThan16MbpsFlag._val = 250
    
    #-----< id-Trace-Collection-Entity-IP-Addess >-----#
    id_Trace_Collection_Entity_IP_Addess = INT(name='id-Trace-Collection-Entity-IP-Addess', mode=MODE_VALUE)
    id_Trace_Collection_Entity_IP_Addess._val = 251
    
    #-----< id-End-Of-CSFB >-----#
    id_End_Of_CSFB = INT(name='id-End-Of-CSFB', mode=MODE_VALUE)
    id_End_Of_CSFB._val = 252
    
    #-----< id-Time-UE-StayedInCell-EnhancedGranularity >-----#
    id_Time_UE_StayedInCell_EnhancedGranularity = INT(name='id-Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_VALUE)
    id_Time_UE_StayedInCell_EnhancedGranularity._val = 253
    
    #-----< id-Out-Of-UTRAN >-----#
    id_Out_Of_UTRAN = INT(name='id-Out-Of-UTRAN', mode=MODE_VALUE)
    id_Out_Of_UTRAN._val = 254
    
    #-----< id-TraceRecordingSessionReference >-----#
    id_TraceRecordingSessionReference = INT(name='id-TraceRecordingSessionReference', mode=MODE_VALUE)
    id_TraceRecordingSessionReference._val = 255
    
    #-----< id-IMSI >-----#
    id_IMSI = INT(name='id-IMSI', mode=MODE_VALUE)
    id_IMSI._val = 256
    
    #-----< id-HO-Cause >-----#
    id_HO_Cause = INT(name='id-HO-Cause', mode=MODE_VALUE)
    id_HO_Cause._val = 257
    
    #-----< id-VoiceSupportMatchIndicator >-----#
    id_VoiceSupportMatchIndicator = INT(name='id-VoiceSupportMatchIndicator', mode=MODE_VALUE)
    id_VoiceSupportMatchIndicator._val = 258
    
    #-----< id-RSRVCC-HO-Indication >-----#
    id_RSRVCC_HO_Indication = INT(name='id-RSRVCC-HO-Indication', mode=MODE_VALUE)
    id_RSRVCC_HO_Indication._val = 259
    
    #-----< id-RSRVCC-Information >-----#
    id_RSRVCC_Information = INT(name='id-RSRVCC-Information', mode=MODE_VALUE)
    id_RSRVCC_Information._val = 260
    
    #-----< id-AnchorPLMN-ID >-----#
    id_AnchorPLMN_ID = INT(name='id-AnchorPLMN-ID', mode=MODE_VALUE)
    id_AnchorPLMN_ID._val = 261
    
    #-----< id-Tunnel-Information-for-BBF >-----#
    id_Tunnel_Information_for_BBF = INT(name='id-Tunnel-Information-for-BBF', mode=MODE_VALUE)
    id_Tunnel_Information_for_BBF._val = 262
    
    #-----< id-Management-Based-MDT-PLMN-List >-----#
    id_Management_Based_MDT_PLMN_List = INT(name='id-Management-Based-MDT-PLMN-List', mode=MODE_VALUE)
    id_Management_Based_MDT_PLMN_List._val = 263
    
    #-----< id-SignallingBasedMDTPLMNList >-----#
    id_SignallingBasedMDTPLMNList = INT(name='id-SignallingBasedMDTPLMNList', mode=MODE_VALUE)
    id_SignallingBasedMDTPLMNList._val = 264
    
    #-----< id-M4Report >-----#
    id_M4Report = INT(name='id-M4Report', mode=MODE_VALUE)
    id_M4Report._val = 265
    
    #-----< id-M5Report >-----#
    id_M5Report = INT(name='id-M5Report', mode=MODE_VALUE)
    id_M5Report._val = 266
    
    #-----< id-M6Report >-----#
    id_M6Report = INT(name='id-M6Report', mode=MODE_VALUE)
    id_M6Report._val = 267
    
    #-----< id-M7Report >-----#
    id_M7Report = INT(name='id-M7Report', mode=MODE_VALUE)
    id_M7Report._val = 268
    
    #-----< id-TimingDifferenceULDL >-----#
    id_TimingDifferenceULDL = INT(name='id-TimingDifferenceULDL', mode=MODE_VALUE)
    id_TimingDifferenceULDL._val = 269
    
    #-----< id-Serving-Cell-Identifier >-----#
    id_Serving_Cell_Identifier = INT(name='id-Serving-Cell-Identifier', mode=MODE_VALUE)
    id_Serving_Cell_Identifier._val = 270
    
    #-----< id-EARFCN-Extended >-----#
    id_EARFCN_Extended = INT(name='id-EARFCN-Extended', mode=MODE_VALUE)
    id_EARFCN_Extended._val = 271
    
    #-----< id-RSRVCC-Operation-Possible >-----#
    id_RSRVCC_Operation_Possible = INT(name='id-RSRVCC-Operation-Possible', mode=MODE_VALUE)
    id_RSRVCC_Operation_Possible._val = 272
    
    #-----< id-SIPTO-LGW-TransportLayerAddress >-----#
    id_SIPTO_LGW_TransportLayerAddress = INT(name='id-SIPTO-LGW-TransportLayerAddress', mode=MODE_VALUE)
    id_SIPTO_LGW_TransportLayerAddress._val = 273
    
    #-----< id-SIPTO-Correlation-ID >-----#
    id_SIPTO_Correlation_ID = INT(name='id-SIPTO-Correlation-ID', mode=MODE_VALUE)
    id_SIPTO_Correlation_ID._val = 274
    
    #-----< id-LHN-ID >-----#
    id_LHN_ID = INT(name='id-LHN-ID', mode=MODE_VALUE)
    id_LHN_ID._val = 275
    
    #-----< id-Session-Re-establishment-Indicator >-----#
    id_Session_Re_establishment_Indicator = INT(name='id-Session-Re-establishment-Indicator', mode=MODE_VALUE)
    id_Session_Re_establishment_Indicator._val = 276
    
    #-----< id-LastE-UTRANPLMNIdentity >-----#
    id_LastE_UTRANPLMNIdentity = INT(name='id-LastE-UTRANPLMNIdentity', mode=MODE_VALUE)
    id_LastE_UTRANPLMNIdentity._val = 277
    
    #-----< id-RSRQ-Type >-----#
    id_RSRQ_Type = INT(name='id-RSRQ-Type', mode=MODE_VALUE)
    id_RSRQ_Type._val = 278
    
    #-----< id-RSRQ-Extension >-----#
    id_RSRQ_Extension = INT(name='id-RSRQ-Extension', mode=MODE_VALUE)
    id_RSRQ_Extension._val = 279
    
    #-----< id-Additional-CSPS-coordination-information >-----#
    id_Additional_CSPS_coordination_information = INT(name='id-Additional-CSPS-coordination-information', mode=MODE_VALUE)
    id_Additional_CSPS_coordination_information._val = 280
    
    #-----< id-UERegistrationQueryResult >-----#
    id_UERegistrationQueryResult = INT(name='id-UERegistrationQueryResult', mode=MODE_VALUE)
    id_UERegistrationQueryResult._val = 281
    
    #-----< id-IuSigConIdRangeEnd >-----#
    id_IuSigConIdRangeEnd = INT(name='id-IuSigConIdRangeEnd', mode=MODE_VALUE)
    id_IuSigConIdRangeEnd._val = 282
    
    #-----< id-BarometricPressure >-----#
    id_BarometricPressure = INT(name='id-BarometricPressure', mode=MODE_VALUE)
    id_BarometricPressure._val = 283
    
    #-----< id-Additional-PositioningDataSet >-----#
    id_Additional_PositioningDataSet = INT(name='id-Additional-PositioningDataSet', mode=MODE_VALUE)
    id_Additional_PositioningDataSet._val = 284
    
    #-----< id-CivicAddress >-----#
    id_CivicAddress = INT(name='id-CivicAddress', mode=MODE_VALUE)
    id_CivicAddress._val = 285
    
    #-----< id-SGSN-Group-Identity >-----#
    id_SGSN_Group_Identity = INT(name='id-SGSN-Group-Identity', mode=MODE_VALUE)
    id_SGSN_Group_Identity._val = 286
    
    #-----< id-P-TMSI >-----#
    id_P_TMSI = INT(name='id-P-TMSI', mode=MODE_VALUE)
    id_P_TMSI._val = 287
    
    #-----< id-RANAP-Message >-----#
    id_RANAP_Message = INT(name='id-RANAP-Message', mode=MODE_VALUE)
    id_RANAP_Message._val = 288
    
    #-----< id-PowerSavingIndicator >-----#
    id_PowerSavingIndicator = INT(name='id-PowerSavingIndicator', mode=MODE_VALUE)
    id_PowerSavingIndicator._val = 289
    
    #-----< id-UE-Usage-Type >-----#
    id_UE_Usage_Type = INT(name='id-UE-Usage-Type', mode=MODE_VALUE)
    id_UE_Usage_Type._val = 290
    
    #-----< id-DCN-ID >-----#
    id_DCN_ID = INT(name='id-DCN-ID', mode=MODE_VALUE)
    id_DCN_ID._val = 291
    
    #-----< id-UE-Application-Layer-Measurement-Configuration >-----#
    id_UE_Application_Layer_Measurement_Configuration = INT(name='id-UE-Application-Layer-Measurement-Configuration', mode=MODE_VALUE)
    id_UE_Application_Layer_Measurement_Configuration._val = 292
    
    #-----< id-UE-Application-Layer-Measurement-Configuration-For-Relocation >-----#
    id_UE_Application_Layer_Measurement_Configuration_For_Relocation = INT(name='id-UE-Application-Layer-Measurement-Configuration-For-Relocation', mode=MODE_VALUE)
    id_UE_Application_Layer_Measurement_Configuration_For_Relocation._val = 293
    
    #-----< id-UE-Application-Layer-Measurement-Capability >-----#
    id_UE_Application_Layer_Measurement_Capability = INT(name='id-UE-Application-Layer-Measurement-Capability', mode=MODE_VALUE)
    id_UE_Application_Layer_Measurement_Capability._val = 294
    
    #-----< id-UeApplicationLayerMeasurementSupportIndication >-----#
    id_UeApplicationLayerMeasurementSupportIndication = INT(name='id-UeApplicationLayerMeasurementSupportIndication', mode=MODE_VALUE)
    id_UeApplicationLayerMeasurementSupportIndication._val = 295
    
    #-----< id-SRVCCSource >-----#
    id_SRVCCSource = INT(name='id-SRVCCSource', mode=MODE_VALUE)
    id_SRVCCSource._val = 296
    
    _all_ = [
        id_RAB_Assignment,
        id_Iu_Release,
        id_RelocationPreparation,
        id_RelocationResourceAllocation,
        id_RelocationCancel,
        id_SRNS_ContextTransfer,
        id_SecurityModeControl,
        id_DataVolumeReport,
        id_Reset,
        id_RAB_ReleaseRequest,
        id_Iu_ReleaseRequest,
        id_RelocationDetect,
        id_RelocationComplete,
        id_Paging,
        id_CommonID,
        id_CN_InvokeTrace,
        id_LocationReportingControl,
        id_LocationReport,
        id_InitialUE_Message,
        id_DirectTransfer,
        id_OverloadControl,
        id_ErrorIndication,
        id_SRNS_DataForward,
        id_ForwardSRNS_Context,
        id_privateMessage,
        id_CN_DeactivateTrace,
        id_ResetResource,
        id_RANAP_Relocation,
        id_RAB_ModifyRequest,
        id_LocationRelatedData,
        id_InformationTransfer,
        id_UESpecificInformation,
        id_UplinkInformationExchange,
        id_DirectInformationTransfer,
        id_MBMSSessionStart,
        id_MBMSSessionUpdate,
        id_MBMSSessionStop,
        id_MBMSUELinking,
        id_MBMSRegistration,
        id_MBMSCNDe_Registration_Procedure,
        id_MBMSRABEstablishmentIndication,
        id_MBMSRABRelease,
        id_enhancedRelocationComplete,
        id_enhancedRelocationCompleteConfirm,
        id_RANAPenhancedRelocation,
        id_SRVCCPreparation,
        id_UeRadioCapabilityMatch,
        id_UeRegistrationQuery,
        id_RerouteNASRequest,
        maxPrivateIEs,
        maxProtocolExtensions,
        maxProtocolIEs,
        maxNrOfDTs,
        maxNrOfErrors,
        maxNrOfIuSigConIds,
        maxNrOfPDPDirections,
        maxNrOfPoints,
        maxNrOfRABs,
        maxNrOfSeparateTrafficDirections,
        maxNrOfSRBs,
        maxNrOfVol,
        maxNrOfLevels,
        maxNrOfAltValues,
        maxNrOfPLMNsSN,
        maxNrOfLAs,
        maxNrOfSNAs,
        maxNrOfUEsToBeTraced,
        maxNrOfInterfaces,
        maxRAB_Subflows,
        maxRAB_SubflowCombination,
        maxSet,
        maxNrOfHSDSCHMACdFlows_1,
        maxnoofMulticastServicesPerUE,
        maxnoofMulticastServicesPerRNC,
        maxMBMSSA,
        maxMBMSRA,
        maxNrOfEDCHMACdFlows_1,
        maxGANSSSet,
        maxNrOfCSGs,
        maxNrOfEUTRAFreqs,
        maxNrOfCellIds,
        maxNrOfRAIs,
        maxNrOfLAIs,
        maxSizeOfIMSInfo,
        maxnoofMDTPLMNs,
        maxAddPosSet,
        maxnoofPLMNs,
        id_AreaIdentity,
        id_CN_DomainIndicator,
        id_Cause,
        id_ChosenEncryptionAlgorithm,
        id_ChosenIntegrityProtectionAlgorithm,
        id_ClassmarkInformation2,
        id_ClassmarkInformation3,
        id_CriticalityDiagnostics,
        id_DL_GTP_PDU_SequenceNumber,
        id_EncryptionInformation,
        id_IntegrityProtectionInformation,
        id_IuTransportAssociation,
        id_L3_Information,
        id_LAI,
        id_NAS_PDU,
        id_NonSearchingIndication,
        id_NumberOfSteps,
        id_OMC_ID,
        id_OldBSS_ToNewBSS_Information,
        id_PagingAreaID,
        id_PagingCause,
        id_PermanentNAS_UE_ID,
        id_RAB_ContextItem,
        id_RAB_ContextList,
        id_RAB_DataForwardingItem,
        id_RAB_DataForwardingItem_SRNS_CtxReq,
        id_RAB_DataForwardingList,
        id_RAB_DataForwardingList_SRNS_CtxReq,
        id_RAB_DataVolumeReportItem,
        id_RAB_DataVolumeReportList,
        id_RAB_DataVolumeReportRequestItem,
        id_RAB_DataVolumeReportRequestList,
        id_RAB_FailedItem,
        id_RAB_FailedList,
        id_RAB_ID,
        id_RAB_QueuedItem,
        id_RAB_QueuedList,
        id_RAB_ReleaseFailedList,
        id_RAB_ReleaseItem,
        id_RAB_ReleaseList,
        id_RAB_ReleasedItem,
        id_RAB_ReleasedList,
        id_RAB_ReleasedList_IuRelComp,
        id_RAB_RelocationReleaseItem,
        id_RAB_RelocationReleaseList,
        id_RAB_SetupItem_RelocReq,
        id_RAB_SetupItem_RelocReqAck,
        id_RAB_SetupList_RelocReq,
        id_RAB_SetupList_RelocReqAck,
        id_RAB_SetupOrModifiedItem,
        id_RAB_SetupOrModifiedList,
        id_RAB_SetupOrModifyItem,
        id_RAB_SetupOrModifyList,
        id_RAC,
        id_RelocationType,
        id_RequestType,
        id_SAI,
        id_SAPI,
        id_SourceID,
        id_Source_ToTarget_TransparentContainer,
        id_TargetID,
        id_Target_ToSource_TransparentContainer,
        id_TemporaryUE_ID,
        id_TraceReference,
        id_TraceType,
        id_TransportLayerAddress,
        id_TriggerID,
        id_UE_ID,
        id_UL_GTP_PDU_SequenceNumber,
        id_RAB_FailedtoReportItem,
        id_RAB_FailedtoReportList,
        id_KeyStatus,
        id_DRX_CycleLengthCoefficient,
        id_IuSigConIdList,
        id_IuSigConIdItem,
        id_IuSigConId,
        id_DirectTransferInformationItem_RANAP_RelocInf,
        id_DirectTransferInformationList_RANAP_RelocInf,
        id_RAB_ContextItem_RANAP_RelocInf,
        id_RAB_ContextList_RANAP_RelocInf,
        id_RAB_ContextFailedtoTransferItem,
        id_RAB_ContextFailedtoTransferList,
        id_GlobalRNC_ID,
        id_RAB_ReleasedItem_IuRelComp,
        id_MessageStructure,
        id_Alt_RAB_Parameters,
        id_Ass_RAB_Parameters,
        id_RAB_ModifyList,
        id_RAB_ModifyItem,
        id_TypeOfError,
        id_BroadcastAssistanceDataDecipheringKeys,
        id_LocationRelatedDataRequestType,
        id_GlobalCN_ID,
        id_LastKnownServiceArea,
        id_SRB_TrCH_Mapping,
        id_InterSystemInformation_TransparentContainer,
        id_NewBSS_To_OldBSS_Information,
        id_SourceRNC_PDCP_context_info,
        id_InformationTransferID,
        id_SNA_Access_Information,
        id_ProvidedData,
        id_GERAN_BSC_Container,
        id_GERAN_Classmark,
        id_GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item,
        id_GERAN_Iumode_RAB_FailedList_RABAssgntResponse,
        id_VerticalAccuracyCode,
        id_ResponseTime,
        id_PositioningPriority,
        id_ClientType,
        id_LocationRelatedDataRequestTypeSpecificToGERANIuMode,
        id_SignallingIndication,
        id_hS_DSCH_MAC_d_Flow_ID,
        id_UESBI_Iu,
        id_PositionData,
        id_PositionDataSpecificToGERANIuMode,
        id_CellLoadInformationGroup,
        id_AccuracyFulfilmentIndicator,
        id_InformationTransferType,
        id_TraceRecordingSessionInformation,
        id_TracePropagationParameters,
        id_InterSystemInformationTransferType,
        id_SelectedPLMN_ID,
        id_RedirectionCompleted,
        id_RedirectionIndication,
        id_NAS_SequenceNumber,
        id_RejectCauseValue,
        id_APN,
        id_CNMBMSLinkingInformation,
        id_DeltaRAListofIdleModeUEs,
        id_FrequenceLayerConvergenceFlag,
        id_InformationExchangeID,
        id_InformationExchangeType,
        id_InformationRequested,
        id_InformationRequestType,
        id_IPMulticastAddress,
        id_JoinedMBMSBearerServicesList,
        id_LeftMBMSBearerServicesList,
        id_MBMSBearerServiceType,
        id_MBMSCNDe_Registration,
        id_MBMSServiceArea,
        id_MBMSSessionDuration,
        id_MBMSSessionIdentity,
        id_PDP_TypeInformation,
        id_RAB_Parameters,
        id_RAListofIdleModeUEs,
        id_MBMSRegistrationRequestType,
        id_SessionUpdateID,
        id_TMGI,
        id_TransportLayerInformation,
        id_UnsuccessfulLinkingList,
        id_MBMSLinkingInformation,
        id_MBMSSessionRepetitionNumber,
        id_AlternativeRABConfiguration,
        id_AlternativeRABConfigurationRequest,
        id_E_DCH_MAC_d_Flow_ID,
        id_SourceBSS_ToTargetBSS_TransparentContainer,
        id_TargetBSS_ToSourceBSS_TransparentContainer,
        id_TimeToMBMSDataTransfer,
        id_IncludeVelocity,
        id_VelocityEstimate,
        id_RedirectAttemptFlag,
        id_RAT_Type,
        id_PeriodicLocationInfo,
        id_MBMSCountingInformation,
        id_170_not_to_be_used_for_IE_ids,
        id_ExtendedRNC_ID,
        id_Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf,
        id_Alt_RAB_Parameter_ExtendedMaxBitrateInf,
        id_Ass_RAB_Parameter_ExtendedGuaranteedBitrateList,
        id_Ass_RAB_Parameter_ExtendedMaxBitrateList,
        id_RAB_Parameter_ExtendedGuaranteedBitrateList,
        id_RAB_Parameter_ExtendedMaxBitrateList,
        id_Requested_RAB_Parameter_ExtendedMaxBitrateList,
        id_Requested_RAB_Parameter_ExtendedGuaranteedBitrateList,
        id_LAofIdleModeUEs,
        id_newLAListofIdleModeUEs,
        id_LAListwithNoIdleModeUEsAnyMore,
        id_183_not_to_be_used_for_IE_ids,
        id_GANSS_PositioningDataSet,
        id_RequestedGANSSAssistanceData,
        id_BroadcastGANSSAssistanceDataDecipheringKeys,
        id_d_RNTI_for_NoIuCSUP,
        id_RAB_SetupList_EnhancedRelocCompleteReq,
        id_RAB_SetupItem_EnhancedRelocCompleteReq,
        id_RAB_SetupList_EnhancedRelocCompleteRes,
        id_RAB_SetupItem_EnhancedRelocCompleteRes,
        id_RAB_SetupList_EnhRelocInfoReq,
        id_RAB_SetupItem_EnhRelocInfoReq,
        id_RAB_SetupList_EnhRelocInfoRes,
        id_RAB_SetupItem_EnhRelocInfoRes,
        id_OldIuSigConId,
        id_RAB_FailedList_EnhRelocInfoRes,
        id_RAB_FailedItem_EnhRelocInfoRes,
        id_Global_ENB_ID,
        id_UE_History_Information,
        id_MBMSSynchronisationInformation,
        id_SubscriberProfileIDforRFP,
        id_CSG_Id,
        id_OldIuSigConIdCS,
        id_OldIuSigConIdPS,
        id_GlobalCN_IDCS,
        id_GlobalCN_IDPS,
        id_SourceExtendedRNC_ID,
        id_RAB_ToBeReleasedItem_EnhancedRelocCompleteRes,
        id_RAB_ToBeReleasedList_EnhancedRelocCompleteRes,
        id_SourceRNC_ID,
        id_Relocation_TargetRNC_ID,
        id_Relocation_TargetExtendedRNC_ID,
        id_Alt_RAB_Parameter_SupportedGuaranteedBitrateInf,
        id_Alt_RAB_Parameter_SupportedMaxBitrateInf,
        id_Ass_RAB_Parameter_SupportedGuaranteedBitrateList,
        id_Ass_RAB_Parameter_SupportedMaxBitrateList,
        id_RAB_Parameter_SupportedGuaranteedBitrateList,
        id_RAB_Parameter_SupportedMaxBitrateList,
        id_Requested_RAB_Parameter_SupportedMaxBitrateList,
        id_Requested_RAB_Parameter_SupportedGuaranteedBitrateList,
        id_Relocation_SourceRNC_ID,
        id_Relocation_SourceExtendedRNC_ID,
        id_EncryptionKey,
        id_IntegrityProtectionKey,
        id_SRVCC_HO_Indication,
        id_SRVCC_Information,
        id_SRVCC_Operation_Possible,
        id_CSG_Id_List,
        id_PSRABtobeReplaced,
        id_E_UTRAN_Service_Handover,
        id_UE_AggregateMaximumBitRate,
        id_CSG_Membership_Status,
        id_Cell_Access_Mode,
        id_IP_Source_Address,
        id_CSFB_Information,
        id_PDP_TypeInformation_extension,
        id_MSISDN,
        id_Offload_RAB_Parameters,
        id_LGW_TransportLayerAddress,
        id_Correlation_ID,
        id_IRAT_Measurement_Configuration,
        id_MDT_Configuration,
        id_Priority_Class_Indicator,
        id_RNSAPRelocationParameters,
        id_RABParametersList,
        id_Management_Based_MDT_Allowed,
        id_HigherBitratesThan16MbpsFlag,
        id_Trace_Collection_Entity_IP_Addess,
        id_End_Of_CSFB,
        id_Time_UE_StayedInCell_EnhancedGranularity,
        id_Out_Of_UTRAN,
        id_TraceRecordingSessionReference,
        id_IMSI,
        id_HO_Cause,
        id_VoiceSupportMatchIndicator,
        id_RSRVCC_HO_Indication,
        id_RSRVCC_Information,
        id_AnchorPLMN_ID,
        id_Tunnel_Information_for_BBF,
        id_Management_Based_MDT_PLMN_List,
        id_SignallingBasedMDTPLMNList,
        id_M4Report,
        id_M5Report,
        id_M6Report,
        id_M7Report,
        id_TimingDifferenceULDL,
        id_Serving_Cell_Identifier,
        id_EARFCN_Extended,
        id_RSRVCC_Operation_Possible,
        id_SIPTO_LGW_TransportLayerAddress,
        id_SIPTO_Correlation_ID,
        id_LHN_ID,
        id_Session_Re_establishment_Indicator,
        id_LastE_UTRANPLMNIdentity,
        id_RSRQ_Type,
        id_RSRQ_Extension,
        id_Additional_CSPS_coordination_information,
        id_UERegistrationQueryResult,
        id_IuSigConIdRangeEnd,
        id_BarometricPressure,
        id_Additional_PositioningDataSet,
        id_CivicAddress,
        id_SGSN_Group_Identity,
        id_P_TMSI,
        id_RANAP_Message,
        id_PowerSavingIndicator,
        id_UE_Usage_Type,
        id_DCN_ID,
        id_UE_Application_Layer_Measurement_Configuration,
        id_UE_Application_Layer_Measurement_Configuration_For_Relocation,
        id_UE_Application_Layer_Measurement_Capability,
        id_UeApplicationLayerMeasurementSupportIndication,
        id_SRVCCSource,
    ]

class RANAP_Containers:

    _name_  = 'RANAP-Containers'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 5]
    
    _obj_ = [
        'RANAP-PROTOCOL-IES',
        'RANAP-PROTOCOL-IES-PAIR',
        'RANAP-PROTOCOL-EXTENSION',
        'RANAP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _type_ = [
        'RANAP-PROTOCOL-IES',
        'RANAP-PROTOCOL-IES-PAIR',
        'RANAP-PROTOCOL-EXTENSION',
        'RANAP-PRIVATE-IES',
        'ProtocolIE-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'RANAP-PROTOCOL-IES',
        'RANAP-PROTOCOL-IES-PAIR',
        'RANAP-PROTOCOL-EXTENSION',
        'RANAP-PRIVATE-IES',
        ]
    _param_ = [
        'ProtocolIE-Container',
        'ProtocolIE-Field',
        'ProtocolIE-ContainerPair',
        'ProtocolIE-FieldPair',
        'ProtocolIE-ContainerList',
        'ProtocolIE-ContainerPairList',
        'ProtocolExtensionContainer',
        'ProtocolExtensionField',
        'PrivateIE-Container',
        'PrivateIE-Field',
        ]
    
    #-----< RANAP-PROTOCOL-IES >-----#
    RANAP_PROTOCOL_IES = CLASS(name='RANAP-PROTOCOL-IES', mode=MODE_TYPE)
    _RANAP_PROTOCOL_IES_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RANAP_PROTOCOL_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    _RANAP_PROTOCOL_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _RANAP_PROTOCOL_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Presence')))
    RANAP_PROTOCOL_IES._cont = ASN1Dict([
        ('id', _RANAP_PROTOCOL_IES_id),
        ('criticality', _RANAP_PROTOCOL_IES_criticality),
        ('Value', _RANAP_PROTOCOL_IES_Value),
        ('presence', _RANAP_PROTOCOL_IES_presence),
        ])
    
    #-----< RANAP-PROTOCOL-IES-PAIR >-----#
    RANAP_PROTOCOL_IES_PAIR = CLASS(name='RANAP-PROTOCOL-IES-PAIR', mode=MODE_TYPE)
    _RANAP_PROTOCOL_IES_PAIR_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProtocolIE-ID')), uniq=True)
    _RANAP_PROTOCOL_IES_PAIR_firstCriticality = ENUM(name='firstCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    _RANAP_PROTOCOL_IES_PAIR_FirstValue = OPEN(name='FirstValue', mode=MODE_TYPE)
    _RANAP_PROTOCOL_IES_PAIR_secondCriticality = ENUM(name='secondCriticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    _RANAP_PROTOCOL_IES_PAIR_SecondValue = OPEN(name='SecondValue', mode=MODE_TYPE)
    _RANAP_PROTOCOL_IES_PAIR_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Presence')))
    RANAP_PROTOCOL_IES_PAIR._cont = ASN1Dict([
        ('id', _RANAP_PROTOCOL_IES_PAIR_id),
        ('firstCriticality', _RANAP_PROTOCOL_IES_PAIR_firstCriticality),
        ('FirstValue', _RANAP_PROTOCOL_IES_PAIR_FirstValue),
        ('secondCriticality', _RANAP_PROTOCOL_IES_PAIR_secondCriticality),
        ('SecondValue', _RANAP_PROTOCOL_IES_PAIR_SecondValue),
        ('presence', _RANAP_PROTOCOL_IES_PAIR_presence),
        ])
    
    #-----< RANAP-PROTOCOL-EXTENSION >-----#
    RANAP_PROTOCOL_EXTENSION = CLASS(name='RANAP-PROTOCOL-EXTENSION', mode=MODE_TYPE)
    _RANAP_PROTOCOL_EXTENSION_id = INT(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProtocolExtensionID')), uniq=True)
    _RANAP_PROTOCOL_EXTENSION_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    _RANAP_PROTOCOL_EXTENSION_Extension = OPEN(name='Extension', mode=MODE_TYPE)
    _RANAP_PROTOCOL_EXTENSION_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Presence')))
    RANAP_PROTOCOL_EXTENSION._cont = ASN1Dict([
        ('id', _RANAP_PROTOCOL_EXTENSION_id),
        ('criticality', _RANAP_PROTOCOL_EXTENSION_criticality),
        ('Extension', _RANAP_PROTOCOL_EXTENSION_Extension),
        ('presence', _RANAP_PROTOCOL_EXTENSION_presence),
        ])
    
    #-----< RANAP-PRIVATE-IES >-----#
    RANAP_PRIVATE_IES = CLASS(name='RANAP-PRIVATE-IES', mode=MODE_TYPE)
    _RANAP_PRIVATE_IES_id = CHOICE(name='id', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'PrivateIE-ID')))
    _RANAP_PRIVATE_IES_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    _RANAP_PRIVATE_IES_Value = OPEN(name='Value', mode=MODE_TYPE)
    _RANAP_PRIVATE_IES_presence = ENUM(name='presence', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Presence')))
    RANAP_PRIVATE_IES._cont = ASN1Dict([
        ('id', _RANAP_PRIVATE_IES_id),
        ('criticality', _RANAP_PRIVATE_IES_criticality),
        ('Value', _RANAP_PRIVATE_IES_Value),
        ('presence', _RANAP_PRIVATE_IES_presence),
        ])
    
    #-----< ProtocolIE-Container >-----#
    ProtocolIE_Container = SEQ_OF(name='ProtocolIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-Field >-----#
    ProtocolIE_Field = SEQ(name='ProtocolIE-Field', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPair >-----#
    ProtocolIE_ContainerPair = SEQ_OF(name='ProtocolIE-ContainerPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-FieldPair >-----#
    ProtocolIE_FieldPair = SEQ(name='ProtocolIE-FieldPair', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerList >-----#
    ProtocolIE_ContainerList = SEQ_OF(name='ProtocolIE-ContainerList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolIE-ContainerPairList >-----#
    ProtocolIE_ContainerPairList = SEQ_OF(name='ProtocolIE-ContainerPairList', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionContainer >-----#
    ProtocolExtensionContainer = SEQ_OF(name='ProtocolExtensionContainer', mode=MODE_TYPE, param=True)
    
    #-----< ProtocolExtensionField >-----#
    ProtocolExtensionField = SEQ(name='ProtocolExtensionField', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Container >-----#
    PrivateIE_Container = SEQ_OF(name='PrivateIE-Container', mode=MODE_TYPE, param=True)
    
    #-----< PrivateIE-Field >-----#
    PrivateIE_Field = SEQ(name='PrivateIE-Field', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _RANAP_PROTOCOL_IES_id,
        _RANAP_PROTOCOL_IES_criticality,
        _RANAP_PROTOCOL_IES_Value,
        _RANAP_PROTOCOL_IES_presence,
        RANAP_PROTOCOL_IES,
        _RANAP_PROTOCOL_IES_PAIR_id,
        _RANAP_PROTOCOL_IES_PAIR_firstCriticality,
        _RANAP_PROTOCOL_IES_PAIR_FirstValue,
        _RANAP_PROTOCOL_IES_PAIR_secondCriticality,
        _RANAP_PROTOCOL_IES_PAIR_SecondValue,
        _RANAP_PROTOCOL_IES_PAIR_presence,
        RANAP_PROTOCOL_IES_PAIR,
        _RANAP_PROTOCOL_EXTENSION_id,
        _RANAP_PROTOCOL_EXTENSION_criticality,
        _RANAP_PROTOCOL_EXTENSION_Extension,
        _RANAP_PROTOCOL_EXTENSION_presence,
        RANAP_PROTOCOL_EXTENSION,
        _RANAP_PRIVATE_IES_id,
        _RANAP_PRIVATE_IES_criticality,
        _RANAP_PRIVATE_IES_Value,
        _RANAP_PRIVATE_IES_presence,
        RANAP_PRIVATE_IES,
    ]

class RANAP_IEs:

    _name_  = 'RANAP-IEs'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 2]
    
    _obj_ = [
        'AccuracyFulfilmentIndicator',
        'Additional-CSPS-coordination-information',
        'Additional-CSPS-coordination-information-ExtIEs',
        'Additional-PositioningDataSet',
        'Additional-PositioningMethodAndUsage',
        'AllocationOrRetentionPriority',
        'AllocationOrRetentionPriority-ExtIEs',
        'Alt-RAB-Parameters',
        'Alt-RAB-Parameters-ExtIEs',
        'Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf',
        'Alt-RAB-Parameter-ExtendedGuaranteedBitrates',
        'Alt-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'Alt-RAB-Parameter-GuaranteedBitrateInf',
        'Alt-RAB-Parameter-GuaranteedBitrateType',
        'Alt-RAB-Parameter-GuaranteedBitrates',
        'Alt-RAB-Parameter-GuaranteedBitrateList',
        'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf',
        'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf-ExtIEs',
        'Alt-RAB-Parameter-SupportedGuaranteedBitrates',
        'Alt-RAB-Parameter-ExtendedMaxBitrateInf',
        'Alt-RAB-Parameter-ExtendedMaxBitrates',
        'Alt-RAB-Parameter-ExtendedMaxBitrateList',
        'Alt-RAB-Parameter-MaxBitrateInf',
        'Alt-RAB-Parameter-MaxBitrateType',
        'Alt-RAB-Parameter-MaxBitrates',
        'Alt-RAB-Parameter-MaxBitrateList',
        'Alt-RAB-Parameter-SupportedMaxBitrateInf',
        'Alt-RAB-Parameter-SupportedMaxBitrateInf-ExtIEs',
        'Alt-RAB-Parameter-SupportedMaxBitrates',
        'AlternativeRABConfigurationRequest',
        'UE-Application-Layer-Measurement-Configuration',
        'UE-Application-Layer-Measurement-Configuration-For-Relocation',
        'ServiceType',
        'APN',
        'AreaScopeForUEApplicationLayerMeasurementConfiguration',
        'AreaIdentity',
        'Ass-RAB-Parameters',
        'Ass-RAB-Parameters-ExtIEs',
        'Ass-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'Ass-RAB-Parameter-ExtendedMaxBitrateList',
        'Ass-RAB-Parameter-GuaranteedBitrateList',
        'Ass-RAB-Parameter-MaxBitrateList',
        'AuthorisedPLMNs',
        'AuthorisedPLMNs-ExtIEs',
        'AuthorisedSNAs',
        'BarometricPressure',
        'BindingID',
        'BroadcastAssistanceDataDecipheringKeys',
        'Cause',
        'CauseMisc',
        'CauseNAS',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseRadioNetworkExtension',
        'CauseNon-Standard',
        'CauseTransmissionNetwork',
        'Cell-Access-Mode',
        'CellBased',
        'CellBased-ExtIEs',
        'CellIdList',
        'Cell-Id',
        'Cell-Capacity-Class-Value',
        'CellLoadInformation',
        'CellLoadInformation-ExtIEs',
        'CellLoadInformationGroup',
        'CellLoadInformationGroup-ExtIEs',
        'CellType',
        'CivicAddress',
        'ClientType',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'MessageStructure',
        'MessageStructure-ExtIEs',
        'CGI',
        'CGI-ExtIEs',
        'ChosenEncryptionAlgorithm',
        'ChosenIntegrityProtectionAlgorithm',
        'CI',
        'ClassmarkInformation2',
        'ClassmarkInformation3',
        'CN-DomainIndicator',
        'CN-ID',
        'Correlation-ID',
        'CSFB-Information',
        'CSG-Id',
        'CSG-Id-List',
        'CSG-Membership-Status',
        'DataPDUType',
        'DataVolumeReference',
        'DataVolumeReportingIndication',
        'DCH-ID',
        'DCN-ID',
        'DeliveryOfErroneousSDU',
        'DeliveryOrder',
        'DeltaRAListofIdleModeUEs',
        'NewRAListofIdleModeUEs',
        'RAListwithNoIdleModeUEsAnyMore',
        'DeltaRAListofIdleModeUEs-ExtIEs',
        'ForwardingIndication',
        'DL-GTP-PDU-SequenceNumber',
        'DL-N-PDU-SequenceNumber',
        'D-RNTI',
        'DRX-CycleLengthCoefficient',
        'DSCH-ID',
        'EARFCN-Extended',
        'E-DCH-MAC-d-Flow-ID',
        'ENB-ID',
        'EncryptionAlgorithm',
        'EncryptionInformation',
        'EncryptionInformation-ExtIEs',
        'EncryptionKey',
        'End-Of-CSFB',
        'EquipmentsToBeTraced',
        'E-UTRAN-Service-Handover',
        'Event',
        'Event1F-Parameters',
        'Event1I-Parameters',
        'ExtendedGuaranteedBitrate',
        'ExtendedMaxBitrate',
        'ExtendedRNC-ID',
        'FrameSequenceNumber',
        'FrequenceLayerConvergenceFlag',
        'GANSS-PositioningDataSet',
        'GANSS-PositioningMethodAndUsage',
        'GeographicalArea',
        'GeographicalCoordinates',
        'GeographicalCoordinates-ExtIEs',
        'GA-AltitudeAndDirection',
        'GA-EllipsoidArc',
        'GA-EllipsoidArc-ExtIEs',
        'GA-Point',
        'GA-Point-ExtIEs',
        'GA-PointWithAltitude',
        'GA-PointWithAltitude-ExtIEs',
        'GA-PointWithAltitudeAndUncertaintyEllipsoid',
        'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        'GA-PointWithUnCertainty',
        'GA-PointWithUnCertainty-ExtIEs',
        'GA-PointWithUnCertaintyEllipse',
        'GA-PointWithUnCertaintyEllipse-ExtIEs',
        'GA-Polygon',
        'GA-Polygon-ExtIEs',
        'GA-UncertaintyEllipse',
        'GERAN-BSC-Container',
        'GERAN-Cell-ID',
        'GERAN-Cell-ID-ExtIEs',
        'GERAN-Classmark',
        'GlobalCN-ID',
        'GlobalRNC-ID',
        'GTP-TEI',
        'GuaranteedBitrate',
        'HigherBitratesThan16MbpsFlag',
        'HS-DSCH-MAC-d-Flow-ID',
        'IMEI',
        'IMEIGroup',
        'IMEIGroup-ExtIEs',
        'IMEIList',
        'IMEISV',
        'IMEISVGroup',
        'IMEISVGroup-ExtIEs',
        'IMEISVList',
        'ImmediateMDT',
        'ImmediateMDT-ExtIEs',
        'IMSI',
        'IncludeVelocity',
        'InformationExchangeID',
        'InformationExchangeType',
        'InformationRequested',
        'InformationRequestType',
        'InformationTransferID',
        'InformationTransferType',
        'IntegrityProtectionAlgorithm',
        'IntegrityProtectionInformation',
        'IntegrityProtectionInformation-ExtIEs',
        'IntegrityProtectionKey',
        'InterSystemInformationTransferType',
        'InterSystemInformation-TransparentContainer',
        'InterSystemInformation-TransparentContainer-ExtIEs',
        'IPMulticastAddress',
        'IuSignallingConnectionIdentifier',
        'IuTransportAssociation',
        'KeyStatus',
        'LA-LIST',
        'LA-LIST-ExtIEs',
        'LAC',
        'LAI',
        'LAI-ExtIEs',
        'LastKnownServiceArea',
        'LastKnownServiceArea-ExtIEs',
        'LastVisitedUTRANCell-Item',
        'LastVisitedUTRANCell-Item-ExtIEs',
        'LHN-ID',
        'Links-to-log',
        'ListOF-SNAs',
        'ListOfInterfacesToTrace',
        'InterfacesToTraceItem',
        'InterfacesToTraceItem-ExtIEs',
        'LoadValue',
        'LocationRelatedDataRequestType',
        'LocationRelatedDataRequestTypeSpecificToGERANIuMode',
        'LocationReportingTransferInformation',
        'LocationReportingTransferInformation-ExtIEs',
        'ReportChangeOfSAI',
        'PeriodicReportingIndicator',
        'DirectReportingIndicator',
        'L3-Information',
        'M1Report',
        'M2Report',
        'M4Report',
        'M4-Collection-Parameters',
        'M4-Collection-Parameters-ExtIEs',
        'M4-Period',
        'M4-Threshold',
        'M5Report',
        'M5-Period',
        'M6Report',
        'M6Report-ExtIEs',
        'M6-Period',
        'M7Report',
        'M7Report-ExtIEs',
        'M7-Period',
        'Management-Based-MDT-Allowed',
        'MaxBitrate',
        'MaxSDU-Size',
        'MBMS-PTP-RAB-ID',
        'MBMSBearerServiceType',
        'MBMSCNDe-Registration',
        'MBMSCountingInformation',
        'MBMSHCIndicator',
        'MBMSIPMulticastAddressandAPNRequest',
        'MBMSLinkingInformation',
        'MBMSRegistrationRequestType',
        'MBMSServiceArea',
        'MBMSSessionDuration',
        'MBMSSessionIdentity',
        'MBMSSessionRepetitionNumber',
        'MDT-Activation',
        'MDTAreaScope',
        'MDT-Configuration',
        'MDT-Configuration-ExtIEs',
        'MDTMode',
        'MDT-PLMN-List',
        'MDT-Report-Parameters',
        'MeasurementQuantity',
        'MeasurementsToActivate',
        'MSISDN',
        'NAS-PDU',
        'NAS-SequenceNumber',
        'NAS-SynchronisationIndicator',
        'NewBSS-To-OldBSS-Information',
        'NonSearchingIndication',
        'NRTLoadInformationValue',
        'Null-NRI',
        'NumberOfIuInstances',
        'NumberOfSteps',
        'Offload-RAB-Parameters',
        'Offload-RAB-Parameters-ExtIEs',
        'Offload-RAB-Parameters-APN',
        'Offload-RAB-Parameters-ChargingCharacteristics',
        'OldBSS-ToNewBSS-Information',
        'OMC-ID',
        'Out-Of-UTRAN',
        'PagingAreaID',
        'PagingCause',
        'PDP-TypeInformation',
        'PDP-Type',
        'PDP-TypeInformation-extension',
        'PDP-Type-extension',
        'PDUType14FrameSequenceNumber',
        'PeriodicLocationInfo',
        'PeriodicLocationInfo-ExtIEs',
        'PermanentNAS-UE-ID',
        'PermittedEncryptionAlgorithms',
        'PermittedIntegrityProtectionAlgorithms',
        'LABased',
        'LABased-ExtIEs',
        'LAI-List',
        'LoggedMDT',
        'LoggedMDT-ExtIEs',
        'LoggingInterval',
        'LoggingDuration',
        'PLMNBased',
        'PLMNBased-ExtIEs',
        'PLMNList',
        'PLMNidentity',
        'PLMNs-in-shared-network',
        'PLMNs-in-shared-network-ExtIEs',
        'Port-Number',
        'PositioningDataDiscriminator',
        'PositioningDataSet',
        'PositioningMethodAndUsage',
        'PositioningPriority',
        'PositionData',
        'PositionData-ExtIEs',
        'PositionDataSpecificToGERANIuMode',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PriorityLevel',
        'Priority-Class-Indicator',
        'ProvidedData',
        'PowerSavingIndicator',
        'P-TMSI',
        'QueuingAllowed',
        'RAB-AsymmetryIndicator',
        'RABased',
        'RABased-ExtIEs',
        'RAI-List',
        'RABDataVolumeReport',
        'RABDataVolumeReport-ExtIEs',
        'RAB-ID',
        'RAB-Parameter-ExtendedGuaranteedBitrateList',
        'RAB-Parameter-ExtendedMaxBitrateList',
        'RAB-Parameter-GuaranteedBitrateList',
        'RAB-Parameter-MaxBitrateList',
        'RAB-Parameters',
        'RAB-Parameters-ExtIEs',
        'RABParametersList',
        'RABParametersList-ExtIEs',
        'RAB-SubflowCombinationBitRate',
        'RAB-TrCH-Mapping',
        'RAB-TrCH-MappingItem',
        'RAB-TrCH-MappingItem-ExtIEs',
        'RAC',
        'RAI',
        'RAI-ExtIEs',
        'RAListofIdleModeUEs',
        'NotEmptyRAListofIdleModeUEs',
        'RAofIdleModeUEs',
        'NotEmptyRAListofIdleModeUEs-ExtIEs',
        'LAListofIdleModeUEs',
        'RAT-Type',
        'RateControlAllowed',
        'RedirectAttemptFlag',
        'RedirectionCompleted',
        'RejectCauseValue',
        'RelocationRequirement',
        'RelocationType',
        'RepetitionNumber0',
        'RepetitionNumber1',
        'ReportArea',
        'ReportInterval',
        'ReportAmount',
        'RequestedGPSAssistanceData',
        'RequestedGANSSAssistanceData',
        'RequestedLocationRelatedDataType',
        'RequestedMBMSIPMulticastAddressandAPNRequest',
        'MBMSIPMulticastAddressandAPNlist',
        'MBMSIPMulticastAddressandAPNlist-ExtIEs',
        'RequestedMulticastServiceList',
        'Requested-RAB-Parameter-Values',
        'Requested-RAB-Parameter-Values-ExtIEs',
        'Requested-RAB-Parameter-ExtendedMaxBitrateList',
        'Requested-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'Requested-RAB-Parameter-MaxBitrateList',
        'Requested-RAB-Parameter-GuaranteedBitrateList',
        'RequestType',
        'ResidualBitErrorRatio',
        'ResidualBitErrorRatio-ExtIEs',
        'ResponseTime',
        'RIMInformation',
        'RIM-Transfer',
        'RIM-Transfer-ExtIEs',
        'RIMRoutingAddress',
        'RNC-ID',
        'RNCTraceInformation',
        'RNCTraceInformation-ExtIEs',
        'RNSAPRelocationParameters',
        'RNSAPRelocationParameters-ExtIEs',
        'RRC-Container',
        'RTLoadValue',
        'RSRVCC-HO-Indication',
        'RSRVCC-Information',
        'RSRVCC-Information-ExtIEs',
        'RSRVCC-Operation-Possible',
        'SAC',
        'SAI',
        'SAI-ExtIEs',
        'SAPI',
        'SessionUpdateID',
        'Shared-Network-Information',
        'Session-Re-establishment-Indicator',
        'Shared-Network-Information-ExtIEs',
        'SignallingIndication',
        'SDU-ErrorRatio',
        'SDU-ErrorRatio-ExtIEs',
        'SDU-FormatInformationParameters',
        'SDU-FormatInformationParameters-ExtIEs',
        'SDU-Parameters',
        'SDU-Parameters-ExtIEs',
        'SGSN-Group-Identity',
        'SGSN-Group-ID',
        'SNA-Access-Information',
        'SNA-Access-Information-ExtIEs',
        'SNAC',
        'Service-Handover',
        'Source-ToTarget-TransparentContainer',
        'SourceeNodeB-ToTargeteNodeB-TransparentContainer',
        'SourceCellID',
        'SourceBSS-ToTargetBSS-TransparentContainer',
        'SourceID',
        'SourceRNC-ID',
        'SourceRNC-ID-ExtIEs',
        'SourceRNC-ToTargetRNC-TransparentContainer',
        'SourceRNC-ToTargetRNC-TransparentContainer-ExtIEs',
        'SRVCCSource',
        'IRAT-Measurement-Configuration',
        'IRAT-Measurement-Configuration-ExtIEs',
        'IRATmeasurementParameters',
        'IRATmeasurementParameters-ExtIEs',
        'RSRQ-Type',
        'RSRQ-Extension',
        'EUTRANFrequencies',
        'MeasBand',
        'EUTRANFrequencies-ExtIEs',
        'SubscriberProfileIDforRFP',
        'SourceStatisticsDescriptor',
        'SupportedRAB-ParameterBitrateList',
        'SupportedBitrate',
        'SourceUTRANCellID',
        'SourceUTRANCellID-ExtIEs',
        'SRB-ID',
        'SRB-TrCH-Mapping',
        'SRB-TrCH-MappingItem',
        'SRB-TrCH-MappingItem-ExtIEs',
        'SRVCC-HO-Indication',
        'SRVCC-Information',
        'SRVCC-Information-ExtIEs',
        'SRVCC-Operation-Possible',
        'SubflowSDU-Size',
        'TAC',
        'TAI',
        'TAI-ExtIEs',
        'Target-ToSource-TransparentContainer',
        'TargeteNodeB-ToSourceeNodeB-TransparentContainer',
        'TargetBSS-ToSourceBSS-TransparentContainer',
        'TargetCellId',
        'TargetID',
        'TargetENB-ID',
        'TargetENB-ID-ExtIEs',
        'TargetRNC-ID',
        'TargetRNC-ID-ExtIEs',
        'TargetRNC-ToSourceRNC-TransparentContainer',
        'TargetRNC-ToSourceRNC-TransparentContainer-ExtIEs',
        'UeApplicationLayerMeasurementSupportIndication',
        'TBCD-STRING',
        'TemporaryUE-ID',
        'Time-UE-StayedInCell',
        'Time-UE-StayedInCell-EnhancedGranularity',
        'TimeToMBMSDataTransfer',
        'TimingDifferenceULDL',
        'TMGI',
        'TMGI-ExtIEs',
        'TMSI',
        'TraceDepth',
        'TraceInformation',
        'TraceInformation-ExtIEs',
        'TracePropagationParameters',
        'TracePropagationParameters-ExtIEs',
        'TraceRecordingSessionInformation',
        'TraceRecordingSessionInformation-ExtIEs',
        'TraceRecordingSessionReference',
        'TraceReference',
        'TraceType',
        'TrafficClass',
        'TrafficHandlingPriority',
        'TransferDelay',
        'UnsuccessfullyTransmittedDataVolume',
        'TransportLayerAddress',
        'TrCH-ID',
        'TrCH-ID-ExtIEs',
        'TrCH-ID-List',
        'TriggerID',
        'TunnelInformation',
        'Tunnel-Information-ExtIEs',
        'TypeOfError',
        'UE-AggregateMaximumBitRate',
        'UE-AggregateMaximumBitRateDownlink',
        'UE-AggregateMaximumBitRateUplink',
        'UE-Application-Layer-Measurement-Capability',
        'UE-History-Information',
        'UE-ID',
        'UE-IsNotServed',
        'UE-IsNotServed-ExtIEs',
        'UE-IsServed',
        'UE-IsServed-ExtIEs',
        'UE-Usage-Type',
        'UERegistrationQueryResult',
        'UESBI-Iu',
        'UESBI-Iu-ExtIEs',
        'UESBI-IuA',
        'UESBI-IuB',
        'UL-GTP-PDU-SequenceNumber',
        'UL-N-PDU-SequenceNumber',
        'UPInformation',
        'UPInformation-ExtIEs',
        'UPInitialisationFrame',
        'UP-ModeVersions',
        'USCH-ID',
        'UserPlaneMode',
        'UTRAN-CellID',
        'UTRAN-CellID-ExtIEs',
        'VelocityEstimate',
        'HorizontalVelocity',
        'HorizontalVelocity-ExtIEs',
        'HorizontalWithVerticalVelocity',
        'HorizontalWithVerticalVelocity-ExtIEs',
        'HorizontalVelocityWithUncertainty',
        'HorizontalVelocityWithUncertainty-ExtIEs',
        'HorizontalWithVerticalVelocityAndUncertainty',
        'HorizontalWithVerticalVelocityAndUncertainty-ExtIEs',
        'HorizontalSpeedAndBearing',
        'VerticalVelocity',
        'VerticalSpeedDirection',
        'VerticalAccuracyCode',
        'VoiceSupportMatchIndicator',
        ]
    _type_ = [
        'AccuracyFulfilmentIndicator',
        'Additional-CSPS-coordination-information',
        'Additional-PositioningDataSet',
        'Additional-PositioningMethodAndUsage',
        'AllocationOrRetentionPriority',
        'Alt-RAB-Parameters',
        'Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf',
        'Alt-RAB-Parameter-ExtendedGuaranteedBitrates',
        'Alt-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'Alt-RAB-Parameter-GuaranteedBitrateInf',
        'Alt-RAB-Parameter-GuaranteedBitrateType',
        'Alt-RAB-Parameter-GuaranteedBitrates',
        'Alt-RAB-Parameter-GuaranteedBitrateList',
        'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf',
        'Alt-RAB-Parameter-SupportedGuaranteedBitrates',
        'Alt-RAB-Parameter-ExtendedMaxBitrateInf',
        'Alt-RAB-Parameter-ExtendedMaxBitrates',
        'Alt-RAB-Parameter-ExtendedMaxBitrateList',
        'Alt-RAB-Parameter-MaxBitrateInf',
        'Alt-RAB-Parameter-MaxBitrateType',
        'Alt-RAB-Parameter-MaxBitrates',
        'Alt-RAB-Parameter-MaxBitrateList',
        'Alt-RAB-Parameter-SupportedMaxBitrateInf',
        'Alt-RAB-Parameter-SupportedMaxBitrates',
        'AlternativeRABConfigurationRequest',
        'UE-Application-Layer-Measurement-Configuration',
        'UE-Application-Layer-Measurement-Configuration-For-Relocation',
        'ServiceType',
        'APN',
        'AreaScopeForUEApplicationLayerMeasurementConfiguration',
        'AreaIdentity',
        'Ass-RAB-Parameters',
        'Ass-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'Ass-RAB-Parameter-ExtendedMaxBitrateList',
        'Ass-RAB-Parameter-GuaranteedBitrateList',
        'Ass-RAB-Parameter-MaxBitrateList',
        'AuthorisedPLMNs',
        'AuthorisedSNAs',
        'BarometricPressure',
        'BindingID',
        'BroadcastAssistanceDataDecipheringKeys',
        'Cause',
        'CauseMisc',
        'CauseNAS',
        'CauseProtocol',
        'CauseRadioNetwork',
        'CauseRadioNetworkExtension',
        'CauseNon-Standard',
        'CauseTransmissionNetwork',
        'Cell-Access-Mode',
        'CellBased',
        'CellIdList',
        'Cell-Id',
        'Cell-Capacity-Class-Value',
        'CellLoadInformation',
        'CellLoadInformationGroup',
        'CellType',
        'CivicAddress',
        'ClientType',
        'CriticalityDiagnostics',
        'CriticalityDiagnostics-IE-List',
        'MessageStructure',
        'CGI',
        'ChosenEncryptionAlgorithm',
        'ChosenIntegrityProtectionAlgorithm',
        'CI',
        'ClassmarkInformation2',
        'ClassmarkInformation3',
        'CN-DomainIndicator',
        'CN-ID',
        'Correlation-ID',
        'CSFB-Information',
        'CSG-Id',
        'CSG-Id-List',
        'CSG-Membership-Status',
        'DataPDUType',
        'DataVolumeReference',
        'DataVolumeReportingIndication',
        'DCH-ID',
        'DCN-ID',
        'DeliveryOfErroneousSDU',
        'DeliveryOrder',
        'DeltaRAListofIdleModeUEs',
        'NewRAListofIdleModeUEs',
        'RAListwithNoIdleModeUEsAnyMore',
        'ForwardingIndication',
        'DL-GTP-PDU-SequenceNumber',
        'DL-N-PDU-SequenceNumber',
        'D-RNTI',
        'DRX-CycleLengthCoefficient',
        'DSCH-ID',
        'EARFCN-Extended',
        'E-DCH-MAC-d-Flow-ID',
        'ENB-ID',
        'EncryptionAlgorithm',
        'EncryptionInformation',
        'EncryptionKey',
        'End-Of-CSFB',
        'EquipmentsToBeTraced',
        'E-UTRAN-Service-Handover',
        'Event',
        'Event1F-Parameters',
        'Event1I-Parameters',
        'ExtendedGuaranteedBitrate',
        'ExtendedMaxBitrate',
        'ExtendedRNC-ID',
        'FrameSequenceNumber',
        'FrequenceLayerConvergenceFlag',
        'GANSS-PositioningDataSet',
        'GANSS-PositioningMethodAndUsage',
        'GeographicalArea',
        'GeographicalCoordinates',
        'GA-AltitudeAndDirection',
        'GA-EllipsoidArc',
        'GA-Point',
        'GA-PointWithAltitude',
        'GA-PointWithAltitudeAndUncertaintyEllipsoid',
        'GA-PointWithUnCertainty',
        'GA-PointWithUnCertaintyEllipse',
        'GA-Polygon',
        'GA-UncertaintyEllipse',
        'GERAN-BSC-Container',
        'GERAN-Cell-ID',
        'GERAN-Classmark',
        'GlobalCN-ID',
        'GlobalRNC-ID',
        'GTP-TEI',
        'GuaranteedBitrate',
        'HigherBitratesThan16MbpsFlag',
        'HS-DSCH-MAC-d-Flow-ID',
        'IMEI',
        'IMEIGroup',
        'IMEIList',
        'IMEISV',
        'IMEISVGroup',
        'IMEISVList',
        'ImmediateMDT',
        'IMSI',
        'IncludeVelocity',
        'InformationExchangeID',
        'InformationExchangeType',
        'InformationRequested',
        'InformationRequestType',
        'InformationTransferID',
        'InformationTransferType',
        'IntegrityProtectionAlgorithm',
        'IntegrityProtectionInformation',
        'IntegrityProtectionKey',
        'InterSystemInformationTransferType',
        'InterSystemInformation-TransparentContainer',
        'IPMulticastAddress',
        'IuSignallingConnectionIdentifier',
        'IuTransportAssociation',
        'KeyStatus',
        'LA-LIST',
        'LAC',
        'LAI',
        'LastKnownServiceArea',
        'LastVisitedUTRANCell-Item',
        'LHN-ID',
        'Links-to-log',
        'ListOF-SNAs',
        'ListOfInterfacesToTrace',
        'InterfacesToTraceItem',
        'LoadValue',
        'LocationRelatedDataRequestType',
        'LocationRelatedDataRequestTypeSpecificToGERANIuMode',
        'LocationReportingTransferInformation',
        'ReportChangeOfSAI',
        'PeriodicReportingIndicator',
        'DirectReportingIndicator',
        'L3-Information',
        'M1Report',
        'M2Report',
        'M4Report',
        'M4-Collection-Parameters',
        'M4-Period',
        'M4-Threshold',
        'M5Report',
        'M5-Period',
        'M6Report',
        'M6-Period',
        'M7Report',
        'M7-Period',
        'Management-Based-MDT-Allowed',
        'MaxBitrate',
        'MaxSDU-Size',
        'MBMS-PTP-RAB-ID',
        'MBMSBearerServiceType',
        'MBMSCNDe-Registration',
        'MBMSCountingInformation',
        'MBMSHCIndicator',
        'MBMSIPMulticastAddressandAPNRequest',
        'MBMSLinkingInformation',
        'MBMSRegistrationRequestType',
        'MBMSServiceArea',
        'MBMSSessionDuration',
        'MBMSSessionIdentity',
        'MBMSSessionRepetitionNumber',
        'MDT-Activation',
        'MDTAreaScope',
        'MDT-Configuration',
        'MDTMode',
        'MDT-PLMN-List',
        'MDT-Report-Parameters',
        'MeasurementQuantity',
        'MeasurementsToActivate',
        'MSISDN',
        'NAS-PDU',
        'NAS-SequenceNumber',
        'NAS-SynchronisationIndicator',
        'NewBSS-To-OldBSS-Information',
        'NonSearchingIndication',
        'NRTLoadInformationValue',
        'Null-NRI',
        'NumberOfIuInstances',
        'NumberOfSteps',
        'Offload-RAB-Parameters',
        'Offload-RAB-Parameters-APN',
        'Offload-RAB-Parameters-ChargingCharacteristics',
        'OldBSS-ToNewBSS-Information',
        'OMC-ID',
        'Out-Of-UTRAN',
        'PagingAreaID',
        'PagingCause',
        'PDP-TypeInformation',
        'PDP-Type',
        'PDP-TypeInformation-extension',
        'PDP-Type-extension',
        'PDUType14FrameSequenceNumber',
        'PeriodicLocationInfo',
        'PermanentNAS-UE-ID',
        'PermittedEncryptionAlgorithms',
        'PermittedIntegrityProtectionAlgorithms',
        'LABased',
        'LAI-List',
        'LoggedMDT',
        'LoggingInterval',
        'LoggingDuration',
        'PLMNBased',
        'PLMNList',
        'PLMNidentity',
        'PLMNs-in-shared-network',
        'Port-Number',
        'PositioningDataDiscriminator',
        'PositioningDataSet',
        'PositioningMethodAndUsage',
        'PositioningPriority',
        'PositionData',
        'PositionDataSpecificToGERANIuMode',
        'Pre-emptionCapability',
        'Pre-emptionVulnerability',
        'PriorityLevel',
        'Priority-Class-Indicator',
        'ProvidedData',
        'PowerSavingIndicator',
        'P-TMSI',
        'QueuingAllowed',
        'RAB-AsymmetryIndicator',
        'RABased',
        'RAI-List',
        'RABDataVolumeReport',
        'RAB-ID',
        'RAB-Parameter-ExtendedGuaranteedBitrateList',
        'RAB-Parameter-ExtendedMaxBitrateList',
        'RAB-Parameter-GuaranteedBitrateList',
        'RAB-Parameter-MaxBitrateList',
        'RAB-Parameters',
        'RABParametersList',
        'RAB-SubflowCombinationBitRate',
        'RAB-TrCH-Mapping',
        'RAB-TrCH-MappingItem',
        'RAC',
        'RAI',
        'RAListofIdleModeUEs',
        'NotEmptyRAListofIdleModeUEs',
        'RAofIdleModeUEs',
        'LAListofIdleModeUEs',
        'RAT-Type',
        'RateControlAllowed',
        'RedirectAttemptFlag',
        'RedirectionCompleted',
        'RejectCauseValue',
        'RelocationRequirement',
        'RelocationType',
        'RepetitionNumber0',
        'RepetitionNumber1',
        'ReportArea',
        'ReportInterval',
        'ReportAmount',
        'RequestedGPSAssistanceData',
        'RequestedGANSSAssistanceData',
        'RequestedLocationRelatedDataType',
        'RequestedMBMSIPMulticastAddressandAPNRequest',
        'MBMSIPMulticastAddressandAPNlist',
        'RequestedMulticastServiceList',
        'Requested-RAB-Parameter-Values',
        'Requested-RAB-Parameter-ExtendedMaxBitrateList',
        'Requested-RAB-Parameter-ExtendedGuaranteedBitrateList',
        'Requested-RAB-Parameter-MaxBitrateList',
        'Requested-RAB-Parameter-GuaranteedBitrateList',
        'RequestType',
        'ResidualBitErrorRatio',
        'ResponseTime',
        'RIMInformation',
        'RIM-Transfer',
        'RIMRoutingAddress',
        'RNC-ID',
        'RNCTraceInformation',
        'RNSAPRelocationParameters',
        'RRC-Container',
        'RTLoadValue',
        'RSRVCC-HO-Indication',
        'RSRVCC-Information',
        'RSRVCC-Operation-Possible',
        'SAC',
        'SAI',
        'SAPI',
        'SessionUpdateID',
        'Shared-Network-Information',
        'Session-Re-establishment-Indicator',
        'SignallingIndication',
        'SDU-ErrorRatio',
        'SDU-FormatInformationParameters',
        'SDU-Parameters',
        'SGSN-Group-Identity',
        'SGSN-Group-ID',
        'SNA-Access-Information',
        'SNAC',
        'Service-Handover',
        'Source-ToTarget-TransparentContainer',
        'SourceeNodeB-ToTargeteNodeB-TransparentContainer',
        'SourceCellID',
        'SourceBSS-ToTargetBSS-TransparentContainer',
        'SourceID',
        'SourceRNC-ID',
        'SourceRNC-ToTargetRNC-TransparentContainer',
        'SRVCCSource',
        'IRAT-Measurement-Configuration',
        'IRATmeasurementParameters',
        'RSRQ-Type',
        'RSRQ-Extension',
        'EUTRANFrequencies',
        'MeasBand',
        'SubscriberProfileIDforRFP',
        'SourceStatisticsDescriptor',
        'SupportedRAB-ParameterBitrateList',
        'SupportedBitrate',
        'SourceUTRANCellID',
        'SRB-ID',
        'SRB-TrCH-Mapping',
        'SRB-TrCH-MappingItem',
        'SRVCC-HO-Indication',
        'SRVCC-Information',
        'SRVCC-Operation-Possible',
        'SubflowSDU-Size',
        'TAC',
        'TAI',
        'Target-ToSource-TransparentContainer',
        'TargeteNodeB-ToSourceeNodeB-TransparentContainer',
        'TargetBSS-ToSourceBSS-TransparentContainer',
        'TargetCellId',
        'TargetID',
        'TargetENB-ID',
        'TargetRNC-ID',
        'TargetRNC-ToSourceRNC-TransparentContainer',
        'UeApplicationLayerMeasurementSupportIndication',
        'TBCD-STRING',
        'TemporaryUE-ID',
        'Time-UE-StayedInCell',
        'Time-UE-StayedInCell-EnhancedGranularity',
        'TimeToMBMSDataTransfer',
        'TimingDifferenceULDL',
        'TMGI',
        'TMSI',
        'TraceDepth',
        'TraceInformation',
        'TracePropagationParameters',
        'TraceRecordingSessionInformation',
        'TraceRecordingSessionReference',
        'TraceReference',
        'TraceType',
        'TrafficClass',
        'TrafficHandlingPriority',
        'TransferDelay',
        'UnsuccessfullyTransmittedDataVolume',
        'TransportLayerAddress',
        'TrCH-ID',
        'TrCH-ID-List',
        'TriggerID',
        'TunnelInformation',
        'TypeOfError',
        'UE-AggregateMaximumBitRate',
        'UE-AggregateMaximumBitRateDownlink',
        'UE-AggregateMaximumBitRateUplink',
        'UE-Application-Layer-Measurement-Capability',
        'UE-History-Information',
        'UE-ID',
        'UE-IsNotServed',
        'UE-IsServed',
        'UE-Usage-Type',
        'UERegistrationQueryResult',
        'UESBI-Iu',
        'UESBI-IuA',
        'UESBI-IuB',
        'UL-GTP-PDU-SequenceNumber',
        'UL-N-PDU-SequenceNumber',
        'UPInformation',
        'UPInitialisationFrame',
        'UP-ModeVersions',
        'USCH-ID',
        'UserPlaneMode',
        'UTRAN-CellID',
        'VelocityEstimate',
        'HorizontalVelocity',
        'HorizontalWithVerticalVelocity',
        'HorizontalVelocityWithUncertainty',
        'HorizontalWithVerticalVelocityAndUncertainty',
        'HorizontalSpeedAndBearing',
        'VerticalVelocity',
        'VerticalSpeedDirection',
        'VerticalAccuracyCode',
        'VoiceSupportMatchIndicator',
        ]
    _set_ = [
        'Additional-CSPS-coordination-information-ExtIEs',
        'AllocationOrRetentionPriority-ExtIEs',
        'Alt-RAB-Parameters-ExtIEs',
        'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf-ExtIEs',
        'Alt-RAB-Parameter-SupportedMaxBitrateInf-ExtIEs',
        'Ass-RAB-Parameters-ExtIEs',
        'AuthorisedPLMNs-ExtIEs',
        'CellBased-ExtIEs',
        'CellLoadInformation-ExtIEs',
        'CellLoadInformationGroup-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'MessageStructure-ExtIEs',
        'CGI-ExtIEs',
        'DeltaRAListofIdleModeUEs-ExtIEs',
        'EncryptionInformation-ExtIEs',
        'GeographicalCoordinates-ExtIEs',
        'GA-EllipsoidArc-ExtIEs',
        'GA-Point-ExtIEs',
        'GA-PointWithAltitude-ExtIEs',
        'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        'GA-PointWithUnCertainty-ExtIEs',
        'GA-PointWithUnCertaintyEllipse-ExtIEs',
        'GA-Polygon-ExtIEs',
        'GERAN-Cell-ID-ExtIEs',
        'IMEIGroup-ExtIEs',
        'IMEISVGroup-ExtIEs',
        'ImmediateMDT-ExtIEs',
        'IntegrityProtectionInformation-ExtIEs',
        'InterSystemInformation-TransparentContainer-ExtIEs',
        'LA-LIST-ExtIEs',
        'LAI-ExtIEs',
        'LastKnownServiceArea-ExtIEs',
        'LastVisitedUTRANCell-Item-ExtIEs',
        'InterfacesToTraceItem-ExtIEs',
        'LocationReportingTransferInformation-ExtIEs',
        'M4-Collection-Parameters-ExtIEs',
        'M6Report-ExtIEs',
        'M7Report-ExtIEs',
        'MDT-Configuration-ExtIEs',
        'Offload-RAB-Parameters-ExtIEs',
        'PeriodicLocationInfo-ExtIEs',
        'LABased-ExtIEs',
        'LoggedMDT-ExtIEs',
        'PLMNBased-ExtIEs',
        'PLMNs-in-shared-network-ExtIEs',
        'PositionData-ExtIEs',
        'RABased-ExtIEs',
        'RABDataVolumeReport-ExtIEs',
        'RAB-Parameters-ExtIEs',
        'RABParametersList-ExtIEs',
        'RAB-TrCH-MappingItem-ExtIEs',
        'RAI-ExtIEs',
        'NotEmptyRAListofIdleModeUEs-ExtIEs',
        'MBMSIPMulticastAddressandAPNlist-ExtIEs',
        'Requested-RAB-Parameter-Values-ExtIEs',
        'ResidualBitErrorRatio-ExtIEs',
        'RIM-Transfer-ExtIEs',
        'RNCTraceInformation-ExtIEs',
        'RNSAPRelocationParameters-ExtIEs',
        'RSRVCC-Information-ExtIEs',
        'SAI-ExtIEs',
        'Shared-Network-Information-ExtIEs',
        'SDU-ErrorRatio-ExtIEs',
        'SDU-FormatInformationParameters-ExtIEs',
        'SDU-Parameters-ExtIEs',
        'SNA-Access-Information-ExtIEs',
        'SourceRNC-ID-ExtIEs',
        'SourceRNC-ToTargetRNC-TransparentContainer-ExtIEs',
        'IRAT-Measurement-Configuration-ExtIEs',
        'IRATmeasurementParameters-ExtIEs',
        'EUTRANFrequencies-ExtIEs',
        'SourceUTRANCellID-ExtIEs',
        'SRB-TrCH-MappingItem-ExtIEs',
        'SRVCC-Information-ExtIEs',
        'TAI-ExtIEs',
        'TargetENB-ID-ExtIEs',
        'TargetRNC-ID-ExtIEs',
        'TargetRNC-ToSourceRNC-TransparentContainer-ExtIEs',
        'TMGI-ExtIEs',
        'TraceInformation-ExtIEs',
        'TracePropagationParameters-ExtIEs',
        'TraceRecordingSessionInformation-ExtIEs',
        'TrCH-ID-ExtIEs',
        'Tunnel-Information-ExtIEs',
        'UE-IsNotServed-ExtIEs',
        'UE-IsServed-ExtIEs',
        'UESBI-Iu-ExtIEs',
        'UPInformation-ExtIEs',
        'UTRAN-CellID-ExtIEs',
        'HorizontalVelocity-ExtIEs',
        'HorizontalWithVerticalVelocity-ExtIEs',
        'HorizontalVelocityWithUncertainty-ExtIEs',
        'HorizontalWithVerticalVelocityAndUncertainty-ExtIEs',
        ]
    _val_ = [
        ]
    _class_ = [
        'Additional-CSPS-coordination-information-ExtIEs',
        'AllocationOrRetentionPriority-ExtIEs',
        'Alt-RAB-Parameters-ExtIEs',
        'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf-ExtIEs',
        'Alt-RAB-Parameter-SupportedMaxBitrateInf-ExtIEs',
        'Ass-RAB-Parameters-ExtIEs',
        'AuthorisedPLMNs-ExtIEs',
        'CellBased-ExtIEs',
        'CellLoadInformation-ExtIEs',
        'CellLoadInformationGroup-ExtIEs',
        'CriticalityDiagnostics-ExtIEs',
        'CriticalityDiagnostics-IE-List-ExtIEs',
        'MessageStructure-ExtIEs',
        'CGI-ExtIEs',
        'DeltaRAListofIdleModeUEs-ExtIEs',
        'EncryptionInformation-ExtIEs',
        'GeographicalCoordinates-ExtIEs',
        'GA-EllipsoidArc-ExtIEs',
        'GA-Point-ExtIEs',
        'GA-PointWithAltitude-ExtIEs',
        'GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs',
        'GA-PointWithUnCertainty-ExtIEs',
        'GA-PointWithUnCertaintyEllipse-ExtIEs',
        'GA-Polygon-ExtIEs',
        'GERAN-Cell-ID-ExtIEs',
        'IMEIGroup-ExtIEs',
        'IMEISVGroup-ExtIEs',
        'ImmediateMDT-ExtIEs',
        'IntegrityProtectionInformation-ExtIEs',
        'InterSystemInformation-TransparentContainer-ExtIEs',
        'LA-LIST-ExtIEs',
        'LAI-ExtIEs',
        'LastKnownServiceArea-ExtIEs',
        'LastVisitedUTRANCell-Item-ExtIEs',
        'InterfacesToTraceItem-ExtIEs',
        'LocationReportingTransferInformation-ExtIEs',
        'M4-Collection-Parameters-ExtIEs',
        'M6Report-ExtIEs',
        'M7Report-ExtIEs',
        'MDT-Configuration-ExtIEs',
        'Offload-RAB-Parameters-ExtIEs',
        'PeriodicLocationInfo-ExtIEs',
        'LABased-ExtIEs',
        'LoggedMDT-ExtIEs',
        'PLMNBased-ExtIEs',
        'PLMNs-in-shared-network-ExtIEs',
        'PositionData-ExtIEs',
        'RABased-ExtIEs',
        'RABDataVolumeReport-ExtIEs',
        'RAB-Parameters-ExtIEs',
        'RABParametersList-ExtIEs',
        'RAB-TrCH-MappingItem-ExtIEs',
        'RAI-ExtIEs',
        'NotEmptyRAListofIdleModeUEs-ExtIEs',
        'MBMSIPMulticastAddressandAPNlist-ExtIEs',
        'Requested-RAB-Parameter-Values-ExtIEs',
        'ResidualBitErrorRatio-ExtIEs',
        'RIM-Transfer-ExtIEs',
        'RNCTraceInformation-ExtIEs',
        'RNSAPRelocationParameters-ExtIEs',
        'RSRVCC-Information-ExtIEs',
        'SAI-ExtIEs',
        'Shared-Network-Information-ExtIEs',
        'SDU-ErrorRatio-ExtIEs',
        'SDU-FormatInformationParameters-ExtIEs',
        'SDU-Parameters-ExtIEs',
        'SNA-Access-Information-ExtIEs',
        'SourceRNC-ID-ExtIEs',
        'SourceRNC-ToTargetRNC-TransparentContainer-ExtIEs',
        'IRAT-Measurement-Configuration-ExtIEs',
        'IRATmeasurementParameters-ExtIEs',
        'EUTRANFrequencies-ExtIEs',
        'SourceUTRANCellID-ExtIEs',
        'SRB-TrCH-MappingItem-ExtIEs',
        'SRVCC-Information-ExtIEs',
        'TAI-ExtIEs',
        'TargetENB-ID-ExtIEs',
        'TargetRNC-ID-ExtIEs',
        'TargetRNC-ToSourceRNC-TransparentContainer-ExtIEs',
        'TMGI-ExtIEs',
        'TraceInformation-ExtIEs',
        'TracePropagationParameters-ExtIEs',
        'TraceRecordingSessionInformation-ExtIEs',
        'TrCH-ID-ExtIEs',
        'Tunnel-Information-ExtIEs',
        'UE-IsNotServed-ExtIEs',
        'UE-IsServed-ExtIEs',
        'UESBI-Iu-ExtIEs',
        'UPInformation-ExtIEs',
        'UTRAN-CellID-ExtIEs',
        'HorizontalVelocity-ExtIEs',
        'HorizontalWithVerticalVelocity-ExtIEs',
        'HorizontalVelocityWithUncertainty-ExtIEs',
        'HorizontalWithVerticalVelocityAndUncertainty-ExtIEs',
        ]
    _param_ = [
        ]
    
    #-----< AccuracyFulfilmentIndicator >-----#
    AccuracyFulfilmentIndicator = ENUM(name='AccuracyFulfilmentIndicator', mode=MODE_TYPE)
    AccuracyFulfilmentIndicator._cont = ASN1Dict([('requested-Accuracy-Fulfilled', 0), ('requested-Accuracy-Not-Fulfilled', 1)])
    AccuracyFulfilmentIndicator._ext = []
    
    #-----< Additional-CSPS-coordination-information >-----#
    Additional_CSPS_coordination_information = SEQ(name='Additional-CSPS-coordination-information', mode=MODE_TYPE)
    _Additional_CSPS_coordination_information_old_LAI = SEQ(name='old-LAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI')), opt=True)
    _Additional_CSPS_coordination_information_old_RAC = OCT_STR(name='old-RAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAC')), opt=True)
    _Additional_CSPS_coordination_information_nRI = BIT_STR(name='nRI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Additional_CSPS_coordination_information_nRI._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    _Additional_CSPS_coordination_information_uE_is_Attaching = NULL(name='uE-is-Attaching', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Additional_CSPS_coordination_information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Additional_CSPS_coordination_information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Additional_CSPS_coordination_information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_CSPS_coordination_information_iE_Extensions__item__id._const_tab = ____Additional_CSPS_coordination_information_iE_Extensions__item__id_tab
    ___Additional_CSPS_coordination_information_iE_Extensions__item__id._const_tab_at = None
    ___Additional_CSPS_coordination_information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality._const_tab = ____Additional_CSPS_coordination_information_iE_Extensions__item__criticality_tab
    ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue._const_tab = ____Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue_tab
    ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Additional_CSPS_coordination_information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Additional_CSPS_coordination_information_iE_Extensions__item__id),
        ('criticality', ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality),
        ('extensionValue', ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue),
        ])
    __Additional_CSPS_coordination_information_iE_Extensions__item_._ext = None
    _Additional_CSPS_coordination_information_iE_Extensions._cont = __Additional_CSPS_coordination_information_iE_Extensions__item_
    _Additional_CSPS_coordination_information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Additional_CSPS_coordination_information._cont = ASN1Dict([
        ('old-LAI', _Additional_CSPS_coordination_information_old_LAI),
        ('old-RAC', _Additional_CSPS_coordination_information_old_RAC),
        ('nRI', _Additional_CSPS_coordination_information_nRI),
        ('uE-is-Attaching', _Additional_CSPS_coordination_information_uE_is_Attaching),
        ('iE-Extensions', _Additional_CSPS_coordination_information_iE_Extensions),
        ])
    Additional_CSPS_coordination_information._ext = []
    
    #-----< Additional-CSPS-coordination-information-ExtIEs >-----#
    Additional_CSPS_coordination_information_ExtIEs = CLASS(name='Additional-CSPS-coordination-information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Additional_CSPS_coordination_information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Additional-PositioningDataSet >-----#
    Additional_PositioningDataSet = SEQ_OF(name='Additional-PositioningDataSet', mode=MODE_TYPE)
    _Additional_PositioningDataSet__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Additional-PositioningMethodAndUsage')))
    Additional_PositioningDataSet._cont = _Additional_PositioningDataSet__item_
    Additional_PositioningDataSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Additional-PositioningMethodAndUsage >-----#
    Additional_PositioningMethodAndUsage = OCT_STR(name='Additional-PositioningMethodAndUsage', mode=MODE_TYPE)
    Additional_PositioningMethodAndUsage._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< AllocationOrRetentionPriority >-----#
    AllocationOrRetentionPriority = SEQ(name='AllocationOrRetentionPriority', mode=MODE_TYPE)
    _AllocationOrRetentionPriority_priorityLevel = INT(name='priorityLevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PriorityLevel')))
    _AllocationOrRetentionPriority_pre_emptionCapability = ENUM(name='pre-emptionCapability', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Pre-emptionCapability')))
    _AllocationOrRetentionPriority_pre_emptionVulnerability = ENUM(name='pre-emptionVulnerability', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Pre-emptionVulnerability')))
    _AllocationOrRetentionPriority_queuingAllowed = ENUM(name='queuingAllowed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'QueuingAllowed')))
    _AllocationOrRetentionPriority_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __AllocationOrRetentionPriority_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___AllocationOrRetentionPriority_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____AllocationOrRetentionPriority_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____AllocationOrRetentionPriority_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationOrRetentionPriority_iE_Extensions__item__id._const_tab = ____AllocationOrRetentionPriority_iE_Extensions__item__id_tab
    ___AllocationOrRetentionPriority_iE_Extensions__item__id._const_tab_at = None
    ___AllocationOrRetentionPriority_iE_Extensions__item__id._const_tab_id = 'id'
    ___AllocationOrRetentionPriority_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____AllocationOrRetentionPriority_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____AllocationOrRetentionPriority_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationOrRetentionPriority_iE_Extensions__item__criticality._const_tab = ____AllocationOrRetentionPriority_iE_Extensions__item__criticality_tab
    ___AllocationOrRetentionPriority_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___AllocationOrRetentionPriority_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____AllocationOrRetentionPriority_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____AllocationOrRetentionPriority_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue._const_tab = ____AllocationOrRetentionPriority_iE_Extensions__item__extensionValue_tab
    ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __AllocationOrRetentionPriority_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___AllocationOrRetentionPriority_iE_Extensions__item__id),
        ('criticality', ___AllocationOrRetentionPriority_iE_Extensions__item__criticality),
        ('extensionValue', ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue),
        ])
    __AllocationOrRetentionPriority_iE_Extensions__item_._ext = None
    _AllocationOrRetentionPriority_iE_Extensions._cont = __AllocationOrRetentionPriority_iE_Extensions__item_
    _AllocationOrRetentionPriority_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    AllocationOrRetentionPriority._cont = ASN1Dict([
        ('priorityLevel', _AllocationOrRetentionPriority_priorityLevel),
        ('pre-emptionCapability', _AllocationOrRetentionPriority_pre_emptionCapability),
        ('pre-emptionVulnerability', _AllocationOrRetentionPriority_pre_emptionVulnerability),
        ('queuingAllowed', _AllocationOrRetentionPriority_queuingAllowed),
        ('iE-Extensions', _AllocationOrRetentionPriority_iE_Extensions),
        ])
    AllocationOrRetentionPriority._ext = []
    
    #-----< AllocationOrRetentionPriority-ExtIEs >-----#
    AllocationOrRetentionPriority_ExtIEs = CLASS(name='AllocationOrRetentionPriority-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    AllocationOrRetentionPriority_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Alt-RAB-Parameters >-----#
    Alt_RAB_Parameters = SEQ(name='Alt-RAB-Parameters', mode=MODE_TYPE)
    _Alt_RAB_Parameters_altMaxBitrateInf = SEQ(name='altMaxBitrateInf', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrateInf')), opt=True)
    _Alt_RAB_Parameters_altGuaranteedBitRateInf = SEQ(name='altGuaranteedBitRateInf', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrateInf')), opt=True)
    _Alt_RAB_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Alt_RAB_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Alt_RAB_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Alt_RAB_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf')))
    _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedMaxBitrateInf')))
    _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedMaxBitrateInf')))
    _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf')))
    ____Alt_RAB_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 158), ('criticality', 'ignore'), ('Extension', _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 172), ('criticality', 'ignore'), ('Extension', _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 173), ('criticality', 'ignore'), ('Extension', _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'reject'), ('Extension', _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 214), ('criticality', 'reject'), ('Extension', _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameters_iE_Extensions__item__id._const_tab = ____Alt_RAB_Parameters_iE_Extensions__item__id_tab
    ___Alt_RAB_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___Alt_RAB_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___Alt_RAB_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Alt_RAB_Parameters_iE_Extensions__item__criticality._const_tab = ____Alt_RAB_Parameters_iE_Extensions__item__id_tab
    ___Alt_RAB_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Alt_RAB_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab = ____Alt_RAB_Parameters_iE_Extensions__item__id_tab
    ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Alt_RAB_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Alt_RAB_Parameters_iE_Extensions__item__id),
        ('criticality', ___Alt_RAB_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue),
        ])
    __Alt_RAB_Parameters_iE_Extensions__item_._ext = None
    _Alt_RAB_Parameters_iE_Extensions._cont = __Alt_RAB_Parameters_iE_Extensions__item_
    _Alt_RAB_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Alt_RAB_Parameters._cont = ASN1Dict([
        ('altMaxBitrateInf', _Alt_RAB_Parameters_altMaxBitrateInf),
        ('altGuaranteedBitRateInf', _Alt_RAB_Parameters_altGuaranteedBitRateInf),
        ('iE-Extensions', _Alt_RAB_Parameters_iE_Extensions),
        ])
    Alt_RAB_Parameters._ext = []
    
    #-----< Alt-RAB-Parameters-ExtIEs >-----#
    Alt_RAB_Parameters_ExtIEs = CLASS(name='Alt-RAB-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _Alt_RAB_Parameters_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _Alt_RAB_Parameters_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf')))
    _Alt_RAB_Parameters_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedMaxBitrateInf')))
    _Alt_RAB_Parameters_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedMaxBitrateInf')))
    _Alt_RAB_Parameters_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedGuaranteedBitrateInf')))
    Alt_RAB_Parameters_ExtIEs._val = ASN1Set(rv=[dict([('id', 158), ('criticality', 'ignore'), ('Extension', _Alt_RAB_Parameters_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 172), ('criticality', 'ignore'), ('Extension', _Alt_RAB_Parameters_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 173), ('criticality', 'ignore'), ('Extension', _Alt_RAB_Parameters_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 215), ('criticality', 'reject'), ('Extension', _Alt_RAB_Parameters_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 214), ('criticality', 'reject'), ('Extension', _Alt_RAB_Parameters_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf >-----#
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf = SEQ(name='Alt-RAB-Parameter-ExtendedGuaranteedBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrateType = ENUM(name='altExtendedGuaranteedBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrateType')))
    _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrates = SEQ_OF(name='altExtendedGuaranteedBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedGuaranteedBitrates')), opt=True)
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf._cont = ASN1Dict([
        ('altExtendedGuaranteedBitrateType', _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrateType),
        ('altExtendedGuaranteedBitrates', _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrates),
        ])
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-ExtendedGuaranteedBitrates >-----#
    Alt_RAB_Parameter_ExtendedGuaranteedBitrates = SEQ_OF(name='Alt-RAB-Parameter-ExtendedGuaranteedBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedGuaranteedBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedGuaranteedBitrateList')))
    Alt_RAB_Parameter_ExtendedGuaranteedBitrates._cont = _Alt_RAB_Parameter_ExtendedGuaranteedBitrates__item_
    Alt_RAB_Parameter_ExtendedGuaranteedBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateList = SEQ_OF(name='Alt-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedGuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedGuaranteedBitrate')))
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateList._cont = _Alt_RAB_Parameter_ExtendedGuaranteedBitrateList__item_
    Alt_RAB_Parameter_ExtendedGuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-GuaranteedBitrateInf >-----#
    Alt_RAB_Parameter_GuaranteedBitrateInf = SEQ(name='Alt-RAB-Parameter-GuaranteedBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrateType = ENUM(name='altGuaranteedBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrateType')))
    _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrates = SEQ_OF(name='altGuaranteedBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrates')), opt=True)
    Alt_RAB_Parameter_GuaranteedBitrateInf._cont = ASN1Dict([
        ('altGuaranteedBitrateType', _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrateType),
        ('altGuaranteedBitrates', _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrates),
        ])
    Alt_RAB_Parameter_GuaranteedBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-GuaranteedBitrateType >-----#
    Alt_RAB_Parameter_GuaranteedBitrateType = ENUM(name='Alt-RAB-Parameter-GuaranteedBitrateType', mode=MODE_TYPE)
    Alt_RAB_Parameter_GuaranteedBitrateType._cont = ASN1Dict([('unspecified', 0), ('value-range', 1), ('discrete-values', 2)])
    Alt_RAB_Parameter_GuaranteedBitrateType._ext = []
    
    #-----< Alt-RAB-Parameter-GuaranteedBitrates >-----#
    Alt_RAB_Parameter_GuaranteedBitrates = SEQ_OF(name='Alt-RAB-Parameter-GuaranteedBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_GuaranteedBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrateList')))
    Alt_RAB_Parameter_GuaranteedBitrates._cont = _Alt_RAB_Parameter_GuaranteedBitrates__item_
    Alt_RAB_Parameter_GuaranteedBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-GuaranteedBitrateList >-----#
    Alt_RAB_Parameter_GuaranteedBitrateList = SEQ_OF(name='Alt-RAB-Parameter-GuaranteedBitrateList', mode=MODE_TYPE)
    _Alt_RAB_Parameter_GuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GuaranteedBitrate')))
    Alt_RAB_Parameter_GuaranteedBitrateList._cont = _Alt_RAB_Parameter_GuaranteedBitrateList__item_
    Alt_RAB_Parameter_GuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-SupportedGuaranteedBitrateInf >-----#
    Alt_RAB_Parameter_SupportedGuaranteedBitrateInf = SEQ(name='Alt-RAB-Parameter-SupportedGuaranteedBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrateType = ENUM(name='altSupportedGuaranteedBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-GuaranteedBitrateType')))
    _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrates = SEQ_OF(name='altSupportedGuaranteedBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedGuaranteedBitrates')), opt=True)
    _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id._const_tab = ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id_tab
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id._const_tab_at = None
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id._const_tab_id = 'id'
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality._const_tab = ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality_tab
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue._const_tab = ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue_tab
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id),
        ('criticality', ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality),
        ('extensionValue', ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue),
        ])
    __Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item_._ext = None
    _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions._cont = __Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item_
    _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Alt_RAB_Parameter_SupportedGuaranteedBitrateInf._cont = ASN1Dict([
        ('altSupportedGuaranteedBitrateType', _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrateType),
        ('altSupportedGuaranteedBitrates', _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrates),
        ('iE-Extensions', _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions),
        ])
    Alt_RAB_Parameter_SupportedGuaranteedBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-SupportedGuaranteedBitrateInf-ExtIEs >-----#
    Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_ExtIEs = CLASS(name='Alt-RAB-Parameter-SupportedGuaranteedBitrateInf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Alt-RAB-Parameter-SupportedGuaranteedBitrates >-----#
    Alt_RAB_Parameter_SupportedGuaranteedBitrates = SEQ_OF(name='Alt-RAB-Parameter-SupportedGuaranteedBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_SupportedGuaranteedBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    Alt_RAB_Parameter_SupportedGuaranteedBitrates._cont = _Alt_RAB_Parameter_SupportedGuaranteedBitrates__item_
    Alt_RAB_Parameter_SupportedGuaranteedBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-ExtendedMaxBitrateInf >-----#
    Alt_RAB_Parameter_ExtendedMaxBitrateInf = SEQ(name='Alt-RAB-Parameter-ExtendedMaxBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrateType = ENUM(name='altExtendedMaxBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrateType')))
    _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrates = SEQ_OF(name='altExtendedMaxBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedMaxBitrates')), opt=True)
    Alt_RAB_Parameter_ExtendedMaxBitrateInf._cont = ASN1Dict([
        ('altExtendedMaxBitrateType', _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrateType),
        ('altExtendedMaxBitrates', _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrates),
        ])
    Alt_RAB_Parameter_ExtendedMaxBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-ExtendedMaxBitrates >-----#
    Alt_RAB_Parameter_ExtendedMaxBitrates = SEQ_OF(name='Alt-RAB-Parameter-ExtendedMaxBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedMaxBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-ExtendedMaxBitrateList')))
    Alt_RAB_Parameter_ExtendedMaxBitrates._cont = _Alt_RAB_Parameter_ExtendedMaxBitrates__item_
    Alt_RAB_Parameter_ExtendedMaxBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-ExtendedMaxBitrateList >-----#
    Alt_RAB_Parameter_ExtendedMaxBitrateList = SEQ_OF(name='Alt-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_TYPE)
    _Alt_RAB_Parameter_ExtendedMaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedMaxBitrate')))
    Alt_RAB_Parameter_ExtendedMaxBitrateList._cont = _Alt_RAB_Parameter_ExtendedMaxBitrateList__item_
    Alt_RAB_Parameter_ExtendedMaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-MaxBitrateInf >-----#
    Alt_RAB_Parameter_MaxBitrateInf = SEQ(name='Alt-RAB-Parameter-MaxBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrateType = ENUM(name='altMaxBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrateType')))
    _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrates = SEQ_OF(name='altMaxBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrates')), opt=True)
    Alt_RAB_Parameter_MaxBitrateInf._cont = ASN1Dict([
        ('altMaxBitrateType', _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrateType),
        ('altMaxBitrates', _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrates),
        ])
    Alt_RAB_Parameter_MaxBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-MaxBitrateType >-----#
    Alt_RAB_Parameter_MaxBitrateType = ENUM(name='Alt-RAB-Parameter-MaxBitrateType', mode=MODE_TYPE)
    Alt_RAB_Parameter_MaxBitrateType._cont = ASN1Dict([('unspecified', 0), ('value-range', 1), ('discrete-values', 2)])
    Alt_RAB_Parameter_MaxBitrateType._ext = []
    
    #-----< Alt-RAB-Parameter-MaxBitrates >-----#
    Alt_RAB_Parameter_MaxBitrates = SEQ_OF(name='Alt-RAB-Parameter-MaxBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_MaxBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrateList')))
    Alt_RAB_Parameter_MaxBitrates._cont = _Alt_RAB_Parameter_MaxBitrates__item_
    Alt_RAB_Parameter_MaxBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-MaxBitrateList >-----#
    Alt_RAB_Parameter_MaxBitrateList = SEQ_OF(name='Alt-RAB-Parameter-MaxBitrateList', mode=MODE_TYPE)
    _Alt_RAB_Parameter_MaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MaxBitrate')))
    Alt_RAB_Parameter_MaxBitrateList._cont = _Alt_RAB_Parameter_MaxBitrateList__item_
    Alt_RAB_Parameter_MaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Alt-RAB-Parameter-SupportedMaxBitrateInf >-----#
    Alt_RAB_Parameter_SupportedMaxBitrateInf = SEQ(name='Alt-RAB-Parameter-SupportedMaxBitrateInf', mode=MODE_TYPE)
    _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrateType = ENUM(name='altSupportedMaxBitrateType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-MaxBitrateType')))
    _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrates = SEQ_OF(name='altSupportedMaxBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameter-SupportedMaxBitrates')), opt=True)
    _Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id._const_tab = ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id_tab
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id._const_tab_at = None
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id._const_tab_id = 'id'
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality._const_tab = ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality_tab
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue._const_tab = ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue_tab
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id),
        ('criticality', ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality),
        ('extensionValue', ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue),
        ])
    __Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item_._ext = None
    _Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions._cont = __Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item_
    _Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Alt_RAB_Parameter_SupportedMaxBitrateInf._cont = ASN1Dict([
        ('altSupportedMaxBitrateType', _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrateType),
        ('altSupportedMaxBitrates', _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrates),
        ('iE-Extensions', _Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions),
        ])
    Alt_RAB_Parameter_SupportedMaxBitrateInf._ext = []
    
    #-----< Alt-RAB-Parameter-SupportedMaxBitrateInf-ExtIEs >-----#
    Alt_RAB_Parameter_SupportedMaxBitrateInf_ExtIEs = CLASS(name='Alt-RAB-Parameter-SupportedMaxBitrateInf-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Alt_RAB_Parameter_SupportedMaxBitrateInf_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Alt-RAB-Parameter-SupportedMaxBitrates >-----#
    Alt_RAB_Parameter_SupportedMaxBitrates = SEQ_OF(name='Alt-RAB-Parameter-SupportedMaxBitrates', mode=MODE_TYPE)
    _Alt_RAB_Parameter_SupportedMaxBitrates__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    Alt_RAB_Parameter_SupportedMaxBitrates._cont = _Alt_RAB_Parameter_SupportedMaxBitrates__item_
    Alt_RAB_Parameter_SupportedMaxBitrates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< AlternativeRABConfigurationRequest >-----#
    AlternativeRABConfigurationRequest = ENUM(name='AlternativeRABConfigurationRequest', mode=MODE_TYPE)
    AlternativeRABConfigurationRequest._cont = ASN1Dict([('alternative-RAB-configuration-Requested', 0)])
    AlternativeRABConfigurationRequest._ext = []
    
    #-----< UE-Application-Layer-Measurement-Configuration >-----#
    UE_Application_Layer_Measurement_Configuration = SEQ(name='UE-Application-Layer-Measurement-Configuration', mode=MODE_TYPE)
    _UE_Application_Layer_Measurement_Configuration_applicationLayerContainerForMeasurementConfiguration = OCT_STR(name='applicationLayerContainerForMeasurementConfiguration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UE_Application_Layer_Measurement_Configuration_applicationLayerContainerForMeasurementConfiguration._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000)], ev=None, er=[])
    _UE_Application_Layer_Measurement_Configuration_areaScopeForUEApplicationLayerMeasurementConfiguration = CHOICE(name='areaScopeForUEApplicationLayerMeasurementConfiguration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'AreaScopeForUEApplicationLayerMeasurementConfiguration')))
    _UE_Application_Layer_Measurement_Configuration_serviceType = ENUM(name='serviceType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ServiceType')))
    UE_Application_Layer_Measurement_Configuration._cont = ASN1Dict([
        ('applicationLayerContainerForMeasurementConfiguration', _UE_Application_Layer_Measurement_Configuration_applicationLayerContainerForMeasurementConfiguration),
        ('areaScopeForUEApplicationLayerMeasurementConfiguration', _UE_Application_Layer_Measurement_Configuration_areaScopeForUEApplicationLayerMeasurementConfiguration),
        ('serviceType', _UE_Application_Layer_Measurement_Configuration_serviceType),
        ])
    UE_Application_Layer_Measurement_Configuration._ext = ['serviceType']
    
    #-----< UE-Application-Layer-Measurement-Configuration-For-Relocation >-----#
    UE_Application_Layer_Measurement_Configuration_For_Relocation = SEQ(name='UE-Application-Layer-Measurement-Configuration-For-Relocation', mode=MODE_TYPE)
    _UE_Application_Layer_Measurement_Configuration_For_Relocation_areaScopeForUEApplicationLayerMeasurementConfiguration = CHOICE(name='areaScopeForUEApplicationLayerMeasurementConfiguration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'AreaScopeForUEApplicationLayerMeasurementConfiguration')))
    _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceReference = OCT_STR(name='traceReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _UE_Application_Layer_Measurement_Configuration_For_Relocation_tracePropagationParameters = SEQ(name='tracePropagationParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TracePropagationParameters')), opt=True)
    _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceCollectionEntityIPAddress = BIT_STR(name='traceCollectionEntityIPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')), opt=True)
    _UE_Application_Layer_Measurement_Configuration_For_Relocation_serviceType = ENUM(name='serviceType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ServiceType')))
    UE_Application_Layer_Measurement_Configuration_For_Relocation._cont = ASN1Dict([
        ('areaScopeForUEApplicationLayerMeasurementConfiguration', _UE_Application_Layer_Measurement_Configuration_For_Relocation_areaScopeForUEApplicationLayerMeasurementConfiguration),
        ('traceReference', _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceReference),
        ('tracePropagationParameters', _UE_Application_Layer_Measurement_Configuration_For_Relocation_tracePropagationParameters),
        ('traceCollectionEntityIPAddress', _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceCollectionEntityIPAddress),
        ('serviceType', _UE_Application_Layer_Measurement_Configuration_For_Relocation_serviceType),
        ])
    UE_Application_Layer_Measurement_Configuration_For_Relocation._ext = ['serviceType']
    
    #-----< ServiceType >-----#
    ServiceType = ENUM(name='ServiceType', mode=MODE_TYPE)
    ServiceType._cont = ASN1Dict([('qMC-for-streaming-service', 0), ('qMC-for-MSTI-service', 1)])
    ServiceType._ext = []
    
    #-----< APN >-----#
    APN = OCT_STR(name='APN', mode=MODE_TYPE)
    APN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< AreaScopeForUEApplicationLayerMeasurementConfiguration >-----#
    AreaScopeForUEApplicationLayerMeasurementConfiguration = CHOICE(name='AreaScopeForUEApplicationLayerMeasurementConfiguration', mode=MODE_TYPE)
    _AreaScopeForUEApplicationLayerMeasurementConfiguration_cellbased = SEQ(name='cellbased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellBased')))
    _AreaScopeForUEApplicationLayerMeasurementConfiguration_labased = SEQ(name='labased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LABased')))
    _AreaScopeForUEApplicationLayerMeasurementConfiguration_rabased = SEQ(name='rabased', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RABased')))
    _AreaScopeForUEApplicationLayerMeasurementConfiguration_plmn_area_based = SEQ(name='plmn-area-based', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNBased')))
    AreaScopeForUEApplicationLayerMeasurementConfiguration._cont = ASN1Dict([
        ('cellbased', _AreaScopeForUEApplicationLayerMeasurementConfiguration_cellbased),
        ('labased', _AreaScopeForUEApplicationLayerMeasurementConfiguration_labased),
        ('rabased', _AreaScopeForUEApplicationLayerMeasurementConfiguration_rabased),
        ('plmn-area-based', _AreaScopeForUEApplicationLayerMeasurementConfiguration_plmn_area_based),
        ])
    AreaScopeForUEApplicationLayerMeasurementConfiguration._ext = []
    
    #-----< AreaIdentity >-----#
    AreaIdentity = CHOICE(name='AreaIdentity', mode=MODE_TYPE)
    _AreaIdentity_sAI = SEQ(name='sAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _AreaIdentity_geographicalArea = CHOICE(name='geographicalArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalArea')))
    AreaIdentity._cont = ASN1Dict([
        ('sAI', _AreaIdentity_sAI),
        ('geographicalArea', _AreaIdentity_geographicalArea),
        ])
    AreaIdentity._ext = []
    
    #-----< Ass-RAB-Parameters >-----#
    Ass_RAB_Parameters = SEQ(name='Ass-RAB-Parameters', mode=MODE_TYPE)
    _Ass_RAB_Parameters_assMaxBitrateInf = SEQ_OF(name='assMaxBitrateInf', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-MaxBitrateList')), opt=True)
    _Ass_RAB_Parameters_assGuaranteedBitRateInf = SEQ_OF(name='assGuaranteedBitRateInf', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-GuaranteedBitrateList')), opt=True)
    _Ass_RAB_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Ass_RAB_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Ass_RAB_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Ass_RAB_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-ExtendedMaxBitrateList')))
    _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    ____Ass_RAB_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 174), ('criticality', 'reject'), ('Extension', _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 175), ('criticality', 'reject'), ('Extension', _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Extension', _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 216), ('criticality', 'ignore'), ('Extension', _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Ass_RAB_Parameters_iE_Extensions__item__id._const_tab = ____Ass_RAB_Parameters_iE_Extensions__item__id_tab
    ___Ass_RAB_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___Ass_RAB_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___Ass_RAB_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Ass_RAB_Parameters_iE_Extensions__item__criticality._const_tab = ____Ass_RAB_Parameters_iE_Extensions__item__id_tab
    ___Ass_RAB_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Ass_RAB_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab = ____Ass_RAB_Parameters_iE_Extensions__item__id_tab
    ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Ass_RAB_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Ass_RAB_Parameters_iE_Extensions__item__id),
        ('criticality', ___Ass_RAB_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue),
        ])
    __Ass_RAB_Parameters_iE_Extensions__item_._ext = None
    _Ass_RAB_Parameters_iE_Extensions._cont = __Ass_RAB_Parameters_iE_Extensions__item_
    _Ass_RAB_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Ass_RAB_Parameters._cont = ASN1Dict([
        ('assMaxBitrateInf', _Ass_RAB_Parameters_assMaxBitrateInf),
        ('assGuaranteedBitRateInf', _Ass_RAB_Parameters_assGuaranteedBitRateInf),
        ('iE-Extensions', _Ass_RAB_Parameters_iE_Extensions),
        ])
    Ass_RAB_Parameters._ext = []
    
    #-----< Ass-RAB-Parameters-ExtIEs >-----#
    Ass_RAB_Parameters_ExtIEs = CLASS(name='Ass-RAB-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _Ass_RAB_Parameters_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _Ass_RAB_Parameters_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameter-ExtendedMaxBitrateList')))
    _Ass_RAB_Parameters_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _Ass_RAB_Parameters_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    Ass_RAB_Parameters_ExtIEs._val = ASN1Set(rv=[dict([('id', 174), ('criticality', 'reject'), ('Extension', _Ass_RAB_Parameters_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 175), ('criticality', 'reject'), ('Extension', _Ass_RAB_Parameters_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 217), ('criticality', 'ignore'), ('Extension', _Ass_RAB_Parameters_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 216), ('criticality', 'ignore'), ('Extension', _Ass_RAB_Parameters_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Ass-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    Ass_RAB_Parameter_ExtendedGuaranteedBitrateList = SEQ_OF(name='Ass-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_TYPE)
    _Ass_RAB_Parameter_ExtendedGuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedGuaranteedBitrate')))
    Ass_RAB_Parameter_ExtendedGuaranteedBitrateList._cont = _Ass_RAB_Parameter_ExtendedGuaranteedBitrateList__item_
    Ass_RAB_Parameter_ExtendedGuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Ass-RAB-Parameter-ExtendedMaxBitrateList >-----#
    Ass_RAB_Parameter_ExtendedMaxBitrateList = SEQ_OF(name='Ass-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_TYPE)
    _Ass_RAB_Parameter_ExtendedMaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedMaxBitrate')))
    Ass_RAB_Parameter_ExtendedMaxBitrateList._cont = _Ass_RAB_Parameter_ExtendedMaxBitrateList__item_
    Ass_RAB_Parameter_ExtendedMaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Ass-RAB-Parameter-GuaranteedBitrateList >-----#
    Ass_RAB_Parameter_GuaranteedBitrateList = SEQ_OF(name='Ass-RAB-Parameter-GuaranteedBitrateList', mode=MODE_TYPE)
    _Ass_RAB_Parameter_GuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GuaranteedBitrate')))
    Ass_RAB_Parameter_GuaranteedBitrateList._cont = _Ass_RAB_Parameter_GuaranteedBitrateList__item_
    Ass_RAB_Parameter_GuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Ass-RAB-Parameter-MaxBitrateList >-----#
    Ass_RAB_Parameter_MaxBitrateList = SEQ_OF(name='Ass-RAB-Parameter-MaxBitrateList', mode=MODE_TYPE)
    _Ass_RAB_Parameter_MaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MaxBitrate')))
    Ass_RAB_Parameter_MaxBitrateList._cont = _Ass_RAB_Parameter_MaxBitrateList__item_
    Ass_RAB_Parameter_MaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< AuthorisedPLMNs >-----#
    AuthorisedPLMNs = SEQ_OF(name='AuthorisedPLMNs', mode=MODE_TYPE)
    _AuthorisedPLMNs__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __AuthorisedPLMNs__item__pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    __AuthorisedPLMNs__item__authorisedSNAsList = SEQ_OF(name='authorisedSNAsList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'AuthorisedSNAs')), opt=True)
    __AuthorisedPLMNs__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___AuthorisedPLMNs__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____AuthorisedPLMNs__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____AuthorisedPLMNs__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____AuthorisedPLMNs__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AuthorisedPLMNs__item__iE_Extensions__item__id._const_tab = _____AuthorisedPLMNs__item__iE_Extensions__item__id_tab
    ____AuthorisedPLMNs__item__iE_Extensions__item__id._const_tab_at = None
    ____AuthorisedPLMNs__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____AuthorisedPLMNs__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____AuthorisedPLMNs__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____AuthorisedPLMNs__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AuthorisedPLMNs__item__iE_Extensions__item__criticality._const_tab = _____AuthorisedPLMNs__item__iE_Extensions__item__criticality_tab
    ____AuthorisedPLMNs__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____AuthorisedPLMNs__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue._const_tab = _____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue_tab
    ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___AuthorisedPLMNs__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____AuthorisedPLMNs__item__iE_Extensions__item__id),
        ('criticality', ____AuthorisedPLMNs__item__iE_Extensions__item__criticality),
        ('extensionValue', ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue),
        ])
    ___AuthorisedPLMNs__item__iE_Extensions__item_._ext = None
    __AuthorisedPLMNs__item__iE_Extensions._cont = ___AuthorisedPLMNs__item__iE_Extensions__item_
    __AuthorisedPLMNs__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _AuthorisedPLMNs__item_._cont = ASN1Dict([
        ('pLMNidentity', __AuthorisedPLMNs__item__pLMNidentity),
        ('authorisedSNAsList', __AuthorisedPLMNs__item__authorisedSNAsList),
        ('iE-Extensions', __AuthorisedPLMNs__item__iE_Extensions),
        ])
    _AuthorisedPLMNs__item_._ext = []
    AuthorisedPLMNs._cont = _AuthorisedPLMNs__item_
    AuthorisedPLMNs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< AuthorisedPLMNs-ExtIEs >-----#
    AuthorisedPLMNs_ExtIEs = CLASS(name='AuthorisedPLMNs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    AuthorisedPLMNs_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AuthorisedSNAs >-----#
    AuthorisedSNAs = SEQ_OF(name='AuthorisedSNAs', mode=MODE_TYPE)
    _AuthorisedSNAs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNAC')))
    AuthorisedSNAs._cont = _AuthorisedSNAs__item_
    AuthorisedSNAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< BarometricPressure >-----#
    BarometricPressure = INT(name='BarometricPressure', mode=MODE_TYPE)
    BarometricPressure._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=30000, ub=115000)], ev=None, er=[])
    
    #-----< BindingID >-----#
    BindingID = OCT_STR(name='BindingID', mode=MODE_TYPE)
    BindingID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< BroadcastAssistanceDataDecipheringKeys >-----#
    BroadcastAssistanceDataDecipheringKeys = SEQ(name='BroadcastAssistanceDataDecipheringKeys', mode=MODE_TYPE)
    _BroadcastAssistanceDataDecipheringKeys_cipheringKeyFlag = BIT_STR(name='cipheringKeyFlag', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BroadcastAssistanceDataDecipheringKeys_cipheringKeyFlag._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _BroadcastAssistanceDataDecipheringKeys_currentDecipheringKey = BIT_STR(name='currentDecipheringKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BroadcastAssistanceDataDecipheringKeys_currentDecipheringKey._const_sz = ASN1Set(rv=[56], rr=[], ev=None, er=[])
    _BroadcastAssistanceDataDecipheringKeys_nextDecipheringKey = BIT_STR(name='nextDecipheringKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BroadcastAssistanceDataDecipheringKeys_nextDecipheringKey._const_sz = ASN1Set(rv=[56], rr=[], ev=None, er=[])
    BroadcastAssistanceDataDecipheringKeys._cont = ASN1Dict([
        ('cipheringKeyFlag', _BroadcastAssistanceDataDecipheringKeys_cipheringKeyFlag),
        ('currentDecipheringKey', _BroadcastAssistanceDataDecipheringKeys_currentDecipheringKey),
        ('nextDecipheringKey', _BroadcastAssistanceDataDecipheringKeys_nextDecipheringKey),
        ])
    BroadcastAssistanceDataDecipheringKeys._ext = []
    
    #-----< Cause >-----#
    Cause = CHOICE(name='Cause', mode=MODE_TYPE)
    _Cause_radioNetwork = INT(name='radioNetwork', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseRadioNetwork')))
    _Cause_transmissionNetwork = INT(name='transmissionNetwork', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseTransmissionNetwork')))
    _Cause_nAS = INT(name='nAS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseNAS')))
    _Cause_protocol = INT(name='protocol', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseProtocol')))
    _Cause_misc = INT(name='misc', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseMisc')))
    _Cause_non_Standard = INT(name='non-Standard', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseNon-Standard')))
    _Cause_radioNetworkExtension = INT(name='radioNetworkExtension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CauseRadioNetworkExtension')))
    Cause._cont = ASN1Dict([
        ('radioNetwork', _Cause_radioNetwork),
        ('transmissionNetwork', _Cause_transmissionNetwork),
        ('nAS', _Cause_nAS),
        ('protocol', _Cause_protocol),
        ('misc', _Cause_misc),
        ('non-Standard', _Cause_non_Standard),
        ('radioNetworkExtension', _Cause_radioNetworkExtension),
        ])
    Cause._ext = ['radioNetworkExtension']
    
    #-----< CauseMisc >-----#
    CauseMisc = INT(name='CauseMisc', mode=MODE_TYPE)
    CauseMisc._cont = ASN1Dict([('om-intervention', 113), ('no-resource-available', 114), ('unspecified-failure', 115), ('network-optimisation', 116)])
    CauseMisc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=113, ub=128)], ev=None, er=[])
    
    #-----< CauseNAS >-----#
    CauseNAS = INT(name='CauseNAS', mode=MODE_TYPE)
    CauseNAS._cont = ASN1Dict([('user-restriction-start-indication', 81), ('user-restriction-end-indication', 82), ('normal-release', 83), ('csg-subscription-expiry', 84)])
    CauseNAS._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=81, ub=96)], ev=None, er=[])
    
    #-----< CauseProtocol >-----#
    CauseProtocol = INT(name='CauseProtocol', mode=MODE_TYPE)
    CauseProtocol._cont = ASN1Dict([('transfer-syntax-error', 97), ('semantic-error', 98), ('message-not-compatible-with-receiver-state', 99), ('abstract-syntax-error-reject', 100), ('abstract-syntax-error-ignore-and-notify', 101), ('abstract-syntax-error-falsely-constructed-message', 102)])
    CauseProtocol._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=97, ub=112)], ev=None, er=[])
    
    #-----< CauseRadioNetwork >-----#
    CauseRadioNetwork = INT(name='CauseRadioNetwork', mode=MODE_TYPE)
    CauseRadioNetwork._cont = ASN1Dict([('rab-pre-empted', 1), ('trelocoverall-expiry', 2), ('trelocprep-expiry', 3), ('treloccomplete-expiry', 4), ('tqueing-expiry', 5), ('relocation-triggered', 6), ('trellocalloc-expiry', 7), ('unable-to-establish-during-relocation', 8), ('unknown-target-rnc', 9), ('relocation-cancelled', 10), ('successful-relocation', 11), ('requested-ciphering-and-or-integrity-protection-algorithms-not-supported', 12), ('conflict-with-already-existing-integrity-protection-and-or-ciphering-information', 13), ('failure-in-the-radio-interface-procedure', 14), ('release-due-to-utran-generated-reason', 15), ('user-inactivity', 16), ('time-critical-relocation', 17), ('requested-traffic-class-not-available', 18), ('invalid-rab-parameters-value', 19), ('requested-maximum-bit-rate-not-available', 20), ('requested-guaranteed-bit-rate-not-available', 21), ('requested-transfer-delay-not-achievable', 22), ('invalid-rab-parameters-combination', 23), ('condition-violation-for-sdu-parameters', 24), ('condition-violation-for-traffic-handling-priority', 25), ('condition-violation-for-guaranteed-bit-rate', 26), ('user-plane-versions-not-supported', 27), ('iu-up-failure', 28), ('relocation-failure-in-target-CN-RNC-or-target-system', 29), ('invalid-RAB-ID', 30), ('no-remaining-rab', 31), ('interaction-with-other-procedure', 32), ('requested-maximum-bit-rate-for-dl-not-available', 33), ('requested-maximum-bit-rate-for-ul-not-available', 34), ('requested-guaranteed-bit-rate-for-dl-not-available', 35), ('requested-guaranteed-bit-rate-for-ul-not-available', 36), ('repeated-integrity-checking-failure', 37), ('requested-request-type-not-supported', 38), ('request-superseded', 39), ('release-due-to-UE-generated-signalling-connection-release', 40), ('resource-optimisation-relocation', 41), ('requested-information-not-available', 42), ('relocation-desirable-for-radio-reasons', 43), ('relocation-not-supported-in-target-RNC-or-target-system', 44), ('directed-retry', 45), ('radio-connection-with-UE-Lost', 46), ('rNC-unable-to-establish-all-RFCs', 47), ('deciphering-keys-not-available', 48), ('dedicated-assistance-data-not-available', 49), ('relocation-target-not-allowed', 50), ('location-reporting-congestion', 51), ('reduce-load-in-serving-cell', 52), ('no-radio-resources-available-in-target-cell', 53), ('gERAN-Iumode-failure', 54), ('access-restricted-due-to-shared-networks', 55), ('incoming-relocation-not-supported-due-to-PUESBINE-feature', 56), ('traffic-load-in-the-target-cell-higher-than-in-the-source-cell', 57), ('mBMS-no-multicast-service-for-this-UE', 58), ('mBMS-unknown-UE-ID', 59), ('successful-MBMS-session-start-no-data-bearer-necessary', 60), ('mBMS-superseded-due-to-NNSF', 61), ('mBMS-UE-linking-already-done', 62), ('mBMS-UE-de-linking-failure-no-existing-UE-linking', 63), ('tMGI-unknown', 64)])
    CauseRadioNetwork._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< CauseRadioNetworkExtension >-----#
    CauseRadioNetworkExtension = INT(name='CauseRadioNetworkExtension', mode=MODE_TYPE)
    CauseRadioNetworkExtension._cont = ASN1Dict([('iP-multicast-address-and-APN-not-valid', 257), ('mBMS-de-registration-rejected-due-to-implicit-registration', 258), ('mBMS-request-superseded', 259), ('mBMS-de-registration-during-session-not-allowed', 260), ('mBMS-no-data-bearer-necessary', 261), ('periodicLocationInformationNotAvailable', 262), ('gTP-Resources-Unavailable', 263), ('tMGI-inUse-overlapping-MBMS-service-area', 264), ('mBMS-no-cell-in-MBMS-service-area', 265), ('no-Iu-CS-UP-relocation', 266), ('successful-MBMS-Session-Start-IP-Multicast-Bearer-established', 267), ('cS-fallback-triggered', 268), ('invalid-CSG-Id', 269)])
    CauseRadioNetworkExtension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=257, ub=512)], ev=None, er=[])
    
    #-----< CauseNon-Standard >-----#
    CauseNon_Standard = INT(name='CauseNon-Standard', mode=MODE_TYPE)
    CauseNon_Standard._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=129, ub=256)], ev=None, er=[])
    
    #-----< CauseTransmissionNetwork >-----#
    CauseTransmissionNetwork = INT(name='CauseTransmissionNetwork', mode=MODE_TYPE)
    CauseTransmissionNetwork._cont = ASN1Dict([('signalling-transport-resource-failure', 65), ('iu-transport-connection-failed-to-establish', 66)])
    CauseTransmissionNetwork._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=65, ub=80)], ev=None, er=[])
    
    #-----< Cell-Access-Mode >-----#
    Cell_Access_Mode = ENUM(name='Cell-Access-Mode', mode=MODE_TYPE)
    Cell_Access_Mode._cont = ASN1Dict([('hybrid', 0)])
    Cell_Access_Mode._ext = []
    
    #-----< CellBased >-----#
    CellBased = SEQ(name='CellBased', mode=MODE_TYPE)
    _CellBased_cellIdList = SEQ_OF(name='cellIdList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellIdList')))
    _CellBased_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellBased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CellBased_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellBased_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellBased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBased_iE_Extensions__item__id._const_tab = ____CellBased_iE_Extensions__item__id_tab
    ___CellBased_iE_Extensions__item__id._const_tab_at = None
    ___CellBased_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellBased_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellBased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellBased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBased_iE_Extensions__item__criticality._const_tab = ____CellBased_iE_Extensions__item__criticality_tab
    ___CellBased_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellBased_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellBased_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellBased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellBased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellBased_iE_Extensions__item__extensionValue._const_tab = ____CellBased_iE_Extensions__item__extensionValue_tab
    ___CellBased_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellBased_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellBased_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellBased_iE_Extensions__item__id),
        ('criticality', ___CellBased_iE_Extensions__item__criticality),
        ('extensionValue', ___CellBased_iE_Extensions__item__extensionValue),
        ])
    __CellBased_iE_Extensions__item_._ext = None
    _CellBased_iE_Extensions._cont = __CellBased_iE_Extensions__item_
    _CellBased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellBased._cont = ASN1Dict([
        ('cellIdList', _CellBased_cellIdList),
        ('iE-Extensions', _CellBased_iE_Extensions),
        ])
    CellBased._ext = []
    
    #-----< CellBased-ExtIEs >-----#
    CellBased_ExtIEs = CLASS(name='CellBased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CellBased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellIdList >-----#
    CellIdList = SEQ_OF(name='CellIdList', mode=MODE_TYPE)
    _CellIdList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Id')))
    CellIdList._cont = _CellIdList__item_
    CellIdList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< Cell-Id >-----#
    Cell_Id = INT(name='Cell-Id', mode=MODE_TYPE)
    Cell_Id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268435455)], ev=None, er=[])
    
    #-----< Cell-Capacity-Class-Value >-----#
    Cell_Capacity_Class_Value = INT(name='Cell-Capacity-Class-Value', mode=MODE_TYPE)
    Cell_Capacity_Class_Value._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=[], er=[])
    
    #-----< CellLoadInformation >-----#
    CellLoadInformation = SEQ(name='CellLoadInformation', mode=MODE_TYPE)
    _CellLoadInformation_cell_Capacity_Class_Value = INT(name='cell-Capacity-Class-Value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cell-Capacity-Class-Value')))
    _CellLoadInformation_loadValue = INT(name='loadValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LoadValue')))
    _CellLoadInformation_rTLoadValue = INT(name='rTLoadValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RTLoadValue')), opt=True)
    _CellLoadInformation_nRTLoadInformationValue = INT(name='nRTLoadInformationValue', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NRTLoadInformationValue')), opt=True)
    _CellLoadInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellLoadInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CellLoadInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellLoadInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformation_iE_Extensions__item__id._const_tab = ____CellLoadInformation_iE_Extensions__item__id_tab
    ___CellLoadInformation_iE_Extensions__item__id._const_tab_at = None
    ___CellLoadInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellLoadInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellLoadInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformation_iE_Extensions__item__criticality._const_tab = ____CellLoadInformation_iE_Extensions__item__criticality_tab
    ___CellLoadInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellLoadInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellLoadInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellLoadInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformation_iE_Extensions__item__extensionValue._const_tab = ____CellLoadInformation_iE_Extensions__item__extensionValue_tab
    ___CellLoadInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellLoadInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellLoadInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellLoadInformation_iE_Extensions__item__id),
        ('criticality', ___CellLoadInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___CellLoadInformation_iE_Extensions__item__extensionValue),
        ])
    __CellLoadInformation_iE_Extensions__item_._ext = None
    _CellLoadInformation_iE_Extensions._cont = __CellLoadInformation_iE_Extensions__item_
    _CellLoadInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellLoadInformation._cont = ASN1Dict([
        ('cell-Capacity-Class-Value', _CellLoadInformation_cell_Capacity_Class_Value),
        ('loadValue', _CellLoadInformation_loadValue),
        ('rTLoadValue', _CellLoadInformation_rTLoadValue),
        ('nRTLoadInformationValue', _CellLoadInformation_nRTLoadInformationValue),
        ('iE-Extensions', _CellLoadInformation_iE_Extensions),
        ])
    CellLoadInformation._ext = []
    
    #-----< CellLoadInformation-ExtIEs >-----#
    CellLoadInformation_ExtIEs = CLASS(name='CellLoadInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CellLoadInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellLoadInformationGroup >-----#
    CellLoadInformationGroup = SEQ(name='CellLoadInformationGroup', mode=MODE_TYPE)
    _CellLoadInformationGroup_sourceCellID = CHOICE(name='sourceCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SourceCellID')))
    _CellLoadInformationGroup_uplinkCellLoadInformation = SEQ(name='uplinkCellLoadInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformation')), opt=True)
    _CellLoadInformationGroup_downlinkCellLoadInformation = SEQ(name='downlinkCellLoadInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformation')), opt=True)
    _CellLoadInformationGroup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CellLoadInformationGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CellLoadInformationGroup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____CellLoadInformationGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformationGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformationGroup_iE_Extensions__item__id._const_tab = ____CellLoadInformationGroup_iE_Extensions__item__id_tab
    ___CellLoadInformationGroup_iE_Extensions__item__id._const_tab_at = None
    ___CellLoadInformationGroup_iE_Extensions__item__id._const_tab_id = 'id'
    ___CellLoadInformationGroup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CellLoadInformationGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformationGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformationGroup_iE_Extensions__item__criticality._const_tab = ____CellLoadInformationGroup_iE_Extensions__item__criticality_tab
    ___CellLoadInformationGroup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CellLoadInformationGroup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CellLoadInformationGroup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CellLoadInformationGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CellLoadInformationGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CellLoadInformationGroup_iE_Extensions__item__extensionValue._const_tab = ____CellLoadInformationGroup_iE_Extensions__item__extensionValue_tab
    ___CellLoadInformationGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CellLoadInformationGroup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CellLoadInformationGroup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CellLoadInformationGroup_iE_Extensions__item__id),
        ('criticality', ___CellLoadInformationGroup_iE_Extensions__item__criticality),
        ('extensionValue', ___CellLoadInformationGroup_iE_Extensions__item__extensionValue),
        ])
    __CellLoadInformationGroup_iE_Extensions__item_._ext = None
    _CellLoadInformationGroup_iE_Extensions._cont = __CellLoadInformationGroup_iE_Extensions__item_
    _CellLoadInformationGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CellLoadInformationGroup._cont = ASN1Dict([
        ('sourceCellID', _CellLoadInformationGroup_sourceCellID),
        ('uplinkCellLoadInformation', _CellLoadInformationGroup_uplinkCellLoadInformation),
        ('downlinkCellLoadInformation', _CellLoadInformationGroup_downlinkCellLoadInformation),
        ('iE-Extensions', _CellLoadInformationGroup_iE_Extensions),
        ])
    CellLoadInformationGroup._ext = []
    
    #-----< CellLoadInformationGroup-ExtIEs >-----#
    CellLoadInformationGroup_ExtIEs = CLASS(name='CellLoadInformationGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CellLoadInformationGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CellType >-----#
    CellType = ENUM(name='CellType', mode=MODE_TYPE)
    CellType._cont = ASN1Dict([('macro', 0), ('micro', 1), ('pico', 2), ('femto', 3)])
    CellType._ext = []
    
    #-----< CivicAddress >-----#
    CivicAddress = OCT_STR(name='CivicAddress', mode=MODE_TYPE)
    
    #-----< ClientType >-----#
    ClientType = ENUM(name='ClientType', mode=MODE_TYPE)
    ClientType._cont = ASN1Dict([('emergency-Services', 0), ('value-Added-Services', 1), ('pLMN-Operator-Services', 2), ('lawful-Intercept-Services', 3), ('pLMN-Operator-Broadcast-Services', 4), ('pLMN-Operator-O-et-M', 5), ('pLMN-Operator-Anonymous-Statistics', 6), ('pLMN-Operator-Target-MS-Service-Support', 7)])
    ClientType._ext = []
    
    #-----< CriticalityDiagnostics >-----#
    CriticalityDiagnostics = SEQ(name='CriticalityDiagnostics', mode=MODE_TYPE)
    _CriticalityDiagnostics_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProcedureCode')), opt=True)
    _CriticalityDiagnostics_triggeringMessage = ENUM(name='triggeringMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'TriggeringMessage')), opt=True)
    _CriticalityDiagnostics_procedureCriticality = ENUM(name='procedureCriticality', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')), opt=True)
    _CriticalityDiagnostics_iEsCriticalityDiagnostics = SEQ_OF(name='iEsCriticalityDiagnostics', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics-IE-List')), opt=True)
    _CriticalityDiagnostics_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CriticalityDiagnostics_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CriticalityDiagnostics_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__id_tab
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_at = None
    ___CriticalityDiagnostics_iE_Extensions__item__id._const_tab_id = 'id'
    ___CriticalityDiagnostics_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab = ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CriticalityDiagnostics_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CriticalityDiagnostics_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CriticalityDiagnostics_iE_Extensions__item__id),
        ('criticality', ___CriticalityDiagnostics_iE_Extensions__item__criticality),
        ('extensionValue', ___CriticalityDiagnostics_iE_Extensions__item__extensionValue),
        ])
    __CriticalityDiagnostics_iE_Extensions__item_._ext = None
    _CriticalityDiagnostics_iE_Extensions._cont = __CriticalityDiagnostics_iE_Extensions__item_
    _CriticalityDiagnostics_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CriticalityDiagnostics._cont = ASN1Dict([
        ('procedureCode', _CriticalityDiagnostics_procedureCode),
        ('triggeringMessage', _CriticalityDiagnostics_triggeringMessage),
        ('procedureCriticality', _CriticalityDiagnostics_procedureCriticality),
        ('iEsCriticalityDiagnostics', _CriticalityDiagnostics_iEsCriticalityDiagnostics),
        ('iE-Extensions', _CriticalityDiagnostics_iE_Extensions),
        ])
    CriticalityDiagnostics._ext = []
    
    #-----< CriticalityDiagnostics-ExtIEs >-----#
    CriticalityDiagnostics_ExtIEs = CLASS(name='CriticalityDiagnostics-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CriticalityDiagnostics_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CriticalityDiagnostics-IE-List >-----#
    CriticalityDiagnostics_IE_List = SEQ_OF(name='CriticalityDiagnostics-IE-List', mode=MODE_TYPE)
    _CriticalityDiagnostics_IE_List__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __CriticalityDiagnostics_IE_List__item__iECriticality = ENUM(name='iECriticality', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')))
    __CriticalityDiagnostics_IE_List__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProtocolIE-ID')))
    __CriticalityDiagnostics_IE_List__item__repetitionNumber = INT(name='repetitionNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RepetitionNumber0')), opt=True)
    __CriticalityDiagnostics_IE_List__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MessageStructure')))
    ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TypeOfError')))
    _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 88), ('criticality', 'ignore'), ('Extension', ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'ignore'), ('Extension', ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_at = None
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab = _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id),
        ('criticality', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality),
        ('extensionValue', ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue),
        ])
    ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_._ext = None
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._cont = ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_
    __CriticalityDiagnostics_IE_List__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _CriticalityDiagnostics_IE_List__item_._cont = ASN1Dict([
        ('iECriticality', __CriticalityDiagnostics_IE_List__item__iECriticality),
        ('iE-ID', __CriticalityDiagnostics_IE_List__item__iE_ID),
        ('repetitionNumber', __CriticalityDiagnostics_IE_List__item__repetitionNumber),
        ('iE-Extensions', __CriticalityDiagnostics_IE_List__item__iE_Extensions),
        ])
    _CriticalityDiagnostics_IE_List__item_._ext = []
    CriticalityDiagnostics_IE_List._cont = _CriticalityDiagnostics_IE_List__item_
    CriticalityDiagnostics_IE_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CriticalityDiagnostics-IE-List-ExtIEs >-----#
    CriticalityDiagnostics_IE_List_ExtIEs = CLASS(name='CriticalityDiagnostics-IE-List-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MessageStructure')))
    _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TypeOfError')))
    CriticalityDiagnostics_IE_List_ExtIEs._val = ASN1Set(rv=[dict([('id', 88), ('criticality', 'ignore'), ('Extension', _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 93), ('criticality', 'ignore'), ('Extension', _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MessageStructure >-----#
    MessageStructure = SEQ_OF(name='MessageStructure', mode=MODE_TYPE)
    _MessageStructure__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __MessageStructure__item__iE_ID = INT(name='iE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProtocolIE-ID')))
    __MessageStructure__item__repetitionNumber = INT(name='repetitionNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RepetitionNumber1')), opt=True)
    __MessageStructure__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___MessageStructure__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____MessageStructure__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____MessageStructure__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__id._const_tab = _____MessageStructure__item__iE_Extensions__item__id_tab
    ____MessageStructure__item__iE_Extensions__item__id._const_tab_at = None
    ____MessageStructure__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____MessageStructure__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____MessageStructure__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab = _____MessageStructure__item__iE_Extensions__item__criticality_tab
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____MessageStructure__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____MessageStructure__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____MessageStructure__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MessageStructure__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab = _____MessageStructure__item__iE_Extensions__item__extensionValue_tab
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____MessageStructure__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___MessageStructure__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____MessageStructure__item__iE_Extensions__item__id),
        ('criticality', ____MessageStructure__item__iE_Extensions__item__criticality),
        ('extensionValue', ____MessageStructure__item__iE_Extensions__item__extensionValue),
        ])
    ___MessageStructure__item__iE_Extensions__item_._ext = None
    __MessageStructure__item__iE_Extensions._cont = ___MessageStructure__item__iE_Extensions__item_
    __MessageStructure__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _MessageStructure__item_._cont = ASN1Dict([
        ('iE-ID', __MessageStructure__item__iE_ID),
        ('repetitionNumber', __MessageStructure__item__repetitionNumber),
        ('iE-Extensions', __MessageStructure__item__iE_Extensions),
        ])
    _MessageStructure__item_._ext = []
    MessageStructure._cont = _MessageStructure__item_
    MessageStructure._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< MessageStructure-ExtIEs >-----#
    MessageStructure_ExtIEs = CLASS(name='MessageStructure-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MessageStructure_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CGI >-----#
    CGI = SEQ(name='CGI', mode=MODE_TYPE)
    _CGI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _CGI_lAC = OCT_STR(name='lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAC')))
    _CGI_cI = OCT_STR(name='cI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CI')))
    _CGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____CGI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____CGI_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    ____CGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 55), ('criticality', 'ignore'), ('Extension', _____CGI_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CGI_iE_Extensions__item__id._const_tab = ____CGI_iE_Extensions__item__id_tab
    ___CGI_iE_Extensions__item__id._const_tab_at = None
    ___CGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___CGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CGI_iE_Extensions__item__criticality._const_tab = ____CGI_iE_Extensions__item__id_tab
    ___CGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CGI_iE_Extensions__item__extensionValue._const_tab = ____CGI_iE_Extensions__item__id_tab
    ___CGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CGI_iE_Extensions__item__id),
        ('criticality', ___CGI_iE_Extensions__item__criticality),
        ('extensionValue', ___CGI_iE_Extensions__item__extensionValue),
        ])
    __CGI_iE_Extensions__item_._ext = None
    _CGI_iE_Extensions._cont = __CGI_iE_Extensions__item_
    _CGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CGI._cont = ASN1Dict([
        ('pLMNidentity', _CGI_pLMNidentity),
        ('lAC', _CGI_lAC),
        ('cI', _CGI_cI),
        ('iE-Extensions', _CGI_iE_Extensions),
        ])
    CGI._ext = None
    
    #-----< CGI-ExtIEs >-----#
    CGI_ExtIEs = CLASS(name='CGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _CGI_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    CGI_ExtIEs._val = ASN1Set(rv=[dict([('id', 55), ('criticality', 'ignore'), ('Extension', _CGI_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ChosenEncryptionAlgorithm >-----#
    ChosenEncryptionAlgorithm = INT(name='ChosenEncryptionAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionAlgorithm')))
    
    #-----< ChosenIntegrityProtectionAlgorithm >-----#
    ChosenIntegrityProtectionAlgorithm = INT(name='ChosenIntegrityProtectionAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionAlgorithm')))
    
    #-----< CI >-----#
    CI = OCT_STR(name='CI', mode=MODE_TYPE)
    CI._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< ClassmarkInformation2 >-----#
    ClassmarkInformation2 = OCT_STR(name='ClassmarkInformation2', mode=MODE_TYPE)
    
    #-----< ClassmarkInformation3 >-----#
    ClassmarkInformation3 = OCT_STR(name='ClassmarkInformation3', mode=MODE_TYPE)
    
    #-----< CN-DomainIndicator >-----#
    CN_DomainIndicator = ENUM(name='CN-DomainIndicator', mode=MODE_TYPE)
    CN_DomainIndicator._cont = ASN1Dict([('cs-domain', 0), ('ps-domain', 1)])
    CN_DomainIndicator._ext = None
    
    #-----< CN-ID >-----#
    CN_ID = INT(name='CN-ID', mode=MODE_TYPE)
    CN_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< Correlation-ID >-----#
    Correlation_ID = OCT_STR(name='Correlation-ID', mode=MODE_TYPE)
    Correlation_ID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< CSFB-Information >-----#
    CSFB_Information = ENUM(name='CSFB-Information', mode=MODE_TYPE)
    CSFB_Information._cont = ASN1Dict([('csfb', 0), ('csfb-high-priority', 1)])
    CSFB_Information._ext = []
    
    #-----< CSG-Id >-----#
    CSG_Id = BIT_STR(name='CSG-Id', mode=MODE_TYPE)
    CSG_Id._const_sz = ASN1Set(rv=[27], rr=[], ev=None, er=[])
    
    #-----< CSG-Id-List >-----#
    CSG_Id_List = SEQ_OF(name='CSG-Id-List', mode=MODE_TYPE)
    _CSG_Id_List__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    CSG_Id_List._cont = _CSG_Id_List__item_
    CSG_Id_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< CSG-Membership-Status >-----#
    CSG_Membership_Status = ENUM(name='CSG-Membership-Status', mode=MODE_TYPE)
    CSG_Membership_Status._cont = ASN1Dict([('member', 0), ('non-member', 1)])
    CSG_Membership_Status._ext = []
    
    #-----< DataPDUType >-----#
    DataPDUType = ENUM(name='DataPDUType', mode=MODE_TYPE)
    DataPDUType._cont = ASN1Dict([('pDUtype0', 0), ('pDUtype1', 1)])
    DataPDUType._ext = []
    
    #-----< DataVolumeReference >-----#
    DataVolumeReference = INT(name='DataVolumeReference', mode=MODE_TYPE)
    DataVolumeReference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< DataVolumeReportingIndication >-----#
    DataVolumeReportingIndication = ENUM(name='DataVolumeReportingIndication', mode=MODE_TYPE)
    DataVolumeReportingIndication._cont = ASN1Dict([('do-report', 0), ('do-not-report', 1)])
    DataVolumeReportingIndication._ext = None
    
    #-----< DCH-ID >-----#
    DCH_ID = INT(name='DCH-ID', mode=MODE_TYPE)
    DCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< DCN-ID >-----#
    DCN_ID = INT(name='DCN-ID', mode=MODE_TYPE)
    DCN_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< DeliveryOfErroneousSDU >-----#
    DeliveryOfErroneousSDU = ENUM(name='DeliveryOfErroneousSDU', mode=MODE_TYPE)
    DeliveryOfErroneousSDU._cont = ASN1Dict([('yes', 0), ('no', 1), ('no-error-detection-consideration', 2)])
    DeliveryOfErroneousSDU._ext = None
    
    #-----< DeliveryOrder >-----#
    DeliveryOrder = ENUM(name='DeliveryOrder', mode=MODE_TYPE)
    DeliveryOrder._cont = ASN1Dict([('delivery-order-requested', 0), ('delivery-order-not-requested', 1)])
    DeliveryOrder._ext = None
    
    #-----< DeltaRAListofIdleModeUEs >-----#
    DeltaRAListofIdleModeUEs = SEQ(name='DeltaRAListofIdleModeUEs', mode=MODE_TYPE)
    _DeltaRAListofIdleModeUEs_newRAListofIdleModeUEs = SEQ_OF(name='newRAListofIdleModeUEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NewRAListofIdleModeUEs')), opt=True)
    _DeltaRAListofIdleModeUEs_rAListwithNoIdleModeUEsAnyMore = SEQ_OF(name='rAListwithNoIdleModeUEsAnyMore', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAListwithNoIdleModeUEsAnyMore')), opt=True)
    _DeltaRAListofIdleModeUEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DeltaRAListofIdleModeUEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 181), ('criticality', 'reject'), ('Extension', _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'conditional')]), dict([('id', 182), ('criticality', 'reject'), ('Extension', _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id._const_tab = ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id._const_tab_at = None
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab = ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab = ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DeltaRAListofIdleModeUEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id),
        ('criticality', ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality),
        ('extensionValue', ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue),
        ])
    __DeltaRAListofIdleModeUEs_iE_Extensions__item_._ext = None
    _DeltaRAListofIdleModeUEs_iE_Extensions._cont = __DeltaRAListofIdleModeUEs_iE_Extensions__item_
    _DeltaRAListofIdleModeUEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DeltaRAListofIdleModeUEs._cont = ASN1Dict([
        ('newRAListofIdleModeUEs', _DeltaRAListofIdleModeUEs_newRAListofIdleModeUEs),
        ('rAListwithNoIdleModeUEsAnyMore', _DeltaRAListofIdleModeUEs_rAListwithNoIdleModeUEsAnyMore),
        ('iE-Extensions', _DeltaRAListofIdleModeUEs_iE_Extensions),
        ])
    DeltaRAListofIdleModeUEs._ext = None
    
    #-----< NewRAListofIdleModeUEs >-----#
    NewRAListofIdleModeUEs = SEQ_OF(name='NewRAListofIdleModeUEs', mode=MODE_TYPE)
    _NewRAListofIdleModeUEs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    NewRAListofIdleModeUEs._cont = _NewRAListofIdleModeUEs__item_
    NewRAListofIdleModeUEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< RAListwithNoIdleModeUEsAnyMore >-----#
    RAListwithNoIdleModeUEsAnyMore = SEQ_OF(name='RAListwithNoIdleModeUEsAnyMore', mode=MODE_TYPE)
    _RAListwithNoIdleModeUEsAnyMore__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    RAListwithNoIdleModeUEsAnyMore._cont = _RAListwithNoIdleModeUEsAnyMore__item_
    RAListwithNoIdleModeUEsAnyMore._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< DeltaRAListofIdleModeUEs-ExtIEs >-----#
    DeltaRAListofIdleModeUEs_ExtIEs = CLASS(name='DeltaRAListofIdleModeUEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    DeltaRAListofIdleModeUEs_ExtIEs._val = ASN1Set(rv=[dict([('id', 181), ('criticality', 'reject'), ('Extension', _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_0), ('presence', 'conditional')]), dict([('id', 182), ('criticality', 'reject'), ('Extension', _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< ForwardingIndication >-----#
    ForwardingIndication = ENUM(name='ForwardingIndication', mode=MODE_TYPE)
    ForwardingIndication._cont = ASN1Dict([('forwarding-admitted', 0)])
    ForwardingIndication._ext = []
    
    #-----< DL-GTP-PDU-SequenceNumber >-----#
    DL_GTP_PDU_SequenceNumber = INT(name='DL-GTP-PDU-SequenceNumber', mode=MODE_TYPE)
    DL_GTP_PDU_SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< DL-N-PDU-SequenceNumber >-----#
    DL_N_PDU_SequenceNumber = INT(name='DL-N-PDU-SequenceNumber', mode=MODE_TYPE)
    DL_N_PDU_SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< D-RNTI >-----#
    D_RNTI = INT(name='D-RNTI', mode=MODE_TYPE)
    D_RNTI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< DRX-CycleLengthCoefficient >-----#
    DRX_CycleLengthCoefficient = INT(name='DRX-CycleLengthCoefficient', mode=MODE_TYPE)
    DRX_CycleLengthCoefficient._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=6, ub=9)], ev=None, er=[])
    
    #-----< DSCH-ID >-----#
    DSCH_ID = INT(name='DSCH-ID', mode=MODE_TYPE)
    DSCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< EARFCN-Extended >-----#
    EARFCN_Extended = INT(name='EARFCN-Extended', mode=MODE_TYPE)
    EARFCN_Extended._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=65536, ub=262143)], ev=[], er=[])
    
    #-----< E-DCH-MAC-d-Flow-ID >-----#
    E_DCH_MAC_d_Flow_ID = INT(name='E-DCH-MAC-d-Flow-ID', mode=MODE_TYPE)
    E_DCH_MAC_d_Flow_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< ENB-ID >-----#
    ENB_ID = CHOICE(name='ENB-ID', mode=MODE_TYPE)
    _ENB_ID_macroENB_ID = BIT_STR(name='macroENB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_macroENB_ID._const_sz = ASN1Set(rv=[20], rr=[], ev=None, er=[])
    _ENB_ID_homeENB_ID = BIT_STR(name='homeENB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_homeENB_ID._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    _ENB_ID_short_macroENB_ID = BIT_STR(name='short-macroENB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_short_macroENB_ID._const_sz = ASN1Set(rv=[18], rr=[], ev=None, er=[])
    _ENB_ID_long_macroENB_ID = BIT_STR(name='long-macroENB-ID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ENB_ID_long_macroENB_ID._const_sz = ASN1Set(rv=[21], rr=[], ev=None, er=[])
    ENB_ID._cont = ASN1Dict([
        ('macroENB-ID', _ENB_ID_macroENB_ID),
        ('homeENB-ID', _ENB_ID_homeENB_ID),
        ('short-macroENB-ID', _ENB_ID_short_macroENB_ID),
        ('long-macroENB-ID', _ENB_ID_long_macroENB_ID),
        ])
    ENB_ID._ext = ['short-macroENB-ID', 'long-macroENB-ID']
    
    #-----< EncryptionAlgorithm >-----#
    EncryptionAlgorithm = INT(name='EncryptionAlgorithm', mode=MODE_TYPE)
    EncryptionAlgorithm._cont = ASN1Dict([('no-encryption', 0), ('standard-UMTS-encryption-algorith-UEA1', 1), ('standard-UMTS-encryption-algorithm-UEA2', 2)])
    EncryptionAlgorithm._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< EncryptionInformation >-----#
    EncryptionInformation = SEQ(name='EncryptionInformation', mode=MODE_TYPE)
    _EncryptionInformation_permittedAlgorithms = SEQ_OF(name='permittedAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PermittedEncryptionAlgorithms')))
    _EncryptionInformation_key = BIT_STR(name='key', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'EncryptionKey')))
    _EncryptionInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EncryptionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___EncryptionInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____EncryptionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EncryptionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncryptionInformation_iE_Extensions__item__id._const_tab = ____EncryptionInformation_iE_Extensions__item__id_tab
    ___EncryptionInformation_iE_Extensions__item__id._const_tab_at = None
    ___EncryptionInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___EncryptionInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EncryptionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EncryptionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncryptionInformation_iE_Extensions__item__criticality._const_tab = ____EncryptionInformation_iE_Extensions__item__criticality_tab
    ___EncryptionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___EncryptionInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___EncryptionInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EncryptionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EncryptionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncryptionInformation_iE_Extensions__item__extensionValue._const_tab = ____EncryptionInformation_iE_Extensions__item__extensionValue_tab
    ___EncryptionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EncryptionInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __EncryptionInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___EncryptionInformation_iE_Extensions__item__id),
        ('criticality', ___EncryptionInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___EncryptionInformation_iE_Extensions__item__extensionValue),
        ])
    __EncryptionInformation_iE_Extensions__item_._ext = None
    _EncryptionInformation_iE_Extensions._cont = __EncryptionInformation_iE_Extensions__item_
    _EncryptionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EncryptionInformation._cont = ASN1Dict([
        ('permittedAlgorithms', _EncryptionInformation_permittedAlgorithms),
        ('key', _EncryptionInformation_key),
        ('iE-Extensions', _EncryptionInformation_iE_Extensions),
        ])
    EncryptionInformation._ext = None
    
    #-----< EncryptionInformation-ExtIEs >-----#
    EncryptionInformation_ExtIEs = CLASS(name='EncryptionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    EncryptionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EncryptionKey >-----#
    EncryptionKey = BIT_STR(name='EncryptionKey', mode=MODE_TYPE)
    EncryptionKey._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    #-----< End-Of-CSFB >-----#
    End_Of_CSFB = ENUM(name='End-Of-CSFB', mode=MODE_TYPE)
    End_Of_CSFB._cont = ASN1Dict([('end-of-CSFB', 0)])
    End_Of_CSFB._ext = []
    
    #-----< EquipmentsToBeTraced >-----#
    EquipmentsToBeTraced = CHOICE(name='EquipmentsToBeTraced', mode=MODE_TYPE)
    _EquipmentsToBeTraced_iMEIlist = SEQ_OF(name='iMEIlist', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEIList')))
    _EquipmentsToBeTraced_iMEISVlist = SEQ_OF(name='iMEISVlist', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEISVList')))
    _EquipmentsToBeTraced_iMEIgroup = SEQ(name='iMEIgroup', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEIGroup')))
    _EquipmentsToBeTraced_iMEISVgroup = SEQ(name='iMEISVgroup', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEISVGroup')))
    EquipmentsToBeTraced._cont = ASN1Dict([
        ('iMEIlist', _EquipmentsToBeTraced_iMEIlist),
        ('iMEISVlist', _EquipmentsToBeTraced_iMEISVlist),
        ('iMEIgroup', _EquipmentsToBeTraced_iMEIgroup),
        ('iMEISVgroup', _EquipmentsToBeTraced_iMEISVgroup),
        ])
    EquipmentsToBeTraced._ext = []
    
    #-----< E-UTRAN-Service-Handover >-----#
    E_UTRAN_Service_Handover = ENUM(name='E-UTRAN-Service-Handover', mode=MODE_TYPE)
    E_UTRAN_Service_Handover._cont = ASN1Dict([('handover-to-E-UTRAN-shall-not-be-performed', 0)])
    E_UTRAN_Service_Handover._ext = []
    
    #-----< Event >-----#
    Event = ENUM(name='Event', mode=MODE_TYPE)
    Event._cont = ASN1Dict([('stop-change-of-service-area', 0), ('direct', 1), ('change-of-servicearea', 2), ('stop-direct', 3), ('periodic', 4), ('stop-periodic', 5)])
    Event._ext = ['stop-direct', 'periodic', 'stop-periodic']
    
    #-----< Event1F-Parameters >-----#
    Event1F_Parameters = SEQ(name='Event1F-Parameters', mode=MODE_TYPE)
    _Event1F_Parameters_measurementQuantity = ENUM(name='measurementQuantity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MeasurementQuantity')))
    _Event1F_Parameters_threshold = INT(name='threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Event1F_Parameters_threshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=165)], ev=None, er=[])
    Event1F_Parameters._cont = ASN1Dict([
        ('measurementQuantity', _Event1F_Parameters_measurementQuantity),
        ('threshold', _Event1F_Parameters_threshold),
        ])
    Event1F_Parameters._ext = []
    
    #-----< Event1I-Parameters >-----#
    Event1I_Parameters = SEQ(name='Event1I-Parameters', mode=MODE_TYPE)
    _Event1I_Parameters_threshold = INT(name='threshold', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Event1I_Parameters_threshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-120, ub=-25)], ev=None, er=[])
    Event1I_Parameters._cont = ASN1Dict([
        ('threshold', _Event1I_Parameters_threshold),
        ])
    Event1I_Parameters._ext = []
    
    #-----< ExtendedGuaranteedBitrate >-----#
    ExtendedGuaranteedBitrate = INT(name='ExtendedGuaranteedBitrate', mode=MODE_TYPE)
    ExtendedGuaranteedBitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=16000001, ub=256000000)], ev=None, er=[])
    
    #-----< ExtendedMaxBitrate >-----#
    ExtendedMaxBitrate = INT(name='ExtendedMaxBitrate', mode=MODE_TYPE)
    ExtendedMaxBitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=16000001, ub=256000000)], ev=None, er=[])
    
    #-----< ExtendedRNC-ID >-----#
    ExtendedRNC_ID = INT(name='ExtendedRNC-ID', mode=MODE_TYPE)
    ExtendedRNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4096, ub=65535)], ev=None, er=[])
    
    #-----< FrameSequenceNumber >-----#
    FrameSequenceNumber = INT(name='FrameSequenceNumber', mode=MODE_TYPE)
    FrameSequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< FrequenceLayerConvergenceFlag >-----#
    FrequenceLayerConvergenceFlag = ENUM(name='FrequenceLayerConvergenceFlag', mode=MODE_TYPE)
    FrequenceLayerConvergenceFlag._cont = ASN1Dict([('no-FLC-flag', 0)])
    FrequenceLayerConvergenceFlag._ext = []
    
    #-----< GANSS-PositioningDataSet >-----#
    GANSS_PositioningDataSet = SEQ_OF(name='GANSS-PositioningDataSet', mode=MODE_TYPE)
    _GANSS_PositioningDataSet__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GANSS-PositioningMethodAndUsage')))
    GANSS_PositioningDataSet._cont = _GANSS_PositioningDataSet__item_
    GANSS_PositioningDataSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< GANSS-PositioningMethodAndUsage >-----#
    GANSS_PositioningMethodAndUsage = OCT_STR(name='GANSS-PositioningMethodAndUsage', mode=MODE_TYPE)
    GANSS_PositioningMethodAndUsage._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< GeographicalArea >-----#
    GeographicalArea = CHOICE(name='GeographicalArea', mode=MODE_TYPE)
    _GeographicalArea_point = SEQ(name='point', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-Point')))
    _GeographicalArea_pointWithUnCertainty = SEQ(name='pointWithUnCertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-PointWithUnCertainty')))
    _GeographicalArea_polygon = SEQ_OF(name='polygon', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-Polygon')))
    _GeographicalArea_pointWithUncertaintyEllipse = SEQ(name='pointWithUncertaintyEllipse', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-PointWithUnCertaintyEllipse')))
    _GeographicalArea_pointWithAltitude = SEQ(name='pointWithAltitude', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-PointWithAltitude')))
    _GeographicalArea_pointWithAltitudeAndUncertaintyEllipsoid = SEQ(name='pointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-PointWithAltitudeAndUncertaintyEllipsoid')))
    _GeographicalArea_ellipsoidArc = SEQ(name='ellipsoidArc', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-EllipsoidArc')))
    GeographicalArea._cont = ASN1Dict([
        ('point', _GeographicalArea_point),
        ('pointWithUnCertainty', _GeographicalArea_pointWithUnCertainty),
        ('polygon', _GeographicalArea_polygon),
        ('pointWithUncertaintyEllipse', _GeographicalArea_pointWithUncertaintyEllipse),
        ('pointWithAltitude', _GeographicalArea_pointWithAltitude),
        ('pointWithAltitudeAndUncertaintyEllipsoid', _GeographicalArea_pointWithAltitudeAndUncertaintyEllipsoid),
        ('ellipsoidArc', _GeographicalArea_ellipsoidArc),
        ])
    GeographicalArea._ext = ['pointWithUncertaintyEllipse', 'pointWithAltitude', 'pointWithAltitudeAndUncertaintyEllipsoid', 'ellipsoidArc']
    
    #-----< GeographicalCoordinates >-----#
    GeographicalCoordinates = SEQ(name='GeographicalCoordinates', mode=MODE_TYPE)
    _GeographicalCoordinates_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _GeographicalCoordinates_latitudeSign._ext = None
    _GeographicalCoordinates_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeographicalCoordinates_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _GeographicalCoordinates_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GeographicalCoordinates_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GeographicalCoordinates_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab = ____GeographicalCoordinates_iE_Extensions__item__id_tab
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_at = None
    ___GeographicalCoordinates_iE_Extensions__item__id._const_tab_id = 'id'
    ___GeographicalCoordinates_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab = ____GeographicalCoordinates_iE_Extensions__item__criticality_tab
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GeographicalCoordinates_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab = ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GeographicalCoordinates_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GeographicalCoordinates_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GeographicalCoordinates_iE_Extensions__item__id),
        ('criticality', ___GeographicalCoordinates_iE_Extensions__item__criticality),
        ('extensionValue', ___GeographicalCoordinates_iE_Extensions__item__extensionValue),
        ])
    __GeographicalCoordinates_iE_Extensions__item_._ext = None
    _GeographicalCoordinates_iE_Extensions._cont = __GeographicalCoordinates_iE_Extensions__item_
    _GeographicalCoordinates_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GeographicalCoordinates._cont = ASN1Dict([
        ('latitudeSign', _GeographicalCoordinates_latitudeSign),
        ('latitude', _GeographicalCoordinates_latitude),
        ('longitude', _GeographicalCoordinates_longitude),
        ('iE-Extensions', _GeographicalCoordinates_iE_Extensions),
        ])
    GeographicalCoordinates._ext = []
    
    #-----< GeographicalCoordinates-ExtIEs >-----#
    GeographicalCoordinates_ExtIEs = CLASS(name='GeographicalCoordinates-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GeographicalCoordinates_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-AltitudeAndDirection >-----#
    GA_AltitudeAndDirection = SEQ(name='GA-AltitudeAndDirection', mode=MODE_TYPE)
    _GA_AltitudeAndDirection_directionOfAltitude = ENUM(name='directionOfAltitude', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_AltitudeAndDirection_directionOfAltitude._cont = ASN1Dict([('height', 0), ('depth', 1)])
    _GA_AltitudeAndDirection_directionOfAltitude._ext = None
    _GA_AltitudeAndDirection_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_AltitudeAndDirection_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    GA_AltitudeAndDirection._cont = ASN1Dict([
        ('directionOfAltitude', _GA_AltitudeAndDirection_directionOfAltitude),
        ('altitude', _GA_AltitudeAndDirection_altitude),
        ])
    GA_AltitudeAndDirection._ext = []
    
    #-----< GA-EllipsoidArc >-----#
    GA_EllipsoidArc = SEQ(name='GA-EllipsoidArc', mode=MODE_TYPE)
    _GA_EllipsoidArc_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_EllipsoidArc_innerRadius = INT(name='innerRadius', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_innerRadius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GA_EllipsoidArc_uncertaintyRadius = INT(name='uncertaintyRadius', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_uncertaintyRadius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_EllipsoidArc_offsetAngle = INT(name='offsetAngle', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_offsetAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _GA_EllipsoidArc_includedAngle = INT(name='includedAngle', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_includedAngle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    _GA_EllipsoidArc_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_EllipsoidArc_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_EllipsoidArc_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_EllipsoidArc_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_EllipsoidArc_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_EllipsoidArc_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__id_tab
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab_at = None
    ___GA_EllipsoidArc_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_EllipsoidArc_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_EllipsoidArc_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab = ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_EllipsoidArc_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_EllipsoidArc_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_EllipsoidArc_iE_Extensions__item__id),
        ('criticality', ___GA_EllipsoidArc_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_EllipsoidArc_iE_Extensions__item__extensionValue),
        ])
    __GA_EllipsoidArc_iE_Extensions__item_._ext = None
    _GA_EllipsoidArc_iE_Extensions._cont = __GA_EllipsoidArc_iE_Extensions__item_
    _GA_EllipsoidArc_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_EllipsoidArc._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_EllipsoidArc_geographicalCoordinates),
        ('innerRadius', _GA_EllipsoidArc_innerRadius),
        ('uncertaintyRadius', _GA_EllipsoidArc_uncertaintyRadius),
        ('offsetAngle', _GA_EllipsoidArc_offsetAngle),
        ('includedAngle', _GA_EllipsoidArc_includedAngle),
        ('confidence', _GA_EllipsoidArc_confidence),
        ('iE-Extensions', _GA_EllipsoidArc_iE_Extensions),
        ])
    GA_EllipsoidArc._ext = []
    
    #-----< GA-EllipsoidArc-ExtIEs >-----#
    GA_EllipsoidArc_ExtIEs = CLASS(name='GA-EllipsoidArc-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_EllipsoidArc_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-Point >-----#
    GA_Point = SEQ(name='GA-Point', mode=MODE_TYPE)
    _GA_Point_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_Point_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_Point_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_Point_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_Point_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_Point_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_Point_iE_Extensions__item__id._const_tab = ____GA_Point_iE_Extensions__item__id_tab
    ___GA_Point_iE_Extensions__item__id._const_tab_at = None
    ___GA_Point_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_Point_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_Point_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_Point_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_Point_iE_Extensions__item__criticality._const_tab = ____GA_Point_iE_Extensions__item__criticality_tab
    ___GA_Point_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_Point_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_Point_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_Point_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_Point_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_Point_iE_Extensions__item__extensionValue._const_tab = ____GA_Point_iE_Extensions__item__extensionValue_tab
    ___GA_Point_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_Point_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_Point_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_Point_iE_Extensions__item__id),
        ('criticality', ___GA_Point_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_Point_iE_Extensions__item__extensionValue),
        ])
    __GA_Point_iE_Extensions__item_._ext = None
    _GA_Point_iE_Extensions._cont = __GA_Point_iE_Extensions__item_
    _GA_Point_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_Point._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_Point_geographicalCoordinates),
        ('iE-Extensions', _GA_Point_iE_Extensions),
        ])
    GA_Point._ext = []
    
    #-----< GA-Point-ExtIEs >-----#
    GA_Point_ExtIEs = CLASS(name='GA-Point-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_Point_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithAltitude >-----#
    GA_PointWithAltitude = SEQ(name='GA-PointWithAltitude', mode=MODE_TYPE)
    _GA_PointWithAltitude_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithAltitude_altitudeAndDirection = SEQ(name='altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-AltitudeAndDirection')))
    _GA_PointWithAltitude_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithAltitude_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithAltitude_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_PointWithAltitude_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__id_tab
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithAltitude_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_PointWithAltitude_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_PointWithAltitude_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_PointWithAltitude_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_PointWithAltitude_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_PointWithAltitude_iE_Extensions__item__id),
        ('criticality', ___GA_PointWithAltitude_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_PointWithAltitude_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithAltitude_iE_Extensions__item_._ext = None
    _GA_PointWithAltitude_iE_Extensions._cont = __GA_PointWithAltitude_iE_Extensions__item_
    _GA_PointWithAltitude_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithAltitude._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_PointWithAltitude_geographicalCoordinates),
        ('altitudeAndDirection', _GA_PointWithAltitude_altitudeAndDirection),
        ('iE-Extensions', _GA_PointWithAltitude_iE_Extensions),
        ])
    GA_PointWithAltitude._ext = []
    
    #-----< GA-PointWithAltitude-ExtIEs >-----#
    GA_PointWithAltitude_ExtIEs = CLASS(name='GA-PointWithAltitude-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_PointWithAltitude_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithAltitudeAndUncertaintyEllipsoid >-----#
    GA_PointWithAltitudeAndUncertaintyEllipsoid = SEQ(name='GA-PointWithAltitudeAndUncertaintyEllipsoid', mode=MODE_TYPE)
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection = SEQ(name='altitudeAndDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-AltitudeAndDirection')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse = SEQ(name='uncertaintyEllipse', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-UncertaintyEllipse')))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude = INT(name='uncertaintyAltitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id),
        ('criticality', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_._ext = None
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions._cont = __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_
    _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithAltitudeAndUncertaintyEllipsoid._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates),
        ('altitudeAndDirection', _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection),
        ('uncertaintyEllipse', _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse),
        ('uncertaintyAltitude', _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude),
        ('confidence', _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence),
        ('iE-Extensions', _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions),
        ])
    GA_PointWithAltitudeAndUncertaintyEllipsoid._ext = []
    
    #-----< GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs >-----#
    GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs = CLASS(name='GA-PointWithAltitudeAndUncertaintyEllipsoid-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithUnCertainty >-----#
    GA_PointWithUnCertainty = SEQ(name='GA-PointWithUnCertainty', mode=MODE_TYPE)
    _GA_PointWithUnCertainty_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithUnCertainty_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithUnCertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithUnCertainty_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithUnCertainty_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_PointWithUnCertainty_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_PointWithUnCertainty_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_PointWithUnCertainty_iE_Extensions__item__id),
        ('criticality', ___GA_PointWithUnCertainty_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithUnCertainty_iE_Extensions__item_._ext = None
    _GA_PointWithUnCertainty_iE_Extensions._cont = __GA_PointWithUnCertainty_iE_Extensions__item_
    _GA_PointWithUnCertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GA_PointWithUnCertainty_uncertaintyCode = INT(name='uncertaintyCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithUnCertainty_uncertaintyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    GA_PointWithUnCertainty._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_PointWithUnCertainty_geographicalCoordinates),
        ('iE-Extensions', _GA_PointWithUnCertainty_iE_Extensions),
        ('uncertaintyCode', _GA_PointWithUnCertainty_uncertaintyCode),
        ])
    GA_PointWithUnCertainty._ext = None
    
    #-----< GA-PointWithUnCertainty-ExtIEs >-----#
    GA_PointWithUnCertainty_ExtIEs = CLASS(name='GA-PointWithUnCertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_PointWithUnCertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-PointWithUnCertaintyEllipse >-----#
    GA_PointWithUnCertaintyEllipse = SEQ(name='GA-PointWithUnCertaintyEllipse', mode=MODE_TYPE)
    _GA_PointWithUnCertaintyEllipse_geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse = SEQ(name='uncertaintyEllipse', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GA-UncertaintyEllipse')))
    _GA_PointWithUnCertaintyEllipse_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_PointWithUnCertaintyEllipse_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_PointWithUnCertaintyEllipse_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab_at = None
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id._const_tab_id = 'id'
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab = ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id),
        ('criticality', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality),
        ('extensionValue', ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue),
        ])
    __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_._ext = None
    _GA_PointWithUnCertaintyEllipse_iE_Extensions._cont = __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_
    _GA_PointWithUnCertaintyEllipse_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GA_PointWithUnCertaintyEllipse._cont = ASN1Dict([
        ('geographicalCoordinates', _GA_PointWithUnCertaintyEllipse_geographicalCoordinates),
        ('uncertaintyEllipse', _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse),
        ('confidence', _GA_PointWithUnCertaintyEllipse_confidence),
        ('iE-Extensions', _GA_PointWithUnCertaintyEllipse_iE_Extensions),
        ])
    GA_PointWithUnCertaintyEllipse._ext = []
    
    #-----< GA-PointWithUnCertaintyEllipse-ExtIEs >-----#
    GA_PointWithUnCertaintyEllipse_ExtIEs = CLASS(name='GA-PointWithUnCertaintyEllipse-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_PointWithUnCertaintyEllipse_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-Polygon >-----#
    GA_Polygon = SEQ_OF(name='GA-Polygon', mode=MODE_TYPE)
    _GA_Polygon__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __GA_Polygon__item__geographicalCoordinates = SEQ(name='geographicalCoordinates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GeographicalCoordinates')))
    __GA_Polygon__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___GA_Polygon__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____GA_Polygon__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____GA_Polygon__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____GA_Polygon__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Polygon__item__iE_Extensions__item__id._const_tab = _____GA_Polygon__item__iE_Extensions__item__id_tab
    ____GA_Polygon__item__iE_Extensions__item__id._const_tab_at = None
    ____GA_Polygon__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____GA_Polygon__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____GA_Polygon__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____GA_Polygon__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Polygon__item__iE_Extensions__item__criticality._const_tab = _____GA_Polygon__item__iE_Extensions__item__criticality_tab
    ____GA_Polygon__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____GA_Polygon__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____GA_Polygon__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____GA_Polygon__item__iE_Extensions__item__extensionValue._const_tab = _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab
    ____GA_Polygon__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____GA_Polygon__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___GA_Polygon__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____GA_Polygon__item__iE_Extensions__item__id),
        ('criticality', ____GA_Polygon__item__iE_Extensions__item__criticality),
        ('extensionValue', ____GA_Polygon__item__iE_Extensions__item__extensionValue),
        ])
    ___GA_Polygon__item__iE_Extensions__item_._ext = None
    __GA_Polygon__item__iE_Extensions._cont = ___GA_Polygon__item__iE_Extensions__item_
    __GA_Polygon__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _GA_Polygon__item_._cont = ASN1Dict([
        ('geographicalCoordinates', __GA_Polygon__item__geographicalCoordinates),
        ('iE-Extensions', __GA_Polygon__item__iE_Extensions),
        ])
    _GA_Polygon__item_._ext = []
    GA_Polygon._cont = _GA_Polygon__item_
    GA_Polygon._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< GA-Polygon-ExtIEs >-----#
    GA_Polygon_ExtIEs = CLASS(name='GA-Polygon-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GA_Polygon_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GA-UncertaintyEllipse >-----#
    GA_UncertaintyEllipse = SEQ(name='GA-UncertaintyEllipse', mode=MODE_TYPE)
    _GA_UncertaintyEllipse_uncertaintySemi_major = INT(name='uncertaintySemi-major', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_uncertaintySemi_major._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_UncertaintyEllipse_uncertaintySemi_minor = INT(name='uncertaintySemi-minor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_uncertaintySemi_minor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _GA_UncertaintyEllipse_orientationOfMajorAxis = INT(name='orientationOfMajorAxis', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GA_UncertaintyEllipse_orientationOfMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    GA_UncertaintyEllipse._cont = ASN1Dict([
        ('uncertaintySemi-major', _GA_UncertaintyEllipse_uncertaintySemi_major),
        ('uncertaintySemi-minor', _GA_UncertaintyEllipse_uncertaintySemi_minor),
        ('orientationOfMajorAxis', _GA_UncertaintyEllipse_orientationOfMajorAxis),
        ])
    GA_UncertaintyEllipse._ext = []
    
    #-----< GERAN-BSC-Container >-----#
    GERAN_BSC_Container = OCT_STR(name='GERAN-BSC-Container', mode=MODE_TYPE)
    
    #-----< GERAN-Cell-ID >-----#
    GERAN_Cell_ID = SEQ(name='GERAN-Cell-ID', mode=MODE_TYPE)
    _GERAN_Cell_ID_lAI = SEQ(name='lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _GERAN_Cell_ID_rAC = OCT_STR(name='rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _GERAN_Cell_ID_cI = OCT_STR(name='cI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CI')))
    _GERAN_Cell_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GERAN_Cell_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GERAN_Cell_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____GERAN_Cell_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__id_tab
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab_at = None
    ___GERAN_Cell_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___GERAN_Cell_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GERAN_Cell_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab = ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GERAN_Cell_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GERAN_Cell_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GERAN_Cell_ID_iE_Extensions__item__id),
        ('criticality', ___GERAN_Cell_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___GERAN_Cell_ID_iE_Extensions__item__extensionValue),
        ])
    __GERAN_Cell_ID_iE_Extensions__item_._ext = None
    _GERAN_Cell_ID_iE_Extensions._cont = __GERAN_Cell_ID_iE_Extensions__item_
    _GERAN_Cell_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GERAN_Cell_ID._cont = ASN1Dict([
        ('lAI', _GERAN_Cell_ID_lAI),
        ('rAC', _GERAN_Cell_ID_rAC),
        ('cI', _GERAN_Cell_ID_cI),
        ('iE-Extensions', _GERAN_Cell_ID_iE_Extensions),
        ])
    GERAN_Cell_ID._ext = None
    
    #-----< GERAN-Cell-ID-ExtIEs >-----#
    GERAN_Cell_ID_ExtIEs = CLASS(name='GERAN-Cell-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GERAN_Cell_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GERAN-Classmark >-----#
    GERAN_Classmark = OCT_STR(name='GERAN-Classmark', mode=MODE_TYPE)
    
    #-----< GlobalCN-ID >-----#
    GlobalCN_ID = SEQ(name='GlobalCN-ID', mode=MODE_TYPE)
    _GlobalCN_ID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _GlobalCN_ID_cN_ID = INT(name='cN-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-ID')))
    GlobalCN_ID._cont = ASN1Dict([
        ('pLMNidentity', _GlobalCN_ID_pLMNidentity),
        ('cN-ID', _GlobalCN_ID_cN_ID),
        ])
    GlobalCN_ID._ext = None
    
    #-----< GlobalRNC-ID >-----#
    GlobalRNC_ID = SEQ(name='GlobalRNC-ID', mode=MODE_TYPE)
    _GlobalRNC_ID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _GlobalRNC_ID_rNC_ID = INT(name='rNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RNC-ID')))
    GlobalRNC_ID._cont = ASN1Dict([
        ('pLMNidentity', _GlobalRNC_ID_pLMNidentity),
        ('rNC-ID', _GlobalRNC_ID_rNC_ID),
        ])
    GlobalRNC_ID._ext = None
    
    #-----< GTP-TEI >-----#
    GTP_TEI = OCT_STR(name='GTP-TEI', mode=MODE_TYPE)
    GTP_TEI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< GuaranteedBitrate >-----#
    GuaranteedBitrate = INT(name='GuaranteedBitrate', mode=MODE_TYPE)
    GuaranteedBitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16000000)], ev=None, er=[])
    
    #-----< HigherBitratesThan16MbpsFlag >-----#
    HigherBitratesThan16MbpsFlag = ENUM(name='HigherBitratesThan16MbpsFlag', mode=MODE_TYPE)
    HigherBitratesThan16MbpsFlag._cont = ASN1Dict([('allowed', 0), ('not-allowed', 1)])
    HigherBitratesThan16MbpsFlag._ext = []
    
    #-----< HS-DSCH-MAC-d-Flow-ID >-----#
    HS_DSCH_MAC_d_Flow_ID = INT(name='HS-DSCH-MAC-d-Flow-ID', mode=MODE_TYPE)
    HS_DSCH_MAC_d_Flow_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    
    #-----< IMEI >-----#
    IMEI = OCT_STR(name='IMEI', mode=MODE_TYPE)
    IMEI._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IMEIGroup >-----#
    IMEIGroup = SEQ(name='IMEIGroup', mode=MODE_TYPE)
    _IMEIGroup_iMEI = OCT_STR(name='iMEI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEI')))
    _IMEIGroup_iMEIMask = BIT_STR(name='iMEIMask', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IMEIGroup_iMEIMask._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _IMEIGroup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IMEIGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___IMEIGroup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____IMEIGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEIGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEIGroup_iE_Extensions__item__id._const_tab = ____IMEIGroup_iE_Extensions__item__id_tab
    ___IMEIGroup_iE_Extensions__item__id._const_tab_at = None
    ___IMEIGroup_iE_Extensions__item__id._const_tab_id = 'id'
    ___IMEIGroup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IMEIGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEIGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEIGroup_iE_Extensions__item__criticality._const_tab = ____IMEIGroup_iE_Extensions__item__criticality_tab
    ___IMEIGroup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IMEIGroup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IMEIGroup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IMEIGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEIGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEIGroup_iE_Extensions__item__extensionValue._const_tab = ____IMEIGroup_iE_Extensions__item__extensionValue_tab
    ___IMEIGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IMEIGroup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IMEIGroup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IMEIGroup_iE_Extensions__item__id),
        ('criticality', ___IMEIGroup_iE_Extensions__item__criticality),
        ('extensionValue', ___IMEIGroup_iE_Extensions__item__extensionValue),
        ])
    __IMEIGroup_iE_Extensions__item_._ext = None
    _IMEIGroup_iE_Extensions._cont = __IMEIGroup_iE_Extensions__item_
    _IMEIGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IMEIGroup._cont = ASN1Dict([
        ('iMEI', _IMEIGroup_iMEI),
        ('iMEIMask', _IMEIGroup_iMEIMask),
        ('iE-Extensions', _IMEIGroup_iE_Extensions),
        ])
    IMEIGroup._ext = None
    
    #-----< IMEIGroup-ExtIEs >-----#
    IMEIGroup_ExtIEs = CLASS(name='IMEIGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    IMEIGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IMEIList >-----#
    IMEIList = SEQ_OF(name='IMEIList', mode=MODE_TYPE)
    _IMEIList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IMEI')))
    IMEIList._cont = _IMEIList__item_
    IMEIList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< IMEISV >-----#
    IMEISV = OCT_STR(name='IMEISV', mode=MODE_TYPE)
    IMEISV._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< IMEISVGroup >-----#
    IMEISVGroup = SEQ(name='IMEISVGroup', mode=MODE_TYPE)
    _IMEISVGroup_iMEISV = OCT_STR(name='iMEISV', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEISV')))
    _IMEISVGroup_iMEISVMask = BIT_STR(name='iMEISVMask', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IMEISVGroup_iMEISVMask._const_sz = ASN1Set(rv=[7], rr=[], ev=None, er=[])
    _IMEISVGroup_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IMEISVGroup_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___IMEISVGroup_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____IMEISVGroup_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEISVGroup_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEISVGroup_iE_Extensions__item__id._const_tab = ____IMEISVGroup_iE_Extensions__item__id_tab
    ___IMEISVGroup_iE_Extensions__item__id._const_tab_at = None
    ___IMEISVGroup_iE_Extensions__item__id._const_tab_id = 'id'
    ___IMEISVGroup_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IMEISVGroup_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEISVGroup_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEISVGroup_iE_Extensions__item__criticality._const_tab = ____IMEISVGroup_iE_Extensions__item__criticality_tab
    ___IMEISVGroup_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IMEISVGroup_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IMEISVGroup_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IMEISVGroup_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IMEISVGroup_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IMEISVGroup_iE_Extensions__item__extensionValue._const_tab = ____IMEISVGroup_iE_Extensions__item__extensionValue_tab
    ___IMEISVGroup_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IMEISVGroup_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IMEISVGroup_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IMEISVGroup_iE_Extensions__item__id),
        ('criticality', ___IMEISVGroup_iE_Extensions__item__criticality),
        ('extensionValue', ___IMEISVGroup_iE_Extensions__item__extensionValue),
        ])
    __IMEISVGroup_iE_Extensions__item_._ext = None
    _IMEISVGroup_iE_Extensions._cont = __IMEISVGroup_iE_Extensions__item_
    _IMEISVGroup_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IMEISVGroup._cont = ASN1Dict([
        ('iMEISV', _IMEISVGroup_iMEISV),
        ('iMEISVMask', _IMEISVGroup_iMEISVMask),
        ('iE-Extensions', _IMEISVGroup_iE_Extensions),
        ])
    IMEISVGroup._ext = None
    
    #-----< IMEISVGroup-ExtIEs >-----#
    IMEISVGroup_ExtIEs = CLASS(name='IMEISVGroup-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    IMEISVGroup_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IMEISVList >-----#
    IMEISVList = SEQ_OF(name='IMEISVList', mode=MODE_TYPE)
    _IMEISVList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IMEISV')))
    IMEISVList._cont = _IMEISVList__item_
    IMEISVList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ImmediateMDT >-----#
    ImmediateMDT = SEQ(name='ImmediateMDT', mode=MODE_TYPE)
    _ImmediateMDT_measurementsToActivate = BIT_STR(name='measurementsToActivate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MeasurementsToActivate')))
    _ImmediateMDT_m1report = CHOICE(name='m1report', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M1Report')), opt=True)
    _ImmediateMDT_m2report = CHOICE(name='m2report', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M2Report')), opt=True)
    _ImmediateMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ImmediateMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ImmediateMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____ImmediateMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M4Report')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M5Report')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M6Report')))
    _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M7Report')))
    ____ImmediateMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 265), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 266), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 267), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 268), ('criticality', 'ignore'), ('Extension', _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ImmediateMDT_iE_Extensions__item__id._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__id._const_tab_at = None
    ___ImmediateMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___ImmediateMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ImmediateMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ImmediateMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab = ____ImmediateMDT_iE_Extensions__item__id_tab
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ImmediateMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ImmediateMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ImmediateMDT_iE_Extensions__item__id),
        ('criticality', ___ImmediateMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___ImmediateMDT_iE_Extensions__item__extensionValue),
        ])
    __ImmediateMDT_iE_Extensions__item_._ext = None
    _ImmediateMDT_iE_Extensions._cont = __ImmediateMDT_iE_Extensions__item_
    _ImmediateMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ImmediateMDT._cont = ASN1Dict([
        ('measurementsToActivate', _ImmediateMDT_measurementsToActivate),
        ('m1report', _ImmediateMDT_m1report),
        ('m2report', _ImmediateMDT_m2report),
        ('iE-Extensions', _ImmediateMDT_iE_Extensions),
        ])
    ImmediateMDT._ext = ['iE-Extensions']
    
    #-----< ImmediateMDT-ExtIEs >-----#
    ImmediateMDT_ExtIEs = CLASS(name='ImmediateMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ImmediateMDT_ExtIEs_val_Extension_0 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M4Report')))
    _ImmediateMDT_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M5Report')))
    _ImmediateMDT_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M6Report')))
    _ImmediateMDT_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'M7Report')))
    ImmediateMDT_ExtIEs._val = ASN1Set(rv=[dict([('id', 265), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 266), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 267), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 268), ('criticality', 'ignore'), ('Extension', _ImmediateMDT_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< IMSI >-----#
    IMSI = OCT_STR(name='IMSI', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TBCD-STRING')))
    IMSI._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=8)], ev=None, er=[])
    
    #-----< IncludeVelocity >-----#
    IncludeVelocity = ENUM(name='IncludeVelocity', mode=MODE_TYPE)
    IncludeVelocity._cont = ASN1Dict([('requested', 0)])
    IncludeVelocity._ext = None
    
    #-----< InformationExchangeID >-----#
    InformationExchangeID = INT(name='InformationExchangeID', mode=MODE_TYPE)
    InformationExchangeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< InformationExchangeType >-----#
    InformationExchangeType = ENUM(name='InformationExchangeType', mode=MODE_TYPE)
    InformationExchangeType._cont = ASN1Dict([('transfer', 0), ('request', 1)])
    InformationExchangeType._ext = []
    
    #-----< InformationRequested >-----#
    InformationRequested = CHOICE(name='InformationRequested', mode=MODE_TYPE)
    _InformationRequested_requestedMBMSIPMulticastAddressandAPNRequest = SEQ_OF(name='requestedMBMSIPMulticastAddressandAPNRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RequestedMBMSIPMulticastAddressandAPNRequest')))
    _InformationRequested_requestedMulticastServiceList = SEQ_OF(name='requestedMulticastServiceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RequestedMulticastServiceList')))
    InformationRequested._cont = ASN1Dict([
        ('requestedMBMSIPMulticastAddressandAPNRequest', _InformationRequested_requestedMBMSIPMulticastAddressandAPNRequest),
        ('requestedMulticastServiceList', _InformationRequested_requestedMulticastServiceList),
        ])
    InformationRequested._ext = []
    
    #-----< InformationRequestType >-----#
    InformationRequestType = CHOICE(name='InformationRequestType', mode=MODE_TYPE)
    _InformationRequestType_mBMSIPMulticastAddressandAPNRequest = SEQ_OF(name='mBMSIPMulticastAddressandAPNRequest', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MBMSIPMulticastAddressandAPNRequest')))
    _InformationRequestType_permanentNAS_UE_ID = CHOICE(name='permanentNAS-UE-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    InformationRequestType._cont = ASN1Dict([
        ('mBMSIPMulticastAddressandAPNRequest', _InformationRequestType_mBMSIPMulticastAddressandAPNRequest),
        ('permanentNAS-UE-ID', _InformationRequestType_permanentNAS_UE_ID),
        ])
    InformationRequestType._ext = []
    
    #-----< InformationTransferID >-----#
    InformationTransferID = INT(name='InformationTransferID', mode=MODE_TYPE)
    InformationTransferID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< InformationTransferType >-----#
    InformationTransferType = CHOICE(name='InformationTransferType', mode=MODE_TYPE)
    _InformationTransferType_rNCTraceInformation = SEQ(name='rNCTraceInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RNCTraceInformation')))
    InformationTransferType._cont = ASN1Dict([
        ('rNCTraceInformation', _InformationTransferType_rNCTraceInformation),
        ])
    InformationTransferType._ext = []
    
    #-----< IntegrityProtectionAlgorithm >-----#
    IntegrityProtectionAlgorithm = INT(name='IntegrityProtectionAlgorithm', mode=MODE_TYPE)
    IntegrityProtectionAlgorithm._cont = ASN1Dict([('standard-UMTS-integrity-algorithm-UIA1', 0), ('standard-UMTS-integrity-algorithm-UIA2', 1), ('no-value', 15)])
    IntegrityProtectionAlgorithm._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< IntegrityProtectionInformation >-----#
    IntegrityProtectionInformation = SEQ(name='IntegrityProtectionInformation', mode=MODE_TYPE)
    _IntegrityProtectionInformation_permittedAlgorithms = SEQ_OF(name='permittedAlgorithms', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PermittedIntegrityProtectionAlgorithms')))
    _IntegrityProtectionInformation_key = BIT_STR(name='key', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionKey')))
    _IntegrityProtectionInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IntegrityProtectionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___IntegrityProtectionInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____IntegrityProtectionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IntegrityProtectionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntegrityProtectionInformation_iE_Extensions__item__id._const_tab = ____IntegrityProtectionInformation_iE_Extensions__item__id_tab
    ___IntegrityProtectionInformation_iE_Extensions__item__id._const_tab_at = None
    ___IntegrityProtectionInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___IntegrityProtectionInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IntegrityProtectionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IntegrityProtectionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntegrityProtectionInformation_iE_Extensions__item__criticality._const_tab = ____IntegrityProtectionInformation_iE_Extensions__item__criticality_tab
    ___IntegrityProtectionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IntegrityProtectionInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IntegrityProtectionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IntegrityProtectionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue._const_tab = ____IntegrityProtectionInformation_iE_Extensions__item__extensionValue_tab
    ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IntegrityProtectionInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IntegrityProtectionInformation_iE_Extensions__item__id),
        ('criticality', ___IntegrityProtectionInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue),
        ])
    __IntegrityProtectionInformation_iE_Extensions__item_._ext = None
    _IntegrityProtectionInformation_iE_Extensions._cont = __IntegrityProtectionInformation_iE_Extensions__item_
    _IntegrityProtectionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IntegrityProtectionInformation._cont = ASN1Dict([
        ('permittedAlgorithms', _IntegrityProtectionInformation_permittedAlgorithms),
        ('key', _IntegrityProtectionInformation_key),
        ('iE-Extensions', _IntegrityProtectionInformation_iE_Extensions),
        ])
    IntegrityProtectionInformation._ext = None
    
    #-----< IntegrityProtectionInformation-ExtIEs >-----#
    IntegrityProtectionInformation_ExtIEs = CLASS(name='IntegrityProtectionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    IntegrityProtectionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IntegrityProtectionKey >-----#
    IntegrityProtectionKey = BIT_STR(name='IntegrityProtectionKey', mode=MODE_TYPE)
    IntegrityProtectionKey._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    #-----< InterSystemInformationTransferType >-----#
    InterSystemInformationTransferType = CHOICE(name='InterSystemInformationTransferType', mode=MODE_TYPE)
    _InterSystemInformationTransferType_rIM_Transfer = SEQ(name='rIM-Transfer', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RIM-Transfer')))
    InterSystemInformationTransferType._cont = ASN1Dict([
        ('rIM-Transfer', _InterSystemInformationTransferType_rIM_Transfer),
        ])
    InterSystemInformationTransferType._ext = []
    
    #-----< InterSystemInformation-TransparentContainer >-----#
    InterSystemInformation_TransparentContainer = SEQ(name='InterSystemInformation-TransparentContainer', mode=MODE_TYPE)
    _InterSystemInformation_TransparentContainer_downlinkCellLoadInformation = SEQ(name='downlinkCellLoadInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformation')), opt=True)
    _InterSystemInformation_TransparentContainer_uplinkCellLoadInformation = SEQ(name='uplinkCellLoadInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformation')), opt=True)
    _InterSystemInformation_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterSystemInformation_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id._const_tab = ____InterSystemInformation_TransparentContainer_iE_Extensions__item__id_tab
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality_tab
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue_tab
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InterSystemInformation_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __InterSystemInformation_TransparentContainer_iE_Extensions__item_._ext = None
    _InterSystemInformation_TransparentContainer_iE_Extensions._cont = __InterSystemInformation_TransparentContainer_iE_Extensions__item_
    _InterSystemInformation_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterSystemInformation_TransparentContainer._cont = ASN1Dict([
        ('downlinkCellLoadInformation', _InterSystemInformation_TransparentContainer_downlinkCellLoadInformation),
        ('uplinkCellLoadInformation', _InterSystemInformation_TransparentContainer_uplinkCellLoadInformation),
        ('iE-Extensions', _InterSystemInformation_TransparentContainer_iE_Extensions),
        ])
    InterSystemInformation_TransparentContainer._ext = []
    
    #-----< InterSystemInformation-TransparentContainer-ExtIEs >-----#
    InterSystemInformation_TransparentContainer_ExtIEs = CLASS(name='InterSystemInformation-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    InterSystemInformation_TransparentContainer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< IPMulticastAddress >-----#
    IPMulticastAddress = OCT_STR(name='IPMulticastAddress', mode=MODE_TYPE)
    IPMulticastAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=4, ub=16)], ev=None, er=[])
    
    #-----< IuSignallingConnectionIdentifier >-----#
    IuSignallingConnectionIdentifier = BIT_STR(name='IuSignallingConnectionIdentifier', mode=MODE_TYPE)
    IuSignallingConnectionIdentifier._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    
    #-----< IuTransportAssociation >-----#
    IuTransportAssociation = CHOICE(name='IuTransportAssociation', mode=MODE_TYPE)
    _IuTransportAssociation_gTP_TEI = OCT_STR(name='gTP-TEI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GTP-TEI')))
    _IuTransportAssociation_bindingID = OCT_STR(name='bindingID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'BindingID')))
    IuTransportAssociation._cont = ASN1Dict([
        ('gTP-TEI', _IuTransportAssociation_gTP_TEI),
        ('bindingID', _IuTransportAssociation_bindingID),
        ])
    IuTransportAssociation._ext = []
    
    #-----< KeyStatus >-----#
    KeyStatus = ENUM(name='KeyStatus', mode=MODE_TYPE)
    KeyStatus._cont = ASN1Dict([('old', 0), ('new', 1)])
    KeyStatus._ext = []
    
    #-----< LA-LIST >-----#
    LA_LIST = SEQ_OF(name='LA-LIST', mode=MODE_TYPE)
    _LA_LIST__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __LA_LIST__item__lAC = OCT_STR(name='lAC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAC')))
    __LA_LIST__item__listOF_SNAs = SEQ_OF(name='listOF-SNAs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ListOF-SNAs')))
    __LA_LIST__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___LA_LIST__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____LA_LIST__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____LA_LIST__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LA_LIST__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LA_LIST__item__iE_Extensions__item__id._const_tab = _____LA_LIST__item__iE_Extensions__item__id_tab
    ____LA_LIST__item__iE_Extensions__item__id._const_tab_at = None
    ____LA_LIST__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____LA_LIST__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____LA_LIST__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LA_LIST__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LA_LIST__item__iE_Extensions__item__criticality._const_tab = _____LA_LIST__item__iE_Extensions__item__criticality_tab
    ____LA_LIST__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____LA_LIST__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____LA_LIST__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____LA_LIST__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LA_LIST__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LA_LIST__item__iE_Extensions__item__extensionValue._const_tab = _____LA_LIST__item__iE_Extensions__item__extensionValue_tab
    ____LA_LIST__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____LA_LIST__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___LA_LIST__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____LA_LIST__item__iE_Extensions__item__id),
        ('criticality', ____LA_LIST__item__iE_Extensions__item__criticality),
        ('extensionValue', ____LA_LIST__item__iE_Extensions__item__extensionValue),
        ])
    ___LA_LIST__item__iE_Extensions__item_._ext = None
    __LA_LIST__item__iE_Extensions._cont = ___LA_LIST__item__iE_Extensions__item_
    __LA_LIST__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _LA_LIST__item_._cont = ASN1Dict([
        ('lAC', __LA_LIST__item__lAC),
        ('listOF-SNAs', __LA_LIST__item__listOF_SNAs),
        ('iE-Extensions', __LA_LIST__item__iE_Extensions),
        ])
    _LA_LIST__item_._ext = []
    LA_LIST._cont = _LA_LIST__item_
    LA_LIST._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< LA-LIST-ExtIEs >-----#
    LA_LIST_ExtIEs = CLASS(name='LA-LIST-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LA_LIST_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LAC >-----#
    LAC = OCT_STR(name='LAC', mode=MODE_TYPE)
    LAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< LAI >-----#
    LAI = SEQ(name='LAI', mode=MODE_TYPE)
    _LAI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _LAI_lAC = OCT_STR(name='lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAC')))
    _LAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LAI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__id._const_tab = ____LAI_iE_Extensions__item__id_tab
    ___LAI_iE_Extensions__item__id._const_tab_at = None
    ___LAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___LAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__criticality._const_tab = ____LAI_iE_Extensions__item__criticality_tab
    ___LAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LAI_iE_Extensions__item__extensionValue._const_tab = ____LAI_iE_Extensions__item__extensionValue_tab
    ___LAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LAI_iE_Extensions__item__id),
        ('criticality', ___LAI_iE_Extensions__item__criticality),
        ('extensionValue', ___LAI_iE_Extensions__item__extensionValue),
        ])
    __LAI_iE_Extensions__item_._ext = None
    _LAI_iE_Extensions._cont = __LAI_iE_Extensions__item_
    _LAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LAI._cont = ASN1Dict([
        ('pLMNidentity', _LAI_pLMNidentity),
        ('lAC', _LAI_lAC),
        ('iE-Extensions', _LAI_iE_Extensions),
        ])
    LAI._ext = None
    
    #-----< LAI-ExtIEs >-----#
    LAI_ExtIEs = CLASS(name='LAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastKnownServiceArea >-----#
    LastKnownServiceArea = SEQ(name='LastKnownServiceArea', mode=MODE_TYPE)
    _LastKnownServiceArea_sAI = SEQ(name='sAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _LastKnownServiceArea_ageOfSAI = INT(name='ageOfSAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LastKnownServiceArea_ageOfSAI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _LastKnownServiceArea_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastKnownServiceArea_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LastKnownServiceArea_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LastKnownServiceArea_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LastKnownServiceArea_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastKnownServiceArea_iE_Extensions__item__id._const_tab = ____LastKnownServiceArea_iE_Extensions__item__id_tab
    ___LastKnownServiceArea_iE_Extensions__item__id._const_tab_at = None
    ___LastKnownServiceArea_iE_Extensions__item__id._const_tab_id = 'id'
    ___LastKnownServiceArea_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LastKnownServiceArea_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LastKnownServiceArea_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastKnownServiceArea_iE_Extensions__item__criticality._const_tab = ____LastKnownServiceArea_iE_Extensions__item__criticality_tab
    ___LastKnownServiceArea_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LastKnownServiceArea_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LastKnownServiceArea_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LastKnownServiceArea_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LastKnownServiceArea_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LastKnownServiceArea_iE_Extensions__item__extensionValue._const_tab = ____LastKnownServiceArea_iE_Extensions__item__extensionValue_tab
    ___LastKnownServiceArea_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LastKnownServiceArea_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LastKnownServiceArea_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LastKnownServiceArea_iE_Extensions__item__id),
        ('criticality', ___LastKnownServiceArea_iE_Extensions__item__criticality),
        ('extensionValue', ___LastKnownServiceArea_iE_Extensions__item__extensionValue),
        ])
    __LastKnownServiceArea_iE_Extensions__item_._ext = None
    _LastKnownServiceArea_iE_Extensions._cont = __LastKnownServiceArea_iE_Extensions__item_
    _LastKnownServiceArea_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastKnownServiceArea._cont = ASN1Dict([
        ('sAI', _LastKnownServiceArea_sAI),
        ('ageOfSAI', _LastKnownServiceArea_ageOfSAI),
        ('iE-Extensions', _LastKnownServiceArea_iE_Extensions),
        ])
    LastKnownServiceArea._ext = []
    
    #-----< LastKnownServiceArea-ExtIEs >-----#
    LastKnownServiceArea_ExtIEs = CLASS(name='LastKnownServiceArea-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LastKnownServiceArea_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LastVisitedUTRANCell-Item >-----#
    LastVisitedUTRANCell_Item = SEQ(name='LastVisitedUTRANCell-Item', mode=MODE_TYPE)
    _LastVisitedUTRANCell_Item_uTRAN_CellID = SEQ(name='uTRAN-CellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UTRAN-CellID')))
    _LastVisitedUTRANCell_Item_cellType = ENUM(name='cellType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellType')))
    _LastVisitedUTRANCell_Item_time_UE_StayedInCell = INT(name='time-UE-StayedInCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Time-UE-StayedInCell')))
    _LastVisitedUTRANCell_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LastVisitedUTRANCell_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 253), ('criticality', 'ignore'), ('Extension', _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Extension', _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__id._const_tab = ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__id._const_tab_at = None
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality._const_tab = ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue._const_tab = ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LastVisitedUTRANCell_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LastVisitedUTRANCell_Item_iE_Extensions__item__id),
        ('criticality', ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue),
        ])
    __LastVisitedUTRANCell_Item_iE_Extensions__item_._ext = None
    _LastVisitedUTRANCell_Item_iE_Extensions._cont = __LastVisitedUTRANCell_Item_iE_Extensions__item_
    _LastVisitedUTRANCell_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LastVisitedUTRANCell_Item._cont = ASN1Dict([
        ('uTRAN-CellID', _LastVisitedUTRANCell_Item_uTRAN_CellID),
        ('cellType', _LastVisitedUTRANCell_Item_cellType),
        ('time-UE-StayedInCell', _LastVisitedUTRANCell_Item_time_UE_StayedInCell),
        ('iE-Extensions', _LastVisitedUTRANCell_Item_iE_Extensions),
        ])
    LastVisitedUTRANCell_Item._ext = []
    
    #-----< LastVisitedUTRANCell-Item-ExtIEs >-----#
    LastVisitedUTRANCell_Item_ExtIEs = CLASS(name='LastVisitedUTRANCell-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Time-UE-StayedInCell-EnhancedGranularity')))
    _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    LastVisitedUTRANCell_Item_ExtIEs._val = ASN1Set(rv=[dict([('id', 253), ('criticality', 'ignore'), ('Extension', _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 257), ('criticality', 'ignore'), ('Extension', _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LHN-ID >-----#
    LHN_ID = OCT_STR(name='LHN-ID', mode=MODE_TYPE)
    LHN_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=32, ub=256)], ev=None, er=[])
    
    #-----< Links-to-log >-----#
    Links_to_log = ENUM(name='Links-to-log', mode=MODE_TYPE)
    Links_to_log._cont = ASN1Dict([('uplink', 0), ('downlink', 1), ('both-uplink-and-downlink', 2)])
    Links_to_log._ext = []
    
    #-----< ListOF-SNAs >-----#
    ListOF_SNAs = SEQ_OF(name='ListOF-SNAs', mode=MODE_TYPE)
    _ListOF_SNAs__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNAC')))
    ListOF_SNAs._cont = _ListOF_SNAs__item_
    ListOF_SNAs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< ListOfInterfacesToTrace >-----#
    ListOfInterfacesToTrace = SEQ_OF(name='ListOfInterfacesToTrace', mode=MODE_TYPE)
    _ListOfInterfacesToTrace__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterfacesToTraceItem')))
    ListOfInterfacesToTrace._cont = _ListOfInterfacesToTrace__item_
    ListOfInterfacesToTrace._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< InterfacesToTraceItem >-----#
    InterfacesToTraceItem = SEQ(name='InterfacesToTraceItem', mode=MODE_TYPE)
    _InterfacesToTraceItem_interface = ENUM(name='interface', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _InterfacesToTraceItem_interface._cont = ASN1Dict([('iu-cs', 0), ('iu-ps', 1), ('iur', 2), ('iub', 3), ('uu', 4)])
    _InterfacesToTraceItem_interface._ext = []
    _InterfacesToTraceItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InterfacesToTraceItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InterfacesToTraceItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____InterfacesToTraceItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterfacesToTraceItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterfacesToTraceItem_iE_Extensions__item__id._const_tab = ____InterfacesToTraceItem_iE_Extensions__item__id_tab
    ___InterfacesToTraceItem_iE_Extensions__item__id._const_tab_at = None
    ___InterfacesToTraceItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___InterfacesToTraceItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterfacesToTraceItem_iE_Extensions__item__criticality._const_tab = ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab
    ___InterfacesToTraceItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___InterfacesToTraceItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue._const_tab = ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InterfacesToTraceItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __InterfacesToTraceItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___InterfacesToTraceItem_iE_Extensions__item__id),
        ('criticality', ___InterfacesToTraceItem_iE_Extensions__item__criticality),
        ('extensionValue', ___InterfacesToTraceItem_iE_Extensions__item__extensionValue),
        ])
    __InterfacesToTraceItem_iE_Extensions__item_._ext = None
    _InterfacesToTraceItem_iE_Extensions._cont = __InterfacesToTraceItem_iE_Extensions__item_
    _InterfacesToTraceItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InterfacesToTraceItem._cont = ASN1Dict([
        ('interface', _InterfacesToTraceItem_interface),
        ('iE-Extensions', _InterfacesToTraceItem_iE_Extensions),
        ])
    InterfacesToTraceItem._ext = []
    
    #-----< InterfacesToTraceItem-ExtIEs >-----#
    InterfacesToTraceItem_ExtIEs = CLASS(name='InterfacesToTraceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    InterfacesToTraceItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LoadValue >-----#
    LoadValue = INT(name='LoadValue', mode=MODE_TYPE)
    LoadValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< LocationRelatedDataRequestType >-----#
    LocationRelatedDataRequestType = SEQ(name='LocationRelatedDataRequestType', mode=MODE_TYPE)
    _LocationRelatedDataRequestType_requestedLocationRelatedDataType = ENUM(name='requestedLocationRelatedDataType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RequestedLocationRelatedDataType')))
    _LocationRelatedDataRequestType_requestedGPSAssistanceData = OCT_STR(name='requestedGPSAssistanceData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RequestedGPSAssistanceData')), opt=True)
    LocationRelatedDataRequestType._cont = ASN1Dict([
        ('requestedLocationRelatedDataType', _LocationRelatedDataRequestType_requestedLocationRelatedDataType),
        ('requestedGPSAssistanceData', _LocationRelatedDataRequestType_requestedGPSAssistanceData),
        ])
    LocationRelatedDataRequestType._ext = []
    
    #-----< LocationRelatedDataRequestTypeSpecificToGERANIuMode >-----#
    LocationRelatedDataRequestTypeSpecificToGERANIuMode = ENUM(name='LocationRelatedDataRequestTypeSpecificToGERANIuMode', mode=MODE_TYPE)
    LocationRelatedDataRequestTypeSpecificToGERANIuMode._cont = ASN1Dict([('decipheringKeysEOTD', 0), ('dedicatedMobileAssistedEOTDAssistanceData', 1), ('dedicatedMobileBasedEOTDAssistanceData', 2)])
    LocationRelatedDataRequestTypeSpecificToGERANIuMode._ext = []
    
    #-----< LocationReportingTransferInformation >-----#
    LocationReportingTransferInformation = SEQ(name='LocationReportingTransferInformation', mode=MODE_TYPE)
    _LocationReportingTransferInformation_reportChangeOfSAI = ENUM(name='reportChangeOfSAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ReportChangeOfSAI')), opt=True)
    _LocationReportingTransferInformation_periodicReportingIndicator = ENUM(name='periodicReportingIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PeriodicReportingIndicator')), opt=True)
    _LocationReportingTransferInformation_directReportingIndicator = ENUM(name='directReportingIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DirectReportingIndicator')), opt=True)
    _LocationReportingTransferInformation_verticalAccuracyCode = INT(name='verticalAccuracyCode', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'VerticalAccuracyCode')), opt=True)
    _LocationReportingTransferInformation_positioningPriorityChangeSAI = ENUM(name='positioningPriorityChangeSAI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PositioningPriority')), opt=True)
    _LocationReportingTransferInformation_positioningPriorityDirect = ENUM(name='positioningPriorityDirect', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PositioningPriority')), opt=True)
    _LocationReportingTransferInformation_clientTypePeriodic = ENUM(name='clientTypePeriodic', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ClientType')), opt=True)
    _LocationReportingTransferInformation_clientTypeDirect = ENUM(name='clientTypeDirect', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ClientType')), opt=True)
    _LocationReportingTransferInformation_responseTime = ENUM(name='responseTime', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ResponseTime')), opt=True)
    _LocationReportingTransferInformation_includeVelocity = ENUM(name='includeVelocity', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IncludeVelocity')), opt=True)
    _LocationReportingTransferInformation_periodicLocationInfo = SEQ(name='periodicLocationInfo', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PeriodicLocationInfo')), opt=True)
    _LocationReportingTransferInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationReportingTransferInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationReportingTransferInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationReportingTransferInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LocationReportingTransferInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationReportingTransferInformation_iE_Extensions__item__id._const_tab = ____LocationReportingTransferInformation_iE_Extensions__item__id_tab
    ___LocationReportingTransferInformation_iE_Extensions__item__id._const_tab_at = None
    ___LocationReportingTransferInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___LocationReportingTransferInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LocationReportingTransferInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LocationReportingTransferInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationReportingTransferInformation_iE_Extensions__item__criticality._const_tab = ____LocationReportingTransferInformation_iE_Extensions__item__criticality_tab
    ___LocationReportingTransferInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReportingTransferInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LocationReportingTransferInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LocationReportingTransferInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue._const_tab = ____LocationReportingTransferInformation_iE_Extensions__item__extensionValue_tab
    ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationReportingTransferInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LocationReportingTransferInformation_iE_Extensions__item__id),
        ('criticality', ___LocationReportingTransferInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue),
        ])
    __LocationReportingTransferInformation_iE_Extensions__item_._ext = None
    _LocationReportingTransferInformation_iE_Extensions._cont = __LocationReportingTransferInformation_iE_Extensions__item_
    _LocationReportingTransferInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationReportingTransferInformation._cont = ASN1Dict([
        ('reportChangeOfSAI', _LocationReportingTransferInformation_reportChangeOfSAI),
        ('periodicReportingIndicator', _LocationReportingTransferInformation_periodicReportingIndicator),
        ('directReportingIndicator', _LocationReportingTransferInformation_directReportingIndicator),
        ('verticalAccuracyCode', _LocationReportingTransferInformation_verticalAccuracyCode),
        ('positioningPriorityChangeSAI', _LocationReportingTransferInformation_positioningPriorityChangeSAI),
        ('positioningPriorityDirect', _LocationReportingTransferInformation_positioningPriorityDirect),
        ('clientTypePeriodic', _LocationReportingTransferInformation_clientTypePeriodic),
        ('clientTypeDirect', _LocationReportingTransferInformation_clientTypeDirect),
        ('responseTime', _LocationReportingTransferInformation_responseTime),
        ('includeVelocity', _LocationReportingTransferInformation_includeVelocity),
        ('periodicLocationInfo', _LocationReportingTransferInformation_periodicLocationInfo),
        ('iE-Extensions', _LocationReportingTransferInformation_iE_Extensions),
        ])
    LocationReportingTransferInformation._ext = []
    
    #-----< LocationReportingTransferInformation-ExtIEs >-----#
    LocationReportingTransferInformation_ExtIEs = CLASS(name='LocationReportingTransferInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LocationReportingTransferInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ReportChangeOfSAI >-----#
    ReportChangeOfSAI = ENUM(name='ReportChangeOfSAI', mode=MODE_TYPE)
    ReportChangeOfSAI._cont = ASN1Dict([('requested', 0)])
    ReportChangeOfSAI._ext = []
    
    #-----< PeriodicReportingIndicator >-----#
    PeriodicReportingIndicator = ENUM(name='PeriodicReportingIndicator', mode=MODE_TYPE)
    PeriodicReportingIndicator._cont = ASN1Dict([('periodicSAI', 0), ('periodicGeo', 1)])
    PeriodicReportingIndicator._ext = []
    
    #-----< DirectReportingIndicator >-----#
    DirectReportingIndicator = ENUM(name='DirectReportingIndicator', mode=MODE_TYPE)
    DirectReportingIndicator._cont = ASN1Dict([('directSAI', 0), ('directGeo', 1)])
    DirectReportingIndicator._ext = []
    
    #-----< L3-Information >-----#
    L3_Information = OCT_STR(name='L3-Information', mode=MODE_TYPE)
    
    #-----< M1Report >-----#
    M1Report = CHOICE(name='M1Report', mode=MODE_TYPE)
    _M1Report_periodic = SEQ(name='periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MDT-Report-Parameters')))
    _M1Report_event1F = SEQ(name='event1F', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Event1F-Parameters')))
    M1Report._cont = ASN1Dict([
        ('periodic', _M1Report_periodic),
        ('event1F', _M1Report_event1F),
        ])
    M1Report._ext = []
    
    #-----< M2Report >-----#
    M2Report = CHOICE(name='M2Report', mode=MODE_TYPE)
    _M2Report_periodic = SEQ(name='periodic', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MDT-Report-Parameters')))
    _M2Report_event1I = SEQ(name='event1I', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Event1I-Parameters')))
    M2Report._cont = ASN1Dict([
        ('periodic', _M2Report_periodic),
        ('event1I', _M2Report_event1I),
        ])
    M2Report._ext = []
    
    #-----< M4Report >-----#
    M4Report = CHOICE(name='M4Report', mode=MODE_TYPE)
    _M4Report_all = NULL(name='all', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _M4Report_m4_collection_parameters = SEQ(name='m4-collection-parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M4-Collection-Parameters')))
    M4Report._cont = ASN1Dict([
        ('all', _M4Report_all),
        ('m4-collection-parameters', _M4Report_m4_collection_parameters),
        ])
    M4Report._ext = []
    
    #-----< M4-Collection-Parameters >-----#
    M4_Collection_Parameters = SEQ(name='M4-Collection-Parameters', mode=MODE_TYPE)
    _M4_Collection_Parameters_m4_period = ENUM(name='m4-period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M4-Period')))
    _M4_Collection_Parameters_m4_threshold = INT(name='m4-threshold', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M4-Threshold')), opt=True)
    _M4_Collection_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M4_Collection_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___M4_Collection_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____M4_Collection_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M4_Collection_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4_Collection_Parameters_iE_Extensions__item__id._const_tab = ____M4_Collection_Parameters_iE_Extensions__item__id_tab
    ___M4_Collection_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___M4_Collection_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___M4_Collection_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M4_Collection_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M4_Collection_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4_Collection_Parameters_iE_Extensions__item__criticality._const_tab = ____M4_Collection_Parameters_iE_Extensions__item__criticality_tab
    ___M4_Collection_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M4_Collection_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M4_Collection_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M4_Collection_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M4_Collection_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M4_Collection_Parameters_iE_Extensions__item__extensionValue._const_tab = ____M4_Collection_Parameters_iE_Extensions__item__extensionValue_tab
    ___M4_Collection_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M4_Collection_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M4_Collection_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M4_Collection_Parameters_iE_Extensions__item__id),
        ('criticality', ___M4_Collection_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___M4_Collection_Parameters_iE_Extensions__item__extensionValue),
        ])
    __M4_Collection_Parameters_iE_Extensions__item_._ext = None
    _M4_Collection_Parameters_iE_Extensions._cont = __M4_Collection_Parameters_iE_Extensions__item_
    _M4_Collection_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M4_Collection_Parameters._cont = ASN1Dict([
        ('m4-period', _M4_Collection_Parameters_m4_period),
        ('m4-threshold', _M4_Collection_Parameters_m4_threshold),
        ('iE-Extensions', _M4_Collection_Parameters_iE_Extensions),
        ])
    M4_Collection_Parameters._ext = []
    
    #-----< M4-Collection-Parameters-ExtIEs >-----#
    M4_Collection_Parameters_ExtIEs = CLASS(name='M4-Collection-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    M4_Collection_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M4-Period >-----#
    M4_Period = ENUM(name='M4-Period', mode=MODE_TYPE)
    M4_Period._cont = ASN1Dict([('ms100', 0), ('ms250', 1), ('ms500', 2), ('ms1000', 3), ('ms2000', 4), ('ms3000', 5), ('ms4000', 6), ('ms6000', 7)])
    M4_Period._ext = []
    
    #-----< M4-Threshold >-----#
    M4_Threshold = INT(name='M4-Threshold', mode=MODE_TYPE)
    M4_Threshold._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    
    #-----< M5Report >-----#
    M5Report = CHOICE(name='M5Report', mode=MODE_TYPE)
    _M5Report_when_available = NULL(name='when-available', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _M5Report_m5_period = ENUM(name='m5-period', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M5-Period')))
    M5Report._cont = ASN1Dict([
        ('when-available', _M5Report_when_available),
        ('m5-period', _M5Report_m5_period),
        ])
    M5Report._ext = []
    
    #-----< M5-Period >-----#
    M5_Period = ENUM(name='M5-Period', mode=MODE_TYPE)
    M5_Period._cont = ASN1Dict([('ms100', 0), ('ms250', 1), ('ms500', 2), ('ms1000', 3), ('ms2000', 4), ('ms3000', 5), ('ms4000', 6), ('ms6000', 7)])
    M5_Period._ext = []
    
    #-----< M6Report >-----#
    M6Report = SEQ(name='M6Report', mode=MODE_TYPE)
    _M6Report_m6_period = ENUM(name='m6-period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M6-Period')))
    _M6Report_m6_links_to_log = ENUM(name='m6-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Links-to-log')))
    _M6Report_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M6Report_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___M6Report_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____M6Report_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M6Report_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Report_iE_Extensions__item__id._const_tab = ____M6Report_iE_Extensions__item__id_tab
    ___M6Report_iE_Extensions__item__id._const_tab_at = None
    ___M6Report_iE_Extensions__item__id._const_tab_id = 'id'
    ___M6Report_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M6Report_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M6Report_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Report_iE_Extensions__item__criticality._const_tab = ____M6Report_iE_Extensions__item__criticality_tab
    ___M6Report_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M6Report_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M6Report_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M6Report_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M6Report_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M6Report_iE_Extensions__item__extensionValue._const_tab = ____M6Report_iE_Extensions__item__extensionValue_tab
    ___M6Report_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M6Report_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M6Report_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M6Report_iE_Extensions__item__id),
        ('criticality', ___M6Report_iE_Extensions__item__criticality),
        ('extensionValue', ___M6Report_iE_Extensions__item__extensionValue),
        ])
    __M6Report_iE_Extensions__item_._ext = None
    _M6Report_iE_Extensions._cont = __M6Report_iE_Extensions__item_
    _M6Report_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M6Report._cont = ASN1Dict([
        ('m6-period', _M6Report_m6_period),
        ('m6-links-to-log', _M6Report_m6_links_to_log),
        ('iE-Extensions', _M6Report_iE_Extensions),
        ])
    M6Report._ext = []
    
    #-----< M6Report-ExtIEs >-----#
    M6Report_ExtIEs = CLASS(name='M6Report-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    M6Report_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M6-Period >-----#
    M6_Period = ENUM(name='M6-Period', mode=MODE_TYPE)
    M6_Period._cont = ASN1Dict([('ms1000', 0), ('ms2000', 1), ('ms3000', 2), ('ms4000', 3), ('ms6000', 4), ('ms8000', 5), ('ms12000', 6), ('ms16000', 7), ('ms20000', 8), ('ms24000', 9), ('ms28000', 10), ('ms32000', 11), ('ms64000', 12)])
    M6_Period._ext = []
    
    #-----< M7Report >-----#
    M7Report = SEQ(name='M7Report', mode=MODE_TYPE)
    _M7Report_m7_period = ENUM(name='m7-period', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'M7-Period')))
    _M7Report_m7_links_to_log = ENUM(name='m7-links-to-log', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Links-to-log')))
    _M7Report_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __M7Report_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___M7Report_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____M7Report_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M7Report_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Report_iE_Extensions__item__id._const_tab = ____M7Report_iE_Extensions__item__id_tab
    ___M7Report_iE_Extensions__item__id._const_tab_at = None
    ___M7Report_iE_Extensions__item__id._const_tab_id = 'id'
    ___M7Report_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____M7Report_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M7Report_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Report_iE_Extensions__item__criticality._const_tab = ____M7Report_iE_Extensions__item__criticality_tab
    ___M7Report_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___M7Report_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___M7Report_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____M7Report_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____M7Report_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___M7Report_iE_Extensions__item__extensionValue._const_tab = ____M7Report_iE_Extensions__item__extensionValue_tab
    ___M7Report_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___M7Report_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __M7Report_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___M7Report_iE_Extensions__item__id),
        ('criticality', ___M7Report_iE_Extensions__item__criticality),
        ('extensionValue', ___M7Report_iE_Extensions__item__extensionValue),
        ])
    __M7Report_iE_Extensions__item_._ext = None
    _M7Report_iE_Extensions._cont = __M7Report_iE_Extensions__item_
    _M7Report_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    M7Report._cont = ASN1Dict([
        ('m7-period', _M7Report_m7_period),
        ('m7-links-to-log', _M7Report_m7_links_to_log),
        ('iE-Extensions', _M7Report_iE_Extensions),
        ])
    M7Report._ext = []
    
    #-----< M7Report-ExtIEs >-----#
    M7Report_ExtIEs = CLASS(name='M7Report-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    M7Report_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< M7-Period >-----#
    M7_Period = ENUM(name='M7-Period', mode=MODE_TYPE)
    M7_Period._cont = ASN1Dict([('ms1000', 0), ('ms2000', 1), ('ms3000', 2), ('ms4000', 3), ('ms6000', 4), ('ms8000', 5), ('ms12000', 6), ('ms16000', 7), ('ms20000', 8), ('ms24000', 9), ('ms28000', 10), ('ms32000', 11), ('ms64000', 12)])
    M7_Period._ext = []
    
    #-----< Management-Based-MDT-Allowed >-----#
    Management_Based_MDT_Allowed = ENUM(name='Management-Based-MDT-Allowed', mode=MODE_TYPE)
    Management_Based_MDT_Allowed._cont = ASN1Dict([('allowed', 0)])
    Management_Based_MDT_Allowed._ext = []
    
    #-----< MaxBitrate >-----#
    MaxBitrate = INT(name='MaxBitrate', mode=MODE_TYPE)
    MaxBitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16000000)], ev=None, er=[])
    
    #-----< MaxSDU-Size >-----#
    MaxSDU_Size = INT(name='MaxSDU-Size', mode=MODE_TYPE)
    MaxSDU_Size._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32768)], ev=None, er=[])
    
    #-----< MBMS-PTP-RAB-ID >-----#
    MBMS_PTP_RAB_ID = BIT_STR(name='MBMS-PTP-RAB-ID', mode=MODE_TYPE)
    MBMS_PTP_RAB_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MBMSBearerServiceType >-----#
    MBMSBearerServiceType = ENUM(name='MBMSBearerServiceType', mode=MODE_TYPE)
    MBMSBearerServiceType._cont = ASN1Dict([('multicast', 0), ('broadcast', 1)])
    MBMSBearerServiceType._ext = []
    
    #-----< MBMSCNDe-Registration >-----#
    MBMSCNDe_Registration = ENUM(name='MBMSCNDe-Registration', mode=MODE_TYPE)
    MBMSCNDe_Registration._cont = ASN1Dict([('normalsessionstop', 0), ('deregister', 1)])
    MBMSCNDe_Registration._ext = []
    
    #-----< MBMSCountingInformation >-----#
    MBMSCountingInformation = ENUM(name='MBMSCountingInformation', mode=MODE_TYPE)
    MBMSCountingInformation._cont = ASN1Dict([('counting', 0), ('notcounting', 1)])
    MBMSCountingInformation._ext = []
    
    #-----< MBMSHCIndicator >-----#
    MBMSHCIndicator = ENUM(name='MBMSHCIndicator', mode=MODE_TYPE)
    MBMSHCIndicator._cont = ASN1Dict([('uncompressed-header', 0), ('compressed-header', 1)])
    MBMSHCIndicator._ext = []
    
    #-----< MBMSIPMulticastAddressandAPNRequest >-----#
    MBMSIPMulticastAddressandAPNRequest = SEQ_OF(name='MBMSIPMulticastAddressandAPNRequest', mode=MODE_TYPE)
    _MBMSIPMulticastAddressandAPNRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    MBMSIPMulticastAddressandAPNRequest._cont = _MBMSIPMulticastAddressandAPNRequest__item_
    MBMSIPMulticastAddressandAPNRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< MBMSLinkingInformation >-----#
    MBMSLinkingInformation = ENUM(name='MBMSLinkingInformation', mode=MODE_TYPE)
    MBMSLinkingInformation._cont = ASN1Dict([('uE-has-joined-multicast-services', 0)])
    MBMSLinkingInformation._ext = []
    
    #-----< MBMSRegistrationRequestType >-----#
    MBMSRegistrationRequestType = ENUM(name='MBMSRegistrationRequestType', mode=MODE_TYPE)
    MBMSRegistrationRequestType._cont = ASN1Dict([('register', 0), ('deregister', 1)])
    MBMSRegistrationRequestType._ext = []
    
    #-----< MBMSServiceArea >-----#
    MBMSServiceArea = OCT_STR(name='MBMSServiceArea', mode=MODE_TYPE)
    
    #-----< MBMSSessionDuration >-----#
    MBMSSessionDuration = OCT_STR(name='MBMSSessionDuration', mode=MODE_TYPE)
    MBMSSessionDuration._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< MBMSSessionIdentity >-----#
    MBMSSessionIdentity = OCT_STR(name='MBMSSessionIdentity', mode=MODE_TYPE)
    MBMSSessionIdentity._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MBMSSessionRepetitionNumber >-----#
    MBMSSessionRepetitionNumber = OCT_STR(name='MBMSSessionRepetitionNumber', mode=MODE_TYPE)
    MBMSSessionRepetitionNumber._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< MDT-Activation >-----#
    MDT_Activation = ENUM(name='MDT-Activation', mode=MODE_TYPE)
    MDT_Activation._cont = ASN1Dict([('immediateMDTonly', 0), ('loggedMDTonly', 1), ('immediateMDTandTrace', 2)])
    MDT_Activation._ext = []
    
    #-----< MDTAreaScope >-----#
    MDTAreaScope = CHOICE(name='MDTAreaScope', mode=MODE_TYPE)
    _MDTAreaScope_cellbased = SEQ(name='cellbased', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CellBased')))
    _MDTAreaScope_labased = SEQ(name='labased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LABased')))
    _MDTAreaScope_rabased = SEQ(name='rabased', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RABased')))
    _MDTAreaScope_plmn_area_based = NULL(name='plmn-area-based', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    MDTAreaScope._cont = ASN1Dict([
        ('cellbased', _MDTAreaScope_cellbased),
        ('labased', _MDTAreaScope_labased),
        ('rabased', _MDTAreaScope_rabased),
        ('plmn-area-based', _MDTAreaScope_plmn_area_based),
        ])
    MDTAreaScope._ext = []
    
    #-----< MDT-Configuration >-----#
    MDT_Configuration = SEQ(name='MDT-Configuration', mode=MODE_TYPE)
    _MDT_Configuration_mdtActivation = ENUM(name='mdtActivation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MDT-Activation')))
    _MDT_Configuration_mdtAreaScope = CHOICE(name='mdtAreaScope', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MDTAreaScope')))
    _MDT_Configuration_mdtMode = CHOICE(name='mdtMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MDTMode')))
    _MDT_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MDT_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MDT_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MDT_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    ____MDT_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 264), ('criticality', 'ignore'), ('Extension', _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MDT_Configuration_iE_Extensions__item__id._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___MDT_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___MDT_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MDT_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MDT_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab = ____MDT_Configuration_iE_Extensions__item__id_tab
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MDT_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MDT_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MDT_Configuration_iE_Extensions__item__id),
        ('criticality', ___MDT_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___MDT_Configuration_iE_Extensions__item__extensionValue),
        ])
    __MDT_Configuration_iE_Extensions__item_._ext = None
    _MDT_Configuration_iE_Extensions._cont = __MDT_Configuration_iE_Extensions__item_
    _MDT_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MDT_Configuration._cont = ASN1Dict([
        ('mdtActivation', _MDT_Configuration_mdtActivation),
        ('mdtAreaScope', _MDT_Configuration_mdtAreaScope),
        ('mdtMode', _MDT_Configuration_mdtMode),
        ('iE-Extensions', _MDT_Configuration_iE_Extensions),
        ])
    MDT_Configuration._ext = []
    
    #-----< MDT-Configuration-ExtIEs >-----#
    MDT_Configuration_ExtIEs = CLASS(name='MDT-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _MDT_Configuration_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    MDT_Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 264), ('criticality', 'ignore'), ('Extension', _MDT_Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MDTMode >-----#
    MDTMode = CHOICE(name='MDTMode', mode=MODE_TYPE)
    _MDTMode_immediateMDT = SEQ(name='immediateMDT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ImmediateMDT')))
    _MDTMode_loggedMDT = SEQ(name='loggedMDT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LoggedMDT')))
    MDTMode._cont = ASN1Dict([
        ('immediateMDT', _MDTMode_immediateMDT),
        ('loggedMDT', _MDTMode_loggedMDT),
        ])
    MDTMode._ext = []
    
    #-----< MDT-PLMN-List >-----#
    MDT_PLMN_List = SEQ_OF(name='MDT-PLMN-List', mode=MODE_TYPE)
    _MDT_PLMN_List__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    MDT_PLMN_List._cont = _MDT_PLMN_List__item_
    MDT_PLMN_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< MDT-Report-Parameters >-----#
    MDT_Report_Parameters = SEQ(name='MDT-Report-Parameters', mode=MODE_TYPE)
    _MDT_Report_Parameters_reportInterval = ENUM(name='reportInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ReportInterval')))
    _MDT_Report_Parameters_reportAmount = ENUM(name='reportAmount', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ReportAmount')))
    MDT_Report_Parameters._cont = ASN1Dict([
        ('reportInterval', _MDT_Report_Parameters_reportInterval),
        ('reportAmount', _MDT_Report_Parameters_reportAmount),
        ])
    MDT_Report_Parameters._ext = []
    
    #-----< MeasurementQuantity >-----#
    MeasurementQuantity = ENUM(name='MeasurementQuantity', mode=MODE_TYPE)
    MeasurementQuantity._cont = ASN1Dict([('cpichEcNo', 0), ('cpichRSCP', 1), ('pathloss', 2)])
    MeasurementQuantity._ext = []
    
    #-----< MeasurementsToActivate >-----#
    MeasurementsToActivate = BIT_STR(name='MeasurementsToActivate', mode=MODE_TYPE)
    MeasurementsToActivate._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< MSISDN >-----#
    MSISDN = OCT_STR(name='MSISDN', mode=MODE_TYPE)
    MSISDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< NAS-PDU >-----#
    NAS_PDU = OCT_STR(name='NAS-PDU', mode=MODE_TYPE)
    
    #-----< NAS-SequenceNumber >-----#
    NAS_SequenceNumber = BIT_STR(name='NAS-SequenceNumber', mode=MODE_TYPE)
    NAS_SequenceNumber._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< NAS-SynchronisationIndicator >-----#
    NAS_SynchronisationIndicator = BIT_STR(name='NAS-SynchronisationIndicator', mode=MODE_TYPE)
    NAS_SynchronisationIndicator._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< NewBSS-To-OldBSS-Information >-----#
    NewBSS_To_OldBSS_Information = OCT_STR(name='NewBSS-To-OldBSS-Information', mode=MODE_TYPE)
    
    #-----< NonSearchingIndication >-----#
    NonSearchingIndication = ENUM(name='NonSearchingIndication', mode=MODE_TYPE)
    NonSearchingIndication._cont = ASN1Dict([('non-searching', 0), ('searching', 1)])
    NonSearchingIndication._ext = None
    
    #-----< NRTLoadInformationValue >-----#
    NRTLoadInformationValue = INT(name='NRTLoadInformationValue', mode=MODE_TYPE)
    NRTLoadInformationValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< Null-NRI >-----#
    Null_NRI = BIT_STR(name='Null-NRI', mode=MODE_TYPE)
    Null_NRI._const_sz = ASN1Set(rv=[10], rr=[], ev=None, er=[])
    
    #-----< NumberOfIuInstances >-----#
    NumberOfIuInstances = INT(name='NumberOfIuInstances', mode=MODE_TYPE)
    NumberOfIuInstances._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< NumberOfSteps >-----#
    NumberOfSteps = INT(name='NumberOfSteps', mode=MODE_TYPE)
    NumberOfSteps._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< Offload-RAB-Parameters >-----#
    Offload_RAB_Parameters = SEQ(name='Offload-RAB-Parameters', mode=MODE_TYPE)
    _Offload_RAB_Parameters_accessPointName = OCT_STR(name='accessPointName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters-APN')))
    _Offload_RAB_Parameters_chargingCharacteristics = OCT_STR(name='chargingCharacteristics', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters-ChargingCharacteristics')))
    _Offload_RAB_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Offload_RAB_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Offload_RAB_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Offload_RAB_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Offload_RAB_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Offload_RAB_Parameters_iE_Extensions__item__id._const_tab = ____Offload_RAB_Parameters_iE_Extensions__item__id_tab
    ___Offload_RAB_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___Offload_RAB_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___Offload_RAB_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Offload_RAB_Parameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Offload_RAB_Parameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Offload_RAB_Parameters_iE_Extensions__item__criticality._const_tab = ____Offload_RAB_Parameters_iE_Extensions__item__criticality_tab
    ___Offload_RAB_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Offload_RAB_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Offload_RAB_Parameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Offload_RAB_Parameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab = ____Offload_RAB_Parameters_iE_Extensions__item__extensionValue_tab
    ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Offload_RAB_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Offload_RAB_Parameters_iE_Extensions__item__id),
        ('criticality', ___Offload_RAB_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue),
        ])
    __Offload_RAB_Parameters_iE_Extensions__item_._ext = None
    _Offload_RAB_Parameters_iE_Extensions._cont = __Offload_RAB_Parameters_iE_Extensions__item_
    _Offload_RAB_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Offload_RAB_Parameters._cont = ASN1Dict([
        ('accessPointName', _Offload_RAB_Parameters_accessPointName),
        ('chargingCharacteristics', _Offload_RAB_Parameters_chargingCharacteristics),
        ('iE-Extensions', _Offload_RAB_Parameters_iE_Extensions),
        ])
    Offload_RAB_Parameters._ext = []
    
    #-----< Offload-RAB-Parameters-ExtIEs >-----#
    Offload_RAB_Parameters_ExtIEs = CLASS(name='Offload-RAB-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Offload_RAB_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Offload-RAB-Parameters-APN >-----#
    Offload_RAB_Parameters_APN = OCT_STR(name='Offload-RAB-Parameters-APN', mode=MODE_TYPE)
    Offload_RAB_Parameters_APN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    
    #-----< Offload-RAB-Parameters-ChargingCharacteristics >-----#
    Offload_RAB_Parameters_ChargingCharacteristics = OCT_STR(name='Offload-RAB-Parameters-ChargingCharacteristics', mode=MODE_TYPE)
    Offload_RAB_Parameters_ChargingCharacteristics._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< OldBSS-ToNewBSS-Information >-----#
    OldBSS_ToNewBSS_Information = OCT_STR(name='OldBSS-ToNewBSS-Information', mode=MODE_TYPE)
    
    #-----< OMC-ID >-----#
    OMC_ID = OCT_STR(name='OMC-ID', mode=MODE_TYPE)
    OMC_ID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=22)], ev=None, er=[])
    
    #-----< Out-Of-UTRAN >-----#
    Out_Of_UTRAN = ENUM(name='Out-Of-UTRAN', mode=MODE_TYPE)
    Out_Of_UTRAN._cont = ASN1Dict([('cell-reselection-to-EUTRAN', 0)])
    Out_Of_UTRAN._ext = []
    
    #-----< PagingAreaID >-----#
    PagingAreaID = CHOICE(name='PagingAreaID', mode=MODE_TYPE)
    _PagingAreaID_lAI = SEQ(name='lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _PagingAreaID_rAI = SEQ(name='rAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAI')))
    PagingAreaID._cont = ASN1Dict([
        ('lAI', _PagingAreaID_lAI),
        ('rAI', _PagingAreaID_rAI),
        ])
    PagingAreaID._ext = []
    
    #-----< PagingCause >-----#
    PagingCause = ENUM(name='PagingCause', mode=MODE_TYPE)
    PagingCause._cont = ASN1Dict([('terminating-conversational-call', 0), ('terminating-streaming-call', 1), ('terminating-interactive-call', 2), ('terminating-background-call', 3), ('terminating-low-priority-signalling', 4), ('terminating-high-priority-signalling', 5)])
    PagingCause._ext = ['terminating-high-priority-signalling']
    
    #-----< PDP-TypeInformation >-----#
    PDP_TypeInformation = SEQ_OF(name='PDP-TypeInformation', mode=MODE_TYPE)
    _PDP_TypeInformation__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-Type')))
    PDP_TypeInformation._cont = _PDP_TypeInformation__item_
    PDP_TypeInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< PDP-Type >-----#
    PDP_Type = ENUM(name='PDP-Type', mode=MODE_TYPE)
    PDP_Type._cont = ASN1Dict([('empty', 0), ('ppp', 1), ('osp-ihoss', 2), ('ipv4', 3), ('ipv6', 4)])
    PDP_Type._ext = []
    
    #-----< PDP-TypeInformation-extension >-----#
    PDP_TypeInformation_extension = SEQ_OF(name='PDP-TypeInformation-extension', mode=MODE_TYPE)
    _PDP_TypeInformation_extension__item_ = ENUM(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-Type-extension')))
    PDP_TypeInformation_extension._cont = _PDP_TypeInformation_extension__item_
    PDP_TypeInformation_extension._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< PDP-Type-extension >-----#
    PDP_Type_extension = ENUM(name='PDP-Type-extension', mode=MODE_TYPE)
    PDP_Type_extension._cont = ASN1Dict([('ipv4-and-ipv6', 0)])
    PDP_Type_extension._ext = []
    
    #-----< PDUType14FrameSequenceNumber >-----#
    PDUType14FrameSequenceNumber = INT(name='PDUType14FrameSequenceNumber', mode=MODE_TYPE)
    PDUType14FrameSequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3)], ev=None, er=[])
    
    #-----< PeriodicLocationInfo >-----#
    PeriodicLocationInfo = SEQ(name='PeriodicLocationInfo', mode=MODE_TYPE)
    _PeriodicLocationInfo_reportingAmount = INT(name='reportingAmount', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicLocationInfo_reportingAmount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=[], er=[])
    _PeriodicLocationInfo_reportingInterval = INT(name='reportingInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicLocationInfo_reportingInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=[], er=[])
    _PeriodicLocationInfo_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PeriodicLocationInfo_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___PeriodicLocationInfo_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____PeriodicLocationInfo_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PeriodicLocationInfo_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicLocationInfo_iE_Extensions__item__id._const_tab = ____PeriodicLocationInfo_iE_Extensions__item__id_tab
    ___PeriodicLocationInfo_iE_Extensions__item__id._const_tab_at = None
    ___PeriodicLocationInfo_iE_Extensions__item__id._const_tab_id = 'id'
    ___PeriodicLocationInfo_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicLocationInfo_iE_Extensions__item__criticality._const_tab = ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab
    ___PeriodicLocationInfo_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PeriodicLocationInfo_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue._const_tab = ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PeriodicLocationInfo_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PeriodicLocationInfo_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PeriodicLocationInfo_iE_Extensions__item__id),
        ('criticality', ___PeriodicLocationInfo_iE_Extensions__item__criticality),
        ('extensionValue', ___PeriodicLocationInfo_iE_Extensions__item__extensionValue),
        ])
    __PeriodicLocationInfo_iE_Extensions__item_._ext = None
    _PeriodicLocationInfo_iE_Extensions._cont = __PeriodicLocationInfo_iE_Extensions__item_
    _PeriodicLocationInfo_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PeriodicLocationInfo._cont = ASN1Dict([
        ('reportingAmount', _PeriodicLocationInfo_reportingAmount),
        ('reportingInterval', _PeriodicLocationInfo_reportingInterval),
        ('iE-Extensions', _PeriodicLocationInfo_iE_Extensions),
        ])
    PeriodicLocationInfo._ext = []
    
    #-----< PeriodicLocationInfo-ExtIEs >-----#
    PeriodicLocationInfo_ExtIEs = CLASS(name='PeriodicLocationInfo-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    PeriodicLocationInfo_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PermanentNAS-UE-ID >-----#
    PermanentNAS_UE_ID = CHOICE(name='PermanentNAS-UE-ID', mode=MODE_TYPE)
    _PermanentNAS_UE_ID_iMSI = OCT_STR(name='iMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMSI')))
    PermanentNAS_UE_ID._cont = ASN1Dict([
        ('iMSI', _PermanentNAS_UE_ID_iMSI),
        ])
    PermanentNAS_UE_ID._ext = []
    
    #-----< PermittedEncryptionAlgorithms >-----#
    PermittedEncryptionAlgorithms = SEQ_OF(name='PermittedEncryptionAlgorithms', mode=MODE_TYPE)
    _PermittedEncryptionAlgorithms__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionAlgorithm')))
    PermittedEncryptionAlgorithms._cont = _PermittedEncryptionAlgorithms__item_
    PermittedEncryptionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PermittedIntegrityProtectionAlgorithms >-----#
    PermittedIntegrityProtectionAlgorithms = SEQ_OF(name='PermittedIntegrityProtectionAlgorithms', mode=MODE_TYPE)
    _PermittedIntegrityProtectionAlgorithms__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionAlgorithm')))
    PermittedIntegrityProtectionAlgorithms._cont = _PermittedIntegrityProtectionAlgorithms__item_
    PermittedIntegrityProtectionAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< LABased >-----#
    LABased = SEQ(name='LABased', mode=MODE_TYPE)
    _LABased_laiList = SEQ_OF(name='laiList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI-List')))
    _LABased_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LABased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LABased_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LABased_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LABased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LABased_iE_Extensions__item__id._const_tab = ____LABased_iE_Extensions__item__id_tab
    ___LABased_iE_Extensions__item__id._const_tab_at = None
    ___LABased_iE_Extensions__item__id._const_tab_id = 'id'
    ___LABased_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LABased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LABased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LABased_iE_Extensions__item__criticality._const_tab = ____LABased_iE_Extensions__item__criticality_tab
    ___LABased_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LABased_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LABased_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LABased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LABased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LABased_iE_Extensions__item__extensionValue._const_tab = ____LABased_iE_Extensions__item__extensionValue_tab
    ___LABased_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LABased_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LABased_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LABased_iE_Extensions__item__id),
        ('criticality', ___LABased_iE_Extensions__item__criticality),
        ('extensionValue', ___LABased_iE_Extensions__item__extensionValue),
        ])
    __LABased_iE_Extensions__item_._ext = None
    _LABased_iE_Extensions._cont = __LABased_iE_Extensions__item_
    _LABased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LABased._cont = ASN1Dict([
        ('laiList', _LABased_laiList),
        ('iE-Extensions', _LABased_iE_Extensions),
        ])
    LABased._ext = []
    
    #-----< LABased-ExtIEs >-----#
    LABased_ExtIEs = CLASS(name='LABased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LABased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LAI-List >-----#
    LAI_List = SEQ_OF(name='LAI-List', mode=MODE_TYPE)
    _LAI_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    LAI_List._cont = _LAI_List__item_
    LAI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< LoggedMDT >-----#
    LoggedMDT = SEQ(name='LoggedMDT', mode=MODE_TYPE)
    _LoggedMDT_loggingInterval = ENUM(name='loggingInterval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LoggingInterval')))
    _LoggedMDT_loggingDuration = ENUM(name='loggingDuration', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LoggingDuration')))
    _LoggedMDT_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LoggedMDT_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LoggedMDT_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LoggedMDT_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LoggedMDT_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMDT_iE_Extensions__item__id._const_tab = ____LoggedMDT_iE_Extensions__item__id_tab
    ___LoggedMDT_iE_Extensions__item__id._const_tab_at = None
    ___LoggedMDT_iE_Extensions__item__id._const_tab_id = 'id'
    ___LoggedMDT_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____LoggedMDT_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LoggedMDT_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab = ____LoggedMDT_iE_Extensions__item__criticality_tab
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___LoggedMDT_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___LoggedMDT_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____LoggedMDT_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____LoggedMDT_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab = ____LoggedMDT_iE_Extensions__item__extensionValue_tab
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LoggedMDT_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __LoggedMDT_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___LoggedMDT_iE_Extensions__item__id),
        ('criticality', ___LoggedMDT_iE_Extensions__item__criticality),
        ('extensionValue', ___LoggedMDT_iE_Extensions__item__extensionValue),
        ])
    __LoggedMDT_iE_Extensions__item_._ext = None
    _LoggedMDT_iE_Extensions._cont = __LoggedMDT_iE_Extensions__item_
    _LoggedMDT_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LoggedMDT._cont = ASN1Dict([
        ('loggingInterval', _LoggedMDT_loggingInterval),
        ('loggingDuration', _LoggedMDT_loggingDuration),
        ('iE-Extensions', _LoggedMDT_iE_Extensions),
        ])
    LoggedMDT._ext = []
    
    #-----< LoggedMDT-ExtIEs >-----#
    LoggedMDT_ExtIEs = CLASS(name='LoggedMDT-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LoggedMDT_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LoggingInterval >-----#
    LoggingInterval = ENUM(name='LoggingInterval', mode=MODE_TYPE)
    LoggingInterval._cont = ASN1Dict([('s1d28', 0), ('s2d56', 1), ('s5d12', 2), ('s10d24', 3), ('s20d48', 4), ('s30d72', 5), ('s40d96', 6), ('s61d44', 7)])
    LoggingInterval._ext = []
    
    #-----< LoggingDuration >-----#
    LoggingDuration = ENUM(name='LoggingDuration', mode=MODE_TYPE)
    LoggingDuration._cont = ASN1Dict([('min10', 0), ('min20', 1), ('min40', 2), ('min60', 3), ('min90', 4), ('min120', 5)])
    LoggingDuration._ext = []
    
    #-----< PLMNBased >-----#
    PLMNBased = SEQ(name='PLMNBased', mode=MODE_TYPE)
    _PLMNBased_plmnList = SEQ_OF(name='plmnList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNList')))
    _PLMNBased_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PLMNBased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___PLMNBased_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____PLMNBased_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PLMNBased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNBased_iE_Extensions__item__id._const_tab = ____PLMNBased_iE_Extensions__item__id_tab
    ___PLMNBased_iE_Extensions__item__id._const_tab_at = None
    ___PLMNBased_iE_Extensions__item__id._const_tab_id = 'id'
    ___PLMNBased_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____PLMNBased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PLMNBased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNBased_iE_Extensions__item__criticality._const_tab = ____PLMNBased_iE_Extensions__item__criticality_tab
    ___PLMNBased_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PLMNBased_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PLMNBased_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____PLMNBased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____PLMNBased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PLMNBased_iE_Extensions__item__extensionValue._const_tab = ____PLMNBased_iE_Extensions__item__extensionValue_tab
    ___PLMNBased_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PLMNBased_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PLMNBased_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PLMNBased_iE_Extensions__item__id),
        ('criticality', ___PLMNBased_iE_Extensions__item__criticality),
        ('extensionValue', ___PLMNBased_iE_Extensions__item__extensionValue),
        ])
    __PLMNBased_iE_Extensions__item_._ext = None
    _PLMNBased_iE_Extensions._cont = __PLMNBased_iE_Extensions__item_
    _PLMNBased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PLMNBased._cont = ASN1Dict([
        ('plmnList', _PLMNBased_plmnList),
        ('iE-Extensions', _PLMNBased_iE_Extensions),
        ])
    PLMNBased._ext = []
    
    #-----< PLMNBased-ExtIEs >-----#
    PLMNBased_ExtIEs = CLASS(name='PLMNBased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    PLMNBased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PLMNList >-----#
    PLMNList = SEQ_OF(name='PLMNList', mode=MODE_TYPE)
    _PLMNList__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    PLMNList._cont = _PLMNList__item_
    PLMNList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< PLMNidentity >-----#
    PLMNidentity = OCT_STR(name='PLMNidentity', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TBCD-STRING')))
    PLMNidentity._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< PLMNs-in-shared-network >-----#
    PLMNs_in_shared_network = SEQ_OF(name='PLMNs-in-shared-network', mode=MODE_TYPE)
    _PLMNs_in_shared_network__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PLMNs_in_shared_network__item__pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    __PLMNs_in_shared_network__item__lA_LIST = SEQ_OF(name='lA-LIST', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LA-LIST')))
    __PLMNs_in_shared_network__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___PLMNs_in_shared_network__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____PLMNs_in_shared_network__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PLMNs_in_shared_network__item__iE_Extensions__item__id._const_tab = _____PLMNs_in_shared_network__item__iE_Extensions__item__id_tab
    ____PLMNs_in_shared_network__item__iE_Extensions__item__id._const_tab_at = None
    ____PLMNs_in_shared_network__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality._const_tab = _____PLMNs_in_shared_network__item__iE_Extensions__item__criticality_tab
    ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue._const_tab = _____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue_tab
    ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___PLMNs_in_shared_network__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____PLMNs_in_shared_network__item__iE_Extensions__item__id),
        ('criticality', ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality),
        ('extensionValue', ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue),
        ])
    ___PLMNs_in_shared_network__item__iE_Extensions__item_._ext = None
    __PLMNs_in_shared_network__item__iE_Extensions._cont = ___PLMNs_in_shared_network__item__iE_Extensions__item_
    __PLMNs_in_shared_network__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _PLMNs_in_shared_network__item_._cont = ASN1Dict([
        ('pLMNidentity', __PLMNs_in_shared_network__item__pLMNidentity),
        ('lA-LIST', __PLMNs_in_shared_network__item__lA_LIST),
        ('iE-Extensions', __PLMNs_in_shared_network__item__iE_Extensions),
        ])
    _PLMNs_in_shared_network__item_._ext = []
    PLMNs_in_shared_network._cont = _PLMNs_in_shared_network__item_
    PLMNs_in_shared_network._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PLMNs-in-shared-network-ExtIEs >-----#
    PLMNs_in_shared_network_ExtIEs = CLASS(name='PLMNs-in-shared-network-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    PLMNs_in_shared_network_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Port-Number >-----#
    Port_Number = OCT_STR(name='Port-Number', mode=MODE_TYPE)
    Port_Number._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< PositioningDataDiscriminator >-----#
    PositioningDataDiscriminator = BIT_STR(name='PositioningDataDiscriminator', mode=MODE_TYPE)
    PositioningDataDiscriminator._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< PositioningDataSet >-----#
    PositioningDataSet = SEQ_OF(name='PositioningDataSet', mode=MODE_TYPE)
    _PositioningDataSet__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositioningMethodAndUsage')))
    PositioningDataSet._cont = _PositioningDataSet__item_
    PositioningDataSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    
    #-----< PositioningMethodAndUsage >-----#
    PositioningMethodAndUsage = OCT_STR(name='PositioningMethodAndUsage', mode=MODE_TYPE)
    PositioningMethodAndUsage._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< PositioningPriority >-----#
    PositioningPriority = ENUM(name='PositioningPriority', mode=MODE_TYPE)
    PositioningPriority._cont = ASN1Dict([('high-Priority', 0), ('normal-Priority', 1)])
    PositioningPriority._ext = []
    
    #-----< PositionData >-----#
    PositionData = SEQ(name='PositionData', mode=MODE_TYPE)
    _PositionData_positioningDataDiscriminator = BIT_STR(name='positioningDataDiscriminator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PositioningDataDiscriminator')))
    _PositionData_positioningDataSet = SEQ_OF(name='positioningDataSet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PositioningDataSet')), opt=True)
    _PositionData_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __PositionData_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___PositionData_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____PositionData_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____PositionData_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GANSS-PositioningDataSet')))
    _____PositionData_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Additional-PositioningDataSet')))
    ____PositionData_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 184), ('criticality', 'ignore'), ('Extension', _____PositionData_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 284), ('criticality', 'ignore'), ('Extension', _____PositionData_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___PositionData_iE_Extensions__item__id._const_tab = ____PositionData_iE_Extensions__item__id_tab
    ___PositionData_iE_Extensions__item__id._const_tab_at = None
    ___PositionData_iE_Extensions__item__id._const_tab_id = 'id'
    ___PositionData_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___PositionData_iE_Extensions__item__criticality._const_tab = ____PositionData_iE_Extensions__item__id_tab
    ___PositionData_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___PositionData_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___PositionData_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___PositionData_iE_Extensions__item__extensionValue._const_tab = ____PositionData_iE_Extensions__item__id_tab
    ___PositionData_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___PositionData_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __PositionData_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___PositionData_iE_Extensions__item__id),
        ('criticality', ___PositionData_iE_Extensions__item__criticality),
        ('extensionValue', ___PositionData_iE_Extensions__item__extensionValue),
        ])
    __PositionData_iE_Extensions__item_._ext = None
    _PositionData_iE_Extensions._cont = __PositionData_iE_Extensions__item_
    _PositionData_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PositionData._cont = ASN1Dict([
        ('positioningDataDiscriminator', _PositionData_positioningDataDiscriminator),
        ('positioningDataSet', _PositionData_positioningDataSet),
        ('iE-Extensions', _PositionData_iE_Extensions),
        ])
    PositionData._ext = []
    
    #-----< PositionData-ExtIEs >-----#
    PositionData_ExtIEs = CLASS(name='PositionData-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _PositionData_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GANSS-PositioningDataSet')))
    _PositionData_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Additional-PositioningDataSet')))
    PositionData_ExtIEs._val = ASN1Set(rv=[dict([('id', 184), ('criticality', 'ignore'), ('Extension', _PositionData_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 284), ('criticality', 'ignore'), ('Extension', _PositionData_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PositionDataSpecificToGERANIuMode >-----#
    PositionDataSpecificToGERANIuMode = OCT_STR(name='PositionDataSpecificToGERANIuMode', mode=MODE_TYPE)
    
    #-----< Pre-emptionCapability >-----#
    Pre_emptionCapability = ENUM(name='Pre-emptionCapability', mode=MODE_TYPE)
    Pre_emptionCapability._cont = ASN1Dict([('shall-not-trigger-pre-emption', 0), ('may-trigger-pre-emption', 1)])
    Pre_emptionCapability._ext = None
    
    #-----< Pre-emptionVulnerability >-----#
    Pre_emptionVulnerability = ENUM(name='Pre-emptionVulnerability', mode=MODE_TYPE)
    Pre_emptionVulnerability._cont = ASN1Dict([('not-pre-emptable', 0), ('pre-emptable', 1)])
    Pre_emptionVulnerability._ext = None
    
    #-----< PriorityLevel >-----#
    PriorityLevel = INT(name='PriorityLevel', mode=MODE_TYPE)
    PriorityLevel._cont = ASN1Dict([('spare', 0), ('highest', 1), ('lowest', 14), ('no-priority', 15)])
    PriorityLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< Priority-Class-Indicator >-----#
    Priority_Class_Indicator = BIT_STR(name='Priority-Class-Indicator', mode=MODE_TYPE)
    Priority_Class_Indicator._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< ProvidedData >-----#
    ProvidedData = CHOICE(name='ProvidedData', mode=MODE_TYPE)
    _ProvidedData_shared_network_information = SEQ(name='shared-network-information', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Shared-Network-Information')))
    ProvidedData._cont = ASN1Dict([
        ('shared-network-information', _ProvidedData_shared_network_information),
        ])
    ProvidedData._ext = []
    
    #-----< PowerSavingIndicator >-----#
    PowerSavingIndicator = ENUM(name='PowerSavingIndicator', mode=MODE_TYPE)
    PowerSavingIndicator._cont = ASN1Dict([('psmConfigured', 0), ('eDRXConfigured', 1)])
    PowerSavingIndicator._ext = []
    
    #-----< P-TMSI >-----#
    P_TMSI = OCT_STR(name='P-TMSI', mode=MODE_TYPE)
    P_TMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< QueuingAllowed >-----#
    QueuingAllowed = ENUM(name='QueuingAllowed', mode=MODE_TYPE)
    QueuingAllowed._cont = ASN1Dict([('queueing-not-allowed', 0), ('queueing-allowed', 1)])
    QueuingAllowed._ext = None
    
    #-----< RAB-AsymmetryIndicator >-----#
    RAB_AsymmetryIndicator = ENUM(name='RAB-AsymmetryIndicator', mode=MODE_TYPE)
    RAB_AsymmetryIndicator._cont = ASN1Dict([('symmetric-bidirectional', 0), ('asymmetric-unidirectional-downlink', 1), ('asymmetric-unidirectional-uplink', 2), ('asymmetric-bidirectional', 3)])
    RAB_AsymmetryIndicator._ext = []
    
    #-----< RABased >-----#
    RABased = SEQ(name='RABased', mode=MODE_TYPE)
    _RABased_raiList = SEQ_OF(name='raiList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAI-List')))
    _RABased_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RABased_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RABased_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RABased_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABased_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABased_iE_Extensions__item__id._const_tab = ____RABased_iE_Extensions__item__id_tab
    ___RABased_iE_Extensions__item__id._const_tab_at = None
    ___RABased_iE_Extensions__item__id._const_tab_id = 'id'
    ___RABased_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RABased_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABased_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABased_iE_Extensions__item__criticality._const_tab = ____RABased_iE_Extensions__item__criticality_tab
    ___RABased_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RABased_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RABased_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RABased_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABased_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABased_iE_Extensions__item__extensionValue._const_tab = ____RABased_iE_Extensions__item__extensionValue_tab
    ___RABased_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RABased_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RABased_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RABased_iE_Extensions__item__id),
        ('criticality', ___RABased_iE_Extensions__item__criticality),
        ('extensionValue', ___RABased_iE_Extensions__item__extensionValue),
        ])
    __RABased_iE_Extensions__item_._ext = None
    _RABased_iE_Extensions._cont = __RABased_iE_Extensions__item_
    _RABased_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RABased._cont = ASN1Dict([
        ('raiList', _RABased_raiList),
        ('iE-Extensions', _RABased_iE_Extensions),
        ])
    RABased._ext = []
    
    #-----< RABased-ExtIEs >-----#
    RABased_ExtIEs = CLASS(name='RABased-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RABased_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAI-List >-----#
    RAI_List = SEQ_OF(name='RAI-List', mode=MODE_TYPE)
    _RAI_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAI')))
    RAI_List._cont = _RAI_List__item_
    RAI_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< RABDataVolumeReport >-----#
    RABDataVolumeReport = SEQ_OF(name='RABDataVolumeReport', mode=MODE_TYPE)
    _RABDataVolumeReport__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __RABDataVolumeReport__item__dl_UnsuccessfullyTransmittedDataVolume = INT(name='dl-UnsuccessfullyTransmittedDataVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UnsuccessfullyTransmittedDataVolume')))
    __RABDataVolumeReport__item__dataVolumeReference = INT(name='dataVolumeReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataVolumeReference')), opt=True)
    __RABDataVolumeReport__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___RABDataVolumeReport__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____RABDataVolumeReport__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____RABDataVolumeReport__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABDataVolumeReport__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABDataVolumeReport__item__iE_Extensions__item__id._const_tab = _____RABDataVolumeReport__item__iE_Extensions__item__id_tab
    ____RABDataVolumeReport__item__iE_Extensions__item__id._const_tab_at = None
    ____RABDataVolumeReport__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____RABDataVolumeReport__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____RABDataVolumeReport__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABDataVolumeReport__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABDataVolumeReport__item__iE_Extensions__item__criticality._const_tab = _____RABDataVolumeReport__item__iE_Extensions__item__criticality_tab
    ____RABDataVolumeReport__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____RABDataVolumeReport__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____RABDataVolumeReport__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABDataVolumeReport__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue._const_tab = _____RABDataVolumeReport__item__iE_Extensions__item__extensionValue_tab
    ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___RABDataVolumeReport__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____RABDataVolumeReport__item__iE_Extensions__item__id),
        ('criticality', ____RABDataVolumeReport__item__iE_Extensions__item__criticality),
        ('extensionValue', ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue),
        ])
    ___RABDataVolumeReport__item__iE_Extensions__item_._ext = None
    __RABDataVolumeReport__item__iE_Extensions._cont = ___RABDataVolumeReport__item__iE_Extensions__item_
    __RABDataVolumeReport__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _RABDataVolumeReport__item_._cont = ASN1Dict([
        ('dl-UnsuccessfullyTransmittedDataVolume', __RABDataVolumeReport__item__dl_UnsuccessfullyTransmittedDataVolume),
        ('dataVolumeReference', __RABDataVolumeReport__item__dataVolumeReference),
        ('iE-Extensions', __RABDataVolumeReport__item__iE_Extensions),
        ])
    _RABDataVolumeReport__item_._ext = []
    RABDataVolumeReport._cont = _RABDataVolumeReport__item_
    RABDataVolumeReport._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RABDataVolumeReport-ExtIEs >-----#
    RABDataVolumeReport_ExtIEs = CLASS(name='RABDataVolumeReport-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RABDataVolumeReport_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ID >-----#
    RAB_ID = BIT_STR(name='RAB-ID', mode=MODE_TYPE)
    RAB_ID._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    RAB_Parameter_ExtendedGuaranteedBitrateList = SEQ_OF(name='RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_TYPE)
    _RAB_Parameter_ExtendedGuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedGuaranteedBitrate')))
    RAB_Parameter_ExtendedGuaranteedBitrateList._cont = _RAB_Parameter_ExtendedGuaranteedBitrateList__item_
    RAB_Parameter_ExtendedGuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RAB-Parameter-ExtendedMaxBitrateList >-----#
    RAB_Parameter_ExtendedMaxBitrateList = SEQ_OF(name='RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_TYPE)
    _RAB_Parameter_ExtendedMaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedMaxBitrate')))
    RAB_Parameter_ExtendedMaxBitrateList._cont = _RAB_Parameter_ExtendedMaxBitrateList__item_
    RAB_Parameter_ExtendedMaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RAB-Parameter-GuaranteedBitrateList >-----#
    RAB_Parameter_GuaranteedBitrateList = SEQ_OF(name='RAB-Parameter-GuaranteedBitrateList', mode=MODE_TYPE)
    _RAB_Parameter_GuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GuaranteedBitrate')))
    RAB_Parameter_GuaranteedBitrateList._cont = _RAB_Parameter_GuaranteedBitrateList__item_
    RAB_Parameter_GuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RAB-Parameter-MaxBitrateList >-----#
    RAB_Parameter_MaxBitrateList = SEQ_OF(name='RAB-Parameter-MaxBitrateList', mode=MODE_TYPE)
    _RAB_Parameter_MaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MaxBitrate')))
    RAB_Parameter_MaxBitrateList._cont = _RAB_Parameter_MaxBitrateList__item_
    RAB_Parameter_MaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RAB-Parameters >-----#
    RAB_Parameters = SEQ(name='RAB-Parameters', mode=MODE_TYPE)
    _RAB_Parameters_trafficClass = ENUM(name='trafficClass', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TrafficClass')))
    _RAB_Parameters_rAB_AsymmetryIndicator = ENUM(name='rAB-AsymmetryIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-AsymmetryIndicator')))
    _RAB_Parameters_maxBitrate = SEQ_OF(name='maxBitrate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-MaxBitrateList')))
    _RAB_Parameters_guaranteedBitRate = SEQ_OF(name='guaranteedBitRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-GuaranteedBitrateList')), opt=True)
    _RAB_Parameters_deliveryOrder = ENUM(name='deliveryOrder', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DeliveryOrder')))
    _RAB_Parameters_maxSDU_Size = INT(name='maxSDU-Size', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MaxSDU-Size')))
    _RAB_Parameters_sDU_Parameters = SEQ_OF(name='sDU-Parameters', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SDU-Parameters')))
    _RAB_Parameters_transferDelay = INT(name='transferDelay', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransferDelay')), opt=True)
    _RAB_Parameters_trafficHandlingPriority = INT(name='trafficHandlingPriority', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TrafficHandlingPriority')), opt=True)
    _RAB_Parameters_allocationOrRetentionPriority = SEQ(name='allocationOrRetentionPriority', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'AllocationOrRetentionPriority')), opt=True)
    _RAB_Parameters_sourceStatisticsDescriptor = ENUM(name='sourceStatisticsDescriptor', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SourceStatisticsDescriptor')), opt=True)
    _RAB_Parameters_relocationRequirement = ENUM(name='relocationRequirement', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RelocationRequirement')), opt=True)
    _RAB_Parameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_Parameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_Parameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_Parameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SignallingIndication')))
    _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-ExtendedMaxBitrateList')))
    _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    ____RAB_Parameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 116), ('criticality', 'ignore'), ('Extension', _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'reject'), ('Extension', _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'reject'), ('Extension', _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'reject'), ('Extension', _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_Parameters_iE_Extensions__item__id._const_tab = ____RAB_Parameters_iE_Extensions__item__id_tab
    ___RAB_Parameters_iE_Extensions__item__id._const_tab_at = None
    ___RAB_Parameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_Parameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_Parameters_iE_Extensions__item__criticality._const_tab = ____RAB_Parameters_iE_Extensions__item__id_tab
    ___RAB_Parameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_Parameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_Parameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_Parameters_iE_Extensions__item__extensionValue._const_tab = ____RAB_Parameters_iE_Extensions__item__id_tab
    ___RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_Parameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_Parameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_Parameters_iE_Extensions__item__id),
        ('criticality', ___RAB_Parameters_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_Parameters_iE_Extensions__item__extensionValue),
        ])
    __RAB_Parameters_iE_Extensions__item_._ext = None
    _RAB_Parameters_iE_Extensions._cont = __RAB_Parameters_iE_Extensions__item_
    _RAB_Parameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_Parameters._cont = ASN1Dict([
        ('trafficClass', _RAB_Parameters_trafficClass),
        ('rAB-AsymmetryIndicator', _RAB_Parameters_rAB_AsymmetryIndicator),
        ('maxBitrate', _RAB_Parameters_maxBitrate),
        ('guaranteedBitRate', _RAB_Parameters_guaranteedBitRate),
        ('deliveryOrder', _RAB_Parameters_deliveryOrder),
        ('maxSDU-Size', _RAB_Parameters_maxSDU_Size),
        ('sDU-Parameters', _RAB_Parameters_sDU_Parameters),
        ('transferDelay', _RAB_Parameters_transferDelay),
        ('trafficHandlingPriority', _RAB_Parameters_trafficHandlingPriority),
        ('allocationOrRetentionPriority', _RAB_Parameters_allocationOrRetentionPriority),
        ('sourceStatisticsDescriptor', _RAB_Parameters_sourceStatisticsDescriptor),
        ('relocationRequirement', _RAB_Parameters_relocationRequirement),
        ('iE-Extensions', _RAB_Parameters_iE_Extensions),
        ])
    RAB_Parameters._ext = []
    
    #-----< RAB-Parameters-ExtIEs >-----#
    RAB_Parameters_ExtIEs = CLASS(name='RAB-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_Parameters_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SignallingIndication')))
    _RAB_Parameters_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _RAB_Parameters_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameter-ExtendedMaxBitrateList')))
    _RAB_Parameters_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _RAB_Parameters_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    RAB_Parameters_ExtIEs._val = ASN1Set(rv=[dict([('id', 116), ('criticality', 'ignore'), ('Extension', _RAB_Parameters_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 176), ('criticality', 'reject'), ('Extension', _RAB_Parameters_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 177), ('criticality', 'reject'), ('Extension', _RAB_Parameters_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 219), ('criticality', 'reject'), ('Extension', _RAB_Parameters_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 218), ('criticality', 'reject'), ('Extension', _RAB_Parameters_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RABParametersList >-----#
    RABParametersList = SEQ_OF(name='RABParametersList', mode=MODE_TYPE)
    _RABParametersList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __RABParametersList__item__rab_Id = BIT_STR(name='rab-Id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    __RABParametersList__item__cn_domain = ENUM(name='cn-domain', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    __RABParametersList__item__rabDataVolumeReport = SEQ_OF(name='rabDataVolumeReport', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RABDataVolumeReport')), opt=True)
    __RABParametersList__item__upInformation = SEQ(name='upInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UPInformation')), opt=True)
    __RABParametersList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___RABParametersList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____RABParametersList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____RABParametersList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABParametersList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABParametersList__item__iE_Extensions__item__id._const_tab = _____RABParametersList__item__iE_Extensions__item__id_tab
    ____RABParametersList__item__iE_Extensions__item__id._const_tab_at = None
    ____RABParametersList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____RABParametersList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____RABParametersList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABParametersList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABParametersList__item__iE_Extensions__item__criticality._const_tab = _____RABParametersList__item__iE_Extensions__item__criticality_tab
    ____RABParametersList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____RABParametersList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____RABParametersList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____RABParametersList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RABParametersList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____RABParametersList__item__iE_Extensions__item__extensionValue._const_tab = _____RABParametersList__item__iE_Extensions__item__extensionValue_tab
    ____RABParametersList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____RABParametersList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___RABParametersList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____RABParametersList__item__iE_Extensions__item__id),
        ('criticality', ____RABParametersList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____RABParametersList__item__iE_Extensions__item__extensionValue),
        ])
    ___RABParametersList__item__iE_Extensions__item_._ext = None
    __RABParametersList__item__iE_Extensions._cont = ___RABParametersList__item__iE_Extensions__item_
    __RABParametersList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _RABParametersList__item_._cont = ASN1Dict([
        ('rab-Id', __RABParametersList__item__rab_Id),
        ('cn-domain', __RABParametersList__item__cn_domain),
        ('rabDataVolumeReport', __RABParametersList__item__rabDataVolumeReport),
        ('upInformation', __RABParametersList__item__upInformation),
        ('iE-Extensions', __RABParametersList__item__iE_Extensions),
        ])
    _RABParametersList__item_._ext = []
    RABParametersList._cont = _RABParametersList__item_
    RABParametersList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RABParametersList-ExtIEs >-----#
    RABParametersList_ExtIEs = CLASS(name='RABParametersList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RABParametersList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-SubflowCombinationBitRate >-----#
    RAB_SubflowCombinationBitRate = INT(name='RAB-SubflowCombinationBitRate', mode=MODE_TYPE)
    RAB_SubflowCombinationBitRate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16000000)], ev=None, er=[])
    
    #-----< RAB-TrCH-Mapping >-----#
    RAB_TrCH_Mapping = SEQ_OF(name='RAB-TrCH-Mapping', mode=MODE_TYPE)
    _RAB_TrCH_Mapping__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-TrCH-MappingItem')))
    RAB_TrCH_Mapping._cont = _RAB_TrCH_Mapping__item_
    RAB_TrCH_Mapping._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-TrCH-MappingItem >-----#
    RAB_TrCH_MappingItem = SEQ(name='RAB-TrCH-MappingItem', mode=MODE_TYPE)
    _RAB_TrCH_MappingItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_TrCH_MappingItem_trCH_ID_List = SEQ_OF(name='trCH-ID-List', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TrCH-ID-List')))
    _RAB_TrCH_MappingItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_TrCH_MappingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_TrCH_MappingItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'ignore'), ('Extension', _____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_TrCH_MappingItem_iE_Extensions__item__id._const_tab = ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab
    ___RAB_TrCH_MappingItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_TrCH_MappingItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab = ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab
    ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab
    ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_TrCH_MappingItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_TrCH_MappingItem_iE_Extensions__item__id),
        ('criticality', ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_TrCH_MappingItem_iE_Extensions__item_._ext = None
    _RAB_TrCH_MappingItem_iE_Extensions._cont = __RAB_TrCH_MappingItem_iE_Extensions__item_
    _RAB_TrCH_MappingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_TrCH_MappingItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_TrCH_MappingItem_rAB_ID),
        ('trCH-ID-List', _RAB_TrCH_MappingItem_trCH_ID_List),
        ('iE-Extensions', _RAB_TrCH_MappingItem_iE_Extensions),
        ])
    RAB_TrCH_MappingItem._ext = []
    
    #-----< RAB-TrCH-MappingItem-ExtIEs >-----#
    RAB_TrCH_MappingItem_ExtIEs = CLASS(name='RAB-TrCH-MappingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_TrCH_MappingItem_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    RAB_TrCH_MappingItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'ignore'), ('Extension', _RAB_TrCH_MappingItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAC >-----#
    RAC = OCT_STR(name='RAC', mode=MODE_TYPE)
    RAC._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< RAI >-----#
    RAI = SEQ(name='RAI', mode=MODE_TYPE)
    _RAI_lAI = SEQ(name='lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _RAI_rAC = OCT_STR(name='rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _RAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAI_iE_Extensions__item__id._const_tab = ____RAI_iE_Extensions__item__id_tab
    ___RAI_iE_Extensions__item__id._const_tab_at = None
    ___RAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAI_iE_Extensions__item__criticality._const_tab = ____RAI_iE_Extensions__item__criticality_tab
    ___RAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAI_iE_Extensions__item__extensionValue._const_tab = ____RAI_iE_Extensions__item__extensionValue_tab
    ___RAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAI_iE_Extensions__item__id),
        ('criticality', ___RAI_iE_Extensions__item__criticality),
        ('extensionValue', ___RAI_iE_Extensions__item__extensionValue),
        ])
    __RAI_iE_Extensions__item_._ext = None
    _RAI_iE_Extensions._cont = __RAI_iE_Extensions__item_
    _RAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAI._cont = ASN1Dict([
        ('lAI', _RAI_lAI),
        ('rAC', _RAI_rAC),
        ('iE-Extensions', _RAI_iE_Extensions),
        ])
    RAI._ext = []
    
    #-----< RAI-ExtIEs >-----#
    RAI_ExtIEs = CLASS(name='RAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAListofIdleModeUEs >-----#
    RAListofIdleModeUEs = CHOICE(name='RAListofIdleModeUEs', mode=MODE_TYPE)
    _RAListofIdleModeUEs_notEmptyRAListofIdleModeUEs = SEQ(name='notEmptyRAListofIdleModeUEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NotEmptyRAListofIdleModeUEs')))
    _RAListofIdleModeUEs_emptyFullRAListofIdleModeUEs = ENUM(name='emptyFullRAListofIdleModeUEs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RAListofIdleModeUEs_emptyFullRAListofIdleModeUEs._cont = ASN1Dict([('emptylist', 0), ('fulllist', 1)])
    _RAListofIdleModeUEs_emptyFullRAListofIdleModeUEs._ext = []
    RAListofIdleModeUEs._cont = ASN1Dict([
        ('notEmptyRAListofIdleModeUEs', _RAListofIdleModeUEs_notEmptyRAListofIdleModeUEs),
        ('emptyFullRAListofIdleModeUEs', _RAListofIdleModeUEs_emptyFullRAListofIdleModeUEs),
        ])
    RAListofIdleModeUEs._ext = []
    
    #-----< NotEmptyRAListofIdleModeUEs >-----#
    NotEmptyRAListofIdleModeUEs = SEQ(name='NotEmptyRAListofIdleModeUEs', mode=MODE_TYPE)
    _NotEmptyRAListofIdleModeUEs_rAofIdleModeUEs = SEQ_OF(name='rAofIdleModeUEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAofIdleModeUEs')))
    _NotEmptyRAListofIdleModeUEs_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __NotEmptyRAListofIdleModeUEs_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 180), ('criticality', 'reject'), ('Extension', _____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id._const_tab = ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id._const_tab_at = None
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id._const_tab_id = 'id'
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab = ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab = ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __NotEmptyRAListofIdleModeUEs_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id),
        ('criticality', ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality),
        ('extensionValue', ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue),
        ])
    __NotEmptyRAListofIdleModeUEs_iE_Extensions__item_._ext = None
    _NotEmptyRAListofIdleModeUEs_iE_Extensions._cont = __NotEmptyRAListofIdleModeUEs_iE_Extensions__item_
    _NotEmptyRAListofIdleModeUEs_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    NotEmptyRAListofIdleModeUEs._cont = ASN1Dict([
        ('rAofIdleModeUEs', _NotEmptyRAListofIdleModeUEs_rAofIdleModeUEs),
        ('iE-Extensions', _NotEmptyRAListofIdleModeUEs_iE_Extensions),
        ])
    NotEmptyRAListofIdleModeUEs._ext = None
    
    #-----< RAofIdleModeUEs >-----#
    RAofIdleModeUEs = SEQ_OF(name='RAofIdleModeUEs', mode=MODE_TYPE)
    _RAofIdleModeUEs__item_ = OCT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    RAofIdleModeUEs._cont = _RAofIdleModeUEs__item_
    RAofIdleModeUEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< NotEmptyRAListofIdleModeUEs-ExtIEs >-----#
    NotEmptyRAListofIdleModeUEs_ExtIEs = CLASS(name='NotEmptyRAListofIdleModeUEs-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _NotEmptyRAListofIdleModeUEs_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAListofIdleModeUEs')))
    NotEmptyRAListofIdleModeUEs_ExtIEs._val = ASN1Set(rv=[dict([('id', 180), ('criticality', 'reject'), ('Extension', _NotEmptyRAListofIdleModeUEs_ExtIEs_val_Extension_0), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< LAListofIdleModeUEs >-----#
    LAListofIdleModeUEs = SEQ_OF(name='LAListofIdleModeUEs', mode=MODE_TYPE)
    _LAListofIdleModeUEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    LAListofIdleModeUEs._cont = _LAListofIdleModeUEs__item_
    LAListofIdleModeUEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    
    #-----< RAT-Type >-----#
    RAT_Type = ENUM(name='RAT-Type', mode=MODE_TYPE)
    RAT_Type._cont = ASN1Dict([('utran', 0), ('geran', 1)])
    RAT_Type._ext = []
    
    #-----< RateControlAllowed >-----#
    RateControlAllowed = ENUM(name='RateControlAllowed', mode=MODE_TYPE)
    RateControlAllowed._cont = ASN1Dict([('not-allowed', 0), ('allowed', 1)])
    RateControlAllowed._ext = None
    
    #-----< RedirectAttemptFlag >-----#
    RedirectAttemptFlag = NULL(name='RedirectAttemptFlag', mode=MODE_TYPE)
    
    #-----< RedirectionCompleted >-----#
    RedirectionCompleted = ENUM(name='RedirectionCompleted', mode=MODE_TYPE)
    RedirectionCompleted._cont = ASN1Dict([('redirection-completed', 0)])
    RedirectionCompleted._ext = []
    
    #-----< RejectCauseValue >-----#
    RejectCauseValue = ENUM(name='RejectCauseValue', mode=MODE_TYPE)
    RejectCauseValue._cont = ASN1Dict([('pLMN-Not-Allowed', 0), ('location-Area-Not-Allowed', 1), ('roaming-Not-Allowed-In-This-Location-Area', 2), ('no-Suitable-Cell-In-Location-Area', 3), ('gPRS-Services-Not-Allowed-In-This-PLMN', 4), ('cS-PS-coordination-required', 5), ('network-failure', 6), ('not-authorized-for-this-CSG', 7)])
    RejectCauseValue._ext = ['network-failure', 'not-authorized-for-this-CSG']
    
    #-----< RelocationRequirement >-----#
    RelocationRequirement = ENUM(name='RelocationRequirement', mode=MODE_TYPE)
    RelocationRequirement._cont = ASN1Dict([('lossless', 0), ('none', 1), ('realtime', 2)])
    RelocationRequirement._ext = ['realtime']
    
    #-----< RelocationType >-----#
    RelocationType = ENUM(name='RelocationType', mode=MODE_TYPE)
    RelocationType._cont = ASN1Dict([('ue-not-involved', 0), ('ue-involved', 1)])
    RelocationType._ext = []
    
    #-----< RepetitionNumber0 >-----#
    RepetitionNumber0 = INT(name='RepetitionNumber0', mode=MODE_TYPE)
    RepetitionNumber0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< RepetitionNumber1 >-----#
    RepetitionNumber1 = INT(name='RepetitionNumber1', mode=MODE_TYPE)
    RepetitionNumber1._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< ReportArea >-----#
    ReportArea = ENUM(name='ReportArea', mode=MODE_TYPE)
    ReportArea._cont = ASN1Dict([('service-area', 0), ('geographical-area', 1)])
    ReportArea._ext = []
    
    #-----< ReportInterval >-----#
    ReportInterval = ENUM(name='ReportInterval', mode=MODE_TYPE)
    ReportInterval._cont = ASN1Dict([('ms250', 0), ('ms500', 1), ('ms1000', 2), ('ms2000', 3), ('ms3000', 4), ('ms4000', 5), ('ms6000', 6), ('ms12000', 7), ('ms16000', 8), ('ms20000', 9), ('ms24000', 10), ('ms32000', 11), ('ms64000', 12), ('ms8000', 13), ('ms28000', 14)])
    ReportInterval._ext = ['ms8000', 'ms28000']
    
    #-----< ReportAmount >-----#
    ReportAmount = ENUM(name='ReportAmount', mode=MODE_TYPE)
    ReportAmount._cont = ASN1Dict([('n1', 0), ('n2', 1), ('n4', 2), ('n8', 3), ('n16', 4), ('n32', 5), ('n64', 6), ('infinity', 7)])
    ReportAmount._ext = []
    
    #-----< RequestedGPSAssistanceData >-----#
    RequestedGPSAssistanceData = OCT_STR(name='RequestedGPSAssistanceData', mode=MODE_TYPE)
    RequestedGPSAssistanceData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=38)], ev=None, er=[])
    
    #-----< RequestedGANSSAssistanceData >-----#
    RequestedGANSSAssistanceData = OCT_STR(name='RequestedGANSSAssistanceData', mode=MODE_TYPE)
    RequestedGANSSAssistanceData._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=201)], ev=None, er=[])
    
    #-----< RequestedLocationRelatedDataType >-----#
    RequestedLocationRelatedDataType = ENUM(name='RequestedLocationRelatedDataType', mode=MODE_TYPE)
    RequestedLocationRelatedDataType._cont = ASN1Dict([('decipheringKeysUEBasedOTDOA', 0), ('decipheringKeysAssistedGPS', 1), ('dedicatedAssistanceDataUEBasedOTDOA', 2), ('dedicatedAssistanceDataAssistedGPS', 3), ('decipheringKeysAssistedGANSS', 4), ('dedicatedAssistanceDataAssistedGANSS', 5), ('decipheringKeysAssistedGPSandGANSS', 6), ('dedicatedAssistanceDataAssistedGPSandGANSS', 7)])
    RequestedLocationRelatedDataType._ext = ['decipheringKeysAssistedGANSS', 'dedicatedAssistanceDataAssistedGANSS', 'decipheringKeysAssistedGPSandGANSS', 'dedicatedAssistanceDataAssistedGPSandGANSS']
    
    #-----< RequestedMBMSIPMulticastAddressandAPNRequest >-----#
    RequestedMBMSIPMulticastAddressandAPNRequest = SEQ_OF(name='RequestedMBMSIPMulticastAddressandAPNRequest', mode=MODE_TYPE)
    _RequestedMBMSIPMulticastAddressandAPNRequest__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSIPMulticastAddressandAPNlist')))
    RequestedMBMSIPMulticastAddressandAPNRequest._cont = _RequestedMBMSIPMulticastAddressandAPNRequest__item_
    RequestedMBMSIPMulticastAddressandAPNRequest._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=512)], ev=None, er=[])
    
    #-----< MBMSIPMulticastAddressandAPNlist >-----#
    MBMSIPMulticastAddressandAPNlist = SEQ(name='MBMSIPMulticastAddressandAPNlist', mode=MODE_TYPE)
    _MBMSIPMulticastAddressandAPNlist_tMGI = SEQ(name='tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSIPMulticastAddressandAPNlist_iPMulticastAddress = OCT_STR(name='iPMulticastAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    _MBMSIPMulticastAddressandAPNlist_aPN = OCT_STR(name='aPN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'APN')))
    _MBMSIPMulticastAddressandAPNlist_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSIPMulticastAddressandAPNlist_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id._const_tab = ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id_tab
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id._const_tab_at = None
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality._const_tab = ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality_tab
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue._const_tab = ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue_tab
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSIPMulticastAddressandAPNlist_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id),
        ('criticality', ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality),
        ('extensionValue', ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue),
        ])
    __MBMSIPMulticastAddressandAPNlist_iE_Extensions__item_._ext = None
    _MBMSIPMulticastAddressandAPNlist_iE_Extensions._cont = __MBMSIPMulticastAddressandAPNlist_iE_Extensions__item_
    _MBMSIPMulticastAddressandAPNlist_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSIPMulticastAddressandAPNlist._cont = ASN1Dict([
        ('tMGI', _MBMSIPMulticastAddressandAPNlist_tMGI),
        ('iPMulticastAddress', _MBMSIPMulticastAddressandAPNlist_iPMulticastAddress),
        ('aPN', _MBMSIPMulticastAddressandAPNlist_aPN),
        ('iE-Extensions', _MBMSIPMulticastAddressandAPNlist_iE_Extensions),
        ])
    MBMSIPMulticastAddressandAPNlist._ext = []
    
    #-----< MBMSIPMulticastAddressandAPNlist-ExtIEs >-----#
    MBMSIPMulticastAddressandAPNlist_ExtIEs = CLASS(name='MBMSIPMulticastAddressandAPNlist-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSIPMulticastAddressandAPNlist_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RequestedMulticastServiceList >-----#
    RequestedMulticastServiceList = SEQ_OF(name='RequestedMulticastServiceList', mode=MODE_TYPE)
    _RequestedMulticastServiceList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    RequestedMulticastServiceList._cont = _RequestedMulticastServiceList__item_
    RequestedMulticastServiceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< Requested-RAB-Parameter-Values >-----#
    Requested_RAB_Parameter_Values = SEQ(name='Requested-RAB-Parameter-Values', mode=MODE_TYPE)
    _Requested_RAB_Parameter_Values_requestedMaxBitrates = SEQ_OF(name='requestedMaxBitrates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-MaxBitrateList')), opt=True)
    _Requested_RAB_Parameter_Values_requestedGuaranteedBitrates = SEQ_OF(name='requestedGuaranteedBitrates', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-GuaranteedBitrateList')), opt=True)
    _Requested_RAB_Parameter_Values_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Requested_RAB_Parameter_Values_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AlternativeRABConfigurationRequest')))
    _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-ExtendedMaxBitrateList')))
    _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 159), ('criticality', 'ignore'), ('Extension', _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 178), ('criticality', 'reject'), ('Extension', _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 179), ('criticality', 'reject'), ('Extension', _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 220), ('criticality', 'reject'), ('Extension', _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 221), ('criticality', 'reject'), ('Extension', _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__id._const_tab = ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__id._const_tab_at = None
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__id._const_tab_id = 'id'
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality._const_tab = ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue._const_tab = ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Requested_RAB_Parameter_Values_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Requested_RAB_Parameter_Values_iE_Extensions__item__id),
        ('criticality', ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality),
        ('extensionValue', ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue),
        ])
    __Requested_RAB_Parameter_Values_iE_Extensions__item_._ext = None
    _Requested_RAB_Parameter_Values_iE_Extensions._cont = __Requested_RAB_Parameter_Values_iE_Extensions__item_
    _Requested_RAB_Parameter_Values_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Requested_RAB_Parameter_Values._cont = ASN1Dict([
        ('requestedMaxBitrates', _Requested_RAB_Parameter_Values_requestedMaxBitrates),
        ('requestedGuaranteedBitrates', _Requested_RAB_Parameter_Values_requestedGuaranteedBitrates),
        ('iE-Extensions', _Requested_RAB_Parameter_Values_iE_Extensions),
        ])
    Requested_RAB_Parameter_Values._ext = []
    
    #-----< Requested-RAB-Parameter-Values-ExtIEs >-----#
    Requested_RAB_Parameter_Values_ExtIEs = CLASS(name='Requested-RAB-Parameter-Values-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AlternativeRABConfigurationRequest')))
    _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-ExtendedMaxBitrateList')))
    _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-ExtendedGuaranteedBitrateList')))
    _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_4 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedRAB-ParameterBitrateList')))
    Requested_RAB_Parameter_Values_ExtIEs._val = ASN1Set(rv=[dict([('id', 159), ('criticality', 'ignore'), ('Extension', _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 178), ('criticality', 'reject'), ('Extension', _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 179), ('criticality', 'reject'), ('Extension', _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 220), ('criticality', 'reject'), ('Extension', _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 221), ('criticality', 'reject'), ('Extension', _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Requested-RAB-Parameter-ExtendedMaxBitrateList >-----#
    Requested_RAB_Parameter_ExtendedMaxBitrateList = SEQ_OF(name='Requested-RAB-Parameter-ExtendedMaxBitrateList', mode=MODE_TYPE)
    _Requested_RAB_Parameter_ExtendedMaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedMaxBitrate')))
    Requested_RAB_Parameter_ExtendedMaxBitrateList._cont = _Requested_RAB_Parameter_ExtendedMaxBitrateList__item_
    Requested_RAB_Parameter_ExtendedMaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Requested-RAB-Parameter-ExtendedGuaranteedBitrateList >-----#
    Requested_RAB_Parameter_ExtendedGuaranteedBitrateList = SEQ_OF(name='Requested-RAB-Parameter-ExtendedGuaranteedBitrateList', mode=MODE_TYPE)
    _Requested_RAB_Parameter_ExtendedGuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedGuaranteedBitrate')))
    Requested_RAB_Parameter_ExtendedGuaranteedBitrateList._cont = _Requested_RAB_Parameter_ExtendedGuaranteedBitrateList__item_
    Requested_RAB_Parameter_ExtendedGuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Requested-RAB-Parameter-MaxBitrateList >-----#
    Requested_RAB_Parameter_MaxBitrateList = SEQ_OF(name='Requested-RAB-Parameter-MaxBitrateList', mode=MODE_TYPE)
    _Requested_RAB_Parameter_MaxBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MaxBitrate')))
    Requested_RAB_Parameter_MaxBitrateList._cont = _Requested_RAB_Parameter_MaxBitrateList__item_
    Requested_RAB_Parameter_MaxBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< Requested-RAB-Parameter-GuaranteedBitrateList >-----#
    Requested_RAB_Parameter_GuaranteedBitrateList = SEQ_OF(name='Requested-RAB-Parameter-GuaranteedBitrateList', mode=MODE_TYPE)
    _Requested_RAB_Parameter_GuaranteedBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GuaranteedBitrate')))
    Requested_RAB_Parameter_GuaranteedBitrateList._cont = _Requested_RAB_Parameter_GuaranteedBitrateList__item_
    Requested_RAB_Parameter_GuaranteedBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< RequestType >-----#
    RequestType = SEQ(name='RequestType', mode=MODE_TYPE)
    _RequestType_event = ENUM(name='event', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Event')))
    _RequestType_reportArea = ENUM(name='reportArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ReportArea')))
    _RequestType_accuracyCode = INT(name='accuracyCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RequestType_accuracyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    RequestType._cont = ASN1Dict([
        ('event', _RequestType_event),
        ('reportArea', _RequestType_reportArea),
        ('accuracyCode', _RequestType_accuracyCode),
        ])
    RequestType._ext = []
    
    #-----< ResidualBitErrorRatio >-----#
    ResidualBitErrorRatio = SEQ(name='ResidualBitErrorRatio', mode=MODE_TYPE)
    _ResidualBitErrorRatio_mantissa = INT(name='mantissa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResidualBitErrorRatio_mantissa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    _ResidualBitErrorRatio_exponent = INT(name='exponent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ResidualBitErrorRatio_exponent._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _ResidualBitErrorRatio_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResidualBitErrorRatio_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResidualBitErrorRatio_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____ResidualBitErrorRatio_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____ResidualBitErrorRatio_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResidualBitErrorRatio_iE_Extensions__item__id._const_tab = ____ResidualBitErrorRatio_iE_Extensions__item__id_tab
    ___ResidualBitErrorRatio_iE_Extensions__item__id._const_tab_at = None
    ___ResidualBitErrorRatio_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResidualBitErrorRatio_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____ResidualBitErrorRatio_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____ResidualBitErrorRatio_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResidualBitErrorRatio_iE_Extensions__item__criticality._const_tab = ____ResidualBitErrorRatio_iE_Extensions__item__criticality_tab
    ___ResidualBitErrorRatio_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResidualBitErrorRatio_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____ResidualBitErrorRatio_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____ResidualBitErrorRatio_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue._const_tab = ____ResidualBitErrorRatio_iE_Extensions__item__extensionValue_tab
    ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResidualBitErrorRatio_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResidualBitErrorRatio_iE_Extensions__item__id),
        ('criticality', ___ResidualBitErrorRatio_iE_Extensions__item__criticality),
        ('extensionValue', ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue),
        ])
    __ResidualBitErrorRatio_iE_Extensions__item_._ext = None
    _ResidualBitErrorRatio_iE_Extensions._cont = __ResidualBitErrorRatio_iE_Extensions__item_
    _ResidualBitErrorRatio_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResidualBitErrorRatio._cont = ASN1Dict([
        ('mantissa', _ResidualBitErrorRatio_mantissa),
        ('exponent', _ResidualBitErrorRatio_exponent),
        ('iE-Extensions', _ResidualBitErrorRatio_iE_Extensions),
        ])
    ResidualBitErrorRatio._ext = None
    
    #-----< ResidualBitErrorRatio-ExtIEs >-----#
    ResidualBitErrorRatio_ExtIEs = CLASS(name='ResidualBitErrorRatio-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ResidualBitErrorRatio_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResponseTime >-----#
    ResponseTime = ENUM(name='ResponseTime', mode=MODE_TYPE)
    ResponseTime._cont = ASN1Dict([('lowdelay', 0), ('delaytolerant', 1)])
    ResponseTime._ext = []
    
    #-----< RIMInformation >-----#
    RIMInformation = OCT_STR(name='RIMInformation', mode=MODE_TYPE)
    
    #-----< RIM-Transfer >-----#
    RIM_Transfer = SEQ(name='RIM-Transfer', mode=MODE_TYPE)
    _RIM_Transfer_rIMInformation = OCT_STR(name='rIMInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RIMInformation')))
    _RIM_Transfer_rIMRoutingAddress = CHOICE(name='rIMRoutingAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RIMRoutingAddress')), opt=True)
    _RIM_Transfer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RIM_Transfer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RIM_Transfer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RIM_Transfer_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RIM_Transfer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIM_Transfer_iE_Extensions__item__id._const_tab = ____RIM_Transfer_iE_Extensions__item__id_tab
    ___RIM_Transfer_iE_Extensions__item__id._const_tab_at = None
    ___RIM_Transfer_iE_Extensions__item__id._const_tab_id = 'id'
    ___RIM_Transfer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RIM_Transfer_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RIM_Transfer_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIM_Transfer_iE_Extensions__item__criticality._const_tab = ____RIM_Transfer_iE_Extensions__item__criticality_tab
    ___RIM_Transfer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RIM_Transfer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RIM_Transfer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RIM_Transfer_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RIM_Transfer_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RIM_Transfer_iE_Extensions__item__extensionValue._const_tab = ____RIM_Transfer_iE_Extensions__item__extensionValue_tab
    ___RIM_Transfer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RIM_Transfer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RIM_Transfer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RIM_Transfer_iE_Extensions__item__id),
        ('criticality', ___RIM_Transfer_iE_Extensions__item__criticality),
        ('extensionValue', ___RIM_Transfer_iE_Extensions__item__extensionValue),
        ])
    __RIM_Transfer_iE_Extensions__item_._ext = None
    _RIM_Transfer_iE_Extensions._cont = __RIM_Transfer_iE_Extensions__item_
    _RIM_Transfer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RIM_Transfer._cont = ASN1Dict([
        ('rIMInformation', _RIM_Transfer_rIMInformation),
        ('rIMRoutingAddress', _RIM_Transfer_rIMRoutingAddress),
        ('iE-Extensions', _RIM_Transfer_iE_Extensions),
        ])
    RIM_Transfer._ext = None
    
    #-----< RIM-Transfer-ExtIEs >-----#
    RIM_Transfer_ExtIEs = CLASS(name='RIM-Transfer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RIM_Transfer_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RIMRoutingAddress >-----#
    RIMRoutingAddress = CHOICE(name='RIMRoutingAddress', mode=MODE_TYPE)
    _RIMRoutingAddress_targetRNC_ID = SEQ(name='targetRNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ID')))
    _RIMRoutingAddress_gERAN_Cell_ID = SEQ(name='gERAN-Cell-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Cell-ID')))
    _RIMRoutingAddress_targeteNB_ID = SEQ(name='targeteNB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetENB-ID')))
    RIMRoutingAddress._cont = ASN1Dict([
        ('targetRNC-ID', _RIMRoutingAddress_targetRNC_ID),
        ('gERAN-Cell-ID', _RIMRoutingAddress_gERAN_Cell_ID),
        ('targeteNB-ID', _RIMRoutingAddress_targeteNB_ID),
        ])
    RIMRoutingAddress._ext = ['targeteNB-ID']
    
    #-----< RNC-ID >-----#
    RNC_ID = INT(name='RNC-ID', mode=MODE_TYPE)
    RNC_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< RNCTraceInformation >-----#
    RNCTraceInformation = SEQ(name='RNCTraceInformation', mode=MODE_TYPE)
    _RNCTraceInformation_traceReference = OCT_STR(name='traceReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _RNCTraceInformation_traceActivationIndicator = ENUM(name='traceActivationIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RNCTraceInformation_traceActivationIndicator._cont = ASN1Dict([('activated', 0), ('deactivated', 1)])
    _RNCTraceInformation_traceActivationIndicator._ext = None
    _RNCTraceInformation_equipmentsToBeTraced = CHOICE(name='equipmentsToBeTraced', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'EquipmentsToBeTraced')), opt=True)
    _RNCTraceInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RNCTraceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RNCTraceInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RNCTraceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionReference')))
    _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IMSI')))
    _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UTRAN-CellID')))
    ____RNCTraceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 255), ('criticality', 'ignore'), ('Extension', _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 256), ('criticality', 'ignore'), ('Extension', _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Extension', _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 270), ('criticality', 'ignore'), ('Extension', _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RNCTraceInformation_iE_Extensions__item__id._const_tab = ____RNCTraceInformation_iE_Extensions__item__id_tab
    ___RNCTraceInformation_iE_Extensions__item__id._const_tab_at = None
    ___RNCTraceInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___RNCTraceInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RNCTraceInformation_iE_Extensions__item__criticality._const_tab = ____RNCTraceInformation_iE_Extensions__item__id_tab
    ___RNCTraceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RNCTraceInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RNCTraceInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RNCTraceInformation_iE_Extensions__item__extensionValue._const_tab = ____RNCTraceInformation_iE_Extensions__item__id_tab
    ___RNCTraceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RNCTraceInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RNCTraceInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RNCTraceInformation_iE_Extensions__item__id),
        ('criticality', ___RNCTraceInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___RNCTraceInformation_iE_Extensions__item__extensionValue),
        ])
    __RNCTraceInformation_iE_Extensions__item_._ext = None
    _RNCTraceInformation_iE_Extensions._cont = __RNCTraceInformation_iE_Extensions__item_
    _RNCTraceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RNCTraceInformation._cont = ASN1Dict([
        ('traceReference', _RNCTraceInformation_traceReference),
        ('traceActivationIndicator', _RNCTraceInformation_traceActivationIndicator),
        ('equipmentsToBeTraced', _RNCTraceInformation_equipmentsToBeTraced),
        ('iE-Extensions', _RNCTraceInformation_iE_Extensions),
        ])
    RNCTraceInformation._ext = None
    
    #-----< RNCTraceInformation-ExtIEs >-----#
    RNCTraceInformation_ExtIEs = CLASS(name='RNCTraceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RNCTraceInformation_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionReference')))
    _RNCTraceInformation_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IMSI')))
    _RNCTraceInformation_ExtIEs_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _RNCTraceInformation_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UTRAN-CellID')))
    RNCTraceInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 255), ('criticality', 'ignore'), ('Extension', _RNCTraceInformation_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 256), ('criticality', 'ignore'), ('Extension', _RNCTraceInformation_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Extension', _RNCTraceInformation_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 270), ('criticality', 'ignore'), ('Extension', _RNCTraceInformation_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RNSAPRelocationParameters >-----#
    RNSAPRelocationParameters = SEQ(name='RNSAPRelocationParameters', mode=MODE_TYPE)
    _RNSAPRelocationParameters_rabParmetersList = SEQ_OF(name='rabParmetersList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RABParametersList')), opt=True)
    _RNSAPRelocationParameters_locationReporting = SEQ(name='locationReporting', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LocationReportingTransferInformation')), opt=True)
    _RNSAPRelocationParameters_traceInformation = SEQ(name='traceInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceInformation')), opt=True)
    _RNSAPRelocationParameters_sourceSAI = SEQ(name='sourceSAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAI')), opt=True)
    _RNSAPRelocationParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RNSAPRelocationParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RNSAPRelocationParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RNSAPRelocationParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RNSAPRelocationParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RNSAPRelocationParameters_iE_Extensions__item__id._const_tab = ____RNSAPRelocationParameters_iE_Extensions__item__id_tab
    ___RNSAPRelocationParameters_iE_Extensions__item__id._const_tab_at = None
    ___RNSAPRelocationParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___RNSAPRelocationParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RNSAPRelocationParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RNSAPRelocationParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RNSAPRelocationParameters_iE_Extensions__item__criticality._const_tab = ____RNSAPRelocationParameters_iE_Extensions__item__criticality_tab
    ___RNSAPRelocationParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RNSAPRelocationParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RNSAPRelocationParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RNSAPRelocationParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue._const_tab = ____RNSAPRelocationParameters_iE_Extensions__item__extensionValue_tab
    ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RNSAPRelocationParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RNSAPRelocationParameters_iE_Extensions__item__id),
        ('criticality', ___RNSAPRelocationParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue),
        ])
    __RNSAPRelocationParameters_iE_Extensions__item_._ext = None
    _RNSAPRelocationParameters_iE_Extensions._cont = __RNSAPRelocationParameters_iE_Extensions__item_
    _RNSAPRelocationParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RNSAPRelocationParameters._cont = ASN1Dict([
        ('rabParmetersList', _RNSAPRelocationParameters_rabParmetersList),
        ('locationReporting', _RNSAPRelocationParameters_locationReporting),
        ('traceInformation', _RNSAPRelocationParameters_traceInformation),
        ('sourceSAI', _RNSAPRelocationParameters_sourceSAI),
        ('iE-Extensions', _RNSAPRelocationParameters_iE_Extensions),
        ])
    RNSAPRelocationParameters._ext = []
    
    #-----< RNSAPRelocationParameters-ExtIEs >-----#
    RNSAPRelocationParameters_ExtIEs = CLASS(name='RNSAPRelocationParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RNSAPRelocationParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RRC-Container >-----#
    RRC_Container = OCT_STR(name='RRC-Container', mode=MODE_TYPE)
    
    #-----< RTLoadValue >-----#
    RTLoadValue = INT(name='RTLoadValue', mode=MODE_TYPE)
    RTLoadValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    
    #-----< RSRVCC-HO-Indication >-----#
    RSRVCC_HO_Indication = ENUM(name='RSRVCC-HO-Indication', mode=MODE_TYPE)
    RSRVCC_HO_Indication._cont = ASN1Dict([('ps-only', 0)])
    RSRVCC_HO_Indication._ext = []
    
    #-----< RSRVCC-Information >-----#
    RSRVCC_Information = SEQ(name='RSRVCC-Information', mode=MODE_TYPE)
    _RSRVCC_Information_nonce = BIT_STR(name='nonce', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RSRVCC_Information_nonce._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _RSRVCC_Information_iMSInformation = OCT_STR(name='iMSInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RSRVCC_Information_iMSInformation._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _RSRVCC_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RSRVCC_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RSRVCC_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RSRVCC_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RSRVCC_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RSRVCC_Information_iE_Extensions__item__id._const_tab = ____RSRVCC_Information_iE_Extensions__item__id_tab
    ___RSRVCC_Information_iE_Extensions__item__id._const_tab_at = None
    ___RSRVCC_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___RSRVCC_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RSRVCC_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RSRVCC_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RSRVCC_Information_iE_Extensions__item__criticality._const_tab = ____RSRVCC_Information_iE_Extensions__item__criticality_tab
    ___RSRVCC_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RSRVCC_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RSRVCC_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RSRVCC_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RSRVCC_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RSRVCC_Information_iE_Extensions__item__extensionValue._const_tab = ____RSRVCC_Information_iE_Extensions__item__extensionValue_tab
    ___RSRVCC_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RSRVCC_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RSRVCC_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RSRVCC_Information_iE_Extensions__item__id),
        ('criticality', ___RSRVCC_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___RSRVCC_Information_iE_Extensions__item__extensionValue),
        ])
    __RSRVCC_Information_iE_Extensions__item_._ext = None
    _RSRVCC_Information_iE_Extensions._cont = __RSRVCC_Information_iE_Extensions__item_
    _RSRVCC_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RSRVCC_Information._cont = ASN1Dict([
        ('nonce', _RSRVCC_Information_nonce),
        ('iMSInformation', _RSRVCC_Information_iMSInformation),
        ('iE-Extensions', _RSRVCC_Information_iE_Extensions),
        ])
    RSRVCC_Information._ext = []
    
    #-----< RSRVCC-Information-ExtIEs >-----#
    RSRVCC_Information_ExtIEs = CLASS(name='RSRVCC-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RSRVCC_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RSRVCC-Operation-Possible >-----#
    RSRVCC_Operation_Possible = ENUM(name='RSRVCC-Operation-Possible', mode=MODE_TYPE)
    RSRVCC_Operation_Possible._cont = ASN1Dict([('rsrvcc-possible', 0)])
    RSRVCC_Operation_Possible._ext = []
    
    #-----< SAC >-----#
    SAC = OCT_STR(name='SAC', mode=MODE_TYPE)
    SAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< SAI >-----#
    SAI = SEQ(name='SAI', mode=MODE_TYPE)
    _SAI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _SAI_lAC = OCT_STR(name='lAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAC')))
    _SAI_sAC = OCT_STR(name='sAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAC')))
    _SAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SAI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAI_iE_Extensions__item__id._const_tab = ____SAI_iE_Extensions__item__id_tab
    ___SAI_iE_Extensions__item__id._const_tab_at = None
    ___SAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___SAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAI_iE_Extensions__item__criticality._const_tab = ____SAI_iE_Extensions__item__criticality_tab
    ___SAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SAI_iE_Extensions__item__extensionValue._const_tab = ____SAI_iE_Extensions__item__extensionValue_tab
    ___SAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SAI_iE_Extensions__item__id),
        ('criticality', ___SAI_iE_Extensions__item__criticality),
        ('extensionValue', ___SAI_iE_Extensions__item__extensionValue),
        ])
    __SAI_iE_Extensions__item_._ext = None
    _SAI_iE_Extensions._cont = __SAI_iE_Extensions__item_
    _SAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SAI._cont = ASN1Dict([
        ('pLMNidentity', _SAI_pLMNidentity),
        ('lAC', _SAI_lAC),
        ('sAC', _SAI_sAC),
        ('iE-Extensions', _SAI_iE_Extensions),
        ])
    SAI._ext = None
    
    #-----< SAI-ExtIEs >-----#
    SAI_ExtIEs = CLASS(name='SAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SAPI >-----#
    SAPI = ENUM(name='SAPI', mode=MODE_TYPE)
    SAPI._cont = ASN1Dict([('sapi-0', 0), ('sapi-3', 1)])
    SAPI._ext = []
    
    #-----< SessionUpdateID >-----#
    SessionUpdateID = INT(name='SessionUpdateID', mode=MODE_TYPE)
    SessionUpdateID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1048575)], ev=None, er=[])
    
    #-----< Shared-Network-Information >-----#
    Shared_Network_Information = SEQ(name='Shared-Network-Information', mode=MODE_TYPE)
    _Shared_Network_Information_pLMNs_in_shared_network = SEQ_OF(name='pLMNs-in-shared-network', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNs-in-shared-network')))
    _Shared_Network_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Shared_Network_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Shared_Network_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Shared_Network_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Shared_Network_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Shared_Network_Information_iE_Extensions__item__id._const_tab = ____Shared_Network_Information_iE_Extensions__item__id_tab
    ___Shared_Network_Information_iE_Extensions__item__id._const_tab_at = None
    ___Shared_Network_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___Shared_Network_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Shared_Network_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Shared_Network_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Shared_Network_Information_iE_Extensions__item__criticality._const_tab = ____Shared_Network_Information_iE_Extensions__item__criticality_tab
    ___Shared_Network_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___Shared_Network_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___Shared_Network_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Shared_Network_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Shared_Network_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Shared_Network_Information_iE_Extensions__item__extensionValue._const_tab = ____Shared_Network_Information_iE_Extensions__item__extensionValue_tab
    ___Shared_Network_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Shared_Network_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __Shared_Network_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___Shared_Network_Information_iE_Extensions__item__id),
        ('criticality', ___Shared_Network_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___Shared_Network_Information_iE_Extensions__item__extensionValue),
        ])
    __Shared_Network_Information_iE_Extensions__item_._ext = None
    _Shared_Network_Information_iE_Extensions._cont = __Shared_Network_Information_iE_Extensions__item_
    _Shared_Network_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Shared_Network_Information._cont = ASN1Dict([
        ('pLMNs-in-shared-network', _Shared_Network_Information_pLMNs_in_shared_network),
        ('iE-Extensions', _Shared_Network_Information_iE_Extensions),
        ])
    Shared_Network_Information._ext = []
    
    #-----< Session-Re-establishment-Indicator >-----#
    Session_Re_establishment_Indicator = ENUM(name='Session-Re-establishment-Indicator', mode=MODE_TYPE)
    Session_Re_establishment_Indicator._cont = ASN1Dict([('true', 0)])
    Session_Re_establishment_Indicator._ext = []
    
    #-----< Shared-Network-Information-ExtIEs >-----#
    Shared_Network_Information_ExtIEs = CLASS(name='Shared-Network-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Shared_Network_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SignallingIndication >-----#
    SignallingIndication = ENUM(name='SignallingIndication', mode=MODE_TYPE)
    SignallingIndication._cont = ASN1Dict([('signalling', 0)])
    SignallingIndication._ext = []
    
    #-----< SDU-ErrorRatio >-----#
    SDU_ErrorRatio = SEQ(name='SDU-ErrorRatio', mode=MODE_TYPE)
    _SDU_ErrorRatio_mantissa = INT(name='mantissa', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SDU_ErrorRatio_mantissa._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=9)], ev=None, er=[])
    _SDU_ErrorRatio_exponent = INT(name='exponent', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SDU_ErrorRatio_exponent._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    _SDU_ErrorRatio_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SDU_ErrorRatio_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SDU_ErrorRatio_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SDU_ErrorRatio_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SDU_ErrorRatio_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDU_ErrorRatio_iE_Extensions__item__id._const_tab = ____SDU_ErrorRatio_iE_Extensions__item__id_tab
    ___SDU_ErrorRatio_iE_Extensions__item__id._const_tab_at = None
    ___SDU_ErrorRatio_iE_Extensions__item__id._const_tab_id = 'id'
    ___SDU_ErrorRatio_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SDU_ErrorRatio_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SDU_ErrorRatio_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDU_ErrorRatio_iE_Extensions__item__criticality._const_tab = ____SDU_ErrorRatio_iE_Extensions__item__criticality_tab
    ___SDU_ErrorRatio_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SDU_ErrorRatio_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SDU_ErrorRatio_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SDU_ErrorRatio_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SDU_ErrorRatio_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SDU_ErrorRatio_iE_Extensions__item__extensionValue._const_tab = ____SDU_ErrorRatio_iE_Extensions__item__extensionValue_tab
    ___SDU_ErrorRatio_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SDU_ErrorRatio_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SDU_ErrorRatio_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SDU_ErrorRatio_iE_Extensions__item__id),
        ('criticality', ___SDU_ErrorRatio_iE_Extensions__item__criticality),
        ('extensionValue', ___SDU_ErrorRatio_iE_Extensions__item__extensionValue),
        ])
    __SDU_ErrorRatio_iE_Extensions__item_._ext = None
    _SDU_ErrorRatio_iE_Extensions._cont = __SDU_ErrorRatio_iE_Extensions__item_
    _SDU_ErrorRatio_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SDU_ErrorRatio._cont = ASN1Dict([
        ('mantissa', _SDU_ErrorRatio_mantissa),
        ('exponent', _SDU_ErrorRatio_exponent),
        ('iE-Extensions', _SDU_ErrorRatio_iE_Extensions),
        ])
    SDU_ErrorRatio._ext = None
    
    #-----< SDU-ErrorRatio-ExtIEs >-----#
    SDU_ErrorRatio_ExtIEs = CLASS(name='SDU-ErrorRatio-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SDU_ErrorRatio_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDU-FormatInformationParameters >-----#
    SDU_FormatInformationParameters = SEQ_OF(name='SDU-FormatInformationParameters', mode=MODE_TYPE)
    _SDU_FormatInformationParameters__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __SDU_FormatInformationParameters__item__subflowSDU_Size = INT(name='subflowSDU-Size', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SubflowSDU-Size')), opt=True)
    __SDU_FormatInformationParameters__item__rAB_SubflowCombinationBitRate = INT(name='rAB-SubflowCombinationBitRate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-SubflowCombinationBitRate')), opt=True)
    __SDU_FormatInformationParameters__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___SDU_FormatInformationParameters__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__id._const_tab = _____SDU_FormatInformationParameters__item__iE_Extensions__item__id_tab
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__id._const_tab_at = None
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality._const_tab = _____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality_tab
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue._const_tab = _____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue_tab
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___SDU_FormatInformationParameters__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____SDU_FormatInformationParameters__item__iE_Extensions__item__id),
        ('criticality', ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality),
        ('extensionValue', ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue),
        ])
    ___SDU_FormatInformationParameters__item__iE_Extensions__item_._ext = None
    __SDU_FormatInformationParameters__item__iE_Extensions._cont = ___SDU_FormatInformationParameters__item__iE_Extensions__item_
    __SDU_FormatInformationParameters__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _SDU_FormatInformationParameters__item_._cont = ASN1Dict([
        ('subflowSDU-Size', __SDU_FormatInformationParameters__item__subflowSDU_Size),
        ('rAB-SubflowCombinationBitRate', __SDU_FormatInformationParameters__item__rAB_SubflowCombinationBitRate),
        ('iE-Extensions', __SDU_FormatInformationParameters__item__iE_Extensions),
        ])
    _SDU_FormatInformationParameters__item_._ext = []
    SDU_FormatInformationParameters._cont = _SDU_FormatInformationParameters__item_
    SDU_FormatInformationParameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SDU-FormatInformationParameters-ExtIEs >-----#
    SDU_FormatInformationParameters_ExtIEs = CLASS(name='SDU-FormatInformationParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SDU_FormatInformationParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SDU-Parameters >-----#
    SDU_Parameters = SEQ_OF(name='SDU-Parameters', mode=MODE_TYPE)
    _SDU_Parameters__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __SDU_Parameters__item__sDU_ErrorRatio = SEQ(name='sDU-ErrorRatio', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SDU-ErrorRatio')), opt=True)
    __SDU_Parameters__item__residualBitErrorRatio = SEQ(name='residualBitErrorRatio', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ResidualBitErrorRatio')))
    __SDU_Parameters__item__deliveryOfErroneousSDU = ENUM(name='deliveryOfErroneousSDU', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DeliveryOfErroneousSDU')))
    __SDU_Parameters__item__sDU_FormatInformationParameters = SEQ_OF(name='sDU-FormatInformationParameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SDU-FormatInformationParameters')), opt=True)
    __SDU_Parameters__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___SDU_Parameters__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____SDU_Parameters__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____SDU_Parameters__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_Parameters__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_Parameters__item__iE_Extensions__item__id._const_tab = _____SDU_Parameters__item__iE_Extensions__item__id_tab
    ____SDU_Parameters__item__iE_Extensions__item__id._const_tab_at = None
    ____SDU_Parameters__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____SDU_Parameters__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____SDU_Parameters__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_Parameters__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_Parameters__item__iE_Extensions__item__criticality._const_tab = _____SDU_Parameters__item__iE_Extensions__item__criticality_tab
    ____SDU_Parameters__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____SDU_Parameters__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____SDU_Parameters__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____SDU_Parameters__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SDU_Parameters__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____SDU_Parameters__item__iE_Extensions__item__extensionValue._const_tab = _____SDU_Parameters__item__iE_Extensions__item__extensionValue_tab
    ____SDU_Parameters__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____SDU_Parameters__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___SDU_Parameters__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____SDU_Parameters__item__iE_Extensions__item__id),
        ('criticality', ____SDU_Parameters__item__iE_Extensions__item__criticality),
        ('extensionValue', ____SDU_Parameters__item__iE_Extensions__item__extensionValue),
        ])
    ___SDU_Parameters__item__iE_Extensions__item_._ext = None
    __SDU_Parameters__item__iE_Extensions._cont = ___SDU_Parameters__item__iE_Extensions__item_
    __SDU_Parameters__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _SDU_Parameters__item_._cont = ASN1Dict([
        ('sDU-ErrorRatio', __SDU_Parameters__item__sDU_ErrorRatio),
        ('residualBitErrorRatio', __SDU_Parameters__item__residualBitErrorRatio),
        ('deliveryOfErroneousSDU', __SDU_Parameters__item__deliveryOfErroneousSDU),
        ('sDU-FormatInformationParameters', __SDU_Parameters__item__sDU_FormatInformationParameters),
        ('iE-Extensions', __SDU_Parameters__item__iE_Extensions),
        ])
    _SDU_Parameters__item_._ext = []
    SDU_Parameters._cont = _SDU_Parameters__item_
    SDU_Parameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< SDU-Parameters-ExtIEs >-----#
    SDU_Parameters_ExtIEs = CLASS(name='SDU-Parameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SDU_Parameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SGSN-Group-Identity >-----#
    SGSN_Group_Identity = CHOICE(name='SGSN-Group-Identity', mode=MODE_TYPE)
    _SGSN_Group_Identity_null_NRI = BIT_STR(name='null-NRI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Null-NRI')))
    _SGSN_Group_Identity_sGSN_Group_ID = OCT_STR(name='sGSN-Group-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SGSN-Group-ID')))
    SGSN_Group_Identity._cont = ASN1Dict([
        ('null-NRI', _SGSN_Group_Identity_null_NRI),
        ('sGSN-Group-ID', _SGSN_Group_Identity_sGSN_Group_ID),
        ])
    SGSN_Group_Identity._ext = None
    
    #-----< SGSN-Group-ID >-----#
    SGSN_Group_ID = OCT_STR(name='SGSN-Group-ID', mode=MODE_TYPE)
    SGSN_Group_ID._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< SNA-Access-Information >-----#
    SNA_Access_Information = SEQ(name='SNA-Access-Information', mode=MODE_TYPE)
    _SNA_Access_Information_authorisedPLMNs = SEQ_OF(name='authorisedPLMNs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'AuthorisedPLMNs')))
    _SNA_Access_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SNA_Access_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SNA_Access_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SNA_Access_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SNA_Access_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNA_Access_Information_iE_Extensions__item__id._const_tab = ____SNA_Access_Information_iE_Extensions__item__id_tab
    ___SNA_Access_Information_iE_Extensions__item__id._const_tab_at = None
    ___SNA_Access_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___SNA_Access_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SNA_Access_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SNA_Access_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNA_Access_Information_iE_Extensions__item__criticality._const_tab = ____SNA_Access_Information_iE_Extensions__item__criticality_tab
    ___SNA_Access_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SNA_Access_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SNA_Access_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SNA_Access_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SNA_Access_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SNA_Access_Information_iE_Extensions__item__extensionValue._const_tab = ____SNA_Access_Information_iE_Extensions__item__extensionValue_tab
    ___SNA_Access_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SNA_Access_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SNA_Access_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SNA_Access_Information_iE_Extensions__item__id),
        ('criticality', ___SNA_Access_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___SNA_Access_Information_iE_Extensions__item__extensionValue),
        ])
    __SNA_Access_Information_iE_Extensions__item_._ext = None
    _SNA_Access_Information_iE_Extensions._cont = __SNA_Access_Information_iE_Extensions__item_
    _SNA_Access_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SNA_Access_Information._cont = ASN1Dict([
        ('authorisedPLMNs', _SNA_Access_Information_authorisedPLMNs),
        ('iE-Extensions', _SNA_Access_Information_iE_Extensions),
        ])
    SNA_Access_Information._ext = []
    
    #-----< SNA-Access-Information-ExtIEs >-----#
    SNA_Access_Information_ExtIEs = CLASS(name='SNA-Access-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SNA_Access_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SNAC >-----#
    SNAC = INT(name='SNAC', mode=MODE_TYPE)
    SNAC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< Service-Handover >-----#
    Service_Handover = ENUM(name='Service-Handover', mode=MODE_TYPE)
    Service_Handover._cont = ASN1Dict([('handover-to-GSM-should-be-performed', 0), ('handover-to-GSM-should-not-be-performed', 1), ('handover-to-GSM-shall-not-be-performed', 2)])
    Service_Handover._ext = []
    
    #-----< Source-ToTarget-TransparentContainer >-----#
    Source_ToTarget_TransparentContainer = OCT_STR(name='Source-ToTarget-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceeNodeB-ToTargeteNodeB-TransparentContainer >-----#
    SourceeNodeB_ToTargeteNodeB_TransparentContainer = OCT_STR(name='SourceeNodeB-ToTargeteNodeB-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceCellID >-----#
    SourceCellID = CHOICE(name='SourceCellID', mode=MODE_TYPE)
    _SourceCellID_sourceUTRANCellID = SEQ(name='sourceUTRANCellID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SourceUTRANCellID')))
    _SourceCellID_sourceGERANCellID = SEQ(name='sourceGERANCellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CGI')))
    SourceCellID._cont = ASN1Dict([
        ('sourceUTRANCellID', _SourceCellID_sourceUTRANCellID),
        ('sourceGERANCellID', _SourceCellID_sourceGERANCellID),
        ])
    SourceCellID._ext = []
    
    #-----< SourceBSS-ToTargetBSS-TransparentContainer >-----#
    SourceBSS_ToTargetBSS_TransparentContainer = OCT_STR(name='SourceBSS-ToTargetBSS-TransparentContainer', mode=MODE_TYPE)
    
    #-----< SourceID >-----#
    SourceID = CHOICE(name='SourceID', mode=MODE_TYPE)
    _SourceID_sourceRNC_ID = SEQ(name='sourceRNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SourceRNC-ID')))
    _SourceID_sAI = SEQ(name='sAI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    SourceID._cont = ASN1Dict([
        ('sourceRNC-ID', _SourceID_sourceRNC_ID),
        ('sAI', _SourceID_sAI),
        ])
    SourceID._ext = []
    
    #-----< SourceRNC-ID >-----#
    SourceRNC_ID = SEQ(name='SourceRNC-ID', mode=MODE_TYPE)
    _SourceRNC_ID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _SourceRNC_ID_rNC_ID = INT(name='rNC-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RNC-ID')))
    _SourceRNC_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceRNC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SourceRNC_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SourceRNC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SourceRNC_ID_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____SourceRNC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _____SourceRNC_ID_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SourceRNC_ID_iE_Extensions__item__id._const_tab = ____SourceRNC_ID_iE_Extensions__item__id_tab
    ___SourceRNC_ID_iE_Extensions__item__id._const_tab_at = None
    ___SourceRNC_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___SourceRNC_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SourceRNC_ID_iE_Extensions__item__criticality._const_tab = ____SourceRNC_ID_iE_Extensions__item__id_tab
    ___SourceRNC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SourceRNC_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SourceRNC_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SourceRNC_ID_iE_Extensions__item__extensionValue._const_tab = ____SourceRNC_ID_iE_Extensions__item__id_tab
    ___SourceRNC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SourceRNC_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SourceRNC_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SourceRNC_ID_iE_Extensions__item__id),
        ('criticality', ___SourceRNC_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___SourceRNC_ID_iE_Extensions__item__extensionValue),
        ])
    __SourceRNC_ID_iE_Extensions__item_._ext = None
    _SourceRNC_ID_iE_Extensions._cont = __SourceRNC_ID_iE_Extensions__item_
    _SourceRNC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceRNC_ID._cont = ASN1Dict([
        ('pLMNidentity', _SourceRNC_ID_pLMNidentity),
        ('rNC-ID', _SourceRNC_ID_rNC_ID),
        ('iE-Extensions', _SourceRNC_ID_iE_Extensions),
        ])
    SourceRNC_ID._ext = None
    
    #-----< SourceRNC-ID-ExtIEs >-----#
    SourceRNC_ID_ExtIEs = CLASS(name='SourceRNC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _SourceRNC_ID_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    SourceRNC_ID_ExtIEs._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _SourceRNC_ID_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SourceRNC-ToTargetRNC-TransparentContainer >-----#
    SourceRNC_ToTargetRNC_TransparentContainer = SEQ(name='SourceRNC-ToTargetRNC-TransparentContainer', mode=MODE_TYPE)
    _SourceRNC_ToTargetRNC_TransparentContainer_rRC_Container = OCT_STR(name='rRC-Container', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    _SourceRNC_ToTargetRNC_TransparentContainer_numberOfIuInstances = INT(name='numberOfIuInstances', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NumberOfIuInstances')))
    _SourceRNC_ToTargetRNC_TransparentContainer_relocationType = ENUM(name='relocationType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RelocationType')))
    _SourceRNC_ToTargetRNC_TransparentContainer_chosenIntegrityProtectionAlgorithm = INT(name='chosenIntegrityProtectionAlgorithm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_integrityProtectionKey = BIT_STR(name='integrityProtectionKey', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionKey')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForSignalling = INT(name='chosenEncryptionAlgorithForSignalling', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_cipheringKey = BIT_STR(name='cipheringKey', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'EncryptionKey')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForCS = INT(name='chosenEncryptionAlgorithForCS', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForPS = INT(name='chosenEncryptionAlgorithForPS', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_d_RNTI = INT(name='d-RNTI', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'D-RNTI')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_targetCellId = INT(name='targetCellId', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetCellId')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_rAB_TrCH_Mapping = SEQ_OF(name='rAB-TrCH-Mapping', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-TrCH-Mapping')), opt=True)
    _SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRB-TrCH-Mapping')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformationGroup')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionInformation')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSLinkingInformation')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'D-RNTI')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-History-Information')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSFB-Information')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IRAT-Measurement-Configuration')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Management-Based-MDT-Allowed')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_12 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_13 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCCSource')))
    ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'reject'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'reject'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 200), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 202), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 227), ('criticality', 'reject'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 230), ('criticality', 'reject'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 237), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 243), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 249), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 296), ('criticality', 'ignore'), ('Extension', _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_14), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id._const_tab = ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item_._ext = None
    _SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions._cont = __SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item_
    _SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceRNC_ToTargetRNC_TransparentContainer._cont = ASN1Dict([
        ('rRC-Container', _SourceRNC_ToTargetRNC_TransparentContainer_rRC_Container),
        ('numberOfIuInstances', _SourceRNC_ToTargetRNC_TransparentContainer_numberOfIuInstances),
        ('relocationType', _SourceRNC_ToTargetRNC_TransparentContainer_relocationType),
        ('chosenIntegrityProtectionAlgorithm', _SourceRNC_ToTargetRNC_TransparentContainer_chosenIntegrityProtectionAlgorithm),
        ('integrityProtectionKey', _SourceRNC_ToTargetRNC_TransparentContainer_integrityProtectionKey),
        ('chosenEncryptionAlgorithForSignalling', _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForSignalling),
        ('cipheringKey', _SourceRNC_ToTargetRNC_TransparentContainer_cipheringKey),
        ('chosenEncryptionAlgorithForCS', _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForCS),
        ('chosenEncryptionAlgorithForPS', _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForPS),
        ('d-RNTI', _SourceRNC_ToTargetRNC_TransparentContainer_d_RNTI),
        ('targetCellId', _SourceRNC_ToTargetRNC_TransparentContainer_targetCellId),
        ('rAB-TrCH-Mapping', _SourceRNC_ToTargetRNC_TransparentContainer_rAB_TrCH_Mapping),
        ('iE-Extensions', _SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions),
        ])
    SourceRNC_ToTargetRNC_TransparentContainer._ext = []
    
    #-----< SourceRNC-ToTargetRNC-TransparentContainer-ExtIEs >-----#
    SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs = CLASS(name='SourceRNC-ToTargetRNC-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRB-TrCH-Mapping')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CellLoadInformationGroup')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionInformation')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSLinkingInformation')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_4 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'D-RNTI')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-History-Information')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_6 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_7 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_8 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSFB-Information')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IRAT-Measurement-Configuration')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_11 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Management-Based-MDT-Allowed')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_12 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_13 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_14 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCCSource')))
    SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([('id', 98), ('criticality', 'reject'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 121), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 124), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 156), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 187), ('criticality', 'reject'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_4), ('presence', 'optional')]), dict([('id', 200), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_5), ('presence', 'optional')]), dict([('id', 202), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_6), ('presence', 'optional')]), dict([('id', 227), ('criticality', 'reject'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_7), ('presence', 'optional')]), dict([('id', 230), ('criticality', 'reject'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_8), ('presence', 'optional')]), dict([('id', 237), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_9), ('presence', 'optional')]), dict([('id', 243), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_10), ('presence', 'optional')]), dict([('id', 249), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_11), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_12), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_13), ('presence', 'optional')]), dict([('id', 296), ('criticality', 'ignore'), ('Extension', _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_14), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRVCCSource >-----#
    SRVCCSource = ENUM(name='SRVCCSource', mode=MODE_TYPE)
    SRVCCSource._cont = ASN1Dict([('v5G', 0)])
    SRVCCSource._ext = []
    
    #-----< IRAT-Measurement-Configuration >-----#
    IRAT_Measurement_Configuration = SEQ(name='IRAT-Measurement-Configuration', mode=MODE_TYPE)
    _IRAT_Measurement_Configuration_rSRP = INT(name='rSRP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRAT_Measurement_Configuration_rSRP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    _IRAT_Measurement_Configuration_rSRQ = INT(name='rSRQ', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _IRAT_Measurement_Configuration_rSRQ._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    _IRAT_Measurement_Configuration_iRATmeasurementParameters = SEQ(name='iRATmeasurementParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IRATmeasurementParameters')))
    _IRAT_Measurement_Configuration_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IRAT_Measurement_Configuration_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___IRAT_Measurement_Configuration_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRQ-Type')))
    _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRQ-Extension')))
    ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 278), ('criticality', 'ignore'), ('Extension', _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 279), ('criticality', 'ignore'), ('Extension', _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___IRAT_Measurement_Configuration_iE_Extensions__item__id._const_tab = ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab
    ___IRAT_Measurement_Configuration_iE_Extensions__item__id._const_tab_at = None
    ___IRAT_Measurement_Configuration_iE_Extensions__item__id._const_tab_id = 'id'
    ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality._const_tab = ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab
    ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue._const_tab = ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab
    ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IRAT_Measurement_Configuration_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IRAT_Measurement_Configuration_iE_Extensions__item__id),
        ('criticality', ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality),
        ('extensionValue', ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue),
        ])
    __IRAT_Measurement_Configuration_iE_Extensions__item_._ext = None
    _IRAT_Measurement_Configuration_iE_Extensions._cont = __IRAT_Measurement_Configuration_iE_Extensions__item_
    _IRAT_Measurement_Configuration_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IRAT_Measurement_Configuration._cont = ASN1Dict([
        ('rSRP', _IRAT_Measurement_Configuration_rSRP),
        ('rSRQ', _IRAT_Measurement_Configuration_rSRQ),
        ('iRATmeasurementParameters', _IRAT_Measurement_Configuration_iRATmeasurementParameters),
        ('iE-Extensions', _IRAT_Measurement_Configuration_iE_Extensions),
        ])
    IRAT_Measurement_Configuration._ext = None
    
    #-----< IRAT-Measurement-Configuration-ExtIEs >-----#
    IRAT_Measurement_Configuration_ExtIEs = CLASS(name='IRAT-Measurement-Configuration-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _IRAT_Measurement_Configuration_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRQ-Type')))
    _IRAT_Measurement_Configuration_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRQ-Extension')))
    IRAT_Measurement_Configuration_ExtIEs._val = ASN1Set(rv=[dict([('id', 278), ('criticality', 'ignore'), ('Extension', _IRAT_Measurement_Configuration_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 279), ('criticality', 'ignore'), ('Extension', _IRAT_Measurement_Configuration_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< IRATmeasurementParameters >-----#
    IRATmeasurementParameters = SEQ(name='IRATmeasurementParameters', mode=MODE_TYPE)
    _IRATmeasurementParameters_measurementDuration = INT(name='measurementDuration', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IRATmeasurementParameters_measurementDuration._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100)], ev=None, er=[])
    _IRATmeasurementParameters_eUTRANFrequencies = SEQ_OF(name='eUTRANFrequencies', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'EUTRANFrequencies')), opt=True)
    _IRATmeasurementParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __IRATmeasurementParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___IRATmeasurementParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____IRATmeasurementParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IRATmeasurementParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IRATmeasurementParameters_iE_Extensions__item__id._const_tab = ____IRATmeasurementParameters_iE_Extensions__item__id_tab
    ___IRATmeasurementParameters_iE_Extensions__item__id._const_tab_at = None
    ___IRATmeasurementParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___IRATmeasurementParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____IRATmeasurementParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IRATmeasurementParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IRATmeasurementParameters_iE_Extensions__item__criticality._const_tab = ____IRATmeasurementParameters_iE_Extensions__item__criticality_tab
    ___IRATmeasurementParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___IRATmeasurementParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___IRATmeasurementParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____IRATmeasurementParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____IRATmeasurementParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___IRATmeasurementParameters_iE_Extensions__item__extensionValue._const_tab = ____IRATmeasurementParameters_iE_Extensions__item__extensionValue_tab
    ___IRATmeasurementParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___IRATmeasurementParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __IRATmeasurementParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___IRATmeasurementParameters_iE_Extensions__item__id),
        ('criticality', ___IRATmeasurementParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___IRATmeasurementParameters_iE_Extensions__item__extensionValue),
        ])
    __IRATmeasurementParameters_iE_Extensions__item_._ext = None
    _IRATmeasurementParameters_iE_Extensions._cont = __IRATmeasurementParameters_iE_Extensions__item_
    _IRATmeasurementParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    IRATmeasurementParameters._cont = ASN1Dict([
        ('measurementDuration', _IRATmeasurementParameters_measurementDuration),
        ('eUTRANFrequencies', _IRATmeasurementParameters_eUTRANFrequencies),
        ('iE-Extensions', _IRATmeasurementParameters_iE_Extensions),
        ])
    IRATmeasurementParameters._ext = None
    
    #-----< IRATmeasurementParameters-ExtIEs >-----#
    IRATmeasurementParameters_ExtIEs = CLASS(name='IRATmeasurementParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    IRATmeasurementParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RSRQ-Type >-----#
    RSRQ_Type = SEQ(name='RSRQ-Type', mode=MODE_TYPE)
    _RSRQ_Type_allSymbols = BOOL(name='allSymbols', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RSRQ_Type_wideBand = BOOL(name='wideBand', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    RSRQ_Type._cont = ASN1Dict([
        ('allSymbols', _RSRQ_Type_allSymbols),
        ('wideBand', _RSRQ_Type_wideBand),
        ])
    RSRQ_Type._ext = None
    
    #-----< RSRQ-Extension >-----#
    RSRQ_Extension = INT(name='RSRQ-Extension', mode=MODE_TYPE)
    RSRQ_Extension._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-30, ub=46)], ev=[], er=[])
    
    #-----< EUTRANFrequencies >-----#
    EUTRANFrequencies = SEQ_OF(name='EUTRANFrequencies', mode=MODE_TYPE)
    _EUTRANFrequencies__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __EUTRANFrequencies__item__earfcn = INT(name='earfcn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __EUTRANFrequencies__item__earfcn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __EUTRANFrequencies__item__measBand = ENUM(name='measBand', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MeasBand')), opt=True)
    __EUTRANFrequencies__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___EUTRANFrequencies__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____EUTRANFrequencies__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____EUTRANFrequencies__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ______EUTRANFrequencies__item__iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EARFCN-Extended')))
    _____EUTRANFrequencies__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 271), ('criticality', 'reject'), ('Extension', ______EUTRANFrequencies__item__iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ____EUTRANFrequencies__item__iE_Extensions__item__id._const_tab = _____EUTRANFrequencies__item__iE_Extensions__item__id_tab
    ____EUTRANFrequencies__item__iE_Extensions__item__id._const_tab_at = None
    ____EUTRANFrequencies__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____EUTRANFrequencies__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EUTRANFrequencies__item__iE_Extensions__item__criticality._const_tab = _____EUTRANFrequencies__item__iE_Extensions__item__id_tab
    ____EUTRANFrequencies__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____EUTRANFrequencies__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue._const_tab = _____EUTRANFrequencies__item__iE_Extensions__item__id_tab
    ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___EUTRANFrequencies__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____EUTRANFrequencies__item__iE_Extensions__item__id),
        ('criticality', ____EUTRANFrequencies__item__iE_Extensions__item__criticality),
        ('extensionValue', ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue),
        ])
    ___EUTRANFrequencies__item__iE_Extensions__item_._ext = None
    __EUTRANFrequencies__item__iE_Extensions._cont = ___EUTRANFrequencies__item__iE_Extensions__item_
    __EUTRANFrequencies__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _EUTRANFrequencies__item_._cont = ASN1Dict([
        ('earfcn', __EUTRANFrequencies__item__earfcn),
        ('measBand', __EUTRANFrequencies__item__measBand),
        ('iE-Extensions', __EUTRANFrequencies__item__iE_Extensions),
        ])
    _EUTRANFrequencies__item_._ext = None
    EUTRANFrequencies._cont = _EUTRANFrequencies__item_
    EUTRANFrequencies._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MeasBand >-----#
    MeasBand = ENUM(name='MeasBand', mode=MODE_TYPE)
    MeasBand._cont = ASN1Dict([('v6', 0), ('v15', 1), ('v25', 2), ('v50', 3), ('v75', 4), ('v100', 5)])
    MeasBand._ext = None
    
    #-----< EUTRANFrequencies-ExtIEs >-----#
    EUTRANFrequencies_ExtIEs = CLASS(name='EUTRANFrequencies-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _EUTRANFrequencies_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EARFCN-Extended')))
    EUTRANFrequencies_ExtIEs._val = ASN1Set(rv=[dict([('id', 271), ('criticality', 'reject'), ('Extension', _EUTRANFrequencies_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SubscriberProfileIDforRFP >-----#
    SubscriberProfileIDforRFP = INT(name='SubscriberProfileIDforRFP', mode=MODE_TYPE)
    SubscriberProfileIDforRFP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< SourceStatisticsDescriptor >-----#
    SourceStatisticsDescriptor = ENUM(name='SourceStatisticsDescriptor', mode=MODE_TYPE)
    SourceStatisticsDescriptor._cont = ASN1Dict([('speech', 0), ('unknown', 1)])
    SourceStatisticsDescriptor._ext = []
    
    #-----< SupportedRAB-ParameterBitrateList >-----#
    SupportedRAB_ParameterBitrateList = SEQ_OF(name='SupportedRAB-ParameterBitrateList', mode=MODE_TYPE)
    _SupportedRAB_ParameterBitrateList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SupportedBitrate')))
    SupportedRAB_ParameterBitrateList._cont = _SupportedRAB_ParameterBitrateList__item_
    SupportedRAB_ParameterBitrateList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< SupportedBitrate >-----#
    SupportedBitrate = INT(name='SupportedBitrate', mode=MODE_TYPE)
    SupportedBitrate._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000000)], ev=[], er=[])
    
    #-----< SourceUTRANCellID >-----#
    SourceUTRANCellID = SEQ(name='SourceUTRANCellID', mode=MODE_TYPE)
    _SourceUTRANCellID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _SourceUTRANCellID_uTRANcellID = INT(name='uTRANcellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetCellId')))
    _SourceUTRANCellID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SourceUTRANCellID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SourceUTRANCellID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SourceUTRANCellID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SourceUTRANCellID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceUTRANCellID_iE_Extensions__item__id._const_tab = ____SourceUTRANCellID_iE_Extensions__item__id_tab
    ___SourceUTRANCellID_iE_Extensions__item__id._const_tab_at = None
    ___SourceUTRANCellID_iE_Extensions__item__id._const_tab_id = 'id'
    ___SourceUTRANCellID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SourceUTRANCellID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SourceUTRANCellID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceUTRANCellID_iE_Extensions__item__criticality._const_tab = ____SourceUTRANCellID_iE_Extensions__item__criticality_tab
    ___SourceUTRANCellID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SourceUTRANCellID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SourceUTRANCellID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SourceUTRANCellID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SourceUTRANCellID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SourceUTRANCellID_iE_Extensions__item__extensionValue._const_tab = ____SourceUTRANCellID_iE_Extensions__item__extensionValue_tab
    ___SourceUTRANCellID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SourceUTRANCellID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SourceUTRANCellID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SourceUTRANCellID_iE_Extensions__item__id),
        ('criticality', ___SourceUTRANCellID_iE_Extensions__item__criticality),
        ('extensionValue', ___SourceUTRANCellID_iE_Extensions__item__extensionValue),
        ])
    __SourceUTRANCellID_iE_Extensions__item_._ext = None
    _SourceUTRANCellID_iE_Extensions._cont = __SourceUTRANCellID_iE_Extensions__item_
    _SourceUTRANCellID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SourceUTRANCellID._cont = ASN1Dict([
        ('pLMNidentity', _SourceUTRANCellID_pLMNidentity),
        ('uTRANcellID', _SourceUTRANCellID_uTRANcellID),
        ('iE-Extensions', _SourceUTRANCellID_iE_Extensions),
        ])
    SourceUTRANCellID._ext = None
    
    #-----< SourceUTRANCellID-ExtIEs >-----#
    SourceUTRANCellID_ExtIEs = CLASS(name='SourceUTRANCellID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SourceUTRANCellID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRB-ID >-----#
    SRB_ID = INT(name='SRB-ID', mode=MODE_TYPE)
    SRB_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< SRB-TrCH-Mapping >-----#
    SRB_TrCH_Mapping = SEQ_OF(name='SRB-TrCH-Mapping', mode=MODE_TYPE)
    _SRB_TrCH_Mapping__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRB-TrCH-MappingItem')))
    SRB_TrCH_Mapping._cont = _SRB_TrCH_Mapping__item_
    SRB_TrCH_Mapping._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SRB-TrCH-MappingItem >-----#
    SRB_TrCH_MappingItem = SEQ(name='SRB-TrCH-MappingItem', mode=MODE_TYPE)
    _SRB_TrCH_MappingItem_sRB_ID = INT(name='sRB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SRB-ID')))
    _SRB_TrCH_MappingItem_trCH_ID = SEQ(name='trCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TrCH-ID')))
    _SRB_TrCH_MappingItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRB_TrCH_MappingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRB_TrCH_MappingItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRB_TrCH_MappingItem_iE_Extensions__item__id._const_tab = ____SRB_TrCH_MappingItem_iE_Extensions__item__id_tab
    ___SRB_TrCH_MappingItem_iE_Extensions__item__id._const_tab_at = None
    ___SRB_TrCH_MappingItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab = ____SRB_TrCH_MappingItem_iE_Extensions__item__criticality_tab
    ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab = ____SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue_tab
    ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRB_TrCH_MappingItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRB_TrCH_MappingItem_iE_Extensions__item__id),
        ('criticality', ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality),
        ('extensionValue', ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue),
        ])
    __SRB_TrCH_MappingItem_iE_Extensions__item_._ext = None
    _SRB_TrCH_MappingItem_iE_Extensions._cont = __SRB_TrCH_MappingItem_iE_Extensions__item_
    _SRB_TrCH_MappingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRB_TrCH_MappingItem._cont = ASN1Dict([
        ('sRB-ID', _SRB_TrCH_MappingItem_sRB_ID),
        ('trCH-ID', _SRB_TrCH_MappingItem_trCH_ID),
        ('iE-Extensions', _SRB_TrCH_MappingItem_iE_Extensions),
        ])
    SRB_TrCH_MappingItem._ext = []
    
    #-----< SRB-TrCH-MappingItem-ExtIEs >-----#
    SRB_TrCH_MappingItem_ExtIEs = CLASS(name='SRB-TrCH-MappingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRB_TrCH_MappingItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCC-HO-Indication >-----#
    SRVCC_HO_Indication = ENUM(name='SRVCC-HO-Indication', mode=MODE_TYPE)
    SRVCC_HO_Indication._cont = ASN1Dict([('ps-and-cs', 0), ('cs-only', 1)])
    SRVCC_HO_Indication._ext = []
    
    #-----< SRVCC-Information >-----#
    SRVCC_Information = SEQ(name='SRVCC-Information', mode=MODE_TYPE)
    _SRVCC_Information_nonce = BIT_STR(name='nonce', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SRVCC_Information_nonce._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _SRVCC_Information_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRVCC_Information_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRVCC_Information_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SRVCC_Information_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_Information_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_Information_iE_Extensions__item__id._const_tab = ____SRVCC_Information_iE_Extensions__item__id_tab
    ___SRVCC_Information_iE_Extensions__item__id._const_tab_at = None
    ___SRVCC_Information_iE_Extensions__item__id._const_tab_id = 'id'
    ___SRVCC_Information_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRVCC_Information_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_Information_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_Information_iE_Extensions__item__criticality._const_tab = ____SRVCC_Information_iE_Extensions__item__criticality_tab
    ___SRVCC_Information_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRVCC_Information_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___SRVCC_Information_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRVCC_Information_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_Information_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_Information_iE_Extensions__item__extensionValue._const_tab = ____SRVCC_Information_iE_Extensions__item__extensionValue_tab
    ___SRVCC_Information_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRVCC_Information_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __SRVCC_Information_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___SRVCC_Information_iE_Extensions__item__id),
        ('criticality', ___SRVCC_Information_iE_Extensions__item__criticality),
        ('extensionValue', ___SRVCC_Information_iE_Extensions__item__extensionValue),
        ])
    __SRVCC_Information_iE_Extensions__item_._ext = None
    _SRVCC_Information_iE_Extensions._cont = __SRVCC_Information_iE_Extensions__item_
    _SRVCC_Information_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRVCC_Information._cont = ASN1Dict([
        ('nonce', _SRVCC_Information_nonce),
        ('iE-Extensions', _SRVCC_Information_iE_Extensions),
        ])
    SRVCC_Information._ext = []
    
    #-----< SRVCC-Information-ExtIEs >-----#
    SRVCC_Information_ExtIEs = CLASS(name='SRVCC-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRVCC_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCC-Operation-Possible >-----#
    SRVCC_Operation_Possible = ENUM(name='SRVCC-Operation-Possible', mode=MODE_TYPE)
    SRVCC_Operation_Possible._cont = ASN1Dict([('srvcc-possible', 0)])
    SRVCC_Operation_Possible._ext = []
    
    #-----< SubflowSDU-Size >-----#
    SubflowSDU_Size = INT(name='SubflowSDU-Size', mode=MODE_TYPE)
    SubflowSDU_Size._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< TAC >-----#
    TAC = OCT_STR(name='TAC', mode=MODE_TYPE)
    TAC._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    
    #-----< TAI >-----#
    TAI = SEQ(name='TAI', mode=MODE_TYPE)
    _TAI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _TAI_tAC = OCT_STR(name='tAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TAC')))
    _TAI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TAI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TAI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TAI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__id._const_tab = ____TAI_iE_Extensions__item__id_tab
    ___TAI_iE_Extensions__item__id._const_tab_at = None
    ___TAI_iE_Extensions__item__id._const_tab_id = 'id'
    ___TAI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TAI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__criticality._const_tab = ____TAI_iE_Extensions__item__criticality_tab
    ___TAI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TAI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TAI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TAI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TAI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TAI_iE_Extensions__item__extensionValue._const_tab = ____TAI_iE_Extensions__item__extensionValue_tab
    ___TAI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TAI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TAI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TAI_iE_Extensions__item__id),
        ('criticality', ___TAI_iE_Extensions__item__criticality),
        ('extensionValue', ___TAI_iE_Extensions__item__extensionValue),
        ])
    __TAI_iE_Extensions__item_._ext = None
    _TAI_iE_Extensions._cont = __TAI_iE_Extensions__item_
    _TAI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TAI._cont = ASN1Dict([
        ('pLMNidentity', _TAI_pLMNidentity),
        ('tAC', _TAI_tAC),
        ('iE-Extensions', _TAI_iE_Extensions),
        ])
    TAI._ext = None
    
    #-----< TAI-ExtIEs >-----#
    TAI_ExtIEs = CLASS(name='TAI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TAI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Target-ToSource-TransparentContainer >-----#
    Target_ToSource_TransparentContainer = OCT_STR(name='Target-ToSource-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargeteNodeB-ToSourceeNodeB-TransparentContainer >-----#
    TargeteNodeB_ToSourceeNodeB_TransparentContainer = OCT_STR(name='TargeteNodeB-ToSourceeNodeB-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargetBSS-ToSourceBSS-TransparentContainer >-----#
    TargetBSS_ToSourceBSS_TransparentContainer = OCT_STR(name='TargetBSS-ToSourceBSS-TransparentContainer', mode=MODE_TYPE)
    
    #-----< TargetCellId >-----#
    TargetCellId = INT(name='TargetCellId', mode=MODE_TYPE)
    TargetCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268435455)], ev=None, er=[])
    
    #-----< TargetID >-----#
    TargetID = CHOICE(name='TargetID', mode=MODE_TYPE)
    _TargetID_targetRNC_ID = SEQ(name='targetRNC-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ID')))
    _TargetID_cGI = SEQ(name='cGI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CGI')))
    _TargetID_targeteNB_ID = SEQ(name='targeteNB-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetENB-ID')))
    TargetID._cont = ASN1Dict([
        ('targetRNC-ID', _TargetID_targetRNC_ID),
        ('cGI', _TargetID_cGI),
        ('targeteNB-ID', _TargetID_targeteNB_ID),
        ])
    TargetID._ext = ['targeteNB-ID']
    
    #-----< TargetENB-ID >-----#
    TargetENB_ID = SEQ(name='TargetENB-ID', mode=MODE_TYPE)
    _TargetENB_ID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _TargetENB_ID_eNB_ID = CHOICE(name='eNB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ENB-ID')))
    _TargetENB_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetENB_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TargetENB_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetENB_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TargetENB_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetENB_ID_iE_Extensions__item__id._const_tab = ____TargetENB_ID_iE_Extensions__item__id_tab
    ___TargetENB_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetENB_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetENB_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TargetENB_ID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TargetENB_ID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetENB_ID_iE_Extensions__item__criticality._const_tab = ____TargetENB_ID_iE_Extensions__item__criticality_tab
    ___TargetENB_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetENB_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetENB_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TargetENB_ID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TargetENB_ID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TargetENB_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetENB_ID_iE_Extensions__item__extensionValue_tab
    ___TargetENB_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetENB_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetENB_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetENB_ID_iE_Extensions__item__id),
        ('criticality', ___TargetENB_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetENB_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetENB_ID_iE_Extensions__item_._ext = None
    _TargetENB_ID_iE_Extensions._cont = __TargetENB_ID_iE_Extensions__item_
    _TargetENB_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _TargetENB_ID_selectedTAI = SEQ(name='selectedTAI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TAI')))
    TargetENB_ID._cont = ASN1Dict([
        ('pLMNidentity', _TargetENB_ID_pLMNidentity),
        ('eNB-ID', _TargetENB_ID_eNB_ID),
        ('iE-Extensions', _TargetENB_ID_iE_Extensions),
        ('selectedTAI', _TargetENB_ID_selectedTAI),
        ])
    TargetENB_ID._ext = []
    
    #-----< TargetENB-ID-ExtIEs >-----#
    TargetENB_ID_ExtIEs = CLASS(name='TargetENB-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TargetENB_ID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TargetRNC-ID >-----#
    TargetRNC_ID = SEQ(name='TargetRNC-ID', mode=MODE_TYPE)
    _TargetRNC_ID_lAI = SEQ(name='lAI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _TargetRNC_ID_rAC = OCT_STR(name='rAC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAC')), opt=True)
    _TargetRNC_ID_rNC_ID = INT(name='rNC-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RNC-ID')))
    _TargetRNC_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRNC_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TargetRNC_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetRNC_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____TargetRNC_ID_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____TargetRNC_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _____TargetRNC_ID_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab = ____TargetRNC_ID_iE_Extensions__item__id_tab
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_at = None
    ___TargetRNC_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetRNC_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab = ____TargetRNC_ID_iE_Extensions__item__id_tab
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetRNC_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetRNC_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab = ____TargetRNC_ID_iE_Extensions__item__id_tab
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetRNC_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetRNC_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetRNC_ID_iE_Extensions__item__id),
        ('criticality', ___TargetRNC_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetRNC_ID_iE_Extensions__item__extensionValue),
        ])
    __TargetRNC_ID_iE_Extensions__item_._ext = None
    _TargetRNC_ID_iE_Extensions._cont = __TargetRNC_ID_iE_Extensions__item_
    _TargetRNC_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRNC_ID._cont = ASN1Dict([
        ('lAI', _TargetRNC_ID_lAI),
        ('rAC', _TargetRNC_ID_rAC),
        ('rNC-ID', _TargetRNC_ID_rNC_ID),
        ('iE-Extensions', _TargetRNC_ID_iE_Extensions),
        ])
    TargetRNC_ID._ext = None
    
    #-----< TargetRNC-ID-ExtIEs >-----#
    TargetRNC_ID_ExtIEs = CLASS(name='TargetRNC-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _TargetRNC_ID_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    TargetRNC_ID_ExtIEs._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _TargetRNC_ID_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TargetRNC-ToSourceRNC-TransparentContainer >-----#
    TargetRNC_ToSourceRNC_TransparentContainer = SEQ(name='TargetRNC-ToSourceRNC-TransparentContainer', mode=MODE_TYPE)
    _TargetRNC_ToSourceRNC_TransparentContainer_rRC_Container = OCT_STR(name='rRC-Container', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    _TargetRNC_ToSourceRNC_TransparentContainer_d_RNTI = INT(name='d-RNTI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'D-RNTI')), opt=True)
    _TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UeApplicationLayerMeasurementSupportIndication')))
    ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 295), ('criticality', 'ignore'), ('Extension', _____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id._const_tab = ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id._const_tab_at = None
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id._const_tab_id = 'id'
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab = ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab = ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id),
        ('criticality', ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality),
        ('extensionValue', ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue),
        ])
    __TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item_._ext = None
    _TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions._cont = __TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item_
    _TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TargetRNC_ToSourceRNC_TransparentContainer._cont = ASN1Dict([
        ('rRC-Container', _TargetRNC_ToSourceRNC_TransparentContainer_rRC_Container),
        ('d-RNTI', _TargetRNC_ToSourceRNC_TransparentContainer_d_RNTI),
        ('iE-Extensions', _TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions),
        ])
    TargetRNC_ToSourceRNC_TransparentContainer._ext = []
    
    #-----< TargetRNC-ToSourceRNC-TransparentContainer-ExtIEs >-----#
    TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs = CLASS(name='TargetRNC-ToSourceRNC-TransparentContainer-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UeApplicationLayerMeasurementSupportIndication')))
    TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs._val = ASN1Set(rv=[dict([('id', 295), ('criticality', 'ignore'), ('Extension', _TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UeApplicationLayerMeasurementSupportIndication >-----#
    UeApplicationLayerMeasurementSupportIndication = BIT_STR(name='UeApplicationLayerMeasurementSupportIndication', mode=MODE_TYPE)
    UeApplicationLayerMeasurementSupportIndication._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< TBCD-STRING >-----#
    TBCD_STRING = OCT_STR(name='TBCD-STRING', mode=MODE_TYPE)
    
    #-----< TemporaryUE-ID >-----#
    TemporaryUE_ID = CHOICE(name='TemporaryUE-ID', mode=MODE_TYPE)
    _TemporaryUE_ID_tMSI = OCT_STR(name='tMSI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TMSI')))
    _TemporaryUE_ID_p_TMSI = OCT_STR(name='p-TMSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'P-TMSI')))
    TemporaryUE_ID._cont = ASN1Dict([
        ('tMSI', _TemporaryUE_ID_tMSI),
        ('p-TMSI', _TemporaryUE_ID_p_TMSI),
        ])
    TemporaryUE_ID._ext = []
    
    #-----< Time-UE-StayedInCell >-----#
    Time_UE_StayedInCell = INT(name='Time-UE-StayedInCell', mode=MODE_TYPE)
    Time_UE_StayedInCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    
    #-----< Time-UE-StayedInCell-EnhancedGranularity >-----#
    Time_UE_StayedInCell_EnhancedGranularity = INT(name='Time-UE-StayedInCell-EnhancedGranularity', mode=MODE_TYPE)
    Time_UE_StayedInCell_EnhancedGranularity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=40950)], ev=None, er=[])
    
    #-----< TimeToMBMSDataTransfer >-----#
    TimeToMBMSDataTransfer = OCT_STR(name='TimeToMBMSDataTransfer', mode=MODE_TYPE)
    TimeToMBMSDataTransfer._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TimingDifferenceULDL >-----#
    TimingDifferenceULDL = OCT_STR(name='TimingDifferenceULDL', mode=MODE_TYPE)
    TimingDifferenceULDL._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TMGI >-----#
    TMGI = SEQ(name='TMGI', mode=MODE_TYPE)
    _TMGI_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _TMGI_serviceID = OCT_STR(name='serviceID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TMGI_serviceID._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _TMGI_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TMGI_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TMGI_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TMGI_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TMGI_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TMGI_iE_Extensions__item__id._const_tab = ____TMGI_iE_Extensions__item__id_tab
    ___TMGI_iE_Extensions__item__id._const_tab_at = None
    ___TMGI_iE_Extensions__item__id._const_tab_id = 'id'
    ___TMGI_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TMGI_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TMGI_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TMGI_iE_Extensions__item__criticality._const_tab = ____TMGI_iE_Extensions__item__criticality_tab
    ___TMGI_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TMGI_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TMGI_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TMGI_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TMGI_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TMGI_iE_Extensions__item__extensionValue._const_tab = ____TMGI_iE_Extensions__item__extensionValue_tab
    ___TMGI_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TMGI_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TMGI_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TMGI_iE_Extensions__item__id),
        ('criticality', ___TMGI_iE_Extensions__item__criticality),
        ('extensionValue', ___TMGI_iE_Extensions__item__extensionValue),
        ])
    __TMGI_iE_Extensions__item_._ext = None
    _TMGI_iE_Extensions._cont = __TMGI_iE_Extensions__item_
    _TMGI_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TMGI._cont = ASN1Dict([
        ('pLMNidentity', _TMGI_pLMNidentity),
        ('serviceID', _TMGI_serviceID),
        ('iE-Extensions', _TMGI_iE_Extensions),
        ])
    TMGI._ext = None
    
    #-----< TMGI-ExtIEs >-----#
    TMGI_ExtIEs = CLASS(name='TMGI-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TMGI_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TMSI >-----#
    TMSI = OCT_STR(name='TMSI', mode=MODE_TYPE)
    TMSI._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    
    #-----< TraceDepth >-----#
    TraceDepth = ENUM(name='TraceDepth', mode=MODE_TYPE)
    TraceDepth._cont = ASN1Dict([('minimum', 0), ('medium', 1), ('maximum', 2)])
    TraceDepth._ext = []
    
    #-----< TraceInformation >-----#
    TraceInformation = SEQ(name='TraceInformation', mode=MODE_TYPE)
    _TraceInformation_traceReference = OCT_STR(name='traceReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _TraceInformation_ue_identity = CHOICE(name='ue-identity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UE-ID')))
    _TraceInformation_tracePropagationParameters = SEQ(name='tracePropagationParameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TracePropagationParameters')), opt=True)
    _TraceInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TraceInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TraceInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceInformation_iE_Extensions__item__id._const_tab = ____TraceInformation_iE_Extensions__item__id_tab
    ___TraceInformation_iE_Extensions__item__id._const_tab_at = None
    ___TraceInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TraceInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TraceInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceInformation_iE_Extensions__item__criticality._const_tab = ____TraceInformation_iE_Extensions__item__criticality_tab
    ___TraceInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TraceInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TraceInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TraceInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceInformation_iE_Extensions__item__extensionValue._const_tab = ____TraceInformation_iE_Extensions__item__extensionValue_tab
    ___TraceInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TraceInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TraceInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TraceInformation_iE_Extensions__item__id),
        ('criticality', ___TraceInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TraceInformation_iE_Extensions__item__extensionValue),
        ])
    __TraceInformation_iE_Extensions__item_._ext = None
    _TraceInformation_iE_Extensions._cont = __TraceInformation_iE_Extensions__item_
    _TraceInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceInformation._cont = ASN1Dict([
        ('traceReference', _TraceInformation_traceReference),
        ('ue-identity', _TraceInformation_ue_identity),
        ('tracePropagationParameters', _TraceInformation_tracePropagationParameters),
        ('iE-Extensions', _TraceInformation_iE_Extensions),
        ])
    TraceInformation._ext = []
    
    #-----< TraceInformation-ExtIEs >-----#
    TraceInformation_ExtIEs = CLASS(name='TraceInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TraceInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TracePropagationParameters >-----#
    TracePropagationParameters = SEQ(name='TracePropagationParameters', mode=MODE_TYPE)
    _TracePropagationParameters_traceRecordingSessionReference = INT(name='traceRecordingSessionReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionReference')))
    _TracePropagationParameters_traceDepth = ENUM(name='traceDepth', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceDepth')))
    _TracePropagationParameters_listOfInterfacesToTrace = SEQ_OF(name='listOfInterfacesToTrace', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'ListOfInterfacesToTrace')), opt=True)
    _TracePropagationParameters_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TracePropagationParameters_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TracePropagationParameters_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TracePropagationParameters_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TracePropagationParameters_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TracePropagationParameters_iE_Extensions__item__id._const_tab = ____TracePropagationParameters_iE_Extensions__item__id_tab
    ___TracePropagationParameters_iE_Extensions__item__id._const_tab_at = None
    ___TracePropagationParameters_iE_Extensions__item__id._const_tab_id = 'id'
    ___TracePropagationParameters_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TracePropagationParameters_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TracePropagationParameters_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TracePropagationParameters_iE_Extensions__item__criticality._const_tab = ____TracePropagationParameters_iE_Extensions__item__criticality_tab
    ___TracePropagationParameters_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TracePropagationParameters_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TracePropagationParameters_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TracePropagationParameters_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TracePropagationParameters_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TracePropagationParameters_iE_Extensions__item__extensionValue._const_tab = ____TracePropagationParameters_iE_Extensions__item__extensionValue_tab
    ___TracePropagationParameters_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TracePropagationParameters_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TracePropagationParameters_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TracePropagationParameters_iE_Extensions__item__id),
        ('criticality', ___TracePropagationParameters_iE_Extensions__item__criticality),
        ('extensionValue', ___TracePropagationParameters_iE_Extensions__item__extensionValue),
        ])
    __TracePropagationParameters_iE_Extensions__item_._ext = None
    _TracePropagationParameters_iE_Extensions._cont = __TracePropagationParameters_iE_Extensions__item_
    _TracePropagationParameters_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TracePropagationParameters._cont = ASN1Dict([
        ('traceRecordingSessionReference', _TracePropagationParameters_traceRecordingSessionReference),
        ('traceDepth', _TracePropagationParameters_traceDepth),
        ('listOfInterfacesToTrace', _TracePropagationParameters_listOfInterfacesToTrace),
        ('iE-Extensions', _TracePropagationParameters_iE_Extensions),
        ])
    TracePropagationParameters._ext = []
    
    #-----< TracePropagationParameters-ExtIEs >-----#
    TracePropagationParameters_ExtIEs = CLASS(name='TracePropagationParameters-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TracePropagationParameters_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TraceRecordingSessionInformation >-----#
    TraceRecordingSessionInformation = SEQ(name='TraceRecordingSessionInformation', mode=MODE_TYPE)
    _TraceRecordingSessionInformation_traceReference = OCT_STR(name='traceReference', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _TraceRecordingSessionInformation_traceRecordingSessionReference = INT(name='traceRecordingSessionReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TraceRecordingSessionReference')))
    _TraceRecordingSessionInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TraceRecordingSessionInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TraceRecordingSessionInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TraceRecordingSessionInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceRecordingSessionInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceRecordingSessionInformation_iE_Extensions__item__id._const_tab = ____TraceRecordingSessionInformation_iE_Extensions__item__id_tab
    ___TraceRecordingSessionInformation_iE_Extensions__item__id._const_tab_at = None
    ___TraceRecordingSessionInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TraceRecordingSessionInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TraceRecordingSessionInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceRecordingSessionInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceRecordingSessionInformation_iE_Extensions__item__criticality._const_tab = ____TraceRecordingSessionInformation_iE_Extensions__item__criticality_tab
    ___TraceRecordingSessionInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TraceRecordingSessionInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TraceRecordingSessionInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TraceRecordingSessionInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue._const_tab = ____TraceRecordingSessionInformation_iE_Extensions__item__extensionValue_tab
    ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TraceRecordingSessionInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TraceRecordingSessionInformation_iE_Extensions__item__id),
        ('criticality', ___TraceRecordingSessionInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue),
        ])
    __TraceRecordingSessionInformation_iE_Extensions__item_._ext = None
    _TraceRecordingSessionInformation_iE_Extensions._cont = __TraceRecordingSessionInformation_iE_Extensions__item_
    _TraceRecordingSessionInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TraceRecordingSessionInformation._cont = ASN1Dict([
        ('traceReference', _TraceRecordingSessionInformation_traceReference),
        ('traceRecordingSessionReference', _TraceRecordingSessionInformation_traceRecordingSessionReference),
        ('iE-Extensions', _TraceRecordingSessionInformation_iE_Extensions),
        ])
    TraceRecordingSessionInformation._ext = []
    
    #-----< TraceRecordingSessionInformation-ExtIEs >-----#
    TraceRecordingSessionInformation_ExtIEs = CLASS(name='TraceRecordingSessionInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TraceRecordingSessionInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TraceRecordingSessionReference >-----#
    TraceRecordingSessionReference = INT(name='TraceRecordingSessionReference', mode=MODE_TYPE)
    TraceRecordingSessionReference._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< TraceReference >-----#
    TraceReference = OCT_STR(name='TraceReference', mode=MODE_TYPE)
    TraceReference._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< TraceType >-----#
    TraceType = OCT_STR(name='TraceType', mode=MODE_TYPE)
    TraceType._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    
    #-----< TrafficClass >-----#
    TrafficClass = ENUM(name='TrafficClass', mode=MODE_TYPE)
    TrafficClass._cont = ASN1Dict([('conversational', 0), ('streaming', 1), ('interactive', 2), ('background', 3)])
    TrafficClass._ext = []
    
    #-----< TrafficHandlingPriority >-----#
    TrafficHandlingPriority = INT(name='TrafficHandlingPriority', mode=MODE_TYPE)
    TrafficHandlingPriority._cont = ASN1Dict([('spare', 0), ('highest', 1), ('lowest', 14), ('no-priority-used', 15)])
    TrafficHandlingPriority._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    
    #-----< TransferDelay >-----#
    TransferDelay = INT(name='TransferDelay', mode=MODE_TYPE)
    TransferDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< UnsuccessfullyTransmittedDataVolume >-----#
    UnsuccessfullyTransmittedDataVolume = INT(name='UnsuccessfullyTransmittedDataVolume', mode=MODE_TYPE)
    UnsuccessfullyTransmittedDataVolume._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< TransportLayerAddress >-----#
    TransportLayerAddress = BIT_STR(name='TransportLayerAddress', mode=MODE_TYPE)
    TransportLayerAddress._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=160)], ev=[], er=[])
    
    #-----< TrCH-ID >-----#
    TrCH_ID = SEQ(name='TrCH-ID', mode=MODE_TYPE)
    _TrCH_ID_dCH_ID = INT(name='dCH-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DCH-ID')), opt=True)
    _TrCH_ID_dSCH_ID = INT(name='dSCH-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DSCH-ID')), opt=True)
    _TrCH_ID_uSCH_ID = INT(name='uSCH-ID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'USCH-ID')), opt=True)
    _TrCH_ID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TrCH_ID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TrCH_ID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TrCH_ID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HS-DSCH-MAC-d-Flow-ID')))
    _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-DCH-MAC-d-Flow-ID')))
    ____TrCH_ID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 117), ('criticality', 'ignore'), ('Extension', _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 160), ('criticality', 'ignore'), ('Extension', _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___TrCH_ID_iE_Extensions__item__id._const_tab = ____TrCH_ID_iE_Extensions__item__id_tab
    ___TrCH_ID_iE_Extensions__item__id._const_tab_at = None
    ___TrCH_ID_iE_Extensions__item__id._const_tab_id = 'id'
    ___TrCH_ID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___TrCH_ID_iE_Extensions__item__criticality._const_tab = ____TrCH_ID_iE_Extensions__item__id_tab
    ___TrCH_ID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TrCH_ID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TrCH_ID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___TrCH_ID_iE_Extensions__item__extensionValue._const_tab = ____TrCH_ID_iE_Extensions__item__id_tab
    ___TrCH_ID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TrCH_ID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TrCH_ID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TrCH_ID_iE_Extensions__item__id),
        ('criticality', ___TrCH_ID_iE_Extensions__item__criticality),
        ('extensionValue', ___TrCH_ID_iE_Extensions__item__extensionValue),
        ])
    __TrCH_ID_iE_Extensions__item_._ext = None
    _TrCH_ID_iE_Extensions._cont = __TrCH_ID_iE_Extensions__item_
    _TrCH_ID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TrCH_ID._cont = ASN1Dict([
        ('dCH-ID', _TrCH_ID_dCH_ID),
        ('dSCH-ID', _TrCH_ID_dSCH_ID),
        ('uSCH-ID', _TrCH_ID_uSCH_ID),
        ('iE-Extensions', _TrCH_ID_iE_Extensions),
        ])
    TrCH_ID._ext = []
    
    #-----< TrCH-ID-ExtIEs >-----#
    TrCH_ID_ExtIEs = CLASS(name='TrCH-ID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _TrCH_ID_ExtIEs_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HS-DSCH-MAC-d-Flow-ID')))
    _TrCH_ID_ExtIEs_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-DCH-MAC-d-Flow-ID')))
    TrCH_ID_ExtIEs._val = ASN1Set(rv=[dict([('id', 117), ('criticality', 'ignore'), ('Extension', _TrCH_ID_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 160), ('criticality', 'ignore'), ('Extension', _TrCH_ID_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TrCH-ID-List >-----#
    TrCH_ID_List = SEQ_OF(name='TrCH-ID-List', mode=MODE_TYPE)
    _TrCH_ID_List__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TrCH-ID')))
    TrCH_ID_List._cont = _TrCH_ID_List__item_
    TrCH_ID_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=7)], ev=None, er=[])
    
    #-----< TriggerID >-----#
    TriggerID = OCT_STR(name='TriggerID', mode=MODE_TYPE)
    TriggerID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=22)], ev=None, er=[])
    
    #-----< TunnelInformation >-----#
    TunnelInformation = SEQ(name='TunnelInformation', mode=MODE_TYPE)
    _TunnelInformation_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _TunnelInformation_uDP_Port_Number = OCT_STR(name='uDP-Port-Number', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Port-Number')), opt=True)
    _TunnelInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TunnelInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TunnelInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TunnelInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__id._const_tab = ____TunnelInformation_iE_Extensions__item__id_tab
    ___TunnelInformation_iE_Extensions__item__id._const_tab_at = None
    ___TunnelInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TunnelInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TunnelInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab = ____TunnelInformation_iE_Extensions__item__criticality_tab
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TunnelInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TunnelInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TunnelInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TunnelInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab = ____TunnelInformation_iE_Extensions__item__extensionValue_tab
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TunnelInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TunnelInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TunnelInformation_iE_Extensions__item__id),
        ('criticality', ___TunnelInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TunnelInformation_iE_Extensions__item__extensionValue),
        ])
    __TunnelInformation_iE_Extensions__item_._ext = None
    _TunnelInformation_iE_Extensions._cont = __TunnelInformation_iE_Extensions__item_
    _TunnelInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TunnelInformation._cont = ASN1Dict([
        ('transportLayerAddress', _TunnelInformation_transportLayerAddress),
        ('uDP-Port-Number', _TunnelInformation_uDP_Port_Number),
        ('iE-Extensions', _TunnelInformation_iE_Extensions),
        ])
    TunnelInformation._ext = []
    
    #-----< Tunnel-Information-ExtIEs >-----#
    Tunnel_Information_ExtIEs = CLASS(name='Tunnel-Information-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Tunnel_Information_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TypeOfError >-----#
    TypeOfError = ENUM(name='TypeOfError', mode=MODE_TYPE)
    TypeOfError._cont = ASN1Dict([('not-understood', 0), ('missing', 1)])
    TypeOfError._ext = []
    
    #-----< UE-AggregateMaximumBitRate >-----#
    UE_AggregateMaximumBitRate = SEQ(name='UE-AggregateMaximumBitRate', mode=MODE_TYPE)
    _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink = INT(name='uE-AggregateMaximumBitRateDownlink', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRateDownlink')), opt=True)
    _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink = INT(name='uE-AggregateMaximumBitRateUplink', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRateUplink')), opt=True)
    UE_AggregateMaximumBitRate._cont = ASN1Dict([
        ('uE-AggregateMaximumBitRateDownlink', _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink),
        ('uE-AggregateMaximumBitRateUplink', _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink),
        ])
    UE_AggregateMaximumBitRate._ext = []
    
    #-----< UE-AggregateMaximumBitRateDownlink >-----#
    UE_AggregateMaximumBitRateDownlink = INT(name='UE-AggregateMaximumBitRateDownlink', mode=MODE_TYPE)
    UE_AggregateMaximumBitRateDownlink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000000)], ev=None, er=[])
    
    #-----< UE-AggregateMaximumBitRateUplink >-----#
    UE_AggregateMaximumBitRateUplink = INT(name='UE-AggregateMaximumBitRateUplink', mode=MODE_TYPE)
    UE_AggregateMaximumBitRateUplink._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000000)], ev=None, er=[])
    
    #-----< UE-Application-Layer-Measurement-Capability >-----#
    UE_Application_Layer_Measurement_Capability = BIT_STR(name='UE-Application-Layer-Measurement-Capability', mode=MODE_TYPE)
    UE_Application_Layer_Measurement_Capability._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< UE-History-Information >-----#
    UE_History_Information = OCT_STR(name='UE-History-Information', mode=MODE_TYPE)
    
    #-----< UE-ID >-----#
    UE_ID = CHOICE(name='UE-ID', mode=MODE_TYPE)
    _UE_ID_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMSI')))
    _UE_ID_imei = OCT_STR(name='imei', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEI')))
    _UE_ID_imeisv = OCT_STR(name='imeisv', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IMEISV')))
    UE_ID._cont = ASN1Dict([
        ('imsi', _UE_ID_imsi),
        ('imei', _UE_ID_imei),
        ('imeisv', _UE_ID_imeisv),
        ])
    UE_ID._ext = ['imeisv']
    
    #-----< UE-IsNotServed >-----#
    UE_IsNotServed = SEQ(name='UE-IsNotServed', mode=MODE_TYPE)
    _UE_IsNotServed_permanentNAS_UE_ID = CHOICE(name='permanentNAS-UE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _UE_IsNotServed_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_IsNotServed_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UE_IsNotServed_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_IsNotServed_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsNotServed_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsNotServed_iE_Extensions__item__id._const_tab = ____UE_IsNotServed_iE_Extensions__item__id_tab
    ___UE_IsNotServed_iE_Extensions__item__id._const_tab_at = None
    ___UE_IsNotServed_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_IsNotServed_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_IsNotServed_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsNotServed_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsNotServed_iE_Extensions__item__criticality._const_tab = ____UE_IsNotServed_iE_Extensions__item__criticality_tab
    ___UE_IsNotServed_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_IsNotServed_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_IsNotServed_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_IsNotServed_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsNotServed_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsNotServed_iE_Extensions__item__extensionValue._const_tab = ____UE_IsNotServed_iE_Extensions__item__extensionValue_tab
    ___UE_IsNotServed_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_IsNotServed_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_IsNotServed_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_IsNotServed_iE_Extensions__item__id),
        ('criticality', ___UE_IsNotServed_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_IsNotServed_iE_Extensions__item__extensionValue),
        ])
    __UE_IsNotServed_iE_Extensions__item_._ext = None
    _UE_IsNotServed_iE_Extensions._cont = __UE_IsNotServed_iE_Extensions__item_
    _UE_IsNotServed_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_IsNotServed._cont = ASN1Dict([
        ('permanentNAS-UE-ID', _UE_IsNotServed_permanentNAS_UE_ID),
        ('iE-Extensions', _UE_IsNotServed_iE_Extensions),
        ])
    UE_IsNotServed._ext = []
    
    #-----< UE-IsNotServed-ExtIEs >-----#
    UE_IsNotServed_ExtIEs = CLASS(name='UE-IsNotServed-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UE_IsNotServed_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-IsServed >-----#
    UE_IsServed = SEQ(name='UE-IsServed', mode=MODE_TYPE)
    _UE_IsServed_permanentNAS_UE_ID = CHOICE(name='permanentNAS-UE-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _UE_IsServed_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _UE_IsServed_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UE_IsServed_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UE_IsServed_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UE_IsServed_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsServed_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsServed_iE_Extensions__item__id._const_tab = ____UE_IsServed_iE_Extensions__item__id_tab
    ___UE_IsServed_iE_Extensions__item__id._const_tab_at = None
    ___UE_IsServed_iE_Extensions__item__id._const_tab_id = 'id'
    ___UE_IsServed_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UE_IsServed_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsServed_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsServed_iE_Extensions__item__criticality._const_tab = ____UE_IsServed_iE_Extensions__item__criticality_tab
    ___UE_IsServed_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UE_IsServed_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UE_IsServed_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UE_IsServed_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UE_IsServed_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UE_IsServed_iE_Extensions__item__extensionValue._const_tab = ____UE_IsServed_iE_Extensions__item__extensionValue_tab
    ___UE_IsServed_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UE_IsServed_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UE_IsServed_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UE_IsServed_iE_Extensions__item__id),
        ('criticality', ___UE_IsServed_iE_Extensions__item__criticality),
        ('extensionValue', ___UE_IsServed_iE_Extensions__item__extensionValue),
        ])
    __UE_IsServed_iE_Extensions__item_._ext = None
    _UE_IsServed_iE_Extensions._cont = __UE_IsServed_iE_Extensions__item_
    _UE_IsServed_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UE_IsServed._cont = ASN1Dict([
        ('permanentNAS-UE-ID', _UE_IsServed_permanentNAS_UE_ID),
        ('pLMNidentity', _UE_IsServed_pLMNidentity),
        ('iE-Extensions', _UE_IsServed_iE_Extensions),
        ])
    UE_IsServed._ext = []
    
    #-----< UE-IsServed-ExtIEs >-----#
    UE_IsServed_ExtIEs = CLASS(name='UE-IsServed-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UE_IsServed_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UE-Usage-Type >-----#
    UE_Usage_Type = INT(name='UE-Usage-Type', mode=MODE_TYPE)
    UE_Usage_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< UERegistrationQueryResult >-----#
    UERegistrationQueryResult = CHOICE(name='UERegistrationQueryResult', mode=MODE_TYPE)
    _UERegistrationQueryResult_uE_IsServed = SEQ(name='uE-IsServed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UE-IsServed')))
    _UERegistrationQueryResult_uE_IsNotServed = SEQ(name='uE-IsNotServed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UE-IsNotServed')))
    UERegistrationQueryResult._cont = ASN1Dict([
        ('uE-IsServed', _UERegistrationQueryResult_uE_IsServed),
        ('uE-IsNotServed', _UERegistrationQueryResult_uE_IsNotServed),
        ])
    UERegistrationQueryResult._ext = None
    
    #-----< UESBI-Iu >-----#
    UESBI_Iu = SEQ(name='UESBI-Iu', mode=MODE_TYPE)
    _UESBI_Iu_uESBI_IuA = BIT_STR(name='uESBI-IuA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UESBI-IuA')), opt=True)
    _UESBI_Iu_uESBI_IuB = BIT_STR(name='uESBI-IuB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UESBI-IuB')), opt=True)
    _UESBI_Iu_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESBI_Iu_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UESBI_Iu_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UESBI_Iu_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESBI_Iu_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESBI_Iu_iE_Extensions__item__id._const_tab = ____UESBI_Iu_iE_Extensions__item__id_tab
    ___UESBI_Iu_iE_Extensions__item__id._const_tab_at = None
    ___UESBI_Iu_iE_Extensions__item__id._const_tab_id = 'id'
    ___UESBI_Iu_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UESBI_Iu_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESBI_Iu_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESBI_Iu_iE_Extensions__item__criticality._const_tab = ____UESBI_Iu_iE_Extensions__item__criticality_tab
    ___UESBI_Iu_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UESBI_Iu_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UESBI_Iu_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UESBI_Iu_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESBI_Iu_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESBI_Iu_iE_Extensions__item__extensionValue._const_tab = ____UESBI_Iu_iE_Extensions__item__extensionValue_tab
    ___UESBI_Iu_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UESBI_Iu_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UESBI_Iu_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UESBI_Iu_iE_Extensions__item__id),
        ('criticality', ___UESBI_Iu_iE_Extensions__item__criticality),
        ('extensionValue', ___UESBI_Iu_iE_Extensions__item__extensionValue),
        ])
    __UESBI_Iu_iE_Extensions__item_._ext = None
    _UESBI_Iu_iE_Extensions._cont = __UESBI_Iu_iE_Extensions__item_
    _UESBI_Iu_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESBI_Iu._cont = ASN1Dict([
        ('uESBI-IuA', _UESBI_Iu_uESBI_IuA),
        ('uESBI-IuB', _UESBI_Iu_uESBI_IuB),
        ('iE-Extensions', _UESBI_Iu_iE_Extensions),
        ])
    UESBI_Iu._ext = []
    
    #-----< UESBI-Iu-ExtIEs >-----#
    UESBI_Iu_ExtIEs = CLASS(name='UESBI-Iu-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UESBI_Iu_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UESBI-IuA >-----#
    UESBI_IuA = BIT_STR(name='UESBI-IuA', mode=MODE_TYPE)
    UESBI_IuA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< UESBI-IuB >-----#
    UESBI_IuB = BIT_STR(name='UESBI-IuB', mode=MODE_TYPE)
    UESBI_IuB._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< UL-GTP-PDU-SequenceNumber >-----#
    UL_GTP_PDU_SequenceNumber = INT(name='UL-GTP-PDU-SequenceNumber', mode=MODE_TYPE)
    UL_GTP_PDU_SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< UL-N-PDU-SequenceNumber >-----#
    UL_N_PDU_SequenceNumber = INT(name='UL-N-PDU-SequenceNumber', mode=MODE_TYPE)
    UL_N_PDU_SequenceNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< UPInformation >-----#
    UPInformation = SEQ(name='UPInformation', mode=MODE_TYPE)
    _UPInformation_frameSeqNoUL = INT(name='frameSeqNoUL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'FrameSequenceNumber')))
    _UPInformation_frameSeqNoDL = INT(name='frameSeqNoDL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'FrameSequenceNumber')))
    _UPInformation_pdu14FrameSeqNoUL = INT(name='pdu14FrameSeqNoUL', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PDUType14FrameSequenceNumber')))
    _UPInformation_pdu14FrameSeqNoDL = INT(name='pdu14FrameSeqNoDL', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PDUType14FrameSequenceNumber')))
    _UPInformation_dataPDUType = ENUM(name='dataPDUType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataPDUType')))
    _UPInformation_upinitialisationFrame = OCT_STR(name='upinitialisationFrame', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UPInitialisationFrame')))
    _UPInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UPInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UPInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UPInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____UPInformation_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TimingDifferenceULDL')))
    ____UPInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 269), ('criticality', 'ignore'), ('Extension', _____UPInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UPInformation_iE_Extensions__item__id._const_tab = ____UPInformation_iE_Extensions__item__id_tab
    ___UPInformation_iE_Extensions__item__id._const_tab_at = None
    ___UPInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___UPInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UPInformation_iE_Extensions__item__criticality._const_tab = ____UPInformation_iE_Extensions__item__id_tab
    ___UPInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UPInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UPInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UPInformation_iE_Extensions__item__extensionValue._const_tab = ____UPInformation_iE_Extensions__item__id_tab
    ___UPInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UPInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UPInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UPInformation_iE_Extensions__item__id),
        ('criticality', ___UPInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___UPInformation_iE_Extensions__item__extensionValue),
        ])
    __UPInformation_iE_Extensions__item_._ext = None
    _UPInformation_iE_Extensions._cont = __UPInformation_iE_Extensions__item_
    _UPInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UPInformation._cont = ASN1Dict([
        ('frameSeqNoUL', _UPInformation_frameSeqNoUL),
        ('frameSeqNoDL', _UPInformation_frameSeqNoDL),
        ('pdu14FrameSeqNoUL', _UPInformation_pdu14FrameSeqNoUL),
        ('pdu14FrameSeqNoDL', _UPInformation_pdu14FrameSeqNoDL),
        ('dataPDUType', _UPInformation_dataPDUType),
        ('upinitialisationFrame', _UPInformation_upinitialisationFrame),
        ('iE-Extensions', _UPInformation_iE_Extensions),
        ])
    UPInformation._ext = []
    
    #-----< UPInformation-ExtIEs >-----#
    UPInformation_ExtIEs = CLASS(name='UPInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _UPInformation_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TimingDifferenceULDL')))
    UPInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 269), ('criticality', 'ignore'), ('Extension', _UPInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UPInitialisationFrame >-----#
    UPInitialisationFrame = OCT_STR(name='UPInitialisationFrame', mode=MODE_TYPE)
    
    #-----< UP-ModeVersions >-----#
    UP_ModeVersions = BIT_STR(name='UP-ModeVersions', mode=MODE_TYPE)
    UP_ModeVersions._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< USCH-ID >-----#
    USCH_ID = INT(name='USCH-ID', mode=MODE_TYPE)
    USCH_ID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    
    #-----< UserPlaneMode >-----#
    UserPlaneMode = ENUM(name='UserPlaneMode', mode=MODE_TYPE)
    UserPlaneMode._cont = ASN1Dict([('transparent-mode', 0), ('support-mode-for-predefined-SDU-sizes', 1)])
    UserPlaneMode._ext = []
    
    #-----< UTRAN-CellID >-----#
    UTRAN_CellID = SEQ(name='UTRAN-CellID', mode=MODE_TYPE)
    _UTRAN_CellID_pLMNidentity = OCT_STR(name='pLMNidentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _UTRAN_CellID_cellID = INT(name='cellID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TargetCellId')))
    _UTRAN_CellID_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UTRAN_CellID_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UTRAN_CellID_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UTRAN_CellID_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UTRAN_CellID_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_CellID_iE_Extensions__item__id._const_tab = ____UTRAN_CellID_iE_Extensions__item__id_tab
    ___UTRAN_CellID_iE_Extensions__item__id._const_tab_at = None
    ___UTRAN_CellID_iE_Extensions__item__id._const_tab_id = 'id'
    ___UTRAN_CellID_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UTRAN_CellID_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UTRAN_CellID_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_CellID_iE_Extensions__item__criticality._const_tab = ____UTRAN_CellID_iE_Extensions__item__criticality_tab
    ___UTRAN_CellID_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UTRAN_CellID_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UTRAN_CellID_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UTRAN_CellID_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UTRAN_CellID_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UTRAN_CellID_iE_Extensions__item__extensionValue._const_tab = ____UTRAN_CellID_iE_Extensions__item__extensionValue_tab
    ___UTRAN_CellID_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UTRAN_CellID_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UTRAN_CellID_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UTRAN_CellID_iE_Extensions__item__id),
        ('criticality', ___UTRAN_CellID_iE_Extensions__item__criticality),
        ('extensionValue', ___UTRAN_CellID_iE_Extensions__item__extensionValue),
        ])
    __UTRAN_CellID_iE_Extensions__item_._ext = None
    _UTRAN_CellID_iE_Extensions._cont = __UTRAN_CellID_iE_Extensions__item_
    _UTRAN_CellID_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UTRAN_CellID._cont = ASN1Dict([
        ('pLMNidentity', _UTRAN_CellID_pLMNidentity),
        ('cellID', _UTRAN_CellID_cellID),
        ('iE-Extensions', _UTRAN_CellID_iE_Extensions),
        ])
    UTRAN_CellID._ext = None
    
    #-----< UTRAN-CellID-ExtIEs >-----#
    UTRAN_CellID_ExtIEs = CLASS(name='UTRAN-CellID-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UTRAN_CellID_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< VelocityEstimate >-----#
    VelocityEstimate = CHOICE(name='VelocityEstimate', mode=MODE_TYPE)
    _VelocityEstimate_horizontalVelocity = SEQ(name='horizontalVelocity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalVelocity')))
    _VelocityEstimate_horizontalWithVerticalVelocity = SEQ(name='horizontalWithVerticalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalWithVerticalVelocity')))
    _VelocityEstimate_horizontalVelocityWithUncertainty = SEQ(name='horizontalVelocityWithUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalVelocityWithUncertainty')))
    _VelocityEstimate_horizontalWithVeritcalVelocityAndUncertainty = SEQ(name='horizontalWithVeritcalVelocityAndUncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalWithVerticalVelocityAndUncertainty')))
    VelocityEstimate._cont = ASN1Dict([
        ('horizontalVelocity', _VelocityEstimate_horizontalVelocity),
        ('horizontalWithVerticalVelocity', _VelocityEstimate_horizontalWithVerticalVelocity),
        ('horizontalVelocityWithUncertainty', _VelocityEstimate_horizontalVelocityWithUncertainty),
        ('horizontalWithVeritcalVelocityAndUncertainty', _VelocityEstimate_horizontalWithVeritcalVelocityAndUncertainty),
        ])
    VelocityEstimate._ext = []
    
    #-----< HorizontalVelocity >-----#
    HorizontalVelocity = SEQ(name='HorizontalVelocity', mode=MODE_TYPE)
    _HorizontalVelocity_horizontalSpeedAndBearing = SEQ(name='horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalVelocity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalVelocity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalVelocity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____HorizontalVelocity_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocity_iE_Extensions__item__id._const_tab = ____HorizontalVelocity_iE_Extensions__item__id_tab
    ___HorizontalVelocity_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalVelocity_iE_Extensions__item__id._const_tab_id = 'id'
    ___HorizontalVelocity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HorizontalVelocity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocity_iE_Extensions__item__criticality._const_tab = ____HorizontalVelocity_iE_Extensions__item__criticality_tab
    ___HorizontalVelocity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HorizontalVelocity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HorizontalVelocity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocity_iE_Extensions__item__extensionValue._const_tab = ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab
    ___HorizontalVelocity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HorizontalVelocity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HorizontalVelocity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HorizontalVelocity_iE_Extensions__item__id),
        ('criticality', ___HorizontalVelocity_iE_Extensions__item__criticality),
        ('extensionValue', ___HorizontalVelocity_iE_Extensions__item__extensionValue),
        ])
    __HorizontalVelocity_iE_Extensions__item_._ext = None
    _HorizontalVelocity_iE_Extensions._cont = __HorizontalVelocity_iE_Extensions__item_
    _HorizontalVelocity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalVelocity._cont = ASN1Dict([
        ('horizontalSpeedAndBearing', _HorizontalVelocity_horizontalSpeedAndBearing),
        ('iE-Extensions', _HorizontalVelocity_iE_Extensions),
        ])
    HorizontalVelocity._ext = []
    
    #-----< HorizontalVelocity-ExtIEs >-----#
    HorizontalVelocity_ExtIEs = CLASS(name='HorizontalVelocity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    HorizontalVelocity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalWithVerticalVelocity >-----#
    HorizontalWithVerticalVelocity = SEQ(name='HorizontalWithVerticalVelocity', mode=MODE_TYPE)
    _HorizontalWithVerticalVelocity_horizontalSpeedAndBearing = SEQ(name='horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalWithVerticalVelocity_veritcalVelocity = SEQ(name='veritcalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'VerticalVelocity')))
    _HorizontalWithVerticalVelocity_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalWithVerticalVelocity_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id._const_tab = ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__id._const_tab_id = 'id'
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality._const_tab = ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue._const_tab = ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HorizontalWithVerticalVelocity_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HorizontalWithVerticalVelocity_iE_Extensions__item__id),
        ('criticality', ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality),
        ('extensionValue', ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue),
        ])
    __HorizontalWithVerticalVelocity_iE_Extensions__item_._ext = None
    _HorizontalWithVerticalVelocity_iE_Extensions._cont = __HorizontalWithVerticalVelocity_iE_Extensions__item_
    _HorizontalWithVerticalVelocity_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalWithVerticalVelocity._cont = ASN1Dict([
        ('horizontalSpeedAndBearing', _HorizontalWithVerticalVelocity_horizontalSpeedAndBearing),
        ('veritcalVelocity', _HorizontalWithVerticalVelocity_veritcalVelocity),
        ('iE-Extensions', _HorizontalWithVerticalVelocity_iE_Extensions),
        ])
    HorizontalWithVerticalVelocity._ext = []
    
    #-----< HorizontalWithVerticalVelocity-ExtIEs >-----#
    HorizontalWithVerticalVelocity_ExtIEs = CLASS(name='HorizontalWithVerticalVelocity-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    HorizontalWithVerticalVelocity_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalVelocityWithUncertainty >-----#
    HorizontalVelocityWithUncertainty = SEQ(name='HorizontalVelocityWithUncertainty', mode=MODE_TYPE)
    _HorizontalVelocityWithUncertainty_horizontalSpeedAndBearing = SEQ(name='horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalVelocityWithUncertainty_uncertaintySpeed = INT(name='uncertaintySpeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalVelocityWithUncertainty_uncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalVelocityWithUncertainty_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalVelocityWithUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id._const_tab = ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id._const_tab_id = 'id'
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality._const_tab = ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue._const_tab = ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HorizontalVelocityWithUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id),
        ('criticality', ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality),
        ('extensionValue', ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue),
        ])
    __HorizontalVelocityWithUncertainty_iE_Extensions__item_._ext = None
    _HorizontalVelocityWithUncertainty_iE_Extensions._cont = __HorizontalVelocityWithUncertainty_iE_Extensions__item_
    _HorizontalVelocityWithUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalVelocityWithUncertainty._cont = ASN1Dict([
        ('horizontalSpeedAndBearing', _HorizontalVelocityWithUncertainty_horizontalSpeedAndBearing),
        ('uncertaintySpeed', _HorizontalVelocityWithUncertainty_uncertaintySpeed),
        ('iE-Extensions', _HorizontalVelocityWithUncertainty_iE_Extensions),
        ])
    HorizontalVelocityWithUncertainty._ext = []
    
    #-----< HorizontalVelocityWithUncertainty-ExtIEs >-----#
    HorizontalVelocityWithUncertainty_ExtIEs = CLASS(name='HorizontalVelocityWithUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    HorizontalVelocityWithUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalWithVerticalVelocityAndUncertainty >-----#
    HorizontalWithVerticalVelocityAndUncertainty = SEQ(name='HorizontalWithVerticalVelocityAndUncertainty', mode=MODE_TYPE)
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeedAndBearing = SEQ(name='horizontalSpeedAndBearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'HorizontalSpeedAndBearing')))
    _HorizontalWithVerticalVelocityAndUncertainty_veritcalVelocity = SEQ(name='veritcalVelocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'VerticalVelocity')))
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed = INT(name='horizontalUncertaintySpeed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed = INT(name='verticalUncertaintySpeed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id._const_tab = ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id._const_tab_at = None
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id._const_tab_id = 'id'
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality._const_tab = ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue._const_tab = ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id),
        ('criticality', ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality),
        ('extensionValue', ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue),
        ])
    __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_._ext = None
    _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions._cont = __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_
    _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    HorizontalWithVerticalVelocityAndUncertainty._cont = ASN1Dict([
        ('horizontalSpeedAndBearing', _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeedAndBearing),
        ('veritcalVelocity', _HorizontalWithVerticalVelocityAndUncertainty_veritcalVelocity),
        ('horizontalUncertaintySpeed', _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed),
        ('verticalUncertaintySpeed', _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed),
        ('iE-Extensions', _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions),
        ])
    HorizontalWithVerticalVelocityAndUncertainty._ext = []
    
    #-----< HorizontalWithVerticalVelocityAndUncertainty-ExtIEs >-----#
    HorizontalWithVerticalVelocityAndUncertainty_ExtIEs = CLASS(name='HorizontalWithVerticalVelocityAndUncertainty-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    HorizontalWithVerticalVelocityAndUncertainty_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< HorizontalSpeedAndBearing >-----#
    HorizontalSpeedAndBearing = SEQ(name='HorizontalSpeedAndBearing', mode=MODE_TYPE)
    _HorizontalSpeedAndBearing_bearing = INT(name='bearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalSpeedAndBearing_bearing._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=359)], ev=None, er=[])
    _HorizontalSpeedAndBearing_horizontalSpeed = INT(name='horizontalSpeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HorizontalSpeedAndBearing_horizontalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2047)], ev=None, er=[])
    HorizontalSpeedAndBearing._cont = ASN1Dict([
        ('bearing', _HorizontalSpeedAndBearing_bearing),
        ('horizontalSpeed', _HorizontalSpeedAndBearing_horizontalSpeed),
        ])
    HorizontalSpeedAndBearing._ext = None
    
    #-----< VerticalVelocity >-----#
    VerticalVelocity = SEQ(name='VerticalVelocity', mode=MODE_TYPE)
    _VerticalVelocity_veritcalSpeed = INT(name='veritcalSpeed', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _VerticalVelocity_veritcalSpeed._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _VerticalVelocity_veritcalSpeedDirection = ENUM(name='veritcalSpeedDirection', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'VerticalSpeedDirection')))
    VerticalVelocity._cont = ASN1Dict([
        ('veritcalSpeed', _VerticalVelocity_veritcalSpeed),
        ('veritcalSpeedDirection', _VerticalVelocity_veritcalSpeedDirection),
        ])
    VerticalVelocity._ext = None
    
    #-----< VerticalSpeedDirection >-----#
    VerticalSpeedDirection = ENUM(name='VerticalSpeedDirection', mode=MODE_TYPE)
    VerticalSpeedDirection._cont = ASN1Dict([('upward', 0), ('downward', 1)])
    VerticalSpeedDirection._ext = None
    
    #-----< VerticalAccuracyCode >-----#
    VerticalAccuracyCode = INT(name='VerticalAccuracyCode', mode=MODE_TYPE)
    VerticalAccuracyCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< VoiceSupportMatchIndicator >-----#
    VoiceSupportMatchIndicator = ENUM(name='VoiceSupportMatchIndicator', mode=MODE_TYPE)
    VoiceSupportMatchIndicator._cont = ASN1Dict([('supported', 0), ('not-supported', 1)])
    VoiceSupportMatchIndicator._ext = []
    
    _all_ = [
        AccuracyFulfilmentIndicator,
        _Additional_CSPS_coordination_information_old_LAI,
        _Additional_CSPS_coordination_information_old_RAC,
        _Additional_CSPS_coordination_information_nRI,
        _Additional_CSPS_coordination_information_uE_is_Attaching,
        ____Additional_CSPS_coordination_information_iE_Extensions__item__id_tab,
        ___Additional_CSPS_coordination_information_iE_Extensions__item__id,
        ____Additional_CSPS_coordination_information_iE_Extensions__item__criticality_tab,
        ___Additional_CSPS_coordination_information_iE_Extensions__item__criticality,
        ____Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue_tab,
        ___Additional_CSPS_coordination_information_iE_Extensions__item__extensionValue,
        __Additional_CSPS_coordination_information_iE_Extensions__item_,
        _Additional_CSPS_coordination_information_iE_Extensions,
        Additional_CSPS_coordination_information,
        Additional_CSPS_coordination_information_ExtIEs,
        _Additional_PositioningDataSet__item_,
        Additional_PositioningDataSet,
        Additional_PositioningMethodAndUsage,
        _AllocationOrRetentionPriority_priorityLevel,
        _AllocationOrRetentionPriority_pre_emptionCapability,
        _AllocationOrRetentionPriority_pre_emptionVulnerability,
        _AllocationOrRetentionPriority_queuingAllowed,
        ____AllocationOrRetentionPriority_iE_Extensions__item__id_tab,
        ___AllocationOrRetentionPriority_iE_Extensions__item__id,
        ____AllocationOrRetentionPriority_iE_Extensions__item__criticality_tab,
        ___AllocationOrRetentionPriority_iE_Extensions__item__criticality,
        ____AllocationOrRetentionPriority_iE_Extensions__item__extensionValue_tab,
        ___AllocationOrRetentionPriority_iE_Extensions__item__extensionValue,
        __AllocationOrRetentionPriority_iE_Extensions__item_,
        _AllocationOrRetentionPriority_iE_Extensions,
        AllocationOrRetentionPriority,
        AllocationOrRetentionPriority_ExtIEs,
        _Alt_RAB_Parameters_altMaxBitrateInf,
        _Alt_RAB_Parameters_altGuaranteedBitRateInf,
        ____Alt_RAB_Parameters_iE_Extensions__item__id_tab,
        _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1,
        _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2,
        _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3,
        _____Alt_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4,
        ___Alt_RAB_Parameters_iE_Extensions__item__id,
        ___Alt_RAB_Parameters_iE_Extensions__item__criticality,
        ___Alt_RAB_Parameters_iE_Extensions__item__extensionValue,
        __Alt_RAB_Parameters_iE_Extensions__item_,
        _Alt_RAB_Parameters_iE_Extensions,
        Alt_RAB_Parameters,
        Alt_RAB_Parameters_ExtIEs,
        _Alt_RAB_Parameters_ExtIEs_val_Extension_0,
        _Alt_RAB_Parameters_ExtIEs_val_Extension_1,
        _Alt_RAB_Parameters_ExtIEs_val_Extension_2,
        _Alt_RAB_Parameters_ExtIEs_val_Extension_3,
        _Alt_RAB_Parameters_ExtIEs_val_Extension_4,
        _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrateType,
        _Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf_altExtendedGuaranteedBitrates,
        Alt_RAB_Parameter_ExtendedGuaranteedBitrateInf,
        _Alt_RAB_Parameter_ExtendedGuaranteedBitrates__item_,
        Alt_RAB_Parameter_ExtendedGuaranteedBitrates,
        _Alt_RAB_Parameter_ExtendedGuaranteedBitrateList__item_,
        Alt_RAB_Parameter_ExtendedGuaranteedBitrateList,
        _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrateType,
        _Alt_RAB_Parameter_GuaranteedBitrateInf_altGuaranteedBitrates,
        Alt_RAB_Parameter_GuaranteedBitrateInf,
        Alt_RAB_Parameter_GuaranteedBitrateType,
        _Alt_RAB_Parameter_GuaranteedBitrates__item_,
        Alt_RAB_Parameter_GuaranteedBitrates,
        _Alt_RAB_Parameter_GuaranteedBitrateList__item_,
        Alt_RAB_Parameter_GuaranteedBitrateList,
        _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrateType,
        _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_altSupportedGuaranteedBitrates,
        ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id_tab,
        ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__id,
        ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality_tab,
        ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__criticality,
        ____Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue_tab,
        ___Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item__extensionValue,
        __Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions__item_,
        _Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_iE_Extensions,
        Alt_RAB_Parameter_SupportedGuaranteedBitrateInf,
        Alt_RAB_Parameter_SupportedGuaranteedBitrateInf_ExtIEs,
        _Alt_RAB_Parameter_SupportedGuaranteedBitrates__item_,
        Alt_RAB_Parameter_SupportedGuaranteedBitrates,
        _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrateType,
        _Alt_RAB_Parameter_ExtendedMaxBitrateInf_altExtendedMaxBitrates,
        Alt_RAB_Parameter_ExtendedMaxBitrateInf,
        _Alt_RAB_Parameter_ExtendedMaxBitrates__item_,
        Alt_RAB_Parameter_ExtendedMaxBitrates,
        _Alt_RAB_Parameter_ExtendedMaxBitrateList__item_,
        Alt_RAB_Parameter_ExtendedMaxBitrateList,
        _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrateType,
        _Alt_RAB_Parameter_MaxBitrateInf_altMaxBitrates,
        Alt_RAB_Parameter_MaxBitrateInf,
        Alt_RAB_Parameter_MaxBitrateType,
        _Alt_RAB_Parameter_MaxBitrates__item_,
        Alt_RAB_Parameter_MaxBitrates,
        _Alt_RAB_Parameter_MaxBitrateList__item_,
        Alt_RAB_Parameter_MaxBitrateList,
        _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrateType,
        _Alt_RAB_Parameter_SupportedMaxBitrateInf_altSupportedMaxBitrates,
        ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id_tab,
        ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__id,
        ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality_tab,
        ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__criticality,
        ____Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue_tab,
        ___Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item__extensionValue,
        __Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions__item_,
        _Alt_RAB_Parameter_SupportedMaxBitrateInf_iE_Extensions,
        Alt_RAB_Parameter_SupportedMaxBitrateInf,
        Alt_RAB_Parameter_SupportedMaxBitrateInf_ExtIEs,
        _Alt_RAB_Parameter_SupportedMaxBitrates__item_,
        Alt_RAB_Parameter_SupportedMaxBitrates,
        AlternativeRABConfigurationRequest,
        _UE_Application_Layer_Measurement_Configuration_applicationLayerContainerForMeasurementConfiguration,
        _UE_Application_Layer_Measurement_Configuration_areaScopeForUEApplicationLayerMeasurementConfiguration,
        _UE_Application_Layer_Measurement_Configuration_serviceType,
        UE_Application_Layer_Measurement_Configuration,
        _UE_Application_Layer_Measurement_Configuration_For_Relocation_areaScopeForUEApplicationLayerMeasurementConfiguration,
        _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceReference,
        _UE_Application_Layer_Measurement_Configuration_For_Relocation_tracePropagationParameters,
        _UE_Application_Layer_Measurement_Configuration_For_Relocation_traceCollectionEntityIPAddress,
        _UE_Application_Layer_Measurement_Configuration_For_Relocation_serviceType,
        UE_Application_Layer_Measurement_Configuration_For_Relocation,
        ServiceType,
        APN,
        _AreaScopeForUEApplicationLayerMeasurementConfiguration_cellbased,
        _AreaScopeForUEApplicationLayerMeasurementConfiguration_labased,
        _AreaScopeForUEApplicationLayerMeasurementConfiguration_rabased,
        _AreaScopeForUEApplicationLayerMeasurementConfiguration_plmn_area_based,
        AreaScopeForUEApplicationLayerMeasurementConfiguration,
        _AreaIdentity_sAI,
        _AreaIdentity_geographicalArea,
        AreaIdentity,
        _Ass_RAB_Parameters_assMaxBitrateInf,
        _Ass_RAB_Parameters_assGuaranteedBitRateInf,
        ____Ass_RAB_Parameters_iE_Extensions__item__id_tab,
        _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1,
        _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2,
        _____Ass_RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3,
        ___Ass_RAB_Parameters_iE_Extensions__item__id,
        ___Ass_RAB_Parameters_iE_Extensions__item__criticality,
        ___Ass_RAB_Parameters_iE_Extensions__item__extensionValue,
        __Ass_RAB_Parameters_iE_Extensions__item_,
        _Ass_RAB_Parameters_iE_Extensions,
        Ass_RAB_Parameters,
        Ass_RAB_Parameters_ExtIEs,
        _Ass_RAB_Parameters_ExtIEs_val_Extension_0,
        _Ass_RAB_Parameters_ExtIEs_val_Extension_1,
        _Ass_RAB_Parameters_ExtIEs_val_Extension_2,
        _Ass_RAB_Parameters_ExtIEs_val_Extension_3,
        _Ass_RAB_Parameter_ExtendedGuaranteedBitrateList__item_,
        Ass_RAB_Parameter_ExtendedGuaranteedBitrateList,
        _Ass_RAB_Parameter_ExtendedMaxBitrateList__item_,
        Ass_RAB_Parameter_ExtendedMaxBitrateList,
        _Ass_RAB_Parameter_GuaranteedBitrateList__item_,
        Ass_RAB_Parameter_GuaranteedBitrateList,
        _Ass_RAB_Parameter_MaxBitrateList__item_,
        Ass_RAB_Parameter_MaxBitrateList,
        __AuthorisedPLMNs__item__pLMNidentity,
        __AuthorisedPLMNs__item__authorisedSNAsList,
        _____AuthorisedPLMNs__item__iE_Extensions__item__id_tab,
        ____AuthorisedPLMNs__item__iE_Extensions__item__id,
        _____AuthorisedPLMNs__item__iE_Extensions__item__criticality_tab,
        ____AuthorisedPLMNs__item__iE_Extensions__item__criticality,
        _____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue_tab,
        ____AuthorisedPLMNs__item__iE_Extensions__item__extensionValue,
        ___AuthorisedPLMNs__item__iE_Extensions__item_,
        __AuthorisedPLMNs__item__iE_Extensions,
        _AuthorisedPLMNs__item_,
        AuthorisedPLMNs,
        AuthorisedPLMNs_ExtIEs,
        _AuthorisedSNAs__item_,
        AuthorisedSNAs,
        BarometricPressure,
        BindingID,
        _BroadcastAssistanceDataDecipheringKeys_cipheringKeyFlag,
        _BroadcastAssistanceDataDecipheringKeys_currentDecipheringKey,
        _BroadcastAssistanceDataDecipheringKeys_nextDecipheringKey,
        BroadcastAssistanceDataDecipheringKeys,
        _Cause_radioNetwork,
        _Cause_transmissionNetwork,
        _Cause_nAS,
        _Cause_protocol,
        _Cause_misc,
        _Cause_non_Standard,
        _Cause_radioNetworkExtension,
        Cause,
        CauseMisc,
        CauseNAS,
        CauseProtocol,
        CauseRadioNetwork,
        CauseRadioNetworkExtension,
        CauseNon_Standard,
        CauseTransmissionNetwork,
        Cell_Access_Mode,
        _CellBased_cellIdList,
        ____CellBased_iE_Extensions__item__id_tab,
        ___CellBased_iE_Extensions__item__id,
        ____CellBased_iE_Extensions__item__criticality_tab,
        ___CellBased_iE_Extensions__item__criticality,
        ____CellBased_iE_Extensions__item__extensionValue_tab,
        ___CellBased_iE_Extensions__item__extensionValue,
        __CellBased_iE_Extensions__item_,
        _CellBased_iE_Extensions,
        CellBased,
        CellBased_ExtIEs,
        _CellIdList__item_,
        CellIdList,
        Cell_Id,
        Cell_Capacity_Class_Value,
        _CellLoadInformation_cell_Capacity_Class_Value,
        _CellLoadInformation_loadValue,
        _CellLoadInformation_rTLoadValue,
        _CellLoadInformation_nRTLoadInformationValue,
        ____CellLoadInformation_iE_Extensions__item__id_tab,
        ___CellLoadInformation_iE_Extensions__item__id,
        ____CellLoadInformation_iE_Extensions__item__criticality_tab,
        ___CellLoadInformation_iE_Extensions__item__criticality,
        ____CellLoadInformation_iE_Extensions__item__extensionValue_tab,
        ___CellLoadInformation_iE_Extensions__item__extensionValue,
        __CellLoadInformation_iE_Extensions__item_,
        _CellLoadInformation_iE_Extensions,
        CellLoadInformation,
        CellLoadInformation_ExtIEs,
        _CellLoadInformationGroup_sourceCellID,
        _CellLoadInformationGroup_uplinkCellLoadInformation,
        _CellLoadInformationGroup_downlinkCellLoadInformation,
        ____CellLoadInformationGroup_iE_Extensions__item__id_tab,
        ___CellLoadInformationGroup_iE_Extensions__item__id,
        ____CellLoadInformationGroup_iE_Extensions__item__criticality_tab,
        ___CellLoadInformationGroup_iE_Extensions__item__criticality,
        ____CellLoadInformationGroup_iE_Extensions__item__extensionValue_tab,
        ___CellLoadInformationGroup_iE_Extensions__item__extensionValue,
        __CellLoadInformationGroup_iE_Extensions__item_,
        _CellLoadInformationGroup_iE_Extensions,
        CellLoadInformationGroup,
        CellLoadInformationGroup_ExtIEs,
        CellType,
        CivicAddress,
        ClientType,
        _CriticalityDiagnostics_procedureCode,
        _CriticalityDiagnostics_triggeringMessage,
        _CriticalityDiagnostics_procedureCriticality,
        _CriticalityDiagnostics_iEsCriticalityDiagnostics,
        ____CriticalityDiagnostics_iE_Extensions__item__id_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__id,
        ____CriticalityDiagnostics_iE_Extensions__item__criticality_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_iE_Extensions__item__extensionValue_tab,
        ___CriticalityDiagnostics_iE_Extensions__item__extensionValue,
        __CriticalityDiagnostics_iE_Extensions__item_,
        _CriticalityDiagnostics_iE_Extensions,
        CriticalityDiagnostics,
        CriticalityDiagnostics_ExtIEs,
        __CriticalityDiagnostics_IE_List__item__iECriticality,
        __CriticalityDiagnostics_IE_List__item__iE_ID,
        __CriticalityDiagnostics_IE_List__item__repetitionNumber,
        _____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab,
        ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_0,
        ______CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id_tab_val_Extension_1,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__id,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__criticality,
        ____CriticalityDiagnostics_IE_List__item__iE_Extensions__item__extensionValue,
        ___CriticalityDiagnostics_IE_List__item__iE_Extensions__item_,
        __CriticalityDiagnostics_IE_List__item__iE_Extensions,
        _CriticalityDiagnostics_IE_List__item_,
        CriticalityDiagnostics_IE_List,
        CriticalityDiagnostics_IE_List_ExtIEs,
        _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_0,
        _CriticalityDiagnostics_IE_List_ExtIEs_val_Extension_1,
        __MessageStructure__item__iE_ID,
        __MessageStructure__item__repetitionNumber,
        _____MessageStructure__item__iE_Extensions__item__id_tab,
        ____MessageStructure__item__iE_Extensions__item__id,
        _____MessageStructure__item__iE_Extensions__item__criticality_tab,
        ____MessageStructure__item__iE_Extensions__item__criticality,
        _____MessageStructure__item__iE_Extensions__item__extensionValue_tab,
        ____MessageStructure__item__iE_Extensions__item__extensionValue,
        ___MessageStructure__item__iE_Extensions__item_,
        __MessageStructure__item__iE_Extensions,
        _MessageStructure__item_,
        MessageStructure,
        MessageStructure_ExtIEs,
        _CGI_pLMNidentity,
        _CGI_lAC,
        _CGI_cI,
        ____CGI_iE_Extensions__item__id_tab,
        _____CGI_iE_Extensions__item__id_tab_val_Extension_0,
        ___CGI_iE_Extensions__item__id,
        ___CGI_iE_Extensions__item__criticality,
        ___CGI_iE_Extensions__item__extensionValue,
        __CGI_iE_Extensions__item_,
        _CGI_iE_Extensions,
        CGI,
        CGI_ExtIEs,
        _CGI_ExtIEs_val_Extension_0,
        ChosenEncryptionAlgorithm,
        ChosenIntegrityProtectionAlgorithm,
        CI,
        ClassmarkInformation2,
        ClassmarkInformation3,
        CN_DomainIndicator,
        CN_ID,
        Correlation_ID,
        CSFB_Information,
        CSG_Id,
        _CSG_Id_List__item_,
        CSG_Id_List,
        CSG_Membership_Status,
        DataPDUType,
        DataVolumeReference,
        DataVolumeReportingIndication,
        DCH_ID,
        DCN_ID,
        DeliveryOfErroneousSDU,
        DeliveryOrder,
        _DeltaRAListofIdleModeUEs_newRAListofIdleModeUEs,
        _DeltaRAListofIdleModeUEs_rAListwithNoIdleModeUEsAnyMore,
        ____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab,
        _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0,
        _____DeltaRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_1,
        ___DeltaRAListofIdleModeUEs_iE_Extensions__item__id,
        ___DeltaRAListofIdleModeUEs_iE_Extensions__item__criticality,
        ___DeltaRAListofIdleModeUEs_iE_Extensions__item__extensionValue,
        __DeltaRAListofIdleModeUEs_iE_Extensions__item_,
        _DeltaRAListofIdleModeUEs_iE_Extensions,
        DeltaRAListofIdleModeUEs,
        _NewRAListofIdleModeUEs__item_,
        NewRAListofIdleModeUEs,
        _RAListwithNoIdleModeUEsAnyMore__item_,
        RAListwithNoIdleModeUEsAnyMore,
        DeltaRAListofIdleModeUEs_ExtIEs,
        _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_0,
        _DeltaRAListofIdleModeUEs_ExtIEs_val_Extension_1,
        ForwardingIndication,
        DL_GTP_PDU_SequenceNumber,
        DL_N_PDU_SequenceNumber,
        D_RNTI,
        DRX_CycleLengthCoefficient,
        DSCH_ID,
        EARFCN_Extended,
        E_DCH_MAC_d_Flow_ID,
        _ENB_ID_macroENB_ID,
        _ENB_ID_homeENB_ID,
        _ENB_ID_short_macroENB_ID,
        _ENB_ID_long_macroENB_ID,
        ENB_ID,
        EncryptionAlgorithm,
        _EncryptionInformation_permittedAlgorithms,
        _EncryptionInformation_key,
        ____EncryptionInformation_iE_Extensions__item__id_tab,
        ___EncryptionInformation_iE_Extensions__item__id,
        ____EncryptionInformation_iE_Extensions__item__criticality_tab,
        ___EncryptionInformation_iE_Extensions__item__criticality,
        ____EncryptionInformation_iE_Extensions__item__extensionValue_tab,
        ___EncryptionInformation_iE_Extensions__item__extensionValue,
        __EncryptionInformation_iE_Extensions__item_,
        _EncryptionInformation_iE_Extensions,
        EncryptionInformation,
        EncryptionInformation_ExtIEs,
        EncryptionKey,
        End_Of_CSFB,
        _EquipmentsToBeTraced_iMEIlist,
        _EquipmentsToBeTraced_iMEISVlist,
        _EquipmentsToBeTraced_iMEIgroup,
        _EquipmentsToBeTraced_iMEISVgroup,
        EquipmentsToBeTraced,
        E_UTRAN_Service_Handover,
        Event,
        _Event1F_Parameters_measurementQuantity,
        _Event1F_Parameters_threshold,
        Event1F_Parameters,
        _Event1I_Parameters_threshold,
        Event1I_Parameters,
        ExtendedGuaranteedBitrate,
        ExtendedMaxBitrate,
        ExtendedRNC_ID,
        FrameSequenceNumber,
        FrequenceLayerConvergenceFlag,
        _GANSS_PositioningDataSet__item_,
        GANSS_PositioningDataSet,
        GANSS_PositioningMethodAndUsage,
        _GeographicalArea_point,
        _GeographicalArea_pointWithUnCertainty,
        _GeographicalArea_polygon,
        _GeographicalArea_pointWithUncertaintyEllipse,
        _GeographicalArea_pointWithAltitude,
        _GeographicalArea_pointWithAltitudeAndUncertaintyEllipsoid,
        _GeographicalArea_ellipsoidArc,
        GeographicalArea,
        _GeographicalCoordinates_latitudeSign,
        _GeographicalCoordinates_latitude,
        _GeographicalCoordinates_longitude,
        ____GeographicalCoordinates_iE_Extensions__item__id_tab,
        ___GeographicalCoordinates_iE_Extensions__item__id,
        ____GeographicalCoordinates_iE_Extensions__item__criticality_tab,
        ___GeographicalCoordinates_iE_Extensions__item__criticality,
        ____GeographicalCoordinates_iE_Extensions__item__extensionValue_tab,
        ___GeographicalCoordinates_iE_Extensions__item__extensionValue,
        __GeographicalCoordinates_iE_Extensions__item_,
        _GeographicalCoordinates_iE_Extensions,
        GeographicalCoordinates,
        GeographicalCoordinates_ExtIEs,
        _GA_AltitudeAndDirection_directionOfAltitude,
        _GA_AltitudeAndDirection_altitude,
        GA_AltitudeAndDirection,
        _GA_EllipsoidArc_geographicalCoordinates,
        _GA_EllipsoidArc_innerRadius,
        _GA_EllipsoidArc_uncertaintyRadius,
        _GA_EllipsoidArc_offsetAngle,
        _GA_EllipsoidArc_includedAngle,
        _GA_EllipsoidArc_confidence,
        ____GA_EllipsoidArc_iE_Extensions__item__id_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__id,
        ____GA_EllipsoidArc_iE_Extensions__item__criticality_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__criticality,
        ____GA_EllipsoidArc_iE_Extensions__item__extensionValue_tab,
        ___GA_EllipsoidArc_iE_Extensions__item__extensionValue,
        __GA_EllipsoidArc_iE_Extensions__item_,
        _GA_EllipsoidArc_iE_Extensions,
        GA_EllipsoidArc,
        GA_EllipsoidArc_ExtIEs,
        _GA_Point_geographicalCoordinates,
        ____GA_Point_iE_Extensions__item__id_tab,
        ___GA_Point_iE_Extensions__item__id,
        ____GA_Point_iE_Extensions__item__criticality_tab,
        ___GA_Point_iE_Extensions__item__criticality,
        ____GA_Point_iE_Extensions__item__extensionValue_tab,
        ___GA_Point_iE_Extensions__item__extensionValue,
        __GA_Point_iE_Extensions__item_,
        _GA_Point_iE_Extensions,
        GA_Point,
        GA_Point_ExtIEs,
        _GA_PointWithAltitude_geographicalCoordinates,
        _GA_PointWithAltitude_altitudeAndDirection,
        ____GA_PointWithAltitude_iE_Extensions__item__id_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__id,
        ____GA_PointWithAltitude_iE_Extensions__item__criticality_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__criticality,
        ____GA_PointWithAltitude_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithAltitude_iE_Extensions__item__extensionValue,
        __GA_PointWithAltitude_iE_Extensions__item_,
        _GA_PointWithAltitude_iE_Extensions,
        GA_PointWithAltitude,
        GA_PointWithAltitude_ExtIEs,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_geographicalCoordinates,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_altitudeAndDirection,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyEllipse,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_uncertaintyAltitude,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_confidence,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__id,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__criticality,
        ____GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item__extensionValue,
        __GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions__item_,
        _GA_PointWithAltitudeAndUncertaintyEllipsoid_iE_Extensions,
        GA_PointWithAltitudeAndUncertaintyEllipsoid,
        GA_PointWithAltitudeAndUncertaintyEllipsoid_ExtIEs,
        _GA_PointWithUnCertainty_geographicalCoordinates,
        ____GA_PointWithUnCertainty_iE_Extensions__item__id_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__id,
        ____GA_PointWithUnCertainty_iE_Extensions__item__criticality_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__criticality,
        ____GA_PointWithUnCertainty_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithUnCertainty_iE_Extensions__item__extensionValue,
        __GA_PointWithUnCertainty_iE_Extensions__item_,
        _GA_PointWithUnCertainty_iE_Extensions,
        _GA_PointWithUnCertainty_uncertaintyCode,
        GA_PointWithUnCertainty,
        GA_PointWithUnCertainty_ExtIEs,
        _GA_PointWithUnCertaintyEllipse_geographicalCoordinates,
        _GA_PointWithUnCertaintyEllipse_uncertaintyEllipse,
        _GA_PointWithUnCertaintyEllipse_confidence,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__id,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__criticality,
        ____GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue_tab,
        ___GA_PointWithUnCertaintyEllipse_iE_Extensions__item__extensionValue,
        __GA_PointWithUnCertaintyEllipse_iE_Extensions__item_,
        _GA_PointWithUnCertaintyEllipse_iE_Extensions,
        GA_PointWithUnCertaintyEllipse,
        GA_PointWithUnCertaintyEllipse_ExtIEs,
        __GA_Polygon__item__geographicalCoordinates,
        _____GA_Polygon__item__iE_Extensions__item__id_tab,
        ____GA_Polygon__item__iE_Extensions__item__id,
        _____GA_Polygon__item__iE_Extensions__item__criticality_tab,
        ____GA_Polygon__item__iE_Extensions__item__criticality,
        _____GA_Polygon__item__iE_Extensions__item__extensionValue_tab,
        ____GA_Polygon__item__iE_Extensions__item__extensionValue,
        ___GA_Polygon__item__iE_Extensions__item_,
        __GA_Polygon__item__iE_Extensions,
        _GA_Polygon__item_,
        GA_Polygon,
        GA_Polygon_ExtIEs,
        _GA_UncertaintyEllipse_uncertaintySemi_major,
        _GA_UncertaintyEllipse_uncertaintySemi_minor,
        _GA_UncertaintyEllipse_orientationOfMajorAxis,
        GA_UncertaintyEllipse,
        GERAN_BSC_Container,
        _GERAN_Cell_ID_lAI,
        _GERAN_Cell_ID_rAC,
        _GERAN_Cell_ID_cI,
        ____GERAN_Cell_ID_iE_Extensions__item__id_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__id,
        ____GERAN_Cell_ID_iE_Extensions__item__criticality_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__criticality,
        ____GERAN_Cell_ID_iE_Extensions__item__extensionValue_tab,
        ___GERAN_Cell_ID_iE_Extensions__item__extensionValue,
        __GERAN_Cell_ID_iE_Extensions__item_,
        _GERAN_Cell_ID_iE_Extensions,
        GERAN_Cell_ID,
        GERAN_Cell_ID_ExtIEs,
        GERAN_Classmark,
        _GlobalCN_ID_pLMNidentity,
        _GlobalCN_ID_cN_ID,
        GlobalCN_ID,
        _GlobalRNC_ID_pLMNidentity,
        _GlobalRNC_ID_rNC_ID,
        GlobalRNC_ID,
        GTP_TEI,
        GuaranteedBitrate,
        HigherBitratesThan16MbpsFlag,
        HS_DSCH_MAC_d_Flow_ID,
        IMEI,
        _IMEIGroup_iMEI,
        _IMEIGroup_iMEIMask,
        ____IMEIGroup_iE_Extensions__item__id_tab,
        ___IMEIGroup_iE_Extensions__item__id,
        ____IMEIGroup_iE_Extensions__item__criticality_tab,
        ___IMEIGroup_iE_Extensions__item__criticality,
        ____IMEIGroup_iE_Extensions__item__extensionValue_tab,
        ___IMEIGroup_iE_Extensions__item__extensionValue,
        __IMEIGroup_iE_Extensions__item_,
        _IMEIGroup_iE_Extensions,
        IMEIGroup,
        IMEIGroup_ExtIEs,
        _IMEIList__item_,
        IMEIList,
        IMEISV,
        _IMEISVGroup_iMEISV,
        _IMEISVGroup_iMEISVMask,
        ____IMEISVGroup_iE_Extensions__item__id_tab,
        ___IMEISVGroup_iE_Extensions__item__id,
        ____IMEISVGroup_iE_Extensions__item__criticality_tab,
        ___IMEISVGroup_iE_Extensions__item__criticality,
        ____IMEISVGroup_iE_Extensions__item__extensionValue_tab,
        ___IMEISVGroup_iE_Extensions__item__extensionValue,
        __IMEISVGroup_iE_Extensions__item_,
        _IMEISVGroup_iE_Extensions,
        IMEISVGroup,
        IMEISVGroup_ExtIEs,
        _IMEISVList__item_,
        IMEISVList,
        _ImmediateMDT_measurementsToActivate,
        _ImmediateMDT_m1report,
        _ImmediateMDT_m2report,
        ____ImmediateMDT_iE_Extensions__item__id_tab,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_0,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_1,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_2,
        _____ImmediateMDT_iE_Extensions__item__id_tab_val_Extension_3,
        ___ImmediateMDT_iE_Extensions__item__id,
        ___ImmediateMDT_iE_Extensions__item__criticality,
        ___ImmediateMDT_iE_Extensions__item__extensionValue,
        __ImmediateMDT_iE_Extensions__item_,
        _ImmediateMDT_iE_Extensions,
        ImmediateMDT,
        ImmediateMDT_ExtIEs,
        _ImmediateMDT_ExtIEs_val_Extension_0,
        _ImmediateMDT_ExtIEs_val_Extension_1,
        _ImmediateMDT_ExtIEs_val_Extension_2,
        _ImmediateMDT_ExtIEs_val_Extension_3,
        IMSI,
        IncludeVelocity,
        InformationExchangeID,
        InformationExchangeType,
        _InformationRequested_requestedMBMSIPMulticastAddressandAPNRequest,
        _InformationRequested_requestedMulticastServiceList,
        InformationRequested,
        _InformationRequestType_mBMSIPMulticastAddressandAPNRequest,
        _InformationRequestType_permanentNAS_UE_ID,
        InformationRequestType,
        InformationTransferID,
        _InformationTransferType_rNCTraceInformation,
        InformationTransferType,
        IntegrityProtectionAlgorithm,
        _IntegrityProtectionInformation_permittedAlgorithms,
        _IntegrityProtectionInformation_key,
        ____IntegrityProtectionInformation_iE_Extensions__item__id_tab,
        ___IntegrityProtectionInformation_iE_Extensions__item__id,
        ____IntegrityProtectionInformation_iE_Extensions__item__criticality_tab,
        ___IntegrityProtectionInformation_iE_Extensions__item__criticality,
        ____IntegrityProtectionInformation_iE_Extensions__item__extensionValue_tab,
        ___IntegrityProtectionInformation_iE_Extensions__item__extensionValue,
        __IntegrityProtectionInformation_iE_Extensions__item_,
        _IntegrityProtectionInformation_iE_Extensions,
        IntegrityProtectionInformation,
        IntegrityProtectionInformation_ExtIEs,
        IntegrityProtectionKey,
        _InterSystemInformationTransferType_rIM_Transfer,
        InterSystemInformationTransferType,
        _InterSystemInformation_TransparentContainer_downlinkCellLoadInformation,
        _InterSystemInformation_TransparentContainer_uplinkCellLoadInformation,
        ____InterSystemInformation_TransparentContainer_iE_Extensions__item__id_tab,
        ___InterSystemInformation_TransparentContainer_iE_Extensions__item__id,
        ____InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality_tab,
        ___InterSystemInformation_TransparentContainer_iE_Extensions__item__criticality,
        ____InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue_tab,
        ___InterSystemInformation_TransparentContainer_iE_Extensions__item__extensionValue,
        __InterSystemInformation_TransparentContainer_iE_Extensions__item_,
        _InterSystemInformation_TransparentContainer_iE_Extensions,
        InterSystemInformation_TransparentContainer,
        InterSystemInformation_TransparentContainer_ExtIEs,
        IPMulticastAddress,
        IuSignallingConnectionIdentifier,
        _IuTransportAssociation_gTP_TEI,
        _IuTransportAssociation_bindingID,
        IuTransportAssociation,
        KeyStatus,
        __LA_LIST__item__lAC,
        __LA_LIST__item__listOF_SNAs,
        _____LA_LIST__item__iE_Extensions__item__id_tab,
        ____LA_LIST__item__iE_Extensions__item__id,
        _____LA_LIST__item__iE_Extensions__item__criticality_tab,
        ____LA_LIST__item__iE_Extensions__item__criticality,
        _____LA_LIST__item__iE_Extensions__item__extensionValue_tab,
        ____LA_LIST__item__iE_Extensions__item__extensionValue,
        ___LA_LIST__item__iE_Extensions__item_,
        __LA_LIST__item__iE_Extensions,
        _LA_LIST__item_,
        LA_LIST,
        LA_LIST_ExtIEs,
        LAC,
        _LAI_pLMNidentity,
        _LAI_lAC,
        ____LAI_iE_Extensions__item__id_tab,
        ___LAI_iE_Extensions__item__id,
        ____LAI_iE_Extensions__item__criticality_tab,
        ___LAI_iE_Extensions__item__criticality,
        ____LAI_iE_Extensions__item__extensionValue_tab,
        ___LAI_iE_Extensions__item__extensionValue,
        __LAI_iE_Extensions__item_,
        _LAI_iE_Extensions,
        LAI,
        LAI_ExtIEs,
        _LastKnownServiceArea_sAI,
        _LastKnownServiceArea_ageOfSAI,
        ____LastKnownServiceArea_iE_Extensions__item__id_tab,
        ___LastKnownServiceArea_iE_Extensions__item__id,
        ____LastKnownServiceArea_iE_Extensions__item__criticality_tab,
        ___LastKnownServiceArea_iE_Extensions__item__criticality,
        ____LastKnownServiceArea_iE_Extensions__item__extensionValue_tab,
        ___LastKnownServiceArea_iE_Extensions__item__extensionValue,
        __LastKnownServiceArea_iE_Extensions__item_,
        _LastKnownServiceArea_iE_Extensions,
        LastKnownServiceArea,
        LastKnownServiceArea_ExtIEs,
        _LastVisitedUTRANCell_Item_uTRAN_CellID,
        _LastVisitedUTRANCell_Item_cellType,
        _LastVisitedUTRANCell_Item_time_UE_StayedInCell,
        ____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab,
        _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_0,
        _____LastVisitedUTRANCell_Item_iE_Extensions__item__id_tab_val_Extension_1,
        ___LastVisitedUTRANCell_Item_iE_Extensions__item__id,
        ___LastVisitedUTRANCell_Item_iE_Extensions__item__criticality,
        ___LastVisitedUTRANCell_Item_iE_Extensions__item__extensionValue,
        __LastVisitedUTRANCell_Item_iE_Extensions__item_,
        _LastVisitedUTRANCell_Item_iE_Extensions,
        LastVisitedUTRANCell_Item,
        LastVisitedUTRANCell_Item_ExtIEs,
        _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_0,
        _LastVisitedUTRANCell_Item_ExtIEs_val_Extension_1,
        LHN_ID,
        Links_to_log,
        _ListOF_SNAs__item_,
        ListOF_SNAs,
        _ListOfInterfacesToTrace__item_,
        ListOfInterfacesToTrace,
        _InterfacesToTraceItem_interface,
        ____InterfacesToTraceItem_iE_Extensions__item__id_tab,
        ___InterfacesToTraceItem_iE_Extensions__item__id,
        ____InterfacesToTraceItem_iE_Extensions__item__criticality_tab,
        ___InterfacesToTraceItem_iE_Extensions__item__criticality,
        ____InterfacesToTraceItem_iE_Extensions__item__extensionValue_tab,
        ___InterfacesToTraceItem_iE_Extensions__item__extensionValue,
        __InterfacesToTraceItem_iE_Extensions__item_,
        _InterfacesToTraceItem_iE_Extensions,
        InterfacesToTraceItem,
        InterfacesToTraceItem_ExtIEs,
        LoadValue,
        _LocationRelatedDataRequestType_requestedLocationRelatedDataType,
        _LocationRelatedDataRequestType_requestedGPSAssistanceData,
        LocationRelatedDataRequestType,
        LocationRelatedDataRequestTypeSpecificToGERANIuMode,
        _LocationReportingTransferInformation_reportChangeOfSAI,
        _LocationReportingTransferInformation_periodicReportingIndicator,
        _LocationReportingTransferInformation_directReportingIndicator,
        _LocationReportingTransferInformation_verticalAccuracyCode,
        _LocationReportingTransferInformation_positioningPriorityChangeSAI,
        _LocationReportingTransferInformation_positioningPriorityDirect,
        _LocationReportingTransferInformation_clientTypePeriodic,
        _LocationReportingTransferInformation_clientTypeDirect,
        _LocationReportingTransferInformation_responseTime,
        _LocationReportingTransferInformation_includeVelocity,
        _LocationReportingTransferInformation_periodicLocationInfo,
        ____LocationReportingTransferInformation_iE_Extensions__item__id_tab,
        ___LocationReportingTransferInformation_iE_Extensions__item__id,
        ____LocationReportingTransferInformation_iE_Extensions__item__criticality_tab,
        ___LocationReportingTransferInformation_iE_Extensions__item__criticality,
        ____LocationReportingTransferInformation_iE_Extensions__item__extensionValue_tab,
        ___LocationReportingTransferInformation_iE_Extensions__item__extensionValue,
        __LocationReportingTransferInformation_iE_Extensions__item_,
        _LocationReportingTransferInformation_iE_Extensions,
        LocationReportingTransferInformation,
        LocationReportingTransferInformation_ExtIEs,
        ReportChangeOfSAI,
        PeriodicReportingIndicator,
        DirectReportingIndicator,
        L3_Information,
        _M1Report_periodic,
        _M1Report_event1F,
        M1Report,
        _M2Report_periodic,
        _M2Report_event1I,
        M2Report,
        _M4Report_all,
        _M4Report_m4_collection_parameters,
        M4Report,
        _M4_Collection_Parameters_m4_period,
        _M4_Collection_Parameters_m4_threshold,
        ____M4_Collection_Parameters_iE_Extensions__item__id_tab,
        ___M4_Collection_Parameters_iE_Extensions__item__id,
        ____M4_Collection_Parameters_iE_Extensions__item__criticality_tab,
        ___M4_Collection_Parameters_iE_Extensions__item__criticality,
        ____M4_Collection_Parameters_iE_Extensions__item__extensionValue_tab,
        ___M4_Collection_Parameters_iE_Extensions__item__extensionValue,
        __M4_Collection_Parameters_iE_Extensions__item_,
        _M4_Collection_Parameters_iE_Extensions,
        M4_Collection_Parameters,
        M4_Collection_Parameters_ExtIEs,
        M4_Period,
        M4_Threshold,
        _M5Report_when_available,
        _M5Report_m5_period,
        M5Report,
        M5_Period,
        _M6Report_m6_period,
        _M6Report_m6_links_to_log,
        ____M6Report_iE_Extensions__item__id_tab,
        ___M6Report_iE_Extensions__item__id,
        ____M6Report_iE_Extensions__item__criticality_tab,
        ___M6Report_iE_Extensions__item__criticality,
        ____M6Report_iE_Extensions__item__extensionValue_tab,
        ___M6Report_iE_Extensions__item__extensionValue,
        __M6Report_iE_Extensions__item_,
        _M6Report_iE_Extensions,
        M6Report,
        M6Report_ExtIEs,
        M6_Period,
        _M7Report_m7_period,
        _M7Report_m7_links_to_log,
        ____M7Report_iE_Extensions__item__id_tab,
        ___M7Report_iE_Extensions__item__id,
        ____M7Report_iE_Extensions__item__criticality_tab,
        ___M7Report_iE_Extensions__item__criticality,
        ____M7Report_iE_Extensions__item__extensionValue_tab,
        ___M7Report_iE_Extensions__item__extensionValue,
        __M7Report_iE_Extensions__item_,
        _M7Report_iE_Extensions,
        M7Report,
        M7Report_ExtIEs,
        M7_Period,
        Management_Based_MDT_Allowed,
        MaxBitrate,
        MaxSDU_Size,
        MBMS_PTP_RAB_ID,
        MBMSBearerServiceType,
        MBMSCNDe_Registration,
        MBMSCountingInformation,
        MBMSHCIndicator,
        _MBMSIPMulticastAddressandAPNRequest__item_,
        MBMSIPMulticastAddressandAPNRequest,
        MBMSLinkingInformation,
        MBMSRegistrationRequestType,
        MBMSServiceArea,
        MBMSSessionDuration,
        MBMSSessionIdentity,
        MBMSSessionRepetitionNumber,
        MDT_Activation,
        _MDTAreaScope_cellbased,
        _MDTAreaScope_labased,
        _MDTAreaScope_rabased,
        _MDTAreaScope_plmn_area_based,
        MDTAreaScope,
        _MDT_Configuration_mdtActivation,
        _MDT_Configuration_mdtAreaScope,
        _MDT_Configuration_mdtMode,
        ____MDT_Configuration_iE_Extensions__item__id_tab,
        _____MDT_Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        ___MDT_Configuration_iE_Extensions__item__id,
        ___MDT_Configuration_iE_Extensions__item__criticality,
        ___MDT_Configuration_iE_Extensions__item__extensionValue,
        __MDT_Configuration_iE_Extensions__item_,
        _MDT_Configuration_iE_Extensions,
        MDT_Configuration,
        MDT_Configuration_ExtIEs,
        _MDT_Configuration_ExtIEs_val_Extension_0,
        _MDTMode_immediateMDT,
        _MDTMode_loggedMDT,
        MDTMode,
        _MDT_PLMN_List__item_,
        MDT_PLMN_List,
        _MDT_Report_Parameters_reportInterval,
        _MDT_Report_Parameters_reportAmount,
        MDT_Report_Parameters,
        MeasurementQuantity,
        MeasurementsToActivate,
        MSISDN,
        NAS_PDU,
        NAS_SequenceNumber,
        NAS_SynchronisationIndicator,
        NewBSS_To_OldBSS_Information,
        NonSearchingIndication,
        NRTLoadInformationValue,
        Null_NRI,
        NumberOfIuInstances,
        NumberOfSteps,
        _Offload_RAB_Parameters_accessPointName,
        _Offload_RAB_Parameters_chargingCharacteristics,
        ____Offload_RAB_Parameters_iE_Extensions__item__id_tab,
        ___Offload_RAB_Parameters_iE_Extensions__item__id,
        ____Offload_RAB_Parameters_iE_Extensions__item__criticality_tab,
        ___Offload_RAB_Parameters_iE_Extensions__item__criticality,
        ____Offload_RAB_Parameters_iE_Extensions__item__extensionValue_tab,
        ___Offload_RAB_Parameters_iE_Extensions__item__extensionValue,
        __Offload_RAB_Parameters_iE_Extensions__item_,
        _Offload_RAB_Parameters_iE_Extensions,
        Offload_RAB_Parameters,
        Offload_RAB_Parameters_ExtIEs,
        Offload_RAB_Parameters_APN,
        Offload_RAB_Parameters_ChargingCharacteristics,
        OldBSS_ToNewBSS_Information,
        OMC_ID,
        Out_Of_UTRAN,
        _PagingAreaID_lAI,
        _PagingAreaID_rAI,
        PagingAreaID,
        PagingCause,
        _PDP_TypeInformation__item_,
        PDP_TypeInformation,
        PDP_Type,
        _PDP_TypeInformation_extension__item_,
        PDP_TypeInformation_extension,
        PDP_Type_extension,
        PDUType14FrameSequenceNumber,
        _PeriodicLocationInfo_reportingAmount,
        _PeriodicLocationInfo_reportingInterval,
        ____PeriodicLocationInfo_iE_Extensions__item__id_tab,
        ___PeriodicLocationInfo_iE_Extensions__item__id,
        ____PeriodicLocationInfo_iE_Extensions__item__criticality_tab,
        ___PeriodicLocationInfo_iE_Extensions__item__criticality,
        ____PeriodicLocationInfo_iE_Extensions__item__extensionValue_tab,
        ___PeriodicLocationInfo_iE_Extensions__item__extensionValue,
        __PeriodicLocationInfo_iE_Extensions__item_,
        _PeriodicLocationInfo_iE_Extensions,
        PeriodicLocationInfo,
        PeriodicLocationInfo_ExtIEs,
        _PermanentNAS_UE_ID_iMSI,
        PermanentNAS_UE_ID,
        _PermittedEncryptionAlgorithms__item_,
        PermittedEncryptionAlgorithms,
        _PermittedIntegrityProtectionAlgorithms__item_,
        PermittedIntegrityProtectionAlgorithms,
        _LABased_laiList,
        ____LABased_iE_Extensions__item__id_tab,
        ___LABased_iE_Extensions__item__id,
        ____LABased_iE_Extensions__item__criticality_tab,
        ___LABased_iE_Extensions__item__criticality,
        ____LABased_iE_Extensions__item__extensionValue_tab,
        ___LABased_iE_Extensions__item__extensionValue,
        __LABased_iE_Extensions__item_,
        _LABased_iE_Extensions,
        LABased,
        LABased_ExtIEs,
        _LAI_List__item_,
        LAI_List,
        _LoggedMDT_loggingInterval,
        _LoggedMDT_loggingDuration,
        ____LoggedMDT_iE_Extensions__item__id_tab,
        ___LoggedMDT_iE_Extensions__item__id,
        ____LoggedMDT_iE_Extensions__item__criticality_tab,
        ___LoggedMDT_iE_Extensions__item__criticality,
        ____LoggedMDT_iE_Extensions__item__extensionValue_tab,
        ___LoggedMDT_iE_Extensions__item__extensionValue,
        __LoggedMDT_iE_Extensions__item_,
        _LoggedMDT_iE_Extensions,
        LoggedMDT,
        LoggedMDT_ExtIEs,
        LoggingInterval,
        LoggingDuration,
        _PLMNBased_plmnList,
        ____PLMNBased_iE_Extensions__item__id_tab,
        ___PLMNBased_iE_Extensions__item__id,
        ____PLMNBased_iE_Extensions__item__criticality_tab,
        ___PLMNBased_iE_Extensions__item__criticality,
        ____PLMNBased_iE_Extensions__item__extensionValue_tab,
        ___PLMNBased_iE_Extensions__item__extensionValue,
        __PLMNBased_iE_Extensions__item_,
        _PLMNBased_iE_Extensions,
        PLMNBased,
        PLMNBased_ExtIEs,
        _PLMNList__item_,
        PLMNList,
        PLMNidentity,
        __PLMNs_in_shared_network__item__pLMNidentity,
        __PLMNs_in_shared_network__item__lA_LIST,
        _____PLMNs_in_shared_network__item__iE_Extensions__item__id_tab,
        ____PLMNs_in_shared_network__item__iE_Extensions__item__id,
        _____PLMNs_in_shared_network__item__iE_Extensions__item__criticality_tab,
        ____PLMNs_in_shared_network__item__iE_Extensions__item__criticality,
        _____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue_tab,
        ____PLMNs_in_shared_network__item__iE_Extensions__item__extensionValue,
        ___PLMNs_in_shared_network__item__iE_Extensions__item_,
        __PLMNs_in_shared_network__item__iE_Extensions,
        _PLMNs_in_shared_network__item_,
        PLMNs_in_shared_network,
        PLMNs_in_shared_network_ExtIEs,
        Port_Number,
        PositioningDataDiscriminator,
        _PositioningDataSet__item_,
        PositioningDataSet,
        PositioningMethodAndUsage,
        PositioningPriority,
        _PositionData_positioningDataDiscriminator,
        _PositionData_positioningDataSet,
        ____PositionData_iE_Extensions__item__id_tab,
        _____PositionData_iE_Extensions__item__id_tab_val_Extension_0,
        _____PositionData_iE_Extensions__item__id_tab_val_Extension_1,
        ___PositionData_iE_Extensions__item__id,
        ___PositionData_iE_Extensions__item__criticality,
        ___PositionData_iE_Extensions__item__extensionValue,
        __PositionData_iE_Extensions__item_,
        _PositionData_iE_Extensions,
        PositionData,
        PositionData_ExtIEs,
        _PositionData_ExtIEs_val_Extension_0,
        _PositionData_ExtIEs_val_Extension_1,
        PositionDataSpecificToGERANIuMode,
        Pre_emptionCapability,
        Pre_emptionVulnerability,
        PriorityLevel,
        Priority_Class_Indicator,
        _ProvidedData_shared_network_information,
        ProvidedData,
        PowerSavingIndicator,
        P_TMSI,
        QueuingAllowed,
        RAB_AsymmetryIndicator,
        _RABased_raiList,
        ____RABased_iE_Extensions__item__id_tab,
        ___RABased_iE_Extensions__item__id,
        ____RABased_iE_Extensions__item__criticality_tab,
        ___RABased_iE_Extensions__item__criticality,
        ____RABased_iE_Extensions__item__extensionValue_tab,
        ___RABased_iE_Extensions__item__extensionValue,
        __RABased_iE_Extensions__item_,
        _RABased_iE_Extensions,
        RABased,
        RABased_ExtIEs,
        _RAI_List__item_,
        RAI_List,
        __RABDataVolumeReport__item__dl_UnsuccessfullyTransmittedDataVolume,
        __RABDataVolumeReport__item__dataVolumeReference,
        _____RABDataVolumeReport__item__iE_Extensions__item__id_tab,
        ____RABDataVolumeReport__item__iE_Extensions__item__id,
        _____RABDataVolumeReport__item__iE_Extensions__item__criticality_tab,
        ____RABDataVolumeReport__item__iE_Extensions__item__criticality,
        _____RABDataVolumeReport__item__iE_Extensions__item__extensionValue_tab,
        ____RABDataVolumeReport__item__iE_Extensions__item__extensionValue,
        ___RABDataVolumeReport__item__iE_Extensions__item_,
        __RABDataVolumeReport__item__iE_Extensions,
        _RABDataVolumeReport__item_,
        RABDataVolumeReport,
        RABDataVolumeReport_ExtIEs,
        RAB_ID,
        _RAB_Parameter_ExtendedGuaranteedBitrateList__item_,
        RAB_Parameter_ExtendedGuaranteedBitrateList,
        _RAB_Parameter_ExtendedMaxBitrateList__item_,
        RAB_Parameter_ExtendedMaxBitrateList,
        _RAB_Parameter_GuaranteedBitrateList__item_,
        RAB_Parameter_GuaranteedBitrateList,
        _RAB_Parameter_MaxBitrateList__item_,
        RAB_Parameter_MaxBitrateList,
        _RAB_Parameters_trafficClass,
        _RAB_Parameters_rAB_AsymmetryIndicator,
        _RAB_Parameters_maxBitrate,
        _RAB_Parameters_guaranteedBitRate,
        _RAB_Parameters_deliveryOrder,
        _RAB_Parameters_maxSDU_Size,
        _RAB_Parameters_sDU_Parameters,
        _RAB_Parameters_transferDelay,
        _RAB_Parameters_trafficHandlingPriority,
        _RAB_Parameters_allocationOrRetentionPriority,
        _RAB_Parameters_sourceStatisticsDescriptor,
        _RAB_Parameters_relocationRequirement,
        ____RAB_Parameters_iE_Extensions__item__id_tab,
        _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_1,
        _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_2,
        _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_3,
        _____RAB_Parameters_iE_Extensions__item__id_tab_val_Extension_4,
        ___RAB_Parameters_iE_Extensions__item__id,
        ___RAB_Parameters_iE_Extensions__item__criticality,
        ___RAB_Parameters_iE_Extensions__item__extensionValue,
        __RAB_Parameters_iE_Extensions__item_,
        _RAB_Parameters_iE_Extensions,
        RAB_Parameters,
        RAB_Parameters_ExtIEs,
        _RAB_Parameters_ExtIEs_val_Extension_0,
        _RAB_Parameters_ExtIEs_val_Extension_1,
        _RAB_Parameters_ExtIEs_val_Extension_2,
        _RAB_Parameters_ExtIEs_val_Extension_3,
        _RAB_Parameters_ExtIEs_val_Extension_4,
        __RABParametersList__item__rab_Id,
        __RABParametersList__item__cn_domain,
        __RABParametersList__item__rabDataVolumeReport,
        __RABParametersList__item__upInformation,
        _____RABParametersList__item__iE_Extensions__item__id_tab,
        ____RABParametersList__item__iE_Extensions__item__id,
        _____RABParametersList__item__iE_Extensions__item__criticality_tab,
        ____RABParametersList__item__iE_Extensions__item__criticality,
        _____RABParametersList__item__iE_Extensions__item__extensionValue_tab,
        ____RABParametersList__item__iE_Extensions__item__extensionValue,
        ___RABParametersList__item__iE_Extensions__item_,
        __RABParametersList__item__iE_Extensions,
        _RABParametersList__item_,
        RABParametersList,
        RABParametersList_ExtIEs,
        RAB_SubflowCombinationBitRate,
        _RAB_TrCH_Mapping__item_,
        RAB_TrCH_Mapping,
        _RAB_TrCH_MappingItem_rAB_ID,
        _RAB_TrCH_MappingItem_trCH_ID_List,
        ____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab,
        _____RAB_TrCH_MappingItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___RAB_TrCH_MappingItem_iE_Extensions__item__id,
        ___RAB_TrCH_MappingItem_iE_Extensions__item__criticality,
        ___RAB_TrCH_MappingItem_iE_Extensions__item__extensionValue,
        __RAB_TrCH_MappingItem_iE_Extensions__item_,
        _RAB_TrCH_MappingItem_iE_Extensions,
        RAB_TrCH_MappingItem,
        RAB_TrCH_MappingItem_ExtIEs,
        _RAB_TrCH_MappingItem_ExtIEs_val_Extension_0,
        RAC,
        _RAI_lAI,
        _RAI_rAC,
        ____RAI_iE_Extensions__item__id_tab,
        ___RAI_iE_Extensions__item__id,
        ____RAI_iE_Extensions__item__criticality_tab,
        ___RAI_iE_Extensions__item__criticality,
        ____RAI_iE_Extensions__item__extensionValue_tab,
        ___RAI_iE_Extensions__item__extensionValue,
        __RAI_iE_Extensions__item_,
        _RAI_iE_Extensions,
        RAI,
        RAI_ExtIEs,
        _RAListofIdleModeUEs_notEmptyRAListofIdleModeUEs,
        _RAListofIdleModeUEs_emptyFullRAListofIdleModeUEs,
        RAListofIdleModeUEs,
        _NotEmptyRAListofIdleModeUEs_rAofIdleModeUEs,
        ____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab,
        _____NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id_tab_val_Extension_0,
        ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__id,
        ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__criticality,
        ___NotEmptyRAListofIdleModeUEs_iE_Extensions__item__extensionValue,
        __NotEmptyRAListofIdleModeUEs_iE_Extensions__item_,
        _NotEmptyRAListofIdleModeUEs_iE_Extensions,
        NotEmptyRAListofIdleModeUEs,
        _RAofIdleModeUEs__item_,
        RAofIdleModeUEs,
        NotEmptyRAListofIdleModeUEs_ExtIEs,
        _NotEmptyRAListofIdleModeUEs_ExtIEs_val_Extension_0,
        _LAListofIdleModeUEs__item_,
        LAListofIdleModeUEs,
        RAT_Type,
        RateControlAllowed,
        RedirectAttemptFlag,
        RedirectionCompleted,
        RejectCauseValue,
        RelocationRequirement,
        RelocationType,
        RepetitionNumber0,
        RepetitionNumber1,
        ReportArea,
        ReportInterval,
        ReportAmount,
        RequestedGPSAssistanceData,
        RequestedGANSSAssistanceData,
        RequestedLocationRelatedDataType,
        _RequestedMBMSIPMulticastAddressandAPNRequest__item_,
        RequestedMBMSIPMulticastAddressandAPNRequest,
        _MBMSIPMulticastAddressandAPNlist_tMGI,
        _MBMSIPMulticastAddressandAPNlist_iPMulticastAddress,
        _MBMSIPMulticastAddressandAPNlist_aPN,
        ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id_tab,
        ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__id,
        ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality_tab,
        ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__criticality,
        ____MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue_tab,
        ___MBMSIPMulticastAddressandAPNlist_iE_Extensions__item__extensionValue,
        __MBMSIPMulticastAddressandAPNlist_iE_Extensions__item_,
        _MBMSIPMulticastAddressandAPNlist_iE_Extensions,
        MBMSIPMulticastAddressandAPNlist,
        MBMSIPMulticastAddressandAPNlist_ExtIEs,
        _RequestedMulticastServiceList__item_,
        RequestedMulticastServiceList,
        _Requested_RAB_Parameter_Values_requestedMaxBitrates,
        _Requested_RAB_Parameter_Values_requestedGuaranteedBitrates,
        ____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab,
        _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_0,
        _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_1,
        _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_2,
        _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_3,
        _____Requested_RAB_Parameter_Values_iE_Extensions__item__id_tab_val_Extension_4,
        ___Requested_RAB_Parameter_Values_iE_Extensions__item__id,
        ___Requested_RAB_Parameter_Values_iE_Extensions__item__criticality,
        ___Requested_RAB_Parameter_Values_iE_Extensions__item__extensionValue,
        __Requested_RAB_Parameter_Values_iE_Extensions__item_,
        _Requested_RAB_Parameter_Values_iE_Extensions,
        Requested_RAB_Parameter_Values,
        Requested_RAB_Parameter_Values_ExtIEs,
        _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_0,
        _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_1,
        _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_2,
        _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_3,
        _Requested_RAB_Parameter_Values_ExtIEs_val_Extension_4,
        _Requested_RAB_Parameter_ExtendedMaxBitrateList__item_,
        Requested_RAB_Parameter_ExtendedMaxBitrateList,
        _Requested_RAB_Parameter_ExtendedGuaranteedBitrateList__item_,
        Requested_RAB_Parameter_ExtendedGuaranteedBitrateList,
        _Requested_RAB_Parameter_MaxBitrateList__item_,
        Requested_RAB_Parameter_MaxBitrateList,
        _Requested_RAB_Parameter_GuaranteedBitrateList__item_,
        Requested_RAB_Parameter_GuaranteedBitrateList,
        _RequestType_event,
        _RequestType_reportArea,
        _RequestType_accuracyCode,
        RequestType,
        _ResidualBitErrorRatio_mantissa,
        _ResidualBitErrorRatio_exponent,
        ____ResidualBitErrorRatio_iE_Extensions__item__id_tab,
        ___ResidualBitErrorRatio_iE_Extensions__item__id,
        ____ResidualBitErrorRatio_iE_Extensions__item__criticality_tab,
        ___ResidualBitErrorRatio_iE_Extensions__item__criticality,
        ____ResidualBitErrorRatio_iE_Extensions__item__extensionValue_tab,
        ___ResidualBitErrorRatio_iE_Extensions__item__extensionValue,
        __ResidualBitErrorRatio_iE_Extensions__item_,
        _ResidualBitErrorRatio_iE_Extensions,
        ResidualBitErrorRatio,
        ResidualBitErrorRatio_ExtIEs,
        ResponseTime,
        RIMInformation,
        _RIM_Transfer_rIMInformation,
        _RIM_Transfer_rIMRoutingAddress,
        ____RIM_Transfer_iE_Extensions__item__id_tab,
        ___RIM_Transfer_iE_Extensions__item__id,
        ____RIM_Transfer_iE_Extensions__item__criticality_tab,
        ___RIM_Transfer_iE_Extensions__item__criticality,
        ____RIM_Transfer_iE_Extensions__item__extensionValue_tab,
        ___RIM_Transfer_iE_Extensions__item__extensionValue,
        __RIM_Transfer_iE_Extensions__item_,
        _RIM_Transfer_iE_Extensions,
        RIM_Transfer,
        RIM_Transfer_ExtIEs,
        _RIMRoutingAddress_targetRNC_ID,
        _RIMRoutingAddress_gERAN_Cell_ID,
        _RIMRoutingAddress_targeteNB_ID,
        RIMRoutingAddress,
        RNC_ID,
        _RNCTraceInformation_traceReference,
        _RNCTraceInformation_traceActivationIndicator,
        _RNCTraceInformation_equipmentsToBeTraced,
        ____RNCTraceInformation_iE_Extensions__item__id_tab,
        _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_0,
        _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_1,
        _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_2,
        _____RNCTraceInformation_iE_Extensions__item__id_tab_val_Extension_3,
        ___RNCTraceInformation_iE_Extensions__item__id,
        ___RNCTraceInformation_iE_Extensions__item__criticality,
        ___RNCTraceInformation_iE_Extensions__item__extensionValue,
        __RNCTraceInformation_iE_Extensions__item_,
        _RNCTraceInformation_iE_Extensions,
        RNCTraceInformation,
        RNCTraceInformation_ExtIEs,
        _RNCTraceInformation_ExtIEs_val_Extension_0,
        _RNCTraceInformation_ExtIEs_val_Extension_1,
        _RNCTraceInformation_ExtIEs_val_Extension_2,
        _RNCTraceInformation_ExtIEs_val_Extension_3,
        _RNSAPRelocationParameters_rabParmetersList,
        _RNSAPRelocationParameters_locationReporting,
        _RNSAPRelocationParameters_traceInformation,
        _RNSAPRelocationParameters_sourceSAI,
        ____RNSAPRelocationParameters_iE_Extensions__item__id_tab,
        ___RNSAPRelocationParameters_iE_Extensions__item__id,
        ____RNSAPRelocationParameters_iE_Extensions__item__criticality_tab,
        ___RNSAPRelocationParameters_iE_Extensions__item__criticality,
        ____RNSAPRelocationParameters_iE_Extensions__item__extensionValue_tab,
        ___RNSAPRelocationParameters_iE_Extensions__item__extensionValue,
        __RNSAPRelocationParameters_iE_Extensions__item_,
        _RNSAPRelocationParameters_iE_Extensions,
        RNSAPRelocationParameters,
        RNSAPRelocationParameters_ExtIEs,
        RRC_Container,
        RTLoadValue,
        RSRVCC_HO_Indication,
        _RSRVCC_Information_nonce,
        _RSRVCC_Information_iMSInformation,
        ____RSRVCC_Information_iE_Extensions__item__id_tab,
        ___RSRVCC_Information_iE_Extensions__item__id,
        ____RSRVCC_Information_iE_Extensions__item__criticality_tab,
        ___RSRVCC_Information_iE_Extensions__item__criticality,
        ____RSRVCC_Information_iE_Extensions__item__extensionValue_tab,
        ___RSRVCC_Information_iE_Extensions__item__extensionValue,
        __RSRVCC_Information_iE_Extensions__item_,
        _RSRVCC_Information_iE_Extensions,
        RSRVCC_Information,
        RSRVCC_Information_ExtIEs,
        RSRVCC_Operation_Possible,
        SAC,
        _SAI_pLMNidentity,
        _SAI_lAC,
        _SAI_sAC,
        ____SAI_iE_Extensions__item__id_tab,
        ___SAI_iE_Extensions__item__id,
        ____SAI_iE_Extensions__item__criticality_tab,
        ___SAI_iE_Extensions__item__criticality,
        ____SAI_iE_Extensions__item__extensionValue_tab,
        ___SAI_iE_Extensions__item__extensionValue,
        __SAI_iE_Extensions__item_,
        _SAI_iE_Extensions,
        SAI,
        SAI_ExtIEs,
        SAPI,
        SessionUpdateID,
        _Shared_Network_Information_pLMNs_in_shared_network,
        ____Shared_Network_Information_iE_Extensions__item__id_tab,
        ___Shared_Network_Information_iE_Extensions__item__id,
        ____Shared_Network_Information_iE_Extensions__item__criticality_tab,
        ___Shared_Network_Information_iE_Extensions__item__criticality,
        ____Shared_Network_Information_iE_Extensions__item__extensionValue_tab,
        ___Shared_Network_Information_iE_Extensions__item__extensionValue,
        __Shared_Network_Information_iE_Extensions__item_,
        _Shared_Network_Information_iE_Extensions,
        Shared_Network_Information,
        Session_Re_establishment_Indicator,
        Shared_Network_Information_ExtIEs,
        SignallingIndication,
        _SDU_ErrorRatio_mantissa,
        _SDU_ErrorRatio_exponent,
        ____SDU_ErrorRatio_iE_Extensions__item__id_tab,
        ___SDU_ErrorRatio_iE_Extensions__item__id,
        ____SDU_ErrorRatio_iE_Extensions__item__criticality_tab,
        ___SDU_ErrorRatio_iE_Extensions__item__criticality,
        ____SDU_ErrorRatio_iE_Extensions__item__extensionValue_tab,
        ___SDU_ErrorRatio_iE_Extensions__item__extensionValue,
        __SDU_ErrorRatio_iE_Extensions__item_,
        _SDU_ErrorRatio_iE_Extensions,
        SDU_ErrorRatio,
        SDU_ErrorRatio_ExtIEs,
        __SDU_FormatInformationParameters__item__subflowSDU_Size,
        __SDU_FormatInformationParameters__item__rAB_SubflowCombinationBitRate,
        _____SDU_FormatInformationParameters__item__iE_Extensions__item__id_tab,
        ____SDU_FormatInformationParameters__item__iE_Extensions__item__id,
        _____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality_tab,
        ____SDU_FormatInformationParameters__item__iE_Extensions__item__criticality,
        _____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue_tab,
        ____SDU_FormatInformationParameters__item__iE_Extensions__item__extensionValue,
        ___SDU_FormatInformationParameters__item__iE_Extensions__item_,
        __SDU_FormatInformationParameters__item__iE_Extensions,
        _SDU_FormatInformationParameters__item_,
        SDU_FormatInformationParameters,
        SDU_FormatInformationParameters_ExtIEs,
        __SDU_Parameters__item__sDU_ErrorRatio,
        __SDU_Parameters__item__residualBitErrorRatio,
        __SDU_Parameters__item__deliveryOfErroneousSDU,
        __SDU_Parameters__item__sDU_FormatInformationParameters,
        _____SDU_Parameters__item__iE_Extensions__item__id_tab,
        ____SDU_Parameters__item__iE_Extensions__item__id,
        _____SDU_Parameters__item__iE_Extensions__item__criticality_tab,
        ____SDU_Parameters__item__iE_Extensions__item__criticality,
        _____SDU_Parameters__item__iE_Extensions__item__extensionValue_tab,
        ____SDU_Parameters__item__iE_Extensions__item__extensionValue,
        ___SDU_Parameters__item__iE_Extensions__item_,
        __SDU_Parameters__item__iE_Extensions,
        _SDU_Parameters__item_,
        SDU_Parameters,
        SDU_Parameters_ExtIEs,
        _SGSN_Group_Identity_null_NRI,
        _SGSN_Group_Identity_sGSN_Group_ID,
        SGSN_Group_Identity,
        SGSN_Group_ID,
        _SNA_Access_Information_authorisedPLMNs,
        ____SNA_Access_Information_iE_Extensions__item__id_tab,
        ___SNA_Access_Information_iE_Extensions__item__id,
        ____SNA_Access_Information_iE_Extensions__item__criticality_tab,
        ___SNA_Access_Information_iE_Extensions__item__criticality,
        ____SNA_Access_Information_iE_Extensions__item__extensionValue_tab,
        ___SNA_Access_Information_iE_Extensions__item__extensionValue,
        __SNA_Access_Information_iE_Extensions__item_,
        _SNA_Access_Information_iE_Extensions,
        SNA_Access_Information,
        SNA_Access_Information_ExtIEs,
        SNAC,
        Service_Handover,
        Source_ToTarget_TransparentContainer,
        SourceeNodeB_ToTargeteNodeB_TransparentContainer,
        _SourceCellID_sourceUTRANCellID,
        _SourceCellID_sourceGERANCellID,
        SourceCellID,
        SourceBSS_ToTargetBSS_TransparentContainer,
        _SourceID_sourceRNC_ID,
        _SourceID_sAI,
        SourceID,
        _SourceRNC_ID_pLMNidentity,
        _SourceRNC_ID_rNC_ID,
        ____SourceRNC_ID_iE_Extensions__item__id_tab,
        _____SourceRNC_ID_iE_Extensions__item__id_tab_val_Extension_0,
        ___SourceRNC_ID_iE_Extensions__item__id,
        ___SourceRNC_ID_iE_Extensions__item__criticality,
        ___SourceRNC_ID_iE_Extensions__item__extensionValue,
        __SourceRNC_ID_iE_Extensions__item_,
        _SourceRNC_ID_iE_Extensions,
        SourceRNC_ID,
        SourceRNC_ID_ExtIEs,
        _SourceRNC_ID_ExtIEs_val_Extension_0,
        _SourceRNC_ToTargetRNC_TransparentContainer_rRC_Container,
        _SourceRNC_ToTargetRNC_TransparentContainer_numberOfIuInstances,
        _SourceRNC_ToTargetRNC_TransparentContainer_relocationType,
        _SourceRNC_ToTargetRNC_TransparentContainer_chosenIntegrityProtectionAlgorithm,
        _SourceRNC_ToTargetRNC_TransparentContainer_integrityProtectionKey,
        _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForSignalling,
        _SourceRNC_ToTargetRNC_TransparentContainer_cipheringKey,
        _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForCS,
        _SourceRNC_ToTargetRNC_TransparentContainer_chosenEncryptionAlgorithForPS,
        _SourceRNC_ToTargetRNC_TransparentContainer_d_RNTI,
        _SourceRNC_ToTargetRNC_TransparentContainer_targetCellId,
        _SourceRNC_ToTargetRNC_TransparentContainer_rAB_TrCH_Mapping,
        ____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_1,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_2,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_3,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_4,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_5,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_6,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_7,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_8,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_9,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_10,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_11,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_12,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_13,
        _____SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_14,
        ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__id,
        ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__criticality,
        ___SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item__extensionValue,
        __SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions__item_,
        _SourceRNC_ToTargetRNC_TransparentContainer_iE_Extensions,
        SourceRNC_ToTargetRNC_TransparentContainer,
        SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_0,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_1,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_2,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_3,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_4,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_5,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_6,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_7,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_8,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_9,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_10,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_11,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_12,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_13,
        _SourceRNC_ToTargetRNC_TransparentContainer_ExtIEs_val_Extension_14,
        SRVCCSource,
        _IRAT_Measurement_Configuration_rSRP,
        _IRAT_Measurement_Configuration_rSRQ,
        _IRAT_Measurement_Configuration_iRATmeasurementParameters,
        ____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab,
        _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_0,
        _____IRAT_Measurement_Configuration_iE_Extensions__item__id_tab_val_Extension_1,
        ___IRAT_Measurement_Configuration_iE_Extensions__item__id,
        ___IRAT_Measurement_Configuration_iE_Extensions__item__criticality,
        ___IRAT_Measurement_Configuration_iE_Extensions__item__extensionValue,
        __IRAT_Measurement_Configuration_iE_Extensions__item_,
        _IRAT_Measurement_Configuration_iE_Extensions,
        IRAT_Measurement_Configuration,
        IRAT_Measurement_Configuration_ExtIEs,
        _IRAT_Measurement_Configuration_ExtIEs_val_Extension_0,
        _IRAT_Measurement_Configuration_ExtIEs_val_Extension_1,
        _IRATmeasurementParameters_measurementDuration,
        _IRATmeasurementParameters_eUTRANFrequencies,
        ____IRATmeasurementParameters_iE_Extensions__item__id_tab,
        ___IRATmeasurementParameters_iE_Extensions__item__id,
        ____IRATmeasurementParameters_iE_Extensions__item__criticality_tab,
        ___IRATmeasurementParameters_iE_Extensions__item__criticality,
        ____IRATmeasurementParameters_iE_Extensions__item__extensionValue_tab,
        ___IRATmeasurementParameters_iE_Extensions__item__extensionValue,
        __IRATmeasurementParameters_iE_Extensions__item_,
        _IRATmeasurementParameters_iE_Extensions,
        IRATmeasurementParameters,
        IRATmeasurementParameters_ExtIEs,
        _RSRQ_Type_allSymbols,
        _RSRQ_Type_wideBand,
        RSRQ_Type,
        RSRQ_Extension,
        __EUTRANFrequencies__item__earfcn,
        __EUTRANFrequencies__item__measBand,
        _____EUTRANFrequencies__item__iE_Extensions__item__id_tab,
        ______EUTRANFrequencies__item__iE_Extensions__item__id_tab_val_Extension_0,
        ____EUTRANFrequencies__item__iE_Extensions__item__id,
        ____EUTRANFrequencies__item__iE_Extensions__item__criticality,
        ____EUTRANFrequencies__item__iE_Extensions__item__extensionValue,
        ___EUTRANFrequencies__item__iE_Extensions__item_,
        __EUTRANFrequencies__item__iE_Extensions,
        _EUTRANFrequencies__item_,
        EUTRANFrequencies,
        MeasBand,
        EUTRANFrequencies_ExtIEs,
        _EUTRANFrequencies_ExtIEs_val_Extension_0,
        SubscriberProfileIDforRFP,
        SourceStatisticsDescriptor,
        _SupportedRAB_ParameterBitrateList__item_,
        SupportedRAB_ParameterBitrateList,
        SupportedBitrate,
        _SourceUTRANCellID_pLMNidentity,
        _SourceUTRANCellID_uTRANcellID,
        ____SourceUTRANCellID_iE_Extensions__item__id_tab,
        ___SourceUTRANCellID_iE_Extensions__item__id,
        ____SourceUTRANCellID_iE_Extensions__item__criticality_tab,
        ___SourceUTRANCellID_iE_Extensions__item__criticality,
        ____SourceUTRANCellID_iE_Extensions__item__extensionValue_tab,
        ___SourceUTRANCellID_iE_Extensions__item__extensionValue,
        __SourceUTRANCellID_iE_Extensions__item_,
        _SourceUTRANCellID_iE_Extensions,
        SourceUTRANCellID,
        SourceUTRANCellID_ExtIEs,
        SRB_ID,
        _SRB_TrCH_Mapping__item_,
        SRB_TrCH_Mapping,
        _SRB_TrCH_MappingItem_sRB_ID,
        _SRB_TrCH_MappingItem_trCH_ID,
        ____SRB_TrCH_MappingItem_iE_Extensions__item__id_tab,
        ___SRB_TrCH_MappingItem_iE_Extensions__item__id,
        ____SRB_TrCH_MappingItem_iE_Extensions__item__criticality_tab,
        ___SRB_TrCH_MappingItem_iE_Extensions__item__criticality,
        ____SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue_tab,
        ___SRB_TrCH_MappingItem_iE_Extensions__item__extensionValue,
        __SRB_TrCH_MappingItem_iE_Extensions__item_,
        _SRB_TrCH_MappingItem_iE_Extensions,
        SRB_TrCH_MappingItem,
        SRB_TrCH_MappingItem_ExtIEs,
        SRVCC_HO_Indication,
        _SRVCC_Information_nonce,
        ____SRVCC_Information_iE_Extensions__item__id_tab,
        ___SRVCC_Information_iE_Extensions__item__id,
        ____SRVCC_Information_iE_Extensions__item__criticality_tab,
        ___SRVCC_Information_iE_Extensions__item__criticality,
        ____SRVCC_Information_iE_Extensions__item__extensionValue_tab,
        ___SRVCC_Information_iE_Extensions__item__extensionValue,
        __SRVCC_Information_iE_Extensions__item_,
        _SRVCC_Information_iE_Extensions,
        SRVCC_Information,
        SRVCC_Information_ExtIEs,
        SRVCC_Operation_Possible,
        SubflowSDU_Size,
        TAC,
        _TAI_pLMNidentity,
        _TAI_tAC,
        ____TAI_iE_Extensions__item__id_tab,
        ___TAI_iE_Extensions__item__id,
        ____TAI_iE_Extensions__item__criticality_tab,
        ___TAI_iE_Extensions__item__criticality,
        ____TAI_iE_Extensions__item__extensionValue_tab,
        ___TAI_iE_Extensions__item__extensionValue,
        __TAI_iE_Extensions__item_,
        _TAI_iE_Extensions,
        TAI,
        TAI_ExtIEs,
        Target_ToSource_TransparentContainer,
        TargeteNodeB_ToSourceeNodeB_TransparentContainer,
        TargetBSS_ToSourceBSS_TransparentContainer,
        TargetCellId,
        _TargetID_targetRNC_ID,
        _TargetID_cGI,
        _TargetID_targeteNB_ID,
        TargetID,
        _TargetENB_ID_pLMNidentity,
        _TargetENB_ID_eNB_ID,
        ____TargetENB_ID_iE_Extensions__item__id_tab,
        ___TargetENB_ID_iE_Extensions__item__id,
        ____TargetENB_ID_iE_Extensions__item__criticality_tab,
        ___TargetENB_ID_iE_Extensions__item__criticality,
        ____TargetENB_ID_iE_Extensions__item__extensionValue_tab,
        ___TargetENB_ID_iE_Extensions__item__extensionValue,
        __TargetENB_ID_iE_Extensions__item_,
        _TargetENB_ID_iE_Extensions,
        _TargetENB_ID_selectedTAI,
        TargetENB_ID,
        TargetENB_ID_ExtIEs,
        _TargetRNC_ID_lAI,
        _TargetRNC_ID_rAC,
        _TargetRNC_ID_rNC_ID,
        ____TargetRNC_ID_iE_Extensions__item__id_tab,
        _____TargetRNC_ID_iE_Extensions__item__id_tab_val_Extension_0,
        ___TargetRNC_ID_iE_Extensions__item__id,
        ___TargetRNC_ID_iE_Extensions__item__criticality,
        ___TargetRNC_ID_iE_Extensions__item__extensionValue,
        __TargetRNC_ID_iE_Extensions__item_,
        _TargetRNC_ID_iE_Extensions,
        TargetRNC_ID,
        TargetRNC_ID_ExtIEs,
        _TargetRNC_ID_ExtIEs_val_Extension_0,
        _TargetRNC_ToSourceRNC_TransparentContainer_rRC_Container,
        _TargetRNC_ToSourceRNC_TransparentContainer_d_RNTI,
        ____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab,
        _____TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id_tab_val_Extension_0,
        ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__id,
        ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__criticality,
        ___TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item__extensionValue,
        __TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions__item_,
        _TargetRNC_ToSourceRNC_TransparentContainer_iE_Extensions,
        TargetRNC_ToSourceRNC_TransparentContainer,
        TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs,
        _TargetRNC_ToSourceRNC_TransparentContainer_ExtIEs_val_Extension_0,
        UeApplicationLayerMeasurementSupportIndication,
        TBCD_STRING,
        _TemporaryUE_ID_tMSI,
        _TemporaryUE_ID_p_TMSI,
        TemporaryUE_ID,
        Time_UE_StayedInCell,
        Time_UE_StayedInCell_EnhancedGranularity,
        TimeToMBMSDataTransfer,
        TimingDifferenceULDL,
        _TMGI_pLMNidentity,
        _TMGI_serviceID,
        ____TMGI_iE_Extensions__item__id_tab,
        ___TMGI_iE_Extensions__item__id,
        ____TMGI_iE_Extensions__item__criticality_tab,
        ___TMGI_iE_Extensions__item__criticality,
        ____TMGI_iE_Extensions__item__extensionValue_tab,
        ___TMGI_iE_Extensions__item__extensionValue,
        __TMGI_iE_Extensions__item_,
        _TMGI_iE_Extensions,
        TMGI,
        TMGI_ExtIEs,
        TMSI,
        TraceDepth,
        _TraceInformation_traceReference,
        _TraceInformation_ue_identity,
        _TraceInformation_tracePropagationParameters,
        ____TraceInformation_iE_Extensions__item__id_tab,
        ___TraceInformation_iE_Extensions__item__id,
        ____TraceInformation_iE_Extensions__item__criticality_tab,
        ___TraceInformation_iE_Extensions__item__criticality,
        ____TraceInformation_iE_Extensions__item__extensionValue_tab,
        ___TraceInformation_iE_Extensions__item__extensionValue,
        __TraceInformation_iE_Extensions__item_,
        _TraceInformation_iE_Extensions,
        TraceInformation,
        TraceInformation_ExtIEs,
        _TracePropagationParameters_traceRecordingSessionReference,
        _TracePropagationParameters_traceDepth,
        _TracePropagationParameters_listOfInterfacesToTrace,
        ____TracePropagationParameters_iE_Extensions__item__id_tab,
        ___TracePropagationParameters_iE_Extensions__item__id,
        ____TracePropagationParameters_iE_Extensions__item__criticality_tab,
        ___TracePropagationParameters_iE_Extensions__item__criticality,
        ____TracePropagationParameters_iE_Extensions__item__extensionValue_tab,
        ___TracePropagationParameters_iE_Extensions__item__extensionValue,
        __TracePropagationParameters_iE_Extensions__item_,
        _TracePropagationParameters_iE_Extensions,
        TracePropagationParameters,
        TracePropagationParameters_ExtIEs,
        _TraceRecordingSessionInformation_traceReference,
        _TraceRecordingSessionInformation_traceRecordingSessionReference,
        ____TraceRecordingSessionInformation_iE_Extensions__item__id_tab,
        ___TraceRecordingSessionInformation_iE_Extensions__item__id,
        ____TraceRecordingSessionInformation_iE_Extensions__item__criticality_tab,
        ___TraceRecordingSessionInformation_iE_Extensions__item__criticality,
        ____TraceRecordingSessionInformation_iE_Extensions__item__extensionValue_tab,
        ___TraceRecordingSessionInformation_iE_Extensions__item__extensionValue,
        __TraceRecordingSessionInformation_iE_Extensions__item_,
        _TraceRecordingSessionInformation_iE_Extensions,
        TraceRecordingSessionInformation,
        TraceRecordingSessionInformation_ExtIEs,
        TraceRecordingSessionReference,
        TraceReference,
        TraceType,
        TrafficClass,
        TrafficHandlingPriority,
        TransferDelay,
        UnsuccessfullyTransmittedDataVolume,
        TransportLayerAddress,
        _TrCH_ID_dCH_ID,
        _TrCH_ID_dSCH_ID,
        _TrCH_ID_uSCH_ID,
        ____TrCH_ID_iE_Extensions__item__id_tab,
        _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_0,
        _____TrCH_ID_iE_Extensions__item__id_tab_val_Extension_1,
        ___TrCH_ID_iE_Extensions__item__id,
        ___TrCH_ID_iE_Extensions__item__criticality,
        ___TrCH_ID_iE_Extensions__item__extensionValue,
        __TrCH_ID_iE_Extensions__item_,
        _TrCH_ID_iE_Extensions,
        TrCH_ID,
        TrCH_ID_ExtIEs,
        _TrCH_ID_ExtIEs_val_Extension_0,
        _TrCH_ID_ExtIEs_val_Extension_1,
        _TrCH_ID_List__item_,
        TrCH_ID_List,
        TriggerID,
        _TunnelInformation_transportLayerAddress,
        _TunnelInformation_uDP_Port_Number,
        ____TunnelInformation_iE_Extensions__item__id_tab,
        ___TunnelInformation_iE_Extensions__item__id,
        ____TunnelInformation_iE_Extensions__item__criticality_tab,
        ___TunnelInformation_iE_Extensions__item__criticality,
        ____TunnelInformation_iE_Extensions__item__extensionValue_tab,
        ___TunnelInformation_iE_Extensions__item__extensionValue,
        __TunnelInformation_iE_Extensions__item_,
        _TunnelInformation_iE_Extensions,
        TunnelInformation,
        Tunnel_Information_ExtIEs,
        TypeOfError,
        _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateDownlink,
        _UE_AggregateMaximumBitRate_uE_AggregateMaximumBitRateUplink,
        UE_AggregateMaximumBitRate,
        UE_AggregateMaximumBitRateDownlink,
        UE_AggregateMaximumBitRateUplink,
        UE_Application_Layer_Measurement_Capability,
        UE_History_Information,
        _UE_ID_imsi,
        _UE_ID_imei,
        _UE_ID_imeisv,
        UE_ID,
        _UE_IsNotServed_permanentNAS_UE_ID,
        ____UE_IsNotServed_iE_Extensions__item__id_tab,
        ___UE_IsNotServed_iE_Extensions__item__id,
        ____UE_IsNotServed_iE_Extensions__item__criticality_tab,
        ___UE_IsNotServed_iE_Extensions__item__criticality,
        ____UE_IsNotServed_iE_Extensions__item__extensionValue_tab,
        ___UE_IsNotServed_iE_Extensions__item__extensionValue,
        __UE_IsNotServed_iE_Extensions__item_,
        _UE_IsNotServed_iE_Extensions,
        UE_IsNotServed,
        UE_IsNotServed_ExtIEs,
        _UE_IsServed_permanentNAS_UE_ID,
        _UE_IsServed_pLMNidentity,
        ____UE_IsServed_iE_Extensions__item__id_tab,
        ___UE_IsServed_iE_Extensions__item__id,
        ____UE_IsServed_iE_Extensions__item__criticality_tab,
        ___UE_IsServed_iE_Extensions__item__criticality,
        ____UE_IsServed_iE_Extensions__item__extensionValue_tab,
        ___UE_IsServed_iE_Extensions__item__extensionValue,
        __UE_IsServed_iE_Extensions__item_,
        _UE_IsServed_iE_Extensions,
        UE_IsServed,
        UE_IsServed_ExtIEs,
        UE_Usage_Type,
        _UERegistrationQueryResult_uE_IsServed,
        _UERegistrationQueryResult_uE_IsNotServed,
        UERegistrationQueryResult,
        _UESBI_Iu_uESBI_IuA,
        _UESBI_Iu_uESBI_IuB,
        ____UESBI_Iu_iE_Extensions__item__id_tab,
        ___UESBI_Iu_iE_Extensions__item__id,
        ____UESBI_Iu_iE_Extensions__item__criticality_tab,
        ___UESBI_Iu_iE_Extensions__item__criticality,
        ____UESBI_Iu_iE_Extensions__item__extensionValue_tab,
        ___UESBI_Iu_iE_Extensions__item__extensionValue,
        __UESBI_Iu_iE_Extensions__item_,
        _UESBI_Iu_iE_Extensions,
        UESBI_Iu,
        UESBI_Iu_ExtIEs,
        UESBI_IuA,
        UESBI_IuB,
        UL_GTP_PDU_SequenceNumber,
        UL_N_PDU_SequenceNumber,
        _UPInformation_frameSeqNoUL,
        _UPInformation_frameSeqNoDL,
        _UPInformation_pdu14FrameSeqNoUL,
        _UPInformation_pdu14FrameSeqNoDL,
        _UPInformation_dataPDUType,
        _UPInformation_upinitialisationFrame,
        ____UPInformation_iE_Extensions__item__id_tab,
        _____UPInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___UPInformation_iE_Extensions__item__id,
        ___UPInformation_iE_Extensions__item__criticality,
        ___UPInformation_iE_Extensions__item__extensionValue,
        __UPInformation_iE_Extensions__item_,
        _UPInformation_iE_Extensions,
        UPInformation,
        UPInformation_ExtIEs,
        _UPInformation_ExtIEs_val_Extension_0,
        UPInitialisationFrame,
        UP_ModeVersions,
        USCH_ID,
        UserPlaneMode,
        _UTRAN_CellID_pLMNidentity,
        _UTRAN_CellID_cellID,
        ____UTRAN_CellID_iE_Extensions__item__id_tab,
        ___UTRAN_CellID_iE_Extensions__item__id,
        ____UTRAN_CellID_iE_Extensions__item__criticality_tab,
        ___UTRAN_CellID_iE_Extensions__item__criticality,
        ____UTRAN_CellID_iE_Extensions__item__extensionValue_tab,
        ___UTRAN_CellID_iE_Extensions__item__extensionValue,
        __UTRAN_CellID_iE_Extensions__item_,
        _UTRAN_CellID_iE_Extensions,
        UTRAN_CellID,
        UTRAN_CellID_ExtIEs,
        _VelocityEstimate_horizontalVelocity,
        _VelocityEstimate_horizontalWithVerticalVelocity,
        _VelocityEstimate_horizontalVelocityWithUncertainty,
        _VelocityEstimate_horizontalWithVeritcalVelocityAndUncertainty,
        VelocityEstimate,
        _HorizontalVelocity_horizontalSpeedAndBearing,
        ____HorizontalVelocity_iE_Extensions__item__id_tab,
        ___HorizontalVelocity_iE_Extensions__item__id,
        ____HorizontalVelocity_iE_Extensions__item__criticality_tab,
        ___HorizontalVelocity_iE_Extensions__item__criticality,
        ____HorizontalVelocity_iE_Extensions__item__extensionValue_tab,
        ___HorizontalVelocity_iE_Extensions__item__extensionValue,
        __HorizontalVelocity_iE_Extensions__item_,
        _HorizontalVelocity_iE_Extensions,
        HorizontalVelocity,
        HorizontalVelocity_ExtIEs,
        _HorizontalWithVerticalVelocity_horizontalSpeedAndBearing,
        _HorizontalWithVerticalVelocity_veritcalVelocity,
        ____HorizontalWithVerticalVelocity_iE_Extensions__item__id_tab,
        ___HorizontalWithVerticalVelocity_iE_Extensions__item__id,
        ____HorizontalWithVerticalVelocity_iE_Extensions__item__criticality_tab,
        ___HorizontalWithVerticalVelocity_iE_Extensions__item__criticality,
        ____HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue_tab,
        ___HorizontalWithVerticalVelocity_iE_Extensions__item__extensionValue,
        __HorizontalWithVerticalVelocity_iE_Extensions__item_,
        _HorizontalWithVerticalVelocity_iE_Extensions,
        HorizontalWithVerticalVelocity,
        HorizontalWithVerticalVelocity_ExtIEs,
        _HorizontalVelocityWithUncertainty_horizontalSpeedAndBearing,
        _HorizontalVelocityWithUncertainty_uncertaintySpeed,
        ____HorizontalVelocityWithUncertainty_iE_Extensions__item__id_tab,
        ___HorizontalVelocityWithUncertainty_iE_Extensions__item__id,
        ____HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality_tab,
        ___HorizontalVelocityWithUncertainty_iE_Extensions__item__criticality,
        ____HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue_tab,
        ___HorizontalVelocityWithUncertainty_iE_Extensions__item__extensionValue,
        __HorizontalVelocityWithUncertainty_iE_Extensions__item_,
        _HorizontalVelocityWithUncertainty_iE_Extensions,
        HorizontalVelocityWithUncertainty,
        HorizontalVelocityWithUncertainty_ExtIEs,
        _HorizontalWithVerticalVelocityAndUncertainty_horizontalSpeedAndBearing,
        _HorizontalWithVerticalVelocityAndUncertainty_veritcalVelocity,
        _HorizontalWithVerticalVelocityAndUncertainty_horizontalUncertaintySpeed,
        _HorizontalWithVerticalVelocityAndUncertainty_verticalUncertaintySpeed,
        ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id_tab,
        ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__id,
        ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality_tab,
        ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__criticality,
        ____HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue_tab,
        ___HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item__extensionValue,
        __HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions__item_,
        _HorizontalWithVerticalVelocityAndUncertainty_iE_Extensions,
        HorizontalWithVerticalVelocityAndUncertainty,
        HorizontalWithVerticalVelocityAndUncertainty_ExtIEs,
        _HorizontalSpeedAndBearing_bearing,
        _HorizontalSpeedAndBearing_horizontalSpeed,
        HorizontalSpeedAndBearing,
        _VerticalVelocity_veritcalSpeed,
        _VerticalVelocity_veritcalSpeedDirection,
        VerticalVelocity,
        VerticalSpeedDirection,
        VerticalAccuracyCode,
        VoiceSupportMatchIndicator,
    ]

class RANAP_PDU_Contents:

    _name_  = 'RANAP-PDU-Contents'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 1]
    
    _obj_ = [
        'RAB-IE-ContainerList',
        'RAB-IE-ContainerPairList',
        'ProtocolError-IE-ContainerList',
        'IuSigConId-IE-ContainerList',
        'DirectTransfer-IE-ContainerList',
        'Iu-ReleaseCommand',
        'Iu-ReleaseCommandIEs',
        'Iu-ReleaseCommandExtensions',
        'Iu-ReleaseComplete',
        'Iu-ReleaseCompleteIEs',
        'RAB-DataVolumeReportList',
        'RAB-DataVolumeReportItemIEs',
        'RAB-DataVolumeReportItem',
        'RAB-DataVolumeReportItem-ExtIEs',
        'RAB-ReleasedList-IuRelComp',
        'RAB-ReleasedItem-IuRelComp-IEs',
        'RAB-ReleasedItem-IuRelComp',
        'RAB-ReleasedItem-IuRelComp-ExtIEs',
        'Iu-ReleaseCompleteExtensions',
        'RelocationRequired',
        'RelocationRequiredIEs',
        'RelocationRequiredExtensions',
        'RelocationCommand',
        'RelocationCommandIEs',
        'RAB-RelocationReleaseList',
        'RAB-RelocationReleaseItemIEs',
        'RAB-RelocationReleaseItem',
        'RAB-RelocationReleaseItem-ExtIEs',
        'RAB-DataForwardingList',
        'RAB-DataForwardingItemIEs',
        'RAB-DataForwardingItem',
        'RAB-DataForwardingItem-ExtIEs',
        'RelocationCommandExtensions',
        'RelocationPreparationFailure',
        'RelocationPreparationFailureIEs',
        'RelocationPreparationFailureExtensions',
        'RelocationRequest',
        'RelocationRequestIEs',
        'RAB-SetupList-RelocReq',
        'RAB-SetupItem-RelocReq-IEs',
        'RAB-SetupItem-RelocReq',
        'RAB-SetupItem-RelocReq-ExtIEs',
        'UserPlaneInformation',
        'UserPlaneInformation-ExtIEs',
        'RelocationRequestExtensions',
        'CNMBMSLinkingInformation',
        'CNMBMSLinkingInformation-ExtIEs',
        'JoinedMBMSBearerService-IEs',
        'JoinedMBMSBearerService-ExtIEs',
        'RelocationRequestAcknowledge',
        'RelocationRequestAcknowledgeIEs',
        'RAB-SetupList-RelocReqAck',
        'RAB-SetupItem-RelocReqAck-IEs',
        'RAB-SetupItem-RelocReqAck',
        'RAB-SetupItem-RelocReqAck-ExtIEs',
        'RAB-FailedList',
        'RAB-FailedItemIEs',
        'RAB-FailedItem',
        'RAB-FailedItem-ExtIEs',
        'RelocationRequestAcknowledgeExtensions',
        'RelocationFailure',
        'RelocationFailureIEs',
        'RelocationFailureExtensions',
        'RelocationCancel',
        'RelocationCancelIEs',
        'RelocationCancelExtensions',
        'RelocationCancelAcknowledge',
        'RelocationCancelAcknowledgeIEs',
        'RelocationCancelAcknowledgeExtensions',
        'SRNS-ContextRequest',
        'SRNS-ContextRequestIEs',
        'RAB-DataForwardingList-SRNS-CtxReq',
        'RAB-DataForwardingItem-SRNS-CtxReq-IEs',
        'RAB-DataForwardingItem-SRNS-CtxReq',
        'RAB-DataForwardingItem-SRNS-CtxReq-ExtIEs',
        'SRNS-ContextRequestExtensions',
        'SRNS-ContextResponse',
        'SRNS-ContextResponseIEs',
        'RAB-ContextList',
        'RAB-ContextItemIEs',
        'RAB-ContextItem',
        'RAB-ContextItem-ExtIEs',
        'RAB-ContextFailedtoTransferList',
        'RABs-ContextFailedtoTransferItemIEs',
        'RABs-ContextFailedtoTransferItem',
        'RABs-ContextFailedtoTransferItem-ExtIEs',
        'SRNS-ContextResponseExtensions',
        'SecurityModeCommand',
        'SecurityModeCommandIEs',
        'SecurityModeCommandExtensions',
        'SecurityModeComplete',
        'SecurityModeCompleteIEs',
        'SecurityModeCompleteExtensions',
        'SecurityModeReject',
        'SecurityModeRejectIEs',
        'SecurityModeRejectExtensions',
        'DataVolumeReportRequest',
        'DataVolumeReportRequestIEs',
        'RAB-DataVolumeReportRequestList',
        'RAB-DataVolumeReportRequestItemIEs',
        'RAB-DataVolumeReportRequestItem',
        'RAB-DataVolumeReportRequestItem-ExtIEs',
        'DataVolumeReportRequestExtensions',
        'DataVolumeReport',
        'DataVolumeReportIEs',
        'DataVolumeReportExtensions',
        'RAB-FailedtoReportList',
        'RABs-failed-to-reportItemIEs',
        'RABs-failed-to-reportItem',
        'RABs-failed-to-reportItem-ExtIEs',
        'Reset',
        'ResetIEs',
        'ResetExtensions',
        'ResetAcknowledge',
        'ResetAcknowledgeIEs',
        'ResetAcknowledgeExtensions',
        'ResetResource',
        'ResetResourceIEs',
        'ResetResourceList',
        'ResetResourceItemIEs',
        'ResetResourceItem',
        'ResetResourceItem-ExtIEs',
        'ResetResourceExtensions',
        'ResetResourceAcknowledge',
        'ResetResourceAcknowledgeIEs',
        'ResetResourceAckList',
        'ResetResourceAckItemIEs',
        'ResetResourceAckItem',
        'ResetResourceAckItem-ExtIEs',
        'ResetResourceAcknowledgeExtensions',
        'RAB-ReleaseRequest',
        'RAB-ReleaseRequestIEs',
        'RAB-ReleaseList',
        'RAB-ReleaseItemIEs',
        'RAB-ReleaseItem',
        'RAB-ReleaseItem-ExtIEs',
        'RAB-ReleaseRequestExtensions',
        'Iu-ReleaseRequest',
        'Iu-ReleaseRequestIEs',
        'Iu-ReleaseRequestExtensions',
        'RelocationDetect',
        'RelocationDetectIEs',
        'RelocationDetectExtensions',
        'RelocationComplete',
        'RelocationCompleteIEs',
        'RelocationCompleteExtensions',
        'EnhancedRelocationCompleteRequest',
        'EnhancedRelocationCompleteRequestIEs',
        'RAB-SetupList-EnhancedRelocCompleteReq',
        'RAB-SetupItem-EnhancedRelocCompleteReq-IEs',
        'RAB-SetupItem-EnhancedRelocCompleteReq',
        'RAB-SetupItem-EnhancedRelocCompleteReq-ExtIEs',
        'EnhancedRelocationCompleteRequestExtensions',
        'EnhancedRelocationCompleteResponse',
        'EnhancedRelocationCompleteResponseIEs',
        'RAB-SetupList-EnhancedRelocCompleteRes',
        'RAB-SetupItem-EnhancedRelocCompleteRes-IEs',
        'RAB-SetupItem-EnhancedRelocCompleteRes',
        'RAB-SetupItem-EnhancedRelocCompleteRes-ExtIEs',
        'RAB-ToBeReleasedList-EnhancedRelocCompleteRes',
        'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-IEs',
        'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes',
        'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-ExtIEs',
        'EnhancedRelocationCompleteResponseExtensions',
        'EnhancedRelocationCompleteFailure',
        'EnhancedRelocationCompleteFailureIEs',
        'EnhancedRelocationCompleteFailureExtensions',
        'EnhancedRelocationCompleteConfirm',
        'EnhancedRelocationCompleteConfirmIEs',
        'EnhancedRelocationCompleteConfirmExtensions',
        'Paging',
        'PagingIEs',
        'PagingExtensions',
        'CommonID',
        'CommonID-IEs',
        'CommonIDExtensions',
        'CN-InvokeTrace',
        'CN-InvokeTraceIEs',
        'CN-InvokeTraceExtensions',
        'CN-DeactivateTrace',
        'CN-DeactivateTraceIEs',
        'CN-DeactivateTraceExtensions',
        'LocationReportingControl',
        'LocationReportingControlIEs',
        'LocationReportingControlExtensions',
        'LocationReport',
        'LocationReportIEs',
        'LocationReportExtensions',
        'InitialUE-Message',
        'InitialUE-MessageIEs',
        'InitialUE-MessageExtensions',
        'DirectTransfer',
        'DirectTransferIEs',
        'DirectTransferExtensions',
        'RedirectionIndication',
        'RedirectionIndication-IEs',
        'Overload',
        'OverloadIEs',
        'OverloadExtensions',
        'ErrorIndication',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'SRNS-DataForwardCommand',
        'SRNS-DataForwardCommandIEs',
        'SRNS-DataForwardCommandExtensions',
        'ForwardSRNS-Context',
        'ForwardSRNS-ContextIEs',
        'ForwardSRNS-ContextExtensions',
        'RAB-AssignmentRequest',
        'RAB-AssignmentRequestIEs',
        'RAB-SetupOrModifyList',
        'RAB-SetupOrModifyItem-IEs',
        'RAB-SetupOrModifyItemFirst',
        'TransportLayerInformation',
        'TransportLayerInformation-ExtIEs',
        'RAB-SetupOrModifyItemFirst-ExtIEs',
        'RAB-SetupOrModifyItemSecond',
        'RAB-SetupOrModifyItemSecond-ExtIEs',
        'RAB-AssignmentRequestExtensions',
        'RAB-AssignmentResponse',
        'RAB-AssignmentResponseIEs',
        'RAB-SetupOrModifiedList',
        'RAB-SetupOrModifiedItemIEs',
        'RAB-SetupOrModifiedItem',
        'RAB-SetupOrModifiedItem-ExtIEs',
        'RAB-ReleasedList',
        'RAB-ReleasedItemIEs',
        'RAB-ReleasedItem',
        'RAB-ReleasedItem-ExtIEs',
        'DataVolumeList',
        'DataVolumeList-ExtIEs',
        'RAB-QueuedList',
        'RAB-QueuedItemIEs',
        'RAB-QueuedItem',
        'RAB-QueuedItem-ExtIEs',
        'RAB-ReleaseFailedList',
        'RAB-AssignmentResponseExtensions',
        'GERAN-Iumode-RAB-FailedList-RABAssgntResponse',
        'GERAN-Iumode-RAB-Failed-RABAssgntResponse-ItemIEs',
        'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item',
        'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item-ExtIEs',
        'PrivateMessage',
        'PrivateMessage-IEs',
        'RANAP-RelocationInformation',
        'RANAP-RelocationInformationIEs',
        'DirectTransferInformationList-RANAP-RelocInf',
        'DirectTransferInformationItemIEs-RANAP-RelocInf',
        'DirectTransferInformationItem-RANAP-RelocInf',
        'RANAP-DirectTransferInformationItem-ExtIEs-RANAP-RelocInf',
        'RAB-ContextList-RANAP-RelocInf',
        'RAB-ContextItemIEs-RANAP-RelocInf',
        'RAB-ContextItem-RANAP-RelocInf',
        'RAB-ContextItem-ExtIEs-RANAP-RelocInf',
        'RANAP-RelocationInformationExtensions',
        'RANAP-EnhancedRelocationInformationRequest',
        'RANAP-EnhancedRelocationInformationRequestIEs',
        'RAB-SetupList-EnhRelocInfoReq',
        'RAB-SetupItem-EnhRelocInfoReq-IEs',
        'RAB-SetupItem-EnhRelocInfoReq',
        'RAB-SetupItem-EnhRelocInfoReq-ExtIEs',
        'TNLInformationEnhRelInfoReq',
        'TNLInformationEnhRelInfoReq-ExtIEs',
        'RANAP-EnhancedRelocationInformationRequestExtensions',
        'RANAP-EnhancedRelocationInformationResponse',
        'RANAP-EnhancedRelocationInformationResponseIEs',
        'RAB-SetupList-EnhRelocInfoRes',
        'RAB-SetupItem-EnhRelocInfoRes-IEs',
        'RAB-SetupItem-EnhRelocInfoRes',
        'RAB-SetupItem-EnhRelocInfoRes-ExtIEs',
        'RAB-FailedList-EnhRelocInfoRes',
        'RAB-FailedItem-EnhRelocInfoRes-IEs',
        'RAB-FailedItem-EnhRelocInfoRes',
        'RAB-FailedItem-EnhRelocInfoRes-ExtIEs',
        'TNLInformationEnhRelInfoRes',
        'TNLInformationEnhRelInfoRes-ExtIEs',
        'RANAP-EnhancedRelocationInformationResponseExtensions',
        'RAB-ModifyRequest',
        'RAB-ModifyRequestIEs',
        'RAB-ModifyList',
        'RAB-ModifyItemIEs',
        'RAB-ModifyItem',
        'RAB-ModifyItem-ExtIEs',
        'RAB-ModifyRequestExtensions',
        'LocationRelatedDataRequest',
        'LocationRelatedDataRequestIEs',
        'LocationRelatedDataRequestExtensions',
        'LocationRelatedDataResponse',
        'LocationRelatedDataResponseIEs',
        'LocationRelatedDataResponseExtensions',
        'LocationRelatedDataFailure',
        'LocationRelatedDataFailureIEs',
        'LocationRelatedDataFailureExtensions',
        'InformationTransferIndication',
        'InformationTransferIndicationIEs',
        'InformationTransferIndicationExtensions',
        'InformationTransferConfirmation',
        'InformationTransferConfirmationIEs',
        'InformationTransferConfirmationExtensions',
        'InformationTransferFailure',
        'InformationTransferFailureIEs',
        'InformationTransferFailureExtensions',
        'UESpecificInformationIndication',
        'UESpecificInformationIndicationIEs',
        'UESpecificInformationIndicationExtensions',
        'DirectInformationTransfer',
        'DirectInformationTransferIEs',
        'DirectInformationTransferExtensions',
        'UplinkInformationExchangeRequest',
        'UplinkInformationExchangeRequestIEs',
        'UplinkInformationExchangeRequestExtensions',
        'UplinkInformationExchangeResponse',
        'UplinkInformationExchangeResponseIEs',
        'UplinkInformationExchangeResponseExtensions',
        'UplinkInformationExchangeFailure',
        'UplinkInformationExchangeFailureIEs',
        'UplinkInformationExchangeFailureExtensions',
        'MBMSSessionStart',
        'MBMSSessionStartIEs',
        'MBMSSessionStartExtensions',
        'MBMSSynchronisationInformation',
        'MBMSSynchronisationInformation-ExtIEs',
        'MBMSSessionStartResponse',
        'MBMSSessionStartResponseIEs',
        'MBMSSessionStartResponseExtensions',
        'MBMSSessionStartFailure',
        'MBMSSessionStartFailureIEs',
        'MBMSSessionStartFailureExtensions',
        'MBMSSessionUpdate',
        'MBMSSessionUpdateIEs',
        'MBMSSessionUpdateExtensions',
        'MBMSSessionUpdateResponse',
        'MBMSSessionUpdateResponseIEs',
        'MBMSSessionUpdateResponseExtensions',
        'MBMSSessionUpdateFailure',
        'MBMSSessionUpdateFailureIEs',
        'MBMSSessionUpdateFailureExtensions',
        'MBMSSessionStop',
        'MBMSSessionStopIEs',
        'MBMSSessionStopExtensions',
        'MBMSSessionStopResponse',
        'MBMSSessionStopResponseIEs',
        'MBMSSessionStopResponseExtensions',
        'MBMSUELinkingRequest',
        'MBMSUELinkingRequestIEs',
        'LeftMBMSBearerService-IEs',
        'LeftMBMSBearerService-ExtIEs',
        'MBMSUELinkingRequestExtensions',
        'MBMSUELinkingResponse',
        'MBMSUELinkingResponseIEs',
        'UnsuccessfulLinking-IEs',
        'UnsuccessfulLinking-ExtIEs',
        'MBMSUELinkingResponseExtensions',
        'MBMSRegistrationRequest',
        'MBMSRegistrationRequestIEs',
        'MBMSRegistrationRequestExtensions',
        'MBMSRegistrationResponse',
        'MBMSRegistrationResponseIEs',
        'MBMSRegistrationResponseExtensions',
        'MBMSRegistrationFailure',
        'MBMSRegistrationFailureIEs',
        'MBMSRegistrationFailureExtensions',
        'MBMSCNDe-RegistrationRequest',
        'MBMSCNDe-RegistrationRequestIEs',
        'MBMSCNDe-RegistrationRequestExtensions',
        'MBMSCNDe-RegistrationResponse',
        'MBMSCNDe-RegistrationResponseIEs',
        'MBMSCNDe-RegistrationResponseExtensions',
        'MBMSRABEstablishmentIndication',
        'MBMSRABEstablishmentIndicationIEs',
        'MBMSRABEstablishmentIndicationExtensions',
        'MBMSRABReleaseRequest',
        'MBMSRABReleaseRequestIEs',
        'MBMSRABReleaseRequestExtensions',
        'MBMSRABRelease',
        'MBMSRABReleaseIEs',
        'MBMSRABReleaseExtensions',
        'MBMSRABReleaseFailure',
        'MBMSRABReleaseFailureIEs',
        'MBMSRABReleaseFailureExtensions',
        'SRVCC-CSKeysRequest',
        'SRVCC-CSKeysRequestIEs',
        'SRVCC-CSKeysRequestExtensions',
        'SRVCC-CSKeysResponse',
        'SRVCC-CSKeysResponseIEs',
        'SRVCC-CSKeysResponseExtensions',
        'UeRadioCapabilityMatchRequest',
        'UeRadioCapabilityMatchRequestIEs',
        'UeRadioCapabilityMatchRequestExtensions',
        'UeRadioCapabilityMatchResponse',
        'UeRadioCapabilityMatchResponseIEs',
        'UeRadioCapabilityMatchResponseExtensions',
        'UeRegistrationQueryRequest',
        'UeRegistrationQueryRequestIEs',
        'UeRegistrationQueryRequestExtensions',
        'UeRegistrationQueryResponse',
        'UeRegistrationQueryResponseIEs',
        'UeRegistrationQueryResponseExtensions',
        'RerouteNASRequest',
        'RerouteNASRequestIEs',
        'RerouteNASRequestExtensions',
        ]
    _type_ = [
        'RAB-IE-ContainerList',
        'RAB-IE-ContainerPairList',
        'ProtocolError-IE-ContainerList',
        'IuSigConId-IE-ContainerList',
        'DirectTransfer-IE-ContainerList',
        'Iu-ReleaseCommand',
        'Iu-ReleaseComplete',
        'RAB-DataVolumeReportList',
        'RAB-DataVolumeReportItem',
        'RAB-ReleasedList-IuRelComp',
        'RAB-ReleasedItem-IuRelComp',
        'RelocationRequired',
        'RelocationCommand',
        'RAB-RelocationReleaseList',
        'RAB-RelocationReleaseItem',
        'RAB-DataForwardingList',
        'RAB-DataForwardingItem',
        'RelocationPreparationFailure',
        'RelocationRequest',
        'RAB-SetupList-RelocReq',
        'RAB-SetupItem-RelocReq',
        'UserPlaneInformation',
        'CNMBMSLinkingInformation',
        'JoinedMBMSBearerService-IEs',
        'RelocationRequestAcknowledge',
        'RAB-SetupList-RelocReqAck',
        'RAB-SetupItem-RelocReqAck',
        'RAB-FailedList',
        'RAB-FailedItem',
        'RelocationFailure',
        'RelocationCancel',
        'RelocationCancelAcknowledge',
        'SRNS-ContextRequest',
        'RAB-DataForwardingList-SRNS-CtxReq',
        'RAB-DataForwardingItem-SRNS-CtxReq',
        'SRNS-ContextResponse',
        'RAB-ContextList',
        'RAB-ContextItem',
        'RAB-ContextFailedtoTransferList',
        'RABs-ContextFailedtoTransferItem',
        'SecurityModeCommand',
        'SecurityModeComplete',
        'SecurityModeReject',
        'DataVolumeReportRequest',
        'RAB-DataVolumeReportRequestList',
        'RAB-DataVolumeReportRequestItem',
        'DataVolumeReport',
        'RAB-FailedtoReportList',
        'RABs-failed-to-reportItem',
        'Reset',
        'ResetAcknowledge',
        'ResetResource',
        'ResetResourceList',
        'ResetResourceItem',
        'ResetResourceAcknowledge',
        'ResetResourceAckList',
        'ResetResourceAckItem',
        'RAB-ReleaseRequest',
        'RAB-ReleaseList',
        'RAB-ReleaseItem',
        'Iu-ReleaseRequest',
        'RelocationDetect',
        'RelocationComplete',
        'EnhancedRelocationCompleteRequest',
        'RAB-SetupList-EnhancedRelocCompleteReq',
        'RAB-SetupItem-EnhancedRelocCompleteReq',
        'EnhancedRelocationCompleteResponse',
        'RAB-SetupList-EnhancedRelocCompleteRes',
        'RAB-SetupItem-EnhancedRelocCompleteRes',
        'RAB-ToBeReleasedList-EnhancedRelocCompleteRes',
        'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes',
        'EnhancedRelocationCompleteFailure',
        'EnhancedRelocationCompleteConfirm',
        'Paging',
        'CommonID',
        'CN-InvokeTrace',
        'CN-DeactivateTrace',
        'LocationReportingControl',
        'LocationReport',
        'InitialUE-Message',
        'DirectTransfer',
        'RedirectionIndication',
        'Overload',
        'ErrorIndication',
        'SRNS-DataForwardCommand',
        'ForwardSRNS-Context',
        'RAB-AssignmentRequest',
        'RAB-SetupOrModifyList',
        'RAB-SetupOrModifyItemFirst',
        'TransportLayerInformation',
        'RAB-SetupOrModifyItemSecond',
        'RAB-AssignmentResponse',
        'RAB-SetupOrModifiedList',
        'RAB-SetupOrModifiedItem',
        'RAB-ReleasedList',
        'RAB-ReleasedItem',
        'DataVolumeList',
        'RAB-QueuedList',
        'RAB-QueuedItem',
        'RAB-ReleaseFailedList',
        'GERAN-Iumode-RAB-FailedList-RABAssgntResponse',
        'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item',
        'PrivateMessage',
        'RANAP-RelocationInformation',
        'DirectTransferInformationList-RANAP-RelocInf',
        'DirectTransferInformationItem-RANAP-RelocInf',
        'RAB-ContextList-RANAP-RelocInf',
        'RAB-ContextItem-RANAP-RelocInf',
        'RANAP-EnhancedRelocationInformationRequest',
        'RAB-SetupList-EnhRelocInfoReq',
        'RAB-SetupItem-EnhRelocInfoReq',
        'TNLInformationEnhRelInfoReq',
        'RANAP-EnhancedRelocationInformationResponse',
        'RAB-SetupList-EnhRelocInfoRes',
        'RAB-SetupItem-EnhRelocInfoRes',
        'RAB-FailedList-EnhRelocInfoRes',
        'RAB-FailedItem-EnhRelocInfoRes',
        'TNLInformationEnhRelInfoRes',
        'RAB-ModifyRequest',
        'RAB-ModifyList',
        'RAB-ModifyItem',
        'LocationRelatedDataRequest',
        'LocationRelatedDataResponse',
        'LocationRelatedDataFailure',
        'InformationTransferIndication',
        'InformationTransferConfirmation',
        'InformationTransferFailure',
        'UESpecificInformationIndication',
        'DirectInformationTransfer',
        'UplinkInformationExchangeRequest',
        'UplinkInformationExchangeResponse',
        'UplinkInformationExchangeFailure',
        'MBMSSessionStart',
        'MBMSSynchronisationInformation',
        'MBMSSessionStartResponse',
        'MBMSSessionStartFailure',
        'MBMSSessionUpdate',
        'MBMSSessionUpdateResponse',
        'MBMSSessionUpdateFailure',
        'MBMSSessionStop',
        'MBMSSessionStopResponse',
        'MBMSUELinkingRequest',
        'LeftMBMSBearerService-IEs',
        'MBMSUELinkingResponse',
        'UnsuccessfulLinking-IEs',
        'MBMSRegistrationRequest',
        'MBMSRegistrationResponse',
        'MBMSRegistrationFailure',
        'MBMSCNDe-RegistrationRequest',
        'MBMSCNDe-RegistrationResponse',
        'MBMSRABEstablishmentIndication',
        'MBMSRABReleaseRequest',
        'MBMSRABRelease',
        'MBMSRABReleaseFailure',
        'SRVCC-CSKeysRequest',
        'SRVCC-CSKeysResponse',
        'UeRadioCapabilityMatchRequest',
        'UeRadioCapabilityMatchResponse',
        'UeRegistrationQueryRequest',
        'UeRegistrationQueryResponse',
        'RerouteNASRequest',
        ]
    _set_ = [
        'Iu-ReleaseCommandIEs',
        'Iu-ReleaseCommandExtensions',
        'Iu-ReleaseCompleteIEs',
        'RAB-DataVolumeReportItemIEs',
        'RAB-DataVolumeReportItem-ExtIEs',
        'RAB-ReleasedItem-IuRelComp-IEs',
        'RAB-ReleasedItem-IuRelComp-ExtIEs',
        'Iu-ReleaseCompleteExtensions',
        'RelocationRequiredIEs',
        'RelocationRequiredExtensions',
        'RelocationCommandIEs',
        'RAB-RelocationReleaseItemIEs',
        'RAB-RelocationReleaseItem-ExtIEs',
        'RAB-DataForwardingItemIEs',
        'RAB-DataForwardingItem-ExtIEs',
        'RelocationCommandExtensions',
        'RelocationPreparationFailureIEs',
        'RelocationPreparationFailureExtensions',
        'RelocationRequestIEs',
        'RAB-SetupItem-RelocReq-IEs',
        'RAB-SetupItem-RelocReq-ExtIEs',
        'UserPlaneInformation-ExtIEs',
        'RelocationRequestExtensions',
        'CNMBMSLinkingInformation-ExtIEs',
        'JoinedMBMSBearerService-ExtIEs',
        'RelocationRequestAcknowledgeIEs',
        'RAB-SetupItem-RelocReqAck-IEs',
        'RAB-SetupItem-RelocReqAck-ExtIEs',
        'RAB-FailedItemIEs',
        'RAB-FailedItem-ExtIEs',
        'RelocationRequestAcknowledgeExtensions',
        'RelocationFailureIEs',
        'RelocationFailureExtensions',
        'RelocationCancelIEs',
        'RelocationCancelExtensions',
        'RelocationCancelAcknowledgeIEs',
        'RelocationCancelAcknowledgeExtensions',
        'SRNS-ContextRequestIEs',
        'RAB-DataForwardingItem-SRNS-CtxReq-IEs',
        'RAB-DataForwardingItem-SRNS-CtxReq-ExtIEs',
        'SRNS-ContextRequestExtensions',
        'SRNS-ContextResponseIEs',
        'RAB-ContextItemIEs',
        'RAB-ContextItem-ExtIEs',
        'RABs-ContextFailedtoTransferItemIEs',
        'RABs-ContextFailedtoTransferItem-ExtIEs',
        'SRNS-ContextResponseExtensions',
        'SecurityModeCommandIEs',
        'SecurityModeCommandExtensions',
        'SecurityModeCompleteIEs',
        'SecurityModeCompleteExtensions',
        'SecurityModeRejectIEs',
        'SecurityModeRejectExtensions',
        'DataVolumeReportRequestIEs',
        'RAB-DataVolumeReportRequestItemIEs',
        'RAB-DataVolumeReportRequestItem-ExtIEs',
        'DataVolumeReportRequestExtensions',
        'DataVolumeReportIEs',
        'DataVolumeReportExtensions',
        'RABs-failed-to-reportItemIEs',
        'RABs-failed-to-reportItem-ExtIEs',
        'ResetIEs',
        'ResetExtensions',
        'ResetAcknowledgeIEs',
        'ResetAcknowledgeExtensions',
        'ResetResourceIEs',
        'ResetResourceItemIEs',
        'ResetResourceItem-ExtIEs',
        'ResetResourceExtensions',
        'ResetResourceAcknowledgeIEs',
        'ResetResourceAckItemIEs',
        'ResetResourceAckItem-ExtIEs',
        'ResetResourceAcknowledgeExtensions',
        'RAB-ReleaseRequestIEs',
        'RAB-ReleaseItemIEs',
        'RAB-ReleaseItem-ExtIEs',
        'RAB-ReleaseRequestExtensions',
        'Iu-ReleaseRequestIEs',
        'Iu-ReleaseRequestExtensions',
        'RelocationDetectIEs',
        'RelocationDetectExtensions',
        'RelocationCompleteIEs',
        'RelocationCompleteExtensions',
        'EnhancedRelocationCompleteRequestIEs',
        'RAB-SetupItem-EnhancedRelocCompleteReq-IEs',
        'RAB-SetupItem-EnhancedRelocCompleteReq-ExtIEs',
        'EnhancedRelocationCompleteRequestExtensions',
        'EnhancedRelocationCompleteResponseIEs',
        'RAB-SetupItem-EnhancedRelocCompleteRes-IEs',
        'RAB-SetupItem-EnhancedRelocCompleteRes-ExtIEs',
        'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-IEs',
        'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-ExtIEs',
        'EnhancedRelocationCompleteResponseExtensions',
        'EnhancedRelocationCompleteFailureIEs',
        'EnhancedRelocationCompleteFailureExtensions',
        'EnhancedRelocationCompleteConfirmIEs',
        'EnhancedRelocationCompleteConfirmExtensions',
        'PagingIEs',
        'PagingExtensions',
        'CommonID-IEs',
        'CommonIDExtensions',
        'CN-InvokeTraceIEs',
        'CN-InvokeTraceExtensions',
        'CN-DeactivateTraceIEs',
        'CN-DeactivateTraceExtensions',
        'LocationReportingControlIEs',
        'LocationReportingControlExtensions',
        'LocationReportIEs',
        'LocationReportExtensions',
        'InitialUE-MessageIEs',
        'InitialUE-MessageExtensions',
        'DirectTransferIEs',
        'DirectTransferExtensions',
        'RedirectionIndication-IEs',
        'OverloadIEs',
        'OverloadExtensions',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'SRNS-DataForwardCommandIEs',
        'SRNS-DataForwardCommandExtensions',
        'ForwardSRNS-ContextIEs',
        'ForwardSRNS-ContextExtensions',
        'RAB-AssignmentRequestIEs',
        'RAB-SetupOrModifyItem-IEs',
        'TransportLayerInformation-ExtIEs',
        'RAB-SetupOrModifyItemFirst-ExtIEs',
        'RAB-SetupOrModifyItemSecond-ExtIEs',
        'RAB-AssignmentRequestExtensions',
        'RAB-AssignmentResponseIEs',
        'RAB-SetupOrModifiedItemIEs',
        'RAB-SetupOrModifiedItem-ExtIEs',
        'RAB-ReleasedItemIEs',
        'RAB-ReleasedItem-ExtIEs',
        'DataVolumeList-ExtIEs',
        'RAB-QueuedItemIEs',
        'RAB-QueuedItem-ExtIEs',
        'RAB-AssignmentResponseExtensions',
        'GERAN-Iumode-RAB-Failed-RABAssgntResponse-ItemIEs',
        'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item-ExtIEs',
        'PrivateMessage-IEs',
        'RANAP-RelocationInformationIEs',
        'DirectTransferInformationItemIEs-RANAP-RelocInf',
        'RANAP-DirectTransferInformationItem-ExtIEs-RANAP-RelocInf',
        'RAB-ContextItemIEs-RANAP-RelocInf',
        'RAB-ContextItem-ExtIEs-RANAP-RelocInf',
        'RANAP-RelocationInformationExtensions',
        'RANAP-EnhancedRelocationInformationRequestIEs',
        'RAB-SetupItem-EnhRelocInfoReq-IEs',
        'RAB-SetupItem-EnhRelocInfoReq-ExtIEs',
        'TNLInformationEnhRelInfoReq-ExtIEs',
        'RANAP-EnhancedRelocationInformationRequestExtensions',
        'RANAP-EnhancedRelocationInformationResponseIEs',
        'RAB-SetupItem-EnhRelocInfoRes-IEs',
        'RAB-SetupItem-EnhRelocInfoRes-ExtIEs',
        'RAB-FailedItem-EnhRelocInfoRes-IEs',
        'RAB-FailedItem-EnhRelocInfoRes-ExtIEs',
        'TNLInformationEnhRelInfoRes-ExtIEs',
        'RANAP-EnhancedRelocationInformationResponseExtensions',
        'RAB-ModifyRequestIEs',
        'RAB-ModifyItemIEs',
        'RAB-ModifyItem-ExtIEs',
        'RAB-ModifyRequestExtensions',
        'LocationRelatedDataRequestIEs',
        'LocationRelatedDataRequestExtensions',
        'LocationRelatedDataResponseIEs',
        'LocationRelatedDataResponseExtensions',
        'LocationRelatedDataFailureIEs',
        'LocationRelatedDataFailureExtensions',
        'InformationTransferIndicationIEs',
        'InformationTransferIndicationExtensions',
        'InformationTransferConfirmationIEs',
        'InformationTransferConfirmationExtensions',
        'InformationTransferFailureIEs',
        'InformationTransferFailureExtensions',
        'UESpecificInformationIndicationIEs',
        'UESpecificInformationIndicationExtensions',
        'DirectInformationTransferIEs',
        'DirectInformationTransferExtensions',
        'UplinkInformationExchangeRequestIEs',
        'UplinkInformationExchangeRequestExtensions',
        'UplinkInformationExchangeResponseIEs',
        'UplinkInformationExchangeResponseExtensions',
        'UplinkInformationExchangeFailureIEs',
        'UplinkInformationExchangeFailureExtensions',
        'MBMSSessionStartIEs',
        'MBMSSessionStartExtensions',
        'MBMSSynchronisationInformation-ExtIEs',
        'MBMSSessionStartResponseIEs',
        'MBMSSessionStartResponseExtensions',
        'MBMSSessionStartFailureIEs',
        'MBMSSessionStartFailureExtensions',
        'MBMSSessionUpdateIEs',
        'MBMSSessionUpdateExtensions',
        'MBMSSessionUpdateResponseIEs',
        'MBMSSessionUpdateResponseExtensions',
        'MBMSSessionUpdateFailureIEs',
        'MBMSSessionUpdateFailureExtensions',
        'MBMSSessionStopIEs',
        'MBMSSessionStopExtensions',
        'MBMSSessionStopResponseIEs',
        'MBMSSessionStopResponseExtensions',
        'MBMSUELinkingRequestIEs',
        'LeftMBMSBearerService-ExtIEs',
        'MBMSUELinkingRequestExtensions',
        'MBMSUELinkingResponseIEs',
        'UnsuccessfulLinking-ExtIEs',
        'MBMSUELinkingResponseExtensions',
        'MBMSRegistrationRequestIEs',
        'MBMSRegistrationRequestExtensions',
        'MBMSRegistrationResponseIEs',
        'MBMSRegistrationResponseExtensions',
        'MBMSRegistrationFailureIEs',
        'MBMSRegistrationFailureExtensions',
        'MBMSCNDe-RegistrationRequestIEs',
        'MBMSCNDe-RegistrationRequestExtensions',
        'MBMSCNDe-RegistrationResponseIEs',
        'MBMSCNDe-RegistrationResponseExtensions',
        'MBMSRABEstablishmentIndicationIEs',
        'MBMSRABEstablishmentIndicationExtensions',
        'MBMSRABReleaseRequestIEs',
        'MBMSRABReleaseRequestExtensions',
        'MBMSRABReleaseIEs',
        'MBMSRABReleaseExtensions',
        'MBMSRABReleaseFailureIEs',
        'MBMSRABReleaseFailureExtensions',
        'SRVCC-CSKeysRequestIEs',
        'SRVCC-CSKeysRequestExtensions',
        'SRVCC-CSKeysResponseIEs',
        'SRVCC-CSKeysResponseExtensions',
        'UeRadioCapabilityMatchRequestIEs',
        'UeRadioCapabilityMatchRequestExtensions',
        'UeRadioCapabilityMatchResponseIEs',
        'UeRadioCapabilityMatchResponseExtensions',
        'UeRegistrationQueryRequestIEs',
        'UeRegistrationQueryRequestExtensions',
        'UeRegistrationQueryResponseIEs',
        'UeRegistrationQueryResponseExtensions',
        'RerouteNASRequestIEs',
        'RerouteNASRequestExtensions',
        ]
    _val_ = [
        ]
    _class_ = [
        'Iu-ReleaseCommandIEs',
        'Iu-ReleaseCommandExtensions',
        'Iu-ReleaseCompleteIEs',
        'RAB-DataVolumeReportItemIEs',
        'RAB-DataVolumeReportItem-ExtIEs',
        'RAB-ReleasedItem-IuRelComp-IEs',
        'RAB-ReleasedItem-IuRelComp-ExtIEs',
        'Iu-ReleaseCompleteExtensions',
        'RelocationRequiredIEs',
        'RelocationRequiredExtensions',
        'RelocationCommandIEs',
        'RAB-RelocationReleaseItemIEs',
        'RAB-RelocationReleaseItem-ExtIEs',
        'RAB-DataForwardingItemIEs',
        'RAB-DataForwardingItem-ExtIEs',
        'RelocationCommandExtensions',
        'RelocationPreparationFailureIEs',
        'RelocationPreparationFailureExtensions',
        'RelocationRequestIEs',
        'RAB-SetupItem-RelocReq-IEs',
        'RAB-SetupItem-RelocReq-ExtIEs',
        'UserPlaneInformation-ExtIEs',
        'RelocationRequestExtensions',
        'CNMBMSLinkingInformation-ExtIEs',
        'JoinedMBMSBearerService-ExtIEs',
        'RelocationRequestAcknowledgeIEs',
        'RAB-SetupItem-RelocReqAck-IEs',
        'RAB-SetupItem-RelocReqAck-ExtIEs',
        'RAB-FailedItemIEs',
        'RAB-FailedItem-ExtIEs',
        'RelocationRequestAcknowledgeExtensions',
        'RelocationFailureIEs',
        'RelocationFailureExtensions',
        'RelocationCancelIEs',
        'RelocationCancelExtensions',
        'RelocationCancelAcknowledgeIEs',
        'RelocationCancelAcknowledgeExtensions',
        'SRNS-ContextRequestIEs',
        'RAB-DataForwardingItem-SRNS-CtxReq-IEs',
        'RAB-DataForwardingItem-SRNS-CtxReq-ExtIEs',
        'SRNS-ContextRequestExtensions',
        'SRNS-ContextResponseIEs',
        'RAB-ContextItemIEs',
        'RAB-ContextItem-ExtIEs',
        'RABs-ContextFailedtoTransferItemIEs',
        'RABs-ContextFailedtoTransferItem-ExtIEs',
        'SRNS-ContextResponseExtensions',
        'SecurityModeCommandIEs',
        'SecurityModeCommandExtensions',
        'SecurityModeCompleteIEs',
        'SecurityModeCompleteExtensions',
        'SecurityModeRejectIEs',
        'SecurityModeRejectExtensions',
        'DataVolumeReportRequestIEs',
        'RAB-DataVolumeReportRequestItemIEs',
        'RAB-DataVolumeReportRequestItem-ExtIEs',
        'DataVolumeReportRequestExtensions',
        'DataVolumeReportIEs',
        'DataVolumeReportExtensions',
        'RABs-failed-to-reportItemIEs',
        'RABs-failed-to-reportItem-ExtIEs',
        'ResetIEs',
        'ResetExtensions',
        'ResetAcknowledgeIEs',
        'ResetAcknowledgeExtensions',
        'ResetResourceIEs',
        'ResetResourceItemIEs',
        'ResetResourceItem-ExtIEs',
        'ResetResourceExtensions',
        'ResetResourceAcknowledgeIEs',
        'ResetResourceAckItemIEs',
        'ResetResourceAckItem-ExtIEs',
        'ResetResourceAcknowledgeExtensions',
        'RAB-ReleaseRequestIEs',
        'RAB-ReleaseItemIEs',
        'RAB-ReleaseItem-ExtIEs',
        'RAB-ReleaseRequestExtensions',
        'Iu-ReleaseRequestIEs',
        'Iu-ReleaseRequestExtensions',
        'RelocationDetectIEs',
        'RelocationDetectExtensions',
        'RelocationCompleteIEs',
        'RelocationCompleteExtensions',
        'EnhancedRelocationCompleteRequestIEs',
        'RAB-SetupItem-EnhancedRelocCompleteReq-IEs',
        'RAB-SetupItem-EnhancedRelocCompleteReq-ExtIEs',
        'EnhancedRelocationCompleteRequestExtensions',
        'EnhancedRelocationCompleteResponseIEs',
        'RAB-SetupItem-EnhancedRelocCompleteRes-IEs',
        'RAB-SetupItem-EnhancedRelocCompleteRes-ExtIEs',
        'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-IEs',
        'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-ExtIEs',
        'EnhancedRelocationCompleteResponseExtensions',
        'EnhancedRelocationCompleteFailureIEs',
        'EnhancedRelocationCompleteFailureExtensions',
        'EnhancedRelocationCompleteConfirmIEs',
        'EnhancedRelocationCompleteConfirmExtensions',
        'PagingIEs',
        'PagingExtensions',
        'CommonID-IEs',
        'CommonIDExtensions',
        'CN-InvokeTraceIEs',
        'CN-InvokeTraceExtensions',
        'CN-DeactivateTraceIEs',
        'CN-DeactivateTraceExtensions',
        'LocationReportingControlIEs',
        'LocationReportingControlExtensions',
        'LocationReportIEs',
        'LocationReportExtensions',
        'InitialUE-MessageIEs',
        'InitialUE-MessageExtensions',
        'DirectTransferIEs',
        'DirectTransferExtensions',
        'RedirectionIndication-IEs',
        'OverloadIEs',
        'OverloadExtensions',
        'ErrorIndicationIEs',
        'ErrorIndicationExtensions',
        'SRNS-DataForwardCommandIEs',
        'SRNS-DataForwardCommandExtensions',
        'ForwardSRNS-ContextIEs',
        'ForwardSRNS-ContextExtensions',
        'RAB-AssignmentRequestIEs',
        'RAB-SetupOrModifyItem-IEs',
        'TransportLayerInformation-ExtIEs',
        'RAB-SetupOrModifyItemFirst-ExtIEs',
        'RAB-SetupOrModifyItemSecond-ExtIEs',
        'RAB-AssignmentRequestExtensions',
        'RAB-AssignmentResponseIEs',
        'RAB-SetupOrModifiedItemIEs',
        'RAB-SetupOrModifiedItem-ExtIEs',
        'RAB-ReleasedItemIEs',
        'RAB-ReleasedItem-ExtIEs',
        'DataVolumeList-ExtIEs',
        'RAB-QueuedItemIEs',
        'RAB-QueuedItem-ExtIEs',
        'RAB-AssignmentResponseExtensions',
        'GERAN-Iumode-RAB-Failed-RABAssgntResponse-ItemIEs',
        'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item-ExtIEs',
        'PrivateMessage-IEs',
        'RANAP-RelocationInformationIEs',
        'DirectTransferInformationItemIEs-RANAP-RelocInf',
        'RANAP-DirectTransferInformationItem-ExtIEs-RANAP-RelocInf',
        'RAB-ContextItemIEs-RANAP-RelocInf',
        'RAB-ContextItem-ExtIEs-RANAP-RelocInf',
        'RANAP-RelocationInformationExtensions',
        'RANAP-EnhancedRelocationInformationRequestIEs',
        'RAB-SetupItem-EnhRelocInfoReq-IEs',
        'RAB-SetupItem-EnhRelocInfoReq-ExtIEs',
        'TNLInformationEnhRelInfoReq-ExtIEs',
        'RANAP-EnhancedRelocationInformationRequestExtensions',
        'RANAP-EnhancedRelocationInformationResponseIEs',
        'RAB-SetupItem-EnhRelocInfoRes-IEs',
        'RAB-SetupItem-EnhRelocInfoRes-ExtIEs',
        'RAB-FailedItem-EnhRelocInfoRes-IEs',
        'RAB-FailedItem-EnhRelocInfoRes-ExtIEs',
        'TNLInformationEnhRelInfoRes-ExtIEs',
        'RANAP-EnhancedRelocationInformationResponseExtensions',
        'RAB-ModifyRequestIEs',
        'RAB-ModifyItemIEs',
        'RAB-ModifyItem-ExtIEs',
        'RAB-ModifyRequestExtensions',
        'LocationRelatedDataRequestIEs',
        'LocationRelatedDataRequestExtensions',
        'LocationRelatedDataResponseIEs',
        'LocationRelatedDataResponseExtensions',
        'LocationRelatedDataFailureIEs',
        'LocationRelatedDataFailureExtensions',
        'InformationTransferIndicationIEs',
        'InformationTransferIndicationExtensions',
        'InformationTransferConfirmationIEs',
        'InformationTransferConfirmationExtensions',
        'InformationTransferFailureIEs',
        'InformationTransferFailureExtensions',
        'UESpecificInformationIndicationIEs',
        'UESpecificInformationIndicationExtensions',
        'DirectInformationTransferIEs',
        'DirectInformationTransferExtensions',
        'UplinkInformationExchangeRequestIEs',
        'UplinkInformationExchangeRequestExtensions',
        'UplinkInformationExchangeResponseIEs',
        'UplinkInformationExchangeResponseExtensions',
        'UplinkInformationExchangeFailureIEs',
        'UplinkInformationExchangeFailureExtensions',
        'MBMSSessionStartIEs',
        'MBMSSessionStartExtensions',
        'MBMSSynchronisationInformation-ExtIEs',
        'MBMSSessionStartResponseIEs',
        'MBMSSessionStartResponseExtensions',
        'MBMSSessionStartFailureIEs',
        'MBMSSessionStartFailureExtensions',
        'MBMSSessionUpdateIEs',
        'MBMSSessionUpdateExtensions',
        'MBMSSessionUpdateResponseIEs',
        'MBMSSessionUpdateResponseExtensions',
        'MBMSSessionUpdateFailureIEs',
        'MBMSSessionUpdateFailureExtensions',
        'MBMSSessionStopIEs',
        'MBMSSessionStopExtensions',
        'MBMSSessionStopResponseIEs',
        'MBMSSessionStopResponseExtensions',
        'MBMSUELinkingRequestIEs',
        'LeftMBMSBearerService-ExtIEs',
        'MBMSUELinkingRequestExtensions',
        'MBMSUELinkingResponseIEs',
        'UnsuccessfulLinking-ExtIEs',
        'MBMSUELinkingResponseExtensions',
        'MBMSRegistrationRequestIEs',
        'MBMSRegistrationRequestExtensions',
        'MBMSRegistrationResponseIEs',
        'MBMSRegistrationResponseExtensions',
        'MBMSRegistrationFailureIEs',
        'MBMSRegistrationFailureExtensions',
        'MBMSCNDe-RegistrationRequestIEs',
        'MBMSCNDe-RegistrationRequestExtensions',
        'MBMSCNDe-RegistrationResponseIEs',
        'MBMSCNDe-RegistrationResponseExtensions',
        'MBMSRABEstablishmentIndicationIEs',
        'MBMSRABEstablishmentIndicationExtensions',
        'MBMSRABReleaseRequestIEs',
        'MBMSRABReleaseRequestExtensions',
        'MBMSRABReleaseIEs',
        'MBMSRABReleaseExtensions',
        'MBMSRABReleaseFailureIEs',
        'MBMSRABReleaseFailureExtensions',
        'SRVCC-CSKeysRequestIEs',
        'SRVCC-CSKeysRequestExtensions',
        'SRVCC-CSKeysResponseIEs',
        'SRVCC-CSKeysResponseExtensions',
        'UeRadioCapabilityMatchRequestIEs',
        'UeRadioCapabilityMatchRequestExtensions',
        'UeRadioCapabilityMatchResponseIEs',
        'UeRadioCapabilityMatchResponseExtensions',
        'UeRegistrationQueryRequestIEs',
        'UeRegistrationQueryRequestExtensions',
        'UeRegistrationQueryResponseIEs',
        'UeRegistrationQueryResponseExtensions',
        'RerouteNASRequestIEs',
        'RerouteNASRequestExtensions',
        ]
    _param_ = [
        'RAB-IE-ContainerList',
        'RAB-IE-ContainerPairList',
        'ProtocolError-IE-ContainerList',
        'IuSigConId-IE-ContainerList',
        'DirectTransfer-IE-ContainerList',
        ]
    
    #-----< RAB-IE-ContainerList >-----#
    RAB_IE_ContainerList = SEQ_OF(name='RAB-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< RAB-IE-ContainerPairList >-----#
    RAB_IE_ContainerPairList = SEQ_OF(name='RAB-IE-ContainerPairList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerPairList')), param=True)
    
    #-----< ProtocolError-IE-ContainerList >-----#
    ProtocolError_IE_ContainerList = SEQ_OF(name='ProtocolError-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< IuSigConId-IE-ContainerList >-----#
    IuSigConId_IE_ContainerList = SEQ_OF(name='IuSigConId-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< DirectTransfer-IE-ContainerList >-----#
    DirectTransfer_IE_ContainerList = SEQ_OF(name='DirectTransfer-IE-ContainerList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerList')), param=True)
    
    #-----< Iu-ReleaseCommand >-----#
    Iu_ReleaseCommand = SEQ(name='Iu-ReleaseCommand', mode=MODE_TYPE)
    _Iu_ReleaseCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Iu_ReleaseCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Iu_ReleaseCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____Iu_ReleaseCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Iu_ReleaseCommand_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____Iu_ReleaseCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____Iu_ReleaseCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Iu_ReleaseCommand_protocolIEs__item__id._const_tab = ____Iu_ReleaseCommand_protocolIEs__item__id_tab
    ___Iu_ReleaseCommand_protocolIEs__item__id._const_tab_at = None
    ___Iu_ReleaseCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___Iu_ReleaseCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___Iu_ReleaseCommand_protocolIEs__item__criticality._const_tab = ____Iu_ReleaseCommand_protocolIEs__item__id_tab
    ___Iu_ReleaseCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Iu_ReleaseCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Iu_ReleaseCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___Iu_ReleaseCommand_protocolIEs__item__value._const_tab = ____Iu_ReleaseCommand_protocolIEs__item__id_tab
    ___Iu_ReleaseCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Iu_ReleaseCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __Iu_ReleaseCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Iu_ReleaseCommand_protocolIEs__item__id),
        ('criticality', ___Iu_ReleaseCommand_protocolIEs__item__criticality),
        ('value', ___Iu_ReleaseCommand_protocolIEs__item__value),
        ])
    __Iu_ReleaseCommand_protocolIEs__item_._ext = None
    _Iu_ReleaseCommand_protocolIEs._cont = __Iu_ReleaseCommand_protocolIEs__item_
    _Iu_ReleaseCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Iu_ReleaseCommand_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Iu_ReleaseCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Iu_ReleaseCommand_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Iu_ReleaseCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'End-Of-CSFB')))
    _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Out-Of-UTRAN')))
    _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    ____Iu_ReleaseCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'ignore'), ('Extension', _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Extension', _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Extension', _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Iu_ReleaseCommand_protocolExtensions__item__id._const_tab = ____Iu_ReleaseCommand_protocolExtensions__item__id_tab
    ___Iu_ReleaseCommand_protocolExtensions__item__id._const_tab_at = None
    ___Iu_ReleaseCommand_protocolExtensions__item__id._const_tab_id = 'id'
    ___Iu_ReleaseCommand_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Iu_ReleaseCommand_protocolExtensions__item__criticality._const_tab = ____Iu_ReleaseCommand_protocolExtensions__item__id_tab
    ___Iu_ReleaseCommand_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Iu_ReleaseCommand_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue._const_tab = ____Iu_ReleaseCommand_protocolExtensions__item__id_tab
    ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Iu_ReleaseCommand_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Iu_ReleaseCommand_protocolExtensions__item__id),
        ('criticality', ___Iu_ReleaseCommand_protocolExtensions__item__criticality),
        ('extensionValue', ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue),
        ])
    __Iu_ReleaseCommand_protocolExtensions__item_._ext = None
    _Iu_ReleaseCommand_protocolExtensions._cont = __Iu_ReleaseCommand_protocolExtensions__item_
    _Iu_ReleaseCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Iu_ReleaseCommand._cont = ASN1Dict([
        ('protocolIEs', _Iu_ReleaseCommand_protocolIEs),
        ('protocolExtensions', _Iu_ReleaseCommand_protocolExtensions),
        ])
    Iu_ReleaseCommand._ext = []
    
    #-----< Iu-ReleaseCommandIEs >-----#
    Iu_ReleaseCommandIEs = CLASS(name='Iu-ReleaseCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _Iu_ReleaseCommandIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    Iu_ReleaseCommandIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _Iu_ReleaseCommandIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Iu-ReleaseCommandExtensions >-----#
    Iu_ReleaseCommandExtensions = CLASS(name='Iu-ReleaseCommandExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _Iu_ReleaseCommandExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'End-Of-CSFB')))
    _Iu_ReleaseCommandExtensions_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Out-Of-UTRAN')))
    _Iu_ReleaseCommandExtensions_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    Iu_ReleaseCommandExtensions._val = ASN1Set(rv=[dict([('id', 252), ('criticality', 'ignore'), ('Extension', _Iu_ReleaseCommandExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 254), ('criticality', 'ignore'), ('Extension', _Iu_ReleaseCommandExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Extension', _Iu_ReleaseCommandExtensions_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Iu-ReleaseComplete >-----#
    Iu_ReleaseComplete = SEQ(name='Iu-ReleaseComplete', mode=MODE_TYPE)
    _Iu_ReleaseComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Iu_ReleaseComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Iu_ReleaseComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____Iu_ReleaseComplete_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportList')))
    _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedList-IuRelComp')))
    _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____Iu_ReleaseComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 31), ('criticality', 'ignore'), ('Value', _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Iu_ReleaseComplete_protocolIEs__item__id._const_tab = ____Iu_ReleaseComplete_protocolIEs__item__id_tab
    ___Iu_ReleaseComplete_protocolIEs__item__id._const_tab_at = None
    ___Iu_ReleaseComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___Iu_ReleaseComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___Iu_ReleaseComplete_protocolIEs__item__criticality._const_tab = ____Iu_ReleaseComplete_protocolIEs__item__id_tab
    ___Iu_ReleaseComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Iu_ReleaseComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Iu_ReleaseComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___Iu_ReleaseComplete_protocolIEs__item__value._const_tab = ____Iu_ReleaseComplete_protocolIEs__item__id_tab
    ___Iu_ReleaseComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Iu_ReleaseComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __Iu_ReleaseComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Iu_ReleaseComplete_protocolIEs__item__id),
        ('criticality', ___Iu_ReleaseComplete_protocolIEs__item__criticality),
        ('value', ___Iu_ReleaseComplete_protocolIEs__item__value),
        ])
    __Iu_ReleaseComplete_protocolIEs__item_._ext = None
    _Iu_ReleaseComplete_protocolIEs._cont = __Iu_ReleaseComplete_protocolIEs__item_
    _Iu_ReleaseComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Iu_ReleaseComplete_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Iu_ReleaseComplete_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Iu_ReleaseComplete_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Iu_ReleaseComplete_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseComplete_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseComplete_protocolExtensions__item__id._const_tab = ____Iu_ReleaseComplete_protocolExtensions__item__id_tab
    ___Iu_ReleaseComplete_protocolExtensions__item__id._const_tab_at = None
    ___Iu_ReleaseComplete_protocolExtensions__item__id._const_tab_id = 'id'
    ___Iu_ReleaseComplete_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Iu_ReleaseComplete_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseComplete_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseComplete_protocolExtensions__item__criticality._const_tab = ____Iu_ReleaseComplete_protocolExtensions__item__criticality_tab
    ___Iu_ReleaseComplete_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Iu_ReleaseComplete_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Iu_ReleaseComplete_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseComplete_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue._const_tab = ____Iu_ReleaseComplete_protocolExtensions__item__extensionValue_tab
    ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Iu_ReleaseComplete_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Iu_ReleaseComplete_protocolExtensions__item__id),
        ('criticality', ___Iu_ReleaseComplete_protocolExtensions__item__criticality),
        ('extensionValue', ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue),
        ])
    __Iu_ReleaseComplete_protocolExtensions__item_._ext = None
    _Iu_ReleaseComplete_protocolExtensions._cont = __Iu_ReleaseComplete_protocolExtensions__item_
    _Iu_ReleaseComplete_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Iu_ReleaseComplete._cont = ASN1Dict([
        ('protocolIEs', _Iu_ReleaseComplete_protocolIEs),
        ('protocolExtensions', _Iu_ReleaseComplete_protocolExtensions),
        ])
    Iu_ReleaseComplete._ext = []
    
    #-----< Iu-ReleaseCompleteIEs >-----#
    Iu_ReleaseCompleteIEs = CLASS(name='Iu-ReleaseCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _Iu_ReleaseCompleteIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportList')))
    _Iu_ReleaseCompleteIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedList-IuRelComp')))
    _Iu_ReleaseCompleteIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    Iu_ReleaseCompleteIEs._val = ASN1Set(rv=[dict([('id', 31), ('criticality', 'ignore'), ('Value', _Iu_ReleaseCompleteIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 44), ('criticality', 'ignore'), ('Value', _Iu_ReleaseCompleteIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _Iu_ReleaseCompleteIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataVolumeReportList >-----#
    RAB_DataVolumeReportList = SEQ_OF(name='RAB-DataVolumeReportList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_DataVolumeReportList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_DataVolumeReportList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_DataVolumeReportList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_DataVolumeReportList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_DataVolumeReportList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportItem')))
    ____RAB_DataVolumeReportList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'ignore'), ('Value', _____RAB_DataVolumeReportList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportList__item___item__id._const_tab = ____RAB_DataVolumeReportList__item___item__id_tab
    ___RAB_DataVolumeReportList__item___item__id._const_tab_at = None
    ___RAB_DataVolumeReportList__item___item__id._const_tab_id = 'id'
    ___RAB_DataVolumeReportList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_DataVolumeReportList__item___item__criticality._const_tab = ____RAB_DataVolumeReportList__item___item__id_tab
    ___RAB_DataVolumeReportList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_DataVolumeReportList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_DataVolumeReportList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_DataVolumeReportList__item___item__value._const_tab = ____RAB_DataVolumeReportList__item___item__id_tab
    ___RAB_DataVolumeReportList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_DataVolumeReportList__item___item__value._const_tab_id = 'Value'
    __RAB_DataVolumeReportList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_DataVolumeReportList__item___item__id),
        ('criticality', ___RAB_DataVolumeReportList__item___item__criticality),
        ('value', ___RAB_DataVolumeReportList__item___item__value),
        ])
    __RAB_DataVolumeReportList__item___item_._ext = None
    _RAB_DataVolumeReportList__item_._cont = __RAB_DataVolumeReportList__item___item_
    _RAB_DataVolumeReportList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_DataVolumeReportList._cont = _RAB_DataVolumeReportList__item_
    RAB_DataVolumeReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-DataVolumeReportItemIEs >-----#
    RAB_DataVolumeReportItemIEs = CLASS(name='RAB-DataVolumeReportItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_DataVolumeReportItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportItem')))
    RAB_DataVolumeReportItemIEs._val = ASN1Set(rv=[dict([('id', 30), ('criticality', 'ignore'), ('Value', _RAB_DataVolumeReportItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataVolumeReportItem >-----#
    RAB_DataVolumeReportItem = SEQ(name='RAB-DataVolumeReportItem', mode=MODE_TYPE)
    _RAB_DataVolumeReportItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_DataVolumeReportItem_dl_UnsuccessfullyTransmittedDataVolume = SEQ_OF(name='dl-UnsuccessfullyTransmittedDataVolume', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeList')), opt=True)
    _RAB_DataVolumeReportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_DataVolumeReportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_DataVolumeReportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportItem_iE_Extensions__item__id._const_tab = ____RAB_DataVolumeReportItem_iE_Extensions__item__id_tab
    ___RAB_DataVolumeReportItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_DataVolumeReportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality._const_tab = ____RAB_DataVolumeReportItem_iE_Extensions__item__criticality_tab
    ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue_tab
    ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_DataVolumeReportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_DataVolumeReportItem_iE_Extensions__item__id),
        ('criticality', ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_DataVolumeReportItem_iE_Extensions__item_._ext = None
    _RAB_DataVolumeReportItem_iE_Extensions._cont = __RAB_DataVolumeReportItem_iE_Extensions__item_
    _RAB_DataVolumeReportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_DataVolumeReportItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_DataVolumeReportItem_rAB_ID),
        ('dl-UnsuccessfullyTransmittedDataVolume', _RAB_DataVolumeReportItem_dl_UnsuccessfullyTransmittedDataVolume),
        ('iE-Extensions', _RAB_DataVolumeReportItem_iE_Extensions),
        ])
    RAB_DataVolumeReportItem._ext = []
    
    #-----< RAB-DataVolumeReportItem-ExtIEs >-----#
    RAB_DataVolumeReportItem_ExtIEs = CLASS(name='RAB-DataVolumeReportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_DataVolumeReportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleasedList-IuRelComp >-----#
    RAB_ReleasedList_IuRelComp = SEQ_OF(name='RAB-ReleasedList-IuRelComp', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ReleasedList_IuRelComp__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ReleasedList_IuRelComp__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ReleasedList_IuRelComp__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_ReleasedList_IuRelComp__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ReleasedList_IuRelComp__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedItem-IuRelComp')))
    ____RAB_ReleasedList_IuRelComp__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 87), ('criticality', 'ignore'), ('Value', _____RAB_ReleasedList_IuRelComp__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ReleasedList_IuRelComp__item___item__id._const_tab = ____RAB_ReleasedList_IuRelComp__item___item__id_tab
    ___RAB_ReleasedList_IuRelComp__item___item__id._const_tab_at = None
    ___RAB_ReleasedList_IuRelComp__item___item__id._const_tab_id = 'id'
    ___RAB_ReleasedList_IuRelComp__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_ReleasedList_IuRelComp__item___item__criticality._const_tab = ____RAB_ReleasedList_IuRelComp__item___item__id_tab
    ___RAB_ReleasedList_IuRelComp__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ReleasedList_IuRelComp__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_ReleasedList_IuRelComp__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_ReleasedList_IuRelComp__item___item__value._const_tab = ____RAB_ReleasedList_IuRelComp__item___item__id_tab
    ___RAB_ReleasedList_IuRelComp__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_ReleasedList_IuRelComp__item___item__value._const_tab_id = 'Value'
    __RAB_ReleasedList_IuRelComp__item___item_._cont = ASN1Dict([
        ('id', ___RAB_ReleasedList_IuRelComp__item___item__id),
        ('criticality', ___RAB_ReleasedList_IuRelComp__item___item__criticality),
        ('value', ___RAB_ReleasedList_IuRelComp__item___item__value),
        ])
    __RAB_ReleasedList_IuRelComp__item___item_._ext = None
    _RAB_ReleasedList_IuRelComp__item_._cont = __RAB_ReleasedList_IuRelComp__item___item_
    _RAB_ReleasedList_IuRelComp__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ReleasedList_IuRelComp._cont = _RAB_ReleasedList_IuRelComp__item_
    RAB_ReleasedList_IuRelComp._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ReleasedItem-IuRelComp-IEs >-----#
    RAB_ReleasedItem_IuRelComp_IEs = CLASS(name='RAB-ReleasedItem-IuRelComp-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ReleasedItem_IuRelComp_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedItem-IuRelComp')))
    RAB_ReleasedItem_IuRelComp_IEs._val = ASN1Set(rv=[dict([('id', 87), ('criticality', 'ignore'), ('Value', _RAB_ReleasedItem_IuRelComp_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleasedItem-IuRelComp >-----#
    RAB_ReleasedItem_IuRelComp = SEQ(name='RAB-ReleasedItem-IuRelComp', mode=MODE_TYPE)
    _RAB_ReleasedItem_IuRelComp_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ReleasedItem_IuRelComp_dL_GTP_PDU_SequenceNumber = INT(name='dL-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ReleasedItem_IuRelComp_uL_GTP_PDU_SequenceNumber = INT(name='uL-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ReleasedItem_IuRelComp_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ReleasedItem_IuRelComp_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id._const_tab = ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id_tab
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality._const_tab = ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality_tab
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue._const_tab = ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue_tab
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_ReleasedItem_IuRelComp_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id),
        ('criticality', ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue),
        ])
    __RAB_ReleasedItem_IuRelComp_iE_Extensions__item_._ext = None
    _RAB_ReleasedItem_IuRelComp_iE_Extensions._cont = __RAB_ReleasedItem_IuRelComp_iE_Extensions__item_
    _RAB_ReleasedItem_IuRelComp_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ReleasedItem_IuRelComp._cont = ASN1Dict([
        ('rAB-ID', _RAB_ReleasedItem_IuRelComp_rAB_ID),
        ('dL-GTP-PDU-SequenceNumber', _RAB_ReleasedItem_IuRelComp_dL_GTP_PDU_SequenceNumber),
        ('uL-GTP-PDU-SequenceNumber', _RAB_ReleasedItem_IuRelComp_uL_GTP_PDU_SequenceNumber),
        ('iE-Extensions', _RAB_ReleasedItem_IuRelComp_iE_Extensions),
        ])
    RAB_ReleasedItem_IuRelComp._ext = []
    
    #-----< RAB-ReleasedItem-IuRelComp-ExtIEs >-----#
    RAB_ReleasedItem_IuRelComp_ExtIEs = CLASS(name='RAB-ReleasedItem-IuRelComp-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ReleasedItem_IuRelComp_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Iu-ReleaseCompleteExtensions >-----#
    Iu_ReleaseCompleteExtensions = CLASS(name='Iu-ReleaseCompleteExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Iu_ReleaseCompleteExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationRequired >-----#
    RelocationRequired = SEQ(name='RelocationRequired', mode=MODE_TYPE)
    _RelocationRequired_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationRequired_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationRequired_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RelocationRequired_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RelocationType')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceID')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetID')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClassmarkInformation2')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClassmarkInformation3')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Source-ToTarget-TransparentContainer')))
    _____RelocationRequired_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'OldBSS-ToNewBSS-Information')))
    ____RelocationRequired_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 56), ('criticality', 'reject'), ('Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 60), ('criticality', 'ignore'), ('Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 62), ('criticality', 'reject'), ('Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'reject'), ('Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_4), ('presence', 'conditional')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_5), ('presence', 'conditional')]), dict([('id', 61), ('criticality', 'reject'), ('Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_6), ('presence', 'conditional')]), dict([('id', 20), ('criticality', 'ignore'), ('Value', _____RelocationRequired_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationRequired_protocolIEs__item__id._const_tab = ____RelocationRequired_protocolIEs__item__id_tab
    ___RelocationRequired_protocolIEs__item__id._const_tab_at = None
    ___RelocationRequired_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationRequired_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RelocationRequired_protocolIEs__item__criticality._const_tab = ____RelocationRequired_protocolIEs__item__id_tab
    ___RelocationRequired_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationRequired_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationRequired_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RelocationRequired_protocolIEs__item__value._const_tab = ____RelocationRequired_protocolIEs__item__id_tab
    ___RelocationRequired_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationRequired_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationRequired_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationRequired_protocolIEs__item__id),
        ('criticality', ___RelocationRequired_protocolIEs__item__criticality),
        ('value', ___RelocationRequired_protocolIEs__item__value),
        ])
    __RelocationRequired_protocolIEs__item_._ext = None
    _RelocationRequired_protocolIEs._cont = __RelocationRequired_protocolIEs__item_
    _RelocationRequired_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationRequired_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationRequired_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationRequired_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationRequired_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceBSS-ToTargetBSS-TransparentContainer')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-HO-Indication')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-HO-Indication')))
    _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration-For-Relocation')))
    ____RelocationRequired_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 108), ('criticality', 'ignore'), ('Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'reject'), ('Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'reject'), ('Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 235), ('criticality', 'reject'), ('Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 259), ('criticality', 'reject'), ('Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 293), ('criticality', 'ignore'), ('Extension', _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationRequired_protocolExtensions__item__id._const_tab = ____RelocationRequired_protocolExtensions__item__id_tab
    ___RelocationRequired_protocolExtensions__item__id._const_tab_at = None
    ___RelocationRequired_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationRequired_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RelocationRequired_protocolExtensions__item__criticality._const_tab = ____RelocationRequired_protocolExtensions__item__id_tab
    ___RelocationRequired_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationRequired_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationRequired_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RelocationRequired_protocolExtensions__item__extensionValue._const_tab = ____RelocationRequired_protocolExtensions__item__id_tab
    ___RelocationRequired_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationRequired_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationRequired_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationRequired_protocolExtensions__item__id),
        ('criticality', ___RelocationRequired_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationRequired_protocolExtensions__item__extensionValue),
        ])
    __RelocationRequired_protocolExtensions__item_._ext = None
    _RelocationRequired_protocolExtensions._cont = __RelocationRequired_protocolExtensions__item_
    _RelocationRequired_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationRequired._cont = ASN1Dict([
        ('protocolIEs', _RelocationRequired_protocolIEs),
        ('protocolExtensions', _RelocationRequired_protocolExtensions),
        ])
    RelocationRequired._ext = []
    
    #-----< RelocationRequiredIEs >-----#
    RelocationRequiredIEs = CLASS(name='RelocationRequiredIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationRequiredIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RelocationType')))
    _RelocationRequiredIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RelocationRequiredIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceID')))
    _RelocationRequiredIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetID')))
    _RelocationRequiredIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClassmarkInformation2')))
    _RelocationRequiredIEs_val_Value_5 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClassmarkInformation3')))
    _RelocationRequiredIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Source-ToTarget-TransparentContainer')))
    _RelocationRequiredIEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'OldBSS-ToNewBSS-Information')))
    RelocationRequiredIEs._val = ASN1Set(rv=[dict([('id', 56), ('criticality', 'reject'), ('Value', _RelocationRequiredIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _RelocationRequiredIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 60), ('criticality', 'ignore'), ('Value', _RelocationRequiredIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 62), ('criticality', 'reject'), ('Value', _RelocationRequiredIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 7), ('criticality', 'reject'), ('Value', _RelocationRequiredIEs_val_Value_4), ('presence', 'conditional')]), dict([('id', 8), ('criticality', 'ignore'), ('Value', _RelocationRequiredIEs_val_Value_5), ('presence', 'conditional')]), dict([('id', 61), ('criticality', 'reject'), ('Value', _RelocationRequiredIEs_val_Value_6), ('presence', 'conditional')]), dict([('id', 20), ('criticality', 'ignore'), ('Value', _RelocationRequiredIEs_val_Value_7), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationRequiredExtensions >-----#
    RelocationRequiredExtensions = CLASS(name='RelocationRequiredExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationRequiredExtensions_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    _RelocationRequiredExtensions_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceBSS-ToTargetBSS-TransparentContainer')))
    _RelocationRequiredExtensions_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-HO-Indication')))
    _RelocationRequiredExtensions_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _RelocationRequiredExtensions_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _RelocationRequiredExtensions_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-HO-Indication')))
    _RelocationRequiredExtensions_val_Extension_6 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration-For-Relocation')))
    RelocationRequiredExtensions._val = ASN1Set(rv=[dict([('id', 108), ('criticality', 'ignore'), ('Extension', _RelocationRequiredExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 161), ('criticality', 'ignore'), ('Extension', _RelocationRequiredExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 226), ('criticality', 'reject'), ('Extension', _RelocationRequiredExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'reject'), ('Extension', _RelocationRequiredExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 235), ('criticality', 'reject'), ('Extension', _RelocationRequiredExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 259), ('criticality', 'reject'), ('Extension', _RelocationRequiredExtensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 293), ('criticality', 'ignore'), ('Extension', _RelocationRequiredExtensions_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCommand >-----#
    RelocationCommand = SEQ(name='RelocationCommand', mode=MODE_TYPE)
    _RelocationCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RelocationCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationCommand_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Target-ToSource-TransparentContainer')))
    _____RelocationCommand_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'L3-Information')))
    _____RelocationCommand_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-RelocationReleaseList')))
    _____RelocationCommand_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList')))
    _____RelocationCommand_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RelocationCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 63), ('criticality', 'reject'), ('Value', _____RelocationCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 14), ('criticality', 'ignore'), ('Value', _____RelocationCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 46), ('criticality', 'ignore'), ('Value', _____RelocationCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 28), ('criticality', 'ignore'), ('Value', _____RelocationCommand_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____RelocationCommand_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationCommand_protocolIEs__item__id._const_tab = ____RelocationCommand_protocolIEs__item__id_tab
    ___RelocationCommand_protocolIEs__item__id._const_tab_at = None
    ___RelocationCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RelocationCommand_protocolIEs__item__criticality._const_tab = ____RelocationCommand_protocolIEs__item__id_tab
    ___RelocationCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RelocationCommand_protocolIEs__item__value._const_tab = ____RelocationCommand_protocolIEs__item__id_tab
    ___RelocationCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationCommand_protocolIEs__item__id),
        ('criticality', ___RelocationCommand_protocolIEs__item__criticality),
        ('value', ___RelocationCommand_protocolIEs__item__value),
        ])
    __RelocationCommand_protocolIEs__item_._ext = None
    _RelocationCommand_protocolIEs._cont = __RelocationCommand_protocolIEs__item_
    _RelocationCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationCommand_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationCommand_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformation-TransparentContainer')))
    _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetBSS-ToSourceBSS-TransparentContainer')))
    _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-Information')))
    ____RelocationCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'ignore'), ('Extension', _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 162), ('criticality', 'ignore'), ('Extension', _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 227), ('criticality', 'reject'), ('Extension', _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 260), ('criticality', 'reject'), ('Extension', _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationCommand_protocolExtensions__item__id._const_tab = ____RelocationCommand_protocolExtensions__item__id_tab
    ___RelocationCommand_protocolExtensions__item__id._const_tab_at = None
    ___RelocationCommand_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationCommand_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RelocationCommand_protocolExtensions__item__criticality._const_tab = ____RelocationCommand_protocolExtensions__item__id_tab
    ___RelocationCommand_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationCommand_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationCommand_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RelocationCommand_protocolExtensions__item__extensionValue._const_tab = ____RelocationCommand_protocolExtensions__item__id_tab
    ___RelocationCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationCommand_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationCommand_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationCommand_protocolExtensions__item__id),
        ('criticality', ___RelocationCommand_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationCommand_protocolExtensions__item__extensionValue),
        ])
    __RelocationCommand_protocolExtensions__item_._ext = None
    _RelocationCommand_protocolExtensions._cont = __RelocationCommand_protocolExtensions__item_
    _RelocationCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationCommand._cont = ASN1Dict([
        ('protocolIEs', _RelocationCommand_protocolIEs),
        ('protocolExtensions', _RelocationCommand_protocolExtensions),
        ])
    RelocationCommand._ext = []
    
    #-----< RelocationCommandIEs >-----#
    RelocationCommandIEs = CLASS(name='RelocationCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationCommandIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Target-ToSource-TransparentContainer')))
    _RelocationCommandIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'L3-Information')))
    _RelocationCommandIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-RelocationReleaseList')))
    _RelocationCommandIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList')))
    _RelocationCommandIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RelocationCommandIEs._val = ASN1Set(rv=[dict([('id', 63), ('criticality', 'reject'), ('Value', _RelocationCommandIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 14), ('criticality', 'ignore'), ('Value', _RelocationCommandIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 46), ('criticality', 'ignore'), ('Value', _RelocationCommandIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 28), ('criticality', 'ignore'), ('Value', _RelocationCommandIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _RelocationCommandIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-RelocationReleaseList >-----#
    RAB_RelocationReleaseList = SEQ_OF(name='RAB-RelocationReleaseList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_RelocationReleaseList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_RelocationReleaseList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_RelocationReleaseList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_RelocationReleaseList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_RelocationReleaseList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-RelocationReleaseItem')))
    ____RAB_RelocationReleaseList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _____RAB_RelocationReleaseList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_RelocationReleaseList__item___item__id._const_tab = ____RAB_RelocationReleaseList__item___item__id_tab
    ___RAB_RelocationReleaseList__item___item__id._const_tab_at = None
    ___RAB_RelocationReleaseList__item___item__id._const_tab_id = 'id'
    ___RAB_RelocationReleaseList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_RelocationReleaseList__item___item__criticality._const_tab = ____RAB_RelocationReleaseList__item___item__id_tab
    ___RAB_RelocationReleaseList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_RelocationReleaseList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_RelocationReleaseList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_RelocationReleaseList__item___item__value._const_tab = ____RAB_RelocationReleaseList__item___item__id_tab
    ___RAB_RelocationReleaseList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_RelocationReleaseList__item___item__value._const_tab_id = 'Value'
    __RAB_RelocationReleaseList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_RelocationReleaseList__item___item__id),
        ('criticality', ___RAB_RelocationReleaseList__item___item__criticality),
        ('value', ___RAB_RelocationReleaseList__item___item__value),
        ])
    __RAB_RelocationReleaseList__item___item_._ext = None
    _RAB_RelocationReleaseList__item_._cont = __RAB_RelocationReleaseList__item___item_
    _RAB_RelocationReleaseList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_RelocationReleaseList._cont = _RAB_RelocationReleaseList__item_
    RAB_RelocationReleaseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-RelocationReleaseItemIEs >-----#
    RAB_RelocationReleaseItemIEs = CLASS(name='RAB-RelocationReleaseItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_RelocationReleaseItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-RelocationReleaseItem')))
    RAB_RelocationReleaseItemIEs._val = ASN1Set(rv=[dict([('id', 45), ('criticality', 'ignore'), ('Value', _RAB_RelocationReleaseItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-RelocationReleaseItem >-----#
    RAB_RelocationReleaseItem = SEQ(name='RAB-RelocationReleaseItem', mode=MODE_TYPE)
    _RAB_RelocationReleaseItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_RelocationReleaseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_RelocationReleaseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_RelocationReleaseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_RelocationReleaseItem_iE_Extensions__item__id._const_tab = ____RAB_RelocationReleaseItem_iE_Extensions__item__id_tab
    ___RAB_RelocationReleaseItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_RelocationReleaseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality._const_tab = ____RAB_RelocationReleaseItem_iE_Extensions__item__criticality_tab
    ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue_tab
    ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_RelocationReleaseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_RelocationReleaseItem_iE_Extensions__item__id),
        ('criticality', ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_RelocationReleaseItem_iE_Extensions__item_._ext = None
    _RAB_RelocationReleaseItem_iE_Extensions._cont = __RAB_RelocationReleaseItem_iE_Extensions__item_
    _RAB_RelocationReleaseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_RelocationReleaseItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_RelocationReleaseItem_rAB_ID),
        ('iE-Extensions', _RAB_RelocationReleaseItem_iE_Extensions),
        ])
    RAB_RelocationReleaseItem._ext = []
    
    #-----< RAB-RelocationReleaseItem-ExtIEs >-----#
    RAB_RelocationReleaseItem_ExtIEs = CLASS(name='RAB-RelocationReleaseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_RelocationReleaseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-DataForwardingList >-----#
    RAB_DataForwardingList = SEQ_OF(name='RAB-DataForwardingList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_DataForwardingList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_DataForwardingList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_DataForwardingList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_DataForwardingList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_DataForwardingList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingItem')))
    ____RAB_DataForwardingList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'ignore'), ('Value', _____RAB_DataForwardingList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_DataForwardingList__item___item__id._const_tab = ____RAB_DataForwardingList__item___item__id_tab
    ___RAB_DataForwardingList__item___item__id._const_tab_at = None
    ___RAB_DataForwardingList__item___item__id._const_tab_id = 'id'
    ___RAB_DataForwardingList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_DataForwardingList__item___item__criticality._const_tab = ____RAB_DataForwardingList__item___item__id_tab
    ___RAB_DataForwardingList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_DataForwardingList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_DataForwardingList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_DataForwardingList__item___item__value._const_tab = ____RAB_DataForwardingList__item___item__id_tab
    ___RAB_DataForwardingList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_DataForwardingList__item___item__value._const_tab_id = 'Value'
    __RAB_DataForwardingList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_DataForwardingList__item___item__id),
        ('criticality', ___RAB_DataForwardingList__item___item__criticality),
        ('value', ___RAB_DataForwardingList__item___item__value),
        ])
    __RAB_DataForwardingList__item___item_._ext = None
    _RAB_DataForwardingList__item_._cont = __RAB_DataForwardingList__item___item_
    _RAB_DataForwardingList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_DataForwardingList._cont = _RAB_DataForwardingList__item_
    RAB_DataForwardingList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-DataForwardingItemIEs >-----#
    RAB_DataForwardingItemIEs = CLASS(name='RAB-DataForwardingItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_DataForwardingItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingItem')))
    RAB_DataForwardingItemIEs._val = ASN1Set(rv=[dict([('id', 26), ('criticality', 'ignore'), ('Value', _RAB_DataForwardingItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataForwardingItem >-----#
    RAB_DataForwardingItem = SEQ(name='RAB-DataForwardingItem', mode=MODE_TYPE)
    _RAB_DataForwardingItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_DataForwardingItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _RAB_DataForwardingItem_iuTransportAssociation = CHOICE(name='iuTransportAssociation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    _RAB_DataForwardingItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_DataForwardingItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_DataForwardingItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_DataForwardingItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    ____RAB_DataForwardingItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 67), ('criticality', 'ignore'), ('Extension', _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Extension', _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_DataForwardingItem_iE_Extensions__item__id._const_tab = ____RAB_DataForwardingItem_iE_Extensions__item__id_tab
    ___RAB_DataForwardingItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_DataForwardingItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_DataForwardingItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_DataForwardingItem_iE_Extensions__item__criticality._const_tab = ____RAB_DataForwardingItem_iE_Extensions__item__id_tab
    ___RAB_DataForwardingItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_DataForwardingItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_DataForwardingItem_iE_Extensions__item__id_tab
    ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_DataForwardingItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_DataForwardingItem_iE_Extensions__item__id),
        ('criticality', ___RAB_DataForwardingItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_DataForwardingItem_iE_Extensions__item_._ext = None
    _RAB_DataForwardingItem_iE_Extensions._cont = __RAB_DataForwardingItem_iE_Extensions__item_
    _RAB_DataForwardingItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_DataForwardingItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_DataForwardingItem_rAB_ID),
        ('transportLayerAddress', _RAB_DataForwardingItem_transportLayerAddress),
        ('iuTransportAssociation', _RAB_DataForwardingItem_iuTransportAssociation),
        ('iE-Extensions', _RAB_DataForwardingItem_iE_Extensions),
        ])
    RAB_DataForwardingItem._ext = []
    
    #-----< RAB-DataForwardingItem-ExtIEs >-----#
    RAB_DataForwardingItem_ExtIEs = CLASS(name='RAB-DataForwardingItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_DataForwardingItem_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _RAB_DataForwardingItem_ExtIEs_val_Extension_1 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    RAB_DataForwardingItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 67), ('criticality', 'ignore'), ('Extension', _RAB_DataForwardingItem_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Extension', _RAB_DataForwardingItem_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCommandExtensions >-----#
    RelocationCommandExtensions = CLASS(name='RelocationCommandExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationCommandExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformation-TransparentContainer')))
    _RelocationCommandExtensions_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetBSS-ToSourceBSS-TransparentContainer')))
    _RelocationCommandExtensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _RelocationCommandExtensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-Information')))
    RelocationCommandExtensions._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'ignore'), ('Extension', _RelocationCommandExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 162), ('criticality', 'ignore'), ('Extension', _RelocationCommandExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 227), ('criticality', 'reject'), ('Extension', _RelocationCommandExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 260), ('criticality', 'reject'), ('Extension', _RelocationCommandExtensions_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationPreparationFailure >-----#
    RelocationPreparationFailure = SEQ(name='RelocationPreparationFailure', mode=MODE_TYPE)
    _RelocationPreparationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationPreparationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationPreparationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RelocationPreparationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RelocationPreparationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationPreparationFailure_protocolIEs__item__id._const_tab = ____RelocationPreparationFailure_protocolIEs__item__id_tab
    ___RelocationPreparationFailure_protocolIEs__item__id._const_tab_at = None
    ___RelocationPreparationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationPreparationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RelocationPreparationFailure_protocolIEs__item__criticality._const_tab = ____RelocationPreparationFailure_protocolIEs__item__id_tab
    ___RelocationPreparationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationPreparationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationPreparationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RelocationPreparationFailure_protocolIEs__item__value._const_tab = ____RelocationPreparationFailure_protocolIEs__item__id_tab
    ___RelocationPreparationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationPreparationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationPreparationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationPreparationFailure_protocolIEs__item__id),
        ('criticality', ___RelocationPreparationFailure_protocolIEs__item__criticality),
        ('value', ___RelocationPreparationFailure_protocolIEs__item__value),
        ])
    __RelocationPreparationFailure_protocolIEs__item_._ext = None
    _RelocationPreparationFailure_protocolIEs._cont = __RelocationPreparationFailure_protocolIEs__item_
    _RelocationPreparationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationPreparationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationPreparationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationPreparationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationPreparationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationPreparationFailure_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformation-TransparentContainer')))
    ____RelocationPreparationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'ignore'), ('Extension', _____RelocationPreparationFailure_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationPreparationFailure_protocolExtensions__item__id._const_tab = ____RelocationPreparationFailure_protocolExtensions__item__id_tab
    ___RelocationPreparationFailure_protocolExtensions__item__id._const_tab_at = None
    ___RelocationPreparationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationPreparationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RelocationPreparationFailure_protocolExtensions__item__criticality._const_tab = ____RelocationPreparationFailure_protocolExtensions__item__id_tab
    ___RelocationPreparationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationPreparationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationPreparationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RelocationPreparationFailure_protocolExtensions__item__extensionValue._const_tab = ____RelocationPreparationFailure_protocolExtensions__item__id_tab
    ___RelocationPreparationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationPreparationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationPreparationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationPreparationFailure_protocolExtensions__item__id),
        ('criticality', ___RelocationPreparationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationPreparationFailure_protocolExtensions__item__extensionValue),
        ])
    __RelocationPreparationFailure_protocolExtensions__item_._ext = None
    _RelocationPreparationFailure_protocolExtensions._cont = __RelocationPreparationFailure_protocolExtensions__item_
    _RelocationPreparationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationPreparationFailure._cont = ASN1Dict([
        ('protocolIEs', _RelocationPreparationFailure_protocolIEs),
        ('protocolExtensions', _RelocationPreparationFailure_protocolExtensions),
        ])
    RelocationPreparationFailure._ext = []
    
    #-----< RelocationPreparationFailureIEs >-----#
    RelocationPreparationFailureIEs = CLASS(name='RelocationPreparationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationPreparationFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RelocationPreparationFailureIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RelocationPreparationFailureIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _RelocationPreparationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _RelocationPreparationFailureIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationPreparationFailureExtensions >-----#
    RelocationPreparationFailureExtensions = CLASS(name='RelocationPreparationFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationPreparationFailureExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformation-TransparentContainer')))
    RelocationPreparationFailureExtensions._val = ASN1Set(rv=[dict([('id', 99), ('criticality', 'ignore'), ('Extension', _RelocationPreparationFailureExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationRequest >-----#
    RelocationRequest = SEQ(name='RelocationRequest', mode=MODE_TYPE)
    _RelocationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RelocationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceRNC-ToTargetRNC-TransparentContainer')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-RelocReq')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _____RelocationRequest_protocolIEs__item__id_tab_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    ____RelocationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 23), ('criticality', 'ignore'), ('Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 61), ('criticality', 'reject'), ('Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'reject'), ('Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'ignore'), ('Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Value', _____RelocationRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RelocationRequest_protocolIEs__item__id._const_tab = ____RelocationRequest_protocolIEs__item__id_tab
    ___RelocationRequest_protocolIEs__item__id._const_tab_at = None
    ___RelocationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RelocationRequest_protocolIEs__item__criticality._const_tab = ____RelocationRequest_protocolIEs__item__id_tab
    ___RelocationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RelocationRequest_protocolIEs__item__value._const_tab = ____RelocationRequest_protocolIEs__item__id_tab
    ___RelocationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationRequest_protocolIEs__item__id),
        ('criticality', ___RelocationRequest_protocolIEs__item__criticality),
        ('value', ___RelocationRequest_protocolIEs__item__value),
        ])
    __RelocationRequest_protocolIEs__item_._ext = None
    _RelocationRequest_protocolIEs._cont = __RelocationRequest_protocolIEs__item_
    _RelocationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CNMBMSLinkingInformation')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_6 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_8 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_9 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PowerSavingIndicator')))
    _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration-For-Relocation')))
    ____RelocationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'reject'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'ignore'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 133), ('criticality', 'ignore'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 233), ('criticality', 'ignore'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'reject'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 239), ('criticality', 'ignore'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 261), ('criticality', 'ignore'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 289), ('criticality', 'ignore'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 293), ('criticality', 'ignore'), ('Extension', _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationRequest_protocolExtensions__item__id._const_tab = ____RelocationRequest_protocolExtensions__item__id_tab
    ___RelocationRequest_protocolExtensions__item__id._const_tab_at = None
    ___RelocationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RelocationRequest_protocolExtensions__item__criticality._const_tab = ____RelocationRequest_protocolExtensions__item__id_tab
    ___RelocationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RelocationRequest_protocolExtensions__item__extensionValue._const_tab = ____RelocationRequest_protocolExtensions__item__id_tab
    ___RelocationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationRequest_protocolExtensions__item__id),
        ('criticality', ___RelocationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationRequest_protocolExtensions__item__extensionValue),
        ])
    __RelocationRequest_protocolExtensions__item_._ext = None
    _RelocationRequest_protocolExtensions._cont = __RelocationRequest_protocolExtensions__item_
    _RelocationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationRequest._cont = ASN1Dict([
        ('protocolIEs', _RelocationRequest_protocolIEs),
        ('protocolExtensions', _RelocationRequest_protocolExtensions),
        ])
    RelocationRequest._ext = []
    
    #-----< RelocationRequestIEs >-----#
    RelocationRequestIEs = CLASS(name='RelocationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationRequestIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _RelocationRequestIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RelocationRequestIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _RelocationRequestIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceRNC-ToTargetRNC-TransparentContainer')))
    _RelocationRequestIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-RelocReq')))
    _RelocationRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _RelocationRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _RelocationRequestIEs_val_Value_7 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    RelocationRequestIEs._val = ASN1Set(rv=[dict([('id', 23), ('criticality', 'ignore'), ('Value', _RelocationRequestIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _RelocationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _RelocationRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 61), ('criticality', 'reject'), ('Value', _RelocationRequestIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 49), ('criticality', 'reject'), ('Value', _RelocationRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 12), ('criticality', 'ignore'), ('Value', _RelocationRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'ignore'), ('Value', _RelocationRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 79), ('criticality', 'ignore'), ('Value', _RelocationRequestIEs_val_Value_7), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-RelocReq >-----#
    RAB_SetupList_RelocReq = SEQ_OF(name='RAB-SetupList-RelocReq', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_RelocReq__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_RelocReq__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_RelocReq__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_SetupList_RelocReq__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_RelocReq__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-RelocReq')))
    ____RAB_SetupList_RelocReq__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'reject'), ('Value', _____RAB_SetupList_RelocReq__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_RelocReq__item___item__id._const_tab = ____RAB_SetupList_RelocReq__item___item__id_tab
    ___RAB_SetupList_RelocReq__item___item__id._const_tab_at = None
    ___RAB_SetupList_RelocReq__item___item__id._const_tab_id = 'id'
    ___RAB_SetupList_RelocReq__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_SetupList_RelocReq__item___item__criticality._const_tab = ____RAB_SetupList_RelocReq__item___item__id_tab
    ___RAB_SetupList_RelocReq__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupList_RelocReq__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupList_RelocReq__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_SetupList_RelocReq__item___item__value._const_tab = ____RAB_SetupList_RelocReq__item___item__id_tab
    ___RAB_SetupList_RelocReq__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_SetupList_RelocReq__item___item__value._const_tab_id = 'Value'
    __RAB_SetupList_RelocReq__item___item_._cont = ASN1Dict([
        ('id', ___RAB_SetupList_RelocReq__item___item__id),
        ('criticality', ___RAB_SetupList_RelocReq__item___item__criticality),
        ('value', ___RAB_SetupList_RelocReq__item___item__value),
        ])
    __RAB_SetupList_RelocReq__item___item_._ext = None
    _RAB_SetupList_RelocReq__item_._cont = __RAB_SetupList_RelocReq__item___item_
    _RAB_SetupList_RelocReq__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_RelocReq._cont = _RAB_SetupList_RelocReq__item_
    RAB_SetupList_RelocReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-RelocReq-IEs >-----#
    RAB_SetupItem_RelocReq_IEs = CLASS(name='RAB-SetupItem-RelocReq-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_RelocReq_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-RelocReq')))
    RAB_SetupItem_RelocReq_IEs._val = ASN1Set(rv=[dict([('id', 47), ('criticality', 'reject'), ('Value', _RAB_SetupItem_RelocReq_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-RelocReq >-----#
    RAB_SetupItem_RelocReq = SEQ(name='RAB-SetupItem-RelocReq', mode=MODE_TYPE)
    _RAB_SetupItem_RelocReq_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_RelocReq_nAS_SynchronisationIndicator = BIT_STR(name='nAS-SynchronisationIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NAS-SynchronisationIndicator')), opt=True)
    _RAB_SetupItem_RelocReq_rAB_Parameters = SEQ(name='rAB-Parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _RAB_SetupItem_RelocReq_dataVolumeReportingIndication = ENUM(name='dataVolumeReportingIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataVolumeReportingIndication')), opt=True)
    _RAB_SetupItem_RelocReq_pDP_TypeInformation = SEQ_OF(name='pDP-TypeInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation')), opt=True)
    _RAB_SetupItem_RelocReq_userPlaneInformation = SEQ(name='userPlaneInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'UserPlaneInformation')))
    _RAB_SetupItem_RelocReq_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _RAB_SetupItem_RelocReq_iuTransportAssociation = CHOICE(name='iuTransportAssociation', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    _RAB_SetupItem_RelocReq_service_Handover = ENUM(name='service-Handover', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Service-Handover')), opt=True)
    _RAB_SetupItem_RelocReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_RelocReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameters')))
    _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-BSC-Container')))
    _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_SetupItem_RelocReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_SetupItem_RelocReq_iE_Extensions__item__id),
        ('criticality', ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_RelocReq_iE_Extensions__item_._ext = None
    _RAB_SetupItem_RelocReq_iE_Extensions._cont = __RAB_SetupItem_RelocReq_iE_Extensions__item_
    _RAB_SetupItem_RelocReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_RelocReq._cont = ASN1Dict([
        ('rAB-ID', _RAB_SetupItem_RelocReq_rAB_ID),
        ('nAS-SynchronisationIndicator', _RAB_SetupItem_RelocReq_nAS_SynchronisationIndicator),
        ('rAB-Parameters', _RAB_SetupItem_RelocReq_rAB_Parameters),
        ('dataVolumeReportingIndication', _RAB_SetupItem_RelocReq_dataVolumeReportingIndication),
        ('pDP-TypeInformation', _RAB_SetupItem_RelocReq_pDP_TypeInformation),
        ('userPlaneInformation', _RAB_SetupItem_RelocReq_userPlaneInformation),
        ('transportLayerAddress', _RAB_SetupItem_RelocReq_transportLayerAddress),
        ('iuTransportAssociation', _RAB_SetupItem_RelocReq_iuTransportAssociation),
        ('service-Handover', _RAB_SetupItem_RelocReq_service_Handover),
        ('iE-Extensions', _RAB_SetupItem_RelocReq_iE_Extensions),
        ])
    RAB_SetupItem_RelocReq._ext = []
    
    #-----< RAB-SetupItem-RelocReq-ExtIEs >-----#
    RAB_SetupItem_RelocReq_ExtIEs = CLASS(name='RAB-SetupItem-RelocReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameters')))
    _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-BSC-Container')))
    _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    RAB_SetupItem_RelocReq_ExtIEs._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 231), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_3), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UserPlaneInformation >-----#
    UserPlaneInformation = SEQ(name='UserPlaneInformation', mode=MODE_TYPE)
    _UserPlaneInformation_userPlaneMode = ENUM(name='userPlaneMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UserPlaneMode')))
    _UserPlaneInformation_uP_ModeVersions = BIT_STR(name='uP-ModeVersions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UP-ModeVersions')))
    _UserPlaneInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UserPlaneInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UserPlaneInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UserPlaneInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UserPlaneInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneInformation_iE_Extensions__item__id._const_tab = ____UserPlaneInformation_iE_Extensions__item__id_tab
    ___UserPlaneInformation_iE_Extensions__item__id._const_tab_at = None
    ___UserPlaneInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___UserPlaneInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UserPlaneInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UserPlaneInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneInformation_iE_Extensions__item__criticality._const_tab = ____UserPlaneInformation_iE_Extensions__item__criticality_tab
    ___UserPlaneInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___UserPlaneInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___UserPlaneInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UserPlaneInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UserPlaneInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UserPlaneInformation_iE_Extensions__item__extensionValue._const_tab = ____UserPlaneInformation_iE_Extensions__item__extensionValue_tab
    ___UserPlaneInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UserPlaneInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __UserPlaneInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___UserPlaneInformation_iE_Extensions__item__id),
        ('criticality', ___UserPlaneInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___UserPlaneInformation_iE_Extensions__item__extensionValue),
        ])
    __UserPlaneInformation_iE_Extensions__item_._ext = None
    _UserPlaneInformation_iE_Extensions._cont = __UserPlaneInformation_iE_Extensions__item_
    _UserPlaneInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UserPlaneInformation._cont = ASN1Dict([
        ('userPlaneMode', _UserPlaneInformation_userPlaneMode),
        ('uP-ModeVersions', _UserPlaneInformation_uP_ModeVersions),
        ('iE-Extensions', _UserPlaneInformation_iE_Extensions),
        ])
    UserPlaneInformation._ext = []
    
    #-----< UserPlaneInformation-ExtIEs >-----#
    UserPlaneInformation_ExtIEs = CLASS(name='UserPlaneInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UserPlaneInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationRequestExtensions >-----#
    RelocationRequestExtensions = CLASS(name='RelocationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationRequestExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _RelocationRequestExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _RelocationRequestExtensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _RelocationRequestExtensions_val_Extension_3 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _RelocationRequestExtensions_val_Extension_4 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CNMBMSLinkingInformation')))
    _RelocationRequestExtensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RelocationRequestExtensions_val_Extension_6 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _RelocationRequestExtensions_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _RelocationRequestExtensions_val_Extension_8 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    _RelocationRequestExtensions_val_Extension_9 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _RelocationRequestExtensions_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PowerSavingIndicator')))
    _RelocationRequestExtensions_val_Extension_11 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration-For-Relocation')))
    RelocationRequestExtensions._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'reject'), ('Extension', _RelocationRequestExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Extension', _RelocationRequestExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Extension', _RelocationRequestExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'ignore'), ('Extension', _RelocationRequestExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 133), ('criticality', 'ignore'), ('Extension', _RelocationRequestExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 233), ('criticality', 'ignore'), ('Extension', _RelocationRequestExtensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'reject'), ('Extension', _RelocationRequestExtensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Extension', _RelocationRequestExtensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 239), ('criticality', 'ignore'), ('Extension', _RelocationRequestExtensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 261), ('criticality', 'ignore'), ('Extension', _RelocationRequestExtensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 289), ('criticality', 'ignore'), ('Extension', _RelocationRequestExtensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 293), ('criticality', 'ignore'), ('Extension', _RelocationRequestExtensions_val_Extension_11), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CNMBMSLinkingInformation >-----#
    CNMBMSLinkingInformation = SEQ(name='CNMBMSLinkingInformation', mode=MODE_TYPE)
    _CNMBMSLinkingInformation_joinedMBMSBearerService_IEs = SEQ_OF(name='joinedMBMSBearerService-IEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'JoinedMBMSBearerService-IEs')))
    _CNMBMSLinkingInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CNMBMSLinkingInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CNMBMSLinkingInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____CNMBMSLinkingInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CNMBMSLinkingInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNMBMSLinkingInformation_iE_Extensions__item__id._const_tab = ____CNMBMSLinkingInformation_iE_Extensions__item__id_tab
    ___CNMBMSLinkingInformation_iE_Extensions__item__id._const_tab_at = None
    ___CNMBMSLinkingInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___CNMBMSLinkingInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CNMBMSLinkingInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CNMBMSLinkingInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNMBMSLinkingInformation_iE_Extensions__item__criticality._const_tab = ____CNMBMSLinkingInformation_iE_Extensions__item__criticality_tab
    ___CNMBMSLinkingInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___CNMBMSLinkingInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CNMBMSLinkingInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CNMBMSLinkingInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue._const_tab = ____CNMBMSLinkingInformation_iE_Extensions__item__extensionValue_tab
    ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __CNMBMSLinkingInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___CNMBMSLinkingInformation_iE_Extensions__item__id),
        ('criticality', ___CNMBMSLinkingInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue),
        ])
    __CNMBMSLinkingInformation_iE_Extensions__item_._ext = None
    _CNMBMSLinkingInformation_iE_Extensions._cont = __CNMBMSLinkingInformation_iE_Extensions__item_
    _CNMBMSLinkingInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CNMBMSLinkingInformation._cont = ASN1Dict([
        ('joinedMBMSBearerService-IEs', _CNMBMSLinkingInformation_joinedMBMSBearerService_IEs),
        ('iE-Extensions', _CNMBMSLinkingInformation_iE_Extensions),
        ])
    CNMBMSLinkingInformation._ext = []
    
    #-----< CNMBMSLinkingInformation-ExtIEs >-----#
    CNMBMSLinkingInformation_ExtIEs = CLASS(name='CNMBMSLinkingInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CNMBMSLinkingInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< JoinedMBMSBearerService-IEs >-----#
    JoinedMBMSBearerService_IEs = SEQ_OF(name='JoinedMBMSBearerService-IEs', mode=MODE_TYPE)
    _JoinedMBMSBearerService_IEs__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __JoinedMBMSBearerService_IEs__item__tMGI = SEQ(name='tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    __JoinedMBMSBearerService_IEs__item__mBMS_PTP_RAB_ID = BIT_STR(name='mBMS-PTP-RAB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MBMS-PTP-RAB-ID')))
    __JoinedMBMSBearerService_IEs__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___JoinedMBMSBearerService_IEs__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab = _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id_tab
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab_at = None
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab = _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab = _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___JoinedMBMSBearerService_IEs__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id),
        ('criticality', ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality),
        ('extensionValue', ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue),
        ])
    ___JoinedMBMSBearerService_IEs__item__iE_Extensions__item_._ext = None
    __JoinedMBMSBearerService_IEs__item__iE_Extensions._cont = ___JoinedMBMSBearerService_IEs__item__iE_Extensions__item_
    __JoinedMBMSBearerService_IEs__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _JoinedMBMSBearerService_IEs__item_._cont = ASN1Dict([
        ('tMGI', __JoinedMBMSBearerService_IEs__item__tMGI),
        ('mBMS-PTP-RAB-ID', __JoinedMBMSBearerService_IEs__item__mBMS_PTP_RAB_ID),
        ('iE-Extensions', __JoinedMBMSBearerService_IEs__item__iE_Extensions),
        ])
    _JoinedMBMSBearerService_IEs__item_._ext = []
    JoinedMBMSBearerService_IEs._cont = _JoinedMBMSBearerService_IEs__item_
    JoinedMBMSBearerService_IEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< JoinedMBMSBearerService-ExtIEs >-----#
    JoinedMBMSBearerService_ExtIEs = CLASS(name='JoinedMBMSBearerService-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    JoinedMBMSBearerService_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationRequestAcknowledge >-----#
    RelocationRequestAcknowledge = SEQ(name='RelocationRequestAcknowledge', mode=MODE_TYPE)
    _RelocationRequestAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationRequestAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationRequestAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RelocationRequestAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ToSourceRNC-TransparentContainer')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-RelocReqAck')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RelocationRequestAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 63), ('criticality', 'ignore'), ('Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'ignore'), ('Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 6), ('criticality', 'ignore'), ('Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationRequestAcknowledge_protocolIEs__item__id._const_tab = ____RelocationRequestAcknowledge_protocolIEs__item__id_tab
    ___RelocationRequestAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___RelocationRequestAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationRequestAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RelocationRequestAcknowledge_protocolIEs__item__criticality._const_tab = ____RelocationRequestAcknowledge_protocolIEs__item__id_tab
    ___RelocationRequestAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationRequestAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationRequestAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RelocationRequestAcknowledge_protocolIEs__item__value._const_tab = ____RelocationRequestAcknowledge_protocolIEs__item__id_tab
    ___RelocationRequestAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationRequestAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationRequestAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationRequestAcknowledge_protocolIEs__item__id),
        ('criticality', ___RelocationRequestAcknowledge_protocolIEs__item__criticality),
        ('value', ___RelocationRequestAcknowledge_protocolIEs__item__value),
        ])
    __RelocationRequestAcknowledge_protocolIEs__item_._ext = None
    _RelocationRequestAcknowledge_protocolIEs._cont = __RelocationRequestAcknowledge_protocolIEs__item_
    _RelocationRequestAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationRequestAcknowledge_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationRequestAcknowledge_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationRequestAcknowledge_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NewBSS-To-OldBSS-Information')))
    _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 100), ('criticality', 'ignore'), ('Extension', _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'ignore'), ('Extension', _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationRequestAcknowledge_protocolExtensions__item__id._const_tab = ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab
    ___RelocationRequestAcknowledge_protocolExtensions__item__id._const_tab_at = None
    ___RelocationRequestAcknowledge_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationRequestAcknowledge_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RelocationRequestAcknowledge_protocolExtensions__item__criticality._const_tab = ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab
    ___RelocationRequestAcknowledge_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationRequestAcknowledge_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue._const_tab = ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab
    ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationRequestAcknowledge_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationRequestAcknowledge_protocolExtensions__item__id),
        ('criticality', ___RelocationRequestAcknowledge_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue),
        ])
    __RelocationRequestAcknowledge_protocolExtensions__item_._ext = None
    _RelocationRequestAcknowledge_protocolExtensions._cont = __RelocationRequestAcknowledge_protocolExtensions__item_
    _RelocationRequestAcknowledge_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationRequestAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _RelocationRequestAcknowledge_protocolIEs),
        ('protocolExtensions', _RelocationRequestAcknowledge_protocolExtensions),
        ])
    RelocationRequestAcknowledge._ext = []
    
    #-----< RelocationRequestAcknowledgeIEs >-----#
    RelocationRequestAcknowledgeIEs = CLASS(name='RelocationRequestAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationRequestAcknowledgeIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ToSourceRNC-TransparentContainer')))
    _RelocationRequestAcknowledgeIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-RelocReqAck')))
    _RelocationRequestAcknowledgeIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    _RelocationRequestAcknowledgeIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _RelocationRequestAcknowledgeIEs_val_Value_4 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _RelocationRequestAcknowledgeIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RelocationRequestAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 63), ('criticality', 'ignore'), ('Value', _RelocationRequestAcknowledgeIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 50), ('criticality', 'ignore'), ('Value', _RelocationRequestAcknowledgeIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'ignore'), ('Value', _RelocationRequestAcknowledgeIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 6), ('criticality', 'ignore'), ('Value', _RelocationRequestAcknowledgeIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _RelocationRequestAcknowledgeIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _RelocationRequestAcknowledgeIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-RelocReqAck >-----#
    RAB_SetupList_RelocReqAck = SEQ_OF(name='RAB-SetupList-RelocReqAck', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_RelocReqAck__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_RelocReqAck__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_RelocReqAck__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_SetupList_RelocReqAck__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_RelocReqAck__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-RelocReqAck')))
    ____RAB_SetupList_RelocReqAck__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 48), ('criticality', 'reject'), ('Value', _____RAB_SetupList_RelocReqAck__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_RelocReqAck__item___item__id._const_tab = ____RAB_SetupList_RelocReqAck__item___item__id_tab
    ___RAB_SetupList_RelocReqAck__item___item__id._const_tab_at = None
    ___RAB_SetupList_RelocReqAck__item___item__id._const_tab_id = 'id'
    ___RAB_SetupList_RelocReqAck__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_SetupList_RelocReqAck__item___item__criticality._const_tab = ____RAB_SetupList_RelocReqAck__item___item__id_tab
    ___RAB_SetupList_RelocReqAck__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupList_RelocReqAck__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupList_RelocReqAck__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_SetupList_RelocReqAck__item___item__value._const_tab = ____RAB_SetupList_RelocReqAck__item___item__id_tab
    ___RAB_SetupList_RelocReqAck__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_SetupList_RelocReqAck__item___item__value._const_tab_id = 'Value'
    __RAB_SetupList_RelocReqAck__item___item_._cont = ASN1Dict([
        ('id', ___RAB_SetupList_RelocReqAck__item___item__id),
        ('criticality', ___RAB_SetupList_RelocReqAck__item___item__criticality),
        ('value', ___RAB_SetupList_RelocReqAck__item___item__value),
        ])
    __RAB_SetupList_RelocReqAck__item___item_._ext = None
    _RAB_SetupList_RelocReqAck__item_._cont = __RAB_SetupList_RelocReqAck__item___item_
    _RAB_SetupList_RelocReqAck__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_RelocReqAck._cont = _RAB_SetupList_RelocReqAck__item_
    RAB_SetupList_RelocReqAck._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-RelocReqAck-IEs >-----#
    RAB_SetupItem_RelocReqAck_IEs = CLASS(name='RAB-SetupItem-RelocReqAck-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_RelocReqAck_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-RelocReqAck')))
    RAB_SetupItem_RelocReqAck_IEs._val = ASN1Set(rv=[dict([('id', 48), ('criticality', 'reject'), ('Value', _RAB_SetupItem_RelocReqAck_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-RelocReqAck >-----#
    RAB_SetupItem_RelocReqAck = SEQ(name='RAB-SetupItem-RelocReqAck', mode=MODE_TYPE)
    _RAB_SetupItem_RelocReqAck_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_RelocReqAck_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')), opt=True)
    _RAB_SetupItem_RelocReqAck_iuTransportAssociation = CHOICE(name='iuTransportAssociation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')), opt=True)
    _RAB_SetupItem_RelocReqAck_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_RelocReqAck_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')))
    _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 90), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 67), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_SetupItem_RelocReqAck_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id),
        ('criticality', ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_RelocReqAck_iE_Extensions__item_._ext = None
    _RAB_SetupItem_RelocReqAck_iE_Extensions._cont = __RAB_SetupItem_RelocReqAck_iE_Extensions__item_
    _RAB_SetupItem_RelocReqAck_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_RelocReqAck._cont = ASN1Dict([
        ('rAB-ID', _RAB_SetupItem_RelocReqAck_rAB_ID),
        ('transportLayerAddress', _RAB_SetupItem_RelocReqAck_transportLayerAddress),
        ('iuTransportAssociation', _RAB_SetupItem_RelocReqAck_iuTransportAssociation),
        ('iE-Extensions', _RAB_SetupItem_RelocReqAck_iE_Extensions),
        ])
    RAB_SetupItem_RelocReqAck._ext = []
    
    #-----< RAB-SetupItem-RelocReqAck-ExtIEs >-----#
    RAB_SetupItem_RelocReqAck_ExtIEs = CLASS(name='RAB-SetupItem-RelocReqAck-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')))
    _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    RAB_SetupItem_RelocReqAck_ExtIEs._val = ASN1Set(rv=[dict([('id', 90), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 67), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 13), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-FailedList >-----#
    RAB_FailedList = SEQ_OF(name='RAB-FailedList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_FailedList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_FailedList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_FailedList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_FailedList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_FailedList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedItem')))
    ____RAB_FailedList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 34), ('criticality', 'ignore'), ('Value', _____RAB_FailedList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_FailedList__item___item__id._const_tab = ____RAB_FailedList__item___item__id_tab
    ___RAB_FailedList__item___item__id._const_tab_at = None
    ___RAB_FailedList__item___item__id._const_tab_id = 'id'
    ___RAB_FailedList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_FailedList__item___item__criticality._const_tab = ____RAB_FailedList__item___item__id_tab
    ___RAB_FailedList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_FailedList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_FailedList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_FailedList__item___item__value._const_tab = ____RAB_FailedList__item___item__id_tab
    ___RAB_FailedList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_FailedList__item___item__value._const_tab_id = 'Value'
    __RAB_FailedList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_FailedList__item___item__id),
        ('criticality', ___RAB_FailedList__item___item__criticality),
        ('value', ___RAB_FailedList__item___item__value),
        ])
    __RAB_FailedList__item___item_._ext = None
    _RAB_FailedList__item_._cont = __RAB_FailedList__item___item_
    _RAB_FailedList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_FailedList._cont = _RAB_FailedList__item_
    RAB_FailedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-FailedItemIEs >-----#
    RAB_FailedItemIEs = CLASS(name='RAB-FailedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_FailedItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedItem')))
    RAB_FailedItemIEs._val = ASN1Set(rv=[dict([('id', 34), ('criticality', 'ignore'), ('Value', _RAB_FailedItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-FailedItem >-----#
    RAB_FailedItem = SEQ(name='RAB-FailedItem', mode=MODE_TYPE)
    _RAB_FailedItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_FailedItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RAB_FailedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_FailedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_FailedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_FailedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_iE_Extensions__item__id._const_tab = ____RAB_FailedItem_iE_Extensions__item__id_tab
    ___RAB_FailedItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_FailedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_FailedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_FailedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_iE_Extensions__item__criticality._const_tab = ____RAB_FailedItem_iE_Extensions__item__criticality_tab
    ___RAB_FailedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_FailedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_FailedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_FailedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_FailedItem_iE_Extensions__item__extensionValue_tab
    ___RAB_FailedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_FailedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_FailedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_FailedItem_iE_Extensions__item__id),
        ('criticality', ___RAB_FailedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_FailedItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_FailedItem_iE_Extensions__item_._ext = None
    _RAB_FailedItem_iE_Extensions._cont = __RAB_FailedItem_iE_Extensions__item_
    _RAB_FailedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_FailedItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_FailedItem_rAB_ID),
        ('cause', _RAB_FailedItem_cause),
        ('iE-Extensions', _RAB_FailedItem_iE_Extensions),
        ])
    RAB_FailedItem._ext = []
    
    #-----< RAB-FailedItem-ExtIEs >-----#
    RAB_FailedItem_ExtIEs = CLASS(name='RAB-FailedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_FailedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationRequestAcknowledgeExtensions >-----#
    RelocationRequestAcknowledgeExtensions = CLASS(name='RelocationRequestAcknowledgeExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationRequestAcknowledgeExtensions_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NewBSS-To-OldBSS-Information')))
    _RelocationRequestAcknowledgeExtensions_val_Extension_1 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    RelocationRequestAcknowledgeExtensions._val = ASN1Set(rv=[dict([('id', 100), ('criticality', 'ignore'), ('Extension', _RelocationRequestAcknowledgeExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'ignore'), ('Extension', _RelocationRequestAcknowledgeExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationFailure >-----#
    RelocationFailure = SEQ(name='RelocationFailure', mode=MODE_TYPE)
    _RelocationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RelocationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____RelocationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RelocationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____RelocationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____RelocationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationFailure_protocolIEs__item__id._const_tab = ____RelocationFailure_protocolIEs__item__id_tab
    ___RelocationFailure_protocolIEs__item__id._const_tab_at = None
    ___RelocationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RelocationFailure_protocolIEs__item__criticality._const_tab = ____RelocationFailure_protocolIEs__item__id_tab
    ___RelocationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RelocationFailure_protocolIEs__item__value._const_tab = ____RelocationFailure_protocolIEs__item__id_tab
    ___RelocationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationFailure_protocolIEs__item__id),
        ('criticality', ___RelocationFailure_protocolIEs__item__criticality),
        ('value', ___RelocationFailure_protocolIEs__item__value),
        ])
    __RelocationFailure_protocolIEs__item_._ext = None
    _RelocationFailure_protocolIEs._cont = __RelocationFailure_protocolIEs__item_
    _RelocationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NewBSS-To-OldBSS-Information')))
    _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    ____RelocationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 100), ('criticality', 'ignore'), ('Extension', _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'ignore'), ('Extension', _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationFailure_protocolExtensions__item__id._const_tab = ____RelocationFailure_protocolExtensions__item__id_tab
    ___RelocationFailure_protocolExtensions__item__id._const_tab_at = None
    ___RelocationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RelocationFailure_protocolExtensions__item__criticality._const_tab = ____RelocationFailure_protocolExtensions__item__id_tab
    ___RelocationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RelocationFailure_protocolExtensions__item__extensionValue._const_tab = ____RelocationFailure_protocolExtensions__item__id_tab
    ___RelocationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationFailure_protocolExtensions__item__id),
        ('criticality', ___RelocationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationFailure_protocolExtensions__item__extensionValue),
        ])
    __RelocationFailure_protocolExtensions__item_._ext = None
    _RelocationFailure_protocolExtensions._cont = __RelocationFailure_protocolExtensions__item_
    _RelocationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationFailure._cont = ASN1Dict([
        ('protocolIEs', _RelocationFailure_protocolIEs),
        ('protocolExtensions', _RelocationFailure_protocolExtensions),
        ])
    RelocationFailure._ext = []
    
    #-----< RelocationFailureIEs >-----#
    RelocationFailureIEs = CLASS(name='RelocationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RelocationFailureIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RelocationFailureIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _RelocationFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _RelocationFailureIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationFailureExtensions >-----#
    RelocationFailureExtensions = CLASS(name='RelocationFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationFailureExtensions_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NewBSS-To-OldBSS-Information')))
    _RelocationFailureExtensions_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    RelocationFailureExtensions._val = ASN1Set(rv=[dict([('id', 100), ('criticality', 'ignore'), ('Extension', _RelocationFailureExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 108), ('criticality', 'ignore'), ('Extension', _RelocationFailureExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCancel >-----#
    RelocationCancel = SEQ(name='RelocationCancel', mode=MODE_TYPE)
    _RelocationCancel_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationCancel_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationCancel_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RelocationCancel_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationCancel_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____RelocationCancel_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____RelocationCancel_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RelocationCancel_protocolIEs__item__id._const_tab = ____RelocationCancel_protocolIEs__item__id_tab
    ___RelocationCancel_protocolIEs__item__id._const_tab_at = None
    ___RelocationCancel_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationCancel_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RelocationCancel_protocolIEs__item__criticality._const_tab = ____RelocationCancel_protocolIEs__item__id_tab
    ___RelocationCancel_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationCancel_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationCancel_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RelocationCancel_protocolIEs__item__value._const_tab = ____RelocationCancel_protocolIEs__item__id_tab
    ___RelocationCancel_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationCancel_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationCancel_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationCancel_protocolIEs__item__id),
        ('criticality', ___RelocationCancel_protocolIEs__item__criticality),
        ('value', ___RelocationCancel_protocolIEs__item__value),
        ])
    __RelocationCancel_protocolIEs__item_._ext = None
    _RelocationCancel_protocolIEs._cont = __RelocationCancel_protocolIEs__item_
    _RelocationCancel_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationCancel_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationCancel_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationCancel_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationCancel_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancel_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancel_protocolExtensions__item__id._const_tab = ____RelocationCancel_protocolExtensions__item__id_tab
    ___RelocationCancel_protocolExtensions__item__id._const_tab_at = None
    ___RelocationCancel_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationCancel_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RelocationCancel_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancel_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancel_protocolExtensions__item__criticality._const_tab = ____RelocationCancel_protocolExtensions__item__criticality_tab
    ___RelocationCancel_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationCancel_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationCancel_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RelocationCancel_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancel_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancel_protocolExtensions__item__extensionValue._const_tab = ____RelocationCancel_protocolExtensions__item__extensionValue_tab
    ___RelocationCancel_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationCancel_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationCancel_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationCancel_protocolExtensions__item__id),
        ('criticality', ___RelocationCancel_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationCancel_protocolExtensions__item__extensionValue),
        ])
    __RelocationCancel_protocolExtensions__item_._ext = None
    _RelocationCancel_protocolExtensions._cont = __RelocationCancel_protocolExtensions__item_
    _RelocationCancel_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationCancel._cont = ASN1Dict([
        ('protocolIEs', _RelocationCancel_protocolIEs),
        ('protocolExtensions', _RelocationCancel_protocolExtensions),
        ])
    RelocationCancel._ext = []
    
    #-----< RelocationCancelIEs >-----#
    RelocationCancelIEs = CLASS(name='RelocationCancelIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationCancelIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    RelocationCancelIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _RelocationCancelIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCancelExtensions >-----#
    RelocationCancelExtensions = CLASS(name='RelocationCancelExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RelocationCancelExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationCancelAcknowledge >-----#
    RelocationCancelAcknowledge = SEQ(name='RelocationCancelAcknowledge', mode=MODE_TYPE)
    _RelocationCancelAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationCancelAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationCancelAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RelocationCancelAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RelocationCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RelocationCancelAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Value', _____RelocationCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationCancelAcknowledge_protocolIEs__item__id._const_tab = ____RelocationCancelAcknowledge_protocolIEs__item__id_tab
    ___RelocationCancelAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___RelocationCancelAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationCancelAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RelocationCancelAcknowledge_protocolIEs__item__criticality._const_tab = ____RelocationCancelAcknowledge_protocolIEs__item__id_tab
    ___RelocationCancelAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationCancelAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationCancelAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RelocationCancelAcknowledge_protocolIEs__item__value._const_tab = ____RelocationCancelAcknowledge_protocolIEs__item__id_tab
    ___RelocationCancelAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationCancelAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationCancelAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationCancelAcknowledge_protocolIEs__item__id),
        ('criticality', ___RelocationCancelAcknowledge_protocolIEs__item__criticality),
        ('value', ___RelocationCancelAcknowledge_protocolIEs__item__value),
        ])
    __RelocationCancelAcknowledge_protocolIEs__item_._ext = None
    _RelocationCancelAcknowledge_protocolIEs._cont = __RelocationCancelAcknowledge_protocolIEs__item_
    _RelocationCancelAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationCancelAcknowledge_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationCancelAcknowledge_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationCancelAcknowledge_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationCancelAcknowledge_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancelAcknowledge_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancelAcknowledge_protocolExtensions__item__id._const_tab = ____RelocationCancelAcknowledge_protocolExtensions__item__id_tab
    ___RelocationCancelAcknowledge_protocolExtensions__item__id._const_tab_at = None
    ___RelocationCancelAcknowledge_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationCancelAcknowledge_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RelocationCancelAcknowledge_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancelAcknowledge_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancelAcknowledge_protocolExtensions__item__criticality._const_tab = ____RelocationCancelAcknowledge_protocolExtensions__item__criticality_tab
    ___RelocationCancelAcknowledge_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationCancelAcknowledge_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RelocationCancelAcknowledge_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationCancelAcknowledge_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue._const_tab = ____RelocationCancelAcknowledge_protocolExtensions__item__extensionValue_tab
    ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationCancelAcknowledge_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationCancelAcknowledge_protocolExtensions__item__id),
        ('criticality', ___RelocationCancelAcknowledge_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue),
        ])
    __RelocationCancelAcknowledge_protocolExtensions__item_._ext = None
    _RelocationCancelAcknowledge_protocolExtensions._cont = __RelocationCancelAcknowledge_protocolExtensions__item_
    _RelocationCancelAcknowledge_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationCancelAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _RelocationCancelAcknowledge_protocolIEs),
        ('protocolExtensions', _RelocationCancelAcknowledge_protocolExtensions),
        ])
    RelocationCancelAcknowledge._ext = []
    
    #-----< RelocationCancelAcknowledgeIEs >-----#
    RelocationCancelAcknowledgeIEs = CLASS(name='RelocationCancelAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RelocationCancelAcknowledgeIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RelocationCancelAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Value', _RelocationCancelAcknowledgeIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RelocationCancelAcknowledgeExtensions >-----#
    RelocationCancelAcknowledgeExtensions = CLASS(name='RelocationCancelAcknowledgeExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RelocationCancelAcknowledgeExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRNS-ContextRequest >-----#
    SRNS_ContextRequest = SEQ(name='SRNS-ContextRequest', mode=MODE_TYPE)
    _SRNS_ContextRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SRNS_ContextRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SRNS_ContextRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____SRNS_ContextRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SRNS_ContextRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList-SRNS-CtxReq')))
    ____SRNS_ContextRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'ignore'), ('Value', _____SRNS_ContextRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___SRNS_ContextRequest_protocolIEs__item__id._const_tab = ____SRNS_ContextRequest_protocolIEs__item__id_tab
    ___SRNS_ContextRequest_protocolIEs__item__id._const_tab_at = None
    ___SRNS_ContextRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SRNS_ContextRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___SRNS_ContextRequest_protocolIEs__item__criticality._const_tab = ____SRNS_ContextRequest_protocolIEs__item__id_tab
    ___SRNS_ContextRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SRNS_ContextRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SRNS_ContextRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___SRNS_ContextRequest_protocolIEs__item__value._const_tab = ____SRNS_ContextRequest_protocolIEs__item__id_tab
    ___SRNS_ContextRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SRNS_ContextRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SRNS_ContextRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SRNS_ContextRequest_protocolIEs__item__id),
        ('criticality', ___SRNS_ContextRequest_protocolIEs__item__criticality),
        ('value', ___SRNS_ContextRequest_protocolIEs__item__value),
        ])
    __SRNS_ContextRequest_protocolIEs__item_._ext = None
    _SRNS_ContextRequest_protocolIEs._cont = __SRNS_ContextRequest_protocolIEs__item_
    _SRNS_ContextRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SRNS_ContextRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRNS_ContextRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRNS_ContextRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SRNS_ContextRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____SRNS_ContextRequest_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAT-Type')))
    ____SRNS_ContextRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 167), ('criticality', 'ignore'), ('Extension', _____SRNS_ContextRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SRNS_ContextRequest_protocolExtensions__item__id._const_tab = ____SRNS_ContextRequest_protocolExtensions__item__id_tab
    ___SRNS_ContextRequest_protocolExtensions__item__id._const_tab_at = None
    ___SRNS_ContextRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___SRNS_ContextRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___SRNS_ContextRequest_protocolExtensions__item__criticality._const_tab = ____SRNS_ContextRequest_protocolExtensions__item__id_tab
    ___SRNS_ContextRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRNS_ContextRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SRNS_ContextRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___SRNS_ContextRequest_protocolExtensions__item__extensionValue._const_tab = ____SRNS_ContextRequest_protocolExtensions__item__id_tab
    ___SRNS_ContextRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRNS_ContextRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SRNS_ContextRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SRNS_ContextRequest_protocolExtensions__item__id),
        ('criticality', ___SRNS_ContextRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___SRNS_ContextRequest_protocolExtensions__item__extensionValue),
        ])
    __SRNS_ContextRequest_protocolExtensions__item_._ext = None
    _SRNS_ContextRequest_protocolExtensions._cont = __SRNS_ContextRequest_protocolExtensions__item_
    _SRNS_ContextRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRNS_ContextRequest._cont = ASN1Dict([
        ('protocolIEs', _SRNS_ContextRequest_protocolIEs),
        ('protocolExtensions', _SRNS_ContextRequest_protocolExtensions),
        ])
    SRNS_ContextRequest._ext = []
    
    #-----< SRNS-ContextRequestIEs >-----#
    SRNS_ContextRequestIEs = CLASS(name='SRNS-ContextRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SRNS_ContextRequestIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList-SRNS-CtxReq')))
    SRNS_ContextRequestIEs._val = ASN1Set(rv=[dict([('id', 29), ('criticality', 'ignore'), ('Value', _SRNS_ContextRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataForwardingList-SRNS-CtxReq >-----#
    RAB_DataForwardingList_SRNS_CtxReq = SEQ_OF(name='RAB-DataForwardingList-SRNS-CtxReq', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_DataForwardingList_SRNS_CtxReq__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_DataForwardingList_SRNS_CtxReq__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingItem-SRNS-CtxReq')))
    ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 27), ('criticality', 'reject'), ('Value', _____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id._const_tab = ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id._const_tab_at = None
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id._const_tab_id = 'id'
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality._const_tab = ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value._const_tab = ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value._const_tab_id = 'Value'
    __RAB_DataForwardingList_SRNS_CtxReq__item___item_._cont = ASN1Dict([
        ('id', ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id),
        ('criticality', ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality),
        ('value', ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value),
        ])
    __RAB_DataForwardingList_SRNS_CtxReq__item___item_._ext = None
    _RAB_DataForwardingList_SRNS_CtxReq__item_._cont = __RAB_DataForwardingList_SRNS_CtxReq__item___item_
    _RAB_DataForwardingList_SRNS_CtxReq__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_DataForwardingList_SRNS_CtxReq._cont = _RAB_DataForwardingList_SRNS_CtxReq__item_
    RAB_DataForwardingList_SRNS_CtxReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-DataForwardingItem-SRNS-CtxReq-IEs >-----#
    RAB_DataForwardingItem_SRNS_CtxReq_IEs = CLASS(name='RAB-DataForwardingItem-SRNS-CtxReq-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_DataForwardingItem_SRNS_CtxReq_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingItem-SRNS-CtxReq')))
    RAB_DataForwardingItem_SRNS_CtxReq_IEs._val = ASN1Set(rv=[dict([('id', 27), ('criticality', 'reject'), ('Value', _RAB_DataForwardingItem_SRNS_CtxReq_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataForwardingItem-SRNS-CtxReq >-----#
    RAB_DataForwardingItem_SRNS_CtxReq = SEQ(name='RAB-DataForwardingItem-SRNS-CtxReq', mode=MODE_TYPE)
    _RAB_DataForwardingItem_SRNS_CtxReq_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id._const_tab = ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id_tab
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id._const_tab_at = None
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality._const_tab = ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality_tab
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue._const_tab = ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue_tab
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id),
        ('criticality', ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue),
        ])
    __RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item_._ext = None
    _RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions._cont = __RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item_
    _RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_DataForwardingItem_SRNS_CtxReq._cont = ASN1Dict([
        ('rAB-ID', _RAB_DataForwardingItem_SRNS_CtxReq_rAB_ID),
        ('iE-Extensions', _RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions),
        ])
    RAB_DataForwardingItem_SRNS_CtxReq._ext = []
    
    #-----< RAB-DataForwardingItem-SRNS-CtxReq-ExtIEs >-----#
    RAB_DataForwardingItem_SRNS_CtxReq_ExtIEs = CLASS(name='RAB-DataForwardingItem-SRNS-CtxReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_DataForwardingItem_SRNS_CtxReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRNS-ContextRequestExtensions >-----#
    SRNS_ContextRequestExtensions = CLASS(name='SRNS-ContextRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _SRNS_ContextRequestExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAT-Type')))
    SRNS_ContextRequestExtensions._val = ASN1Set(rv=[dict([('id', 167), ('criticality', 'ignore'), ('Extension', _SRNS_ContextRequestExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRNS-ContextResponse >-----#
    SRNS_ContextResponse = SEQ(name='SRNS-ContextResponse', mode=MODE_TYPE)
    _SRNS_ContextResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SRNS_ContextResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SRNS_ContextResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____SRNS_ContextResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList')))
    _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextFailedtoTransferList')))
    _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____SRNS_ContextResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SRNS_ContextResponse_protocolIEs__item__id._const_tab = ____SRNS_ContextResponse_protocolIEs__item__id_tab
    ___SRNS_ContextResponse_protocolIEs__item__id._const_tab_at = None
    ___SRNS_ContextResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___SRNS_ContextResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___SRNS_ContextResponse_protocolIEs__item__criticality._const_tab = ____SRNS_ContextResponse_protocolIEs__item__id_tab
    ___SRNS_ContextResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SRNS_ContextResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SRNS_ContextResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___SRNS_ContextResponse_protocolIEs__item__value._const_tab = ____SRNS_ContextResponse_protocolIEs__item__id_tab
    ___SRNS_ContextResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SRNS_ContextResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __SRNS_ContextResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SRNS_ContextResponse_protocolIEs__item__id),
        ('criticality', ___SRNS_ContextResponse_protocolIEs__item__criticality),
        ('value', ___SRNS_ContextResponse_protocolIEs__item__value),
        ])
    __SRNS_ContextResponse_protocolIEs__item_._ext = None
    _SRNS_ContextResponse_protocolIEs._cont = __SRNS_ContextResponse_protocolIEs__item_
    _SRNS_ContextResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SRNS_ContextResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRNS_ContextResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRNS_ContextResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SRNS_ContextResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_ContextResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_ContextResponse_protocolExtensions__item__id._const_tab = ____SRNS_ContextResponse_protocolExtensions__item__id_tab
    ___SRNS_ContextResponse_protocolExtensions__item__id._const_tab_at = None
    ___SRNS_ContextResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___SRNS_ContextResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRNS_ContextResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_ContextResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_ContextResponse_protocolExtensions__item__criticality._const_tab = ____SRNS_ContextResponse_protocolExtensions__item__criticality_tab
    ___SRNS_ContextResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRNS_ContextResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SRNS_ContextResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRNS_ContextResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_ContextResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_ContextResponse_protocolExtensions__item__extensionValue._const_tab = ____SRNS_ContextResponse_protocolExtensions__item__extensionValue_tab
    ___SRNS_ContextResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRNS_ContextResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SRNS_ContextResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SRNS_ContextResponse_protocolExtensions__item__id),
        ('criticality', ___SRNS_ContextResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___SRNS_ContextResponse_protocolExtensions__item__extensionValue),
        ])
    __SRNS_ContextResponse_protocolExtensions__item_._ext = None
    _SRNS_ContextResponse_protocolExtensions._cont = __SRNS_ContextResponse_protocolExtensions__item_
    _SRNS_ContextResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRNS_ContextResponse._cont = ASN1Dict([
        ('protocolIEs', _SRNS_ContextResponse_protocolIEs),
        ('protocolExtensions', _SRNS_ContextResponse_protocolExtensions),
        ])
    SRNS_ContextResponse._ext = []
    
    #-----< SRNS-ContextResponseIEs >-----#
    SRNS_ContextResponseIEs = CLASS(name='SRNS-ContextResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SRNS_ContextResponseIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList')))
    _SRNS_ContextResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextFailedtoTransferList')))
    _SRNS_ContextResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    SRNS_ContextResponseIEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _SRNS_ContextResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 85), ('criticality', 'ignore'), ('Value', _SRNS_ContextResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _SRNS_ContextResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ContextList >-----#
    RAB_ContextList = SEQ_OF(name='RAB-ContextList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ContextList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ContextList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ContextList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_ContextList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ContextList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextItem')))
    ____RAB_ContextList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 24), ('criticality', 'ignore'), ('Value', _____RAB_ContextList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ContextList__item___item__id._const_tab = ____RAB_ContextList__item___item__id_tab
    ___RAB_ContextList__item___item__id._const_tab_at = None
    ___RAB_ContextList__item___item__id._const_tab_id = 'id'
    ___RAB_ContextList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_ContextList__item___item__criticality._const_tab = ____RAB_ContextList__item___item__id_tab
    ___RAB_ContextList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ContextList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_ContextList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_ContextList__item___item__value._const_tab = ____RAB_ContextList__item___item__id_tab
    ___RAB_ContextList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_ContextList__item___item__value._const_tab_id = 'Value'
    __RAB_ContextList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_ContextList__item___item__id),
        ('criticality', ___RAB_ContextList__item___item__criticality),
        ('value', ___RAB_ContextList__item___item__value),
        ])
    __RAB_ContextList__item___item_._ext = None
    _RAB_ContextList__item_._cont = __RAB_ContextList__item___item_
    _RAB_ContextList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ContextList._cont = _RAB_ContextList__item_
    RAB_ContextList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ContextItemIEs >-----#
    RAB_ContextItemIEs = CLASS(name='RAB-ContextItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ContextItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextItem')))
    RAB_ContextItemIEs._val = ASN1Set(rv=[dict([('id', 24), ('criticality', 'ignore'), ('Value', _RAB_ContextItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ContextItem >-----#
    RAB_ContextItem = SEQ(name='RAB-ContextItem', mode=MODE_TYPE)
    _RAB_ContextItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ContextItem_dl_GTP_PDU_SequenceNumber = INT(name='dl-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_ul_GTP_PDU_SequenceNumber = INT(name='ul-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_dl_N_PDU_SequenceNumber = INT(name='dl-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-N-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_ul_N_PDU_SequenceNumber = INT(name='ul-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-N-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ContextItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ContextItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_ContextItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_iE_Extensions__item__id._const_tab = ____RAB_ContextItem_iE_Extensions__item__id_tab
    ___RAB_ContextItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ContextItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_ContextItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_ContextItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_iE_Extensions__item__criticality._const_tab = ____RAB_ContextItem_iE_Extensions__item__criticality_tab
    ___RAB_ContextItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ContextItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_ContextItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_ContextItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_ContextItem_iE_Extensions__item__extensionValue_tab
    ___RAB_ContextItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_ContextItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_ContextItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_ContextItem_iE_Extensions__item__id),
        ('criticality', ___RAB_ContextItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_ContextItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_ContextItem_iE_Extensions__item_._ext = None
    _RAB_ContextItem_iE_Extensions._cont = __RAB_ContextItem_iE_Extensions__item_
    _RAB_ContextItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ContextItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_ContextItem_rAB_ID),
        ('dl-GTP-PDU-SequenceNumber', _RAB_ContextItem_dl_GTP_PDU_SequenceNumber),
        ('ul-GTP-PDU-SequenceNumber', _RAB_ContextItem_ul_GTP_PDU_SequenceNumber),
        ('dl-N-PDU-SequenceNumber', _RAB_ContextItem_dl_N_PDU_SequenceNumber),
        ('ul-N-PDU-SequenceNumber', _RAB_ContextItem_ul_N_PDU_SequenceNumber),
        ('iE-Extensions', _RAB_ContextItem_iE_Extensions),
        ])
    RAB_ContextItem._ext = []
    
    #-----< RAB-ContextItem-ExtIEs >-----#
    RAB_ContextItem_ExtIEs = CLASS(name='RAB-ContextItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ContextItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ContextFailedtoTransferList >-----#
    RAB_ContextFailedtoTransferList = SEQ_OF(name='RAB-ContextFailedtoTransferList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ContextFailedtoTransferList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ContextFailedtoTransferList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ContextFailedtoTransferList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_ContextFailedtoTransferList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ContextFailedtoTransferList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RABs-ContextFailedtoTransferItem')))
    ____RAB_ContextFailedtoTransferList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 84), ('criticality', 'ignore'), ('Value', _____RAB_ContextFailedtoTransferList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ContextFailedtoTransferList__item___item__id._const_tab = ____RAB_ContextFailedtoTransferList__item___item__id_tab
    ___RAB_ContextFailedtoTransferList__item___item__id._const_tab_at = None
    ___RAB_ContextFailedtoTransferList__item___item__id._const_tab_id = 'id'
    ___RAB_ContextFailedtoTransferList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_ContextFailedtoTransferList__item___item__criticality._const_tab = ____RAB_ContextFailedtoTransferList__item___item__id_tab
    ___RAB_ContextFailedtoTransferList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ContextFailedtoTransferList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_ContextFailedtoTransferList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_ContextFailedtoTransferList__item___item__value._const_tab = ____RAB_ContextFailedtoTransferList__item___item__id_tab
    ___RAB_ContextFailedtoTransferList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_ContextFailedtoTransferList__item___item__value._const_tab_id = 'Value'
    __RAB_ContextFailedtoTransferList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_ContextFailedtoTransferList__item___item__id),
        ('criticality', ___RAB_ContextFailedtoTransferList__item___item__criticality),
        ('value', ___RAB_ContextFailedtoTransferList__item___item__value),
        ])
    __RAB_ContextFailedtoTransferList__item___item_._ext = None
    _RAB_ContextFailedtoTransferList__item_._cont = __RAB_ContextFailedtoTransferList__item___item_
    _RAB_ContextFailedtoTransferList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ContextFailedtoTransferList._cont = _RAB_ContextFailedtoTransferList__item_
    RAB_ContextFailedtoTransferList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RABs-ContextFailedtoTransferItemIEs >-----#
    RABs_ContextFailedtoTransferItemIEs = CLASS(name='RABs-ContextFailedtoTransferItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RABs_ContextFailedtoTransferItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RABs-ContextFailedtoTransferItem')))
    RABs_ContextFailedtoTransferItemIEs._val = ASN1Set(rv=[dict([('id', 84), ('criticality', 'ignore'), ('Value', _RABs_ContextFailedtoTransferItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RABs-ContextFailedtoTransferItem >-----#
    RABs_ContextFailedtoTransferItem = SEQ(name='RABs-ContextFailedtoTransferItem', mode=MODE_TYPE)
    _RABs_ContextFailedtoTransferItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RABs_ContextFailedtoTransferItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RABs_ContextFailedtoTransferItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RABs_ContextFailedtoTransferItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id._const_tab = ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__id_tab
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id._const_tab_at = None
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality._const_tab = ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality_tab
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue._const_tab = ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue_tab
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RABs_ContextFailedtoTransferItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id),
        ('criticality', ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue),
        ])
    __RABs_ContextFailedtoTransferItem_iE_Extensions__item_._ext = None
    _RABs_ContextFailedtoTransferItem_iE_Extensions._cont = __RABs_ContextFailedtoTransferItem_iE_Extensions__item_
    _RABs_ContextFailedtoTransferItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RABs_ContextFailedtoTransferItem._cont = ASN1Dict([
        ('rAB-ID', _RABs_ContextFailedtoTransferItem_rAB_ID),
        ('cause', _RABs_ContextFailedtoTransferItem_cause),
        ('iE-Extensions', _RABs_ContextFailedtoTransferItem_iE_Extensions),
        ])
    RABs_ContextFailedtoTransferItem._ext = []
    
    #-----< RABs-ContextFailedtoTransferItem-ExtIEs >-----#
    RABs_ContextFailedtoTransferItem_ExtIEs = CLASS(name='RABs-ContextFailedtoTransferItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RABs_ContextFailedtoTransferItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRNS-ContextResponseExtensions >-----#
    SRNS_ContextResponseExtensions = CLASS(name='SRNS-ContextResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRNS_ContextResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityModeCommand >-----#
    SecurityModeCommand = SEQ(name='SecurityModeCommand', mode=MODE_TYPE)
    _SecurityModeCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SecurityModeCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SecurityModeCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____SecurityModeCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'KeyStatus')))
    ____SecurityModeCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 12), ('criticality', 'reject'), ('Value', _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'ignore'), ('Value', _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'reject'), ('Value', _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___SecurityModeCommand_protocolIEs__item__id._const_tab = ____SecurityModeCommand_protocolIEs__item__id_tab
    ___SecurityModeCommand_protocolIEs__item__id._const_tab_at = None
    ___SecurityModeCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___SecurityModeCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___SecurityModeCommand_protocolIEs__item__criticality._const_tab = ____SecurityModeCommand_protocolIEs__item__id_tab
    ___SecurityModeCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityModeCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SecurityModeCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___SecurityModeCommand_protocolIEs__item__value._const_tab = ____SecurityModeCommand_protocolIEs__item__id_tab
    ___SecurityModeCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SecurityModeCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __SecurityModeCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SecurityModeCommand_protocolIEs__item__id),
        ('criticality', ___SecurityModeCommand_protocolIEs__item__criticality),
        ('value', ___SecurityModeCommand_protocolIEs__item__value),
        ])
    __SecurityModeCommand_protocolIEs__item_._ext = None
    _SecurityModeCommand_protocolIEs._cont = __SecurityModeCommand_protocolIEs__item_
    _SecurityModeCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SecurityModeCommand_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityModeCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SecurityModeCommand_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityModeCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeCommand_protocolExtensions__item__id._const_tab = ____SecurityModeCommand_protocolExtensions__item__id_tab
    ___SecurityModeCommand_protocolExtensions__item__id._const_tab_at = None
    ___SecurityModeCommand_protocolExtensions__item__id._const_tab_id = 'id'
    ___SecurityModeCommand_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityModeCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeCommand_protocolExtensions__item__criticality._const_tab = ____SecurityModeCommand_protocolExtensions__item__criticality_tab
    ___SecurityModeCommand_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityModeCommand_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityModeCommand_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityModeCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeCommand_protocolExtensions__item__extensionValue._const_tab = ____SecurityModeCommand_protocolExtensions__item__extensionValue_tab
    ___SecurityModeCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityModeCommand_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityModeCommand_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SecurityModeCommand_protocolExtensions__item__id),
        ('criticality', ___SecurityModeCommand_protocolExtensions__item__criticality),
        ('extensionValue', ___SecurityModeCommand_protocolExtensions__item__extensionValue),
        ])
    __SecurityModeCommand_protocolExtensions__item_._ext = None
    _SecurityModeCommand_protocolExtensions._cont = __SecurityModeCommand_protocolExtensions__item_
    _SecurityModeCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityModeCommand._cont = ASN1Dict([
        ('protocolIEs', _SecurityModeCommand_protocolIEs),
        ('protocolExtensions', _SecurityModeCommand_protocolExtensions),
        ])
    SecurityModeCommand._ext = []
    
    #-----< SecurityModeCommandIEs >-----#
    SecurityModeCommandIEs = CLASS(name='SecurityModeCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SecurityModeCommandIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _SecurityModeCommandIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _SecurityModeCommandIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'KeyStatus')))
    SecurityModeCommandIEs._val = ASN1Set(rv=[dict([('id', 12), ('criticality', 'reject'), ('Value', _SecurityModeCommandIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 11), ('criticality', 'ignore'), ('Value', _SecurityModeCommandIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 75), ('criticality', 'reject'), ('Value', _SecurityModeCommandIEs_val_Value_2), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< SecurityModeCommandExtensions >-----#
    SecurityModeCommandExtensions = CLASS(name='SecurityModeCommandExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SecurityModeCommandExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityModeComplete >-----#
    SecurityModeComplete = SEQ(name='SecurityModeComplete', mode=MODE_TYPE)
    _SecurityModeComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SecurityModeComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SecurityModeComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____SecurityModeComplete_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____SecurityModeComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 6), ('criticality', 'reject'), ('Value', _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SecurityModeComplete_protocolIEs__item__id._const_tab = ____SecurityModeComplete_protocolIEs__item__id_tab
    ___SecurityModeComplete_protocolIEs__item__id._const_tab_at = None
    ___SecurityModeComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___SecurityModeComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___SecurityModeComplete_protocolIEs__item__criticality._const_tab = ____SecurityModeComplete_protocolIEs__item__id_tab
    ___SecurityModeComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityModeComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SecurityModeComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___SecurityModeComplete_protocolIEs__item__value._const_tab = ____SecurityModeComplete_protocolIEs__item__id_tab
    ___SecurityModeComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SecurityModeComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __SecurityModeComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SecurityModeComplete_protocolIEs__item__id),
        ('criticality', ___SecurityModeComplete_protocolIEs__item__criticality),
        ('value', ___SecurityModeComplete_protocolIEs__item__value),
        ])
    __SecurityModeComplete_protocolIEs__item_._ext = None
    _SecurityModeComplete_protocolIEs._cont = __SecurityModeComplete_protocolIEs__item_
    _SecurityModeComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SecurityModeComplete_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityModeComplete_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SecurityModeComplete_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityModeComplete_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeComplete_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeComplete_protocolExtensions__item__id._const_tab = ____SecurityModeComplete_protocolExtensions__item__id_tab
    ___SecurityModeComplete_protocolExtensions__item__id._const_tab_at = None
    ___SecurityModeComplete_protocolExtensions__item__id._const_tab_id = 'id'
    ___SecurityModeComplete_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityModeComplete_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeComplete_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeComplete_protocolExtensions__item__criticality._const_tab = ____SecurityModeComplete_protocolExtensions__item__criticality_tab
    ___SecurityModeComplete_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityModeComplete_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityModeComplete_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityModeComplete_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeComplete_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeComplete_protocolExtensions__item__extensionValue._const_tab = ____SecurityModeComplete_protocolExtensions__item__extensionValue_tab
    ___SecurityModeComplete_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityModeComplete_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityModeComplete_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SecurityModeComplete_protocolExtensions__item__id),
        ('criticality', ___SecurityModeComplete_protocolExtensions__item__criticality),
        ('extensionValue', ___SecurityModeComplete_protocolExtensions__item__extensionValue),
        ])
    __SecurityModeComplete_protocolExtensions__item_._ext = None
    _SecurityModeComplete_protocolExtensions._cont = __SecurityModeComplete_protocolExtensions__item_
    _SecurityModeComplete_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityModeComplete._cont = ASN1Dict([
        ('protocolIEs', _SecurityModeComplete_protocolIEs),
        ('protocolExtensions', _SecurityModeComplete_protocolExtensions),
        ])
    SecurityModeComplete._ext = []
    
    #-----< SecurityModeCompleteIEs >-----#
    SecurityModeCompleteIEs = CLASS(name='SecurityModeCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SecurityModeCompleteIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _SecurityModeCompleteIEs_val_Value_1 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _SecurityModeCompleteIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    SecurityModeCompleteIEs._val = ASN1Set(rv=[dict([('id', 6), ('criticality', 'reject'), ('Value', _SecurityModeCompleteIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 5), ('criticality', 'ignore'), ('Value', _SecurityModeCompleteIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _SecurityModeCompleteIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SecurityModeCompleteExtensions >-----#
    SecurityModeCompleteExtensions = CLASS(name='SecurityModeCompleteExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SecurityModeCompleteExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityModeReject >-----#
    SecurityModeReject = SEQ(name='SecurityModeReject', mode=MODE_TYPE)
    _SecurityModeReject_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SecurityModeReject_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SecurityModeReject_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____SecurityModeReject_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____SecurityModeReject_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SecurityModeReject_protocolIEs__item__id._const_tab = ____SecurityModeReject_protocolIEs__item__id_tab
    ___SecurityModeReject_protocolIEs__item__id._const_tab_at = None
    ___SecurityModeReject_protocolIEs__item__id._const_tab_id = 'id'
    ___SecurityModeReject_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___SecurityModeReject_protocolIEs__item__criticality._const_tab = ____SecurityModeReject_protocolIEs__item__id_tab
    ___SecurityModeReject_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityModeReject_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SecurityModeReject_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___SecurityModeReject_protocolIEs__item__value._const_tab = ____SecurityModeReject_protocolIEs__item__id_tab
    ___SecurityModeReject_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SecurityModeReject_protocolIEs__item__value._const_tab_id = 'Value'
    __SecurityModeReject_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SecurityModeReject_protocolIEs__item__id),
        ('criticality', ___SecurityModeReject_protocolIEs__item__criticality),
        ('value', ___SecurityModeReject_protocolIEs__item__value),
        ])
    __SecurityModeReject_protocolIEs__item_._ext = None
    _SecurityModeReject_protocolIEs._cont = __SecurityModeReject_protocolIEs__item_
    _SecurityModeReject_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SecurityModeReject_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SecurityModeReject_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SecurityModeReject_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SecurityModeReject_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeReject_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeReject_protocolExtensions__item__id._const_tab = ____SecurityModeReject_protocolExtensions__item__id_tab
    ___SecurityModeReject_protocolExtensions__item__id._const_tab_at = None
    ___SecurityModeReject_protocolExtensions__item__id._const_tab_id = 'id'
    ___SecurityModeReject_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SecurityModeReject_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeReject_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeReject_protocolExtensions__item__criticality._const_tab = ____SecurityModeReject_protocolExtensions__item__criticality_tab
    ___SecurityModeReject_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SecurityModeReject_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SecurityModeReject_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SecurityModeReject_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SecurityModeReject_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SecurityModeReject_protocolExtensions__item__extensionValue._const_tab = ____SecurityModeReject_protocolExtensions__item__extensionValue_tab
    ___SecurityModeReject_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SecurityModeReject_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SecurityModeReject_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SecurityModeReject_protocolExtensions__item__id),
        ('criticality', ___SecurityModeReject_protocolExtensions__item__criticality),
        ('extensionValue', ___SecurityModeReject_protocolExtensions__item__extensionValue),
        ])
    __SecurityModeReject_protocolExtensions__item_._ext = None
    _SecurityModeReject_protocolExtensions._cont = __SecurityModeReject_protocolExtensions__item_
    _SecurityModeReject_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SecurityModeReject._cont = ASN1Dict([
        ('protocolIEs', _SecurityModeReject_protocolIEs),
        ('protocolExtensions', _SecurityModeReject_protocolExtensions),
        ])
    SecurityModeReject._ext = []
    
    #-----< SecurityModeRejectIEs >-----#
    SecurityModeRejectIEs = CLASS(name='SecurityModeRejectIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SecurityModeRejectIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _SecurityModeRejectIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    SecurityModeRejectIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _SecurityModeRejectIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _SecurityModeRejectIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SecurityModeRejectExtensions >-----#
    SecurityModeRejectExtensions = CLASS(name='SecurityModeRejectExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SecurityModeRejectExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataVolumeReportRequest >-----#
    DataVolumeReportRequest = SEQ(name='DataVolumeReportRequest', mode=MODE_TYPE)
    _DataVolumeReportRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __DataVolumeReportRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___DataVolumeReportRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____DataVolumeReportRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____DataVolumeReportRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportRequestList')))
    ____DataVolumeReportRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 33), ('criticality', 'ignore'), ('Value', _____DataVolumeReportRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DataVolumeReportRequest_protocolIEs__item__id._const_tab = ____DataVolumeReportRequest_protocolIEs__item__id_tab
    ___DataVolumeReportRequest_protocolIEs__item__id._const_tab_at = None
    ___DataVolumeReportRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___DataVolumeReportRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___DataVolumeReportRequest_protocolIEs__item__criticality._const_tab = ____DataVolumeReportRequest_protocolIEs__item__id_tab
    ___DataVolumeReportRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DataVolumeReportRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DataVolumeReportRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___DataVolumeReportRequest_protocolIEs__item__value._const_tab = ____DataVolumeReportRequest_protocolIEs__item__id_tab
    ___DataVolumeReportRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DataVolumeReportRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __DataVolumeReportRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DataVolumeReportRequest_protocolIEs__item__id),
        ('criticality', ___DataVolumeReportRequest_protocolIEs__item__criticality),
        ('value', ___DataVolumeReportRequest_protocolIEs__item__value),
        ])
    __DataVolumeReportRequest_protocolIEs__item_._ext = None
    _DataVolumeReportRequest_protocolIEs._cont = __DataVolumeReportRequest_protocolIEs__item_
    _DataVolumeReportRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DataVolumeReportRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataVolumeReportRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DataVolumeReportRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____DataVolumeReportRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReportRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReportRequest_protocolExtensions__item__id._const_tab = ____DataVolumeReportRequest_protocolExtensions__item__id_tab
    ___DataVolumeReportRequest_protocolExtensions__item__id._const_tab_at = None
    ___DataVolumeReportRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___DataVolumeReportRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DataVolumeReportRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReportRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReportRequest_protocolExtensions__item__criticality._const_tab = ____DataVolumeReportRequest_protocolExtensions__item__criticality_tab
    ___DataVolumeReportRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DataVolumeReportRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DataVolumeReportRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DataVolumeReportRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReportRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReportRequest_protocolExtensions__item__extensionValue._const_tab = ____DataVolumeReportRequest_protocolExtensions__item__extensionValue_tab
    ___DataVolumeReportRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DataVolumeReportRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DataVolumeReportRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DataVolumeReportRequest_protocolExtensions__item__id),
        ('criticality', ___DataVolumeReportRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___DataVolumeReportRequest_protocolExtensions__item__extensionValue),
        ])
    __DataVolumeReportRequest_protocolExtensions__item_._ext = None
    _DataVolumeReportRequest_protocolExtensions._cont = __DataVolumeReportRequest_protocolExtensions__item_
    _DataVolumeReportRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataVolumeReportRequest._cont = ASN1Dict([
        ('protocolIEs', _DataVolumeReportRequest_protocolIEs),
        ('protocolExtensions', _DataVolumeReportRequest_protocolExtensions),
        ])
    DataVolumeReportRequest._ext = []
    
    #-----< DataVolumeReportRequestIEs >-----#
    DataVolumeReportRequestIEs = CLASS(name='DataVolumeReportRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _DataVolumeReportRequestIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportRequestList')))
    DataVolumeReportRequestIEs._val = ASN1Set(rv=[dict([('id', 33), ('criticality', 'ignore'), ('Value', _DataVolumeReportRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataVolumeReportRequestList >-----#
    RAB_DataVolumeReportRequestList = SEQ_OF(name='RAB-DataVolumeReportRequestList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_DataVolumeReportRequestList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_DataVolumeReportRequestList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_DataVolumeReportRequestList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_DataVolumeReportRequestList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_DataVolumeReportRequestList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportRequestItem')))
    ____RAB_DataVolumeReportRequestList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 32), ('criticality', 'reject'), ('Value', _____RAB_DataVolumeReportRequestList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportRequestList__item___item__id._const_tab = ____RAB_DataVolumeReportRequestList__item___item__id_tab
    ___RAB_DataVolumeReportRequestList__item___item__id._const_tab_at = None
    ___RAB_DataVolumeReportRequestList__item___item__id._const_tab_id = 'id'
    ___RAB_DataVolumeReportRequestList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_DataVolumeReportRequestList__item___item__criticality._const_tab = ____RAB_DataVolumeReportRequestList__item___item__id_tab
    ___RAB_DataVolumeReportRequestList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_DataVolumeReportRequestList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_DataVolumeReportRequestList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_DataVolumeReportRequestList__item___item__value._const_tab = ____RAB_DataVolumeReportRequestList__item___item__id_tab
    ___RAB_DataVolumeReportRequestList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_DataVolumeReportRequestList__item___item__value._const_tab_id = 'Value'
    __RAB_DataVolumeReportRequestList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_DataVolumeReportRequestList__item___item__id),
        ('criticality', ___RAB_DataVolumeReportRequestList__item___item__criticality),
        ('value', ___RAB_DataVolumeReportRequestList__item___item__value),
        ])
    __RAB_DataVolumeReportRequestList__item___item_._ext = None
    _RAB_DataVolumeReportRequestList__item_._cont = __RAB_DataVolumeReportRequestList__item___item_
    _RAB_DataVolumeReportRequestList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_DataVolumeReportRequestList._cont = _RAB_DataVolumeReportRequestList__item_
    RAB_DataVolumeReportRequestList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-DataVolumeReportRequestItemIEs >-----#
    RAB_DataVolumeReportRequestItemIEs = CLASS(name='RAB-DataVolumeReportRequestItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_DataVolumeReportRequestItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportRequestItem')))
    RAB_DataVolumeReportRequestItemIEs._val = ASN1Set(rv=[dict([('id', 32), ('criticality', 'reject'), ('Value', _RAB_DataVolumeReportRequestItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-DataVolumeReportRequestItem >-----#
    RAB_DataVolumeReportRequestItem = SEQ(name='RAB-DataVolumeReportRequestItem', mode=MODE_TYPE)
    _RAB_DataVolumeReportRequestItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_DataVolumeReportRequestItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_DataVolumeReportRequestItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id._const_tab = ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__id_tab
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality._const_tab = ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality_tab
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue_tab
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_DataVolumeReportRequestItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id),
        ('criticality', ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_DataVolumeReportRequestItem_iE_Extensions__item_._ext = None
    _RAB_DataVolumeReportRequestItem_iE_Extensions._cont = __RAB_DataVolumeReportRequestItem_iE_Extensions__item_
    _RAB_DataVolumeReportRequestItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_DataVolumeReportRequestItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_DataVolumeReportRequestItem_rAB_ID),
        ('iE-Extensions', _RAB_DataVolumeReportRequestItem_iE_Extensions),
        ])
    RAB_DataVolumeReportRequestItem._ext = []
    
    #-----< RAB-DataVolumeReportRequestItem-ExtIEs >-----#
    RAB_DataVolumeReportRequestItem_ExtIEs = CLASS(name='RAB-DataVolumeReportRequestItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_DataVolumeReportRequestItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataVolumeReportRequestExtensions >-----#
    DataVolumeReportRequestExtensions = CLASS(name='DataVolumeReportRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    DataVolumeReportRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataVolumeReport >-----#
    DataVolumeReport = SEQ(name='DataVolumeReport', mode=MODE_TYPE)
    _DataVolumeReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __DataVolumeReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___DataVolumeReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____DataVolumeReport_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportList')))
    _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedtoReportList')))
    _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____DataVolumeReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 31), ('criticality', 'ignore'), ('Value', _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 72), ('criticality', 'ignore'), ('Value', _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DataVolumeReport_protocolIEs__item__id._const_tab = ____DataVolumeReport_protocolIEs__item__id_tab
    ___DataVolumeReport_protocolIEs__item__id._const_tab_at = None
    ___DataVolumeReport_protocolIEs__item__id._const_tab_id = 'id'
    ___DataVolumeReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___DataVolumeReport_protocolIEs__item__criticality._const_tab = ____DataVolumeReport_protocolIEs__item__id_tab
    ___DataVolumeReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DataVolumeReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DataVolumeReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___DataVolumeReport_protocolIEs__item__value._const_tab = ____DataVolumeReport_protocolIEs__item__id_tab
    ___DataVolumeReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DataVolumeReport_protocolIEs__item__value._const_tab_id = 'Value'
    __DataVolumeReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DataVolumeReport_protocolIEs__item__id),
        ('criticality', ___DataVolumeReport_protocolIEs__item__criticality),
        ('value', ___DataVolumeReport_protocolIEs__item__value),
        ])
    __DataVolumeReport_protocolIEs__item_._ext = None
    _DataVolumeReport_protocolIEs._cont = __DataVolumeReport_protocolIEs__item_
    _DataVolumeReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DataVolumeReport_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DataVolumeReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DataVolumeReport_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____DataVolumeReport_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReport_protocolExtensions__item__id._const_tab = ____DataVolumeReport_protocolExtensions__item__id_tab
    ___DataVolumeReport_protocolExtensions__item__id._const_tab_at = None
    ___DataVolumeReport_protocolExtensions__item__id._const_tab_id = 'id'
    ___DataVolumeReport_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DataVolumeReport_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReport_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReport_protocolExtensions__item__criticality._const_tab = ____DataVolumeReport_protocolExtensions__item__criticality_tab
    ___DataVolumeReport_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DataVolumeReport_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DataVolumeReport_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DataVolumeReport_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DataVolumeReport_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DataVolumeReport_protocolExtensions__item__extensionValue._const_tab = ____DataVolumeReport_protocolExtensions__item__extensionValue_tab
    ___DataVolumeReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DataVolumeReport_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DataVolumeReport_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DataVolumeReport_protocolExtensions__item__id),
        ('criticality', ___DataVolumeReport_protocolExtensions__item__criticality),
        ('extensionValue', ___DataVolumeReport_protocolExtensions__item__extensionValue),
        ])
    __DataVolumeReport_protocolExtensions__item_._ext = None
    _DataVolumeReport_protocolExtensions._cont = __DataVolumeReport_protocolExtensions__item_
    _DataVolumeReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DataVolumeReport._cont = ASN1Dict([
        ('protocolIEs', _DataVolumeReport_protocolIEs),
        ('protocolExtensions', _DataVolumeReport_protocolExtensions),
        ])
    DataVolumeReport._ext = []
    
    #-----< DataVolumeReportIEs >-----#
    DataVolumeReportIEs = CLASS(name='DataVolumeReportIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _DataVolumeReportIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataVolumeReportList')))
    _DataVolumeReportIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedtoReportList')))
    _DataVolumeReportIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    DataVolumeReportIEs._val = ASN1Set(rv=[dict([('id', 31), ('criticality', 'ignore'), ('Value', _DataVolumeReportIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 72), ('criticality', 'ignore'), ('Value', _DataVolumeReportIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _DataVolumeReportIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DataVolumeReportExtensions >-----#
    DataVolumeReportExtensions = CLASS(name='DataVolumeReportExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    DataVolumeReportExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-FailedtoReportList >-----#
    RAB_FailedtoReportList = SEQ_OF(name='RAB-FailedtoReportList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_FailedtoReportList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_FailedtoReportList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_FailedtoReportList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_FailedtoReportList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_FailedtoReportList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RABs-failed-to-reportItem')))
    ____RAB_FailedtoReportList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 71), ('criticality', 'ignore'), ('Value', _____RAB_FailedtoReportList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_FailedtoReportList__item___item__id._const_tab = ____RAB_FailedtoReportList__item___item__id_tab
    ___RAB_FailedtoReportList__item___item__id._const_tab_at = None
    ___RAB_FailedtoReportList__item___item__id._const_tab_id = 'id'
    ___RAB_FailedtoReportList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_FailedtoReportList__item___item__criticality._const_tab = ____RAB_FailedtoReportList__item___item__id_tab
    ___RAB_FailedtoReportList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_FailedtoReportList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_FailedtoReportList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_FailedtoReportList__item___item__value._const_tab = ____RAB_FailedtoReportList__item___item__id_tab
    ___RAB_FailedtoReportList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_FailedtoReportList__item___item__value._const_tab_id = 'Value'
    __RAB_FailedtoReportList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_FailedtoReportList__item___item__id),
        ('criticality', ___RAB_FailedtoReportList__item___item__criticality),
        ('value', ___RAB_FailedtoReportList__item___item__value),
        ])
    __RAB_FailedtoReportList__item___item_._ext = None
    _RAB_FailedtoReportList__item_._cont = __RAB_FailedtoReportList__item___item_
    _RAB_FailedtoReportList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_FailedtoReportList._cont = _RAB_FailedtoReportList__item_
    RAB_FailedtoReportList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RABs-failed-to-reportItemIEs >-----#
    RABs_failed_to_reportItemIEs = CLASS(name='RABs-failed-to-reportItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RABs_failed_to_reportItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RABs-failed-to-reportItem')))
    RABs_failed_to_reportItemIEs._val = ASN1Set(rv=[dict([('id', 71), ('criticality', 'ignore'), ('Value', _RABs_failed_to_reportItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RABs-failed-to-reportItem >-----#
    RABs_failed_to_reportItem = SEQ(name='RABs-failed-to-reportItem', mode=MODE_TYPE)
    _RABs_failed_to_reportItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RABs_failed_to_reportItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RABs_failed_to_reportItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RABs_failed_to_reportItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RABs_failed_to_reportItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RABs_failed_to_reportItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_failed_to_reportItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_failed_to_reportItem_iE_Extensions__item__id._const_tab = ____RABs_failed_to_reportItem_iE_Extensions__item__id_tab
    ___RABs_failed_to_reportItem_iE_Extensions__item__id._const_tab_at = None
    ___RABs_failed_to_reportItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RABs_failed_to_reportItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RABs_failed_to_reportItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_failed_to_reportItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_failed_to_reportItem_iE_Extensions__item__criticality._const_tab = ____RABs_failed_to_reportItem_iE_Extensions__item__criticality_tab
    ___RABs_failed_to_reportItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RABs_failed_to_reportItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RABs_failed_to_reportItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RABs_failed_to_reportItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue._const_tab = ____RABs_failed_to_reportItem_iE_Extensions__item__extensionValue_tab
    ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RABs_failed_to_reportItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RABs_failed_to_reportItem_iE_Extensions__item__id),
        ('criticality', ___RABs_failed_to_reportItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue),
        ])
    __RABs_failed_to_reportItem_iE_Extensions__item_._ext = None
    _RABs_failed_to_reportItem_iE_Extensions._cont = __RABs_failed_to_reportItem_iE_Extensions__item_
    _RABs_failed_to_reportItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RABs_failed_to_reportItem._cont = ASN1Dict([
        ('rAB-ID', _RABs_failed_to_reportItem_rAB_ID),
        ('cause', _RABs_failed_to_reportItem_cause),
        ('iE-Extensions', _RABs_failed_to_reportItem_iE_Extensions),
        ])
    RABs_failed_to_reportItem._ext = []
    
    #-----< RABs-failed-to-reportItem-ExtIEs >-----#
    RABs_failed_to_reportItem_ExtIEs = CLASS(name='RABs-failed-to-reportItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RABs_failed_to_reportItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Reset >-----#
    Reset = SEQ(name='Reset', mode=MODE_TYPE)
    _Reset_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Reset_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Reset_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____Reset_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Reset_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____Reset_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____Reset_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____Reset_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____Reset_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Reset_protocolIEs__item__id._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__id._const_tab_at = None
    ___Reset_protocolIEs__item__id._const_tab_id = 'id'
    ___Reset_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___Reset_protocolIEs__item__criticality._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Reset_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Reset_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___Reset_protocolIEs__item__value._const_tab = ____Reset_protocolIEs__item__id_tab
    ___Reset_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Reset_protocolIEs__item__value._const_tab_id = 'Value'
    __Reset_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Reset_protocolIEs__item__id),
        ('criticality', ___Reset_protocolIEs__item__criticality),
        ('value', ___Reset_protocolIEs__item__value),
        ])
    __Reset_protocolIEs__item_._ext = None
    _Reset_protocolIEs._cont = __Reset_protocolIEs__item_
    _Reset_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Reset_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Reset_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Reset_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Reset_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Reset_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____Reset_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____Reset_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____Reset_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _____Reset_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Reset_protocolExtensions__item__id._const_tab = ____Reset_protocolExtensions__item__id_tab
    ___Reset_protocolExtensions__item__id._const_tab_at = None
    ___Reset_protocolExtensions__item__id._const_tab_id = 'id'
    ___Reset_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Reset_protocolExtensions__item__criticality._const_tab = ____Reset_protocolExtensions__item__id_tab
    ___Reset_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Reset_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Reset_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Reset_protocolExtensions__item__extensionValue._const_tab = ____Reset_protocolExtensions__item__id_tab
    ___Reset_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Reset_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Reset_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Reset_protocolExtensions__item__id),
        ('criticality', ___Reset_protocolExtensions__item__criticality),
        ('extensionValue', ___Reset_protocolExtensions__item__extensionValue),
        ])
    __Reset_protocolExtensions__item_._ext = None
    _Reset_protocolExtensions._cont = __Reset_protocolExtensions__item_
    _Reset_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Reset._cont = ASN1Dict([
        ('protocolIEs', _Reset_protocolIEs),
        ('protocolExtensions', _Reset_protocolExtensions),
        ])
    Reset._ext = []
    
    #-----< ResetIEs >-----#
    ResetIEs = CLASS(name='ResetIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _ResetIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _ResetIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ResetIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _ResetIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _ResetIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _ResetIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetExtensions >-----#
    ResetExtensions = CLASS(name='ResetExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _ResetExtensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ResetExtensions._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _ResetExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _ResetExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetAcknowledge >-----#
    ResetAcknowledge = SEQ(name='ResetAcknowledge', mode=MODE_TYPE)
    _ResetAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ResetAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ResetAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____ResetAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____ResetAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'reject'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetAcknowledge_protocolIEs__item__id._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ResetAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___ResetAcknowledge_protocolIEs__item__value._const_tab = ____ResetAcknowledge_protocolIEs__item__id_tab
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetAcknowledge_protocolIEs__item__id),
        ('criticality', ___ResetAcknowledge_protocolIEs__item__criticality),
        ('value', ___ResetAcknowledge_protocolIEs__item__value),
        ])
    __ResetAcknowledge_protocolIEs__item_._ext = None
    _ResetAcknowledge_protocolIEs._cont = __ResetAcknowledge_protocolIEs__item_
    _ResetAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResetAcknowledge_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetAcknowledge_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResetAcknowledge_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____ResetAcknowledge_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____ResetAcknowledge_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetAcknowledge_protocolExtensions__item__id._const_tab = ____ResetAcknowledge_protocolExtensions__item__id_tab
    ___ResetAcknowledge_protocolExtensions__item__id._const_tab_at = None
    ___ResetAcknowledge_protocolExtensions__item__id._const_tab_id = 'id'
    ___ResetAcknowledge_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ResetAcknowledge_protocolExtensions__item__criticality._const_tab = ____ResetAcknowledge_protocolExtensions__item__id_tab
    ___ResetAcknowledge_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResetAcknowledge_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ResetAcknowledge_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ResetAcknowledge_protocolExtensions__item__extensionValue._const_tab = ____ResetAcknowledge_protocolExtensions__item__id_tab
    ___ResetAcknowledge_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResetAcknowledge_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ResetAcknowledge_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ResetAcknowledge_protocolExtensions__item__id),
        ('criticality', ___ResetAcknowledge_protocolExtensions__item__criticality),
        ('extensionValue', ___ResetAcknowledge_protocolExtensions__item__extensionValue),
        ])
    __ResetAcknowledge_protocolExtensions__item_._ext = None
    _ResetAcknowledge_protocolExtensions._cont = __ResetAcknowledge_protocolExtensions__item_
    _ResetAcknowledge_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _ResetAcknowledge_protocolIEs),
        ('protocolExtensions', _ResetAcknowledge_protocolExtensions),
        ])
    ResetAcknowledge._ext = []
    
    #-----< ResetAcknowledgeIEs >-----#
    ResetAcknowledgeIEs = CLASS(name='ResetAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetAcknowledgeIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _ResetAcknowledgeIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _ResetAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ResetAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'reject'), ('Value', _ResetAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _ResetAcknowledgeIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _ResetAcknowledgeIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetAcknowledgeExtensions >-----#
    ResetAcknowledgeExtensions = CLASS(name='ResetAcknowledgeExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetAcknowledgeExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _ResetAcknowledgeExtensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ResetAcknowledgeExtensions._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _ResetAcknowledgeExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _ResetAcknowledgeExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResource >-----#
    ResetResource = SEQ(name='ResetResource', mode=MODE_TYPE)
    _ResetResource_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ResetResource_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ResetResource_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____ResetResource_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ResetResource_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____ResetResource_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____ResetResource_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceList')))
    _____ResetResource_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____ResetResource_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'reject'), ('Value', _____ResetResource_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____ResetResource_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____ResetResource_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____ResetResource_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetResource_protocolIEs__item__id._const_tab = ____ResetResource_protocolIEs__item__id_tab
    ___ResetResource_protocolIEs__item__id._const_tab_at = None
    ___ResetResource_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetResource_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___ResetResource_protocolIEs__item__criticality._const_tab = ____ResetResource_protocolIEs__item__id_tab
    ___ResetResource_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetResource_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetResource_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___ResetResource_protocolIEs__item__value._const_tab = ____ResetResource_protocolIEs__item__id_tab
    ___ResetResource_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetResource_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetResource_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetResource_protocolIEs__item__id),
        ('criticality', ___ResetResource_protocolIEs__item__criticality),
        ('value', ___ResetResource_protocolIEs__item__value),
        ])
    __ResetResource_protocolIEs__item_._ext = None
    _ResetResource_protocolIEs._cont = __ResetResource_protocolIEs__item_
    _ResetResource_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResetResource_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetResource_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResetResource_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____ResetResource_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ResetResource_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____ResetResource_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____ResetResource_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____ResetResource_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _____ResetResource_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetResource_protocolExtensions__item__id._const_tab = ____ResetResource_protocolExtensions__item__id_tab
    ___ResetResource_protocolExtensions__item__id._const_tab_at = None
    ___ResetResource_protocolExtensions__item__id._const_tab_id = 'id'
    ___ResetResource_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ResetResource_protocolExtensions__item__criticality._const_tab = ____ResetResource_protocolExtensions__item__id_tab
    ___ResetResource_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResetResource_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ResetResource_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ResetResource_protocolExtensions__item__extensionValue._const_tab = ____ResetResource_protocolExtensions__item__id_tab
    ___ResetResource_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResetResource_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ResetResource_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ResetResource_protocolExtensions__item__id),
        ('criticality', ___ResetResource_protocolExtensions__item__criticality),
        ('extensionValue', ___ResetResource_protocolExtensions__item__extensionValue),
        ])
    __ResetResource_protocolExtensions__item_._ext = None
    _ResetResource_protocolExtensions._cont = __ResetResource_protocolExtensions__item_
    _ResetResource_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetResource._cont = ASN1Dict([
        ('protocolIEs', _ResetResource_protocolIEs),
        ('protocolExtensions', _ResetResource_protocolExtensions),
        ])
    ResetResource._ext = []
    
    #-----< ResetResourceIEs >-----#
    ResetResourceIEs = CLASS(name='ResetResourceIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetResourceIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _ResetResourceIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _ResetResourceIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceList')))
    _ResetResourceIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ResetResourceIEs._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'reject'), ('Value', _ResetResourceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _ResetResourceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _ResetResourceIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _ResetResourceIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceList >-----#
    ResetResourceList = SEQ_OF(name='ResetResourceList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'IuSigConId-IE-ContainerList')))
    _ResetResourceList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ResetResourceList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ResetResourceList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____ResetResourceList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ResetResourceList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceItem')))
    ____ResetResourceList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____ResetResourceList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ResetResourceList__item___item__id._const_tab = ____ResetResourceList__item___item__id_tab
    ___ResetResourceList__item___item__id._const_tab_at = None
    ___ResetResourceList__item___item__id._const_tab_id = 'id'
    ___ResetResourceList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___ResetResourceList__item___item__criticality._const_tab = ____ResetResourceList__item___item__id_tab
    ___ResetResourceList__item___item__criticality._const_tab_at = ('..', 'id')
    ___ResetResourceList__item___item__criticality._const_tab_id = 'criticality'
    ___ResetResourceList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___ResetResourceList__item___item__value._const_tab = ____ResetResourceList__item___item__id_tab
    ___ResetResourceList__item___item__value._const_tab_at = ('..', 'id')
    ___ResetResourceList__item___item__value._const_tab_id = 'Value'
    __ResetResourceList__item___item_._cont = ASN1Dict([
        ('id', ___ResetResourceList__item___item__id),
        ('criticality', ___ResetResourceList__item___item__criticality),
        ('value', ___ResetResourceList__item___item__value),
        ])
    __ResetResourceList__item___item_._ext = None
    _ResetResourceList__item_._cont = __ResetResourceList__item___item_
    _ResetResourceList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetResourceList._cont = _ResetResourceList__item_
    ResetResourceList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=250)], ev=None, er=[])
    
    #-----< ResetResourceItemIEs >-----#
    ResetResourceItemIEs = CLASS(name='ResetResourceItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetResourceItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceItem')))
    ResetResourceItemIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _ResetResourceItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceItem >-----#
    ResetResourceItem = SEQ(name='ResetResourceItem', mode=MODE_TYPE)
    _ResetResourceItem_iuSigConId = BIT_STR(name='iuSigConId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _ResetResourceItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetResourceItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResetResourceItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____ResetResourceItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ResetResourceItem_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    ____ResetResourceItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 282), ('criticality', 'reject'), ('Extension', _____ResetResourceItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetResourceItem_iE_Extensions__item__id._const_tab = ____ResetResourceItem_iE_Extensions__item__id_tab
    ___ResetResourceItem_iE_Extensions__item__id._const_tab_at = None
    ___ResetResourceItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResetResourceItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ResetResourceItem_iE_Extensions__item__criticality._const_tab = ____ResetResourceItem_iE_Extensions__item__id_tab
    ___ResetResourceItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResetResourceItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResetResourceItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ResetResourceItem_iE_Extensions__item__extensionValue._const_tab = ____ResetResourceItem_iE_Extensions__item__id_tab
    ___ResetResourceItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResetResourceItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResetResourceItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResetResourceItem_iE_Extensions__item__id),
        ('criticality', ___ResetResourceItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ResetResourceItem_iE_Extensions__item__extensionValue),
        ])
    __ResetResourceItem_iE_Extensions__item_._ext = None
    _ResetResourceItem_iE_Extensions._cont = __ResetResourceItem_iE_Extensions__item_
    _ResetResourceItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetResourceItem._cont = ASN1Dict([
        ('iuSigConId', _ResetResourceItem_iuSigConId),
        ('iE-Extensions', _ResetResourceItem_iE_Extensions),
        ])
    ResetResourceItem._ext = []
    
    #-----< ResetResourceItem-ExtIEs >-----#
    ResetResourceItem_ExtIEs = CLASS(name='ResetResourceItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetResourceItem_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    ResetResourceItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 282), ('criticality', 'reject'), ('Extension', _ResetResourceItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceExtensions >-----#
    ResetResourceExtensions = CLASS(name='ResetResourceExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetResourceExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _ResetResourceExtensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ResetResourceExtensions._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _ResetResourceExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _ResetResourceExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceAcknowledge >-----#
    ResetResourceAcknowledge = SEQ(name='ResetResourceAcknowledge', mode=MODE_TYPE)
    _ResetResourceAcknowledge_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ResetResourceAcknowledge_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ResetResourceAcknowledge_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____ResetResourceAcknowledge_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAckList')))
    _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____ResetResourceAcknowledge_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'reject'), ('Value', _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetResourceAcknowledge_protocolIEs__item__id._const_tab = ____ResetResourceAcknowledge_protocolIEs__item__id_tab
    ___ResetResourceAcknowledge_protocolIEs__item__id._const_tab_at = None
    ___ResetResourceAcknowledge_protocolIEs__item__id._const_tab_id = 'id'
    ___ResetResourceAcknowledge_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___ResetResourceAcknowledge_protocolIEs__item__criticality._const_tab = ____ResetResourceAcknowledge_protocolIEs__item__id_tab
    ___ResetResourceAcknowledge_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ResetResourceAcknowledge_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ResetResourceAcknowledge_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___ResetResourceAcknowledge_protocolIEs__item__value._const_tab = ____ResetResourceAcknowledge_protocolIEs__item__id_tab
    ___ResetResourceAcknowledge_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ResetResourceAcknowledge_protocolIEs__item__value._const_tab_id = 'Value'
    __ResetResourceAcknowledge_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ResetResourceAcknowledge_protocolIEs__item__id),
        ('criticality', ___ResetResourceAcknowledge_protocolIEs__item__criticality),
        ('value', ___ResetResourceAcknowledge_protocolIEs__item__value),
        ])
    __ResetResourceAcknowledge_protocolIEs__item_._ext = None
    _ResetResourceAcknowledge_protocolIEs._cont = __ResetResourceAcknowledge_protocolIEs__item_
    _ResetResourceAcknowledge_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ResetResourceAcknowledge_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetResourceAcknowledge_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResetResourceAcknowledge_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____ResetResourceAcknowledge_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____ResetResourceAcknowledge_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetResourceAcknowledge_protocolExtensions__item__id._const_tab = ____ResetResourceAcknowledge_protocolExtensions__item__id_tab
    ___ResetResourceAcknowledge_protocolExtensions__item__id._const_tab_at = None
    ___ResetResourceAcknowledge_protocolExtensions__item__id._const_tab_id = 'id'
    ___ResetResourceAcknowledge_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ResetResourceAcknowledge_protocolExtensions__item__criticality._const_tab = ____ResetResourceAcknowledge_protocolExtensions__item__id_tab
    ___ResetResourceAcknowledge_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResetResourceAcknowledge_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue._const_tab = ____ResetResourceAcknowledge_protocolExtensions__item__id_tab
    ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ResetResourceAcknowledge_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ResetResourceAcknowledge_protocolExtensions__item__id),
        ('criticality', ___ResetResourceAcknowledge_protocolExtensions__item__criticality),
        ('extensionValue', ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue),
        ])
    __ResetResourceAcknowledge_protocolExtensions__item_._ext = None
    _ResetResourceAcknowledge_protocolExtensions._cont = __ResetResourceAcknowledge_protocolExtensions__item_
    _ResetResourceAcknowledge_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetResourceAcknowledge._cont = ASN1Dict([
        ('protocolIEs', _ResetResourceAcknowledge_protocolIEs),
        ('protocolExtensions', _ResetResourceAcknowledge_protocolExtensions),
        ])
    ResetResourceAcknowledge._ext = []
    
    #-----< ResetResourceAcknowledgeIEs >-----#
    ResetResourceAcknowledgeIEs = CLASS(name='ResetResourceAcknowledgeIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetResourceAcknowledgeIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _ResetResourceAcknowledgeIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAckList')))
    _ResetResourceAcknowledgeIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _ResetResourceAcknowledgeIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ResetResourceAcknowledgeIEs._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'reject'), ('Value', _ResetResourceAcknowledgeIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 77), ('criticality', 'ignore'), ('Value', _ResetResourceAcknowledgeIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _ResetResourceAcknowledgeIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _ResetResourceAcknowledgeIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceAckList >-----#
    ResetResourceAckList = SEQ_OF(name='ResetResourceAckList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'IuSigConId-IE-ContainerList')))
    _ResetResourceAckList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ResetResourceAckList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ResetResourceAckList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____ResetResourceAckList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ResetResourceAckList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAckItem')))
    ____ResetResourceAckList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _____ResetResourceAckList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ResetResourceAckList__item___item__id._const_tab = ____ResetResourceAckList__item___item__id_tab
    ___ResetResourceAckList__item___item__id._const_tab_at = None
    ___ResetResourceAckList__item___item__id._const_tab_id = 'id'
    ___ResetResourceAckList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___ResetResourceAckList__item___item__criticality._const_tab = ____ResetResourceAckList__item___item__id_tab
    ___ResetResourceAckList__item___item__criticality._const_tab_at = ('..', 'id')
    ___ResetResourceAckList__item___item__criticality._const_tab_id = 'criticality'
    ___ResetResourceAckList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___ResetResourceAckList__item___item__value._const_tab = ____ResetResourceAckList__item___item__id_tab
    ___ResetResourceAckList__item___item__value._const_tab_at = ('..', 'id')
    ___ResetResourceAckList__item___item__value._const_tab_id = 'Value'
    __ResetResourceAckList__item___item_._cont = ASN1Dict([
        ('id', ___ResetResourceAckList__item___item__id),
        ('criticality', ___ResetResourceAckList__item___item__criticality),
        ('value', ___ResetResourceAckList__item___item__value),
        ])
    __ResetResourceAckList__item___item_._ext = None
    _ResetResourceAckList__item_._cont = __ResetResourceAckList__item___item_
    _ResetResourceAckList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    ResetResourceAckList._cont = _ResetResourceAckList__item_
    ResetResourceAckList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=250)], ev=None, er=[])
    
    #-----< ResetResourceAckItemIEs >-----#
    ResetResourceAckItemIEs = CLASS(name='ResetResourceAckItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ResetResourceAckItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAckItem')))
    ResetResourceAckItemIEs._val = ASN1Set(rv=[dict([('id', 78), ('criticality', 'reject'), ('Value', _ResetResourceAckItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceAckItem >-----#
    ResetResourceAckItem = SEQ(name='ResetResourceAckItem', mode=MODE_TYPE)
    _ResetResourceAckItem_iuSigConId = BIT_STR(name='iuSigConId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _ResetResourceAckItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ResetResourceAckItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ResetResourceAckItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____ResetResourceAckItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ResetResourceAckItem_iE_Extensions__item__id_tab_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    ____ResetResourceAckItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 282), ('criticality', 'ignore'), ('Extension', _____ResetResourceAckItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ResetResourceAckItem_iE_Extensions__item__id._const_tab = ____ResetResourceAckItem_iE_Extensions__item__id_tab
    ___ResetResourceAckItem_iE_Extensions__item__id._const_tab_at = None
    ___ResetResourceAckItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___ResetResourceAckItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ResetResourceAckItem_iE_Extensions__item__criticality._const_tab = ____ResetResourceAckItem_iE_Extensions__item__id_tab
    ___ResetResourceAckItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___ResetResourceAckItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___ResetResourceAckItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ResetResourceAckItem_iE_Extensions__item__extensionValue._const_tab = ____ResetResourceAckItem_iE_Extensions__item__id_tab
    ___ResetResourceAckItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ResetResourceAckItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __ResetResourceAckItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___ResetResourceAckItem_iE_Extensions__item__id),
        ('criticality', ___ResetResourceAckItem_iE_Extensions__item__criticality),
        ('extensionValue', ___ResetResourceAckItem_iE_Extensions__item__extensionValue),
        ])
    __ResetResourceAckItem_iE_Extensions__item_._ext = None
    _ResetResourceAckItem_iE_Extensions._cont = __ResetResourceAckItem_iE_Extensions__item_
    _ResetResourceAckItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ResetResourceAckItem._cont = ASN1Dict([
        ('iuSigConId', _ResetResourceAckItem_iuSigConId),
        ('iE-Extensions', _ResetResourceAckItem_iE_Extensions),
        ])
    ResetResourceAckItem._ext = []
    
    #-----< ResetResourceAckItem-ExtIEs >-----#
    ResetResourceAckItem_ExtIEs = CLASS(name='ResetResourceAckItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetResourceAckItem_ExtIEs_val_Extension_0 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    ResetResourceAckItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 282), ('criticality', 'ignore'), ('Extension', _ResetResourceAckItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ResetResourceAcknowledgeExtensions >-----#
    ResetResourceAcknowledgeExtensions = CLASS(name='ResetResourceAcknowledgeExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ResetResourceAcknowledgeExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _ResetResourceAcknowledgeExtensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ResetResourceAcknowledgeExtensions._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _ResetResourceAcknowledgeExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _ResetResourceAcknowledgeExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleaseRequest >-----#
    RAB_ReleaseRequest = SEQ(name='RAB-ReleaseRequest', mode=MODE_TYPE)
    _RAB_ReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_ReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseList')))
    ____RAB_ReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Value', _____RAB_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ReleaseRequest_protocolIEs__item__id._const_tab = ____RAB_ReleaseRequest_protocolIEs__item__id_tab
    ___RAB_ReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___RAB_ReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RAB_ReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_ReleaseRequest_protocolIEs__item__criticality._const_tab = ____RAB_ReleaseRequest_protocolIEs__item__id_tab
    ___RAB_ReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RAB_ReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_ReleaseRequest_protocolIEs__item__value._const_tab = ____RAB_ReleaseRequest_protocolIEs__item__id_tab
    ___RAB_ReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RAB_ReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RAB_ReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RAB_ReleaseRequest_protocolIEs__item__id),
        ('criticality', ___RAB_ReleaseRequest_protocolIEs__item__criticality),
        ('value', ___RAB_ReleaseRequest_protocolIEs__item__value),
        ])
    __RAB_ReleaseRequest_protocolIEs__item_._ext = None
    _RAB_ReleaseRequest_protocolIEs._cont = __RAB_ReleaseRequest_protocolIEs__item_
    _RAB_ReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RAB_ReleaseRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ReleaseRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ReleaseRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_ReleaseRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseRequest_protocolExtensions__item__id._const_tab = ____RAB_ReleaseRequest_protocolExtensions__item__id_tab
    ___RAB_ReleaseRequest_protocolExtensions__item__id._const_tab_at = None
    ___RAB_ReleaseRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___RAB_ReleaseRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_ReleaseRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseRequest_protocolExtensions__item__criticality._const_tab = ____RAB_ReleaseRequest_protocolExtensions__item__criticality_tab
    ___RAB_ReleaseRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ReleaseRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_ReleaseRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab = ____RAB_ReleaseRequest_protocolExtensions__item__extensionValue_tab
    ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_ReleaseRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RAB_ReleaseRequest_protocolExtensions__item__id),
        ('criticality', ___RAB_ReleaseRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue),
        ])
    __RAB_ReleaseRequest_protocolExtensions__item_._ext = None
    _RAB_ReleaseRequest_protocolExtensions._cont = __RAB_ReleaseRequest_protocolExtensions__item_
    _RAB_ReleaseRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _RAB_ReleaseRequest_protocolIEs),
        ('protocolExtensions', _RAB_ReleaseRequest_protocolExtensions),
        ])
    RAB_ReleaseRequest._ext = []
    
    #-----< RAB-ReleaseRequestIEs >-----#
    RAB_ReleaseRequestIEs = CLASS(name='RAB-ReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ReleaseRequestIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseList')))
    RAB_ReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 41), ('criticality', 'ignore'), ('Value', _RAB_ReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleaseList >-----#
    RAB_ReleaseList = SEQ_OF(name='RAB-ReleaseList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ReleaseList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ReleaseList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ReleaseList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_ReleaseList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ReleaseList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseItem')))
    ____RAB_ReleaseList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'ignore'), ('Value', _____RAB_ReleaseList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ReleaseList__item___item__id._const_tab = ____RAB_ReleaseList__item___item__id_tab
    ___RAB_ReleaseList__item___item__id._const_tab_at = None
    ___RAB_ReleaseList__item___item__id._const_tab_id = 'id'
    ___RAB_ReleaseList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_ReleaseList__item___item__criticality._const_tab = ____RAB_ReleaseList__item___item__id_tab
    ___RAB_ReleaseList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ReleaseList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_ReleaseList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_ReleaseList__item___item__value._const_tab = ____RAB_ReleaseList__item___item__id_tab
    ___RAB_ReleaseList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_ReleaseList__item___item__value._const_tab_id = 'Value'
    __RAB_ReleaseList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_ReleaseList__item___item__id),
        ('criticality', ___RAB_ReleaseList__item___item__criticality),
        ('value', ___RAB_ReleaseList__item___item__value),
        ])
    __RAB_ReleaseList__item___item_._ext = None
    _RAB_ReleaseList__item_._cont = __RAB_ReleaseList__item___item_
    _RAB_ReleaseList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ReleaseList._cont = _RAB_ReleaseList__item_
    RAB_ReleaseList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ReleaseItemIEs >-----#
    RAB_ReleaseItemIEs = CLASS(name='RAB-ReleaseItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ReleaseItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseItem')))
    RAB_ReleaseItemIEs._val = ASN1Set(rv=[dict([('id', 40), ('criticality', 'ignore'), ('Value', _RAB_ReleaseItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleaseItem >-----#
    RAB_ReleaseItem = SEQ(name='RAB-ReleaseItem', mode=MODE_TYPE)
    _RAB_ReleaseItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ReleaseItem_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RAB_ReleaseItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ReleaseItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ReleaseItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_ReleaseItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseItem_iE_Extensions__item__id._const_tab = ____RAB_ReleaseItem_iE_Extensions__item__id_tab
    ___RAB_ReleaseItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ReleaseItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_ReleaseItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_ReleaseItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseItem_iE_Extensions__item__criticality._const_tab = ____RAB_ReleaseItem_iE_Extensions__item__criticality_tab
    ___RAB_ReleaseItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ReleaseItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_ReleaseItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_ReleaseItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleaseItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleaseItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_ReleaseItem_iE_Extensions__item__extensionValue_tab
    ___RAB_ReleaseItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_ReleaseItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_ReleaseItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_ReleaseItem_iE_Extensions__item__id),
        ('criticality', ___RAB_ReleaseItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_ReleaseItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_ReleaseItem_iE_Extensions__item_._ext = None
    _RAB_ReleaseItem_iE_Extensions._cont = __RAB_ReleaseItem_iE_Extensions__item_
    _RAB_ReleaseItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ReleaseItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_ReleaseItem_rAB_ID),
        ('cause', _RAB_ReleaseItem_cause),
        ('iE-Extensions', _RAB_ReleaseItem_iE_Extensions),
        ])
    RAB_ReleaseItem._ext = []
    
    #-----< RAB-ReleaseItem-ExtIEs >-----#
    RAB_ReleaseItem_ExtIEs = CLASS(name='RAB-ReleaseItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ReleaseItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleaseRequestExtensions >-----#
    RAB_ReleaseRequestExtensions = CLASS(name='RAB-ReleaseRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ReleaseRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Iu-ReleaseRequest >-----#
    Iu_ReleaseRequest = SEQ(name='Iu-ReleaseRequest', mode=MODE_TYPE)
    _Iu_ReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Iu_ReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Iu_ReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____Iu_ReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Iu_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____Iu_ReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____Iu_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___Iu_ReleaseRequest_protocolIEs__item__id._const_tab = ____Iu_ReleaseRequest_protocolIEs__item__id_tab
    ___Iu_ReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___Iu_ReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___Iu_ReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___Iu_ReleaseRequest_protocolIEs__item__criticality._const_tab = ____Iu_ReleaseRequest_protocolIEs__item__id_tab
    ___Iu_ReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Iu_ReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Iu_ReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___Iu_ReleaseRequest_protocolIEs__item__value._const_tab = ____Iu_ReleaseRequest_protocolIEs__item__id_tab
    ___Iu_ReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Iu_ReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __Iu_ReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Iu_ReleaseRequest_protocolIEs__item__id),
        ('criticality', ___Iu_ReleaseRequest_protocolIEs__item__criticality),
        ('value', ___Iu_ReleaseRequest_protocolIEs__item__value),
        ])
    __Iu_ReleaseRequest_protocolIEs__item_._ext = None
    _Iu_ReleaseRequest_protocolIEs._cont = __Iu_ReleaseRequest_protocolIEs__item_
    _Iu_ReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Iu_ReleaseRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Iu_ReleaseRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Iu_ReleaseRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Iu_ReleaseRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseRequest_protocolExtensions__item__id._const_tab = ____Iu_ReleaseRequest_protocolExtensions__item__id_tab
    ___Iu_ReleaseRequest_protocolExtensions__item__id._const_tab_at = None
    ___Iu_ReleaseRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___Iu_ReleaseRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____Iu_ReleaseRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseRequest_protocolExtensions__item__criticality._const_tab = ____Iu_ReleaseRequest_protocolExtensions__item__criticality_tab
    ___Iu_ReleaseRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Iu_ReleaseRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____Iu_ReleaseRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____Iu_ReleaseRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab = ____Iu_ReleaseRequest_protocolExtensions__item__extensionValue_tab
    ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Iu_ReleaseRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Iu_ReleaseRequest_protocolExtensions__item__id),
        ('criticality', ___Iu_ReleaseRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue),
        ])
    __Iu_ReleaseRequest_protocolExtensions__item_._ext = None
    _Iu_ReleaseRequest_protocolExtensions._cont = __Iu_ReleaseRequest_protocolExtensions__item_
    _Iu_ReleaseRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Iu_ReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _Iu_ReleaseRequest_protocolIEs),
        ('protocolExtensions', _Iu_ReleaseRequest_protocolExtensions),
        ])
    Iu_ReleaseRequest._ext = []
    
    #-----< Iu-ReleaseRequestIEs >-----#
    Iu_ReleaseRequestIEs = CLASS(name='Iu-ReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _Iu_ReleaseRequestIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    Iu_ReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _Iu_ReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< Iu-ReleaseRequestExtensions >-----#
    Iu_ReleaseRequestExtensions = CLASS(name='Iu-ReleaseRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    Iu_ReleaseRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationDetect >-----#
    RelocationDetect = SEQ(name='RelocationDetect', mode=MODE_TYPE)
    _RelocationDetect_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationDetect_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationDetect_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RelocationDetect_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationDetect_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolIEs__item__id._const_tab = ____RelocationDetect_protocolIEs__item__id_tab
    ___RelocationDetect_protocolIEs__item__id._const_tab_at = None
    ___RelocationDetect_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationDetect_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ____RelocationDetect_protocolIEs__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationDetect_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolIEs__item__criticality._const_tab = ____RelocationDetect_protocolIEs__item__criticality_tab
    ___RelocationDetect_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationDetect_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationDetect_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ____RelocationDetect_protocolIEs__item__value_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationDetect_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolIEs__item__value._const_tab = ____RelocationDetect_protocolIEs__item__value_tab
    ___RelocationDetect_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationDetect_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationDetect_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationDetect_protocolIEs__item__id),
        ('criticality', ___RelocationDetect_protocolIEs__item__criticality),
        ('value', ___RelocationDetect_protocolIEs__item__value),
        ])
    __RelocationDetect_protocolIEs__item_._ext = None
    _RelocationDetect_protocolIEs._cont = __RelocationDetect_protocolIEs__item_
    _RelocationDetect_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationDetect_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationDetect_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationDetect_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationDetect_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationDetect_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolExtensions__item__id._const_tab = ____RelocationDetect_protocolExtensions__item__id_tab
    ___RelocationDetect_protocolExtensions__item__id._const_tab_at = None
    ___RelocationDetect_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationDetect_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RelocationDetect_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationDetect_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolExtensions__item__criticality._const_tab = ____RelocationDetect_protocolExtensions__item__criticality_tab
    ___RelocationDetect_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationDetect_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationDetect_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RelocationDetect_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RelocationDetect_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationDetect_protocolExtensions__item__extensionValue._const_tab = ____RelocationDetect_protocolExtensions__item__extensionValue_tab
    ___RelocationDetect_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationDetect_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationDetect_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationDetect_protocolExtensions__item__id),
        ('criticality', ___RelocationDetect_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationDetect_protocolExtensions__item__extensionValue),
        ])
    __RelocationDetect_protocolExtensions__item_._ext = None
    _RelocationDetect_protocolExtensions._cont = __RelocationDetect_protocolExtensions__item_
    _RelocationDetect_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationDetect._cont = ASN1Dict([
        ('protocolIEs', _RelocationDetect_protocolIEs),
        ('protocolExtensions', _RelocationDetect_protocolExtensions),
        ])
    RelocationDetect._ext = []
    
    #-----< RelocationDetectIEs >-----#
    RelocationDetectIEs = CLASS(name='RelocationDetectIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    RelocationDetectIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationDetectExtensions >-----#
    RelocationDetectExtensions = CLASS(name='RelocationDetectExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RelocationDetectExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationComplete >-----#
    RelocationComplete = SEQ(name='RelocationComplete', mode=MODE_TYPE)
    _RelocationComplete_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RelocationComplete_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RelocationComplete_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RelocationComplete_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationComplete_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolIEs__item__id._const_tab = ____RelocationComplete_protocolIEs__item__id_tab
    ___RelocationComplete_protocolIEs__item__id._const_tab_at = None
    ___RelocationComplete_protocolIEs__item__id._const_tab_id = 'id'
    ___RelocationComplete_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ____RelocationComplete_protocolIEs__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationComplete_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolIEs__item__criticality._const_tab = ____RelocationComplete_protocolIEs__item__criticality_tab
    ___RelocationComplete_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationComplete_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RelocationComplete_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ____RelocationComplete_protocolIEs__item__value_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RelocationComplete_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolIEs__item__value._const_tab = ____RelocationComplete_protocolIEs__item__value_tab
    ___RelocationComplete_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RelocationComplete_protocolIEs__item__value._const_tab_id = 'Value'
    __RelocationComplete_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RelocationComplete_protocolIEs__item__id),
        ('criticality', ___RelocationComplete_protocolIEs__item__criticality),
        ('value', ___RelocationComplete_protocolIEs__item__value),
        ])
    __RelocationComplete_protocolIEs__item_._ext = None
    _RelocationComplete_protocolIEs._cont = __RelocationComplete_protocolIEs__item_
    _RelocationComplete_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RelocationComplete_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RelocationComplete_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RelocationComplete_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RelocationComplete_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    ____RelocationComplete_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 250), ('criticality', 'ignore'), ('Extension', _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Extension', _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Extension', _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RelocationComplete_protocolExtensions__item__id._const_tab = ____RelocationComplete_protocolExtensions__item__id_tab
    ___RelocationComplete_protocolExtensions__item__id._const_tab_at = None
    ___RelocationComplete_protocolExtensions__item__id._const_tab_id = 'id'
    ___RelocationComplete_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RelocationComplete_protocolExtensions__item__criticality._const_tab = ____RelocationComplete_protocolExtensions__item__id_tab
    ___RelocationComplete_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RelocationComplete_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RelocationComplete_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RelocationComplete_protocolExtensions__item__extensionValue._const_tab = ____RelocationComplete_protocolExtensions__item__id_tab
    ___RelocationComplete_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RelocationComplete_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RelocationComplete_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RelocationComplete_protocolExtensions__item__id),
        ('criticality', ___RelocationComplete_protocolExtensions__item__criticality),
        ('extensionValue', ___RelocationComplete_protocolExtensions__item__extensionValue),
        ])
    __RelocationComplete_protocolExtensions__item_._ext = None
    _RelocationComplete_protocolExtensions._cont = __RelocationComplete_protocolExtensions__item_
    _RelocationComplete_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RelocationComplete._cont = ASN1Dict([
        ('protocolIEs', _RelocationComplete_protocolIEs),
        ('protocolExtensions', _RelocationComplete_protocolExtensions),
        ])
    RelocationComplete._ext = []
    
    #-----< RelocationCompleteIEs >-----#
    RelocationCompleteIEs = CLASS(name='RelocationCompleteIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    RelocationCompleteIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RelocationCompleteExtensions >-----#
    RelocationCompleteExtensions = CLASS(name='RelocationCompleteExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RelocationCompleteExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _RelocationCompleteExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _RelocationCompleteExtensions_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    RelocationCompleteExtensions._val = ASN1Set(rv=[dict([('id', 250), ('criticality', 'ignore'), ('Extension', _RelocationCompleteExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Extension', _RelocationCompleteExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Extension', _RelocationCompleteExtensions_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteRequest >-----#
    EnhancedRelocationCompleteRequest = SEQ(name='EnhancedRelocationCompleteRequest', mode=MODE_TYPE)
    _EnhancedRelocationCompleteRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationCompleteRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhancedRelocCompleteReq')))
    ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 196), ('criticality', 'reject'), ('Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 79), ('criticality', 'reject'), ('Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 223), ('criticality', 'ignore'), ('Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'reject'), ('Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 213), ('criticality', 'reject'), ('Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'reject'), ('Value', _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__id._const_tab = ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__value._const_tab = ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __EnhancedRelocationCompleteRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___EnhancedRelocationCompleteRequest_protocolIEs__item__id),
        ('criticality', ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality),
        ('value', ___EnhancedRelocationCompleteRequest_protocolIEs__item__value),
        ])
    __EnhancedRelocationCompleteRequest_protocolIEs__item_._ext = None
    _EnhancedRelocationCompleteRequest_protocolIEs._cont = __EnhancedRelocationCompleteRequest_protocolIEs__item_
    _EnhancedRelocationCompleteRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationCompleteRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationCompleteRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 6), ('criticality', 'ignore'), ('Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 250), ('criticality', 'ignore'), ('Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'reject'), ('Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 235), ('criticality', 'reject'), ('Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Extension', _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id._const_tab = ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __EnhancedRelocationCompleteRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id),
        ('criticality', ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationCompleteRequest_protocolExtensions__item_._ext = None
    _EnhancedRelocationCompleteRequest_protocolExtensions._cont = __EnhancedRelocationCompleteRequest_protocolExtensions__item_
    _EnhancedRelocationCompleteRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationCompleteRequest._cont = ASN1Dict([
        ('protocolIEs', _EnhancedRelocationCompleteRequest_protocolIEs),
        ('protocolExtensions', _EnhancedRelocationCompleteRequest_protocolExtensions),
        ])
    EnhancedRelocationCompleteRequest._ext = []
    
    #-----< EnhancedRelocationCompleteRequestIEs >-----#
    EnhancedRelocationCompleteRequestIEs = CLASS(name='EnhancedRelocationCompleteRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_5 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _EnhancedRelocationCompleteRequestIEs_val_Value_6 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhancedRelocCompleteReq')))
    EnhancedRelocationCompleteRequestIEs._val = ASN1Set(rv=[dict([('id', 196), ('criticality', 'reject'), ('Value', _EnhancedRelocationCompleteRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 79), ('criticality', 'reject'), ('Value', _EnhancedRelocationCompleteRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 222), ('criticality', 'ignore'), ('Value', _EnhancedRelocationCompleteRequestIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 223), ('criticality', 'ignore'), ('Value', _EnhancedRelocationCompleteRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 212), ('criticality', 'reject'), ('Value', _EnhancedRelocationCompleteRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 213), ('criticality', 'reject'), ('Value', _EnhancedRelocationCompleteRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 188), ('criticality', 'reject'), ('Value', _EnhancedRelocationCompleteRequestIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-EnhancedRelocCompleteReq >-----#
    RAB_SetupList_EnhancedRelocCompleteReq = SEQ_OF(name='RAB-SetupList-EnhancedRelocCompleteReq', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_EnhancedRelocCompleteReq__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_EnhancedRelocCompleteReq__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhancedRelocCompleteReq')))
    ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 189), ('criticality', 'reject'), ('Value', _____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id._const_tab = ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id._const_tab_at = None
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id._const_tab_id = 'id'
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality._const_tab = ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value._const_tab = ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value._const_tab_id = 'Value'
    __RAB_SetupList_EnhancedRelocCompleteReq__item___item_._cont = ASN1Dict([
        ('id', ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id),
        ('criticality', ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality),
        ('value', ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value),
        ])
    __RAB_SetupList_EnhancedRelocCompleteReq__item___item_._ext = None
    _RAB_SetupList_EnhancedRelocCompleteReq__item_._cont = __RAB_SetupList_EnhancedRelocCompleteReq__item___item_
    _RAB_SetupList_EnhancedRelocCompleteReq__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_EnhancedRelocCompleteReq._cont = _RAB_SetupList_EnhancedRelocCompleteReq__item_
    RAB_SetupList_EnhancedRelocCompleteReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteReq-IEs >-----#
    RAB_SetupItem_EnhancedRelocCompleteReq_IEs = CLASS(name='RAB-SetupItem-EnhancedRelocCompleteReq-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_EnhancedRelocCompleteReq_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhancedRelocCompleteReq')))
    RAB_SetupItem_EnhancedRelocCompleteReq_IEs._val = ASN1Set(rv=[dict([('id', 189), ('criticality', 'reject'), ('Value', _RAB_SetupItem_EnhancedRelocCompleteReq_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteReq >-----#
    RAB_SetupItem_EnhancedRelocCompleteReq = SEQ(name='RAB-SetupItem-EnhancedRelocCompleteReq', mode=MODE_TYPE)
    _RAB_SetupItem_EnhancedRelocCompleteReq_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_EnhancedRelocCompleteReq_transportLayerAddressReq1 = BIT_STR(name='transportLayerAddressReq1', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteReq_iuTransportAssociationReq1 = CHOICE(name='iuTransportAssociationReq1', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteReq_ass_RAB_Parameters = SEQ(name='ass-RAB-Parameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality_tab
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue_tab
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id),
        ('criticality', ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item_._ext = None
    _RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions._cont = __RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item_
    _RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_EnhancedRelocCompleteReq._cont = ASN1Dict([
        ('rAB-ID', _RAB_SetupItem_EnhancedRelocCompleteReq_rAB_ID),
        ('transportLayerAddressReq1', _RAB_SetupItem_EnhancedRelocCompleteReq_transportLayerAddressReq1),
        ('iuTransportAssociationReq1', _RAB_SetupItem_EnhancedRelocCompleteReq_iuTransportAssociationReq1),
        ('ass-RAB-Parameters', _RAB_SetupItem_EnhancedRelocCompleteReq_ass_RAB_Parameters),
        ('iE-Extensions', _RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions),
        ])
    RAB_SetupItem_EnhancedRelocCompleteReq._ext = []
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteReq-ExtIEs >-----#
    RAB_SetupItem_EnhancedRelocCompleteReq_ExtIEs = CLASS(name='RAB-SetupItem-EnhancedRelocCompleteReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_SetupItem_EnhancedRelocCompleteReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteRequestExtensions >-----#
    EnhancedRelocationCompleteRequestExtensions = CLASS(name='EnhancedRelocationCompleteRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenIntegrityProtectionAlgorithm')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ChosenEncryptionAlgorithm')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _EnhancedRelocationCompleteRequestExtensions_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    EnhancedRelocationCompleteRequestExtensions._val = ASN1Set(rv=[dict([('id', 6), ('criticality', 'ignore'), ('Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 5), ('criticality', 'ignore'), ('Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 250), ('criticality', 'ignore'), ('Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'reject'), ('Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 235), ('criticality', 'reject'), ('Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Extension', _EnhancedRelocationCompleteRequestExtensions_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteResponse >-----#
    EnhancedRelocationCompleteResponse = SEQ(name='EnhancedRelocationCompleteResponse', mode=MODE_TYPE)
    _EnhancedRelocationCompleteResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationCompleteResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhancedRelocCompleteRes')))
    _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ToBeReleasedList-EnhancedRelocCompleteRes')))
    _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 190), ('criticality', 'ignore'), ('Value', _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 210), ('criticality', 'ignore'), ('Value', _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__id._const_tab = ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__value._const_tab = ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __EnhancedRelocationCompleteResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___EnhancedRelocationCompleteResponse_protocolIEs__item__id),
        ('criticality', ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality),
        ('value', ___EnhancedRelocationCompleteResponse_protocolIEs__item__value),
        ])
    __EnhancedRelocationCompleteResponse_protocolIEs__item_._ext = None
    _EnhancedRelocationCompleteResponse_protocolIEs._cont = __EnhancedRelocationCompleteResponse_protocolIEs__item_
    _EnhancedRelocationCompleteResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationCompleteResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationCompleteResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 233), ('criticality', 'ignore'), ('Extension', _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 239), ('criticality', 'ignore'), ('Extension', _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Extension', _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id._const_tab = ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __EnhancedRelocationCompleteResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id),
        ('criticality', ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationCompleteResponse_protocolExtensions__item_._ext = None
    _EnhancedRelocationCompleteResponse_protocolExtensions._cont = __EnhancedRelocationCompleteResponse_protocolExtensions__item_
    _EnhancedRelocationCompleteResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationCompleteResponse._cont = ASN1Dict([
        ('protocolIEs', _EnhancedRelocationCompleteResponse_protocolIEs),
        ('protocolExtensions', _EnhancedRelocationCompleteResponse_protocolExtensions),
        ])
    EnhancedRelocationCompleteResponse._ext = []
    
    #-----< EnhancedRelocationCompleteResponseIEs >-----#
    EnhancedRelocationCompleteResponseIEs = CLASS(name='EnhancedRelocationCompleteResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _EnhancedRelocationCompleteResponseIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhancedRelocCompleteRes')))
    _EnhancedRelocationCompleteResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ToBeReleasedList-EnhancedRelocCompleteRes')))
    _EnhancedRelocationCompleteResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    EnhancedRelocationCompleteResponseIEs._val = ASN1Set(rv=[dict([('id', 190), ('criticality', 'ignore'), ('Value', _EnhancedRelocationCompleteResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 210), ('criticality', 'ignore'), ('Value', _EnhancedRelocationCompleteResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _EnhancedRelocationCompleteResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-EnhancedRelocCompleteRes >-----#
    RAB_SetupList_EnhancedRelocCompleteRes = SEQ_OF(name='RAB-SetupList-EnhancedRelocCompleteRes', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_EnhancedRelocCompleteRes__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_EnhancedRelocCompleteRes__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhancedRelocCompleteRes')))
    ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 191), ('criticality', 'reject'), ('Value', _____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id._const_tab = ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id._const_tab_at = None
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id._const_tab_id = 'id'
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality._const_tab = ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value._const_tab = ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value._const_tab_id = 'Value'
    __RAB_SetupList_EnhancedRelocCompleteRes__item___item_._cont = ASN1Dict([
        ('id', ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id),
        ('criticality', ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality),
        ('value', ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value),
        ])
    __RAB_SetupList_EnhancedRelocCompleteRes__item___item_._ext = None
    _RAB_SetupList_EnhancedRelocCompleteRes__item_._cont = __RAB_SetupList_EnhancedRelocCompleteRes__item___item_
    _RAB_SetupList_EnhancedRelocCompleteRes__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_EnhancedRelocCompleteRes._cont = _RAB_SetupList_EnhancedRelocCompleteRes__item_
    RAB_SetupList_EnhancedRelocCompleteRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteRes-IEs >-----#
    RAB_SetupItem_EnhancedRelocCompleteRes_IEs = CLASS(name='RAB-SetupItem-EnhancedRelocCompleteRes-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_EnhancedRelocCompleteRes_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhancedRelocCompleteRes')))
    RAB_SetupItem_EnhancedRelocCompleteRes_IEs._val = ASN1Set(rv=[dict([('id', 191), ('criticality', 'reject'), ('Value', _RAB_SetupItem_EnhancedRelocCompleteRes_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteRes >-----#
    RAB_SetupItem_EnhancedRelocCompleteRes = SEQ(name='RAB-SetupItem-EnhancedRelocCompleteRes', mode=MODE_TYPE)
    _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_Parameters = SEQ(name='rAB-Parameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteRes_userPlaneInformation = SEQ(name='userPlaneInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'UserPlaneInformation')))
    _RAB_SetupItem_EnhancedRelocCompleteRes_transportLayerAddressRes1 = BIT_STR(name='transportLayerAddressRes1', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteRes_iuTransportAssociationRes1 = CHOICE(name='iuTransportAssociationRes1', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteRes_rab2beReleasedList = SEQ_OF(name='rab2beReleasedList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ToBeReleasedList-EnhancedRelocCompleteRes')), opt=True)
    _RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 240), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id),
        ('criticality', ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item_._ext = None
    _RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions._cont = __RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item_
    _RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_EnhancedRelocCompleteRes._cont = ASN1Dict([
        ('rAB-ID', _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_ID),
        ('rAB-Parameters', _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_Parameters),
        ('userPlaneInformation', _RAB_SetupItem_EnhancedRelocCompleteRes_userPlaneInformation),
        ('transportLayerAddressRes1', _RAB_SetupItem_EnhancedRelocCompleteRes_transportLayerAddressRes1),
        ('iuTransportAssociationRes1', _RAB_SetupItem_EnhancedRelocCompleteRes_iuTransportAssociationRes1),
        ('rab2beReleasedList', _RAB_SetupItem_EnhancedRelocCompleteRes_rab2beReleasedList),
        ('iE-Extensions', _RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions),
        ])
    RAB_SetupItem_EnhancedRelocCompleteRes._ext = []
    
    #-----< RAB-SetupItem-EnhancedRelocCompleteRes-ExtIEs >-----#
    RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs = CLASS(name='RAB-SetupItem-EnhancedRelocCompleteRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs._val = ASN1Set(rv=[dict([('id', 240), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ToBeReleasedList-EnhancedRelocCompleteRes >-----#
    RAB_ToBeReleasedList_EnhancedRelocCompleteRes = SEQ_OF(name='RAB-ToBeReleasedList-EnhancedRelocCompleteRes', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes')))
    ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 209), ('criticality', 'ignore'), ('Value', _____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id._const_tab = ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id._const_tab_at = None
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id._const_tab_id = 'id'
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality._const_tab = ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value._const_tab = ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value._const_tab_id = 'Value'
    __RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item_._cont = ASN1Dict([
        ('id', ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id),
        ('criticality', ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality),
        ('value', ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value),
        ])
    __RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item_._ext = None
    _RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item_._cont = __RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item_
    _RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ToBeReleasedList_EnhancedRelocCompleteRes._cont = _RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item_
    RAB_ToBeReleasedList_EnhancedRelocCompleteRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-IEs >-----#
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs = CLASS(name='RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ToBeReleasedItem-EnhancedRelocCompleteRes')))
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs._val = ASN1Set(rv=[dict([('id', 209), ('criticality', 'ignore'), ('Value', _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ToBeReleasedItem-EnhancedRelocCompleteRes >-----#
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes = SEQ(name='RAB-ToBeReleasedItem-EnhancedRelocCompleteRes', mode=MODE_TYPE)
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab = ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab = ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality_tab
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab = ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue_tab
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id),
        ('criticality', ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue),
        ])
    __RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item_._ext = None
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions._cont = __RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item_
    _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes._cont = ASN1Dict([
        ('rAB-ID', _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_rAB_ID),
        ('cause', _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_cause),
        ('iE-Extensions', _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions),
        ])
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes._ext = []
    
    #-----< RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-ExtIEs >-----#
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_ExtIEs = CLASS(name='RAB-ToBeReleasedItem-EnhancedRelocCompleteRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteResponseExtensions >-----#
    EnhancedRelocationCompleteResponseExtensions = CLASS(name='EnhancedRelocationCompleteResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _EnhancedRelocationCompleteResponseExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _EnhancedRelocationCompleteResponseExtensions_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    _EnhancedRelocationCompleteResponseExtensions_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    EnhancedRelocationCompleteResponseExtensions._val = ASN1Set(rv=[dict([('id', 233), ('criticality', 'ignore'), ('Extension', _EnhancedRelocationCompleteResponseExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 239), ('criticality', 'ignore'), ('Extension', _EnhancedRelocationCompleteResponseExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Extension', _EnhancedRelocationCompleteResponseExtensions_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteFailure >-----#
    EnhancedRelocationCompleteFailure = SEQ(name='EnhancedRelocationCompleteFailure', mode=MODE_TYPE)
    _EnhancedRelocationCompleteFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationCompleteFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__id._const_tab = ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__value._const_tab = ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __EnhancedRelocationCompleteFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___EnhancedRelocationCompleteFailure_protocolIEs__item__id),
        ('criticality', ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality),
        ('value', ___EnhancedRelocationCompleteFailure_protocolIEs__item__value),
        ])
    __EnhancedRelocationCompleteFailure_protocolIEs__item_._ext = None
    _EnhancedRelocationCompleteFailure_protocolIEs._cont = __EnhancedRelocationCompleteFailure_protocolIEs__item_
    _EnhancedRelocationCompleteFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationCompleteFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationCompleteFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id._const_tab = ____EnhancedRelocationCompleteFailure_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __EnhancedRelocationCompleteFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id),
        ('criticality', ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationCompleteFailure_protocolExtensions__item_._ext = None
    _EnhancedRelocationCompleteFailure_protocolExtensions._cont = __EnhancedRelocationCompleteFailure_protocolExtensions__item_
    _EnhancedRelocationCompleteFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationCompleteFailure._cont = ASN1Dict([
        ('protocolIEs', _EnhancedRelocationCompleteFailure_protocolIEs),
        ('protocolExtensions', _EnhancedRelocationCompleteFailure_protocolExtensions),
        ])
    EnhancedRelocationCompleteFailure._ext = []
    
    #-----< EnhancedRelocationCompleteFailureIEs >-----#
    EnhancedRelocationCompleteFailureIEs = CLASS(name='EnhancedRelocationCompleteFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _EnhancedRelocationCompleteFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _EnhancedRelocationCompleteFailureIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    EnhancedRelocationCompleteFailureIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _EnhancedRelocationCompleteFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _EnhancedRelocationCompleteFailureIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteFailureExtensions >-----#
    EnhancedRelocationCompleteFailureExtensions = CLASS(name='EnhancedRelocationCompleteFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationCompleteFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteConfirm >-----#
    EnhancedRelocationCompleteConfirm = SEQ(name='EnhancedRelocationCompleteConfirm', mode=MODE_TYPE)
    _EnhancedRelocationCompleteConfirm_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __EnhancedRelocationCompleteConfirm_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'ignore'), ('Value', _____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id._const_tab = ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id._const_tab_id = 'id'
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality._const_tab = ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value._const_tab = ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value._const_tab_id = 'Value'
    __EnhancedRelocationCompleteConfirm_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id),
        ('criticality', ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality),
        ('value', ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value),
        ])
    __EnhancedRelocationCompleteConfirm_protocolIEs__item_._ext = None
    _EnhancedRelocationCompleteConfirm_protocolIEs._cont = __EnhancedRelocationCompleteConfirm_protocolIEs__item_
    _EnhancedRelocationCompleteConfirm_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _EnhancedRelocationCompleteConfirm_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __EnhancedRelocationCompleteConfirm_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id._const_tab = ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__id_tab
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id._const_tab_at = None
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id._const_tab_id = 'id'
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality._const_tab = ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality_tab
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue._const_tab = ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue_tab
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __EnhancedRelocationCompleteConfirm_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id),
        ('criticality', ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality),
        ('extensionValue', ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue),
        ])
    __EnhancedRelocationCompleteConfirm_protocolExtensions__item_._ext = None
    _EnhancedRelocationCompleteConfirm_protocolExtensions._cont = __EnhancedRelocationCompleteConfirm_protocolExtensions__item_
    _EnhancedRelocationCompleteConfirm_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    EnhancedRelocationCompleteConfirm._cont = ASN1Dict([
        ('protocolIEs', _EnhancedRelocationCompleteConfirm_protocolIEs),
        ('protocolExtensions', _EnhancedRelocationCompleteConfirm_protocolExtensions),
        ])
    EnhancedRelocationCompleteConfirm._ext = []
    
    #-----< EnhancedRelocationCompleteConfirmIEs >-----#
    EnhancedRelocationCompleteConfirmIEs = CLASS(name='EnhancedRelocationCompleteConfirmIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _EnhancedRelocationCompleteConfirmIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    EnhancedRelocationCompleteConfirmIEs._val = ASN1Set(rv=[dict([('id', 35), ('criticality', 'ignore'), ('Value', _EnhancedRelocationCompleteConfirmIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< EnhancedRelocationCompleteConfirmExtensions >-----#
    EnhancedRelocationCompleteConfirmExtensions = CLASS(name='EnhancedRelocationCompleteConfirmExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    EnhancedRelocationCompleteConfirmExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Paging >-----#
    Paging = SEQ(name='Paging', mode=MODE_TYPE)
    _Paging_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Paging_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Paging_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____Paging_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Paging_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____Paging_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _____Paging_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TemporaryUE-ID')))
    _____Paging_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PagingAreaID')))
    _____Paging_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PagingCause')))
    _____Paging_protocolIEs__item__id_tab_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NonSearchingIndication')))
    _____Paging_protocolIEs__item__id_tab_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DRX-CycleLengthCoefficient')))
    ____Paging_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 21), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 76), ('criticality', 'ignore'), ('Value', _____Paging_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Paging_protocolIEs__item__id._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__id._const_tab_at = None
    ___Paging_protocolIEs__item__id._const_tab_id = 'id'
    ___Paging_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___Paging_protocolIEs__item__criticality._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Paging_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___Paging_protocolIEs__item__value._const_tab = ____Paging_protocolIEs__item__id_tab
    ___Paging_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Paging_protocolIEs__item__value._const_tab_id = 'Value'
    __Paging_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Paging_protocolIEs__item__id),
        ('criticality', ___Paging_protocolIEs__item__criticality),
        ('value', ___Paging_protocolIEs__item__value),
        ])
    __Paging_protocolIEs__item_._ext = None
    _Paging_protocolIEs._cont = __Paging_protocolIEs__item_
    _Paging_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Paging_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Paging_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Paging_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Paging_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Paging_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____Paging_protocolExtensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id-List')))
    ____Paging_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____Paging_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 229), ('criticality', 'ignore'), ('Extension', _____Paging_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Paging_protocolExtensions__item__id._const_tab = ____Paging_protocolExtensions__item__id_tab
    ___Paging_protocolExtensions__item__id._const_tab_at = None
    ___Paging_protocolExtensions__item__id._const_tab_id = 'id'
    ___Paging_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Paging_protocolExtensions__item__criticality._const_tab = ____Paging_protocolExtensions__item__id_tab
    ___Paging_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Paging_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Paging_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Paging_protocolExtensions__item__extensionValue._const_tab = ____Paging_protocolExtensions__item__id_tab
    ___Paging_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Paging_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Paging_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Paging_protocolExtensions__item__id),
        ('criticality', ___Paging_protocolExtensions__item__criticality),
        ('extensionValue', ___Paging_protocolExtensions__item__extensionValue),
        ])
    __Paging_protocolExtensions__item_._ext = None
    _Paging_protocolExtensions._cont = __Paging_protocolExtensions__item_
    _Paging_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Paging._cont = ASN1Dict([
        ('protocolIEs', _Paging_protocolIEs),
        ('protocolExtensions', _Paging_protocolExtensions),
        ])
    Paging._ext = []
    
    #-----< PagingIEs >-----#
    PagingIEs = CLASS(name='PagingIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _PagingIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _PagingIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _PagingIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TemporaryUE-ID')))
    _PagingIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PagingAreaID')))
    _PagingIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PagingCause')))
    _PagingIEs_val_Value_5 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NonSearchingIndication')))
    _PagingIEs_val_Value_6 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DRX-CycleLengthCoefficient')))
    PagingIEs._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 64), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 21), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 22), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 17), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 76), ('criticality', 'ignore'), ('Value', _PagingIEs_val_Value_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< PagingExtensions >-----#
    PagingExtensions = CLASS(name='PagingExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _PagingExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _PagingExtensions_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id-List')))
    PagingExtensions._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _PagingExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 229), ('criticality', 'ignore'), ('Extension', _PagingExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CommonID >-----#
    CommonID = SEQ(name='CommonID', mode=MODE_TYPE)
    _CommonID_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __CommonID_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___CommonID_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____CommonID_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____CommonID_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    ____CommonID_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 23), ('criticality', 'ignore'), ('Value', _____CommonID_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___CommonID_protocolIEs__item__id._const_tab = ____CommonID_protocolIEs__item__id_tab
    ___CommonID_protocolIEs__item__id._const_tab_at = None
    ___CommonID_protocolIEs__item__id._const_tab_id = 'id'
    ___CommonID_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___CommonID_protocolIEs__item__criticality._const_tab = ____CommonID_protocolIEs__item__id_tab
    ___CommonID_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CommonID_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CommonID_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___CommonID_protocolIEs__item__value._const_tab = ____CommonID_protocolIEs__item__id_tab
    ___CommonID_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CommonID_protocolIEs__item__value._const_tab_id = 'Value'
    __CommonID_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CommonID_protocolIEs__item__id),
        ('criticality', ___CommonID_protocolIEs__item__criticality),
        ('value', ___CommonID_protocolIEs__item__value),
        ])
    __CommonID_protocolIEs__item_._ext = None
    _CommonID_protocolIEs._cont = __CommonID_protocolIEs__item_
    _CommonID_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CommonID_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CommonID_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CommonID_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____CommonID_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Operation-Possible')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Management-Based-MDT-Allowed')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-Operation-Possible')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_9 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____CommonID_protocolExtensions__item__id_tab_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PowerSavingIndicator')))
    ____CommonID_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 105), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 202), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 249), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 272), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 289), ('criticality', 'ignore'), ('Extension', _____CommonID_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CommonID_protocolExtensions__item__id._const_tab = ____CommonID_protocolExtensions__item__id_tab
    ___CommonID_protocolExtensions__item__id._const_tab_at = None
    ___CommonID_protocolExtensions__item__id._const_tab_id = 'id'
    ___CommonID_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CommonID_protocolExtensions__item__criticality._const_tab = ____CommonID_protocolExtensions__item__id_tab
    ___CommonID_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CommonID_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CommonID_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CommonID_protocolExtensions__item__extensionValue._const_tab = ____CommonID_protocolExtensions__item__id_tab
    ___CommonID_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CommonID_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CommonID_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CommonID_protocolExtensions__item__id),
        ('criticality', ___CommonID_protocolExtensions__item__criticality),
        ('extensionValue', ___CommonID_protocolExtensions__item__extensionValue),
        ])
    __CommonID_protocolExtensions__item_._ext = None
    _CommonID_protocolExtensions._cont = __CommonID_protocolExtensions__item_
    _CommonID_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CommonID._cont = ASN1Dict([
        ('protocolIEs', _CommonID_protocolIEs),
        ('protocolExtensions', _CommonID_protocolExtensions),
        ])
    CommonID._ext = []
    
    #-----< CommonID-IEs >-----#
    CommonID_IEs = CLASS(name='CommonID-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _CommonID_IEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    CommonID_IEs._val = ASN1Set(rv=[dict([('id', 23), ('criticality', 'ignore'), ('Value', _CommonID_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< CommonIDExtensions >-----#
    CommonIDExtensions = CLASS(name='CommonIDExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _CommonIDExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _CommonIDExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _CommonIDExtensions_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _CommonIDExtensions_val_Extension_3 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _CommonIDExtensions_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Operation-Possible')))
    _CommonIDExtensions_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _CommonIDExtensions_val_Extension_6 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Management-Based-MDT-Allowed')))
    _CommonIDExtensions_val_Extension_7 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-PLMN-List')))
    _CommonIDExtensions_val_Extension_8 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RSRVCC-Operation-Possible')))
    _CommonIDExtensions_val_Extension_9 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _CommonIDExtensions_val_Extension_10 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PowerSavingIndicator')))
    CommonIDExtensions._val = ASN1Set(rv=[dict([('id', 105), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 202), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 228), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 249), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 263), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 272), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 277), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 289), ('criticality', 'ignore'), ('Extension', _CommonIDExtensions_val_Extension_10), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CN-InvokeTrace >-----#
    CN_InvokeTrace = SEQ(name='CN-InvokeTrace', mode=MODE_TYPE)
    _CN_InvokeTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __CN_InvokeTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___CN_InvokeTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____CN_InvokeTrace_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceType')))
    _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TriggerID')))
    _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-ID')))
    _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'OMC-ID')))
    ____CN_InvokeTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 66), ('criticality', 'ignore'), ('Value', _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 69), ('criticality', 'ignore'), ('Value', _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CN_InvokeTrace_protocolIEs__item__id._const_tab = ____CN_InvokeTrace_protocolIEs__item__id_tab
    ___CN_InvokeTrace_protocolIEs__item__id._const_tab_at = None
    ___CN_InvokeTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___CN_InvokeTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___CN_InvokeTrace_protocolIEs__item__criticality._const_tab = ____CN_InvokeTrace_protocolIEs__item__id_tab
    ___CN_InvokeTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CN_InvokeTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CN_InvokeTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___CN_InvokeTrace_protocolIEs__item__value._const_tab = ____CN_InvokeTrace_protocolIEs__item__id_tab
    ___CN_InvokeTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CN_InvokeTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __CN_InvokeTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CN_InvokeTrace_protocolIEs__item__id),
        ('criticality', ___CN_InvokeTrace_protocolIEs__item__criticality),
        ('value', ___CN_InvokeTrace_protocolIEs__item__value),
        ])
    __CN_InvokeTrace_protocolIEs__item_._ext = None
    _CN_InvokeTrace_protocolIEs._cont = __CN_InvokeTrace_protocolIEs__item_
    _CN_InvokeTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CN_InvokeTrace_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CN_InvokeTrace_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CN_InvokeTrace_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____CN_InvokeTrace_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TracePropagationParameters')))
    _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-Configuration')))
    _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration')))
    ____CN_InvokeTrace_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 125), ('criticality', 'ignore'), ('Extension', _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 244), ('criticality', 'ignore'), ('Extension', _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Extension', _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 292), ('criticality', 'ignore'), ('Extension', _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CN_InvokeTrace_protocolExtensions__item__id._const_tab = ____CN_InvokeTrace_protocolExtensions__item__id_tab
    ___CN_InvokeTrace_protocolExtensions__item__id._const_tab_at = None
    ___CN_InvokeTrace_protocolExtensions__item__id._const_tab_id = 'id'
    ___CN_InvokeTrace_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___CN_InvokeTrace_protocolExtensions__item__criticality._const_tab = ____CN_InvokeTrace_protocolExtensions__item__id_tab
    ___CN_InvokeTrace_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CN_InvokeTrace_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CN_InvokeTrace_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___CN_InvokeTrace_protocolExtensions__item__extensionValue._const_tab = ____CN_InvokeTrace_protocolExtensions__item__id_tab
    ___CN_InvokeTrace_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CN_InvokeTrace_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CN_InvokeTrace_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CN_InvokeTrace_protocolExtensions__item__id),
        ('criticality', ___CN_InvokeTrace_protocolExtensions__item__criticality),
        ('extensionValue', ___CN_InvokeTrace_protocolExtensions__item__extensionValue),
        ])
    __CN_InvokeTrace_protocolExtensions__item_._ext = None
    _CN_InvokeTrace_protocolExtensions._cont = __CN_InvokeTrace_protocolExtensions__item_
    _CN_InvokeTrace_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CN_InvokeTrace._cont = ASN1Dict([
        ('protocolIEs', _CN_InvokeTrace_protocolIEs),
        ('protocolExtensions', _CN_InvokeTrace_protocolExtensions),
        ])
    CN_InvokeTrace._ext = []
    
    #-----< CN-InvokeTraceIEs >-----#
    CN_InvokeTraceIEs = CLASS(name='CN-InvokeTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _CN_InvokeTraceIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceType')))
    _CN_InvokeTraceIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _CN_InvokeTraceIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TriggerID')))
    _CN_InvokeTraceIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-ID')))
    _CN_InvokeTraceIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'OMC-ID')))
    CN_InvokeTraceIEs._val = ASN1Set(rv=[dict([('id', 66), ('criticality', 'ignore'), ('Value', _CN_InvokeTraceIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 65), ('criticality', 'ignore'), ('Value', _CN_InvokeTraceIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _CN_InvokeTraceIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 69), ('criticality', 'ignore'), ('Value', _CN_InvokeTraceIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 19), ('criticality', 'ignore'), ('Value', _CN_InvokeTraceIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CN-InvokeTraceExtensions >-----#
    CN_InvokeTraceExtensions = CLASS(name='CN-InvokeTraceExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _CN_InvokeTraceExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TracePropagationParameters')))
    _CN_InvokeTraceExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MDT-Configuration')))
    _CN_InvokeTraceExtensions_val_Extension_2 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _CN_InvokeTraceExtensions_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Configuration')))
    CN_InvokeTraceExtensions._val = ASN1Set(rv=[dict([('id', 125), ('criticality', 'ignore'), ('Extension', _CN_InvokeTraceExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 244), ('criticality', 'ignore'), ('Extension', _CN_InvokeTraceExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 251), ('criticality', 'ignore'), ('Extension', _CN_InvokeTraceExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 292), ('criticality', 'ignore'), ('Extension', _CN_InvokeTraceExtensions_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CN-DeactivateTrace >-----#
    CN_DeactivateTrace = SEQ(name='CN-DeactivateTrace', mode=MODE_TYPE)
    _CN_DeactivateTrace_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __CN_DeactivateTrace_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___CN_DeactivateTrace_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____CN_DeactivateTrace_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TriggerID')))
    ____CN_DeactivateTrace_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 65), ('criticality', 'ignore'), ('Value', _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___CN_DeactivateTrace_protocolIEs__item__id._const_tab = ____CN_DeactivateTrace_protocolIEs__item__id_tab
    ___CN_DeactivateTrace_protocolIEs__item__id._const_tab_at = None
    ___CN_DeactivateTrace_protocolIEs__item__id._const_tab_id = 'id'
    ___CN_DeactivateTrace_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___CN_DeactivateTrace_protocolIEs__item__criticality._const_tab = ____CN_DeactivateTrace_protocolIEs__item__id_tab
    ___CN_DeactivateTrace_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___CN_DeactivateTrace_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___CN_DeactivateTrace_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___CN_DeactivateTrace_protocolIEs__item__value._const_tab = ____CN_DeactivateTrace_protocolIEs__item__id_tab
    ___CN_DeactivateTrace_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___CN_DeactivateTrace_protocolIEs__item__value._const_tab_id = 'Value'
    __CN_DeactivateTrace_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___CN_DeactivateTrace_protocolIEs__item__id),
        ('criticality', ___CN_DeactivateTrace_protocolIEs__item__criticality),
        ('value', ___CN_DeactivateTrace_protocolIEs__item__value),
        ])
    __CN_DeactivateTrace_protocolIEs__item_._ext = None
    _CN_DeactivateTrace_protocolIEs._cont = __CN_DeactivateTrace_protocolIEs__item_
    _CN_DeactivateTrace_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CN_DeactivateTrace_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __CN_DeactivateTrace_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___CN_DeactivateTrace_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____CN_DeactivateTrace_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CN_DeactivateTrace_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_DeactivateTrace_protocolExtensions__item__id._const_tab = ____CN_DeactivateTrace_protocolExtensions__item__id_tab
    ___CN_DeactivateTrace_protocolExtensions__item__id._const_tab_at = None
    ___CN_DeactivateTrace_protocolExtensions__item__id._const_tab_id = 'id'
    ___CN_DeactivateTrace_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____CN_DeactivateTrace_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CN_DeactivateTrace_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_DeactivateTrace_protocolExtensions__item__criticality._const_tab = ____CN_DeactivateTrace_protocolExtensions__item__criticality_tab
    ___CN_DeactivateTrace_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___CN_DeactivateTrace_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___CN_DeactivateTrace_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____CN_DeactivateTrace_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____CN_DeactivateTrace_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CN_DeactivateTrace_protocolExtensions__item__extensionValue._const_tab = ____CN_DeactivateTrace_protocolExtensions__item__extensionValue_tab
    ___CN_DeactivateTrace_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___CN_DeactivateTrace_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __CN_DeactivateTrace_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___CN_DeactivateTrace_protocolExtensions__item__id),
        ('criticality', ___CN_DeactivateTrace_protocolExtensions__item__criticality),
        ('extensionValue', ___CN_DeactivateTrace_protocolExtensions__item__extensionValue),
        ])
    __CN_DeactivateTrace_protocolExtensions__item_._ext = None
    _CN_DeactivateTrace_protocolExtensions._cont = __CN_DeactivateTrace_protocolExtensions__item_
    _CN_DeactivateTrace_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    CN_DeactivateTrace._cont = ASN1Dict([
        ('protocolIEs', _CN_DeactivateTrace_protocolIEs),
        ('protocolExtensions', _CN_DeactivateTrace_protocolExtensions),
        ])
    CN_DeactivateTrace._ext = []
    
    #-----< CN-DeactivateTraceIEs >-----#
    CN_DeactivateTraceIEs = CLASS(name='CN-DeactivateTraceIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _CN_DeactivateTraceIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TraceReference')))
    _CN_DeactivateTraceIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TriggerID')))
    CN_DeactivateTraceIEs._val = ASN1Set(rv=[dict([('id', 65), ('criticality', 'ignore'), ('Value', _CN_DeactivateTraceIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 68), ('criticality', 'ignore'), ('Value', _CN_DeactivateTraceIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< CN-DeactivateTraceExtensions >-----#
    CN_DeactivateTraceExtensions = CLASS(name='CN-DeactivateTraceExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    CN_DeactivateTraceExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationReportingControl >-----#
    LocationReportingControl = SEQ(name='LocationReportingControl', mode=MODE_TYPE)
    _LocationReportingControl_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __LocationReportingControl_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___LocationReportingControl_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____LocationReportingControl_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestType')))
    ____LocationReportingControl_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'ignore'), ('Value', _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___LocationReportingControl_protocolIEs__item__id._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__id._const_tab_at = None
    ___LocationReportingControl_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationReportingControl_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReportingControl_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationReportingControl_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___LocationReportingControl_protocolIEs__item__value._const_tab = ____LocationReportingControl_protocolIEs__item__id_tab
    ___LocationReportingControl_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationReportingControl_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationReportingControl_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationReportingControl_protocolIEs__item__id),
        ('criticality', ___LocationReportingControl_protocolIEs__item__criticality),
        ('value', ___LocationReportingControl_protocolIEs__item__value),
        ])
    __LocationReportingControl_protocolIEs__item_._ext = None
    _LocationReportingControl_protocolIEs._cont = __LocationReportingControl_protocolIEs__item_
    _LocationReportingControl_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LocationReportingControl_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationReportingControl_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationReportingControl_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationReportingControl_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VerticalAccuracyCode')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ResponseTime')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositioningPriority')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClientType')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IncludeVelocity')))
    _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PeriodicLocationInfo')))
    ____LocationReportingControl_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 112), ('criticality', 'ignore'), ('Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 113), ('criticality', 'ignore'), ('Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 114), ('criticality', 'ignore'), ('Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 164), ('criticality', 'ignore'), ('Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 168), ('criticality', 'ignore'), ('Extension', _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LocationReportingControl_protocolExtensions__item__id._const_tab = ____LocationReportingControl_protocolExtensions__item__id_tab
    ___LocationReportingControl_protocolExtensions__item__id._const_tab_at = None
    ___LocationReportingControl_protocolExtensions__item__id._const_tab_id = 'id'
    ___LocationReportingControl_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LocationReportingControl_protocolExtensions__item__criticality._const_tab = ____LocationReportingControl_protocolExtensions__item__id_tab
    ___LocationReportingControl_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReportingControl_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___LocationReportingControl_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LocationReportingControl_protocolExtensions__item__extensionValue._const_tab = ____LocationReportingControl_protocolExtensions__item__id_tab
    ___LocationReportingControl_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationReportingControl_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationReportingControl_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___LocationReportingControl_protocolExtensions__item__id),
        ('criticality', ___LocationReportingControl_protocolExtensions__item__criticality),
        ('extensionValue', ___LocationReportingControl_protocolExtensions__item__extensionValue),
        ])
    __LocationReportingControl_protocolExtensions__item_._ext = None
    _LocationReportingControl_protocolExtensions._cont = __LocationReportingControl_protocolExtensions__item_
    _LocationReportingControl_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationReportingControl._cont = ASN1Dict([
        ('protocolIEs', _LocationReportingControl_protocolIEs),
        ('protocolExtensions', _LocationReportingControl_protocolExtensions),
        ])
    LocationReportingControl._ext = []
    
    #-----< LocationReportingControlIEs >-----#
    LocationReportingControlIEs = CLASS(name='LocationReportingControlIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _LocationReportingControlIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestType')))
    LocationReportingControlIEs._val = ASN1Set(rv=[dict([('id', 57), ('criticality', 'ignore'), ('Value', _LocationReportingControlIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportingControlExtensions >-----#
    LocationReportingControlExtensions = CLASS(name='LocationReportingControlExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LocationReportingControlExtensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VerticalAccuracyCode')))
    _LocationReportingControlExtensions_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ResponseTime')))
    _LocationReportingControlExtensions_val_Extension_2 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositioningPriority')))
    _LocationReportingControlExtensions_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ClientType')))
    _LocationReportingControlExtensions_val_Extension_4 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IncludeVelocity')))
    _LocationReportingControlExtensions_val_Extension_5 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PeriodicLocationInfo')))
    LocationReportingControlExtensions._val = ASN1Set(rv=[dict([('id', 111), ('criticality', 'ignore'), ('Extension', _LocationReportingControlExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 112), ('criticality', 'ignore'), ('Extension', _LocationReportingControlExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 113), ('criticality', 'ignore'), ('Extension', _LocationReportingControlExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 114), ('criticality', 'ignore'), ('Extension', _LocationReportingControlExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 164), ('criticality', 'ignore'), ('Extension', _LocationReportingControlExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 168), ('criticality', 'ignore'), ('Extension', _LocationReportingControlExtensions_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationReport >-----#
    LocationReport = SEQ(name='LocationReport', mode=MODE_TYPE)
    _LocationReport_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __LocationReport_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___LocationReport_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____LocationReport_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AreaIdentity')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____LocationReport_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestType')))
    ____LocationReport_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 57), ('criticality', 'ignore'), ('Value', _____LocationReport_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LocationReport_protocolIEs__item__id._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__id._const_tab_at = None
    ___LocationReport_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationReport_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___LocationReport_protocolIEs__item__criticality._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReport_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationReport_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___LocationReport_protocolIEs__item__value._const_tab = ____LocationReport_protocolIEs__item__id_tab
    ___LocationReport_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationReport_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationReport_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationReport_protocolIEs__item__id),
        ('criticality', ___LocationReport_protocolIEs__item__criticality),
        ('value', ___LocationReport_protocolIEs__item__value),
        ])
    __LocationReport_protocolIEs__item_._ext = None
    _LocationReport_protocolIEs._cont = __LocationReport_protocolIEs__item_
    _LocationReport_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LocationReport_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationReport_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationReport_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationReport_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LastKnownServiceArea')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositionData')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositionDataSpecificToGERANIuMode')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AccuracyFulfilmentIndicator')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VelocityEstimate')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BarometricPressure')))
    _____LocationReport_protocolExtensions__item__id_tab_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CivicAddress')))
    ____LocationReport_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 97), ('criticality', 'ignore'), ('Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 119), ('criticality', 'ignore'), ('Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 120), ('criticality', 'ignore'), ('Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 122), ('criticality', 'ignore'), ('Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 285), ('criticality', 'ignore'), ('Extension', _____LocationReport_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LocationReport_protocolExtensions__item__id._const_tab = ____LocationReport_protocolExtensions__item__id_tab
    ___LocationReport_protocolExtensions__item__id._const_tab_at = None
    ___LocationReport_protocolExtensions__item__id._const_tab_id = 'id'
    ___LocationReport_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LocationReport_protocolExtensions__item__criticality._const_tab = ____LocationReport_protocolExtensions__item__id_tab
    ___LocationReport_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationReport_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___LocationReport_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LocationReport_protocolExtensions__item__extensionValue._const_tab = ____LocationReport_protocolExtensions__item__id_tab
    ___LocationReport_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationReport_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationReport_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___LocationReport_protocolExtensions__item__id),
        ('criticality', ___LocationReport_protocolExtensions__item__criticality),
        ('extensionValue', ___LocationReport_protocolExtensions__item__extensionValue),
        ])
    __LocationReport_protocolExtensions__item_._ext = None
    _LocationReport_protocolExtensions._cont = __LocationReport_protocolExtensions__item_
    _LocationReport_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationReport._cont = ASN1Dict([
        ('protocolIEs', _LocationReport_protocolIEs),
        ('protocolExtensions', _LocationReport_protocolExtensions),
        ])
    LocationReport._ext = []
    
    #-----< LocationReportIEs >-----#
    LocationReportIEs = CLASS(name='LocationReportIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _LocationReportIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AreaIdentity')))
    _LocationReportIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _LocationReportIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestType')))
    LocationReportIEs._val = ASN1Set(rv=[dict([('id', 0), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 57), ('criticality', 'ignore'), ('Value', _LocationReportIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationReportExtensions >-----#
    LocationReportExtensions = CLASS(name='LocationReportExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LocationReportExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LastKnownServiceArea')))
    _LocationReportExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositionData')))
    _LocationReportExtensions_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PositionDataSpecificToGERANIuMode')))
    _LocationReportExtensions_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'AccuracyFulfilmentIndicator')))
    _LocationReportExtensions_val_Extension_4 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VelocityEstimate')))
    _LocationReportExtensions_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BarometricPressure')))
    _LocationReportExtensions_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CivicAddress')))
    LocationReportExtensions._val = ASN1Set(rv=[dict([('id', 97), ('criticality', 'ignore'), ('Extension', _LocationReportExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 119), ('criticality', 'ignore'), ('Extension', _LocationReportExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 120), ('criticality', 'ignore'), ('Extension', _LocationReportExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 122), ('criticality', 'ignore'), ('Extension', _LocationReportExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 165), ('criticality', 'ignore'), ('Extension', _LocationReportExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 283), ('criticality', 'ignore'), ('Extension', _LocationReportExtensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 285), ('criticality', 'ignore'), ('Extension', _LocationReportExtensions_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InitialUE-Message >-----#
    InitialUE_Message = SEQ(name='InitialUE-Message', mode=MODE_TYPE)
    _InitialUE_Message_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __InitialUE_Message_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___InitialUE_Message_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____InitialUE_Message_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____InitialUE_Message_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'ignore'), ('Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 55), ('criticality', 'ignore'), ('Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_2), ('presence', 'conditional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 16), ('criticality', 'ignore'), ('Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 79), ('criticality', 'ignore'), ('Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InitialUE_Message_protocolIEs__item__id._const_tab = ____InitialUE_Message_protocolIEs__item__id_tab
    ___InitialUE_Message_protocolIEs__item__id._const_tab_at = None
    ___InitialUE_Message_protocolIEs__item__id._const_tab_id = 'id'
    ___InitialUE_Message_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___InitialUE_Message_protocolIEs__item__criticality._const_tab = ____InitialUE_Message_protocolIEs__item__id_tab
    ___InitialUE_Message_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InitialUE_Message_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InitialUE_Message_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___InitialUE_Message_protocolIEs__item__value._const_tab = ____InitialUE_Message_protocolIEs__item__id_tab
    ___InitialUE_Message_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InitialUE_Message_protocolIEs__item__value._const_tab_id = 'Value'
    __InitialUE_Message_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InitialUE_Message_protocolIEs__item__id),
        ('criticality', ___InitialUE_Message_protocolIEs__item__criticality),
        ('value', ___InitialUE_Message_protocolIEs__item__value),
        ])
    __InitialUE_Message_protocolIEs__item_._ext = None
    _InitialUE_Message_protocolIEs._cont = __InitialUE_Message_protocolIEs__item_
    _InitialUE_Message_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InitialUE_Message_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InitialUE_Message_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InitialUE_Message_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____InitialUE_Message_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-SequenceNumber')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_4 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RedirectAttemptFlag')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_6 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_8 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_11 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_12 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_13 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SGSN-Group-Identity')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_14 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Usage-Type')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_15 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DCN-ID')))
    _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_16 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    ____InitialUE_Message_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 108), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 130), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 166), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'reject'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')]), dict([('id', 235), ('criticality', 'reject'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_7), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_8), ('presence', 'optional')]), dict([('id', 250), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_9), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_10), ('presence', 'optional')]), dict([('id', 273), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_11), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_12), ('presence', 'optional')]), dict([('id', 286), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_13), ('presence', 'optional')]), dict([('id', 290), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_14), ('presence', 'optional')]), dict([('id', 291), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_15), ('presence', 'optional')]), dict([('id', 294), ('criticality', 'ignore'), ('Extension', _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_16), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InitialUE_Message_protocolExtensions__item__id._const_tab = ____InitialUE_Message_protocolExtensions__item__id_tab
    ___InitialUE_Message_protocolExtensions__item__id._const_tab_at = None
    ___InitialUE_Message_protocolExtensions__item__id._const_tab_id = 'id'
    ___InitialUE_Message_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___InitialUE_Message_protocolExtensions__item__criticality._const_tab = ____InitialUE_Message_protocolExtensions__item__id_tab
    ___InitialUE_Message_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InitialUE_Message_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InitialUE_Message_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___InitialUE_Message_protocolExtensions__item__extensionValue._const_tab = ____InitialUE_Message_protocolExtensions__item__id_tab
    ___InitialUE_Message_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InitialUE_Message_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InitialUE_Message_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InitialUE_Message_protocolExtensions__item__id),
        ('criticality', ___InitialUE_Message_protocolExtensions__item__criticality),
        ('extensionValue', ___InitialUE_Message_protocolExtensions__item__extensionValue),
        ])
    __InitialUE_Message_protocolExtensions__item_._ext = None
    _InitialUE_Message_protocolExtensions._cont = __InitialUE_Message_protocolExtensions__item_
    _InitialUE_Message_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InitialUE_Message._cont = ASN1Dict([
        ('protocolIEs', _InitialUE_Message_protocolIEs),
        ('protocolExtensions', _InitialUE_Message_protocolExtensions),
        ])
    InitialUE_Message._ext = []
    
    #-----< InitialUE-MessageIEs >-----#
    InitialUE_MessageIEs = CLASS(name='InitialUE-MessageIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _InitialUE_MessageIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _InitialUE_MessageIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _InitialUE_MessageIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _InitialUE_MessageIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _InitialUE_MessageIEs_val_Value_4 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _InitialUE_MessageIEs_val_Value_5 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _InitialUE_MessageIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    InitialUE_MessageIEs._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'ignore'), ('Value', _InitialUE_MessageIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _InitialUE_MessageIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 55), ('criticality', 'ignore'), ('Value', _InitialUE_MessageIEs_val_Value_2), ('presence', 'conditional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _InitialUE_MessageIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 16), ('criticality', 'ignore'), ('Value', _InitialUE_MessageIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 79), ('criticality', 'ignore'), ('Value', _InitialUE_MessageIEs_val_Value_5), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _InitialUE_MessageIEs_val_Value_6), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InitialUE-MessageExtensions >-----#
    InitialUE_MessageExtensions = CLASS(name='InitialUE-MessageExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _InitialUE_MessageExtensions_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')))
    _InitialUE_MessageExtensions_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _InitialUE_MessageExtensions_val_Extension_2 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _InitialUE_MessageExtensions_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-SequenceNumber')))
    _InitialUE_MessageExtensions_val_Extension_4 = NULL(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RedirectAttemptFlag')))
    _InitialUE_MessageExtensions_val_Extension_5 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _InitialUE_MessageExtensions_val_Extension_6 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _InitialUE_MessageExtensions_val_Extension_7 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cell-Access-Mode')))
    _InitialUE_MessageExtensions_val_Extension_8 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _InitialUE_MessageExtensions_val_Extension_9 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'HigherBitratesThan16MbpsFlag')))
    _InitialUE_MessageExtensions_val_Extension_10 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TunnelInformation')))
    _InitialUE_MessageExtensions_val_Extension_11 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _InitialUE_MessageExtensions_val_Extension_12 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    _InitialUE_MessageExtensions_val_Extension_13 = CHOICE(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SGSN-Group-Identity')))
    _InitialUE_MessageExtensions_val_Extension_14 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Usage-Type')))
    _InitialUE_MessageExtensions_val_Extension_15 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DCN-ID')))
    _InitialUE_MessageExtensions_val_Extension_16 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Application-Layer-Measurement-Capability')))
    InitialUE_MessageExtensions._val = ASN1Set(rv=[dict([('id', 108), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 130), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 166), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _InitialUE_MessageExtensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'reject'), ('Extension', _InitialUE_MessageExtensions_val_Extension_6), ('presence', 'optional')]), dict([('id', 235), ('criticality', 'reject'), ('Extension', _InitialUE_MessageExtensions_val_Extension_7), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_8), ('presence', 'optional')]), dict([('id', 250), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_9), ('presence', 'optional')]), dict([('id', 262), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_10), ('presence', 'optional')]), dict([('id', 273), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_11), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_12), ('presence', 'optional')]), dict([('id', 286), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_13), ('presence', 'optional')]), dict([('id', 290), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_14), ('presence', 'optional')]), dict([('id', 291), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_15), ('presence', 'optional')]), dict([('id', 294), ('criticality', 'ignore'), ('Extension', _InitialUE_MessageExtensions_val_Extension_16), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransfer >-----#
    DirectTransfer = SEQ(name='DirectTransfer', mode=MODE_TYPE)
    _DirectTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __DirectTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___DirectTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____DirectTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _____DirectTransfer_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAPI')))
    ____DirectTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'ignore'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'ignore'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 59), ('criticality', 'ignore'), ('Value', _____DirectTransfer_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolIEs__item__id._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__id._const_tab_at = None
    ___DirectTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___DirectTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___DirectTransfer_protocolIEs__item__criticality._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DirectTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___DirectTransfer_protocolIEs__item__value._const_tab = ____DirectTransfer_protocolIEs__item__id_tab
    ___DirectTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __DirectTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DirectTransfer_protocolIEs__item__id),
        ('criticality', ___DirectTransfer_protocolIEs__item__criticality),
        ('value', ___DirectTransfer_protocolIEs__item__value),
        ])
    __DirectTransfer_protocolIEs__item_._ext = None
    _DirectTransfer_protocolIEs._cont = __DirectTransfer_protocolIEs__item_
    _DirectTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DirectTransfer_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DirectTransfer_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DirectTransfer_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____DirectTransfer_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RedirectionIndication')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RedirectionCompleted')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    ____DirectTransfer_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 129), ('criticality', 'ignore'), ('Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 128), ('criticality', 'ignore'), ('Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 202), ('criticality', 'ignore'), ('Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 273), ('criticality', 'ignore'), ('Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Extension', _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DirectTransfer_protocolExtensions__item__id._const_tab = ____DirectTransfer_protocolExtensions__item__id_tab
    ___DirectTransfer_protocolExtensions__item__id._const_tab_at = None
    ___DirectTransfer_protocolExtensions__item__id._const_tab_id = 'id'
    ___DirectTransfer_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab = ____DirectTransfer_protocolExtensions__item__id_tab
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DirectTransfer_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab = ____DirectTransfer_protocolExtensions__item__id_tab
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DirectTransfer_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DirectTransfer_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DirectTransfer_protocolExtensions__item__id),
        ('criticality', ___DirectTransfer_protocolExtensions__item__criticality),
        ('extensionValue', ___DirectTransfer_protocolExtensions__item__extensionValue),
        ])
    __DirectTransfer_protocolExtensions__item_._ext = None
    _DirectTransfer_protocolExtensions._cont = __DirectTransfer_protocolExtensions__item_
    _DirectTransfer_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DirectTransfer._cont = ASN1Dict([
        ('protocolIEs', _DirectTransfer_protocolIEs),
        ('protocolExtensions', _DirectTransfer_protocolExtensions),
        ])
    DirectTransfer._ext = []
    
    #-----< DirectTransferIEs >-----#
    DirectTransferIEs = CLASS(name='DirectTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _DirectTransferIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _DirectTransferIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LAI')))
    _DirectTransferIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAC')))
    _DirectTransferIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAI')))
    _DirectTransferIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SAPI')))
    DirectTransferIEs._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'ignore'), ('Value', _DirectTransferIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 15), ('criticality', 'ignore'), ('Value', _DirectTransferIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 55), ('criticality', 'ignore'), ('Value', _DirectTransferIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 58), ('criticality', 'ignore'), ('Value', _DirectTransferIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 59), ('criticality', 'ignore'), ('Value', _DirectTransferIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransferExtensions >-----#
    DirectTransferExtensions = CLASS(name='DirectTransferExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _DirectTransferExtensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RedirectionIndication')))
    _DirectTransferExtensions_val_Extension_1 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RedirectionCompleted')))
    _DirectTransferExtensions_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SubscriberProfileIDforRFP')))
    _DirectTransferExtensions_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _DirectTransferExtensions_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _DirectTransferExtensions_val_Extension_5 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LHN-ID')))
    DirectTransferExtensions._val = ASN1Set(rv=[dict([('id', 129), ('criticality', 'ignore'), ('Extension', _DirectTransferExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 128), ('criticality', 'ignore'), ('Extension', _DirectTransferExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 202), ('criticality', 'ignore'), ('Extension', _DirectTransferExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 241), ('criticality', 'ignore'), ('Extension', _DirectTransferExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 273), ('criticality', 'ignore'), ('Extension', _DirectTransferExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 275), ('criticality', 'ignore'), ('Extension', _DirectTransferExtensions_val_Extension_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RedirectionIndication >-----#
    RedirectionIndication = SEQ_OF(name='RedirectionIndication', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    _RedirectionIndication__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    __RedirectionIndication__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ___RedirectionIndication__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____RedirectionIndication__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    ____RedirectionIndication__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RejectCauseValue')))
    ____RedirectionIndication__item__id_tab_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-SequenceNumber')))
    ____RedirectionIndication__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    ____RedirectionIndication__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Additional-CSPS-coordination-information')))
    ___RedirectionIndication__item__id_tab._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'ignore'), ('Value', ____RedirectionIndication__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 131), ('criticality', 'ignore'), ('Value', ____RedirectionIndication__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', ____RedirectionIndication__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', ____RedirectionIndication__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Value', ____RedirectionIndication__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    __RedirectionIndication__item__id._const_tab = ___RedirectionIndication__item__id_tab
    __RedirectionIndication__item__id._const_tab_at = None
    __RedirectionIndication__item__id._const_tab_id = 'id'
    __RedirectionIndication__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    __RedirectionIndication__item__criticality._const_tab = ___RedirectionIndication__item__id_tab
    __RedirectionIndication__item__criticality._const_tab_at = ('..', 'id')
    __RedirectionIndication__item__criticality._const_tab_id = 'criticality'
    __RedirectionIndication__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    __RedirectionIndication__item__value._const_tab = ___RedirectionIndication__item__id_tab
    __RedirectionIndication__item__value._const_tab_at = ('..', 'id')
    __RedirectionIndication__item__value._const_tab_id = 'Value'
    _RedirectionIndication__item_._cont = ASN1Dict([
        ('id', __RedirectionIndication__item__id),
        ('criticality', __RedirectionIndication__item__criticality),
        ('value', __RedirectionIndication__item__value),
        ])
    _RedirectionIndication__item_._ext = None
    RedirectionIndication._cont = _RedirectionIndication__item_
    RedirectionIndication._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< RedirectionIndication-IEs >-----#
    RedirectionIndication_IEs = CLASS(name='RedirectionIndication-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RedirectionIndication_IEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _RedirectionIndication_IEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RejectCauseValue')))
    _RedirectionIndication_IEs_val_Value_2 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NAS-SequenceNumber')))
    _RedirectionIndication_IEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    _RedirectionIndication_IEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Additional-CSPS-coordination-information')))
    RedirectionIndication_IEs._val = ASN1Set(rv=[dict([('id', 16), ('criticality', 'ignore'), ('Value', _RedirectionIndication_IEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 131), ('criticality', 'ignore'), ('Value', _RedirectionIndication_IEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 130), ('criticality', 'ignore'), ('Value', _RedirectionIndication_IEs_val_Value_2), ('presence', 'optional')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _RedirectionIndication_IEs_val_Value_3), ('presence', 'optional')]), dict([('id', 280), ('criticality', 'reject'), ('Value', _RedirectionIndication_IEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< Overload >-----#
    Overload = SEQ(name='Overload', mode=MODE_TYPE)
    _Overload_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __Overload_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___Overload_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____Overload_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____Overload_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NumberOfSteps')))
    _____Overload_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____Overload_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'ignore'), ('Value', _____Overload_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____Overload_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Overload_protocolIEs__item__id._const_tab = ____Overload_protocolIEs__item__id_tab
    ___Overload_protocolIEs__item__id._const_tab_at = None
    ___Overload_protocolIEs__item__id._const_tab_id = 'id'
    ___Overload_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___Overload_protocolIEs__item__criticality._const_tab = ____Overload_protocolIEs__item__id_tab
    ___Overload_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___Overload_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___Overload_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___Overload_protocolIEs__item__value._const_tab = ____Overload_protocolIEs__item__id_tab
    ___Overload_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___Overload_protocolIEs__item__value._const_tab_id = 'Value'
    __Overload_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___Overload_protocolIEs__item__id),
        ('criticality', ___Overload_protocolIEs__item__criticality),
        ('value', ___Overload_protocolIEs__item__value),
        ])
    __Overload_protocolIEs__item_._ext = None
    _Overload_protocolIEs._cont = __Overload_protocolIEs__item_
    _Overload_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _Overload_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __Overload_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___Overload_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____Overload_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____Overload_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____Overload_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____Overload_protocolExtensions__item__id_tab_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _____Overload_protocolExtensions__item__id_tab_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Priority-Class-Indicator')))
    ____Overload_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'ignore'), ('Extension', _____Overload_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____Overload_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _____Overload_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 245), ('criticality', 'ignore'), ('Extension', _____Overload_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___Overload_protocolExtensions__item__id._const_tab = ____Overload_protocolExtensions__item__id_tab
    ___Overload_protocolExtensions__item__id._const_tab_at = None
    ___Overload_protocolExtensions__item__id._const_tab_id = 'id'
    ___Overload_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___Overload_protocolExtensions__item__criticality._const_tab = ____Overload_protocolExtensions__item__id_tab
    ___Overload_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___Overload_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___Overload_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___Overload_protocolExtensions__item__extensionValue._const_tab = ____Overload_protocolExtensions__item__id_tab
    ___Overload_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___Overload_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __Overload_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___Overload_protocolExtensions__item__id),
        ('criticality', ___Overload_protocolExtensions__item__criticality),
        ('extensionValue', ___Overload_protocolExtensions__item__extensionValue),
        ])
    __Overload_protocolExtensions__item_._ext = None
    _Overload_protocolExtensions._cont = __Overload_protocolExtensions__item_
    _Overload_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    Overload._cont = ASN1Dict([
        ('protocolIEs', _Overload_protocolIEs),
        ('protocolExtensions', _Overload_protocolExtensions),
        ])
    Overload._ext = []
    
    #-----< OverloadIEs >-----#
    OverloadIEs = CLASS(name='OverloadIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _OverloadIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'NumberOfSteps')))
    _OverloadIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    OverloadIEs._val = ASN1Set(rv=[dict([('id', 18), ('criticality', 'ignore'), ('Value', _OverloadIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _OverloadIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< OverloadExtensions >-----#
    OverloadExtensions = CLASS(name='OverloadExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _OverloadExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _OverloadExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _OverloadExtensions_val_Extension_2 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    _OverloadExtensions_val_Extension_3 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Priority-Class-Indicator')))
    OverloadExtensions._val = ASN1Set(rv=[dict([('id', 3), ('criticality', 'ignore'), ('Extension', _OverloadExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Extension', _OverloadExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _OverloadExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 245), ('criticality', 'ignore'), ('Extension', _OverloadExtensions_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndication >-----#
    ErrorIndication = SEQ(name='ErrorIndication', mode=MODE_TYPE)
    _ErrorIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ErrorIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ErrorIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____ErrorIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____ErrorIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolIEs__item__id._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__id._const_tab_at = None
    ___ErrorIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___ErrorIndication_protocolIEs__item__criticality._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___ErrorIndication_protocolIEs__item__value._const_tab = ____ErrorIndication_protocolIEs__item__id_tab
    ___ErrorIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __ErrorIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolIEs__item__id),
        ('criticality', ___ErrorIndication_protocolIEs__item__criticality),
        ('value', ___ErrorIndication_protocolIEs__item__value),
        ])
    __ErrorIndication_protocolIEs__item_._ext = None
    _ErrorIndication_protocolIEs._cont = __ErrorIndication_protocolIEs__item_
    _ErrorIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ErrorIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ErrorIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ErrorIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____ErrorIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____ErrorIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ErrorIndication_protocolExtensions__item__id._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__id._const_tab_at = None
    ___ErrorIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___ErrorIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ErrorIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab = ____ErrorIndication_protocolExtensions__item__id_tab
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ErrorIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ErrorIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ErrorIndication_protocolExtensions__item__id),
        ('criticality', ___ErrorIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___ErrorIndication_protocolExtensions__item__extensionValue),
        ])
    __ErrorIndication_protocolExtensions__item_._ext = None
    _ErrorIndication_protocolExtensions._cont = __ErrorIndication_protocolExtensions__item_
    _ErrorIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ErrorIndication._cont = ASN1Dict([
        ('protocolIEs', _ErrorIndication_protocolIEs),
        ('protocolExtensions', _ErrorIndication_protocolExtensions),
        ])
    ErrorIndication._ext = []
    
    #-----< ErrorIndicationIEs >-----#
    ErrorIndicationIEs = CLASS(name='ErrorIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ErrorIndicationIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _ErrorIndicationIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _ErrorIndicationIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _ErrorIndicationIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ErrorIndicationIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _ErrorIndicationIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< ErrorIndicationExtensions >-----#
    ErrorIndicationExtensions = CLASS(name='ErrorIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ErrorIndicationExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _ErrorIndicationExtensions_val_Extension_1 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ErrorIndicationExtensions._val = ASN1Set(rv=[dict([('id', 96), ('criticality', 'ignore'), ('Extension', _ErrorIndicationExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 171), ('criticality', 'reject'), ('Extension', _ErrorIndicationExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRNS-DataForwardCommand >-----#
    SRNS_DataForwardCommand = SEQ(name='SRNS-DataForwardCommand', mode=MODE_TYPE)
    _SRNS_DataForwardCommand_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SRNS_DataForwardCommand_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SRNS_DataForwardCommand_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____SRNS_DataForwardCommand_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SRNS_DataForwardCommand_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList')))
    ____SRNS_DataForwardCommand_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 28), ('criticality', 'ignore'), ('Value', _____SRNS_DataForwardCommand_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SRNS_DataForwardCommand_protocolIEs__item__id._const_tab = ____SRNS_DataForwardCommand_protocolIEs__item__id_tab
    ___SRNS_DataForwardCommand_protocolIEs__item__id._const_tab_at = None
    ___SRNS_DataForwardCommand_protocolIEs__item__id._const_tab_id = 'id'
    ___SRNS_DataForwardCommand_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___SRNS_DataForwardCommand_protocolIEs__item__criticality._const_tab = ____SRNS_DataForwardCommand_protocolIEs__item__id_tab
    ___SRNS_DataForwardCommand_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SRNS_DataForwardCommand_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SRNS_DataForwardCommand_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___SRNS_DataForwardCommand_protocolIEs__item__value._const_tab = ____SRNS_DataForwardCommand_protocolIEs__item__id_tab
    ___SRNS_DataForwardCommand_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SRNS_DataForwardCommand_protocolIEs__item__value._const_tab_id = 'Value'
    __SRNS_DataForwardCommand_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SRNS_DataForwardCommand_protocolIEs__item__id),
        ('criticality', ___SRNS_DataForwardCommand_protocolIEs__item__criticality),
        ('value', ___SRNS_DataForwardCommand_protocolIEs__item__value),
        ])
    __SRNS_DataForwardCommand_protocolIEs__item_._ext = None
    _SRNS_DataForwardCommand_protocolIEs._cont = __SRNS_DataForwardCommand_protocolIEs__item_
    _SRNS_DataForwardCommand_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SRNS_DataForwardCommand_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRNS_DataForwardCommand_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRNS_DataForwardCommand_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SRNS_DataForwardCommand_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_DataForwardCommand_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_DataForwardCommand_protocolExtensions__item__id._const_tab = ____SRNS_DataForwardCommand_protocolExtensions__item__id_tab
    ___SRNS_DataForwardCommand_protocolExtensions__item__id._const_tab_at = None
    ___SRNS_DataForwardCommand_protocolExtensions__item__id._const_tab_id = 'id'
    ___SRNS_DataForwardCommand_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRNS_DataForwardCommand_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_DataForwardCommand_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_DataForwardCommand_protocolExtensions__item__criticality._const_tab = ____SRNS_DataForwardCommand_protocolExtensions__item__criticality_tab
    ___SRNS_DataForwardCommand_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRNS_DataForwardCommand_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRNS_DataForwardCommand_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRNS_DataForwardCommand_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue._const_tab = ____SRNS_DataForwardCommand_protocolExtensions__item__extensionValue_tab
    ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SRNS_DataForwardCommand_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SRNS_DataForwardCommand_protocolExtensions__item__id),
        ('criticality', ___SRNS_DataForwardCommand_protocolExtensions__item__criticality),
        ('extensionValue', ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue),
        ])
    __SRNS_DataForwardCommand_protocolExtensions__item_._ext = None
    _SRNS_DataForwardCommand_protocolExtensions._cont = __SRNS_DataForwardCommand_protocolExtensions__item_
    _SRNS_DataForwardCommand_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRNS_DataForwardCommand._cont = ASN1Dict([
        ('protocolIEs', _SRNS_DataForwardCommand_protocolIEs),
        ('protocolExtensions', _SRNS_DataForwardCommand_protocolExtensions),
        ])
    SRNS_DataForwardCommand._ext = []
    
    #-----< SRNS-DataForwardCommandIEs >-----#
    SRNS_DataForwardCommandIEs = CLASS(name='SRNS-DataForwardCommandIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SRNS_DataForwardCommandIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-DataForwardingList')))
    SRNS_DataForwardCommandIEs._val = ASN1Set(rv=[dict([('id', 28), ('criticality', 'ignore'), ('Value', _SRNS_DataForwardCommandIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRNS-DataForwardCommandExtensions >-----#
    SRNS_DataForwardCommandExtensions = CLASS(name='SRNS-DataForwardCommandExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRNS_DataForwardCommandExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ForwardSRNS-Context >-----#
    ForwardSRNS_Context = SEQ(name='ForwardSRNS-Context', mode=MODE_TYPE)
    _ForwardSRNS_Context_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __ForwardSRNS_Context_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___ForwardSRNS_Context_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____ForwardSRNS_Context_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____ForwardSRNS_Context_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList')))
    ____ForwardSRNS_Context_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _____ForwardSRNS_Context_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___ForwardSRNS_Context_protocolIEs__item__id._const_tab = ____ForwardSRNS_Context_protocolIEs__item__id_tab
    ___ForwardSRNS_Context_protocolIEs__item__id._const_tab_at = None
    ___ForwardSRNS_Context_protocolIEs__item__id._const_tab_id = 'id'
    ___ForwardSRNS_Context_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___ForwardSRNS_Context_protocolIEs__item__criticality._const_tab = ____ForwardSRNS_Context_protocolIEs__item__id_tab
    ___ForwardSRNS_Context_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___ForwardSRNS_Context_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___ForwardSRNS_Context_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___ForwardSRNS_Context_protocolIEs__item__value._const_tab = ____ForwardSRNS_Context_protocolIEs__item__id_tab
    ___ForwardSRNS_Context_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___ForwardSRNS_Context_protocolIEs__item__value._const_tab_id = 'Value'
    __ForwardSRNS_Context_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___ForwardSRNS_Context_protocolIEs__item__id),
        ('criticality', ___ForwardSRNS_Context_protocolIEs__item__criticality),
        ('value', ___ForwardSRNS_Context_protocolIEs__item__value),
        ])
    __ForwardSRNS_Context_protocolIEs__item_._ext = None
    _ForwardSRNS_Context_protocolIEs._cont = __ForwardSRNS_Context_protocolIEs__item_
    _ForwardSRNS_Context_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ForwardSRNS_Context_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __ForwardSRNS_Context_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___ForwardSRNS_Context_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____ForwardSRNS_Context_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____ForwardSRNS_Context_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    ____ForwardSRNS_Context_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____ForwardSRNS_Context_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___ForwardSRNS_Context_protocolExtensions__item__id._const_tab = ____ForwardSRNS_Context_protocolExtensions__item__id_tab
    ___ForwardSRNS_Context_protocolExtensions__item__id._const_tab_at = None
    ___ForwardSRNS_Context_protocolExtensions__item__id._const_tab_id = 'id'
    ___ForwardSRNS_Context_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___ForwardSRNS_Context_protocolExtensions__item__criticality._const_tab = ____ForwardSRNS_Context_protocolExtensions__item__id_tab
    ___ForwardSRNS_Context_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___ForwardSRNS_Context_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___ForwardSRNS_Context_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___ForwardSRNS_Context_protocolExtensions__item__extensionValue._const_tab = ____ForwardSRNS_Context_protocolExtensions__item__id_tab
    ___ForwardSRNS_Context_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___ForwardSRNS_Context_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __ForwardSRNS_Context_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___ForwardSRNS_Context_protocolExtensions__item__id),
        ('criticality', ___ForwardSRNS_Context_protocolExtensions__item__criticality),
        ('extensionValue', ___ForwardSRNS_Context_protocolExtensions__item__extensionValue),
        ])
    __ForwardSRNS_Context_protocolExtensions__item_._ext = None
    _ForwardSRNS_Context_protocolExtensions._cont = __ForwardSRNS_Context_protocolExtensions__item_
    _ForwardSRNS_Context_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    ForwardSRNS_Context._cont = ASN1Dict([
        ('protocolIEs', _ForwardSRNS_Context_protocolIEs),
        ('protocolExtensions', _ForwardSRNS_Context_protocolExtensions),
        ])
    ForwardSRNS_Context._ext = []
    
    #-----< ForwardSRNS-ContextIEs >-----#
    ForwardSRNS_ContextIEs = CLASS(name='ForwardSRNS-ContextIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _ForwardSRNS_ContextIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList')))
    ForwardSRNS_ContextIEs._val = ASN1Set(rv=[dict([('id', 25), ('criticality', 'ignore'), ('Value', _ForwardSRNS_ContextIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< ForwardSRNS-ContextExtensions >-----#
    ForwardSRNS_ContextExtensions = CLASS(name='ForwardSRNS-ContextExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _ForwardSRNS_ContextExtensions_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    ForwardSRNS_ContextExtensions._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _ForwardSRNS_ContextExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-AssignmentRequest >-----#
    RAB_AssignmentRequest = SEQ(name='RAB-AssignmentRequest', mode=MODE_TYPE)
    _RAB_AssignmentRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_AssignmentRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_AssignmentRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_AssignmentRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyList')))
    _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseList')))
    ____RAB_AssignmentRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 54), ('criticality', 'ignore'), ('Value', _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_AssignmentRequest_protocolIEs__item__id._const_tab = ____RAB_AssignmentRequest_protocolIEs__item__id_tab
    ___RAB_AssignmentRequest_protocolIEs__item__id._const_tab_at = None
    ___RAB_AssignmentRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RAB_AssignmentRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_AssignmentRequest_protocolIEs__item__criticality._const_tab = ____RAB_AssignmentRequest_protocolIEs__item__id_tab
    ___RAB_AssignmentRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_AssignmentRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RAB_AssignmentRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_AssignmentRequest_protocolIEs__item__value._const_tab = ____RAB_AssignmentRequest_protocolIEs__item__id_tab
    ___RAB_AssignmentRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RAB_AssignmentRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RAB_AssignmentRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RAB_AssignmentRequest_protocolIEs__item__id),
        ('criticality', ___RAB_AssignmentRequest_protocolIEs__item__criticality),
        ('value', ___RAB_AssignmentRequest_protocolIEs__item__value),
        ])
    __RAB_AssignmentRequest_protocolIEs__item_._ext = None
    _RAB_AssignmentRequest_protocolIEs._cont = __RAB_AssignmentRequest_protocolIEs__item_
    _RAB_AssignmentRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RAB_AssignmentRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_AssignmentRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_AssignmentRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_AssignmentRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    ____RAB_AssignmentRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 233), ('criticality', 'ignore'), ('Extension', _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 239), ('criticality', 'ignore'), ('Extension', _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_AssignmentRequest_protocolExtensions__item__id._const_tab = ____RAB_AssignmentRequest_protocolExtensions__item__id_tab
    ___RAB_AssignmentRequest_protocolExtensions__item__id._const_tab_at = None
    ___RAB_AssignmentRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___RAB_AssignmentRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_AssignmentRequest_protocolExtensions__item__criticality._const_tab = ____RAB_AssignmentRequest_protocolExtensions__item__id_tab
    ___RAB_AssignmentRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_AssignmentRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue._const_tab = ____RAB_AssignmentRequest_protocolExtensions__item__id_tab
    ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_AssignmentRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RAB_AssignmentRequest_protocolExtensions__item__id),
        ('criticality', ___RAB_AssignmentRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue),
        ])
    __RAB_AssignmentRequest_protocolExtensions__item_._ext = None
    _RAB_AssignmentRequest_protocolExtensions._cont = __RAB_AssignmentRequest_protocolExtensions__item_
    _RAB_AssignmentRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_AssignmentRequest._cont = ASN1Dict([
        ('protocolIEs', _RAB_AssignmentRequest_protocolIEs),
        ('protocolExtensions', _RAB_AssignmentRequest_protocolExtensions),
        ])
    RAB_AssignmentRequest._ext = []
    
    #-----< RAB-AssignmentRequestIEs >-----#
    RAB_AssignmentRequestIEs = CLASS(name='RAB-AssignmentRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_AssignmentRequestIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyList')))
    _RAB_AssignmentRequestIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseList')))
    RAB_AssignmentRequestIEs._val = ASN1Set(rv=[dict([('id', 54), ('criticality', 'ignore'), ('Value', _RAB_AssignmentRequestIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 41), ('criticality', 'ignore'), ('Value', _RAB_AssignmentRequestIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifyList >-----#
    RAB_SetupOrModifyList = SEQ_OF(name='RAB-SetupOrModifyList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerPairList')))
    _RAB_SetupOrModifyList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-ContainerPair')))
    __RAB_SetupOrModifyList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-FieldPair')))
    ___RAB_SetupOrModifyList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR'), ['id']))
    ____RAB_SetupOrModifyList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES-PAIR', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR')))
    _____RAB_SetupOrModifyList__item___item__id_tab_val_FirstValue_0 = SEQ(name='FirstValue', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyItemFirst')))
    _____RAB_SetupOrModifyList__item___item__id_tab_val_SecondValue_0 = SEQ(name='SecondValue', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyItemSecond')))
    ____RAB_SetupOrModifyList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 53), ('firstCriticality', 'reject'), ('FirstValue', _____RAB_SetupOrModifyList__item___item__id_tab_val_FirstValue_0), ('secondCriticality', 'ignore'), ('SecondValue', _____RAB_SetupOrModifyList__item___item__id_tab_val_SecondValue_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupOrModifyList__item___item__id._const_tab = ____RAB_SetupOrModifyList__item___item__id_tab
    ___RAB_SetupOrModifyList__item___item__id._const_tab_at = None
    ___RAB_SetupOrModifyList__item___item__id._const_tab_id = 'id'
    ___RAB_SetupOrModifyList__item___item__firstCriticality = ENUM(name='firstCriticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR'), ['firstCriticality']))
    ___RAB_SetupOrModifyList__item___item__firstCriticality._const_tab = ____RAB_SetupOrModifyList__item___item__id_tab
    ___RAB_SetupOrModifyList__item___item__firstCriticality._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifyList__item___item__firstCriticality._const_tab_id = 'firstCriticality'
    ___RAB_SetupOrModifyList__item___item__firstValue = OPEN(name='firstValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR'), ['FirstValue']))
    ___RAB_SetupOrModifyList__item___item__firstValue._const_tab = ____RAB_SetupOrModifyList__item___item__id_tab
    ___RAB_SetupOrModifyList__item___item__firstValue._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifyList__item___item__firstValue._const_tab_id = 'FirstValue'
    ___RAB_SetupOrModifyList__item___item__secondCriticality = ENUM(name='secondCriticality', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR'), ['secondCriticality']))
    ___RAB_SetupOrModifyList__item___item__secondCriticality._const_tab = ____RAB_SetupOrModifyList__item___item__id_tab
    ___RAB_SetupOrModifyList__item___item__secondCriticality._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifyList__item___item__secondCriticality._const_tab_id = 'secondCriticality'
    ___RAB_SetupOrModifyList__item___item__secondValue = OPEN(name='secondValue', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR'), ['SecondValue']))
    ___RAB_SetupOrModifyList__item___item__secondValue._const_tab = ____RAB_SetupOrModifyList__item___item__id_tab
    ___RAB_SetupOrModifyList__item___item__secondValue._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifyList__item___item__secondValue._const_tab_id = 'SecondValue'
    __RAB_SetupOrModifyList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_SetupOrModifyList__item___item__id),
        ('firstCriticality', ___RAB_SetupOrModifyList__item___item__firstCriticality),
        ('firstValue', ___RAB_SetupOrModifyList__item___item__firstValue),
        ('secondCriticality', ___RAB_SetupOrModifyList__item___item__secondCriticality),
        ('secondValue', ___RAB_SetupOrModifyList__item___item__secondValue),
        ])
    __RAB_SetupOrModifyList__item___item_._ext = None
    _RAB_SetupOrModifyList__item_._cont = __RAB_SetupOrModifyList__item___item_
    _RAB_SetupOrModifyList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupOrModifyList._cont = _RAB_SetupOrModifyList__item_
    RAB_SetupOrModifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupOrModifyItem-IEs >-----#
    RAB_SetupOrModifyItem_IEs = CLASS(name='RAB-SetupOrModifyItem-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES-PAIR')))
    _RAB_SetupOrModifyItem_IEs_val_FirstValue_0 = SEQ(name='FirstValue', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyItemFirst')))
    _RAB_SetupOrModifyItem_IEs_val_SecondValue_0 = SEQ(name='SecondValue', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifyItemSecond')))
    RAB_SetupOrModifyItem_IEs._val = ASN1Set(rv=[dict([('id', 53), ('firstCriticality', 'reject'), ('FirstValue', _RAB_SetupOrModifyItem_IEs_val_FirstValue_0), ('secondCriticality', 'ignore'), ('SecondValue', _RAB_SetupOrModifyItem_IEs_val_SecondValue_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifyItemFirst >-----#
    RAB_SetupOrModifyItemFirst = SEQ(name='RAB-SetupOrModifyItemFirst', mode=MODE_TYPE)
    _RAB_SetupOrModifyItemFirst_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupOrModifyItemFirst_nAS_SynchronisationIndicator = BIT_STR(name='nAS-SynchronisationIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NAS-SynchronisationIndicator')), opt=True)
    _RAB_SetupOrModifyItemFirst_rAB_Parameters = SEQ(name='rAB-Parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')), opt=True)
    _RAB_SetupOrModifyItemFirst_userPlaneInformation = SEQ(name='userPlaneInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'UserPlaneInformation')), opt=True)
    _RAB_SetupOrModifyItemFirst_transportLayerInformation = SEQ(name='transportLayerInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')), opt=True)
    _RAB_SetupOrModifyItemFirst_service_Handover = ENUM(name='service-Handover', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Service-Handover')), opt=True)
    _RAB_SetupOrModifyItemFirst_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupOrModifyItemFirst_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Correlation-ID')))
    _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Correlation-ID')))
    ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 231), ('criticality', 'ignore'), ('Extension', _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 242), ('criticality', 'ignore'), ('Extension', _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 274), ('criticality', 'ignore'), ('Extension', _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id._const_tab = ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality._const_tab = ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_SetupOrModifyItemFirst_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id),
        ('criticality', ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupOrModifyItemFirst_iE_Extensions__item_._ext = None
    _RAB_SetupOrModifyItemFirst_iE_Extensions._cont = __RAB_SetupOrModifyItemFirst_iE_Extensions__item_
    _RAB_SetupOrModifyItemFirst_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupOrModifyItemFirst._cont = ASN1Dict([
        ('rAB-ID', _RAB_SetupOrModifyItemFirst_rAB_ID),
        ('nAS-SynchronisationIndicator', _RAB_SetupOrModifyItemFirst_nAS_SynchronisationIndicator),
        ('rAB-Parameters', _RAB_SetupOrModifyItemFirst_rAB_Parameters),
        ('userPlaneInformation', _RAB_SetupOrModifyItemFirst_userPlaneInformation),
        ('transportLayerInformation', _RAB_SetupOrModifyItemFirst_transportLayerInformation),
        ('service-Handover', _RAB_SetupOrModifyItemFirst_service_Handover),
        ('iE-Extensions', _RAB_SetupOrModifyItemFirst_iE_Extensions),
        ])
    RAB_SetupOrModifyItemFirst._ext = []
    
    #-----< TransportLayerInformation >-----#
    TransportLayerInformation = SEQ(name='TransportLayerInformation', mode=MODE_TYPE)
    _TransportLayerInformation_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _TransportLayerInformation_iuTransportAssociation = CHOICE(name='iuTransportAssociation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    _TransportLayerInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TransportLayerInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TransportLayerInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TransportLayerInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TransportLayerInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportLayerInformation_iE_Extensions__item__id._const_tab = ____TransportLayerInformation_iE_Extensions__item__id_tab
    ___TransportLayerInformation_iE_Extensions__item__id._const_tab_at = None
    ___TransportLayerInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___TransportLayerInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TransportLayerInformation_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TransportLayerInformation_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportLayerInformation_iE_Extensions__item__criticality._const_tab = ____TransportLayerInformation_iE_Extensions__item__criticality_tab
    ___TransportLayerInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TransportLayerInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TransportLayerInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TransportLayerInformation_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TransportLayerInformation_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TransportLayerInformation_iE_Extensions__item__extensionValue._const_tab = ____TransportLayerInformation_iE_Extensions__item__extensionValue_tab
    ___TransportLayerInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TransportLayerInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TransportLayerInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TransportLayerInformation_iE_Extensions__item__id),
        ('criticality', ___TransportLayerInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___TransportLayerInformation_iE_Extensions__item__extensionValue),
        ])
    __TransportLayerInformation_iE_Extensions__item_._ext = None
    _TransportLayerInformation_iE_Extensions._cont = __TransportLayerInformation_iE_Extensions__item_
    _TransportLayerInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TransportLayerInformation._cont = ASN1Dict([
        ('transportLayerAddress', _TransportLayerInformation_transportLayerAddress),
        ('iuTransportAssociation', _TransportLayerInformation_iuTransportAssociation),
        ('iE-Extensions', _TransportLayerInformation_iE_Extensions),
        ])
    TransportLayerInformation._ext = []
    
    #-----< TransportLayerInformation-ExtIEs >-----#
    TransportLayerInformation_ExtIEs = CLASS(name='TransportLayerInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TransportLayerInformation_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifyItemFirst-ExtIEs >-----#
    RAB_SetupOrModifyItemFirst_ExtIEs = CLASS(name='RAB-SetupOrModifyItemFirst-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Correlation-ID')))
    _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_2 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Correlation-ID')))
    RAB_SetupOrModifyItemFirst_ExtIEs._val = ASN1Set(rv=[dict([('id', 231), ('criticality', 'ignore'), ('Extension', _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 242), ('criticality', 'ignore'), ('Extension', _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 274), ('criticality', 'ignore'), ('Extension', _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifyItemSecond >-----#
    RAB_SetupOrModifyItemSecond = SEQ(name='RAB-SetupOrModifyItemSecond', mode=MODE_TYPE)
    _RAB_SetupOrModifyItemSecond_pDP_TypeInformation = SEQ_OF(name='pDP-TypeInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation')), opt=True)
    _RAB_SetupOrModifyItemSecond_dataVolumeReportingIndication = ENUM(name='dataVolumeReportingIndication', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataVolumeReportingIndication')), opt=True)
    _RAB_SetupOrModifyItemSecond_dl_GTP_PDU_SequenceNumber = INT(name='dl-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_SetupOrModifyItemSecond_ul_GTP_PDU_SequenceNumber = INT(name='ul-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_SetupOrModifyItemSecond_dl_N_PDU_SequenceNumber = INT(name='dl-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-N-PDU-SequenceNumber')), opt=True)
    _RAB_SetupOrModifyItemSecond_ul_N_PDU_SequenceNumber = INT(name='ul-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-N-PDU-SequenceNumber')), opt=True)
    _RAB_SetupOrModifyItemSecond_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupOrModifyItemSecond_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameters')))
    _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-BSC-Container')))
    _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'ignore'), ('Extension', _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Extension', _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Extension', _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Extension', _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id._const_tab = ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality._const_tab = ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_SetupOrModifyItemSecond_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id),
        ('criticality', ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupOrModifyItemSecond_iE_Extensions__item_._ext = None
    _RAB_SetupOrModifyItemSecond_iE_Extensions._cont = __RAB_SetupOrModifyItemSecond_iE_Extensions__item_
    _RAB_SetupOrModifyItemSecond_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupOrModifyItemSecond._cont = ASN1Dict([
        ('pDP-TypeInformation', _RAB_SetupOrModifyItemSecond_pDP_TypeInformation),
        ('dataVolumeReportingIndication', _RAB_SetupOrModifyItemSecond_dataVolumeReportingIndication),
        ('dl-GTP-PDU-SequenceNumber', _RAB_SetupOrModifyItemSecond_dl_GTP_PDU_SequenceNumber),
        ('ul-GTP-PDU-SequenceNumber', _RAB_SetupOrModifyItemSecond_ul_GTP_PDU_SequenceNumber),
        ('dl-N-PDU-SequenceNumber', _RAB_SetupOrModifyItemSecond_dl_N_PDU_SequenceNumber),
        ('ul-N-PDU-SequenceNumber', _RAB_SetupOrModifyItemSecond_ul_N_PDU_SequenceNumber),
        ('iE-Extensions', _RAB_SetupOrModifyItemSecond_iE_Extensions),
        ])
    RAB_SetupOrModifyItemSecond._ext = []
    
    #-----< RAB-SetupOrModifyItemSecond-ExtIEs >-----#
    RAB_SetupOrModifyItemSecond_ExtIEs = CLASS(name='RAB-SetupOrModifyItemSecond-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameters')))
    _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GERAN-BSC-Container')))
    _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_3 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Offload-RAB-Parameters')))
    RAB_SetupOrModifyItemSecond_ExtIEs._val = ASN1Set(rv=[dict([('id', 89), ('criticality', 'ignore'), ('Extension', _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 107), ('criticality', 'ignore'), ('Extension', _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_1), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Extension', _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_2), ('presence', 'optional')]), dict([('id', 240), ('criticality', 'ignore'), ('Extension', _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-AssignmentRequestExtensions >-----#
    RAB_AssignmentRequestExtensions = CLASS(name='RAB-AssignmentRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_AssignmentRequestExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RAB_AssignmentRequestExtensions_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MSISDN')))
    RAB_AssignmentRequestExtensions._val = ASN1Set(rv=[dict([('id', 233), ('criticality', 'ignore'), ('Extension', _RAB_AssignmentRequestExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 239), ('criticality', 'ignore'), ('Extension', _RAB_AssignmentRequestExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-AssignmentResponse >-----#
    RAB_AssignmentResponse = SEQ(name='RAB-AssignmentResponse', mode=MODE_TYPE)
    _RAB_AssignmentResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_AssignmentResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_AssignmentResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_AssignmentResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifiedList')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedList')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-QueuedList')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseFailedList')))
    _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RAB_AssignmentResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 52), ('criticality', 'ignore'), ('Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 43), ('criticality', 'ignore'), ('Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'ignore'), ('Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 39), ('criticality', 'ignore'), ('Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_AssignmentResponse_protocolIEs__item__id._const_tab = ____RAB_AssignmentResponse_protocolIEs__item__id_tab
    ___RAB_AssignmentResponse_protocolIEs__item__id._const_tab_at = None
    ___RAB_AssignmentResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___RAB_AssignmentResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_AssignmentResponse_protocolIEs__item__criticality._const_tab = ____RAB_AssignmentResponse_protocolIEs__item__id_tab
    ___RAB_AssignmentResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_AssignmentResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RAB_AssignmentResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_AssignmentResponse_protocolIEs__item__value._const_tab = ____RAB_AssignmentResponse_protocolIEs__item__id_tab
    ___RAB_AssignmentResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RAB_AssignmentResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __RAB_AssignmentResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RAB_AssignmentResponse_protocolIEs__item__id),
        ('criticality', ___RAB_AssignmentResponse_protocolIEs__item__criticality),
        ('value', ___RAB_AssignmentResponse_protocolIEs__item__value),
        ])
    __RAB_AssignmentResponse_protocolIEs__item_._ext = None
    _RAB_AssignmentResponse_protocolIEs._cont = __RAB_AssignmentResponse_protocolIEs__item_
    _RAB_AssignmentResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RAB_AssignmentResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_AssignmentResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_AssignmentResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_AssignmentResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_AssignmentResponse_protocolExtensions__item__id_tab_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'GERAN-Iumode-RAB-FailedList-RABAssgntResponse')))
    ____RAB_AssignmentResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 110), ('criticality', 'ignore'), ('Extension', _____RAB_AssignmentResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_AssignmentResponse_protocolExtensions__item__id._const_tab = ____RAB_AssignmentResponse_protocolExtensions__item__id_tab
    ___RAB_AssignmentResponse_protocolExtensions__item__id._const_tab_at = None
    ___RAB_AssignmentResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___RAB_AssignmentResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_AssignmentResponse_protocolExtensions__item__criticality._const_tab = ____RAB_AssignmentResponse_protocolExtensions__item__id_tab
    ___RAB_AssignmentResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_AssignmentResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue._const_tab = ____RAB_AssignmentResponse_protocolExtensions__item__id_tab
    ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_AssignmentResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RAB_AssignmentResponse_protocolExtensions__item__id),
        ('criticality', ___RAB_AssignmentResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue),
        ])
    __RAB_AssignmentResponse_protocolExtensions__item_._ext = None
    _RAB_AssignmentResponse_protocolExtensions._cont = __RAB_AssignmentResponse_protocolExtensions__item_
    _RAB_AssignmentResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_AssignmentResponse._cont = ASN1Dict([
        ('protocolIEs', _RAB_AssignmentResponse_protocolIEs),
        ('protocolExtensions', _RAB_AssignmentResponse_protocolExtensions),
        ])
    RAB_AssignmentResponse._ext = []
    
    #-----< RAB-AssignmentResponseIEs >-----#
    RAB_AssignmentResponseIEs = CLASS(name='RAB-AssignmentResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_AssignmentResponseIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifiedList')))
    _RAB_AssignmentResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedList')))
    _RAB_AssignmentResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-QueuedList')))
    _RAB_AssignmentResponseIEs_val_Value_3 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    _RAB_AssignmentResponseIEs_val_Value_4 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseFailedList')))
    _RAB_AssignmentResponseIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RAB_AssignmentResponseIEs._val = ASN1Set(rv=[dict([('id', 52), ('criticality', 'ignore'), ('Value', _RAB_AssignmentResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 43), ('criticality', 'ignore'), ('Value', _RAB_AssignmentResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 38), ('criticality', 'ignore'), ('Value', _RAB_AssignmentResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 35), ('criticality', 'ignore'), ('Value', _RAB_AssignmentResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 39), ('criticality', 'ignore'), ('Value', _RAB_AssignmentResponseIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _RAB_AssignmentResponseIEs_val_Value_5), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifiedList >-----#
    RAB_SetupOrModifiedList = SEQ_OF(name='RAB-SetupOrModifiedList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupOrModifiedList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupOrModifiedList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupOrModifiedList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_SetupOrModifiedList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupOrModifiedList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifiedItem')))
    ____RAB_SetupOrModifiedList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'ignore'), ('Value', _____RAB_SetupOrModifiedList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupOrModifiedList__item___item__id._const_tab = ____RAB_SetupOrModifiedList__item___item__id_tab
    ___RAB_SetupOrModifiedList__item___item__id._const_tab_at = None
    ___RAB_SetupOrModifiedList__item___item__id._const_tab_id = 'id'
    ___RAB_SetupOrModifiedList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_SetupOrModifiedList__item___item__criticality._const_tab = ____RAB_SetupOrModifiedList__item___item__id_tab
    ___RAB_SetupOrModifiedList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifiedList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupOrModifiedList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_SetupOrModifiedList__item___item__value._const_tab = ____RAB_SetupOrModifiedList__item___item__id_tab
    ___RAB_SetupOrModifiedList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifiedList__item___item__value._const_tab_id = 'Value'
    __RAB_SetupOrModifiedList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_SetupOrModifiedList__item___item__id),
        ('criticality', ___RAB_SetupOrModifiedList__item___item__criticality),
        ('value', ___RAB_SetupOrModifiedList__item___item__value),
        ])
    __RAB_SetupOrModifiedList__item___item_._ext = None
    _RAB_SetupOrModifiedList__item_._cont = __RAB_SetupOrModifiedList__item___item_
    _RAB_SetupOrModifiedList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupOrModifiedList._cont = _RAB_SetupOrModifiedList__item_
    RAB_SetupOrModifiedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupOrModifiedItemIEs >-----#
    RAB_SetupOrModifiedItemIEs = CLASS(name='RAB-SetupOrModifiedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupOrModifiedItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupOrModifiedItem')))
    RAB_SetupOrModifiedItemIEs._val = ASN1Set(rv=[dict([('id', 51), ('criticality', 'ignore'), ('Value', _RAB_SetupOrModifiedItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupOrModifiedItem >-----#
    RAB_SetupOrModifiedItem = SEQ(name='RAB-SetupOrModifiedItem', mode=MODE_TYPE)
    _RAB_SetupOrModifiedItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupOrModifiedItem_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')), opt=True)
    _RAB_SetupOrModifiedItem_iuTransportAssociation = CHOICE(name='iuTransportAssociation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')), opt=True)
    _RAB_SetupOrModifiedItem_dl_dataVolumes = SEQ_OF(name='dl-dataVolumes', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeList')), opt=True)
    _RAB_SetupOrModifiedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupOrModifiedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')))
    ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 90), ('criticality', 'ignore'), ('Extension', _____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__id._const_tab = ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality._const_tab = ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_SetupOrModifiedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_SetupOrModifiedItem_iE_Extensions__item__id),
        ('criticality', ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupOrModifiedItem_iE_Extensions__item_._ext = None
    _RAB_SetupOrModifiedItem_iE_Extensions._cont = __RAB_SetupOrModifiedItem_iE_Extensions__item_
    _RAB_SetupOrModifiedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupOrModifiedItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_SetupOrModifiedItem_rAB_ID),
        ('transportLayerAddress', _RAB_SetupOrModifiedItem_transportLayerAddress),
        ('iuTransportAssociation', _RAB_SetupOrModifiedItem_iuTransportAssociation),
        ('dl-dataVolumes', _RAB_SetupOrModifiedItem_dl_dataVolumes),
        ('iE-Extensions', _RAB_SetupOrModifiedItem_iE_Extensions),
        ])
    RAB_SetupOrModifiedItem._ext = []
    
    #-----< RAB-SetupOrModifiedItem-ExtIEs >-----#
    RAB_SetupOrModifiedItem_ExtIEs = CLASS(name='RAB-SetupOrModifiedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupOrModifiedItem_ExtIEs_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')))
    RAB_SetupOrModifiedItem_ExtIEs._val = ASN1Set(rv=[dict([('id', 90), ('criticality', 'ignore'), ('Extension', _RAB_SetupOrModifiedItem_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleasedList >-----#
    RAB_ReleasedList = SEQ_OF(name='RAB-ReleasedList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ReleasedList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ReleasedList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ReleasedList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_ReleasedList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ReleasedList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedItem')))
    ____RAB_ReleasedList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 42), ('criticality', 'ignore'), ('Value', _____RAB_ReleasedList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ReleasedList__item___item__id._const_tab = ____RAB_ReleasedList__item___item__id_tab
    ___RAB_ReleasedList__item___item__id._const_tab_at = None
    ___RAB_ReleasedList__item___item__id._const_tab_id = 'id'
    ___RAB_ReleasedList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_ReleasedList__item___item__criticality._const_tab = ____RAB_ReleasedList__item___item__id_tab
    ___RAB_ReleasedList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ReleasedList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_ReleasedList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_ReleasedList__item___item__value._const_tab = ____RAB_ReleasedList__item___item__id_tab
    ___RAB_ReleasedList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_ReleasedList__item___item__value._const_tab_id = 'Value'
    __RAB_ReleasedList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_ReleasedList__item___item__id),
        ('criticality', ___RAB_ReleasedList__item___item__criticality),
        ('value', ___RAB_ReleasedList__item___item__value),
        ])
    __RAB_ReleasedList__item___item_._ext = None
    _RAB_ReleasedList__item_._cont = __RAB_ReleasedList__item___item_
    _RAB_ReleasedList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ReleasedList._cont = _RAB_ReleasedList__item_
    RAB_ReleasedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ReleasedItemIEs >-----#
    RAB_ReleasedItemIEs = CLASS(name='RAB-ReleasedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ReleasedItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleasedItem')))
    RAB_ReleasedItemIEs._val = ASN1Set(rv=[dict([('id', 42), ('criticality', 'ignore'), ('Value', _RAB_ReleasedItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleasedItem >-----#
    RAB_ReleasedItem = SEQ(name='RAB-ReleasedItem', mode=MODE_TYPE)
    _RAB_ReleasedItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ReleasedItem_dl_dataVolumes = SEQ_OF(name='dl-dataVolumes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeList')), opt=True)
    _RAB_ReleasedItem_dL_GTP_PDU_SequenceNumber = INT(name='dL-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ReleasedItem_uL_GTP_PDU_SequenceNumber = INT(name='uL-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ReleasedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ReleasedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ReleasedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_ReleasedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_iE_Extensions__item__id._const_tab = ____RAB_ReleasedItem_iE_Extensions__item__id_tab
    ___RAB_ReleasedItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ReleasedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_ReleasedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_ReleasedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_iE_Extensions__item__criticality._const_tab = ____RAB_ReleasedItem_iE_Extensions__item__criticality_tab
    ___RAB_ReleasedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ReleasedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_ReleasedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_ReleasedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ReleasedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ReleasedItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_ReleasedItem_iE_Extensions__item__extensionValue_tab
    ___RAB_ReleasedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_ReleasedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_ReleasedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_ReleasedItem_iE_Extensions__item__id),
        ('criticality', ___RAB_ReleasedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_ReleasedItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_ReleasedItem_iE_Extensions__item_._ext = None
    _RAB_ReleasedItem_iE_Extensions._cont = __RAB_ReleasedItem_iE_Extensions__item_
    _RAB_ReleasedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ReleasedItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_ReleasedItem_rAB_ID),
        ('dl-dataVolumes', _RAB_ReleasedItem_dl_dataVolumes),
        ('dL-GTP-PDU-SequenceNumber', _RAB_ReleasedItem_dL_GTP_PDU_SequenceNumber),
        ('uL-GTP-PDU-SequenceNumber', _RAB_ReleasedItem_uL_GTP_PDU_SequenceNumber),
        ('iE-Extensions', _RAB_ReleasedItem_iE_Extensions),
        ])
    RAB_ReleasedItem._ext = []
    
    #-----< RAB-ReleasedItem-ExtIEs >-----#
    RAB_ReleasedItem_ExtIEs = CLASS(name='RAB-ReleasedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ReleasedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DataVolumeList >-----#
    DataVolumeList = SEQ_OF(name='DataVolumeList', mode=MODE_TYPE)
    _DataVolumeList__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __DataVolumeList__item__dl_UnsuccessfullyTransmittedDataVolume = INT(name='dl-UnsuccessfullyTransmittedDataVolume', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UnsuccessfullyTransmittedDataVolume')))
    __DataVolumeList__item__dataVolumeReference = INT(name='dataVolumeReference', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataVolumeReference')), opt=True)
    __DataVolumeList__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___DataVolumeList__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____DataVolumeList__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____DataVolumeList__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DataVolumeList__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DataVolumeList__item__iE_Extensions__item__id._const_tab = _____DataVolumeList__item__iE_Extensions__item__id_tab
    ____DataVolumeList__item__iE_Extensions__item__id._const_tab_at = None
    ____DataVolumeList__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____DataVolumeList__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____DataVolumeList__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DataVolumeList__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DataVolumeList__item__iE_Extensions__item__criticality._const_tab = _____DataVolumeList__item__iE_Extensions__item__criticality_tab
    ____DataVolumeList__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____DataVolumeList__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____DataVolumeList__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____DataVolumeList__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DataVolumeList__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____DataVolumeList__item__iE_Extensions__item__extensionValue._const_tab = _____DataVolumeList__item__iE_Extensions__item__extensionValue_tab
    ____DataVolumeList__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____DataVolumeList__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___DataVolumeList__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____DataVolumeList__item__iE_Extensions__item__id),
        ('criticality', ____DataVolumeList__item__iE_Extensions__item__criticality),
        ('extensionValue', ____DataVolumeList__item__iE_Extensions__item__extensionValue),
        ])
    ___DataVolumeList__item__iE_Extensions__item_._ext = None
    __DataVolumeList__item__iE_Extensions._cont = ___DataVolumeList__item__iE_Extensions__item_
    __DataVolumeList__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _DataVolumeList__item_._cont = ASN1Dict([
        ('dl-UnsuccessfullyTransmittedDataVolume', __DataVolumeList__item__dl_UnsuccessfullyTransmittedDataVolume),
        ('dataVolumeReference', __DataVolumeList__item__dataVolumeReference),
        ('iE-Extensions', __DataVolumeList__item__iE_Extensions),
        ])
    _DataVolumeList__item_._ext = []
    DataVolumeList._cont = _DataVolumeList__item_
    DataVolumeList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2)], ev=None, er=[])
    
    #-----< DataVolumeList-ExtIEs >-----#
    DataVolumeList_ExtIEs = CLASS(name='DataVolumeList-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    DataVolumeList_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-QueuedList >-----#
    RAB_QueuedList = SEQ_OF(name='RAB-QueuedList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_QueuedList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_QueuedList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_QueuedList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_QueuedList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_QueuedList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-QueuedItem')))
    ____RAB_QueuedList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 37), ('criticality', 'ignore'), ('Value', _____RAB_QueuedList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_QueuedList__item___item__id._const_tab = ____RAB_QueuedList__item___item__id_tab
    ___RAB_QueuedList__item___item__id._const_tab_at = None
    ___RAB_QueuedList__item___item__id._const_tab_id = 'id'
    ___RAB_QueuedList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_QueuedList__item___item__criticality._const_tab = ____RAB_QueuedList__item___item__id_tab
    ___RAB_QueuedList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_QueuedList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_QueuedList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_QueuedList__item___item__value._const_tab = ____RAB_QueuedList__item___item__id_tab
    ___RAB_QueuedList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_QueuedList__item___item__value._const_tab_id = 'Value'
    __RAB_QueuedList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_QueuedList__item___item__id),
        ('criticality', ___RAB_QueuedList__item___item__criticality),
        ('value', ___RAB_QueuedList__item___item__value),
        ])
    __RAB_QueuedList__item___item_._ext = None
    _RAB_QueuedList__item_._cont = __RAB_QueuedList__item___item_
    _RAB_QueuedList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_QueuedList._cont = _RAB_QueuedList__item_
    RAB_QueuedList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-QueuedItemIEs >-----#
    RAB_QueuedItemIEs = CLASS(name='RAB-QueuedItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_QueuedItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-QueuedItem')))
    RAB_QueuedItemIEs._val = ASN1Set(rv=[dict([('id', 37), ('criticality', 'ignore'), ('Value', _RAB_QueuedItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-QueuedItem >-----#
    RAB_QueuedItem = SEQ(name='RAB-QueuedItem', mode=MODE_TYPE)
    _RAB_QueuedItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_QueuedItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_QueuedItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_QueuedItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_QueuedItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_QueuedItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_QueuedItem_iE_Extensions__item__id._const_tab = ____RAB_QueuedItem_iE_Extensions__item__id_tab
    ___RAB_QueuedItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_QueuedItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_QueuedItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_QueuedItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_QueuedItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_QueuedItem_iE_Extensions__item__criticality._const_tab = ____RAB_QueuedItem_iE_Extensions__item__criticality_tab
    ___RAB_QueuedItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_QueuedItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_QueuedItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_QueuedItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_QueuedItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_QueuedItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_QueuedItem_iE_Extensions__item__extensionValue_tab
    ___RAB_QueuedItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_QueuedItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_QueuedItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_QueuedItem_iE_Extensions__item__id),
        ('criticality', ___RAB_QueuedItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_QueuedItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_QueuedItem_iE_Extensions__item_._ext = None
    _RAB_QueuedItem_iE_Extensions._cont = __RAB_QueuedItem_iE_Extensions__item_
    _RAB_QueuedItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_QueuedItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_QueuedItem_rAB_ID),
        ('iE-Extensions', _RAB_QueuedItem_iE_Extensions),
        ])
    RAB_QueuedItem._ext = []
    
    #-----< RAB-QueuedItem-ExtIEs >-----#
    RAB_QueuedItem_ExtIEs = CLASS(name='RAB-QueuedItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_QueuedItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ReleaseFailedList >-----#
    RAB_ReleaseFailedList = SEQ_OF(name='RAB-ReleaseFailedList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList')))
    
    #-----< RAB-AssignmentResponseExtensions >-----#
    RAB_AssignmentResponseExtensions = CLASS(name='RAB-AssignmentResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_AssignmentResponseExtensions_val_Extension_0 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'GERAN-Iumode-RAB-FailedList-RABAssgntResponse')))
    RAB_AssignmentResponseExtensions._val = ASN1Set(rv=[dict([('id', 110), ('criticality', 'ignore'), ('Extension', _RAB_AssignmentResponseExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< GERAN-Iumode-RAB-FailedList-RABAssgntResponse >-----#
    GERAN_Iumode_RAB_FailedList_RABAssgntResponse = SEQ_OF(name='GERAN-Iumode-RAB-FailedList-RABAssgntResponse', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item')))
    ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 109), ('criticality', 'ignore'), ('Value', _____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id._const_tab = ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id._const_tab_at = None
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id._const_tab_id = 'id'
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality._const_tab = ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality._const_tab_at = ('..', 'id')
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality._const_tab_id = 'criticality'
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value._const_tab = ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value._const_tab_at = ('..', 'id')
    ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value._const_tab_id = 'Value'
    __GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item_._cont = ASN1Dict([
        ('id', ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id),
        ('criticality', ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality),
        ('value', ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value),
        ])
    __GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item_._ext = None
    _GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item_._cont = __GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item_
    _GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GERAN_Iumode_RAB_FailedList_RABAssgntResponse._cont = _GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item_
    GERAN_Iumode_RAB_FailedList_RABAssgntResponse._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< GERAN-Iumode-RAB-Failed-RABAssgntResponse-ItemIEs >-----#
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs = CLASS(name='GERAN-Iumode-RAB-Failed-RABAssgntResponse-ItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item')))
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs._val = ASN1Set(rv=[dict([('id', 109), ('criticality', 'ignore'), ('Value', _GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item >-----#
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item = SEQ(name='GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item', mode=MODE_TYPE)
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_gERAN_Classmark = OCT_STR(name='gERAN-Classmark', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GERAN-Classmark')), opt=True)
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id._const_tab = ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id_tab
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id._const_tab_at = None
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id._const_tab_id = 'id'
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality._const_tab = ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality_tab
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue._const_tab = ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue_tab
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id),
        ('criticality', ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality),
        ('extensionValue', ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue),
        ])
    __GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item_._ext = None
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions._cont = __GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item_
    _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item._cont = ASN1Dict([
        ('rAB-ID', _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_rAB_ID),
        ('cause', _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_cause),
        ('gERAN-Classmark', _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_gERAN_Classmark),
        ('iE-Extensions', _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions),
        ])
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item._ext = []
    
    #-----< GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item-ExtIEs >-----#
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_ExtIEs = CLASS(name='GERAN-Iumode-RAB-Failed-RABAssgntResponse-Item-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PrivateMessage >-----#
    PrivateMessage = SEQ(name='PrivateMessage', mode=MODE_TYPE)
    _PrivateMessage_privateIEs = SEQ_OF(name='privateIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'PrivateIE-Container')))
    __PrivateMessage_privateIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'PrivateIE-Field')))
    ___PrivateMessage_privateIEs__item__id = CHOICE(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PRIVATE-IES'), ['id']))
    ____PrivateMessage_privateIEs__item__id_tab = CLASS(name='_tab_RANAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__id._const_tab = ____PrivateMessage_privateIEs__item__id_tab
    ___PrivateMessage_privateIEs__item__id._const_tab_at = None
    ___PrivateMessage_privateIEs__item__id._const_tab_id = 'id'
    ___PrivateMessage_privateIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PRIVATE-IES'), ['criticality']))
    ____PrivateMessage_privateIEs__item__criticality_tab = CLASS(name='_tab_RANAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__criticality._const_tab = ____PrivateMessage_privateIEs__item__criticality_tab
    ___PrivateMessage_privateIEs__item__criticality._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__criticality._const_tab_id = 'criticality'
    ___PrivateMessage_privateIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PRIVATE-IES'), ['Value']))
    ____PrivateMessage_privateIEs__item__value_tab = CLASS(name='_tab_RANAP-PRIVATE-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PRIVATE-IES')))
    ____PrivateMessage_privateIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___PrivateMessage_privateIEs__item__value._const_tab = ____PrivateMessage_privateIEs__item__value_tab
    ___PrivateMessage_privateIEs__item__value._const_tab_at = ('..', 'id')
    ___PrivateMessage_privateIEs__item__value._const_tab_id = 'Value'
    __PrivateMessage_privateIEs__item_._cont = ASN1Dict([
        ('id', ___PrivateMessage_privateIEs__item__id),
        ('criticality', ___PrivateMessage_privateIEs__item__criticality),
        ('value', ___PrivateMessage_privateIEs__item__value),
        ])
    __PrivateMessage_privateIEs__item_._ext = None
    _PrivateMessage_privateIEs._cont = __PrivateMessage_privateIEs__item_
    _PrivateMessage_privateIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    PrivateMessage._cont = ASN1Dict([
        ('privateIEs', _PrivateMessage_privateIEs),
        ])
    PrivateMessage._ext = []
    
    #-----< PrivateMessage-IEs >-----#
    PrivateMessage_IEs = CLASS(name='PrivateMessage-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PRIVATE-IES')))
    PrivateMessage_IEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANAP-RelocationInformation >-----#
    RANAP_RelocationInformation = SEQ(name='RANAP-RelocationInformation', mode=MODE_TYPE)
    _RANAP_RelocationInformation_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RANAP_RelocationInformation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RANAP_RelocationInformation_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RANAP_RelocationInformation_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransferInformationList-RANAP-RelocInf')))
    _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList-RANAP-RelocInf')))
    ____RANAP_RelocationInformation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 81), ('criticality', 'ignore'), ('Value', _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RANAP_RelocationInformation_protocolIEs__item__id._const_tab = ____RANAP_RelocationInformation_protocolIEs__item__id_tab
    ___RANAP_RelocationInformation_protocolIEs__item__id._const_tab_at = None
    ___RANAP_RelocationInformation_protocolIEs__item__id._const_tab_id = 'id'
    ___RANAP_RelocationInformation_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RANAP_RelocationInformation_protocolIEs__item__criticality._const_tab = ____RANAP_RelocationInformation_protocolIEs__item__id_tab
    ___RANAP_RelocationInformation_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RANAP_RelocationInformation_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RANAP_RelocationInformation_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RANAP_RelocationInformation_protocolIEs__item__value._const_tab = ____RANAP_RelocationInformation_protocolIEs__item__id_tab
    ___RANAP_RelocationInformation_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RANAP_RelocationInformation_protocolIEs__item__value._const_tab_id = 'Value'
    __RANAP_RelocationInformation_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RANAP_RelocationInformation_protocolIEs__item__id),
        ('criticality', ___RANAP_RelocationInformation_protocolIEs__item__criticality),
        ('value', ___RANAP_RelocationInformation_protocolIEs__item__value),
        ])
    __RANAP_RelocationInformation_protocolIEs__item_._ext = None
    _RANAP_RelocationInformation_protocolIEs._cont = __RANAP_RelocationInformation_protocolIEs__item_
    _RANAP_RelocationInformation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RANAP_RelocationInformation_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RANAP_RelocationInformation_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RANAP_RelocationInformation_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RANAP_RelocationInformation_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RNSAPRelocationParameters')))
    ____RANAP_RelocationInformation_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 247), ('criticality', 'reject'), ('Extension', _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RANAP_RelocationInformation_protocolExtensions__item__id._const_tab = ____RANAP_RelocationInformation_protocolExtensions__item__id_tab
    ___RANAP_RelocationInformation_protocolExtensions__item__id._const_tab_at = None
    ___RANAP_RelocationInformation_protocolExtensions__item__id._const_tab_id = 'id'
    ___RANAP_RelocationInformation_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RANAP_RelocationInformation_protocolExtensions__item__criticality._const_tab = ____RANAP_RelocationInformation_protocolExtensions__item__id_tab
    ___RANAP_RelocationInformation_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RANAP_RelocationInformation_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue._const_tab = ____RANAP_RelocationInformation_protocolExtensions__item__id_tab
    ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RANAP_RelocationInformation_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RANAP_RelocationInformation_protocolExtensions__item__id),
        ('criticality', ___RANAP_RelocationInformation_protocolExtensions__item__criticality),
        ('extensionValue', ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue),
        ])
    __RANAP_RelocationInformation_protocolExtensions__item_._ext = None
    _RANAP_RelocationInformation_protocolExtensions._cont = __RANAP_RelocationInformation_protocolExtensions__item_
    _RANAP_RelocationInformation_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RANAP_RelocationInformation._cont = ASN1Dict([
        ('protocolIEs', _RANAP_RelocationInformation_protocolIEs),
        ('protocolExtensions', _RANAP_RelocationInformation_protocolExtensions),
        ])
    RANAP_RelocationInformation._ext = []
    
    #-----< RANAP-RelocationInformationIEs >-----#
    RANAP_RelocationInformationIEs = CLASS(name='RANAP-RelocationInformationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RANAP_RelocationInformationIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransferInformationList-RANAP-RelocInf')))
    _RANAP_RelocationInformationIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextList-RANAP-RelocInf')))
    RANAP_RelocationInformationIEs._val = ASN1Set(rv=[dict([('id', 81), ('criticality', 'ignore'), ('Value', _RANAP_RelocationInformationIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 83), ('criticality', 'ignore'), ('Value', _RANAP_RelocationInformationIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransferInformationList-RANAP-RelocInf >-----#
    DirectTransferInformationList_RANAP_RelocInf = SEQ_OF(name='DirectTransferInformationList-RANAP-RelocInf', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer-IE-ContainerList')))
    _DirectTransferInformationList_RANAP_RelocInf__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __DirectTransferInformationList_RANAP_RelocInf__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransferInformationItem-RANAP-RelocInf')))
    ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'ignore'), ('Value', _____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__id._const_tab = ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__id._const_tab_at = None
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__id._const_tab_id = 'id'
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality._const_tab = ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality._const_tab_at = ('..', 'id')
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality._const_tab_id = 'criticality'
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__value._const_tab = ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__value._const_tab_at = ('..', 'id')
    ___DirectTransferInformationList_RANAP_RelocInf__item___item__value._const_tab_id = 'Value'
    __DirectTransferInformationList_RANAP_RelocInf__item___item_._cont = ASN1Dict([
        ('id', ___DirectTransferInformationList_RANAP_RelocInf__item___item__id),
        ('criticality', ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality),
        ('value', ___DirectTransferInformationList_RANAP_RelocInf__item___item__value),
        ])
    __DirectTransferInformationList_RANAP_RelocInf__item___item_._ext = None
    _DirectTransferInformationList_RANAP_RelocInf__item_._cont = __DirectTransferInformationList_RANAP_RelocInf__item___item_
    _DirectTransferInformationList_RANAP_RelocInf__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    DirectTransferInformationList_RANAP_RelocInf._cont = _DirectTransferInformationList_RANAP_RelocInf__item_
    DirectTransferInformationList_RANAP_RelocInf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< DirectTransferInformationItemIEs-RANAP-RelocInf >-----#
    DirectTransferInformationItemIEs_RANAP_RelocInf = CLASS(name='DirectTransferInformationItemIEs-RANAP-RelocInf', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _DirectTransferInformationItemIEs_RANAP_RelocInf_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransferInformationItem-RANAP-RelocInf')))
    DirectTransferInformationItemIEs_RANAP_RelocInf._val = ASN1Set(rv=[dict([('id', 80), ('criticality', 'ignore'), ('Value', _DirectTransferInformationItemIEs_RANAP_RelocInf_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< DirectTransferInformationItem-RANAP-RelocInf >-----#
    DirectTransferInformationItem_RANAP_RelocInf = SEQ(name='DirectTransferInformationItem-RANAP-RelocInf', mode=MODE_TYPE)
    _DirectTransferInformationItem_RANAP_RelocInf_nAS_PDU = OCT_STR(name='nAS-PDU', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'NAS-PDU')))
    _DirectTransferInformationItem_RANAP_RelocInf_sAPI = ENUM(name='sAPI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'SAPI')))
    _DirectTransferInformationItem_RANAP_RelocInf_cN_DomainIndicator = ENUM(name='cN-DomainIndicator', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab = ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id_tab
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab_at = None
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab_id = 'id'
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab = ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab = ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id),
        ('criticality', ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality),
        ('extensionValue', ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue),
        ])
    __DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item_._ext = None
    _DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions._cont = __DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item_
    _DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DirectTransferInformationItem_RANAP_RelocInf._cont = ASN1Dict([
        ('nAS-PDU', _DirectTransferInformationItem_RANAP_RelocInf_nAS_PDU),
        ('sAPI', _DirectTransferInformationItem_RANAP_RelocInf_sAPI),
        ('cN-DomainIndicator', _DirectTransferInformationItem_RANAP_RelocInf_cN_DomainIndicator),
        ('iE-Extensions', _DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions),
        ])
    DirectTransferInformationItem_RANAP_RelocInf._ext = []
    
    #-----< RANAP-DirectTransferInformationItem-ExtIEs-RANAP-RelocInf >-----#
    RANAP_DirectTransferInformationItem_ExtIEs_RANAP_RelocInf = CLASS(name='RANAP-DirectTransferInformationItem-ExtIEs-RANAP-RelocInf', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RANAP_DirectTransferInformationItem_ExtIEs_RANAP_RelocInf._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ContextList-RANAP-RelocInf >-----#
    RAB_ContextList_RANAP_RelocInf = SEQ_OF(name='RAB-ContextList-RANAP-RelocInf', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ContextList_RANAP_RelocInf__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ContextList_RANAP_RelocInf__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ContextList_RANAP_RelocInf__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ContextList_RANAP_RelocInf__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextItem-RANAP-RelocInf')))
    ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 82), ('criticality', 'ignore'), ('Value', _____RAB_ContextList_RANAP_RelocInf__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ContextList_RANAP_RelocInf__item___item__id._const_tab = ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab
    ___RAB_ContextList_RANAP_RelocInf__item___item__id._const_tab_at = None
    ___RAB_ContextList_RANAP_RelocInf__item___item__id._const_tab_id = 'id'
    ___RAB_ContextList_RANAP_RelocInf__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_ContextList_RANAP_RelocInf__item___item__criticality._const_tab = ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab
    ___RAB_ContextList_RANAP_RelocInf__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ContextList_RANAP_RelocInf__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_ContextList_RANAP_RelocInf__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_ContextList_RANAP_RelocInf__item___item__value._const_tab = ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab
    ___RAB_ContextList_RANAP_RelocInf__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_ContextList_RANAP_RelocInf__item___item__value._const_tab_id = 'Value'
    __RAB_ContextList_RANAP_RelocInf__item___item_._cont = ASN1Dict([
        ('id', ___RAB_ContextList_RANAP_RelocInf__item___item__id),
        ('criticality', ___RAB_ContextList_RANAP_RelocInf__item___item__criticality),
        ('value', ___RAB_ContextList_RANAP_RelocInf__item___item__value),
        ])
    __RAB_ContextList_RANAP_RelocInf__item___item_._ext = None
    _RAB_ContextList_RANAP_RelocInf__item_._cont = __RAB_ContextList_RANAP_RelocInf__item___item_
    _RAB_ContextList_RANAP_RelocInf__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ContextList_RANAP_RelocInf._cont = _RAB_ContextList_RANAP_RelocInf__item_
    RAB_ContextList_RANAP_RelocInf._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ContextItemIEs-RANAP-RelocInf >-----#
    RAB_ContextItemIEs_RANAP_RelocInf = CLASS(name='RAB-ContextItemIEs-RANAP-RelocInf', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ContextItemIEs_RANAP_RelocInf_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ContextItem-RANAP-RelocInf')))
    RAB_ContextItemIEs_RANAP_RelocInf._val = ASN1Set(rv=[dict([('id', 82), ('criticality', 'ignore'), ('Value', _RAB_ContextItemIEs_RANAP_RelocInf_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ContextItem-RANAP-RelocInf >-----#
    RAB_ContextItem_RANAP_RelocInf = SEQ(name='RAB-ContextItem-RANAP-RelocInf', mode=MODE_TYPE)
    _RAB_ContextItem_RANAP_RelocInf_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ContextItem_RANAP_RelocInf_dl_GTP_PDU_SequenceNumber = INT(name='dl-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_RANAP_RelocInf_ul_GTP_PDU_SequenceNumber = INT(name='ul-GTP-PDU-SequenceNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-GTP-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_RANAP_RelocInf_dl_N_PDU_SequenceNumber = INT(name='dl-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DL-N-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_RANAP_RelocInf_ul_N_PDU_SequenceNumber = INT(name='ul-N-PDU-SequenceNumber', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'UL-N-PDU-SequenceNumber')), opt=True)
    _RAB_ContextItem_RANAP_RelocInf_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab = ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id_tab
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab = ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab = ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id),
        ('criticality', ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue),
        ])
    __RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item_._ext = None
    _RAB_ContextItem_RANAP_RelocInf_iE_Extensions._cont = __RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item_
    _RAB_ContextItem_RANAP_RelocInf_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ContextItem_RANAP_RelocInf._cont = ASN1Dict([
        ('rAB-ID', _RAB_ContextItem_RANAP_RelocInf_rAB_ID),
        ('dl-GTP-PDU-SequenceNumber', _RAB_ContextItem_RANAP_RelocInf_dl_GTP_PDU_SequenceNumber),
        ('ul-GTP-PDU-SequenceNumber', _RAB_ContextItem_RANAP_RelocInf_ul_GTP_PDU_SequenceNumber),
        ('dl-N-PDU-SequenceNumber', _RAB_ContextItem_RANAP_RelocInf_dl_N_PDU_SequenceNumber),
        ('ul-N-PDU-SequenceNumber', _RAB_ContextItem_RANAP_RelocInf_ul_N_PDU_SequenceNumber),
        ('iE-Extensions', _RAB_ContextItem_RANAP_RelocInf_iE_Extensions),
        ])
    RAB_ContextItem_RANAP_RelocInf._ext = []
    
    #-----< RAB-ContextItem-ExtIEs-RANAP-RelocInf >-----#
    RAB_ContextItem_ExtIEs_RANAP_RelocInf = CLASS(name='RAB-ContextItem-ExtIEs-RANAP-RelocInf', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ContextItem_ExtIEs_RANAP_RelocInf._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANAP-RelocationInformationExtensions >-----#
    RANAP_RelocationInformationExtensions = CLASS(name='RANAP-RelocationInformationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RANAP_RelocationInformationExtensions_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RRC-Container')))
    _RANAP_RelocationInformationExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RNSAPRelocationParameters')))
    RANAP_RelocationInformationExtensions._val = ASN1Set(rv=[dict([('id', 103), ('criticality', 'ignore'), ('Extension', _RANAP_RelocationInformationExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 247), ('criticality', 'reject'), ('Extension', _RANAP_RelocationInformationExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANAP-EnhancedRelocationInformationRequest >-----#
    RANAP_EnhancedRelocationInformationRequest = SEQ(name='RANAP-EnhancedRelocationInformationRequest', mode=MODE_TYPE)
    _RANAP_EnhancedRelocationInformationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RANAP_EnhancedRelocationInformationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceRNC-ToTargetRNC-TransparentContainer')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhRelocInfoReq')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CNMBMSLinkingInformation')))
    ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'reject'), ('Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 204), ('criticality', 'ignore'), ('Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'reject'), ('Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'reject'), ('Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_6), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_7), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'ignore'), ('Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id._const_tab_at = None
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RANAP_EnhancedRelocationInformationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id),
        ('criticality', ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality),
        ('value', ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value),
        ])
    __RANAP_EnhancedRelocationInformationRequest_protocolIEs__item_._ext = None
    _RANAP_EnhancedRelocationInformationRequest_protocolIEs._cont = __RANAP_EnhancedRelocationInformationRequest_protocolIEs__item_
    _RANAP_EnhancedRelocationInformationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RANAP_EnhancedRelocationInformationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RABParametersList')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 12), ('criticality', 'ignore'), ('Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'ignore'), ('Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 233), ('criticality', 'ignore'), ('Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'reject'), ('Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'reject'), ('Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_4), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'reject'), ('Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_5), ('presence', 'optional')]), dict([('id', 261), ('criticality', 'ignore'), ('Extension', _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_6), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id._const_tab_at = None
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue._const_tab = ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id),
        ('criticality', ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue),
        ])
    __RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item_._ext = None
    _RANAP_EnhancedRelocationInformationRequest_protocolExtensions._cont = __RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item_
    _RANAP_EnhancedRelocationInformationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RANAP_EnhancedRelocationInformationRequest._cont = ASN1Dict([
        ('protocolIEs', _RANAP_EnhancedRelocationInformationRequest_protocolIEs),
        ('protocolExtensions', _RANAP_EnhancedRelocationInformationRequest_protocolExtensions),
        ])
    RANAP_EnhancedRelocationInformationRequest._ext = []
    
    #-----< RANAP-EnhancedRelocationInformationRequestIEs >-----#
    RANAP_EnhancedRelocationInformationRequestIEs = CLASS(name='RANAP-EnhancedRelocationInformationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SourceRNC-ToTargetRNC-TransparentContainer')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhRelocInfoReq')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SNA-Access-Information')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_8 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CNMBMSLinkingInformation')))
    RANAP_EnhancedRelocationInformationRequestIEs._val = ASN1Set(rv=[dict([('id', 61), ('criticality', 'reject'), ('Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 204), ('criticality', 'ignore'), ('Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 206), ('criticality', 'reject'), ('Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 205), ('criticality', 'ignore'), ('Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 207), ('criticality', 'reject'), ('Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_4), ('presence', 'optional')]), dict([('id', 192), ('criticality', 'reject'), ('Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 105), ('criticality', 'ignore'), ('Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_6), ('presence', 'optional')]), dict([('id', 118), ('criticality', 'ignore'), ('Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_7), ('presence', 'optional')]), dict([('id', 127), ('criticality', 'ignore'), ('Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 133), ('criticality', 'ignore'), ('Value', _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_9), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-EnhRelocInfoReq >-----#
    RAB_SetupList_EnhRelocInfoReq = SEQ_OF(name='RAB-SetupList-EnhRelocInfoReq', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_EnhRelocInfoReq__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_EnhRelocInfoReq__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_EnhRelocInfoReq__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhRelocInfoReq')))
    ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 193), ('criticality', 'reject'), ('Value', _____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_EnhRelocInfoReq__item___item__id._const_tab = ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoReq__item___item__id._const_tab_at = None
    ___RAB_SetupList_EnhRelocInfoReq__item___item__id._const_tab_id = 'id'
    ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality._const_tab = ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupList_EnhRelocInfoReq__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_SetupList_EnhRelocInfoReq__item___item__value._const_tab = ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoReq__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_SetupList_EnhRelocInfoReq__item___item__value._const_tab_id = 'Value'
    __RAB_SetupList_EnhRelocInfoReq__item___item_._cont = ASN1Dict([
        ('id', ___RAB_SetupList_EnhRelocInfoReq__item___item__id),
        ('criticality', ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality),
        ('value', ___RAB_SetupList_EnhRelocInfoReq__item___item__value),
        ])
    __RAB_SetupList_EnhRelocInfoReq__item___item_._ext = None
    _RAB_SetupList_EnhRelocInfoReq__item_._cont = __RAB_SetupList_EnhRelocInfoReq__item___item_
    _RAB_SetupList_EnhRelocInfoReq__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_EnhRelocInfoReq._cont = _RAB_SetupList_EnhRelocInfoReq__item_
    RAB_SetupList_EnhRelocInfoReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-EnhRelocInfoReq-IEs >-----#
    RAB_SetupItem_EnhRelocInfoReq_IEs = CLASS(name='RAB-SetupItem-EnhRelocInfoReq-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_EnhRelocInfoReq_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhRelocInfoReq')))
    RAB_SetupItem_EnhRelocInfoReq_IEs._val = ASN1Set(rv=[dict([('id', 193), ('criticality', 'reject'), ('Value', _RAB_SetupItem_EnhRelocInfoReq_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-EnhRelocInfoReq >-----#
    RAB_SetupItem_EnhRelocInfoReq = SEQ(name='RAB-SetupItem-EnhRelocInfoReq', mode=MODE_TYPE)
    _RAB_SetupItem_EnhRelocInfoReq_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_EnhRelocInfoReq_cN_DomainIndicator = ENUM(name='cN-DomainIndicator', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _RAB_SetupItem_EnhRelocInfoReq_rAB_Parameters = SEQ(name='rAB-Parameters', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _RAB_SetupItem_EnhRelocInfoReq_dataVolumeReportingIndication = ENUM(name='dataVolumeReportingIndication', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'DataVolumeReportingIndication')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_pDP_TypeInformation = SEQ_OF(name='pDP-TypeInformation', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_userPlaneInformation = SEQ(name='userPlaneInformation', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'UserPlaneInformation')))
    _RAB_SetupItem_EnhRelocInfoReq_dataForwardingInformation = SEQ(name='dataForwardingInformation', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'TNLInformationEnhRelInfoReq')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_sourceSideIuULTNLInfo = SEQ(name='sourceSideIuULTNLInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'TNLInformationEnhRelInfoReq')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_service_Handover = ENUM(name='service-Handover', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Service-Handover')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_alt_RAB_Parameters = SEQ(name='alt-RAB-Parameters', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Alt-RAB-Parameters')), opt=True)
    _RAB_SetupItem_EnhRelocInfoReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 231), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Extension', _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id),
        ('criticality', ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item_._ext = None
    _RAB_SetupItem_EnhRelocInfoReq_iE_Extensions._cont = __RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item_
    _RAB_SetupItem_EnhRelocInfoReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_EnhRelocInfoReq._cont = ASN1Dict([
        ('rAB-ID', _RAB_SetupItem_EnhRelocInfoReq_rAB_ID),
        ('cN-DomainIndicator', _RAB_SetupItem_EnhRelocInfoReq_cN_DomainIndicator),
        ('rAB-Parameters', _RAB_SetupItem_EnhRelocInfoReq_rAB_Parameters),
        ('dataVolumeReportingIndication', _RAB_SetupItem_EnhRelocInfoReq_dataVolumeReportingIndication),
        ('pDP-TypeInformation', _RAB_SetupItem_EnhRelocInfoReq_pDP_TypeInformation),
        ('userPlaneInformation', _RAB_SetupItem_EnhRelocInfoReq_userPlaneInformation),
        ('dataForwardingInformation', _RAB_SetupItem_EnhRelocInfoReq_dataForwardingInformation),
        ('sourceSideIuULTNLInfo', _RAB_SetupItem_EnhRelocInfoReq_sourceSideIuULTNLInfo),
        ('service-Handover', _RAB_SetupItem_EnhRelocInfoReq_service_Handover),
        ('alt-RAB-Parameters', _RAB_SetupItem_EnhRelocInfoReq_alt_RAB_Parameters),
        ('iE-Extensions', _RAB_SetupItem_EnhRelocInfoReq_iE_Extensions),
        ])
    RAB_SetupItem_EnhRelocInfoReq._ext = []
    
    #-----< RAB-SetupItem-EnhRelocInfoReq-ExtIEs >-----#
    RAB_SetupItem_EnhRelocInfoReq_ExtIEs = CLASS(name='RAB-SetupItem-EnhRelocInfoReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'E-UTRAN-Service-Handover')))
    _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_1 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    RAB_SetupItem_EnhRelocInfoReq_ExtIEs._val = ASN1Set(rv=[dict([('id', 231), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_0), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Extension', _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< TNLInformationEnhRelInfoReq >-----#
    TNLInformationEnhRelInfoReq = SEQ(name='TNLInformationEnhRelInfoReq', mode=MODE_TYPE)
    _TNLInformationEnhRelInfoReq_transportLayerAddress = BIT_STR(name='transportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _TNLInformationEnhRelInfoReq_iuTransportAssociation = CHOICE(name='iuTransportAssociation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    _TNLInformationEnhRelInfoReq_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLInformationEnhRelInfoReq_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id._const_tab = ____TNLInformationEnhRelInfoReq_iE_Extensions__item__id_tab
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id._const_tab_at = None
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality._const_tab = ____TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality_tab
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue._const_tab = ____TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue_tab
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLInformationEnhRelInfoReq_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id),
        ('criticality', ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue),
        ])
    __TNLInformationEnhRelInfoReq_iE_Extensions__item_._ext = None
    _TNLInformationEnhRelInfoReq_iE_Extensions._cont = __TNLInformationEnhRelInfoReq_iE_Extensions__item_
    _TNLInformationEnhRelInfoReq_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLInformationEnhRelInfoReq._cont = ASN1Dict([
        ('transportLayerAddress', _TNLInformationEnhRelInfoReq_transportLayerAddress),
        ('iuTransportAssociation', _TNLInformationEnhRelInfoReq_iuTransportAssociation),
        ('iE-Extensions', _TNLInformationEnhRelInfoReq_iE_Extensions),
        ])
    TNLInformationEnhRelInfoReq._ext = []
    
    #-----< TNLInformationEnhRelInfoReq-ExtIEs >-----#
    TNLInformationEnhRelInfoReq_ExtIEs = CLASS(name='TNLInformationEnhRelInfoReq-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TNLInformationEnhRelInfoReq_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANAP-EnhancedRelocationInformationRequestExtensions >-----#
    RANAP_EnhancedRelocationInformationRequestExtensions = CLASS(name='RANAP-EnhancedRelocationInformationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionInformation')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionInformation')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_2 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-AggregateMaximumBitRate')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_3 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RABParametersList')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_4 = BIT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Id')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_5 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CSG-Membership-Status')))
    _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_6 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PLMNidentity')))
    RANAP_EnhancedRelocationInformationRequestExtensions._val = ASN1Set(rv=[dict([('id', 12), ('criticality', 'ignore'), ('Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 11), ('criticality', 'ignore'), ('Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 233), ('criticality', 'ignore'), ('Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 248), ('criticality', 'reject'), ('Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_3), ('presence', 'optional')]), dict([('id', 203), ('criticality', 'reject'), ('Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_4), ('presence', 'optional')]), dict([('id', 234), ('criticality', 'reject'), ('Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_5), ('presence', 'optional')]), dict([('id', 261), ('criticality', 'ignore'), ('Extension', _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_6), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RANAP-EnhancedRelocationInformationResponse >-----#
    RANAP_EnhancedRelocationInformationResponse = SEQ(name='RANAP-EnhancedRelocationInformationResponse', mode=MODE_TYPE)
    _RANAP_EnhancedRelocationInformationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RANAP_EnhancedRelocationInformationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ToSourceRNC-TransparentContainer')))
    _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhRelocInfoRes')))
    _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList-EnhRelocInfoRes')))
    _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 63), ('criticality', 'ignore'), ('Value', _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Value', _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 197), ('criticality', 'ignore'), ('Value', _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id._const_tab_at = None
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __RANAP_EnhancedRelocationInformationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id),
        ('criticality', ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality),
        ('value', ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value),
        ])
    __RANAP_EnhancedRelocationInformationResponse_protocolIEs__item_._ext = None
    _RANAP_EnhancedRelocationInformationResponse_protocolIEs._cont = __RANAP_EnhancedRelocationInformationResponse_protocolIEs__item_
    _RANAP_EnhancedRelocationInformationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RANAP_EnhancedRelocationInformationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id._const_tab_at = None
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue._const_tab = ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue_tab
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id),
        ('criticality', ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue),
        ])
    __RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item_._ext = None
    _RANAP_EnhancedRelocationInformationResponse_protocolExtensions._cont = __RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item_
    _RANAP_EnhancedRelocationInformationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RANAP_EnhancedRelocationInformationResponse._cont = ASN1Dict([
        ('protocolIEs', _RANAP_EnhancedRelocationInformationResponse_protocolIEs),
        ('protocolExtensions', _RANAP_EnhancedRelocationInformationResponse_protocolExtensions),
        ])
    RANAP_EnhancedRelocationInformationResponse._ext = []
    
    #-----< RANAP-EnhancedRelocationInformationResponseIEs >-----#
    RANAP_EnhancedRelocationInformationResponseIEs = CLASS(name='RANAP-EnhancedRelocationInformationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TargetRNC-ToSourceRNC-TransparentContainer')))
    _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupList-EnhRelocInfoRes')))
    _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_2 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedList-EnhRelocInfoRes')))
    _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    RANAP_EnhancedRelocationInformationResponseIEs._val = ASN1Set(rv=[dict([('id', 63), ('criticality', 'ignore'), ('Value', _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 194), ('criticality', 'ignore'), ('Value', _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 197), ('criticality', 'ignore'), ('Value', _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupList-EnhRelocInfoRes >-----#
    RAB_SetupList_EnhRelocInfoRes = SEQ_OF(name='RAB-SetupList-EnhRelocInfoRes', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_SetupList_EnhRelocInfoRes__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_SetupList_EnhRelocInfoRes__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_SetupList_EnhRelocInfoRes__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhRelocInfoRes')))
    ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 195), ('criticality', 'reject'), ('Value', _____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_SetupList_EnhRelocInfoRes__item___item__id._const_tab = ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoRes__item___item__id._const_tab_at = None
    ___RAB_SetupList_EnhRelocInfoRes__item___item__id._const_tab_id = 'id'
    ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality._const_tab = ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupList_EnhRelocInfoRes__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_SetupList_EnhRelocInfoRes__item___item__value._const_tab = ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_SetupList_EnhRelocInfoRes__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_SetupList_EnhRelocInfoRes__item___item__value._const_tab_id = 'Value'
    __RAB_SetupList_EnhRelocInfoRes__item___item_._cont = ASN1Dict([
        ('id', ___RAB_SetupList_EnhRelocInfoRes__item___item__id),
        ('criticality', ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality),
        ('value', ___RAB_SetupList_EnhRelocInfoRes__item___item__value),
        ])
    __RAB_SetupList_EnhRelocInfoRes__item___item_._ext = None
    _RAB_SetupList_EnhRelocInfoRes__item_._cont = __RAB_SetupList_EnhRelocInfoRes__item___item_
    _RAB_SetupList_EnhRelocInfoRes__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_SetupList_EnhRelocInfoRes._cont = _RAB_SetupList_EnhRelocInfoRes__item_
    RAB_SetupList_EnhRelocInfoRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-SetupItem-EnhRelocInfoRes-IEs >-----#
    RAB_SetupItem_EnhRelocInfoRes_IEs = CLASS(name='RAB-SetupItem-EnhRelocInfoRes-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_SetupItem_EnhRelocInfoRes_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-SetupItem-EnhRelocInfoRes')))
    RAB_SetupItem_EnhRelocInfoRes_IEs._val = ASN1Set(rv=[dict([('id', 195), ('criticality', 'reject'), ('Value', _RAB_SetupItem_EnhRelocInfoRes_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-SetupItem-EnhRelocInfoRes >-----#
    RAB_SetupItem_EnhRelocInfoRes = SEQ(name='RAB-SetupItem-EnhRelocInfoRes', mode=MODE_TYPE)
    _RAB_SetupItem_EnhRelocInfoRes_cN_DomainIndicator = ENUM(name='cN-DomainIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _RAB_SetupItem_EnhRelocInfoRes_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_SetupItem_EnhRelocInfoRes_dataForwardingInformation = SEQ(name='dataForwardingInformation', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Contents', 'TNLInformationEnhRelInfoRes')), opt=True)
    _RAB_SetupItem_EnhRelocInfoRes_ass_RAB_Parameters = SEQ(name='ass-RAB-Parameters', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Ass-RAB-Parameters')), opt=True)
    _RAB_SetupItem_EnhRelocInfoRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab = ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id_tab
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab_at = None
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab = ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab = ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id),
        ('criticality', ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue),
        ])
    __RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item_._ext = None
    _RAB_SetupItem_EnhRelocInfoRes_iE_Extensions._cont = __RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item_
    _RAB_SetupItem_EnhRelocInfoRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_SetupItem_EnhRelocInfoRes._cont = ASN1Dict([
        ('cN-DomainIndicator', _RAB_SetupItem_EnhRelocInfoRes_cN_DomainIndicator),
        ('rAB-ID', _RAB_SetupItem_EnhRelocInfoRes_rAB_ID),
        ('dataForwardingInformation', _RAB_SetupItem_EnhRelocInfoRes_dataForwardingInformation),
        ('ass-RAB-Parameters', _RAB_SetupItem_EnhRelocInfoRes_ass_RAB_Parameters),
        ('iE-Extensions', _RAB_SetupItem_EnhRelocInfoRes_iE_Extensions),
        ])
    RAB_SetupItem_EnhRelocInfoRes._ext = []
    
    #-----< RAB-SetupItem-EnhRelocInfoRes-ExtIEs >-----#
    RAB_SetupItem_EnhRelocInfoRes_ExtIEs = CLASS(name='RAB-SetupItem-EnhRelocInfoRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_SetupItem_EnhRelocInfoRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-FailedList-EnhRelocInfoRes >-----#
    RAB_FailedList_EnhRelocInfoRes = SEQ_OF(name='RAB-FailedList-EnhRelocInfoRes', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_FailedList_EnhRelocInfoRes__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_FailedList_EnhRelocInfoRes__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_FailedList_EnhRelocInfoRes__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedItem-EnhRelocInfoRes')))
    ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 198), ('criticality', 'reject'), ('Value', _____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_FailedList_EnhRelocInfoRes__item___item__id._const_tab = ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_FailedList_EnhRelocInfoRes__item___item__id._const_tab_at = None
    ___RAB_FailedList_EnhRelocInfoRes__item___item__id._const_tab_id = 'id'
    ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality._const_tab = ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_FailedList_EnhRelocInfoRes__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_FailedList_EnhRelocInfoRes__item___item__value._const_tab = ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab
    ___RAB_FailedList_EnhRelocInfoRes__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_FailedList_EnhRelocInfoRes__item___item__value._const_tab_id = 'Value'
    __RAB_FailedList_EnhRelocInfoRes__item___item_._cont = ASN1Dict([
        ('id', ___RAB_FailedList_EnhRelocInfoRes__item___item__id),
        ('criticality', ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality),
        ('value', ___RAB_FailedList_EnhRelocInfoRes__item___item__value),
        ])
    __RAB_FailedList_EnhRelocInfoRes__item___item_._ext = None
    _RAB_FailedList_EnhRelocInfoRes__item_._cont = __RAB_FailedList_EnhRelocInfoRes__item___item_
    _RAB_FailedList_EnhRelocInfoRes__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_FailedList_EnhRelocInfoRes._cont = _RAB_FailedList_EnhRelocInfoRes__item_
    RAB_FailedList_EnhRelocInfoRes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-FailedItem-EnhRelocInfoRes-IEs >-----#
    RAB_FailedItem_EnhRelocInfoRes_IEs = CLASS(name='RAB-FailedItem-EnhRelocInfoRes-IEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_FailedItem_EnhRelocInfoRes_IEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-FailedItem-EnhRelocInfoRes')))
    RAB_FailedItem_EnhRelocInfoRes_IEs._val = ASN1Set(rv=[dict([('id', 198), ('criticality', 'reject'), ('Value', _RAB_FailedItem_EnhRelocInfoRes_IEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-FailedItem-EnhRelocInfoRes >-----#
    RAB_FailedItem_EnhRelocInfoRes = SEQ(name='RAB-FailedItem-EnhRelocInfoRes', mode=MODE_TYPE)
    _RAB_FailedItem_EnhRelocInfoRes_cN_DomainIndicator = ENUM(name='cN-DomainIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _RAB_FailedItem_EnhRelocInfoRes_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_FailedItem_EnhRelocInfoRes_cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _RAB_FailedItem_EnhRelocInfoRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab = ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id_tab
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab_at = None
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab = ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab = ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id),
        ('criticality', ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue),
        ])
    __RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item_._ext = None
    _RAB_FailedItem_EnhRelocInfoRes_iE_Extensions._cont = __RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item_
    _RAB_FailedItem_EnhRelocInfoRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_FailedItem_EnhRelocInfoRes._cont = ASN1Dict([
        ('cN-DomainIndicator', _RAB_FailedItem_EnhRelocInfoRes_cN_DomainIndicator),
        ('rAB-ID', _RAB_FailedItem_EnhRelocInfoRes_rAB_ID),
        ('cause', _RAB_FailedItem_EnhRelocInfoRes_cause),
        ('iE-Extensions', _RAB_FailedItem_EnhRelocInfoRes_iE_Extensions),
        ])
    RAB_FailedItem_EnhRelocInfoRes._ext = []
    
    #-----< RAB-FailedItem-EnhRelocInfoRes-ExtIEs >-----#
    RAB_FailedItem_EnhRelocInfoRes_ExtIEs = CLASS(name='RAB-FailedItem-EnhRelocInfoRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_FailedItem_EnhRelocInfoRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TNLInformationEnhRelInfoRes >-----#
    TNLInformationEnhRelInfoRes = SEQ(name='TNLInformationEnhRelInfoRes', mode=MODE_TYPE)
    _TNLInformationEnhRelInfoRes_dl_forwardingTransportLayerAddress = BIT_STR(name='dl-forwardingTransportLayerAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TransportLayerAddress')))
    _TNLInformationEnhRelInfoRes_dl_forwardingTransportAssociation = CHOICE(name='dl-forwardingTransportAssociation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IuTransportAssociation')))
    _TNLInformationEnhRelInfoRes_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __TNLInformationEnhRelInfoRes_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id._const_tab = ____TNLInformationEnhRelInfoRes_iE_Extensions__item__id_tab
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id._const_tab_at = None
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id._const_tab_id = 'id'
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality._const_tab = ____TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality_tab
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue._const_tab = ____TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue_tab
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __TNLInformationEnhRelInfoRes_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id),
        ('criticality', ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality),
        ('extensionValue', ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue),
        ])
    __TNLInformationEnhRelInfoRes_iE_Extensions__item_._ext = None
    _TNLInformationEnhRelInfoRes_iE_Extensions._cont = __TNLInformationEnhRelInfoRes_iE_Extensions__item_
    _TNLInformationEnhRelInfoRes_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    TNLInformationEnhRelInfoRes._cont = ASN1Dict([
        ('dl-forwardingTransportLayerAddress', _TNLInformationEnhRelInfoRes_dl_forwardingTransportLayerAddress),
        ('dl-forwardingTransportAssociation', _TNLInformationEnhRelInfoRes_dl_forwardingTransportAssociation),
        ('iE-Extensions', _TNLInformationEnhRelInfoRes_iE_Extensions),
        ])
    TNLInformationEnhRelInfoRes._ext = []
    
    #-----< TNLInformationEnhRelInfoRes-ExtIEs >-----#
    TNLInformationEnhRelInfoRes_ExtIEs = CLASS(name='TNLInformationEnhRelInfoRes-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    TNLInformationEnhRelInfoRes_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RANAP-EnhancedRelocationInformationResponseExtensions >-----#
    RANAP_EnhancedRelocationInformationResponseExtensions = CLASS(name='RANAP-EnhancedRelocationInformationResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RANAP_EnhancedRelocationInformationResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ModifyRequest >-----#
    RAB_ModifyRequest = SEQ(name='RAB-ModifyRequest', mode=MODE_TYPE)
    _RAB_ModifyRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ModifyRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ModifyRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_ModifyRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ModifyRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyList')))
    ____RAB_ModifyRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 91), ('criticality', 'ignore'), ('Value', _____RAB_ModifyRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ModifyRequest_protocolIEs__item__id._const_tab = ____RAB_ModifyRequest_protocolIEs__item__id_tab
    ___RAB_ModifyRequest_protocolIEs__item__id._const_tab_at = None
    ___RAB_ModifyRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RAB_ModifyRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_ModifyRequest_protocolIEs__item__criticality._const_tab = ____RAB_ModifyRequest_protocolIEs__item__id_tab
    ___RAB_ModifyRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ModifyRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RAB_ModifyRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_ModifyRequest_protocolIEs__item__value._const_tab = ____RAB_ModifyRequest_protocolIEs__item__id_tab
    ___RAB_ModifyRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RAB_ModifyRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RAB_ModifyRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RAB_ModifyRequest_protocolIEs__item__id),
        ('criticality', ___RAB_ModifyRequest_protocolIEs__item__criticality),
        ('value', ___RAB_ModifyRequest_protocolIEs__item__value),
        ])
    __RAB_ModifyRequest_protocolIEs__item_._ext = None
    _RAB_ModifyRequest_protocolIEs._cont = __RAB_ModifyRequest_protocolIEs__item_
    _RAB_ModifyRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RAB_ModifyRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ModifyRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ModifyRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_ModifyRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyRequest_protocolExtensions__item__id._const_tab = ____RAB_ModifyRequest_protocolExtensions__item__id_tab
    ___RAB_ModifyRequest_protocolExtensions__item__id._const_tab_at = None
    ___RAB_ModifyRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___RAB_ModifyRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_ModifyRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyRequest_protocolExtensions__item__criticality._const_tab = ____RAB_ModifyRequest_protocolExtensions__item__criticality_tab
    ___RAB_ModifyRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ModifyRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_ModifyRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_ModifyRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyRequest_protocolExtensions__item__extensionValue._const_tab = ____RAB_ModifyRequest_protocolExtensions__item__extensionValue_tab
    ___RAB_ModifyRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_ModifyRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_ModifyRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RAB_ModifyRequest_protocolExtensions__item__id),
        ('criticality', ___RAB_ModifyRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___RAB_ModifyRequest_protocolExtensions__item__extensionValue),
        ])
    __RAB_ModifyRequest_protocolExtensions__item_._ext = None
    _RAB_ModifyRequest_protocolExtensions._cont = __RAB_ModifyRequest_protocolExtensions__item_
    _RAB_ModifyRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ModifyRequest._cont = ASN1Dict([
        ('protocolIEs', _RAB_ModifyRequest_protocolIEs),
        ('protocolExtensions', _RAB_ModifyRequest_protocolExtensions),
        ])
    RAB_ModifyRequest._ext = []
    
    #-----< RAB-ModifyRequestIEs >-----#
    RAB_ModifyRequestIEs = CLASS(name='RAB-ModifyRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ModifyRequestIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyList')))
    RAB_ModifyRequestIEs._val = ASN1Set(rv=[dict([('id', 91), ('criticality', 'ignore'), ('Value', _RAB_ModifyRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ModifyList >-----#
    RAB_ModifyList = SEQ_OF(name='RAB-ModifyList', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-IE-ContainerList')))
    _RAB_ModifyList__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RAB_ModifyList__item___item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RAB_ModifyList__item___item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RAB_ModifyList__item___item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RAB_ModifyList__item___item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyItem')))
    ____RAB_ModifyList__item___item__id_tab._val = ASN1Set(rv=[dict([('id', 92), ('criticality', 'ignore'), ('Value', _____RAB_ModifyList__item___item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___RAB_ModifyList__item___item__id._const_tab = ____RAB_ModifyList__item___item__id_tab
    ___RAB_ModifyList__item___item__id._const_tab_at = None
    ___RAB_ModifyList__item___item__id._const_tab_id = 'id'
    ___RAB_ModifyList__item___item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RAB_ModifyList__item___item__criticality._const_tab = ____RAB_ModifyList__item___item__id_tab
    ___RAB_ModifyList__item___item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ModifyList__item___item__criticality._const_tab_id = 'criticality'
    ___RAB_ModifyList__item___item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RAB_ModifyList__item___item__value._const_tab = ____RAB_ModifyList__item___item__id_tab
    ___RAB_ModifyList__item___item__value._const_tab_at = ('..', 'id')
    ___RAB_ModifyList__item___item__value._const_tab_id = 'Value'
    __RAB_ModifyList__item___item_._cont = ASN1Dict([
        ('id', ___RAB_ModifyList__item___item__id),
        ('criticality', ___RAB_ModifyList__item___item__criticality),
        ('value', ___RAB_ModifyList__item___item__value),
        ])
    __RAB_ModifyList__item___item_._ext = None
    _RAB_ModifyList__item_._cont = __RAB_ModifyList__item___item_
    _RAB_ModifyList__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    RAB_ModifyList._cont = _RAB_ModifyList__item_
    RAB_ModifyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< RAB-ModifyItemIEs >-----#
    RAB_ModifyItemIEs = CLASS(name='RAB-ModifyItemIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RAB_ModifyItemIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyItem')))
    RAB_ModifyItemIEs._val = ASN1Set(rv=[dict([('id', 92), ('criticality', 'ignore'), ('Value', _RAB_ModifyItemIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< RAB-ModifyItem >-----#
    RAB_ModifyItem = SEQ(name='RAB-ModifyItem', mode=MODE_TYPE)
    _RAB_ModifyItem_rAB_ID = BIT_STR(name='rAB-ID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'RAB-ID')))
    _RAB_ModifyItem_requested_RAB_Parameter_Values = SEQ(name='requested-RAB-Parameter-Values', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Requested-RAB-Parameter-Values')))
    _RAB_ModifyItem_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RAB_ModifyItem_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RAB_ModifyItem_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RAB_ModifyItem_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyItem_iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyItem_iE_Extensions__item__id._const_tab = ____RAB_ModifyItem_iE_Extensions__item__id_tab
    ___RAB_ModifyItem_iE_Extensions__item__id._const_tab_at = None
    ___RAB_ModifyItem_iE_Extensions__item__id._const_tab_id = 'id'
    ___RAB_ModifyItem_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RAB_ModifyItem_iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyItem_iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyItem_iE_Extensions__item__criticality._const_tab = ____RAB_ModifyItem_iE_Extensions__item__criticality_tab
    ___RAB_ModifyItem_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___RAB_ModifyItem_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___RAB_ModifyItem_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RAB_ModifyItem_iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RAB_ModifyItem_iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RAB_ModifyItem_iE_Extensions__item__extensionValue._const_tab = ____RAB_ModifyItem_iE_Extensions__item__extensionValue_tab
    ___RAB_ModifyItem_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RAB_ModifyItem_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __RAB_ModifyItem_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___RAB_ModifyItem_iE_Extensions__item__id),
        ('criticality', ___RAB_ModifyItem_iE_Extensions__item__criticality),
        ('extensionValue', ___RAB_ModifyItem_iE_Extensions__item__extensionValue),
        ])
    __RAB_ModifyItem_iE_Extensions__item_._ext = None
    _RAB_ModifyItem_iE_Extensions._cont = __RAB_ModifyItem_iE_Extensions__item_
    _RAB_ModifyItem_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RAB_ModifyItem._cont = ASN1Dict([
        ('rAB-ID', _RAB_ModifyItem_rAB_ID),
        ('requested-RAB-Parameter-Values', _RAB_ModifyItem_requested_RAB_Parameter_Values),
        ('iE-Extensions', _RAB_ModifyItem_iE_Extensions),
        ])
    RAB_ModifyItem._ext = []
    
    #-----< RAB-ModifyItem-ExtIEs >-----#
    RAB_ModifyItem_ExtIEs = CLASS(name='RAB-ModifyItem-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ModifyItem_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RAB-ModifyRequestExtensions >-----#
    RAB_ModifyRequestExtensions = CLASS(name='RAB-ModifyRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RAB_ModifyRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataRequest >-----#
    LocationRelatedDataRequest = SEQ(name='LocationRelatedDataRequest', mode=MODE_TYPE)
    _LocationRelatedDataRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __LocationRelatedDataRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___LocationRelatedDataRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____LocationRelatedDataRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____LocationRelatedDataRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LocationRelatedDataRequestType')))
    ____LocationRelatedDataRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 95), ('criticality', 'reject'), ('Value', _____LocationRelatedDataRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataRequest_protocolIEs__item__id._const_tab = ____LocationRelatedDataRequest_protocolIEs__item__id_tab
    ___LocationRelatedDataRequest_protocolIEs__item__id._const_tab_at = None
    ___LocationRelatedDataRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationRelatedDataRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___LocationRelatedDataRequest_protocolIEs__item__criticality._const_tab = ____LocationRelatedDataRequest_protocolIEs__item__id_tab
    ___LocationRelatedDataRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationRelatedDataRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationRelatedDataRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___LocationRelatedDataRequest_protocolIEs__item__value._const_tab = ____LocationRelatedDataRequest_protocolIEs__item__id_tab
    ___LocationRelatedDataRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationRelatedDataRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationRelatedDataRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationRelatedDataRequest_protocolIEs__item__id),
        ('criticality', ___LocationRelatedDataRequest_protocolIEs__item__criticality),
        ('value', ___LocationRelatedDataRequest_protocolIEs__item__value),
        ])
    __LocationRelatedDataRequest_protocolIEs__item_._ext = None
    _LocationRelatedDataRequest_protocolIEs._cont = __LocationRelatedDataRequest_protocolIEs__item_
    _LocationRelatedDataRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LocationRelatedDataRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationRelatedDataRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationRelatedDataRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationRelatedDataRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LocationRelatedDataRequestTypeSpecificToGERANIuMode')))
    _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestedGANSSAssistanceData')))
    ____LocationRelatedDataRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 115), ('criticality', 'reject'), ('Extension', _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 185), ('criticality', 'reject'), ('Extension', _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataRequest_protocolExtensions__item__id._const_tab = ____LocationRelatedDataRequest_protocolExtensions__item__id_tab
    ___LocationRelatedDataRequest_protocolExtensions__item__id._const_tab_at = None
    ___LocationRelatedDataRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___LocationRelatedDataRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LocationRelatedDataRequest_protocolExtensions__item__criticality._const_tab = ____LocationRelatedDataRequest_protocolExtensions__item__id_tab
    ___LocationRelatedDataRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationRelatedDataRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue._const_tab = ____LocationRelatedDataRequest_protocolExtensions__item__id_tab
    ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationRelatedDataRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___LocationRelatedDataRequest_protocolExtensions__item__id),
        ('criticality', ___LocationRelatedDataRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue),
        ])
    __LocationRelatedDataRequest_protocolExtensions__item_._ext = None
    _LocationRelatedDataRequest_protocolExtensions._cont = __LocationRelatedDataRequest_protocolExtensions__item_
    _LocationRelatedDataRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationRelatedDataRequest._cont = ASN1Dict([
        ('protocolIEs', _LocationRelatedDataRequest_protocolIEs),
        ('protocolExtensions', _LocationRelatedDataRequest_protocolExtensions),
        ])
    LocationRelatedDataRequest._ext = []
    
    #-----< LocationRelatedDataRequestIEs >-----#
    LocationRelatedDataRequestIEs = CLASS(name='LocationRelatedDataRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _LocationRelatedDataRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LocationRelatedDataRequestType')))
    LocationRelatedDataRequestIEs._val = ASN1Set(rv=[dict([('id', 95), ('criticality', 'reject'), ('Value', _LocationRelatedDataRequestIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataRequestExtensions >-----#
    LocationRelatedDataRequestExtensions = CLASS(name='LocationRelatedDataRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LocationRelatedDataRequestExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'LocationRelatedDataRequestTypeSpecificToGERANIuMode')))
    _LocationRelatedDataRequestExtensions_val_Extension_1 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RequestedGANSSAssistanceData')))
    LocationRelatedDataRequestExtensions._val = ASN1Set(rv=[dict([('id', 115), ('criticality', 'reject'), ('Extension', _LocationRelatedDataRequestExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 185), ('criticality', 'reject'), ('Extension', _LocationRelatedDataRequestExtensions_val_Extension_1), ('presence', 'conditional')])], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataResponse >-----#
    LocationRelatedDataResponse = SEQ(name='LocationRelatedDataResponse', mode=MODE_TYPE)
    _LocationRelatedDataResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __LocationRelatedDataResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___LocationRelatedDataResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____LocationRelatedDataResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____LocationRelatedDataResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BroadcastAssistanceDataDecipheringKeys')))
    ____LocationRelatedDataResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 94), ('criticality', 'ignore'), ('Value', _____LocationRelatedDataResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataResponse_protocolIEs__item__id._const_tab = ____LocationRelatedDataResponse_protocolIEs__item__id_tab
    ___LocationRelatedDataResponse_protocolIEs__item__id._const_tab_at = None
    ___LocationRelatedDataResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationRelatedDataResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___LocationRelatedDataResponse_protocolIEs__item__criticality._const_tab = ____LocationRelatedDataResponse_protocolIEs__item__id_tab
    ___LocationRelatedDataResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationRelatedDataResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationRelatedDataResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___LocationRelatedDataResponse_protocolIEs__item__value._const_tab = ____LocationRelatedDataResponse_protocolIEs__item__id_tab
    ___LocationRelatedDataResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationRelatedDataResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationRelatedDataResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationRelatedDataResponse_protocolIEs__item__id),
        ('criticality', ___LocationRelatedDataResponse_protocolIEs__item__criticality),
        ('value', ___LocationRelatedDataResponse_protocolIEs__item__value),
        ])
    __LocationRelatedDataResponse_protocolIEs__item_._ext = None
    _LocationRelatedDataResponse_protocolIEs._cont = __LocationRelatedDataResponse_protocolIEs__item_
    _LocationRelatedDataResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LocationRelatedDataResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationRelatedDataResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationRelatedDataResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationRelatedDataResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BroadcastAssistanceDataDecipheringKeys')))
    ____LocationRelatedDataResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Extension', _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Extension', _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataResponse_protocolExtensions__item__id._const_tab = ____LocationRelatedDataResponse_protocolExtensions__item__id_tab
    ___LocationRelatedDataResponse_protocolExtensions__item__id._const_tab_at = None
    ___LocationRelatedDataResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___LocationRelatedDataResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LocationRelatedDataResponse_protocolExtensions__item__criticality._const_tab = ____LocationRelatedDataResponse_protocolExtensions__item__id_tab
    ___LocationRelatedDataResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationRelatedDataResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue._const_tab = ____LocationRelatedDataResponse_protocolExtensions__item__id_tab
    ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationRelatedDataResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___LocationRelatedDataResponse_protocolExtensions__item__id),
        ('criticality', ___LocationRelatedDataResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue),
        ])
    __LocationRelatedDataResponse_protocolExtensions__item_._ext = None
    _LocationRelatedDataResponse_protocolExtensions._cont = __LocationRelatedDataResponse_protocolExtensions__item_
    _LocationRelatedDataResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationRelatedDataResponse._cont = ASN1Dict([
        ('protocolIEs', _LocationRelatedDataResponse_protocolIEs),
        ('protocolExtensions', _LocationRelatedDataResponse_protocolExtensions),
        ])
    LocationRelatedDataResponse._ext = []
    
    #-----< LocationRelatedDataResponseIEs >-----#
    LocationRelatedDataResponseIEs = CLASS(name='LocationRelatedDataResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _LocationRelatedDataResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BroadcastAssistanceDataDecipheringKeys')))
    LocationRelatedDataResponseIEs._val = ASN1Set(rv=[dict([('id', 94), ('criticality', 'ignore'), ('Value', _LocationRelatedDataResponseIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataResponseExtensions >-----#
    LocationRelatedDataResponseExtensions = CLASS(name='LocationRelatedDataResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LocationRelatedDataResponseExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _LocationRelatedDataResponseExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'BroadcastAssistanceDataDecipheringKeys')))
    LocationRelatedDataResponseExtensions._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Extension', _LocationRelatedDataResponseExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 186), ('criticality', 'ignore'), ('Extension', _LocationRelatedDataResponseExtensions_val_Extension_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataFailure >-----#
    LocationRelatedDataFailure = SEQ(name='LocationRelatedDataFailure', mode=MODE_TYPE)
    _LocationRelatedDataFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __LocationRelatedDataFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___LocationRelatedDataFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____LocationRelatedDataFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____LocationRelatedDataFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____LocationRelatedDataFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____LocationRelatedDataFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataFailure_protocolIEs__item__id._const_tab = ____LocationRelatedDataFailure_protocolIEs__item__id_tab
    ___LocationRelatedDataFailure_protocolIEs__item__id._const_tab_at = None
    ___LocationRelatedDataFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___LocationRelatedDataFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___LocationRelatedDataFailure_protocolIEs__item__criticality._const_tab = ____LocationRelatedDataFailure_protocolIEs__item__id_tab
    ___LocationRelatedDataFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___LocationRelatedDataFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___LocationRelatedDataFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___LocationRelatedDataFailure_protocolIEs__item__value._const_tab = ____LocationRelatedDataFailure_protocolIEs__item__id_tab
    ___LocationRelatedDataFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___LocationRelatedDataFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __LocationRelatedDataFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___LocationRelatedDataFailure_protocolIEs__item__id),
        ('criticality', ___LocationRelatedDataFailure_protocolIEs__item__criticality),
        ('value', ___LocationRelatedDataFailure_protocolIEs__item__value),
        ])
    __LocationRelatedDataFailure_protocolIEs__item_._ext = None
    _LocationRelatedDataFailure_protocolIEs._cont = __LocationRelatedDataFailure_protocolIEs__item_
    _LocationRelatedDataFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LocationRelatedDataFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __LocationRelatedDataFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___LocationRelatedDataFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____LocationRelatedDataFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LocationRelatedDataFailure_protocolExtensions__item__id_tab_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____LocationRelatedDataFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Extension', _____LocationRelatedDataFailure_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___LocationRelatedDataFailure_protocolExtensions__item__id._const_tab = ____LocationRelatedDataFailure_protocolExtensions__item__id_tab
    ___LocationRelatedDataFailure_protocolExtensions__item__id._const_tab_at = None
    ___LocationRelatedDataFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___LocationRelatedDataFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___LocationRelatedDataFailure_protocolExtensions__item__criticality._const_tab = ____LocationRelatedDataFailure_protocolExtensions__item__id_tab
    ___LocationRelatedDataFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___LocationRelatedDataFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue._const_tab = ____LocationRelatedDataFailure_protocolExtensions__item__id_tab
    ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __LocationRelatedDataFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___LocationRelatedDataFailure_protocolExtensions__item__id),
        ('criticality', ___LocationRelatedDataFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue),
        ])
    __LocationRelatedDataFailure_protocolExtensions__item_._ext = None
    _LocationRelatedDataFailure_protocolExtensions._cont = __LocationRelatedDataFailure_protocolExtensions__item_
    _LocationRelatedDataFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    LocationRelatedDataFailure._cont = ASN1Dict([
        ('protocolIEs', _LocationRelatedDataFailure_protocolIEs),
        ('protocolExtensions', _LocationRelatedDataFailure_protocolExtensions),
        ])
    LocationRelatedDataFailure._ext = []
    
    #-----< LocationRelatedDataFailureIEs >-----#
    LocationRelatedDataFailureIEs = CLASS(name='LocationRelatedDataFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _LocationRelatedDataFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    LocationRelatedDataFailureIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _LocationRelatedDataFailureIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< LocationRelatedDataFailureExtensions >-----#
    LocationRelatedDataFailureExtensions = CLASS(name='LocationRelatedDataFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _LocationRelatedDataFailureExtensions_val_Extension_0 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    LocationRelatedDataFailureExtensions._val = ASN1Set(rv=[dict([('id', 9), ('criticality', 'ignore'), ('Extension', _LocationRelatedDataFailureExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferIndication >-----#
    InformationTransferIndication = SEQ(name='InformationTransferIndication', mode=MODE_TYPE)
    _InformationTransferIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __InformationTransferIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___InformationTransferIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____InformationTransferIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ProvidedData')))
    _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    ____InformationTransferIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 104), ('criticality', 'reject'), ('Value', _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 106), ('criticality', 'reject'), ('Value', _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InformationTransferIndication_protocolIEs__item__id._const_tab = ____InformationTransferIndication_protocolIEs__item__id_tab
    ___InformationTransferIndication_protocolIEs__item__id._const_tab_at = None
    ___InformationTransferIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationTransferIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___InformationTransferIndication_protocolIEs__item__criticality._const_tab = ____InformationTransferIndication_protocolIEs__item__id_tab
    ___InformationTransferIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationTransferIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationTransferIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___InformationTransferIndication_protocolIEs__item__value._const_tab = ____InformationTransferIndication_protocolIEs__item__id_tab
    ___InformationTransferIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationTransferIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationTransferIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationTransferIndication_protocolIEs__item__id),
        ('criticality', ___InformationTransferIndication_protocolIEs__item__criticality),
        ('value', ___InformationTransferIndication_protocolIEs__item__value),
        ])
    __InformationTransferIndication_protocolIEs__item_._ext = None
    _InformationTransferIndication_protocolIEs._cont = __InformationTransferIndication_protocolIEs__item_
    _InformationTransferIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationTransferIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationTransferIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InformationTransferIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationTransferIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InformationTransferIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationTransferIndication_protocolExtensions__item__id._const_tab = ____InformationTransferIndication_protocolExtensions__item__id_tab
    ___InformationTransferIndication_protocolExtensions__item__id._const_tab_at = None
    ___InformationTransferIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationTransferIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____InformationTransferIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InformationTransferIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationTransferIndication_protocolExtensions__item__criticality._const_tab = ____InformationTransferIndication_protocolExtensions__item__criticality_tab
    ___InformationTransferIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationTransferIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationTransferIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____InformationTransferIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____InformationTransferIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___InformationTransferIndication_protocolExtensions__item__extensionValue._const_tab = ____InformationTransferIndication_protocolExtensions__item__extensionValue_tab
    ___InformationTransferIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationTransferIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationTransferIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationTransferIndication_protocolExtensions__item__id),
        ('criticality', ___InformationTransferIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationTransferIndication_protocolExtensions__item__extensionValue),
        ])
    __InformationTransferIndication_protocolExtensions__item_._ext = None
    _InformationTransferIndication_protocolExtensions._cont = __InformationTransferIndication_protocolExtensions__item_
    _InformationTransferIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationTransferIndication._cont = ASN1Dict([
        ('protocolIEs', _InformationTransferIndication_protocolIEs),
        ('protocolExtensions', _InformationTransferIndication_protocolExtensions),
        ])
    InformationTransferIndication._ext = []
    
    #-----< InformationTransferIndicationIEs >-----#
    InformationTransferIndicationIEs = CLASS(name='InformationTransferIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _InformationTransferIndicationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _InformationTransferIndicationIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ProvidedData')))
    _InformationTransferIndicationIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _InformationTransferIndicationIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    InformationTransferIndicationIEs._val = ASN1Set(rv=[dict([('id', 104), ('criticality', 'reject'), ('Value', _InformationTransferIndicationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 106), ('criticality', 'reject'), ('Value', _InformationTransferIndicationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _InformationTransferIndicationIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _InformationTransferIndicationIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferIndicationExtensions >-----#
    InformationTransferIndicationExtensions = CLASS(name='InformationTransferIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    InformationTransferIndicationExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< InformationTransferConfirmation >-----#
    InformationTransferConfirmation = SEQ(name='InformationTransferConfirmation', mode=MODE_TYPE)
    _InformationTransferConfirmation_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __InformationTransferConfirmation_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___InformationTransferConfirmation_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____InformationTransferConfirmation_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____InformationTransferConfirmation_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 104), ('criticality', 'ignore'), ('Value', _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InformationTransferConfirmation_protocolIEs__item__id._const_tab = ____InformationTransferConfirmation_protocolIEs__item__id_tab
    ___InformationTransferConfirmation_protocolIEs__item__id._const_tab_at = None
    ___InformationTransferConfirmation_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationTransferConfirmation_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___InformationTransferConfirmation_protocolIEs__item__criticality._const_tab = ____InformationTransferConfirmation_protocolIEs__item__id_tab
    ___InformationTransferConfirmation_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationTransferConfirmation_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationTransferConfirmation_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___InformationTransferConfirmation_protocolIEs__item__value._const_tab = ____InformationTransferConfirmation_protocolIEs__item__id_tab
    ___InformationTransferConfirmation_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationTransferConfirmation_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationTransferConfirmation_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationTransferConfirmation_protocolIEs__item__id),
        ('criticality', ___InformationTransferConfirmation_protocolIEs__item__criticality),
        ('value', ___InformationTransferConfirmation_protocolIEs__item__value),
        ])
    __InformationTransferConfirmation_protocolIEs__item_._ext = None
    _InformationTransferConfirmation_protocolIEs._cont = __InformationTransferConfirmation_protocolIEs__item_
    _InformationTransferConfirmation_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationTransferConfirmation_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationTransferConfirmation_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InformationTransferConfirmation_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationTransferConfirmation_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____InformationTransferConfirmation_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____InformationTransferConfirmation_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _____InformationTransferConfirmation_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InformationTransferConfirmation_protocolExtensions__item__id._const_tab = ____InformationTransferConfirmation_protocolExtensions__item__id_tab
    ___InformationTransferConfirmation_protocolExtensions__item__id._const_tab_at = None
    ___InformationTransferConfirmation_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationTransferConfirmation_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___InformationTransferConfirmation_protocolExtensions__item__criticality._const_tab = ____InformationTransferConfirmation_protocolExtensions__item__id_tab
    ___InformationTransferConfirmation_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationTransferConfirmation_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationTransferConfirmation_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___InformationTransferConfirmation_protocolExtensions__item__extensionValue._const_tab = ____InformationTransferConfirmation_protocolExtensions__item__id_tab
    ___InformationTransferConfirmation_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationTransferConfirmation_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationTransferConfirmation_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationTransferConfirmation_protocolExtensions__item__id),
        ('criticality', ___InformationTransferConfirmation_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationTransferConfirmation_protocolExtensions__item__extensionValue),
        ])
    __InformationTransferConfirmation_protocolExtensions__item_._ext = None
    _InformationTransferConfirmation_protocolExtensions._cont = __InformationTransferConfirmation_protocolExtensions__item_
    _InformationTransferConfirmation_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationTransferConfirmation._cont = ASN1Dict([
        ('protocolIEs', _InformationTransferConfirmation_protocolIEs),
        ('protocolExtensions', _InformationTransferConfirmation_protocolExtensions),
        ])
    InformationTransferConfirmation._ext = []
    
    #-----< InformationTransferConfirmationIEs >-----#
    InformationTransferConfirmationIEs = CLASS(name='InformationTransferConfirmationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _InformationTransferConfirmationIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _InformationTransferConfirmationIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _InformationTransferConfirmationIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _InformationTransferConfirmationIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    InformationTransferConfirmationIEs._val = ASN1Set(rv=[dict([('id', 104), ('criticality', 'ignore'), ('Value', _InformationTransferConfirmationIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _InformationTransferConfirmationIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _InformationTransferConfirmationIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _InformationTransferConfirmationIEs_val_Value_3), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferConfirmationExtensions >-----#
    InformationTransferConfirmationExtensions = CLASS(name='InformationTransferConfirmationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _InformationTransferConfirmationExtensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    InformationTransferConfirmationExtensions._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _InformationTransferConfirmationExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferFailure >-----#
    InformationTransferFailure = SEQ(name='InformationTransferFailure', mode=MODE_TYPE)
    _InformationTransferFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __InformationTransferFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___InformationTransferFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____InformationTransferFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____InformationTransferFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 104), ('criticality', 'ignore'), ('Value', _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___InformationTransferFailure_protocolIEs__item__id._const_tab = ____InformationTransferFailure_protocolIEs__item__id_tab
    ___InformationTransferFailure_protocolIEs__item__id._const_tab_at = None
    ___InformationTransferFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___InformationTransferFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___InformationTransferFailure_protocolIEs__item__criticality._const_tab = ____InformationTransferFailure_protocolIEs__item__id_tab
    ___InformationTransferFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___InformationTransferFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___InformationTransferFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___InformationTransferFailure_protocolIEs__item__value._const_tab = ____InformationTransferFailure_protocolIEs__item__id_tab
    ___InformationTransferFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___InformationTransferFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __InformationTransferFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___InformationTransferFailure_protocolIEs__item__id),
        ('criticality', ___InformationTransferFailure_protocolIEs__item__criticality),
        ('value', ___InformationTransferFailure_protocolIEs__item__value),
        ])
    __InformationTransferFailure_protocolIEs__item_._ext = None
    _InformationTransferFailure_protocolIEs._cont = __InformationTransferFailure_protocolIEs__item_
    _InformationTransferFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _InformationTransferFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __InformationTransferFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___InformationTransferFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____InformationTransferFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____InformationTransferFailure_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____InformationTransferFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _____InformationTransferFailure_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___InformationTransferFailure_protocolExtensions__item__id._const_tab = ____InformationTransferFailure_protocolExtensions__item__id_tab
    ___InformationTransferFailure_protocolExtensions__item__id._const_tab_at = None
    ___InformationTransferFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___InformationTransferFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___InformationTransferFailure_protocolExtensions__item__criticality._const_tab = ____InformationTransferFailure_protocolExtensions__item__id_tab
    ___InformationTransferFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___InformationTransferFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___InformationTransferFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___InformationTransferFailure_protocolExtensions__item__extensionValue._const_tab = ____InformationTransferFailure_protocolExtensions__item__id_tab
    ___InformationTransferFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___InformationTransferFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __InformationTransferFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___InformationTransferFailure_protocolExtensions__item__id),
        ('criticality', ___InformationTransferFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___InformationTransferFailure_protocolExtensions__item__extensionValue),
        ])
    __InformationTransferFailure_protocolExtensions__item_._ext = None
    _InformationTransferFailure_protocolExtensions._cont = __InformationTransferFailure_protocolExtensions__item_
    _InformationTransferFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    InformationTransferFailure._cont = ASN1Dict([
        ('protocolIEs', _InformationTransferFailure_protocolIEs),
        ('protocolExtensions', _InformationTransferFailure_protocolExtensions),
        ])
    InformationTransferFailure._ext = []
    
    #-----< InformationTransferFailureIEs >-----#
    InformationTransferFailureIEs = CLASS(name='InformationTransferFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _InformationTransferFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferID')))
    _InformationTransferFailureIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _InformationTransferFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _InformationTransferFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    _InformationTransferFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    InformationTransferFailureIEs._val = ASN1Set(rv=[dict([('id', 104), ('criticality', 'ignore'), ('Value', _InformationTransferFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _InformationTransferFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _InformationTransferFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _InformationTransferFailureIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _InformationTransferFailureIEs_val_Value_4), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< InformationTransferFailureExtensions >-----#
    InformationTransferFailureExtensions = CLASS(name='InformationTransferFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _InformationTransferFailureExtensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    InformationTransferFailureExtensions._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _InformationTransferFailureExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UESpecificInformationIndication >-----#
    UESpecificInformationIndication = SEQ(name='UESpecificInformationIndication', mode=MODE_TYPE)
    _UESpecificInformationIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UESpecificInformationIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UESpecificInformationIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____UESpecificInformationIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UESpecificInformationIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    ____UESpecificInformationIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 118), ('criticality', 'ignore'), ('Value', _____UESpecificInformationIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UESpecificInformationIndication_protocolIEs__item__id._const_tab = ____UESpecificInformationIndication_protocolIEs__item__id_tab
    ___UESpecificInformationIndication_protocolIEs__item__id._const_tab_at = None
    ___UESpecificInformationIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___UESpecificInformationIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___UESpecificInformationIndication_protocolIEs__item__criticality._const_tab = ____UESpecificInformationIndication_protocolIEs__item__id_tab
    ___UESpecificInformationIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UESpecificInformationIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UESpecificInformationIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___UESpecificInformationIndication_protocolIEs__item__value._const_tab = ____UESpecificInformationIndication_protocolIEs__item__id_tab
    ___UESpecificInformationIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UESpecificInformationIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __UESpecificInformationIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UESpecificInformationIndication_protocolIEs__item__id),
        ('criticality', ___UESpecificInformationIndication_protocolIEs__item__criticality),
        ('value', ___UESpecificInformationIndication_protocolIEs__item__value),
        ])
    __UESpecificInformationIndication_protocolIEs__item_._ext = None
    _UESpecificInformationIndication_protocolIEs._cont = __UESpecificInformationIndication_protocolIEs__item_
    _UESpecificInformationIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UESpecificInformationIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UESpecificInformationIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UESpecificInformationIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UESpecificInformationIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESpecificInformationIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESpecificInformationIndication_protocolExtensions__item__id._const_tab = ____UESpecificInformationIndication_protocolExtensions__item__id_tab
    ___UESpecificInformationIndication_protocolExtensions__item__id._const_tab_at = None
    ___UESpecificInformationIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___UESpecificInformationIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UESpecificInformationIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESpecificInformationIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESpecificInformationIndication_protocolExtensions__item__criticality._const_tab = ____UESpecificInformationIndication_protocolExtensions__item__criticality_tab
    ___UESpecificInformationIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UESpecificInformationIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UESpecificInformationIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UESpecificInformationIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UESpecificInformationIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UESpecificInformationIndication_protocolExtensions__item__extensionValue._const_tab = ____UESpecificInformationIndication_protocolExtensions__item__extensionValue_tab
    ___UESpecificInformationIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UESpecificInformationIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UESpecificInformationIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UESpecificInformationIndication_protocolExtensions__item__id),
        ('criticality', ___UESpecificInformationIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___UESpecificInformationIndication_protocolExtensions__item__extensionValue),
        ])
    __UESpecificInformationIndication_protocolExtensions__item_._ext = None
    _UESpecificInformationIndication_protocolExtensions._cont = __UESpecificInformationIndication_protocolExtensions__item_
    _UESpecificInformationIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UESpecificInformationIndication._cont = ASN1Dict([
        ('protocolIEs', _UESpecificInformationIndication_protocolIEs),
        ('protocolExtensions', _UESpecificInformationIndication_protocolExtensions),
        ])
    UESpecificInformationIndication._ext = []
    
    #-----< UESpecificInformationIndicationIEs >-----#
    UESpecificInformationIndicationIEs = CLASS(name='UESpecificInformationIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UESpecificInformationIndicationIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UESBI-Iu')))
    UESpecificInformationIndicationIEs._val = ASN1Set(rv=[dict([('id', 118), ('criticality', 'ignore'), ('Value', _UESpecificInformationIndicationIEs_val_Value_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UESpecificInformationIndicationExtensions >-----#
    UESpecificInformationIndicationExtensions = CLASS(name='UESpecificInformationIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UESpecificInformationIndicationExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DirectInformationTransfer >-----#
    DirectInformationTransfer = SEQ(name='DirectInformationTransfer', mode=MODE_TYPE)
    _DirectInformationTransfer_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __DirectInformationTransfer_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___DirectInformationTransfer_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____DirectInformationTransfer_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformationTransferType')))
    _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    ____DirectInformationTransfer_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 126), ('criticality', 'ignore'), ('Value', _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DirectInformationTransfer_protocolIEs__item__id._const_tab = ____DirectInformationTransfer_protocolIEs__item__id_tab
    ___DirectInformationTransfer_protocolIEs__item__id._const_tab_at = None
    ___DirectInformationTransfer_protocolIEs__item__id._const_tab_id = 'id'
    ___DirectInformationTransfer_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___DirectInformationTransfer_protocolIEs__item__criticality._const_tab = ____DirectInformationTransfer_protocolIEs__item__id_tab
    ___DirectInformationTransfer_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___DirectInformationTransfer_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___DirectInformationTransfer_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___DirectInformationTransfer_protocolIEs__item__value._const_tab = ____DirectInformationTransfer_protocolIEs__item__id_tab
    ___DirectInformationTransfer_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___DirectInformationTransfer_protocolIEs__item__value._const_tab_id = 'Value'
    __DirectInformationTransfer_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___DirectInformationTransfer_protocolIEs__item__id),
        ('criticality', ___DirectInformationTransfer_protocolIEs__item__criticality),
        ('value', ___DirectInformationTransfer_protocolIEs__item__value),
        ])
    __DirectInformationTransfer_protocolIEs__item_._ext = None
    _DirectInformationTransfer_protocolIEs._cont = __DirectInformationTransfer_protocolIEs__item_
    _DirectInformationTransfer_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _DirectInformationTransfer_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __DirectInformationTransfer_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___DirectInformationTransfer_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____DirectInformationTransfer_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____DirectInformationTransfer_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____DirectInformationTransfer_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _____DirectInformationTransfer_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___DirectInformationTransfer_protocolExtensions__item__id._const_tab = ____DirectInformationTransfer_protocolExtensions__item__id_tab
    ___DirectInformationTransfer_protocolExtensions__item__id._const_tab_at = None
    ___DirectInformationTransfer_protocolExtensions__item__id._const_tab_id = 'id'
    ___DirectInformationTransfer_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___DirectInformationTransfer_protocolExtensions__item__criticality._const_tab = ____DirectInformationTransfer_protocolExtensions__item__id_tab
    ___DirectInformationTransfer_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___DirectInformationTransfer_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue._const_tab = ____DirectInformationTransfer_protocolExtensions__item__id_tab
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___DirectInformationTransfer_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __DirectInformationTransfer_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___DirectInformationTransfer_protocolExtensions__item__id),
        ('criticality', ___DirectInformationTransfer_protocolExtensions__item__criticality),
        ('extensionValue', ___DirectInformationTransfer_protocolExtensions__item__extensionValue),
        ])
    __DirectInformationTransfer_protocolExtensions__item_._ext = None
    _DirectInformationTransfer_protocolExtensions._cont = __DirectInformationTransfer_protocolExtensions__item_
    _DirectInformationTransfer_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    DirectInformationTransfer._cont = ASN1Dict([
        ('protocolIEs', _DirectInformationTransfer_protocolIEs),
        ('protocolExtensions', _DirectInformationTransfer_protocolExtensions),
        ])
    DirectInformationTransfer._ext = []
    
    #-----< DirectInformationTransferIEs >-----#
    DirectInformationTransferIEs = CLASS(name='DirectInformationTransferIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _DirectInformationTransferIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InterSystemInformationTransferType')))
    _DirectInformationTransferIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _DirectInformationTransferIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _DirectInformationTransferIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    DirectInformationTransferIEs._val = ASN1Set(rv=[dict([('id', 126), ('criticality', 'ignore'), ('Value', _DirectInformationTransferIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _DirectInformationTransferIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _DirectInformationTransferIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _DirectInformationTransferIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< DirectInformationTransferExtensions >-----#
    DirectInformationTransferExtensions = CLASS(name='DirectInformationTransferExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _DirectInformationTransferExtensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    DirectInformationTransferExtensions._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _DirectInformationTransferExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeRequest >-----#
    UplinkInformationExchangeRequest = SEQ(name='UplinkInformationExchangeRequest', mode=MODE_TYPE)
    _UplinkInformationExchangeRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UplinkInformationExchangeRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UplinkInformationExchangeRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeType')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferType')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationRequestType')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'reject'), ('Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 137), ('criticality', 'reject'), ('Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 123), ('criticality', 'reject'), ('Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'conditional')]), dict([('id', 139), ('criticality', 'reject'), ('Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'conditional')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'reject'), ('Value', _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeRequest_protocolIEs__item__id._const_tab = ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab
    ___UplinkInformationExchangeRequest_protocolIEs__item__id._const_tab_at = None
    ___UplinkInformationExchangeRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkInformationExchangeRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___UplinkInformationExchangeRequest_protocolIEs__item__criticality._const_tab = ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab
    ___UplinkInformationExchangeRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkInformationExchangeRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___UplinkInformationExchangeRequest_protocolIEs__item__value._const_tab = ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab
    ___UplinkInformationExchangeRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkInformationExchangeRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkInformationExchangeRequest_protocolIEs__item__id),
        ('criticality', ___UplinkInformationExchangeRequest_protocolIEs__item__criticality),
        ('value', ___UplinkInformationExchangeRequest_protocolIEs__item__value),
        ])
    __UplinkInformationExchangeRequest_protocolIEs__item_._ext = None
    _UplinkInformationExchangeRequest_protocolIEs._cont = __UplinkInformationExchangeRequest_protocolIEs__item_
    _UplinkInformationExchangeRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UplinkInformationExchangeRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UplinkInformationExchangeRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UplinkInformationExchangeRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeRequest_protocolExtensions__item__id._const_tab = ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab
    ___UplinkInformationExchangeRequest_protocolExtensions__item__id._const_tab_at = None
    ___UplinkInformationExchangeRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality._const_tab = ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab
    ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue._const_tab = ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab
    ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UplinkInformationExchangeRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UplinkInformationExchangeRequest_protocolExtensions__item__id),
        ('criticality', ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue),
        ])
    __UplinkInformationExchangeRequest_protocolExtensions__item_._ext = None
    _UplinkInformationExchangeRequest_protocolExtensions._cont = __UplinkInformationExchangeRequest_protocolExtensions__item_
    _UplinkInformationExchangeRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UplinkInformationExchangeRequest._cont = ASN1Dict([
        ('protocolIEs', _UplinkInformationExchangeRequest_protocolIEs),
        ('protocolExtensions', _UplinkInformationExchangeRequest_protocolExtensions),
        ])
    UplinkInformationExchangeRequest._ext = []
    
    #-----< UplinkInformationExchangeRequestIEs >-----#
    UplinkInformationExchangeRequestIEs = CLASS(name='UplinkInformationExchangeRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UplinkInformationExchangeRequestIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _UplinkInformationExchangeRequestIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeType')))
    _UplinkInformationExchangeRequestIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationTransferType')))
    _UplinkInformationExchangeRequestIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationRequestType')))
    _UplinkInformationExchangeRequestIEs_val_Value_4 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _UplinkInformationExchangeRequestIEs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    UplinkInformationExchangeRequestIEs._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'reject'), ('Value', _UplinkInformationExchangeRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 137), ('criticality', 'reject'), ('Value', _UplinkInformationExchangeRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 123), ('criticality', 'reject'), ('Value', _UplinkInformationExchangeRequestIEs_val_Value_2), ('presence', 'conditional')]), dict([('id', 139), ('criticality', 'reject'), ('Value', _UplinkInformationExchangeRequestIEs_val_Value_3), ('presence', 'conditional')]), dict([('id', 3), ('criticality', 'reject'), ('Value', _UplinkInformationExchangeRequestIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'reject'), ('Value', _UplinkInformationExchangeRequestIEs_val_Value_5), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeRequestExtensions >-----#
    UplinkInformationExchangeRequestExtensions = CLASS(name='UplinkInformationExchangeRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _UplinkInformationExchangeRequestExtensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    UplinkInformationExchangeRequestExtensions._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _UplinkInformationExchangeRequestExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeResponse >-----#
    UplinkInformationExchangeResponse = SEQ(name='UplinkInformationExchangeResponse', mode=MODE_TYPE)
    _UplinkInformationExchangeResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UplinkInformationExchangeResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UplinkInformationExchangeResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationRequested')))
    _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'ignore'), ('Value', _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 138), ('criticality', 'ignore'), ('Value', _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeResponse_protocolIEs__item__id._const_tab = ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab
    ___UplinkInformationExchangeResponse_protocolIEs__item__id._const_tab_at = None
    ___UplinkInformationExchangeResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkInformationExchangeResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___UplinkInformationExchangeResponse_protocolIEs__item__criticality._const_tab = ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab
    ___UplinkInformationExchangeResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkInformationExchangeResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___UplinkInformationExchangeResponse_protocolIEs__item__value._const_tab = ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab
    ___UplinkInformationExchangeResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkInformationExchangeResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkInformationExchangeResponse_protocolIEs__item__id),
        ('criticality', ___UplinkInformationExchangeResponse_protocolIEs__item__criticality),
        ('value', ___UplinkInformationExchangeResponse_protocolIEs__item__value),
        ])
    __UplinkInformationExchangeResponse_protocolIEs__item_._ext = None
    _UplinkInformationExchangeResponse_protocolIEs._cont = __UplinkInformationExchangeResponse_protocolIEs__item_
    _UplinkInformationExchangeResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UplinkInformationExchangeResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UplinkInformationExchangeResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UplinkInformationExchangeResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeResponse_protocolExtensions__item__id._const_tab = ____UplinkInformationExchangeResponse_protocolExtensions__item__id_tab
    ___UplinkInformationExchangeResponse_protocolExtensions__item__id._const_tab_at = None
    ___UplinkInformationExchangeResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality._const_tab = ____UplinkInformationExchangeResponse_protocolExtensions__item__criticality_tab
    ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue._const_tab = ____UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue_tab
    ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UplinkInformationExchangeResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UplinkInformationExchangeResponse_protocolExtensions__item__id),
        ('criticality', ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue),
        ])
    __UplinkInformationExchangeResponse_protocolExtensions__item_._ext = None
    _UplinkInformationExchangeResponse_protocolExtensions._cont = __UplinkInformationExchangeResponse_protocolExtensions__item_
    _UplinkInformationExchangeResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UplinkInformationExchangeResponse._cont = ASN1Dict([
        ('protocolIEs', _UplinkInformationExchangeResponse_protocolIEs),
        ('protocolExtensions', _UplinkInformationExchangeResponse_protocolExtensions),
        ])
    UplinkInformationExchangeResponse._ext = []
    
    #-----< UplinkInformationExchangeResponseIEs >-----#
    UplinkInformationExchangeResponseIEs = CLASS(name='UplinkInformationExchangeResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UplinkInformationExchangeResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _UplinkInformationExchangeResponseIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationRequested')))
    _UplinkInformationExchangeResponseIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _UplinkInformationExchangeResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _UplinkInformationExchangeResponseIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    UplinkInformationExchangeResponseIEs._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'ignore'), ('Value', _UplinkInformationExchangeResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 138), ('criticality', 'ignore'), ('Value', _UplinkInformationExchangeResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _UplinkInformationExchangeResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _UplinkInformationExchangeResponseIEs_val_Value_3), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _UplinkInformationExchangeResponseIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeResponseExtensions >-----#
    UplinkInformationExchangeResponseExtensions = CLASS(name='UplinkInformationExchangeResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UplinkInformationExchangeResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeFailure >-----#
    UplinkInformationExchangeFailure = SEQ(name='UplinkInformationExchangeFailure', mode=MODE_TYPE)
    _UplinkInformationExchangeFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UplinkInformationExchangeFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UplinkInformationExchangeFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'ignore'), ('Value', _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeFailure_protocolIEs__item__id._const_tab = ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab
    ___UplinkInformationExchangeFailure_protocolIEs__item__id._const_tab_at = None
    ___UplinkInformationExchangeFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___UplinkInformationExchangeFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___UplinkInformationExchangeFailure_protocolIEs__item__criticality._const_tab = ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab
    ___UplinkInformationExchangeFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UplinkInformationExchangeFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___UplinkInformationExchangeFailure_protocolIEs__item__value._const_tab = ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab
    ___UplinkInformationExchangeFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __UplinkInformationExchangeFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UplinkInformationExchangeFailure_protocolIEs__item__id),
        ('criticality', ___UplinkInformationExchangeFailure_protocolIEs__item__criticality),
        ('value', ___UplinkInformationExchangeFailure_protocolIEs__item__value),
        ])
    __UplinkInformationExchangeFailure_protocolIEs__item_._ext = None
    _UplinkInformationExchangeFailure_protocolIEs._cont = __UplinkInformationExchangeFailure_protocolIEs__item_
    _UplinkInformationExchangeFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UplinkInformationExchangeFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UplinkInformationExchangeFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UplinkInformationExchangeFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeFailure_protocolExtensions__item__id._const_tab = ____UplinkInformationExchangeFailure_protocolExtensions__item__id_tab
    ___UplinkInformationExchangeFailure_protocolExtensions__item__id._const_tab_at = None
    ___UplinkInformationExchangeFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality._const_tab = ____UplinkInformationExchangeFailure_protocolExtensions__item__criticality_tab
    ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue._const_tab = ____UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue_tab
    ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UplinkInformationExchangeFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UplinkInformationExchangeFailure_protocolExtensions__item__id),
        ('criticality', ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue),
        ])
    __UplinkInformationExchangeFailure_protocolExtensions__item_._ext = None
    _UplinkInformationExchangeFailure_protocolExtensions._cont = __UplinkInformationExchangeFailure_protocolExtensions__item_
    _UplinkInformationExchangeFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UplinkInformationExchangeFailure._cont = ASN1Dict([
        ('protocolIEs', _UplinkInformationExchangeFailure_protocolIEs),
        ('protocolExtensions', _UplinkInformationExchangeFailure_protocolExtensions),
        ])
    UplinkInformationExchangeFailure._ext = []
    
    #-----< UplinkInformationExchangeFailureIEs >-----#
    UplinkInformationExchangeFailureIEs = CLASS(name='UplinkInformationExchangeFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UplinkInformationExchangeFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'InformationExchangeID')))
    _UplinkInformationExchangeFailureIEs_val_Value_1 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CN-DomainIndicator')))
    _UplinkInformationExchangeFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _UplinkInformationExchangeFailureIEs_val_Value_3 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _UplinkInformationExchangeFailureIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    UplinkInformationExchangeFailureIEs._val = ASN1Set(rv=[dict([('id', 136), ('criticality', 'ignore'), ('Value', _UplinkInformationExchangeFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 3), ('criticality', 'ignore'), ('Value', _UplinkInformationExchangeFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _UplinkInformationExchangeFailureIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _UplinkInformationExchangeFailureIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _UplinkInformationExchangeFailureIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UplinkInformationExchangeFailureExtensions >-----#
    UplinkInformationExchangeFailureExtensions = CLASS(name='UplinkInformationExchangeFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UplinkInformationExchangeFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStart >-----#
    MBMSSessionStart = SEQ(name='MBMSSessionStart', mode=MODE_TYPE)
    _MBMSSessionStart_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionStart_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionStart_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSSessionStart_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionIdentity')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSBearerServiceType')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionDuration')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSServiceArea')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'FrequenceLayerConvergenceFlag')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_9 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAListofIdleModeUEs')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_11 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionRepetitionNumber')))
    _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_12 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TimeToMBMSDataTransfer')))
    ____MBMSSessionStart_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'reject'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'ignore'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 143), ('criticality', 'reject'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 79), ('criticality', 'reject'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_3), ('presence', 'mandatory')]), dict([('id', 149), ('criticality', 'reject'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_4), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'ignore'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_5), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'reject'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_6), ('presence', 'mandatory')]), dict([('id', 145), ('criticality', 'reject'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_7), ('presence', 'mandatory')]), dict([('id', 135), ('criticality', 'ignore'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_8), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'ignore'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_9), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_10), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_11), ('presence', 'optional')]), dict([('id', 163), ('criticality', 'reject'), ('Value', _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_12), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSSessionStart_protocolIEs__item__id._const_tab = ____MBMSSessionStart_protocolIEs__item__id_tab
    ___MBMSSessionStart_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionStart_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSSessionStart_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSSessionStart_protocolIEs__item__criticality._const_tab = ____MBMSSessionStart_protocolIEs__item__id_tab
    ___MBMSSessionStart_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionStart_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionStart_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSSessionStart_protocolIEs__item__value._const_tab = ____MBMSSessionStart_protocolIEs__item__id_tab
    ___MBMSSessionStart_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSSessionStart_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSSessionStart_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionStart_protocolIEs__item__id),
        ('criticality', ___MBMSSessionStart_protocolIEs__item__criticality),
        ('value', ___MBMSSessionStart_protocolIEs__item__value),
        ])
    __MBMSSessionStart_protocolIEs__item_._ext = None
    _MBMSSessionStart_protocolIEs._cont = __MBMSSessionStart_protocolIEs__item_
    _MBMSSessionStart_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionStart_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionStart_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionStart_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSSessionStart_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSCountingInformation')))
    _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSynchronisationInformation')))
    _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Session-Re-establishment-Indicator')))
    ____MBMSSessionStart_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 169), ('criticality', 'ignore'), ('Extension', _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')]), dict([('id', 201), ('criticality', 'ignore'), ('Extension', _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_1), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Extension', _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_2), ('presence', 'optional')]), dict([('id', 276), ('criticality', 'ignore'), ('Extension', _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionStart_protocolExtensions__item__id._const_tab = ____MBMSSessionStart_protocolExtensions__item__id_tab
    ___MBMSSessionStart_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionStart_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSSessionStart_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MBMSSessionStart_protocolExtensions__item__criticality._const_tab = ____MBMSSessionStart_protocolExtensions__item__id_tab
    ___MBMSSessionStart_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionStart_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionStart_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MBMSSessionStart_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionStart_protocolExtensions__item__id_tab
    ___MBMSSessionStart_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSSessionStart_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSSessionStart_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionStart_protocolExtensions__item__id),
        ('criticality', ___MBMSSessionStart_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSSessionStart_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionStart_protocolExtensions__item_._ext = None
    _MBMSSessionStart_protocolExtensions._cont = __MBMSSessionStart_protocolExtensions__item_
    _MBMSSessionStart_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionStart._cont = ASN1Dict([
        ('protocolIEs', _MBMSSessionStart_protocolIEs),
        ('protocolExtensions', _MBMSSessionStart_protocolExtensions),
        ])
    MBMSSessionStart._ext = []
    
    #-----< MBMSSessionStartIEs >-----#
    MBMSSessionStartIEs = CLASS(name='MBMSSessionStartIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionStartIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSSessionStartIEs_val_Value_1 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionIdentity')))
    _MBMSSessionStartIEs_val_Value_2 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSBearerServiceType')))
    _MBMSSessionStartIEs_val_Value_3 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _MBMSSessionStartIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAB-Parameters')))
    _MBMSSessionStartIEs_val_Value_5 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation')))
    _MBMSSessionStartIEs_val_Value_6 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionDuration')))
    _MBMSSessionStartIEs_val_Value_7 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSServiceArea')))
    _MBMSSessionStartIEs_val_Value_8 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'FrequenceLayerConvergenceFlag')))
    _MBMSSessionStartIEs_val_Value_9 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'RAListofIdleModeUEs')))
    _MBMSSessionStartIEs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _MBMSSessionStartIEs_val_Value_11 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSSessionRepetitionNumber')))
    _MBMSSessionStartIEs_val_Value_12 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TimeToMBMSDataTransfer')))
    MBMSSessionStartIEs._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'reject'), ('Value', _MBMSSessionStartIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 147), ('criticality', 'ignore'), ('Value', _MBMSSessionStartIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 143), ('criticality', 'reject'), ('Value', _MBMSSessionStartIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 79), ('criticality', 'reject'), ('Value', _MBMSSessionStartIEs_val_Value_3), ('presence', 'mandatory')]), dict([('id', 149), ('criticality', 'reject'), ('Value', _MBMSSessionStartIEs_val_Value_4), ('presence', 'mandatory')]), dict([('id', 148), ('criticality', 'ignore'), ('Value', _MBMSSessionStartIEs_val_Value_5), ('presence', 'optional')]), dict([('id', 146), ('criticality', 'reject'), ('Value', _MBMSSessionStartIEs_val_Value_6), ('presence', 'mandatory')]), dict([('id', 145), ('criticality', 'reject'), ('Value', _MBMSSessionStartIEs_val_Value_7), ('presence', 'mandatory')]), dict([('id', 135), ('criticality', 'ignore'), ('Value', _MBMSSessionStartIEs_val_Value_8), ('presence', 'optional')]), dict([('id', 150), ('criticality', 'ignore'), ('Value', _MBMSSessionStartIEs_val_Value_9), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _MBMSSessionStartIEs_val_Value_10), ('presence', 'optional')]), dict([('id', 157), ('criticality', 'ignore'), ('Value', _MBMSSessionStartIEs_val_Value_11), ('presence', 'optional')]), dict([('id', 163), ('criticality', 'reject'), ('Value', _MBMSSessionStartIEs_val_Value_12), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStartExtensions >-----#
    MBMSSessionStartExtensions = CLASS(name='MBMSSessionStartExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _MBMSSessionStartExtensions_val_Extension_0 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSCountingInformation')))
    _MBMSSessionStartExtensions_val_Extension_1 = SEQ(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSynchronisationInformation')))
    _MBMSSessionStartExtensions_val_Extension_2 = SEQ_OF(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PDP-TypeInformation-extension')))
    _MBMSSessionStartExtensions_val_Extension_3 = ENUM(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Session-Re-establishment-Indicator')))
    MBMSSessionStartExtensions._val = ASN1Set(rv=[dict([('id', 169), ('criticality', 'ignore'), ('Extension', _MBMSSessionStartExtensions_val_Extension_0), ('presence', 'optional')]), dict([('id', 201), ('criticality', 'ignore'), ('Extension', _MBMSSessionStartExtensions_val_Extension_1), ('presence', 'optional')]), dict([('id', 238), ('criticality', 'ignore'), ('Extension', _MBMSSessionStartExtensions_val_Extension_2), ('presence', 'optional')]), dict([('id', 276), ('criticality', 'ignore'), ('Extension', _MBMSSessionStartExtensions_val_Extension_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSynchronisationInformation >-----#
    MBMSSynchronisationInformation = SEQ(name='MBMSSynchronisationInformation', mode=MODE_TYPE)
    _MBMSSynchronisationInformation_mBMSHCIndicator = ENUM(name='mBMSHCIndicator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'MBMSHCIndicator')))
    _MBMSSynchronisationInformation_iPMulticastAddress = OCT_STR(name='iPMulticastAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    _MBMSSynchronisationInformation_gTPDLTEID = OCT_STR(name='gTPDLTEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'GTP-TEI')))
    _MBMSSynchronisationInformation_iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSynchronisationInformation_iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSynchronisationInformation_iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MBMSSynchronisationInformation_iE_Extensions__item__id_tab_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 236), ('criticality', 'reject'), ('Extension', _____MBMSSynchronisationInformation_iE_Extensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSSynchronisationInformation_iE_Extensions__item__id._const_tab = ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab
    ___MBMSSynchronisationInformation_iE_Extensions__item__id._const_tab_at = None
    ___MBMSSynchronisationInformation_iE_Extensions__item__id._const_tab_id = 'id'
    ___MBMSSynchronisationInformation_iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MBMSSynchronisationInformation_iE_Extensions__item__criticality._const_tab = ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab
    ___MBMSSynchronisationInformation_iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSynchronisationInformation_iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue._const_tab = ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab
    ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSSynchronisationInformation_iE_Extensions__item_._cont = ASN1Dict([
        ('id', ___MBMSSynchronisationInformation_iE_Extensions__item__id),
        ('criticality', ___MBMSSynchronisationInformation_iE_Extensions__item__criticality),
        ('extensionValue', ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue),
        ])
    __MBMSSynchronisationInformation_iE_Extensions__item_._ext = None
    _MBMSSynchronisationInformation_iE_Extensions._cont = __MBMSSynchronisationInformation_iE_Extensions__item_
    _MBMSSynchronisationInformation_iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSynchronisationInformation._cont = ASN1Dict([
        ('mBMSHCIndicator', _MBMSSynchronisationInformation_mBMSHCIndicator),
        ('iPMulticastAddress', _MBMSSynchronisationInformation_iPMulticastAddress),
        ('gTPDLTEID', _MBMSSynchronisationInformation_gTPDLTEID),
        ('iE-Extensions', _MBMSSynchronisationInformation_iE_Extensions),
        ])
    MBMSSynchronisationInformation._ext = []
    
    #-----< MBMSSynchronisationInformation-ExtIEs >-----#
    MBMSSynchronisationInformation_ExtIEs = CLASS(name='MBMSSynchronisationInformation-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _MBMSSynchronisationInformation_ExtIEs_val_Extension_0 = OCT_STR(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    MBMSSynchronisationInformation_ExtIEs._val = ASN1Set(rv=[dict([('id', 236), ('criticality', 'reject'), ('Extension', _MBMSSynchronisationInformation_ExtIEs_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStartResponse >-----#
    MBMSSessionStartResponse = SEQ(name='MBMSSessionStartResponse', mode=MODE_TYPE)
    _MBMSSessionStartResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionStartResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionStartResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSSessionStartResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSSessionStartResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'ignore'), ('Value', _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionStartResponse_protocolIEs__item__id._const_tab = ____MBMSSessionStartResponse_protocolIEs__item__id_tab
    ___MBMSSessionStartResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionStartResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSSessionStartResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSSessionStartResponse_protocolIEs__item__criticality._const_tab = ____MBMSSessionStartResponse_protocolIEs__item__id_tab
    ___MBMSSessionStartResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionStartResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionStartResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSSessionStartResponse_protocolIEs__item__value._const_tab = ____MBMSSessionStartResponse_protocolIEs__item__id_tab
    ___MBMSSessionStartResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSSessionStartResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSSessionStartResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionStartResponse_protocolIEs__item__id),
        ('criticality', ___MBMSSessionStartResponse_protocolIEs__item__criticality),
        ('value', ___MBMSSessionStartResponse_protocolIEs__item__value),
        ])
    __MBMSSessionStartResponse_protocolIEs__item_._ext = None
    _MBMSSessionStartResponse_protocolIEs._cont = __MBMSSessionStartResponse_protocolIEs__item_
    _MBMSSessionStartResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionStartResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionStartResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionStartResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSSessionStartResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartResponse_protocolExtensions__item__id._const_tab = ____MBMSSessionStartResponse_protocolExtensions__item__id_tab
    ___MBMSSessionStartResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionStartResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSSessionStartResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSSessionStartResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartResponse_protocolExtensions__item__criticality._const_tab = ____MBMSSessionStartResponse_protocolExtensions__item__criticality_tab
    ___MBMSSessionStartResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionStartResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSSessionStartResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionStartResponse_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSSessionStartResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionStartResponse_protocolExtensions__item__id),
        ('criticality', ___MBMSSessionStartResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionStartResponse_protocolExtensions__item_._ext = None
    _MBMSSessionStartResponse_protocolExtensions._cont = __MBMSSessionStartResponse_protocolExtensions__item_
    _MBMSSessionStartResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionStartResponse._cont = ASN1Dict([
        ('protocolIEs', _MBMSSessionStartResponse_protocolIEs),
        ('protocolExtensions', _MBMSSessionStartResponse_protocolExtensions),
        ])
    MBMSSessionStartResponse._ext = []
    
    #-----< MBMSSessionStartResponseIEs >-----#
    MBMSSessionStartResponseIEs = CLASS(name='MBMSSessionStartResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionStartResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    _MBMSSessionStartResponseIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSSessionStartResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSSessionStartResponseIEs._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'ignore'), ('Value', _MBMSSessionStartResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _MBMSSessionStartResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSSessionStartResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStartResponseExtensions >-----#
    MBMSSessionStartResponseExtensions = CLASS(name='MBMSSessionStartResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionStartResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStartFailure >-----#
    MBMSSessionStartFailure = SEQ(name='MBMSSessionStartFailure', mode=MODE_TYPE)
    _MBMSSessionStartFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionStartFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionStartFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSSessionStartFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSSessionStartFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionStartFailure_protocolIEs__item__id._const_tab = ____MBMSSessionStartFailure_protocolIEs__item__id_tab
    ___MBMSSessionStartFailure_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionStartFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSSessionStartFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSSessionStartFailure_protocolIEs__item__criticality._const_tab = ____MBMSSessionStartFailure_protocolIEs__item__id_tab
    ___MBMSSessionStartFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionStartFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionStartFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSSessionStartFailure_protocolIEs__item__value._const_tab = ____MBMSSessionStartFailure_protocolIEs__item__id_tab
    ___MBMSSessionStartFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSSessionStartFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSSessionStartFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionStartFailure_protocolIEs__item__id),
        ('criticality', ___MBMSSessionStartFailure_protocolIEs__item__criticality),
        ('value', ___MBMSSessionStartFailure_protocolIEs__item__value),
        ])
    __MBMSSessionStartFailure_protocolIEs__item_._ext = None
    _MBMSSessionStartFailure_protocolIEs._cont = __MBMSSessionStartFailure_protocolIEs__item_
    _MBMSSessionStartFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionStartFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionStartFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionStartFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSSessionStartFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartFailure_protocolExtensions__item__id._const_tab = ____MBMSSessionStartFailure_protocolExtensions__item__id_tab
    ___MBMSSessionStartFailure_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionStartFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSSessionStartFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSSessionStartFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartFailure_protocolExtensions__item__criticality._const_tab = ____MBMSSessionStartFailure_protocolExtensions__item__criticality_tab
    ___MBMSSessionStartFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionStartFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSSessionStartFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStartFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionStartFailure_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSSessionStartFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionStartFailure_protocolExtensions__item__id),
        ('criticality', ___MBMSSessionStartFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionStartFailure_protocolExtensions__item_._ext = None
    _MBMSSessionStartFailure_protocolExtensions._cont = __MBMSSessionStartFailure_protocolExtensions__item_
    _MBMSSessionStartFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionStartFailure._cont = ASN1Dict([
        ('protocolIEs', _MBMSSessionStartFailure_protocolIEs),
        ('protocolExtensions', _MBMSSessionStartFailure_protocolExtensions),
        ])
    MBMSSessionStartFailure._ext = []
    
    #-----< MBMSSessionStartFailureIEs >-----#
    MBMSSessionStartFailureIEs = CLASS(name='MBMSSessionStartFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionStartFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSSessionStartFailureIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSSessionStartFailureIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _MBMSSessionStartFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSSessionStartFailureIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStartFailureExtensions >-----#
    MBMSSessionStartFailureExtensions = CLASS(name='MBMSSessionStartFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionStartFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdate >-----#
    MBMSSessionUpdate = SEQ(name='MBMSSessionUpdate', mode=MODE_TYPE)
    _MBMSSessionUpdate_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionUpdate_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionUpdate_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSSessionUpdate_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DeltaRAListofIdleModeUEs')))
    ____MBMSSessionUpdate_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'reject'), ('Value', _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 134), ('criticality', 'reject'), ('Value', _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSSessionUpdate_protocolIEs__item__id._const_tab = ____MBMSSessionUpdate_protocolIEs__item__id_tab
    ___MBMSSessionUpdate_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionUpdate_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSSessionUpdate_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSSessionUpdate_protocolIEs__item__criticality._const_tab = ____MBMSSessionUpdate_protocolIEs__item__id_tab
    ___MBMSSessionUpdate_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdate_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionUpdate_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSSessionUpdate_protocolIEs__item__value._const_tab = ____MBMSSessionUpdate_protocolIEs__item__id_tab
    ___MBMSSessionUpdate_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdate_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSSessionUpdate_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionUpdate_protocolIEs__item__id),
        ('criticality', ___MBMSSessionUpdate_protocolIEs__item__criticality),
        ('value', ___MBMSSessionUpdate_protocolIEs__item__value),
        ])
    __MBMSSessionUpdate_protocolIEs__item_._ext = None
    _MBMSSessionUpdate_protocolIEs._cont = __MBMSSessionUpdate_protocolIEs__item_
    _MBMSSessionUpdate_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionUpdate_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionUpdate_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionUpdate_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSSessionUpdate_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdate_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdate_protocolExtensions__item__id._const_tab = ____MBMSSessionUpdate_protocolExtensions__item__id_tab
    ___MBMSSessionUpdate_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionUpdate_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSSessionUpdate_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSSessionUpdate_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdate_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdate_protocolExtensions__item__criticality._const_tab = ____MBMSSessionUpdate_protocolExtensions__item__criticality_tab
    ___MBMSSessionUpdate_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdate_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionUpdate_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSSessionUpdate_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdate_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdate_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionUpdate_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionUpdate_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdate_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSSessionUpdate_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionUpdate_protocolExtensions__item__id),
        ('criticality', ___MBMSSessionUpdate_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSSessionUpdate_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionUpdate_protocolExtensions__item_._ext = None
    _MBMSSessionUpdate_protocolExtensions._cont = __MBMSSessionUpdate_protocolExtensions__item_
    _MBMSSessionUpdate_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionUpdate._cont = ASN1Dict([
        ('protocolIEs', _MBMSSessionUpdate_protocolIEs),
        ('protocolExtensions', _MBMSSessionUpdate_protocolExtensions),
        ])
    MBMSSessionUpdate._ext = []
    
    #-----< MBMSSessionUpdateIEs >-----#
    MBMSSessionUpdateIEs = CLASS(name='MBMSSessionUpdateIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionUpdateIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _MBMSSessionUpdateIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'DeltaRAListofIdleModeUEs')))
    MBMSSessionUpdateIEs._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'reject'), ('Value', _MBMSSessionUpdateIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 134), ('criticality', 'reject'), ('Value', _MBMSSessionUpdateIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdateExtensions >-----#
    MBMSSessionUpdateExtensions = CLASS(name='MBMSSessionUpdateExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionUpdateExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdateResponse >-----#
    MBMSSessionUpdateResponse = SEQ(name='MBMSSessionUpdateResponse', mode=MODE_TYPE)
    _MBMSSessionUpdateResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionUpdateResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionUpdateResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'ignore'), ('Value', _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateResponse_protocolIEs__item__id._const_tab = ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab
    ___MBMSSessionUpdateResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionUpdateResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSSessionUpdateResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSSessionUpdateResponse_protocolIEs__item__criticality._const_tab = ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab
    ___MBMSSessionUpdateResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdateResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionUpdateResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSSessionUpdateResponse_protocolIEs__item__value._const_tab = ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab
    ___MBMSSessionUpdateResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdateResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSSessionUpdateResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionUpdateResponse_protocolIEs__item__id),
        ('criticality', ___MBMSSessionUpdateResponse_protocolIEs__item__criticality),
        ('value', ___MBMSSessionUpdateResponse_protocolIEs__item__value),
        ])
    __MBMSSessionUpdateResponse_protocolIEs__item_._ext = None
    _MBMSSessionUpdateResponse_protocolIEs._cont = __MBMSSessionUpdateResponse_protocolIEs__item_
    _MBMSSessionUpdateResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionUpdateResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionUpdateResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionUpdateResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateResponse_protocolExtensions__item__id._const_tab = ____MBMSSessionUpdateResponse_protocolExtensions__item__id_tab
    ___MBMSSessionUpdateResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionUpdateResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality._const_tab = ____MBMSSessionUpdateResponse_protocolExtensions__item__criticality_tab
    ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSSessionUpdateResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionUpdateResponse_protocolExtensions__item__id),
        ('criticality', ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionUpdateResponse_protocolExtensions__item_._ext = None
    _MBMSSessionUpdateResponse_protocolExtensions._cont = __MBMSSessionUpdateResponse_protocolExtensions__item_
    _MBMSSessionUpdateResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionUpdateResponse._cont = ASN1Dict([
        ('protocolIEs', _MBMSSessionUpdateResponse_protocolIEs),
        ('protocolExtensions', _MBMSSessionUpdateResponse_protocolExtensions),
        ])
    MBMSSessionUpdateResponse._ext = []
    
    #-----< MBMSSessionUpdateResponseIEs >-----#
    MBMSSessionUpdateResponseIEs = CLASS(name='MBMSSessionUpdateResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionUpdateResponseIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _MBMSSessionUpdateResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    _MBMSSessionUpdateResponseIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSSessionUpdateResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSSessionUpdateResponseIEs._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'ignore'), ('Value', _MBMSSessionUpdateResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 154), ('criticality', 'ignore'), ('Value', _MBMSSessionUpdateResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _MBMSSessionUpdateResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSSessionUpdateResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdateResponseExtensions >-----#
    MBMSSessionUpdateResponseExtensions = CLASS(name='MBMSSessionUpdateResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionUpdateResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdateFailure >-----#
    MBMSSessionUpdateFailure = SEQ(name='MBMSSessionUpdateFailure', mode=MODE_TYPE)
    _MBMSSessionUpdateFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionUpdateFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionUpdateFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'ignore'), ('Value', _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateFailure_protocolIEs__item__id._const_tab = ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab
    ___MBMSSessionUpdateFailure_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionUpdateFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSSessionUpdateFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSSessionUpdateFailure_protocolIEs__item__criticality._const_tab = ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab
    ___MBMSSessionUpdateFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdateFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionUpdateFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSSessionUpdateFailure_protocolIEs__item__value._const_tab = ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab
    ___MBMSSessionUpdateFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdateFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSSessionUpdateFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionUpdateFailure_protocolIEs__item__id),
        ('criticality', ___MBMSSessionUpdateFailure_protocolIEs__item__criticality),
        ('value', ___MBMSSessionUpdateFailure_protocolIEs__item__value),
        ])
    __MBMSSessionUpdateFailure_protocolIEs__item_._ext = None
    _MBMSSessionUpdateFailure_protocolIEs._cont = __MBMSSessionUpdateFailure_protocolIEs__item_
    _MBMSSessionUpdateFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionUpdateFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionUpdateFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionUpdateFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateFailure_protocolExtensions__item__id._const_tab = ____MBMSSessionUpdateFailure_protocolExtensions__item__id_tab
    ___MBMSSessionUpdateFailure_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionUpdateFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality._const_tab = ____MBMSSessionUpdateFailure_protocolExtensions__item__criticality_tab
    ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSSessionUpdateFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionUpdateFailure_protocolExtensions__item__id),
        ('criticality', ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionUpdateFailure_protocolExtensions__item_._ext = None
    _MBMSSessionUpdateFailure_protocolExtensions._cont = __MBMSSessionUpdateFailure_protocolExtensions__item_
    _MBMSSessionUpdateFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionUpdateFailure._cont = ASN1Dict([
        ('protocolIEs', _MBMSSessionUpdateFailure_protocolIEs),
        ('protocolExtensions', _MBMSSessionUpdateFailure_protocolExtensions),
        ])
    MBMSSessionUpdateFailure._ext = []
    
    #-----< MBMSSessionUpdateFailureIEs >-----#
    MBMSSessionUpdateFailureIEs = CLASS(name='MBMSSessionUpdateFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionUpdateFailureIEs_val_Value_0 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SessionUpdateID')))
    _MBMSSessionUpdateFailureIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSSessionUpdateFailureIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSSessionUpdateFailureIEs._val = ASN1Set(rv=[dict([('id', 152), ('criticality', 'ignore'), ('Value', _MBMSSessionUpdateFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _MBMSSessionUpdateFailureIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSSessionUpdateFailureIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionUpdateFailureExtensions >-----#
    MBMSSessionUpdateFailureExtensions = CLASS(name='MBMSSessionUpdateFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionUpdateFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStop >-----#
    MBMSSessionStop = SEQ(name='MBMSSessionStop', mode=MODE_TYPE)
    _MBMSSessionStop_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionStop_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionStop_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSSessionStop_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionStop_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSCNDe-Registration')))
    ____MBMSSessionStop_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'reject'), ('Value', _____MBMSSessionStop_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSSessionStop_protocolIEs__item__id._const_tab = ____MBMSSessionStop_protocolIEs__item__id_tab
    ___MBMSSessionStop_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionStop_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSSessionStop_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSSessionStop_protocolIEs__item__criticality._const_tab = ____MBMSSessionStop_protocolIEs__item__id_tab
    ___MBMSSessionStop_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionStop_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionStop_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSSessionStop_protocolIEs__item__value._const_tab = ____MBMSSessionStop_protocolIEs__item__id_tab
    ___MBMSSessionStop_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSSessionStop_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSSessionStop_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionStop_protocolIEs__item__id),
        ('criticality', ___MBMSSessionStop_protocolIEs__item__criticality),
        ('value', ___MBMSSessionStop_protocolIEs__item__value),
        ])
    __MBMSSessionStop_protocolIEs__item_._ext = None
    _MBMSSessionStop_protocolIEs._cont = __MBMSSessionStop_protocolIEs__item_
    _MBMSSessionStop_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionStop_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionStop_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionStop_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSSessionStop_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStop_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStop_protocolExtensions__item__id._const_tab = ____MBMSSessionStop_protocolExtensions__item__id_tab
    ___MBMSSessionStop_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionStop_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSSessionStop_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSSessionStop_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStop_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStop_protocolExtensions__item__criticality._const_tab = ____MBMSSessionStop_protocolExtensions__item__criticality_tab
    ___MBMSSessionStop_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionStop_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionStop_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSSessionStop_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStop_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStop_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionStop_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionStop_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSSessionStop_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSSessionStop_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionStop_protocolExtensions__item__id),
        ('criticality', ___MBMSSessionStop_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSSessionStop_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionStop_protocolExtensions__item_._ext = None
    _MBMSSessionStop_protocolExtensions._cont = __MBMSSessionStop_protocolExtensions__item_
    _MBMSSessionStop_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionStop._cont = ASN1Dict([
        ('protocolIEs', _MBMSSessionStop_protocolIEs),
        ('protocolExtensions', _MBMSSessionStop_protocolExtensions),
        ])
    MBMSSessionStop._ext = []
    
    #-----< MBMSSessionStopIEs >-----#
    MBMSSessionStopIEs = CLASS(name='MBMSSessionStopIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionStopIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSCNDe-Registration')))
    MBMSSessionStopIEs._val = ASN1Set(rv=[dict([('id', 144), ('criticality', 'reject'), ('Value', _MBMSSessionStopIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStopExtensions >-----#
    MBMSSessionStopExtensions = CLASS(name='MBMSSessionStopExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionStopExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStopResponse >-----#
    MBMSSessionStopResponse = SEQ(name='MBMSSessionStopResponse', mode=MODE_TYPE)
    _MBMSSessionStopResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSSessionStopResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSSessionStopResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSSessionStopResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSSessionStopResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSSessionStopResponse_protocolIEs__item__id._const_tab = ____MBMSSessionStopResponse_protocolIEs__item__id_tab
    ___MBMSSessionStopResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSSessionStopResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSSessionStopResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSSessionStopResponse_protocolIEs__item__criticality._const_tab = ____MBMSSessionStopResponse_protocolIEs__item__id_tab
    ___MBMSSessionStopResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionStopResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionStopResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSSessionStopResponse_protocolIEs__item__value._const_tab = ____MBMSSessionStopResponse_protocolIEs__item__id_tab
    ___MBMSSessionStopResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSSessionStopResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSSessionStopResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionStopResponse_protocolIEs__item__id),
        ('criticality', ___MBMSSessionStopResponse_protocolIEs__item__criticality),
        ('value', ___MBMSSessionStopResponse_protocolIEs__item__value),
        ])
    __MBMSSessionStopResponse_protocolIEs__item_._ext = None
    _MBMSSessionStopResponse_protocolIEs._cont = __MBMSSessionStopResponse_protocolIEs__item_
    _MBMSSessionStopResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSSessionStopResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSSessionStopResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSSessionStopResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSSessionStopResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStopResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStopResponse_protocolExtensions__item__id._const_tab = ____MBMSSessionStopResponse_protocolExtensions__item__id_tab
    ___MBMSSessionStopResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSSessionStopResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSSessionStopResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSSessionStopResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStopResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStopResponse_protocolExtensions__item__criticality._const_tab = ____MBMSSessionStopResponse_protocolExtensions__item__criticality_tab
    ___MBMSSessionStopResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSSessionStopResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSSessionStopResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSSessionStopResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSSessionStopResponse_protocolExtensions__item__extensionValue_tab
    ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSSessionStopResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSSessionStopResponse_protocolExtensions__item__id),
        ('criticality', ___MBMSSessionStopResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSSessionStopResponse_protocolExtensions__item_._ext = None
    _MBMSSessionStopResponse_protocolExtensions._cont = __MBMSSessionStopResponse_protocolExtensions__item_
    _MBMSSessionStopResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSSessionStopResponse._cont = ASN1Dict([
        ('protocolIEs', _MBMSSessionStopResponse_protocolIEs),
        ('protocolExtensions', _MBMSSessionStopResponse_protocolExtensions),
        ])
    MBMSSessionStopResponse._ext = []
    
    #-----< MBMSSessionStopResponseIEs >-----#
    MBMSSessionStopResponseIEs = CLASS(name='MBMSSessionStopResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSSessionStopResponseIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSSessionStopResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSSessionStopResponseIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _MBMSSessionStopResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSSessionStopResponseIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSSessionStopResponseExtensions >-----#
    MBMSSessionStopResponseExtensions = CLASS(name='MBMSSessionStopResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSSessionStopResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSUELinkingRequest >-----#
    MBMSUELinkingRequest = SEQ(name='MBMSUELinkingRequest', mode=MODE_TYPE)
    _MBMSUELinkingRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSUELinkingRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSUELinkingRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSUELinkingRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'JoinedMBMSBearerService-IEs')))
    _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LeftMBMSBearerService-IEs')))
    ____MBMSUELinkingRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 141), ('criticality', 'reject'), ('Value', _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'reject'), ('Value', _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSUELinkingRequest_protocolIEs__item__id._const_tab = ____MBMSUELinkingRequest_protocolIEs__item__id_tab
    ___MBMSUELinkingRequest_protocolIEs__item__id._const_tab_at = None
    ___MBMSUELinkingRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSUELinkingRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSUELinkingRequest_protocolIEs__item__criticality._const_tab = ____MBMSUELinkingRequest_protocolIEs__item__id_tab
    ___MBMSUELinkingRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSUELinkingRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSUELinkingRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSUELinkingRequest_protocolIEs__item__value._const_tab = ____MBMSUELinkingRequest_protocolIEs__item__id_tab
    ___MBMSUELinkingRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSUELinkingRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSUELinkingRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSUELinkingRequest_protocolIEs__item__id),
        ('criticality', ___MBMSUELinkingRequest_protocolIEs__item__criticality),
        ('value', ___MBMSUELinkingRequest_protocolIEs__item__value),
        ])
    __MBMSUELinkingRequest_protocolIEs__item_._ext = None
    _MBMSUELinkingRequest_protocolIEs._cont = __MBMSUELinkingRequest_protocolIEs__item_
    _MBMSUELinkingRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSUELinkingRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSUELinkingRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSUELinkingRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSUELinkingRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingRequest_protocolExtensions__item__id._const_tab = ____MBMSUELinkingRequest_protocolExtensions__item__id_tab
    ___MBMSUELinkingRequest_protocolExtensions__item__id._const_tab_at = None
    ___MBMSUELinkingRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSUELinkingRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSUELinkingRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingRequest_protocolExtensions__item__criticality._const_tab = ____MBMSUELinkingRequest_protocolExtensions__item__criticality_tab
    ___MBMSUELinkingRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSUELinkingRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSUELinkingRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue._const_tab = ____MBMSUELinkingRequest_protocolExtensions__item__extensionValue_tab
    ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSUELinkingRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSUELinkingRequest_protocolExtensions__item__id),
        ('criticality', ___MBMSUELinkingRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue),
        ])
    __MBMSUELinkingRequest_protocolExtensions__item_._ext = None
    _MBMSUELinkingRequest_protocolExtensions._cont = __MBMSUELinkingRequest_protocolExtensions__item_
    _MBMSUELinkingRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSUELinkingRequest._cont = ASN1Dict([
        ('protocolIEs', _MBMSUELinkingRequest_protocolIEs),
        ('protocolExtensions', _MBMSUELinkingRequest_protocolExtensions),
        ])
    MBMSUELinkingRequest._ext = []
    
    #-----< MBMSUELinkingRequestIEs >-----#
    MBMSUELinkingRequestIEs = CLASS(name='MBMSUELinkingRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSUELinkingRequestIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'JoinedMBMSBearerService-IEs')))
    _MBMSUELinkingRequestIEs_val_Value_1 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LeftMBMSBearerService-IEs')))
    MBMSUELinkingRequestIEs._val = ASN1Set(rv=[dict([('id', 141), ('criticality', 'reject'), ('Value', _MBMSUELinkingRequestIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 142), ('criticality', 'reject'), ('Value', _MBMSUELinkingRequestIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< LeftMBMSBearerService-IEs >-----#
    LeftMBMSBearerService_IEs = SEQ_OF(name='LeftMBMSBearerService-IEs', mode=MODE_TYPE)
    _LeftMBMSBearerService_IEs__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __LeftMBMSBearerService_IEs__item__tMGI = SEQ(name='tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    __LeftMBMSBearerService_IEs__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___LeftMBMSBearerService_IEs__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab = _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id_tab
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab_at = None
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab = _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab = _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___LeftMBMSBearerService_IEs__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id),
        ('criticality', ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality),
        ('extensionValue', ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue),
        ])
    ___LeftMBMSBearerService_IEs__item__iE_Extensions__item_._ext = None
    __LeftMBMSBearerService_IEs__item__iE_Extensions._cont = ___LeftMBMSBearerService_IEs__item__iE_Extensions__item_
    __LeftMBMSBearerService_IEs__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _LeftMBMSBearerService_IEs__item_._cont = ASN1Dict([
        ('tMGI', __LeftMBMSBearerService_IEs__item__tMGI),
        ('iE-Extensions', __LeftMBMSBearerService_IEs__item__iE_Extensions),
        ])
    _LeftMBMSBearerService_IEs__item_._ext = []
    LeftMBMSBearerService_IEs._cont = _LeftMBMSBearerService_IEs__item_
    LeftMBMSBearerService_IEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< LeftMBMSBearerService-ExtIEs >-----#
    LeftMBMSBearerService_ExtIEs = CLASS(name='LeftMBMSBearerService-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    LeftMBMSBearerService_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSUELinkingRequestExtensions >-----#
    MBMSUELinkingRequestExtensions = CLASS(name='MBMSUELinkingRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSUELinkingRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSUELinkingResponse >-----#
    MBMSUELinkingResponse = SEQ(name='MBMSUELinkingResponse', mode=MODE_TYPE)
    _MBMSUELinkingResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSUELinkingResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSUELinkingResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSUELinkingResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UnsuccessfulLinking-IEs')))
    _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSUELinkingResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'ignore'), ('Value', _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSUELinkingResponse_protocolIEs__item__id._const_tab = ____MBMSUELinkingResponse_protocolIEs__item__id_tab
    ___MBMSUELinkingResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSUELinkingResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSUELinkingResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSUELinkingResponse_protocolIEs__item__criticality._const_tab = ____MBMSUELinkingResponse_protocolIEs__item__id_tab
    ___MBMSUELinkingResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSUELinkingResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSUELinkingResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSUELinkingResponse_protocolIEs__item__value._const_tab = ____MBMSUELinkingResponse_protocolIEs__item__id_tab
    ___MBMSUELinkingResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSUELinkingResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSUELinkingResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSUELinkingResponse_protocolIEs__item__id),
        ('criticality', ___MBMSUELinkingResponse_protocolIEs__item__criticality),
        ('value', ___MBMSUELinkingResponse_protocolIEs__item__value),
        ])
    __MBMSUELinkingResponse_protocolIEs__item_._ext = None
    _MBMSUELinkingResponse_protocolIEs._cont = __MBMSUELinkingResponse_protocolIEs__item_
    _MBMSUELinkingResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSUELinkingResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSUELinkingResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSUELinkingResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSUELinkingResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingResponse_protocolExtensions__item__id._const_tab = ____MBMSUELinkingResponse_protocolExtensions__item__id_tab
    ___MBMSUELinkingResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSUELinkingResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSUELinkingResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSUELinkingResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingResponse_protocolExtensions__item__criticality._const_tab = ____MBMSUELinkingResponse_protocolExtensions__item__criticality_tab
    ___MBMSUELinkingResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSUELinkingResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSUELinkingResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSUELinkingResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSUELinkingResponse_protocolExtensions__item__extensionValue_tab
    ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSUELinkingResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSUELinkingResponse_protocolExtensions__item__id),
        ('criticality', ___MBMSUELinkingResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSUELinkingResponse_protocolExtensions__item_._ext = None
    _MBMSUELinkingResponse_protocolExtensions._cont = __MBMSUELinkingResponse_protocolExtensions__item_
    _MBMSUELinkingResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSUELinkingResponse._cont = ASN1Dict([
        ('protocolIEs', _MBMSUELinkingResponse_protocolIEs),
        ('protocolExtensions', _MBMSUELinkingResponse_protocolExtensions),
        ])
    MBMSUELinkingResponse._ext = []
    
    #-----< MBMSUELinkingResponseIEs >-----#
    MBMSUELinkingResponseIEs = CLASS(name='MBMSUELinkingResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSUELinkingResponseIEs_val_Value_0 = SEQ_OF(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UnsuccessfulLinking-IEs')))
    _MBMSUELinkingResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSUELinkingResponseIEs._val = ASN1Set(rv=[dict([('id', 155), ('criticality', 'ignore'), ('Value', _MBMSUELinkingResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSUELinkingResponseIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< UnsuccessfulLinking-IEs >-----#
    UnsuccessfulLinking_IEs = SEQ_OF(name='UnsuccessfulLinking-IEs', mode=MODE_TYPE)
    _UnsuccessfulLinking_IEs__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __UnsuccessfulLinking_IEs__item__tMGI = SEQ(name='tMGI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    __UnsuccessfulLinking_IEs__item__cause = CHOICE(name='cause', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    __UnsuccessfulLinking_IEs__item__iE_Extensions = SEQ_OF(name='iE-Extensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    ___UnsuccessfulLinking_IEs__item__iE_Extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id._const_tab = _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id_tab
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id._const_tab_at = None
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id._const_tab_id = 'id'
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality._const_tab = _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality_tab
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality._const_tab_at = ('..', 'id')
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality._const_tab_id = 'criticality'
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue._const_tab = _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue_tab
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue._const_tab_at = ('..', 'id')
    ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue._const_tab_id = 'Extension'
    ___UnsuccessfulLinking_IEs__item__iE_Extensions__item_._cont = ASN1Dict([
        ('id', ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id),
        ('criticality', ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality),
        ('extensionValue', ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue),
        ])
    ___UnsuccessfulLinking_IEs__item__iE_Extensions__item_._ext = None
    __UnsuccessfulLinking_IEs__item__iE_Extensions._cont = ___UnsuccessfulLinking_IEs__item__iE_Extensions__item_
    __UnsuccessfulLinking_IEs__item__iE_Extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    _UnsuccessfulLinking_IEs__item_._cont = ASN1Dict([
        ('tMGI', __UnsuccessfulLinking_IEs__item__tMGI),
        ('cause', __UnsuccessfulLinking_IEs__item__cause),
        ('iE-Extensions', __UnsuccessfulLinking_IEs__item__iE_Extensions),
        ])
    _UnsuccessfulLinking_IEs__item_._ext = []
    UnsuccessfulLinking_IEs._cont = _UnsuccessfulLinking_IEs__item_
    UnsuccessfulLinking_IEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    
    #-----< UnsuccessfulLinking-ExtIEs >-----#
    UnsuccessfulLinking_ExtIEs = CLASS(name='UnsuccessfulLinking-ExtIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UnsuccessfulLinking_ExtIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSUELinkingResponseExtensions >-----#
    MBMSUELinkingResponseExtensions = CLASS(name='MBMSUELinkingResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSUELinkingResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationRequest >-----#
    MBMSRegistrationRequest = SEQ(name='MBMSRegistrationRequest', mode=MODE_TYPE)
    _MBMSRegistrationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRegistrationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRegistrationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSRegistrationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSRegistrationRequestType')))
    _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'APN')))
    _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    ____MBMSRegistrationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 151), ('criticality', 'reject'), ('Value', _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 153), ('criticality', 'reject'), ('Value', _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 140), ('criticality', 'reject'), ('Value', _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'conditional')]), dict([('id', 132), ('criticality', 'reject'), ('Value', _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'conditional')]), dict([('id', 86), ('criticality', 'reject'), ('Value', _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_4), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSRegistrationRequest_protocolIEs__item__id._const_tab = ____MBMSRegistrationRequest_protocolIEs__item__id_tab
    ___MBMSRegistrationRequest_protocolIEs__item__id._const_tab_at = None
    ___MBMSRegistrationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSRegistrationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSRegistrationRequest_protocolIEs__item__criticality._const_tab = ____MBMSRegistrationRequest_protocolIEs__item__id_tab
    ___MBMSRegistrationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRegistrationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSRegistrationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSRegistrationRequest_protocolIEs__item__value._const_tab = ____MBMSRegistrationRequest_protocolIEs__item__id_tab
    ___MBMSRegistrationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSRegistrationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSRegistrationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSRegistrationRequest_protocolIEs__item__id),
        ('criticality', ___MBMSRegistrationRequest_protocolIEs__item__criticality),
        ('value', ___MBMSRegistrationRequest_protocolIEs__item__value),
        ])
    __MBMSRegistrationRequest_protocolIEs__item_._ext = None
    _MBMSRegistrationRequest_protocolIEs._cont = __MBMSRegistrationRequest_protocolIEs__item_
    _MBMSRegistrationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRegistrationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRegistrationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRegistrationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSRegistrationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MBMSRegistrationRequest_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____MBMSRegistrationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _____MBMSRegistrationRequest_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSRegistrationRequest_protocolExtensions__item__id._const_tab = ____MBMSRegistrationRequest_protocolExtensions__item__id_tab
    ___MBMSRegistrationRequest_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRegistrationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSRegistrationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MBMSRegistrationRequest_protocolExtensions__item__criticality._const_tab = ____MBMSRegistrationRequest_protocolExtensions__item__id_tab
    ___MBMSRegistrationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRegistrationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue._const_tab = ____MBMSRegistrationRequest_protocolExtensions__item__id_tab
    ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSRegistrationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSRegistrationRequest_protocolExtensions__item__id),
        ('criticality', ___MBMSRegistrationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue),
        ])
    __MBMSRegistrationRequest_protocolExtensions__item_._ext = None
    _MBMSRegistrationRequest_protocolExtensions._cont = __MBMSRegistrationRequest_protocolExtensions__item_
    _MBMSRegistrationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRegistrationRequest._cont = ASN1Dict([
        ('protocolIEs', _MBMSRegistrationRequest_protocolIEs),
        ('protocolExtensions', _MBMSRegistrationRequest_protocolExtensions),
        ])
    MBMSRegistrationRequest._ext = []
    
    #-----< MBMSRegistrationRequestIEs >-----#
    MBMSRegistrationRequestIEs = CLASS(name='MBMSRegistrationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRegistrationRequestIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'MBMSRegistrationRequestType')))
    _MBMSRegistrationRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSRegistrationRequestIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IPMulticastAddress')))
    _MBMSRegistrationRequestIEs_val_Value_3 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'APN')))
    _MBMSRegistrationRequestIEs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    MBMSRegistrationRequestIEs._val = ASN1Set(rv=[dict([('id', 151), ('criticality', 'reject'), ('Value', _MBMSRegistrationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 153), ('criticality', 'reject'), ('Value', _MBMSRegistrationRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 140), ('criticality', 'reject'), ('Value', _MBMSRegistrationRequestIEs_val_Value_2), ('presence', 'conditional')]), dict([('id', 132), ('criticality', 'reject'), ('Value', _MBMSRegistrationRequestIEs_val_Value_3), ('presence', 'conditional')]), dict([('id', 86), ('criticality', 'reject'), ('Value', _MBMSRegistrationRequestIEs_val_Value_4), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationRequestExtensions >-----#
    MBMSRegistrationRequestExtensions = CLASS(name='MBMSRegistrationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _MBMSRegistrationRequestExtensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    MBMSRegistrationRequestExtensions._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _MBMSRegistrationRequestExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationResponse >-----#
    MBMSRegistrationResponse = SEQ(name='MBMSRegistrationResponse', mode=MODE_TYPE)
    _MBMSRegistrationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRegistrationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRegistrationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSRegistrationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSRegistrationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'ignore'), ('Value', _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSRegistrationResponse_protocolIEs__item__id._const_tab = ____MBMSRegistrationResponse_protocolIEs__item__id_tab
    ___MBMSRegistrationResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSRegistrationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSRegistrationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSRegistrationResponse_protocolIEs__item__criticality._const_tab = ____MBMSRegistrationResponse_protocolIEs__item__id_tab
    ___MBMSRegistrationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRegistrationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSRegistrationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSRegistrationResponse_protocolIEs__item__value._const_tab = ____MBMSRegistrationResponse_protocolIEs__item__id_tab
    ___MBMSRegistrationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSRegistrationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSRegistrationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSRegistrationResponse_protocolIEs__item__id),
        ('criticality', ___MBMSRegistrationResponse_protocolIEs__item__criticality),
        ('value', ___MBMSRegistrationResponse_protocolIEs__item__value),
        ])
    __MBMSRegistrationResponse_protocolIEs__item_._ext = None
    _MBMSRegistrationResponse_protocolIEs._cont = __MBMSRegistrationResponse_protocolIEs__item_
    _MBMSRegistrationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRegistrationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRegistrationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRegistrationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSRegistrationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationResponse_protocolExtensions__item__id._const_tab = ____MBMSRegistrationResponse_protocolExtensions__item__id_tab
    ___MBMSRegistrationResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRegistrationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSRegistrationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSRegistrationResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationResponse_protocolExtensions__item__criticality._const_tab = ____MBMSRegistrationResponse_protocolExtensions__item__criticality_tab
    ___MBMSRegistrationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRegistrationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSRegistrationResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSRegistrationResponse_protocolExtensions__item__extensionValue_tab
    ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSRegistrationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSRegistrationResponse_protocolExtensions__item__id),
        ('criticality', ___MBMSRegistrationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSRegistrationResponse_protocolExtensions__item_._ext = None
    _MBMSRegistrationResponse_protocolExtensions._cont = __MBMSRegistrationResponse_protocolExtensions__item_
    _MBMSRegistrationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRegistrationResponse._cont = ASN1Dict([
        ('protocolIEs', _MBMSRegistrationResponse_protocolIEs),
        ('protocolExtensions', _MBMSRegistrationResponse_protocolExtensions),
        ])
    MBMSRegistrationResponse._ext = []
    
    #-----< MBMSRegistrationResponseIEs >-----#
    MBMSRegistrationResponseIEs = CLASS(name='MBMSRegistrationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRegistrationResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSRegistrationResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _MBMSRegistrationResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSRegistrationResponseIEs._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'ignore'), ('Value', _MBMSRegistrationResponseIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _MBMSRegistrationResponseIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSRegistrationResponseIEs_val_Value_2), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationResponseExtensions >-----#
    MBMSRegistrationResponseExtensions = CLASS(name='MBMSRegistrationResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRegistrationResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationFailure >-----#
    MBMSRegistrationFailure = SEQ(name='MBMSRegistrationFailure', mode=MODE_TYPE)
    _MBMSRegistrationFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRegistrationFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRegistrationFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSRegistrationFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSRegistrationFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'ignore'), ('Value', _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSRegistrationFailure_protocolIEs__item__id._const_tab = ____MBMSRegistrationFailure_protocolIEs__item__id_tab
    ___MBMSRegistrationFailure_protocolIEs__item__id._const_tab_at = None
    ___MBMSRegistrationFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSRegistrationFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSRegistrationFailure_protocolIEs__item__criticality._const_tab = ____MBMSRegistrationFailure_protocolIEs__item__id_tab
    ___MBMSRegistrationFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRegistrationFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSRegistrationFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSRegistrationFailure_protocolIEs__item__value._const_tab = ____MBMSRegistrationFailure_protocolIEs__item__id_tab
    ___MBMSRegistrationFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSRegistrationFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSRegistrationFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSRegistrationFailure_protocolIEs__item__id),
        ('criticality', ___MBMSRegistrationFailure_protocolIEs__item__criticality),
        ('value', ___MBMSRegistrationFailure_protocolIEs__item__value),
        ])
    __MBMSRegistrationFailure_protocolIEs__item_._ext = None
    _MBMSRegistrationFailure_protocolIEs._cont = __MBMSRegistrationFailure_protocolIEs__item_
    _MBMSRegistrationFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRegistrationFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRegistrationFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRegistrationFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSRegistrationFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationFailure_protocolExtensions__item__id._const_tab = ____MBMSRegistrationFailure_protocolExtensions__item__id_tab
    ___MBMSRegistrationFailure_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRegistrationFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSRegistrationFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSRegistrationFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationFailure_protocolExtensions__item__criticality._const_tab = ____MBMSRegistrationFailure_protocolExtensions__item__criticality_tab
    ___MBMSRegistrationFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRegistrationFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSRegistrationFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRegistrationFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue._const_tab = ____MBMSRegistrationFailure_protocolExtensions__item__extensionValue_tab
    ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSRegistrationFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSRegistrationFailure_protocolExtensions__item__id),
        ('criticality', ___MBMSRegistrationFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue),
        ])
    __MBMSRegistrationFailure_protocolExtensions__item_._ext = None
    _MBMSRegistrationFailure_protocolExtensions._cont = __MBMSRegistrationFailure_protocolExtensions__item_
    _MBMSRegistrationFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRegistrationFailure._cont = ASN1Dict([
        ('protocolIEs', _MBMSRegistrationFailure_protocolIEs),
        ('protocolExtensions', _MBMSRegistrationFailure_protocolExtensions),
        ])
    MBMSRegistrationFailure._ext = []
    
    #-----< MBMSRegistrationFailureIEs >-----#
    MBMSRegistrationFailureIEs = CLASS(name='MBMSRegistrationFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRegistrationFailureIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSRegistrationFailureIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    _MBMSRegistrationFailureIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSRegistrationFailureIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSRegistrationFailureIEs._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'ignore'), ('Value', _MBMSRegistrationFailureIEs_val_Value_0), ('presence', 'optional')]), dict([('id', 96), ('criticality', 'ignore'), ('Value', _MBMSRegistrationFailureIEs_val_Value_1), ('presence', 'optional')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _MBMSRegistrationFailureIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSRegistrationFailureIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRegistrationFailureExtensions >-----#
    MBMSRegistrationFailureExtensions = CLASS(name='MBMSRegistrationFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRegistrationFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSCNDe-RegistrationRequest >-----#
    MBMSCNDe_RegistrationRequest = SEQ(name='MBMSCNDe-RegistrationRequest', mode=MODE_TYPE)
    _MBMSCNDe_RegistrationRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSCNDe_RegistrationRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'reject'), ('Value', _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id._const_tab = ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id._const_tab_at = None
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality._const_tab = ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value._const_tab = ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSCNDe_RegistrationRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id),
        ('criticality', ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality),
        ('value', ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value),
        ])
    __MBMSCNDe_RegistrationRequest_protocolIEs__item_._ext = None
    _MBMSCNDe_RegistrationRequest_protocolIEs._cont = __MBMSCNDe_RegistrationRequest_protocolIEs__item_
    _MBMSCNDe_RegistrationRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSCNDe_RegistrationRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSCNDe_RegistrationRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id._const_tab = ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__id_tab
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id._const_tab_at = None
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality._const_tab = ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality_tab
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue._const_tab = ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue_tab
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSCNDe_RegistrationRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id),
        ('criticality', ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue),
        ])
    __MBMSCNDe_RegistrationRequest_protocolExtensions__item_._ext = None
    _MBMSCNDe_RegistrationRequest_protocolExtensions._cont = __MBMSCNDe_RegistrationRequest_protocolExtensions__item_
    _MBMSCNDe_RegistrationRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSCNDe_RegistrationRequest._cont = ASN1Dict([
        ('protocolIEs', _MBMSCNDe_RegistrationRequest_protocolIEs),
        ('protocolExtensions', _MBMSCNDe_RegistrationRequest_protocolExtensions),
        ])
    MBMSCNDe_RegistrationRequest._ext = []
    
    #-----< MBMSCNDe-RegistrationRequestIEs >-----#
    MBMSCNDe_RegistrationRequestIEs = CLASS(name='MBMSCNDe-RegistrationRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSCNDe_RegistrationRequestIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSCNDe_RegistrationRequestIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalCN-ID')))
    MBMSCNDe_RegistrationRequestIEs._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'reject'), ('Value', _MBMSCNDe_RegistrationRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 96), ('criticality', 'reject'), ('Value', _MBMSCNDe_RegistrationRequestIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSCNDe-RegistrationRequestExtensions >-----#
    MBMSCNDe_RegistrationRequestExtensions = CLASS(name='MBMSCNDe-RegistrationRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSCNDe_RegistrationRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSCNDe-RegistrationResponse >-----#
    MBMSCNDe_RegistrationResponse = SEQ(name='MBMSCNDe-RegistrationResponse', mode=MODE_TYPE)
    _MBMSCNDe_RegistrationResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSCNDe_RegistrationResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'ignore'), ('Value', _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id._const_tab = ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id._const_tab_at = None
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality._const_tab = ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value._const_tab = ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSCNDe_RegistrationResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id),
        ('criticality', ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality),
        ('value', ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value),
        ])
    __MBMSCNDe_RegistrationResponse_protocolIEs__item_._ext = None
    _MBMSCNDe_RegistrationResponse_protocolIEs._cont = __MBMSCNDe_RegistrationResponse_protocolIEs__item_
    _MBMSCNDe_RegistrationResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSCNDe_RegistrationResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSCNDe_RegistrationResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab_val_Extension_0), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id._const_tab = ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id._const_tab_at = None
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality._const_tab = ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue._const_tab = ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSCNDe_RegistrationResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id),
        ('criticality', ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue),
        ])
    __MBMSCNDe_RegistrationResponse_protocolExtensions__item_._ext = None
    _MBMSCNDe_RegistrationResponse_protocolExtensions._cont = __MBMSCNDe_RegistrationResponse_protocolExtensions__item_
    _MBMSCNDe_RegistrationResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSCNDe_RegistrationResponse._cont = ASN1Dict([
        ('protocolIEs', _MBMSCNDe_RegistrationResponse_protocolIEs),
        ('protocolExtensions', _MBMSCNDe_RegistrationResponse_protocolExtensions),
        ])
    MBMSCNDe_RegistrationResponse._ext = []
    
    #-----< MBMSCNDe-RegistrationResponseIEs >-----#
    MBMSCNDe_RegistrationResponseIEs = CLASS(name='MBMSCNDe-RegistrationResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSCNDe_RegistrationResponseIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'TMGI')))
    _MBMSCNDe_RegistrationResponseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'GlobalRNC-ID')))
    _MBMSCNDe_RegistrationResponseIEs_val_Value_2 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSCNDe_RegistrationResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSCNDe_RegistrationResponseIEs._val = ASN1Set(rv=[dict([('id', 153), ('criticality', 'ignore'), ('Value', _MBMSCNDe_RegistrationResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 86), ('criticality', 'ignore'), ('Value', _MBMSCNDe_RegistrationResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 4), ('criticality', 'ignore'), ('Value', _MBMSCNDe_RegistrationResponseIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSCNDe_RegistrationResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSCNDe-RegistrationResponseExtensions >-----#
    MBMSCNDe_RegistrationResponseExtensions = CLASS(name='MBMSCNDe-RegistrationResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    _MBMSCNDe_RegistrationResponseExtensions_val_Extension_0 = INT(name='Extension', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'ExtendedRNC-ID')))
    MBMSCNDe_RegistrationResponseExtensions._val = ASN1Set(rv=[dict([('id', 171), ('criticality', 'reject'), ('Extension', _MBMSCNDe_RegistrationResponseExtensions_val_Extension_0), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRABEstablishmentIndication >-----#
    MBMSRABEstablishmentIndication = SEQ(name='MBMSRABEstablishmentIndication', mode=MODE_TYPE)
    _MBMSRABEstablishmentIndication_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRABEstablishmentIndication_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRABEstablishmentIndication_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'ignore'), ('Value', _____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSRABEstablishmentIndication_protocolIEs__item__id._const_tab = ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab
    ___MBMSRABEstablishmentIndication_protocolIEs__item__id._const_tab_at = None
    ___MBMSRABEstablishmentIndication_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality._const_tab = ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab
    ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSRABEstablishmentIndication_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSRABEstablishmentIndication_protocolIEs__item__value._const_tab = ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab
    ___MBMSRABEstablishmentIndication_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSRABEstablishmentIndication_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSRABEstablishmentIndication_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSRABEstablishmentIndication_protocolIEs__item__id),
        ('criticality', ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality),
        ('value', ___MBMSRABEstablishmentIndication_protocolIEs__item__value),
        ])
    __MBMSRABEstablishmentIndication_protocolIEs__item_._ext = None
    _MBMSRABEstablishmentIndication_protocolIEs._cont = __MBMSRABEstablishmentIndication_protocolIEs__item_
    _MBMSRABEstablishmentIndication_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRABEstablishmentIndication_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRABEstablishmentIndication_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__id._const_tab = ____MBMSRABEstablishmentIndication_protocolExtensions__item__id_tab
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality._const_tab = ____MBMSRABEstablishmentIndication_protocolExtensions__item__criticality_tab
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue._const_tab = ____MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue_tab
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSRABEstablishmentIndication_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSRABEstablishmentIndication_protocolExtensions__item__id),
        ('criticality', ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue),
        ])
    __MBMSRABEstablishmentIndication_protocolExtensions__item_._ext = None
    _MBMSRABEstablishmentIndication_protocolExtensions._cont = __MBMSRABEstablishmentIndication_protocolExtensions__item_
    _MBMSRABEstablishmentIndication_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRABEstablishmentIndication._cont = ASN1Dict([
        ('protocolIEs', _MBMSRABEstablishmentIndication_protocolIEs),
        ('protocolExtensions', _MBMSRABEstablishmentIndication_protocolExtensions),
        ])
    MBMSRABEstablishmentIndication._ext = []
    
    #-----< MBMSRABEstablishmentIndicationIEs >-----#
    MBMSRABEstablishmentIndicationIEs = CLASS(name='MBMSRABEstablishmentIndicationIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRABEstablishmentIndicationIEs_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'TransportLayerInformation')))
    MBMSRABEstablishmentIndicationIEs._val = ASN1Set(rv=[dict([('id', 154), ('criticality', 'ignore'), ('Value', _MBMSRABEstablishmentIndicationIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRABEstablishmentIndicationExtensions >-----#
    MBMSRABEstablishmentIndicationExtensions = CLASS(name='MBMSRABEstablishmentIndicationExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRABEstablishmentIndicationExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSRABReleaseRequest >-----#
    MBMSRABReleaseRequest = SEQ(name='MBMSRABReleaseRequest', mode=MODE_TYPE)
    _MBMSRABReleaseRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRABReleaseRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRABReleaseRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSRABReleaseRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRABReleaseRequest_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    ____MBMSRABReleaseRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____MBMSRABReleaseRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___MBMSRABReleaseRequest_protocolIEs__item__id._const_tab = ____MBMSRABReleaseRequest_protocolIEs__item__id_tab
    ___MBMSRABReleaseRequest_protocolIEs__item__id._const_tab_at = None
    ___MBMSRABReleaseRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSRABReleaseRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSRABReleaseRequest_protocolIEs__item__criticality._const_tab = ____MBMSRABReleaseRequest_protocolIEs__item__id_tab
    ___MBMSRABReleaseRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRABReleaseRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSRABReleaseRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSRABReleaseRequest_protocolIEs__item__value._const_tab = ____MBMSRABReleaseRequest_protocolIEs__item__id_tab
    ___MBMSRABReleaseRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSRABReleaseRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSRABReleaseRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSRABReleaseRequest_protocolIEs__item__id),
        ('criticality', ___MBMSRABReleaseRequest_protocolIEs__item__criticality),
        ('value', ___MBMSRABReleaseRequest_protocolIEs__item__value),
        ])
    __MBMSRABReleaseRequest_protocolIEs__item_._ext = None
    _MBMSRABReleaseRequest_protocolIEs._cont = __MBMSRABReleaseRequest_protocolIEs__item_
    _MBMSRABReleaseRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRABReleaseRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRABReleaseRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRABReleaseRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSRABReleaseRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseRequest_protocolExtensions__item__id._const_tab = ____MBMSRABReleaseRequest_protocolExtensions__item__id_tab
    ___MBMSRABReleaseRequest_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRABReleaseRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSRABReleaseRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSRABReleaseRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseRequest_protocolExtensions__item__criticality._const_tab = ____MBMSRABReleaseRequest_protocolExtensions__item__criticality_tab
    ___MBMSRABReleaseRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRABReleaseRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSRABReleaseRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue._const_tab = ____MBMSRABReleaseRequest_protocolExtensions__item__extensionValue_tab
    ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSRABReleaseRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSRABReleaseRequest_protocolExtensions__item__id),
        ('criticality', ___MBMSRABReleaseRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue),
        ])
    __MBMSRABReleaseRequest_protocolExtensions__item_._ext = None
    _MBMSRABReleaseRequest_protocolExtensions._cont = __MBMSRABReleaseRequest_protocolExtensions__item_
    _MBMSRABReleaseRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRABReleaseRequest._cont = ASN1Dict([
        ('protocolIEs', _MBMSRABReleaseRequest_protocolIEs),
        ('protocolExtensions', _MBMSRABReleaseRequest_protocolExtensions),
        ])
    MBMSRABReleaseRequest._ext = []
    
    #-----< MBMSRABReleaseRequestIEs >-----#
    MBMSRABReleaseRequestIEs = CLASS(name='MBMSRABReleaseRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRABReleaseRequestIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    MBMSRABReleaseRequestIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _MBMSRABReleaseRequestIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRABReleaseRequestExtensions >-----#
    MBMSRABReleaseRequestExtensions = CLASS(name='MBMSRABReleaseRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRABReleaseRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSRABRelease >-----#
    MBMSRABRelease = SEQ(name='MBMSRABRelease', mode=MODE_TYPE)
    _MBMSRABRelease_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRABRelease_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRABRelease_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSRABRelease_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSRABRelease_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSRABRelease_protocolIEs__item__id._const_tab = ____MBMSRABRelease_protocolIEs__item__id_tab
    ___MBMSRABRelease_protocolIEs__item__id._const_tab_at = None
    ___MBMSRABRelease_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSRABRelease_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSRABRelease_protocolIEs__item__criticality._const_tab = ____MBMSRABRelease_protocolIEs__item__id_tab
    ___MBMSRABRelease_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRABRelease_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSRABRelease_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSRABRelease_protocolIEs__item__value._const_tab = ____MBMSRABRelease_protocolIEs__item__id_tab
    ___MBMSRABRelease_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSRABRelease_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSRABRelease_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSRABRelease_protocolIEs__item__id),
        ('criticality', ___MBMSRABRelease_protocolIEs__item__criticality),
        ('value', ___MBMSRABRelease_protocolIEs__item__value),
        ])
    __MBMSRABRelease_protocolIEs__item_._ext = None
    _MBMSRABRelease_protocolIEs._cont = __MBMSRABRelease_protocolIEs__item_
    _MBMSRABRelease_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRABRelease_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRABRelease_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRABRelease_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSRABRelease_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABRelease_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABRelease_protocolExtensions__item__id._const_tab = ____MBMSRABRelease_protocolExtensions__item__id_tab
    ___MBMSRABRelease_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRABRelease_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSRABRelease_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSRABRelease_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABRelease_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABRelease_protocolExtensions__item__criticality._const_tab = ____MBMSRABRelease_protocolExtensions__item__criticality_tab
    ___MBMSRABRelease_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRABRelease_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSRABRelease_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSRABRelease_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABRelease_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABRelease_protocolExtensions__item__extensionValue._const_tab = ____MBMSRABRelease_protocolExtensions__item__extensionValue_tab
    ___MBMSRABRelease_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSRABRelease_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSRABRelease_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSRABRelease_protocolExtensions__item__id),
        ('criticality', ___MBMSRABRelease_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSRABRelease_protocolExtensions__item__extensionValue),
        ])
    __MBMSRABRelease_protocolExtensions__item_._ext = None
    _MBMSRABRelease_protocolExtensions._cont = __MBMSRABRelease_protocolExtensions__item_
    _MBMSRABRelease_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRABRelease._cont = ASN1Dict([
        ('protocolIEs', _MBMSRABRelease_protocolIEs),
        ('protocolExtensions', _MBMSRABRelease_protocolExtensions),
        ])
    MBMSRABRelease._ext = []
    
    #-----< MBMSRABReleaseIEs >-----#
    MBMSRABReleaseIEs = CLASS(name='MBMSRABReleaseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRABReleaseIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSRABReleaseIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSRABReleaseIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _MBMSRABReleaseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSRABReleaseIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRABReleaseExtensions >-----#
    MBMSRABReleaseExtensions = CLASS(name='MBMSRABReleaseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRABReleaseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< MBMSRABReleaseFailure >-----#
    MBMSRABReleaseFailure = SEQ(name='MBMSRABReleaseFailure', mode=MODE_TYPE)
    _MBMSRABReleaseFailure_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __MBMSRABReleaseFailure_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___MBMSRABReleaseFailure_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____MBMSRABReleaseFailure_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____MBMSRABReleaseFailure_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_1), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___MBMSRABReleaseFailure_protocolIEs__item__id._const_tab = ____MBMSRABReleaseFailure_protocolIEs__item__id_tab
    ___MBMSRABReleaseFailure_protocolIEs__item__id._const_tab_at = None
    ___MBMSRABReleaseFailure_protocolIEs__item__id._const_tab_id = 'id'
    ___MBMSRABReleaseFailure_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___MBMSRABReleaseFailure_protocolIEs__item__criticality._const_tab = ____MBMSRABReleaseFailure_protocolIEs__item__id_tab
    ___MBMSRABReleaseFailure_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRABReleaseFailure_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___MBMSRABReleaseFailure_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___MBMSRABReleaseFailure_protocolIEs__item__value._const_tab = ____MBMSRABReleaseFailure_protocolIEs__item__id_tab
    ___MBMSRABReleaseFailure_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___MBMSRABReleaseFailure_protocolIEs__item__value._const_tab_id = 'Value'
    __MBMSRABReleaseFailure_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___MBMSRABReleaseFailure_protocolIEs__item__id),
        ('criticality', ___MBMSRABReleaseFailure_protocolIEs__item__criticality),
        ('value', ___MBMSRABReleaseFailure_protocolIEs__item__value),
        ])
    __MBMSRABReleaseFailure_protocolIEs__item_._ext = None
    _MBMSRABReleaseFailure_protocolIEs._cont = __MBMSRABReleaseFailure_protocolIEs__item_
    _MBMSRABReleaseFailure_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _MBMSRABReleaseFailure_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __MBMSRABReleaseFailure_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___MBMSRABReleaseFailure_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____MBMSRABReleaseFailure_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseFailure_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseFailure_protocolExtensions__item__id._const_tab = ____MBMSRABReleaseFailure_protocolExtensions__item__id_tab
    ___MBMSRABReleaseFailure_protocolExtensions__item__id._const_tab_at = None
    ___MBMSRABReleaseFailure_protocolExtensions__item__id._const_tab_id = 'id'
    ___MBMSRABReleaseFailure_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____MBMSRABReleaseFailure_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseFailure_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseFailure_protocolExtensions__item__criticality._const_tab = ____MBMSRABReleaseFailure_protocolExtensions__item__criticality_tab
    ___MBMSRABReleaseFailure_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___MBMSRABReleaseFailure_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____MBMSRABReleaseFailure_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____MBMSRABReleaseFailure_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue._const_tab = ____MBMSRABReleaseFailure_protocolExtensions__item__extensionValue_tab
    ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __MBMSRABReleaseFailure_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___MBMSRABReleaseFailure_protocolExtensions__item__id),
        ('criticality', ___MBMSRABReleaseFailure_protocolExtensions__item__criticality),
        ('extensionValue', ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue),
        ])
    __MBMSRABReleaseFailure_protocolExtensions__item_._ext = None
    _MBMSRABReleaseFailure_protocolExtensions._cont = __MBMSRABReleaseFailure_protocolExtensions__item_
    _MBMSRABReleaseFailure_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    MBMSRABReleaseFailure._cont = ASN1Dict([
        ('protocolIEs', _MBMSRABReleaseFailure_protocolIEs),
        ('protocolExtensions', _MBMSRABReleaseFailure_protocolExtensions),
        ])
    MBMSRABReleaseFailure._ext = []
    
    #-----< MBMSRABReleaseFailureIEs >-----#
    MBMSRABReleaseFailureIEs = CLASS(name='MBMSRABReleaseFailureIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _MBMSRABReleaseFailureIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'Cause')))
    _MBMSRABReleaseFailureIEs_val_Value_1 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    MBMSRABReleaseFailureIEs._val = ASN1Set(rv=[dict([('id', 4), ('criticality', 'ignore'), ('Value', _MBMSRABReleaseFailureIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _MBMSRABReleaseFailureIEs_val_Value_1), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< MBMSRABReleaseFailureExtensions >-----#
    MBMSRABReleaseFailureExtensions = CLASS(name='MBMSRABReleaseFailureExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    MBMSRABReleaseFailureExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCC-CSKeysRequest >-----#
    SRVCC_CSKeysRequest = SEQ(name='SRVCC-CSKeysRequest', mode=MODE_TYPE)
    _SRVCC_CSKeysRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SRVCC_CSKeysRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SRVCC_CSKeysRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____SRVCC_CSKeysRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____SRVCC_CSKeysRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolIEs__item__id._const_tab = ____SRVCC_CSKeysRequest_protocolIEs__item__id_tab
    ___SRVCC_CSKeysRequest_protocolIEs__item__id._const_tab_at = None
    ___SRVCC_CSKeysRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___SRVCC_CSKeysRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ____SRVCC_CSKeysRequest_protocolIEs__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____SRVCC_CSKeysRequest_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolIEs__item__criticality._const_tab = ____SRVCC_CSKeysRequest_protocolIEs__item__criticality_tab
    ___SRVCC_CSKeysRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SRVCC_CSKeysRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SRVCC_CSKeysRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ____SRVCC_CSKeysRequest_protocolIEs__item__value_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____SRVCC_CSKeysRequest_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolIEs__item__value._const_tab = ____SRVCC_CSKeysRequest_protocolIEs__item__value_tab
    ___SRVCC_CSKeysRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SRVCC_CSKeysRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __SRVCC_CSKeysRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SRVCC_CSKeysRequest_protocolIEs__item__id),
        ('criticality', ___SRVCC_CSKeysRequest_protocolIEs__item__criticality),
        ('value', ___SRVCC_CSKeysRequest_protocolIEs__item__value),
        ])
    __SRVCC_CSKeysRequest_protocolIEs__item_._ext = None
    _SRVCC_CSKeysRequest_protocolIEs._cont = __SRVCC_CSKeysRequest_protocolIEs__item_
    _SRVCC_CSKeysRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SRVCC_CSKeysRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRVCC_CSKeysRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRVCC_CSKeysRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolExtensions__item__id._const_tab = ____SRVCC_CSKeysRequest_protocolExtensions__item__id_tab
    ___SRVCC_CSKeysRequest_protocolExtensions__item__id._const_tab_at = None
    ___SRVCC_CSKeysRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality._const_tab = ____SRVCC_CSKeysRequest_protocolExtensions__item__criticality_tab
    ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue._const_tab = ____SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue_tab
    ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SRVCC_CSKeysRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SRVCC_CSKeysRequest_protocolExtensions__item__id),
        ('criticality', ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue),
        ])
    __SRVCC_CSKeysRequest_protocolExtensions__item_._ext = None
    _SRVCC_CSKeysRequest_protocolExtensions._cont = __SRVCC_CSKeysRequest_protocolExtensions__item_
    _SRVCC_CSKeysRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRVCC_CSKeysRequest._cont = ASN1Dict([
        ('protocolIEs', _SRVCC_CSKeysRequest_protocolIEs),
        ('protocolExtensions', _SRVCC_CSKeysRequest_protocolExtensions),
        ])
    SRVCC_CSKeysRequest._ext = []
    
    #-----< SRVCC-CSKeysRequestIEs >-----#
    SRVCC_CSKeysRequestIEs = CLASS(name='SRVCC-CSKeysRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    SRVCC_CSKeysRequestIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCC-CSKeysRequestExtensions >-----#
    SRVCC_CSKeysRequestExtensions = CLASS(name='SRVCC-CSKeysRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRVCC_CSKeysRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SRVCC-CSKeysResponse >-----#
    SRVCC_CSKeysResponse = SEQ(name='SRVCC-CSKeysResponse', mode=MODE_TYPE)
    _SRVCC_CSKeysResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __SRVCC_CSKeysResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___SRVCC_CSKeysResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionKey')))
    _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionKey')))
    _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 225), ('criticality', 'reject'), ('Value', _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 224), ('criticality', 'reject'), ('Value', _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 227), ('criticality', 'reject'), ('Value', _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_2), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysResponse_protocolIEs__item__id._const_tab = ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab
    ___SRVCC_CSKeysResponse_protocolIEs__item__id._const_tab_at = None
    ___SRVCC_CSKeysResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___SRVCC_CSKeysResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___SRVCC_CSKeysResponse_protocolIEs__item__criticality._const_tab = ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab
    ___SRVCC_CSKeysResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___SRVCC_CSKeysResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___SRVCC_CSKeysResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___SRVCC_CSKeysResponse_protocolIEs__item__value._const_tab = ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab
    ___SRVCC_CSKeysResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___SRVCC_CSKeysResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __SRVCC_CSKeysResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___SRVCC_CSKeysResponse_protocolIEs__item__id),
        ('criticality', ___SRVCC_CSKeysResponse_protocolIEs__item__criticality),
        ('value', ___SRVCC_CSKeysResponse_protocolIEs__item__value),
        ])
    __SRVCC_CSKeysResponse_protocolIEs__item_._ext = None
    _SRVCC_CSKeysResponse_protocolIEs._cont = __SRVCC_CSKeysResponse_protocolIEs__item_
    _SRVCC_CSKeysResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SRVCC_CSKeysResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __SRVCC_CSKeysResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___SRVCC_CSKeysResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysResponse_protocolExtensions__item__id._const_tab = ____SRVCC_CSKeysResponse_protocolExtensions__item__id_tab
    ___SRVCC_CSKeysResponse_protocolExtensions__item__id._const_tab_at = None
    ___SRVCC_CSKeysResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality._const_tab = ____SRVCC_CSKeysResponse_protocolExtensions__item__criticality_tab
    ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue._const_tab = ____SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue_tab
    ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __SRVCC_CSKeysResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___SRVCC_CSKeysResponse_protocolExtensions__item__id),
        ('criticality', ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue),
        ])
    __SRVCC_CSKeysResponse_protocolExtensions__item_._ext = None
    _SRVCC_CSKeysResponse_protocolExtensions._cont = __SRVCC_CSKeysResponse_protocolExtensions__item_
    _SRVCC_CSKeysResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    SRVCC_CSKeysResponse._cont = ASN1Dict([
        ('protocolIEs', _SRVCC_CSKeysResponse_protocolIEs),
        ('protocolExtensions', _SRVCC_CSKeysResponse_protocolExtensions),
        ])
    SRVCC_CSKeysResponse._ext = []
    
    #-----< SRVCC-CSKeysResponseIEs >-----#
    SRVCC_CSKeysResponseIEs = CLASS(name='SRVCC-CSKeysResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _SRVCC_CSKeysResponseIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IntegrityProtectionKey')))
    _SRVCC_CSKeysResponseIEs_val_Value_1 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'EncryptionKey')))
    _SRVCC_CSKeysResponseIEs_val_Value_2 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SRVCC-Information')))
    _SRVCC_CSKeysResponseIEs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'CriticalityDiagnostics')))
    SRVCC_CSKeysResponseIEs._val = ASN1Set(rv=[dict([('id', 225), ('criticality', 'reject'), ('Value', _SRVCC_CSKeysResponseIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 224), ('criticality', 'reject'), ('Value', _SRVCC_CSKeysResponseIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 227), ('criticality', 'reject'), ('Value', _SRVCC_CSKeysResponseIEs_val_Value_2), ('presence', 'mandatory')]), dict([('id', 9), ('criticality', 'ignore'), ('Value', _SRVCC_CSKeysResponseIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< SRVCC-CSKeysResponseExtensions >-----#
    SRVCC_CSKeysResponseExtensions = CLASS(name='SRVCC-CSKeysResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    SRVCC_CSKeysResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UeRadioCapabilityMatchRequest >-----#
    UeRadioCapabilityMatchRequest = SEQ(name='UeRadioCapabilityMatchRequest', mode=MODE_TYPE)
    _UeRadioCapabilityMatchRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UeRadioCapabilityMatchRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__id._const_tab = ____UeRadioCapabilityMatchRequest_protocolIEs__item__id_tab
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__id._const_tab_at = None
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab = ____UeRadioCapabilityMatchRequest_protocolIEs__item__criticality_tab
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__value_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    ____UeRadioCapabilityMatchRequest_protocolIEs__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__value._const_tab = ____UeRadioCapabilityMatchRequest_protocolIEs__item__value_tab
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UeRadioCapabilityMatchRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UeRadioCapabilityMatchRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UeRadioCapabilityMatchRequest_protocolIEs__item__id),
        ('criticality', ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality),
        ('value', ___UeRadioCapabilityMatchRequest_protocolIEs__item__value),
        ])
    __UeRadioCapabilityMatchRequest_protocolIEs__item_._ext = None
    _UeRadioCapabilityMatchRequest_protocolIEs._cont = __UeRadioCapabilityMatchRequest_protocolIEs__item_
    _UeRadioCapabilityMatchRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UeRadioCapabilityMatchRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UeRadioCapabilityMatchRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id._const_tab = ____UeRadioCapabilityMatchRequest_protocolExtensions__item__id_tab
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id._const_tab_at = None
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality._const_tab = ____UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality_tab
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue._const_tab = ____UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue_tab
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UeRadioCapabilityMatchRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id),
        ('criticality', ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue),
        ])
    __UeRadioCapabilityMatchRequest_protocolExtensions__item_._ext = None
    _UeRadioCapabilityMatchRequest_protocolExtensions._cont = __UeRadioCapabilityMatchRequest_protocolExtensions__item_
    _UeRadioCapabilityMatchRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UeRadioCapabilityMatchRequest._cont = ASN1Dict([
        ('protocolIEs', _UeRadioCapabilityMatchRequest_protocolIEs),
        ('protocolExtensions', _UeRadioCapabilityMatchRequest_protocolExtensions),
        ])
    UeRadioCapabilityMatchRequest._ext = []
    
    #-----< UeRadioCapabilityMatchRequestIEs >-----#
    UeRadioCapabilityMatchRequestIEs = CLASS(name='UeRadioCapabilityMatchRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    UeRadioCapabilityMatchRequestIEs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UeRadioCapabilityMatchRequestExtensions >-----#
    UeRadioCapabilityMatchRequestExtensions = CLASS(name='UeRadioCapabilityMatchRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UeRadioCapabilityMatchRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UeRadioCapabilityMatchResponse >-----#
    UeRadioCapabilityMatchResponse = SEQ(name='UeRadioCapabilityMatchResponse', mode=MODE_TYPE)
    _UeRadioCapabilityMatchResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UeRadioCapabilityMatchResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VoiceSupportMatchIndicator')))
    ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 258), ('criticality', 'reject'), ('Value', _____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__id._const_tab = ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__id._const_tab_at = None
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab = ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__value._const_tab = ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UeRadioCapabilityMatchResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UeRadioCapabilityMatchResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UeRadioCapabilityMatchResponse_protocolIEs__item__id),
        ('criticality', ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality),
        ('value', ___UeRadioCapabilityMatchResponse_protocolIEs__item__value),
        ])
    __UeRadioCapabilityMatchResponse_protocolIEs__item_._ext = None
    _UeRadioCapabilityMatchResponse_protocolIEs._cont = __UeRadioCapabilityMatchResponse_protocolIEs__item_
    _UeRadioCapabilityMatchResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UeRadioCapabilityMatchResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UeRadioCapabilityMatchResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id._const_tab = ____UeRadioCapabilityMatchResponse_protocolExtensions__item__id_tab
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id._const_tab_at = None
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality._const_tab = ____UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality_tab
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue._const_tab = ____UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue_tab
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UeRadioCapabilityMatchResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id),
        ('criticality', ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue),
        ])
    __UeRadioCapabilityMatchResponse_protocolExtensions__item_._ext = None
    _UeRadioCapabilityMatchResponse_protocolExtensions._cont = __UeRadioCapabilityMatchResponse_protocolExtensions__item_
    _UeRadioCapabilityMatchResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UeRadioCapabilityMatchResponse._cont = ASN1Dict([
        ('protocolIEs', _UeRadioCapabilityMatchResponse_protocolIEs),
        ('protocolExtensions', _UeRadioCapabilityMatchResponse_protocolExtensions),
        ])
    UeRadioCapabilityMatchResponse._ext = []
    
    #-----< UeRadioCapabilityMatchResponseIEs >-----#
    UeRadioCapabilityMatchResponseIEs = CLASS(name='UeRadioCapabilityMatchResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UeRadioCapabilityMatchResponseIEs_val_Value_0 = ENUM(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'VoiceSupportMatchIndicator')))
    UeRadioCapabilityMatchResponseIEs._val = ASN1Set(rv=[dict([('id', 258), ('criticality', 'reject'), ('Value', _UeRadioCapabilityMatchResponseIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UeRadioCapabilityMatchResponseExtensions >-----#
    UeRadioCapabilityMatchResponseExtensions = CLASS(name='UeRadioCapabilityMatchResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UeRadioCapabilityMatchResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UeRegistrationQueryRequest >-----#
    UeRegistrationQueryRequest = SEQ(name='UeRegistrationQueryRequest', mode=MODE_TYPE)
    _UeRegistrationQueryRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UeRegistrationQueryRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UeRegistrationQueryRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____UeRegistrationQueryRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    ____UeRegistrationQueryRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 79), ('criticality', 'ignore'), ('Value', _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UeRegistrationQueryRequest_protocolIEs__item__id._const_tab = ____UeRegistrationQueryRequest_protocolIEs__item__id_tab
    ___UeRegistrationQueryRequest_protocolIEs__item__id._const_tab_at = None
    ___UeRegistrationQueryRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___UeRegistrationQueryRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___UeRegistrationQueryRequest_protocolIEs__item__criticality._const_tab = ____UeRegistrationQueryRequest_protocolIEs__item__id_tab
    ___UeRegistrationQueryRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UeRegistrationQueryRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UeRegistrationQueryRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___UeRegistrationQueryRequest_protocolIEs__item__value._const_tab = ____UeRegistrationQueryRequest_protocolIEs__item__id_tab
    ___UeRegistrationQueryRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UeRegistrationQueryRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __UeRegistrationQueryRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UeRegistrationQueryRequest_protocolIEs__item__id),
        ('criticality', ___UeRegistrationQueryRequest_protocolIEs__item__criticality),
        ('value', ___UeRegistrationQueryRequest_protocolIEs__item__value),
        ])
    __UeRegistrationQueryRequest_protocolIEs__item_._ext = None
    _UeRegistrationQueryRequest_protocolIEs._cont = __UeRegistrationQueryRequest_protocolIEs__item_
    _UeRegistrationQueryRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UeRegistrationQueryRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UeRegistrationQueryRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UeRegistrationQueryRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UeRegistrationQueryRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryRequest_protocolExtensions__item__id._const_tab = ____UeRegistrationQueryRequest_protocolExtensions__item__id_tab
    ___UeRegistrationQueryRequest_protocolExtensions__item__id._const_tab_at = None
    ___UeRegistrationQueryRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___UeRegistrationQueryRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UeRegistrationQueryRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryRequest_protocolExtensions__item__criticality._const_tab = ____UeRegistrationQueryRequest_protocolExtensions__item__criticality_tab
    ___UeRegistrationQueryRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UeRegistrationQueryRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UeRegistrationQueryRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue._const_tab = ____UeRegistrationQueryRequest_protocolExtensions__item__extensionValue_tab
    ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UeRegistrationQueryRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UeRegistrationQueryRequest_protocolExtensions__item__id),
        ('criticality', ___UeRegistrationQueryRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue),
        ])
    __UeRegistrationQueryRequest_protocolExtensions__item_._ext = None
    _UeRegistrationQueryRequest_protocolExtensions._cont = __UeRegistrationQueryRequest_protocolExtensions__item_
    _UeRegistrationQueryRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UeRegistrationQueryRequest._cont = ASN1Dict([
        ('protocolIEs', _UeRegistrationQueryRequest_protocolIEs),
        ('protocolExtensions', _UeRegistrationQueryRequest_protocolExtensions),
        ])
    UeRegistrationQueryRequest._ext = []
    
    #-----< UeRegistrationQueryRequestIEs >-----#
    UeRegistrationQueryRequestIEs = CLASS(name='UeRegistrationQueryRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UeRegistrationQueryRequestIEs_val_Value_0 = BIT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'IuSignallingConnectionIdentifier')))
    _UeRegistrationQueryRequestIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'PermanentNAS-UE-ID')))
    UeRegistrationQueryRequestIEs._val = ASN1Set(rv=[dict([('id', 79), ('criticality', 'ignore'), ('Value', _UeRegistrationQueryRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 23), ('criticality', 'ignore'), ('Value', _UeRegistrationQueryRequestIEs_val_Value_1), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UeRegistrationQueryRequestExtensions >-----#
    UeRegistrationQueryRequestExtensions = CLASS(name='UeRegistrationQueryRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UeRegistrationQueryRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< UeRegistrationQueryResponse >-----#
    UeRegistrationQueryResponse = SEQ(name='UeRegistrationQueryResponse', mode=MODE_TYPE)
    _UeRegistrationQueryResponse_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __UeRegistrationQueryResponse_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___UeRegistrationQueryResponse_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____UeRegistrationQueryResponse_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____UeRegistrationQueryResponse_protocolIEs__item__id_tab_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UERegistrationQueryResult')))
    ____UeRegistrationQueryResponse_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 281), ('criticality', 'ignore'), ('Value', _____UeRegistrationQueryResponse_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=None, er=[])
    ___UeRegistrationQueryResponse_protocolIEs__item__id._const_tab = ____UeRegistrationQueryResponse_protocolIEs__item__id_tab
    ___UeRegistrationQueryResponse_protocolIEs__item__id._const_tab_at = None
    ___UeRegistrationQueryResponse_protocolIEs__item__id._const_tab_id = 'id'
    ___UeRegistrationQueryResponse_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___UeRegistrationQueryResponse_protocolIEs__item__criticality._const_tab = ____UeRegistrationQueryResponse_protocolIEs__item__id_tab
    ___UeRegistrationQueryResponse_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___UeRegistrationQueryResponse_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___UeRegistrationQueryResponse_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___UeRegistrationQueryResponse_protocolIEs__item__value._const_tab = ____UeRegistrationQueryResponse_protocolIEs__item__id_tab
    ___UeRegistrationQueryResponse_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___UeRegistrationQueryResponse_protocolIEs__item__value._const_tab_id = 'Value'
    __UeRegistrationQueryResponse_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___UeRegistrationQueryResponse_protocolIEs__item__id),
        ('criticality', ___UeRegistrationQueryResponse_protocolIEs__item__criticality),
        ('value', ___UeRegistrationQueryResponse_protocolIEs__item__value),
        ])
    __UeRegistrationQueryResponse_protocolIEs__item_._ext = None
    _UeRegistrationQueryResponse_protocolIEs._cont = __UeRegistrationQueryResponse_protocolIEs__item_
    _UeRegistrationQueryResponse_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UeRegistrationQueryResponse_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __UeRegistrationQueryResponse_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___UeRegistrationQueryResponse_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____UeRegistrationQueryResponse_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryResponse_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryResponse_protocolExtensions__item__id._const_tab = ____UeRegistrationQueryResponse_protocolExtensions__item__id_tab
    ___UeRegistrationQueryResponse_protocolExtensions__item__id._const_tab_at = None
    ___UeRegistrationQueryResponse_protocolExtensions__item__id._const_tab_id = 'id'
    ___UeRegistrationQueryResponse_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____UeRegistrationQueryResponse_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryResponse_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryResponse_protocolExtensions__item__criticality._const_tab = ____UeRegistrationQueryResponse_protocolExtensions__item__criticality_tab
    ___UeRegistrationQueryResponse_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___UeRegistrationQueryResponse_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____UeRegistrationQueryResponse_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____UeRegistrationQueryResponse_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue._const_tab = ____UeRegistrationQueryResponse_protocolExtensions__item__extensionValue_tab
    ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __UeRegistrationQueryResponse_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___UeRegistrationQueryResponse_protocolExtensions__item__id),
        ('criticality', ___UeRegistrationQueryResponse_protocolExtensions__item__criticality),
        ('extensionValue', ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue),
        ])
    __UeRegistrationQueryResponse_protocolExtensions__item_._ext = None
    _UeRegistrationQueryResponse_protocolExtensions._cont = __UeRegistrationQueryResponse_protocolExtensions__item_
    _UeRegistrationQueryResponse_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    UeRegistrationQueryResponse._cont = ASN1Dict([
        ('protocolIEs', _UeRegistrationQueryResponse_protocolIEs),
        ('protocolExtensions', _UeRegistrationQueryResponse_protocolExtensions),
        ])
    UeRegistrationQueryResponse._ext = []
    
    #-----< UeRegistrationQueryResponseIEs >-----#
    UeRegistrationQueryResponseIEs = CLASS(name='UeRegistrationQueryResponseIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _UeRegistrationQueryResponseIEs_val_Value_0 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UERegistrationQueryResult')))
    UeRegistrationQueryResponseIEs._val = ASN1Set(rv=[dict([('id', 281), ('criticality', 'ignore'), ('Value', _UeRegistrationQueryResponseIEs_val_Value_0), ('presence', 'mandatory')])], rr=[], ev=[], er=[])
    
    #-----< UeRegistrationQueryResponseExtensions >-----#
    UeRegistrationQueryResponseExtensions = CLASS(name='UeRegistrationQueryResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    UeRegistrationQueryResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RerouteNASRequest >-----#
    RerouteNASRequest = SEQ(name='RerouteNASRequest', mode=MODE_TYPE)
    _RerouteNASRequest_protocolIEs = SEQ_OF(name='protocolIEs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Container')))
    __RerouteNASRequest_protocolIEs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolIE-Field')))
    ___RerouteNASRequest_protocolIEs__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['id']))
    ____RerouteNASRequest_protocolIEs__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-IES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE)
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SGSN-Group-Identity')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'P-TMSI')))
    _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Usage-Type')))
    ____RerouteNASRequest_protocolIEs__item__id_tab._val = ASN1Set(rv=[dict([('id', 288), ('criticality', 'ignore'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0), ('presence', 'mandatory')]), dict([('id', 286), ('criticality', 'ignore'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1), ('presence', 'mandatory')]), dict([('id', 287), ('criticality', 'ignore'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2), ('presence', 'optional')]), dict([('id', 290), ('criticality', 'ignore'), ('Value', _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3), ('presence', 'optional')])], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolIEs__item__id._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_at = None
    ___RerouteNASRequest_protocolIEs__item__id._const_tab_id = 'id'
    ___RerouteNASRequest_protocolIEs__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['criticality']))
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_at = ('..', 'id')
    ___RerouteNASRequest_protocolIEs__item__criticality._const_tab_id = 'criticality'
    ___RerouteNASRequest_protocolIEs__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-IES'), ['Value']))
    ___RerouteNASRequest_protocolIEs__item__value._const_tab = ____RerouteNASRequest_protocolIEs__item__id_tab
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_at = ('..', 'id')
    ___RerouteNASRequest_protocolIEs__item__value._const_tab_id = 'Value'
    __RerouteNASRequest_protocolIEs__item_._cont = ASN1Dict([
        ('id', ___RerouteNASRequest_protocolIEs__item__id),
        ('criticality', ___RerouteNASRequest_protocolIEs__item__criticality),
        ('value', ___RerouteNASRequest_protocolIEs__item__value),
        ])
    __RerouteNASRequest_protocolIEs__item_._ext = None
    _RerouteNASRequest_protocolIEs._cont = __RerouteNASRequest_protocolIEs__item_
    _RerouteNASRequest_protocolIEs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _RerouteNASRequest_protocolExtensions = SEQ_OF(name='protocolExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionContainer')), opt=True)
    __RerouteNASRequest_protocolExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-Containers', 'ProtocolExtensionField')))
    ___RerouteNASRequest_protocolExtensions__item__id = INT(name='id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['id']))
    ____RerouteNASRequest_protocolExtensions__item__id_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RerouteNASRequest_protocolExtensions__item__id_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolExtensions__item__id._const_tab = ____RerouteNASRequest_protocolExtensions__item__id_tab
    ___RerouteNASRequest_protocolExtensions__item__id._const_tab_at = None
    ___RerouteNASRequest_protocolExtensions__item__id._const_tab_id = 'id'
    ___RerouteNASRequest_protocolExtensions__item__criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['criticality']))
    ____RerouteNASRequest_protocolExtensions__item__criticality_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RerouteNASRequest_protocolExtensions__item__criticality_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolExtensions__item__criticality._const_tab = ____RerouteNASRequest_protocolExtensions__item__criticality_tab
    ___RerouteNASRequest_protocolExtensions__item__criticality._const_tab_at = ('..', 'id')
    ___RerouteNASRequest_protocolExtensions__item__criticality._const_tab_id = 'criticality'
    ___RerouteNASRequest_protocolExtensions__item__extensionValue = OPEN(name='extensionValue', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION'), ['Extension']))
    ____RerouteNASRequest_protocolExtensions__item__extensionValue_tab = CLASS(name='_tab_RANAP-PROTOCOL-EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    ____RerouteNASRequest_protocolExtensions__item__extensionValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___RerouteNASRequest_protocolExtensions__item__extensionValue._const_tab = ____RerouteNASRequest_protocolExtensions__item__extensionValue_tab
    ___RerouteNASRequest_protocolExtensions__item__extensionValue._const_tab_at = ('..', 'id')
    ___RerouteNASRequest_protocolExtensions__item__extensionValue._const_tab_id = 'Extension'
    __RerouteNASRequest_protocolExtensions__item_._cont = ASN1Dict([
        ('id', ___RerouteNASRequest_protocolExtensions__item__id),
        ('criticality', ___RerouteNASRequest_protocolExtensions__item__criticality),
        ('extensionValue', ___RerouteNASRequest_protocolExtensions__item__extensionValue),
        ])
    __RerouteNASRequest_protocolExtensions__item_._ext = None
    _RerouteNASRequest_protocolExtensions._cont = __RerouteNASRequest_protocolExtensions__item_
    _RerouteNASRequest_protocolExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65535)], ev=None, er=[])
    RerouteNASRequest._cont = ASN1Dict([
        ('protocolIEs', _RerouteNASRequest_protocolIEs),
        ('protocolExtensions', _RerouteNASRequest_protocolExtensions),
        ])
    RerouteNASRequest._ext = []
    
    #-----< RerouteNASRequestIEs >-----#
    RerouteNASRequestIEs = CLASS(name='RerouteNASRequestIEs', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-IES')))
    _RerouteNASRequestIEs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE)
    _RerouteNASRequestIEs_val_Value_1 = CHOICE(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'SGSN-Group-Identity')))
    _RerouteNASRequestIEs_val_Value_2 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'P-TMSI')))
    _RerouteNASRequestIEs_val_Value_3 = INT(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-IEs', 'UE-Usage-Type')))
    RerouteNASRequestIEs._val = ASN1Set(rv=[dict([('id', 288), ('criticality', 'ignore'), ('Value', _RerouteNASRequestIEs_val_Value_0), ('presence', 'mandatory')]), dict([('id', 286), ('criticality', 'ignore'), ('Value', _RerouteNASRequestIEs_val_Value_1), ('presence', 'mandatory')]), dict([('id', 287), ('criticality', 'ignore'), ('Value', _RerouteNASRequestIEs_val_Value_2), ('presence', 'optional')]), dict([('id', 290), ('criticality', 'ignore'), ('Value', _RerouteNASRequestIEs_val_Value_3), ('presence', 'optional')])], rr=[], ev=[], er=[])
    
    #-----< RerouteNASRequestExtensions >-----#
    RerouteNASRequestExtensions = CLASS(name='RerouteNASRequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('RANAP-Containers', 'RANAP-PROTOCOL-EXTENSION')))
    RerouteNASRequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        ____Iu_ReleaseCommand_protocolIEs__item__id_tab,
        _____Iu_ReleaseCommand_protocolIEs__item__id_tab_val_Value_0,
        ___Iu_ReleaseCommand_protocolIEs__item__id,
        ___Iu_ReleaseCommand_protocolIEs__item__criticality,
        ___Iu_ReleaseCommand_protocolIEs__item__value,
        __Iu_ReleaseCommand_protocolIEs__item_,
        _Iu_ReleaseCommand_protocolIEs,
        ____Iu_ReleaseCommand_protocolExtensions__item__id_tab,
        _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_0,
        _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_1,
        _____Iu_ReleaseCommand_protocolExtensions__item__id_tab_val_Extension_2,
        ___Iu_ReleaseCommand_protocolExtensions__item__id,
        ___Iu_ReleaseCommand_protocolExtensions__item__criticality,
        ___Iu_ReleaseCommand_protocolExtensions__item__extensionValue,
        __Iu_ReleaseCommand_protocolExtensions__item_,
        _Iu_ReleaseCommand_protocolExtensions,
        Iu_ReleaseCommand,
        Iu_ReleaseCommandIEs,
        _Iu_ReleaseCommandIEs_val_Value_0,
        Iu_ReleaseCommandExtensions,
        _Iu_ReleaseCommandExtensions_val_Extension_0,
        _Iu_ReleaseCommandExtensions_val_Extension_1,
        _Iu_ReleaseCommandExtensions_val_Extension_2,
        ____Iu_ReleaseComplete_protocolIEs__item__id_tab,
        _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_0,
        _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_1,
        _____Iu_ReleaseComplete_protocolIEs__item__id_tab_val_Value_2,
        ___Iu_ReleaseComplete_protocolIEs__item__id,
        ___Iu_ReleaseComplete_protocolIEs__item__criticality,
        ___Iu_ReleaseComplete_protocolIEs__item__value,
        __Iu_ReleaseComplete_protocolIEs__item_,
        _Iu_ReleaseComplete_protocolIEs,
        ____Iu_ReleaseComplete_protocolExtensions__item__id_tab,
        ___Iu_ReleaseComplete_protocolExtensions__item__id,
        ____Iu_ReleaseComplete_protocolExtensions__item__criticality_tab,
        ___Iu_ReleaseComplete_protocolExtensions__item__criticality,
        ____Iu_ReleaseComplete_protocolExtensions__item__extensionValue_tab,
        ___Iu_ReleaseComplete_protocolExtensions__item__extensionValue,
        __Iu_ReleaseComplete_protocolExtensions__item_,
        _Iu_ReleaseComplete_protocolExtensions,
        Iu_ReleaseComplete,
        Iu_ReleaseCompleteIEs,
        _Iu_ReleaseCompleteIEs_val_Value_0,
        _Iu_ReleaseCompleteIEs_val_Value_1,
        _Iu_ReleaseCompleteIEs_val_Value_2,
        ____RAB_DataVolumeReportList__item___item__id_tab,
        _____RAB_DataVolumeReportList__item___item__id_tab_val_Value_0,
        ___RAB_DataVolumeReportList__item___item__id,
        ___RAB_DataVolumeReportList__item___item__criticality,
        ___RAB_DataVolumeReportList__item___item__value,
        __RAB_DataVolumeReportList__item___item_,
        _RAB_DataVolumeReportList__item_,
        RAB_DataVolumeReportList,
        RAB_DataVolumeReportItemIEs,
        _RAB_DataVolumeReportItemIEs_val_Value_0,
        _RAB_DataVolumeReportItem_rAB_ID,
        _RAB_DataVolumeReportItem_dl_UnsuccessfullyTransmittedDataVolume,
        ____RAB_DataVolumeReportItem_iE_Extensions__item__id_tab,
        ___RAB_DataVolumeReportItem_iE_Extensions__item__id,
        ____RAB_DataVolumeReportItem_iE_Extensions__item__criticality_tab,
        ___RAB_DataVolumeReportItem_iE_Extensions__item__criticality,
        ____RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_DataVolumeReportItem_iE_Extensions__item__extensionValue,
        __RAB_DataVolumeReportItem_iE_Extensions__item_,
        _RAB_DataVolumeReportItem_iE_Extensions,
        RAB_DataVolumeReportItem,
        RAB_DataVolumeReportItem_ExtIEs,
        ____RAB_ReleasedList_IuRelComp__item___item__id_tab,
        _____RAB_ReleasedList_IuRelComp__item___item__id_tab_val_Value_0,
        ___RAB_ReleasedList_IuRelComp__item___item__id,
        ___RAB_ReleasedList_IuRelComp__item___item__criticality,
        ___RAB_ReleasedList_IuRelComp__item___item__value,
        __RAB_ReleasedList_IuRelComp__item___item_,
        _RAB_ReleasedList_IuRelComp__item_,
        RAB_ReleasedList_IuRelComp,
        RAB_ReleasedItem_IuRelComp_IEs,
        _RAB_ReleasedItem_IuRelComp_IEs_val_Value_0,
        _RAB_ReleasedItem_IuRelComp_rAB_ID,
        _RAB_ReleasedItem_IuRelComp_dL_GTP_PDU_SequenceNumber,
        _RAB_ReleasedItem_IuRelComp_uL_GTP_PDU_SequenceNumber,
        ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id_tab,
        ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__id,
        ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality_tab,
        ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__criticality,
        ____RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue_tab,
        ___RAB_ReleasedItem_IuRelComp_iE_Extensions__item__extensionValue,
        __RAB_ReleasedItem_IuRelComp_iE_Extensions__item_,
        _RAB_ReleasedItem_IuRelComp_iE_Extensions,
        RAB_ReleasedItem_IuRelComp,
        RAB_ReleasedItem_IuRelComp_ExtIEs,
        Iu_ReleaseCompleteExtensions,
        ____RelocationRequired_protocolIEs__item__id_tab,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_1,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_2,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_3,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_4,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_5,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_6,
        _____RelocationRequired_protocolIEs__item__id_tab_val_Value_7,
        ___RelocationRequired_protocolIEs__item__id,
        ___RelocationRequired_protocolIEs__item__criticality,
        ___RelocationRequired_protocolIEs__item__value,
        __RelocationRequired_protocolIEs__item_,
        _RelocationRequired_protocolIEs,
        ____RelocationRequired_protocolExtensions__item__id_tab,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_1,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_2,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_3,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_4,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_5,
        _____RelocationRequired_protocolExtensions__item__id_tab_val_Extension_6,
        ___RelocationRequired_protocolExtensions__item__id,
        ___RelocationRequired_protocolExtensions__item__criticality,
        ___RelocationRequired_protocolExtensions__item__extensionValue,
        __RelocationRequired_protocolExtensions__item_,
        _RelocationRequired_protocolExtensions,
        RelocationRequired,
        RelocationRequiredIEs,
        _RelocationRequiredIEs_val_Value_0,
        _RelocationRequiredIEs_val_Value_1,
        _RelocationRequiredIEs_val_Value_2,
        _RelocationRequiredIEs_val_Value_3,
        _RelocationRequiredIEs_val_Value_4,
        _RelocationRequiredIEs_val_Value_5,
        _RelocationRequiredIEs_val_Value_6,
        _RelocationRequiredIEs_val_Value_7,
        RelocationRequiredExtensions,
        _RelocationRequiredExtensions_val_Extension_0,
        _RelocationRequiredExtensions_val_Extension_1,
        _RelocationRequiredExtensions_val_Extension_2,
        _RelocationRequiredExtensions_val_Extension_3,
        _RelocationRequiredExtensions_val_Extension_4,
        _RelocationRequiredExtensions_val_Extension_5,
        _RelocationRequiredExtensions_val_Extension_6,
        ____RelocationCommand_protocolIEs__item__id_tab,
        _____RelocationCommand_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationCommand_protocolIEs__item__id_tab_val_Value_1,
        _____RelocationCommand_protocolIEs__item__id_tab_val_Value_2,
        _____RelocationCommand_protocolIEs__item__id_tab_val_Value_3,
        _____RelocationCommand_protocolIEs__item__id_tab_val_Value_4,
        ___RelocationCommand_protocolIEs__item__id,
        ___RelocationCommand_protocolIEs__item__criticality,
        ___RelocationCommand_protocolIEs__item__value,
        __RelocationCommand_protocolIEs__item_,
        _RelocationCommand_protocolIEs,
        ____RelocationCommand_protocolExtensions__item__id_tab,
        _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_1,
        _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_2,
        _____RelocationCommand_protocolExtensions__item__id_tab_val_Extension_3,
        ___RelocationCommand_protocolExtensions__item__id,
        ___RelocationCommand_protocolExtensions__item__criticality,
        ___RelocationCommand_protocolExtensions__item__extensionValue,
        __RelocationCommand_protocolExtensions__item_,
        _RelocationCommand_protocolExtensions,
        RelocationCommand,
        RelocationCommandIEs,
        _RelocationCommandIEs_val_Value_0,
        _RelocationCommandIEs_val_Value_1,
        _RelocationCommandIEs_val_Value_2,
        _RelocationCommandIEs_val_Value_3,
        _RelocationCommandIEs_val_Value_4,
        ____RAB_RelocationReleaseList__item___item__id_tab,
        _____RAB_RelocationReleaseList__item___item__id_tab_val_Value_0,
        ___RAB_RelocationReleaseList__item___item__id,
        ___RAB_RelocationReleaseList__item___item__criticality,
        ___RAB_RelocationReleaseList__item___item__value,
        __RAB_RelocationReleaseList__item___item_,
        _RAB_RelocationReleaseList__item_,
        RAB_RelocationReleaseList,
        RAB_RelocationReleaseItemIEs,
        _RAB_RelocationReleaseItemIEs_val_Value_0,
        _RAB_RelocationReleaseItem_rAB_ID,
        ____RAB_RelocationReleaseItem_iE_Extensions__item__id_tab,
        ___RAB_RelocationReleaseItem_iE_Extensions__item__id,
        ____RAB_RelocationReleaseItem_iE_Extensions__item__criticality_tab,
        ___RAB_RelocationReleaseItem_iE_Extensions__item__criticality,
        ____RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_RelocationReleaseItem_iE_Extensions__item__extensionValue,
        __RAB_RelocationReleaseItem_iE_Extensions__item_,
        _RAB_RelocationReleaseItem_iE_Extensions,
        RAB_RelocationReleaseItem,
        RAB_RelocationReleaseItem_ExtIEs,
        ____RAB_DataForwardingList__item___item__id_tab,
        _____RAB_DataForwardingList__item___item__id_tab_val_Value_0,
        ___RAB_DataForwardingList__item___item__id,
        ___RAB_DataForwardingList__item___item__criticality,
        ___RAB_DataForwardingList__item___item__value,
        __RAB_DataForwardingList__item___item_,
        _RAB_DataForwardingList__item_,
        RAB_DataForwardingList,
        RAB_DataForwardingItemIEs,
        _RAB_DataForwardingItemIEs_val_Value_0,
        _RAB_DataForwardingItem_rAB_ID,
        _RAB_DataForwardingItem_transportLayerAddress,
        _RAB_DataForwardingItem_iuTransportAssociation,
        ____RAB_DataForwardingItem_iE_Extensions__item__id_tab,
        _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_DataForwardingItem_iE_Extensions__item__id_tab_val_Extension_1,
        ___RAB_DataForwardingItem_iE_Extensions__item__id,
        ___RAB_DataForwardingItem_iE_Extensions__item__criticality,
        ___RAB_DataForwardingItem_iE_Extensions__item__extensionValue,
        __RAB_DataForwardingItem_iE_Extensions__item_,
        _RAB_DataForwardingItem_iE_Extensions,
        RAB_DataForwardingItem,
        RAB_DataForwardingItem_ExtIEs,
        _RAB_DataForwardingItem_ExtIEs_val_Extension_0,
        _RAB_DataForwardingItem_ExtIEs_val_Extension_1,
        RelocationCommandExtensions,
        _RelocationCommandExtensions_val_Extension_0,
        _RelocationCommandExtensions_val_Extension_1,
        _RelocationCommandExtensions_val_Extension_2,
        _RelocationCommandExtensions_val_Extension_3,
        ____RelocationPreparationFailure_protocolIEs__item__id_tab,
        _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationPreparationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___RelocationPreparationFailure_protocolIEs__item__id,
        ___RelocationPreparationFailure_protocolIEs__item__criticality,
        ___RelocationPreparationFailure_protocolIEs__item__value,
        __RelocationPreparationFailure_protocolIEs__item_,
        _RelocationPreparationFailure_protocolIEs,
        ____RelocationPreparationFailure_protocolExtensions__item__id_tab,
        _____RelocationPreparationFailure_protocolExtensions__item__id_tab_val_Extension_0,
        ___RelocationPreparationFailure_protocolExtensions__item__id,
        ___RelocationPreparationFailure_protocolExtensions__item__criticality,
        ___RelocationPreparationFailure_protocolExtensions__item__extensionValue,
        __RelocationPreparationFailure_protocolExtensions__item_,
        _RelocationPreparationFailure_protocolExtensions,
        RelocationPreparationFailure,
        RelocationPreparationFailureIEs,
        _RelocationPreparationFailureIEs_val_Value_0,
        _RelocationPreparationFailureIEs_val_Value_1,
        RelocationPreparationFailureExtensions,
        _RelocationPreparationFailureExtensions_val_Extension_0,
        ____RelocationRequest_protocolIEs__item__id_tab,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____RelocationRequest_protocolIEs__item__id_tab_val_Value_7,
        ___RelocationRequest_protocolIEs__item__id,
        ___RelocationRequest_protocolIEs__item__criticality,
        ___RelocationRequest_protocolIEs__item__value,
        __RelocationRequest_protocolIEs__item_,
        _RelocationRequest_protocolIEs,
        ____RelocationRequest_protocolExtensions__item__id_tab,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_5,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_6,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_7,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_8,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_9,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_10,
        _____RelocationRequest_protocolExtensions__item__id_tab_val_Extension_11,
        ___RelocationRequest_protocolExtensions__item__id,
        ___RelocationRequest_protocolExtensions__item__criticality,
        ___RelocationRequest_protocolExtensions__item__extensionValue,
        __RelocationRequest_protocolExtensions__item_,
        _RelocationRequest_protocolExtensions,
        RelocationRequest,
        RelocationRequestIEs,
        _RelocationRequestIEs_val_Value_0,
        _RelocationRequestIEs_val_Value_1,
        _RelocationRequestIEs_val_Value_2,
        _RelocationRequestIEs_val_Value_3,
        _RelocationRequestIEs_val_Value_4,
        _RelocationRequestIEs_val_Value_5,
        _RelocationRequestIEs_val_Value_6,
        _RelocationRequestIEs_val_Value_7,
        ____RAB_SetupList_RelocReq__item___item__id_tab,
        _____RAB_SetupList_RelocReq__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_RelocReq__item___item__id,
        ___RAB_SetupList_RelocReq__item___item__criticality,
        ___RAB_SetupList_RelocReq__item___item__value,
        __RAB_SetupList_RelocReq__item___item_,
        _RAB_SetupList_RelocReq__item_,
        RAB_SetupList_RelocReq,
        RAB_SetupItem_RelocReq_IEs,
        _RAB_SetupItem_RelocReq_IEs_val_Value_0,
        _RAB_SetupItem_RelocReq_rAB_ID,
        _RAB_SetupItem_RelocReq_nAS_SynchronisationIndicator,
        _RAB_SetupItem_RelocReq_rAB_Parameters,
        _RAB_SetupItem_RelocReq_dataVolumeReportingIndication,
        _RAB_SetupItem_RelocReq_pDP_TypeInformation,
        _RAB_SetupItem_RelocReq_userPlaneInformation,
        _RAB_SetupItem_RelocReq_transportLayerAddress,
        _RAB_SetupItem_RelocReq_iuTransportAssociation,
        _RAB_SetupItem_RelocReq_service_Handover,
        ____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab,
        _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_1,
        _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_2,
        _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_3,
        _____RAB_SetupItem_RelocReq_iE_Extensions__item__id_tab_val_Extension_4,
        ___RAB_SetupItem_RelocReq_iE_Extensions__item__id,
        ___RAB_SetupItem_RelocReq_iE_Extensions__item__criticality,
        ___RAB_SetupItem_RelocReq_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_RelocReq_iE_Extensions__item_,
        _RAB_SetupItem_RelocReq_iE_Extensions,
        RAB_SetupItem_RelocReq,
        RAB_SetupItem_RelocReq_ExtIEs,
        _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_0,
        _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_1,
        _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_2,
        _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_3,
        _RAB_SetupItem_RelocReq_ExtIEs_val_Extension_4,
        _UserPlaneInformation_userPlaneMode,
        _UserPlaneInformation_uP_ModeVersions,
        ____UserPlaneInformation_iE_Extensions__item__id_tab,
        ___UserPlaneInformation_iE_Extensions__item__id,
        ____UserPlaneInformation_iE_Extensions__item__criticality_tab,
        ___UserPlaneInformation_iE_Extensions__item__criticality,
        ____UserPlaneInformation_iE_Extensions__item__extensionValue_tab,
        ___UserPlaneInformation_iE_Extensions__item__extensionValue,
        __UserPlaneInformation_iE_Extensions__item_,
        _UserPlaneInformation_iE_Extensions,
        UserPlaneInformation,
        UserPlaneInformation_ExtIEs,
        RelocationRequestExtensions,
        _RelocationRequestExtensions_val_Extension_0,
        _RelocationRequestExtensions_val_Extension_1,
        _RelocationRequestExtensions_val_Extension_2,
        _RelocationRequestExtensions_val_Extension_3,
        _RelocationRequestExtensions_val_Extension_4,
        _RelocationRequestExtensions_val_Extension_5,
        _RelocationRequestExtensions_val_Extension_6,
        _RelocationRequestExtensions_val_Extension_7,
        _RelocationRequestExtensions_val_Extension_8,
        _RelocationRequestExtensions_val_Extension_9,
        _RelocationRequestExtensions_val_Extension_10,
        _RelocationRequestExtensions_val_Extension_11,
        _CNMBMSLinkingInformation_joinedMBMSBearerService_IEs,
        ____CNMBMSLinkingInformation_iE_Extensions__item__id_tab,
        ___CNMBMSLinkingInformation_iE_Extensions__item__id,
        ____CNMBMSLinkingInformation_iE_Extensions__item__criticality_tab,
        ___CNMBMSLinkingInformation_iE_Extensions__item__criticality,
        ____CNMBMSLinkingInformation_iE_Extensions__item__extensionValue_tab,
        ___CNMBMSLinkingInformation_iE_Extensions__item__extensionValue,
        __CNMBMSLinkingInformation_iE_Extensions__item_,
        _CNMBMSLinkingInformation_iE_Extensions,
        CNMBMSLinkingInformation,
        CNMBMSLinkingInformation_ExtIEs,
        __JoinedMBMSBearerService_IEs__item__tMGI,
        __JoinedMBMSBearerService_IEs__item__mBMS_PTP_RAB_ID,
        _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id_tab,
        ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__id,
        _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab,
        ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__criticality,
        _____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab,
        ____JoinedMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue,
        ___JoinedMBMSBearerService_IEs__item__iE_Extensions__item_,
        __JoinedMBMSBearerService_IEs__item__iE_Extensions,
        _JoinedMBMSBearerService_IEs__item_,
        JoinedMBMSBearerService_IEs,
        JoinedMBMSBearerService_ExtIEs,
        ____RelocationRequestAcknowledge_protocolIEs__item__id_tab,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_4,
        _____RelocationRequestAcknowledge_protocolIEs__item__id_tab_val_Value_5,
        ___RelocationRequestAcknowledge_protocolIEs__item__id,
        ___RelocationRequestAcknowledge_protocolIEs__item__criticality,
        ___RelocationRequestAcknowledge_protocolIEs__item__value,
        __RelocationRequestAcknowledge_protocolIEs__item_,
        _RelocationRequestAcknowledge_protocolIEs,
        ____RelocationRequestAcknowledge_protocolExtensions__item__id_tab,
        _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationRequestAcknowledge_protocolExtensions__item__id_tab_val_Extension_1,
        ___RelocationRequestAcknowledge_protocolExtensions__item__id,
        ___RelocationRequestAcknowledge_protocolExtensions__item__criticality,
        ___RelocationRequestAcknowledge_protocolExtensions__item__extensionValue,
        __RelocationRequestAcknowledge_protocolExtensions__item_,
        _RelocationRequestAcknowledge_protocolExtensions,
        RelocationRequestAcknowledge,
        RelocationRequestAcknowledgeIEs,
        _RelocationRequestAcknowledgeIEs_val_Value_0,
        _RelocationRequestAcknowledgeIEs_val_Value_1,
        _RelocationRequestAcknowledgeIEs_val_Value_2,
        _RelocationRequestAcknowledgeIEs_val_Value_3,
        _RelocationRequestAcknowledgeIEs_val_Value_4,
        _RelocationRequestAcknowledgeIEs_val_Value_5,
        ____RAB_SetupList_RelocReqAck__item___item__id_tab,
        _____RAB_SetupList_RelocReqAck__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_RelocReqAck__item___item__id,
        ___RAB_SetupList_RelocReqAck__item___item__criticality,
        ___RAB_SetupList_RelocReqAck__item___item__value,
        __RAB_SetupList_RelocReqAck__item___item_,
        _RAB_SetupList_RelocReqAck__item_,
        RAB_SetupList_RelocReqAck,
        RAB_SetupItem_RelocReqAck_IEs,
        _RAB_SetupItem_RelocReqAck_IEs_val_Value_0,
        _RAB_SetupItem_RelocReqAck_rAB_ID,
        _RAB_SetupItem_RelocReqAck_transportLayerAddress,
        _RAB_SetupItem_RelocReqAck_iuTransportAssociation,
        ____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab,
        _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_1,
        _____RAB_SetupItem_RelocReqAck_iE_Extensions__item__id_tab_val_Extension_2,
        ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__id,
        ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__criticality,
        ___RAB_SetupItem_RelocReqAck_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_RelocReqAck_iE_Extensions__item_,
        _RAB_SetupItem_RelocReqAck_iE_Extensions,
        RAB_SetupItem_RelocReqAck,
        RAB_SetupItem_RelocReqAck_ExtIEs,
        _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_0,
        _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_1,
        _RAB_SetupItem_RelocReqAck_ExtIEs_val_Extension_2,
        ____RAB_FailedList__item___item__id_tab,
        _____RAB_FailedList__item___item__id_tab_val_Value_0,
        ___RAB_FailedList__item___item__id,
        ___RAB_FailedList__item___item__criticality,
        ___RAB_FailedList__item___item__value,
        __RAB_FailedList__item___item_,
        _RAB_FailedList__item_,
        RAB_FailedList,
        RAB_FailedItemIEs,
        _RAB_FailedItemIEs_val_Value_0,
        _RAB_FailedItem_rAB_ID,
        _RAB_FailedItem_cause,
        ____RAB_FailedItem_iE_Extensions__item__id_tab,
        ___RAB_FailedItem_iE_Extensions__item__id,
        ____RAB_FailedItem_iE_Extensions__item__criticality_tab,
        ___RAB_FailedItem_iE_Extensions__item__criticality,
        ____RAB_FailedItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_FailedItem_iE_Extensions__item__extensionValue,
        __RAB_FailedItem_iE_Extensions__item_,
        _RAB_FailedItem_iE_Extensions,
        RAB_FailedItem,
        RAB_FailedItem_ExtIEs,
        RelocationRequestAcknowledgeExtensions,
        _RelocationRequestAcknowledgeExtensions_val_Extension_0,
        _RelocationRequestAcknowledgeExtensions_val_Extension_1,
        ____RelocationFailure_protocolIEs__item__id_tab,
        _____RelocationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____RelocationFailure_protocolIEs__item__id_tab_val_Value_1,
        ___RelocationFailure_protocolIEs__item__id,
        ___RelocationFailure_protocolIEs__item__criticality,
        ___RelocationFailure_protocolIEs__item__value,
        __RelocationFailure_protocolIEs__item_,
        _RelocationFailure_protocolIEs,
        ____RelocationFailure_protocolExtensions__item__id_tab,
        _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationFailure_protocolExtensions__item__id_tab_val_Extension_1,
        ___RelocationFailure_protocolExtensions__item__id,
        ___RelocationFailure_protocolExtensions__item__criticality,
        ___RelocationFailure_protocolExtensions__item__extensionValue,
        __RelocationFailure_protocolExtensions__item_,
        _RelocationFailure_protocolExtensions,
        RelocationFailure,
        RelocationFailureIEs,
        _RelocationFailureIEs_val_Value_0,
        _RelocationFailureIEs_val_Value_1,
        RelocationFailureExtensions,
        _RelocationFailureExtensions_val_Extension_0,
        _RelocationFailureExtensions_val_Extension_1,
        ____RelocationCancel_protocolIEs__item__id_tab,
        _____RelocationCancel_protocolIEs__item__id_tab_val_Value_0,
        ___RelocationCancel_protocolIEs__item__id,
        ___RelocationCancel_protocolIEs__item__criticality,
        ___RelocationCancel_protocolIEs__item__value,
        __RelocationCancel_protocolIEs__item_,
        _RelocationCancel_protocolIEs,
        ____RelocationCancel_protocolExtensions__item__id_tab,
        ___RelocationCancel_protocolExtensions__item__id,
        ____RelocationCancel_protocolExtensions__item__criticality_tab,
        ___RelocationCancel_protocolExtensions__item__criticality,
        ____RelocationCancel_protocolExtensions__item__extensionValue_tab,
        ___RelocationCancel_protocolExtensions__item__extensionValue,
        __RelocationCancel_protocolExtensions__item_,
        _RelocationCancel_protocolExtensions,
        RelocationCancel,
        RelocationCancelIEs,
        _RelocationCancelIEs_val_Value_0,
        RelocationCancelExtensions,
        ____RelocationCancelAcknowledge_protocolIEs__item__id_tab,
        _____RelocationCancelAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        ___RelocationCancelAcknowledge_protocolIEs__item__id,
        ___RelocationCancelAcknowledge_protocolIEs__item__criticality,
        ___RelocationCancelAcknowledge_protocolIEs__item__value,
        __RelocationCancelAcknowledge_protocolIEs__item_,
        _RelocationCancelAcknowledge_protocolIEs,
        ____RelocationCancelAcknowledge_protocolExtensions__item__id_tab,
        ___RelocationCancelAcknowledge_protocolExtensions__item__id,
        ____RelocationCancelAcknowledge_protocolExtensions__item__criticality_tab,
        ___RelocationCancelAcknowledge_protocolExtensions__item__criticality,
        ____RelocationCancelAcknowledge_protocolExtensions__item__extensionValue_tab,
        ___RelocationCancelAcknowledge_protocolExtensions__item__extensionValue,
        __RelocationCancelAcknowledge_protocolExtensions__item_,
        _RelocationCancelAcknowledge_protocolExtensions,
        RelocationCancelAcknowledge,
        RelocationCancelAcknowledgeIEs,
        _RelocationCancelAcknowledgeIEs_val_Value_0,
        RelocationCancelAcknowledgeExtensions,
        ____SRNS_ContextRequest_protocolIEs__item__id_tab,
        _____SRNS_ContextRequest_protocolIEs__item__id_tab_val_Value_0,
        ___SRNS_ContextRequest_protocolIEs__item__id,
        ___SRNS_ContextRequest_protocolIEs__item__criticality,
        ___SRNS_ContextRequest_protocolIEs__item__value,
        __SRNS_ContextRequest_protocolIEs__item_,
        _SRNS_ContextRequest_protocolIEs,
        ____SRNS_ContextRequest_protocolExtensions__item__id_tab,
        _____SRNS_ContextRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___SRNS_ContextRequest_protocolExtensions__item__id,
        ___SRNS_ContextRequest_protocolExtensions__item__criticality,
        ___SRNS_ContextRequest_protocolExtensions__item__extensionValue,
        __SRNS_ContextRequest_protocolExtensions__item_,
        _SRNS_ContextRequest_protocolExtensions,
        SRNS_ContextRequest,
        SRNS_ContextRequestIEs,
        _SRNS_ContextRequestIEs_val_Value_0,
        ____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab,
        _____RAB_DataForwardingList_SRNS_CtxReq__item___item__id_tab_val_Value_0,
        ___RAB_DataForwardingList_SRNS_CtxReq__item___item__id,
        ___RAB_DataForwardingList_SRNS_CtxReq__item___item__criticality,
        ___RAB_DataForwardingList_SRNS_CtxReq__item___item__value,
        __RAB_DataForwardingList_SRNS_CtxReq__item___item_,
        _RAB_DataForwardingList_SRNS_CtxReq__item_,
        RAB_DataForwardingList_SRNS_CtxReq,
        RAB_DataForwardingItem_SRNS_CtxReq_IEs,
        _RAB_DataForwardingItem_SRNS_CtxReq_IEs_val_Value_0,
        _RAB_DataForwardingItem_SRNS_CtxReq_rAB_ID,
        ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id_tab,
        ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__id,
        ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality_tab,
        ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__criticality,
        ____RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue_tab,
        ___RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item__extensionValue,
        __RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions__item_,
        _RAB_DataForwardingItem_SRNS_CtxReq_iE_Extensions,
        RAB_DataForwardingItem_SRNS_CtxReq,
        RAB_DataForwardingItem_SRNS_CtxReq_ExtIEs,
        SRNS_ContextRequestExtensions,
        _SRNS_ContextRequestExtensions_val_Extension_0,
        ____SRNS_ContextResponse_protocolIEs__item__id_tab,
        _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_0,
        _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_1,
        _____SRNS_ContextResponse_protocolIEs__item__id_tab_val_Value_2,
        ___SRNS_ContextResponse_protocolIEs__item__id,
        ___SRNS_ContextResponse_protocolIEs__item__criticality,
        ___SRNS_ContextResponse_protocolIEs__item__value,
        __SRNS_ContextResponse_protocolIEs__item_,
        _SRNS_ContextResponse_protocolIEs,
        ____SRNS_ContextResponse_protocolExtensions__item__id_tab,
        ___SRNS_ContextResponse_protocolExtensions__item__id,
        ____SRNS_ContextResponse_protocolExtensions__item__criticality_tab,
        ___SRNS_ContextResponse_protocolExtensions__item__criticality,
        ____SRNS_ContextResponse_protocolExtensions__item__extensionValue_tab,
        ___SRNS_ContextResponse_protocolExtensions__item__extensionValue,
        __SRNS_ContextResponse_protocolExtensions__item_,
        _SRNS_ContextResponse_protocolExtensions,
        SRNS_ContextResponse,
        SRNS_ContextResponseIEs,
        _SRNS_ContextResponseIEs_val_Value_0,
        _SRNS_ContextResponseIEs_val_Value_1,
        _SRNS_ContextResponseIEs_val_Value_2,
        ____RAB_ContextList__item___item__id_tab,
        _____RAB_ContextList__item___item__id_tab_val_Value_0,
        ___RAB_ContextList__item___item__id,
        ___RAB_ContextList__item___item__criticality,
        ___RAB_ContextList__item___item__value,
        __RAB_ContextList__item___item_,
        _RAB_ContextList__item_,
        RAB_ContextList,
        RAB_ContextItemIEs,
        _RAB_ContextItemIEs_val_Value_0,
        _RAB_ContextItem_rAB_ID,
        _RAB_ContextItem_dl_GTP_PDU_SequenceNumber,
        _RAB_ContextItem_ul_GTP_PDU_SequenceNumber,
        _RAB_ContextItem_dl_N_PDU_SequenceNumber,
        _RAB_ContextItem_ul_N_PDU_SequenceNumber,
        ____RAB_ContextItem_iE_Extensions__item__id_tab,
        ___RAB_ContextItem_iE_Extensions__item__id,
        ____RAB_ContextItem_iE_Extensions__item__criticality_tab,
        ___RAB_ContextItem_iE_Extensions__item__criticality,
        ____RAB_ContextItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_ContextItem_iE_Extensions__item__extensionValue,
        __RAB_ContextItem_iE_Extensions__item_,
        _RAB_ContextItem_iE_Extensions,
        RAB_ContextItem,
        RAB_ContextItem_ExtIEs,
        ____RAB_ContextFailedtoTransferList__item___item__id_tab,
        _____RAB_ContextFailedtoTransferList__item___item__id_tab_val_Value_0,
        ___RAB_ContextFailedtoTransferList__item___item__id,
        ___RAB_ContextFailedtoTransferList__item___item__criticality,
        ___RAB_ContextFailedtoTransferList__item___item__value,
        __RAB_ContextFailedtoTransferList__item___item_,
        _RAB_ContextFailedtoTransferList__item_,
        RAB_ContextFailedtoTransferList,
        RABs_ContextFailedtoTransferItemIEs,
        _RABs_ContextFailedtoTransferItemIEs_val_Value_0,
        _RABs_ContextFailedtoTransferItem_rAB_ID,
        _RABs_ContextFailedtoTransferItem_cause,
        ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__id_tab,
        ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__id,
        ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality_tab,
        ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__criticality,
        ____RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue_tab,
        ___RABs_ContextFailedtoTransferItem_iE_Extensions__item__extensionValue,
        __RABs_ContextFailedtoTransferItem_iE_Extensions__item_,
        _RABs_ContextFailedtoTransferItem_iE_Extensions,
        RABs_ContextFailedtoTransferItem,
        RABs_ContextFailedtoTransferItem_ExtIEs,
        SRNS_ContextResponseExtensions,
        ____SecurityModeCommand_protocolIEs__item__id_tab,
        _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_0,
        _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_1,
        _____SecurityModeCommand_protocolIEs__item__id_tab_val_Value_2,
        ___SecurityModeCommand_protocolIEs__item__id,
        ___SecurityModeCommand_protocolIEs__item__criticality,
        ___SecurityModeCommand_protocolIEs__item__value,
        __SecurityModeCommand_protocolIEs__item_,
        _SecurityModeCommand_protocolIEs,
        ____SecurityModeCommand_protocolExtensions__item__id_tab,
        ___SecurityModeCommand_protocolExtensions__item__id,
        ____SecurityModeCommand_protocolExtensions__item__criticality_tab,
        ___SecurityModeCommand_protocolExtensions__item__criticality,
        ____SecurityModeCommand_protocolExtensions__item__extensionValue_tab,
        ___SecurityModeCommand_protocolExtensions__item__extensionValue,
        __SecurityModeCommand_protocolExtensions__item_,
        _SecurityModeCommand_protocolExtensions,
        SecurityModeCommand,
        SecurityModeCommandIEs,
        _SecurityModeCommandIEs_val_Value_0,
        _SecurityModeCommandIEs_val_Value_1,
        _SecurityModeCommandIEs_val_Value_2,
        SecurityModeCommandExtensions,
        ____SecurityModeComplete_protocolIEs__item__id_tab,
        _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_0,
        _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_1,
        _____SecurityModeComplete_protocolIEs__item__id_tab_val_Value_2,
        ___SecurityModeComplete_protocolIEs__item__id,
        ___SecurityModeComplete_protocolIEs__item__criticality,
        ___SecurityModeComplete_protocolIEs__item__value,
        __SecurityModeComplete_protocolIEs__item_,
        _SecurityModeComplete_protocolIEs,
        ____SecurityModeComplete_protocolExtensions__item__id_tab,
        ___SecurityModeComplete_protocolExtensions__item__id,
        ____SecurityModeComplete_protocolExtensions__item__criticality_tab,
        ___SecurityModeComplete_protocolExtensions__item__criticality,
        ____SecurityModeComplete_protocolExtensions__item__extensionValue_tab,
        ___SecurityModeComplete_protocolExtensions__item__extensionValue,
        __SecurityModeComplete_protocolExtensions__item_,
        _SecurityModeComplete_protocolExtensions,
        SecurityModeComplete,
        SecurityModeCompleteIEs,
        _SecurityModeCompleteIEs_val_Value_0,
        _SecurityModeCompleteIEs_val_Value_1,
        _SecurityModeCompleteIEs_val_Value_2,
        SecurityModeCompleteExtensions,
        ____SecurityModeReject_protocolIEs__item__id_tab,
        _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_0,
        _____SecurityModeReject_protocolIEs__item__id_tab_val_Value_1,
        ___SecurityModeReject_protocolIEs__item__id,
        ___SecurityModeReject_protocolIEs__item__criticality,
        ___SecurityModeReject_protocolIEs__item__value,
        __SecurityModeReject_protocolIEs__item_,
        _SecurityModeReject_protocolIEs,
        ____SecurityModeReject_protocolExtensions__item__id_tab,
        ___SecurityModeReject_protocolExtensions__item__id,
        ____SecurityModeReject_protocolExtensions__item__criticality_tab,
        ___SecurityModeReject_protocolExtensions__item__criticality,
        ____SecurityModeReject_protocolExtensions__item__extensionValue_tab,
        ___SecurityModeReject_protocolExtensions__item__extensionValue,
        __SecurityModeReject_protocolExtensions__item_,
        _SecurityModeReject_protocolExtensions,
        SecurityModeReject,
        SecurityModeRejectIEs,
        _SecurityModeRejectIEs_val_Value_0,
        _SecurityModeRejectIEs_val_Value_1,
        SecurityModeRejectExtensions,
        ____DataVolumeReportRequest_protocolIEs__item__id_tab,
        _____DataVolumeReportRequest_protocolIEs__item__id_tab_val_Value_0,
        ___DataVolumeReportRequest_protocolIEs__item__id,
        ___DataVolumeReportRequest_protocolIEs__item__criticality,
        ___DataVolumeReportRequest_protocolIEs__item__value,
        __DataVolumeReportRequest_protocolIEs__item_,
        _DataVolumeReportRequest_protocolIEs,
        ____DataVolumeReportRequest_protocolExtensions__item__id_tab,
        ___DataVolumeReportRequest_protocolExtensions__item__id,
        ____DataVolumeReportRequest_protocolExtensions__item__criticality_tab,
        ___DataVolumeReportRequest_protocolExtensions__item__criticality,
        ____DataVolumeReportRequest_protocolExtensions__item__extensionValue_tab,
        ___DataVolumeReportRequest_protocolExtensions__item__extensionValue,
        __DataVolumeReportRequest_protocolExtensions__item_,
        _DataVolumeReportRequest_protocolExtensions,
        DataVolumeReportRequest,
        DataVolumeReportRequestIEs,
        _DataVolumeReportRequestIEs_val_Value_0,
        ____RAB_DataVolumeReportRequestList__item___item__id_tab,
        _____RAB_DataVolumeReportRequestList__item___item__id_tab_val_Value_0,
        ___RAB_DataVolumeReportRequestList__item___item__id,
        ___RAB_DataVolumeReportRequestList__item___item__criticality,
        ___RAB_DataVolumeReportRequestList__item___item__value,
        __RAB_DataVolumeReportRequestList__item___item_,
        _RAB_DataVolumeReportRequestList__item_,
        RAB_DataVolumeReportRequestList,
        RAB_DataVolumeReportRequestItemIEs,
        _RAB_DataVolumeReportRequestItemIEs_val_Value_0,
        _RAB_DataVolumeReportRequestItem_rAB_ID,
        ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__id_tab,
        ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__id,
        ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality_tab,
        ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__criticality,
        ____RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_DataVolumeReportRequestItem_iE_Extensions__item__extensionValue,
        __RAB_DataVolumeReportRequestItem_iE_Extensions__item_,
        _RAB_DataVolumeReportRequestItem_iE_Extensions,
        RAB_DataVolumeReportRequestItem,
        RAB_DataVolumeReportRequestItem_ExtIEs,
        DataVolumeReportRequestExtensions,
        ____DataVolumeReport_protocolIEs__item__id_tab,
        _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_0,
        _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_1,
        _____DataVolumeReport_protocolIEs__item__id_tab_val_Value_2,
        ___DataVolumeReport_protocolIEs__item__id,
        ___DataVolumeReport_protocolIEs__item__criticality,
        ___DataVolumeReport_protocolIEs__item__value,
        __DataVolumeReport_protocolIEs__item_,
        _DataVolumeReport_protocolIEs,
        ____DataVolumeReport_protocolExtensions__item__id_tab,
        ___DataVolumeReport_protocolExtensions__item__id,
        ____DataVolumeReport_protocolExtensions__item__criticality_tab,
        ___DataVolumeReport_protocolExtensions__item__criticality,
        ____DataVolumeReport_protocolExtensions__item__extensionValue_tab,
        ___DataVolumeReport_protocolExtensions__item__extensionValue,
        __DataVolumeReport_protocolExtensions__item_,
        _DataVolumeReport_protocolExtensions,
        DataVolumeReport,
        DataVolumeReportIEs,
        _DataVolumeReportIEs_val_Value_0,
        _DataVolumeReportIEs_val_Value_1,
        _DataVolumeReportIEs_val_Value_2,
        DataVolumeReportExtensions,
        ____RAB_FailedtoReportList__item___item__id_tab,
        _____RAB_FailedtoReportList__item___item__id_tab_val_Value_0,
        ___RAB_FailedtoReportList__item___item__id,
        ___RAB_FailedtoReportList__item___item__criticality,
        ___RAB_FailedtoReportList__item___item__value,
        __RAB_FailedtoReportList__item___item_,
        _RAB_FailedtoReportList__item_,
        RAB_FailedtoReportList,
        RABs_failed_to_reportItemIEs,
        _RABs_failed_to_reportItemIEs_val_Value_0,
        _RABs_failed_to_reportItem_rAB_ID,
        _RABs_failed_to_reportItem_cause,
        ____RABs_failed_to_reportItem_iE_Extensions__item__id_tab,
        ___RABs_failed_to_reportItem_iE_Extensions__item__id,
        ____RABs_failed_to_reportItem_iE_Extensions__item__criticality_tab,
        ___RABs_failed_to_reportItem_iE_Extensions__item__criticality,
        ____RABs_failed_to_reportItem_iE_Extensions__item__extensionValue_tab,
        ___RABs_failed_to_reportItem_iE_Extensions__item__extensionValue,
        __RABs_failed_to_reportItem_iE_Extensions__item_,
        _RABs_failed_to_reportItem_iE_Extensions,
        RABs_failed_to_reportItem,
        RABs_failed_to_reportItem_ExtIEs,
        ____Reset_protocolIEs__item__id_tab,
        _____Reset_protocolIEs__item__id_tab_val_Value_0,
        _____Reset_protocolIEs__item__id_tab_val_Value_1,
        _____Reset_protocolIEs__item__id_tab_val_Value_2,
        ___Reset_protocolIEs__item__id,
        ___Reset_protocolIEs__item__criticality,
        ___Reset_protocolIEs__item__value,
        __Reset_protocolIEs__item_,
        _Reset_protocolIEs,
        ____Reset_protocolExtensions__item__id_tab,
        _____Reset_protocolExtensions__item__id_tab_val_Extension_0,
        _____Reset_protocolExtensions__item__id_tab_val_Extension_1,
        ___Reset_protocolExtensions__item__id,
        ___Reset_protocolExtensions__item__criticality,
        ___Reset_protocolExtensions__item__extensionValue,
        __Reset_protocolExtensions__item_,
        _Reset_protocolExtensions,
        Reset,
        ResetIEs,
        _ResetIEs_val_Value_0,
        _ResetIEs_val_Value_1,
        _ResetIEs_val_Value_2,
        ResetExtensions,
        _ResetExtensions_val_Extension_0,
        _ResetExtensions_val_Extension_1,
        ____ResetAcknowledge_protocolIEs__item__id_tab,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____ResetAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        ___ResetAcknowledge_protocolIEs__item__id,
        ___ResetAcknowledge_protocolIEs__item__criticality,
        ___ResetAcknowledge_protocolIEs__item__value,
        __ResetAcknowledge_protocolIEs__item_,
        _ResetAcknowledge_protocolIEs,
        ____ResetAcknowledge_protocolExtensions__item__id_tab,
        _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_0,
        _____ResetAcknowledge_protocolExtensions__item__id_tab_val_Extension_1,
        ___ResetAcknowledge_protocolExtensions__item__id,
        ___ResetAcknowledge_protocolExtensions__item__criticality,
        ___ResetAcknowledge_protocolExtensions__item__extensionValue,
        __ResetAcknowledge_protocolExtensions__item_,
        _ResetAcknowledge_protocolExtensions,
        ResetAcknowledge,
        ResetAcknowledgeIEs,
        _ResetAcknowledgeIEs_val_Value_0,
        _ResetAcknowledgeIEs_val_Value_1,
        _ResetAcknowledgeIEs_val_Value_2,
        ResetAcknowledgeExtensions,
        _ResetAcknowledgeExtensions_val_Extension_0,
        _ResetAcknowledgeExtensions_val_Extension_1,
        ____ResetResource_protocolIEs__item__id_tab,
        _____ResetResource_protocolIEs__item__id_tab_val_Value_0,
        _____ResetResource_protocolIEs__item__id_tab_val_Value_1,
        _____ResetResource_protocolIEs__item__id_tab_val_Value_2,
        _____ResetResource_protocolIEs__item__id_tab_val_Value_3,
        ___ResetResource_protocolIEs__item__id,
        ___ResetResource_protocolIEs__item__criticality,
        ___ResetResource_protocolIEs__item__value,
        __ResetResource_protocolIEs__item_,
        _ResetResource_protocolIEs,
        ____ResetResource_protocolExtensions__item__id_tab,
        _____ResetResource_protocolExtensions__item__id_tab_val_Extension_0,
        _____ResetResource_protocolExtensions__item__id_tab_val_Extension_1,
        ___ResetResource_protocolExtensions__item__id,
        ___ResetResource_protocolExtensions__item__criticality,
        ___ResetResource_protocolExtensions__item__extensionValue,
        __ResetResource_protocolExtensions__item_,
        _ResetResource_protocolExtensions,
        ResetResource,
        ResetResourceIEs,
        _ResetResourceIEs_val_Value_0,
        _ResetResourceIEs_val_Value_1,
        _ResetResourceIEs_val_Value_2,
        _ResetResourceIEs_val_Value_3,
        ____ResetResourceList__item___item__id_tab,
        _____ResetResourceList__item___item__id_tab_val_Value_0,
        ___ResetResourceList__item___item__id,
        ___ResetResourceList__item___item__criticality,
        ___ResetResourceList__item___item__value,
        __ResetResourceList__item___item_,
        _ResetResourceList__item_,
        ResetResourceList,
        ResetResourceItemIEs,
        _ResetResourceItemIEs_val_Value_0,
        _ResetResourceItem_iuSigConId,
        ____ResetResourceItem_iE_Extensions__item__id_tab,
        _____ResetResourceItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___ResetResourceItem_iE_Extensions__item__id,
        ___ResetResourceItem_iE_Extensions__item__criticality,
        ___ResetResourceItem_iE_Extensions__item__extensionValue,
        __ResetResourceItem_iE_Extensions__item_,
        _ResetResourceItem_iE_Extensions,
        ResetResourceItem,
        ResetResourceItem_ExtIEs,
        _ResetResourceItem_ExtIEs_val_Extension_0,
        ResetResourceExtensions,
        _ResetResourceExtensions_val_Extension_0,
        _ResetResourceExtensions_val_Extension_1,
        ____ResetResourceAcknowledge_protocolIEs__item__id_tab,
        _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_0,
        _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_1,
        _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_2,
        _____ResetResourceAcknowledge_protocolIEs__item__id_tab_val_Value_3,
        ___ResetResourceAcknowledge_protocolIEs__item__id,
        ___ResetResourceAcknowledge_protocolIEs__item__criticality,
        ___ResetResourceAcknowledge_protocolIEs__item__value,
        __ResetResourceAcknowledge_protocolIEs__item_,
        _ResetResourceAcknowledge_protocolIEs,
        ____ResetResourceAcknowledge_protocolExtensions__item__id_tab,
        _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_0,
        _____ResetResourceAcknowledge_protocolExtensions__item__id_tab_val_Extension_1,
        ___ResetResourceAcknowledge_protocolExtensions__item__id,
        ___ResetResourceAcknowledge_protocolExtensions__item__criticality,
        ___ResetResourceAcknowledge_protocolExtensions__item__extensionValue,
        __ResetResourceAcknowledge_protocolExtensions__item_,
        _ResetResourceAcknowledge_protocolExtensions,
        ResetResourceAcknowledge,
        ResetResourceAcknowledgeIEs,
        _ResetResourceAcknowledgeIEs_val_Value_0,
        _ResetResourceAcknowledgeIEs_val_Value_1,
        _ResetResourceAcknowledgeIEs_val_Value_2,
        _ResetResourceAcknowledgeIEs_val_Value_3,
        ____ResetResourceAckList__item___item__id_tab,
        _____ResetResourceAckList__item___item__id_tab_val_Value_0,
        ___ResetResourceAckList__item___item__id,
        ___ResetResourceAckList__item___item__criticality,
        ___ResetResourceAckList__item___item__value,
        __ResetResourceAckList__item___item_,
        _ResetResourceAckList__item_,
        ResetResourceAckList,
        ResetResourceAckItemIEs,
        _ResetResourceAckItemIEs_val_Value_0,
        _ResetResourceAckItem_iuSigConId,
        ____ResetResourceAckItem_iE_Extensions__item__id_tab,
        _____ResetResourceAckItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___ResetResourceAckItem_iE_Extensions__item__id,
        ___ResetResourceAckItem_iE_Extensions__item__criticality,
        ___ResetResourceAckItem_iE_Extensions__item__extensionValue,
        __ResetResourceAckItem_iE_Extensions__item_,
        _ResetResourceAckItem_iE_Extensions,
        ResetResourceAckItem,
        ResetResourceAckItem_ExtIEs,
        _ResetResourceAckItem_ExtIEs_val_Extension_0,
        ResetResourceAcknowledgeExtensions,
        _ResetResourceAcknowledgeExtensions_val_Extension_0,
        _ResetResourceAcknowledgeExtensions_val_Extension_1,
        ____RAB_ReleaseRequest_protocolIEs__item__id_tab,
        _____RAB_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        ___RAB_ReleaseRequest_protocolIEs__item__id,
        ___RAB_ReleaseRequest_protocolIEs__item__criticality,
        ___RAB_ReleaseRequest_protocolIEs__item__value,
        __RAB_ReleaseRequest_protocolIEs__item_,
        _RAB_ReleaseRequest_protocolIEs,
        ____RAB_ReleaseRequest_protocolExtensions__item__id_tab,
        ___RAB_ReleaseRequest_protocolExtensions__item__id,
        ____RAB_ReleaseRequest_protocolExtensions__item__criticality_tab,
        ___RAB_ReleaseRequest_protocolExtensions__item__criticality,
        ____RAB_ReleaseRequest_protocolExtensions__item__extensionValue_tab,
        ___RAB_ReleaseRequest_protocolExtensions__item__extensionValue,
        __RAB_ReleaseRequest_protocolExtensions__item_,
        _RAB_ReleaseRequest_protocolExtensions,
        RAB_ReleaseRequest,
        RAB_ReleaseRequestIEs,
        _RAB_ReleaseRequestIEs_val_Value_0,
        ____RAB_ReleaseList__item___item__id_tab,
        _____RAB_ReleaseList__item___item__id_tab_val_Value_0,
        ___RAB_ReleaseList__item___item__id,
        ___RAB_ReleaseList__item___item__criticality,
        ___RAB_ReleaseList__item___item__value,
        __RAB_ReleaseList__item___item_,
        _RAB_ReleaseList__item_,
        RAB_ReleaseList,
        RAB_ReleaseItemIEs,
        _RAB_ReleaseItemIEs_val_Value_0,
        _RAB_ReleaseItem_rAB_ID,
        _RAB_ReleaseItem_cause,
        ____RAB_ReleaseItem_iE_Extensions__item__id_tab,
        ___RAB_ReleaseItem_iE_Extensions__item__id,
        ____RAB_ReleaseItem_iE_Extensions__item__criticality_tab,
        ___RAB_ReleaseItem_iE_Extensions__item__criticality,
        ____RAB_ReleaseItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_ReleaseItem_iE_Extensions__item__extensionValue,
        __RAB_ReleaseItem_iE_Extensions__item_,
        _RAB_ReleaseItem_iE_Extensions,
        RAB_ReleaseItem,
        RAB_ReleaseItem_ExtIEs,
        RAB_ReleaseRequestExtensions,
        ____Iu_ReleaseRequest_protocolIEs__item__id_tab,
        _____Iu_ReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        ___Iu_ReleaseRequest_protocolIEs__item__id,
        ___Iu_ReleaseRequest_protocolIEs__item__criticality,
        ___Iu_ReleaseRequest_protocolIEs__item__value,
        __Iu_ReleaseRequest_protocolIEs__item_,
        _Iu_ReleaseRequest_protocolIEs,
        ____Iu_ReleaseRequest_protocolExtensions__item__id_tab,
        ___Iu_ReleaseRequest_protocolExtensions__item__id,
        ____Iu_ReleaseRequest_protocolExtensions__item__criticality_tab,
        ___Iu_ReleaseRequest_protocolExtensions__item__criticality,
        ____Iu_ReleaseRequest_protocolExtensions__item__extensionValue_tab,
        ___Iu_ReleaseRequest_protocolExtensions__item__extensionValue,
        __Iu_ReleaseRequest_protocolExtensions__item_,
        _Iu_ReleaseRequest_protocolExtensions,
        Iu_ReleaseRequest,
        Iu_ReleaseRequestIEs,
        _Iu_ReleaseRequestIEs_val_Value_0,
        Iu_ReleaseRequestExtensions,
        ____RelocationDetect_protocolIEs__item__id_tab,
        ___RelocationDetect_protocolIEs__item__id,
        ____RelocationDetect_protocolIEs__item__criticality_tab,
        ___RelocationDetect_protocolIEs__item__criticality,
        ____RelocationDetect_protocolIEs__item__value_tab,
        ___RelocationDetect_protocolIEs__item__value,
        __RelocationDetect_protocolIEs__item_,
        _RelocationDetect_protocolIEs,
        ____RelocationDetect_protocolExtensions__item__id_tab,
        ___RelocationDetect_protocolExtensions__item__id,
        ____RelocationDetect_protocolExtensions__item__criticality_tab,
        ___RelocationDetect_protocolExtensions__item__criticality,
        ____RelocationDetect_protocolExtensions__item__extensionValue_tab,
        ___RelocationDetect_protocolExtensions__item__extensionValue,
        __RelocationDetect_protocolExtensions__item_,
        _RelocationDetect_protocolExtensions,
        RelocationDetect,
        RelocationDetectIEs,
        RelocationDetectExtensions,
        ____RelocationComplete_protocolIEs__item__id_tab,
        ___RelocationComplete_protocolIEs__item__id,
        ____RelocationComplete_protocolIEs__item__criticality_tab,
        ___RelocationComplete_protocolIEs__item__criticality,
        ____RelocationComplete_protocolIEs__item__value_tab,
        ___RelocationComplete_protocolIEs__item__value,
        __RelocationComplete_protocolIEs__item_,
        _RelocationComplete_protocolIEs,
        ____RelocationComplete_protocolExtensions__item__id_tab,
        _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_0,
        _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_1,
        _____RelocationComplete_protocolExtensions__item__id_tab_val_Extension_2,
        ___RelocationComplete_protocolExtensions__item__id,
        ___RelocationComplete_protocolExtensions__item__criticality,
        ___RelocationComplete_protocolExtensions__item__extensionValue,
        __RelocationComplete_protocolExtensions__item_,
        _RelocationComplete_protocolExtensions,
        RelocationComplete,
        RelocationCompleteIEs,
        RelocationCompleteExtensions,
        _RelocationCompleteExtensions_val_Extension_0,
        _RelocationCompleteExtensions_val_Extension_1,
        _RelocationCompleteExtensions_val_Extension_2,
        ____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_1,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_2,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_3,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_4,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_5,
        _____EnhancedRelocationCompleteRequest_protocolIEs__item__id_tab_val_Value_6,
        ___EnhancedRelocationCompleteRequest_protocolIEs__item__id,
        ___EnhancedRelocationCompleteRequest_protocolIEs__item__criticality,
        ___EnhancedRelocationCompleteRequest_protocolIEs__item__value,
        __EnhancedRelocationCompleteRequest_protocolIEs__item_,
        _EnhancedRelocationCompleteRequest_protocolIEs,
        ____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_5,
        _____EnhancedRelocationCompleteRequest_protocolExtensions__item__id_tab_val_Extension_6,
        ___EnhancedRelocationCompleteRequest_protocolExtensions__item__id,
        ___EnhancedRelocationCompleteRequest_protocolExtensions__item__criticality,
        ___EnhancedRelocationCompleteRequest_protocolExtensions__item__extensionValue,
        __EnhancedRelocationCompleteRequest_protocolExtensions__item_,
        _EnhancedRelocationCompleteRequest_protocolExtensions,
        EnhancedRelocationCompleteRequest,
        EnhancedRelocationCompleteRequestIEs,
        _EnhancedRelocationCompleteRequestIEs_val_Value_0,
        _EnhancedRelocationCompleteRequestIEs_val_Value_1,
        _EnhancedRelocationCompleteRequestIEs_val_Value_2,
        _EnhancedRelocationCompleteRequestIEs_val_Value_3,
        _EnhancedRelocationCompleteRequestIEs_val_Value_4,
        _EnhancedRelocationCompleteRequestIEs_val_Value_5,
        _EnhancedRelocationCompleteRequestIEs_val_Value_6,
        ____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab,
        _____RAB_SetupList_EnhancedRelocCompleteReq__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__id,
        ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__criticality,
        ___RAB_SetupList_EnhancedRelocCompleteReq__item___item__value,
        __RAB_SetupList_EnhancedRelocCompleteReq__item___item_,
        _RAB_SetupList_EnhancedRelocCompleteReq__item_,
        RAB_SetupList_EnhancedRelocCompleteReq,
        RAB_SetupItem_EnhancedRelocCompleteReq_IEs,
        _RAB_SetupItem_EnhancedRelocCompleteReq_IEs_val_Value_0,
        _RAB_SetupItem_EnhancedRelocCompleteReq_rAB_ID,
        _RAB_SetupItem_EnhancedRelocCompleteReq_transportLayerAddressReq1,
        _RAB_SetupItem_EnhancedRelocCompleteReq_iuTransportAssociationReq1,
        _RAB_SetupItem_EnhancedRelocCompleteReq_ass_RAB_Parameters,
        ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id_tab,
        ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__id,
        ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality_tab,
        ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__criticality,
        ____RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue_tab,
        ___RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions__item_,
        _RAB_SetupItem_EnhancedRelocCompleteReq_iE_Extensions,
        RAB_SetupItem_EnhancedRelocCompleteReq,
        RAB_SetupItem_EnhancedRelocCompleteReq_ExtIEs,
        EnhancedRelocationCompleteRequestExtensions,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_0,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_1,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_2,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_3,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_4,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_5,
        _EnhancedRelocationCompleteRequestExtensions_val_Extension_6,
        ____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab,
        _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_1,
        _____EnhancedRelocationCompleteResponse_protocolIEs__item__id_tab_val_Value_2,
        ___EnhancedRelocationCompleteResponse_protocolIEs__item__id,
        ___EnhancedRelocationCompleteResponse_protocolIEs__item__criticality,
        ___EnhancedRelocationCompleteResponse_protocolIEs__item__value,
        __EnhancedRelocationCompleteResponse_protocolIEs__item_,
        _EnhancedRelocationCompleteResponse_protocolIEs,
        ____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab,
        _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_0,
        _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_1,
        _____EnhancedRelocationCompleteResponse_protocolExtensions__item__id_tab_val_Extension_2,
        ___EnhancedRelocationCompleteResponse_protocolExtensions__item__id,
        ___EnhancedRelocationCompleteResponse_protocolExtensions__item__criticality,
        ___EnhancedRelocationCompleteResponse_protocolExtensions__item__extensionValue,
        __EnhancedRelocationCompleteResponse_protocolExtensions__item_,
        _EnhancedRelocationCompleteResponse_protocolExtensions,
        EnhancedRelocationCompleteResponse,
        EnhancedRelocationCompleteResponseIEs,
        _EnhancedRelocationCompleteResponseIEs_val_Value_0,
        _EnhancedRelocationCompleteResponseIEs_val_Value_1,
        _EnhancedRelocationCompleteResponseIEs_val_Value_2,
        ____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab,
        _____RAB_SetupList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__id,
        ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__criticality,
        ___RAB_SetupList_EnhancedRelocCompleteRes__item___item__value,
        __RAB_SetupList_EnhancedRelocCompleteRes__item___item_,
        _RAB_SetupList_EnhancedRelocCompleteRes__item_,
        RAB_SetupList_EnhancedRelocCompleteRes,
        RAB_SetupItem_EnhancedRelocCompleteRes_IEs,
        _RAB_SetupItem_EnhancedRelocCompleteRes_IEs_val_Value_0,
        _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_ID,
        _RAB_SetupItem_EnhancedRelocCompleteRes_rAB_Parameters,
        _RAB_SetupItem_EnhancedRelocCompleteRes_userPlaneInformation,
        _RAB_SetupItem_EnhancedRelocCompleteRes_transportLayerAddressRes1,
        _RAB_SetupItem_EnhancedRelocCompleteRes_iuTransportAssociationRes1,
        _RAB_SetupItem_EnhancedRelocCompleteRes_rab2beReleasedList,
        ____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab,
        _____RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab_val_Extension_0,
        ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__id,
        ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality,
        ___RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions__item_,
        _RAB_SetupItem_EnhancedRelocCompleteRes_iE_Extensions,
        RAB_SetupItem_EnhancedRelocCompleteRes,
        RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs,
        _RAB_SetupItem_EnhancedRelocCompleteRes_ExtIEs_val_Extension_0,
        ____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab,
        _____RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id_tab_val_Value_0,
        ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__id,
        ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__criticality,
        ___RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item__value,
        __RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item___item_,
        _RAB_ToBeReleasedList_EnhancedRelocCompleteRes__item_,
        RAB_ToBeReleasedList_EnhancedRelocCompleteRes,
        RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs,
        _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_IEs_val_Value_0,
        _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_rAB_ID,
        _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_cause,
        ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id_tab,
        ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__id,
        ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality_tab,
        ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__criticality,
        ____RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue_tab,
        ___RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item__extensionValue,
        __RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions__item_,
        _RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_iE_Extensions,
        RAB_ToBeReleasedItem_EnhancedRelocCompleteRes,
        RAB_ToBeReleasedItem_EnhancedRelocCompleteRes_ExtIEs,
        EnhancedRelocationCompleteResponseExtensions,
        _EnhancedRelocationCompleteResponseExtensions_val_Extension_0,
        _EnhancedRelocationCompleteResponseExtensions_val_Extension_1,
        _EnhancedRelocationCompleteResponseExtensions_val_Extension_2,
        ____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab,
        _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_0,
        _____EnhancedRelocationCompleteFailure_protocolIEs__item__id_tab_val_Value_1,
        ___EnhancedRelocationCompleteFailure_protocolIEs__item__id,
        ___EnhancedRelocationCompleteFailure_protocolIEs__item__criticality,
        ___EnhancedRelocationCompleteFailure_protocolIEs__item__value,
        __EnhancedRelocationCompleteFailure_protocolIEs__item_,
        _EnhancedRelocationCompleteFailure_protocolIEs,
        ____EnhancedRelocationCompleteFailure_protocolExtensions__item__id_tab,
        ___EnhancedRelocationCompleteFailure_protocolExtensions__item__id,
        ____EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationCompleteFailure_protocolExtensions__item__criticality,
        ____EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationCompleteFailure_protocolExtensions__item__extensionValue,
        __EnhancedRelocationCompleteFailure_protocolExtensions__item_,
        _EnhancedRelocationCompleteFailure_protocolExtensions,
        EnhancedRelocationCompleteFailure,
        EnhancedRelocationCompleteFailureIEs,
        _EnhancedRelocationCompleteFailureIEs_val_Value_0,
        _EnhancedRelocationCompleteFailureIEs_val_Value_1,
        EnhancedRelocationCompleteFailureExtensions,
        ____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab,
        _____EnhancedRelocationCompleteConfirm_protocolIEs__item__id_tab_val_Value_0,
        ___EnhancedRelocationCompleteConfirm_protocolIEs__item__id,
        ___EnhancedRelocationCompleteConfirm_protocolIEs__item__criticality,
        ___EnhancedRelocationCompleteConfirm_protocolIEs__item__value,
        __EnhancedRelocationCompleteConfirm_protocolIEs__item_,
        _EnhancedRelocationCompleteConfirm_protocolIEs,
        ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__id_tab,
        ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__id,
        ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality_tab,
        ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__criticality,
        ____EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue_tab,
        ___EnhancedRelocationCompleteConfirm_protocolExtensions__item__extensionValue,
        __EnhancedRelocationCompleteConfirm_protocolExtensions__item_,
        _EnhancedRelocationCompleteConfirm_protocolExtensions,
        EnhancedRelocationCompleteConfirm,
        EnhancedRelocationCompleteConfirmIEs,
        _EnhancedRelocationCompleteConfirmIEs_val_Value_0,
        EnhancedRelocationCompleteConfirmExtensions,
        ____Paging_protocolIEs__item__id_tab,
        _____Paging_protocolIEs__item__id_tab_val_Value_0,
        _____Paging_protocolIEs__item__id_tab_val_Value_1,
        _____Paging_protocolIEs__item__id_tab_val_Value_2,
        _____Paging_protocolIEs__item__id_tab_val_Value_3,
        _____Paging_protocolIEs__item__id_tab_val_Value_4,
        _____Paging_protocolIEs__item__id_tab_val_Value_5,
        _____Paging_protocolIEs__item__id_tab_val_Value_6,
        ___Paging_protocolIEs__item__id,
        ___Paging_protocolIEs__item__criticality,
        ___Paging_protocolIEs__item__value,
        __Paging_protocolIEs__item_,
        _Paging_protocolIEs,
        ____Paging_protocolExtensions__item__id_tab,
        _____Paging_protocolExtensions__item__id_tab_val_Extension_0,
        _____Paging_protocolExtensions__item__id_tab_val_Extension_1,
        ___Paging_protocolExtensions__item__id,
        ___Paging_protocolExtensions__item__criticality,
        ___Paging_protocolExtensions__item__extensionValue,
        __Paging_protocolExtensions__item_,
        _Paging_protocolExtensions,
        Paging,
        PagingIEs,
        _PagingIEs_val_Value_0,
        _PagingIEs_val_Value_1,
        _PagingIEs_val_Value_2,
        _PagingIEs_val_Value_3,
        _PagingIEs_val_Value_4,
        _PagingIEs_val_Value_5,
        _PagingIEs_val_Value_6,
        PagingExtensions,
        _PagingExtensions_val_Extension_0,
        _PagingExtensions_val_Extension_1,
        ____CommonID_protocolIEs__item__id_tab,
        _____CommonID_protocolIEs__item__id_tab_val_Value_0,
        ___CommonID_protocolIEs__item__id,
        ___CommonID_protocolIEs__item__criticality,
        ___CommonID_protocolIEs__item__value,
        __CommonID_protocolIEs__item_,
        _CommonID_protocolIEs,
        ____CommonID_protocolExtensions__item__id_tab,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_0,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_1,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_2,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_3,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_4,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_5,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_6,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_7,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_8,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_9,
        _____CommonID_protocolExtensions__item__id_tab_val_Extension_10,
        ___CommonID_protocolExtensions__item__id,
        ___CommonID_protocolExtensions__item__criticality,
        ___CommonID_protocolExtensions__item__extensionValue,
        __CommonID_protocolExtensions__item_,
        _CommonID_protocolExtensions,
        CommonID,
        CommonID_IEs,
        _CommonID_IEs_val_Value_0,
        CommonIDExtensions,
        _CommonIDExtensions_val_Extension_0,
        _CommonIDExtensions_val_Extension_1,
        _CommonIDExtensions_val_Extension_2,
        _CommonIDExtensions_val_Extension_3,
        _CommonIDExtensions_val_Extension_4,
        _CommonIDExtensions_val_Extension_5,
        _CommonIDExtensions_val_Extension_6,
        _CommonIDExtensions_val_Extension_7,
        _CommonIDExtensions_val_Extension_8,
        _CommonIDExtensions_val_Extension_9,
        _CommonIDExtensions_val_Extension_10,
        ____CN_InvokeTrace_protocolIEs__item__id_tab,
        _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_1,
        _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_2,
        _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_3,
        _____CN_InvokeTrace_protocolIEs__item__id_tab_val_Value_4,
        ___CN_InvokeTrace_protocolIEs__item__id,
        ___CN_InvokeTrace_protocolIEs__item__criticality,
        ___CN_InvokeTrace_protocolIEs__item__value,
        __CN_InvokeTrace_protocolIEs__item_,
        _CN_InvokeTrace_protocolIEs,
        ____CN_InvokeTrace_protocolExtensions__item__id_tab,
        _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_0,
        _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_1,
        _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_2,
        _____CN_InvokeTrace_protocolExtensions__item__id_tab_val_Extension_3,
        ___CN_InvokeTrace_protocolExtensions__item__id,
        ___CN_InvokeTrace_protocolExtensions__item__criticality,
        ___CN_InvokeTrace_protocolExtensions__item__extensionValue,
        __CN_InvokeTrace_protocolExtensions__item_,
        _CN_InvokeTrace_protocolExtensions,
        CN_InvokeTrace,
        CN_InvokeTraceIEs,
        _CN_InvokeTraceIEs_val_Value_0,
        _CN_InvokeTraceIEs_val_Value_1,
        _CN_InvokeTraceIEs_val_Value_2,
        _CN_InvokeTraceIEs_val_Value_3,
        _CN_InvokeTraceIEs_val_Value_4,
        CN_InvokeTraceExtensions,
        _CN_InvokeTraceExtensions_val_Extension_0,
        _CN_InvokeTraceExtensions_val_Extension_1,
        _CN_InvokeTraceExtensions_val_Extension_2,
        _CN_InvokeTraceExtensions_val_Extension_3,
        ____CN_DeactivateTrace_protocolIEs__item__id_tab,
        _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_0,
        _____CN_DeactivateTrace_protocolIEs__item__id_tab_val_Value_1,
        ___CN_DeactivateTrace_protocolIEs__item__id,
        ___CN_DeactivateTrace_protocolIEs__item__criticality,
        ___CN_DeactivateTrace_protocolIEs__item__value,
        __CN_DeactivateTrace_protocolIEs__item_,
        _CN_DeactivateTrace_protocolIEs,
        ____CN_DeactivateTrace_protocolExtensions__item__id_tab,
        ___CN_DeactivateTrace_protocolExtensions__item__id,
        ____CN_DeactivateTrace_protocolExtensions__item__criticality_tab,
        ___CN_DeactivateTrace_protocolExtensions__item__criticality,
        ____CN_DeactivateTrace_protocolExtensions__item__extensionValue_tab,
        ___CN_DeactivateTrace_protocolExtensions__item__extensionValue,
        __CN_DeactivateTrace_protocolExtensions__item_,
        _CN_DeactivateTrace_protocolExtensions,
        CN_DeactivateTrace,
        CN_DeactivateTraceIEs,
        _CN_DeactivateTraceIEs_val_Value_0,
        _CN_DeactivateTraceIEs_val_Value_1,
        CN_DeactivateTraceExtensions,
        ____LocationReportingControl_protocolIEs__item__id_tab,
        _____LocationReportingControl_protocolIEs__item__id_tab_val_Value_0,
        ___LocationReportingControl_protocolIEs__item__id,
        ___LocationReportingControl_protocolIEs__item__criticality,
        ___LocationReportingControl_protocolIEs__item__value,
        __LocationReportingControl_protocolIEs__item_,
        _LocationReportingControl_protocolIEs,
        ____LocationReportingControl_protocolExtensions__item__id_tab,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_0,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_1,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_2,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_3,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_4,
        _____LocationReportingControl_protocolExtensions__item__id_tab_val_Extension_5,
        ___LocationReportingControl_protocolExtensions__item__id,
        ___LocationReportingControl_protocolExtensions__item__criticality,
        ___LocationReportingControl_protocolExtensions__item__extensionValue,
        __LocationReportingControl_protocolExtensions__item_,
        _LocationReportingControl_protocolExtensions,
        LocationReportingControl,
        LocationReportingControlIEs,
        _LocationReportingControlIEs_val_Value_0,
        LocationReportingControlExtensions,
        _LocationReportingControlExtensions_val_Extension_0,
        _LocationReportingControlExtensions_val_Extension_1,
        _LocationReportingControlExtensions_val_Extension_2,
        _LocationReportingControlExtensions_val_Extension_3,
        _LocationReportingControlExtensions_val_Extension_4,
        _LocationReportingControlExtensions_val_Extension_5,
        ____LocationReport_protocolIEs__item__id_tab,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_0,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_1,
        _____LocationReport_protocolIEs__item__id_tab_val_Value_2,
        ___LocationReport_protocolIEs__item__id,
        ___LocationReport_protocolIEs__item__criticality,
        ___LocationReport_protocolIEs__item__value,
        __LocationReport_protocolIEs__item_,
        _LocationReport_protocolIEs,
        ____LocationReport_protocolExtensions__item__id_tab,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_0,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_1,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_2,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_3,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_4,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_5,
        _____LocationReport_protocolExtensions__item__id_tab_val_Extension_6,
        ___LocationReport_protocolExtensions__item__id,
        ___LocationReport_protocolExtensions__item__criticality,
        ___LocationReport_protocolExtensions__item__extensionValue,
        __LocationReport_protocolExtensions__item_,
        _LocationReport_protocolExtensions,
        LocationReport,
        LocationReportIEs,
        _LocationReportIEs_val_Value_0,
        _LocationReportIEs_val_Value_1,
        _LocationReportIEs_val_Value_2,
        LocationReportExtensions,
        _LocationReportExtensions_val_Extension_0,
        _LocationReportExtensions_val_Extension_1,
        _LocationReportExtensions_val_Extension_2,
        _LocationReportExtensions_val_Extension_3,
        _LocationReportExtensions_val_Extension_4,
        _LocationReportExtensions_val_Extension_5,
        _LocationReportExtensions_val_Extension_6,
        ____InitialUE_Message_protocolIEs__item__id_tab,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_0,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_1,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_2,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_3,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_4,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_5,
        _____InitialUE_Message_protocolIEs__item__id_tab_val_Value_6,
        ___InitialUE_Message_protocolIEs__item__id,
        ___InitialUE_Message_protocolIEs__item__criticality,
        ___InitialUE_Message_protocolIEs__item__value,
        __InitialUE_Message_protocolIEs__item_,
        _InitialUE_Message_protocolIEs,
        ____InitialUE_Message_protocolExtensions__item__id_tab,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_0,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_1,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_2,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_3,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_4,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_5,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_6,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_7,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_8,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_9,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_10,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_11,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_12,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_13,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_14,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_15,
        _____InitialUE_Message_protocolExtensions__item__id_tab_val_Extension_16,
        ___InitialUE_Message_protocolExtensions__item__id,
        ___InitialUE_Message_protocolExtensions__item__criticality,
        ___InitialUE_Message_protocolExtensions__item__extensionValue,
        __InitialUE_Message_protocolExtensions__item_,
        _InitialUE_Message_protocolExtensions,
        InitialUE_Message,
        InitialUE_MessageIEs,
        _InitialUE_MessageIEs_val_Value_0,
        _InitialUE_MessageIEs_val_Value_1,
        _InitialUE_MessageIEs_val_Value_2,
        _InitialUE_MessageIEs_val_Value_3,
        _InitialUE_MessageIEs_val_Value_4,
        _InitialUE_MessageIEs_val_Value_5,
        _InitialUE_MessageIEs_val_Value_6,
        InitialUE_MessageExtensions,
        _InitialUE_MessageExtensions_val_Extension_0,
        _InitialUE_MessageExtensions_val_Extension_1,
        _InitialUE_MessageExtensions_val_Extension_2,
        _InitialUE_MessageExtensions_val_Extension_3,
        _InitialUE_MessageExtensions_val_Extension_4,
        _InitialUE_MessageExtensions_val_Extension_5,
        _InitialUE_MessageExtensions_val_Extension_6,
        _InitialUE_MessageExtensions_val_Extension_7,
        _InitialUE_MessageExtensions_val_Extension_8,
        _InitialUE_MessageExtensions_val_Extension_9,
        _InitialUE_MessageExtensions_val_Extension_10,
        _InitialUE_MessageExtensions_val_Extension_11,
        _InitialUE_MessageExtensions_val_Extension_12,
        _InitialUE_MessageExtensions_val_Extension_13,
        _InitialUE_MessageExtensions_val_Extension_14,
        _InitialUE_MessageExtensions_val_Extension_15,
        _InitialUE_MessageExtensions_val_Extension_16,
        ____DirectTransfer_protocolIEs__item__id_tab,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_3,
        _____DirectTransfer_protocolIEs__item__id_tab_val_Value_4,
        ___DirectTransfer_protocolIEs__item__id,
        ___DirectTransfer_protocolIEs__item__criticality,
        ___DirectTransfer_protocolIEs__item__value,
        __DirectTransfer_protocolIEs__item_,
        _DirectTransfer_protocolIEs,
        ____DirectTransfer_protocolExtensions__item__id_tab,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_0,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_1,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_2,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_3,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_4,
        _____DirectTransfer_protocolExtensions__item__id_tab_val_Extension_5,
        ___DirectTransfer_protocolExtensions__item__id,
        ___DirectTransfer_protocolExtensions__item__criticality,
        ___DirectTransfer_protocolExtensions__item__extensionValue,
        __DirectTransfer_protocolExtensions__item_,
        _DirectTransfer_protocolExtensions,
        DirectTransfer,
        DirectTransferIEs,
        _DirectTransferIEs_val_Value_0,
        _DirectTransferIEs_val_Value_1,
        _DirectTransferIEs_val_Value_2,
        _DirectTransferIEs_val_Value_3,
        _DirectTransferIEs_val_Value_4,
        DirectTransferExtensions,
        _DirectTransferExtensions_val_Extension_0,
        _DirectTransferExtensions_val_Extension_1,
        _DirectTransferExtensions_val_Extension_2,
        _DirectTransferExtensions_val_Extension_3,
        _DirectTransferExtensions_val_Extension_4,
        _DirectTransferExtensions_val_Extension_5,
        ___RedirectionIndication__item__id_tab,
        ____RedirectionIndication__item__id_tab_val_Value_0,
        ____RedirectionIndication__item__id_tab_val_Value_1,
        ____RedirectionIndication__item__id_tab_val_Value_2,
        ____RedirectionIndication__item__id_tab_val_Value_3,
        ____RedirectionIndication__item__id_tab_val_Value_4,
        __RedirectionIndication__item__id,
        __RedirectionIndication__item__criticality,
        __RedirectionIndication__item__value,
        _RedirectionIndication__item_,
        RedirectionIndication,
        RedirectionIndication_IEs,
        _RedirectionIndication_IEs_val_Value_0,
        _RedirectionIndication_IEs_val_Value_1,
        _RedirectionIndication_IEs_val_Value_2,
        _RedirectionIndication_IEs_val_Value_3,
        _RedirectionIndication_IEs_val_Value_4,
        ____Overload_protocolIEs__item__id_tab,
        _____Overload_protocolIEs__item__id_tab_val_Value_0,
        _____Overload_protocolIEs__item__id_tab_val_Value_1,
        ___Overload_protocolIEs__item__id,
        ___Overload_protocolIEs__item__criticality,
        ___Overload_protocolIEs__item__value,
        __Overload_protocolIEs__item_,
        _Overload_protocolIEs,
        ____Overload_protocolExtensions__item__id_tab,
        _____Overload_protocolExtensions__item__id_tab_val_Extension_0,
        _____Overload_protocolExtensions__item__id_tab_val_Extension_1,
        _____Overload_protocolExtensions__item__id_tab_val_Extension_2,
        _____Overload_protocolExtensions__item__id_tab_val_Extension_3,
        ___Overload_protocolExtensions__item__id,
        ___Overload_protocolExtensions__item__criticality,
        ___Overload_protocolExtensions__item__extensionValue,
        __Overload_protocolExtensions__item_,
        _Overload_protocolExtensions,
        Overload,
        OverloadIEs,
        _OverloadIEs_val_Value_0,
        _OverloadIEs_val_Value_1,
        OverloadExtensions,
        _OverloadExtensions_val_Extension_0,
        _OverloadExtensions_val_Extension_1,
        _OverloadExtensions_val_Extension_2,
        _OverloadExtensions_val_Extension_3,
        ____ErrorIndication_protocolIEs__item__id_tab,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_0,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_1,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_2,
        _____ErrorIndication_protocolIEs__item__id_tab_val_Value_3,
        ___ErrorIndication_protocolIEs__item__id,
        ___ErrorIndication_protocolIEs__item__criticality,
        ___ErrorIndication_protocolIEs__item__value,
        __ErrorIndication_protocolIEs__item_,
        _ErrorIndication_protocolIEs,
        ____ErrorIndication_protocolExtensions__item__id_tab,
        _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_0,
        _____ErrorIndication_protocolExtensions__item__id_tab_val_Extension_1,
        ___ErrorIndication_protocolExtensions__item__id,
        ___ErrorIndication_protocolExtensions__item__criticality,
        ___ErrorIndication_protocolExtensions__item__extensionValue,
        __ErrorIndication_protocolExtensions__item_,
        _ErrorIndication_protocolExtensions,
        ErrorIndication,
        ErrorIndicationIEs,
        _ErrorIndicationIEs_val_Value_0,
        _ErrorIndicationIEs_val_Value_1,
        _ErrorIndicationIEs_val_Value_2,
        _ErrorIndicationIEs_val_Value_3,
        ErrorIndicationExtensions,
        _ErrorIndicationExtensions_val_Extension_0,
        _ErrorIndicationExtensions_val_Extension_1,
        ____SRNS_DataForwardCommand_protocolIEs__item__id_tab,
        _____SRNS_DataForwardCommand_protocolIEs__item__id_tab_val_Value_0,
        ___SRNS_DataForwardCommand_protocolIEs__item__id,
        ___SRNS_DataForwardCommand_protocolIEs__item__criticality,
        ___SRNS_DataForwardCommand_protocolIEs__item__value,
        __SRNS_DataForwardCommand_protocolIEs__item_,
        _SRNS_DataForwardCommand_protocolIEs,
        ____SRNS_DataForwardCommand_protocolExtensions__item__id_tab,
        ___SRNS_DataForwardCommand_protocolExtensions__item__id,
        ____SRNS_DataForwardCommand_protocolExtensions__item__criticality_tab,
        ___SRNS_DataForwardCommand_protocolExtensions__item__criticality,
        ____SRNS_DataForwardCommand_protocolExtensions__item__extensionValue_tab,
        ___SRNS_DataForwardCommand_protocolExtensions__item__extensionValue,
        __SRNS_DataForwardCommand_protocolExtensions__item_,
        _SRNS_DataForwardCommand_protocolExtensions,
        SRNS_DataForwardCommand,
        SRNS_DataForwardCommandIEs,
        _SRNS_DataForwardCommandIEs_val_Value_0,
        SRNS_DataForwardCommandExtensions,
        ____ForwardSRNS_Context_protocolIEs__item__id_tab,
        _____ForwardSRNS_Context_protocolIEs__item__id_tab_val_Value_0,
        ___ForwardSRNS_Context_protocolIEs__item__id,
        ___ForwardSRNS_Context_protocolIEs__item__criticality,
        ___ForwardSRNS_Context_protocolIEs__item__value,
        __ForwardSRNS_Context_protocolIEs__item_,
        _ForwardSRNS_Context_protocolIEs,
        ____ForwardSRNS_Context_protocolExtensions__item__id_tab,
        _____ForwardSRNS_Context_protocolExtensions__item__id_tab_val_Extension_0,
        ___ForwardSRNS_Context_protocolExtensions__item__id,
        ___ForwardSRNS_Context_protocolExtensions__item__criticality,
        ___ForwardSRNS_Context_protocolExtensions__item__extensionValue,
        __ForwardSRNS_Context_protocolExtensions__item_,
        _ForwardSRNS_Context_protocolExtensions,
        ForwardSRNS_Context,
        ForwardSRNS_ContextIEs,
        _ForwardSRNS_ContextIEs_val_Value_0,
        ForwardSRNS_ContextExtensions,
        _ForwardSRNS_ContextExtensions_val_Extension_0,
        ____RAB_AssignmentRequest_protocolIEs__item__id_tab,
        _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RAB_AssignmentRequest_protocolIEs__item__id_tab_val_Value_1,
        ___RAB_AssignmentRequest_protocolIEs__item__id,
        ___RAB_AssignmentRequest_protocolIEs__item__criticality,
        ___RAB_AssignmentRequest_protocolIEs__item__value,
        __RAB_AssignmentRequest_protocolIEs__item_,
        _RAB_AssignmentRequest_protocolIEs,
        ____RAB_AssignmentRequest_protocolExtensions__item__id_tab,
        _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____RAB_AssignmentRequest_protocolExtensions__item__id_tab_val_Extension_1,
        ___RAB_AssignmentRequest_protocolExtensions__item__id,
        ___RAB_AssignmentRequest_protocolExtensions__item__criticality,
        ___RAB_AssignmentRequest_protocolExtensions__item__extensionValue,
        __RAB_AssignmentRequest_protocolExtensions__item_,
        _RAB_AssignmentRequest_protocolExtensions,
        RAB_AssignmentRequest,
        RAB_AssignmentRequestIEs,
        _RAB_AssignmentRequestIEs_val_Value_0,
        _RAB_AssignmentRequestIEs_val_Value_1,
        ____RAB_SetupOrModifyList__item___item__id_tab,
        _____RAB_SetupOrModifyList__item___item__id_tab_val_FirstValue_0,
        _____RAB_SetupOrModifyList__item___item__id_tab_val_SecondValue_0,
        ___RAB_SetupOrModifyList__item___item__id,
        ___RAB_SetupOrModifyList__item___item__firstCriticality,
        ___RAB_SetupOrModifyList__item___item__firstValue,
        ___RAB_SetupOrModifyList__item___item__secondCriticality,
        ___RAB_SetupOrModifyList__item___item__secondValue,
        __RAB_SetupOrModifyList__item___item_,
        _RAB_SetupOrModifyList__item_,
        RAB_SetupOrModifyList,
        RAB_SetupOrModifyItem_IEs,
        _RAB_SetupOrModifyItem_IEs_val_FirstValue_0,
        _RAB_SetupOrModifyItem_IEs_val_SecondValue_0,
        _RAB_SetupOrModifyItemFirst_rAB_ID,
        _RAB_SetupOrModifyItemFirst_nAS_SynchronisationIndicator,
        _RAB_SetupOrModifyItemFirst_rAB_Parameters,
        _RAB_SetupOrModifyItemFirst_userPlaneInformation,
        _RAB_SetupOrModifyItemFirst_transportLayerInformation,
        _RAB_SetupOrModifyItemFirst_service_Handover,
        ____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab,
        _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_1,
        _____RAB_SetupOrModifyItemFirst_iE_Extensions__item__id_tab_val_Extension_2,
        ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__id,
        ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__criticality,
        ___RAB_SetupOrModifyItemFirst_iE_Extensions__item__extensionValue,
        __RAB_SetupOrModifyItemFirst_iE_Extensions__item_,
        _RAB_SetupOrModifyItemFirst_iE_Extensions,
        RAB_SetupOrModifyItemFirst,
        _TransportLayerInformation_transportLayerAddress,
        _TransportLayerInformation_iuTransportAssociation,
        ____TransportLayerInformation_iE_Extensions__item__id_tab,
        ___TransportLayerInformation_iE_Extensions__item__id,
        ____TransportLayerInformation_iE_Extensions__item__criticality_tab,
        ___TransportLayerInformation_iE_Extensions__item__criticality,
        ____TransportLayerInformation_iE_Extensions__item__extensionValue_tab,
        ___TransportLayerInformation_iE_Extensions__item__extensionValue,
        __TransportLayerInformation_iE_Extensions__item_,
        _TransportLayerInformation_iE_Extensions,
        TransportLayerInformation,
        TransportLayerInformation_ExtIEs,
        RAB_SetupOrModifyItemFirst_ExtIEs,
        _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_0,
        _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_1,
        _RAB_SetupOrModifyItemFirst_ExtIEs_val_Extension_2,
        _RAB_SetupOrModifyItemSecond_pDP_TypeInformation,
        _RAB_SetupOrModifyItemSecond_dataVolumeReportingIndication,
        _RAB_SetupOrModifyItemSecond_dl_GTP_PDU_SequenceNumber,
        _RAB_SetupOrModifyItemSecond_ul_GTP_PDU_SequenceNumber,
        _RAB_SetupOrModifyItemSecond_dl_N_PDU_SequenceNumber,
        _RAB_SetupOrModifyItemSecond_ul_N_PDU_SequenceNumber,
        ____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab,
        _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_1,
        _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_2,
        _____RAB_SetupOrModifyItemSecond_iE_Extensions__item__id_tab_val_Extension_3,
        ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__id,
        ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__criticality,
        ___RAB_SetupOrModifyItemSecond_iE_Extensions__item__extensionValue,
        __RAB_SetupOrModifyItemSecond_iE_Extensions__item_,
        _RAB_SetupOrModifyItemSecond_iE_Extensions,
        RAB_SetupOrModifyItemSecond,
        RAB_SetupOrModifyItemSecond_ExtIEs,
        _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_0,
        _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_1,
        _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_2,
        _RAB_SetupOrModifyItemSecond_ExtIEs_val_Extension_3,
        RAB_AssignmentRequestExtensions,
        _RAB_AssignmentRequestExtensions_val_Extension_0,
        _RAB_AssignmentRequestExtensions_val_Extension_1,
        ____RAB_AssignmentResponse_protocolIEs__item__id_tab,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_2,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_3,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_4,
        _____RAB_AssignmentResponse_protocolIEs__item__id_tab_val_Value_5,
        ___RAB_AssignmentResponse_protocolIEs__item__id,
        ___RAB_AssignmentResponse_protocolIEs__item__criticality,
        ___RAB_AssignmentResponse_protocolIEs__item__value,
        __RAB_AssignmentResponse_protocolIEs__item_,
        _RAB_AssignmentResponse_protocolIEs,
        ____RAB_AssignmentResponse_protocolExtensions__item__id_tab,
        _____RAB_AssignmentResponse_protocolExtensions__item__id_tab_val_Extension_0,
        ___RAB_AssignmentResponse_protocolExtensions__item__id,
        ___RAB_AssignmentResponse_protocolExtensions__item__criticality,
        ___RAB_AssignmentResponse_protocolExtensions__item__extensionValue,
        __RAB_AssignmentResponse_protocolExtensions__item_,
        _RAB_AssignmentResponse_protocolExtensions,
        RAB_AssignmentResponse,
        RAB_AssignmentResponseIEs,
        _RAB_AssignmentResponseIEs_val_Value_0,
        _RAB_AssignmentResponseIEs_val_Value_1,
        _RAB_AssignmentResponseIEs_val_Value_2,
        _RAB_AssignmentResponseIEs_val_Value_3,
        _RAB_AssignmentResponseIEs_val_Value_4,
        _RAB_AssignmentResponseIEs_val_Value_5,
        ____RAB_SetupOrModifiedList__item___item__id_tab,
        _____RAB_SetupOrModifiedList__item___item__id_tab_val_Value_0,
        ___RAB_SetupOrModifiedList__item___item__id,
        ___RAB_SetupOrModifiedList__item___item__criticality,
        ___RAB_SetupOrModifiedList__item___item__value,
        __RAB_SetupOrModifiedList__item___item_,
        _RAB_SetupOrModifiedList__item_,
        RAB_SetupOrModifiedList,
        RAB_SetupOrModifiedItemIEs,
        _RAB_SetupOrModifiedItemIEs_val_Value_0,
        _RAB_SetupOrModifiedItem_rAB_ID,
        _RAB_SetupOrModifiedItem_transportLayerAddress,
        _RAB_SetupOrModifiedItem_iuTransportAssociation,
        _RAB_SetupOrModifiedItem_dl_dataVolumes,
        ____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab,
        _____RAB_SetupOrModifiedItem_iE_Extensions__item__id_tab_val_Extension_0,
        ___RAB_SetupOrModifiedItem_iE_Extensions__item__id,
        ___RAB_SetupOrModifiedItem_iE_Extensions__item__criticality,
        ___RAB_SetupOrModifiedItem_iE_Extensions__item__extensionValue,
        __RAB_SetupOrModifiedItem_iE_Extensions__item_,
        _RAB_SetupOrModifiedItem_iE_Extensions,
        RAB_SetupOrModifiedItem,
        RAB_SetupOrModifiedItem_ExtIEs,
        _RAB_SetupOrModifiedItem_ExtIEs_val_Extension_0,
        ____RAB_ReleasedList__item___item__id_tab,
        _____RAB_ReleasedList__item___item__id_tab_val_Value_0,
        ___RAB_ReleasedList__item___item__id,
        ___RAB_ReleasedList__item___item__criticality,
        ___RAB_ReleasedList__item___item__value,
        __RAB_ReleasedList__item___item_,
        _RAB_ReleasedList__item_,
        RAB_ReleasedList,
        RAB_ReleasedItemIEs,
        _RAB_ReleasedItemIEs_val_Value_0,
        _RAB_ReleasedItem_rAB_ID,
        _RAB_ReleasedItem_dl_dataVolumes,
        _RAB_ReleasedItem_dL_GTP_PDU_SequenceNumber,
        _RAB_ReleasedItem_uL_GTP_PDU_SequenceNumber,
        ____RAB_ReleasedItem_iE_Extensions__item__id_tab,
        ___RAB_ReleasedItem_iE_Extensions__item__id,
        ____RAB_ReleasedItem_iE_Extensions__item__criticality_tab,
        ___RAB_ReleasedItem_iE_Extensions__item__criticality,
        ____RAB_ReleasedItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_ReleasedItem_iE_Extensions__item__extensionValue,
        __RAB_ReleasedItem_iE_Extensions__item_,
        _RAB_ReleasedItem_iE_Extensions,
        RAB_ReleasedItem,
        RAB_ReleasedItem_ExtIEs,
        __DataVolumeList__item__dl_UnsuccessfullyTransmittedDataVolume,
        __DataVolumeList__item__dataVolumeReference,
        _____DataVolumeList__item__iE_Extensions__item__id_tab,
        ____DataVolumeList__item__iE_Extensions__item__id,
        _____DataVolumeList__item__iE_Extensions__item__criticality_tab,
        ____DataVolumeList__item__iE_Extensions__item__criticality,
        _____DataVolumeList__item__iE_Extensions__item__extensionValue_tab,
        ____DataVolumeList__item__iE_Extensions__item__extensionValue,
        ___DataVolumeList__item__iE_Extensions__item_,
        __DataVolumeList__item__iE_Extensions,
        _DataVolumeList__item_,
        DataVolumeList,
        DataVolumeList_ExtIEs,
        ____RAB_QueuedList__item___item__id_tab,
        _____RAB_QueuedList__item___item__id_tab_val_Value_0,
        ___RAB_QueuedList__item___item__id,
        ___RAB_QueuedList__item___item__criticality,
        ___RAB_QueuedList__item___item__value,
        __RAB_QueuedList__item___item_,
        _RAB_QueuedList__item_,
        RAB_QueuedList,
        RAB_QueuedItemIEs,
        _RAB_QueuedItemIEs_val_Value_0,
        _RAB_QueuedItem_rAB_ID,
        ____RAB_QueuedItem_iE_Extensions__item__id_tab,
        ___RAB_QueuedItem_iE_Extensions__item__id,
        ____RAB_QueuedItem_iE_Extensions__item__criticality_tab,
        ___RAB_QueuedItem_iE_Extensions__item__criticality,
        ____RAB_QueuedItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_QueuedItem_iE_Extensions__item__extensionValue,
        __RAB_QueuedItem_iE_Extensions__item_,
        _RAB_QueuedItem_iE_Extensions,
        RAB_QueuedItem,
        RAB_QueuedItem_ExtIEs,
        RAB_ReleaseFailedList,
        RAB_AssignmentResponseExtensions,
        _RAB_AssignmentResponseExtensions_val_Extension_0,
        ____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab,
        _____GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id_tab_val_Value_0,
        ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__id,
        ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__criticality,
        ___GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item__value,
        __GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item___item_,
        _GERAN_Iumode_RAB_FailedList_RABAssgntResponse__item_,
        GERAN_Iumode_RAB_FailedList_RABAssgntResponse,
        GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs,
        _GERAN_Iumode_RAB_Failed_RABAssgntResponse_ItemIEs_val_Value_0,
        _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_rAB_ID,
        _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_cause,
        _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_gERAN_Classmark,
        ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id_tab,
        ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__id,
        ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality_tab,
        ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__criticality,
        ____GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue_tab,
        ___GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item__extensionValue,
        __GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions__item_,
        _GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_iE_Extensions,
        GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item,
        GERAN_Iumode_RAB_Failed_RABAssgntResponse_Item_ExtIEs,
        ____PrivateMessage_privateIEs__item__id_tab,
        ___PrivateMessage_privateIEs__item__id,
        ____PrivateMessage_privateIEs__item__criticality_tab,
        ___PrivateMessage_privateIEs__item__criticality,
        ____PrivateMessage_privateIEs__item__value_tab,
        ___PrivateMessage_privateIEs__item__value,
        __PrivateMessage_privateIEs__item_,
        _PrivateMessage_privateIEs,
        PrivateMessage,
        PrivateMessage_IEs,
        ____RANAP_RelocationInformation_protocolIEs__item__id_tab,
        _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_0,
        _____RANAP_RelocationInformation_protocolIEs__item__id_tab_val_Value_1,
        ___RANAP_RelocationInformation_protocolIEs__item__id,
        ___RANAP_RelocationInformation_protocolIEs__item__criticality,
        ___RANAP_RelocationInformation_protocolIEs__item__value,
        __RANAP_RelocationInformation_protocolIEs__item_,
        _RANAP_RelocationInformation_protocolIEs,
        ____RANAP_RelocationInformation_protocolExtensions__item__id_tab,
        _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_0,
        _____RANAP_RelocationInformation_protocolExtensions__item__id_tab_val_Extension_1,
        ___RANAP_RelocationInformation_protocolExtensions__item__id,
        ___RANAP_RelocationInformation_protocolExtensions__item__criticality,
        ___RANAP_RelocationInformation_protocolExtensions__item__extensionValue,
        __RANAP_RelocationInformation_protocolExtensions__item_,
        _RANAP_RelocationInformation_protocolExtensions,
        RANAP_RelocationInformation,
        RANAP_RelocationInformationIEs,
        _RANAP_RelocationInformationIEs_val_Value_0,
        _RANAP_RelocationInformationIEs_val_Value_1,
        ____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab,
        _____DirectTransferInformationList_RANAP_RelocInf__item___item__id_tab_val_Value_0,
        ___DirectTransferInformationList_RANAP_RelocInf__item___item__id,
        ___DirectTransferInformationList_RANAP_RelocInf__item___item__criticality,
        ___DirectTransferInformationList_RANAP_RelocInf__item___item__value,
        __DirectTransferInformationList_RANAP_RelocInf__item___item_,
        _DirectTransferInformationList_RANAP_RelocInf__item_,
        DirectTransferInformationList_RANAP_RelocInf,
        DirectTransferInformationItemIEs_RANAP_RelocInf,
        _DirectTransferInformationItemIEs_RANAP_RelocInf_val_Value_0,
        _DirectTransferInformationItem_RANAP_RelocInf_nAS_PDU,
        _DirectTransferInformationItem_RANAP_RelocInf_sAPI,
        _DirectTransferInformationItem_RANAP_RelocInf_cN_DomainIndicator,
        ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id_tab,
        ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__id,
        ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab,
        ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__criticality,
        ____DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab,
        ___DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item__extensionValue,
        __DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions__item_,
        _DirectTransferInformationItem_RANAP_RelocInf_iE_Extensions,
        DirectTransferInformationItem_RANAP_RelocInf,
        RANAP_DirectTransferInformationItem_ExtIEs_RANAP_RelocInf,
        ____RAB_ContextList_RANAP_RelocInf__item___item__id_tab,
        _____RAB_ContextList_RANAP_RelocInf__item___item__id_tab_val_Value_0,
        ___RAB_ContextList_RANAP_RelocInf__item___item__id,
        ___RAB_ContextList_RANAP_RelocInf__item___item__criticality,
        ___RAB_ContextList_RANAP_RelocInf__item___item__value,
        __RAB_ContextList_RANAP_RelocInf__item___item_,
        _RAB_ContextList_RANAP_RelocInf__item_,
        RAB_ContextList_RANAP_RelocInf,
        RAB_ContextItemIEs_RANAP_RelocInf,
        _RAB_ContextItemIEs_RANAP_RelocInf_val_Value_0,
        _RAB_ContextItem_RANAP_RelocInf_rAB_ID,
        _RAB_ContextItem_RANAP_RelocInf_dl_GTP_PDU_SequenceNumber,
        _RAB_ContextItem_RANAP_RelocInf_ul_GTP_PDU_SequenceNumber,
        _RAB_ContextItem_RANAP_RelocInf_dl_N_PDU_SequenceNumber,
        _RAB_ContextItem_RANAP_RelocInf_ul_N_PDU_SequenceNumber,
        ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id_tab,
        ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__id,
        ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality_tab,
        ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__criticality,
        ____RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue_tab,
        ___RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item__extensionValue,
        __RAB_ContextItem_RANAP_RelocInf_iE_Extensions__item_,
        _RAB_ContextItem_RANAP_RelocInf_iE_Extensions,
        RAB_ContextItem_RANAP_RelocInf,
        RAB_ContextItem_ExtIEs_RANAP_RelocInf,
        RANAP_RelocationInformationExtensions,
        _RANAP_RelocationInformationExtensions_val_Extension_0,
        _RANAP_RelocationInformationExtensions_val_Extension_1,
        ____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_4,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_5,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_6,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_7,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_8,
        _____RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id_tab_val_Value_9,
        ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__id,
        ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__criticality,
        ___RANAP_EnhancedRelocationInformationRequest_protocolIEs__item__value,
        __RANAP_EnhancedRelocationInformationRequest_protocolIEs__item_,
        _RANAP_EnhancedRelocationInformationRequest_protocolIEs,
        ____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_1,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_2,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_3,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_4,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_5,
        _____RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id_tab_val_Extension_6,
        ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__id,
        ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__criticality,
        ___RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item__extensionValue,
        __RANAP_EnhancedRelocationInformationRequest_protocolExtensions__item_,
        _RANAP_EnhancedRelocationInformationRequest_protocolExtensions,
        RANAP_EnhancedRelocationInformationRequest,
        RANAP_EnhancedRelocationInformationRequestIEs,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_0,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_1,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_2,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_3,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_4,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_5,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_6,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_7,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_8,
        _RANAP_EnhancedRelocationInformationRequestIEs_val_Value_9,
        ____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab,
        _____RAB_SetupList_EnhRelocInfoReq__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_EnhRelocInfoReq__item___item__id,
        ___RAB_SetupList_EnhRelocInfoReq__item___item__criticality,
        ___RAB_SetupList_EnhRelocInfoReq__item___item__value,
        __RAB_SetupList_EnhRelocInfoReq__item___item_,
        _RAB_SetupList_EnhRelocInfoReq__item_,
        RAB_SetupList_EnhRelocInfoReq,
        RAB_SetupItem_EnhRelocInfoReq_IEs,
        _RAB_SetupItem_EnhRelocInfoReq_IEs_val_Value_0,
        _RAB_SetupItem_EnhRelocInfoReq_rAB_ID,
        _RAB_SetupItem_EnhRelocInfoReq_cN_DomainIndicator,
        _RAB_SetupItem_EnhRelocInfoReq_rAB_Parameters,
        _RAB_SetupItem_EnhRelocInfoReq_dataVolumeReportingIndication,
        _RAB_SetupItem_EnhRelocInfoReq_pDP_TypeInformation,
        _RAB_SetupItem_EnhRelocInfoReq_userPlaneInformation,
        _RAB_SetupItem_EnhRelocInfoReq_dataForwardingInformation,
        _RAB_SetupItem_EnhRelocInfoReq_sourceSideIuULTNLInfo,
        _RAB_SetupItem_EnhRelocInfoReq_service_Handover,
        _RAB_SetupItem_EnhRelocInfoReq_alt_RAB_Parameters,
        ____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab,
        _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_0,
        _____RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id_tab_val_Extension_1,
        ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__id,
        ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__criticality,
        ___RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_EnhRelocInfoReq_iE_Extensions__item_,
        _RAB_SetupItem_EnhRelocInfoReq_iE_Extensions,
        RAB_SetupItem_EnhRelocInfoReq,
        RAB_SetupItem_EnhRelocInfoReq_ExtIEs,
        _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_0,
        _RAB_SetupItem_EnhRelocInfoReq_ExtIEs_val_Extension_1,
        _TNLInformationEnhRelInfoReq_transportLayerAddress,
        _TNLInformationEnhRelInfoReq_iuTransportAssociation,
        ____TNLInformationEnhRelInfoReq_iE_Extensions__item__id_tab,
        ___TNLInformationEnhRelInfoReq_iE_Extensions__item__id,
        ____TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality_tab,
        ___TNLInformationEnhRelInfoReq_iE_Extensions__item__criticality,
        ____TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue_tab,
        ___TNLInformationEnhRelInfoReq_iE_Extensions__item__extensionValue,
        __TNLInformationEnhRelInfoReq_iE_Extensions__item_,
        _TNLInformationEnhRelInfoReq_iE_Extensions,
        TNLInformationEnhRelInfoReq,
        TNLInformationEnhRelInfoReq_ExtIEs,
        RANAP_EnhancedRelocationInformationRequestExtensions,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_0,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_1,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_2,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_3,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_4,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_5,
        _RANAP_EnhancedRelocationInformationRequestExtensions_val_Extension_6,
        ____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab,
        _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__id,
        ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__criticality,
        ___RANAP_EnhancedRelocationInformationResponse_protocolIEs__item__value,
        __RANAP_EnhancedRelocationInformationResponse_protocolIEs__item_,
        _RANAP_EnhancedRelocationInformationResponse_protocolIEs,
        ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id_tab,
        ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__id,
        ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality_tab,
        ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__criticality,
        ____RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue_tab,
        ___RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item__extensionValue,
        __RANAP_EnhancedRelocationInformationResponse_protocolExtensions__item_,
        _RANAP_EnhancedRelocationInformationResponse_protocolExtensions,
        RANAP_EnhancedRelocationInformationResponse,
        RANAP_EnhancedRelocationInformationResponseIEs,
        _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_0,
        _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_1,
        _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_2,
        _RANAP_EnhancedRelocationInformationResponseIEs_val_Value_3,
        ____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab,
        _____RAB_SetupList_EnhRelocInfoRes__item___item__id_tab_val_Value_0,
        ___RAB_SetupList_EnhRelocInfoRes__item___item__id,
        ___RAB_SetupList_EnhRelocInfoRes__item___item__criticality,
        ___RAB_SetupList_EnhRelocInfoRes__item___item__value,
        __RAB_SetupList_EnhRelocInfoRes__item___item_,
        _RAB_SetupList_EnhRelocInfoRes__item_,
        RAB_SetupList_EnhRelocInfoRes,
        RAB_SetupItem_EnhRelocInfoRes_IEs,
        _RAB_SetupItem_EnhRelocInfoRes_IEs_val_Value_0,
        _RAB_SetupItem_EnhRelocInfoRes_cN_DomainIndicator,
        _RAB_SetupItem_EnhRelocInfoRes_rAB_ID,
        _RAB_SetupItem_EnhRelocInfoRes_dataForwardingInformation,
        _RAB_SetupItem_EnhRelocInfoRes_ass_RAB_Parameters,
        ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id_tab,
        ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__id,
        ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab,
        ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__criticality,
        ____RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab,
        ___RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue,
        __RAB_SetupItem_EnhRelocInfoRes_iE_Extensions__item_,
        _RAB_SetupItem_EnhRelocInfoRes_iE_Extensions,
        RAB_SetupItem_EnhRelocInfoRes,
        RAB_SetupItem_EnhRelocInfoRes_ExtIEs,
        ____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab,
        _____RAB_FailedList_EnhRelocInfoRes__item___item__id_tab_val_Value_0,
        ___RAB_FailedList_EnhRelocInfoRes__item___item__id,
        ___RAB_FailedList_EnhRelocInfoRes__item___item__criticality,
        ___RAB_FailedList_EnhRelocInfoRes__item___item__value,
        __RAB_FailedList_EnhRelocInfoRes__item___item_,
        _RAB_FailedList_EnhRelocInfoRes__item_,
        RAB_FailedList_EnhRelocInfoRes,
        RAB_FailedItem_EnhRelocInfoRes_IEs,
        _RAB_FailedItem_EnhRelocInfoRes_IEs_val_Value_0,
        _RAB_FailedItem_EnhRelocInfoRes_cN_DomainIndicator,
        _RAB_FailedItem_EnhRelocInfoRes_rAB_ID,
        _RAB_FailedItem_EnhRelocInfoRes_cause,
        ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id_tab,
        ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__id,
        ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality_tab,
        ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__criticality,
        ____RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue_tab,
        ___RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item__extensionValue,
        __RAB_FailedItem_EnhRelocInfoRes_iE_Extensions__item_,
        _RAB_FailedItem_EnhRelocInfoRes_iE_Extensions,
        RAB_FailedItem_EnhRelocInfoRes,
        RAB_FailedItem_EnhRelocInfoRes_ExtIEs,
        _TNLInformationEnhRelInfoRes_dl_forwardingTransportLayerAddress,
        _TNLInformationEnhRelInfoRes_dl_forwardingTransportAssociation,
        ____TNLInformationEnhRelInfoRes_iE_Extensions__item__id_tab,
        ___TNLInformationEnhRelInfoRes_iE_Extensions__item__id,
        ____TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality_tab,
        ___TNLInformationEnhRelInfoRes_iE_Extensions__item__criticality,
        ____TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue_tab,
        ___TNLInformationEnhRelInfoRes_iE_Extensions__item__extensionValue,
        __TNLInformationEnhRelInfoRes_iE_Extensions__item_,
        _TNLInformationEnhRelInfoRes_iE_Extensions,
        TNLInformationEnhRelInfoRes,
        TNLInformationEnhRelInfoRes_ExtIEs,
        RANAP_EnhancedRelocationInformationResponseExtensions,
        ____RAB_ModifyRequest_protocolIEs__item__id_tab,
        _____RAB_ModifyRequest_protocolIEs__item__id_tab_val_Value_0,
        ___RAB_ModifyRequest_protocolIEs__item__id,
        ___RAB_ModifyRequest_protocolIEs__item__criticality,
        ___RAB_ModifyRequest_protocolIEs__item__value,
        __RAB_ModifyRequest_protocolIEs__item_,
        _RAB_ModifyRequest_protocolIEs,
        ____RAB_ModifyRequest_protocolExtensions__item__id_tab,
        ___RAB_ModifyRequest_protocolExtensions__item__id,
        ____RAB_ModifyRequest_protocolExtensions__item__criticality_tab,
        ___RAB_ModifyRequest_protocolExtensions__item__criticality,
        ____RAB_ModifyRequest_protocolExtensions__item__extensionValue_tab,
        ___RAB_ModifyRequest_protocolExtensions__item__extensionValue,
        __RAB_ModifyRequest_protocolExtensions__item_,
        _RAB_ModifyRequest_protocolExtensions,
        RAB_ModifyRequest,
        RAB_ModifyRequestIEs,
        _RAB_ModifyRequestIEs_val_Value_0,
        ____RAB_ModifyList__item___item__id_tab,
        _____RAB_ModifyList__item___item__id_tab_val_Value_0,
        ___RAB_ModifyList__item___item__id,
        ___RAB_ModifyList__item___item__criticality,
        ___RAB_ModifyList__item___item__value,
        __RAB_ModifyList__item___item_,
        _RAB_ModifyList__item_,
        RAB_ModifyList,
        RAB_ModifyItemIEs,
        _RAB_ModifyItemIEs_val_Value_0,
        _RAB_ModifyItem_rAB_ID,
        _RAB_ModifyItem_requested_RAB_Parameter_Values,
        ____RAB_ModifyItem_iE_Extensions__item__id_tab,
        ___RAB_ModifyItem_iE_Extensions__item__id,
        ____RAB_ModifyItem_iE_Extensions__item__criticality_tab,
        ___RAB_ModifyItem_iE_Extensions__item__criticality,
        ____RAB_ModifyItem_iE_Extensions__item__extensionValue_tab,
        ___RAB_ModifyItem_iE_Extensions__item__extensionValue,
        __RAB_ModifyItem_iE_Extensions__item_,
        _RAB_ModifyItem_iE_Extensions,
        RAB_ModifyItem,
        RAB_ModifyItem_ExtIEs,
        RAB_ModifyRequestExtensions,
        ____LocationRelatedDataRequest_protocolIEs__item__id_tab,
        _____LocationRelatedDataRequest_protocolIEs__item__id_tab_val_Value_0,
        ___LocationRelatedDataRequest_protocolIEs__item__id,
        ___LocationRelatedDataRequest_protocolIEs__item__criticality,
        ___LocationRelatedDataRequest_protocolIEs__item__value,
        __LocationRelatedDataRequest_protocolIEs__item_,
        _LocationRelatedDataRequest_protocolIEs,
        ____LocationRelatedDataRequest_protocolExtensions__item__id_tab,
        _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_0,
        _____LocationRelatedDataRequest_protocolExtensions__item__id_tab_val_Extension_1,
        ___LocationRelatedDataRequest_protocolExtensions__item__id,
        ___LocationRelatedDataRequest_protocolExtensions__item__criticality,
        ___LocationRelatedDataRequest_protocolExtensions__item__extensionValue,
        __LocationRelatedDataRequest_protocolExtensions__item_,
        _LocationRelatedDataRequest_protocolExtensions,
        LocationRelatedDataRequest,
        LocationRelatedDataRequestIEs,
        _LocationRelatedDataRequestIEs_val_Value_0,
        LocationRelatedDataRequestExtensions,
        _LocationRelatedDataRequestExtensions_val_Extension_0,
        _LocationRelatedDataRequestExtensions_val_Extension_1,
        ____LocationRelatedDataResponse_protocolIEs__item__id_tab,
        _____LocationRelatedDataResponse_protocolIEs__item__id_tab_val_Value_0,
        ___LocationRelatedDataResponse_protocolIEs__item__id,
        ___LocationRelatedDataResponse_protocolIEs__item__criticality,
        ___LocationRelatedDataResponse_protocolIEs__item__value,
        __LocationRelatedDataResponse_protocolIEs__item_,
        _LocationRelatedDataResponse_protocolIEs,
        ____LocationRelatedDataResponse_protocolExtensions__item__id_tab,
        _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_0,
        _____LocationRelatedDataResponse_protocolExtensions__item__id_tab_val_Extension_1,
        ___LocationRelatedDataResponse_protocolExtensions__item__id,
        ___LocationRelatedDataResponse_protocolExtensions__item__criticality,
        ___LocationRelatedDataResponse_protocolExtensions__item__extensionValue,
        __LocationRelatedDataResponse_protocolExtensions__item_,
        _LocationRelatedDataResponse_protocolExtensions,
        LocationRelatedDataResponse,
        LocationRelatedDataResponseIEs,
        _LocationRelatedDataResponseIEs_val_Value_0,
        LocationRelatedDataResponseExtensions,
        _LocationRelatedDataResponseExtensions_val_Extension_0,
        _LocationRelatedDataResponseExtensions_val_Extension_1,
        ____LocationRelatedDataFailure_protocolIEs__item__id_tab,
        _____LocationRelatedDataFailure_protocolIEs__item__id_tab_val_Value_0,
        ___LocationRelatedDataFailure_protocolIEs__item__id,
        ___LocationRelatedDataFailure_protocolIEs__item__criticality,
        ___LocationRelatedDataFailure_protocolIEs__item__value,
        __LocationRelatedDataFailure_protocolIEs__item_,
        _LocationRelatedDataFailure_protocolIEs,
        ____LocationRelatedDataFailure_protocolExtensions__item__id_tab,
        _____LocationRelatedDataFailure_protocolExtensions__item__id_tab_val_Extension_0,
        ___LocationRelatedDataFailure_protocolExtensions__item__id,
        ___LocationRelatedDataFailure_protocolExtensions__item__criticality,
        ___LocationRelatedDataFailure_protocolExtensions__item__extensionValue,
        __LocationRelatedDataFailure_protocolExtensions__item_,
        _LocationRelatedDataFailure_protocolExtensions,
        LocationRelatedDataFailure,
        LocationRelatedDataFailureIEs,
        _LocationRelatedDataFailureIEs_val_Value_0,
        LocationRelatedDataFailureExtensions,
        _LocationRelatedDataFailureExtensions_val_Extension_0,
        ____InformationTransferIndication_protocolIEs__item__id_tab,
        _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_0,
        _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_1,
        _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_2,
        _____InformationTransferIndication_protocolIEs__item__id_tab_val_Value_3,
        ___InformationTransferIndication_protocolIEs__item__id,
        ___InformationTransferIndication_protocolIEs__item__criticality,
        ___InformationTransferIndication_protocolIEs__item__value,
        __InformationTransferIndication_protocolIEs__item_,
        _InformationTransferIndication_protocolIEs,
        ____InformationTransferIndication_protocolExtensions__item__id_tab,
        ___InformationTransferIndication_protocolExtensions__item__id,
        ____InformationTransferIndication_protocolExtensions__item__criticality_tab,
        ___InformationTransferIndication_protocolExtensions__item__criticality,
        ____InformationTransferIndication_protocolExtensions__item__extensionValue_tab,
        ___InformationTransferIndication_protocolExtensions__item__extensionValue,
        __InformationTransferIndication_protocolExtensions__item_,
        _InformationTransferIndication_protocolExtensions,
        InformationTransferIndication,
        InformationTransferIndicationIEs,
        _InformationTransferIndicationIEs_val_Value_0,
        _InformationTransferIndicationIEs_val_Value_1,
        _InformationTransferIndicationIEs_val_Value_2,
        _InformationTransferIndicationIEs_val_Value_3,
        InformationTransferIndicationExtensions,
        ____InformationTransferConfirmation_protocolIEs__item__id_tab,
        _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_0,
        _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_1,
        _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_2,
        _____InformationTransferConfirmation_protocolIEs__item__id_tab_val_Value_3,
        ___InformationTransferConfirmation_protocolIEs__item__id,
        ___InformationTransferConfirmation_protocolIEs__item__criticality,
        ___InformationTransferConfirmation_protocolIEs__item__value,
        __InformationTransferConfirmation_protocolIEs__item_,
        _InformationTransferConfirmation_protocolIEs,
        ____InformationTransferConfirmation_protocolExtensions__item__id_tab,
        _____InformationTransferConfirmation_protocolExtensions__item__id_tab_val_Extension_0,
        ___InformationTransferConfirmation_protocolExtensions__item__id,
        ___InformationTransferConfirmation_protocolExtensions__item__criticality,
        ___InformationTransferConfirmation_protocolExtensions__item__extensionValue,
        __InformationTransferConfirmation_protocolExtensions__item_,
        _InformationTransferConfirmation_protocolExtensions,
        InformationTransferConfirmation,
        InformationTransferConfirmationIEs,
        _InformationTransferConfirmationIEs_val_Value_0,
        _InformationTransferConfirmationIEs_val_Value_1,
        _InformationTransferConfirmationIEs_val_Value_2,
        _InformationTransferConfirmationIEs_val_Value_3,
        InformationTransferConfirmationExtensions,
        _InformationTransferConfirmationExtensions_val_Extension_0,
        ____InformationTransferFailure_protocolIEs__item__id_tab,
        _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_0,
        _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_1,
        _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_2,
        _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_3,
        _____InformationTransferFailure_protocolIEs__item__id_tab_val_Value_4,
        ___InformationTransferFailure_protocolIEs__item__id,
        ___InformationTransferFailure_protocolIEs__item__criticality,
        ___InformationTransferFailure_protocolIEs__item__value,
        __InformationTransferFailure_protocolIEs__item_,
        _InformationTransferFailure_protocolIEs,
        ____InformationTransferFailure_protocolExtensions__item__id_tab,
        _____InformationTransferFailure_protocolExtensions__item__id_tab_val_Extension_0,
        ___InformationTransferFailure_protocolExtensions__item__id,
        ___InformationTransferFailure_protocolExtensions__item__criticality,
        ___InformationTransferFailure_protocolExtensions__item__extensionValue,
        __InformationTransferFailure_protocolExtensions__item_,
        _InformationTransferFailure_protocolExtensions,
        InformationTransferFailure,
        InformationTransferFailureIEs,
        _InformationTransferFailureIEs_val_Value_0,
        _InformationTransferFailureIEs_val_Value_1,
        _InformationTransferFailureIEs_val_Value_2,
        _InformationTransferFailureIEs_val_Value_3,
        _InformationTransferFailureIEs_val_Value_4,
        InformationTransferFailureExtensions,
        _InformationTransferFailureExtensions_val_Extension_0,
        ____UESpecificInformationIndication_protocolIEs__item__id_tab,
        _____UESpecificInformationIndication_protocolIEs__item__id_tab_val_Value_0,
        ___UESpecificInformationIndication_protocolIEs__item__id,
        ___UESpecificInformationIndication_protocolIEs__item__criticality,
        ___UESpecificInformationIndication_protocolIEs__item__value,
        __UESpecificInformationIndication_protocolIEs__item_,
        _UESpecificInformationIndication_protocolIEs,
        ____UESpecificInformationIndication_protocolExtensions__item__id_tab,
        ___UESpecificInformationIndication_protocolExtensions__item__id,
        ____UESpecificInformationIndication_protocolExtensions__item__criticality_tab,
        ___UESpecificInformationIndication_protocolExtensions__item__criticality,
        ____UESpecificInformationIndication_protocolExtensions__item__extensionValue_tab,
        ___UESpecificInformationIndication_protocolExtensions__item__extensionValue,
        __UESpecificInformationIndication_protocolExtensions__item_,
        _UESpecificInformationIndication_protocolExtensions,
        UESpecificInformationIndication,
        UESpecificInformationIndicationIEs,
        _UESpecificInformationIndicationIEs_val_Value_0,
        UESpecificInformationIndicationExtensions,
        ____DirectInformationTransfer_protocolIEs__item__id_tab,
        _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_0,
        _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_1,
        _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_2,
        _____DirectInformationTransfer_protocolIEs__item__id_tab_val_Value_3,
        ___DirectInformationTransfer_protocolIEs__item__id,
        ___DirectInformationTransfer_protocolIEs__item__criticality,
        ___DirectInformationTransfer_protocolIEs__item__value,
        __DirectInformationTransfer_protocolIEs__item_,
        _DirectInformationTransfer_protocolIEs,
        ____DirectInformationTransfer_protocolExtensions__item__id_tab,
        _____DirectInformationTransfer_protocolExtensions__item__id_tab_val_Extension_0,
        ___DirectInformationTransfer_protocolExtensions__item__id,
        ___DirectInformationTransfer_protocolExtensions__item__criticality,
        ___DirectInformationTransfer_protocolExtensions__item__extensionValue,
        __DirectInformationTransfer_protocolExtensions__item_,
        _DirectInformationTransfer_protocolExtensions,
        DirectInformationTransfer,
        DirectInformationTransferIEs,
        _DirectInformationTransferIEs_val_Value_0,
        _DirectInformationTransferIEs_val_Value_1,
        _DirectInformationTransferIEs_val_Value_2,
        _DirectInformationTransferIEs_val_Value_3,
        DirectInformationTransferExtensions,
        _DirectInformationTransferExtensions_val_Extension_0,
        ____UplinkInformationExchangeRequest_protocolIEs__item__id_tab,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_4,
        _____UplinkInformationExchangeRequest_protocolIEs__item__id_tab_val_Value_5,
        ___UplinkInformationExchangeRequest_protocolIEs__item__id,
        ___UplinkInformationExchangeRequest_protocolIEs__item__criticality,
        ___UplinkInformationExchangeRequest_protocolIEs__item__value,
        __UplinkInformationExchangeRequest_protocolIEs__item_,
        _UplinkInformationExchangeRequest_protocolIEs,
        ____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab,
        _____UplinkInformationExchangeRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___UplinkInformationExchangeRequest_protocolExtensions__item__id,
        ___UplinkInformationExchangeRequest_protocolExtensions__item__criticality,
        ___UplinkInformationExchangeRequest_protocolExtensions__item__extensionValue,
        __UplinkInformationExchangeRequest_protocolExtensions__item_,
        _UplinkInformationExchangeRequest_protocolExtensions,
        UplinkInformationExchangeRequest,
        UplinkInformationExchangeRequestIEs,
        _UplinkInformationExchangeRequestIEs_val_Value_0,
        _UplinkInformationExchangeRequestIEs_val_Value_1,
        _UplinkInformationExchangeRequestIEs_val_Value_2,
        _UplinkInformationExchangeRequestIEs_val_Value_3,
        _UplinkInformationExchangeRequestIEs_val_Value_4,
        _UplinkInformationExchangeRequestIEs_val_Value_5,
        UplinkInformationExchangeRequestExtensions,
        _UplinkInformationExchangeRequestExtensions_val_Extension_0,
        ____UplinkInformationExchangeResponse_protocolIEs__item__id_tab,
        _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkInformationExchangeResponse_protocolIEs__item__id_tab_val_Value_4,
        ___UplinkInformationExchangeResponse_protocolIEs__item__id,
        ___UplinkInformationExchangeResponse_protocolIEs__item__criticality,
        ___UplinkInformationExchangeResponse_protocolIEs__item__value,
        __UplinkInformationExchangeResponse_protocolIEs__item_,
        _UplinkInformationExchangeResponse_protocolIEs,
        ____UplinkInformationExchangeResponse_protocolExtensions__item__id_tab,
        ___UplinkInformationExchangeResponse_protocolExtensions__item__id,
        ____UplinkInformationExchangeResponse_protocolExtensions__item__criticality_tab,
        ___UplinkInformationExchangeResponse_protocolExtensions__item__criticality,
        ____UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue_tab,
        ___UplinkInformationExchangeResponse_protocolExtensions__item__extensionValue,
        __UplinkInformationExchangeResponse_protocolExtensions__item_,
        _UplinkInformationExchangeResponse_protocolExtensions,
        UplinkInformationExchangeResponse,
        UplinkInformationExchangeResponseIEs,
        _UplinkInformationExchangeResponseIEs_val_Value_0,
        _UplinkInformationExchangeResponseIEs_val_Value_1,
        _UplinkInformationExchangeResponseIEs_val_Value_2,
        _UplinkInformationExchangeResponseIEs_val_Value_3,
        _UplinkInformationExchangeResponseIEs_val_Value_4,
        UplinkInformationExchangeResponseExtensions,
        ____UplinkInformationExchangeFailure_protocolIEs__item__id_tab,
        _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_0,
        _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_1,
        _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_2,
        _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_3,
        _____UplinkInformationExchangeFailure_protocolIEs__item__id_tab_val_Value_4,
        ___UplinkInformationExchangeFailure_protocolIEs__item__id,
        ___UplinkInformationExchangeFailure_protocolIEs__item__criticality,
        ___UplinkInformationExchangeFailure_protocolIEs__item__value,
        __UplinkInformationExchangeFailure_protocolIEs__item_,
        _UplinkInformationExchangeFailure_protocolIEs,
        ____UplinkInformationExchangeFailure_protocolExtensions__item__id_tab,
        ___UplinkInformationExchangeFailure_protocolExtensions__item__id,
        ____UplinkInformationExchangeFailure_protocolExtensions__item__criticality_tab,
        ___UplinkInformationExchangeFailure_protocolExtensions__item__criticality,
        ____UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue_tab,
        ___UplinkInformationExchangeFailure_protocolExtensions__item__extensionValue,
        __UplinkInformationExchangeFailure_protocolExtensions__item_,
        _UplinkInformationExchangeFailure_protocolExtensions,
        UplinkInformationExchangeFailure,
        UplinkInformationExchangeFailureIEs,
        _UplinkInformationExchangeFailureIEs_val_Value_0,
        _UplinkInformationExchangeFailureIEs_val_Value_1,
        _UplinkInformationExchangeFailureIEs_val_Value_2,
        _UplinkInformationExchangeFailureIEs_val_Value_3,
        _UplinkInformationExchangeFailureIEs_val_Value_4,
        UplinkInformationExchangeFailureExtensions,
        ____MBMSSessionStart_protocolIEs__item__id_tab,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_3,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_4,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_5,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_6,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_7,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_8,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_9,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_10,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_11,
        _____MBMSSessionStart_protocolIEs__item__id_tab_val_Value_12,
        ___MBMSSessionStart_protocolIEs__item__id,
        ___MBMSSessionStart_protocolIEs__item__criticality,
        ___MBMSSessionStart_protocolIEs__item__value,
        __MBMSSessionStart_protocolIEs__item_,
        _MBMSSessionStart_protocolIEs,
        ____MBMSSessionStart_protocolExtensions__item__id_tab,
        _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_0,
        _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_1,
        _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_2,
        _____MBMSSessionStart_protocolExtensions__item__id_tab_val_Extension_3,
        ___MBMSSessionStart_protocolExtensions__item__id,
        ___MBMSSessionStart_protocolExtensions__item__criticality,
        ___MBMSSessionStart_protocolExtensions__item__extensionValue,
        __MBMSSessionStart_protocolExtensions__item_,
        _MBMSSessionStart_protocolExtensions,
        MBMSSessionStart,
        MBMSSessionStartIEs,
        _MBMSSessionStartIEs_val_Value_0,
        _MBMSSessionStartIEs_val_Value_1,
        _MBMSSessionStartIEs_val_Value_2,
        _MBMSSessionStartIEs_val_Value_3,
        _MBMSSessionStartIEs_val_Value_4,
        _MBMSSessionStartIEs_val_Value_5,
        _MBMSSessionStartIEs_val_Value_6,
        _MBMSSessionStartIEs_val_Value_7,
        _MBMSSessionStartIEs_val_Value_8,
        _MBMSSessionStartIEs_val_Value_9,
        _MBMSSessionStartIEs_val_Value_10,
        _MBMSSessionStartIEs_val_Value_11,
        _MBMSSessionStartIEs_val_Value_12,
        MBMSSessionStartExtensions,
        _MBMSSessionStartExtensions_val_Extension_0,
        _MBMSSessionStartExtensions_val_Extension_1,
        _MBMSSessionStartExtensions_val_Extension_2,
        _MBMSSessionStartExtensions_val_Extension_3,
        _MBMSSynchronisationInformation_mBMSHCIndicator,
        _MBMSSynchronisationInformation_iPMulticastAddress,
        _MBMSSynchronisationInformation_gTPDLTEID,
        ____MBMSSynchronisationInformation_iE_Extensions__item__id_tab,
        _____MBMSSynchronisationInformation_iE_Extensions__item__id_tab_val_Extension_0,
        ___MBMSSynchronisationInformation_iE_Extensions__item__id,
        ___MBMSSynchronisationInformation_iE_Extensions__item__criticality,
        ___MBMSSynchronisationInformation_iE_Extensions__item__extensionValue,
        __MBMSSynchronisationInformation_iE_Extensions__item_,
        _MBMSSynchronisationInformation_iE_Extensions,
        MBMSSynchronisationInformation,
        MBMSSynchronisationInformation_ExtIEs,
        _MBMSSynchronisationInformation_ExtIEs_val_Extension_0,
        ____MBMSSessionStartResponse_protocolIEs__item__id_tab,
        _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSSessionStartResponse_protocolIEs__item__id_tab_val_Value_2,
        ___MBMSSessionStartResponse_protocolIEs__item__id,
        ___MBMSSessionStartResponse_protocolIEs__item__criticality,
        ___MBMSSessionStartResponse_protocolIEs__item__value,
        __MBMSSessionStartResponse_protocolIEs__item_,
        _MBMSSessionStartResponse_protocolIEs,
        ____MBMSSessionStartResponse_protocolExtensions__item__id_tab,
        ___MBMSSessionStartResponse_protocolExtensions__item__id,
        ____MBMSSessionStartResponse_protocolExtensions__item__criticality_tab,
        ___MBMSSessionStartResponse_protocolExtensions__item__criticality,
        ____MBMSSessionStartResponse_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionStartResponse_protocolExtensions__item__extensionValue,
        __MBMSSessionStartResponse_protocolExtensions__item_,
        _MBMSSessionStartResponse_protocolExtensions,
        MBMSSessionStartResponse,
        MBMSSessionStartResponseIEs,
        _MBMSSessionStartResponseIEs_val_Value_0,
        _MBMSSessionStartResponseIEs_val_Value_1,
        _MBMSSessionStartResponseIEs_val_Value_2,
        MBMSSessionStartResponseExtensions,
        ____MBMSSessionStartFailure_protocolIEs__item__id_tab,
        _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionStartFailure_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSSessionStartFailure_protocolIEs__item__id,
        ___MBMSSessionStartFailure_protocolIEs__item__criticality,
        ___MBMSSessionStartFailure_protocolIEs__item__value,
        __MBMSSessionStartFailure_protocolIEs__item_,
        _MBMSSessionStartFailure_protocolIEs,
        ____MBMSSessionStartFailure_protocolExtensions__item__id_tab,
        ___MBMSSessionStartFailure_protocolExtensions__item__id,
        ____MBMSSessionStartFailure_protocolExtensions__item__criticality_tab,
        ___MBMSSessionStartFailure_protocolExtensions__item__criticality,
        ____MBMSSessionStartFailure_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionStartFailure_protocolExtensions__item__extensionValue,
        __MBMSSessionStartFailure_protocolExtensions__item_,
        _MBMSSessionStartFailure_protocolExtensions,
        MBMSSessionStartFailure,
        MBMSSessionStartFailureIEs,
        _MBMSSessionStartFailureIEs_val_Value_0,
        _MBMSSessionStartFailureIEs_val_Value_1,
        MBMSSessionStartFailureExtensions,
        ____MBMSSessionUpdate_protocolIEs__item__id_tab,
        _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionUpdate_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSSessionUpdate_protocolIEs__item__id,
        ___MBMSSessionUpdate_protocolIEs__item__criticality,
        ___MBMSSessionUpdate_protocolIEs__item__value,
        __MBMSSessionUpdate_protocolIEs__item_,
        _MBMSSessionUpdate_protocolIEs,
        ____MBMSSessionUpdate_protocolExtensions__item__id_tab,
        ___MBMSSessionUpdate_protocolExtensions__item__id,
        ____MBMSSessionUpdate_protocolExtensions__item__criticality_tab,
        ___MBMSSessionUpdate_protocolExtensions__item__criticality,
        ____MBMSSessionUpdate_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionUpdate_protocolExtensions__item__extensionValue,
        __MBMSSessionUpdate_protocolExtensions__item_,
        _MBMSSessionUpdate_protocolExtensions,
        MBMSSessionUpdate,
        MBMSSessionUpdateIEs,
        _MBMSSessionUpdateIEs_val_Value_0,
        _MBMSSessionUpdateIEs_val_Value_1,
        MBMSSessionUpdateExtensions,
        ____MBMSSessionUpdateResponse_protocolIEs__item__id_tab,
        _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSSessionUpdateResponse_protocolIEs__item__id_tab_val_Value_3,
        ___MBMSSessionUpdateResponse_protocolIEs__item__id,
        ___MBMSSessionUpdateResponse_protocolIEs__item__criticality,
        ___MBMSSessionUpdateResponse_protocolIEs__item__value,
        __MBMSSessionUpdateResponse_protocolIEs__item_,
        _MBMSSessionUpdateResponse_protocolIEs,
        ____MBMSSessionUpdateResponse_protocolExtensions__item__id_tab,
        ___MBMSSessionUpdateResponse_protocolExtensions__item__id,
        ____MBMSSessionUpdateResponse_protocolExtensions__item__criticality_tab,
        ___MBMSSessionUpdateResponse_protocolExtensions__item__criticality,
        ____MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionUpdateResponse_protocolExtensions__item__extensionValue,
        __MBMSSessionUpdateResponse_protocolExtensions__item_,
        _MBMSSessionUpdateResponse_protocolExtensions,
        MBMSSessionUpdateResponse,
        MBMSSessionUpdateResponseIEs,
        _MBMSSessionUpdateResponseIEs_val_Value_0,
        _MBMSSessionUpdateResponseIEs_val_Value_1,
        _MBMSSessionUpdateResponseIEs_val_Value_2,
        _MBMSSessionUpdateResponseIEs_val_Value_3,
        MBMSSessionUpdateResponseExtensions,
        ____MBMSSessionUpdateFailure_protocolIEs__item__id_tab,
        _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSSessionUpdateFailure_protocolIEs__item__id_tab_val_Value_2,
        ___MBMSSessionUpdateFailure_protocolIEs__item__id,
        ___MBMSSessionUpdateFailure_protocolIEs__item__criticality,
        ___MBMSSessionUpdateFailure_protocolIEs__item__value,
        __MBMSSessionUpdateFailure_protocolIEs__item_,
        _MBMSSessionUpdateFailure_protocolIEs,
        ____MBMSSessionUpdateFailure_protocolExtensions__item__id_tab,
        ___MBMSSessionUpdateFailure_protocolExtensions__item__id,
        ____MBMSSessionUpdateFailure_protocolExtensions__item__criticality_tab,
        ___MBMSSessionUpdateFailure_protocolExtensions__item__criticality,
        ____MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionUpdateFailure_protocolExtensions__item__extensionValue,
        __MBMSSessionUpdateFailure_protocolExtensions__item_,
        _MBMSSessionUpdateFailure_protocolExtensions,
        MBMSSessionUpdateFailure,
        MBMSSessionUpdateFailureIEs,
        _MBMSSessionUpdateFailureIEs_val_Value_0,
        _MBMSSessionUpdateFailureIEs_val_Value_1,
        _MBMSSessionUpdateFailureIEs_val_Value_2,
        MBMSSessionUpdateFailureExtensions,
        ____MBMSSessionStop_protocolIEs__item__id_tab,
        _____MBMSSessionStop_protocolIEs__item__id_tab_val_Value_0,
        ___MBMSSessionStop_protocolIEs__item__id,
        ___MBMSSessionStop_protocolIEs__item__criticality,
        ___MBMSSessionStop_protocolIEs__item__value,
        __MBMSSessionStop_protocolIEs__item_,
        _MBMSSessionStop_protocolIEs,
        ____MBMSSessionStop_protocolExtensions__item__id_tab,
        ___MBMSSessionStop_protocolExtensions__item__id,
        ____MBMSSessionStop_protocolExtensions__item__criticality_tab,
        ___MBMSSessionStop_protocolExtensions__item__criticality,
        ____MBMSSessionStop_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionStop_protocolExtensions__item__extensionValue,
        __MBMSSessionStop_protocolExtensions__item_,
        _MBMSSessionStop_protocolExtensions,
        MBMSSessionStop,
        MBMSSessionStopIEs,
        _MBMSSessionStopIEs_val_Value_0,
        MBMSSessionStopExtensions,
        ____MBMSSessionStopResponse_protocolIEs__item__id_tab,
        _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSSessionStopResponse_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSSessionStopResponse_protocolIEs__item__id,
        ___MBMSSessionStopResponse_protocolIEs__item__criticality,
        ___MBMSSessionStopResponse_protocolIEs__item__value,
        __MBMSSessionStopResponse_protocolIEs__item_,
        _MBMSSessionStopResponse_protocolIEs,
        ____MBMSSessionStopResponse_protocolExtensions__item__id_tab,
        ___MBMSSessionStopResponse_protocolExtensions__item__id,
        ____MBMSSessionStopResponse_protocolExtensions__item__criticality_tab,
        ___MBMSSessionStopResponse_protocolExtensions__item__criticality,
        ____MBMSSessionStopResponse_protocolExtensions__item__extensionValue_tab,
        ___MBMSSessionStopResponse_protocolExtensions__item__extensionValue,
        __MBMSSessionStopResponse_protocolExtensions__item_,
        _MBMSSessionStopResponse_protocolExtensions,
        MBMSSessionStopResponse,
        MBMSSessionStopResponseIEs,
        _MBMSSessionStopResponseIEs_val_Value_0,
        _MBMSSessionStopResponseIEs_val_Value_1,
        MBMSSessionStopResponseExtensions,
        ____MBMSUELinkingRequest_protocolIEs__item__id_tab,
        _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSUELinkingRequest_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSUELinkingRequest_protocolIEs__item__id,
        ___MBMSUELinkingRequest_protocolIEs__item__criticality,
        ___MBMSUELinkingRequest_protocolIEs__item__value,
        __MBMSUELinkingRequest_protocolIEs__item_,
        _MBMSUELinkingRequest_protocolIEs,
        ____MBMSUELinkingRequest_protocolExtensions__item__id_tab,
        ___MBMSUELinkingRequest_protocolExtensions__item__id,
        ____MBMSUELinkingRequest_protocolExtensions__item__criticality_tab,
        ___MBMSUELinkingRequest_protocolExtensions__item__criticality,
        ____MBMSUELinkingRequest_protocolExtensions__item__extensionValue_tab,
        ___MBMSUELinkingRequest_protocolExtensions__item__extensionValue,
        __MBMSUELinkingRequest_protocolExtensions__item_,
        _MBMSUELinkingRequest_protocolExtensions,
        MBMSUELinkingRequest,
        MBMSUELinkingRequestIEs,
        _MBMSUELinkingRequestIEs_val_Value_0,
        _MBMSUELinkingRequestIEs_val_Value_1,
        __LeftMBMSBearerService_IEs__item__tMGI,
        _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id_tab,
        ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__id,
        _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality_tab,
        ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__criticality,
        _____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue_tab,
        ____LeftMBMSBearerService_IEs__item__iE_Extensions__item__extensionValue,
        ___LeftMBMSBearerService_IEs__item__iE_Extensions__item_,
        __LeftMBMSBearerService_IEs__item__iE_Extensions,
        _LeftMBMSBearerService_IEs__item_,
        LeftMBMSBearerService_IEs,
        LeftMBMSBearerService_ExtIEs,
        MBMSUELinkingRequestExtensions,
        ____MBMSUELinkingResponse_protocolIEs__item__id_tab,
        _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSUELinkingResponse_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSUELinkingResponse_protocolIEs__item__id,
        ___MBMSUELinkingResponse_protocolIEs__item__criticality,
        ___MBMSUELinkingResponse_protocolIEs__item__value,
        __MBMSUELinkingResponse_protocolIEs__item_,
        _MBMSUELinkingResponse_protocolIEs,
        ____MBMSUELinkingResponse_protocolExtensions__item__id_tab,
        ___MBMSUELinkingResponse_protocolExtensions__item__id,
        ____MBMSUELinkingResponse_protocolExtensions__item__criticality_tab,
        ___MBMSUELinkingResponse_protocolExtensions__item__criticality,
        ____MBMSUELinkingResponse_protocolExtensions__item__extensionValue_tab,
        ___MBMSUELinkingResponse_protocolExtensions__item__extensionValue,
        __MBMSUELinkingResponse_protocolExtensions__item_,
        _MBMSUELinkingResponse_protocolExtensions,
        MBMSUELinkingResponse,
        MBMSUELinkingResponseIEs,
        _MBMSUELinkingResponseIEs_val_Value_0,
        _MBMSUELinkingResponseIEs_val_Value_1,
        __UnsuccessfulLinking_IEs__item__tMGI,
        __UnsuccessfulLinking_IEs__item__cause,
        _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id_tab,
        ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__id,
        _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality_tab,
        ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__criticality,
        _____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue_tab,
        ____UnsuccessfulLinking_IEs__item__iE_Extensions__item__extensionValue,
        ___UnsuccessfulLinking_IEs__item__iE_Extensions__item_,
        __UnsuccessfulLinking_IEs__item__iE_Extensions,
        _UnsuccessfulLinking_IEs__item_,
        UnsuccessfulLinking_IEs,
        UnsuccessfulLinking_ExtIEs,
        MBMSUELinkingResponseExtensions,
        ____MBMSRegistrationRequest_protocolIEs__item__id_tab,
        _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_3,
        _____MBMSRegistrationRequest_protocolIEs__item__id_tab_val_Value_4,
        ___MBMSRegistrationRequest_protocolIEs__item__id,
        ___MBMSRegistrationRequest_protocolIEs__item__criticality,
        ___MBMSRegistrationRequest_protocolIEs__item__value,
        __MBMSRegistrationRequest_protocolIEs__item_,
        _MBMSRegistrationRequest_protocolIEs,
        ____MBMSRegistrationRequest_protocolExtensions__item__id_tab,
        _____MBMSRegistrationRequest_protocolExtensions__item__id_tab_val_Extension_0,
        ___MBMSRegistrationRequest_protocolExtensions__item__id,
        ___MBMSRegistrationRequest_protocolExtensions__item__criticality,
        ___MBMSRegistrationRequest_protocolExtensions__item__extensionValue,
        __MBMSRegistrationRequest_protocolExtensions__item_,
        _MBMSRegistrationRequest_protocolExtensions,
        MBMSRegistrationRequest,
        MBMSRegistrationRequestIEs,
        _MBMSRegistrationRequestIEs_val_Value_0,
        _MBMSRegistrationRequestIEs_val_Value_1,
        _MBMSRegistrationRequestIEs_val_Value_2,
        _MBMSRegistrationRequestIEs_val_Value_3,
        _MBMSRegistrationRequestIEs_val_Value_4,
        MBMSRegistrationRequestExtensions,
        _MBMSRegistrationRequestExtensions_val_Extension_0,
        ____MBMSRegistrationResponse_protocolIEs__item__id_tab,
        _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSRegistrationResponse_protocolIEs__item__id_tab_val_Value_2,
        ___MBMSRegistrationResponse_protocolIEs__item__id,
        ___MBMSRegistrationResponse_protocolIEs__item__criticality,
        ___MBMSRegistrationResponse_protocolIEs__item__value,
        __MBMSRegistrationResponse_protocolIEs__item_,
        _MBMSRegistrationResponse_protocolIEs,
        ____MBMSRegistrationResponse_protocolExtensions__item__id_tab,
        ___MBMSRegistrationResponse_protocolExtensions__item__id,
        ____MBMSRegistrationResponse_protocolExtensions__item__criticality_tab,
        ___MBMSRegistrationResponse_protocolExtensions__item__criticality,
        ____MBMSRegistrationResponse_protocolExtensions__item__extensionValue_tab,
        ___MBMSRegistrationResponse_protocolExtensions__item__extensionValue,
        __MBMSRegistrationResponse_protocolExtensions__item_,
        _MBMSRegistrationResponse_protocolExtensions,
        MBMSRegistrationResponse,
        MBMSRegistrationResponseIEs,
        _MBMSRegistrationResponseIEs_val_Value_0,
        _MBMSRegistrationResponseIEs_val_Value_1,
        _MBMSRegistrationResponseIEs_val_Value_2,
        MBMSRegistrationResponseExtensions,
        ____MBMSRegistrationFailure_protocolIEs__item__id_tab,
        _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSRegistrationFailure_protocolIEs__item__id_tab_val_Value_3,
        ___MBMSRegistrationFailure_protocolIEs__item__id,
        ___MBMSRegistrationFailure_protocolIEs__item__criticality,
        ___MBMSRegistrationFailure_protocolIEs__item__value,
        __MBMSRegistrationFailure_protocolIEs__item_,
        _MBMSRegistrationFailure_protocolIEs,
        ____MBMSRegistrationFailure_protocolExtensions__item__id_tab,
        ___MBMSRegistrationFailure_protocolExtensions__item__id,
        ____MBMSRegistrationFailure_protocolExtensions__item__criticality_tab,
        ___MBMSRegistrationFailure_protocolExtensions__item__criticality,
        ____MBMSRegistrationFailure_protocolExtensions__item__extensionValue_tab,
        ___MBMSRegistrationFailure_protocolExtensions__item__extensionValue,
        __MBMSRegistrationFailure_protocolExtensions__item_,
        _MBMSRegistrationFailure_protocolExtensions,
        MBMSRegistrationFailure,
        MBMSRegistrationFailureIEs,
        _MBMSRegistrationFailureIEs_val_Value_0,
        _MBMSRegistrationFailureIEs_val_Value_1,
        _MBMSRegistrationFailureIEs_val_Value_2,
        _MBMSRegistrationFailureIEs_val_Value_3,
        MBMSRegistrationFailureExtensions,
        ____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab,
        _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSCNDe_RegistrationRequest_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSCNDe_RegistrationRequest_protocolIEs__item__id,
        ___MBMSCNDe_RegistrationRequest_protocolIEs__item__criticality,
        ___MBMSCNDe_RegistrationRequest_protocolIEs__item__value,
        __MBMSCNDe_RegistrationRequest_protocolIEs__item_,
        _MBMSCNDe_RegistrationRequest_protocolIEs,
        ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__id_tab,
        ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__id,
        ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality_tab,
        ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__criticality,
        ____MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue_tab,
        ___MBMSCNDe_RegistrationRequest_protocolExtensions__item__extensionValue,
        __MBMSCNDe_RegistrationRequest_protocolExtensions__item_,
        _MBMSCNDe_RegistrationRequest_protocolExtensions,
        MBMSCNDe_RegistrationRequest,
        MBMSCNDe_RegistrationRequestIEs,
        _MBMSCNDe_RegistrationRequestIEs_val_Value_0,
        _MBMSCNDe_RegistrationRequestIEs_val_Value_1,
        MBMSCNDe_RegistrationRequestExtensions,
        ____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab,
        _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_1,
        _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_2,
        _____MBMSCNDe_RegistrationResponse_protocolIEs__item__id_tab_val_Value_3,
        ___MBMSCNDe_RegistrationResponse_protocolIEs__item__id,
        ___MBMSCNDe_RegistrationResponse_protocolIEs__item__criticality,
        ___MBMSCNDe_RegistrationResponse_protocolIEs__item__value,
        __MBMSCNDe_RegistrationResponse_protocolIEs__item_,
        _MBMSCNDe_RegistrationResponse_protocolIEs,
        ____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab,
        _____MBMSCNDe_RegistrationResponse_protocolExtensions__item__id_tab_val_Extension_0,
        ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__id,
        ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__criticality,
        ___MBMSCNDe_RegistrationResponse_protocolExtensions__item__extensionValue,
        __MBMSCNDe_RegistrationResponse_protocolExtensions__item_,
        _MBMSCNDe_RegistrationResponse_protocolExtensions,
        MBMSCNDe_RegistrationResponse,
        MBMSCNDe_RegistrationResponseIEs,
        _MBMSCNDe_RegistrationResponseIEs_val_Value_0,
        _MBMSCNDe_RegistrationResponseIEs_val_Value_1,
        _MBMSCNDe_RegistrationResponseIEs_val_Value_2,
        _MBMSCNDe_RegistrationResponseIEs_val_Value_3,
        MBMSCNDe_RegistrationResponseExtensions,
        _MBMSCNDe_RegistrationResponseExtensions_val_Extension_0,
        ____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab,
        _____MBMSRABEstablishmentIndication_protocolIEs__item__id_tab_val_Value_0,
        ___MBMSRABEstablishmentIndication_protocolIEs__item__id,
        ___MBMSRABEstablishmentIndication_protocolIEs__item__criticality,
        ___MBMSRABEstablishmentIndication_protocolIEs__item__value,
        __MBMSRABEstablishmentIndication_protocolIEs__item_,
        _MBMSRABEstablishmentIndication_protocolIEs,
        ____MBMSRABEstablishmentIndication_protocolExtensions__item__id_tab,
        ___MBMSRABEstablishmentIndication_protocolExtensions__item__id,
        ____MBMSRABEstablishmentIndication_protocolExtensions__item__criticality_tab,
        ___MBMSRABEstablishmentIndication_protocolExtensions__item__criticality,
        ____MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue_tab,
        ___MBMSRABEstablishmentIndication_protocolExtensions__item__extensionValue,
        __MBMSRABEstablishmentIndication_protocolExtensions__item_,
        _MBMSRABEstablishmentIndication_protocolExtensions,
        MBMSRABEstablishmentIndication,
        MBMSRABEstablishmentIndicationIEs,
        _MBMSRABEstablishmentIndicationIEs_val_Value_0,
        MBMSRABEstablishmentIndicationExtensions,
        ____MBMSRABReleaseRequest_protocolIEs__item__id_tab,
        _____MBMSRABReleaseRequest_protocolIEs__item__id_tab_val_Value_0,
        ___MBMSRABReleaseRequest_protocolIEs__item__id,
        ___MBMSRABReleaseRequest_protocolIEs__item__criticality,
        ___MBMSRABReleaseRequest_protocolIEs__item__value,
        __MBMSRABReleaseRequest_protocolIEs__item_,
        _MBMSRABReleaseRequest_protocolIEs,
        ____MBMSRABReleaseRequest_protocolExtensions__item__id_tab,
        ___MBMSRABReleaseRequest_protocolExtensions__item__id,
        ____MBMSRABReleaseRequest_protocolExtensions__item__criticality_tab,
        ___MBMSRABReleaseRequest_protocolExtensions__item__criticality,
        ____MBMSRABReleaseRequest_protocolExtensions__item__extensionValue_tab,
        ___MBMSRABReleaseRequest_protocolExtensions__item__extensionValue,
        __MBMSRABReleaseRequest_protocolExtensions__item_,
        _MBMSRABReleaseRequest_protocolExtensions,
        MBMSRABReleaseRequest,
        MBMSRABReleaseRequestIEs,
        _MBMSRABReleaseRequestIEs_val_Value_0,
        MBMSRABReleaseRequestExtensions,
        ____MBMSRABRelease_protocolIEs__item__id_tab,
        _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSRABRelease_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSRABRelease_protocolIEs__item__id,
        ___MBMSRABRelease_protocolIEs__item__criticality,
        ___MBMSRABRelease_protocolIEs__item__value,
        __MBMSRABRelease_protocolIEs__item_,
        _MBMSRABRelease_protocolIEs,
        ____MBMSRABRelease_protocolExtensions__item__id_tab,
        ___MBMSRABRelease_protocolExtensions__item__id,
        ____MBMSRABRelease_protocolExtensions__item__criticality_tab,
        ___MBMSRABRelease_protocolExtensions__item__criticality,
        ____MBMSRABRelease_protocolExtensions__item__extensionValue_tab,
        ___MBMSRABRelease_protocolExtensions__item__extensionValue,
        __MBMSRABRelease_protocolExtensions__item_,
        _MBMSRABRelease_protocolExtensions,
        MBMSRABRelease,
        MBMSRABReleaseIEs,
        _MBMSRABReleaseIEs_val_Value_0,
        _MBMSRABReleaseIEs_val_Value_1,
        MBMSRABReleaseExtensions,
        ____MBMSRABReleaseFailure_protocolIEs__item__id_tab,
        _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_0,
        _____MBMSRABReleaseFailure_protocolIEs__item__id_tab_val_Value_1,
        ___MBMSRABReleaseFailure_protocolIEs__item__id,
        ___MBMSRABReleaseFailure_protocolIEs__item__criticality,
        ___MBMSRABReleaseFailure_protocolIEs__item__value,
        __MBMSRABReleaseFailure_protocolIEs__item_,
        _MBMSRABReleaseFailure_protocolIEs,
        ____MBMSRABReleaseFailure_protocolExtensions__item__id_tab,
        ___MBMSRABReleaseFailure_protocolExtensions__item__id,
        ____MBMSRABReleaseFailure_protocolExtensions__item__criticality_tab,
        ___MBMSRABReleaseFailure_protocolExtensions__item__criticality,
        ____MBMSRABReleaseFailure_protocolExtensions__item__extensionValue_tab,
        ___MBMSRABReleaseFailure_protocolExtensions__item__extensionValue,
        __MBMSRABReleaseFailure_protocolExtensions__item_,
        _MBMSRABReleaseFailure_protocolExtensions,
        MBMSRABReleaseFailure,
        MBMSRABReleaseFailureIEs,
        _MBMSRABReleaseFailureIEs_val_Value_0,
        _MBMSRABReleaseFailureIEs_val_Value_1,
        MBMSRABReleaseFailureExtensions,
        ____SRVCC_CSKeysRequest_protocolIEs__item__id_tab,
        ___SRVCC_CSKeysRequest_protocolIEs__item__id,
        ____SRVCC_CSKeysRequest_protocolIEs__item__criticality_tab,
        ___SRVCC_CSKeysRequest_protocolIEs__item__criticality,
        ____SRVCC_CSKeysRequest_protocolIEs__item__value_tab,
        ___SRVCC_CSKeysRequest_protocolIEs__item__value,
        __SRVCC_CSKeysRequest_protocolIEs__item_,
        _SRVCC_CSKeysRequest_protocolIEs,
        ____SRVCC_CSKeysRequest_protocolExtensions__item__id_tab,
        ___SRVCC_CSKeysRequest_protocolExtensions__item__id,
        ____SRVCC_CSKeysRequest_protocolExtensions__item__criticality_tab,
        ___SRVCC_CSKeysRequest_protocolExtensions__item__criticality,
        ____SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue_tab,
        ___SRVCC_CSKeysRequest_protocolExtensions__item__extensionValue,
        __SRVCC_CSKeysRequest_protocolExtensions__item_,
        _SRVCC_CSKeysRequest_protocolExtensions,
        SRVCC_CSKeysRequest,
        SRVCC_CSKeysRequestIEs,
        SRVCC_CSKeysRequestExtensions,
        ____SRVCC_CSKeysResponse_protocolIEs__item__id_tab,
        _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_0,
        _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_1,
        _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_2,
        _____SRVCC_CSKeysResponse_protocolIEs__item__id_tab_val_Value_3,
        ___SRVCC_CSKeysResponse_protocolIEs__item__id,
        ___SRVCC_CSKeysResponse_protocolIEs__item__criticality,
        ___SRVCC_CSKeysResponse_protocolIEs__item__value,
        __SRVCC_CSKeysResponse_protocolIEs__item_,
        _SRVCC_CSKeysResponse_protocolIEs,
        ____SRVCC_CSKeysResponse_protocolExtensions__item__id_tab,
        ___SRVCC_CSKeysResponse_protocolExtensions__item__id,
        ____SRVCC_CSKeysResponse_protocolExtensions__item__criticality_tab,
        ___SRVCC_CSKeysResponse_protocolExtensions__item__criticality,
        ____SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue_tab,
        ___SRVCC_CSKeysResponse_protocolExtensions__item__extensionValue,
        __SRVCC_CSKeysResponse_protocolExtensions__item_,
        _SRVCC_CSKeysResponse_protocolExtensions,
        SRVCC_CSKeysResponse,
        SRVCC_CSKeysResponseIEs,
        _SRVCC_CSKeysResponseIEs_val_Value_0,
        _SRVCC_CSKeysResponseIEs_val_Value_1,
        _SRVCC_CSKeysResponseIEs_val_Value_2,
        _SRVCC_CSKeysResponseIEs_val_Value_3,
        SRVCC_CSKeysResponseExtensions,
        ____UeRadioCapabilityMatchRequest_protocolIEs__item__id_tab,
        ___UeRadioCapabilityMatchRequest_protocolIEs__item__id,
        ____UeRadioCapabilityMatchRequest_protocolIEs__item__criticality_tab,
        ___UeRadioCapabilityMatchRequest_protocolIEs__item__criticality,
        ____UeRadioCapabilityMatchRequest_protocolIEs__item__value_tab,
        ___UeRadioCapabilityMatchRequest_protocolIEs__item__value,
        __UeRadioCapabilityMatchRequest_protocolIEs__item_,
        _UeRadioCapabilityMatchRequest_protocolIEs,
        ____UeRadioCapabilityMatchRequest_protocolExtensions__item__id_tab,
        ___UeRadioCapabilityMatchRequest_protocolExtensions__item__id,
        ____UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality_tab,
        ___UeRadioCapabilityMatchRequest_protocolExtensions__item__criticality,
        ____UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue_tab,
        ___UeRadioCapabilityMatchRequest_protocolExtensions__item__extensionValue,
        __UeRadioCapabilityMatchRequest_protocolExtensions__item_,
        _UeRadioCapabilityMatchRequest_protocolExtensions,
        UeRadioCapabilityMatchRequest,
        UeRadioCapabilityMatchRequestIEs,
        UeRadioCapabilityMatchRequestExtensions,
        ____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab,
        _____UeRadioCapabilityMatchResponse_protocolIEs__item__id_tab_val_Value_0,
        ___UeRadioCapabilityMatchResponse_protocolIEs__item__id,
        ___UeRadioCapabilityMatchResponse_protocolIEs__item__criticality,
        ___UeRadioCapabilityMatchResponse_protocolIEs__item__value,
        __UeRadioCapabilityMatchResponse_protocolIEs__item_,
        _UeRadioCapabilityMatchResponse_protocolIEs,
        ____UeRadioCapabilityMatchResponse_protocolExtensions__item__id_tab,
        ___UeRadioCapabilityMatchResponse_protocolExtensions__item__id,
        ____UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality_tab,
        ___UeRadioCapabilityMatchResponse_protocolExtensions__item__criticality,
        ____UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue_tab,
        ___UeRadioCapabilityMatchResponse_protocolExtensions__item__extensionValue,
        __UeRadioCapabilityMatchResponse_protocolExtensions__item_,
        _UeRadioCapabilityMatchResponse_protocolExtensions,
        UeRadioCapabilityMatchResponse,
        UeRadioCapabilityMatchResponseIEs,
        _UeRadioCapabilityMatchResponseIEs_val_Value_0,
        UeRadioCapabilityMatchResponseExtensions,
        ____UeRegistrationQueryRequest_protocolIEs__item__id_tab,
        _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_0,
        _____UeRegistrationQueryRequest_protocolIEs__item__id_tab_val_Value_1,
        ___UeRegistrationQueryRequest_protocolIEs__item__id,
        ___UeRegistrationQueryRequest_protocolIEs__item__criticality,
        ___UeRegistrationQueryRequest_protocolIEs__item__value,
        __UeRegistrationQueryRequest_protocolIEs__item_,
        _UeRegistrationQueryRequest_protocolIEs,
        ____UeRegistrationQueryRequest_protocolExtensions__item__id_tab,
        ___UeRegistrationQueryRequest_protocolExtensions__item__id,
        ____UeRegistrationQueryRequest_protocolExtensions__item__criticality_tab,
        ___UeRegistrationQueryRequest_protocolExtensions__item__criticality,
        ____UeRegistrationQueryRequest_protocolExtensions__item__extensionValue_tab,
        ___UeRegistrationQueryRequest_protocolExtensions__item__extensionValue,
        __UeRegistrationQueryRequest_protocolExtensions__item_,
        _UeRegistrationQueryRequest_protocolExtensions,
        UeRegistrationQueryRequest,
        UeRegistrationQueryRequestIEs,
        _UeRegistrationQueryRequestIEs_val_Value_0,
        _UeRegistrationQueryRequestIEs_val_Value_1,
        UeRegistrationQueryRequestExtensions,
        ____UeRegistrationQueryResponse_protocolIEs__item__id_tab,
        _____UeRegistrationQueryResponse_protocolIEs__item__id_tab_val_Value_0,
        ___UeRegistrationQueryResponse_protocolIEs__item__id,
        ___UeRegistrationQueryResponse_protocolIEs__item__criticality,
        ___UeRegistrationQueryResponse_protocolIEs__item__value,
        __UeRegistrationQueryResponse_protocolIEs__item_,
        _UeRegistrationQueryResponse_protocolIEs,
        ____UeRegistrationQueryResponse_protocolExtensions__item__id_tab,
        ___UeRegistrationQueryResponse_protocolExtensions__item__id,
        ____UeRegistrationQueryResponse_protocolExtensions__item__criticality_tab,
        ___UeRegistrationQueryResponse_protocolExtensions__item__criticality,
        ____UeRegistrationQueryResponse_protocolExtensions__item__extensionValue_tab,
        ___UeRegistrationQueryResponse_protocolExtensions__item__extensionValue,
        __UeRegistrationQueryResponse_protocolExtensions__item_,
        _UeRegistrationQueryResponse_protocolExtensions,
        UeRegistrationQueryResponse,
        UeRegistrationQueryResponseIEs,
        _UeRegistrationQueryResponseIEs_val_Value_0,
        UeRegistrationQueryResponseExtensions,
        ____RerouteNASRequest_protocolIEs__item__id_tab,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_0,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_1,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_2,
        _____RerouteNASRequest_protocolIEs__item__id_tab_val_Value_3,
        ___RerouteNASRequest_protocolIEs__item__id,
        ___RerouteNASRequest_protocolIEs__item__criticality,
        ___RerouteNASRequest_protocolIEs__item__value,
        __RerouteNASRequest_protocolIEs__item_,
        _RerouteNASRequest_protocolIEs,
        ____RerouteNASRequest_protocolExtensions__item__id_tab,
        ___RerouteNASRequest_protocolExtensions__item__id,
        ____RerouteNASRequest_protocolExtensions__item__criticality_tab,
        ___RerouteNASRequest_protocolExtensions__item__criticality,
        ____RerouteNASRequest_protocolExtensions__item__extensionValue_tab,
        ___RerouteNASRequest_protocolExtensions__item__extensionValue,
        __RerouteNASRequest_protocolExtensions__item_,
        _RerouteNASRequest_protocolExtensions,
        RerouteNASRequest,
        RerouteNASRequestIEs,
        _RerouteNASRequestIEs_val_Value_0,
        _RerouteNASRequestIEs_val_Value_1,
        _RerouteNASRequestIEs_val_Value_2,
        _RerouteNASRequestIEs_val_Value_3,
        RerouteNASRequestExtensions,
    ]

class RANAP_PDU_Descriptions:

    _name_  = 'RANAP-PDU-Descriptions'
    _oid_   = [0, 4, 0, 0, 20, 3, 0, 1, 0]
    
    _obj_ = [
        'RANAP-ELEMENTARY-PROCEDURE',
        'RANAP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'Outcome',
        'RANAP-ELEMENTARY-PROCEDURES',
        'RANAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'RANAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'RANAP-ELEMENTARY-PROCEDURES-CLASS-3',
        'iu-Release',
        'relocationPreparation',
        'relocationResourceAllocation',
        'relocationCancel',
        'sRNS-ContextTransfer',
        'securityModeControl',
        'dataVolumeReport',
        'reset',
        'rAB-ReleaseRequest',
        'iu-ReleaseRequest',
        'relocationDetect',
        'relocationComplete',
        'paging',
        'commonID',
        'cN-InvokeTrace',
        'cN-DeactivateTrace',
        'locationReportingControl',
        'locationReport',
        'initialUE-Message',
        'directTransfer',
        'overloadControl',
        'errorIndication',
        'sRNS-DataForward',
        'forwardSRNS-Context',
        'rAB-Assignment',
        'privateMessage',
        'resetResource',
        'rANAP-Relocation',
        'rAB-ModifyRequest',
        'locationRelatedData',
        'informationTransfer',
        'uESpecificInformation',
        'directInformationTransfer',
        'uplinkInformationExchange',
        'mBMSSessionStart',
        'mBMSSessionUpdate',
        'mBMSSessionStop',
        'mBMSUELinking',
        'mBMSRegistration',
        'mBMSCNDe-Registration',
        'mBMSRABEstablishmentIndication',
        'mBMSRABRelease',
        'enhancedRelocationComplete',
        'enhancedRelocationCompleteConfirm',
        'rANAP-enhancedRelocation',
        'sRVCCPreparation',
        'ueRadioCapabilityMatch',
        'ueRegistrationQuery',
        'rerouteNASRequest',
        ]
    _type_ = [
        'RANAP-ELEMENTARY-PROCEDURE',
        'RANAP-PDU',
        'InitiatingMessage',
        'SuccessfulOutcome',
        'UnsuccessfulOutcome',
        'Outcome',
        ]
    _set_ = [
        'RANAP-ELEMENTARY-PROCEDURES',
        'RANAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'RANAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'RANAP-ELEMENTARY-PROCEDURES-CLASS-3',
        ]
    _val_ = [
        'iu-Release',
        'relocationPreparation',
        'relocationResourceAllocation',
        'relocationCancel',
        'sRNS-ContextTransfer',
        'securityModeControl',
        'dataVolumeReport',
        'reset',
        'rAB-ReleaseRequest',
        'iu-ReleaseRequest',
        'relocationDetect',
        'relocationComplete',
        'paging',
        'commonID',
        'cN-InvokeTrace',
        'cN-DeactivateTrace',
        'locationReportingControl',
        'locationReport',
        'initialUE-Message',
        'directTransfer',
        'overloadControl',
        'errorIndication',
        'sRNS-DataForward',
        'forwardSRNS-Context',
        'rAB-Assignment',
        'privateMessage',
        'resetResource',
        'rANAP-Relocation',
        'rAB-ModifyRequest',
        'locationRelatedData',
        'informationTransfer',
        'uESpecificInformation',
        'directInformationTransfer',
        'uplinkInformationExchange',
        'mBMSSessionStart',
        'mBMSSessionUpdate',
        'mBMSSessionStop',
        'mBMSUELinking',
        'mBMSRegistration',
        'mBMSCNDe-Registration',
        'mBMSRABEstablishmentIndication',
        'mBMSRABRelease',
        'enhancedRelocationComplete',
        'enhancedRelocationCompleteConfirm',
        'rANAP-enhancedRelocation',
        'sRVCCPreparation',
        'ueRadioCapabilityMatch',
        'ueRegistrationQuery',
        'rerouteNASRequest',
        ]
    _class_ = [
        'RANAP-ELEMENTARY-PROCEDURE',
        'RANAP-ELEMENTARY-PROCEDURES',
        'RANAP-ELEMENTARY-PROCEDURES-CLASS-1',
        'RANAP-ELEMENTARY-PROCEDURES-CLASS-2',
        'RANAP-ELEMENTARY-PROCEDURES-CLASS-3',
        'iu-Release',
        'relocationPreparation',
        'relocationResourceAllocation',
        'relocationCancel',
        'sRNS-ContextTransfer',
        'securityModeControl',
        'dataVolumeReport',
        'reset',
        'rAB-ReleaseRequest',
        'iu-ReleaseRequest',
        'relocationDetect',
        'relocationComplete',
        'paging',
        'commonID',
        'cN-InvokeTrace',
        'cN-DeactivateTrace',
        'locationReportingControl',
        'locationReport',
        'initialUE-Message',
        'directTransfer',
        'overloadControl',
        'errorIndication',
        'sRNS-DataForward',
        'forwardSRNS-Context',
        'rAB-Assignment',
        'privateMessage',
        'resetResource',
        'rANAP-Relocation',
        'rAB-ModifyRequest',
        'locationRelatedData',
        'informationTransfer',
        'uESpecificInformation',
        'directInformationTransfer',
        'uplinkInformationExchange',
        'mBMSSessionStart',
        'mBMSSessionUpdate',
        'mBMSSessionStop',
        'mBMSUELinking',
        'mBMSRegistration',
        'mBMSCNDe-Registration',
        'mBMSRABEstablishmentIndication',
        'mBMSRABRelease',
        'enhancedRelocationComplete',
        'enhancedRelocationCompleteConfirm',
        'rANAP-enhancedRelocation',
        'sRVCCPreparation',
        'ueRadioCapabilityMatch',
        'ueRegistrationQuery',
        'rerouteNASRequest',
        ]
    _param_ = [
        ]
    
    #-----< RANAP-ELEMENTARY-PROCEDURE >-----#
    RANAP_ELEMENTARY_PROCEDURE = CLASS(name='RANAP-ELEMENTARY-PROCEDURE', mode=MODE_TYPE)
    _RANAP_ELEMENTARY_PROCEDURE_InitiatingMessage = OPEN(name='InitiatingMessage', mode=MODE_TYPE)
    _RANAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome = OPEN(name='SuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _RANAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome = OPEN(name='UnsuccessfulOutcome', mode=MODE_TYPE, opt=True)
    _RANAP_ELEMENTARY_PROCEDURE_Outcome = OPEN(name='Outcome', mode=MODE_TYPE, opt=True)
    _RANAP_ELEMENTARY_PROCEDURE_procedureCode = INT(name='procedureCode', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'ProcedureCode')), uniq=True)
    _RANAP_ELEMENTARY_PROCEDURE_criticality = ENUM(name='criticality', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-CommonDataTypes', 'Criticality')), default='ignore')
    RANAP_ELEMENTARY_PROCEDURE._cont = ASN1Dict([
        ('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURE_InitiatingMessage),
        ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome),
        ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome),
        ('Outcome', _RANAP_ELEMENTARY_PROCEDURE_Outcome),
        ('procedureCode', _RANAP_ELEMENTARY_PROCEDURE_procedureCode),
        ('criticality', _RANAP_ELEMENTARY_PROCEDURE_criticality),
        ])
    
    #-----< RANAP-PDU >-----#
    RANAP_PDU = CHOICE(name='RANAP-PDU', mode=MODE_TYPE)
    _RANAP_PDU_initiatingMessage = SEQ(name='initiatingMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'InitiatingMessage')))
    _RANAP_PDU_successfulOutcome = SEQ(name='successfulOutcome', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'SuccessfulOutcome')))
    _RANAP_PDU_unsuccessfulOutcome = SEQ(name='unsuccessfulOutcome', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'UnsuccessfulOutcome')))
    _RANAP_PDU_outcome = SEQ(name='outcome', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'Outcome')))
    RANAP_PDU._cont = ASN1Dict([
        ('initiatingMessage', _RANAP_PDU_initiatingMessage),
        ('successfulOutcome', _RANAP_PDU_successfulOutcome),
        ('unsuccessfulOutcome', _RANAP_PDU_unsuccessfulOutcome),
        ('outcome', _RANAP_PDU_outcome),
        ])
    RANAP_PDU._ext = []
    
    #-----< InitiatingMessage >-----#
    InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE)
    _InitiatingMessage_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __InitiatingMessage_procedureCode_tab = CLASS(name='_tab_RANAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    ___InitiatingMessage_procedureCode_tab_val_Outcome_27 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_29 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_33 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    ___InitiatingMessage_procedureCode_tab_val_Outcome_34 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_35 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_35 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_36 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_37 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_37 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_38 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_38 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_39 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    ___InitiatingMessage_procedureCode_tab_val_Outcome_40 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    ___InitiatingMessage_procedureCode_tab_val_Outcome_41 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    ___InitiatingMessage_procedureCode_tab_val_Outcome_42 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    __InitiatingMessage_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27), ('Outcome', ___InitiatingMessage_procedureCode_tab_val_Outcome_27), ('procedureCode', 0), ('criticality', 'reject')])], rr=[], ev=[dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_28), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_29), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_29), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_30), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_31), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_31), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_32), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_32), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_33), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34), ('Outcome', ___InitiatingMessage_procedureCode_tab_val_Outcome_34), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_35), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_35), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_36), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_37), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_37), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_38), ('UnsuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_38), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39), ('SuccessfulOutcome', ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_39), ('procedureCode', 45), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40), ('Outcome', ___InitiatingMessage_procedureCode_tab_val_Outcome_40), ('procedureCode', 46), ('criticality', 'reject')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41), ('Outcome', ___InitiatingMessage_procedureCode_tab_val_Outcome_41), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42), ('Outcome', ___InitiatingMessage_procedureCode_tab_val_Outcome_42), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 49), ('criticality', 'reject')])], er=[])
    _InitiatingMessage_procedureCode._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_procedureCode._const_tab_at = None
    _InitiatingMessage_procedureCode._const_tab_id = 'procedureCode'
    _InitiatingMessage_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _InitiatingMessage_criticality._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_criticality._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_criticality._const_tab_id = 'criticality'
    _InitiatingMessage_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['InitiatingMessage']))
    _InitiatingMessage_value._const_tab = __InitiatingMessage_procedureCode_tab
    _InitiatingMessage_value._const_tab_at = ('..', 'procedureCode')
    _InitiatingMessage_value._const_tab_id = 'InitiatingMessage'
    InitiatingMessage._cont = ASN1Dict([
        ('procedureCode', _InitiatingMessage_procedureCode),
        ('criticality', _InitiatingMessage_criticality),
        ('value', _InitiatingMessage_value),
        ])
    InitiatingMessage._ext = None
    
    #-----< SuccessfulOutcome >-----#
    SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE)
    _SuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __SuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_RANAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_Outcome_27 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_Outcome_34 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_Outcome_40 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_Outcome_41 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_Outcome_42 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    __SuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('Outcome', ___SuccessfulOutcome_procedureCode_tab_val_Outcome_27), ('procedureCode', 0), ('criticality', 'reject')])], rr=[], ev=[dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('Outcome', ___SuccessfulOutcome_procedureCode_tab_val_Outcome_34), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38), ('UnsuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), ('SuccessfulOutcome', ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39), ('procedureCode', 45), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), ('Outcome', ___SuccessfulOutcome_procedureCode_tab_val_Outcome_40), ('procedureCode', 46), ('criticality', 'reject')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), ('Outcome', ___SuccessfulOutcome_procedureCode_tab_val_Outcome_41), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), ('Outcome', ___SuccessfulOutcome_procedureCode_tab_val_Outcome_42), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 49), ('criticality', 'reject')])], er=[])
    _SuccessfulOutcome_procedureCode._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_procedureCode._const_tab_at = None
    _SuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _SuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _SuccessfulOutcome_criticality._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _SuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['SuccessfulOutcome']))
    _SuccessfulOutcome_value._const_tab = __SuccessfulOutcome_procedureCode_tab
    _SuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _SuccessfulOutcome_value._const_tab_id = 'SuccessfulOutcome'
    SuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _SuccessfulOutcome_procedureCode),
        ('criticality', _SuccessfulOutcome_criticality),
        ('value', _SuccessfulOutcome_value),
        ])
    SuccessfulOutcome._ext = None
    
    #-----< UnsuccessfulOutcome >-----#
    UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE)
    _UnsuccessfulOutcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __UnsuccessfulOutcome_procedureCode_tab = CLASS(name='_tab_RANAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_27 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_34 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_40 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_41 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_42 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    __UnsuccessfulOutcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27), ('Outcome', ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_27), ('procedureCode', 0), ('criticality', 'reject')])], rr=[], ev=[dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34), ('Outcome', ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_34), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38), ('UnsuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39), ('SuccessfulOutcome', ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39), ('procedureCode', 45), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40), ('Outcome', ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_40), ('procedureCode', 46), ('criticality', 'reject')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41), ('Outcome', ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_41), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42), ('Outcome', ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_42), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 49), ('criticality', 'reject')])], er=[])
    _UnsuccessfulOutcome_procedureCode._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_procedureCode._const_tab_at = None
    _UnsuccessfulOutcome_procedureCode._const_tab_id = 'procedureCode'
    _UnsuccessfulOutcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _UnsuccessfulOutcome_criticality._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_criticality._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_criticality._const_tab_id = 'criticality'
    _UnsuccessfulOutcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['UnsuccessfulOutcome']))
    _UnsuccessfulOutcome_value._const_tab = __UnsuccessfulOutcome_procedureCode_tab
    _UnsuccessfulOutcome_value._const_tab_at = ('..', 'procedureCode')
    _UnsuccessfulOutcome_value._const_tab_id = 'UnsuccessfulOutcome'
    UnsuccessfulOutcome._cont = ASN1Dict([
        ('procedureCode', _UnsuccessfulOutcome_procedureCode),
        ('criticality', _UnsuccessfulOutcome_criticality),
        ('value', _UnsuccessfulOutcome_value),
        ])
    UnsuccessfulOutcome._ext = None
    
    #-----< Outcome >-----#
    Outcome = SEQ(name='Outcome', mode=MODE_TYPE)
    _Outcome_procedureCode = INT(name='procedureCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['procedureCode']))
    __Outcome_procedureCode_tab = CLASS(name='_tab_RANAP-ELEMENTARY-PROCEDURE', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    ___Outcome_procedureCode_tab_val_Outcome_27 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_29 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_31 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_32 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_32 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_33 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    ___Outcome_procedureCode_tab_val_Outcome_34 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_35 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_35 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_36 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_37 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_37 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_38 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_38 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    ___Outcome_procedureCode_tab_val_SuccessfulOutcome_39 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    ___Outcome_procedureCode_tab_val_Outcome_40 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    ___Outcome_procedureCode_tab_val_Outcome_41 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    ___Outcome_procedureCode_tab_val_Outcome_42 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    ___Outcome_procedureCode_tab_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    __Outcome_procedureCode_tab._val = ASN1Set(rv=[dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_0), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_1), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_2), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_3), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_4), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_5), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_6), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_7), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_8), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_8), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_9), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_11), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_12), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_13), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_14), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_15), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_16), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_17), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_18), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_19), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_20), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_21), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_22), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_23), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_24), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_25), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_26), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_27), ('Outcome', ___Outcome_procedureCode_tab_val_Outcome_27), ('procedureCode', 0), ('criticality', 'reject')])], rr=[], ev=[dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_28), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_28), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_29), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_29), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_29), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_30), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_30), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_31), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_31), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_31), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_32), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_32), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_32), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_33), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_33), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_34), ('Outcome', ___Outcome_procedureCode_tab_val_Outcome_34), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_35), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_35), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_35), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_36), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_36), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_37), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_37), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_37), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_38), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_38), ('UnsuccessfulOutcome', ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_38), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_39), ('SuccessfulOutcome', ___Outcome_procedureCode_tab_val_SuccessfulOutcome_39), ('procedureCode', 45), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_40), ('Outcome', ___Outcome_procedureCode_tab_val_Outcome_40), ('procedureCode', 46), ('criticality', 'reject')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_41), ('Outcome', ___Outcome_procedureCode_tab_val_Outcome_41), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_42), ('Outcome', ___Outcome_procedureCode_tab_val_Outcome_42), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_43), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_44), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_45), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_46), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_47), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', ___Outcome_procedureCode_tab_val_InitiatingMessage_48), ('procedureCode', 49), ('criticality', 'reject')])], er=[])
    _Outcome_procedureCode._const_tab = __Outcome_procedureCode_tab
    _Outcome_procedureCode._const_tab_at = None
    _Outcome_procedureCode._const_tab_id = 'procedureCode'
    _Outcome_criticality = ENUM(name='criticality', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['criticality']))
    _Outcome_criticality._const_tab = __Outcome_procedureCode_tab
    _Outcome_criticality._const_tab_at = ('..', 'procedureCode')
    _Outcome_criticality._const_tab_id = 'criticality'
    _Outcome_value = OPEN(name='value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE'), ['Outcome']))
    _Outcome_value._const_tab = __Outcome_procedureCode_tab
    _Outcome_value._const_tab_at = ('..', 'procedureCode')
    _Outcome_value._const_tab_id = 'Outcome'
    Outcome._cont = ASN1Dict([
        ('procedureCode', _Outcome_procedureCode),
        ('criticality', _Outcome_criticality),
        ('value', _Outcome_value),
        ])
    Outcome._ext = None
    
    #-----< RANAP-ELEMENTARY-PROCEDURES >-----#
    RANAP_ELEMENTARY_PROCEDURES = CLASS(name='RANAP-ELEMENTARY-PROCEDURES', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_27 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_28 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_29 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_29 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_30 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_30 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_31 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_31 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_32 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_32 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_33 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_34 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_35 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_35 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_36 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_37 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_37 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_38 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_38 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_39 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_40 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_41 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_42 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    RANAP_ELEMENTARY_PROCEDURES._val = ASN1Set(rv=[dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8), ('procedureCode', 27), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26), ('procedureCode', 28), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27), ('Outcome', _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_27), ('procedureCode', 0), ('criticality', 'reject')])], rr=[], ev=[dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_28), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_29), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_29), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_30), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_30), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_31), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_31), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_32), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_32), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_33), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34), ('Outcome', _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_34), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_35), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_35), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_36), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_37), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_37), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_38), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_38), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_39), ('procedureCode', 45), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40), ('Outcome', _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_40), ('procedureCode', 46), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41), ('Outcome', _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_41), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42), ('Outcome', _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_42), ('procedureCode', 48), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48), ('procedureCode', 49), ('criticality', 'reject')])], er=[])
    
    #-----< RANAP-ELEMENTARY-PROCEDURES-CLASS-1 >-----#
    RANAP_ELEMENTARY_PROCEDURES_CLASS_1 = CLASS(name='RANAP-ELEMENTARY-PROCEDURES-CLASS-1', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_15 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19 = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20 = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_21 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_22 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_23 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    RANAP_ELEMENTARY_PROCEDURES_CLASS_1._val = ASN1Set(rv=[dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0), ('procedureCode', 1), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1), ('procedureCode', 2), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2), ('procedureCode', 3), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3), ('procedureCode', 4), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4), ('procedureCode', 5), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5), ('procedureCode', 6), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6), ('procedureCode', 7), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7), ('procedureCode', 9), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8), ('procedureCode', 27), ('criticality', 'reject')])], rr=[], ev=[dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9), ('procedureCode', 30), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10), ('procedureCode', 31), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11), ('procedureCode', 33), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12), ('procedureCode', 35), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13), ('procedureCode', 36), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14), ('procedureCode', 37), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15), ('Outcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_15), ('procedureCode', 38), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16), ('procedureCode', 39), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17), ('procedureCode', 40), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18), ('procedureCode', 42), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19), ('UnsuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19), ('procedureCode', 43), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20), ('SuccessfulOutcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20), ('procedureCode', 45), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21), ('Outcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_21), ('procedureCode', 46), ('criticality', 'reject')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22), ('Outcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_22), ('procedureCode', 47), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23), ('Outcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_23), ('procedureCode', 48), ('criticality', 'ignore')])], er=[])
    
    #-----< RANAP-ELEMENTARY-PROCEDURES-CLASS-2 >-----#
    RANAP_ELEMENTARY_PROCEDURES_CLASS_2 = CLASS(name='RANAP-ELEMENTARY-PROCEDURES-CLASS-2', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    RANAP_ELEMENTARY_PROCEDURES_CLASS_2._val = ASN1Set(rv=[dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0), ('procedureCode', 10), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1), ('procedureCode', 11), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2), ('procedureCode', 12), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3), ('procedureCode', 13), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4), ('procedureCode', 14), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5), ('procedureCode', 15), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6), ('procedureCode', 16), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7), ('procedureCode', 26), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8), ('procedureCode', 17), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9), ('procedureCode', 18), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10), ('procedureCode', 19), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11), ('procedureCode', 20), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12), ('procedureCode', 21), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13), ('procedureCode', 22), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14), ('procedureCode', 23), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15), ('procedureCode', 24), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16), ('procedureCode', 25), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17), ('procedureCode', 28), ('criticality', 'ignore')])], rr=[], ev=[dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18), ('procedureCode', 29), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19), ('procedureCode', 32), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20), ('procedureCode', 34), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21), ('procedureCode', 41), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22), ('procedureCode', 44), ('criticality', 'ignore')]), dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23), ('procedureCode', 49), ('criticality', 'reject')])], er=[])
    
    #-----< RANAP-ELEMENTARY-PROCEDURES-CLASS-3 >-----#
    RANAP_ELEMENTARY_PROCEDURES_CLASS_3 = CLASS(name='RANAP-ELEMENTARY-PROCEDURES-CLASS-3', mode=MODE_SET, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_InitiatingMessage_0 = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_Outcome_0 = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    RANAP_ELEMENTARY_PROCEDURES_CLASS_3._val = ASN1Set(rv=[dict([('InitiatingMessage', _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_InitiatingMessage_0), ('Outcome', _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_Outcome_0), ('procedureCode', 0), ('criticality', 'reject')])], rr=[], ev=[], er=[])
    
    #-----< iu-Release >-----#
    iu_Release = CLASS(name='iu-Release', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _iu_Release_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseCommand')))
    _iu_Release_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseComplete')))
    iu_Release._val = dict([('InitiatingMessage', _iu_Release_val_InitiatingMessage), ('SuccessfulOutcome', _iu_Release_val_SuccessfulOutcome), ('procedureCode', 1), ('criticality', 'reject')])
    
    #-----< relocationPreparation >-----#
    relocationPreparation = CLASS(name='relocationPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _relocationPreparation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequired')))
    _relocationPreparation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCommand')))
    _relocationPreparation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationPreparationFailure')))
    relocationPreparation._val = dict([('InitiatingMessage', _relocationPreparation_val_InitiatingMessage), ('SuccessfulOutcome', _relocationPreparation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _relocationPreparation_val_UnsuccessfulOutcome), ('procedureCode', 2), ('criticality', 'reject')])
    
    #-----< relocationResourceAllocation >-----#
    relocationResourceAllocation = CLASS(name='relocationResourceAllocation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _relocationResourceAllocation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequest')))
    _relocationResourceAllocation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationRequestAcknowledge')))
    _relocationResourceAllocation_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationFailure')))
    relocationResourceAllocation._val = dict([('InitiatingMessage', _relocationResourceAllocation_val_InitiatingMessage), ('SuccessfulOutcome', _relocationResourceAllocation_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _relocationResourceAllocation_val_UnsuccessfulOutcome), ('procedureCode', 3), ('criticality', 'reject')])
    
    #-----< relocationCancel >-----#
    relocationCancel = CLASS(name='relocationCancel', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _relocationCancel_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancel')))
    _relocationCancel_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationCancelAcknowledge')))
    relocationCancel._val = dict([('InitiatingMessage', _relocationCancel_val_InitiatingMessage), ('SuccessfulOutcome', _relocationCancel_val_SuccessfulOutcome), ('procedureCode', 4), ('criticality', 'reject')])
    
    #-----< sRNS-ContextTransfer >-----#
    sRNS_ContextTransfer = CLASS(name='sRNS-ContextTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _sRNS_ContextTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextRequest')))
    _sRNS_ContextTransfer_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-ContextResponse')))
    sRNS_ContextTransfer._val = dict([('InitiatingMessage', _sRNS_ContextTransfer_val_InitiatingMessage), ('SuccessfulOutcome', _sRNS_ContextTransfer_val_SuccessfulOutcome), ('procedureCode', 5), ('criticality', 'reject')])
    
    #-----< securityModeControl >-----#
    securityModeControl = CLASS(name='securityModeControl', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _securityModeControl_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeCommand')))
    _securityModeControl_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeComplete')))
    _securityModeControl_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SecurityModeReject')))
    securityModeControl._val = dict([('InitiatingMessage', _securityModeControl_val_InitiatingMessage), ('SuccessfulOutcome', _securityModeControl_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _securityModeControl_val_UnsuccessfulOutcome), ('procedureCode', 6), ('criticality', 'reject')])
    
    #-----< dataVolumeReport >-----#
    dataVolumeReport = CLASS(name='dataVolumeReport', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _dataVolumeReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReportRequest')))
    _dataVolumeReport_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DataVolumeReport')))
    dataVolumeReport._val = dict([('InitiatingMessage', _dataVolumeReport_val_InitiatingMessage), ('SuccessfulOutcome', _dataVolumeReport_val_SuccessfulOutcome), ('procedureCode', 7), ('criticality', 'reject')])
    
    #-----< reset >-----#
    reset = CLASS(name='reset', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _reset_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Reset')))
    _reset_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetAcknowledge')))
    reset._val = dict([('InitiatingMessage', _reset_val_InitiatingMessage), ('SuccessfulOutcome', _reset_val_SuccessfulOutcome), ('procedureCode', 9), ('criticality', 'reject')])
    
    #-----< rAB-ReleaseRequest >-----#
    rAB_ReleaseRequest = CLASS(name='rAB-ReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rAB_ReleaseRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ReleaseRequest')))
    rAB_ReleaseRequest._val = dict([('InitiatingMessage', _rAB_ReleaseRequest_val_InitiatingMessage), ('procedureCode', 10), ('criticality', 'ignore')])
    
    #-----< iu-ReleaseRequest >-----#
    iu_ReleaseRequest = CLASS(name='iu-ReleaseRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _iu_ReleaseRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Iu-ReleaseRequest')))
    iu_ReleaseRequest._val = dict([('InitiatingMessage', _iu_ReleaseRequest_val_InitiatingMessage), ('procedureCode', 11), ('criticality', 'ignore')])
    
    #-----< relocationDetect >-----#
    relocationDetect = CLASS(name='relocationDetect', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _relocationDetect_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationDetect')))
    relocationDetect._val = dict([('InitiatingMessage', _relocationDetect_val_InitiatingMessage), ('procedureCode', 12), ('criticality', 'ignore')])
    
    #-----< relocationComplete >-----#
    relocationComplete = CLASS(name='relocationComplete', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _relocationComplete_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RelocationComplete')))
    relocationComplete._val = dict([('InitiatingMessage', _relocationComplete_val_InitiatingMessage), ('procedureCode', 13), ('criticality', 'ignore')])
    
    #-----< paging >-----#
    paging = CLASS(name='paging', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _paging_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Paging')))
    paging._val = dict([('InitiatingMessage', _paging_val_InitiatingMessage), ('procedureCode', 14), ('criticality', 'ignore')])
    
    #-----< commonID >-----#
    commonID = CLASS(name='commonID', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _commonID_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CommonID')))
    commonID._val = dict([('InitiatingMessage', _commonID_val_InitiatingMessage), ('procedureCode', 15), ('criticality', 'ignore')])
    
    #-----< cN-InvokeTrace >-----#
    cN_InvokeTrace = CLASS(name='cN-InvokeTrace', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _cN_InvokeTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-InvokeTrace')))
    cN_InvokeTrace._val = dict([('InitiatingMessage', _cN_InvokeTrace_val_InitiatingMessage), ('procedureCode', 16), ('criticality', 'ignore')])
    
    #-----< cN-DeactivateTrace >-----#
    cN_DeactivateTrace = CLASS(name='cN-DeactivateTrace', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _cN_DeactivateTrace_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'CN-DeactivateTrace')))
    cN_DeactivateTrace._val = dict([('InitiatingMessage', _cN_DeactivateTrace_val_InitiatingMessage), ('procedureCode', 26), ('criticality', 'ignore')])
    
    #-----< locationReportingControl >-----#
    locationReportingControl = CLASS(name='locationReportingControl', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _locationReportingControl_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReportingControl')))
    locationReportingControl._val = dict([('InitiatingMessage', _locationReportingControl_val_InitiatingMessage), ('procedureCode', 17), ('criticality', 'ignore')])
    
    #-----< locationReport >-----#
    locationReport = CLASS(name='locationReport', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _locationReport_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationReport')))
    locationReport._val = dict([('InitiatingMessage', _locationReport_val_InitiatingMessage), ('procedureCode', 18), ('criticality', 'ignore')])
    
    #-----< initialUE-Message >-----#
    initialUE_Message = CLASS(name='initialUE-Message', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _initialUE_Message_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InitialUE-Message')))
    initialUE_Message._val = dict([('InitiatingMessage', _initialUE_Message_val_InitiatingMessage), ('procedureCode', 19), ('criticality', 'ignore')])
    
    #-----< directTransfer >-----#
    directTransfer = CLASS(name='directTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _directTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectTransfer')))
    directTransfer._val = dict([('InitiatingMessage', _directTransfer_val_InitiatingMessage), ('procedureCode', 20), ('criticality', 'ignore')])
    
    #-----< overloadControl >-----#
    overloadControl = CLASS(name='overloadControl', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _overloadControl_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'Overload')))
    overloadControl._val = dict([('InitiatingMessage', _overloadControl_val_InitiatingMessage), ('procedureCode', 21), ('criticality', 'ignore')])
    
    #-----< errorIndication >-----#
    errorIndication = CLASS(name='errorIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _errorIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ErrorIndication')))
    errorIndication._val = dict([('InitiatingMessage', _errorIndication_val_InitiatingMessage), ('procedureCode', 22), ('criticality', 'ignore')])
    
    #-----< sRNS-DataForward >-----#
    sRNS_DataForward = CLASS(name='sRNS-DataForward', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _sRNS_DataForward_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRNS-DataForwardCommand')))
    sRNS_DataForward._val = dict([('InitiatingMessage', _sRNS_DataForward_val_InitiatingMessage), ('procedureCode', 23), ('criticality', 'ignore')])
    
    #-----< forwardSRNS-Context >-----#
    forwardSRNS_Context = CLASS(name='forwardSRNS-Context', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _forwardSRNS_Context_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ForwardSRNS-Context')))
    forwardSRNS_Context._val = dict([('InitiatingMessage', _forwardSRNS_Context_val_InitiatingMessage), ('procedureCode', 24), ('criticality', 'ignore')])
    
    #-----< rAB-Assignment >-----#
    rAB_Assignment = CLASS(name='rAB-Assignment', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rAB_Assignment_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentRequest')))
    _rAB_Assignment_val_Outcome = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-AssignmentResponse')))
    rAB_Assignment._val = dict([('InitiatingMessage', _rAB_Assignment_val_InitiatingMessage), ('Outcome', _rAB_Assignment_val_Outcome), ('procedureCode', 0), ('criticality', 'reject')])
    
    #-----< privateMessage >-----#
    privateMessage = CLASS(name='privateMessage', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _privateMessage_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'PrivateMessage')))
    privateMessage._val = dict([('InitiatingMessage', _privateMessage_val_InitiatingMessage), ('procedureCode', 25), ('criticality', 'ignore')])
    
    #-----< resetResource >-----#
    resetResource = CLASS(name='resetResource', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _resetResource_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResource')))
    _resetResource_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'ResetResourceAcknowledge')))
    resetResource._val = dict([('InitiatingMessage', _resetResource_val_InitiatingMessage), ('SuccessfulOutcome', _resetResource_val_SuccessfulOutcome), ('procedureCode', 27), ('criticality', 'reject')])
    
    #-----< rANAP-Relocation >-----#
    rANAP_Relocation = CLASS(name='rANAP-Relocation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rANAP_Relocation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-RelocationInformation')))
    rANAP_Relocation._val = dict([('InitiatingMessage', _rANAP_Relocation_val_InitiatingMessage), ('procedureCode', 28), ('criticality', 'ignore')])
    
    #-----< rAB-ModifyRequest >-----#
    rAB_ModifyRequest = CLASS(name='rAB-ModifyRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rAB_ModifyRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RAB-ModifyRequest')))
    rAB_ModifyRequest._val = dict([('InitiatingMessage', _rAB_ModifyRequest_val_InitiatingMessage), ('procedureCode', 29), ('criticality', 'ignore')])
    
    #-----< locationRelatedData >-----#
    locationRelatedData = CLASS(name='locationRelatedData', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _locationRelatedData_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataRequest')))
    _locationRelatedData_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataResponse')))
    _locationRelatedData_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'LocationRelatedDataFailure')))
    locationRelatedData._val = dict([('InitiatingMessage', _locationRelatedData_val_InitiatingMessage), ('SuccessfulOutcome', _locationRelatedData_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _locationRelatedData_val_UnsuccessfulOutcome), ('procedureCode', 30), ('criticality', 'reject')])
    
    #-----< informationTransfer >-----#
    informationTransfer = CLASS(name='informationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _informationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferIndication')))
    _informationTransfer_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferConfirmation')))
    _informationTransfer_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'InformationTransferFailure')))
    informationTransfer._val = dict([('InitiatingMessage', _informationTransfer_val_InitiatingMessage), ('SuccessfulOutcome', _informationTransfer_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _informationTransfer_val_UnsuccessfulOutcome), ('procedureCode', 31), ('criticality', 'reject')])
    
    #-----< uESpecificInformation >-----#
    uESpecificInformation = CLASS(name='uESpecificInformation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _uESpecificInformation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UESpecificInformationIndication')))
    uESpecificInformation._val = dict([('InitiatingMessage', _uESpecificInformation_val_InitiatingMessage), ('procedureCode', 32), ('criticality', 'ignore')])
    
    #-----< directInformationTransfer >-----#
    directInformationTransfer = CLASS(name='directInformationTransfer', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _directInformationTransfer_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'DirectInformationTransfer')))
    directInformationTransfer._val = dict([('InitiatingMessage', _directInformationTransfer_val_InitiatingMessage), ('procedureCode', 34), ('criticality', 'ignore')])
    
    #-----< uplinkInformationExchange >-----#
    uplinkInformationExchange = CLASS(name='uplinkInformationExchange', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _uplinkInformationExchange_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeRequest')))
    _uplinkInformationExchange_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeResponse')))
    _uplinkInformationExchange_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UplinkInformationExchangeFailure')))
    uplinkInformationExchange._val = dict([('InitiatingMessage', _uplinkInformationExchange_val_InitiatingMessage), ('SuccessfulOutcome', _uplinkInformationExchange_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _uplinkInformationExchange_val_UnsuccessfulOutcome), ('procedureCode', 33), ('criticality', 'reject')])
    
    #-----< mBMSSessionStart >-----#
    mBMSSessionStart = CLASS(name='mBMSSessionStart', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSSessionStart_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStart')))
    _mBMSSessionStart_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartResponse')))
    _mBMSSessionStart_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStartFailure')))
    mBMSSessionStart._val = dict([('InitiatingMessage', _mBMSSessionStart_val_InitiatingMessage), ('SuccessfulOutcome', _mBMSSessionStart_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _mBMSSessionStart_val_UnsuccessfulOutcome), ('procedureCode', 35), ('criticality', 'reject')])
    
    #-----< mBMSSessionUpdate >-----#
    mBMSSessionUpdate = CLASS(name='mBMSSessionUpdate', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSSessionUpdate_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdate')))
    _mBMSSessionUpdate_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateResponse')))
    _mBMSSessionUpdate_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionUpdateFailure')))
    mBMSSessionUpdate._val = dict([('InitiatingMessage', _mBMSSessionUpdate_val_InitiatingMessage), ('SuccessfulOutcome', _mBMSSessionUpdate_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _mBMSSessionUpdate_val_UnsuccessfulOutcome), ('procedureCode', 36), ('criticality', 'reject')])
    
    #-----< mBMSSessionStop >-----#
    mBMSSessionStop = CLASS(name='mBMSSessionStop', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSSessionStop_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStop')))
    _mBMSSessionStop_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSSessionStopResponse')))
    mBMSSessionStop._val = dict([('InitiatingMessage', _mBMSSessionStop_val_InitiatingMessage), ('SuccessfulOutcome', _mBMSSessionStop_val_SuccessfulOutcome), ('procedureCode', 37), ('criticality', 'reject')])
    
    #-----< mBMSUELinking >-----#
    mBMSUELinking = CLASS(name='mBMSUELinking', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSUELinking_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingRequest')))
    _mBMSUELinking_val_Outcome = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSUELinkingResponse')))
    mBMSUELinking._val = dict([('InitiatingMessage', _mBMSUELinking_val_InitiatingMessage), ('Outcome', _mBMSUELinking_val_Outcome), ('procedureCode', 38), ('criticality', 'reject')])
    
    #-----< mBMSRegistration >-----#
    mBMSRegistration = CLASS(name='mBMSRegistration', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSRegistration_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationRequest')))
    _mBMSRegistration_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationResponse')))
    _mBMSRegistration_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRegistrationFailure')))
    mBMSRegistration._val = dict([('InitiatingMessage', _mBMSRegistration_val_InitiatingMessage), ('SuccessfulOutcome', _mBMSRegistration_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _mBMSRegistration_val_UnsuccessfulOutcome), ('procedureCode', 39), ('criticality', 'reject')])
    
    #-----< mBMSCNDe-Registration >-----#
    mBMSCNDe_Registration = CLASS(name='mBMSCNDe-Registration', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSCNDe_Registration_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationRequest')))
    _mBMSCNDe_Registration_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSCNDe-RegistrationResponse')))
    mBMSCNDe_Registration._val = dict([('InitiatingMessage', _mBMSCNDe_Registration_val_InitiatingMessage), ('SuccessfulOutcome', _mBMSCNDe_Registration_val_SuccessfulOutcome), ('procedureCode', 40), ('criticality', 'reject')])
    
    #-----< mBMSRABEstablishmentIndication >-----#
    mBMSRABEstablishmentIndication = CLASS(name='mBMSRABEstablishmentIndication', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSRABEstablishmentIndication_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABEstablishmentIndication')))
    mBMSRABEstablishmentIndication._val = dict([('InitiatingMessage', _mBMSRABEstablishmentIndication_val_InitiatingMessage), ('procedureCode', 41), ('criticality', 'ignore')])
    
    #-----< mBMSRABRelease >-----#
    mBMSRABRelease = CLASS(name='mBMSRABRelease', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _mBMSRABRelease_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseRequest')))
    _mBMSRABRelease_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABRelease')))
    _mBMSRABRelease_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'MBMSRABReleaseFailure')))
    mBMSRABRelease._val = dict([('InitiatingMessage', _mBMSRABRelease_val_InitiatingMessage), ('SuccessfulOutcome', _mBMSRABRelease_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _mBMSRABRelease_val_UnsuccessfulOutcome), ('procedureCode', 42), ('criticality', 'reject')])
    
    #-----< enhancedRelocationComplete >-----#
    enhancedRelocationComplete = CLASS(name='enhancedRelocationComplete', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _enhancedRelocationComplete_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteRequest')))
    _enhancedRelocationComplete_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteResponse')))
    _enhancedRelocationComplete_val_UnsuccessfulOutcome = SEQ(name='UnsuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteFailure')))
    enhancedRelocationComplete._val = dict([('InitiatingMessage', _enhancedRelocationComplete_val_InitiatingMessage), ('SuccessfulOutcome', _enhancedRelocationComplete_val_SuccessfulOutcome), ('UnsuccessfulOutcome', _enhancedRelocationComplete_val_UnsuccessfulOutcome), ('procedureCode', 43), ('criticality', 'reject')])
    
    #-----< enhancedRelocationCompleteConfirm >-----#
    enhancedRelocationCompleteConfirm = CLASS(name='enhancedRelocationCompleteConfirm', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _enhancedRelocationCompleteConfirm_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'EnhancedRelocationCompleteConfirm')))
    enhancedRelocationCompleteConfirm._val = dict([('InitiatingMessage', _enhancedRelocationCompleteConfirm_val_InitiatingMessage), ('procedureCode', 44), ('criticality', 'ignore')])
    
    #-----< rANAP-enhancedRelocation >-----#
    rANAP_enhancedRelocation = CLASS(name='rANAP-enhancedRelocation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rANAP_enhancedRelocation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationRequest')))
    _rANAP_enhancedRelocation_val_SuccessfulOutcome = SEQ(name='SuccessfulOutcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RANAP-EnhancedRelocationInformationResponse')))
    rANAP_enhancedRelocation._val = dict([('InitiatingMessage', _rANAP_enhancedRelocation_val_InitiatingMessage), ('SuccessfulOutcome', _rANAP_enhancedRelocation_val_SuccessfulOutcome), ('procedureCode', 45), ('criticality', 'reject')])
    
    #-----< sRVCCPreparation >-----#
    sRVCCPreparation = CLASS(name='sRVCCPreparation', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _sRVCCPreparation_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysRequest')))
    _sRVCCPreparation_val_Outcome = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'SRVCC-CSKeysResponse')))
    sRVCCPreparation._val = dict([('InitiatingMessage', _sRVCCPreparation_val_InitiatingMessage), ('Outcome', _sRVCCPreparation_val_Outcome), ('procedureCode', 46), ('criticality', 'reject')])
    
    #-----< ueRadioCapabilityMatch >-----#
    ueRadioCapabilityMatch = CLASS(name='ueRadioCapabilityMatch', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _ueRadioCapabilityMatch_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchRequest')))
    _ueRadioCapabilityMatch_val_Outcome = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRadioCapabilityMatchResponse')))
    ueRadioCapabilityMatch._val = dict([('InitiatingMessage', _ueRadioCapabilityMatch_val_InitiatingMessage), ('Outcome', _ueRadioCapabilityMatch_val_Outcome), ('procedureCode', 47), ('criticality', 'ignore')])
    
    #-----< ueRegistrationQuery >-----#
    ueRegistrationQuery = CLASS(name='ueRegistrationQuery', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _ueRegistrationQuery_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryRequest')))
    _ueRegistrationQuery_val_Outcome = SEQ(name='Outcome', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'UeRegistrationQueryResponse')))
    ueRegistrationQuery._val = dict([('InitiatingMessage', _ueRegistrationQuery_val_InitiatingMessage), ('Outcome', _ueRegistrationQuery_val_Outcome), ('procedureCode', 48), ('criticality', 'ignore')])
    
    #-----< rerouteNASRequest >-----#
    rerouteNASRequest = CLASS(name='rerouteNASRequest', mode=MODE_VALUE, typeref=ASN1RefType(('RANAP-PDU-Descriptions', 'RANAP-ELEMENTARY-PROCEDURE')))
    _rerouteNASRequest_val_InitiatingMessage = SEQ(name='InitiatingMessage', mode=MODE_TYPE, typeref=ASN1RefType(('RANAP-PDU-Contents', 'RerouteNASRequest')))
    rerouteNASRequest._val = dict([('InitiatingMessage', _rerouteNASRequest_val_InitiatingMessage), ('procedureCode', 49), ('criticality', 'reject')])
    
    _all_ = [
        _RANAP_ELEMENTARY_PROCEDURE_InitiatingMessage,
        _RANAP_ELEMENTARY_PROCEDURE_SuccessfulOutcome,
        _RANAP_ELEMENTARY_PROCEDURE_UnsuccessfulOutcome,
        _RANAP_ELEMENTARY_PROCEDURE_Outcome,
        _RANAP_ELEMENTARY_PROCEDURE_procedureCode,
        _RANAP_ELEMENTARY_PROCEDURE_criticality,
        RANAP_ELEMENTARY_PROCEDURE,
        _RANAP_PDU_initiatingMessage,
        _RANAP_PDU_successfulOutcome,
        _RANAP_PDU_unsuccessfulOutcome,
        _RANAP_PDU_outcome,
        RANAP_PDU,
        __InitiatingMessage_procedureCode_tab,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_0,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_0,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_1,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_2,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_3,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_3,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_4,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_4,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_5,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_6,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_6,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_7,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_7,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_8,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_8,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_9,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_10,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_11,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_12,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_13,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_14,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_15,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_16,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_17,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_18,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_19,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_20,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_21,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_22,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_23,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_24,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_25,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_26,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_27,
        ___InitiatingMessage_procedureCode_tab_val_Outcome_27,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_28,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_28,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_29,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_29,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_29,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_30,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_30,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_31,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_31,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_32,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_32,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_33,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_33,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_34,
        ___InitiatingMessage_procedureCode_tab_val_Outcome_34,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_35,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_35,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_35,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_36,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_36,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_37,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_37,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_37,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_38,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_38,
        ___InitiatingMessage_procedureCode_tab_val_UnsuccessfulOutcome_38,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_39,
        ___InitiatingMessage_procedureCode_tab_val_SuccessfulOutcome_39,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_40,
        ___InitiatingMessage_procedureCode_tab_val_Outcome_40,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_41,
        ___InitiatingMessage_procedureCode_tab_val_Outcome_41,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_42,
        ___InitiatingMessage_procedureCode_tab_val_Outcome_42,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_43,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_44,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_45,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_46,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_47,
        ___InitiatingMessage_procedureCode_tab_val_InitiatingMessage_48,
        _InitiatingMessage_procedureCode,
        _InitiatingMessage_criticality,
        _InitiatingMessage_value,
        InitiatingMessage,
        __SuccessfulOutcome_procedureCode_tab,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___SuccessfulOutcome_procedureCode_tab_val_Outcome_27,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___SuccessfulOutcome_procedureCode_tab_val_Outcome_34,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38,
        ___SuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___SuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___SuccessfulOutcome_procedureCode_tab_val_Outcome_40,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___SuccessfulOutcome_procedureCode_tab_val_Outcome_41,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___SuccessfulOutcome_procedureCode_tab_val_Outcome_42,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___SuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        _SuccessfulOutcome_procedureCode,
        _SuccessfulOutcome_criticality,
        _SuccessfulOutcome_value,
        SuccessfulOutcome,
        __UnsuccessfulOutcome_procedureCode_tab,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_9,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_10,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_11,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_12,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_13,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_14,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_15,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_16,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_17,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_18,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_19,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_20,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_21,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_22,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_23,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_24,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_25,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_26,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_27,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_29,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_33,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_34,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_35,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_36,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_37,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_UnsuccessfulOutcome_38,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_SuccessfulOutcome_39,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_40,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_41,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_Outcome_42,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_43,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_44,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_45,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_46,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_47,
        ___UnsuccessfulOutcome_procedureCode_tab_val_InitiatingMessage_48,
        _UnsuccessfulOutcome_procedureCode,
        _UnsuccessfulOutcome_criticality,
        _UnsuccessfulOutcome_value,
        UnsuccessfulOutcome,
        __Outcome_procedureCode_tab,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_0,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_0,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_1,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_1,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_1,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_2,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_2,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_2,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_3,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_3,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_4,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_4,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_5,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_5,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_5,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_6,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_6,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_7,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_7,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_8,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_8,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_9,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_10,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_11,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_12,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_13,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_14,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_15,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_16,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_17,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_18,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_19,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_20,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_21,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_22,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_23,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_24,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_25,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_26,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_27,
        ___Outcome_procedureCode_tab_val_Outcome_27,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_28,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_28,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_28,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_29,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_29,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_29,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_30,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_30,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_30,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_31,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_31,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_31,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_32,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_32,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_32,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_33,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_33,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_34,
        ___Outcome_procedureCode_tab_val_Outcome_34,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_35,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_35,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_35,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_36,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_36,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_37,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_37,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_37,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_38,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_38,
        ___Outcome_procedureCode_tab_val_UnsuccessfulOutcome_38,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_39,
        ___Outcome_procedureCode_tab_val_SuccessfulOutcome_39,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_40,
        ___Outcome_procedureCode_tab_val_Outcome_40,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_41,
        ___Outcome_procedureCode_tab_val_Outcome_41,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_42,
        ___Outcome_procedureCode_tab_val_Outcome_42,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_43,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_44,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_45,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_46,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_47,
        ___Outcome_procedureCode_tab_val_InitiatingMessage_48,
        _Outcome_procedureCode,
        _Outcome_criticality,
        _Outcome_value,
        Outcome,
        RANAP_ELEMENTARY_PROCEDURES,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_0,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_0,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_1,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_1,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_1,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_2,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_2,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_2,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_3,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_3,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_4,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_4,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_5,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_5,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_5,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_6,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_6,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_7,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_7,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_8,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_8,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_9,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_10,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_11,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_12,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_13,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_14,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_15,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_16,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_17,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_18,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_19,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_20,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_21,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_22,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_23,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_24,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_25,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_26,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_27,
        _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_27,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_28,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_28,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_28,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_29,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_29,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_29,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_30,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_30,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_30,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_31,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_31,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_31,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_32,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_32,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_32,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_33,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_33,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_34,
        _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_34,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_35,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_35,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_35,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_36,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_36,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_37,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_37,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_37,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_38,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_38,
        _RANAP_ELEMENTARY_PROCEDURES_val_UnsuccessfulOutcome_38,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_39,
        _RANAP_ELEMENTARY_PROCEDURES_val_SuccessfulOutcome_39,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_40,
        _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_40,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_41,
        _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_41,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_42,
        _RANAP_ELEMENTARY_PROCEDURES_val_Outcome_42,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_43,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_44,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_45,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_46,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_47,
        _RANAP_ELEMENTARY_PROCEDURES_val_InitiatingMessage_48,
        RANAP_ELEMENTARY_PROCEDURES_CLASS_1,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_0,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_0,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_1,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_1,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_1,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_2,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_2,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_2,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_3,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_3,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_4,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_4,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_5,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_5,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_5,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_6,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_6,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_7,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_7,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_8,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_8,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_9,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_9,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_9,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_10,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_10,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_10,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_11,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_11,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_11,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_12,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_12,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_12,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_13,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_13,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_13,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_14,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_14,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_15,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_15,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_16,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_16,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_16,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_17,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_17,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_18,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_18,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_18,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_19,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_19,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_UnsuccessfulOutcome_19,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_20,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_SuccessfulOutcome_20,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_21,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_21,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_22,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_22,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_InitiatingMessage_23,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_1_val_Outcome_23,
        RANAP_ELEMENTARY_PROCEDURES_CLASS_2,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_0,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_1,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_2,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_3,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_4,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_5,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_6,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_7,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_8,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_9,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_10,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_11,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_12,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_13,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_14,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_15,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_16,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_17,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_18,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_19,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_20,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_21,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_22,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_2_val_InitiatingMessage_23,
        RANAP_ELEMENTARY_PROCEDURES_CLASS_3,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_InitiatingMessage_0,
        _RANAP_ELEMENTARY_PROCEDURES_CLASS_3_val_Outcome_0,
        iu_Release,
        _iu_Release_val_InitiatingMessage,
        _iu_Release_val_SuccessfulOutcome,
        relocationPreparation,
        _relocationPreparation_val_InitiatingMessage,
        _relocationPreparation_val_SuccessfulOutcome,
        _relocationPreparation_val_UnsuccessfulOutcome,
        relocationResourceAllocation,
        _relocationResourceAllocation_val_InitiatingMessage,
        _relocationResourceAllocation_val_SuccessfulOutcome,
        _relocationResourceAllocation_val_UnsuccessfulOutcome,
        relocationCancel,
        _relocationCancel_val_InitiatingMessage,
        _relocationCancel_val_SuccessfulOutcome,
        sRNS_ContextTransfer,
        _sRNS_ContextTransfer_val_InitiatingMessage,
        _sRNS_ContextTransfer_val_SuccessfulOutcome,
        securityModeControl,
        _securityModeControl_val_InitiatingMessage,
        _securityModeControl_val_SuccessfulOutcome,
        _securityModeControl_val_UnsuccessfulOutcome,
        dataVolumeReport,
        _dataVolumeReport_val_InitiatingMessage,
        _dataVolumeReport_val_SuccessfulOutcome,
        reset,
        _reset_val_InitiatingMessage,
        _reset_val_SuccessfulOutcome,
        rAB_ReleaseRequest,
        _rAB_ReleaseRequest_val_InitiatingMessage,
        iu_ReleaseRequest,
        _iu_ReleaseRequest_val_InitiatingMessage,
        relocationDetect,
        _relocationDetect_val_InitiatingMessage,
        relocationComplete,
        _relocationComplete_val_InitiatingMessage,
        paging,
        _paging_val_InitiatingMessage,
        commonID,
        _commonID_val_InitiatingMessage,
        cN_InvokeTrace,
        _cN_InvokeTrace_val_InitiatingMessage,
        cN_DeactivateTrace,
        _cN_DeactivateTrace_val_InitiatingMessage,
        locationReportingControl,
        _locationReportingControl_val_InitiatingMessage,
        locationReport,
        _locationReport_val_InitiatingMessage,
        initialUE_Message,
        _initialUE_Message_val_InitiatingMessage,
        directTransfer,
        _directTransfer_val_InitiatingMessage,
        overloadControl,
        _overloadControl_val_InitiatingMessage,
        errorIndication,
        _errorIndication_val_InitiatingMessage,
        sRNS_DataForward,
        _sRNS_DataForward_val_InitiatingMessage,
        forwardSRNS_Context,
        _forwardSRNS_Context_val_InitiatingMessage,
        rAB_Assignment,
        _rAB_Assignment_val_InitiatingMessage,
        _rAB_Assignment_val_Outcome,
        privateMessage,
        _privateMessage_val_InitiatingMessage,
        resetResource,
        _resetResource_val_InitiatingMessage,
        _resetResource_val_SuccessfulOutcome,
        rANAP_Relocation,
        _rANAP_Relocation_val_InitiatingMessage,
        rAB_ModifyRequest,
        _rAB_ModifyRequest_val_InitiatingMessage,
        locationRelatedData,
        _locationRelatedData_val_InitiatingMessage,
        _locationRelatedData_val_SuccessfulOutcome,
        _locationRelatedData_val_UnsuccessfulOutcome,
        informationTransfer,
        _informationTransfer_val_InitiatingMessage,
        _informationTransfer_val_SuccessfulOutcome,
        _informationTransfer_val_UnsuccessfulOutcome,
        uESpecificInformation,
        _uESpecificInformation_val_InitiatingMessage,
        directInformationTransfer,
        _directInformationTransfer_val_InitiatingMessage,
        uplinkInformationExchange,
        _uplinkInformationExchange_val_InitiatingMessage,
        _uplinkInformationExchange_val_SuccessfulOutcome,
        _uplinkInformationExchange_val_UnsuccessfulOutcome,
        mBMSSessionStart,
        _mBMSSessionStart_val_InitiatingMessage,
        _mBMSSessionStart_val_SuccessfulOutcome,
        _mBMSSessionStart_val_UnsuccessfulOutcome,
        mBMSSessionUpdate,
        _mBMSSessionUpdate_val_InitiatingMessage,
        _mBMSSessionUpdate_val_SuccessfulOutcome,
        _mBMSSessionUpdate_val_UnsuccessfulOutcome,
        mBMSSessionStop,
        _mBMSSessionStop_val_InitiatingMessage,
        _mBMSSessionStop_val_SuccessfulOutcome,
        mBMSUELinking,
        _mBMSUELinking_val_InitiatingMessage,
        _mBMSUELinking_val_Outcome,
        mBMSRegistration,
        _mBMSRegistration_val_InitiatingMessage,
        _mBMSRegistration_val_SuccessfulOutcome,
        _mBMSRegistration_val_UnsuccessfulOutcome,
        mBMSCNDe_Registration,
        _mBMSCNDe_Registration_val_InitiatingMessage,
        _mBMSCNDe_Registration_val_SuccessfulOutcome,
        mBMSRABEstablishmentIndication,
        _mBMSRABEstablishmentIndication_val_InitiatingMessage,
        mBMSRABRelease,
        _mBMSRABRelease_val_InitiatingMessage,
        _mBMSRABRelease_val_SuccessfulOutcome,
        _mBMSRABRelease_val_UnsuccessfulOutcome,
        enhancedRelocationComplete,
        _enhancedRelocationComplete_val_InitiatingMessage,
        _enhancedRelocationComplete_val_SuccessfulOutcome,
        _enhancedRelocationComplete_val_UnsuccessfulOutcome,
        enhancedRelocationCompleteConfirm,
        _enhancedRelocationCompleteConfirm_val_InitiatingMessage,
        rANAP_enhancedRelocation,
        _rANAP_enhancedRelocation_val_InitiatingMessage,
        _rANAP_enhancedRelocation_val_SuccessfulOutcome,
        sRVCCPreparation,
        _sRVCCPreparation_val_InitiatingMessage,
        _sRVCCPreparation_val_Outcome,
        ueRadioCapabilityMatch,
        _ueRadioCapabilityMatch_val_InitiatingMessage,
        _ueRadioCapabilityMatch_val_Outcome,
        ueRegistrationQuery,
        _ueRegistrationQuery_val_InitiatingMessage,
        _ueRegistrationQuery_val_Outcome,
        rerouteNASRequest,
        _rerouteNASRequest_val_InitiatingMessage,
    ]

init_modules(RANAP_CommonDataTypes, RANAP_Constants, RANAP_Containers, RANAP_IEs, RANAP_PDU_Contents, RANAP_PDU_Descriptions)
