# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class CryptographicMessageSyntax_2009:

    _name_  = 'CryptographicMessageSyntax-2009'
    _oid_   = [1, 2, 840, 113549, 1, 9, 16, 0, 41]
    
    _obj_ = [
        'CONTENT-TYPE',
        'ContentType',
        'ContentInfo',
        'ContentSet',
        'SignedData',
        'SignerInfos',
        'EncapsulatedContentInfo',
        'SignerInfo',
        'SignedAttributes',
        'SignerIdentifier',
        'SignedAttributesSet',
        'UnsignedAttributes',
        'SignatureValue',
        'EnvelopedData',
        'OriginatorInfo',
        'RecipientInfos',
        'EncryptedContentInfo',
        'UnprotectedAttributes',
        'RecipientInfo',
        'EncryptedKey',
        'KeyTransRecipientInfo',
        'KeyTransportAlgorithmSet',
        'RecipientIdentifier',
        'KeyAgreeRecipientInfo',
        'KeyAgreementAlgorithmSet',
        'OriginatorIdentifierOrKey',
        'OriginatorPublicKey',
        'OriginatorKeySet',
        'RecipientEncryptedKeys',
        'RecipientEncryptedKey',
        'KeyAgreeRecipientIdentifier',
        'RecipientKeyIdentifier',
        'SubjectKeyIdentifier',
        'KEKRecipientInfo',
        'KEKIdentifier',
        'PasswordRecipientInfo',
        'OTHER-RECIPIENT',
        'OtherRecipientInfo',
        'SupportedOtherRecipInfo',
        'DigestedData',
        'Digest',
        'EncryptedData',
        'AuthenticatedData',
        'AuthAttributes',
        'AuthAttributeSet',
        'MessageAuthenticationCode',
        'UnauthAttributes',
        'UnauthAttributeSet',
        'DigestAlgorithmIdentifier',
        'DigestAlgorithmSet',
        'SignatureAlgorithmIdentifier',
        'SignatureAlgorithmSet',
        'KeyEncryptionAlgorithmIdentifier',
        'KeyEncryptionAlgorithmSet',
        'ContentEncryptionAlgorithmIdentifier',
        'ContentEncryptionAlgorithmSet',
        'MessageAuthenticationCodeAlgorithm',
        'MessageAuthenticationCodeAlgorithmSet',
        'KeyDerivationAlgorithmIdentifier',
        'RevocationInfoChoices',
        'RevocationInfoChoice',
        'OTHER-REVOK-INFO',
        'OtherRevocationInfoFormat',
        'SupportedOtherRevokInfo',
        'CertificateChoices',
        'AttributeCertificateV2',
        'OTHER-CERT-FMT',
        'OtherCertificateFormat',
        'SupportedCertFormats',
        'CertificateSet',
        'IssuerAndSerialNumber',
        'CMSVersion',
        'UserKeyingMaterial',
        'KEY-ATTRIBUTE',
        'OtherKeyAttribute',
        'SupportedKeyAttributes',
        'id-ct-contentInfo',
        'ct-Data',
        'id-data',
        'ct-SignedData',
        'id-signedData',
        'ct-EnvelopedData',
        'id-envelopedData',
        'ct-DigestedData',
        'id-digestedData',
        'ct-EncryptedData',
        'id-encryptedData',
        'ct-AuthenticatedData',
        'id-ct-authData',
        'MessageDigest',
        'SigningTime',
        'Time',
        'Countersignature',
        'aa-contentType',
        'id-contentType',
        'aa-messageDigest',
        'id-messageDigest',
        'aa-signingTime',
        'id-signingTime',
        'aa-countersignature',
        'id-countersignature',
        'ExtendedCertificateOrCertificate',
        'ExtendedCertificate',
        'ExtendedCertificateInfo',
        'Signature',
        'Attribute',
        'Attributes',
        ]
    _type_ = [
        'CONTENT-TYPE',
        'ContentType',
        'ContentInfo',
        'SignedData',
        'SignerInfos',
        'EncapsulatedContentInfo',
        'SignerInfo',
        'SignedAttributes',
        'SignerIdentifier',
        'SignatureValue',
        'EnvelopedData',
        'OriginatorInfo',
        'RecipientInfos',
        'EncryptedContentInfo',
        'RecipientInfo',
        'EncryptedKey',
        'KeyTransRecipientInfo',
        'RecipientIdentifier',
        'KeyAgreeRecipientInfo',
        'OriginatorIdentifierOrKey',
        'OriginatorPublicKey',
        'RecipientEncryptedKeys',
        'RecipientEncryptedKey',
        'KeyAgreeRecipientIdentifier',
        'RecipientKeyIdentifier',
        'SubjectKeyIdentifier',
        'KEKRecipientInfo',
        'KEKIdentifier',
        'PasswordRecipientInfo',
        'OTHER-RECIPIENT',
        'OtherRecipientInfo',
        'DigestedData',
        'Digest',
        'EncryptedData',
        'AuthenticatedData',
        'AuthAttributes',
        'MessageAuthenticationCode',
        'UnauthAttributes',
        'DigestAlgorithmIdentifier',
        'SignatureAlgorithmIdentifier',
        'KeyEncryptionAlgorithmIdentifier',
        'ContentEncryptionAlgorithmIdentifier',
        'MessageAuthenticationCodeAlgorithm',
        'KeyDerivationAlgorithmIdentifier',
        'RevocationInfoChoices',
        'RevocationInfoChoice',
        'OTHER-REVOK-INFO',
        'OtherRevocationInfoFormat',
        'CertificateChoices',
        'AttributeCertificateV2',
        'OTHER-CERT-FMT',
        'OtherCertificateFormat',
        'CertificateSet',
        'IssuerAndSerialNumber',
        'CMSVersion',
        'UserKeyingMaterial',
        'KEY-ATTRIBUTE',
        'OtherKeyAttribute',
        'MessageDigest',
        'SigningTime',
        'Time',
        'Countersignature',
        'ExtendedCertificateOrCertificate',
        'ExtendedCertificate',
        'ExtendedCertificateInfo',
        'Signature',
        'Attribute',
        'Attributes',
        ]
    _set_ = [
        'ContentSet',
        'SignedAttributesSet',
        'UnsignedAttributes',
        'UnprotectedAttributes',
        'KeyTransportAlgorithmSet',
        'KeyAgreementAlgorithmSet',
        'OriginatorKeySet',
        'SupportedOtherRecipInfo',
        'AuthAttributeSet',
        'UnauthAttributeSet',
        'DigestAlgorithmSet',
        'SignatureAlgorithmSet',
        'KeyEncryptionAlgorithmSet',
        'ContentEncryptionAlgorithmSet',
        'MessageAuthenticationCodeAlgorithmSet',
        'SupportedOtherRevokInfo',
        'SupportedCertFormats',
        'SupportedKeyAttributes',
        ]
    _val_ = [
        'id-ct-contentInfo',
        'ct-Data',
        'id-data',
        'ct-SignedData',
        'id-signedData',
        'ct-EnvelopedData',
        'id-envelopedData',
        'ct-DigestedData',
        'id-digestedData',
        'ct-EncryptedData',
        'id-encryptedData',
        'ct-AuthenticatedData',
        'id-ct-authData',
        'aa-contentType',
        'id-contentType',
        'aa-messageDigest',
        'id-messageDigest',
        'aa-signingTime',
        'id-signingTime',
        'aa-countersignature',
        'id-countersignature',
        ]
    _class_ = [
        'CONTENT-TYPE',
        'ContentSet',
        'SignedAttributesSet',
        'UnsignedAttributes',
        'UnprotectedAttributes',
        'KeyTransportAlgorithmSet',
        'KeyAgreementAlgorithmSet',
        'OriginatorKeySet',
        'OTHER-RECIPIENT',
        'SupportedOtherRecipInfo',
        'AuthAttributeSet',
        'UnauthAttributeSet',
        'DigestAlgorithmSet',
        'SignatureAlgorithmSet',
        'KeyEncryptionAlgorithmSet',
        'ContentEncryptionAlgorithmSet',
        'MessageAuthenticationCodeAlgorithmSet',
        'OTHER-REVOK-INFO',
        'SupportedOtherRevokInfo',
        'OTHER-CERT-FMT',
        'SupportedCertFormats',
        'KEY-ATTRIBUTE',
        'SupportedKeyAttributes',
        'ct-Data',
        'ct-SignedData',
        'ct-EnvelopedData',
        'ct-DigestedData',
        'ct-EncryptedData',
        'ct-AuthenticatedData',
        'aa-contentType',
        'aa-messageDigest',
        'aa-signingTime',
        'aa-countersignature',
        ]
    _param_ = [
        'Attribute',
        'Attributes',
        ]
    
    #-----< CONTENT-TYPE >-----#
    CONTENT_TYPE = CLASS(name='CONTENT-TYPE', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< ContentType >-----#
    ContentType = OID(name='ContentType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE'), ['id']))
    
    #-----< ContentInfo >-----#
    ContentInfo = SEQ(name='ContentInfo', mode=MODE_TYPE)
    _ContentInfo_contentType = OID(name='contentType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE'), ['id']))
    __ContentInfo_contentType_tab = CLASS(name='_tab_CONTENT-TYPE', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    ___ContentInfo_contentType_tab_val_Type_0 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___ContentInfo_contentType_tab_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignedData')))
    ___ContentInfo_contentType_tab_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedData')))
    ___ContentInfo_contentType_tab_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EnvelopedData')))
    ___ContentInfo_contentType_tab_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'AuthenticatedData')))
    ___ContentInfo_contentType_tab_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'DigestedData')))
    __ContentInfo_contentType_tab._val = ASN1Set(rv=[dict([('Type', ___ContentInfo_contentType_tab_val_Type_0), ('id', (1, 2, 840, 113549, 1, 7, 1))]), dict([('Type', ___ContentInfo_contentType_tab_val_Type_1), ('id', (1, 2, 840, 113549, 1, 7, 2))]), dict([('Type', ___ContentInfo_contentType_tab_val_Type_2), ('id', (1, 2, 840, 113549, 1, 7, 6))]), dict([('Type', ___ContentInfo_contentType_tab_val_Type_3), ('id', (1, 2, 840, 113549, 1, 7, 3))]), dict([('Type', ___ContentInfo_contentType_tab_val_Type_4), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 2))]), dict([('Type', ___ContentInfo_contentType_tab_val_Type_5), ('id', (1, 2, 840, 113549, 1, 7, 5))])], rr=[], ev=None, er=[])
    _ContentInfo_contentType._const_tab = __ContentInfo_contentType_tab
    _ContentInfo_contentType._const_tab_at = None
    _ContentInfo_contentType._const_tab_id = 'id'
    _ContentInfo_content = OPEN(name='content', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE'), ['Type']))
    _ContentInfo_content._const_tab = __ContentInfo_contentType_tab
    _ContentInfo_content._const_tab_at = ('..', 'contentType')
    _ContentInfo_content._const_tab_id = 'Type'
    ContentInfo._cont = ASN1Dict([
        ('contentType', _ContentInfo_contentType),
        ('content', _ContentInfo_content),
        ])
    ContentInfo._ext = None
    
    #-----< ContentSet >-----#
    ContentSet = CLASS(name='ContentSet', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ContentSet_val_Type_0 = OCT_STR(name='Type', mode=MODE_TYPE)
    _ContentSet_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignedData')))
    _ContentSet_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedData')))
    _ContentSet_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EnvelopedData')))
    _ContentSet_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'AuthenticatedData')))
    _ContentSet_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'DigestedData')))
    ContentSet._val = ASN1Set(rv=[dict([('Type', _ContentSet_val_Type_0), ('id', (1, 2, 840, 113549, 1, 7, 1))]), dict([('Type', _ContentSet_val_Type_1), ('id', (1, 2, 840, 113549, 1, 7, 2))]), dict([('Type', _ContentSet_val_Type_2), ('id', (1, 2, 840, 113549, 1, 7, 6))]), dict([('Type', _ContentSet_val_Type_3), ('id', (1, 2, 840, 113549, 1, 7, 3))]), dict([('Type', _ContentSet_val_Type_4), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 2))]), dict([('Type', _ContentSet_val_Type_5), ('id', (1, 2, 840, 113549, 1, 7, 5))])], rr=[], ev=[], er=[])
    
    #-----< SignedData >-----#
    SignedData = SEQ(name='SignedData', mode=MODE_TYPE)
    _SignedData_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _SignedData_digestAlgorithms = SET_OF(name='digestAlgorithms', mode=MODE_TYPE)
    __SignedData_digestAlgorithms__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'DigestAlgorithmIdentifier')))
    _SignedData_digestAlgorithms._cont = __SignedData_digestAlgorithms__item_
    _SignedData_encapContentInfo = SEQ(name='encapContentInfo', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncapsulatedContentInfo')))
    _SignedData_certificates = SET_OF(name='certificates', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CertificateSet')), opt=True)
    _SignedData_crls = SET_OF(name='crls', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RevocationInfoChoices')), opt=True)
    _SignedData_signerInfos = SET_OF(name='signerInfos', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignerInfos')))
    SignedData._cont = ASN1Dict([
        ('version', _SignedData_version),
        ('digestAlgorithms', _SignedData_digestAlgorithms),
        ('encapContentInfo', _SignedData_encapContentInfo),
        ('certificates', _SignedData_certificates),
        ('crls', _SignedData_crls),
        ('signerInfos', _SignedData_signerInfos),
        ])
    SignedData._ext = None
    
    #-----< SignerInfos >-----#
    SignerInfos = SET_OF(name='SignerInfos', mode=MODE_TYPE)
    _SignerInfos__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignerInfo')))
    SignerInfos._cont = _SignerInfos__item_
    
    #-----< EncapsulatedContentInfo >-----#
    EncapsulatedContentInfo = SEQ(name='EncapsulatedContentInfo', mode=MODE_TYPE)
    _EncapsulatedContentInfo_eContentType = OID(name='eContentType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE'), ['id']))
    __EncapsulatedContentInfo_eContentType_tab = CLASS(name='_tab_CONTENT-TYPE', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    ___EncapsulatedContentInfo_eContentType_tab_val_Type_0 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___EncapsulatedContentInfo_eContentType_tab_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignedData')))
    ___EncapsulatedContentInfo_eContentType_tab_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedData')))
    ___EncapsulatedContentInfo_eContentType_tab_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EnvelopedData')))
    ___EncapsulatedContentInfo_eContentType_tab_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'AuthenticatedData')))
    ___EncapsulatedContentInfo_eContentType_tab_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'DigestedData')))
    __EncapsulatedContentInfo_eContentType_tab._val = ASN1Set(rv=[dict([('Type', ___EncapsulatedContentInfo_eContentType_tab_val_Type_0), ('id', (1, 2, 840, 113549, 1, 7, 1))]), dict([('Type', ___EncapsulatedContentInfo_eContentType_tab_val_Type_1), ('id', (1, 2, 840, 113549, 1, 7, 2))]), dict([('Type', ___EncapsulatedContentInfo_eContentType_tab_val_Type_2), ('id', (1, 2, 840, 113549, 1, 7, 6))]), dict([('Type', ___EncapsulatedContentInfo_eContentType_tab_val_Type_3), ('id', (1, 2, 840, 113549, 1, 7, 3))]), dict([('Type', ___EncapsulatedContentInfo_eContentType_tab_val_Type_4), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 2))]), dict([('Type', ___EncapsulatedContentInfo_eContentType_tab_val_Type_5), ('id', (1, 2, 840, 113549, 1, 7, 5))])], rr=[], ev=None, er=[])
    _EncapsulatedContentInfo_eContentType._const_tab = __EncapsulatedContentInfo_eContentType_tab
    _EncapsulatedContentInfo_eContentType._const_tab_at = None
    _EncapsulatedContentInfo_eContentType._const_tab_id = 'id'
    _EncapsulatedContentInfo_eContent = OCT_STR(name='eContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __EncapsulatedContentInfo_eContent_contain = OPEN(name='_cont_eContent', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE'), ['Type']))
    __EncapsulatedContentInfo_eContent_contain._const_tab = __EncapsulatedContentInfo_eContentType_tab
    __EncapsulatedContentInfo_eContent_contain._const_tab_at = ('..', 'eContentType')
    __EncapsulatedContentInfo_eContent_contain._const_tab_id = 'Type'
    _EncapsulatedContentInfo_eContent._const_cont = __EncapsulatedContentInfo_eContent_contain
    EncapsulatedContentInfo._cont = ASN1Dict([
        ('eContentType', _EncapsulatedContentInfo_eContentType),
        ('eContent', _EncapsulatedContentInfo_eContent),
        ])
    EncapsulatedContentInfo._ext = None
    
    #-----< SignerInfo >-----#
    SignerInfo = SEQ(name='SignerInfo', mode=MODE_TYPE)
    _SignerInfo_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _SignerInfo_sid = CHOICE(name='sid', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignerIdentifier')))
    _SignerInfo_digestAlgorithm = SEQ(name='digestAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'DigestAlgorithmIdentifier')))
    _SignerInfo_signedAttrs = SET_OF(name='signedAttrs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignedAttributes')), opt=True)
    _SignerInfo_signatureAlgorithm = SEQ(name='signatureAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignatureAlgorithmIdentifier')))
    _SignerInfo_signature = OCT_STR(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignatureValue')))
    _SignerInfo_unsignedAttrs = SET_OF(name='unsignedAttrs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Attributes')), opt=True)
    __SignerInfo_unsignedAttrs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Attribute')))
    ___SignerInfo_unsignedAttrs__item__attrType = OID(name='attrType', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ____SignerInfo_unsignedAttrs__item__attrType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _____SignerInfo_unsignedAttrs__item__attrType_tab_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Countersignature')))
    ____SignerInfo_unsignedAttrs__item__attrType_tab._val = ASN1Set(rv=[dict([('Type', _____SignerInfo_unsignedAttrs__item__attrType_tab_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 6))])], rr=[], ev=None, er=[])
    ___SignerInfo_unsignedAttrs__item__attrType._const_tab = ____SignerInfo_unsignedAttrs__item__attrType_tab
    ___SignerInfo_unsignedAttrs__item__attrType._const_tab_at = None
    ___SignerInfo_unsignedAttrs__item__attrType._const_tab_id = 'id'
    ___SignerInfo_unsignedAttrs__item__attrValues = SET_OF(name='attrValues', mode=MODE_TYPE)
    ____SignerInfo_unsignedAttrs__item__attrValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    ____SignerInfo_unsignedAttrs__item__attrValues__item_._const_tab = ____SignerInfo_unsignedAttrs__item__attrType_tab
    ____SignerInfo_unsignedAttrs__item__attrValues__item_._const_tab_at = ('..', '..', 'attrType')
    ____SignerInfo_unsignedAttrs__item__attrValues__item_._const_tab_id = 'Type'
    ___SignerInfo_unsignedAttrs__item__attrValues._cont = ____SignerInfo_unsignedAttrs__item__attrValues__item_
    __SignerInfo_unsignedAttrs__item_._cont = ASN1Dict([
        ('attrType', ___SignerInfo_unsignedAttrs__item__attrType),
        ('attrValues', ___SignerInfo_unsignedAttrs__item__attrValues),
        ])
    __SignerInfo_unsignedAttrs__item_._ext = None
    _SignerInfo_unsignedAttrs._cont = __SignerInfo_unsignedAttrs__item_
    _SignerInfo_unsignedAttrs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SignerInfo._cont = ASN1Dict([
        ('version', _SignerInfo_version),
        ('sid', _SignerInfo_sid),
        ('digestAlgorithm', _SignerInfo_digestAlgorithm),
        ('signedAttrs', _SignerInfo_signedAttrs),
        ('signatureAlgorithm', _SignerInfo_signatureAlgorithm),
        ('signature', _SignerInfo_signature),
        ('unsignedAttrs', _SignerInfo_unsignedAttrs),
        ])
    SignerInfo._ext = None
    
    #-----< SignedAttributes >-----#
    SignedAttributes = SET_OF(name='SignedAttributes', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Attributes')))
    _SignedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Attribute')))
    __SignedAttributes__item__attrType = OID(name='attrType', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ___SignedAttributes__item__attrType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____SignedAttributes__item__attrType_tab_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SigningTime')))
    ____SignedAttributes__item__attrType_tab_val_Type_1 = OCT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'MessageDigest')))
    ____SignedAttributes__item__attrType_tab_val_Type_2 = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentType')))
    ___SignedAttributes__item__attrType_tab._val = ASN1Set(rv=[dict([('Type', ____SignedAttributes__item__attrType_tab_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 5))]), dict([('Type', ____SignedAttributes__item__attrType_tab_val_Type_1), ('id', (1, 2, 840, 113549, 1, 9, 4))]), dict([('Type', ____SignedAttributes__item__attrType_tab_val_Type_2), ('id', (1, 2, 840, 113549, 1, 9, 3))])], rr=[], ev=None, er=[])
    __SignedAttributes__item__attrType._const_tab = ___SignedAttributes__item__attrType_tab
    __SignedAttributes__item__attrType._const_tab_at = None
    __SignedAttributes__item__attrType._const_tab_id = 'id'
    __SignedAttributes__item__attrValues = SET_OF(name='attrValues', mode=MODE_TYPE)
    ___SignedAttributes__item__attrValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    ___SignedAttributes__item__attrValues__item_._const_tab = ___SignedAttributes__item__attrType_tab
    ___SignedAttributes__item__attrValues__item_._const_tab_at = ('..', '..', 'attrType')
    ___SignedAttributes__item__attrValues__item_._const_tab_id = 'Type'
    __SignedAttributes__item__attrValues._cont = ___SignedAttributes__item__attrValues__item_
    _SignedAttributes__item_._cont = ASN1Dict([
        ('attrType', __SignedAttributes__item__attrType),
        ('attrValues', __SignedAttributes__item__attrValues),
        ])
    _SignedAttributes__item_._ext = None
    SignedAttributes._cont = _SignedAttributes__item_
    SignedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< SignerIdentifier >-----#
    SignerIdentifier = CHOICE(name='SignerIdentifier', mode=MODE_TYPE)
    _SignerIdentifier_issuerAndSerialNumber = SEQ(name='issuerAndSerialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'IssuerAndSerialNumber')))
    _SignerIdentifier_subjectKeyIdentifier = OCT_STR(name='subjectKeyIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SubjectKeyIdentifier')), group=0)
    SignerIdentifier._cont = ASN1Dict([
        ('issuerAndSerialNumber', _SignerIdentifier_issuerAndSerialNumber),
        ('subjectKeyIdentifier', _SignerIdentifier_subjectKeyIdentifier),
        ])
    SignerIdentifier._ext = ['subjectKeyIdentifier']
    
    #-----< SignedAttributesSet >-----#
    SignedAttributesSet = CLASS(name='SignedAttributesSet', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _SignedAttributesSet_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SigningTime')))
    _SignedAttributesSet_val_Type_1 = OCT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'MessageDigest')))
    _SignedAttributesSet_val_Type_2 = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentType')))
    SignedAttributesSet._val = ASN1Set(rv=[dict([('Type', _SignedAttributesSet_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 5))]), dict([('Type', _SignedAttributesSet_val_Type_1), ('id', (1, 2, 840, 113549, 1, 9, 4))]), dict([('Type', _SignedAttributesSet_val_Type_2), ('id', (1, 2, 840, 113549, 1, 9, 3))])], rr=[], ev=[], er=[])
    
    #-----< UnsignedAttributes >-----#
    UnsignedAttributes = CLASS(name='UnsignedAttributes', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _UnsignedAttributes_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Countersignature')))
    UnsignedAttributes._val = ASN1Set(rv=[dict([('Type', _UnsignedAttributes_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 6))])], rr=[], ev=[], er=[])
    
    #-----< SignatureValue >-----#
    SignatureValue = OCT_STR(name='SignatureValue', mode=MODE_TYPE)
    
    #-----< EnvelopedData >-----#
    EnvelopedData = SEQ(name='EnvelopedData', mode=MODE_TYPE)
    _EnvelopedData_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _EnvelopedData_originatorInfo = SEQ(name='originatorInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OriginatorInfo')), opt=True)
    _EnvelopedData_recipientInfos = SET_OF(name='recipientInfos', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RecipientInfos')))
    _EnvelopedData_encryptedContentInfo = SEQ(name='encryptedContentInfo', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedContentInfo')))
    _EnvelopedData_unprotectedAttrs = SET_OF(name='unprotectedAttrs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Attributes')), opt=True, group=0)
    __EnvelopedData_unprotectedAttrs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Attribute')))
    ___EnvelopedData_unprotectedAttrs__item__attrType = OID(name='attrType', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ____EnvelopedData_unprotectedAttrs__item__attrType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____EnvelopedData_unprotectedAttrs__item__attrType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EnvelopedData_unprotectedAttrs__item__attrType._const_tab = ____EnvelopedData_unprotectedAttrs__item__attrType_tab
    ___EnvelopedData_unprotectedAttrs__item__attrType._const_tab_at = None
    ___EnvelopedData_unprotectedAttrs__item__attrType._const_tab_id = 'id'
    ___EnvelopedData_unprotectedAttrs__item__attrValues = SET_OF(name='attrValues', mode=MODE_TYPE)
    ____EnvelopedData_unprotectedAttrs__item__attrValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    _____EnvelopedData_unprotectedAttrs__item__attrValues__item__tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _____EnvelopedData_unprotectedAttrs__item__attrValues__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____EnvelopedData_unprotectedAttrs__item__attrValues__item_._const_tab = _____EnvelopedData_unprotectedAttrs__item__attrValues__item__tab
    ____EnvelopedData_unprotectedAttrs__item__attrValues__item_._const_tab_at = ('..', '..', 'attrType')
    ____EnvelopedData_unprotectedAttrs__item__attrValues__item_._const_tab_id = 'Type'
    ___EnvelopedData_unprotectedAttrs__item__attrValues._cont = ____EnvelopedData_unprotectedAttrs__item__attrValues__item_
    __EnvelopedData_unprotectedAttrs__item_._cont = ASN1Dict([
        ('attrType', ___EnvelopedData_unprotectedAttrs__item__attrType),
        ('attrValues', ___EnvelopedData_unprotectedAttrs__item__attrValues),
        ])
    __EnvelopedData_unprotectedAttrs__item_._ext = None
    _EnvelopedData_unprotectedAttrs._cont = __EnvelopedData_unprotectedAttrs__item_
    _EnvelopedData_unprotectedAttrs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    EnvelopedData._cont = ASN1Dict([
        ('version', _EnvelopedData_version),
        ('originatorInfo', _EnvelopedData_originatorInfo),
        ('recipientInfos', _EnvelopedData_recipientInfos),
        ('encryptedContentInfo', _EnvelopedData_encryptedContentInfo),
        ('unprotectedAttrs', _EnvelopedData_unprotectedAttrs),
        ])
    EnvelopedData._ext = ['unprotectedAttrs']
    
    #-----< OriginatorInfo >-----#
    OriginatorInfo = SEQ(name='OriginatorInfo', mode=MODE_TYPE)
    _OriginatorInfo_certs = SET_OF(name='certs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CertificateSet')), opt=True)
    _OriginatorInfo_crls = SET_OF(name='crls', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RevocationInfoChoices')), opt=True)
    OriginatorInfo._cont = ASN1Dict([
        ('certs', _OriginatorInfo_certs),
        ('crls', _OriginatorInfo_crls),
        ])
    OriginatorInfo._ext = None
    
    #-----< RecipientInfos >-----#
    RecipientInfos = SET_OF(name='RecipientInfos', mode=MODE_TYPE)
    _RecipientInfos__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RecipientInfo')))
    RecipientInfos._cont = _RecipientInfos__item_
    RecipientInfos._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< EncryptedContentInfo >-----#
    EncryptedContentInfo = SEQ(name='EncryptedContentInfo', mode=MODE_TYPE)
    _EncryptedContentInfo_contentType = OID(name='contentType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE'), ['id']))
    __EncryptedContentInfo_contentType_tab = CLASS(name='_tab_CONTENT-TYPE', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    ___EncryptedContentInfo_contentType_tab_val_Type_0 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___EncryptedContentInfo_contentType_tab_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignedData')))
    ___EncryptedContentInfo_contentType_tab_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedData')))
    ___EncryptedContentInfo_contentType_tab_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EnvelopedData')))
    ___EncryptedContentInfo_contentType_tab_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'AuthenticatedData')))
    ___EncryptedContentInfo_contentType_tab_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'DigestedData')))
    __EncryptedContentInfo_contentType_tab._val = ASN1Set(rv=[dict([('Type', ___EncryptedContentInfo_contentType_tab_val_Type_0), ('id', (1, 2, 840, 113549, 1, 7, 1))]), dict([('Type', ___EncryptedContentInfo_contentType_tab_val_Type_1), ('id', (1, 2, 840, 113549, 1, 7, 2))]), dict([('Type', ___EncryptedContentInfo_contentType_tab_val_Type_2), ('id', (1, 2, 840, 113549, 1, 7, 6))]), dict([('Type', ___EncryptedContentInfo_contentType_tab_val_Type_3), ('id', (1, 2, 840, 113549, 1, 7, 3))]), dict([('Type', ___EncryptedContentInfo_contentType_tab_val_Type_4), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 2))]), dict([('Type', ___EncryptedContentInfo_contentType_tab_val_Type_5), ('id', (1, 2, 840, 113549, 1, 7, 5))])], rr=[], ev=None, er=[])
    _EncryptedContentInfo_contentType._const_tab = __EncryptedContentInfo_contentType_tab
    _EncryptedContentInfo_contentType._const_tab_at = None
    _EncryptedContentInfo_contentType._const_tab_id = 'id'
    _EncryptedContentInfo_contentEncryptionAlgorithm = SEQ(name='contentEncryptionAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentEncryptionAlgorithmIdentifier')))
    _EncryptedContentInfo_encryptedContent = OCT_STR(name='encryptedContent', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    EncryptedContentInfo._cont = ASN1Dict([
        ('contentType', _EncryptedContentInfo_contentType),
        ('contentEncryptionAlgorithm', _EncryptedContentInfo_contentEncryptionAlgorithm),
        ('encryptedContent', _EncryptedContentInfo_encryptedContent),
        ])
    EncryptedContentInfo._ext = None
    
    #-----< UnprotectedAttributes >-----#
    UnprotectedAttributes = CLASS(name='UnprotectedAttributes', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    UnprotectedAttributes._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< RecipientInfo >-----#
    RecipientInfo = CHOICE(name='RecipientInfo', mode=MODE_TYPE)
    _RecipientInfo_ktri = SEQ(name='ktri', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KeyTransRecipientInfo')))
    _RecipientInfo_kari = SEQ(name='kari', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KeyAgreeRecipientInfo')), group=0)
    _RecipientInfo_kekri = SEQ(name='kekri', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KEKRecipientInfo')), group=1)
    _RecipientInfo_pwri = SEQ(name='pwri', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'PasswordRecipientInfo')), group=2)
    _RecipientInfo_ori = SEQ(name='ori', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OtherRecipientInfo')), group=2)
    RecipientInfo._cont = ASN1Dict([
        ('ktri', _RecipientInfo_ktri),
        ('kari', _RecipientInfo_kari),
        ('kekri', _RecipientInfo_kekri),
        ('pwri', _RecipientInfo_pwri),
        ('ori', _RecipientInfo_ori),
        ])
    RecipientInfo._ext = ['kari', 'kekri', 'pwri', 'ori']
    
    #-----< EncryptedKey >-----#
    EncryptedKey = OCT_STR(name='EncryptedKey', mode=MODE_TYPE)
    
    #-----< KeyTransRecipientInfo >-----#
    KeyTransRecipientInfo = SEQ(name='KeyTransRecipientInfo', mode=MODE_TYPE)
    _KeyTransRecipientInfo_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _KeyTransRecipientInfo_rid = CHOICE(name='rid', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RecipientIdentifier')))
    _KeyTransRecipientInfo_keyEncryptionAlgorithm = SEQ(name='keyEncryptionAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-TRANSPORT'), ['id']))
    ___KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab = CLASS(name='_tab_KEY-TRANSPORT', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-TRANSPORT')))
    ____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('Params', ____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 1))]))])], rr=[], ev=None, er=[])
    __KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm._const_tab = ___KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab
    __KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm._const_tab_at = None
    __KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm._const_tab_id = 'id'
    __KeyTransRecipientInfo_keyEncryptionAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-TRANSPORT'), ['Params']), opt=True)
    __KeyTransRecipientInfo_keyEncryptionAlgorithm_parameters._const_tab = ___KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab
    __KeyTransRecipientInfo_keyEncryptionAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __KeyTransRecipientInfo_keyEncryptionAlgorithm_parameters._const_tab_id = 'Params'
    _KeyTransRecipientInfo_keyEncryptionAlgorithm._cont = ASN1Dict([
        ('algorithm', __KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm),
        ('parameters', __KeyTransRecipientInfo_keyEncryptionAlgorithm_parameters),
        ])
    _KeyTransRecipientInfo_keyEncryptionAlgorithm._ext = None
    _KeyTransRecipientInfo_encryptedKey = OCT_STR(name='encryptedKey', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedKey')))
    KeyTransRecipientInfo._cont = ASN1Dict([
        ('version', _KeyTransRecipientInfo_version),
        ('rid', _KeyTransRecipientInfo_rid),
        ('keyEncryptionAlgorithm', _KeyTransRecipientInfo_keyEncryptionAlgorithm),
        ('encryptedKey', _KeyTransRecipientInfo_encryptedKey),
        ])
    KeyTransRecipientInfo._ext = None
    
    #-----< KeyTransportAlgorithmSet >-----#
    KeyTransportAlgorithmSet = CLASS(name='KeyTransportAlgorithmSet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-TRANSPORT')))
    _KeyTransportAlgorithmSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    KeyTransportAlgorithmSet._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('Params', _KeyTransportAlgorithmSet_val_Params_0), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 1))]))])], rr=[], ev=[], er=[])
    
    #-----< RecipientIdentifier >-----#
    RecipientIdentifier = CHOICE(name='RecipientIdentifier', mode=MODE_TYPE)
    _RecipientIdentifier_issuerAndSerialNumber = SEQ(name='issuerAndSerialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'IssuerAndSerialNumber')))
    _RecipientIdentifier_subjectKeyIdentifier = OCT_STR(name='subjectKeyIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SubjectKeyIdentifier')), group=0)
    RecipientIdentifier._cont = ASN1Dict([
        ('issuerAndSerialNumber', _RecipientIdentifier_issuerAndSerialNumber),
        ('subjectKeyIdentifier', _RecipientIdentifier_subjectKeyIdentifier),
        ])
    RecipientIdentifier._ext = ['subjectKeyIdentifier']
    
    #-----< KeyAgreeRecipientInfo >-----#
    KeyAgreeRecipientInfo = SEQ(name='KeyAgreeRecipientInfo', mode=MODE_TYPE)
    _KeyAgreeRecipientInfo_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _KeyAgreeRecipientInfo_originator = CHOICE(name='originator', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OriginatorIdentifierOrKey')))
    _KeyAgreeRecipientInfo_ukm = OCT_STR(name='ukm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'UserKeyingMaterial')), opt=True)
    _KeyAgreeRecipientInfo_keyEncryptionAlgorithm = SEQ(name='keyEncryptionAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-AGREE'), ['id']))
    ___KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab = CLASS(name='_tab_KEY-AGREE', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-AGREE')))
    ____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DomainParameters')))
    _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    ____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    ___KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5)), ('Params', ____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=None, er=[])), ('ukmPresence', 'optional'), ('smimeCaps', dict([('Type', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5))]))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10)), ('Params', ____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=None, er=[])), ('ukmPresence', 'optional'), ('smimeCaps', dict([('Type', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10))]))])], rr=[], ev=None, er=[])
    __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm._const_tab = ___KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab
    __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm._const_tab_at = None
    __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm._const_tab_id = 'id'
    __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-AGREE'), ['Params']), opt=True)
    __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_parameters._const_tab = ___KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab
    __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_parameters._const_tab_id = 'Params'
    _KeyAgreeRecipientInfo_keyEncryptionAlgorithm._cont = ASN1Dict([
        ('algorithm', __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm),
        ('parameters', __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_parameters),
        ])
    _KeyAgreeRecipientInfo_keyEncryptionAlgorithm._ext = None
    _KeyAgreeRecipientInfo_recipientEncryptedKeys = SEQ_OF(name='recipientEncryptedKeys', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RecipientEncryptedKeys')))
    KeyAgreeRecipientInfo._cont = ASN1Dict([
        ('version', _KeyAgreeRecipientInfo_version),
        ('originator', _KeyAgreeRecipientInfo_originator),
        ('ukm', _KeyAgreeRecipientInfo_ukm),
        ('keyEncryptionAlgorithm', _KeyAgreeRecipientInfo_keyEncryptionAlgorithm),
        ('recipientEncryptedKeys', _KeyAgreeRecipientInfo_recipientEncryptedKeys),
        ])
    KeyAgreeRecipientInfo._ext = None
    
    #-----< KeyAgreementAlgorithmSet >-----#
    KeyAgreementAlgorithmSet = CLASS(name='KeyAgreementAlgorithmSet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-AGREE')))
    _KeyAgreementAlgorithmSet_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _KeyAgreementAlgorithmSet_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    KeyAgreementAlgorithmSet._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5)), ('Params', _KeyAgreementAlgorithmSet_val_Params_0), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=None, er=[])), ('ukmPresence', 'optional'), ('smimeCaps', dict([('Type', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5))]))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10)), ('Params', _KeyAgreementAlgorithmSet_val_Params_1), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=None, er=[])), ('ukmPresence', 'optional'), ('smimeCaps', dict([('Type', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10))]))])], rr=[], ev=[], er=[])
    
    #-----< OriginatorIdentifierOrKey >-----#
    OriginatorIdentifierOrKey = CHOICE(name='OriginatorIdentifierOrKey', mode=MODE_TYPE)
    _OriginatorIdentifierOrKey_issuerAndSerialNumber = SEQ(name='issuerAndSerialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'IssuerAndSerialNumber')))
    _OriginatorIdentifierOrKey_subjectKeyIdentifier = OCT_STR(name='subjectKeyIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SubjectKeyIdentifier')))
    _OriginatorIdentifierOrKey_originatorKey = SEQ(name='originatorKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OriginatorPublicKey')))
    OriginatorIdentifierOrKey._cont = ASN1Dict([
        ('issuerAndSerialNumber', _OriginatorIdentifierOrKey_issuerAndSerialNumber),
        ('subjectKeyIdentifier', _OriginatorIdentifierOrKey_subjectKeyIdentifier),
        ('originatorKey', _OriginatorIdentifierOrKey_originatorKey),
        ])
    OriginatorIdentifierOrKey._ext = None
    
    #-----< OriginatorPublicKey >-----#
    OriginatorPublicKey = SEQ(name='OriginatorPublicKey', mode=MODE_TYPE)
    _OriginatorPublicKey_algorithm = SEQ(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __OriginatorPublicKey_algorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'PUBLIC-KEY'), ['id']))
    ___OriginatorPublicKey_algorithm_algorithm_tab = CLASS(name='_tab_PUBLIC-KEY', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    ____OriginatorPublicKey_algorithm_algorithm_tab_val_KeyValue_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    ____OriginatorPublicKey_algorithm_algorithm_tab_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DomainParameters')))
    ___OriginatorPublicKey_algorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', ____OriginatorPublicKey_algorithm_algorithm_tab_val_KeyValue_0), ('Params', ____OriginatorPublicKey_algorithm_algorithm_tab_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=None, er=[])
    __OriginatorPublicKey_algorithm_algorithm._const_tab = ___OriginatorPublicKey_algorithm_algorithm_tab
    __OriginatorPublicKey_algorithm_algorithm._const_tab_at = None
    __OriginatorPublicKey_algorithm_algorithm._const_tab_id = 'id'
    __OriginatorPublicKey_algorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'PUBLIC-KEY'), ['Params']), opt=True)
    __OriginatorPublicKey_algorithm_parameters._const_tab = ___OriginatorPublicKey_algorithm_algorithm_tab
    __OriginatorPublicKey_algorithm_parameters._const_tab_at = ('..', 'algorithm')
    __OriginatorPublicKey_algorithm_parameters._const_tab_id = 'Params'
    _OriginatorPublicKey_algorithm._cont = ASN1Dict([
        ('algorithm', __OriginatorPublicKey_algorithm_algorithm),
        ('parameters', __OriginatorPublicKey_algorithm_parameters),
        ])
    _OriginatorPublicKey_algorithm._ext = None
    _OriginatorPublicKey_publicKey = BIT_STR(name='publicKey', mode=MODE_TYPE)
    OriginatorPublicKey._cont = ASN1Dict([
        ('algorithm', _OriginatorPublicKey_algorithm),
        ('publicKey', _OriginatorPublicKey_publicKey),
        ])
    OriginatorPublicKey._ext = None
    
    #-----< OriginatorKeySet >-----#
    OriginatorKeySet = CLASS(name='OriginatorKeySet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _OriginatorKeySet_val_KeyValue_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    _OriginatorKeySet_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DomainParameters')))
    OriginatorKeySet._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _OriginatorKeySet_val_KeyValue_0), ('Params', _OriginatorKeySet_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=[], er=[])
    
    #-----< RecipientEncryptedKeys >-----#
    RecipientEncryptedKeys = SEQ_OF(name='RecipientEncryptedKeys', mode=MODE_TYPE)
    _RecipientEncryptedKeys__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RecipientEncryptedKey')))
    RecipientEncryptedKeys._cont = _RecipientEncryptedKeys__item_
    
    #-----< RecipientEncryptedKey >-----#
    RecipientEncryptedKey = SEQ(name='RecipientEncryptedKey', mode=MODE_TYPE)
    _RecipientEncryptedKey_rid = CHOICE(name='rid', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KeyAgreeRecipientIdentifier')))
    _RecipientEncryptedKey_encryptedKey = OCT_STR(name='encryptedKey', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedKey')))
    RecipientEncryptedKey._cont = ASN1Dict([
        ('rid', _RecipientEncryptedKey_rid),
        ('encryptedKey', _RecipientEncryptedKey_encryptedKey),
        ])
    RecipientEncryptedKey._ext = None
    
    #-----< KeyAgreeRecipientIdentifier >-----#
    KeyAgreeRecipientIdentifier = CHOICE(name='KeyAgreeRecipientIdentifier', mode=MODE_TYPE)
    _KeyAgreeRecipientIdentifier_issuerAndSerialNumber = SEQ(name='issuerAndSerialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'IssuerAndSerialNumber')))
    _KeyAgreeRecipientIdentifier_rKeyId = SEQ(name='rKeyId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RecipientKeyIdentifier')))
    KeyAgreeRecipientIdentifier._cont = ASN1Dict([
        ('issuerAndSerialNumber', _KeyAgreeRecipientIdentifier_issuerAndSerialNumber),
        ('rKeyId', _KeyAgreeRecipientIdentifier_rKeyId),
        ])
    KeyAgreeRecipientIdentifier._ext = None
    
    #-----< RecipientKeyIdentifier >-----#
    RecipientKeyIdentifier = SEQ(name='RecipientKeyIdentifier', mode=MODE_TYPE)
    _RecipientKeyIdentifier_subjectKeyIdentifier = OCT_STR(name='subjectKeyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SubjectKeyIdentifier')))
    _RecipientKeyIdentifier_date = TIME_GEN(name='date', mode=MODE_TYPE, opt=True)
    _RecipientKeyIdentifier_other = SEQ(name='other', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OtherKeyAttribute')), opt=True)
    RecipientKeyIdentifier._cont = ASN1Dict([
        ('subjectKeyIdentifier', _RecipientKeyIdentifier_subjectKeyIdentifier),
        ('date', _RecipientKeyIdentifier_date),
        ('other', _RecipientKeyIdentifier_other),
        ])
    RecipientKeyIdentifier._ext = None
    
    #-----< SubjectKeyIdentifier >-----#
    SubjectKeyIdentifier = OCT_STR(name='SubjectKeyIdentifier', mode=MODE_TYPE)
    
    #-----< KEKRecipientInfo >-----#
    KEKRecipientInfo = SEQ(name='KEKRecipientInfo', mode=MODE_TYPE)
    _KEKRecipientInfo_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _KEKRecipientInfo_kekid = SEQ(name='kekid', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KEKIdentifier')))
    _KEKRecipientInfo_keyEncryptionAlgorithm = SEQ(name='keyEncryptionAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KeyEncryptionAlgorithmIdentifier')))
    _KEKRecipientInfo_encryptedKey = OCT_STR(name='encryptedKey', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedKey')))
    KEKRecipientInfo._cont = ASN1Dict([
        ('version', _KEKRecipientInfo_version),
        ('kekid', _KEKRecipientInfo_kekid),
        ('keyEncryptionAlgorithm', _KEKRecipientInfo_keyEncryptionAlgorithm),
        ('encryptedKey', _KEKRecipientInfo_encryptedKey),
        ])
    KEKRecipientInfo._ext = None
    
    #-----< KEKIdentifier >-----#
    KEKIdentifier = SEQ(name='KEKIdentifier', mode=MODE_TYPE)
    _KEKIdentifier_keyIdentifier = OCT_STR(name='keyIdentifier', mode=MODE_TYPE)
    _KEKIdentifier_date = TIME_GEN(name='date', mode=MODE_TYPE, opt=True)
    _KEKIdentifier_other = SEQ(name='other', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OtherKeyAttribute')), opt=True)
    KEKIdentifier._cont = ASN1Dict([
        ('keyIdentifier', _KEKIdentifier_keyIdentifier),
        ('date', _KEKIdentifier_date),
        ('other', _KEKIdentifier_other),
        ])
    KEKIdentifier._ext = None
    
    #-----< PasswordRecipientInfo >-----#
    PasswordRecipientInfo = SEQ(name='PasswordRecipientInfo', mode=MODE_TYPE)
    _PasswordRecipientInfo_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _PasswordRecipientInfo_keyDerivationAlgorithm = SEQ(name='keyDerivationAlgorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KeyDerivationAlgorithmIdentifier')), opt=True)
    _PasswordRecipientInfo_keyEncryptionAlgorithm = SEQ(name='keyEncryptionAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KeyEncryptionAlgorithmIdentifier')))
    _PasswordRecipientInfo_encryptedKey = OCT_STR(name='encryptedKey', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedKey')))
    PasswordRecipientInfo._cont = ASN1Dict([
        ('version', _PasswordRecipientInfo_version),
        ('keyDerivationAlgorithm', _PasswordRecipientInfo_keyDerivationAlgorithm),
        ('keyEncryptionAlgorithm', _PasswordRecipientInfo_keyEncryptionAlgorithm),
        ('encryptedKey', _PasswordRecipientInfo_encryptedKey),
        ])
    PasswordRecipientInfo._ext = None
    
    #-----< OTHER-RECIPIENT >-----#
    OTHER_RECIPIENT = CLASS(name='OTHER-RECIPIENT', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< OtherRecipientInfo >-----#
    OtherRecipientInfo = SEQ(name='OtherRecipientInfo', mode=MODE_TYPE)
    _OtherRecipientInfo_oriType = OID(name='oriType', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'OTHER-RECIPIENT'), ['id']))
    __OtherRecipientInfo_oriType_tab = CLASS(name='_tab_OTHER-RECIPIENT', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OTHER-RECIPIENT')))
    __OtherRecipientInfo_oriType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _OtherRecipientInfo_oriType._const_tab = __OtherRecipientInfo_oriType_tab
    _OtherRecipientInfo_oriType._const_tab_at = None
    _OtherRecipientInfo_oriType._const_tab_id = 'id'
    _OtherRecipientInfo_oriValue = OPEN(name='oriValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'OTHER-RECIPIENT'), ['Type']))
    __OtherRecipientInfo_oriValue_tab = CLASS(name='_tab_OTHER-RECIPIENT', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OTHER-RECIPIENT')))
    __OtherRecipientInfo_oriValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _OtherRecipientInfo_oriValue._const_tab = __OtherRecipientInfo_oriValue_tab
    _OtherRecipientInfo_oriValue._const_tab_at = ('..', 'oriType')
    _OtherRecipientInfo_oriValue._const_tab_id = 'Type'
    OtherRecipientInfo._cont = ASN1Dict([
        ('oriType', _OtherRecipientInfo_oriType),
        ('oriValue', _OtherRecipientInfo_oriValue),
        ])
    OtherRecipientInfo._ext = None
    
    #-----< SupportedOtherRecipInfo >-----#
    SupportedOtherRecipInfo = CLASS(name='SupportedOtherRecipInfo', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OTHER-RECIPIENT')))
    SupportedOtherRecipInfo._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DigestedData >-----#
    DigestedData = SEQ(name='DigestedData', mode=MODE_TYPE)
    _DigestedData_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _DigestedData_digestAlgorithm = SEQ(name='digestAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'DigestAlgorithmIdentifier')))
    _DigestedData_encapContentInfo = SEQ(name='encapContentInfo', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncapsulatedContentInfo')))
    _DigestedData_digest = OCT_STR(name='digest', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Digest')))
    DigestedData._cont = ASN1Dict([
        ('version', _DigestedData_version),
        ('digestAlgorithm', _DigestedData_digestAlgorithm),
        ('encapContentInfo', _DigestedData_encapContentInfo),
        ('digest', _DigestedData_digest),
        ])
    DigestedData._ext = []
    
    #-----< Digest >-----#
    Digest = OCT_STR(name='Digest', mode=MODE_TYPE)
    
    #-----< EncryptedData >-----#
    EncryptedData = SEQ(name='EncryptedData', mode=MODE_TYPE)
    _EncryptedData_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _EncryptedData_encryptedContentInfo = SEQ(name='encryptedContentInfo', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedContentInfo')))
    _EncryptedData_unprotectedAttrs = SET_OF(name='unprotectedAttrs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Attributes')), opt=True, group=0)
    __EncryptedData_unprotectedAttrs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Attribute')))
    ___EncryptedData_unprotectedAttrs__item__attrType = OID(name='attrType', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ____EncryptedData_unprotectedAttrs__item__attrType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____EncryptedData_unprotectedAttrs__item__attrType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___EncryptedData_unprotectedAttrs__item__attrType._const_tab = ____EncryptedData_unprotectedAttrs__item__attrType_tab
    ___EncryptedData_unprotectedAttrs__item__attrType._const_tab_at = None
    ___EncryptedData_unprotectedAttrs__item__attrType._const_tab_id = 'id'
    ___EncryptedData_unprotectedAttrs__item__attrValues = SET_OF(name='attrValues', mode=MODE_TYPE)
    ____EncryptedData_unprotectedAttrs__item__attrValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    _____EncryptedData_unprotectedAttrs__item__attrValues__item__tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _____EncryptedData_unprotectedAttrs__item__attrValues__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____EncryptedData_unprotectedAttrs__item__attrValues__item_._const_tab = _____EncryptedData_unprotectedAttrs__item__attrValues__item__tab
    ____EncryptedData_unprotectedAttrs__item__attrValues__item_._const_tab_at = ('..', '..', 'attrType')
    ____EncryptedData_unprotectedAttrs__item__attrValues__item_._const_tab_id = 'Type'
    ___EncryptedData_unprotectedAttrs__item__attrValues._cont = ____EncryptedData_unprotectedAttrs__item__attrValues__item_
    __EncryptedData_unprotectedAttrs__item_._cont = ASN1Dict([
        ('attrType', ___EncryptedData_unprotectedAttrs__item__attrType),
        ('attrValues', ___EncryptedData_unprotectedAttrs__item__attrValues),
        ])
    __EncryptedData_unprotectedAttrs__item_._ext = None
    _EncryptedData_unprotectedAttrs._cont = __EncryptedData_unprotectedAttrs__item_
    _EncryptedData_unprotectedAttrs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    EncryptedData._cont = ASN1Dict([
        ('version', _EncryptedData_version),
        ('encryptedContentInfo', _EncryptedData_encryptedContentInfo),
        ('unprotectedAttrs', _EncryptedData_unprotectedAttrs),
        ])
    EncryptedData._ext = ['unprotectedAttrs']
    
    #-----< AuthenticatedData >-----#
    AuthenticatedData = SEQ(name='AuthenticatedData', mode=MODE_TYPE)
    _AuthenticatedData_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _AuthenticatedData_originatorInfo = SEQ(name='originatorInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OriginatorInfo')), opt=True)
    _AuthenticatedData_recipientInfos = SET_OF(name='recipientInfos', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RecipientInfos')))
    _AuthenticatedData_macAlgorithm = SEQ(name='macAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'MessageAuthenticationCodeAlgorithm')))
    _AuthenticatedData_digestAlgorithm = SEQ(name='digestAlgorithm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'DigestAlgorithmIdentifier')), opt=True)
    _AuthenticatedData_encapContentInfo = SEQ(name='encapContentInfo', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncapsulatedContentInfo')))
    _AuthenticatedData_authAttrs = SET_OF(name='authAttrs', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'AuthAttributes')), opt=True)
    _AuthenticatedData_mac = OCT_STR(name='mac', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'MessageAuthenticationCode')))
    _AuthenticatedData_unauthAttrs = SET_OF(name='unauthAttrs', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'UnauthAttributes')), opt=True)
    AuthenticatedData._cont = ASN1Dict([
        ('version', _AuthenticatedData_version),
        ('originatorInfo', _AuthenticatedData_originatorInfo),
        ('recipientInfos', _AuthenticatedData_recipientInfos),
        ('macAlgorithm', _AuthenticatedData_macAlgorithm),
        ('digestAlgorithm', _AuthenticatedData_digestAlgorithm),
        ('encapContentInfo', _AuthenticatedData_encapContentInfo),
        ('authAttrs', _AuthenticatedData_authAttrs),
        ('mac', _AuthenticatedData_mac),
        ('unauthAttrs', _AuthenticatedData_unauthAttrs),
        ])
    AuthenticatedData._ext = None
    
    #-----< AuthAttributes >-----#
    AuthAttributes = SET_OF(name='AuthAttributes', mode=MODE_TYPE)
    _AuthAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Attribute')))
    __AuthAttributes__item__attrType = OID(name='attrType', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ___AuthAttributes__item__attrType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____AuthAttributes__item__attrType_tab_val_Type_0 = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentType')))
    ____AuthAttributes__item__attrType_tab_val_Type_1 = OCT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'MessageDigest')))
    ____AuthAttributes__item__attrType_tab_val_Type_2 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SigningTime')))
    ___AuthAttributes__item__attrType_tab._val = ASN1Set(rv=[dict([('Type', ____AuthAttributes__item__attrType_tab_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 3))]), dict([('Type', ____AuthAttributes__item__attrType_tab_val_Type_1), ('id', (1, 2, 840, 113549, 1, 9, 4))]), dict([('Type', ____AuthAttributes__item__attrType_tab_val_Type_2), ('id', (1, 2, 840, 113549, 1, 9, 5))])], rr=[], ev=None, er=[])
    __AuthAttributes__item__attrType._const_tab = ___AuthAttributes__item__attrType_tab
    __AuthAttributes__item__attrType._const_tab_at = None
    __AuthAttributes__item__attrType._const_tab_id = 'id'
    __AuthAttributes__item__attrValues = SET_OF(name='attrValues', mode=MODE_TYPE)
    ___AuthAttributes__item__attrValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    ___AuthAttributes__item__attrValues__item_._const_tab = ___AuthAttributes__item__attrType_tab
    ___AuthAttributes__item__attrValues__item_._const_tab_at = ('..', '..', 'attrType')
    ___AuthAttributes__item__attrValues__item_._const_tab_id = 'Type'
    __AuthAttributes__item__attrValues._cont = ___AuthAttributes__item__attrValues__item_
    _AuthAttributes__item_._cont = ASN1Dict([
        ('attrType', __AuthAttributes__item__attrType),
        ('attrValues', __AuthAttributes__item__attrValues),
        ])
    _AuthAttributes__item_._ext = None
    AuthAttributes._cont = _AuthAttributes__item_
    AuthAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AuthAttributeSet >-----#
    AuthAttributeSet = CLASS(name='AuthAttributeSet', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _AuthAttributeSet_val_Type_0 = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentType')))
    _AuthAttributeSet_val_Type_1 = OCT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'MessageDigest')))
    _AuthAttributeSet_val_Type_2 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SigningTime')))
    AuthAttributeSet._val = ASN1Set(rv=[dict([('Type', _AuthAttributeSet_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 3))]), dict([('Type', _AuthAttributeSet_val_Type_1), ('id', (1, 2, 840, 113549, 1, 9, 4))]), dict([('Type', _AuthAttributeSet_val_Type_2), ('id', (1, 2, 840, 113549, 1, 9, 5))])], rr=[], ev=[], er=[])
    
    #-----< MessageAuthenticationCode >-----#
    MessageAuthenticationCode = OCT_STR(name='MessageAuthenticationCode', mode=MODE_TYPE)
    
    #-----< UnauthAttributes >-----#
    UnauthAttributes = SET_OF(name='UnauthAttributes', mode=MODE_TYPE)
    _UnauthAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Attribute')))
    __UnauthAttributes__item__attrType = OID(name='attrType', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ___UnauthAttributes__item__attrType_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ___UnauthAttributes__item__attrType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __UnauthAttributes__item__attrType._const_tab = ___UnauthAttributes__item__attrType_tab
    __UnauthAttributes__item__attrType._const_tab_at = None
    __UnauthAttributes__item__attrType._const_tab_id = 'id'
    __UnauthAttributes__item__attrValues = SET_OF(name='attrValues', mode=MODE_TYPE)
    ___UnauthAttributes__item__attrValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    ____UnauthAttributes__item__attrValues__item__tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____UnauthAttributes__item__attrValues__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___UnauthAttributes__item__attrValues__item_._const_tab = ____UnauthAttributes__item__attrValues__item__tab
    ___UnauthAttributes__item__attrValues__item_._const_tab_at = ('..', '..', 'attrType')
    ___UnauthAttributes__item__attrValues__item_._const_tab_id = 'Type'
    __UnauthAttributes__item__attrValues._cont = ___UnauthAttributes__item__attrValues__item_
    _UnauthAttributes__item_._cont = ASN1Dict([
        ('attrType', __UnauthAttributes__item__attrType),
        ('attrValues', __UnauthAttributes__item__attrValues),
        ])
    _UnauthAttributes__item_._ext = None
    UnauthAttributes._cont = _UnauthAttributes__item_
    UnauthAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< UnauthAttributeSet >-----#
    UnauthAttributeSet = CLASS(name='UnauthAttributeSet', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    UnauthAttributeSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< DigestAlgorithmIdentifier >-----#
    DigestAlgorithmIdentifier = SEQ(name='DigestAlgorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _DigestAlgorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    __DigestAlgorithmIdentifier_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    __DigestAlgorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _DigestAlgorithmIdentifier_algorithm._const_tab = __DigestAlgorithmIdentifier_algorithm_tab
    _DigestAlgorithmIdentifier_algorithm._const_tab_at = None
    _DigestAlgorithmIdentifier_algorithm._const_tab_id = 'id'
    _DigestAlgorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    __DigestAlgorithmIdentifier_parameters_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    __DigestAlgorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _DigestAlgorithmIdentifier_parameters._const_tab = __DigestAlgorithmIdentifier_parameters_tab
    _DigestAlgorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _DigestAlgorithmIdentifier_parameters._const_tab_id = 'Params'
    DigestAlgorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _DigestAlgorithmIdentifier_algorithm),
        ('parameters', _DigestAlgorithmIdentifier_parameters),
        ])
    DigestAlgorithmIdentifier._ext = None
    
    #-----< DigestAlgorithmSet >-----#
    DigestAlgorithmSet = CLASS(name='DigestAlgorithmSet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    DigestAlgorithmSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SignatureAlgorithmIdentifier >-----#
    SignatureAlgorithmIdentifier = SEQ(name='SignatureAlgorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _SignatureAlgorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    __SignatureAlgorithmIdentifier_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    __SignatureAlgorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SignatureAlgorithmIdentifier_algorithm._const_tab = __SignatureAlgorithmIdentifier_algorithm_tab
    _SignatureAlgorithmIdentifier_algorithm._const_tab_at = None
    _SignatureAlgorithmIdentifier_algorithm._const_tab_id = 'id'
    _SignatureAlgorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __SignatureAlgorithmIdentifier_parameters_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    __SignatureAlgorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _SignatureAlgorithmIdentifier_parameters._const_tab = __SignatureAlgorithmIdentifier_parameters_tab
    _SignatureAlgorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _SignatureAlgorithmIdentifier_parameters._const_tab_id = 'Params'
    SignatureAlgorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _SignatureAlgorithmIdentifier_algorithm),
        ('parameters', _SignatureAlgorithmIdentifier_parameters),
        ])
    SignatureAlgorithmIdentifier._ext = None
    
    #-----< SignatureAlgorithmSet >-----#
    SignatureAlgorithmSet = CLASS(name='SignatureAlgorithmSet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    SignatureAlgorithmSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< KeyEncryptionAlgorithmIdentifier >-----#
    KeyEncryptionAlgorithmIdentifier = SEQ(name='KeyEncryptionAlgorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _KeyEncryptionAlgorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-WRAP'), ['id']))
    __KeyEncryptionAlgorithmIdentifier_algorithm_tab = CLASS(name='_tab_KEY-WRAP', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-WRAP')))
    ___KeyEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___KeyEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_1 = INT(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'RC2wrapParameter')))
    __KeyEncryptionAlgorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6)), ('Params', ___KeyEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6))]))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7)), ('Params', ___KeyEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7))]))])], rr=[], ev=None, er=[])
    _KeyEncryptionAlgorithmIdentifier_algorithm._const_tab = __KeyEncryptionAlgorithmIdentifier_algorithm_tab
    _KeyEncryptionAlgorithmIdentifier_algorithm._const_tab_at = None
    _KeyEncryptionAlgorithmIdentifier_algorithm._const_tab_id = 'id'
    _KeyEncryptionAlgorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-WRAP'), ['Params']), opt=True)
    _KeyEncryptionAlgorithmIdentifier_parameters._const_tab = __KeyEncryptionAlgorithmIdentifier_algorithm_tab
    _KeyEncryptionAlgorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _KeyEncryptionAlgorithmIdentifier_parameters._const_tab_id = 'Params'
    KeyEncryptionAlgorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _KeyEncryptionAlgorithmIdentifier_algorithm),
        ('parameters', _KeyEncryptionAlgorithmIdentifier_parameters),
        ])
    KeyEncryptionAlgorithmIdentifier._ext = None
    
    #-----< KeyEncryptionAlgorithmSet >-----#
    KeyEncryptionAlgorithmSet = CLASS(name='KeyEncryptionAlgorithmSet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-WRAP')))
    _KeyEncryptionAlgorithmSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _KeyEncryptionAlgorithmSet_val_Params_1 = INT(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'RC2wrapParameter')))
    KeyEncryptionAlgorithmSet._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6)), ('Params', _KeyEncryptionAlgorithmSet_val_Params_0), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6))]))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7)), ('Params', _KeyEncryptionAlgorithmSet_val_Params_1), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7))]))])], rr=[], ev=[], er=[])
    
    #-----< ContentEncryptionAlgorithmIdentifier >-----#
    ContentEncryptionAlgorithmIdentifier = SEQ(name='ContentEncryptionAlgorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _ContentEncryptionAlgorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'CONTENT-ENCRYPTION'), ['id']))
    __ContentEncryptionAlgorithmIdentifier_algorithm_tab = CLASS(name='_tab_CONTENT-ENCRYPTION', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'CONTENT-ENCRYPTION')))
    ___ContentEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_0 = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'IV')))
    ___ContentEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'RC2CBCParameter')))
    ____ContentEncryptionAlgorithmIdentifier_algorithm_tab_smimeCaps_val_Type = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SecureMimeMessageV3dot1-2009', 'SMIMECapabilitiesParametersForRC2CBC')))
    __ContentEncryptionAlgorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 3, 7)), ('Params', ___ContentEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 3, 7))]))]), dict([('id', (1, 2, 840, 113549, 3, 2)), ('Params', ___ContentEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('smimeCaps', dict([('Type', ____ContentEncryptionAlgorithmIdentifier_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 3, 2))]))])], rr=[], ev=None, er=[])
    _ContentEncryptionAlgorithmIdentifier_algorithm._const_tab = __ContentEncryptionAlgorithmIdentifier_algorithm_tab
    _ContentEncryptionAlgorithmIdentifier_algorithm._const_tab_at = None
    _ContentEncryptionAlgorithmIdentifier_algorithm._const_tab_id = 'id'
    _ContentEncryptionAlgorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'CONTENT-ENCRYPTION'), ['Params']), opt=True)
    _ContentEncryptionAlgorithmIdentifier_parameters._const_tab = __ContentEncryptionAlgorithmIdentifier_algorithm_tab
    _ContentEncryptionAlgorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _ContentEncryptionAlgorithmIdentifier_parameters._const_tab_id = 'Params'
    ContentEncryptionAlgorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _ContentEncryptionAlgorithmIdentifier_algorithm),
        ('parameters', _ContentEncryptionAlgorithmIdentifier_parameters),
        ])
    ContentEncryptionAlgorithmIdentifier._ext = None
    
    #-----< ContentEncryptionAlgorithmSet >-----#
    ContentEncryptionAlgorithmSet = CLASS(name='ContentEncryptionAlgorithmSet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'CONTENT-ENCRYPTION')))
    _ContentEncryptionAlgorithmSet_val_Params_0 = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'IV')))
    _ContentEncryptionAlgorithmSet_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'RC2CBCParameter')))
    ContentEncryptionAlgorithmSet._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 3, 7)), ('Params', _ContentEncryptionAlgorithmSet_val_Params_0), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 3, 7))]))]), dict([('id', (1, 2, 840, 113549, 3, 2)), ('Params', _ContentEncryptionAlgorithmSet_val_Params_1), ('paramPresence', 'required'), ('smimeCaps', dict([('Type', ____ContentEncryptionAlgorithmIdentifier_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 3, 2))]))])], rr=[], ev=[], er=[])
    
    #-----< MessageAuthenticationCodeAlgorithm >-----#
    MessageAuthenticationCodeAlgorithm = SEQ(name='MessageAuthenticationCodeAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _MessageAuthenticationCodeAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['id']))
    __MessageAuthenticationCodeAlgorithm_algorithm_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ___MessageAuthenticationCodeAlgorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __MessageAuthenticationCodeAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', ___MessageAuthenticationCodeAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])], rr=[], ev=None, er=[])
    _MessageAuthenticationCodeAlgorithm_algorithm._const_tab = __MessageAuthenticationCodeAlgorithm_algorithm_tab
    _MessageAuthenticationCodeAlgorithm_algorithm._const_tab_at = None
    _MessageAuthenticationCodeAlgorithm_algorithm._const_tab_id = 'id'
    _MessageAuthenticationCodeAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['Params']), opt=True)
    _MessageAuthenticationCodeAlgorithm_parameters._const_tab = __MessageAuthenticationCodeAlgorithm_algorithm_tab
    _MessageAuthenticationCodeAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    _MessageAuthenticationCodeAlgorithm_parameters._const_tab_id = 'Params'
    MessageAuthenticationCodeAlgorithm._cont = ASN1Dict([
        ('algorithm', _MessageAuthenticationCodeAlgorithm_algorithm),
        ('parameters', _MessageAuthenticationCodeAlgorithm_parameters),
        ])
    MessageAuthenticationCodeAlgorithm._ext = None
    
    #-----< MessageAuthenticationCodeAlgorithmSet >-----#
    MessageAuthenticationCodeAlgorithmSet = CLASS(name='MessageAuthenticationCodeAlgorithmSet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    _MessageAuthenticationCodeAlgorithmSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    MessageAuthenticationCodeAlgorithmSet._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', _MessageAuthenticationCodeAlgorithmSet_val_Params_0), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])], rr=[], ev=[], er=[])
    
    #-----< KeyDerivationAlgorithmIdentifier >-----#
    KeyDerivationAlgorithmIdentifier = SEQ(name='KeyDerivationAlgorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _KeyDerivationAlgorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-DERIVATION'), ['id']))
    __KeyDerivationAlgorithmIdentifier_algorithm_tab = CLASS(name='_tab_KEY-DERIVATION', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-DERIVATION')))
    ___KeyDerivationAlgorithmIdentifier_algorithm_tab_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'PBKDF2-params')))
    __KeyDerivationAlgorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 5, 12)), ('Params', ___KeyDerivationAlgorithmIdentifier_algorithm_tab_val_Params_0), ('paramPresence', 'required')])], rr=[], ev=None, er=[])
    _KeyDerivationAlgorithmIdentifier_algorithm._const_tab = __KeyDerivationAlgorithmIdentifier_algorithm_tab
    _KeyDerivationAlgorithmIdentifier_algorithm._const_tab_at = None
    _KeyDerivationAlgorithmIdentifier_algorithm._const_tab_id = 'id'
    _KeyDerivationAlgorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-DERIVATION'), ['Params']), opt=True)
    _KeyDerivationAlgorithmIdentifier_parameters._const_tab = __KeyDerivationAlgorithmIdentifier_algorithm_tab
    _KeyDerivationAlgorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _KeyDerivationAlgorithmIdentifier_parameters._const_tab_id = 'Params'
    KeyDerivationAlgorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _KeyDerivationAlgorithmIdentifier_algorithm),
        ('parameters', _KeyDerivationAlgorithmIdentifier_parameters),
        ])
    KeyDerivationAlgorithmIdentifier._ext = None
    
    #-----< RevocationInfoChoices >-----#
    RevocationInfoChoices = SET_OF(name='RevocationInfoChoices', mode=MODE_TYPE)
    _RevocationInfoChoices__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RevocationInfoChoice')))
    RevocationInfoChoices._cont = _RevocationInfoChoices__item_
    
    #-----< RevocationInfoChoice >-----#
    RevocationInfoChoice = CHOICE(name='RevocationInfoChoice', mode=MODE_TYPE)
    _RevocationInfoChoice_crl = SEQ(name='crl', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateList')))
    _RevocationInfoChoice_other = SEQ(name='other', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OtherRevocationInfoFormat')), group=0)
    RevocationInfoChoice._cont = ASN1Dict([
        ('crl', _RevocationInfoChoice_crl),
        ('other', _RevocationInfoChoice_other),
        ])
    RevocationInfoChoice._ext = ['other']
    
    #-----< OTHER-REVOK-INFO >-----#
    OTHER_REVOK_INFO = CLASS(name='OTHER-REVOK-INFO', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< OtherRevocationInfoFormat >-----#
    OtherRevocationInfoFormat = SEQ(name='OtherRevocationInfoFormat', mode=MODE_TYPE)
    _OtherRevocationInfoFormat_otherRevInfoFormat = OID(name='otherRevInfoFormat', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'OTHER-REVOK-INFO'), ['id']))
    __OtherRevocationInfoFormat_otherRevInfoFormat_tab = CLASS(name='_tab_OTHER-REVOK-INFO', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OTHER-REVOK-INFO')))
    __OtherRevocationInfoFormat_otherRevInfoFormat_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _OtherRevocationInfoFormat_otherRevInfoFormat._const_tab = __OtherRevocationInfoFormat_otherRevInfoFormat_tab
    _OtherRevocationInfoFormat_otherRevInfoFormat._const_tab_at = None
    _OtherRevocationInfoFormat_otherRevInfoFormat._const_tab_id = 'id'
    _OtherRevocationInfoFormat_otherRevInfo = OPEN(name='otherRevInfo', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'OTHER-REVOK-INFO'), ['Type']))
    __OtherRevocationInfoFormat_otherRevInfo_tab = CLASS(name='_tab_OTHER-REVOK-INFO', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OTHER-REVOK-INFO')))
    __OtherRevocationInfoFormat_otherRevInfo_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _OtherRevocationInfoFormat_otherRevInfo._const_tab = __OtherRevocationInfoFormat_otherRevInfo_tab
    _OtherRevocationInfoFormat_otherRevInfo._const_tab_at = ('..', 'otherRevInfoFormat')
    _OtherRevocationInfoFormat_otherRevInfo._const_tab_id = 'Type'
    OtherRevocationInfoFormat._cont = ASN1Dict([
        ('otherRevInfoFormat', _OtherRevocationInfoFormat_otherRevInfoFormat),
        ('otherRevInfo', _OtherRevocationInfoFormat_otherRevInfo),
        ])
    OtherRevocationInfoFormat._ext = None
    
    #-----< SupportedOtherRevokInfo >-----#
    SupportedOtherRevokInfo = CLASS(name='SupportedOtherRevokInfo', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OTHER-REVOK-INFO')))
    SupportedOtherRevokInfo._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CertificateChoices >-----#
    CertificateChoices = CHOICE(name='CertificateChoices', mode=MODE_TYPE)
    _CertificateChoices_certificate = SEQ(name='certificate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    _CertificateChoices_extendedCertificate = SEQ(name='extendedCertificate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ExtendedCertificate')))
    _CertificateChoices_v1AttrCert = SEQ(name='v1AttrCert', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AttributeCertificateVersion1-2009', 'AttributeCertificateV1')), group=0)
    _CertificateChoices_v2AttrCert = SEQ(name='v2AttrCert', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'AttributeCertificateV2')), group=1)
    _CertificateChoices_other = SEQ(name='other', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OtherCertificateFormat')), group=2)
    CertificateChoices._cont = ASN1Dict([
        ('certificate', _CertificateChoices_certificate),
        ('extendedCertificate', _CertificateChoices_extendedCertificate),
        ('v1AttrCert', _CertificateChoices_v1AttrCert),
        ('v2AttrCert', _CertificateChoices_v2AttrCert),
        ('other', _CertificateChoices_other),
        ])
    CertificateChoices._ext = ['v1AttrCert', 'v2AttrCert', 'other']
    
    #-----< AttributeCertificateV2 >-----#
    AttributeCertificateV2 = SEQ(name='AttributeCertificateV2', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttributeCertificate')))
    
    #-----< OTHER-CERT-FMT >-----#
    OTHER_CERT_FMT = CLASS(name='OTHER-CERT-FMT', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< OtherCertificateFormat >-----#
    OtherCertificateFormat = SEQ(name='OtherCertificateFormat', mode=MODE_TYPE)
    _OtherCertificateFormat_otherCertFormat = OID(name='otherCertFormat', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'OTHER-CERT-FMT'), ['id']))
    __OtherCertificateFormat_otherCertFormat_tab = CLASS(name='_tab_OTHER-CERT-FMT', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OTHER-CERT-FMT')))
    __OtherCertificateFormat_otherCertFormat_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _OtherCertificateFormat_otherCertFormat._const_tab = __OtherCertificateFormat_otherCertFormat_tab
    _OtherCertificateFormat_otherCertFormat._const_tab_at = None
    _OtherCertificateFormat_otherCertFormat._const_tab_id = 'id'
    _OtherCertificateFormat_otherCert = OPEN(name='otherCert', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'OTHER-CERT-FMT'), ['Type']))
    __OtherCertificateFormat_otherCert_tab = CLASS(name='_tab_OTHER-CERT-FMT', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OTHER-CERT-FMT')))
    __OtherCertificateFormat_otherCert_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _OtherCertificateFormat_otherCert._const_tab = __OtherCertificateFormat_otherCert_tab
    _OtherCertificateFormat_otherCert._const_tab_at = ('..', 'otherCertFormat')
    _OtherCertificateFormat_otherCert._const_tab_id = 'Type'
    OtherCertificateFormat._cont = ASN1Dict([
        ('otherCertFormat', _OtherCertificateFormat_otherCertFormat),
        ('otherCert', _OtherCertificateFormat_otherCert),
        ])
    OtherCertificateFormat._ext = None
    
    #-----< SupportedCertFormats >-----#
    SupportedCertFormats = CLASS(name='SupportedCertFormats', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'OTHER-CERT-FMT')))
    SupportedCertFormats._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CertificateSet >-----#
    CertificateSet = SET_OF(name='CertificateSet', mode=MODE_TYPE)
    _CertificateSet__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CertificateChoices')))
    CertificateSet._cont = _CertificateSet__item_
    
    #-----< IssuerAndSerialNumber >-----#
    IssuerAndSerialNumber = SEQ(name='IssuerAndSerialNumber', mode=MODE_TYPE)
    _IssuerAndSerialNumber_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    _IssuerAndSerialNumber_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateSerialNumber')))
    IssuerAndSerialNumber._cont = ASN1Dict([
        ('issuer', _IssuerAndSerialNumber_issuer),
        ('serialNumber', _IssuerAndSerialNumber_serialNumber),
        ])
    IssuerAndSerialNumber._ext = None
    
    #-----< CMSVersion >-----#
    CMSVersion = INT(name='CMSVersion', mode=MODE_TYPE)
    CMSVersion._cont = ASN1Dict([('v0', 0), ('v1', 1), ('v2', 2), ('v3', 3), ('v4', 4), ('v5', 5)])
    
    #-----< UserKeyingMaterial >-----#
    UserKeyingMaterial = OCT_STR(name='UserKeyingMaterial', mode=MODE_TYPE)
    
    #-----< KEY-ATTRIBUTE >-----#
    KEY_ATTRIBUTE = CLASS(name='KEY-ATTRIBUTE', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< OtherKeyAttribute >-----#
    OtherKeyAttribute = SEQ(name='OtherKeyAttribute', mode=MODE_TYPE)
    _OtherKeyAttribute_keyAttrId = OID(name='keyAttrId', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'KEY-ATTRIBUTE'), ['id']))
    __OtherKeyAttribute_keyAttrId_tab = CLASS(name='_tab_KEY-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KEY-ATTRIBUTE')))
    __OtherKeyAttribute_keyAttrId_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _OtherKeyAttribute_keyAttrId._const_tab = __OtherKeyAttribute_keyAttrId_tab
    _OtherKeyAttribute_keyAttrId._const_tab_at = None
    _OtherKeyAttribute_keyAttrId._const_tab_id = 'id'
    _OtherKeyAttribute_keyAttr = OPEN(name='keyAttr', mode=MODE_TYPE, typeref=ASN1RefClassField(('CryptographicMessageSyntax-2009', 'KEY-ATTRIBUTE'), ['Type']))
    __OtherKeyAttribute_keyAttr_tab = CLASS(name='_tab_KEY-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KEY-ATTRIBUTE')))
    __OtherKeyAttribute_keyAttr_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _OtherKeyAttribute_keyAttr._const_tab = __OtherKeyAttribute_keyAttr_tab
    _OtherKeyAttribute_keyAttr._const_tab_at = ('..', 'keyAttrId')
    _OtherKeyAttribute_keyAttr._const_tab_id = 'Type'
    OtherKeyAttribute._cont = ASN1Dict([
        ('keyAttrId', _OtherKeyAttribute_keyAttrId),
        ('keyAttr', _OtherKeyAttribute_keyAttr),
        ])
    OtherKeyAttribute._ext = None
    
    #-----< SupportedKeyAttributes >-----#
    SupportedKeyAttributes = CLASS(name='SupportedKeyAttributes', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'KEY-ATTRIBUTE')))
    SupportedKeyAttributes._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< id-ct-contentInfo >-----#
    id_ct_contentInfo = OID(name='id-ct-contentInfo', mode=MODE_VALUE)
    id_ct_contentInfo._val = (1, 2, 840, 113549, 1, 9, 16, 1, 6)
    
    #-----< ct-Data >-----#
    ct_Data = CLASS(name='ct-Data', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_Data_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    ct_Data._val = dict([('Type', _ct_Data_val_Type), ('id', (1, 2, 840, 113549, 1, 7, 1))])
    
    #-----< id-data >-----#
    id_data = OID(name='id-data', mode=MODE_VALUE)
    id_data._val = (1, 2, 840, 113549, 1, 7, 1)
    
    #-----< ct-SignedData >-----#
    ct_SignedData = CLASS(name='ct-SignedData', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_SignedData_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignedData')))
    ct_SignedData._val = dict([('Type', _ct_SignedData_val_Type), ('id', (1, 2, 840, 113549, 1, 7, 2))])
    
    #-----< id-signedData >-----#
    id_signedData = OID(name='id-signedData', mode=MODE_VALUE)
    id_signedData._val = (1, 2, 840, 113549, 1, 7, 2)
    
    #-----< ct-EnvelopedData >-----#
    ct_EnvelopedData = CLASS(name='ct-EnvelopedData', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_EnvelopedData_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EnvelopedData')))
    ct_EnvelopedData._val = dict([('Type', _ct_EnvelopedData_val_Type), ('id', (1, 2, 840, 113549, 1, 7, 3))])
    
    #-----< id-envelopedData >-----#
    id_envelopedData = OID(name='id-envelopedData', mode=MODE_VALUE)
    id_envelopedData._val = (1, 2, 840, 113549, 1, 7, 3)
    
    #-----< ct-DigestedData >-----#
    ct_DigestedData = CLASS(name='ct-DigestedData', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_DigestedData_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'DigestedData')))
    ct_DigestedData._val = dict([('Type', _ct_DigestedData_val_Type), ('id', (1, 2, 840, 113549, 1, 7, 5))])
    
    #-----< id-digestedData >-----#
    id_digestedData = OID(name='id-digestedData', mode=MODE_VALUE)
    id_digestedData._val = (1, 2, 840, 113549, 1, 7, 5)
    
    #-----< ct-EncryptedData >-----#
    ct_EncryptedData = CLASS(name='ct-EncryptedData', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_EncryptedData_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EncryptedData')))
    ct_EncryptedData._val = dict([('Type', _ct_EncryptedData_val_Type), ('id', (1, 2, 840, 113549, 1, 7, 6))])
    
    #-----< id-encryptedData >-----#
    id_encryptedData = OID(name='id-encryptedData', mode=MODE_VALUE)
    id_encryptedData._val = (1, 2, 840, 113549, 1, 7, 6)
    
    #-----< ct-AuthenticatedData >-----#
    ct_AuthenticatedData = CLASS(name='ct-AuthenticatedData', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_AuthenticatedData_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'AuthenticatedData')))
    ct_AuthenticatedData._val = dict([('Type', _ct_AuthenticatedData_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 2))])
    
    #-----< id-ct-authData >-----#
    id_ct_authData = OID(name='id-ct-authData', mode=MODE_VALUE)
    id_ct_authData._val = (1, 2, 840, 113549, 1, 9, 16, 1, 2)
    
    #-----< MessageDigest >-----#
    MessageDigest = OCT_STR(name='MessageDigest', mode=MODE_TYPE)
    
    #-----< SigningTime >-----#
    SigningTime = CHOICE(name='SigningTime', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Time')))
    
    #-----< Time >-----#
    Time = CHOICE(name='Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name='utcTime', mode=MODE_TYPE)
    _Time_generalTime = TIME_GEN(name='generalTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        ('utcTime', _Time_utcTime),
        ('generalTime', _Time_generalTime),
        ])
    Time._ext = None
    
    #-----< Countersignature >-----#
    Countersignature = SEQ(name='Countersignature', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignerInfo')))
    
    #-----< aa-contentType >-----#
    aa_contentType = CLASS(name='aa-contentType', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _aa_contentType_val_Type = OID(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentType')))
    aa_contentType._val = dict([('Type', _aa_contentType_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 3))])
    
    #-----< id-contentType >-----#
    id_contentType = OID(name='id-contentType', mode=MODE_VALUE)
    id_contentType._val = (1, 2, 840, 113549, 1, 9, 3)
    
    #-----< aa-messageDigest >-----#
    aa_messageDigest = CLASS(name='aa-messageDigest', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _aa_messageDigest_val_Type = OCT_STR(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'MessageDigest')))
    aa_messageDigest._val = dict([('Type', _aa_messageDigest_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 4))])
    
    #-----< id-messageDigest >-----#
    id_messageDigest = OID(name='id-messageDigest', mode=MODE_VALUE)
    id_messageDigest._val = (1, 2, 840, 113549, 1, 9, 4)
    
    #-----< aa-signingTime >-----#
    aa_signingTime = CLASS(name='aa-signingTime', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _aa_signingTime_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SigningTime')))
    aa_signingTime._val = dict([('Type', _aa_signingTime_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 5))])
    
    #-----< id-signingTime >-----#
    id_signingTime = OID(name='id-signingTime', mode=MODE_VALUE)
    id_signingTime._val = (1, 2, 840, 113549, 1, 9, 5)
    
    #-----< aa-countersignature >-----#
    aa_countersignature = CLASS(name='aa-countersignature', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _aa_countersignature_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Countersignature')))
    aa_countersignature._val = dict([('Type', _aa_countersignature_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 6))])
    
    #-----< id-countersignature >-----#
    id_countersignature = OID(name='id-countersignature', mode=MODE_VALUE)
    id_countersignature._val = (1, 2, 840, 113549, 1, 9, 6)
    
    #-----< ExtendedCertificateOrCertificate >-----#
    ExtendedCertificateOrCertificate = CHOICE(name='ExtendedCertificateOrCertificate', mode=MODE_TYPE)
    _ExtendedCertificateOrCertificate_certificate = SEQ(name='certificate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    _ExtendedCertificateOrCertificate_extendedCertificate = SEQ(name='extendedCertificate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ExtendedCertificate')))
    ExtendedCertificateOrCertificate._cont = ASN1Dict([
        ('certificate', _ExtendedCertificateOrCertificate_certificate),
        ('extendedCertificate', _ExtendedCertificateOrCertificate_extendedCertificate),
        ])
    ExtendedCertificateOrCertificate._ext = None
    
    #-----< ExtendedCertificate >-----#
    ExtendedCertificate = SEQ(name='ExtendedCertificate', mode=MODE_TYPE)
    _ExtendedCertificate_extendedCertificateInfo = SEQ(name='extendedCertificateInfo', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ExtendedCertificateInfo')))
    _ExtendedCertificate_signatureAlgorithm = SEQ(name='signatureAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SignatureAlgorithmIdentifier')))
    _ExtendedCertificate_signature = BIT_STR(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'Signature')))
    ExtendedCertificate._cont = ASN1Dict([
        ('extendedCertificateInfo', _ExtendedCertificate_extendedCertificateInfo),
        ('signatureAlgorithm', _ExtendedCertificate_signatureAlgorithm),
        ('signature', _ExtendedCertificate_signature),
        ])
    ExtendedCertificate._ext = None
    
    #-----< ExtendedCertificateInfo >-----#
    ExtendedCertificateInfo = SEQ(name='ExtendedCertificateInfo', mode=MODE_TYPE)
    _ExtendedCertificateInfo_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CMSVersion')))
    _ExtendedCertificateInfo_certificate = SEQ(name='certificate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    _ExtendedCertificateInfo_attributes = SET_OF(name='attributes', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'UnauthAttributes')))
    ExtendedCertificateInfo._cont = ASN1Dict([
        ('version', _ExtendedCertificateInfo_version),
        ('certificate', _ExtendedCertificateInfo_certificate),
        ('attributes', _ExtendedCertificateInfo_attributes),
        ])
    ExtendedCertificateInfo._ext = None
    
    #-----< Signature >-----#
    Signature = BIT_STR(name='Signature', mode=MODE_TYPE)
    
    #-----< Attribute >-----#
    Attribute = SEQ(name='Attribute', mode=MODE_TYPE, param=True)
    
    #-----< Attributes >-----#
    Attributes = SET_OF(name='Attributes', mode=MODE_TYPE, param=True)
    
    _all_ = [
        CONTENT_TYPE,
        ContentType,
        __ContentInfo_contentType_tab,
        ___ContentInfo_contentType_tab_val_Type_0,
        ___ContentInfo_contentType_tab_val_Type_1,
        ___ContentInfo_contentType_tab_val_Type_2,
        ___ContentInfo_contentType_tab_val_Type_3,
        ___ContentInfo_contentType_tab_val_Type_4,
        ___ContentInfo_contentType_tab_val_Type_5,
        _ContentInfo_contentType,
        _ContentInfo_content,
        ContentInfo,
        ContentSet,
        _ContentSet_val_Type_0,
        _ContentSet_val_Type_1,
        _ContentSet_val_Type_2,
        _ContentSet_val_Type_3,
        _ContentSet_val_Type_4,
        _ContentSet_val_Type_5,
        _SignedData_version,
        __SignedData_digestAlgorithms__item_,
        _SignedData_digestAlgorithms,
        _SignedData_encapContentInfo,
        _SignedData_certificates,
        _SignedData_crls,
        _SignedData_signerInfos,
        SignedData,
        _SignerInfos__item_,
        SignerInfos,
        __EncapsulatedContentInfo_eContentType_tab,
        ___EncapsulatedContentInfo_eContentType_tab_val_Type_0,
        ___EncapsulatedContentInfo_eContentType_tab_val_Type_1,
        ___EncapsulatedContentInfo_eContentType_tab_val_Type_2,
        ___EncapsulatedContentInfo_eContentType_tab_val_Type_3,
        ___EncapsulatedContentInfo_eContentType_tab_val_Type_4,
        ___EncapsulatedContentInfo_eContentType_tab_val_Type_5,
        _EncapsulatedContentInfo_eContentType,
        __EncapsulatedContentInfo_eContent_contain,
        _EncapsulatedContentInfo_eContent,
        EncapsulatedContentInfo,
        _SignerInfo_version,
        _SignerInfo_sid,
        _SignerInfo_digestAlgorithm,
        _SignerInfo_signedAttrs,
        _SignerInfo_signatureAlgorithm,
        _SignerInfo_signature,
        ____SignerInfo_unsignedAttrs__item__attrType_tab,
        _____SignerInfo_unsignedAttrs__item__attrType_tab_val_Type_0,
        ___SignerInfo_unsignedAttrs__item__attrType,
        ____SignerInfo_unsignedAttrs__item__attrValues__item_,
        ___SignerInfo_unsignedAttrs__item__attrValues,
        __SignerInfo_unsignedAttrs__item_,
        _SignerInfo_unsignedAttrs,
        SignerInfo,
        ___SignedAttributes__item__attrType_tab,
        ____SignedAttributes__item__attrType_tab_val_Type_0,
        ____SignedAttributes__item__attrType_tab_val_Type_1,
        ____SignedAttributes__item__attrType_tab_val_Type_2,
        __SignedAttributes__item__attrType,
        ___SignedAttributes__item__attrValues__item_,
        __SignedAttributes__item__attrValues,
        _SignedAttributes__item_,
        SignedAttributes,
        _SignerIdentifier_issuerAndSerialNumber,
        _SignerIdentifier_subjectKeyIdentifier,
        SignerIdentifier,
        SignedAttributesSet,
        _SignedAttributesSet_val_Type_0,
        _SignedAttributesSet_val_Type_1,
        _SignedAttributesSet_val_Type_2,
        UnsignedAttributes,
        _UnsignedAttributes_val_Type_0,
        SignatureValue,
        _EnvelopedData_version,
        _EnvelopedData_originatorInfo,
        _EnvelopedData_recipientInfos,
        _EnvelopedData_encryptedContentInfo,
        ____EnvelopedData_unprotectedAttrs__item__attrType_tab,
        ___EnvelopedData_unprotectedAttrs__item__attrType,
        _____EnvelopedData_unprotectedAttrs__item__attrValues__item__tab,
        ____EnvelopedData_unprotectedAttrs__item__attrValues__item_,
        ___EnvelopedData_unprotectedAttrs__item__attrValues,
        __EnvelopedData_unprotectedAttrs__item_,
        _EnvelopedData_unprotectedAttrs,
        EnvelopedData,
        _OriginatorInfo_certs,
        _OriginatorInfo_crls,
        OriginatorInfo,
        _RecipientInfos__item_,
        RecipientInfos,
        __EncryptedContentInfo_contentType_tab,
        ___EncryptedContentInfo_contentType_tab_val_Type_0,
        ___EncryptedContentInfo_contentType_tab_val_Type_1,
        ___EncryptedContentInfo_contentType_tab_val_Type_2,
        ___EncryptedContentInfo_contentType_tab_val_Type_3,
        ___EncryptedContentInfo_contentType_tab_val_Type_4,
        ___EncryptedContentInfo_contentType_tab_val_Type_5,
        _EncryptedContentInfo_contentType,
        _EncryptedContentInfo_contentEncryptionAlgorithm,
        _EncryptedContentInfo_encryptedContent,
        EncryptedContentInfo,
        UnprotectedAttributes,
        _RecipientInfo_ktri,
        _RecipientInfo_kari,
        _RecipientInfo_kekri,
        _RecipientInfo_pwri,
        _RecipientInfo_ori,
        RecipientInfo,
        EncryptedKey,
        _KeyTransRecipientInfo_version,
        _KeyTransRecipientInfo_rid,
        ___KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab,
        ____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_val_Params_0,
        _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0,
        _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0,
        __KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm,
        __KeyTransRecipientInfo_keyEncryptionAlgorithm_parameters,
        _KeyTransRecipientInfo_keyEncryptionAlgorithm,
        _KeyTransRecipientInfo_encryptedKey,
        KeyTransRecipientInfo,
        KeyTransportAlgorithmSet,
        _KeyTransportAlgorithmSet_val_Params_0,
        _RecipientIdentifier_issuerAndSerialNumber,
        _RecipientIdentifier_subjectKeyIdentifier,
        RecipientIdentifier,
        _KeyAgreeRecipientInfo_version,
        _KeyAgreeRecipientInfo_originator,
        _KeyAgreeRecipientInfo_ukm,
        ___KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab,
        ____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_val_Params_0,
        _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0,
        _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0,
        _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type,
        ____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_val_Params_1,
        __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm,
        __KeyAgreeRecipientInfo_keyEncryptionAlgorithm_parameters,
        _KeyAgreeRecipientInfo_keyEncryptionAlgorithm,
        _KeyAgreeRecipientInfo_recipientEncryptedKeys,
        KeyAgreeRecipientInfo,
        KeyAgreementAlgorithmSet,
        _KeyAgreementAlgorithmSet_val_Params_0,
        _KeyAgreementAlgorithmSet_val_Params_1,
        _OriginatorIdentifierOrKey_issuerAndSerialNumber,
        _OriginatorIdentifierOrKey_subjectKeyIdentifier,
        _OriginatorIdentifierOrKey_originatorKey,
        OriginatorIdentifierOrKey,
        ___OriginatorPublicKey_algorithm_algorithm_tab,
        ____OriginatorPublicKey_algorithm_algorithm_tab_val_KeyValue_0,
        ____OriginatorPublicKey_algorithm_algorithm_tab_val_Params_0,
        __OriginatorPublicKey_algorithm_algorithm,
        __OriginatorPublicKey_algorithm_parameters,
        _OriginatorPublicKey_algorithm,
        _OriginatorPublicKey_publicKey,
        OriginatorPublicKey,
        OriginatorKeySet,
        _OriginatorKeySet_val_KeyValue_0,
        _OriginatorKeySet_val_Params_0,
        _RecipientEncryptedKeys__item_,
        RecipientEncryptedKeys,
        _RecipientEncryptedKey_rid,
        _RecipientEncryptedKey_encryptedKey,
        RecipientEncryptedKey,
        _KeyAgreeRecipientIdentifier_issuerAndSerialNumber,
        _KeyAgreeRecipientIdentifier_rKeyId,
        KeyAgreeRecipientIdentifier,
        _RecipientKeyIdentifier_subjectKeyIdentifier,
        _RecipientKeyIdentifier_date,
        _RecipientKeyIdentifier_other,
        RecipientKeyIdentifier,
        SubjectKeyIdentifier,
        _KEKRecipientInfo_version,
        _KEKRecipientInfo_kekid,
        _KEKRecipientInfo_keyEncryptionAlgorithm,
        _KEKRecipientInfo_encryptedKey,
        KEKRecipientInfo,
        _KEKIdentifier_keyIdentifier,
        _KEKIdentifier_date,
        _KEKIdentifier_other,
        KEKIdentifier,
        _PasswordRecipientInfo_version,
        _PasswordRecipientInfo_keyDerivationAlgorithm,
        _PasswordRecipientInfo_keyEncryptionAlgorithm,
        _PasswordRecipientInfo_encryptedKey,
        PasswordRecipientInfo,
        OTHER_RECIPIENT,
        __OtherRecipientInfo_oriType_tab,
        _OtherRecipientInfo_oriType,
        __OtherRecipientInfo_oriValue_tab,
        _OtherRecipientInfo_oriValue,
        OtherRecipientInfo,
        SupportedOtherRecipInfo,
        _DigestedData_version,
        _DigestedData_digestAlgorithm,
        _DigestedData_encapContentInfo,
        _DigestedData_digest,
        DigestedData,
        Digest,
        _EncryptedData_version,
        _EncryptedData_encryptedContentInfo,
        ____EncryptedData_unprotectedAttrs__item__attrType_tab,
        ___EncryptedData_unprotectedAttrs__item__attrType,
        _____EncryptedData_unprotectedAttrs__item__attrValues__item__tab,
        ____EncryptedData_unprotectedAttrs__item__attrValues__item_,
        ___EncryptedData_unprotectedAttrs__item__attrValues,
        __EncryptedData_unprotectedAttrs__item_,
        _EncryptedData_unprotectedAttrs,
        EncryptedData,
        _AuthenticatedData_version,
        _AuthenticatedData_originatorInfo,
        _AuthenticatedData_recipientInfos,
        _AuthenticatedData_macAlgorithm,
        _AuthenticatedData_digestAlgorithm,
        _AuthenticatedData_encapContentInfo,
        _AuthenticatedData_authAttrs,
        _AuthenticatedData_mac,
        _AuthenticatedData_unauthAttrs,
        AuthenticatedData,
        ___AuthAttributes__item__attrType_tab,
        ____AuthAttributes__item__attrType_tab_val_Type_0,
        ____AuthAttributes__item__attrType_tab_val_Type_1,
        ____AuthAttributes__item__attrType_tab_val_Type_2,
        __AuthAttributes__item__attrType,
        ___AuthAttributes__item__attrValues__item_,
        __AuthAttributes__item__attrValues,
        _AuthAttributes__item_,
        AuthAttributes,
        AuthAttributeSet,
        _AuthAttributeSet_val_Type_0,
        _AuthAttributeSet_val_Type_1,
        _AuthAttributeSet_val_Type_2,
        MessageAuthenticationCode,
        ___UnauthAttributes__item__attrType_tab,
        __UnauthAttributes__item__attrType,
        ____UnauthAttributes__item__attrValues__item__tab,
        ___UnauthAttributes__item__attrValues__item_,
        __UnauthAttributes__item__attrValues,
        _UnauthAttributes__item_,
        UnauthAttributes,
        UnauthAttributeSet,
        __DigestAlgorithmIdentifier_algorithm_tab,
        _DigestAlgorithmIdentifier_algorithm,
        __DigestAlgorithmIdentifier_parameters_tab,
        _DigestAlgorithmIdentifier_parameters,
        DigestAlgorithmIdentifier,
        DigestAlgorithmSet,
        __SignatureAlgorithmIdentifier_algorithm_tab,
        _SignatureAlgorithmIdentifier_algorithm,
        __SignatureAlgorithmIdentifier_parameters_tab,
        _SignatureAlgorithmIdentifier_parameters,
        SignatureAlgorithmIdentifier,
        SignatureAlgorithmSet,
        __KeyEncryptionAlgorithmIdentifier_algorithm_tab,
        ___KeyEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_0,
        ___KeyEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_1,
        _KeyEncryptionAlgorithmIdentifier_algorithm,
        _KeyEncryptionAlgorithmIdentifier_parameters,
        KeyEncryptionAlgorithmIdentifier,
        KeyEncryptionAlgorithmSet,
        _KeyEncryptionAlgorithmSet_val_Params_0,
        _KeyEncryptionAlgorithmSet_val_Params_1,
        __ContentEncryptionAlgorithmIdentifier_algorithm_tab,
        ___ContentEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_0,
        ___ContentEncryptionAlgorithmIdentifier_algorithm_tab_val_Params_1,
        ____ContentEncryptionAlgorithmIdentifier_algorithm_tab_smimeCaps_val_Type,
        _ContentEncryptionAlgorithmIdentifier_algorithm,
        _ContentEncryptionAlgorithmIdentifier_parameters,
        ContentEncryptionAlgorithmIdentifier,
        ContentEncryptionAlgorithmSet,
        _ContentEncryptionAlgorithmSet_val_Params_0,
        _ContentEncryptionAlgorithmSet_val_Params_1,
        __MessageAuthenticationCodeAlgorithm_algorithm_tab,
        ___MessageAuthenticationCodeAlgorithm_algorithm_tab_val_Params_0,
        _MessageAuthenticationCodeAlgorithm_algorithm,
        _MessageAuthenticationCodeAlgorithm_parameters,
        MessageAuthenticationCodeAlgorithm,
        MessageAuthenticationCodeAlgorithmSet,
        _MessageAuthenticationCodeAlgorithmSet_val_Params_0,
        __KeyDerivationAlgorithmIdentifier_algorithm_tab,
        ___KeyDerivationAlgorithmIdentifier_algorithm_tab_val_Params_0,
        _KeyDerivationAlgorithmIdentifier_algorithm,
        _KeyDerivationAlgorithmIdentifier_parameters,
        KeyDerivationAlgorithmIdentifier,
        _RevocationInfoChoices__item_,
        RevocationInfoChoices,
        _RevocationInfoChoice_crl,
        _RevocationInfoChoice_other,
        RevocationInfoChoice,
        OTHER_REVOK_INFO,
        __OtherRevocationInfoFormat_otherRevInfoFormat_tab,
        _OtherRevocationInfoFormat_otherRevInfoFormat,
        __OtherRevocationInfoFormat_otherRevInfo_tab,
        _OtherRevocationInfoFormat_otherRevInfo,
        OtherRevocationInfoFormat,
        SupportedOtherRevokInfo,
        _CertificateChoices_certificate,
        _CertificateChoices_extendedCertificate,
        _CertificateChoices_v1AttrCert,
        _CertificateChoices_v2AttrCert,
        _CertificateChoices_other,
        CertificateChoices,
        AttributeCertificateV2,
        OTHER_CERT_FMT,
        __OtherCertificateFormat_otherCertFormat_tab,
        _OtherCertificateFormat_otherCertFormat,
        __OtherCertificateFormat_otherCert_tab,
        _OtherCertificateFormat_otherCert,
        OtherCertificateFormat,
        SupportedCertFormats,
        _CertificateSet__item_,
        CertificateSet,
        _IssuerAndSerialNumber_issuer,
        _IssuerAndSerialNumber_serialNumber,
        IssuerAndSerialNumber,
        CMSVersion,
        UserKeyingMaterial,
        KEY_ATTRIBUTE,
        __OtherKeyAttribute_keyAttrId_tab,
        _OtherKeyAttribute_keyAttrId,
        __OtherKeyAttribute_keyAttr_tab,
        _OtherKeyAttribute_keyAttr,
        OtherKeyAttribute,
        SupportedKeyAttributes,
        id_ct_contentInfo,
        ct_Data,
        _ct_Data_val_Type,
        id_data,
        ct_SignedData,
        _ct_SignedData_val_Type,
        id_signedData,
        ct_EnvelopedData,
        _ct_EnvelopedData_val_Type,
        id_envelopedData,
        ct_DigestedData,
        _ct_DigestedData_val_Type,
        id_digestedData,
        ct_EncryptedData,
        _ct_EncryptedData_val_Type,
        id_encryptedData,
        ct_AuthenticatedData,
        _ct_AuthenticatedData_val_Type,
        id_ct_authData,
        MessageDigest,
        SigningTime,
        _Time_utcTime,
        _Time_generalTime,
        Time,
        Countersignature,
        aa_contentType,
        _aa_contentType_val_Type,
        id_contentType,
        aa_messageDigest,
        _aa_messageDigest_val_Type,
        id_messageDigest,
        aa_signingTime,
        _aa_signingTime_val_Type,
        id_signingTime,
        aa_countersignature,
        _aa_countersignature_val_Type,
        id_countersignature,
        _ExtendedCertificateOrCertificate_certificate,
        _ExtendedCertificateOrCertificate_extendedCertificate,
        ExtendedCertificateOrCertificate,
        _ExtendedCertificate_extendedCertificateInfo,
        _ExtendedCertificate_signatureAlgorithm,
        _ExtendedCertificate_signature,
        ExtendedCertificate,
        _ExtendedCertificateInfo_version,
        _ExtendedCertificateInfo_certificate,
        _ExtendedCertificateInfo_attributes,
        ExtendedCertificateInfo,
        Signature,
    ]

class CryptographicMessageSyntaxAlgorithms_2009:

    _name_  = 'CryptographicMessageSyntaxAlgorithms-2009'
    _oid_   = [1, 2, 840, 113549, 1, 9, 16, 0, 37]
    
    _obj_ = [
        'MessageDigestAlgs',
        'SignatureAlgs',
        'KeyAgreementAlgs',
        'KeyAgreePublicKeys',
        'KeyTransportAlgs',
        'KeyWrapAlgs',
        'KeyDerivationAlgs',
        'ContentEncryptionAlgs',
        'MessageAuthAlgs',
        'SMimeCaps',
        'id-alg-ESDH',
        'id-alg-SSDH',
        'id-alg-CMS3DESwrap',
        'id-alg-CMSRC2wrap',
        'des-ede3-cbc',
        'rc2-cbc',
        'hMAC-SHA1',
        'id-PBKDF2',
        'KeyWrapAlgorithm',
        'RC2wrapParameter',
        'RC2ParameterVersion',
        'CBCParameter',
        'IV',
        'RC2CBCParameter',
        'maca-hMAC-SHA1',
        'PBKDF2-PRFsAlgorithmIdentifier',
        'alg-hMAC-SHA1',
        'PBKDF2-PRFs',
        'PBKDF2-SaltSources',
        'PBKDF2-SaltSourcesAlgorithmIdentifier',
        'defaultPBKDF2',
        'PBKDF2-params',
        'kaa-esdh',
        'kaa-ssdh',
        'dh-public-number',
        'pk-originator-dh',
        'kwa-3DESWrap',
        'kwa-RC2Wrap',
        'kda-PBKDF2',
        'cea-3DES-cbc',
        'cea-RC2-cbc',
        'kt-rsa',
        'cap-3DESwrap',
        ]
    _type_ = [
        'KeyWrapAlgorithm',
        'RC2wrapParameter',
        'RC2ParameterVersion',
        'CBCParameter',
        'IV',
        'RC2CBCParameter',
        'PBKDF2-PRFsAlgorithmIdentifier',
        'PBKDF2-SaltSourcesAlgorithmIdentifier',
        'PBKDF2-params',
        ]
    _set_ = [
        'MessageDigestAlgs',
        'SignatureAlgs',
        'KeyAgreementAlgs',
        'KeyAgreePublicKeys',
        'KeyTransportAlgs',
        'KeyWrapAlgs',
        'KeyDerivationAlgs',
        'ContentEncryptionAlgs',
        'MessageAuthAlgs',
        'SMimeCaps',
        'PBKDF2-PRFs',
        'PBKDF2-SaltSources',
        ]
    _val_ = [
        'id-alg-ESDH',
        'id-alg-SSDH',
        'id-alg-CMS3DESwrap',
        'id-alg-CMSRC2wrap',
        'des-ede3-cbc',
        'rc2-cbc',
        'hMAC-SHA1',
        'id-PBKDF2',
        'maca-hMAC-SHA1',
        'alg-hMAC-SHA1',
        'defaultPBKDF2',
        'kaa-esdh',
        'kaa-ssdh',
        'dh-public-number',
        'pk-originator-dh',
        'kwa-3DESWrap',
        'kwa-RC2Wrap',
        'kda-PBKDF2',
        'cea-3DES-cbc',
        'cea-RC2-cbc',
        'kt-rsa',
        'cap-3DESwrap',
        ]
    _class_ = [
        'MessageDigestAlgs',
        'SignatureAlgs',
        'KeyAgreementAlgs',
        'KeyAgreePublicKeys',
        'KeyTransportAlgs',
        'KeyWrapAlgs',
        'KeyDerivationAlgs',
        'ContentEncryptionAlgs',
        'MessageAuthAlgs',
        'SMimeCaps',
        'maca-hMAC-SHA1',
        'alg-hMAC-SHA1',
        'PBKDF2-PRFs',
        'PBKDF2-SaltSources',
        'kaa-esdh',
        'kaa-ssdh',
        'pk-originator-dh',
        'kwa-3DESWrap',
        'kwa-RC2Wrap',
        'kda-PBKDF2',
        'cea-3DES-cbc',
        'cea-RC2-cbc',
        'kt-rsa',
        'cap-3DESwrap',
        ]
    _param_ = [
        ]
    
    #-----< MessageDigestAlgs >-----#
    MessageDigestAlgs = CLASS(name='MessageDigestAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    MessageDigestAlgs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SignatureAlgs >-----#
    SignatureAlgs = CLASS(name='SignatureAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    SignatureAlgs._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< KeyAgreementAlgs >-----#
    KeyAgreementAlgs = CLASS(name='KeyAgreementAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-AGREE')))
    _KeyAgreementAlgs_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DomainParameters')))
    _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _KeyAgreementAlgs_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    KeyAgreementAlgs._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5)), ('Params', _KeyAgreementAlgs_val_Params_0), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=None, er=[])), ('ukmPresence', 'optional'), ('smimeCaps', dict([('Type', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5))]))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10)), ('Params', _KeyAgreementAlgs_val_Params_1), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=None, er=[])), ('ukmPresence', 'optional'), ('smimeCaps', dict([('Type', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10))]))])], rr=[], ev=[], er=[])
    
    #-----< KeyAgreePublicKeys >-----#
    KeyAgreePublicKeys = CLASS(name='KeyAgreePublicKeys', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _KeyAgreePublicKeys_val_KeyValue_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    _KeyAgreePublicKeys_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DomainParameters')))
    KeyAgreePublicKeys._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _KeyAgreePublicKeys_val_KeyValue_0), ('Params', _KeyAgreePublicKeys_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=[], er=[])
    
    #-----< KeyTransportAlgs >-----#
    KeyTransportAlgs = CLASS(name='KeyTransportAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-TRANSPORT')))
    _KeyTransportAlgs_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    KeyTransportAlgs._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('Params', _KeyTransportAlgs_val_Params_0), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 1))]))])], rr=[], ev=[], er=[])
    
    #-----< KeyWrapAlgs >-----#
    KeyWrapAlgs = CLASS(name='KeyWrapAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-WRAP')))
    _KeyWrapAlgs_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _KeyWrapAlgs_val_Params_1 = INT(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'RC2wrapParameter')))
    KeyWrapAlgs._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6)), ('Params', _KeyWrapAlgs_val_Params_0), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6))]))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7)), ('Params', _KeyWrapAlgs_val_Params_1), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7))]))])], rr=[], ev=[], er=[])
    
    #-----< KeyDerivationAlgs >-----#
    KeyDerivationAlgs = CLASS(name='KeyDerivationAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-DERIVATION')))
    _KeyDerivationAlgs_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'PBKDF2-params')))
    KeyDerivationAlgs._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 5, 12)), ('Params', _KeyDerivationAlgs_val_Params_0), ('paramPresence', 'required')])], rr=[], ev=[], er=[])
    
    #-----< ContentEncryptionAlgs >-----#
    ContentEncryptionAlgs = CLASS(name='ContentEncryptionAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'CONTENT-ENCRYPTION')))
    _ContentEncryptionAlgs_val_Params_0 = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'IV')))
    _ContentEncryptionAlgs_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'RC2CBCParameter')))
    ____ContentEncryptionAlgorithmIdentifier_algorithm_tab_smimeCaps_val_Type = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SecureMimeMessageV3dot1-2009', 'SMIMECapabilitiesParametersForRC2CBC')))
    ContentEncryptionAlgs._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 3, 7)), ('Params', _ContentEncryptionAlgs_val_Params_0), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 3, 7))]))]), dict([('id', (1, 2, 840, 113549, 3, 2)), ('Params', _ContentEncryptionAlgs_val_Params_1), ('paramPresence', 'required'), ('smimeCaps', dict([('Type', ____ContentEncryptionAlgorithmIdentifier_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 3, 2))]))])], rr=[], ev=[], er=[])
    
    #-----< MessageAuthAlgs >-----#
    MessageAuthAlgs = CLASS(name='MessageAuthAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    _MessageAuthAlgs_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    MessageAuthAlgs._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', _MessageAuthAlgs_val_Params_0), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])], rr=[], ev=[], er=[])
    
    #-----< SMimeCaps >-----#
    SMimeCaps = CLASS(name='SMimeCaps', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')))
    _SMimeCaps_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _SMimeCaps_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _SMimeCaps_val_Type_6 = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SecureMimeMessageV3dot1-2009', 'SMIMECapabilitiesParametersForRC2CBC')))
    SMimeCaps._val = ASN1Set(rv=[dict([('Type', _SMimeCaps_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5))]), dict([('Type', _SMimeCaps_val_Type_1), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10))]), dict([('id', (1, 2, 840, 113549, 1, 1, 1))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7))]), dict([('id', (1, 2, 840, 113549, 3, 7))]), dict([('Type', _SMimeCaps_val_Type_6), ('id', (1, 2, 840, 113549, 3, 2))]), dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))])], rr=[], ev=[], er=[])
    
    #-----< id-alg-ESDH >-----#
    id_alg_ESDH = OID(name='id-alg-ESDH', mode=MODE_VALUE)
    id_alg_ESDH._val = (1, 2, 840, 113549, 1, 9, 16, 3, 5)
    
    #-----< id-alg-SSDH >-----#
    id_alg_SSDH = OID(name='id-alg-SSDH', mode=MODE_VALUE)
    id_alg_SSDH._val = (1, 2, 840, 113549, 1, 9, 16, 3, 10)
    
    #-----< id-alg-CMS3DESwrap >-----#
    id_alg_CMS3DESwrap = OID(name='id-alg-CMS3DESwrap', mode=MODE_VALUE)
    id_alg_CMS3DESwrap._val = (1, 2, 840, 113549, 1, 9, 16, 3, 6)
    
    #-----< id-alg-CMSRC2wrap >-----#
    id_alg_CMSRC2wrap = OID(name='id-alg-CMSRC2wrap', mode=MODE_VALUE)
    id_alg_CMSRC2wrap._val = (1, 2, 840, 113549, 1, 9, 16, 3, 7)
    
    #-----< des-ede3-cbc >-----#
    des_ede3_cbc = OID(name='des-ede3-cbc', mode=MODE_VALUE)
    des_ede3_cbc._val = (1, 2, 840, 113549, 3, 7)
    
    #-----< rc2-cbc >-----#
    rc2_cbc = OID(name='rc2-cbc', mode=MODE_VALUE)
    rc2_cbc._val = (1, 2, 840, 113549, 3, 2)
    
    #-----< hMAC-SHA1 >-----#
    hMAC_SHA1 = OID(name='hMAC-SHA1', mode=MODE_VALUE)
    hMAC_SHA1._val = (1, 3, 6, 1, 5, 5, 8, 1, 2)
    
    #-----< id-PBKDF2 >-----#
    id_PBKDF2 = OID(name='id-PBKDF2', mode=MODE_VALUE)
    id_PBKDF2._val = (1, 2, 840, 113549, 1, 5, 12)
    
    #-----< KeyWrapAlgorithm >-----#
    KeyWrapAlgorithm = SEQ(name='KeyWrapAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _KeyWrapAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-WRAP'), ['id']))
    __KeyWrapAlgorithm_algorithm_tab = CLASS(name='_tab_KEY-WRAP', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-WRAP')))
    ___KeyWrapAlgorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___KeyWrapAlgorithm_algorithm_tab_val_Params_1 = INT(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'RC2wrapParameter')))
    __KeyWrapAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6)), ('Params', ___KeyWrapAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6))]))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7)), ('Params', ___KeyWrapAlgorithm_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7))]))])], rr=[], ev=None, er=[])
    _KeyWrapAlgorithm_algorithm._const_tab = __KeyWrapAlgorithm_algorithm_tab
    _KeyWrapAlgorithm_algorithm._const_tab_at = None
    _KeyWrapAlgorithm_algorithm._const_tab_id = 'id'
    _KeyWrapAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-WRAP'), ['Params']), opt=True)
    _KeyWrapAlgorithm_parameters._const_tab = __KeyWrapAlgorithm_algorithm_tab
    _KeyWrapAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    _KeyWrapAlgorithm_parameters._const_tab_id = 'Params'
    KeyWrapAlgorithm._cont = ASN1Dict([
        ('algorithm', _KeyWrapAlgorithm_algorithm),
        ('parameters', _KeyWrapAlgorithm_parameters),
        ])
    KeyWrapAlgorithm._ext = None
    
    #-----< RC2wrapParameter >-----#
    RC2wrapParameter = INT(name='RC2wrapParameter', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'RC2ParameterVersion')))
    
    #-----< RC2ParameterVersion >-----#
    RC2ParameterVersion = INT(name='RC2ParameterVersion', mode=MODE_TYPE)
    
    #-----< CBCParameter >-----#
    CBCParameter = OCT_STR(name='CBCParameter', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'IV')))
    
    #-----< IV >-----#
    IV = OCT_STR(name='IV', mode=MODE_TYPE)
    
    #-----< RC2CBCParameter >-----#
    RC2CBCParameter = SEQ(name='RC2CBCParameter', mode=MODE_TYPE)
    _RC2CBCParameter_rc2ParameterVersion = INT(name='rc2ParameterVersion', mode=MODE_TYPE)
    _RC2CBCParameter_rc2ParameterVersion._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    _RC2CBCParameter_iv = OCT_STR(name='iv', mode=MODE_TYPE)
    RC2CBCParameter._cont = ASN1Dict([
        ('rc2ParameterVersion', _RC2CBCParameter_rc2ParameterVersion),
        ('iv', _RC2CBCParameter_iv),
        ])
    RC2CBCParameter._ext = None
    
    #-----< maca-hMAC-SHA1 >-----#
    maca_hMAC_SHA1 = CLASS(name='maca-hMAC-SHA1', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    _maca_hMAC_SHA1_val_Params = NULL(name='Params', mode=MODE_TYPE)
    maca_hMAC_SHA1._val = dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', _maca_hMAC_SHA1_val_Params), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])
    
    #-----< PBKDF2-PRFsAlgorithmIdentifier >-----#
    PBKDF2_PRFsAlgorithmIdentifier = SEQ(name='PBKDF2-PRFsAlgorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _PBKDF2_PRFsAlgorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['id']))
    __PBKDF2_PRFsAlgorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___PBKDF2_PRFsAlgorithmIdentifier_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __PBKDF2_PRFsAlgorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', ___PBKDF2_PRFsAlgorithmIdentifier_algorithm_tab_val_Params_0), ('paramPresence', 'required')])], rr=[], ev=None, er=[])
    _PBKDF2_PRFsAlgorithmIdentifier_algorithm._const_tab = __PBKDF2_PRFsAlgorithmIdentifier_algorithm_tab
    _PBKDF2_PRFsAlgorithmIdentifier_algorithm._const_tab_at = None
    _PBKDF2_PRFsAlgorithmIdentifier_algorithm._const_tab_id = 'id'
    _PBKDF2_PRFsAlgorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['Params']), opt=True)
    _PBKDF2_PRFsAlgorithmIdentifier_parameters._const_tab = __PBKDF2_PRFsAlgorithmIdentifier_algorithm_tab
    _PBKDF2_PRFsAlgorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _PBKDF2_PRFsAlgorithmIdentifier_parameters._const_tab_id = 'Params'
    PBKDF2_PRFsAlgorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _PBKDF2_PRFsAlgorithmIdentifier_algorithm),
        ('parameters', _PBKDF2_PRFsAlgorithmIdentifier_parameters),
        ])
    PBKDF2_PRFsAlgorithmIdentifier._ext = None
    
    #-----< alg-hMAC-SHA1 >-----#
    alg_hMAC_SHA1 = CLASS(name='alg-hMAC-SHA1', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    _alg_hMAC_SHA1_val_Params = NULL(name='Params', mode=MODE_TYPE)
    alg_hMAC_SHA1._val = dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', _alg_hMAC_SHA1_val_Params), ('paramPresence', 'required')])
    
    #-----< PBKDF2-PRFs >-----#
    PBKDF2_PRFs = CLASS(name='PBKDF2-PRFs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    _PBKDF2_PRFs_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    PBKDF2_PRFs._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', _PBKDF2_PRFs_val_Params_0), ('paramPresence', 'required')])], rr=[], ev=[], er=[])
    
    #-----< PBKDF2-SaltSources >-----#
    PBKDF2_SaltSources = CLASS(name='PBKDF2-SaltSources', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    PBKDF2_SaltSources._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< PBKDF2-SaltSourcesAlgorithmIdentifier >-----#
    PBKDF2_SaltSourcesAlgorithmIdentifier = SEQ(name='PBKDF2-SaltSourcesAlgorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _PBKDF2_SaltSourcesAlgorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['id']))
    __PBKDF2_SaltSourcesAlgorithmIdentifier_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    __PBKDF2_SaltSourcesAlgorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PBKDF2_SaltSourcesAlgorithmIdentifier_algorithm._const_tab = __PBKDF2_SaltSourcesAlgorithmIdentifier_algorithm_tab
    _PBKDF2_SaltSourcesAlgorithmIdentifier_algorithm._const_tab_at = None
    _PBKDF2_SaltSourcesAlgorithmIdentifier_algorithm._const_tab_id = 'id'
    _PBKDF2_SaltSourcesAlgorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['Params']), opt=True)
    __PBKDF2_SaltSourcesAlgorithmIdentifier_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    __PBKDF2_SaltSourcesAlgorithmIdentifier_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _PBKDF2_SaltSourcesAlgorithmIdentifier_parameters._const_tab = __PBKDF2_SaltSourcesAlgorithmIdentifier_parameters_tab
    _PBKDF2_SaltSourcesAlgorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    _PBKDF2_SaltSourcesAlgorithmIdentifier_parameters._const_tab_id = 'Params'
    PBKDF2_SaltSourcesAlgorithmIdentifier._cont = ASN1Dict([
        ('algorithm', _PBKDF2_SaltSourcesAlgorithmIdentifier_algorithm),
        ('parameters', _PBKDF2_SaltSourcesAlgorithmIdentifier_parameters),
        ])
    PBKDF2_SaltSourcesAlgorithmIdentifier._ext = None
    
    #-----< defaultPBKDF2 >-----#
    defaultPBKDF2 = SEQ(name='defaultPBKDF2', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'PBKDF2-PRFsAlgorithmIdentifier')))
    _parameters_val = NULL(name='parameters', mode=MODE_TYPE)
    defaultPBKDF2._val = dict([('algorithm', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('parameters', (_parameters_val, 0))])
    
    #-----< PBKDF2-params >-----#
    PBKDF2_params = SEQ(name='PBKDF2-params', mode=MODE_TYPE)
    _PBKDF2_params_salt = CHOICE(name='salt', mode=MODE_TYPE)
    __PBKDF2_params_salt_specified = OCT_STR(name='specified', mode=MODE_TYPE)
    __PBKDF2_params_salt_otherSource = SEQ(name='otherSource', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'PBKDF2-SaltSourcesAlgorithmIdentifier')))
    _PBKDF2_params_salt._cont = ASN1Dict([
        ('specified', __PBKDF2_params_salt_specified),
        ('otherSource', __PBKDF2_params_salt_otherSource),
        ])
    _PBKDF2_params_salt._ext = None
    _PBKDF2_params_iterationCount = INT(name='iterationCount', mode=MODE_TYPE)
    _PBKDF2_params_iterationCount._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PBKDF2_params_keyLength = INT(name='keyLength', mode=MODE_TYPE, opt=True)
    _PBKDF2_params_keyLength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _PBKDF2_params_prf = SEQ(name='prf', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'PBKDF2-PRFsAlgorithmIdentifier')), default=dict([('algorithm', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('parameters', (_parameters_val, 0))]))
    PBKDF2_params._cont = ASN1Dict([
        ('salt', _PBKDF2_params_salt),
        ('iterationCount', _PBKDF2_params_iterationCount),
        ('keyLength', _PBKDF2_params_keyLength),
        ('prf', _PBKDF2_params_prf),
        ])
    PBKDF2_params._ext = None
    
    #-----< kaa-esdh >-----#
    kaa_esdh = CLASS(name='kaa-esdh', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-AGREE')))
    _kaa_esdh_val_Params = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    kaa_esdh._val = dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5)), ('Params', _kaa_esdh_val_Params), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=None, er=[])), ('ukmPresence', 'optional'), ('smimeCaps', dict([('Type', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5))]))])
    
    #-----< kaa-ssdh >-----#
    kaa_ssdh = CLASS(name='kaa-ssdh', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-AGREE')))
    _kaa_ssdh_val_Params = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    kaa_ssdh._val = dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10)), ('Params', _kaa_ssdh_val_Params), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])], rr=[], ev=None, er=[])), ('ukmPresence', 'optional'), ('smimeCaps', dict([('Type', _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10))]))])
    
    #-----< dh-public-number >-----#
    dh_public_number = OID(name='dh-public-number', mode=MODE_VALUE)
    dh_public_number._val = (1, 2, 840, 10046, 2, 1)
    
    #-----< pk-originator-dh >-----#
    pk_originator_dh = CLASS(name='pk-originator-dh', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _pk_originator_dh_val_KeyValue = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    pk_originator_dh._val = dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _pk_originator_dh_val_KeyValue), ('paramPresence', 'absent'), ('keyUsage', (19, 9))])
    
    #-----< kwa-3DESWrap >-----#
    kwa_3DESWrap = CLASS(name='kwa-3DESWrap', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-WRAP')))
    _kwa_3DESWrap_val_Params = NULL(name='Params', mode=MODE_TYPE)
    kwa_3DESWrap._val = dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6)), ('Params', _kwa_3DESWrap_val_Params), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6))]))])
    
    #-----< kwa-RC2Wrap >-----#
    kwa_RC2Wrap = CLASS(name='kwa-RC2Wrap', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-WRAP')))
    _kwa_RC2Wrap_val_Params = INT(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'RC2wrapParameter')))
    kwa_RC2Wrap._val = dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7)), ('Params', _kwa_RC2Wrap_val_Params), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7))]))])
    
    #-----< kda-PBKDF2 >-----#
    kda_PBKDF2 = CLASS(name='kda-PBKDF2', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-DERIVATION')))
    _kda_PBKDF2_val_Params = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'PBKDF2-params')))
    kda_PBKDF2._val = dict([('id', (1, 2, 840, 113549, 1, 5, 12)), ('Params', _kda_PBKDF2_val_Params), ('paramPresence', 'required')])
    
    #-----< cea-3DES-cbc >-----#
    cea_3DES_cbc = CLASS(name='cea-3DES-cbc', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'CONTENT-ENCRYPTION')))
    _cea_3DES_cbc_val_Params = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'IV')))
    cea_3DES_cbc._val = dict([('id', (1, 2, 840, 113549, 3, 7)), ('Params', _cea_3DES_cbc_val_Params), ('paramPresence', 'required'), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 3, 7))]))])
    
    #-----< cea-RC2-cbc >-----#
    cea_RC2_cbc = CLASS(name='cea-RC2-cbc', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'CONTENT-ENCRYPTION')))
    _cea_RC2_cbc_val_Params = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'RC2CBCParameter')))
    cea_RC2_cbc._val = dict([('id', (1, 2, 840, 113549, 3, 2)), ('Params', _cea_RC2_cbc_val_Params), ('paramPresence', 'required'), ('smimeCaps', dict([('Type', ____ContentEncryptionAlgorithmIdentifier_algorithm_tab_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 3, 2))]))])
    
    #-----< kt-rsa >-----#
    kt_rsa = CLASS(name='kt-rsa', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-TRANSPORT')))
    _kt_rsa_val_Params = NULL(name='Params', mode=MODE_TYPE)
    kt_rsa._val = dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('Params', _kt_rsa_val_Params), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0), ('Params', _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 1))]))])
    
    #-----< cap-3DESwrap >-----#
    cap_3DESwrap = CLASS(name='cap-3DESwrap', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')))
    cap_3DESwrap._val = dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6))])
    
    _all_ = [
        MessageDigestAlgs,
        SignatureAlgs,
        KeyAgreementAlgs,
        _KeyAgreementAlgs_val_Params_0,
        _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0,
        _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0,
        _____KeyAgreeRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_smimeCaps_val_Type,
        _KeyAgreementAlgs_val_Params_1,
        KeyAgreePublicKeys,
        _KeyAgreePublicKeys_val_KeyValue_0,
        _KeyAgreePublicKeys_val_Params_0,
        KeyTransportAlgs,
        _KeyTransportAlgs_val_Params_0,
        _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_KeyValue_0,
        _____KeyTransRecipientInfo_keyEncryptionAlgorithm_algorithm_tab_PublicKeySet_val_Params_0,
        KeyWrapAlgs,
        _KeyWrapAlgs_val_Params_0,
        _KeyWrapAlgs_val_Params_1,
        KeyDerivationAlgs,
        _KeyDerivationAlgs_val_Params_0,
        ContentEncryptionAlgs,
        _ContentEncryptionAlgs_val_Params_0,
        _ContentEncryptionAlgs_val_Params_1,
        ____ContentEncryptionAlgorithmIdentifier_algorithm_tab_smimeCaps_val_Type,
        MessageAuthAlgs,
        _MessageAuthAlgs_val_Params_0,
        SMimeCaps,
        _SMimeCaps_val_Type_0,
        _SMimeCaps_val_Type_1,
        _SMimeCaps_val_Type_6,
        id_alg_ESDH,
        id_alg_SSDH,
        id_alg_CMS3DESwrap,
        id_alg_CMSRC2wrap,
        des_ede3_cbc,
        rc2_cbc,
        hMAC_SHA1,
        id_PBKDF2,
        __KeyWrapAlgorithm_algorithm_tab,
        ___KeyWrapAlgorithm_algorithm_tab_val_Params_0,
        ___KeyWrapAlgorithm_algorithm_tab_val_Params_1,
        _KeyWrapAlgorithm_algorithm,
        _KeyWrapAlgorithm_parameters,
        KeyWrapAlgorithm,
        RC2wrapParameter,
        RC2ParameterVersion,
        CBCParameter,
        IV,
        _RC2CBCParameter_rc2ParameterVersion,
        _RC2CBCParameter_iv,
        RC2CBCParameter,
        maca_hMAC_SHA1,
        _maca_hMAC_SHA1_val_Params,
        __PBKDF2_PRFsAlgorithmIdentifier_algorithm_tab,
        ___PBKDF2_PRFsAlgorithmIdentifier_algorithm_tab_val_Params_0,
        _PBKDF2_PRFsAlgorithmIdentifier_algorithm,
        _PBKDF2_PRFsAlgorithmIdentifier_parameters,
        PBKDF2_PRFsAlgorithmIdentifier,
        alg_hMAC_SHA1,
        _alg_hMAC_SHA1_val_Params,
        PBKDF2_PRFs,
        _PBKDF2_PRFs_val_Params_0,
        PBKDF2_SaltSources,
        __PBKDF2_SaltSourcesAlgorithmIdentifier_algorithm_tab,
        _PBKDF2_SaltSourcesAlgorithmIdentifier_algorithm,
        __PBKDF2_SaltSourcesAlgorithmIdentifier_parameters_tab,
        _PBKDF2_SaltSourcesAlgorithmIdentifier_parameters,
        PBKDF2_SaltSourcesAlgorithmIdentifier,
        defaultPBKDF2,
        _parameters_val,
        __PBKDF2_params_salt_specified,
        __PBKDF2_params_salt_otherSource,
        _PBKDF2_params_salt,
        _PBKDF2_params_iterationCount,
        _PBKDF2_params_keyLength,
        _PBKDF2_params_prf,
        PBKDF2_params,
        kaa_esdh,
        _kaa_esdh_val_Params,
        kaa_ssdh,
        _kaa_ssdh_val_Params,
        dh_public_number,
        pk_originator_dh,
        _pk_originator_dh_val_KeyValue,
        kwa_3DESWrap,
        _kwa_3DESWrap_val_Params,
        kwa_RC2Wrap,
        _kwa_RC2Wrap_val_Params,
        kda_PBKDF2,
        _kda_PBKDF2_val_Params,
        cea_3DES_cbc,
        _cea_3DES_cbc_val_Params,
        cea_RC2_cbc,
        _cea_RC2_cbc_val_Params,
        kt_rsa,
        _kt_rsa_val_Params,
        cap_3DESwrap,
    ]

class SecureMimeMessageV3dot1_2009:

    _name_  = 'SecureMimeMessageV3dot1-2009'
    _oid_   = [1, 2, 840, 113549, 1, 9, 16, 0, 39]
    
    _obj_ = [
        'SMimeAttributeSet',
        'id-aa',
        'aa-smimeCapabilities',
        'smimeCapabilities',
        'SMimeCapsSet',
        'aa-encrypKeyPref',
        'id-aa-encrypKeyPref',
        'SMIMEEncryptionKeyPreference',
        'id-smime',
        'id-cap',
        'cap-preferBinaryInside',
        'id-cap-preferBinaryInside',
        'cap-RC2CBC',
        'SMIMECapabilitiesParametersForRC2CBC',
        ]
    _type_ = [
        'SMIMEEncryptionKeyPreference',
        'SMIMECapabilitiesParametersForRC2CBC',
        ]
    _set_ = [
        'SMimeAttributeSet',
        'SMimeCapsSet',
        ]
    _val_ = [
        'id-aa',
        'aa-smimeCapabilities',
        'smimeCapabilities',
        'aa-encrypKeyPref',
        'id-aa-encrypKeyPref',
        'id-smime',
        'id-cap',
        'cap-preferBinaryInside',
        'id-cap-preferBinaryInside',
        'cap-RC2CBC',
        ]
    _class_ = [
        'SMimeAttributeSet',
        'aa-smimeCapabilities',
        'SMimeCapsSet',
        'aa-encrypKeyPref',
        'cap-preferBinaryInside',
        'cap-RC2CBC',
        ]
    _param_ = [
        ]
    
    #-----< SMimeAttributeSet >-----#
    SMimeAttributeSet = CLASS(name='SMimeAttributeSet', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _SMimeAttributeSet_val_Type_0 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIMECapabilities')))
    __SMimeAttributeSet_val_Type_0__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIMECapability')))
    ___SMimeAttributeSet_val_Type_0__item__capabilityID = OID(name='capabilityID', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SMIME-CAPS'), ['id']))
    ____SMimeAttributeSet_val_Type_0__item__capabilityID_tab = CLASS(name='_tab_SMIME-CAPS', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')))
    _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_1 = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SecureMimeMessageV3dot1-2009', 'SMIMECapabilitiesParametersForRC2CBC')))
    _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_13 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_14 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_21 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    ____SMimeAttributeSet_val_Type_0__item__capabilityID_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 9, 16, 11, 1))]), dict([('Type', _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_1), ('id', (1, 2, 840, 113549, 3, 2))]), dict([('id', (1, 2, 840, 113549, 1, 1, 2))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5))]), dict([('id', (1, 2, 840, 10040, 4, 3))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]), dict([('id', (1, 2, 840, 10045, 4, 1))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4))]), dict([('Type', _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_13), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5))]), dict([('Type', _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_14), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10))]), dict([('id', (1, 2, 840, 113549, 1, 1, 1))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7))]), dict([('id', (1, 2, 840, 113549, 3, 7))]), dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10))]), dict([('Type', _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_21), ('id', (1, 2, 840, 113549, 1, 1, 7))])], rr=[], ev=None, er=[])
    ___SMimeAttributeSet_val_Type_0__item__capabilityID._const_tab = ____SMimeAttributeSet_val_Type_0__item__capabilityID_tab
    ___SMimeAttributeSet_val_Type_0__item__capabilityID._const_tab_at = None
    ___SMimeAttributeSet_val_Type_0__item__capabilityID._const_tab_id = 'id'
    ___SMimeAttributeSet_val_Type_0__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SMIME-CAPS'), ['Type']), opt=True)
    ___SMimeAttributeSet_val_Type_0__item__parameters._const_tab = ____SMimeAttributeSet_val_Type_0__item__capabilityID_tab
    ___SMimeAttributeSet_val_Type_0__item__parameters._const_tab_at = ('..', 'capabilityID')
    ___SMimeAttributeSet_val_Type_0__item__parameters._const_tab_id = 'Type'
    __SMimeAttributeSet_val_Type_0__item_._cont = ASN1Dict([
        ('capabilityID', ___SMimeAttributeSet_val_Type_0__item__capabilityID),
        ('parameters', ___SMimeAttributeSet_val_Type_0__item__parameters),
        ])
    __SMimeAttributeSet_val_Type_0__item_._ext = None
    _SMimeAttributeSet_val_Type_0._cont = __SMimeAttributeSet_val_Type_0__item_
    _SMimeAttributeSet_val_Type_0._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SMimeAttributeSet_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SecureMimeMessageV3dot1-2009', 'SMIMEEncryptionKeyPreference')))
    SMimeAttributeSet._val = ASN1Set(rv=[dict([('Type', _SMimeAttributeSet_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 15))]), dict([('Type', _SMimeAttributeSet_val_Type_1), ('id', (1, 2, 840, 113549, 1, 9, 16, 2, 11))])], rr=[], ev=[], er=[])
    
    #-----< id-aa >-----#
    id_aa = OID(name='id-aa', mode=MODE_VALUE)
    id_aa._val = (1, 2, 840, 113549, 1, 9, 16, 2)
    
    #-----< aa-smimeCapabilities >-----#
    aa_smimeCapabilities = CLASS(name='aa-smimeCapabilities', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _aa_smimeCapabilities_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIMECapabilities')))
    __aa_smimeCapabilities_val_Type__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIMECapability')))
    ___aa_smimeCapabilities_val_Type__item__capabilityID = OID(name='capabilityID', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SMIME-CAPS'), ['id']))
    ____aa_smimeCapabilities_val_Type__item__capabilityID_tab = CLASS(name='_tab_SMIME-CAPS', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')))
    _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_1 = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SecureMimeMessageV3dot1-2009', 'SMIMECapabilitiesParametersForRC2CBC')))
    _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_13 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_14 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_21 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    ____aa_smimeCapabilities_val_Type__item__capabilityID_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 9, 16, 11, 1))]), dict([('Type', _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_1), ('id', (1, 2, 840, 113549, 3, 2))]), dict([('id', (1, 2, 840, 113549, 1, 1, 2))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5))]), dict([('id', (1, 2, 840, 10040, 4, 3))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]), dict([('id', (1, 2, 840, 10045, 4, 1))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4))]), dict([('Type', _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_13), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5))]), dict([('Type', _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_14), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10))]), dict([('id', (1, 2, 840, 113549, 1, 1, 1))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7))]), dict([('id', (1, 2, 840, 113549, 3, 7))]), dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10))]), dict([('Type', _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_21), ('id', (1, 2, 840, 113549, 1, 1, 7))])], rr=[], ev=None, er=[])
    ___aa_smimeCapabilities_val_Type__item__capabilityID._const_tab = ____aa_smimeCapabilities_val_Type__item__capabilityID_tab
    ___aa_smimeCapabilities_val_Type__item__capabilityID._const_tab_at = None
    ___aa_smimeCapabilities_val_Type__item__capabilityID._const_tab_id = 'id'
    ___aa_smimeCapabilities_val_Type__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SMIME-CAPS'), ['Type']), opt=True)
    ___aa_smimeCapabilities_val_Type__item__parameters._const_tab = ____aa_smimeCapabilities_val_Type__item__capabilityID_tab
    ___aa_smimeCapabilities_val_Type__item__parameters._const_tab_at = ('..', 'capabilityID')
    ___aa_smimeCapabilities_val_Type__item__parameters._const_tab_id = 'Type'
    __aa_smimeCapabilities_val_Type__item_._cont = ASN1Dict([
        ('capabilityID', ___aa_smimeCapabilities_val_Type__item__capabilityID),
        ('parameters', ___aa_smimeCapabilities_val_Type__item__parameters),
        ])
    __aa_smimeCapabilities_val_Type__item_._ext = None
    _aa_smimeCapabilities_val_Type._cont = __aa_smimeCapabilities_val_Type__item_
    _aa_smimeCapabilities_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    aa_smimeCapabilities._val = dict([('Type', _aa_smimeCapabilities_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 15))])
    
    #-----< smimeCapabilities >-----#
    smimeCapabilities = OID(name='smimeCapabilities', mode=MODE_VALUE)
    smimeCapabilities._val = (1, 2, 840, 113549, 1, 9, 15)
    
    #-----< SMimeCapsSet >-----#
    SMimeCapsSet = CLASS(name='SMimeCapsSet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')))
    _SMimeCapsSet_val_Type_1 = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SecureMimeMessageV3dot1-2009', 'SMIMECapabilitiesParametersForRC2CBC')))
    _SMimeCapsSet_val_Type_13 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _SMimeCapsSet_val_Type_14 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'KeyWrapAlgorithm')))
    _SMimeCapsSet_val_Type_21 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    SMimeCapsSet._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 9, 16, 11, 1))]), dict([('Type', _SMimeCapsSet_val_Type_1), ('id', (1, 2, 840, 113549, 3, 2))]), dict([('id', (1, 2, 840, 113549, 1, 1, 2))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5))]), dict([('id', (1, 2, 840, 10040, 4, 3))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]), dict([('id', (1, 2, 840, 10045, 4, 1))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4))]), dict([('Type', _SMimeCapsSet_val_Type_13), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 5))]), dict([('Type', _SMimeCapsSet_val_Type_14), ('id', (1, 2, 840, 113549, 1, 9, 16, 3, 10))]), dict([('id', (1, 2, 840, 113549, 1, 1, 1))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 6))]), dict([('id', (1, 2, 840, 113549, 1, 9, 16, 3, 7))]), dict([('id', (1, 2, 840, 113549, 3, 7))]), dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10))]), dict([('Type', _SMimeCapsSet_val_Type_21), ('id', (1, 2, 840, 113549, 1, 1, 7))])], rr=[], ev=[], er=[])
    
    #-----< aa-encrypKeyPref >-----#
    aa_encrypKeyPref = CLASS(name='aa-encrypKeyPref', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _aa_encrypKeyPref_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SecureMimeMessageV3dot1-2009', 'SMIMEEncryptionKeyPreference')))
    aa_encrypKeyPref._val = dict([('Type', _aa_encrypKeyPref_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 2, 11))])
    
    #-----< id-aa-encrypKeyPref >-----#
    id_aa_encrypKeyPref = OID(name='id-aa-encrypKeyPref', mode=MODE_VALUE)
    id_aa_encrypKeyPref._val = (1, 2, 840, 113549, 1, 9, 16, 2, 11)
    
    #-----< SMIMEEncryptionKeyPreference >-----#
    SMIMEEncryptionKeyPreference = CHOICE(name='SMIMEEncryptionKeyPreference', mode=MODE_TYPE)
    _SMIMEEncryptionKeyPreference_issuerAndSerialNumber = SEQ(name='issuerAndSerialNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'IssuerAndSerialNumber')))
    _SMIMEEncryptionKeyPreference_receipentKeyId = SEQ(name='receipentKeyId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'RecipientKeyIdentifier')))
    _SMIMEEncryptionKeyPreference_subjectAltKeyIdentifier = OCT_STR(name='subjectAltKeyIdentifier', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'SubjectKeyIdentifier')))
    SMIMEEncryptionKeyPreference._cont = ASN1Dict([
        ('issuerAndSerialNumber', _SMIMEEncryptionKeyPreference_issuerAndSerialNumber),
        ('receipentKeyId', _SMIMEEncryptionKeyPreference_receipentKeyId),
        ('subjectAltKeyIdentifier', _SMIMEEncryptionKeyPreference_subjectAltKeyIdentifier),
        ])
    SMIMEEncryptionKeyPreference._ext = None
    
    #-----< id-smime >-----#
    id_smime = OID(name='id-smime', mode=MODE_VALUE)
    id_smime._val = (1, 2, 840, 113549, 1, 9, 16)
    
    #-----< id-cap >-----#
    id_cap = OID(name='id-cap', mode=MODE_VALUE)
    id_cap._val = (1, 2, 840, 113549, 1, 9, 16, 11)
    
    #-----< cap-preferBinaryInside >-----#
    cap_preferBinaryInside = CLASS(name='cap-preferBinaryInside', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')))
    cap_preferBinaryInside._val = dict([('id', (1, 2, 840, 113549, 1, 9, 16, 11, 1))])
    
    #-----< id-cap-preferBinaryInside >-----#
    id_cap_preferBinaryInside = OID(name='id-cap-preferBinaryInside', mode=MODE_VALUE)
    id_cap_preferBinaryInside._val = (1, 2, 840, 113549, 1, 9, 16, 11, 1)
    
    #-----< cap-RC2CBC >-----#
    cap_RC2CBC = CLASS(name='cap-RC2CBC', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')))
    _cap_RC2CBC_val_Type = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SecureMimeMessageV3dot1-2009', 'SMIMECapabilitiesParametersForRC2CBC')))
    cap_RC2CBC._val = dict([('Type', _cap_RC2CBC_val_Type), ('id', (1, 2, 840, 113549, 3, 2))])
    
    #-----< SMIMECapabilitiesParametersForRC2CBC >-----#
    SMIMECapabilitiesParametersForRC2CBC = INT(name='SMIMECapabilitiesParametersForRC2CBC', mode=MODE_TYPE)
    SMIMECapabilitiesParametersForRC2CBC._const_val = ASN1Set(rv=[40, 128], rr=[], ev=[], er=[])
    
    _all_ = [
        SMimeAttributeSet,
        ____SMimeAttributeSet_val_Type_0__item__capabilityID_tab,
        _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_1,
        _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_13,
        _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_14,
        _____SMimeAttributeSet_val_Type_0__item__capabilityID_tab_val_Type_21,
        ___SMimeAttributeSet_val_Type_0__item__capabilityID,
        ___SMimeAttributeSet_val_Type_0__item__parameters,
        __SMimeAttributeSet_val_Type_0__item_,
        _SMimeAttributeSet_val_Type_0,
        _SMimeAttributeSet_val_Type_1,
        id_aa,
        aa_smimeCapabilities,
        ____aa_smimeCapabilities_val_Type__item__capabilityID_tab,
        _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_1,
        _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_13,
        _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_14,
        _____aa_smimeCapabilities_val_Type__item__capabilityID_tab_val_Type_21,
        ___aa_smimeCapabilities_val_Type__item__capabilityID,
        ___aa_smimeCapabilities_val_Type__item__parameters,
        __aa_smimeCapabilities_val_Type__item_,
        _aa_smimeCapabilities_val_Type,
        smimeCapabilities,
        SMimeCapsSet,
        _SMimeCapsSet_val_Type_1,
        _SMimeCapsSet_val_Type_13,
        _SMimeCapsSet_val_Type_14,
        _SMimeCapsSet_val_Type_21,
        aa_encrypKeyPref,
        _aa_encrypKeyPref_val_Type,
        id_aa_encrypKeyPref,
        _SMIMEEncryptionKeyPreference_issuerAndSerialNumber,
        _SMIMEEncryptionKeyPreference_receipentKeyId,
        _SMIMEEncryptionKeyPreference_subjectAltKeyIdentifier,
        SMIMEEncryptionKeyPreference,
        id_smime,
        id_cap,
        cap_preferBinaryInside,
        id_cap_preferBinaryInside,
        cap_RC2CBC,
        _cap_RC2CBC_val_Type,
        SMIMECapabilitiesParametersForRC2CBC,
    ]

class AlgorithmInformation_2009:

    _name_  = 'AlgorithmInformation-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 58]
    
    _obj_ = [
        'ParamOptions',
        'DIGEST-ALGORITHM',
        'SIGNATURE-ALGORITHM',
        'PUBLIC-KEY',
        'KEY-TRANSPORT',
        'KEY-AGREE',
        'KEY-WRAP',
        'KEY-DERIVATION',
        'MAC-ALGORITHM',
        'CONTENT-ENCRYPTION',
        'ALGORITHM',
        'AlgorithmIdentifier',
        'SMIME-CAPS',
        'SMIMECapability',
        'SMIMECapabilities',
        ]
    _type_ = [
        'ParamOptions',
        'DIGEST-ALGORITHM',
        'SIGNATURE-ALGORITHM',
        'PUBLIC-KEY',
        'KEY-TRANSPORT',
        'KEY-AGREE',
        'KEY-WRAP',
        'KEY-DERIVATION',
        'MAC-ALGORITHM',
        'CONTENT-ENCRYPTION',
        'ALGORITHM',
        'AlgorithmIdentifier',
        'SMIME-CAPS',
        'SMIMECapability',
        'SMIMECapabilities',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'DIGEST-ALGORITHM',
        'SIGNATURE-ALGORITHM',
        'PUBLIC-KEY',
        'KEY-TRANSPORT',
        'KEY-AGREE',
        'KEY-WRAP',
        'KEY-DERIVATION',
        'MAC-ALGORITHM',
        'CONTENT-ENCRYPTION',
        'ALGORITHM',
        'SMIME-CAPS',
        ]
    _param_ = [
        'AlgorithmIdentifier',
        'SMIMECapability',
        'SMIMECapabilities',
        ]
    
    #-----< ParamOptions >-----#
    ParamOptions = ENUM(name='ParamOptions', mode=MODE_TYPE)
    ParamOptions._cont = ASN1Dict([('required', 0), ('preferredPresent', 1), ('preferredAbsent', 2), ('absent', 3), ('inheritable', 4), ('optional', 5)])
    ParamOptions._ext = []
    
    #-----< DIGEST-ALGORITHM >-----#
    DIGEST_ALGORITHM = CLASS(name='DIGEST-ALGORITHM', mode=MODE_TYPE)
    _DIGEST_ALGORITHM_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _DIGEST_ALGORITHM_Params = OPEN(name='Params', mode=MODE_TYPE, opt=True)
    _DIGEST_ALGORITHM_paramPresence = ENUM(name='paramPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    DIGEST_ALGORITHM._cont = ASN1Dict([
        ('id', _DIGEST_ALGORITHM_id),
        ('Params', _DIGEST_ALGORITHM_Params),
        ('paramPresence', _DIGEST_ALGORITHM_paramPresence),
        ])
    
    #-----< SIGNATURE-ALGORITHM >-----#
    SIGNATURE_ALGORITHM = CLASS(name='SIGNATURE-ALGORITHM', mode=MODE_TYPE)
    _SIGNATURE_ALGORITHM_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _SIGNATURE_ALGORITHM_Value = OPEN(name='Value', mode=MODE_TYPE, opt=True)
    _SIGNATURE_ALGORITHM_Params = OPEN(name='Params', mode=MODE_TYPE, opt=True)
    _SIGNATURE_ALGORITHM_paramPresence = ENUM(name='paramPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    _SIGNATURE_ALGORITHM_HashSet = CLASS(name='HashSet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')), opt=True)
    _SIGNATURE_ALGORITHM_PublicKeySet = CLASS(name='PublicKeySet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')), opt=True)
    _SIGNATURE_ALGORITHM_smimeCaps = CLASS(name='smimeCaps', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')), opt=True)
    SIGNATURE_ALGORITHM._cont = ASN1Dict([
        ('id', _SIGNATURE_ALGORITHM_id),
        ('Value', _SIGNATURE_ALGORITHM_Value),
        ('Params', _SIGNATURE_ALGORITHM_Params),
        ('paramPresence', _SIGNATURE_ALGORITHM_paramPresence),
        ('HashSet', _SIGNATURE_ALGORITHM_HashSet),
        ('PublicKeySet', _SIGNATURE_ALGORITHM_PublicKeySet),
        ('smimeCaps', _SIGNATURE_ALGORITHM_smimeCaps),
        ])
    
    #-----< PUBLIC-KEY >-----#
    PUBLIC_KEY = CLASS(name='PUBLIC-KEY', mode=MODE_TYPE)
    _PUBLIC_KEY_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _PUBLIC_KEY_KeyValue = OPEN(name='KeyValue', mode=MODE_TYPE, opt=True)
    _PUBLIC_KEY_Params = OPEN(name='Params', mode=MODE_TYPE, opt=True)
    _PUBLIC_KEY_paramPresence = ENUM(name='paramPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    _PUBLIC_KEY_keyUsage = BIT_STR(name='keyUsage', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyUsage')), opt=True)
    _PUBLIC_KEY_PrivateKey = OPEN(name='PrivateKey', mode=MODE_TYPE, opt=True)
    PUBLIC_KEY._cont = ASN1Dict([
        ('id', _PUBLIC_KEY_id),
        ('KeyValue', _PUBLIC_KEY_KeyValue),
        ('Params', _PUBLIC_KEY_Params),
        ('paramPresence', _PUBLIC_KEY_paramPresence),
        ('keyUsage', _PUBLIC_KEY_keyUsage),
        ('PrivateKey', _PUBLIC_KEY_PrivateKey),
        ])
    
    #-----< KEY-TRANSPORT >-----#
    KEY_TRANSPORT = CLASS(name='KEY-TRANSPORT', mode=MODE_TYPE)
    _KEY_TRANSPORT_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _KEY_TRANSPORT_Params = OPEN(name='Params', mode=MODE_TYPE, opt=True)
    _KEY_TRANSPORT_paramPresence = ENUM(name='paramPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    _KEY_TRANSPORT_PublicKeySet = CLASS(name='PublicKeySet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')), opt=True)
    _KEY_TRANSPORT_smimeCaps = CLASS(name='smimeCaps', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')), opt=True)
    KEY_TRANSPORT._cont = ASN1Dict([
        ('id', _KEY_TRANSPORT_id),
        ('Params', _KEY_TRANSPORT_Params),
        ('paramPresence', _KEY_TRANSPORT_paramPresence),
        ('PublicKeySet', _KEY_TRANSPORT_PublicKeySet),
        ('smimeCaps', _KEY_TRANSPORT_smimeCaps),
        ])
    
    #-----< KEY-AGREE >-----#
    KEY_AGREE = CLASS(name='KEY-AGREE', mode=MODE_TYPE)
    _KEY_AGREE_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _KEY_AGREE_Params = OPEN(name='Params', mode=MODE_TYPE, opt=True)
    _KEY_AGREE_paramPresence = ENUM(name='paramPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    _KEY_AGREE_PublicKeySet = CLASS(name='PublicKeySet', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')), opt=True)
    _KEY_AGREE_Ukm = OPEN(name='Ukm', mode=MODE_TYPE, opt=True)
    _KEY_AGREE_ukmPresence = ENUM(name='ukmPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    _KEY_AGREE_smimeCaps = CLASS(name='smimeCaps', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')), opt=True)
    KEY_AGREE._cont = ASN1Dict([
        ('id', _KEY_AGREE_id),
        ('Params', _KEY_AGREE_Params),
        ('paramPresence', _KEY_AGREE_paramPresence),
        ('PublicKeySet', _KEY_AGREE_PublicKeySet),
        ('Ukm', _KEY_AGREE_Ukm),
        ('ukmPresence', _KEY_AGREE_ukmPresence),
        ('smimeCaps', _KEY_AGREE_smimeCaps),
        ])
    
    #-----< KEY-WRAP >-----#
    KEY_WRAP = CLASS(name='KEY-WRAP', mode=MODE_TYPE)
    _KEY_WRAP_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _KEY_WRAP_Params = OPEN(name='Params', mode=MODE_TYPE, opt=True)
    _KEY_WRAP_paramPresence = ENUM(name='paramPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    _KEY_WRAP_smimeCaps = CLASS(name='smimeCaps', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')), opt=True)
    KEY_WRAP._cont = ASN1Dict([
        ('id', _KEY_WRAP_id),
        ('Params', _KEY_WRAP_Params),
        ('paramPresence', _KEY_WRAP_paramPresence),
        ('smimeCaps', _KEY_WRAP_smimeCaps),
        ])
    
    #-----< KEY-DERIVATION >-----#
    KEY_DERIVATION = CLASS(name='KEY-DERIVATION', mode=MODE_TYPE)
    _KEY_DERIVATION_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _KEY_DERIVATION_Params = OPEN(name='Params', mode=MODE_TYPE, opt=True)
    _KEY_DERIVATION_paramPresence = ENUM(name='paramPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    _KEY_DERIVATION_smimeCaps = CLASS(name='smimeCaps', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')), opt=True)
    KEY_DERIVATION._cont = ASN1Dict([
        ('id', _KEY_DERIVATION_id),
        ('Params', _KEY_DERIVATION_Params),
        ('paramPresence', _KEY_DERIVATION_paramPresence),
        ('smimeCaps', _KEY_DERIVATION_smimeCaps),
        ])
    
    #-----< MAC-ALGORITHM >-----#
    MAC_ALGORITHM = CLASS(name='MAC-ALGORITHM', mode=MODE_TYPE)
    _MAC_ALGORITHM_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _MAC_ALGORITHM_Params = OPEN(name='Params', mode=MODE_TYPE, opt=True)
    _MAC_ALGORITHM_paramPresence = ENUM(name='paramPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    _MAC_ALGORITHM_keyed = BOOL(name='keyed', mode=MODE_VALUE)
    _MAC_ALGORITHM_smimeCaps = CLASS(name='smimeCaps', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')), opt=True)
    MAC_ALGORITHM._cont = ASN1Dict([
        ('id', _MAC_ALGORITHM_id),
        ('Params', _MAC_ALGORITHM_Params),
        ('paramPresence', _MAC_ALGORITHM_paramPresence),
        ('keyed', _MAC_ALGORITHM_keyed),
        ('smimeCaps', _MAC_ALGORITHM_smimeCaps),
        ])
    
    #-----< CONTENT-ENCRYPTION >-----#
    CONTENT_ENCRYPTION = CLASS(name='CONTENT-ENCRYPTION', mode=MODE_TYPE)
    _CONTENT_ENCRYPTION_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _CONTENT_ENCRYPTION_Params = OPEN(name='Params', mode=MODE_TYPE, opt=True)
    _CONTENT_ENCRYPTION_paramPresence = ENUM(name='paramPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    _CONTENT_ENCRYPTION_smimeCaps = CLASS(name='smimeCaps', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')), opt=True)
    CONTENT_ENCRYPTION._cont = ASN1Dict([
        ('id', _CONTENT_ENCRYPTION_id),
        ('Params', _CONTENT_ENCRYPTION_Params),
        ('paramPresence', _CONTENT_ENCRYPTION_paramPresence),
        ('smimeCaps', _CONTENT_ENCRYPTION_smimeCaps),
        ])
    
    #-----< ALGORITHM >-----#
    ALGORITHM = CLASS(name='ALGORITHM', mode=MODE_TYPE)
    _ALGORITHM_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _ALGORITHM_Params = OPEN(name='Params', mode=MODE_TYPE, opt=True)
    _ALGORITHM_paramPresence = ENUM(name='paramPresence', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ParamOptions')), default='absent')
    _ALGORITHM_smimeCaps = CLASS(name='smimeCaps', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')), opt=True)
    ALGORITHM._cont = ASN1Dict([
        ('id', _ALGORITHM_id),
        ('Params', _ALGORITHM_Params),
        ('paramPresence', _ALGORITHM_paramPresence),
        ('smimeCaps', _ALGORITHM_smimeCaps),
        ])
    
    #-----< AlgorithmIdentifier >-----#
    AlgorithmIdentifier = SEQ(name='AlgorithmIdentifier', mode=MODE_TYPE, param=True)
    
    #-----< SMIME-CAPS >-----#
    SMIME_CAPS = CLASS(name='SMIME-CAPS', mode=MODE_TYPE)
    _SMIME_CAPS_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _SMIME_CAPS_Type = OPEN(name='Type', mode=MODE_TYPE, opt=True)
    SMIME_CAPS._cont = ASN1Dict([
        ('id', _SMIME_CAPS_id),
        ('Type', _SMIME_CAPS_Type),
        ])
    
    #-----< SMIMECapability >-----#
    SMIMECapability = SEQ(name='SMIMECapability', mode=MODE_TYPE, param=True)
    
    #-----< SMIMECapabilities >-----#
    SMIMECapabilities = SEQ_OF(name='SMIMECapabilities', mode=MODE_TYPE, param=True)
    
    _all_ = [
        ParamOptions,
        _DIGEST_ALGORITHM_id,
        _DIGEST_ALGORITHM_Params,
        _DIGEST_ALGORITHM_paramPresence,
        DIGEST_ALGORITHM,
        _SIGNATURE_ALGORITHM_id,
        _SIGNATURE_ALGORITHM_Value,
        _SIGNATURE_ALGORITHM_Params,
        _SIGNATURE_ALGORITHM_paramPresence,
        _SIGNATURE_ALGORITHM_HashSet,
        _SIGNATURE_ALGORITHM_PublicKeySet,
        _SIGNATURE_ALGORITHM_smimeCaps,
        SIGNATURE_ALGORITHM,
        _PUBLIC_KEY_id,
        _PUBLIC_KEY_KeyValue,
        _PUBLIC_KEY_Params,
        _PUBLIC_KEY_paramPresence,
        _PUBLIC_KEY_keyUsage,
        _PUBLIC_KEY_PrivateKey,
        PUBLIC_KEY,
        _KEY_TRANSPORT_id,
        _KEY_TRANSPORT_Params,
        _KEY_TRANSPORT_paramPresence,
        _KEY_TRANSPORT_PublicKeySet,
        _KEY_TRANSPORT_smimeCaps,
        KEY_TRANSPORT,
        _KEY_AGREE_id,
        _KEY_AGREE_Params,
        _KEY_AGREE_paramPresence,
        _KEY_AGREE_PublicKeySet,
        _KEY_AGREE_Ukm,
        _KEY_AGREE_ukmPresence,
        _KEY_AGREE_smimeCaps,
        KEY_AGREE,
        _KEY_WRAP_id,
        _KEY_WRAP_Params,
        _KEY_WRAP_paramPresence,
        _KEY_WRAP_smimeCaps,
        KEY_WRAP,
        _KEY_DERIVATION_id,
        _KEY_DERIVATION_Params,
        _KEY_DERIVATION_paramPresence,
        _KEY_DERIVATION_smimeCaps,
        KEY_DERIVATION,
        _MAC_ALGORITHM_id,
        _MAC_ALGORITHM_Params,
        _MAC_ALGORITHM_paramPresence,
        _MAC_ALGORITHM_keyed,
        _MAC_ALGORITHM_smimeCaps,
        MAC_ALGORITHM,
        _CONTENT_ENCRYPTION_id,
        _CONTENT_ENCRYPTION_Params,
        _CONTENT_ENCRYPTION_paramPresence,
        _CONTENT_ENCRYPTION_smimeCaps,
        CONTENT_ENCRYPTION,
        _ALGORITHM_id,
        _ALGORITHM_Params,
        _ALGORITHM_paramPresence,
        _ALGORITHM_smimeCaps,
        ALGORITHM,
        _SMIME_CAPS_id,
        _SMIME_CAPS_Type,
        SMIME_CAPS,
    ]

class AttributeCertificateVersion1_2009:

    _name_  = 'AttributeCertificateVersion1-2009'
    _oid_   = [1, 2, 840, 113549, 1, 9, 16, 0, 49]
    
    _obj_ = [
        'AttributeCertificateV1',
        'AttributeCertificateInfoV1',
        'AttCertVersionV1',
        'AttrList',
        'AttributeCertExtensionsV1',
        ]
    _type_ = [
        'AttributeCertificateV1',
        'AttributeCertificateInfoV1',
        'AttCertVersionV1',
        ]
    _set_ = [
        'AttrList',
        'AttributeCertExtensionsV1',
        ]
    _val_ = [
        ]
    _class_ = [
        'AttrList',
        'AttributeCertExtensionsV1',
        ]
    _param_ = [
        ]
    
    #-----< AttributeCertificateV1 >-----#
    AttributeCertificateV1 = SEQ(name='AttributeCertificateV1', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SIGNED')))
    _AttributeCertificateV1_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateVersion1-2009', 'AttributeCertificateInfoV1')))
    _AttributeCertificateV1_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE)
    __AttributeCertificateV1_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___AttributeCertificateV1_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    __SIGNATURE_ALGORITHM_HashSet_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___AttributeCertificateV1_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_3), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_4), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_5), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_6), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_7), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_8), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_9), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_10), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __AttributeCertificateV1_algorithmIdentifier_algorithm._const_tab = ___AttributeCertificateV1_algorithmIdentifier_algorithm_tab
    __AttributeCertificateV1_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeCertificateV1_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AttributeCertificateV1_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __AttributeCertificateV1_algorithmIdentifier_parameters._const_tab = ___AttributeCertificateV1_algorithmIdentifier_algorithm_tab
    __AttributeCertificateV1_algorithmIdentifier_parameters._const_tab_at = ('..', '..', 'algorithmIdentifier', 'algorithm')
    __AttributeCertificateV1_algorithmIdentifier_parameters._const_tab_id = 'Params'
    _AttributeCertificateV1_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AttributeCertificateV1_algorithmIdentifier_algorithm),
        ('parameters', __AttributeCertificateV1_algorithmIdentifier_parameters),
        ])
    _AttributeCertificateV1_algorithmIdentifier._ext = None
    _AttributeCertificateV1_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __AttributeCertificateV1_signature_contain = OPEN(name='_cont_signature', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Value']))
    __AttributeCertificateV1_signature_contain._const_tab = ___AttributeCertificateV1_algorithmIdentifier_algorithm_tab
    __AttributeCertificateV1_signature_contain._const_tab_at = ('..', 'algorithmIdentifier', 'algorithm')
    __AttributeCertificateV1_signature_contain._const_tab_id = 'Value'
    _AttributeCertificateV1_signature._const_cont = __AttributeCertificateV1_signature_contain
    AttributeCertificateV1._cont = ASN1Dict([
        ('toBeSigned', _AttributeCertificateV1_toBeSigned),
        ('algorithmIdentifier', _AttributeCertificateV1_algorithmIdentifier),
        ('signature', _AttributeCertificateV1_signature),
        ])
    AttributeCertificateV1._ext = None
    
    #-----< AttributeCertificateInfoV1 >-----#
    AttributeCertificateInfoV1 = SEQ(name='AttributeCertificateInfoV1', mode=MODE_TYPE)
    _AttributeCertificateInfoV1_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('AttributeCertificateVersion1-2009', 'AttCertVersionV1')), default=0)
    _AttributeCertificateInfoV1_subject = CHOICE(name='subject', mode=MODE_TYPE)
    __AttributeCertificateInfoV1_subject_baseCertificateID = SEQ(name='baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IssuerSerial')))
    __AttributeCertificateInfoV1_subject_subjectName = SEQ_OF(name='subjectName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _AttributeCertificateInfoV1_subject._cont = ASN1Dict([
        ('baseCertificateID', __AttributeCertificateInfoV1_subject_baseCertificateID),
        ('subjectName', __AttributeCertificateInfoV1_subject_subjectName),
        ])
    _AttributeCertificateInfoV1_subject._ext = None
    _AttributeCertificateInfoV1_issuer = SEQ_OF(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _AttributeCertificateInfoV1_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __AttributeCertificateInfoV1_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___AttributeCertificateInfoV1_signature_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ___AttributeCertificateInfoV1_signature_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __AttributeCertificateInfoV1_signature_algorithm._const_tab = ___AttributeCertificateInfoV1_signature_algorithm_tab
    __AttributeCertificateInfoV1_signature_algorithm._const_tab_at = None
    __AttributeCertificateInfoV1_signature_algorithm._const_tab_id = 'id'
    __AttributeCertificateInfoV1_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    ___AttributeCertificateInfoV1_signature_parameters_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ___AttributeCertificateInfoV1_signature_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __AttributeCertificateInfoV1_signature_parameters._const_tab = ___AttributeCertificateInfoV1_signature_parameters_tab
    __AttributeCertificateInfoV1_signature_parameters._const_tab_at = ('..', 'algorithm')
    __AttributeCertificateInfoV1_signature_parameters._const_tab_id = 'Params'
    _AttributeCertificateInfoV1_signature._cont = ASN1Dict([
        ('algorithm', __AttributeCertificateInfoV1_signature_algorithm),
        ('parameters', __AttributeCertificateInfoV1_signature_parameters),
        ])
    _AttributeCertificateInfoV1_signature._ext = None
    _AttributeCertificateInfoV1_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateSerialNumber')))
    _AttributeCertificateInfoV1_attCertValidityPeriod = SEQ(name='attCertValidityPeriod', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttCertValidityPeriod')))
    _AttributeCertificateInfoV1_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE)
    __AttributeCertificateInfoV1_attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'AttributeSet')))
    ___AttributeCertificateInfoV1_attributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ____AttributeCertificateInfoV1_attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____AttributeCertificateInfoV1_attributes__item__type_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AttributeCertificateInfoV1_attributes__item__type._const_tab = ____AttributeCertificateInfoV1_attributes__item__type_tab
    ___AttributeCertificateInfoV1_attributes__item__type._const_tab_at = None
    ___AttributeCertificateInfoV1_attributes__item__type._const_tab_id = 'id'
    ___AttributeCertificateInfoV1_attributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AttributeCertificateInfoV1_attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    _____AttributeCertificateInfoV1_attributes__item__values__item__tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _____AttributeCertificateInfoV1_attributes__item__values__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AttributeCertificateInfoV1_attributes__item__values__item_._const_tab = _____AttributeCertificateInfoV1_attributes__item__values__item__tab
    ____AttributeCertificateInfoV1_attributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AttributeCertificateInfoV1_attributes__item__values__item_._const_tab_id = 'Type'
    ___AttributeCertificateInfoV1_attributes__item__values._cont = ____AttributeCertificateInfoV1_attributes__item__values__item_
    ___AttributeCertificateInfoV1_attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AttributeCertificateInfoV1_attributes__item_._cont = ASN1Dict([
        ('type', ___AttributeCertificateInfoV1_attributes__item__type),
        ('values', ___AttributeCertificateInfoV1_attributes__item__values),
        ])
    __AttributeCertificateInfoV1_attributes__item_._ext = None
    _AttributeCertificateInfoV1_attributes._cont = __AttributeCertificateInfoV1_attributes__item_
    _AttributeCertificateInfoV1_issuerUniqueID = BIT_STR(name='issuerUniqueID', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'UniqueIdentifier')), opt=True)
    _AttributeCertificateInfoV1_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __AttributeCertificateInfoV1_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___AttributeCertificateInfoV1_extensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____AttributeCertificateInfoV1_extensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    ____AttributeCertificateInfoV1_extensions__item__extnID_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___AttributeCertificateInfoV1_extensions__item__extnID._const_tab = ____AttributeCertificateInfoV1_extensions__item__extnID_tab
    ___AttributeCertificateInfoV1_extensions__item__extnID._const_tab_at = None
    ___AttributeCertificateInfoV1_extensions__item__extnID._const_tab_id = 'id'
    ___AttributeCertificateInfoV1_extensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___AttributeCertificateInfoV1_extensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____AttributeCertificateInfoV1_extensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    _____AttributeCertificateInfoV1_extensions__item__extnValue_contain_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____AttributeCertificateInfoV1_extensions__item__extnValue_contain_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____AttributeCertificateInfoV1_extensions__item__extnValue_contain._const_tab = _____AttributeCertificateInfoV1_extensions__item__extnValue_contain_tab
    ____AttributeCertificateInfoV1_extensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____AttributeCertificateInfoV1_extensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___AttributeCertificateInfoV1_extensions__item__extnValue._const_cont = ____AttributeCertificateInfoV1_extensions__item__extnValue_contain
    __AttributeCertificateInfoV1_extensions__item_._cont = ASN1Dict([
        ('extnID', ___AttributeCertificateInfoV1_extensions__item__extnID),
        ('critical', ___AttributeCertificateInfoV1_extensions__item__critical),
        ('extnValue', ___AttributeCertificateInfoV1_extensions__item__extnValue),
        ])
    __AttributeCertificateInfoV1_extensions__item_._ext = None
    _AttributeCertificateInfoV1_extensions._cont = __AttributeCertificateInfoV1_extensions__item_
    _AttributeCertificateInfoV1_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AttributeCertificateInfoV1._cont = ASN1Dict([
        ('version', _AttributeCertificateInfoV1_version),
        ('subject', _AttributeCertificateInfoV1_subject),
        ('issuer', _AttributeCertificateInfoV1_issuer),
        ('signature', _AttributeCertificateInfoV1_signature),
        ('serialNumber', _AttributeCertificateInfoV1_serialNumber),
        ('attCertValidityPeriod', _AttributeCertificateInfoV1_attCertValidityPeriod),
        ('attributes', _AttributeCertificateInfoV1_attributes),
        ('issuerUniqueID', _AttributeCertificateInfoV1_issuerUniqueID),
        ('extensions', _AttributeCertificateInfoV1_extensions),
        ])
    AttributeCertificateInfoV1._ext = None
    
    #-----< AttCertVersionV1 >-----#
    AttCertVersionV1 = INT(name='AttCertVersionV1', mode=MODE_TYPE)
    AttCertVersionV1._cont = ASN1Dict([('v1', 0)])
    
    #-----< AttrList >-----#
    AttrList = CLASS(name='AttrList', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    AttrList._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< AttributeCertExtensionsV1 >-----#
    AttributeCertExtensionsV1 = CLASS(name='AttributeCertExtensionsV1', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    AttributeCertExtensionsV1._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        _AttributeCertificateV1_toBeSigned,
        ___AttributeCertificateV1_algorithmIdentifier_algorithm_tab,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_0,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_1,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_2,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_3,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_3,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_4,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_5,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_5,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_6,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_6,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_7,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_7,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_8,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_8,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_9,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_9,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Value_10,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_10,
        ____AttributeCertificateV1_algorithmIdentifier_algorithm_tab_val_Params_11,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_1,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_2,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_3,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1,
        __AttributeCertificateV1_algorithmIdentifier_algorithm,
        __AttributeCertificateV1_algorithmIdentifier_parameters,
        _AttributeCertificateV1_algorithmIdentifier,
        __AttributeCertificateV1_signature_contain,
        _AttributeCertificateV1_signature,
        AttributeCertificateV1,
        _AttributeCertificateInfoV1_version,
        __AttributeCertificateInfoV1_subject_baseCertificateID,
        __AttributeCertificateInfoV1_subject_subjectName,
        _AttributeCertificateInfoV1_subject,
        _AttributeCertificateInfoV1_issuer,
        ___AttributeCertificateInfoV1_signature_algorithm_tab,
        __AttributeCertificateInfoV1_signature_algorithm,
        ___AttributeCertificateInfoV1_signature_parameters_tab,
        __AttributeCertificateInfoV1_signature_parameters,
        _AttributeCertificateInfoV1_signature,
        _AttributeCertificateInfoV1_serialNumber,
        _AttributeCertificateInfoV1_attCertValidityPeriod,
        ____AttributeCertificateInfoV1_attributes__item__type_tab,
        ___AttributeCertificateInfoV1_attributes__item__type,
        _____AttributeCertificateInfoV1_attributes__item__values__item__tab,
        ____AttributeCertificateInfoV1_attributes__item__values__item_,
        ___AttributeCertificateInfoV1_attributes__item__values,
        __AttributeCertificateInfoV1_attributes__item_,
        _AttributeCertificateInfoV1_attributes,
        _AttributeCertificateInfoV1_issuerUniqueID,
        ____AttributeCertificateInfoV1_extensions__item__extnID_tab,
        ___AttributeCertificateInfoV1_extensions__item__extnID,
        ___AttributeCertificateInfoV1_extensions__item__critical,
        _____AttributeCertificateInfoV1_extensions__item__extnValue_contain_tab,
        ____AttributeCertificateInfoV1_extensions__item__extnValue_contain,
        ___AttributeCertificateInfoV1_extensions__item__extnValue,
        __AttributeCertificateInfoV1_extensions__item_,
        _AttributeCertificateInfoV1_extensions,
        AttributeCertificateInfoV1,
        AttCertVersionV1,
        AttrList,
        AttributeCertExtensionsV1,
    ]

class EnrollmentMessageSyntax_2009:

    _name_  = 'EnrollmentMessageSyntax-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 53]
    
    _obj_ = [
        'CMC-ContentTypes',
        'SignatureAlgs',
        'CMC-UnsignedAtts',
        'id-cmc',
        'id-cct',
        'ct-PKIData',
        'id-cct-PKIData',
        'PKIData',
        'BodyPartID',
        'TaggedAttribute',
        'Cmc-Control-Set',
        'OTHER-REQUEST',
        'OtherRequests',
        'TaggedRequest',
        'TaggedCertificationRequest',
        'AttributeList',
        'CertificationRequest',
        'TaggedContentInfo',
        'OTHER-MSG',
        'OtherMsgSet',
        'OtherMsg',
        'ct-PKIResponse',
        'id-cct-PKIResponse',
        'ResponseBody',
        'PKIResponse',
        'CMC-CONTROL',
        'cmc-identityProof',
        'id-cmc-identityProof',
        'cmc-dataReturn',
        'id-cmc-dataReturn',
        'cmc-regInfo',
        'id-cmc-regInfo',
        'cmc-responseInfo',
        'id-cmc-responseInfo',
        'cmc-queryPending',
        'id-cmc-queryPending',
        'cmc-popLinkRandom',
        'id-cmc-popLinkRandom',
        'cmc-popLinkWitness',
        'id-cmc-popLinkWitness',
        'cmc-identification',
        'id-cmc-identification',
        'cmc-transactionId',
        'id-cmc-transactionId',
        'cmc-senderNonce',
        'id-cmc-senderNonce',
        'cmc-recipientNonce',
        'id-cmc-recipientNonce',
        'cmc-statusInfo',
        'id-cmc-statusInfo',
        'CMCStatusInfo',
        'PendInfo',
        'CMCStatus',
        'CMCFailInfo',
        'cmc-addExtensions',
        'id-cmc-addExtensions',
        'AddExtensions',
        'cmc-encryptedPOP',
        'cmc-decryptedPOP',
        'id-cmc-encryptedPOP',
        'id-cmc-decryptedPOP',
        'EncryptedPOP',
        'POPAlgs',
        'WitnessAlgs',
        'DecryptedPOP',
        'cmc-lraPOPWitness',
        'id-cmc-lraPOPWitness',
        'LraPopWitness',
        'cmc-getCert',
        'id-cmc-getCert',
        'GetCert',
        'cmc-getCRL',
        'id-cmc-getCRL',
        'GetCRL',
        'cmc-revokeRequest',
        'id-cmc-revokeRequest',
        'RevokeRequest',
        'cmc-confirmCertAcceptance',
        'id-cmc-confirmCertAcceptance',
        'CMCCertId',
        'at-extension-req',
        'id-ExtensionReq',
        'ExtensionReq',
        'sa-noSignature',
        'id-alg-noSignature',
        'NoSignatureValue',
        'id-aa',
        'aa-cmc-unsignedData',
        'id-aa-cmc-unsignedData',
        'CMCUnsignedData',
        'cmc-statusInfoV2',
        'id-cmc-statusInfoV2',
        'EXTENDED-FAILURE-INFO',
        'ExtendedFailures',
        'CMCStatusInfoV2',
        'BodyPartReference',
        'BodyPartPath',
        'cmc-trustedAnchors',
        'id-cmc-trustedAnchors',
        'PublishTrustAnchors',
        'HashAlgorithms',
        'cmc-authData',
        'id-cmc-authData',
        'AuthPublish',
        'cmc-batchRequests',
        'id-cmc-batchRequests',
        'cmc-batchResponses',
        'id-cmc-batchResponses',
        'BodyPartList',
        'cmc-publishCert',
        'id-cmc-publishCert',
        'CMCPublicationInfo',
        'cmc-modCertTemplate',
        'id-cmc-modCertTemplate',
        'ModCertTemplate',
        'cmc-controlProcessed',
        'id-cmc-controlProcessed',
        'ControlsProcessed',
        'cmc-identityProofV2',
        'id-cmc-identityProofV2',
        'IdentityProofV2',
        'cmc-popLinkWitnessV2',
        'id-cmc-popLinkWitnessV2',
        'PopLinkWitnessV2',
        'KeyDevAlgs',
        ]
    _type_ = [
        'PKIData',
        'BodyPartID',
        'TaggedAttribute',
        'OTHER-REQUEST',
        'TaggedRequest',
        'TaggedCertificationRequest',
        'CertificationRequest',
        'TaggedContentInfo',
        'OTHER-MSG',
        'OtherMsg',
        'ResponseBody',
        'PKIResponse',
        'CMC-CONTROL',
        'CMCStatusInfo',
        'PendInfo',
        'CMCStatus',
        'CMCFailInfo',
        'AddExtensions',
        'EncryptedPOP',
        'DecryptedPOP',
        'LraPopWitness',
        'GetCert',
        'GetCRL',
        'RevokeRequest',
        'CMCCertId',
        'ExtensionReq',
        'NoSignatureValue',
        'CMCUnsignedData',
        'EXTENDED-FAILURE-INFO',
        'CMCStatusInfoV2',
        'BodyPartReference',
        'BodyPartPath',
        'PublishTrustAnchors',
        'AuthPublish',
        'BodyPartList',
        'CMCPublicationInfo',
        'ModCertTemplate',
        'ControlsProcessed',
        'IdentityProofV2',
        'PopLinkWitnessV2',
        ]
    _set_ = [
        'CMC-ContentTypes',
        'SignatureAlgs',
        'CMC-UnsignedAtts',
        'Cmc-Control-Set',
        'OtherRequests',
        'AttributeList',
        'OtherMsgSet',
        'POPAlgs',
        'WitnessAlgs',
        'ExtendedFailures',
        'HashAlgorithms',
        'KeyDevAlgs',
        ]
    _val_ = [
        'id-cmc',
        'id-cct',
        'ct-PKIData',
        'id-cct-PKIData',
        'ct-PKIResponse',
        'id-cct-PKIResponse',
        'cmc-identityProof',
        'id-cmc-identityProof',
        'cmc-dataReturn',
        'id-cmc-dataReturn',
        'cmc-regInfo',
        'id-cmc-regInfo',
        'cmc-responseInfo',
        'id-cmc-responseInfo',
        'cmc-queryPending',
        'id-cmc-queryPending',
        'cmc-popLinkRandom',
        'id-cmc-popLinkRandom',
        'cmc-popLinkWitness',
        'id-cmc-popLinkWitness',
        'cmc-identification',
        'id-cmc-identification',
        'cmc-transactionId',
        'id-cmc-transactionId',
        'cmc-senderNonce',
        'id-cmc-senderNonce',
        'cmc-recipientNonce',
        'id-cmc-recipientNonce',
        'cmc-statusInfo',
        'id-cmc-statusInfo',
        'cmc-addExtensions',
        'id-cmc-addExtensions',
        'cmc-encryptedPOP',
        'cmc-decryptedPOP',
        'id-cmc-encryptedPOP',
        'id-cmc-decryptedPOP',
        'cmc-lraPOPWitness',
        'id-cmc-lraPOPWitness',
        'cmc-getCert',
        'id-cmc-getCert',
        'cmc-getCRL',
        'id-cmc-getCRL',
        'cmc-revokeRequest',
        'id-cmc-revokeRequest',
        'cmc-confirmCertAcceptance',
        'id-cmc-confirmCertAcceptance',
        'at-extension-req',
        'id-ExtensionReq',
        'sa-noSignature',
        'id-alg-noSignature',
        'id-aa',
        'aa-cmc-unsignedData',
        'id-aa-cmc-unsignedData',
        'cmc-statusInfoV2',
        'id-cmc-statusInfoV2',
        'cmc-trustedAnchors',
        'id-cmc-trustedAnchors',
        'cmc-authData',
        'id-cmc-authData',
        'cmc-batchRequests',
        'id-cmc-batchRequests',
        'cmc-batchResponses',
        'id-cmc-batchResponses',
        'cmc-publishCert',
        'id-cmc-publishCert',
        'cmc-modCertTemplate',
        'id-cmc-modCertTemplate',
        'cmc-controlProcessed',
        'id-cmc-controlProcessed',
        'cmc-identityProofV2',
        'id-cmc-identityProofV2',
        'cmc-popLinkWitnessV2',
        'id-cmc-popLinkWitnessV2',
        ]
    _class_ = [
        'CMC-ContentTypes',
        'SignatureAlgs',
        'CMC-UnsignedAtts',
        'ct-PKIData',
        'Cmc-Control-Set',
        'OTHER-REQUEST',
        'OtherRequests',
        'AttributeList',
        'OTHER-MSG',
        'OtherMsgSet',
        'ct-PKIResponse',
        'CMC-CONTROL',
        'cmc-identityProof',
        'cmc-dataReturn',
        'cmc-regInfo',
        'cmc-responseInfo',
        'cmc-queryPending',
        'cmc-popLinkRandom',
        'cmc-popLinkWitness',
        'cmc-identification',
        'cmc-transactionId',
        'cmc-senderNonce',
        'cmc-recipientNonce',
        'cmc-statusInfo',
        'cmc-addExtensions',
        'cmc-encryptedPOP',
        'cmc-decryptedPOP',
        'POPAlgs',
        'WitnessAlgs',
        'cmc-lraPOPWitness',
        'cmc-getCert',
        'cmc-getCRL',
        'cmc-revokeRequest',
        'cmc-confirmCertAcceptance',
        'at-extension-req',
        'sa-noSignature',
        'aa-cmc-unsignedData',
        'cmc-statusInfoV2',
        'EXTENDED-FAILURE-INFO',
        'ExtendedFailures',
        'cmc-trustedAnchors',
        'HashAlgorithms',
        'cmc-authData',
        'cmc-batchRequests',
        'cmc-batchResponses',
        'cmc-publishCert',
        'cmc-modCertTemplate',
        'cmc-controlProcessed',
        'cmc-identityProofV2',
        'cmc-popLinkWitnessV2',
        'KeyDevAlgs',
        ]
    _param_ = [
        ]
    
    #-----< CMC-ContentTypes >-----#
    CMC_ContentTypes = CLASS(name='CMC-ContentTypes', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _CMC_ContentTypes_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PKIData')))
    _CMC_ContentTypes_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PKIResponse')))
    CMC_ContentTypes._val = ASN1Set(rv=[dict([('Type', _CMC_ContentTypes_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 12, 2))]), dict([('Type', _CMC_ContentTypes_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 12, 3))])], rr=[], ev=[], er=[])
    
    #-----< SignatureAlgs >-----#
    SignatureAlgs = CLASS(name='SignatureAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _SignatureAlgs_val_Value_0 = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'NoSignatureValue')))
    _SignatureAlgs_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    SignatureAlgs._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 7, 6, 2)), ('Value', _SignatureAlgs_val_Value_0), ('Params', _SignatureAlgs_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[]))])], rr=[], ev=None, er=[])
    
    #-----< CMC-UnsignedAtts >-----#
    CMC_UnsignedAtts = CLASS(name='CMC-UnsignedAtts', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _CMC_UnsignedAtts_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCUnsignedData')))
    CMC_UnsignedAtts._val = ASN1Set(rv=[dict([('Type', _CMC_UnsignedAtts_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 16, 2, 34))])], rr=[], ev=None, er=[])
    
    #-----< id-cmc >-----#
    id_cmc = OID(name='id-cmc', mode=MODE_VALUE)
    id_cmc._val = (1, 3, 6, 1, 5, 5, 7, 7)
    
    #-----< id-cct >-----#
    id_cct = OID(name='id-cct', mode=MODE_VALUE)
    id_cct._val = (1, 3, 6, 1, 5, 5, 7, 12)
    
    #-----< ct-PKIData >-----#
    ct_PKIData = CLASS(name='ct-PKIData', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_PKIData_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PKIData')))
    ct_PKIData._val = dict([('Type', _ct_PKIData_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 12, 2))])
    
    #-----< id-cct-PKIData >-----#
    id_cct_PKIData = OID(name='id-cct-PKIData', mode=MODE_VALUE)
    id_cct_PKIData._val = (1, 3, 6, 1, 5, 5, 7, 12, 2)
    
    #-----< PKIData >-----#
    PKIData = SEQ(name='PKIData', mode=MODE_TYPE)
    _PKIData_controlSequence = SEQ_OF(name='controlSequence', mode=MODE_TYPE)
    __PKIData_controlSequence__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'TaggedAttribute')))
    _PKIData_controlSequence._cont = __PKIData_controlSequence__item_
    _PKIData_controlSequence._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PKIData_reqSequence = SEQ_OF(name='reqSequence', mode=MODE_TYPE)
    __PKIData_reqSequence__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'TaggedRequest')))
    _PKIData_reqSequence._cont = __PKIData_reqSequence__item_
    _PKIData_reqSequence._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PKIData_cmsSequence = SEQ_OF(name='cmsSequence', mode=MODE_TYPE)
    __PKIData_cmsSequence__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'TaggedContentInfo')))
    _PKIData_cmsSequence._cont = __PKIData_cmsSequence__item_
    _PKIData_cmsSequence._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PKIData_otherMsgSequence = SEQ_OF(name='otherMsgSequence', mode=MODE_TYPE)
    __PKIData_otherMsgSequence__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'OtherMsg')))
    _PKIData_otherMsgSequence._cont = __PKIData_otherMsgSequence__item_
    _PKIData_otherMsgSequence._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    PKIData._cont = ASN1Dict([
        ('controlSequence', _PKIData_controlSequence),
        ('reqSequence', _PKIData_reqSequence),
        ('cmsSequence', _PKIData_cmsSequence),
        ('otherMsgSequence', _PKIData_otherMsgSequence),
        ])
    PKIData._ext = None
    
    #-----< BodyPartID >-----#
    BodyPartID = INT(name='BodyPartID', mode=MODE_TYPE)
    BodyPartID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    
    #-----< TaggedAttribute >-----#
    TaggedAttribute = SEQ(name='TaggedAttribute', mode=MODE_TYPE)
    _TaggedAttribute_bodyPartID = INT(name='bodyPartID', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _TaggedAttribute_attrType = OID(name='attrType', mode=MODE_TYPE, typeref=ASN1RefClassField(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL'), ['id']))
    __TaggedAttribute_attrType_tab = CLASS(name='_tab_CMC-CONTROL', mode=MODE_SET, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    ___TaggedAttribute_attrType_tab_val_Type_0 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_1 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_2 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_3 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_4 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_5 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_6 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_7 = STR_UTF8(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_8 = INT(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_9 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_10 = OCT_STR(name='Type', mode=MODE_TYPE)
    ___TaggedAttribute_attrType_tab_val_Type_11 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCStatusInfo')))
    ___TaggedAttribute_attrType_tab_val_Type_12 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'AddExtensions')))
    ___TaggedAttribute_attrType_tab_val_Type_13 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'EncryptedPOP')))
    ___TaggedAttribute_attrType_tab_val_Type_14 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'DecryptedPOP')))
    ___TaggedAttribute_attrType_tab_val_Type_15 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'LraPopWitness')))
    ___TaggedAttribute_attrType_tab_val_Type_16 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'GetCert')))
    ___TaggedAttribute_attrType_tab_val_Type_17 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'GetCRL')))
    ___TaggedAttribute_attrType_tab_val_Type_18 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'RevokeRequest')))
    ___TaggedAttribute_attrType_tab_val_Type_19 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCCertId')))
    ___TaggedAttribute_attrType_tab_val_Type_20 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCStatusInfoV2')))
    ___TaggedAttribute_attrType_tab_val_Type_21 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PublishTrustAnchors')))
    ___TaggedAttribute_attrType_tab_val_Type_22 = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'AuthPublish')))
    ___TaggedAttribute_attrType_tab_val_Type_23 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartList')))
    ___TaggedAttribute_attrType_tab_val_Type_24 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartList')))
    ___TaggedAttribute_attrType_tab_val_Type_25 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCPublicationInfo')))
    ___TaggedAttribute_attrType_tab_val_Type_26 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'ModCertTemplate')))
    ___TaggedAttribute_attrType_tab_val_Type_27 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'ControlsProcessed')))
    ___TaggedAttribute_attrType_tab_val_Type_28 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'IdentityProofV2')))
    ___TaggedAttribute_attrType_tab_val_Type_29 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PopLinkWitnessV2')))
    __TaggedAttribute_attrType_tab._val = ASN1Set(rv=[dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 3))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 4))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 18))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 19))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_4), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 21))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_5), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 22))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_6), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 23))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_7), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 2))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_8), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 5))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_9), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 6))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_10), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 7))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_11), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 1))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_12), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 8))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_13), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 9))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_14), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 10))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_15), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 11))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_16), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 15))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_17), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 16))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_18), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 17))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_19), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 24))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_20), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 25))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_21), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 26))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_22), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 27))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_23), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 28))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_24), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 29))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_25), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 30))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_26), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 31))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_27), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 32))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_28), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 33))]), dict([('Type', ___TaggedAttribute_attrType_tab_val_Type_29), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 34))])], rr=[], ev=None, er=[])
    _TaggedAttribute_attrType._const_tab = __TaggedAttribute_attrType_tab
    _TaggedAttribute_attrType._const_tab_at = None
    _TaggedAttribute_attrType._const_tab_id = 'id'
    _TaggedAttribute_attrValues = SET_OF(name='attrValues', mode=MODE_TYPE)
    __TaggedAttribute_attrValues__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL'), ['Type']))
    __TaggedAttribute_attrValues__item_._const_tab = __TaggedAttribute_attrType_tab
    __TaggedAttribute_attrValues__item_._const_tab_at = ('..', '..', 'attrType')
    __TaggedAttribute_attrValues__item_._const_tab_id = 'Type'
    _TaggedAttribute_attrValues._cont = __TaggedAttribute_attrValues__item_
    TaggedAttribute._cont = ASN1Dict([
        ('bodyPartID', _TaggedAttribute_bodyPartID),
        ('attrType', _TaggedAttribute_attrType),
        ('attrValues', _TaggedAttribute_attrValues),
        ])
    TaggedAttribute._ext = None
    
    #-----< Cmc-Control-Set >-----#
    Cmc_Control_Set = CLASS(name='Cmc-Control-Set', mode=MODE_SET, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _Cmc_Control_Set_val_Type_0 = OCT_STR(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_1 = OCT_STR(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_2 = OCT_STR(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_3 = OCT_STR(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_4 = OCT_STR(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_5 = OCT_STR(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_6 = OCT_STR(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_7 = STR_UTF8(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_8 = INT(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_9 = OCT_STR(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_10 = OCT_STR(name='Type', mode=MODE_TYPE)
    _Cmc_Control_Set_val_Type_11 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCStatusInfo')))
    _Cmc_Control_Set_val_Type_12 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'AddExtensions')))
    _Cmc_Control_Set_val_Type_13 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'EncryptedPOP')))
    _Cmc_Control_Set_val_Type_14 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'DecryptedPOP')))
    _Cmc_Control_Set_val_Type_15 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'LraPopWitness')))
    _Cmc_Control_Set_val_Type_16 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'GetCert')))
    _Cmc_Control_Set_val_Type_17 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'GetCRL')))
    _Cmc_Control_Set_val_Type_18 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'RevokeRequest')))
    _Cmc_Control_Set_val_Type_19 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCCertId')))
    _Cmc_Control_Set_val_Type_20 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCStatusInfoV2')))
    _Cmc_Control_Set_val_Type_21 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PublishTrustAnchors')))
    _Cmc_Control_Set_val_Type_22 = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'AuthPublish')))
    _Cmc_Control_Set_val_Type_23 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartList')))
    _Cmc_Control_Set_val_Type_24 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartList')))
    _Cmc_Control_Set_val_Type_25 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCPublicationInfo')))
    _Cmc_Control_Set_val_Type_26 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'ModCertTemplate')))
    _Cmc_Control_Set_val_Type_27 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'ControlsProcessed')))
    _Cmc_Control_Set_val_Type_28 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'IdentityProofV2')))
    _Cmc_Control_Set_val_Type_29 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PopLinkWitnessV2')))
    Cmc_Control_Set._val = ASN1Set(rv=[dict([('Type', _Cmc_Control_Set_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 3))]), dict([('Type', _Cmc_Control_Set_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 4))]), dict([('Type', _Cmc_Control_Set_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 18))]), dict([('Type', _Cmc_Control_Set_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 19))]), dict([('Type', _Cmc_Control_Set_val_Type_4), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 21))]), dict([('Type', _Cmc_Control_Set_val_Type_5), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 22))]), dict([('Type', _Cmc_Control_Set_val_Type_6), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 23))]), dict([('Type', _Cmc_Control_Set_val_Type_7), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 2))]), dict([('Type', _Cmc_Control_Set_val_Type_8), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 5))]), dict([('Type', _Cmc_Control_Set_val_Type_9), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 6))]), dict([('Type', _Cmc_Control_Set_val_Type_10), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 7))]), dict([('Type', _Cmc_Control_Set_val_Type_11), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 1))]), dict([('Type', _Cmc_Control_Set_val_Type_12), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 8))]), dict([('Type', _Cmc_Control_Set_val_Type_13), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 9))]), dict([('Type', _Cmc_Control_Set_val_Type_14), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 10))]), dict([('Type', _Cmc_Control_Set_val_Type_15), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 11))]), dict([('Type', _Cmc_Control_Set_val_Type_16), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 15))]), dict([('Type', _Cmc_Control_Set_val_Type_17), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 16))]), dict([('Type', _Cmc_Control_Set_val_Type_18), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 17))]), dict([('Type', _Cmc_Control_Set_val_Type_19), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 24))]), dict([('Type', _Cmc_Control_Set_val_Type_20), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 25))]), dict([('Type', _Cmc_Control_Set_val_Type_21), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 26))]), dict([('Type', _Cmc_Control_Set_val_Type_22), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 27))]), dict([('Type', _Cmc_Control_Set_val_Type_23), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 28))]), dict([('Type', _Cmc_Control_Set_val_Type_24), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 29))]), dict([('Type', _Cmc_Control_Set_val_Type_25), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 30))]), dict([('Type', _Cmc_Control_Set_val_Type_26), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 31))]), dict([('Type', _Cmc_Control_Set_val_Type_27), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 32))]), dict([('Type', _Cmc_Control_Set_val_Type_28), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 33))]), dict([('Type', _Cmc_Control_Set_val_Type_29), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 34))])], rr=[], ev=[], er=[])
    
    #-----< OTHER-REQUEST >-----#
    OTHER_REQUEST = CLASS(name='OTHER-REQUEST', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< OtherRequests >-----#
    OtherRequests = CLASS(name='OtherRequests', mode=MODE_SET, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'OTHER-REQUEST')))
    OtherRequests._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< TaggedRequest >-----#
    TaggedRequest = CHOICE(name='TaggedRequest', mode=MODE_TYPE)
    _TaggedRequest_tcr = SEQ(name='tcr', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'TaggedCertificationRequest')))
    _TaggedRequest_crm = SEQ(name='crm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'CertReqMsg')))
    _TaggedRequest_orm = SEQ(name='orm', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __TaggedRequest_orm_bodyPartID = INT(name='bodyPartID', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    __TaggedRequest_orm_requestMessageType = OID(name='requestMessageType', mode=MODE_TYPE, typeref=ASN1RefClassField(('EnrollmentMessageSyntax-2009', 'OTHER-REQUEST'), ['id']))
    ___TaggedRequest_orm_requestMessageType_tab = CLASS(name='_tab_OTHER-REQUEST', mode=MODE_SET, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'OTHER-REQUEST')))
    ___TaggedRequest_orm_requestMessageType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TaggedRequest_orm_requestMessageType._const_tab = ___TaggedRequest_orm_requestMessageType_tab
    __TaggedRequest_orm_requestMessageType._const_tab_at = None
    __TaggedRequest_orm_requestMessageType._const_tab_id = 'id'
    __TaggedRequest_orm_requestMessageValue = OPEN(name='requestMessageValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('EnrollmentMessageSyntax-2009', 'OTHER-REQUEST'), ['Type']))
    ___TaggedRequest_orm_requestMessageValue_tab = CLASS(name='_tab_OTHER-REQUEST', mode=MODE_SET, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'OTHER-REQUEST')))
    ___TaggedRequest_orm_requestMessageValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __TaggedRequest_orm_requestMessageValue._const_tab = ___TaggedRequest_orm_requestMessageValue_tab
    __TaggedRequest_orm_requestMessageValue._const_tab_at = ('..', 'requestMessageType')
    __TaggedRequest_orm_requestMessageValue._const_tab_id = 'Type'
    _TaggedRequest_orm._cont = ASN1Dict([
        ('bodyPartID', __TaggedRequest_orm_bodyPartID),
        ('requestMessageType', __TaggedRequest_orm_requestMessageType),
        ('requestMessageValue', __TaggedRequest_orm_requestMessageValue),
        ])
    _TaggedRequest_orm._ext = None
    TaggedRequest._cont = ASN1Dict([
        ('tcr', _TaggedRequest_tcr),
        ('crm', _TaggedRequest_crm),
        ('orm', _TaggedRequest_orm),
        ])
    TaggedRequest._ext = None
    
    #-----< TaggedCertificationRequest >-----#
    TaggedCertificationRequest = SEQ(name='TaggedCertificationRequest', mode=MODE_TYPE)
    _TaggedCertificationRequest_bodyPartID = INT(name='bodyPartID', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _TaggedCertificationRequest_certificationRequest = SEQ(name='certificationRequest', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CertificationRequest')))
    TaggedCertificationRequest._cont = ASN1Dict([
        ('bodyPartID', _TaggedCertificationRequest_bodyPartID),
        ('certificationRequest', _TaggedCertificationRequest_certificationRequest),
        ])
    TaggedCertificationRequest._ext = None
    
    #-----< AttributeList >-----#
    AttributeList = CLASS(name='AttributeList', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _AttributeList_val_Type_0 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'ExtensionReq')))
    AttributeList._val = ASN1Set(rv=[dict([('Type', _AttributeList_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 14))])], rr=[], ev=[], er=[])
    
    #-----< CertificationRequest >-----#
    CertificationRequest = SEQ(name='CertificationRequest', mode=MODE_TYPE)
    _CertificationRequest_certificationRequestInfo = SEQ(name='certificationRequestInfo', mode=MODE_TYPE)
    __CertificationRequest_certificationRequestInfo_version = INT(name='version', mode=MODE_TYPE)
    __CertificationRequest_certificationRequestInfo_subject = CHOICE(name='subject', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    __CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo = SEQ(name='subjectPublicKeyInfo', mode=MODE_TYPE)
    ___CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm = SEQ(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'PUBLIC-KEY'), ['id']))
    _____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab = CLASS(name='_tab_PUBLIC-KEY', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_1 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_2 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_2 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DomainParameters')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_3 = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'KEA-Params-Id')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_4 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_4 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_5 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_5 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_6 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_6 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_7 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_7 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_8 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_8 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    _____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_0), ('Params', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_1), ('Params', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_1), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))]), dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_2), ('Params', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_2), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))]), dict([('id', (2, 16, 840, 1, 101, 2, 1, 1, 22)), ('Params', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_3), ('paramPresence', 'required'), ('keyUsage', (19, 9))])], rr=[], ev=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_4), ('Params', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_4), ('paramPresence', 'required'), ('keyUsage', (103, 7))]), dict([('id', (1, 3, 132, 1, 12)), ('KeyValue', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_5), ('Params', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_5), ('paramPresence', 'required'), ('keyUsage', (19, 9))]), dict([('id', (1, 3, 132, 1, 13)), ('KeyValue', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_6), ('Params', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_6), ('paramPresence', 'required'), ('keyUsage', (19, 9))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_7), ('Params', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_7), ('paramPresence', 'optional'), ('keyUsage', (99, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 7)), ('KeyValue', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_8), ('Params', ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_8), ('paramPresence', 'optional'), ('keyUsage', (3, 4))])], er=[])
    ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm._const_tab = _____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab
    ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm._const_tab_at = None
    ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm._const_tab_id = 'id'
    ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'PUBLIC-KEY'), ['Params']), opt=True)
    ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_parameters._const_tab = _____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab
    ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_parameters._const_tab_at = ('..', 'algorithm')
    ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_parameters._const_tab_id = 'Params'
    ___CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm._cont = ASN1Dict([
        ('algorithm', ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm),
        ('parameters', ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_parameters),
        ])
    ___CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm._ext = None
    ___CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_subjectPublicKey = BIT_STR(name='subjectPublicKey', mode=MODE_TYPE)
    __CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo._cont = ASN1Dict([
        ('algorithm', ___CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm),
        ('subjectPublicKey', ___CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_subjectPublicKey),
        ])
    __CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo._ext = None
    __CertificationRequest_certificationRequestInfo_attributes = SET_OF(name='attributes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CertificationRequest_certificationRequestInfo_attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'AttributeSet')))
    ____CertificationRequest_certificationRequestInfo_attributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    _____CertificationRequest_certificationRequestInfo_attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ______CertificationRequest_certificationRequestInfo_attributes__item__type_tab_val_Type_0 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'ExtensionReq')))
    _____CertificationRequest_certificationRequestInfo_attributes__item__type_tab._val = ASN1Set(rv=[dict([('Type', ______CertificationRequest_certificationRequestInfo_attributes__item__type_tab_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 14))])], rr=[], ev=None, er=[])
    ____CertificationRequest_certificationRequestInfo_attributes__item__type._const_tab = _____CertificationRequest_certificationRequestInfo_attributes__item__type_tab
    ____CertificationRequest_certificationRequestInfo_attributes__item__type._const_tab_at = None
    ____CertificationRequest_certificationRequestInfo_attributes__item__type._const_tab_id = 'id'
    ____CertificationRequest_certificationRequestInfo_attributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    _____CertificationRequest_certificationRequestInfo_attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    _____CertificationRequest_certificationRequestInfo_attributes__item__values__item_._const_tab = _____CertificationRequest_certificationRequestInfo_attributes__item__type_tab
    _____CertificationRequest_certificationRequestInfo_attributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    _____CertificationRequest_certificationRequestInfo_attributes__item__values__item_._const_tab_id = 'Type'
    ____CertificationRequest_certificationRequestInfo_attributes__item__values._cont = _____CertificationRequest_certificationRequestInfo_attributes__item__values__item_
    ____CertificationRequest_certificationRequestInfo_attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ___CertificationRequest_certificationRequestInfo_attributes__item_._cont = ASN1Dict([
        ('type', ____CertificationRequest_certificationRequestInfo_attributes__item__type),
        ('values', ____CertificationRequest_certificationRequestInfo_attributes__item__values),
        ])
    ___CertificationRequest_certificationRequestInfo_attributes__item_._ext = None
    __CertificationRequest_certificationRequestInfo_attributes._cont = ___CertificationRequest_certificationRequestInfo_attributes__item_
    _CertificationRequest_certificationRequestInfo._cont = ASN1Dict([
        ('version', __CertificationRequest_certificationRequestInfo_version),
        ('subject', __CertificationRequest_certificationRequestInfo_subject),
        ('subjectPublicKeyInfo', __CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo),
        ('attributes', __CertificationRequest_certificationRequestInfo_attributes),
        ])
    _CertificationRequest_certificationRequestInfo._ext = None
    _CertificationRequest_signatureAlgorithm = SEQ(name='signatureAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __CertificationRequest_signatureAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___CertificationRequest_signatureAlgorithm_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    __SIGNATURE_ALGORITHM_HashSet_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___CertificationRequest_signatureAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_3), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_4), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_5), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_6), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_7), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_8), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_9), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_10), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __CertificationRequest_signatureAlgorithm_algorithm._const_tab = ___CertificationRequest_signatureAlgorithm_algorithm_tab
    __CertificationRequest_signatureAlgorithm_algorithm._const_tab_at = None
    __CertificationRequest_signatureAlgorithm_algorithm._const_tab_id = 'id'
    __CertificationRequest_signatureAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __CertificationRequest_signatureAlgorithm_parameters._const_tab = ___CertificationRequest_signatureAlgorithm_algorithm_tab
    __CertificationRequest_signatureAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __CertificationRequest_signatureAlgorithm_parameters._const_tab_id = 'Params'
    _CertificationRequest_signatureAlgorithm._cont = ASN1Dict([
        ('algorithm', __CertificationRequest_signatureAlgorithm_algorithm),
        ('parameters', __CertificationRequest_signatureAlgorithm_parameters),
        ])
    _CertificationRequest_signatureAlgorithm._ext = None
    _CertificationRequest_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    CertificationRequest._cont = ASN1Dict([
        ('certificationRequestInfo', _CertificationRequest_certificationRequestInfo),
        ('signatureAlgorithm', _CertificationRequest_signatureAlgorithm),
        ('signature', _CertificationRequest_signature),
        ])
    CertificationRequest._ext = None
    
    #-----< TaggedContentInfo >-----#
    TaggedContentInfo = SEQ(name='TaggedContentInfo', mode=MODE_TYPE)
    _TaggedContentInfo_bodyPartID = INT(name='bodyPartID', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _TaggedContentInfo_contentInfo = SEQ(name='contentInfo', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentInfo')))
    TaggedContentInfo._cont = ASN1Dict([
        ('bodyPartID', _TaggedContentInfo_bodyPartID),
        ('contentInfo', _TaggedContentInfo_contentInfo),
        ])
    TaggedContentInfo._ext = None
    
    #-----< OTHER-MSG >-----#
    OTHER_MSG = CLASS(name='OTHER-MSG', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< OtherMsgSet >-----#
    OtherMsgSet = CLASS(name='OtherMsgSet', mode=MODE_SET, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'OTHER-MSG')))
    OtherMsgSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< OtherMsg >-----#
    OtherMsg = SEQ(name='OtherMsg', mode=MODE_TYPE)
    _OtherMsg_bodyPartID = INT(name='bodyPartID', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _OtherMsg_otherMsgType = OID(name='otherMsgType', mode=MODE_TYPE, typeref=ASN1RefClassField(('EnrollmentMessageSyntax-2009', 'OTHER-MSG'), ['id']))
    __OtherMsg_otherMsgType_tab = CLASS(name='_tab_OTHER-MSG', mode=MODE_SET, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'OTHER-MSG')))
    __OtherMsg_otherMsgType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _OtherMsg_otherMsgType._const_tab = __OtherMsg_otherMsgType_tab
    _OtherMsg_otherMsgType._const_tab_at = None
    _OtherMsg_otherMsgType._const_tab_id = 'id'
    _OtherMsg_otherMsgValue = OPEN(name='otherMsgValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('EnrollmentMessageSyntax-2009', 'OTHER-MSG'), ['Type']))
    __OtherMsg_otherMsgValue_tab = CLASS(name='_tab_OTHER-MSG', mode=MODE_SET, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'OTHER-MSG')))
    __OtherMsg_otherMsgValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _OtherMsg_otherMsgValue._const_tab = __OtherMsg_otherMsgValue_tab
    _OtherMsg_otherMsgValue._const_tab_at = ('..', 'otherMsgType')
    _OtherMsg_otherMsgValue._const_tab_id = 'Type'
    OtherMsg._cont = ASN1Dict([
        ('bodyPartID', _OtherMsg_bodyPartID),
        ('otherMsgType', _OtherMsg_otherMsgType),
        ('otherMsgValue', _OtherMsg_otherMsgValue),
        ])
    OtherMsg._ext = None
    
    #-----< ct-PKIResponse >-----#
    ct_PKIResponse = CLASS(name='ct-PKIResponse', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_PKIResponse_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PKIResponse')))
    ct_PKIResponse._val = dict([('Type', _ct_PKIResponse_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 12, 3))])
    
    #-----< id-cct-PKIResponse >-----#
    id_cct_PKIResponse = OID(name='id-cct-PKIResponse', mode=MODE_VALUE)
    id_cct_PKIResponse._val = (1, 3, 6, 1, 5, 5, 7, 12, 3)
    
    #-----< ResponseBody >-----#
    ResponseBody = SEQ(name='ResponseBody', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PKIResponse')))
    
    #-----< PKIResponse >-----#
    PKIResponse = SEQ(name='PKIResponse', mode=MODE_TYPE)
    _PKIResponse_controlSequence = SEQ_OF(name='controlSequence', mode=MODE_TYPE)
    __PKIResponse_controlSequence__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'TaggedAttribute')))
    _PKIResponse_controlSequence._cont = __PKIResponse_controlSequence__item_
    _PKIResponse_controlSequence._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PKIResponse_cmsSequence = SEQ_OF(name='cmsSequence', mode=MODE_TYPE)
    __PKIResponse_cmsSequence__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'TaggedContentInfo')))
    _PKIResponse_cmsSequence._cont = __PKIResponse_cmsSequence__item_
    _PKIResponse_cmsSequence._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _PKIResponse_otherMsgSequence = SEQ_OF(name='otherMsgSequence', mode=MODE_TYPE)
    __PKIResponse_otherMsgSequence__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'OtherMsg')))
    _PKIResponse_otherMsgSequence._cont = __PKIResponse_otherMsgSequence__item_
    _PKIResponse_otherMsgSequence._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    PKIResponse._cont = ASN1Dict([
        ('controlSequence', _PKIResponse_controlSequence),
        ('cmsSequence', _PKIResponse_cmsSequence),
        ('otherMsgSequence', _PKIResponse_otherMsgSequence),
        ])
    PKIResponse._ext = None
    
    #-----< CMC-CONTROL >-----#
    CMC_CONTROL = CLASS(name='CMC-CONTROL', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< cmc-identityProof >-----#
    cmc_identityProof = CLASS(name='cmc-identityProof', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_identityProof_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    cmc_identityProof._val = dict([('Type', _cmc_identityProof_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 3))])
    
    #-----< id-cmc-identityProof >-----#
    id_cmc_identityProof = OID(name='id-cmc-identityProof', mode=MODE_VALUE)
    id_cmc_identityProof._val = (1, 3, 6, 1, 5, 5, 7, 7, 3)
    
    #-----< cmc-dataReturn >-----#
    cmc_dataReturn = CLASS(name='cmc-dataReturn', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_dataReturn_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    cmc_dataReturn._val = dict([('Type', _cmc_dataReturn_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 4))])
    
    #-----< id-cmc-dataReturn >-----#
    id_cmc_dataReturn = OID(name='id-cmc-dataReturn', mode=MODE_VALUE)
    id_cmc_dataReturn._val = (1, 3, 6, 1, 5, 5, 7, 7, 4)
    
    #-----< cmc-regInfo >-----#
    cmc_regInfo = CLASS(name='cmc-regInfo', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_regInfo_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    cmc_regInfo._val = dict([('Type', _cmc_regInfo_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 18))])
    
    #-----< id-cmc-regInfo >-----#
    id_cmc_regInfo = OID(name='id-cmc-regInfo', mode=MODE_VALUE)
    id_cmc_regInfo._val = (1, 3, 6, 1, 5, 5, 7, 7, 18)
    
    #-----< cmc-responseInfo >-----#
    cmc_responseInfo = CLASS(name='cmc-responseInfo', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_responseInfo_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    cmc_responseInfo._val = dict([('Type', _cmc_responseInfo_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 19))])
    
    #-----< id-cmc-responseInfo >-----#
    id_cmc_responseInfo = OID(name='id-cmc-responseInfo', mode=MODE_VALUE)
    id_cmc_responseInfo._val = (1, 3, 6, 1, 5, 5, 7, 7, 19)
    
    #-----< cmc-queryPending >-----#
    cmc_queryPending = CLASS(name='cmc-queryPending', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_queryPending_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    cmc_queryPending._val = dict([('Type', _cmc_queryPending_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 21))])
    
    #-----< id-cmc-queryPending >-----#
    id_cmc_queryPending = OID(name='id-cmc-queryPending', mode=MODE_VALUE)
    id_cmc_queryPending._val = (1, 3, 6, 1, 5, 5, 7, 7, 21)
    
    #-----< cmc-popLinkRandom >-----#
    cmc_popLinkRandom = CLASS(name='cmc-popLinkRandom', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_popLinkRandom_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    cmc_popLinkRandom._val = dict([('Type', _cmc_popLinkRandom_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 22))])
    
    #-----< id-cmc-popLinkRandom >-----#
    id_cmc_popLinkRandom = OID(name='id-cmc-popLinkRandom', mode=MODE_VALUE)
    id_cmc_popLinkRandom._val = (1, 3, 6, 1, 5, 5, 7, 7, 22)
    
    #-----< cmc-popLinkWitness >-----#
    cmc_popLinkWitness = CLASS(name='cmc-popLinkWitness', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_popLinkWitness_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    cmc_popLinkWitness._val = dict([('Type', _cmc_popLinkWitness_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 23))])
    
    #-----< id-cmc-popLinkWitness >-----#
    id_cmc_popLinkWitness = OID(name='id-cmc-popLinkWitness', mode=MODE_VALUE)
    id_cmc_popLinkWitness._val = (1, 3, 6, 1, 5, 5, 7, 7, 23)
    
    #-----< cmc-identification >-----#
    cmc_identification = CLASS(name='cmc-identification', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_identification_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE)
    cmc_identification._val = dict([('Type', _cmc_identification_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 2))])
    
    #-----< id-cmc-identification >-----#
    id_cmc_identification = OID(name='id-cmc-identification', mode=MODE_VALUE)
    id_cmc_identification._val = (1, 3, 6, 1, 5, 5, 7, 7, 2)
    
    #-----< cmc-transactionId >-----#
    cmc_transactionId = CLASS(name='cmc-transactionId', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_transactionId_val_Type = INT(name='Type', mode=MODE_TYPE)
    cmc_transactionId._val = dict([('Type', _cmc_transactionId_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 5))])
    
    #-----< id-cmc-transactionId >-----#
    id_cmc_transactionId = OID(name='id-cmc-transactionId', mode=MODE_VALUE)
    id_cmc_transactionId._val = (1, 3, 6, 1, 5, 5, 7, 7, 5)
    
    #-----< cmc-senderNonce >-----#
    cmc_senderNonce = CLASS(name='cmc-senderNonce', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_senderNonce_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    cmc_senderNonce._val = dict([('Type', _cmc_senderNonce_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 6))])
    
    #-----< id-cmc-senderNonce >-----#
    id_cmc_senderNonce = OID(name='id-cmc-senderNonce', mode=MODE_VALUE)
    id_cmc_senderNonce._val = (1, 3, 6, 1, 5, 5, 7, 7, 6)
    
    #-----< cmc-recipientNonce >-----#
    cmc_recipientNonce = CLASS(name='cmc-recipientNonce', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_recipientNonce_val_Type = OCT_STR(name='Type', mode=MODE_TYPE)
    cmc_recipientNonce._val = dict([('Type', _cmc_recipientNonce_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 7))])
    
    #-----< id-cmc-recipientNonce >-----#
    id_cmc_recipientNonce = OID(name='id-cmc-recipientNonce', mode=MODE_VALUE)
    id_cmc_recipientNonce._val = (1, 3, 6, 1, 5, 5, 7, 7, 7)
    
    #-----< cmc-statusInfo >-----#
    cmc_statusInfo = CLASS(name='cmc-statusInfo', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_statusInfo_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCStatusInfo')))
    cmc_statusInfo._val = dict([('Type', _cmc_statusInfo_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 1))])
    
    #-----< id-cmc-statusInfo >-----#
    id_cmc_statusInfo = OID(name='id-cmc-statusInfo', mode=MODE_VALUE)
    id_cmc_statusInfo._val = (1, 3, 6, 1, 5, 5, 7, 7, 1)
    
    #-----< CMCStatusInfo >-----#
    CMCStatusInfo = SEQ(name='CMCStatusInfo', mode=MODE_TYPE)
    _CMCStatusInfo_cMCStatus = INT(name='cMCStatus', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCStatus')))
    _CMCStatusInfo_bodyList = SEQ_OF(name='bodyList', mode=MODE_TYPE)
    __CMCStatusInfo_bodyList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _CMCStatusInfo_bodyList._cont = __CMCStatusInfo_bodyList__item_
    _CMCStatusInfo_bodyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _CMCStatusInfo_statusString = STR_UTF8(name='statusString', mode=MODE_TYPE, opt=True)
    _CMCStatusInfo_otherInfo = CHOICE(name='otherInfo', mode=MODE_TYPE, opt=True)
    __CMCStatusInfo_otherInfo_failInfo = INT(name='failInfo', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCFailInfo')))
    __CMCStatusInfo_otherInfo_pendInfo = SEQ(name='pendInfo', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PendInfo')))
    _CMCStatusInfo_otherInfo._cont = ASN1Dict([
        ('failInfo', __CMCStatusInfo_otherInfo_failInfo),
        ('pendInfo', __CMCStatusInfo_otherInfo_pendInfo),
        ])
    _CMCStatusInfo_otherInfo._ext = None
    CMCStatusInfo._cont = ASN1Dict([
        ('cMCStatus', _CMCStatusInfo_cMCStatus),
        ('bodyList', _CMCStatusInfo_bodyList),
        ('statusString', _CMCStatusInfo_statusString),
        ('otherInfo', _CMCStatusInfo_otherInfo),
        ])
    CMCStatusInfo._ext = None
    
    #-----< PendInfo >-----#
    PendInfo = SEQ(name='PendInfo', mode=MODE_TYPE)
    _PendInfo_pendToken = OCT_STR(name='pendToken', mode=MODE_TYPE)
    _PendInfo_pendTime = TIME_GEN(name='pendTime', mode=MODE_TYPE)
    PendInfo._cont = ASN1Dict([
        ('pendToken', _PendInfo_pendToken),
        ('pendTime', _PendInfo_pendTime),
        ])
    PendInfo._ext = None
    
    #-----< CMCStatus >-----#
    CMCStatus = INT(name='CMCStatus', mode=MODE_TYPE)
    CMCStatus._cont = ASN1Dict([('success', 0), ('failed', 2), ('pending', 3), ('noSupport', 4), ('confirmRequired', 5), ('popRequired', 6), ('partial', 7)])
    
    #-----< CMCFailInfo >-----#
    CMCFailInfo = INT(name='CMCFailInfo', mode=MODE_TYPE)
    CMCFailInfo._cont = ASN1Dict([('badAlg', 0), ('badMessageCheck', 1), ('badRequest', 2), ('badTime', 3), ('badCertId', 4), ('unsuportedExt', 5), ('mustArchiveKeys', 6), ('badIdentity', 7), ('popRequired', 8), ('popFailed', 9), ('noKeyReuse', 10), ('internalCAError', 11), ('tryLater', 12), ('authDataFail', 13)])
    
    #-----< cmc-addExtensions >-----#
    cmc_addExtensions = CLASS(name='cmc-addExtensions', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_addExtensions_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'AddExtensions')))
    cmc_addExtensions._val = dict([('Type', _cmc_addExtensions_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 8))])
    
    #-----< id-cmc-addExtensions >-----#
    id_cmc_addExtensions = OID(name='id-cmc-addExtensions', mode=MODE_VALUE)
    id_cmc_addExtensions._val = (1, 3, 6, 1, 5, 5, 7, 7, 8)
    
    #-----< AddExtensions >-----#
    AddExtensions = SEQ(name='AddExtensions', mode=MODE_TYPE)
    _AddExtensions_pkiDataReference = INT(name='pkiDataReference', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _AddExtensions_certReferences = SEQ_OF(name='certReferences', mode=MODE_TYPE)
    __AddExtensions_certReferences__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _AddExtensions_certReferences._cont = __AddExtensions_certReferences__item_
    _AddExtensions_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE)
    __AddExtensions_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___AddExtensions_extensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____AddExtensions_extensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_0 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityKeyIdentifier')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_1 = OCT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyIdentifier')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_2 = BIT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyUsage')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_3 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PrivateKeyUsagePeriod')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_4 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CertificatePolicies')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_5 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyMappings')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_6 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_7 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_8 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectDirectoryAttributes')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_9 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'BasicConstraints')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_10 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'NameConstraints')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_11 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyConstraints')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_12 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'ExtKeyUsageSyntax')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_13 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_14 = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SkipCerts')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_15 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_16 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityInfoAccessSyntax')))
    _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_17 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectInfoAccessSyntax')))
    ____AddExtensions_extensions__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_0), ('id', (2, 5, 29, 35))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_1), ('id', (2, 5, 29, 14))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_2), ('id', (2, 5, 29, 15))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_3), ('id', (2, 5, 29, 16))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_4), ('id', (2, 5, 29, 32))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_5), ('id', (2, 5, 29, 33))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_6), ('id', (2, 5, 29, 17))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_7), ('id', (2, 5, 29, 18))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_8), ('id', (2, 5, 29, 9))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_9), ('id', (2, 5, 29, 19))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_10), ('id', (2, 5, 29, 30))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_11), ('id', (2, 5, 29, 36))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_12), ('id', (2, 5, 29, 37))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_13), ('id', (2, 5, 29, 31))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_14), ('id', (2, 5, 29, 54))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_15), ('id', (2, 5, 29, 46))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_16), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 1))]), dict([('ExtnType', _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_17), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 11))])], rr=[], ev=None, er=[])
    ___AddExtensions_extensions__item__extnID._const_tab = ____AddExtensions_extensions__item__extnID_tab
    ___AddExtensions_extensions__item__extnID._const_tab_at = None
    ___AddExtensions_extensions__item__extnID._const_tab_id = 'id'
    ___AddExtensions_extensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___AddExtensions_extensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____AddExtensions_extensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ____AddExtensions_extensions__item__extnValue_contain._const_tab = ____AddExtensions_extensions__item__extnID_tab
    ____AddExtensions_extensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____AddExtensions_extensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___AddExtensions_extensions__item__extnValue._const_cont = ____AddExtensions_extensions__item__extnValue_contain
    __AddExtensions_extensions__item_._cont = ASN1Dict([
        ('extnID', ___AddExtensions_extensions__item__extnID),
        ('critical', ___AddExtensions_extensions__item__critical),
        ('extnValue', ___AddExtensions_extensions__item__extnValue),
        ])
    __AddExtensions_extensions__item_._ext = None
    _AddExtensions_extensions._cont = __AddExtensions_extensions__item_
    AddExtensions._cont = ASN1Dict([
        ('pkiDataReference', _AddExtensions_pkiDataReference),
        ('certReferences', _AddExtensions_certReferences),
        ('extensions', _AddExtensions_extensions),
        ])
    AddExtensions._ext = None
    
    #-----< cmc-encryptedPOP >-----#
    cmc_encryptedPOP = CLASS(name='cmc-encryptedPOP', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_encryptedPOP_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'EncryptedPOP')))
    cmc_encryptedPOP._val = dict([('Type', _cmc_encryptedPOP_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 9))])
    
    #-----< cmc-decryptedPOP >-----#
    cmc_decryptedPOP = CLASS(name='cmc-decryptedPOP', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_decryptedPOP_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'DecryptedPOP')))
    cmc_decryptedPOP._val = dict([('Type', _cmc_decryptedPOP_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 10))])
    
    #-----< id-cmc-encryptedPOP >-----#
    id_cmc_encryptedPOP = OID(name='id-cmc-encryptedPOP', mode=MODE_VALUE)
    id_cmc_encryptedPOP._val = (1, 3, 6, 1, 5, 5, 7, 7, 9)
    
    #-----< id-cmc-decryptedPOP >-----#
    id_cmc_decryptedPOP = OID(name='id-cmc-decryptedPOP', mode=MODE_VALUE)
    id_cmc_decryptedPOP._val = (1, 3, 6, 1, 5, 5, 7, 7, 10)
    
    #-----< EncryptedPOP >-----#
    EncryptedPOP = SEQ(name='EncryptedPOP', mode=MODE_TYPE)
    _EncryptedPOP_request = CHOICE(name='request', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'TaggedRequest')))
    _EncryptedPOP_cms = SEQ(name='cms', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentInfo')))
    _EncryptedPOP_thePOPAlgID = SEQ(name='thePOPAlgID', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __EncryptedPOP_thePOPAlgID_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['id']))
    ___EncryptedPOP_thePOPAlgID_algorithm_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ____EncryptedPOP_thePOPAlgID_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___EncryptedPOP_thePOPAlgID_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', ____EncryptedPOP_thePOPAlgID_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])], rr=[], ev=None, er=[])
    __EncryptedPOP_thePOPAlgID_algorithm._const_tab = ___EncryptedPOP_thePOPAlgID_algorithm_tab
    __EncryptedPOP_thePOPAlgID_algorithm._const_tab_at = None
    __EncryptedPOP_thePOPAlgID_algorithm._const_tab_id = 'id'
    __EncryptedPOP_thePOPAlgID_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['Params']), opt=True)
    __EncryptedPOP_thePOPAlgID_parameters._const_tab = ___EncryptedPOP_thePOPAlgID_algorithm_tab
    __EncryptedPOP_thePOPAlgID_parameters._const_tab_at = ('..', 'algorithm')
    __EncryptedPOP_thePOPAlgID_parameters._const_tab_id = 'Params'
    _EncryptedPOP_thePOPAlgID._cont = ASN1Dict([
        ('algorithm', __EncryptedPOP_thePOPAlgID_algorithm),
        ('parameters', __EncryptedPOP_thePOPAlgID_parameters),
        ])
    _EncryptedPOP_thePOPAlgID._ext = None
    _EncryptedPOP_witnessAlgID = SEQ(name='witnessAlgID', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __EncryptedPOP_witnessAlgID_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___EncryptedPOP_witnessAlgID_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ____EncryptedPOP_witnessAlgID_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___EncryptedPOP_witnessAlgID_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', ____EncryptedPOP_witnessAlgID_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])
    __EncryptedPOP_witnessAlgID_algorithm._const_tab = ___EncryptedPOP_witnessAlgID_algorithm_tab
    __EncryptedPOP_witnessAlgID_algorithm._const_tab_at = None
    __EncryptedPOP_witnessAlgID_algorithm._const_tab_id = 'id'
    __EncryptedPOP_witnessAlgID_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    __EncryptedPOP_witnessAlgID_parameters._const_tab = ___EncryptedPOP_witnessAlgID_algorithm_tab
    __EncryptedPOP_witnessAlgID_parameters._const_tab_at = ('..', 'algorithm')
    __EncryptedPOP_witnessAlgID_parameters._const_tab_id = 'Params'
    _EncryptedPOP_witnessAlgID._cont = ASN1Dict([
        ('algorithm', __EncryptedPOP_witnessAlgID_algorithm),
        ('parameters', __EncryptedPOP_witnessAlgID_parameters),
        ])
    _EncryptedPOP_witnessAlgID._ext = None
    _EncryptedPOP_witness = OCT_STR(name='witness', mode=MODE_TYPE)
    EncryptedPOP._cont = ASN1Dict([
        ('request', _EncryptedPOP_request),
        ('cms', _EncryptedPOP_cms),
        ('thePOPAlgID', _EncryptedPOP_thePOPAlgID),
        ('witnessAlgID', _EncryptedPOP_witnessAlgID),
        ('witness', _EncryptedPOP_witness),
        ])
    EncryptedPOP._ext = None
    
    #-----< POPAlgs >-----#
    POPAlgs = CLASS(name='POPAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    _POPAlgs_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    POPAlgs._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', _POPAlgs_val_Params_0), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])], rr=[], ev=[], er=[])
    
    #-----< WitnessAlgs >-----#
    WitnessAlgs = CLASS(name='WitnessAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _WitnessAlgs_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    WitnessAlgs._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', _WitnessAlgs_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=[], er=[])
    
    #-----< DecryptedPOP >-----#
    DecryptedPOP = SEQ(name='DecryptedPOP', mode=MODE_TYPE)
    _DecryptedPOP_bodyPartID = INT(name='bodyPartID', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _DecryptedPOP_thePOPAlgID = SEQ(name='thePOPAlgID', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __DecryptedPOP_thePOPAlgID_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['id']))
    ___DecryptedPOP_thePOPAlgID_algorithm_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ____DecryptedPOP_thePOPAlgID_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___DecryptedPOP_thePOPAlgID_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', ____DecryptedPOP_thePOPAlgID_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])], rr=[], ev=None, er=[])
    __DecryptedPOP_thePOPAlgID_algorithm._const_tab = ___DecryptedPOP_thePOPAlgID_algorithm_tab
    __DecryptedPOP_thePOPAlgID_algorithm._const_tab_at = None
    __DecryptedPOP_thePOPAlgID_algorithm._const_tab_id = 'id'
    __DecryptedPOP_thePOPAlgID_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['Params']), opt=True)
    __DecryptedPOP_thePOPAlgID_parameters._const_tab = ___DecryptedPOP_thePOPAlgID_algorithm_tab
    __DecryptedPOP_thePOPAlgID_parameters._const_tab_at = ('..', 'algorithm')
    __DecryptedPOP_thePOPAlgID_parameters._const_tab_id = 'Params'
    _DecryptedPOP_thePOPAlgID._cont = ASN1Dict([
        ('algorithm', __DecryptedPOP_thePOPAlgID_algorithm),
        ('parameters', __DecryptedPOP_thePOPAlgID_parameters),
        ])
    _DecryptedPOP_thePOPAlgID._ext = None
    _DecryptedPOP_thePOP = OCT_STR(name='thePOP', mode=MODE_TYPE)
    DecryptedPOP._cont = ASN1Dict([
        ('bodyPartID', _DecryptedPOP_bodyPartID),
        ('thePOPAlgID', _DecryptedPOP_thePOPAlgID),
        ('thePOP', _DecryptedPOP_thePOP),
        ])
    DecryptedPOP._ext = None
    
    #-----< cmc-lraPOPWitness >-----#
    cmc_lraPOPWitness = CLASS(name='cmc-lraPOPWitness', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_lraPOPWitness_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'LraPopWitness')))
    cmc_lraPOPWitness._val = dict([('Type', _cmc_lraPOPWitness_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 11))])
    
    #-----< id-cmc-lraPOPWitness >-----#
    id_cmc_lraPOPWitness = OID(name='id-cmc-lraPOPWitness', mode=MODE_VALUE)
    id_cmc_lraPOPWitness._val = (1, 3, 6, 1, 5, 5, 7, 7, 11)
    
    #-----< LraPopWitness >-----#
    LraPopWitness = SEQ(name='LraPopWitness', mode=MODE_TYPE)
    _LraPopWitness_pkiDataBodyid = INT(name='pkiDataBodyid', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _LraPopWitness_bodyIds = SEQ_OF(name='bodyIds', mode=MODE_TYPE)
    __LraPopWitness_bodyIds__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _LraPopWitness_bodyIds._cont = __LraPopWitness_bodyIds__item_
    LraPopWitness._cont = ASN1Dict([
        ('pkiDataBodyid', _LraPopWitness_pkiDataBodyid),
        ('bodyIds', _LraPopWitness_bodyIds),
        ])
    LraPopWitness._ext = None
    
    #-----< cmc-getCert >-----#
    cmc_getCert = CLASS(name='cmc-getCert', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_getCert_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'GetCert')))
    cmc_getCert._val = dict([('Type', _cmc_getCert_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 15))])
    
    #-----< id-cmc-getCert >-----#
    id_cmc_getCert = OID(name='id-cmc-getCert', mode=MODE_VALUE)
    id_cmc_getCert._val = (1, 3, 6, 1, 5, 5, 7, 7, 15)
    
    #-----< GetCert >-----#
    GetCert = SEQ(name='GetCert', mode=MODE_TYPE)
    _GetCert_issuerName = CHOICE(name='issuerName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _GetCert_serialNumber = INT(name='serialNumber', mode=MODE_TYPE)
    GetCert._cont = ASN1Dict([
        ('issuerName', _GetCert_issuerName),
        ('serialNumber', _GetCert_serialNumber),
        ])
    GetCert._ext = None
    
    #-----< cmc-getCRL >-----#
    cmc_getCRL = CLASS(name='cmc-getCRL', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_getCRL_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'GetCRL')))
    cmc_getCRL._val = dict([('Type', _cmc_getCRL_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 16))])
    
    #-----< id-cmc-getCRL >-----#
    id_cmc_getCRL = OID(name='id-cmc-getCRL', mode=MODE_VALUE)
    id_cmc_getCRL._val = (1, 3, 6, 1, 5, 5, 7, 7, 16)
    
    #-----< GetCRL >-----#
    GetCRL = SEQ(name='GetCRL', mode=MODE_TYPE)
    _GetCRL_issuerName = CHOICE(name='issuerName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    _GetCRL_cRLName = CHOICE(name='cRLName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')), opt=True)
    _GetCRL_time = TIME_GEN(name='time', mode=MODE_TYPE, opt=True)
    _GetCRL_reasons = BIT_STR(name='reasons', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'ReasonFlags')), opt=True)
    GetCRL._cont = ASN1Dict([
        ('issuerName', _GetCRL_issuerName),
        ('cRLName', _GetCRL_cRLName),
        ('time', _GetCRL_time),
        ('reasons', _GetCRL_reasons),
        ])
    GetCRL._ext = None
    
    #-----< cmc-revokeRequest >-----#
    cmc_revokeRequest = CLASS(name='cmc-revokeRequest', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_revokeRequest_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'RevokeRequest')))
    cmc_revokeRequest._val = dict([('Type', _cmc_revokeRequest_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 17))])
    
    #-----< id-cmc-revokeRequest >-----#
    id_cmc_revokeRequest = OID(name='id-cmc-revokeRequest', mode=MODE_VALUE)
    id_cmc_revokeRequest._val = (1, 3, 6, 1, 5, 5, 7, 7, 17)
    
    #-----< RevokeRequest >-----#
    RevokeRequest = SEQ(name='RevokeRequest', mode=MODE_TYPE)
    _RevokeRequest_issuerName = CHOICE(name='issuerName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    _RevokeRequest_serialNumber = INT(name='serialNumber', mode=MODE_TYPE)
    _RevokeRequest_reason = ENUM(name='reason', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLReason')))
    _RevokeRequest_invalidityDate = TIME_GEN(name='invalidityDate', mode=MODE_TYPE, opt=True)
    _RevokeRequest_passphrase = OCT_STR(name='passphrase', mode=MODE_TYPE, opt=True)
    _RevokeRequest_comment = STR_UTF8(name='comment', mode=MODE_TYPE, opt=True)
    RevokeRequest._cont = ASN1Dict([
        ('issuerName', _RevokeRequest_issuerName),
        ('serialNumber', _RevokeRequest_serialNumber),
        ('reason', _RevokeRequest_reason),
        ('invalidityDate', _RevokeRequest_invalidityDate),
        ('passphrase', _RevokeRequest_passphrase),
        ('comment', _RevokeRequest_comment),
        ])
    RevokeRequest._ext = None
    
    #-----< cmc-confirmCertAcceptance >-----#
    cmc_confirmCertAcceptance = CLASS(name='cmc-confirmCertAcceptance', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_confirmCertAcceptance_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCCertId')))
    cmc_confirmCertAcceptance._val = dict([('Type', _cmc_confirmCertAcceptance_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 24))])
    
    #-----< id-cmc-confirmCertAcceptance >-----#
    id_cmc_confirmCertAcceptance = OID(name='id-cmc-confirmCertAcceptance', mode=MODE_VALUE)
    id_cmc_confirmCertAcceptance._val = (1, 3, 6, 1, 5, 5, 7, 7, 24)
    
    #-----< CMCCertId >-----#
    CMCCertId = SEQ(name='CMCCertId', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'IssuerAndSerialNumber')))
    
    #-----< at-extension-req >-----#
    at_extension_req = CLASS(name='at-extension-req', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_extension_req_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'ExtensionReq')))
    at_extension_req._val = dict([('Type', _at_extension_req_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 14))])
    
    #-----< id-ExtensionReq >-----#
    id_ExtensionReq = OID(name='id-ExtensionReq', mode=MODE_VALUE)
    id_ExtensionReq._val = (1, 2, 840, 113549, 1, 9, 14)
    
    #-----< ExtensionReq >-----#
    ExtensionReq = SEQ_OF(name='ExtensionReq', mode=MODE_TYPE)
    _ExtensionReq__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    __ExtensionReq__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ___ExtensionReq__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_0 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityKeyIdentifier')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_1 = OCT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyIdentifier')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_2 = BIT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyUsage')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_3 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PrivateKeyUsagePeriod')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_4 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CertificatePolicies')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_5 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyMappings')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_6 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_7 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_8 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectDirectoryAttributes')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_9 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'BasicConstraints')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_10 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'NameConstraints')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_11 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyConstraints')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_12 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'ExtKeyUsageSyntax')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_13 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_14 = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SkipCerts')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_15 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_16 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityInfoAccessSyntax')))
    ____ExtensionReq__item__extnID_tab_val_ExtnType_17 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectInfoAccessSyntax')))
    ___ExtensionReq__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_0), ('id', (2, 5, 29, 35))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_1), ('id', (2, 5, 29, 14))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_2), ('id', (2, 5, 29, 15))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_3), ('id', (2, 5, 29, 16))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_4), ('id', (2, 5, 29, 32))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_5), ('id', (2, 5, 29, 33))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_6), ('id', (2, 5, 29, 17))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_7), ('id', (2, 5, 29, 18))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_8), ('id', (2, 5, 29, 9))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_9), ('id', (2, 5, 29, 19))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_10), ('id', (2, 5, 29, 30))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_11), ('id', (2, 5, 29, 36))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_12), ('id', (2, 5, 29, 37))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_13), ('id', (2, 5, 29, 31))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_14), ('id', (2, 5, 29, 54))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_15), ('id', (2, 5, 29, 46))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_16), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 1))]), dict([('ExtnType', ____ExtensionReq__item__extnID_tab_val_ExtnType_17), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 11))])], rr=[], ev=None, er=[])
    __ExtensionReq__item__extnID._const_tab = ___ExtensionReq__item__extnID_tab
    __ExtensionReq__item__extnID._const_tab_at = None
    __ExtensionReq__item__extnID._const_tab_id = 'id'
    __ExtensionReq__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    __ExtensionReq__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ___ExtensionReq__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ___ExtensionReq__item__extnValue_contain._const_tab = ___ExtensionReq__item__extnID_tab
    ___ExtensionReq__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ___ExtensionReq__item__extnValue_contain._const_tab_id = 'ExtnType'
    __ExtensionReq__item__extnValue._const_cont = ___ExtensionReq__item__extnValue_contain
    _ExtensionReq__item_._cont = ASN1Dict([
        ('extnID', __ExtensionReq__item__extnID),
        ('critical', __ExtensionReq__item__critical),
        ('extnValue', __ExtensionReq__item__extnValue),
        ])
    _ExtensionReq__item_._ext = None
    ExtensionReq._cont = _ExtensionReq__item_
    ExtensionReq._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< sa-noSignature >-----#
    sa_noSignature = CLASS(name='sa-noSignature', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_noSignature_val_Value = OCT_STR(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'NoSignatureValue')))
    _sa_noSignature_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_noSignature._val = dict([('id', (1, 3, 6, 1, 5, 5, 7, 6, 2)), ('Value', _sa_noSignature_val_Value), ('Params', _sa_noSignature_val_Params), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[]))])
    
    #-----< id-alg-noSignature >-----#
    id_alg_noSignature = OID(name='id-alg-noSignature', mode=MODE_VALUE)
    id_alg_noSignature._val = (1, 3, 6, 1, 5, 5, 7, 6, 2)
    
    #-----< NoSignatureValue >-----#
    NoSignatureValue = OCT_STR(name='NoSignatureValue', mode=MODE_TYPE)
    
    #-----< id-aa >-----#
    id_aa = OID(name='id-aa', mode=MODE_VALUE)
    id_aa._val = (1, 2, 840, 113549, 1, 9, 16, 2)
    
    #-----< aa-cmc-unsignedData >-----#
    aa_cmc_unsignedData = CLASS(name='aa-cmc-unsignedData', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _aa_cmc_unsignedData_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCUnsignedData')))
    aa_cmc_unsignedData._val = dict([('Type', _aa_cmc_unsignedData_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 2, 34))])
    
    #-----< id-aa-cmc-unsignedData >-----#
    id_aa_cmc_unsignedData = OID(name='id-aa-cmc-unsignedData', mode=MODE_VALUE)
    id_aa_cmc_unsignedData._val = (1, 2, 840, 113549, 1, 9, 16, 2, 34)
    
    #-----< CMCUnsignedData >-----#
    CMCUnsignedData = SEQ(name='CMCUnsignedData', mode=MODE_TYPE)
    _CMCUnsignedData_bodyPartPath = SEQ_OF(name='bodyPartPath', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartPath')))
    _CMCUnsignedData_identifier = OID(name='identifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['id']))
    _CMCUnsignedData_content = OPEN(name='content', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['Type']))
    CMCUnsignedData._cont = ASN1Dict([
        ('bodyPartPath', _CMCUnsignedData_bodyPartPath),
        ('identifier', _CMCUnsignedData_identifier),
        ('content', _CMCUnsignedData_content),
        ])
    CMCUnsignedData._ext = None
    
    #-----< cmc-statusInfoV2 >-----#
    cmc_statusInfoV2 = CLASS(name='cmc-statusInfoV2', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_statusInfoV2_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCStatusInfoV2')))
    cmc_statusInfoV2._val = dict([('Type', _cmc_statusInfoV2_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 25))])
    
    #-----< id-cmc-statusInfoV2 >-----#
    id_cmc_statusInfoV2 = OID(name='id-cmc-statusInfoV2', mode=MODE_VALUE)
    id_cmc_statusInfoV2._val = (1, 3, 6, 1, 5, 5, 7, 7, 25)
    
    #-----< EXTENDED-FAILURE-INFO >-----#
    EXTENDED_FAILURE_INFO = CLASS(name='EXTENDED-FAILURE-INFO', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< ExtendedFailures >-----#
    ExtendedFailures = CLASS(name='ExtendedFailures', mode=MODE_SET, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'EXTENDED-FAILURE-INFO')))
    ExtendedFailures._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CMCStatusInfoV2 >-----#
    CMCStatusInfoV2 = SEQ(name='CMCStatusInfoV2', mode=MODE_TYPE)
    _CMCStatusInfoV2_cMCStatus = INT(name='cMCStatus', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCStatus')))
    _CMCStatusInfoV2_bodyList = SEQ_OF(name='bodyList', mode=MODE_TYPE)
    __CMCStatusInfoV2_bodyList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartReference')))
    _CMCStatusInfoV2_bodyList._cont = __CMCStatusInfoV2_bodyList__item_
    _CMCStatusInfoV2_bodyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _CMCStatusInfoV2_statusString = STR_UTF8(name='statusString', mode=MODE_TYPE, opt=True)
    _CMCStatusInfoV2_otherInfo = CHOICE(name='otherInfo', mode=MODE_TYPE, opt=True)
    __CMCStatusInfoV2_otherInfo_failInfo = INT(name='failInfo', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCFailInfo')))
    __CMCStatusInfoV2_otherInfo_pendInfo = SEQ(name='pendInfo', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PendInfo')))
    __CMCStatusInfoV2_otherInfo_extendedFailInfo = SEQ(name='extendedFailInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID = OID(name='failInfoOID', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['id']))
    ____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab = CLASS(name='TYPE-IDENTIFIER', mode=MODE_SET)
    _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab_Type = OPEN(name='Type', mode=MODE_TYPE)
    ____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab._cont = ASN1Dict([
        ('id', _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab_id),
        ('Type', _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab_Type),
        ])
    ____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID._const_tab = ____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab
    ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID._const_tab_at = None
    ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID._const_tab_id = 'id'
    ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue = OPEN(name='failInfoValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('_IMPL_', 'TYPE-IDENTIFIER'), ['Type']))
    ____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab = CLASS(name='TYPE-IDENTIFIER', mode=MODE_SET)
    _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab_Type = OPEN(name='Type', mode=MODE_TYPE)
    ____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab._cont = ASN1Dict([
        ('id', _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab_id),
        ('Type', _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab_Type),
        ])
    ____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue._const_tab = ____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab
    ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue._const_tab_at = ('..', 'failInfoOID')
    ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue._const_tab_id = 'Type'
    __CMCStatusInfoV2_otherInfo_extendedFailInfo._cont = ASN1Dict([
        ('failInfoOID', ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID),
        ('failInfoValue', ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue),
        ])
    __CMCStatusInfoV2_otherInfo_extendedFailInfo._ext = None
    _CMCStatusInfoV2_otherInfo._cont = ASN1Dict([
        ('failInfo', __CMCStatusInfoV2_otherInfo_failInfo),
        ('pendInfo', __CMCStatusInfoV2_otherInfo_pendInfo),
        ('extendedFailInfo', __CMCStatusInfoV2_otherInfo_extendedFailInfo),
        ])
    _CMCStatusInfoV2_otherInfo._ext = None
    CMCStatusInfoV2._cont = ASN1Dict([
        ('cMCStatus', _CMCStatusInfoV2_cMCStatus),
        ('bodyList', _CMCStatusInfoV2_bodyList),
        ('statusString', _CMCStatusInfoV2_statusString),
        ('otherInfo', _CMCStatusInfoV2_otherInfo),
        ])
    CMCStatusInfoV2._ext = None
    
    #-----< BodyPartReference >-----#
    BodyPartReference = CHOICE(name='BodyPartReference', mode=MODE_TYPE)
    _BodyPartReference_bodyPartID = INT(name='bodyPartID', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    _BodyPartReference_bodyPartPath = SEQ_OF(name='bodyPartPath', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartPath')))
    BodyPartReference._cont = ASN1Dict([
        ('bodyPartID', _BodyPartReference_bodyPartID),
        ('bodyPartPath', _BodyPartReference_bodyPartPath),
        ])
    BodyPartReference._ext = None
    
    #-----< BodyPartPath >-----#
    BodyPartPath = SEQ_OF(name='BodyPartPath', mode=MODE_TYPE)
    _BodyPartPath__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    BodyPartPath._cont = _BodyPartPath__item_
    BodyPartPath._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< cmc-trustedAnchors >-----#
    cmc_trustedAnchors = CLASS(name='cmc-trustedAnchors', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_trustedAnchors_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PublishTrustAnchors')))
    cmc_trustedAnchors._val = dict([('Type', _cmc_trustedAnchors_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 26))])
    
    #-----< id-cmc-trustedAnchors >-----#
    id_cmc_trustedAnchors = OID(name='id-cmc-trustedAnchors', mode=MODE_VALUE)
    id_cmc_trustedAnchors._val = (1, 3, 6, 1, 5, 5, 7, 7, 26)
    
    #-----< PublishTrustAnchors >-----#
    PublishTrustAnchors = SEQ(name='PublishTrustAnchors', mode=MODE_TYPE)
    _PublishTrustAnchors_seqNumber = INT(name='seqNumber', mode=MODE_TYPE)
    _PublishTrustAnchors_hashAlgorithm = SEQ(name='hashAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __PublishTrustAnchors_hashAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___PublishTrustAnchors_hashAlgorithm_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ____PublishTrustAnchors_hashAlgorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____PublishTrustAnchors_hashAlgorithm_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ___PublishTrustAnchors_hashAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', ____PublishTrustAnchors_hashAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', ____PublishTrustAnchors_hashAlgorithm_algorithm_tab_val_Params_1), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])
    __PublishTrustAnchors_hashAlgorithm_algorithm._const_tab = ___PublishTrustAnchors_hashAlgorithm_algorithm_tab
    __PublishTrustAnchors_hashAlgorithm_algorithm._const_tab_at = None
    __PublishTrustAnchors_hashAlgorithm_algorithm._const_tab_id = 'id'
    __PublishTrustAnchors_hashAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    __PublishTrustAnchors_hashAlgorithm_parameters._const_tab = ___PublishTrustAnchors_hashAlgorithm_algorithm_tab
    __PublishTrustAnchors_hashAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __PublishTrustAnchors_hashAlgorithm_parameters._const_tab_id = 'Params'
    _PublishTrustAnchors_hashAlgorithm._cont = ASN1Dict([
        ('algorithm', __PublishTrustAnchors_hashAlgorithm_algorithm),
        ('parameters', __PublishTrustAnchors_hashAlgorithm_parameters),
        ])
    _PublishTrustAnchors_hashAlgorithm._ext = None
    _PublishTrustAnchors_anchorHashes = SEQ_OF(name='anchorHashes', mode=MODE_TYPE)
    __PublishTrustAnchors_anchorHashes__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _PublishTrustAnchors_anchorHashes._cont = __PublishTrustAnchors_anchorHashes__item_
    PublishTrustAnchors._cont = ASN1Dict([
        ('seqNumber', _PublishTrustAnchors_seqNumber),
        ('hashAlgorithm', _PublishTrustAnchors_hashAlgorithm),
        ('anchorHashes', _PublishTrustAnchors_anchorHashes),
        ])
    PublishTrustAnchors._ext = None
    
    #-----< HashAlgorithms >-----#
    HashAlgorithms = CLASS(name='HashAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _HashAlgorithms_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _HashAlgorithms_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    HashAlgorithms._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', _HashAlgorithms_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', _HashAlgorithms_val_Params_1), ('paramPresence', 'preferredAbsent')])], rr=[], ev=[], er=[])
    
    #-----< cmc-authData >-----#
    cmc_authData = CLASS(name='cmc-authData', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_authData_val_Type = INT(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'AuthPublish')))
    cmc_authData._val = dict([('Type', _cmc_authData_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 27))])
    
    #-----< id-cmc-authData >-----#
    id_cmc_authData = OID(name='id-cmc-authData', mode=MODE_VALUE)
    id_cmc_authData._val = (1, 3, 6, 1, 5, 5, 7, 7, 27)
    
    #-----< AuthPublish >-----#
    AuthPublish = INT(name='AuthPublish', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    
    #-----< cmc-batchRequests >-----#
    cmc_batchRequests = CLASS(name='cmc-batchRequests', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_batchRequests_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartList')))
    cmc_batchRequests._val = dict([('Type', _cmc_batchRequests_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 28))])
    
    #-----< id-cmc-batchRequests >-----#
    id_cmc_batchRequests = OID(name='id-cmc-batchRequests', mode=MODE_VALUE)
    id_cmc_batchRequests._val = (1, 3, 6, 1, 5, 5, 7, 7, 28)
    
    #-----< cmc-batchResponses >-----#
    cmc_batchResponses = CLASS(name='cmc-batchResponses', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_batchResponses_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartList')))
    cmc_batchResponses._val = dict([('Type', _cmc_batchResponses_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 29))])
    
    #-----< id-cmc-batchResponses >-----#
    id_cmc_batchResponses = OID(name='id-cmc-batchResponses', mode=MODE_VALUE)
    id_cmc_batchResponses._val = (1, 3, 6, 1, 5, 5, 7, 7, 29)
    
    #-----< BodyPartList >-----#
    BodyPartList = SEQ_OF(name='BodyPartList', mode=MODE_TYPE)
    _BodyPartList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartID')))
    BodyPartList._cont = _BodyPartList__item_
    BodyPartList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< cmc-publishCert >-----#
    cmc_publishCert = CLASS(name='cmc-publishCert', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_publishCert_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMCPublicationInfo')))
    cmc_publishCert._val = dict([('Type', _cmc_publishCert_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 30))])
    
    #-----< id-cmc-publishCert >-----#
    id_cmc_publishCert = OID(name='id-cmc-publishCert', mode=MODE_VALUE)
    id_cmc_publishCert._val = (1, 3, 6, 1, 5, 5, 7, 7, 30)
    
    #-----< CMCPublicationInfo >-----#
    CMCPublicationInfo = SEQ(name='CMCPublicationInfo', mode=MODE_TYPE)
    _CMCPublicationInfo_hashAlg = SEQ(name='hashAlg', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __CMCPublicationInfo_hashAlg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___CMCPublicationInfo_hashAlg_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ____CMCPublicationInfo_hashAlg_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____CMCPublicationInfo_hashAlg_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ___CMCPublicationInfo_hashAlg_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', ____CMCPublicationInfo_hashAlg_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', ____CMCPublicationInfo_hashAlg_algorithm_tab_val_Params_1), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])
    __CMCPublicationInfo_hashAlg_algorithm._const_tab = ___CMCPublicationInfo_hashAlg_algorithm_tab
    __CMCPublicationInfo_hashAlg_algorithm._const_tab_at = None
    __CMCPublicationInfo_hashAlg_algorithm._const_tab_id = 'id'
    __CMCPublicationInfo_hashAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    __CMCPublicationInfo_hashAlg_parameters._const_tab = ___CMCPublicationInfo_hashAlg_algorithm_tab
    __CMCPublicationInfo_hashAlg_parameters._const_tab_at = ('..', 'algorithm')
    __CMCPublicationInfo_hashAlg_parameters._const_tab_id = 'Params'
    _CMCPublicationInfo_hashAlg._cont = ASN1Dict([
        ('algorithm', __CMCPublicationInfo_hashAlg_algorithm),
        ('parameters', __CMCPublicationInfo_hashAlg_parameters),
        ])
    _CMCPublicationInfo_hashAlg._ext = None
    _CMCPublicationInfo_certHashes = SEQ_OF(name='certHashes', mode=MODE_TYPE)
    __CMCPublicationInfo_certHashes__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _CMCPublicationInfo_certHashes._cont = __CMCPublicationInfo_certHashes__item_
    _CMCPublicationInfo_pubInfo = SEQ(name='pubInfo', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PKIPublicationInfo')))
    CMCPublicationInfo._cont = ASN1Dict([
        ('hashAlg', _CMCPublicationInfo_hashAlg),
        ('certHashes', _CMCPublicationInfo_certHashes),
        ('pubInfo', _CMCPublicationInfo_pubInfo),
        ])
    CMCPublicationInfo._ext = None
    
    #-----< cmc-modCertTemplate >-----#
    cmc_modCertTemplate = CLASS(name='cmc-modCertTemplate', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_modCertTemplate_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'ModCertTemplate')))
    cmc_modCertTemplate._val = dict([('Type', _cmc_modCertTemplate_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 31))])
    
    #-----< id-cmc-modCertTemplate >-----#
    id_cmc_modCertTemplate = OID(name='id-cmc-modCertTemplate', mode=MODE_VALUE)
    id_cmc_modCertTemplate._val = (1, 3, 6, 1, 5, 5, 7, 7, 31)
    
    #-----< ModCertTemplate >-----#
    ModCertTemplate = SEQ(name='ModCertTemplate', mode=MODE_TYPE)
    _ModCertTemplate_pkiDataReference = SEQ_OF(name='pkiDataReference', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartPath')))
    _ModCertTemplate_certReferences = SEQ_OF(name='certReferences', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartList')))
    _ModCertTemplate_replace = BOOL(name='replace', mode=MODE_TYPE, default=True)
    _ModCertTemplate_certTemplate = SEQ(name='certTemplate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertTemplate')))
    ModCertTemplate._cont = ASN1Dict([
        ('pkiDataReference', _ModCertTemplate_pkiDataReference),
        ('certReferences', _ModCertTemplate_certReferences),
        ('replace', _ModCertTemplate_replace),
        ('certTemplate', _ModCertTemplate_certTemplate),
        ])
    ModCertTemplate._ext = None
    
    #-----< cmc-controlProcessed >-----#
    cmc_controlProcessed = CLASS(name='cmc-controlProcessed', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_controlProcessed_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'ControlsProcessed')))
    cmc_controlProcessed._val = dict([('Type', _cmc_controlProcessed_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 32))])
    
    #-----< id-cmc-controlProcessed >-----#
    id_cmc_controlProcessed = OID(name='id-cmc-controlProcessed', mode=MODE_VALUE)
    id_cmc_controlProcessed._val = (1, 3, 6, 1, 5, 5, 7, 7, 32)
    
    #-----< ControlsProcessed >-----#
    ControlsProcessed = SEQ(name='ControlsProcessed', mode=MODE_TYPE)
    _ControlsProcessed_bodyList = SEQ_OF(name='bodyList', mode=MODE_TYPE)
    __ControlsProcessed_bodyList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'BodyPartReference')))
    _ControlsProcessed_bodyList._cont = __ControlsProcessed_bodyList__item_
    _ControlsProcessed_bodyList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ControlsProcessed._cont = ASN1Dict([
        ('bodyList', _ControlsProcessed_bodyList),
        ])
    ControlsProcessed._ext = None
    
    #-----< cmc-identityProofV2 >-----#
    cmc_identityProofV2 = CLASS(name='cmc-identityProofV2', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_identityProofV2_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'IdentityProofV2')))
    cmc_identityProofV2._val = dict([('Type', _cmc_identityProofV2_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 33))])
    
    #-----< id-cmc-identityProofV2 >-----#
    id_cmc_identityProofV2 = OID(name='id-cmc-identityProofV2', mode=MODE_VALUE)
    id_cmc_identityProofV2._val = (1, 3, 6, 1, 5, 5, 7, 7, 33)
    
    #-----< IdentityProofV2 >-----#
    IdentityProofV2 = SEQ(name='IdentityProofV2', mode=MODE_TYPE)
    _IdentityProofV2_proofAlgID = SEQ(name='proofAlgID', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __IdentityProofV2_proofAlgID_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___IdentityProofV2_proofAlgID_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ____IdentityProofV2_proofAlgID_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___IdentityProofV2_proofAlgID_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', ____IdentityProofV2_proofAlgID_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])
    __IdentityProofV2_proofAlgID_algorithm._const_tab = ___IdentityProofV2_proofAlgID_algorithm_tab
    __IdentityProofV2_proofAlgID_algorithm._const_tab_at = None
    __IdentityProofV2_proofAlgID_algorithm._const_tab_id = 'id'
    __IdentityProofV2_proofAlgID_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    __IdentityProofV2_proofAlgID_parameters._const_tab = ___IdentityProofV2_proofAlgID_algorithm_tab
    __IdentityProofV2_proofAlgID_parameters._const_tab_at = ('..', 'algorithm')
    __IdentityProofV2_proofAlgID_parameters._const_tab_id = 'Params'
    _IdentityProofV2_proofAlgID._cont = ASN1Dict([
        ('algorithm', __IdentityProofV2_proofAlgID_algorithm),
        ('parameters', __IdentityProofV2_proofAlgID_parameters),
        ])
    _IdentityProofV2_proofAlgID._ext = None
    _IdentityProofV2_macAlgId = SEQ(name='macAlgId', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __IdentityProofV2_macAlgId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['id']))
    ___IdentityProofV2_macAlgId_algorithm_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ____IdentityProofV2_macAlgId_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___IdentityProofV2_macAlgId_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', ____IdentityProofV2_macAlgId_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])], rr=[], ev=None, er=[])
    __IdentityProofV2_macAlgId_algorithm._const_tab = ___IdentityProofV2_macAlgId_algorithm_tab
    __IdentityProofV2_macAlgId_algorithm._const_tab_at = None
    __IdentityProofV2_macAlgId_algorithm._const_tab_id = 'id'
    __IdentityProofV2_macAlgId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['Params']), opt=True)
    __IdentityProofV2_macAlgId_parameters._const_tab = ___IdentityProofV2_macAlgId_algorithm_tab
    __IdentityProofV2_macAlgId_parameters._const_tab_at = ('..', 'algorithm')
    __IdentityProofV2_macAlgId_parameters._const_tab_id = 'Params'
    _IdentityProofV2_macAlgId._cont = ASN1Dict([
        ('algorithm', __IdentityProofV2_macAlgId_algorithm),
        ('parameters', __IdentityProofV2_macAlgId_parameters),
        ])
    _IdentityProofV2_macAlgId._ext = None
    _IdentityProofV2_witness = OCT_STR(name='witness', mode=MODE_TYPE)
    IdentityProofV2._cont = ASN1Dict([
        ('proofAlgID', _IdentityProofV2_proofAlgID),
        ('macAlgId', _IdentityProofV2_macAlgId),
        ('witness', _IdentityProofV2_witness),
        ])
    IdentityProofV2._ext = None
    
    #-----< cmc-popLinkWitnessV2 >-----#
    cmc_popLinkWitnessV2 = CLASS(name='cmc-popLinkWitnessV2', mode=MODE_VALUE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'CMC-CONTROL')))
    _cmc_popLinkWitnessV2_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('EnrollmentMessageSyntax-2009', 'PopLinkWitnessV2')))
    cmc_popLinkWitnessV2._val = dict([('Type', _cmc_popLinkWitnessV2_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 7, 34))])
    
    #-----< id-cmc-popLinkWitnessV2 >-----#
    id_cmc_popLinkWitnessV2 = OID(name='id-cmc-popLinkWitnessV2', mode=MODE_VALUE)
    id_cmc_popLinkWitnessV2._val = (1, 3, 6, 1, 5, 5, 7, 7, 34)
    
    #-----< PopLinkWitnessV2 >-----#
    PopLinkWitnessV2 = SEQ(name='PopLinkWitnessV2', mode=MODE_TYPE)
    _PopLinkWitnessV2_keyGenAlgorithm = SEQ(name='keyGenAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __PopLinkWitnessV2_keyGenAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-DERIVATION'), ['id']))
    ___PopLinkWitnessV2_keyGenAlgorithm_algorithm_tab = CLASS(name='_tab_KEY-DERIVATION', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-DERIVATION')))
    ____PopLinkWitnessV2_keyGenAlgorithm_algorithm_tab_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'PBKDF2-params')))
    ___PopLinkWitnessV2_keyGenAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 5, 12)), ('Params', ____PopLinkWitnessV2_keyGenAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'required')])], rr=[], ev=None, er=[])
    __PopLinkWitnessV2_keyGenAlgorithm_algorithm._const_tab = ___PopLinkWitnessV2_keyGenAlgorithm_algorithm_tab
    __PopLinkWitnessV2_keyGenAlgorithm_algorithm._const_tab_at = None
    __PopLinkWitnessV2_keyGenAlgorithm_algorithm._const_tab_id = 'id'
    __PopLinkWitnessV2_keyGenAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-DERIVATION'), ['Params']), opt=True)
    __PopLinkWitnessV2_keyGenAlgorithm_parameters._const_tab = ___PopLinkWitnessV2_keyGenAlgorithm_algorithm_tab
    __PopLinkWitnessV2_keyGenAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __PopLinkWitnessV2_keyGenAlgorithm_parameters._const_tab_id = 'Params'
    _PopLinkWitnessV2_keyGenAlgorithm._cont = ASN1Dict([
        ('algorithm', __PopLinkWitnessV2_keyGenAlgorithm_algorithm),
        ('parameters', __PopLinkWitnessV2_keyGenAlgorithm_parameters),
        ])
    _PopLinkWitnessV2_keyGenAlgorithm._ext = None
    _PopLinkWitnessV2_macAlgorithm = SEQ(name='macAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __PopLinkWitnessV2_macAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['id']))
    ___PopLinkWitnessV2_macAlgorithm_algorithm_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ____PopLinkWitnessV2_macAlgorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___PopLinkWitnessV2_macAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', ____PopLinkWitnessV2_macAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])], rr=[], ev=None, er=[])
    __PopLinkWitnessV2_macAlgorithm_algorithm._const_tab = ___PopLinkWitnessV2_macAlgorithm_algorithm_tab
    __PopLinkWitnessV2_macAlgorithm_algorithm._const_tab_at = None
    __PopLinkWitnessV2_macAlgorithm_algorithm._const_tab_id = 'id'
    __PopLinkWitnessV2_macAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['Params']), opt=True)
    __PopLinkWitnessV2_macAlgorithm_parameters._const_tab = ___PopLinkWitnessV2_macAlgorithm_algorithm_tab
    __PopLinkWitnessV2_macAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __PopLinkWitnessV2_macAlgorithm_parameters._const_tab_id = 'Params'
    _PopLinkWitnessV2_macAlgorithm._cont = ASN1Dict([
        ('algorithm', __PopLinkWitnessV2_macAlgorithm_algorithm),
        ('parameters', __PopLinkWitnessV2_macAlgorithm_parameters),
        ])
    _PopLinkWitnessV2_macAlgorithm._ext = None
    _PopLinkWitnessV2_witness = OCT_STR(name='witness', mode=MODE_TYPE)
    PopLinkWitnessV2._cont = ASN1Dict([
        ('keyGenAlgorithm', _PopLinkWitnessV2_keyGenAlgorithm),
        ('macAlgorithm', _PopLinkWitnessV2_macAlgorithm),
        ('witness', _PopLinkWitnessV2_witness),
        ])
    PopLinkWitnessV2._ext = None
    
    #-----< KeyDevAlgs >-----#
    KeyDevAlgs = CLASS(name='KeyDevAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-DERIVATION')))
    _KeyDevAlgs_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntaxAlgorithms-2009', 'PBKDF2-params')))
    KeyDevAlgs._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 5, 12)), ('Params', _KeyDevAlgs_val_Params_0), ('paramPresence', 'required')])], rr=[], ev=[], er=[])
    
    _all_ = [
        CMC_ContentTypes,
        _CMC_ContentTypes_val_Type_0,
        _CMC_ContentTypes_val_Type_1,
        SignatureAlgs,
        _SignatureAlgs_val_Value_0,
        _SignatureAlgs_val_Params_0,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_0,
        CMC_UnsignedAtts,
        _CMC_UnsignedAtts_val_Type_0,
        id_cmc,
        id_cct,
        ct_PKIData,
        _ct_PKIData_val_Type,
        id_cct_PKIData,
        __PKIData_controlSequence__item_,
        _PKIData_controlSequence,
        __PKIData_reqSequence__item_,
        _PKIData_reqSequence,
        __PKIData_cmsSequence__item_,
        _PKIData_cmsSequence,
        __PKIData_otherMsgSequence__item_,
        _PKIData_otherMsgSequence,
        PKIData,
        BodyPartID,
        _TaggedAttribute_bodyPartID,
        __TaggedAttribute_attrType_tab,
        ___TaggedAttribute_attrType_tab_val_Type_0,
        ___TaggedAttribute_attrType_tab_val_Type_1,
        ___TaggedAttribute_attrType_tab_val_Type_2,
        ___TaggedAttribute_attrType_tab_val_Type_3,
        ___TaggedAttribute_attrType_tab_val_Type_4,
        ___TaggedAttribute_attrType_tab_val_Type_5,
        ___TaggedAttribute_attrType_tab_val_Type_6,
        ___TaggedAttribute_attrType_tab_val_Type_7,
        ___TaggedAttribute_attrType_tab_val_Type_8,
        ___TaggedAttribute_attrType_tab_val_Type_9,
        ___TaggedAttribute_attrType_tab_val_Type_10,
        ___TaggedAttribute_attrType_tab_val_Type_11,
        ___TaggedAttribute_attrType_tab_val_Type_12,
        ___TaggedAttribute_attrType_tab_val_Type_13,
        ___TaggedAttribute_attrType_tab_val_Type_14,
        ___TaggedAttribute_attrType_tab_val_Type_15,
        ___TaggedAttribute_attrType_tab_val_Type_16,
        ___TaggedAttribute_attrType_tab_val_Type_17,
        ___TaggedAttribute_attrType_tab_val_Type_18,
        ___TaggedAttribute_attrType_tab_val_Type_19,
        ___TaggedAttribute_attrType_tab_val_Type_20,
        ___TaggedAttribute_attrType_tab_val_Type_21,
        ___TaggedAttribute_attrType_tab_val_Type_22,
        ___TaggedAttribute_attrType_tab_val_Type_23,
        ___TaggedAttribute_attrType_tab_val_Type_24,
        ___TaggedAttribute_attrType_tab_val_Type_25,
        ___TaggedAttribute_attrType_tab_val_Type_26,
        ___TaggedAttribute_attrType_tab_val_Type_27,
        ___TaggedAttribute_attrType_tab_val_Type_28,
        ___TaggedAttribute_attrType_tab_val_Type_29,
        _TaggedAttribute_attrType,
        __TaggedAttribute_attrValues__item_,
        _TaggedAttribute_attrValues,
        TaggedAttribute,
        Cmc_Control_Set,
        _Cmc_Control_Set_val_Type_0,
        _Cmc_Control_Set_val_Type_1,
        _Cmc_Control_Set_val_Type_2,
        _Cmc_Control_Set_val_Type_3,
        _Cmc_Control_Set_val_Type_4,
        _Cmc_Control_Set_val_Type_5,
        _Cmc_Control_Set_val_Type_6,
        _Cmc_Control_Set_val_Type_7,
        _Cmc_Control_Set_val_Type_8,
        _Cmc_Control_Set_val_Type_9,
        _Cmc_Control_Set_val_Type_10,
        _Cmc_Control_Set_val_Type_11,
        _Cmc_Control_Set_val_Type_12,
        _Cmc_Control_Set_val_Type_13,
        _Cmc_Control_Set_val_Type_14,
        _Cmc_Control_Set_val_Type_15,
        _Cmc_Control_Set_val_Type_16,
        _Cmc_Control_Set_val_Type_17,
        _Cmc_Control_Set_val_Type_18,
        _Cmc_Control_Set_val_Type_19,
        _Cmc_Control_Set_val_Type_20,
        _Cmc_Control_Set_val_Type_21,
        _Cmc_Control_Set_val_Type_22,
        _Cmc_Control_Set_val_Type_23,
        _Cmc_Control_Set_val_Type_24,
        _Cmc_Control_Set_val_Type_25,
        _Cmc_Control_Set_val_Type_26,
        _Cmc_Control_Set_val_Type_27,
        _Cmc_Control_Set_val_Type_28,
        _Cmc_Control_Set_val_Type_29,
        OTHER_REQUEST,
        OtherRequests,
        _TaggedRequest_tcr,
        _TaggedRequest_crm,
        __TaggedRequest_orm_bodyPartID,
        ___TaggedRequest_orm_requestMessageType_tab,
        __TaggedRequest_orm_requestMessageType,
        ___TaggedRequest_orm_requestMessageValue_tab,
        __TaggedRequest_orm_requestMessageValue,
        _TaggedRequest_orm,
        TaggedRequest,
        _TaggedCertificationRequest_bodyPartID,
        _TaggedCertificationRequest_certificationRequest,
        TaggedCertificationRequest,
        AttributeList,
        _AttributeList_val_Type_0,
        __CertificationRequest_certificationRequestInfo_version,
        __CertificationRequest_certificationRequestInfo_subject,
        _____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_0,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_0,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_1,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_1,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_2,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_2,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_3,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_4,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_4,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_5,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_5,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_6,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_6,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_7,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_7,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_8,
        ______CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_8,
        ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_algorithm,
        ____CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm_parameters,
        ___CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_algorithm,
        ___CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo_subjectPublicKey,
        __CertificationRequest_certificationRequestInfo_subjectPublicKeyInfo,
        _____CertificationRequest_certificationRequestInfo_attributes__item__type_tab,
        ______CertificationRequest_certificationRequestInfo_attributes__item__type_tab_val_Type_0,
        ____CertificationRequest_certificationRequestInfo_attributes__item__type,
        _____CertificationRequest_certificationRequestInfo_attributes__item__values__item_,
        ____CertificationRequest_certificationRequestInfo_attributes__item__values,
        ___CertificationRequest_certificationRequestInfo_attributes__item_,
        __CertificationRequest_certificationRequestInfo_attributes,
        _CertificationRequest_certificationRequestInfo,
        ___CertificationRequest_signatureAlgorithm_algorithm_tab,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_1,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_2,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_3,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_3,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_4,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_5,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_5,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_6,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_6,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_7,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_7,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_8,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_8,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_9,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_9,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Value_10,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_10,
        ____CertificationRequest_signatureAlgorithm_algorithm_tab_val_Params_11,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_1,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_2,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_3,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1,
        __CertificationRequest_signatureAlgorithm_algorithm,
        __CertificationRequest_signatureAlgorithm_parameters,
        _CertificationRequest_signatureAlgorithm,
        _CertificationRequest_signature,
        CertificationRequest,
        _TaggedContentInfo_bodyPartID,
        _TaggedContentInfo_contentInfo,
        TaggedContentInfo,
        OTHER_MSG,
        OtherMsgSet,
        _OtherMsg_bodyPartID,
        __OtherMsg_otherMsgType_tab,
        _OtherMsg_otherMsgType,
        __OtherMsg_otherMsgValue_tab,
        _OtherMsg_otherMsgValue,
        OtherMsg,
        ct_PKIResponse,
        _ct_PKIResponse_val_Type,
        id_cct_PKIResponse,
        ResponseBody,
        __PKIResponse_controlSequence__item_,
        _PKIResponse_controlSequence,
        __PKIResponse_cmsSequence__item_,
        _PKIResponse_cmsSequence,
        __PKIResponse_otherMsgSequence__item_,
        _PKIResponse_otherMsgSequence,
        PKIResponse,
        CMC_CONTROL,
        cmc_identityProof,
        _cmc_identityProof_val_Type,
        id_cmc_identityProof,
        cmc_dataReturn,
        _cmc_dataReturn_val_Type,
        id_cmc_dataReturn,
        cmc_regInfo,
        _cmc_regInfo_val_Type,
        id_cmc_regInfo,
        cmc_responseInfo,
        _cmc_responseInfo_val_Type,
        id_cmc_responseInfo,
        cmc_queryPending,
        _cmc_queryPending_val_Type,
        id_cmc_queryPending,
        cmc_popLinkRandom,
        _cmc_popLinkRandom_val_Type,
        id_cmc_popLinkRandom,
        cmc_popLinkWitness,
        _cmc_popLinkWitness_val_Type,
        id_cmc_popLinkWitness,
        cmc_identification,
        _cmc_identification_val_Type,
        id_cmc_identification,
        cmc_transactionId,
        _cmc_transactionId_val_Type,
        id_cmc_transactionId,
        cmc_senderNonce,
        _cmc_senderNonce_val_Type,
        id_cmc_senderNonce,
        cmc_recipientNonce,
        _cmc_recipientNonce_val_Type,
        id_cmc_recipientNonce,
        cmc_statusInfo,
        _cmc_statusInfo_val_Type,
        id_cmc_statusInfo,
        _CMCStatusInfo_cMCStatus,
        __CMCStatusInfo_bodyList__item_,
        _CMCStatusInfo_bodyList,
        _CMCStatusInfo_statusString,
        __CMCStatusInfo_otherInfo_failInfo,
        __CMCStatusInfo_otherInfo_pendInfo,
        _CMCStatusInfo_otherInfo,
        CMCStatusInfo,
        _PendInfo_pendToken,
        _PendInfo_pendTime,
        PendInfo,
        CMCStatus,
        CMCFailInfo,
        cmc_addExtensions,
        _cmc_addExtensions_val_Type,
        id_cmc_addExtensions,
        _AddExtensions_pkiDataReference,
        __AddExtensions_certReferences__item_,
        _AddExtensions_certReferences,
        ____AddExtensions_extensions__item__extnID_tab,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_0,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_1,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_2,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_3,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_4,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_5,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_6,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_7,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_8,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_9,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_10,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_11,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_12,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_13,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_14,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_15,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_16,
        _____AddExtensions_extensions__item__extnID_tab_val_ExtnType_17,
        ___AddExtensions_extensions__item__extnID,
        ___AddExtensions_extensions__item__critical,
        ____AddExtensions_extensions__item__extnValue_contain,
        ___AddExtensions_extensions__item__extnValue,
        __AddExtensions_extensions__item_,
        _AddExtensions_extensions,
        AddExtensions,
        cmc_encryptedPOP,
        _cmc_encryptedPOP_val_Type,
        cmc_decryptedPOP,
        _cmc_decryptedPOP_val_Type,
        id_cmc_encryptedPOP,
        id_cmc_decryptedPOP,
        _EncryptedPOP_request,
        _EncryptedPOP_cms,
        ___EncryptedPOP_thePOPAlgID_algorithm_tab,
        ____EncryptedPOP_thePOPAlgID_algorithm_tab_val_Params_0,
        __EncryptedPOP_thePOPAlgID_algorithm,
        __EncryptedPOP_thePOPAlgID_parameters,
        _EncryptedPOP_thePOPAlgID,
        ___EncryptedPOP_witnessAlgID_algorithm_tab,
        ____EncryptedPOP_witnessAlgID_algorithm_tab_val_Params_0,
        __EncryptedPOP_witnessAlgID_algorithm,
        __EncryptedPOP_witnessAlgID_parameters,
        _EncryptedPOP_witnessAlgID,
        _EncryptedPOP_witness,
        EncryptedPOP,
        POPAlgs,
        _POPAlgs_val_Params_0,
        WitnessAlgs,
        _WitnessAlgs_val_Params_0,
        _DecryptedPOP_bodyPartID,
        ___DecryptedPOP_thePOPAlgID_algorithm_tab,
        ____DecryptedPOP_thePOPAlgID_algorithm_tab_val_Params_0,
        __DecryptedPOP_thePOPAlgID_algorithm,
        __DecryptedPOP_thePOPAlgID_parameters,
        _DecryptedPOP_thePOPAlgID,
        _DecryptedPOP_thePOP,
        DecryptedPOP,
        cmc_lraPOPWitness,
        _cmc_lraPOPWitness_val_Type,
        id_cmc_lraPOPWitness,
        _LraPopWitness_pkiDataBodyid,
        __LraPopWitness_bodyIds__item_,
        _LraPopWitness_bodyIds,
        LraPopWitness,
        cmc_getCert,
        _cmc_getCert_val_Type,
        id_cmc_getCert,
        _GetCert_issuerName,
        _GetCert_serialNumber,
        GetCert,
        cmc_getCRL,
        _cmc_getCRL_val_Type,
        id_cmc_getCRL,
        _GetCRL_issuerName,
        _GetCRL_cRLName,
        _GetCRL_time,
        _GetCRL_reasons,
        GetCRL,
        cmc_revokeRequest,
        _cmc_revokeRequest_val_Type,
        id_cmc_revokeRequest,
        _RevokeRequest_issuerName,
        _RevokeRequest_serialNumber,
        _RevokeRequest_reason,
        _RevokeRequest_invalidityDate,
        _RevokeRequest_passphrase,
        _RevokeRequest_comment,
        RevokeRequest,
        cmc_confirmCertAcceptance,
        _cmc_confirmCertAcceptance_val_Type,
        id_cmc_confirmCertAcceptance,
        CMCCertId,
        at_extension_req,
        _at_extension_req_val_Type,
        id_ExtensionReq,
        ___ExtensionReq__item__extnID_tab,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_0,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_1,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_2,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_3,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_4,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_5,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_6,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_7,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_8,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_9,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_10,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_11,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_12,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_13,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_14,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_15,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_16,
        ____ExtensionReq__item__extnID_tab_val_ExtnType_17,
        __ExtensionReq__item__extnID,
        __ExtensionReq__item__critical,
        ___ExtensionReq__item__extnValue_contain,
        __ExtensionReq__item__extnValue,
        _ExtensionReq__item_,
        ExtensionReq,
        sa_noSignature,
        _sa_noSignature_val_Value,
        _sa_noSignature_val_Params,
        id_alg_noSignature,
        NoSignatureValue,
        id_aa,
        aa_cmc_unsignedData,
        _aa_cmc_unsignedData_val_Type,
        id_aa_cmc_unsignedData,
        _CMCUnsignedData_bodyPartPath,
        _CMCUnsignedData_identifier,
        _CMCUnsignedData_content,
        CMCUnsignedData,
        cmc_statusInfoV2,
        _cmc_statusInfoV2_val_Type,
        id_cmc_statusInfoV2,
        EXTENDED_FAILURE_INFO,
        ExtendedFailures,
        _CMCStatusInfoV2_cMCStatus,
        __CMCStatusInfoV2_bodyList__item_,
        _CMCStatusInfoV2_bodyList,
        _CMCStatusInfoV2_statusString,
        __CMCStatusInfoV2_otherInfo_failInfo,
        __CMCStatusInfoV2_otherInfo_pendInfo,
        _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab_id,
        _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab_Type,
        ____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID_tab,
        ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoOID,
        _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab_id,
        _____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab_Type,
        ____CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue_tab,
        ___CMCStatusInfoV2_otherInfo_extendedFailInfo_failInfoValue,
        __CMCStatusInfoV2_otherInfo_extendedFailInfo,
        _CMCStatusInfoV2_otherInfo,
        CMCStatusInfoV2,
        _BodyPartReference_bodyPartID,
        _BodyPartReference_bodyPartPath,
        BodyPartReference,
        _BodyPartPath__item_,
        BodyPartPath,
        cmc_trustedAnchors,
        _cmc_trustedAnchors_val_Type,
        id_cmc_trustedAnchors,
        _PublishTrustAnchors_seqNumber,
        ___PublishTrustAnchors_hashAlgorithm_algorithm_tab,
        ____PublishTrustAnchors_hashAlgorithm_algorithm_tab_val_Params_0,
        ____PublishTrustAnchors_hashAlgorithm_algorithm_tab_val_Params_1,
        __PublishTrustAnchors_hashAlgorithm_algorithm,
        __PublishTrustAnchors_hashAlgorithm_parameters,
        _PublishTrustAnchors_hashAlgorithm,
        __PublishTrustAnchors_anchorHashes__item_,
        _PublishTrustAnchors_anchorHashes,
        PublishTrustAnchors,
        HashAlgorithms,
        _HashAlgorithms_val_Params_0,
        _HashAlgorithms_val_Params_1,
        cmc_authData,
        _cmc_authData_val_Type,
        id_cmc_authData,
        AuthPublish,
        cmc_batchRequests,
        _cmc_batchRequests_val_Type,
        id_cmc_batchRequests,
        cmc_batchResponses,
        _cmc_batchResponses_val_Type,
        id_cmc_batchResponses,
        _BodyPartList__item_,
        BodyPartList,
        cmc_publishCert,
        _cmc_publishCert_val_Type,
        id_cmc_publishCert,
        ___CMCPublicationInfo_hashAlg_algorithm_tab,
        ____CMCPublicationInfo_hashAlg_algorithm_tab_val_Params_0,
        ____CMCPublicationInfo_hashAlg_algorithm_tab_val_Params_1,
        __CMCPublicationInfo_hashAlg_algorithm,
        __CMCPublicationInfo_hashAlg_parameters,
        _CMCPublicationInfo_hashAlg,
        __CMCPublicationInfo_certHashes__item_,
        _CMCPublicationInfo_certHashes,
        _CMCPublicationInfo_pubInfo,
        CMCPublicationInfo,
        cmc_modCertTemplate,
        _cmc_modCertTemplate_val_Type,
        id_cmc_modCertTemplate,
        _ModCertTemplate_pkiDataReference,
        _ModCertTemplate_certReferences,
        _ModCertTemplate_replace,
        _ModCertTemplate_certTemplate,
        ModCertTemplate,
        cmc_controlProcessed,
        _cmc_controlProcessed_val_Type,
        id_cmc_controlProcessed,
        __ControlsProcessed_bodyList__item_,
        _ControlsProcessed_bodyList,
        ControlsProcessed,
        cmc_identityProofV2,
        _cmc_identityProofV2_val_Type,
        id_cmc_identityProofV2,
        ___IdentityProofV2_proofAlgID_algorithm_tab,
        ____IdentityProofV2_proofAlgID_algorithm_tab_val_Params_0,
        __IdentityProofV2_proofAlgID_algorithm,
        __IdentityProofV2_proofAlgID_parameters,
        _IdentityProofV2_proofAlgID,
        ___IdentityProofV2_macAlgId_algorithm_tab,
        ____IdentityProofV2_macAlgId_algorithm_tab_val_Params_0,
        __IdentityProofV2_macAlgId_algorithm,
        __IdentityProofV2_macAlgId_parameters,
        _IdentityProofV2_macAlgId,
        _IdentityProofV2_witness,
        IdentityProofV2,
        cmc_popLinkWitnessV2,
        _cmc_popLinkWitnessV2_val_Type,
        id_cmc_popLinkWitnessV2,
        ___PopLinkWitnessV2_keyGenAlgorithm_algorithm_tab,
        ____PopLinkWitnessV2_keyGenAlgorithm_algorithm_tab_val_Params_0,
        __PopLinkWitnessV2_keyGenAlgorithm_algorithm,
        __PopLinkWitnessV2_keyGenAlgorithm_parameters,
        _PopLinkWitnessV2_keyGenAlgorithm,
        ___PopLinkWitnessV2_macAlgorithm_algorithm_tab,
        ____PopLinkWitnessV2_macAlgorithm_algorithm_tab_val_Params_0,
        __PopLinkWitnessV2_macAlgorithm_algorithm,
        __PopLinkWitnessV2_macAlgorithm_parameters,
        _PopLinkWitnessV2_macAlgorithm,
        _PopLinkWitnessV2_witness,
        PopLinkWitnessV2,
        KeyDevAlgs,
        _KeyDevAlgs_val_Params_0,
    ]

class OCSP_2009:

    _name_  = 'OCSP-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 48]
    
    _obj_ = [
        'OCSPRequest',
        'TBSRequest',
        'Signature',
        'Version',
        'Request',
        'CertID',
        'OCSPResponse',
        'OCSPResponseStatus',
        'RESPONSE',
        'ResponseSet',
        'ResponseBytes',
        'basicResponse',
        'BasicOCSPResponse',
        'ResponseData',
        'ResponderID',
        'KeyHash',
        'SingleResponse',
        'CertStatus',
        'RevokedInfo',
        'UnknownInfo',
        'CRLReason',
        'ArchiveCutoff',
        'AcceptableResponses',
        'ServiceLocator',
        'CrlID',
        're-ocsp-nonce',
        're-ocsp-response',
        're-ocsp-service-locator',
        're-ocsp-crl',
        're-ocsp-archive-cutoff',
        'id-kp-OCSPSigning',
        'id-pkix-ocsp',
        'id-pkix-ocsp-basic',
        'id-pkix-ocsp-nonce',
        'id-pkix-ocsp-crl',
        'id-pkix-ocsp-response',
        'id-pkix-ocsp-nocheck',
        'id-pkix-ocsp-archive-cutoff',
        'id-pkix-ocsp-service-locator',
        ]
    _type_ = [
        'OCSPRequest',
        'TBSRequest',
        'Signature',
        'Version',
        'Request',
        'CertID',
        'OCSPResponse',
        'OCSPResponseStatus',
        'RESPONSE',
        'ResponseBytes',
        'BasicOCSPResponse',
        'ResponseData',
        'ResponderID',
        'KeyHash',
        'SingleResponse',
        'CertStatus',
        'RevokedInfo',
        'UnknownInfo',
        'CRLReason',
        'ArchiveCutoff',
        'AcceptableResponses',
        'ServiceLocator',
        'CrlID',
        ]
    _set_ = [
        'ResponseSet',
        ]
    _val_ = [
        'basicResponse',
        're-ocsp-nonce',
        're-ocsp-response',
        're-ocsp-service-locator',
        're-ocsp-crl',
        're-ocsp-archive-cutoff',
        'id-kp-OCSPSigning',
        'id-pkix-ocsp',
        'id-pkix-ocsp-basic',
        'id-pkix-ocsp-nonce',
        'id-pkix-ocsp-crl',
        'id-pkix-ocsp-response',
        'id-pkix-ocsp-nocheck',
        'id-pkix-ocsp-archive-cutoff',
        'id-pkix-ocsp-service-locator',
        ]
    _class_ = [
        'RESPONSE',
        'ResponseSet',
        'basicResponse',
        're-ocsp-nonce',
        're-ocsp-response',
        're-ocsp-service-locator',
        're-ocsp-crl',
        're-ocsp-archive-cutoff',
        ]
    _param_ = [
        ]
    
    #-----< OCSPRequest >-----#
    OCSPRequest = SEQ(name='OCSPRequest', mode=MODE_TYPE)
    _OCSPRequest_tbsRequest = SEQ(name='tbsRequest', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'TBSRequest')))
    _OCSPRequest_optionalSignature = SEQ(name='optionalSignature', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OCSP-2009', 'Signature')), opt=True)
    OCSPRequest._cont = ASN1Dict([
        ('tbsRequest', _OCSPRequest_tbsRequest),
        ('optionalSignature', _OCSPRequest_optionalSignature),
        ])
    OCSPRequest._ext = None
    
    #-----< TBSRequest >-----#
    TBSRequest = SEQ(name='TBSRequest', mode=MODE_TYPE)
    _TBSRequest_version = INT(name='version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OCSP-2009', 'Version')), default=0)
    _TBSRequest_requestorName = CHOICE(name='requestorName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')), opt=True)
    _TBSRequest_requestList = SEQ_OF(name='requestList', mode=MODE_TYPE)
    __TBSRequest_requestList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'Request')))
    _TBSRequest_requestList._cont = __TBSRequest_requestList__item_
    _TBSRequest_requestExtensions = SEQ_OF(name='requestExtensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __TBSRequest_requestExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___TBSRequest_requestExtensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____TBSRequest_requestExtensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____TBSRequest_requestExtensions__item__extnID_tab_val_ExtnType_0 = OCT_STR(name='ExtnType', mode=MODE_TYPE)
    _____TBSRequest_requestExtensions__item__extnID_tab_val_ExtnType_1 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'AcceptableResponses')))
    ____TBSRequest_requestExtensions__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', _____TBSRequest_requestExtensions__item__extnID_tab_val_ExtnType_0), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 2))]), dict([('ExtnType', _____TBSRequest_requestExtensions__item__extnID_tab_val_ExtnType_1), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 4))])], rr=[], ev=None, er=[])
    ___TBSRequest_requestExtensions__item__extnID._const_tab = ____TBSRequest_requestExtensions__item__extnID_tab
    ___TBSRequest_requestExtensions__item__extnID._const_tab_at = None
    ___TBSRequest_requestExtensions__item__extnID._const_tab_id = 'id'
    ___TBSRequest_requestExtensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___TBSRequest_requestExtensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____TBSRequest_requestExtensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ____TBSRequest_requestExtensions__item__extnValue_contain._const_tab = ____TBSRequest_requestExtensions__item__extnID_tab
    ____TBSRequest_requestExtensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____TBSRequest_requestExtensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___TBSRequest_requestExtensions__item__extnValue._const_cont = ____TBSRequest_requestExtensions__item__extnValue_contain
    __TBSRequest_requestExtensions__item_._cont = ASN1Dict([
        ('extnID', ___TBSRequest_requestExtensions__item__extnID),
        ('critical', ___TBSRequest_requestExtensions__item__critical),
        ('extnValue', ___TBSRequest_requestExtensions__item__extnValue),
        ])
    __TBSRequest_requestExtensions__item_._ext = None
    _TBSRequest_requestExtensions._cont = __TBSRequest_requestExtensions__item_
    _TBSRequest_requestExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    TBSRequest._cont = ASN1Dict([
        ('version', _TBSRequest_version),
        ('requestorName', _TBSRequest_requestorName),
        ('requestList', _TBSRequest_requestList),
        ('requestExtensions', _TBSRequest_requestExtensions),
        ])
    TBSRequest._ext = None
    
    #-----< Signature >-----#
    Signature = SEQ(name='Signature', mode=MODE_TYPE)
    _Signature_signatureAlgorithm = SEQ(name='signatureAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __Signature_signatureAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___Signature_signatureAlgorithm_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ___Signature_signatureAlgorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __Signature_signatureAlgorithm_algorithm._const_tab = ___Signature_signatureAlgorithm_algorithm_tab
    __Signature_signatureAlgorithm_algorithm._const_tab_at = None
    __Signature_signatureAlgorithm_algorithm._const_tab_id = 'id'
    __Signature_signatureAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    ___Signature_signatureAlgorithm_parameters_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ___Signature_signatureAlgorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __Signature_signatureAlgorithm_parameters._const_tab = ___Signature_signatureAlgorithm_parameters_tab
    __Signature_signatureAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __Signature_signatureAlgorithm_parameters._const_tab_id = 'Params'
    _Signature_signatureAlgorithm._cont = ASN1Dict([
        ('algorithm', __Signature_signatureAlgorithm_algorithm),
        ('parameters', __Signature_signatureAlgorithm_parameters),
        ])
    _Signature_signatureAlgorithm._ext = None
    _Signature_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _Signature_certs = SEQ_OF(name='certs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __Signature_certs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    _Signature_certs._cont = __Signature_certs__item_
    Signature._cont = ASN1Dict([
        ('signatureAlgorithm', _Signature_signatureAlgorithm),
        ('signature', _Signature_signature),
        ('certs', _Signature_certs),
        ])
    Signature._ext = None
    
    #-----< Version >-----#
    Version = INT(name='Version', mode=MODE_TYPE)
    Version._cont = ASN1Dict([('v1', 0)])
    
    #-----< Request >-----#
    Request = SEQ(name='Request', mode=MODE_TYPE)
    _Request_reqCert = SEQ(name='reqCert', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'CertID')))
    _Request_singleRequestExtensions = SEQ_OF(name='singleRequestExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __Request_singleRequestExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___Request_singleRequestExtensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____Request_singleRequestExtensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____Request_singleRequestExtensions__item__extnID_tab_val_ExtnType_0 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'ServiceLocator')))
    ____Request_singleRequestExtensions__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', _____Request_singleRequestExtensions__item__extnID_tab_val_ExtnType_0), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 7))])], rr=[], ev=None, er=[])
    ___Request_singleRequestExtensions__item__extnID._const_tab = ____Request_singleRequestExtensions__item__extnID_tab
    ___Request_singleRequestExtensions__item__extnID._const_tab_at = None
    ___Request_singleRequestExtensions__item__extnID._const_tab_id = 'id'
    ___Request_singleRequestExtensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___Request_singleRequestExtensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____Request_singleRequestExtensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ____Request_singleRequestExtensions__item__extnValue_contain._const_tab = ____Request_singleRequestExtensions__item__extnID_tab
    ____Request_singleRequestExtensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____Request_singleRequestExtensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___Request_singleRequestExtensions__item__extnValue._const_cont = ____Request_singleRequestExtensions__item__extnValue_contain
    __Request_singleRequestExtensions__item_._cont = ASN1Dict([
        ('extnID', ___Request_singleRequestExtensions__item__extnID),
        ('critical', ___Request_singleRequestExtensions__item__critical),
        ('extnValue', ___Request_singleRequestExtensions__item__extnValue),
        ])
    __Request_singleRequestExtensions__item_._ext = None
    _Request_singleRequestExtensions._cont = __Request_singleRequestExtensions__item_
    _Request_singleRequestExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    Request._cont = ASN1Dict([
        ('reqCert', _Request_reqCert),
        ('singleRequestExtensions', _Request_singleRequestExtensions),
        ])
    Request._ext = None
    
    #-----< CertID >-----#
    CertID = SEQ(name='CertID', mode=MODE_TYPE)
    _CertID_hashAlgorithm = SEQ(name='hashAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __CertID_hashAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___CertID_hashAlgorithm_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___CertID_hashAlgorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __CertID_hashAlgorithm_algorithm._const_tab = ___CertID_hashAlgorithm_algorithm_tab
    __CertID_hashAlgorithm_algorithm._const_tab_at = None
    __CertID_hashAlgorithm_algorithm._const_tab_id = 'id'
    __CertID_hashAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    ___CertID_hashAlgorithm_parameters_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___CertID_hashAlgorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __CertID_hashAlgorithm_parameters._const_tab = ___CertID_hashAlgorithm_parameters_tab
    __CertID_hashAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __CertID_hashAlgorithm_parameters._const_tab_id = 'Params'
    _CertID_hashAlgorithm._cont = ASN1Dict([
        ('algorithm', __CertID_hashAlgorithm_algorithm),
        ('parameters', __CertID_hashAlgorithm_parameters),
        ])
    _CertID_hashAlgorithm._ext = None
    _CertID_issuerNameHash = OCT_STR(name='issuerNameHash', mode=MODE_TYPE)
    _CertID_issuerKeyHash = OCT_STR(name='issuerKeyHash', mode=MODE_TYPE)
    _CertID_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateSerialNumber')))
    CertID._cont = ASN1Dict([
        ('hashAlgorithm', _CertID_hashAlgorithm),
        ('issuerNameHash', _CertID_issuerNameHash),
        ('issuerKeyHash', _CertID_issuerKeyHash),
        ('serialNumber', _CertID_serialNumber),
        ])
    CertID._ext = None
    
    #-----< OCSPResponse >-----#
    OCSPResponse = SEQ(name='OCSPResponse', mode=MODE_TYPE)
    _OCSPResponse_responseStatus = ENUM(name='responseStatus', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'OCSPResponseStatus')))
    _OCSPResponse_responseBytes = SEQ(name='responseBytes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OCSP-2009', 'ResponseBytes')), opt=True)
    OCSPResponse._cont = ASN1Dict([
        ('responseStatus', _OCSPResponse_responseStatus),
        ('responseBytes', _OCSPResponse_responseBytes),
        ])
    OCSPResponse._ext = None
    
    #-----< OCSPResponseStatus >-----#
    OCSPResponseStatus = ENUM(name='OCSPResponseStatus', mode=MODE_TYPE)
    OCSPResponseStatus._cont = ASN1Dict([('successful', 0), ('malformedRequest', 1), ('internalError', 2), ('tryLater', 3), ('sigRequired', 5), ('unauthorized', 6)])
    OCSPResponseStatus._ext = None
    
    #-----< RESPONSE >-----#
    RESPONSE = CLASS(name='RESPONSE', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< ResponseSet >-----#
    ResponseSet = CLASS(name='ResponseSet', mode=MODE_SET, typeref=ASN1RefType(('OCSP-2009', 'RESPONSE')))
    _ResponseSet_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'BasicOCSPResponse')))
    ResponseSet._val = ASN1Set(rv=[dict([('Type', _ResponseSet_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 1))])], rr=[], ev=[], er=[])
    
    #-----< ResponseBytes >-----#
    ResponseBytes = SEQ(name='ResponseBytes', mode=MODE_TYPE)
    _ResponseBytes_responseType = OID(name='responseType', mode=MODE_TYPE, typeref=ASN1RefClassField(('OCSP-2009', 'RESPONSE'), ['id']))
    __ResponseBytes_responseType_tab = CLASS(name='_tab_RESPONSE', mode=MODE_SET, typeref=ASN1RefType(('OCSP-2009', 'RESPONSE')))
    ___ResponseBytes_responseType_tab_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'BasicOCSPResponse')))
    __ResponseBytes_responseType_tab._val = ASN1Set(rv=[dict([('Type', ___ResponseBytes_responseType_tab_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 1))])], rr=[], ev=None, er=[])
    _ResponseBytes_responseType._const_tab = __ResponseBytes_responseType_tab
    _ResponseBytes_responseType._const_tab_at = None
    _ResponseBytes_responseType._const_tab_id = 'id'
    _ResponseBytes_response = OCT_STR(name='response', mode=MODE_TYPE)
    __ResponseBytes_response_contain = OPEN(name='_cont_response', mode=MODE_TYPE, typeref=ASN1RefClassField(('OCSP-2009', 'RESPONSE'), ['Type']))
    __ResponseBytes_response_contain._const_tab = __ResponseBytes_responseType_tab
    __ResponseBytes_response_contain._const_tab_at = ('..', 'responseType')
    __ResponseBytes_response_contain._const_tab_id = 'Type'
    _ResponseBytes_response._const_cont = __ResponseBytes_response_contain
    ResponseBytes._cont = ASN1Dict([
        ('responseType', _ResponseBytes_responseType),
        ('response', _ResponseBytes_response),
        ])
    ResponseBytes._ext = None
    
    #-----< basicResponse >-----#
    basicResponse = CLASS(name='basicResponse', mode=MODE_VALUE, typeref=ASN1RefType(('OCSP-2009', 'RESPONSE')))
    _basicResponse_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'BasicOCSPResponse')))
    basicResponse._val = dict([('Type', _basicResponse_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 1))])
    
    #-----< BasicOCSPResponse >-----#
    BasicOCSPResponse = SEQ(name='BasicOCSPResponse', mode=MODE_TYPE)
    _BasicOCSPResponse_tbsResponseData = SEQ(name='tbsResponseData', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'ResponseData')))
    _BasicOCSPResponse_signatureAlgorithm = SEQ(name='signatureAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __BasicOCSPResponse_signatureAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___BasicOCSPResponse_signatureAlgorithm_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Value_0 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0 = NULL(name='Params', mode=MODE_TYPE)
    ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    ___BasicOCSPResponse_signatureAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Value_0), ('Params', ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_3), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))])], rr=[], ev=None, er=[])
    __BasicOCSPResponse_signatureAlgorithm_algorithm._const_tab = ___BasicOCSPResponse_signatureAlgorithm_algorithm_tab
    __BasicOCSPResponse_signatureAlgorithm_algorithm._const_tab_at = None
    __BasicOCSPResponse_signatureAlgorithm_algorithm._const_tab_id = 'id'
    __BasicOCSPResponse_signatureAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __BasicOCSPResponse_signatureAlgorithm_parameters._const_tab = ___BasicOCSPResponse_signatureAlgorithm_algorithm_tab
    __BasicOCSPResponse_signatureAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __BasicOCSPResponse_signatureAlgorithm_parameters._const_tab_id = 'Params'
    _BasicOCSPResponse_signatureAlgorithm._cont = ASN1Dict([
        ('algorithm', __BasicOCSPResponse_signatureAlgorithm_algorithm),
        ('parameters', __BasicOCSPResponse_signatureAlgorithm_parameters),
        ])
    _BasicOCSPResponse_signatureAlgorithm._ext = None
    _BasicOCSPResponse_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    _BasicOCSPResponse_certs = SEQ_OF(name='certs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __BasicOCSPResponse_certs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    _BasicOCSPResponse_certs._cont = __BasicOCSPResponse_certs__item_
    BasicOCSPResponse._cont = ASN1Dict([
        ('tbsResponseData', _BasicOCSPResponse_tbsResponseData),
        ('signatureAlgorithm', _BasicOCSPResponse_signatureAlgorithm),
        ('signature', _BasicOCSPResponse_signature),
        ('certs', _BasicOCSPResponse_certs),
        ])
    BasicOCSPResponse._ext = None
    
    #-----< ResponseData >-----#
    ResponseData = SEQ(name='ResponseData', mode=MODE_TYPE)
    _ResponseData_version = INT(name='version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OCSP-2009', 'Version')), default=0)
    _ResponseData_responderID = CHOICE(name='responderID', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'ResponderID')))
    _ResponseData_producedAt = TIME_GEN(name='producedAt', mode=MODE_TYPE)
    _ResponseData_responses = SEQ_OF(name='responses', mode=MODE_TYPE)
    __ResponseData_responses__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'SingleResponse')))
    _ResponseData_responses._cont = __ResponseData_responses__item_
    _ResponseData_responseExtensions = SEQ_OF(name='responseExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __ResponseData_responseExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___ResponseData_responseExtensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____ResponseData_responseExtensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____ResponseData_responseExtensions__item__extnID_tab_val_ExtnType_0 = OCT_STR(name='ExtnType', mode=MODE_TYPE)
    ____ResponseData_responseExtensions__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', _____ResponseData_responseExtensions__item__extnID_tab_val_ExtnType_0), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 2))])], rr=[], ev=None, er=[])
    ___ResponseData_responseExtensions__item__extnID._const_tab = ____ResponseData_responseExtensions__item__extnID_tab
    ___ResponseData_responseExtensions__item__extnID._const_tab_at = None
    ___ResponseData_responseExtensions__item__extnID._const_tab_id = 'id'
    ___ResponseData_responseExtensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___ResponseData_responseExtensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____ResponseData_responseExtensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ____ResponseData_responseExtensions__item__extnValue_contain._const_tab = ____ResponseData_responseExtensions__item__extnID_tab
    ____ResponseData_responseExtensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____ResponseData_responseExtensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___ResponseData_responseExtensions__item__extnValue._const_cont = ____ResponseData_responseExtensions__item__extnValue_contain
    __ResponseData_responseExtensions__item_._cont = ASN1Dict([
        ('extnID', ___ResponseData_responseExtensions__item__extnID),
        ('critical', ___ResponseData_responseExtensions__item__critical),
        ('extnValue', ___ResponseData_responseExtensions__item__extnValue),
        ])
    __ResponseData_responseExtensions__item_._ext = None
    _ResponseData_responseExtensions._cont = __ResponseData_responseExtensions__item_
    _ResponseData_responseExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    ResponseData._cont = ASN1Dict([
        ('version', _ResponseData_version),
        ('responderID', _ResponseData_responderID),
        ('producedAt', _ResponseData_producedAt),
        ('responses', _ResponseData_responses),
        ('responseExtensions', _ResponseData_responseExtensions),
        ])
    ResponseData._ext = None
    
    #-----< ResponderID >-----#
    ResponderID = CHOICE(name='ResponderID', mode=MODE_TYPE)
    _ResponderID_byName = CHOICE(name='byName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    _ResponderID_byKey = OCT_STR(name='byKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OCSP-2009', 'KeyHash')))
    ResponderID._cont = ASN1Dict([
        ('byName', _ResponderID_byName),
        ('byKey', _ResponderID_byKey),
        ])
    ResponderID._ext = None
    
    #-----< KeyHash >-----#
    KeyHash = OCT_STR(name='KeyHash', mode=MODE_TYPE)
    
    #-----< SingleResponse >-----#
    SingleResponse = SEQ(name='SingleResponse', mode=MODE_TYPE)
    _SingleResponse_certID = SEQ(name='certID', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'CertID')))
    _SingleResponse_certStatus = CHOICE(name='certStatus', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'CertStatus')))
    _SingleResponse_thisUpdate = TIME_GEN(name='thisUpdate', mode=MODE_TYPE)
    _SingleResponse_nextUpdate = TIME_GEN(name='nextUpdate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _SingleResponse_singleExtensions = SEQ_OF(name='singleExtensions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __SingleResponse_singleExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___SingleResponse_singleExtensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____SingleResponse_singleExtensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_0 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'CrlID')))
    _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_1 = TIME_GEN(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'ArchiveCutoff')))
    _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_2 = ENUM(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLReason')))
    _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_3 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_4 = OID(name='ExtnType', mode=MODE_TYPE)
    _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_5 = TIME_GEN(name='ExtnType', mode=MODE_TYPE)
    ____SingleResponse_singleExtensions__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_0), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 3))]), dict([('ExtnType', _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_1), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 6))]), dict([('ExtnType', _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_2), ('id', (2, 5, 29, 21))]), dict([('ExtnType', _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_3), ('id', (2, 5, 29, 29))]), dict([('ExtnType', _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_4), ('id', (2, 5, 29, 23))]), dict([('ExtnType', _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_5), ('id', (2, 5, 29, 24))])], rr=[], ev=None, er=[])
    ___SingleResponse_singleExtensions__item__extnID._const_tab = ____SingleResponse_singleExtensions__item__extnID_tab
    ___SingleResponse_singleExtensions__item__extnID._const_tab_at = None
    ___SingleResponse_singleExtensions__item__extnID._const_tab_id = 'id'
    ___SingleResponse_singleExtensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___SingleResponse_singleExtensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____SingleResponse_singleExtensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ____SingleResponse_singleExtensions__item__extnValue_contain._const_tab = ____SingleResponse_singleExtensions__item__extnID_tab
    ____SingleResponse_singleExtensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____SingleResponse_singleExtensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___SingleResponse_singleExtensions__item__extnValue._const_cont = ____SingleResponse_singleExtensions__item__extnValue_contain
    __SingleResponse_singleExtensions__item_._cont = ASN1Dict([
        ('extnID', ___SingleResponse_singleExtensions__item__extnID),
        ('critical', ___SingleResponse_singleExtensions__item__critical),
        ('extnValue', ___SingleResponse_singleExtensions__item__extnValue),
        ])
    __SingleResponse_singleExtensions__item_._ext = None
    _SingleResponse_singleExtensions._cont = __SingleResponse_singleExtensions__item_
    _SingleResponse_singleExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    SingleResponse._cont = ASN1Dict([
        ('certID', _SingleResponse_certID),
        ('certStatus', _SingleResponse_certStatus),
        ('thisUpdate', _SingleResponse_thisUpdate),
        ('nextUpdate', _SingleResponse_nextUpdate),
        ('singleExtensions', _SingleResponse_singleExtensions),
        ])
    SingleResponse._ext = None
    
    #-----< CertStatus >-----#
    CertStatus = CHOICE(name='CertStatus', mode=MODE_TYPE)
    _CertStatus_good = NULL(name='good', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CertStatus_revoked = SEQ(name='revoked', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OCSP-2009', 'RevokedInfo')))
    _CertStatus_unknown = NULL(name='unknown', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OCSP-2009', 'UnknownInfo')))
    CertStatus._cont = ASN1Dict([
        ('good', _CertStatus_good),
        ('revoked', _CertStatus_revoked),
        ('unknown', _CertStatus_unknown),
        ])
    CertStatus._ext = None
    
    #-----< RevokedInfo >-----#
    RevokedInfo = SEQ(name='RevokedInfo', mode=MODE_TYPE)
    _RevokedInfo_revocationTime = TIME_GEN(name='revocationTime', mode=MODE_TYPE)
    _RevokedInfo_revocationReason = INT(name='revocationReason', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('OCSP-2009', 'CRLReason')), opt=True)
    RevokedInfo._cont = ASN1Dict([
        ('revocationTime', _RevokedInfo_revocationTime),
        ('revocationReason', _RevokedInfo_revocationReason),
        ])
    RevokedInfo._ext = None
    
    #-----< UnknownInfo >-----#
    UnknownInfo = NULL(name='UnknownInfo', mode=MODE_TYPE)
    
    #-----< CRLReason >-----#
    CRLReason = INT(name='CRLReason', mode=MODE_TYPE)
    
    #-----< ArchiveCutoff >-----#
    ArchiveCutoff = TIME_GEN(name='ArchiveCutoff', mode=MODE_TYPE)
    
    #-----< AcceptableResponses >-----#
    AcceptableResponses = SEQ_OF(name='AcceptableResponses', mode=MODE_TYPE)
    _AcceptableResponses__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('OCSP-2009', 'RESPONSE'), ['id']))
    __AcceptableResponses__item__tab = CLASS(name='_tab_RESPONSE', mode=MODE_SET, typeref=ASN1RefType(('OCSP-2009', 'RESPONSE')))
    ___AcceptableResponses__item__tab_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'BasicOCSPResponse')))
    __AcceptableResponses__item__tab._val = ASN1Set(rv=[dict([('Type', ___AcceptableResponses__item__tab_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 1))])], rr=[], ev=None, er=[])
    _AcceptableResponses__item_._const_tab = __AcceptableResponses__item__tab
    _AcceptableResponses__item_._const_tab_at = None
    _AcceptableResponses__item_._const_tab_id = 'id'
    AcceptableResponses._cont = _AcceptableResponses__item_
    
    #-----< ServiceLocator >-----#
    ServiceLocator = SEQ(name='ServiceLocator', mode=MODE_TYPE)
    _ServiceLocator_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    _ServiceLocator_locator = SEQ_OF(name='locator', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityInfoAccessSyntax')))
    ServiceLocator._cont = ASN1Dict([
        ('issuer', _ServiceLocator_issuer),
        ('locator', _ServiceLocator_locator),
        ])
    ServiceLocator._ext = None
    
    #-----< CrlID >-----#
    CrlID = SEQ(name='CrlID', mode=MODE_TYPE)
    _CrlID_crlUrl = STR_IA5(name='crlUrl', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CrlID_crlNum = INT(name='crlNum', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CrlID_crlTime = TIME_GEN(name='crlTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    CrlID._cont = ASN1Dict([
        ('crlUrl', _CrlID_crlUrl),
        ('crlNum', _CrlID_crlNum),
        ('crlTime', _CrlID_crlTime),
        ])
    CrlID._ext = None
    
    #-----< re-ocsp-nonce >-----#
    re_ocsp_nonce = CLASS(name='re-ocsp-nonce', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _re_ocsp_nonce_val_ExtnType = OCT_STR(name='ExtnType', mode=MODE_TYPE)
    re_ocsp_nonce._val = dict([('ExtnType', _re_ocsp_nonce_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 2))])
    
    #-----< re-ocsp-response >-----#
    re_ocsp_response = CLASS(name='re-ocsp-response', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _re_ocsp_response_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'AcceptableResponses')))
    re_ocsp_response._val = dict([('ExtnType', _re_ocsp_response_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 4))])
    
    #-----< re-ocsp-service-locator >-----#
    re_ocsp_service_locator = CLASS(name='re-ocsp-service-locator', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _re_ocsp_service_locator_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'ServiceLocator')))
    re_ocsp_service_locator._val = dict([('ExtnType', _re_ocsp_service_locator_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 7))])
    
    #-----< re-ocsp-crl >-----#
    re_ocsp_crl = CLASS(name='re-ocsp-crl', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _re_ocsp_crl_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'CrlID')))
    re_ocsp_crl._val = dict([('ExtnType', _re_ocsp_crl_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 3))])
    
    #-----< re-ocsp-archive-cutoff >-----#
    re_ocsp_archive_cutoff = CLASS(name='re-ocsp-archive-cutoff', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _re_ocsp_archive_cutoff_val_ExtnType = TIME_GEN(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('OCSP-2009', 'ArchiveCutoff')))
    re_ocsp_archive_cutoff._val = dict([('ExtnType', _re_ocsp_archive_cutoff_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 48, 1, 6))])
    
    #-----< id-kp-OCSPSigning >-----#
    id_kp_OCSPSigning = OID(name='id-kp-OCSPSigning', mode=MODE_VALUE)
    id_kp_OCSPSigning._val = (1, 3, 6, 1, 5, 5, 7, 3, 9)
    
    #-----< id-pkix-ocsp >-----#
    id_pkix_ocsp = OID(name='id-pkix-ocsp', mode=MODE_VALUE)
    id_pkix_ocsp._val = (1, 3, 6, 1, 5, 5, 7, 48, 1)
    
    #-----< id-pkix-ocsp-basic >-----#
    id_pkix_ocsp_basic = OID(name='id-pkix-ocsp-basic', mode=MODE_VALUE)
    id_pkix_ocsp_basic._val = (1, 3, 6, 1, 5, 5, 7, 48, 1, 1)
    
    #-----< id-pkix-ocsp-nonce >-----#
    id_pkix_ocsp_nonce = OID(name='id-pkix-ocsp-nonce', mode=MODE_VALUE)
    id_pkix_ocsp_nonce._val = (1, 3, 6, 1, 5, 5, 7, 48, 1, 2)
    
    #-----< id-pkix-ocsp-crl >-----#
    id_pkix_ocsp_crl = OID(name='id-pkix-ocsp-crl', mode=MODE_VALUE)
    id_pkix_ocsp_crl._val = (1, 3, 6, 1, 5, 5, 7, 48, 1, 3)
    
    #-----< id-pkix-ocsp-response >-----#
    id_pkix_ocsp_response = OID(name='id-pkix-ocsp-response', mode=MODE_VALUE)
    id_pkix_ocsp_response._val = (1, 3, 6, 1, 5, 5, 7, 48, 1, 4)
    
    #-----< id-pkix-ocsp-nocheck >-----#
    id_pkix_ocsp_nocheck = OID(name='id-pkix-ocsp-nocheck', mode=MODE_VALUE)
    id_pkix_ocsp_nocheck._val = (1, 3, 6, 1, 5, 5, 7, 48, 1, 5)
    
    #-----< id-pkix-ocsp-archive-cutoff >-----#
    id_pkix_ocsp_archive_cutoff = OID(name='id-pkix-ocsp-archive-cutoff', mode=MODE_VALUE)
    id_pkix_ocsp_archive_cutoff._val = (1, 3, 6, 1, 5, 5, 7, 48, 1, 6)
    
    #-----< id-pkix-ocsp-service-locator >-----#
    id_pkix_ocsp_service_locator = OID(name='id-pkix-ocsp-service-locator', mode=MODE_VALUE)
    id_pkix_ocsp_service_locator._val = (1, 3, 6, 1, 5, 5, 7, 48, 1, 7)
    
    _all_ = [
        _OCSPRequest_tbsRequest,
        _OCSPRequest_optionalSignature,
        OCSPRequest,
        _TBSRequest_version,
        _TBSRequest_requestorName,
        __TBSRequest_requestList__item_,
        _TBSRequest_requestList,
        ____TBSRequest_requestExtensions__item__extnID_tab,
        _____TBSRequest_requestExtensions__item__extnID_tab_val_ExtnType_0,
        _____TBSRequest_requestExtensions__item__extnID_tab_val_ExtnType_1,
        ___TBSRequest_requestExtensions__item__extnID,
        ___TBSRequest_requestExtensions__item__critical,
        ____TBSRequest_requestExtensions__item__extnValue_contain,
        ___TBSRequest_requestExtensions__item__extnValue,
        __TBSRequest_requestExtensions__item_,
        _TBSRequest_requestExtensions,
        TBSRequest,
        ___Signature_signatureAlgorithm_algorithm_tab,
        __Signature_signatureAlgorithm_algorithm,
        ___Signature_signatureAlgorithm_parameters_tab,
        __Signature_signatureAlgorithm_parameters,
        _Signature_signatureAlgorithm,
        _Signature_signature,
        __Signature_certs__item_,
        _Signature_certs,
        Signature,
        Version,
        _Request_reqCert,
        ____Request_singleRequestExtensions__item__extnID_tab,
        _____Request_singleRequestExtensions__item__extnID_tab_val_ExtnType_0,
        ___Request_singleRequestExtensions__item__extnID,
        ___Request_singleRequestExtensions__item__critical,
        ____Request_singleRequestExtensions__item__extnValue_contain,
        ___Request_singleRequestExtensions__item__extnValue,
        __Request_singleRequestExtensions__item_,
        _Request_singleRequestExtensions,
        Request,
        ___CertID_hashAlgorithm_algorithm_tab,
        __CertID_hashAlgorithm_algorithm,
        ___CertID_hashAlgorithm_parameters_tab,
        __CertID_hashAlgorithm_parameters,
        _CertID_hashAlgorithm,
        _CertID_issuerNameHash,
        _CertID_issuerKeyHash,
        _CertID_serialNumber,
        CertID,
        _OCSPResponse_responseStatus,
        _OCSPResponse_responseBytes,
        OCSPResponse,
        OCSPResponseStatus,
        RESPONSE,
        ResponseSet,
        _ResponseSet_val_Type_0,
        __ResponseBytes_responseType_tab,
        ___ResponseBytes_responseType_tab_val_Type_0,
        _ResponseBytes_responseType,
        __ResponseBytes_response_contain,
        _ResponseBytes_response,
        ResponseBytes,
        basicResponse,
        _basicResponse_val_Type,
        _BasicOCSPResponse_tbsResponseData,
        ___BasicOCSPResponse_signatureAlgorithm_algorithm_tab,
        ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Value_0,
        ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_0,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0,
        ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0,
        ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_2,
        ____BasicOCSPResponse_signatureAlgorithm_algorithm_tab_val_Params_3,
        __BasicOCSPResponse_signatureAlgorithm_algorithm,
        __BasicOCSPResponse_signatureAlgorithm_parameters,
        _BasicOCSPResponse_signatureAlgorithm,
        _BasicOCSPResponse_signature,
        __BasicOCSPResponse_certs__item_,
        _BasicOCSPResponse_certs,
        BasicOCSPResponse,
        _ResponseData_version,
        _ResponseData_responderID,
        _ResponseData_producedAt,
        __ResponseData_responses__item_,
        _ResponseData_responses,
        ____ResponseData_responseExtensions__item__extnID_tab,
        _____ResponseData_responseExtensions__item__extnID_tab_val_ExtnType_0,
        ___ResponseData_responseExtensions__item__extnID,
        ___ResponseData_responseExtensions__item__critical,
        ____ResponseData_responseExtensions__item__extnValue_contain,
        ___ResponseData_responseExtensions__item__extnValue,
        __ResponseData_responseExtensions__item_,
        _ResponseData_responseExtensions,
        ResponseData,
        _ResponderID_byName,
        _ResponderID_byKey,
        ResponderID,
        KeyHash,
        _SingleResponse_certID,
        _SingleResponse_certStatus,
        _SingleResponse_thisUpdate,
        _SingleResponse_nextUpdate,
        ____SingleResponse_singleExtensions__item__extnID_tab,
        _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_0,
        _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_1,
        _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_2,
        _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_3,
        _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_4,
        _____SingleResponse_singleExtensions__item__extnID_tab_val_ExtnType_5,
        ___SingleResponse_singleExtensions__item__extnID,
        ___SingleResponse_singleExtensions__item__critical,
        ____SingleResponse_singleExtensions__item__extnValue_contain,
        ___SingleResponse_singleExtensions__item__extnValue,
        __SingleResponse_singleExtensions__item_,
        _SingleResponse_singleExtensions,
        SingleResponse,
        _CertStatus_good,
        _CertStatus_revoked,
        _CertStatus_unknown,
        CertStatus,
        _RevokedInfo_revocationTime,
        _RevokedInfo_revocationReason,
        RevokedInfo,
        UnknownInfo,
        CRLReason,
        ArchiveCutoff,
        __AcceptableResponses__item__tab,
        ___AcceptableResponses__item__tab_val_Type_0,
        _AcceptableResponses__item_,
        AcceptableResponses,
        _ServiceLocator_issuer,
        _ServiceLocator_locator,
        ServiceLocator,
        _CrlID_crlUrl,
        _CrlID_crlNum,
        _CrlID_crlTime,
        CrlID,
        re_ocsp_nonce,
        _re_ocsp_nonce_val_ExtnType,
        re_ocsp_response,
        _re_ocsp_response_val_ExtnType,
        re_ocsp_service_locator,
        _re_ocsp_service_locator_val_ExtnType,
        re_ocsp_crl,
        _re_ocsp_crl_val_ExtnType,
        re_ocsp_archive_cutoff,
        _re_ocsp_archive_cutoff_val_ExtnType,
        id_kp_OCSPSigning,
        id_pkix_ocsp,
        id_pkix_ocsp_basic,
        id_pkix_ocsp_nonce,
        id_pkix_ocsp_crl,
        id_pkix_ocsp_response,
        id_pkix_ocsp_nocheck,
        id_pkix_ocsp_archive_cutoff,
        id_pkix_ocsp_service_locator,
    ]

class PKCS_10:

    _name_  = 'PKCS-10'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 69]
    
    _obj_ = [
        'CertificationRequestInfo',
        'SubjectPublicKeyInfo',
        'PKInfoAlgorithms',
        'Attributes',
        'CRIAttributes',
        'Attribute',
        'CertificationRequest',
        'SignatureAlgorithms',
        ]
    _type_ = [
        'CertificationRequestInfo',
        'SubjectPublicKeyInfo',
        'Attributes',
        'Attribute',
        'CertificationRequest',
        ]
    _set_ = [
        'PKInfoAlgorithms',
        'CRIAttributes',
        'SignatureAlgorithms',
        ]
    _val_ = [
        ]
    _class_ = [
        'PKInfoAlgorithms',
        'CRIAttributes',
        'SignatureAlgorithms',
        ]
    _param_ = [
        'SubjectPublicKeyInfo',
        'Attributes',
        'Attribute',
        ]
    
    #-----< CertificationRequestInfo >-----#
    CertificationRequestInfo = SEQ(name='CertificationRequestInfo', mode=MODE_TYPE)
    _CertificationRequestInfo_version = INT(name='version', mode=MODE_TYPE)
    _CertificationRequestInfo_version._cont = ASN1Dict([('v1', 0)])
    _CertificationRequestInfo_version._const_val = ASN1Set(rv=[0], rr=[], ev=[], er=[])
    _CertificationRequestInfo_subject = CHOICE(name='subject', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    _CertificationRequestInfo_subjectPKInfo = SEQ(name='subjectPKInfo', mode=MODE_TYPE, typeref=ASN1RefType(('PKCS-10', 'SubjectPublicKeyInfo')))
    __CertificationRequestInfo_subjectPKInfo_algorithm = SEQ(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    ___CertificationRequestInfo_subjectPKInfo_algorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'PUBLIC-KEY'), ['id']))
    ____CertificationRequestInfo_subjectPKInfo_algorithm_algorithm_tab = CLASS(name='_tab_PUBLIC-KEY', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    ____CertificationRequestInfo_subjectPKInfo_algorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CertificationRequestInfo_subjectPKInfo_algorithm_algorithm._const_tab = ____CertificationRequestInfo_subjectPKInfo_algorithm_algorithm_tab
    ___CertificationRequestInfo_subjectPKInfo_algorithm_algorithm._const_tab_at = None
    ___CertificationRequestInfo_subjectPKInfo_algorithm_algorithm._const_tab_id = 'id'
    ___CertificationRequestInfo_subjectPKInfo_algorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'PUBLIC-KEY'), ['Params']), opt=True)
    ____CertificationRequestInfo_subjectPKInfo_algorithm_parameters_tab = CLASS(name='_tab_PUBLIC-KEY', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    ____CertificationRequestInfo_subjectPKInfo_algorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CertificationRequestInfo_subjectPKInfo_algorithm_parameters._const_tab = ____CertificationRequestInfo_subjectPKInfo_algorithm_parameters_tab
    ___CertificationRequestInfo_subjectPKInfo_algorithm_parameters._const_tab_at = ('..', 'algorithm')
    ___CertificationRequestInfo_subjectPKInfo_algorithm_parameters._const_tab_id = 'Params'
    __CertificationRequestInfo_subjectPKInfo_algorithm._cont = ASN1Dict([
        ('algorithm', ___CertificationRequestInfo_subjectPKInfo_algorithm_algorithm),
        ('parameters', ___CertificationRequestInfo_subjectPKInfo_algorithm_parameters),
        ])
    __CertificationRequestInfo_subjectPKInfo_algorithm._ext = None
    __CertificationRequestInfo_subjectPKInfo_subjectPublicKey = BIT_STR(name='subjectPublicKey', mode=MODE_TYPE)
    _CertificationRequestInfo_subjectPKInfo._cont = ASN1Dict([
        ('algorithm', __CertificationRequestInfo_subjectPKInfo_algorithm),
        ('subjectPublicKey', __CertificationRequestInfo_subjectPKInfo_subjectPublicKey),
        ])
    _CertificationRequestInfo_subjectPKInfo._ext = None
    _CertificationRequestInfo_attributes = SET_OF(name='attributes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKCS-10', 'Attributes')))
    __CertificationRequestInfo_attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKCS-10', 'Attribute')))
    ___CertificationRequestInfo_attributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ____CertificationRequestInfo_attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____CertificationRequestInfo_attributes__item__type_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CertificationRequestInfo_attributes__item__type._const_tab = ____CertificationRequestInfo_attributes__item__type_tab
    ___CertificationRequestInfo_attributes__item__type._const_tab_at = None
    ___CertificationRequestInfo_attributes__item__type._const_tab_id = 'id'
    ___CertificationRequestInfo_attributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____CertificationRequestInfo_attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    _____CertificationRequestInfo_attributes__item__values__item__tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _____CertificationRequestInfo_attributes__item__values__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CertificationRequestInfo_attributes__item__values__item_._const_tab = _____CertificationRequestInfo_attributes__item__values__item__tab
    ____CertificationRequestInfo_attributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____CertificationRequestInfo_attributes__item__values__item_._const_tab_id = 'Type'
    ___CertificationRequestInfo_attributes__item__values._cont = ____CertificationRequestInfo_attributes__item__values__item_
    ___CertificationRequestInfo_attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __CertificationRequestInfo_attributes__item_._cont = ASN1Dict([
        ('type', ___CertificationRequestInfo_attributes__item__type),
        ('values', ___CertificationRequestInfo_attributes__item__values),
        ])
    __CertificationRequestInfo_attributes__item_._ext = None
    _CertificationRequestInfo_attributes._cont = __CertificationRequestInfo_attributes__item_
    CertificationRequestInfo._cont = ASN1Dict([
        ('version', _CertificationRequestInfo_version),
        ('subject', _CertificationRequestInfo_subject),
        ('subjectPKInfo', _CertificationRequestInfo_subjectPKInfo),
        ('attributes', _CertificationRequestInfo_attributes),
        ])
    CertificationRequestInfo._ext = None
    
    #-----< SubjectPublicKeyInfo >-----#
    SubjectPublicKeyInfo = SEQ(name='SubjectPublicKeyInfo', mode=MODE_TYPE, param=True)
    
    #-----< PKInfoAlgorithms >-----#
    PKInfoAlgorithms = CLASS(name='PKInfoAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    PKInfoAlgorithms._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Attributes >-----#
    Attributes = SET_OF(name='Attributes', mode=MODE_TYPE, param=True)
    
    #-----< CRIAttributes >-----#
    CRIAttributes = CLASS(name='CRIAttributes', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    CRIAttributes._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Attribute >-----#
    Attribute = SEQ(name='Attribute', mode=MODE_TYPE, param=True)
    
    #-----< CertificationRequest >-----#
    CertificationRequest = SEQ(name='CertificationRequest', mode=MODE_TYPE)
    _CertificationRequest_certificationRequestInfo = SEQ(name='certificationRequestInfo', mode=MODE_TYPE, typeref=ASN1RefType(('PKCS-10', 'CertificationRequestInfo')))
    _CertificationRequest_signatureAlgorithm = SEQ(name='signatureAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __CertificationRequest_signatureAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___CertificationRequest_signatureAlgorithm_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ___CertificationRequest_signatureAlgorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificationRequest_signatureAlgorithm_algorithm._const_tab = ___CertificationRequest_signatureAlgorithm_algorithm_tab
    __CertificationRequest_signatureAlgorithm_algorithm._const_tab_at = None
    __CertificationRequest_signatureAlgorithm_algorithm._const_tab_id = 'id'
    __CertificationRequest_signatureAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    ___CertificationRequest_signatureAlgorithm_parameters_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ___CertificationRequest_signatureAlgorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __CertificationRequest_signatureAlgorithm_parameters._const_tab = ___CertificationRequest_signatureAlgorithm_parameters_tab
    __CertificationRequest_signatureAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __CertificationRequest_signatureAlgorithm_parameters._const_tab_id = 'Params'
    _CertificationRequest_signatureAlgorithm._cont = ASN1Dict([
        ('algorithm', __CertificationRequest_signatureAlgorithm_algorithm),
        ('parameters', __CertificationRequest_signatureAlgorithm_parameters),
        ])
    _CertificationRequest_signatureAlgorithm._ext = None
    _CertificationRequest_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    CertificationRequest._cont = ASN1Dict([
        ('certificationRequestInfo', _CertificationRequest_certificationRequestInfo),
        ('signatureAlgorithm', _CertificationRequest_signatureAlgorithm),
        ('signature', _CertificationRequest_signature),
        ])
    CertificationRequest._ext = None
    
    #-----< SignatureAlgorithms >-----#
    SignatureAlgorithms = CLASS(name='SignatureAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    SignatureAlgorithms._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    _all_ = [
        _CertificationRequestInfo_version,
        _CertificationRequestInfo_subject,
        ____CertificationRequestInfo_subjectPKInfo_algorithm_algorithm_tab,
        ___CertificationRequestInfo_subjectPKInfo_algorithm_algorithm,
        ____CertificationRequestInfo_subjectPKInfo_algorithm_parameters_tab,
        ___CertificationRequestInfo_subjectPKInfo_algorithm_parameters,
        __CertificationRequestInfo_subjectPKInfo_algorithm,
        __CertificationRequestInfo_subjectPKInfo_subjectPublicKey,
        _CertificationRequestInfo_subjectPKInfo,
        ____CertificationRequestInfo_attributes__item__type_tab,
        ___CertificationRequestInfo_attributes__item__type,
        _____CertificationRequestInfo_attributes__item__values__item__tab,
        ____CertificationRequestInfo_attributes__item__values__item_,
        ___CertificationRequestInfo_attributes__item__values,
        __CertificationRequestInfo_attributes__item_,
        _CertificationRequestInfo_attributes,
        CertificationRequestInfo,
        PKInfoAlgorithms,
        CRIAttributes,
        _CertificationRequest_certificationRequestInfo,
        ___CertificationRequest_signatureAlgorithm_algorithm_tab,
        __CertificationRequest_signatureAlgorithm_algorithm,
        ___CertificationRequest_signatureAlgorithm_parameters_tab,
        __CertificationRequest_signatureAlgorithm_parameters,
        _CertificationRequest_signatureAlgorithm,
        _CertificationRequest_signature,
        CertificationRequest,
        SignatureAlgorithms,
    ]

class PKIX1Explicit_2009:

    _name_  = 'PKIX1Explicit-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 51]
    
    _obj_ = [
        'id-pkix',
        'id-pe',
        'id-qt',
        'id-kp',
        'id-ad',
        'id-qt-cps',
        'id-qt-unotice',
        'id-ad-ocsp',
        'id-ad-caIssuers',
        'id-ad-timeStamping',
        'id-ad-caRepository',
        'AttributeType',
        'id-at',
        'id-at-name',
        'at-name',
        'id-at-surname',
        'at-surname',
        'id-at-givenName',
        'at-givenName',
        'id-at-initials',
        'at-initials',
        'id-at-generationQualifier',
        'at-generationQualifier',
        'DirectoryString',
        'X520name',
        'id-at-commonName',
        'at-x520CommonName',
        'X520CommonName',
        'id-at-localityName',
        'at-x520LocalityName',
        'X520LocalityName',
        'id-at-stateOrProvinceName',
        'at-x520StateOrProvinceName',
        'X520StateOrProvinceName',
        'id-at-organizationName',
        'at-x520OrganizationName',
        'X520OrganizationName',
        'id-at-organizationalUnitName',
        'at-x520OrganizationalUnitName',
        'X520OrganizationalUnitName',
        'id-at-title',
        'at-x520Title',
        'id-at-dnQualifier',
        'at-x520dnQualifier',
        'id-at-countryName',
        'at-x520countryName',
        'id-at-serialNumber',
        'at-x520SerialNumber',
        'id-at-pseudonym',
        'at-x520Pseudonym',
        'id-domainComponent',
        'at-domainComponent',
        'pkcs-9',
        'id-emailAddress',
        'at-emailAddress',
        'Name',
        'RDNSequence',
        'DistinguishedName',
        'RelativeDistinguishedName',
        'SupportedAttributes',
        'Certificate',
        'TBSCertificate',
        'Version',
        'CertificateSerialNumber',
        'Validity',
        'Time',
        'UniqueIdentifier',
        'SubjectPublicKeyInfo',
        'CertificateList',
        'TBSCertList',
        'SignatureAlgorithms',
        'PublicKeyAlgorithms',
        'ub-state-name',
        'ub-organization-name',
        'ub-organizational-unit-name',
        'ub-title',
        'ub-serial-number',
        'ub-pseudonym',
        'ub-emailaddress-length',
        'ub-locality-name',
        'ub-common-name',
        'ub-name',
        'SIGNED',
        ]
    _type_ = [
        'AttributeType',
        'DirectoryString',
        'X520name',
        'X520CommonName',
        'X520LocalityName',
        'X520StateOrProvinceName',
        'X520OrganizationName',
        'X520OrganizationalUnitName',
        'Name',
        'RDNSequence',
        'DistinguishedName',
        'RelativeDistinguishedName',
        'Certificate',
        'TBSCertificate',
        'Version',
        'CertificateSerialNumber',
        'Validity',
        'Time',
        'UniqueIdentifier',
        'SubjectPublicKeyInfo',
        'CertificateList',
        'TBSCertList',
        'SIGNED',
        ]
    _set_ = [
        'SupportedAttributes',
        'SignatureAlgorithms',
        'PublicKeyAlgorithms',
        ]
    _val_ = [
        'id-pkix',
        'id-pe',
        'id-qt',
        'id-kp',
        'id-ad',
        'id-qt-cps',
        'id-qt-unotice',
        'id-ad-ocsp',
        'id-ad-caIssuers',
        'id-ad-timeStamping',
        'id-ad-caRepository',
        'id-at',
        'id-at-name',
        'at-name',
        'id-at-surname',
        'at-surname',
        'id-at-givenName',
        'at-givenName',
        'id-at-initials',
        'at-initials',
        'id-at-generationQualifier',
        'at-generationQualifier',
        'id-at-commonName',
        'at-x520CommonName',
        'id-at-localityName',
        'at-x520LocalityName',
        'id-at-stateOrProvinceName',
        'at-x520StateOrProvinceName',
        'id-at-organizationName',
        'at-x520OrganizationName',
        'id-at-organizationalUnitName',
        'at-x520OrganizationalUnitName',
        'id-at-title',
        'at-x520Title',
        'id-at-dnQualifier',
        'at-x520dnQualifier',
        'id-at-countryName',
        'at-x520countryName',
        'id-at-serialNumber',
        'at-x520SerialNumber',
        'id-at-pseudonym',
        'at-x520Pseudonym',
        'id-domainComponent',
        'at-domainComponent',
        'pkcs-9',
        'id-emailAddress',
        'at-emailAddress',
        'ub-state-name',
        'ub-organization-name',
        'ub-organizational-unit-name',
        'ub-title',
        'ub-serial-number',
        'ub-pseudonym',
        'ub-emailaddress-length',
        'ub-locality-name',
        'ub-common-name',
        'ub-name',
        ]
    _class_ = [
        'at-name',
        'at-surname',
        'at-givenName',
        'at-initials',
        'at-generationQualifier',
        'at-x520CommonName',
        'at-x520LocalityName',
        'at-x520StateOrProvinceName',
        'at-x520OrganizationName',
        'at-x520OrganizationalUnitName',
        'at-x520Title',
        'at-x520dnQualifier',
        'at-x520countryName',
        'at-x520SerialNumber',
        'at-x520Pseudonym',
        'at-domainComponent',
        'at-emailAddress',
        'SupportedAttributes',
        'SignatureAlgorithms',
        'PublicKeyAlgorithms',
        ]
    _param_ = [
        'DirectoryString',
        'SIGNED',
        ]
    
    #-----< id-pkix >-----#
    id_pkix = OID(name='id-pkix', mode=MODE_VALUE)
    id_pkix._val = (1, 3, 6, 1, 5, 5, 7)
    
    #-----< id-pe >-----#
    id_pe = OID(name='id-pe', mode=MODE_VALUE)
    id_pe._val = (1, 3, 6, 1, 5, 5, 7, 1)
    
    #-----< id-qt >-----#
    id_qt = OID(name='id-qt', mode=MODE_VALUE)
    id_qt._val = (1, 3, 6, 1, 5, 5, 7, 2)
    
    #-----< id-kp >-----#
    id_kp = OID(name='id-kp', mode=MODE_VALUE)
    id_kp._val = (1, 3, 6, 1, 5, 5, 7, 3)
    
    #-----< id-ad >-----#
    id_ad = OID(name='id-ad', mode=MODE_VALUE)
    id_ad._val = (1, 3, 6, 1, 5, 5, 7, 48)
    
    #-----< id-qt-cps >-----#
    id_qt_cps = OID(name='id-qt-cps', mode=MODE_VALUE)
    id_qt_cps._val = (1, 3, 6, 1, 5, 5, 7, 2, 1)
    
    #-----< id-qt-unotice >-----#
    id_qt_unotice = OID(name='id-qt-unotice', mode=MODE_VALUE)
    id_qt_unotice._val = (1, 3, 6, 1, 5, 5, 7, 2, 2)
    
    #-----< id-ad-ocsp >-----#
    id_ad_ocsp = OID(name='id-ad-ocsp', mode=MODE_VALUE)
    id_ad_ocsp._val = (1, 3, 6, 1, 5, 5, 7, 48, 1)
    
    #-----< id-ad-caIssuers >-----#
    id_ad_caIssuers = OID(name='id-ad-caIssuers', mode=MODE_VALUE)
    id_ad_caIssuers._val = (1, 3, 6, 1, 5, 5, 7, 48, 2)
    
    #-----< id-ad-timeStamping >-----#
    id_ad_timeStamping = OID(name='id-ad-timeStamping', mode=MODE_VALUE)
    id_ad_timeStamping._val = (1, 3, 6, 1, 5, 5, 7, 48, 3)
    
    #-----< id-ad-caRepository >-----#
    id_ad_caRepository = OID(name='id-ad-caRepository', mode=MODE_VALUE)
    id_ad_caRepository._val = (1, 3, 6, 1, 5, 5, 7, 48, 5)
    
    #-----< AttributeType >-----#
    AttributeType = OID(name='AttributeType', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    
    #-----< id-at >-----#
    id_at = OID(name='id-at', mode=MODE_VALUE)
    id_at._val = (2, 5, 4)
    
    #-----< id-at-name >-----#
    id_at_name = OID(name='id-at-name', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_name._val = (2, 5, 4, 41)
    
    #-----< at-name >-----#
    at_name = CLASS(name='at-name', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_name_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    at_name._val = dict([('Type', _at_name_val_Type), ('id', (2, 5, 4, 41))])
    
    #-----< id-at-surname >-----#
    id_at_surname = OID(name='id-at-surname', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_surname._val = (2, 5, 4, 4)
    
    #-----< at-surname >-----#
    at_surname = CLASS(name='at-surname', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_surname_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    at_surname._val = dict([('Type', _at_surname_val_Type), ('id', (2, 5, 4, 4))])
    
    #-----< id-at-givenName >-----#
    id_at_givenName = OID(name='id-at-givenName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_givenName._val = (2, 5, 4, 42)
    
    #-----< at-givenName >-----#
    at_givenName = CLASS(name='at-givenName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_givenName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    at_givenName._val = dict([('Type', _at_givenName_val_Type), ('id', (2, 5, 4, 42))])
    
    #-----< id-at-initials >-----#
    id_at_initials = OID(name='id-at-initials', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_initials._val = (2, 5, 4, 43)
    
    #-----< at-initials >-----#
    at_initials = CLASS(name='at-initials', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_initials_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    at_initials._val = dict([('Type', _at_initials_val_Type), ('id', (2, 5, 4, 43))])
    
    #-----< id-at-generationQualifier >-----#
    id_at_generationQualifier = OID(name='id-at-generationQualifier', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_generationQualifier._val = (2, 5, 4, 44)
    
    #-----< at-generationQualifier >-----#
    at_generationQualifier = CLASS(name='at-generationQualifier', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_generationQualifier_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    at_generationQualifier._val = dict([('Type', _at_generationQualifier_val_Type), ('id', (2, 5, 4, 44))])
    
    #-----< DirectoryString >-----#
    DirectoryString = CHOICE(name='DirectoryString', mode=MODE_TYPE, param=True)
    
    #-----< X520name >-----#
    X520name = CHOICE(name='X520name', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _X520name_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _X520name_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    _X520name_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _X520name_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    _X520name_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _X520name_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    _X520name_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _X520name_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    _X520name_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _X520name_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    X520name._cont = ASN1Dict([
        ('teletexString', _X520name_teletexString),
        ('printableString', _X520name_printableString),
        ('bmpString', _X520name_bmpString),
        ('universalString', _X520name_universalString),
        ('uTF8String', _X520name_uTF8String),
        ])
    X520name._ext = None
    
    #-----< id-at-commonName >-----#
    id_at_commonName = OID(name='id-at-commonName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_commonName._val = (2, 5, 4, 3)
    
    #-----< at-x520CommonName >-----#
    at_x520CommonName = CLASS(name='at-x520CommonName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_x520CommonName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520CommonName')))
    at_x520CommonName._val = dict([('Type', _at_x520CommonName_val_Type), ('id', (2, 5, 4, 3))])
    
    #-----< X520CommonName >-----#
    X520CommonName = CHOICE(name='X520CommonName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _X520CommonName_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _X520CommonName_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520CommonName_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _X520CommonName_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520CommonName_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _X520CommonName_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520CommonName_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _X520CommonName_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520CommonName_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _X520CommonName_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    X520CommonName._cont = ASN1Dict([
        ('teletexString', _X520CommonName_teletexString),
        ('printableString', _X520CommonName_printableString),
        ('bmpString', _X520CommonName_bmpString),
        ('universalString', _X520CommonName_universalString),
        ('uTF8String', _X520CommonName_uTF8String),
        ])
    X520CommonName._ext = None
    
    #-----< id-at-localityName >-----#
    id_at_localityName = OID(name='id-at-localityName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_localityName._val = (2, 5, 4, 7)
    
    #-----< at-x520LocalityName >-----#
    at_x520LocalityName = CLASS(name='at-x520LocalityName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_x520LocalityName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520LocalityName')))
    at_x520LocalityName._val = dict([('Type', _at_x520LocalityName_val_Type), ('id', (2, 5, 4, 7))])
    
    #-----< X520LocalityName >-----#
    X520LocalityName = CHOICE(name='X520LocalityName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _X520LocalityName_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _X520LocalityName_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _X520LocalityName_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _X520LocalityName_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _X520LocalityName_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _X520LocalityName_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _X520LocalityName_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _X520LocalityName_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _X520LocalityName_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _X520LocalityName_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    X520LocalityName._cont = ASN1Dict([
        ('teletexString', _X520LocalityName_teletexString),
        ('printableString', _X520LocalityName_printableString),
        ('bmpString', _X520LocalityName_bmpString),
        ('universalString', _X520LocalityName_universalString),
        ('uTF8String', _X520LocalityName_uTF8String),
        ])
    X520LocalityName._ext = None
    
    #-----< id-at-stateOrProvinceName >-----#
    id_at_stateOrProvinceName = OID(name='id-at-stateOrProvinceName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_stateOrProvinceName._val = (2, 5, 4, 8)
    
    #-----< at-x520StateOrProvinceName >-----#
    at_x520StateOrProvinceName = CLASS(name='at-x520StateOrProvinceName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_x520StateOrProvinceName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __at_x520StateOrProvinceName_val_Type_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __at_x520StateOrProvinceName_val_Type_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __at_x520StateOrProvinceName_val_Type_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __at_x520StateOrProvinceName_val_Type_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __at_x520StateOrProvinceName_val_Type_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __at_x520StateOrProvinceName_val_Type_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __at_x520StateOrProvinceName_val_Type_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __at_x520StateOrProvinceName_val_Type_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __at_x520StateOrProvinceName_val_Type_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __at_x520StateOrProvinceName_val_Type_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _at_x520StateOrProvinceName_val_Type._cont = ASN1Dict([
        ('teletexString', __at_x520StateOrProvinceName_val_Type_teletexString),
        ('printableString', __at_x520StateOrProvinceName_val_Type_printableString),
        ('bmpString', __at_x520StateOrProvinceName_val_Type_bmpString),
        ('universalString', __at_x520StateOrProvinceName_val_Type_universalString),
        ('uTF8String', __at_x520StateOrProvinceName_val_Type_uTF8String),
        ])
    _at_x520StateOrProvinceName_val_Type._ext = None
    at_x520StateOrProvinceName._val = dict([('Type', _at_x520StateOrProvinceName_val_Type), ('id', (2, 5, 4, 8))])
    
    #-----< X520StateOrProvinceName >-----#
    X520StateOrProvinceName = CHOICE(name='X520StateOrProvinceName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _X520StateOrProvinceName_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _X520StateOrProvinceName_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _X520StateOrProvinceName_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _X520StateOrProvinceName_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _X520StateOrProvinceName_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _X520StateOrProvinceName_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _X520StateOrProvinceName_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _X520StateOrProvinceName_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _X520StateOrProvinceName_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _X520StateOrProvinceName_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    X520StateOrProvinceName._cont = ASN1Dict([
        ('teletexString', _X520StateOrProvinceName_teletexString),
        ('printableString', _X520StateOrProvinceName_printableString),
        ('bmpString', _X520StateOrProvinceName_bmpString),
        ('universalString', _X520StateOrProvinceName_universalString),
        ('uTF8String', _X520StateOrProvinceName_uTF8String),
        ])
    X520StateOrProvinceName._ext = None
    
    #-----< id-at-organizationName >-----#
    id_at_organizationName = OID(name='id-at-organizationName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_organizationName._val = (2, 5, 4, 10)
    
    #-----< at-x520OrganizationName >-----#
    at_x520OrganizationName = CLASS(name='at-x520OrganizationName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_x520OrganizationName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __at_x520OrganizationName_val_Type_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __at_x520OrganizationName_val_Type_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520OrganizationName_val_Type_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __at_x520OrganizationName_val_Type_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520OrganizationName_val_Type_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __at_x520OrganizationName_val_Type_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520OrganizationName_val_Type_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __at_x520OrganizationName_val_Type_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520OrganizationName_val_Type_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __at_x520OrganizationName_val_Type_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _at_x520OrganizationName_val_Type._cont = ASN1Dict([
        ('teletexString', __at_x520OrganizationName_val_Type_teletexString),
        ('printableString', __at_x520OrganizationName_val_Type_printableString),
        ('bmpString', __at_x520OrganizationName_val_Type_bmpString),
        ('universalString', __at_x520OrganizationName_val_Type_universalString),
        ('uTF8String', __at_x520OrganizationName_val_Type_uTF8String),
        ])
    _at_x520OrganizationName_val_Type._ext = None
    at_x520OrganizationName._val = dict([('Type', _at_x520OrganizationName_val_Type), ('id', (2, 5, 4, 10))])
    
    #-----< X520OrganizationName >-----#
    X520OrganizationName = CHOICE(name='X520OrganizationName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _X520OrganizationName_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _X520OrganizationName_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520OrganizationName_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _X520OrganizationName_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520OrganizationName_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _X520OrganizationName_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520OrganizationName_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _X520OrganizationName_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520OrganizationName_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _X520OrganizationName_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    X520OrganizationName._cont = ASN1Dict([
        ('teletexString', _X520OrganizationName_teletexString),
        ('printableString', _X520OrganizationName_printableString),
        ('bmpString', _X520OrganizationName_bmpString),
        ('universalString', _X520OrganizationName_universalString),
        ('uTF8String', _X520OrganizationName_uTF8String),
        ])
    X520OrganizationName._ext = None
    
    #-----< id-at-organizationalUnitName >-----#
    id_at_organizationalUnitName = OID(name='id-at-organizationalUnitName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_organizationalUnitName._val = (2, 5, 4, 11)
    
    #-----< at-x520OrganizationalUnitName >-----#
    at_x520OrganizationalUnitName = CLASS(name='at-x520OrganizationalUnitName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_x520OrganizationalUnitName_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __at_x520OrganizationalUnitName_val_Type_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __at_x520OrganizationalUnitName_val_Type_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520OrganizationalUnitName_val_Type_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __at_x520OrganizationalUnitName_val_Type_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520OrganizationalUnitName_val_Type_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __at_x520OrganizationalUnitName_val_Type_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520OrganizationalUnitName_val_Type_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __at_x520OrganizationalUnitName_val_Type_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520OrganizationalUnitName_val_Type_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __at_x520OrganizationalUnitName_val_Type_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _at_x520OrganizationalUnitName_val_Type._cont = ASN1Dict([
        ('teletexString', __at_x520OrganizationalUnitName_val_Type_teletexString),
        ('printableString', __at_x520OrganizationalUnitName_val_Type_printableString),
        ('bmpString', __at_x520OrganizationalUnitName_val_Type_bmpString),
        ('universalString', __at_x520OrganizationalUnitName_val_Type_universalString),
        ('uTF8String', __at_x520OrganizationalUnitName_val_Type_uTF8String),
        ])
    _at_x520OrganizationalUnitName_val_Type._ext = None
    at_x520OrganizationalUnitName._val = dict([('Type', _at_x520OrganizationalUnitName_val_Type), ('id', (2, 5, 4, 11))])
    
    #-----< X520OrganizationalUnitName >-----#
    X520OrganizationalUnitName = CHOICE(name='X520OrganizationalUnitName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _X520OrganizationalUnitName_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _X520OrganizationalUnitName_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520OrganizationalUnitName_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _X520OrganizationalUnitName_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520OrganizationalUnitName_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _X520OrganizationalUnitName_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520OrganizationalUnitName_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _X520OrganizationalUnitName_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _X520OrganizationalUnitName_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _X520OrganizationalUnitName_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    X520OrganizationalUnitName._cont = ASN1Dict([
        ('teletexString', _X520OrganizationalUnitName_teletexString),
        ('printableString', _X520OrganizationalUnitName_printableString),
        ('bmpString', _X520OrganizationalUnitName_bmpString),
        ('universalString', _X520OrganizationalUnitName_universalString),
        ('uTF8String', _X520OrganizationalUnitName_uTF8String),
        ])
    X520OrganizationalUnitName._ext = None
    
    #-----< id-at-title >-----#
    id_at_title = OID(name='id-at-title', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_title._val = (2, 5, 4, 12)
    
    #-----< at-x520Title >-----#
    at_x520Title = CLASS(name='at-x520Title', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_x520Title_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __at_x520Title_val_Type_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __at_x520Title_val_Type_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520Title_val_Type_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __at_x520Title_val_Type_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520Title_val_Type_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __at_x520Title_val_Type_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520Title_val_Type_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __at_x520Title_val_Type_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __at_x520Title_val_Type_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __at_x520Title_val_Type_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _at_x520Title_val_Type._cont = ASN1Dict([
        ('teletexString', __at_x520Title_val_Type_teletexString),
        ('printableString', __at_x520Title_val_Type_printableString),
        ('bmpString', __at_x520Title_val_Type_bmpString),
        ('universalString', __at_x520Title_val_Type_universalString),
        ('uTF8String', __at_x520Title_val_Type_uTF8String),
        ])
    _at_x520Title_val_Type._ext = None
    at_x520Title._val = dict([('Type', _at_x520Title_val_Type), ('id', (2, 5, 4, 12))])
    
    #-----< id-at-dnQualifier >-----#
    id_at_dnQualifier = OID(name='id-at-dnQualifier', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_dnQualifier._val = (2, 5, 4, 46)
    
    #-----< at-x520dnQualifier >-----#
    at_x520dnQualifier = CLASS(name='at-x520dnQualifier', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_x520dnQualifier_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    at_x520dnQualifier._val = dict([('Type', _at_x520dnQualifier_val_Type), ('id', (2, 5, 4, 46))])
    
    #-----< id-at-countryName >-----#
    id_at_countryName = OID(name='id-at-countryName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_countryName._val = (2, 5, 4, 6)
    
    #-----< at-x520countryName >-----#
    at_x520countryName = CLASS(name='at-x520countryName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_x520countryName_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    _at_x520countryName_val_Type._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    at_x520countryName._val = dict([('Type', _at_x520countryName_val_Type), ('id', (2, 5, 4, 6))])
    
    #-----< id-at-serialNumber >-----#
    id_at_serialNumber = OID(name='id-at-serialNumber', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_serialNumber._val = (2, 5, 4, 5)
    
    #-----< at-x520SerialNumber >-----#
    at_x520SerialNumber = CLASS(name='at-x520SerialNumber', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_x520SerialNumber_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    _at_x520SerialNumber_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    at_x520SerialNumber._val = dict([('Type', _at_x520SerialNumber_val_Type), ('id', (2, 5, 4, 5))])
    
    #-----< id-at-pseudonym >-----#
    id_at_pseudonym = OID(name='id-at-pseudonym', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_at_pseudonym._val = (2, 5, 4, 65)
    
    #-----< at-x520Pseudonym >-----#
    at_x520Pseudonym = CLASS(name='at-x520Pseudonym', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_x520Pseudonym_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __at_x520Pseudonym_val_Type_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __at_x520Pseudonym_val_Type_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __at_x520Pseudonym_val_Type_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __at_x520Pseudonym_val_Type_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __at_x520Pseudonym_val_Type_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __at_x520Pseudonym_val_Type_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __at_x520Pseudonym_val_Type_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __at_x520Pseudonym_val_Type_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __at_x520Pseudonym_val_Type_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __at_x520Pseudonym_val_Type_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _at_x520Pseudonym_val_Type._cont = ASN1Dict([
        ('teletexString', __at_x520Pseudonym_val_Type_teletexString),
        ('printableString', __at_x520Pseudonym_val_Type_printableString),
        ('bmpString', __at_x520Pseudonym_val_Type_bmpString),
        ('universalString', __at_x520Pseudonym_val_Type_universalString),
        ('uTF8String', __at_x520Pseudonym_val_Type_uTF8String),
        ])
    _at_x520Pseudonym_val_Type._ext = None
    at_x520Pseudonym._val = dict([('Type', _at_x520Pseudonym_val_Type), ('id', (2, 5, 4, 65))])
    
    #-----< id-domainComponent >-----#
    id_domainComponent = OID(name='id-domainComponent', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_domainComponent._val = (0, 9, 2342, 19200300, 100, 1, 25)
    
    #-----< at-domainComponent >-----#
    at_domainComponent = CLASS(name='at-domainComponent', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_domainComponent_val_Type = STR_IA5(name='Type', mode=MODE_TYPE)
    at_domainComponent._val = dict([('Type', _at_domainComponent_val_Type), ('id', (0, 9, 2342, 19200300, 100, 1, 25))])
    
    #-----< pkcs-9 >-----#
    pkcs_9 = OID(name='pkcs-9', mode=MODE_VALUE)
    pkcs_9._val = (1, 2, 840, 113549, 1, 9)
    
    #-----< id-emailAddress >-----#
    id_emailAddress = OID(name='id-emailAddress', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'AttributeType')))
    id_emailAddress._val = (1, 2, 840, 113549, 1, 9, 1)
    
    #-----< at-emailAddress >-----#
    at_emailAddress = CLASS(name='at-emailAddress', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_emailAddress_val_Type = STR_IA5(name='Type', mode=MODE_TYPE)
    _at_emailAddress_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    at_emailAddress._val = dict([('Type', _at_emailAddress_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 1))])
    
    #-----< Name >-----#
    Name = CHOICE(name='Name', mode=MODE_TYPE)
    _Name_rdnSequence = SEQ_OF(name='rdnSequence', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'RDNSequence')))
    Name._cont = ASN1Dict([
        ('rdnSequence', _Name_rdnSequence),
        ])
    Name._ext = None
    
    #-----< RDNSequence >-----#
    RDNSequence = SEQ_OF(name='RDNSequence', mode=MODE_TYPE)
    _RDNSequence__item_ = SET_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'RelativeDistinguishedName')))
    RDNSequence._cont = _RDNSequence__item_
    
    #-----< DistinguishedName >-----#
    DistinguishedName = SEQ_OF(name='DistinguishedName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'RDNSequence')))
    
    #-----< RelativeDistinguishedName >-----#
    RelativeDistinguishedName = SET_OF(name='RelativeDistinguishedName', mode=MODE_TYPE)
    _RelativeDistinguishedName__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'SingleAttribute')))
    __RelativeDistinguishedName__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ___RelativeDistinguishedName__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____RelativeDistinguishedName__item__type_tab_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    ____RelativeDistinguishedName__item__type_tab_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    ____RelativeDistinguishedName__item__type_tab_val_Type_2 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    ____RelativeDistinguishedName__item__type_tab_val_Type_3 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    ____RelativeDistinguishedName__item__type_tab_val_Type_4 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    ____RelativeDistinguishedName__item__type_tab_val_Type_5 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520CommonName')))
    ____RelativeDistinguishedName__item__type_tab_val_Type_6 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520LocalityName')))
    ____RelativeDistinguishedName__item__type_tab_val_Type_7 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _____RelativeDistinguishedName__item__type_tab_val_Type_7_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_7_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_7_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_7_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_7_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_7_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_7_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_7_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_7_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_7_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    ____RelativeDistinguishedName__item__type_tab_val_Type_7._cont = ASN1Dict([
        ('teletexString', _____RelativeDistinguishedName__item__type_tab_val_Type_7_teletexString),
        ('printableString', _____RelativeDistinguishedName__item__type_tab_val_Type_7_printableString),
        ('bmpString', _____RelativeDistinguishedName__item__type_tab_val_Type_7_bmpString),
        ('universalString', _____RelativeDistinguishedName__item__type_tab_val_Type_7_universalString),
        ('uTF8String', _____RelativeDistinguishedName__item__type_tab_val_Type_7_uTF8String),
        ])
    ____RelativeDistinguishedName__item__type_tab_val_Type_7._ext = None
    ____RelativeDistinguishedName__item__type_tab_val_Type_8 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _____RelativeDistinguishedName__item__type_tab_val_Type_8_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_8_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_8_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_8_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_8_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_8_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_8_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_8_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_8_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_8_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ____RelativeDistinguishedName__item__type_tab_val_Type_8._cont = ASN1Dict([
        ('teletexString', _____RelativeDistinguishedName__item__type_tab_val_Type_8_teletexString),
        ('printableString', _____RelativeDistinguishedName__item__type_tab_val_Type_8_printableString),
        ('bmpString', _____RelativeDistinguishedName__item__type_tab_val_Type_8_bmpString),
        ('universalString', _____RelativeDistinguishedName__item__type_tab_val_Type_8_universalString),
        ('uTF8String', _____RelativeDistinguishedName__item__type_tab_val_Type_8_uTF8String),
        ])
    ____RelativeDistinguishedName__item__type_tab_val_Type_8._ext = None
    ____RelativeDistinguishedName__item__type_tab_val_Type_9 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _____RelativeDistinguishedName__item__type_tab_val_Type_9_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_9_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_9_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_9_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_9_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_9_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_9_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_9_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_9_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_9_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ____RelativeDistinguishedName__item__type_tab_val_Type_9._cont = ASN1Dict([
        ('teletexString', _____RelativeDistinguishedName__item__type_tab_val_Type_9_teletexString),
        ('printableString', _____RelativeDistinguishedName__item__type_tab_val_Type_9_printableString),
        ('bmpString', _____RelativeDistinguishedName__item__type_tab_val_Type_9_bmpString),
        ('universalString', _____RelativeDistinguishedName__item__type_tab_val_Type_9_universalString),
        ('uTF8String', _____RelativeDistinguishedName__item__type_tab_val_Type_9_uTF8String),
        ])
    ____RelativeDistinguishedName__item__type_tab_val_Type_9._ext = None
    ____RelativeDistinguishedName__item__type_tab_val_Type_10 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _____RelativeDistinguishedName__item__type_tab_val_Type_10_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_10_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_10_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_10_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_10_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_10_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_10_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_10_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_10_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_10_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ____RelativeDistinguishedName__item__type_tab_val_Type_10._cont = ASN1Dict([
        ('teletexString', _____RelativeDistinguishedName__item__type_tab_val_Type_10_teletexString),
        ('printableString', _____RelativeDistinguishedName__item__type_tab_val_Type_10_printableString),
        ('bmpString', _____RelativeDistinguishedName__item__type_tab_val_Type_10_bmpString),
        ('universalString', _____RelativeDistinguishedName__item__type_tab_val_Type_10_universalString),
        ('uTF8String', _____RelativeDistinguishedName__item__type_tab_val_Type_10_uTF8String),
        ])
    ____RelativeDistinguishedName__item__type_tab_val_Type_10._ext = None
    ____RelativeDistinguishedName__item__type_tab_val_Type_11 = STR_PRINT(name='Type', mode=MODE_TYPE)
    ____RelativeDistinguishedName__item__type_tab_val_Type_12 = STR_PRINT(name='Type', mode=MODE_TYPE)
    ____RelativeDistinguishedName__item__type_tab_val_Type_12._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ____RelativeDistinguishedName__item__type_tab_val_Type_13 = STR_PRINT(name='Type', mode=MODE_TYPE)
    ____RelativeDistinguishedName__item__type_tab_val_Type_13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ____RelativeDistinguishedName__item__type_tab_val_Type_14 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _____RelativeDistinguishedName__item__type_tab_val_Type_14_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_14_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_14_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_14_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_14_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_14_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_14_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_14_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____RelativeDistinguishedName__item__type_tab_val_Type_14_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _____RelativeDistinguishedName__item__type_tab_val_Type_14_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    ____RelativeDistinguishedName__item__type_tab_val_Type_14._cont = ASN1Dict([
        ('teletexString', _____RelativeDistinguishedName__item__type_tab_val_Type_14_teletexString),
        ('printableString', _____RelativeDistinguishedName__item__type_tab_val_Type_14_printableString),
        ('bmpString', _____RelativeDistinguishedName__item__type_tab_val_Type_14_bmpString),
        ('universalString', _____RelativeDistinguishedName__item__type_tab_val_Type_14_universalString),
        ('uTF8String', _____RelativeDistinguishedName__item__type_tab_val_Type_14_uTF8String),
        ])
    ____RelativeDistinguishedName__item__type_tab_val_Type_14._ext = None
    ____RelativeDistinguishedName__item__type_tab_val_Type_15 = STR_IA5(name='Type', mode=MODE_TYPE)
    ____RelativeDistinguishedName__item__type_tab_val_Type_16 = STR_IA5(name='Type', mode=MODE_TYPE)
    ____RelativeDistinguishedName__item__type_tab_val_Type_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    ___RelativeDistinguishedName__item__type_tab._val = ASN1Set(rv=[dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_0), ('id', (2, 5, 4, 41))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_1), ('id', (2, 5, 4, 4))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_2), ('id', (2, 5, 4, 42))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_3), ('id', (2, 5, 4, 43))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_4), ('id', (2, 5, 4, 44))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_5), ('id', (2, 5, 4, 3))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_6), ('id', (2, 5, 4, 7))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_7), ('id', (2, 5, 4, 8))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_8), ('id', (2, 5, 4, 10))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_9), ('id', (2, 5, 4, 11))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_10), ('id', (2, 5, 4, 12))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_11), ('id', (2, 5, 4, 46))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_12), ('id', (2, 5, 4, 6))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_13), ('id', (2, 5, 4, 5))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_14), ('id', (2, 5, 4, 65))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_15), ('id', (0, 9, 2342, 19200300, 100, 1, 25))]), dict([('Type', ____RelativeDistinguishedName__item__type_tab_val_Type_16), ('id', (1, 2, 840, 113549, 1, 9, 1))])], rr=[], ev=None, er=[])
    __RelativeDistinguishedName__item__type._const_tab = ___RelativeDistinguishedName__item__type_tab
    __RelativeDistinguishedName__item__type._const_tab_at = None
    __RelativeDistinguishedName__item__type._const_tab_id = 'id'
    __RelativeDistinguishedName__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    __RelativeDistinguishedName__item__value._const_tab = ___RelativeDistinguishedName__item__type_tab
    __RelativeDistinguishedName__item__value._const_tab_at = ('..', 'type')
    __RelativeDistinguishedName__item__value._const_tab_id = 'Type'
    _RelativeDistinguishedName__item_._cont = ASN1Dict([
        ('type', __RelativeDistinguishedName__item__type),
        ('value', __RelativeDistinguishedName__item__value),
        ])
    _RelativeDistinguishedName__item_._ext = None
    RelativeDistinguishedName._cont = _RelativeDistinguishedName__item_
    RelativeDistinguishedName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< SupportedAttributes >-----#
    SupportedAttributes = CLASS(name='SupportedAttributes', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _SupportedAttributes_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    _SupportedAttributes_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    _SupportedAttributes_val_Type_2 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    _SupportedAttributes_val_Type_3 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    _SupportedAttributes_val_Type_4 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    _SupportedAttributes_val_Type_5 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520CommonName')))
    _SupportedAttributes_val_Type_6 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520LocalityName')))
    _SupportedAttributes_val_Type_7 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __SupportedAttributes_val_Type_7_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_7_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __SupportedAttributes_val_Type_7_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_7_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __SupportedAttributes_val_Type_7_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_7_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __SupportedAttributes_val_Type_7_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_7_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __SupportedAttributes_val_Type_7_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_7_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _SupportedAttributes_val_Type_7._cont = ASN1Dict([
        ('teletexString', __SupportedAttributes_val_Type_7_teletexString),
        ('printableString', __SupportedAttributes_val_Type_7_printableString),
        ('bmpString', __SupportedAttributes_val_Type_7_bmpString),
        ('universalString', __SupportedAttributes_val_Type_7_universalString),
        ('uTF8String', __SupportedAttributes_val_Type_7_uTF8String),
        ])
    _SupportedAttributes_val_Type_7._ext = None
    _SupportedAttributes_val_Type_8 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __SupportedAttributes_val_Type_8_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_8_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_8_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_8_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_8_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_8_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_8_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_8_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_8_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_8_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _SupportedAttributes_val_Type_8._cont = ASN1Dict([
        ('teletexString', __SupportedAttributes_val_Type_8_teletexString),
        ('printableString', __SupportedAttributes_val_Type_8_printableString),
        ('bmpString', __SupportedAttributes_val_Type_8_bmpString),
        ('universalString', __SupportedAttributes_val_Type_8_universalString),
        ('uTF8String', __SupportedAttributes_val_Type_8_uTF8String),
        ])
    _SupportedAttributes_val_Type_8._ext = None
    _SupportedAttributes_val_Type_9 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __SupportedAttributes_val_Type_9_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_9_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_9_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_9_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_9_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_9_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_9_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_9_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_9_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_9_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _SupportedAttributes_val_Type_9._cont = ASN1Dict([
        ('teletexString', __SupportedAttributes_val_Type_9_teletexString),
        ('printableString', __SupportedAttributes_val_Type_9_printableString),
        ('bmpString', __SupportedAttributes_val_Type_9_bmpString),
        ('universalString', __SupportedAttributes_val_Type_9_universalString),
        ('uTF8String', __SupportedAttributes_val_Type_9_uTF8String),
        ])
    _SupportedAttributes_val_Type_9._ext = None
    _SupportedAttributes_val_Type_10 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __SupportedAttributes_val_Type_10_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_10_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_10_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_10_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_10_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_10_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_10_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_10_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    __SupportedAttributes_val_Type_10_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_10_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _SupportedAttributes_val_Type_10._cont = ASN1Dict([
        ('teletexString', __SupportedAttributes_val_Type_10_teletexString),
        ('printableString', __SupportedAttributes_val_Type_10_printableString),
        ('bmpString', __SupportedAttributes_val_Type_10_bmpString),
        ('universalString', __SupportedAttributes_val_Type_10_universalString),
        ('uTF8String', __SupportedAttributes_val_Type_10_uTF8String),
        ])
    _SupportedAttributes_val_Type_10._ext = None
    _SupportedAttributes_val_Type_11 = STR_PRINT(name='Type', mode=MODE_TYPE)
    _SupportedAttributes_val_Type_12 = STR_PRINT(name='Type', mode=MODE_TYPE)
    _SupportedAttributes_val_Type_12._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _SupportedAttributes_val_Type_13 = STR_PRINT(name='Type', mode=MODE_TYPE)
    _SupportedAttributes_val_Type_13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _SupportedAttributes_val_Type_14 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __SupportedAttributes_val_Type_14_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_14_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __SupportedAttributes_val_Type_14_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_14_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __SupportedAttributes_val_Type_14_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_14_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __SupportedAttributes_val_Type_14_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_14_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    __SupportedAttributes_val_Type_14_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __SupportedAttributes_val_Type_14_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _SupportedAttributes_val_Type_14._cont = ASN1Dict([
        ('teletexString', __SupportedAttributes_val_Type_14_teletexString),
        ('printableString', __SupportedAttributes_val_Type_14_printableString),
        ('bmpString', __SupportedAttributes_val_Type_14_bmpString),
        ('universalString', __SupportedAttributes_val_Type_14_universalString),
        ('uTF8String', __SupportedAttributes_val_Type_14_uTF8String),
        ])
    _SupportedAttributes_val_Type_14._ext = None
    _SupportedAttributes_val_Type_15 = STR_IA5(name='Type', mode=MODE_TYPE)
    _SupportedAttributes_val_Type_16 = STR_IA5(name='Type', mode=MODE_TYPE)
    _SupportedAttributes_val_Type_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    SupportedAttributes._val = ASN1Set(rv=[dict([('Type', _SupportedAttributes_val_Type_0), ('id', (2, 5, 4, 41))]), dict([('Type', _SupportedAttributes_val_Type_1), ('id', (2, 5, 4, 4))]), dict([('Type', _SupportedAttributes_val_Type_2), ('id', (2, 5, 4, 42))]), dict([('Type', _SupportedAttributes_val_Type_3), ('id', (2, 5, 4, 43))]), dict([('Type', _SupportedAttributes_val_Type_4), ('id', (2, 5, 4, 44))]), dict([('Type', _SupportedAttributes_val_Type_5), ('id', (2, 5, 4, 3))]), dict([('Type', _SupportedAttributes_val_Type_6), ('id', (2, 5, 4, 7))]), dict([('Type', _SupportedAttributes_val_Type_7), ('id', (2, 5, 4, 8))]), dict([('Type', _SupportedAttributes_val_Type_8), ('id', (2, 5, 4, 10))]), dict([('Type', _SupportedAttributes_val_Type_9), ('id', (2, 5, 4, 11))]), dict([('Type', _SupportedAttributes_val_Type_10), ('id', (2, 5, 4, 12))]), dict([('Type', _SupportedAttributes_val_Type_11), ('id', (2, 5, 4, 46))]), dict([('Type', _SupportedAttributes_val_Type_12), ('id', (2, 5, 4, 6))]), dict([('Type', _SupportedAttributes_val_Type_13), ('id', (2, 5, 4, 5))]), dict([('Type', _SupportedAttributes_val_Type_14), ('id', (2, 5, 4, 65))]), dict([('Type', _SupportedAttributes_val_Type_15), ('id', (0, 9, 2342, 19200300, 100, 1, 25))]), dict([('Type', _SupportedAttributes_val_Type_16), ('id', (1, 2, 840, 113549, 1, 9, 1))])], rr=[], ev=[], er=[])
    
    #-----< Certificate >-----#
    Certificate = SEQ(name='Certificate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SIGNED')))
    _Certificate_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'TBSCertificate')))
    _Certificate_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE)
    __Certificate_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___Certificate_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    __SIGNATURE_ALGORITHM_HashSet_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___Certificate_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_3), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_4), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_5), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_6), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_7), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_8), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_9), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_10), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __Certificate_algorithmIdentifier_algorithm._const_tab = ___Certificate_algorithmIdentifier_algorithm_tab
    __Certificate_algorithmIdentifier_algorithm._const_tab_at = None
    __Certificate_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __Certificate_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __Certificate_algorithmIdentifier_parameters._const_tab = ___Certificate_algorithmIdentifier_algorithm_tab
    __Certificate_algorithmIdentifier_parameters._const_tab_at = ('..', '..', 'algorithmIdentifier', 'algorithm')
    __Certificate_algorithmIdentifier_parameters._const_tab_id = 'Params'
    _Certificate_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __Certificate_algorithmIdentifier_algorithm),
        ('parameters', __Certificate_algorithmIdentifier_parameters),
        ])
    _Certificate_algorithmIdentifier._ext = None
    _Certificate_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __Certificate_signature_contain = OPEN(name='_cont_signature', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Value']))
    __Certificate_signature_contain._const_tab = ___Certificate_algorithmIdentifier_algorithm_tab
    __Certificate_signature_contain._const_tab_at = ('..', 'algorithmIdentifier', 'algorithm')
    __Certificate_signature_contain._const_tab_id = 'Value'
    _Certificate_signature._const_cont = __Certificate_signature_contain
    Certificate._cont = ASN1Dict([
        ('toBeSigned', _Certificate_toBeSigned),
        ('algorithmIdentifier', _Certificate_algorithmIdentifier),
        ('signature', _Certificate_signature),
        ])
    Certificate._ext = None
    
    #-----< TBSCertificate >-----#
    TBSCertificate = SEQ(name='TBSCertificate', mode=MODE_TYPE)
    _TBSCertificate_version = INT(name='version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'Version')), default=0)
    _TBSCertificate_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateSerialNumber')))
    _TBSCertificate_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __TBSCertificate_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___TBSCertificate_signature_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____TBSCertificate_signature_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____TBSCertificate_signature_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____TBSCertificate_signature_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____TBSCertificate_signature_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____TBSCertificate_signature_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____TBSCertificate_signature_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____TBSCertificate_signature_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____TBSCertificate_signature_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____TBSCertificate_signature_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertificate_signature_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___TBSCertificate_signature_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____TBSCertificate_signature_algorithm_tab_val_Value_3), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____TBSCertificate_signature_algorithm_tab_val_Value_4), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____TBSCertificate_signature_algorithm_tab_val_Value_5), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____TBSCertificate_signature_algorithm_tab_val_Value_6), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____TBSCertificate_signature_algorithm_tab_val_Value_7), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____TBSCertificate_signature_algorithm_tab_val_Value_8), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____TBSCertificate_signature_algorithm_tab_val_Value_9), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____TBSCertificate_signature_algorithm_tab_val_Value_10), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____TBSCertificate_signature_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __TBSCertificate_signature_algorithm._const_tab = ___TBSCertificate_signature_algorithm_tab
    __TBSCertificate_signature_algorithm._const_tab_at = None
    __TBSCertificate_signature_algorithm._const_tab_id = 'id'
    __TBSCertificate_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __TBSCertificate_signature_parameters._const_tab = ___TBSCertificate_signature_algorithm_tab
    __TBSCertificate_signature_parameters._const_tab_at = ('..', 'algorithm')
    __TBSCertificate_signature_parameters._const_tab_id = 'Params'
    _TBSCertificate_signature._cont = ASN1Dict([
        ('algorithm', __TBSCertificate_signature_algorithm),
        ('parameters', __TBSCertificate_signature_parameters),
        ])
    _TBSCertificate_signature._ext = None
    _TBSCertificate_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    _TBSCertificate_validity = SEQ(name='validity', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Validity')))
    _TBSCertificate_subject = CHOICE(name='subject', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    _TBSCertificate_subjectPublicKeyInfo = SEQ(name='subjectPublicKeyInfo', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SubjectPublicKeyInfo')))
    _TBSCertificate_issuerUniqueID = BIT_STR(name='issuerUniqueID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'UniqueIdentifier')), opt=True, group=0)
    _TBSCertificate_subjectUniqueID = BIT_STR(name='subjectUniqueID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'UniqueIdentifier')), opt=True, group=0)
    _TBSCertificate_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True, group=1)
    __TBSCertificate_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___TBSCertificate_extensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____TBSCertificate_extensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_0 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityKeyIdentifier')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_1 = OCT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyIdentifier')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_2 = BIT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyUsage')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_3 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PrivateKeyUsagePeriod')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_4 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CertificatePolicies')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_5 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyMappings')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_6 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_7 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_8 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectDirectoryAttributes')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_9 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'BasicConstraints')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_10 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'NameConstraints')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_11 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyConstraints')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_12 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'ExtKeyUsageSyntax')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_13 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_14 = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SkipCerts')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_15 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_16 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityInfoAccessSyntax')))
    _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_17 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectInfoAccessSyntax')))
    ____TBSCertificate_extensions__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_0), ('id', (2, 5, 29, 35))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_1), ('id', (2, 5, 29, 14))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_2), ('id', (2, 5, 29, 15))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_3), ('id', (2, 5, 29, 16))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_4), ('id', (2, 5, 29, 32))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_5), ('id', (2, 5, 29, 33))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_6), ('id', (2, 5, 29, 17))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_7), ('id', (2, 5, 29, 18))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_8), ('id', (2, 5, 29, 9))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_9), ('id', (2, 5, 29, 19))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_10), ('id', (2, 5, 29, 30))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_11), ('id', (2, 5, 29, 36))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_12), ('id', (2, 5, 29, 37))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_13), ('id', (2, 5, 29, 31))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_14), ('id', (2, 5, 29, 54))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_15), ('id', (2, 5, 29, 46))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_16), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 1))]), dict([('ExtnType', _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_17), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 11))])], rr=[], ev=None, er=[])
    ___TBSCertificate_extensions__item__extnID._const_tab = ____TBSCertificate_extensions__item__extnID_tab
    ___TBSCertificate_extensions__item__extnID._const_tab_at = None
    ___TBSCertificate_extensions__item__extnID._const_tab_id = 'id'
    ___TBSCertificate_extensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___TBSCertificate_extensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____TBSCertificate_extensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ____TBSCertificate_extensions__item__extnValue_contain._const_tab = ____TBSCertificate_extensions__item__extnID_tab
    ____TBSCertificate_extensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____TBSCertificate_extensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___TBSCertificate_extensions__item__extnValue._const_cont = ____TBSCertificate_extensions__item__extnValue_contain
    __TBSCertificate_extensions__item_._cont = ASN1Dict([
        ('extnID', ___TBSCertificate_extensions__item__extnID),
        ('critical', ___TBSCertificate_extensions__item__critical),
        ('extnValue', ___TBSCertificate_extensions__item__extnValue),
        ])
    __TBSCertificate_extensions__item_._ext = None
    _TBSCertificate_extensions._cont = __TBSCertificate_extensions__item_
    _TBSCertificate_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    TBSCertificate._cont = ASN1Dict([
        ('version', _TBSCertificate_version),
        ('serialNumber', _TBSCertificate_serialNumber),
        ('signature', _TBSCertificate_signature),
        ('issuer', _TBSCertificate_issuer),
        ('validity', _TBSCertificate_validity),
        ('subject', _TBSCertificate_subject),
        ('subjectPublicKeyInfo', _TBSCertificate_subjectPublicKeyInfo),
        ('issuerUniqueID', _TBSCertificate_issuerUniqueID),
        ('subjectUniqueID', _TBSCertificate_subjectUniqueID),
        ('extensions', _TBSCertificate_extensions),
        ])
    TBSCertificate._ext = ['issuerUniqueID', 'subjectUniqueID', 'extensions']
    
    #-----< Version >-----#
    Version = INT(name='Version', mode=MODE_TYPE)
    Version._cont = ASN1Dict([('v1', 0), ('v2', 1), ('v3', 2)])
    
    #-----< CertificateSerialNumber >-----#
    CertificateSerialNumber = INT(name='CertificateSerialNumber', mode=MODE_TYPE)
    
    #-----< Validity >-----#
    Validity = SEQ(name='Validity', mode=MODE_TYPE)
    _Validity_notBefore = CHOICE(name='notBefore', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Time')))
    _Validity_notAfter = CHOICE(name='notAfter', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Time')))
    Validity._cont = ASN1Dict([
        ('notBefore', _Validity_notBefore),
        ('notAfter', _Validity_notAfter),
        ])
    Validity._ext = None
    
    #-----< Time >-----#
    Time = CHOICE(name='Time', mode=MODE_TYPE)
    _Time_utcTime = TIME_UTC(name='utcTime', mode=MODE_TYPE)
    _Time_generalTime = TIME_GEN(name='generalTime', mode=MODE_TYPE)
    Time._cont = ASN1Dict([
        ('utcTime', _Time_utcTime),
        ('generalTime', _Time_generalTime),
        ])
    Time._ext = None
    
    #-----< UniqueIdentifier >-----#
    UniqueIdentifier = BIT_STR(name='UniqueIdentifier', mode=MODE_TYPE)
    
    #-----< SubjectPublicKeyInfo >-----#
    SubjectPublicKeyInfo = SEQ(name='SubjectPublicKeyInfo', mode=MODE_TYPE)
    _SubjectPublicKeyInfo_algorithm = SEQ(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __SubjectPublicKeyInfo_algorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'PUBLIC-KEY'), ['id']))
    ___SubjectPublicKeyInfo_algorithm_algorithm_tab = CLASS(name='_tab_PUBLIC-KEY', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_1 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_2 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_2 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DomainParameters')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_3 = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'KEA-Params-Id')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_4 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_4 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_5 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_5 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_6 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_6 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_7 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_7 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_8 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_8 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    ___SubjectPublicKeyInfo_algorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_0), ('Params', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_1), ('Params', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_1), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))]), dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_2), ('Params', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_2), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))]), dict([('id', (2, 16, 840, 1, 101, 2, 1, 1, 22)), ('Params', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_3), ('paramPresence', 'required'), ('keyUsage', (19, 9))])], rr=[], ev=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_4), ('Params', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_4), ('paramPresence', 'required'), ('keyUsage', (103, 7))]), dict([('id', (1, 3, 132, 1, 12)), ('KeyValue', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_5), ('Params', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_5), ('paramPresence', 'required'), ('keyUsage', (19, 9))]), dict([('id', (1, 3, 132, 1, 13)), ('KeyValue', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_6), ('Params', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_6), ('paramPresence', 'required'), ('keyUsage', (19, 9))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_7), ('Params', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_7), ('paramPresence', 'optional'), ('keyUsage', (99, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 7)), ('KeyValue', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_8), ('Params', ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_8), ('paramPresence', 'optional'), ('keyUsage', (3, 4))])], er=[])
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab = ___SubjectPublicKeyInfo_algorithm_algorithm_tab
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab_at = None
    __SubjectPublicKeyInfo_algorithm_algorithm._const_tab_id = 'id'
    __SubjectPublicKeyInfo_algorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'PUBLIC-KEY'), ['Params']), opt=True)
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab = ___SubjectPublicKeyInfo_algorithm_algorithm_tab
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab_at = ('..', 'algorithm')
    __SubjectPublicKeyInfo_algorithm_parameters._const_tab_id = 'Params'
    _SubjectPublicKeyInfo_algorithm._cont = ASN1Dict([
        ('algorithm', __SubjectPublicKeyInfo_algorithm_algorithm),
        ('parameters', __SubjectPublicKeyInfo_algorithm_parameters),
        ])
    _SubjectPublicKeyInfo_algorithm._ext = None
    _SubjectPublicKeyInfo_subjectPublicKey = BIT_STR(name='subjectPublicKey', mode=MODE_TYPE)
    SubjectPublicKeyInfo._cont = ASN1Dict([
        ('algorithm', _SubjectPublicKeyInfo_algorithm),
        ('subjectPublicKey', _SubjectPublicKeyInfo_subjectPublicKey),
        ])
    SubjectPublicKeyInfo._ext = None
    
    #-----< CertificateList >-----#
    CertificateList = SEQ(name='CertificateList', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SIGNED')))
    _CertificateList_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'TBSCertList')))
    _CertificateList_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE)
    __CertificateList_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___CertificateList_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___CertificateList_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_3), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_4), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_5), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_6), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_7), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_8), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_9), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_10), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __CertificateList_algorithmIdentifier_algorithm._const_tab = ___CertificateList_algorithmIdentifier_algorithm_tab
    __CertificateList_algorithmIdentifier_algorithm._const_tab_at = None
    __CertificateList_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __CertificateList_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __CertificateList_algorithmIdentifier_parameters._const_tab = ___CertificateList_algorithmIdentifier_algorithm_tab
    __CertificateList_algorithmIdentifier_parameters._const_tab_at = ('..', '..', 'algorithmIdentifier', 'algorithm')
    __CertificateList_algorithmIdentifier_parameters._const_tab_id = 'Params'
    _CertificateList_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __CertificateList_algorithmIdentifier_algorithm),
        ('parameters', __CertificateList_algorithmIdentifier_parameters),
        ])
    _CertificateList_algorithmIdentifier._ext = None
    _CertificateList_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __CertificateList_signature_contain = OPEN(name='_cont_signature', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Value']))
    __CertificateList_signature_contain._const_tab = ___CertificateList_algorithmIdentifier_algorithm_tab
    __CertificateList_signature_contain._const_tab_at = ('..', 'algorithmIdentifier', 'algorithm')
    __CertificateList_signature_contain._const_tab_id = 'Value'
    _CertificateList_signature._const_cont = __CertificateList_signature_contain
    CertificateList._cont = ASN1Dict([
        ('toBeSigned', _CertificateList_toBeSigned),
        ('algorithmIdentifier', _CertificateList_algorithmIdentifier),
        ('signature', _CertificateList_signature),
        ])
    CertificateList._ext = None
    
    #-----< TBSCertList >-----#
    TBSCertList = SEQ(name='TBSCertList', mode=MODE_TYPE)
    _TBSCertList_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Version')), opt=True)
    _TBSCertList_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __TBSCertList_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___TBSCertList_signature_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____TBSCertList_signature_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____TBSCertList_signature_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____TBSCertList_signature_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____TBSCertList_signature_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____TBSCertList_signature_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____TBSCertList_signature_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____TBSCertList_signature_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____TBSCertList_signature_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____TBSCertList_signature_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____TBSCertList_signature_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___TBSCertList_signature_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____TBSCertList_signature_algorithm_tab_val_Value_3), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____TBSCertList_signature_algorithm_tab_val_Value_4), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____TBSCertList_signature_algorithm_tab_val_Value_5), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____TBSCertList_signature_algorithm_tab_val_Value_6), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____TBSCertList_signature_algorithm_tab_val_Value_7), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____TBSCertList_signature_algorithm_tab_val_Value_8), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____TBSCertList_signature_algorithm_tab_val_Value_9), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____TBSCertList_signature_algorithm_tab_val_Value_10), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____TBSCertList_signature_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __TBSCertList_signature_algorithm._const_tab = ___TBSCertList_signature_algorithm_tab
    __TBSCertList_signature_algorithm._const_tab_at = None
    __TBSCertList_signature_algorithm._const_tab_id = 'id'
    __TBSCertList_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __TBSCertList_signature_parameters._const_tab = ___TBSCertList_signature_algorithm_tab
    __TBSCertList_signature_parameters._const_tab_at = ('..', 'algorithm')
    __TBSCertList_signature_parameters._const_tab_id = 'Params'
    _TBSCertList_signature._cont = ASN1Dict([
        ('algorithm', __TBSCertList_signature_algorithm),
        ('parameters', __TBSCertList_signature_parameters),
        ])
    _TBSCertList_signature._ext = None
    _TBSCertList_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    _TBSCertList_thisUpdate = CHOICE(name='thisUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Time')))
    _TBSCertList_nextUpdate = CHOICE(name='nextUpdate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Time')), opt=True)
    _TBSCertList_revokedCertificates = SEQ_OF(name='revokedCertificates', mode=MODE_TYPE, opt=True)
    __TBSCertList_revokedCertificates__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    ___TBSCertList_revokedCertificates__item__userCertificate = INT(name='userCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateSerialNumber')))
    ___TBSCertList_revokedCertificates__item__revocationDate = CHOICE(name='revocationDate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Time')))
    ___TBSCertList_revokedCertificates__item__crlEntryExtensions = SEQ_OF(name='crlEntryExtensions', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True, group=0)
    ____TBSCertList_revokedCertificates__item__crlEntryExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_0 = ENUM(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLReason')))
    _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_1 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_2 = OID(name='ExtnType', mode=MODE_TYPE)
    _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_3 = TIME_GEN(name='ExtnType', mode=MODE_TYPE)
    ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_0), ('id', (2, 5, 29, 21))]), dict([('ExtnType', _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_1), ('id', (2, 5, 29, 29))]), dict([('ExtnType', _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_2), ('id', (2, 5, 29, 23))]), dict([('ExtnType', _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_3), ('id', (2, 5, 29, 24))])], rr=[], ev=None, er=[])
    _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID._const_tab = ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab
    _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID._const_tab_at = None
    _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID._const_tab_id = 'id'
    _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnValue_contain._const_tab = ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab
    ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnValue._const_cont = ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnValue_contain
    ____TBSCertList_revokedCertificates__item__crlEntryExtensions__item_._cont = ASN1Dict([
        ('extnID', _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID),
        ('critical', _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__critical),
        ('extnValue', _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnValue),
        ])
    ____TBSCertList_revokedCertificates__item__crlEntryExtensions__item_._ext = None
    ___TBSCertList_revokedCertificates__item__crlEntryExtensions._cont = ____TBSCertList_revokedCertificates__item__crlEntryExtensions__item_
    ___TBSCertList_revokedCertificates__item__crlEntryExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __TBSCertList_revokedCertificates__item_._cont = ASN1Dict([
        ('userCertificate', ___TBSCertList_revokedCertificates__item__userCertificate),
        ('revocationDate', ___TBSCertList_revokedCertificates__item__revocationDate),
        ('crlEntryExtensions', ___TBSCertList_revokedCertificates__item__crlEntryExtensions),
        ])
    __TBSCertList_revokedCertificates__item_._ext = ['crlEntryExtensions']
    _TBSCertList_revokedCertificates._cont = __TBSCertList_revokedCertificates__item_
    _TBSCertList_revokedCertificates._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _TBSCertList_crlExtensions = SEQ_OF(name='crlExtensions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True, group=0)
    __TBSCertList_crlExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___TBSCertList_crlExtensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____TBSCertList_crlExtensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_0 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityKeyIdentifier')))
    _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_1 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_2 = INT(name='ExtnType', mode=MODE_TYPE)
    _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_3 = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLNumber')))
    _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_4 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'IssuingDistributionPoint')))
    _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_5 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    ____TBSCertList_crlExtensions__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_0), ('id', (2, 5, 29, 35))]), dict([('ExtnType', _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_1), ('id', (2, 5, 29, 18))]), dict([('ExtnType', _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_2), ('id', (2, 5, 29, 20))]), dict([('ExtnType', _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_3), ('id', (2, 5, 29, 27))]), dict([('ExtnType', _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_4), ('id', (2, 5, 29, 28))]), dict([('ExtnType', _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_5), ('id', (2, 5, 29, 46))])], rr=[], ev=None, er=[])
    ___TBSCertList_crlExtensions__item__extnID._const_tab = ____TBSCertList_crlExtensions__item__extnID_tab
    ___TBSCertList_crlExtensions__item__extnID._const_tab_at = None
    ___TBSCertList_crlExtensions__item__extnID._const_tab_id = 'id'
    ___TBSCertList_crlExtensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___TBSCertList_crlExtensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____TBSCertList_crlExtensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ____TBSCertList_crlExtensions__item__extnValue_contain._const_tab = ____TBSCertList_crlExtensions__item__extnID_tab
    ____TBSCertList_crlExtensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____TBSCertList_crlExtensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___TBSCertList_crlExtensions__item__extnValue._const_cont = ____TBSCertList_crlExtensions__item__extnValue_contain
    __TBSCertList_crlExtensions__item_._cont = ASN1Dict([
        ('extnID', ___TBSCertList_crlExtensions__item__extnID),
        ('critical', ___TBSCertList_crlExtensions__item__critical),
        ('extnValue', ___TBSCertList_crlExtensions__item__extnValue),
        ])
    __TBSCertList_crlExtensions__item_._ext = None
    _TBSCertList_crlExtensions._cont = __TBSCertList_crlExtensions__item_
    _TBSCertList_crlExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    TBSCertList._cont = ASN1Dict([
        ('version', _TBSCertList_version),
        ('signature', _TBSCertList_signature),
        ('issuer', _TBSCertList_issuer),
        ('thisUpdate', _TBSCertList_thisUpdate),
        ('nextUpdate', _TBSCertList_nextUpdate),
        ('revokedCertificates', _TBSCertList_revokedCertificates),
        ('crlExtensions', _TBSCertList_crlExtensions),
        ])
    TBSCertList._ext = ['crlExtensions']
    
    #-----< SignatureAlgorithms >-----#
    SignatureAlgorithms = CLASS(name='SignatureAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _SignatureAlgorithms_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _SignatureAlgorithms_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _SignatureAlgorithms_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _SignatureAlgorithms_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _SignatureAlgorithms_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _SignatureAlgorithms_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _SignatureAlgorithms_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _SignatureAlgorithms_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _SignatureAlgorithms_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgorithms_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    SignatureAlgorithms._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', _SignatureAlgorithms_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', _SignatureAlgorithms_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', _SignatureAlgorithms_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', _SignatureAlgorithms_val_Value_3), ('Params', _SignatureAlgorithms_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', _SignatureAlgorithms_val_Value_4), ('Params', _SignatureAlgorithms_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', _SignatureAlgorithms_val_Value_5), ('Params', _SignatureAlgorithms_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', _SignatureAlgorithms_val_Value_6), ('Params', _SignatureAlgorithms_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', _SignatureAlgorithms_val_Value_7), ('Params', _SignatureAlgorithms_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', _SignatureAlgorithms_val_Value_8), ('Params', _SignatureAlgorithms_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', _SignatureAlgorithms_val_Value_9), ('Params', _SignatureAlgorithms_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', _SignatureAlgorithms_val_Value_10), ('Params', _SignatureAlgorithms_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', _SignatureAlgorithms_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    
    #-----< PublicKeyAlgorithms >-----#
    PublicKeyAlgorithms = CLASS(name='PublicKeyAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _PublicKeyAlgorithms_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _PublicKeyAlgorithms_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _PublicKeyAlgorithms_val_KeyValue_1 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    _PublicKeyAlgorithms_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    _PublicKeyAlgorithms_val_KeyValue_2 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    _PublicKeyAlgorithms_val_Params_2 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DomainParameters')))
    _PublicKeyAlgorithms_val_Params_3 = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'KEA-Params-Id')))
    _PublicKeyAlgorithms_val_KeyValue_4 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    _PublicKeyAlgorithms_val_Params_4 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    _PublicKeyAlgorithms_val_KeyValue_5 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    _PublicKeyAlgorithms_val_Params_5 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    _PublicKeyAlgorithms_val_KeyValue_6 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    _PublicKeyAlgorithms_val_Params_6 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    _PublicKeyAlgorithms_val_KeyValue_7 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _PublicKeyAlgorithms_val_Params_7 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    _PublicKeyAlgorithms_val_KeyValue_8 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _PublicKeyAlgorithms_val_Params_8 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    PublicKeyAlgorithms._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', _PublicKeyAlgorithms_val_KeyValue_0), ('Params', _PublicKeyAlgorithms_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', _PublicKeyAlgorithms_val_KeyValue_1), ('Params', _PublicKeyAlgorithms_val_Params_1), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))]), dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _PublicKeyAlgorithms_val_KeyValue_2), ('Params', _PublicKeyAlgorithms_val_Params_2), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))]), dict([('id', (2, 16, 840, 1, 101, 2, 1, 1, 22)), ('Params', _PublicKeyAlgorithms_val_Params_3), ('paramPresence', 'required'), ('keyUsage', (19, 9))])], rr=[], ev=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', _PublicKeyAlgorithms_val_KeyValue_4), ('Params', _PublicKeyAlgorithms_val_Params_4), ('paramPresence', 'required'), ('keyUsage', (103, 7))]), dict([('id', (1, 3, 132, 1, 12)), ('KeyValue', _PublicKeyAlgorithms_val_KeyValue_5), ('Params', _PublicKeyAlgorithms_val_Params_5), ('paramPresence', 'required'), ('keyUsage', (19, 9))]), dict([('id', (1, 3, 132, 1, 13)), ('KeyValue', _PublicKeyAlgorithms_val_KeyValue_6), ('Params', _PublicKeyAlgorithms_val_Params_6), ('paramPresence', 'required'), ('keyUsage', (19, 9))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', _PublicKeyAlgorithms_val_KeyValue_7), ('Params', _PublicKeyAlgorithms_val_Params_7), ('paramPresence', 'optional'), ('keyUsage', (99, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 7)), ('KeyValue', _PublicKeyAlgorithms_val_KeyValue_8), ('Params', _PublicKeyAlgorithms_val_Params_8), ('paramPresence', 'optional'), ('keyUsage', (3, 4))])], er=[])
    
    #-----< ub-state-name >-----#
    ub_state_name = INT(name='ub-state-name', mode=MODE_VALUE)
    ub_state_name._val = 128
    
    #-----< ub-organization-name >-----#
    ub_organization_name = INT(name='ub-organization-name', mode=MODE_VALUE)
    ub_organization_name._val = 64
    
    #-----< ub-organizational-unit-name >-----#
    ub_organizational_unit_name = INT(name='ub-organizational-unit-name', mode=MODE_VALUE)
    ub_organizational_unit_name._val = 64
    
    #-----< ub-title >-----#
    ub_title = INT(name='ub-title', mode=MODE_VALUE)
    ub_title._val = 64
    
    #-----< ub-serial-number >-----#
    ub_serial_number = INT(name='ub-serial-number', mode=MODE_VALUE)
    ub_serial_number._val = 64
    
    #-----< ub-pseudonym >-----#
    ub_pseudonym = INT(name='ub-pseudonym', mode=MODE_VALUE)
    ub_pseudonym._val = 128
    
    #-----< ub-emailaddress-length >-----#
    ub_emailaddress_length = INT(name='ub-emailaddress-length', mode=MODE_VALUE)
    ub_emailaddress_length._val = 255
    
    #-----< ub-locality-name >-----#
    ub_locality_name = INT(name='ub-locality-name', mode=MODE_VALUE)
    ub_locality_name._val = 128
    
    #-----< ub-common-name >-----#
    ub_common_name = INT(name='ub-common-name', mode=MODE_VALUE)
    ub_common_name._val = 64
    
    #-----< ub-name >-----#
    ub_name = INT(name='ub-name', mode=MODE_VALUE)
    ub_name._val = 32768
    
    #-----< SIGNED >-----#
    SIGNED = SEQ(name='SIGNED', mode=MODE_TYPE, param=True)
    
    _all_ = [
        id_pkix,
        id_pe,
        id_qt,
        id_kp,
        id_ad,
        id_qt_cps,
        id_qt_unotice,
        id_ad_ocsp,
        id_ad_caIssuers,
        id_ad_timeStamping,
        id_ad_caRepository,
        AttributeType,
        id_at,
        id_at_name,
        at_name,
        _at_name_val_Type,
        id_at_surname,
        at_surname,
        _at_surname_val_Type,
        id_at_givenName,
        at_givenName,
        _at_givenName_val_Type,
        id_at_initials,
        at_initials,
        _at_initials_val_Type,
        id_at_generationQualifier,
        at_generationQualifier,
        _at_generationQualifier_val_Type,
        _X520name_teletexString,
        _X520name_printableString,
        _X520name_bmpString,
        _X520name_universalString,
        _X520name_uTF8String,
        X520name,
        id_at_commonName,
        at_x520CommonName,
        _at_x520CommonName_val_Type,
        _X520CommonName_teletexString,
        _X520CommonName_printableString,
        _X520CommonName_bmpString,
        _X520CommonName_universalString,
        _X520CommonName_uTF8String,
        X520CommonName,
        id_at_localityName,
        at_x520LocalityName,
        _at_x520LocalityName_val_Type,
        _X520LocalityName_teletexString,
        _X520LocalityName_printableString,
        _X520LocalityName_bmpString,
        _X520LocalityName_universalString,
        _X520LocalityName_uTF8String,
        X520LocalityName,
        id_at_stateOrProvinceName,
        at_x520StateOrProvinceName,
        __at_x520StateOrProvinceName_val_Type_teletexString,
        __at_x520StateOrProvinceName_val_Type_printableString,
        __at_x520StateOrProvinceName_val_Type_bmpString,
        __at_x520StateOrProvinceName_val_Type_universalString,
        __at_x520StateOrProvinceName_val_Type_uTF8String,
        _at_x520StateOrProvinceName_val_Type,
        _X520StateOrProvinceName_teletexString,
        _X520StateOrProvinceName_printableString,
        _X520StateOrProvinceName_bmpString,
        _X520StateOrProvinceName_universalString,
        _X520StateOrProvinceName_uTF8String,
        X520StateOrProvinceName,
        id_at_organizationName,
        at_x520OrganizationName,
        __at_x520OrganizationName_val_Type_teletexString,
        __at_x520OrganizationName_val_Type_printableString,
        __at_x520OrganizationName_val_Type_bmpString,
        __at_x520OrganizationName_val_Type_universalString,
        __at_x520OrganizationName_val_Type_uTF8String,
        _at_x520OrganizationName_val_Type,
        _X520OrganizationName_teletexString,
        _X520OrganizationName_printableString,
        _X520OrganizationName_bmpString,
        _X520OrganizationName_universalString,
        _X520OrganizationName_uTF8String,
        X520OrganizationName,
        id_at_organizationalUnitName,
        at_x520OrganizationalUnitName,
        __at_x520OrganizationalUnitName_val_Type_teletexString,
        __at_x520OrganizationalUnitName_val_Type_printableString,
        __at_x520OrganizationalUnitName_val_Type_bmpString,
        __at_x520OrganizationalUnitName_val_Type_universalString,
        __at_x520OrganizationalUnitName_val_Type_uTF8String,
        _at_x520OrganizationalUnitName_val_Type,
        _X520OrganizationalUnitName_teletexString,
        _X520OrganizationalUnitName_printableString,
        _X520OrganizationalUnitName_bmpString,
        _X520OrganizationalUnitName_universalString,
        _X520OrganizationalUnitName_uTF8String,
        X520OrganizationalUnitName,
        id_at_title,
        at_x520Title,
        __at_x520Title_val_Type_teletexString,
        __at_x520Title_val_Type_printableString,
        __at_x520Title_val_Type_bmpString,
        __at_x520Title_val_Type_universalString,
        __at_x520Title_val_Type_uTF8String,
        _at_x520Title_val_Type,
        id_at_dnQualifier,
        at_x520dnQualifier,
        _at_x520dnQualifier_val_Type,
        id_at_countryName,
        at_x520countryName,
        _at_x520countryName_val_Type,
        id_at_serialNumber,
        at_x520SerialNumber,
        _at_x520SerialNumber_val_Type,
        id_at_pseudonym,
        at_x520Pseudonym,
        __at_x520Pseudonym_val_Type_teletexString,
        __at_x520Pseudonym_val_Type_printableString,
        __at_x520Pseudonym_val_Type_bmpString,
        __at_x520Pseudonym_val_Type_universalString,
        __at_x520Pseudonym_val_Type_uTF8String,
        _at_x520Pseudonym_val_Type,
        id_domainComponent,
        at_domainComponent,
        _at_domainComponent_val_Type,
        pkcs_9,
        id_emailAddress,
        at_emailAddress,
        _at_emailAddress_val_Type,
        _Name_rdnSequence,
        Name,
        _RDNSequence__item_,
        RDNSequence,
        DistinguishedName,
        ___RelativeDistinguishedName__item__type_tab,
        ____RelativeDistinguishedName__item__type_tab_val_Type_0,
        ____RelativeDistinguishedName__item__type_tab_val_Type_1,
        ____RelativeDistinguishedName__item__type_tab_val_Type_2,
        ____RelativeDistinguishedName__item__type_tab_val_Type_3,
        ____RelativeDistinguishedName__item__type_tab_val_Type_4,
        ____RelativeDistinguishedName__item__type_tab_val_Type_5,
        ____RelativeDistinguishedName__item__type_tab_val_Type_6,
        _____RelativeDistinguishedName__item__type_tab_val_Type_7_teletexString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_7_printableString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_7_bmpString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_7_universalString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_7_uTF8String,
        ____RelativeDistinguishedName__item__type_tab_val_Type_7,
        _____RelativeDistinguishedName__item__type_tab_val_Type_8_teletexString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_8_printableString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_8_bmpString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_8_universalString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_8_uTF8String,
        ____RelativeDistinguishedName__item__type_tab_val_Type_8,
        _____RelativeDistinguishedName__item__type_tab_val_Type_9_teletexString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_9_printableString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_9_bmpString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_9_universalString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_9_uTF8String,
        ____RelativeDistinguishedName__item__type_tab_val_Type_9,
        _____RelativeDistinguishedName__item__type_tab_val_Type_10_teletexString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_10_printableString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_10_bmpString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_10_universalString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_10_uTF8String,
        ____RelativeDistinguishedName__item__type_tab_val_Type_10,
        ____RelativeDistinguishedName__item__type_tab_val_Type_11,
        ____RelativeDistinguishedName__item__type_tab_val_Type_12,
        ____RelativeDistinguishedName__item__type_tab_val_Type_13,
        _____RelativeDistinguishedName__item__type_tab_val_Type_14_teletexString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_14_printableString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_14_bmpString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_14_universalString,
        _____RelativeDistinguishedName__item__type_tab_val_Type_14_uTF8String,
        ____RelativeDistinguishedName__item__type_tab_val_Type_14,
        ____RelativeDistinguishedName__item__type_tab_val_Type_15,
        ____RelativeDistinguishedName__item__type_tab_val_Type_16,
        __RelativeDistinguishedName__item__type,
        __RelativeDistinguishedName__item__value,
        _RelativeDistinguishedName__item_,
        RelativeDistinguishedName,
        SupportedAttributes,
        _SupportedAttributes_val_Type_0,
        _SupportedAttributes_val_Type_1,
        _SupportedAttributes_val_Type_2,
        _SupportedAttributes_val_Type_3,
        _SupportedAttributes_val_Type_4,
        _SupportedAttributes_val_Type_5,
        _SupportedAttributes_val_Type_6,
        __SupportedAttributes_val_Type_7_teletexString,
        __SupportedAttributes_val_Type_7_printableString,
        __SupportedAttributes_val_Type_7_bmpString,
        __SupportedAttributes_val_Type_7_universalString,
        __SupportedAttributes_val_Type_7_uTF8String,
        _SupportedAttributes_val_Type_7,
        __SupportedAttributes_val_Type_8_teletexString,
        __SupportedAttributes_val_Type_8_printableString,
        __SupportedAttributes_val_Type_8_bmpString,
        __SupportedAttributes_val_Type_8_universalString,
        __SupportedAttributes_val_Type_8_uTF8String,
        _SupportedAttributes_val_Type_8,
        __SupportedAttributes_val_Type_9_teletexString,
        __SupportedAttributes_val_Type_9_printableString,
        __SupportedAttributes_val_Type_9_bmpString,
        __SupportedAttributes_val_Type_9_universalString,
        __SupportedAttributes_val_Type_9_uTF8String,
        _SupportedAttributes_val_Type_9,
        __SupportedAttributes_val_Type_10_teletexString,
        __SupportedAttributes_val_Type_10_printableString,
        __SupportedAttributes_val_Type_10_bmpString,
        __SupportedAttributes_val_Type_10_universalString,
        __SupportedAttributes_val_Type_10_uTF8String,
        _SupportedAttributes_val_Type_10,
        _SupportedAttributes_val_Type_11,
        _SupportedAttributes_val_Type_12,
        _SupportedAttributes_val_Type_13,
        __SupportedAttributes_val_Type_14_teletexString,
        __SupportedAttributes_val_Type_14_printableString,
        __SupportedAttributes_val_Type_14_bmpString,
        __SupportedAttributes_val_Type_14_universalString,
        __SupportedAttributes_val_Type_14_uTF8String,
        _SupportedAttributes_val_Type_14,
        _SupportedAttributes_val_Type_15,
        _SupportedAttributes_val_Type_16,
        _Certificate_toBeSigned,
        ___Certificate_algorithmIdentifier_algorithm_tab,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_0,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_1,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_2,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_3,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_3,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_4,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_5,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_5,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_6,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_6,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_7,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_7,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_8,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_8,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_9,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_9,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Value_10,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_10,
        ____Certificate_algorithmIdentifier_algorithm_tab_val_Params_11,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_1,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_2,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_3,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1,
        __Certificate_algorithmIdentifier_algorithm,
        __Certificate_algorithmIdentifier_parameters,
        _Certificate_algorithmIdentifier,
        __Certificate_signature_contain,
        _Certificate_signature,
        Certificate,
        _TBSCertificate_version,
        _TBSCertificate_serialNumber,
        ___TBSCertificate_signature_algorithm_tab,
        ____TBSCertificate_signature_algorithm_tab_val_Params_0,
        ____TBSCertificate_signature_algorithm_tab_val_Params_1,
        ____TBSCertificate_signature_algorithm_tab_val_Params_2,
        ____TBSCertificate_signature_algorithm_tab_val_Value_3,
        ____TBSCertificate_signature_algorithm_tab_val_Params_3,
        ____TBSCertificate_signature_algorithm_tab_val_Value_4,
        ____TBSCertificate_signature_algorithm_tab_val_Params_4,
        ____TBSCertificate_signature_algorithm_tab_val_Value_5,
        ____TBSCertificate_signature_algorithm_tab_val_Params_5,
        ____TBSCertificate_signature_algorithm_tab_val_Value_6,
        ____TBSCertificate_signature_algorithm_tab_val_Params_6,
        ____TBSCertificate_signature_algorithm_tab_val_Value_7,
        ____TBSCertificate_signature_algorithm_tab_val_Params_7,
        ____TBSCertificate_signature_algorithm_tab_val_Value_8,
        ____TBSCertificate_signature_algorithm_tab_val_Params_8,
        ____TBSCertificate_signature_algorithm_tab_val_Value_9,
        ____TBSCertificate_signature_algorithm_tab_val_Params_9,
        ____TBSCertificate_signature_algorithm_tab_val_Value_10,
        ____TBSCertificate_signature_algorithm_tab_val_Params_10,
        ____TBSCertificate_signature_algorithm_tab_val_Params_11,
        __TBSCertificate_signature_algorithm,
        __TBSCertificate_signature_parameters,
        _TBSCertificate_signature,
        _TBSCertificate_issuer,
        _TBSCertificate_validity,
        _TBSCertificate_subject,
        _TBSCertificate_subjectPublicKeyInfo,
        _TBSCertificate_issuerUniqueID,
        _TBSCertificate_subjectUniqueID,
        ____TBSCertificate_extensions__item__extnID_tab,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_0,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_1,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_2,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_3,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_4,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_5,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_6,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_7,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_8,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_9,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_10,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_11,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_12,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_13,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_14,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_15,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_16,
        _____TBSCertificate_extensions__item__extnID_tab_val_ExtnType_17,
        ___TBSCertificate_extensions__item__extnID,
        ___TBSCertificate_extensions__item__critical,
        ____TBSCertificate_extensions__item__extnValue_contain,
        ___TBSCertificate_extensions__item__extnValue,
        __TBSCertificate_extensions__item_,
        _TBSCertificate_extensions,
        TBSCertificate,
        Version,
        CertificateSerialNumber,
        _Validity_notBefore,
        _Validity_notAfter,
        Validity,
        _Time_utcTime,
        _Time_generalTime,
        Time,
        UniqueIdentifier,
        ___SubjectPublicKeyInfo_algorithm_algorithm_tab,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_0,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_0,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_1,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_1,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_2,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_2,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_3,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_4,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_4,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_5,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_5,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_6,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_6,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_7,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_7,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_KeyValue_8,
        ____SubjectPublicKeyInfo_algorithm_algorithm_tab_val_Params_8,
        __SubjectPublicKeyInfo_algorithm_algorithm,
        __SubjectPublicKeyInfo_algorithm_parameters,
        _SubjectPublicKeyInfo_algorithm,
        _SubjectPublicKeyInfo_subjectPublicKey,
        SubjectPublicKeyInfo,
        _CertificateList_toBeSigned,
        ___CertificateList_algorithmIdentifier_algorithm_tab,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_0,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_1,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_2,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_3,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_3,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_4,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_4,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_5,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_5,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_6,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_6,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_7,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_7,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_8,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_8,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_9,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_9,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Value_10,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_10,
        ____CertificateList_algorithmIdentifier_algorithm_tab_val_Params_11,
        __CertificateList_algorithmIdentifier_algorithm,
        __CertificateList_algorithmIdentifier_parameters,
        _CertificateList_algorithmIdentifier,
        __CertificateList_signature_contain,
        _CertificateList_signature,
        CertificateList,
        _TBSCertList_version,
        ___TBSCertList_signature_algorithm_tab,
        ____TBSCertList_signature_algorithm_tab_val_Params_0,
        ____TBSCertList_signature_algorithm_tab_val_Params_1,
        ____TBSCertList_signature_algorithm_tab_val_Params_2,
        ____TBSCertList_signature_algorithm_tab_val_Value_3,
        ____TBSCertList_signature_algorithm_tab_val_Params_3,
        ____TBSCertList_signature_algorithm_tab_val_Value_4,
        ____TBSCertList_signature_algorithm_tab_val_Params_4,
        ____TBSCertList_signature_algorithm_tab_val_Value_5,
        ____TBSCertList_signature_algorithm_tab_val_Params_5,
        ____TBSCertList_signature_algorithm_tab_val_Value_6,
        ____TBSCertList_signature_algorithm_tab_val_Params_6,
        ____TBSCertList_signature_algorithm_tab_val_Value_7,
        ____TBSCertList_signature_algorithm_tab_val_Params_7,
        ____TBSCertList_signature_algorithm_tab_val_Value_8,
        ____TBSCertList_signature_algorithm_tab_val_Params_8,
        ____TBSCertList_signature_algorithm_tab_val_Value_9,
        ____TBSCertList_signature_algorithm_tab_val_Params_9,
        ____TBSCertList_signature_algorithm_tab_val_Value_10,
        ____TBSCertList_signature_algorithm_tab_val_Params_10,
        ____TBSCertList_signature_algorithm_tab_val_Params_11,
        __TBSCertList_signature_algorithm,
        __TBSCertList_signature_parameters,
        _TBSCertList_signature,
        _TBSCertList_issuer,
        _TBSCertList_thisUpdate,
        _TBSCertList_nextUpdate,
        ___TBSCertList_revokedCertificates__item__userCertificate,
        ___TBSCertList_revokedCertificates__item__revocationDate,
        ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab,
        _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_0,
        _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_1,
        _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_2,
        _______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID_tab_val_ExtnType_3,
        _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnID,
        _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__critical,
        ______TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnValue_contain,
        _____TBSCertList_revokedCertificates__item__crlEntryExtensions__item__extnValue,
        ____TBSCertList_revokedCertificates__item__crlEntryExtensions__item_,
        ___TBSCertList_revokedCertificates__item__crlEntryExtensions,
        __TBSCertList_revokedCertificates__item_,
        _TBSCertList_revokedCertificates,
        ____TBSCertList_crlExtensions__item__extnID_tab,
        _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_0,
        _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_1,
        _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_2,
        _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_3,
        _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_4,
        _____TBSCertList_crlExtensions__item__extnID_tab_val_ExtnType_5,
        ___TBSCertList_crlExtensions__item__extnID,
        ___TBSCertList_crlExtensions__item__critical,
        ____TBSCertList_crlExtensions__item__extnValue_contain,
        ___TBSCertList_crlExtensions__item__extnValue,
        __TBSCertList_crlExtensions__item_,
        _TBSCertList_crlExtensions,
        TBSCertList,
        SignatureAlgorithms,
        _SignatureAlgorithms_val_Params_0,
        _SignatureAlgorithms_val_Params_1,
        _SignatureAlgorithms_val_Params_2,
        _SignatureAlgorithms_val_Value_3,
        _SignatureAlgorithms_val_Params_3,
        _SignatureAlgorithms_val_Value_4,
        _SignatureAlgorithms_val_Params_4,
        _SignatureAlgorithms_val_Value_5,
        _SignatureAlgorithms_val_Params_5,
        _SignatureAlgorithms_val_Value_6,
        _SignatureAlgorithms_val_Params_6,
        _SignatureAlgorithms_val_Value_7,
        _SignatureAlgorithms_val_Params_7,
        _SignatureAlgorithms_val_Value_8,
        _SignatureAlgorithms_val_Params_8,
        _SignatureAlgorithms_val_Value_9,
        _SignatureAlgorithms_val_Params_9,
        _SignatureAlgorithms_val_Value_10,
        _SignatureAlgorithms_val_Params_10,
        _SignatureAlgorithms_val_Params_11,
        PublicKeyAlgorithms,
        _PublicKeyAlgorithms_val_KeyValue_0,
        _PublicKeyAlgorithms_val_Params_0,
        _PublicKeyAlgorithms_val_KeyValue_1,
        _PublicKeyAlgorithms_val_Params_1,
        _PublicKeyAlgorithms_val_KeyValue_2,
        _PublicKeyAlgorithms_val_Params_2,
        _PublicKeyAlgorithms_val_Params_3,
        _PublicKeyAlgorithms_val_KeyValue_4,
        _PublicKeyAlgorithms_val_Params_4,
        _PublicKeyAlgorithms_val_KeyValue_5,
        _PublicKeyAlgorithms_val_Params_5,
        _PublicKeyAlgorithms_val_KeyValue_6,
        _PublicKeyAlgorithms_val_Params_6,
        _PublicKeyAlgorithms_val_KeyValue_7,
        _PublicKeyAlgorithms_val_Params_7,
        _PublicKeyAlgorithms_val_KeyValue_8,
        _PublicKeyAlgorithms_val_Params_8,
        ub_state_name,
        ub_organization_name,
        ub_organizational_unit_name,
        ub_title,
        ub_serial_number,
        ub_pseudonym,
        ub_emailaddress_length,
        ub_locality_name,
        ub_common_name,
        ub_name,
    ]

class PKIX1Implicit_2009:

    _name_  = 'PKIX1Implicit-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 59]
    
    _obj_ = [
        'CertExtensions',
        'CrlExtensions',
        'CrlEntryExtensions',
        'id-ce',
        'ext-AuthorityKeyIdentifier',
        'id-ce-authorityKeyIdentifier',
        'AuthorityKeyIdentifier',
        'KeyIdentifier',
        'ext-SubjectKeyIdentifier',
        'id-ce-subjectKeyIdentifier',
        'ext-KeyUsage',
        'id-ce-keyUsage',
        'KeyUsage',
        'ext-PrivateKeyUsagePeriod',
        'id-ce-privateKeyUsagePeriod',
        'PrivateKeyUsagePeriod',
        'ext-CertificatePolicies',
        'id-ce-certificatePolicies',
        'CertificatePolicies',
        'PolicyInformation',
        'CertPolicyId',
        'CERT-POLICY-QUALIFIER',
        'PolicyQualifierInfo',
        'PolicyQualifierId',
        'pqid-cps',
        'pqid-unotice',
        'CPSuri',
        'UserNotice',
        'NoticeReference',
        'DisplayText',
        'ext-PolicyMappings',
        'id-ce-policyMappings',
        'PolicyMappings',
        'ext-SubjectAltName',
        'id-ce-subjectAltName',
        'GeneralNames',
        'GeneralName',
        'OTHER-NAME',
        'EDIPartyName',
        'ext-IssuerAltName',
        'id-ce-issuerAltName',
        'ext-SubjectDirectoryAttributes',
        'id-ce-subjectDirectoryAttributes',
        'SubjectDirectoryAttributes',
        'ext-BasicConstraints',
        'id-ce-basicConstraints',
        'BasicConstraints',
        'ext-NameConstraints',
        'id-ce-nameConstraints',
        'NameConstraints',
        'GeneralSubtrees',
        'GeneralSubtree',
        'BaseDistance',
        'ext-PolicyConstraints',
        'id-ce-policyConstraints',
        'PolicyConstraints',
        'SkipCerts',
        'ext-CRLDistributionPoints',
        'id-ce-cRLDistributionPoints',
        'CRLDistributionPoints',
        'DistributionPoint',
        'DistributionPointName',
        'ReasonFlags',
        'ext-ExtKeyUsage',
        'id-ce-extKeyUsage',
        'ExtKeyUsageSyntax',
        'KeyPurposeId',
        'anyExtendedKeyUsage',
        'id-kp-serverAuth',
        'id-kp-clientAuth',
        'id-kp-codeSigning',
        'id-kp-emailProtection',
        'id-kp-timeStamping',
        'id-kp-OCSPSigning',
        'ext-InhibitAnyPolicy',
        'id-ce-inhibitAnyPolicy',
        'ext-FreshestCRL',
        'id-ce-freshestCRL',
        'ext-AuthorityInfoAccess',
        'id-pe-authorityInfoAccess',
        'AuthorityInfoAccessSyntax',
        'AccessDescription',
        'ext-SubjectInfoAccessSyntax',
        'id-pe-subjectInfoAccess',
        'SubjectInfoAccessSyntax',
        'ext-CRLNumber',
        'id-ce-cRLNumber',
        'CRLNumber',
        'ext-IssuingDistributionPoint',
        'id-ce-issuingDistributionPoint',
        'IssuingDistributionPoint',
        'ext-DeltaCRLIndicator',
        'id-ce-deltaCRLIndicator',
        'ext-CRLReason',
        'id-ce-cRLReasons',
        'CRLReason',
        'ext-CertificateIssuer',
        'id-ce-certificateIssuer',
        'ext-HoldInstructionCode',
        'id-ce-holdInstructionCode',
        'holdInstruction',
        'id-holdinstruction-none',
        'id-holdinstruction-callissuer',
        'id-holdinstruction-reject',
        'ext-InvalidityDate',
        'id-ce-invalidityDate',
        'ubMax',
        ]
    _type_ = [
        'AuthorityKeyIdentifier',
        'KeyIdentifier',
        'KeyUsage',
        'PrivateKeyUsagePeriod',
        'CertificatePolicies',
        'PolicyInformation',
        'CertPolicyId',
        'CERT-POLICY-QUALIFIER',
        'PolicyQualifierInfo',
        'CPSuri',
        'UserNotice',
        'NoticeReference',
        'DisplayText',
        'PolicyMappings',
        'GeneralNames',
        'GeneralName',
        'OTHER-NAME',
        'EDIPartyName',
        'SubjectDirectoryAttributes',
        'BasicConstraints',
        'NameConstraints',
        'GeneralSubtrees',
        'GeneralSubtree',
        'BaseDistance',
        'PolicyConstraints',
        'SkipCerts',
        'CRLDistributionPoints',
        'DistributionPoint',
        'DistributionPointName',
        'ReasonFlags',
        'ExtKeyUsageSyntax',
        'KeyPurposeId',
        'AuthorityInfoAccessSyntax',
        'AccessDescription',
        'SubjectInfoAccessSyntax',
        'CRLNumber',
        'IssuingDistributionPoint',
        'CRLReason',
        ]
    _set_ = [
        'CertExtensions',
        'CrlExtensions',
        'CrlEntryExtensions',
        'PolicyQualifierId',
        ]
    _val_ = [
        'id-ce',
        'ext-AuthorityKeyIdentifier',
        'id-ce-authorityKeyIdentifier',
        'ext-SubjectKeyIdentifier',
        'id-ce-subjectKeyIdentifier',
        'ext-KeyUsage',
        'id-ce-keyUsage',
        'ext-PrivateKeyUsagePeriod',
        'id-ce-privateKeyUsagePeriod',
        'ext-CertificatePolicies',
        'id-ce-certificatePolicies',
        'pqid-cps',
        'pqid-unotice',
        'ext-PolicyMappings',
        'id-ce-policyMappings',
        'ext-SubjectAltName',
        'id-ce-subjectAltName',
        'ext-IssuerAltName',
        'id-ce-issuerAltName',
        'ext-SubjectDirectoryAttributes',
        'id-ce-subjectDirectoryAttributes',
        'ext-BasicConstraints',
        'id-ce-basicConstraints',
        'ext-NameConstraints',
        'id-ce-nameConstraints',
        'ext-PolicyConstraints',
        'id-ce-policyConstraints',
        'ext-CRLDistributionPoints',
        'id-ce-cRLDistributionPoints',
        'ext-ExtKeyUsage',
        'id-ce-extKeyUsage',
        'anyExtendedKeyUsage',
        'id-kp-serverAuth',
        'id-kp-clientAuth',
        'id-kp-codeSigning',
        'id-kp-emailProtection',
        'id-kp-timeStamping',
        'id-kp-OCSPSigning',
        'ext-InhibitAnyPolicy',
        'id-ce-inhibitAnyPolicy',
        'ext-FreshestCRL',
        'id-ce-freshestCRL',
        'ext-AuthorityInfoAccess',
        'id-pe-authorityInfoAccess',
        'ext-SubjectInfoAccessSyntax',
        'id-pe-subjectInfoAccess',
        'ext-CRLNumber',
        'id-ce-cRLNumber',
        'ext-IssuingDistributionPoint',
        'id-ce-issuingDistributionPoint',
        'ext-DeltaCRLIndicator',
        'id-ce-deltaCRLIndicator',
        'ext-CRLReason',
        'id-ce-cRLReasons',
        'ext-CertificateIssuer',
        'id-ce-certificateIssuer',
        'ext-HoldInstructionCode',
        'id-ce-holdInstructionCode',
        'holdInstruction',
        'id-holdinstruction-none',
        'id-holdinstruction-callissuer',
        'id-holdinstruction-reject',
        'ext-InvalidityDate',
        'id-ce-invalidityDate',
        'ubMax',
        ]
    _class_ = [
        'CertExtensions',
        'CrlExtensions',
        'CrlEntryExtensions',
        'ext-AuthorityKeyIdentifier',
        'ext-SubjectKeyIdentifier',
        'ext-KeyUsage',
        'ext-PrivateKeyUsagePeriod',
        'ext-CertificatePolicies',
        'CERT-POLICY-QUALIFIER',
        'PolicyQualifierId',
        'pqid-cps',
        'pqid-unotice',
        'ext-PolicyMappings',
        'ext-SubjectAltName',
        'OTHER-NAME',
        'ext-IssuerAltName',
        'ext-SubjectDirectoryAttributes',
        'ext-BasicConstraints',
        'ext-NameConstraints',
        'ext-PolicyConstraints',
        'ext-CRLDistributionPoints',
        'ext-ExtKeyUsage',
        'ext-InhibitAnyPolicy',
        'ext-FreshestCRL',
        'ext-AuthorityInfoAccess',
        'ext-SubjectInfoAccessSyntax',
        'ext-CRLNumber',
        'ext-IssuingDistributionPoint',
        'ext-DeltaCRLIndicator',
        'ext-CRLReason',
        'ext-CertificateIssuer',
        'ext-HoldInstructionCode',
        'ext-InvalidityDate',
        ]
    _param_ = [
        ]
    
    #-----< CertExtensions >-----#
    CertExtensions = CLASS(name='CertExtensions', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _CertExtensions_val_ExtnType_0 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityKeyIdentifier')))
    _CertExtensions_val_ExtnType_1 = OCT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyIdentifier')))
    _CertExtensions_val_ExtnType_2 = BIT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyUsage')))
    _CertExtensions_val_ExtnType_3 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PrivateKeyUsagePeriod')))
    _CertExtensions_val_ExtnType_4 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CertificatePolicies')))
    _CertExtensions_val_ExtnType_5 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyMappings')))
    _CertExtensions_val_ExtnType_6 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _CertExtensions_val_ExtnType_7 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _CertExtensions_val_ExtnType_8 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectDirectoryAttributes')))
    _CertExtensions_val_ExtnType_9 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'BasicConstraints')))
    _CertExtensions_val_ExtnType_10 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'NameConstraints')))
    _CertExtensions_val_ExtnType_11 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyConstraints')))
    _CertExtensions_val_ExtnType_12 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'ExtKeyUsageSyntax')))
    _CertExtensions_val_ExtnType_13 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    _CertExtensions_val_ExtnType_14 = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SkipCerts')))
    _CertExtensions_val_ExtnType_15 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    _CertExtensions_val_ExtnType_16 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityInfoAccessSyntax')))
    _CertExtensions_val_ExtnType_17 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectInfoAccessSyntax')))
    CertExtensions._val = ASN1Set(rv=[dict([('ExtnType', _CertExtensions_val_ExtnType_0), ('id', (2, 5, 29, 35))]), dict([('ExtnType', _CertExtensions_val_ExtnType_1), ('id', (2, 5, 29, 14))]), dict([('ExtnType', _CertExtensions_val_ExtnType_2), ('id', (2, 5, 29, 15))]), dict([('ExtnType', _CertExtensions_val_ExtnType_3), ('id', (2, 5, 29, 16))]), dict([('ExtnType', _CertExtensions_val_ExtnType_4), ('id', (2, 5, 29, 32))]), dict([('ExtnType', _CertExtensions_val_ExtnType_5), ('id', (2, 5, 29, 33))]), dict([('ExtnType', _CertExtensions_val_ExtnType_6), ('id', (2, 5, 29, 17))]), dict([('ExtnType', _CertExtensions_val_ExtnType_7), ('id', (2, 5, 29, 18))]), dict([('ExtnType', _CertExtensions_val_ExtnType_8), ('id', (2, 5, 29, 9))]), dict([('ExtnType', _CertExtensions_val_ExtnType_9), ('id', (2, 5, 29, 19))]), dict([('ExtnType', _CertExtensions_val_ExtnType_10), ('id', (2, 5, 29, 30))]), dict([('ExtnType', _CertExtensions_val_ExtnType_11), ('id', (2, 5, 29, 36))]), dict([('ExtnType', _CertExtensions_val_ExtnType_12), ('id', (2, 5, 29, 37))]), dict([('ExtnType', _CertExtensions_val_ExtnType_13), ('id', (2, 5, 29, 31))]), dict([('ExtnType', _CertExtensions_val_ExtnType_14), ('id', (2, 5, 29, 54))]), dict([('ExtnType', _CertExtensions_val_ExtnType_15), ('id', (2, 5, 29, 46))]), dict([('ExtnType', _CertExtensions_val_ExtnType_16), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 1))]), dict([('ExtnType', _CertExtensions_val_ExtnType_17), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 11))])], rr=[], ev=[], er=[])
    
    #-----< CrlExtensions >-----#
    CrlExtensions = CLASS(name='CrlExtensions', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _CrlExtensions_val_ExtnType_0 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityKeyIdentifier')))
    _CrlExtensions_val_ExtnType_1 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _CrlExtensions_val_ExtnType_2 = INT(name='ExtnType', mode=MODE_TYPE)
    _CrlExtensions_val_ExtnType_2._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _CrlExtensions_val_ExtnType_3 = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLNumber')))
    _CrlExtensions_val_ExtnType_4 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'IssuingDistributionPoint')))
    _CrlExtensions_val_ExtnType_5 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    CrlExtensions._val = ASN1Set(rv=[dict([('ExtnType', _CrlExtensions_val_ExtnType_0), ('id', (2, 5, 29, 35))]), dict([('ExtnType', _CrlExtensions_val_ExtnType_1), ('id', (2, 5, 29, 18))]), dict([('ExtnType', _CrlExtensions_val_ExtnType_2), ('id', (2, 5, 29, 20))]), dict([('ExtnType', _CrlExtensions_val_ExtnType_3), ('id', (2, 5, 29, 27))]), dict([('ExtnType', _CrlExtensions_val_ExtnType_4), ('id', (2, 5, 29, 28))]), dict([('ExtnType', _CrlExtensions_val_ExtnType_5), ('id', (2, 5, 29, 46))])], rr=[], ev=[], er=[])
    
    #-----< CrlEntryExtensions >-----#
    CrlEntryExtensions = CLASS(name='CrlEntryExtensions', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _CrlEntryExtensions_val_ExtnType_0 = ENUM(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLReason')))
    _CrlEntryExtensions_val_ExtnType_1 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _CrlEntryExtensions_val_ExtnType_2 = OID(name='ExtnType', mode=MODE_TYPE)
    _CrlEntryExtensions_val_ExtnType_3 = TIME_GEN(name='ExtnType', mode=MODE_TYPE)
    CrlEntryExtensions._val = ASN1Set(rv=[dict([('ExtnType', _CrlEntryExtensions_val_ExtnType_0), ('id', (2, 5, 29, 21))]), dict([('ExtnType', _CrlEntryExtensions_val_ExtnType_1), ('id', (2, 5, 29, 29))]), dict([('ExtnType', _CrlEntryExtensions_val_ExtnType_2), ('id', (2, 5, 29, 23))]), dict([('ExtnType', _CrlEntryExtensions_val_ExtnType_3), ('id', (2, 5, 29, 24))])], rr=[], ev=[], er=[])
    
    #-----< id-ce >-----#
    id_ce = OID(name='id-ce', mode=MODE_VALUE)
    id_ce._val = (2, 5, 29)
    
    #-----< ext-AuthorityKeyIdentifier >-----#
    ext_AuthorityKeyIdentifier = CLASS(name='ext-AuthorityKeyIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_AuthorityKeyIdentifier_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityKeyIdentifier')))
    ext_AuthorityKeyIdentifier._val = dict([('ExtnType', _ext_AuthorityKeyIdentifier_val_ExtnType), ('id', (2, 5, 29, 35))])
    
    #-----< id-ce-authorityKeyIdentifier >-----#
    id_ce_authorityKeyIdentifier = OID(name='id-ce-authorityKeyIdentifier', mode=MODE_VALUE)
    id_ce_authorityKeyIdentifier._val = (2, 5, 29, 35)
    
    #-----< AuthorityKeyIdentifier >-----#
    AuthorityKeyIdentifier = SEQ(name='AuthorityKeyIdentifier', mode=MODE_TYPE)
    _AuthorityKeyIdentifier_keyIdentifier = OCT_STR(name='keyIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyIdentifier')), opt=True)
    _AuthorityKeyIdentifier_authorityCertIssuer = SEQ_OF(name='authorityCertIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')), opt=True)
    _AuthorityKeyIdentifier_authorityCertSerialNumber = INT(name='authorityCertSerialNumber', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateSerialNumber')), opt=True)
    AuthorityKeyIdentifier._cont = ASN1Dict([
        ('keyIdentifier', _AuthorityKeyIdentifier_keyIdentifier),
        ('authorityCertIssuer', _AuthorityKeyIdentifier_authorityCertIssuer),
        ('authorityCertSerialNumber', _AuthorityKeyIdentifier_authorityCertSerialNumber),
        ])
    AuthorityKeyIdentifier._ext = None
    
    #-----< KeyIdentifier >-----#
    KeyIdentifier = OCT_STR(name='KeyIdentifier', mode=MODE_TYPE)
    
    #-----< ext-SubjectKeyIdentifier >-----#
    ext_SubjectKeyIdentifier = CLASS(name='ext-SubjectKeyIdentifier', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_SubjectKeyIdentifier_val_ExtnType = OCT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyIdentifier')))
    ext_SubjectKeyIdentifier._val = dict([('ExtnType', _ext_SubjectKeyIdentifier_val_ExtnType), ('id', (2, 5, 29, 14))])
    
    #-----< id-ce-subjectKeyIdentifier >-----#
    id_ce_subjectKeyIdentifier = OID(name='id-ce-subjectKeyIdentifier', mode=MODE_VALUE)
    id_ce_subjectKeyIdentifier._val = (2, 5, 29, 14)
    
    #-----< ext-KeyUsage >-----#
    ext_KeyUsage = CLASS(name='ext-KeyUsage', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_KeyUsage_val_ExtnType = BIT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyUsage')))
    ext_KeyUsage._val = dict([('ExtnType', _ext_KeyUsage_val_ExtnType), ('id', (2, 5, 29, 15))])
    
    #-----< id-ce-keyUsage >-----#
    id_ce_keyUsage = OID(name='id-ce-keyUsage', mode=MODE_VALUE)
    id_ce_keyUsage._val = (2, 5, 29, 15)
    
    #-----< KeyUsage >-----#
    KeyUsage = BIT_STR(name='KeyUsage', mode=MODE_TYPE)
    KeyUsage._cont = ASN1Dict([('digitalSignature', 0), ('nonRepudiation', 1), ('keyEncipherment', 2), ('dataEncipherment', 3), ('keyAgreement', 4), ('keyCertSign', 5), ('cRLSign', 6), ('encipherOnly', 7), ('decipherOnly', 8)])
    
    #-----< ext-PrivateKeyUsagePeriod >-----#
    ext_PrivateKeyUsagePeriod = CLASS(name='ext-PrivateKeyUsagePeriod', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_PrivateKeyUsagePeriod_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PrivateKeyUsagePeriod')))
    ext_PrivateKeyUsagePeriod._val = dict([('ExtnType', _ext_PrivateKeyUsagePeriod_val_ExtnType), ('id', (2, 5, 29, 16))])
    
    #-----< id-ce-privateKeyUsagePeriod >-----#
    id_ce_privateKeyUsagePeriod = OID(name='id-ce-privateKeyUsagePeriod', mode=MODE_VALUE)
    id_ce_privateKeyUsagePeriod._val = (2, 5, 29, 16)
    
    #-----< PrivateKeyUsagePeriod >-----#
    PrivateKeyUsagePeriod = SEQ(name='PrivateKeyUsagePeriod', mode=MODE_TYPE)
    _PrivateKeyUsagePeriod_notBefore = TIME_GEN(name='notBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PrivateKeyUsagePeriod_notAfter = TIME_GEN(name='notAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    PrivateKeyUsagePeriod._cont = ASN1Dict([
        ('notBefore', _PrivateKeyUsagePeriod_notBefore),
        ('notAfter', _PrivateKeyUsagePeriod_notAfter),
        ])
    PrivateKeyUsagePeriod._ext = None
    
    #-----< ext-CertificatePolicies >-----#
    ext_CertificatePolicies = CLASS(name='ext-CertificatePolicies', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_CertificatePolicies_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CertificatePolicies')))
    ext_CertificatePolicies._val = dict([('ExtnType', _ext_CertificatePolicies_val_ExtnType), ('id', (2, 5, 29, 32))])
    
    #-----< id-ce-certificatePolicies >-----#
    id_ce_certificatePolicies = OID(name='id-ce-certificatePolicies', mode=MODE_VALUE)
    id_ce_certificatePolicies._val = (2, 5, 29, 32)
    
    #-----< CertificatePolicies >-----#
    CertificatePolicies = SEQ_OF(name='CertificatePolicies', mode=MODE_TYPE)
    _CertificatePolicies__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyInformation')))
    CertificatePolicies._cont = _CertificatePolicies__item_
    CertificatePolicies._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PolicyInformation >-----#
    PolicyInformation = SEQ(name='PolicyInformation', mode=MODE_TYPE)
    _PolicyInformation_policyIdentifier = OID(name='policyIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CertPolicyId')))
    _PolicyInformation_policyQualifiers = SEQ_OF(name='policyQualifiers', mode=MODE_TYPE, opt=True)
    __PolicyInformation_policyQualifiers__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyQualifierInfo')))
    _PolicyInformation_policyQualifiers._cont = __PolicyInformation_policyQualifiers__item_
    _PolicyInformation_policyQualifiers._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PolicyInformation._cont = ASN1Dict([
        ('policyIdentifier', _PolicyInformation_policyIdentifier),
        ('policyQualifiers', _PolicyInformation_policyQualifiers),
        ])
    PolicyInformation._ext = None
    
    #-----< CertPolicyId >-----#
    CertPolicyId = OID(name='CertPolicyId', mode=MODE_TYPE)
    
    #-----< CERT-POLICY-QUALIFIER >-----#
    CERT_POLICY_QUALIFIER = CLASS(name='CERT-POLICY-QUALIFIER', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< PolicyQualifierInfo >-----#
    PolicyQualifierInfo = SEQ(name='PolicyQualifierInfo', mode=MODE_TYPE)
    _PolicyQualifierInfo_policyQualifierId = OID(name='policyQualifierId', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX1Implicit-2009', 'CERT-POLICY-QUALIFIER'), ['id']))
    __PolicyQualifierInfo_policyQualifierId_tab = CLASS(name='_tab_CERT-POLICY-QUALIFIER', mode=MODE_SET, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CERT-POLICY-QUALIFIER')))
    ___PolicyQualifierInfo_policyQualifierId_tab_val_Type_0 = STR_IA5(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CPSuri')))
    ___PolicyQualifierInfo_policyQualifierId_tab_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'UserNotice')))
    __PolicyQualifierInfo_policyQualifierId_tab._val = ASN1Set(rv=[dict([('Type', ___PolicyQualifierInfo_policyQualifierId_tab_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 2, 1))]), dict([('Type', ___PolicyQualifierInfo_policyQualifierId_tab_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 2, 2))])], rr=[], ev=None, er=[])
    _PolicyQualifierInfo_policyQualifierId._const_tab = __PolicyQualifierInfo_policyQualifierId_tab
    _PolicyQualifierInfo_policyQualifierId._const_tab_at = None
    _PolicyQualifierInfo_policyQualifierId._const_tab_id = 'id'
    _PolicyQualifierInfo_qualifier = OPEN(name='qualifier', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX1Implicit-2009', 'CERT-POLICY-QUALIFIER'), ['Type']))
    _PolicyQualifierInfo_qualifier._const_tab = __PolicyQualifierInfo_policyQualifierId_tab
    _PolicyQualifierInfo_qualifier._const_tab_at = ('..', 'policyQualifierId')
    _PolicyQualifierInfo_qualifier._const_tab_id = 'Type'
    PolicyQualifierInfo._cont = ASN1Dict([
        ('policyQualifierId', _PolicyQualifierInfo_policyQualifierId),
        ('qualifier', _PolicyQualifierInfo_qualifier),
        ])
    PolicyQualifierInfo._ext = None
    
    #-----< PolicyQualifierId >-----#
    PolicyQualifierId = CLASS(name='PolicyQualifierId', mode=MODE_SET, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CERT-POLICY-QUALIFIER')))
    _PolicyQualifierId_val_Type_0 = STR_IA5(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CPSuri')))
    _PolicyQualifierId_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'UserNotice')))
    PolicyQualifierId._val = ASN1Set(rv=[dict([('Type', _PolicyQualifierId_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 2, 1))]), dict([('Type', _PolicyQualifierId_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 2, 2))])], rr=[], ev=[], er=[])
    
    #-----< pqid-cps >-----#
    pqid_cps = CLASS(name='pqid-cps', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CERT-POLICY-QUALIFIER')))
    _pqid_cps_val_Type = STR_IA5(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CPSuri')))
    pqid_cps._val = dict([('Type', _pqid_cps_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 2, 1))])
    
    #-----< pqid-unotice >-----#
    pqid_unotice = CLASS(name='pqid-unotice', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CERT-POLICY-QUALIFIER')))
    _pqid_unotice_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'UserNotice')))
    pqid_unotice._val = dict([('Type', _pqid_unotice_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 2, 2))])
    
    #-----< CPSuri >-----#
    CPSuri = STR_IA5(name='CPSuri', mode=MODE_TYPE)
    
    #-----< UserNotice >-----#
    UserNotice = SEQ(name='UserNotice', mode=MODE_TYPE)
    _UserNotice_noticeRef = SEQ(name='noticeRef', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'NoticeReference')), opt=True)
    _UserNotice_explicitText = CHOICE(name='explicitText', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'DisplayText')), opt=True)
    UserNotice._cont = ASN1Dict([
        ('noticeRef', _UserNotice_noticeRef),
        ('explicitText', _UserNotice_explicitText),
        ])
    UserNotice._ext = None
    
    #-----< NoticeReference >-----#
    NoticeReference = SEQ(name='NoticeReference', mode=MODE_TYPE)
    _NoticeReference_organization = CHOICE(name='organization', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'DisplayText')))
    _NoticeReference_noticeNumbers = SEQ_OF(name='noticeNumbers', mode=MODE_TYPE)
    __NoticeReference_noticeNumbers__item_ = INT(name='_item_', mode=MODE_TYPE)
    _NoticeReference_noticeNumbers._cont = __NoticeReference_noticeNumbers__item_
    NoticeReference._cont = ASN1Dict([
        ('organization', _NoticeReference_organization),
        ('noticeNumbers', _NoticeReference_noticeNumbers),
        ])
    NoticeReference._ext = None
    
    #-----< DisplayText >-----#
    DisplayText = CHOICE(name='DisplayText', mode=MODE_TYPE)
    _DisplayText_ia5String = STR_IA5(name='ia5String', mode=MODE_TYPE)
    _DisplayText_ia5String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    _DisplayText_visibleString = STR_VIS(name='visibleString', mode=MODE_TYPE)
    _DisplayText_visibleString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    _DisplayText_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _DisplayText_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    _DisplayText_utf8String = STR_UTF8(name='utf8String', mode=MODE_TYPE)
    _DisplayText_utf8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=200)], ev=None, er=[])
    DisplayText._cont = ASN1Dict([
        ('ia5String', _DisplayText_ia5String),
        ('visibleString', _DisplayText_visibleString),
        ('bmpString', _DisplayText_bmpString),
        ('utf8String', _DisplayText_utf8String),
        ])
    DisplayText._ext = None
    
    #-----< ext-PolicyMappings >-----#
    ext_PolicyMappings = CLASS(name='ext-PolicyMappings', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_PolicyMappings_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyMappings')))
    ext_PolicyMappings._val = dict([('ExtnType', _ext_PolicyMappings_val_ExtnType), ('id', (2, 5, 29, 33))])
    
    #-----< id-ce-policyMappings >-----#
    id_ce_policyMappings = OID(name='id-ce-policyMappings', mode=MODE_VALUE)
    id_ce_policyMappings._val = (2, 5, 29, 33)
    
    #-----< PolicyMappings >-----#
    PolicyMappings = SEQ_OF(name='PolicyMappings', mode=MODE_TYPE)
    _PolicyMappings__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PolicyMappings__item__issuerDomainPolicy = OID(name='issuerDomainPolicy', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CertPolicyId')))
    __PolicyMappings__item__subjectDomainPolicy = OID(name='subjectDomainPolicy', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CertPolicyId')))
    _PolicyMappings__item_._cont = ASN1Dict([
        ('issuerDomainPolicy', __PolicyMappings__item__issuerDomainPolicy),
        ('subjectDomainPolicy', __PolicyMappings__item__subjectDomainPolicy),
        ])
    _PolicyMappings__item_._ext = None
    PolicyMappings._cont = _PolicyMappings__item_
    PolicyMappings._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< ext-SubjectAltName >-----#
    ext_SubjectAltName = CLASS(name='ext-SubjectAltName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_SubjectAltName_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    ext_SubjectAltName._val = dict([('ExtnType', _ext_SubjectAltName_val_ExtnType), ('id', (2, 5, 29, 17))])
    
    #-----< id-ce-subjectAltName >-----#
    id_ce_subjectAltName = OID(name='id-ce-subjectAltName', mode=MODE_VALUE)
    id_ce_subjectAltName._val = (2, 5, 29, 17)
    
    #-----< GeneralNames >-----#
    GeneralNames = SEQ_OF(name='GeneralNames', mode=MODE_TYPE)
    _GeneralNames__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    GeneralNames._cont = _GeneralNames__item_
    GeneralNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralName >-----#
    GeneralName = CHOICE(name='GeneralName', mode=MODE_TYPE)
    _GeneralName_otherName = SEQ(name='otherName', mode=MODE_TYPE)
    __GeneralName_otherName_type_id = OID(name='type-id', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX1Implicit-2009', 'OTHER-NAME'), ['id']))
    __GeneralName_otherName_value = OPEN(name='value', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PKIX1Implicit-2009', 'OTHER-NAME'), ['Type']))
    _GeneralName_otherName._cont = ASN1Dict([
        ('type-id', __GeneralName_otherName_type_id),
        ('value', __GeneralName_otherName_value),
        ])
    _GeneralName_otherName._ext = None
    _GeneralName_otherName.TAG = 8
    _GeneralName_rfc822Name = STR_IA5(name='rfc822Name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_dNSName = STR_IA5(name='dNSName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_x400Address = SEQ(name='x400Address', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'ORAddress')))
    _GeneralName_directoryName = CHOICE(name='directoryName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')))
    _GeneralName_ediPartyName = SEQ(name='ediPartyName', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'EDIPartyName')))
    _GeneralName_uniformResourceIdentifier = STR_IA5(name='uniformResourceIdentifier', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_iPAddress = OCT_STR(name='iPAddress', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeneralName_registeredID = OID(name='registeredID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GeneralName._cont = ASN1Dict([
        ('otherName', _GeneralName_otherName),
        ('rfc822Name', _GeneralName_rfc822Name),
        ('dNSName', _GeneralName_dNSName),
        ('x400Address', _GeneralName_x400Address),
        ('directoryName', _GeneralName_directoryName),
        ('ediPartyName', _GeneralName_ediPartyName),
        ('uniformResourceIdentifier', _GeneralName_uniformResourceIdentifier),
        ('iPAddress', _GeneralName_iPAddress),
        ('registeredID', _GeneralName_registeredID),
        ])
    GeneralName._ext = None
    
    #-----< OTHER-NAME >-----#
    OTHER_NAME = CLASS(name='OTHER-NAME', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< EDIPartyName >-----#
    EDIPartyName = SEQ(name='EDIPartyName', mode=MODE_TYPE)
    _EDIPartyName_nameAssigner = CHOICE(name='nameAssigner', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')), opt=True)
    __EDIPartyName_nameAssigner_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __EDIPartyName_nameAssigner_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    __EDIPartyName_nameAssigner_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __EDIPartyName_nameAssigner_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    __EDIPartyName_nameAssigner_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __EDIPartyName_nameAssigner_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    __EDIPartyName_nameAssigner_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __EDIPartyName_nameAssigner_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    __EDIPartyName_nameAssigner_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __EDIPartyName_nameAssigner_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    _EDIPartyName_nameAssigner._cont = ASN1Dict([
        ('teletexString', __EDIPartyName_nameAssigner_teletexString),
        ('printableString', __EDIPartyName_nameAssigner_printableString),
        ('bmpString', __EDIPartyName_nameAssigner_bmpString),
        ('universalString', __EDIPartyName_nameAssigner_universalString),
        ('uTF8String', __EDIPartyName_nameAssigner_uTF8String),
        ])
    _EDIPartyName_nameAssigner._ext = None
    _EDIPartyName_partyName = CHOICE(name='partyName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    __EDIPartyName_partyName_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    __EDIPartyName_partyName_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    __EDIPartyName_partyName_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    __EDIPartyName_partyName_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    __EDIPartyName_partyName_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    __EDIPartyName_partyName_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    __EDIPartyName_partyName_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    __EDIPartyName_partyName_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    __EDIPartyName_partyName_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    __EDIPartyName_partyName_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32768)], ev=None, er=[])
    _EDIPartyName_partyName._cont = ASN1Dict([
        ('teletexString', __EDIPartyName_partyName_teletexString),
        ('printableString', __EDIPartyName_partyName_printableString),
        ('bmpString', __EDIPartyName_partyName_bmpString),
        ('universalString', __EDIPartyName_partyName_universalString),
        ('uTF8String', __EDIPartyName_partyName_uTF8String),
        ])
    _EDIPartyName_partyName._ext = None
    EDIPartyName._cont = ASN1Dict([
        ('nameAssigner', _EDIPartyName_nameAssigner),
        ('partyName', _EDIPartyName_partyName),
        ])
    EDIPartyName._ext = None
    
    #-----< ext-IssuerAltName >-----#
    ext_IssuerAltName = CLASS(name='ext-IssuerAltName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_IssuerAltName_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    ext_IssuerAltName._val = dict([('ExtnType', _ext_IssuerAltName_val_ExtnType), ('id', (2, 5, 29, 18))])
    
    #-----< id-ce-issuerAltName >-----#
    id_ce_issuerAltName = OID(name='id-ce-issuerAltName', mode=MODE_VALUE)
    id_ce_issuerAltName._val = (2, 5, 29, 18)
    
    #-----< ext-SubjectDirectoryAttributes >-----#
    ext_SubjectDirectoryAttributes = CLASS(name='ext-SubjectDirectoryAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_SubjectDirectoryAttributes_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectDirectoryAttributes')))
    ext_SubjectDirectoryAttributes._val = dict([('ExtnType', _ext_SubjectDirectoryAttributes_val_ExtnType), ('id', (2, 5, 29, 9))])
    
    #-----< id-ce-subjectDirectoryAttributes >-----#
    id_ce_subjectDirectoryAttributes = OID(name='id-ce-subjectDirectoryAttributes', mode=MODE_VALUE)
    id_ce_subjectDirectoryAttributes._val = (2, 5, 29, 9)
    
    #-----< SubjectDirectoryAttributes >-----#
    SubjectDirectoryAttributes = SEQ_OF(name='SubjectDirectoryAttributes', mode=MODE_TYPE)
    _SubjectDirectoryAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'AttributeSet')))
    __SubjectDirectoryAttributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ___SubjectDirectoryAttributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_0 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_1 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_2 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_3 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_4 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520name')))
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_5 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520CommonName')))
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_6 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'X520LocalityName')))
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_7 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_7._cont = ASN1Dict([
        ('teletexString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_teletexString),
        ('printableString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_printableString),
        ('bmpString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_bmpString),
        ('universalString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_universalString),
        ('uTF8String', _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_uTF8String),
        ])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_7._ext = None
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_8 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_8._cont = ASN1Dict([
        ('teletexString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_teletexString),
        ('printableString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_printableString),
        ('bmpString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_bmpString),
        ('universalString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_universalString),
        ('uTF8String', _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_uTF8String),
        ])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_8._ext = None
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_9 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_9._cont = ASN1Dict([
        ('teletexString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_teletexString),
        ('printableString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_printableString),
        ('bmpString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_bmpString),
        ('universalString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_universalString),
        ('uTF8String', _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_uTF8String),
        ])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_9._ext = None
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_10 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_10._cont = ASN1Dict([
        ('teletexString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_teletexString),
        ('printableString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_printableString),
        ('bmpString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_bmpString),
        ('universalString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_universalString),
        ('uTF8String', _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_uTF8String),
        ])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_10._ext = None
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_11 = STR_PRINT(name='Type', mode=MODE_TYPE)
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_12 = STR_PRINT(name='Type', mode=MODE_TYPE)
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_12._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_13 = STR_PRINT(name='Type', mode=MODE_TYPE)
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_13._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_14 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'DirectoryString')))
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_teletexString = STR_TELE(name='teletexString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_teletexString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_printableString = STR_PRINT(name='printableString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_printableString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_bmpString = STR_BMP(name='bmpString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_bmpString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_universalString = STR_UNIV(name='universalString', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_universalString._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_uTF8String = STR_UTF8(name='uTF8String', mode=MODE_TYPE)
    _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_uTF8String._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_14._cont = ASN1Dict([
        ('teletexString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_teletexString),
        ('printableString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_printableString),
        ('bmpString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_bmpString),
        ('universalString', _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_universalString),
        ('uTF8String', _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_uTF8String),
        ])
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_14._ext = None
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_15 = STR_IA5(name='Type', mode=MODE_TYPE)
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_16 = STR_IA5(name='Type', mode=MODE_TYPE)
    ____SubjectDirectoryAttributes__item__type_tab_val_Type_16._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    ___SubjectDirectoryAttributes__item__type_tab._val = ASN1Set(rv=[dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_0), ('id', (2, 5, 4, 41))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_1), ('id', (2, 5, 4, 4))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_2), ('id', (2, 5, 4, 42))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_3), ('id', (2, 5, 4, 43))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_4), ('id', (2, 5, 4, 44))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_5), ('id', (2, 5, 4, 3))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_6), ('id', (2, 5, 4, 7))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_7), ('id', (2, 5, 4, 8))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_8), ('id', (2, 5, 4, 10))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_9), ('id', (2, 5, 4, 11))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_10), ('id', (2, 5, 4, 12))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_11), ('id', (2, 5, 4, 46))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_12), ('id', (2, 5, 4, 6))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_13), ('id', (2, 5, 4, 5))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_14), ('id', (2, 5, 4, 65))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_15), ('id', (0, 9, 2342, 19200300, 100, 1, 25))]), dict([('Type', ____SubjectDirectoryAttributes__item__type_tab_val_Type_16), ('id', (1, 2, 840, 113549, 1, 9, 1))])], rr=[], ev=None, er=[])
    __SubjectDirectoryAttributes__item__type._const_tab = ___SubjectDirectoryAttributes__item__type_tab
    __SubjectDirectoryAttributes__item__type._const_tab_at = None
    __SubjectDirectoryAttributes__item__type._const_tab_id = 'id'
    __SubjectDirectoryAttributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ___SubjectDirectoryAttributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    ___SubjectDirectoryAttributes__item__values__item_._const_tab = ___SubjectDirectoryAttributes__item__type_tab
    ___SubjectDirectoryAttributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ___SubjectDirectoryAttributes__item__values__item_._const_tab_id = 'Type'
    __SubjectDirectoryAttributes__item__values._cont = ___SubjectDirectoryAttributes__item__values__item_
    __SubjectDirectoryAttributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _SubjectDirectoryAttributes__item_._cont = ASN1Dict([
        ('type', __SubjectDirectoryAttributes__item__type),
        ('values', __SubjectDirectoryAttributes__item__values),
        ])
    _SubjectDirectoryAttributes__item_._ext = None
    SubjectDirectoryAttributes._cont = _SubjectDirectoryAttributes__item_
    SubjectDirectoryAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< ext-BasicConstraints >-----#
    ext_BasicConstraints = CLASS(name='ext-BasicConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_BasicConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'BasicConstraints')))
    ext_BasicConstraints._val = dict([('ExtnType', _ext_BasicConstraints_val_ExtnType), ('id', (2, 5, 29, 19))])
    
    #-----< id-ce-basicConstraints >-----#
    id_ce_basicConstraints = OID(name='id-ce-basicConstraints', mode=MODE_VALUE)
    id_ce_basicConstraints._val = (2, 5, 29, 19)
    
    #-----< BasicConstraints >-----#
    BasicConstraints = SEQ(name='BasicConstraints', mode=MODE_TYPE)
    _BasicConstraints_cA = BOOL(name='cA', mode=MODE_TYPE, default=False)
    _BasicConstraints_pathLenConstraint = INT(name='pathLenConstraint', mode=MODE_TYPE, opt=True)
    _BasicConstraints_pathLenConstraint._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    BasicConstraints._cont = ASN1Dict([
        ('cA', _BasicConstraints_cA),
        ('pathLenConstraint', _BasicConstraints_pathLenConstraint),
        ])
    BasicConstraints._ext = None
    
    #-----< ext-NameConstraints >-----#
    ext_NameConstraints = CLASS(name='ext-NameConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_NameConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'NameConstraints')))
    ext_NameConstraints._val = dict([('ExtnType', _ext_NameConstraints_val_ExtnType), ('id', (2, 5, 29, 30))])
    
    #-----< id-ce-nameConstraints >-----#
    id_ce_nameConstraints = OID(name='id-ce-nameConstraints', mode=MODE_VALUE)
    id_ce_nameConstraints._val = (2, 5, 29, 30)
    
    #-----< NameConstraints >-----#
    NameConstraints = SEQ(name='NameConstraints', mode=MODE_TYPE)
    _NameConstraints_permittedSubtrees = SEQ_OF(name='permittedSubtrees', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralSubtrees')), opt=True)
    _NameConstraints_excludedSubtrees = SEQ_OF(name='excludedSubtrees', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralSubtrees')), opt=True)
    NameConstraints._cont = ASN1Dict([
        ('permittedSubtrees', _NameConstraints_permittedSubtrees),
        ('excludedSubtrees', _NameConstraints_excludedSubtrees),
        ])
    NameConstraints._ext = None
    
    #-----< GeneralSubtrees >-----#
    GeneralSubtrees = SEQ_OF(name='GeneralSubtrees', mode=MODE_TYPE)
    _GeneralSubtrees__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralSubtree')))
    GeneralSubtrees._cont = _GeneralSubtrees__item_
    GeneralSubtrees._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< GeneralSubtree >-----#
    GeneralSubtree = SEQ(name='GeneralSubtree', mode=MODE_TYPE)
    _GeneralSubtree_base = CHOICE(name='base', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _GeneralSubtree_minimum = INT(name='minimum', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'BaseDistance')), default=0)
    _GeneralSubtree_maximum = INT(name='maximum', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'BaseDistance')), opt=True)
    GeneralSubtree._cont = ASN1Dict([
        ('base', _GeneralSubtree_base),
        ('minimum', _GeneralSubtree_minimum),
        ('maximum', _GeneralSubtree_maximum),
        ])
    GeneralSubtree._ext = None
    
    #-----< BaseDistance >-----#
    BaseDistance = INT(name='BaseDistance', mode=MODE_TYPE)
    BaseDistance._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< ext-PolicyConstraints >-----#
    ext_PolicyConstraints = CLASS(name='ext-PolicyConstraints', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_PolicyConstraints_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyConstraints')))
    ext_PolicyConstraints._val = dict([('ExtnType', _ext_PolicyConstraints_val_ExtnType), ('id', (2, 5, 29, 36))])
    
    #-----< id-ce-policyConstraints >-----#
    id_ce_policyConstraints = OID(name='id-ce-policyConstraints', mode=MODE_VALUE)
    id_ce_policyConstraints._val = (2, 5, 29, 36)
    
    #-----< PolicyConstraints >-----#
    PolicyConstraints = SEQ(name='PolicyConstraints', mode=MODE_TYPE)
    _PolicyConstraints_requireExplicitPolicy = INT(name='requireExplicitPolicy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'SkipCerts')), opt=True)
    _PolicyConstraints_inhibitPolicyMapping = INT(name='inhibitPolicyMapping', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'SkipCerts')), opt=True)
    PolicyConstraints._cont = ASN1Dict([
        ('requireExplicitPolicy', _PolicyConstraints_requireExplicitPolicy),
        ('inhibitPolicyMapping', _PolicyConstraints_inhibitPolicyMapping),
        ])
    PolicyConstraints._ext = None
    
    #-----< SkipCerts >-----#
    SkipCerts = INT(name='SkipCerts', mode=MODE_TYPE)
    SkipCerts._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< ext-CRLDistributionPoints >-----#
    ext_CRLDistributionPoints = CLASS(name='ext-CRLDistributionPoints', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_CRLDistributionPoints_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    ext_CRLDistributionPoints._val = dict([('ExtnType', _ext_CRLDistributionPoints_val_ExtnType), ('id', (2, 5, 29, 31))])
    
    #-----< id-ce-cRLDistributionPoints >-----#
    id_ce_cRLDistributionPoints = OID(name='id-ce-cRLDistributionPoints', mode=MODE_VALUE)
    id_ce_cRLDistributionPoints._val = (2, 5, 29, 31)
    
    #-----< CRLDistributionPoints >-----#
    CRLDistributionPoints = SEQ_OF(name='CRLDistributionPoints', mode=MODE_TYPE)
    _CRLDistributionPoints__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'DistributionPoint')))
    CRLDistributionPoints._cont = _CRLDistributionPoints__item_
    CRLDistributionPoints._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< DistributionPoint >-----#
    DistributionPoint = SEQ(name='DistributionPoint', mode=MODE_TYPE)
    _DistributionPoint_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'DistributionPointName')), opt=True)
    _DistributionPoint_reasons = BIT_STR(name='reasons', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'ReasonFlags')), opt=True)
    _DistributionPoint_cRLIssuer = SEQ_OF(name='cRLIssuer', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')), opt=True)
    DistributionPoint._cont = ASN1Dict([
        ('distributionPoint', _DistributionPoint_distributionPoint),
        ('reasons', _DistributionPoint_reasons),
        ('cRLIssuer', _DistributionPoint_cRLIssuer),
        ])
    DistributionPoint._ext = None
    
    #-----< DistributionPointName >-----#
    DistributionPointName = CHOICE(name='DistributionPointName', mode=MODE_TYPE)
    _DistributionPointName_fullName = SEQ_OF(name='fullName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _DistributionPointName_nameRelativeToCRLIssuer = SET_OF(name='nameRelativeToCRLIssuer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'RelativeDistinguishedName')))
    DistributionPointName._cont = ASN1Dict([
        ('fullName', _DistributionPointName_fullName),
        ('nameRelativeToCRLIssuer', _DistributionPointName_nameRelativeToCRLIssuer),
        ])
    DistributionPointName._ext = None
    
    #-----< ReasonFlags >-----#
    ReasonFlags = BIT_STR(name='ReasonFlags', mode=MODE_TYPE)
    ReasonFlags._cont = ASN1Dict([('unused', 0), ('keyCompromise', 1), ('cACompromise', 2), ('affiliationChanged', 3), ('superseded', 4), ('cessationOfOperation', 5), ('certificateHold', 6), ('privilegeWithdrawn', 7), ('aACompromise', 8)])
    
    #-----< ext-ExtKeyUsage >-----#
    ext_ExtKeyUsage = CLASS(name='ext-ExtKeyUsage', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_ExtKeyUsage_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'ExtKeyUsageSyntax')))
    ext_ExtKeyUsage._val = dict([('ExtnType', _ext_ExtKeyUsage_val_ExtnType), ('id', (2, 5, 29, 37))])
    
    #-----< id-ce-extKeyUsage >-----#
    id_ce_extKeyUsage = OID(name='id-ce-extKeyUsage', mode=MODE_VALUE)
    id_ce_extKeyUsage._val = (2, 5, 29, 37)
    
    #-----< ExtKeyUsageSyntax >-----#
    ExtKeyUsageSyntax = SEQ_OF(name='ExtKeyUsageSyntax', mode=MODE_TYPE)
    _ExtKeyUsageSyntax__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyPurposeId')))
    ExtKeyUsageSyntax._cont = _ExtKeyUsageSyntax__item_
    ExtKeyUsageSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< KeyPurposeId >-----#
    KeyPurposeId = OID(name='KeyPurposeId', mode=MODE_TYPE)
    
    #-----< anyExtendedKeyUsage >-----#
    anyExtendedKeyUsage = OID(name='anyExtendedKeyUsage', mode=MODE_VALUE)
    anyExtendedKeyUsage._val = (2, 5, 29, 37, 0)
    
    #-----< id-kp-serverAuth >-----#
    id_kp_serverAuth = OID(name='id-kp-serverAuth', mode=MODE_VALUE)
    id_kp_serverAuth._val = (1, 3, 6, 1, 5, 5, 7, 3, 1)
    
    #-----< id-kp-clientAuth >-----#
    id_kp_clientAuth = OID(name='id-kp-clientAuth', mode=MODE_VALUE)
    id_kp_clientAuth._val = (1, 3, 6, 1, 5, 5, 7, 3, 2)
    
    #-----< id-kp-codeSigning >-----#
    id_kp_codeSigning = OID(name='id-kp-codeSigning', mode=MODE_VALUE)
    id_kp_codeSigning._val = (1, 3, 6, 1, 5, 5, 7, 3, 3)
    
    #-----< id-kp-emailProtection >-----#
    id_kp_emailProtection = OID(name='id-kp-emailProtection', mode=MODE_VALUE)
    id_kp_emailProtection._val = (1, 3, 6, 1, 5, 5, 7, 3, 4)
    
    #-----< id-kp-timeStamping >-----#
    id_kp_timeStamping = OID(name='id-kp-timeStamping', mode=MODE_VALUE)
    id_kp_timeStamping._val = (1, 3, 6, 1, 5, 5, 7, 3, 8)
    
    #-----< id-kp-OCSPSigning >-----#
    id_kp_OCSPSigning = OID(name='id-kp-OCSPSigning', mode=MODE_VALUE)
    id_kp_OCSPSigning._val = (1, 3, 6, 1, 5, 5, 7, 3, 9)
    
    #-----< ext-InhibitAnyPolicy >-----#
    ext_InhibitAnyPolicy = CLASS(name='ext-InhibitAnyPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_InhibitAnyPolicy_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SkipCerts')))
    ext_InhibitAnyPolicy._val = dict([('ExtnType', _ext_InhibitAnyPolicy_val_ExtnType), ('id', (2, 5, 29, 54))])
    
    #-----< id-ce-inhibitAnyPolicy >-----#
    id_ce_inhibitAnyPolicy = OID(name='id-ce-inhibitAnyPolicy', mode=MODE_VALUE)
    id_ce_inhibitAnyPolicy._val = (2, 5, 29, 54)
    
    #-----< ext-FreshestCRL >-----#
    ext_FreshestCRL = CLASS(name='ext-FreshestCRL', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_FreshestCRL_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    ext_FreshestCRL._val = dict([('ExtnType', _ext_FreshestCRL_val_ExtnType), ('id', (2, 5, 29, 46))])
    
    #-----< id-ce-freshestCRL >-----#
    id_ce_freshestCRL = OID(name='id-ce-freshestCRL', mode=MODE_VALUE)
    id_ce_freshestCRL._val = (2, 5, 29, 46)
    
    #-----< ext-AuthorityInfoAccess >-----#
    ext_AuthorityInfoAccess = CLASS(name='ext-AuthorityInfoAccess', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_AuthorityInfoAccess_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityInfoAccessSyntax')))
    ext_AuthorityInfoAccess._val = dict([('ExtnType', _ext_AuthorityInfoAccess_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 1))])
    
    #-----< id-pe-authorityInfoAccess >-----#
    id_pe_authorityInfoAccess = OID(name='id-pe-authorityInfoAccess', mode=MODE_VALUE)
    id_pe_authorityInfoAccess._val = (1, 3, 6, 1, 5, 5, 7, 1, 1)
    
    #-----< AuthorityInfoAccessSyntax >-----#
    AuthorityInfoAccessSyntax = SEQ_OF(name='AuthorityInfoAccessSyntax', mode=MODE_TYPE)
    _AuthorityInfoAccessSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AccessDescription')))
    AuthorityInfoAccessSyntax._cont = _AuthorityInfoAccessSyntax__item_
    AuthorityInfoAccessSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< AccessDescription >-----#
    AccessDescription = SEQ(name='AccessDescription', mode=MODE_TYPE)
    _AccessDescription_accessMethod = OID(name='accessMethod', mode=MODE_TYPE)
    _AccessDescription_accessLocation = CHOICE(name='accessLocation', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    AccessDescription._cont = ASN1Dict([
        ('accessMethod', _AccessDescription_accessMethod),
        ('accessLocation', _AccessDescription_accessLocation),
        ])
    AccessDescription._ext = None
    
    #-----< ext-SubjectInfoAccessSyntax >-----#
    ext_SubjectInfoAccessSyntax = CLASS(name='ext-SubjectInfoAccessSyntax', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_SubjectInfoAccessSyntax_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectInfoAccessSyntax')))
    ext_SubjectInfoAccessSyntax._val = dict([('ExtnType', _ext_SubjectInfoAccessSyntax_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 11))])
    
    #-----< id-pe-subjectInfoAccess >-----#
    id_pe_subjectInfoAccess = OID(name='id-pe-subjectInfoAccess', mode=MODE_VALUE)
    id_pe_subjectInfoAccess._val = (1, 3, 6, 1, 5, 5, 7, 1, 11)
    
    #-----< SubjectInfoAccessSyntax >-----#
    SubjectInfoAccessSyntax = SEQ_OF(name='SubjectInfoAccessSyntax', mode=MODE_TYPE)
    _SubjectInfoAccessSyntax__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AccessDescription')))
    SubjectInfoAccessSyntax._cont = _SubjectInfoAccessSyntax__item_
    SubjectInfoAccessSyntax._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< ext-CRLNumber >-----#
    ext_CRLNumber = CLASS(name='ext-CRLNumber', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_CRLNumber_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE)
    _ext_CRLNumber_val_ExtnType._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    ext_CRLNumber._val = dict([('ExtnType', _ext_CRLNumber_val_ExtnType), ('id', (2, 5, 29, 20))])
    
    #-----< id-ce-cRLNumber >-----#
    id_ce_cRLNumber = OID(name='id-ce-cRLNumber', mode=MODE_VALUE)
    id_ce_cRLNumber._val = (2, 5, 29, 20)
    
    #-----< CRLNumber >-----#
    CRLNumber = INT(name='CRLNumber', mode=MODE_TYPE)
    CRLNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< ext-IssuingDistributionPoint >-----#
    ext_IssuingDistributionPoint = CLASS(name='ext-IssuingDistributionPoint', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_IssuingDistributionPoint_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'IssuingDistributionPoint')))
    ext_IssuingDistributionPoint._val = dict([('ExtnType', _ext_IssuingDistributionPoint_val_ExtnType), ('id', (2, 5, 29, 28))])
    
    #-----< id-ce-issuingDistributionPoint >-----#
    id_ce_issuingDistributionPoint = OID(name='id-ce-issuingDistributionPoint', mode=MODE_VALUE)
    id_ce_issuingDistributionPoint._val = (2, 5, 29, 28)
    
    #-----< IssuingDistributionPoint >-----#
    IssuingDistributionPoint = SEQ(name='IssuingDistributionPoint', mode=MODE_TYPE)
    _IssuingDistributionPoint_distributionPoint = CHOICE(name='distributionPoint', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'DistributionPointName')), opt=True)
    _IssuingDistributionPoint_onlyContainsUserCerts = BOOL(name='onlyContainsUserCerts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistributionPoint_onlyContainsCACerts = BOOL(name='onlyContainsCACerts', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistributionPoint_onlySomeReasons = BIT_STR(name='onlySomeReasons', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'ReasonFlags')), opt=True)
    _IssuingDistributionPoint_indirectCRL = BOOL(name='indirectCRL', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _IssuingDistributionPoint_onlyContainsAttributeCerts = BOOL(name='onlyContainsAttributeCerts', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    IssuingDistributionPoint._cont = ASN1Dict([
        ('distributionPoint', _IssuingDistributionPoint_distributionPoint),
        ('onlyContainsUserCerts', _IssuingDistributionPoint_onlyContainsUserCerts),
        ('onlyContainsCACerts', _IssuingDistributionPoint_onlyContainsCACerts),
        ('onlySomeReasons', _IssuingDistributionPoint_onlySomeReasons),
        ('indirectCRL', _IssuingDistributionPoint_indirectCRL),
        ('onlyContainsAttributeCerts', _IssuingDistributionPoint_onlyContainsAttributeCerts),
        ])
    IssuingDistributionPoint._ext = None
    
    #-----< ext-DeltaCRLIndicator >-----#
    ext_DeltaCRLIndicator = CLASS(name='ext-DeltaCRLIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_DeltaCRLIndicator_val_ExtnType = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLNumber')))
    ext_DeltaCRLIndicator._val = dict([('ExtnType', _ext_DeltaCRLIndicator_val_ExtnType), ('id', (2, 5, 29, 27))])
    
    #-----< id-ce-deltaCRLIndicator >-----#
    id_ce_deltaCRLIndicator = OID(name='id-ce-deltaCRLIndicator', mode=MODE_VALUE)
    id_ce_deltaCRLIndicator._val = (2, 5, 29, 27)
    
    #-----< ext-CRLReason >-----#
    ext_CRLReason = CLASS(name='ext-CRLReason', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_CRLReason_val_ExtnType = ENUM(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLReason')))
    ext_CRLReason._val = dict([('ExtnType', _ext_CRLReason_val_ExtnType), ('id', (2, 5, 29, 21))])
    
    #-----< id-ce-cRLReasons >-----#
    id_ce_cRLReasons = OID(name='id-ce-cRLReasons', mode=MODE_VALUE)
    id_ce_cRLReasons._val = (2, 5, 29, 21)
    
    #-----< CRLReason >-----#
    CRLReason = ENUM(name='CRLReason', mode=MODE_TYPE)
    CRLReason._cont = ASN1Dict([('unspecified', 0), ('keyCompromise', 1), ('cACompromise', 2), ('affiliationChanged', 3), ('superseded', 4), ('cessationOfOperation', 5), ('certificateHold', 6), ('removeFromCRL', 8), ('privilegeWithdrawn', 9), ('aACompromise', 10)])
    CRLReason._ext = None
    
    #-----< ext-CertificateIssuer >-----#
    ext_CertificateIssuer = CLASS(name='ext-CertificateIssuer', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_CertificateIssuer_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    ext_CertificateIssuer._val = dict([('ExtnType', _ext_CertificateIssuer_val_ExtnType), ('id', (2, 5, 29, 29))])
    
    #-----< id-ce-certificateIssuer >-----#
    id_ce_certificateIssuer = OID(name='id-ce-certificateIssuer', mode=MODE_VALUE)
    id_ce_certificateIssuer._val = (2, 5, 29, 29)
    
    #-----< ext-HoldInstructionCode >-----#
    ext_HoldInstructionCode = CLASS(name='ext-HoldInstructionCode', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_HoldInstructionCode_val_ExtnType = OID(name='ExtnType', mode=MODE_TYPE)
    ext_HoldInstructionCode._val = dict([('ExtnType', _ext_HoldInstructionCode_val_ExtnType), ('id', (2, 5, 29, 23))])
    
    #-----< id-ce-holdInstructionCode >-----#
    id_ce_holdInstructionCode = OID(name='id-ce-holdInstructionCode', mode=MODE_VALUE)
    id_ce_holdInstructionCode._val = (2, 5, 29, 23)
    
    #-----< holdInstruction >-----#
    holdInstruction = OID(name='holdInstruction', mode=MODE_VALUE)
    holdInstruction._val = (2, 2, 840, 10040, 2)
    
    #-----< id-holdinstruction-none >-----#
    id_holdinstruction_none = OID(name='id-holdinstruction-none', mode=MODE_VALUE)
    id_holdinstruction_none._val = (2, 2, 840, 10040, 2, 1)
    
    #-----< id-holdinstruction-callissuer >-----#
    id_holdinstruction_callissuer = OID(name='id-holdinstruction-callissuer', mode=MODE_VALUE)
    id_holdinstruction_callissuer._val = (2, 2, 840, 10040, 2, 2)
    
    #-----< id-holdinstruction-reject >-----#
    id_holdinstruction_reject = OID(name='id-holdinstruction-reject', mode=MODE_VALUE)
    id_holdinstruction_reject._val = (2, 2, 840, 10040, 2, 3)
    
    #-----< ext-InvalidityDate >-----#
    ext_InvalidityDate = CLASS(name='ext-InvalidityDate', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_InvalidityDate_val_ExtnType = TIME_GEN(name='ExtnType', mode=MODE_TYPE)
    ext_InvalidityDate._val = dict([('ExtnType', _ext_InvalidityDate_val_ExtnType), ('id', (2, 5, 29, 24))])
    
    #-----< id-ce-invalidityDate >-----#
    id_ce_invalidityDate = OID(name='id-ce-invalidityDate', mode=MODE_VALUE)
    id_ce_invalidityDate._val = (2, 5, 29, 24)
    
    #-----< ubMax >-----#
    ubMax = INT(name='ubMax', mode=MODE_VALUE)
    ubMax._val = 32768
    
    _all_ = [
        CertExtensions,
        _CertExtensions_val_ExtnType_0,
        _CertExtensions_val_ExtnType_1,
        _CertExtensions_val_ExtnType_2,
        _CertExtensions_val_ExtnType_3,
        _CertExtensions_val_ExtnType_4,
        _CertExtensions_val_ExtnType_5,
        _CertExtensions_val_ExtnType_6,
        _CertExtensions_val_ExtnType_7,
        _CertExtensions_val_ExtnType_8,
        _CertExtensions_val_ExtnType_9,
        _CertExtensions_val_ExtnType_10,
        _CertExtensions_val_ExtnType_11,
        _CertExtensions_val_ExtnType_12,
        _CertExtensions_val_ExtnType_13,
        _CertExtensions_val_ExtnType_14,
        _CertExtensions_val_ExtnType_15,
        _CertExtensions_val_ExtnType_16,
        _CertExtensions_val_ExtnType_17,
        CrlExtensions,
        _CrlExtensions_val_ExtnType_0,
        _CrlExtensions_val_ExtnType_1,
        _CrlExtensions_val_ExtnType_2,
        _CrlExtensions_val_ExtnType_3,
        _CrlExtensions_val_ExtnType_4,
        _CrlExtensions_val_ExtnType_5,
        CrlEntryExtensions,
        _CrlEntryExtensions_val_ExtnType_0,
        _CrlEntryExtensions_val_ExtnType_1,
        _CrlEntryExtensions_val_ExtnType_2,
        _CrlEntryExtensions_val_ExtnType_3,
        id_ce,
        ext_AuthorityKeyIdentifier,
        _ext_AuthorityKeyIdentifier_val_ExtnType,
        id_ce_authorityKeyIdentifier,
        _AuthorityKeyIdentifier_keyIdentifier,
        _AuthorityKeyIdentifier_authorityCertIssuer,
        _AuthorityKeyIdentifier_authorityCertSerialNumber,
        AuthorityKeyIdentifier,
        KeyIdentifier,
        ext_SubjectKeyIdentifier,
        _ext_SubjectKeyIdentifier_val_ExtnType,
        id_ce_subjectKeyIdentifier,
        ext_KeyUsage,
        _ext_KeyUsage_val_ExtnType,
        id_ce_keyUsage,
        KeyUsage,
        ext_PrivateKeyUsagePeriod,
        _ext_PrivateKeyUsagePeriod_val_ExtnType,
        id_ce_privateKeyUsagePeriod,
        _PrivateKeyUsagePeriod_notBefore,
        _PrivateKeyUsagePeriod_notAfter,
        PrivateKeyUsagePeriod,
        ext_CertificatePolicies,
        _ext_CertificatePolicies_val_ExtnType,
        id_ce_certificatePolicies,
        _CertificatePolicies__item_,
        CertificatePolicies,
        _PolicyInformation_policyIdentifier,
        __PolicyInformation_policyQualifiers__item_,
        _PolicyInformation_policyQualifiers,
        PolicyInformation,
        CertPolicyId,
        CERT_POLICY_QUALIFIER,
        __PolicyQualifierInfo_policyQualifierId_tab,
        ___PolicyQualifierInfo_policyQualifierId_tab_val_Type_0,
        ___PolicyQualifierInfo_policyQualifierId_tab_val_Type_1,
        _PolicyQualifierInfo_policyQualifierId,
        _PolicyQualifierInfo_qualifier,
        PolicyQualifierInfo,
        PolicyQualifierId,
        _PolicyQualifierId_val_Type_0,
        _PolicyQualifierId_val_Type_1,
        pqid_cps,
        _pqid_cps_val_Type,
        pqid_unotice,
        _pqid_unotice_val_Type,
        CPSuri,
        _UserNotice_noticeRef,
        _UserNotice_explicitText,
        UserNotice,
        _NoticeReference_organization,
        __NoticeReference_noticeNumbers__item_,
        _NoticeReference_noticeNumbers,
        NoticeReference,
        _DisplayText_ia5String,
        _DisplayText_visibleString,
        _DisplayText_bmpString,
        _DisplayText_utf8String,
        DisplayText,
        ext_PolicyMappings,
        _ext_PolicyMappings_val_ExtnType,
        id_ce_policyMappings,
        __PolicyMappings__item__issuerDomainPolicy,
        __PolicyMappings__item__subjectDomainPolicy,
        _PolicyMappings__item_,
        PolicyMappings,
        ext_SubjectAltName,
        _ext_SubjectAltName_val_ExtnType,
        id_ce_subjectAltName,
        _GeneralNames__item_,
        GeneralNames,
        __GeneralName_otherName_type_id,
        __GeneralName_otherName_value,
        _GeneralName_otherName,
        _GeneralName_otherName,
        _GeneralName_rfc822Name,
        _GeneralName_dNSName,
        _GeneralName_x400Address,
        _GeneralName_directoryName,
        _GeneralName_ediPartyName,
        _GeneralName_uniformResourceIdentifier,
        _GeneralName_iPAddress,
        _GeneralName_registeredID,
        GeneralName,
        OTHER_NAME,
        __EDIPartyName_nameAssigner_teletexString,
        __EDIPartyName_nameAssigner_printableString,
        __EDIPartyName_nameAssigner_bmpString,
        __EDIPartyName_nameAssigner_universalString,
        __EDIPartyName_nameAssigner_uTF8String,
        _EDIPartyName_nameAssigner,
        __EDIPartyName_partyName_teletexString,
        __EDIPartyName_partyName_printableString,
        __EDIPartyName_partyName_bmpString,
        __EDIPartyName_partyName_universalString,
        __EDIPartyName_partyName_uTF8String,
        _EDIPartyName_partyName,
        EDIPartyName,
        ext_IssuerAltName,
        _ext_IssuerAltName_val_ExtnType,
        id_ce_issuerAltName,
        ext_SubjectDirectoryAttributes,
        _ext_SubjectDirectoryAttributes_val_ExtnType,
        id_ce_subjectDirectoryAttributes,
        ___SubjectDirectoryAttributes__item__type_tab,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_0,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_1,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_2,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_3,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_4,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_5,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_6,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_teletexString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_printableString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_bmpString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_universalString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_7_uTF8String,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_7,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_teletexString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_printableString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_bmpString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_universalString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_8_uTF8String,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_8,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_teletexString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_printableString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_bmpString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_universalString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_9_uTF8String,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_9,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_teletexString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_printableString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_bmpString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_universalString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_10_uTF8String,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_10,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_11,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_12,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_13,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_teletexString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_printableString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_bmpString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_universalString,
        _____SubjectDirectoryAttributes__item__type_tab_val_Type_14_uTF8String,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_14,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_15,
        ____SubjectDirectoryAttributes__item__type_tab_val_Type_16,
        __SubjectDirectoryAttributes__item__type,
        ___SubjectDirectoryAttributes__item__values__item_,
        __SubjectDirectoryAttributes__item__values,
        _SubjectDirectoryAttributes__item_,
        SubjectDirectoryAttributes,
        ext_BasicConstraints,
        _ext_BasicConstraints_val_ExtnType,
        id_ce_basicConstraints,
        _BasicConstraints_cA,
        _BasicConstraints_pathLenConstraint,
        BasicConstraints,
        ext_NameConstraints,
        _ext_NameConstraints_val_ExtnType,
        id_ce_nameConstraints,
        _NameConstraints_permittedSubtrees,
        _NameConstraints_excludedSubtrees,
        NameConstraints,
        _GeneralSubtrees__item_,
        GeneralSubtrees,
        _GeneralSubtree_base,
        _GeneralSubtree_minimum,
        _GeneralSubtree_maximum,
        GeneralSubtree,
        BaseDistance,
        ext_PolicyConstraints,
        _ext_PolicyConstraints_val_ExtnType,
        id_ce_policyConstraints,
        _PolicyConstraints_requireExplicitPolicy,
        _PolicyConstraints_inhibitPolicyMapping,
        PolicyConstraints,
        SkipCerts,
        ext_CRLDistributionPoints,
        _ext_CRLDistributionPoints_val_ExtnType,
        id_ce_cRLDistributionPoints,
        _CRLDistributionPoints__item_,
        CRLDistributionPoints,
        _DistributionPoint_distributionPoint,
        _DistributionPoint_reasons,
        _DistributionPoint_cRLIssuer,
        DistributionPoint,
        _DistributionPointName_fullName,
        _DistributionPointName_nameRelativeToCRLIssuer,
        DistributionPointName,
        ReasonFlags,
        ext_ExtKeyUsage,
        _ext_ExtKeyUsage_val_ExtnType,
        id_ce_extKeyUsage,
        _ExtKeyUsageSyntax__item_,
        ExtKeyUsageSyntax,
        KeyPurposeId,
        anyExtendedKeyUsage,
        id_kp_serverAuth,
        id_kp_clientAuth,
        id_kp_codeSigning,
        id_kp_emailProtection,
        id_kp_timeStamping,
        id_kp_OCSPSigning,
        ext_InhibitAnyPolicy,
        _ext_InhibitAnyPolicy_val_ExtnType,
        id_ce_inhibitAnyPolicy,
        ext_FreshestCRL,
        _ext_FreshestCRL_val_ExtnType,
        id_ce_freshestCRL,
        ext_AuthorityInfoAccess,
        _ext_AuthorityInfoAccess_val_ExtnType,
        id_pe_authorityInfoAccess,
        _AuthorityInfoAccessSyntax__item_,
        AuthorityInfoAccessSyntax,
        _AccessDescription_accessMethod,
        _AccessDescription_accessLocation,
        AccessDescription,
        ext_SubjectInfoAccessSyntax,
        _ext_SubjectInfoAccessSyntax_val_ExtnType,
        id_pe_subjectInfoAccess,
        _SubjectInfoAccessSyntax__item_,
        SubjectInfoAccessSyntax,
        ext_CRLNumber,
        _ext_CRLNumber_val_ExtnType,
        id_ce_cRLNumber,
        CRLNumber,
        ext_IssuingDistributionPoint,
        _ext_IssuingDistributionPoint_val_ExtnType,
        id_ce_issuingDistributionPoint,
        _IssuingDistributionPoint_distributionPoint,
        _IssuingDistributionPoint_onlyContainsUserCerts,
        _IssuingDistributionPoint_onlyContainsCACerts,
        _IssuingDistributionPoint_onlySomeReasons,
        _IssuingDistributionPoint_indirectCRL,
        _IssuingDistributionPoint_onlyContainsAttributeCerts,
        IssuingDistributionPoint,
        ext_DeltaCRLIndicator,
        _ext_DeltaCRLIndicator_val_ExtnType,
        id_ce_deltaCRLIndicator,
        ext_CRLReason,
        _ext_CRLReason_val_ExtnType,
        id_ce_cRLReasons,
        CRLReason,
        ext_CertificateIssuer,
        _ext_CertificateIssuer_val_ExtnType,
        id_ce_certificateIssuer,
        ext_HoldInstructionCode,
        _ext_HoldInstructionCode_val_ExtnType,
        id_ce_holdInstructionCode,
        holdInstruction,
        id_holdinstruction_none,
        id_holdinstruction_callissuer,
        id_holdinstruction_reject,
        ext_InvalidityDate,
        _ext_InvalidityDate_val_ExtnType,
        id_ce_invalidityDate,
        ubMax,
    ]

class PKIX1_PSS_OAEP_Algorithms_2009:

    _name_  = 'PKIX1-PSS-OAEP-Algorithms-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 54]
    
    _obj_ = [
        'PublicKeys',
        'SignatureAlgs',
        'KeyTransportAlgs',
        'HashAlgs',
        'SMimeCaps',
        'pk-rsaSSA-PSS',
        'sa-rsaSSA-PSS',
        'sa-sha224WithRSAEncryption',
        'sha224WithRSAEncryption',
        'sa-sha256WithRSAEncryption',
        'sha256WithRSAEncryption',
        'sa-sha384WithRSAEncryption',
        'sha384WithRSAEncryption',
        'sa-sha512WithRSAEncryption',
        'sha512WithRSAEncryption',
        'pk-rsaES-OAEP',
        'kta-rsaES-OAEP',
        'pkcs-1',
        'id-RSAES-OAEP',
        'id-mgf1',
        'id-pSpecified',
        'id-RSASSA-PSS',
        'id-sha224',
        'mda-sha224',
        'id-sha256',
        'mda-sha256',
        'id-sha384',
        'mda-sha384',
        'id-sha512',
        'mda-sha512',
        'EncodingParameters',
        'nullOctetString',
        'nullParameters',
        'HashAlgorithm',
        'HashAlgorithms',
        'sha1Identifier',
        'MaskGenAlgorithm',
        'mgf1SHA1',
        'PKCS1MGFAlgorithms',
        'PSourceAlgorithm',
        'PSS-SourceAlgorithms',
        'pSpecifiedEmpty',
        'RSASSA-PSS-params',
        'RSAES-OAEP-params',
        ]
    _type_ = [
        'EncodingParameters',
        'HashAlgorithm',
        'MaskGenAlgorithm',
        'PSourceAlgorithm',
        'RSASSA-PSS-params',
        'RSAES-OAEP-params',
        ]
    _set_ = [
        'PublicKeys',
        'SignatureAlgs',
        'KeyTransportAlgs',
        'HashAlgs',
        'SMimeCaps',
        'HashAlgorithms',
        'PKCS1MGFAlgorithms',
        'PSS-SourceAlgorithms',
        ]
    _val_ = [
        'pk-rsaSSA-PSS',
        'sa-rsaSSA-PSS',
        'sa-sha224WithRSAEncryption',
        'sha224WithRSAEncryption',
        'sa-sha256WithRSAEncryption',
        'sha256WithRSAEncryption',
        'sa-sha384WithRSAEncryption',
        'sha384WithRSAEncryption',
        'sa-sha512WithRSAEncryption',
        'sha512WithRSAEncryption',
        'pk-rsaES-OAEP',
        'kta-rsaES-OAEP',
        'pkcs-1',
        'id-RSAES-OAEP',
        'id-mgf1',
        'id-pSpecified',
        'id-RSASSA-PSS',
        'id-sha224',
        'mda-sha224',
        'id-sha256',
        'mda-sha256',
        'id-sha384',
        'mda-sha384',
        'id-sha512',
        'mda-sha512',
        'nullOctetString',
        'nullParameters',
        'sha1Identifier',
        'mgf1SHA1',
        'pSpecifiedEmpty',
        ]
    _class_ = [
        'PublicKeys',
        'SignatureAlgs',
        'KeyTransportAlgs',
        'HashAlgs',
        'SMimeCaps',
        'pk-rsaSSA-PSS',
        'sa-rsaSSA-PSS',
        'sa-sha224WithRSAEncryption',
        'sa-sha256WithRSAEncryption',
        'sa-sha384WithRSAEncryption',
        'sa-sha512WithRSAEncryption',
        'pk-rsaES-OAEP',
        'kta-rsaES-OAEP',
        'mda-sha224',
        'mda-sha256',
        'mda-sha384',
        'mda-sha512',
        'HashAlgorithms',
        'PKCS1MGFAlgorithms',
        'PSS-SourceAlgorithms',
        ]
    _param_ = [
        ]
    
    #-----< PublicKeys >-----#
    PublicKeys = CLASS(name='PublicKeys', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _PublicKeys_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _PublicKeys_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    _PublicKeys_val_KeyValue_1 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _PublicKeys_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    PublicKeys._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', _PublicKeys_val_KeyValue_0), ('Params', _PublicKeys_val_Params_0), ('paramPresence', 'optional'), ('keyUsage', (99, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 7)), ('KeyValue', _PublicKeys_val_KeyValue_1), ('Params', _PublicKeys_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (3, 4))])], rr=[], ev=[], er=[])
    
    #-----< SignatureAlgs >-----#
    SignatureAlgs = CLASS(name='SignatureAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _SignatureAlgs_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    __SIGNATURE_ALGORITHM_HashSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    SignatureAlgs._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', _SignatureAlgs_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], rr=[], ev=[], er=[])
    
    #-----< KeyTransportAlgs >-----#
    KeyTransportAlgs = CLASS(name='KeyTransportAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-TRANSPORT')))
    _KeyTransportAlgs_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    __KEY_TRANSPORT_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __KEY_TRANSPORT_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __KEY_TRANSPORT_PublicKeySet_val_KeyValue_1 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __KEY_TRANSPORT_PublicKeySet_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    __KEY_TRANSPORT_smimeCaps_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    KeyTransportAlgs._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 7)), ('Params', _KeyTransportAlgs_val_Params_0), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __KEY_TRANSPORT_PublicKeySet_val_KeyValue_0), ('Params', __KEY_TRANSPORT_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 7)), ('KeyValue', __KEY_TRANSPORT_PublicKeySet_val_KeyValue_1), ('Params', __KEY_TRANSPORT_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (3, 4))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('Type', __KEY_TRANSPORT_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 1, 1, 7))]))])], rr=[], ev=[], er=[])
    
    #-----< HashAlgs >-----#
    HashAlgs = CLASS(name='HashAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _HashAlgs_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _HashAlgs_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    _HashAlgs_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    _HashAlgs_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    HashAlgs._val = ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', _HashAlgs_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', _HashAlgs_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', _HashAlgs_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', _HashAlgs_val_Params_3), ('paramPresence', 'preferredAbsent')])], rr=[], ev=[], er=[])
    
    #-----< SMimeCaps >-----#
    SMimeCaps = CLASS(name='SMimeCaps', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')))
    _SMimeCaps_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    SMimeCaps._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 10))]), dict([('Type', _SMimeCaps_val_Type_1), ('id', (1, 2, 840, 113549, 1, 1, 7))])], rr=[], ev=[], er=[])
    
    #-----< pk-rsaSSA-PSS >-----#
    pk_rsaSSA_PSS = CLASS(name='pk-rsaSSA-PSS', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _pk_rsaSSA_PSS_val_KeyValue = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _pk_rsaSSA_PSS_val_Params = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    pk_rsaSSA_PSS._val = dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', _pk_rsaSSA_PSS_val_KeyValue), ('Params', _pk_rsaSSA_PSS_val_Params), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])
    
    #-----< sa-rsaSSA-PSS >-----#
    sa_rsaSSA_PSS = CLASS(name='sa-rsaSSA-PSS', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_rsaSSA_PSS_val_Params = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    sa_rsaSSA_PSS._val = dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', _sa_rsaSSA_PSS_val_Params), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])
    
    #-----< sa-sha224WithRSAEncryption >-----#
    sa_sha224WithRSAEncryption = CLASS(name='sa-sha224WithRSAEncryption', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_sha224WithRSAEncryption_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_sha224WithRSAEncryption._val = dict([('id', (1, 2, 840, 113549, 1, 1, 14)), ('Params', _sa_sha224WithRSAEncryption_val_Params), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 14))]))])
    
    #-----< sha224WithRSAEncryption >-----#
    sha224WithRSAEncryption = OID(name='sha224WithRSAEncryption', mode=MODE_VALUE)
    sha224WithRSAEncryption._val = (1, 2, 840, 113549, 1, 1, 14)
    
    #-----< sa-sha256WithRSAEncryption >-----#
    sa_sha256WithRSAEncryption = CLASS(name='sa-sha256WithRSAEncryption', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_sha256WithRSAEncryption_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_sha256WithRSAEncryption._val = dict([('id', (1, 2, 840, 113549, 1, 1, 11)), ('Params', _sa_sha256WithRSAEncryption_val_Params), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 11))]))])
    
    #-----< sha256WithRSAEncryption >-----#
    sha256WithRSAEncryption = OID(name='sha256WithRSAEncryption', mode=MODE_VALUE)
    sha256WithRSAEncryption._val = (1, 2, 840, 113549, 1, 1, 11)
    
    #-----< sa-sha384WithRSAEncryption >-----#
    sa_sha384WithRSAEncryption = CLASS(name='sa-sha384WithRSAEncryption', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_sha384WithRSAEncryption_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_sha384WithRSAEncryption._val = dict([('id', (1, 2, 840, 113549, 1, 1, 12)), ('Params', _sa_sha384WithRSAEncryption_val_Params), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 12))]))])
    
    #-----< sha384WithRSAEncryption >-----#
    sha384WithRSAEncryption = OID(name='sha384WithRSAEncryption', mode=MODE_VALUE)
    sha384WithRSAEncryption._val = (1, 2, 840, 113549, 1, 1, 12)
    
    #-----< sa-sha512WithRSAEncryption >-----#
    sa_sha512WithRSAEncryption = CLASS(name='sa-sha512WithRSAEncryption', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_sha512WithRSAEncryption_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_sha512WithRSAEncryption._val = dict([('id', (1, 2, 840, 113549, 1, 1, 13)), ('Params', _sa_sha512WithRSAEncryption_val_Params), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 13))]))])
    
    #-----< sha512WithRSAEncryption >-----#
    sha512WithRSAEncryption = OID(name='sha512WithRSAEncryption', mode=MODE_VALUE)
    sha512WithRSAEncryption._val = (1, 2, 840, 113549, 1, 1, 13)
    
    #-----< pk-rsaES-OAEP >-----#
    pk_rsaES_OAEP = CLASS(name='pk-rsaES-OAEP', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _pk_rsaES_OAEP_val_KeyValue = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _pk_rsaES_OAEP_val_Params = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    pk_rsaES_OAEP._val = dict([('id', (1, 2, 840, 113549, 1, 1, 7)), ('KeyValue', _pk_rsaES_OAEP_val_KeyValue), ('Params', _pk_rsaES_OAEP_val_Params), ('paramPresence', 'optional'), ('keyUsage', (3, 4))])
    
    #-----< kta-rsaES-OAEP >-----#
    kta_rsaES_OAEP = CLASS(name='kta-rsaES-OAEP', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-TRANSPORT')))
    _kta_rsaES_OAEP_val_Params = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSAES-OAEP-params')))
    kta_rsaES_OAEP._val = dict([('id', (1, 2, 840, 113549, 1, 1, 7)), ('Params', _kta_rsaES_OAEP_val_Params), ('paramPresence', 'required'), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __KEY_TRANSPORT_PublicKeySet_val_KeyValue_0), ('Params', __KEY_TRANSPORT_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 7)), ('KeyValue', __KEY_TRANSPORT_PublicKeySet_val_KeyValue_1), ('Params', __KEY_TRANSPORT_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (3, 4))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('Type', __KEY_TRANSPORT_smimeCaps_val_Type), ('id', (1, 2, 840, 113549, 1, 1, 7))]))])
    
    #-----< pkcs-1 >-----#
    pkcs_1 = OID(name='pkcs-1', mode=MODE_VALUE)
    pkcs_1._val = (1, 2, 840, 113549, 1, 1)
    
    #-----< id-RSAES-OAEP >-----#
    id_RSAES_OAEP = OID(name='id-RSAES-OAEP', mode=MODE_VALUE)
    id_RSAES_OAEP._val = (1, 2, 840, 113549, 1, 1, 7)
    
    #-----< id-mgf1 >-----#
    id_mgf1 = OID(name='id-mgf1', mode=MODE_VALUE)
    id_mgf1._val = (1, 2, 840, 113549, 1, 1, 8)
    
    #-----< id-pSpecified >-----#
    id_pSpecified = OID(name='id-pSpecified', mode=MODE_VALUE)
    id_pSpecified._val = (1, 2, 840, 113549, 1, 1, 9)
    
    #-----< id-RSASSA-PSS >-----#
    id_RSASSA_PSS = OID(name='id-RSASSA-PSS', mode=MODE_VALUE)
    id_RSASSA_PSS._val = (1, 2, 840, 113549, 1, 1, 10)
    
    #-----< id-sha224 >-----#
    id_sha224 = OID(name='id-sha224', mode=MODE_VALUE)
    id_sha224._val = (2, 16, 840, 1, 101, 3, 4, 2, 4)
    
    #-----< mda-sha224 >-----#
    mda_sha224 = CLASS(name='mda-sha224', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _mda_sha224_val_Params = NULL(name='Params', mode=MODE_TYPE)
    mda_sha224._val = dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', _mda_sha224_val_Params), ('paramPresence', 'preferredAbsent')])
    
    #-----< id-sha256 >-----#
    id_sha256 = OID(name='id-sha256', mode=MODE_VALUE)
    id_sha256._val = (2, 16, 840, 1, 101, 3, 4, 2, 1)
    
    #-----< mda-sha256 >-----#
    mda_sha256 = CLASS(name='mda-sha256', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _mda_sha256_val_Params = NULL(name='Params', mode=MODE_TYPE)
    mda_sha256._val = dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', _mda_sha256_val_Params), ('paramPresence', 'preferredAbsent')])
    
    #-----< id-sha384 >-----#
    id_sha384 = OID(name='id-sha384', mode=MODE_VALUE)
    id_sha384._val = (2, 16, 840, 1, 101, 3, 4, 2, 2)
    
    #-----< mda-sha384 >-----#
    mda_sha384 = CLASS(name='mda-sha384', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _mda_sha384_val_Params = NULL(name='Params', mode=MODE_TYPE)
    mda_sha384._val = dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', _mda_sha384_val_Params), ('paramPresence', 'preferredAbsent')])
    
    #-----< id-sha512 >-----#
    id_sha512 = OID(name='id-sha512', mode=MODE_VALUE)
    id_sha512._val = (2, 16, 840, 1, 101, 3, 4, 2, 3)
    
    #-----< mda-sha512 >-----#
    mda_sha512 = CLASS(name='mda-sha512', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _mda_sha512_val_Params = NULL(name='Params', mode=MODE_TYPE)
    mda_sha512._val = dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', _mda_sha512_val_Params), ('paramPresence', 'preferredAbsent')])
    
    #-----< EncodingParameters >-----#
    EncodingParameters = OCT_STR(name='EncodingParameters', mode=MODE_TYPE)
    EncodingParameters._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    
    #-----< nullOctetString >-----#
    nullOctetString = OCT_STR(name='nullOctetString', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'EncodingParameters')))
    nullOctetString._val = b''
    
    #-----< nullParameters >-----#
    nullParameters = NULL(name='nullParameters', mode=MODE_VALUE)
    nullParameters._val = 0
    
    #-----< HashAlgorithm >-----#
    HashAlgorithm = SEQ(name='HashAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _HashAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    __HashAlgorithm_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___HashAlgorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___HashAlgorithm_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ___HashAlgorithm_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ___HashAlgorithm_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    ___HashAlgorithm_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __HashAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', ___HashAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'preferredPresent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', ___HashAlgorithm_algorithm_tab_val_Params_1), ('paramPresence', 'preferredPresent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', ___HashAlgorithm_algorithm_tab_val_Params_2), ('paramPresence', 'preferredPresent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', ___HashAlgorithm_algorithm_tab_val_Params_3), ('paramPresence', 'preferredPresent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', ___HashAlgorithm_algorithm_tab_val_Params_4), ('paramPresence', 'preferredPresent')])], rr=[], ev=None, er=[])
    _HashAlgorithm_algorithm._const_tab = __HashAlgorithm_algorithm_tab
    _HashAlgorithm_algorithm._const_tab_at = None
    _HashAlgorithm_algorithm._const_tab_id = 'id'
    _HashAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    _HashAlgorithm_parameters._const_tab = __HashAlgorithm_algorithm_tab
    _HashAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    _HashAlgorithm_parameters._const_tab_id = 'Params'
    HashAlgorithm._cont = ASN1Dict([
        ('algorithm', _HashAlgorithm_algorithm),
        ('parameters', _HashAlgorithm_parameters),
        ])
    HashAlgorithm._ext = None
    
    #-----< HashAlgorithms >-----#
    HashAlgorithms = CLASS(name='HashAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _HashAlgorithms_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _HashAlgorithms_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    _HashAlgorithms_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    _HashAlgorithms_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    _HashAlgorithms_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    HashAlgorithms._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', _HashAlgorithms_val_Params_0), ('paramPresence', 'preferredPresent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', _HashAlgorithms_val_Params_1), ('paramPresence', 'preferredPresent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', _HashAlgorithms_val_Params_2), ('paramPresence', 'preferredPresent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', _HashAlgorithms_val_Params_3), ('paramPresence', 'preferredPresent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', _HashAlgorithms_val_Params_4), ('paramPresence', 'preferredPresent')])], rr=[], ev=None, er=[])
    
    #-----< sha1Identifier >-----#
    sha1Identifier = SEQ(name='sha1Identifier', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'HashAlgorithm')))
    _parameters_val = NULL(name='parameters', mode=MODE_TYPE)
    sha1Identifier._val = dict([('algorithm', (1, 3, 14, 3, 2, 26)), ('parameters', (_parameters_val, 0))])
    
    #-----< MaskGenAlgorithm >-----#
    MaskGenAlgorithm = SEQ(name='MaskGenAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _MaskGenAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['id']))
    __MaskGenAlgorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___MaskGenAlgorithm_algorithm_tab_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'HashAlgorithm')))
    __MaskGenAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 8)), ('Params', ___MaskGenAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'required')])], rr=[], ev=None, er=[])
    _MaskGenAlgorithm_algorithm._const_tab = __MaskGenAlgorithm_algorithm_tab
    _MaskGenAlgorithm_algorithm._const_tab_at = None
    _MaskGenAlgorithm_algorithm._const_tab_id = 'id'
    _MaskGenAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['Params']), opt=True)
    _MaskGenAlgorithm_parameters._const_tab = __MaskGenAlgorithm_algorithm_tab
    _MaskGenAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    _MaskGenAlgorithm_parameters._const_tab_id = 'Params'
    MaskGenAlgorithm._cont = ASN1Dict([
        ('algorithm', _MaskGenAlgorithm_algorithm),
        ('parameters', _MaskGenAlgorithm_parameters),
        ])
    MaskGenAlgorithm._ext = None
    
    #-----< mgf1SHA1 >-----#
    mgf1SHA1 = SEQ(name='mgf1SHA1', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'MaskGenAlgorithm')))
    _parameters_val_0 = SEQ(name='parameters', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'HashAlgorithm')))
    mgf1SHA1._val = dict([('algorithm', (1, 2, 840, 113549, 1, 1, 8)), ('parameters', (_parameters_val_0, dict([('algorithm', (1, 3, 14, 3, 2, 26)), ('parameters', (_parameters_val, 0))])))])
    
    #-----< PKCS1MGFAlgorithms >-----#
    PKCS1MGFAlgorithms = CLASS(name='PKCS1MGFAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    _PKCS1MGFAlgorithms_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'HashAlgorithm')))
    PKCS1MGFAlgorithms._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 8)), ('Params', _PKCS1MGFAlgorithms_val_Params_0), ('paramPresence', 'required')])], rr=[], ev=[], er=[])
    
    #-----< PSourceAlgorithm >-----#
    PSourceAlgorithm = SEQ(name='PSourceAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _PSourceAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['id']))
    __PSourceAlgorithm_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___PSourceAlgorithm_algorithm_tab_val_Params_0 = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'EncodingParameters')))
    __PSourceAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 9)), ('Params', ___PSourceAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'required')])], rr=[], ev=None, er=[])
    _PSourceAlgorithm_algorithm._const_tab = __PSourceAlgorithm_algorithm_tab
    _PSourceAlgorithm_algorithm._const_tab_at = None
    _PSourceAlgorithm_algorithm._const_tab_id = 'id'
    _PSourceAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['Params']), opt=True)
    _PSourceAlgorithm_parameters._const_tab = __PSourceAlgorithm_algorithm_tab
    _PSourceAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    _PSourceAlgorithm_parameters._const_tab_id = 'Params'
    PSourceAlgorithm._cont = ASN1Dict([
        ('algorithm', _PSourceAlgorithm_algorithm),
        ('parameters', _PSourceAlgorithm_parameters),
        ])
    PSourceAlgorithm._ext = None
    
    #-----< PSS-SourceAlgorithms >-----#
    PSS_SourceAlgorithms = CLASS(name='PSS-SourceAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    _PSS_SourceAlgorithms_val_Params_0 = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'EncodingParameters')))
    PSS_SourceAlgorithms._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 9)), ('Params', _PSS_SourceAlgorithms_val_Params_0), ('paramPresence', 'required')])], rr=[], ev=[], er=[])
    
    #-----< pSpecifiedEmpty >-----#
    pSpecifiedEmpty = SEQ(name='pSpecifiedEmpty', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'PSourceAlgorithm')))
    _parameters_val_1 = OCT_STR(name='parameters', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'EncodingParameters')))
    pSpecifiedEmpty._val = dict([('algorithm', (1, 2, 840, 113549, 1, 1, 9)), ('parameters', (_parameters_val_1, b''))])
    
    #-----< RSASSA-PSS-params >-----#
    RSASSA_PSS_params = SEQ(name='RSASSA-PSS-params', mode=MODE_TYPE)
    _RSASSA_PSS_params_hashAlgorithm = SEQ(name='hashAlgorithm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'HashAlgorithm')), default=dict([('algorithm', (1, 3, 14, 3, 2, 26)), ('parameters', (_parameters_val, 0))]))
    _RSASSA_PSS_params_maskGenAlgorithm = SEQ(name='maskGenAlgorithm', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'MaskGenAlgorithm')), default=dict([('algorithm', (1, 2, 840, 113549, 1, 1, 8)), ('parameters', (_parameters_val_0, dict([('algorithm', (1, 3, 14, 3, 2, 26)), ('parameters', (_parameters_val, 0))])))]))
    _RSASSA_PSS_params_saltLength = INT(name='saltLength', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=20)
    _RSASSA_PSS_params_trailerField = INT(name='trailerField', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), default=1)
    RSASSA_PSS_params._cont = ASN1Dict([
        ('hashAlgorithm', _RSASSA_PSS_params_hashAlgorithm),
        ('maskGenAlgorithm', _RSASSA_PSS_params_maskGenAlgorithm),
        ('saltLength', _RSASSA_PSS_params_saltLength),
        ('trailerField', _RSASSA_PSS_params_trailerField),
        ])
    RSASSA_PSS_params._ext = None
    
    #-----< RSAES-OAEP-params >-----#
    RSAES_OAEP_params = SEQ(name='RSAES-OAEP-params', mode=MODE_TYPE)
    _RSAES_OAEP_params_hashFunc = SEQ(name='hashFunc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'HashAlgorithm')), default=dict([('algorithm', (1, 3, 14, 3, 2, 26)), ('parameters', (_parameters_val, 0))]))
    _RSAES_OAEP_params_maskGenFunc = SEQ(name='maskGenFunc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'MaskGenAlgorithm')), default=dict([('algorithm', (1, 2, 840, 113549, 1, 1, 8)), ('parameters', (_parameters_val_0, dict([('algorithm', (1, 3, 14, 3, 2, 26)), ('parameters', (_parameters_val, 0))])))]))
    _RSAES_OAEP_params_pSourceFunc = SEQ(name='pSourceFunc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'PSourceAlgorithm')), default=dict([('algorithm', (1, 2, 840, 113549, 1, 1, 9)), ('parameters', (_parameters_val_1, b''))]))
    RSAES_OAEP_params._cont = ASN1Dict([
        ('hashFunc', _RSAES_OAEP_params_hashFunc),
        ('maskGenFunc', _RSAES_OAEP_params_maskGenFunc),
        ('pSourceFunc', _RSAES_OAEP_params_pSourceFunc),
        ])
    RSAES_OAEP_params._ext = None
    
    _all_ = [
        PublicKeys,
        _PublicKeys_val_KeyValue_0,
        _PublicKeys_val_Params_0,
        _PublicKeys_val_KeyValue_1,
        _PublicKeys_val_Params_1,
        SignatureAlgs,
        _SignatureAlgs_val_Params_0,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_0,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_1,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_2,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_3,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1,
        KeyTransportAlgs,
        _KeyTransportAlgs_val_Params_0,
        __KEY_TRANSPORT_PublicKeySet_val_KeyValue_0,
        __KEY_TRANSPORT_PublicKeySet_val_Params_0,
        __KEY_TRANSPORT_PublicKeySet_val_KeyValue_1,
        __KEY_TRANSPORT_PublicKeySet_val_Params_1,
        __KEY_TRANSPORT_smimeCaps_val_Type,
        HashAlgs,
        _HashAlgs_val_Params_0,
        _HashAlgs_val_Params_1,
        _HashAlgs_val_Params_2,
        _HashAlgs_val_Params_3,
        SMimeCaps,
        _SMimeCaps_val_Type_1,
        pk_rsaSSA_PSS,
        _pk_rsaSSA_PSS_val_KeyValue,
        _pk_rsaSSA_PSS_val_Params,
        sa_rsaSSA_PSS,
        _sa_rsaSSA_PSS_val_Params,
        sa_sha224WithRSAEncryption,
        _sa_sha224WithRSAEncryption_val_Params,
        sha224WithRSAEncryption,
        sa_sha256WithRSAEncryption,
        _sa_sha256WithRSAEncryption_val_Params,
        sha256WithRSAEncryption,
        sa_sha384WithRSAEncryption,
        _sa_sha384WithRSAEncryption_val_Params,
        sha384WithRSAEncryption,
        sa_sha512WithRSAEncryption,
        _sa_sha512WithRSAEncryption_val_Params,
        sha512WithRSAEncryption,
        pk_rsaES_OAEP,
        _pk_rsaES_OAEP_val_KeyValue,
        _pk_rsaES_OAEP_val_Params,
        kta_rsaES_OAEP,
        _kta_rsaES_OAEP_val_Params,
        pkcs_1,
        id_RSAES_OAEP,
        id_mgf1,
        id_pSpecified,
        id_RSASSA_PSS,
        id_sha224,
        mda_sha224,
        _mda_sha224_val_Params,
        id_sha256,
        mda_sha256,
        _mda_sha256_val_Params,
        id_sha384,
        mda_sha384,
        _mda_sha384_val_Params,
        id_sha512,
        mda_sha512,
        _mda_sha512_val_Params,
        EncodingParameters,
        nullOctetString,
        nullParameters,
        __HashAlgorithm_algorithm_tab,
        ___HashAlgorithm_algorithm_tab_val_Params_0,
        ___HashAlgorithm_algorithm_tab_val_Params_1,
        ___HashAlgorithm_algorithm_tab_val_Params_2,
        ___HashAlgorithm_algorithm_tab_val_Params_3,
        ___HashAlgorithm_algorithm_tab_val_Params_4,
        _HashAlgorithm_algorithm,
        _HashAlgorithm_parameters,
        HashAlgorithm,
        HashAlgorithms,
        _HashAlgorithms_val_Params_0,
        _HashAlgorithms_val_Params_1,
        _HashAlgorithms_val_Params_2,
        _HashAlgorithms_val_Params_3,
        _HashAlgorithms_val_Params_4,
        sha1Identifier,
        _parameters_val,
        __MaskGenAlgorithm_algorithm_tab,
        ___MaskGenAlgorithm_algorithm_tab_val_Params_0,
        _MaskGenAlgorithm_algorithm,
        _MaskGenAlgorithm_parameters,
        MaskGenAlgorithm,
        mgf1SHA1,
        _parameters_val_0,
        PKCS1MGFAlgorithms,
        _PKCS1MGFAlgorithms_val_Params_0,
        __PSourceAlgorithm_algorithm_tab,
        ___PSourceAlgorithm_algorithm_tab_val_Params_0,
        _PSourceAlgorithm_algorithm,
        _PSourceAlgorithm_parameters,
        PSourceAlgorithm,
        PSS_SourceAlgorithms,
        _PSS_SourceAlgorithms_val_Params_0,
        pSpecifiedEmpty,
        _parameters_val_1,
        _RSASSA_PSS_params_hashAlgorithm,
        _RSASSA_PSS_params_maskGenAlgorithm,
        _RSASSA_PSS_params_saltLength,
        _RSASSA_PSS_params_trailerField,
        RSASSA_PSS_params,
        _RSAES_OAEP_params_hashFunc,
        _RSAES_OAEP_params_maskGenFunc,
        _RSAES_OAEP_params_pSourceFunc,
        RSAES_OAEP_params,
    ]

class PKIXAlgs_2009:

    _name_  = 'PKIXAlgs-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 56]
    
    _obj_ = [
        'PublicKeys',
        'SignatureAlgs',
        'SMimeCaps',
        'pk-rsa',
        'rsaEncryption',
        'RSAPublicKey',
        'pk-dsa',
        'id-dsa',
        'DSA-Params',
        'DSAPublicKey',
        'pk-dh',
        'dhpublicnumber',
        'DomainParameters',
        'ValidationParams',
        'DHPublicKey',
        'pk-kea',
        'id-keyExchangeAlgorithm',
        'KEA-Params-Id',
        'pk-ec',
        'ECPoint',
        'id-ecPublicKey',
        'pk-ecDH',
        'id-ecDH',
        'pk-ecMQV',
        'id-ecMQV',
        'ECParameters',
        'CURVE',
        'NamedCurve',
        'secp192r1',
        'sect163k1',
        'sect163r2',
        'secp224r1',
        'sect233k1',
        'sect233r1',
        'secp256r1',
        'sect283k1',
        'sect283r1',
        'secp384r1',
        'sect409k1',
        'sect409r1',
        'secp521r1',
        'sect571k1',
        'sect571r1',
        'sa-rsaWithMD2',
        'md2WithRSAEncryption',
        'sa-rsaWithMD5',
        'md5WithRSAEncryption',
        'sa-rsaWithSHA1',
        'sha1WithRSAEncryption',
        'sa-dsaWithSHA1',
        'dsa-with-sha1',
        'sa-dsaWithSHA224',
        'dsa-with-sha224',
        'sa-dsaWithSHA256',
        'dsa-with-sha256',
        'sa-ecdsaWithSHA1',
        'ecdsa-with-SHA1',
        'sa-ecdsaWithSHA224',
        'ecdsa-with-SHA224',
        'sa-ecdsaWithSHA256',
        'ecdsa-with-SHA256',
        'sa-ecdsaWithSHA384',
        'ecdsa-with-SHA384',
        'sa-ecdsaWithSHA512',
        'ecdsa-with-SHA512',
        'DSA-Sig-Value',
        'ECDSA-Sig-Value',
        'HashAlgs',
        'mda-md2',
        'id-md2',
        'mda-md5',
        'id-md5',
        'mda-sha1',
        'id-sha1',
        ]
    _type_ = [
        'RSAPublicKey',
        'DSA-Params',
        'DSAPublicKey',
        'DomainParameters',
        'ValidationParams',
        'DHPublicKey',
        'KEA-Params-Id',
        'ECPoint',
        'ECParameters',
        'CURVE',
        'DSA-Sig-Value',
        'ECDSA-Sig-Value',
        ]
    _set_ = [
        'PublicKeys',
        'SignatureAlgs',
        'SMimeCaps',
        'NamedCurve',
        'HashAlgs',
        ]
    _val_ = [
        'pk-rsa',
        'rsaEncryption',
        'pk-dsa',
        'id-dsa',
        'pk-dh',
        'dhpublicnumber',
        'pk-kea',
        'id-keyExchangeAlgorithm',
        'pk-ec',
        'id-ecPublicKey',
        'pk-ecDH',
        'id-ecDH',
        'pk-ecMQV',
        'id-ecMQV',
        'secp192r1',
        'sect163k1',
        'sect163r2',
        'secp224r1',
        'sect233k1',
        'sect233r1',
        'secp256r1',
        'sect283k1',
        'sect283r1',
        'secp384r1',
        'sect409k1',
        'sect409r1',
        'secp521r1',
        'sect571k1',
        'sect571r1',
        'sa-rsaWithMD2',
        'md2WithRSAEncryption',
        'sa-rsaWithMD5',
        'md5WithRSAEncryption',
        'sa-rsaWithSHA1',
        'sha1WithRSAEncryption',
        'sa-dsaWithSHA1',
        'dsa-with-sha1',
        'sa-dsaWithSHA224',
        'dsa-with-sha224',
        'sa-dsaWithSHA256',
        'dsa-with-sha256',
        'sa-ecdsaWithSHA1',
        'ecdsa-with-SHA1',
        'sa-ecdsaWithSHA224',
        'ecdsa-with-SHA224',
        'sa-ecdsaWithSHA256',
        'ecdsa-with-SHA256',
        'sa-ecdsaWithSHA384',
        'ecdsa-with-SHA384',
        'sa-ecdsaWithSHA512',
        'ecdsa-with-SHA512',
        'mda-md2',
        'id-md2',
        'mda-md5',
        'id-md5',
        'mda-sha1',
        'id-sha1',
        ]
    _class_ = [
        'PublicKeys',
        'SignatureAlgs',
        'SMimeCaps',
        'pk-rsa',
        'pk-dsa',
        'pk-dh',
        'pk-kea',
        'pk-ec',
        'pk-ecDH',
        'pk-ecMQV',
        'CURVE',
        'NamedCurve',
        'sa-rsaWithMD2',
        'sa-rsaWithMD5',
        'sa-rsaWithSHA1',
        'sa-dsaWithSHA1',
        'sa-dsaWithSHA224',
        'sa-dsaWithSHA256',
        'sa-ecdsaWithSHA1',
        'sa-ecdsaWithSHA224',
        'sa-ecdsaWithSHA256',
        'sa-ecdsaWithSHA384',
        'sa-ecdsaWithSHA512',
        'HashAlgs',
        'mda-md2',
        'mda-md5',
        'mda-sha1',
        ]
    _param_ = [
        ]
    
    #-----< PublicKeys >-----#
    PublicKeys = CLASS(name='PublicKeys', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _PublicKeys_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _PublicKeys_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _PublicKeys_val_KeyValue_1 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    _PublicKeys_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    _PublicKeys_val_KeyValue_2 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    _PublicKeys_val_Params_2 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DomainParameters')))
    _PublicKeys_val_Params_3 = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'KEA-Params-Id')))
    _PublicKeys_val_KeyValue_4 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    _PublicKeys_val_Params_4 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    _PublicKeys_val_KeyValue_5 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    _PublicKeys_val_Params_5 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    _PublicKeys_val_KeyValue_6 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    _PublicKeys_val_Params_6 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    PublicKeys._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', _PublicKeys_val_KeyValue_0), ('Params', _PublicKeys_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', _PublicKeys_val_KeyValue_1), ('Params', _PublicKeys_val_Params_1), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))]), dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _PublicKeys_val_KeyValue_2), ('Params', _PublicKeys_val_Params_2), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))]), dict([('id', (2, 16, 840, 1, 101, 2, 1, 1, 22)), ('Params', _PublicKeys_val_Params_3), ('paramPresence', 'required'), ('keyUsage', (19, 9))])], rr=[], ev=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', _PublicKeys_val_KeyValue_4), ('Params', _PublicKeys_val_Params_4), ('paramPresence', 'required'), ('keyUsage', (103, 7))]), dict([('id', (1, 3, 132, 1, 12)), ('KeyValue', _PublicKeys_val_KeyValue_5), ('Params', _PublicKeys_val_Params_5), ('paramPresence', 'required'), ('keyUsage', (19, 9))]), dict([('id', (1, 3, 132, 1, 13)), ('KeyValue', _PublicKeys_val_KeyValue_6), ('Params', _PublicKeys_val_Params_6), ('paramPresence', 'required'), ('keyUsage', (19, 9))])], er=[])
    
    #-----< SignatureAlgs >-----#
    SignatureAlgs = CLASS(name='SignatureAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _SignatureAlgs_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgs_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgs_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgs_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _SignatureAlgs_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    _SignatureAlgs_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _SignatureAlgs_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    _SignatureAlgs_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _SignatureAlgs_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgs_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _SignatureAlgs_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgs_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _SignatureAlgs_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgs_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _SignatureAlgs_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgs_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _SignatureAlgs_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    _SignatureAlgs_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _SignatureAlgs_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    SignatureAlgs._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', _SignatureAlgs_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', _SignatureAlgs_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', _SignatureAlgs_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', _SignatureAlgs_val_Value_3), ('Params', _SignatureAlgs_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', _SignatureAlgs_val_Value_4), ('Params', _SignatureAlgs_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', _SignatureAlgs_val_Value_5), ('Params', _SignatureAlgs_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', _SignatureAlgs_val_Value_6), ('Params', _SignatureAlgs_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', _SignatureAlgs_val_Value_7), ('Params', _SignatureAlgs_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', _SignatureAlgs_val_Value_8), ('Params', _SignatureAlgs_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', _SignatureAlgs_val_Value_9), ('Params', _SignatureAlgs_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', _SignatureAlgs_val_Value_10), ('Params', _SignatureAlgs_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))])], er=[])
    
    #-----< SMimeCaps >-----#
    SMimeCaps = CLASS(name='SMimeCaps', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SMIME-CAPS')))
    SMimeCaps._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5))]), dict([('id', (1, 2, 840, 10040, 4, 3))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]), dict([('id', (1, 2, 840, 10045, 4, 1))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4))])], rr=[], ev=[], er=[])
    
    #-----< pk-rsa >-----#
    pk_rsa = CLASS(name='pk-rsa', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _pk_rsa_val_KeyValue = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    _pk_rsa_val_Params = NULL(name='Params', mode=MODE_TYPE)
    pk_rsa._val = dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', _pk_rsa_val_KeyValue), ('Params', _pk_rsa_val_Params), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])
    
    #-----< rsaEncryption >-----#
    rsaEncryption = OID(name='rsaEncryption', mode=MODE_VALUE)
    rsaEncryption._val = (1, 2, 840, 113549, 1, 1, 1)
    
    #-----< RSAPublicKey >-----#
    RSAPublicKey = SEQ(name='RSAPublicKey', mode=MODE_TYPE)
    _RSAPublicKey_modulus = INT(name='modulus', mode=MODE_TYPE)
    _RSAPublicKey_publicExponent = INT(name='publicExponent', mode=MODE_TYPE)
    RSAPublicKey._cont = ASN1Dict([
        ('modulus', _RSAPublicKey_modulus),
        ('publicExponent', _RSAPublicKey_publicExponent),
        ])
    RSAPublicKey._ext = None
    
    #-----< pk-dsa >-----#
    pk_dsa = CLASS(name='pk-dsa', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _pk_dsa_val_KeyValue = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    _pk_dsa_val_Params = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    pk_dsa._val = dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', _pk_dsa_val_KeyValue), ('Params', _pk_dsa_val_Params), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])
    
    #-----< id-dsa >-----#
    id_dsa = OID(name='id-dsa', mode=MODE_VALUE)
    id_dsa._val = (1, 2, 840, 10040, 4, 1)
    
    #-----< DSA-Params >-----#
    DSA_Params = SEQ(name='DSA-Params', mode=MODE_TYPE)
    _DSA_Params_p = INT(name='p', mode=MODE_TYPE)
    _DSA_Params_q = INT(name='q', mode=MODE_TYPE)
    _DSA_Params_g = INT(name='g', mode=MODE_TYPE)
    DSA_Params._cont = ASN1Dict([
        ('p', _DSA_Params_p),
        ('q', _DSA_Params_q),
        ('g', _DSA_Params_g),
        ])
    DSA_Params._ext = None
    
    #-----< DSAPublicKey >-----#
    DSAPublicKey = INT(name='DSAPublicKey', mode=MODE_TYPE)
    
    #-----< pk-dh >-----#
    pk_dh = CLASS(name='pk-dh', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _pk_dh_val_KeyValue = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DHPublicKey')))
    _pk_dh_val_Params = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DomainParameters')))
    pk_dh._val = dict([('id', (1, 2, 840, 10046, 2, 1)), ('KeyValue', _pk_dh_val_KeyValue), ('Params', _pk_dh_val_Params), ('paramPresence', 'inheritable'), ('keyUsage', (19, 9))])
    
    #-----< dhpublicnumber >-----#
    dhpublicnumber = OID(name='dhpublicnumber', mode=MODE_VALUE)
    dhpublicnumber._val = (1, 2, 840, 10046, 2, 1)
    
    #-----< DomainParameters >-----#
    DomainParameters = SEQ(name='DomainParameters', mode=MODE_TYPE)
    _DomainParameters_p = INT(name='p', mode=MODE_TYPE)
    _DomainParameters_g = INT(name='g', mode=MODE_TYPE)
    _DomainParameters_q = INT(name='q', mode=MODE_TYPE)
    _DomainParameters_j = INT(name='j', mode=MODE_TYPE, opt=True)
    _DomainParameters_validationParams = SEQ(name='validationParams', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ValidationParams')), opt=True)
    DomainParameters._cont = ASN1Dict([
        ('p', _DomainParameters_p),
        ('g', _DomainParameters_g),
        ('q', _DomainParameters_q),
        ('j', _DomainParameters_j),
        ('validationParams', _DomainParameters_validationParams),
        ])
    DomainParameters._ext = None
    
    #-----< ValidationParams >-----#
    ValidationParams = SEQ(name='ValidationParams', mode=MODE_TYPE)
    _ValidationParams_seed = BIT_STR(name='seed', mode=MODE_TYPE)
    _ValidationParams_pgenCounter = INT(name='pgenCounter', mode=MODE_TYPE)
    ValidationParams._cont = ASN1Dict([
        ('seed', _ValidationParams_seed),
        ('pgenCounter', _ValidationParams_pgenCounter),
        ])
    ValidationParams._ext = None
    
    #-----< DHPublicKey >-----#
    DHPublicKey = INT(name='DHPublicKey', mode=MODE_TYPE)
    
    #-----< pk-kea >-----#
    pk_kea = CLASS(name='pk-kea', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _pk_kea_val_Params = OCT_STR(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'KEA-Params-Id')))
    pk_kea._val = dict([('id', (2, 16, 840, 1, 101, 2, 1, 1, 22)), ('Params', _pk_kea_val_Params), ('paramPresence', 'required'), ('keyUsage', (19, 9))])
    
    #-----< id-keyExchangeAlgorithm >-----#
    id_keyExchangeAlgorithm = OID(name='id-keyExchangeAlgorithm', mode=MODE_VALUE)
    id_keyExchangeAlgorithm._val = (2, 16, 840, 1, 101, 2, 1, 1, 22)
    
    #-----< KEA-Params-Id >-----#
    KEA_Params_Id = OCT_STR(name='KEA-Params-Id', mode=MODE_TYPE)
    
    #-----< pk-ec >-----#
    pk_ec = CLASS(name='pk-ec', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _pk_ec_val_KeyValue = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    _pk_ec_val_Params = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    pk_ec._val = dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', _pk_ec_val_KeyValue), ('Params', _pk_ec_val_Params), ('paramPresence', 'required'), ('keyUsage', (103, 7))])
    
    #-----< ECPoint >-----#
    ECPoint = OCT_STR(name='ECPoint', mode=MODE_TYPE)
    
    #-----< id-ecPublicKey >-----#
    id_ecPublicKey = OID(name='id-ecPublicKey', mode=MODE_VALUE)
    id_ecPublicKey._val = (1, 2, 840, 10045, 2, 1)
    
    #-----< pk-ecDH >-----#
    pk_ecDH = CLASS(name='pk-ecDH', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _pk_ecDH_val_KeyValue = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    _pk_ecDH_val_Params = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    pk_ecDH._val = dict([('id', (1, 3, 132, 1, 12)), ('KeyValue', _pk_ecDH_val_KeyValue), ('Params', _pk_ecDH_val_Params), ('paramPresence', 'required'), ('keyUsage', (19, 9))])
    
    #-----< id-ecDH >-----#
    id_ecDH = OID(name='id-ecDH', mode=MODE_VALUE)
    id_ecDH._val = (1, 3, 132, 1, 12)
    
    #-----< pk-ecMQV >-----#
    pk_ecMQV = CLASS(name='pk-ecMQV', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    _pk_ecMQV_val_KeyValue = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    _pk_ecMQV_val_Params = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    pk_ecMQV._val = dict([('id', (1, 3, 132, 1, 13)), ('KeyValue', _pk_ecMQV_val_KeyValue), ('Params', _pk_ecMQV_val_Params), ('paramPresence', 'required'), ('keyUsage', (19, 9))])
    
    #-----< id-ecMQV >-----#
    id_ecMQV = OID(name='id-ecMQV', mode=MODE_VALUE)
    id_ecMQV._val = (1, 3, 132, 1, 13)
    
    #-----< ECParameters >-----#
    ECParameters = CHOICE(name='ECParameters', mode=MODE_TYPE)
    _ECParameters_namedCurve = OID(name='namedCurve', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIXAlgs-2009', 'CURVE'), ['id']))
    __ECParameters_namedCurve_tab = CLASS(name='_tab_CURVE', mode=MODE_SET, typeref=ASN1RefType(('PKIXAlgs-2009', 'CURVE')))
    __ECParameters_namedCurve_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 3, 1, 1))]), dict([('id', (1, 3, 132, 0, 1))]), dict([('id', (1, 3, 132, 0, 15))]), dict([('id', (1, 3, 132, 0, 33))]), dict([('id', (1, 3, 132, 0, 26))]), dict([('id', (1, 3, 132, 0, 27))]), dict([('id', (1, 2, 840, 10045, 3, 1, 7))]), dict([('id', (1, 3, 132, 0, 16))]), dict([('id', (1, 3, 132, 0, 17))]), dict([('id', (1, 3, 132, 0, 34))]), dict([('id', (1, 3, 132, 0, 36))]), dict([('id', (1, 3, 132, 0, 37))]), dict([('id', (1, 3, 132, 0, 35))]), dict([('id', (1, 3, 132, 0, 38))]), dict([('id', (1, 3, 132, 0, 39))])], rr=[], ev=None, er=[])
    _ECParameters_namedCurve._const_tab = __ECParameters_namedCurve_tab
    _ECParameters_namedCurve._const_tab_at = None
    _ECParameters_namedCurve._const_tab_id = 'id'
    ECParameters._cont = ASN1Dict([
        ('namedCurve', _ECParameters_namedCurve),
        ])
    ECParameters._ext = None
    
    #-----< CURVE >-----#
    CURVE = CLASS(name='CURVE', mode=MODE_TYPE)
    _CURVE_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    CURVE._cont = ASN1Dict([
        ('id', _CURVE_id),
        ])
    
    #-----< NamedCurve >-----#
    NamedCurve = CLASS(name='NamedCurve', mode=MODE_SET, typeref=ASN1RefType(('PKIXAlgs-2009', 'CURVE')))
    NamedCurve._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 3, 1, 1))]), dict([('id', (1, 3, 132, 0, 1))]), dict([('id', (1, 3, 132, 0, 15))]), dict([('id', (1, 3, 132, 0, 33))]), dict([('id', (1, 3, 132, 0, 26))]), dict([('id', (1, 3, 132, 0, 27))]), dict([('id', (1, 2, 840, 10045, 3, 1, 7))]), dict([('id', (1, 3, 132, 0, 16))]), dict([('id', (1, 3, 132, 0, 17))]), dict([('id', (1, 3, 132, 0, 34))]), dict([('id', (1, 3, 132, 0, 36))]), dict([('id', (1, 3, 132, 0, 37))]), dict([('id', (1, 3, 132, 0, 35))]), dict([('id', (1, 3, 132, 0, 38))]), dict([('id', (1, 3, 132, 0, 39))])], rr=[], ev=[], er=[])
    
    #-----< secp192r1 >-----#
    secp192r1 = OID(name='secp192r1', mode=MODE_VALUE)
    secp192r1._val = (1, 2, 840, 10045, 3, 1, 1)
    
    #-----< sect163k1 >-----#
    sect163k1 = OID(name='sect163k1', mode=MODE_VALUE)
    sect163k1._val = (1, 3, 132, 0, 1)
    
    #-----< sect163r2 >-----#
    sect163r2 = OID(name='sect163r2', mode=MODE_VALUE)
    sect163r2._val = (1, 3, 132, 0, 15)
    
    #-----< secp224r1 >-----#
    secp224r1 = OID(name='secp224r1', mode=MODE_VALUE)
    secp224r1._val = (1, 3, 132, 0, 33)
    
    #-----< sect233k1 >-----#
    sect233k1 = OID(name='sect233k1', mode=MODE_VALUE)
    sect233k1._val = (1, 3, 132, 0, 26)
    
    #-----< sect233r1 >-----#
    sect233r1 = OID(name='sect233r1', mode=MODE_VALUE)
    sect233r1._val = (1, 3, 132, 0, 27)
    
    #-----< secp256r1 >-----#
    secp256r1 = OID(name='secp256r1', mode=MODE_VALUE)
    secp256r1._val = (1, 2, 840, 10045, 3, 1, 7)
    
    #-----< sect283k1 >-----#
    sect283k1 = OID(name='sect283k1', mode=MODE_VALUE)
    sect283k1._val = (1, 3, 132, 0, 16)
    
    #-----< sect283r1 >-----#
    sect283r1 = OID(name='sect283r1', mode=MODE_VALUE)
    sect283r1._val = (1, 3, 132, 0, 17)
    
    #-----< secp384r1 >-----#
    secp384r1 = OID(name='secp384r1', mode=MODE_VALUE)
    secp384r1._val = (1, 3, 132, 0, 34)
    
    #-----< sect409k1 >-----#
    sect409k1 = OID(name='sect409k1', mode=MODE_VALUE)
    sect409k1._val = (1, 3, 132, 0, 36)
    
    #-----< sect409r1 >-----#
    sect409r1 = OID(name='sect409r1', mode=MODE_VALUE)
    sect409r1._val = (1, 3, 132, 0, 37)
    
    #-----< secp521r1 >-----#
    secp521r1 = OID(name='secp521r1', mode=MODE_VALUE)
    secp521r1._val = (1, 3, 132, 0, 35)
    
    #-----< sect571k1 >-----#
    sect571k1 = OID(name='sect571k1', mode=MODE_VALUE)
    sect571k1._val = (1, 3, 132, 0, 38)
    
    #-----< sect571r1 >-----#
    sect571r1 = OID(name='sect571r1', mode=MODE_VALUE)
    sect571r1._val = (1, 3, 132, 0, 39)
    
    #-----< sa-rsaWithMD2 >-----#
    sa_rsaWithMD2 = CLASS(name='sa-rsaWithMD2', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_rsaWithMD2_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_rsaWithMD2._val = dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', _sa_rsaWithMD2_val_Params), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))])
    
    #-----< md2WithRSAEncryption >-----#
    md2WithRSAEncryption = OID(name='md2WithRSAEncryption', mode=MODE_VALUE)
    md2WithRSAEncryption._val = (1, 2, 840, 113549, 1, 1, 2)
    
    #-----< sa-rsaWithMD5 >-----#
    sa_rsaWithMD5 = CLASS(name='sa-rsaWithMD5', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_rsaWithMD5_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_rsaWithMD5._val = dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', _sa_rsaWithMD5_val_Params), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))])
    
    #-----< md5WithRSAEncryption >-----#
    md5WithRSAEncryption = OID(name='md5WithRSAEncryption', mode=MODE_VALUE)
    md5WithRSAEncryption._val = (1, 2, 840, 113549, 1, 1, 4)
    
    #-----< sa-rsaWithSHA1 >-----#
    sa_rsaWithSHA1 = CLASS(name='sa-rsaWithSHA1', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_rsaWithSHA1_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_rsaWithSHA1._val = dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', _sa_rsaWithSHA1_val_Params), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))])
    
    #-----< sha1WithRSAEncryption >-----#
    sha1WithRSAEncryption = OID(name='sha1WithRSAEncryption', mode=MODE_VALUE)
    sha1WithRSAEncryption._val = (1, 2, 840, 113549, 1, 1, 5)
    
    #-----< sa-dsaWithSHA1 >-----#
    sa_dsaWithSHA1 = CLASS(name='sa-dsaWithSHA1', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_dsaWithSHA1_val_Value = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _sa_dsaWithSHA1_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_dsaWithSHA1._val = dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', _sa_dsaWithSHA1_val_Value), ('Params', _sa_dsaWithSHA1_val_Params), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))])
    
    #-----< dsa-with-sha1 >-----#
    dsa_with_sha1 = OID(name='dsa-with-sha1', mode=MODE_VALUE)
    dsa_with_sha1._val = (1, 2, 840, 10040, 4, 3)
    
    #-----< sa-dsaWithSHA224 >-----#
    sa_dsaWithSHA224 = CLASS(name='sa-dsaWithSHA224', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_dsaWithSHA224_val_Value = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _sa_dsaWithSHA224_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_dsaWithSHA224._val = dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', _sa_dsaWithSHA224_val_Value), ('Params', _sa_dsaWithSHA224_val_Params), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))])
    
    #-----< dsa-with-sha224 >-----#
    dsa_with_sha224 = OID(name='dsa-with-sha224', mode=MODE_VALUE)
    dsa_with_sha224._val = (2, 16, 840, 1, 101, 3, 4, 3, 1)
    
    #-----< sa-dsaWithSHA256 >-----#
    sa_dsaWithSHA256 = CLASS(name='sa-dsaWithSHA256', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_dsaWithSHA256_val_Value = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _sa_dsaWithSHA256_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_dsaWithSHA256._val = dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', _sa_dsaWithSHA256_val_Value), ('Params', _sa_dsaWithSHA256_val_Params), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))])
    
    #-----< dsa-with-sha256 >-----#
    dsa_with_sha256 = OID(name='dsa-with-sha256', mode=MODE_VALUE)
    dsa_with_sha256._val = (2, 16, 840, 1, 101, 3, 4, 3, 2)
    
    #-----< sa-ecdsaWithSHA1 >-----#
    sa_ecdsaWithSHA1 = CLASS(name='sa-ecdsaWithSHA1', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_ecdsaWithSHA1_val_Value = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _sa_ecdsaWithSHA1_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_ecdsaWithSHA1._val = dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', _sa_ecdsaWithSHA1_val_Value), ('Params', _sa_ecdsaWithSHA1_val_Params), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])
    
    #-----< ecdsa-with-SHA1 >-----#
    ecdsa_with_SHA1 = OID(name='ecdsa-with-SHA1', mode=MODE_VALUE)
    ecdsa_with_SHA1._val = (1, 2, 840, 10045, 4, 1)
    
    #-----< sa-ecdsaWithSHA224 >-----#
    sa_ecdsaWithSHA224 = CLASS(name='sa-ecdsaWithSHA224', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_ecdsaWithSHA224_val_Value = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _sa_ecdsaWithSHA224_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_ecdsaWithSHA224._val = dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', _sa_ecdsaWithSHA224_val_Value), ('Params', _sa_ecdsaWithSHA224_val_Params), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))])
    
    #-----< ecdsa-with-SHA224 >-----#
    ecdsa_with_SHA224 = OID(name='ecdsa-with-SHA224', mode=MODE_VALUE)
    ecdsa_with_SHA224._val = (1, 2, 840, 10045, 4, 3, 1)
    
    #-----< sa-ecdsaWithSHA256 >-----#
    sa_ecdsaWithSHA256 = CLASS(name='sa-ecdsaWithSHA256', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_ecdsaWithSHA256_val_Value = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _sa_ecdsaWithSHA256_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_ecdsaWithSHA256._val = dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', _sa_ecdsaWithSHA256_val_Value), ('Params', _sa_ecdsaWithSHA256_val_Params), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))])
    
    #-----< ecdsa-with-SHA256 >-----#
    ecdsa_with_SHA256 = OID(name='ecdsa-with-SHA256', mode=MODE_VALUE)
    ecdsa_with_SHA256._val = (1, 2, 840, 10045, 4, 3, 2)
    
    #-----< sa-ecdsaWithSHA384 >-----#
    sa_ecdsaWithSHA384 = CLASS(name='sa-ecdsaWithSHA384', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_ecdsaWithSHA384_val_Value = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _sa_ecdsaWithSHA384_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_ecdsaWithSHA384._val = dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', _sa_ecdsaWithSHA384_val_Value), ('Params', _sa_ecdsaWithSHA384_val_Params), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))])
    
    #-----< ecdsa-with-SHA384 >-----#
    ecdsa_with_SHA384 = OID(name='ecdsa-with-SHA384', mode=MODE_VALUE)
    ecdsa_with_SHA384._val = (1, 2, 840, 10045, 4, 3, 3)
    
    #-----< sa-ecdsaWithSHA512 >-----#
    sa_ecdsaWithSHA512 = CLASS(name='sa-ecdsaWithSHA512', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _sa_ecdsaWithSHA512_val_Value = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _sa_ecdsaWithSHA512_val_Params = NULL(name='Params', mode=MODE_TYPE)
    sa_ecdsaWithSHA512._val = dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', _sa_ecdsaWithSHA512_val_Value), ('Params', _sa_ecdsaWithSHA512_val_Params), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))])
    
    #-----< ecdsa-with-SHA512 >-----#
    ecdsa_with_SHA512 = OID(name='ecdsa-with-SHA512', mode=MODE_VALUE)
    ecdsa_with_SHA512._val = (1, 2, 840, 10045, 4, 3, 4)
    
    #-----< DSA-Sig-Value >-----#
    DSA_Sig_Value = SEQ(name='DSA-Sig-Value', mode=MODE_TYPE)
    _DSA_Sig_Value_r = INT(name='r', mode=MODE_TYPE)
    _DSA_Sig_Value_s = INT(name='s', mode=MODE_TYPE)
    DSA_Sig_Value._cont = ASN1Dict([
        ('r', _DSA_Sig_Value_r),
        ('s', _DSA_Sig_Value_s),
        ])
    DSA_Sig_Value._ext = None
    
    #-----< ECDSA-Sig-Value >-----#
    ECDSA_Sig_Value = SEQ(name='ECDSA-Sig-Value', mode=MODE_TYPE)
    _ECDSA_Sig_Value_r = INT(name='r', mode=MODE_TYPE)
    _ECDSA_Sig_Value_s = INT(name='s', mode=MODE_TYPE)
    ECDSA_Sig_Value._cont = ASN1Dict([
        ('r', _ECDSA_Sig_Value_r),
        ('s', _ECDSA_Sig_Value_s),
        ])
    ECDSA_Sig_Value._ext = None
    
    #-----< HashAlgs >-----#
    HashAlgs = CLASS(name='HashAlgs', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _HashAlgs_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _HashAlgs_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    _HashAlgs_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    HashAlgs._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', _HashAlgs_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', _HashAlgs_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', _HashAlgs_val_Params_2), ('paramPresence', 'preferredAbsent')])], rr=[], ev=[], er=[])
    
    #-----< mda-md2 >-----#
    mda_md2 = CLASS(name='mda-md2', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _mda_md2_val_Params = NULL(name='Params', mode=MODE_TYPE)
    mda_md2._val = dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', _mda_md2_val_Params), ('paramPresence', 'preferredAbsent')])
    
    #-----< id-md2 >-----#
    id_md2 = OID(name='id-md2', mode=MODE_VALUE)
    id_md2._val = (1, 2, 840, 113549, 2, 2)
    
    #-----< mda-md5 >-----#
    mda_md5 = CLASS(name='mda-md5', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _mda_md5_val_Params = NULL(name='Params', mode=MODE_TYPE)
    mda_md5._val = dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', _mda_md5_val_Params), ('paramPresence', 'preferredAbsent')])
    
    #-----< id-md5 >-----#
    id_md5 = OID(name='id-md5', mode=MODE_VALUE)
    id_md5._val = (1, 2, 840, 113549, 2, 5)
    
    #-----< mda-sha1 >-----#
    mda_sha1 = CLASS(name='mda-sha1', mode=MODE_VALUE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _mda_sha1_val_Params = NULL(name='Params', mode=MODE_TYPE)
    mda_sha1._val = dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', _mda_sha1_val_Params), ('paramPresence', 'preferredAbsent')])
    
    #-----< id-sha1 >-----#
    id_sha1 = OID(name='id-sha1', mode=MODE_VALUE)
    id_sha1._val = (1, 3, 14, 3, 2, 26)
    
    _all_ = [
        PublicKeys,
        _PublicKeys_val_KeyValue_0,
        _PublicKeys_val_Params_0,
        _PublicKeys_val_KeyValue_1,
        _PublicKeys_val_Params_1,
        _PublicKeys_val_KeyValue_2,
        _PublicKeys_val_Params_2,
        _PublicKeys_val_Params_3,
        _PublicKeys_val_KeyValue_4,
        _PublicKeys_val_Params_4,
        _PublicKeys_val_KeyValue_5,
        _PublicKeys_val_Params_5,
        _PublicKeys_val_KeyValue_6,
        _PublicKeys_val_Params_6,
        SignatureAlgs,
        _SignatureAlgs_val_Params_0,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0,
        _SignatureAlgs_val_Params_1,
        _SignatureAlgs_val_Params_2,
        _SignatureAlgs_val_Value_3,
        _SignatureAlgs_val_Params_3,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0,
        _SignatureAlgs_val_Value_4,
        _SignatureAlgs_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1,
        _SignatureAlgs_val_Value_5,
        _SignatureAlgs_val_Params_5,
        _SignatureAlgs_val_Value_6,
        _SignatureAlgs_val_Params_6,
        _SignatureAlgs_val_Value_7,
        _SignatureAlgs_val_Params_7,
        _SignatureAlgs_val_Value_8,
        _SignatureAlgs_val_Params_8,
        _SignatureAlgs_val_Value_9,
        _SignatureAlgs_val_Params_9,
        _SignatureAlgs_val_Value_10,
        _SignatureAlgs_val_Params_10,
        SMimeCaps,
        pk_rsa,
        _pk_rsa_val_KeyValue,
        _pk_rsa_val_Params,
        rsaEncryption,
        _RSAPublicKey_modulus,
        _RSAPublicKey_publicExponent,
        RSAPublicKey,
        pk_dsa,
        _pk_dsa_val_KeyValue,
        _pk_dsa_val_Params,
        id_dsa,
        _DSA_Params_p,
        _DSA_Params_q,
        _DSA_Params_g,
        DSA_Params,
        DSAPublicKey,
        pk_dh,
        _pk_dh_val_KeyValue,
        _pk_dh_val_Params,
        dhpublicnumber,
        _DomainParameters_p,
        _DomainParameters_g,
        _DomainParameters_q,
        _DomainParameters_j,
        _DomainParameters_validationParams,
        DomainParameters,
        _ValidationParams_seed,
        _ValidationParams_pgenCounter,
        ValidationParams,
        DHPublicKey,
        pk_kea,
        _pk_kea_val_Params,
        id_keyExchangeAlgorithm,
        KEA_Params_Id,
        pk_ec,
        _pk_ec_val_KeyValue,
        _pk_ec_val_Params,
        ECPoint,
        id_ecPublicKey,
        pk_ecDH,
        _pk_ecDH_val_KeyValue,
        _pk_ecDH_val_Params,
        id_ecDH,
        pk_ecMQV,
        _pk_ecMQV_val_KeyValue,
        _pk_ecMQV_val_Params,
        id_ecMQV,
        __ECParameters_namedCurve_tab,
        _ECParameters_namedCurve,
        ECParameters,
        _CURVE_id,
        CURVE,
        NamedCurve,
        secp192r1,
        sect163k1,
        sect163r2,
        secp224r1,
        sect233k1,
        sect233r1,
        secp256r1,
        sect283k1,
        sect283r1,
        secp384r1,
        sect409k1,
        sect409r1,
        secp521r1,
        sect571k1,
        sect571r1,
        sa_rsaWithMD2,
        _sa_rsaWithMD2_val_Params,
        md2WithRSAEncryption,
        sa_rsaWithMD5,
        _sa_rsaWithMD5_val_Params,
        md5WithRSAEncryption,
        sa_rsaWithSHA1,
        _sa_rsaWithSHA1_val_Params,
        sha1WithRSAEncryption,
        sa_dsaWithSHA1,
        _sa_dsaWithSHA1_val_Value,
        _sa_dsaWithSHA1_val_Params,
        dsa_with_sha1,
        sa_dsaWithSHA224,
        _sa_dsaWithSHA224_val_Value,
        _sa_dsaWithSHA224_val_Params,
        dsa_with_sha224,
        sa_dsaWithSHA256,
        _sa_dsaWithSHA256_val_Value,
        _sa_dsaWithSHA256_val_Params,
        dsa_with_sha256,
        sa_ecdsaWithSHA1,
        _sa_ecdsaWithSHA1_val_Value,
        _sa_ecdsaWithSHA1_val_Params,
        ecdsa_with_SHA1,
        sa_ecdsaWithSHA224,
        _sa_ecdsaWithSHA224_val_Value,
        _sa_ecdsaWithSHA224_val_Params,
        ecdsa_with_SHA224,
        sa_ecdsaWithSHA256,
        _sa_ecdsaWithSHA256_val_Value,
        _sa_ecdsaWithSHA256_val_Params,
        ecdsa_with_SHA256,
        sa_ecdsaWithSHA384,
        _sa_ecdsaWithSHA384_val_Value,
        _sa_ecdsaWithSHA384_val_Params,
        ecdsa_with_SHA384,
        sa_ecdsaWithSHA512,
        _sa_ecdsaWithSHA512_val_Value,
        _sa_ecdsaWithSHA512_val_Params,
        ecdsa_with_SHA512,
        _DSA_Sig_Value_r,
        _DSA_Sig_Value_s,
        DSA_Sig_Value,
        _ECDSA_Sig_Value_r,
        _ECDSA_Sig_Value_s,
        ECDSA_Sig_Value,
        HashAlgs,
        _HashAlgs_val_Params_0,
        _HashAlgs_val_Params_1,
        _HashAlgs_val_Params_2,
        mda_md2,
        _mda_md2_val_Params,
        id_md2,
        mda_md5,
        _mda_md5_val_Params,
        id_md5,
        mda_sha1,
        _mda_sha1_val_Params,
        id_sha1,
    ]

class PKIXAttributeCertificate_2009:

    _name_  = 'PKIXAttributeCertificate-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 47]
    
    _obj_ = [
        'AttributeCertExtensions',
        'ext-auditIdentity',
        'ext-targetInformation',
        'ext-noRevAvail',
        'ext-ac-proxying',
        'ext-aaControls',
        'AttributesDefined',
        'at-authenticationInfo',
        'at-accesIdentity',
        'at-chargingIdentity',
        'at-group',
        'at-role',
        'at-clearance',
        'at-clearance-RFC3281',
        'at-encAttrs',
        'id-pe-ac-auditIdentity',
        'id-pe-aaControls',
        'id-pe-ac-proxying',
        'id-ce-targetInformation',
        'id-ce-noRevAvail',
        'id-aca',
        'id-aca-authenticationInfo',
        'id-aca-accessIdentity',
        'id-aca-chargingIdentity',
        'id-aca-group',
        'id-aca-encAttrs',
        'id-at-role',
        'id-at-clearance',
        'id-at-clearance-rfc3281',
        'AttributeCertificate',
        'AttributeCertificateInfo',
        'AttCertVersion',
        'Holder',
        'ObjectDigestInfo',
        'AttCertIssuer',
        'V2Form',
        'IssuerSerial',
        'AttCertValidityPeriod',
        'Targets',
        'Target',
        'TargetCert',
        'AAControls',
        'AttrSpec',
        'ProxyInfo',
        'IetfAttrSyntax',
        'SvceAuthInfo',
        'RoleSyntax',
        'Clearance',
        'Clearance-rfc3281',
        'ClassList',
        'SupportedSecurityCategories',
        'SecurityCategory-rfc3281',
        'ACClearAttrs',
        ]
    _type_ = [
        'AttributeCertificate',
        'AttributeCertificateInfo',
        'AttCertVersion',
        'Holder',
        'ObjectDigestInfo',
        'AttCertIssuer',
        'V2Form',
        'IssuerSerial',
        'AttCertValidityPeriod',
        'Targets',
        'Target',
        'TargetCert',
        'AAControls',
        'AttrSpec',
        'ProxyInfo',
        'IetfAttrSyntax',
        'SvceAuthInfo',
        'RoleSyntax',
        'Clearance',
        'Clearance-rfc3281',
        'ClassList',
        'SecurityCategory-rfc3281',
        'ACClearAttrs',
        ]
    _set_ = [
        'AttributeCertExtensions',
        'AttributesDefined',
        'SupportedSecurityCategories',
        ]
    _val_ = [
        'ext-auditIdentity',
        'ext-targetInformation',
        'ext-noRevAvail',
        'ext-ac-proxying',
        'ext-aaControls',
        'at-authenticationInfo',
        'at-accesIdentity',
        'at-chargingIdentity',
        'at-group',
        'at-role',
        'at-clearance',
        'at-clearance-RFC3281',
        'at-encAttrs',
        'id-pe-ac-auditIdentity',
        'id-pe-aaControls',
        'id-pe-ac-proxying',
        'id-ce-targetInformation',
        'id-ce-noRevAvail',
        'id-aca',
        'id-aca-authenticationInfo',
        'id-aca-accessIdentity',
        'id-aca-chargingIdentity',
        'id-aca-group',
        'id-aca-encAttrs',
        'id-at-role',
        'id-at-clearance',
        'id-at-clearance-rfc3281',
        ]
    _class_ = [
        'AttributeCertExtensions',
        'ext-auditIdentity',
        'ext-targetInformation',
        'ext-noRevAvail',
        'ext-ac-proxying',
        'ext-aaControls',
        'AttributesDefined',
        'at-authenticationInfo',
        'at-accesIdentity',
        'at-chargingIdentity',
        'at-group',
        'at-role',
        'at-clearance',
        'at-clearance-RFC3281',
        'at-encAttrs',
        'SupportedSecurityCategories',
        ]
    _param_ = [
        'SecurityCategory-rfc3281',
        ]
    
    #-----< AttributeCertExtensions >-----#
    AttributeCertExtensions = CLASS(name='AttributeCertExtensions', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _AttributeCertExtensions_val_ExtnType_0 = OCT_STR(name='ExtnType', mode=MODE_TYPE)
    _AttributeCertExtensions_val_ExtnType_1 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Targets')))
    _AttributeCertExtensions_val_ExtnType_2 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityKeyIdentifier')))
    _AttributeCertExtensions_val_ExtnType_3 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityInfoAccessSyntax')))
    _AttributeCertExtensions_val_ExtnType_4 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    _AttributeCertExtensions_val_ExtnType_5 = NULL(name='ExtnType', mode=MODE_TYPE)
    _AttributeCertExtensions_val_ExtnType_6 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'ProxyInfo')))
    _AttributeCertExtensions_val_ExtnType_7 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AAControls')))
    AttributeCertExtensions._val = ASN1Set(rv=[dict([('ExtnType', _AttributeCertExtensions_val_ExtnType_0), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 4))]), dict([('ExtnType', _AttributeCertExtensions_val_ExtnType_1), ('id', (2, 5, 29, 55))]), dict([('ExtnType', _AttributeCertExtensions_val_ExtnType_2), ('id', (2, 5, 29, 35))]), dict([('ExtnType', _AttributeCertExtensions_val_ExtnType_3), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 1))]), dict([('ExtnType', _AttributeCertExtensions_val_ExtnType_4), ('id', (2, 5, 29, 31))]), dict([('ExtnType', _AttributeCertExtensions_val_ExtnType_5), ('id', (2, 5, 29, 56))]), dict([('ExtnType', _AttributeCertExtensions_val_ExtnType_6), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 10))]), dict([('ExtnType', _AttributeCertExtensions_val_ExtnType_7), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 6))])], rr=[], ev=[], er=[])
    
    #-----< ext-auditIdentity >-----#
    ext_auditIdentity = CLASS(name='ext-auditIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_auditIdentity_val_ExtnType = OCT_STR(name='ExtnType', mode=MODE_TYPE)
    ext_auditIdentity._val = dict([('ExtnType', _ext_auditIdentity_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 4))])
    
    #-----< ext-targetInformation >-----#
    ext_targetInformation = CLASS(name='ext-targetInformation', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_targetInformation_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Targets')))
    ext_targetInformation._val = dict([('ExtnType', _ext_targetInformation_val_ExtnType), ('id', (2, 5, 29, 55))])
    
    #-----< ext-noRevAvail >-----#
    ext_noRevAvail = CLASS(name='ext-noRevAvail', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_noRevAvail_val_ExtnType = NULL(name='ExtnType', mode=MODE_TYPE)
    ext_noRevAvail._val = dict([('ExtnType', _ext_noRevAvail_val_ExtnType), ('id', (2, 5, 29, 56))])
    
    #-----< ext-ac-proxying >-----#
    ext_ac_proxying = CLASS(name='ext-ac-proxying', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_ac_proxying_val_ExtnType = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'ProxyInfo')))
    ext_ac_proxying._val = dict([('ExtnType', _ext_ac_proxying_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 10))])
    
    #-----< ext-aaControls >-----#
    ext_aaControls = CLASS(name='ext-aaControls', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _ext_aaControls_val_ExtnType = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AAControls')))
    ext_aaControls._val = dict([('ExtnType', _ext_aaControls_val_ExtnType), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 6))])
    
    #-----< AttributesDefined >-----#
    AttributesDefined = CLASS(name='AttributesDefined', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _AttributesDefined_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'SvceAuthInfo')))
    _AttributesDefined_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'SvceAuthInfo')))
    _AttributesDefined_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IetfAttrSyntax')))
    _AttributesDefined_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IetfAttrSyntax')))
    _AttributesDefined_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'RoleSyntax')))
    _AttributesDefined_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Clearance')))
    _AttributesDefined_val_Type_6 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentInfo')))
    AttributesDefined._val = ASN1Set(rv=[dict([('Type', _AttributesDefined_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 1))]), dict([('Type', _AttributesDefined_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 2))]), dict([('Type', _AttributesDefined_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 3))]), dict([('Type', _AttributesDefined_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 4))]), dict([('Type', _AttributesDefined_val_Type_4), ('id', (2, 5, 4, 72))]), dict([('Type', _AttributesDefined_val_Type_5), ('id', (2, 5, 4, 55))]), dict([('Type', _AttributesDefined_val_Type_6), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 6))])], rr=[], ev=[], er=[])
    
    #-----< at-authenticationInfo >-----#
    at_authenticationInfo = CLASS(name='at-authenticationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_authenticationInfo_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'SvceAuthInfo')))
    at_authenticationInfo._val = dict([('Type', _at_authenticationInfo_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 1))])
    
    #-----< at-accesIdentity >-----#
    at_accesIdentity = CLASS(name='at-accesIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_accesIdentity_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'SvceAuthInfo')))
    at_accesIdentity._val = dict([('Type', _at_accesIdentity_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 2))])
    
    #-----< at-chargingIdentity >-----#
    at_chargingIdentity = CLASS(name='at-chargingIdentity', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_chargingIdentity_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IetfAttrSyntax')))
    at_chargingIdentity._val = dict([('Type', _at_chargingIdentity_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 3))])
    
    #-----< at-group >-----#
    at_group = CLASS(name='at-group', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_group_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IetfAttrSyntax')))
    at_group._val = dict([('Type', _at_group_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 4))])
    
    #-----< at-role >-----#
    at_role = CLASS(name='at-role', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_role_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'RoleSyntax')))
    at_role._val = dict([('Type', _at_role_val_Type), ('id', (2, 5, 4, 72))])
    
    #-----< at-clearance >-----#
    at_clearance = CLASS(name='at-clearance', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_clearance_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Clearance')))
    at_clearance._val = dict([('Type', _at_clearance_val_Type), ('id', (2, 5, 4, 55))])
    
    #-----< at-clearance-RFC3281 >-----#
    at_clearance_RFC3281 = CLASS(name='at-clearance-RFC3281', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_clearance_RFC3281_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Clearance-rfc3281')))
    at_clearance_RFC3281._val = dict([('Type', _at_clearance_RFC3281_val_Type), ('id', (2, 5, 1, 5, 55))])
    
    #-----< at-encAttrs >-----#
    at_encAttrs = CLASS(name='at-encAttrs', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _at_encAttrs_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentInfo')))
    at_encAttrs._val = dict([('Type', _at_encAttrs_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 6))])
    
    #-----< id-pe-ac-auditIdentity >-----#
    id_pe_ac_auditIdentity = OID(name='id-pe-ac-auditIdentity', mode=MODE_VALUE)
    id_pe_ac_auditIdentity._val = (1, 3, 6, 1, 5, 5, 7, 1, 4)
    
    #-----< id-pe-aaControls >-----#
    id_pe_aaControls = OID(name='id-pe-aaControls', mode=MODE_VALUE)
    id_pe_aaControls._val = (1, 3, 6, 1, 5, 5, 7, 1, 6)
    
    #-----< id-pe-ac-proxying >-----#
    id_pe_ac_proxying = OID(name='id-pe-ac-proxying', mode=MODE_VALUE)
    id_pe_ac_proxying._val = (1, 3, 6, 1, 5, 5, 7, 1, 10)
    
    #-----< id-ce-targetInformation >-----#
    id_ce_targetInformation = OID(name='id-ce-targetInformation', mode=MODE_VALUE)
    id_ce_targetInformation._val = (2, 5, 29, 55)
    
    #-----< id-ce-noRevAvail >-----#
    id_ce_noRevAvail = OID(name='id-ce-noRevAvail', mode=MODE_VALUE)
    id_ce_noRevAvail._val = (2, 5, 29, 56)
    
    #-----< id-aca >-----#
    id_aca = OID(name='id-aca', mode=MODE_VALUE)
    id_aca._val = (1, 3, 6, 1, 5, 5, 7, 10)
    
    #-----< id-aca-authenticationInfo >-----#
    id_aca_authenticationInfo = OID(name='id-aca-authenticationInfo', mode=MODE_VALUE)
    id_aca_authenticationInfo._val = (1, 3, 6, 1, 5, 5, 7, 10, 1)
    
    #-----< id-aca-accessIdentity >-----#
    id_aca_accessIdentity = OID(name='id-aca-accessIdentity', mode=MODE_VALUE)
    id_aca_accessIdentity._val = (1, 3, 6, 1, 5, 5, 7, 10, 2)
    
    #-----< id-aca-chargingIdentity >-----#
    id_aca_chargingIdentity = OID(name='id-aca-chargingIdentity', mode=MODE_VALUE)
    id_aca_chargingIdentity._val = (1, 3, 6, 1, 5, 5, 7, 10, 3)
    
    #-----< id-aca-group >-----#
    id_aca_group = OID(name='id-aca-group', mode=MODE_VALUE)
    id_aca_group._val = (1, 3, 6, 1, 5, 5, 7, 10, 4)
    
    #-----< id-aca-encAttrs >-----#
    id_aca_encAttrs = OID(name='id-aca-encAttrs', mode=MODE_VALUE)
    id_aca_encAttrs._val = (1, 3, 6, 1, 5, 5, 7, 10, 6)
    
    #-----< id-at-role >-----#
    id_at_role = OID(name='id-at-role', mode=MODE_VALUE)
    id_at_role._val = (2, 5, 4, 72)
    
    #-----< id-at-clearance >-----#
    id_at_clearance = OID(name='id-at-clearance', mode=MODE_VALUE)
    id_at_clearance._val = (2, 5, 4, 55)
    
    #-----< id-at-clearance-rfc3281 >-----#
    id_at_clearance_rfc3281 = OID(name='id-at-clearance-rfc3281', mode=MODE_VALUE)
    id_at_clearance_rfc3281._val = (2, 5, 1, 5, 55)
    
    #-----< AttributeCertificate >-----#
    AttributeCertificate = SEQ(name='AttributeCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SIGNED')))
    _AttributeCertificate_toBeSigned = SEQ(name='toBeSigned', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttributeCertificateInfo')))
    _AttributeCertificate_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE)
    __AttributeCertificate_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___AttributeCertificate_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    __SIGNATURE_ALGORITHM_HashSet_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___AttributeCertificate_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_3), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_4), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_5), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_6), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_7), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_8), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_9), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_10), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab = ___AttributeCertificate_algorithmIdentifier_algorithm_tab
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab_at = None
    __AttributeCertificate_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __AttributeCertificate_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab = ___AttributeCertificate_algorithmIdentifier_algorithm_tab
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab_at = ('..', '..', 'algorithmIdentifier', 'algorithm')
    __AttributeCertificate_algorithmIdentifier_parameters._const_tab_id = 'Params'
    _AttributeCertificate_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __AttributeCertificate_algorithmIdentifier_algorithm),
        ('parameters', __AttributeCertificate_algorithmIdentifier_parameters),
        ])
    _AttributeCertificate_algorithmIdentifier._ext = None
    _AttributeCertificate_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    __AttributeCertificate_signature_contain = OPEN(name='_cont_signature', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Value']))
    __AttributeCertificate_signature_contain._const_tab = ___AttributeCertificate_algorithmIdentifier_algorithm_tab
    __AttributeCertificate_signature_contain._const_tab_at = ('..', 'algorithmIdentifier', 'algorithm')
    __AttributeCertificate_signature_contain._const_tab_id = 'Value'
    _AttributeCertificate_signature._const_cont = __AttributeCertificate_signature_contain
    AttributeCertificate._cont = ASN1Dict([
        ('toBeSigned', _AttributeCertificate_toBeSigned),
        ('algorithmIdentifier', _AttributeCertificate_algorithmIdentifier),
        ('signature', _AttributeCertificate_signature),
        ])
    AttributeCertificate._ext = None
    
    #-----< AttributeCertificateInfo >-----#
    AttributeCertificateInfo = SEQ(name='AttributeCertificateInfo', mode=MODE_TYPE)
    _AttributeCertificateInfo_version = INT(name='version', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttCertVersion')))
    _AttributeCertificateInfo_holder = SEQ(name='holder', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Holder')))
    _AttributeCertificateInfo_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttCertIssuer')))
    _AttributeCertificateInfo_signature = SEQ(name='signature', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __AttributeCertificateInfo_signature_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___AttributeCertificateInfo_signature_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___AttributeCertificateInfo_signature_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_3), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_4), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_5), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_6), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_7), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_8), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_9), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_10), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __AttributeCertificateInfo_signature_algorithm._const_tab = ___AttributeCertificateInfo_signature_algorithm_tab
    __AttributeCertificateInfo_signature_algorithm._const_tab_at = None
    __AttributeCertificateInfo_signature_algorithm._const_tab_id = 'id'
    __AttributeCertificateInfo_signature_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __AttributeCertificateInfo_signature_parameters._const_tab = ___AttributeCertificateInfo_signature_algorithm_tab
    __AttributeCertificateInfo_signature_parameters._const_tab_at = ('..', 'algorithm')
    __AttributeCertificateInfo_signature_parameters._const_tab_id = 'Params'
    _AttributeCertificateInfo_signature._cont = ASN1Dict([
        ('algorithm', __AttributeCertificateInfo_signature_algorithm),
        ('parameters', __AttributeCertificateInfo_signature_parameters),
        ])
    _AttributeCertificateInfo_signature._ext = None
    _AttributeCertificateInfo_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateSerialNumber')))
    _AttributeCertificateInfo_attrCertValidityPeriod = SEQ(name='attrCertValidityPeriod', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttCertValidityPeriod')))
    _AttributeCertificateInfo_attributes = SEQ_OF(name='attributes', mode=MODE_TYPE)
    __AttributeCertificateInfo_attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'AttributeSet')))
    ___AttributeCertificateInfo_attributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ____AttributeCertificateInfo_attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'SvceAuthInfo')))
    _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'SvceAuthInfo')))
    _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IetfAttrSyntax')))
    _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IetfAttrSyntax')))
    _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'RoleSyntax')))
    _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Clearance')))
    _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_6 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentInfo')))
    ____AttributeCertificateInfo_attributes__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 1))]), dict([('Type', _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 2))]), dict([('Type', _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 3))]), dict([('Type', _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 4))]), dict([('Type', _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_4), ('id', (2, 5, 4, 72))]), dict([('Type', _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_5), ('id', (2, 5, 4, 55))]), dict([('Type', _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_6), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 6))])], rr=[], ev=None, er=[])
    ___AttributeCertificateInfo_attributes__item__type._const_tab = ____AttributeCertificateInfo_attributes__item__type_tab
    ___AttributeCertificateInfo_attributes__item__type._const_tab_at = None
    ___AttributeCertificateInfo_attributes__item__type._const_tab_id = 'id'
    ___AttributeCertificateInfo_attributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____AttributeCertificateInfo_attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    ____AttributeCertificateInfo_attributes__item__values__item_._const_tab = ____AttributeCertificateInfo_attributes__item__type_tab
    ____AttributeCertificateInfo_attributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____AttributeCertificateInfo_attributes__item__values__item_._const_tab_id = 'Type'
    ___AttributeCertificateInfo_attributes__item__values._cont = ____AttributeCertificateInfo_attributes__item__values__item_
    ___AttributeCertificateInfo_attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __AttributeCertificateInfo_attributes__item_._cont = ASN1Dict([
        ('type', ___AttributeCertificateInfo_attributes__item__type),
        ('values', ___AttributeCertificateInfo_attributes__item__values),
        ])
    __AttributeCertificateInfo_attributes__item_._ext = None
    _AttributeCertificateInfo_attributes._cont = __AttributeCertificateInfo_attributes__item_
    _AttributeCertificateInfo_issuerUniqueID = BIT_STR(name='issuerUniqueID', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'UniqueIdentifier')), opt=True)
    _AttributeCertificateInfo_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __AttributeCertificateInfo_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___AttributeCertificateInfo_extensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____AttributeCertificateInfo_extensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_0 = OCT_STR(name='ExtnType', mode=MODE_TYPE)
    _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_1 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Targets')))
    _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_2 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityKeyIdentifier')))
    _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_3 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityInfoAccessSyntax')))
    _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_4 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_5 = NULL(name='ExtnType', mode=MODE_TYPE)
    _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_6 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'ProxyInfo')))
    _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_7 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AAControls')))
    ____AttributeCertificateInfo_extensions__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_0), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 4))]), dict([('ExtnType', _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_1), ('id', (2, 5, 29, 55))]), dict([('ExtnType', _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_2), ('id', (2, 5, 29, 35))]), dict([('ExtnType', _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_3), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 1))]), dict([('ExtnType', _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_4), ('id', (2, 5, 29, 31))]), dict([('ExtnType', _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_5), ('id', (2, 5, 29, 56))]), dict([('ExtnType', _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_6), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 10))]), dict([('ExtnType', _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_7), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 6))])], rr=[], ev=None, er=[])
    ___AttributeCertificateInfo_extensions__item__extnID._const_tab = ____AttributeCertificateInfo_extensions__item__extnID_tab
    ___AttributeCertificateInfo_extensions__item__extnID._const_tab_at = None
    ___AttributeCertificateInfo_extensions__item__extnID._const_tab_id = 'id'
    ___AttributeCertificateInfo_extensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___AttributeCertificateInfo_extensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____AttributeCertificateInfo_extensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ____AttributeCertificateInfo_extensions__item__extnValue_contain._const_tab = ____AttributeCertificateInfo_extensions__item__extnID_tab
    ____AttributeCertificateInfo_extensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____AttributeCertificateInfo_extensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___AttributeCertificateInfo_extensions__item__extnValue._const_cont = ____AttributeCertificateInfo_extensions__item__extnValue_contain
    __AttributeCertificateInfo_extensions__item_._cont = ASN1Dict([
        ('extnID', ___AttributeCertificateInfo_extensions__item__extnID),
        ('critical', ___AttributeCertificateInfo_extensions__item__critical),
        ('extnValue', ___AttributeCertificateInfo_extensions__item__extnValue),
        ])
    __AttributeCertificateInfo_extensions__item_._ext = None
    _AttributeCertificateInfo_extensions._cont = __AttributeCertificateInfo_extensions__item_
    _AttributeCertificateInfo_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    AttributeCertificateInfo._cont = ASN1Dict([
        ('version', _AttributeCertificateInfo_version),
        ('holder', _AttributeCertificateInfo_holder),
        ('issuer', _AttributeCertificateInfo_issuer),
        ('signature', _AttributeCertificateInfo_signature),
        ('serialNumber', _AttributeCertificateInfo_serialNumber),
        ('attrCertValidityPeriod', _AttributeCertificateInfo_attrCertValidityPeriod),
        ('attributes', _AttributeCertificateInfo_attributes),
        ('issuerUniqueID', _AttributeCertificateInfo_issuerUniqueID),
        ('extensions', _AttributeCertificateInfo_extensions),
        ])
    AttributeCertificateInfo._ext = None
    
    #-----< AttCertVersion >-----#
    AttCertVersion = INT(name='AttCertVersion', mode=MODE_TYPE)
    AttCertVersion._cont = ASN1Dict([('v2', 1)])
    
    #-----< Holder >-----#
    Holder = SEQ(name='Holder', mode=MODE_TYPE)
    _Holder_baseCertificateID = SEQ(name='baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IssuerSerial')), opt=True)
    _Holder_entityName = SEQ_OF(name='entityName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')), opt=True)
    _Holder_objectDigestInfo = SEQ(name='objectDigestInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'ObjectDigestInfo')), opt=True)
    Holder._cont = ASN1Dict([
        ('baseCertificateID', _Holder_baseCertificateID),
        ('entityName', _Holder_entityName),
        ('objectDigestInfo', _Holder_objectDigestInfo),
        ])
    Holder._ext = None
    
    #-----< ObjectDigestInfo >-----#
    ObjectDigestInfo = SEQ(name='ObjectDigestInfo', mode=MODE_TYPE)
    _ObjectDigestInfo_digestedObjectType = ENUM(name='digestedObjectType', mode=MODE_TYPE)
    _ObjectDigestInfo_digestedObjectType._cont = ASN1Dict([('publicKey', 0), ('publicKeyCert', 1), ('otherObjectTypes', 2)])
    _ObjectDigestInfo_digestedObjectType._ext = None
    _ObjectDigestInfo_otherObjectTypeID = OID(name='otherObjectTypeID', mode=MODE_TYPE, opt=True)
    _ObjectDigestInfo_digestAlgorithm = SEQ(name='digestAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __ObjectDigestInfo_digestAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___ObjectDigestInfo_digestAlgorithm_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___ObjectDigestInfo_digestAlgorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab = ___ObjectDigestInfo_digestAlgorithm_algorithm_tab
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab_at = None
    __ObjectDigestInfo_digestAlgorithm_algorithm._const_tab_id = 'id'
    __ObjectDigestInfo_digestAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    ___ObjectDigestInfo_digestAlgorithm_parameters_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___ObjectDigestInfo_digestAlgorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab = ___ObjectDigestInfo_digestAlgorithm_parameters_tab
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __ObjectDigestInfo_digestAlgorithm_parameters._const_tab_id = 'Params'
    _ObjectDigestInfo_digestAlgorithm._cont = ASN1Dict([
        ('algorithm', __ObjectDigestInfo_digestAlgorithm_algorithm),
        ('parameters', __ObjectDigestInfo_digestAlgorithm_parameters),
        ])
    _ObjectDigestInfo_digestAlgorithm._ext = None
    _ObjectDigestInfo_objectDigest = BIT_STR(name='objectDigest', mode=MODE_TYPE)
    ObjectDigestInfo._cont = ASN1Dict([
        ('digestedObjectType', _ObjectDigestInfo_digestedObjectType),
        ('otherObjectTypeID', _ObjectDigestInfo_otherObjectTypeID),
        ('digestAlgorithm', _ObjectDigestInfo_digestAlgorithm),
        ('objectDigest', _ObjectDigestInfo_objectDigest),
        ])
    ObjectDigestInfo._ext = None
    
    #-----< AttCertIssuer >-----#
    AttCertIssuer = CHOICE(name='AttCertIssuer', mode=MODE_TYPE)
    _AttCertIssuer_v1Form = SEQ_OF(name='v1Form', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _AttCertIssuer_v2Form = SEQ(name='v2Form', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'V2Form')))
    AttCertIssuer._cont = ASN1Dict([
        ('v1Form', _AttCertIssuer_v1Form),
        ('v2Form', _AttCertIssuer_v2Form),
        ])
    AttCertIssuer._ext = None
    
    #-----< V2Form >-----#
    V2Form = SEQ(name='V2Form', mode=MODE_TYPE)
    _V2Form_issuerName = SEQ_OF(name='issuerName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')), opt=True)
    _V2Form_baseCertificateID = SEQ(name='baseCertificateID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IssuerSerial')), opt=True)
    _V2Form_objectDigestInfo = SEQ(name='objectDigestInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'ObjectDigestInfo')), opt=True)
    V2Form._cont = ASN1Dict([
        ('issuerName', _V2Form_issuerName),
        ('baseCertificateID', _V2Form_baseCertificateID),
        ('objectDigestInfo', _V2Form_objectDigestInfo),
        ])
    V2Form._ext = None
    
    #-----< IssuerSerial >-----#
    IssuerSerial = SEQ(name='IssuerSerial', mode=MODE_TYPE)
    _IssuerSerial_issuer = SEQ_OF(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _IssuerSerial_serial = INT(name='serial', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateSerialNumber')))
    _IssuerSerial_issuerUID = BIT_STR(name='issuerUID', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'UniqueIdentifier')), opt=True)
    IssuerSerial._cont = ASN1Dict([
        ('issuer', _IssuerSerial_issuer),
        ('serial', _IssuerSerial_serial),
        ('issuerUID', _IssuerSerial_issuerUID),
        ])
    IssuerSerial._ext = None
    
    #-----< AttCertValidityPeriod >-----#
    AttCertValidityPeriod = SEQ(name='AttCertValidityPeriod', mode=MODE_TYPE)
    _AttCertValidityPeriod_notBeforeTime = TIME_GEN(name='notBeforeTime', mode=MODE_TYPE)
    _AttCertValidityPeriod_notAfterTime = TIME_GEN(name='notAfterTime', mode=MODE_TYPE)
    AttCertValidityPeriod._cont = ASN1Dict([
        ('notBeforeTime', _AttCertValidityPeriod_notBeforeTime),
        ('notAfterTime', _AttCertValidityPeriod_notAfterTime),
        ])
    AttCertValidityPeriod._ext = None
    
    #-----< Targets >-----#
    Targets = SEQ_OF(name='Targets', mode=MODE_TYPE)
    _Targets__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Target')))
    Targets._cont = _Targets__item_
    
    #-----< Target >-----#
    Target = CHOICE(name='Target', mode=MODE_TYPE)
    _Target_targetName = CHOICE(name='targetName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _Target_targetGroup = CHOICE(name='targetGroup', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _Target_targetCert = SEQ(name='targetCert', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'TargetCert')))
    Target._cont = ASN1Dict([
        ('targetName', _Target_targetName),
        ('targetGroup', _Target_targetGroup),
        ('targetCert', _Target_targetCert),
        ])
    Target._ext = None
    
    #-----< TargetCert >-----#
    TargetCert = SEQ(name='TargetCert', mode=MODE_TYPE)
    _TargetCert_targetCertificate = SEQ(name='targetCertificate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IssuerSerial')))
    _TargetCert_targetName = CHOICE(name='targetName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')), opt=True)
    _TargetCert_certDigestInfo = SEQ(name='certDigestInfo', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'ObjectDigestInfo')), opt=True)
    TargetCert._cont = ASN1Dict([
        ('targetCertificate', _TargetCert_targetCertificate),
        ('targetName', _TargetCert_targetName),
        ('certDigestInfo', _TargetCert_certDigestInfo),
        ])
    TargetCert._ext = None
    
    #-----< AAControls >-----#
    AAControls = SEQ(name='AAControls', mode=MODE_TYPE)
    _AAControls_pathLenConstraint = INT(name='pathLenConstraint', mode=MODE_TYPE, opt=True)
    _AAControls_pathLenConstraint._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=None)], ev=None, er=[])
    _AAControls_permittedAttrs = SEQ_OF(name='permittedAttrs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttrSpec')), opt=True)
    _AAControls_excludedAttrs = SEQ_OF(name='excludedAttrs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttrSpec')), opt=True)
    _AAControls_permitUnSpecified = BOOL(name='permitUnSpecified', mode=MODE_TYPE, default=True)
    AAControls._cont = ASN1Dict([
        ('pathLenConstraint', _AAControls_pathLenConstraint),
        ('permittedAttrs', _AAControls_permittedAttrs),
        ('excludedAttrs', _AAControls_excludedAttrs),
        ('permitUnSpecified', _AAControls_permitUnSpecified),
        ])
    AAControls._ext = None
    
    #-----< AttrSpec >-----#
    AttrSpec = SEQ_OF(name='AttrSpec', mode=MODE_TYPE)
    _AttrSpec__item_ = OID(name='_item_', mode=MODE_TYPE)
    AttrSpec._cont = _AttrSpec__item_
    
    #-----< ProxyInfo >-----#
    ProxyInfo = SEQ_OF(name='ProxyInfo', mode=MODE_TYPE)
    _ProxyInfo__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Targets')))
    ProxyInfo._cont = _ProxyInfo__item_
    
    #-----< IetfAttrSyntax >-----#
    IetfAttrSyntax = SEQ(name='IetfAttrSyntax', mode=MODE_TYPE)
    _IetfAttrSyntax_policyAuthority = SEQ_OF(name='policyAuthority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')), opt=True)
    _IetfAttrSyntax_values = SEQ_OF(name='values', mode=MODE_TYPE)
    __IetfAttrSyntax_values__item_ = CHOICE(name='_item_', mode=MODE_TYPE)
    ___IetfAttrSyntax_values__item__octets = OCT_STR(name='octets', mode=MODE_TYPE)
    ___IetfAttrSyntax_values__item__oid = OID(name='oid', mode=MODE_TYPE)
    ___IetfAttrSyntax_values__item__string = STR_UTF8(name='string', mode=MODE_TYPE)
    __IetfAttrSyntax_values__item_._cont = ASN1Dict([
        ('octets', ___IetfAttrSyntax_values__item__octets),
        ('oid', ___IetfAttrSyntax_values__item__oid),
        ('string', ___IetfAttrSyntax_values__item__string),
        ])
    __IetfAttrSyntax_values__item_._ext = None
    _IetfAttrSyntax_values._cont = __IetfAttrSyntax_values__item_
    IetfAttrSyntax._cont = ASN1Dict([
        ('policyAuthority', _IetfAttrSyntax_policyAuthority),
        ('values', _IetfAttrSyntax_values),
        ])
    IetfAttrSyntax._ext = None
    
    #-----< SvceAuthInfo >-----#
    SvceAuthInfo = SEQ(name='SvceAuthInfo', mode=MODE_TYPE)
    _SvceAuthInfo_service = CHOICE(name='service', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _SvceAuthInfo_ident = CHOICE(name='ident', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _SvceAuthInfo_authInfo = OCT_STR(name='authInfo', mode=MODE_TYPE, opt=True)
    SvceAuthInfo._cont = ASN1Dict([
        ('service', _SvceAuthInfo_service),
        ('ident', _SvceAuthInfo_ident),
        ('authInfo', _SvceAuthInfo_authInfo),
        ])
    SvceAuthInfo._ext = None
    
    #-----< RoleSyntax >-----#
    RoleSyntax = SEQ(name='RoleSyntax', mode=MODE_TYPE)
    _RoleSyntax_roleAuthority = SEQ_OF(name='roleAuthority', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')), opt=True)
    _RoleSyntax_roleName = CHOICE(name='roleName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    RoleSyntax._cont = ASN1Dict([
        ('roleAuthority', _RoleSyntax_roleAuthority),
        ('roleName', _RoleSyntax_roleName),
        ])
    RoleSyntax._ext = None
    
    #-----< Clearance >-----#
    Clearance = SEQ(name='Clearance', mode=MODE_TYPE)
    _Clearance_policyId = OID(name='policyId', mode=MODE_TYPE)
    _Clearance_classList = BIT_STR(name='classList', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'ClassList')), default=(1, 2))
    _Clearance_securityCategories = SET_OF(name='securityCategories', mode=MODE_TYPE, opt=True)
    __Clearance_securityCategories__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'SecurityCategory')))
    ___Clearance_securityCategories__item__type = OID(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'SECURITY-CATEGORY'), ['id']))
    ____Clearance_securityCategories__item__type_tab = CLASS(name='_tab_SECURITY-CATEGORY', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'SECURITY-CATEGORY')))
    ____Clearance_securityCategories__item__type_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Clearance_securityCategories__item__type._const_tab = ____Clearance_securityCategories__item__type_tab
    ___Clearance_securityCategories__item__type._const_tab_at = None
    ___Clearance_securityCategories__item__type._const_tab_id = 'id'
    ___Clearance_securityCategories__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'SECURITY-CATEGORY'), ['Type']))
    ____Clearance_securityCategories__item__value_tab = CLASS(name='_tab_SECURITY-CATEGORY', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'SECURITY-CATEGORY')))
    ____Clearance_securityCategories__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Clearance_securityCategories__item__value._const_tab = ____Clearance_securityCategories__item__value_tab
    ___Clearance_securityCategories__item__value._const_tab_at = ('..', 'type')
    ___Clearance_securityCategories__item__value._const_tab_id = 'Type'
    __Clearance_securityCategories__item_._cont = ASN1Dict([
        ('type', ___Clearance_securityCategories__item__type),
        ('value', ___Clearance_securityCategories__item__value),
        ])
    __Clearance_securityCategories__item_._ext = None
    _Clearance_securityCategories._cont = __Clearance_securityCategories__item_
    Clearance._cont = ASN1Dict([
        ('policyId', _Clearance_policyId),
        ('classList', _Clearance_classList),
        ('securityCategories', _Clearance_securityCategories),
        ])
    Clearance._ext = None
    
    #-----< Clearance-rfc3281 >-----#
    Clearance_rfc3281 = SEQ(name='Clearance-rfc3281', mode=MODE_TYPE)
    _Clearance_rfc3281_policyId = OID(name='policyId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Clearance_rfc3281_classList = BIT_STR(name='classList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'ClassList')), default=(1, 2))
    _Clearance_rfc3281_securityCategories = SET_OF(name='securityCategories', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Clearance_rfc3281_securityCategories__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'SecurityCategory-rfc3281')))
    ___Clearance_rfc3281_securityCategories__item__type = OID(name='type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'SECURITY-CATEGORY'), ['id']))
    ____Clearance_rfc3281_securityCategories__item__type_tab = CLASS(name='_tab_SECURITY-CATEGORY', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'SECURITY-CATEGORY')))
    ____Clearance_rfc3281_securityCategories__item__type_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Clearance_rfc3281_securityCategories__item__type._const_tab = ____Clearance_rfc3281_securityCategories__item__type_tab
    ___Clearance_rfc3281_securityCategories__item__type._const_tab_at = None
    ___Clearance_rfc3281_securityCategories__item__type._const_tab_id = 'id'
    ___Clearance_rfc3281_securityCategories__item__value = OPEN(name='value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'SECURITY-CATEGORY'), ['Type']))
    ____Clearance_rfc3281_securityCategories__item__value_tab = CLASS(name='_tab_SECURITY-CATEGORY', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'SECURITY-CATEGORY')))
    ____Clearance_rfc3281_securityCategories__item__value_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Clearance_rfc3281_securityCategories__item__value._const_tab = ____Clearance_rfc3281_securityCategories__item__value_tab
    ___Clearance_rfc3281_securityCategories__item__value._const_tab_at = ('..', 'type')
    ___Clearance_rfc3281_securityCategories__item__value._const_tab_id = 'Type'
    __Clearance_rfc3281_securityCategories__item_._cont = ASN1Dict([
        ('type', ___Clearance_rfc3281_securityCategories__item__type),
        ('value', ___Clearance_rfc3281_securityCategories__item__value),
        ])
    __Clearance_rfc3281_securityCategories__item_._ext = None
    _Clearance_rfc3281_securityCategories._cont = __Clearance_rfc3281_securityCategories__item_
    Clearance_rfc3281._cont = ASN1Dict([
        ('policyId', _Clearance_rfc3281_policyId),
        ('classList', _Clearance_rfc3281_classList),
        ('securityCategories', _Clearance_rfc3281_securityCategories),
        ])
    Clearance_rfc3281._ext = None
    
    #-----< ClassList >-----#
    ClassList = BIT_STR(name='ClassList', mode=MODE_TYPE)
    ClassList._cont = ASN1Dict([('unmarked', 0), ('unclassified', 1), ('restricted', 2), ('confidential', 3), ('secret', 4), ('topSecret', 5)])
    
    #-----< SupportedSecurityCategories >-----#
    SupportedSecurityCategories = CLASS(name='SupportedSecurityCategories', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'SECURITY-CATEGORY')))
    SupportedSecurityCategories._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SecurityCategory-rfc3281 >-----#
    SecurityCategory_rfc3281 = SEQ(name='SecurityCategory-rfc3281', mode=MODE_TYPE, param=True)
    
    #-----< ACClearAttrs >-----#
    ACClearAttrs = SEQ(name='ACClearAttrs', mode=MODE_TYPE)
    _ACClearAttrs_acIssuer = CHOICE(name='acIssuer', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _ACClearAttrs_acSerial = INT(name='acSerial', mode=MODE_TYPE)
    _ACClearAttrs_attrs = SEQ_OF(name='attrs', mode=MODE_TYPE)
    __ACClearAttrs_attrs__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'AttributeSet')))
    ___ACClearAttrs_attrs__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ____ACClearAttrs_attrs__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _____ACClearAttrs_attrs__item__type_tab_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'SvceAuthInfo')))
    _____ACClearAttrs_attrs__item__type_tab_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'SvceAuthInfo')))
    _____ACClearAttrs_attrs__item__type_tab_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IetfAttrSyntax')))
    _____ACClearAttrs_attrs__item__type_tab_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'IetfAttrSyntax')))
    _____ACClearAttrs_attrs__item__type_tab_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'RoleSyntax')))
    _____ACClearAttrs_attrs__item__type_tab_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'Clearance')))
    _____ACClearAttrs_attrs__item__type_tab_val_Type_6 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentInfo')))
    ____ACClearAttrs_attrs__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____ACClearAttrs_attrs__item__type_tab_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 1))]), dict([('Type', _____ACClearAttrs_attrs__item__type_tab_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 2))]), dict([('Type', _____ACClearAttrs_attrs__item__type_tab_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 3))]), dict([('Type', _____ACClearAttrs_attrs__item__type_tab_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 4))]), dict([('Type', _____ACClearAttrs_attrs__item__type_tab_val_Type_4), ('id', (2, 5, 4, 72))]), dict([('Type', _____ACClearAttrs_attrs__item__type_tab_val_Type_5), ('id', (2, 5, 4, 55))]), dict([('Type', _____ACClearAttrs_attrs__item__type_tab_val_Type_6), ('id', (1, 3, 6, 1, 5, 5, 7, 10, 6))])], rr=[], ev=None, er=[])
    ___ACClearAttrs_attrs__item__type._const_tab = ____ACClearAttrs_attrs__item__type_tab
    ___ACClearAttrs_attrs__item__type._const_tab_at = None
    ___ACClearAttrs_attrs__item__type._const_tab_id = 'id'
    ___ACClearAttrs_attrs__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ____ACClearAttrs_attrs__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    ____ACClearAttrs_attrs__item__values__item_._const_tab = ____ACClearAttrs_attrs__item__type_tab
    ____ACClearAttrs_attrs__item__values__item_._const_tab_at = ('..', '..', 'type')
    ____ACClearAttrs_attrs__item__values__item_._const_tab_id = 'Type'
    ___ACClearAttrs_attrs__item__values._cont = ____ACClearAttrs_attrs__item__values__item_
    ___ACClearAttrs_attrs__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    __ACClearAttrs_attrs__item_._cont = ASN1Dict([
        ('type', ___ACClearAttrs_attrs__item__type),
        ('values', ___ACClearAttrs_attrs__item__values),
        ])
    __ACClearAttrs_attrs__item_._ext = None
    _ACClearAttrs_attrs._cont = __ACClearAttrs_attrs__item_
    ACClearAttrs._cont = ASN1Dict([
        ('acIssuer', _ACClearAttrs_acIssuer),
        ('acSerial', _ACClearAttrs_acSerial),
        ('attrs', _ACClearAttrs_attrs),
        ])
    ACClearAttrs._ext = None
    
    _all_ = [
        AttributeCertExtensions,
        _AttributeCertExtensions_val_ExtnType_0,
        _AttributeCertExtensions_val_ExtnType_1,
        _AttributeCertExtensions_val_ExtnType_2,
        _AttributeCertExtensions_val_ExtnType_3,
        _AttributeCertExtensions_val_ExtnType_4,
        _AttributeCertExtensions_val_ExtnType_5,
        _AttributeCertExtensions_val_ExtnType_6,
        _AttributeCertExtensions_val_ExtnType_7,
        ext_auditIdentity,
        _ext_auditIdentity_val_ExtnType,
        ext_targetInformation,
        _ext_targetInformation_val_ExtnType,
        ext_noRevAvail,
        _ext_noRevAvail_val_ExtnType,
        ext_ac_proxying,
        _ext_ac_proxying_val_ExtnType,
        ext_aaControls,
        _ext_aaControls_val_ExtnType,
        AttributesDefined,
        _AttributesDefined_val_Type_0,
        _AttributesDefined_val_Type_1,
        _AttributesDefined_val_Type_2,
        _AttributesDefined_val_Type_3,
        _AttributesDefined_val_Type_4,
        _AttributesDefined_val_Type_5,
        _AttributesDefined_val_Type_6,
        at_authenticationInfo,
        _at_authenticationInfo_val_Type,
        at_accesIdentity,
        _at_accesIdentity_val_Type,
        at_chargingIdentity,
        _at_chargingIdentity_val_Type,
        at_group,
        _at_group_val_Type,
        at_role,
        _at_role_val_Type,
        at_clearance,
        _at_clearance_val_Type,
        at_clearance_RFC3281,
        _at_clearance_RFC3281_val_Type,
        at_encAttrs,
        _at_encAttrs_val_Type,
        id_pe_ac_auditIdentity,
        id_pe_aaControls,
        id_pe_ac_proxying,
        id_ce_targetInformation,
        id_ce_noRevAvail,
        id_aca,
        id_aca_authenticationInfo,
        id_aca_accessIdentity,
        id_aca_chargingIdentity,
        id_aca_group,
        id_aca_encAttrs,
        id_at_role,
        id_at_clearance,
        id_at_clearance_rfc3281,
        _AttributeCertificate_toBeSigned,
        ___AttributeCertificate_algorithmIdentifier_algorithm_tab,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_0,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_1,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_2,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_3,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_3,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_4,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_5,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_5,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_6,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_6,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_7,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_7,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_8,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_8,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_9,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_9,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Value_10,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_10,
        ____AttributeCertificate_algorithmIdentifier_algorithm_tab_val_Params_11,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_1,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_2,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_3,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1,
        __AttributeCertificate_algorithmIdentifier_algorithm,
        __AttributeCertificate_algorithmIdentifier_parameters,
        _AttributeCertificate_algorithmIdentifier,
        __AttributeCertificate_signature_contain,
        _AttributeCertificate_signature,
        AttributeCertificate,
        _AttributeCertificateInfo_version,
        _AttributeCertificateInfo_holder,
        _AttributeCertificateInfo_issuer,
        ___AttributeCertificateInfo_signature_algorithm_tab,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_0,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_1,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_2,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_3,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_3,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_4,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_4,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_5,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_5,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_6,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_6,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_7,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_7,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_8,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_8,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_9,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_9,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Value_10,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_10,
        ____AttributeCertificateInfo_signature_algorithm_tab_val_Params_11,
        __AttributeCertificateInfo_signature_algorithm,
        __AttributeCertificateInfo_signature_parameters,
        _AttributeCertificateInfo_signature,
        _AttributeCertificateInfo_serialNumber,
        _AttributeCertificateInfo_attrCertValidityPeriod,
        ____AttributeCertificateInfo_attributes__item__type_tab,
        _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_0,
        _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_1,
        _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_2,
        _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_3,
        _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_4,
        _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_5,
        _____AttributeCertificateInfo_attributes__item__type_tab_val_Type_6,
        ___AttributeCertificateInfo_attributes__item__type,
        ____AttributeCertificateInfo_attributes__item__values__item_,
        ___AttributeCertificateInfo_attributes__item__values,
        __AttributeCertificateInfo_attributes__item_,
        _AttributeCertificateInfo_attributes,
        _AttributeCertificateInfo_issuerUniqueID,
        ____AttributeCertificateInfo_extensions__item__extnID_tab,
        _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_0,
        _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_1,
        _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_2,
        _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_3,
        _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_4,
        _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_5,
        _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_6,
        _____AttributeCertificateInfo_extensions__item__extnID_tab_val_ExtnType_7,
        ___AttributeCertificateInfo_extensions__item__extnID,
        ___AttributeCertificateInfo_extensions__item__critical,
        ____AttributeCertificateInfo_extensions__item__extnValue_contain,
        ___AttributeCertificateInfo_extensions__item__extnValue,
        __AttributeCertificateInfo_extensions__item_,
        _AttributeCertificateInfo_extensions,
        AttributeCertificateInfo,
        AttCertVersion,
        _Holder_baseCertificateID,
        _Holder_entityName,
        _Holder_objectDigestInfo,
        Holder,
        _ObjectDigestInfo_digestedObjectType,
        _ObjectDigestInfo_otherObjectTypeID,
        ___ObjectDigestInfo_digestAlgorithm_algorithm_tab,
        __ObjectDigestInfo_digestAlgorithm_algorithm,
        ___ObjectDigestInfo_digestAlgorithm_parameters_tab,
        __ObjectDigestInfo_digestAlgorithm_parameters,
        _ObjectDigestInfo_digestAlgorithm,
        _ObjectDigestInfo_objectDigest,
        ObjectDigestInfo,
        _AttCertIssuer_v1Form,
        _AttCertIssuer_v2Form,
        AttCertIssuer,
        _V2Form_issuerName,
        _V2Form_baseCertificateID,
        _V2Form_objectDigestInfo,
        V2Form,
        _IssuerSerial_issuer,
        _IssuerSerial_serial,
        _IssuerSerial_issuerUID,
        IssuerSerial,
        _AttCertValidityPeriod_notBeforeTime,
        _AttCertValidityPeriod_notAfterTime,
        AttCertValidityPeriod,
        _Targets__item_,
        Targets,
        _Target_targetName,
        _Target_targetGroup,
        _Target_targetCert,
        Target,
        _TargetCert_targetCertificate,
        _TargetCert_targetName,
        _TargetCert_certDigestInfo,
        TargetCert,
        _AAControls_pathLenConstraint,
        _AAControls_permittedAttrs,
        _AAControls_excludedAttrs,
        _AAControls_permitUnSpecified,
        AAControls,
        _AttrSpec__item_,
        AttrSpec,
        _ProxyInfo__item_,
        ProxyInfo,
        _IetfAttrSyntax_policyAuthority,
        ___IetfAttrSyntax_values__item__octets,
        ___IetfAttrSyntax_values__item__oid,
        ___IetfAttrSyntax_values__item__string,
        __IetfAttrSyntax_values__item_,
        _IetfAttrSyntax_values,
        IetfAttrSyntax,
        _SvceAuthInfo_service,
        _SvceAuthInfo_ident,
        _SvceAuthInfo_authInfo,
        SvceAuthInfo,
        _RoleSyntax_roleAuthority,
        _RoleSyntax_roleName,
        RoleSyntax,
        _Clearance_policyId,
        _Clearance_classList,
        ____Clearance_securityCategories__item__type_tab,
        ___Clearance_securityCategories__item__type,
        ____Clearance_securityCategories__item__value_tab,
        ___Clearance_securityCategories__item__value,
        __Clearance_securityCategories__item_,
        _Clearance_securityCategories,
        Clearance,
        _Clearance_rfc3281_policyId,
        _Clearance_rfc3281_classList,
        ____Clearance_rfc3281_securityCategories__item__type_tab,
        ___Clearance_rfc3281_securityCategories__item__type,
        ____Clearance_rfc3281_securityCategories__item__value_tab,
        ___Clearance_rfc3281_securityCategories__item__value,
        __Clearance_rfc3281_securityCategories__item_,
        _Clearance_rfc3281_securityCategories,
        Clearance_rfc3281,
        ClassList,
        SupportedSecurityCategories,
        _ACClearAttrs_acIssuer,
        _ACClearAttrs_acSerial,
        ____ACClearAttrs_attrs__item__type_tab,
        _____ACClearAttrs_attrs__item__type_tab_val_Type_0,
        _____ACClearAttrs_attrs__item__type_tab_val_Type_1,
        _____ACClearAttrs_attrs__item__type_tab_val_Type_2,
        _____ACClearAttrs_attrs__item__type_tab_val_Type_3,
        _____ACClearAttrs_attrs__item__type_tab_val_Type_4,
        _____ACClearAttrs_attrs__item__type_tab_val_Type_5,
        _____ACClearAttrs_attrs__item__type_tab_val_Type_6,
        ___ACClearAttrs_attrs__item__type,
        ____ACClearAttrs_attrs__item__values__item_,
        ___ACClearAttrs_attrs__item__values,
        __ACClearAttrs_attrs__item_,
        _ACClearAttrs_attrs,
        ACClearAttrs,
    ]

class PKIXCMP_2009:

    _name_  = 'PKIXCMP-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 50]
    
    _obj_ = [
        'CMPCertificate',
        'PKIMessage',
        'PKIMessages',
        'PKIHeader',
        'PKIFreeText',
        'PKIBody',
        'PKIProtection',
        'ProtectedPart',
        'id-PasswordBasedMac',
        'PBMParameter',
        'id-DHBasedMac',
        'DHBMParameter',
        'PKIStatus',
        'PKIFailureInfo',
        'PKIStatusInfo',
        'OOBCert',
        'OOBCertHash',
        'POPODecKeyChallContent',
        'Challenge',
        'POPODecKeyRespContent',
        'CertRepMessage',
        'CertResponse',
        'CertifiedKeyPair',
        'CertOrEncCert',
        'KeyRecRepContent',
        'RevReqContent',
        'RevDetails',
        'RevRepContent',
        'CAKeyUpdAnnContent',
        'CertAnnContent',
        'RevAnnContent',
        'CRLAnnContent',
        'PKIConfirmContent',
        'NestedMessageContent',
        'INFO-TYPE-AND-VALUE',
        'InfoTypeAndValue',
        'SupportedInfoSet',
        'GenMsgContent',
        'GenRepContent',
        'ErrorMsgContent',
        'CertConfirmContent',
        'CertStatus',
        'PollReqContent',
        'PollRepContent',
        ]
    _type_ = [
        'CMPCertificate',
        'PKIMessage',
        'PKIMessages',
        'PKIHeader',
        'PKIFreeText',
        'PKIBody',
        'PKIProtection',
        'ProtectedPart',
        'PBMParameter',
        'DHBMParameter',
        'PKIStatus',
        'PKIFailureInfo',
        'PKIStatusInfo',
        'OOBCert',
        'OOBCertHash',
        'POPODecKeyChallContent',
        'Challenge',
        'POPODecKeyRespContent',
        'CertRepMessage',
        'CertResponse',
        'CertifiedKeyPair',
        'CertOrEncCert',
        'KeyRecRepContent',
        'RevReqContent',
        'RevDetails',
        'RevRepContent',
        'CAKeyUpdAnnContent',
        'CertAnnContent',
        'RevAnnContent',
        'CRLAnnContent',
        'PKIConfirmContent',
        'NestedMessageContent',
        'INFO-TYPE-AND-VALUE',
        'InfoTypeAndValue',
        'GenMsgContent',
        'GenRepContent',
        'ErrorMsgContent',
        'CertConfirmContent',
        'CertStatus',
        'PollReqContent',
        'PollRepContent',
        ]
    _set_ = [
        'SupportedInfoSet',
        ]
    _val_ = [
        'id-PasswordBasedMac',
        'id-DHBasedMac',
        ]
    _class_ = [
        'INFO-TYPE-AND-VALUE',
        'SupportedInfoSet',
        ]
    _param_ = [
        ]
    
    #-----< CMPCertificate >-----#
    CMPCertificate = CHOICE(name='CMPCertificate', mode=MODE_TYPE)
    _CMPCertificate_x509v3PKCert = SEQ(name='x509v3PKCert', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    CMPCertificate._cont = ASN1Dict([
        ('x509v3PKCert', _CMPCertificate_x509v3PKCert),
        ])
    CMPCertificate._ext = []
    
    #-----< PKIMessage >-----#
    PKIMessage = SEQ(name='PKIMessage', mode=MODE_TYPE)
    _PKIMessage_header = SEQ(name='header', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIHeader')))
    _PKIMessage_body = CHOICE(name='body', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIBody')))
    _PKIMessage_protection = BIT_STR(name='protection', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'PKIProtection')), opt=True)
    _PKIMessage_extraCerts = SEQ_OF(name='extraCerts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PKIMessage_extraCerts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CMPCertificate')))
    _PKIMessage_extraCerts._cont = __PKIMessage_extraCerts__item_
    _PKIMessage_extraCerts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PKIMessage._cont = ASN1Dict([
        ('header', _PKIMessage_header),
        ('body', _PKIMessage_body),
        ('protection', _PKIMessage_protection),
        ('extraCerts', _PKIMessage_extraCerts),
        ])
    PKIMessage._ext = None
    
    #-----< PKIMessages >-----#
    PKIMessages = SEQ_OF(name='PKIMessages', mode=MODE_TYPE)
    _PKIMessages__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIMessage')))
    PKIMessages._cont = _PKIMessages__item_
    PKIMessages._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PKIHeader >-----#
    PKIHeader = SEQ(name='PKIHeader', mode=MODE_TYPE)
    _PKIHeader_pvno = INT(name='pvno', mode=MODE_TYPE)
    _PKIHeader_pvno._cont = ASN1Dict([('cmp1999', 1), ('cmp2000', 2)])
    _PKIHeader_sender = CHOICE(name='sender', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _PKIHeader_recipient = CHOICE(name='recipient', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _PKIHeader_messageTime = TIME_GEN(name='messageTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PKIHeader_protectionAlg = SEQ(name='protectionAlg', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')), opt=True)
    __PKIHeader_protectionAlg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['id']))
    ___PKIHeader_protectionAlg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___PKIHeader_protectionAlg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __PKIHeader_protectionAlg_algorithm._const_tab = ___PKIHeader_protectionAlg_algorithm_tab
    __PKIHeader_protectionAlg_algorithm._const_tab_at = None
    __PKIHeader_protectionAlg_algorithm._const_tab_id = 'id'
    __PKIHeader_protectionAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['Params']), opt=True)
    ___PKIHeader_protectionAlg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___PKIHeader_protectionAlg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __PKIHeader_protectionAlg_parameters._const_tab = ___PKIHeader_protectionAlg_parameters_tab
    __PKIHeader_protectionAlg_parameters._const_tab_at = ('..', 'algorithm')
    __PKIHeader_protectionAlg_parameters._const_tab_id = 'Params'
    _PKIHeader_protectionAlg._cont = ASN1Dict([
        ('algorithm', __PKIHeader_protectionAlg_algorithm),
        ('parameters', __PKIHeader_protectionAlg_parameters),
        ])
    _PKIHeader_protectionAlg._ext = None
    _PKIHeader_senderKID = OCT_STR(name='senderKID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyIdentifier')), opt=True)
    _PKIHeader_recipKID = OCT_STR(name='recipKID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyIdentifier')), opt=True)
    _PKIHeader_transactionID = OCT_STR(name='transactionID', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PKIHeader_senderNonce = OCT_STR(name='senderNonce', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PKIHeader_recipNonce = OCT_STR(name='recipNonce', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PKIHeader_freeText = SEQ_OF(name='freeText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'PKIFreeText')), opt=True)
    _PKIHeader_generalInfo = SEQ_OF(name='generalInfo', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __PKIHeader_generalInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'InfoTypeAndValue')))
    _PKIHeader_generalInfo._cont = __PKIHeader_generalInfo__item_
    _PKIHeader_generalInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PKIHeader._cont = ASN1Dict([
        ('pvno', _PKIHeader_pvno),
        ('sender', _PKIHeader_sender),
        ('recipient', _PKIHeader_recipient),
        ('messageTime', _PKIHeader_messageTime),
        ('protectionAlg', _PKIHeader_protectionAlg),
        ('senderKID', _PKIHeader_senderKID),
        ('recipKID', _PKIHeader_recipKID),
        ('transactionID', _PKIHeader_transactionID),
        ('senderNonce', _PKIHeader_senderNonce),
        ('recipNonce', _PKIHeader_recipNonce),
        ('freeText', _PKIHeader_freeText),
        ('generalInfo', _PKIHeader_generalInfo),
        ])
    PKIHeader._ext = None
    
    #-----< PKIFreeText >-----#
    PKIFreeText = SEQ_OF(name='PKIFreeText', mode=MODE_TYPE)
    _PKIFreeText__item_ = STR_UTF8(name='_item_', mode=MODE_TYPE)
    PKIFreeText._cont = _PKIFreeText__item_
    PKIFreeText._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< PKIBody >-----#
    PKIBody = CHOICE(name='PKIBody', mode=MODE_TYPE)
    _PKIBody_ir = SEQ_OF(name='ir', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'CertReqMessages')))
    _PKIBody_ip = SEQ(name='ip', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'CertRepMessage')))
    _PKIBody_cr = SEQ_OF(name='cr', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'CertReqMessages')))
    _PKIBody_cp = SEQ(name='cp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'CertRepMessage')))
    _PKIBody_p10cr = SEQ(name='p10cr', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKCS-10', 'CertificationRequest')))
    _PKIBody_popdecc = SEQ_OF(name='popdecc', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'POPODecKeyChallContent')))
    _PKIBody_popdecr = SEQ_OF(name='popdecr', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'POPODecKeyRespContent')))
    _PKIBody_kur = SEQ_OF(name='kur', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'CertReqMessages')))
    _PKIBody_kup = SEQ(name='kup', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'CertRepMessage')))
    _PKIBody_krr = SEQ_OF(name='krr', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'CertReqMessages')))
    _PKIBody_krp = SEQ(name='krp', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'KeyRecRepContent')))
    _PKIBody_rr = SEQ_OF(name='rr', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'RevReqContent')))
    _PKIBody_rp = SEQ(name='rp', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'RevRepContent')))
    _PKIBody_ccr = SEQ_OF(name='ccr', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'CertReqMessages')))
    _PKIBody_ccp = SEQ(name='ccp', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'CertRepMessage')))
    _PKIBody_ckuann = SEQ(name='ckuann', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'CAKeyUpdAnnContent')))
    _PKIBody_cann = CHOICE(name='cann', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'CertAnnContent')))
    _PKIBody_rann = SEQ(name='rann', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'RevAnnContent')))
    _PKIBody_crlann = SEQ_OF(name='crlann', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'CRLAnnContent')))
    _PKIBody_pkiconf = NULL(name='pkiconf', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'PKIConfirmContent')))
    _PKIBody_nested = SEQ_OF(name='nested', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'NestedMessageContent')))
    _PKIBody_genm = SEQ_OF(name='genm', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'GenMsgContent')))
    _PKIBody_genp = SEQ_OF(name='genp', mode=MODE_TYPE, tag=(22, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'GenRepContent')))
    _PKIBody_error = SEQ(name='error', mode=MODE_TYPE, tag=(23, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'ErrorMsgContent')))
    _PKIBody_certConf = SEQ_OF(name='certConf', mode=MODE_TYPE, tag=(24, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'CertConfirmContent')))
    _PKIBody_pollReq = SEQ_OF(name='pollReq', mode=MODE_TYPE, tag=(25, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'PollReqContent')))
    _PKIBody_pollRep = SEQ_OF(name='pollRep', mode=MODE_TYPE, tag=(26, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'PollRepContent')))
    PKIBody._cont = ASN1Dict([
        ('ir', _PKIBody_ir),
        ('ip', _PKIBody_ip),
        ('cr', _PKIBody_cr),
        ('cp', _PKIBody_cp),
        ('p10cr', _PKIBody_p10cr),
        ('popdecc', _PKIBody_popdecc),
        ('popdecr', _PKIBody_popdecr),
        ('kur', _PKIBody_kur),
        ('kup', _PKIBody_kup),
        ('krr', _PKIBody_krr),
        ('krp', _PKIBody_krp),
        ('rr', _PKIBody_rr),
        ('rp', _PKIBody_rp),
        ('ccr', _PKIBody_ccr),
        ('ccp', _PKIBody_ccp),
        ('ckuann', _PKIBody_ckuann),
        ('cann', _PKIBody_cann),
        ('rann', _PKIBody_rann),
        ('crlann', _PKIBody_crlann),
        ('pkiconf', _PKIBody_pkiconf),
        ('nested', _PKIBody_nested),
        ('genm', _PKIBody_genm),
        ('genp', _PKIBody_genp),
        ('error', _PKIBody_error),
        ('certConf', _PKIBody_certConf),
        ('pollReq', _PKIBody_pollReq),
        ('pollRep', _PKIBody_pollRep),
        ])
    PKIBody._ext = None
    
    #-----< PKIProtection >-----#
    PKIProtection = BIT_STR(name='PKIProtection', mode=MODE_TYPE)
    
    #-----< ProtectedPart >-----#
    ProtectedPart = SEQ(name='ProtectedPart', mode=MODE_TYPE)
    _ProtectedPart_header = SEQ(name='header', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIHeader')))
    _ProtectedPart_body = CHOICE(name='body', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIBody')))
    ProtectedPart._cont = ASN1Dict([
        ('header', _ProtectedPart_header),
        ('body', _ProtectedPart_body),
        ])
    ProtectedPart._ext = None
    
    #-----< id-PasswordBasedMac >-----#
    id_PasswordBasedMac = OID(name='id-PasswordBasedMac', mode=MODE_VALUE)
    id_PasswordBasedMac._val = (1, 2, 840, 113533, 7, 66, 13)
    
    #-----< PBMParameter >-----#
    PBMParameter = SEQ(name='PBMParameter', mode=MODE_TYPE)
    _PBMParameter_salt = OCT_STR(name='salt', mode=MODE_TYPE)
    _PBMParameter_owf = SEQ(name='owf', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __PBMParameter_owf_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___PBMParameter_owf_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___PBMParameter_owf_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __PBMParameter_owf_algorithm._const_tab = ___PBMParameter_owf_algorithm_tab
    __PBMParameter_owf_algorithm._const_tab_at = None
    __PBMParameter_owf_algorithm._const_tab_id = 'id'
    __PBMParameter_owf_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    ___PBMParameter_owf_parameters_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___PBMParameter_owf_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __PBMParameter_owf_parameters._const_tab = ___PBMParameter_owf_parameters_tab
    __PBMParameter_owf_parameters._const_tab_at = ('..', 'algorithm')
    __PBMParameter_owf_parameters._const_tab_id = 'Params'
    _PBMParameter_owf._cont = ASN1Dict([
        ('algorithm', __PBMParameter_owf_algorithm),
        ('parameters', __PBMParameter_owf_parameters),
        ])
    _PBMParameter_owf._ext = None
    _PBMParameter_iterationCount = INT(name='iterationCount', mode=MODE_TYPE)
    _PBMParameter_mac = SEQ(name='mac', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __PBMParameter_mac_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['id']))
    ___PBMParameter_mac_algorithm_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ___PBMParameter_mac_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __PBMParameter_mac_algorithm._const_tab = ___PBMParameter_mac_algorithm_tab
    __PBMParameter_mac_algorithm._const_tab_at = None
    __PBMParameter_mac_algorithm._const_tab_id = 'id'
    __PBMParameter_mac_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['Params']), opt=True)
    ___PBMParameter_mac_parameters_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ___PBMParameter_mac_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __PBMParameter_mac_parameters._const_tab = ___PBMParameter_mac_parameters_tab
    __PBMParameter_mac_parameters._const_tab_at = ('..', 'algorithm')
    __PBMParameter_mac_parameters._const_tab_id = 'Params'
    _PBMParameter_mac._cont = ASN1Dict([
        ('algorithm', __PBMParameter_mac_algorithm),
        ('parameters', __PBMParameter_mac_parameters),
        ])
    _PBMParameter_mac._ext = None
    PBMParameter._cont = ASN1Dict([
        ('salt', _PBMParameter_salt),
        ('owf', _PBMParameter_owf),
        ('iterationCount', _PBMParameter_iterationCount),
        ('mac', _PBMParameter_mac),
        ])
    PBMParameter._ext = None
    
    #-----< id-DHBasedMac >-----#
    id_DHBasedMac = OID(name='id-DHBasedMac', mode=MODE_VALUE)
    id_DHBasedMac._val = (1, 2, 840, 113533, 7, 66, 30)
    
    #-----< DHBMParameter >-----#
    DHBMParameter = SEQ(name='DHBMParameter', mode=MODE_TYPE)
    _DHBMParameter_owf = SEQ(name='owf', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __DHBMParameter_owf_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___DHBMParameter_owf_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___DHBMParameter_owf_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __DHBMParameter_owf_algorithm._const_tab = ___DHBMParameter_owf_algorithm_tab
    __DHBMParameter_owf_algorithm._const_tab_at = None
    __DHBMParameter_owf_algorithm._const_tab_id = 'id'
    __DHBMParameter_owf_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    ___DHBMParameter_owf_parameters_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___DHBMParameter_owf_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __DHBMParameter_owf_parameters._const_tab = ___DHBMParameter_owf_parameters_tab
    __DHBMParameter_owf_parameters._const_tab_at = ('..', 'algorithm')
    __DHBMParameter_owf_parameters._const_tab_id = 'Params'
    _DHBMParameter_owf._cont = ASN1Dict([
        ('algorithm', __DHBMParameter_owf_algorithm),
        ('parameters', __DHBMParameter_owf_parameters),
        ])
    _DHBMParameter_owf._ext = None
    _DHBMParameter_mac = SEQ(name='mac', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __DHBMParameter_mac_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['id']))
    ___DHBMParameter_mac_algorithm_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ___DHBMParameter_mac_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __DHBMParameter_mac_algorithm._const_tab = ___DHBMParameter_mac_algorithm_tab
    __DHBMParameter_mac_algorithm._const_tab_at = None
    __DHBMParameter_mac_algorithm._const_tab_id = 'id'
    __DHBMParameter_mac_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['Params']), opt=True)
    ___DHBMParameter_mac_parameters_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ___DHBMParameter_mac_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __DHBMParameter_mac_parameters._const_tab = ___DHBMParameter_mac_parameters_tab
    __DHBMParameter_mac_parameters._const_tab_at = ('..', 'algorithm')
    __DHBMParameter_mac_parameters._const_tab_id = 'Params'
    _DHBMParameter_mac._cont = ASN1Dict([
        ('algorithm', __DHBMParameter_mac_algorithm),
        ('parameters', __DHBMParameter_mac_parameters),
        ])
    _DHBMParameter_mac._ext = None
    DHBMParameter._cont = ASN1Dict([
        ('owf', _DHBMParameter_owf),
        ('mac', _DHBMParameter_mac),
        ])
    DHBMParameter._ext = None
    
    #-----< PKIStatus >-----#
    PKIStatus = INT(name='PKIStatus', mode=MODE_TYPE)
    PKIStatus._cont = ASN1Dict([('accepted', 0), ('grantedWithMods', 1), ('rejection', 2), ('waiting', 3), ('revocationWarning', 4), ('revocationNotification', 5), ('keyUpdateWarning', 6)])
    
    #-----< PKIFailureInfo >-----#
    PKIFailureInfo = BIT_STR(name='PKIFailureInfo', mode=MODE_TYPE)
    PKIFailureInfo._cont = ASN1Dict([('badAlg', 0), ('badMessageCheck', 1), ('badRequest', 2), ('badTime', 3), ('badCertId', 4), ('badDataFormat', 5), ('wrongAuthority', 6), ('incorrectData', 7), ('missingTimeStamp', 8), ('badPOP', 9), ('certRevoked', 10), ('certConfirmed', 11), ('wrongIntegrity', 12), ('badRecipientNonce', 13), ('timeNotAvailable', 14), ('unacceptedPolicy', 15), ('unacceptedExtension', 16), ('addInfoNotAvailable', 17), ('badSenderNonce', 18), ('badCertTemplate', 19), ('signerNotTrusted', 20), ('transactionIdInUse', 21), ('unsupportedVersion', 22), ('notAuthorized', 23), ('systemUnavail', 24), ('systemFailure', 25), ('duplicateCertReq', 26)])
    
    #-----< PKIStatusInfo >-----#
    PKIStatusInfo = SEQ(name='PKIStatusInfo', mode=MODE_TYPE)
    _PKIStatusInfo_status = INT(name='status', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIStatus')))
    _PKIStatusInfo_statusString = SEQ_OF(name='statusString', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIFreeText')), opt=True)
    _PKIStatusInfo_failInfo = BIT_STR(name='failInfo', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIFailureInfo')), opt=True)
    PKIStatusInfo._cont = ASN1Dict([
        ('status', _PKIStatusInfo_status),
        ('statusString', _PKIStatusInfo_statusString),
        ('failInfo', _PKIStatusInfo_failInfo),
        ])
    PKIStatusInfo._ext = None
    
    #-----< OOBCert >-----#
    OOBCert = CHOICE(name='OOBCert', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CMPCertificate')))
    
    #-----< OOBCertHash >-----#
    OOBCertHash = SEQ(name='OOBCertHash', mode=MODE_TYPE)
    _OOBCertHash_hashAlg = SEQ(name='hashAlg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')), opt=True)
    __OOBCertHash_hashAlg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___OOBCertHash_hashAlg_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___OOBCertHash_hashAlg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __OOBCertHash_hashAlg_algorithm._const_tab = ___OOBCertHash_hashAlg_algorithm_tab
    __OOBCertHash_hashAlg_algorithm._const_tab_at = None
    __OOBCertHash_hashAlg_algorithm._const_tab_id = 'id'
    __OOBCertHash_hashAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    ___OOBCertHash_hashAlg_parameters_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___OOBCertHash_hashAlg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __OOBCertHash_hashAlg_parameters._const_tab = ___OOBCertHash_hashAlg_parameters_tab
    __OOBCertHash_hashAlg_parameters._const_tab_at = ('..', 'algorithm')
    __OOBCertHash_hashAlg_parameters._const_tab_id = 'Params'
    _OOBCertHash_hashAlg._cont = ASN1Dict([
        ('algorithm', __OOBCertHash_hashAlg_algorithm),
        ('parameters', __OOBCertHash_hashAlg_parameters),
        ])
    _OOBCertHash_hashAlg._ext = None
    _OOBCertHash_certId = SEQ(name='certId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'CertId')), opt=True)
    _OOBCertHash_hashVal = BIT_STR(name='hashVal', mode=MODE_TYPE)
    OOBCertHash._cont = ASN1Dict([
        ('hashAlg', _OOBCertHash_hashAlg),
        ('certId', _OOBCertHash_certId),
        ('hashVal', _OOBCertHash_hashVal),
        ])
    OOBCertHash._ext = None
    
    #-----< POPODecKeyChallContent >-----#
    POPODecKeyChallContent = SEQ_OF(name='POPODecKeyChallContent', mode=MODE_TYPE)
    _POPODecKeyChallContent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'Challenge')))
    POPODecKeyChallContent._cont = _POPODecKeyChallContent__item_
    
    #-----< Challenge >-----#
    Challenge = SEQ(name='Challenge', mode=MODE_TYPE)
    _Challenge_owf = SEQ(name='owf', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')), opt=True)
    __Challenge_owf_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___Challenge_owf_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___Challenge_owf_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __Challenge_owf_algorithm._const_tab = ___Challenge_owf_algorithm_tab
    __Challenge_owf_algorithm._const_tab_at = None
    __Challenge_owf_algorithm._const_tab_id = 'id'
    __Challenge_owf_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    ___Challenge_owf_parameters_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___Challenge_owf_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __Challenge_owf_parameters._const_tab = ___Challenge_owf_parameters_tab
    __Challenge_owf_parameters._const_tab_at = ('..', 'algorithm')
    __Challenge_owf_parameters._const_tab_id = 'Params'
    _Challenge_owf._cont = ASN1Dict([
        ('algorithm', __Challenge_owf_algorithm),
        ('parameters', __Challenge_owf_parameters),
        ])
    _Challenge_owf._ext = None
    _Challenge_witness = OCT_STR(name='witness', mode=MODE_TYPE)
    _Challenge_challenge = OCT_STR(name='challenge', mode=MODE_TYPE)
    Challenge._cont = ASN1Dict([
        ('owf', _Challenge_owf),
        ('witness', _Challenge_witness),
        ('challenge', _Challenge_challenge),
        ])
    Challenge._ext = None
    
    #-----< POPODecKeyRespContent >-----#
    POPODecKeyRespContent = SEQ_OF(name='POPODecKeyRespContent', mode=MODE_TYPE)
    _POPODecKeyRespContent__item_ = INT(name='_item_', mode=MODE_TYPE)
    POPODecKeyRespContent._cont = _POPODecKeyRespContent__item_
    
    #-----< CertRepMessage >-----#
    CertRepMessage = SEQ(name='CertRepMessage', mode=MODE_TYPE)
    _CertRepMessage_caPubs = SEQ_OF(name='caPubs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __CertRepMessage_caPubs__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CMPCertificate')))
    _CertRepMessage_caPubs._cont = __CertRepMessage_caPubs__item_
    _CertRepMessage_caPubs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _CertRepMessage_response = SEQ_OF(name='response', mode=MODE_TYPE)
    __CertRepMessage_response__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CertResponse')))
    _CertRepMessage_response._cont = __CertRepMessage_response__item_
    CertRepMessage._cont = ASN1Dict([
        ('caPubs', _CertRepMessage_caPubs),
        ('response', _CertRepMessage_response),
        ])
    CertRepMessage._ext = None
    
    #-----< CertResponse >-----#
    CertResponse = SEQ(name='CertResponse', mode=MODE_TYPE)
    _CertResponse_certReqId = INT(name='certReqId', mode=MODE_TYPE)
    _CertResponse_status = SEQ(name='status', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIStatusInfo')))
    _CertResponse_certifiedKeyPair = SEQ(name='certifiedKeyPair', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CertifiedKeyPair')), opt=True)
    _CertResponse_rspInfo = OCT_STR(name='rspInfo', mode=MODE_TYPE, opt=True)
    CertResponse._cont = ASN1Dict([
        ('certReqId', _CertResponse_certReqId),
        ('status', _CertResponse_status),
        ('certifiedKeyPair', _CertResponse_certifiedKeyPair),
        ('rspInfo', _CertResponse_rspInfo),
        ])
    CertResponse._ext = None
    
    #-----< CertifiedKeyPair >-----#
    CertifiedKeyPair = SEQ(name='CertifiedKeyPair', mode=MODE_TYPE)
    _CertifiedKeyPair_certOrEncCert = CHOICE(name='certOrEncCert', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CertOrEncCert')))
    _CertifiedKeyPair_privateKey = SEQ(name='privateKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'EncryptedValue')), opt=True)
    _CertifiedKeyPair_publicationInfo = SEQ(name='publicationInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'PKIPublicationInfo')), opt=True)
    CertifiedKeyPair._cont = ASN1Dict([
        ('certOrEncCert', _CertifiedKeyPair_certOrEncCert),
        ('privateKey', _CertifiedKeyPair_privateKey),
        ('publicationInfo', _CertifiedKeyPair_publicationInfo),
        ])
    CertifiedKeyPair._ext = None
    
    #-----< CertOrEncCert >-----#
    CertOrEncCert = CHOICE(name='CertOrEncCert', mode=MODE_TYPE)
    _CertOrEncCert_certificate = CHOICE(name='certificate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'CMPCertificate')))
    _CertOrEncCert_encryptedCert = SEQ(name='encryptedCert', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'EncryptedValue')))
    CertOrEncCert._cont = ASN1Dict([
        ('certificate', _CertOrEncCert_certificate),
        ('encryptedCert', _CertOrEncCert_encryptedCert),
        ])
    CertOrEncCert._ext = None
    
    #-----< KeyRecRepContent >-----#
    KeyRecRepContent = SEQ(name='KeyRecRepContent', mode=MODE_TYPE)
    _KeyRecRepContent_status = SEQ(name='status', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIStatusInfo')))
    _KeyRecRepContent_newSigCert = CHOICE(name='newSigCert', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIXCMP-2009', 'CMPCertificate')), opt=True)
    _KeyRecRepContent_caCerts = SEQ_OF(name='caCerts', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __KeyRecRepContent_caCerts__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CMPCertificate')))
    _KeyRecRepContent_caCerts._cont = __KeyRecRepContent_caCerts__item_
    _KeyRecRepContent_caCerts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _KeyRecRepContent_keyPairHist = SEQ_OF(name='keyPairHist', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __KeyRecRepContent_keyPairHist__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CertifiedKeyPair')))
    _KeyRecRepContent_keyPairHist._cont = __KeyRecRepContent_keyPairHist__item_
    _KeyRecRepContent_keyPairHist._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    KeyRecRepContent._cont = ASN1Dict([
        ('status', _KeyRecRepContent_status),
        ('newSigCert', _KeyRecRepContent_newSigCert),
        ('caCerts', _KeyRecRepContent_caCerts),
        ('keyPairHist', _KeyRecRepContent_keyPairHist),
        ])
    KeyRecRepContent._ext = None
    
    #-----< RevReqContent >-----#
    RevReqContent = SEQ_OF(name='RevReqContent', mode=MODE_TYPE)
    _RevReqContent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'RevDetails')))
    RevReqContent._cont = _RevReqContent__item_
    
    #-----< RevDetails >-----#
    RevDetails = SEQ(name='RevDetails', mode=MODE_TYPE)
    _RevDetails_certDetails = SEQ(name='certDetails', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertTemplate')))
    _RevDetails_crlEntryDetails = SEQ_OF(name='crlEntryDetails', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __RevDetails_crlEntryDetails__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___RevDetails_crlEntryDetails__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____RevDetails_crlEntryDetails__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    ____RevDetails_crlEntryDetails__item__extnID_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    ___RevDetails_crlEntryDetails__item__extnID._const_tab = ____RevDetails_crlEntryDetails__item__extnID_tab
    ___RevDetails_crlEntryDetails__item__extnID._const_tab_at = None
    ___RevDetails_crlEntryDetails__item__extnID._const_tab_id = 'id'
    ___RevDetails_crlEntryDetails__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___RevDetails_crlEntryDetails__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____RevDetails_crlEntryDetails__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    _____RevDetails_crlEntryDetails__item__extnValue_contain_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____RevDetails_crlEntryDetails__item__extnValue_contain_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    ____RevDetails_crlEntryDetails__item__extnValue_contain._const_tab = _____RevDetails_crlEntryDetails__item__extnValue_contain_tab
    ____RevDetails_crlEntryDetails__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____RevDetails_crlEntryDetails__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___RevDetails_crlEntryDetails__item__extnValue._const_cont = ____RevDetails_crlEntryDetails__item__extnValue_contain
    __RevDetails_crlEntryDetails__item_._cont = ASN1Dict([
        ('extnID', ___RevDetails_crlEntryDetails__item__extnID),
        ('critical', ___RevDetails_crlEntryDetails__item__critical),
        ('extnValue', ___RevDetails_crlEntryDetails__item__extnValue),
        ])
    __RevDetails_crlEntryDetails__item_._ext = None
    _RevDetails_crlEntryDetails._cont = __RevDetails_crlEntryDetails__item_
    _RevDetails_crlEntryDetails._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    RevDetails._cont = ASN1Dict([
        ('certDetails', _RevDetails_certDetails),
        ('crlEntryDetails', _RevDetails_crlEntryDetails),
        ])
    RevDetails._ext = None
    
    #-----< RevRepContent >-----#
    RevRepContent = SEQ(name='RevRepContent', mode=MODE_TYPE)
    _RevRepContent_status = SEQ_OF(name='status', mode=MODE_TYPE)
    __RevRepContent_status__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIStatusInfo')))
    _RevRepContent_status._cont = __RevRepContent_status__item_
    _RevRepContent_status._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _RevRepContent_revCerts = SEQ_OF(name='revCerts', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RevRepContent_revCerts__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertId')))
    _RevRepContent_revCerts._cont = __RevRepContent_revCerts__item_
    _RevRepContent_revCerts._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _RevRepContent_crls = SEQ_OF(name='crls', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __RevRepContent_crls__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateList')))
    _RevRepContent_crls._cont = __RevRepContent_crls__item_
    _RevRepContent_crls._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    RevRepContent._cont = ASN1Dict([
        ('status', _RevRepContent_status),
        ('revCerts', _RevRepContent_revCerts),
        ('crls', _RevRepContent_crls),
        ])
    RevRepContent._ext = None
    
    #-----< CAKeyUpdAnnContent >-----#
    CAKeyUpdAnnContent = SEQ(name='CAKeyUpdAnnContent', mode=MODE_TYPE)
    _CAKeyUpdAnnContent_oldWithNew = CHOICE(name='oldWithNew', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CMPCertificate')))
    _CAKeyUpdAnnContent_newWithOld = CHOICE(name='newWithOld', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CMPCertificate')))
    _CAKeyUpdAnnContent_newWithNew = CHOICE(name='newWithNew', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CMPCertificate')))
    CAKeyUpdAnnContent._cont = ASN1Dict([
        ('oldWithNew', _CAKeyUpdAnnContent_oldWithNew),
        ('newWithOld', _CAKeyUpdAnnContent_newWithOld),
        ('newWithNew', _CAKeyUpdAnnContent_newWithNew),
        ])
    CAKeyUpdAnnContent._ext = None
    
    #-----< CertAnnContent >-----#
    CertAnnContent = CHOICE(name='CertAnnContent', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CMPCertificate')))
    
    #-----< RevAnnContent >-----#
    RevAnnContent = SEQ(name='RevAnnContent', mode=MODE_TYPE)
    _RevAnnContent_status = INT(name='status', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIStatus')))
    _RevAnnContent_certId = SEQ(name='certId', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertId')))
    _RevAnnContent_willBeRevokedAt = TIME_GEN(name='willBeRevokedAt', mode=MODE_TYPE)
    _RevAnnContent_badSinceDate = TIME_GEN(name='badSinceDate', mode=MODE_TYPE)
    _RevAnnContent_crlDetails = SEQ_OF(name='crlDetails', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __RevAnnContent_crlDetails__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___RevAnnContent_crlDetails__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____RevAnnContent_crlDetails__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    ____RevAnnContent_crlDetails__item__extnID_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    ___RevAnnContent_crlDetails__item__extnID._const_tab = ____RevAnnContent_crlDetails__item__extnID_tab
    ___RevAnnContent_crlDetails__item__extnID._const_tab_at = None
    ___RevAnnContent_crlDetails__item__extnID._const_tab_id = 'id'
    ___RevAnnContent_crlDetails__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___RevAnnContent_crlDetails__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____RevAnnContent_crlDetails__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    _____RevAnnContent_crlDetails__item__extnValue_contain_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____RevAnnContent_crlDetails__item__extnValue_contain_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    ____RevAnnContent_crlDetails__item__extnValue_contain._const_tab = _____RevAnnContent_crlDetails__item__extnValue_contain_tab
    ____RevAnnContent_crlDetails__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____RevAnnContent_crlDetails__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___RevAnnContent_crlDetails__item__extnValue._const_cont = ____RevAnnContent_crlDetails__item__extnValue_contain
    __RevAnnContent_crlDetails__item_._cont = ASN1Dict([
        ('extnID', ___RevAnnContent_crlDetails__item__extnID),
        ('critical', ___RevAnnContent_crlDetails__item__critical),
        ('extnValue', ___RevAnnContent_crlDetails__item__extnValue),
        ])
    __RevAnnContent_crlDetails__item_._ext = None
    _RevAnnContent_crlDetails._cont = __RevAnnContent_crlDetails__item_
    _RevAnnContent_crlDetails._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    RevAnnContent._cont = ASN1Dict([
        ('status', _RevAnnContent_status),
        ('certId', _RevAnnContent_certId),
        ('willBeRevokedAt', _RevAnnContent_willBeRevokedAt),
        ('badSinceDate', _RevAnnContent_badSinceDate),
        ('crlDetails', _RevAnnContent_crlDetails),
        ])
    RevAnnContent._ext = None
    
    #-----< CRLAnnContent >-----#
    CRLAnnContent = SEQ_OF(name='CRLAnnContent', mode=MODE_TYPE)
    _CRLAnnContent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateList')))
    CRLAnnContent._cont = _CRLAnnContent__item_
    
    #-----< PKIConfirmContent >-----#
    PKIConfirmContent = NULL(name='PKIConfirmContent', mode=MODE_TYPE)
    
    #-----< NestedMessageContent >-----#
    NestedMessageContent = SEQ_OF(name='NestedMessageContent', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIMessages')))
    
    #-----< INFO-TYPE-AND-VALUE >-----#
    INFO_TYPE_AND_VALUE = CLASS(name='INFO-TYPE-AND-VALUE', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< InfoTypeAndValue >-----#
    InfoTypeAndValue = SEQ(name='InfoTypeAndValue', mode=MODE_TYPE)
    _InfoTypeAndValue_infoType = OID(name='infoType', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIXCMP-2009', 'INFO-TYPE-AND-VALUE'), ['id']))
    __InfoTypeAndValue_infoType_tab = CLASS(name='_tab_INFO-TYPE-AND-VALUE', mode=MODE_SET, typeref=ASN1RefType(('PKIXCMP-2009', 'INFO-TYPE-AND-VALUE')))
    __InfoTypeAndValue_infoType_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _InfoTypeAndValue_infoType._const_tab = __InfoTypeAndValue_infoType_tab
    _InfoTypeAndValue_infoType._const_tab_at = None
    _InfoTypeAndValue_infoType._const_tab_id = 'id'
    _InfoTypeAndValue_infoValue = OPEN(name='infoValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIXCMP-2009', 'INFO-TYPE-AND-VALUE'), ['Type']))
    __InfoTypeAndValue_infoValue_tab = CLASS(name='_tab_INFO-TYPE-AND-VALUE', mode=MODE_SET, typeref=ASN1RefType(('PKIXCMP-2009', 'INFO-TYPE-AND-VALUE')))
    __InfoTypeAndValue_infoValue_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    _InfoTypeAndValue_infoValue._const_tab = __InfoTypeAndValue_infoValue_tab
    _InfoTypeAndValue_infoValue._const_tab_at = ('..', 'infoType')
    _InfoTypeAndValue_infoValue._const_tab_id = 'Type'
    InfoTypeAndValue._cont = ASN1Dict([
        ('infoType', _InfoTypeAndValue_infoType),
        ('infoValue', _InfoTypeAndValue_infoValue),
        ])
    InfoTypeAndValue._ext = None
    
    #-----< SupportedInfoSet >-----#
    SupportedInfoSet = CLASS(name='SupportedInfoSet', mode=MODE_SET, typeref=ASN1RefType(('PKIXCMP-2009', 'INFO-TYPE-AND-VALUE')))
    SupportedInfoSet._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< GenMsgContent >-----#
    GenMsgContent = SEQ_OF(name='GenMsgContent', mode=MODE_TYPE)
    _GenMsgContent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'InfoTypeAndValue')))
    GenMsgContent._cont = _GenMsgContent__item_
    
    #-----< GenRepContent >-----#
    GenRepContent = SEQ_OF(name='GenRepContent', mode=MODE_TYPE)
    _GenRepContent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'InfoTypeAndValue')))
    GenRepContent._cont = _GenRepContent__item_
    
    #-----< ErrorMsgContent >-----#
    ErrorMsgContent = SEQ(name='ErrorMsgContent', mode=MODE_TYPE)
    _ErrorMsgContent_pKIStatusInfo = SEQ(name='pKIStatusInfo', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIStatusInfo')))
    _ErrorMsgContent_errorCode = INT(name='errorCode', mode=MODE_TYPE, opt=True)
    _ErrorMsgContent_errorDetails = SEQ_OF(name='errorDetails', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIFreeText')), opt=True)
    ErrorMsgContent._cont = ASN1Dict([
        ('pKIStatusInfo', _ErrorMsgContent_pKIStatusInfo),
        ('errorCode', _ErrorMsgContent_errorCode),
        ('errorDetails', _ErrorMsgContent_errorDetails),
        ])
    ErrorMsgContent._ext = None
    
    #-----< CertConfirmContent >-----#
    CertConfirmContent = SEQ_OF(name='CertConfirmContent', mode=MODE_TYPE)
    _CertConfirmContent__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'CertStatus')))
    CertConfirmContent._cont = _CertConfirmContent__item_
    
    #-----< CertStatus >-----#
    CertStatus = SEQ(name='CertStatus', mode=MODE_TYPE)
    _CertStatus_certHash = OCT_STR(name='certHash', mode=MODE_TYPE)
    _CertStatus_certReqId = INT(name='certReqId', mode=MODE_TYPE)
    _CertStatus_statusInfo = SEQ(name='statusInfo', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIStatusInfo')), opt=True)
    CertStatus._cont = ASN1Dict([
        ('certHash', _CertStatus_certHash),
        ('certReqId', _CertStatus_certReqId),
        ('statusInfo', _CertStatus_statusInfo),
        ])
    CertStatus._ext = None
    
    #-----< PollReqContent >-----#
    PollReqContent = SEQ_OF(name='PollReqContent', mode=MODE_TYPE)
    _PollReqContent__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PollReqContent__item__certReqId = INT(name='certReqId', mode=MODE_TYPE)
    _PollReqContent__item_._cont = ASN1Dict([
        ('certReqId', __PollReqContent__item__certReqId),
        ])
    _PollReqContent__item_._ext = None
    PollReqContent._cont = _PollReqContent__item_
    
    #-----< PollRepContent >-----#
    PollRepContent = SEQ_OF(name='PollRepContent', mode=MODE_TYPE)
    _PollRepContent__item_ = SEQ(name='_item_', mode=MODE_TYPE)
    __PollRepContent__item__certReqId = INT(name='certReqId', mode=MODE_TYPE)
    __PollRepContent__item__checkAfter = INT(name='checkAfter', mode=MODE_TYPE)
    __PollRepContent__item__reason = SEQ_OF(name='reason', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCMP-2009', 'PKIFreeText')), opt=True)
    _PollRepContent__item_._cont = ASN1Dict([
        ('certReqId', __PollRepContent__item__certReqId),
        ('checkAfter', __PollRepContent__item__checkAfter),
        ('reason', __PollRepContent__item__reason),
        ])
    _PollRepContent__item_._ext = None
    PollRepContent._cont = _PollRepContent__item_
    
    _all_ = [
        _CMPCertificate_x509v3PKCert,
        CMPCertificate,
        _PKIMessage_header,
        _PKIMessage_body,
        _PKIMessage_protection,
        __PKIMessage_extraCerts__item_,
        _PKIMessage_extraCerts,
        PKIMessage,
        _PKIMessages__item_,
        PKIMessages,
        _PKIHeader_pvno,
        _PKIHeader_sender,
        _PKIHeader_recipient,
        _PKIHeader_messageTime,
        ___PKIHeader_protectionAlg_algorithm_tab,
        __PKIHeader_protectionAlg_algorithm,
        ___PKIHeader_protectionAlg_parameters_tab,
        __PKIHeader_protectionAlg_parameters,
        _PKIHeader_protectionAlg,
        _PKIHeader_senderKID,
        _PKIHeader_recipKID,
        _PKIHeader_transactionID,
        _PKIHeader_senderNonce,
        _PKIHeader_recipNonce,
        _PKIHeader_freeText,
        __PKIHeader_generalInfo__item_,
        _PKIHeader_generalInfo,
        PKIHeader,
        _PKIFreeText__item_,
        PKIFreeText,
        _PKIBody_ir,
        _PKIBody_ip,
        _PKIBody_cr,
        _PKIBody_cp,
        _PKIBody_p10cr,
        _PKIBody_popdecc,
        _PKIBody_popdecr,
        _PKIBody_kur,
        _PKIBody_kup,
        _PKIBody_krr,
        _PKIBody_krp,
        _PKIBody_rr,
        _PKIBody_rp,
        _PKIBody_ccr,
        _PKIBody_ccp,
        _PKIBody_ckuann,
        _PKIBody_cann,
        _PKIBody_rann,
        _PKIBody_crlann,
        _PKIBody_pkiconf,
        _PKIBody_nested,
        _PKIBody_genm,
        _PKIBody_genp,
        _PKIBody_error,
        _PKIBody_certConf,
        _PKIBody_pollReq,
        _PKIBody_pollRep,
        PKIBody,
        PKIProtection,
        _ProtectedPart_header,
        _ProtectedPart_body,
        ProtectedPart,
        id_PasswordBasedMac,
        _PBMParameter_salt,
        ___PBMParameter_owf_algorithm_tab,
        __PBMParameter_owf_algorithm,
        ___PBMParameter_owf_parameters_tab,
        __PBMParameter_owf_parameters,
        _PBMParameter_owf,
        _PBMParameter_iterationCount,
        ___PBMParameter_mac_algorithm_tab,
        __PBMParameter_mac_algorithm,
        ___PBMParameter_mac_parameters_tab,
        __PBMParameter_mac_parameters,
        _PBMParameter_mac,
        PBMParameter,
        id_DHBasedMac,
        ___DHBMParameter_owf_algorithm_tab,
        __DHBMParameter_owf_algorithm,
        ___DHBMParameter_owf_parameters_tab,
        __DHBMParameter_owf_parameters,
        _DHBMParameter_owf,
        ___DHBMParameter_mac_algorithm_tab,
        __DHBMParameter_mac_algorithm,
        ___DHBMParameter_mac_parameters_tab,
        __DHBMParameter_mac_parameters,
        _DHBMParameter_mac,
        DHBMParameter,
        PKIStatus,
        PKIFailureInfo,
        _PKIStatusInfo_status,
        _PKIStatusInfo_statusString,
        _PKIStatusInfo_failInfo,
        PKIStatusInfo,
        OOBCert,
        ___OOBCertHash_hashAlg_algorithm_tab,
        __OOBCertHash_hashAlg_algorithm,
        ___OOBCertHash_hashAlg_parameters_tab,
        __OOBCertHash_hashAlg_parameters,
        _OOBCertHash_hashAlg,
        _OOBCertHash_certId,
        _OOBCertHash_hashVal,
        OOBCertHash,
        _POPODecKeyChallContent__item_,
        POPODecKeyChallContent,
        ___Challenge_owf_algorithm_tab,
        __Challenge_owf_algorithm,
        ___Challenge_owf_parameters_tab,
        __Challenge_owf_parameters,
        _Challenge_owf,
        _Challenge_witness,
        _Challenge_challenge,
        Challenge,
        _POPODecKeyRespContent__item_,
        POPODecKeyRespContent,
        __CertRepMessage_caPubs__item_,
        _CertRepMessage_caPubs,
        __CertRepMessage_response__item_,
        _CertRepMessage_response,
        CertRepMessage,
        _CertResponse_certReqId,
        _CertResponse_status,
        _CertResponse_certifiedKeyPair,
        _CertResponse_rspInfo,
        CertResponse,
        _CertifiedKeyPair_certOrEncCert,
        _CertifiedKeyPair_privateKey,
        _CertifiedKeyPair_publicationInfo,
        CertifiedKeyPair,
        _CertOrEncCert_certificate,
        _CertOrEncCert_encryptedCert,
        CertOrEncCert,
        _KeyRecRepContent_status,
        _KeyRecRepContent_newSigCert,
        __KeyRecRepContent_caCerts__item_,
        _KeyRecRepContent_caCerts,
        __KeyRecRepContent_keyPairHist__item_,
        _KeyRecRepContent_keyPairHist,
        KeyRecRepContent,
        _RevReqContent__item_,
        RevReqContent,
        _RevDetails_certDetails,
        ____RevDetails_crlEntryDetails__item__extnID_tab,
        ___RevDetails_crlEntryDetails__item__extnID,
        ___RevDetails_crlEntryDetails__item__critical,
        _____RevDetails_crlEntryDetails__item__extnValue_contain_tab,
        ____RevDetails_crlEntryDetails__item__extnValue_contain,
        ___RevDetails_crlEntryDetails__item__extnValue,
        __RevDetails_crlEntryDetails__item_,
        _RevDetails_crlEntryDetails,
        RevDetails,
        __RevRepContent_status__item_,
        _RevRepContent_status,
        __RevRepContent_revCerts__item_,
        _RevRepContent_revCerts,
        __RevRepContent_crls__item_,
        _RevRepContent_crls,
        RevRepContent,
        _CAKeyUpdAnnContent_oldWithNew,
        _CAKeyUpdAnnContent_newWithOld,
        _CAKeyUpdAnnContent_newWithNew,
        CAKeyUpdAnnContent,
        CertAnnContent,
        _RevAnnContent_status,
        _RevAnnContent_certId,
        _RevAnnContent_willBeRevokedAt,
        _RevAnnContent_badSinceDate,
        ____RevAnnContent_crlDetails__item__extnID_tab,
        ___RevAnnContent_crlDetails__item__extnID,
        ___RevAnnContent_crlDetails__item__critical,
        _____RevAnnContent_crlDetails__item__extnValue_contain_tab,
        ____RevAnnContent_crlDetails__item__extnValue_contain,
        ___RevAnnContent_crlDetails__item__extnValue,
        __RevAnnContent_crlDetails__item_,
        _RevAnnContent_crlDetails,
        RevAnnContent,
        _CRLAnnContent__item_,
        CRLAnnContent,
        PKIConfirmContent,
        NestedMessageContent,
        INFO_TYPE_AND_VALUE,
        __InfoTypeAndValue_infoType_tab,
        _InfoTypeAndValue_infoType,
        __InfoTypeAndValue_infoValue_tab,
        _InfoTypeAndValue_infoValue,
        InfoTypeAndValue,
        SupportedInfoSet,
        _GenMsgContent__item_,
        GenMsgContent,
        _GenRepContent__item_,
        GenRepContent,
        _ErrorMsgContent_pKIStatusInfo,
        _ErrorMsgContent_errorCode,
        _ErrorMsgContent_errorDetails,
        ErrorMsgContent,
        _CertConfirmContent__item_,
        CertConfirmContent,
        _CertStatus_certHash,
        _CertStatus_certReqId,
        _CertStatus_statusInfo,
        CertStatus,
        __PollReqContent__item__certReqId,
        _PollReqContent__item_,
        PollReqContent,
        __PollRepContent__item__certReqId,
        __PollRepContent__item__checkAfter,
        __PollRepContent__item__reason,
        _PollRepContent__item_,
        PollRepContent,
    ]

class PKIX_CommonTypes_2009:

    _name_  = 'PKIX-CommonTypes-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 57]
    
    _obj_ = [
        'ATTRIBUTE',
        'MATCHING-RULE',
        'AttributeSet',
        'SingleAttribute',
        'EXTENSION',
        'Extensions',
        'Extension',
        'SECURITY-CATEGORY',
        'SecurityCategory',
        ]
    _type_ = [
        'ATTRIBUTE',
        'MATCHING-RULE',
        'AttributeSet',
        'SingleAttribute',
        'EXTENSION',
        'Extensions',
        'Extension',
        'SECURITY-CATEGORY',
        'SecurityCategory',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        'ATTRIBUTE',
        'MATCHING-RULE',
        'EXTENSION',
        'SECURITY-CATEGORY',
        ]
    _param_ = [
        'AttributeSet',
        'SingleAttribute',
        'Extensions',
        'Extension',
        'SecurityCategory',
        ]
    
    #-----< ATTRIBUTE >-----#
    ATTRIBUTE = CLASS(name='ATTRIBUTE', mode=MODE_TYPE)
    _ATTRIBUTE_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _ATTRIBUTE_Type = OPEN(name='Type', mode=MODE_TYPE, opt=True)
    _ATTRIBUTE_equality_match = CLASS(name='equality-match', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'MATCHING-RULE')), opt=True)
    _ATTRIBUTE_minCount = INT(name='minCount', mode=MODE_VALUE, default=1)
    _ATTRIBUTE_maxCount = INT(name='maxCount', mode=MODE_VALUE, opt=True)
    ATTRIBUTE._cont = ASN1Dict([
        ('id', _ATTRIBUTE_id),
        ('Type', _ATTRIBUTE_Type),
        ('equality-match', _ATTRIBUTE_equality_match),
        ('minCount', _ATTRIBUTE_minCount),
        ('maxCount', _ATTRIBUTE_maxCount),
        ])
    
    #-----< MATCHING-RULE >-----#
    MATCHING_RULE = CLASS(name='MATCHING-RULE', mode=MODE_TYPE)
    _MATCHING_RULE_ParentMatchingRules = CLASS(name='ParentMatchingRules', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'MATCHING-RULE')), opt=True)
    _MATCHING_RULE_AssertionType = OPEN(name='AssertionType', mode=MODE_TYPE, opt=True)
    _MATCHING_RULE_uniqueMatchIndicator = CLASS(name='uniqueMatchIndicator', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')), opt=True)
    _MATCHING_RULE_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    MATCHING_RULE._cont = ASN1Dict([
        ('ParentMatchingRules', _MATCHING_RULE_ParentMatchingRules),
        ('AssertionType', _MATCHING_RULE_AssertionType),
        ('uniqueMatchIndicator', _MATCHING_RULE_uniqueMatchIndicator),
        ('id', _MATCHING_RULE_id),
        ])
    
    #-----< AttributeSet >-----#
    AttributeSet = SEQ(name='AttributeSet', mode=MODE_TYPE, param=True)
    
    #-----< SingleAttribute >-----#
    SingleAttribute = SEQ(name='SingleAttribute', mode=MODE_TYPE, param=True)
    
    #-----< EXTENSION >-----#
    EXTENSION = CLASS(name='EXTENSION', mode=MODE_TYPE)
    _EXTENSION_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _EXTENSION_ExtnType = OPEN(name='ExtnType', mode=MODE_TYPE)
    _EXTENSION_Critical = BOOL(name='Critical', mode=MODE_SET, default=ASN1Set(rv=[True, False], rr=[], ev=None, er=[]))
    EXTENSION._cont = ASN1Dict([
        ('id', _EXTENSION_id),
        ('ExtnType', _EXTENSION_ExtnType),
        ('Critical', _EXTENSION_Critical),
        ])
    
    #-----< Extensions >-----#
    Extensions = SEQ_OF(name='Extensions', mode=MODE_TYPE, param=True)
    
    #-----< Extension >-----#
    Extension = SEQ(name='Extension', mode=MODE_TYPE, param=True)
    
    #-----< SECURITY-CATEGORY >-----#
    SECURITY_CATEGORY = CLASS(name='SECURITY-CATEGORY', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< SecurityCategory >-----#
    SecurityCategory = SEQ(name='SecurityCategory', mode=MODE_TYPE, param=True)
    
    _all_ = [
        _ATTRIBUTE_id,
        _ATTRIBUTE_Type,
        _ATTRIBUTE_equality_match,
        _ATTRIBUTE_minCount,
        _ATTRIBUTE_maxCount,
        ATTRIBUTE,
        _MATCHING_RULE_ParentMatchingRules,
        _MATCHING_RULE_AssertionType,
        _MATCHING_RULE_uniqueMatchIndicator,
        _MATCHING_RULE_id,
        MATCHING_RULE,
        _EXTENSION_id,
        _EXTENSION_ExtnType,
        _EXTENSION_Critical,
        EXTENSION,
        SECURITY_CATEGORY,
    ]

class PKIXCRMF_2009:

    _name_  = 'PKIXCRMF-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 55]
    
    _obj_ = [
        'id-pkip',
        'id-smime',
        'id-ct',
        'CertReqMessages',
        'CertReqMsg',
        'CertRequest',
        'CertTemplate',
        'OptionalValidity',
        'Controls',
        'ProofOfPossession',
        'POPOSigningKey',
        'POPOSigningKeyInput',
        'PKMACValue',
        'id-PasswordBasedMac',
        'Password-MACAlgorithms',
        'PBMParameter',
        'DigestAlgorithms',
        'MACAlgorithms',
        'POPOPrivKey',
        'SubsequentMessage',
        'ct-encKeyWithID',
        'id-ct-encKeyWithID',
        'EncKeyWithID',
        'PrivateKeyInfo',
        'Attributes',
        'PrivateKeyAttributes',
        'id-regCtrl',
        'RegControlSet',
        'regCtrl-regToken',
        'id-regCtrl-regToken',
        'RegToken',
        'regCtrl-authenticator',
        'id-regCtrl-authenticator',
        'Authenticator',
        'regCtrl-pkiPublicationInfo',
        'id-regCtrl-pkiPublicationInfo',
        'PKIPublicationInfo',
        'SinglePubInfo',
        'regCtrl-pkiArchiveOptions',
        'id-regCtrl-pkiArchiveOptions',
        'PKIArchiveOptions',
        'EncryptedKey',
        'EncryptedValue',
        'KeyGenParameters',
        'regCtrl-oldCertID',
        'id-regCtrl-oldCertID',
        'OldCertId',
        'CertId',
        'regCtrl-protocolEncrKey',
        'id-regCtrl-protocolEncrKey',
        'ProtocolEncrKey',
        'id-regInfo',
        'RegInfoSet',
        'regInfo-utf8Pairs',
        'id-regInfo-utf8Pairs',
        'UTF8Pairs',
        'regInfo-certReq',
        'id-regInfo-certReq',
        'CertReq',
        ]
    _type_ = [
        'CertReqMessages',
        'CertReqMsg',
        'CertRequest',
        'CertTemplate',
        'OptionalValidity',
        'Controls',
        'ProofOfPossession',
        'POPOSigningKey',
        'POPOSigningKeyInput',
        'PKMACValue',
        'PBMParameter',
        'POPOPrivKey',
        'SubsequentMessage',
        'EncKeyWithID',
        'PrivateKeyInfo',
        'Attributes',
        'RegToken',
        'Authenticator',
        'PKIPublicationInfo',
        'SinglePubInfo',
        'PKIArchiveOptions',
        'EncryptedKey',
        'EncryptedValue',
        'KeyGenParameters',
        'OldCertId',
        'CertId',
        'ProtocolEncrKey',
        'UTF8Pairs',
        'CertReq',
        ]
    _set_ = [
        'Password-MACAlgorithms',
        'DigestAlgorithms',
        'MACAlgorithms',
        'PrivateKeyAttributes',
        'RegControlSet',
        'RegInfoSet',
        ]
    _val_ = [
        'id-pkip',
        'id-smime',
        'id-ct',
        'id-PasswordBasedMac',
        'ct-encKeyWithID',
        'id-ct-encKeyWithID',
        'id-regCtrl',
        'regCtrl-regToken',
        'id-regCtrl-regToken',
        'regCtrl-authenticator',
        'id-regCtrl-authenticator',
        'regCtrl-pkiPublicationInfo',
        'id-regCtrl-pkiPublicationInfo',
        'regCtrl-pkiArchiveOptions',
        'id-regCtrl-pkiArchiveOptions',
        'regCtrl-oldCertID',
        'id-regCtrl-oldCertID',
        'regCtrl-protocolEncrKey',
        'id-regCtrl-protocolEncrKey',
        'id-regInfo',
        'regInfo-utf8Pairs',
        'id-regInfo-utf8Pairs',
        'regInfo-certReq',
        'id-regInfo-certReq',
        ]
    _class_ = [
        'Password-MACAlgorithms',
        'DigestAlgorithms',
        'MACAlgorithms',
        'ct-encKeyWithID',
        'PrivateKeyAttributes',
        'RegControlSet',
        'regCtrl-regToken',
        'regCtrl-authenticator',
        'regCtrl-pkiPublicationInfo',
        'regCtrl-pkiArchiveOptions',
        'regCtrl-oldCertID',
        'regCtrl-protocolEncrKey',
        'RegInfoSet',
        'regInfo-utf8Pairs',
        'regInfo-certReq',
        ]
    _param_ = [
        ]
    
    #-----< id-pkip >-----#
    id_pkip = OID(name='id-pkip', mode=MODE_VALUE)
    id_pkip._val = (1, 3, 6, 1, 5, 5, 7, 5)
    
    #-----< id-smime >-----#
    id_smime = OID(name='id-smime', mode=MODE_VALUE)
    id_smime._val = (1, 2, 840, 113549, 1, 9, 16)
    
    #-----< id-ct >-----#
    id_ct = OID(name='id-ct', mode=MODE_VALUE)
    id_ct._val = (1, 2, 840, 113549, 1, 9, 16, 1)
    
    #-----< CertReqMessages >-----#
    CertReqMessages = SEQ_OF(name='CertReqMessages', mode=MODE_TYPE)
    _CertReqMessages__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertReqMsg')))
    CertReqMessages._cont = _CertReqMessages__item_
    CertReqMessages._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertReqMsg >-----#
    CertReqMsg = SEQ(name='CertReqMsg', mode=MODE_TYPE)
    _CertReqMsg_certReq = SEQ(name='certReq', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertRequest')))
    _CertReqMsg_popo = CHOICE(name='popo', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'ProofOfPossession')), opt=True)
    _CertReqMsg_regInfo = SEQ_OF(name='regInfo', mode=MODE_TYPE, opt=True)
    __CertReqMsg_regInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'SingleAttribute')))
    ___CertReqMsg_regInfo__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ____CertReqMsg_regInfo__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _____CertReqMsg_regInfo__item__type_tab_val_Type_0 = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'UTF8Pairs')))
    _____CertReqMsg_regInfo__item__type_tab_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertReq')))
    ____CertReqMsg_regInfo__item__type_tab._val = ASN1Set(rv=[dict([('Type', _____CertReqMsg_regInfo__item__type_tab_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 2, 1))]), dict([('Type', _____CertReqMsg_regInfo__item__type_tab_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 2, 2))])], rr=[], ev=None, er=[])
    ___CertReqMsg_regInfo__item__type._const_tab = ____CertReqMsg_regInfo__item__type_tab
    ___CertReqMsg_regInfo__item__type._const_tab_at = None
    ___CertReqMsg_regInfo__item__type._const_tab_id = 'id'
    ___CertReqMsg_regInfo__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    ___CertReqMsg_regInfo__item__value._const_tab = ____CertReqMsg_regInfo__item__type_tab
    ___CertReqMsg_regInfo__item__value._const_tab_at = ('..', 'type')
    ___CertReqMsg_regInfo__item__value._const_tab_id = 'Type'
    __CertReqMsg_regInfo__item_._cont = ASN1Dict([
        ('type', ___CertReqMsg_regInfo__item__type),
        ('value', ___CertReqMsg_regInfo__item__value),
        ])
    __CertReqMsg_regInfo__item_._ext = None
    _CertReqMsg_regInfo._cont = __CertReqMsg_regInfo__item_
    _CertReqMsg_regInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CertReqMsg._cont = ASN1Dict([
        ('certReq', _CertReqMsg_certReq),
        ('popo', _CertReqMsg_popo),
        ('regInfo', _CertReqMsg_regInfo),
        ])
    CertReqMsg._ext = None
    
    #-----< CertRequest >-----#
    CertRequest = SEQ(name='CertRequest', mode=MODE_TYPE)
    _CertRequest_certReqId = INT(name='certReqId', mode=MODE_TYPE)
    _CertRequest_certTemplate = SEQ(name='certTemplate', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertTemplate')))
    _CertRequest_controls = SEQ_OF(name='controls', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'Controls')), opt=True)
    CertRequest._cont = ASN1Dict([
        ('certReqId', _CertRequest_certReqId),
        ('certTemplate', _CertRequest_certTemplate),
        ('controls', _CertRequest_controls),
        ])
    CertRequest._ext = None
    
    #-----< CertTemplate >-----#
    CertTemplate = SEQ(name='CertTemplate', mode=MODE_TYPE)
    _CertTemplate_version = INT(name='version', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'Version')), opt=True)
    _CertTemplate_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertTemplate_signingAlg = SEQ(name='signingAlg', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')), opt=True)
    __CertTemplate_signingAlg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___CertTemplate_signingAlg_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____CertTemplate_signingAlg_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____CertTemplate_signingAlg_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____CertTemplate_signingAlg_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____CertTemplate_signingAlg_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____CertTemplate_signingAlg_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____CertTemplate_signingAlg_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____CertTemplate_signingAlg_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    __SIGNATURE_ALGORITHM_HashSet_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___CertTemplate_signingAlg_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____CertTemplate_signingAlg_algorithm_tab_val_Value_3), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____CertTemplate_signingAlg_algorithm_tab_val_Value_4), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____CertTemplate_signingAlg_algorithm_tab_val_Value_5), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____CertTemplate_signingAlg_algorithm_tab_val_Value_6), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____CertTemplate_signingAlg_algorithm_tab_val_Value_7), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____CertTemplate_signingAlg_algorithm_tab_val_Value_8), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____CertTemplate_signingAlg_algorithm_tab_val_Value_9), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____CertTemplate_signingAlg_algorithm_tab_val_Value_10), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____CertTemplate_signingAlg_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __CertTemplate_signingAlg_algorithm._const_tab = ___CertTemplate_signingAlg_algorithm_tab
    __CertTemplate_signingAlg_algorithm._const_tab_at = None
    __CertTemplate_signingAlg_algorithm._const_tab_id = 'id'
    __CertTemplate_signingAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __CertTemplate_signingAlg_parameters._const_tab = ___CertTemplate_signingAlg_algorithm_tab
    __CertTemplate_signingAlg_parameters._const_tab_at = ('..', 'algorithm')
    __CertTemplate_signingAlg_parameters._const_tab_id = 'Params'
    _CertTemplate_signingAlg._cont = ASN1Dict([
        ('algorithm', __CertTemplate_signingAlg_algorithm),
        ('parameters', __CertTemplate_signingAlg_parameters),
        ])
    _CertTemplate_signingAlg._ext = None
    _CertTemplate_issuer = CHOICE(name='issuer', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')), opt=True)
    _CertTemplate_validity = SEQ(name='validity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'OptionalValidity')), opt=True)
    _CertTemplate_subject = CHOICE(name='subject', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'Name')), opt=True)
    _CertTemplate_publicKey = SEQ(name='publicKey', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'SubjectPublicKeyInfo')), opt=True)
    _CertTemplate_issuerUID = BIT_STR(name='issuerUID', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'UniqueIdentifier')), opt=True)
    _CertTemplate_subjectUID = BIT_STR(name='subjectUID', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'UniqueIdentifier')), opt=True)
    _CertTemplate_extensions = SEQ_OF(name='extensions', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __CertTemplate_extensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___CertTemplate_extensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____CertTemplate_extensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_0 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityKeyIdentifier')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_1 = OCT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyIdentifier')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_2 = BIT_STR(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyUsage')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_3 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PrivateKeyUsagePeriod')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_4 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CertificatePolicies')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_5 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyMappings')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_6 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_7 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_8 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectDirectoryAttributes')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_9 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'BasicConstraints')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_10 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'NameConstraints')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_11 = SEQ(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'PolicyConstraints')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_12 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'ExtKeyUsageSyntax')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_13 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_14 = INT(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SkipCerts')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_15 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'CRLDistributionPoints')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_16 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'AuthorityInfoAccessSyntax')))
    _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_17 = SEQ_OF(name='ExtnType', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'SubjectInfoAccessSyntax')))
    ____CertTemplate_extensions__item__extnID_tab._val = ASN1Set(rv=[dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_0), ('id', (2, 5, 29, 35))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_1), ('id', (2, 5, 29, 14))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_2), ('id', (2, 5, 29, 15))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_3), ('id', (2, 5, 29, 16))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_4), ('id', (2, 5, 29, 32))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_5), ('id', (2, 5, 29, 33))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_6), ('id', (2, 5, 29, 17))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_7), ('id', (2, 5, 29, 18))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_8), ('id', (2, 5, 29, 9))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_9), ('id', (2, 5, 29, 19))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_10), ('id', (2, 5, 29, 30))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_11), ('id', (2, 5, 29, 36))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_12), ('id', (2, 5, 29, 37))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_13), ('id', (2, 5, 29, 31))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_14), ('id', (2, 5, 29, 54))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_15), ('id', (2, 5, 29, 46))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_16), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 1))]), dict([('ExtnType', _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_17), ('id', (1, 3, 6, 1, 5, 5, 7, 1, 11))])], rr=[], ev=None, er=[])
    ___CertTemplate_extensions__item__extnID._const_tab = ____CertTemplate_extensions__item__extnID_tab
    ___CertTemplate_extensions__item__extnID._const_tab_at = None
    ___CertTemplate_extensions__item__extnID._const_tab_id = 'id'
    ___CertTemplate_extensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___CertTemplate_extensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____CertTemplate_extensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    ____CertTemplate_extensions__item__extnValue_contain._const_tab = ____CertTemplate_extensions__item__extnID_tab
    ____CertTemplate_extensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____CertTemplate_extensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___CertTemplate_extensions__item__extnValue._const_cont = ____CertTemplate_extensions__item__extnValue_contain
    __CertTemplate_extensions__item_._cont = ASN1Dict([
        ('extnID', ___CertTemplate_extensions__item__extnID),
        ('critical', ___CertTemplate_extensions__item__critical),
        ('extnValue', ___CertTemplate_extensions__item__extnValue),
        ])
    __CertTemplate_extensions__item_._ext = None
    _CertTemplate_extensions._cont = __CertTemplate_extensions__item_
    _CertTemplate_extensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CertTemplate._cont = ASN1Dict([
        ('version', _CertTemplate_version),
        ('serialNumber', _CertTemplate_serialNumber),
        ('signingAlg', _CertTemplate_signingAlg),
        ('issuer', _CertTemplate_issuer),
        ('validity', _CertTemplate_validity),
        ('subject', _CertTemplate_subject),
        ('publicKey', _CertTemplate_publicKey),
        ('issuerUID', _CertTemplate_issuerUID),
        ('subjectUID', _CertTemplate_subjectUID),
        ('extensions', _CertTemplate_extensions),
        ])
    CertTemplate._ext = None
    
    #-----< OptionalValidity >-----#
    OptionalValidity = SEQ(name='OptionalValidity', mode=MODE_TYPE)
    _OptionalValidity_notBefore = CHOICE(name='notBefore', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'Time')), opt=True)
    _OptionalValidity_notAfter = CHOICE(name='notAfter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'Time')), opt=True)
    OptionalValidity._cont = ASN1Dict([
        ('notBefore', _OptionalValidity_notBefore),
        ('notAfter', _OptionalValidity_notAfter),
        ])
    OptionalValidity._ext = None
    
    #-----< Controls >-----#
    Controls = SEQ_OF(name='Controls', mode=MODE_TYPE)
    _Controls__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'SingleAttribute')))
    __Controls__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ___Controls__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____Controls__item__type_tab_val_Type_0 = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'RegToken')))
    ____Controls__item__type_tab_val_Type_1 = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'Authenticator')))
    ____Controls__item__type_tab_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PKIPublicationInfo')))
    ____Controls__item__type_tab_val_Type_3 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PKIArchiveOptions')))
    ____Controls__item__type_tab_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'OldCertId')))
    ____Controls__item__type_tab_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'ProtocolEncrKey')))
    ___Controls__item__type_tab._val = ASN1Set(rv=[dict([('Type', ____Controls__item__type_tab_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 1))]), dict([('Type', ____Controls__item__type_tab_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 2))]), dict([('Type', ____Controls__item__type_tab_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 3))]), dict([('Type', ____Controls__item__type_tab_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 4))]), dict([('Type', ____Controls__item__type_tab_val_Type_4), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 5))]), dict([('Type', ____Controls__item__type_tab_val_Type_5), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 6))])], rr=[], ev=None, er=[])
    __Controls__item__type._const_tab = ___Controls__item__type_tab
    __Controls__item__type._const_tab_at = None
    __Controls__item__type._const_tab_id = 'id'
    __Controls__item__value = OPEN(name='value', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    __Controls__item__value._const_tab = ___Controls__item__type_tab
    __Controls__item__value._const_tab_at = ('..', 'type')
    __Controls__item__value._const_tab_id = 'Type'
    _Controls__item_._cont = ASN1Dict([
        ('type', __Controls__item__type),
        ('value', __Controls__item__value),
        ])
    _Controls__item_._ext = None
    Controls._cont = _Controls__item_
    Controls._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< ProofOfPossession >-----#
    ProofOfPossession = CHOICE(name='ProofOfPossession', mode=MODE_TYPE)
    _ProofOfPossession_raVerified = NULL(name='raVerified', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ProofOfPossession_signature = SEQ(name='signature', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'POPOSigningKey')))
    _ProofOfPossession_keyEncipherment = CHOICE(name='keyEncipherment', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'POPOPrivKey')))
    _ProofOfPossession_keyAgreement = CHOICE(name='keyAgreement', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'POPOPrivKey')))
    ProofOfPossession._cont = ASN1Dict([
        ('raVerified', _ProofOfPossession_raVerified),
        ('signature', _ProofOfPossession_signature),
        ('keyEncipherment', _ProofOfPossession_keyEncipherment),
        ('keyAgreement', _ProofOfPossession_keyAgreement),
        ])
    ProofOfPossession._ext = None
    
    #-----< POPOSigningKey >-----#
    POPOSigningKey = SEQ(name='POPOSigningKey', mode=MODE_TYPE)
    _POPOSigningKey_poposkInput = SEQ(name='poposkInput', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'POPOSigningKeyInput')), opt=True)
    _POPOSigningKey_algorithmIdentifier = SEQ(name='algorithmIdentifier', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __POPOSigningKey_algorithmIdentifier_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___POPOSigningKey_algorithmIdentifier_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___POPOSigningKey_algorithmIdentifier_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_3), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_4), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_5), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_6), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_7), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_8), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_9), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_10), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __POPOSigningKey_algorithmIdentifier_algorithm._const_tab = ___POPOSigningKey_algorithmIdentifier_algorithm_tab
    __POPOSigningKey_algorithmIdentifier_algorithm._const_tab_at = None
    __POPOSigningKey_algorithmIdentifier_algorithm._const_tab_id = 'id'
    __POPOSigningKey_algorithmIdentifier_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __POPOSigningKey_algorithmIdentifier_parameters._const_tab = ___POPOSigningKey_algorithmIdentifier_algorithm_tab
    __POPOSigningKey_algorithmIdentifier_parameters._const_tab_at = ('..', 'algorithm')
    __POPOSigningKey_algorithmIdentifier_parameters._const_tab_id = 'Params'
    _POPOSigningKey_algorithmIdentifier._cont = ASN1Dict([
        ('algorithm', __POPOSigningKey_algorithmIdentifier_algorithm),
        ('parameters', __POPOSigningKey_algorithmIdentifier_parameters),
        ])
    _POPOSigningKey_algorithmIdentifier._ext = None
    _POPOSigningKey_signature = BIT_STR(name='signature', mode=MODE_TYPE)
    POPOSigningKey._cont = ASN1Dict([
        ('poposkInput', _POPOSigningKey_poposkInput),
        ('algorithmIdentifier', _POPOSigningKey_algorithmIdentifier),
        ('signature', _POPOSigningKey_signature),
        ])
    POPOSigningKey._ext = None
    
    #-----< POPOSigningKeyInput >-----#
    POPOSigningKeyInput = SEQ(name='POPOSigningKeyInput', mode=MODE_TYPE)
    _POPOSigningKeyInput_authInfo = CHOICE(name='authInfo', mode=MODE_TYPE)
    __POPOSigningKeyInput_authInfo_sender = CHOICE(name='sender', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    __POPOSigningKeyInput_authInfo_publicKeyMAC = SEQ(name='publicKeyMAC', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PKMACValue')))
    _POPOSigningKeyInput_authInfo._cont = ASN1Dict([
        ('sender', __POPOSigningKeyInput_authInfo_sender),
        ('publicKeyMAC', __POPOSigningKeyInput_authInfo_publicKeyMAC),
        ])
    _POPOSigningKeyInput_authInfo._ext = None
    _POPOSigningKeyInput_publicKey = SEQ(name='publicKey', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SubjectPublicKeyInfo')))
    POPOSigningKeyInput._cont = ASN1Dict([
        ('authInfo', _POPOSigningKeyInput_authInfo),
        ('publicKey', _POPOSigningKeyInput_publicKey),
        ])
    POPOSigningKeyInput._ext = None
    
    #-----< PKMACValue >-----#
    PKMACValue = SEQ(name='PKMACValue', mode=MODE_TYPE)
    _PKMACValue_algId = SEQ(name='algId', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __PKMACValue_algId_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['id']))
    ___PKMACValue_algId_algorithm_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ____PKMACValue_algId_algorithm_tab_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PBMParameter')))
    ___PKMACValue_algId_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113533, 7, 66, 13)), ('Params', ____PKMACValue_algId_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('keyed', True)])], rr=[], ev=None, er=[])
    __PKMACValue_algId_algorithm._const_tab = ___PKMACValue_algId_algorithm_tab
    __PKMACValue_algId_algorithm._const_tab_at = None
    __PKMACValue_algId_algorithm._const_tab_id = 'id'
    __PKMACValue_algId_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['Params']), opt=True)
    __PKMACValue_algId_parameters._const_tab = ___PKMACValue_algId_algorithm_tab
    __PKMACValue_algId_parameters._const_tab_at = ('..', 'algorithm')
    __PKMACValue_algId_parameters._const_tab_id = 'Params'
    _PKMACValue_algId._cont = ASN1Dict([
        ('algorithm', __PKMACValue_algId_algorithm),
        ('parameters', __PKMACValue_algId_parameters),
        ])
    _PKMACValue_algId._ext = None
    _PKMACValue_value = BIT_STR(name='value', mode=MODE_TYPE)
    PKMACValue._cont = ASN1Dict([
        ('algId', _PKMACValue_algId),
        ('value', _PKMACValue_value),
        ])
    PKMACValue._ext = None
    
    #-----< id-PasswordBasedMac >-----#
    id_PasswordBasedMac = OID(name='id-PasswordBasedMac', mode=MODE_VALUE)
    id_PasswordBasedMac._val = (1, 2, 840, 113533, 7, 66, 13)
    
    #-----< Password-MACAlgorithms >-----#
    Password_MACAlgorithms = CLASS(name='Password-MACAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    _Password_MACAlgorithms_val_Params_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PBMParameter')))
    Password_MACAlgorithms._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113533, 7, 66, 13)), ('Params', _Password_MACAlgorithms_val_Params_0), ('paramPresence', 'required'), ('keyed', True)])], rr=[], ev=[], er=[])
    
    #-----< PBMParameter >-----#
    PBMParameter = SEQ(name='PBMParameter', mode=MODE_TYPE)
    _PBMParameter_salt = OCT_STR(name='salt', mode=MODE_TYPE)
    _PBMParameter_owf = SEQ(name='owf', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __PBMParameter_owf_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    ___PBMParameter_owf_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ____PBMParameter_owf_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___PBMParameter_owf_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', ____PBMParameter_owf_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])
    __PBMParameter_owf_algorithm._const_tab = ___PBMParameter_owf_algorithm_tab
    __PBMParameter_owf_algorithm._const_tab_at = None
    __PBMParameter_owf_algorithm._const_tab_id = 'id'
    __PBMParameter_owf_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    __PBMParameter_owf_parameters._const_tab = ___PBMParameter_owf_algorithm_tab
    __PBMParameter_owf_parameters._const_tab_at = ('..', 'algorithm')
    __PBMParameter_owf_parameters._const_tab_id = 'Params'
    _PBMParameter_owf._cont = ASN1Dict([
        ('algorithm', __PBMParameter_owf_algorithm),
        ('parameters', __PBMParameter_owf_parameters),
        ])
    _PBMParameter_owf._ext = None
    _PBMParameter_iterationCount = INT(name='iterationCount', mode=MODE_TYPE)
    _PBMParameter_mac = SEQ(name='mac', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __PBMParameter_mac_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['id']))
    ___PBMParameter_mac_algorithm_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ____PBMParameter_mac_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ___PBMParameter_mac_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', ____PBMParameter_mac_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])], rr=[], ev=None, er=[])
    __PBMParameter_mac_algorithm._const_tab = ___PBMParameter_mac_algorithm_tab
    __PBMParameter_mac_algorithm._const_tab_at = None
    __PBMParameter_mac_algorithm._const_tab_id = 'id'
    __PBMParameter_mac_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['Params']), opt=True)
    __PBMParameter_mac_parameters._const_tab = ___PBMParameter_mac_algorithm_tab
    __PBMParameter_mac_parameters._const_tab_at = ('..', 'algorithm')
    __PBMParameter_mac_parameters._const_tab_id = 'Params'
    _PBMParameter_mac._cont = ASN1Dict([
        ('algorithm', __PBMParameter_mac_algorithm),
        ('parameters', __PBMParameter_mac_parameters),
        ])
    _PBMParameter_mac._ext = None
    PBMParameter._cont = ASN1Dict([
        ('salt', _PBMParameter_salt),
        ('owf', _PBMParameter_owf),
        ('iterationCount', _PBMParameter_iterationCount),
        ('mac', _PBMParameter_mac),
        ])
    PBMParameter._ext = None
    
    #-----< DigestAlgorithms >-----#
    DigestAlgorithms = CLASS(name='DigestAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    _DigestAlgorithms_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    DigestAlgorithms._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', _DigestAlgorithms_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=[], er=[])
    
    #-----< MACAlgorithms >-----#
    MACAlgorithms = CLASS(name='MACAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    _MACAlgorithms_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    MACAlgorithms._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2)), ('Params', _MACAlgorithms_val_Params_0), ('paramPresence', 'preferredAbsent'), ('keyed', True), ('smimeCaps', dict([('id', (1, 3, 6, 1, 5, 5, 8, 1, 2))]))])], rr=[], ev=[], er=[])
    
    #-----< POPOPrivKey >-----#
    POPOPrivKey = CHOICE(name='POPOPrivKey', mode=MODE_TYPE)
    _POPOPrivKey_thisMessage = BIT_STR(name='thisMessage', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _POPOPrivKey_subsequentMessage = INT(name='subsequentMessage', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'SubsequentMessage')))
    _POPOPrivKey_dhMAC = BIT_STR(name='dhMAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _POPOPrivKey_agreeMAC = SEQ(name='agreeMAC', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'PKMACValue')))
    _POPOPrivKey_encryptedKey = SEQ(name='encryptedKey', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EnvelopedData')))
    POPOPrivKey._cont = ASN1Dict([
        ('thisMessage', _POPOPrivKey_thisMessage),
        ('subsequentMessage', _POPOPrivKey_subsequentMessage),
        ('dhMAC', _POPOPrivKey_dhMAC),
        ('agreeMAC', _POPOPrivKey_agreeMAC),
        ('encryptedKey', _POPOPrivKey_encryptedKey),
        ])
    POPOPrivKey._ext = None
    
    #-----< SubsequentMessage >-----#
    SubsequentMessage = INT(name='SubsequentMessage', mode=MODE_TYPE)
    SubsequentMessage._cont = ASN1Dict([('encrCert', 0), ('challengeResp', 1)])
    
    #-----< ct-encKeyWithID >-----#
    ct_encKeyWithID = CLASS(name='ct-encKeyWithID', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_encKeyWithID_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'EncKeyWithID')))
    ct_encKeyWithID._val = dict([('Type', _ct_encKeyWithID_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 21))])
    
    #-----< id-ct-encKeyWithID >-----#
    id_ct_encKeyWithID = OID(name='id-ct-encKeyWithID', mode=MODE_VALUE)
    id_ct_encKeyWithID._val = (1, 2, 840, 113549, 1, 9, 16, 1, 21)
    
    #-----< EncKeyWithID >-----#
    EncKeyWithID = SEQ(name='EncKeyWithID', mode=MODE_TYPE)
    _EncKeyWithID_privateKey = SEQ(name='privateKey', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PrivateKeyInfo')))
    _EncKeyWithID_identifier = CHOICE(name='identifier', mode=MODE_TYPE, opt=True)
    __EncKeyWithID_identifier_string = STR_UTF8(name='string', mode=MODE_TYPE)
    __EncKeyWithID_identifier_generalName = CHOICE(name='generalName', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _EncKeyWithID_identifier._cont = ASN1Dict([
        ('string', __EncKeyWithID_identifier_string),
        ('generalName', __EncKeyWithID_identifier_generalName),
        ])
    _EncKeyWithID_identifier._ext = None
    EncKeyWithID._cont = ASN1Dict([
        ('privateKey', _EncKeyWithID_privateKey),
        ('identifier', _EncKeyWithID_identifier),
        ])
    EncKeyWithID._ext = None
    
    #-----< PrivateKeyInfo >-----#
    PrivateKeyInfo = SEQ(name='PrivateKeyInfo', mode=MODE_TYPE)
    _PrivateKeyInfo_version = INT(name='version', mode=MODE_TYPE)
    _PrivateKeyInfo_privateKeyAlgorithm = SEQ(name='privateKeyAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __PrivateKeyInfo_privateKeyAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'PUBLIC-KEY'), ['id']))
    ___PrivateKeyInfo_privateKeyAlgorithm_algorithm_tab = CLASS(name='_tab_PUBLIC-KEY', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    ___PrivateKeyInfo_privateKeyAlgorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __PrivateKeyInfo_privateKeyAlgorithm_algorithm._const_tab = ___PrivateKeyInfo_privateKeyAlgorithm_algorithm_tab
    __PrivateKeyInfo_privateKeyAlgorithm_algorithm._const_tab_at = None
    __PrivateKeyInfo_privateKeyAlgorithm_algorithm._const_tab_id = 'id'
    __PrivateKeyInfo_privateKeyAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'PUBLIC-KEY'), ['Params']), opt=True)
    ___PrivateKeyInfo_privateKeyAlgorithm_parameters_tab = CLASS(name='_tab_PUBLIC-KEY', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'PUBLIC-KEY')))
    ___PrivateKeyInfo_privateKeyAlgorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __PrivateKeyInfo_privateKeyAlgorithm_parameters._const_tab = ___PrivateKeyInfo_privateKeyAlgorithm_parameters_tab
    __PrivateKeyInfo_privateKeyAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __PrivateKeyInfo_privateKeyAlgorithm_parameters._const_tab_id = 'Params'
    _PrivateKeyInfo_privateKeyAlgorithm._cont = ASN1Dict([
        ('algorithm', __PrivateKeyInfo_privateKeyAlgorithm_algorithm),
        ('parameters', __PrivateKeyInfo_privateKeyAlgorithm_parameters),
        ])
    _PrivateKeyInfo_privateKeyAlgorithm._ext = None
    _PrivateKeyInfo_privateKey = OCT_STR(name='privateKey', mode=MODE_TYPE)
    _PrivateKeyInfo_attributes = SET_OF(name='attributes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'Attributes')), opt=True)
    PrivateKeyInfo._cont = ASN1Dict([
        ('version', _PrivateKeyInfo_version),
        ('privateKeyAlgorithm', _PrivateKeyInfo_privateKeyAlgorithm),
        ('privateKey', _PrivateKeyInfo_privateKey),
        ('attributes', _PrivateKeyInfo_attributes),
        ])
    PrivateKeyInfo._ext = None
    
    #-----< Attributes >-----#
    Attributes = SET_OF(name='Attributes', mode=MODE_TYPE)
    _Attributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'AttributeSet')))
    __Attributes__item__type = OID(name='type', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['id']))
    ___Attributes__item__type_tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ___Attributes__item__type_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __Attributes__item__type._const_tab = ___Attributes__item__type_tab
    __Attributes__item__type._const_tab_at = None
    __Attributes__item__type._const_tab_id = 'id'
    __Attributes__item__values = SET_OF(name='values', mode=MODE_TYPE)
    ___Attributes__item__values__item_ = OPEN(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'ATTRIBUTE'), ['Type']))
    ____Attributes__item__values__item__tab = CLASS(name='_tab_ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    ____Attributes__item__values__item__tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Attributes__item__values__item_._const_tab = ____Attributes__item__values__item__tab
    ___Attributes__item__values__item_._const_tab_at = ('..', '..', 'type')
    ___Attributes__item__values__item_._const_tab_id = 'Type'
    __Attributes__item__values._cont = ___Attributes__item__values__item_
    __Attributes__item__values._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _Attributes__item_._cont = ASN1Dict([
        ('type', __Attributes__item__type),
        ('values', __Attributes__item__values),
        ])
    _Attributes__item_._ext = None
    Attributes._cont = _Attributes__item_
    
    #-----< PrivateKeyAttributes >-----#
    PrivateKeyAttributes = CLASS(name='PrivateKeyAttributes', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    PrivateKeyAttributes._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< id-regCtrl >-----#
    id_regCtrl = OID(name='id-regCtrl', mode=MODE_VALUE)
    id_regCtrl._val = (1, 3, 6, 1, 5, 5, 7, 5, 1)
    
    #-----< RegControlSet >-----#
    RegControlSet = CLASS(name='RegControlSet', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _RegControlSet_val_Type_0 = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'RegToken')))
    _RegControlSet_val_Type_1 = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'Authenticator')))
    _RegControlSet_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PKIPublicationInfo')))
    _RegControlSet_val_Type_3 = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PKIArchiveOptions')))
    _RegControlSet_val_Type_4 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'OldCertId')))
    _RegControlSet_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'ProtocolEncrKey')))
    RegControlSet._val = ASN1Set(rv=[dict([('Type', _RegControlSet_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 1))]), dict([('Type', _RegControlSet_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 2))]), dict([('Type', _RegControlSet_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 3))]), dict([('Type', _RegControlSet_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 4))]), dict([('Type', _RegControlSet_val_Type_4), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 5))]), dict([('Type', _RegControlSet_val_Type_5), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 6))])], rr=[], ev=[], er=[])
    
    #-----< regCtrl-regToken >-----#
    regCtrl_regToken = CLASS(name='regCtrl-regToken', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _regCtrl_regToken_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'RegToken')))
    regCtrl_regToken._val = dict([('Type', _regCtrl_regToken_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 1))])
    
    #-----< id-regCtrl-regToken >-----#
    id_regCtrl_regToken = OID(name='id-regCtrl-regToken', mode=MODE_VALUE)
    id_regCtrl_regToken._val = (1, 3, 6, 1, 5, 5, 7, 5, 1, 1)
    
    #-----< RegToken >-----#
    RegToken = STR_UTF8(name='RegToken', mode=MODE_TYPE)
    
    #-----< regCtrl-authenticator >-----#
    regCtrl_authenticator = CLASS(name='regCtrl-authenticator', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _regCtrl_authenticator_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'Authenticator')))
    regCtrl_authenticator._val = dict([('Type', _regCtrl_authenticator_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 2))])
    
    #-----< id-regCtrl-authenticator >-----#
    id_regCtrl_authenticator = OID(name='id-regCtrl-authenticator', mode=MODE_VALUE)
    id_regCtrl_authenticator._val = (1, 3, 6, 1, 5, 5, 7, 5, 1, 2)
    
    #-----< Authenticator >-----#
    Authenticator = STR_UTF8(name='Authenticator', mode=MODE_TYPE)
    
    #-----< regCtrl-pkiPublicationInfo >-----#
    regCtrl_pkiPublicationInfo = CLASS(name='regCtrl-pkiPublicationInfo', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _regCtrl_pkiPublicationInfo_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PKIPublicationInfo')))
    regCtrl_pkiPublicationInfo._val = dict([('Type', _regCtrl_pkiPublicationInfo_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 3))])
    
    #-----< id-regCtrl-pkiPublicationInfo >-----#
    id_regCtrl_pkiPublicationInfo = OID(name='id-regCtrl-pkiPublicationInfo', mode=MODE_VALUE)
    id_regCtrl_pkiPublicationInfo._val = (1, 3, 6, 1, 5, 5, 7, 5, 1, 3)
    
    #-----< PKIPublicationInfo >-----#
    PKIPublicationInfo = SEQ(name='PKIPublicationInfo', mode=MODE_TYPE)
    _PKIPublicationInfo_action = INT(name='action', mode=MODE_TYPE)
    _PKIPublicationInfo_action._cont = ASN1Dict([('dontPublish', 0), ('pleasePublish', 1)])
    _PKIPublicationInfo_pubInfos = SEQ_OF(name='pubInfos', mode=MODE_TYPE, opt=True)
    __PKIPublicationInfo_pubInfos__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'SinglePubInfo')))
    _PKIPublicationInfo_pubInfos._cont = __PKIPublicationInfo_pubInfos__item_
    _PKIPublicationInfo_pubInfos._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PKIPublicationInfo._cont = ASN1Dict([
        ('action', _PKIPublicationInfo_action),
        ('pubInfos', _PKIPublicationInfo_pubInfos),
        ])
    PKIPublicationInfo._ext = None
    
    #-----< SinglePubInfo >-----#
    SinglePubInfo = SEQ(name='SinglePubInfo', mode=MODE_TYPE)
    _SinglePubInfo_pubMethod = INT(name='pubMethod', mode=MODE_TYPE)
    _SinglePubInfo_pubMethod._cont = ASN1Dict([('dontCare', 0), ('x500', 1), ('web', 2), ('ldap', 3)])
    _SinglePubInfo_pubLocation = CHOICE(name='pubLocation', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')), opt=True)
    SinglePubInfo._cont = ASN1Dict([
        ('pubMethod', _SinglePubInfo_pubMethod),
        ('pubLocation', _SinglePubInfo_pubLocation),
        ])
    SinglePubInfo._ext = None
    
    #-----< regCtrl-pkiArchiveOptions >-----#
    regCtrl_pkiArchiveOptions = CLASS(name='regCtrl-pkiArchiveOptions', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _regCtrl_pkiArchiveOptions_val_Type = CHOICE(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'PKIArchiveOptions')))
    regCtrl_pkiArchiveOptions._val = dict([('Type', _regCtrl_pkiArchiveOptions_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 4))])
    
    #-----< id-regCtrl-pkiArchiveOptions >-----#
    id_regCtrl_pkiArchiveOptions = OID(name='id-regCtrl-pkiArchiveOptions', mode=MODE_VALUE)
    id_regCtrl_pkiArchiveOptions._val = (1, 3, 6, 1, 5, 5, 7, 5, 1, 4)
    
    #-----< PKIArchiveOptions >-----#
    PKIArchiveOptions = CHOICE(name='PKIArchiveOptions', mode=MODE_TYPE)
    _PKIArchiveOptions_encryptedPrivKey = CHOICE(name='encryptedPrivKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'EncryptedKey')))
    _PKIArchiveOptions_keyGenParameters = OCT_STR(name='keyGenParameters', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXCRMF-2009', 'KeyGenParameters')))
    _PKIArchiveOptions_archiveRemGenPrivKey = BOOL(name='archiveRemGenPrivKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    PKIArchiveOptions._cont = ASN1Dict([
        ('encryptedPrivKey', _PKIArchiveOptions_encryptedPrivKey),
        ('keyGenParameters', _PKIArchiveOptions_keyGenParameters),
        ('archiveRemGenPrivKey', _PKIArchiveOptions_archiveRemGenPrivKey),
        ])
    PKIArchiveOptions._ext = None
    
    #-----< EncryptedKey >-----#
    EncryptedKey = CHOICE(name='EncryptedKey', mode=MODE_TYPE)
    _EncryptedKey_encryptedValue = SEQ(name='encryptedValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'EncryptedValue')))
    _EncryptedKey_envelopedData = SEQ(name='envelopedData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'EnvelopedData')))
    EncryptedKey._cont = ASN1Dict([
        ('encryptedValue', _EncryptedKey_encryptedValue),
        ('envelopedData', _EncryptedKey_envelopedData),
        ])
    EncryptedKey._ext = None
    
    #-----< EncryptedValue >-----#
    EncryptedValue = SEQ(name='EncryptedValue', mode=MODE_TYPE)
    _EncryptedValue_intendedAlg = SEQ(name='intendedAlg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')), opt=True)
    __EncryptedValue_intendedAlg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['id']))
    ___EncryptedValue_intendedAlg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___EncryptedValue_intendedAlg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __EncryptedValue_intendedAlg_algorithm._const_tab = ___EncryptedValue_intendedAlg_algorithm_tab
    __EncryptedValue_intendedAlg_algorithm._const_tab_at = None
    __EncryptedValue_intendedAlg_algorithm._const_tab_id = 'id'
    __EncryptedValue_intendedAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['Params']), opt=True)
    ___EncryptedValue_intendedAlg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___EncryptedValue_intendedAlg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __EncryptedValue_intendedAlg_parameters._const_tab = ___EncryptedValue_intendedAlg_parameters_tab
    __EncryptedValue_intendedAlg_parameters._const_tab_at = ('..', 'algorithm')
    __EncryptedValue_intendedAlg_parameters._const_tab_id = 'Params'
    _EncryptedValue_intendedAlg._cont = ASN1Dict([
        ('algorithm', __EncryptedValue_intendedAlg_algorithm),
        ('parameters', __EncryptedValue_intendedAlg_parameters),
        ])
    _EncryptedValue_intendedAlg._ext = None
    _EncryptedValue_symmAlg = SEQ(name='symmAlg', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')), opt=True)
    __EncryptedValue_symmAlg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['id']))
    ___EncryptedValue_symmAlg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___EncryptedValue_symmAlg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __EncryptedValue_symmAlg_algorithm._const_tab = ___EncryptedValue_symmAlg_algorithm_tab
    __EncryptedValue_symmAlg_algorithm._const_tab_at = None
    __EncryptedValue_symmAlg_algorithm._const_tab_id = 'id'
    __EncryptedValue_symmAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['Params']), opt=True)
    ___EncryptedValue_symmAlg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___EncryptedValue_symmAlg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __EncryptedValue_symmAlg_parameters._const_tab = ___EncryptedValue_symmAlg_parameters_tab
    __EncryptedValue_symmAlg_parameters._const_tab_at = ('..', 'algorithm')
    __EncryptedValue_symmAlg_parameters._const_tab_id = 'Params'
    _EncryptedValue_symmAlg._cont = ASN1Dict([
        ('algorithm', __EncryptedValue_symmAlg_algorithm),
        ('parameters', __EncryptedValue_symmAlg_parameters),
        ])
    _EncryptedValue_symmAlg._ext = None
    _EncryptedValue_encSymmKey = BIT_STR(name='encSymmKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EncryptedValue_keyAlg = SEQ(name='keyAlg', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')), opt=True)
    __EncryptedValue_keyAlg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['id']))
    ___EncryptedValue_keyAlg_algorithm_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___EncryptedValue_keyAlg_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __EncryptedValue_keyAlg_algorithm._const_tab = ___EncryptedValue_keyAlg_algorithm_tab
    __EncryptedValue_keyAlg_algorithm._const_tab_at = None
    __EncryptedValue_keyAlg_algorithm._const_tab_id = 'id'
    __EncryptedValue_keyAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'ALGORITHM'), ['Params']), opt=True)
    ___EncryptedValue_keyAlg_parameters_tab = CLASS(name='_tab_ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'ALGORITHM')))
    ___EncryptedValue_keyAlg_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    __EncryptedValue_keyAlg_parameters._const_tab = ___EncryptedValue_keyAlg_parameters_tab
    __EncryptedValue_keyAlg_parameters._const_tab_at = ('..', 'algorithm')
    __EncryptedValue_keyAlg_parameters._const_tab_id = 'Params'
    _EncryptedValue_keyAlg._cont = ASN1Dict([
        ('algorithm', __EncryptedValue_keyAlg_algorithm),
        ('parameters', __EncryptedValue_keyAlg_parameters),
        ])
    _EncryptedValue_keyAlg._ext = None
    _EncryptedValue_valueHint = OCT_STR(name='valueHint', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EncryptedValue_encValue = BIT_STR(name='encValue', mode=MODE_TYPE)
    EncryptedValue._cont = ASN1Dict([
        ('intendedAlg', _EncryptedValue_intendedAlg),
        ('symmAlg', _EncryptedValue_symmAlg),
        ('encSymmKey', _EncryptedValue_encSymmKey),
        ('keyAlg', _EncryptedValue_keyAlg),
        ('valueHint', _EncryptedValue_valueHint),
        ('encValue', _EncryptedValue_encValue),
        ])
    EncryptedValue._ext = None
    
    #-----< KeyGenParameters >-----#
    KeyGenParameters = OCT_STR(name='KeyGenParameters', mode=MODE_TYPE)
    
    #-----< regCtrl-oldCertID >-----#
    regCtrl_oldCertID = CLASS(name='regCtrl-oldCertID', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _regCtrl_oldCertID_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'OldCertId')))
    regCtrl_oldCertID._val = dict([('Type', _regCtrl_oldCertID_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 5))])
    
    #-----< id-regCtrl-oldCertID >-----#
    id_regCtrl_oldCertID = OID(name='id-regCtrl-oldCertID', mode=MODE_VALUE)
    id_regCtrl_oldCertID._val = (1, 3, 6, 1, 5, 5, 7, 5, 1, 5)
    
    #-----< OldCertId >-----#
    OldCertId = SEQ(name='OldCertId', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertId')))
    
    #-----< CertId >-----#
    CertId = SEQ(name='CertId', mode=MODE_TYPE)
    _CertId_issuer = CHOICE(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')))
    _CertId_serialNumber = INT(name='serialNumber', mode=MODE_TYPE)
    CertId._cont = ASN1Dict([
        ('issuer', _CertId_issuer),
        ('serialNumber', _CertId_serialNumber),
        ])
    CertId._ext = None
    
    #-----< regCtrl-protocolEncrKey >-----#
    regCtrl_protocolEncrKey = CLASS(name='regCtrl-protocolEncrKey', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _regCtrl_protocolEncrKey_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'ProtocolEncrKey')))
    regCtrl_protocolEncrKey._val = dict([('Type', _regCtrl_protocolEncrKey_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 1, 6))])
    
    #-----< id-regCtrl-protocolEncrKey >-----#
    id_regCtrl_protocolEncrKey = OID(name='id-regCtrl-protocolEncrKey', mode=MODE_VALUE)
    id_regCtrl_protocolEncrKey._val = (1, 3, 6, 1, 5, 5, 7, 5, 1, 6)
    
    #-----< ProtocolEncrKey >-----#
    ProtocolEncrKey = SEQ(name='ProtocolEncrKey', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SubjectPublicKeyInfo')))
    
    #-----< id-regInfo >-----#
    id_regInfo = OID(name='id-regInfo', mode=MODE_VALUE)
    id_regInfo._val = (1, 3, 6, 1, 5, 5, 7, 5, 2)
    
    #-----< RegInfoSet >-----#
    RegInfoSet = CLASS(name='RegInfoSet', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _RegInfoSet_val_Type_0 = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'UTF8Pairs')))
    _RegInfoSet_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertReq')))
    RegInfoSet._val = ASN1Set(rv=[dict([('Type', _RegInfoSet_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 2, 1))]), dict([('Type', _RegInfoSet_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 2, 2))])], rr=[], ev=None, er=[])
    
    #-----< regInfo-utf8Pairs >-----#
    regInfo_utf8Pairs = CLASS(name='regInfo-utf8Pairs', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _regInfo_utf8Pairs_val_Type = STR_UTF8(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'UTF8Pairs')))
    regInfo_utf8Pairs._val = dict([('Type', _regInfo_utf8Pairs_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 2, 1))])
    
    #-----< id-regInfo-utf8Pairs >-----#
    id_regInfo_utf8Pairs = OID(name='id-regInfo-utf8Pairs', mode=MODE_VALUE)
    id_regInfo_utf8Pairs._val = (1, 3, 6, 1, 5, 5, 7, 5, 2, 1)
    
    #-----< UTF8Pairs >-----#
    UTF8Pairs = STR_UTF8(name='UTF8Pairs', mode=MODE_TYPE)
    
    #-----< regInfo-certReq >-----#
    regInfo_certReq = CLASS(name='regInfo-certReq', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    _regInfo_certReq_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertReq')))
    regInfo_certReq._val = dict([('Type', _regInfo_certReq_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 5, 2, 2))])
    
    #-----< id-regInfo-certReq >-----#
    id_regInfo_certReq = OID(name='id-regInfo-certReq', mode=MODE_VALUE)
    id_regInfo_certReq._val = (1, 3, 6, 1, 5, 5, 7, 5, 2, 2)
    
    #-----< CertReq >-----#
    CertReq = SEQ(name='CertReq', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXCRMF-2009', 'CertRequest')))
    
    _all_ = [
        id_pkip,
        id_smime,
        id_ct,
        _CertReqMessages__item_,
        CertReqMessages,
        _CertReqMsg_certReq,
        _CertReqMsg_popo,
        ____CertReqMsg_regInfo__item__type_tab,
        _____CertReqMsg_regInfo__item__type_tab_val_Type_0,
        _____CertReqMsg_regInfo__item__type_tab_val_Type_1,
        ___CertReqMsg_regInfo__item__type,
        ___CertReqMsg_regInfo__item__value,
        __CertReqMsg_regInfo__item_,
        _CertReqMsg_regInfo,
        CertReqMsg,
        _CertRequest_certReqId,
        _CertRequest_certTemplate,
        _CertRequest_controls,
        CertRequest,
        _CertTemplate_version,
        _CertTemplate_serialNumber,
        ___CertTemplate_signingAlg_algorithm_tab,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_0,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_1,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_2,
        ____CertTemplate_signingAlg_algorithm_tab_val_Value_3,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_3,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0,
        ____CertTemplate_signingAlg_algorithm_tab_val_Value_4,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1,
        ____CertTemplate_signingAlg_algorithm_tab_val_Value_5,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_5,
        ____CertTemplate_signingAlg_algorithm_tab_val_Value_6,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_6,
        ____CertTemplate_signingAlg_algorithm_tab_val_Value_7,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_7,
        ____CertTemplate_signingAlg_algorithm_tab_val_Value_8,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_8,
        ____CertTemplate_signingAlg_algorithm_tab_val_Value_9,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_9,
        ____CertTemplate_signingAlg_algorithm_tab_val_Value_10,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_10,
        ____CertTemplate_signingAlg_algorithm_tab_val_Params_11,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_1,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_2,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_3,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1,
        __CertTemplate_signingAlg_algorithm,
        __CertTemplate_signingAlg_parameters,
        _CertTemplate_signingAlg,
        _CertTemplate_issuer,
        _CertTemplate_validity,
        _CertTemplate_subject,
        _CertTemplate_publicKey,
        _CertTemplate_issuerUID,
        _CertTemplate_subjectUID,
        ____CertTemplate_extensions__item__extnID_tab,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_0,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_1,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_2,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_3,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_4,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_5,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_6,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_7,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_8,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_9,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_10,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_11,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_12,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_13,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_14,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_15,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_16,
        _____CertTemplate_extensions__item__extnID_tab_val_ExtnType_17,
        ___CertTemplate_extensions__item__extnID,
        ___CertTemplate_extensions__item__critical,
        ____CertTemplate_extensions__item__extnValue_contain,
        ___CertTemplate_extensions__item__extnValue,
        __CertTemplate_extensions__item_,
        _CertTemplate_extensions,
        CertTemplate,
        _OptionalValidity_notBefore,
        _OptionalValidity_notAfter,
        OptionalValidity,
        ___Controls__item__type_tab,
        ____Controls__item__type_tab_val_Type_0,
        ____Controls__item__type_tab_val_Type_1,
        ____Controls__item__type_tab_val_Type_2,
        ____Controls__item__type_tab_val_Type_3,
        ____Controls__item__type_tab_val_Type_4,
        ____Controls__item__type_tab_val_Type_5,
        __Controls__item__type,
        __Controls__item__value,
        _Controls__item_,
        Controls,
        _ProofOfPossession_raVerified,
        _ProofOfPossession_signature,
        _ProofOfPossession_keyEncipherment,
        _ProofOfPossession_keyAgreement,
        ProofOfPossession,
        _POPOSigningKey_poposkInput,
        ___POPOSigningKey_algorithmIdentifier_algorithm_tab,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_0,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_1,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_2,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_3,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_3,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_4,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_4,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_5,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_5,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_6,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_6,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_7,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_7,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_8,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_8,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_9,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_9,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Value_10,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_10,
        ____POPOSigningKey_algorithmIdentifier_algorithm_tab_val_Params_11,
        __POPOSigningKey_algorithmIdentifier_algorithm,
        __POPOSigningKey_algorithmIdentifier_parameters,
        _POPOSigningKey_algorithmIdentifier,
        _POPOSigningKey_signature,
        POPOSigningKey,
        __POPOSigningKeyInput_authInfo_sender,
        __POPOSigningKeyInput_authInfo_publicKeyMAC,
        _POPOSigningKeyInput_authInfo,
        _POPOSigningKeyInput_publicKey,
        POPOSigningKeyInput,
        ___PKMACValue_algId_algorithm_tab,
        ____PKMACValue_algId_algorithm_tab_val_Params_0,
        __PKMACValue_algId_algorithm,
        __PKMACValue_algId_parameters,
        _PKMACValue_algId,
        _PKMACValue_value,
        PKMACValue,
        id_PasswordBasedMac,
        Password_MACAlgorithms,
        _Password_MACAlgorithms_val_Params_0,
        _PBMParameter_salt,
        ___PBMParameter_owf_algorithm_tab,
        ____PBMParameter_owf_algorithm_tab_val_Params_0,
        __PBMParameter_owf_algorithm,
        __PBMParameter_owf_parameters,
        _PBMParameter_owf,
        _PBMParameter_iterationCount,
        ___PBMParameter_mac_algorithm_tab,
        ____PBMParameter_mac_algorithm_tab_val_Params_0,
        __PBMParameter_mac_algorithm,
        __PBMParameter_mac_parameters,
        _PBMParameter_mac,
        PBMParameter,
        DigestAlgorithms,
        _DigestAlgorithms_val_Params_0,
        MACAlgorithms,
        _MACAlgorithms_val_Params_0,
        _POPOPrivKey_thisMessage,
        _POPOPrivKey_subsequentMessage,
        _POPOPrivKey_dhMAC,
        _POPOPrivKey_agreeMAC,
        _POPOPrivKey_encryptedKey,
        POPOPrivKey,
        SubsequentMessage,
        ct_encKeyWithID,
        _ct_encKeyWithID_val_Type,
        id_ct_encKeyWithID,
        _EncKeyWithID_privateKey,
        __EncKeyWithID_identifier_string,
        __EncKeyWithID_identifier_generalName,
        _EncKeyWithID_identifier,
        EncKeyWithID,
        _PrivateKeyInfo_version,
        ___PrivateKeyInfo_privateKeyAlgorithm_algorithm_tab,
        __PrivateKeyInfo_privateKeyAlgorithm_algorithm,
        ___PrivateKeyInfo_privateKeyAlgorithm_parameters_tab,
        __PrivateKeyInfo_privateKeyAlgorithm_parameters,
        _PrivateKeyInfo_privateKeyAlgorithm,
        _PrivateKeyInfo_privateKey,
        _PrivateKeyInfo_attributes,
        PrivateKeyInfo,
        ___Attributes__item__type_tab,
        __Attributes__item__type,
        ____Attributes__item__values__item__tab,
        ___Attributes__item__values__item_,
        __Attributes__item__values,
        _Attributes__item_,
        Attributes,
        PrivateKeyAttributes,
        id_regCtrl,
        RegControlSet,
        _RegControlSet_val_Type_0,
        _RegControlSet_val_Type_1,
        _RegControlSet_val_Type_2,
        _RegControlSet_val_Type_3,
        _RegControlSet_val_Type_4,
        _RegControlSet_val_Type_5,
        regCtrl_regToken,
        _regCtrl_regToken_val_Type,
        id_regCtrl_regToken,
        RegToken,
        regCtrl_authenticator,
        _regCtrl_authenticator_val_Type,
        id_regCtrl_authenticator,
        Authenticator,
        regCtrl_pkiPublicationInfo,
        _regCtrl_pkiPublicationInfo_val_Type,
        id_regCtrl_pkiPublicationInfo,
        _PKIPublicationInfo_action,
        __PKIPublicationInfo_pubInfos__item_,
        _PKIPublicationInfo_pubInfos,
        PKIPublicationInfo,
        _SinglePubInfo_pubMethod,
        _SinglePubInfo_pubLocation,
        SinglePubInfo,
        regCtrl_pkiArchiveOptions,
        _regCtrl_pkiArchiveOptions_val_Type,
        id_regCtrl_pkiArchiveOptions,
        _PKIArchiveOptions_encryptedPrivKey,
        _PKIArchiveOptions_keyGenParameters,
        _PKIArchiveOptions_archiveRemGenPrivKey,
        PKIArchiveOptions,
        _EncryptedKey_encryptedValue,
        _EncryptedKey_envelopedData,
        EncryptedKey,
        ___EncryptedValue_intendedAlg_algorithm_tab,
        __EncryptedValue_intendedAlg_algorithm,
        ___EncryptedValue_intendedAlg_parameters_tab,
        __EncryptedValue_intendedAlg_parameters,
        _EncryptedValue_intendedAlg,
        ___EncryptedValue_symmAlg_algorithm_tab,
        __EncryptedValue_symmAlg_algorithm,
        ___EncryptedValue_symmAlg_parameters_tab,
        __EncryptedValue_symmAlg_parameters,
        _EncryptedValue_symmAlg,
        _EncryptedValue_encSymmKey,
        ___EncryptedValue_keyAlg_algorithm_tab,
        __EncryptedValue_keyAlg_algorithm,
        ___EncryptedValue_keyAlg_parameters_tab,
        __EncryptedValue_keyAlg_parameters,
        _EncryptedValue_keyAlg,
        _EncryptedValue_valueHint,
        _EncryptedValue_encValue,
        EncryptedValue,
        KeyGenParameters,
        regCtrl_oldCertID,
        _regCtrl_oldCertID_val_Type,
        id_regCtrl_oldCertID,
        OldCertId,
        _CertId_issuer,
        _CertId_serialNumber,
        CertId,
        regCtrl_protocolEncrKey,
        _regCtrl_protocolEncrKey_val_Type,
        id_regCtrl_protocolEncrKey,
        ProtocolEncrKey,
        id_regInfo,
        RegInfoSet,
        _RegInfoSet_val_Type_0,
        _RegInfoSet_val_Type_1,
        regInfo_utf8Pairs,
        _regInfo_utf8Pairs_val_Type,
        id_regInfo_utf8Pairs,
        UTF8Pairs,
        regInfo_certReq,
        _regInfo_certReq_val_Type,
        id_regInfo_certReq,
        CertReq,
    ]

class PKIX_X400Address_2009:

    _name_  = 'PKIX-X400Address-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 60]
    
    _obj_ = [
        'ORAddress',
        'BuiltInStandardAttributes',
        'CountryName',
        'AdministrationDomainName',
        'NetworkAddress',
        'X121Address',
        'TerminalIdentifier',
        'PrivateDomainName',
        'OrganizationName',
        'NumericUserIdentifier',
        'PersonalName',
        'OrganizationalUnitNames',
        'OrganizationalUnitName',
        'BuiltInDomainDefinedAttributes',
        'BuiltInDomainDefinedAttribute',
        'ExtensionAttributes',
        'EXTENSION-ATTRIBUTE',
        'ExtensionAttribute',
        'SupportedExtensionAttributes',
        'ea-commonName',
        'ea-teletexCommonName',
        'ea-teletexOrganizationName',
        'ea-teletexPersonalName',
        'ea-teletexOrganizationalUnitNames',
        'TeletexOrganizationalUnitName',
        'ea-pDSName',
        'ea-physicalDeliveryCountryName',
        'ea-postalCode',
        'ea-physicalDeliveryOfficeName',
        'ea-physicalDeliveryOfficeNumber',
        'ea-extensionORAddressComponents',
        'ea-physicalDeliveryPersonalName',
        'ea-physicalDeliveryOrganizationName',
        'ea-extensionPhysicalDeliveryAddressComponents',
        'ea-unformattedPostalAddress',
        'ea-streetAddress',
        'ea-postOfficeBoxAddress',
        'ea-posteRestanteAddress',
        'ea-uniquePostalName',
        'ea-localPostalAttributes',
        'PDSParameter',
        'ea-extendedNetworkAddress',
        'PresentationAddress',
        'ea-terminalType',
        'ea-teletexDomainDefinedAttributes',
        'TeletexDomainDefinedAttribute',
        'ub-match',
        'ub-common-name-length',
        'ub-country-name-alpha-length',
        'ub-country-name-numeric-length',
        'ub-domain-defined-attributes',
        'ub-domain-defined-attribute-type-length',
        'ub-domain-defined-attribute-value-length',
        'ub-domain-name-length',
        'ub-extension-attributes',
        'ub-e163-4-number-length',
        'ub-e163-4-sub-address-length',
        'ub-generation-qualifier-length',
        'ub-given-name-length',
        'ub-initials-length',
        'ub-integer-options',
        'ub-numeric-user-id-length',
        'ub-organization-name-length',
        'ub-organizational-unit-name-length',
        'ub-organizational-units',
        'ub-pds-name-length',
        'ub-pds-parameter-length',
        'ub-pds-physical-address-lines',
        'ub-postal-code-length',
        'ub-surname-length',
        'ub-terminal-id-length',
        'ub-unformatted-address-length',
        'ub-x121-address-length',
        ]
    _type_ = [
        'ORAddress',
        'BuiltInStandardAttributes',
        'CountryName',
        'AdministrationDomainName',
        'NetworkAddress',
        'X121Address',
        'TerminalIdentifier',
        'PrivateDomainName',
        'OrganizationName',
        'NumericUserIdentifier',
        'PersonalName',
        'OrganizationalUnitNames',
        'OrganizationalUnitName',
        'BuiltInDomainDefinedAttributes',
        'BuiltInDomainDefinedAttribute',
        'ExtensionAttributes',
        'EXTENSION-ATTRIBUTE',
        'ExtensionAttribute',
        'TeletexOrganizationalUnitName',
        'PDSParameter',
        'PresentationAddress',
        'TeletexDomainDefinedAttribute',
        ]
    _set_ = [
        'SupportedExtensionAttributes',
        ]
    _val_ = [
        'ea-commonName',
        'ea-teletexCommonName',
        'ea-teletexOrganizationName',
        'ea-teletexPersonalName',
        'ea-teletexOrganizationalUnitNames',
        'ea-pDSName',
        'ea-physicalDeliveryCountryName',
        'ea-postalCode',
        'ea-physicalDeliveryOfficeName',
        'ea-physicalDeliveryOfficeNumber',
        'ea-extensionORAddressComponents',
        'ea-physicalDeliveryPersonalName',
        'ea-physicalDeliveryOrganizationName',
        'ea-extensionPhysicalDeliveryAddressComponents',
        'ea-unformattedPostalAddress',
        'ea-streetAddress',
        'ea-postOfficeBoxAddress',
        'ea-posteRestanteAddress',
        'ea-uniquePostalName',
        'ea-localPostalAttributes',
        'ea-extendedNetworkAddress',
        'ea-terminalType',
        'ea-teletexDomainDefinedAttributes',
        'ub-match',
        'ub-common-name-length',
        'ub-country-name-alpha-length',
        'ub-country-name-numeric-length',
        'ub-domain-defined-attributes',
        'ub-domain-defined-attribute-type-length',
        'ub-domain-defined-attribute-value-length',
        'ub-domain-name-length',
        'ub-extension-attributes',
        'ub-e163-4-number-length',
        'ub-e163-4-sub-address-length',
        'ub-generation-qualifier-length',
        'ub-given-name-length',
        'ub-initials-length',
        'ub-integer-options',
        'ub-numeric-user-id-length',
        'ub-organization-name-length',
        'ub-organizational-unit-name-length',
        'ub-organizational-units',
        'ub-pds-name-length',
        'ub-pds-parameter-length',
        'ub-pds-physical-address-lines',
        'ub-postal-code-length',
        'ub-surname-length',
        'ub-terminal-id-length',
        'ub-unformatted-address-length',
        'ub-x121-address-length',
        ]
    _class_ = [
        'EXTENSION-ATTRIBUTE',
        'SupportedExtensionAttributes',
        'ea-commonName',
        'ea-teletexCommonName',
        'ea-teletexOrganizationName',
        'ea-teletexPersonalName',
        'ea-teletexOrganizationalUnitNames',
        'ea-pDSName',
        'ea-physicalDeliveryCountryName',
        'ea-postalCode',
        'ea-physicalDeliveryOfficeName',
        'ea-physicalDeliveryOfficeNumber',
        'ea-extensionORAddressComponents',
        'ea-physicalDeliveryPersonalName',
        'ea-physicalDeliveryOrganizationName',
        'ea-extensionPhysicalDeliveryAddressComponents',
        'ea-unformattedPostalAddress',
        'ea-streetAddress',
        'ea-postOfficeBoxAddress',
        'ea-posteRestanteAddress',
        'ea-uniquePostalName',
        'ea-localPostalAttributes',
        'ea-extendedNetworkAddress',
        'ea-terminalType',
        'ea-teletexDomainDefinedAttributes',
        ]
    _param_ = [
        ]
    
    #-----< ORAddress >-----#
    ORAddress = SEQ(name='ORAddress', mode=MODE_TYPE)
    _ORAddress_built_in_standard_attributes = SEQ(name='built-in-standard-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'BuiltInStandardAttributes')))
    _ORAddress_built_in_domain_defined_attributes = SEQ_OF(name='built-in-domain-defined-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'BuiltInDomainDefinedAttributes')), opt=True)
    _ORAddress_extension_attributes = SET_OF(name='extension-attributes', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'ExtensionAttributes')), opt=True)
    ORAddress._cont = ASN1Dict([
        ('built-in-standard-attributes', _ORAddress_built_in_standard_attributes),
        ('built-in-domain-defined-attributes', _ORAddress_built_in_domain_defined_attributes),
        ('extension-attributes', _ORAddress_extension_attributes),
        ])
    ORAddress._ext = None
    
    #-----< BuiltInStandardAttributes >-----#
    BuiltInStandardAttributes = SEQ(name='BuiltInStandardAttributes', mode=MODE_TYPE)
    _BuiltInStandardAttributes_country_name = CHOICE(name='country-name', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'CountryName')), opt=True)
    _BuiltInStandardAttributes_administration_domain_name = CHOICE(name='administration-domain-name', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'AdministrationDomainName')), opt=True)
    _BuiltInStandardAttributes_network_address = STR_NUM(name='network-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'NetworkAddress')), opt=True)
    _BuiltInStandardAttributes_terminal_identifier = STR_PRINT(name='terminal-identifier', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'TerminalIdentifier')), opt=True)
    _BuiltInStandardAttributes_private_domain_name = CHOICE(name='private-domain-name', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'PrivateDomainName')), opt=True)
    _BuiltInStandardAttributes_organization_name = STR_PRINT(name='organization-name', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'OrganizationName')), opt=True)
    _BuiltInStandardAttributes_numeric_user_identifier = STR_NUM(name='numeric-user-identifier', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'NumericUserIdentifier')), opt=True)
    _BuiltInStandardAttributes_personal_name = SET(name='personal-name', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'PersonalName')), opt=True)
    _BuiltInStandardAttributes_organizational_unit_names = SEQ_OF(name='organizational-unit-names', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'OrganizationalUnitNames')), opt=True)
    BuiltInStandardAttributes._cont = ASN1Dict([
        ('country-name', _BuiltInStandardAttributes_country_name),
        ('administration-domain-name', _BuiltInStandardAttributes_administration_domain_name),
        ('network-address', _BuiltInStandardAttributes_network_address),
        ('terminal-identifier', _BuiltInStandardAttributes_terminal_identifier),
        ('private-domain-name', _BuiltInStandardAttributes_private_domain_name),
        ('organization-name', _BuiltInStandardAttributes_organization_name),
        ('numeric-user-identifier', _BuiltInStandardAttributes_numeric_user_identifier),
        ('personal-name', _BuiltInStandardAttributes_personal_name),
        ('organizational-unit-names', _BuiltInStandardAttributes_organizational_unit_names),
        ])
    BuiltInStandardAttributes._ext = None
    
    #-----< CountryName >-----#
    CountryName = CHOICE(name='CountryName', mode=MODE_TYPE, tag=(1, TAG_APPLICATION, TAG_EXPLICIT))
    _CountryName_x121_dcc_code = STR_NUM(name='x121-dcc-code', mode=MODE_TYPE)
    _CountryName_x121_dcc_code._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _CountryName_iso_3166_alpha2_code = STR_PRINT(name='iso-3166-alpha2-code', mode=MODE_TYPE)
    _CountryName_iso_3166_alpha2_code._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    CountryName._cont = ASN1Dict([
        ('x121-dcc-code', _CountryName_x121_dcc_code),
        ('iso-3166-alpha2-code', _CountryName_iso_3166_alpha2_code),
        ])
    CountryName._ext = None
    
    #-----< AdministrationDomainName >-----#
    AdministrationDomainName = CHOICE(name='AdministrationDomainName', mode=MODE_TYPE, tag=(2, TAG_APPLICATION, TAG_EXPLICIT))
    _AdministrationDomainName_numeric = STR_NUM(name='numeric', mode=MODE_TYPE)
    _AdministrationDomainName_numeric._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    _AdministrationDomainName_printable = STR_PRINT(name='printable', mode=MODE_TYPE)
    _AdministrationDomainName_printable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16)], ev=None, er=[])
    AdministrationDomainName._cont = ASN1Dict([
        ('numeric', _AdministrationDomainName_numeric),
        ('printable', _AdministrationDomainName_printable),
        ])
    AdministrationDomainName._ext = None
    
    #-----< NetworkAddress >-----#
    NetworkAddress = STR_NUM(name='NetworkAddress', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'X121Address')))
    
    #-----< X121Address >-----#
    X121Address = STR_NUM(name='X121Address', mode=MODE_TYPE)
    X121Address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< TerminalIdentifier >-----#
    TerminalIdentifier = STR_PRINT(name='TerminalIdentifier', mode=MODE_TYPE)
    TerminalIdentifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=None, er=[])
    
    #-----< PrivateDomainName >-----#
    PrivateDomainName = CHOICE(name='PrivateDomainName', mode=MODE_TYPE)
    _PrivateDomainName_numeric = STR_NUM(name='numeric', mode=MODE_TYPE)
    _PrivateDomainName_numeric._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PrivateDomainName_printable = STR_PRINT(name='printable', mode=MODE_TYPE)
    _PrivateDomainName_printable._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    PrivateDomainName._cont = ASN1Dict([
        ('numeric', _PrivateDomainName_numeric),
        ('printable', _PrivateDomainName_printable),
        ])
    PrivateDomainName._ext = None
    
    #-----< OrganizationName >-----#
    OrganizationName = STR_PRINT(name='OrganizationName', mode=MODE_TYPE)
    OrganizationName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< NumericUserIdentifier >-----#
    NumericUserIdentifier = STR_NUM(name='NumericUserIdentifier', mode=MODE_TYPE)
    NumericUserIdentifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< PersonalName >-----#
    PersonalName = SET(name='PersonalName', mode=MODE_TYPE)
    _PersonalName_surname = STR_PRINT(name='surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PersonalName_surname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    _PersonalName_given_name = STR_PRINT(name='given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PersonalName_given_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _PersonalName_initials = STR_PRINT(name='initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PersonalName_initials._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    _PersonalName_generation_qualifier = STR_PRINT(name='generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PersonalName_generation_qualifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    PersonalName._cont = ASN1Dict([
        ('surname', _PersonalName_surname),
        ('given-name', _PersonalName_given_name),
        ('initials', _PersonalName_initials),
        ('generation-qualifier', _PersonalName_generation_qualifier),
        ])
    PersonalName._ext = None
    
    #-----< OrganizationalUnitNames >-----#
    OrganizationalUnitNames = SEQ_OF(name='OrganizationalUnitNames', mode=MODE_TYPE)
    _OrganizationalUnitNames__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'OrganizationalUnitName')))
    OrganizationalUnitNames._cont = _OrganizationalUnitNames__item_
    OrganizationalUnitNames._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< OrganizationalUnitName >-----#
    OrganizationalUnitName = STR_PRINT(name='OrganizationalUnitName', mode=MODE_TYPE)
    OrganizationalUnitName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< BuiltInDomainDefinedAttributes >-----#
    BuiltInDomainDefinedAttributes = SEQ_OF(name='BuiltInDomainDefinedAttributes', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'BuiltInDomainDefinedAttribute')))
    BuiltInDomainDefinedAttributes._cont = _BuiltInDomainDefinedAttributes__item_
    BuiltInDomainDefinedAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    
    #-----< BuiltInDomainDefinedAttribute >-----#
    BuiltInDomainDefinedAttribute = SEQ(name='BuiltInDomainDefinedAttribute', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_type = STR_PRINT(name='type', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _BuiltInDomainDefinedAttribute_value = STR_PRINT(name='value', mode=MODE_TYPE)
    _BuiltInDomainDefinedAttribute_value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    BuiltInDomainDefinedAttribute._cont = ASN1Dict([
        ('type', _BuiltInDomainDefinedAttribute_type),
        ('value', _BuiltInDomainDefinedAttribute_value),
        ])
    BuiltInDomainDefinedAttribute._ext = None
    
    #-----< ExtensionAttributes >-----#
    ExtensionAttributes = SET_OF(name='ExtensionAttributes', mode=MODE_TYPE)
    _ExtensionAttributes__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'ExtensionAttribute')))
    ExtensionAttributes._cont = _ExtensionAttributes__item_
    ExtensionAttributes._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< EXTENSION-ATTRIBUTE >-----#
    EXTENSION_ATTRIBUTE = CLASS(name='EXTENSION-ATTRIBUTE', mode=MODE_TYPE)
    _EXTENSION_ATTRIBUTE_id = INT(name='id', mode=MODE_VALUE, uniq=True)
    _EXTENSION_ATTRIBUTE_id._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    _EXTENSION_ATTRIBUTE_Type = OPEN(name='Type', mode=MODE_TYPE)
    EXTENSION_ATTRIBUTE._cont = ASN1Dict([
        ('id', _EXTENSION_ATTRIBUTE_id),
        ('Type', _EXTENSION_ATTRIBUTE_Type),
        ])
    
    #-----< ExtensionAttribute >-----#
    ExtensionAttribute = SEQ(name='ExtensionAttribute', mode=MODE_TYPE)
    _ExtensionAttribute_extension_attribute_type = INT(name='extension-attribute-type', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefClassField(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE'), ['id']))
    __ExtensionAttribute_extension_attribute_type_tab = CLASS(name='_tab_EXTENSION-ATTRIBUTE', mode=MODE_SET, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0 = STR_PRINT(name='Type', mode=MODE_TYPE)
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1 = STR_TELE(name='Type', mode=MODE_TYPE)
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2 = STR_TELE(name='Type', mode=MODE_TYPE)
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3 = SET(name='Type', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_surname = STR_TELE(name='surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_surname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_given_name = STR_TELE(name='given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_given_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_initials = STR_TELE(name='initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_initials._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_generation_qualifier = STR_TELE(name='generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_generation_qualifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3._cont = ASN1Dict([
        ('surname', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_surname),
        ('given-name', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_given_name),
        ('initials', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_initials),
        ('generation-qualifier', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_generation_qualifier),
        ])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3._ext = None
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4 = SEQ_OF(name='Type', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_4__item_ = STR_TELE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'TeletexOrganizationalUnitName')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4._cont = ____ExtensionAttribute_extension_attribute_type_tab_val_Type_4__item_
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5 = STR_PRINT(name='Type', mode=MODE_TYPE)
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6 = CHOICE(name='Type', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_6_x121_dcc_code = STR_NUM(name='x121-dcc-code', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_6_x121_dcc_code._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_6_iso_3166_alpha2_code = STR_PRINT(name='iso-3166-alpha2-code', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_6_iso_3166_alpha2_code._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6._cont = ASN1Dict([
        ('x121-dcc-code', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_6_x121_dcc_code),
        ('iso-3166-alpha2-code', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_6_iso_3166_alpha2_code),
        ])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6._ext = None
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7 = CHOICE(name='Type', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_7_numeric_code = STR_NUM(name='numeric-code', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_7_numeric_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_7_printable_code = STR_PRINT(name='printable-code', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_7_printable_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7._cont = ASN1Dict([
        ('numeric-code', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_7_numeric_code),
        ('printable-code', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_7_printable_code),
        ])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7._ext = None
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14 = SET(name='Type', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_printable_address = SEQ_OF(name='printable-address', mode=MODE_TYPE, opt=True)
    _____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_printable_address__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE)
    _____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_printable_address__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_printable_address._cont = _____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_printable_address__item_
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_printable_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_teletex_string = STR_TELE(name='teletex-string', mode=MODE_TYPE, opt=True)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_teletex_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14._cont = ASN1Dict([
        ('printable-address', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_printable_address),
        ('teletex-string', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_teletex_string),
        ])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14._ext = None
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20 = CHOICE(name='Type', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address = SEQ(name='e163-4-address', mode=MODE_TYPE)
    _____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address_number = STR_NUM(name='number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address_number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    _____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address_sub_address = STR_NUM(name='sub-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address_sub_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address._cont = ASN1Dict([
        ('number', _____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address_number),
        ('sub-address', _____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address_sub_address),
        ])
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address._ext = None
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_psap_address = SEQ(name='psap-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'PresentationAddress')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20._cont = ASN1Dict([
        ('e163-4-address', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address),
        ('psap-address', ____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_psap_address),
        ])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20._ext = None
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21 = INT(name='Type', mode=MODE_TYPE)
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21._cont = ASN1Dict([('telex', 3), ('teletex', 4), ('g3-facsimile', 5), ('g4-facsimile', 6), ('ia5-terminal', 7), ('videotex', 8)])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22 = SEQ_OF(name='Type', mode=MODE_TYPE)
    ____ExtensionAttribute_extension_attribute_type_tab_val_Type_22__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'TeletexDomainDefinedAttribute')))
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22._cont = ____ExtensionAttribute_extension_attribute_type_tab_val_Type_22__item_
    ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    __ExtensionAttribute_extension_attribute_type_tab._val = ASN1Set(rv=[dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0), ('id', 1)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1), ('id', 2)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2), ('id', 3)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3), ('id', 4)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4), ('id', 5)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5), ('id', 7)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6), ('id', 8)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7), ('id', 9)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8), ('id', 10)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9), ('id', 11)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10), ('id', 12)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11), ('id', 13)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12), ('id', 14)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13), ('id', 15)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14), ('id', 16)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15), ('id', 17)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16), ('id', 18)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17), ('id', 19)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18), ('id', 20)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19), ('id', 21)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20), ('id', 22)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21), ('id', 23)]), dict([('Type', ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22), ('id', 6)])], rr=[], ev=None, er=[])
    _ExtensionAttribute_extension_attribute_type._const_tab = __ExtensionAttribute_extension_attribute_type_tab
    _ExtensionAttribute_extension_attribute_type._const_tab_at = None
    _ExtensionAttribute_extension_attribute_type._const_tab_id = 'id'
    _ExtensionAttribute_extension_attribute_value = OPEN(name='extension-attribute-value', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefClassField(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE'), ['Type']))
    _ExtensionAttribute_extension_attribute_value._const_tab = __ExtensionAttribute_extension_attribute_type_tab
    _ExtensionAttribute_extension_attribute_value._const_tab_at = ('..', 'extension-attribute-type')
    _ExtensionAttribute_extension_attribute_value._const_tab_id = 'Type'
    ExtensionAttribute._cont = ASN1Dict([
        ('extension-attribute-type', _ExtensionAttribute_extension_attribute_type),
        ('extension-attribute-value', _ExtensionAttribute_extension_attribute_value),
        ])
    ExtensionAttribute._ext = None
    
    #-----< SupportedExtensionAttributes >-----#
    SupportedExtensionAttributes = CLASS(name='SupportedExtensionAttributes', mode=MODE_SET, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _SupportedExtensionAttributes_val_Type_0 = STR_PRINT(name='Type', mode=MODE_TYPE)
    _SupportedExtensionAttributes_val_Type_0._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _SupportedExtensionAttributes_val_Type_1 = STR_TELE(name='Type', mode=MODE_TYPE)
    _SupportedExtensionAttributes_val_Type_1._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _SupportedExtensionAttributes_val_Type_2 = STR_TELE(name='Type', mode=MODE_TYPE)
    _SupportedExtensionAttributes_val_Type_2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    _SupportedExtensionAttributes_val_Type_3 = SET(name='Type', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_3_surname = STR_TELE(name='surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SupportedExtensionAttributes_val_Type_3_surname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    __SupportedExtensionAttributes_val_Type_3_given_name = STR_TELE(name='given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SupportedExtensionAttributes_val_Type_3_given_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __SupportedExtensionAttributes_val_Type_3_initials = STR_TELE(name='initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SupportedExtensionAttributes_val_Type_3_initials._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __SupportedExtensionAttributes_val_Type_3_generation_qualifier = STR_TELE(name='generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SupportedExtensionAttributes_val_Type_3_generation_qualifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _SupportedExtensionAttributes_val_Type_3._cont = ASN1Dict([
        ('surname', __SupportedExtensionAttributes_val_Type_3_surname),
        ('given-name', __SupportedExtensionAttributes_val_Type_3_given_name),
        ('initials', __SupportedExtensionAttributes_val_Type_3_initials),
        ('generation-qualifier', __SupportedExtensionAttributes_val_Type_3_generation_qualifier),
        ])
    _SupportedExtensionAttributes_val_Type_3._ext = None
    _SupportedExtensionAttributes_val_Type_4 = SEQ_OF(name='Type', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_4__item_ = STR_TELE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'TeletexOrganizationalUnitName')))
    _SupportedExtensionAttributes_val_Type_4._cont = __SupportedExtensionAttributes_val_Type_4__item_
    _SupportedExtensionAttributes_val_Type_4._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    _SupportedExtensionAttributes_val_Type_5 = STR_PRINT(name='Type', mode=MODE_TYPE)
    _SupportedExtensionAttributes_val_Type_5._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _SupportedExtensionAttributes_val_Type_6 = CHOICE(name='Type', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_6_x121_dcc_code = STR_NUM(name='x121-dcc-code', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_6_x121_dcc_code._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    __SupportedExtensionAttributes_val_Type_6_iso_3166_alpha2_code = STR_PRINT(name='iso-3166-alpha2-code', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_6_iso_3166_alpha2_code._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _SupportedExtensionAttributes_val_Type_6._cont = ASN1Dict([
        ('x121-dcc-code', __SupportedExtensionAttributes_val_Type_6_x121_dcc_code),
        ('iso-3166-alpha2-code', __SupportedExtensionAttributes_val_Type_6_iso_3166_alpha2_code),
        ])
    _SupportedExtensionAttributes_val_Type_6._ext = None
    _SupportedExtensionAttributes_val_Type_7 = CHOICE(name='Type', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_7_numeric_code = STR_NUM(name='numeric-code', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_7_numeric_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __SupportedExtensionAttributes_val_Type_7_printable_code = STR_PRINT(name='printable-code', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_7_printable_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _SupportedExtensionAttributes_val_Type_7._cont = ASN1Dict([
        ('numeric-code', __SupportedExtensionAttributes_val_Type_7_numeric_code),
        ('printable-code', __SupportedExtensionAttributes_val_Type_7_printable_code),
        ])
    _SupportedExtensionAttributes_val_Type_7._ext = None
    _SupportedExtensionAttributes_val_Type_8 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_9 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_10 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_11 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_12 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_13 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_14 = SET(name='Type', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_14_printable_address = SEQ_OF(name='printable-address', mode=MODE_TYPE, opt=True)
    ___SupportedExtensionAttributes_val_Type_14_printable_address__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE)
    ___SupportedExtensionAttributes_val_Type_14_printable_address__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __SupportedExtensionAttributes_val_Type_14_printable_address._cont = ___SupportedExtensionAttributes_val_Type_14_printable_address__item_
    __SupportedExtensionAttributes_val_Type_14_printable_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    __SupportedExtensionAttributes_val_Type_14_teletex_string = STR_TELE(name='teletex-string', mode=MODE_TYPE, opt=True)
    __SupportedExtensionAttributes_val_Type_14_teletex_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    _SupportedExtensionAttributes_val_Type_14._cont = ASN1Dict([
        ('printable-address', __SupportedExtensionAttributes_val_Type_14_printable_address),
        ('teletex-string', __SupportedExtensionAttributes_val_Type_14_teletex_string),
        ])
    _SupportedExtensionAttributes_val_Type_14._ext = None
    _SupportedExtensionAttributes_val_Type_15 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_16 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_17 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_18 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_19 = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    _SupportedExtensionAttributes_val_Type_20 = CHOICE(name='Type', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_20_e163_4_address = SEQ(name='e163-4-address', mode=MODE_TYPE)
    ___SupportedExtensionAttributes_val_Type_20_e163_4_address_number = STR_NUM(name='number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SupportedExtensionAttributes_val_Type_20_e163_4_address_number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    ___SupportedExtensionAttributes_val_Type_20_e163_4_address_sub_address = STR_NUM(name='sub-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___SupportedExtensionAttributes_val_Type_20_e163_4_address_sub_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    __SupportedExtensionAttributes_val_Type_20_e163_4_address._cont = ASN1Dict([
        ('number', ___SupportedExtensionAttributes_val_Type_20_e163_4_address_number),
        ('sub-address', ___SupportedExtensionAttributes_val_Type_20_e163_4_address_sub_address),
        ])
    __SupportedExtensionAttributes_val_Type_20_e163_4_address._ext = None
    __SupportedExtensionAttributes_val_Type_20_psap_address = SEQ(name='psap-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'PresentationAddress')))
    _SupportedExtensionAttributes_val_Type_20._cont = ASN1Dict([
        ('e163-4-address', __SupportedExtensionAttributes_val_Type_20_e163_4_address),
        ('psap-address', __SupportedExtensionAttributes_val_Type_20_psap_address),
        ])
    _SupportedExtensionAttributes_val_Type_20._ext = None
    _SupportedExtensionAttributes_val_Type_21 = INT(name='Type', mode=MODE_TYPE)
    _SupportedExtensionAttributes_val_Type_21._cont = ASN1Dict([('telex', 3), ('teletex', 4), ('g3-facsimile', 5), ('g4-facsimile', 6), ('ia5-terminal', 7), ('videotex', 8)])
    _SupportedExtensionAttributes_val_Type_21._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    _SupportedExtensionAttributes_val_Type_22 = SEQ_OF(name='Type', mode=MODE_TYPE)
    __SupportedExtensionAttributes_val_Type_22__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'TeletexDomainDefinedAttribute')))
    _SupportedExtensionAttributes_val_Type_22._cont = __SupportedExtensionAttributes_val_Type_22__item_
    _SupportedExtensionAttributes_val_Type_22._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    SupportedExtensionAttributes._val = ASN1Set(rv=[dict([('Type', _SupportedExtensionAttributes_val_Type_0), ('id', 1)]), dict([('Type', _SupportedExtensionAttributes_val_Type_1), ('id', 2)]), dict([('Type', _SupportedExtensionAttributes_val_Type_2), ('id', 3)]), dict([('Type', _SupportedExtensionAttributes_val_Type_3), ('id', 4)]), dict([('Type', _SupportedExtensionAttributes_val_Type_4), ('id', 5)]), dict([('Type', _SupportedExtensionAttributes_val_Type_5), ('id', 7)]), dict([('Type', _SupportedExtensionAttributes_val_Type_6), ('id', 8)]), dict([('Type', _SupportedExtensionAttributes_val_Type_7), ('id', 9)]), dict([('Type', _SupportedExtensionAttributes_val_Type_8), ('id', 10)]), dict([('Type', _SupportedExtensionAttributes_val_Type_9), ('id', 11)]), dict([('Type', _SupportedExtensionAttributes_val_Type_10), ('id', 12)]), dict([('Type', _SupportedExtensionAttributes_val_Type_11), ('id', 13)]), dict([('Type', _SupportedExtensionAttributes_val_Type_12), ('id', 14)]), dict([('Type', _SupportedExtensionAttributes_val_Type_13), ('id', 15)]), dict([('Type', _SupportedExtensionAttributes_val_Type_14), ('id', 16)]), dict([('Type', _SupportedExtensionAttributes_val_Type_15), ('id', 17)]), dict([('Type', _SupportedExtensionAttributes_val_Type_16), ('id', 18)]), dict([('Type', _SupportedExtensionAttributes_val_Type_17), ('id', 19)]), dict([('Type', _SupportedExtensionAttributes_val_Type_18), ('id', 20)]), dict([('Type', _SupportedExtensionAttributes_val_Type_19), ('id', 21)]), dict([('Type', _SupportedExtensionAttributes_val_Type_20), ('id', 22)]), dict([('Type', _SupportedExtensionAttributes_val_Type_21), ('id', 23)]), dict([('Type', _SupportedExtensionAttributes_val_Type_22), ('id', 6)])], rr=[], ev=[], er=[])
    
    #-----< ea-commonName >-----#
    ea_commonName = CLASS(name='ea-commonName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_commonName_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    _ea_commonName_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ea_commonName._val = dict([('Type', _ea_commonName_val_Type), ('id', 1)])
    
    #-----< ea-teletexCommonName >-----#
    ea_teletexCommonName = CLASS(name='ea-teletexCommonName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_teletexCommonName_val_Type = STR_TELE(name='Type', mode=MODE_TYPE)
    _ea_teletexCommonName_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ea_teletexCommonName._val = dict([('Type', _ea_teletexCommonName_val_Type), ('id', 2)])
    
    #-----< ea-teletexOrganizationName >-----#
    ea_teletexOrganizationName = CLASS(name='ea-teletexOrganizationName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_teletexOrganizationName_val_Type = STR_TELE(name='Type', mode=MODE_TYPE)
    _ea_teletexOrganizationName_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    ea_teletexOrganizationName._val = dict([('Type', _ea_teletexOrganizationName_val_Type), ('id', 3)])
    
    #-----< ea-teletexPersonalName >-----#
    ea_teletexPersonalName = CLASS(name='ea-teletexPersonalName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_teletexPersonalName_val_Type = SET(name='Type', mode=MODE_TYPE)
    __ea_teletexPersonalName_val_Type_surname = STR_TELE(name='surname', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __ea_teletexPersonalName_val_Type_surname._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    __ea_teletexPersonalName_val_Type_given_name = STR_TELE(name='given-name', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ea_teletexPersonalName_val_Type_given_name._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __ea_teletexPersonalName_val_Type_initials = STR_TELE(name='initials', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ea_teletexPersonalName_val_Type_initials._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=5)], ev=None, er=[])
    __ea_teletexPersonalName_val_Type_generation_qualifier = STR_TELE(name='generation-qualifier', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ea_teletexPersonalName_val_Type_generation_qualifier._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _ea_teletexPersonalName_val_Type._cont = ASN1Dict([
        ('surname', __ea_teletexPersonalName_val_Type_surname),
        ('given-name', __ea_teletexPersonalName_val_Type_given_name),
        ('initials', __ea_teletexPersonalName_val_Type_initials),
        ('generation-qualifier', __ea_teletexPersonalName_val_Type_generation_qualifier),
        ])
    _ea_teletexPersonalName_val_Type._ext = None
    ea_teletexPersonalName._val = dict([('Type', _ea_teletexPersonalName_val_Type), ('id', 4)])
    
    #-----< ea-teletexOrganizationalUnitNames >-----#
    ea_teletexOrganizationalUnitNames = CLASS(name='ea-teletexOrganizationalUnitNames', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_teletexOrganizationalUnitNames_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE)
    __ea_teletexOrganizationalUnitNames_val_Type__item_ = STR_TELE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'TeletexOrganizationalUnitName')))
    _ea_teletexOrganizationalUnitNames_val_Type._cont = __ea_teletexOrganizationalUnitNames_val_Type__item_
    _ea_teletexOrganizationalUnitNames_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ea_teletexOrganizationalUnitNames._val = dict([('Type', _ea_teletexOrganizationalUnitNames_val_Type), ('id', 5)])
    
    #-----< TeletexOrganizationalUnitName >-----#
    TeletexOrganizationalUnitName = STR_TELE(name='TeletexOrganizationalUnitName', mode=MODE_TYPE)
    TeletexOrganizationalUnitName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< ea-pDSName >-----#
    ea_pDSName = CLASS(name='ea-pDSName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_pDSName_val_Type = STR_PRINT(name='Type', mode=MODE_TYPE)
    _ea_pDSName_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    ea_pDSName._val = dict([('Type', _ea_pDSName_val_Type), ('id', 7)])
    
    #-----< ea-physicalDeliveryCountryName >-----#
    ea_physicalDeliveryCountryName = CLASS(name='ea-physicalDeliveryCountryName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_physicalDeliveryCountryName_val_Type = CHOICE(name='Type', mode=MODE_TYPE)
    __ea_physicalDeliveryCountryName_val_Type_x121_dcc_code = STR_NUM(name='x121-dcc-code', mode=MODE_TYPE)
    __ea_physicalDeliveryCountryName_val_Type_x121_dcc_code._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    __ea_physicalDeliveryCountryName_val_Type_iso_3166_alpha2_code = STR_PRINT(name='iso-3166-alpha2-code', mode=MODE_TYPE)
    __ea_physicalDeliveryCountryName_val_Type_iso_3166_alpha2_code._const_sz = ASN1Set(rv=[2], rr=[], ev=None, er=[])
    _ea_physicalDeliveryCountryName_val_Type._cont = ASN1Dict([
        ('x121-dcc-code', __ea_physicalDeliveryCountryName_val_Type_x121_dcc_code),
        ('iso-3166-alpha2-code', __ea_physicalDeliveryCountryName_val_Type_iso_3166_alpha2_code),
        ])
    _ea_physicalDeliveryCountryName_val_Type._ext = None
    ea_physicalDeliveryCountryName._val = dict([('Type', _ea_physicalDeliveryCountryName_val_Type), ('id', 8)])
    
    #-----< ea-postalCode >-----#
    ea_postalCode = CLASS(name='ea-postalCode', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_postalCode_val_Type = CHOICE(name='Type', mode=MODE_TYPE)
    __ea_postalCode_val_Type_numeric_code = STR_NUM(name='numeric-code', mode=MODE_TYPE)
    __ea_postalCode_val_Type_numeric_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    __ea_postalCode_val_Type_printable_code = STR_PRINT(name='printable-code', mode=MODE_TYPE)
    __ea_postalCode_val_Type_printable_code._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    _ea_postalCode_val_Type._cont = ASN1Dict([
        ('numeric-code', __ea_postalCode_val_Type_numeric_code),
        ('printable-code', __ea_postalCode_val_Type_printable_code),
        ])
    _ea_postalCode_val_Type._ext = None
    ea_postalCode._val = dict([('Type', _ea_postalCode_val_Type), ('id', 9)])
    
    #-----< ea-physicalDeliveryOfficeName >-----#
    ea_physicalDeliveryOfficeName = CLASS(name='ea-physicalDeliveryOfficeName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_physicalDeliveryOfficeName_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_physicalDeliveryOfficeName._val = dict([('Type', _ea_physicalDeliveryOfficeName_val_Type), ('id', 10)])
    
    #-----< ea-physicalDeliveryOfficeNumber >-----#
    ea_physicalDeliveryOfficeNumber = CLASS(name='ea-physicalDeliveryOfficeNumber', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_physicalDeliveryOfficeNumber_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_physicalDeliveryOfficeNumber._val = dict([('Type', _ea_physicalDeliveryOfficeNumber_val_Type), ('id', 11)])
    
    #-----< ea-extensionORAddressComponents >-----#
    ea_extensionORAddressComponents = CLASS(name='ea-extensionORAddressComponents', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_extensionORAddressComponents_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_extensionORAddressComponents._val = dict([('Type', _ea_extensionORAddressComponents_val_Type), ('id', 12)])
    
    #-----< ea-physicalDeliveryPersonalName >-----#
    ea_physicalDeliveryPersonalName = CLASS(name='ea-physicalDeliveryPersonalName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_physicalDeliveryPersonalName_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_physicalDeliveryPersonalName._val = dict([('Type', _ea_physicalDeliveryPersonalName_val_Type), ('id', 13)])
    
    #-----< ea-physicalDeliveryOrganizationName >-----#
    ea_physicalDeliveryOrganizationName = CLASS(name='ea-physicalDeliveryOrganizationName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_physicalDeliveryOrganizationName_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_physicalDeliveryOrganizationName._val = dict([('Type', _ea_physicalDeliveryOrganizationName_val_Type), ('id', 14)])
    
    #-----< ea-extensionPhysicalDeliveryAddressComponents >-----#
    ea_extensionPhysicalDeliveryAddressComponents = CLASS(name='ea-extensionPhysicalDeliveryAddressComponents', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_extensionPhysicalDeliveryAddressComponents_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_extensionPhysicalDeliveryAddressComponents._val = dict([('Type', _ea_extensionPhysicalDeliveryAddressComponents_val_Type), ('id', 15)])
    
    #-----< ea-unformattedPostalAddress >-----#
    ea_unformattedPostalAddress = CLASS(name='ea-unformattedPostalAddress', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_unformattedPostalAddress_val_Type = SET(name='Type', mode=MODE_TYPE)
    __ea_unformattedPostalAddress_val_Type_printable_address = SEQ_OF(name='printable-address', mode=MODE_TYPE, opt=True)
    ___ea_unformattedPostalAddress_val_Type_printable_address__item_ = STR_PRINT(name='_item_', mode=MODE_TYPE)
    ___ea_unformattedPostalAddress_val_Type_printable_address__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    __ea_unformattedPostalAddress_val_Type_printable_address._cont = ___ea_unformattedPostalAddress_val_Type_printable_address__item_
    __ea_unformattedPostalAddress_val_Type_printable_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=6)], ev=None, er=[])
    __ea_unformattedPostalAddress_val_Type_teletex_string = STR_TELE(name='teletex-string', mode=MODE_TYPE, opt=True)
    __ea_unformattedPostalAddress_val_Type_teletex_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=180)], ev=None, er=[])
    _ea_unformattedPostalAddress_val_Type._cont = ASN1Dict([
        ('printable-address', __ea_unformattedPostalAddress_val_Type_printable_address),
        ('teletex-string', __ea_unformattedPostalAddress_val_Type_teletex_string),
        ])
    _ea_unformattedPostalAddress_val_Type._ext = None
    ea_unformattedPostalAddress._val = dict([('Type', _ea_unformattedPostalAddress_val_Type), ('id', 16)])
    
    #-----< ea-streetAddress >-----#
    ea_streetAddress = CLASS(name='ea-streetAddress', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_streetAddress_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_streetAddress._val = dict([('Type', _ea_streetAddress_val_Type), ('id', 17)])
    
    #-----< ea-postOfficeBoxAddress >-----#
    ea_postOfficeBoxAddress = CLASS(name='ea-postOfficeBoxAddress', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_postOfficeBoxAddress_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_postOfficeBoxAddress._val = dict([('Type', _ea_postOfficeBoxAddress_val_Type), ('id', 18)])
    
    #-----< ea-posteRestanteAddress >-----#
    ea_posteRestanteAddress = CLASS(name='ea-posteRestanteAddress', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_posteRestanteAddress_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_posteRestanteAddress._val = dict([('Type', _ea_posteRestanteAddress_val_Type), ('id', 19)])
    
    #-----< ea-uniquePostalName >-----#
    ea_uniquePostalName = CLASS(name='ea-uniquePostalName', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_uniquePostalName_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_uniquePostalName._val = dict([('Type', _ea_uniquePostalName_val_Type), ('id', 20)])
    
    #-----< ea-localPostalAttributes >-----#
    ea_localPostalAttributes = CLASS(name='ea-localPostalAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_localPostalAttributes_val_Type = SET(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'PDSParameter')))
    ea_localPostalAttributes._val = dict([('Type', _ea_localPostalAttributes_val_Type), ('id', 21)])
    
    #-----< PDSParameter >-----#
    PDSParameter = SET(name='PDSParameter', mode=MODE_TYPE)
    _PDSParameter_printable_string = STR_PRINT(name='printable-string', mode=MODE_TYPE, opt=True)
    _PDSParameter_printable_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    _PDSParameter_teletex_string = STR_TELE(name='teletex-string', mode=MODE_TYPE, opt=True)
    _PDSParameter_teletex_string._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=30)], ev=None, er=[])
    PDSParameter._cont = ASN1Dict([
        ('printable-string', _PDSParameter_printable_string),
        ('teletex-string', _PDSParameter_teletex_string),
        ])
    PDSParameter._ext = None
    
    #-----< ea-extendedNetworkAddress >-----#
    ea_extendedNetworkAddress = CLASS(name='ea-extendedNetworkAddress', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_extendedNetworkAddress_val_Type = CHOICE(name='Type', mode=MODE_TYPE)
    __ea_extendedNetworkAddress_val_Type_e163_4_address = SEQ(name='e163-4-address', mode=MODE_TYPE)
    ___ea_extendedNetworkAddress_val_Type_e163_4_address_number = STR_NUM(name='number', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___ea_extendedNetworkAddress_val_Type_e163_4_address_number._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    ___ea_extendedNetworkAddress_val_Type_e163_4_address_sub_address = STR_NUM(name='sub-address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    ___ea_extendedNetworkAddress_val_Type_e163_4_address_sub_address._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=40)], ev=None, er=[])
    __ea_extendedNetworkAddress_val_Type_e163_4_address._cont = ASN1Dict([
        ('number', ___ea_extendedNetworkAddress_val_Type_e163_4_address_number),
        ('sub-address', ___ea_extendedNetworkAddress_val_Type_e163_4_address_sub_address),
        ])
    __ea_extendedNetworkAddress_val_Type_e163_4_address._ext = None
    __ea_extendedNetworkAddress_val_Type_psap_address = SEQ(name='psap-address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-X400Address-2009', 'PresentationAddress')))
    _ea_extendedNetworkAddress_val_Type._cont = ASN1Dict([
        ('e163-4-address', __ea_extendedNetworkAddress_val_Type_e163_4_address),
        ('psap-address', __ea_extendedNetworkAddress_val_Type_psap_address),
        ])
    _ea_extendedNetworkAddress_val_Type._ext = None
    ea_extendedNetworkAddress._val = dict([('Type', _ea_extendedNetworkAddress_val_Type), ('id', 22)])
    
    #-----< PresentationAddress >-----#
    PresentationAddress = SEQ(name='PresentationAddress', mode=MODE_TYPE)
    _PresentationAddress_pSelector = OCT_STR(name='pSelector', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_sSelector = OCT_STR(name='sSelector', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_tSelector = OCT_STR(name='tSelector', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _PresentationAddress_nAddresses = SET_OF(name='nAddresses', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __PresentationAddress_nAddresses__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    _PresentationAddress_nAddresses._cont = __PresentationAddress_nAddresses__item_
    _PresentationAddress_nAddresses._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    PresentationAddress._cont = ASN1Dict([
        ('pSelector', _PresentationAddress_pSelector),
        ('sSelector', _PresentationAddress_sSelector),
        ('tSelector', _PresentationAddress_tSelector),
        ('nAddresses', _PresentationAddress_nAddresses),
        ])
    PresentationAddress._ext = None
    
    #-----< ea-terminalType >-----#
    ea_terminalType = CLASS(name='ea-terminalType', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_terminalType_val_Type = INT(name='Type', mode=MODE_TYPE)
    _ea_terminalType_val_Type._cont = ASN1Dict([('telex', 3), ('teletex', 4), ('g3-facsimile', 5), ('g4-facsimile', 6), ('ia5-terminal', 7), ('videotex', 8)])
    _ea_terminalType_val_Type._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    ea_terminalType._val = dict([('Type', _ea_terminalType_val_Type), ('id', 23)])
    
    #-----< ea-teletexDomainDefinedAttributes >-----#
    ea_teletexDomainDefinedAttributes = CLASS(name='ea-teletexDomainDefinedAttributes', mode=MODE_VALUE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'EXTENSION-ATTRIBUTE')))
    _ea_teletexDomainDefinedAttributes_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE)
    __ea_teletexDomainDefinedAttributes_val_Type__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-X400Address-2009', 'TeletexDomainDefinedAttribute')))
    _ea_teletexDomainDefinedAttributes_val_Type._cont = __ea_teletexDomainDefinedAttributes_val_Type__item_
    _ea_teletexDomainDefinedAttributes_val_Type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=4)], ev=None, er=[])
    ea_teletexDomainDefinedAttributes._val = dict([('Type', _ea_teletexDomainDefinedAttributes_val_Type), ('id', 6)])
    
    #-----< TeletexDomainDefinedAttribute >-----#
    TeletexDomainDefinedAttribute = SEQ(name='TeletexDomainDefinedAttribute', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_type = STR_TELE(name='type', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_type._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    _TeletexDomainDefinedAttribute_value = STR_TELE(name='value', mode=MODE_TYPE)
    _TeletexDomainDefinedAttribute_value._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    TeletexDomainDefinedAttribute._cont = ASN1Dict([
        ('type', _TeletexDomainDefinedAttribute_type),
        ('value', _TeletexDomainDefinedAttribute_value),
        ])
    TeletexDomainDefinedAttribute._ext = None
    
    #-----< ub-match >-----#
    ub_match = INT(name='ub-match', mode=MODE_VALUE)
    ub_match._val = 128
    
    #-----< ub-common-name-length >-----#
    ub_common_name_length = INT(name='ub-common-name-length', mode=MODE_VALUE)
    ub_common_name_length._val = 64
    
    #-----< ub-country-name-alpha-length >-----#
    ub_country_name_alpha_length = INT(name='ub-country-name-alpha-length', mode=MODE_VALUE)
    ub_country_name_alpha_length._val = 2
    
    #-----< ub-country-name-numeric-length >-----#
    ub_country_name_numeric_length = INT(name='ub-country-name-numeric-length', mode=MODE_VALUE)
    ub_country_name_numeric_length._val = 3
    
    #-----< ub-domain-defined-attributes >-----#
    ub_domain_defined_attributes = INT(name='ub-domain-defined-attributes', mode=MODE_VALUE)
    ub_domain_defined_attributes._val = 4
    
    #-----< ub-domain-defined-attribute-type-length >-----#
    ub_domain_defined_attribute_type_length = INT(name='ub-domain-defined-attribute-type-length', mode=MODE_VALUE)
    ub_domain_defined_attribute_type_length._val = 8
    
    #-----< ub-domain-defined-attribute-value-length >-----#
    ub_domain_defined_attribute_value_length = INT(name='ub-domain-defined-attribute-value-length', mode=MODE_VALUE)
    ub_domain_defined_attribute_value_length._val = 128
    
    #-----< ub-domain-name-length >-----#
    ub_domain_name_length = INT(name='ub-domain-name-length', mode=MODE_VALUE)
    ub_domain_name_length._val = 16
    
    #-----< ub-extension-attributes >-----#
    ub_extension_attributes = INT(name='ub-extension-attributes', mode=MODE_VALUE)
    ub_extension_attributes._val = 256
    
    #-----< ub-e163-4-number-length >-----#
    ub_e163_4_number_length = INT(name='ub-e163-4-number-length', mode=MODE_VALUE)
    ub_e163_4_number_length._val = 15
    
    #-----< ub-e163-4-sub-address-length >-----#
    ub_e163_4_sub_address_length = INT(name='ub-e163-4-sub-address-length', mode=MODE_VALUE)
    ub_e163_4_sub_address_length._val = 40
    
    #-----< ub-generation-qualifier-length >-----#
    ub_generation_qualifier_length = INT(name='ub-generation-qualifier-length', mode=MODE_VALUE)
    ub_generation_qualifier_length._val = 3
    
    #-----< ub-given-name-length >-----#
    ub_given_name_length = INT(name='ub-given-name-length', mode=MODE_VALUE)
    ub_given_name_length._val = 16
    
    #-----< ub-initials-length >-----#
    ub_initials_length = INT(name='ub-initials-length', mode=MODE_VALUE)
    ub_initials_length._val = 5
    
    #-----< ub-integer-options >-----#
    ub_integer_options = INT(name='ub-integer-options', mode=MODE_VALUE)
    ub_integer_options._val = 256
    
    #-----< ub-numeric-user-id-length >-----#
    ub_numeric_user_id_length = INT(name='ub-numeric-user-id-length', mode=MODE_VALUE)
    ub_numeric_user_id_length._val = 32
    
    #-----< ub-organization-name-length >-----#
    ub_organization_name_length = INT(name='ub-organization-name-length', mode=MODE_VALUE)
    ub_organization_name_length._val = 64
    
    #-----< ub-organizational-unit-name-length >-----#
    ub_organizational_unit_name_length = INT(name='ub-organizational-unit-name-length', mode=MODE_VALUE)
    ub_organizational_unit_name_length._val = 32
    
    #-----< ub-organizational-units >-----#
    ub_organizational_units = INT(name='ub-organizational-units', mode=MODE_VALUE)
    ub_organizational_units._val = 4
    
    #-----< ub-pds-name-length >-----#
    ub_pds_name_length = INT(name='ub-pds-name-length', mode=MODE_VALUE)
    ub_pds_name_length._val = 16
    
    #-----< ub-pds-parameter-length >-----#
    ub_pds_parameter_length = INT(name='ub-pds-parameter-length', mode=MODE_VALUE)
    ub_pds_parameter_length._val = 30
    
    #-----< ub-pds-physical-address-lines >-----#
    ub_pds_physical_address_lines = INT(name='ub-pds-physical-address-lines', mode=MODE_VALUE)
    ub_pds_physical_address_lines._val = 6
    
    #-----< ub-postal-code-length >-----#
    ub_postal_code_length = INT(name='ub-postal-code-length', mode=MODE_VALUE)
    ub_postal_code_length._val = 16
    
    #-----< ub-surname-length >-----#
    ub_surname_length = INT(name='ub-surname-length', mode=MODE_VALUE)
    ub_surname_length._val = 40
    
    #-----< ub-terminal-id-length >-----#
    ub_terminal_id_length = INT(name='ub-terminal-id-length', mode=MODE_VALUE)
    ub_terminal_id_length._val = 24
    
    #-----< ub-unformatted-address-length >-----#
    ub_unformatted_address_length = INT(name='ub-unformatted-address-length', mode=MODE_VALUE)
    ub_unformatted_address_length._val = 180
    
    #-----< ub-x121-address-length >-----#
    ub_x121_address_length = INT(name='ub-x121-address-length', mode=MODE_VALUE)
    ub_x121_address_length._val = 16
    
    _all_ = [
        _ORAddress_built_in_standard_attributes,
        _ORAddress_built_in_domain_defined_attributes,
        _ORAddress_extension_attributes,
        ORAddress,
        _BuiltInStandardAttributes_country_name,
        _BuiltInStandardAttributes_administration_domain_name,
        _BuiltInStandardAttributes_network_address,
        _BuiltInStandardAttributes_terminal_identifier,
        _BuiltInStandardAttributes_private_domain_name,
        _BuiltInStandardAttributes_organization_name,
        _BuiltInStandardAttributes_numeric_user_identifier,
        _BuiltInStandardAttributes_personal_name,
        _BuiltInStandardAttributes_organizational_unit_names,
        BuiltInStandardAttributes,
        _CountryName_x121_dcc_code,
        _CountryName_iso_3166_alpha2_code,
        CountryName,
        _AdministrationDomainName_numeric,
        _AdministrationDomainName_printable,
        AdministrationDomainName,
        NetworkAddress,
        X121Address,
        TerminalIdentifier,
        _PrivateDomainName_numeric,
        _PrivateDomainName_printable,
        PrivateDomainName,
        OrganizationName,
        NumericUserIdentifier,
        _PersonalName_surname,
        _PersonalName_given_name,
        _PersonalName_initials,
        _PersonalName_generation_qualifier,
        PersonalName,
        _OrganizationalUnitNames__item_,
        OrganizationalUnitNames,
        OrganizationalUnitName,
        _BuiltInDomainDefinedAttributes__item_,
        BuiltInDomainDefinedAttributes,
        _BuiltInDomainDefinedAttribute_type,
        _BuiltInDomainDefinedAttribute_value,
        BuiltInDomainDefinedAttribute,
        _ExtensionAttributes__item_,
        ExtensionAttributes,
        _EXTENSION_ATTRIBUTE_id,
        _EXTENSION_ATTRIBUTE_Type,
        EXTENSION_ATTRIBUTE,
        __ExtensionAttribute_extension_attribute_type_tab,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_0,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_1,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_2,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_surname,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_given_name,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_initials,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_3_generation_qualifier,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_3,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_4__item_,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_4,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_5,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_6_x121_dcc_code,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_6_iso_3166_alpha2_code,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_6,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_7_numeric_code,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_7_printable_code,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_7,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_8,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_9,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_10,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_11,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_12,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_13,
        _____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_printable_address__item_,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_printable_address,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_14_teletex_string,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_14,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_15,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_16,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_17,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_18,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_19,
        _____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address_number,
        _____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address_sub_address,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_e163_4_address,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_20_psap_address,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_20,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_21,
        ____ExtensionAttribute_extension_attribute_type_tab_val_Type_22__item_,
        ___ExtensionAttribute_extension_attribute_type_tab_val_Type_22,
        _ExtensionAttribute_extension_attribute_type,
        _ExtensionAttribute_extension_attribute_value,
        ExtensionAttribute,
        SupportedExtensionAttributes,
        _SupportedExtensionAttributes_val_Type_0,
        _SupportedExtensionAttributes_val_Type_1,
        _SupportedExtensionAttributes_val_Type_2,
        __SupportedExtensionAttributes_val_Type_3_surname,
        __SupportedExtensionAttributes_val_Type_3_given_name,
        __SupportedExtensionAttributes_val_Type_3_initials,
        __SupportedExtensionAttributes_val_Type_3_generation_qualifier,
        _SupportedExtensionAttributes_val_Type_3,
        __SupportedExtensionAttributes_val_Type_4__item_,
        _SupportedExtensionAttributes_val_Type_4,
        _SupportedExtensionAttributes_val_Type_5,
        __SupportedExtensionAttributes_val_Type_6_x121_dcc_code,
        __SupportedExtensionAttributes_val_Type_6_iso_3166_alpha2_code,
        _SupportedExtensionAttributes_val_Type_6,
        __SupportedExtensionAttributes_val_Type_7_numeric_code,
        __SupportedExtensionAttributes_val_Type_7_printable_code,
        _SupportedExtensionAttributes_val_Type_7,
        _SupportedExtensionAttributes_val_Type_8,
        _SupportedExtensionAttributes_val_Type_9,
        _SupportedExtensionAttributes_val_Type_10,
        _SupportedExtensionAttributes_val_Type_11,
        _SupportedExtensionAttributes_val_Type_12,
        _SupportedExtensionAttributes_val_Type_13,
        ___SupportedExtensionAttributes_val_Type_14_printable_address__item_,
        __SupportedExtensionAttributes_val_Type_14_printable_address,
        __SupportedExtensionAttributes_val_Type_14_teletex_string,
        _SupportedExtensionAttributes_val_Type_14,
        _SupportedExtensionAttributes_val_Type_15,
        _SupportedExtensionAttributes_val_Type_16,
        _SupportedExtensionAttributes_val_Type_17,
        _SupportedExtensionAttributes_val_Type_18,
        _SupportedExtensionAttributes_val_Type_19,
        ___SupportedExtensionAttributes_val_Type_20_e163_4_address_number,
        ___SupportedExtensionAttributes_val_Type_20_e163_4_address_sub_address,
        __SupportedExtensionAttributes_val_Type_20_e163_4_address,
        __SupportedExtensionAttributes_val_Type_20_psap_address,
        _SupportedExtensionAttributes_val_Type_20,
        _SupportedExtensionAttributes_val_Type_21,
        __SupportedExtensionAttributes_val_Type_22__item_,
        _SupportedExtensionAttributes_val_Type_22,
        ea_commonName,
        _ea_commonName_val_Type,
        ea_teletexCommonName,
        _ea_teletexCommonName_val_Type,
        ea_teletexOrganizationName,
        _ea_teletexOrganizationName_val_Type,
        ea_teletexPersonalName,
        __ea_teletexPersonalName_val_Type_surname,
        __ea_teletexPersonalName_val_Type_given_name,
        __ea_teletexPersonalName_val_Type_initials,
        __ea_teletexPersonalName_val_Type_generation_qualifier,
        _ea_teletexPersonalName_val_Type,
        ea_teletexOrganizationalUnitNames,
        __ea_teletexOrganizationalUnitNames_val_Type__item_,
        _ea_teletexOrganizationalUnitNames_val_Type,
        TeletexOrganizationalUnitName,
        ea_pDSName,
        _ea_pDSName_val_Type,
        ea_physicalDeliveryCountryName,
        __ea_physicalDeliveryCountryName_val_Type_x121_dcc_code,
        __ea_physicalDeliveryCountryName_val_Type_iso_3166_alpha2_code,
        _ea_physicalDeliveryCountryName_val_Type,
        ea_postalCode,
        __ea_postalCode_val_Type_numeric_code,
        __ea_postalCode_val_Type_printable_code,
        _ea_postalCode_val_Type,
        ea_physicalDeliveryOfficeName,
        _ea_physicalDeliveryOfficeName_val_Type,
        ea_physicalDeliveryOfficeNumber,
        _ea_physicalDeliveryOfficeNumber_val_Type,
        ea_extensionORAddressComponents,
        _ea_extensionORAddressComponents_val_Type,
        ea_physicalDeliveryPersonalName,
        _ea_physicalDeliveryPersonalName_val_Type,
        ea_physicalDeliveryOrganizationName,
        _ea_physicalDeliveryOrganizationName_val_Type,
        ea_extensionPhysicalDeliveryAddressComponents,
        _ea_extensionPhysicalDeliveryAddressComponents_val_Type,
        ea_unformattedPostalAddress,
        ___ea_unformattedPostalAddress_val_Type_printable_address__item_,
        __ea_unformattedPostalAddress_val_Type_printable_address,
        __ea_unformattedPostalAddress_val_Type_teletex_string,
        _ea_unformattedPostalAddress_val_Type,
        ea_streetAddress,
        _ea_streetAddress_val_Type,
        ea_postOfficeBoxAddress,
        _ea_postOfficeBoxAddress_val_Type,
        ea_posteRestanteAddress,
        _ea_posteRestanteAddress_val_Type,
        ea_uniquePostalName,
        _ea_uniquePostalName_val_Type,
        ea_localPostalAttributes,
        _ea_localPostalAttributes_val_Type,
        _PDSParameter_printable_string,
        _PDSParameter_teletex_string,
        PDSParameter,
        ea_extendedNetworkAddress,
        ___ea_extendedNetworkAddress_val_Type_e163_4_address_number,
        ___ea_extendedNetworkAddress_val_Type_e163_4_address_sub_address,
        __ea_extendedNetworkAddress_val_Type_e163_4_address,
        __ea_extendedNetworkAddress_val_Type_psap_address,
        _ea_extendedNetworkAddress_val_Type,
        _PresentationAddress_pSelector,
        _PresentationAddress_sSelector,
        _PresentationAddress_tSelector,
        __PresentationAddress_nAddresses__item_,
        _PresentationAddress_nAddresses,
        PresentationAddress,
        ea_terminalType,
        _ea_terminalType_val_Type,
        ea_teletexDomainDefinedAttributes,
        __ea_teletexDomainDefinedAttributes_val_Type__item_,
        _ea_teletexDomainDefinedAttributes_val_Type,
        _TeletexDomainDefinedAttribute_type,
        _TeletexDomainDefinedAttribute_value,
        TeletexDomainDefinedAttribute,
        ub_match,
        ub_common_name_length,
        ub_country_name_alpha_length,
        ub_country_name_numeric_length,
        ub_domain_defined_attributes,
        ub_domain_defined_attribute_type_length,
        ub_domain_defined_attribute_value_length,
        ub_domain_name_length,
        ub_extension_attributes,
        ub_e163_4_number_length,
        ub_e163_4_sub_address_length,
        ub_generation_qualifier_length,
        ub_given_name_length,
        ub_initials_length,
        ub_integer_options,
        ub_numeric_user_id_length,
        ub_organization_name_length,
        ub_organizational_unit_name_length,
        ub_organizational_units,
        ub_pds_name_length,
        ub_pds_parameter_length,
        ub_pds_physical_address_lines,
        ub_postal_code_length,
        ub_surname_length,
        ub_terminal_id_length,
        ub_unformatted_address_length,
        ub_x121_address_length,
    ]

class SCVP_2009:

    _name_  = 'SCVP-2009'
    _oid_   = [1, 3, 6, 1, 5, 5, 7, 0, 52]
    
    _obj_ = [
        'ContentTypes',
        'id-ct',
        'ct-scvp-certValRequest',
        'id-ct-scvp-certValRequest',
        'CVRequest',
        'RequestExtensions',
        'Query',
        'QueryExtensions',
        'CertReferences',
        'CertReference',
        'PKCReference',
        'ACReference',
        'HashAlgorithm',
        'SCVPCertID',
        'SCVPIssuerSerial',
        'ValidationPolicy',
        'CertChecks',
        'WantBack',
        'POLICY',
        'ValidationPolRefSet',
        'ValidationPolRef',
        'ValidationAlgSet',
        'ValidationAlg',
        'NameValidationAlgSet',
        'NameValidationAlgParams',
        'TrustAnchors',
        'KeyAgreePublicKey',
        'SupportedKeyAgreePublicKeys',
        'SupportedMACAlgorithms',
        'SupportedKeyDerivationFunctions',
        'ResponseFlags',
        'CertBundle',
        'RevocationInfos',
        'RevocationInfo',
        'REV-INFO',
        'OtherRevInfo',
        'ct-scvp-certValResponse',
        'id-ct-scvp-certValResponse',
        'CVResponse',
        'CVResponseExtensions',
        'ResponseStatus',
        'CVStatusCode',
        'RespValidationPolicy',
        'RequestReference',
        'HashValue',
        'ReplyObjects',
        'CertReply',
        'ReplyStatus',
        'ReplyChecks',
        'ReplyCheck',
        'ReplyWantBacks',
        'ReplyWantBack',
        'WANT-BACK',
        'AllWantBacks',
        'CertBundles',
        'RevInfoWantBack',
        'SCVPResponses',
        'ct-scvp-valPolRequest',
        'id-ct-scvp-valPolRequest',
        'ValPolRequest',
        'ct-scvp-valPolResponse',
        'id-ct-scvp-valPolResponse',
        'ValPolResponse',
        'ResponseTypes',
        'RevocationInfoTypes',
        'AuthPolicy',
        'id-stc',
        'CertCheckSet',
        'id-stc-build-pkc-path',
        'id-stc-build-valid-pkc-path',
        'id-stc-build-status-checked-pkc-path',
        'ACertCheckSet',
        'id-stc-build-aa-path',
        'id-stc-build-valid-aa-path',
        'id-stc-build-status-checked-aa-path',
        'id-stc-status-check-ac-and-build-status-checked-aa-path',
        'id-swb',
        'WantBackSet',
        'ACertWantBackSet',
        'AnyWantBackSet',
        'swb-pkc-best-cert-path',
        'id-swb-pkc-best-cert-path',
        'swb-pkc-revocation-info',
        'id-swb-pkc-revocation-info',
        'swb-pkc-public-key-info',
        'id-swb-pkc-public-key-info',
        'swb-aa-cert-path',
        'id-swb-aa-cert-path',
        'swb-aa-revocation-info',
        'id-swb-aa-revocation-info',
        'swb-ac-revocation-info',
        'id-swb-ac-revocation-info',
        'swb-relayed-responses',
        'id-swb-relayed-responses',
        'swb-pkc-all-cert-paths',
        'id-swb-pkc-all-cert-paths',
        'swb-pkc-ee-revocation-info',
        'id-swb-pkc-ee-revocation-info',
        'swb-pkc-CAs-revocation-info',
        'id-swb-pkc-CAs-revocation-info',
        'swb-pkc-cert',
        'id-swb-pkc-cert',
        'swb-ac-cert',
        'id-swb-ac-cert',
        'id-svp',
        'svp-defaultValPolicy',
        'id-svp-defaultValPolicy',
        'svp-basicValAlg',
        'id-svp-basicValAlg',
        'id-bvae',
        'BasicValidationErrorSet',
        'id-bvae-expired',
        'id-bvae-not-yet-valid',
        'id-bvae-wrongTrustAnchor',
        'id-bvae-noValidCertPath',
        'id-bvae-revoked',
        'id-bvae-invalidKeyPurpose',
        'id-bvae-invalidKeyUsage',
        'id-bvae-invalidCertPolicy',
        'svp-nameValAlg',
        'id-svp-nameValAlg',
        'NameCompAlgSet',
        'id-nva-dnCompAlg',
        'id-nvae',
        'NameValidationErrorSet',
        'id-nvae-name-mismatch',
        'id-nvae-no-name',
        'id-nvae-unknown-alg',
        'id-nvae-bad-name',
        'id-nvae-bad-name-type',
        'id-nvae-mixed-names',
        'id-kp',
        'SvcpExtKeyUsageSet',
        'id-kp-scvpServer',
        'id-kp-scvpClient',
        ]
    _type_ = [
        'CVRequest',
        'Query',
        'CertReferences',
        'CertReference',
        'PKCReference',
        'ACReference',
        'HashAlgorithm',
        'SCVPCertID',
        'SCVPIssuerSerial',
        'ValidationPolicy',
        'CertChecks',
        'WantBack',
        'POLICY',
        'ValidationPolRef',
        'ValidationAlg',
        'NameValidationAlgParams',
        'TrustAnchors',
        'KeyAgreePublicKey',
        'ResponseFlags',
        'CertBundle',
        'RevocationInfos',
        'RevocationInfo',
        'REV-INFO',
        'OtherRevInfo',
        'CVResponse',
        'ResponseStatus',
        'CVStatusCode',
        'RespValidationPolicy',
        'RequestReference',
        'HashValue',
        'ReplyObjects',
        'CertReply',
        'ReplyStatus',
        'ReplyChecks',
        'ReplyCheck',
        'ReplyWantBacks',
        'ReplyWantBack',
        'WANT-BACK',
        'CertBundles',
        'RevInfoWantBack',
        'SCVPResponses',
        'ValPolRequest',
        'ValPolResponse',
        'ResponseTypes',
        'RevocationInfoTypes',
        'AuthPolicy',
        ]
    _set_ = [
        'ContentTypes',
        'RequestExtensions',
        'QueryExtensions',
        'ValidationPolRefSet',
        'ValidationAlgSet',
        'NameValidationAlgSet',
        'SupportedKeyAgreePublicKeys',
        'SupportedMACAlgorithms',
        'SupportedKeyDerivationFunctions',
        'CVResponseExtensions',
        'AllWantBacks',
        'CertCheckSet',
        'ACertCheckSet',
        'WantBackSet',
        'ACertWantBackSet',
        'AnyWantBackSet',
        'BasicValidationErrorSet',
        'NameCompAlgSet',
        'NameValidationErrorSet',
        'SvcpExtKeyUsageSet',
        ]
    _val_ = [
        'id-ct',
        'ct-scvp-certValRequest',
        'id-ct-scvp-certValRequest',
        'ct-scvp-certValResponse',
        'id-ct-scvp-certValResponse',
        'ct-scvp-valPolRequest',
        'id-ct-scvp-valPolRequest',
        'ct-scvp-valPolResponse',
        'id-ct-scvp-valPolResponse',
        'id-stc',
        'id-stc-build-pkc-path',
        'id-stc-build-valid-pkc-path',
        'id-stc-build-status-checked-pkc-path',
        'id-stc-build-aa-path',
        'id-stc-build-valid-aa-path',
        'id-stc-build-status-checked-aa-path',
        'id-stc-status-check-ac-and-build-status-checked-aa-path',
        'id-swb',
        'swb-pkc-best-cert-path',
        'id-swb-pkc-best-cert-path',
        'swb-pkc-revocation-info',
        'id-swb-pkc-revocation-info',
        'swb-pkc-public-key-info',
        'id-swb-pkc-public-key-info',
        'swb-aa-cert-path',
        'id-swb-aa-cert-path',
        'swb-aa-revocation-info',
        'id-swb-aa-revocation-info',
        'swb-ac-revocation-info',
        'id-swb-ac-revocation-info',
        'swb-relayed-responses',
        'id-swb-relayed-responses',
        'swb-pkc-all-cert-paths',
        'id-swb-pkc-all-cert-paths',
        'swb-pkc-ee-revocation-info',
        'id-swb-pkc-ee-revocation-info',
        'swb-pkc-CAs-revocation-info',
        'id-swb-pkc-CAs-revocation-info',
        'swb-pkc-cert',
        'id-swb-pkc-cert',
        'swb-ac-cert',
        'id-swb-ac-cert',
        'id-svp',
        'svp-defaultValPolicy',
        'id-svp-defaultValPolicy',
        'svp-basicValAlg',
        'id-svp-basicValAlg',
        'id-bvae',
        'id-bvae-expired',
        'id-bvae-not-yet-valid',
        'id-bvae-wrongTrustAnchor',
        'id-bvae-noValidCertPath',
        'id-bvae-revoked',
        'id-bvae-invalidKeyPurpose',
        'id-bvae-invalidKeyUsage',
        'id-bvae-invalidCertPolicy',
        'svp-nameValAlg',
        'id-svp-nameValAlg',
        'id-nva-dnCompAlg',
        'id-nvae',
        'id-nvae-name-mismatch',
        'id-nvae-no-name',
        'id-nvae-unknown-alg',
        'id-nvae-bad-name',
        'id-nvae-bad-name-type',
        'id-nvae-mixed-names',
        'id-kp',
        'id-kp-scvpServer',
        'id-kp-scvpClient',
        ]
    _class_ = [
        'ContentTypes',
        'ct-scvp-certValRequest',
        'RequestExtensions',
        'QueryExtensions',
        'POLICY',
        'ValidationPolRefSet',
        'ValidationAlgSet',
        'NameValidationAlgSet',
        'SupportedKeyAgreePublicKeys',
        'SupportedMACAlgorithms',
        'SupportedKeyDerivationFunctions',
        'REV-INFO',
        'ct-scvp-certValResponse',
        'CVResponseExtensions',
        'WANT-BACK',
        'AllWantBacks',
        'ct-scvp-valPolRequest',
        'ct-scvp-valPolResponse',
        'WantBackSet',
        'ACertWantBackSet',
        'AnyWantBackSet',
        'swb-pkc-best-cert-path',
        'swb-pkc-revocation-info',
        'swb-pkc-public-key-info',
        'swb-aa-cert-path',
        'swb-aa-revocation-info',
        'swb-ac-revocation-info',
        'swb-relayed-responses',
        'swb-pkc-all-cert-paths',
        'swb-pkc-ee-revocation-info',
        'swb-pkc-CAs-revocation-info',
        'swb-pkc-cert',
        'swb-ac-cert',
        'svp-defaultValPolicy',
        'svp-basicValAlg',
        'svp-nameValAlg',
        ]
    _param_ = [
        ]
    
    #-----< ContentTypes >-----#
    ContentTypes = CLASS(name='ContentTypes', mode=MODE_SET, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ContentTypes_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CVRequest')))
    _ContentTypes_val_Type_1 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CVResponse')))
    _ContentTypes_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ValPolRequest')))
    _ContentTypes_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ValPolResponse')))
    ContentTypes._val = ASN1Set(rv=[dict([('Type', _ContentTypes_val_Type_0), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 10))]), dict([('Type', _ContentTypes_val_Type_1), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 11))]), dict([('Type', _ContentTypes_val_Type_2), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 12))]), dict([('Type', _ContentTypes_val_Type_3), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 13))])], rr=[], ev=[], er=[])
    
    #-----< id-ct >-----#
    id_ct = OID(name='id-ct', mode=MODE_VALUE)
    id_ct._val = (1, 2, 840, 113549, 1, 9, 16, 1)
    
    #-----< ct-scvp-certValRequest >-----#
    ct_scvp_certValRequest = CLASS(name='ct-scvp-certValRequest', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_scvp_certValRequest_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CVRequest')))
    ct_scvp_certValRequest._val = dict([('Type', _ct_scvp_certValRequest_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 10))])
    
    #-----< id-ct-scvp-certValRequest >-----#
    id_ct_scvp_certValRequest = OID(name='id-ct-scvp-certValRequest', mode=MODE_VALUE)
    id_ct_scvp_certValRequest._val = (1, 2, 840, 113549, 1, 9, 16, 1, 10)
    
    #-----< CVRequest >-----#
    CVRequest = SEQ(name='CVRequest', mode=MODE_TYPE)
    _CVRequest_cvRequestVersion = INT(name='cvRequestVersion', mode=MODE_TYPE, default=1)
    _CVRequest_query = SEQ(name='query', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'Query')))
    _CVRequest_requestorRef = SEQ_OF(name='requestorRef', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')), opt=True)
    _CVRequest_requestNonce = OCT_STR(name='requestNonce', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CVRequest_requestorName = CHOICE(name='requestorName', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')), opt=True)
    _CVRequest_responderName = CHOICE(name='responderName', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralName')), opt=True)
    _CVRequest_requestExtensions = SEQ_OF(name='requestExtensions', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __CVRequest_requestExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___CVRequest_requestExtensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____CVRequest_requestExtensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    ____CVRequest_requestExtensions__item__extnID_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CVRequest_requestExtensions__item__extnID._const_tab = ____CVRequest_requestExtensions__item__extnID_tab
    ___CVRequest_requestExtensions__item__extnID._const_tab_at = None
    ___CVRequest_requestExtensions__item__extnID._const_tab_id = 'id'
    ___CVRequest_requestExtensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___CVRequest_requestExtensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____CVRequest_requestExtensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    _____CVRequest_requestExtensions__item__extnValue_contain_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____CVRequest_requestExtensions__item__extnValue_contain_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CVRequest_requestExtensions__item__extnValue_contain._const_tab = _____CVRequest_requestExtensions__item__extnValue_contain_tab
    ____CVRequest_requestExtensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____CVRequest_requestExtensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___CVRequest_requestExtensions__item__extnValue._const_cont = ____CVRequest_requestExtensions__item__extnValue_contain
    __CVRequest_requestExtensions__item_._cont = ASN1Dict([
        ('extnID', ___CVRequest_requestExtensions__item__extnID),
        ('critical', ___CVRequest_requestExtensions__item__critical),
        ('extnValue', ___CVRequest_requestExtensions__item__extnValue),
        ])
    __CVRequest_requestExtensions__item_._ext = None
    _CVRequest_requestExtensions._cont = __CVRequest_requestExtensions__item_
    _CVRequest_requestExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _CVRequest_signatureAlg = SEQ(name='signatureAlg', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')), opt=True)
    __CVRequest_signatureAlg_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___CVRequest_signatureAlg_algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    ____CVRequest_signatureAlg_algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0 = INT(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Params')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1 = OCT_STR(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECPoint')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1 = CHOICE(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECParameters')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    ____CVRequest_signatureAlg_algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    ____CVRequest_signatureAlg_algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    ____CVRequest_signatureAlg_algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    ____CVRequest_signatureAlg_algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    ____CVRequest_signatureAlg_algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    ____CVRequest_signatureAlg_algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    __SIGNATURE_ALGORITHM_HashSet_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_HashSet_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1 = SEQ(name='KeyValue', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'RSAPublicKey')))
    __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ___CVRequest_signatureAlg_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', ____CVRequest_signatureAlg_algorithm_tab_val_Value_3), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', ____CVRequest_signatureAlg_algorithm_tab_val_Value_4), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', ____CVRequest_signatureAlg_algorithm_tab_val_Value_5), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', ____CVRequest_signatureAlg_algorithm_tab_val_Value_6), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', ____CVRequest_signatureAlg_algorithm_tab_val_Value_7), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', ____CVRequest_signatureAlg_algorithm_tab_val_Value_8), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', ____CVRequest_signatureAlg_algorithm_tab_val_Value_9), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', ____CVRequest_signatureAlg_algorithm_tab_val_Value_10), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', ____CVRequest_signatureAlg_algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    __CVRequest_signatureAlg_algorithm._const_tab = ___CVRequest_signatureAlg_algorithm_tab
    __CVRequest_signatureAlg_algorithm._const_tab_at = None
    __CVRequest_signatureAlg_algorithm._const_tab_id = 'id'
    __CVRequest_signatureAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    __CVRequest_signatureAlg_parameters._const_tab = ___CVRequest_signatureAlg_algorithm_tab
    __CVRequest_signatureAlg_parameters._const_tab_at = ('..', 'algorithm')
    __CVRequest_signatureAlg_parameters._const_tab_id = 'Params'
    _CVRequest_signatureAlg._cont = ASN1Dict([
        ('algorithm', __CVRequest_signatureAlg_algorithm),
        ('parameters', __CVRequest_signatureAlg_parameters),
        ])
    _CVRequest_signatureAlg._ext = None
    _CVRequest_hashAlg = OID(name='hashAlg', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CVRequest_requestorText = STR_UTF8(name='requestorText', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CVRequest_requestorText._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    CVRequest._cont = ASN1Dict([
        ('cvRequestVersion', _CVRequest_cvRequestVersion),
        ('query', _CVRequest_query),
        ('requestorRef', _CVRequest_requestorRef),
        ('requestNonce', _CVRequest_requestNonce),
        ('requestorName', _CVRequest_requestorName),
        ('responderName', _CVRequest_responderName),
        ('requestExtensions', _CVRequest_requestExtensions),
        ('signatureAlg', _CVRequest_signatureAlg),
        ('hashAlg', _CVRequest_hashAlg),
        ('requestorText', _CVRequest_requestorText),
        ])
    CVRequest._ext = None
    
    #-----< RequestExtensions >-----#
    RequestExtensions = CLASS(name='RequestExtensions', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    RequestExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< Query >-----#
    Query = SEQ(name='Query', mode=MODE_TYPE)
    _Query_queriedCerts = CHOICE(name='queriedCerts', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertReferences')))
    _Query_checks = SEQ_OF(name='checks', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertChecks')))
    _Query_wantBack = SEQ_OF(name='wantBack', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'WantBack')), opt=True)
    _Query_validationPolicy = SEQ(name='validationPolicy', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ValidationPolicy')))
    _Query_responseFlags = SEQ(name='responseFlags', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ResponseFlags')), opt=True)
    _Query_serverContextInfo = OCT_STR(name='serverContextInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Query_validationTime = TIME_GEN(name='validationTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Query_intermediateCerts = SEQ_OF(name='intermediateCerts', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'CertBundle')), opt=True)
    _Query_revInfos = SEQ_OF(name='revInfos', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'RevocationInfos')), opt=True)
    _Query_producedAt = TIME_GEN(name='producedAt', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Query_queryExtensions = SEQ_OF(name='queryExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __Query_queryExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___Query_queryExtensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____Query_queryExtensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    ____Query_queryExtensions__item__extnID_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___Query_queryExtensions__item__extnID._const_tab = ____Query_queryExtensions__item__extnID_tab
    ___Query_queryExtensions__item__extnID._const_tab_at = None
    ___Query_queryExtensions__item__extnID._const_tab_id = 'id'
    ___Query_queryExtensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___Query_queryExtensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____Query_queryExtensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    _____Query_queryExtensions__item__extnValue_contain_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____Query_queryExtensions__item__extnValue_contain_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____Query_queryExtensions__item__extnValue_contain._const_tab = _____Query_queryExtensions__item__extnValue_contain_tab
    ____Query_queryExtensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____Query_queryExtensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___Query_queryExtensions__item__extnValue._const_cont = ____Query_queryExtensions__item__extnValue_contain
    __Query_queryExtensions__item_._cont = ASN1Dict([
        ('extnID', ___Query_queryExtensions__item__extnID),
        ('critical', ___Query_queryExtensions__item__critical),
        ('extnValue', ___Query_queryExtensions__item__extnValue),
        ])
    __Query_queryExtensions__item_._ext = None
    _Query_queryExtensions._cont = __Query_queryExtensions__item_
    _Query_queryExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    Query._cont = ASN1Dict([
        ('queriedCerts', _Query_queriedCerts),
        ('checks', _Query_checks),
        ('wantBack', _Query_wantBack),
        ('validationPolicy', _Query_validationPolicy),
        ('responseFlags', _Query_responseFlags),
        ('serverContextInfo', _Query_serverContextInfo),
        ('validationTime', _Query_validationTime),
        ('intermediateCerts', _Query_intermediateCerts),
        ('revInfos', _Query_revInfos),
        ('producedAt', _Query_producedAt),
        ('queryExtensions', _Query_queryExtensions),
        ])
    Query._ext = None
    
    #-----< QueryExtensions >-----#
    QueryExtensions = CLASS(name='QueryExtensions', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    QueryExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< CertReferences >-----#
    CertReferences = CHOICE(name='CertReferences', mode=MODE_TYPE)
    _CertReferences_pkcRefs = SEQ_OF(name='pkcRefs', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CertReferences_pkcRefs__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'PKCReference')))
    _CertReferences_pkcRefs._cont = __CertReferences_pkcRefs__item_
    _CertReferences_pkcRefs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _CertReferences_acRefs = SEQ_OF(name='acRefs', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __CertReferences_acRefs__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ACReference')))
    _CertReferences_acRefs._cont = __CertReferences_acRefs__item_
    _CertReferences_acRefs._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CertReferences._cont = ASN1Dict([
        ('pkcRefs', _CertReferences_pkcRefs),
        ('acRefs', _CertReferences_acRefs),
        ])
    CertReferences._ext = None
    
    #-----< CertReference >-----#
    CertReference = CHOICE(name='CertReference', mode=MODE_TYPE)
    _CertReference_pkc = CHOICE(name='pkc', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'PKCReference')))
    _CertReference_ac = CHOICE(name='ac', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ACReference')))
    CertReference._cont = ASN1Dict([
        ('pkc', _CertReference_pkc),
        ('ac', _CertReference_ac),
        ])
    CertReference._ext = None
    
    #-----< PKCReference >-----#
    PKCReference = CHOICE(name='PKCReference', mode=MODE_TYPE)
    _PKCReference_cert = SEQ(name='cert', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    _PKCReference_pkcRef = SEQ(name='pkcRef', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'SCVPCertID')))
    PKCReference._cont = ASN1Dict([
        ('cert', _PKCReference_cert),
        ('pkcRef', _PKCReference_pkcRef),
        ])
    PKCReference._ext = None
    
    #-----< ACReference >-----#
    ACReference = CHOICE(name='ACReference', mode=MODE_TYPE)
    _ACReference_attrCert = SEQ(name='attrCert', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttributeCertificate')))
    _ACReference_acRef = SEQ(name='acRef', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'SCVPCertID')))
    ACReference._cont = ASN1Dict([
        ('attrCert', _ACReference_attrCert),
        ('acRef', _ACReference_acRef),
        ])
    ACReference._ext = None
    
    #-----< HashAlgorithm >-----#
    HashAlgorithm = SEQ(name='HashAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    _HashAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['id']))
    __HashAlgorithm_algorithm_tab = CLASS(name='_tab_DIGEST-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM')))
    ___HashAlgorithm_algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    __HashAlgorithm_algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', ___HashAlgorithm_algorithm_tab_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])
    _HashAlgorithm_algorithm._const_tab = __HashAlgorithm_algorithm_tab
    _HashAlgorithm_algorithm._const_tab_at = None
    _HashAlgorithm_algorithm._const_tab_id = 'id'
    _HashAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'DIGEST-ALGORITHM'), ['Params']), opt=True)
    _HashAlgorithm_parameters._const_tab = __HashAlgorithm_algorithm_tab
    _HashAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    _HashAlgorithm_parameters._const_tab_id = 'Params'
    HashAlgorithm._cont = ASN1Dict([
        ('algorithm', _HashAlgorithm_algorithm),
        ('parameters', _HashAlgorithm_parameters),
        ])
    HashAlgorithm._ext = None
    
    #-----< SCVPCertID >-----#
    SCVPCertID = SEQ(name='SCVPCertID', mode=MODE_TYPE)
    _SCVPCertID_certHash = OCT_STR(name='certHash', mode=MODE_TYPE)
    _SCVPCertID_issuerSerial = SEQ(name='issuerSerial', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'SCVPIssuerSerial')))
    _SCVPCertID_hashAlgorithm = SEQ(name='hashAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'HashAlgorithm')), default=dict([('algorithm', (1, 3, 14, 3, 2, 26))]))
    SCVPCertID._cont = ASN1Dict([
        ('certHash', _SCVPCertID_certHash),
        ('issuerSerial', _SCVPCertID_issuerSerial),
        ('hashAlgorithm', _SCVPCertID_hashAlgorithm),
        ])
    SCVPCertID._ext = None
    
    #-----< SCVPIssuerSerial >-----#
    SCVPIssuerSerial = SEQ(name='SCVPIssuerSerial', mode=MODE_TYPE)
    _SCVPIssuerSerial_issuer = SEQ_OF(name='issuer', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    _SCVPIssuerSerial_serialNumber = INT(name='serialNumber', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateSerialNumber')))
    SCVPIssuerSerial._cont = ASN1Dict([
        ('issuer', _SCVPIssuerSerial_issuer),
        ('serialNumber', _SCVPIssuerSerial_serialNumber),
        ])
    SCVPIssuerSerial._ext = None
    
    #-----< ValidationPolicy >-----#
    ValidationPolicy = SEQ(name='ValidationPolicy', mode=MODE_TYPE)
    _ValidationPolicy_validationPolRef = SEQ(name='validationPolRef', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ValidationPolRef')))
    _ValidationPolicy_validationAlg = SEQ(name='validationAlg', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'ValidationAlg')), opt=True)
    _ValidationPolicy_userPolicySet = SEQ_OF(name='userPolicySet', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ValidationPolicy_userPolicySet__item_ = OID(name='_item_', mode=MODE_TYPE)
    _ValidationPolicy_userPolicySet._cont = __ValidationPolicy_userPolicySet__item_
    _ValidationPolicy_userPolicySet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ValidationPolicy_inhibitPolicyMapping = BOOL(name='inhibitPolicyMapping', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ValidationPolicy_requireExplicitPolicy = BOOL(name='requireExplicitPolicy', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ValidationPolicy_inhibitAnyPolicy = BOOL(name='inhibitAnyPolicy', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ValidationPolicy_trustAnchors = SEQ_OF(name='trustAnchors', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'TrustAnchors')), opt=True)
    _ValidationPolicy_keyUsages = SEQ_OF(name='keyUsages', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ValidationPolicy_keyUsages__item_ = BIT_STR(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyUsage')))
    _ValidationPolicy_keyUsages._cont = __ValidationPolicy_keyUsages__item_
    _ValidationPolicy_extendedKeyUsages = SEQ_OF(name='extendedKeyUsages', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ValidationPolicy_extendedKeyUsages__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyPurposeId')))
    _ValidationPolicy_extendedKeyUsages._cont = __ValidationPolicy_extendedKeyUsages__item_
    _ValidationPolicy_specifiedKeyUsages = SEQ_OF(name='specifiedKeyUsages', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ValidationPolicy_specifiedKeyUsages__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'KeyPurposeId')))
    _ValidationPolicy_specifiedKeyUsages._cont = __ValidationPolicy_specifiedKeyUsages__item_
    ValidationPolicy._cont = ASN1Dict([
        ('validationPolRef', _ValidationPolicy_validationPolRef),
        ('validationAlg', _ValidationPolicy_validationAlg),
        ('userPolicySet', _ValidationPolicy_userPolicySet),
        ('inhibitPolicyMapping', _ValidationPolicy_inhibitPolicyMapping),
        ('requireExplicitPolicy', _ValidationPolicy_requireExplicitPolicy),
        ('inhibitAnyPolicy', _ValidationPolicy_inhibitAnyPolicy),
        ('trustAnchors', _ValidationPolicy_trustAnchors),
        ('keyUsages', _ValidationPolicy_keyUsages),
        ('extendedKeyUsages', _ValidationPolicy_extendedKeyUsages),
        ('specifiedKeyUsages', _ValidationPolicy_specifiedKeyUsages),
        ])
    ValidationPolicy._ext = None
    
    #-----< CertChecks >-----#
    CertChecks = SEQ_OF(name='CertChecks', mode=MODE_TYPE)
    _CertChecks__item_ = OID(name='_item_', mode=MODE_TYPE)
    _CertChecks__item_._const_val = ASN1Set(rv=[(1, 3, 6, 1, 5, 5, 7, 17, 1), (1, 3, 6, 1, 5, 5, 7, 17, 2), (1, 3, 6, 1, 5, 5, 7, 17, 3), (1, 3, 6, 1, 5, 5, 7, 17, 4), (1, 3, 6, 1, 5, 5, 7, 17, 5), (1, 3, 6, 1, 5, 5, 7, 17, 6), (1, 3, 6, 1, 5, 5, 7, 17, 7)], rr=[], ev=[], er=[])
    CertChecks._cont = _CertChecks__item_
    CertChecks._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< WantBack >-----#
    WantBack = SEQ_OF(name='WantBack', mode=MODE_TYPE)
    _WantBack__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefClassField(('SCVP-2009', 'WANT-BACK'), ['id']))
    __WantBack__item__tab = CLASS(name='_tab_WANT-BACK', mode=MODE_SET, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    ___WantBack__item__tab_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    ___WantBack__item__tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    ___WantBack__item__tab_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ___WantBack__item__tab_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SubjectPublicKeyInfo')))
    ___WantBack__item__tab_val_Type_4 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundles')))
    ___WantBack__item__tab_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ___WantBack__item__tab_val_Type_6 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ___WantBack__item__tab_val_Type_7 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttributeCertificate')))
    ___WantBack__item__tab_val_Type_8 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    ___WantBack__item__tab_val_Type_9 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ___WantBack__item__tab_val_Type_10 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ___WantBack__item__tab_val_Type_11 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'SCVPResponses')))
    __WantBack__item__tab._val = ASN1Set(rv=[dict([('Type', ___WantBack__item__tab_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 10))]), dict([('Type', ___WantBack__item__tab_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 1))]), dict([('Type', ___WantBack__item__tab_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 2))]), dict([('Type', ___WantBack__item__tab_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 4))]), dict([('Type', ___WantBack__item__tab_val_Type_4), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 12))]), dict([('Type', ___WantBack__item__tab_val_Type_5), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 13))]), dict([('Type', ___WantBack__item__tab_val_Type_6), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 14))]), dict([('Type', ___WantBack__item__tab_val_Type_7), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 11))]), dict([('Type', ___WantBack__item__tab_val_Type_8), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 5))]), dict([('Type', ___WantBack__item__tab_val_Type_9), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 6))]), dict([('Type', ___WantBack__item__tab_val_Type_10), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 7))]), dict([('Type', ___WantBack__item__tab_val_Type_11), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 9))])], rr=[], ev=None, er=[])
    _WantBack__item_._const_tab = __WantBack__item__tab
    _WantBack__item_._const_tab_at = None
    _WantBack__item_._const_tab_id = 'id'
    WantBack._cont = _WantBack__item_
    WantBack._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< POLICY >-----#
    POLICY = CLASS(name='POLICY', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'ATTRIBUTE')))
    
    #-----< ValidationPolRefSet >-----#
    ValidationPolRefSet = CLASS(name='ValidationPolRefSet', mode=MODE_SET, typeref=ASN1RefType(('SCVP-2009', 'POLICY')))
    ValidationPolRefSet._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 7, 19, 1))])], rr=[], ev=[], er=[])
    
    #-----< ValidationPolRef >-----#
    ValidationPolRef = SEQ(name='ValidationPolRef', mode=MODE_TYPE)
    _ValidationPolRef_valPolId = OID(name='valPolId', mode=MODE_TYPE, typeref=ASN1RefClassField(('SCVP-2009', 'POLICY'), ['id']))
    _ValidationPolRef_valPolParams = OPEN(name='valPolParams', mode=MODE_TYPE, typeref=ASN1RefClassField(('SCVP-2009', 'POLICY'), ['Type']), opt=True)
    ValidationPolRef._cont = ASN1Dict([
        ('valPolId', _ValidationPolRef_valPolId),
        ('valPolParams', _ValidationPolRef_valPolParams),
        ])
    ValidationPolRef._ext = None
    
    #-----< ValidationAlgSet >-----#
    ValidationAlgSet = CLASS(name='ValidationAlgSet', mode=MODE_SET, typeref=ASN1RefType(('SCVP-2009', 'POLICY')))
    ValidationAlgSet._val = ASN1Set(rv=[dict([('id', (1, 3, 6, 1, 5, 5, 7, 19, 3))])], rr=[], ev=[], er=[])
    
    #-----< ValidationAlg >-----#
    ValidationAlg = SEQ(name='ValidationAlg', mode=MODE_TYPE)
    _ValidationAlg_valAlgId = OID(name='valAlgId', mode=MODE_TYPE, typeref=ASN1RefClassField(('SCVP-2009', 'POLICY'), ['id']))
    _ValidationAlg_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('SCVP-2009', 'POLICY'), ['Type']), opt=True)
    ValidationAlg._cont = ASN1Dict([
        ('valAlgId', _ValidationAlg_valAlgId),
        ('parameters', _ValidationAlg_parameters),
        ])
    ValidationAlg._ext = None
    
    #-----< NameValidationAlgSet >-----#
    NameValidationAlgSet = CLASS(name='NameValidationAlgSet', mode=MODE_SET, typeref=ASN1RefType(('SCVP-2009', 'POLICY')))
    _NameValidationAlgSet_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'NameValidationAlgParams')))
    NameValidationAlgSet._val = ASN1Set(rv=[dict([('Type', _NameValidationAlgSet_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 19, 2))])], rr=[], ev=[], er=[])
    
    #-----< NameValidationAlgParams >-----#
    NameValidationAlgParams = SEQ(name='NameValidationAlgParams', mode=MODE_TYPE)
    _NameValidationAlgParams_nameCompAlgId = OID(name='nameCompAlgId', mode=MODE_TYPE)
    _NameValidationAlgParams_nameCompAlgId._const_val = ASN1Set(rv=[(1, 3, 6, 1, 5, 5, 7, 19, 4)], rr=[], ev=[], er=[])
    _NameValidationAlgParams_validationNames = SEQ_OF(name='validationNames', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')))
    NameValidationAlgParams._cont = ASN1Dict([
        ('nameCompAlgId', _NameValidationAlgParams_nameCompAlgId),
        ('validationNames', _NameValidationAlgParams_validationNames),
        ])
    NameValidationAlgParams._ext = None
    
    #-----< TrustAnchors >-----#
    TrustAnchors = SEQ_OF(name='TrustAnchors', mode=MODE_TYPE)
    _TrustAnchors__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'PKCReference')))
    TrustAnchors._cont = _TrustAnchors__item_
    TrustAnchors._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< KeyAgreePublicKey >-----#
    KeyAgreePublicKey = SEQ(name='KeyAgreePublicKey', mode=MODE_TYPE)
    _KeyAgreePublicKey_algorithm = SEQ(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __KeyAgreePublicKey_algorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-AGREE'), ['id']))
    ___KeyAgreePublicKey_algorithm_algorithm_tab = CLASS(name='_tab_KEY-AGREE', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-AGREE')))
    ___KeyAgreePublicKey_algorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __KeyAgreePublicKey_algorithm_algorithm._const_tab = ___KeyAgreePublicKey_algorithm_algorithm_tab
    __KeyAgreePublicKey_algorithm_algorithm._const_tab_at = None
    __KeyAgreePublicKey_algorithm_algorithm._const_tab_id = 'id'
    __KeyAgreePublicKey_algorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-AGREE'), ['Params']), opt=True)
    ___KeyAgreePublicKey_algorithm_parameters_tab = CLASS(name='_tab_KEY-AGREE', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-AGREE')))
    ___KeyAgreePublicKey_algorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __KeyAgreePublicKey_algorithm_parameters._const_tab = ___KeyAgreePublicKey_algorithm_parameters_tab
    __KeyAgreePublicKey_algorithm_parameters._const_tab_at = ('..', 'algorithm')
    __KeyAgreePublicKey_algorithm_parameters._const_tab_id = 'Params'
    _KeyAgreePublicKey_algorithm._cont = ASN1Dict([
        ('algorithm', __KeyAgreePublicKey_algorithm_algorithm),
        ('parameters', __KeyAgreePublicKey_algorithm_parameters),
        ])
    _KeyAgreePublicKey_algorithm._ext = None
    _KeyAgreePublicKey_publicKey = BIT_STR(name='publicKey', mode=MODE_TYPE)
    _KeyAgreePublicKey_macAlgorithm = SEQ(name='macAlgorithm', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    __KeyAgreePublicKey_macAlgorithm_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['id']))
    ___KeyAgreePublicKey_macAlgorithm_algorithm_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ___KeyAgreePublicKey_macAlgorithm_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __KeyAgreePublicKey_macAlgorithm_algorithm._const_tab = ___KeyAgreePublicKey_macAlgorithm_algorithm_tab
    __KeyAgreePublicKey_macAlgorithm_algorithm._const_tab_at = None
    __KeyAgreePublicKey_macAlgorithm_algorithm._const_tab_id = 'id'
    __KeyAgreePublicKey_macAlgorithm_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'MAC-ALGORITHM'), ['Params']), opt=True)
    ___KeyAgreePublicKey_macAlgorithm_parameters_tab = CLASS(name='_tab_MAC-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    ___KeyAgreePublicKey_macAlgorithm_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __KeyAgreePublicKey_macAlgorithm_parameters._const_tab = ___KeyAgreePublicKey_macAlgorithm_parameters_tab
    __KeyAgreePublicKey_macAlgorithm_parameters._const_tab_at = ('..', 'algorithm')
    __KeyAgreePublicKey_macAlgorithm_parameters._const_tab_id = 'Params'
    _KeyAgreePublicKey_macAlgorithm._cont = ASN1Dict([
        ('algorithm', __KeyAgreePublicKey_macAlgorithm_algorithm),
        ('parameters', __KeyAgreePublicKey_macAlgorithm_parameters),
        ])
    _KeyAgreePublicKey_macAlgorithm._ext = None
    _KeyAgreePublicKey_kDF = SEQ(name='kDF', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')), opt=True)
    __KeyAgreePublicKey_kDF_algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-DERIVATION'), ['id']))
    ___KeyAgreePublicKey_kDF_algorithm_tab = CLASS(name='_tab_KEY-DERIVATION', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-DERIVATION')))
    ___KeyAgreePublicKey_kDF_algorithm_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __KeyAgreePublicKey_kDF_algorithm._const_tab = ___KeyAgreePublicKey_kDF_algorithm_tab
    __KeyAgreePublicKey_kDF_algorithm._const_tab_at = None
    __KeyAgreePublicKey_kDF_algorithm._const_tab_id = 'id'
    __KeyAgreePublicKey_kDF_parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'KEY-DERIVATION'), ['Params']), opt=True)
    ___KeyAgreePublicKey_kDF_parameters_tab = CLASS(name='_tab_KEY-DERIVATION', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-DERIVATION')))
    ___KeyAgreePublicKey_kDF_parameters_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    __KeyAgreePublicKey_kDF_parameters._const_tab = ___KeyAgreePublicKey_kDF_parameters_tab
    __KeyAgreePublicKey_kDF_parameters._const_tab_at = ('..', 'algorithm')
    __KeyAgreePublicKey_kDF_parameters._const_tab_id = 'Params'
    _KeyAgreePublicKey_kDF._cont = ASN1Dict([
        ('algorithm', __KeyAgreePublicKey_kDF_algorithm),
        ('parameters', __KeyAgreePublicKey_kDF_parameters),
        ])
    _KeyAgreePublicKey_kDF._ext = None
    KeyAgreePublicKey._cont = ASN1Dict([
        ('algorithm', _KeyAgreePublicKey_algorithm),
        ('publicKey', _KeyAgreePublicKey_publicKey),
        ('macAlgorithm', _KeyAgreePublicKey_macAlgorithm),
        ('kDF', _KeyAgreePublicKey_kDF),
        ])
    KeyAgreePublicKey._ext = None
    
    #-----< SupportedKeyAgreePublicKeys >-----#
    SupportedKeyAgreePublicKeys = CLASS(name='SupportedKeyAgreePublicKeys', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-AGREE')))
    SupportedKeyAgreePublicKeys._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SupportedMACAlgorithms >-----#
    SupportedMACAlgorithms = CLASS(name='SupportedMACAlgorithms', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'MAC-ALGORITHM')))
    SupportedMACAlgorithms._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< SupportedKeyDerivationFunctions >-----#
    SupportedKeyDerivationFunctions = CLASS(name='SupportedKeyDerivationFunctions', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'KEY-DERIVATION')))
    SupportedKeyDerivationFunctions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResponseFlags >-----#
    ResponseFlags = SEQ(name='ResponseFlags', mode=MODE_TYPE)
    _ResponseFlags_fullRequestInResponse = BOOL(name='fullRequestInResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=False)
    _ResponseFlags_responseValidationPolByRef = BOOL(name='responseValidationPolByRef', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _ResponseFlags_protectResponse = BOOL(name='protectResponse', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    _ResponseFlags_cachedResponse = BOOL(name='cachedResponse', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), default=True)
    ResponseFlags._cont = ASN1Dict([
        ('fullRequestInResponse', _ResponseFlags_fullRequestInResponse),
        ('responseValidationPolByRef', _ResponseFlags_responseValidationPolByRef),
        ('protectResponse', _ResponseFlags_protectResponse),
        ('cachedResponse', _ResponseFlags_cachedResponse),
        ])
    ResponseFlags._ext = None
    
    #-----< CertBundle >-----#
    CertBundle = SEQ_OF(name='CertBundle', mode=MODE_TYPE)
    _CertBundle__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    CertBundle._cont = _CertBundle__item_
    CertBundle._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< RevocationInfos >-----#
    RevocationInfos = SEQ_OF(name='RevocationInfos', mode=MODE_TYPE)
    _RevocationInfos__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevocationInfo')))
    RevocationInfos._cont = _RevocationInfos__item_
    RevocationInfos._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< RevocationInfo >-----#
    RevocationInfo = CHOICE(name='RevocationInfo', mode=MODE_TYPE)
    _RevocationInfo_crl = SEQ(name='crl', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateList')))
    _RevocationInfo_delta_crl = SEQ(name='delta-crl', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Explicit-2009', 'CertificateList')))
    _RevocationInfo_ocsp = SEQ(name='ocsp', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('OCSP-2009', 'OCSPResponse')))
    _RevocationInfo_other = SEQ(name='other', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'OtherRevInfo')))
    RevocationInfo._cont = ASN1Dict([
        ('crl', _RevocationInfo_crl),
        ('delta-crl', _RevocationInfo_delta_crl),
        ('ocsp', _RevocationInfo_ocsp),
        ('other', _RevocationInfo_other),
        ])
    RevocationInfo._ext = None
    
    #-----< REV-INFO >-----#
    REV_INFO = CLASS(name='REV-INFO', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< OtherRevInfo >-----#
    OtherRevInfo = SEQ(name='OtherRevInfo', mode=MODE_TYPE)
    _OtherRevInfo_riType = OID(name='riType', mode=MODE_TYPE, typeref=ASN1RefClassField(('SCVP-2009', 'REV-INFO'), ['id']))
    _OtherRevInfo_riValue = OPEN(name='riValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('SCVP-2009', 'REV-INFO'), ['Type']))
    OtherRevInfo._cont = ASN1Dict([
        ('riType', _OtherRevInfo_riType),
        ('riValue', _OtherRevInfo_riValue),
        ])
    OtherRevInfo._ext = None
    
    #-----< ct-scvp-certValResponse >-----#
    ct_scvp_certValResponse = CLASS(name='ct-scvp-certValResponse', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_scvp_certValResponse_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CVResponse')))
    ct_scvp_certValResponse._val = dict([('Type', _ct_scvp_certValResponse_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 11))])
    
    #-----< id-ct-scvp-certValResponse >-----#
    id_ct_scvp_certValResponse = OID(name='id-ct-scvp-certValResponse', mode=MODE_VALUE)
    id_ct_scvp_certValResponse._val = (1, 2, 840, 113549, 1, 9, 16, 1, 11)
    
    #-----< CVResponse >-----#
    CVResponse = SEQ(name='CVResponse', mode=MODE_TYPE)
    _CVResponse_cvResponseVersion = INT(name='cvResponseVersion', mode=MODE_TYPE)
    _CVResponse_serverConfigurationID = INT(name='serverConfigurationID', mode=MODE_TYPE)
    _CVResponse_producedAt = TIME_GEN(name='producedAt', mode=MODE_TYPE)
    _CVResponse_responseStatus = SEQ(name='responseStatus', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ResponseStatus')))
    _CVResponse_respValidationPolicy = SEQ(name='respValidationPolicy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'RespValidationPolicy')), opt=True)
    _CVResponse_requestRef = CHOICE(name='requestRef', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'RequestReference')), opt=True)
    _CVResponse_requestorRef = SEQ_OF(name='requestorRef', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')), opt=True)
    _CVResponse_requestorName = SEQ_OF(name='requestorName', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX1Implicit-2009', 'GeneralNames')), opt=True)
    _CVResponse_replyObjects = SEQ_OF(name='replyObjects', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'ReplyObjects')), opt=True)
    _CVResponse_respNonce = OCT_STR(name='respNonce', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CVResponse_serverContextInfo = OCT_STR(name='serverContextInfo', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CVResponse_cvResponseExtensions = SEQ_OF(name='cvResponseExtensions', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __CVResponse_cvResponseExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___CVResponse_cvResponseExtensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____CVResponse_cvResponseExtensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    ____CVResponse_cvResponseExtensions__item__extnID_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ___CVResponse_cvResponseExtensions__item__extnID._const_tab = ____CVResponse_cvResponseExtensions__item__extnID_tab
    ___CVResponse_cvResponseExtensions__item__extnID._const_tab_at = None
    ___CVResponse_cvResponseExtensions__item__extnID._const_tab_id = 'id'
    ___CVResponse_cvResponseExtensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___CVResponse_cvResponseExtensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____CVResponse_cvResponseExtensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    _____CVResponse_cvResponseExtensions__item__extnValue_contain_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____CVResponse_cvResponseExtensions__item__extnValue_contain_tab._val = ASN1Set(rv=[], rr=[], ev=None, er=[])
    ____CVResponse_cvResponseExtensions__item__extnValue_contain._const_tab = _____CVResponse_cvResponseExtensions__item__extnValue_contain_tab
    ____CVResponse_cvResponseExtensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____CVResponse_cvResponseExtensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___CVResponse_cvResponseExtensions__item__extnValue._const_cont = ____CVResponse_cvResponseExtensions__item__extnValue_contain
    __CVResponse_cvResponseExtensions__item_._cont = ASN1Dict([
        ('extnID', ___CVResponse_cvResponseExtensions__item__extnID),
        ('critical', ___CVResponse_cvResponseExtensions__item__critical),
        ('extnValue', ___CVResponse_cvResponseExtensions__item__extnValue),
        ])
    __CVResponse_cvResponseExtensions__item_._ext = None
    _CVResponse_cvResponseExtensions._cont = __CVResponse_cvResponseExtensions__item_
    _CVResponse_cvResponseExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _CVResponse_requestorText = STR_UTF8(name='requestorText', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CVResponse_requestorText._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    CVResponse._cont = ASN1Dict([
        ('cvResponseVersion', _CVResponse_cvResponseVersion),
        ('serverConfigurationID', _CVResponse_serverConfigurationID),
        ('producedAt', _CVResponse_producedAt),
        ('responseStatus', _CVResponse_responseStatus),
        ('respValidationPolicy', _CVResponse_respValidationPolicy),
        ('requestRef', _CVResponse_requestRef),
        ('requestorRef', _CVResponse_requestorRef),
        ('requestorName', _CVResponse_requestorName),
        ('replyObjects', _CVResponse_replyObjects),
        ('respNonce', _CVResponse_respNonce),
        ('serverContextInfo', _CVResponse_serverContextInfo),
        ('cvResponseExtensions', _CVResponse_cvResponseExtensions),
        ('requestorText', _CVResponse_requestorText),
        ])
    CVResponse._ext = None
    
    #-----< CVResponseExtensions >-----#
    CVResponseExtensions = CLASS(name='CVResponseExtensions', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    CVResponseExtensions._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    
    #-----< ResponseStatus >-----#
    ResponseStatus = SEQ(name='ResponseStatus', mode=MODE_TYPE)
    _ResponseStatus_statusCode = ENUM(name='statusCode', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CVStatusCode')), default='okay')
    _ResponseStatus_errorMessage = STR_UTF8(name='errorMessage', mode=MODE_TYPE, opt=True)
    ResponseStatus._cont = ASN1Dict([
        ('statusCode', _ResponseStatus_statusCode),
        ('errorMessage', _ResponseStatus_errorMessage),
        ])
    ResponseStatus._ext = None
    
    #-----< CVStatusCode >-----#
    CVStatusCode = ENUM(name='CVStatusCode', mode=MODE_TYPE)
    CVStatusCode._cont = ASN1Dict([('okay', 0), ('skipUnrecognizedItems', 1), ('tooBusy', 10), ('invalidRequest', 11), ('internalError', 12), ('badStructure', 20), ('unsupportedVersion', 21), ('abortUnrecognizedItems', 22), ('unrecognizedSigKey', 23), ('badSignatureOrMAC', 24), ('unableToDecode', 25), ('notAuthorized', 26), ('unsupportedChecks', 27), ('unsupportedWantBacks', 28), ('unsupportedSignatureOrMAC', 29), ('invalidSignatureOrMAC', 30), ('protectedResponseUnsupported', 31), ('unrecognizedResponderName', 32), ('relayingLoop', 40), ('unrecognizedValPol', 50), ('unrecognizedValAlg', 51), ('fullRequestInResponseUnsupported', 52), ('fullPolResponseUnsupported', 53), ('inhibitPolicyMappingUnsupported', 54), ('requireExplicitPolicyUnsupported', 55), ('inhibitAnyPolicyUnsupported', 56), ('validationTimeUnsupported', 57), ('unrecognizedCritQueryExt', 63), ('unrecognizedCritRequestExt', 64)])
    CVStatusCode._ext = []
    
    #-----< RespValidationPolicy >-----#
    RespValidationPolicy = SEQ(name='RespValidationPolicy', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ValidationPolicy')))
    
    #-----< RequestReference >-----#
    RequestReference = CHOICE(name='RequestReference', mode=MODE_TYPE)
    _RequestReference_requestHash = SEQ(name='requestHash', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'HashValue')))
    _RequestReference_fullRequest = SEQ(name='fullRequest', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SCVP-2009', 'CVRequest')))
    RequestReference._cont = ASN1Dict([
        ('requestHash', _RequestReference_requestHash),
        ('fullRequest', _RequestReference_fullRequest),
        ])
    RequestReference._ext = None
    
    #-----< HashValue >-----#
    HashValue = SEQ(name='HashValue', mode=MODE_TYPE)
    _HashValue_algorithm = SEQ(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'HashAlgorithm')), default=dict([('algorithm', (1, 3, 14, 3, 2, 26))]))
    _HashValue_value = OCT_STR(name='value', mode=MODE_TYPE)
    HashValue._cont = ASN1Dict([
        ('algorithm', _HashValue_algorithm),
        ('value', _HashValue_value),
        ])
    HashValue._ext = None
    
    #-----< ReplyObjects >-----#
    ReplyObjects = SEQ_OF(name='ReplyObjects', mode=MODE_TYPE)
    _ReplyObjects__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertReply')))
    ReplyObjects._cont = _ReplyObjects__item_
    ReplyObjects._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< CertReply >-----#
    CertReply = SEQ(name='CertReply', mode=MODE_TYPE)
    _CertReply_cert = CHOICE(name='cert', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertReference')))
    _CertReply_replyStatus = ENUM(name='replyStatus', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ReplyStatus')), default='success')
    _CertReply_replyValTime = TIME_GEN(name='replyValTime', mode=MODE_TYPE)
    _CertReply_replyChecks = SEQ_OF(name='replyChecks', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ReplyChecks')))
    _CertReply_replyWantBacks = SEQ_OF(name='replyWantBacks', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ReplyWantBacks')))
    _CertReply_validationErrors = SEQ_OF(name='validationErrors', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __CertReply_validationErrors__item_ = OID(name='_item_', mode=MODE_TYPE)
    __CertReply_validationErrors__item_._const_val = ASN1Set(rv=[(1, 3, 6, 1, 5, 5, 7, 19, 3, 1), (1, 3, 6, 1, 5, 5, 7, 19, 3, 2), (1, 3, 6, 1, 5, 5, 7, 19, 3, 3), (1, 3, 6, 1, 5, 5, 7, 19, 3, 4), (1, 3, 6, 1, 5, 5, 7, 19, 3, 5), (1, 3, 6, 1, 5, 5, 7, 19, 3, 9), (1, 3, 6, 1, 5, 5, 7, 19, 3, 10), (1, 3, 6, 1, 5, 5, 7, 19, 3, 11), (1, 3, 6, 1, 5, 5, 7, 19, 2, 1), (1, 3, 6, 1, 5, 5, 7, 19, 2, 2), (1, 3, 6, 1, 5, 5, 7, 19, 2, 3), (1, 3, 6, 1, 5, 5, 7, 19, 2, 4), (1, 3, 6, 1, 5, 5, 7, 19, 2, 5), (1, 3, 6, 1, 5, 5, 7, 19, 2, 6)], rr=[], ev=[], er=[])
    _CertReply_validationErrors._cont = __CertReply_validationErrors__item_
    _CertReply_validationErrors._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _CertReply_nextUpdate = TIME_GEN(name='nextUpdate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CertReply_certReplyExtensions = SEQ_OF(name='certReplyExtensions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extensions')), opt=True)
    __CertReply_certReplyExtensions__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'Extension')))
    ___CertReply_certReplyExtensions__item__extnID = OID(name='extnID', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['id']))
    ____CertReply_certReplyExtensions__item__extnID_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    ____CertReply_certReplyExtensions__item__extnID_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    ___CertReply_certReplyExtensions__item__extnID._const_tab = ____CertReply_certReplyExtensions__item__extnID_tab
    ___CertReply_certReplyExtensions__item__extnID._const_tab_at = None
    ___CertReply_certReplyExtensions__item__extnID._const_tab_id = 'id'
    ___CertReply_certReplyExtensions__item__critical = BOOL(name='critical', mode=MODE_TYPE, default=False)
    ___CertReply_certReplyExtensions__item__extnValue = OCT_STR(name='extnValue', mode=MODE_TYPE)
    ____CertReply_certReplyExtensions__item__extnValue_contain = OPEN(name='_cont_extnValue', mode=MODE_TYPE, typeref=ASN1RefClassField(('PKIX-CommonTypes-2009', 'EXTENSION'), ['ExtnType']))
    _____CertReply_certReplyExtensions__item__extnValue_contain_tab = CLASS(name='_tab_EXTENSION', mode=MODE_SET, typeref=ASN1RefType(('PKIX-CommonTypes-2009', 'EXTENSION')))
    _____CertReply_certReplyExtensions__item__extnValue_contain_tab._val = ASN1Set(rv=[], rr=[], ev=[], er=[])
    ____CertReply_certReplyExtensions__item__extnValue_contain._const_tab = _____CertReply_certReplyExtensions__item__extnValue_contain_tab
    ____CertReply_certReplyExtensions__item__extnValue_contain._const_tab_at = ('..', 'extnID')
    ____CertReply_certReplyExtensions__item__extnValue_contain._const_tab_id = 'ExtnType'
    ___CertReply_certReplyExtensions__item__extnValue._const_cont = ____CertReply_certReplyExtensions__item__extnValue_contain
    __CertReply_certReplyExtensions__item_._cont = ASN1Dict([
        ('extnID', ___CertReply_certReplyExtensions__item__extnID),
        ('critical', ___CertReply_certReplyExtensions__item__critical),
        ('extnValue', ___CertReply_certReplyExtensions__item__extnValue),
        ])
    __CertReply_certReplyExtensions__item_._ext = None
    _CertReply_certReplyExtensions._cont = __CertReply_certReplyExtensions__item_
    _CertReply_certReplyExtensions._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    CertReply._cont = ASN1Dict([
        ('cert', _CertReply_cert),
        ('replyStatus', _CertReply_replyStatus),
        ('replyValTime', _CertReply_replyValTime),
        ('replyChecks', _CertReply_replyChecks),
        ('replyWantBacks', _CertReply_replyWantBacks),
        ('validationErrors', _CertReply_validationErrors),
        ('nextUpdate', _CertReply_nextUpdate),
        ('certReplyExtensions', _CertReply_certReplyExtensions),
        ])
    CertReply._ext = None
    
    #-----< ReplyStatus >-----#
    ReplyStatus = ENUM(name='ReplyStatus', mode=MODE_TYPE)
    ReplyStatus._cont = ASN1Dict([('success', 0), ('malformedPKC', 1), ('malformedAC', 2), ('unavailableValidationTime', 3), ('referenceCertHashFail', 4), ('certPathConstructFail', 5), ('certPathNotValid', 6), ('certPathNotValidNow', 7), ('wantBackUnsatisfied', 8)])
    ReplyStatus._ext = None
    
    #-----< ReplyChecks >-----#
    ReplyChecks = SEQ_OF(name='ReplyChecks', mode=MODE_TYPE)
    _ReplyChecks__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ReplyCheck')))
    ReplyChecks._cont = _ReplyChecks__item_
    
    #-----< ReplyCheck >-----#
    ReplyCheck = SEQ(name='ReplyCheck', mode=MODE_TYPE)
    _ReplyCheck_check = OID(name='check', mode=MODE_TYPE)
    _ReplyCheck_check._const_val = ASN1Set(rv=[(1, 3, 6, 1, 5, 5, 7, 17, 1), (1, 3, 6, 1, 5, 5, 7, 17, 2), (1, 3, 6, 1, 5, 5, 7, 17, 3), (1, 3, 6, 1, 5, 5, 7, 17, 4), (1, 3, 6, 1, 5, 5, 7, 17, 5), (1, 3, 6, 1, 5, 5, 7, 17, 6), (1, 3, 6, 1, 5, 5, 7, 17, 7)], rr=[], ev=[], er=[])
    _ReplyCheck_status = INT(name='status', mode=MODE_TYPE, default=0)
    ReplyCheck._cont = ASN1Dict([
        ('check', _ReplyCheck_check),
        ('status', _ReplyCheck_status),
        ])
    ReplyCheck._ext = None
    
    #-----< ReplyWantBacks >-----#
    ReplyWantBacks = SEQ_OF(name='ReplyWantBacks', mode=MODE_TYPE)
    _ReplyWantBacks__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ReplyWantBack')))
    ReplyWantBacks._cont = _ReplyWantBacks__item_
    
    #-----< ReplyWantBack >-----#
    ReplyWantBack = SEQ(name='ReplyWantBack', mode=MODE_TYPE)
    _ReplyWantBack_wb = OID(name='wb', mode=MODE_TYPE, typeref=ASN1RefClassField(('SCVP-2009', 'WANT-BACK'), ['id']))
    __ReplyWantBack_wb_tab = CLASS(name='_tab_WANT-BACK', mode=MODE_SET, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    ___ReplyWantBack_wb_tab_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    ___ReplyWantBack_wb_tab_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    ___ReplyWantBack_wb_tab_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ___ReplyWantBack_wb_tab_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SubjectPublicKeyInfo')))
    ___ReplyWantBack_wb_tab_val_Type_4 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundles')))
    ___ReplyWantBack_wb_tab_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ___ReplyWantBack_wb_tab_val_Type_6 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ___ReplyWantBack_wb_tab_val_Type_7 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttributeCertificate')))
    ___ReplyWantBack_wb_tab_val_Type_8 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    ___ReplyWantBack_wb_tab_val_Type_9 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ___ReplyWantBack_wb_tab_val_Type_10 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ___ReplyWantBack_wb_tab_val_Type_11 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'SCVPResponses')))
    __ReplyWantBack_wb_tab._val = ASN1Set(rv=[dict([('Type', ___ReplyWantBack_wb_tab_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 10))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 1))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 2))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 4))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_4), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 12))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_5), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 13))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_6), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 14))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_7), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 11))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_8), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 5))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_9), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 6))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_10), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 7))]), dict([('Type', ___ReplyWantBack_wb_tab_val_Type_11), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 9))])], rr=[], ev=None, er=[])
    _ReplyWantBack_wb._const_tab = __ReplyWantBack_wb_tab
    _ReplyWantBack_wb._const_tab_at = None
    _ReplyWantBack_wb._const_tab_id = 'id'
    _ReplyWantBack_value = OCT_STR(name='value', mode=MODE_TYPE)
    __ReplyWantBack_value_contain = OPEN(name='_cont_value', mode=MODE_TYPE, typeref=ASN1RefClassField(('SCVP-2009', 'WANT-BACK'), ['Type']))
    __ReplyWantBack_value_contain._const_tab = __ReplyWantBack_wb_tab
    __ReplyWantBack_value_contain._const_tab_at = ('..', 'wb')
    __ReplyWantBack_value_contain._const_tab_id = 'Type'
    _ReplyWantBack_value._const_cont = __ReplyWantBack_value_contain
    ReplyWantBack._cont = ASN1Dict([
        ('wb', _ReplyWantBack_wb),
        ('value', _ReplyWantBack_value),
        ])
    ReplyWantBack._ext = None
    
    #-----< WANT-BACK >-----#
    WANT_BACK = CLASS(name='WANT-BACK', mode=MODE_TYPE, typeref=ASN1RefType(('_IMPL_', 'TYPE-IDENTIFIER'), []))
    
    #-----< AllWantBacks >-----#
    AllWantBacks = CLASS(name='AllWantBacks', mode=MODE_SET, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _AllWantBacks_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    _AllWantBacks_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    _AllWantBacks_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    _AllWantBacks_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SubjectPublicKeyInfo')))
    _AllWantBacks_val_Type_4 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundles')))
    _AllWantBacks_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    _AllWantBacks_val_Type_6 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    _AllWantBacks_val_Type_7 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttributeCertificate')))
    _AllWantBacks_val_Type_8 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    _AllWantBacks_val_Type_9 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    _AllWantBacks_val_Type_10 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    _AllWantBacks_val_Type_11 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'SCVPResponses')))
    AllWantBacks._val = ASN1Set(rv=[dict([('Type', _AllWantBacks_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 10))]), dict([('Type', _AllWantBacks_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 1))]), dict([('Type', _AllWantBacks_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 2))]), dict([('Type', _AllWantBacks_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 4))]), dict([('Type', _AllWantBacks_val_Type_4), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 12))]), dict([('Type', _AllWantBacks_val_Type_5), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 13))]), dict([('Type', _AllWantBacks_val_Type_6), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 14))]), dict([('Type', _AllWantBacks_val_Type_7), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 11))]), dict([('Type', _AllWantBacks_val_Type_8), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 5))]), dict([('Type', _AllWantBacks_val_Type_9), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 6))]), dict([('Type', _AllWantBacks_val_Type_10), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 7))]), dict([('Type', _AllWantBacks_val_Type_11), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 9))])], rr=[], ev=[], er=[])
    
    #-----< CertBundles >-----#
    CertBundles = SEQ_OF(name='CertBundles', mode=MODE_TYPE)
    _CertBundles__item_ = SEQ_OF(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    CertBundles._cont = _CertBundles__item_
    CertBundles._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    
    #-----< RevInfoWantBack >-----#
    RevInfoWantBack = SEQ(name='RevInfoWantBack', mode=MODE_TYPE)
    _RevInfoWantBack_revocationInfo = SEQ_OF(name='revocationInfo', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevocationInfos')))
    _RevInfoWantBack_extraCerts = SEQ_OF(name='extraCerts', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')), opt=True)
    RevInfoWantBack._cont = ASN1Dict([
        ('revocationInfo', _RevInfoWantBack_revocationInfo),
        ('extraCerts', _RevInfoWantBack_extraCerts),
        ])
    RevInfoWantBack._ext = None
    
    #-----< SCVPResponses >-----#
    SCVPResponses = SEQ_OF(name='SCVPResponses', mode=MODE_TYPE)
    _SCVPResponses__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'ContentInfo')))
    SCVPResponses._cont = _SCVPResponses__item_
    
    #-----< ct-scvp-valPolRequest >-----#
    ct_scvp_valPolRequest = CLASS(name='ct-scvp-valPolRequest', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_scvp_valPolRequest_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ValPolRequest')))
    ct_scvp_valPolRequest._val = dict([('Type', _ct_scvp_valPolRequest_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 12))])
    
    #-----< id-ct-scvp-valPolRequest >-----#
    id_ct_scvp_valPolRequest = OID(name='id-ct-scvp-valPolRequest', mode=MODE_VALUE)
    id_ct_scvp_valPolRequest._val = (1, 2, 840, 113549, 1, 9, 16, 1, 12)
    
    #-----< ValPolRequest >-----#
    ValPolRequest = SEQ(name='ValPolRequest', mode=MODE_TYPE)
    _ValPolRequest_vpRequestVersion = INT(name='vpRequestVersion', mode=MODE_TYPE, default=1)
    _ValPolRequest_requestNonce = OCT_STR(name='requestNonce', mode=MODE_TYPE)
    ValPolRequest._cont = ASN1Dict([
        ('vpRequestVersion', _ValPolRequest_vpRequestVersion),
        ('requestNonce', _ValPolRequest_requestNonce),
        ])
    ValPolRequest._ext = None
    
    #-----< ct-scvp-valPolResponse >-----#
    ct_scvp_valPolResponse = CLASS(name='ct-scvp-valPolResponse', mode=MODE_VALUE, typeref=ASN1RefType(('CryptographicMessageSyntax-2009', 'CONTENT-TYPE')))
    _ct_scvp_valPolResponse_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ValPolResponse')))
    ct_scvp_valPolResponse._val = dict([('Type', _ct_scvp_valPolResponse_val_Type), ('id', (1, 2, 840, 113549, 1, 9, 16, 1, 13))])
    
    #-----< id-ct-scvp-valPolResponse >-----#
    id_ct_scvp_valPolResponse = OID(name='id-ct-scvp-valPolResponse', mode=MODE_VALUE)
    id_ct_scvp_valPolResponse._val = (1, 2, 840, 113549, 1, 9, 16, 1, 13)
    
    #-----< ValPolResponse >-----#
    ValPolResponse = SEQ(name='ValPolResponse', mode=MODE_TYPE)
    _ValPolResponse_vpResponseVersion = INT(name='vpResponseVersion', mode=MODE_TYPE)
    _ValPolResponse_maxCVRequestVersion = INT(name='maxCVRequestVersion', mode=MODE_TYPE)
    _ValPolResponse_maxVPRequestVersion = INT(name='maxVPRequestVersion', mode=MODE_TYPE)
    _ValPolResponse_serverConfigurationID = INT(name='serverConfigurationID', mode=MODE_TYPE)
    _ValPolResponse_thisUpdate = TIME_GEN(name='thisUpdate', mode=MODE_TYPE)
    _ValPolResponse_nextUpdate = TIME_GEN(name='nextUpdate', mode=MODE_TYPE, opt=True)
    _ValPolResponse_supportedChecks = SEQ_OF(name='supportedChecks', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertChecks')))
    _ValPolResponse_supportedWantBacks = SEQ_OF(name='supportedWantBacks', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'WantBack')))
    _ValPolResponse_validationPolicies = SEQ_OF(name='validationPolicies', mode=MODE_TYPE)
    __ValPolResponse_validationPolicies__item_ = OID(name='_item_', mode=MODE_TYPE)
    _ValPolResponse_validationPolicies._cont = __ValPolResponse_validationPolicies__item_
    _ValPolResponse_validationAlgs = SEQ_OF(name='validationAlgs', mode=MODE_TYPE)
    __ValPolResponse_validationAlgs__item_ = OID(name='_item_', mode=MODE_TYPE)
    _ValPolResponse_validationAlgs._cont = __ValPolResponse_validationAlgs__item_
    _ValPolResponse_authPolicies = SEQ_OF(name='authPolicies', mode=MODE_TYPE)
    __ValPolResponse_authPolicies__item_ = OID(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'AuthPolicy')))
    _ValPolResponse_authPolicies._cont = __ValPolResponse_authPolicies__item_
    _ValPolResponse_responseTypes = ENUM(name='responseTypes', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'ResponseTypes')))
    _ValPolResponse_defaultPolicyValues = SEQ(name='defaultPolicyValues', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RespValidationPolicy')))
    _ValPolResponse_revocationInfoTypes = BIT_STR(name='revocationInfoTypes', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevocationInfoTypes')))
    _ValPolResponse_signatureGeneration = SEQ_OF(name='signatureGeneration', mode=MODE_TYPE)
    __ValPolResponse_signatureGeneration__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    ___ValPolResponse_signatureGeneration__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ____ValPolResponse_signatureGeneration__item__algorithm_tab = CLASS(name='_tab_SIGNATURE-ALGORITHM', mode=MODE_SET, typeref=ASN1RefType(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM')))
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_0 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_1 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_2 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_3 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_3 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_4 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_4 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_5 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_5 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_6 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'DSA-Sig-Value')))
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_6 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_7 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_7 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_8 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_8 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_9 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_9 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_10 = SEQ(name='Value', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAlgs-2009', 'ECDSA-Sig-Value')))
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_10 = NULL(name='Params', mode=MODE_TYPE)
    _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_11 = SEQ(name='Params', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1-PSS-OAEP-Algorithms-2009', 'RSASSA-PSS-params')))
    ____ValPolResponse_signatureGeneration__item__algorithm_tab._val = ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 2)), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_0), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 2))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 4)), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_1), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 2, 5)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 5)), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_2), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 5))]))]), dict([('id', (1, 2, 840, 10040, 4, 3)), ('Value', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_3), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_3), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10040, 4, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 1)), ('Value', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_4), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_4), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 1))]))])], rr=[], ev=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1)), ('Value', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_5), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_5), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 1))]))]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2)), ('Value', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_6), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_6), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10040, 4, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0), ('paramPresence', 'inheritable'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (2, 16, 840, 1, 101, 3, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 1)), ('Value', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_7), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_7), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 1))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 2)), ('Value', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_8), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_8), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 2))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 3)), ('Value', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_9), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_9), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 3))]))]), dict([('id', (1, 2, 840, 10045, 4, 3, 4)), ('Value', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_10), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_10), ('paramPresence', 'absent'), ('HashSet', ASN1Set(rv=[dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 10045, 2, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1), ('paramPresence', 'required'), ('keyUsage', (103, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 10045, 4, 3, 4))]))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('Params', _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_11), ('paramPresence', 'required'), ('HashSet', ASN1Set(rv=[dict([('id', (1, 3, 14, 3, 2, 26)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_0), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 4)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_1), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 1)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_2), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 2)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_3), ('paramPresence', 'preferredAbsent')]), dict([('id', (2, 16, 840, 1, 101, 3, 4, 2, 3)), ('Params', __SIGNATURE_ALGORITHM_HashSet_val_Params_4), ('paramPresence', 'preferredAbsent')])], rr=[], ev=None, er=[])), ('PublicKeySet', ASN1Set(rv=[dict([('id', (1, 2, 840, 113549, 1, 1, 1)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0), ('paramPresence', 'absent'), ('keyUsage', (123, 7))]), dict([('id', (1, 2, 840, 113549, 1, 1, 10)), ('KeyValue', __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1), ('Params', __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1), ('paramPresence', 'optional'), ('keyUsage', (99, 7))])], rr=[], ev=None, er=[])), ('smimeCaps', dict([('id', (1, 2, 840, 113549, 1, 1, 10))]))])], er=[])
    ___ValPolResponse_signatureGeneration__item__algorithm._const_tab = ____ValPolResponse_signatureGeneration__item__algorithm_tab
    ___ValPolResponse_signatureGeneration__item__algorithm._const_tab_at = None
    ___ValPolResponse_signatureGeneration__item__algorithm._const_tab_id = 'id'
    ___ValPolResponse_signatureGeneration__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    ___ValPolResponse_signatureGeneration__item__parameters._const_tab = ____ValPolResponse_signatureGeneration__item__algorithm_tab
    ___ValPolResponse_signatureGeneration__item__parameters._const_tab_at = ('..', 'algorithm')
    ___ValPolResponse_signatureGeneration__item__parameters._const_tab_id = 'Params'
    __ValPolResponse_signatureGeneration__item_._cont = ASN1Dict([
        ('algorithm', ___ValPolResponse_signatureGeneration__item__algorithm),
        ('parameters', ___ValPolResponse_signatureGeneration__item__parameters),
        ])
    __ValPolResponse_signatureGeneration__item_._ext = None
    _ValPolResponse_signatureGeneration._cont = __ValPolResponse_signatureGeneration__item_
    _ValPolResponse_signatureVerification = SEQ_OF(name='signatureVerification', mode=MODE_TYPE)
    __ValPolResponse_signatureVerification__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('AlgorithmInformation-2009', 'AlgorithmIdentifier')))
    ___ValPolResponse_signatureVerification__item__algorithm = OID(name='algorithm', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['id']))
    ___ValPolResponse_signatureVerification__item__algorithm._const_tab = ____ValPolResponse_signatureGeneration__item__algorithm_tab
    ___ValPolResponse_signatureVerification__item__algorithm._const_tab_at = None
    ___ValPolResponse_signatureVerification__item__algorithm._const_tab_id = 'id'
    ___ValPolResponse_signatureVerification__item__parameters = OPEN(name='parameters', mode=MODE_TYPE, typeref=ASN1RefClassField(('AlgorithmInformation-2009', 'SIGNATURE-ALGORITHM'), ['Params']), opt=True)
    ___ValPolResponse_signatureVerification__item__parameters._const_tab = ____ValPolResponse_signatureGeneration__item__algorithm_tab
    ___ValPolResponse_signatureVerification__item__parameters._const_tab_at = ('..', 'algorithm')
    ___ValPolResponse_signatureVerification__item__parameters._const_tab_id = 'Params'
    __ValPolResponse_signatureVerification__item_._cont = ASN1Dict([
        ('algorithm', ___ValPolResponse_signatureVerification__item__algorithm),
        ('parameters', ___ValPolResponse_signatureVerification__item__parameters),
        ])
    __ValPolResponse_signatureVerification__item_._ext = None
    _ValPolResponse_signatureVerification._cont = __ValPolResponse_signatureVerification__item_
    _ValPolResponse_hashAlgorithms = SEQ_OF(name='hashAlgorithms', mode=MODE_TYPE)
    __ValPolResponse_hashAlgorithms__item_ = OID(name='_item_', mode=MODE_TYPE)
    _ValPolResponse_hashAlgorithms._cont = __ValPolResponse_hashAlgorithms__item_
    _ValPolResponse_hashAlgorithms._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=None)], ev=None, er=[])
    _ValPolResponse_serverPublicKeys = SEQ_OF(name='serverPublicKeys', mode=MODE_TYPE, opt=True)
    __ValPolResponse_serverPublicKeys__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'KeyAgreePublicKey')))
    _ValPolResponse_serverPublicKeys._cont = __ValPolResponse_serverPublicKeys__item_
    _ValPolResponse_clockSkew = INT(name='clockSkew', mode=MODE_TYPE, default=10)
    _ValPolResponse_requestNonce = OCT_STR(name='requestNonce', mode=MODE_TYPE, opt=True)
    ValPolResponse._cont = ASN1Dict([
        ('vpResponseVersion', _ValPolResponse_vpResponseVersion),
        ('maxCVRequestVersion', _ValPolResponse_maxCVRequestVersion),
        ('maxVPRequestVersion', _ValPolResponse_maxVPRequestVersion),
        ('serverConfigurationID', _ValPolResponse_serverConfigurationID),
        ('thisUpdate', _ValPolResponse_thisUpdate),
        ('nextUpdate', _ValPolResponse_nextUpdate),
        ('supportedChecks', _ValPolResponse_supportedChecks),
        ('supportedWantBacks', _ValPolResponse_supportedWantBacks),
        ('validationPolicies', _ValPolResponse_validationPolicies),
        ('validationAlgs', _ValPolResponse_validationAlgs),
        ('authPolicies', _ValPolResponse_authPolicies),
        ('responseTypes', _ValPolResponse_responseTypes),
        ('defaultPolicyValues', _ValPolResponse_defaultPolicyValues),
        ('revocationInfoTypes', _ValPolResponse_revocationInfoTypes),
        ('signatureGeneration', _ValPolResponse_signatureGeneration),
        ('signatureVerification', _ValPolResponse_signatureVerification),
        ('hashAlgorithms', _ValPolResponse_hashAlgorithms),
        ('serverPublicKeys', _ValPolResponse_serverPublicKeys),
        ('clockSkew', _ValPolResponse_clockSkew),
        ('requestNonce', _ValPolResponse_requestNonce),
        ])
    ValPolResponse._ext = None
    
    #-----< ResponseTypes >-----#
    ResponseTypes = ENUM(name='ResponseTypes', mode=MODE_TYPE)
    ResponseTypes._cont = ASN1Dict([('cached-only', 0), ('non-cached-only', 1), ('cached-and-non-cached', 2)])
    ResponseTypes._ext = None
    
    #-----< RevocationInfoTypes >-----#
    RevocationInfoTypes = BIT_STR(name='RevocationInfoTypes', mode=MODE_TYPE)
    RevocationInfoTypes._cont = ASN1Dict([('fullCRLs', 0), ('deltaCRLs', 1), ('indirectCRLs', 2), ('oCSPResponses', 3)])
    
    #-----< AuthPolicy >-----#
    AuthPolicy = OID(name='AuthPolicy', mode=MODE_TYPE)
    
    #-----< id-stc >-----#
    id_stc = OID(name='id-stc', mode=MODE_VALUE)
    id_stc._val = (1, 3, 6, 1, 5, 5, 7, 17)
    
    #-----< CertCheckSet >-----#
    CertCheckSet = OID(name='CertCheckSet', mode=MODE_SET)
    CertCheckSet._val = ASN1Set(rv=[(1, 3, 6, 1, 5, 5, 7, 17, 1), (1, 3, 6, 1, 5, 5, 7, 17, 2), (1, 3, 6, 1, 5, 5, 7, 17, 3)], rr=[], ev=[], er=[])
    
    #-----< id-stc-build-pkc-path >-----#
    id_stc_build_pkc_path = OID(name='id-stc-build-pkc-path', mode=MODE_VALUE)
    id_stc_build_pkc_path._val = (1, 3, 6, 1, 5, 5, 7, 17, 1)
    
    #-----< id-stc-build-valid-pkc-path >-----#
    id_stc_build_valid_pkc_path = OID(name='id-stc-build-valid-pkc-path', mode=MODE_VALUE)
    id_stc_build_valid_pkc_path._val = (1, 3, 6, 1, 5, 5, 7, 17, 2)
    
    #-----< id-stc-build-status-checked-pkc-path >-----#
    id_stc_build_status_checked_pkc_path = OID(name='id-stc-build-status-checked-pkc-path', mode=MODE_VALUE)
    id_stc_build_status_checked_pkc_path._val = (1, 3, 6, 1, 5, 5, 7, 17, 3)
    
    #-----< ACertCheckSet >-----#
    ACertCheckSet = OID(name='ACertCheckSet', mode=MODE_SET)
    ACertCheckSet._val = ASN1Set(rv=[(1, 3, 6, 1, 5, 5, 7, 17, 4), (1, 3, 6, 1, 5, 5, 7, 17, 5), (1, 3, 6, 1, 5, 5, 7, 17, 6), (1, 3, 6, 1, 5, 5, 7, 17, 7)], rr=[], ev=None, er=[])
    
    #-----< id-stc-build-aa-path >-----#
    id_stc_build_aa_path = OID(name='id-stc-build-aa-path', mode=MODE_VALUE)
    id_stc_build_aa_path._val = (1, 3, 6, 1, 5, 5, 7, 17, 4)
    
    #-----< id-stc-build-valid-aa-path >-----#
    id_stc_build_valid_aa_path = OID(name='id-stc-build-valid-aa-path', mode=MODE_VALUE)
    id_stc_build_valid_aa_path._val = (1, 3, 6, 1, 5, 5, 7, 17, 5)
    
    #-----< id-stc-build-status-checked-aa-path >-----#
    id_stc_build_status_checked_aa_path = OID(name='id-stc-build-status-checked-aa-path', mode=MODE_VALUE)
    id_stc_build_status_checked_aa_path._val = (1, 3, 6, 1, 5, 5, 7, 17, 6)
    
    #-----< id-stc-status-check-ac-and-build-status-checked-aa-path >-----#
    id_stc_status_check_ac_and_build_status_checked_aa_path = OID(name='id-stc-status-check-ac-and-build-status-checked-aa-path', mode=MODE_VALUE)
    id_stc_status_check_ac_and_build_status_checked_aa_path._val = (1, 3, 6, 1, 5, 5, 7, 17, 7)
    
    #-----< id-swb >-----#
    id_swb = OID(name='id-swb', mode=MODE_VALUE)
    id_swb._val = (1, 3, 6, 1, 5, 5, 7, 18)
    
    #-----< WantBackSet >-----#
    WantBackSet = CLASS(name='WantBackSet', mode=MODE_SET, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _WantBackSet_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    _WantBackSet_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    _WantBackSet_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    _WantBackSet_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SubjectPublicKeyInfo')))
    _WantBackSet_val_Type_4 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundles')))
    _WantBackSet_val_Type_5 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    _WantBackSet_val_Type_6 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    WantBackSet._val = ASN1Set(rv=[dict([('Type', _WantBackSet_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 10))]), dict([('Type', _WantBackSet_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 1))]), dict([('Type', _WantBackSet_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 2))]), dict([('Type', _WantBackSet_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 4))]), dict([('Type', _WantBackSet_val_Type_4), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 12))]), dict([('Type', _WantBackSet_val_Type_5), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 13))]), dict([('Type', _WantBackSet_val_Type_6), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 14))])], rr=[], ev=None, er=[])
    
    #-----< ACertWantBackSet >-----#
    ACertWantBackSet = CLASS(name='ACertWantBackSet', mode=MODE_SET, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _ACertWantBackSet_val_Type_0 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttributeCertificate')))
    _ACertWantBackSet_val_Type_1 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    _ACertWantBackSet_val_Type_2 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    _ACertWantBackSet_val_Type_3 = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    ACertWantBackSet._val = ASN1Set(rv=[dict([('Type', _ACertWantBackSet_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 11))]), dict([('Type', _ACertWantBackSet_val_Type_1), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 5))]), dict([('Type', _ACertWantBackSet_val_Type_2), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 6))]), dict([('Type', _ACertWantBackSet_val_Type_3), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 7))])], rr=[], ev=None, er=[])
    
    #-----< AnyWantBackSet >-----#
    AnyWantBackSet = CLASS(name='AnyWantBackSet', mode=MODE_SET, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _AnyWantBackSet_val_Type_0 = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'SCVPResponses')))
    AnyWantBackSet._val = ASN1Set(rv=[dict([('Type', _AnyWantBackSet_val_Type_0), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 9))])], rr=[], ev=None, er=[])
    
    #-----< swb-pkc-best-cert-path >-----#
    swb_pkc_best_cert_path = CLASS(name='swb-pkc-best-cert-path', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_pkc_best_cert_path_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    swb_pkc_best_cert_path._val = dict([('Type', _swb_pkc_best_cert_path_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 1))])
    
    #-----< id-swb-pkc-best-cert-path >-----#
    id_swb_pkc_best_cert_path = OID(name='id-swb-pkc-best-cert-path', mode=MODE_VALUE)
    id_swb_pkc_best_cert_path._val = (1, 3, 6, 1, 5, 5, 7, 18, 1)
    
    #-----< swb-pkc-revocation-info >-----#
    swb_pkc_revocation_info = CLASS(name='swb-pkc-revocation-info', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_pkc_revocation_info_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    swb_pkc_revocation_info._val = dict([('Type', _swb_pkc_revocation_info_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 2))])
    
    #-----< id-swb-pkc-revocation-info >-----#
    id_swb_pkc_revocation_info = OID(name='id-swb-pkc-revocation-info', mode=MODE_VALUE)
    id_swb_pkc_revocation_info._val = (1, 3, 6, 1, 5, 5, 7, 18, 2)
    
    #-----< swb-pkc-public-key-info >-----#
    swb_pkc_public_key_info = CLASS(name='swb-pkc-public-key-info', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_pkc_public_key_info_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'SubjectPublicKeyInfo')))
    swb_pkc_public_key_info._val = dict([('Type', _swb_pkc_public_key_info_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 4))])
    
    #-----< id-swb-pkc-public-key-info >-----#
    id_swb_pkc_public_key_info = OID(name='id-swb-pkc-public-key-info', mode=MODE_VALUE)
    id_swb_pkc_public_key_info._val = (1, 3, 6, 1, 5, 5, 7, 18, 4)
    
    #-----< swb-aa-cert-path >-----#
    swb_aa_cert_path = CLASS(name='swb-aa-cert-path', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_aa_cert_path_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundle')))
    swb_aa_cert_path._val = dict([('Type', _swb_aa_cert_path_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 5))])
    
    #-----< id-swb-aa-cert-path >-----#
    id_swb_aa_cert_path = OID(name='id-swb-aa-cert-path', mode=MODE_VALUE)
    id_swb_aa_cert_path._val = (1, 3, 6, 1, 5, 5, 7, 18, 5)
    
    #-----< swb-aa-revocation-info >-----#
    swb_aa_revocation_info = CLASS(name='swb-aa-revocation-info', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_aa_revocation_info_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    swb_aa_revocation_info._val = dict([('Type', _swb_aa_revocation_info_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 6))])
    
    #-----< id-swb-aa-revocation-info >-----#
    id_swb_aa_revocation_info = OID(name='id-swb-aa-revocation-info', mode=MODE_VALUE)
    id_swb_aa_revocation_info._val = (1, 3, 6, 1, 5, 5, 7, 18, 6)
    
    #-----< swb-ac-revocation-info >-----#
    swb_ac_revocation_info = CLASS(name='swb-ac-revocation-info', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_ac_revocation_info_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    swb_ac_revocation_info._val = dict([('Type', _swb_ac_revocation_info_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 7))])
    
    #-----< id-swb-ac-revocation-info >-----#
    id_swb_ac_revocation_info = OID(name='id-swb-ac-revocation-info', mode=MODE_VALUE)
    id_swb_ac_revocation_info._val = (1, 3, 6, 1, 5, 5, 7, 18, 7)
    
    #-----< swb-relayed-responses >-----#
    swb_relayed_responses = CLASS(name='swb-relayed-responses', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_relayed_responses_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'SCVPResponses')))
    swb_relayed_responses._val = dict([('Type', _swb_relayed_responses_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 9))])
    
    #-----< id-swb-relayed-responses >-----#
    id_swb_relayed_responses = OID(name='id-swb-relayed-responses', mode=MODE_VALUE)
    id_swb_relayed_responses._val = (1, 3, 6, 1, 5, 5, 7, 18, 9)
    
    #-----< swb-pkc-all-cert-paths >-----#
    swb_pkc_all_cert_paths = CLASS(name='swb-pkc-all-cert-paths', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_pkc_all_cert_paths_val_Type = SEQ_OF(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'CertBundles')))
    swb_pkc_all_cert_paths._val = dict([('Type', _swb_pkc_all_cert_paths_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 12))])
    
    #-----< id-swb-pkc-all-cert-paths >-----#
    id_swb_pkc_all_cert_paths = OID(name='id-swb-pkc-all-cert-paths', mode=MODE_VALUE)
    id_swb_pkc_all_cert_paths._val = (1, 3, 6, 1, 5, 5, 7, 18, 12)
    
    #-----< swb-pkc-ee-revocation-info >-----#
    swb_pkc_ee_revocation_info = CLASS(name='swb-pkc-ee-revocation-info', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_pkc_ee_revocation_info_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    swb_pkc_ee_revocation_info._val = dict([('Type', _swb_pkc_ee_revocation_info_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 13))])
    
    #-----< id-swb-pkc-ee-revocation-info >-----#
    id_swb_pkc_ee_revocation_info = OID(name='id-swb-pkc-ee-revocation-info', mode=MODE_VALUE)
    id_swb_pkc_ee_revocation_info._val = (1, 3, 6, 1, 5, 5, 7, 18, 13)
    
    #-----< swb-pkc-CAs-revocation-info >-----#
    swb_pkc_CAs_revocation_info = CLASS(name='swb-pkc-CAs-revocation-info', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_pkc_CAs_revocation_info_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'RevInfoWantBack')))
    swb_pkc_CAs_revocation_info._val = dict([('Type', _swb_pkc_CAs_revocation_info_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 14))])
    
    #-----< id-swb-pkc-CAs-revocation-info >-----#
    id_swb_pkc_CAs_revocation_info = OID(name='id-swb-pkc-CAs-revocation-info', mode=MODE_VALUE)
    id_swb_pkc_CAs_revocation_info._val = (1, 3, 6, 1, 5, 5, 7, 18, 14)
    
    #-----< swb-pkc-cert >-----#
    swb_pkc_cert = CLASS(name='swb-pkc-cert', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_pkc_cert_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIX1Explicit-2009', 'Certificate')))
    swb_pkc_cert._val = dict([('Type', _swb_pkc_cert_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 10))])
    
    #-----< id-swb-pkc-cert >-----#
    id_swb_pkc_cert = OID(name='id-swb-pkc-cert', mode=MODE_VALUE)
    id_swb_pkc_cert._val = (1, 3, 6, 1, 5, 5, 7, 18, 10)
    
    #-----< swb-ac-cert >-----#
    swb_ac_cert = CLASS(name='swb-ac-cert', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'WANT-BACK')))
    _swb_ac_cert_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('PKIXAttributeCertificate-2009', 'AttributeCertificate')))
    swb_ac_cert._val = dict([('Type', _swb_ac_cert_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 18, 11))])
    
    #-----< id-swb-ac-cert >-----#
    id_swb_ac_cert = OID(name='id-swb-ac-cert', mode=MODE_VALUE)
    id_swb_ac_cert._val = (1, 3, 6, 1, 5, 5, 7, 18, 11)
    
    #-----< id-svp >-----#
    id_svp = OID(name='id-svp', mode=MODE_VALUE)
    id_svp._val = (1, 3, 6, 1, 5, 5, 7, 19)
    
    #-----< svp-defaultValPolicy >-----#
    svp_defaultValPolicy = CLASS(name='svp-defaultValPolicy', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'POLICY')))
    svp_defaultValPolicy._val = dict([('id', (1, 3, 6, 1, 5, 5, 7, 19, 1))])
    
    #-----< id-svp-defaultValPolicy >-----#
    id_svp_defaultValPolicy = OID(name='id-svp-defaultValPolicy', mode=MODE_VALUE)
    id_svp_defaultValPolicy._val = (1, 3, 6, 1, 5, 5, 7, 19, 1)
    
    #-----< svp-basicValAlg >-----#
    svp_basicValAlg = CLASS(name='svp-basicValAlg', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'POLICY')))
    svp_basicValAlg._val = dict([('id', (1, 3, 6, 1, 5, 5, 7, 19, 3))])
    
    #-----< id-svp-basicValAlg >-----#
    id_svp_basicValAlg = OID(name='id-svp-basicValAlg', mode=MODE_VALUE)
    id_svp_basicValAlg._val = (1, 3, 6, 1, 5, 5, 7, 19, 3)
    
    #-----< id-bvae >-----#
    id_bvae = OID(name='id-bvae', mode=MODE_VALUE)
    id_bvae._val = (1, 3, 6, 1, 5, 5, 7, 19, 3)
    
    #-----< BasicValidationErrorSet >-----#
    BasicValidationErrorSet = OID(name='BasicValidationErrorSet', mode=MODE_SET)
    BasicValidationErrorSet._val = ASN1Set(rv=[(1, 3, 6, 1, 5, 5, 7, 19, 3, 1), (1, 3, 6, 1, 5, 5, 7, 19, 3, 2), (1, 3, 6, 1, 5, 5, 7, 19, 3, 3), (1, 3, 6, 1, 5, 5, 7, 19, 3, 4), (1, 3, 6, 1, 5, 5, 7, 19, 3, 5), (1, 3, 6, 1, 5, 5, 7, 19, 3, 9), (1, 3, 6, 1, 5, 5, 7, 19, 3, 10), (1, 3, 6, 1, 5, 5, 7, 19, 3, 11)], rr=[], ev=None, er=[])
    
    #-----< id-bvae-expired >-----#
    id_bvae_expired = OID(name='id-bvae-expired', mode=MODE_VALUE)
    id_bvae_expired._val = (1, 3, 6, 1, 5, 5, 7, 19, 3, 1)
    
    #-----< id-bvae-not-yet-valid >-----#
    id_bvae_not_yet_valid = OID(name='id-bvae-not-yet-valid', mode=MODE_VALUE)
    id_bvae_not_yet_valid._val = (1, 3, 6, 1, 5, 5, 7, 19, 3, 2)
    
    #-----< id-bvae-wrongTrustAnchor >-----#
    id_bvae_wrongTrustAnchor = OID(name='id-bvae-wrongTrustAnchor', mode=MODE_VALUE)
    id_bvae_wrongTrustAnchor._val = (1, 3, 6, 1, 5, 5, 7, 19, 3, 3)
    
    #-----< id-bvae-noValidCertPath >-----#
    id_bvae_noValidCertPath = OID(name='id-bvae-noValidCertPath', mode=MODE_VALUE)
    id_bvae_noValidCertPath._val = (1, 3, 6, 1, 5, 5, 7, 19, 3, 4)
    
    #-----< id-bvae-revoked >-----#
    id_bvae_revoked = OID(name='id-bvae-revoked', mode=MODE_VALUE)
    id_bvae_revoked._val = (1, 3, 6, 1, 5, 5, 7, 19, 3, 5)
    
    #-----< id-bvae-invalidKeyPurpose >-----#
    id_bvae_invalidKeyPurpose = OID(name='id-bvae-invalidKeyPurpose', mode=MODE_VALUE)
    id_bvae_invalidKeyPurpose._val = (1, 3, 6, 1, 5, 5, 7, 19, 3, 9)
    
    #-----< id-bvae-invalidKeyUsage >-----#
    id_bvae_invalidKeyUsage = OID(name='id-bvae-invalidKeyUsage', mode=MODE_VALUE)
    id_bvae_invalidKeyUsage._val = (1, 3, 6, 1, 5, 5, 7, 19, 3, 10)
    
    #-----< id-bvae-invalidCertPolicy >-----#
    id_bvae_invalidCertPolicy = OID(name='id-bvae-invalidCertPolicy', mode=MODE_VALUE)
    id_bvae_invalidCertPolicy._val = (1, 3, 6, 1, 5, 5, 7, 19, 3, 11)
    
    #-----< svp-nameValAlg >-----#
    svp_nameValAlg = CLASS(name='svp-nameValAlg', mode=MODE_VALUE, typeref=ASN1RefType(('SCVP-2009', 'POLICY')))
    _svp_nameValAlg_val_Type = SEQ(name='Type', mode=MODE_TYPE, typeref=ASN1RefType(('SCVP-2009', 'NameValidationAlgParams')))
    svp_nameValAlg._val = dict([('Type', _svp_nameValAlg_val_Type), ('id', (1, 3, 6, 1, 5, 5, 7, 19, 2))])
    
    #-----< id-svp-nameValAlg >-----#
    id_svp_nameValAlg = OID(name='id-svp-nameValAlg', mode=MODE_VALUE)
    id_svp_nameValAlg._val = (1, 3, 6, 1, 5, 5, 7, 19, 2)
    
    #-----< NameCompAlgSet >-----#
    NameCompAlgSet = OID(name='NameCompAlgSet', mode=MODE_SET)
    NameCompAlgSet._val = ASN1Set(rv=[(1, 3, 6, 1, 5, 5, 7, 19, 4)], rr=[], ev=None, er=[])
    
    #-----< id-nva-dnCompAlg >-----#
    id_nva_dnCompAlg = OID(name='id-nva-dnCompAlg', mode=MODE_VALUE)
    id_nva_dnCompAlg._val = (1, 3, 6, 1, 5, 5, 7, 19, 4)
    
    #-----< id-nvae >-----#
    id_nvae = OID(name='id-nvae', mode=MODE_VALUE)
    id_nvae._val = (1, 3, 6, 1, 5, 5, 7, 19, 2)
    
    #-----< NameValidationErrorSet >-----#
    NameValidationErrorSet = OID(name='NameValidationErrorSet', mode=MODE_SET)
    NameValidationErrorSet._val = ASN1Set(rv=[(1, 3, 6, 1, 5, 5, 7, 19, 2, 1), (1, 3, 6, 1, 5, 5, 7, 19, 2, 2), (1, 3, 6, 1, 5, 5, 7, 19, 2, 3), (1, 3, 6, 1, 5, 5, 7, 19, 2, 4), (1, 3, 6, 1, 5, 5, 7, 19, 2, 5), (1, 3, 6, 1, 5, 5, 7, 19, 2, 6)], rr=[], ev=None, er=[])
    
    #-----< id-nvae-name-mismatch >-----#
    id_nvae_name_mismatch = OID(name='id-nvae-name-mismatch', mode=MODE_VALUE)
    id_nvae_name_mismatch._val = (1, 3, 6, 1, 5, 5, 7, 19, 2, 1)
    
    #-----< id-nvae-no-name >-----#
    id_nvae_no_name = OID(name='id-nvae-no-name', mode=MODE_VALUE)
    id_nvae_no_name._val = (1, 3, 6, 1, 5, 5, 7, 19, 2, 2)
    
    #-----< id-nvae-unknown-alg >-----#
    id_nvae_unknown_alg = OID(name='id-nvae-unknown-alg', mode=MODE_VALUE)
    id_nvae_unknown_alg._val = (1, 3, 6, 1, 5, 5, 7, 19, 2, 3)
    
    #-----< id-nvae-bad-name >-----#
    id_nvae_bad_name = OID(name='id-nvae-bad-name', mode=MODE_VALUE)
    id_nvae_bad_name._val = (1, 3, 6, 1, 5, 5, 7, 19, 2, 4)
    
    #-----< id-nvae-bad-name-type >-----#
    id_nvae_bad_name_type = OID(name='id-nvae-bad-name-type', mode=MODE_VALUE)
    id_nvae_bad_name_type._val = (1, 3, 6, 1, 5, 5, 7, 19, 2, 5)
    
    #-----< id-nvae-mixed-names >-----#
    id_nvae_mixed_names = OID(name='id-nvae-mixed-names', mode=MODE_VALUE)
    id_nvae_mixed_names._val = (1, 3, 6, 1, 5, 5, 7, 19, 2, 6)
    
    #-----< id-kp >-----#
    id_kp = OID(name='id-kp', mode=MODE_VALUE)
    id_kp._val = (1, 3, 6, 1, 5, 5, 7, 3)
    
    #-----< SvcpExtKeyUsageSet >-----#
    SvcpExtKeyUsageSet = OID(name='SvcpExtKeyUsageSet', mode=MODE_SET)
    SvcpExtKeyUsageSet._val = ASN1Set(rv=[(1, 3, 6, 1, 5, 5, 7, 3, 15), (1, 3, 6, 1, 5, 5, 7, 3, 16)], rr=[], ev=None, er=[])
    
    #-----< id-kp-scvpServer >-----#
    id_kp_scvpServer = OID(name='id-kp-scvpServer', mode=MODE_VALUE)
    id_kp_scvpServer._val = (1, 3, 6, 1, 5, 5, 7, 3, 15)
    
    #-----< id-kp-scvpClient >-----#
    id_kp_scvpClient = OID(name='id-kp-scvpClient', mode=MODE_VALUE)
    id_kp_scvpClient._val = (1, 3, 6, 1, 5, 5, 7, 3, 16)
    
    _all_ = [
        ContentTypes,
        _ContentTypes_val_Type_0,
        _ContentTypes_val_Type_1,
        _ContentTypes_val_Type_2,
        _ContentTypes_val_Type_3,
        id_ct,
        ct_scvp_certValRequest,
        _ct_scvp_certValRequest_val_Type,
        id_ct_scvp_certValRequest,
        _CVRequest_cvRequestVersion,
        _CVRequest_query,
        _CVRequest_requestorRef,
        _CVRequest_requestNonce,
        _CVRequest_requestorName,
        _CVRequest_responderName,
        ____CVRequest_requestExtensions__item__extnID_tab,
        ___CVRequest_requestExtensions__item__extnID,
        ___CVRequest_requestExtensions__item__critical,
        _____CVRequest_requestExtensions__item__extnValue_contain_tab,
        ____CVRequest_requestExtensions__item__extnValue_contain,
        ___CVRequest_requestExtensions__item__extnValue,
        __CVRequest_requestExtensions__item_,
        _CVRequest_requestExtensions,
        ___CVRequest_signatureAlg_algorithm_tab,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_0,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_1,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_2,
        ____CVRequest_signatureAlg_algorithm_tab_val_Value_3,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_3,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_0,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_0,
        ____CVRequest_signatureAlg_algorithm_tab_val_Value_4,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_0_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_0_1,
        ____CVRequest_signatureAlg_algorithm_tab_val_Value_5,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_5,
        ____CVRequest_signatureAlg_algorithm_tab_val_Value_6,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_6,
        ____CVRequest_signatureAlg_algorithm_tab_val_Value_7,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_7,
        ____CVRequest_signatureAlg_algorithm_tab_val_Value_8,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_8,
        ____CVRequest_signatureAlg_algorithm_tab_val_Value_9,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_9,
        ____CVRequest_signatureAlg_algorithm_tab_val_Value_10,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_10,
        ____CVRequest_signatureAlg_algorithm_tab_val_Params_11,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_1,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_2,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_3,
        __SIGNATURE_ALGORITHM_HashSet_val_Params_4,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_KeyValue_1,
        __SIGNATURE_ALGORITHM_PublicKeySet_val_Params_1,
        __CVRequest_signatureAlg_algorithm,
        __CVRequest_signatureAlg_parameters,
        _CVRequest_signatureAlg,
        _CVRequest_hashAlg,
        _CVRequest_requestorText,
        CVRequest,
        RequestExtensions,
        _Query_queriedCerts,
        _Query_checks,
        _Query_wantBack,
        _Query_validationPolicy,
        _Query_responseFlags,
        _Query_serverContextInfo,
        _Query_validationTime,
        _Query_intermediateCerts,
        _Query_revInfos,
        _Query_producedAt,
        ____Query_queryExtensions__item__extnID_tab,
        ___Query_queryExtensions__item__extnID,
        ___Query_queryExtensions__item__critical,
        _____Query_queryExtensions__item__extnValue_contain_tab,
        ____Query_queryExtensions__item__extnValue_contain,
        ___Query_queryExtensions__item__extnValue,
        __Query_queryExtensions__item_,
        _Query_queryExtensions,
        Query,
        QueryExtensions,
        __CertReferences_pkcRefs__item_,
        _CertReferences_pkcRefs,
        __CertReferences_acRefs__item_,
        _CertReferences_acRefs,
        CertReferences,
        _CertReference_pkc,
        _CertReference_ac,
        CertReference,
        _PKCReference_cert,
        _PKCReference_pkcRef,
        PKCReference,
        _ACReference_attrCert,
        _ACReference_acRef,
        ACReference,
        __HashAlgorithm_algorithm_tab,
        ___HashAlgorithm_algorithm_tab_val_Params_0,
        _HashAlgorithm_algorithm,
        _HashAlgorithm_parameters,
        HashAlgorithm,
        _SCVPCertID_certHash,
        _SCVPCertID_issuerSerial,
        _SCVPCertID_hashAlgorithm,
        SCVPCertID,
        _SCVPIssuerSerial_issuer,
        _SCVPIssuerSerial_serialNumber,
        SCVPIssuerSerial,
        _ValidationPolicy_validationPolRef,
        _ValidationPolicy_validationAlg,
        __ValidationPolicy_userPolicySet__item_,
        _ValidationPolicy_userPolicySet,
        _ValidationPolicy_inhibitPolicyMapping,
        _ValidationPolicy_requireExplicitPolicy,
        _ValidationPolicy_inhibitAnyPolicy,
        _ValidationPolicy_trustAnchors,
        __ValidationPolicy_keyUsages__item_,
        _ValidationPolicy_keyUsages,
        __ValidationPolicy_extendedKeyUsages__item_,
        _ValidationPolicy_extendedKeyUsages,
        __ValidationPolicy_specifiedKeyUsages__item_,
        _ValidationPolicy_specifiedKeyUsages,
        ValidationPolicy,
        _CertChecks__item_,
        CertChecks,
        __WantBack__item__tab,
        ___WantBack__item__tab_val_Type_0,
        ___WantBack__item__tab_val_Type_1,
        ___WantBack__item__tab_val_Type_2,
        ___WantBack__item__tab_val_Type_3,
        ___WantBack__item__tab_val_Type_4,
        ___WantBack__item__tab_val_Type_5,
        ___WantBack__item__tab_val_Type_6,
        ___WantBack__item__tab_val_Type_7,
        ___WantBack__item__tab_val_Type_8,
        ___WantBack__item__tab_val_Type_9,
        ___WantBack__item__tab_val_Type_10,
        ___WantBack__item__tab_val_Type_11,
        _WantBack__item_,
        WantBack,
        POLICY,
        ValidationPolRefSet,
        _ValidationPolRef_valPolId,
        _ValidationPolRef_valPolParams,
        ValidationPolRef,
        ValidationAlgSet,
        _ValidationAlg_valAlgId,
        _ValidationAlg_parameters,
        ValidationAlg,
        NameValidationAlgSet,
        _NameValidationAlgSet_val_Type_0,
        _NameValidationAlgParams_nameCompAlgId,
        _NameValidationAlgParams_validationNames,
        NameValidationAlgParams,
        _TrustAnchors__item_,
        TrustAnchors,
        ___KeyAgreePublicKey_algorithm_algorithm_tab,
        __KeyAgreePublicKey_algorithm_algorithm,
        ___KeyAgreePublicKey_algorithm_parameters_tab,
        __KeyAgreePublicKey_algorithm_parameters,
        _KeyAgreePublicKey_algorithm,
        _KeyAgreePublicKey_publicKey,
        ___KeyAgreePublicKey_macAlgorithm_algorithm_tab,
        __KeyAgreePublicKey_macAlgorithm_algorithm,
        ___KeyAgreePublicKey_macAlgorithm_parameters_tab,
        __KeyAgreePublicKey_macAlgorithm_parameters,
        _KeyAgreePublicKey_macAlgorithm,
        ___KeyAgreePublicKey_kDF_algorithm_tab,
        __KeyAgreePublicKey_kDF_algorithm,
        ___KeyAgreePublicKey_kDF_parameters_tab,
        __KeyAgreePublicKey_kDF_parameters,
        _KeyAgreePublicKey_kDF,
        KeyAgreePublicKey,
        SupportedKeyAgreePublicKeys,
        SupportedMACAlgorithms,
        SupportedKeyDerivationFunctions,
        _ResponseFlags_fullRequestInResponse,
        _ResponseFlags_responseValidationPolByRef,
        _ResponseFlags_protectResponse,
        _ResponseFlags_cachedResponse,
        ResponseFlags,
        _CertBundle__item_,
        CertBundle,
        _RevocationInfos__item_,
        RevocationInfos,
        _RevocationInfo_crl,
        _RevocationInfo_delta_crl,
        _RevocationInfo_ocsp,
        _RevocationInfo_other,
        RevocationInfo,
        REV_INFO,
        _OtherRevInfo_riType,
        _OtherRevInfo_riValue,
        OtherRevInfo,
        ct_scvp_certValResponse,
        _ct_scvp_certValResponse_val_Type,
        id_ct_scvp_certValResponse,
        _CVResponse_cvResponseVersion,
        _CVResponse_serverConfigurationID,
        _CVResponse_producedAt,
        _CVResponse_responseStatus,
        _CVResponse_respValidationPolicy,
        _CVResponse_requestRef,
        _CVResponse_requestorRef,
        _CVResponse_requestorName,
        _CVResponse_replyObjects,
        _CVResponse_respNonce,
        _CVResponse_serverContextInfo,
        ____CVResponse_cvResponseExtensions__item__extnID_tab,
        ___CVResponse_cvResponseExtensions__item__extnID,
        ___CVResponse_cvResponseExtensions__item__critical,
        _____CVResponse_cvResponseExtensions__item__extnValue_contain_tab,
        ____CVResponse_cvResponseExtensions__item__extnValue_contain,
        ___CVResponse_cvResponseExtensions__item__extnValue,
        __CVResponse_cvResponseExtensions__item_,
        _CVResponse_cvResponseExtensions,
        _CVResponse_requestorText,
        CVResponse,
        CVResponseExtensions,
        _ResponseStatus_statusCode,
        _ResponseStatus_errorMessage,
        ResponseStatus,
        CVStatusCode,
        RespValidationPolicy,
        _RequestReference_requestHash,
        _RequestReference_fullRequest,
        RequestReference,
        _HashValue_algorithm,
        _HashValue_value,
        HashValue,
        _ReplyObjects__item_,
        ReplyObjects,
        _CertReply_cert,
        _CertReply_replyStatus,
        _CertReply_replyValTime,
        _CertReply_replyChecks,
        _CertReply_replyWantBacks,
        __CertReply_validationErrors__item_,
        _CertReply_validationErrors,
        _CertReply_nextUpdate,
        ____CertReply_certReplyExtensions__item__extnID_tab,
        ___CertReply_certReplyExtensions__item__extnID,
        ___CertReply_certReplyExtensions__item__critical,
        _____CertReply_certReplyExtensions__item__extnValue_contain_tab,
        ____CertReply_certReplyExtensions__item__extnValue_contain,
        ___CertReply_certReplyExtensions__item__extnValue,
        __CertReply_certReplyExtensions__item_,
        _CertReply_certReplyExtensions,
        CertReply,
        ReplyStatus,
        _ReplyChecks__item_,
        ReplyChecks,
        _ReplyCheck_check,
        _ReplyCheck_status,
        ReplyCheck,
        _ReplyWantBacks__item_,
        ReplyWantBacks,
        __ReplyWantBack_wb_tab,
        ___ReplyWantBack_wb_tab_val_Type_0,
        ___ReplyWantBack_wb_tab_val_Type_1,
        ___ReplyWantBack_wb_tab_val_Type_2,
        ___ReplyWantBack_wb_tab_val_Type_3,
        ___ReplyWantBack_wb_tab_val_Type_4,
        ___ReplyWantBack_wb_tab_val_Type_5,
        ___ReplyWantBack_wb_tab_val_Type_6,
        ___ReplyWantBack_wb_tab_val_Type_7,
        ___ReplyWantBack_wb_tab_val_Type_8,
        ___ReplyWantBack_wb_tab_val_Type_9,
        ___ReplyWantBack_wb_tab_val_Type_10,
        ___ReplyWantBack_wb_tab_val_Type_11,
        _ReplyWantBack_wb,
        __ReplyWantBack_value_contain,
        _ReplyWantBack_value,
        ReplyWantBack,
        WANT_BACK,
        AllWantBacks,
        _AllWantBacks_val_Type_0,
        _AllWantBacks_val_Type_1,
        _AllWantBacks_val_Type_2,
        _AllWantBacks_val_Type_3,
        _AllWantBacks_val_Type_4,
        _AllWantBacks_val_Type_5,
        _AllWantBacks_val_Type_6,
        _AllWantBacks_val_Type_7,
        _AllWantBacks_val_Type_8,
        _AllWantBacks_val_Type_9,
        _AllWantBacks_val_Type_10,
        _AllWantBacks_val_Type_11,
        _CertBundles__item_,
        CertBundles,
        _RevInfoWantBack_revocationInfo,
        _RevInfoWantBack_extraCerts,
        RevInfoWantBack,
        _SCVPResponses__item_,
        SCVPResponses,
        ct_scvp_valPolRequest,
        _ct_scvp_valPolRequest_val_Type,
        id_ct_scvp_valPolRequest,
        _ValPolRequest_vpRequestVersion,
        _ValPolRequest_requestNonce,
        ValPolRequest,
        ct_scvp_valPolResponse,
        _ct_scvp_valPolResponse_val_Type,
        id_ct_scvp_valPolResponse,
        _ValPolResponse_vpResponseVersion,
        _ValPolResponse_maxCVRequestVersion,
        _ValPolResponse_maxVPRequestVersion,
        _ValPolResponse_serverConfigurationID,
        _ValPolResponse_thisUpdate,
        _ValPolResponse_nextUpdate,
        _ValPolResponse_supportedChecks,
        _ValPolResponse_supportedWantBacks,
        __ValPolResponse_validationPolicies__item_,
        _ValPolResponse_validationPolicies,
        __ValPolResponse_validationAlgs__item_,
        _ValPolResponse_validationAlgs,
        __ValPolResponse_authPolicies__item_,
        _ValPolResponse_authPolicies,
        _ValPolResponse_responseTypes,
        _ValPolResponse_defaultPolicyValues,
        _ValPolResponse_revocationInfoTypes,
        ____ValPolResponse_signatureGeneration__item__algorithm_tab,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_0,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_1,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_2,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_3,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_3,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_4,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_4,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_5,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_5,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_6,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_6,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_7,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_7,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_8,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_8,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_9,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_9,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Value_10,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_10,
        _____ValPolResponse_signatureGeneration__item__algorithm_tab_val_Params_11,
        ___ValPolResponse_signatureGeneration__item__algorithm,
        ___ValPolResponse_signatureGeneration__item__parameters,
        __ValPolResponse_signatureGeneration__item_,
        _ValPolResponse_signatureGeneration,
        ___ValPolResponse_signatureVerification__item__algorithm,
        ___ValPolResponse_signatureVerification__item__parameters,
        __ValPolResponse_signatureVerification__item_,
        _ValPolResponse_signatureVerification,
        __ValPolResponse_hashAlgorithms__item_,
        _ValPolResponse_hashAlgorithms,
        __ValPolResponse_serverPublicKeys__item_,
        _ValPolResponse_serverPublicKeys,
        _ValPolResponse_clockSkew,
        _ValPolResponse_requestNonce,
        ValPolResponse,
        ResponseTypes,
        RevocationInfoTypes,
        AuthPolicy,
        id_stc,
        CertCheckSet,
        id_stc_build_pkc_path,
        id_stc_build_valid_pkc_path,
        id_stc_build_status_checked_pkc_path,
        ACertCheckSet,
        id_stc_build_aa_path,
        id_stc_build_valid_aa_path,
        id_stc_build_status_checked_aa_path,
        id_stc_status_check_ac_and_build_status_checked_aa_path,
        id_swb,
        WantBackSet,
        _WantBackSet_val_Type_0,
        _WantBackSet_val_Type_1,
        _WantBackSet_val_Type_2,
        _WantBackSet_val_Type_3,
        _WantBackSet_val_Type_4,
        _WantBackSet_val_Type_5,
        _WantBackSet_val_Type_6,
        ACertWantBackSet,
        _ACertWantBackSet_val_Type_0,
        _ACertWantBackSet_val_Type_1,
        _ACertWantBackSet_val_Type_2,
        _ACertWantBackSet_val_Type_3,
        AnyWantBackSet,
        _AnyWantBackSet_val_Type_0,
        swb_pkc_best_cert_path,
        _swb_pkc_best_cert_path_val_Type,
        id_swb_pkc_best_cert_path,
        swb_pkc_revocation_info,
        _swb_pkc_revocation_info_val_Type,
        id_swb_pkc_revocation_info,
        swb_pkc_public_key_info,
        _swb_pkc_public_key_info_val_Type,
        id_swb_pkc_public_key_info,
        swb_aa_cert_path,
        _swb_aa_cert_path_val_Type,
        id_swb_aa_cert_path,
        swb_aa_revocation_info,
        _swb_aa_revocation_info_val_Type,
        id_swb_aa_revocation_info,
        swb_ac_revocation_info,
        _swb_ac_revocation_info_val_Type,
        id_swb_ac_revocation_info,
        swb_relayed_responses,
        _swb_relayed_responses_val_Type,
        id_swb_relayed_responses,
        swb_pkc_all_cert_paths,
        _swb_pkc_all_cert_paths_val_Type,
        id_swb_pkc_all_cert_paths,
        swb_pkc_ee_revocation_info,
        _swb_pkc_ee_revocation_info_val_Type,
        id_swb_pkc_ee_revocation_info,
        swb_pkc_CAs_revocation_info,
        _swb_pkc_CAs_revocation_info_val_Type,
        id_swb_pkc_CAs_revocation_info,
        swb_pkc_cert,
        _swb_pkc_cert_val_Type,
        id_swb_pkc_cert,
        swb_ac_cert,
        _swb_ac_cert_val_Type,
        id_swb_ac_cert,
        id_svp,
        svp_defaultValPolicy,
        id_svp_defaultValPolicy,
        svp_basicValAlg,
        id_svp_basicValAlg,
        id_bvae,
        BasicValidationErrorSet,
        id_bvae_expired,
        id_bvae_not_yet_valid,
        id_bvae_wrongTrustAnchor,
        id_bvae_noValidCertPath,
        id_bvae_revoked,
        id_bvae_invalidKeyPurpose,
        id_bvae_invalidKeyUsage,
        id_bvae_invalidCertPolicy,
        svp_nameValAlg,
        _svp_nameValAlg_val_Type,
        id_svp_nameValAlg,
        NameCompAlgSet,
        id_nva_dnCompAlg,
        id_nvae,
        NameValidationErrorSet,
        id_nvae_name_mismatch,
        id_nvae_no_name,
        id_nvae_unknown_alg,
        id_nvae_bad_name,
        id_nvae_bad_name_type,
        id_nvae_mixed_names,
        id_kp,
        SvcpExtKeyUsageSet,
        id_kp_scvpServer,
        id_kp_scvpClient,
    ]

class _IMPL_:

    _name_ = '_IMPL_'
    _oid_  = []
    _obj_  = ['REAL', 'EXTERNAL', 'EMBEDDED PDV', 'CHARACTER STRING', 'TYPE-IDENTIFIER', 'ABSTRACT-SYNTAX']
    
    #-----< REAL >-----#
    REAL = SEQ(name='REAL', mode=MODE_TYPE)
    _REAL_mantissa = INT(name='mantissa', mode=MODE_TYPE)
    _REAL_base = INT(name='base', mode=MODE_TYPE)
    _REAL_base._const_val = ASN1Set(rv=[2, 10], rr=[], ev=None, er=[])
    _REAL_exponent = INT(name='exponent', mode=MODE_TYPE)
    REAL._cont = ASN1Dict([
        ('mantissa', _REAL_mantissa),
        ('base', _REAL_base),
        ('exponent', _REAL_exponent),
        ])
    REAL._ext = None
    
    #-----< EXTERNAL >-----#
    EXTERNAL = SEQ(name='EXTERNAL', mode=MODE_TYPE)
    _EXTERNAL_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EXTERNAL_identification_syntaxes_abstract),
        ('transfer', ___EXTERNAL_identification_syntaxes_transfer),
        ])
    __EXTERNAL_identification_syntaxes._ext = None
    __EXTERNAL_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EXTERNAL_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EXTERNAL_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EXTERNAL_identification_context_negotiation_transfer_syntax),
        ])
    __EXTERNAL_identification_context_negotiation._ext = None
    __EXTERNAL_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EXTERNAL_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EXTERNAL_identification._cont = ASN1Dict([
        ('syntaxes', __EXTERNAL_identification_syntaxes),
        ('syntax', __EXTERNAL_identification_syntax),
        ('presentation-context-id', __EXTERNAL_identification_presentation_context_id),
        ('context-negotiation', __EXTERNAL_identification_context_negotiation),
        ('transfer-syntax', __EXTERNAL_identification_transfer_syntax),
        ('fixed', __EXTERNAL_identification_fixed),
        ])
    _EXTERNAL_identification._ext = None
    _EXTERNAL_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EXTERNAL_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EXTERNAL._cont = ASN1Dict([
        ('identification', _EXTERNAL_identification),
        ('data-value-descriptor', _EXTERNAL_data_value_descriptor),
        ('data-value', _EXTERNAL_data_value),
        ])
    EXTERNAL._ext = None
    
    #-----< EMBEDDED PDV >-----#
    EMBEDDED_PDV = SEQ(name='EMBEDDED PDV', mode=MODE_TYPE)
    _EMBEDDED_PDV_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___EMBEDDED_PDV_identification_syntaxes_abstract),
        ('transfer', ___EMBEDDED_PDV_identification_syntaxes_transfer),
        ])
    __EMBEDDED_PDV_identification_syntaxes._ext = None
    __EMBEDDED_PDV_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax),
        ])
    __EMBEDDED_PDV_identification_context_negotiation._ext = None
    __EMBEDDED_PDV_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __EMBEDDED_PDV_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _EMBEDDED_PDV_identification._cont = ASN1Dict([
        ('syntaxes', __EMBEDDED_PDV_identification_syntaxes),
        ('syntax', __EMBEDDED_PDV_identification_syntax),
        ('presentation-context-id', __EMBEDDED_PDV_identification_presentation_context_id),
        ('context-negotiation', __EMBEDDED_PDV_identification_context_negotiation),
        ('transfer-syntax', __EMBEDDED_PDV_identification_transfer_syntax),
        ('fixed', __EMBEDDED_PDV_identification_fixed),
        ])
    _EMBEDDED_PDV_identification._ext = None
    _EMBEDDED_PDV_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _EMBEDDED_PDV_data_value = OCT_STR(name='data-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    EMBEDDED_PDV._cont = ASN1Dict([
        ('identification', _EMBEDDED_PDV_identification),
        ('data-value-descriptor', _EMBEDDED_PDV_data_value_descriptor),
        ('data-value', _EMBEDDED_PDV_data_value),
        ])
    EMBEDDED_PDV._ext = None
    
    #-----< CHARACTER STRING >-----#
    CHARACTER_STRING = SEQ(name='CHARACTER STRING', mode=MODE_TYPE)
    _CHARACTER_STRING_identification = CHOICE(name='identification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes = SEQ(name='syntaxes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_abstract = OID(name='abstract', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_syntaxes_transfer = OID(name='transfer', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_syntaxes._cont = ASN1Dict([
        ('abstract', ___CHARACTER_STRING_identification_syntaxes_abstract),
        ('transfer', ___CHARACTER_STRING_identification_syntaxes_transfer),
        ])
    __CHARACTER_STRING_identification_syntaxes._ext = None
    __CHARACTER_STRING_identification_syntax = OID(name='syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation = SEQ(name='context-negotiation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id = INT(name='presentation-context-id', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_context_negotiation._cont = ASN1Dict([
        ('presentation-context-id', ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id),
        ('transfer-syntax', ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax),
        ])
    __CHARACTER_STRING_identification_context_negotiation._ext = None
    __CHARACTER_STRING_identification_transfer_syntax = OID(name='transfer-syntax', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CHARACTER_STRING_identification_fixed = NULL(name='fixed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    _CHARACTER_STRING_identification._cont = ASN1Dict([
        ('syntaxes', __CHARACTER_STRING_identification_syntaxes),
        ('syntax', __CHARACTER_STRING_identification_syntax),
        ('presentation-context-id', __CHARACTER_STRING_identification_presentation_context_id),
        ('context-negotiation', __CHARACTER_STRING_identification_context_negotiation),
        ('transfer-syntax', __CHARACTER_STRING_identification_transfer_syntax),
        ('fixed', __CHARACTER_STRING_identification_fixed),
        ])
    _CHARACTER_STRING_identification._ext = None
    _CHARACTER_STRING_data_value_descriptor = OBJ_DESC(name='data-value-descriptor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    _CHARACTER_STRING_string_value = OCT_STR(name='string-value', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    CHARACTER_STRING._cont = ASN1Dict([
        ('identification', _CHARACTER_STRING_identification),
        ('data-value-descriptor', _CHARACTER_STRING_data_value_descriptor),
        ('string-value', _CHARACTER_STRING_string_value),
        ])
    CHARACTER_STRING._ext = None
    
    #-----< TYPE-IDENTIFIER >-----#
    TYPE_IDENTIFIER = CLASS(name='TYPE-IDENTIFIER', mode=MODE_TYPE)
    _TYPE_IDENTIFIER_id = OID(name='id', mode=MODE_VALUE, uniq=True)
    _TYPE_IDENTIFIER_Type = OPEN(name='Type', mode=MODE_TYPE)
    TYPE_IDENTIFIER._cont = ASN1Dict([
        ('id', _TYPE_IDENTIFIER_id),
        ('Type', _TYPE_IDENTIFIER_Type),
        ])
    
    #-----< ABSTRACT-SYNTAX >-----#
    ABSTRACT_SYNTAX = CLASS(name='ABSTRACT-SYNTAX', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_id = OID(name='id', mode=MODE_VALUE)
    _ABSTRACT_SYNTAX_Type = OPEN(name='Type', mode=MODE_TYPE)
    _ABSTRACT_SYNTAX_property = BIT_STR(name='property', mode=MODE_VALUE, default=(0, 0))
    _ABSTRACT_SYNTAX_property._cont = ASN1Dict([('handles-invalid-encodings', 0)])
    ABSTRACT_SYNTAX._cont = ASN1Dict([
        ('id', _ABSTRACT_SYNTAX_id),
        ('Type', _ABSTRACT_SYNTAX_Type),
        ('property', _ABSTRACT_SYNTAX_property),
        ])
    
    _all_ = [
        _REAL_mantissa,
        _REAL_base,
        _REAL_exponent,
        REAL,
        ___EXTERNAL_identification_syntaxes_abstract,
        ___EXTERNAL_identification_syntaxes_transfer,
        __EXTERNAL_identification_syntaxes,
        __EXTERNAL_identification_syntax,
        __EXTERNAL_identification_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_presentation_context_id,
        ___EXTERNAL_identification_context_negotiation_transfer_syntax,
        __EXTERNAL_identification_context_negotiation,
        __EXTERNAL_identification_transfer_syntax,
        __EXTERNAL_identification_fixed,
        _EXTERNAL_identification,
        _EXTERNAL_data_value_descriptor,
        _EXTERNAL_data_value,
        EXTERNAL,
        ___EMBEDDED_PDV_identification_syntaxes_abstract,
        ___EMBEDDED_PDV_identification_syntaxes_transfer,
        __EMBEDDED_PDV_identification_syntaxes,
        __EMBEDDED_PDV_identification_syntax,
        __EMBEDDED_PDV_identification_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_presentation_context_id,
        ___EMBEDDED_PDV_identification_context_negotiation_transfer_syntax,
        __EMBEDDED_PDV_identification_context_negotiation,
        __EMBEDDED_PDV_identification_transfer_syntax,
        __EMBEDDED_PDV_identification_fixed,
        _EMBEDDED_PDV_identification,
        _EMBEDDED_PDV_data_value_descriptor,
        _EMBEDDED_PDV_data_value,
        EMBEDDED_PDV,
        ___CHARACTER_STRING_identification_syntaxes_abstract,
        ___CHARACTER_STRING_identification_syntaxes_transfer,
        __CHARACTER_STRING_identification_syntaxes,
        __CHARACTER_STRING_identification_syntax,
        __CHARACTER_STRING_identification_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_presentation_context_id,
        ___CHARACTER_STRING_identification_context_negotiation_transfer_syntax,
        __CHARACTER_STRING_identification_context_negotiation,
        __CHARACTER_STRING_identification_transfer_syntax,
        __CHARACTER_STRING_identification_fixed,
        _CHARACTER_STRING_identification,
        _CHARACTER_STRING_data_value_descriptor,
        _CHARACTER_STRING_string_value,
        CHARACTER_STRING,
        _TYPE_IDENTIFIER_id,
        _TYPE_IDENTIFIER_Type,
        TYPE_IDENTIFIER,
        _ABSTRACT_SYNTAX_id,
        _ABSTRACT_SYNTAX_Type,
        _ABSTRACT_SYNTAX_property,
        ABSTRACT_SYNTAX,
    ]

init_modules(CryptographicMessageSyntax_2009, CryptographicMessageSyntaxAlgorithms_2009, SecureMimeMessageV3dot1_2009, AlgorithmInformation_2009, AttributeCertificateVersion1_2009, EnrollmentMessageSyntax_2009, OCSP_2009, PKCS_10, PKIX1Explicit_2009, PKIX1Implicit_2009, PKIX1_PSS_OAEP_Algorithms_2009, PKIXAlgs_2009, PKIXAttributeCertificate_2009, PKIXCMP_2009, PKIX_CommonTypes_2009, PKIXCRMF_2009, PKIX_X400Address_2009, SCVP_2009, _IMPL_)
