# -*- coding: UTF-8 -*-
# Code automatically generated by pycrate_asn1c

from pycrate_asn1rt.utils            import *
from pycrate_asn1rt.err              import *
from pycrate_asn1rt.glob             import make_GLOBAL, GLOBAL
from pycrate_asn1rt.dictobj          import ASN1Dict
from pycrate_asn1rt.refobj           import *
from pycrate_asn1rt.setobj           import *
from pycrate_asn1rt.asnobj_basic     import *
from pycrate_asn1rt.asnobj_str       import *
from pycrate_asn1rt.asnobj_construct import *
from pycrate_asn1rt.asnobj_class     import *
from pycrate_asn1rt.asnobj_ext       import *
from pycrate_asn1rt.init             import init_modules

class ULP_Components:

    _name_  = 'ULP-Components'
    _oid_   = []
    
    _obj_ = [
        'Version',
        'SessionID',
        'SetSessionID',
        'SETId',
        'SlpSessionID',
        'IPAddress',
        'SLPAddress',
        'FQDN',
        'Ver',
        'LocationId',
        'Status',
        'CellInfo',
        'Position',
        'PositionEstimate',
        'AltitudeInfo',
        'CdmaCellInformation',
        'GsmCellInformation',
        'WcdmaCellInformation',
        'TimingAdvance',
        'TAResolution',
        'ChipRate',
        'FrequencyInfo',
        'FrequencyInfoFDD',
        'FrequencyInfoTDD',
        'UARFCN',
        'NMR',
        'NMRelement',
        'MeasuredResultsList',
        'MeasuredResults',
        'CellMeasuredResultsList',
        'UTRA-CarrierRSSI',
        'CellMeasuredResults',
        'CellParametersID',
        'TGSN',
        'PrimaryCCPCH-RSCP',
        'TimeslotISCP',
        'TimeslotISCP-List',
        'PrimaryCPICH-Info',
        'CPICH-Ec-N0',
        'CPICH-RSCP',
        'Pathloss',
        'maxCellMeas',
        'maxFreq',
        'maxTS',
        'StatusCode',
        'QoP',
        'Velocity',
        'Horvel',
        'Horandvervel',
        'Horveluncert',
        'Horandveruncert',
        'PosMethod',
        ]
    _type_ = [
        'Version',
        'SessionID',
        'SetSessionID',
        'SETId',
        'SlpSessionID',
        'IPAddress',
        'SLPAddress',
        'FQDN',
        'Ver',
        'LocationId',
        'Status',
        'CellInfo',
        'Position',
        'PositionEstimate',
        'AltitudeInfo',
        'CdmaCellInformation',
        'GsmCellInformation',
        'WcdmaCellInformation',
        'TimingAdvance',
        'TAResolution',
        'ChipRate',
        'FrequencyInfo',
        'FrequencyInfoFDD',
        'FrequencyInfoTDD',
        'UARFCN',
        'NMR',
        'NMRelement',
        'MeasuredResultsList',
        'MeasuredResults',
        'CellMeasuredResultsList',
        'UTRA-CarrierRSSI',
        'CellMeasuredResults',
        'CellParametersID',
        'TGSN',
        'PrimaryCCPCH-RSCP',
        'TimeslotISCP',
        'TimeslotISCP-List',
        'PrimaryCPICH-Info',
        'CPICH-Ec-N0',
        'CPICH-RSCP',
        'Pathloss',
        'StatusCode',
        'QoP',
        'Velocity',
        'Horvel',
        'Horandvervel',
        'Horveluncert',
        'Horandveruncert',
        'PosMethod',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxCellMeas',
        'maxFreq',
        'maxTS',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Version >-----#
    Version = SEQ(name='Version', mode=MODE_TYPE)
    _Version_maj = INT(name='maj', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Version_maj._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _Version_min = INT(name='min', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Version_min._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _Version_servind = INT(name='servind', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Version_servind._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    Version._cont = ASN1Dict([
        ('maj', _Version_maj),
        ('min', _Version_min),
        ('servind', _Version_servind),
        ])
    Version._ext = None
    
    #-----< SessionID >-----#
    SessionID = SEQ(name='SessionID', mode=MODE_TYPE)
    _SessionID_setSessionID = SEQ(name='setSessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'SetSessionID')), opt=True)
    _SessionID_slpSessionID = SEQ(name='slpSessionID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'SlpSessionID')), opt=True)
    SessionID._cont = ASN1Dict([
        ('setSessionID', _SessionID_setSessionID),
        ('slpSessionID', _SessionID_slpSessionID),
        ])
    SessionID._ext = None
    
    #-----< SetSessionID >-----#
    SetSessionID = SEQ(name='SetSessionID', mode=MODE_TYPE)
    _SetSessionID_sessionId = INT(name='sessionId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SetSessionID_sessionId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _SetSessionID_setId = CHOICE(name='setId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'SETId')))
    SetSessionID._cont = ASN1Dict([
        ('sessionId', _SetSessionID_sessionId),
        ('setId', _SetSessionID_setId),
        ])
    SetSessionID._ext = None
    
    #-----< SETId >-----#
    SETId = CHOICE(name='SETId', mode=MODE_TYPE)
    _SETId_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SETId_msisdn._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SETId_mdn = OCT_STR(name='mdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SETId_mdn._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SETId_min = BIT_STR(name='min', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SETId_min._const_sz = ASN1Set(rv=[34], rr=[], ev=None, er=[])
    _SETId_imsi = OCT_STR(name='imsi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SETId_imsi._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _SETId_nai = STR_IA5(name='nai', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SETId_nai._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000)], ev=None, er=[])
    _SETId_iPAddress = CHOICE(name='iPAddress', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'IPAddress')))
    SETId._cont = ASN1Dict([
        ('msisdn', _SETId_msisdn),
        ('mdn', _SETId_mdn),
        ('min', _SETId_min),
        ('imsi', _SETId_imsi),
        ('nai', _SETId_nai),
        ('iPAddress', _SETId_iPAddress),
        ])
    SETId._ext = []
    
    #-----< SlpSessionID >-----#
    SlpSessionID = SEQ(name='SlpSessionID', mode=MODE_TYPE)
    _SlpSessionID_sessionID = OCT_STR(name='sessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SlpSessionID_sessionID._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _SlpSessionID_slpId = CHOICE(name='slpId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'SLPAddress')))
    SlpSessionID._cont = ASN1Dict([
        ('sessionID', _SlpSessionID_sessionID),
        ('slpId', _SlpSessionID_slpId),
        ])
    SlpSessionID._ext = None
    
    #-----< IPAddress >-----#
    IPAddress = CHOICE(name='IPAddress', mode=MODE_TYPE)
    _IPAddress_ipv4Address = OCT_STR(name='ipv4Address', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPAddress_ipv4Address._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _IPAddress_ipv6Address = OCT_STR(name='ipv6Address', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _IPAddress_ipv6Address._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    IPAddress._cont = ASN1Dict([
        ('ipv4Address', _IPAddress_ipv4Address),
        ('ipv6Address', _IPAddress_ipv6Address),
        ])
    IPAddress._ext = None
    
    #-----< SLPAddress >-----#
    SLPAddress = CHOICE(name='SLPAddress', mode=MODE_TYPE)
    _SLPAddress_iPAddress = CHOICE(name='iPAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'IPAddress')))
    _SLPAddress_fqdn = STR_VIS(name='fqdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'FQDN')))
    _SLPAddress_fqdn._const_alpha = ASN1Set(rv=['.', '-'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    SLPAddress._cont = ASN1Dict([
        ('iPAddress', _SLPAddress_iPAddress),
        ('fqdn', _SLPAddress_fqdn),
        ])
    SLPAddress._ext = []
    
    #-----< FQDN >-----#
    FQDN = STR_VIS(name='FQDN', mode=MODE_TYPE)
    FQDN._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    FQDN._const_alpha = ASN1Set(rv=['.', '-'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    
    #-----< Ver >-----#
    Ver = BIT_STR(name='Ver', mode=MODE_TYPE)
    Ver._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< LocationId >-----#
    LocationId = SEQ(name='LocationId', mode=MODE_TYPE)
    _LocationId_cellInfo = CHOICE(name='cellInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'CellInfo')))
    _LocationId_status = ENUM(name='status', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Status')))
    LocationId._cont = ASN1Dict([
        ('cellInfo', _LocationId_cellInfo),
        ('status', _LocationId_status),
        ])
    LocationId._ext = []
    
    #-----< Status >-----#
    Status = ENUM(name='Status', mode=MODE_TYPE)
    Status._cont = ASN1Dict([('stale', 0), ('current', 1), ('unknown', 2)])
    Status._ext = []
    
    #-----< CellInfo >-----#
    CellInfo = CHOICE(name='CellInfo', mode=MODE_TYPE)
    _CellInfo_gsmCell = SEQ(name='gsmCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'GsmCellInformation')))
    _CellInfo_wcdmaCell = SEQ(name='wcdmaCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'WcdmaCellInformation')))
    _CellInfo_cdmaCell = SEQ(name='cdmaCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'CdmaCellInformation')))
    _CellInfo_ver2_CellInfo_extension = CHOICE(name='ver2-CellInfo-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'Ver2-CellInfo-extension')))
    CellInfo._cont = ASN1Dict([
        ('gsmCell', _CellInfo_gsmCell),
        ('wcdmaCell', _CellInfo_wcdmaCell),
        ('cdmaCell', _CellInfo_cdmaCell),
        ('ver2-CellInfo-extension', _CellInfo_ver2_CellInfo_extension),
        ])
    CellInfo._ext = ['ver2-CellInfo-extension']
    
    #-----< Position >-----#
    Position = SEQ(name='Position', mode=MODE_TYPE)
    _Position_timestamp = TIME_UTC(name='timestamp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Position_positionEstimate = SEQ(name='positionEstimate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PositionEstimate')))
    _Position_velocity = CHOICE(name='velocity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'Velocity')), opt=True)
    Position._cont = ASN1Dict([
        ('timestamp', _Position_timestamp),
        ('positionEstimate', _Position_positionEstimate),
        ('velocity', _Position_velocity),
        ])
    Position._ext = []
    
    #-----< PositionEstimate >-----#
    PositionEstimate = SEQ(name='PositionEstimate', mode=MODE_TYPE)
    _PositionEstimate_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PositionEstimate_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _PositionEstimate_latitudeSign._ext = None
    _PositionEstimate_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PositionEstimate_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _PositionEstimate_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PositionEstimate_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    _PositionEstimate_uncertainty = SEQ(name='uncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __PositionEstimate_uncertainty_uncertaintySemiMajor = INT(name='uncertaintySemiMajor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PositionEstimate_uncertainty_uncertaintySemiMajor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    __PositionEstimate_uncertainty_uncertaintySemiMinor = INT(name='uncertaintySemiMinor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PositionEstimate_uncertainty_uncertaintySemiMinor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    __PositionEstimate_uncertainty_orientationMajorAxis = INT(name='orientationMajorAxis', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __PositionEstimate_uncertainty_orientationMajorAxis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=180)], ev=None, er=[])
    _PositionEstimate_uncertainty._cont = ASN1Dict([
        ('uncertaintySemiMajor', __PositionEstimate_uncertainty_uncertaintySemiMajor),
        ('uncertaintySemiMinor', __PositionEstimate_uncertainty_uncertaintySemiMinor),
        ('orientationMajorAxis', __PositionEstimate_uncertainty_orientationMajorAxis),
        ])
    _PositionEstimate_uncertainty._ext = None
    _PositionEstimate_confidence = INT(name='confidence', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PositionEstimate_confidence._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=100)], ev=None, er=[])
    _PositionEstimate_altitudeInfo = SEQ(name='altitudeInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'AltitudeInfo')), opt=True)
    PositionEstimate._cont = ASN1Dict([
        ('latitudeSign', _PositionEstimate_latitudeSign),
        ('latitude', _PositionEstimate_latitude),
        ('longitude', _PositionEstimate_longitude),
        ('uncertainty', _PositionEstimate_uncertainty),
        ('confidence', _PositionEstimate_confidence),
        ('altitudeInfo', _PositionEstimate_altitudeInfo),
        ])
    PositionEstimate._ext = []
    
    #-----< AltitudeInfo >-----#
    AltitudeInfo = SEQ(name='AltitudeInfo', mode=MODE_TYPE)
    _AltitudeInfo_altitudeDirection = ENUM(name='altitudeDirection', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AltitudeInfo_altitudeDirection._cont = ASN1Dict([('height', 0), ('depth', 1)])
    _AltitudeInfo_altitudeDirection._ext = None
    _AltitudeInfo_altitude = INT(name='altitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AltitudeInfo_altitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _AltitudeInfo_altUncertainty = INT(name='altUncertainty', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AltitudeInfo_altUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    AltitudeInfo._cont = ASN1Dict([
        ('altitudeDirection', _AltitudeInfo_altitudeDirection),
        ('altitude', _AltitudeInfo_altitude),
        ('altUncertainty', _AltitudeInfo_altUncertainty),
        ])
    AltitudeInfo._ext = []
    
    #-----< CdmaCellInformation >-----#
    CdmaCellInformation = SEQ(name='CdmaCellInformation', mode=MODE_TYPE)
    _CdmaCellInformation_refNID = INT(name='refNID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CdmaCellInformation_refNID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CdmaCellInformation_refSID = INT(name='refSID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CdmaCellInformation_refSID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _CdmaCellInformation_refBASEID = INT(name='refBASEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CdmaCellInformation_refBASEID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CdmaCellInformation_refBASELAT = INT(name='refBASELAT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CdmaCellInformation_refBASELAT._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4194303)], ev=None, er=[])
    _CdmaCellInformation_reBASELONG = INT(name='reBASELONG', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CdmaCellInformation_reBASELONG._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _CdmaCellInformation_refREFPN = INT(name='refREFPN', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CdmaCellInformation_refREFPN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _CdmaCellInformation_refWeekNumber = INT(name='refWeekNumber', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CdmaCellInformation_refWeekNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CdmaCellInformation_refSeconds = INT(name='refSeconds', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CdmaCellInformation_refSeconds._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4194303)], ev=None, er=[])
    CdmaCellInformation._cont = ASN1Dict([
        ('refNID', _CdmaCellInformation_refNID),
        ('refSID', _CdmaCellInformation_refSID),
        ('refBASEID', _CdmaCellInformation_refBASEID),
        ('refBASELAT', _CdmaCellInformation_refBASELAT),
        ('reBASELONG', _CdmaCellInformation_reBASELONG),
        ('refREFPN', _CdmaCellInformation_refREFPN),
        ('refWeekNumber', _CdmaCellInformation_refWeekNumber),
        ('refSeconds', _CdmaCellInformation_refSeconds),
        ])
    CdmaCellInformation._ext = []
    
    #-----< GsmCellInformation >-----#
    GsmCellInformation = SEQ(name='GsmCellInformation', mode=MODE_TYPE)
    _GsmCellInformation_refMCC = INT(name='refMCC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GsmCellInformation_refMCC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _GsmCellInformation_refMNC = INT(name='refMNC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GsmCellInformation_refMNC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _GsmCellInformation_refLAC = INT(name='refLAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GsmCellInformation_refLAC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GsmCellInformation_refCI = INT(name='refCI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GsmCellInformation_refCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GsmCellInformation_nmr = SEQ_OF(name='nmr', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'NMR')), opt=True)
    _GsmCellInformation_ta = INT(name='ta', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GsmCellInformation_ta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    GsmCellInformation._cont = ASN1Dict([
        ('refMCC', _GsmCellInformation_refMCC),
        ('refMNC', _GsmCellInformation_refMNC),
        ('refLAC', _GsmCellInformation_refLAC),
        ('refCI', _GsmCellInformation_refCI),
        ('nmr', _GsmCellInformation_nmr),
        ('ta', _GsmCellInformation_ta),
        ])
    GsmCellInformation._ext = []
    
    #-----< WcdmaCellInformation >-----#
    WcdmaCellInformation = SEQ(name='WcdmaCellInformation', mode=MODE_TYPE)
    _WcdmaCellInformation_refMCC = INT(name='refMCC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WcdmaCellInformation_refMCC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _WcdmaCellInformation_refMNC = INT(name='refMNC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WcdmaCellInformation_refMNC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _WcdmaCellInformation_refUC = INT(name='refUC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WcdmaCellInformation_refUC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268435455)], ev=None, er=[])
    _WcdmaCellInformation_frequencyInfo = SEQ(name='frequencyInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'FrequencyInfo')), opt=True)
    _WcdmaCellInformation_primaryScramblingCode = INT(name='primaryScramblingCode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WcdmaCellInformation_primaryScramblingCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    _WcdmaCellInformation_measuredResultsList = SEQ_OF(name='measuredResultsList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'MeasuredResultsList')), opt=True)
    _WcdmaCellInformation_cellParametersId = INT(name='cellParametersId', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WcdmaCellInformation_cellParametersId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _WcdmaCellInformation_timingAdvance = SEQ(name='timingAdvance', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'TimingAdvance')), opt=True)
    WcdmaCellInformation._cont = ASN1Dict([
        ('refMCC', _WcdmaCellInformation_refMCC),
        ('refMNC', _WcdmaCellInformation_refMNC),
        ('refUC', _WcdmaCellInformation_refUC),
        ('frequencyInfo', _WcdmaCellInformation_frequencyInfo),
        ('primaryScramblingCode', _WcdmaCellInformation_primaryScramblingCode),
        ('measuredResultsList', _WcdmaCellInformation_measuredResultsList),
        ('cellParametersId', _WcdmaCellInformation_cellParametersId),
        ('timingAdvance', _WcdmaCellInformation_timingAdvance),
        ])
    WcdmaCellInformation._ext = ['cellParametersId', 'timingAdvance']
    
    #-----< TimingAdvance >-----#
    TimingAdvance = SEQ(name='TimingAdvance', mode=MODE_TYPE)
    _TimingAdvance_ta = INT(name='ta', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimingAdvance_ta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _TimingAdvance_tAResolution = ENUM(name='tAResolution', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'TAResolution')), opt=True)
    _TimingAdvance_chipRate = ENUM(name='chipRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'ChipRate')), opt=True)
    TimingAdvance._cont = ASN1Dict([
        ('ta', _TimingAdvance_ta),
        ('tAResolution', _TimingAdvance_tAResolution),
        ('chipRate', _TimingAdvance_chipRate),
        ])
    TimingAdvance._ext = []
    
    #-----< TAResolution >-----#
    TAResolution = ENUM(name='TAResolution', mode=MODE_TYPE)
    TAResolution._cont = ASN1Dict([('res10chip', 0), ('res05chip', 1), ('res0125chip', 2)])
    TAResolution._ext = []
    
    #-----< ChipRate >-----#
    ChipRate = ENUM(name='ChipRate', mode=MODE_TYPE)
    ChipRate._cont = ASN1Dict([('tdd128', 0), ('tdd384', 1), ('tdd768', 2)])
    ChipRate._ext = []
    
    #-----< FrequencyInfo >-----#
    FrequencyInfo = SEQ(name='FrequencyInfo', mode=MODE_TYPE)
    _FrequencyInfo_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __FrequencyInfo_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'FrequencyInfoFDD')))
    __FrequencyInfo_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'FrequencyInfoTDD')))
    _FrequencyInfo_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __FrequencyInfo_modeSpecificInfo_fdd),
        ('tdd', __FrequencyInfo_modeSpecificInfo_tdd),
        ])
    _FrequencyInfo_modeSpecificInfo._ext = []
    FrequencyInfo._cont = ASN1Dict([
        ('modeSpecificInfo', _FrequencyInfo_modeSpecificInfo),
        ])
    FrequencyInfo._ext = []
    
    #-----< FrequencyInfoFDD >-----#
    FrequencyInfoFDD = SEQ(name='FrequencyInfoFDD', mode=MODE_TYPE)
    _FrequencyInfoFDD_uarfcn_UL = INT(name='uarfcn-UL', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'UARFCN')), opt=True)
    _FrequencyInfoFDD_uarfcn_DL = INT(name='uarfcn-DL', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'UARFCN')))
    FrequencyInfoFDD._cont = ASN1Dict([
        ('uarfcn-UL', _FrequencyInfoFDD_uarfcn_UL),
        ('uarfcn-DL', _FrequencyInfoFDD_uarfcn_DL),
        ])
    FrequencyInfoFDD._ext = []
    
    #-----< FrequencyInfoTDD >-----#
    FrequencyInfoTDD = SEQ(name='FrequencyInfoTDD', mode=MODE_TYPE)
    _FrequencyInfoTDD_uarfcn_Nt = INT(name='uarfcn-Nt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'UARFCN')))
    FrequencyInfoTDD._cont = ASN1Dict([
        ('uarfcn-Nt', _FrequencyInfoTDD_uarfcn_Nt),
        ])
    FrequencyInfoTDD._ext = []
    
    #-----< UARFCN >-----#
    UARFCN = INT(name='UARFCN', mode=MODE_TYPE)
    UARFCN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    
    #-----< NMR >-----#
    NMR = SEQ_OF(name='NMR', mode=MODE_TYPE)
    _NMR__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ULP-Components', 'NMRelement')))
    NMR._cont = _NMR__item_
    NMR._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=15)], ev=None, er=[])
    
    #-----< NMRelement >-----#
    NMRelement = SEQ(name='NMRelement', mode=MODE_TYPE)
    _NMRelement_arfcn = INT(name='arfcn', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NMRelement_arfcn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _NMRelement_bsic = INT(name='bsic', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NMRelement_bsic._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _NMRelement_rxLev = INT(name='rxLev', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NMRelement_rxLev._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    NMRelement._cont = ASN1Dict([
        ('arfcn', _NMRelement_arfcn),
        ('bsic', _NMRelement_bsic),
        ('rxLev', _NMRelement_rxLev),
        ])
    NMRelement._ext = []
    
    #-----< MeasuredResultsList >-----#
    MeasuredResultsList = SEQ_OF(name='MeasuredResultsList', mode=MODE_TYPE)
    _MeasuredResultsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ULP-Components', 'MeasuredResults')))
    MeasuredResultsList._cont = _MeasuredResultsList__item_
    MeasuredResultsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MeasuredResults >-----#
    MeasuredResults = SEQ(name='MeasuredResults', mode=MODE_TYPE)
    _MeasuredResults_frequencyInfo = SEQ(name='frequencyInfo', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'FrequencyInfo')), opt=True)
    _MeasuredResults_utra_CarrierRSSI = INT(name='utra-CarrierRSSI', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'UTRA-CarrierRSSI')), opt=True)
    _MeasuredResults_cellMeasuredResultsList = SEQ_OF(name='cellMeasuredResultsList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'CellMeasuredResultsList')), opt=True)
    MeasuredResults._cont = ASN1Dict([
        ('frequencyInfo', _MeasuredResults_frequencyInfo),
        ('utra-CarrierRSSI', _MeasuredResults_utra_CarrierRSSI),
        ('cellMeasuredResultsList', _MeasuredResults_cellMeasuredResultsList),
        ])
    MeasuredResults._ext = None
    
    #-----< CellMeasuredResultsList >-----#
    CellMeasuredResultsList = SEQ_OF(name='CellMeasuredResultsList', mode=MODE_TYPE)
    _CellMeasuredResultsList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ULP-Components', 'CellMeasuredResults')))
    CellMeasuredResultsList._cont = _CellMeasuredResultsList__item_
    CellMeasuredResultsList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< UTRA-CarrierRSSI >-----#
    UTRA_CarrierRSSI = INT(name='UTRA-CarrierRSSI', mode=MODE_TYPE)
    UTRA_CarrierRSSI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< CellMeasuredResults >-----#
    CellMeasuredResults = SEQ(name='CellMeasuredResults', mode=MODE_TYPE)
    _CellMeasuredResults_cellIdentity = INT(name='cellIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CellMeasuredResults_cellIdentity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268435455)], ev=None, er=[])
    _CellMeasuredResults_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT))
    __CellMeasuredResults_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CellMeasuredResults_modeSpecificInfo_fdd_primaryCPICH_Info = SEQ(name='primaryCPICH-Info', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PrimaryCPICH-Info')))
    ___CellMeasuredResults_modeSpecificInfo_fdd_cpich_Ec_N0 = INT(name='cpich-Ec-N0', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'CPICH-Ec-N0')), opt=True)
    ___CellMeasuredResults_modeSpecificInfo_fdd_cpich_RSCP = INT(name='cpich-RSCP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'CPICH-RSCP')), opt=True)
    ___CellMeasuredResults_modeSpecificInfo_fdd_pathloss = INT(name='pathloss', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Pathloss')), opt=True)
    __CellMeasuredResults_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('primaryCPICH-Info', ___CellMeasuredResults_modeSpecificInfo_fdd_primaryCPICH_Info),
        ('cpich-Ec-N0', ___CellMeasuredResults_modeSpecificInfo_fdd_cpich_Ec_N0),
        ('cpich-RSCP', ___CellMeasuredResults_modeSpecificInfo_fdd_cpich_RSCP),
        ('pathloss', ___CellMeasuredResults_modeSpecificInfo_fdd_pathloss),
        ])
    __CellMeasuredResults_modeSpecificInfo_fdd._ext = None
    __CellMeasuredResults_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___CellMeasuredResults_modeSpecificInfo_tdd_cellParametersID = INT(name='cellParametersID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'CellParametersID')))
    ___CellMeasuredResults_modeSpecificInfo_tdd_proposedTGSN = INT(name='proposedTGSN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'TGSN')), opt=True)
    ___CellMeasuredResults_modeSpecificInfo_tdd_primaryCCPCH_RSCP = INT(name='primaryCCPCH-RSCP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PrimaryCCPCH-RSCP')), opt=True)
    ___CellMeasuredResults_modeSpecificInfo_tdd_pathloss = INT(name='pathloss', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Pathloss')), opt=True)
    ___CellMeasuredResults_modeSpecificInfo_tdd_timeslotISCP_List = SEQ_OF(name='timeslotISCP-List', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'TimeslotISCP-List')), opt=True)
    __CellMeasuredResults_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('cellParametersID', ___CellMeasuredResults_modeSpecificInfo_tdd_cellParametersID),
        ('proposedTGSN', ___CellMeasuredResults_modeSpecificInfo_tdd_proposedTGSN),
        ('primaryCCPCH-RSCP', ___CellMeasuredResults_modeSpecificInfo_tdd_primaryCCPCH_RSCP),
        ('pathloss', ___CellMeasuredResults_modeSpecificInfo_tdd_pathloss),
        ('timeslotISCP-List', ___CellMeasuredResults_modeSpecificInfo_tdd_timeslotISCP_List),
        ])
    __CellMeasuredResults_modeSpecificInfo_tdd._ext = None
    _CellMeasuredResults_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __CellMeasuredResults_modeSpecificInfo_fdd),
        ('tdd', __CellMeasuredResults_modeSpecificInfo_tdd),
        ])
    _CellMeasuredResults_modeSpecificInfo._ext = None
    CellMeasuredResults._cont = ASN1Dict([
        ('cellIdentity', _CellMeasuredResults_cellIdentity),
        ('modeSpecificInfo', _CellMeasuredResults_modeSpecificInfo),
        ])
    CellMeasuredResults._ext = None
    
    #-----< CellParametersID >-----#
    CellParametersID = INT(name='CellParametersID', mode=MODE_TYPE)
    CellParametersID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< TGSN >-----#
    TGSN = INT(name='TGSN', mode=MODE_TYPE)
    TGSN._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=14)], ev=None, er=[])
    
    #-----< PrimaryCCPCH-RSCP >-----#
    PrimaryCCPCH_RSCP = INT(name='PrimaryCCPCH-RSCP', mode=MODE_TYPE)
    PrimaryCCPCH_RSCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< TimeslotISCP >-----#
    TimeslotISCP = INT(name='TimeslotISCP', mode=MODE_TYPE)
    TimeslotISCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< TimeslotISCP-List >-----#
    TimeslotISCP_List = SEQ_OF(name='TimeslotISCP-List', mode=MODE_TYPE)
    _TimeslotISCP_List__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ULP-Components', 'TimeslotISCP')))
    TimeslotISCP_List._cont = _TimeslotISCP_List__item_
    TimeslotISCP_List._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=14)], ev=None, er=[])
    
    #-----< PrimaryCPICH-Info >-----#
    PrimaryCPICH_Info = SEQ(name='PrimaryCPICH-Info', mode=MODE_TYPE)
    _PrimaryCPICH_Info_primaryScramblingCode = INT(name='primaryScramblingCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PrimaryCPICH_Info_primaryScramblingCode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=511)], ev=None, er=[])
    PrimaryCPICH_Info._cont = ASN1Dict([
        ('primaryScramblingCode', _PrimaryCPICH_Info_primaryScramblingCode),
        ])
    PrimaryCPICH_Info._ext = None
    
    #-----< CPICH-Ec-N0 >-----#
    CPICH_Ec_N0 = INT(name='CPICH-Ec-N0', mode=MODE_TYPE)
    CPICH_Ec_N0._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    
    #-----< CPICH-RSCP >-----#
    CPICH_RSCP = INT(name='CPICH-RSCP', mode=MODE_TYPE)
    CPICH_RSCP._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    
    #-----< Pathloss >-----#
    Pathloss = INT(name='Pathloss', mode=MODE_TYPE)
    Pathloss._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=46, ub=173)], ev=None, er=[])
    
    #-----< maxCellMeas >-----#
    maxCellMeas = INT(name='maxCellMeas', mode=MODE_VALUE)
    maxCellMeas._val = 32
    
    #-----< maxFreq >-----#
    maxFreq = INT(name='maxFreq', mode=MODE_VALUE)
    maxFreq._val = 8
    
    #-----< maxTS >-----#
    maxTS = INT(name='maxTS', mode=MODE_VALUE)
    maxTS._val = 14
    
    #-----< StatusCode >-----#
    StatusCode = ENUM(name='StatusCode', mode=MODE_TYPE)
    StatusCode._cont = ASN1Dict([('unspecified', 0), ('systemFailure', 1), ('unexpectedMessage', 2), ('protocolError', 3), ('dataMissing', 4), ('unexpectedDataValue', 5), ('posMethodFailure', 6), ('posMethodMismatch', 7), ('posProtocolMismatch', 8), ('targetSETnotReachable', 9), ('versionNotSupported', 10), ('resourceShortage', 11), ('invalidSessionId', 12), ('nonProxyModeNotSupported', 13), ('proxyModeNotSupported', 14), ('positioningNotPermitted', 15), ('authNetFailure', 16), ('authSuplinitFailure', 17), ('ver2-incompatibleProtectionLevel', 18), ('ver2-serviceNotSupported', 19), ('ver2-insufficientInterval', 20), ('ver2-noSUPLCoverage', 21), ('consentDeniedByUser', 100), ('consentGrantedByUser', 101), ('ver2-sessionStopped', 102), ('ver2-appIdDenied', 103)])
    StatusCode._ext = ['ver2-incompatibleProtectionLevel', 'ver2-serviceNotSupported', 'ver2-insufficientInterval', 'ver2-noSUPLCoverage', 'ver2-sessionStopped', 'ver2-appIdDenied']
    
    #-----< QoP >-----#
    QoP = SEQ(name='QoP', mode=MODE_TYPE)
    _QoP_horacc = INT(name='horacc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _QoP_horacc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _QoP_veracc = INT(name='veracc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoP_veracc._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _QoP_maxLocAge = INT(name='maxLocAge', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoP_maxLocAge._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _QoP_delay = INT(name='delay', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _QoP_delay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    QoP._cont = ASN1Dict([
        ('horacc', _QoP_horacc),
        ('veracc', _QoP_veracc),
        ('maxLocAge', _QoP_maxLocAge),
        ('delay', _QoP_delay),
        ])
    QoP._ext = []
    
    #-----< Velocity >-----#
    Velocity = CHOICE(name='Velocity', mode=MODE_TYPE)
    _Velocity_horvel = SEQ(name='horvel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Horvel')))
    _Velocity_horandvervel = SEQ(name='horandvervel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Horandvervel')))
    _Velocity_horveluncert = SEQ(name='horveluncert', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Horveluncert')))
    _Velocity_horandveruncert = SEQ(name='horandveruncert', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Horandveruncert')))
    Velocity._cont = ASN1Dict([
        ('horvel', _Velocity_horvel),
        ('horandvervel', _Velocity_horandvervel),
        ('horveluncert', _Velocity_horveluncert),
        ('horandveruncert', _Velocity_horandveruncert),
        ])
    Velocity._ext = []
    
    #-----< Horvel >-----#
    Horvel = SEQ(name='Horvel', mode=MODE_TYPE)
    _Horvel_bearing = BIT_STR(name='bearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horvel_bearing._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _Horvel_horspeed = BIT_STR(name='horspeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horvel_horspeed._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    Horvel._cont = ASN1Dict([
        ('bearing', _Horvel_bearing),
        ('horspeed', _Horvel_horspeed),
        ])
    Horvel._ext = []
    
    #-----< Horandvervel >-----#
    Horandvervel = SEQ(name='Horandvervel', mode=MODE_TYPE)
    _Horandvervel_verdirect = BIT_STR(name='verdirect', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horandvervel_verdirect._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _Horandvervel_bearing = BIT_STR(name='bearing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horandvervel_bearing._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _Horandvervel_horspeed = BIT_STR(name='horspeed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horandvervel_horspeed._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _Horandvervel_verspeed = BIT_STR(name='verspeed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horandvervel_verspeed._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    Horandvervel._cont = ASN1Dict([
        ('verdirect', _Horandvervel_verdirect),
        ('bearing', _Horandvervel_bearing),
        ('horspeed', _Horandvervel_horspeed),
        ('verspeed', _Horandvervel_verspeed),
        ])
    Horandvervel._ext = []
    
    #-----< Horveluncert >-----#
    Horveluncert = SEQ(name='Horveluncert', mode=MODE_TYPE)
    _Horveluncert_bearing = BIT_STR(name='bearing', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horveluncert_bearing._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _Horveluncert_horspeed = BIT_STR(name='horspeed', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horveluncert_horspeed._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _Horveluncert_uncertspeed = BIT_STR(name='uncertspeed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horveluncert_uncertspeed._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    Horveluncert._cont = ASN1Dict([
        ('bearing', _Horveluncert_bearing),
        ('horspeed', _Horveluncert_horspeed),
        ('uncertspeed', _Horveluncert_uncertspeed),
        ])
    Horveluncert._ext = []
    
    #-----< Horandveruncert >-----#
    Horandveruncert = SEQ(name='Horandveruncert', mode=MODE_TYPE)
    _Horandveruncert_verdirect = BIT_STR(name='verdirect', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horandveruncert_verdirect._const_sz = ASN1Set(rv=[1], rr=[], ev=None, er=[])
    _Horandveruncert_bearing = BIT_STR(name='bearing', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horandveruncert_bearing._const_sz = ASN1Set(rv=[9], rr=[], ev=None, er=[])
    _Horandveruncert_horspeed = BIT_STR(name='horspeed', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horandveruncert_horspeed._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _Horandveruncert_verspeed = BIT_STR(name='verspeed', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horandveruncert_verspeed._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _Horandveruncert_horuncertspeed = BIT_STR(name='horuncertspeed', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horandveruncert_horuncertspeed._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _Horandveruncert_veruncertspeed = BIT_STR(name='veruncertspeed', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Horandveruncert_veruncertspeed._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    Horandveruncert._cont = ASN1Dict([
        ('verdirect', _Horandveruncert_verdirect),
        ('bearing', _Horandveruncert_bearing),
        ('horspeed', _Horandveruncert_horspeed),
        ('verspeed', _Horandveruncert_verspeed),
        ('horuncertspeed', _Horandveruncert_horuncertspeed),
        ('veruncertspeed', _Horandveruncert_veruncertspeed),
        ])
    Horandveruncert._ext = []
    
    #-----< PosMethod >-----#
    PosMethod = ENUM(name='PosMethod', mode=MODE_TYPE)
    PosMethod._cont = ASN1Dict([('agpsSETassisted', 0), ('agpsSETbased', 1), ('agpsSETassistedpref', 2), ('agpsSETbasedpref', 3), ('autonomousGPS', 4), ('aFLT', 5), ('eCID', 6), ('eOTD', 7), ('oTDOA', 8), ('noPosition', 9), ('ver2-historicalDataRetrieval', 10), ('ver2-agnssSETassisted', 11), ('ver2-agnssSETbased', 12), ('ver2-agnssSETassistedpref', 13), ('ver2-agnssSETbasedpref', 14), ('ver2-autonomousGNSS', 15), ('ver2-sessioninfoquery', 16)])
    PosMethod._ext = ['ver2-historicalDataRetrieval', 'ver2-agnssSETassisted', 'ver2-agnssSETbased', 'ver2-agnssSETassistedpref', 'ver2-agnssSETbasedpref', 'ver2-autonomousGNSS', 'ver2-sessioninfoquery']
    
    _all_ = [
        _Version_maj,
        _Version_min,
        _Version_servind,
        Version,
        _SessionID_setSessionID,
        _SessionID_slpSessionID,
        SessionID,
        _SetSessionID_sessionId,
        _SetSessionID_setId,
        SetSessionID,
        _SETId_msisdn,
        _SETId_mdn,
        _SETId_min,
        _SETId_imsi,
        _SETId_nai,
        _SETId_iPAddress,
        SETId,
        _SlpSessionID_sessionID,
        _SlpSessionID_slpId,
        SlpSessionID,
        _IPAddress_ipv4Address,
        _IPAddress_ipv6Address,
        IPAddress,
        _SLPAddress_iPAddress,
        _SLPAddress_fqdn,
        SLPAddress,
        FQDN,
        Ver,
        _LocationId_cellInfo,
        _LocationId_status,
        LocationId,
        Status,
        _CellInfo_gsmCell,
        _CellInfo_wcdmaCell,
        _CellInfo_cdmaCell,
        _CellInfo_ver2_CellInfo_extension,
        CellInfo,
        _Position_timestamp,
        _Position_positionEstimate,
        _Position_velocity,
        Position,
        _PositionEstimate_latitudeSign,
        _PositionEstimate_latitude,
        _PositionEstimate_longitude,
        __PositionEstimate_uncertainty_uncertaintySemiMajor,
        __PositionEstimate_uncertainty_uncertaintySemiMinor,
        __PositionEstimate_uncertainty_orientationMajorAxis,
        _PositionEstimate_uncertainty,
        _PositionEstimate_confidence,
        _PositionEstimate_altitudeInfo,
        PositionEstimate,
        _AltitudeInfo_altitudeDirection,
        _AltitudeInfo_altitude,
        _AltitudeInfo_altUncertainty,
        AltitudeInfo,
        _CdmaCellInformation_refNID,
        _CdmaCellInformation_refSID,
        _CdmaCellInformation_refBASEID,
        _CdmaCellInformation_refBASELAT,
        _CdmaCellInformation_reBASELONG,
        _CdmaCellInformation_refREFPN,
        _CdmaCellInformation_refWeekNumber,
        _CdmaCellInformation_refSeconds,
        CdmaCellInformation,
        _GsmCellInformation_refMCC,
        _GsmCellInformation_refMNC,
        _GsmCellInformation_refLAC,
        _GsmCellInformation_refCI,
        _GsmCellInformation_nmr,
        _GsmCellInformation_ta,
        GsmCellInformation,
        _WcdmaCellInformation_refMCC,
        _WcdmaCellInformation_refMNC,
        _WcdmaCellInformation_refUC,
        _WcdmaCellInformation_frequencyInfo,
        _WcdmaCellInformation_primaryScramblingCode,
        _WcdmaCellInformation_measuredResultsList,
        _WcdmaCellInformation_cellParametersId,
        _WcdmaCellInformation_timingAdvance,
        WcdmaCellInformation,
        _TimingAdvance_ta,
        _TimingAdvance_tAResolution,
        _TimingAdvance_chipRate,
        TimingAdvance,
        TAResolution,
        ChipRate,
        __FrequencyInfo_modeSpecificInfo_fdd,
        __FrequencyInfo_modeSpecificInfo_tdd,
        _FrequencyInfo_modeSpecificInfo,
        FrequencyInfo,
        _FrequencyInfoFDD_uarfcn_UL,
        _FrequencyInfoFDD_uarfcn_DL,
        FrequencyInfoFDD,
        _FrequencyInfoTDD_uarfcn_Nt,
        FrequencyInfoTDD,
        UARFCN,
        _NMR__item_,
        NMR,
        _NMRelement_arfcn,
        _NMRelement_bsic,
        _NMRelement_rxLev,
        NMRelement,
        _MeasuredResultsList__item_,
        MeasuredResultsList,
        _MeasuredResults_frequencyInfo,
        _MeasuredResults_utra_CarrierRSSI,
        _MeasuredResults_cellMeasuredResultsList,
        MeasuredResults,
        _CellMeasuredResultsList__item_,
        CellMeasuredResultsList,
        UTRA_CarrierRSSI,
        _CellMeasuredResults_cellIdentity,
        ___CellMeasuredResults_modeSpecificInfo_fdd_primaryCPICH_Info,
        ___CellMeasuredResults_modeSpecificInfo_fdd_cpich_Ec_N0,
        ___CellMeasuredResults_modeSpecificInfo_fdd_cpich_RSCP,
        ___CellMeasuredResults_modeSpecificInfo_fdd_pathloss,
        __CellMeasuredResults_modeSpecificInfo_fdd,
        ___CellMeasuredResults_modeSpecificInfo_tdd_cellParametersID,
        ___CellMeasuredResults_modeSpecificInfo_tdd_proposedTGSN,
        ___CellMeasuredResults_modeSpecificInfo_tdd_primaryCCPCH_RSCP,
        ___CellMeasuredResults_modeSpecificInfo_tdd_pathloss,
        ___CellMeasuredResults_modeSpecificInfo_tdd_timeslotISCP_List,
        __CellMeasuredResults_modeSpecificInfo_tdd,
        _CellMeasuredResults_modeSpecificInfo,
        CellMeasuredResults,
        CellParametersID,
        TGSN,
        PrimaryCCPCH_RSCP,
        TimeslotISCP,
        _TimeslotISCP_List__item_,
        TimeslotISCP_List,
        _PrimaryCPICH_Info_primaryScramblingCode,
        PrimaryCPICH_Info,
        CPICH_Ec_N0,
        CPICH_RSCP,
        Pathloss,
        maxCellMeas,
        maxFreq,
        maxTS,
        StatusCode,
        _QoP_horacc,
        _QoP_veracc,
        _QoP_maxLocAge,
        _QoP_delay,
        QoP,
        _Velocity_horvel,
        _Velocity_horandvervel,
        _Velocity_horveluncert,
        _Velocity_horandveruncert,
        Velocity,
        _Horvel_bearing,
        _Horvel_horspeed,
        Horvel,
        _Horandvervel_verdirect,
        _Horandvervel_bearing,
        _Horandvervel_horspeed,
        _Horandvervel_verspeed,
        Horandvervel,
        _Horveluncert_bearing,
        _Horveluncert_horspeed,
        _Horveluncert_uncertspeed,
        Horveluncert,
        _Horandveruncert_verdirect,
        _Horandveruncert_bearing,
        _Horandveruncert_horspeed,
        _Horandveruncert_verspeed,
        _Horandveruncert_horuncertspeed,
        _Horandveruncert_veruncertspeed,
        Horandveruncert,
        PosMethod,
    ]

class Ver2_ULP_Components:

    _name_  = 'Ver2-ULP-Components'
    _oid_   = []
    
    _obj_ = [
        'MultipleLocationIds',
        'LocationIdData',
        'RelativeTime',
        'maxLidSize',
        'SupportedNetworkInformation',
        'SupportedWLANInfo',
        'maxWLANApDataSize',
        'SupportedWLANApsList',
        'SupportedWLANApsChannel11a',
        'SupportedWLANApsChannel11bg',
        'SupportedWLANApData',
        'SupportedWCDMAInfo',
        'Ver2-CellInfo-extension',
        'HrpdCellInformation',
        'UmbCellInformation',
        'LteCellInformation',
        'MeasResultListEUTRA',
        'MeasResultEUTRA',
        'PhysCellId',
        'TrackingAreaCode',
        'CellGlobalIdEUTRA',
        'PLMN-Identity',
        'CellIdentity',
        'MCC',
        'MNC',
        'MCC-MNC-Digit',
        'RSRP-Range',
        'RSRQ-Range',
        'maxCellReport',
        'WlanAPInformation',
        'RTD',
        'RTDUnits',
        'ReportedLocation',
        'LocationEncodingDescriptor',
        'LocationData',
        'RepLocation',
        'LciLocData',
        'LocationDataLCI',
        'WimaxBSInformation',
        'WimaxBsID',
        'WimaxRTD',
        'WimaxNMRList',
        'WimaxNMR',
        'maxWimaxBSMeas',
        'UTRAN-GPSReferenceTimeAssistance',
        'UTRAN-GPSReferenceTime',
        'UTRANGPSDriftRate',
        'UTRAN-GPSReferenceTimeResult',
        'UTRAN-GANSSReferenceTimeAssistance',
        'UTRAN-GANSSReferenceTime',
        'UTRANGANSSDriftRate',
        'UTRAN-GANSSReferenceTimeResult',
        'SET-GANSSReferenceTime',
        'GNSSPosTechnology',
        'GANSSSignals',
        'SPCSETKey',
        'SPCTID',
        'SPCSETKeylifetime',
        'CauseCode',
        'ThirdParty',
        'ThirdPartyID',
        'ApplicationID',
        'ReportingCap',
        'RepMode',
        'BatchRepCap',
        'Coordinate',
        'CircularArea',
        'EllipticalArea',
        'PolygonArea',
        'PolygonDescription',
        ]
    _type_ = [
        'MultipleLocationIds',
        'LocationIdData',
        'RelativeTime',
        'SupportedNetworkInformation',
        'SupportedWLANInfo',
        'SupportedWLANApsList',
        'SupportedWLANApsChannel11a',
        'SupportedWLANApsChannel11bg',
        'SupportedWLANApData',
        'SupportedWCDMAInfo',
        'Ver2-CellInfo-extension',
        'HrpdCellInformation',
        'UmbCellInformation',
        'LteCellInformation',
        'MeasResultListEUTRA',
        'MeasResultEUTRA',
        'PhysCellId',
        'TrackingAreaCode',
        'CellGlobalIdEUTRA',
        'PLMN-Identity',
        'CellIdentity',
        'MCC',
        'MNC',
        'MCC-MNC-Digit',
        'RSRP-Range',
        'RSRQ-Range',
        'WlanAPInformation',
        'RTD',
        'RTDUnits',
        'ReportedLocation',
        'LocationEncodingDescriptor',
        'LocationData',
        'RepLocation',
        'LciLocData',
        'LocationDataLCI',
        'WimaxBSInformation',
        'WimaxBsID',
        'WimaxRTD',
        'WimaxNMRList',
        'WimaxNMR',
        'UTRAN-GPSReferenceTimeAssistance',
        'UTRAN-GPSReferenceTime',
        'UTRANGPSDriftRate',
        'UTRAN-GPSReferenceTimeResult',
        'UTRAN-GANSSReferenceTimeAssistance',
        'UTRAN-GANSSReferenceTime',
        'UTRANGANSSDriftRate',
        'UTRAN-GANSSReferenceTimeResult',
        'SET-GANSSReferenceTime',
        'GNSSPosTechnology',
        'GANSSSignals',
        'SPCSETKey',
        'SPCTID',
        'SPCSETKeylifetime',
        'CauseCode',
        'ThirdParty',
        'ThirdPartyID',
        'ApplicationID',
        'ReportingCap',
        'RepMode',
        'BatchRepCap',
        'Coordinate',
        'CircularArea',
        'EllipticalArea',
        'PolygonArea',
        'PolygonDescription',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxLidSize',
        'maxWLANApDataSize',
        'maxCellReport',
        'maxWimaxBSMeas',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< MultipleLocationIds >-----#
    MultipleLocationIds = SEQ_OF(name='MultipleLocationIds', mode=MODE_TYPE)
    _MultipleLocationIds__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Ver2-ULP-Components', 'LocationIdData')))
    MultipleLocationIds._cont = _MultipleLocationIds__item_
    MultipleLocationIds._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< LocationIdData >-----#
    LocationIdData = SEQ(name='LocationIdData', mode=MODE_TYPE)
    _LocationIdData_locationId = SEQ(name='locationId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'LocationId')))
    _LocationIdData_relativetimestamp = INT(name='relativetimestamp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'RelativeTime')), opt=True)
    _LocationIdData_servingFlag = BOOL(name='servingFlag', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    LocationIdData._cont = ASN1Dict([
        ('locationId', _LocationIdData_locationId),
        ('relativetimestamp', _LocationIdData_relativetimestamp),
        ('servingFlag', _LocationIdData_servingFlag),
        ])
    LocationIdData._ext = []
    
    #-----< RelativeTime >-----#
    RelativeTime = INT(name='RelativeTime', mode=MODE_TYPE)
    RelativeTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    
    #-----< maxLidSize >-----#
    maxLidSize = INT(name='maxLidSize', mode=MODE_VALUE)
    maxLidSize._val = 64
    
    #-----< SupportedNetworkInformation >-----#
    SupportedNetworkInformation = SEQ(name='SupportedNetworkInformation', mode=MODE_TYPE)
    _SupportedNetworkInformation_wlan = BOOL(name='wlan', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_supportedWLANInfo = SEQ(name='supportedWLANInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SupportedWLANInfo')), opt=True)
    _SupportedNetworkInformation_supportedWLANApsList = SEQ(name='supportedWLANApsList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SupportedWLANApsList')), opt=True)
    _SupportedNetworkInformation_gsm = BOOL(name='gsm', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_wcdma = BOOL(name='wcdma', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_supportedWCDMAInfo = SEQ(name='supportedWCDMAInfo', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SupportedWCDMAInfo')), opt=True)
    _SupportedNetworkInformation_cdma = BOOL(name='cdma', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_hrdp = BOOL(name='hrdp', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_umb = BOOL(name='umb', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_lte = BOOL(name='lte', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_wimax = BOOL(name='wimax', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_historic = BOOL(name='historic', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_nonServing = BOOL(name='nonServing', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_uTRANGPSReferenceTime = BOOL(name='uTRANGPSReferenceTime', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedNetworkInformation_uTRANGANSSReferenceTime = BOOL(name='uTRANGANSSReferenceTime', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SupportedNetworkInformation._cont = ASN1Dict([
        ('wlan', _SupportedNetworkInformation_wlan),
        ('supportedWLANInfo', _SupportedNetworkInformation_supportedWLANInfo),
        ('supportedWLANApsList', _SupportedNetworkInformation_supportedWLANApsList),
        ('gsm', _SupportedNetworkInformation_gsm),
        ('wcdma', _SupportedNetworkInformation_wcdma),
        ('supportedWCDMAInfo', _SupportedNetworkInformation_supportedWCDMAInfo),
        ('cdma', _SupportedNetworkInformation_cdma),
        ('hrdp', _SupportedNetworkInformation_hrdp),
        ('umb', _SupportedNetworkInformation_umb),
        ('lte', _SupportedNetworkInformation_lte),
        ('wimax', _SupportedNetworkInformation_wimax),
        ('historic', _SupportedNetworkInformation_historic),
        ('nonServing', _SupportedNetworkInformation_nonServing),
        ('uTRANGPSReferenceTime', _SupportedNetworkInformation_uTRANGPSReferenceTime),
        ('uTRANGANSSReferenceTime', _SupportedNetworkInformation_uTRANGANSSReferenceTime),
        ])
    SupportedNetworkInformation._ext = []
    
    #-----< SupportedWLANInfo >-----#
    SupportedWLANInfo = SEQ(name='SupportedWLANInfo', mode=MODE_TYPE)
    _SupportedWLANInfo_apTP = BOOL(name='apTP', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_apAG = BOOL(name='apAG', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_apSN = BOOL(name='apSN', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_apDevType = BOOL(name='apDevType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_apRSSI = BOOL(name='apRSSI', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_apChanFreq = BOOL(name='apChanFreq', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_apRTD = BOOL(name='apRTD', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_setTP = BOOL(name='setTP', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_setAG = BOOL(name='setAG', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_setSN = BOOL(name='setSN', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_setRSSI = BOOL(name='setRSSI', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANInfo_apRepLoc = BOOL(name='apRepLoc', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SupportedWLANInfo._cont = ASN1Dict([
        ('apTP', _SupportedWLANInfo_apTP),
        ('apAG', _SupportedWLANInfo_apAG),
        ('apSN', _SupportedWLANInfo_apSN),
        ('apDevType', _SupportedWLANInfo_apDevType),
        ('apRSSI', _SupportedWLANInfo_apRSSI),
        ('apChanFreq', _SupportedWLANInfo_apChanFreq),
        ('apRTD', _SupportedWLANInfo_apRTD),
        ('setTP', _SupportedWLANInfo_setTP),
        ('setAG', _SupportedWLANInfo_setAG),
        ('setSN', _SupportedWLANInfo_setSN),
        ('setRSSI', _SupportedWLANInfo_setRSSI),
        ('apRepLoc', _SupportedWLANInfo_apRepLoc),
        ])
    SupportedWLANInfo._ext = []
    
    #-----< maxWLANApDataSize >-----#
    maxWLANApDataSize = INT(name='maxWLANApDataSize', mode=MODE_VALUE)
    maxWLANApDataSize._val = 128
    
    #-----< SupportedWLANApsList >-----#
    SupportedWLANApsList = SEQ(name='SupportedWLANApsList', mode=MODE_TYPE)
    _SupportedWLANApsList_supportedWLANApDataList = SEQ_OF(name='supportedWLANApDataList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SupportedWLANApsList_supportedWLANApDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Ver2-ULP-Components', 'SupportedWLANApData')))
    _SupportedWLANApsList_supportedWLANApDataList._cont = __SupportedWLANApsList_supportedWLANApDataList__item_
    _SupportedWLANApsList_supportedWLANApDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _SupportedWLANApsList_supportedWLANapsChannel11a = SEQ(name='supportedWLANapsChannel11a', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SupportedWLANApsChannel11a')), opt=True)
    _SupportedWLANApsList_supportedWLANapsChannel11bg = SEQ(name='supportedWLANapsChannel11bg', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SupportedWLANApsChannel11bg')), opt=True)
    SupportedWLANApsList._cont = ASN1Dict([
        ('supportedWLANApDataList', _SupportedWLANApsList_supportedWLANApDataList),
        ('supportedWLANapsChannel11a', _SupportedWLANApsList_supportedWLANapsChannel11a),
        ('supportedWLANapsChannel11bg', _SupportedWLANApsList_supportedWLANapsChannel11bg),
        ])
    SupportedWLANApsList._ext = []
    
    #-----< SupportedWLANApsChannel11a >-----#
    SupportedWLANApsChannel11a = SEQ(name='SupportedWLANApsChannel11a', mode=MODE_TYPE)
    _SupportedWLANApsChannel11a_ch34 = BOOL(name='ch34', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch36 = BOOL(name='ch36', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch38 = BOOL(name='ch38', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch40 = BOOL(name='ch40', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch42 = BOOL(name='ch42', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch44 = BOOL(name='ch44', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch46 = BOOL(name='ch46', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch48 = BOOL(name='ch48', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch52 = BOOL(name='ch52', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch56 = BOOL(name='ch56', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch60 = BOOL(name='ch60', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch64 = BOOL(name='ch64', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch149 = BOOL(name='ch149', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch153 = BOOL(name='ch153', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch157 = BOOL(name='ch157', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11a_ch161 = BOOL(name='ch161', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SupportedWLANApsChannel11a._cont = ASN1Dict([
        ('ch34', _SupportedWLANApsChannel11a_ch34),
        ('ch36', _SupportedWLANApsChannel11a_ch36),
        ('ch38', _SupportedWLANApsChannel11a_ch38),
        ('ch40', _SupportedWLANApsChannel11a_ch40),
        ('ch42', _SupportedWLANApsChannel11a_ch42),
        ('ch44', _SupportedWLANApsChannel11a_ch44),
        ('ch46', _SupportedWLANApsChannel11a_ch46),
        ('ch48', _SupportedWLANApsChannel11a_ch48),
        ('ch52', _SupportedWLANApsChannel11a_ch52),
        ('ch56', _SupportedWLANApsChannel11a_ch56),
        ('ch60', _SupportedWLANApsChannel11a_ch60),
        ('ch64', _SupportedWLANApsChannel11a_ch64),
        ('ch149', _SupportedWLANApsChannel11a_ch149),
        ('ch153', _SupportedWLANApsChannel11a_ch153),
        ('ch157', _SupportedWLANApsChannel11a_ch157),
        ('ch161', _SupportedWLANApsChannel11a_ch161),
        ])
    SupportedWLANApsChannel11a._ext = None
    
    #-----< SupportedWLANApsChannel11bg >-----#
    SupportedWLANApsChannel11bg = SEQ(name='SupportedWLANApsChannel11bg', mode=MODE_TYPE)
    _SupportedWLANApsChannel11bg_ch1 = BOOL(name='ch1', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch2 = BOOL(name='ch2', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch3 = BOOL(name='ch3', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch4 = BOOL(name='ch4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch5 = BOOL(name='ch5', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch6 = BOOL(name='ch6', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch7 = BOOL(name='ch7', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch8 = BOOL(name='ch8', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch9 = BOOL(name='ch9', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch10 = BOOL(name='ch10', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch11 = BOOL(name='ch11', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch12 = BOOL(name='ch12', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch13 = BOOL(name='ch13', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApsChannel11bg_ch14 = BOOL(name='ch14', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SupportedWLANApsChannel11bg._cont = ASN1Dict([
        ('ch1', _SupportedWLANApsChannel11bg_ch1),
        ('ch2', _SupportedWLANApsChannel11bg_ch2),
        ('ch3', _SupportedWLANApsChannel11bg_ch3),
        ('ch4', _SupportedWLANApsChannel11bg_ch4),
        ('ch5', _SupportedWLANApsChannel11bg_ch5),
        ('ch6', _SupportedWLANApsChannel11bg_ch6),
        ('ch7', _SupportedWLANApsChannel11bg_ch7),
        ('ch8', _SupportedWLANApsChannel11bg_ch8),
        ('ch9', _SupportedWLANApsChannel11bg_ch9),
        ('ch10', _SupportedWLANApsChannel11bg_ch10),
        ('ch11', _SupportedWLANApsChannel11bg_ch11),
        ('ch12', _SupportedWLANApsChannel11bg_ch12),
        ('ch13', _SupportedWLANApsChannel11bg_ch13),
        ('ch14', _SupportedWLANApsChannel11bg_ch14),
        ])
    SupportedWLANApsChannel11bg._ext = None
    
    #-----< SupportedWLANApData >-----#
    SupportedWLANApData = SEQ(name='SupportedWLANApData', mode=MODE_TYPE)
    _SupportedWLANApData_apMACAddress = BIT_STR(name='apMACAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApData_apMACAddress._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    _SupportedWLANApData_apDevType = ENUM(name='apDevType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedWLANApData_apDevType._cont = ASN1Dict([('wlan802-11a', 0), ('wlan802-11b', 1), ('wlan802-11g', 2)])
    _SupportedWLANApData_apDevType._ext = []
    SupportedWLANApData._cont = ASN1Dict([
        ('apMACAddress', _SupportedWLANApData_apMACAddress),
        ('apDevType', _SupportedWLANApData_apDevType),
        ])
    SupportedWLANApData._ext = []
    
    #-----< SupportedWCDMAInfo >-----#
    SupportedWCDMAInfo = SEQ(name='SupportedWCDMAInfo', mode=MODE_TYPE)
    _SupportedWCDMAInfo_mrl = BOOL(name='mrl', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SupportedWCDMAInfo._cont = ASN1Dict([
        ('mrl', _SupportedWCDMAInfo_mrl),
        ])
    SupportedWCDMAInfo._ext = []
    
    #-----< Ver2-CellInfo-extension >-----#
    Ver2_CellInfo_extension = CHOICE(name='Ver2-CellInfo-extension', mode=MODE_TYPE)
    _Ver2_CellInfo_extension_hrpdCell = SEQ(name='hrpdCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'HrpdCellInformation')))
    _Ver2_CellInfo_extension_umbCell = SEQ(name='umbCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UmbCellInformation')))
    _Ver2_CellInfo_extension_lteCell = SEQ(name='lteCell', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'LteCellInformation')))
    _Ver2_CellInfo_extension_wlanAP = SEQ(name='wlanAP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'WlanAPInformation')))
    _Ver2_CellInfo_extension_wimaxBS = SEQ(name='wimaxBS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'WimaxBSInformation')))
    Ver2_CellInfo_extension._cont = ASN1Dict([
        ('hrpdCell', _Ver2_CellInfo_extension_hrpdCell),
        ('umbCell', _Ver2_CellInfo_extension_umbCell),
        ('lteCell', _Ver2_CellInfo_extension_lteCell),
        ('wlanAP', _Ver2_CellInfo_extension_wlanAP),
        ('wimaxBS', _Ver2_CellInfo_extension_wimaxBS),
        ])
    Ver2_CellInfo_extension._ext = []
    
    #-----< HrpdCellInformation >-----#
    HrpdCellInformation = SEQ(name='HrpdCellInformation', mode=MODE_TYPE)
    _HrpdCellInformation_refSECTORID = BIT_STR(name='refSECTORID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _HrpdCellInformation_refSECTORID._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _HrpdCellInformation_refBASELAT = INT(name='refBASELAT', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HrpdCellInformation_refBASELAT._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4194303)], ev=None, er=[])
    _HrpdCellInformation_reBASELONG = INT(name='reBASELONG', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HrpdCellInformation_reBASELONG._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _HrpdCellInformation_refWeekNumber = INT(name='refWeekNumber', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HrpdCellInformation_refWeekNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _HrpdCellInformation_refSeconds = INT(name='refSeconds', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HrpdCellInformation_refSeconds._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4194303)], ev=None, er=[])
    HrpdCellInformation._cont = ASN1Dict([
        ('refSECTORID', _HrpdCellInformation_refSECTORID),
        ('refBASELAT', _HrpdCellInformation_refBASELAT),
        ('reBASELONG', _HrpdCellInformation_reBASELONG),
        ('refWeekNumber', _HrpdCellInformation_refWeekNumber),
        ('refSeconds', _HrpdCellInformation_refSeconds),
        ])
    HrpdCellInformation._ext = []
    
    #-----< UmbCellInformation >-----#
    UmbCellInformation = SEQ(name='UmbCellInformation', mode=MODE_TYPE)
    _UmbCellInformation_refSECTORID = BIT_STR(name='refSECTORID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UmbCellInformation_refSECTORID._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _UmbCellInformation_refMCC = INT(name='refMCC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UmbCellInformation_refMCC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _UmbCellInformation_refMNC = INT(name='refMNC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UmbCellInformation_refMNC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _UmbCellInformation_refBASELAT = INT(name='refBASELAT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UmbCellInformation_refBASELAT._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4194303)], ev=None, er=[])
    _UmbCellInformation_reBASELONG = INT(name='reBASELONG', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UmbCellInformation_reBASELONG._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _UmbCellInformation_refWeekNumber = INT(name='refWeekNumber', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UmbCellInformation_refWeekNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _UmbCellInformation_refSeconds = INT(name='refSeconds', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UmbCellInformation_refSeconds._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4194303)], ev=None, er=[])
    UmbCellInformation._cont = ASN1Dict([
        ('refSECTORID', _UmbCellInformation_refSECTORID),
        ('refMCC', _UmbCellInformation_refMCC),
        ('refMNC', _UmbCellInformation_refMNC),
        ('refBASELAT', _UmbCellInformation_refBASELAT),
        ('reBASELONG', _UmbCellInformation_reBASELONG),
        ('refWeekNumber', _UmbCellInformation_refWeekNumber),
        ('refSeconds', _UmbCellInformation_refSeconds),
        ])
    UmbCellInformation._ext = []
    
    #-----< LteCellInformation >-----#
    LteCellInformation = SEQ(name='LteCellInformation', mode=MODE_TYPE)
    _LteCellInformation_cellGlobalIdEUTRA = SEQ(name='cellGlobalIdEUTRA', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'CellGlobalIdEUTRA')))
    _LteCellInformation_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'PhysCellId')))
    _LteCellInformation_trackingAreaCode = BIT_STR(name='trackingAreaCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'TrackingAreaCode')))
    _LteCellInformation_rsrpResult = INT(name='rsrpResult', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'RSRP-Range')), opt=True)
    _LteCellInformation_rsrqResult = INT(name='rsrqResult', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'RSRQ-Range')), opt=True)
    _LteCellInformation_ta = INT(name='ta', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LteCellInformation_ta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1282)], ev=None, er=[])
    _LteCellInformation_measResultListEUTRA = SEQ_OF(name='measResultListEUTRA', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'MeasResultListEUTRA')), opt=True)
    _LteCellInformation_earfcn = INT(name='earfcn', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LteCellInformation_earfcn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _LteCellInformation_earfcn_ext = INT(name='earfcn-ext', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LteCellInformation_earfcn_ext._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=65536, ub=262143)], ev=None, er=[])
    LteCellInformation._cont = ASN1Dict([
        ('cellGlobalIdEUTRA', _LteCellInformation_cellGlobalIdEUTRA),
        ('physCellId', _LteCellInformation_physCellId),
        ('trackingAreaCode', _LteCellInformation_trackingAreaCode),
        ('rsrpResult', _LteCellInformation_rsrpResult),
        ('rsrqResult', _LteCellInformation_rsrqResult),
        ('ta', _LteCellInformation_ta),
        ('measResultListEUTRA', _LteCellInformation_measResultListEUTRA),
        ('earfcn', _LteCellInformation_earfcn),
        ('earfcn-ext', _LteCellInformation_earfcn_ext),
        ])
    LteCellInformation._ext = ['earfcn', 'earfcn-ext']
    
    #-----< MeasResultListEUTRA >-----#
    MeasResultListEUTRA = SEQ_OF(name='MeasResultListEUTRA', mode=MODE_TYPE)
    _MeasResultListEUTRA__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Ver2-ULP-Components', 'MeasResultEUTRA')))
    MeasResultListEUTRA._cont = _MeasResultListEUTRA__item_
    MeasResultListEUTRA._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< MeasResultEUTRA >-----#
    MeasResultEUTRA = SEQ(name='MeasResultEUTRA', mode=MODE_TYPE)
    _MeasResultEUTRA_physCellId = INT(name='physCellId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'PhysCellId')))
    _MeasResultEUTRA_cgi_Info = SEQ(name='cgi-Info', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MeasResultEUTRA_cgi_Info_cellGlobalId = SEQ(name='cellGlobalId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'CellGlobalIdEUTRA')))
    __MeasResultEUTRA_cgi_Info_trackingAreaCode = BIT_STR(name='trackingAreaCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'TrackingAreaCode')))
    _MeasResultEUTRA_cgi_Info._cont = ASN1Dict([
        ('cellGlobalId', __MeasResultEUTRA_cgi_Info_cellGlobalId),
        ('trackingAreaCode', __MeasResultEUTRA_cgi_Info_trackingAreaCode),
        ])
    _MeasResultEUTRA_cgi_Info._ext = None
    _MeasResultEUTRA_measResult = SEQ(name='measResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __MeasResultEUTRA_measResult_rsrpResult = INT(name='rsrpResult', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'RSRP-Range')), opt=True)
    __MeasResultEUTRA_measResult_rsrqResult = INT(name='rsrqResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'RSRQ-Range')), opt=True)
    __MeasResultEUTRA_measResult_earfcn = INT(name='earfcn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MeasResultEUTRA_measResult_earfcn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    __MeasResultEUTRA_measResult_earfcn_ext = INT(name='earfcn-ext', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __MeasResultEUTRA_measResult_earfcn_ext._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=65536, ub=262143)], ev=None, er=[])
    _MeasResultEUTRA_measResult._cont = ASN1Dict([
        ('rsrpResult', __MeasResultEUTRA_measResult_rsrpResult),
        ('rsrqResult', __MeasResultEUTRA_measResult_rsrqResult),
        ('earfcn', __MeasResultEUTRA_measResult_earfcn),
        ('earfcn-ext', __MeasResultEUTRA_measResult_earfcn_ext),
        ])
    _MeasResultEUTRA_measResult._ext = ['earfcn', 'earfcn-ext']
    MeasResultEUTRA._cont = ASN1Dict([
        ('physCellId', _MeasResultEUTRA_physCellId),
        ('cgi-Info', _MeasResultEUTRA_cgi_Info),
        ('measResult', _MeasResultEUTRA_measResult),
        ])
    MeasResultEUTRA._ext = None
    
    #-----< PhysCellId >-----#
    PhysCellId = INT(name='PhysCellId', mode=MODE_TYPE)
    PhysCellId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=503)], ev=None, er=[])
    
    #-----< TrackingAreaCode >-----#
    TrackingAreaCode = BIT_STR(name='TrackingAreaCode', mode=MODE_TYPE)
    TrackingAreaCode._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    
    #-----< CellGlobalIdEUTRA >-----#
    CellGlobalIdEUTRA = SEQ(name='CellGlobalIdEUTRA', mode=MODE_TYPE)
    _CellGlobalIdEUTRA_plmn_Identity = SEQ(name='plmn-Identity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'PLMN-Identity')))
    _CellGlobalIdEUTRA_cellIdentity = BIT_STR(name='cellIdentity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'CellIdentity')))
    CellGlobalIdEUTRA._cont = ASN1Dict([
        ('plmn-Identity', _CellGlobalIdEUTRA_plmn_Identity),
        ('cellIdentity', _CellGlobalIdEUTRA_cellIdentity),
        ])
    CellGlobalIdEUTRA._ext = []
    
    #-----< PLMN-Identity >-----#
    PLMN_Identity = SEQ(name='PLMN-Identity', mode=MODE_TYPE)
    _PLMN_Identity_mcc = SEQ_OF(name='mcc', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'MCC')), opt=True)
    _PLMN_Identity_mnc = SEQ_OF(name='mnc', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'MNC')))
    PLMN_Identity._cont = ASN1Dict([
        ('mcc', _PLMN_Identity_mcc),
        ('mnc', _PLMN_Identity_mnc),
        ])
    PLMN_Identity._ext = None
    
    #-----< CellIdentity >-----#
    CellIdentity = BIT_STR(name='CellIdentity', mode=MODE_TYPE)
    CellIdentity._const_sz = ASN1Set(rv=[28], rr=[], ev=None, er=[])
    
    #-----< MCC >-----#
    MCC = SEQ_OF(name='MCC', mode=MODE_TYPE)
    _MCC__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Ver2-ULP-Components', 'MCC-MNC-Digit')))
    MCC._cont = _MCC__item_
    MCC._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    
    #-----< MNC >-----#
    MNC = SEQ_OF(name='MNC', mode=MODE_TYPE)
    _MNC__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Ver2-ULP-Components', 'MCC-MNC-Digit')))
    MNC._cont = _MNC__item_
    MNC._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=2, ub=3)], ev=None, er=[])
    
    #-----< MCC-MNC-Digit >-----#
    MCC_MNC_Digit = INT(name='MCC-MNC-Digit', mode=MODE_TYPE)
    MCC_MNC_Digit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=9)], ev=None, er=[])
    
    #-----< RSRP-Range >-----#
    RSRP_Range = INT(name='RSRP-Range', mode=MODE_TYPE)
    RSRP_Range._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=97)], ev=None, er=[])
    
    #-----< RSRQ-Range >-----#
    RSRQ_Range = INT(name='RSRQ-Range', mode=MODE_TYPE)
    RSRQ_Range._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=34)], ev=None, er=[])
    
    #-----< maxCellReport >-----#
    maxCellReport = INT(name='maxCellReport', mode=MODE_VALUE)
    maxCellReport._val = 8
    
    #-----< WlanAPInformation >-----#
    WlanAPInformation = SEQ(name='WlanAPInformation', mode=MODE_TYPE)
    _WlanAPInformation_apMACAddress = BIT_STR(name='apMACAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WlanAPInformation_apMACAddress._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    _WlanAPInformation_apTransmitPower = INT(name='apTransmitPower', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_apTransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _WlanAPInformation_apAntennaGain = INT(name='apAntennaGain', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_apAntennaGain._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _WlanAPInformation_apSignaltoNoise = INT(name='apSignaltoNoise', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_apSignaltoNoise._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _WlanAPInformation_apDeviceType = ENUM(name='apDeviceType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_apDeviceType._cont = ASN1Dict([('wlan802-11a', 0), ('wlan802-11b', 1), ('wlan802-11g', 2), ('wlan802-11n', 3), ('wlan802-11ac', 4), ('wlan802-11ad', 5)])
    _WlanAPInformation_apDeviceType._ext = ['wlan802-11n', 'wlan802-11ac', 'wlan802-11ad']
    _WlanAPInformation_apSignalStrength = INT(name='apSignalStrength', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_apSignalStrength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _WlanAPInformation_apChannelFrequency = INT(name='apChannelFrequency', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_apChannelFrequency._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    _WlanAPInformation_apRoundTripDelay = SEQ(name='apRoundTripDelay', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'RTD')), opt=True)
    _WlanAPInformation_setTransmitPower = INT(name='setTransmitPower', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_setTransmitPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _WlanAPInformation_setAntennaGain = INT(name='setAntennaGain', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_setAntennaGain._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _WlanAPInformation_setSignaltoNoise = INT(name='setSignaltoNoise', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_setSignaltoNoise._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _WlanAPInformation_setSignalStrength = INT(name='setSignalStrength', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_setSignalStrength._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-127, ub=128)], ev=None, er=[])
    _WlanAPInformation_apReportedLocation = SEQ(name='apReportedLocation', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'ReportedLocation')), opt=True)
    _WlanAPInformation_apRepLocation = CHOICE(name='apRepLocation', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'RepLocation')), opt=True)
    _WlanAPInformation_apSignalStrengthDelta = INT(name='apSignalStrengthDelta', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_apSignalStrengthDelta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _WlanAPInformation_apSignaltoNoiseDelta = INT(name='apSignaltoNoiseDelta', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_apSignaltoNoiseDelta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _WlanAPInformation_setSignalStrengthDelta = INT(name='setSignalStrengthDelta', mode=MODE_TYPE, tag=(16, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_setSignalStrengthDelta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _WlanAPInformation_setSignaltoNoiseDelta = INT(name='setSignaltoNoiseDelta', mode=MODE_TYPE, tag=(17, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_setSignaltoNoiseDelta._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1)], ev=None, er=[])
    _WlanAPInformation_operatingClass = INT(name='operatingClass', mode=MODE_TYPE, tag=(18, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_operatingClass._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _WlanAPInformation_apSSID = OCT_STR(name='apSSID', mode=MODE_TYPE, tag=(19, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_apSSID._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _WlanAPInformation_apPHYType = ENUM(name='apPHYType', mode=MODE_TYPE, tag=(20, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_apPHYType._cont = ASN1Dict([('unknown', 0), ('any', 1), ('fhss', 2), ('dsss', 3), ('irbaseband', 4), ('ofdm', 5), ('hrdsss', 6), ('erp', 7), ('ht', 8), ('ihv', 9)])
    _WlanAPInformation_apPHYType._ext = []
    _WlanAPInformation_setMACAddress = BIT_STR(name='setMACAddress', mode=MODE_TYPE, tag=(21, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WlanAPInformation_setMACAddress._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    WlanAPInformation._cont = ASN1Dict([
        ('apMACAddress', _WlanAPInformation_apMACAddress),
        ('apTransmitPower', _WlanAPInformation_apTransmitPower),
        ('apAntennaGain', _WlanAPInformation_apAntennaGain),
        ('apSignaltoNoise', _WlanAPInformation_apSignaltoNoise),
        ('apDeviceType', _WlanAPInformation_apDeviceType),
        ('apSignalStrength', _WlanAPInformation_apSignalStrength),
        ('apChannelFrequency', _WlanAPInformation_apChannelFrequency),
        ('apRoundTripDelay', _WlanAPInformation_apRoundTripDelay),
        ('setTransmitPower', _WlanAPInformation_setTransmitPower),
        ('setAntennaGain', _WlanAPInformation_setAntennaGain),
        ('setSignaltoNoise', _WlanAPInformation_setSignaltoNoise),
        ('setSignalStrength', _WlanAPInformation_setSignalStrength),
        ('apReportedLocation', _WlanAPInformation_apReportedLocation),
        ('apRepLocation', _WlanAPInformation_apRepLocation),
        ('apSignalStrengthDelta', _WlanAPInformation_apSignalStrengthDelta),
        ('apSignaltoNoiseDelta', _WlanAPInformation_apSignaltoNoiseDelta),
        ('setSignalStrengthDelta', _WlanAPInformation_setSignalStrengthDelta),
        ('setSignaltoNoiseDelta', _WlanAPInformation_setSignaltoNoiseDelta),
        ('operatingClass', _WlanAPInformation_operatingClass),
        ('apSSID', _WlanAPInformation_apSSID),
        ('apPHYType', _WlanAPInformation_apPHYType),
        ('setMACAddress', _WlanAPInformation_setMACAddress),
        ])
    WlanAPInformation._ext = ['apRepLocation', 'apSignalStrengthDelta', 'apSignaltoNoiseDelta', 'setSignalStrengthDelta', 'setSignaltoNoiseDelta', 'operatingClass', 'apSSID', 'apPHYType', 'setMACAddress']
    
    #-----< RTD >-----#
    RTD = SEQ(name='RTD', mode=MODE_TYPE)
    _RTD_rTDValue = INT(name='rTDValue', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RTD_rTDValue._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16777216)], ev=None, er=[])
    _RTD_rTDUnits = ENUM(name='rTDUnits', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'RTDUnits')))
    _RTD_rTDAccuracy = INT(name='rTDAccuracy', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _RTD_rTDAccuracy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    RTD._cont = ASN1Dict([
        ('rTDValue', _RTD_rTDValue),
        ('rTDUnits', _RTD_rTDUnits),
        ('rTDAccuracy', _RTD_rTDAccuracy),
        ])
    RTD._ext = []
    
    #-----< RTDUnits >-----#
    RTDUnits = ENUM(name='RTDUnits', mode=MODE_TYPE)
    RTDUnits._cont = ASN1Dict([('microseconds', 0), ('hundredsofnanoseconds', 1), ('tensofnanoseconds', 2), ('nanoseconds', 3), ('tenthsofnanoseconds', 4)])
    RTDUnits._ext = []
    
    #-----< ReportedLocation >-----#
    ReportedLocation = SEQ(name='ReportedLocation', mode=MODE_TYPE)
    _ReportedLocation_locationEncodingDescriptor = ENUM(name='locationEncodingDescriptor', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'LocationEncodingDescriptor')))
    _ReportedLocation_locationData = SEQ(name='locationData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'LocationData')))
    ReportedLocation._cont = ASN1Dict([
        ('locationEncodingDescriptor', _ReportedLocation_locationEncodingDescriptor),
        ('locationData', _ReportedLocation_locationData),
        ])
    ReportedLocation._ext = []
    
    #-----< LocationEncodingDescriptor >-----#
    LocationEncodingDescriptor = ENUM(name='LocationEncodingDescriptor', mode=MODE_TYPE)
    LocationEncodingDescriptor._cont = ASN1Dict([('lci', 0), ('asn1', 1)])
    LocationEncodingDescriptor._ext = []
    
    #-----< LocationData >-----#
    LocationData = SEQ(name='LocationData', mode=MODE_TYPE)
    _LocationData_locationAccuracy = INT(name='locationAccuracy', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LocationData_locationAccuracy._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _LocationData_locationValue = OCT_STR(name='locationValue', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationData_locationValue._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    LocationData._cont = ASN1Dict([
        ('locationAccuracy', _LocationData_locationAccuracy),
        ('locationValue', _LocationData_locationValue),
        ])
    LocationData._ext = []
    
    #-----< RepLocation >-----#
    RepLocation = CHOICE(name='RepLocation', mode=MODE_TYPE)
    _RepLocation_lciLocData = SEQ(name='lciLocData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'LciLocData')))
    RepLocation._cont = ASN1Dict([
        ('lciLocData', _RepLocation_lciLocData),
        ])
    RepLocation._ext = []
    
    #-----< LciLocData >-----#
    LciLocData = SEQ(name='LciLocData', mode=MODE_TYPE)
    _LciLocData_locationDataLCI = SEQ(name='locationDataLCI', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'LocationDataLCI')), opt=True)
    LciLocData._cont = ASN1Dict([
        ('locationDataLCI', _LciLocData_locationDataLCI),
        ])
    LciLocData._ext = []
    
    #-----< LocationDataLCI >-----#
    LocationDataLCI = SEQ(name='LocationDataLCI', mode=MODE_TYPE)
    _LocationDataLCI_latitudeResolution = BIT_STR(name='latitudeResolution', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationDataLCI_latitudeResolution._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _LocationDataLCI_latitude = BIT_STR(name='latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationDataLCI_latitude._const_sz = ASN1Set(rv=[34], rr=[], ev=None, er=[])
    _LocationDataLCI_longitudeResolution = BIT_STR(name='longitudeResolution', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationDataLCI_longitudeResolution._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _LocationDataLCI_longitude = BIT_STR(name='longitude', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationDataLCI_longitude._const_sz = ASN1Set(rv=[34], rr=[], ev=None, er=[])
    _LocationDataLCI_altitudeType = BIT_STR(name='altitudeType', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationDataLCI_altitudeType._const_sz = ASN1Set(rv=[4], rr=[], ev=None, er=[])
    _LocationDataLCI_altitudeResolution = BIT_STR(name='altitudeResolution', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationDataLCI_altitudeResolution._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _LocationDataLCI_altitude = BIT_STR(name='altitude', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationDataLCI_altitude._const_sz = ASN1Set(rv=[30], rr=[], ev=None, er=[])
    _LocationDataLCI_datum = BIT_STR(name='datum', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _LocationDataLCI_datum._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    LocationDataLCI._cont = ASN1Dict([
        ('latitudeResolution', _LocationDataLCI_latitudeResolution),
        ('latitude', _LocationDataLCI_latitude),
        ('longitudeResolution', _LocationDataLCI_longitudeResolution),
        ('longitude', _LocationDataLCI_longitude),
        ('altitudeType', _LocationDataLCI_altitudeType),
        ('altitudeResolution', _LocationDataLCI_altitudeResolution),
        ('altitude', _LocationDataLCI_altitude),
        ('datum', _LocationDataLCI_datum),
        ])
    LocationDataLCI._ext = []
    
    #-----< WimaxBSInformation >-----#
    WimaxBSInformation = SEQ(name='WimaxBSInformation', mode=MODE_TYPE)
    _WimaxBSInformation_wimaxBsID = SEQ(name='wimaxBsID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'WimaxBsID')))
    _WimaxBSInformation_wimaxRTD = SEQ(name='wimaxRTD', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'WimaxRTD')), opt=True)
    _WimaxBSInformation_wimaxNMRList = SEQ_OF(name='wimaxNMRList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'WimaxNMRList')), opt=True)
    WimaxBSInformation._cont = ASN1Dict([
        ('wimaxBsID', _WimaxBSInformation_wimaxBsID),
        ('wimaxRTD', _WimaxBSInformation_wimaxRTD),
        ('wimaxNMRList', _WimaxBSInformation_wimaxNMRList),
        ])
    WimaxBSInformation._ext = []
    
    #-----< WimaxBsID >-----#
    WimaxBsID = SEQ(name='WimaxBsID', mode=MODE_TYPE)
    _WimaxBsID_bsID_MSB = BIT_STR(name='bsID-MSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WimaxBsID_bsID_MSB._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _WimaxBsID_bsID_LSB = BIT_STR(name='bsID-LSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WimaxBsID_bsID_LSB._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    WimaxBsID._cont = ASN1Dict([
        ('bsID-MSB', _WimaxBsID_bsID_MSB),
        ('bsID-LSB', _WimaxBsID_bsID_LSB),
        ])
    WimaxBsID._ext = []
    
    #-----< WimaxRTD >-----#
    WimaxRTD = SEQ(name='WimaxRTD', mode=MODE_TYPE)
    _WimaxRTD_rtd = INT(name='rtd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WimaxRTD_rtd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _WimaxRTD_rTDstd = INT(name='rTDstd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WimaxRTD_rTDstd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    WimaxRTD._cont = ASN1Dict([
        ('rtd', _WimaxRTD_rtd),
        ('rTDstd', _WimaxRTD_rTDstd),
        ])
    WimaxRTD._ext = []
    
    #-----< WimaxNMRList >-----#
    WimaxNMRList = SEQ_OF(name='WimaxNMRList', mode=MODE_TYPE)
    _WimaxNMRList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Ver2-ULP-Components', 'WimaxNMR')))
    WimaxNMRList._cont = _WimaxNMRList__item_
    WimaxNMRList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< WimaxNMR >-----#
    WimaxNMR = SEQ(name='WimaxNMR', mode=MODE_TYPE)
    _WimaxNMR_wimaxBsID = SEQ(name='wimaxBsID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'WimaxBsID')))
    _WimaxNMR_relDelay = INT(name='relDelay', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WimaxNMR_relDelay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-32768, ub=32767)], ev=None, er=[])
    _WimaxNMR_relDelaystd = INT(name='relDelaystd', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WimaxNMR_relDelaystd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _WimaxNMR_rssi = INT(name='rssi', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WimaxNMR_rssi._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _WimaxNMR_rSSIstd = INT(name='rSSIstd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WimaxNMR_rSSIstd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _WimaxNMR_bSTxPower = INT(name='bSTxPower', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WimaxNMR_bSTxPower._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _WimaxNMR_cinr = INT(name='cinr', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WimaxNMR_cinr._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _WimaxNMR_cINRstd = INT(name='cINRstd', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WimaxNMR_cINRstd._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _WimaxNMR_bSLocation = SEQ(name='bSLocation', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'ReportedLocation')), opt=True)
    WimaxNMR._cont = ASN1Dict([
        ('wimaxBsID', _WimaxNMR_wimaxBsID),
        ('relDelay', _WimaxNMR_relDelay),
        ('relDelaystd', _WimaxNMR_relDelaystd),
        ('rssi', _WimaxNMR_rssi),
        ('rSSIstd', _WimaxNMR_rSSIstd),
        ('bSTxPower', _WimaxNMR_bSTxPower),
        ('cinr', _WimaxNMR_cinr),
        ('cINRstd', _WimaxNMR_cINRstd),
        ('bSLocation', _WimaxNMR_bSLocation),
        ])
    WimaxNMR._ext = []
    
    #-----< maxWimaxBSMeas >-----#
    maxWimaxBSMeas = INT(name='maxWimaxBSMeas', mode=MODE_VALUE)
    maxWimaxBSMeas._val = 32
    
    #-----< UTRAN-GPSReferenceTimeAssistance >-----#
    UTRAN_GPSReferenceTimeAssistance = SEQ(name='UTRAN-GPSReferenceTimeAssistance', mode=MODE_TYPE)
    _UTRAN_GPSReferenceTimeAssistance_utran_GPSReferenceTime = SEQ(name='utran-GPSReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UTRAN-GPSReferenceTime')))
    _UTRAN_GPSReferenceTimeAssistance_gpsReferenceTimeUncertainty = INT(name='gpsReferenceTimeUncertainty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTRAN_GPSReferenceTimeAssistance_gpsReferenceTimeUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    _UTRAN_GPSReferenceTimeAssistance_utranGPSDriftRate = ENUM(name='utranGPSDriftRate', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UTRANGPSDriftRate')), opt=True)
    UTRAN_GPSReferenceTimeAssistance._cont = ASN1Dict([
        ('utran-GPSReferenceTime', _UTRAN_GPSReferenceTimeAssistance_utran_GPSReferenceTime),
        ('gpsReferenceTimeUncertainty', _UTRAN_GPSReferenceTimeAssistance_gpsReferenceTimeUncertainty),
        ('utranGPSDriftRate', _UTRAN_GPSReferenceTimeAssistance_utranGPSDriftRate),
        ])
    UTRAN_GPSReferenceTimeAssistance._ext = None
    
    #-----< UTRAN-GPSReferenceTime >-----#
    UTRAN_GPSReferenceTime = SEQ(name='UTRAN-GPSReferenceTime', mode=MODE_TYPE)
    _UTRAN_GPSReferenceTime_utran_GPSTimingOfCell = SEQ(name='utran-GPSTimingOfCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UTRAN_GPSReferenceTime_utran_GPSTimingOfCell_ms_part = INT(name='ms-part', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UTRAN_GPSReferenceTime_utran_GPSTimingOfCell_ms_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    __UTRAN_GPSReferenceTime_utran_GPSTimingOfCell_ls_part = INT(name='ls-part', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UTRAN_GPSReferenceTime_utran_GPSTimingOfCell_ls_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _UTRAN_GPSReferenceTime_utran_GPSTimingOfCell._cont = ASN1Dict([
        ('ms-part', __UTRAN_GPSReferenceTime_utran_GPSTimingOfCell_ms_part),
        ('ls-part', __UTRAN_GPSReferenceTime_utran_GPSTimingOfCell_ls_part),
        ])
    _UTRAN_GPSReferenceTime_utran_GPSTimingOfCell._ext = None
    _UTRAN_GPSReferenceTime_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UTRAN_GPSReferenceTime_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UTRAN_GPSReferenceTime_modeSpecificInfo_fdd_referenceIdentity = SEQ(name='referenceIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PrimaryCPICH-Info')))
    __UTRAN_GPSReferenceTime_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('referenceIdentity', ___UTRAN_GPSReferenceTime_modeSpecificInfo_fdd_referenceIdentity),
        ])
    __UTRAN_GPSReferenceTime_modeSpecificInfo_fdd._ext = None
    __UTRAN_GPSReferenceTime_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UTRAN_GPSReferenceTime_modeSpecificInfo_tdd_referenceIdentity = INT(name='referenceIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'CellParametersID')))
    __UTRAN_GPSReferenceTime_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('referenceIdentity', ___UTRAN_GPSReferenceTime_modeSpecificInfo_tdd_referenceIdentity),
        ])
    __UTRAN_GPSReferenceTime_modeSpecificInfo_tdd._ext = None
    _UTRAN_GPSReferenceTime_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __UTRAN_GPSReferenceTime_modeSpecificInfo_fdd),
        ('tdd', __UTRAN_GPSReferenceTime_modeSpecificInfo_tdd),
        ])
    _UTRAN_GPSReferenceTime_modeSpecificInfo._ext = None
    _UTRAN_GPSReferenceTime_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GPSReferenceTime_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    UTRAN_GPSReferenceTime._cont = ASN1Dict([
        ('utran-GPSTimingOfCell', _UTRAN_GPSReferenceTime_utran_GPSTimingOfCell),
        ('modeSpecificInfo', _UTRAN_GPSReferenceTime_modeSpecificInfo),
        ('sfn', _UTRAN_GPSReferenceTime_sfn),
        ])
    UTRAN_GPSReferenceTime._ext = None
    
    #-----< UTRANGPSDriftRate >-----#
    UTRANGPSDriftRate = ENUM(name='UTRANGPSDriftRate', mode=MODE_TYPE)
    UTRANGPSDriftRate._cont = ASN1Dict([('utran-GPSDrift0', 0), ('utran-GPSDrift1', 1), ('utran-GPSDrift2', 2), ('utran-GPSDrift5', 3), ('utran-GPSDrift10', 4), ('utran-GPSDrift15', 5), ('utran-GPSDrift25', 6), ('utran-GPSDrift50', 7), ('utran-GPSDrift-1', 8), ('utran-GPSDrift-2', 9), ('utran-GPSDrift-5', 10), ('utran-GPSDrift-10', 11), ('utran-GPSDrift-15', 12), ('utran-GPSDrift-25', 13), ('utran-GPSDrift-50', 14)])
    UTRANGPSDriftRate._ext = None
    
    #-----< UTRAN-GPSReferenceTimeResult >-----#
    UTRAN_GPSReferenceTimeResult = SEQ(name='UTRAN-GPSReferenceTimeResult', mode=MODE_TYPE)
    _UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell = SEQ(name='set-GPSTimingOfCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell_ms_part = INT(name='ms-part', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell_ms_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=16383)], ev=None, er=[])
    __UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell_ls_part = INT(name='ls-part', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell_ls_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell._cont = ASN1Dict([
        ('ms-part', __UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell_ms_part),
        ('ls-part', __UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell_ls_part),
        ])
    _UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell._ext = None
    _UTRAN_GPSReferenceTimeResult_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UTRAN_GPSReferenceTimeResult_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UTRAN_GPSReferenceTimeResult_modeSpecificInfo_fdd_referenceIdentity = SEQ(name='referenceIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PrimaryCPICH-Info')))
    __UTRAN_GPSReferenceTimeResult_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('referenceIdentity', ___UTRAN_GPSReferenceTimeResult_modeSpecificInfo_fdd_referenceIdentity),
        ])
    __UTRAN_GPSReferenceTimeResult_modeSpecificInfo_fdd._ext = None
    __UTRAN_GPSReferenceTimeResult_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UTRAN_GPSReferenceTimeResult_modeSpecificInfo_tdd_referenceIdentity = INT(name='referenceIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'CellParametersID')))
    __UTRAN_GPSReferenceTimeResult_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('referenceIdentity', ___UTRAN_GPSReferenceTimeResult_modeSpecificInfo_tdd_referenceIdentity),
        ])
    __UTRAN_GPSReferenceTimeResult_modeSpecificInfo_tdd._ext = None
    _UTRAN_GPSReferenceTimeResult_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __UTRAN_GPSReferenceTimeResult_modeSpecificInfo_fdd),
        ('tdd', __UTRAN_GPSReferenceTimeResult_modeSpecificInfo_tdd),
        ])
    _UTRAN_GPSReferenceTimeResult_modeSpecificInfo._ext = None
    _UTRAN_GPSReferenceTimeResult_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GPSReferenceTimeResult_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _UTRAN_GPSReferenceTimeResult_gpsReferenceTimeUncertainty = INT(name='gpsReferenceTimeUncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTRAN_GPSReferenceTimeResult_gpsReferenceTimeUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    UTRAN_GPSReferenceTimeResult._cont = ASN1Dict([
        ('set-GPSTimingOfCell', _UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell),
        ('modeSpecificInfo', _UTRAN_GPSReferenceTimeResult_modeSpecificInfo),
        ('sfn', _UTRAN_GPSReferenceTimeResult_sfn),
        ('gpsReferenceTimeUncertainty', _UTRAN_GPSReferenceTimeResult_gpsReferenceTimeUncertainty),
        ])
    UTRAN_GPSReferenceTimeResult._ext = []
    
    #-----< UTRAN-GANSSReferenceTimeAssistance >-----#
    UTRAN_GANSSReferenceTimeAssistance = SEQ(name='UTRAN-GANSSReferenceTimeAssistance', mode=MODE_TYPE)
    _UTRAN_GANSSReferenceTimeAssistance_ganssDay = INT(name='ganssDay', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTRAN_GANSSReferenceTimeAssistance_ganssDay._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _UTRAN_GANSSReferenceTimeAssistance_ganssTimeID = INT(name='ganssTimeID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GANSSReferenceTimeAssistance_ganssTimeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _UTRAN_GANSSReferenceTimeAssistance_utran_GANSSReferenceTime = SEQ(name='utran-GANSSReferenceTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UTRAN-GANSSReferenceTime')))
    _UTRAN_GANSSReferenceTimeAssistance_utranGANSSDriftRate = ENUM(name='utranGANSSDriftRate', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UTRANGANSSDriftRate')), opt=True)
    UTRAN_GANSSReferenceTimeAssistance._cont = ASN1Dict([
        ('ganssDay', _UTRAN_GANSSReferenceTimeAssistance_ganssDay),
        ('ganssTimeID', _UTRAN_GANSSReferenceTimeAssistance_ganssTimeID),
        ('utran-GANSSReferenceTime', _UTRAN_GANSSReferenceTimeAssistance_utran_GANSSReferenceTime),
        ('utranGANSSDriftRate', _UTRAN_GANSSReferenceTimeAssistance_utranGANSSDriftRate),
        ])
    UTRAN_GANSSReferenceTimeAssistance._ext = None
    
    #-----< UTRAN-GANSSReferenceTime >-----#
    UTRAN_GANSSReferenceTime = SEQ(name='UTRAN-GANSSReferenceTime', mode=MODE_TYPE)
    _UTRAN_GANSSReferenceTime_ganssTOD = INT(name='ganssTOD', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GANSSReferenceTime_ganssTOD._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=86399)], ev=None, er=[])
    _UTRAN_GANSSReferenceTime_utran_GANSSTimingOfCell = INT(name='utran-GANSSTimingOfCell', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTRAN_GANSSReferenceTime_utran_GANSSTimingOfCell._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=3999999)], ev=None, er=[])
    _UTRAN_GANSSReferenceTime_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __UTRAN_GANSSReferenceTime_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UTRAN_GANSSReferenceTime_modeSpecificInfo_fdd_referenceIdentity = SEQ(name='referenceIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PrimaryCPICH-Info')))
    __UTRAN_GANSSReferenceTime_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('referenceIdentity', ___UTRAN_GANSSReferenceTime_modeSpecificInfo_fdd_referenceIdentity),
        ])
    __UTRAN_GANSSReferenceTime_modeSpecificInfo_fdd._ext = None
    __UTRAN_GANSSReferenceTime_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___UTRAN_GANSSReferenceTime_modeSpecificInfo_tdd_referenceIdentity = INT(name='referenceIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'CellParametersID')))
    __UTRAN_GANSSReferenceTime_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('referenceIdentity', ___UTRAN_GANSSReferenceTime_modeSpecificInfo_tdd_referenceIdentity),
        ])
    __UTRAN_GANSSReferenceTime_modeSpecificInfo_tdd._ext = None
    _UTRAN_GANSSReferenceTime_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __UTRAN_GANSSReferenceTime_modeSpecificInfo_fdd),
        ('tdd', __UTRAN_GANSSReferenceTime_modeSpecificInfo_tdd),
        ])
    _UTRAN_GANSSReferenceTime_modeSpecificInfo._ext = None
    _UTRAN_GANSSReferenceTime_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GANSSReferenceTime_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _UTRAN_GANSSReferenceTime_ganss_TODUncertainty = INT(name='ganss-TODUncertainty', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UTRAN_GANSSReferenceTime_ganss_TODUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    UTRAN_GANSSReferenceTime._cont = ASN1Dict([
        ('ganssTOD', _UTRAN_GANSSReferenceTime_ganssTOD),
        ('utran-GANSSTimingOfCell', _UTRAN_GANSSReferenceTime_utran_GANSSTimingOfCell),
        ('modeSpecificInfo', _UTRAN_GANSSReferenceTime_modeSpecificInfo),
        ('sfn', _UTRAN_GANSSReferenceTime_sfn),
        ('ganss-TODUncertainty', _UTRAN_GANSSReferenceTime_ganss_TODUncertainty),
        ])
    UTRAN_GANSSReferenceTime._ext = []
    
    #-----< UTRANGANSSDriftRate >-----#
    UTRANGANSSDriftRate = ENUM(name='UTRANGANSSDriftRate', mode=MODE_TYPE)
    UTRANGANSSDriftRate._cont = ASN1Dict([('utran-GANSSDrift0', 0), ('utran-GANSSDrift1', 1), ('utran-GANSSDrift2', 2), ('utran-GANSSDrift5', 3), ('utran-GANSSDrift10', 4), ('utran-GANSSDrift15', 5), ('utran-GANSSDrift25', 6), ('utran-GANSSDrift50', 7), ('utran-GANSSDrift-1', 8), ('utran-GANSSDrift-2', 9), ('utran-GANSSDrift-5', 10), ('utran-GANSSDrift-10', 11), ('utran-GANSSDrift-15', 12), ('utran-GANSSDrift-25', 13), ('utran-GANSSDrift-50', 14)])
    UTRANGANSSDriftRate._ext = None
    
    #-----< UTRAN-GANSSReferenceTimeResult >-----#
    UTRAN_GANSSReferenceTimeResult = SEQ(name='UTRAN-GANSSReferenceTimeResult', mode=MODE_TYPE)
    _UTRAN_GANSSReferenceTimeResult_ganssTimeID = INT(name='ganssTimeID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _UTRAN_GANSSReferenceTimeResult_ganssTimeID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _UTRAN_GANSSReferenceTimeResult_set_GANSSReferenceTime = SEQ(name='set-GANSSReferenceTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SET-GANSSReferenceTime')))
    UTRAN_GANSSReferenceTimeResult._cont = ASN1Dict([
        ('ganssTimeID', _UTRAN_GANSSReferenceTimeResult_ganssTimeID),
        ('set-GANSSReferenceTime', _UTRAN_GANSSReferenceTimeResult_set_GANSSReferenceTime),
        ])
    UTRAN_GANSSReferenceTimeResult._ext = []
    
    #-----< SET-GANSSReferenceTime >-----#
    SET_GANSSReferenceTime = SEQ(name='SET-GANSSReferenceTime', mode=MODE_TYPE)
    _SET_GANSSReferenceTime_set_GANSSTimingOfCell = SEQ(name='set-GANSSTimingOfCell', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __SET_GANSSReferenceTime_set_GANSSTimingOfCell_ms_part = INT(name='ms-part', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SET_GANSSReferenceTime_set_GANSSTimingOfCell_ms_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=80)], ev=None, er=[])
    __SET_GANSSReferenceTime_set_GANSSTimingOfCell_ls_part = INT(name='ls-part', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    __SET_GANSSReferenceTime_set_GANSSTimingOfCell_ls_part._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4294967295)], ev=None, er=[])
    _SET_GANSSReferenceTime_set_GANSSTimingOfCell._cont = ASN1Dict([
        ('ms-part', __SET_GANSSReferenceTime_set_GANSSTimingOfCell_ms_part),
        ('ls-part', __SET_GANSSReferenceTime_set_GANSSTimingOfCell_ls_part),
        ])
    _SET_GANSSReferenceTime_set_GANSSTimingOfCell._ext = None
    _SET_GANSSReferenceTime_modeSpecificInfo = CHOICE(name='modeSpecificInfo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), opt=True)
    __SET_GANSSReferenceTime_modeSpecificInfo_fdd = SEQ(name='fdd', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SET_GANSSReferenceTime_modeSpecificInfo_fdd_referenceIdentity = SEQ(name='referenceIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PrimaryCPICH-Info')))
    __SET_GANSSReferenceTime_modeSpecificInfo_fdd._cont = ASN1Dict([
        ('referenceIdentity', ___SET_GANSSReferenceTime_modeSpecificInfo_fdd_referenceIdentity),
        ])
    __SET_GANSSReferenceTime_modeSpecificInfo_fdd._ext = None
    __SET_GANSSReferenceTime_modeSpecificInfo_tdd = SEQ(name='tdd', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ___SET_GANSSReferenceTime_modeSpecificInfo_tdd_referenceIdentity = INT(name='referenceIdentity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'CellParametersID')))
    __SET_GANSSReferenceTime_modeSpecificInfo_tdd._cont = ASN1Dict([
        ('referenceIdentity', ___SET_GANSSReferenceTime_modeSpecificInfo_tdd_referenceIdentity),
        ])
    __SET_GANSSReferenceTime_modeSpecificInfo_tdd._ext = None
    _SET_GANSSReferenceTime_modeSpecificInfo._cont = ASN1Dict([
        ('fdd', __SET_GANSSReferenceTime_modeSpecificInfo_fdd),
        ('tdd', __SET_GANSSReferenceTime_modeSpecificInfo_tdd),
        ])
    _SET_GANSSReferenceTime_modeSpecificInfo._ext = None
    _SET_GANSSReferenceTime_sfn = INT(name='sfn', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SET_GANSSReferenceTime_sfn._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _SET_GANSSReferenceTime_ganss_TODUncertainty = INT(name='ganss-TODUncertainty', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _SET_GANSSReferenceTime_ganss_TODUncertainty._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=127)], ev=None, er=[])
    SET_GANSSReferenceTime._cont = ASN1Dict([
        ('set-GANSSTimingOfCell', _SET_GANSSReferenceTime_set_GANSSTimingOfCell),
        ('modeSpecificInfo', _SET_GANSSReferenceTime_modeSpecificInfo),
        ('sfn', _SET_GANSSReferenceTime_sfn),
        ('ganss-TODUncertainty', _SET_GANSSReferenceTime_ganss_TODUncertainty),
        ])
    SET_GANSSReferenceTime._ext = []
    
    #-----< GNSSPosTechnology >-----#
    GNSSPosTechnology = SEQ(name='GNSSPosTechnology', mode=MODE_TYPE)
    _GNSSPosTechnology_gps = BOOL(name='gps', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSSPosTechnology_galileo = BOOL(name='galileo', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSSPosTechnology_sbas = BOOL(name='sbas', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSSPosTechnology_modernized_gps = BOOL(name='modernized-gps', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSSPosTechnology_qzss = BOOL(name='qzss', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSSPosTechnology_glonass = BOOL(name='glonass', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GNSSPosTechnology_bds = BOOL(name='bds', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GNSSPosTechnology._cont = ASN1Dict([
        ('gps', _GNSSPosTechnology_gps),
        ('galileo', _GNSSPosTechnology_galileo),
        ('sbas', _GNSSPosTechnology_sbas),
        ('modernized-gps', _GNSSPosTechnology_modernized_gps),
        ('qzss', _GNSSPosTechnology_qzss),
        ('glonass', _GNSSPosTechnology_glonass),
        ('bds', _GNSSPosTechnology_bds),
        ])
    GNSSPosTechnology._ext = ['bds']
    
    #-----< GANSSSignals >-----#
    GANSSSignals = BIT_STR(name='GANSSSignals', mode=MODE_TYPE)
    GANSSSignals._cont = ASN1Dict([('signal1', 0), ('signal2', 1), ('signal3', 2), ('signal4', 3), ('signal5', 4), ('signal6', 5), ('signal7', 6), ('signal8', 7)])
    GANSSSignals._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< SPCSETKey >-----#
    SPCSETKey = BIT_STR(name='SPCSETKey', mode=MODE_TYPE)
    SPCSETKey._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    #-----< SPCTID >-----#
    SPCTID = SEQ(name='SPCTID', mode=MODE_TYPE)
    _SPCTID_rand = BIT_STR(name='rand', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SPCTID_rand._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _SPCTID_slpFQDN = STR_VIS(name='slpFQDN', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'FQDN')))
    _SPCTID_slpFQDN._const_alpha = ASN1Set(rv=['.', '-'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    SPCTID._cont = ASN1Dict([
        ('rand', _SPCTID_rand),
        ('slpFQDN', _SPCTID_slpFQDN),
        ])
    SPCTID._ext = []
    
    #-----< SPCSETKeylifetime >-----#
    SPCSETKeylifetime = INT(name='SPCSETKeylifetime', mode=MODE_TYPE)
    SPCSETKeylifetime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=None, er=[])
    
    #-----< CauseCode >-----#
    CauseCode = ENUM(name='CauseCode', mode=MODE_TYPE)
    CauseCode._cont = ASN1Dict([('servingNetWorkNotInAreaIdList', 0), ('sETCapabilitiesChanged', 1), ('noSUPLCoverage', 2)])
    CauseCode._ext = []
    
    #-----< ThirdParty >-----#
    ThirdParty = SEQ_OF(name='ThirdParty', mode=MODE_TYPE)
    _ThirdParty__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Ver2-ULP-Components', 'ThirdPartyID')))
    ThirdParty._cont = _ThirdParty__item_
    ThirdParty._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< ThirdPartyID >-----#
    ThirdPartyID = CHOICE(name='ThirdPartyID', mode=MODE_TYPE)
    _ThirdPartyID_logicalName = STR_IA5(name='logicalName', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ThirdPartyID_logicalName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000)], ev=None, er=[])
    _ThirdPartyID_msisdn = OCT_STR(name='msisdn', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ThirdPartyID_msisdn._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _ThirdPartyID_emailaddr = STR_IA5(name='emailaddr', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ThirdPartyID_emailaddr._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000)], ev=None, er=[])
    _ThirdPartyID_sip_uri = STR_VIS(name='sip-uri', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ThirdPartyID_sip_uri._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _ThirdPartyID_sip_uri._const_alpha = ASN1Set(rv=[':', '.', '/', '-', '_', '~', '#', '@', '?'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    _ThirdPartyID_ims_public_identity = STR_VIS(name='ims-public-identity', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ThirdPartyID_ims_public_identity._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _ThirdPartyID_ims_public_identity._const_alpha = ASN1Set(rv=[':', '.', '/', '-', '_', '~', '#', '@', '?'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    _ThirdPartyID_min = BIT_STR(name='min', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ThirdPartyID_min._const_sz = ASN1Set(rv=[34], rr=[], ev=None, er=[])
    _ThirdPartyID_mdn = OCT_STR(name='mdn', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ThirdPartyID_mdn._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _ThirdPartyID_uri = STR_VIS(name='uri', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ThirdPartyID_uri._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=255)], ev=None, er=[])
    _ThirdPartyID_uri._const_alpha = ASN1Set(rv=['.', '/', '-', '_', '~', '#'], rr=[ASN1RangeStr(lb='a', ub='z'), ASN1RangeStr(lb='A', ub='Z'), ASN1RangeStr(lb='0', ub='9')], ev=None, er=[])
    ThirdPartyID._cont = ASN1Dict([
        ('logicalName', _ThirdPartyID_logicalName),
        ('msisdn', _ThirdPartyID_msisdn),
        ('emailaddr', _ThirdPartyID_emailaddr),
        ('sip-uri', _ThirdPartyID_sip_uri),
        ('ims-public-identity', _ThirdPartyID_ims_public_identity),
        ('min', _ThirdPartyID_min),
        ('mdn', _ThirdPartyID_mdn),
        ('uri', _ThirdPartyID_uri),
        ])
    ThirdPartyID._ext = []
    
    #-----< ApplicationID >-----#
    ApplicationID = SEQ(name='ApplicationID', mode=MODE_TYPE)
    _ApplicationID_appProvider = STR_IA5(name='appProvider', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ApplicationID_appProvider._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=24)], ev=None, er=[])
    _ApplicationID_appName = STR_IA5(name='appName', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ApplicationID_appName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _ApplicationID_appVersion = STR_IA5(name='appVersion', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ApplicationID_appVersion._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    ApplicationID._cont = ASN1Dict([
        ('appProvider', _ApplicationID_appProvider),
        ('appName', _ApplicationID_appName),
        ('appVersion', _ApplicationID_appVersion),
        ])
    ApplicationID._ext = []
    
    #-----< ReportingCap >-----#
    ReportingCap = SEQ(name='ReportingCap', mode=MODE_TYPE)
    _ReportingCap_minInt = INT(name='minInt', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReportingCap_minInt._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3600)], ev=None, er=[])
    _ReportingCap_maxInt = INT(name='maxInt', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportingCap_maxInt._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1440)], ev=None, er=[])
    _ReportingCap_repMode = SEQ(name='repMode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'RepMode')))
    _ReportingCap_batchRepCap = SEQ(name='batchRepCap', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'BatchRepCap')), opt=True)
    ReportingCap._cont = ASN1Dict([
        ('minInt', _ReportingCap_minInt),
        ('maxInt', _ReportingCap_maxInt),
        ('repMode', _ReportingCap_repMode),
        ('batchRepCap', _ReportingCap_batchRepCap),
        ])
    ReportingCap._ext = []
    
    #-----< RepMode >-----#
    RepMode = SEQ(name='RepMode', mode=MODE_TYPE)
    _RepMode_realtime = BOOL(name='realtime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RepMode_quasirealtime = BOOL(name='quasirealtime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RepMode_batch = BOOL(name='batch', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    RepMode._cont = ASN1Dict([
        ('realtime', _RepMode_realtime),
        ('quasirealtime', _RepMode_quasirealtime),
        ('batch', _RepMode_batch),
        ])
    RepMode._ext = []
    
    #-----< BatchRepCap >-----#
    BatchRepCap = SEQ(name='BatchRepCap', mode=MODE_TYPE)
    _BatchRepCap_report_position = BOOL(name='report-position', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BatchRepCap_report_measurements = BOOL(name='report-measurements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BatchRepCap_max_num_positions = INT(name='max-num-positions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BatchRepCap_max_num_positions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _BatchRepCap_max_num_measurements = INT(name='max-num-measurements', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _BatchRepCap_max_num_measurements._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    BatchRepCap._cont = ASN1Dict([
        ('report-position', _BatchRepCap_report_position),
        ('report-measurements', _BatchRepCap_report_measurements),
        ('max-num-positions', _BatchRepCap_max_num_positions),
        ('max-num-measurements', _BatchRepCap_max_num_measurements),
        ])
    BatchRepCap._ext = []
    
    #-----< Coordinate >-----#
    Coordinate = SEQ(name='Coordinate', mode=MODE_TYPE)
    _Coordinate_latitudeSign = ENUM(name='latitudeSign', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Coordinate_latitudeSign._cont = ASN1Dict([('north', 0), ('south', 1)])
    _Coordinate_latitudeSign._ext = None
    _Coordinate_latitude = INT(name='latitude', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Coordinate_latitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8388607)], ev=None, er=[])
    _Coordinate_longitude = INT(name='longitude', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Coordinate_longitude._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-8388608, ub=8388607)], ev=None, er=[])
    Coordinate._cont = ASN1Dict([
        ('latitudeSign', _Coordinate_latitudeSign),
        ('latitude', _Coordinate_latitude),
        ('longitude', _Coordinate_longitude),
        ])
    Coordinate._ext = None
    
    #-----< CircularArea >-----#
    CircularArea = SEQ(name='CircularArea', mode=MODE_TYPE)
    _CircularArea_coordinate = SEQ(name='coordinate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'Coordinate')))
    _CircularArea_radius = INT(name='radius', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _CircularArea_radius._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000)], ev=None, er=[])
    _CircularArea_radius_min = INT(name='radius-min', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CircularArea_radius_min._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000)], ev=None, er=[])
    _CircularArea_radius_max = INT(name='radius-max', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CircularArea_radius_max._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1500000)], ev=None, er=[])
    CircularArea._cont = ASN1Dict([
        ('coordinate', _CircularArea_coordinate),
        ('radius', _CircularArea_radius),
        ('radius-min', _CircularArea_radius_min),
        ('radius-max', _CircularArea_radius_max),
        ])
    CircularArea._ext = None
    
    #-----< EllipticalArea >-----#
    EllipticalArea = SEQ(name='EllipticalArea', mode=MODE_TYPE)
    _EllipticalArea_coordinate = SEQ(name='coordinate', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'Coordinate')))
    _EllipticalArea_semiMajor = INT(name='semiMajor', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipticalArea_semiMajor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000)], ev=None, er=[])
    _EllipticalArea_semiMajor_min = INT(name='semiMajor-min', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EllipticalArea_semiMajor_min._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000)], ev=None, er=[])
    _EllipticalArea_semiMajor_max = INT(name='semiMajor-max', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EllipticalArea_semiMajor_max._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1500000)], ev=None, er=[])
    _EllipticalArea_semiMinor = INT(name='semiMinor', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipticalArea_semiMinor._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000)], ev=None, er=[])
    _EllipticalArea_semiMinor_min = INT(name='semiMinor-min', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EllipticalArea_semiMinor_min._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1000000)], ev=None, er=[])
    _EllipticalArea_semiMinor_max = INT(name='semiMinor-max', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EllipticalArea_semiMinor_max._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1500000)], ev=None, er=[])
    _EllipticalArea_angle = INT(name='angle', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _EllipticalArea_angle._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=179)], ev=None, er=[])
    EllipticalArea._cont = ASN1Dict([
        ('coordinate', _EllipticalArea_coordinate),
        ('semiMajor', _EllipticalArea_semiMajor),
        ('semiMajor-min', _EllipticalArea_semiMajor_min),
        ('semiMajor-max', _EllipticalArea_semiMajor_max),
        ('semiMinor', _EllipticalArea_semiMinor),
        ('semiMinor-min', _EllipticalArea_semiMinor_min),
        ('semiMinor-max', _EllipticalArea_semiMinor_max),
        ('angle', _EllipticalArea_angle),
        ])
    EllipticalArea._ext = None
    
    #-----< PolygonArea >-----#
    PolygonArea = SEQ(name='PolygonArea', mode=MODE_TYPE)
    _PolygonArea_polygonDescription = SEQ_OF(name='polygonDescription', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'PolygonDescription')))
    _PolygonArea_polygonHysteresis = INT(name='polygonHysteresis', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PolygonArea_polygonHysteresis._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=100000)], ev=None, er=[])
    PolygonArea._cont = ASN1Dict([
        ('polygonDescription', _PolygonArea_polygonDescription),
        ('polygonHysteresis', _PolygonArea_polygonHysteresis),
        ])
    PolygonArea._ext = None
    
    #-----< PolygonDescription >-----#
    PolygonDescription = SEQ_OF(name='PolygonDescription', mode=MODE_TYPE)
    _PolygonDescription__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('Ver2-ULP-Components', 'Coordinate')))
    PolygonDescription._cont = _PolygonDescription__item_
    PolygonDescription._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=3, ub=15)], ev=None, er=[])
    
    _all_ = [
        _MultipleLocationIds__item_,
        MultipleLocationIds,
        _LocationIdData_locationId,
        _LocationIdData_relativetimestamp,
        _LocationIdData_servingFlag,
        LocationIdData,
        RelativeTime,
        maxLidSize,
        _SupportedNetworkInformation_wlan,
        _SupportedNetworkInformation_supportedWLANInfo,
        _SupportedNetworkInformation_supportedWLANApsList,
        _SupportedNetworkInformation_gsm,
        _SupportedNetworkInformation_wcdma,
        _SupportedNetworkInformation_supportedWCDMAInfo,
        _SupportedNetworkInformation_cdma,
        _SupportedNetworkInformation_hrdp,
        _SupportedNetworkInformation_umb,
        _SupportedNetworkInformation_lte,
        _SupportedNetworkInformation_wimax,
        _SupportedNetworkInformation_historic,
        _SupportedNetworkInformation_nonServing,
        _SupportedNetworkInformation_uTRANGPSReferenceTime,
        _SupportedNetworkInformation_uTRANGANSSReferenceTime,
        SupportedNetworkInformation,
        _SupportedWLANInfo_apTP,
        _SupportedWLANInfo_apAG,
        _SupportedWLANInfo_apSN,
        _SupportedWLANInfo_apDevType,
        _SupportedWLANInfo_apRSSI,
        _SupportedWLANInfo_apChanFreq,
        _SupportedWLANInfo_apRTD,
        _SupportedWLANInfo_setTP,
        _SupportedWLANInfo_setAG,
        _SupportedWLANInfo_setSN,
        _SupportedWLANInfo_setRSSI,
        _SupportedWLANInfo_apRepLoc,
        SupportedWLANInfo,
        maxWLANApDataSize,
        __SupportedWLANApsList_supportedWLANApDataList__item_,
        _SupportedWLANApsList_supportedWLANApDataList,
        _SupportedWLANApsList_supportedWLANapsChannel11a,
        _SupportedWLANApsList_supportedWLANapsChannel11bg,
        SupportedWLANApsList,
        _SupportedWLANApsChannel11a_ch34,
        _SupportedWLANApsChannel11a_ch36,
        _SupportedWLANApsChannel11a_ch38,
        _SupportedWLANApsChannel11a_ch40,
        _SupportedWLANApsChannel11a_ch42,
        _SupportedWLANApsChannel11a_ch44,
        _SupportedWLANApsChannel11a_ch46,
        _SupportedWLANApsChannel11a_ch48,
        _SupportedWLANApsChannel11a_ch52,
        _SupportedWLANApsChannel11a_ch56,
        _SupportedWLANApsChannel11a_ch60,
        _SupportedWLANApsChannel11a_ch64,
        _SupportedWLANApsChannel11a_ch149,
        _SupportedWLANApsChannel11a_ch153,
        _SupportedWLANApsChannel11a_ch157,
        _SupportedWLANApsChannel11a_ch161,
        SupportedWLANApsChannel11a,
        _SupportedWLANApsChannel11bg_ch1,
        _SupportedWLANApsChannel11bg_ch2,
        _SupportedWLANApsChannel11bg_ch3,
        _SupportedWLANApsChannel11bg_ch4,
        _SupportedWLANApsChannel11bg_ch5,
        _SupportedWLANApsChannel11bg_ch6,
        _SupportedWLANApsChannel11bg_ch7,
        _SupportedWLANApsChannel11bg_ch8,
        _SupportedWLANApsChannel11bg_ch9,
        _SupportedWLANApsChannel11bg_ch10,
        _SupportedWLANApsChannel11bg_ch11,
        _SupportedWLANApsChannel11bg_ch12,
        _SupportedWLANApsChannel11bg_ch13,
        _SupportedWLANApsChannel11bg_ch14,
        SupportedWLANApsChannel11bg,
        _SupportedWLANApData_apMACAddress,
        _SupportedWLANApData_apDevType,
        SupportedWLANApData,
        _SupportedWCDMAInfo_mrl,
        SupportedWCDMAInfo,
        _Ver2_CellInfo_extension_hrpdCell,
        _Ver2_CellInfo_extension_umbCell,
        _Ver2_CellInfo_extension_lteCell,
        _Ver2_CellInfo_extension_wlanAP,
        _Ver2_CellInfo_extension_wimaxBS,
        Ver2_CellInfo_extension,
        _HrpdCellInformation_refSECTORID,
        _HrpdCellInformation_refBASELAT,
        _HrpdCellInformation_reBASELONG,
        _HrpdCellInformation_refWeekNumber,
        _HrpdCellInformation_refSeconds,
        HrpdCellInformation,
        _UmbCellInformation_refSECTORID,
        _UmbCellInformation_refMCC,
        _UmbCellInformation_refMNC,
        _UmbCellInformation_refBASELAT,
        _UmbCellInformation_reBASELONG,
        _UmbCellInformation_refWeekNumber,
        _UmbCellInformation_refSeconds,
        UmbCellInformation,
        _LteCellInformation_cellGlobalIdEUTRA,
        _LteCellInformation_physCellId,
        _LteCellInformation_trackingAreaCode,
        _LteCellInformation_rsrpResult,
        _LteCellInformation_rsrqResult,
        _LteCellInformation_ta,
        _LteCellInformation_measResultListEUTRA,
        _LteCellInformation_earfcn,
        _LteCellInformation_earfcn_ext,
        LteCellInformation,
        _MeasResultListEUTRA__item_,
        MeasResultListEUTRA,
        _MeasResultEUTRA_physCellId,
        __MeasResultEUTRA_cgi_Info_cellGlobalId,
        __MeasResultEUTRA_cgi_Info_trackingAreaCode,
        _MeasResultEUTRA_cgi_Info,
        __MeasResultEUTRA_measResult_rsrpResult,
        __MeasResultEUTRA_measResult_rsrqResult,
        __MeasResultEUTRA_measResult_earfcn,
        __MeasResultEUTRA_measResult_earfcn_ext,
        _MeasResultEUTRA_measResult,
        MeasResultEUTRA,
        PhysCellId,
        TrackingAreaCode,
        _CellGlobalIdEUTRA_plmn_Identity,
        _CellGlobalIdEUTRA_cellIdentity,
        CellGlobalIdEUTRA,
        _PLMN_Identity_mcc,
        _PLMN_Identity_mnc,
        PLMN_Identity,
        CellIdentity,
        _MCC__item_,
        MCC,
        _MNC__item_,
        MNC,
        MCC_MNC_Digit,
        RSRP_Range,
        RSRQ_Range,
        maxCellReport,
        _WlanAPInformation_apMACAddress,
        _WlanAPInformation_apTransmitPower,
        _WlanAPInformation_apAntennaGain,
        _WlanAPInformation_apSignaltoNoise,
        _WlanAPInformation_apDeviceType,
        _WlanAPInformation_apSignalStrength,
        _WlanAPInformation_apChannelFrequency,
        _WlanAPInformation_apRoundTripDelay,
        _WlanAPInformation_setTransmitPower,
        _WlanAPInformation_setAntennaGain,
        _WlanAPInformation_setSignaltoNoise,
        _WlanAPInformation_setSignalStrength,
        _WlanAPInformation_apReportedLocation,
        _WlanAPInformation_apRepLocation,
        _WlanAPInformation_apSignalStrengthDelta,
        _WlanAPInformation_apSignaltoNoiseDelta,
        _WlanAPInformation_setSignalStrengthDelta,
        _WlanAPInformation_setSignaltoNoiseDelta,
        _WlanAPInformation_operatingClass,
        _WlanAPInformation_apSSID,
        _WlanAPInformation_apPHYType,
        _WlanAPInformation_setMACAddress,
        WlanAPInformation,
        _RTD_rTDValue,
        _RTD_rTDUnits,
        _RTD_rTDAccuracy,
        RTD,
        RTDUnits,
        _ReportedLocation_locationEncodingDescriptor,
        _ReportedLocation_locationData,
        ReportedLocation,
        LocationEncodingDescriptor,
        _LocationData_locationAccuracy,
        _LocationData_locationValue,
        LocationData,
        _RepLocation_lciLocData,
        RepLocation,
        _LciLocData_locationDataLCI,
        LciLocData,
        _LocationDataLCI_latitudeResolution,
        _LocationDataLCI_latitude,
        _LocationDataLCI_longitudeResolution,
        _LocationDataLCI_longitude,
        _LocationDataLCI_altitudeType,
        _LocationDataLCI_altitudeResolution,
        _LocationDataLCI_altitude,
        _LocationDataLCI_datum,
        LocationDataLCI,
        _WimaxBSInformation_wimaxBsID,
        _WimaxBSInformation_wimaxRTD,
        _WimaxBSInformation_wimaxNMRList,
        WimaxBSInformation,
        _WimaxBsID_bsID_MSB,
        _WimaxBsID_bsID_LSB,
        WimaxBsID,
        _WimaxRTD_rtd,
        _WimaxRTD_rTDstd,
        WimaxRTD,
        _WimaxNMRList__item_,
        WimaxNMRList,
        _WimaxNMR_wimaxBsID,
        _WimaxNMR_relDelay,
        _WimaxNMR_relDelaystd,
        _WimaxNMR_rssi,
        _WimaxNMR_rSSIstd,
        _WimaxNMR_bSTxPower,
        _WimaxNMR_cinr,
        _WimaxNMR_cINRstd,
        _WimaxNMR_bSLocation,
        WimaxNMR,
        maxWimaxBSMeas,
        _UTRAN_GPSReferenceTimeAssistance_utran_GPSReferenceTime,
        _UTRAN_GPSReferenceTimeAssistance_gpsReferenceTimeUncertainty,
        _UTRAN_GPSReferenceTimeAssistance_utranGPSDriftRate,
        UTRAN_GPSReferenceTimeAssistance,
        __UTRAN_GPSReferenceTime_utran_GPSTimingOfCell_ms_part,
        __UTRAN_GPSReferenceTime_utran_GPSTimingOfCell_ls_part,
        _UTRAN_GPSReferenceTime_utran_GPSTimingOfCell,
        ___UTRAN_GPSReferenceTime_modeSpecificInfo_fdd_referenceIdentity,
        __UTRAN_GPSReferenceTime_modeSpecificInfo_fdd,
        ___UTRAN_GPSReferenceTime_modeSpecificInfo_tdd_referenceIdentity,
        __UTRAN_GPSReferenceTime_modeSpecificInfo_tdd,
        _UTRAN_GPSReferenceTime_modeSpecificInfo,
        _UTRAN_GPSReferenceTime_sfn,
        UTRAN_GPSReferenceTime,
        UTRANGPSDriftRate,
        __UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell_ms_part,
        __UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell_ls_part,
        _UTRAN_GPSReferenceTimeResult_set_GPSTimingOfCell,
        ___UTRAN_GPSReferenceTimeResult_modeSpecificInfo_fdd_referenceIdentity,
        __UTRAN_GPSReferenceTimeResult_modeSpecificInfo_fdd,
        ___UTRAN_GPSReferenceTimeResult_modeSpecificInfo_tdd_referenceIdentity,
        __UTRAN_GPSReferenceTimeResult_modeSpecificInfo_tdd,
        _UTRAN_GPSReferenceTimeResult_modeSpecificInfo,
        _UTRAN_GPSReferenceTimeResult_sfn,
        _UTRAN_GPSReferenceTimeResult_gpsReferenceTimeUncertainty,
        UTRAN_GPSReferenceTimeResult,
        _UTRAN_GANSSReferenceTimeAssistance_ganssDay,
        _UTRAN_GANSSReferenceTimeAssistance_ganssTimeID,
        _UTRAN_GANSSReferenceTimeAssistance_utran_GANSSReferenceTime,
        _UTRAN_GANSSReferenceTimeAssistance_utranGANSSDriftRate,
        UTRAN_GANSSReferenceTimeAssistance,
        _UTRAN_GANSSReferenceTime_ganssTOD,
        _UTRAN_GANSSReferenceTime_utran_GANSSTimingOfCell,
        ___UTRAN_GANSSReferenceTime_modeSpecificInfo_fdd_referenceIdentity,
        __UTRAN_GANSSReferenceTime_modeSpecificInfo_fdd,
        ___UTRAN_GANSSReferenceTime_modeSpecificInfo_tdd_referenceIdentity,
        __UTRAN_GANSSReferenceTime_modeSpecificInfo_tdd,
        _UTRAN_GANSSReferenceTime_modeSpecificInfo,
        _UTRAN_GANSSReferenceTime_sfn,
        _UTRAN_GANSSReferenceTime_ganss_TODUncertainty,
        UTRAN_GANSSReferenceTime,
        UTRANGANSSDriftRate,
        _UTRAN_GANSSReferenceTimeResult_ganssTimeID,
        _UTRAN_GANSSReferenceTimeResult_set_GANSSReferenceTime,
        UTRAN_GANSSReferenceTimeResult,
        __SET_GANSSReferenceTime_set_GANSSTimingOfCell_ms_part,
        __SET_GANSSReferenceTime_set_GANSSTimingOfCell_ls_part,
        _SET_GANSSReferenceTime_set_GANSSTimingOfCell,
        ___SET_GANSSReferenceTime_modeSpecificInfo_fdd_referenceIdentity,
        __SET_GANSSReferenceTime_modeSpecificInfo_fdd,
        ___SET_GANSSReferenceTime_modeSpecificInfo_tdd_referenceIdentity,
        __SET_GANSSReferenceTime_modeSpecificInfo_tdd,
        _SET_GANSSReferenceTime_modeSpecificInfo,
        _SET_GANSSReferenceTime_sfn,
        _SET_GANSSReferenceTime_ganss_TODUncertainty,
        SET_GANSSReferenceTime,
        _GNSSPosTechnology_gps,
        _GNSSPosTechnology_galileo,
        _GNSSPosTechnology_sbas,
        _GNSSPosTechnology_modernized_gps,
        _GNSSPosTechnology_qzss,
        _GNSSPosTechnology_glonass,
        _GNSSPosTechnology_bds,
        GNSSPosTechnology,
        GANSSSignals,
        SPCSETKey,
        _SPCTID_rand,
        _SPCTID_slpFQDN,
        SPCTID,
        SPCSETKeylifetime,
        CauseCode,
        _ThirdParty__item_,
        ThirdParty,
        _ThirdPartyID_logicalName,
        _ThirdPartyID_msisdn,
        _ThirdPartyID_emailaddr,
        _ThirdPartyID_sip_uri,
        _ThirdPartyID_ims_public_identity,
        _ThirdPartyID_min,
        _ThirdPartyID_mdn,
        _ThirdPartyID_uri,
        ThirdPartyID,
        _ApplicationID_appProvider,
        _ApplicationID_appName,
        _ApplicationID_appVersion,
        ApplicationID,
        _ReportingCap_minInt,
        _ReportingCap_maxInt,
        _ReportingCap_repMode,
        _ReportingCap_batchRepCap,
        ReportingCap,
        _RepMode_realtime,
        _RepMode_quasirealtime,
        _RepMode_batch,
        RepMode,
        _BatchRepCap_report_position,
        _BatchRepCap_report_measurements,
        _BatchRepCap_max_num_positions,
        _BatchRepCap_max_num_measurements,
        BatchRepCap,
        _Coordinate_latitudeSign,
        _Coordinate_latitude,
        _Coordinate_longitude,
        Coordinate,
        _CircularArea_coordinate,
        _CircularArea_radius,
        _CircularArea_radius_min,
        _CircularArea_radius_max,
        CircularArea,
        _EllipticalArea_coordinate,
        _EllipticalArea_semiMajor,
        _EllipticalArea_semiMajor_min,
        _EllipticalArea_semiMajor_max,
        _EllipticalArea_semiMinor,
        _EllipticalArea_semiMinor_min,
        _EllipticalArea_semiMinor_max,
        _EllipticalArea_angle,
        EllipticalArea,
        _PolygonArea_polygonDescription,
        _PolygonArea_polygonHysteresis,
        PolygonArea,
        _PolygonDescription__item_,
        PolygonDescription,
    ]

class SUPL_INIT:

    _name_  = 'SUPL-INIT'
    _oid_   = []
    
    _obj_ = [
        'SUPLINIT',
        'Notification',
        'NotificationType',
        'EncodingType',
        'maxReqLength',
        'maxClientLength',
        'FormatIndicator',
        'SLPMode',
        'MAC',
        'KeyIdentity',
        ]
    _type_ = [
        'SUPLINIT',
        'Notification',
        'NotificationType',
        'EncodingType',
        'FormatIndicator',
        'SLPMode',
        'MAC',
        'KeyIdentity',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxReqLength',
        'maxClientLength',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SUPLINIT >-----#
    SUPLINIT = SEQ(name='SUPLINIT', mode=MODE_TYPE)
    _SUPLINIT_posMethod = ENUM(name='posMethod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PosMethod')))
    _SUPLINIT_notification = SEQ(name='notification', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-INIT', 'Notification')), opt=True)
    _SUPLINIT_sLPAddress = CHOICE(name='sLPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'SLPAddress')), opt=True)
    _SUPLINIT_qoP = SEQ(name='qoP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'QoP')), opt=True)
    _SUPLINIT_sLPMode = ENUM(name='sLPMode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-INIT', 'SLPMode')))
    _SUPLINIT_mac = BIT_STR(name='mac', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-INIT', 'MAC')), opt=True)
    _SUPLINIT_keyIdentity = BIT_STR(name='keyIdentity', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-INIT', 'KeyIdentity')), opt=True)
    _SUPLINIT_ver2_SUPL_INIT_extension = SEQ(name='ver2-SUPL-INIT-extension', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'Ver2-SUPL-INIT-extension')), opt=True)
    SUPLINIT._cont = ASN1Dict([
        ('posMethod', _SUPLINIT_posMethod),
        ('notification', _SUPLINIT_notification),
        ('sLPAddress', _SUPLINIT_sLPAddress),
        ('qoP', _SUPLINIT_qoP),
        ('sLPMode', _SUPLINIT_sLPMode),
        ('mac', _SUPLINIT_mac),
        ('keyIdentity', _SUPLINIT_keyIdentity),
        ('ver2-SUPL-INIT-extension', _SUPLINIT_ver2_SUPL_INIT_extension),
        ])
    SUPLINIT._ext = ['ver2-SUPL-INIT-extension']
    
    #-----< Notification >-----#
    Notification = SEQ(name='Notification', mode=MODE_TYPE)
    _Notification_notificationType = ENUM(name='notificationType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-INIT', 'NotificationType')))
    _Notification_encodingType = ENUM(name='encodingType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-INIT', 'EncodingType')), opt=True)
    _Notification_requestorId = OCT_STR(name='requestorId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Notification_requestorId._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    _Notification_requestorIdType = ENUM(name='requestorIdType', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-INIT', 'FormatIndicator')), opt=True)
    _Notification_clientName = OCT_STR(name='clientName', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Notification_clientName._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=50)], ev=None, er=[])
    _Notification_clientNameType = ENUM(name='clientNameType', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-INIT', 'FormatIndicator')), opt=True)
    _Notification_ver2_Notification_extension = SEQ(name='ver2-Notification-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'Ver2-Notification-extension')), opt=True)
    Notification._cont = ASN1Dict([
        ('notificationType', _Notification_notificationType),
        ('encodingType', _Notification_encodingType),
        ('requestorId', _Notification_requestorId),
        ('requestorIdType', _Notification_requestorIdType),
        ('clientName', _Notification_clientName),
        ('clientNameType', _Notification_clientNameType),
        ('ver2-Notification-extension', _Notification_ver2_Notification_extension),
        ])
    Notification._ext = ['ver2-Notification-extension']
    
    #-----< NotificationType >-----#
    NotificationType = ENUM(name='NotificationType', mode=MODE_TYPE)
    NotificationType._cont = ASN1Dict([('noNotificationNoVerification', 0), ('notificationOnly', 1), ('notificationAndVerficationAllowedNA', 2), ('notificationAndVerficationDeniedNA', 3), ('privacyOverride', 4)])
    NotificationType._ext = []
    
    #-----< EncodingType >-----#
    EncodingType = ENUM(name='EncodingType', mode=MODE_TYPE)
    EncodingType._cont = ASN1Dict([('ucs2', 0), ('gsmDefault', 1), ('utf8', 2)])
    EncodingType._ext = []
    
    #-----< maxReqLength >-----#
    maxReqLength = INT(name='maxReqLength', mode=MODE_VALUE)
    maxReqLength._val = 50
    
    #-----< maxClientLength >-----#
    maxClientLength = INT(name='maxClientLength', mode=MODE_VALUE)
    maxClientLength._val = 50
    
    #-----< FormatIndicator >-----#
    FormatIndicator = ENUM(name='FormatIndicator', mode=MODE_TYPE)
    FormatIndicator._cont = ASN1Dict([('logicalName', 0), ('e-mailAddress', 1), ('msisdn', 2), ('url', 3), ('sipUrl', 4), ('min', 5), ('mdn', 6), ('iMSPublicidentity', 7)])
    FormatIndicator._ext = []
    
    #-----< SLPMode >-----#
    SLPMode = ENUM(name='SLPMode', mode=MODE_TYPE)
    SLPMode._cont = ASN1Dict([('proxy', 0), ('nonProxy', 1)])
    SLPMode._ext = None
    
    #-----< MAC >-----#
    MAC = BIT_STR(name='MAC', mode=MODE_TYPE)
    MAC._const_sz = ASN1Set(rv=[64], rr=[], ev=None, er=[])
    
    #-----< KeyIdentity >-----#
    KeyIdentity = BIT_STR(name='KeyIdentity', mode=MODE_TYPE)
    KeyIdentity._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    _all_ = [
        _SUPLINIT_posMethod,
        _SUPLINIT_notification,
        _SUPLINIT_sLPAddress,
        _SUPLINIT_qoP,
        _SUPLINIT_sLPMode,
        _SUPLINIT_mac,
        _SUPLINIT_keyIdentity,
        _SUPLINIT_ver2_SUPL_INIT_extension,
        SUPLINIT,
        _Notification_notificationType,
        _Notification_encodingType,
        _Notification_requestorId,
        _Notification_requestorIdType,
        _Notification_clientName,
        _Notification_clientNameType,
        _Notification_ver2_Notification_extension,
        Notification,
        NotificationType,
        EncodingType,
        maxReqLength,
        maxClientLength,
        FormatIndicator,
        SLPMode,
        MAC,
        KeyIdentity,
    ]

class SUPL_START:

    _name_  = 'SUPL-START'
    _oid_   = []
    
    _obj_ = [
        'SUPLSTART',
        'SETCapabilities',
        'PosTechnology',
        'PrefMethod',
        'PosProtocol',
        ]
    _type_ = [
        'SUPLSTART',
        'SETCapabilities',
        'PosTechnology',
        'PrefMethod',
        'PosProtocol',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SUPLSTART >-----#
    SUPLSTART = SEQ(name='SUPLSTART', mode=MODE_TYPE)
    _SUPLSTART_sETCapabilities = SEQ(name='sETCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-START', 'SETCapabilities')))
    _SUPLSTART_locationId = SEQ(name='locationId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'LocationId')))
    _SUPLSTART_qoP = SEQ(name='qoP', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'QoP')), opt=True)
    _SUPLSTART_ver2_SUPL_START_extension = SEQ(name='ver2-SUPL-START-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'Ver2-SUPL-START-extension')), opt=True)
    SUPLSTART._cont = ASN1Dict([
        ('sETCapabilities', _SUPLSTART_sETCapabilities),
        ('locationId', _SUPLSTART_locationId),
        ('qoP', _SUPLSTART_qoP),
        ('ver2-SUPL-START-extension', _SUPLSTART_ver2_SUPL_START_extension),
        ])
    SUPLSTART._ext = ['ver2-SUPL-START-extension']
    
    #-----< SETCapabilities >-----#
    SETCapabilities = SEQ(name='SETCapabilities', mode=MODE_TYPE)
    _SETCapabilities_posTechnology = SEQ(name='posTechnology', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-START', 'PosTechnology')))
    _SETCapabilities_prefMethod = ENUM(name='prefMethod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-START', 'PrefMethod')))
    _SETCapabilities_posProtocol = SEQ(name='posProtocol', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-START', 'PosProtocol')))
    _SETCapabilities_ver2_SETCapabilities_extension = SEQ(name='ver2-SETCapabilities-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'Ver2-SETCapabilities-extension')), opt=True)
    SETCapabilities._cont = ASN1Dict([
        ('posTechnology', _SETCapabilities_posTechnology),
        ('prefMethod', _SETCapabilities_prefMethod),
        ('posProtocol', _SETCapabilities_posProtocol),
        ('ver2-SETCapabilities-extension', _SETCapabilities_ver2_SETCapabilities_extension),
        ])
    SETCapabilities._ext = ['ver2-SETCapabilities-extension']
    
    #-----< PosTechnology >-----#
    PosTechnology = SEQ(name='PosTechnology', mode=MODE_TYPE)
    _PosTechnology_agpsSETassisted = BOOL(name='agpsSETassisted', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosTechnology_agpsSETBased = BOOL(name='agpsSETBased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosTechnology_autonomousGPS = BOOL(name='autonomousGPS', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosTechnology_aflt = BOOL(name='aflt', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosTechnology_ecid = BOOL(name='ecid', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosTechnology_eotd = BOOL(name='eotd', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosTechnology_otdoa = BOOL(name='otdoa', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosTechnology_ver2_PosTechnology_extension = SEQ(name='ver2-PosTechnology-extension', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'Ver2-PosTechnology-extension')), opt=True)
    PosTechnology._cont = ASN1Dict([
        ('agpsSETassisted', _PosTechnology_agpsSETassisted),
        ('agpsSETBased', _PosTechnology_agpsSETBased),
        ('autonomousGPS', _PosTechnology_autonomousGPS),
        ('aflt', _PosTechnology_aflt),
        ('ecid', _PosTechnology_ecid),
        ('eotd', _PosTechnology_eotd),
        ('otdoa', _PosTechnology_otdoa),
        ('ver2-PosTechnology-extension', _PosTechnology_ver2_PosTechnology_extension),
        ])
    PosTechnology._ext = ['ver2-PosTechnology-extension']
    
    #-----< PrefMethod >-----#
    PrefMethod = ENUM(name='PrefMethod', mode=MODE_TYPE)
    PrefMethod._cont = ASN1Dict([('agpsSETassistedPreferred', 0), ('agpsSETBasedPreferred', 1), ('noPreference', 2)])
    PrefMethod._ext = None
    
    #-----< PosProtocol >-----#
    PosProtocol = SEQ(name='PosProtocol', mode=MODE_TYPE)
    _PosProtocol_tia801 = BOOL(name='tia801', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosProtocol_rrlp = BOOL(name='rrlp', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosProtocol_rrc = BOOL(name='rrc', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosProtocol_ver2_PosProtocol_extension = SEQ(name='ver2-PosProtocol-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'Ver2-PosProtocol-extension')), opt=True)
    PosProtocol._cont = ASN1Dict([
        ('tia801', _PosProtocol_tia801),
        ('rrlp', _PosProtocol_rrlp),
        ('rrc', _PosProtocol_rrc),
        ('ver2-PosProtocol-extension', _PosProtocol_ver2_PosProtocol_extension),
        ])
    PosProtocol._ext = ['ver2-PosProtocol-extension']
    
    _all_ = [
        _SUPLSTART_sETCapabilities,
        _SUPLSTART_locationId,
        _SUPLSTART_qoP,
        _SUPLSTART_ver2_SUPL_START_extension,
        SUPLSTART,
        _SETCapabilities_posTechnology,
        _SETCapabilities_prefMethod,
        _SETCapabilities_posProtocol,
        _SETCapabilities_ver2_SETCapabilities_extension,
        SETCapabilities,
        _PosTechnology_agpsSETassisted,
        _PosTechnology_agpsSETBased,
        _PosTechnology_autonomousGPS,
        _PosTechnology_aflt,
        _PosTechnology_ecid,
        _PosTechnology_eotd,
        _PosTechnology_otdoa,
        _PosTechnology_ver2_PosTechnology_extension,
        PosTechnology,
        PrefMethod,
        _PosProtocol_tia801,
        _PosProtocol_rrlp,
        _PosProtocol_rrc,
        _PosProtocol_ver2_PosProtocol_extension,
        PosProtocol,
    ]

class SUPL_RESPONSE:

    _name_  = 'SUPL-RESPONSE'
    _oid_   = []
    
    _obj_ = [
        'SUPLRESPONSE',
        'SETAuthKey',
        'KeyIdentity4',
        ]
    _type_ = [
        'SUPLRESPONSE',
        'SETAuthKey',
        'KeyIdentity4',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SUPLRESPONSE >-----#
    SUPLRESPONSE = SEQ(name='SUPLRESPONSE', mode=MODE_TYPE)
    _SUPLRESPONSE_posMethod = ENUM(name='posMethod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PosMethod')))
    _SUPLRESPONSE_sLPAddress = CHOICE(name='sLPAddress', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'SLPAddress')), opt=True)
    _SUPLRESPONSE_sETAuthKey = CHOICE(name='sETAuthKey', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SUPL-RESPONSE', 'SETAuthKey')), opt=True)
    _SUPLRESPONSE_keyIdentity4 = BIT_STR(name='keyIdentity4', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-RESPONSE', 'KeyIdentity4')), opt=True)
    _SUPLRESPONSE_ver2_SUPL_RESPONSE_extension = SEQ(name='ver2-SUPL-RESPONSE-extension', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'Ver2-SUPL-RESPONSE-extension')), opt=True)
    SUPLRESPONSE._cont = ASN1Dict([
        ('posMethod', _SUPLRESPONSE_posMethod),
        ('sLPAddress', _SUPLRESPONSE_sLPAddress),
        ('sETAuthKey', _SUPLRESPONSE_sETAuthKey),
        ('keyIdentity4', _SUPLRESPONSE_keyIdentity4),
        ('ver2-SUPL-RESPONSE-extension', _SUPLRESPONSE_ver2_SUPL_RESPONSE_extension),
        ])
    SUPLRESPONSE._ext = ['ver2-SUPL-RESPONSE-extension']
    
    #-----< SETAuthKey >-----#
    SETAuthKey = CHOICE(name='SETAuthKey', mode=MODE_TYPE)
    _SETAuthKey_shortKey = BIT_STR(name='shortKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SETAuthKey_shortKey._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    _SETAuthKey_longKey = BIT_STR(name='longKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SETAuthKey_longKey._const_sz = ASN1Set(rv=[256], rr=[], ev=None, er=[])
    SETAuthKey._cont = ASN1Dict([
        ('shortKey', _SETAuthKey_shortKey),
        ('longKey', _SETAuthKey_longKey),
        ])
    SETAuthKey._ext = []
    
    #-----< KeyIdentity4 >-----#
    KeyIdentity4 = BIT_STR(name='KeyIdentity4', mode=MODE_TYPE)
    KeyIdentity4._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    
    _all_ = [
        _SUPLRESPONSE_posMethod,
        _SUPLRESPONSE_sLPAddress,
        _SUPLRESPONSE_sETAuthKey,
        _SUPLRESPONSE_keyIdentity4,
        _SUPLRESPONSE_ver2_SUPL_RESPONSE_extension,
        SUPLRESPONSE,
        _SETAuthKey_shortKey,
        _SETAuthKey_longKey,
        SETAuthKey,
        KeyIdentity4,
    ]

class SUPL_POS_INIT:

    _name_  = 'SUPL-POS-INIT'
    _oid_   = []
    
    _obj_ = [
        'SUPLPOSINIT',
        'RequestedAssistData',
        'NavigationModel',
        'SatelliteInfo',
        'SatelliteInfoElement',
        ]
    _type_ = [
        'SUPLPOSINIT',
        'RequestedAssistData',
        'NavigationModel',
        'SatelliteInfo',
        'SatelliteInfoElement',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SUPLPOSINIT >-----#
    SUPLPOSINIT = SEQ(name='SUPLPOSINIT', mode=MODE_TYPE)
    _SUPLPOSINIT_sETCapabilities = SEQ(name='sETCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-START', 'SETCapabilities')))
    _SUPLPOSINIT_requestedAssistData = SEQ(name='requestedAssistData', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-POS-INIT', 'RequestedAssistData')), opt=True)
    _SUPLPOSINIT_locationId = SEQ(name='locationId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'LocationId')))
    _SUPLPOSINIT_position = SEQ(name='position', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Position')), opt=True)
    _SUPLPOSINIT_suplpos = SEQ(name='suplpos', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-POS', 'SUPLPOS')), opt=True)
    _SUPLPOSINIT_ver = BIT_STR(name='ver', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Ver')), opt=True)
    _SUPLPOSINIT_ver2_SUPL_POS_INIT_extension = SEQ(name='ver2-SUPL-POS-INIT-extension', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'Ver2-SUPL-POS-INIT-extension')), opt=True)
    SUPLPOSINIT._cont = ASN1Dict([
        ('sETCapabilities', _SUPLPOSINIT_sETCapabilities),
        ('requestedAssistData', _SUPLPOSINIT_requestedAssistData),
        ('locationId', _SUPLPOSINIT_locationId),
        ('position', _SUPLPOSINIT_position),
        ('suplpos', _SUPLPOSINIT_suplpos),
        ('ver', _SUPLPOSINIT_ver),
        ('ver2-SUPL-POS-INIT-extension', _SUPLPOSINIT_ver2_SUPL_POS_INIT_extension),
        ])
    SUPLPOSINIT._ext = ['ver2-SUPL-POS-INIT-extension']
    
    #-----< RequestedAssistData >-----#
    RequestedAssistData = SEQ(name='RequestedAssistData', mode=MODE_TYPE)
    _RequestedAssistData_almanacRequested = BOOL(name='almanacRequested', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedAssistData_utcModelRequested = BOOL(name='utcModelRequested', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedAssistData_ionosphericModelRequested = BOOL(name='ionosphericModelRequested', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedAssistData_dgpsCorrectionsRequested = BOOL(name='dgpsCorrectionsRequested', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedAssistData_referenceLocationRequested = BOOL(name='referenceLocationRequested', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedAssistData_referenceTimeRequested = BOOL(name='referenceTimeRequested', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedAssistData_acquisitionAssistanceRequested = BOOL(name='acquisitionAssistanceRequested', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedAssistData_realTimeIntegrityRequested = BOOL(name='realTimeIntegrityRequested', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedAssistData_navigationModelRequested = BOOL(name='navigationModelRequested', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RequestedAssistData_navigationModelData = SEQ(name='navigationModelData', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-POS-INIT', 'NavigationModel')), opt=True)
    _RequestedAssistData_ver2_RequestedAssistData_extension = SEQ(name='ver2-RequestedAssistData-extension', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'Ver2-RequestedAssistData-extension')), opt=True)
    RequestedAssistData._cont = ASN1Dict([
        ('almanacRequested', _RequestedAssistData_almanacRequested),
        ('utcModelRequested', _RequestedAssistData_utcModelRequested),
        ('ionosphericModelRequested', _RequestedAssistData_ionosphericModelRequested),
        ('dgpsCorrectionsRequested', _RequestedAssistData_dgpsCorrectionsRequested),
        ('referenceLocationRequested', _RequestedAssistData_referenceLocationRequested),
        ('referenceTimeRequested', _RequestedAssistData_referenceTimeRequested),
        ('acquisitionAssistanceRequested', _RequestedAssistData_acquisitionAssistanceRequested),
        ('realTimeIntegrityRequested', _RequestedAssistData_realTimeIntegrityRequested),
        ('navigationModelRequested', _RequestedAssistData_navigationModelRequested),
        ('navigationModelData', _RequestedAssistData_navigationModelData),
        ('ver2-RequestedAssistData-extension', _RequestedAssistData_ver2_RequestedAssistData_extension),
        ])
    RequestedAssistData._ext = ['ver2-RequestedAssistData-extension']
    
    #-----< NavigationModel >-----#
    NavigationModel = SEQ(name='NavigationModel', mode=MODE_TYPE)
    _NavigationModel_gpsWeek = INT(name='gpsWeek', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavigationModel_gpsWeek._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _NavigationModel_gpsToe = INT(name='gpsToe', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavigationModel_gpsToe._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=167)], ev=None, er=[])
    _NavigationModel_nsat = INT(name='nsat', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavigationModel_nsat._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31)], ev=None, er=[])
    _NavigationModel_toeLimit = INT(name='toeLimit', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _NavigationModel_toeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=10)], ev=None, er=[])
    _NavigationModel_satInfo = SEQ_OF(name='satInfo', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-POS-INIT', 'SatelliteInfo')), opt=True)
    NavigationModel._cont = ASN1Dict([
        ('gpsWeek', _NavigationModel_gpsWeek),
        ('gpsToe', _NavigationModel_gpsToe),
        ('nsat', _NavigationModel_nsat),
        ('toeLimit', _NavigationModel_toeLimit),
        ('satInfo', _NavigationModel_satInfo),
        ])
    NavigationModel._ext = []
    
    #-----< SatelliteInfo >-----#
    SatelliteInfo = SEQ_OF(name='SatelliteInfo', mode=MODE_TYPE)
    _SatelliteInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SUPL-POS-INIT', 'SatelliteInfoElement')))
    SatelliteInfo._cont = _SatelliteInfo__item_
    SatelliteInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=31)], ev=None, er=[])
    
    #-----< SatelliteInfoElement >-----#
    SatelliteInfoElement = SEQ(name='SatelliteInfoElement', mode=MODE_TYPE)
    _SatelliteInfoElement_satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SatelliteInfoElement_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SatelliteInfoElement_iode = INT(name='iode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SatelliteInfoElement_iode._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    SatelliteInfoElement._cont = ASN1Dict([
        ('satId', _SatelliteInfoElement_satId),
        ('iode', _SatelliteInfoElement_iode),
        ])
    SatelliteInfoElement._ext = []
    
    _all_ = [
        _SUPLPOSINIT_sETCapabilities,
        _SUPLPOSINIT_requestedAssistData,
        _SUPLPOSINIT_locationId,
        _SUPLPOSINIT_position,
        _SUPLPOSINIT_suplpos,
        _SUPLPOSINIT_ver,
        _SUPLPOSINIT_ver2_SUPL_POS_INIT_extension,
        SUPLPOSINIT,
        _RequestedAssistData_almanacRequested,
        _RequestedAssistData_utcModelRequested,
        _RequestedAssistData_ionosphericModelRequested,
        _RequestedAssistData_dgpsCorrectionsRequested,
        _RequestedAssistData_referenceLocationRequested,
        _RequestedAssistData_referenceTimeRequested,
        _RequestedAssistData_acquisitionAssistanceRequested,
        _RequestedAssistData_realTimeIntegrityRequested,
        _RequestedAssistData_navigationModelRequested,
        _RequestedAssistData_navigationModelData,
        _RequestedAssistData_ver2_RequestedAssistData_extension,
        RequestedAssistData,
        _NavigationModel_gpsWeek,
        _NavigationModel_gpsToe,
        _NavigationModel_nsat,
        _NavigationModel_toeLimit,
        _NavigationModel_satInfo,
        NavigationModel,
        _SatelliteInfo__item_,
        SatelliteInfo,
        _SatelliteInfoElement_satId,
        _SatelliteInfoElement_iode,
        SatelliteInfoElement,
    ]

class SUPL_POS:

    _name_  = 'SUPL-POS'
    _oid_   = []
    
    _obj_ = [
        'SUPLPOS',
        'PosPayLoad',
        ]
    _type_ = [
        'SUPLPOS',
        'PosPayLoad',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SUPLPOS >-----#
    SUPLPOS = SEQ(name='SUPLPOS', mode=MODE_TYPE)
    _SUPLPOS_posPayLoad = CHOICE(name='posPayLoad', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SUPL-POS', 'PosPayLoad')))
    _SUPLPOS_velocity = CHOICE(name='velocity', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'Velocity')), opt=True)
    _SUPLPOS_ver2_SUPL_POS_extension = SEQ(name='ver2-SUPL-POS-extension', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'Ver2-SUPL-POS-extension')), opt=True)
    SUPLPOS._cont = ASN1Dict([
        ('posPayLoad', _SUPLPOS_posPayLoad),
        ('velocity', _SUPLPOS_velocity),
        ('ver2-SUPL-POS-extension', _SUPLPOS_ver2_SUPL_POS_extension),
        ])
    SUPLPOS._ext = ['ver2-SUPL-POS-extension']
    
    #-----< PosPayLoad >-----#
    PosPayLoad = CHOICE(name='PosPayLoad', mode=MODE_TYPE)
    _PosPayLoad_tia801payload = OCT_STR(name='tia801payload', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosPayLoad_tia801payload._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8192)], ev=None, er=[])
    _PosPayLoad_rrcPayload = OCT_STR(name='rrcPayload', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosPayLoad_rrcPayload._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8192)], ev=None, er=[])
    _PosPayLoad_rrlpPayload = OCT_STR(name='rrlpPayload', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosPayLoad_rrlpPayload._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8192)], ev=None, er=[])
    _PosPayLoad_ver2_PosPayLoad_extension = SEQ(name='ver2-PosPayLoad-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'Ver2-PosPayLoad-extension')))
    PosPayLoad._cont = ASN1Dict([
        ('tia801payload', _PosPayLoad_tia801payload),
        ('rrcPayload', _PosPayLoad_rrcPayload),
        ('rrlpPayload', _PosPayLoad_rrlpPayload),
        ('ver2-PosPayLoad-extension', _PosPayLoad_ver2_PosPayLoad_extension),
        ])
    PosPayLoad._ext = ['ver2-PosPayLoad-extension']
    
    _all_ = [
        _SUPLPOS_posPayLoad,
        _SUPLPOS_velocity,
        _SUPLPOS_ver2_SUPL_POS_extension,
        SUPLPOS,
        _PosPayLoad_tia801payload,
        _PosPayLoad_rrcPayload,
        _PosPayLoad_rrlpPayload,
        _PosPayLoad_ver2_PosPayLoad_extension,
        PosPayLoad,
    ]

class SUPL_END:

    _name_  = 'SUPL-END'
    _oid_   = []
    
    _obj_ = [
        'SUPLEND',
        ]
    _type_ = [
        'SUPLEND',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SUPLEND >-----#
    SUPLEND = SEQ(name='SUPLEND', mode=MODE_TYPE)
    _SUPLEND_position = SEQ(name='position', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Position')), opt=True)
    _SUPLEND_statusCode = ENUM(name='statusCode', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'StatusCode')), opt=True)
    _SUPLEND_ver = BIT_STR(name='ver', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Ver')), opt=True)
    _SUPLEND_ver2_SUPL_END_extension = SEQ(name='ver2-SUPL-END-extension', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'Ver2-SUPL-END-extension')), opt=True)
    SUPLEND._cont = ASN1Dict([
        ('position', _SUPLEND_position),
        ('statusCode', _SUPLEND_statusCode),
        ('ver', _SUPLEND_ver),
        ('ver2-SUPL-END-extension', _SUPLEND_ver2_SUPL_END_extension),
        ])
    SUPLEND._ext = ['ver2-SUPL-END-extension']
    
    _all_ = [
        _SUPLEND_position,
        _SUPLEND_statusCode,
        _SUPLEND_ver,
        _SUPLEND_ver2_SUPL_END_extension,
        SUPLEND,
    ]

class SUPL_AUTH_REQ:

    _name_  = 'SUPL-AUTH-REQ'
    _oid_   = []
    
    _obj_ = [
        'SUPLAUTHREQ',
        ]
    _type_ = [
        'SUPLAUTHREQ',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SUPLAUTHREQ >-----#
    SUPLAUTHREQ = SEQ(name='SUPLAUTHREQ', mode=MODE_TYPE)
    _SUPLAUTHREQ_ver = BIT_STR(name='ver', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Ver')), opt=True)
    _SUPLAUTHREQ_sETCapabilities = SEQ(name='sETCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-START', 'SETCapabilities')), opt=True)
    SUPLAUTHREQ._cont = ASN1Dict([
        ('ver', _SUPLAUTHREQ_ver),
        ('sETCapabilities', _SUPLAUTHREQ_sETCapabilities),
        ])
    SUPLAUTHREQ._ext = []
    
    _all_ = [
        _SUPLAUTHREQ_ver,
        _SUPLAUTHREQ_sETCapabilities,
        SUPLAUTHREQ,
    ]

class SUPL_AUTH_RESP:

    _name_  = 'SUPL-AUTH-RESP'
    _oid_   = []
    
    _obj_ = [
        'SUPLAUTHRESP',
        ]
    _type_ = [
        'SUPLAUTHRESP',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< SUPLAUTHRESP >-----#
    SUPLAUTHRESP = SEQ(name='SUPLAUTHRESP', mode=MODE_TYPE)
    _SUPLAUTHRESP_sPCSETKey = BIT_STR(name='sPCSETKey', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SPCSETKey')))
    _SUPLAUTHRESP_spctid = SEQ(name='spctid', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SPCTID')))
    _SUPLAUTHRESP_sPCSETKeylifetime = INT(name='sPCSETKeylifetime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SPCSETKeylifetime')), opt=True)
    SUPLAUTHRESP._cont = ASN1Dict([
        ('sPCSETKey', _SUPLAUTHRESP_sPCSETKey),
        ('spctid', _SUPLAUTHRESP_spctid),
        ('sPCSETKeylifetime', _SUPLAUTHRESP_sPCSETKeylifetime),
        ])
    SUPLAUTHRESP._ext = []
    
    _all_ = [
        _SUPLAUTHRESP_sPCSETKey,
        _SUPLAUTHRESP_spctid,
        _SUPLAUTHRESP_sPCSETKeylifetime,
        SUPLAUTHRESP,
    ]

class SUPL_NOTIFY:

    _name_  = 'SUPL-NOTIFY'
    _oid_   = []
    
    _obj_ = [
        'Ver2-SUPLNOTIFY',
        ]
    _type_ = [
        'Ver2-SUPLNOTIFY',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Ver2-SUPLNOTIFY >-----#
    Ver2_SUPLNOTIFY = SEQ(name='Ver2-SUPLNOTIFY', mode=MODE_TYPE)
    _Ver2_SUPLNOTIFY_notification = SEQ(name='notification', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-INIT', 'Notification')))
    Ver2_SUPLNOTIFY._cont = ASN1Dict([
        ('notification', _Ver2_SUPLNOTIFY_notification),
        ])
    Ver2_SUPLNOTIFY._ext = []
    
    _all_ = [
        _Ver2_SUPLNOTIFY_notification,
        Ver2_SUPLNOTIFY,
    ]

class SUPL_NOTIFY_RESPONSE:

    _name_  = 'SUPL-NOTIFY-RESPONSE'
    _oid_   = []
    
    _obj_ = [
        'Ver2-SUPLNOTIFYRESPONSE',
        'NotificationResponse',
        ]
    _type_ = [
        'Ver2-SUPLNOTIFYRESPONSE',
        'NotificationResponse',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Ver2-SUPLNOTIFYRESPONSE >-----#
    Ver2_SUPLNOTIFYRESPONSE = SEQ(name='Ver2-SUPLNOTIFYRESPONSE', mode=MODE_TYPE)
    _Ver2_SUPLNOTIFYRESPONSE_notificationResponse = ENUM(name='notificationResponse', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-NOTIFY-RESPONSE', 'NotificationResponse')), opt=True)
    Ver2_SUPLNOTIFYRESPONSE._cont = ASN1Dict([
        ('notificationResponse', _Ver2_SUPLNOTIFYRESPONSE_notificationResponse),
        ])
    Ver2_SUPLNOTIFYRESPONSE._ext = []
    
    #-----< NotificationResponse >-----#
    NotificationResponse = ENUM(name='NotificationResponse', mode=MODE_TYPE)
    NotificationResponse._cont = ASN1Dict([('allowed', 0), ('notAllowed', 1)])
    NotificationResponse._ext = []
    
    _all_ = [
        _Ver2_SUPLNOTIFYRESPONSE_notificationResponse,
        Ver2_SUPLNOTIFYRESPONSE,
        NotificationResponse,
    ]

class SUPL_SET_INIT:

    _name_  = 'SUPL-SET-INIT'
    _oid_   = []
    
    _obj_ = [
        'Ver2-SUPLSETINIT',
        ]
    _type_ = [
        'Ver2-SUPLSETINIT',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Ver2-SUPLSETINIT >-----#
    Ver2_SUPLSETINIT = SEQ(name='Ver2-SUPLSETINIT', mode=MODE_TYPE)
    _Ver2_SUPLSETINIT_targetSETID = CHOICE(name='targetSETID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'SETId')))
    _Ver2_SUPLSETINIT_qoP = SEQ(name='qoP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'QoP')), opt=True)
    _Ver2_SUPLSETINIT_applicationID = SEQ(name='applicationID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'ApplicationID')), opt=True)
    Ver2_SUPLSETINIT._cont = ASN1Dict([
        ('targetSETID', _Ver2_SUPLSETINIT_targetSETID),
        ('qoP', _Ver2_SUPLSETINIT_qoP),
        ('applicationID', _Ver2_SUPLSETINIT_applicationID),
        ])
    Ver2_SUPLSETINIT._ext = []
    
    _all_ = [
        _Ver2_SUPLSETINIT_targetSETID,
        _Ver2_SUPLSETINIT_qoP,
        _Ver2_SUPLSETINIT_applicationID,
        Ver2_SUPLSETINIT,
    ]

class SUPL_TRIGGERED_START:

    _name_  = 'SUPL-TRIGGERED-START'
    _oid_   = []
    
    _obj_ = [
        'Ver2-SUPLTRIGGEREDSTART',
        'TriggerType',
        'TriggerParams',
        'PeriodicParams',
        'AreaEventParams',
        'AreaEventType',
        'RepeatedReportingParams',
        'GeographicTargetAreaList',
        'GeographicTargetArea',
        'AreaIdList',
        'AreaIdSet',
        'AreaId',
        'GSMAreaId',
        'WCDMAAreaId',
        'CDMAAreaId',
        'HRPDAreaId',
        'UMBAreaId',
        'LTEAreaId',
        'WLANAreaId',
        'WimaxAreaId',
        'AreaIdSetType',
        'GeoAreaMappingList',
        'GeoAreaIndex',
        'maxNumGeoArea',
        'maxAreaId',
        'maxAreaIdList',
        ]
    _type_ = [
        'Ver2-SUPLTRIGGEREDSTART',
        'TriggerType',
        'TriggerParams',
        'PeriodicParams',
        'AreaEventParams',
        'AreaEventType',
        'RepeatedReportingParams',
        'GeographicTargetAreaList',
        'GeographicTargetArea',
        'AreaIdList',
        'AreaIdSet',
        'AreaId',
        'GSMAreaId',
        'WCDMAAreaId',
        'CDMAAreaId',
        'HRPDAreaId',
        'UMBAreaId',
        'LTEAreaId',
        'WLANAreaId',
        'WimaxAreaId',
        'AreaIdSetType',
        'GeoAreaMappingList',
        'GeoAreaIndex',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxNumGeoArea',
        'maxAreaId',
        'maxAreaIdList',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Ver2-SUPLTRIGGEREDSTART >-----#
    Ver2_SUPLTRIGGEREDSTART = SEQ(name='Ver2-SUPLTRIGGEREDSTART', mode=MODE_TYPE)
    _Ver2_SUPLTRIGGEREDSTART_sETCapabilities = SEQ(name='sETCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-START', 'SETCapabilities')))
    _Ver2_SUPLTRIGGEREDSTART_locationId = SEQ(name='locationId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'LocationId')))
    _Ver2_SUPLTRIGGEREDSTART_ver = BIT_STR(name='ver', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Ver')), opt=True)
    _Ver2_SUPLTRIGGEREDSTART_qoP = SEQ(name='qoP', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'QoP')), opt=True)
    _Ver2_SUPLTRIGGEREDSTART_multipleLocationIds = SEQ_OF(name='multipleLocationIds', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'MultipleLocationIds')), opt=True)
    _Ver2_SUPLTRIGGEREDSTART_thirdParty = SEQ_OF(name='thirdParty', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'ThirdParty')), opt=True)
    _Ver2_SUPLTRIGGEREDSTART_applicationID = SEQ(name='applicationID', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'ApplicationID')), opt=True)
    _Ver2_SUPLTRIGGEREDSTART_triggerType = ENUM(name='triggerType', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'TriggerType')), opt=True)
    _Ver2_SUPLTRIGGEREDSTART_triggerParams = CHOICE(name='triggerParams', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'TriggerParams')), opt=True)
    _Ver2_SUPLTRIGGEREDSTART_position = SEQ(name='position', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Position')), opt=True)
    _Ver2_SUPLTRIGGEREDSTART_reportingCap = SEQ(name='reportingCap', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'ReportingCap')), opt=True)
    _Ver2_SUPLTRIGGEREDSTART_causeCode = ENUM(name='causeCode', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'CauseCode')), opt=True)
    Ver2_SUPLTRIGGEREDSTART._cont = ASN1Dict([
        ('sETCapabilities', _Ver2_SUPLTRIGGEREDSTART_sETCapabilities),
        ('locationId', _Ver2_SUPLTRIGGEREDSTART_locationId),
        ('ver', _Ver2_SUPLTRIGGEREDSTART_ver),
        ('qoP', _Ver2_SUPLTRIGGEREDSTART_qoP),
        ('multipleLocationIds', _Ver2_SUPLTRIGGEREDSTART_multipleLocationIds),
        ('thirdParty', _Ver2_SUPLTRIGGEREDSTART_thirdParty),
        ('applicationID', _Ver2_SUPLTRIGGEREDSTART_applicationID),
        ('triggerType', _Ver2_SUPLTRIGGEREDSTART_triggerType),
        ('triggerParams', _Ver2_SUPLTRIGGEREDSTART_triggerParams),
        ('position', _Ver2_SUPLTRIGGEREDSTART_position),
        ('reportingCap', _Ver2_SUPLTRIGGEREDSTART_reportingCap),
        ('causeCode', _Ver2_SUPLTRIGGEREDSTART_causeCode),
        ])
    Ver2_SUPLTRIGGEREDSTART._ext = []
    
    #-----< TriggerType >-----#
    TriggerType = ENUM(name='TriggerType', mode=MODE_TYPE)
    TriggerType._cont = ASN1Dict([('periodic', 0), ('areaEvent', 1)])
    TriggerType._ext = []
    
    #-----< TriggerParams >-----#
    TriggerParams = CHOICE(name='TriggerParams', mode=MODE_TYPE)
    _TriggerParams_periodicParams = SEQ(name='periodicParams', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'PeriodicParams')))
    _TriggerParams_areaEventParams = SEQ(name='areaEventParams', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'AreaEventParams')))
    TriggerParams._cont = ASN1Dict([
        ('periodicParams', _TriggerParams_periodicParams),
        ('areaEventParams', _TriggerParams_areaEventParams),
        ])
    TriggerParams._ext = []
    
    #-----< PeriodicParams >-----#
    PeriodicParams = SEQ(name='PeriodicParams', mode=MODE_TYPE)
    _PeriodicParams_numberOfFixes = INT(name='numberOfFixes', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicParams_numberOfFixes._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=None, er=[])
    _PeriodicParams_intervalBetweenFixes = INT(name='intervalBetweenFixes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PeriodicParams_intervalBetweenFixes._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8639999)], ev=None, er=[])
    _PeriodicParams_startTime = INT(name='startTime', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _PeriodicParams_startTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2678400)], ev=None, er=[])
    PeriodicParams._cont = ASN1Dict([
        ('numberOfFixes', _PeriodicParams_numberOfFixes),
        ('intervalBetweenFixes', _PeriodicParams_intervalBetweenFixes),
        ('startTime', _PeriodicParams_startTime),
        ])
    PeriodicParams._ext = []
    
    #-----< AreaEventParams >-----#
    AreaEventParams = SEQ(name='AreaEventParams', mode=MODE_TYPE)
    _AreaEventParams_areaEventType = ENUM(name='areaEventType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'AreaEventType')))
    _AreaEventParams_locationEstimate = BOOL(name='locationEstimate', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _AreaEventParams_repeatedReportingParams = SEQ(name='repeatedReportingParams', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'RepeatedReportingParams')), opt=True)
    _AreaEventParams_startTime = INT(name='startTime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AreaEventParams_startTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=2678400)], ev=None, er=[])
    _AreaEventParams_stopTime = INT(name='stopTime', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _AreaEventParams_stopTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=11318399)], ev=None, er=[])
    _AreaEventParams_geographicTargetAreaList = SEQ_OF(name='geographicTargetAreaList', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'GeographicTargetAreaList')), opt=True)
    _AreaEventParams_areaIdLists = SEQ_OF(name='areaIdLists', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __AreaEventParams_areaIdLists__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'AreaIdList')))
    _AreaEventParams_areaIdLists._cont = __AreaEventParams_areaIdLists__item_
    _AreaEventParams_areaIdLists._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    AreaEventParams._cont = ASN1Dict([
        ('areaEventType', _AreaEventParams_areaEventType),
        ('locationEstimate', _AreaEventParams_locationEstimate),
        ('repeatedReportingParams', _AreaEventParams_repeatedReportingParams),
        ('startTime', _AreaEventParams_startTime),
        ('stopTime', _AreaEventParams_stopTime),
        ('geographicTargetAreaList', _AreaEventParams_geographicTargetAreaList),
        ('areaIdLists', _AreaEventParams_areaIdLists),
        ])
    AreaEventParams._ext = []
    
    #-----< AreaEventType >-----#
    AreaEventType = ENUM(name='AreaEventType', mode=MODE_TYPE)
    AreaEventType._cont = ASN1Dict([('enteringArea', 0), ('insideArea', 1), ('outsideArea', 2), ('leavingArea', 3)])
    AreaEventType._ext = []
    
    #-----< RepeatedReportingParams >-----#
    RepeatedReportingParams = SEQ(name='RepeatedReportingParams', mode=MODE_TYPE)
    _RepeatedReportingParams_minimumIntervalTime = INT(name='minimumIntervalTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RepeatedReportingParams_minimumIntervalTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=604800)], ev=None, er=[])
    _RepeatedReportingParams_maximumNumberOfReports = INT(name='maximumNumberOfReports', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _RepeatedReportingParams_maximumNumberOfReports._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    RepeatedReportingParams._cont = ASN1Dict([
        ('minimumIntervalTime', _RepeatedReportingParams_minimumIntervalTime),
        ('maximumNumberOfReports', _RepeatedReportingParams_maximumNumberOfReports),
        ])
    RepeatedReportingParams._ext = []
    
    #-----< GeographicTargetAreaList >-----#
    GeographicTargetAreaList = SEQ_OF(name='GeographicTargetAreaList', mode=MODE_TYPE)
    _GeographicTargetAreaList__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'GeographicTargetArea')))
    GeographicTargetAreaList._cont = _GeographicTargetAreaList__item_
    GeographicTargetAreaList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GeographicTargetArea >-----#
    GeographicTargetArea = CHOICE(name='GeographicTargetArea', mode=MODE_TYPE)
    _GeographicTargetArea_circularArea = SEQ(name='circularArea', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'CircularArea')))
    _GeographicTargetArea_ellipticalArea = SEQ(name='ellipticalArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'EllipticalArea')))
    _GeographicTargetArea_polygonArea = SEQ(name='polygonArea', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'PolygonArea')))
    GeographicTargetArea._cont = ASN1Dict([
        ('circularArea', _GeographicTargetArea_circularArea),
        ('ellipticalArea', _GeographicTargetArea_ellipticalArea),
        ('polygonArea', _GeographicTargetArea_polygonArea),
        ])
    GeographicTargetArea._ext = []
    
    #-----< AreaIdList >-----#
    AreaIdList = SEQ(name='AreaIdList', mode=MODE_TYPE)
    _AreaIdList_areaIdSet = SEQ_OF(name='areaIdSet', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'AreaIdSet')))
    _AreaIdList_areaIdSetType = ENUM(name='areaIdSetType', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'AreaIdSetType')), opt=True)
    _AreaIdList_geoAreaMappingList = SEQ_OF(name='geoAreaMappingList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'GeoAreaMappingList')), opt=True)
    AreaIdList._cont = ASN1Dict([
        ('areaIdSet', _AreaIdList_areaIdSet),
        ('areaIdSetType', _AreaIdList_areaIdSetType),
        ('geoAreaMappingList', _AreaIdList_geoAreaMappingList),
        ])
    AreaIdList._ext = None
    
    #-----< AreaIdSet >-----#
    AreaIdSet = SEQ_OF(name='AreaIdSet', mode=MODE_TYPE)
    _AreaIdSet__item_ = CHOICE(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'AreaId')))
    AreaIdSet._cont = _AreaIdSet__item_
    AreaIdSet._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    
    #-----< AreaId >-----#
    AreaId = CHOICE(name='AreaId', mode=MODE_TYPE)
    _AreaId_gSMAreaId = SEQ(name='gSMAreaId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'GSMAreaId')))
    _AreaId_wCDMAAreaId = SEQ(name='wCDMAAreaId', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'WCDMAAreaId')))
    _AreaId_cDMAAreaId = SEQ(name='cDMAAreaId', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'CDMAAreaId')))
    _AreaId_hRPDAreaId = SEQ(name='hRPDAreaId', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'HRPDAreaId')))
    _AreaId_uMBAreaId = SEQ(name='uMBAreaId', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'UMBAreaId')))
    _AreaId_lTEAreaId = SEQ(name='lTEAreaId', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'LTEAreaId')))
    _AreaId_wLANAreaId = SEQ(name='wLANAreaId', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'WLANAreaId')))
    _AreaId_wiMAXAreaId = SEQ(name='wiMAXAreaId', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'WimaxAreaId')))
    AreaId._cont = ASN1Dict([
        ('gSMAreaId', _AreaId_gSMAreaId),
        ('wCDMAAreaId', _AreaId_wCDMAAreaId),
        ('cDMAAreaId', _AreaId_cDMAAreaId),
        ('hRPDAreaId', _AreaId_hRPDAreaId),
        ('uMBAreaId', _AreaId_uMBAreaId),
        ('lTEAreaId', _AreaId_lTEAreaId),
        ('wLANAreaId', _AreaId_wLANAreaId),
        ('wiMAXAreaId', _AreaId_wiMAXAreaId),
        ])
    AreaId._ext = []
    
    #-----< GSMAreaId >-----#
    GSMAreaId = SEQ(name='GSMAreaId', mode=MODE_TYPE)
    _GSMAreaId_refMCC = INT(name='refMCC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GSMAreaId_refMCC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _GSMAreaId_refMNC = INT(name='refMNC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GSMAreaId_refMNC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _GSMAreaId_refLAC = INT(name='refLAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GSMAreaId_refLAC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _GSMAreaId_refCI = INT(name='refCI', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GSMAreaId_refCI._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    GSMAreaId._cont = ASN1Dict([
        ('refMCC', _GSMAreaId_refMCC),
        ('refMNC', _GSMAreaId_refMNC),
        ('refLAC', _GSMAreaId_refLAC),
        ('refCI', _GSMAreaId_refCI),
        ])
    GSMAreaId._ext = []
    
    #-----< WCDMAAreaId >-----#
    WCDMAAreaId = SEQ(name='WCDMAAreaId', mode=MODE_TYPE)
    _WCDMAAreaId_refMCC = INT(name='refMCC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WCDMAAreaId_refMCC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _WCDMAAreaId_refMNC = INT(name='refMNC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WCDMAAreaId_refMNC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _WCDMAAreaId_refLAC = INT(name='refLAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WCDMAAreaId_refLAC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _WCDMAAreaId_refUC = INT(name='refUC', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WCDMAAreaId_refUC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=268435455)], ev=None, er=[])
    WCDMAAreaId._cont = ASN1Dict([
        ('refMCC', _WCDMAAreaId_refMCC),
        ('refMNC', _WCDMAAreaId_refMNC),
        ('refLAC', _WCDMAAreaId_refLAC),
        ('refUC', _WCDMAAreaId_refUC),
        ])
    WCDMAAreaId._ext = []
    
    #-----< CDMAAreaId >-----#
    CDMAAreaId = SEQ(name='CDMAAreaId', mode=MODE_TYPE)
    _CDMAAreaId_refSID = INT(name='refSID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CDMAAreaId_refSID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _CDMAAreaId_refNID = INT(name='refNID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CDMAAreaId_refNID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32767)], ev=None, er=[])
    _CDMAAreaId_refBASEID = INT(name='refBASEID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _CDMAAreaId_refBASEID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    CDMAAreaId._cont = ASN1Dict([
        ('refSID', _CDMAAreaId_refSID),
        ('refNID', _CDMAAreaId_refNID),
        ('refBASEID', _CDMAAreaId_refBASEID),
        ])
    CDMAAreaId._ext = []
    
    #-----< HRPDAreaId >-----#
    HRPDAreaId = SEQ(name='HRPDAreaId', mode=MODE_TYPE)
    _HRPDAreaId_refSECTORID = BIT_STR(name='refSECTORID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _HRPDAreaId_refSECTORID._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    HRPDAreaId._cont = ASN1Dict([
        ('refSECTORID', _HRPDAreaId_refSECTORID),
        ])
    HRPDAreaId._ext = []
    
    #-----< UMBAreaId >-----#
    UMBAreaId = SEQ(name='UMBAreaId', mode=MODE_TYPE)
    _UMBAreaId_refMCC = INT(name='refMCC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UMBAreaId_refMCC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _UMBAreaId_refMNC = INT(name='refMNC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UMBAreaId_refMNC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _UMBAreaId_refSECTORID = BIT_STR(name='refSECTORID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _UMBAreaId_refSECTORID._const_sz = ASN1Set(rv=[128], rr=[], ev=None, er=[])
    UMBAreaId._cont = ASN1Dict([
        ('refMCC', _UMBAreaId_refMCC),
        ('refMNC', _UMBAreaId_refMNC),
        ('refSECTORID', _UMBAreaId_refSECTORID),
        ])
    UMBAreaId._ext = []
    
    #-----< LTEAreaId >-----#
    LTEAreaId = SEQ(name='LTEAreaId', mode=MODE_TYPE)
    _LTEAreaId_refMCC = INT(name='refMCC', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LTEAreaId_refMCC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _LTEAreaId_refMNC = INT(name='refMNC', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LTEAreaId_refMNC._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=999)], ev=None, er=[])
    _LTEAreaId_refCI = BIT_STR(name='refCI', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _LTEAreaId_refCI._const_sz = ASN1Set(rv=[29], rr=[], ev=None, er=[])
    LTEAreaId._cont = ASN1Dict([
        ('refMCC', _LTEAreaId_refMCC),
        ('refMNC', _LTEAreaId_refMNC),
        ('refCI', _LTEAreaId_refCI),
        ])
    LTEAreaId._ext = []
    
    #-----< WLANAreaId >-----#
    WLANAreaId = SEQ(name='WLANAreaId', mode=MODE_TYPE)
    _WLANAreaId_apMACAddress = BIT_STR(name='apMACAddress', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WLANAreaId_apMACAddress._const_sz = ASN1Set(rv=[48], rr=[], ev=None, er=[])
    WLANAreaId._cont = ASN1Dict([
        ('apMACAddress', _WLANAreaId_apMACAddress),
        ])
    WLANAreaId._ext = []
    
    #-----< WimaxAreaId >-----#
    WimaxAreaId = SEQ(name='WimaxAreaId', mode=MODE_TYPE)
    _WimaxAreaId_bsID_MSB = BIT_STR(name='bsID-MSB', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _WimaxAreaId_bsID_MSB._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    _WimaxAreaId_bsID_LSB = BIT_STR(name='bsID-LSB', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _WimaxAreaId_bsID_LSB._const_sz = ASN1Set(rv=[24], rr=[], ev=None, er=[])
    WimaxAreaId._cont = ASN1Dict([
        ('bsID-MSB', _WimaxAreaId_bsID_MSB),
        ('bsID-LSB', _WimaxAreaId_bsID_LSB),
        ])
    WimaxAreaId._ext = None
    
    #-----< AreaIdSetType >-----#
    AreaIdSetType = ENUM(name='AreaIdSetType', mode=MODE_TYPE)
    AreaIdSetType._cont = ASN1Dict([('border', 0), ('within', 1)])
    AreaIdSetType._ext = []
    
    #-----< GeoAreaMappingList >-----#
    GeoAreaMappingList = SEQ_OF(name='GeoAreaMappingList', mode=MODE_TYPE)
    _GeoAreaMappingList__item_ = INT(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'GeoAreaIndex')))
    GeoAreaMappingList._cont = _GeoAreaMappingList__item_
    GeoAreaMappingList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< GeoAreaIndex >-----#
    GeoAreaIndex = INT(name='GeoAreaIndex', mode=MODE_TYPE)
    GeoAreaIndex._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    
    #-----< maxNumGeoArea >-----#
    maxNumGeoArea = INT(name='maxNumGeoArea', mode=MODE_VALUE)
    maxNumGeoArea._val = 32
    
    #-----< maxAreaId >-----#
    maxAreaId = INT(name='maxAreaId', mode=MODE_VALUE)
    maxAreaId._val = 256
    
    #-----< maxAreaIdList >-----#
    maxAreaIdList = INT(name='maxAreaIdList', mode=MODE_VALUE)
    maxAreaIdList._val = 32
    
    _all_ = [
        _Ver2_SUPLTRIGGEREDSTART_sETCapabilities,
        _Ver2_SUPLTRIGGEREDSTART_locationId,
        _Ver2_SUPLTRIGGEREDSTART_ver,
        _Ver2_SUPLTRIGGEREDSTART_qoP,
        _Ver2_SUPLTRIGGEREDSTART_multipleLocationIds,
        _Ver2_SUPLTRIGGEREDSTART_thirdParty,
        _Ver2_SUPLTRIGGEREDSTART_applicationID,
        _Ver2_SUPLTRIGGEREDSTART_triggerType,
        _Ver2_SUPLTRIGGEREDSTART_triggerParams,
        _Ver2_SUPLTRIGGEREDSTART_position,
        _Ver2_SUPLTRIGGEREDSTART_reportingCap,
        _Ver2_SUPLTRIGGEREDSTART_causeCode,
        Ver2_SUPLTRIGGEREDSTART,
        TriggerType,
        _TriggerParams_periodicParams,
        _TriggerParams_areaEventParams,
        TriggerParams,
        _PeriodicParams_numberOfFixes,
        _PeriodicParams_intervalBetweenFixes,
        _PeriodicParams_startTime,
        PeriodicParams,
        _AreaEventParams_areaEventType,
        _AreaEventParams_locationEstimate,
        _AreaEventParams_repeatedReportingParams,
        _AreaEventParams_startTime,
        _AreaEventParams_stopTime,
        _AreaEventParams_geographicTargetAreaList,
        __AreaEventParams_areaIdLists__item_,
        _AreaEventParams_areaIdLists,
        AreaEventParams,
        AreaEventType,
        _RepeatedReportingParams_minimumIntervalTime,
        _RepeatedReportingParams_maximumNumberOfReports,
        RepeatedReportingParams,
        _GeographicTargetAreaList__item_,
        GeographicTargetAreaList,
        _GeographicTargetArea_circularArea,
        _GeographicTargetArea_ellipticalArea,
        _GeographicTargetArea_polygonArea,
        GeographicTargetArea,
        _AreaIdList_areaIdSet,
        _AreaIdList_areaIdSetType,
        _AreaIdList_geoAreaMappingList,
        AreaIdList,
        _AreaIdSet__item_,
        AreaIdSet,
        _AreaId_gSMAreaId,
        _AreaId_wCDMAAreaId,
        _AreaId_cDMAAreaId,
        _AreaId_hRPDAreaId,
        _AreaId_uMBAreaId,
        _AreaId_lTEAreaId,
        _AreaId_wLANAreaId,
        _AreaId_wiMAXAreaId,
        AreaId,
        _GSMAreaId_refMCC,
        _GSMAreaId_refMNC,
        _GSMAreaId_refLAC,
        _GSMAreaId_refCI,
        GSMAreaId,
        _WCDMAAreaId_refMCC,
        _WCDMAAreaId_refMNC,
        _WCDMAAreaId_refLAC,
        _WCDMAAreaId_refUC,
        WCDMAAreaId,
        _CDMAAreaId_refSID,
        _CDMAAreaId_refNID,
        _CDMAAreaId_refBASEID,
        CDMAAreaId,
        _HRPDAreaId_refSECTORID,
        HRPDAreaId,
        _UMBAreaId_refMCC,
        _UMBAreaId_refMNC,
        _UMBAreaId_refSECTORID,
        UMBAreaId,
        _LTEAreaId_refMCC,
        _LTEAreaId_refMNC,
        _LTEAreaId_refCI,
        LTEAreaId,
        _WLANAreaId_apMACAddress,
        WLANAreaId,
        _WimaxAreaId_bsID_MSB,
        _WimaxAreaId_bsID_LSB,
        WimaxAreaId,
        AreaIdSetType,
        _GeoAreaMappingList__item_,
        GeoAreaMappingList,
        GeoAreaIndex,
        maxNumGeoArea,
        maxAreaId,
        maxAreaIdList,
    ]

class SUPL_TRIGGERED_RESPONSE:

    _name_  = 'SUPL-TRIGGERED-RESPONSE'
    _oid_   = []
    
    _obj_ = [
        'Ver2-SUPLTRIGGEREDRESPONSE',
        'ReportingMode',
        'RepModee',
        'BatchRepConditions',
        'BatchRepType',
        ]
    _type_ = [
        'Ver2-SUPLTRIGGEREDRESPONSE',
        'ReportingMode',
        'RepModee',
        'BatchRepConditions',
        'BatchRepType',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Ver2-SUPLTRIGGEREDRESPONSE >-----#
    Ver2_SUPLTRIGGEREDRESPONSE = SEQ(name='Ver2-SUPLTRIGGEREDRESPONSE', mode=MODE_TYPE)
    _Ver2_SUPLTRIGGEREDRESPONSE_posMethod = ENUM(name='posMethod', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PosMethod')))
    _Ver2_SUPLTRIGGEREDRESPONSE_triggerParams = CHOICE(name='triggerParams', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'TriggerParams')), opt=True)
    _Ver2_SUPLTRIGGEREDRESPONSE_sLPAddress = CHOICE(name='sLPAddress', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'SLPAddress')), opt=True)
    _Ver2_SUPLTRIGGEREDRESPONSE_supportedNetworkInformation = SEQ(name='supportedNetworkInformation', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SupportedNetworkInformation')), opt=True)
    _Ver2_SUPLTRIGGEREDRESPONSE_reportingMode = SEQ(name='reportingMode', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-RESPONSE', 'ReportingMode')), opt=True)
    _Ver2_SUPLTRIGGEREDRESPONSE_sPCSETKey = BIT_STR(name='sPCSETKey', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SPCSETKey')), opt=True)
    _Ver2_SUPLTRIGGEREDRESPONSE_spctid = SEQ(name='spctid', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SPCTID')), opt=True)
    _Ver2_SUPLTRIGGEREDRESPONSE_sPCSETKeylifetime = INT(name='sPCSETKeylifetime', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SPCSETKeylifetime')), opt=True)
    _Ver2_SUPLTRIGGEREDRESPONSE_gnssPosTechnology = SEQ(name='gnssPosTechnology', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'GNSSPosTechnology')), opt=True)
    Ver2_SUPLTRIGGEREDRESPONSE._cont = ASN1Dict([
        ('posMethod', _Ver2_SUPLTRIGGEREDRESPONSE_posMethod),
        ('triggerParams', _Ver2_SUPLTRIGGEREDRESPONSE_triggerParams),
        ('sLPAddress', _Ver2_SUPLTRIGGEREDRESPONSE_sLPAddress),
        ('supportedNetworkInformation', _Ver2_SUPLTRIGGEREDRESPONSE_supportedNetworkInformation),
        ('reportingMode', _Ver2_SUPLTRIGGEREDRESPONSE_reportingMode),
        ('sPCSETKey', _Ver2_SUPLTRIGGEREDRESPONSE_sPCSETKey),
        ('spctid', _Ver2_SUPLTRIGGEREDRESPONSE_spctid),
        ('sPCSETKeylifetime', _Ver2_SUPLTRIGGEREDRESPONSE_sPCSETKeylifetime),
        ('gnssPosTechnology', _Ver2_SUPLTRIGGEREDRESPONSE_gnssPosTechnology),
        ])
    Ver2_SUPLTRIGGEREDRESPONSE._ext = []
    
    #-----< ReportingMode >-----#
    ReportingMode = SEQ(name='ReportingMode', mode=MODE_TYPE)
    _ReportingMode_repMode = ENUM(name='repMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-RESPONSE', 'RepModee')))
    _ReportingMode_batchRepConditions = CHOICE(name='batchRepConditions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-RESPONSE', 'BatchRepConditions')), opt=True)
    _ReportingMode_batchRepType = SEQ(name='batchRepType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-RESPONSE', 'BatchRepType')), opt=True)
    ReportingMode._cont = ASN1Dict([
        ('repMode', _ReportingMode_repMode),
        ('batchRepConditions', _ReportingMode_batchRepConditions),
        ('batchRepType', _ReportingMode_batchRepType),
        ])
    ReportingMode._ext = []
    
    #-----< RepModee >-----#
    RepModee = ENUM(name='RepModee', mode=MODE_TYPE)
    RepModee._cont = ASN1Dict([('realtime', 1), ('quasirealtime', 2), ('batch', 3)])
    RepModee._ext = []
    
    #-----< BatchRepConditions >-----#
    BatchRepConditions = CHOICE(name='BatchRepConditions', mode=MODE_TYPE)
    _BatchRepConditions_num_interval = INT(name='num-interval', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BatchRepConditions_num_interval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    _BatchRepConditions_num_minutes = INT(name='num-minutes', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BatchRepConditions_num_minutes._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=2048)], ev=None, er=[])
    _BatchRepConditions_endofsession = NULL(name='endofsession', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    BatchRepConditions._cont = ASN1Dict([
        ('num-interval', _BatchRepConditions_num_interval),
        ('num-minutes', _BatchRepConditions_num_minutes),
        ('endofsession', _BatchRepConditions_endofsession),
        ])
    BatchRepConditions._ext = []
    
    #-----< BatchRepType >-----#
    BatchRepType = SEQ(name='BatchRepType', mode=MODE_TYPE)
    _BatchRepType_reportPosition = BOOL(name='reportPosition', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BatchRepType_reportMeasurements = BOOL(name='reportMeasurements', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BatchRepType_intermediateReports = BOOL(name='intermediateReports', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BatchRepType_discardOldest = BOOL(name='discardOldest', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    BatchRepType._cont = ASN1Dict([
        ('reportPosition', _BatchRepType_reportPosition),
        ('reportMeasurements', _BatchRepType_reportMeasurements),
        ('intermediateReports', _BatchRepType_intermediateReports),
        ('discardOldest', _BatchRepType_discardOldest),
        ])
    BatchRepType._ext = []
    
    _all_ = [
        _Ver2_SUPLTRIGGEREDRESPONSE_posMethod,
        _Ver2_SUPLTRIGGEREDRESPONSE_triggerParams,
        _Ver2_SUPLTRIGGEREDRESPONSE_sLPAddress,
        _Ver2_SUPLTRIGGEREDRESPONSE_supportedNetworkInformation,
        _Ver2_SUPLTRIGGEREDRESPONSE_reportingMode,
        _Ver2_SUPLTRIGGEREDRESPONSE_sPCSETKey,
        _Ver2_SUPLTRIGGEREDRESPONSE_spctid,
        _Ver2_SUPLTRIGGEREDRESPONSE_sPCSETKeylifetime,
        _Ver2_SUPLTRIGGEREDRESPONSE_gnssPosTechnology,
        Ver2_SUPLTRIGGEREDRESPONSE,
        _ReportingMode_repMode,
        _ReportingMode_batchRepConditions,
        _ReportingMode_batchRepType,
        ReportingMode,
        RepModee,
        _BatchRepConditions_num_interval,
        _BatchRepConditions_num_minutes,
        _BatchRepConditions_endofsession,
        BatchRepConditions,
        _BatchRepType_reportPosition,
        _BatchRepType_reportMeasurements,
        _BatchRepType_intermediateReports,
        _BatchRepType_discardOldest,
        BatchRepType,
    ]

class SUPL_REPORT:

    _name_  = 'SUPL-REPORT'
    _oid_   = []
    
    _obj_ = [
        'Ver2-SUPLREPORT',
        'SessionList',
        'SessionInformation',
        'maxnumSessions',
        'ReportDataList',
        'ReportData',
        'PositionData',
        'GANSSsignalsInfo',
        'GANSSSignalsDescription',
        'ResultCode',
        'TimeStamp',
        ]
    _type_ = [
        'Ver2-SUPLREPORT',
        'SessionList',
        'SessionInformation',
        'ReportDataList',
        'ReportData',
        'PositionData',
        'GANSSsignalsInfo',
        'GANSSSignalsDescription',
        'ResultCode',
        'TimeStamp',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxnumSessions',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Ver2-SUPLREPORT >-----#
    Ver2_SUPLREPORT = SEQ(name='Ver2-SUPLREPORT', mode=MODE_TYPE)
    _Ver2_SUPLREPORT_sessionList = SEQ_OF(name='sessionList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-REPORT', 'SessionList')), opt=True)
    _Ver2_SUPLREPORT_sETCapabilities = SEQ(name='sETCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-START', 'SETCapabilities')), opt=True)
    _Ver2_SUPLREPORT_reportDataList = SEQ_OF(name='reportDataList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-REPORT', 'ReportDataList')), opt=True)
    _Ver2_SUPLREPORT_ver = BIT_STR(name='ver', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Ver')), opt=True)
    _Ver2_SUPLREPORT_moreComponents = NULL(name='moreComponents', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Ver2_SUPLREPORT._cont = ASN1Dict([
        ('sessionList', _Ver2_SUPLREPORT_sessionList),
        ('sETCapabilities', _Ver2_SUPLREPORT_sETCapabilities),
        ('reportDataList', _Ver2_SUPLREPORT_reportDataList),
        ('ver', _Ver2_SUPLREPORT_ver),
        ('moreComponents', _Ver2_SUPLREPORT_moreComponents),
        ])
    Ver2_SUPLREPORT._ext = []
    
    #-----< SessionList >-----#
    SessionList = SEQ_OF(name='SessionList', mode=MODE_TYPE)
    _SessionList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SUPL-REPORT', 'SessionInformation')))
    SessionList._cont = _SessionList__item_
    SessionList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=64)], ev=None, er=[])
    
    #-----< SessionInformation >-----#
    SessionInformation = SEQ(name='SessionInformation', mode=MODE_TYPE)
    _SessionInformation_sessionID = SEQ(name='sessionID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'SessionID')))
    SessionInformation._cont = ASN1Dict([
        ('sessionID', _SessionInformation_sessionID),
        ])
    SessionInformation._ext = []
    
    #-----< maxnumSessions >-----#
    maxnumSessions = INT(name='maxnumSessions', mode=MODE_VALUE)
    maxnumSessions._val = 64
    
    #-----< ReportDataList >-----#
    ReportDataList = SEQ_OF(name='ReportDataList', mode=MODE_TYPE)
    _ReportDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SUPL-REPORT', 'ReportData')))
    ReportDataList._cont = _ReportDataList__item_
    ReportDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=1024)], ev=None, er=[])
    
    #-----< ReportData >-----#
    ReportData = SEQ(name='ReportData', mode=MODE_TYPE)
    _ReportData_positionData = SEQ(name='positionData', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-REPORT', 'PositionData')), opt=True)
    _ReportData_multipleLocationIds = SEQ_OF(name='multipleLocationIds', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'MultipleLocationIds')), opt=True)
    _ReportData_resultCode = ENUM(name='resultCode', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-REPORT', 'ResultCode')), opt=True)
    _ReportData_timestamp = CHOICE(name='timestamp', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('SUPL-REPORT', 'TimeStamp')), opt=True)
    ReportData._cont = ASN1Dict([
        ('positionData', _ReportData_positionData),
        ('multipleLocationIds', _ReportData_multipleLocationIds),
        ('resultCode', _ReportData_resultCode),
        ('timestamp', _ReportData_timestamp),
        ])
    ReportData._ext = []
    
    #-----< PositionData >-----#
    PositionData = SEQ(name='PositionData', mode=MODE_TYPE)
    _PositionData_position = SEQ(name='position', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Position')))
    _PositionData_posMethod = ENUM(name='posMethod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'PosMethod')), opt=True)
    _PositionData_gnssPosTechnology = SEQ(name='gnssPosTechnology', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'GNSSPosTechnology')), opt=True)
    _PositionData_ganssSignalsInfo = SEQ_OF(name='ganssSignalsInfo', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-REPORT', 'GANSSsignalsInfo')), opt=True)
    PositionData._cont = ASN1Dict([
        ('position', _PositionData_position),
        ('posMethod', _PositionData_posMethod),
        ('gnssPosTechnology', _PositionData_gnssPosTechnology),
        ('ganssSignalsInfo', _PositionData_ganssSignalsInfo),
        ])
    PositionData._ext = []
    
    #-----< GANSSsignalsInfo >-----#
    GANSSsignalsInfo = SEQ_OF(name='GANSSsignalsInfo', mode=MODE_TYPE)
    _GANSSsignalsInfo__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('SUPL-REPORT', 'GANSSSignalsDescription')))
    GANSSsignalsInfo._cont = _GANSSsignalsInfo__item_
    GANSSsignalsInfo._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GANSSSignalsDescription >-----#
    GANSSSignalsDescription = SEQ(name='GANSSSignalsDescription', mode=MODE_TYPE)
    _GANSSSignalsDescription_ganssId = INT(name='ganssId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSSSignalsDescription_ganssId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _GANSSSignalsDescription_gANSSSignals = BIT_STR(name='gANSSSignals', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'GANSSSignals')))
    GANSSSignalsDescription._cont = ASN1Dict([
        ('ganssId', _GANSSSignalsDescription_ganssId),
        ('gANSSSignals', _GANSSSignalsDescription_gANSSSignals),
        ])
    GANSSSignalsDescription._ext = []
    
    #-----< ResultCode >-----#
    ResultCode = ENUM(name='ResultCode', mode=MODE_TYPE)
    ResultCode._cont = ASN1Dict([('outofradiocoverage', 1), ('noposition', 2), ('nomeasurement', 3), ('nopositionnomeasurement', 4), ('outofmemory', 5), ('outofmemoryintermediatereporting', 6), ('other', 7)])
    ResultCode._ext = []
    
    #-----< TimeStamp >-----#
    TimeStamp = CHOICE(name='TimeStamp', mode=MODE_TYPE)
    _TimeStamp_absoluteTime = TIME_UTC(name='absoluteTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStamp_relativeTime = INT(name='relativeTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeStamp_relativeTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=31536000)], ev=None, er=[])
    TimeStamp._cont = ASN1Dict([
        ('absoluteTime', _TimeStamp_absoluteTime),
        ('relativeTime', _TimeStamp_relativeTime),
        ])
    TimeStamp._ext = None
    
    _all_ = [
        _Ver2_SUPLREPORT_sessionList,
        _Ver2_SUPLREPORT_sETCapabilities,
        _Ver2_SUPLREPORT_reportDataList,
        _Ver2_SUPLREPORT_ver,
        _Ver2_SUPLREPORT_moreComponents,
        Ver2_SUPLREPORT,
        _SessionList__item_,
        SessionList,
        _SessionInformation_sessionID,
        SessionInformation,
        maxnumSessions,
        _ReportDataList__item_,
        ReportDataList,
        _ReportData_positionData,
        _ReportData_multipleLocationIds,
        _ReportData_resultCode,
        _ReportData_timestamp,
        ReportData,
        _PositionData_position,
        _PositionData_posMethod,
        _PositionData_gnssPosTechnology,
        _PositionData_ganssSignalsInfo,
        PositionData,
        _GANSSsignalsInfo__item_,
        GANSSsignalsInfo,
        _GANSSSignalsDescription_ganssId,
        _GANSSSignalsDescription_gANSSSignals,
        GANSSSignalsDescription,
        ResultCode,
        _TimeStamp_absoluteTime,
        _TimeStamp_relativeTime,
        TimeStamp,
    ]

class SUPL_TRIGGERED_STOP:

    _name_  = 'SUPL-TRIGGERED-STOP'
    _oid_   = []
    
    _obj_ = [
        'Ver2-SUPLTRIGGEREDSTOP',
        ]
    _type_ = [
        'Ver2-SUPLTRIGGEREDSTOP',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Ver2-SUPLTRIGGEREDSTOP >-----#
    Ver2_SUPLTRIGGEREDSTOP = SEQ(name='Ver2-SUPLTRIGGEREDSTOP', mode=MODE_TYPE)
    _Ver2_SUPLTRIGGEREDSTOP_statusCode = ENUM(name='statusCode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'StatusCode')), opt=True)
    Ver2_SUPLTRIGGEREDSTOP._cont = ASN1Dict([
        ('statusCode', _Ver2_SUPLTRIGGEREDSTOP_statusCode),
        ])
    Ver2_SUPLTRIGGEREDSTOP._ext = []
    
    _all_ = [
        _Ver2_SUPLTRIGGEREDSTOP_statusCode,
        Ver2_SUPLTRIGGEREDSTOP,
    ]

class ULP_Version_2_message_extensions:

    _name_  = 'ULP-Version-2-message-extensions'
    _oid_   = []
    
    _obj_ = [
        'Ver2-SUPL-INIT-extension',
        'NotificationMode',
        'HistoricReporting',
        'AllowedReportingType',
        'ReportingCriteria',
        'TimeWindow',
        'ProtectionLevel',
        'ProtLevel',
        'BasicProtectionParams',
        'Ver2-SUPL-START-extension',
        'Ver2-SUPL-RESPONSE-extension',
        'Ver2-SUPL-POS-INIT-extension',
        'Ver2-SUPL-POS-extension',
        'Ver2-SUPL-END-extension',
        ]
    _type_ = [
        'Ver2-SUPL-INIT-extension',
        'NotificationMode',
        'HistoricReporting',
        'AllowedReportingType',
        'ReportingCriteria',
        'TimeWindow',
        'ProtectionLevel',
        'ProtLevel',
        'BasicProtectionParams',
        'Ver2-SUPL-START-extension',
        'Ver2-SUPL-RESPONSE-extension',
        'Ver2-SUPL-POS-INIT-extension',
        'Ver2-SUPL-POS-extension',
        'Ver2-SUPL-END-extension',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Ver2-SUPL-INIT-extension >-----#
    Ver2_SUPL_INIT_extension = SEQ(name='Ver2-SUPL-INIT-extension', mode=MODE_TYPE)
    _Ver2_SUPL_INIT_extension_notificationMode = ENUM(name='notificationMode', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'NotificationMode')), opt=True)
    _Ver2_SUPL_INIT_extension_supportedNetworkInformation = SEQ(name='supportedNetworkInformation', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SupportedNetworkInformation')), opt=True)
    _Ver2_SUPL_INIT_extension_triggerType = ENUM(name='triggerType', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'TriggerType')), opt=True)
    _Ver2_SUPL_INIT_extension_e_SLPAddress = CHOICE(name='e-SLPAddress', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP-Components', 'SLPAddress')), opt=True)
    _Ver2_SUPL_INIT_extension_historicReporting = SEQ(name='historicReporting', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'HistoricReporting')), opt=True)
    _Ver2_SUPL_INIT_extension_protectionLevel = SEQ(name='protectionLevel', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'ProtectionLevel')), opt=True)
    _Ver2_SUPL_INIT_extension_gnssPosTechnology = SEQ(name='gnssPosTechnology', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'GNSSPosTechnology')), opt=True)
    _Ver2_SUPL_INIT_extension_minimumMajorVersion = INT(name='minimumMajorVersion', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Ver2_SUPL_INIT_extension_minimumMajorVersion._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    Ver2_SUPL_INIT_extension._cont = ASN1Dict([
        ('notificationMode', _Ver2_SUPL_INIT_extension_notificationMode),
        ('supportedNetworkInformation', _Ver2_SUPL_INIT_extension_supportedNetworkInformation),
        ('triggerType', _Ver2_SUPL_INIT_extension_triggerType),
        ('e-SLPAddress', _Ver2_SUPL_INIT_extension_e_SLPAddress),
        ('historicReporting', _Ver2_SUPL_INIT_extension_historicReporting),
        ('protectionLevel', _Ver2_SUPL_INIT_extension_protectionLevel),
        ('gnssPosTechnology', _Ver2_SUPL_INIT_extension_gnssPosTechnology),
        ('minimumMajorVersion', _Ver2_SUPL_INIT_extension_minimumMajorVersion),
        ])
    Ver2_SUPL_INIT_extension._ext = []
    
    #-----< NotificationMode >-----#
    NotificationMode = ENUM(name='NotificationMode', mode=MODE_TYPE)
    NotificationMode._cont = ASN1Dict([('normal', 0), ('basedOnLocation', 1)])
    NotificationMode._ext = []
    
    #-----< HistoricReporting >-----#
    HistoricReporting = SEQ(name='HistoricReporting', mode=MODE_TYPE)
    _HistoricReporting_allowedReportingType = ENUM(name='allowedReportingType', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'AllowedReportingType')))
    _HistoricReporting_reportingCriteria = SEQ(name='reportingCriteria', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'ReportingCriteria')), opt=True)
    HistoricReporting._cont = ASN1Dict([
        ('allowedReportingType', _HistoricReporting_allowedReportingType),
        ('reportingCriteria', _HistoricReporting_reportingCriteria),
        ])
    HistoricReporting._ext = []
    
    #-----< AllowedReportingType >-----#
    AllowedReportingType = ENUM(name='AllowedReportingType', mode=MODE_TYPE)
    AllowedReportingType._cont = ASN1Dict([('positionsOnly', 0), ('measurementsOnly', 1), ('positionsAndMeasurements', 2)])
    AllowedReportingType._ext = []
    
    #-----< ReportingCriteria >-----#
    ReportingCriteria = SEQ(name='ReportingCriteria', mode=MODE_TYPE)
    _ReportingCriteria_timeWindow = SEQ(name='timeWindow', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'TimeWindow')), opt=True)
    _ReportingCriteria_maxNumberofReports = INT(name='maxNumberofReports', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportingCriteria_maxNumberofReports._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=65536)], ev=None, er=[])
    _ReportingCriteria_minTimeInterval = INT(name='minTimeInterval', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _ReportingCriteria_minTimeInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=86400)], ev=None, er=[])
    ReportingCriteria._cont = ASN1Dict([
        ('timeWindow', _ReportingCriteria_timeWindow),
        ('maxNumberofReports', _ReportingCriteria_maxNumberofReports),
        ('minTimeInterval', _ReportingCriteria_minTimeInterval),
        ])
    ReportingCriteria._ext = []
    
    #-----< TimeWindow >-----#
    TimeWindow = SEQ(name='TimeWindow', mode=MODE_TYPE)
    _TimeWindow_startTime = INT(name='startTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeWindow_startTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-525600, ub=-1)], ev=None, er=[])
    _TimeWindow_stopTime = INT(name='stopTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _TimeWindow_stopTime._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=-525599, ub=0)], ev=None, er=[])
    TimeWindow._cont = ASN1Dict([
        ('startTime', _TimeWindow_startTime),
        ('stopTime', _TimeWindow_stopTime),
        ])
    TimeWindow._ext = None
    
    #-----< ProtectionLevel >-----#
    ProtectionLevel = SEQ(name='ProtectionLevel', mode=MODE_TYPE)
    _ProtectionLevel_protlevel = ENUM(name='protlevel', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'ProtLevel')))
    _ProtectionLevel_basicProtectionParams = SEQ(name='basicProtectionParams', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-message-extensions', 'BasicProtectionParams')), opt=True)
    ProtectionLevel._cont = ASN1Dict([
        ('protlevel', _ProtectionLevel_protlevel),
        ('basicProtectionParams', _ProtectionLevel_basicProtectionParams),
        ])
    ProtectionLevel._ext = []
    
    #-----< ProtLevel >-----#
    ProtLevel = ENUM(name='ProtLevel', mode=MODE_TYPE)
    ProtLevel._cont = ASN1Dict([('nullProtection', 0), ('basicProtection', 1)])
    ProtLevel._ext = []
    
    #-----< BasicProtectionParams >-----#
    BasicProtectionParams = SEQ(name='BasicProtectionParams', mode=MODE_TYPE)
    _BasicProtectionParams_keyIdentifier = OCT_STR(name='keyIdentifier', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BasicProtectionParams_keyIdentifier._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    _BasicProtectionParams_basicReplayCounter = INT(name='basicReplayCounter', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BasicProtectionParams_basicReplayCounter._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _BasicProtectionParams_basicMAC = BIT_STR(name='basicMAC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _BasicProtectionParams_basicMAC._const_sz = ASN1Set(rv=[32], rr=[], ev=None, er=[])
    BasicProtectionParams._cont = ASN1Dict([
        ('keyIdentifier', _BasicProtectionParams_keyIdentifier),
        ('basicReplayCounter', _BasicProtectionParams_basicReplayCounter),
        ('basicMAC', _BasicProtectionParams_basicMAC),
        ])
    BasicProtectionParams._ext = []
    
    #-----< Ver2-SUPL-START-extension >-----#
    Ver2_SUPL_START_extension = SEQ(name='Ver2-SUPL-START-extension', mode=MODE_TYPE)
    _Ver2_SUPL_START_extension_multipleLocationIds = SEQ_OF(name='multipleLocationIds', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'MultipleLocationIds')), opt=True)
    _Ver2_SUPL_START_extension_thirdParty = SEQ_OF(name='thirdParty', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'ThirdParty')), opt=True)
    _Ver2_SUPL_START_extension_applicationID = SEQ(name='applicationID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'ApplicationID')), opt=True)
    _Ver2_SUPL_START_extension_position = SEQ(name='position', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Position')), opt=True)
    Ver2_SUPL_START_extension._cont = ASN1Dict([
        ('multipleLocationIds', _Ver2_SUPL_START_extension_multipleLocationIds),
        ('thirdParty', _Ver2_SUPL_START_extension_thirdParty),
        ('applicationID', _Ver2_SUPL_START_extension_applicationID),
        ('position', _Ver2_SUPL_START_extension_position),
        ])
    Ver2_SUPL_START_extension._ext = []
    
    #-----< Ver2-SUPL-RESPONSE-extension >-----#
    Ver2_SUPL_RESPONSE_extension = SEQ(name='Ver2-SUPL-RESPONSE-extension', mode=MODE_TYPE)
    _Ver2_SUPL_RESPONSE_extension_supportedNetworkInformation = SEQ(name='supportedNetworkInformation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SupportedNetworkInformation')), opt=True)
    _Ver2_SUPL_RESPONSE_extension_sPCSETKey = BIT_STR(name='sPCSETKey', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SPCSETKey')), opt=True)
    _Ver2_SUPL_RESPONSE_extension_spctid = SEQ(name='spctid', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SPCTID')), opt=True)
    _Ver2_SUPL_RESPONSE_extension_sPCSETKeylifetime = INT(name='sPCSETKeylifetime', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'SPCSETKeylifetime')), opt=True)
    _Ver2_SUPL_RESPONSE_extension_initialApproximateposition = SEQ(name='initialApproximateposition', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Position')), opt=True)
    _Ver2_SUPL_RESPONSE_extension_gnssPosTechnology = SEQ(name='gnssPosTechnology', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'GNSSPosTechnology')), opt=True)
    Ver2_SUPL_RESPONSE_extension._cont = ASN1Dict([
        ('supportedNetworkInformation', _Ver2_SUPL_RESPONSE_extension_supportedNetworkInformation),
        ('sPCSETKey', _Ver2_SUPL_RESPONSE_extension_sPCSETKey),
        ('spctid', _Ver2_SUPL_RESPONSE_extension_spctid),
        ('sPCSETKeylifetime', _Ver2_SUPL_RESPONSE_extension_sPCSETKeylifetime),
        ('initialApproximateposition', _Ver2_SUPL_RESPONSE_extension_initialApproximateposition),
        ('gnssPosTechnology', _Ver2_SUPL_RESPONSE_extension_gnssPosTechnology),
        ])
    Ver2_SUPL_RESPONSE_extension._ext = []
    
    #-----< Ver2-SUPL-POS-INIT-extension >-----#
    Ver2_SUPL_POS_INIT_extension = SEQ(name='Ver2-SUPL-POS-INIT-extension', mode=MODE_TYPE)
    _Ver2_SUPL_POS_INIT_extension_multipleLocationIds = SEQ_OF(name='multipleLocationIds', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'MultipleLocationIds')), opt=True)
    _Ver2_SUPL_POS_INIT_extension_utran_GPSReferenceTimeResult = SEQ(name='utran-GPSReferenceTimeResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UTRAN-GPSReferenceTimeResult')), opt=True)
    _Ver2_SUPL_POS_INIT_extension_utran_GANSSReferenceTimeResult = SEQ(name='utran-GANSSReferenceTimeResult', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UTRAN-GANSSReferenceTimeResult')), opt=True)
    Ver2_SUPL_POS_INIT_extension._cont = ASN1Dict([
        ('multipleLocationIds', _Ver2_SUPL_POS_INIT_extension_multipleLocationIds),
        ('utran-GPSReferenceTimeResult', _Ver2_SUPL_POS_INIT_extension_utran_GPSReferenceTimeResult),
        ('utran-GANSSReferenceTimeResult', _Ver2_SUPL_POS_INIT_extension_utran_GANSSReferenceTimeResult),
        ])
    Ver2_SUPL_POS_INIT_extension._ext = []
    
    #-----< Ver2-SUPL-POS-extension >-----#
    Ver2_SUPL_POS_extension = SEQ(name='Ver2-SUPL-POS-extension', mode=MODE_TYPE)
    _Ver2_SUPL_POS_extension_utran_GPSReferenceTimeAssistance = SEQ(name='utran-GPSReferenceTimeAssistance', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UTRAN-GPSReferenceTimeAssistance')), opt=True)
    _Ver2_SUPL_POS_extension_utran_GPSReferenceTimeResult = SEQ(name='utran-GPSReferenceTimeResult', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UTRAN-GPSReferenceTimeResult')), opt=True)
    _Ver2_SUPL_POS_extension_utran_GANSSReferenceTimeAssistance = SEQ(name='utran-GANSSReferenceTimeAssistance', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UTRAN-GANSSReferenceTimeAssistance')), opt=True)
    _Ver2_SUPL_POS_extension_utran_GANSSReferenceTimeResult = SEQ(name='utran-GANSSReferenceTimeResult', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'UTRAN-GANSSReferenceTimeResult')), opt=True)
    Ver2_SUPL_POS_extension._cont = ASN1Dict([
        ('utran-GPSReferenceTimeAssistance', _Ver2_SUPL_POS_extension_utran_GPSReferenceTimeAssistance),
        ('utran-GPSReferenceTimeResult', _Ver2_SUPL_POS_extension_utran_GPSReferenceTimeResult),
        ('utran-GANSSReferenceTimeAssistance', _Ver2_SUPL_POS_extension_utran_GANSSReferenceTimeAssistance),
        ('utran-GANSSReferenceTimeResult', _Ver2_SUPL_POS_extension_utran_GANSSReferenceTimeResult),
        ])
    Ver2_SUPL_POS_extension._ext = []
    
    #-----< Ver2-SUPL-END-extension >-----#
    Ver2_SUPL_END_extension = SEQ(name='Ver2-SUPL-END-extension', mode=MODE_TYPE)
    _Ver2_SUPL_END_extension_sETCapabilities = SEQ(name='sETCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-START', 'SETCapabilities')), opt=True)
    Ver2_SUPL_END_extension._cont = ASN1Dict([
        ('sETCapabilities', _Ver2_SUPL_END_extension_sETCapabilities),
        ])
    Ver2_SUPL_END_extension._ext = []
    
    _all_ = [
        _Ver2_SUPL_INIT_extension_notificationMode,
        _Ver2_SUPL_INIT_extension_supportedNetworkInformation,
        _Ver2_SUPL_INIT_extension_triggerType,
        _Ver2_SUPL_INIT_extension_e_SLPAddress,
        _Ver2_SUPL_INIT_extension_historicReporting,
        _Ver2_SUPL_INIT_extension_protectionLevel,
        _Ver2_SUPL_INIT_extension_gnssPosTechnology,
        _Ver2_SUPL_INIT_extension_minimumMajorVersion,
        Ver2_SUPL_INIT_extension,
        NotificationMode,
        _HistoricReporting_allowedReportingType,
        _HistoricReporting_reportingCriteria,
        HistoricReporting,
        AllowedReportingType,
        _ReportingCriteria_timeWindow,
        _ReportingCriteria_maxNumberofReports,
        _ReportingCriteria_minTimeInterval,
        ReportingCriteria,
        _TimeWindow_startTime,
        _TimeWindow_stopTime,
        TimeWindow,
        _ProtectionLevel_protlevel,
        _ProtectionLevel_basicProtectionParams,
        ProtectionLevel,
        ProtLevel,
        _BasicProtectionParams_keyIdentifier,
        _BasicProtectionParams_basicReplayCounter,
        _BasicProtectionParams_basicMAC,
        BasicProtectionParams,
        _Ver2_SUPL_START_extension_multipleLocationIds,
        _Ver2_SUPL_START_extension_thirdParty,
        _Ver2_SUPL_START_extension_applicationID,
        _Ver2_SUPL_START_extension_position,
        Ver2_SUPL_START_extension,
        _Ver2_SUPL_RESPONSE_extension_supportedNetworkInformation,
        _Ver2_SUPL_RESPONSE_extension_sPCSETKey,
        _Ver2_SUPL_RESPONSE_extension_spctid,
        _Ver2_SUPL_RESPONSE_extension_sPCSETKeylifetime,
        _Ver2_SUPL_RESPONSE_extension_initialApproximateposition,
        _Ver2_SUPL_RESPONSE_extension_gnssPosTechnology,
        Ver2_SUPL_RESPONSE_extension,
        _Ver2_SUPL_POS_INIT_extension_multipleLocationIds,
        _Ver2_SUPL_POS_INIT_extension_utran_GPSReferenceTimeResult,
        _Ver2_SUPL_POS_INIT_extension_utran_GANSSReferenceTimeResult,
        Ver2_SUPL_POS_INIT_extension,
        _Ver2_SUPL_POS_extension_utran_GPSReferenceTimeAssistance,
        _Ver2_SUPL_POS_extension_utran_GPSReferenceTimeResult,
        _Ver2_SUPL_POS_extension_utran_GANSSReferenceTimeAssistance,
        _Ver2_SUPL_POS_extension_utran_GANSSReferenceTimeResult,
        Ver2_SUPL_POS_extension,
        _Ver2_SUPL_END_extension_sETCapabilities,
        Ver2_SUPL_END_extension,
    ]

class ULP_Version_2_parameter_extensions:

    _name_  = 'ULP-Version-2-parameter-extensions'
    _oid_   = []
    
    _obj_ = [
        'Ver2-Notification-extension',
        'Ver2-SETCapabilities-extension',
        'ServiceCapabilities',
        'ServicesSupported',
        'EventTriggerCapabilities',
        'GeoAreaShapesSupported',
        'SessionCapabilities',
        'SupportedBearers',
        'Ver2-PosProtocol-extension',
        'PosProtocolVersion3GPP',
        'PosProtocolVersion3GPP2',
        'Supported3GPP2PosProtocolVersion',
        'PosProtocolVersionOMA',
        'Ver2-PosTechnology-extension',
        'GANSSPositionMethods',
        'GANSSPositionMethod',
        'GANSSPositioningMethodTypes',
        'Ver2-RequestedAssistData-extension',
        'GanssRequestedCommonAssistanceDataList',
        'GanssRequestedGenericAssistanceDataList',
        'GanssReqGenericData',
        'DGANSS-Sig-Id-Req',
        'BDS-Sig-Id-Req',
        'GanssNavigationModelData',
        'SatellitesListRelatedDataList',
        'SatellitesListRelatedData',
        'maxGANSS',
        'maxGANSSSat',
        'GanssDataBits',
        'ReqDataBitAssistanceList',
        'GanssAdditionalDataChoices',
        'ExtendedEphemeris',
        'ExtendedEphCheck',
        'GanssExtendedEphCheck',
        'GPSTime',
        'GANSSextEphTime',
        'Ver2-PosPayLoad-extension',
        ]
    _type_ = [
        'Ver2-Notification-extension',
        'Ver2-SETCapabilities-extension',
        'ServiceCapabilities',
        'ServicesSupported',
        'EventTriggerCapabilities',
        'GeoAreaShapesSupported',
        'SessionCapabilities',
        'SupportedBearers',
        'Ver2-PosProtocol-extension',
        'PosProtocolVersion3GPP',
        'PosProtocolVersion3GPP2',
        'Supported3GPP2PosProtocolVersion',
        'PosProtocolVersionOMA',
        'Ver2-PosTechnology-extension',
        'GANSSPositionMethods',
        'GANSSPositionMethod',
        'GANSSPositioningMethodTypes',
        'Ver2-RequestedAssistData-extension',
        'GanssRequestedCommonAssistanceDataList',
        'GanssRequestedGenericAssistanceDataList',
        'GanssReqGenericData',
        'DGANSS-Sig-Id-Req',
        'BDS-Sig-Id-Req',
        'GanssNavigationModelData',
        'SatellitesListRelatedDataList',
        'SatellitesListRelatedData',
        'GanssDataBits',
        'ReqDataBitAssistanceList',
        'GanssAdditionalDataChoices',
        'ExtendedEphemeris',
        'ExtendedEphCheck',
        'GanssExtendedEphCheck',
        'GPSTime',
        'GANSSextEphTime',
        'Ver2-PosPayLoad-extension',
        ]
    _set_ = [
        ]
    _val_ = [
        'maxGANSS',
        'maxGANSSSat',
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< Ver2-Notification-extension >-----#
    Ver2_Notification_extension = SEQ(name='Ver2-Notification-extension', mode=MODE_TYPE)
    _Ver2_Notification_extension_emergencyCallLocation = NULL(name='emergencyCallLocation', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    Ver2_Notification_extension._cont = ASN1Dict([
        ('emergencyCallLocation', _Ver2_Notification_extension_emergencyCallLocation),
        ])
    Ver2_Notification_extension._ext = []
    
    #-----< Ver2-SETCapabilities-extension >-----#
    Ver2_SETCapabilities_extension = SEQ(name='Ver2-SETCapabilities-extension', mode=MODE_TYPE)
    _Ver2_SETCapabilities_extension_serviceCapabilities = SEQ(name='serviceCapabilities', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'ServiceCapabilities')), opt=True)
    _Ver2_SETCapabilities_extension_supportedBearers = SEQ(name='supportedBearers', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'SupportedBearers')), opt=True)
    Ver2_SETCapabilities_extension._cont = ASN1Dict([
        ('serviceCapabilities', _Ver2_SETCapabilities_extension_serviceCapabilities),
        ('supportedBearers', _Ver2_SETCapabilities_extension_supportedBearers),
        ])
    Ver2_SETCapabilities_extension._ext = ['supportedBearers']
    
    #-----< ServiceCapabilities >-----#
    ServiceCapabilities = SEQ(name='ServiceCapabilities', mode=MODE_TYPE)
    _ServiceCapabilities_servicesSupported = SEQ(name='servicesSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'ServicesSupported')))
    _ServiceCapabilities_reportingCapabilities = SEQ(name='reportingCapabilities', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'ReportingCap')), opt=True)
    _ServiceCapabilities_eventTriggerCapabilities = SEQ(name='eventTriggerCapabilities', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'EventTriggerCapabilities')), opt=True)
    _ServiceCapabilities_sessionCapabilities = SEQ(name='sessionCapabilities', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'SessionCapabilities')))
    ServiceCapabilities._cont = ASN1Dict([
        ('servicesSupported', _ServiceCapabilities_servicesSupported),
        ('reportingCapabilities', _ServiceCapabilities_reportingCapabilities),
        ('eventTriggerCapabilities', _ServiceCapabilities_eventTriggerCapabilities),
        ('sessionCapabilities', _ServiceCapabilities_sessionCapabilities),
        ])
    ServiceCapabilities._ext = []
    
    #-----< ServicesSupported >-----#
    ServicesSupported = SEQ(name='ServicesSupported', mode=MODE_TYPE)
    _ServicesSupported_periodicTrigger = BOOL(name='periodicTrigger', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ServicesSupported_areaEventTrigger = BOOL(name='areaEventTrigger', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    ServicesSupported._cont = ASN1Dict([
        ('periodicTrigger', _ServicesSupported_periodicTrigger),
        ('areaEventTrigger', _ServicesSupported_areaEventTrigger),
        ])
    ServicesSupported._ext = []
    
    #-----< EventTriggerCapabilities >-----#
    EventTriggerCapabilities = SEQ(name='EventTriggerCapabilities', mode=MODE_TYPE)
    _EventTriggerCapabilities_geoAreaShapesSupported = SEQ(name='geoAreaShapesSupported', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GeoAreaShapesSupported')))
    _EventTriggerCapabilities_maxNumGeoAreaSupported = INT(name='maxNumGeoAreaSupported', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EventTriggerCapabilities_maxNumGeoAreaSupported._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _EventTriggerCapabilities_maxAreaIdListSupported = INT(name='maxAreaIdListSupported', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EventTriggerCapabilities_maxAreaIdListSupported._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    _EventTriggerCapabilities_maxAreaIdSupportedPerList = INT(name='maxAreaIdSupportedPerList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _EventTriggerCapabilities_maxAreaIdSupportedPerList._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=256)], ev=None, er=[])
    EventTriggerCapabilities._cont = ASN1Dict([
        ('geoAreaShapesSupported', _EventTriggerCapabilities_geoAreaShapesSupported),
        ('maxNumGeoAreaSupported', _EventTriggerCapabilities_maxNumGeoAreaSupported),
        ('maxAreaIdListSupported', _EventTriggerCapabilities_maxAreaIdListSupported),
        ('maxAreaIdSupportedPerList', _EventTriggerCapabilities_maxAreaIdSupportedPerList),
        ])
    EventTriggerCapabilities._ext = []
    
    #-----< GeoAreaShapesSupported >-----#
    GeoAreaShapesSupported = SEQ(name='GeoAreaShapesSupported', mode=MODE_TYPE)
    _GeoAreaShapesSupported_ellipticalArea = BOOL(name='ellipticalArea', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GeoAreaShapesSupported_polygonArea = BOOL(name='polygonArea', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GeoAreaShapesSupported._cont = ASN1Dict([
        ('ellipticalArea', _GeoAreaShapesSupported_ellipticalArea),
        ('polygonArea', _GeoAreaShapesSupported_polygonArea),
        ])
    GeoAreaShapesSupported._ext = []
    
    #-----< SessionCapabilities >-----#
    SessionCapabilities = SEQ(name='SessionCapabilities', mode=MODE_TYPE)
    _SessionCapabilities_maxNumberTotalSessions = INT(name='maxNumberTotalSessions', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SessionCapabilities_maxNumberTotalSessions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=128)], ev=None, er=[])
    _SessionCapabilities_maxNumberPeriodicSessions = INT(name='maxNumberPeriodicSessions', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SessionCapabilities_maxNumberPeriodicSessions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    _SessionCapabilities_maxNumberTriggeredSessions = INT(name='maxNumberTriggeredSessions', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SessionCapabilities_maxNumberTriggeredSessions._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    SessionCapabilities._cont = ASN1Dict([
        ('maxNumberTotalSessions', _SessionCapabilities_maxNumberTotalSessions),
        ('maxNumberPeriodicSessions', _SessionCapabilities_maxNumberPeriodicSessions),
        ('maxNumberTriggeredSessions', _SessionCapabilities_maxNumberTriggeredSessions),
        ])
    SessionCapabilities._ext = []
    
    #-----< SupportedBearers >-----#
    SupportedBearers = SEQ(name='SupportedBearers', mode=MODE_TYPE)
    _SupportedBearers_gsm = BOOL(name='gsm', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedBearers_wcdma = BOOL(name='wcdma', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedBearers_lte = BOOL(name='lte', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedBearers_cdma = BOOL(name='cdma', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedBearers_hprd = BOOL(name='hprd', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedBearers_umb = BOOL(name='umb', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedBearers_wlan = BOOL(name='wlan', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SupportedBearers_wiMAX = BOOL(name='wiMAX', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    SupportedBearers._cont = ASN1Dict([
        ('gsm', _SupportedBearers_gsm),
        ('wcdma', _SupportedBearers_wcdma),
        ('lte', _SupportedBearers_lte),
        ('cdma', _SupportedBearers_cdma),
        ('hprd', _SupportedBearers_hprd),
        ('umb', _SupportedBearers_umb),
        ('wlan', _SupportedBearers_wlan),
        ('wiMAX', _SupportedBearers_wiMAX),
        ])
    SupportedBearers._ext = []
    
    #-----< Ver2-PosProtocol-extension >-----#
    Ver2_PosProtocol_extension = SEQ(name='Ver2-PosProtocol-extension', mode=MODE_TYPE)
    _Ver2_PosProtocol_extension_lpp = BOOL(name='lpp', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Ver2_PosProtocol_extension_posProtocolVersionRRLP = SEQ(name='posProtocolVersionRRLP', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'PosProtocolVersion3GPP')), opt=True)
    _Ver2_PosProtocol_extension_posProtocolVersionRRC = SEQ(name='posProtocolVersionRRC', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'PosProtocolVersion3GPP')), opt=True)
    _Ver2_PosProtocol_extension_posProtocolVersionTIA801 = SEQ_OF(name='posProtocolVersionTIA801', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'PosProtocolVersion3GPP2')), opt=True)
    _Ver2_PosProtocol_extension_posProtocolVersionLPP = SEQ(name='posProtocolVersionLPP', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'PosProtocolVersion3GPP')), opt=True)
    _Ver2_PosProtocol_extension_lppe = BOOL(name='lppe', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _Ver2_PosProtocol_extension_posProtocolVersionLPPe = SEQ(name='posProtocolVersionLPPe', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'PosProtocolVersionOMA')), opt=True)
    Ver2_PosProtocol_extension._cont = ASN1Dict([
        ('lpp', _Ver2_PosProtocol_extension_lpp),
        ('posProtocolVersionRRLP', _Ver2_PosProtocol_extension_posProtocolVersionRRLP),
        ('posProtocolVersionRRC', _Ver2_PosProtocol_extension_posProtocolVersionRRC),
        ('posProtocolVersionTIA801', _Ver2_PosProtocol_extension_posProtocolVersionTIA801),
        ('posProtocolVersionLPP', _Ver2_PosProtocol_extension_posProtocolVersionLPP),
        ('lppe', _Ver2_PosProtocol_extension_lppe),
        ('posProtocolVersionLPPe', _Ver2_PosProtocol_extension_posProtocolVersionLPPe),
        ])
    Ver2_PosProtocol_extension._ext = ['lppe', 'posProtocolVersionLPPe']
    
    #-----< PosProtocolVersion3GPP >-----#
    PosProtocolVersion3GPP = SEQ(name='PosProtocolVersion3GPP', mode=MODE_TYPE)
    _PosProtocolVersion3GPP_majorVersionField = INT(name='majorVersionField', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosProtocolVersion3GPP_majorVersionField._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _PosProtocolVersion3GPP_technicalVersionField = INT(name='technicalVersionField', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosProtocolVersion3GPP_technicalVersionField._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _PosProtocolVersion3GPP_editorialVersionField = INT(name='editorialVersionField', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosProtocolVersion3GPP_editorialVersionField._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    PosProtocolVersion3GPP._cont = ASN1Dict([
        ('majorVersionField', _PosProtocolVersion3GPP_majorVersionField),
        ('technicalVersionField', _PosProtocolVersion3GPP_technicalVersionField),
        ('editorialVersionField', _PosProtocolVersion3GPP_editorialVersionField),
        ])
    PosProtocolVersion3GPP._ext = []
    
    #-----< PosProtocolVersion3GPP2 >-----#
    PosProtocolVersion3GPP2 = SEQ_OF(name='PosProtocolVersion3GPP2', mode=MODE_TYPE)
    _PosProtocolVersion3GPP2__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'Supported3GPP2PosProtocolVersion')))
    PosProtocolVersion3GPP2._cont = _PosProtocolVersion3GPP2__item_
    PosProtocolVersion3GPP2._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=8)], ev=None, er=[])
    
    #-----< Supported3GPP2PosProtocolVersion >-----#
    Supported3GPP2PosProtocolVersion = SEQ(name='Supported3GPP2PosProtocolVersion', mode=MODE_TYPE)
    _Supported3GPP2PosProtocolVersion_revisionNumber = BIT_STR(name='revisionNumber', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported3GPP2PosProtocolVersion_revisionNumber._const_sz = ASN1Set(rv=[6], rr=[], ev=None, er=[])
    _Supported3GPP2PosProtocolVersion_pointReleaseNumber = INT(name='pointReleaseNumber', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported3GPP2PosProtocolVersion_pointReleaseNumber._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _Supported3GPP2PosProtocolVersion_internalEditLevel = INT(name='internalEditLevel', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _Supported3GPP2PosProtocolVersion_internalEditLevel._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    Supported3GPP2PosProtocolVersion._cont = ASN1Dict([
        ('revisionNumber', _Supported3GPP2PosProtocolVersion_revisionNumber),
        ('pointReleaseNumber', _Supported3GPP2PosProtocolVersion_pointReleaseNumber),
        ('internalEditLevel', _Supported3GPP2PosProtocolVersion_internalEditLevel),
        ])
    Supported3GPP2PosProtocolVersion._ext = []
    
    #-----< PosProtocolVersionOMA >-----#
    PosProtocolVersionOMA = SEQ(name='PosProtocolVersionOMA', mode=MODE_TYPE)
    _PosProtocolVersionOMA_majorVersionField = INT(name='majorVersionField', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosProtocolVersionOMA_majorVersionField._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    _PosProtocolVersionOMA_minorVersionField = INT(name='minorVersionField', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _PosProtocolVersionOMA_minorVersionField._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=255)], ev=None, er=[])
    PosProtocolVersionOMA._cont = ASN1Dict([
        ('majorVersionField', _PosProtocolVersionOMA_majorVersionField),
        ('minorVersionField', _PosProtocolVersionOMA_minorVersionField),
        ])
    PosProtocolVersionOMA._ext = []
    
    #-----< Ver2-PosTechnology-extension >-----#
    Ver2_PosTechnology_extension = SEQ(name='Ver2-PosTechnology-extension', mode=MODE_TYPE)
    _Ver2_PosTechnology_extension_gANSSPositionMethods = SEQ_OF(name='gANSSPositionMethods', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GANSSPositionMethods')), opt=True)
    Ver2_PosTechnology_extension._cont = ASN1Dict([
        ('gANSSPositionMethods', _Ver2_PosTechnology_extension_gANSSPositionMethods),
        ])
    Ver2_PosTechnology_extension._ext = []
    
    #-----< GANSSPositionMethods >-----#
    GANSSPositionMethods = SEQ_OF(name='GANSSPositionMethods', mode=MODE_TYPE)
    _GANSSPositionMethods__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GANSSPositionMethod')))
    GANSSPositionMethods._cont = _GANSSPositionMethods__item_
    GANSSPositionMethods._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GANSSPositionMethod >-----#
    GANSSPositionMethod = SEQ(name='GANSSPositionMethod', mode=MODE_TYPE)
    _GANSSPositionMethod_ganssId = INT(name='ganssId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSSPositionMethod_ganssId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _GANSSPositionMethod_ganssSBASid = BIT_STR(name='ganssSBASid', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GANSSPositionMethod_ganssSBASid._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GANSSPositionMethod_gANSSPositioningMethodTypes = SEQ(name='gANSSPositioningMethodTypes', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GANSSPositioningMethodTypes')))
    _GANSSPositionMethod_gANSSSignals = BIT_STR(name='gANSSSignals', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'GANSSSignals')))
    GANSSPositionMethod._cont = ASN1Dict([
        ('ganssId', _GANSSPositionMethod_ganssId),
        ('ganssSBASid', _GANSSPositionMethod_ganssSBASid),
        ('gANSSPositioningMethodTypes', _GANSSPositionMethod_gANSSPositioningMethodTypes),
        ('gANSSSignals', _GANSSPositionMethod_gANSSSignals),
        ])
    GANSSPositionMethod._ext = []
    
    #-----< GANSSPositioningMethodTypes >-----#
    GANSSPositioningMethodTypes = SEQ(name='GANSSPositioningMethodTypes', mode=MODE_TYPE)
    _GANSSPositioningMethodTypes_setAssisted = BOOL(name='setAssisted', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSSPositioningMethodTypes_setBased = BOOL(name='setBased', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSSPositioningMethodTypes_autonomous = BOOL(name='autonomous', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    GANSSPositioningMethodTypes._cont = ASN1Dict([
        ('setAssisted', _GANSSPositioningMethodTypes_setAssisted),
        ('setBased', _GANSSPositioningMethodTypes_setBased),
        ('autonomous', _GANSSPositioningMethodTypes_autonomous),
        ])
    GANSSPositioningMethodTypes._ext = []
    
    #-----< Ver2-RequestedAssistData-extension >-----#
    Ver2_RequestedAssistData_extension = SEQ(name='Ver2-RequestedAssistData-extension', mode=MODE_TYPE)
    _Ver2_RequestedAssistData_extension_ganssRequestedCommonAssistanceDataList = SEQ(name='ganssRequestedCommonAssistanceDataList', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GanssRequestedCommonAssistanceDataList')), opt=True)
    _Ver2_RequestedAssistData_extension_ganssRequestedGenericAssistanceDataList = SEQ_OF(name='ganssRequestedGenericAssistanceDataList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GanssRequestedGenericAssistanceDataList')), opt=True)
    _Ver2_RequestedAssistData_extension_extendedEphemeris = SEQ(name='extendedEphemeris', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'ExtendedEphemeris')), opt=True)
    _Ver2_RequestedAssistData_extension_extendedEphemerisCheck = SEQ(name='extendedEphemerisCheck', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'ExtendedEphCheck')), opt=True)
    Ver2_RequestedAssistData_extension._cont = ASN1Dict([
        ('ganssRequestedCommonAssistanceDataList', _Ver2_RequestedAssistData_extension_ganssRequestedCommonAssistanceDataList),
        ('ganssRequestedGenericAssistanceDataList', _Ver2_RequestedAssistData_extension_ganssRequestedGenericAssistanceDataList),
        ('extendedEphemeris', _Ver2_RequestedAssistData_extension_extendedEphemeris),
        ('extendedEphemerisCheck', _Ver2_RequestedAssistData_extension_extendedEphemerisCheck),
        ])
    Ver2_RequestedAssistData_extension._ext = []
    
    #-----< GanssRequestedCommonAssistanceDataList >-----#
    GanssRequestedCommonAssistanceDataList = SEQ(name='GanssRequestedCommonAssistanceDataList', mode=MODE_TYPE)
    _GanssRequestedCommonAssistanceDataList_ganssReferenceTime = BOOL(name='ganssReferenceTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssRequestedCommonAssistanceDataList_ganssIonosphericModel = BOOL(name='ganssIonosphericModel', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssRequestedCommonAssistanceDataList_ganssAdditionalIonosphericModelForDataID00 = BOOL(name='ganssAdditionalIonosphericModelForDataID00', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssRequestedCommonAssistanceDataList_ganssAdditionalIonosphericModelForDataID11 = BOOL(name='ganssAdditionalIonosphericModelForDataID11', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssRequestedCommonAssistanceDataList_ganssEarthOrientationParameters = BOOL(name='ganssEarthOrientationParameters', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssRequestedCommonAssistanceDataList_ganssAdditionalIonosphericModelForDataID01 = BOOL(name='ganssAdditionalIonosphericModelForDataID01', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GanssRequestedCommonAssistanceDataList._cont = ASN1Dict([
        ('ganssReferenceTime', _GanssRequestedCommonAssistanceDataList_ganssReferenceTime),
        ('ganssIonosphericModel', _GanssRequestedCommonAssistanceDataList_ganssIonosphericModel),
        ('ganssAdditionalIonosphericModelForDataID00', _GanssRequestedCommonAssistanceDataList_ganssAdditionalIonosphericModelForDataID00),
        ('ganssAdditionalIonosphericModelForDataID11', _GanssRequestedCommonAssistanceDataList_ganssAdditionalIonosphericModelForDataID11),
        ('ganssEarthOrientationParameters', _GanssRequestedCommonAssistanceDataList_ganssEarthOrientationParameters),
        ('ganssAdditionalIonosphericModelForDataID01', _GanssRequestedCommonAssistanceDataList_ganssAdditionalIonosphericModelForDataID01),
        ])
    GanssRequestedCommonAssistanceDataList._ext = ['ganssAdditionalIonosphericModelForDataID01']
    
    #-----< GanssRequestedGenericAssistanceDataList >-----#
    GanssRequestedGenericAssistanceDataList = SEQ_OF(name='GanssRequestedGenericAssistanceDataList', mode=MODE_TYPE)
    _GanssRequestedGenericAssistanceDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GanssReqGenericData')))
    GanssRequestedGenericAssistanceDataList._cont = _GanssRequestedGenericAssistanceDataList__item_
    GanssRequestedGenericAssistanceDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=16)], ev=None, er=[])
    
    #-----< GanssReqGenericData >-----#
    GanssReqGenericData = SEQ(name='GanssReqGenericData', mode=MODE_TYPE)
    _GanssReqGenericData_ganssId = INT(name='ganssId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssReqGenericData_ganssId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _GanssReqGenericData_ganssSBASid = BIT_STR(name='ganssSBASid', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssReqGenericData_ganssSBASid._const_sz = ASN1Set(rv=[3], rr=[], ev=None, er=[])
    _GanssReqGenericData_ganssRealTimeIntegrity = BOOL(name='ganssRealTimeIntegrity', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssReqGenericData_ganssDifferentialCorrection = BIT_STR(name='ganssDifferentialCorrection', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'DGANSS-Sig-Id-Req')), opt=True)
    _GanssReqGenericData_ganssAlmanac = BOOL(name='ganssAlmanac', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssReqGenericData_ganssNavigationModelData = SEQ(name='ganssNavigationModelData', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GanssNavigationModelData')), opt=True)
    _GanssReqGenericData_ganssTimeModels = BIT_STR(name='ganssTimeModels', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssReqGenericData_ganssTimeModels._const_sz = ASN1Set(rv=[16], rr=[], ev=None, er=[])
    _GanssReqGenericData_ganssReferenceMeasurementInfo = BOOL(name='ganssReferenceMeasurementInfo', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssReqGenericData_ganssDataBits = SEQ(name='ganssDataBits', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GanssDataBits')), opt=True)
    _GanssReqGenericData_ganssUTCModel = BOOL(name='ganssUTCModel', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssReqGenericData_ganssAdditionalDataChoices = SEQ(name='ganssAdditionalDataChoices', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GanssAdditionalDataChoices')), opt=True)
    _GanssReqGenericData_ganssAuxiliaryInformation = BOOL(name='ganssAuxiliaryInformation', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssReqGenericData_ganssExtendedEphemeris = SEQ(name='ganssExtendedEphemeris', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'ExtendedEphemeris')), opt=True)
    _GanssReqGenericData_ganssExtendedEphemerisCheck = SEQ(name='ganssExtendedEphemerisCheck', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GanssExtendedEphCheck')), opt=True)
    _GanssReqGenericData_bds_DifferentialCorrection = BIT_STR(name='bds-DifferentialCorrection', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'BDS-Sig-Id-Req')), opt=True)
    _GanssReqGenericData_bds_GridModelReq = BOOL(name='bds-GridModelReq', mode=MODE_TYPE, tag=(15, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    GanssReqGenericData._cont = ASN1Dict([
        ('ganssId', _GanssReqGenericData_ganssId),
        ('ganssSBASid', _GanssReqGenericData_ganssSBASid),
        ('ganssRealTimeIntegrity', _GanssReqGenericData_ganssRealTimeIntegrity),
        ('ganssDifferentialCorrection', _GanssReqGenericData_ganssDifferentialCorrection),
        ('ganssAlmanac', _GanssReqGenericData_ganssAlmanac),
        ('ganssNavigationModelData', _GanssReqGenericData_ganssNavigationModelData),
        ('ganssTimeModels', _GanssReqGenericData_ganssTimeModels),
        ('ganssReferenceMeasurementInfo', _GanssReqGenericData_ganssReferenceMeasurementInfo),
        ('ganssDataBits', _GanssReqGenericData_ganssDataBits),
        ('ganssUTCModel', _GanssReqGenericData_ganssUTCModel),
        ('ganssAdditionalDataChoices', _GanssReqGenericData_ganssAdditionalDataChoices),
        ('ganssAuxiliaryInformation', _GanssReqGenericData_ganssAuxiliaryInformation),
        ('ganssExtendedEphemeris', _GanssReqGenericData_ganssExtendedEphemeris),
        ('ganssExtendedEphemerisCheck', _GanssReqGenericData_ganssExtendedEphemerisCheck),
        ('bds-DifferentialCorrection', _GanssReqGenericData_bds_DifferentialCorrection),
        ('bds-GridModelReq', _GanssReqGenericData_bds_GridModelReq),
        ])
    GanssReqGenericData._ext = ['bds-DifferentialCorrection', 'bds-GridModelReq']
    
    #-----< DGANSS-Sig-Id-Req >-----#
    DGANSS_Sig_Id_Req = BIT_STR(name='DGANSS-Sig-Id-Req', mode=MODE_TYPE)
    DGANSS_Sig_Id_Req._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< BDS-Sig-Id-Req >-----#
    BDS_Sig_Id_Req = BIT_STR(name='BDS-Sig-Id-Req', mode=MODE_TYPE)
    BDS_Sig_Id_Req._const_sz = ASN1Set(rv=[8], rr=[], ev=None, er=[])
    
    #-----< GanssNavigationModelData >-----#
    GanssNavigationModelData = SEQ(name='GanssNavigationModelData', mode=MODE_TYPE)
    _GanssNavigationModelData_ganssWeek = INT(name='ganssWeek', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssNavigationModelData_ganssWeek._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=4095)], ev=None, er=[])
    _GanssNavigationModelData_ganssToe = INT(name='ganssToe', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssNavigationModelData_ganssToe._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=167)], ev=None, er=[])
    _GanssNavigationModelData_t_toeLimit = INT(name='t-toeLimit', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssNavigationModelData_t_toeLimit._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _GanssNavigationModelData_satellitesListRelatedDataList = SEQ_OF(name='satellitesListRelatedDataList', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'SatellitesListRelatedDataList')), opt=True)
    GanssNavigationModelData._cont = ASN1Dict([
        ('ganssWeek', _GanssNavigationModelData_ganssWeek),
        ('ganssToe', _GanssNavigationModelData_ganssToe),
        ('t-toeLimit', _GanssNavigationModelData_t_toeLimit),
        ('satellitesListRelatedDataList', _GanssNavigationModelData_satellitesListRelatedDataList),
        ])
    GanssNavigationModelData._ext = []
    
    #-----< SatellitesListRelatedDataList >-----#
    SatellitesListRelatedDataList = SEQ_OF(name='SatellitesListRelatedDataList', mode=MODE_TYPE)
    _SatellitesListRelatedDataList__item_ = SEQ(name='_item_', mode=MODE_TYPE, typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'SatellitesListRelatedData')))
    SatellitesListRelatedDataList._cont = _SatellitesListRelatedDataList__item_
    SatellitesListRelatedDataList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=32)], ev=None, er=[])
    
    #-----< SatellitesListRelatedData >-----#
    SatellitesListRelatedData = SEQ(name='SatellitesListRelatedData', mode=MODE_TYPE)
    _SatellitesListRelatedData_satId = INT(name='satId', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SatellitesListRelatedData_satId._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _SatellitesListRelatedData_iod = INT(name='iod', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _SatellitesListRelatedData_iod._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    SatellitesListRelatedData._cont = ASN1Dict([
        ('satId', _SatellitesListRelatedData_satId),
        ('iod', _SatellitesListRelatedData_iod),
        ])
    SatellitesListRelatedData._ext = []
    
    #-----< maxGANSS >-----#
    maxGANSS = INT(name='maxGANSS', mode=MODE_VALUE)
    maxGANSS._val = 16
    
    #-----< maxGANSSSat >-----#
    maxGANSSSat = INT(name='maxGANSSSat', mode=MODE_VALUE)
    maxGANSSSat._val = 32
    
    #-----< GanssDataBits >-----#
    GanssDataBits = SEQ(name='GanssDataBits', mode=MODE_TYPE)
    _GanssDataBits_ganssTODmin = INT(name='ganssTODmin', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GanssDataBits_ganssTODmin._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=59)], ev=None, er=[])
    _GanssDataBits_reqDataBitAssistanceList = SEQ(name='reqDataBitAssistanceList', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'ReqDataBitAssistanceList')))
    GanssDataBits._cont = ASN1Dict([
        ('ganssTODmin', _GanssDataBits_ganssTODmin),
        ('reqDataBitAssistanceList', _GanssDataBits_reqDataBitAssistanceList),
        ])
    GanssDataBits._ext = []
    
    #-----< ReqDataBitAssistanceList >-----#
    ReqDataBitAssistanceList = SEQ(name='ReqDataBitAssistanceList', mode=MODE_TYPE)
    _ReqDataBitAssistanceList_gnssSignals = BIT_STR(name='gnssSignals', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('Ver2-ULP-Components', 'GANSSSignals')))
    _ReqDataBitAssistanceList_ganssDataBitInterval = INT(name='ganssDataBitInterval', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ReqDataBitAssistanceList_ganssDataBitInterval._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=15)], ev=None, er=[])
    _ReqDataBitAssistanceList_ganssDataBitSatList = SEQ_OF(name='ganssDataBitSatList', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __ReqDataBitAssistanceList_ganssDataBitSatList__item_ = INT(name='_item_', mode=MODE_TYPE)
    __ReqDataBitAssistanceList_ganssDataBitSatList__item_._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=63)], ev=None, er=[])
    _ReqDataBitAssistanceList_ganssDataBitSatList._cont = __ReqDataBitAssistanceList_ganssDataBitSatList__item_
    _ReqDataBitAssistanceList_ganssDataBitSatList._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=32)], ev=None, er=[])
    ReqDataBitAssistanceList._cont = ASN1Dict([
        ('gnssSignals', _ReqDataBitAssistanceList_gnssSignals),
        ('ganssDataBitInterval', _ReqDataBitAssistanceList_ganssDataBitInterval),
        ('ganssDataBitSatList', _ReqDataBitAssistanceList_ganssDataBitSatList),
        ])
    ReqDataBitAssistanceList._ext = []
    
    #-----< GanssAdditionalDataChoices >-----#
    GanssAdditionalDataChoices = SEQ(name='GanssAdditionalDataChoices', mode=MODE_TYPE)
    _GanssAdditionalDataChoices_orbitModelID = INT(name='orbitModelID', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssAdditionalDataChoices_orbitModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _GanssAdditionalDataChoices_clockModelID = INT(name='clockModelID', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssAdditionalDataChoices_clockModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _GanssAdditionalDataChoices_utcModelID = INT(name='utcModelID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssAdditionalDataChoices_utcModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    _GanssAdditionalDataChoices_almanacModelID = INT(name='almanacModelID', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    _GanssAdditionalDataChoices_almanacModelID._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=7)], ev=None, er=[])
    GanssAdditionalDataChoices._cont = ASN1Dict([
        ('orbitModelID', _GanssAdditionalDataChoices_orbitModelID),
        ('clockModelID', _GanssAdditionalDataChoices_clockModelID),
        ('utcModelID', _GanssAdditionalDataChoices_utcModelID),
        ('almanacModelID', _GanssAdditionalDataChoices_almanacModelID),
        ])
    GanssAdditionalDataChoices._ext = []
    
    #-----< ExtendedEphemeris >-----#
    ExtendedEphemeris = SEQ(name='ExtendedEphemeris', mode=MODE_TYPE)
    _ExtendedEphemeris_validity = INT(name='validity', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ExtendedEphemeris_validity._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=256)], ev=None, er=[])
    ExtendedEphemeris._cont = ASN1Dict([
        ('validity', _ExtendedEphemeris_validity),
        ])
    ExtendedEphemeris._ext = []
    
    #-----< ExtendedEphCheck >-----#
    ExtendedEphCheck = SEQ(name='ExtendedEphCheck', mode=MODE_TYPE)
    _ExtendedEphCheck_beginTime = SEQ(name='beginTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GPSTime')))
    _ExtendedEphCheck_endTime = SEQ(name='endTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GPSTime')))
    ExtendedEphCheck._cont = ASN1Dict([
        ('beginTime', _ExtendedEphCheck_beginTime),
        ('endTime', _ExtendedEphCheck_endTime),
        ])
    ExtendedEphCheck._ext = []
    
    #-----< GanssExtendedEphCheck >-----#
    GanssExtendedEphCheck = SEQ(name='GanssExtendedEphCheck', mode=MODE_TYPE)
    _GanssExtendedEphCheck_beginTime = SEQ(name='beginTime', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GANSSextEphTime')))
    _GanssExtendedEphCheck_endTime = SEQ(name='endTime', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Version-2-parameter-extensions', 'GANSSextEphTime')))
    GanssExtendedEphCheck._cont = ASN1Dict([
        ('beginTime', _GanssExtendedEphCheck_beginTime),
        ('endTime', _GanssExtendedEphCheck_endTime),
        ])
    GanssExtendedEphCheck._ext = []
    
    #-----< GPSTime >-----#
    GPSTime = SEQ(name='GPSTime', mode=MODE_TYPE)
    _GPSTime_gPSWeek = INT(name='gPSWeek', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPSTime_gPSWeek._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=1023)], ev=None, er=[])
    _GPSTime_gPSTOWhour = INT(name='gPSTOWhour', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GPSTime_gPSTOWhour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=167)], ev=None, er=[])
    GPSTime._cont = ASN1Dict([
        ('gPSWeek', _GPSTime_gPSWeek),
        ('gPSTOWhour', _GPSTime_gPSTOWhour),
        ])
    GPSTime._ext = []
    
    #-----< GANSSextEphTime >-----#
    GANSSextEphTime = SEQ(name='GANSSextEphTime', mode=MODE_TYPE)
    _GANSSextEphTime_gANSSday = INT(name='gANSSday', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSSextEphTime_gANSSday._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=8191)], ev=None, er=[])
    _GANSSextEphTime_gANSSTODhour = INT(name='gANSSTODhour', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _GANSSextEphTime_gANSSTODhour._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=23)], ev=None, er=[])
    GANSSextEphTime._cont = ASN1Dict([
        ('gANSSday', _GANSSextEphTime_gANSSday),
        ('gANSSTODhour', _GANSSextEphTime_gANSSTODhour),
        ])
    GANSSextEphTime._ext = []
    
    #-----< Ver2-PosPayLoad-extension >-----#
    Ver2_PosPayLoad_extension = SEQ(name='Ver2-PosPayLoad-extension', mode=MODE_TYPE)
    _Ver2_PosPayLoad_extension_lPPPayload = SEQ_OF(name='lPPPayload', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Ver2_PosPayLoad_extension_lPPPayload__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    __Ver2_PosPayLoad_extension_lPPPayload__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60000)], ev=None, er=[])
    _Ver2_PosPayLoad_extension_lPPPayload._cont = __Ver2_PosPayLoad_extension_lPPPayload__item_
    _Ver2_PosPayLoad_extension_lPPPayload._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    _Ver2_PosPayLoad_extension_tia801Payload = SEQ_OF(name='tia801Payload', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), opt=True)
    __Ver2_PosPayLoad_extension_tia801Payload__item_ = OCT_STR(name='_item_', mode=MODE_TYPE)
    __Ver2_PosPayLoad_extension_tia801Payload__item_._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=60000)], ev=None, er=[])
    _Ver2_PosPayLoad_extension_tia801Payload._cont = __Ver2_PosPayLoad_extension_tia801Payload__item_
    _Ver2_PosPayLoad_extension_tia801Payload._const_sz = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=1, ub=3)], ev=None, er=[])
    Ver2_PosPayLoad_extension._cont = ASN1Dict([
        ('lPPPayload', _Ver2_PosPayLoad_extension_lPPPayload),
        ('tia801Payload', _Ver2_PosPayLoad_extension_tia801Payload),
        ])
    Ver2_PosPayLoad_extension._ext = []
    
    _all_ = [
        _Ver2_Notification_extension_emergencyCallLocation,
        Ver2_Notification_extension,
        _Ver2_SETCapabilities_extension_serviceCapabilities,
        _Ver2_SETCapabilities_extension_supportedBearers,
        Ver2_SETCapabilities_extension,
        _ServiceCapabilities_servicesSupported,
        _ServiceCapabilities_reportingCapabilities,
        _ServiceCapabilities_eventTriggerCapabilities,
        _ServiceCapabilities_sessionCapabilities,
        ServiceCapabilities,
        _ServicesSupported_periodicTrigger,
        _ServicesSupported_areaEventTrigger,
        ServicesSupported,
        _EventTriggerCapabilities_geoAreaShapesSupported,
        _EventTriggerCapabilities_maxNumGeoAreaSupported,
        _EventTriggerCapabilities_maxAreaIdListSupported,
        _EventTriggerCapabilities_maxAreaIdSupportedPerList,
        EventTriggerCapabilities,
        _GeoAreaShapesSupported_ellipticalArea,
        _GeoAreaShapesSupported_polygonArea,
        GeoAreaShapesSupported,
        _SessionCapabilities_maxNumberTotalSessions,
        _SessionCapabilities_maxNumberPeriodicSessions,
        _SessionCapabilities_maxNumberTriggeredSessions,
        SessionCapabilities,
        _SupportedBearers_gsm,
        _SupportedBearers_wcdma,
        _SupportedBearers_lte,
        _SupportedBearers_cdma,
        _SupportedBearers_hprd,
        _SupportedBearers_umb,
        _SupportedBearers_wlan,
        _SupportedBearers_wiMAX,
        SupportedBearers,
        _Ver2_PosProtocol_extension_lpp,
        _Ver2_PosProtocol_extension_posProtocolVersionRRLP,
        _Ver2_PosProtocol_extension_posProtocolVersionRRC,
        _Ver2_PosProtocol_extension_posProtocolVersionTIA801,
        _Ver2_PosProtocol_extension_posProtocolVersionLPP,
        _Ver2_PosProtocol_extension_lppe,
        _Ver2_PosProtocol_extension_posProtocolVersionLPPe,
        Ver2_PosProtocol_extension,
        _PosProtocolVersion3GPP_majorVersionField,
        _PosProtocolVersion3GPP_technicalVersionField,
        _PosProtocolVersion3GPP_editorialVersionField,
        PosProtocolVersion3GPP,
        _PosProtocolVersion3GPP2__item_,
        PosProtocolVersion3GPP2,
        _Supported3GPP2PosProtocolVersion_revisionNumber,
        _Supported3GPP2PosProtocolVersion_pointReleaseNumber,
        _Supported3GPP2PosProtocolVersion_internalEditLevel,
        Supported3GPP2PosProtocolVersion,
        _PosProtocolVersionOMA_majorVersionField,
        _PosProtocolVersionOMA_minorVersionField,
        PosProtocolVersionOMA,
        _Ver2_PosTechnology_extension_gANSSPositionMethods,
        Ver2_PosTechnology_extension,
        _GANSSPositionMethods__item_,
        GANSSPositionMethods,
        _GANSSPositionMethod_ganssId,
        _GANSSPositionMethod_ganssSBASid,
        _GANSSPositionMethod_gANSSPositioningMethodTypes,
        _GANSSPositionMethod_gANSSSignals,
        GANSSPositionMethod,
        _GANSSPositioningMethodTypes_setAssisted,
        _GANSSPositioningMethodTypes_setBased,
        _GANSSPositioningMethodTypes_autonomous,
        GANSSPositioningMethodTypes,
        _Ver2_RequestedAssistData_extension_ganssRequestedCommonAssistanceDataList,
        _Ver2_RequestedAssistData_extension_ganssRequestedGenericAssistanceDataList,
        _Ver2_RequestedAssistData_extension_extendedEphemeris,
        _Ver2_RequestedAssistData_extension_extendedEphemerisCheck,
        Ver2_RequestedAssistData_extension,
        _GanssRequestedCommonAssistanceDataList_ganssReferenceTime,
        _GanssRequestedCommonAssistanceDataList_ganssIonosphericModel,
        _GanssRequestedCommonAssistanceDataList_ganssAdditionalIonosphericModelForDataID00,
        _GanssRequestedCommonAssistanceDataList_ganssAdditionalIonosphericModelForDataID11,
        _GanssRequestedCommonAssistanceDataList_ganssEarthOrientationParameters,
        _GanssRequestedCommonAssistanceDataList_ganssAdditionalIonosphericModelForDataID01,
        GanssRequestedCommonAssistanceDataList,
        _GanssRequestedGenericAssistanceDataList__item_,
        GanssRequestedGenericAssistanceDataList,
        _GanssReqGenericData_ganssId,
        _GanssReqGenericData_ganssSBASid,
        _GanssReqGenericData_ganssRealTimeIntegrity,
        _GanssReqGenericData_ganssDifferentialCorrection,
        _GanssReqGenericData_ganssAlmanac,
        _GanssReqGenericData_ganssNavigationModelData,
        _GanssReqGenericData_ganssTimeModels,
        _GanssReqGenericData_ganssReferenceMeasurementInfo,
        _GanssReqGenericData_ganssDataBits,
        _GanssReqGenericData_ganssUTCModel,
        _GanssReqGenericData_ganssAdditionalDataChoices,
        _GanssReqGenericData_ganssAuxiliaryInformation,
        _GanssReqGenericData_ganssExtendedEphemeris,
        _GanssReqGenericData_ganssExtendedEphemerisCheck,
        _GanssReqGenericData_bds_DifferentialCorrection,
        _GanssReqGenericData_bds_GridModelReq,
        GanssReqGenericData,
        DGANSS_Sig_Id_Req,
        BDS_Sig_Id_Req,
        _GanssNavigationModelData_ganssWeek,
        _GanssNavigationModelData_ganssToe,
        _GanssNavigationModelData_t_toeLimit,
        _GanssNavigationModelData_satellitesListRelatedDataList,
        GanssNavigationModelData,
        _SatellitesListRelatedDataList__item_,
        SatellitesListRelatedDataList,
        _SatellitesListRelatedData_satId,
        _SatellitesListRelatedData_iod,
        SatellitesListRelatedData,
        maxGANSS,
        maxGANSSSat,
        _GanssDataBits_ganssTODmin,
        _GanssDataBits_reqDataBitAssistanceList,
        GanssDataBits,
        _ReqDataBitAssistanceList_gnssSignals,
        _ReqDataBitAssistanceList_ganssDataBitInterval,
        __ReqDataBitAssistanceList_ganssDataBitSatList__item_,
        _ReqDataBitAssistanceList_ganssDataBitSatList,
        ReqDataBitAssistanceList,
        _GanssAdditionalDataChoices_orbitModelID,
        _GanssAdditionalDataChoices_clockModelID,
        _GanssAdditionalDataChoices_utcModelID,
        _GanssAdditionalDataChoices_almanacModelID,
        GanssAdditionalDataChoices,
        _ExtendedEphemeris_validity,
        ExtendedEphemeris,
        _ExtendedEphCheck_beginTime,
        _ExtendedEphCheck_endTime,
        ExtendedEphCheck,
        _GanssExtendedEphCheck_beginTime,
        _GanssExtendedEphCheck_endTime,
        GanssExtendedEphCheck,
        _GPSTime_gPSWeek,
        _GPSTime_gPSTOWhour,
        GPSTime,
        _GANSSextEphTime_gANSSday,
        _GANSSextEphTime_gANSSTODhour,
        GANSSextEphTime,
        __Ver2_PosPayLoad_extension_lPPPayload__item_,
        _Ver2_PosPayLoad_extension_lPPPayload,
        __Ver2_PosPayLoad_extension_tia801Payload__item_,
        _Ver2_PosPayLoad_extension_tia801Payload,
        Ver2_PosPayLoad_extension,
    ]

class ULP:

    _name_  = 'ULP'
    _oid_   = []
    
    _obj_ = [
        'ULP-PDU',
        'UlpMessage',
        ]
    _type_ = [
        'ULP-PDU',
        'UlpMessage',
        ]
    _set_ = [
        ]
    _val_ = [
        ]
    _class_ = [
        ]
    _param_ = [
        ]
    
    #-----< ULP-PDU >-----#
    ULP_PDU = SEQ(name='ULP-PDU', mode=MODE_TYPE)
    _ULP_PDU_length = INT(name='length', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT))
    _ULP_PDU_length._const_val = ASN1Set(rv=[], rr=[ASN1RangeInt(lb=0, ub=65535)], ev=None, er=[])
    _ULP_PDU_version = SEQ(name='version', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'Version')))
    _ULP_PDU_sessionID = SEQ(name='sessionID', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('ULP-Components', 'SessionID')))
    _ULP_PDU_message = CHOICE(name='message', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_EXPLICIT), typeref=ASN1RefType(('ULP', 'UlpMessage')))
    ULP_PDU._cont = ASN1Dict([
        ('length', _ULP_PDU_length),
        ('version', _ULP_PDU_version),
        ('sessionID', _ULP_PDU_sessionID),
        ('message', _ULP_PDU_message),
        ])
    ULP_PDU._ext = None
    
    #-----< UlpMessage >-----#
    UlpMessage = CHOICE(name='UlpMessage', mode=MODE_TYPE)
    _UlpMessage_msSUPLINIT = SEQ(name='msSUPLINIT', mode=MODE_TYPE, tag=(0, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-INIT', 'SUPLINIT')))
    _UlpMessage_msSUPLSTART = SEQ(name='msSUPLSTART', mode=MODE_TYPE, tag=(1, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-START', 'SUPLSTART')))
    _UlpMessage_msSUPLRESPONSE = SEQ(name='msSUPLRESPONSE', mode=MODE_TYPE, tag=(2, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-RESPONSE', 'SUPLRESPONSE')))
    _UlpMessage_msSUPLPOSINIT = SEQ(name='msSUPLPOSINIT', mode=MODE_TYPE, tag=(3, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-POS-INIT', 'SUPLPOSINIT')))
    _UlpMessage_msSUPLPOS = SEQ(name='msSUPLPOS', mode=MODE_TYPE, tag=(4, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-POS', 'SUPLPOS')))
    _UlpMessage_msSUPLEND = SEQ(name='msSUPLEND', mode=MODE_TYPE, tag=(5, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-END', 'SUPLEND')))
    _UlpMessage_msSUPLAUTHREQ = SEQ(name='msSUPLAUTHREQ', mode=MODE_TYPE, tag=(6, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-AUTH-REQ', 'SUPLAUTHREQ')))
    _UlpMessage_msSUPLAUTHRESP = SEQ(name='msSUPLAUTHRESP', mode=MODE_TYPE, tag=(7, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-AUTH-RESP', 'SUPLAUTHRESP')))
    _UlpMessage_msSUPLTRIGGEREDSTART = SEQ(name='msSUPLTRIGGEREDSTART', mode=MODE_TYPE, tag=(8, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-START', 'Ver2-SUPLTRIGGEREDSTART')))
    _UlpMessage_msSUPLTRIGGEREDRESPONSE = SEQ(name='msSUPLTRIGGEREDRESPONSE', mode=MODE_TYPE, tag=(9, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-RESPONSE', 'Ver2-SUPLTRIGGEREDRESPONSE')))
    _UlpMessage_msSUPLTRIGGEREDSTOP = SEQ(name='msSUPLTRIGGEREDSTOP', mode=MODE_TYPE, tag=(10, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-TRIGGERED-STOP', 'Ver2-SUPLTRIGGEREDSTOP')))
    _UlpMessage_msSUPLNOTIFY = SEQ(name='msSUPLNOTIFY', mode=MODE_TYPE, tag=(11, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-NOTIFY', 'Ver2-SUPLNOTIFY')))
    _UlpMessage_msSUPLNOTIFYRESPONSE = SEQ(name='msSUPLNOTIFYRESPONSE', mode=MODE_TYPE, tag=(12, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-NOTIFY-RESPONSE', 'Ver2-SUPLNOTIFYRESPONSE')))
    _UlpMessage_msSUPLSETINIT = SEQ(name='msSUPLSETINIT', mode=MODE_TYPE, tag=(13, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-SET-INIT', 'Ver2-SUPLSETINIT')))
    _UlpMessage_msSUPLREPORT = SEQ(name='msSUPLREPORT', mode=MODE_TYPE, tag=(14, TAG_CONTEXT_SPEC, TAG_IMPLICIT), typeref=ASN1RefType(('SUPL-REPORT', 'Ver2-SUPLREPORT')))
    UlpMessage._cont = ASN1Dict([
        ('msSUPLINIT', _UlpMessage_msSUPLINIT),
        ('msSUPLSTART', _UlpMessage_msSUPLSTART),
        ('msSUPLRESPONSE', _UlpMessage_msSUPLRESPONSE),
        ('msSUPLPOSINIT', _UlpMessage_msSUPLPOSINIT),
        ('msSUPLPOS', _UlpMessage_msSUPLPOS),
        ('msSUPLEND', _UlpMessage_msSUPLEND),
        ('msSUPLAUTHREQ', _UlpMessage_msSUPLAUTHREQ),
        ('msSUPLAUTHRESP', _UlpMessage_msSUPLAUTHRESP),
        ('msSUPLTRIGGEREDSTART', _UlpMessage_msSUPLTRIGGEREDSTART),
        ('msSUPLTRIGGEREDRESPONSE', _UlpMessage_msSUPLTRIGGEREDRESPONSE),
        ('msSUPLTRIGGEREDSTOP', _UlpMessage_msSUPLTRIGGEREDSTOP),
        ('msSUPLNOTIFY', _UlpMessage_msSUPLNOTIFY),
        ('msSUPLNOTIFYRESPONSE', _UlpMessage_msSUPLNOTIFYRESPONSE),
        ('msSUPLSETINIT', _UlpMessage_msSUPLSETINIT),
        ('msSUPLREPORT', _UlpMessage_msSUPLREPORT),
        ])
    UlpMessage._ext = ['msSUPLTRIGGEREDSTART', 'msSUPLTRIGGEREDRESPONSE', 'msSUPLTRIGGEREDSTOP', 'msSUPLNOTIFY', 'msSUPLNOTIFYRESPONSE', 'msSUPLSETINIT', 'msSUPLREPORT']
    
    _all_ = [
        _ULP_PDU_length,
        _ULP_PDU_version,
        _ULP_PDU_sessionID,
        _ULP_PDU_message,
        ULP_PDU,
        _UlpMessage_msSUPLINIT,
        _UlpMessage_msSUPLSTART,
        _UlpMessage_msSUPLRESPONSE,
        _UlpMessage_msSUPLPOSINIT,
        _UlpMessage_msSUPLPOS,
        _UlpMessage_msSUPLEND,
        _UlpMessage_msSUPLAUTHREQ,
        _UlpMessage_msSUPLAUTHRESP,
        _UlpMessage_msSUPLTRIGGEREDSTART,
        _UlpMessage_msSUPLTRIGGEREDRESPONSE,
        _UlpMessage_msSUPLTRIGGEREDSTOP,
        _UlpMessage_msSUPLNOTIFY,
        _UlpMessage_msSUPLNOTIFYRESPONSE,
        _UlpMessage_msSUPLSETINIT,
        _UlpMessage_msSUPLREPORT,
        UlpMessage,
    ]

init_modules(ULP_Components, Ver2_ULP_Components, SUPL_INIT, SUPL_START, SUPL_RESPONSE, SUPL_POS_INIT, SUPL_POS, SUPL_END, SUPL_AUTH_REQ, SUPL_AUTH_RESP, SUPL_NOTIFY, SUPL_NOTIFY_RESPONSE, SUPL_SET_INIT, SUPL_TRIGGERED_START, SUPL_TRIGGERED_RESPONSE, SUPL_REPORT, SUPL_TRIGGERED_STOP, ULP_Version_2_message_extensions, ULP_Version_2_parameter_extensions, ULP)
